crystal_doc_search_index_callback({"repository_name":"Crystal","body":"# Crystal\n\n[![Linux CI Build Status](https://github.com/crystal-lang/crystal/workflows/Linux%20CI/badge.svg)](https://github.com/crystal-lang/crystal/actions?query=workflow%3A%22Linux+CI%22+event%3Apush+branch%3Amaster)\n[![macOS CI Build Status](https://github.com/crystal-lang/crystal/workflows/macOS%20CI/badge.svg)](https://github.com/crystal-lang/crystal/actions?query=workflow%3A%22macOS+CI%22+event%3Apush+branch%3Amaster)\n[![AArch64 CI Build Status](https://github.com/crystal-lang/crystal/workflows/AArch64%20CI/badge.svg)](https://github.com/crystal-lang/crystal/actions?query=workflow%3A%22AArch64+CI%22+event%3Apush+branch%3Amaster)\n[![Windows CI Build Status](https://github.com/crystal-lang/crystal/workflows/Windows%20CI/badge.svg)](https://github.com/crystal-lang/crystal/actions?query=workflow%3A%22Windows+CI%22+event%3Apush+branch%3Amaster)\n[![CircleCI Build Status](https://circleci.com/gh/crystal-lang/crystal/tree/master.svg?style=shield)](https://circleci.com/gh/crystal-lang/crystal)\n[![Join the chat at https://gitter.im/crystal-lang/crystal](https://badges.gitter.im/crystal-lang/crystal.svg)](https://gitter.im/crystal-lang/crystal)\n[![Code Triagers Badge](https://www.codetriage.com/crystal-lang/crystal/badges/users.svg)](https://www.codetriage.com/crystal-lang/crystal)\n\n---\n\n[![Crystal - Born and raised at Manas](https://cloud.githubusercontent.com/assets/209371/13291809/022e2360-daf8-11e5-8be7-d02c1c8b38fb.png)](https://manas.tech/)\n\nCrystal is a programming language with the following goals:\n\n* Have a syntax similar to Ruby (but compatibility with it is not a goal)\n* Statically type-checked but without having to specify the type of variables or method arguments.\n* Be able to call C code by writing bindings to it in Crystal.\n* Have compile-time evaluation and generation of code, to avoid boilerplate code.\n* Compile to efficient native code.\n\nWhy?\n----\n\nWe love Ruby's efficiency for writing code.\n\nWe love C's efficiency for running code.\n\nWe want the best of both worlds.\n\nWe want the compiler to understand what we mean without having to specify types everywhere.\n\nWe want full OOP.\n\nOh, and we don't want to write C code to make the code run faster.\n\nProject Status\n--------------\n\nWithin a major version, language features won't be removed or changed in any way that could prevent a Crystal program written with that version from compiling and working. The built-in standard library might be enriched, but it will always be done with backwards compatibility in mind.\n\nDevelopment of the Crystal language is possible thanks to the community's effort and the continued support of [84codes](https://www.84codes.com/), [Nikola Motor Company](https://nikolamotor.com/) and every other [sponsor](https://crystal-lang.org/sponsors).\n\nInstalling\n----------\n\n[Follow these installation instructions](https://crystal-lang.org/install)\n\nTry it online\n-------------\n\n[play.crystal-lang.org](https://play.crystal-lang.org/)\n\nDocumentation\n-------------\n\n* [Language Reference](http://crystal-lang.org/reference)\n* [Standard library API](https://crystal-lang.org/api)\n* [Roadmap](https://github.com/crystal-lang/crystal/wiki/Roadmap)\n\nCommunity\n---------\n\nHave any questions or suggestions? Ask on the [Crystal Forum](https://forum.crystal-lang.org), on our [Gitter channel](https://gitter.im/crystal-lang/crystal) or IRC channel [#crystal-lang](https://web.libera.chat/#crystal-lang) at irc.libera.chat, or on Stack Overflow under the [crystal-lang](http://stackoverflow.com/questions/tagged/crystal-lang) tag. There is also an archived [Google Group](https://groups.google.com/forum/?fromgroups#!forum/crystal-lang).\n\nContributing\n------------\n\nThe Crystal repository is hosted at [crystal-lang/crystal](https://github.com/crystal-lang/crystal) on GitHub.\n\nRead the general [Contributing guide](https://github.com/crystal-lang/crystal/blob/master/CONTRIBUTING.md), and then:\n\n1. Fork it (<https://github.com/crystal-lang/crystal/fork>)\n2. Create your feature branch (`git checkout -b my-new-feature`)\n3. Commit your changes (`git commit -am 'Add some feature'`)\n4. Push to the branch (`git push origin my-new-feature`)\n5. Create a new Pull Request\n","program":{"html_id":"Crystal/toplevel","path":"toplevel.html","kind":"module","full_name":"Top Level Namespace","name":"Top Level Namespace","abstract":false,"ancestors":[{"html_id":"Crystal/Spec/Methods","kind":"module","full_name":"Spec::Methods","name":"Methods"},{"html_id":"Crystal/Spec/Expectations","kind":"module","full_name":"Spec::Expectations","name":"Expectations"}],"locations":[],"repository_name":"Crystal","program":true,"enum":false,"alias":false,"const":false,"constants":[{"id":"ARGF","name":"ARGF","value":"IO::ARGF.new(ARGV, STDIN)","doc":"An `IO` for reading files from `ARGV`.\n\nUsage example:\n\n`program.cr`:\n```\nputs ARGF.gets_to_end\n```\n\nA file to read from: (`file`)\n```text\n123\n```\n\n```text\n$ crystal build program.cr\n$ ./program file\n123\n$ ./program file file\n123123\n$ # If ARGV is empty, ARGF reads from STDIN instead:\n$ echo \"hello\" | ./program\nhello\n$ ./program unknown\nUnhandled exception: Error opening file with mode 'r': 'unknown': No such file or directory (File::NotFoundError)\n...\n```\n\nAfter a file from `ARGV` has been read, it's removed from `ARGV`.\n\nYou can manipulate `ARGV` yourself to control what `ARGF` operates on.\nIf you remove a file from `ARGV`, it is ignored by `ARGF`; if you add files to `ARGV`, `ARGF` will read from it.\n\n```\nARGV.replace [\"file1\"]\nARGF.gets_to_end # => Content of file1\nARGV             # => []\nARGV << \"file2\"\nARGF.gets_to_end # => Content of file2\n```","summary":"<p>An <code><a href=\"IO.html\">IO</a></code> for reading files from <code><a href=\"toplevel.html#ARGV\">ARGV</a></code>.</p>"},{"id":"ARGV","name":"ARGV","value":"Array.new(ARGC_UNSAFE - 1) do |i|\n  String.new(ARGV_UNSAFE[1 + i])\nend","doc":"An array of arguments passed to the program.","summary":"<p>An array of arguments passed to the program.</p>"},{"id":"PROGRAM_NAME","name":"PROGRAM_NAME","value":"String.new(ARGV_UNSAFE.value)","doc":"The name, the program was called with.","summary":"<p>The name, the program was called with.</p>"},{"id":"STDERR","name":"STDERR","value":"IO::FileDescriptor.from_stdio(2)","doc":"The standard error file descriptor.\n\nTypically used to output error messages and diagnostics.\n\nAt the start of the program STDERR is configured like this:\n- if it's a TTY device (like the console) then `sync` is `true`,\n  meaning that output will be outputted as soon as it is written\n  to STDERR. This is so users can see real time output data.\n- if it's not a TTY device (like a file, or because the output\n  was piped to a file) then `sync` is `false` but `flush_on_newline`\n  is `true`. This is so that if you pipe the output to a file, and,\n  for example, you `tail -f`, you can see data on a line-per-line basis.\n  This is convenient but slower than with `flush_on_newline` set to `false`.\n  If you need a bit more performance and you don't care about near real-time\n  output you can do `STDERR.flush_on_newline = false`.","summary":"<p>The standard error file descriptor.</p>"},{"id":"STDIN","name":"STDIN","value":"IO::FileDescriptor.from_stdio(0)","doc":"The standard input file descriptor. Contains data piped to the program.","summary":"<p>The standard input file descriptor.</p>"},{"id":"STDOUT","name":"STDOUT","value":"IO::FileDescriptor.from_stdio(1)","doc":"The standard output file descriptor.\n\nTypically used to output data and information.\n\nAt the start of the program STDOUT is configured like this:\n- if it's a TTY device (like the console) then `sync` is `true`,\n  meaning that output will be outputted as soon as it is written\n  to STDOUT. This is so users can see real time output data.\n- if it's not a TTY device (like a file, or because the output\n  was piped to a file) then `sync` is `false` but `flush_on_newline`\n  is `true`. This is so that if you pipe the output to a file, and,\n  for example, you `tail -f`, you can see data on a line-per-line basis.\n  This is convenient but slower than with `flush_on_newline` set to `false`.\n  If you need a bit more performance and you don't care about near real-time\n  output you can do `STDOUT.flush_on_newline = false`.","summary":"<p>The standard output file descriptor.</p>"}],"included_modules":[{"html_id":"Crystal/Spec/Expectations","kind":"module","full_name":"Spec::Expectations","name":"Expectations"},{"html_id":"Crystal/Spec/Methods","kind":"module","full_name":"Spec::Methods","name":"Methods"}],"extended_modules":[{"html_id":"Crystal/Spec/Expectations","kind":"module","full_name":"Spec::Expectations","name":"Expectations"},{"html_id":"Crystal/Spec/Methods","kind":"module","full_name":"Spec::Methods","name":"Methods"}],"class_methods":[{"html_id":"`(command):String-class-method","name":"`","doc":"Returns the standard output of executing *command* in a subshell.\nStandard input, and error are inherited.\nThe special `$?` variable is set to a `Process::Status` associated with this execution.\n\nIt is impossible to call this method with any regular call syntax. There is an associated literal type which calls the method with the literal content as command:\n\n```\n`echo hi`   # => \"hi\\n\"\n$?.success? # => true\n```\n\nSee [`Command` literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/command.html) in the language reference.","summary":"<p>Returns the standard output of executing <em>command</em> in a subshell.</p>","abstract":false,"args":[{"name":"command","external_name":"command","restriction":""}],"args_string":"(command) : String","args_html":"(command) : <a href=\"String.html\">String</a>","location":{"filename":"src/process.cr","line_number":435,"url":null},"def":{"name":"`","args":[{"name":"command","external_name":"command","restriction":""}],"return_type":"String","visibility":"Public","body":"process = Process.new(command, shell: true, input: Process::Redirect::Inherit, output: Process::Redirect::Pipe, error: Process::Redirect::Inherit)\noutput = process.output.gets_to_end\nstatus = process.wait\n$? = status\noutput\n"}},{"html_id":"abort(message=nil,status=1):NoReturn-class-method","name":"abort","doc":"Terminates execution immediately, printing *message* to `STDERR` and\nthen calling `exit(status)`.","summary":"<p>Terminates execution immediately, printing <em>message</em> to <code><a href=\"toplevel.html#STDERR\">STDERR</a></code> and then calling <code><a href=\"toplevel.html#exit%28status%3D0%29%3ANoReturn-class-method\">exit(status)</a></code>.</p>","abstract":false,"args":[{"name":"message","default_value":"nil","external_name":"message","restriction":""},{"name":"status","default_value":"1","external_name":"status","restriction":""}],"args_string":"(message = nil, status = 1) : NoReturn","args_html":"(message = <span class=\"n\">nil</span>, status = <span class=\"n\">1</span>) : NoReturn","location":{"filename":"src/kernel.cr","line_number":500,"url":null},"def":{"name":"abort","args":[{"name":"message","default_value":"nil","external_name":"message","restriction":""},{"name":"status","default_value":"1","external_name":"status","restriction":""}],"return_type":"NoReturn","visibility":"Public","body":"if message\n  Crystal.ignore_stdio_errors do\n    STDERR.puts(message)\n  end\nend\nexit(status)\n"}},{"html_id":"at_exit(&handler:Int32,Exception?->):Nil-class-method","name":"at_exit","doc":"Registers the given `Proc` for execution when the program exits.\nIf multiple handlers are registered, they are executed in reverse order of registration.\n\n```\ndef do_at_exit(str1)\n  at_exit { print str1 }\nend\n\nat_exit { puts \"cruel world\" }\ndo_at_exit(\"goodbye \")\nexit\n```\n\nProduces:\n\n```text\ngoodbye cruel world\n```\n\nThe exit status code that will be returned by this program is passed to\nthe block as its first argument. In case of any unhandled exception, it is\npassed as the second argument to the block, if the program terminates\nnormally or `exit(status)` is called explicitly, then the second argument\nwill be `nil`.\n\nNOTE: If `at_exit` is called inside an `at_exit` handler, it will be called\nright after the current `at_exit` handler ends, and then other handlers\nwill be invoked.","summary":"<p>Registers the given <code><a href=\"Proc.html\">Proc</a></code> for execution when the program exits.</p>","abstract":false,"location":{"filename":"src/kernel.cr","line_number":483,"url":null},"def":{"name":"at_exit","yields":2,"block_arg":{"name":"handler","external_name":"handler","restriction":"(Int32, Exception | ::Nil ->)"},"return_type":"Nil","visibility":"Public","body":"Crystal::AtExitHandlers.add(handler)"}},{"html_id":"caller:Array(String)-class-method","name":"caller","doc":"Returns the current execution stack as an array containing strings\nusually in the form file:line:column or file:line:column in 'method'.","summary":"<p>Returns the current execution stack as an array containing strings usually in the form file:line:column or file:line:column in 'method'.</p>","abstract":false,"location":{"filename":"src/exception/call_stack.cr","line_number":11,"url":null},"def":{"name":"caller","return_type":"Array(String)","visibility":"Public","body":"Exception::CallStack.new.printable_backtrace"}},{"html_id":"exit(status=0):NoReturn-class-method","name":"exit","doc":"Terminates execution immediately, returning the given status code\nto the invoking environment.\n\nRegistered `at_exit` procs are executed.","summary":"<p>Terminates execution immediately, returning the given status code to the invoking environment.</p>","abstract":false,"args":[{"name":"status","default_value":"0","external_name":"status","restriction":""}],"args_string":"(status = 0) : NoReturn","args_html":"(status = <span class=\"n\">0</span>) : NoReturn","location":{"filename":"src/kernel.cr","line_number":491,"url":null},"def":{"name":"exit","args":[{"name":"status","default_value":"0","external_name":"status","restriction":""}],"return_type":"NoReturn","visibility":"Public","body":"status = Crystal::AtExitHandlers.run(status)\nCrystal.ignore_stdio_errors do\n  STDOUT.flush\nend\nCrystal.ignore_stdio_errors do\n  STDERR.flush\nend\nProcess.exit(status)\n"}},{"html_id":"gets(*args,**options)-class-method","name":"gets","doc":"Reads a line from `STDIN`.\n\nSee also: `IO#gets`.","summary":"<p>Reads a line from <code><a href=\"toplevel.html#STDIN\">STDIN</a></code>.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/kernel.cr","line_number":110,"url":null},"def":{"name":"gets","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"STDIN.gets(*args, **options)"}},{"html_id":"instance_sizeof(type:Class):Int32-class-method","name":"instance_sizeof","doc":"Returns the instance size of the given class as number of bytes.\n\n*type* must be a constant or `typeof()` expression. It cannot be evaluated at runtime.\n\n```\ninstance_sizeof(String)    # => 16\ninstance_sizeof(Exception) # => 48\n```\n\nSee `sizeof` for determining the size of value types.\nNOTE: This is a pseudo-method provided directly by the Crystal compiler.\nIt cannot be redefined nor overridden.","summary":"<p>Returns the instance size of the given class as number of bytes.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Class"}],"args_string":"(type : Class) : Int32","args_html":"(type : <a href=\"Class.html\">Class</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/docs_pseudo_methods.cr","line_number":61,"url":null},"def":{"name":"__crystal_pseudo_instance_sizeof","args":[{"name":"type","external_name":"type","restriction":"Class"}],"return_type":"Int32","visibility":"Public","body":""}},{"html_id":"loop(&)-class-method","name":"loop","doc":"Repeatedly executes the block.\n\n```\nloop do\n  line = gets\n  break unless line\n  # ...\nend\n```","summary":"<p>Repeatedly executes the block.</p>","abstract":false,"location":{"filename":"src/kernel.cr","line_number":101,"url":null},"def":{"name":"loop","yields":0,"visibility":"Public","body":"while true\n  yield\nend"}},{"html_id":"main(argc:Int32,argv:Pointer(Pointer(UInt8)))-class-method","name":"main","doc":"Main function that acts as C's main function.\nInvokes `Crystal.main`.\n\nCan be redefined. See `Crystal.main` for examples.\n\nOn Windows the actual entry point is `wmain`, but there is no need to redefine\nthat. See the file required below for details.","summary":"<p>Main function that acts as C's main function.</p>","abstract":false,"args":[{"name":"argc","external_name":"argc","restriction":""},{"name":"argv","external_name":"argv","restriction":""}],"args_string":"(argc : Int32, argv : Pointer(Pointer(UInt8)))","args_html":"(argc : <a href=\"Int32.html\">Int32</a>, argv : <a href=\"Pointer.html\">Pointer</a>(<a href=\"Pointer.html\">Pointer</a>(<a href=\"UInt8.html\">UInt8</a>)))","location":{"filename":"src/crystal/main.cr","line_number":126,"url":null},"def":{"name":"main","args":[{"name":"argc","external_name":"argc","restriction":""},{"name":"argv","external_name":"argv","restriction":""}],"visibility":"Public","body":"Crystal.main(argc, argv)"}},{"html_id":"offsetof(type:Class,offset):Int32-class-method","name":"offsetof","doc":"Returns the byte offset of an instance variable in a struct or class type.\n\n*type* must be a constant or `typeof()` expression. It cannot be evaluated at runtime.\n*offset*  must be the name of an instance variable of *type*, prefixed by `@`,\nor the index of an element in a Tuple, starting from 0, if *type* is a `Tuple`.\n```\noffsetof(String, @bytesize)       # => 4\noffsetof(Exception, @message)     # => 8\noffsetof(Time, @location)         # => 16\noffsetof({Int32, Int8, Int32}, 0) # => 0\noffsetof({Int32, Int8, Int32}, 1) # => 4\noffsetof({Int32, Int8, Int32}, 2) # => 8\n```\nNOTE: This is a pseudo-method provided directly by the Crystal compiler.\nIt cannot be redefined nor overridden.","summary":"<p>Returns the byte offset of an instance variable in a struct or class type.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Class"},{"name":"offset","external_name":"offset","restriction":""}],"args_string":"(type : Class, offset) : Int32","args_html":"(type : <a href=\"Class.html\">Class</a>, offset) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/docs_pseudo_methods.cr","line_number":91,"url":null},"def":{"name":"__crystal_pseudo_offsetof","args":[{"name":"type","external_name":"type","restriction":"Class"},{"name":"offset","external_name":"offset","restriction":""}],"return_type":"Int32","visibility":"Public","body":""}},{"html_id":"p(object)-class-method","name":"p","doc":"Inspects *object* to `STDOUT` followed\nby a newline. Returns *object*.\n\nSee also: `Object#inspect(io)`.","summary":"<p>Inspects <em>object</em> to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code> followed by a newline.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":""}],"args_string":"(object)","args_html":"(object)","location":{"filename":"src/kernel.cr","line_number":393,"url":null},"def":{"name":"p","args":[{"name":"object","external_name":"object","restriction":""}],"visibility":"Public","body":"object.inspect(STDOUT)\nputs\nobject\n"}},{"html_id":"p(*objects)-class-method","name":"p","doc":"Inspects each object in *objects* to `STDOUT`, followed\nby a newline. Returns *objects*.\n\nSee also: `Object#inspect(io)`.","summary":"<p>Inspects each object in <em>objects</em> to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code>, followed by a newline.</p>","abstract":false,"args":[{"name":"objects","external_name":"objects","restriction":""}],"args_string":"(*objects)","args_html":"(*objects)","location":{"filename":"src/kernel.cr","line_number":403,"url":null},"def":{"name":"p","args":[{"name":"objects","external_name":"objects","restriction":""}],"splat_index":0,"visibility":"Public","body":"objects.each do |obj|\n  p(obj)\nend\nobjects\n"}},{"html_id":"p(**objects)-class-method","name":"p","doc":"Inspects *objects* to `STDOUT`, followed\nby a newline. Returns *objects*.\n\n```\np foo: 23, bar: 42 # => {foo: 23, bar: 42}\n```\n\nSee `Object#inspect(io)`","summary":"<p>Inspects <em>objects</em> to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code>, followed by a newline.</p>","abstract":false,"location":{"filename":"src/kernel.cr","line_number":418,"url":null},"def":{"name":"p","double_splat":{"name":"objects","external_name":"objects","restriction":""},"visibility":"Public","body":"if objects.empty?\nelse\n  p(objects)\nend"}},{"html_id":"pointerof(variable:T):Pointer(T)forallT-class-method","name":"pointerof","doc":"Returns a `Pointer` to the contents of a variable.\n\n*variable* must be a variable (local, instance, class or library).\n\n```\na = 1\nptr = pointerof(a)\nptr.value = 2\n\na # => 2\n```\nNOTE: This is a pseudo-method provided directly by the Crystal compiler.\nIt cannot be redefined nor overridden.","summary":"<p>Returns a <code><a href=\"Pointer.html\">Pointer</a></code> to the contents of a variable.</p>","abstract":false,"args":[{"name":"variable","external_name":"variable","restriction":"T"}],"args_string":"(variable : T) : Pointer(T) forall T","args_html":"(variable : T) : <a href=\"Pointer.html\">Pointer</a>(T) forall T","location":{"filename":"src/docs_pseudo_methods.cr","line_number":75,"url":null},"def":{"name":"__crystal_pseudo_pointerof","args":[{"name":"variable","external_name":"variable","restriction":"T"}],"return_type":"Pointer(T)","visibility":"Public","body":""}},{"html_id":"pp(object)-class-method","name":"pp","doc":"Pretty prints *object* to `STDOUT` followed\nby a newline. Returns *object*.\n\nSee also: `Object#pretty_print(pp)`.","summary":"<p>Pretty prints <em>object</em> to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code> followed by a newline.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":""}],"args_string":"(object)","args_html":"(object)","location":{"filename":"src/kernel.cr","line_number":426,"url":null},"def":{"name":"pp","args":[{"name":"object","external_name":"object","restriction":""}],"visibility":"Public","body":"PrettyPrint.format(object, STDOUT, 79)\nputs\nobject\n"}},{"html_id":"pp(*objects)-class-method","name":"pp","doc":"Pretty prints each object in *objects* to `STDOUT`, followed\nby a newline. Returns *objects*.\n\nSee also: `Object#pretty_print(pp)`.","summary":"<p>Pretty prints each object in <em>objects</em> to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code>, followed by a newline.</p>","abstract":false,"args":[{"name":"objects","external_name":"objects","restriction":""}],"args_string":"(*objects)","args_html":"(*objects)","location":{"filename":"src/kernel.cr","line_number":436,"url":null},"def":{"name":"pp","args":[{"name":"objects","external_name":"objects","restriction":""}],"splat_index":0,"visibility":"Public","body":"objects.each do |obj|\n  pp(obj)\nend\nobjects\n"}},{"html_id":"pp(**objects)-class-method","name":"pp","doc":"Pretty prints *objects* to `STDOUT`, followed\nby a newline. Returns *objects*.\n\n```\np foo: 23, bar: 42 # => {foo: 23, bar: 42}\n```\n\nSee `Object#pretty_print(pp)`","summary":"<p>Pretty prints <em>objects</em> to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code>, followed by a newline.</p>","abstract":false,"location":{"filename":"src/kernel.cr","line_number":451,"url":null},"def":{"name":"pp","double_splat":{"name":"objects","external_name":"objects","restriction":""},"visibility":"Public","body":"if objects.empty?\nelse\n  pp(objects)\nend"}},{"html_id":"print(*objects:_):Nil-class-method","name":"print","doc":"Prints objects to `STDOUT` and then invokes `STDOUT.flush`.\n\nSee also: `IO#print`.","summary":"<p>Prints objects to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code> and then invokes <code>STDOUT.flush</code>.</p>","abstract":false,"args":[{"name":"objects","external_name":"objects","restriction":"_"}],"args_string":"(*objects : _) : Nil","args_html":"(*objects : _) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/kernel.cr","line_number":124,"url":null},"def":{"name":"print","args":[{"name":"objects","external_name":"objects","restriction":"_"}],"splat_index":0,"return_type":"Nil","visibility":"Public","body":"STDOUT.print(*objects)"}},{"html_id":"printf(format_string,args:Array|Tuple):Nil-class-method","name":"printf","doc":"Prints a formatted string to `STDOUT`.\n\nFor details on the format string, see `sprintf`.","summary":"<p>Prints a formatted string to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code>.</p>","abstract":false,"args":[{"name":"format_string","external_name":"format_string","restriction":""},{"name":"args","external_name":"args","restriction":"Array | Tuple"}],"args_string":"(format_string, args : Array | Tuple) : Nil","args_html":"(format_string, args : <a href=\"Array.html\">Array</a> | <a href=\"Tuple.html\">Tuple</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/kernel.cr","line_number":136,"url":null},"def":{"name":"printf","args":[{"name":"format_string","external_name":"format_string","restriction":""},{"name":"args","external_name":"args","restriction":"Array | Tuple"}],"return_type":"Nil","visibility":"Public","body":"STDOUT.printf(format_string, args)"}},{"html_id":"printf(format_string,*args):Nil-class-method","name":"printf","doc":"Prints a formatted string to `STDOUT`.\n\nFor details on the format string, see `sprintf`.","summary":"<p>Prints a formatted string to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code>.</p>","abstract":false,"args":[{"name":"format_string","external_name":"format_string","restriction":""},{"name":"args","external_name":"args","restriction":""}],"args_string":"(format_string, *args) : Nil","args_html":"(format_string, *args) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/kernel.cr","line_number":131,"url":null},"def":{"name":"printf","args":[{"name":"format_string","external_name":"format_string","restriction":""},{"name":"args","external_name":"args","restriction":""}],"splat_index":1,"return_type":"Nil","visibility":"Public","body":"printf(format_string, args)"}},{"html_id":"puts(*objects):Nil-class-method","name":"puts","doc":"Prints *objects* to `STDOUT`, each followed by a newline character unless\nthe object is a `String` and already ends with a newline.\n\nSee also: `IO#puts`.","summary":"<p>Prints <em>objects</em> to <code><a href=\"toplevel.html#STDOUT\">STDOUT</a></code>, each followed by a newline character unless the object is a <code><a href=\"String.html\">String</a></code> and already ends with a newline.</p>","abstract":false,"args":[{"name":"objects","external_name":"objects","restriction":""}],"args_string":"(*objects) : Nil","args_html":"(*objects) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/kernel.cr","line_number":385,"url":null},"def":{"name":"puts","args":[{"name":"objects","external_name":"objects","restriction":""}],"splat_index":0,"return_type":"Nil","visibility":"Public","body":"STDOUT.puts(*objects)"}},{"html_id":"raise(exception:Exception):NoReturn-class-method","name":"raise","doc":"Raises the *exception*.\n\nThis will set the exception's callstack if it hasn't been already.\nRe-raising a previously caught exception won't replace the callstack.","summary":"<p>Raises the <em>exception</em>.</p>","abstract":false,"args":[{"name":"exception","external_name":"exception","restriction":"Exception"}],"args_string":"(exception : Exception) : NoReturn","args_html":"(exception : <a href=\"Exception.html\">Exception</a>) : NoReturn","location":{"filename":"src/raise.cr","line_number":192,"url":null},"def":{"name":"raise","args":[{"name":"exception","external_name":"exception","restriction":"Exception"}],"return_type":"NoReturn","visibility":"Public","body":"exception.callstack || (exception.callstack = Exception::CallStack.new)\nraise_without_backtrace(exception)\n"}},{"html_id":"raise(message:String):NoReturn-class-method","name":"raise","doc":"Raises an Exception with the *message*.","summary":"<p>Raises an Exception with the <em>message</em>.</p>","abstract":false,"args":[{"name":"message","external_name":"message","restriction":"String"}],"args_string":"(message : String) : NoReturn","args_html":"(message : <a href=\"String.html\">String</a>) : NoReturn","location":{"filename":"src/raise.cr","line_number":225,"url":null},"def":{"name":"raise","args":[{"name":"message","external_name":"message","restriction":"String"}],"return_type":"NoReturn","visibility":"Public","body":"raise(Exception.new(message))"}},{"html_id":"raise_without_backtrace(exception:Exception):NoReturn-class-method","name":"raise_without_backtrace","abstract":false,"args":[{"name":"exception","external_name":"exception","restriction":"Exception"}],"args_string":"(exception : Exception) : NoReturn","args_html":"(exception : <a href=\"Exception.html\">Exception</a>) : NoReturn","location":{"filename":"src/raise.cr","line_number":231,"url":null},"def":{"name":"raise_without_backtrace","args":[{"name":"exception","external_name":"exception","restriction":"Exception"}],"return_type":"NoReturn","visibility":"Public","body":"unwind_ex = Pointer(LibUnwind::Exception).malloc\nunwind_ex.value.exception_class = LibC::SizeT.zero\nunwind_ex.value.exception_cleanup = LibC::SizeT.zero\nunwind_ex.value.exception_object = exception.as(::Pointer(Void))\nunwind_ex.value.exception_type_id = exception.crystal_type_id\n__crystal_raise(unwind_ex)\n"}},{"html_id":"rand(x)-class-method","name":"rand","doc":"See `Random#rand(x)`.","summary":"<p>See <code>Random#rand(x)</code>.</p>","abstract":false,"args":[{"name":"x","external_name":"x","restriction":""}],"args_string":"(x)","args_html":"(x)","location":{"filename":"src/random.cr","line_number":442,"url":null},"def":{"name":"rand","args":[{"name":"x","external_name":"x","restriction":""}],"visibility":"Public","body":"Random.rand(x)"}},{"html_id":"rand:Float64-class-method","name":"rand","doc":"See `Random#rand`.","summary":"<p>See <code>Random#rand</code>.</p>","abstract":false,"location":{"filename":"src/random.cr","line_number":437,"url":null},"def":{"name":"rand","return_type":"Float64","visibility":"Public","body":"Random.rand"}},{"html_id":"read_line(*args,**options)-class-method","name":"read_line","doc":"Reads a line from `STDIN`.\n\nSee also: `IO#read_line`.","summary":"<p>Reads a line from <code><a href=\"toplevel.html#STDIN\">STDIN</a></code>.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/kernel.cr","line_number":117,"url":null},"def":{"name":"read_line","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"STDIN.read_line(*args, **options)"}},{"html_id":"sizeof(type:Class):Int32-class-method","name":"sizeof","doc":"Returns the size of the given type as number of bytes.\n\n*type* must be a constant or `typeof()` expression. It cannot be evaluated\nat runtime.\n\n```\nsizeof(Int32)        # => 4\nsizeof(Int64)        # => 8\nsizeof(typeof(true)) # => 1\n```\n\nFor `Reference` types, the size is the same as the size of a pointer:\n\n```\n# On a 64 bits machine\nsizeof(Pointer(Int32)) # => 8\nsizeof(String)         # => 8\n```\n\nThis is because a `Reference`'s memory is allocated on the heap and a pointer\nto it is passed around. The size of a class on the heap can be determined\nusing `#instance_sizeof`.\nNOTE: This is a pseudo-method provided directly by the Crystal compiler.\nIt cannot be redefined nor overridden.","summary":"<p>Returns the size of the given type as number of bytes.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Class"}],"args_string":"(type : Class) : Int32","args_html":"(type : <a href=\"Class.html\">Class</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/docs_pseudo_methods.cr","line_number":48,"url":null},"def":{"name":"__crystal_pseudo_sizeof","args":[{"name":"type","external_name":"type","restriction":"Class"}],"return_type":"Int32","visibility":"Public","body":""}},{"html_id":"sleep(seconds:Number):Nil-class-method","name":"sleep","doc":"Blocks the current fiber for the specified number of seconds.\n\nWhile this fiber is waiting this time, other ready-to-execute\nfibers might start their execution.","summary":"<p>Blocks the current fiber for the specified number of seconds.</p>","abstract":false,"args":[{"name":"seconds","external_name":"seconds","restriction":"Number"}],"args_string":"(seconds : Number) : Nil","args_html":"(seconds : <a href=\"Number.html\">Number</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/concurrent.cr","line_number":9,"url":null},"def":{"name":"sleep","args":[{"name":"seconds","external_name":"seconds","restriction":"Number"}],"return_type":"Nil","visibility":"Public","body":"if seconds < 0\n  raise(ArgumentError.new(\"Sleep seconds must be positive\"))\nend\nCrystal::Scheduler.sleep(seconds.seconds)\n"}},{"html_id":"sleep(time:Time::Span):Nil-class-method","name":"sleep","doc":"Blocks the current Fiber for the specified time span.\n\nWhile this fiber is waiting this time, other ready-to-execute\nfibers might start their execution.","summary":"<p>Blocks the current Fiber for the specified time span.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time::Span"}],"args_string":"(time : Time::Span) : Nil","args_html":"(time : <a href=\"Time/Span.html\">Time::Span</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/concurrent.cr","line_number":21,"url":null},"def":{"name":"sleep","args":[{"name":"time","external_name":"time","restriction":"Time::Span"}],"return_type":"Nil","visibility":"Public","body":"Crystal::Scheduler.sleep(time)"}},{"html_id":"sleep:Nil-class-method","name":"sleep","doc":"Blocks the current fiber forever.\n\nMeanwhile, other ready-to-execute fibers might start their execution.","summary":"<p>Blocks the current fiber forever.</p>","abstract":false,"location":{"filename":"src/concurrent.cr","line_number":28,"url":null},"def":{"name":"sleep","return_type":"Nil","visibility":"Public","body":"Crystal::Scheduler.reschedule"}},{"html_id":"spawn(*,name:String?=nil,same_thread=false,&block)-class-method","name":"spawn","doc":"Spawns a new fiber.\n\nThe newly created fiber doesn't run as soon as spawned.\n\nExample:\n```\n# Write \"1\" every 1 second and \"2\" every 2 seconds for 6 seconds.\n\nch = Channel(Nil).new\n\nspawn do\n  6.times do\n    sleep 1\n    puts 1\n  end\n  ch.send(nil)\nend\n\nspawn do\n  3.times do\n    sleep 2\n    puts 2\n  end\n  ch.send(nil)\nend\n\n2.times { ch.receive }\n```","summary":"<p>Spawns a new fiber.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"name","default_value":"nil","external_name":"name","restriction":"String | ::Nil"},{"name":"same_thread","default_value":"false","external_name":"same_thread","restriction":""}],"args_string":"(*, name : String? = nil, same_thread = false, &block)","args_html":"(*, name : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>, same_thread = <span class=\"n\">false</span>, &block)","location":{"filename":"src/concurrent.cr","line_number":60,"url":null},"def":{"name":"spawn","args":[{"name":"","external_name":"","restriction":""},{"name":"name","default_value":"nil","external_name":"name","restriction":"String | ::Nil"},{"name":"same_thread","default_value":"false","external_name":"same_thread","restriction":""}],"splat_index":0,"yields":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"fiber = Fiber.new(name, &block)\nif same_thread\n  (fiber.@current_thread).set(Thread.current)\nend\nCrystal::Scheduler.enqueue(fiber)\nfiber\n"}},{"html_id":"sprintf(format_string,args:Array|Tuple):String-class-method","name":"sprintf","doc":"Returns a formatted string.\nThe string is produced according to the *format_string* with format specifiers\nbeing replaced by values from *args* formatted according to the specifier.\n\nWithin the format string, any characters other than format specifiers\n(specifiers beginning with `%`) are copied to the result.\nThe formatter supports positional format specifiers (`%.1f`),\nformatted substitution (`%<name>.1f`) and plain substitution (`%{name}`).\n\nSubstitutions expect the first argument to be a `Hash` or `NamedTuple` to\nresolve substitution names.\nPositional specifiers correspond to the positional values in the method\narguments, or the array supplied as first argument.\n\nA simple format specifier consists of a percent sign, followed by optional flags,\nwidth, and precision indicators, then terminated with a field type\ncharacter.\n\n```text\n%[flags][width][.precision]type\n```\n\nA formatted substitution is similar but after the percent sign follows the\nmandatory name of the substitution wrapped in angle brackets.\n\n```text\n%<name>[flags][width][.precision]type\n```\n\nThe field type controls how the corresponding argument value is to be\ninterpreted, while the flags modify that interpretation.\n\nThe field type characters are:\n\n```text\nField | Integer Format\n------+------------------------------------------------------------------\n  b   | Formats argument as a binary number.\n  d   | Formats argument as a decimal number.\n  i   | Same as d.\n  o   | Formats argument as an octal number.\n  x   | Formats argument as a hexadecimal number using lowercase letters.\n  X   | Same as x, but uses uppercase letters.\n\nField | Float Format\n------+---------------------------------------------------------------\n  e   | Formats floating point argument into exponential notation\n      | with one digit before the decimal point as [-]d.dddddde[+-]dd.\n      | The precision specifies the number of digits after the decimal\n      | point (defaulting to six).\n  E   | Equivalent to e, but uses an uppercase E to indicate\n      | the exponent.\n  f   | Formats floating point argument as [-]ddd.dddddd,\n      | where the precision specifies the number of digits after\n      | the decimal point.\n  g   | Formats a floating point number using exponential form\n      | if the exponent is less than -4 or greater than or\n      | equal to the precision, or in dd.dddd form otherwise.\n      | The precision specifies the number of significant digits.\n  G   | Equivalent to g, but use an uppercase E in exponent form.\n  a   | Formats floating point argument as [-]0xh.hhhhp[+-]dd,\n      | which consists of an optional sign, \"0x\", fraction part\n      | as hexadecimal, \"p\", and exponential part as decimal.\n  A   | Equivalent to a, but uses uppercase X and P.\n\nField | Other Format\n------+------------------------------------------------------------\n  c   | Argument is a single character itself.\n  s   | Argument is a string to be substituted. If the format\n      | sequence contains a precision, at most that many characters\n      | will be copied.\n  %   | A percent sign itself will be displayed. No argument taken.\n```\n\nFlags modify the behavior of the format specifiers:\n\n```text\nFlag     | Applies to    | Meaning\n---------+---------------+--------------------------------------------\nspace    | bdiouxX       | Add a leading space character to\n         | aAeEfgG       | non-negative numbers.\n         | (numeric fmt) | For o, x, X, b, use\n         |               | a minus sign with absolute value for\n         |               | negative values.\n---------+---------------+--------------------------------------------\n+        | bdiouxX       | Add a leading plus sign to non-negative\n         | aAeEfgG       | numbers.\n         | (numeric fmt) | For o, x, X, b, use\n         |               | a minus sign with absolute value for\n         |               | negative values.\n---------+---------------+--------------------------------------------\n-        | all           | Left-justify the result of this conversion.\n---------+---------------+--------------------------------------------\n0 (zero) | bdiouxX       | Pad with zeros, not spaces.\n         | aAeEfgG       | For o, x, X, b, radix-1\n         | (numeric fmt) | is used for negative numbers formatted as\n         |               | complements.\n```\n\nExamples of flags:\n\nDecimal number conversion:\n```\nsprintf \"%d\", 123  # => \"123\"\nsprintf \"%+d\", 123 # => \"+123\"\nsprintf \"% d\", 123 # => \" 123\"\n```\n\nOctal number conversion:\n```\nsprintf \"%o\", 123   # => \"173\"\nsprintf \"%+o\", 123  # => \"+173\"\nsprintf \"%o\", -123  # => \"-173\"\nsprintf \"%+o\", -123 # => \"-173\"\n```\n\nHexadecimal number conversion:\n```\nsprintf \"%x\", 123   # => \"7b\"\nsprintf \"%+x\", 123  # => \"+7b\"\nsprintf \"%x\", -123  # => \"-7b\"\nsprintf \"%+x\", -123 # => \"-7b\"\nsprintf \"%#x\", 0    # => \"0\"\nsprintf \"% x\", 123  # => \" 7b\"\nsprintf \"% x\", -123 # => \"-7b\"\nsprintf \"%X\", 123   # => \"7B\"\nsprintf \"%#X\", -123 # => \"-7B\"\n```\n\nBinary number conversion:\n```\nsprintf \"%b\", 123    # => \"1111011\"\nsprintf \"%+b\", 123   # => \"+1111011\"\nsprintf \"%+b\", -123  # => \"-1111011\"\nsprintf \"%b\", -123   # => \"-1111011\"\nsprintf \"%#b\", 0     # => \"0\"\nsprintf \"% b\", 123   # => \" 1111011\"\nsprintf \"%+ b\", 123  # => \"+ 1111011\"\nsprintf \"% b\", -123  # => \"-1111011\"\nsprintf \"%+ b\", -123 # => \"-1111011\"\n```\n\nFloating point conversion:\n```\nsprintf \"%a\", 123 # => \"0x1.ecp+6\"\nsprintf \"%A\", 123 # => \"0X1.ECP+6\"\n```\n\nExponential form conversion:\n```\nsprintf \"%g\", 123.4          # => \"123.4\"\nsprintf \"%g\", 123.4567       # => \"123.457\"\nsprintf \"%20.8g\", 1234.56789 # => \"           1234.5679\"\nsprintf \"%20.8g\", 123456789  # => \"       1.2345679e+08\"\nsprintf \"%20.8G\", 123456789  # => \"       1.2345679E+08\"\nsprintf \"%20.8g\", -123456789 # => \"      -1.2345679e+08\"\nsprintf \"%20.8G\", -123456789 # => \"      -1.2345679E+08\"\n```\n\nThe field width is an optional integer, followed optionally by a\nperiod and a precision. The width specifies the minimum number of\ncharacters that will be written to the result for this field.\n\nExamples of width:\n```\nsprintf \"%20d\", 123   # => \"                 123\"\nsprintf \"%+20d\", 123  # => \"                +123\"\nsprintf \"%020d\", 123  # => \"00000000000000000123\"\nsprintf \"%+020d\", 123 # => \"+0000000000000000123\"\nsprintf \"% 020d\", 123 # => \" 0000000000000000123\"\nsprintf \"%-20d\", 123  # => \"123                 \"\nsprintf \"%-+20d\", 123 # => \"+123                \"\nsprintf \"%- 20d\", 123 # => \" 123                \"\nsprintf \"%020x\", -123 # => \"00000000000000000-7b\"\nsprintf \"%020X\", -123 # => \"00000000000000000-7B\"\n```\n\nFor numeric fields, the precision controls the number of decimal places\ndisplayed.\n\nFor string fields, the precision determines the maximum\nnumber of characters to be copied from the string.\n\nExamples of precisions:\n\nPrecision for `d`, `o`, `x` and `b` is\nminimum number of digits:\n```\nsprintf \"%20.8d\", 123   # => \"                 123\"\nsprintf \"%020.8d\", 123  # => \"00000000000000000123\"\nsprintf \"%20.8o\", 123   # => \"                 173\"\nsprintf \"%020.8o\", 123  # => \"00000000000000000173\"\nsprintf \"%20.8x\", 123   # => \"                  7b\"\nsprintf \"%020.8x\", 123  # => \"0000000000000000007b\"\nsprintf \"%20.8b\", 123   # => \"             1111011\"\nsprintf \"%20.8d\", -123  # => \"                -123\"\nsprintf \"%020.8d\", -123 # => \"0000000000000000-123\"\nsprintf \"%20.8o\", -123  # => \"                -173\"\nsprintf \"%20.8x\", -123  # => \"                 -7b\"\nsprintf \"%20.8b\", -11   # => \"               -1011\"\n```\n\nPrecision for `e` is number of digits after the decimal point:\n```\nsprintf \"%20.8e\", 1234.56789 # => \"      1.23456789e+03\"\n```\n\nPrecision for `f` is number of digits after the decimal point:\n```\nsprintf \"%20.8f\", 1234.56789 # => \"       1234.56789000\"\n```\n\nPrecision for `g` is number of significant digits:\n```\nsprintf \"%20.8g\", 1234.56789 # => \"           1234.5679\"\nsprintf \"%20.8g\", 123456789  # => \"       1.2345679e+08\"\nsprintf \"%-20.8g\", 123456789 # => \"1.2345679e+08       \"\n```\n\nPrecision for `s` is maximum number of characters:\n```\nsprintf \"%20.8s\", \"string test\" # => \"            string t\"\n```\n\nAdditional examples:\n```\nsprintf \"%d %04x\", 123, 123             # => \"123 007b\"\nsprintf \"%08b '%4s'\", 123, 123          # => \"01111011 ' 123'\"\nsprintf \"%+g:% g:%-g\", 1.23, 1.23, 1.23 # => \"+1.23: 1.23:1.23\"\n```","summary":"<p>Returns a formatted string.</p>","abstract":false,"args":[{"name":"format_string","external_name":"format_string","restriction":""},{"name":"args","external_name":"args","restriction":"Array | Tuple"}],"args_string":"(format_string, args : Array | Tuple) : String","args_html":"(format_string, args : <a href=\"Array.html\">Array</a> | <a href=\"Tuple.html\">Tuple</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/kernel.cr","line_number":375,"url":null},"def":{"name":"sprintf","args":[{"name":"format_string","external_name":"format_string","restriction":""},{"name":"args","external_name":"args","restriction":"Array | Tuple"}],"return_type":"String","visibility":"Public","body":"String.build(format_string.bytesize) do |str|\n  (String::Formatter(typeof(args)).new(format_string, args, str)).format\nend"}},{"html_id":"sprintf(format_string,*args):String-class-method","name":"sprintf","doc":"Returns a formatted string.\nThe string is produced according to the *format_string* with format specifiers\nbeing replaced by values from *args* formatted according to the specifier.\n\nWithin the format string, any characters other than format specifiers\n(specifiers beginning with `%`) are copied to the result.\nThe formatter supports positional format specifiers (`%.1f`),\nformatted substitution (`%<name>.1f`) and plain substitution (`%{name}`).\n\nSubstitutions expect the first argument to be a `Hash` or `NamedTuple` to\nresolve substitution names.\nPositional specifiers correspond to the positional values in the method\narguments, or the array supplied as first argument.\n\nA simple format specifier consists of a percent sign, followed by optional flags,\nwidth, and precision indicators, then terminated with a field type\ncharacter.\n\n```text\n%[flags][width][.precision]type\n```\n\nA formatted substitution is similar but after the percent sign follows the\nmandatory name of the substitution wrapped in angle brackets.\n\n```text\n%<name>[flags][width][.precision]type\n```\n\nThe field type controls how the corresponding argument value is to be\ninterpreted, while the flags modify that interpretation.\n\nThe field type characters are:\n\n```text\nField | Integer Format\n------+------------------------------------------------------------------\n  b   | Formats argument as a binary number.\n  d   | Formats argument as a decimal number.\n  i   | Same as d.\n  o   | Formats argument as an octal number.\n  x   | Formats argument as a hexadecimal number using lowercase letters.\n  X   | Same as x, but uses uppercase letters.\n\nField | Float Format\n------+---------------------------------------------------------------\n  e   | Formats floating point argument into exponential notation\n      | with one digit before the decimal point as [-]d.dddddde[+-]dd.\n      | The precision specifies the number of digits after the decimal\n      | point (defaulting to six).\n  E   | Equivalent to e, but uses an uppercase E to indicate\n      | the exponent.\n  f   | Formats floating point argument as [-]ddd.dddddd,\n      | where the precision specifies the number of digits after\n      | the decimal point.\n  g   | Formats a floating point number using exponential form\n      | if the exponent is less than -4 or greater than or\n      | equal to the precision, or in dd.dddd form otherwise.\n      | The precision specifies the number of significant digits.\n  G   | Equivalent to g, but use an uppercase E in exponent form.\n  a   | Formats floating point argument as [-]0xh.hhhhp[+-]dd,\n      | which consists of an optional sign, \"0x\", fraction part\n      | as hexadecimal, \"p\", and exponential part as decimal.\n  A   | Equivalent to a, but uses uppercase X and P.\n\nField | Other Format\n------+------------------------------------------------------------\n  c   | Argument is a single character itself.\n  s   | Argument is a string to be substituted. If the format\n      | sequence contains a precision, at most that many characters\n      | will be copied.\n  %   | A percent sign itself will be displayed. No argument taken.\n```\n\nFlags modify the behavior of the format specifiers:\n\n```text\nFlag     | Applies to    | Meaning\n---------+---------------+--------------------------------------------\nspace    | bdiouxX       | Add a leading space character to\n         | aAeEfgG       | non-negative numbers.\n         | (numeric fmt) | For o, x, X, b, use\n         |               | a minus sign with absolute value for\n         |               | negative values.\n---------+---------------+--------------------------------------------\n+        | bdiouxX       | Add a leading plus sign to non-negative\n         | aAeEfgG       | numbers.\n         | (numeric fmt) | For o, x, X, b, use\n         |               | a minus sign with absolute value for\n         |               | negative values.\n---------+---------------+--------------------------------------------\n-        | all           | Left-justify the result of this conversion.\n---------+---------------+--------------------------------------------\n0 (zero) | bdiouxX       | Pad with zeros, not spaces.\n         | aAeEfgG       | For o, x, X, b, radix-1\n         | (numeric fmt) | is used for negative numbers formatted as\n         |               | complements.\n```\n\nExamples of flags:\n\nDecimal number conversion:\n```\nsprintf \"%d\", 123  # => \"123\"\nsprintf \"%+d\", 123 # => \"+123\"\nsprintf \"% d\", 123 # => \" 123\"\n```\n\nOctal number conversion:\n```\nsprintf \"%o\", 123   # => \"173\"\nsprintf \"%+o\", 123  # => \"+173\"\nsprintf \"%o\", -123  # => \"-173\"\nsprintf \"%+o\", -123 # => \"-173\"\n```\n\nHexadecimal number conversion:\n```\nsprintf \"%x\", 123   # => \"7b\"\nsprintf \"%+x\", 123  # => \"+7b\"\nsprintf \"%x\", -123  # => \"-7b\"\nsprintf \"%+x\", -123 # => \"-7b\"\nsprintf \"%#x\", 0    # => \"0\"\nsprintf \"% x\", 123  # => \" 7b\"\nsprintf \"% x\", -123 # => \"-7b\"\nsprintf \"%X\", 123   # => \"7B\"\nsprintf \"%#X\", -123 # => \"-7B\"\n```\n\nBinary number conversion:\n```\nsprintf \"%b\", 123    # => \"1111011\"\nsprintf \"%+b\", 123   # => \"+1111011\"\nsprintf \"%+b\", -123  # => \"-1111011\"\nsprintf \"%b\", -123   # => \"-1111011\"\nsprintf \"%#b\", 0     # => \"0\"\nsprintf \"% b\", 123   # => \" 1111011\"\nsprintf \"%+ b\", 123  # => \"+ 1111011\"\nsprintf \"% b\", -123  # => \"-1111011\"\nsprintf \"%+ b\", -123 # => \"-1111011\"\n```\n\nFloating point conversion:\n```\nsprintf \"%a\", 123 # => \"0x1.ecp+6\"\nsprintf \"%A\", 123 # => \"0X1.ECP+6\"\n```\n\nExponential form conversion:\n```\nsprintf \"%g\", 123.4          # => \"123.4\"\nsprintf \"%g\", 123.4567       # => \"123.457\"\nsprintf \"%20.8g\", 1234.56789 # => \"           1234.5679\"\nsprintf \"%20.8g\", 123456789  # => \"       1.2345679e+08\"\nsprintf \"%20.8G\", 123456789  # => \"       1.2345679E+08\"\nsprintf \"%20.8g\", -123456789 # => \"      -1.2345679e+08\"\nsprintf \"%20.8G\", -123456789 # => \"      -1.2345679E+08\"\n```\n\nThe field width is an optional integer, followed optionally by a\nperiod and a precision. The width specifies the minimum number of\ncharacters that will be written to the result for this field.\n\nExamples of width:\n```\nsprintf \"%20d\", 123   # => \"                 123\"\nsprintf \"%+20d\", 123  # => \"                +123\"\nsprintf \"%020d\", 123  # => \"00000000000000000123\"\nsprintf \"%+020d\", 123 # => \"+0000000000000000123\"\nsprintf \"% 020d\", 123 # => \" 0000000000000000123\"\nsprintf \"%-20d\", 123  # => \"123                 \"\nsprintf \"%-+20d\", 123 # => \"+123                \"\nsprintf \"%- 20d\", 123 # => \" 123                \"\nsprintf \"%020x\", -123 # => \"00000000000000000-7b\"\nsprintf \"%020X\", -123 # => \"00000000000000000-7B\"\n```\n\nFor numeric fields, the precision controls the number of decimal places\ndisplayed.\n\nFor string fields, the precision determines the maximum\nnumber of characters to be copied from the string.\n\nExamples of precisions:\n\nPrecision for `d`, `o`, `x` and `b` is\nminimum number of digits:\n```\nsprintf \"%20.8d\", 123   # => \"                 123\"\nsprintf \"%020.8d\", 123  # => \"00000000000000000123\"\nsprintf \"%20.8o\", 123   # => \"                 173\"\nsprintf \"%020.8o\", 123  # => \"00000000000000000173\"\nsprintf \"%20.8x\", 123   # => \"                  7b\"\nsprintf \"%020.8x\", 123  # => \"0000000000000000007b\"\nsprintf \"%20.8b\", 123   # => \"             1111011\"\nsprintf \"%20.8d\", -123  # => \"                -123\"\nsprintf \"%020.8d\", -123 # => \"0000000000000000-123\"\nsprintf \"%20.8o\", -123  # => \"                -173\"\nsprintf \"%20.8x\", -123  # => \"                 -7b\"\nsprintf \"%20.8b\", -11   # => \"               -1011\"\n```\n\nPrecision for `e` is number of digits after the decimal point:\n```\nsprintf \"%20.8e\", 1234.56789 # => \"      1.23456789e+03\"\n```\n\nPrecision for `f` is number of digits after the decimal point:\n```\nsprintf \"%20.8f\", 1234.56789 # => \"       1234.56789000\"\n```\n\nPrecision for `g` is number of significant digits:\n```\nsprintf \"%20.8g\", 1234.56789 # => \"           1234.5679\"\nsprintf \"%20.8g\", 123456789  # => \"       1.2345679e+08\"\nsprintf \"%-20.8g\", 123456789 # => \"1.2345679e+08       \"\n```\n\nPrecision for `s` is maximum number of characters:\n```\nsprintf \"%20.8s\", \"string test\" # => \"            string t\"\n```\n\nAdditional examples:\n```\nsprintf \"%d %04x\", 123, 123             # => \"123 007b\"\nsprintf \"%08b '%4s'\", 123, 123          # => \"01111011 ' 123'\"\nsprintf \"%+g:% g:%-g\", 1.23, 1.23, 1.23 # => \"+1.23: 1.23:1.23\"\n```","summary":"<p>Returns a formatted string.</p>","abstract":false,"args":[{"name":"format_string","external_name":"format_string","restriction":""},{"name":"args","external_name":"args","restriction":""}],"args_string":"(format_string, *args) : String","args_html":"(format_string, *args) : <a href=\"String.html\">String</a>","location":{"filename":"src/kernel.cr","line_number":370,"url":null},"def":{"name":"sprintf","args":[{"name":"format_string","external_name":"format_string","restriction":""},{"name":"args","external_name":"args","restriction":""}],"splat_index":1,"return_type":"String","visibility":"Public","body":"sprintf(format_string, args)"}},{"html_id":"system(command:String,args=nil):Bool-class-method","name":"system","doc":"Executes the given command in a subshell.\nStandard input, output and error are inherited.\nReturns `true` if the command gives zero exit code, `false` otherwise.\nThe special `$?` variable is set to a `Process::Status` associated with this execution.\n\nIf *command* contains no spaces and *args* is given, it will become\nits argument list.\n\nIf *command* contains spaces and *args* is given, *command* must include\n`\"${@}\"` (including the quotes) to receive the argument list.\n\nNo shell interpretation is done in *args*.\n\nExample:\n\n```\nsystem(\"echo *\")\n```\n\nProduces:\n\n```text\nLICENSE shard.yml Readme.md spec src\n```","summary":"<p>Executes the given command in a subshell.</p>","abstract":false,"args":[{"name":"command","external_name":"command","restriction":"String"},{"name":"args","default_value":"nil","external_name":"args","restriction":""}],"args_string":"(command : String, args = nil) : Bool","args_html":"(command : <a href=\"String.html\">String</a>, args = <span class=\"n\">nil</span>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/process.cr","line_number":417,"url":null},"def":{"name":"system","args":[{"name":"command","external_name":"command","restriction":"String"},{"name":"args","default_value":"nil","external_name":"args","restriction":""}],"return_type":"Bool","visibility":"Public","body":"status = Process.run(command, args, shell: true, input: Process::Redirect::Inherit, output: Process::Redirect::Inherit, error: Process::Redirect::Inherit)\n$? = status\nstatus.success?\n"}},{"html_id":"timeout_select_action(timeout:Time::Span):Channel::TimeoutAction-class-method","name":"timeout_select_action","doc":"Timeout keyword for use in `select`.\n\n```\nselect\nwhen x = ch.receive\n  puts \"got #{x}\"\nwhen timeout(1.seconds)\n  puts \"timeout\"\nend\n```\n\nNOTE: It won't trigger if the `select` has an `else` case (i.e.: a non-blocking select).","summary":"<p>Timeout keyword for use in <code>select</code>.</p>","abstract":false,"args":[{"name":"timeout","external_name":"timeout","restriction":"Time::Span"}],"args_string":"(timeout : Time::Span) : Channel::TimeoutAction","args_html":"(timeout : <a href=\"Time/Span.html\">Time::Span</a>) : Channel::TimeoutAction","location":{"filename":"src/channel.cr","line_number":736,"url":null},"def":{"name":"timeout_select_action","args":[{"name":"timeout","external_name":"timeout","restriction":"Time::Span"}],"return_type":"Channel::TimeoutAction","visibility":"Public","body":"Channel::TimeoutAction.new(timeout)"}},{"html_id":"typeof(*expression):Class-class-method","name":"typeof","doc":"Returns the type of an expression.\n\n```\ntypeof(1) # => Int32\n```\n\nIt accepts multiple arguments, and the result is the union of the expression types:\n\n```\ntypeof(1, \"a\", 'a') # => (Int32 | String | Char)\n```\n\nThe expressions passed as arguments to `typeof` do not evaluate. The compiler\nonly analyzes their return type.\nNOTE: This is a pseudo-method provided directly by the Crystal compiler.\nIt cannot be redefined nor overridden.","summary":"<p>Returns the type of an expression.</p>","abstract":false,"args":[{"name":"expression","external_name":"expression","restriction":""}],"args_string":"(*expression) : Class","args_html":"(*expression) : <a href=\"Class.html\">Class</a>","location":{"filename":"src/docs_pseudo_methods.cr","line_number":23,"url":null},"def":{"name":"__crystal_pseudo_typeof","args":[{"name":"expression","external_name":"expression","restriction":""}],"splat_index":0,"return_type":"Class","visibility":"Public","body":""}}],"macros":[{"html_id":"debugger-macro","name":"debugger","abstract":false,"location":{"filename":"src/intrinsics.cr","line_number":240,"url":null},"def":{"name":"debugger","visibility":"Public","body":"  Intrinsics.debugtrap\n"}},{"html_id":"p!(*exps)-macro","name":"p!","doc":"Prints a series of expressions together with their inspected values.\nUseful for print style debugging.\n\n```\na = 1\np! a # => \"a # => 1\"\n\np! [1, 2, 3].map(&.to_s) # => \"[1, 2, 3].map(&.to_s) # => [\"1\", \"2\", \"3\"]\"\n```\n\nSee also: `p`, `Object#inspect`.","summary":"<p>Prints a series of expressions together with their inspected values.</p>","abstract":false,"args":[{"name":"exps","external_name":"exps","restriction":""}],"args_string":"(*exps)","args_html":"(*exps)","location":{"filename":"src/macros.cr","line_number":166,"url":null},"def":{"name":"p!","args":[{"name":"exps","external_name":"exps","restriction":""}],"splat_index":0,"visibility":"Public","body":"  \n{% if exps.size == 0 %}\n    # Nothing\n  {% else %}{% if exps.size == 1 %}\n    {% exp = exps.first %}\n    %prefix = \"#{{{ exp.stringify }}} # => \"\n    ::print %prefix\n    ::p({{ exp }})\n  {% else %}\n    %names = { {{ *exps.map(&.stringify) }} }\n    %max_size = %names.max_of &.size\n    {\n      {% for exp, i in exps %}\n        begin\n          %prefix = \"#{%names[{{ i }}].ljust(%max_size)} # => \"\n          ::print %prefix\n          ::p({{ exp }})\n        end,\n      {% end %}\n    }\n  {% end %}{% end %}\n\n\n"}},{"html_id":"pp!(*exps)-macro","name":"pp!","doc":"Prints a series of expressions together with their pretty printed values.\nUseful for print style debugging.\n\n```\na = 1\npp! a # => \"a # => 1\"\n\npp! [1, 2, 3].map(&.to_s) # => \"[1, 2, 3].map(&.to_s) # => [\"1\", \"2\", \"3\"]\"\n```\n\nSee also: `pp`, `Object#pretty_inspect`.","summary":"<p>Prints a series of expressions together with their pretty printed values.</p>","abstract":false,"args":[{"name":"exps","external_name":"exps","restriction":""}],"args_string":"(*exps)","args_html":"(*exps)","location":{"filename":"src/macros.cr","line_number":132,"url":null},"def":{"name":"pp!","args":[{"name":"exps","external_name":"exps","restriction":""}],"splat_index":0,"visibility":"Public","body":"  \n{% if exps.size == 0 %}\n    # Nothing\n  {% else %}{% if exps.size == 1 %}\n    {% exp = exps.first %}\n    %prefix = \"#{{{ exp.stringify }}} # => \"\n    ::print %prefix\n    ::pp({{ exp }})\n  {% else %}\n    %names = { {{ *exps.map(&.stringify) }} }\n    %max_size = %names.max_of &.size\n    {\n      {% for exp, i in exps %}\n        begin\n          %prefix = \"#{%names[{{ i }}].ljust(%max_size)} # => \"\n          ::print %prefix\n          ::pp({{ exp }})\n        end,\n      {% end %}\n    }\n  {% end %}{% end %}\n\n\n"}},{"html_id":"record(name,*properties)-macro","name":"record","doc":"Defines a **`Struct`** with the given name and properties.\n\nThe generated struct has a constructor with the given properties\nin the same order as declared. The struct only provides getters,\nnot setters, making it immutable by default.\n\nThe properties can be type declarations or assignments.\n\nYou can pass a block to this macro, that will be inserted inside\nthe struct definition.\n\n```\nrecord Point, x : Int32, y : Int32\n\nPoint.new 1, 2 # => #<Point(@x=1, @y=2)>\n```\n\nAn example with the block version:\n\n```\nrecord Person, first_name : String, last_name : String do\n  def full_name\n    \"#{first_name} #{last_name}\"\n  end\nend\n\nperson = Person.new \"John\", \"Doe\"\nperson.full_name # => \"John Doe\"\n```\n\nAn example with type declarations and default values:\n\n```\nrecord Point, x : Int32 = 0, y : Int32 = 0\n\nPoint.new      # => #<Point(@x=0, @y=0)>\nPoint.new y: 2 # => #<Point(@x=0, @y=2)>\n```\n\nAn example with assignments (in this case the compiler must be able to\ninfer the types from the default values):\n\n```\nrecord Point, x = 0, y = 0\n\nPoint.new      # => #<Point(@x=0, @y=0)>\nPoint.new y: 2 # => #<Point(@x=0, @y=2)>\n```\n\nThis macro also provides a `copy_with` method which returns\na copy of the record with the provided properties altered.\n\n```\nrecord Point, x = 0, y = 0\n\np = Point.new y: 2 # => #<Point(@x=0, @y=2)>\np.copy_with x: 3   # => #<Point(@x=3, @y=2)>\np                  # => #<Point(@x=0, @y=2)>\n```","summary":"<p>Defines a <strong><code><a href=\"Struct.html\">Struct</a></code></strong> with the given name and properties.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"properties","external_name":"properties","restriction":""}],"args_string":"(name, *properties)","args_html":"(name, *properties)","location":{"filename":"src/macros.cr","line_number":60,"url":null},"def":{"name":"record","args":[{"name":"name","external_name":"name","restriction":""},{"name":"properties","external_name":"properties","restriction":""}],"splat_index":1,"visibility":"Public","body":"  struct \n{{ name.id }}\n\n    \n{% for property in properties %}\n      {% if property.is_a?(Assign) %}\n        getter {{ property.target.id }}\n      {% else %}{% if property.is_a?(TypeDeclaration) %}\n        getter {{ property }}\n      {% else %}\n        getter :{{ property.id }}\n      {% end %}{% end %}\n    {% end %}\n\n\n    def initialize(\n{{ *properties.map do |field|\n  \"@#{field.id}\".id\nend }}\n)\n    \nend\n\n    \n{{ yield }}\n\n\n    def copy_with(\n{{ *properties.map do |property|\n  if property.is_a?(Assign)\n    \"#{property.target.id} _#{property.target.id} = @#{property.target.id}\".id\n  else\n    if property.is_a?(TypeDeclaration)\n      \"#{property.var.id} _#{property.var.id} = @#{property.var.id}\".id\n    else\n      \"#{property.id} _#{property.id} = @#{property.id}\".id\n    end\n  end\nend }}\n)\n      self.class.new(\n{{ *properties.map do |property|\n  if property.is_a?(Assign)\n    \"_#{property.target.id}\".id\n  else\n    if property.is_a?(TypeDeclaration)\n      \"_#{property.var.id}\".id\n    else\n      \"_#{property.id}\".id\n    end\n  end\nend }}\n)\n    \nend\n\n    def clone\n      self.class.new(\n{{ *properties.map do |property|\n  if property.is_a?(Assign)\n    \"@#{property.target.id}.clone\".id\n  else\n    if property.is_a?(TypeDeclaration)\n      \"@#{property.var.id}.clone\".id\n    else\n      \"@#{property.id}.clone\".id\n    end\n  end\nend }}\n)\n    \nend\n  \nend\n\n"}},{"html_id":"spawn(call,*,name=nil,same_thread=false,&block)-macro","name":"spawn","doc":"Spawns a fiber by first creating a `Proc`, passing the *call*'s\nexpressions to it, and letting the `Proc` finally invoke the *call*.\n\nCompare this:\n\n```\ni = 0\nwhile i < 5\n  spawn { print(i) }\n  i += 1\nend\nFiber.yield\n# Output: 55555\n```\n\nTo this:\n\n```\ni = 0\nwhile i < 5\n  spawn print(i)\n  i += 1\nend\nFiber.yield\n# Output: 01234\n```\n\nThis is because in the first case all spawned fibers refer to\nthe same local variable, while in the second example copies of\n*i* are passed to a `Proc` that eventually invokes the call.","summary":"<p>Spawns a fiber by first creating a <code><a href=\"Proc.html\">Proc</a></code>, passing the <em>call</em>'s expressions to it, and letting the <code><a href=\"Proc.html\">Proc</a></code> finally invoke the <em>call</em>.</p>","abstract":false,"args":[{"name":"call","external_name":"call","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"name","default_value":"nil","external_name":"name","restriction":""},{"name":"same_thread","default_value":"false","external_name":"same_thread","restriction":""}],"args_string":"(call, *, name = nil, same_thread = false, &block)","args_html":"(call, *, name = <span class=\"n\">nil</span>, same_thread = <span class=\"n\">false</span>, &block)","location":{"filename":"src/concurrent.cr","line_number":99,"url":null},"def":{"name":"spawn","args":[{"name":"call","external_name":"call","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"name","default_value":"nil","external_name":"name","restriction":""},{"name":"same_thread","default_value":"false","external_name":"same_thread","restriction":""}],"splat_index":1,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"  \n{% if block %}\n    {% raise(\"`spawn(call)` can't be invoked with a block, did you mean `spawn(name: ...) { ... }`?\") %}\n  {% end %}\n\n\n  \n{% if call.is_a?(Call) %}\n    ->(\n      {% for arg, i in call.args %}\n        __arg{{ i }} : typeof({{ arg.is_a?(Splat) ? arg.exp : arg }}),\n      {% end %}\n      {% if call.named_args %}\n        {% for narg, i in call.named_args %}\n          __narg{{ i }} : typeof({{ narg.value }}),\n        {% end %}\n      {% end %}\n      ) {\n      spawn(name: {{ name }}, same_thread: {{ same_thread }}) do\n        {% if call.receiver %}{{ call.receiver }}.{% end %}{{ call.name }}(\n          {% for arg, i in call.args %}\n            {% if arg.is_a?(Splat) %}*{% end %}__arg{{ i }},\n          {% end %}\n          {% if call.named_args %}\n            {% for narg, i in call.named_args %}\n              {{ narg.name }}: __narg{{ i }},\n            {% end %}\n          {% end %}\n        )\n      end\n      }.call(\n        {% for arg in call.args %}\n          {{ arg.is_a?(Splat) ? arg.exp : arg }},\n        {% end %}\n        {% if call.named_args %}\n          {{ call.named_args.map(&.value).splat }}\n        {% end %}\n      )\n  {% else %}\n    spawn do\n      {{ call }}\n    end\n  {% end %}\n\n\n"}}],"types":[{"html_id":"Crystal/ArgumentError","path":"ArgumentError.html","kind":"class","full_name":"ArgumentError","name":"ArgumentError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/exception.cr","line_number":89,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"Raised when the arguments are wrong and there isn't a more specific `Exception` class.\n\n```\n[1, 2, 3].first(-4) # raises ArgumentError (attempt to take negative size)\n```","summary":"<p>Raised when the arguments are wrong and there isn't a more specific <code><a href=\"Exception.html\">Exception</a></code> class.</p>","constructors":[{"html_id":"new(message=\"Argumenterror\")-class-method","name":"new","abstract":false,"args":[{"name":"message","default_value":"\"Argument error\"","external_name":"message","restriction":""}],"args_string":"(message = \"Argument error\")","args_html":"(message = <span class=\"s\">&quot;Argument error&quot;</span>)","location":{"filename":"src/exception.cr","line_number":90,"url":null},"def":{"name":"new","args":[{"name":"message","default_value":"\"Argument error\"","external_name":"message","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]},{"html_id":"Crystal/Array","path":"Array.html","kind":"class","full_name":"Array(T)","name":"Array","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Indexable/Mutable","kind":"module","full_name":"Indexable::Mutable","name":"Mutable"},{"html_id":"Crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"},{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/array.cr","line_number":48,"url":null},{"filename":"src/json/any.cr","line_number":313,"url":null},{"filename":"src/json/to_json.cr","line_number":93,"url":null},{"filename":"src/yaml/any.cr","line_number":352,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":34,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Indexable/Mutable","kind":"module","full_name":"Indexable::Mutable","name":"Mutable"}],"doc":"An `Array` is an ordered, integer-indexed collection of objects of type T.\n\nArray indexing starts at 0. A negative index is assumed to be\nrelative to the end of the array: -1 indicates the last element,\n-2 is the next to last element, and so on.\n\nAn `Array` can be created using the usual `new` method (several are provided), or with an array literal:\n\n```\nArray(Int32).new  # => []\n[1, 2, 3]         # Array(Int32)\n[1, \"hello\", 'x'] # Array(Int32 | String | Char)\n```\n\nSee [`Array` literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/array.html) in the language reference.\n\nAn `Array` can have mixed types, meaning T will be a union of types, but these are determined\nwhen the array is created, either by specifying T or by using an array literal. In the latter\ncase, T will be set to the union of the array literal elements' types.\n\nWhen creating an empty array you must always specify T:\n\n```\n[] of Int32 # same as Array(Int32)\n[]          # syntax error\n```\n\nAn `Array` is implemented using an internal buffer of some capacity\nand is reallocated when elements are pushed to it when more capacity\nis needed. This is normally known as a [dynamic array](http://en.wikipedia.org/wiki/Dynamic_array).\n\nYou can use a special array literal syntax with other types too, as long as they define an argless\n`new` method and a `<<` method. `Set` is one such type:\n\n```\nset = Set{1, 2, 3} # => Set{1, 2, 3}\nset.class          # => Set(Int32)\n```\n\nThe above is the same as this:\n\n```\nset = Set(typeof(1, 2, 3)).new\nset << 1\nset << 2\nset << 3\n```","summary":"<p>An <code><a href=\"Array.html\">Array</a></code> is an ordered, integer-indexed collection of objects of type T.</p>","class_methods":[{"html_id":"each_product(arrays:Array(Array),reuse=false,&)-class-method","name":"each_product","doc":"Yields each ordered combination of the elements taken from each of the\n*arrays* as `Array`s.\nTraversal of elements starts from the last given array.","summary":"<p>Yields each ordered combination of the elements taken from each of the <em>arrays</em> as <code><a href=\"Array.html\">Array</a></code>s.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Indexable.html#each_cartesian%28%2Aothers%3AIndexable%2C%26%29-instance-method\">Indexable.each_cartesian(indexables : Indexable(Indexable)</a>, reuse = false, &block)</code> instead</p>","abstract":false,"args":[{"name":"arrays","external_name":"arrays","restriction":"Array(Array)"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(arrays : Array(Array), reuse = false, &)","args_html":"(arrays : <a href=\"Array.html\">Array</a>(<a href=\"Array.html\">Array</a>), reuse = <span class=\"n\">false</span>, &)","location":{"filename":"src/array.cr","line_number":1217,"url":null},"def":{"name":"each_product","args":[{"name":"arrays","external_name":"arrays","restriction":"Array(Array)"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"yields":1,"visibility":"Public","body":"Indexable.each_cartesian(arrays, reuse: reuse) do |r|\n  yield r\nend"}},{"html_id":"each_product(*arrays:Array,reuse=false,&)-class-method","name":"each_product","doc":"Yields each ordered combination of the elements taken from each of the\n*arrays* as `Array`s.\nTraversal of elements starts from the last given array.","summary":"<p>Yields each ordered combination of the elements taken from each of the <em>arrays</em> as <code><a href=\"Array.html\">Array</a></code>s.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Indexable.html#each_cartesian%28%2Aothers%3AIndexable%2C%26%29-instance-method\">Indexable.each_cartesian(indexables : Indexable(Indexable)</a>, reuse = false, &block)</code> instead</p>","abstract":false,"args":[{"name":"arrays","external_name":"arrays","restriction":"Array"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(*arrays : Array, reuse = false, &)","args_html":"(*arrays : <a href=\"Array.html\">Array</a>, reuse = <span class=\"n\">false</span>, &)","location":{"filename":"src/array.cr","line_number":1223,"url":null},"def":{"name":"each_product","args":[{"name":"arrays","external_name":"arrays","restriction":"Array"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"splat_index":0,"yields":1,"visibility":"Public","body":"Indexable.each_cartesian(arrays, reuse: reuse) do |r|\n  yield r\nend"}},{"html_id":"from_json(string_or_io,&):Nil-class-method","name":"from_json","doc":"Parses a `String` or `IO` denoting a JSON array, yielding\neach of its elements to the given block. This is useful\nfor decoding an array and processing its elements without\ncreating an Array in memory, which might be expensive.\n\n```\nrequire \"json\"\n\nArray(Int32).from_json(\"[1, 2, 3]\") do |element|\n  puts element\nend\n```\n\nOutput:\n\n```text\n1\n2\n3\n```\n\nTo parse and get an `Array`, use the block-less overload.","summary":"<p>Parses a <code><a href=\"String.html\">String</a></code> or <code><a href=\"IO.html\">IO</a></code> denoting a JSON array, yielding each of its elements to the given block.</p>","abstract":false,"args":[{"name":"string_or_io","external_name":"string_or_io","restriction":""}],"args_string":"(string_or_io, &) : Nil","args_html":"(string_or_io, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/from_json.cr","line_number":53,"url":null},"def":{"name":"from_json","args":[{"name":"string_or_io","external_name":"string_or_io","restriction":""}],"yields":1,"return_type":"Nil","visibility":"Public","body":"parser = JSON::PullParser.new(string_or_io)\nnew(parser) do |element|\n  yield element\nend\nnil\n"}},{"html_id":"from_yaml(string_or_io:String|IO,&)-class-method","name":"from_yaml","abstract":false,"args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"}],"args_string":"(string_or_io : String | IO, &)","args_html":"(string_or_io : <a href=\"String.html\">String</a> | <a href=\"IO.html\">IO</a>, &)","location":{"filename":"src/yaml/from_yaml.cr","line_number":15,"url":null},"def":{"name":"from_yaml","args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"}],"yields":1,"visibility":"Public","body":"new(YAML::ParseContext.new, parse_yaml(string_or_io)) do |element|\n  yield element\nend"}},{"html_id":"product(arrays:Array(Array))-class-method","name":"product","doc":"Returns an `Array` of all ordered combinations of elements taken from each\nof the *arrays* as `Array`s.\nTraversal of elements starts from the last given array.","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of all ordered combinations of elements taken from each of the <em>arrays</em> as <code><a href=\"Array.html\">Array</a></code>s.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Indexable.html#cartesian_product%28indexables%3AIndexable%28Indexable%29%29-class-method\">Indexable.cartesian_product(indexables : Indexable(Indexable)</a>)</code> instead</p>","abstract":false,"args":[{"name":"arrays","external_name":"arrays","restriction":"Array(Array)"}],"args_string":"(arrays : Array(Array))","args_html":"(arrays : <a href=\"Array.html\">Array</a>(<a href=\"Array.html\">Array</a>))","location":{"filename":"src/array.cr","line_number":1203,"url":null},"def":{"name":"product","args":[{"name":"arrays","external_name":"arrays","restriction":"Array(Array)"}],"visibility":"Public","body":"Indexable.cartesian_product(arrays)"}},{"html_id":"product(*arrays:Array)-class-method","name":"product","doc":"Returns an `Array` of all ordered combinations of elements taken from each\nof the *arrays* as `Array`s.\nTraversal of elements starts from the last given array.","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of all ordered combinations of elements taken from each of the <em>arrays</em> as <code><a href=\"Array.html\">Array</a></code>s.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Indexable.html#cartesian_product%28indexables%3AIndexable%28Indexable%29%29-class-method\">Indexable.cartesian_product(indexables : Indexable(Indexable)</a>)</code> instead</p>","abstract":false,"args":[{"name":"arrays","external_name":"arrays","restriction":"Array"}],"args_string":"(*arrays : Array)","args_html":"(*arrays : <a href=\"Array.html\">Array</a>)","location":{"filename":"src/array.cr","line_number":1209,"url":null},"def":{"name":"product","args":[{"name":"arrays","external_name":"arrays","restriction":"Array"}],"splat_index":0,"visibility":"Public","body":"Indexable.cartesian_product(arrays)"}}],"constructors":[{"html_id":"additive_identity:self-class-method","name":"additive_identity","doc":"Returns the additive identity of this type.\n\nThis is an empty array.","summary":"<p>Returns the additive identity of this type.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":347,"url":null},"def":{"name":"additive_identity","return_type":"self","visibility":"Public","body":"self.new"}},{"html_id":"build(capacity:Int,&:Pointer(T)->):self-class-method","name":"build","doc":"Creates a new `Array`, allocating an internal buffer with the given *capacity*,\nand yielding that buffer. The given block must return the desired size of the array.\n\nThis method is **unsafe**, but is usually used to initialize the buffer\nby passing it to a C function.\n\n```\nArray.build(3) do |buffer|\n  LibSome.fill_buffer_and_return_number_of_elements_filled(buffer)\nend\n```","summary":"<p>Creates a new <code><a href=\"Array.html\">Array</a></code>, allocating an internal buffer with the given <em>capacity</em>, and yielding that buffer.</p>","abstract":false,"args":[{"name":"capacity","external_name":"capacity","restriction":"Int"}],"args_string":"(capacity : Int, & : Pointer(T) -> ) : self","args_html":"(capacity : <a href=\"Int.html\">Int</a>, & : <a href=\"Pointer.html\">Pointer</a>(T) -> ) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":182,"url":null},"def":{"name":"build","args":[{"name":"capacity","external_name":"capacity","restriction":"Int"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Pointer(T) ->)"},"return_type":"self","visibility":"Public","body":"ary = Array(T).new(capacity)\nary.size = (yield ary.to_unsafe).to_i\nary\n"}},{"html_id":"new(size:Int,value:T)-class-method","name":"new","doc":"Creates a new `Array` of the given *size* filled with the same *value* in each position.\n\n```\nArray.new(3, 'a') # => ['a', 'a', 'a']\n\nary = Array.new(3, [1])\nary # => [[1], [1], [1]]\nary[0][0] = 2\nary # => [[2], [2], [2]]\n```","summary":"<p>Creates a new <code><a href=\"Array.html\">Array</a></code> of the given <em>size</em> filled with the same <em>value</em> in each position.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(size : Int, value : T)","args_html":"(size : <a href=\"Int.html\">Int</a>, value : T)","location":{"filename":"src/array.cr","line_number":136,"url":null},"def":{"name":"new","args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"_ = Array(T).allocate\n_.initialize(size, value)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":91,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"ctx.read_alias(node, self) do |obj|\n  return obj\nend\nary = new\nctx.record_anchor(node, ary)\nnew(ctx, node) do |element|\n  ary << element\nend\nary\n"}},{"html_id":"new(initial_capacity:Int)-class-method","name":"new","doc":"Creates a new empty `Array` backed by a buffer that is initially\n`initial_capacity` big.\n\nThe *initial_capacity* is useful to avoid unnecessary reallocations\nof the internal buffer in case of growth. If you have an estimate\nof the maximum number of elements an array will hold, the array should\nbe initialized with that capacity for improved performance.\n\n```\nary = Array(Int32).new(5)\nary.size # => 0\n```","summary":"<p>Creates a new empty <code><a href=\"Array.html\">Array</a></code> backed by a buffer that is initially <code>initial_capacity</code> big.</p>","abstract":false,"args":[{"name":"initial_capacity","external_name":"initial_capacity","restriction":"Int"}],"args_string":"(initial_capacity : Int)","args_html":"(initial_capacity : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/array.cr","line_number":112,"url":null},"def":{"name":"new","args":[{"name":"initial_capacity","external_name":"initial_capacity","restriction":"Int"}],"visibility":"Public","body":"_ = Array(T).allocate\n_.initialize(initial_capacity)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":148,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"ary = new\nnew(pull) do |element|\n  ary << element\nend\nary\n"}},{"html_id":"new-class-method","name":"new","doc":"Creates a new empty `Array`.","summary":"<p>Creates a new empty <code><a href=\"Array.html\">Array</a></code>.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":94,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = Array(T).allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node,&)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node, &)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>, &)","location":{"filename":"src/yaml/from_yaml.cr","line_number":106,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"yields":1,"visibility":"Public","body":"if node.is_a?(YAML::Nodes::Sequence)\nelse\n  node.raise(\"Expected sequence, not #{node.kind}\")\nend\nnode.each do |value|\n  yield T.new(ctx, value)\nend\n"}},{"html_id":"new(size:Int,&:Int32->T)-class-method","name":"new","doc":"Creates a new `Array` of the given *size* and invokes the given block once\nfor each index of `self`, assigning the block's value in that index.\n\n```\nArray.new(3) { |i| (i + 1) ** 2 } # => [1, 4, 9]\n\nary = Array.new(3) { [1] }\nary # => [[1], [1], [1]]\nary[0][0] = 2\nary # => [[2], [1], [1]]\n```","summary":"<p>Creates a new <code><a href=\"Array.html\">Array</a></code> of the given <em>size</em> and invokes the given block once for each index of <code>self</code>, assigning the block's value in that index.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int"}],"args_string":"(size : Int, & : Int32 -> T)","args_html":"(size : <a href=\"Int.html\">Int</a>, & : <a href=\"Int32.html\">Int32</a> -> T)","location":{"filename":"src/array.cr","line_number":162,"url":null},"def":{"name":"new","args":[{"name":"size","external_name":"size","restriction":"Int"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Int32 -> T)"},"visibility":"Public","body":"Array(T).build(size) do |buffer|\n  size.to_i.times do |i|\n    buffer[i] = yield i\n  end\n  size\nend"}},{"html_id":"new(pull:JSON::PullParser,&)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser, &)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>, &)","location":{"filename":"src/json/from_json.cr","line_number":156,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"yields":1,"visibility":"Public","body":"pull.read_array do\n  yield T.new(pull)\nend"}}],"instance_methods":[{"html_id":"&(other:Array(U))forallU-instance-method","name":"&","doc":"Set intersection: returns a new `Array` containing elements common to `self`\nand *other*, excluding any duplicates. The order is preserved from `self`.\n\n```\n[1, 1, 3, 5] & [1, 2, 3]               # => [ 1, 3 ]\n['a', 'b', 'b', 'z'] & ['a', 'b', 'c'] # => [ 'a', 'b' ]\n```\n\nSee also: `#uniq`.","summary":"<p>Set intersection: returns a new <code><a href=\"Array.html\">Array</a></code> containing elements common to <code>self</code> and <em>other</em>, excluding any duplicates.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Array(U)"}],"args_string":"(other : Array(U)) forall U","args_html":"(other : <a href=\"Array.html\">Array</a>(U)) forall U","location":{"filename":"src/array.cr","line_number":255,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Array(U)"}],"visibility":"Public","body":"if self.empty? || other.empty?\n  return Array(T).new\nend\nif (self.size + other.size) <= (SMALL_ARRAY_SIZE * 2)\n  ary = Array(T).new\n  each do |elem|\n    if (!(ary.includes?(elem))) && (other.includes?(elem))\n      ary << elem\n    end\n  end\n  return ary\nend\nhash = other.to_lookup_hash\nhash_size = hash.size\nArray(T).build(Math.min(size, other.size)) do |buffer|\n  i = 0\n  each do |obj|\n    hash.delete(obj)\n    new_hash_size = hash.size\n    if hash_size != new_hash_size\n      hash_size = new_hash_size\n      buffer[i] = obj\n      i = i + 1\n    end\n  end\n  i\nend\n"}},{"html_id":"*(times:Int)-instance-method","name":"*","doc":"Repetition: Returns a new `Array` built by concatenating *times* copies of `self`.\n\n```\n[\"a\", \"b\", \"c\"] * 2 # => [ \"a\", \"b\", \"c\", \"a\", \"b\", \"c\" ]\n```","summary":"<p>Repetition: Returns a new <code><a href=\"Array.html\">Array</a></code> built by concatenating <em>times</em> copies of <code>self</code>.</p>","abstract":false,"args":[{"name":"times","external_name":"times","restriction":"Int"}],"args_string":"(times : Int)","args_html":"(times : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/array.cr","line_number":381,"url":null},"def":{"name":"*","args":[{"name":"times","external_name":"times","restriction":"Int"}],"visibility":"Public","body":"if (times == 0) || empty?\n  return Array(T).new\nend\nif times == 1\n  return dup\nend\nif size == 1\n  return Array(T).new(times, first)\nend\nnew_size = size * times\nArray(T).build(new_size) do |buffer|\n  buffer.copy_from(to_unsafe, size)\n  n = size\n  while n <= (new_size // 2)\n    (buffer + n).copy_from(buffer, n)\n    n = n * 2\n  end\n  (buffer + n).copy_from(buffer, new_size - n)\n  new_size\nend\n"}},{"html_id":"+(other:Array(U))forallU-instance-method","name":"+","doc":"Concatenation. Returns a new `Array` built by concatenating `self` and *other*.\nThe type of the new array is the union of the types of both the original arrays.\n\n```\n[1, 2] + [\"a\"]  # => [1,2,\"a\"] of (Int32 | String)\n[1, 2] + [2, 3] # => [1,2,2,3]\n```","summary":"<p>Concatenation.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Array(U)"}],"args_string":"(other : Array(U)) forall U","args_html":"(other : <a href=\"Array.html\">Array</a>(U)) forall U","location":{"filename":"src/array.cr","line_number":335,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Array(U)"}],"visibility":"Public","body":"new_size = size + other.size\nArray(T | U).build(new_size) do |buffer|\n  buffer.copy_from(@buffer, size)\n  (buffer + size).copy_from(other.to_unsafe, other.size)\n  new_size\nend\n"}},{"html_id":"-(other:Array(U))forallU-instance-method","name":"-","doc":"Difference. Returns a new `Array` that is a copy of `self`, removing any items\nthat appear in *other*. The order of `self` is preserved.\n\n```\n[1, 2, 3] - [2, 1] # => [3]\n```","summary":"<p>Difference.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Array(U)"}],"args_string":"(other : Array(U)) forall U","args_html":"(other : <a href=\"Array.html\">Array</a>(U)) forall U","location":{"filename":"src/array.cr","line_number":357,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Array(U)"}],"visibility":"Public","body":"if size <= SMALL_ARRAY_SIZE || other.size <= SMALL_ARRAY_SIZE\n  ary = Array(T).new\n  each do |elem|\n    if other.includes?(elem)\n    else\n      ary << elem\n    end\n  end\n  return ary\nend\nary = Array(T).new(Math.max(size - other.size, 0))\nhash = other.to_lookup_hash\neach do |obj|\n  if hash.has_key?(obj)\n  else\n    ary << obj\n  end\nend\nary\n"}},{"html_id":"<<(value:T)-instance-method","name":"<<","doc":"Append. Alias for `push`.\n\n```\na = [1, 2]\na << 3 # => [1,2,3]\n```","summary":"<p>Append.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T)","args_html":"(value : T)","location":{"filename":"src/array.cr","line_number":415,"url":null},"def":{"name":"<<","args":[{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"push(value)"}},{"html_id":"<=>(other:Array)-instance-method","name":"<=>","doc":"Combined comparison operator.\n\nReturns `-1`, `0` or `1` depending on whether `self` is less than *other*, equals *other*\nor is greater than *other*.\n\nIt compares the elements of both arrays in the same position using the\n`<=>` operator. As soon as one of such comparisons returns a non-zero\nvalue, that result is the return value of the comparison.\n\nIf all elements are equal, the comparison is based on the size of the arrays.\n\n```\n[8] <=> [1, 2, 3] # => 1\n[2] <=> [4, 2, 3] # => -1\n[1, 2] <=> [1, 2] # => 0\n```","summary":"<p>Combined comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Array"}],"args_string":"(other : Array)","args_html":"(other : <a href=\"Array.html\">Array</a>)","location":{"filename":"src/array.cr","line_number":237,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Array"}],"visibility":"Public","body":"min_size = Math.min(size, other.size)\n0.upto(min_size - 1) do |i|\n  n = @buffer[i] <=> other.to_unsafe[i]\n  if n != 0\n    return n\n  end\nend\nsize <=> other.size\n"}},{"html_id":"==(other:Array)-instance-method","name":"==","doc":"Equality. Returns `true` if each element in `self` is equal to each\ncorresponding element in *other*.\n\n```\nary = [1, 2, 3]\nary == [1, 2, 3] # => true\nary == [2, 3]    # => false\n```","summary":"<p>Equality.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Array"}],"args_string":"(other : Array)","args_html":"(other : <a href=\"Array.html\">Array</a>)","location":{"filename":"src/array.cr","line_number":213,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Array"}],"visibility":"Public","body":"equals?(other) do |x, y|\n  x == y\nend"}},{"html_id":"==(other:JSON::Any)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"JSON::Any"}],"args_string":"(other : JSON::Any)","args_html":"(other : <a href=\"JSON/Any.html\">JSON::Any</a>)","location":{"filename":"src/json/any.cr","line_number":314,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"JSON::Any"}],"visibility":"Public","body":"self == other.raw"}},{"html_id":"==(other:YAML::Any)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"YAML::Any"}],"args_string":"(other : YAML::Any)","args_html":"(other : <a href=\"YAML/Any.html\">YAML::Any</a>)","location":{"filename":"src/yaml/any.cr","line_number":353,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"YAML::Any"}],"visibility":"Public","body":"self == other.raw"}},{"html_id":"==(other)-instance-method","name":"==","doc":"Returns `false` (other can only be a `Value` here).","summary":"<p>Returns <code>false</code> (other can only be a <code><a href=\"Value.html\">Value</a></code> here).</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/array.cr","line_number":217,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"false"}},{"html_id":"[](start:Int,count:Int):Array(T)-instance-method","name":"[]","doc":"Returns count or less (if there aren't enough) elements starting at the\ngiven start index.\n\nNegative *start* is added to `self.size`, thus it's treated as\nindex counting from the end of the array, `-1` designating the last element.\n\nRaises `IndexError` if *start* index is out of bounds.\nRaises `ArgumentError` if *count* is negative.\n\n```\na = [\"a\", \"b\", \"c\", \"d\", \"e\"]\na[-3, 3] # => [\"c\", \"d\", \"e\"]\na[1, 2]  # => [\"b\", \"c\"]\na[5, 1]  # => []\na[6, 1]  # raises IndexError\n```","summary":"<p>Returns count or less (if there aren't enough) elements starting at the given start index.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int) : Array(T)","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <a href=\"Array.html\">Array</a>(T)","location":{"filename":"src/array.cr","line_number":654,"url":null},"def":{"name":"[]","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"Array(T)","visibility":"Public","body":"self[start, count]? || (raise(IndexError.new))"}},{"html_id":"[](range:Range):Array(T)-instance-method","name":"[]","doc":"Returns all elements that are within the given range.\n\nThe first element in the returned array is `self[range.begin]` followed\nby the next elements up to index `range.end` (or `self[range.end - 1]` if\nthe range is exclusive).\nIf there are fewer elements in `self`, the returned array is shorter than\n`range.size`.\n\n```\na = [\"a\", \"b\", \"c\", \"d\", \"e\"]\na[1..3] # => [\"b\", \"c\", \"d\"]\n# range.end > array.size\na[3..7] # => [\"d\", \"e\"]\n```\n\nOpen ended ranges are clamped at the start and end of the array, respectively.\n\n```\n# open ended ranges\na[2..] # => [\"c\", \"d\", \"e\"]\na[..2] # => [\"a\", \"b\", \"c\"]\n```\n\nNegative range values are added to `self.size`, thus they are treated as\nindices counting from the end of the array, `-1` designating the last element.\n\n```\n# negative indices, both ranges are equivalent for `a`\na[1..3]   # => [\"b\", \"c\", \"d\"]\na[-4..-2] # => [\"b\", \"c\", \"d\"]\n# Mixing negative and positive indices, both ranges are equivalent for `a`\na[1..-2] # => [\"b\", \"c\", \"d\"]\na[-4..3] # => [\"b\", \"c\", \"d\"]\n```\n\nRaises `IndexError` if the start index is out of range (`range.begin >\nself.size || range.begin < -self.size`). If `range.begin == self.size` an\nempty array is returned. If `range.begin > range.end`, an empty array is\nreturned.\n\n```\n# range.begin > array.size\na[6..10] # raise IndexError\n# range.begin == array.size\na[5..10] # => []\n# range.begin > range.end\na[3..1]   # => []\na[-2..-4] # => []\na[-2..1]  # => []\na[3..-4]  # => []\n```","summary":"<p>Returns all elements that are within the given range.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range) : Array(T)","args_html":"(range : <a href=\"Range.html\">Range</a>) : <a href=\"Array.html\">Array</a>(T)","location":{"filename":"src/array.cr","line_number":623,"url":null},"def":{"name":"[]","args":[{"name":"range","external_name":"range","restriction":"Range"}],"return_type":"Array(T)","visibility":"Public","body":"self[*(Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new))]"}},{"html_id":"[]=(start:Int,count:Int,values:Array(T))-instance-method","name":"[]=","doc":"Replaces a subrange with the elements of the given array.\n\n```\na = [1, 2, 3, 4, 5]\na[1, 3] = [6, 7, 8]\na # => [1, 6, 7, 8, 5]\n\na = [1, 2, 3, 4, 5]\na[1, 3] = [6, 7]\na # => [1, 6, 7, 5]\n\na = [1, 2, 3, 4, 5]\na[1, 3] = [6, 7, 8, 9, 10]\na # => [1, 6, 7, 8, 9, 10, 5]\n```","summary":"<p>Replaces a subrange with the elements of the given array.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"},{"name":"values","external_name":"values","restriction":"Array(T)"}],"args_string":"(start : Int, count : Int, values : Array(T))","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>, values : <a href=\"Array.html\">Array</a>(T))","location":{"filename":"src/array.cr","line_number":518,"url":null},"def":{"name":"[]=","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"},{"name":"values","external_name":"values","restriction":"Array(T)"}],"visibility":"Public","body":"start, count = normalize_start_and_count(start, count)\ndiff = values.size - count\nif diff == 0\n  (@buffer + start).copy_from(values.to_unsafe, values.size)\nelse\n  if diff < 0\n    diff = -diff\n    (@buffer + start).copy_from(values.to_unsafe, values.size)\n    ((@buffer + start) + values.size).move_from((@buffer + start) + count, (size - start) - count)\n    ((@buffer + @size) - diff).clear(diff)\n    @size = @size - diff\n  else\n    resize_to_capacity(Math.pw2ceil(@size + diff))\n    ((@buffer + start) + values.size).move_from((@buffer + start) + count, (size - start) - count)\n    (@buffer + start).copy_from(values.to_unsafe, values.size)\n    @size = @size + diff\n  end\nend\nvalues\n"}},{"html_id":"[]=(start:Int,count:Int,value:T)-instance-method","name":"[]=","doc":"Replaces a subrange with a single value. All elements in the range\n`start...start+count` are removed and replaced by a single element\n*value*.\n\nIf *count* is zero, *value* is inserted at *start*.\n\nNegative values of *start* count from the end of the array.\n\n```\na = [1, 2, 3, 4, 5]\na[1, 3] = 6\na # => [1, 6, 5]\n\na = [1, 2, 3, 4, 5]\na[1, 0] = 6\na # => [1, 6, 2, 3, 4, 5]\n```","summary":"<p>Replaces a subrange with a single value.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(start : Int, count : Int, value : T)","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>, value : T)","location":{"filename":"src/array.cr","line_number":436,"url":null},"def":{"name":"[]=","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"start, count = normalize_start_and_count(start, count)\ncase count\nwhen 0\n  insert(start, value)\nwhen 1\n  @buffer[start] = value\nelse\n  diff = count - 1\n  if start == 0\n    @buffer.clear(diff)\n    shift_buffer_by(diff)\n    @buffer.value = value\n  else\n    ((@buffer + start) + 1).move_from((@buffer + start) + count, (size - start) - count)\n    ((@buffer + @size) - diff).clear(diff)\n    @buffer[start] = value\n  end\n  @size = @size - diff\nend\nvalue\n"}},{"html_id":"[]=(range:Range,values:Array(T))-instance-method","name":"[]=","doc":"Replaces a subrange with the elements of the given array.\n\n```\na = [1, 2, 3, 4, 5]\na[1..3] = [6, 7, 8]\na # => [1, 6, 7, 8, 5]\n\na = [1, 2, 3, 4, 5]\na[1..3] = [6, 7]\na # => [1, 6, 7, 5]\n\na = [1, 2, 3, 4, 5]\na[1..3] = [6, 7, 8, 9, 10]\na # => [1, 6, 7, 8, 9, 10, 5]\n\na = [1, 2, 3, 4, 5]\na[2..] = [6, 7, 8, 9, 10]\na # => [1, 2, 6, 7, 8, 9, 10]\n```","summary":"<p>Replaces a subrange with the elements of the given array.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"},{"name":"values","external_name":"values","restriction":"Array(T)"}],"args_string":"(range : Range, values : Array(T))","args_html":"(range : <a href=\"Range.html\">Range</a>, values : <a href=\"Array.html\">Array</a>(T))","location":{"filename":"src/array.cr","line_number":568,"url":null},"def":{"name":"[]=","args":[{"name":"range","external_name":"range","restriction":"Range"},{"name":"values","external_name":"values","restriction":"Array(T)"}],"visibility":"Public","body":"self[*(Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new))] = values"}},{"html_id":"[]=(range:Range,value:T)-instance-method","name":"[]=","doc":"Replaces a subrange with a single value.\n\n```\na = [1, 2, 3, 4, 5]\na[1..3] = 6\na # => [1, 6, 5]\n\na = [1, 2, 3, 4, 5]\na[1...1] = 6\na # => [1, 6, 2, 3, 4, 5]\n\na = [1, 2, 3, 4, 5]\na[2...] = 6\na # => [1, 2, 6]\n```","summary":"<p>Replaces a subrange with a single value.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"},{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(range : Range, value : T)","args_html":"(range : <a href=\"Range.html\">Range</a>, value : T)","location":{"filename":"src/array.cr","line_number":499,"url":null},"def":{"name":"[]=","args":[{"name":"range","external_name":"range","restriction":"Range"},{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"self[*(Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new))] = value"}},{"html_id":"[]=(values:Array(T),*,indexstart:Int,count:Int)-instance-method","name":"[]=","doc":"Replaces a subrange with the elements of the given array.\n\n```\na = [1, 2, 3, 4, 5]\na[1, 3] = [6, 7, 8]\na # => [1, 6, 7, 8, 5]\n\na = [1, 2, 3, 4, 5]\na[1, 3] = [6, 7]\na # => [1, 6, 7, 5]\n\na = [1, 2, 3, 4, 5]\na[1, 3] = [6, 7, 8, 9, 10]\na # => [1, 6, 7, 8, 9, 10, 5]\n```","summary":"<p>Replaces a subrange with the elements of the given array.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Array.html#%5B%5D%3D%28start%3AInt%2Ccount%3AInt%2Cvalues%3AArray%28T%29%29-instance-method\">#[]=(start, count, values)</a></code> instead</p>","abstract":false,"args":[{"name":"values","external_name":"values","restriction":"Array(T)"},{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"index","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(values : Array(T), *, index start : Int, count : Int)","args_html":"(values : <a href=\"Array.html\">Array</a>(T), *, index start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/array.cr","line_number":545,"url":null},"def":{"name":"[]=","args":[{"name":"values","external_name":"values","restriction":"Array(T)"},{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"index","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"splat_index":1,"visibility":"Public","body":"self[start, count] = values"}},{"html_id":"[]=(value:T,*,indexstart:Int,count:Int)-instance-method","name":"[]=","doc":"Replaces a subrange with a single value. All elements in the range\n`start...start+count` are removed and replaced by a single element\n*value*.\n\nIf *count* is zero, *value* is inserted at *start*.\n\nNegative values of *start* count from the end of the array.\n\n```\na = [1, 2, 3, 4, 5]\na[1, 3] = 6\na # => [1, 6, 5]\n\na = [1, 2, 3, 4, 5]\na[1, 0] = 6\na # => [1, 6, 2, 3, 4, 5]\n```","summary":"<p>Replaces a subrange with a single value.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Array.html#%5B%5D%3D%28start%3AInt%2Ccount%3AInt%2Cvalues%3AArray%28T%29%29-instance-method\">#[]=(start, count, value)</a></code> instead</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"index","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(value : T, *, index start : Int, count : Int)","args_html":"(value : T, *, index start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/array.cr","line_number":480,"url":null},"def":{"name":"[]=","args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"index","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"splat_index":1,"visibility":"Public","body":"self[start, count] = value"}},{"html_id":"[]?(start:Int,count:Int):Array(T)?-instance-method","name":"[]?","doc":"Like `#[](Int, Int)` but returns `nil` if the *start* index is out of range.","summary":"<p>Like <code><a href=\"Array.html#%5B%5D%28start%3AInt%2Ccount%3AInt%29%3AArray%28T%29-instance-method\">#[](Int, Int)</a></code> but returns <code>nil</code> if the <em>start</em> index is out of range.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int) : Array(T)?","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <a href=\"Array.html\">Array</a>(T)?","location":{"filename":"src/array.cr","line_number":659,"url":null},"def":{"name":"[]?","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"Array(T) | ::Nil","visibility":"Public","body":"start, count = normalize_start_and_count(start, count) do\n  return nil\nend\nif count == 0\n  return Array(T).new\nend\nArray(T).build(count) do |buffer|\n  buffer.copy_from(@buffer + start, count)\n  count\nend\n"}},{"html_id":"[]?(range:Range):Array(T)?-instance-method","name":"[]?","doc":"Like `#[](Range)`, but returns `nil` if `range.begin` is out of range.\n\n```\na = [\"a\", \"b\", \"c\", \"d\", \"e\"]\na[6..10]? # => nil\na[6..]?   # => nil\n```","summary":"<p>Like <code><a href=\"Array.html#%5B%5D%28range%3ARange%29%3AArray%28T%29-instance-method\">#[](Range)</a></code>, but returns <code>nil</code> if <code>range.begin</code> is out of range.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range) : Array(T)?","args_html":"(range : <a href=\"Range.html\">Range</a>) : <a href=\"Array.html\">Array</a>(T)?","location":{"filename":"src/array.cr","line_number":634,"url":null},"def":{"name":"[]?","args":[{"name":"range","external_name":"range","restriction":"Range"}],"return_type":"Array(T) | ::Nil","visibility":"Public","body":"self[*(Indexable.range_to_index_and_count(range, size)) || (return nil)]?"}},{"html_id":"clear:self-instance-method","name":"clear","doc":"Removes all elements from self.\n\n```\na = [\"a\", \"b\", \"c\", \"d\", \"e\"]\na.clear # => []\n```","summary":"<p>Removes all elements from self.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":685,"url":null},"def":{"name":"clear","return_type":"self","visibility":"Public","body":"@buffer.clear(@size)\n@size = 0\nself\n"}},{"html_id":"clone-instance-method","name":"clone","doc":"Returns a new `Array` that has `self`'s elements cloned.\nThat is, it returns a deep copy of `self`.\n\nUse `#dup` if you want a shallow copy.\n\n```\nary = [[1, 2], [3, 4]]\nary2 = ary.clone\nary[0][0] = 5\nary  # => [[5, 2], [3, 4]]\nary2 # => [[1, 2], [3, 4]]\n\nary2 << [7, 8]\nary  # => [[5, 2], [3, 4]]\nary2 # => [[1, 2], [3, 4], [7, 8]]\n```","summary":"<p>Returns a new <code><a href=\"Array.html\">Array</a></code> that has <code>self</code>'s elements cloned.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":707,"url":null},"def":{"name":"clone","visibility":"Public","body":"{% if ((((T == ::Bool) || (T == ::Char)) || (T == ::String)) || (T == ::Symbol)) || T < ::Number::Primitive %}\n      Array(T).new(size) { |i| @buffer[i].clone.as(T) }\n    {% else %}\n      exec_recursive_clone do |hash|\n        clone = Array(T).new(size)\n        hash[object_id] = clone.object_id\n        each do |element|\n          clone << element.clone.as(T)\n        end\n        clone\n      end\n    {% end %}"}},{"html_id":"compact-instance-method","name":"compact","doc":"Returns a copy of `self` with all `nil` elements removed.\n\n```\n[\"a\", nil, \"b\", nil, \"c\", nil].compact # => [\"a\", \"b\", \"c\"]\n```","summary":"<p>Returns a copy of <code>self</code> with all <code>nil</code> elements removed.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":727,"url":null},"def":{"name":"compact","visibility":"Public","body":"compact_map(&.itself)"}},{"html_id":"compact!:self-instance-method","name":"compact!","doc":"Removes all `nil` elements from `self` and returns `self`.\n\n```\nary = [\"a\", nil, \"b\", nil, \"c\"]\nary.compact!\nary # => [\"a\", \"b\", \"c\"]\n```","summary":"<p>Removes all <code>nil</code> elements from <code>self</code> and returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":738,"url":null},"def":{"name":"compact!","return_type":"self","visibility":"Public","body":"reject! do |__arg1|\n  __arg1.nil?\nend"}},{"html_id":"concat(other:Array)-instance-method","name":"concat","doc":"Appends the elements of *other* to `self`, and returns `self`.\n\n```\nary = [\"a\", \"b\"]\nary.concat([\"c\", \"d\"])\nary # => [\"a\", \"b\", \"c\", \"d\"]\n```","summary":"<p>Appends the elements of <em>other</em> to <code>self</code>, and returns <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Array"}],"args_string":"(other : Array)","args_html":"(other : <a href=\"Array.html\">Array</a>)","location":{"filename":"src/array.cr","line_number":749,"url":null},"def":{"name":"concat","args":[{"name":"other","external_name":"other","restriction":"Array"}],"visibility":"Public","body":"other_size = other.size\nresize_if_cant_insert(other_size)\n(@buffer + @size).copy_from(other.to_unsafe, other_size)\n@size = @size + other_size\nself\n"}},{"html_id":"concat(other:Enumerable)-instance-method","name":"concat","doc":"Appends the elements of *other* to `self`, and returns `self`.\n\n```\nary = [\"a\", \"b\"]\nary.concat([\"c\", \"d\"])\nary # => [\"a\", \"b\", \"c\", \"d\"]\n```","summary":"<p>Appends the elements of <em>other</em> to <code>self</code>, and returns <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Enumerable"}],"args_string":"(other : Enumerable)","args_html":"(other : <a href=\"Enumerable.html\">Enumerable</a>)","location":{"filename":"src/array.cr","line_number":762,"url":null},"def":{"name":"concat","args":[{"name":"other","external_name":"other","restriction":"Enumerable"}],"visibility":"Public","body":"left_before_resize = remaining_capacity - @size\nlen = @size\nbuf = @buffer + len\nother.each do |elem|\n  if left_before_resize == 0\n    increase_capacity\n    left_before_resize = remaining_capacity - len\n    buf = @buffer + len\n  end\n  buf.value = elem\n  buf = buf + 1\n  len = len + 1\n  left_before_resize = left_before_resize - 1\nend\n@size = len\nself\n"}},{"html_id":"delete(obj):T?-instance-method","name":"delete","doc":"Removes all items from `self` that are equal to *obj*.\n\nReturns the last found element that was equal to *obj*,\nif any, or `nil` if not found.\n\n```\na = [\"a\", \"b\", \"b\", \"b\", \"c\"]\na.delete(\"b\") # => \"b\"\na             # => [\"a\", \"c\"]\n\na.delete(\"x\") # => nil\na             # => [\"a\", \"c\"]\n```","summary":"<p>Removes all items from <code>self</code> that are equal to <em>obj</em>.</p>","abstract":false,"args":[{"name":"obj","external_name":"obj","restriction":""}],"args_string":"(obj) : T?","args_html":"(obj) : T?","location":{"filename":"src/array.cr","line_number":796,"url":null},"def":{"name":"delete","args":[{"name":"obj","external_name":"obj","restriction":""}],"return_type":"T | ::Nil","visibility":"Public","body":"internal_delete do |e|\n  e == obj\nend[1]"}},{"html_id":"delete_at(start:Int,count:Int):self-instance-method","name":"delete_at","doc":"Removes *count* elements from `self` starting at *start*.\nIf the size of `self` is less than *count*, removes values to the end of the array without error.\nReturns an array of the removed elements with the original order of `self` preserved.\nRaises `IndexError` if *start* is out of range.\n\n```\na = [\"ant\", \"bat\", \"cat\", \"dog\"]\na.delete_at(1, 2)  # => [\"bat\", \"cat\"]\na                  # => [\"ant\", \"dog\"]\na.delete_at(99, 1) # raises IndexError\n```","summary":"<p>Removes <em>count</em> elements from <code>self</code> starting at <em>start</em>.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int) : self","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":849,"url":null},"def":{"name":"delete_at","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"start, count = normalize_start_and_count(start, count)\nval = self[start, count]\n(@buffer + start).move_from((@buffer + start) + count, (size - start) - count)\n@size = @size - count\n(@buffer + @size).clear(count)\nval\n"}},{"html_id":"delete_at(index:Int)-instance-method","name":"delete_at","doc":"Removes the element at *index*, returning that element.\nRaises `IndexError` if *index* is out of range.\n\n```\na = [\"ant\", \"bat\", \"cat\", \"dog\"]\na.delete_at(2)  # => \"cat\"\na               # => [\"ant\", \"bat\", \"dog\"]\na.delete_at(99) # raises IndexError\n```","summary":"<p>Removes the element at <em>index</em>, returning that element.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","args_html":"(index : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/array.cr","line_number":809,"url":null},"def":{"name":"delete_at","args":[{"name":"index","external_name":"index","restriction":"Int"}],"visibility":"Public","body":"index = check_index_out_of_bounds(index)\nif index == 0\n  return shift_when_not_empty\nend\nelem = @buffer[index]\n(@buffer + index).move_from((@buffer + index) + 1, (size - index) - 1)\n@size = @size - 1\n(@buffer + @size).clear\nelem\n"}},{"html_id":"delete_at(range:Range):self-instance-method","name":"delete_at","doc":"Removes all elements within the given *range*.\nReturns an array of the removed elements with the original order of `self` preserved.\nRaises `IndexError` if the index is out of range.\n\n```\na = [\"ant\", \"bat\", \"cat\", \"dog\"]\na.delete_at(1..2)    # => [\"bat\", \"cat\"]\na                    # => [\"ant\", \"dog\"]\na.delete_at(99..100) # raises IndexError\n```","summary":"<p>Removes all elements within the given <em>range</em>.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range) : self","args_html":"(range : <a href=\"Range.html\">Range</a>) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":834,"url":null},"def":{"name":"delete_at","args":[{"name":"range","external_name":"range","restriction":"Range"}],"return_type":"self","visibility":"Public","body":"delete_at(*(Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new)))"}},{"html_id":"delete_at(*,indexstart:Int,count:Int):self-instance-method","name":"delete_at","doc":"Removes *count* elements from `self` starting at *start*.\nIf the size of `self` is less than *count*, removes values to the end of the array without error.\nReturns an array of the removed elements with the original order of `self` preserved.\nRaises `IndexError` if *start* is out of range.\n\n```\na = [\"ant\", \"bat\", \"cat\", \"dog\"]\na.delete_at(1, 2)  # => [\"bat\", \"cat\"]\na                  # => [\"ant\", \"dog\"]\na.delete_at(99, 1) # raises IndexError\n```","summary":"<p>Removes <em>count</em> elements from <code>self</code> starting at <em>start</em>.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Array.html#delete_at%28start%3AInt%2Ccount%3AInt%29%3Aself-instance-method\">#delete_at(start, count)</a></code> instead</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"index","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(*, index start : Int, count : Int) : self","args_html":"(*, index start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":861,"url":null},"def":{"name":"delete_at","args":[{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"index","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"splat_index":0,"return_type":"self","visibility":"Public","body":"delete_at(start, count)"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a new `Array` that has exactly `self`'s elements.\nThat is, it returns a shallow copy of `self`.\n\nUse `#clone` if you want a deep copy.\n\n```\nary = [[1, 2], [3, 4]]\nary2 = ary.dup\nary[0][0] = 5\nary  # => [[5, 2], [3, 4]]\nary2 # => [[5, 2], [3, 4]]\n\nary2 << [7, 8]\nary  # => [[5, 2], [3, 4]]\nary2 # => [[5, 2], [3, 4], [7, 8]]\n```","summary":"<p>Returns a new <code><a href=\"Array.html\">Array</a></code> that has exactly <code>self</code>'s elements.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":881,"url":null},"def":{"name":"dup","visibility":"Public","body":"Array(T).build(@size) do |buffer|\n  buffer.copy_from(@buffer, size)\n  size\nend"}},{"html_id":"each_repeated_permutation(size:Int=self.size,reuse=false,&):Nil-instance-method","name":"each_repeated_permutation","abstract":false,"args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int = self.size, reuse = false, &) : Nil","args_html":"(size : <a href=\"Int.html\">Int</a> = <span class=\"k\">self</span>.size, reuse = <span class=\"n\">false</span>, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/array.cr","line_number":1235,"url":null},"def":{"name":"each_repeated_permutation","args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"yields":1,"return_type":"Nil","visibility":"Public","body":"n = self.size\nif (size != 0) && (n == 0)\n  return\nend\nif size < 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nif size == 0\n  yield([] of T)\nelse\n  Indexable.each_cartesian(Array.new(size, self), reuse: reuse) do |r|\n    yield r\n  end\nend\n"}},{"html_id":"fill(start:Int,&:Int32->T):self-instance-method","name":"fill","doc":"Yields each index of `self`, starting at *start*, to the given block and then assigns\nthe block's value in that position. Returns `self`.\n\nNegative values of *start* count from the end of the array.\n\nRaises `IndexError` if *start* is outside the array range.\n\n```\na = [1, 2, 3, 4]\na.fill(2) { |i| i * i } # => [1, 2, 4, 9]\n```","summary":"<p>Yields each index of <code>self</code>, starting at <em>start</em>, to the given block and then assigns the block's value in that position.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Array.html#fill%28%2A%2Cfromstart%3AInt%2C%26%3AInt32-%3ET%29%3Aself-instance-method\">#fill(start.., &)</a></code> instead</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"}],"args_string":"(start : Int, & : Int32 -> T) : self","args_html":"(start : <a href=\"Int.html\">Int</a>, & : <a href=\"Int32.html\">Int32</a> -> T) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":900,"url":null},"def":{"name":"fill","args":[{"name":"start","external_name":"start","restriction":"Int"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Int32 -> T)"},"return_type":"self","visibility":"Public","body":"fill(start..) do |i|\n  yield i\nend"}},{"html_id":"fill(*,fromstart:Int,&:Int32->T):self-instance-method","name":"fill","doc":"Yields each index of `self`, starting at *start*, to the given block and then assigns\nthe block's value in that position. Returns `self`.\n\nNegative values of *start* count from the end of the array.\n\nRaises `IndexError` if *start* is outside the array range.\n\n```\na = [1, 2, 3, 4]\na.fill(2) { |i| i * i } # => [1, 2, 4, 9]\n```","summary":"<p>Yields each index of <code>self</code>, starting at <em>start</em>, to the given block and then assigns the block's value in that position.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Array.html#fill%28%2A%2Cfromstart%3AInt%2C%26%3AInt32-%3ET%29%3Aself-instance-method\">#fill(start.., &)</a></code> instead</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"from","restriction":"Int"}],"args_string":"(*, from start : Int, & : Int32 -> T) : self","args_html":"(*, from start : <a href=\"Int.html\">Int</a>, & : <a href=\"Int32.html\">Int32</a> -> T) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":906,"url":null},"def":{"name":"fill","args":[{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"from","restriction":"Int"}],"splat_index":0,"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Int32 -> T)"},"return_type":"self","visibility":"Public","body":"fill(start..) do |i|\n  yield i\nend"}},{"html_id":"fill(*,fromstart:Int,count:Int,&:Int32->T):self-instance-method","name":"fill","doc":"Yields each index of `self`, starting at *start* and just *count* times,\nto the given block and then assigns the block's value in that position. Returns `self`.\n\nNegative values of *start* count from the end of the array.\n\nRaises `IndexError` if *start* is outside the array range.\n\nHas no effect if *count* is zero or negative.\n\n```\na = [1, 2, 3, 4, 5, 6]\na.fill(2, 2) { |i| i * i } # => [1, 2, 4, 9, 5, 6]\n```","summary":"<p>Yields each index of <code>self</code>, starting at <em>start</em> and just <em>count</em> times, to the given block and then assigns the block's value in that position.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Indexable/Mutable.html#fill%28value%3AT%2Cstart%3AInt%2Ccount%3AInt%29%3Aself-instance-method\">Indexable::Mutable#fill(start, count, &)</a></code> instead</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"from","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(*, from start : Int, count : Int, & : Int32 -> T) : self","args_html":"(*, from start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>, & : <a href=\"Int32.html\">Int32</a> -> T) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":924,"url":null},"def":{"name":"fill","args":[{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"from","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"splat_index":0,"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Int32 -> T)"},"return_type":"self","visibility":"Public","body":"fill(start, count) do |i|\n  yield i\nend"}},{"html_id":"fill(value:T,start:Int,count:Int):self-instance-method","name":"fill","doc":"Replaces *count* or less (if there aren't enough) elements starting at the\ngiven *start* index with *value*. Returns `self`.\n\nNegative values of *start* count from the end of the container.\n\nRaises `IndexError` if the *start* index is out of range.\n\nRaises `ArgumentError` if *count* is negative.\n\n```\narray = [1, 2, 3, 4, 5]\narray.fill(9, 2, 2) # => [1, 2, 9, 9, 5]\narray               # => [1, 2, 9, 9, 5]\n```","summary":"<p>Replaces <em>count</em> or less (if there aren't enough) elements starting at the given <em>start</em> index with <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(value : T, start : Int, count : Int) : self","args_html":"(value : T, start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":968,"url":null},"def":{"name":"fill","args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"to_unsafe_slice.fill(value, start, count)\nself\n"}},{"html_id":"fill(value:T,start:Int):self-instance-method","name":"fill","doc":"Replaces every element in `self`, starting at *start*, with the given *value*. Returns `self`.\n\nNegative values of *start* count from the end of the array.\n\n```\na = [1, 2, 3, 4, 5]\na.fill(9, 2) # => [1, 2, 9, 9, 9]\n```","summary":"<p>Replaces every element in <code>self</code>, starting at <em>start</em>, with the given <em>value</em>.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Array.html#fill%28%2A%2Cfromstart%3AInt%2C%26%3AInt32-%3ET%29%3Aself-instance-method\">#fill(value, start..)</a></code> instead</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"start","external_name":"start","restriction":"Int"}],"args_string":"(value : T, start : Int) : self","args_html":"(value : T, start : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":944,"url":null},"def":{"name":"fill","args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"start","external_name":"start","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"fill(value, start..)"}},{"html_id":"fill(value:T,range:Range):self-instance-method","name":"fill","doc":"Replaces every element in *range* with *value*. Returns `self`.\n\nNegative values of *from* count from the end of the array.\n\n```\na = [1, 2, 3, 4, 5]\na.fill(9, 2..3) # => [1, 2, 9, 9, 5]\n```","summary":"<p>Replaces every element in <em>range</em> with <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(value : T, range : Range) : self","args_html":"(value : T, range : <a href=\"Range.html\">Range</a>) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":987,"url":null},"def":{"name":"fill","args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"range","external_name":"range","restriction":"Range"}],"return_type":"self","visibility":"Public","body":"to_unsafe_slice.fill(value, range)\nself\n"}},{"html_id":"fill(value:T):self-instance-method","name":"fill","doc":"Replaces every element in `self` with the given *value*. Returns `self`.\n\n```\narray = [1, 2, 3, 4]\narray.fill(2) # => [2, 2, 2, 2]\narray         # => [2, 2, 2, 2]\n```","summary":"<p>Replaces every element in <code>self</code> with the given <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T) : self","args_html":"(value : T) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":929,"url":null},"def":{"name":"fill","args":[{"name":"value","external_name":"value","restriction":"T"}],"return_type":"self","visibility":"Public","body":"to_unsafe_slice.fill(value)\nself\n"}},{"html_id":"fill(value:T,*,fromstart:Int):self-instance-method","name":"fill","doc":"Replaces every element in `self`, starting at *start*, with the given *value*. Returns `self`.\n\nNegative values of *start* count from the end of the array.\n\n```\na = [1, 2, 3, 4, 5]\na.fill(9, 2) # => [1, 2, 9, 9, 9]\n```","summary":"<p>Replaces every element in <code>self</code>, starting at <em>start</em>, with the given <em>value</em>.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Array.html#fill%28%2A%2Cfromstart%3AInt%2C%26%3AInt32-%3ET%29%3Aself-instance-method\">#fill(value, start..)</a></code> instead</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"from","restriction":"Int"}],"args_string":"(value : T, *, from start : Int) : self","args_html":"(value : T, *, from start : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":950,"url":null},"def":{"name":"fill","args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"from","restriction":"Int"}],"splat_index":1,"return_type":"self","visibility":"Public","body":"fill(value, start..)"}},{"html_id":"fill(value:T,*,fromstart:Int,count:Int):self-instance-method","name":"fill","doc":"Replaces *count* or less (if there aren't enough) elements starting at the\ngiven *start* index with *value*. Returns `self`.\n\nNegative values of *start* count from the end of the container.\n\nRaises `IndexError` if the *start* index is out of range.\n\nRaises `ArgumentError` if *count* is negative.\n\n```\narray = [1, 2, 3, 4, 5]\narray.fill(9, 2, 2) # => [1, 2, 9, 9, 5]\narray               # => [1, 2, 9, 9, 5]\n```","summary":"<p>Replaces <em>count</em> or less (if there aren't enough) elements starting at the given <em>start</em> index with <em>value</em>.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Array.html#fill%28%2A%2Cfromstart%3AInt%2Ccount%3AInt%2C%26%3AInt32-%3ET%29%3Aself-instance-method\">#fill(value, start, count)</a></code> instead</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"from","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(value : T, *, from start : Int, count : Int) : self","args_html":"(value : T, *, from start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":975,"url":null},"def":{"name":"fill","args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"from","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"splat_index":1,"return_type":"self","visibility":"Public","body":"fill(value, start, count)"}},{"html_id":"first(n:Int):Array(T)-instance-method","name":"first","doc":"Returns the first *n* elements of the array.\n\n```\n[1, 2, 3].first(2) # => [1, 2]\n[1, 2, 3].first(4) # => [1, 2, 3]\n```","summary":"<p>Returns the first <em>n</em> elements of the array.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"}],"args_string":"(n : Int) : Array(T)","args_html":"(n : <a href=\"Int.html\">Int</a>) : <a href=\"Array.html\">Array</a>(T)","location":{"filename":"src/array.cr","line_number":998,"url":null},"def":{"name":"first","args":[{"name":"n","external_name":"n","restriction":"Int"}],"return_type":"Array(T)","visibility":"Public","body":"self[0, n]"}},{"html_id":"flatten-instance-method","name":"flatten","doc":"Returns a new `Array` that is a one-dimensional flattening of `self` (recursively).\n\nThat is, for every element that is an array or an iterator, extract its elements into the new array.\n\n```\ns = [1, 2, 3]          # => [1, 2, 3]\nt = [4, 5, 6, [7, 8]]  # => [4, 5, 6, [7, 8]]\nu = [9, [10, 11].each] # => [9, #<Indexable::ItemIterator>]\na = [s, t, u, 12, 13]  # => [[1, 2, 3], [4, 5, 6, [7, 8]], 9, #<Indexable::ItemIterator>, 12, 13]\na.flatten              # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13]\n```","summary":"<p>Returns a new <code><a href=\"Array.html\">Array</a></code> that is a one-dimensional flattening of <code>self</code> (recursively).</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1195,"url":null},"def":{"name":"flatten","visibility":"Public","body":"FlattenHelper(typeof(FlattenHelper.element_type(self))).flatten(self)"}},{"html_id":"index(object,offset:Int=0)-instance-method","name":"index","doc":"Returns the index of the first appearance of *value* in `self`\nstarting from the given *offset*, or `nil` if the value is not in `self`.\n\n```\n[1, 2, 3, 1, 2, 3].index(2, offset: 2) # => 4\n```","summary":"<p>Returns the index of the first appearance of <em>value</em> in <code>self</code> starting from the given <em>offset</em>, or <code>nil</code> if the value is not in <code>self</code>.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":""},{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"args_string":"(object, offset : Int = 0)","args_html":"(object, offset : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>)","location":{"filename":"src/array.cr","line_number":2134,"url":null},"def":{"name":"index","args":[{"name":"object","external_name":"object","restriction":""},{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"visibility":"Public","body":"if T.is_a?(UInt8.class) && (object.is_a?(UInt8) || (object.is_a?(Int) && (0 <= object && object < 256)))\n  return to_unsafe_slice.fast_index(object, offset)\nend\nsuper(object, offset)\n"}},{"html_id":"insert(index:Int,object:T)-instance-method","name":"insert","doc":"Insert *object* before the element at *index* and shifting successive elements, if any.\nReturns `self`.\n\nNegative values of *index* count from the end of the array.\n\n```\na = [\"a\", \"b\", \"c\"]\na.insert(0, \"x\")  # => [\"x\", \"a\", \"b\", \"c\"]\na.insert(2, \"y\")  # => [\"x\", \"a\", \"y\", \"b\", \"c\"]\na.insert(-1, \"z\") # => [\"x\", \"a\", \"y\", \"b\", \"c\", \"z\"]\n```","summary":"<p>Insert <em>object</em> before the element at <em>index</em> and shifting successive elements, if any.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"object","external_name":"object","restriction":"T"}],"args_string":"(index : Int, object : T)","args_html":"(index : <a href=\"Int.html\">Int</a>, object : T)","location":{"filename":"src/array.cr","line_number":1013,"url":null},"def":{"name":"insert","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"object","external_name":"object","restriction":"T"}],"visibility":"Public","body":"if index == 0\n  return unshift(object)\nend\nif index < 0\n  index = index + (size + 1)\nend\nif 0 <= index && index <= size\nelse\n  raise(IndexError.new)\nend\ncheck_needs_resize\n((@buffer + index) + 1).move_from(@buffer + index, size - index)\n@buffer[index] = object\n@size = @size + 1\nself\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/array.cr","line_number":1035,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"last(n:Int):Array(T)-instance-method","name":"last","doc":"Returns the last *n* elements of the array.\n\n```\n[1, 2, 3].last(2) # => [2, 3]\n[1, 2, 3].last(4) # => [1, 2, 3]\n```","summary":"<p>Returns the last <em>n</em> elements of the array.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"}],"args_string":"(n : Int) : Array(T)","args_html":"(n : <a href=\"Int.html\">Int</a>) : <a href=\"Array.html\">Array</a>(T)","location":{"filename":"src/array.cr","line_number":1045,"url":null},"def":{"name":"last","args":[{"name":"n","external_name":"n","restriction":"Int"}],"return_type":"Array(T)","visibility":"Public","body":"if n < @size\n  self[@size - n, n]\nelse\n  dup\nend"}},{"html_id":"map(&:T->U)forallU-instance-method","name":"map","doc":"Optimized version of `Enumerable#map`.","summary":"<p>Optimized version of <code><a href=\"Enumerable.html#map%28%26%3AT-%3EU%29%3AArray%28U%29forallU-instance-method\">Enumerable#map</a></code>.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1059,"url":null},"def":{"name":"map","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"visibility":"Public","body":"Array(U).new(size) do |i|\n  yield @buffer[i]\nend"}},{"html_id":"map_with_index(offset=0,&:T,Int32->_)-instance-method","name":"map_with_index","doc":"Optimized version of `Enumerable#map_with_index`.\n\nAccepts an optional *offset* parameter, which tells it to start counting\nfrom there.\n\n```\ngems = [\"crystal\", \"pearl\", \"diamond\"]\nresults = gems.map_with_index { |gem, i| \"#{i}: #{gem}\" }\nresults # => [\"0: crystal\", \"1: pearl\", \"2: diamond\"]\n```","summary":"<p>Optimized version of <code><a href=\"Enumerable.html#map_with_index%28offset%3D0%2C%26%3AT%2CInt32-%3EU%29%3AArray%28U%29forallU-instance-method\">Enumerable#map_with_index</a></code>.</p>","abstract":false,"args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(offset = 0, & : T, Int32 -> _)","args_html":"(offset = <span class=\"n\">0</span>, & : T, <a href=\"Int32.html\">Int32</a> -> _)","location":{"filename":"src/array.cr","line_number":1162,"url":null},"def":{"name":"map_with_index","args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"yields":2,"block_arg":{"name":"","external_name":"","restriction":"(T, Int32 -> _)"},"visibility":"Public","body":"Array.new(size) do |i|\n  yield @buffer[i], offset + i\nend"}},{"html_id":"pop(n:Int):Array(T)-instance-method","name":"pop","doc":"Removes the last *n* values from `self`, at index *size - 1*.\nThis method returns an array of the removed values, with the original order preserved.\n\nIf *n* is greater than the size of `self`, all values will be removed from `self`\nwithout raising an error.\n\n```\na = [\"a\", \"b\", \"c\"]\na.pop(2) # => [\"b\", \"c\"]\na        # => [\"a\"]\n\na = [\"a\", \"b\", \"c\"]\na.pop(4) # => [\"a\", \"b\", \"c\"]\na        # => []\n```\n\nSee also: `#truncate`.","summary":"<p>Removes the last <em>n</em> values from <code>self</code>, at index <em>size - 1</em>.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"}],"args_string":"(n : Int) : Array(T)","args_html":"(n : <a href=\"Int.html\">Int</a>) : <a href=\"Array.html\">Array</a>(T)","location":{"filename":"src/array.cr","line_number":1307,"url":null},"def":{"name":"pop","args":[{"name":"n","external_name":"n","restriction":"Int"}],"return_type":"Array(T)","visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Can't pop negative count\"))\nend\nn = Math.min(n, @size)\nary = Array(T).new(n) do |i|\n  @buffer[(@size - n) + i]\nend\n@size = @size - n\n(@buffer + @size).clear(n)\nary\n"}},{"html_id":"pop:T-instance-method","name":"pop","doc":"Removes the last value from `self`, at index *size - 1*.\nThis method returns the removed value.\nRaises `IndexError` if array is of 0 size.\n\n```\na = [\"a\", \"b\", \"c\"]\na.pop # => \"c\"\na     # => [\"a\", \"b\"]\n```\n\nSee also: `#truncate`.","summary":"<p>Removes the last value from <code>self</code>, at index <em>size - 1</em>.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1258,"url":null},"def":{"name":"pop","return_type":"T","visibility":"Public","body":"pop do\n  raise(IndexError.new)\nend"}},{"html_id":"pop(&)-instance-method","name":"pop","doc":"Removes the last value from `self`.\nIf the array is empty, the given block is called.\n\n```\na = [1]\na.pop { \"Testing\" } # => 1\na.pop { \"Testing\" } # => \"Testing\"\n```\n\nSee also: `#truncate`.","summary":"<p>Removes the last value from <code>self</code>.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1272,"url":null},"def":{"name":"pop","yields":0,"visibility":"Public","body":"if @size == 0\n  yield\nelse\n  @size = @size - 1\n  value = @buffer[@size]\n  (@buffer + @size).clear\n  if empty? && (@offset_to_buffer != 0)\n    reset_buffer_to_root_buffer\n  end\n  value\nend"}},{"html_id":"pop?:T?-instance-method","name":"pop?","doc":"Like `pop`, but returns `nil` if `self` is empty.\n\nSee also: `#truncate`.","summary":"<p>Like <code><a href=\"Array.html#pop%3AT-instance-method\">#pop</a></code>, but returns <code>nil</code> if <code>self</code> is empty.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1324,"url":null},"def":{"name":"pop?","return_type":"T | ::Nil","visibility":"Public","body":"pop do\n  nil\nend"}},{"html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","args_html":"(pp) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/array.cr","line_number":1719,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"return_type":"Nil","visibility":"Public","body":"executed = exec_recursive(:pretty_print) do\n  pp.list(\"[\", self, \"]\")\nend\nif executed\nelse\n  pp.text(\"[...]\")\nend\n"}},{"html_id":"product(ary:Array(U))forallU-instance-method","name":"product","doc":"Returns an `Array` of all ordered combinations of elements taken from each\nof `self` and *ary* as `Tuple`s.\nTraversal of elements starts from *ary*.","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of all ordered combinations of elements taken from each of <code>self</code> and <em>ary</em> as <code><a href=\"Tuple.html\">Tuple</a></code>s.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Indexable.html#cartesian_product%28%2Aothers%3AIndexable%29-instance-method\">Indexable#cartesian_product(*others : Indexable)</a></code> instead</p>","abstract":false,"args":[{"name":"ary","external_name":"ary","restriction":"Array(U)"}],"args_string":"(ary : Array(U)) forall U","args_html":"(ary : <a href=\"Array.html\">Array</a>(U)) forall U","location":{"filename":"src/array.cr","line_number":1332,"url":null},"def":{"name":"product","args":[{"name":"ary","external_name":"ary","restriction":"Array(U)"}],"visibility":"Public","body":"cartesian_product(ary)"}},{"html_id":"product(enumerable:Enumerable,&)-instance-method","name":"product","doc":"Yields each ordered combination of the elements taken from each of `self`\nand *enumerable* as a `Tuple`.\nTraversal of elements starts from *enumerable*.","summary":"<p>Yields each ordered combination of the elements taken from each of <code>self</code> and <em>enumerable</em> as a <code><a href=\"Tuple.html\">Tuple</a></code>.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Indexable.html#each_cartesian%28indexables%3AIndexable%28Indexable%29%2Creuse%3Dfalse%2C%26%29-class-method\">Indexable#each_cartesian(*others : Indexable, &block)</a></code> instead</p>","abstract":false,"args":[{"name":"enumerable","external_name":"enumerable","restriction":"Enumerable"}],"args_string":"(enumerable : Enumerable, &)","args_html":"(enumerable : <a href=\"Enumerable.html\">Enumerable</a>, &)","location":{"filename":"src/array.cr","line_number":1340,"url":null},"def":{"name":"product","args":[{"name":"enumerable","external_name":"enumerable","restriction":"Enumerable"}],"yields":2,"visibility":"Public","body":"self.each do |a|\n  enumerable.each do |b|\n    yield a, b\n  end\nend"}},{"html_id":"push(value:T)-instance-method","name":"push","doc":"Append. Pushes one value to the end of `self`, given that the type of the value is *T*\n(which might be a single type or a union of types).\nThis method returns `self`, so several calls can be chained.\nSee `pop` for the opposite effect.\n\n```\na = [\"a\", \"b\"]\na.push(\"c\") # => [\"a\", \"b\", \"c\"]\na.push(1)   # Errors, because the array only accepts String.\n\na = [\"a\", \"b\"] of (Int32 | String)\na.push(\"c\") # => [\"a\", \"b\", \"c\"]\na.push(1)   # => [\"a\", \"b\", \"c\", 1]\n```","summary":"<p>Append.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T)","args_html":"(value : T)","location":{"filename":"src/array.cr","line_number":1358,"url":null},"def":{"name":"push","args":[{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"check_needs_resize\n@buffer[@size] = value\n@size = @size + 1\nself\n"}},{"html_id":"push(*values:T):self-instance-method","name":"push","doc":"Append multiple values. The same as `push`, but takes an arbitrary number\nof values to push into `self`. Returns `self`.\n\n```\na = [\"a\"]\na.push(\"b\", \"c\") # => [\"a\", \"b\", \"c\"]\n```","summary":"<p>Append multiple values.</p>","abstract":false,"args":[{"name":"values","external_name":"values","restriction":"T"}],"args_string":"(*values : T) : self","args_html":"(*values : T) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":1372,"url":null},"def":{"name":"push","args":[{"name":"values","external_name":"values","restriction":"T"}],"splat_index":0,"return_type":"self","visibility":"Public","body":"new_size = @size + values.size\nresize_if_cant_insert(values.size)\nvalues.each_with_index do |value, i|\n  @buffer[@size + i] = value\nend\n@size = @size + values.size\nself\n"}},{"html_id":"reject!(&:T->):self-instance-method","name":"reject!","doc":"Modifies `self`, deleting the elements in the collection for which the\npassed block returns `true`. Returns `self`.\n\n```\nary = [1, 6, 2, 4, 8]\nary.reject! { |x| x > 3 }\nary # => [1, 2]\n```\n\nSee also: `Array#reject`.","summary":"<p>Modifies <code>self</code>, deleting the elements in the collection for which the passed block returns <code>true</code>.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1101,"url":null},"def":{"name":"reject!","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"self","visibility":"Public","body":"internal_delete do |e|\n  yield e\nend\nself\n"}},{"html_id":"reject!(pattern):self-instance-method","name":"reject!","doc":"Modifies `self`, deleting the elements in the collection for which\n`pattern === element`.\n\n```\nary = [1, 6, 2, 4, 8]\nary.reject!(3..7)\nary # => [1, 2, 8]\n```\n\nSee also: `Array#select!`.","summary":"<p>Modifies <code>self</code>, deleting the elements in the collection for which <code>pattern === element</code>.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : self","args_html":"(pattern) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":1116,"url":null},"def":{"name":"reject!","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"self","visibility":"Public","body":"reject! do |elem|\n  pattern === elem\nend\nself\n"}},{"html_id":"remaining_capacity:Int32-instance-method","name":"remaining_capacity","abstract":false,"location":{"filename":"src/array.cr","line_number":2034,"url":null},"def":{"name":"remaining_capacity","return_type":"Int32","visibility":"Public","body":"@capacity - @offset_to_buffer"}},{"html_id":"repeated_permutations(size:Int=self.size):Array(Array(T))-instance-method","name":"repeated_permutations","abstract":false,"args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"}],"args_string":"(size : Int = self.size) : Array(Array(T))","args_html":"(size : <a href=\"Int.html\">Int</a> = <span class=\"k\">self</span>.size) : <a href=\"Array.html\">Array</a>(<a href=\"Array.html\">Array</a>(T))","location":{"filename":"src/array.cr","line_number":1227,"url":null},"def":{"name":"repeated_permutations","args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"}],"return_type":"Array(Array(T))","visibility":"Public","body":"ary = [] of Array(T)\neach_repeated_permutation(size) do |a|\n  ary << a\nend\nary\n"}},{"html_id":"replace(other:Array):self-instance-method","name":"replace","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Array"}],"args_string":"(other : Array) : self","args_html":"(other : <a href=\"Array.html\">Array</a>) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":1384,"url":null},"def":{"name":"replace","args":[{"name":"other","external_name":"other","restriction":"Array"}],"return_type":"self","visibility":"Public","body":"@size = other.size\nif @size > @capacity\n  resize_to_capacity(Math.pw2ceil(@size))\nend\n@buffer.copy_from(other.to_unsafe, other.size)\nself\n"}},{"html_id":"reverse:Array(T)-instance-method","name":"reverse","doc":"Returns an array with all the elements in the collection reversed.\n\n```\na = [1, 2, 3]\na.reverse # => [3, 2, 1]\n```","summary":"<p>Returns an array with all the elements in the collection reversed.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1397,"url":null},"def":{"name":"reverse","return_type":"Array(T)","visibility":"Public","body":"Array(T).new(size) do |i|\n  @buffer[(size - i) - 1]\nend"}},{"html_id":"rotate(n=1):Array(T)-instance-method","name":"rotate","doc":"Returns an array with all the elements shifted to the left `n` times.\n\n```\na = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\na.rotate    # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]\na.rotate(1) # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]\na.rotate(3) # => [3, 4, 5, 6, 7, 8, 9, 0, 1, 2]\na           # => [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\n```","summary":"<p>Returns an array with all the elements shifted to the left <code>n</code> times.</p>","abstract":false,"args":[{"name":"n","default_value":"1","external_name":"n","restriction":""}],"args_string":"(n = 1) : Array(T)","args_html":"(n = <span class=\"n\">1</span>) : <a href=\"Array.html\">Array</a>(T)","location":{"filename":"src/array.cr","line_number":1416,"url":null},"def":{"name":"rotate","args":[{"name":"n","default_value":"1","external_name":"n","restriction":""}],"return_type":"Array(T)","visibility":"Public","body":"if size == 0\n  return self\nend\nn = n % size\nif n == 0\n  return self\nend\nres = Array(T).new(size)\nres.to_unsafe.copy_from(@buffer + n, size - n)\n((res.to_unsafe + size) - n).copy_from(@buffer, n)\nres.size = size\nres\n"}},{"html_id":"rotate!(n:Int=1):self-instance-method","name":"rotate!","doc":"Shifts all elements of `self` to the left *n* times. Returns `self`.\n\n```\na1 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\na2 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\na3 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\n\na1.rotate!\na2.rotate!(1)\na3.rotate!(3)\n\na1 # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]\na2 # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]\na3 # => [3, 4, 5, 6, 7, 8, 9, 0, 1, 2]\n```","summary":"<p>Shifts all elements of <code>self</code> to the left <em>n</em> times.</p>","abstract":false,"args":[{"name":"n","default_value":"1","external_name":"n","restriction":"Int"}],"args_string":"(n : Int = 1) : self","args_html":"(n : <a href=\"Int.html\">Int</a> = <span class=\"n\">1</span>) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":1402,"url":null},"def":{"name":"rotate!","args":[{"name":"n","default_value":"1","external_name":"n","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"to_unsafe_slice.rotate!(n)\nself\n"}},{"html_id":"select!(&:T->):self-instance-method","name":"select!","doc":"Modifies `self`, keeping only the elements in the collection for which the\npassed block returns `true`. Returns `self`.\n\n```\nary = [1, 6, 2, 4, 8]\nary.select! { |x| x > 3 }\nary # => [6, 4, 8]\n```\n\nSee also: `Array#select`.","summary":"<p>Modifies <code>self</code>, keeping only the elements in the collection for which the passed block returns <code>true</code>.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1073,"url":null},"def":{"name":"select!","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"self","visibility":"Public","body":"reject! do |elem|\n  !(yield(elem))\nend"}},{"html_id":"select!(pattern):self-instance-method","name":"select!","doc":"Modifies `self`, keeping only the elements in the collection for which\n`pattern === element`.\n\n```\nary = [1, 6, 2, 4, 8]\nary.select!(3..7)\nary # => [6, 4]\n```\n\nSee also: `Array#reject!`.","summary":"<p>Modifies <code>self</code>, keeping only the elements in the collection for which <code>pattern === element</code>.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : self","args_html":"(pattern) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":1087,"url":null},"def":{"name":"select!","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"self","visibility":"Public","body":"self.select! do |elem|\n  pattern === elem\nend"}},{"html_id":"shift(n:Int):Array(T)-instance-method","name":"shift","doc":"Removes the first *n* values of `self`, starting at index 0.\nThis method returns an array of the removed values.\n\nIf *n* is greater than the size of `self`, all values will be removed from `self`\nwithout raising an error.\n\n```\na = [\"a\", \"b\", \"c\"]\na.shift # => \"a\"\na       # => [\"b\", \"c\"]\n\na = [\"a\", \"b\", \"c\"]\na.shift(4) # => [\"a\", \"b\", \"c\"]\na          # => []\n```\n\nSee also: `#truncate`.","summary":"<p>Removes the first <em>n</em> values of <code>self</code>, starting at index 0.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"}],"args_string":"(n : Int) : Array(T)","args_html":"(n : <a href=\"Int.html\">Int</a>) : <a href=\"Array.html\">Array</a>(T)","location":{"filename":"src/array.cr","line_number":1494,"url":null},"def":{"name":"shift","args":[{"name":"n","external_name":"n","restriction":"Int"}],"return_type":"Array(T)","visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Can't shift negative count\"))\nend\nn = Math.min(n, @size)\nary = Array(T).new(n) do |i|\n  @buffer[i]\nend\n@size = @size - n\n@buffer.clear(n)\nif empty?\n  reset_buffer_to_root_buffer\nelse\n  shift_buffer_by(n)\nend\nary\n"}},{"html_id":"shift:T-instance-method","name":"shift","doc":"Removes the first value of `self`, at index 0. This method returns the removed value.\nIf the array is empty, it raises `IndexError`.\n\n```\na = [\"a\", \"b\", \"c\"]\na.shift # => \"a\"\na       # => [\"b\", \"c\"]\n```\n\nSee also: `#truncate`.","summary":"<p>Removes the first value of <code>self</code>, at index 0.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1437,"url":null},"def":{"name":"shift","return_type":"T","visibility":"Public","body":"shift do\n  raise(IndexError.new)\nend"}},{"html_id":"shift(&)-instance-method","name":"shift","doc":"Removes the first value of `self`, at index 0, or otherwise invokes the given block.\nThis method returns the removed value.\nIf the array is empty, it invokes the given block and returns its value.\n\n```\na = [\"a\"]\na.shift { \"empty!\" } # => \"a\"\na                    # => []\na.shift { \"empty!\" } # => \"empty!\"\na                    # => []\n```\n\nSee also: `#truncate`.","summary":"<p>Removes the first value of <code>self</code>, at index 0, or otherwise invokes the given block.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1454,"url":null},"def":{"name":"shift","yields":0,"visibility":"Public","body":"if @size == 0\n  yield\nelse\n  shift_when_not_empty\nend"}},{"html_id":"shift?:T?-instance-method","name":"shift?","doc":"Removes the first value of `self`, at index 0. This method returns the removed value.\nIf the array is empty, it returns `nil` without raising any error.\n\n```\na = [\"a\", \"b\"]\na.shift? # => \"a\"\na        # => [\"b\"]\na.shift? # => \"b\"\na        # => []\na.shift? # => nil\na        # => []\n```\n\nSee also: `#truncate`.","summary":"<p>Removes the first value of <code>self</code>, at index 0.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1529,"url":null},"def":{"name":"shift?","return_type":"T | ::Nil","visibility":"Public","body":"shift do\n  nil\nend"}},{"html_id":"shuffle(random=Random::DEFAULT):Array(T)-instance-method","name":"shuffle","doc":"Returns an array with all the elements in the collection randomized\nusing the given *random* number generator.","summary":"<p>Returns an array with all the elements in the collection randomized using the given <em>random</em> number generator.</p>","abstract":false,"args":[{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(random = Random::DEFAULT) : Array(T)","args_html":"(random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>) : <a href=\"Array.html\">Array</a>(T)","location":{"filename":"src/array.cr","line_number":1535,"url":null},"def":{"name":"shuffle","args":[{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"return_type":"Array(T)","visibility":"Public","body":"dup.shuffle!(random)"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Returns the number of elements in the array.\n\n```\n[:foo, :bar].size # => 2\n```","summary":"<p>Returns the number of elements in the array.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":203,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"@size"}},{"html_id":"skip(count:Int):Array(T)-instance-method","name":"skip","doc":"Returns an `Array` with the first *count* elements removed\nfrom the original array.\n\nIf *count* is bigger than the number of elements in the array, returns an empty array.\n\n```\n[1, 2, 3, 4, 5, 6].skip(3) # => [4, 5, 6]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with the first <em>count</em> elements removed from the original array.</p>","abstract":false,"args":[{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(count : Int) : Array(T)","args_html":"(count : <a href=\"Int.html\">Int</a>) : <a href=\"Array.html\">Array</a>(T)","location":{"filename":"src/array.cr","line_number":1174,"url":null},"def":{"name":"skip","args":[{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"Array(T)","visibility":"Public","body":"if count < 0\n  raise(ArgumentError.new(\"Attempt to skip negative size\"))\nend\nnew_size = Math.max(size - count, 0)\nArray(T).build(new_size) do |buffer|\n  buffer.copy_from(to_unsafe + count, new_size)\n  new_size\nend\n"}},{"html_id":"sort:Array(T)-instance-method","name":"sort","doc":"Returns a new instance with all elements sorted based on the return value of\ntheir comparison method `T#<=>` (see `Comparable#<=>`), using a stable sort algorithm.\n\n```\na = [3, 1, 2]\na.sort # => [1, 2, 3]\na      # => [3, 1, 2]\n```\n\nSee `Indexable::Mutable#sort!` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two elements returns `nil`.","summary":"<p>Returns a new instance with all elements sorted based on the return value of their comparison method <code>T#<=></code> (see <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">Comparable#<=></a></code>), using a stable sort algorithm.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1551,"url":null},"def":{"name":"sort","return_type":"Array(T)","visibility":"Public","body":"dup.sort!"}},{"html_id":"sort(&block:T,T->U):Array(T)forallU-instance-method","name":"sort","doc":"Returns a new instance with all elements sorted based on the comparator in the\ngiven block, using a stable sort algorithm.\n\n```\na = [3, 1, 2]\nb = a.sort { |a, b| b <=> a }\n\nb # => [3, 2, 1]\na # => [3, 1, 2]\n```\n\nSee `Indexable::Mutable#sort!(&block : T, T -> U)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if for any two elements the block returns `nil`.","summary":"<p>Returns a new instance with all elements sorted based on the comparator in the given block, using a stable sort algorithm.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1585,"url":null},"def":{"name":"sort","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> U)"},"return_type":"Array(T)","visibility":"Public","body":"{% if U <= ::Union(Int32, ::Nil) %}{% else %}\n      {% raise(\"expected block to return Int32 or Nil, not #{U}\") %}\n    {% end %}\ndup.sort!(&block)\n"}},{"html_id":"sort!:Array(T)-instance-method","name":"sort!","doc":"Sorts all elements in `self` based on the return value of the comparison\nmethod `T#<=>` (see `Comparable#<=>`), using a stable sort algorithm.\n\n```\na = [3, 1, 2]\na.sort!\na # => [1, 2, 3]\n```\n\nThis sort operation modifies `self`. See `#sort` for a non-modifying option\nthat allocates a new instance.\n\nSee `Slice#sort!` for details on the implementation.\n\nRaises `ArgumentError` if the comparison between any two elements returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the return value of the comparison method <code>T#<=></code> (see <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">Comparable#<=></a></code>), using a stable sort algorithm.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1616,"url":null},"def":{"name":"sort!","return_type":"Array(T)","visibility":"Public","body":"to_unsafe_slice.sort!\nself\n"}},{"html_id":"sort!(&block:T,T->U):selfforallU-instance-method","name":"sort!","doc":"Sorts all elements in `self` based on the comparator in the given block, using\na stable sort algorithm.\n\nThe block must implement a comparison between two elements *a* and *b*,\nwhere `a < b` returns `-1`, `a == b` returns `0`, and `a > b` returns `1`.\nThe comparison operator `<=>` can be used for this.\n\n```\na = [3, 1, 2]\n# This is a reverse sort (forward sort would be `a <=> b`)\na.sort! { |a, b| b <=> a }\na # => [3, 2, 1]\n```\n\nThis sort operation modifies `self`. See `#sort(&block : T, T -> U)` for a\nnon-modifying option that allocates a new instance.\n\nSee `Slice#sort!(&block : T, T -> U)` for details on the implementation.\n\nRaises `ArgumentError` if for any two elements the block returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the comparator in the given block, using a stable sort algorithm.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1628,"url":null},"def":{"name":"sort!","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> U)"},"return_type":"self","visibility":"Public","body":"{% if U <= ::Union(Int32, ::Nil) %}{% else %}\n      {% raise(\"expected block to return Int32 or Nil, not #{U}\") %}\n    {% end %}\nto_unsafe_slice.sort!(&block)\nself\n"}},{"html_id":"sort_by(&block:T->_):Array(T)-instance-method","name":"sort_by","doc":"Returns a new instance with all elements sorted by the output value of the\nblock. The output values are compared via the comparison method `T#<=>`\n(see `Comparable#<=>`), using a stable sort algorithm.\n\n```\na = %w(apple pear fig)\nb = a.sort_by { |word| word.size }\nb # => [\"fig\", \"pear\", \"apple\"]\na # => [\"apple\", \"pear\", \"fig\"]\n```\n\nIf stability is expendable, `#unstable_sort_by(&block : T -> _)` provides a\nperformance advantage over stable sort.\n\nSee `Indexable::Mutable#sort_by!(&block : T -> _)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two comparison values returns `nil`.","summary":"<p>Returns a new instance with all elements sorted by the output value of the block.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1664,"url":null},"def":{"name":"sort_by","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> _)"},"return_type":"Array(T)","visibility":"Public","body":"dup.sort_by! do |e|\n  yield(e)\nend"}},{"html_id":"sort_by!(&block:T->_):Array(T)-instance-method","name":"sort_by!","doc":"Sorts all elements in `self` by the output value of the\nblock. The output values are compared via the comparison method `#<=>`\n(see `Comparable#<=>`), using a stable sort algorithm.\n\n```\na = %w(apple pear fig)\na.sort_by! { |word| word.size }\na # => [\"fig\", \"pear\", \"apple\"]\n```\n\nThis sort operation modifies `self`. See `#sort_by(&block : T -> _)` for a\nnon-modifying option that allocates a new instance.\n\nIf stability is expendable, `#unstable_sort_by!(&block : T -> _)` provides a\nperformance advantage over stable sort.\n\nSee `#sort!(&block : T -> _)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two comparison values returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> by the output value of the block.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1689,"url":null},"def":{"name":"sort_by!","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> _)"},"return_type":"Array(T)","visibility":"Public","body":"sorted = map do |e|\n  {e, yield(e)}\nend.sort! do |x, y|\n  x[1] <=> y[1]\nend\n@size.times do |i|\n  @buffer[i] = sorted.to_unsafe[i][0]\nend\nself\n"}},{"html_id":"to_a-instance-method","name":"to_a","doc":"Returns an `Array` with all the elements in the collection.\n\n```\n{1, 2, 3}.to_a # => [1, 2, 3]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1706,"url":null},"def":{"name":"to_a","visibility":"Public","body":"self"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":94,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.array do\n  each(&.to_json(json))\nend"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a short String representation of this object\nwhich includes its class name and its object address.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).to_s # => #<Person:0x10a199f20>\n```","summary":"<p>Appends a short String representation of this object which includes its class name and its object address.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/array.cr","line_number":1710,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"executed = exec_recursive(:to_s) do\n  io << '['\n  join(io, \", \", &.inspect(io))\n  io << ']'\nend\nif executed\nelse\n  io << \"[...]\"\nend\n"}},{"html_id":"to_unsafe:Pointer(T)-instance-method","name":"to_unsafe","doc":"Returns a pointer to the internal buffer where `self`'s elements are stored.\n\nThis method is **unsafe** because it returns a pointer, and the pointed might eventually\nnot be that of `self` if the array grows and its internal buffer is reallocated.\n\n```\nary = [1, 2, 3]\nary.to_unsafe[0] # => 1\n```","summary":"<p>Returns a pointer to the internal buffer where <code>self</code>'s elements are stored.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1735,"url":null},"def":{"name":"to_unsafe","return_type":"Pointer(T)","visibility":"Public","body":"@buffer"}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder) : Nil","args_html":"(yaml : <a href=\"YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":35,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"yaml.sequence(reference: self) do\n  each(&.to_yaml(yaml))\nend"}},{"html_id":"transpose-instance-method","name":"transpose","doc":"Assumes that `self` is an array of arrays and transposes the rows and columns.\n\n```\na = [[:a, :b], [:c, :d], [:e, :f]]\na.transpose # => [[:a, :c, :e], [:b, :d, :f]]\na           # => [[:a, :b], [:c, :d], [:e, :f]]\n```","summary":"<p>Assumes that <code>self</code> is an array of arrays and transposes the rows and columns.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1746,"url":null},"def":{"name":"transpose","visibility":"Public","body":"if empty?\n  return Array(Array(typeof(Enumerable.element_type(Enumerable.element_type(self))))).new\nend\nlen = self[0].size\n(1...@size).each do |i|\n  l = self[i].size\n  if len != l\n    raise(IndexError.new)\n  end\nend\nArray(Array(typeof(Enumerable.element_type(Enumerable.element_type(self))))).new(len) do |i|\n  Array(typeof(Enumerable.element_type(Enumerable.element_type(self)))).new(@size) do |j|\n    self[j][i]\n  end\nend\n"}},{"html_id":"truncate(start:Int,count:Int):self-instance-method","name":"truncate","doc":"Removes all elements except the *count* or less (if there aren't enough)\nelements starting at the given *start* index. Returns `self`.\n\nNegative values of *start* count from the end of the array.\n\nRaises `IndexError` if the *start* index is out of range.\n\nRaises `ArgumentError` if *count* is negative.\n\n```\na = [0, 1, 4, 9, 16, 25]\na.truncate(2, 3) # => [4, 9, 16]\na                # => [4, 9, 16]\n```\n\nSee also: `#pop`, `#shift`.","summary":"<p>Removes all elements except the <em>count</em> or less (if there aren't enough) elements starting at the given <em>start</em> index.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int) : self","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":1778,"url":null},"def":{"name":"truncate","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"start, count = normalize_start_and_count(start, count)\nif count == 0\n  clear\n  reset_buffer_to_root_buffer\nelse\n  @buffer.clear(start)\n  ((@buffer + start) + count).clear((size - start) - count)\n  @size = count\n  shift_buffer_by(start)\nend\nself\n"}},{"html_id":"truncate(range:Range):self-instance-method","name":"truncate","doc":"Removes all elements except those within the given *range*. Returns `self`.\n\n```\na = [0, 1, 4, 9, 16, 25]\na.truncate(1..-3) # => [1, 4, 9]\na                 # => [1, 4, 9]\n```","summary":"<p>Removes all elements except those within the given <em>range</em>.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range) : self","args_html":"(range : <a href=\"Range.html\">Range</a>) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":1801,"url":null},"def":{"name":"truncate","args":[{"name":"range","external_name":"range","restriction":"Range"}],"return_type":"self","visibility":"Public","body":"truncate(*(Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new)))"}},{"html_id":"uniq-instance-method","name":"uniq","doc":"Returns a new `Array` by removing duplicate values in `self`.\n\n```\na = [\"a\", \"a\", \"b\", \"b\", \"c\"]\na.uniq # => [\"a\", \"b\", \"c\"]\na      # => [ \"a\", \"a\", \"b\", \"b\", \"c\" ]\n```","summary":"<p>Returns a new <code><a href=\"Array.html\">Array</a></code> by removing duplicate values in <code>self</code>.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1812,"url":null},"def":{"name":"uniq","visibility":"Public","body":"if size <= 1\n  return dup\nend\nif size <= SMALL_ARRAY_SIZE\n  ary = Array(T).new\n  each do |elem|\n    if ary.includes?(elem)\n    else\n      ary << elem\n    end\n  end\n  return ary\nend\nto_lookup_hash.values\n"}},{"html_id":"uniq(&:T->)-instance-method","name":"uniq","doc":"Returns a new `Array` by removing duplicate values in `self`, using the block's\nvalue for comparison.\n\n```\na = [{\"student\", \"sam\"}, {\"student\", \"george\"}, {\"teacher\", \"matz\"}]\na.uniq { |s| s[0] } # => [{\"student\", \"sam\"}, {\"teacher\", \"matz\"}]\na                   # => [{\"student\", \"sam\"}, {\"student\", \"george\"}, {\"teacher\", \"matz\"}]\n```","summary":"<p>Returns a new <code><a href=\"Array.html\">Array</a></code> by removing duplicate values in <code>self</code>, using the block's value for comparison.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1839,"url":null},"def":{"name":"uniq","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"visibility":"Public","body":"if size <= 1\n  dup\nelse\n  hash = to_lookup_hash do |elem|\n    yield elem\n  end\n  hash.values\nend"}},{"html_id":"uniq!:self-instance-method","name":"uniq!","doc":"Removes duplicate elements from `self`. Returns `self`.\n\n```\na = [\"a\", \"a\", \"b\", \"b\", \"c\"]\na.uniq! # => [\"a\", \"b\", \"c\"]\na       # => [\"a\", \"b\", \"c\"]\n```","summary":"<p>Removes duplicate elements from <code>self</code>.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1855,"url":null},"def":{"name":"uniq!","return_type":"self","visibility":"Public","body":"if size <= 1\n  return self\nend\nif size <= SMALL_ARRAY_SIZE\n  internal_delete do |elem, index|\n    (0...index).any? do |subindex|\n      elem == to_unsafe[subindex]\n    end\n  end\n  return self\nend\nuniq!(&.itself)\n"}},{"html_id":"uniq!(&:T->):self-instance-method","name":"uniq!","doc":"Removes duplicate elements from `self`, using the block's value for comparison. Returns `self`.\n\n```\na = [{\"student\", \"sam\"}, {\"student\", \"george\"}, {\"teacher\", \"matz\"}]\na.uniq! { |s| s[0] } # => [{\"student\", \"sam\"}, {\"teacher\", \"matz\"}]\na                    # => [{\"student\", \"sam\"}, {\"teacher\", \"matz\"}]\n```","summary":"<p>Removes duplicate elements from <code>self</code>, using the block's value for comparison.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1880,"url":null},"def":{"name":"uniq!","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"self","visibility":"Public","body":"if size <= 1\n  return self\nend\nhash = to_lookup_hash do |elem|\n  yield elem\nend\nif size == hash.size\n  return self\nend\nold_size = @size\n@size = hash.size\nremoved = old_size - @size\nif removed == 0\n  return self\nend\nptr = @buffer\nhash.each do |k, v|\n  ptr.value = v\n  ptr = ptr + 1\nend\n(@buffer + @size).clear(removed)\nself\n"}},{"html_id":"unsafe_fetch(index:Int):T-instance-method","name":"unsafe_fetch","doc":"Returns the element at the given *index*, without doing any bounds check.\n\n`Indexable` makes sure to invoke this method with *index* in `0...size`,\nso converting negative indices to positive ones is not needed here.\n\nClients never invoke this method directly. Instead, they access\nelements with `#[](index)` and `#[]?(index)`.\n\nThis method should only be directly invoked if you are absolutely\nsure the index is in bounds, to avoid a bounds check for a small boost\nof performance.","summary":"<p>Returns the element at the given <em>index</em>, without doing any bounds check.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : T","args_html":"(index : <a href=\"Int.html\">Int</a>) : T","location":{"filename":"src/array.cr","line_number":670,"url":null},"def":{"name":"unsafe_fetch","args":[{"name":"index","external_name":"index","restriction":"Int"}],"return_type":"T","visibility":"Public","body":"@buffer[index]"}},{"html_id":"unsafe_put(index:Int,value:T)-instance-method","name":"unsafe_put","doc":"Sets the element at the given *index* to *value*, without doing any bounds\ncheck.\n\n`Indexable::Mutable` makes sure to invoke this method with *index* in\n`0...size`, so converting negative indices to positive ones is not needed\nhere.\n\nClients never invoke this method directly. Instead, they modify elements\nwith `#[]=(index, value)`.\n\nThis method should only be directly invoked if you are absolutely\nsure the index is in bounds, to avoid a bounds check for a small boost\nof performance.","summary":"<p>Sets the element at the given <em>index</em> to <em>value</em>, without doing any bounds check.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(index : Int, value : T)","args_html":"(index : <a href=\"Int.html\">Int</a>, value : T)","location":{"filename":"src/array.cr","line_number":675,"url":null},"def":{"name":"unsafe_put","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"@buffer[index] = value"}},{"html_id":"unshift(object:T):self-instance-method","name":"unshift","doc":"Prepend. Adds *object* to the beginning of `self`, given that the type of the value is *T*\n(which might be a single type or a union of types).\nThis method returns `self`, so several calls can be chained.\nSee `shift` for the opposite effect.\n\n```\na = [\"a\", \"b\"]\na.unshift(\"c\") # => [\"c\", \"a\", \"b\"]\na.unshift(1)   # Errors, because the array only accepts String.\n\na = [\"a\", \"b\"] of (Int32 | String)\na.unshift(\"c\") # => [\"c\", \"a\", \"b\"]\na.unshift(1)   # => [1, \"c\", \"a\", \"b\"]\n```","summary":"<p>Prepend.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":"T"}],"args_string":"(object : T) : self","args_html":"(object : T) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":1920,"url":null},"def":{"name":"unshift","args":[{"name":"object","external_name":"object","restriction":"T"}],"return_type":"self","visibility":"Public","body":"check_needs_resize_for_unshift\nshift_buffer_by(-1)\n@buffer.value = object\n@size = @size + 1\nself\n"}},{"html_id":"unshift(*values:T):self-instance-method","name":"unshift","doc":"Prepend multiple values. The same as `unshift`, but takes an arbitrary number\nof values to add to the array. Returns `self`.","summary":"<p>Prepend multiple values.</p>","abstract":false,"args":[{"name":"values","external_name":"values","restriction":"T"}],"args_string":"(*values : T) : self","args_html":"(*values : T) : <span class=\"k\">self</span>","location":{"filename":"src/array.cr","line_number":1931,"url":null},"def":{"name":"unshift","args":[{"name":"values","external_name":"values","restriction":"T"}],"splat_index":0,"return_type":"self","visibility":"Public","body":"values.reverse_each do |value|\n  unshift(value)\nend\nself\n"}},{"html_id":"unstable_sort:Array(T)-instance-method","name":"unstable_sort","doc":"Returns a new instance with all elements sorted based on the return value of\ntheir comparison method `T#<=>` (see `Comparable#<=>`), using an unstable sort algorithm.\n\n```\na = [3, 1, 2]\na.unstable_sort # => [1, 2, 3]\na               # => [3, 1, 2]\n```\n\nSee `Indexable::Mutable#unstable_sort!` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two elements returns `nil`.","summary":"<p>Returns a new instance with all elements sorted based on the return value of their comparison method <code>T#<=></code> (see <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">Comparable#<=></a></code>), using an unstable sort algorithm.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1567,"url":null},"def":{"name":"unstable_sort","return_type":"Array(T)","visibility":"Public","body":"dup.unstable_sort!"}},{"html_id":"unstable_sort(&block:T,T->U):Array(T)forallU-instance-method","name":"unstable_sort","doc":"Returns a new instance with all elements sorted based on the comparator in the\ngiven block, using an unstable sort algorithm.\n\n```\na = [3, 1, 2]\nb = a.unstable_sort { |a, b| b <=> a }\n\nb # => [3, 2, 1]\na # => [3, 1, 2]\n```\n\nSee `Indexable::Mutable#unstable_sort!(&block : T, T -> U)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if for any two elements the block returns `nil`.","summary":"<p>Returns a new instance with all elements sorted based on the comparator in the given block, using an unstable sort algorithm.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1607,"url":null},"def":{"name":"unstable_sort","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> U)"},"return_type":"Array(T)","visibility":"Public","body":"{% if U <= ::Union(Int32, ::Nil) %}{% else %}\n      {% raise(\"expected block to return Int32 or Nil, not #{U}\") %}\n    {% end %}\ndup.unstable_sort!(&block)\n"}},{"html_id":"unstable_sort!:self-instance-method","name":"unstable_sort!","doc":"Sorts all elements in `self` based on the return value of the comparison\nmethod `T#<=>` (see `Comparable#<=>`), using an unstable sort algorithm.\n\n```\na = [3, 1, 2]\na.unstable_sort!\na # => [1, 2, 3]\n```\n\nThis sort operation modifies `self`. See `#unstable_sort` for a non-modifying\noption that allocates a new instance.\n\nSee `Slice#unstable_sort!` for details on the implementation.\n\nRaises `ArgumentError` if the comparison between any two elements returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the return value of the comparison method <code>T#<=></code> (see <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">Comparable#<=></a></code>), using an unstable sort algorithm.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1622,"url":null},"def":{"name":"unstable_sort!","return_type":"self","visibility":"Public","body":"to_unsafe_slice.unstable_sort!\nself\n"}},{"html_id":"unstable_sort!(&block:T,T->U):selfforallU-instance-method","name":"unstable_sort!","doc":"Sorts all elements in `self` based on the comparator in the given block,\nusing an unstable sort algorithm.\n\nThe block must implement a comparison between two elements *a* and *b*,\nwhere `a < b` returns `-1`, `a == b` returns `0`, and `a > b` returns `1`.\nThe comparison operator `<=>` can be used for this.\n\n```\na = [3, 1, 2]\n# This is a reverse sort (forward sort would be `a <=> b`)\na.unstable_sort! { |a, b| b <=> a }\na # => [3, 2, 1]\n```\n\nThis sort operation modifies `self`. See `#unstable_sort(&block : T, T -> U)`\nfor a non-modifying option that allocates a new instance.\n\nSee `Slice#unstable_sort!(&block : T, T -> U)` for details on the implementation.\n\nRaises `ArgumentError` if for any two elements the block returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the comparator in the given block, using an unstable sort algorithm.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1638,"url":null},"def":{"name":"unstable_sort!","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> U)"},"return_type":"self","visibility":"Public","body":"{% if U <= ::Union(Int32, ::Nil) %}{% else %}\n      {% raise(\"expected block to return Int32 or Nil, not #{U}\") %}\n    {% end %}\nto_unsafe_slice.unstable_sort!(&block)\nself\n"}},{"html_id":"unstable_sort_by(&block:T->_):Array(T)-instance-method","name":"unstable_sort_by","doc":"Returns a new instance with all elements sorted by the output value of the\nblock. The output values are compared via the comparison method `#<=>`\n(see `Comparable#<=>`), using an unstable sort algorithm.\n\n```\na = %w(apple pear fig)\nb = a.unstable_sort_by { |word| word.size }\nb # => [\"fig\", \"pear\", \"apple\"]\na # => [\"apple\", \"pear\", \"fig\"]\n```\n\nIf stability is necessary, use `#sort_by(&block : T -> _)` instead.\n\nSee `Indexable::Mutable#unstable_sort!(&block : T -> _)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two comparison values returns `nil`.","summary":"<p>Returns a new instance with all elements sorted by the output value of the block.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1684,"url":null},"def":{"name":"unstable_sort_by","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> _)"},"return_type":"Array(T)","visibility":"Public","body":"dup.unstable_sort_by! do |e|\n  yield(e)\nend"}},{"html_id":"unstable_sort_by!(&block:T->_):Array(T)-instance-method","name":"unstable_sort_by!","doc":"Sorts all elements in `self` by the output value of the\nblock. The output values are compared via the comparison method `#<=>`\n(see `Comparable#<=>`), using an unstable sort algorithm.\n\n```\na = %w(apple pear fig)\na.usntable_sort_by! { |word| word.size }\na # => [\"fig\", \"pear\", \"apple\"]\n```\n\nThis sort operation modifies `self`. See `#unstable_sort_by(&block : T -> _)`\nfor a non-modifying option that allocates a new instance.\n\nIf stability is necessary, use  `#sort_by!(&block : T -> _)` instead.\n\nSee `#unstable_sort!(&block : T -> _)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two comparison values returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> by the output value of the block.</p>","abstract":false,"location":{"filename":"src/array.cr","line_number":1698,"url":null},"def":{"name":"unstable_sort_by!","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> _)"},"return_type":"Array(T)","visibility":"Public","body":"sorted = map do |e|\n  {e, yield(e)}\nend.unstable_sort! do |x, y|\n  x[1] <=> y[1]\nend\n@size.times do |i|\n  @buffer[i] = sorted.to_unsafe[i][0]\nend\nself\n"}},{"html_id":"|(other:Array(U))forallU-instance-method","name":"|","doc":"Set union: returns a new `Array` by joining `self` with *other*, excluding\nany duplicates, and preserving the order from `self`.\n\n```\n[\"a\", \"b\", \"c\"] | [\"c\", \"d\", \"a\"] # => [ \"a\", \"b\", \"c\", \"d\" ]\n```\n\nSee also: `#uniq`.","summary":"<p>Set union: returns a new <code><a href=\"Array.html\">Array</a></code> by joining <code>self</code> with <em>other</em>, excluding any duplicates, and preserving the order from <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Array(U)"}],"args_string":"(other : Array(U)) forall U","args_html":"(other : <a href=\"Array.html\">Array</a>(U)) forall U","location":{"filename":"src/array.cr","line_number":293,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Array(U)"}],"visibility":"Public","body":"if (size + other.size) <= SMALL_ARRAY_SIZE\n  ary = Array(T | U).new\n  each do |elem|\n    if ary.includes?(elem)\n    else\n      ary << elem\n    end\n  end\n  other.each do |elem|\n    if ary.includes?(elem)\n    else\n      ary << elem\n    end\n  end\n  return ary\nend\nArray(T | U).build(size + other.size) do |buffer|\n  hash = Hash(T, Bool).new\n  i = 0\n  each do |obj|\n    if hash.has_key?(obj)\n    else\n      buffer[i] = obj\n      hash[obj] = true\n      i = i + 1\n    end\n  end\n  other.each do |obj|\n    if hash.has_key?(obj)\n    else\n      buffer[i] = obj\n      hash[obj] = true\n      i = i + 1\n    end\n  end\n  i\nend\n"}}]},{"html_id":"Crystal/Atomic","path":"Atomic.html","kind":"struct","full_name":"Atomic(T)","name":"Atomic","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/atomic.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"A value that may be updated atomically.\n\nOnly primitive integer types, reference types or nilable reference types\ncan be used with an Atomic type.","summary":"<p>A value that may be updated atomically.</p>","constructors":[{"html_id":"new(value:T)-class-method","name":"new","doc":"Creates an Atomic with the given initial value.","summary":"<p>Creates an Atomic with the given initial value.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T)","args_html":"(value : T)","location":{"filename":"src/atomic.cr","line_number":7,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"_ = Atomic(T).allocate\n_.initialize(value)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"add(value:T):T-instance-method","name":"add","doc":"Performs `atomic_value += value`. Returns the old value.\n\n```\natomic = Atomic.new(1)\natomic.add(2) # => 1\natomic.get    # => 3\n```","summary":"<p>Performs <code>atomic_value += value</code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T) : T","args_html":"(value : T) : T","location":{"filename":"src/atomic.cr","line_number":55,"url":null},"def":{"name":"add","args":[{"name":"value","external_name":"value","restriction":"T"}],"return_type":"T","visibility":"Public","body":"Ops.atomicrmw(:add, pointerof(@value), value, :sequentially_consistent, false)"}},{"html_id":"and(value:T):T-instance-method","name":"and","doc":"Performs `atomic_value &= value`. Returns the old value.\n\n```\natomic = Atomic.new(5)\natomic.and(3) # => 5\natomic.get    # => 1\n```","summary":"<p>Performs <code>atomic_value &= value</code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T) : T","args_html":"(value : T) : T","location":{"filename":"src/atomic.cr","line_number":77,"url":null},"def":{"name":"and","args":[{"name":"value","external_name":"value","restriction":"T"}],"return_type":"T","visibility":"Public","body":"Ops.atomicrmw(:and, pointerof(@value), value, :sequentially_consistent, false)"}},{"html_id":"compare_and_set(cmp:T,new:T):Tuple(T,Bool)-instance-method","name":"compare_and_set","doc":"Compares this atomic's value with *cmp*:\n\n* if they are equal, sets the value to *new*, and returns `{old_value, true}`\n* if they are not equal the value remains the same, and returns `{old_value, false}`\n\n```\natomic = Atomic.new(1)\n\natomic.compare_and_set(2, 3) # => {1, false}\natomic.get                   # => 1\n\natomic.compare_and_set(1, 3) # => {1, true}\natomic.get                   # => 3\n```","summary":"<p>Compares this atomic's value with <em>cmp</em>:</p>","abstract":false,"args":[{"name":"cmp","external_name":"cmp","restriction":"T"},{"name":"new","external_name":"new","restriction":"T"}],"args_string":"(cmp : T, new : T) : Tuple(T, Bool)","args_html":"(cmp : T, new : T) : <a href=\"Tuple.html\">Tuple</a>(T, <a href=\"Bool.html\">Bool</a>)","location":{"filename":"src/atomic.cr","line_number":31,"url":null},"def":{"name":"compare_and_set","args":[{"name":"cmp","external_name":"cmp","restriction":"T"},{"name":"new","external_name":"new","restriction":"T"}],"return_type":"::Tuple(T, Bool)","visibility":"Public","body":"{% if T.union? && T.union_types.all? do |t|\n  (t == Nil) || t < Reference\nend %}\n      # If so, use addresses because LLVM < 3.9 doesn't support cmpxchg with pointers\n      address, success = Ops.cmpxchg(pointerof(@value).as(LibC::SizeT*), LibC::SizeT.new(cmp.as(T).object_id), LibC::SizeT.new(new.as(T).object_id), :sequentially_consistent, :sequentially_consistent)\n      {address == 0 ? nil : Pointer(T).new(address).as(T), success}\n      # Check if it's a reference type\n    {% else %}{% if T < Reference %}\n      # Use addresses again (but this can't return nil)\n      address, success = Ops.cmpxchg(pointerof(@value).as(LibC::SizeT*), LibC::SizeT.new(cmp.as(T).object_id), LibC::SizeT.new(new.as(T).object_id), :sequentially_consistent, :sequentially_consistent)\n      {Pointer(T).new(address).as(T), success}\n    {% else %}\n      # Otherwise, this is an integer type\n      Ops.cmpxchg(pointerof(@value), cmp, new, :sequentially_consistent, :sequentially_consistent)\n    {% end %}{% end %}"}},{"html_id":"get:T-instance-method","name":"get","doc":"Atomically returns this atomic's value.","summary":"<p>Atomically returns this atomic's value.</p>","abstract":false,"location":{"filename":"src/atomic.cr","line_number":191,"url":null},"def":{"name":"get","return_type":"T","visibility":"Public","body":"Ops.load(pointerof(@value), :sequentially_consistent, true)"}},{"html_id":"lazy_get-instance-method","name":"lazy_get","doc":"**Non-atomically** returns this atomic's value.","summary":"<p><strong>Non-atomically</strong> returns this atomic's value.</p>","abstract":false,"location":{"filename":"src/atomic.cr","line_number":196,"url":null},"def":{"name":"lazy_get","visibility":"Public","body":"@value"}},{"html_id":"lazy_set(value:T):T-instance-method","name":"lazy_set","doc":"**Non-atomically** sets this atomic's value to *value*. Returns the **new** value.\n\n```\natomic = Atomic.new(5)\natomic.lazy_set(10) # => 10\natomic.get          # => 10\n```","summary":"<p><strong>Non-atomically</strong> sets this atomic's value to <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T) : T","args_html":"(value : T) : T","location":{"filename":"src/atomic.cr","line_number":187,"url":null},"def":{"name":"lazy_set","args":[{"name":"value","external_name":"value","restriction":"T"}],"return_type":"T","visibility":"Public","body":"@value = value"}},{"html_id":"max(value:T)-instance-method","name":"max","doc":"Performs `atomic_value = max(atomic_value, value)`. Returns the old value.\n\n```\natomic = Atomic.new(5)\n\natomic.max(3) # => 5\natomic.get    # => 5\n\natomic.max(10) # => 5\natomic.get     # => 10\n```","summary":"<p>Performs <code>atomic_value = max(atomic_value, value)</code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T)","args_html":"(value : T)","location":{"filename":"src/atomic.cr","line_number":125,"url":null},"def":{"name":"max","args":[{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"{% if T < Int::Signed %}\n      Ops.atomicrmw(:max, pointerof(@value), value, :sequentially_consistent, false)\n    {% else %}\n      Ops.atomicrmw(:umax, pointerof(@value), value, :sequentially_consistent, false)\n    {% end %}"}},{"html_id":"min(value:T)-instance-method","name":"min","doc":"Performs `atomic_value = min(atomic_value, value)`. Returns the old value.\n\n```\natomic = Atomic.new(5)\n\natomic.min(10) # => 5\natomic.get     # => 5\n\natomic.min(3) # => 5\natomic.get    # => 3\n```","summary":"<p>Performs <code>atomic_value = min(atomic_value, value)</code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T)","args_html":"(value : T)","location":{"filename":"src/atomic.cr","line_number":144,"url":null},"def":{"name":"min","args":[{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"{% if T < Int::Signed %}\n      Ops.atomicrmw(:min, pointerof(@value), value, :sequentially_consistent, false)\n    {% else %}\n      Ops.atomicrmw(:umin, pointerof(@value), value, :sequentially_consistent, false)\n    {% end %}"}},{"html_id":"nand(value:T):T-instance-method","name":"nand","doc":"Performs `atomic_value = ~(atomic_value & value)`. Returns the old value.\n\n```\natomic = Atomic.new(5)\natomic.nand(3) # => 5\natomic.get     # => -2\n```","summary":"<p>Performs <code>atomic_value = ~(atomic_value & value)</code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T) : T","args_html":"(value : T) : T","location":{"filename":"src/atomic.cr","line_number":88,"url":null},"def":{"name":"nand","args":[{"name":"value","external_name":"value","restriction":"T"}],"return_type":"T","visibility":"Public","body":"Ops.atomicrmw(:nand, pointerof(@value), value, :sequentially_consistent, false)"}},{"html_id":"or(value:T):T-instance-method","name":"or","doc":"Performs `atomic_value |= value`. Returns the old value.\n\n```\natomic = Atomic.new(5)\natomic.or(2) # => 5\natomic.get   # => 7\n```","summary":"<p>Performs <code>atomic_value |= value</code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T) : T","args_html":"(value : T) : T","location":{"filename":"src/atomic.cr","line_number":99,"url":null},"def":{"name":"or","args":[{"name":"value","external_name":"value","restriction":"T"}],"return_type":"T","visibility":"Public","body":"Ops.atomicrmw(:or, pointerof(@value), value, :sequentially_consistent, false)"}},{"html_id":"set(value:T):T-instance-method","name":"set","doc":"Atomically sets this atomic's value to *value*. Returns the **new** value.\n\n```\natomic = Atomic.new(5)\natomic.set(10) # => 10\natomic.get     # => 10\n```","summary":"<p>Atomically sets this atomic's value to <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T) : T","args_html":"(value : T) : T","location":{"filename":"src/atomic.cr","line_number":175,"url":null},"def":{"name":"set","args":[{"name":"value","external_name":"value","restriction":"T"}],"return_type":"T","visibility":"Public","body":"Ops.store(pointerof(@value), value.as(T), :sequentially_consistent, true)\nvalue\n"}},{"html_id":"sub(value:T):T-instance-method","name":"sub","doc":"Performs `atomic_value -= value`. Returns the old value.\n\n```\natomic = Atomic.new(9)\natomic.sub(2) # => 9\natomic.get    # => 7\n```","summary":"<p>Performs <code>atomic_value -= value</code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T) : T","args_html":"(value : T) : T","location":{"filename":"src/atomic.cr","line_number":66,"url":null},"def":{"name":"sub","args":[{"name":"value","external_name":"value","restriction":"T"}],"return_type":"T","visibility":"Public","body":"Ops.atomicrmw(:sub, pointerof(@value), value, :sequentially_consistent, false)"}},{"html_id":"swap(value:T)-instance-method","name":"swap","doc":"Atomically sets this atomic's value to *value*. Returns the **old** value.\n\n```\natomic = Atomic.new(5)\natomic.swap(10) # => 5\natomic.get      # => 10\n```","summary":"<p>Atomically sets this atomic's value to <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T)","args_html":"(value : T)","location":{"filename":"src/atomic.cr","line_number":159,"url":null},"def":{"name":"swap","args":[{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"{% if (T.union? && T.union_types.all? do |t|\n  (t == Nil) || t < Reference\nend) || T < Reference %}\n      address = Ops.atomicrmw(:xchg, pointerof(@value).as(LibC::SizeT*), LibC::SizeT.new(value.as(T).object_id), :sequentially_consistent, false)\n      Pointer(T).new(address).as(T)\n    {% else %}\n      Ops.atomicrmw(:xchg, pointerof(@value), value, :sequentially_consistent, false)\n    {% end %}"}},{"html_id":"xor(value:T):T-instance-method","name":"xor","doc":"Performs `atomic_value ^= value`. Returns the old value.\n\n```\natomic = Atomic.new(5)\natomic.xor(3) # => 5\natomic.get    # => 6\n```","summary":"<p>Performs <code>atomic_value ^= value</code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T) : T","args_html":"(value : T) : T","location":{"filename":"src/atomic.cr","line_number":110,"url":null},"def":{"name":"xor","args":[{"name":"value","external_name":"value","restriction":"T"}],"return_type":"T","visibility":"Public","body":"Ops.atomicrmw(:xor, pointerof(@value), value, :sequentially_consistent, false)"}}],"types":[{"html_id":"Crystal/Atomic/Flag","path":"Atomic/Flag.html","kind":"struct","full_name":"Atomic::Flag","name":"Flag","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/atomic.cr","line_number":239,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Atomic","kind":"struct","full_name":"Atomic(T)","name":"Atomic"},"doc":"An atomic flag, that can be set or not.\n\nConcurrency safe. If many fibers try to set the atomic in parallel, only one\nwill succeed.\n\nExample:\n```\nflag = Atomic::Flag.new\nflag.test_and_set # => true\nflag.test_and_set # => false\nflag.clear\nflag.test_and_set # => true\n```","summary":"<p>An atomic flag, that can be set or not.</p>","constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/atomic.cr","line_number":240,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"clear:Nil-instance-method","name":"clear","doc":"Atomically clears the flag.","summary":"<p>Atomically clears the flag.</p>","abstract":false,"location":{"filename":"src/atomic.cr","line_number":251,"url":null},"def":{"name":"clear","return_type":"Nil","visibility":"Public","body":"Atomic::Ops.store(pointerof(@value), 0_u8, :sequentially_consistent, true)"}},{"html_id":"test_and_set:Bool-instance-method","name":"test_and_set","doc":"Atomically tries to set the flag. Only succeeds and returns `true` if the\nflag wasn't previously set; returns `false` otherwise.","summary":"<p>Atomically tries to set the flag.</p>","abstract":false,"location":{"filename":"src/atomic.cr","line_number":246,"url":null},"def":{"name":"test_and_set","return_type":"Bool","visibility":"Public","body":"(Atomic::Ops.atomicrmw(:xchg, pointerof(@value), 1_u8, :sequentially_consistent, false)) == 0_u8"}}]}]},{"html_id":"Crystal/Base64","path":"Base64.html","kind":"module","full_name":"Base64","name":"Base64","abstract":false,"locations":[{"filename":"src/base64.cr","line_number":18,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"extended_modules":[{"html_id":"Crystal/Base64","kind":"module","full_name":"Base64","name":"Base64"}],"doc":"The `Base64` module provides for the encoding (`encode`, `strict_encode`,\n`urlsafe_encode`) and decoding (`decode`)\nof binary data using a base64 representation.\n\n### Example\n\nA simple encoding and decoding.\n\n```\nrequire \"base64\"\n\nenc = Base64.encode(\"Send reinforcements\") # => \"U2VuZCByZWluZm9yY2VtZW50cw==\\n\"\nplain = Base64.decode_string(enc)          # => \"Send reinforcements\"\n```\n\nThe purpose of using base64 to encode data is that it translates any binary\ndata into purely printable characters.","summary":"<p>The <code><a href=\"Base64.html\">Base64</a></code> module provides for the encoding (<code><a href=\"Base64.html#encode%28data%2Cio%3AIO%29-instance-method\">#encode</a></code>, <code><a href=\"Base64.html#strict_encode%28data%2Cio%3AIO%29-instance-method\">#strict_encode</a></code>, <code><a href=\"Base64.html#urlsafe_encode%28data%2Cio%3AIO%29-instance-method\">#urlsafe_encode</a></code>) and decoding (<code><a href=\"Base64.html#decode%28data%2Cio%3AIO%29-instance-method\">#decode</a></code>) of binary data using a base64 representation.</p>","instance_methods":[{"html_id":"decode(data,io:IO)-instance-method","name":"decode","doc":"Writes the base64-decoded version of *data* to *io*.\nThis will decode either the normal or urlsafe alphabets.","summary":"<p>Writes the base64-decoded version of <em>data</em> to <em>io</em>.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(data, io : IO)","args_html":"(data, io : <a href=\"IO.html\">IO</a>)","location":{"filename":"src/base64.cr","line_number":171,"url":null},"def":{"name":"decode","args":[{"name":"data","external_name":"data","restriction":""},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"count = 0\nfrom_base64(data.to_slice) do |byte|\n  io.write_byte(byte)\n  count = count + 1\nend\nio.flush\ncount\n"}},{"html_id":"decode(data):Bytes-instance-method","name":"decode","doc":"Returns the base64-decoded version of *data* as a `Bytes`.\nThis will decode either the normal or urlsafe alphabets.","summary":"<p>Returns the base64-decoded version of <em>data</em> as a <code><a href=\"Bytes.html\">Bytes</a></code>.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""}],"args_string":"(data) : Bytes","args_html":"(data) : <a href=\"Bytes.html\">Bytes</a>","location":{"filename":"src/base64.cr","line_number":161,"url":null},"def":{"name":"decode","args":[{"name":"data","external_name":"data","restriction":""}],"return_type":"Bytes","visibility":"Public","body":"slice = data.to_slice\nbuf = Pointer(UInt8).malloc(decode_size(slice.size))\nappender = buf.appender\nfrom_base64(slice) do |byte|\n  appender << byte\nend\nSlice.new(buf, appender.size.to_i32)\n"}},{"html_id":"decode_string(data):String-instance-method","name":"decode_string","doc":"Returns the base64-decoded version of *data* as a string.\nThis will decode either the normal or urlsafe alphabets.","summary":"<p>Returns the base64-decoded version of <em>data</em> as a string.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""}],"args_string":"(data) : String","args_html":"(data) : <a href=\"String.html\">String</a>","location":{"filename":"src/base64.cr","line_number":183,"url":null},"def":{"name":"decode_string","args":[{"name":"data","external_name":"data","restriction":""}],"return_type":"String","visibility":"Public","body":"slice = data.to_slice\nString.new(decode_size(slice.size)) do |buf|\n  appender = buf.appender\n  from_base64(slice) do |byte|\n    appender << byte\n  end\n  {appender.size, 0}\nend\n"}},{"html_id":"encode(data,io:IO)-instance-method","name":"encode","doc":"Writes the base64-encoded version of *data* to *io*.\nThis method complies with [RFC 2045](https://tools.ietf.org/html/rfc2045).\nLine feeds are added to every 60 encoded characters.\n\n```\nBase64.encode(\"Now is the time for all good coders\\nto learn Crystal\", STDOUT)\n```","summary":"<p>Writes the base64-encoded version of <em>data</em> to <em>io</em>.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(data, io : IO)","args_html":"(data, io : <a href=\"IO.html\">IO</a>)","location":{"filename":"src/base64.cr","line_number":61,"url":null},"def":{"name":"encode","args":[{"name":"data","external_name":"data","restriction":""},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"count = 0\nencode_with_new_lines(data.to_slice) do |byte|\n  io << byte.unsafe_chr\n  count = count + 1\nend\nio.flush\ncount\n"}},{"html_id":"encode(data):String-instance-method","name":"encode","doc":"Returns the base64-encoded version of *data*.\nThis method complies with [RFC 2045](https://tools.ietf.org/html/rfc2045).\nLine feeds are added to every 60 encoded characters.\n\n```\nputs Base64.encode(\"Now is the time for all good coders\\nto learn Crystal\")\n```\n\nGenerates:\n\n```text\nTm93IGlzIHRoZSB0aW1lIGZvciBhbGwgZ29vZCBjb2RlcnMKdG8gbGVhcm4g\nQ3J5c3RhbA==\n```","summary":"<p>Returns the base64-encoded version of <em>data</em>.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""}],"args_string":"(data) : String","args_html":"(data) : <a href=\"String.html\">String</a>","location":{"filename":"src/base64.cr","line_number":44,"url":null},"def":{"name":"encode","args":[{"name":"data","external_name":"data","restriction":""}],"return_type":"String","visibility":"Public","body":"slice = data.to_slice\nString.new(encode_size(slice.size, new_lines: true)) do |buf|\n  appender = buf.appender\n  encode_with_new_lines(slice) do |byte|\n    appender << byte\n  end\n  size = appender.size\n  {size, size}\nend\n"}},{"html_id":"strict_encode(data,io:IO)-instance-method","name":"strict_encode","doc":"Writes the base64-encoded version of *data* with no newlines to *io*.\nThis method complies with [RFC 4648](https://tools.ietf.org/html/rfc4648).\n\n```\nBase64.strict_encode(\"Now is the time for all good coders\\nto learn Crystal\", STDOUT)\n```","summary":"<p>Writes the base64-encoded version of <em>data</em> with no newlines to <em>io</em>.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(data, io : IO)","args_html":"(data, io : <a href=\"IO.html\">IO</a>)","location":{"filename":"src/base64.cr","line_number":118,"url":null},"def":{"name":"strict_encode","args":[{"name":"data","external_name":"data","restriction":""},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"strict_encode_to_io_internal(data, io, CHARS_STD, pad: true)"}},{"html_id":"strict_encode(data):String-instance-method","name":"strict_encode","doc":"Returns the base64-encoded version of *data* with no newlines.\nThis method complies with [RFC 4648](https://tools.ietf.org/html/rfc4648).\n\n```\nputs Base64.strict_encode(\"Now is the time for all good coders\\nto learn Crystal\")\n```\n\nGenerates:\n\n```text\nTm93IGlzIHRoZSB0aW1lIGZvciBhbGwgZ29vZCBjb2RlcnMKdG8gbGVhcm4gQ3J5c3RhbA==\n```","summary":"<p>Returns the base64-encoded version of <em>data</em> with no newlines.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""}],"args_string":"(data) : String","args_html":"(data) : <a href=\"String.html\">String</a>","location":{"filename":"src/base64.cr","line_number":98,"url":null},"def":{"name":"strict_encode","args":[{"name":"data","external_name":"data","restriction":""}],"return_type":"String","visibility":"Public","body":"strict_encode(data, CHARS_STD, pad: true)"}},{"html_id":"urlsafe_encode(data,io:IO)-instance-method","name":"urlsafe_encode","doc":"Writes the base64-encoded version of *data* using a urlsafe alphabet to *io*.\nThis method complies with \"Base 64 Encoding with URL and Filename Safe\nAlphabet\" in [RFC 4648](https://tools.ietf.org/html/rfc4648).\n\nThe alphabet uses `'-'` instead of `'+'` and `'_'` instead of `'/'`.","summary":"<p>Writes the base64-encoded version of <em>data</em> using a urlsafe alphabet to <em>io</em>.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(data, io : IO)","args_html":"(data, io : <a href=\"IO.html\">IO</a>)","location":{"filename":"src/base64.cr","line_number":155,"url":null},"def":{"name":"urlsafe_encode","args":[{"name":"data","external_name":"data","restriction":""},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"strict_encode_to_io_internal(data, io, CHARS_SAFE, pad: true)"}},{"html_id":"urlsafe_encode(data,padding=true):String-instance-method","name":"urlsafe_encode","doc":"Returns the base64-encoded version of *data* using a urlsafe alphabet.\nThis method complies with \"Base 64 Encoding with URL and Filename Safe\nAlphabet\" in [RFC 4648](https://tools.ietf.org/html/rfc4648).\n\nThe alphabet uses `'-'` instead of `'+'` and `'_'` instead of `'/'`.\n\nThe *padding* parameter defaults to `true`. When `false`, enough `=` characters\nare not added to make the output divisible by 4.","summary":"<p>Returns the base64-encoded version of <em>data</em> using a urlsafe alphabet.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""},{"name":"padding","default_value":"true","external_name":"padding","restriction":""}],"args_string":"(data, padding = true) : String","args_html":"(data, padding = <span class=\"n\">true</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/base64.cr","line_number":140,"url":null},"def":{"name":"urlsafe_encode","args":[{"name":"data","external_name":"data","restriction":""},{"name":"padding","default_value":"true","external_name":"padding","restriction":""}],"return_type":"String","visibility":"Public","body":"slice = data.to_slice\nString.new(encode_size(slice.size)) do |buf|\n  appender = buf.appender\n  to_base64(slice, CHARS_SAFE, pad: padding) do |byte|\n    appender << byte\n  end\n  size = appender.size\n  {size, size}\nend\n"}}],"types":[{"html_id":"Crystal/Base64/Error","path":"Base64/Error.html","kind":"class","full_name":"Base64::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/base64.cr","line_number":21,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Base64","kind":"module","full_name":"Base64","name":"Base64"}}]},{"html_id":"Crystal/Benchmark","path":"Benchmark.html","kind":"module","full_name":"Benchmark","name":"Benchmark","abstract":false,"locations":[{"filename":"src/benchmark.cr","line_number":85,"url":null},{"filename":"src/benchmark/bm.cr","line_number":1,"url":null},{"filename":"src/benchmark/ips.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"extended_modules":[{"html_id":"Crystal/Benchmark","kind":"module","full_name":"Benchmark","name":"Benchmark"}],"doc":"The Benchmark module provides methods for benchmarking Crystal code, giving\ndetailed reports on the time and memory taken for each task.\n\n### Measure the number of iterations per second of each task\n\n```\nrequire \"benchmark\"\n\nBenchmark.ips do |x|\n  x.report(\"short sleep\") { sleep 0.01 }\n  x.report(\"shorter sleep\") { sleep 0.001 }\nend\n```\n\nThis generates the following output showing the mean iterations per second,\nthe mean times per iteration, the standard deviation relative to the mean, and a comparison:\n\n```text\n  short sleep   88.7  ( 11.27ms) (± 3.33%)  8.90× slower\nshorter sleep  789.7  (  1.27ms) (± 3.02%)       fastest\n```\n\n`Benchmark::IPS` defaults to 2 seconds of warmup time and 5 seconds of\ncalculation time. This can be configured:\n\n```\nrequire \"benchmark\"\n\nBenchmark.ips(warmup: 4, calculation: 10) do |x|\n  x.report(\"sleep\") { sleep 0.01 }\nend\n```\n\nMake sure to always benchmark code by compiling with the `--release` flag.\n\n### Measure the time to construct the string given by the expression: `\"a\"*1_000_000_000`\n\n```\nrequire \"benchmark\"\n\nputs Benchmark.measure { \"a\"*1_000_000_000 }\n```\n\nThis generates the following output:\n\n```text\n 0.190000   0.220000   0.410000 (  0.420185)\n```\n\nThis report shows the user CPU time, system CPU time, the sum of\nthe user and system CPU times, and the elapsed real time. The unit\nof time is seconds.\n\n### Do some experiments sequentially using the `#bm` method:\n\n```\nrequire \"benchmark\"\n\nn = 5000000\nBenchmark.bm do |x|\n  x.report(\"times:\") do\n    n.times do\n      a = \"1\"\n    end\n  end\n  x.report(\"upto:\") do\n    1.upto(n) do\n      a = \"1\"\n    end\n  end\nend\n```\n\nThe result:\n\n```text\n           user     system      total        real\ntimes:   0.010000   0.000000   0.010000 (  0.008976)\nupto:    0.010000   0.000000   0.010000 (  0.010466)\n```\n\nMake sure to always benchmark code by compiling with the `--release` flag.","summary":"<p>The Benchmark module provides methods for benchmarking Crystal code, giving detailed reports on the time and memory taken for each task.</p>","instance_methods":[{"html_id":"bm(&)-instance-method","name":"bm","doc":"Main interface of the `Benchmark` module. Yields a `Job` to which\none can report the benchmarks. See the module's description.","summary":"<p>Main interface of the <code><a href=\"Benchmark.html\">Benchmark</a></code> module.</p>","abstract":false,"location":{"filename":"src/benchmark.cr","line_number":90,"url":null},"def":{"name":"bm","yields":1,"visibility":"Public","body":"{% if !(flag?(:release)) %}\n      puts \"Warning: benchmarking without the `--release` flag won't yield useful results\"\n    {% end %}\nreport = BM::Job.new\nyield report\nreport.execute\nreport\n"}},{"html_id":"ips(calculation=5,warmup=2,interactive=STDOUT.tty?,&)-instance-method","name":"ips","doc":"Instruction per second interface of the `Benchmark` module. Yields a `Job`\nto which one can report the benchmarks. See the module's description.\n\nThe optional parameters *calculation* and *warmup* set the duration of\nthose stages in seconds. For more detail on these stages see\n`Benchmark::IPS`. When the *interactive* parameter is `true`, results are\ndisplayed and updated as they are calculated, otherwise all at once.","summary":"<p>Instruction per second interface of the <code><a href=\"Benchmark.html\">Benchmark</a></code> module.</p>","abstract":false,"args":[{"name":"calculation","default_value":"5","external_name":"calculation","restriction":""},{"name":"warmup","default_value":"2","external_name":"warmup","restriction":""},{"name":"interactive","default_value":"STDOUT.tty?","external_name":"interactive","restriction":""}],"args_string":"(calculation = 5, warmup = 2, interactive = STDOUT.tty?, &)","args_html":"(calculation = <span class=\"n\">5</span>, warmup = <span class=\"n\">2</span>, interactive = <span class=\"t\">STDOUT</span>.tty?, &)","location":{"filename":"src/benchmark.cr","line_number":108,"url":null},"def":{"name":"ips","args":[{"name":"calculation","default_value":"5","external_name":"calculation","restriction":""},{"name":"warmup","default_value":"2","external_name":"warmup","restriction":""},{"name":"interactive","default_value":"STDOUT.tty?","external_name":"interactive","restriction":""}],"yields":1,"visibility":"Public","body":"{% if !(flag?(:release)) %}\n      puts \"Warning: benchmarking without the `--release` flag won't yield useful results\"\n    {% end %}\njob = IPS::Job.new(calculation, warmup, interactive)\nyield job\njob.execute\njob.report\njob\n"}},{"html_id":"measure(label=\"\",&):BM::Tms-instance-method","name":"measure","doc":"Returns the time used to execute the given block.","summary":"<p>Returns the time used to execute the given block.</p>","abstract":false,"args":[{"name":"label","default_value":"\"\"","external_name":"label","restriction":""}],"args_string":"(label = \"\", &) : BM::Tms","args_html":"(label = <span class=\"s\">&quot;&quot;</span>, &) : <a href=\"Benchmark/BM/Tms.html\">BM::Tms</a>","location":{"filename":"src/benchmark.cr","line_number":121,"url":null},"def":{"name":"measure","args":[{"name":"label","default_value":"\"\"","external_name":"label","restriction":""}],"yields":0,"return_type":"BM::Tms","visibility":"Public","body":"t0, r0 = Process.times, Time.monotonic\nyield\nt1, r1 = Process.times, Time.monotonic\nBM::Tms.new(t1.utime - t0.utime, t1.stime - t0.stime, t1.cutime - t0.cutime, t1.cstime - t0.cstime, (r1 - r0).total_seconds, label)\n"}},{"html_id":"memory(&)-instance-method","name":"memory","doc":"Returns the memory in bytes that the given block consumes.\n\n```\nBenchmark.memory { Array(Int32).new } # => 32\n```","summary":"<p>Returns the memory in bytes that the given block consumes.</p>","abstract":false,"location":{"filename":"src/benchmark.cr","line_number":147,"url":null},"def":{"name":"memory","yields":0,"visibility":"Public","body":"bytes_before_measure = GC.stats.total_bytes\nyield\n(GC.stats.total_bytes - bytes_before_measure).to_i64\n"}},{"html_id":"realtime(&):Time::Span-instance-method","name":"realtime","doc":"Returns the elapsed real time used to execute the given block.\n\n```\nBenchmark.realtime { \"a\" * 100_000 } # => 00:00:00.0005840\n```","summary":"<p>Returns the elapsed real time used to execute the given block.</p>","abstract":false,"location":{"filename":"src/benchmark.cr","line_number":138,"url":null},"def":{"name":"realtime","yields":0,"return_type":"Time::Span","visibility":"Public","body":"Time.measure do\n  yield\nend"}}],"types":[{"html_id":"Crystal/Benchmark/BM","path":"Benchmark/BM.html","kind":"module","full_name":"Benchmark::BM","name":"BM","abstract":false,"locations":[{"filename":"src/benchmark/bm.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Benchmark","kind":"module","full_name":"Benchmark","name":"Benchmark"},"types":[{"html_id":"Crystal/Benchmark/BM/Job","path":"Benchmark/BM/Job.html","kind":"class","full_name":"Benchmark::BM::Job","name":"Job","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/benchmark/bm.cr","line_number":39,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Benchmark/BM","kind":"module","full_name":"Benchmark::BM","name":"BM"},"doc":"Yielded by `Benchmark#bm`, use `#report` to report benchmarks.","summary":"<p>Yielded by <code><a href=\"../../Benchmark.html#bm%28%26%29-instance-method\">Benchmark#bm</a></code>, use <code><a href=\"../../Benchmark/BM/Job.html#report%28label%3D%22%22%2C%26block%29-instance-method\">#report</a></code> to report benchmarks.</p>","instance_methods":[{"html_id":"report(label=\"\",&block)-instance-method","name":"report","doc":"Reports a single benchmark unit.","summary":"<p>Reports a single benchmark unit.</p>","abstract":false,"args":[{"name":"label","default_value":"\" \"","external_name":"label","restriction":""}],"args_string":"(label = \" \", &block)","args_html":"(label = <span class=\"s\">&quot; &quot;</span>, &block)","location":{"filename":"src/benchmark/bm.cr","line_number":47,"url":null},"def":{"name":"report","args":[{"name":"label","default_value":"\" \"","external_name":"label","restriction":""}],"yields":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"if label.size > @label_width\n  @label_width = label.size\nend\n@reports << {label, block}\n"}}]},{"html_id":"Crystal/Benchmark/BM/Tms","path":"Benchmark/BM/Tms.html","kind":"class","full_name":"Benchmark::BM::Tms","name":"Tms","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/benchmark/bm.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Benchmark/BM","kind":"module","full_name":"Benchmark::BM","name":"BM"},"doc":"A data object, representing the times associated with a benchmark measurement.","summary":"<p>A data object, representing the times associated with a benchmark measurement.</p>","instance_methods":[{"html_id":"cstime:Float64-instance-method","name":"cstime","doc":"System CPU time of children","summary":"<p>System CPU time of children</p>","abstract":false,"location":{"filename":"src/benchmark/bm.cr","line_number":15,"url":null},"def":{"name":"cstime","return_type":"Float64","visibility":"Public","body":"@cstime"}},{"html_id":"cutime:Float64-instance-method","name":"cutime","doc":"User CPU time of children","summary":"<p>User CPU time of children</p>","abstract":false,"location":{"filename":"src/benchmark/bm.cr","line_number":12,"url":null},"def":{"name":"cutime","return_type":"Float64","visibility":"Public","body":"@cutime"}},{"html_id":"label:String-instance-method","name":"label","doc":"The label associated with this measure","summary":"<p>The label associated with this measure</p>","abstract":false,"location":{"filename":"src/benchmark/bm.cr","line_number":21,"url":null},"def":{"name":"label","return_type":"String","visibility":"Public","body":"@label"}},{"html_id":"real:Float64-instance-method","name":"real","doc":"Elapsed real time","summary":"<p>Elapsed real time</p>","abstract":false,"location":{"filename":"src/benchmark/bm.cr","line_number":18,"url":null},"def":{"name":"real","return_type":"Float64","visibility":"Public","body":"@real"}},{"html_id":"stime:Float64-instance-method","name":"stime","doc":"System CPU time","summary":"<p>System CPU time</p>","abstract":false,"location":{"filename":"src/benchmark/bm.cr","line_number":9,"url":null},"def":{"name":"stime","return_type":"Float64","visibility":"Public","body":"@stime"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Prints *utime*, *stime*, *total* and *real* to the given IO.","summary":"<p>Prints <em>utime</em>, <em>stime</em>, <em>total</em> and <em>real</em> to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../../IO.html\">IO</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/benchmark/bm.cr","line_number":33,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io.printf(\"  %.6f   %.6f   %.6f (  %.6f)\", utime, stime, total, real)"}},{"html_id":"total:Float64-instance-method","name":"total","doc":"Total time, that is utime + stime + cutime + cstime","summary":"<p>Total time, that is utime + stime + cutime + cstime</p>","abstract":false,"location":{"filename":"src/benchmark/bm.cr","line_number":28,"url":null},"def":{"name":"total","return_type":"Float64","visibility":"Public","body":"((utime + stime) + cutime) + cstime"}},{"html_id":"utime:Float64-instance-method","name":"utime","doc":"User CPU time","summary":"<p>User CPU time</p>","abstract":false,"location":{"filename":"src/benchmark/bm.cr","line_number":6,"url":null},"def":{"name":"utime","return_type":"Float64","visibility":"Public","body":"@utime"}}]}]},{"html_id":"Crystal/Benchmark/IPS","path":"Benchmark/IPS.html","kind":"module","full_name":"Benchmark::IPS","name":"IPS","abstract":false,"locations":[{"filename":"src/benchmark/ips.cr","line_number":14,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Benchmark","kind":"module","full_name":"Benchmark","name":"Benchmark"},"doc":"Benchmark IPS calculates the number of iterations per second for a given\nblock of code. The strategy is to use two stages: a warmup stage and a\ncalculation stage.\n\nThe warmup phase defaults to 2 seconds. During this stage we figure out how\nmany cycles are needed to run the block for roughly 100ms, and record it.\n\nThe calculation defaults to 5 seconds. During this stage we run the block\nin sets of the size calculated in the warmup stage. The measurements for\nthose sets are then used to calculate the mean and standard deviation,\nwhich are then reported. Additionally we compare the means to that of the\nfastest.","summary":"<p>Benchmark IPS calculates the number of iterations per second for a given block of code.</p>","types":[{"html_id":"Crystal/Benchmark/IPS/Entry","path":"Benchmark/IPS/Entry.html","kind":"class","full_name":"Benchmark::IPS::Entry","name":"Entry","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/benchmark/ips.cr","line_number":125,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Benchmark/IPS","kind":"module","full_name":"Benchmark::IPS","name":"IPS"},"constructors":[{"html_id":"new(label:String,action:->)-class-method","name":"new","abstract":false,"args":[{"name":"label","external_name":"label","restriction":"String"},{"name":"action","external_name":"action","restriction":"(->)"}],"args_string":"(label : String, action :  -> )","args_html":"(label : <a href=\"../../String.html\">String</a>, action :  -> )","location":{"filename":"src/benchmark/ips.cr","line_number":160,"url":null},"def":{"name":"new","args":[{"name":"label","external_name":"label","restriction":"String"},{"name":"action","external_name":"action","restriction":"(->)"}],"visibility":"Public","body":"_ = allocate\n_.initialize(label, action)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"action:->-instance-method","name":"action","doc":"Code to be benchmarked","summary":"<p>Code to be benchmarked</p>","abstract":false,"location":{"filename":"src/benchmark/ips.cr","line_number":130,"url":null},"def":{"name":"action","return_type":"(->)","visibility":"Public","body":"@action"}},{"html_id":"action=(action:->)-instance-method","name":"action=","doc":"Code to be benchmarked","summary":"<p>Code to be benchmarked</p>","abstract":false,"args":[{"name":"action","external_name":"action","restriction":"(->)"}],"args_string":"(action :  -> )","args_html":"(action :  -> )","location":{"filename":"src/benchmark/ips.cr","line_number":130,"url":null},"def":{"name":"action=","args":[{"name":"action","external_name":"action","restriction":"(->)"}],"visibility":"Public","body":"@action = action"}},{"html_id":"bytes_per_op:UInt64-instance-method","name":"bytes_per_op","doc":"Number of bytes allocated per operation","summary":"<p>Number of bytes allocated per operation</p>","abstract":false,"def":{"name":"bytes_per_op","return_type":"UInt64","visibility":"Public","body":"if (value = @bytes_per_op).nil?\n  ::raise(NilAssertionError.new(\"Benchmark::IPS::Entry#bytes_per_op cannot be nil\"))\nelse\n  value\nend"}},{"html_id":"bytes_per_op=(bytes_per_op:UInt64)-instance-method","name":"bytes_per_op=","doc":"Number of bytes allocated per operation","summary":"<p>Number of bytes allocated per operation</p>","abstract":false,"args":[{"name":"bytes_per_op","external_name":"bytes_per_op","restriction":"UInt64"}],"args_string":"(bytes_per_op : UInt64)","args_html":"(bytes_per_op : <a href=\"../../UInt64.html\">UInt64</a>)","location":{"filename":"src/benchmark/ips.cr","line_number":155,"url":null},"def":{"name":"bytes_per_op=","args":[{"name":"bytes_per_op","external_name":"bytes_per_op","restriction":"UInt64"}],"visibility":"Public","body":"@bytes_per_op = bytes_per_op"}},{"html_id":"bytes_per_op?:UInt64?-instance-method","name":"bytes_per_op?","doc":"Number of bytes allocated per operation","summary":"<p>Number of bytes allocated per operation</p>","abstract":false,"def":{"name":"bytes_per_op?","return_type":"UInt64 | ::Nil","visibility":"Public","body":"@bytes_per_op"}},{"html_id":"calculate_stats(samples):Nil-instance-method","name":"calculate_stats","abstract":false,"args":[{"name":"samples","external_name":"samples","restriction":""}],"args_string":"(samples) : Nil","args_html":"(samples) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/benchmark/ips.cr","line_number":180,"url":null},"def":{"name":"calculate_stats","args":[{"name":"samples","external_name":"samples","restriction":""}],"return_type":"Nil","visibility":"Public","body":"@ran = true\n@size = samples.size\n@mean = samples.sum.to_f / size.to_f\n@variance = (samples.reduce(0) do |acc, i|\n  acc + ((i - mean) ** 2)\nend).to_f / size.to_f\n@stddev = Math.sqrt(variance)\n@relative_stddev = 100.0 * (stddev / mean)\n"}},{"html_id":"call:Nil-instance-method","name":"call","abstract":false,"location":{"filename":"src/benchmark/ips.cr","line_number":167,"url":null},"def":{"name":"call","return_type":"Nil","visibility":"Public","body":"action.call"}},{"html_id":"call_for_100ms:Nil-instance-method","name":"call_for_100ms","abstract":false,"location":{"filename":"src/benchmark/ips.cr","line_number":171,"url":null},"def":{"name":"call_for_100ms","return_type":"Nil","visibility":"Public","body":"cycles.times do\n  action.call\nend"}},{"html_id":"cycles:Int32-instance-method","name":"cycles","doc":"Number of cycles needed to run for approx 100ms\nCalculated during the warmup stage","summary":"<p>Number of cycles needed to run for approx 100ms Calculated during the warmup stage</p>","abstract":false,"def":{"name":"cycles","return_type":"Int32","visibility":"Public","body":"if (value = @cycles).nil?\n  ::raise(NilAssertionError.new(\"Benchmark::IPS::Entry#cycles cannot be nil\"))\nelse\n  value\nend"}},{"html_id":"cycles=(cycles:Int32)-instance-method","name":"cycles=","doc":"Number of cycles needed to run for approx 100ms\nCalculated during the warmup stage","summary":"<p>Number of cycles needed to run for approx 100ms Calculated during the warmup stage</p>","abstract":false,"args":[{"name":"cycles","external_name":"cycles","restriction":"Int32"}],"args_string":"(cycles : Int32)","args_html":"(cycles : <a href=\"../../Int32.html\">Int32</a>)","location":{"filename":"src/benchmark/ips.cr","line_number":134,"url":null},"def":{"name":"cycles=","args":[{"name":"cycles","external_name":"cycles","restriction":"Int32"}],"visibility":"Public","body":"@cycles = cycles"}},{"html_id":"cycles?:Int32?-instance-method","name":"cycles?","doc":"Number of cycles needed to run for approx 100ms\nCalculated during the warmup stage","summary":"<p>Number of cycles needed to run for approx 100ms Calculated during the warmup stage</p>","abstract":false,"def":{"name":"cycles?","return_type":"Int32 | ::Nil","visibility":"Public","body":"@cycles"}},{"html_id":"human_compare:String-instance-method","name":"human_compare","abstract":false,"location":{"filename":"src/benchmark/ips.cr","line_number":202,"url":null},"def":{"name":"human_compare","return_type":"String","visibility":"Public","body":"if slower == 1.0\n  \"fastest\"\nelse\n  sprintf(\"%5.2f× slower\", slower)\nend"}},{"html_id":"human_iteration_time:String-instance-method","name":"human_iteration_time","abstract":false,"location":{"filename":"src/benchmark/ips.cr","line_number":193,"url":null},"def":{"name":"human_iteration_time","return_type":"String","visibility":"Public","body":"iteration_time = 1.0 / mean\niteration_time.humanize(precision: 2, significant: false) do |magnitude, _|\n  magnitude = (Number.prefix_index(magnitude)).clamp(-9..0)\n  {magnitude, magnitude == 0 ? \"s \" : \"#{Number.si_prefix(magnitude)}s\"}\nend.rjust(8)\n"}},{"html_id":"human_mean:String-instance-method","name":"human_mean","abstract":false,"location":{"filename":"src/benchmark/ips.cr","line_number":189,"url":null},"def":{"name":"human_mean","return_type":"String","visibility":"Public","body":"mean.humanize(precision: 2, significant: false, prefixes: Number::SI_PREFIXES_PADDED).rjust(7)"}},{"html_id":"label:String-instance-method","name":"label","doc":"Label of the benchmark","summary":"<p>Label of the benchmark</p>","abstract":false,"location":{"filename":"src/benchmark/ips.cr","line_number":127,"url":null},"def":{"name":"label","return_type":"String","visibility":"Public","body":"@label"}},{"html_id":"label=(label:String)-instance-method","name":"label=","doc":"Label of the benchmark","summary":"<p>Label of the benchmark</p>","abstract":false,"args":[{"name":"label","external_name":"label","restriction":"String"}],"args_string":"(label : String)","args_html":"(label : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/benchmark/ips.cr","line_number":127,"url":null},"def":{"name":"label=","args":[{"name":"label","external_name":"label","restriction":"String"}],"visibility":"Public","body":"@label = label"}},{"html_id":"mean:Float64-instance-method","name":"mean","doc":"Statistical mean from calculation stage","summary":"<p>Statistical mean from calculation stage</p>","abstract":false,"def":{"name":"mean","return_type":"Float64","visibility":"Public","body":"if (value = @mean).nil?\n  ::raise(NilAssertionError.new(\"Benchmark::IPS::Entry#mean cannot be nil\"))\nelse\n  value\nend"}},{"html_id":"mean=(mean:Float64)-instance-method","name":"mean=","doc":"Statistical mean from calculation stage","summary":"<p>Statistical mean from calculation stage</p>","abstract":false,"args":[{"name":"mean","external_name":"mean","restriction":"Float64"}],"args_string":"(mean : Float64)","args_html":"(mean : <a href=\"../../Float64.html\">Float64</a>)","location":{"filename":"src/benchmark/ips.cr","line_number":140,"url":null},"def":{"name":"mean=","args":[{"name":"mean","external_name":"mean","restriction":"Float64"}],"visibility":"Public","body":"@mean = mean"}},{"html_id":"mean?:Float64?-instance-method","name":"mean?","doc":"Statistical mean from calculation stage","summary":"<p>Statistical mean from calculation stage</p>","abstract":false,"def":{"name":"mean?","return_type":"Float64 | ::Nil","visibility":"Public","body":"@mean"}},{"html_id":"ran?:Bool-instance-method","name":"ran?","abstract":false,"location":{"filename":"src/benchmark/ips.cr","line_number":163,"url":null},"def":{"name":"ran?","return_type":"Bool","visibility":"Public","body":"@ran"}},{"html_id":"relative_stddev:Float64-instance-method","name":"relative_stddev","doc":"Relative standard deviation as a percentage","summary":"<p>Relative standard deviation as a percentage</p>","abstract":false,"def":{"name":"relative_stddev","return_type":"Float64","visibility":"Public","body":"if (value = @relative_stddev).nil?\n  ::raise(NilAssertionError.new(\"Benchmark::IPS::Entry#relative_stddev cannot be nil\"))\nelse\n  value\nend"}},{"html_id":"relative_stddev=(relative_stddev:Float64)-instance-method","name":"relative_stddev=","doc":"Relative standard deviation as a percentage","summary":"<p>Relative standard deviation as a percentage</p>","abstract":false,"args":[{"name":"relative_stddev","external_name":"relative_stddev","restriction":"Float64"}],"args_string":"(relative_stddev : Float64)","args_html":"(relative_stddev : <a href=\"../../Float64.html\">Float64</a>)","location":{"filename":"src/benchmark/ips.cr","line_number":149,"url":null},"def":{"name":"relative_stddev=","args":[{"name":"relative_stddev","external_name":"relative_stddev","restriction":"Float64"}],"visibility":"Public","body":"@relative_stddev = relative_stddev"}},{"html_id":"relative_stddev?:Float64?-instance-method","name":"relative_stddev?","doc":"Relative standard deviation as a percentage","summary":"<p>Relative standard deviation as a percentage</p>","abstract":false,"def":{"name":"relative_stddev?","return_type":"Float64 | ::Nil","visibility":"Public","body":"@relative_stddev"}},{"html_id":"set_cycles(duration,iterations):Nil-instance-method","name":"set_cycles","abstract":false,"args":[{"name":"duration","external_name":"duration","restriction":""},{"name":"iterations","external_name":"iterations","restriction":""}],"args_string":"(duration, iterations) : Nil","args_html":"(duration, iterations) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/benchmark/ips.cr","line_number":175,"url":null},"def":{"name":"set_cycles","args":[{"name":"duration","external_name":"duration","restriction":""},{"name":"iterations","external_name":"iterations","restriction":""}],"return_type":"Nil","visibility":"Public","body":"@cycles = ((iterations / duration.total_milliseconds) * 100).to_i\nif cycles <= 0\n  @cycles = 1\nend\n"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Number of 100ms runs during the calculation stage","summary":"<p>Number of 100ms runs during the calculation stage</p>","abstract":false,"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"if (value = @size).nil?\n  ::raise(NilAssertionError.new(\"Benchmark::IPS::Entry#size cannot be nil\"))\nelse\n  value\nend"}},{"html_id":"size=(size:Int32)-instance-method","name":"size=","doc":"Number of 100ms runs during the calculation stage","summary":"<p>Number of 100ms runs during the calculation stage</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int32"}],"args_string":"(size : Int32)","args_html":"(size : <a href=\"../../Int32.html\">Int32</a>)","location":{"filename":"src/benchmark/ips.cr","line_number":137,"url":null},"def":{"name":"size=","args":[{"name":"size","external_name":"size","restriction":"Int32"}],"visibility":"Public","body":"@size = size"}},{"html_id":"size?:Int32?-instance-method","name":"size?","doc":"Number of 100ms runs during the calculation stage","summary":"<p>Number of 100ms runs during the calculation stage</p>","abstract":false,"def":{"name":"size?","return_type":"Int32 | ::Nil","visibility":"Public","body":"@size"}},{"html_id":"slower:Float64-instance-method","name":"slower","doc":"Multiple slower than the fastest entry","summary":"<p>Multiple slower than the fastest entry</p>","abstract":false,"def":{"name":"slower","return_type":"Float64","visibility":"Public","body":"if (value = @slower).nil?\n  ::raise(NilAssertionError.new(\"Benchmark::IPS::Entry#slower cannot be nil\"))\nelse\n  value\nend"}},{"html_id":"slower=(slower:Float64)-instance-method","name":"slower=","doc":"Multiple slower than the fastest entry","summary":"<p>Multiple slower than the fastest entry</p>","abstract":false,"args":[{"name":"slower","external_name":"slower","restriction":"Float64"}],"args_string":"(slower : Float64)","args_html":"(slower : <a href=\"../../Float64.html\">Float64</a>)","location":{"filename":"src/benchmark/ips.cr","line_number":152,"url":null},"def":{"name":"slower=","args":[{"name":"slower","external_name":"slower","restriction":"Float64"}],"visibility":"Public","body":"@slower = slower"}},{"html_id":"slower?:Float64?-instance-method","name":"slower?","doc":"Multiple slower than the fastest entry","summary":"<p>Multiple slower than the fastest entry</p>","abstract":false,"def":{"name":"slower?","return_type":"Float64 | ::Nil","visibility":"Public","body":"@slower"}},{"html_id":"stddev:Float64-instance-method","name":"stddev","doc":"Statistical standard deviation from calculation stage","summary":"<p>Statistical standard deviation from calculation stage</p>","abstract":false,"def":{"name":"stddev","return_type":"Float64","visibility":"Public","body":"if (value = @stddev).nil?\n  ::raise(NilAssertionError.new(\"Benchmark::IPS::Entry#stddev cannot be nil\"))\nelse\n  value\nend"}},{"html_id":"stddev=(stddev:Float64)-instance-method","name":"stddev=","doc":"Statistical standard deviation from calculation stage","summary":"<p>Statistical standard deviation from calculation stage</p>","abstract":false,"args":[{"name":"stddev","external_name":"stddev","restriction":"Float64"}],"args_string":"(stddev : Float64)","args_html":"(stddev : <a href=\"../../Float64.html\">Float64</a>)","location":{"filename":"src/benchmark/ips.cr","line_number":146,"url":null},"def":{"name":"stddev=","args":[{"name":"stddev","external_name":"stddev","restriction":"Float64"}],"visibility":"Public","body":"@stddev = stddev"}},{"html_id":"stddev?:Float64?-instance-method","name":"stddev?","doc":"Statistical standard deviation from calculation stage","summary":"<p>Statistical standard deviation from calculation stage</p>","abstract":false,"def":{"name":"stddev?","return_type":"Float64 | ::Nil","visibility":"Public","body":"@stddev"}},{"html_id":"variance:Float64-instance-method","name":"variance","doc":"Statistical variance from calculation stage","summary":"<p>Statistical variance from calculation stage</p>","abstract":false,"def":{"name":"variance","return_type":"Float64","visibility":"Public","body":"if (value = @variance).nil?\n  ::raise(NilAssertionError.new(\"Benchmark::IPS::Entry#variance cannot be nil\"))\nelse\n  value\nend"}},{"html_id":"variance=(variance:Float64)-instance-method","name":"variance=","doc":"Statistical variance from calculation stage","summary":"<p>Statistical variance from calculation stage</p>","abstract":false,"args":[{"name":"variance","external_name":"variance","restriction":"Float64"}],"args_string":"(variance : Float64)","args_html":"(variance : <a href=\"../../Float64.html\">Float64</a>)","location":{"filename":"src/benchmark/ips.cr","line_number":143,"url":null},"def":{"name":"variance=","args":[{"name":"variance","external_name":"variance","restriction":"Float64"}],"visibility":"Public","body":"@variance = variance"}},{"html_id":"variance?:Float64?-instance-method","name":"variance?","doc":"Statistical variance from calculation stage","summary":"<p>Statistical variance from calculation stage</p>","abstract":false,"def":{"name":"variance?","return_type":"Float64 | ::Nil","visibility":"Public","body":"@variance"}}]},{"html_id":"Crystal/Benchmark/IPS/Job","path":"Benchmark/IPS/Job.html","kind":"class","full_name":"Benchmark::IPS::Job","name":"Job","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/benchmark/ips.cr","line_number":15,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Benchmark/IPS","kind":"module","full_name":"Benchmark::IPS","name":"IPS"},"constructors":[{"html_id":"new(calculation=5,warmup=2,interactive=STDOUT.tty?)-class-method","name":"new","abstract":false,"args":[{"name":"calculation","default_value":"5","external_name":"calculation","restriction":""},{"name":"warmup","default_value":"2","external_name":"warmup","restriction":""},{"name":"interactive","default_value":"STDOUT.tty?","external_name":"interactive","restriction":""}],"args_string":"(calculation = 5, warmup = 2, interactive = STDOUT.tty?)","args_html":"(calculation = <span class=\"n\">5</span>, warmup = <span class=\"n\">2</span>, interactive = <span class=\"t\">STDOUT</span>.tty?)","location":{"filename":"src/benchmark/ips.cr","line_number":23,"url":null},"def":{"name":"new","args":[{"name":"calculation","default_value":"5","external_name":"calculation","restriction":""},{"name":"warmup","default_value":"2","external_name":"warmup","restriction":""},{"name":"interactive","default_value":"STDOUT.tty?","external_name":"interactive","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(calculation, warmup, interactive)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"execute:Nil-instance-method","name":"execute","abstract":false,"location":{"filename":"src/benchmark/ips.cr","line_number":37,"url":null},"def":{"name":"execute","return_type":"Nil","visibility":"Public","body":"run_warmup\nrun_calculation\nrun_comparison\n"}},{"html_id":"items:Array(Entry)-instance-method","name":"items","doc":"List of all entries in the benchmark.\nAfter #execute, these are populated with the resulting statistics.","summary":"<p>List of all entries in the benchmark.</p>","abstract":false,"location":{"filename":"src/benchmark/ips.cr","line_number":18,"url":null},"def":{"name":"items","return_type":"Array(Entry)","visibility":"Public","body":"@items"}},{"html_id":"items=(items:Array(Entry))-instance-method","name":"items=","doc":"List of all entries in the benchmark.\nAfter #execute, these are populated with the resulting statistics.","summary":"<p>List of all entries in the benchmark.</p>","abstract":false,"args":[{"name":"items","external_name":"items","restriction":"Array(Entry)"}],"args_string":"(items : Array(Entry))","args_html":"(items : <a href=\"../../Array.html\">Array</a>(<a href=\"../../Benchmark/IPS/Entry.html\">Entry</a>))","location":{"filename":"src/benchmark/ips.cr","line_number":18,"url":null},"def":{"name":"items=","args":[{"name":"items","external_name":"items","restriction":"Array(Entry)"}],"visibility":"Public","body":"@items = items"}},{"html_id":"report(label=\"\",&action):Benchmark::IPS::Entry-instance-method","name":"report","doc":"Adds code to be benchmarked","summary":"<p>Adds code to be benchmarked</p>","abstract":false,"args":[{"name":"label","default_value":"\"\"","external_name":"label","restriction":""}],"args_string":"(label = \"\", &action) : Benchmark::IPS::Entry","args_html":"(label = <span class=\"s\">&quot;&quot;</span>, &action) : <a href=\"../../Benchmark/IPS/Entry.html\">Benchmark::IPS::Entry</a>","location":{"filename":"src/benchmark/ips.cr","line_number":31,"url":null},"def":{"name":"report","args":[{"name":"label","default_value":"\"\"","external_name":"label","restriction":""}],"yields":0,"block_arg":{"name":"action","external_name":"action","restriction":""},"return_type":"Benchmark::IPS::Entry","visibility":"Public","body":"item = Entry.new(label, action)\n@items << item\nitem\n"}},{"html_id":"report:Nil-instance-method","name":"report","abstract":false,"location":{"filename":"src/benchmark/ips.cr","line_number":43,"url":null},"def":{"name":"report","return_type":"Nil","visibility":"Public","body":"max_label = ran_items.max_of do |__arg0|\n  __arg0.label.size\nend\nmax_compare = ran_items.max_of do |__arg1|\n  __arg1.human_compare.size\nend\nmax_bytes_per_op = ran_items.max_of do |__arg2|\n  __arg2.bytes_per_op.humanize(base: 1024).size\nend\nran_items.each do |item|\n  printf(\"%s %s (%s) (±%5.2f%%)  %sB/op  %s\\n\", item.label.rjust(max_label), item.human_mean, item.human_iteration_time, item.relative_stddev, item.bytes_per_op.humanize(base: 1024).rjust(max_bytes_per_op), item.human_compare.rjust(max_compare))\nend\n"}}]}]}]},{"html_id":"Crystal/BigDecimal","path":"BigDecimal.html","kind":"struct","full_name":"BigDecimal","name":"BigDecimal","abstract":false,"superclass":{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big.cr","line_number":11,"url":null},{"filename":"src/big/big_decimal.cr","line_number":17,"url":null},{"filename":"src/big/number.cr","line_number":25,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"DEFAULT_MAX_DIV_ITERATIONS","name":"DEFAULT_MAX_DIV_ITERATIONS","value":"100_u64"},{"id":"TEN","name":"TEN","value":"BigInt.new(10)"},{"id":"ZERO","name":"ZERO","value":"BigInt.new(0)"}],"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"doc":"A `BigDecimal` can represent arbitrarily large precision decimals.\n\nIt is internally represented by a pair of `BigInt` and `UInt64`: value and scale.\nValue contains the actual value, and scale tells the decimal point place.\nE.g. when value is `1234` and scale `2`, the result is `12.34`.\n\nThe general idea and some of the arithmetic algorithms were adapted from\nthe MIT/APACHE-licensed [bigdecimal-rs](https://github.com/akubera/bigdecimal-rs).","summary":"<p>A <code><a href=\"BigDecimal.html\">BigDecimal</a></code> can represent arbitrarily large precision decimals.</p>","constructors":[{"html_id":"new(value:BigInt,scale:UInt64)-class-method","name":"new","doc":"Creates a new `BigDecimal` from `BigInt` *value* and `UInt64` *scale*,\nwhich matches the internal representation.","summary":"<p>Creates a new <code><a href=\"BigDecimal.html\">BigDecimal</a></code> from <code><a href=\"BigInt.html\">BigInt</a></code> <em>value</em> and <code><a href=\"UInt64.html\">UInt64</a></code> <em>scale</em>, which matches the internal representation.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"BigInt"},{"name":"scale","external_name":"scale","restriction":"UInt64"}],"args_string":"(value : BigInt, scale : UInt64)","args_html":"(value : <a href=\"BigInt.html\">BigInt</a>, scale : <a href=\"UInt64.html\">UInt64</a>)","location":{"filename":"src/big/big_decimal.cr","line_number":54,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"BigInt"},{"name":"scale","external_name":"scale","restriction":"UInt64"}],"visibility":"Public","body":"_ = allocate\n_.initialize(value, scale)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:Float)-class-method","name":"new","doc":"Creates a new `BigDecimal` from `Float`.\n\nNOTE: Floats are fundamentally less precise than BigDecimals,\nwhich makes initialization from them risky.","summary":"<p>Creates a new <code><a href=\"BigDecimal.html\">BigDecimal</a></code> from <code><a href=\"Float.html\">Float</a></code>.</p>","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"Float"}],"args_string":"(num : Float)","args_html":"(num : <a href=\"Float.html\">Float</a>)","location":{"filename":"src/big/big_decimal.cr","line_number":34,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"Float"}],"visibility":"Public","body":"new(num.to_s)"}},{"html_id":"new(num:BigRational)-class-method","name":"new","doc":"Creates a new `BigDecimal` from `BigRational`.\n\nNOTE: BigRational are fundamentally more precise than BigDecimals,\nwhich makes initialization from them risky.","summary":"<p>Creates a new <code><a href=\"BigDecimal.html\">BigDecimal</a></code> from <code><a href=\"BigRational.html\">BigRational</a></code>.</p>","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"BigRational"}],"args_string":"(num : BigRational)","args_html":"(num : <a href=\"BigRational.html\">BigRational</a>)","location":{"filename":"src/big/big_decimal.cr","line_number":42,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"BigRational"}],"visibility":"Public","body":"num.numerator.to_big_d / num.denominator.to_big_d"}},{"html_id":"new(num:BigDecimal)-class-method","name":"new","doc":"Returns *num*. Useful for generic code that does `T.new(...)` with `T`\nbeing a `Number`.","summary":"<p>Returns <em>num</em>.</p>","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"BigDecimal"}],"args_string":"(num : BigDecimal)","args_html":"(num : <a href=\"BigDecimal.html\">BigDecimal</a>)","location":{"filename":"src/big/big_decimal.cr","line_number":48,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"BigDecimal"}],"visibility":"Public","body":"num"}},{"html_id":"new(num:Int=0,scale:Int=0)-class-method","name":"new","doc":"Creates a new `BigDecimal` from `Int`.","summary":"<p>Creates a new <code><a href=\"BigDecimal.html\">BigDecimal</a></code> from <code><a href=\"Int.html\">Int</a></code>.</p>","abstract":false,"args":[{"name":"num","default_value":"0","external_name":"num","restriction":"Int"},{"name":"scale","default_value":"0","external_name":"scale","restriction":"Int"}],"args_string":"(num : Int = 0, scale : Int = 0)","args_html":"(num : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>, scale : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>)","location":{"filename":"src/big/big_decimal.cr","line_number":58,"url":null},"def":{"name":"new","args":[{"name":"num","default_value":"0","external_name":"num","restriction":"Int"},{"name":"scale","default_value":"0","external_name":"scale","restriction":"Int"}],"visibility":"Public","body":"_ = allocate\n_.initialize(num, scale)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(str:String)-class-method","name":"new","doc":"Creates a new `BigDecimal` from a `String`.\n\nAllows only valid number strings with an optional negative sign.","summary":"<p>Creates a new <code><a href=\"BigDecimal.html\">BigDecimal</a></code> from a <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"String"}],"args_string":"(str : String)","args_html":"(str : <a href=\"String.html\">String</a>)","location":{"filename":"src/big/big_decimal.cr","line_number":65,"url":null},"def":{"name":"new","args":[{"name":"str","external_name":"str","restriction":"String"}],"visibility":"Public","body":"_ = allocate\n_.initialize(str)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"*(other:BigDecimal):BigDecimal-instance-method","name":"*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":184,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"BigDecimal.new(@value * other.value, @scale + other.scale)"}},{"html_id":"*(other:Number):BigDecimal-instance-method","name":"*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Number"}],"args_string":"(other : Number) : BigDecimal","args_html":"(other : <a href=\"Number.html\">Number</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":188,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Number"}],"return_type":"BigDecimal","visibility":"Public","body":"self * (BigDecimal.new(other))"}},{"html_id":"**(other:Int):BigDecimal-instance-method","name":"**","doc":"Raises the decimal to the *other*th power\n\n```\nrequire \"big\"\n\nBigDecimal.new(1234, 2) ** 2 # => 152.2756\n```","summary":"<p>Raises the decimal to the <em>other</em>th power</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigDecimal","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":294,"url":null},"def":{"name":"**","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigDecimal","visibility":"Public","body":"if other < 0\n  return (to_big_r ** other).to_big_d\nend\nBigDecimal.new(@value ** other, @scale * other)\n"}},{"html_id":"+(other:BigDecimal):BigDecimal-instance-method","name":"+","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":152,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"if @scale > other.scale\n  scaled = other.scale_to(self)\n  BigDecimal.new(@value + scaled.value, @scale)\nelse\n  if @scale < other.scale\n    scaled = scale_to(other)\n    BigDecimal.new(scaled.value + other.value, other.scale)\n  else\n    BigDecimal.new(@value + other.value, @scale)\n  end\nend"}},{"html_id":"+(other:Number):BigDecimal-instance-method","name":"+","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Number"}],"args_string":"(other : Number) : BigDecimal","args_html":"(other : <a href=\"Number.html\">Number</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":164,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Number"}],"return_type":"BigDecimal","visibility":"Public","body":"self + (BigDecimal.new(other))"}},{"html_id":"-(other:BigDecimal):BigDecimal-instance-method","name":"-","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":168,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"if @scale > other.scale\n  scaled = other.scale_to(self)\n  BigDecimal.new(@value - scaled.value, @scale)\nelse\n  if @scale < other.scale\n    scaled = scale_to(other)\n    BigDecimal.new(scaled.value - other.value, other.scale)\n  else\n    BigDecimal.new(@value - other.value, @scale)\n  end\nend"}},{"html_id":"-(other:Number):BigDecimal-instance-method","name":"-","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Number"}],"args_string":"(other : Number) : BigDecimal","args_html":"(other : <a href=\"Number.html\">Number</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":180,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Number"}],"return_type":"BigDecimal","visibility":"Public","body":"self - (BigDecimal.new(other))"}},{"html_id":"-:BigDecimal-instance-method","name":"-","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":148,"url":null},"def":{"name":"-","return_type":"BigDecimal","visibility":"Public","body":"BigDecimal.new(-@value, @scale)"}},{"html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":192,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"div(other)"}},{"html_id":"/(other:BigInt):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigDecimal","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":196,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigFloat):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigDecimal","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":196,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_decimal.cr","line_number":197,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:Int8):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : BigDecimal","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":26,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:UInt8):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : BigDecimal","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":26,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:Int16):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : BigDecimal","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":26,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:UInt16):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : BigDecimal","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":26,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:Int32):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : BigDecimal","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":26,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:UInt32):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : BigDecimal","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":26,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:Int64):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : BigDecimal","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":26,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:UInt64):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : BigDecimal","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":26,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:Int128):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : BigDecimal","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":26,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:UInt128):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : BigDecimal","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":26,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:Float32):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : BigDecimal","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":27,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:Float64):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : BigDecimal","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":27,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"<=>(other:BigDecimal):Int32-instance-method","name":"<=>","doc":"The comparison operator. Returns `0` if the two objects are equal,\na negative number if this object is considered less than *other*,\na positive number if this object is considered greater than *other*,\nor `nil` if the two objects are not comparable.\n\nSubclasses define this method to provide class-specific ordering.\n\nThe comparison operator is usually used to sort values:\n\n```\n# Sort in a descending way:\n[3, 1, 2].sort { |x, y| y <=> x } # => [3, 2, 1]\n\n# Sort in an ascending way:\n[3, 1, 2].sort { |x, y| x <=> y } # => [1, 2, 3]\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : Int32","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/big/big_decimal.cr","line_number":235,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"Int32","visibility":"Public","body":"if @scale > other.scale\n  @value <=> (other.scale_to(self)).value\nelse\n  if @scale < other.scale\n    (scale_to(other)).value <=> other.value\n  else\n    @value <=> other.value\n  end\nend"}},{"html_id":"<=>(other:Int|Float|BigRational)-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int | Float | BigRational"}],"args_string":"(other : Int | Float | BigRational)","args_html":"(other : <a href=\"Int.html\">Int</a> | <a href=\"Float.html\">Float</a> | <a href=\"BigRational.html\">BigRational</a>)","location":{"filename":"src/big/big_decimal.cr","line_number":245,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Int | Float | BigRational"}],"visibility":"Public","body":"self <=> (BigDecimal.new(other))"}},{"html_id":"==(other:BigDecimal):Bool-instance-method","name":"==","doc":"Compares this object to *other* based on the receiver’s `<=>` method,\nreturning `true` if it returns `0`.\n\nAlso returns `true` if this and *other* are the same object.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"BigDecimal.html#%3C%3D%3E%28other%3ABigDecimal%29%3AInt32-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns <code>0</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : Bool","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/big/big_decimal.cr","line_number":249,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"Bool","visibility":"Public","body":"case @scale\nwhen .>(other.scale)\n  scaled = other.value * (power_ten_to(@scale - other.scale))\n  @value == scaled\nwhen .<(other.scale)\n  scaled = @value * (power_ten_to(other.scale - @scale))\n  scaled == other.value\nelse\n  @value == other.value\nend"}},{"html_id":"ceil:BigDecimal-instance-method","name":"ceil","doc":"Rounds towards positive infinity.","summary":"<p>Rounds towards positive infinity.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":300,"url":null},"def":{"name":"ceil","return_type":"BigDecimal","visibility":"Public","body":"round_impl do |rem|\n  rem > 0\nend"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":595,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"div(other:BigDecimal,max_div_iterations=DEFAULT_MAX_DIV_ITERATIONS):BigDecimal-instance-method","name":"div","doc":"Divides `self` with another `BigDecimal`, with a optionally configurable *max_div_iterations*, which\ndefines a maximum number of iterations in case the division is not exact.\n\n```\nBigDecimal.new(1).div(BigDecimal.new(2))    # => BigDecimal(@value=5, @scale=2)\nBigDecimal.new(1).div(BigDecimal.new(3), 5) # => BigDecimal(@value=33333, @scale=5)\n```","summary":"<p>Divides <code>self</code> with another <code><a href=\"BigDecimal.html\">BigDecimal</a></code>, with a optionally configurable <em>max_div_iterations</em>, which defines a maximum number of iterations in case the division is not exact.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"},{"name":"max_div_iterations","default_value":"DEFAULT_MAX_DIV_ITERATIONS","external_name":"max_div_iterations","restriction":""}],"args_string":"(other : BigDecimal, max_div_iterations = DEFAULT_MAX_DIV_ITERATIONS) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>, max_div_iterations = <span class=\"t\">DEFAULT_MAX_DIV_ITERATIONS</span>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":206,"url":null},"def":{"name":"div","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"},{"name":"max_div_iterations","default_value":"DEFAULT_MAX_DIV_ITERATIONS","external_name":"max_div_iterations","restriction":""}],"return_type":"BigDecimal","visibility":"Public","body":"check_division_by_zero(other)\nother.factor_powers_of_ten\nnumerator, denominator = @value, other.@value\nscale = if @scale >= other.scale\n  @scale - other.scale\nelse\n  numerator = numerator * (TEN ** (other.scale - @scale))\n  0\nend\nquotient, remainder = numerator.divmod(denominator)\nif remainder == ZERO\n  return BigDecimal.new(normalize_quotient(other, quotient), scale)\nend\nremainder = remainder * TEN\ni = 0\nwhile (remainder != ZERO) && i < max_div_iterations\n  inner_quotient, inner_remainder = remainder.divmod(denominator)\n  quotient = (quotient * TEN) + inner_quotient\n  remainder = inner_remainder * TEN\n  i = i + 1\nend\nBigDecimal.new(normalize_quotient(other, quotient), scale + i)\n"}},{"html_id":"floor:BigDecimal-instance-method","name":"floor","doc":"Rounds towards negative infinity.","summary":"<p>Rounds towards negative infinity.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":305,"url":null},"def":{"name":"floor","return_type":"BigDecimal","visibility":"Public","body":"round_impl do |rem|\n  rem < 0\nend"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"Appends this object's value to *hasher*, and returns the modified *hasher*.\n\nUsually the macro `def_hash` can be used to generate this method.\nOtherwise, invoke `hash(hasher)` on each object's instance variables to\naccumulate the result:\n\n```\ndef hash(hasher)\n  hasher = @some_ivar.hash(hasher)\n  hasher = @some_other_ivar.hash(hasher)\n  hasher\nend\n```","summary":"<p>Appends this object's value to <em>hasher</em>, and returns the modified <em>hasher</em>.</p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/big/big_decimal.cr","line_number":599,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher.string(to_s)"}},{"html_id":"normalize_quotient(other:BigDecimal,quotient:BigInt):BigInt-instance-method","name":"normalize_quotient","doc":"Returns the *quotient* as absolutely negative if `self` and *other* have\ndifferent signs, otherwise returns the *quotient*.","summary":"<p>Returns the <em>quotient</em> as absolutely negative if <code>self</code> and <em>other</em> have different signs, otherwise returns the <em>quotient</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"},{"name":"quotient","external_name":"quotient","restriction":"BigInt"}],"args_string":"(other : BigDecimal, quotient : BigInt) : BigInt","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>, quotient : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_decimal.cr","line_number":605,"url":null},"def":{"name":"normalize_quotient","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"},{"name":"quotient","external_name":"quotient","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"if (@value < 0 && other.value > 0) || (other.value < 0 && @value > 0)\n  -quotient.abs\nelse\n  quotient\nend"}},{"html_id":"round(digits:Number,base=10,*,mode:RoundingMode=:ties_even):BigDecimal-instance-method","name":"round","doc":"Rounds this number to a given precision.\n\nRounds to the specified number of *digits* after the decimal place,\n(or before if negative), in base *base*.\n\nThe rounding *mode* controls the direction of the rounding. The default is\n`RoundingMode::TIES_EVEN` which rounds to the nearest integer, with ties\n(fractional value of `0.5`) being rounded to the even neighbor (Banker's rounding).\n\n```\n-1763.116.round(2) # => -1763.12\n```","summary":"<p>Rounds this number to a given precision.</p>","abstract":false,"args":[{"name":"digits","external_name":"digits","restriction":"Number"},{"name":"base","default_value":"10","external_name":"base","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"mode","default_value":":ties_even","external_name":"mode","restriction":"RoundingMode"}],"args_string":"(digits : Number, base = 10, *, mode : RoundingMode = :ties_even) : BigDecimal","args_html":"(digits : <a href=\"Number.html\">Number</a>, base = <span class=\"n\">10</span>, *, mode : <a href=\"Number/RoundingMode.html\">RoundingMode</a> = <span class=\"n\">:ties_even</span>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":355,"url":null},"def":{"name":"round","args":[{"name":"digits","external_name":"digits","restriction":"Number"},{"name":"base","default_value":"10","external_name":"base","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"mode","default_value":":ties_even","external_name":"mode","restriction":"RoundingMode"}],"splat_index":2,"return_type":"BigDecimal","visibility":"Public","body":"if ((base == 10) && @scale <= digits) || zero?\n  return self\nend\nif digits < 0\n  multiplier = base.to_big_d ** digits.abs\n  shifted = self / multiplier\nelse\n  multiplier = base.to_big_d ** digits\n  shifted = self * multiplier\nend\nrounded = shifted.round(mode)\nif digits < 0\n  result = rounded * multiplier\nelse\n  result = rounded / multiplier\nend\nBigDecimal.new(result)\n"}},{"html_id":"round_away:BigDecimal-instance-method","name":"round_away","doc":"Rounds towards the nearest integer. If both neighboring integers are equidistant,\nrounds away from zero.","summary":"<p>Rounds towards the nearest integer.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":333,"url":null},"def":{"name":"round_away","return_type":"BigDecimal","visibility":"Public","body":"round_impl do |rem, rem_range|\n  rem.abs >= (rem_range // 2)\nend"}},{"html_id":"round_even:BigDecimal-instance-method","name":"round_even","doc":"Rounds towards the nearest integer. If both neighboring integers are equidistant,\nrounds towards the even neighbor (Banker's rounding).","summary":"<p>Rounds towards the nearest integer.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":316,"url":null},"def":{"name":"round_even","return_type":"BigDecimal","visibility":"Public","body":"round_impl do |rem, rem_range, mantissa|\n  case rem.abs <=> (rem_range // 2)\n  when .<(0)\n    false\n  when .>(0)\n    true\n  else\n    mantissa.to_i!.odd?\n  end\nend"}},{"html_id":"scale:UInt64-instance-method","name":"scale","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":28,"url":null},"def":{"name":"scale","return_type":"UInt64","visibility":"Public","body":"@scale"}},{"html_id":"scale_to(new_scale:BigDecimal):BigDecimal-instance-method","name":"scale_to","doc":"Scales a `BigDecimal` to another `BigDecimal`, so they can be\ncomputed easier.","summary":"<p>Scales a <code><a href=\"BigDecimal.html\">BigDecimal</a></code> to another <code><a href=\"BigDecimal.html\">BigDecimal</a></code>, so they can be computed easier.</p>","abstract":false,"args":[{"name":"new_scale","external_name":"new_scale","restriction":"BigDecimal"}],"args_string":"(new_scale : BigDecimal) : BigDecimal","args_html":"(new_scale : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":268,"url":null},"def":{"name":"scale_to","args":[{"name":"new_scale","external_name":"new_scale","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"in_scale(new_scale.scale)"}},{"html_id":"to_big_d-instance-method","name":"to_big_d","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":417,"url":null},"def":{"name":"to_big_d","visibility":"Public","body":"self"}},{"html_id":"to_big_f-instance-method","name":"to_big_f","doc":"Converts to `BigFloat`.","summary":"<p>Converts to <code><a href=\"BigFloat.html\">BigFloat</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":413,"url":null},"def":{"name":"to_big_f","visibility":"Public","body":"BigFloat.new(to_s)"}},{"html_id":"to_big_i:BigInt-instance-method","name":"to_big_i","doc":"Converts to `BigInt`. Truncates anything on the right side of the decimal point.","summary":"<p>Converts to <code><a href=\"BigInt.html\">BigInt</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":408,"url":null},"def":{"name":"to_big_i","return_type":"BigInt","visibility":"Public","body":"trunc.value"}},{"html_id":"to_big_r:BigRational-instance-method","name":"to_big_r","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":421,"url":null},"def":{"name":"to_big_r","return_type":"BigRational","visibility":"Public","body":"BigRational.new(self.value, BigDecimal::TEN ** self.scale)"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Converts to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Converts to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":573,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"to_f64"}},{"html_id":"to_f!:Float64-instance-method","name":"to_f!","doc":"Converts to `Float64`.\nIn case of overflow a wrapping is performed.","summary":"<p>Converts to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":591,"url":null},"def":{"name":"to_f!","return_type":"Float64","visibility":"Public","body":"to_f64!"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Converts to `Float32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Converts to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":567,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"to_f64.to_f32"}},{"html_id":"to_f32!-instance-method","name":"to_f32!","doc":"Converts to `Float32`.\nIn case of overflow a wrapping is performed.","summary":"<p>Converts to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":579,"url":null},"def":{"name":"to_f32!","visibility":"Public","body":"to_f64.to_f32!"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Converts to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Converts to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":561,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"to_s.to_f64"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","doc":"Converts to `Float64`.\nIn case of overflow a wrapping is performed.","summary":"<p>Converts to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":585,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"to_f64"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Converts to `Int32`. Truncates anything on the right side of the decimal point.\nRaises `OverflowError` in case of overflow.","summary":"<p>Converts to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":451,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"to_i32"}},{"html_id":"to_i!:Int32-instance-method","name":"to_i!","doc":"Converts to `Int32`. Truncates anything on the right side of the decimal point.\nIn case of overflow a wrapping is performed.","summary":"<p>Converts to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":481,"url":null},"def":{"name":"to_i!","return_type":"Int32","visibility":"Public","body":"to_i32!"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Converts to `Int16`. Truncates anything on the right side of the decimal point.\nRaises `OverflowError` in case of overflow.","summary":"<p>Converts to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":439,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"to_big_i.to_i16"}},{"html_id":"to_i16!-instance-method","name":"to_i16!","doc":"Converts to `Int16`. Truncates anything on the right side of the decimal point.\nIn case of overflow a wrapping is performed.","summary":"<p>Converts to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":463,"url":null},"def":{"name":"to_i16!","visibility":"Public","body":"to_big_i.to_i16!"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Converts to `Int32`. Truncates anything on the right side of the decimal point.\nRaises `OverflowError` in case of overflow.","summary":"<p>Converts to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":433,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"to_big_i.to_i32"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","doc":"Converts to `Int32`. Truncates anything on the right side of the decimal point.\nIn case of overflow a wrapping is performed.","summary":"<p>Converts to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":469,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"to_big_i.to_i32!"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Converts to `Int64`. Truncates anything on the right side of the decimal point.\nRaises `OverflowError` in case of overflow.","summary":"<p>Converts to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":427,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"to_big_i.to_i64"}},{"html_id":"to_i64!-instance-method","name":"to_i64!","doc":"Converts to `Int64`. Truncates anything on the right side of the decimal point.\nIn case of overflow a wrapping is performed.","summary":"<p>Converts to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":475,"url":null},"def":{"name":"to_i64!","visibility":"Public","body":"to_big_i.to_i64!"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Converts to `Int8`. Truncates anything on the right side of the decimal point.\nRaises `OverflowError` in case of overflow.","summary":"<p>Converts to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":445,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"to_big_i.to_i8"}},{"html_id":"to_i8!-instance-method","name":"to_i8!","doc":"Converts to `Int8`. Truncates anything on the right side of the decimal point.\nIn case of overflow a wrapping is performed.","summary":"<p>Converts to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":457,"url":null},"def":{"name":"to_i8!","visibility":"Public","body":"to_big_i.to_i8!"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a `String` representation of this object\nto the given `IO` object.\n\nAn object must never append itself to the io argument,\nas this will in turn call `to_s(io)` on it.","summary":"<p>Appends a <code><a href=\"String.html\">String</a></code> representation of this object to the given <code><a href=\"IO.html\">IO</a></code> object.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/big/big_decimal.cr","line_number":379,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"factor_powers_of_ten\ns = @value.to_s\nif @scale == 0\n  io << s\n  return\nend\nif @scale >= s.size && @value >= 0\n  io << \"0.\"\n  (@scale - s.size).times do\n    io << '0'\n  end\n  io << s\nelse\n  if @scale >= s.size && @value < 0\n    io << \"-0.0\"\n    (@scale - s.size).times do\n      io << '0'\n    end\n    io << s[1..-1]\n  else\n    if ((offset = s.size - @scale) == 1) && @value < 0\n      (io << \"-0.\") << s[offset..-1]\n    else\n      ((io << s[0...offset]) << '.') << s[offset..-1]\n    end\n  end\nend\n"}},{"html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Converts to `UInt32`. Truncates anything on the right side of the decimal point.\nRaises `OverflowError` in case of overflow.","summary":"<p>Converts to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":520,"url":null},"def":{"name":"to_u","return_type":"UInt32","visibility":"Public","body":"to_u32"}},{"html_id":"to_u!:UInt32-instance-method","name":"to_u!","doc":"Converts to `UInt32`. Truncates anything on the right side of the decimal point,\nconverting negative to positive.\nIn case of overflow a wrapping is performed.","summary":"<p>Converts to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":555,"url":null},"def":{"name":"to_u!","return_type":"UInt32","visibility":"Public","body":"to_u32!"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Converts to `UInt16`. Truncates anything on the right side of the decimal point.\nRaises `OverflowError` in case of overflow.","summary":"<p>Converts to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":508,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"to_big_u.to_u16"}},{"html_id":"to_u16!-instance-method","name":"to_u16!","doc":"Converts to `UInt16`. Truncates anything on the right side of the decimal point,\nconverting negative to positive.\nIn case of overflow a wrapping is performed.","summary":"<p>Converts to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":534,"url":null},"def":{"name":"to_u16!","visibility":"Public","body":"to_big_u!.to_u16!"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Converts to `UInt32`. Truncates anything on the right side of the decimal point.\nRaises `OverflowError` in case of overflow.","summary":"<p>Converts to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":502,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"to_big_u.to_u32"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","doc":"Converts to `UInt32`. Truncates anything on the right side of the decimal point,\nconverting negative to positive.\nIn case of overflow a wrapping is performed.","summary":"<p>Converts to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":541,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"to_big_u!.to_u32!"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Converts to `UInt64`. Truncates anything on the right side of the decimal point.\nRaises `OverflowError` in case of overflow.","summary":"<p>Converts to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":496,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"to_big_u.to_u64"}},{"html_id":"to_u64!-instance-method","name":"to_u64!","doc":"Converts to `UInt64`. Truncates anything on the right side of the decimal point,\nconverting negative to positive.\nIn case of overflow a wrapping is performed.","summary":"<p>Converts to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":548,"url":null},"def":{"name":"to_u64!","visibility":"Public","body":"to_big_u!.to_u64!"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Converts to `UInt8`. Truncates anything on the right side of the decimal point.\nRaises `OverflowError` in case of overflow.","summary":"<p>Converts to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":514,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"to_big_u.to_u8"}},{"html_id":"to_u8!-instance-method","name":"to_u8!","doc":"Converts to `UInt8`. Truncates anything on the right side of the decimal point,\nconverting negative to positive.\nIn case of overflow a wrapping is performed.","summary":"<p>Converts to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":527,"url":null},"def":{"name":"to_u8!","visibility":"Public","body":"to_big_u!.to_u8!"}},{"html_id":"trunc:BigDecimal-instance-method","name":"trunc","doc":"Rounds towards zero.","summary":"<p>Rounds towards zero.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":310,"url":null},"def":{"name":"trunc","return_type":"BigDecimal","visibility":"Public","body":"round_impl do\n  false\nend"}},{"html_id":"value:BigInt-instance-method","name":"value","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":27,"url":null},"def":{"name":"value","return_type":"BigInt","visibility":"Public","body":"@value"}},{"html_id":"zero?:Bool-instance-method","name":"zero?","doc":"Returns `true` if `self` is equal to zero.\n\n```\n0.zero? # => true\n5.zero? # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to zero.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":262,"url":null},"def":{"name":"zero?","return_type":"Bool","visibility":"Public","body":"@value.zero?"}}]},{"html_id":"Crystal/BigFloat","path":"BigFloat.html","kind":"struct","full_name":"BigFloat","name":"BigFloat","abstract":false,"superclass":{"html_id":"Crystal/Float","kind":"struct","full_name":"Float","name":"Float"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Float","kind":"struct","full_name":"Float","name":"Float"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big.cr","line_number":5,"url":null},{"filename":"src/big/big_float.cr","line_number":7,"url":null},{"filename":"src/big/number.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"doc":"A `BigFloat` can represent arbitrarily large floats.\n\nIt is implemented under the hood with [GMP](https://gmplib.org/).","summary":"<p>A <code><a href=\"BigFloat.html\">BigFloat</a></code> can represent arbitrarily large floats.</p>","class_methods":[{"html_id":"default_precision-class-method","name":"default_precision","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":88,"url":null},"def":{"name":"default_precision","visibility":"Public","body":"LibGMP.mpf_get_default_prec"}},{"html_id":"default_precision=(prec:Int)-class-method","name":"default_precision=","abstract":false,"args":[{"name":"prec","external_name":"prec","restriction":"Int"}],"args_string":"(prec : Int)","args_html":"(prec : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/big/big_float.cr","line_number":92,"url":null},"def":{"name":"default_precision=","args":[{"name":"prec","external_name":"prec","restriction":"Int"}],"visibility":"Public","body":"LibGMP.mpf_set_default_prec(prec.to_u64)"}}],"constructors":[{"html_id":"new(num:Float,precision:Int)-class-method","name":"new","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"Float"},{"name":"precision","external_name":"precision","restriction":"Int"}],"args_string":"(num : Float, precision : Int)","args_html":"(num : <a href=\"Float.html\">Float</a>, precision : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/big/big_float.cr","line_number":71,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"Float"},{"name":"precision","external_name":"precision","restriction":"Int"}],"visibility":"Public","body":"_ = allocate\n_.initialize(num, precision)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(str:String)-class-method","name":"new","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"String"}],"args_string":"(str : String)","args_html":"(str : <a href=\"String.html\">String</a>)","location":{"filename":"src/big/big_float.cr","line_number":16,"url":null},"def":{"name":"new","args":[{"name":"str","external_name":"str","restriction":"String"}],"visibility":"Public","body":"_ = allocate\n_.initialize(str)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:BigInt)-class-method","name":"new","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"BigInt"}],"args_string":"(num : BigInt)","args_html":"(num : <a href=\"BigInt.html\">BigInt</a>)","location":{"filename":"src/big/big_float.cr","line_number":26,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"BigInt"}],"visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:BigRational)-class-method","name":"new","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"BigRational"}],"args_string":"(num : BigRational)","args_html":"(num : <a href=\"BigRational.html\">BigRational</a>)","location":{"filename":"src/big/big_float.cr","line_number":31,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"BigRational"}],"visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:BigFloat)-class-method","name":"new","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"BigFloat"}],"args_string":"(num : BigFloat)","args_html":"(num : <a href=\"BigFloat.html\">BigFloat</a>)","location":{"filename":"src/big/big_float.cr","line_number":36,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"BigFloat"}],"visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:Int8|Int16|Int32)-class-method","name":"new","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"Int8 | Int16 | Int32"}],"args_string":"(num : Int8 | Int16 | Int32)","args_html":"(num : <a href=\"Int8.html\">Int8</a> | <a href=\"Int16.html\">Int16</a> | <a href=\"Int32.html\">Int32</a>)","location":{"filename":"src/big/big_float.cr","line_number":41,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"Int8 | Int16 | Int32"}],"visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:UInt8|UInt16|UInt32)-class-method","name":"new","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"UInt8 | UInt16 | UInt32"}],"args_string":"(num : UInt8 | UInt16 | UInt32)","args_html":"(num : <a href=\"UInt8.html\">UInt8</a> | <a href=\"UInt16.html\">UInt16</a> | <a href=\"UInt32.html\">UInt32</a>)","location":{"filename":"src/big/big_float.cr","line_number":45,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"UInt8 | UInt16 | UInt32"}],"visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:Int64)-class-method","name":"new","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"Int64"}],"args_string":"(num : Int64)","args_html":"(num : <a href=\"Int64.html\">Int64</a>)","location":{"filename":"src/big/big_float.cr","line_number":49,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"Int64"}],"visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:UInt64)-class-method","name":"new","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"UInt64"}],"args_string":"(num : UInt64)","args_html":"(num : <a href=\"UInt64.html\">UInt64</a>)","location":{"filename":"src/big/big_float.cr","line_number":58,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"UInt64"}],"visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:Number)-class-method","name":"new","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"Number"}],"args_string":"(num : Number)","args_html":"(num : <a href=\"Number.html\">Number</a>)","location":{"filename":"src/big/big_float.cr","line_number":67,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"Number"}],"visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(mpf:LibGMP::MPF)-class-method","name":"new","abstract":false,"args":[{"name":"mpf","external_name":"mpf","restriction":"LibGMP::MPF"}],"args_string":"(mpf : LibGMP::MPF)","args_html":"(mpf : LibGMP::MPF)","location":{"filename":"src/big/big_float.cr","line_number":76,"url":null},"def":{"name":"new","args":[{"name":"mpf","external_name":"mpf","restriction":"LibGMP::MPF"}],"visibility":"Public","body":"_ = allocate\n_.initialize(mpf)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":12,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(&)-class-method","name":"new","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":79,"url":null},"def":{"name":"new","yields":1,"visibility":"Public","body":"LibGMP.mpf_init(out mpf)\nyield pointerof(mpf)\nnew(mpf)\n"}}],"instance_methods":[{"html_id":"*(other:Number):BigFloat-instance-method","name":"*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Number"}],"args_string":"(other : Number) : BigFloat","args_html":"(other : <a href=\"Number.html\">Number</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/big_float.cr","line_number":130,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Number"}],"return_type":"BigFloat","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_mul(mpf, self, other.to_big_f)\nend"}},{"html_id":"**(other:Int):BigFloat-instance-method","name":"**","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigFloat","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/big_float.cr","line_number":144,"url":null},"def":{"name":"**","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigFloat","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_pow_ui(mpf, self, other.to_u64)\nend"}},{"html_id":"+(other:Number):BigFloat-instance-method","name":"+","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Number"}],"args_string":"(other : Number) : BigFloat","args_html":"(other : <a href=\"Number.html\">Number</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/big_float.cr","line_number":122,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Number"}],"return_type":"BigFloat","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_add(mpf, self, other.to_big_f)\nend"}},{"html_id":"-(other:Number):BigFloat-instance-method","name":"-","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Number"}],"args_string":"(other : Number) : BigFloat","args_html":"(other : <a href=\"Number.html\">Number</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/big_float.cr","line_number":126,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Number"}],"return_type":"BigFloat","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_sub(mpf, self, other.to_big_f)\nend"}},{"html_id":"-:BigFloat-instance-method","name":"-","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":118,"url":null},"def":{"name":"-","return_type":"BigFloat","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_neg(mpf, self)\nend"}},{"html_id":"/(other:BigFloat):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigFloat","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/big_float.cr","line_number":134,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"if other == 0\n  raise(DivisionByZeroError.new)\nend\nBigFloat.new do |mpf|\n  LibGMP.mpf_div(mpf, self, other)\nend\n"}},{"html_id":"/(other:BigInt):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigFloat","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/big_float.cr","line_number":140,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_float.cr","line_number":141,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_float.cr","line_number":142,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:UInt8|UInt16|UInt32|UInt64):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8 | UInt16 | UInt32 | UInt64"}],"args_string":"(other : UInt8 | UInt16 | UInt32 | UInt64) : BigFloat","args_html":"(other : <a href=\"UInt8.html\">UInt8</a> | <a href=\"UInt16.html\">UInt16</a> | <a href=\"UInt32.html\">UInt32</a> | <a href=\"UInt64.html\">UInt64</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":11,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8 | UInt16 | UInt32 | UInt64"}],"return_type":"BigFloat","visibility":"Public","body":"if other == 0\n  raise(DivisionByZeroError.new)\nend\nif other.is_a?(UInt8 | UInt16 | UInt32) || ((LibGMP::ULong == UInt64) && other.is_a?(UInt64))\n  BigFloat.new do |mpf|\n    LibGMP.mpf_div_ui(mpf, self, other)\n  end\nelse\n  BigFloat.new do |mpf|\n    LibGMP.mpf_div(mpf, self, other.to_big_f)\n  end\nend\n"}},{"html_id":"/(other:Int8):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : BigFloat","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":21,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:Int16):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : BigFloat","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":21,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:Int32):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : BigFloat","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":21,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:Int64):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : BigFloat","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":21,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:Int128):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : BigFloat","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":21,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:UInt128):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : BigFloat","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":21,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:Float32):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : BigFloat","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":22,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:Float64):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : BigFloat","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":22,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"<=>(other:BigFloat)-instance-method","name":"<=>","doc":"The comparison operator. Returns `0` if the two objects are equal,\na negative number if this object is considered less than *other*,\na positive number if this object is considered greater than *other*,\nor `nil` if the two objects are not comparable.\n\nSubclasses define this method to provide class-specific ordering.\n\nThe comparison operator is usually used to sort values:\n\n```\n# Sort in a descending way:\n[3, 1, 2].sort { |x, y| y <=> x } # => [3, 2, 1]\n\n# Sort in an ascending way:\n[3, 1, 2].sort { |x, y| x <=> y } # => [1, 2, 3]\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat)","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>)","location":{"filename":"src/big/big_float.cr","line_number":96,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"visibility":"Public","body":"LibGMP.mpf_cmp(self, other)"}},{"html_id":"<=>(other:BigInt)-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt)","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>)","location":{"filename":"src/big/big_float.cr","line_number":100,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"visibility":"Public","body":"LibGMP.mpf_cmp_z(self, other)"}},{"html_id":"<=>(other:Float32|Float64)-instance-method","name":"<=>","doc":"The comparison operator. Returns `0` if the two objects are equal,\na negative number if this object is considered less than *other*,\na positive number if this object is considered greater than *other*,\nor `nil` if the two objects are not comparable.\n\nSubclasses define this method to provide class-specific ordering.\n\nThe comparison operator is usually used to sort values:\n\n```\n# Sort in a descending way:\n[3, 1, 2].sort { |x, y| y <=> x } # => [3, 2, 1]\n\n# Sort in an ascending way:\n[3, 1, 2].sort { |x, y| x <=> y } # => [1, 2, 3]\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32 | Float64"}],"args_string":"(other : Float32 | Float64)","args_html":"(other : <a href=\"Float32.html\">Float32</a> | <a href=\"Float64.html\">Float64</a>)","location":{"filename":"src/big/big_float.cr","line_number":104,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Float32 | Float64"}],"visibility":"Public","body":"LibGMP.mpf_cmp_d(self, other.to_f64)"}},{"html_id":"<=>(other:Number)-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Number"}],"args_string":"(other : Number)","args_html":"(other : <a href=\"Number.html\">Number</a>)","location":{"filename":"src/big/big_float.cr","line_number":108,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Number"}],"visibility":"Public","body":"if other.is_a?(Int8 | Int16 | Int32) || ((LibGMP::Long == Int64) && other.is_a?(Int64))\n  LibGMP.mpf_cmp_si(self, other)\nelse\n  if other.is_a?(UInt8 | UInt16 | UInt32) || ((LibGMP::ULong == UInt64) && other.is_a?(UInt64))\n    LibGMP.mpf_cmp_ui(self, other)\n  else\n    LibGMP.mpf_cmp(self, other.to_big_f)\n  end\nend"}},{"html_id":"abs:BigFloat-instance-method","name":"abs","doc":"Returns the absolute value of this number.\n\n```\n123.abs  # => 123\n-123.abs # => 123\n```","summary":"<p>Returns the absolute value of this number.</p>","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":148,"url":null},"def":{"name":"abs","return_type":"BigFloat","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_abs(mpf, self)\nend"}},{"html_id":"ceil:BigFloat-instance-method","name":"ceil","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":152,"url":null},"def":{"name":"ceil","return_type":"BigFloat","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_ceil(mpf, self)\nend"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":309,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"fdiv(other:Number::Primitive):self-instance-method","name":"fdiv","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Number::Primitive"}],"args_string":"(other : Number::Primitive) : self","args_html":"(other : <a href=\"Number/Primitive.html\">Number::Primitive</a>) : <span class=\"k\">self</span>","location":{"filename":"src/big/number.cr","line_number":7,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"Number::Primitive"}],"return_type":"self","visibility":"Public","body":"self.class.new(self / other)"}},{"html_id":"floor:BigFloat-instance-method","name":"floor","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":156,"url":null},"def":{"name":"floor","return_type":"BigFloat","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_floor(mpf, self)\nend"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"TODO: improve this","summary":"<p><span class=\"flag orange\">TODO</span>  improve this</p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/big/big_float.cr","line_number":86,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = to_f64.hash(hasher)\nhasher\n"}},{"html_id":"round_away:self-instance-method","name":"round_away","doc":"Rounds towards the nearest integer. If both neighboring integers are equidistant,\nrounds away from zero.","summary":"<p>Rounds towards the nearest integer.</p>","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":338,"url":null},"def":{"name":"round_away","return_type":"self","visibility":"Public","body":"if self >= 0\n  (self + 0.5).floor\nelse\n  (self - 0.5).ceil\nend"}},{"html_id":"round_even:self-instance-method","name":"round_even","doc":"Rounds towards the nearest integer. If both neighboring integers are equidistant,\nrounds towards the even neighbor (Banker's rounding).","summary":"<p>Rounds towards the nearest integer.</p>","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":315,"url":null},"def":{"name":"round_even","return_type":"self","visibility":"Public","body":"if self >= 0\n  halfway = self + 0.5\nelse\n  halfway = self - 0.5\nend\nif halfway.integer?\n  if halfway == ((halfway / 2).trunc * 2)\n    halfway\n  else\n    halfway - sign\n  end\nelse\n  if self >= 0\n    halfway.floor\n  else\n    halfway.ceil\n  end\nend\n"}},{"html_id":"to_big_f:BigFloat-instance-method","name":"to_big_f","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":188,"url":null},"def":{"name":"to_big_f","return_type":"BigFloat","visibility":"Public","body":"self"}},{"html_id":"to_big_i:BigInt-instance-method","name":"to_big_i","doc":"Returns a `BigInt` representing this float (rounded using `floor`).\n```\nrequire \"big\"\n\n1212341515125412412412421.0.to_big_i\n```","summary":"<p>Returns a <code><a href=\"BigInt.html\">BigInt</a></code> representing this float (rounded using <code><a href=\"BigFloat.html#floor%3ABigFloat-instance-method\">#floor</a></code>).</p>","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":192,"url":null},"def":{"name":"to_big_i","return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.set_f(mpz, mpf)\nend"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":172,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"to_f64"}},{"html_id":"to_f!:Float64-instance-method","name":"to_f!","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":184,"url":null},"def":{"name":"to_f!","return_type":"Float64","visibility":"Public","body":"to_f64!"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":168,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"to_f64.to_f32"}},{"html_id":"to_f32!:Float32-instance-method","name":"to_f32!","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":176,"url":null},"def":{"name":"to_f32!","return_type":"Float32","visibility":"Public","body":"to_f64.to_f32!"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":164,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"LibGMP.mpf_get_d(self)"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":180,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"to_f64"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":213,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"to_i32"}},{"html_id":"to_i!:Int32-instance-method","name":"to_i!","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":217,"url":null},"def":{"name":"to_i!","return_type":"Int32","visibility":"Public","body":"to_i32!"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":205,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"to_i64.to_i16"}},{"html_id":"to_i16!:Int16-instance-method","name":"to_i16!","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":225,"url":null},"def":{"name":"to_i16!","return_type":"Int16","visibility":"Public","body":"(LibGMP.mpf_get_si(self)).to_i16!"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":201,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"to_i64.to_i32"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":229,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"(LibGMP.mpf_get_si(self)).to_i32!"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":196,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"if LibGMP::Long::MIN <= self && self <= LibGMP::Long::MAX\nelse\n  raise(OverflowError.new)\nend\n(LibGMP.mpf_get_si(self)).to_i64!\n"}},{"html_id":"to_i64!:Int64-instance-method","name":"to_i64!","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":233,"url":null},"def":{"name":"to_i64!","return_type":"Int64","visibility":"Public","body":"(LibGMP.mpf_get_si(self)).to_i64!"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":209,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"to_i64.to_i8"}},{"html_id":"to_i8!:Int8-instance-method","name":"to_i8!","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":221,"url":null},"def":{"name":"to_i8!","return_type":"Int8","visibility":"Public","body":"(LibGMP.mpf_get_si(self)).to_i8!"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a `String` representation of this object\nto the given `IO` object.\n\nAn object must never append itself to the io argument,\nas this will in turn call `to_s(io)` on it.","summary":"<p>Appends a <code><a href=\"String.html\">String</a></code> representation of this object to the given <code><a href=\"IO.html\">IO</a></code> object.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/big/big_float.cr","line_number":282,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"cstr = LibGMP.mpf_get_str(nil, out expptr, 10, 0, self)\nlength = LibC.strlen(cstr)\ndecimal_set = false\nif self < 0\n  io << '-'\nend\nif expptr == 0\n  io << 0\nelse\n  if expptr < 0\n    (io << 0) << '.'\n    decimal_set = true\n    expptr.abs.times do\n      io << 0\n    end\n  end\nend\nif self < 0\n  expptr = expptr + 1\nend\nlength.times do |i|\n  if cstr[i] == 45\n    next\n  end\n  if i == expptr\n    io << '.'\n    decimal_set = true\n  end\n  io << cstr[i].unsafe_chr\nend\nif expptr > 0\n  (expptr - length).times do\n    io << 0\n  end\nend\nif !decimal_set\n  io << \".0\"\nend\n"}},{"html_id":"to_u:UInt32-instance-method","name":"to_u","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":254,"url":null},"def":{"name":"to_u","return_type":"UInt32","visibility":"Public","body":"to_u32"}},{"html_id":"to_u!:UInt32-instance-method","name":"to_u!","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":258,"url":null},"def":{"name":"to_u!","return_type":"UInt32","visibility":"Public","body":"to_u32!"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":246,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"to_u64.to_u16"}},{"html_id":"to_u16!:UInt16-instance-method","name":"to_u16!","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":266,"url":null},"def":{"name":"to_u16!","return_type":"UInt16","visibility":"Public","body":"(LibGMP.mpf_get_ui(self)).to_u16!"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":242,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"to_u64.to_u32"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":270,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"(LibGMP.mpf_get_ui(self)).to_u32!"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":237,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"if 0 <= self && self <= LibGMP::ULong::MAX\nelse\n  raise(OverflowError.new)\nend\n(LibGMP.mpf_get_ui(self)).to_u64!\n"}},{"html_id":"to_u64!:UInt64-instance-method","name":"to_u64!","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":274,"url":null},"def":{"name":"to_u64!","return_type":"UInt64","visibility":"Public","body":"(LibGMP.mpf_get_ui(self)).to_u64!"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":250,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"to_u64.to_u8"}},{"html_id":"to_u8!:UInt8-instance-method","name":"to_u8!","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":262,"url":null},"def":{"name":"to_u8!","return_type":"UInt8","visibility":"Public","body":"(LibGMP.mpf_get_ui(self)).to_u8!"}},{"html_id":"to_unsafe-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":278,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"mpf"}},{"html_id":"trunc:BigFloat-instance-method","name":"trunc","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":160,"url":null},"def":{"name":"trunc","return_type":"BigFloat","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_trunc(mpf, self)\nend"}}]},{"html_id":"Crystal/BigInt","path":"BigInt.html","kind":"struct","full_name":"BigInt","name":"BigInt","abstract":false,"superclass":{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big.cr","line_number":2,"url":null},{"filename":"src/big/big_int.cr","line_number":8,"url":null},{"filename":"src/big/number.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"doc":"A `BigInt` can represent arbitrarily large integers.\n\nIt is implemented under the hood with [GMP](https://gmplib.org/).","summary":"<p>A <code><a href=\"BigInt.html\">BigInt</a></code> can represent arbitrarily large integers.</p>","constructors":[{"html_id":"new(str:String,base=10)-class-method","name":"new","doc":"Creates a `BigInt` with the value denoted by *str* in the given *base*.\n\nRaises `ArgumentError` if the string doesn't denote a valid integer.\n\n```\nrequire \"big\"\n\nBigInt.new(\"123456789123456789123456789123456789\") # => 123456789123456789123456789123456789\nBigInt.new(\"123_456_789_123_456_789_123_456_789\")  # => 123456789123456789123456789\nBigInt.new(\"1234567890ABCDEF\", base: 16)           # => 1311768467294899695\n```","summary":"<p>Creates a <code><a href=\"BigInt.html\">BigInt</a></code> with the value denoted by <em>str</em> in the given <em>base</em>.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":""}],"args_string":"(str : String, base = 10)","args_html":"(str : <a href=\"String.html\">String</a>, base = <span class=\"n\">10</span>)","location":{"filename":"src/big/big_int.cr","line_number":36,"url":null},"def":{"name":"new","args":[{"name":"str","external_name":"str","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(str, base)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:Int::Signed)-class-method","name":"new","doc":"Creates a `BigInt` from the given *num*.","summary":"<p>Creates a <code><a href=\"BigInt.html\">BigInt</a></code> from the given <em>num</em>.</p>","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"Int::Signed"}],"args_string":"(num : Int::Signed)","args_html":"(num : <a href=\"Int/Signed.html\">Int::Signed</a>)","location":{"filename":"src/big/big_int.cr","line_number":48,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"Int::Signed"}],"visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:Int::Unsigned)-class-method","name":"new","doc":"Creates a `BigInt` from the given *num*.","summary":"<p>Creates a <code><a href=\"BigInt.html\">BigInt</a></code> from the given <em>num</em>.</p>","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"Int::Unsigned"}],"args_string":"(num : Int::Unsigned)","args_html":"(num : <a href=\"Int/Unsigned.html\">Int::Unsigned</a>)","location":{"filename":"src/big/big_int.cr","line_number":57,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"Int::Unsigned"}],"visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:Float::Primitive)-class-method","name":"new","doc":"Creates a `BigInt` from the given *num*.","summary":"<p>Creates a <code><a href=\"BigInt.html\">BigInt</a></code> from the given <em>num</em>.</p>","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"Float::Primitive"}],"args_string":"(num : Float::Primitive)","args_html":"(num : <a href=\"Float/Primitive.html\">Float::Primitive</a>)","location":{"filename":"src/big/big_int.cr","line_number":66,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"Float::Primitive"}],"visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:BigFloat)-class-method","name":"new","doc":"Creates a `BigInt` from the given *num*.","summary":"<p>Creates a <code><a href=\"BigInt.html\">BigInt</a></code> from the given <em>num</em>.</p>","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"BigFloat"}],"args_string":"(num : BigFloat)","args_html":"(num : <a href=\"BigFloat.html\">BigFloat</a>)","location":{"filename":"src/big/big_int.cr","line_number":71,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"BigFloat"}],"visibility":"Public","body":"num.to_big_i"}},{"html_id":"new(num:BigDecimal)-class-method","name":"new","doc":"Creates a `BigInt` from the given *num*.","summary":"<p>Creates a <code><a href=\"BigInt.html\">BigInt</a></code> from the given <em>num</em>.</p>","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"BigDecimal"}],"args_string":"(num : BigDecimal)","args_html":"(num : <a href=\"BigDecimal.html\">BigDecimal</a>)","location":{"filename":"src/big/big_int.cr","line_number":76,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"BigDecimal"}],"visibility":"Public","body":"num.to_big_i"}},{"html_id":"new(num:BigRational)-class-method","name":"new","doc":"Creates a `BigInt` from the given *num*.","summary":"<p>Creates a <code><a href=\"BigInt.html\">BigInt</a></code> from the given <em>num</em>.</p>","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"BigRational"}],"args_string":"(num : BigRational)","args_html":"(num : <a href=\"BigRational.html\">BigRational</a>)","location":{"filename":"src/big/big_int.cr","line_number":81,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"BigRational"}],"visibility":"Public","body":"num.to_big_i"}},{"html_id":"new(num:BigInt)-class-method","name":"new","doc":"Returns *num*. Useful for generic code that does `T.new(...)` with `T`\nbeing a `Number`.","summary":"<p>Returns <em>num</em>.</p>","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"BigInt"}],"args_string":"(num : BigInt)","args_html":"(num : <a href=\"BigInt.html\">BigInt</a>)","location":{"filename":"src/big/big_int.cr","line_number":87,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"BigInt"}],"visibility":"Public","body":"num"}},{"html_id":"new-class-method","name":"new","doc":"Creates a `BigInt` with the value zero.\n\n```\nrequire \"big\"\n\nBigInt.new # => 0\n```","summary":"<p>Creates a <code><a href=\"BigInt.html\">BigInt</a></code> with the value zero.</p>","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":21,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"%(other:Int):BigInt-instance-method","name":"%","doc":"Returns `self` modulo *other*.\n\nThis uses floored division.\n\nSee `Int#/` for more details.","summary":"<p>Returns <code>self</code> modulo <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":252,"url":null},"def":{"name":"%","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"check_division_by_zero(other)\nif other < 0\n  -((-self).unsafe_floored_mod(-other))\nelse\n  unsafe_floored_mod(other)\nend\n"}},{"html_id":"&(other:Int):BigInt-instance-method","name":"&","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":351,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.and(mpz, self, other.to_big_i)\nend"}},{"html_id":"&*(other):BigInt-instance-method","name":"&*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other) : BigInt","args_html":"(other) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":195,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":""}],"return_type":"BigInt","visibility":"Public","body":"self * other"}},{"html_id":"&+(other):BigInt-instance-method","name":"&+","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other) : BigInt","args_html":"(other) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":140,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":""}],"return_type":"BigInt","visibility":"Public","body":"self + other"}},{"html_id":"&-(other):BigInt-instance-method","name":"&-","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other) : BigInt","args_html":"(other) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":158,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":""}],"return_type":"BigInt","visibility":"Public","body":"self - other"}},{"html_id":"*(other:BigInt):BigInt-instance-method","name":"*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":179,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.mul(mpz, self, other)\nend"}},{"html_id":"*(other:LibGMP::IntPrimitiveSigned):BigInt-instance-method","name":"*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"LibGMP::IntPrimitiveSigned"}],"args_string":"(other : LibGMP::IntPrimitiveSigned) : BigInt","args_html":"(other : LibGMP::IntPrimitiveSigned) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":183,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"LibGMP::IntPrimitiveSigned"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.mul_si(mpz, self, other)\nend"}},{"html_id":"*(other:LibGMP::IntPrimitiveUnsigned):BigInt-instance-method","name":"*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"LibGMP::IntPrimitiveUnsigned"}],"args_string":"(other : LibGMP::IntPrimitiveUnsigned) : BigInt","args_html":"(other : LibGMP::IntPrimitiveUnsigned) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":187,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"LibGMP::IntPrimitiveUnsigned"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.mul_ui(mpz, self, other)\nend"}},{"html_id":"*(other:Int):BigInt-instance-method","name":"*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":191,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"self * other.to_big_i"}},{"html_id":"**(other:Int):BigInt-instance-method","name":"**","doc":"Returns the value of raising `self` to the power of *exponent*.\n\nRaises `ArgumentError` if *exponent* is negative: if this is needed,\neither use a float base or a float exponent.\n\nRaises `OverflowError` in case of overflow.\n\n```\n2 ** 3  # => 8\n2 ** 0  # => 1\n2 ** -1 # ArgumentError\n```","summary":"<p>Returns the value of raising <code>self</code> to the power of <em>exponent</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":378,"url":null},"def":{"name":"**","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"if other < 0\n  raise(ArgumentError.new(\"Negative exponent isn't supported\"))\nend\nBigInt.new do |mpz|\n  LibGMP.pow_ui(mpz, self, other)\nend\n"}},{"html_id":"+(other:BigInt):BigInt-instance-method","name":"+","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":126,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.add(mpz, self, other)\nend"}},{"html_id":"+(other:Int):BigInt-instance-method","name":"+","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":130,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"if other < 0\n  self - other.abs\nelse\n  if other <= LibGMP::ULong::MAX\n    BigInt.new do |mpz|\n      LibGMP.add_ui(mpz, self, other)\n    end\n  else\n    self + other.to_big_i\n  end\nend"}},{"html_id":"-(other:BigInt):BigInt-instance-method","name":"-","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":144,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.sub(mpz, self, other)\nend"}},{"html_id":"-(other:Int):BigInt-instance-method","name":"-","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":148,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"if other < 0\n  self + other.abs\nelse\n  if other <= LibGMP::ULong::MAX\n    BigInt.new do |mpz|\n      LibGMP.sub_ui(mpz, self, other)\n    end\n  else\n    self - other.to_big_i\n  end\nend"}},{"html_id":"-:BigInt-instance-method","name":"-","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":162,"url":null},"def":{"name":"-","return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.neg(mpz, self)\nend"}},{"html_id":"/(other:BigInt):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigFloat","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/big_int.cr","line_number":199,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_int.cr","line_number":200,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_int.cr","line_number":201,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:Int8):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : BigFloat","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":2,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:UInt8):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : BigFloat","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":2,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:Int16):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : BigFloat","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":2,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:UInt16):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : BigFloat","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":2,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:Int32):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : BigFloat","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":2,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:UInt32):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : BigFloat","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":2,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:Int64):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : BigFloat","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":2,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:UInt64):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : BigFloat","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":2,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:Int128):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : BigFloat","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":2,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:UInt128):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : BigFloat","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":2,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:Float32):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : BigFloat","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":3,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:Float64):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : BigFloat","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":3,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"//(other:Int::Unsigned):BigInt-instance-method","name":"//","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int::Unsigned"}],"args_string":"(other : Int::Unsigned) : BigInt","args_html":"(other : <a href=\"Int/Unsigned.html\">Int::Unsigned</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":203,"url":null},"def":{"name":"//","args":[{"name":"other","external_name":"other","restriction":"Int::Unsigned"}],"return_type":"BigInt","visibility":"Public","body":"check_division_by_zero(other)\nunsafe_floored_div(other)\n"}},{"html_id":"//(other:Int):BigInt-instance-method","name":"//","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":208,"url":null},"def":{"name":"//","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"check_division_by_zero(other)\nif other < 0\n  (-self).unsafe_floored_div(-other)\nelse\n  unsafe_floored_div(other)\nend\n"}},{"html_id":"<<(other:Int):BigInt-instance-method","name":"<<","doc":"Returns the result of shifting this number's bits *count* positions to the left.\n\n* If *count* is greater than the number of bits of this integer, returns 0\n* If *count* is negative, a right shift is performed\n\n```\n8000 << 1  # => 16000\n8000 << 2  # => 32000\n8000 << 32 # => 0\n8000 << -1 # => 4000\n```","summary":"<p>Returns the result of shifting this number's bits <em>count</em> positions to the left.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":374,"url":null},"def":{"name":"<<","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.mul_2exp(mpz, self, other)\nend"}},{"html_id":"<=>(other:BigInt)-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt)","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>)","location":{"filename":"src/big/big_int.cr","line_number":102,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"visibility":"Public","body":"LibGMP.cmp(mpz, other)"}},{"html_id":"<=>(other:Int::Signed)-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int::Signed"}],"args_string":"(other : Int::Signed)","args_html":"(other : <a href=\"Int/Signed.html\">Int::Signed</a>)","location":{"filename":"src/big/big_int.cr","line_number":106,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Int::Signed"}],"visibility":"Public","body":"if LibC::Long::MIN <= other && other <= LibC::Long::MAX\n  LibGMP.cmp_si(mpz, other)\nelse\n  self <=> (BigInt.new(other))\nend"}},{"html_id":"<=>(other:Int::Unsigned)-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int::Unsigned"}],"args_string":"(other : Int::Unsigned)","args_html":"(other : <a href=\"Int/Unsigned.html\">Int::Unsigned</a>)","location":{"filename":"src/big/big_int.cr","line_number":114,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Int::Unsigned"}],"visibility":"Public","body":"if other <= LibC::ULong::MAX\n  LibGMP.cmp_ui(mpz, other)\nelse\n  self <=> (BigInt.new(other))\nend"}},{"html_id":"<=>(other:Float)-instance-method","name":"<=>","doc":"The comparison operator. Returns `0` if the two objects are equal,\na negative number if this object is considered less than *other*,\na positive number if this object is considered greater than *other*,\nor `nil` if the two objects are not comparable.\n\nSubclasses define this method to provide class-specific ordering.\n\nThe comparison operator is usually used to sort values:\n\n```\n# Sort in a descending way:\n[3, 1, 2].sort { |x, y| y <=> x } # => [3, 2, 1]\n\n# Sort in an ascending way:\n[3, 1, 2].sort { |x, y| x <=> y } # => [1, 2, 3]\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float"}],"args_string":"(other : Float)","args_html":"(other : <a href=\"Float.html\">Float</a>)","location":{"filename":"src/big/big_int.cr","line_number":122,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Float"}],"visibility":"Public","body":"LibGMP.cmp_d(mpz, other)"}},{"html_id":">>(other:Int):BigInt-instance-method","name":">>","doc":"Returns the result of shifting this number's bits *count* positions to the right.\nAlso known as arithmetic right shift.\n\n* If *count* is greater than the number of bits of this integer, returns 0\n* If *count* is negative, a left shift is performed\n\n```\n8000 >> 1  # => 4000\n8000 >> 2  # => 2000\n8000 >> 32 # => 0\n8000 >> -1 # => 16000\n\n-8000 >> 1 # => -4000\n```","summary":"<p>Returns the result of shifting this number's bits <em>count</em> positions to the right.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":363,"url":null},"def":{"name":">>","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.fdiv_q_2exp(mpz, self, other)\nend"}},{"html_id":"^(other:Int):BigInt-instance-method","name":"^","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":359,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.xor(mpz, self, other.to_big_i)\nend"}},{"html_id":"abs:BigInt-instance-method","name":"abs","doc":"Returns the absolute value of this number.\n\n```\n123.abs  # => 123\n-123.abs # => 123\n```","summary":"<p>Returns the absolute value of this number.</p>","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":166,"url":null},"def":{"name":"abs","return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.abs(mpz, self)\nend"}},{"html_id":"bit_length:Int32-instance-method","name":"bit_length","doc":"Returns the number of bits of this int value.\n\n“The number of bits” means that the bit position of the highest bit\nwhich is different to the sign bit.\n(The bit position of the bit 2**n is n+1.)\nIf there is no such bit (zero or minus one), zero is returned.\n\nI.e. This method returns `ceil(log2(self < 0 ? -self : self + 1))`.\n\n```\n0.bit_length # => 0\n1.bit_length # => 1\n2.bit_length # => 2\n3.bit_length # => 2\n4.bit_length # => 3\n5.bit_length # => 3\n\n# The above is the same as\n0b0.bit_length   # => 0\n0b1.bit_length   # => 1\n0b10.bit_length  # => 2\n0b11.bit_length  # => 2\n0b100.bit_length # => 3\n0b101.bit_length # => 3\n```","summary":"<p>Returns the number of bits of this int value.</p>","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":406,"url":null},"def":{"name":"bit_length","return_type":"Int32","visibility":"Public","body":"(LibGMP.sizeinbase(self, 2)).to_i"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":687,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"digits(base=10):Array(Int32)-instance-method","name":"digits","doc":"Returns the digits of a number in a given base.\nThe digits are returned as an array with the least significant digit as the first array element.\n\n```\n12345.digits      # => [5, 4, 3, 2, 1]\n12345.digits(7)   # => [4, 6, 6, 0, 5]\n12345.digits(100) # => [45, 23, 1]\n\n-12345.digits(7) # => ArgumentError\n```","summary":"<p>Returns the digits of a number in a given base.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":""}],"args_string":"(base = 10) : Array(Int32)","args_html":"(base = <span class=\"n\">10</span>) : <a href=\"Array.html\">Array</a>(<a href=\"Int32.html\">Int32</a>)","location":{"filename":"src/big/big_int.cr","line_number":538,"url":null},"def":{"name":"digits","args":[{"name":"base","default_value":"10","external_name":"base","restriction":""}],"return_type":"Array(Int32)","visibility":"Public","body":"if self < 0\n  raise(ArgumentError.new(\"Can't request digits of negative number\"))\nend\nary = [] of Int32\n(self.to_s(base)).each_char do |c|\n  ary << (c.to_i(base))\nend\nary.reverse!\nary\n"}},{"html_id":"divmod(number:BigInt):Tuple(BigInt,BigInt)-instance-method","name":"divmod","abstract":false,"args":[{"name":"number","external_name":"number","restriction":"BigInt"}],"args_string":"(number : BigInt) : Tuple(BigInt, BigInt)","args_html":"(number : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"BigInt.html\">BigInt</a>, <a href=\"BigInt.html\">BigInt</a>)","location":{"filename":"src/big/big_int.cr","line_number":268,"url":null},"def":{"name":"divmod","args":[{"name":"number","external_name":"number","restriction":"BigInt"}],"return_type":"::Tuple(BigInt, BigInt)","visibility":"Public","body":"check_division_by_zero(number)\nunsafe_floored_divmod(number)\n"}},{"html_id":"divmod(number:LibGMP::ULong)-instance-method","name":"divmod","abstract":false,"args":[{"name":"number","external_name":"number","restriction":"LibGMP::ULong"}],"args_string":"(number : LibGMP::ULong)","args_html":"(number : LibGMP::ULong)","location":{"filename":"src/big/big_int.cr","line_number":274,"url":null},"def":{"name":"divmod","args":[{"name":"number","external_name":"number","restriction":"LibGMP::ULong"}],"visibility":"Public","body":"check_division_by_zero(number)\nunsafe_floored_divmod(number)\n"}},{"html_id":"divmod(number:Int::Signed):Tuple(BigInt,BigInt)-instance-method","name":"divmod","abstract":false,"args":[{"name":"number","external_name":"number","restriction":"Int::Signed"}],"args_string":"(number : Int::Signed) : Tuple(BigInt, BigInt)","args_html":"(number : <a href=\"Int/Signed.html\">Int::Signed</a>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"BigInt.html\">BigInt</a>, <a href=\"BigInt.html\">BigInt</a>)","location":{"filename":"src/big/big_int.cr","line_number":279,"url":null},"def":{"name":"divmod","args":[{"name":"number","external_name":"number","restriction":"Int::Signed"}],"return_type":"::Tuple(BigInt, BigInt)","visibility":"Public","body":"check_division_by_zero(number)\nif number > 0 && number <= LibC::Long::MAX\n  unsafe_floored_divmod(LibGMP::ULong.new(number))\nelse\n  divmod(number.to_big_i)\nend\n"}},{"html_id":"divmod(number:Int::Unsigned)-instance-method","name":"divmod","abstract":false,"args":[{"name":"number","external_name":"number","restriction":"Int::Unsigned"}],"args_string":"(number : Int::Unsigned)","args_html":"(number : <a href=\"Int/Unsigned.html\">Int::Unsigned</a>)","location":{"filename":"src/big/big_int.cr","line_number":288,"url":null},"def":{"name":"divmod","args":[{"name":"number","external_name":"number","restriction":"Int::Unsigned"}],"visibility":"Public","body":"check_division_by_zero(number)\nif number <= LibC::ULong::MAX\n  unsafe_floored_divmod(LibGMP::ULong.new(number))\nelse\n  divmod(number.to_big_i)\nend\n"}},{"html_id":"factorial:BigInt-instance-method","name":"factorial","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":170,"url":null},"def":{"name":"factorial","return_type":"BigInt","visibility":"Public","body":"if self < 0\n  raise(ArgumentError.new(\"Factorial not defined for negative values\"))\nelse\n  if self > LibGMP::ULong::MAX\n    raise(ArgumentError.new(\"Factorial not supported for numbers bigger than 2^64\"))\n  end\nend\nBigInt.new do |mpz|\n  LibGMP.fac_ui(mpz, self)\nend\n"}},{"html_id":"gcd(other:BigInt):BigInt-instance-method","name":"gcd","doc":"Returns the greatest common divisor of `self` and *other*.","summary":"<p>Returns the greatest common divisor of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":386,"url":null},"def":{"name":"gcd","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.gcd(mpz, self, other)\nend"}},{"html_id":"gcd(other:Int):Int-instance-method","name":"gcd","doc":"Returns the greatest common divisor of `self` and *other*.","summary":"<p>Returns the greatest common divisor of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : Int","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"Int.html\">Int</a>","location":{"filename":"src/big/big_int.cr","line_number":391,"url":null},"def":{"name":"gcd","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"Int","visibility":"Public","body":"result = LibGMP.gcd_ui(nil, self, other.abs.to_u64)\nresult == 0 ? self : result\n"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"TODO: check hash equality for numbers >= 2**63","summary":"<p><span class=\"flag orange\">TODO</span>  check hash equality for numbers &gt;= 2**63</p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/big/big_int.cr","line_number":411,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = to_i64!.hash(hasher)\nhasher\n"}},{"html_id":"lcm(other:BigInt):BigInt-instance-method","name":"lcm","doc":"Returns the least common multiple of `self` and *other*.","summary":"<p>Returns the least common multiple of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":397,"url":null},"def":{"name":"lcm","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.lcm(mpz, self, other)\nend"}},{"html_id":"lcm(other:Int):BigInt-instance-method","name":"lcm","doc":"Returns the least common multiple of `self` and *other*.","summary":"<p>Returns the least common multiple of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":402,"url":null},"def":{"name":"lcm","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.lcm_ui(mpz, self, other.abs.to_u64)\nend"}},{"html_id":"popcount:Int-instance-method","name":"popcount","doc":"Counts `1`-bits in the binary representation of this integer.\n\n```\n5.popcount   # => 2\n-15.popcount # => 29\n```","summary":"<p>Counts <code>1</code>-bits in the binary representation of this integer.</p>","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":549,"url":null},"def":{"name":"popcount","return_type":"Int","visibility":"Public","body":"LibGMP.popcount(self)"}},{"html_id":"remainder(other:Int):BigInt-instance-method","name":"remainder","doc":"Returns `self` remainder *other*.\n\nThis uses truncated division.\n\nSee `Int#tdiv` for more details.","summary":"<p>Returns <code>self</code> remainder <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":262,"url":null},"def":{"name":"remainder","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"check_division_by_zero(other)\nunsafe_truncated_mod(other)\n"}},{"html_id":"tdiv(other:Int):BigInt-instance-method","name":"tdiv","doc":"Divides `self` by *other* using truncated division.\n\nIn truncated division, given two integers x and y:\n* `q = x.tdiv(y)` is rounded toward zero\n* `r = x.remainder(y)` has the sign of the first argument\n* `x == q*y + r`\n\nFor example:\n\n```text\n x     y     x / y     x % y\n 5     3       1         2\n-5     3      -1        -2\n 5    -3      -1         2\n-5    -3       1        -2\n```\n\nRaises if *other* is `0`, or if *other* is `-1` and\n`self` is signed and is the minimum value for that\ninteger type.","summary":"<p>Divides <code>self</code> by <em>other</em> using truncated division.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":218,"url":null},"def":{"name":"tdiv","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"check_division_by_zero(other)\nunsafe_truncated_div(other)\n"}},{"html_id":"to_big_d:BigDecimal-instance-method","name":"to_big_d","doc":"Converts `self` to `BigDecimal`.\n```\nrequire \"big\"\n12123415151254124124.to_big_d\n```","summary":"<p>Converts <code>self</code> to <code><a href=\"BigDecimal.html\">BigDecimal</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":679,"url":null},"def":{"name":"to_big_d","return_type":"BigDecimal","visibility":"Public","body":"BigDecimal.new(self)"}},{"html_id":"to_big_f:BigFloat-instance-method","name":"to_big_f","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":675,"url":null},"def":{"name":"to_big_f","return_type":"BigFloat","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_set_z(mpf, mpz)\nend"}},{"html_id":"to_big_i:BigInt-instance-method","name":"to_big_i","doc":"Returns a `BigInt` representing this integer.\n```\nrequire \"big\"\n\n123.to_big_i\n```","summary":"<p>Returns a <code><a href=\"BigInt.html\">BigInt</a></code> representing this integer.</p>","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":671,"url":null},"def":{"name":"to_big_i","return_type":"BigInt","visibility":"Public","body":"self"}},{"html_id":"to_big_r:BigRational-instance-method","name":"to_big_r","doc":"Returns a `BigRational` representing this integer.\n```\nrequire \"big\"\n\n123.to_big_r\n```","summary":"<p>Returns a <code><a href=\"BigRational.html\">BigRational</a></code> representing this integer.</p>","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":683,"url":null},"def":{"name":"to_big_r","return_type":"BigRational","visibility":"Public","body":"BigRational.new(self)"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":647,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"to_f64"}},{"html_id":"to_f!-instance-method","name":"to_f!","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":659,"url":null},"def":{"name":"to_f!","visibility":"Public","body":"to_f64!"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":651,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"to_f64.to_f32"}},{"html_id":"to_f32!-instance-method","name":"to_f32!","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":663,"url":null},"def":{"name":"to_f32!","visibility":"Public","body":"(LibGMP.get_d(self)).to_f32!"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":655,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"LibGMP.get_d(self)"}},{"html_id":"to_f64!-instance-method","name":"to_f64!","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":667,"url":null},"def":{"name":"to_f64!","visibility":"Public","body":"LibGMP.get_d(self)"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":557,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"to_i32"}},{"html_id":"to_i!-instance-method","name":"to_i!","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":581,"url":null},"def":{"name":"to_i!","visibility":"Public","body":"to_i32!"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":565,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"to_i32.to_i16"}},{"html_id":"to_i16!:Int16-instance-method","name":"to_i16!","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":589,"url":null},"def":{"name":"to_i16!","return_type":"Int16","visibility":"Public","body":"(LibGMP.get_si(self)).to_i16!"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":569,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"(LibGMP.get_si(self)).to_i32"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":593,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"(LibGMP.get_si(self)).to_i32!"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":573,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"if LibGMP::Long::MIN <= self && self <= LibGMP::Long::MAX\n  (LibGMP.get_si(self)).to_i64\nelse\n  to_s.to_i64 do\n    raise(OverflowError.new)\n  end\nend"}},{"html_id":"to_i64!:Int64-instance-method","name":"to_i64!","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":597,"url":null},"def":{"name":"to_i64!","return_type":"Int64","visibility":"Public","body":"(self % BITS64).to_u64.to_i64!"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":561,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"to_i32.to_i8"}},{"html_id":"to_i8!:Int8-instance-method","name":"to_i8!","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":585,"url":null},"def":{"name":"to_i8!","return_type":"Int8","visibility":"Public","body":"(LibGMP.get_si(self)).to_i8!"}},{"html_id":"to_s(io:IO,base:Int=10,*,precision:Int=1,upcase:Bool=false):Nil-instance-method","name":"to_s","doc":"Appends a string representation of this integer to the given *io*.\n\n*base* specifies the radix of the written string, and must be either 62 or\na number between 2 and 36. By default, digits above 9 are represented by\nASCII lowercase letters (`a` for 10, `b` for 11, etc.), but uppercase\nletters may be used if *upcase* is `true`, unless base 62 is used. In that\ncase, lowercase letters are used for 10 to 35, and uppercase ones for 36 to\n61, and *upcase* must be `false`.\n\n*precision* specifies the minimum number of digits in the written string.\nIf there are fewer digits than this number, the string is left-padded by\nzeros. If `self` and *precision* are both zero, returns an empty string.","summary":"<p>Appends a string representation of this integer to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"","external_name":"","restriction":""},{"name":"precision","default_value":"1","external_name":"precision","restriction":"Int"},{"name":"upcase","default_value":"false","external_name":"upcase","restriction":"Bool"}],"args_string":"(io : IO, base : Int = 10, *, precision : Int = 1, upcase : Bool = false) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, *, precision : <a href=\"Int.html\">Int</a> = <span class=\"n\">1</span>, upcase : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/big/big_int.cr","line_number":489,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"","external_name":"","restriction":""},{"name":"precision","default_value":"1","external_name":"precision","restriction":"Int"},{"name":"upcase","default_value":"false","external_name":"upcase","restriction":"Bool"}],"splat_index":2,"return_type":"Nil","visibility":"Public","body":"if (2 <= base && base <= 36) || (base == 62)\nelse\n  raise(ArgumentError.new(\"Invalid base #{base}\"))\nend\nif upcase && (base == 62)\n  raise(ArgumentError.new(\"upcase must be false for base 62\"))\nend\nif precision >= 0\nelse\n  raise(ArgumentError.new(\"Precision must be non-negative\"))\nend\ncase {self, precision}\nwhen {0, 0}\nwhen {0, 1}\n  io << '0'\nwhen {1, 1}\n  io << '1'\nelse\n  count = (LibGMP.sizeinbase(self, base)).to_i\n  ptr = LibGMP.get_str(nil, upcase ? -base : base, self)\n  negative = self < 0\n  if ptr[count + (negative ? 0 : -1)] == 0\n    count = count - 1\n  end\n  if precision <= count\n    buffer = Slice.new(ptr, count + (negative ? 1 : 0))\n  else\n    if negative\n      io << '-'\n      ptr = ptr + 1\n    end\n    (precision - count).times do\n      io << '0'\n    end\n    buffer = Slice.new(ptr, count)\n  end\n  if base == 62\n    base62_swapcase(buffer)\n  end\n  io.write_string(buffer)\nend\n"}},{"html_id":"to_s(base:Int=10,*,precision:Int=1,upcase:Bool=false):String-instance-method","name":"to_s","doc":"Returns a string representation of this integer.\n\n*base* specifies the radix of the returned string, and must be either 62 or\na number between 2 and 36. By default, digits above 9 are represented by\nASCII lowercase letters (`a` for 10, `b` for 11, etc.), but uppercase\nletters may be used if *upcase* is `true`, unless base 62 is used. In that\ncase, lowercase letters are used for 10 to 35, and uppercase ones for 36 to\n61, and *upcase* must be `false`.\n\n*precision* specifies the minimum number of digits in the returned string.\nIf there are fewer digits than this number, the string is left-padded by\nzeros. If `self` and *precision* are both zero, returns an empty string.\n\n```\n1234.to_s                   # => \"1234\"\n1234.to_s(2)                # => \"10011010010\"\n1234.to_s(16)               # => \"4d2\"\n1234.to_s(16, upcase: true) # => \"4D2\"\n1234.to_s(36)               # => \"ya\"\n1234.to_s(62)               # => \"jU\"\n1234.to_s(precision: 2)     # => \"1234\"\n1234.to_s(precision: 6)     # => \"001234\"\n```","summary":"<p>Returns a string representation of this integer.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"","external_name":"","restriction":""},{"name":"precision","default_value":"1","external_name":"precision","restriction":"Int"},{"name":"upcase","default_value":"false","external_name":"upcase","restriction":"Bool"}],"args_string":"(base : Int = 10, *, precision : Int = 1, upcase : Bool = false) : String","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, *, precision : <a href=\"Int.html\">Int</a> = <span class=\"n\">1</span>, upcase : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/big/big_int.cr","line_number":413,"url":null},"def":{"name":"to_s","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"","external_name":"","restriction":""},{"name":"precision","default_value":"1","external_name":"precision","restriction":"Int"},{"name":"upcase","default_value":"false","external_name":"upcase","restriction":"Bool"}],"splat_index":1,"return_type":"String","visibility":"Public","body":"if (2 <= base && base <= 36) || (base == 62)\nelse\n  raise(ArgumentError.new(\"Invalid base #{base}\"))\nend\nif upcase && (base == 62)\n  raise(ArgumentError.new(\"upcase must be false for base 62\"))\nend\nif precision >= 0\nelse\n  raise(ArgumentError.new(\"Precision must be non-negative\"))\nend\ncase {self, precision}\nwhen {0, 0}\n  \"\"\nwhen {0, 1}\n  \"0\"\nwhen {1, 1}\n  \"1\"\nelse\n  count = (LibGMP.sizeinbase(self, base)).to_i\n  negative = self < 0\n  if precision <= count\n    len = count + (negative ? 1 : 0)\n    String.new(len + 1) do |buffer|\n      buffer[len - 1] = 0\n      LibGMP.get_str(buffer, upcase ? -base : base, self)\n      if buffer[len - 1] == 0\n        if precision == count\n          start = buffer + (negative ? 1 : 0)\n          start.move_to(start + 1, count - 1)\n          start.value = '0'.ord.to_u8\n        else\n          len = len - 1\n        end\n      end\n      if base == 62\n        base62_swapcase(Slice.new(buffer, len))\n      end\n      {len, len}\n    end\n  else\n    len = precision + (negative ? 1 : 0)\n    String.new(len + 1) do |buffer|\n      buffer[len - 1] = 0\n      start = (buffer + precision) - count\n      LibGMP.get_str(start, upcase ? -base : base, self)\n      if buffer[len - 1] == 0\n        count = count - 1\n        if negative\n          start = start + 1\n        end\n        start.move_to(start + 1, count)\n      end\n      if base == 62\n        base62_swapcase(Slice.new((buffer + len) - count, count))\n      end\n      if negative\n        buffer.value = '-'.ord.to_u8\n        buffer = buffer + 1\n      end\n      (Slice.new(buffer, precision - count)).fill('0'.ord.to_u8)\n      {len, len}\n    end\n  end\nend\n"}},{"html_id":"to_u:UInt32-instance-method","name":"to_u","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":601,"url":null},"def":{"name":"to_u","return_type":"UInt32","visibility":"Public","body":"to_u32"}},{"html_id":"to_u!-instance-method","name":"to_u!","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":625,"url":null},"def":{"name":"to_u!","visibility":"Public","body":"to_u32!"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":609,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"to_u32.to_u16"}},{"html_id":"to_u16!:UInt16-instance-method","name":"to_u16!","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":633,"url":null},"def":{"name":"to_u16!","return_type":"UInt16","visibility":"Public","body":"(LibGMP.get_ui(self)).to_u16!"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":613,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"to_u64.to_u32"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":637,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"(LibGMP.get_ui(self)).to_u32!"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":617,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"if LibGMP::ULong::MIN <= self && self <= LibGMP::ULong::MAX\n  (LibGMP.get_ui(self)).to_u64\nelse\n  to_s.to_u64 do\n    raise(OverflowError.new)\n  end\nend"}},{"html_id":"to_u64!:UInt64-instance-method","name":"to_u64!","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":641,"url":null},"def":{"name":"to_u64!","return_type":"UInt64","visibility":"Public","body":"(self % BITS64).to_u64"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":605,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"to_u32.to_u8"}},{"html_id":"to_u8!:UInt8-instance-method","name":"to_u8!","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":629,"url":null},"def":{"name":"to_u8!","return_type":"UInt8","visibility":"Public","body":"(LibGMP.get_ui(self)).to_u8!"}},{"html_id":"to_unsafe-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":701,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"mpz"}},{"html_id":"trailing_zeros_count:Int-instance-method","name":"trailing_zeros_count","doc":"Returns the number of trailing `0`-bits.","summary":"<p>Returns the number of trailing <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":553,"url":null},"def":{"name":"trailing_zeros_count","return_type":"Int","visibility":"Public","body":"LibGMP.scan1(self, 0)"}},{"html_id":"unsafe_floored_div(other:BigInt):BigInt-instance-method","name":"unsafe_floored_div","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":224,"url":null},"def":{"name":"unsafe_floored_div","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.fdiv_q(mpz, self, other)\nend"}},{"html_id":"unsafe_floored_div(other:Int):BigInt-instance-method","name":"unsafe_floored_div","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":228,"url":null},"def":{"name":"unsafe_floored_div","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"if (LibGMP::ULong == UInt32) && (other < Int32::MIN || other > UInt32::MAX)\n  unsafe_floored_div(other.to_big_i)\nelse\n  if other < 0\n    -BigInt.new do |mpz|\n      LibGMP.fdiv_q_ui(mpz, self, other.abs)\n    end\n  else\n    BigInt.new do |mpz|\n      LibGMP.fdiv_q_ui(mpz, self, other)\n    end\n  end\nend"}},{"html_id":"unsafe_floored_divmod(number:BigInt):Tuple(BigInt,BigInt)-instance-method","name":"unsafe_floored_divmod","abstract":false,"args":[{"name":"number","external_name":"number","restriction":"BigInt"}],"args_string":"(number : BigInt) : Tuple(BigInt, BigInt)","args_html":"(number : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"BigInt.html\">BigInt</a>, <a href=\"BigInt.html\">BigInt</a>)","location":{"filename":"src/big/big_int.cr","line_number":323,"url":null},"def":{"name":"unsafe_floored_divmod","args":[{"name":"number","external_name":"number","restriction":"BigInt"}],"return_type":"::Tuple(BigInt, BigInt)","visibility":"Public","body":"the_q = BigInt.new\nthe_r = BigInt.new do |r|\n  LibGMP.fdiv_qr(the_q, r, self, number)\nend\n{the_q, the_r}\n"}},{"html_id":"unsafe_floored_divmod(number:LibGMP::ULong):Tuple(BigInt,BigInt)-instance-method","name":"unsafe_floored_divmod","abstract":false,"args":[{"name":"number","external_name":"number","restriction":"LibGMP::ULong"}],"args_string":"(number : LibGMP::ULong) : Tuple(BigInt, BigInt)","args_html":"(number : LibGMP::ULong) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"BigInt.html\">BigInt</a>, <a href=\"BigInt.html\">BigInt</a>)","location":{"filename":"src/big/big_int.cr","line_number":329,"url":null},"def":{"name":"unsafe_floored_divmod","args":[{"name":"number","external_name":"number","restriction":"LibGMP::ULong"}],"return_type":"::Tuple(BigInt, BigInt)","visibility":"Public","body":"the_q = BigInt.new\nthe_r = BigInt.new do |r|\n  LibGMP.fdiv_qr_ui(the_q, r, self, number)\nend\n{the_q, the_r}\n"}},{"html_id":"unsafe_floored_mod(other:BigInt):BigInt-instance-method","name":"unsafe_floored_mod","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":297,"url":null},"def":{"name":"unsafe_floored_mod","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.fdiv_r(mpz, self, other)\nend"}},{"html_id":"unsafe_floored_mod(other:Int):BigInt-instance-method","name":"unsafe_floored_mod","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":301,"url":null},"def":{"name":"unsafe_floored_mod","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"if (other < LibGMP::Long::MIN || other > LibGMP::ULong::MAX)\n  unsafe_floored_mod(other.to_big_i)\nelse\n  if other < 0\n    -BigInt.new do |mpz|\n      LibGMP.fdiv_r_ui(mpz, self, other.abs)\n    end\n  else\n    BigInt.new do |mpz|\n      LibGMP.fdiv_r_ui(mpz, self, other)\n    end\n  end\nend"}},{"html_id":"unsafe_truncated_div(other:BigInt):BigInt-instance-method","name":"unsafe_truncated_div","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":238,"url":null},"def":{"name":"unsafe_truncated_div","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.tdiv_q(mpz, self, other)\nend"}},{"html_id":"unsafe_truncated_div(other:Int):BigInt-instance-method","name":"unsafe_truncated_div","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":242,"url":null},"def":{"name":"unsafe_truncated_div","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"if (LibGMP::ULong == UInt32) && (other < Int32::MIN || other > UInt32::MAX)\n  unsafe_truncated_div(other.to_big_i)\nelse\n  if other < 0\n    -BigInt.new do |mpz|\n      LibGMP.tdiv_q_ui(mpz, self, other.abs)\n    end\n  else\n    BigInt.new do |mpz|\n      LibGMP.tdiv_q_ui(mpz, self, other)\n    end\n  end\nend"}},{"html_id":"unsafe_truncated_divmod(number:BigInt)-instance-method","name":"unsafe_truncated_divmod","abstract":false,"args":[{"name":"number","external_name":"number","restriction":"BigInt"}],"args_string":"(number : BigInt)","args_html":"(number : <a href=\"BigInt.html\">BigInt</a>)","location":{"filename":"src/big/big_int.cr","line_number":335,"url":null},"def":{"name":"unsafe_truncated_divmod","args":[{"name":"number","external_name":"number","restriction":"BigInt"}],"visibility":"Public","body":"the_q = BigInt.new\nthe_r = BigInt.new do |r|\n  LibGMP.tdiv_qr(the_q, r, self, number)\nend\n{the_q, the_r}\n"}},{"html_id":"unsafe_truncated_divmod(number:LibGMP::ULong)-instance-method","name":"unsafe_truncated_divmod","abstract":false,"args":[{"name":"number","external_name":"number","restriction":"LibGMP::ULong"}],"args_string":"(number : LibGMP::ULong)","args_html":"(number : LibGMP::ULong)","location":{"filename":"src/big/big_int.cr","line_number":341,"url":null},"def":{"name":"unsafe_truncated_divmod","args":[{"name":"number","external_name":"number","restriction":"LibGMP::ULong"}],"visibility":"Public","body":"the_q = BigInt.new\nthe_r = BigInt.new do |r|\n  LibGMP.tdiv_qr_ui(the_q, r, self, number)\nend\n{the_q, the_r}\n"}},{"html_id":"unsafe_truncated_mod(other:BigInt):BigInt-instance-method","name":"unsafe_truncated_mod","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":311,"url":null},"def":{"name":"unsafe_truncated_mod","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.tdiv_r(mpz, self, other)\nend"}},{"html_id":"unsafe_truncated_mod(other:LibGMP::IntPrimitive):BigInt-instance-method","name":"unsafe_truncated_mod","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"LibGMP::IntPrimitive"}],"args_string":"(other : LibGMP::IntPrimitive) : BigInt","args_html":"(other : LibGMP::IntPrimitive) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":315,"url":null},"def":{"name":"unsafe_truncated_mod","args":[{"name":"other","external_name":"other","restriction":"LibGMP::IntPrimitive"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.tdiv_r_ui(mpz, self, other.abs)\nend"}},{"html_id":"unsafe_truncated_mod(other:Int):BigInt-instance-method","name":"unsafe_truncated_mod","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":319,"url":null},"def":{"name":"unsafe_truncated_mod","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.tdiv_r_ui(mpz, self, other.abs.to_big_i)\nend"}},{"html_id":"|(other:Int):BigInt-instance-method","name":"|","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigInt","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":355,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.ior(mpz, self, other.to_big_i)\nend"}},{"html_id":"~:BigInt-instance-method","name":"~","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":347,"url":null},"def":{"name":"~","return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.com(mpz, self)\nend"}}]},{"html_id":"Crystal/BigRational","path":"BigRational.html","kind":"struct","full_name":"BigRational","name":"BigRational","abstract":false,"superclass":{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big.cr","line_number":8,"url":null},{"filename":"src/big/big_decimal.cr","line_number":683,"url":null},{"filename":"src/big/big_rational.cr","line_number":19,"url":null},{"filename":"src/big/number.cr","line_number":30,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"doc":"Rational numbers are represented as the quotient of arbitrarily large\nnumerators and denominators. Rationals are canonicalized such that the\ndenominator and the numerator have no common factors, and that the\ndenominator is positive. Zero has the unique representation 0/1.\n\n```\nrequire \"big\"\n\nr = BigRational.new(7.to_big_i, 3.to_big_i)\nr.to_s # => \"7/3\"\n\nr = BigRational.new(3, -9)\nr.to_s # => \"-1/3\"\n```\n\nIt is implemented under the hood with [GMP](https://gmplib.org/).","summary":"<p>Rational numbers are represented as the quotient of arbitrarily large numerators and denominators.</p>","constructors":[{"html_id":"new(numerator:Int,denominator:Int)-class-method","name":"new","doc":"Creates a new `BigRational`.\n\nIf *denominator* is 0, this will raise an exception.","summary":"<p>Creates a new <code><a href=\"BigRational.html\">BigRational</a></code>.</p>","abstract":false,"args":[{"name":"numerator","external_name":"numerator","restriction":"Int"},{"name":"denominator","external_name":"denominator","restriction":"Int"}],"args_string":"(numerator : Int, denominator : Int)","args_html":"(numerator : <a href=\"Int.html\">Int</a>, denominator : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/big/big_rational.cr","line_number":30,"url":null},"def":{"name":"new","args":[{"name":"numerator","external_name":"numerator","restriction":"Int"},{"name":"denominator","external_name":"denominator","restriction":"Int"}],"visibility":"Public","body":"_ = allocate\n_.initialize(numerator, denominator)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:Int)-class-method","name":"new","doc":"Creates a new `BigRational` with *num* as the numerator and 1 for denominator.","summary":"<p>Creates a new <code><a href=\"BigRational.html\">BigRational</a></code> with <em>num</em> as the numerator and 1 for denominator.</p>","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"Int"}],"args_string":"(num : Int)","args_html":"(num : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/big/big_rational.cr","line_number":43,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"Int"}],"visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:Float)-class-method","name":"new","doc":"Creates a exact representation of float as rational.","summary":"<p>Creates a exact representation of float as rational.</p>","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"Float"}],"args_string":"(num : Float)","args_html":"(num : <a href=\"Float.html\">Float</a>)","location":{"filename":"src/big/big_rational.cr","line_number":48,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"Float"}],"visibility":"Public","body":"_ = allocate\n_.initialize(num)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(num:BigRational)-class-method","name":"new","doc":"Creates a `BigRational` from the given *num*.","summary":"<p>Creates a <code><a href=\"BigRational.html\">BigRational</a></code> from the given <em>num</em>.</p>","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"BigRational"}],"args_string":"(num : BigRational)","args_html":"(num : <a href=\"BigRational.html\">BigRational</a>)","location":{"filename":"src/big/big_rational.cr","line_number":63,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"BigRational"}],"visibility":"Public","body":"num"}},{"html_id":"new(num:BigDecimal)-class-method","name":"new","doc":"Creates a `BigRational` from the given *num*.","summary":"<p>Creates a <code><a href=\"BigRational.html\">BigRational</a></code> from the given <em>num</em>.</p>","abstract":false,"args":[{"name":"num","external_name":"num","restriction":"BigDecimal"}],"args_string":"(num : BigDecimal)","args_html":"(num : <a href=\"BigDecimal.html\">BigDecimal</a>)","location":{"filename":"src/big/big_rational.cr","line_number":68,"url":null},"def":{"name":"new","args":[{"name":"num","external_name":"num","restriction":"BigDecimal"}],"visibility":"Public","body":"num.to_big_r"}}],"instance_methods":[{"html_id":"*(other:BigRational):BigRational-instance-method","name":"*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":123,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"BigRational.new do |mpq|\n  LibGMP.mpq_mul(mpq, self, other)\nend"}},{"html_id":"*(other:Int):BigRational-instance-method","name":"*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigRational","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":127,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigRational","visibility":"Public","body":"self * other.to_big_r"}},{"html_id":"**(other:Int):BigRational-instance-method","name":"**","doc":"Raises the rational to the *other*th power\n\nThis will raise `DivisionByZeroError` if rational is 0 and *other* is negative.\n\n```\nrequire \"big\"\n\nBigRational.new(2, 3) ** 2  # => 4/9\nBigRational.new(2, 3) ** -1 # => 3/2\n```","summary":"<p>Raises the rational to the <em>other</em>th power</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigRational","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":187,"url":null},"def":{"name":"**","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigRational","visibility":"Public","body":"if other < 0\n  return (self ** other.abs).inv\nend\nBigRational.new(numerator ** other, denominator ** other)\n"}},{"html_id":"+(other:BigRational):BigRational-instance-method","name":"+","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":107,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"BigRational.new do |mpq|\n  LibGMP.mpq_add(mpq, self, other)\nend"}},{"html_id":"+(other:Int):BigRational-instance-method","name":"+","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigRational","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":111,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigRational","visibility":"Public","body":"self + other.to_big_r"}},{"html_id":"-(other:BigRational):BigRational-instance-method","name":"-","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":115,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"BigRational.new do |mpq|\n  LibGMP.mpq_sub(mpq, self, other)\nend"}},{"html_id":"-(other:Int):BigRational-instance-method","name":"-","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigRational","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":119,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigRational","visibility":"Public","body":"self - other.to_big_r"}},{"html_id":"-:BigRational-instance-method","name":"-","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":173,"url":null},"def":{"name":"-","return_type":"BigRational","visibility":"Public","body":"BigRational.new do |mpq|\n  LibGMP.mpq_neg(mpq, self)\nend"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":131,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"check_division_by_zero(other)\nBigRational.new do |mpq|\n  LibGMP.mpq_div(mpq, self, other)\nend\n"}},{"html_id":"/(other:BigInt):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigRational","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":136,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:BigFloat):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigRational","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":136,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:BigDecimal):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigRational","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":136,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:Int8):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : BigRational","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":31,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:UInt8):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : BigRational","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":31,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:Int16):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : BigRational","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":31,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:UInt16):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : BigRational","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":31,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:Int32):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : BigRational","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":31,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:UInt32):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : BigRational","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":31,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:Int64):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : BigRational","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":31,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:UInt64):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : BigRational","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":31,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:Int128):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : BigRational","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":31,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:UInt128):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : BigRational","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":31,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:Float32):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : BigRational","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":32,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"/(other:Float64):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : BigRational","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":32,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"<<(other:Int):BigRational-instance-method","name":"<<","doc":"Multiplies the rational by (2 ** *other*)\n\n```\nrequire \"big\"\n\nBigRational.new(2, 3) << 2 # => 8/3\n```","summary":"<p>Multiplies the rational by (2 ** <em>other</em>)</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigRational","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":169,"url":null},"def":{"name":"<<","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigRational","visibility":"Public","body":"BigRational.new do |mpq|\n  LibGMP.mpq_mul_2exp(mpq, self, other)\nend"}},{"html_id":"<=>(other:BigRational)-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational)","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>)","location":{"filename":"src/big/big_rational.cr","line_number":91,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"visibility":"Public","body":"LibGMP.mpq_cmp(mpq, other)"}},{"html_id":"<=>(other:Float32|Float64)-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32 | Float64"}],"args_string":"(other : Float32 | Float64)","args_html":"(other : <a href=\"Float32.html\">Float32</a> | <a href=\"Float64.html\">Float64</a>)","location":{"filename":"src/big/big_rational.cr","line_number":95,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Float32 | Float64"}],"visibility":"Public","body":"self <=> (BigRational.new(other))"}},{"html_id":"<=>(other:Float)-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float"}],"args_string":"(other : Float)","args_html":"(other : <a href=\"Float.html\">Float</a>)","location":{"filename":"src/big/big_rational.cr","line_number":99,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Float"}],"visibility":"Public","body":"to_big_f <=> other.to_big_f"}},{"html_id":"<=>(other:Int)-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","args_html":"(other : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/big/big_rational.cr","line_number":103,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Int"}],"visibility":"Public","body":"LibGMP.mpq_cmp(mpq, other.to_big_r)"}},{"html_id":"<=>(other:BigDecimal)-instance-method","name":"<=>","doc":"The comparison operator. Returns `0` if the two objects are equal,\na negative number if this object is considered less than *other*,\na positive number if this object is considered greater than *other*,\nor `nil` if the two objects are not comparable.\n\nSubclasses define this method to provide class-specific ordering.\n\nThe comparison operator is usually used to sort values:\n\n```\n# Sort in a descending way:\n[3, 1, 2].sort { |x, y| y <=> x } # => [3, 2, 1]\n\n# Sort in an ascending way:\n[3, 1, 2].sort { |x, y| x <=> y } # => [1, 2, 3]\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal)","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>)","location":{"filename":"src/big/big_decimal.cr","line_number":686,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"visibility":"Public","body":"to_big_d <=> other"}},{"html_id":">>(other:Int):BigRational-instance-method","name":">>","doc":"Divides the rational by (2 ** *other*)\n\n```\nrequire \"big\"\n\nBigRational.new(2, 3) >> 2 # => 1/6\n```","summary":"<p>Divides the rational by (2 ** <em>other</em>)</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : BigRational","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":158,"url":null},"def":{"name":">>","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"BigRational","visibility":"Public","body":"BigRational.new do |mpq|\n  LibGMP.mpq_div_2exp(mpq, self, other)\nend"}},{"html_id":"abs:BigRational-instance-method","name":"abs","doc":"Returns the absolute value of this number.\n\n```\n123.abs  # => 123\n-123.abs # => 123\n```","summary":"<p>Returns the absolute value of this number.</p>","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":202,"url":null},"def":{"name":"abs","return_type":"BigRational","visibility":"Public","body":"BigRational.new do |mpq|\n  LibGMP.mpq_abs(mpq, self)\nend"}},{"html_id":"ceil:BigRational-instance-method","name":"ceil","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":138,"url":null},"def":{"name":"ceil","return_type":"BigRational","visibility":"Public","body":"diff = (denominator - (numerator % denominator)) % denominator\nBigRational.new(numerator + diff, denominator)\n"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":284,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"denominator:BigInt-instance-method","name":"denominator","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":87,"url":null},"def":{"name":"denominator","return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.mpq_get_den(mpz, self)\nend"}},{"html_id":"floor:BigRational-instance-method","name":"floor","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":143,"url":null},"def":{"name":"floor","return_type":"BigRational","visibility":"Public","body":"BigRational.new(numerator - (numerator % denominator), denominator)"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"TODO: improve this","summary":"<p><span class=\"flag orange\">TODO</span>  improve this</p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/big/big_rational.cr","line_number":207,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = to_f64.hash(hasher)\nhasher\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a string representation of this object\nto the given `IO` object.\n\nSimilar to `to_s(io)`, but usually appends more information\nabout this object.\nSee `#inspect`.","summary":"<p>Appends a string representation of this object to the given <code><a href=\"IO.html\">IO</a></code> object.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/big/big_rational.cr","line_number":280,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"inspect:String-instance-method","name":"inspect","doc":"Returns a `String` representation of this object suitable\nto be embedded inside other expressions, sometimes providing\nmore information about this object.\n\n`#inspect` (and `#inspect(io)`) are the methods used when\nyou invoke `#to_s` or `#inspect` on an object that holds\nother objects and wants to show them. For example when you\ninvoke `Array#to_s`, `#inspect` will be invoked on each element:\n\n```\nary = [\"one\", \"two\", \"three, etc.\"]\nary.inspect # => [\"one\", \"two\", \"three, etc.\"]\n```\n\nNote that if Array invoked `#to_s` on each of the elements\nabove, the output would have been this:\n\n```\nary = [\"one\", \"two\", \"three, etc.\"]\n# If inspect invoked to_s on each element...\nary.inspect # => [one, two, three, etc.]\n```\n\nNote that it's not clear how many elements the array has,\nor which are they, because `#to_s` doesn't guarantee that\nthe string representation is clearly delimited (in the case\nof `String` the quotes are not shown).\n\nAlso note that sometimes the output of `#inspect` will look\nlike a Crystal expression that will compile, but this isn't\nalways the case, nor is it necessary. Notably, `Reference#inspect`\nand `Struct#inspect` return values that don't compile.\n\nClasses must usually **not** override this method. Instead,\nthey must override `inspect(io)`, which must append to the\ngiven `IO` object.","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> representation of this object suitable to be embedded inside other expressions, sometimes providing more information about this object.</p>","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":276,"url":null},"def":{"name":"inspect","return_type":"String","visibility":"Public","body":"to_s"}},{"html_id":"inv:BigRational-instance-method","name":"inv","doc":"Returns a new `BigRational` as 1/r.\n\nThis will raise an exception if rational is 0.","summary":"<p>Returns a new <code><a href=\"BigRational.html\">BigRational</a></code> as 1/r.</p>","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":197,"url":null},"def":{"name":"inv","return_type":"BigRational","visibility":"Public","body":"check_division_by_zero(self)\nBigRational.new do |mpq|\n  LibGMP.mpq_inv(mpq, self)\nend\n"}},{"html_id":"numerator:BigInt-instance-method","name":"numerator","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":83,"url":null},"def":{"name":"numerator","return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.mpq_get_num(mpz, self)\nend"}},{"html_id":"to_big_d:BigDecimal-instance-method","name":"to_big_d","doc":"Converts `self` to `BigDecimal`.","summary":"<p>Converts <code>self</code> to <code><a href=\"BigDecimal.html\">BigDecimal</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":691,"url":null},"def":{"name":"to_big_d","return_type":"BigDecimal","visibility":"Public","body":"BigDecimal.new(self)"}},{"html_id":"to_big_f:BigFloat-instance-method","name":"to_big_f","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":247,"url":null},"def":{"name":"to_big_f","return_type":"BigFloat","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_set_q(mpf, mpq)\nend"}},{"html_id":"to_big_i:BigInt-instance-method","name":"to_big_i","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":251,"url":null},"def":{"name":"to_big_i","return_type":"BigInt","visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.set_q(mpz, mpq)\nend"}},{"html_id":"to_big_r:BigRational-instance-method","name":"to_big_r","doc":"Returns `self`.\n\n```\nrequire \"big\"\n\nBigRational.new(4, 5).to_big_r # => 4/5\n```","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":243,"url":null},"def":{"name":"to_big_r","return_type":"BigRational","visibility":"Public","body":"self"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns the `Float64` representing this rational.","summary":"<p>Returns the <code><a href=\"Float64.html\">Float64</a></code> representing this rational.</p>","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":210,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"to_f64"}},{"html_id":"to_f!:Float64-instance-method","name":"to_f!","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":230,"url":null},"def":{"name":"to_f!","return_type":"Float64","visibility":"Public","body":"to_f64!"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":214,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"to_f64.to_f32"}},{"html_id":"to_f32!:Float32-instance-method","name":"to_f32!","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":222,"url":null},"def":{"name":"to_f32!","return_type":"Float32","visibility":"Public","body":"to_f64.to_f32!"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":218,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"LibGMP.mpq_get_d(mpq)"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":226,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"to_f64"}},{"html_id":"to_i16(*args,**options)-instance-method","name":"to_i16","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_i16","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"to_f64.to_i16(*args, **options)"}},{"html_id":"to_i16(*args,**options,&)-instance-method","name":"to_i16","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_i16","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"to_f64.to_i16(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"to_i32(*args,**options)-instance-method","name":"to_i32","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_i32","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"to_f64.to_i32(*args, **options)"}},{"html_id":"to_i32(*args,**options,&)-instance-method","name":"to_i32","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_i32","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"to_f64.to_i32(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"to_i64(*args,**options)-instance-method","name":"to_i64","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_i64","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"to_f64.to_i64(*args, **options)"}},{"html_id":"to_i64(*args,**options,&)-instance-method","name":"to_i64","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_i64","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"to_f64.to_i64(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"to_i8(*args,**options)-instance-method","name":"to_i8","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_i8","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"to_f64.to_i8(*args, **options)"}},{"html_id":"to_i8(*args,**options,&)-instance-method","name":"to_i8","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_i8","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"to_f64.to_i8(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"to_s(base:Int=10):String-instance-method","name":"to_s","doc":"Returns the string representing this rational.\n\nOptionally takes a radix base (2 through 36).\n\n```\nrequire \"big\"\n\nr = BigRational.new(8243243, 562828882)\nr.to_s     # => \"8243243/562828882\"\nr.to_s(16) # => \"7dc82b/218c1652\"\nr.to_s(36) # => \"4woiz/9b3djm\"\n```","summary":"<p>Returns the string representing this rational.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10) : String","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/big/big_rational.cr","line_number":267,"url":null},"def":{"name":"to_s","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"return_type":"String","visibility":"Public","body":"String.new(to_cstr(base))"}},{"html_id":"to_s(io:IO,base:Int=10):Nil-instance-method","name":"to_s","doc":"Appends a `String` representation of this object\nto the given `IO` object.\n\nAn object must never append itself to the io argument,\nas this will in turn call `to_s(io)` on it.","summary":"<p>Appends a <code><a href=\"String.html\">String</a></code> representation of this object to the given <code><a href=\"IO.html\">IO</a></code> object.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(io : IO, base : Int = 10) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/big/big_rational.cr","line_number":271,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"return_type":"Nil","visibility":"Public","body":"str = to_cstr(base)\nio.write_string(Slice.new(str, LibC.strlen(str)))\n"}},{"html_id":"to_u16(*args,**options)-instance-method","name":"to_u16","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_u16","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"to_f64.to_u16(*args, **options)"}},{"html_id":"to_u16(*args,**options,&)-instance-method","name":"to_u16","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_u16","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"to_f64.to_u16(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"to_u32(*args,**options)-instance-method","name":"to_u32","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_u32","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"to_f64.to_u32(*args, **options)"}},{"html_id":"to_u32(*args,**options,&)-instance-method","name":"to_u32","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_u32","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"to_f64.to_u32(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"to_u64(*args,**options)-instance-method","name":"to_u64","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_u64","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"to_f64.to_u64(*args, **options)"}},{"html_id":"to_u64(*args,**options,&)-instance-method","name":"to_u64","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_u64","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"to_f64.to_u64(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"to_u8(*args,**options)-instance-method","name":"to_u8","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_u8","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"to_f64.to_u8(*args, **options)"}},{"html_id":"to_u8(*args,**options,&)-instance-method","name":"to_u8","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/big/big_rational.cr","line_number":234,"url":null},"def":{"name":"to_u8","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"to_f64.to_u8(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"to_unsafe-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":292,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"mpq"}},{"html_id":"trunc:BigRational-instance-method","name":"trunc","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":147,"url":null},"def":{"name":"trunc","return_type":"BigRational","visibility":"Public","body":"self < 0 ? ceil : floor"}}]},{"html_id":"Crystal/BitArray","path":"BitArray.html","kind":"struct","full_name":"BitArray","name":"BitArray","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Indexable/Mutable","kind":"module","full_name":"Indexable::Mutable","name":"Mutable"},{"html_id":"Crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"},{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/bit_array.cr","line_number":18,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Indexable/Mutable","kind":"module","full_name":"Indexable::Mutable","name":"Mutable"}],"doc":"`BitArray` is an array data structure that compactly stores bits.\n\nBits externally represented as `Bool`s are stored internally as\n`UInt32`s. The total number of bits stored is set at creation and is\nimmutable.\n\n### Example\n\n```\nrequire \"bit_array\"\n\nba = BitArray.new(12) # => \"BitArray[000000000000]\"\nba[2]                 # => false\n0.upto(5) { |i| ba[i * 2] = true }\nba    # => \"BitArray[101010101010]\"\nba[2] # => true\n```","summary":"<p><code><a href=\"BitArray.html\">BitArray</a></code> is an array data structure that compactly stores bits.</p>","constructors":[{"html_id":"new(size,initial:Bool=false)-class-method","name":"new","doc":"Creates a new `BitArray` of *size* bits.\n\n*initial* optionally sets the starting value, `true` or `false`, for all bits\nin the array.","summary":"<p>Creates a new <code><a href=\"BitArray.html\">BitArray</a></code> of <em>size</em> bits.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":""},{"name":"initial","default_value":"false","external_name":"initial","restriction":"Bool"}],"args_string":"(size, initial : Bool = false)","args_html":"(size, initial : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>)","location":{"filename":"src/bit_array.cr","line_number":28,"url":null},"def":{"name":"new","args":[{"name":"size","external_name":"size","restriction":""},{"name":"initial","default_value":"false","external_name":"initial","restriction":"Bool"}],"visibility":"Public","body":"_ = allocate\n_.initialize(size, initial)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"==(other:BitArray)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BitArray"}],"args_string":"(other : BitArray)","args_html":"(other : <a href=\"BitArray.html\">BitArray</a>)","location":{"filename":"src/bit_array.cr","line_number":34,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"BitArray"}],"visibility":"Public","body":"if size != other.size\n  return false\nend\nreturn (LibC.memcmp(@bits, other.@bits, bytesize)) == 0\n"}},{"html_id":"[](start:Int,count:Int):BitArray-instance-method","name":"[]","doc":"Returns count or less (if there aren't enough) elements starting at the\ngiven start index.\n\nNegative indices count backward from the end of the array (-1 is the last\nelement). Additionally, an empty array is returned when the starting index\nfor an element range is at the end of the array.\n\nRaises `IndexError` if the starting index is out of range.\n\n```\nrequire \"bit_array\"\n\nba = BitArray.new(5)\nba[0] = true; ba[2] = true; ba[4] = true\nba # => BitArray[10101]\n\nba[-3, 3] # => BitArray[101]\nba[6, 1]  # raise indexError\nba[1, 2]  # => BitArray[01]\nba[5, 1]  # => BitArray[]\n```","summary":"<p>Returns count or less (if there aren't enough) elements starting at the given start index.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int) : BitArray","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <a href=\"BitArray.html\">BitArray</a>","location":{"filename":"src/bit_array.cr","line_number":113,"url":null},"def":{"name":"[]","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"BitArray","visibility":"Public","body":"start, count = normalize_start_and_count(start, count)\nif count == 0\n  return BitArray.new(0)\nend\nif size <= 32\n  bits = @bits[0]\n  bits = bits >> start\n  bits = bits & (~(UInt32::MAX << count))\n  (BitArray.new(count)).tap do |ba|\n    (ba.@bits)[0] = bits\n  end\nelse\n  if size <= 64\n    bits = (@bits.as(::Pointer(UInt64)))[0]\n    bits = bits >> start\n    bits = bits & (~(UInt64::MAX << count))\n    if count <= 32\n      (BitArray.new(count)).tap do |ba|\n        (ba.@bits)[0] = bits.to_u32!\n      end\n    else\n      (BitArray.new(count)).tap do |ba|\n        ((ba.@bits).as(::Pointer(UInt64)))[0] = bits\n      end\n    end\n  else\n    ba = BitArray.new(count)\n    start_bit_index, start_sub_index = start.divmod(32)\n    end_bit_index = (start + count) // 32\n    i = 0\n    bits = @bits[start_bit_index]\n    while (start_bit_index + i) <= end_bit_index\n      low_bits = bits\n      low_bits = low_bits >> start_sub_index\n      bits = @bits[(start_bit_index + i) + 1]\n      high_bits = bits\n      high_bits = high_bits & (~(UInt32::MAX << start_sub_index))\n      high_bits = high_bits << (32 - start_sub_index)\n      (ba.@bits)[i] = low_bits | high_bits\n      i = i + 1\n    end\n    ba.clear_unused_bits\n    ba\n  end\nend\n"}},{"html_id":"[](range:Range):BitArray-instance-method","name":"[]","doc":"Returns all elements that are within the given range.\n\nNegative indices count backward from the end of the array (-1 is the last\nelement). Additionally, an empty array is returned when the starting index\nfor an element range is at the end of the array.\n\nRaises `IndexError` if the starting index is out of range.\n\n```\nrequire \"bit_array\"\n\nba = BitArray.new(5)\nba[0] = true; ba[2] = true; ba[4] = true\nba # => BitArray[10101]\n\nba[1..3]    # => BitArray[010]\nba[4..7]    # => BitArray[1]\nba[6..10]   # raise IndexError\nba[5..10]   # => BitArray[]\nba[-2...-1] # => BitArray[0]\n```","summary":"<p>Returns all elements that are within the given range.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range) : BitArray","args_html":"(range : <a href=\"Range.html\">Range</a>) : <a href=\"BitArray.html\">BitArray</a>","location":{"filename":"src/bit_array.cr","line_number":88,"url":null},"def":{"name":"[]","args":[{"name":"range","external_name":"range","restriction":"Range"}],"return_type":"BitArray","visibility":"Public","body":"self[*(Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new))]"}},{"html_id":"[]=(index:Int,value:Bool):Bool-instance-method","name":"[]=","doc":"Sets the given *value* at the given *index*. Returns *value*.\n\nNegative indices can be used to start counting from the end of the\ncontainer. Raises `IndexError` if trying to set an element outside the\ncontainer's range.\n\n```\nary = [1, 2, 3]\nary[0] = 5\nary # => [5, 2, 3]\n\nary[3] = 5 # raises IndexError\n```","summary":"<p>Sets the given <em>value</em> at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"Bool"}],"args_string":"(index : Int, value : Bool) : Bool","args_html":"(index : <a href=\"Int.html\">Int</a>, value : <a href=\"Bool.html\">Bool</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/bit_array.cr","line_number":57,"url":null},"def":{"name":"[]=","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"Bool"}],"return_type":"Bool","visibility":"Public","body":"bit_index, sub_index = bit_index_and_sub_index(index)\nif value\n  __temp_85 = bit_index\n  @bits[__temp_85] = @bits[__temp_85] | (1 << sub_index)\nelse\n  __temp_87 = bit_index\n  @bits[__temp_87] = @bits[__temp_87] & (~(1 << sub_index))\nend\nvalue\n"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a new `BitArray` with all of the same elements.","summary":"<p>Returns a new <code><a href=\"BitArray.html\">BitArray</a></code> with all of the same elements.</p>","abstract":false,"location":{"filename":"src/bit_array.cr","line_number":421,"url":null},"def":{"name":"dup","visibility":"Public","body":"bit_array = BitArray.new(@size)\n@bits.copy_to(bit_array.@bits, malloc_size)\nbit_array\n"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/bit_array.cr","line_number":414,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = size.hash(hasher)\nhasher = to_slice.hash(hasher)\nhasher\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Creates a string representation of self.\n\n```\nrequire \"bit_array\"\n\nba = BitArray.new(5)\nba.to_s # => \"BitArray[00000]\"\n```","summary":"<p>Creates a string representation of self.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/bit_array.cr","line_number":399,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"invert:Nil-instance-method","name":"invert","doc":"Inverts all bits in the array. Falses become `true` and vice versa.\n\n```\nrequire \"bit_array\"\n\nba = BitArray.new(5)\nba[2] = true; ba[3] = true\nba # => BitArray[00110]\nba.invert\nba # => BitArray[11001]\n```","summary":"<p>Inverts all bits in the array.</p>","abstract":false,"location":{"filename":"src/bit_array.cr","line_number":262,"url":null},"def":{"name":"invert","return_type":"Nil","visibility":"Public","body":"malloc_size.times do |i|\n  @bits[i] = ~@bits[i]\nend\nclear_unused_bits\n"}},{"html_id":"reverse!:self-instance-method","name":"reverse!","doc":"Reverses in-place all the elements of `self`. Returns `self`.","summary":"<p>Reverses in-place all the elements of <code>self</code>.</p>","abstract":false,"location":{"filename":"src/bit_array.cr","line_number":270,"url":null},"def":{"name":"reverse!","return_type":"self","visibility":"Public","body":"if size <= 1\n  return self\nend\nif size <= 32\n  @bits.value = (Intrinsics.bitreverse32(@bits.value)) >> (32 - size)\nelse\n  if size <= 64\n    more_bits = @bits.as(::Pointer(UInt64))\n    more_bits.value = (Intrinsics.bitreverse64(more_bits.value)) >> (64 - size)\n  else\n    offset = (-size) % 32\n    if offset != 0\n      (malloc_size - 1).downto(1) do |i|\n        @bits[i] = Intrinsics.bitreverse32((@bits[i] << offset) | (@bits[i - 1] >> (32 - offset)))\n      end\n      @bits[0] = Intrinsics.bitreverse32(@bits[0] << offset)\n    else\n      (Slice.new(@bits, malloc_size)).map! do |x|\n        Intrinsics.bitreverse32(x)\n      end\n    end\n    (Slice.new(@bits, malloc_size)).reverse!\n  end\nend\nself\n"}},{"html_id":"rotate!(n:Int=1):self-instance-method","name":"rotate!","doc":"Shifts all elements of `self` to the left *n* times. Returns `self`.\n\n```\na1 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\na2 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\na3 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\n\na1.rotate!\na2.rotate!(1)\na3.rotate!(3)\n\na1 # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]\na2 # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]\na3 # => [3, 4, 5, 6, 7, 8, 9, 0, 1, 2]\n```","summary":"<p>Shifts all elements of <code>self</code> to the left <em>n</em> times.</p>","abstract":false,"args":[{"name":"n","default_value":"1","external_name":"n","restriction":"Int"}],"args_string":"(n : Int = 1) : self","args_html":"(n : <a href=\"Int.html\">Int</a> = <span class=\"n\">1</span>) : <span class=\"k\">self</span>","location":{"filename":"src/bit_array.cr","line_number":314,"url":null},"def":{"name":"rotate!","args":[{"name":"n","default_value":"1","external_name":"n","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"if size <= 1\n  return self\nend\nn = n % size\nif n == 0\n  return self\nend\nif ((size % 8) == 0) && ((n % 8) == 0)\n  to_slice.rotate!(n // 8)\nelse\n  if size <= 32\n    @bits[0] = (@bits[0] >> n) | (@bits[0] << (size - n))\n    clear_unused_bits\n  else\n    if n <= 32\n      temp = @bits[0]\n      malloc_size = self.malloc_size\n      (malloc_size - 1).times do |i|\n        @bits[i] = (@bits[i] >> n) | (@bits[i + 1] << (32 - n))\n      end\n      end_sub_index = ((size - 1) % 32) + 1\n      if n <= end_sub_index\n        @bits[malloc_size - 1] = (@bits[malloc_size - 1] >> n) | (temp << (end_sub_index - n))\n      else\n        __temp_97 = malloc_size - 2\n        @bits[__temp_97] = @bits[__temp_97] | (temp << ((32 + end_sub_index) - n))\n        @bits[malloc_size - 1] = temp << (end_sub_index - n)\n      end\n      clear_unused_bits\n    else\n      if n >= (size - 32)\n        n = size - n\n        malloc_size = self.malloc_size\n        end_sub_index = ((size - 1) % 32) + 1\n        if n <= end_sub_index\n          temp = @bits[malloc_size - 1] >> (end_sub_index - n)\n        else\n          temp = (@bits[malloc_size - 1] << (n - end_sub_index)) | (@bits[malloc_size - 2] >> ((32 + end_sub_index) - n))\n        end\n        (malloc_size - 1).downto(1) do |i|\n          @bits[i] = (@bits[i] << n) | (@bits[i - 1] >> (32 - n))\n        end\n        @bits[0] = (@bits[0] << n) | temp\n        clear_unused_bits\n      else\n        super(n)\n      end\n    end\n  end\nend\nself\n"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"The number of bits the BitArray stores","summary":"<p>The number of bits the BitArray stores</p>","abstract":false,"location":{"filename":"src/bit_array.cr","line_number":22,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"@size"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Creates a string representation of self.\n\n```\nrequire \"bit_array\"\n\nba = BitArray.new(5)\nba.to_s # => \"BitArray[00000]\"\n```","summary":"<p>Creates a string representation of self.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/bit_array.cr","line_number":390,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"BitArray[\"\neach do |value|\n  io << (value ? '1' : '0')\nend\nio << ']'\n"}},{"html_id":"to_slice:Bytes-instance-method","name":"to_slice","doc":"Returns a `Bytes` able to read and write bytes from a buffer.\nThe slice will be long enough to hold all the bits groups in bytes despite the `UInt32` internal representation.\nIt's useful for reading and writing a bit array from a byte buffer directly.\n\nWARNING: It is undefined behaviour to set any of the unused bits of a bit array to\n`true` via a slice.","summary":"<p>Returns a <code><a href=\"Bytes.html\">Bytes</a></code> able to read and write bytes from a buffer.</p>","abstract":false,"location":{"filename":"src/bit_array.cr","line_number":409,"url":null},"def":{"name":"to_slice","return_type":"Bytes","visibility":"Public","body":"Slice.new(@bits.as(Pointer(UInt8)), bytesize)"}},{"html_id":"toggle(start:Int,count:Int)-instance-method","name":"toggle","doc":"Toggles *count* or less (if there aren't enough) bits starting at the given\n*start* index. A `false` bit becomes a `true` bit, and vice versa.\n\nNegative indices count backward from the end of the array (-1 is the last\nelement).\n\nRaises `IndexError` if *index* is out of range.\nRaises `ArgumentError` if *count* is a negative number.\n\n```\nrequire \"bit_array\"\n\nba = BitArray.new(5)\nba.to_s # => \"BitArray[00000]\"\nba.toggle(1, 3)\nba.to_s # => \"BitArray[01110]\"\n```","summary":"<p>Toggles <em>count</em> or less (if there aren't enough) bits starting at the given <em>start</em> index.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int)","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/bit_array.cr","line_number":226,"url":null},"def":{"name":"toggle","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"visibility":"Public","body":"start, count = normalize_start_and_count(start, count)\nif count == 0\n  return\nend\nstart_bit_index, start_sub_index = start.divmod(32)\nend_bit_index, end_sub_index = ((start + count) - 1).divmod(32)\nif start_bit_index == end_bit_index\n  __temp_91 = start_bit_index\n  @bits[__temp_91] = @bits[__temp_91] ^ (uint32_mask(start_sub_index, end_sub_index))\nelse\n  __temp_93 = start_bit_index\n  @bits[__temp_93] = @bits[__temp_93] ^ (uint32_mask(start_sub_index, 31))\n  ((start_bit_index + 1)..(end_bit_index - 1)).each do |i|\n    @bits[i] = ~@bits[i]\n  end\n  __temp_95 = end_bit_index\n  @bits[__temp_95] = @bits[__temp_95] ^ (uint32_mask(0, end_sub_index))\nend\n"}},{"html_id":"toggle(range:Range)-instance-method","name":"toggle","doc":"Toggles all bits that are within the given *range*. A `false` bit becomes a\n`true` bit, and vice versa.\n\nNegative indices count backward from the end of the array (-1 is the last\nelement).\n\nRaises `IndexError` if the starting index is out of range.\n\n```\nrequire \"bit_array\"\n\nba = BitArray.new(5)\nba.to_s # => \"BitArray[00000]\"\nba.toggle(1..-2)\nba.to_s # => \"BitArray[01110]\"\n```","summary":"<p>Toggles all bits that are within the given <em>range</em>.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range)","args_html":"(range : <a href=\"Range.html\">Range</a>)","location":{"filename":"src/bit_array.cr","line_number":205,"url":null},"def":{"name":"toggle","args":[{"name":"range","external_name":"range","restriction":"Range"}],"visibility":"Public","body":"toggle(*(Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new)))"}},{"html_id":"toggle(index):Nil-instance-method","name":"toggle","doc":"Toggles the bit at the given *index*. A `false` bit becomes a `true` bit,\nand vice versa.\n\nNegative indices count backward from the end of the array (-1 is the last\nelement).\n\nRaises `IndexError` if *index* is out of range.\n\n```\nrequire \"bit_array\"\n\nba = BitArray.new(5)\nba[3] # => false\nba.toggle(3)\nba[3] # => true\n```","summary":"<p>Toggles the bit at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":""}],"args_string":"(index) : Nil","args_html":"(index) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/bit_array.cr","line_number":184,"url":null},"def":{"name":"toggle","args":[{"name":"index","external_name":"index","restriction":""}],"return_type":"Nil","visibility":"Public","body":"bit_index, sub_index = bit_index_and_sub_index(index)\n__temp_89 = bit_index\n@bits[__temp_89] = @bits[__temp_89] ^ (1 << sub_index)\n"}},{"html_id":"unsafe_fetch(index:Int):Bool-instance-method","name":"unsafe_fetch","doc":"Returns the element at the given *index*, without doing any bounds check.\n\n`Indexable` makes sure to invoke this method with *index* in `0...size`,\nso converting negative indices to positive ones is not needed here.\n\nClients never invoke this method directly. Instead, they access\nelements with `#[](index)` and `#[]?(index)`.\n\nThis method should only be directly invoked if you are absolutely\nsure the index is in bounds, to avoid a bounds check for a small boost\nof performance.","summary":"<p>Returns the element at the given <em>index</em>, without doing any bounds check.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : Bool","args_html":"(index : <a href=\"Int.html\">Int</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/bit_array.cr","line_number":42,"url":null},"def":{"name":"unsafe_fetch","args":[{"name":"index","external_name":"index","restriction":"Int"}],"return_type":"Bool","visibility":"Public","body":"bit_index, sub_index = index.divmod(32)\n(@bits[bit_index] & (1 << sub_index)) > 0\n"}},{"html_id":"unsafe_put(index:Int,value:Bool)-instance-method","name":"unsafe_put","doc":"Sets the element at the given *index* to *value*, without doing any bounds\ncheck.\n\n`Indexable::Mutable` makes sure to invoke this method with *index* in\n`0...size`, so converting negative indices to positive ones is not needed\nhere.\n\nClients never invoke this method directly. Instead, they modify elements\nwith `#[]=(index, value)`.\n\nThis method should only be directly invoked if you are absolutely\nsure the index is in bounds, to avoid a bounds check for a small boost\nof performance.","summary":"<p>Sets the element at the given <em>index</em> to <em>value</em>, without doing any bounds check.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"Bool"}],"args_string":"(index : Int, value : Bool)","args_html":"(index : <a href=\"Int.html\">Int</a>, value : <a href=\"Bool.html\">Bool</a>)","location":{"filename":"src/bit_array.cr","line_number":47,"url":null},"def":{"name":"unsafe_put","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"Bool"}],"visibility":"Public","body":"bit_index, sub_index = index.divmod(32)\nif value\n  __temp_81 = bit_index\n  @bits[__temp_81] = @bits[__temp_81] | (1 << sub_index)\nelse\n  __temp_83 = bit_index\n  @bits[__temp_83] = @bits[__temp_83] & (~(1 << sub_index))\nend\n"}}]},{"html_id":"Crystal/Bool","path":"Bool.html","kind":"struct","full_name":"Bool","name":"Bool","abstract":false,"superclass":{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/bool.cr","line_number":9,"url":null},{"filename":"src/json/to_json.cr","line_number":37,"url":null},{"filename":"src/primitives.cr","line_number":61,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":104,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"Bool has only two possible values: `true` and `false`. They are constructed using these literals:\n\n```\ntrue  # A Bool that is true\nfalse # A Bool that is false\n```\n\nSee [`Bool` literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/bool.html) in the language reference.","summary":"<p>Bool has only two possible values: <code>true</code> and <code>false</code>.</p>","constructors":[{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":55,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"parse_scalar(ctx, node, self)"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":72,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"pull.read_bool"}}],"instance_methods":[{"html_id":"!=(other:Bool):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Bool"}],"args_string":"(other : Bool) : Bool","args_html":"(other : <a href=\"Bool.html\">Bool</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":69,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Bool"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Bool):Bool-instance-method","name":"&","doc":"Bitwise AND. Returns `true` if this bool and *other* are `true`, otherwise returns `false`.\n\n```\nfalse & false # => false\nfalse & true  # => false\ntrue & false  # => false\ntrue & true   # => true\n```","summary":"<p>Bitwise AND.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Bool"}],"args_string":"(other : Bool) : Bool","args_html":"(other : <a href=\"Bool.html\">Bool</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/bool.cr","line_number":30,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Bool"}],"return_type":"Bool","visibility":"Public","body":"self ? other : false"}},{"html_id":"==(other:Bool):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Bool"}],"args_string":"(other : Bool) : Bool","args_html":"(other : <a href=\"Bool.html\">Bool</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":64,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Bool"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Bool):Bool-instance-method","name":"^","doc":"Exclusive OR. Returns `true` if this bool is different from *other*, otherwise returns `false`.\n\n```\nfalse ^ false # => false\nfalse ^ true  # => true\ntrue ^ false  # => true\ntrue ^ true   # => false\n```","summary":"<p>Exclusive OR.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Bool"}],"args_string":"(other : Bool) : Bool","args_html":"(other : <a href=\"Bool.html\">Bool</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/bool.cr","line_number":42,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Bool"}],"return_type":"Bool","visibility":"Public","body":"self != other"}},{"html_id":"clone:Bool-instance-method","name":"clone","abstract":false,"location":{"filename":"src/bool.cr","line_number":68,"url":null},"def":{"name":"clone","return_type":"Bool","visibility":"Public","body":"self"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/bool.cr","line_number":47,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher.bool(self)"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":38,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.bool(self)"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends `\"true\"` for `true` and `\"false\"` for `false` to the given IO.","summary":"<p>Appends <code>\"true\"</code> for <code>true</code> and <code>\"false\"</code> for <code>false</code> to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/bool.cr","line_number":64,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << to_s"}},{"html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns `\"true\"` for `true` and `\"false\"` for `false`.","summary":"<p>Returns <code>\"true\"</code> for <code>true</code> and <code>\"false\"</code> for <code>false</code>.</p>","abstract":false,"location":{"filename":"src/bool.cr","line_number":59,"url":null},"def":{"name":"to_s","return_type":"String","visibility":"Public","body":"self ? \"true\" : \"false\""}},{"html_id":"to_unsafe:LibC::Int-instance-method","name":"to_unsafe","doc":"Returns an integer derived from the boolean value, for interoperability with C-style booleans.\n\nThe value is `1` for `true` and `0` for `false`.","summary":"<p>Returns an integer derived from the boolean value, for interoperability with C-style booleans.</p>","abstract":false,"location":{"filename":"src/bool.cr","line_number":54,"url":null},"def":{"name":"to_unsafe","return_type":"LibC::Int","visibility":"Public","body":"LibC::Int.new(self ? 1 : 0)"}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder) : Nil","args_html":"(yaml : <a href=\"YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":105,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"yaml.scalar(self)"}},{"html_id":"|(other:Bool):Bool-instance-method","name":"|","doc":"Bitwise OR. Returns `true` if this bool or *other* is `true`, otherwise returns `false`.\n\n```\nfalse | false # => false\nfalse | true  # => true\ntrue | false  # => true\ntrue | true   # => true\n```","summary":"<p>Bitwise OR.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Bool"}],"args_string":"(other : Bool) : Bool","args_html":"(other : <a href=\"Bool.html\">Bool</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/bool.cr","line_number":18,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Bool"}],"return_type":"Bool","visibility":"Public","body":"self ? true : other"}}]},{"html_id":"Crystal/Box","path":"Box.html","kind":"class","full_name":"Box(T)","name":"Box","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/box.cr","line_number":7,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"A Box allows turning any object to a `Void*` and back.\n\nA Box's purpose is passing data to C as a `Void*` and then converting that\nback to the original data type.\n\nFor an example usage, see `Proc`'s explanation about sending Procs to C.","summary":"<p>A Box allows turning any object to a <code>Void*</code> and back.</p>","class_methods":[{"html_id":"box(r:Reference?):Pointer(Void)-class-method","name":"box","doc":"Creates a Box for a reference type (or `nil`) and returns the same pointer (or `NULL`)","summary":"<p>Creates a Box for a reference type (or <code>nil</code>) and returns the same pointer (or <code>NULL</code>)</p>","abstract":false,"args":[{"name":"r","external_name":"r","restriction":"Reference | ::Nil"}],"args_string":"(r : Reference?) : Pointer(Void)","args_html":"(r : <a href=\"Reference.html\">Reference</a>?) : <a href=\"Pointer.html\">Pointer</a>(Void)","location":{"filename":"src/box.cr","line_number":18,"url":null},"def":{"name":"box","args":[{"name":"r","external_name":"r","restriction":"Reference | ::Nil"}],"return_type":"::Pointer(Void)","visibility":"Public","body":"r.as(::Pointer(Void))"}},{"html_id":"box(object):Pointer(Void)-class-method","name":"box","doc":"Creates a Box for an object and returns it as a `Void*`.","summary":"<p>Creates a Box for an object and returns it as a <code>Void*</code>.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":""}],"args_string":"(object) : Pointer(Void)","args_html":"(object) : <a href=\"Pointer.html\">Pointer</a>(Void)","location":{"filename":"src/box.cr","line_number":23,"url":null},"def":{"name":"box","args":[{"name":"object","external_name":"object","restriction":""}],"return_type":"::Pointer(Void)","visibility":"Public","body":"(new(object)).as(::Pointer(Void))"}},{"html_id":"unbox(pointer:Pointer(Void)):T-class-method","name":"unbox","doc":"Unboxes a `Void*` into an object of type `T`. Note that for this you must\nspecify T: `Box(T).unbox(data)`.","summary":"<p>Unboxes a <code>Void*</code> into an object of type <code>T</code>.</p>","abstract":false,"args":[{"name":"pointer","external_name":"pointer","restriction":"::Pointer(Void)"}],"args_string":"(pointer : Pointer(Void)) : T","args_html":"(pointer : <a href=\"Pointer.html\">Pointer</a>(Void)) : T","location":{"filename":"src/box.cr","line_number":29,"url":null},"def":{"name":"unbox","args":[{"name":"pointer","external_name":"pointer","restriction":"::Pointer(Void)"}],"return_type":"T","visibility":"Public","body":"{% if T <= Reference || (T == Nil) %}\n      pointer.as(T)\n    {% else %}\n      pointer.as(self).object\n    {% end %}"}}],"constructors":[{"html_id":"new(object:T)-class-method","name":"new","doc":"Creates a `Box` with the given object.\n\nThis method isn't usually used directly. Instead, `Box.box` is used.","summary":"<p>Creates a <code><a href=\"Box.html\">Box</a></code> with the given object.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":"T"}],"args_string":"(object : T)","args_html":"(object : T)","location":{"filename":"src/box.cr","line_number":14,"url":null},"def":{"name":"new","args":[{"name":"object","external_name":"object","restriction":"T"}],"visibility":"Public","body":"_ = Box(T).allocate\n_.initialize(object)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"object:T-instance-method","name":"object","doc":"Returns the original object","summary":"<p>Returns the original object</p>","abstract":false,"location":{"filename":"src/box.cr","line_number":9,"url":null},"def":{"name":"object","return_type":"T","visibility":"Public","body":"@object"}}]},{"html_id":"Crystal/Bytes","path":"Bytes.html","kind":"alias","full_name":"Bytes","name":"Bytes","abstract":false,"locations":[{"filename":"src/slice.cr","line_number":1177,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"Slice(UInt8)","aliased_html":"<a href=\"Slice.html\">Slice</a>(<a href=\"UInt8.html\">UInt8</a>)","const":false,"doc":"A convenient alias for the most common slice type,\na slice of bytes, used for example in `IO#read` and `IO#write`.","summary":"<p>A convenient alias for the most common slice type, a slice of bytes, used for example in <code><a href=\"IO.html#read%28slice%3ABytes%29-instance-method\">IO#read</a></code> and <code><a href=\"IO.html#write%28slice%3ABytes%29%3ANil-instance-method\">IO#write</a></code>.</p>"},{"html_id":"Crystal/Channel","path":"Channel.html","kind":"class","full_name":"Channel(T)","name":"Channel","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/channel.cr","line_number":25,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"A `Channel` enables concurrent communication between fibers.\n\nThey allow communicating data between fibers without sharing memory and without having to worry about locks, semaphores or other special structures.\n\n```\nchannel = Channel(Int32).new\n\nspawn do\n  channel.send(0)\n  channel.send(1)\nend\n\nchannel.receive # => 0\nchannel.receive # => 1\n```\n\nNOTE: Although a `Channel(Nil)` or any other nilable types like `Channel(Int32?)` are valid\nthey are discouraged since from certain methods or constructs it receiving a `nil` as data\nwill be indistinguishable from a closed channel.\n","summary":"<p>A <code><a href=\"Channel.html\">Channel</a></code> enables concurrent communication between fibers.</p>","class_methods":[{"html_id":"receive_first(channels:Tuple|Array)-class-method","name":"receive_first","abstract":false,"args":[{"name":"channels","external_name":"channels","restriction":"Tuple | Array"}],"args_string":"(channels : Tuple | Array)","args_html":"(channels : <a href=\"Tuple.html\">Tuple</a> | <a href=\"Array.html\">Array</a>)","location":{"filename":"src/channel.cr","line_number":387,"url":null},"def":{"name":"receive_first","args":[{"name":"channels","external_name":"channels","restriction":"Tuple | Array"}],"visibility":"Public","body":"_, value = self.select(channels.map(&.receive_select_action))\nvalue\n"}},{"html_id":"receive_first(*channels)-class-method","name":"receive_first","abstract":false,"args":[{"name":"channels","external_name":"channels","restriction":""}],"args_string":"(*channels)","args_html":"(*channels)","location":{"filename":"src/channel.cr","line_number":383,"url":null},"def":{"name":"receive_first","args":[{"name":"channels","external_name":"channels","restriction":""}],"splat_index":0,"visibility":"Public","body":"receive_first(channels)"}},{"html_id":"send_first(value,channels:Tuple|Array):Nil-class-method","name":"send_first","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"channels","external_name":"channels","restriction":"Tuple | Array"}],"args_string":"(value, channels : Tuple | Array) : Nil","args_html":"(value, channels : <a href=\"Tuple.html\">Tuple</a> | <a href=\"Array.html\">Array</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/channel.cr","line_number":396,"url":null},"def":{"name":"send_first","args":[{"name":"value","external_name":"value","restriction":""},{"name":"channels","external_name":"channels","restriction":"Tuple | Array"}],"return_type":"Nil","visibility":"Public","body":"self.select(channels.map(&.send_select_action(value)))\nnil\n"}},{"html_id":"send_first(value,*channels):Nil-class-method","name":"send_first","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"channels","external_name":"channels","restriction":""}],"args_string":"(value, *channels) : Nil","args_html":"(value, *channels) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/channel.cr","line_number":392,"url":null},"def":{"name":"send_first","args":[{"name":"value","external_name":"value","restriction":""},{"name":"channels","external_name":"channels","restriction":""}],"splat_index":1,"return_type":"Nil","visibility":"Public","body":"send_first(value, channels)"}}],"constructors":[{"html_id":"new(capacity=0)-class-method","name":"new","abstract":false,"args":[{"name":"capacity","default_value":"0","external_name":"capacity","restriction":""}],"args_string":"(capacity = 0)","args_html":"(capacity = <span class=\"n\">0</span>)","location":{"filename":"src/channel.cr","line_number":171,"url":null},"def":{"name":"new","args":[{"name":"capacity","default_value":"0","external_name":"capacity","restriction":""}],"visibility":"Public","body":"_ = Channel(T).allocate\n_.initialize(capacity)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"close:Bool-instance-method","name":"close","doc":"Closes the channel.\nThe method prevents any new value from being sent to / received from the channel.\nAll fibers blocked in `send` or `receive` will be awakened with `Channel::ClosedError`\n\nBoth awaiting and subsequent calls to `#send` will consider the channel closed.\nAll items successfully sent to the channel can be received, before `#receive` considers the channel closed.\nCalling `#close` on a closed channel does not have any effect.\n\nIt returns `true` when the channel was successfully closed, or `false` if it was already closed.","summary":"<p>Closes the channel.</p>","abstract":false,"location":{"filename":"src/channel.cr","line_number":191,"url":null},"def":{"name":"close","return_type":"Bool","visibility":"Public","body":"sender_list = Crystal::PointerLinkedList(Sender(T)).new\nreceiver_list = Crystal::PointerLinkedList(Receiver(T)).new\n@lock.sync do\n  if @closed\n    return false\n  end\n  @closed = true\n  @senders, sender_list = sender_list, @senders\n  @receivers, receiver_list = receiver_list, @receivers\nend\nsender_list.each do |__arg0|\n  __arg0.value.close\nend\nreceiver_list.each do |__arg1|\n  __arg1.value.close\nend\ntrue\n"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","abstract":false,"location":{"filename":"src/channel.cr","line_number":208,"url":null},"def":{"name":"closed?","return_type":"Bool","visibility":"Public","body":"@closed"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/channel.cr","line_number":375,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"pretty_print(pp)-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp)","args_html":"(pp)","location":{"filename":"src/channel.cr","line_number":379,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"visibility":"Public","body":"pp.text(inspect)"}},{"html_id":"receive:T-instance-method","name":"receive","doc":"Receives a value from the channel.\nIf there is a value waiting, then it is returned immediately. Otherwise, this method blocks until a value is sent to the channel.\n\nRaises `ClosedError` if the channel is closed or closes while waiting for receive.\n\n```\nchannel = Channel(Int32).new\nspawn do\n  channel.send(1)\nend\nchannel.receive # => 1\n```","summary":"<p>Receives a value from the channel.</p>","abstract":false,"location":{"filename":"src/channel.cr","line_number":279,"url":null},"def":{"name":"receive","return_type":"T","visibility":"Public","body":"receive_impl do\n  raise(ClosedError.new)\nend"}},{"html_id":"receive?:T?-instance-method","name":"receive?","doc":"Receives a value from the channel.\nIf there is a value waiting, it is returned immediately. Otherwise, this method blocks until a value is sent to the channel.\n\nReturns `nil` if the channel is closed or closes while waiting for receive.","summary":"<p>Receives a value from the channel.</p>","abstract":false,"location":{"filename":"src/channel.cr","line_number":287,"url":null},"def":{"name":"receive?","return_type":"T | ::Nil","visibility":"Public","body":"receive_impl do\n  return nil\nend"}},{"html_id":"send(value:T):self-instance-method","name":"send","doc":"Sends a value to the channel.\nIf the channel has spare capacity, then the method returns immediately.\nOtherwise, this method blocks the calling fiber until another fiber calls `#receive` on the channel.\n\nRaises `ClosedError` if the channel is closed or closes while waiting on a full channel.","summary":"<p>Sends a value to the channel.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T) : self","args_html":"(value : T) : <span class=\"k\">self</span>","location":{"filename":"src/channel.cr","line_number":217,"url":null},"def":{"name":"send","args":[{"name":"value","external_name":"value","restriction":"T"}],"return_type":"self","visibility":"Public","body":"sender = Sender(T).new\n@lock.lock\ncase send_internal(value)\nin .delivered?\n  @lock.unlock\nin .closed?\n  @lock.unlock\n  raise(ClosedError.new)\nin .none?\n  sender.fiber = Fiber.current\n  sender.data = value\n  @senders.push(pointerof(sender))\n  @lock.unlock\n  Crystal::Scheduler.reschedule\n  case sender.state\n  in .delivered?\n  in .closed?\n    raise(ClosedError.new)\n  in .none?\n    raise(\"BUG: Fiber was awaken without channel delivery state set\")\n  end\nend\nself\n"}}],"types":[{"html_id":"Crystal/Channel/ClosedError","path":"Channel/ClosedError.html","kind":"class","full_name":"Channel::ClosedError","name":"ClosedError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/channel.cr","line_number":117,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Channel","kind":"class","full_name":"Channel(T)","name":"Channel"},"constructors":[{"html_id":"new(msg=\"Channelisclosed\")-class-method","name":"new","abstract":false,"args":[{"name":"msg","default_value":"\"Channel is closed\"","external_name":"msg","restriction":""}],"args_string":"(msg = \"Channel is closed\")","args_html":"(msg = <span class=\"s\">&quot;Channel is closed&quot;</span>)","location":{"filename":"src/channel.cr","line_number":118,"url":null},"def":{"name":"new","args":[{"name":"msg","default_value":"\"Channel is closed\"","external_name":"msg","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(msg)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]}]},{"html_id":"Crystal/Char","path":"Char.html","kind":"struct","full_name":"Char","name":"Char","abstract":false,"superclass":{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/char.cr","line_number":43,"url":null},{"filename":"src/char/reader.cr","line_number":1,"url":null},{"filename":"src/primitives.cr","line_number":73,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"MAX","name":"MAX","value":"1114111.unsafe_chr","doc":"The maximum character.","summary":"<p>The maximum character.</p>"},{"id":"MAX_CODEPOINT","name":"MAX_CODEPOINT","value":"1114111","doc":"The maximum valid codepoint for a character.","summary":"<p>The maximum valid codepoint for a character.</p>"},{"id":"REPLACEMENT","name":"REPLACEMENT","value":"'�'","doc":"The replacement character, used on invalid UTF-8 byte sequences.","summary":"<p>The replacement character, used on invalid UTF-8 byte sequences.</p>"},{"id":"ZERO","name":"ZERO","value":"'\\0'","doc":"The character representing the end of a C string.","summary":"<p>The character representing the end of a C string.</p>"}],"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"}],"doc":"A `Char` represents a [Unicode](http://en.wikipedia.org/wiki/Unicode) [code point](http://en.wikipedia.org/wiki/Code_point).\nIt occupies 32 bits.\n\nIt is created by enclosing an UTF-8 character in single quotes.\n\n```\n'a'\n'z'\n'0'\n'_'\n'あ'\n```\n\nYou can use a backslash to denote some characters:\n\n```\n'\\'' # single quote\n'\\\\' # backslash\n'\\e' # escape\n'\\f' # form feed\n'\\n' # newline\n'\\r' # carriage return\n'\\t' # tab\n'\\v' # vertical tab\n```\n\nYou can use a backslash followed by an *u* and four hexadecimal characters to denote a unicode codepoint written:\n\n```\n'\\u0041' # == 'A'\n```\n\nOr you can use curly braces and specify up to four hexadecimal numbers:\n\n```\n'\\u{41}' # == 'A'\n```\n\nSee [`Char` literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/char.html) in the language reference.","summary":"<p>A <code><a href=\"Char.html\">Char</a></code> represents a <a href=\"http://en.wikipedia.org/wiki/Unicode\">Unicode</a> <a href=\"http://en.wikipedia.org/wiki/Code_point\">code point</a>.</p>","instance_methods":[{"html_id":"!=(other:Char):Bool-instance-method","name":"!=","doc":"Returns `true` if `self`'s codepoint is not equal to *other*'s codepoint.","summary":"<p>Returns <code>true</code> if <code>self</code>'s codepoint is not equal to <em>other</em>'s codepoint.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Char"}],"args_string":"(other : Char) : Bool","args_html":"(other : <a href=\"Char.html\">Char</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":93,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Char"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(str:String):String-instance-method","name":"+","doc":"Concatenates this char and *string*.\n\n```\n'f' + \"oo\" # => \"foo\"\n```","summary":"<p>Concatenates this char and <em>string</em>.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"String"}],"args_string":"(str : String) : String","args_html":"(str : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/char.cr","line_number":75,"url":null},"def":{"name":"+","args":[{"name":"str","external_name":"str","restriction":"String"}],"return_type":"String","visibility":"Public","body":"bytesize = str.bytesize + self.bytesize\nString.new(bytesize) do |buffer|\n  count = 0\n  each_byte do |byte|\n    buffer[count] = byte\n    count = count + 1\n  end\n  (buffer + count).copy_from(str.to_unsafe, str.bytesize)\n  {bytesize, str.size + 1}\nend\n"}},{"html_id":"+(other:Int):Char-instance-method","name":"+","doc":"Returns a char that has this char's codepoint plus *other*.\n\n```\n'a' + 1 # => 'b'\n'a' + 2 # => 'c'\n```","summary":"<p>Returns a char that has this char's codepoint plus <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : Char","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"Char.html\">Char</a>","location":{"filename":"src/char.cr","line_number":96,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"Char","visibility":"Public","body":"(ord + other).chr"}},{"html_id":"-(other:Char):Int32-instance-method","name":"-","doc":"Returns the difference of the codepoint values of this char and *other*.\n\n```\n'a' - 'a' # => 0\n'b' - 'a' # => 1\n'c' - 'a' # => 2\n```","summary":"<p>Returns the difference of the codepoint values of this char and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Char"}],"args_string":"(other : Char) : Int32","args_html":"(other : <a href=\"Char.html\">Char</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/char.cr","line_number":66,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Char"}],"return_type":"Int32","visibility":"Public","body":"ord - other.ord"}},{"html_id":"-(other:Int):Char-instance-method","name":"-","doc":"Returns a char that has this char's codepoint minus *other*.\n\n```\n'c' - 1 # => 'b'\n'c' - 2 # => 'a'\n```","summary":"<p>Returns a char that has this char's codepoint minus <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : Char","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"Char.html\">Char</a>","location":{"filename":"src/char.cr","line_number":106,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"Char","visibility":"Public","body":"(ord - other).chr"}},{"html_id":"<(other:Char):Bool-instance-method","name":"<","doc":"Returns `true` if `self`'s codepoint is less than *other*'s codepoint.","summary":"<p>Returns <code>true</code> if <code>self</code>'s codepoint is less than <em>other</em>'s codepoint.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Char"}],"args_string":"(other : Char) : Bool","args_html":"(other : <a href=\"Char.html\">Char</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":93,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Char"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Char):Bool-instance-method","name":"<=","doc":"Returns `true` if `self`'s codepoint is less than or equal to *other*'s codepoint.","summary":"<p>Returns <code>true</code> if <code>self</code>'s codepoint is less than or equal to <em>other</em>'s codepoint.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Char"}],"args_string":"(other : Char) : Bool","args_html":"(other : <a href=\"Char.html\">Char</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":93,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Char"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=>(other:Char)-instance-method","name":"<=>","doc":"The comparison operator.\n\nReturns the difference of the codepoint values of `self` and *other*.\nThe result is either negative, `0` or positive based on whether `other`'s codepoint is\nless, equal, or greater than `self`'s codepoint.\n\n```\n'a' <=> 'c' # => -2\n'z' <=> 'z' # => 0\n'c' <=> 'a' # => 2\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Char"}],"args_string":"(other : Char)","args_html":"(other : <a href=\"Char.html\">Char</a>)","location":{"filename":"src/char.cr","line_number":121,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Char"}],"visibility":"Public","body":"self - other"}},{"html_id":"==(other:Char):Bool-instance-method","name":"==","doc":"Returns `true` if `self`'s codepoint is equal to *other*'s codepoint.","summary":"<p>Returns <code>true</code> if <code>self</code>'s codepoint is equal to <em>other</em>'s codepoint.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Char"}],"args_string":"(other : Char) : Bool","args_html":"(other : <a href=\"Char.html\">Char</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":93,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Char"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"===(byte:Int)-instance-method","name":"===","doc":"Returns `true` if the codepoint is equal to *byte* ignoring the type.\n\n```\n'c'.ord       # => 99\n'c' === 99_u8 # => true\n'c' === 99    # => true\n'z' === 99    # => false\n```","summary":"<p>Returns <code>true</code> if the codepoint is equal to <em>byte</em> ignoring the type.</p>","abstract":false,"args":[{"name":"byte","external_name":"byte","restriction":"Int"}],"args_string":"(byte : Int)","args_html":"(byte : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/char.cr","line_number":919,"url":null},"def":{"name":"===","args":[{"name":"byte","external_name":"byte","restriction":"Int"}],"visibility":"Public","body":"ord === byte"}},{"html_id":">(other:Char):Bool-instance-method","name":">","doc":"Returns `true` if `self`'s codepoint is greater than *other*'s codepoint.","summary":"<p>Returns <code>true</code> if <code>self</code>'s codepoint is greater than <em>other</em>'s codepoint.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Char"}],"args_string":"(other : Char) : Bool","args_html":"(other : <a href=\"Char.html\">Char</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":93,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Char"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Char):Bool-instance-method","name":">=","doc":"Returns `true` if `self`'s codepoint is greater than or equal to *other*'s codepoint.","summary":"<p>Returns <code>true</code> if <code>self</code>'s codepoint is greater than or equal to <em>other</em>'s codepoint.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Char"}],"args_string":"(other : Char) : Bool","args_html":"(other : <a href=\"Char.html\">Char</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":93,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Char"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"alphanumeric?:Bool-instance-method","name":"alphanumeric?","doc":"Returns `true` if this char is a letter or a number according to unicode.\n\n```\n'c'.alphanumeric? # => true\n'8'.alphanumeric? # => true\n'.'.alphanumeric? # => false\n```","summary":"<p>Returns <code>true</code> if this char is a letter or a number according to unicode.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":272,"url":null},"def":{"name":"alphanumeric?","return_type":"Bool","visibility":"Public","body":"letter? || number?"}},{"html_id":"ascii?:Bool-instance-method","name":"ascii?","doc":"Returns `true` if this char is an ASCII character\n(codepoint is in (0..127))","summary":"<p>Returns <code>true</code> if this char is an ASCII character (codepoint is in (0..127))</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":154,"url":null},"def":{"name":"ascii?","return_type":"Bool","visibility":"Public","body":"ord < 128"}},{"html_id":"ascii_alphanumeric?:Bool-instance-method","name":"ascii_alphanumeric?","doc":"Returns `true` if this char is an ASCII letter or number ('0' to '9', 'a' to 'z', 'A' to 'Z').\n\n```\n'c'.ascii_alphanumeric? # => true\n'8'.ascii_alphanumeric? # => true\n'.'.ascii_alphanumeric? # => false\n```","summary":"<p>Returns <code>true</code> if this char is an ASCII letter or number ('0' to '9', 'a' to 'z', 'A' to 'Z').</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":261,"url":null},"def":{"name":"ascii_alphanumeric?","return_type":"Bool","visibility":"Public","body":"ascii_letter? || ascii_number?"}},{"html_id":"ascii_control?:Bool-instance-method","name":"ascii_control?","doc":"Returns `true` if this char is an ASCII control character.\n\nThis includes the *C0 control codes* (`U+0000` through `U+001F`) and the\n*Delete* character (`U+007F`).\n\n```\n('\\u0000'..'\\u0019').each do |char|\n  char.control? # => true\nend\n\n('\\u007F'..'\\u009F').each do |char|\n  char.control? # => true\nend\n```","summary":"<p>Returns <code>true</code> if this char is an ASCII control character.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":528,"url":null},"def":{"name":"ascii_control?","return_type":"Bool","visibility":"Public","body":"ord < 32 || (ord == 127)"}},{"html_id":"ascii_letter?:Bool-instance-method","name":"ascii_letter?","doc":"Returns `true` if this char is an ASCII letter ('a' to 'z', 'A' to 'Z').\n\n```\n'c'.ascii_letter? # => true\n'á'.ascii_letter? # => false\n'8'.ascii_letter? # => false\n```","summary":"<p>Returns <code>true</code> if this char is an ASCII letter ('a' to 'z', 'A' to 'Z').</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":236,"url":null},"def":{"name":"ascii_letter?","return_type":"Bool","visibility":"Public","body":"ascii_lowercase? || ascii_uppercase?"}},{"html_id":"ascii_lowercase?:Bool-instance-method","name":"ascii_lowercase?","doc":"Returns `true` if this char is a lowercase ASCII letter.\n\n```\n'c'.ascii_lowercase? # => true\n'ç'.lowercase?       # => true\n'G'.ascii_lowercase? # => false\n'.'.ascii_lowercase? # => false\n```","summary":"<p>Returns <code>true</code> if this char is a lowercase ASCII letter.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":189,"url":null},"def":{"name":"ascii_lowercase?","return_type":"Bool","visibility":"Public","body":"'a' <= self && self <= 'z'"}},{"html_id":"ascii_number?(base:Int=10):Bool-instance-method","name":"ascii_number?","doc":"Returns `true` if this char is an ASCII number in specified base.\n\nBase can be from 0 to 36 with digits from '0' to '9' and 'a' to 'z' or 'A' to 'Z'.\n\n```\n'4'.ascii_number?     # => true\n'z'.ascii_number?     # => false\n'z'.ascii_number?(36) # => true\n```","summary":"<p>Returns <code>true</code> if this char is an ASCII number in specified base.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10) : Bool","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/char.cr","line_number":167,"url":null},"def":{"name":"ascii_number?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"return_type":"Bool","visibility":"Public","body":"!(!(to_i?(base)))"}},{"html_id":"ascii_uppercase?:Bool-instance-method","name":"ascii_uppercase?","doc":"Returns `true` if this char is an ASCII uppercase letter.\n\n```\n'H'.ascii_uppercase? # => true\n'Á'.ascii_uppercase? # => false\n'c'.ascii_uppercase? # => false\n'.'.ascii_uppercase? # => false\n```","summary":"<p>Returns <code>true</code> if this char is an ASCII uppercase letter.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":213,"url":null},"def":{"name":"ascii_uppercase?","return_type":"Bool","visibility":"Public","body":"'A' <= self && self <= 'Z'"}},{"html_id":"ascii_whitespace?:Bool-instance-method","name":"ascii_whitespace?","doc":"Returns `true` if this char is an ASCII whitespace.\n\n```\n' '.ascii_whitespace?  # => true\n'\\t'.ascii_whitespace? # => true\n'b'.ascii_whitespace?  # => false\n```","summary":"<p>Returns <code>true</code> if this char is an ASCII whitespace.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":283,"url":null},"def":{"name":"ascii_whitespace?","return_type":"Bool","visibility":"Public","body":"(self == ' ') || (9 <= (__temp_35 = ord) && __temp_35 <= 13)"}},{"html_id":"bytes:Array(UInt8)-instance-method","name":"bytes","doc":"Returns this char bytes as encoded by UTF-8, as an `Array(UInt8)`.\n\n```\n'a'.bytes # => [97]\n'あ'.bytes # => [227, 129, 130]\n```","summary":"<p>Returns this char bytes as encoded by UTF-8, as an <code><a href=\"Array.html\">Array</a>(<a href=\"UInt8.html\">UInt8</a>)</code>.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":864,"url":null},"def":{"name":"bytes","return_type":"Array(UInt8)","visibility":"Public","body":"bytes = [] of UInt8\neach_byte do |byte|\n  bytes << byte\nend\nbytes\n"}},{"html_id":"bytesize:Int32-instance-method","name":"bytesize","doc":"Returns the number of UTF-8 bytes in this char.\n\n```\n'a'.bytesize # => 1\n'好'.bytesize # => 3\n```","summary":"<p>Returns the number of UTF-8 bytes in this char.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":839,"url":null},"def":{"name":"bytesize","return_type":"Int32","visibility":"Public","body":"c = ord\nif c < 128\n  1\nelse\n  if c <= 2047\n    2\n  else\n    if c <= 65535\n      3\n    else\n      4\n    end\n  end\nend\n"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/char.cr","line_number":923,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"control?:Bool-instance-method","name":"control?","doc":"Returns `true` if this char is a control character according to unicode.","summary":"<p>Returns <code>true</code> if this char is a control character according to unicode.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":533,"url":null},"def":{"name":"control?","return_type":"Bool","visibility":"Public","body":"ascii? ? ascii_control? : Unicode.control?(self)"}},{"html_id":"downcase(options=Unicode::CaseOptions::None):Char-instance-method","name":"downcase","doc":"Returns the downcase equivalent of this char.\n\nNote that this only works for characters whose downcase\nequivalent yields a single codepoint. There are a few\ncharacters, like 'İ', than when downcased result in multiple\ncharacters (in this case: 'I' and the dot mark).\n\nFor a more correct method see the method that receives a block.\n\n```\n'Z'.downcase # => 'z'\n'x'.downcase # => 'x'\n'.'.downcase # => '.'\n```","summary":"<p>Returns the downcase equivalent of this char.</p>","abstract":false,"args":[{"name":"options","default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"args_string":"(options = Unicode::CaseOptions::None) : Char","args_html":"(options = <span class=\"t\">Unicode</span><span class=\"t\">::</span><span class=\"t\">CaseOptions</span><span class=\"t\">::</span><span class=\"t\">None</span>) : <a href=\"Char.html\">Char</a>","location":{"filename":"src/char.cr","line_number":403,"url":null},"def":{"name":"downcase","args":[{"name":"options","default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"return_type":"Char","visibility":"Public","body":"Unicode.downcase(self, options)"}},{"html_id":"downcase(options=Unicode::CaseOptions::None,&)-instance-method","name":"downcase","doc":"Yields each char for the downcase equivalent of this char.\n\nThis method takes into account the possibility that an downcase\nversion of a char might result in multiple chars, like for\n'İ', which results in 'i' and a dot mark.","summary":"<p>Yields each char for the downcase equivalent of this char.</p>","abstract":false,"args":[{"name":"options","default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"args_string":"(options = Unicode::CaseOptions::None, &)","args_html":"(options = <span class=\"t\">Unicode</span><span class=\"t\">::</span><span class=\"t\">CaseOptions</span><span class=\"t\">::</span><span class=\"t\">None</span>, &)","location":{"filename":"src/char.cr","line_number":412,"url":null},"def":{"name":"downcase","args":[{"name":"options","default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"yields":1,"visibility":"Public","body":"Unicode.downcase(self, options) do |char|\n  yield char\nend"}},{"html_id":"dump(io)-instance-method","name":"dump","doc":"Returns a representation of `self` as an ASCII-compatible Crystal char literal,\nwrapped in single quotes.\n\nNon-printable characters (see `#printable?`) and non-ASCII characters\n(codepoints larger `U+007F`) are escaped.\n\n```\n'a'.dump      # => \"'a'\"\n'\\t'.dump     # => \"'\\\\t'\"\n'あ'.dump      # => \"'\\\\u3042'\"\n'\\u0012'.dump # => \"'\\\\u0012'\"\n'😀'.dump      # => \"'\\\\u{1F600}'\"\n```\n\nSee `#unicode_escape` for the format used to escape charactes without a\nspecial escape sequence.\n\n* `#inspect` only escapes non-printable characters.","summary":"<p>Returns a representation of <code>self</code> as an ASCII-compatible Crystal char literal, wrapped in single quotes.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""}],"args_string":"(io)","args_html":"(io)","location":{"filename":"src/char.cr","line_number":615,"url":null},"def":{"name":"dump","args":[{"name":"io","external_name":"io","restriction":""}],"visibility":"Public","body":"io << dump"}},{"html_id":"dump:String-instance-method","name":"dump","doc":"Returns a representation of `self` as an ASCII-compatible Crystal char literal,\nwrapped in single quotes.\n\nNon-printable characters (see `#printable?`) and non-ASCII characters\n(codepoints larger `U+007F`) are escaped.\n\n```\n'a'.dump      # => \"'a'\"\n'\\t'.dump     # => \"'\\\\t'\"\n'あ'.dump      # => \"'\\\\u3042'\"\n'\\u0012'.dump # => \"'\\\\u0012'\"\n'😀'.dump      # => \"'\\\\u{1F600}'\"\n```\n\nSee `#unicode_escape` for the format used to escape charactes without a\nspecial escape sequence.\n\n* `#inspect` only escapes non-printable characters.","summary":"<p>Returns a representation of <code>self</code> as an ASCII-compatible Crystal char literal, wrapped in single quotes.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":604,"url":null},"def":{"name":"dump","return_type":"String","visibility":"Public","body":"dump_or_inspect do |io|\n  if ascii_control? || ord >= 128\n    unicode_escape(io)\n  else\n    to_s(io)\n  end\nend"}},{"html_id":"each_byte(&):Nil-instance-method","name":"each_byte","doc":"Yields each of the bytes of this char as encoded by UTF-8.\n\n```\nputs \"'a'\"\n'a'.each_byte do |byte|\n  puts byte\nend\nputs\n\nputs \"'あ'\"\n'あ'.each_byte do |byte|\n  puts byte\nend\n```\n\nOutput:\n\n```text\n'a'\n97\n\n'あ'\n227\n129\n130\n```","summary":"<p>Yields each of the bytes of this char as encoded by UTF-8.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":808,"url":null},"def":{"name":"each_byte","yields":1,"return_type":"Nil","visibility":"Public","body":"c = ord\nif c < 128\n  yield c.to_u8\nelse\n  if c <= 2047\n    yield (192 | (c >> 6)).to_u8\n    yield (128 | (c & 63)).to_u8\n  else\n    if c <= 65535\n      yield (224 | (c >> 12)).to_u8\n      yield (128 | ((c >> 6) & 63)).to_u8\n      yield (128 | (c & 63)).to_u8\n    else\n      yield (240 | (c >> 18)).to_u8\n      yield (128 | ((c >> 12) & 63)).to_u8\n      yield (128 | ((c >> 6) & 63)).to_u8\n      yield (128 | (c & 63)).to_u8\n    end\n  end\nend\n"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/char.cr","line_number":449,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher.char(self)"}},{"html_id":"hex?:Bool-instance-method","name":"hex?","doc":"Returns `true` if this char is an ASCII hex digit ('0' to '9', 'a' to 'f', 'A' to 'F').\n\n```\n'5'.hex? # => true\n'a'.hex? # => true\n'F'.hex? # => true\n'g'.hex? # => false\n```","summary":"<p>Returns <code>true</code> if this char is an ASCII hex digit ('0' to '9', 'a' to 'f', 'A' to 'F').</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":306,"url":null},"def":{"name":"hex?","return_type":"Bool","visibility":"Public","body":"ascii_number?(16)"}},{"html_id":"in_set?(*sets:String):Bool-instance-method","name":"in_set?","doc":"Returns `true` if this char is matched by the given *sets*.\n\nEach parameter defines a set, the character is matched against\nthe intersection of those, in other words it needs to\nmatch all sets.\n\nIf a set starts with a ^, it is negated. The sequence c1-c2\nmeans all characters between and including c1 and c2\nand is known as a range.\n\nThe backslash character \\ can be used to escape ^ or - and\nis otherwise ignored unless it appears at the end of a range\nor set.\n\n```\n'l'.in_set? \"lo\"          # => true\n'l'.in_set? \"lo\", \"o\"     # => false\n'l'.in_set? \"hello\", \"^l\" # => false\n'l'.in_set? \"j-m\"         # => true\n\n'^'.in_set? \"\\\\^aeiou\" # => true\n'-'.in_set? \"a\\\\-eo\"   # => true\n\n'\\\\'.in_set? \"\\\\\"    # => true\n'\\\\'.in_set? \"\\\\A\"   # => false\n'\\\\'.in_set? \"X-\\\\w\" # => true\n```","summary":"<p>Returns <code>true</code> if this char is matched by the given <em>sets</em>.</p>","abstract":false,"args":[{"name":"sets","external_name":"sets","restriction":"String"}],"args_string":"(*sets : String) : Bool","args_html":"(*sets : <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/char.cr","line_number":337,"url":null},"def":{"name":"in_set?","args":[{"name":"sets","external_name":"sets","restriction":"String"}],"splat_index":0,"return_type":"Bool","visibility":"Public","body":"if sets.size > 1\n  return sets.all? do |set|\n    in_set?(set)\n  end\nend\nset = sets.first\nnot_negated = true\nrange = false\nprevious = nil\nset.each_char do |char|\n  case char\n  when '^'\n    if previous\n    else\n      not_negated = false\n      previous = char\n      next\n    end\n  when '-'\n    if previous && (previous != '\\\\')\n      range = true\n      if previous == '^'\n        previous = '^'\n        not_negated = true\n      end\n      next\n    else\n      if self == char\n        return not_negated\n      end\n    end\n  end\n  if range && previous\n    if previous > char\n      raise(ArgumentError.new(\"Invalid range #{previous}-#{char}\"))\n    end\n    if previous <= self && self <= char\n      return not_negated\n    end\n    range = false\n  else\n    if char != '\\\\'\n      if self == char\n        return not_negated\n      end\n    end\n  end\n  previous = char\nend\nif range && (self == '-')\n  return not_negated\nend\nif (previous == '\\\\') && (self == previous)\n  return not_negated\nend\n!not_negated\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Returns a representation of `self` as a Crystal char literal, wrapped in single\nquotes.\n\nNon-printable characters (see `#printable?`) are escaped.\n\n```\n'a'.inspect      # => \"'a'\"\n'\\t'.inspect     # => \"'\\\\t'\"\n'あ'.inspect      # => \"'あ'\"\n'\\u0012'.inspect # => \"'\\\\u0012'\"\n'😀'.inspect      # => \"'\\u{1F600}'\"\n```\n\nSee `#unicode_escape` for the format used to escape charactes without a\nspecial escape sequence.\n\n* `#dump` additionally escapes all non-ASCII characters.","summary":"<p>Returns a representation of <code>self</code> as a Crystal char literal, wrapped in single quotes.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/char.cr","line_number":582,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << inspect"}},{"html_id":"inspect:String-instance-method","name":"inspect","doc":"Returns a representation of `self` as a Crystal char literal, wrapped in single\nquotes.\n\nNon-printable characters (see `#printable?`) are escaped.\n\n```\n'a'.inspect      # => \"'a'\"\n'\\t'.inspect     # => \"'\\\\t'\"\n'あ'.inspect      # => \"'あ'\"\n'\\u0012'.inspect # => \"'\\\\u0012'\"\n'😀'.inspect      # => \"'\\u{1F600}'\"\n```\n\nSee `#unicode_escape` for the format used to escape charactes without a\nspecial escape sequence.\n\n* `#dump` additionally escapes all non-ASCII characters.","summary":"<p>Returns a representation of <code>self</code> as a Crystal char literal, wrapped in single quotes.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":571,"url":null},"def":{"name":"inspect","return_type":"String","visibility":"Public","body":"dump_or_inspect do |io|\n  if printable?\n    to_s(io)\n  else\n    unicode_escape(io)\n  end\nend"}},{"html_id":"letter?:Bool-instance-method","name":"letter?","doc":"Returns `true` if this char is a letter.\n\nAll codepoints in the Unicode General Category `L` (Letter) are considered\na letter.\n\n```\n'c'.letter? # => true\n'á'.letter? # => true\n'8'.letter? # => false\n```","summary":"<p>Returns <code>true</code> if this char is a letter.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":250,"url":null},"def":{"name":"letter?","return_type":"Bool","visibility":"Public","body":"ascii? ? ascii_letter? : Unicode.letter?(self)"}},{"html_id":"lowercase?:Bool-instance-method","name":"lowercase?","doc":"Returns `true` if this char is a lowercase letter.\n\n```\n'c'.lowercase? # => true\n'ç'.lowercase? # => true\n'G'.lowercase? # => false\n'.'.lowercase? # => false\n```","summary":"<p>Returns <code>true</code> if this char is a lowercase letter.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":201,"url":null},"def":{"name":"lowercase?","return_type":"Bool","visibility":"Public","body":"ascii? ? ascii_lowercase? : Unicode.lowercase?(self)"}},{"html_id":"mark?:Bool-instance-method","name":"mark?","doc":"Returns `true` if this char is a mark character according to unicode.","summary":"<p>Returns <code>true</code> if this char is a mark character according to unicode.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":538,"url":null},"def":{"name":"mark?","return_type":"Bool","visibility":"Public","body":"Unicode.mark?(self)"}},{"html_id":"number?:Bool-instance-method","name":"number?","doc":"Returns `true` if this char is a number according to unicode.\n\n```\n'1'.number? # => true\n'a'.number? # => false\n```","summary":"<p>Returns <code>true</code> if this char is a number according to unicode.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":177,"url":null},"def":{"name":"number?","return_type":"Bool","visibility":"Public","body":"ascii? ? ascii_number? : Unicode.number?(self)"}},{"html_id":"ord:Int32-instance-method","name":"ord","doc":"Returns the codepoint of this char.\n\nThe codepoint is the integer representation.\nThe Universal Coded Character Set (UCS) standard, commonly known as Unicode,\nassigns names and meanings to numbers, these numbers are called codepoints.\n\nFor values below and including 127 this matches the ASCII codes\nand thus its byte representation.\n\n```\n'a'.ord      # => 97\n'\\0'.ord     # => 0\n'\\u007f'.ord # => 127\n'☃'.ord      # => 9731\n```","summary":"<p>Returns the codepoint of this char.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":90,"url":null},"def":{"name":"ord","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"pred:Char-instance-method","name":"pred","doc":"Returns the predecessor codepoint before this one.\n\nThis can be used for iterating a range of characters (see `Range#each`).\n\n```\n'b'.pred # => 'a'\n'ぃ'.pred # => 'あ'\n```\n```\n\nThis does not always return `codepoint - 1`. There is a gap in the\nrange of Unicode scalars: The surrogate codepoints `U+D800` through `U+DFFF`.\n\n```\n'\\uE000'.pred # => '\\uD7FF'\n```\n\nRaises `OverflowError` for `Char::ZERO`.\n\n* `#succ` returns the successor codepoint.","summary":"<p>Returns the predecessor codepoint before this one.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":503,"url":null},"def":{"name":"pred","return_type":"Char","visibility":"Public","body":"case self\nwhen '\\uE000'\n  '퟿'\nwhen ZERO\n  raise(OverflowError.new(\"Out of Char range\"))\nelse\n  (ord - 1).unsafe_chr\nend"}},{"html_id":"printable?-instance-method","name":"printable?","doc":"Returns `true` if this char is a printable character.\n\nThere is no universal definition of printable characters in Unicode.\nFor the purpose of this method, all characters with a visible glyph and the\nASCII whitespace (` `) are considered printable.\n\nThis means characters which are `control?` or `whitespace?` (except for ` `)\nare non-printable.","summary":"<p>Returns <code>true</code> if this char is a printable character.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":550,"url":null},"def":{"name":"printable?","visibility":"Public","body":"(!control?) && ((!whitespace?) || (self == ' '))"}},{"html_id":"step(*,tolimit=nil,exclusive:Bool=false,&)-instance-method","name":"step","doc":"Performs a `#step` in the direction of the _limit_. For instance:\n\n```\n'd'.step(to: 'a').to_a # => ['d', 'c', 'b', 'a']\n'a'.step(to: 'd').to_a # => ['a', 'b', 'c', 'd']\n```","summary":"<p>Performs a <code><a href=\"Char.html#step%28%2A%2Ctolimit%3Dnil%2Cexclusive%3ABool%3Dfalse%2C%26%29-instance-method\">#step</a></code> in the direction of the <em>limit</em>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"limit","default_value":"nil","external_name":"to","restriction":""},{"name":"exclusive","default_value":"false","external_name":"exclusive","restriction":"Bool"}],"args_string":"(*, to limit = nil, exclusive : Bool = false, &)","args_html":"(*, to limit = <span class=\"n\">nil</span>, exclusive : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &)","location":{"filename":"src/char.cr","line_number":131,"url":null},"def":{"name":"step","args":[{"name":"","external_name":"","restriction":""},{"name":"limit","default_value":"nil","external_name":"to","restriction":""},{"name":"exclusive","default_value":"false","external_name":"exclusive","restriction":"Bool"}],"splat_index":0,"yields":1,"visibility":"Public","body":"if limit\n  direction = limit <=> self\nend\nstep = direction.try(&.sign) || 1\nstep(to: limit, by: step, exclusive: exclusive) do |x|\n  yield x\nend\n"}},{"html_id":"step(*,tolimit=nil,exclusive:Bool=false)-instance-method","name":"step","doc":"Performs a `#step` in the direction of the _limit_. For instance:\n\n```\n'd'.step(to: 'a').to_a # => ['d', 'c', 'b', 'a']\n'a'.step(to: 'd').to_a # => ['a', 'b', 'c', 'd']\n```","summary":"<p>Performs a <code><a href=\"Char.html#step%28%2A%2Ctolimit%3Dnil%2Cexclusive%3ABool%3Dfalse%2C%26%29-instance-method\">#step</a></code> in the direction of the <em>limit</em>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"limit","default_value":"nil","external_name":"to","restriction":""},{"name":"exclusive","default_value":"false","external_name":"exclusive","restriction":"Bool"}],"args_string":"(*, to limit = nil, exclusive : Bool = false)","args_html":"(*, to limit = <span class=\"n\">nil</span>, exclusive : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>)","location":{"filename":"src/char.cr","line_number":143,"url":null},"def":{"name":"step","args":[{"name":"","external_name":"","restriction":""},{"name":"limit","default_value":"nil","external_name":"to","restriction":""},{"name":"exclusive","default_value":"false","external_name":"exclusive","restriction":"Bool"}],"splat_index":0,"visibility":"Public","body":"if limit\n  direction = limit <=> self\nend\nstep = direction.try(&.sign) || 1\nstep(to: limit, by: step, exclusive: exclusive)\n"}},{"html_id":"succ:Char-instance-method","name":"succ","doc":"Returns the successor codepoint after this one.\n\nThis can be used for iterating a range of characters (see `Range#each`).\n\n```\n'a'.succ # => 'b'\n'あ'.succ # => 'ぃ'\n```\n\nThis does not always return `codepoint + 1`. There is a gap in the\nrange of Unicode scalars: The surrogate codepoints `U+D800` through `U+DFFF`.\n\n```\n'\\uD7FF'.succ # => '\\uE000'\n```\n\nRaises `OverflowError` for `Char::MAX`.\n\n* `#pred` returns the predecessor codepoint.","summary":"<p>Returns the successor codepoint after this one.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":472,"url":null},"def":{"name":"succ","return_type":"Char","visibility":"Public","body":"case self\nwhen '퟿'\n  '\\uE000'\nwhen MAX\n  raise(OverflowError.new(\"Out of Char range\"))\nelse\n  (ord + 1).unsafe_chr\nend"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns the integer value of this char as a float if it's an ASCII char denoting a digit,\nraises otherwise.\n\n```\n'1'.to_f # => 1.0\n'8'.to_f # => 8.0\n'c'.to_f # raises ArgumentError\n```","summary":"<p>Returns the integer value of this char as a float if it's an ASCII char denoting a digit, raises otherwise.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":746,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"to_f64"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"See also: `to_f`.","summary":"<p>See also: <code><a href=\"Char.html#to_f%3AFloat64-instance-method\">#to_f</a></code>.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":763,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"to_i.to_f32"}},{"html_id":"to_f32?:Float32?-instance-method","name":"to_f32?","doc":"See also: `to_f?`.","summary":"<p>See also: <code><a href=\"Char.html#to_f%3F%3AFloat64%3F-instance-method\">#to_f?</a></code>.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":768,"url":null},"def":{"name":"to_f32?","return_type":"Float32 | ::Nil","visibility":"Public","body":"to_i?.try(&.to_f32)"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Same as `to_f`.","summary":"<p>Same as <code><a href=\"Char.html#to_f%3AFloat64-instance-method\">#to_f</a></code>.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":773,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"to_i.to_f64"}},{"html_id":"to_f64?:Float64?-instance-method","name":"to_f64?","doc":"Same as `to_f?`.","summary":"<p>Same as <code><a href=\"Char.html#to_f%3F%3AFloat64%3F-instance-method\">#to_f?</a></code>.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":778,"url":null},"def":{"name":"to_f64?","return_type":"Float64 | ::Nil","visibility":"Public","body":"to_i?.try(&.to_f64)"}},{"html_id":"to_f?:Float64?-instance-method","name":"to_f?","doc":"Returns the integer value of this char as a float if it's an ASCII char denoting a digit,\n`nil` otherwise.\n\n```\n'1'.to_f? # => 1.0\n'8'.to_f? # => 8.0\n'c'.to_f? # => nil\n```","summary":"<p>Returns the integer value of this char as a float if it's an ASCII char denoting a digit, <code>nil</code> otherwise.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":758,"url":null},"def":{"name":"to_f?","return_type":"Float64 | ::Nil","visibility":"Public","body":"to_f64?"}},{"html_id":"to_i(base:Int=10):Int32-instance-method","name":"to_i","doc":"Returns the integer value of this char if it's an ASCII char denoting a digit\nin *base*, raises otherwise.\n\n```\n'1'.to_i     # => 1\n'8'.to_i     # => 8\n'c'.to_i     # raises ArgumentError\n'1'.to_i(16) # => 1\n'a'.to_i(16) # => 10\n'f'.to_i(16) # => 15\n'z'.to_i(16) # raises ArgumentError\n```","summary":"<p>Returns the integer value of this char if it's an ASCII char denoting a digit in <em>base</em>, raises otherwise.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10) : Int32","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/char.cr","line_number":684,"url":null},"def":{"name":"to_i","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"return_type":"Int32","visibility":"Public","body":"(to_i?(base)) || (raise(ArgumentError.new(\"Invalid integer: #{self}\")))"}},{"html_id":"to_i16(base:Int=10)-instance-method","name":"to_i16","doc":"See also: `to_i`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>)","location":{"filename":"src/char.cr","line_number":726,"url":null},"def":{"name":"to_i16","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"visibility":"Public","body":"(to_i(base)).to_i16"}},{"html_id":"to_i16?(base:Int=10)-instance-method","name":"to_i16?","doc":"See also: `to_i?`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>)","location":{"filename":"src/char.cr","line_number":726,"url":null},"def":{"name":"to_i16?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"visibility":"Public","body":"(to_i?(base)).try(&.to_i16)"}},{"html_id":"to_i32(base:Int=10):Int32-instance-method","name":"to_i32","doc":"Same as `to_i`.","summary":"<p>Same as <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10) : Int32","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/char.cr","line_number":717,"url":null},"def":{"name":"to_i32","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"return_type":"Int32","visibility":"Public","body":"to_i(base)"}},{"html_id":"to_i32?(base:Int=10):Int32?-instance-method","name":"to_i32?","doc":"Same as `to_i?`.","summary":"<p>Same as <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10) : Int32?","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/char.cr","line_number":722,"url":null},"def":{"name":"to_i32?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"to_i?(base)"}},{"html_id":"to_i64(base:Int=10)-instance-method","name":"to_i64","doc":"See also: `to_i`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>)","location":{"filename":"src/char.cr","line_number":726,"url":null},"def":{"name":"to_i64","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"visibility":"Public","body":"(to_i(base)).to_i64"}},{"html_id":"to_i64?(base:Int=10)-instance-method","name":"to_i64?","doc":"See also: `to_i?`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>)","location":{"filename":"src/char.cr","line_number":726,"url":null},"def":{"name":"to_i64?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"visibility":"Public","body":"(to_i?(base)).try(&.to_i64)"}},{"html_id":"to_i8(base:Int=10)-instance-method","name":"to_i8","doc":"See also: `to_i`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>)","location":{"filename":"src/char.cr","line_number":726,"url":null},"def":{"name":"to_i8","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"visibility":"Public","body":"(to_i(base)).to_i8"}},{"html_id":"to_i8?(base:Int=10)-instance-method","name":"to_i8?","doc":"See also: `to_i?`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>)","location":{"filename":"src/char.cr","line_number":726,"url":null},"def":{"name":"to_i8?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"visibility":"Public","body":"(to_i?(base)).try(&.to_i8)"}},{"html_id":"to_i?(base:Int=10):Int32?-instance-method","name":"to_i?","doc":"Returns the integer value of this char if it's an ASCII char denoting a digit\nin *base*, `nil` otherwise.\n\n```\n'1'.to_i?     # => 1\n'8'.to_i?     # => 8\n'c'.to_i?     # => nil\n'1'.to_i?(16) # => 1\n'a'.to_i?(16) # => 10\n'f'.to_i?(16) # => 15\n'z'.to_i?(16) # => nil\n```","summary":"<p>Returns the integer value of this char if it's an ASCII char denoting a digit in <em>base</em>, <code>nil</code> otherwise.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10) : Int32?","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/char.cr","line_number":700,"url":null},"def":{"name":"to_i?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"if 2 <= base && base <= 36\nelse\n  raise(ArgumentError.new(\"Invalid base #{base}, expected 2 to 36\"))\nend\nif base == 10\n  if '0' <= self && self <= '9'\n  else\n    return\n  end\n  self - '0'\nelse\n  ord = ord()\n  if 0 <= ord && ord < 256\n    digit = String::CHAR_TO_DIGIT.to_unsafe[ord]\n    if (digit == -1) || digit >= base\n      return\n    end\n    digit.to_i32\n  end\nend\n"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends this char to the given `IO`.\n\nThis appends this char's bytes as encoded by UTF-8 to the given `IO`.","summary":"<p>Appends this char to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/char.cr","line_number":890,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"if ascii?\n  byte = ord.to_u8\n  if io.has_non_utf8_encoding?\n    io.write_string(Slice.new(pointerof(byte), 1))\n  else\n    io.write_byte(byte)\n  end\nelse\n  chars = uninitialized ::StaticArray(UInt8, 4)\n  i = 0\n  each_byte do |byte|\n    chars[i] = byte\n    i = i + 1\n  end\n  io.write_string(chars.to_slice[0, i])\nend"}},{"html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns this char as a string containing this char as a single character.\n\n```\n'a'.to_s # => \"a\"\n'あ'.to_s # => \"あ\"\n```","summary":"<p>Returns this char as a string containing this char as a single character.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":878,"url":null},"def":{"name":"to_s","return_type":"String","visibility":"Public","body":"bytesize = self.bytesize\nString.new(bytesize) do |buffer|\n  appender = buffer.appender\n  each_byte do |byte|\n    appender << byte\n  end\n  {bytesize, 1}\nend\n"}},{"html_id":"to_u16(base:Int=10)-instance-method","name":"to_u16","doc":"See also: `to_i`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>)","location":{"filename":"src/char.cr","line_number":726,"url":null},"def":{"name":"to_u16","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"visibility":"Public","body":"(to_i(base)).to_u16"}},{"html_id":"to_u16?(base:Int=10)-instance-method","name":"to_u16?","doc":"See also: `to_i?`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>)","location":{"filename":"src/char.cr","line_number":726,"url":null},"def":{"name":"to_u16?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"visibility":"Public","body":"(to_i?(base)).try(&.to_u16)"}},{"html_id":"to_u32(base:Int=10)-instance-method","name":"to_u32","doc":"See also: `to_i`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>)","location":{"filename":"src/char.cr","line_number":726,"url":null},"def":{"name":"to_u32","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"visibility":"Public","body":"(to_i(base)).to_u32"}},{"html_id":"to_u32?(base:Int=10)-instance-method","name":"to_u32?","doc":"See also: `to_i?`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>)","location":{"filename":"src/char.cr","line_number":726,"url":null},"def":{"name":"to_u32?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"visibility":"Public","body":"(to_i?(base)).try(&.to_u32)"}},{"html_id":"to_u64(base:Int=10)-instance-method","name":"to_u64","doc":"See also: `to_i`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>)","location":{"filename":"src/char.cr","line_number":726,"url":null},"def":{"name":"to_u64","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"visibility":"Public","body":"(to_i(base)).to_u64"}},{"html_id":"to_u64?(base:Int=10)-instance-method","name":"to_u64?","doc":"See also: `to_i?`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>)","location":{"filename":"src/char.cr","line_number":726,"url":null},"def":{"name":"to_u64?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"visibility":"Public","body":"(to_i?(base)).try(&.to_u64)"}},{"html_id":"to_u8(base:Int=10)-instance-method","name":"to_u8","doc":"See also: `to_i`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%28base%3AInt%3D10%29%3AInt32-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>)","location":{"filename":"src/char.cr","line_number":726,"url":null},"def":{"name":"to_u8","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"visibility":"Public","body":"(to_i(base)).to_u8"}},{"html_id":"to_u8?(base:Int=10)-instance-method","name":"to_u8?","doc":"See also: `to_i?`.","summary":"<p>See also: <code><a href=\"Char.html#to_i%3F%28base%3AInt%3D10%29%3AInt32%3F-instance-method\">#to_i?</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"args_string":"(base : Int = 10)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>)","location":{"filename":"src/char.cr","line_number":726,"url":null},"def":{"name":"to_u8?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"}],"visibility":"Public","body":"(to_i?(base)).try(&.to_u8)"}},{"html_id":"unicode_escape(io:IO):Nil-instance-method","name":"unicode_escape","doc":"Returns the Unicode escape sequence representing this character.\n\nThe codepoints are expressed as hexadecimal digits with uppercase letters.\nUnicode escapes always use the four digit style for codepoints `U+FFFF`\nand lower, adding leading zeros when necessary. Higher codepoints have their\ndigits wrapped in curly braces and no leading zeros.\n\n```\n'a'.unicode_escape      # => \"\\\\u00E1\"\n'\\t'.unicode_escape     # => \"\\\\u0009\"\n'あ'.unicode_escape      # => \"\\\\u3042\"\n'\\u0012'.unicode_escape # => \"\\\\u0012\"\n'😀'.unicode_escape      # => \"\\\\u{1F600}\"\n```","summary":"<p>Returns the Unicode escape sequence representing this character.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/char.cr","line_number":662,"url":null},"def":{"name":"unicode_escape","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"\\\\u\"\nif ord > 65535\n  io << '{'\nend\nif ord < 4096\n  io << '0'\nend\nif ord < 256\n  io << '0'\nend\nif ord < 16\n  io << '0'\nend\nord.to_s(io, 16, upcase: true)\nif ord > 65535\n  io << '}'\nend\n"}},{"html_id":"unicode_escape:String-instance-method","name":"unicode_escape","doc":"Returns the Unicode escape sequence representing this character.\n\nThe codepoints are expressed as hexadecimal digits with uppercase letters.\nUnicode escapes always use the four digit style for codepoints `U+FFFF`\nand lower, adding leading zeros when necessary. Higher codepoints have their\ndigits wrapped in curly braces and no leading zeros.\n\n```\n'a'.unicode_escape      # => \"\\\\u00E1\"\n'\\t'.unicode_escape     # => \"\\\\u0009\"\n'あ'.unicode_escape      # => \"\\\\u3042\"\n'\\u0012'.unicode_escape # => \"\\\\u0012\"\n'😀'.unicode_escape      # => \"\\\\u{1F600}\"\n```","summary":"<p>Returns the Unicode escape sequence representing this character.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":655,"url":null},"def":{"name":"unicode_escape","return_type":"String","visibility":"Public","body":"String.build do |io|\n  unicode_escape(io)\nend"}},{"html_id":"upcase(options=Unicode::CaseOptions::None):Char-instance-method","name":"upcase","doc":"Returns the upcase equivalent of this char.\n\nNote that this only works for characters whose upcase\nequivalent yields a single codepoint. There are a few\ncharacters, like 'ﬄ', than when upcased result in multiple\ncharacters (in this case: 'F', 'F', 'L').\n\nFor a more correct method see the method that receives a block.\n\n```\n'z'.upcase # => 'Z'\n'X'.upcase # => 'X'\n'.'.upcase # => '.'\n```","summary":"<p>Returns the upcase equivalent of this char.</p>","abstract":false,"args":[{"name":"options","default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"args_string":"(options = Unicode::CaseOptions::None) : Char","args_html":"(options = <span class=\"t\">Unicode</span><span class=\"t\">::</span><span class=\"t\">CaseOptions</span><span class=\"t\">::</span><span class=\"t\">None</span>) : <a href=\"Char.html\">Char</a>","location":{"filename":"src/char.cr","line_number":430,"url":null},"def":{"name":"upcase","args":[{"name":"options","default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"return_type":"Char","visibility":"Public","body":"Unicode.upcase(self, options)"}},{"html_id":"upcase(options=Unicode::CaseOptions::None,&)-instance-method","name":"upcase","doc":"Yields each char for the upcase equivalent of this char.\n\nThis method takes into account the possibility that an upcase\nversion of a char might result in multiple chars, like for\n'ﬄ', which results in 'F', 'F' and 'L'.\n\n```\n'z'.upcase { |v| puts v } # prints 'Z'\n'ﬄ'.upcase { |v| puts v } # prints 'F', 'F', 'L'\n```","summary":"<p>Yields each char for the upcase equivalent of this char.</p>","abstract":false,"args":[{"name":"options","default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"args_string":"(options = Unicode::CaseOptions::None, &)","args_html":"(options = <span class=\"t\">Unicode</span><span class=\"t\">::</span><span class=\"t\">CaseOptions</span><span class=\"t\">::</span><span class=\"t\">None</span>, &)","location":{"filename":"src/char.cr","line_number":444,"url":null},"def":{"name":"upcase","args":[{"name":"options","default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"yields":1,"visibility":"Public","body":"Unicode.upcase(self, options) do |char|\n  yield char\nend"}},{"html_id":"uppercase?:Bool-instance-method","name":"uppercase?","doc":"Returns `true` if this char is an uppercase letter.\n\n```\n'H'.uppercase? # => true\n'Á'.uppercase? # => true\n'c'.uppercase? # => false\n'.'.uppercase? # => false\n```","summary":"<p>Returns <code>true</code> if this char is an uppercase letter.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":225,"url":null},"def":{"name":"uppercase?","return_type":"Bool","visibility":"Public","body":"ascii? ? ascii_uppercase? : Unicode.uppercase?(self)"}},{"html_id":"whitespace?:Bool-instance-method","name":"whitespace?","doc":"Returns `true` if this char is a whitespace according to unicode.\n\n```\n' '.whitespace?  # => true\n'\\t'.whitespace? # => true\n'b'.whitespace?  # => false\n```","summary":"<p>Returns <code>true</code> if this char is a whitespace according to unicode.</p>","abstract":false,"location":{"filename":"src/char.cr","line_number":294,"url":null},"def":{"name":"whitespace?","return_type":"Bool","visibility":"Public","body":"ascii? ? ascii_whitespace? : Unicode.whitespace?(self)"}}],"types":[{"html_id":"Crystal/Char/Reader","path":"Char/Reader.html","kind":"struct","full_name":"Char::Reader","name":"Reader","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/char/reader.cr","line_number":14,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"namespace":{"html_id":"Crystal/Char","kind":"struct","full_name":"Char","name":"Char"},"doc":"A `Char::Reader` allows iterating a `String` by Chars.\n\nAs soon as you instantiate a `Char::Reader` it will decode the first\nchar in the `String`, which can be accessed by invoking `current_char`.\nAt this point `pos`, the current position in the string, will equal zero.\nSuccessive calls to `next_char` return the next chars in the string,\nadvancing `pos`.\n\nNote that the null character `'\\0'` will be returned in `current_char` when\nthe end is reached (as well as when the string is empty). Thus, `has_next?`\nwill return `false` only when `pos` is equal to the string's bytesize, in which\ncase `current_char` will always be `'\\0'`.","summary":"<p>A <code><a href=\"../Char/Reader.html\">Char::Reader</a></code> allows iterating a <code><a href=\"../String.html\">String</a></code> by Chars.</p>","constructors":[{"html_id":"new(string:String,pos=0)-class-method","name":"new","doc":"Creates a reader with the specified *string* positioned at\nbyte index *pos*.","summary":"<p>Creates a reader with the specified <em>string</em> positioned at byte index <em>pos</em>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"pos","default_value":"0","external_name":"pos","restriction":""}],"args_string":"(string : String, pos = 0)","args_html":"(string : <a href=\"../String.html\">String</a>, pos = <span class=\"n\">0</span>)","location":{"filename":"src/char/reader.cr","line_number":58,"url":null},"def":{"name":"new","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"pos","default_value":"0","external_name":"pos","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(string, pos)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(*,at_endstring:String)-class-method","name":"new","doc":"Creates a reader that will be positioned at the last char\nof the given string.","summary":"<p>Creates a reader that will be positioned at the last char of the given string.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"string","external_name":"at_end","restriction":"String"}],"args_string":"(*, at_end string : String)","args_html":"(*, at_end string : <a href=\"../String.html\">String</a>)","location":{"filename":"src/char/reader.cr","line_number":68,"url":null},"def":{"name":"new","args":[{"name":"","external_name":"","restriction":""},{"name":"string","external_name":"at_end","restriction":"String"}],"splat_index":0,"visibility":"Public","body":"_ = allocate\n_.initialize(at_end: string)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"current_char:Char-instance-method","name":"current_char","doc":"Returns the current character.\n\n```\nreader = Char::Reader.new(\"ab\")\nreader.current_char # => 'a'\nreader.next_char\nreader.current_char # => 'b'\n```","summary":"<p>Returns the current character.</p>","abstract":false,"location":{"filename":"src/char/reader.cr","line_number":28,"url":null},"def":{"name":"current_char","return_type":"Char","visibility":"Public","body":"@current_char"}},{"html_id":"current_char_width:Int32-instance-method","name":"current_char_width","doc":"Returns the size of the `#current_char` (in bytes) as if it were encoded in UTF-8.\n\n```\nreader = Char::Reader.new(\"aé\")\nreader.current_char_width # => 1\nreader.next_char\nreader.current_char_width # => 2\n```","summary":"<p>Returns the size of the <code><a href=\"../Char/Reader.html#current_char%3AChar-instance-method\">#current_char</a></code> (in bytes) as if it were encoded in UTF-8.</p>","abstract":false,"location":{"filename":"src/char/reader.cr","line_number":38,"url":null},"def":{"name":"current_char_width","return_type":"Int32","visibility":"Public","body":"@current_char_width"}},{"html_id":"each(&):Nil-instance-method","name":"each","doc":"Yields successive characters from `#string` starting from `#pos`.\n\n```\nreader = Char::Reader.new(\"abc\")\nreader.next_char\nreader.each do |c|\n  puts c.upcase\nend\n```\n\n``` text\nB\nC\n```","summary":"<p>Yields successive characters from <code><a href=\"../Char/Reader.html#string%3AString-instance-method\">#string</a></code> starting from <code><a href=\"../Char/Reader.html#pos%3AInt32-instance-method\">#pos</a></code>.</p>","abstract":false,"location":{"filename":"src/char/reader.cr","line_number":179,"url":null},"def":{"name":"each","yields":1,"return_type":"Nil","visibility":"Public","body":"while has_next?\n  yield current_char\n  @pos = @pos + @current_char_width\n  decode_current_char\nend"}},{"html_id":"error:UInt8?-instance-method","name":"error","doc":"If there was an error decoding the current char because\nof an invalid UTF-8 byte sequence, returns the byte\nthat produced the invalid encoding. Returns `0` if the char would've been\nout of bounds. Otherwise returns `nil`.","summary":"<p>If there was an error decoding the current char because of an invalid UTF-8 byte sequence, returns the byte that produced the invalid encoding.</p>","abstract":false,"location":{"filename":"src/char/reader.cr","line_number":54,"url":null},"def":{"name":"error","return_type":"UInt8 | ::Nil","visibility":"Public","body":"@error"}},{"html_id":"has_next?:Bool-instance-method","name":"has_next?","doc":"Returns `true` if there is a character left to read.\nThe terminating byte `'\\0'` is considered a valid character\nby this method.\n\n```\nreader = Char::Reader.new(\"a\")\nreader.has_next?      # => true\nreader.peek_next_char # => '\\0'\n```","summary":"<p>Returns <code>true</code> if there is a character left to read.</p>","abstract":false,"location":{"filename":"src/char/reader.cr","line_number":85,"url":null},"def":{"name":"has_next?","return_type":"Bool","visibility":"Public","body":"!@end"}},{"html_id":"has_previous?:Bool-instance-method","name":"has_previous?","doc":"Returns `true` if there are characters before\nthe current one.","summary":"<p>Returns <code>true</code> if there are characters before the current one.</p>","abstract":false,"location":{"filename":"src/char/reader.cr","line_number":130,"url":null},"def":{"name":"has_previous?","return_type":"Bool","visibility":"Public","body":"@pos > 0"}},{"html_id":"next_char:Char-instance-method","name":"next_char","doc":"Reads the next character in the string,\n`#pos` is incremented. Raises `IndexError` if the reader is\nat the end of the `#string`.\n\n```\nreader = Char::Reader.new(\"ab\")\nreader.next_char # => 'b'\n```","summary":"<p>Reads the next character in the string, <code><a href=\"../Char/Reader.html#pos%3AInt32-instance-method\">#pos</a></code> is incremented.</p>","abstract":false,"location":{"filename":"src/char/reader.cr","line_number":97,"url":null},"def":{"name":"next_char","return_type":"Char","visibility":"Public","body":"@pos = @pos + @current_char_width\nif @pos > @string.bytesize\n  raise(IndexError.new)\nend\ndecode_current_char\n"}},{"html_id":"peek_next_char:Char-instance-method","name":"peek_next_char","doc":"Returns the next character in the `#string`\nwithout incrementing `#pos`.\nRaises `IndexError` if the reader is at\nthe end of the `#string`.\n\n```\nreader = Char::Reader.new(\"ab\")\nreader.peek_next_char # => 'b'\nreader.current_char   # => 'a'\n```","summary":"<p>Returns the next character in the <code><a href=\"../Char/Reader.html#string%3AString-instance-method\">#string</a></code> without incrementing <code><a href=\"../Char/Reader.html#pos%3AInt32-instance-method\">#pos</a></code>.</p>","abstract":false,"location":{"filename":"src/char/reader.cr","line_number":116,"url":null},"def":{"name":"peek_next_char","return_type":"Char","visibility":"Public","body":"next_pos = @pos + @current_char_width\nif next_pos > @string.bytesize\n  raise(IndexError.new)\nend\ndecode_char_at(next_pos) do |code_point|\n  code_point.unsafe_chr\nend\n"}},{"html_id":"pos:Int32-instance-method","name":"pos","doc":"Returns the position of the current character.\n\n```\nreader = Char::Reader.new(\"ab\")\nreader.pos # => 0\nreader.next_char\nreader.pos # => 1\n```","summary":"<p>Returns the position of the current character.</p>","abstract":false,"location":{"filename":"src/char/reader.cr","line_number":48,"url":null},"def":{"name":"pos","return_type":"Int32","visibility":"Public","body":"@pos"}},{"html_id":"pos=(pos)-instance-method","name":"pos=","doc":"Sets `#pos` to *pos*.\n\n```\nreader = Char::Reader.new(\"abc\")\nreader.next_char\nreader.next_char\nreader.pos = 0\nreader.current_char # => 'a'\n```","summary":"<p>Sets <code><a href=\"../Char/Reader.html#pos%3AInt32-instance-method\">#pos</a></code> to <em>pos</em>.</p>","abstract":false,"args":[{"name":"pos","external_name":"pos","restriction":""}],"args_string":"(pos)","args_html":"(pos)","location":{"filename":"src/char/reader.cr","line_number":155,"url":null},"def":{"name":"pos=","args":[{"name":"pos","external_name":"pos","restriction":""}],"visibility":"Public","body":"if pos > @string.bytesize\n  raise(IndexError.new)\nend\n@pos = pos\ndecode_current_char\npos\n"}},{"html_id":"previous_char:Char-instance-method","name":"previous_char","doc":"Returns the previous character, `#pos`\nis decremented.\nRaises `IndexError` if the reader is at the beginning of\nthe `#string`","summary":"<p>Returns the previous character, <code><a href=\"../Char/Reader.html#pos%3AInt32-instance-method\">#pos</a></code> is decremented.</p>","abstract":false,"location":{"filename":"src/char/reader.cr","line_number":138,"url":null},"def":{"name":"previous_char","return_type":"Char","visibility":"Public","body":"if has_previous?\nelse\n  raise(IndexError.new)\nend\ndecode_previous_char.as(Char)\n"}},{"html_id":"string:String-instance-method","name":"string","doc":"Returns the reader's String.","summary":"<p>Returns the reader's String.</p>","abstract":false,"location":{"filename":"src/char/reader.cr","line_number":18,"url":null},"def":{"name":"string","return_type":"String","visibility":"Public","body":"@string"}}]}]},{"html_id":"Crystal/Class","path":"Class.html","kind":"class","full_name":"Class","name":"Class","abstract":true,"superclass":{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/class.cr","line_number":1,"url":null},{"filename":"src/primitives.cr","line_number":54,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"class_methods":[{"html_id":"<(other:T.class):BoolforallT-class-method","name":"<","doc":"Returns whether this class inherits or includes *other*.\n\n```\nInt32 < Number  # => true\nInt32 < Value   # => true\nInt32 < Int32   # => false\nInt32 <= String # => false\n```","summary":"<p>Returns whether this class inherits or includes <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) : Bool forall T","args_html":"(other : <span class=\"t\">T</span>.<span class=\"k\">class</span>) : <a href=\"Bool.html\">Bool</a> forall T","location":{"filename":"src/class.cr","line_number":29,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"T.class"}],"return_type":"Bool","visibility":"Public","body":"{% @type %}\nother._gt(self)\n"}},{"html_id":"<=(other:T.class):BoolforallT-class-method","name":"<=","doc":"Returns whether this class inherits or includes *other*, or\nis equal to *other*.\n\n```\nInt32 < Number  # => true\nInt32 < Value   # => true\nInt32 <= Int32  # => true\nInt32 <= String # => false\n```","summary":"<p>Returns whether this class inherits or includes <em>other</em>, or is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) : Bool forall T","args_html":"(other : <span class=\"t\">T</span>.<span class=\"k\">class</span>) : <a href=\"Bool.html\">Bool</a> forall T","location":{"filename":"src/class.cr","line_number":44,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"T.class"}],"return_type":"Bool","visibility":"Public","body":"{% @type %}\nother._gte(self)\n"}},{"html_id":"==(other:Class):Bool-class-method","name":"==","doc":"Returns whether this class is the same as *other*.\n\n```\nInt32 == Int32  # => true\nInt32 == String # => false\n```","summary":"<p>Returns whether this class is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Class"}],"args_string":"(other : Class) : Bool","args_html":"(other : <a href=\"Class.html\">Class</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/class.cr","line_number":17,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Class"}],"return_type":"Bool","visibility":"Public","body":"crystal_type_id == other.crystal_type_id"}},{"html_id":"===(other)-class-method","name":"===","doc":"Case equality.\n\nThe `===` method is used in a `case ... when ... end` expression.\n\nFor example, this code:\n\n```\ncase value\nwhen x\n  # something when x\nwhen y\n  # something when y\nend\n```\n\nIs equivalent to this code:\n\n```\nif x === value\n  # something when x\nelsif y === value\n  # something when y\nend\n```\n\nObject simply implements `===` by invoking `==`, but subclasses\n(notably `Regex`) can override it to provide meaningful case-equality semantics.","summary":"<p>Case equality.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/class.cr","line_number":97,"url":null},"def":{"name":"===","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"other.is_a?(self)"}},{"html_id":">(other:T.class):BoolforallT-class-method","name":">","doc":"Returns whether *other* inherits or includes `self`.\n\n```\nNumber > Int32  # => true\nNumber > Number # => false\nNumber > Object # => false\n```","summary":"<p>Returns whether <em>other</em> inherits or includes <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) : Bool forall T","args_html":"(other : <span class=\"t\">T</span>.<span class=\"k\">class</span>) : <a href=\"Bool.html\">Bool</a> forall T","location":{"filename":"src/class.cr","line_number":57,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"T.class"}],"return_type":"Bool","visibility":"Public","body":"{% @type %}\nother._lt(self)\n"}},{"html_id":">=(other:T.class)forallT-class-method","name":">=","doc":"Returns whether *other* inherits or includes `self`, or is equal\nto `self`.\n\n```\nNumber >= Int32  # => true\nNumber >= Number # => true\nNumber >= Object # => false\n```","summary":"<p>Returns whether <em>other</em> inherits or includes <code>self</code>, or is equal to <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) forall T","args_html":"(other : <span class=\"t\">T</span>.<span class=\"k\">class</span>) forall T","location":{"filename":"src/class.cr","line_number":71,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"T.class"}],"visibility":"Public","body":"{% @type %}\nother._lte(self)\n"}},{"html_id":"clone-class-method","name":"clone","abstract":false,"location":{"filename":"src/class.cr","line_number":156,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"dup-class-method","name":"dup","doc":"Returns a shallow copy of this object.\n\nBecause `Value` is a value type, this method returns `self`,\nwhich already involves a shallow copy of this object because\nvalue types are passed by value.","summary":"<p>Returns a shallow copy of this object.</p>","abstract":false,"location":{"filename":"src/class.cr","line_number":152,"url":null},"def":{"name":"dup","visibility":"Public","body":"self"}},{"html_id":"hash(hasher)-class-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/class.cr","line_number":7,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher.class(self)"}},{"html_id":"inspect(io:IO):Nil-class-method","name":"inspect","doc":"Appends a string representation of this object\nto the given `IO` object.\n\nSimilar to `to_s(io)`, but usually appends more information\nabout this object.\nSee `#inspect`.","summary":"<p>Appends a string representation of this object to the given <code><a href=\"IO.html\">IO</a></code> object.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/class.cr","line_number":2,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"name:String-class-method","name":"name","doc":"Returns the name of this class.\n\n```\nString.name # => \"String\"\n```","summary":"<p>Returns the name of this class.</p>","abstract":false,"location":{"filename":"src/class.cr","line_number":106,"url":null},"def":{"name":"name","return_type":"String","visibility":"Public","body":"{{ @type.name.stringify }}"}},{"html_id":"nilable?:Bool-class-method","name":"nilable?","doc":"Returns `true` if this class is `Nil`.\n\n```\nInt32.nilable? # => false\nNil.nilable?   # => true\n```","summary":"<p>Returns <code>true</code> if this class is <code><a href=\"Nil.html\">Nil</a></code>.</p>","abstract":false,"location":{"filename":"src/class.cr","line_number":144,"url":null},"def":{"name":"nilable?","return_type":"Bool","visibility":"Public","body":"self == ::Nil"}},{"html_id":"to_s(io:IO):Nil-class-method","name":"to_s","doc":"Appends a `String` representation of this object\nto the given `IO` object.\n\nAn object must never append itself to the io argument,\nas this will in turn call `to_s(io)` on it.","summary":"<p>Appends a <code><a href=\"String.html\">String</a></code> representation of this object to the given <code><a href=\"IO.html\">IO</a></code> object.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/class.cr","line_number":148,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << ({{ @type.name.stringify }})"}},{"html_id":"|(other:U.class)forallU-class-method","name":"|","doc":"Returns the union type of `self` and *other*.\n\n```\nInt32 | Char # => (Int32 | Char)\n```","summary":"<p>Returns the union type of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"U.class"}],"args_string":"(other : U.class) forall U","args_html":"(other : <span class=\"t\">U</span>.<span class=\"k\">class</span>) forall U","location":{"filename":"src/class.cr","line_number":132,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"U.class"}],"visibility":"Public","body":"t = uninitialized self\nu = uninitialized U\ntypeof(t, u)\n"}}],"constructors":[{"html_id":"cast(other):self-class-method","name":"cast","doc":"Casts *other* to this class.\n\nThis is the same as using `as`, but allows the class to be passed around as\nan argument. See the\n[documentation on as](//crystal-lang.org/docs/syntax_and_semantics/as.html)\nfor more information.\n\n```\nklass = Int32\nnumber = [99, \"str\"][0]\ntypeof(number)             # => (String | Int32)\ntypeof(klass.cast(number)) # => Int32\n```","summary":"<p>Casts <em>other</em> to this class.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other) : self","args_html":"(other) : <span class=\"k\">self</span>","location":{"filename":"src/class.cr","line_number":123,"url":null},"def":{"name":"cast","args":[{"name":"other","external_name":"other","restriction":""}],"return_type":"self","visibility":"Public","body":"other.as(self)"}}],"instance_methods":[{"html_id":"<(other:T.class):BoolforallT-instance-method","name":"<","doc":"Returns whether this class inherits or includes *other*.\n\n```\nInt32 < Number  # => true\nInt32 < Value   # => true\nInt32 < Int32   # => false\nInt32 <= String # => false\n```","summary":"<p>Returns whether this class inherits or includes <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) : Bool forall T","args_html":"(other : <span class=\"t\">T</span>.<span class=\"k\">class</span>) : <a href=\"Bool.html\">Bool</a> forall T","location":{"filename":"src/class.cr","line_number":29,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"T.class"}],"return_type":"Bool","visibility":"Public","body":"{% @type %}\nother._gt(self)\n"}},{"html_id":"<=(other:T.class):BoolforallT-instance-method","name":"<=","doc":"Returns whether this class inherits or includes *other*, or\nis equal to *other*.\n\n```\nInt32 < Number  # => true\nInt32 < Value   # => true\nInt32 <= Int32  # => true\nInt32 <= String # => false\n```","summary":"<p>Returns whether this class inherits or includes <em>other</em>, or is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) : Bool forall T","args_html":"(other : <span class=\"t\">T</span>.<span class=\"k\">class</span>) : <a href=\"Bool.html\">Bool</a> forall T","location":{"filename":"src/class.cr","line_number":44,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"T.class"}],"return_type":"Bool","visibility":"Public","body":"{% @type %}\nother._gte(self)\n"}},{"html_id":"==(other:Class):Bool-instance-method","name":"==","doc":"Returns whether this class is the same as *other*.\n\n```\nInt32 == Int32  # => true\nInt32 == String # => false\n```","summary":"<p>Returns whether this class is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Class"}],"args_string":"(other : Class) : Bool","args_html":"(other : <a href=\"Class.html\">Class</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/class.cr","line_number":17,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Class"}],"return_type":"Bool","visibility":"Public","body":"crystal_type_id == other.crystal_type_id"}},{"html_id":"===(other)-instance-method","name":"===","doc":"Case equality.\n\nThe `===` method is used in a `case ... when ... end` expression.\n\nFor example, this code:\n\n```\ncase value\nwhen x\n  # something when x\nwhen y\n  # something when y\nend\n```\n\nIs equivalent to this code:\n\n```\nif x === value\n  # something when x\nelsif y === value\n  # something when y\nend\n```\n\nObject simply implements `===` by invoking `==`, but subclasses\n(notably `Regex`) can override it to provide meaningful case-equality semantics.","summary":"<p>Case equality.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/class.cr","line_number":97,"url":null},"def":{"name":"===","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"other.is_a?(self)"}},{"html_id":">(other:T.class):BoolforallT-instance-method","name":">","doc":"Returns whether *other* inherits or includes `self`.\n\n```\nNumber > Int32  # => true\nNumber > Number # => false\nNumber > Object # => false\n```","summary":"<p>Returns whether <em>other</em> inherits or includes <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) : Bool forall T","args_html":"(other : <span class=\"t\">T</span>.<span class=\"k\">class</span>) : <a href=\"Bool.html\">Bool</a> forall T","location":{"filename":"src/class.cr","line_number":57,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"T.class"}],"return_type":"Bool","visibility":"Public","body":"{% @type %}\nother._lt(self)\n"}},{"html_id":">=(other:T.class)forallT-instance-method","name":">=","doc":"Returns whether *other* inherits or includes `self`, or is equal\nto `self`.\n\n```\nNumber >= Int32  # => true\nNumber >= Number # => true\nNumber >= Object # => false\n```","summary":"<p>Returns whether <em>other</em> inherits or includes <code>self</code>, or is equal to <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"T.class"}],"args_string":"(other : T.class) forall T","args_html":"(other : <span class=\"t\">T</span>.<span class=\"k\">class</span>) forall T","location":{"filename":"src/class.cr","line_number":71,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"T.class"}],"visibility":"Public","body":"{% @type %}\nother._lte(self)\n"}},{"html_id":"cast(other):self-instance-method","name":"cast","doc":"Casts *other* to this class.\n\nThis is the same as using `as`, but allows the class to be passed around as\nan argument. See the\n[documentation on as](//crystal-lang.org/docs/syntax_and_semantics/as.html)\nfor more information.\n\n```\nklass = Int32\nnumber = [99, \"str\"][0]\ntypeof(number)             # => (String | Int32)\ntypeof(klass.cast(number)) # => Int32\n```","summary":"<p>Casts <em>other</em> to this class.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other) : self","args_html":"(other) : <span class=\"k\">self</span>","location":{"filename":"src/class.cr","line_number":123,"url":null},"def":{"name":"cast","args":[{"name":"other","external_name":"other","restriction":""}],"return_type":"self","visibility":"Public","body":"other.as(self)"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/class.cr","line_number":156,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy of this object.\n\nBecause `Value` is a value type, this method returns `self`,\nwhich already involves a shallow copy of this object because\nvalue types are passed by value.","summary":"<p>Returns a shallow copy of this object.</p>","abstract":false,"location":{"filename":"src/class.cr","line_number":152,"url":null},"def":{"name":"dup","visibility":"Public","body":"self"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/class.cr","line_number":7,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher.class(self)"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a string representation of this object\nto the given `IO` object.\n\nSimilar to `to_s(io)`, but usually appends more information\nabout this object.\nSee `#inspect`.","summary":"<p>Appends a string representation of this object to the given <code><a href=\"IO.html\">IO</a></code> object.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/class.cr","line_number":2,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"name:String-instance-method","name":"name","doc":"Returns the name of this class.\n\n```\nString.name # => \"String\"\n```","summary":"<p>Returns the name of this class.</p>","abstract":false,"location":{"filename":"src/class.cr","line_number":106,"url":null},"def":{"name":"name","return_type":"String","visibility":"Public","body":"{{ @type.name.stringify }}"}},{"html_id":"nilable?:Bool-instance-method","name":"nilable?","doc":"Returns `true` if this class is `Nil`.\n\n```\nInt32.nilable? # => false\nNil.nilable?   # => true\n```","summary":"<p>Returns <code>true</code> if this class is <code><a href=\"Nil.html\">Nil</a></code>.</p>","abstract":false,"location":{"filename":"src/class.cr","line_number":144,"url":null},"def":{"name":"nilable?","return_type":"Bool","visibility":"Public","body":"self == ::Nil"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a `String` representation of this object\nto the given `IO` object.\n\nAn object must never append itself to the io argument,\nas this will in turn call `to_s(io)` on it.","summary":"<p>Appends a <code><a href=\"String.html\">String</a></code> representation of this object to the given <code><a href=\"IO.html\">IO</a></code> object.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/class.cr","line_number":148,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << ({{ @type.name.stringify }})"}},{"html_id":"|(other:U.class)forallU-instance-method","name":"|","doc":"Returns the union type of `self` and *other*.\n\n```\nInt32 | Char # => (Int32 | Char)\n```","summary":"<p>Returns the union type of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"U.class"}],"args_string":"(other : U.class) forall U","args_html":"(other : <span class=\"t\">U</span>.<span class=\"k\">class</span>) forall U","location":{"filename":"src/class.cr","line_number":132,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"U.class"}],"visibility":"Public","body":"t = uninitialized self\nu = uninitialized U\ntypeof(t, u)\n"}}]},{"html_id":"Crystal/Colorize","path":"Colorize.html","kind":"module","full_name":"Colorize","name":"Colorize","abstract":false,"locations":[{"filename":"src/colorize.cr","line_number":123,"url":null},{"filename":"src/colorize.cr","line_number":191,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"With `Colorize` you can change the fore- and background colors and text decorations when rendering text\non terminals supporting ANSI escape codes. It adds the `colorize` method to `Object` and thus all classes\nas its main interface, which calls `to_s` and surrounds it with the necessary escape codes\nwhen it comes to obtaining a string representation of the object.\n\nIts first argument changes the foreground color:\n\n```\nrequire \"colorize\"\n\n\"foo\".colorize(:green)\n100.colorize(:red)\n[1, 2, 3].colorize(:blue)\n```\n\nThere are alternative ways to change the foreground color:\n\n```\nrequire \"colorize\"\n\n\"foo\".colorize.fore(:green)\n\"foo\".colorize.green\n```\n\nTo change the background color, the following methods are available:\n\n```\nrequire \"colorize\"\n\n\"foo\".colorize.back(:green)\n\"foo\".colorize.on(:green)\n\"foo\".colorize.on_green\n```\n\nYou can also pass an RGB color to `colorize`:\n\n```\nrequire \"colorize\"\n\n\"foo\".colorize(0, 255, 255) # => \"foo\" in aqua\n\n# This is the same as:\n\n\"foo\".colorize(Colorize::ColorRGB.new(0, 255, 255)) # => \"foo\" in aqua\n```\n\nOr an 8-bit color:\n\n```\nrequire \"colorize\"\n\n\"foo\".colorize(Colorize::Color256.new(208)) # => \"foo\" in orange\n```\n\nIt's also possible to change the text decoration:\n\n```\nrequire \"colorize\"\n\n\"foo\".colorize.mode(:underline)\n\"foo\".colorize.underline\n```\n\nThe `colorize` method returns a `Colorize::Object` instance,\nwhich allows chaining methods together:\n\n```\nrequire \"colorize\"\n\n\"foo\".colorize.fore(:yellow).back(:blue).mode(:underline)\n```\n\nWith the `toggle` method you can temporarily disable adding the escape codes.\nSettings of the instance are preserved however and can be turned back on later:\n\n```\nrequire \"colorize\"\n\n\"foo\".colorize(:red).toggle(false)              # => \"foo\" without color\n\"foo\".colorize(:red).toggle(false).toggle(true) # => \"foo\" in red\n```\n\nThe color `:default` leaves the object's representation as it is but the object is a `Colorize::Object` then\nwhich is handy in conditions such as:\n\n```\nrequire \"colorize\"\n\n\"foo\".colorize(Random::DEFAULT.next_bool ? :green : :default)\n```\n\nAvailable colors are:\n```\n:default\n:black\n:red\n:green\n:yellow\n:blue\n:magenta\n:cyan\n:light_gray\n:dark_gray\n:light_red\n:light_green\n:light_yellow\n:light_blue\n:light_magenta\n:light_cyan\n:white\n```\n\nAvailable text decorations are:\n```\n:bold\n:bright\n:dim\n:underline\n:blink\n:reverse\n:hidden\n```","summary":"<p>With <code><a href=\"Colorize.html\">Colorize</a></code> you can change the fore- and background colors and text decorations when rendering text on terminals supporting ANSI escape codes.</p>","class_methods":[{"html_id":"enabled=(enabled:Bool)-class-method","name":"enabled=","doc":"Objects will only be colored if this is `true`.\n\n```\nrequire \"colorize\"\n\nColorize.enabled = true\n\"hello\".colorize.red.to_s # => \"\\e[31mhello\\e[0m\"\n\nColorize.enabled = false\n\"hello\".colorize.red.to_s # => \"hello\"\n```\n\nNOTE: This is by default disabled on non-TTY devices because they likely don't support ANSI escape codes.\nThis will also be disabled if the environment variable `TERM` is \"dumb\".","summary":"<p>Objects will only be colored if this is <code>true</code>.</p>","abstract":false,"args":[{"name":"enabled","external_name":"enabled","restriction":"Bool"}],"args_string":"(enabled : Bool)","args_html":"(enabled : <a href=\"Bool.html\">Bool</a>)","location":{"filename":"src/colorize.cr","line_number":138,"url":null},"def":{"name":"enabled=","args":[{"name":"enabled","external_name":"enabled","restriction":"Bool"}],"visibility":"Public","body":"@@enabled = enabled"}},{"html_id":"enabled?:Bool-class-method","name":"enabled?","doc":"Objects will only be colored if this is `true`.\n\n```\nrequire \"colorize\"\n\nColorize.enabled = true\n\"hello\".colorize.red.to_s # => \"\\e[31mhello\\e[0m\"\n\nColorize.enabled = false\n\"hello\".colorize.red.to_s # => \"hello\"\n```\n\nNOTE: This is by default disabled on non-TTY devices because they likely don't support ANSI escape codes.\nThis will also be disabled if the environment variable `TERM` is \"dumb\".","summary":"<p>Objects will only be colored if this is <code>true</code>.</p>","abstract":false,"location":{"filename":"src/colorize.cr","line_number":138,"url":null},"def":{"name":"enabled?","return_type":"Bool","visibility":"Public","body":"@@enabled"}},{"html_id":"on_tty_only!-class-method","name":"on_tty_only!","doc":"Makes `Colorize.enabled` `true` if and only if both of `STDOUT.tty?`\nand `STDERR.tty?` are `true` and the tty is not considered a dumb terminal.\nThis is determined by the environment variable called `TERM`.\nIf `TERM=dumb`, color won't be enabled.","summary":"<p>Makes <code>Colorize.enabled</code> <code>true</code> if and only if both of <code>STDOUT.tty?</code> and <code>STDERR.tty?</code> are <code>true</code> and the tty is not considered a dumb terminal.</p>","abstract":false,"location":{"filename":"src/colorize.cr","line_number":144,"url":null},"def":{"name":"on_tty_only!","visibility":"Public","body":"self.enabled = (STDOUT.tty? && STDERR.tty?) && (ENV[\"TERM\"]? != \"dumb\")"}},{"html_id":"reset(io=STDOUT)-class-method","name":"reset","doc":"Resets the color and text decoration of the *io*.\n\n```\nwith_color.green.surround(io) do\n  io << \"green\"\n  Colorize.reset\n  io << \" default\"\nend\n```","summary":"<p>Resets the color and text decoration of the <em>io</em>.</p>","abstract":false,"args":[{"name":"io","default_value":"STDOUT","external_name":"io","restriction":""}],"args_string":"(io = STDOUT)","args_html":"(io = <span class=\"t\">STDOUT</span>)","location":{"filename":"src/colorize.cr","line_number":157,"url":null},"def":{"name":"reset","args":[{"name":"io","default_value":"STDOUT","external_name":"io","restriction":""}],"visibility":"Public","body":"if enabled?\n  io << \"\\e[0m\"\nend"}},{"html_id":"with:Colorize::Object(String)-class-method","name":"with","doc":"Helper method to use colorize with `IO`.\n\n```\nio = IO::Memory.new\nio << \"not-green\"\nColorize.with.green.bold.surround(io) do\n  io << \"green and bold if Colorize.enabled\"\nend\n```","summary":"<p>Helper method to use colorize with <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/colorize.cr","line_number":170,"url":null},"def":{"name":"with","return_type":"Colorize::Object(String)","visibility":"Public","body":"\"\".colorize"}}],"types":[{"html_id":"Crystal/Colorize/Color","path":"Colorize/Color.html","kind":"alias","full_name":"Colorize::Color","name":"Color","abstract":false,"locations":[{"filename":"src/colorize.cr","line_number":192,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(Colorize::Color256 | Colorize::ColorANSI | Colorize::ColorRGB)","aliased_html":"<a href=\"../Colorize/Color256.html\">Colorize::Color256</a> | <a href=\"../Colorize/ColorANSI.html\">Colorize::ColorANSI</a> | <a href=\"../Colorize/ColorRGB.html\">Colorize::ColorRGB</a>","const":false,"namespace":{"html_id":"Crystal/Colorize","kind":"module","full_name":"Colorize","name":"Colorize"}},{"html_id":"Crystal/Colorize/Color256","path":"Colorize/Color256.html","kind":"struct","full_name":"Colorize::Color256","name":"Color256","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/colorize.cr","line_number":224,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Colorize","kind":"module","full_name":"Colorize","name":"Colorize"},"doc":"An 8-bit color.","summary":"<p>An 8-bit color.</p>","constructors":[{"html_id":"new(value:UInt8)-class-method","name":"new","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"UInt8"}],"args_string":"(value : UInt8)","args_html":"(value : <a href=\"../UInt8.html\">UInt8</a>)","location":{"filename":"src/colorize.cr","line_number":224,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"UInt8"}],"visibility":"Public","body":"_ = allocate\n_.initialize(value)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"back(io:IO):Nil-instance-method","name":"back","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/colorize.cr","line_number":231,"url":null},"def":{"name":"back","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"48;5;\"\nvalue.to_s(io)\n"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/colorize.cr","line_number":224,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new(@value.clone)"}},{"html_id":"copy_with(value_value=@value)-instance-method","name":"copy_with","abstract":false,"args":[{"name":"_value","default_value":"@value","external_name":"value","restriction":""}],"args_string":"(value _value = @value)","args_html":"(value _value = @value)","location":{"filename":"src/colorize.cr","line_number":224,"url":null},"def":{"name":"copy_with","args":[{"name":"_value","default_value":"@value","external_name":"value","restriction":""}],"visibility":"Public","body":"self.class.new(_value)"}},{"html_id":"fore(io:IO):Nil-instance-method","name":"fore","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/colorize.cr","line_number":226,"url":null},"def":{"name":"fore","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"38;5;\"\nvalue.to_s(io)\n"}},{"html_id":"value:UInt8-instance-method","name":"value","abstract":false,"def":{"name":"value","return_type":"UInt8","visibility":"Public","body":"@value"}}]},{"html_id":"Crystal/Colorize/ColorANSI","path":"Colorize/ColorANSI.html","kind":"enum","full_name":"Colorize::ColorANSI","name":"ColorANSI","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/colorize.cr","line_number":195,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Default","name":"Default","value":"39"},{"id":"Black","name":"Black","value":"30"},{"id":"Red","name":"Red","value":"31"},{"id":"Green","name":"Green","value":"32"},{"id":"Yellow","name":"Yellow","value":"33"},{"id":"Blue","name":"Blue","value":"34"},{"id":"Magenta","name":"Magenta","value":"35"},{"id":"Cyan","name":"Cyan","value":"36"},{"id":"LightGray","name":"LightGray","value":"37"},{"id":"DarkGray","name":"DarkGray","value":"90"},{"id":"LightRed","name":"LightRed","value":"91"},{"id":"LightGreen","name":"LightGreen","value":"92"},{"id":"LightYellow","name":"LightYellow","value":"93"},{"id":"LightBlue","name":"LightBlue","value":"94"},{"id":"LightMagenta","name":"LightMagenta","value":"95"},{"id":"LightCyan","name":"LightCyan","value":"96"},{"id":"White","name":"White","value":"97"}],"namespace":{"html_id":"Crystal/Colorize","kind":"module","full_name":"Colorize","name":"Colorize"},"doc":"One color of a fixed set of colors.","summary":"<p>One color of a fixed set of colors.</p>","instance_methods":[{"html_id":"back(io:IO):Nil-instance-method","name":"back","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/colorize.cr","line_number":218,"url":null},"def":{"name":"back","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"(to_i + 10).to_s(io)"}},{"html_id":"black?-instance-method","name":"black?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":197,"url":null},"def":{"name":"black?","visibility":"Public","body":"self == Black"}},{"html_id":"blue?-instance-method","name":"blue?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":201,"url":null},"def":{"name":"blue?","visibility":"Public","body":"self == Blue"}},{"html_id":"cyan?-instance-method","name":"cyan?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":203,"url":null},"def":{"name":"cyan?","visibility":"Public","body":"self == Cyan"}},{"html_id":"dark_gray?-instance-method","name":"dark_gray?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":205,"url":null},"def":{"name":"dark_gray?","visibility":"Public","body":"self == DarkGray"}},{"html_id":"default?-instance-method","name":"default?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":196,"url":null},"def":{"name":"default?","visibility":"Public","body":"self == Default"}},{"html_id":"fore(io:IO):Nil-instance-method","name":"fore","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/colorize.cr","line_number":214,"url":null},"def":{"name":"fore","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_i.to_s(io)"}},{"html_id":"green?-instance-method","name":"green?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":199,"url":null},"def":{"name":"green?","visibility":"Public","body":"self == Green"}},{"html_id":"light_blue?-instance-method","name":"light_blue?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":209,"url":null},"def":{"name":"light_blue?","visibility":"Public","body":"self == LightBlue"}},{"html_id":"light_cyan?-instance-method","name":"light_cyan?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":211,"url":null},"def":{"name":"light_cyan?","visibility":"Public","body":"self == LightCyan"}},{"html_id":"light_gray?-instance-method","name":"light_gray?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":204,"url":null},"def":{"name":"light_gray?","visibility":"Public","body":"self == LightGray"}},{"html_id":"light_green?-instance-method","name":"light_green?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":207,"url":null},"def":{"name":"light_green?","visibility":"Public","body":"self == LightGreen"}},{"html_id":"light_magenta?-instance-method","name":"light_magenta?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":210,"url":null},"def":{"name":"light_magenta?","visibility":"Public","body":"self == LightMagenta"}},{"html_id":"light_red?-instance-method","name":"light_red?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":206,"url":null},"def":{"name":"light_red?","visibility":"Public","body":"self == LightRed"}},{"html_id":"light_yellow?-instance-method","name":"light_yellow?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":208,"url":null},"def":{"name":"light_yellow?","visibility":"Public","body":"self == LightYellow"}},{"html_id":"magenta?-instance-method","name":"magenta?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":202,"url":null},"def":{"name":"magenta?","visibility":"Public","body":"self == Magenta"}},{"html_id":"red?-instance-method","name":"red?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":198,"url":null},"def":{"name":"red?","visibility":"Public","body":"self == Red"}},{"html_id":"white?-instance-method","name":"white?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":212,"url":null},"def":{"name":"white?","visibility":"Public","body":"self == White"}},{"html_id":"yellow?-instance-method","name":"yellow?","abstract":false,"location":{"filename":"src/colorize.cr","line_number":200,"url":null},"def":{"name":"yellow?","visibility":"Public","body":"self == Yellow"}}]},{"html_id":"Crystal/Colorize/ColorRGB","path":"Colorize/ColorRGB.html","kind":"struct","full_name":"Colorize::ColorRGB","name":"ColorRGB","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/colorize.cr","line_number":238,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Colorize","kind":"module","full_name":"Colorize","name":"Colorize"},"doc":"An RGB color.","summary":"<p>An RGB color.</p>","constructors":[{"html_id":"new(red:UInt8,green:UInt8,blue:UInt8)-class-method","name":"new","abstract":false,"args":[{"name":"red","external_name":"red","restriction":"UInt8"},{"name":"green","external_name":"green","restriction":"UInt8"},{"name":"blue","external_name":"blue","restriction":"UInt8"}],"args_string":"(red : UInt8, green : UInt8, blue : UInt8)","args_html":"(red : <a href=\"../UInt8.html\">UInt8</a>, green : <a href=\"../UInt8.html\">UInt8</a>, blue : <a href=\"../UInt8.html\">UInt8</a>)","location":{"filename":"src/colorize.cr","line_number":238,"url":null},"def":{"name":"new","args":[{"name":"red","external_name":"red","restriction":"UInt8"},{"name":"green","external_name":"green","restriction":"UInt8"},{"name":"blue","external_name":"blue","restriction":"UInt8"}],"visibility":"Public","body":"_ = allocate\n_.initialize(red, green, blue)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"back(io:IO):Nil-instance-method","name":"back","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/colorize.cr","line_number":249,"url":null},"def":{"name":"back","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"48;2;\"\n(io << red) << \";\"\n(io << green) << \";\"\nio << blue\n"}},{"html_id":"blue:UInt8-instance-method","name":"blue","abstract":false,"def":{"name":"blue","return_type":"UInt8","visibility":"Public","body":"@blue"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/colorize.cr","line_number":238,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new(@red.clone, @green.clone, @blue.clone)"}},{"html_id":"copy_with(red_red=@red,green_green=@green,blue_blue=@blue)-instance-method","name":"copy_with","abstract":false,"args":[{"name":"_red","default_value":"@red","external_name":"red","restriction":""},{"name":"_green","default_value":"@green","external_name":"green","restriction":""},{"name":"_blue","default_value":"@blue","external_name":"blue","restriction":""}],"args_string":"(red _red = @red, green _green = @green, blue _blue = @blue)","args_html":"(red _red = @red, green _green = @green, blue _blue = @blue)","location":{"filename":"src/colorize.cr","line_number":238,"url":null},"def":{"name":"copy_with","args":[{"name":"_red","default_value":"@red","external_name":"red","restriction":""},{"name":"_green","default_value":"@green","external_name":"green","restriction":""},{"name":"_blue","default_value":"@blue","external_name":"blue","restriction":""}],"visibility":"Public","body":"self.class.new(_red, _green, _blue)"}},{"html_id":"fore(io:IO):Nil-instance-method","name":"fore","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/colorize.cr","line_number":242,"url":null},"def":{"name":"fore","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"38;2;\"\n(io << red) << \";\"\n(io << green) << \";\"\nio << blue\n"}},{"html_id":"green:UInt8-instance-method","name":"green","abstract":false,"def":{"name":"green","return_type":"UInt8","visibility":"Public","body":"@green"}},{"html_id":"red:UInt8-instance-method","name":"red","abstract":false,"def":{"name":"red","return_type":"UInt8","visibility":"Public","body":"@red"}}]},{"html_id":"Crystal/Colorize/Object","path":"Colorize/Object.html","kind":"struct","full_name":"Colorize::Object(T)","name":"Object","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/colorize.cr","line_number":259,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Colorize","kind":"module","full_name":"Colorize","name":"Colorize"},"doc":"A colorized object. Colors and text decorations can be modified.","summary":"<p>A colorized object.</p>","constructors":[{"html_id":"new(object:T)-class-method","name":"new","abstract":false,"args":[{"name":"object","external_name":"object","restriction":"T"}],"args_string":"(object : T)","args_html":"(object : T)","location":{"filename":"src/colorize.cr","line_number":283,"url":null},"def":{"name":"new","args":[{"name":"object","external_name":"object","restriction":"T"}],"visibility":"Public","body":"_ = Object(T).allocate\n_.initialize(object)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"back(color:Symbol):self-instance-method","name":"back","abstract":false,"args":[{"name":"color","external_name":"color","restriction":"Symbol"}],"args_string":"(color : Symbol) : self","args_html":"(color : <a href=\"../Symbol.html\">Symbol</a>) : <span class=\"k\">self</span>","location":{"filename":"src/colorize.cr","line_number":324,"url":null},"def":{"name":"back","args":[{"name":"color","external_name":"color","restriction":"Symbol"}],"return_type":"self","visibility":"Public","body":"{% for name in COLORS %}\n      if color == :{{ name.id }}\n        @back = ColorANSI::{{ name.camelcase.id }}\n        return self\n      end\n    {% end %}\nraise(ArgumentError.new(\"Unknown color: #{color}\"))\n"}},{"html_id":"back(back:Color):self-instance-method","name":"back","abstract":false,"args":[{"name":"back","external_name":"back","restriction":"Color"}],"args_string":"(back : Color) : self","args_html":"(back : <a href=\"../Colorize/Color.html\">Color</a>) : <span class=\"k\">self</span>","location":{"filename":"src/colorize.cr","line_number":335,"url":null},"def":{"name":"back","args":[{"name":"back","external_name":"back","restriction":"Color"}],"return_type":"self","visibility":"Public","body":"@back = back\nself\n"}},{"html_id":"black-instance-method","name":"black","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"black","visibility":"Public","body":"@fore = ColorANSI::Black\nself\n"}},{"html_id":"blink-instance-method","name":"blink","abstract":false,"location":{"filename":"src/colorize.cr","line_number":302,"url":null},"def":{"name":"blink","visibility":"Public","body":"@mode = @mode | MODE_BLINK_FLAG\nself\n"}},{"html_id":"blue-instance-method","name":"blue","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"blue","visibility":"Public","body":"@fore = ColorANSI::Blue\nself\n"}},{"html_id":"bold-instance-method","name":"bold","abstract":false,"location":{"filename":"src/colorize.cr","line_number":302,"url":null},"def":{"name":"bold","visibility":"Public","body":"@mode = @mode | MODE_BOLD_FLAG\nself\n"}},{"html_id":"bright-instance-method","name":"bright","abstract":false,"location":{"filename":"src/colorize.cr","line_number":302,"url":null},"def":{"name":"bright","visibility":"Public","body":"@mode = @mode | MODE_BRIGHT_FLAG\nself\n"}},{"html_id":"cyan-instance-method","name":"cyan","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"cyan","visibility":"Public","body":"@fore = ColorANSI::Cyan\nself\n"}},{"html_id":"dark_gray-instance-method","name":"dark_gray","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"dark_gray","visibility":"Public","body":"@fore = ColorANSI::DarkGray\nself\n"}},{"html_id":"default-instance-method","name":"default","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"default","visibility":"Public","body":"@fore = ColorANSI::Default\nself\n"}},{"html_id":"dim-instance-method","name":"dim","abstract":false,"location":{"filename":"src/colorize.cr","line_number":302,"url":null},"def":{"name":"dim","visibility":"Public","body":"@mode = @mode | MODE_DIM_FLAG\nself\n"}},{"html_id":"fore(color:Symbol):self-instance-method","name":"fore","abstract":false,"args":[{"name":"color","external_name":"color","restriction":"Symbol"}],"args_string":"(color : Symbol) : self","args_html":"(color : <a href=\"../Symbol.html\">Symbol</a>) : <span class=\"k\">self</span>","location":{"filename":"src/colorize.cr","line_number":309,"url":null},"def":{"name":"fore","args":[{"name":"color","external_name":"color","restriction":"Symbol"}],"return_type":"self","visibility":"Public","body":"{% for name in COLORS %}\n      if color == :{{ name.id }}\n        @fore = ColorANSI::{{ name.camelcase.id }}\n        return self\n      end\n    {% end %}\nraise(ArgumentError.new(\"Unknown color: #{color}\"))\n"}},{"html_id":"fore(fore:Color):self-instance-method","name":"fore","abstract":false,"args":[{"name":"fore","external_name":"fore","restriction":"Color"}],"args_string":"(fore : Color) : self","args_html":"(fore : <a href=\"../Colorize/Color.html\">Color</a>) : <span class=\"k\">self</span>","location":{"filename":"src/colorize.cr","line_number":320,"url":null},"def":{"name":"fore","args":[{"name":"fore","external_name":"fore","restriction":"Color"}],"return_type":"self","visibility":"Public","body":"@fore = fore\nself\n"}},{"html_id":"green-instance-method","name":"green","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"green","visibility":"Public","body":"@fore = ColorANSI::Green\nself\n"}},{"html_id":"hidden-instance-method","name":"hidden","abstract":false,"location":{"filename":"src/colorize.cr","line_number":302,"url":null},"def":{"name":"hidden","visibility":"Public","body":"@mode = @mode | MODE_HIDDEN_FLAG\nself\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Inspects this object and makes the ANSI escape codes visible.","summary":"<p>Inspects this object and makes the ANSI escape codes visible.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/colorize.cr","line_number":368,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"surround(io) do\n  @object.inspect(io)\nend"}},{"html_id":"light_blue-instance-method","name":"light_blue","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"light_blue","visibility":"Public","body":"@fore = ColorANSI::LightBlue\nself\n"}},{"html_id":"light_cyan-instance-method","name":"light_cyan","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"light_cyan","visibility":"Public","body":"@fore = ColorANSI::LightCyan\nself\n"}},{"html_id":"light_gray-instance-method","name":"light_gray","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"light_gray","visibility":"Public","body":"@fore = ColorANSI::LightGray\nself\n"}},{"html_id":"light_green-instance-method","name":"light_green","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"light_green","visibility":"Public","body":"@fore = ColorANSI::LightGreen\nself\n"}},{"html_id":"light_magenta-instance-method","name":"light_magenta","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"light_magenta","visibility":"Public","body":"@fore = ColorANSI::LightMagenta\nself\n"}},{"html_id":"light_red-instance-method","name":"light_red","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"light_red","visibility":"Public","body":"@fore = ColorANSI::LightRed\nself\n"}},{"html_id":"light_yellow-instance-method","name":"light_yellow","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"light_yellow","visibility":"Public","body":"@fore = ColorANSI::LightYellow\nself\n"}},{"html_id":"magenta-instance-method","name":"magenta","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"magenta","visibility":"Public","body":"@fore = ColorANSI::Magenta\nself\n"}},{"html_id":"mode(mode:Symbol):self-instance-method","name":"mode","abstract":false,"args":[{"name":"mode","external_name":"mode","restriction":"Symbol"}],"args_string":"(mode : Symbol) : self","args_html":"(mode : <a href=\"../Symbol.html\">Symbol</a>) : <span class=\"k\">self</span>","location":{"filename":"src/colorize.cr","line_number":339,"url":null},"def":{"name":"mode","args":[{"name":"mode","external_name":"mode","restriction":"Symbol"}],"return_type":"self","visibility":"Public","body":"{% for name in MODES %}\n      if mode == :{{ name.id }}\n        @mode |= MODE_{{ name.upcase.id }}_FLAG\n        return self\n      end\n    {% end %}\nraise(ArgumentError.new(\"Unknown mode: #{mode}\"))\n"}},{"html_id":"on(color:Symbol)-instance-method","name":"on","abstract":false,"args":[{"name":"color","external_name":"color","restriction":"Symbol"}],"args_string":"(color : Symbol)","args_html":"(color : <a href=\"../Symbol.html\">Symbol</a>)","location":{"filename":"src/colorize.cr","line_number":350,"url":null},"def":{"name":"on","args":[{"name":"color","external_name":"color","restriction":"Symbol"}],"visibility":"Public","body":"back(color)"}},{"html_id":"on_black-instance-method","name":"on_black","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_black","visibility":"Public","body":"@back = ColorANSI::Black\nself\n"}},{"html_id":"on_blue-instance-method","name":"on_blue","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_blue","visibility":"Public","body":"@back = ColorANSI::Blue\nself\n"}},{"html_id":"on_cyan-instance-method","name":"on_cyan","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_cyan","visibility":"Public","body":"@back = ColorANSI::Cyan\nself\n"}},{"html_id":"on_dark_gray-instance-method","name":"on_dark_gray","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_dark_gray","visibility":"Public","body":"@back = ColorANSI::DarkGray\nself\n"}},{"html_id":"on_default-instance-method","name":"on_default","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_default","visibility":"Public","body":"@back = ColorANSI::Default\nself\n"}},{"html_id":"on_green-instance-method","name":"on_green","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_green","visibility":"Public","body":"@back = ColorANSI::Green\nself\n"}},{"html_id":"on_light_blue-instance-method","name":"on_light_blue","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_light_blue","visibility":"Public","body":"@back = ColorANSI::LightBlue\nself\n"}},{"html_id":"on_light_cyan-instance-method","name":"on_light_cyan","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_light_cyan","visibility":"Public","body":"@back = ColorANSI::LightCyan\nself\n"}},{"html_id":"on_light_gray-instance-method","name":"on_light_gray","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_light_gray","visibility":"Public","body":"@back = ColorANSI::LightGray\nself\n"}},{"html_id":"on_light_green-instance-method","name":"on_light_green","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_light_green","visibility":"Public","body":"@back = ColorANSI::LightGreen\nself\n"}},{"html_id":"on_light_magenta-instance-method","name":"on_light_magenta","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_light_magenta","visibility":"Public","body":"@back = ColorANSI::LightMagenta\nself\n"}},{"html_id":"on_light_red-instance-method","name":"on_light_red","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_light_red","visibility":"Public","body":"@back = ColorANSI::LightRed\nself\n"}},{"html_id":"on_light_yellow-instance-method","name":"on_light_yellow","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_light_yellow","visibility":"Public","body":"@back = ColorANSI::LightYellow\nself\n"}},{"html_id":"on_magenta-instance-method","name":"on_magenta","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_magenta","visibility":"Public","body":"@back = ColorANSI::Magenta\nself\n"}},{"html_id":"on_red-instance-method","name":"on_red","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_red","visibility":"Public","body":"@back = ColorANSI::Red\nself\n"}},{"html_id":"on_white-instance-method","name":"on_white","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_white","visibility":"Public","body":"@back = ColorANSI::White\nself\n"}},{"html_id":"on_yellow-instance-method","name":"on_yellow","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"on_yellow","visibility":"Public","body":"@back = ColorANSI::Yellow\nself\n"}},{"html_id":"red-instance-method","name":"red","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"red","visibility":"Public","body":"@fore = ColorANSI::Red\nself\n"}},{"html_id":"reverse-instance-method","name":"reverse","abstract":false,"location":{"filename":"src/colorize.cr","line_number":302,"url":null},"def":{"name":"reverse","visibility":"Public","body":"@mode = @mode | MODE_REVERSE_FLAG\nself\n"}},{"html_id":"surround(io=STDOUT,&)-instance-method","name":"surround","doc":"Surrounds *io* by the ANSI escape codes and lets you build colored strings:\n\n```\nrequire \"colorize\"\n\nio = IO::Memory.new\n\nwith_color.red.surround(io) do\n  io << \"colorful\"\n  with_color.green.bold.surround(io) do\n    io << \" hello \"\n  end\n  with_color.blue.surround(io) do\n    io << \"world\"\n  end\n  io << \" string\"\nend\n\nio.to_s # returns a colorful string where \"colorful\" is red, \"hello\" green, \"world\" blue and \" string\" red again\n```","summary":"<p>Surrounds <em>io</em> by the ANSI escape codes and lets you build colored strings:</p>","abstract":false,"args":[{"name":"io","default_value":"STDOUT","external_name":"io","restriction":""}],"args_string":"(io = STDOUT, &)","args_html":"(io = <span class=\"t\">STDOUT</span>, &)","location":{"filename":"src/colorize.cr","line_number":394,"url":null},"def":{"name":"surround","args":[{"name":"io","default_value":"STDOUT","external_name":"io","restriction":""}],"yields":1,"visibility":"Public","body":"if @enabled\nelse\n  return yield io\nend\nObject.surround(io, to_named_tuple) do |io|\n  yield io\nend\n"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends this object colored and with text decoration to *io*.","summary":"<p>Appends this object colored and with text decoration to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/colorize.cr","line_number":361,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"surround(io) do\n  io << @object\nend"}},{"html_id":"toggle(flag)-instance-method","name":"toggle","doc":"Enables or disables colors and text decoration on this object.","summary":"<p>Enables or disables colors and text decoration on this object.</p>","abstract":false,"args":[{"name":"flag","external_name":"flag","restriction":""}],"args_string":"(flag)","args_html":"(flag)","location":{"filename":"src/colorize.cr","line_number":355,"url":null},"def":{"name":"toggle","args":[{"name":"flag","external_name":"flag","restriction":""}],"visibility":"Public","body":"@enabled = !(!flag)\nself\n"}},{"html_id":"underline-instance-method","name":"underline","abstract":false,"location":{"filename":"src/colorize.cr","line_number":302,"url":null},"def":{"name":"underline","visibility":"Public","body":"@mode = @mode | MODE_UNDERLINE_FLAG\nself\n"}},{"html_id":"white-instance-method","name":"white","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"white","visibility":"Public","body":"@fore = ColorANSI::White\nself\n"}},{"html_id":"yellow-instance-method","name":"yellow","abstract":false,"location":{"filename":"src/colorize.cr","line_number":290,"url":null},"def":{"name":"yellow","visibility":"Public","body":"@fore = ColorANSI::Yellow\nself\n"}}]},{"html_id":"Crystal/Colorize/ObjectExtensions","path":"Colorize/ObjectExtensions.html","kind":"module","full_name":"Colorize::ObjectExtensions","name":"ObjectExtensions","abstract":false,"locations":[{"filename":"src/colorize.cr","line_number":175,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"including_types":[{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"namespace":{"html_id":"Crystal/Colorize","kind":"module","full_name":"Colorize","name":"Colorize"},"instance_methods":[{"html_id":"colorize(fore)-instance-method","name":"colorize","doc":"Turns `self` into a `Colorize::Object` and colors it with a color.","summary":"<p>Turns <code>self</code> into a <code><a href=\"../Colorize/Object.html\">Colorize::Object</a></code> and colors it with a color.</p>","abstract":false,"args":[{"name":"fore","external_name":"fore","restriction":""}],"args_string":"(fore)","args_html":"(fore)","location":{"filename":"src/colorize.cr","line_number":182,"url":null},"def":{"name":"colorize","args":[{"name":"fore","external_name":"fore","restriction":""}],"visibility":"Public","body":"(Colorize::Object.new(self)).fore(fore)"}},{"html_id":"colorize:Colorize::Object-instance-method","name":"colorize","doc":"Turns `self` into a `Colorize::Object`.","summary":"<p>Turns <code>self</code> into a <code><a href=\"../Colorize/Object.html\">Colorize::Object</a></code>.</p>","abstract":false,"location":{"filename":"src/colorize.cr","line_number":177,"url":null},"def":{"name":"colorize","return_type":"Colorize::Object","visibility":"Public","body":"Colorize::Object.new(self)"}}]}]},{"html_id":"Crystal/Comparable","path":"Comparable.html","kind":"module","full_name":"Comparable(T)","name":"Comparable","abstract":false,"locations":[{"filename":"src/comparable.cr","line_number":21,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"including_types":[{"html_id":"Crystal/Array","kind":"class","full_name":"Array(T)","name":"Array"},{"html_id":"Crystal/BigDecimal","kind":"struct","full_name":"BigDecimal","name":"BigDecimal"},{"html_id":"Crystal/BigFloat","kind":"struct","full_name":"BigFloat","name":"BigFloat"},{"html_id":"Crystal/BigInt","kind":"struct","full_name":"BigInt","name":"BigInt"},{"html_id":"Crystal/BigRational","kind":"struct","full_name":"BigRational","name":"BigRational"},{"html_id":"Crystal/Char","kind":"struct","full_name":"Char","name":"Char"},{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Float","kind":"struct","full_name":"Float","name":"Float"},{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Path","kind":"struct","full_name":"Path","name":"Path"},{"html_id":"Crystal/Pointer","kind":"struct","full_name":"Pointer(T)","name":"Pointer"},{"html_id":"Crystal/SemanticVersion","kind":"struct","full_name":"SemanticVersion","name":"SemanticVersion"},{"html_id":"Crystal/SemanticVersion/Prerelease","kind":"struct","full_name":"SemanticVersion::Prerelease","name":"Prerelease"},{"html_id":"Crystal/Slice","kind":"struct","full_name":"Slice(T)","name":"Slice"},{"html_id":"Crystal/StaticArray","kind":"struct","full_name":"StaticArray(T, N)","name":"StaticArray"},{"html_id":"Crystal/String","kind":"class","full_name":"String","name":"String"},{"html_id":"Crystal/Symbol","kind":"struct","full_name":"Symbol","name":"Symbol"},{"html_id":"Crystal/Time","kind":"struct","full_name":"Time","name":"Time"},{"html_id":"Crystal/Time/Span","kind":"struct","full_name":"Time::Span","name":"Span"},{"html_id":"Crystal/Tuple","kind":"struct","full_name":"Tuple(*T)","name":"Tuple"},{"html_id":"Crystal/UUID","kind":"struct","full_name":"UUID","name":"UUID"}],"doc":"The `Comparable` mixin is used by classes whose objects may be ordered.\n\nIncluding types must provide an `<=>` method, which compares the receiver against\nanother object, returning:\n- a negative number if `self` is less than the other object\n- a positive number if `self` is greater than the other object\n- `0` if `self` is equal to the other object\n- `nil` if `self` and the other object are not comparable\n\n`Comparable` uses `<=>` to implement the conventional comparison operators\n(`<`, `<=`, `==`, `>=`, and `>`). All of these return `false` when `<=>`\nreturns `nil`.\n\nNote that returning `nil` is only useful when defining a partial comparable\nrelationship. One such example is float values: they are generally comparable,\nexcept for `NaN`. If none of the values of a type are comparable between each\nother, `Comparable` shouldn't be included.\n\nNOTE: When `nil` is returned from `<=>`, `Array#sort` and related sorting\nmethods will perform slightly slower.","summary":"<p>The <code><a href=\"Comparable.html\">Comparable</a></code> mixin is used by classes whose objects may be ordered.</p>","instance_methods":[{"html_id":"<(other:T):Bool-instance-method","name":"<","doc":"Compares this object to *other* based on the receiver’s `<=>` method,\nreturning `true` if it returns a negative number.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns a negative number.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"T"}],"args_string":"(other : T) : Bool","args_html":"(other : T) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/comparable.cr","line_number":24,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"T"}],"return_type":"Bool","visibility":"Public","body":"cmp = self <=> other\ncmp ? cmp < 0 : false\n"}},{"html_id":"<=(other:T)-instance-method","name":"<=","doc":"Compares this object to *other* based on the receiver’s `<=>` method,\nreturning `true` if it returns a value equal or less then `0`.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns a value equal or less then <code>0</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"T"}],"args_string":"(other : T)","args_html":"(other : T)","location":{"filename":"src/comparable.cr","line_number":31,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"T"}],"visibility":"Public","body":"cmp = self <=> other\ncmp ? cmp <= 0 : false\n"}},{"html_id":"<=>(other:T)-instance-method","name":"<=>","doc":"The comparison operator. Returns `0` if the two objects are equal,\na negative number if this object is considered less than *other*,\na positive number if this object is considered greater than *other*,\nor `nil` if the two objects are not comparable.\n\nSubclasses define this method to provide class-specific ordering.\n\nThe comparison operator is usually used to sort values:\n\n```\n# Sort in a descending way:\n[3, 1, 2].sort { |x, y| y <=> x } # => [3, 2, 1]\n\n# Sort in an ascending way:\n[3, 1, 2].sort { |x, y| x <=> y } # => [1, 2, 3]\n```","summary":"<p>The comparison operator.</p>","abstract":true,"args":[{"name":"other","external_name":"other","restriction":"T"}],"args_string":"(other : T)","args_html":"(other : T)","location":{"filename":"src/comparable.cr","line_number":83,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"T"}],"visibility":"Public","body":""}},{"html_id":"==(other:T)-instance-method","name":"==","doc":"Compares this object to *other* based on the receiver’s `<=>` method,\nreturning `true` if it returns `0`.\n\nAlso returns `true` if this and *other* are the same object.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns <code>0</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"T"}],"args_string":"(other : T)","args_html":"(other : T)","location":{"filename":"src/comparable.cr","line_number":40,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"T"}],"visibility":"Public","body":"if self.is_a?(Reference)\n  if other.is_a?(Reference) && (self.same?(other))\n    return true\n  end\n  if other.is_a?(Nil) && (self.same?(other))\n    return true\n  end\nend\ncmp = self <=> other\ncmp ? cmp == 0 : false\n"}},{"html_id":">(other:T):Bool-instance-method","name":">","doc":"Compares this object to *other* based on the receiver’s `<=>` method,\nreturning `true` if it returns a value greater then `0`.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns a value greater then <code>0</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"T"}],"args_string":"(other : T) : Bool","args_html":"(other : T) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/comparable.cr","line_number":55,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"T"}],"return_type":"Bool","visibility":"Public","body":"cmp = self <=> other\ncmp ? cmp > 0 : false\n"}},{"html_id":">=(other:T)-instance-method","name":">=","doc":"Compares this object to *other* based on the receiver’s `<=>` method,\nreturning `true` if it returns a value equal or greater than `0`.","summary":"<p>Compares this object to <em>other</em> based on the receiver’s <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">#<=></a></code> method, returning <code>true</code> if it returns a value equal or greater than <code>0</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"T"}],"args_string":"(other : T)","args_html":"(other : T)","location":{"filename":"src/comparable.cr","line_number":62,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"T"}],"visibility":"Public","body":"cmp = self <=> other\ncmp ? cmp >= 0 : false\n"}},{"html_id":"clamp(min,max)-instance-method","name":"clamp","doc":"Clamps a value between *min* and *max*.\n\n```\n5.clamp(10, 100)   # => 10\n50.clamp(10, 100)  # => 50\n500.clamp(10, 100) # => 100\n\n5.clamp(10, nil)  # => 10\n50.clamp(10, nil) # => 50\n\n5.clamp(nil, 10)  # => 5\n50.clamp(nil, 10) # => 10\n```","summary":"<p>Clamps a value between <em>min</em> and <em>max</em>.</p>","abstract":false,"args":[{"name":"min","external_name":"min","restriction":""},{"name":"max","external_name":"max","restriction":""}],"args_string":"(min, max)","args_html":"(min, max)","location":{"filename":"src/comparable.cr","line_number":116,"url":null},"def":{"name":"clamp","args":[{"name":"min","external_name":"min","restriction":""},{"name":"max","external_name":"max","restriction":""}],"visibility":"Public","body":"if (!max.nil?) && self > max\n  return max\nend\nif (!min.nil?) && self < min\n  return min\nend\nself\n"}},{"html_id":"clamp(range:Range)-instance-method","name":"clamp","doc":"Clamps a value within *range*.\n\n```\n5.clamp(10..100)   # => 10\n50.clamp(10..100)  # => 50\n500.clamp(10..100) # => 100\n\n5.clamp(10..)  # => 10\n50.clamp(10..) # => 50\n\n5.clamp(..10)  # => 5\n50.clamp(..10) # => 10\n```","summary":"<p>Clamps a value within <em>range</em>.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range)","args_html":"(range : <a href=\"Range.html\">Range</a>)","location":{"filename":"src/comparable.cr","line_number":98,"url":null},"def":{"name":"clamp","args":[{"name":"range","external_name":"range","restriction":"Range"}],"visibility":"Public","body":"if (!range.end.nil?) && range.exclusive?\n  raise(ArgumentError.new(\"Can't clamp an exclusive range\"))\nend\nclamp(range.begin, range.end)\n"}}]},{"html_id":"Crystal/Complex","path":"Complex.html","kind":"struct","full_name":"Complex","name":"Complex","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/complex.cr","line_number":15,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"A complex number is a number represented in the form a + bi. In this form,\na and b are real numbers, and i is an imaginary number such as i² = -1.\nThe a is the real part of the number, and the b is the imaginary part of\nthe number.\n\n```\nrequire \"complex\"\n\nComplex.new(1, 0)   # => 1.0 + 0.0i\nComplex.new(5, -12) # => 5.0 - 12.0i\n\n1.to_c # => 1.0 + 0.0i\n1.i    # => 0.0 + 1.0i\n```","summary":"<p>A complex number is a number represented in the form a + bi.</p>","constructors":[{"html_id":"additive_identity:self-class-method","name":"additive_identity","abstract":false,"location":{"filename":"src/complex.cr","line_number":258,"url":null},"def":{"name":"additive_identity","return_type":"self","visibility":"Public","body":"zero"}},{"html_id":"new(real:Number,imag:Number=0)-class-method","name":"new","abstract":false,"args":[{"name":"real","external_name":"real","restriction":"Number"},{"name":"imag","default_value":"0","external_name":"imag","restriction":"Number"}],"args_string":"(real : Number, imag : Number = 0)","args_html":"(real : <a href=\"Number.html\">Number</a>, imag : <a href=\"Number.html\">Number</a> = <span class=\"n\">0</span>)","location":{"filename":"src/complex.cr","line_number":22,"url":null},"def":{"name":"new","args":[{"name":"real","external_name":"real","restriction":"Number"},{"name":"imag","default_value":"0","external_name":"imag","restriction":"Number"}],"visibility":"Public","body":"_ = allocate\n_.initialize(real, imag)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(c:Complex)-class-method","name":"new","abstract":false,"args":[{"name":"c","external_name":"c","restriction":"Complex"}],"args_string":"(c : Complex)","args_html":"(c : <a href=\"Complex.html\">Complex</a>)","location":{"filename":"src/complex.cr","line_number":27,"url":null},"def":{"name":"new","args":[{"name":"c","external_name":"c","restriction":"Complex"}],"visibility":"Public","body":"c"}},{"html_id":"zero:Complex-class-method","name":"zero","doc":"Returns the number `0` in complex form.","summary":"<p>Returns the number <code>0</code> in complex form.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":250,"url":null},"def":{"name":"zero","return_type":"Complex","visibility":"Public","body":"new(0, 0)"}}],"instance_methods":[{"html_id":"*(other:Complex):Complex-instance-method","name":"*","doc":"Multiplies `self` by *other*.","summary":"<p>Multiplies <code>self</code> by <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex) : Complex","args_html":"(other : <a href=\"Complex.html\">Complex</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":211,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Complex"}],"return_type":"Complex","visibility":"Public","body":"Complex.new((@real * other.real) - (@imag * other.imag), (@real * other.imag) + (@imag * other.real))"}},{"html_id":"*(other:Number):Complex-instance-method","name":"*","doc":"Multiplies `self` by *other*.","summary":"<p>Multiplies <code>self</code> by <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Number"}],"args_string":"(other : Number) : Complex","args_html":"(other : <a href=\"Number.html\">Number</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":216,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Number"}],"return_type":"Complex","visibility":"Public","body":"Complex.new(@real * other, @imag * other)"}},{"html_id":"+(other:Complex):Complex-instance-method","name":"+","doc":"Adds the value of `self` to *other*.","summary":"<p>Adds the value of <code>self</code> to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex) : Complex","args_html":"(other : <a href=\"Complex.html\">Complex</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":186,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Complex"}],"return_type":"Complex","visibility":"Public","body":"Complex.new(@real + other.real, @imag + other.imag)"}},{"html_id":"+(other:Number):Complex-instance-method","name":"+","doc":"Adds the value of `self` to *other*.","summary":"<p>Adds the value of <code>self</code> to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Number"}],"args_string":"(other : Number) : Complex","args_html":"(other : <a href=\"Number.html\">Number</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":191,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Number"}],"return_type":"Complex","visibility":"Public","body":"Complex.new(@real + other, @imag)"}},{"html_id":"+:Complex-instance-method","name":"+","doc":"Returns `self`.","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":181,"url":null},"def":{"name":"+","return_type":"Complex","visibility":"Public","body":"self"}},{"html_id":"-(other:Complex):Complex-instance-method","name":"-","doc":"Removes the value of *other* from `self`.","summary":"<p>Removes the value of <em>other</em> from <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex) : Complex","args_html":"(other : <a href=\"Complex.html\">Complex</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":201,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Complex"}],"return_type":"Complex","visibility":"Public","body":"Complex.new(@real - other.real, @imag - other.imag)"}},{"html_id":"-(other:Number):Complex-instance-method","name":"-","doc":"Removes the value of *other* from `self`.","summary":"<p>Removes the value of <em>other</em> from <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Number"}],"args_string":"(other : Number) : Complex","args_html":"(other : <a href=\"Number.html\">Number</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":206,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Number"}],"return_type":"Complex","visibility":"Public","body":"Complex.new(@real - other, @imag)"}},{"html_id":"-:Complex-instance-method","name":"-","doc":"Returns the opposite of `self`.","summary":"<p>Returns the opposite of <code>self</code>.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":196,"url":null},"def":{"name":"-","return_type":"Complex","visibility":"Public","body":"Complex.new(-@real, -@imag)"}},{"html_id":"/(other:Complex):Complex-instance-method","name":"/","doc":"Divides `self` by *other*.","summary":"<p>Divides <code>self</code> by <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex) : Complex","args_html":"(other : <a href=\"Complex.html\">Complex</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":221,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Complex"}],"return_type":"Complex","visibility":"Public","body":"if other.real <= other.imag\n  r = other.real / other.imag\n  d = other.imag + (r * other.real)\n  Complex.new(((@real * r) + @imag) / d, ((@imag * r) - @real) / d)\nelse\n  r = other.imag / other.real\n  d = other.real + (r * other.imag)\n  Complex.new((@real + (@imag * r)) / d, (@imag - (@real * r)) / d)\nend"}},{"html_id":"/(other:Number):Complex-instance-method","name":"/","doc":"Divides `self` by *other*.","summary":"<p>Divides <code>self</code> by <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Number"}],"args_string":"(other : Number) : Complex","args_html":"(other : <a href=\"Number.html\">Number</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":234,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Number"}],"return_type":"Complex","visibility":"Public","body":"Complex.new(@real / other, @imag / other)"}},{"html_id":"==(other:Complex)-instance-method","name":"==","doc":"Determines whether `self` equals *other* or not.","summary":"<p>Determines whether <code>self</code> equals <em>other</em> or not.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex)","args_html":"(other : <a href=\"Complex.html\">Complex</a>)","location":{"filename":"src/complex.cr","line_number":32,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Complex"}],"visibility":"Public","body":"(@real == other.real) && (@imag == other.imag)"}},{"html_id":"==(other:Number)-instance-method","name":"==","doc":"Determines whether `self` equals *other* or not.","summary":"<p>Determines whether <code>self</code> equals <em>other</em> or not.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Number"}],"args_string":"(other : Number)","args_html":"(other : <a href=\"Number.html\">Number</a>)","location":{"filename":"src/complex.cr","line_number":37,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Number"}],"visibility":"Public","body":"self == other.to_c"}},{"html_id":"==(other)-instance-method","name":"==","doc":"Determines whether `self` equals *other* or not.","summary":"<p>Determines whether <code>self</code> equals <em>other</em> or not.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/complex.cr","line_number":42,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"false"}},{"html_id":"abs:Float64-instance-method","name":"abs","doc":"Returns the absolute value of this complex number in a\nnumber form, using the Pythagorean theorem.\n\n```\nrequire \"complex\"\n\nComplex.new(42, 2).abs  # => 42.04759208325728\nComplex.new(-42, 2).abs # => 42.04759208325728\n```","summary":"<p>Returns the absolute value of this complex number in a number form, using the Pythagorean theorem.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":128,"url":null},"def":{"name":"abs","return_type":"Float64","visibility":"Public","body":"Math.hypot(@real, @imag)"}},{"html_id":"abs2:Float64-instance-method","name":"abs2","doc":"Returns the square of absolute value in a number form.\n\n```\nrequire \"complex\"\n\nComplex.new(42, 2).abs2 # => 1768\n```","summary":"<p>Returns the square of absolute value in a number form.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":139,"url":null},"def":{"name":"abs2","return_type":"Float64","visibility":"Public","body":"(@real * @real) + (@imag * @imag)"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/complex.cr","line_number":238,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"conj:Complex-instance-method","name":"conj","doc":"Returns the conjugate of `self`.\n\n```\nrequire \"complex\"\n\nComplex.new(42, 2).conj  # => 42.0 - 2.0i\nComplex.new(42, -2).conj # => 42.0 + 2.0i\n```","summary":"<p>Returns the conjugate of <code>self</code>.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":171,"url":null},"def":{"name":"conj","return_type":"Complex","visibility":"Public","body":"Complex.new(@real, -@imag)"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/complex.cr","line_number":243,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = real.hash(hasher)\nif imag.zero?\nelse\n  hasher = imag.hash(hasher)\nend\nhasher\n"}},{"html_id":"imag:Float64-instance-method","name":"imag","doc":"Returns the imaginary part.","summary":"<p>Returns the imaginary part.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":20,"url":null},"def":{"name":"imag","return_type":"Float64","visibility":"Public","body":"@imag"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Writes this complex object to an *io*, surrounded by parentheses.\n\n```\nrequire \"complex\"\n\nComplex.new(42, 2).inspect # => \"(42.0 + 2.0i)\"\n```","summary":"<p>Writes this complex object to an <em>io</em>, surrounded by parentheses.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/complex.cr","line_number":113,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << '('\nto_s(io)\nio << ')'\n"}},{"html_id":"inv:Complex-instance-method","name":"inv","doc":"Returns the inverse of `self`.","summary":"<p>Returns the inverse of <code>self</code>.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":176,"url":null},"def":{"name":"inv","return_type":"Complex","visibility":"Public","body":"conj / abs2"}},{"html_id":"multiplicative_identity:self-instance-method","name":"multiplicative_identity","abstract":false,"location":{"filename":"src/complex.cr","line_number":262,"url":null},"def":{"name":"multiplicative_identity","return_type":"self","visibility":"Public","body":"new(1, 0)"}},{"html_id":"phase:Float64-instance-method","name":"phase","doc":"Returns the phase of `self`.","summary":"<p>Returns the phase of <code>self</code>.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":148,"url":null},"def":{"name":"phase","return_type":"Float64","visibility":"Public","body":"Math.atan2(@imag, @real)"}},{"html_id":"polar:Tuple(Float64,Float64)-instance-method","name":"polar","doc":"Returns a `Tuple` with the `abs` value and the `phase`.\n\n```\nrequire \"complex\"\n\nComplex.new(42, 2).polar # => {42.047592083257278, 0.047583103276983396}\n```","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> with the <code><a href=\"Complex.html#abs%3AFloat64-instance-method\">#abs</a></code> value and the <code><a href=\"Complex.html#phase%3AFloat64-instance-method\">#phase</a></code>.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":159,"url":null},"def":{"name":"polar","return_type":"::Tuple(Float64, Float64)","visibility":"Public","body":"{abs, phase}"}},{"html_id":"real:Float64-instance-method","name":"real","doc":"Returns the real part.","summary":"<p>Returns the real part.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":17,"url":null},"def":{"name":"real","return_type":"Float64","visibility":"Public","body":"@real"}},{"html_id":"round(digits=0):Complex-instance-method","name":"round","doc":"Rounds to the nearest *digits*.","summary":"<p>Rounds to the nearest <em>digits</em>.</p>","abstract":false,"args":[{"name":"digits","default_value":"0","external_name":"digits","restriction":""}],"args_string":"(digits = 0) : Complex","args_html":"(digits = <span class=\"n\">0</span>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":267,"url":null},"def":{"name":"round","args":[{"name":"digits","default_value":"0","external_name":"digits","restriction":""}],"return_type":"Complex","visibility":"Public","body":"Complex.new(@real.round(digits), @imag.round(digits))"}},{"html_id":"sign:Complex-instance-method","name":"sign","abstract":false,"location":{"filename":"src/complex.cr","line_number":143,"url":null},"def":{"name":"sign","return_type":"Complex","visibility":"Public","body":"self / abs"}},{"html_id":"to_c-instance-method","name":"to_c","doc":"Returns `self`.","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":47,"url":null},"def":{"name":"to_c","visibility":"Public","body":"self"}},{"html_id":"to_f-instance-method","name":"to_f","doc":"See `#to_f64`.","summary":"<p>See <code><a href=\"Complex.html#to_f64%3AFloat64-instance-method\">#to_f64</a></code>.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":67,"url":null},"def":{"name":"to_f","visibility":"Public","body":"to_f64"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns the value as a `Float32` if possible (the imaginary part should be exactly zero),\nraises otherwise.","summary":"<p>Returns the value as a <code><a href=\"Float32.html\">Float32</a></code> if possible (the imaginary part should be exactly zero), raises otherwise.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":62,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"to_f64.to_f32"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns the value as a `Float64` if possible (the imaginary part should be exactly zero),\nraises otherwise.","summary":"<p>Returns the value as a <code><a href=\"Float64.html\">Float64</a></code> if possible (the imaginary part should be exactly zero), raises otherwise.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":53,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"if @imag.zero?\nelse\n  raise(Exception.new(\"Complex number with non-zero imaginary part can't be converted to real number\"))\nend\n@real\n"}},{"html_id":"to_i-instance-method","name":"to_i","doc":"See `#to_i32`.","summary":"<p>See <code><a href=\"Complex.html#to_i32%28%2Aargs%2C%2A%2Aoptions%29-instance-method\">#to_i32</a></code>.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":88,"url":null},"def":{"name":"to_i","visibility":"Public","body":"to_i32"}},{"html_id":"to_i16(*args,**options)-instance-method","name":"to_i16","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/complex.cr","line_number":77,"url":null},"def":{"name":"to_i16","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"to_i64.to_i16(*args, **options)"}},{"html_id":"to_i16(*args,**options,&)-instance-method","name":"to_i16","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/complex.cr","line_number":77,"url":null},"def":{"name":"to_i16","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"to_i64.to_i16(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"to_i32(*args,**options)-instance-method","name":"to_i32","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/complex.cr","line_number":77,"url":null},"def":{"name":"to_i32","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"to_i64.to_i32(*args, **options)"}},{"html_id":"to_i32(*args,**options,&)-instance-method","name":"to_i32","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/complex.cr","line_number":77,"url":null},"def":{"name":"to_i32","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"to_i64.to_i32(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns the value as an `Int64` if possible (the imaginary part should be exactly zero),\nraises otherwise.","summary":"<p>Returns the value as an <code><a href=\"Int64.html\">Int64</a></code> if possible (the imaginary part should be exactly zero), raises otherwise.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":73,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"to_f64.to_i64"}},{"html_id":"to_i8(*args,**options)-instance-method","name":"to_i8","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/complex.cr","line_number":77,"url":null},"def":{"name":"to_i8","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"to_i64.to_i8(*args, **options)"}},{"html_id":"to_i8(*args,**options,&)-instance-method","name":"to_i8","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/complex.cr","line_number":77,"url":null},"def":{"name":"to_i8","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"to_i64.to_i8(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Writes this complex object to an *io*.\n\n```\nrequire \"complex\"\n\nComplex.new(42, 2).to_s # => \"42.0 + 2.0i\"\n```","summary":"<p>Writes this complex object to an <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/complex.cr","line_number":99,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << @real\nio << (@imag >= 0 ? \" + \" : \" - \")\nio << @imag.abs\nio << 'i'\n"}},{"html_id":"to_u16(*args,**options)-instance-method","name":"to_u16","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/complex.cr","line_number":85,"url":null},"def":{"name":"to_u16","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"to_u64.to_u16(*args, **options)"}},{"html_id":"to_u16(*args,**options,&)-instance-method","name":"to_u16","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/complex.cr","line_number":85,"url":null},"def":{"name":"to_u16","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"to_u64.to_u16(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"to_u32(*args,**options)-instance-method","name":"to_u32","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/complex.cr","line_number":85,"url":null},"def":{"name":"to_u32","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"to_u64.to_u32(*args, **options)"}},{"html_id":"to_u32(*args,**options,&)-instance-method","name":"to_u32","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/complex.cr","line_number":85,"url":null},"def":{"name":"to_u32","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"to_u64.to_u32(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns the value as an `UInt64` if possible (the imaginary part should be exactly zero),\nraises otherwise.","summary":"<p>Returns the value as an <code><a href=\"UInt64.html\">UInt64</a></code> if possible (the imaginary part should be exactly zero), raises otherwise.</p>","abstract":false,"location":{"filename":"src/complex.cr","line_number":81,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"to_f64.to_u64"}},{"html_id":"to_u8(*args,**options)-instance-method","name":"to_u8","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/complex.cr","line_number":85,"url":null},"def":{"name":"to_u8","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"to_u64.to_u8(*args, **options)"}},{"html_id":"to_u8(*args,**options,&)-instance-method","name":"to_u8","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/complex.cr","line_number":85,"url":null},"def":{"name":"to_u8","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"to_u64.to_u8(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"zero?:Bool-instance-method","name":"zero?","abstract":false,"location":{"filename":"src/complex.cr","line_number":254,"url":null},"def":{"name":"zero?","return_type":"Bool","visibility":"Public","body":"(@real == 0) && (@imag == 0)"}}]},{"html_id":"Crystal/Compress","path":"Compress.html","kind":"module","full_name":"Compress","name":"Compress","abstract":false,"locations":[{"filename":"src/compress/deflate/reader.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"types":[{"html_id":"Crystal/Compress/Deflate","path":"Compress/Deflate.html","kind":"module","full_name":"Compress::Deflate","name":"Deflate","abstract":false,"locations":[{"filename":"src/compress/deflate/deflate.cr","line_number":9,"url":null},{"filename":"src/compress/deflate/reader.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"BEST_COMPRESSION","name":"BEST_COMPRESSION","value":"9"},{"id":"BEST_SPEED","name":"BEST_SPEED","value":"1"},{"id":"DEFAULT_COMPRESSION","name":"DEFAULT_COMPRESSION","value":"-1"},{"id":"NO_COMPRESSION","name":"NO_COMPRESSION","value":"0"}],"namespace":{"html_id":"Crystal/Compress","kind":"module","full_name":"Compress","name":"Compress"},"doc":"The Deflate module contains readers and writers of DEFLATE format compressed\ndata, as specified in [RFC 1951](https://www.ietf.org/rfc/rfc1951.txt).\n\nSee `Gzip`, `Zip` and `Zlib` for modules that provide access\nto DEFLATE-based file formats.","summary":"<p>The Deflate module contains readers and writers of DEFLATE format compressed data, as specified in <a href=\"https://www.ietf.org/rfc/rfc1951.txt\">RFC 1951</a>.</p>","types":[{"html_id":"Crystal/Compress/Deflate/Error","path":"Compress/Deflate/Error.html","kind":"class","full_name":"Compress::Deflate::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/deflate/deflate.cr","line_number":23,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Compress/Deflate","kind":"module","full_name":"Compress::Deflate","name":"Deflate"},"constructors":[{"html_id":"new(ret,stream)-class-method","name":"new","abstract":false,"args":[{"name":"ret","external_name":"ret","restriction":""},{"name":"stream","external_name":"stream","restriction":""}],"args_string":"(ret, stream)","args_html":"(ret, stream)","location":{"filename":"src/compress/deflate/deflate.cr","line_number":24,"url":null},"def":{"name":"new","args":[{"name":"ret","external_name":"ret","restriction":""},{"name":"stream","external_name":"stream","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(ret, stream)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]},{"html_id":"Crystal/Compress/Deflate/Reader","path":"Compress/Deflate/Reader.html","kind":"class","full_name":"Compress::Deflate::Reader","name":"Reader","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/deflate/reader.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"}],"namespace":{"html_id":"Crystal/Compress/Deflate","kind":"module","full_name":"Compress::Deflate","name":"Deflate"},"doc":"A read-only `IO` object to decompress data in the DEFLATE format.\n\nInstances of this class wrap another IO object. When you read from this instance\ninstance, it reads data from the underlying IO, decompresses it, and returns\nit to the caller.","summary":"<p>A read-only <code><a href=\"../../IO.html\">IO</a></code> object to decompress data in the DEFLATE format.</p>","class_methods":[{"html_id":"gzip(input,sync_close:Bool=false,&)-class-method","name":"gzip","doc":"Creates an instance of Flate::Reader for the gzip format, yields it to the given block, and closes\nit at its end.","summary":"<p>Creates an instance of Flate::Reader for the gzip format, yields it to the given block, and closes it at its end.</p>","abstract":false,"args":[{"name":"input","external_name":"input","restriction":""},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"}],"args_string":"(input, sync_close : Bool = false, &)","args_html":"(input, sync_close : <a href=\"../../Bool.html\">Bool</a> = <span class=\"n\">false</span>, &)","location":{"filename":"src/compress/deflate/reader.cr","line_number":49,"url":null},"def":{"name":"gzip","args":[{"name":"input","external_name":"input","restriction":""},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"}],"yields":1,"visibility":"Public","body":"reader = gzip(input, sync_close: sync_close)\nbegin\n  yield reader\nensure\n  reader.close\nend\n"}},{"html_id":"open(io:IO,sync_close:Bool=false,dict:Bytes?=nil,&)-class-method","name":"open","doc":"Creates a new reader from the given *io*, yields it to the given block,\nand closes it at its end.","summary":"<p>Creates a new reader from the given <em>io</em>, yields it to the given block, and closes it at its end.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(io : IO, sync_close : Bool = false, dict : Bytes? = nil, &)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, sync_close : <a href=\"../../Bool.html\">Bool</a> = <span class=\"n\">false</span>, dict : <a href=\"../../Bytes.html\">Bytes</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/compress/deflate/reader.cr","line_number":36,"url":null},"def":{"name":"open","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"yields":1,"visibility":"Public","body":"reader = new(io, sync_close: sync_close, dict: dict)\nbegin\n  yield reader\nensure\n  reader.close\nend\n"}}],"constructors":[{"html_id":"gzip(input,sync_close:Bool=false):self-class-method","name":"gzip","doc":"Creates an instance of Flate::Reader for the gzip format.\nhas written.","summary":"<p>Creates an instance of Flate::Reader for the gzip format.</p>","abstract":false,"args":[{"name":"input","external_name":"input","restriction":""},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"}],"args_string":"(input, sync_close : Bool = false) : self","args_html":"(input, sync_close : <a href=\"../../Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <span class=\"k\">self</span>","location":{"filename":"src/compress/deflate/reader.cr","line_number":43,"url":null},"def":{"name":"gzip","args":[{"name":"input","external_name":"input","restriction":""},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"}],"return_type":"self","visibility":"Public","body":"new(input, wbits: GZIP, sync_close: sync_close)"}},{"html_id":"new(io:IO,sync_close:Bool=false,dict:Bytes?=nil)-class-method","name":"new","doc":"Creates an instance of Flate::Reader.","summary":"<p>Creates an instance of Flate::Reader.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(io : IO, sync_close : Bool = false, dict : Bytes? = nil)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, sync_close : <a href=\"../../Bool.html\">Bool</a> = <span class=\"n\">false</span>, dict : <a href=\"../../Bytes.html\">Bytes</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/compress/deflate/reader.cr","line_number":22,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, sync_close, dict)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this reader is closed.","summary":"<p>Returns <code>true</code> if this reader is closed.</p>","abstract":false,"location":{"filename":"src/compress/deflate/reader.cr","line_number":13,"url":null},"def":{"name":"closed?","visibility":"Public","body":"@closed"}},{"html_id":"dict:Bytes?-instance-method","name":"dict","doc":"Dictionary passed in the constructor","summary":"<p>Dictionary passed in the constructor</p>","abstract":false,"location":{"filename":"src/compress/deflate/reader.cr","line_number":16,"url":null},"def":{"name":"dict","return_type":"Bytes | ::Nil","visibility":"Public","body":"@dict"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../../IO.html\">IO</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/compress/deflate/reader.cr","line_number":151,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"sync_close=(sync_close:Bool)-instance-method","name":"sync_close=","doc":"If `#sync_close?` is `true`, closing this IO will close the underlying IO.","summary":"<p>If <code><a href=\"../../Compress/Deflate/Reader.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this IO will close the underlying IO.</p>","abstract":false,"args":[{"name":"sync_close","external_name":"sync_close","restriction":"Bool"}],"args_string":"(sync_close : Bool)","args_html":"(sync_close : <a href=\"../../Bool.html\">Bool</a>)","location":{"filename":"src/compress/deflate/reader.cr","line_number":10,"url":null},"def":{"name":"sync_close=","args":[{"name":"sync_close","external_name":"sync_close","restriction":"Bool"}],"visibility":"Public","body":"@sync_close = sync_close"}},{"html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"If `#sync_close?` is `true`, closing this IO will close the underlying IO.","summary":"<p>If <code><a href=\"../../Compress/Deflate/Reader.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this IO will close the underlying IO.</p>","abstract":false,"location":{"filename":"src/compress/deflate/reader.cr","line_number":10,"url":null},"def":{"name":"sync_close?","return_type":"Bool","visibility":"Public","body":"@sync_close"}},{"html_id":"unbuffered_close:Nil-instance-method","name":"unbuffered_close","doc":"Closes this reader.","summary":"<p>Closes this reader.</p>","abstract":false,"location":{"filename":"src/compress/deflate/reader.cr","line_number":133,"url":null},"def":{"name":"unbuffered_close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nret = LibZ.inflateEnd(pointerof(@stream))\nif ret.ok?\nelse\n  raise(Compress::Deflate::Error.new(ret, @stream))\nend\nif @sync_close\n  @io.close\nend\n"}},{"html_id":"unbuffered_flush:NoReturn-instance-method","name":"unbuffered_flush","doc":"Flushes the wrapped `IO`.","summary":"<p>Flushes the wrapped <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/compress/deflate/reader.cr","line_number":128,"url":null},"def":{"name":"unbuffered_flush","return_type":"NoReturn","visibility":"Public","body":"raise(IO::Error.new(\"Can't flush Compress::Deflate::Reader\"))"}},{"html_id":"unbuffered_read(slice:Bytes):Int32-instance-method","name":"unbuffered_read","doc":"See `IO#read`.","summary":"<p>See <code><a href=\"../../IO.html#read%28slice%3ABytes%29-instance-method\">IO#read</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Int32","args_html":"(slice : <a href=\"../../Bytes.html\">Bytes</a>) : <a href=\"../../Int32.html\">Int32</a>","location":{"filename":"src/compress/deflate/reader.cr","line_number":60,"url":null},"def":{"name":"unbuffered_read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Int32","visibility":"Public","body":"check_open\nif slice.empty?\n  return 0\nend\nif @end\n  return 0\nend\nwhile true\n  if @stream.avail_in == 0\n    @peek = @io.peek\n    if peek = @peek\n      @stream.next_in = peek\n      @stream.avail_in = peek.size\n    else\n      @stream.next_in = @buf.to_unsafe\n      @stream.avail_in = (@io.read(@buf.to_slice)).to_u32\n    end\n  end\n  old_avail_in = @stream.avail_in\n  @stream.avail_out = slice.size.to_u32\n  @stream.next_out = slice.to_unsafe\n  ret = LibZ.inflate(pointerof(@stream), LibZ::Flush::NO_FLUSH)\n  read_bytes = slice.size - @stream.avail_out\n  avail_in_diff = old_avail_in - @stream.avail_in\n  if @peek && avail_in_diff > 0\n    @io.skip(avail_in_diff)\n  end\n  case ret\n  when .need_dict?\n    if dict = @dict\n      ret = LibZ.inflateSetDictionary(pointerof(@stream), dict, dict.size)\n      if ret.ok?\n        next\n      end\n    end\n    raise(Compress::Deflate::Error.new(ret, @stream))\n  when .errno?, .data_error?, .mem_error?, .buf_error?, .version_error?\n    raise(Compress::Deflate::Error.new(ret, @stream))\n  when .stream_end?\n    @end = true\n    return read_bytes\n  else\n    if read_bytes == 0\n      next\n    else\n      return read_bytes\n    end\n  end\nend\n"}},{"html_id":"unbuffered_rewind:Nil-instance-method","name":"unbuffered_rewind","doc":"Rewinds the wrapped `IO`.","summary":"<p>Rewinds the wrapped <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/compress/deflate/reader.cr","line_number":143,"url":null},"def":{"name":"unbuffered_rewind","return_type":"Nil","visibility":"Public","body":"check_open\n@io.rewind\ninitialize(@io, @sync_close, @dict)\n"}},{"html_id":"unbuffered_write(slice:Bytes):NoReturn-instance-method","name":"unbuffered_write","doc":"Always raises `IO::Error` because this is a read-only `IO`.","summary":"<p>Always raises <code><a href=\"../../IO/Error.html\">IO::Error</a></code> because this is a read-only <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : NoReturn","args_html":"(slice : <a href=\"../../Bytes.html\">Bytes</a>) : NoReturn","location":{"filename":"src/compress/deflate/reader.cr","line_number":55,"url":null},"def":{"name":"unbuffered_write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"NoReturn","visibility":"Public","body":"raise(IO::Error.new(\"Can't write to Compress::Deflate::Reader\"))"}}]},{"html_id":"Crystal/Compress/Deflate/Strategy","path":"Compress/Deflate/Strategy.html","kind":"enum","full_name":"Compress::Deflate::Strategy","name":"Strategy","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/deflate/deflate.cr","line_number":15,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"FILTERED","name":"FILTERED","value":"1"},{"id":"HUFFMAN_ONLY","name":"HUFFMAN_ONLY","value":"2"},{"id":"RLE","name":"RLE","value":"3"},{"id":"FIXED","name":"FIXED","value":"4"},{"id":"DEFAULT","name":"DEFAULT","value":"0"}],"namespace":{"html_id":"Crystal/Compress/Deflate","kind":"module","full_name":"Compress::Deflate","name":"Deflate"},"instance_methods":[{"html_id":"default?-instance-method","name":"default?","abstract":false,"location":{"filename":"src/compress/deflate/deflate.cr","line_number":20,"url":null},"def":{"name":"default?","visibility":"Public","body":"self == DEFAULT"}},{"html_id":"filtered?-instance-method","name":"filtered?","abstract":false,"location":{"filename":"src/compress/deflate/deflate.cr","line_number":16,"url":null},"def":{"name":"filtered?","visibility":"Public","body":"self == FILTERED"}},{"html_id":"fixed?-instance-method","name":"fixed?","abstract":false,"location":{"filename":"src/compress/deflate/deflate.cr","line_number":19,"url":null},"def":{"name":"fixed?","visibility":"Public","body":"self == FIXED"}},{"html_id":"huffman_only?-instance-method","name":"huffman_only?","abstract":false,"location":{"filename":"src/compress/deflate/deflate.cr","line_number":17,"url":null},"def":{"name":"huffman_only?","visibility":"Public","body":"self == HUFFMAN_ONLY"}},{"html_id":"rle?-instance-method","name":"rle?","abstract":false,"location":{"filename":"src/compress/deflate/deflate.cr","line_number":18,"url":null},"def":{"name":"rle?","visibility":"Public","body":"self == RLE"}}]},{"html_id":"Crystal/Compress/Deflate/Writer","path":"Compress/Deflate/Writer.html","kind":"class","full_name":"Compress::Deflate::Writer","name":"Writer","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/deflate/writer.cr","line_number":8,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Compress/Deflate","kind":"module","full_name":"Compress::Deflate","name":"Deflate"},"doc":"A write-only `IO` object to compress data in the DEFLATE format.\n\nInstances of this class wrap another IO object. When you write to this\ninstance, it compresses the data and writes it to the underlying IO.\n\nNOTE: unless created with a block, `close` must be invoked after all\ndata has been written to a Flate::Writer instance.","summary":"<p>A write-only <code><a href=\"../../IO.html\">IO</a></code> object to compress data in the DEFLATE format.</p>","class_methods":[{"html_id":"open(io:IO,level:Int32=Compress::Deflate::DEFAULT_COMPRESSION,strategy:Compress::Deflate::Strategy=Compress::Deflate::Strategy::DEFAULT,sync_close:Bool=false,dict:Bytes?=nil,&)-class-method","name":"open","doc":"Creates a new writer for the given *io*, yields it to the given block,\nand closes it at its end.","summary":"<p>Creates a new writer for the given <em>io</em>, yields it to the given block, and closes it at its end.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"level","default_value":"Compress::Deflate::DEFAULT_COMPRESSION","external_name":"level","restriction":"Int32"},{"name":"strategy","default_value":"Compress::Deflate::Strategy::DEFAULT","external_name":"strategy","restriction":"Compress::Deflate::Strategy"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(io : IO, level : Int32 = Compress::Deflate::DEFAULT_COMPRESSION, strategy : Compress::Deflate::Strategy = Compress::Deflate::Strategy::DEFAULT, sync_close : Bool = false, dict : Bytes? = nil, &)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, level : <a href=\"../../Int32.html\">Int32</a> = <span class=\"t\">Compress</span><span class=\"t\">::</span><span class=\"t\">Deflate</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, strategy : <a href=\"../../Compress/Deflate/Strategy.html\">Compress::Deflate::Strategy</a> = <span class=\"t\">Compress</span><span class=\"t\">::</span><span class=\"t\">Deflate</span><span class=\"t\">::</span><span class=\"t\">Strategy</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>, sync_close : <a href=\"../../Bool.html\">Bool</a> = <span class=\"n\">false</span>, dict : <a href=\"../../Bytes.html\">Bytes</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/compress/deflate/writer.cr","line_number":33,"url":null},"def":{"name":"open","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"level","default_value":"Compress::Deflate::DEFAULT_COMPRESSION","external_name":"level","restriction":"Int32"},{"name":"strategy","default_value":"Compress::Deflate::Strategy::DEFAULT","external_name":"strategy","restriction":"Compress::Deflate::Strategy"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"yields":1,"visibility":"Public","body":"writer = new(io, level: level, strategy: strategy, sync_close: sync_close, dict: dict)\nbegin\n  yield writer\nensure\n  writer.close\nend\n"}}],"constructors":[{"html_id":"new(output:IO,level:Int32=Compress::Deflate::DEFAULT_COMPRESSION,strategy:Compress::Deflate::Strategy=Compress::Deflate::Strategy::DEFAULT,sync_close:Bool=false,dict:Bytes?=nil)-class-method","name":"new","doc":"Creates an instance of Flate::Writer. `close` must be invoked after all data\nhas written.","summary":"<p>Creates an instance of Flate::Writer.</p>","abstract":false,"args":[{"name":"output","external_name":"output","restriction":"IO"},{"name":"level","default_value":"Compress::Deflate::DEFAULT_COMPRESSION","external_name":"level","restriction":"Int32"},{"name":"strategy","default_value":"Compress::Deflate::Strategy::DEFAULT","external_name":"strategy","restriction":"Compress::Deflate::Strategy"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(output : IO, level : Int32 = Compress::Deflate::DEFAULT_COMPRESSION, strategy : Compress::Deflate::Strategy = Compress::Deflate::Strategy::DEFAULT, sync_close : Bool = false, dict : Bytes? = nil)","args_html":"(output : <a href=\"../../IO.html\">IO</a>, level : <a href=\"../../Int32.html\">Int32</a> = <span class=\"t\">Compress</span><span class=\"t\">::</span><span class=\"t\">Deflate</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, strategy : <a href=\"../../Compress/Deflate/Strategy.html\">Compress::Deflate::Strategy</a> = <span class=\"t\">Compress</span><span class=\"t\">::</span><span class=\"t\">Deflate</span><span class=\"t\">::</span><span class=\"t\">Strategy</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>, sync_close : <a href=\"../../Bool.html\">Bool</a> = <span class=\"n\">false</span>, dict : <a href=\"../../Bytes.html\">Bytes</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/compress/deflate/writer.cr","line_number":14,"url":null},"def":{"name":"new","args":[{"name":"output","external_name":"output","restriction":"IO"},{"name":"level","default_value":"Compress::Deflate::DEFAULT_COMPRESSION","external_name":"level","restriction":"Int32"},{"name":"strategy","default_value":"Compress::Deflate::Strategy::DEFAULT","external_name":"strategy","restriction":"Compress::Deflate::Strategy"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(output, level, strategy, sync_close, dict)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes this writer. Must be invoked after all data has been written.","summary":"<p>Closes this writer.</p>","abstract":false,"location":{"filename":"src/compress/deflate/writer.cr","line_number":65,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\n@stream.avail_in = 0\n@stream.next_in = Pointer(UInt8).null\nconsume_output(LibZ::Flush::FINISH)\nret = LibZ.deflateEnd(pointerof(@stream))\nif ret.ok?\nelse\n  raise(Compress::Deflate::Error.new(ret, @stream))\nend\nif @sync_close\n  @output.close\nend\n"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this IO is closed.","summary":"<p>Returns <code>true</code> if this IO is closed.</p>","abstract":false,"location":{"filename":"src/compress/deflate/writer.cr","line_number":80,"url":null},"def":{"name":"closed?","return_type":"Bool","visibility":"Public","body":"@closed"}},{"html_id":"flush:Nil-instance-method","name":"flush","doc":"See `IO#flush`.","summary":"<p>See <code><a href=\"../../IO.html#flush-instance-method\">IO#flush</a></code>.</p>","abstract":false,"location":{"filename":"src/compress/deflate/writer.cr","line_number":57,"url":null},"def":{"name":"flush","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\nconsume_output(LibZ::Flush::SYNC_FLUSH)\n@output.flush\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../../IO.html\">IO</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/compress/deflate/writer.cr","line_number":84,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"read(slice:Bytes):NoReturn-instance-method","name":"read","doc":"Always raises `IO::Error` because this is a write-only `IO`.","summary":"<p>Always raises <code><a href=\"../../IO/Error.html\">IO::Error</a></code> because this is a write-only <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : NoReturn","args_html":"(slice : <a href=\"../../Bytes.html\">Bytes</a>) : NoReturn","location":{"filename":"src/compress/deflate/writer.cr","line_number":41,"url":null},"def":{"name":"read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"NoReturn","visibility":"Public","body":"raise(\"Can't read from Flate::Writer\")"}},{"html_id":"sync_close=(sync_close:Bool)-instance-method","name":"sync_close=","doc":"If `#sync_close?` is `true`, closing this IO will close the underlying IO.","summary":"<p>If <code><a href=\"../../Compress/Deflate/Writer.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this IO will close the underlying IO.</p>","abstract":false,"args":[{"name":"sync_close","external_name":"sync_close","restriction":"Bool"}],"args_string":"(sync_close : Bool)","args_html":"(sync_close : <a href=\"../../Bool.html\">Bool</a>)","location":{"filename":"src/compress/deflate/writer.cr","line_number":10,"url":null},"def":{"name":"sync_close=","args":[{"name":"sync_close","external_name":"sync_close","restriction":"Bool"}],"visibility":"Public","body":"@sync_close = sync_close"}},{"html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"If `#sync_close?` is `true`, closing this IO will close the underlying IO.","summary":"<p>If <code><a href=\"../../Compress/Deflate/Writer.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this IO will close the underlying IO.</p>","abstract":false,"location":{"filename":"src/compress/deflate/writer.cr","line_number":10,"url":null},"def":{"name":"sync_close?","return_type":"Bool","visibility":"Public","body":"@sync_close"}},{"html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"See `IO#write`.","summary":"<p>See <code><a href=\"../../IO.html#write%28slice%3ABytes%29%3ANil-instance-method\">IO#write</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"../../Bytes.html\">Bytes</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/compress/deflate/writer.cr","line_number":46,"url":null},"def":{"name":"write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"check_open\nif slice.empty?\n  return\nend\n@stream.avail_in = slice.size\n@stream.next_in = slice\nconsume_output(LibZ::Flush::NO_FLUSH)\n"}}]}]},{"html_id":"Crystal/Compress/Gzip","path":"Compress/Gzip.html","kind":"module","full_name":"Compress::Gzip","name":"Gzip","abstract":false,"locations":[{"filename":"src/compress/gzip/gzip.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"BEST_COMPRESSION","name":"BEST_COMPRESSION","value":"Compress::Deflate::BEST_COMPRESSION"},{"id":"BEST_SPEED","name":"BEST_SPEED","value":"Compress::Deflate::BEST_SPEED"},{"id":"DEFAULT_COMPRESSION","name":"DEFAULT_COMPRESSION","value":"Compress::Deflate::DEFAULT_COMPRESSION"},{"id":"NO_COMPRESSION","name":"NO_COMPRESSION","value":"Compress::Deflate::NO_COMPRESSION"}],"namespace":{"html_id":"Crystal/Compress","kind":"module","full_name":"Compress","name":"Compress"},"doc":"The Gzip module contains readers and writers of gzip format compressed\ndata, as specified in [RFC 1952](https://www.ietf.org/rfc/rfc1952.txt).","summary":"<p>The Gzip module contains readers and writers of gzip format compressed data, as specified in <a href=\"https://www.ietf.org/rfc/rfc1952.txt\">RFC 1952</a>.</p>","types":[{"html_id":"Crystal/Compress/Gzip/Error","path":"Compress/Gzip/Error.html","kind":"class","full_name":"Compress::Gzip::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/gzip/gzip.cr","line_number":16,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Compress/Gzip","kind":"module","full_name":"Compress::Gzip","name":"Gzip"}},{"html_id":"Crystal/Compress/Gzip/Header","path":"Compress/Gzip/Header.html","kind":"class","full_name":"Compress::Gzip::Header","name":"Header","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/gzip/header.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Compress/Gzip","kind":"module","full_name":"Compress::Gzip","name":"Gzip"},"doc":"A header in a gzip stream.","summary":"<p>A header in a gzip stream.</p>","instance_methods":[{"html_id":"comment:String?-instance-method","name":"comment","abstract":false,"location":{"filename":"src/compress/gzip/header.cr","line_number":7,"url":null},"def":{"name":"comment","return_type":"String | ::Nil","visibility":"Public","body":"@comment"}},{"html_id":"comment=(comment:String?)-instance-method","name":"comment=","abstract":false,"args":[{"name":"comment","external_name":"comment","restriction":"String | ::Nil"}],"args_string":"(comment : String?)","args_html":"(comment : <a href=\"../../String.html\">String</a>?)","location":{"filename":"src/compress/gzip/header.cr","line_number":7,"url":null},"def":{"name":"comment=","args":[{"name":"comment","external_name":"comment","restriction":"String | ::Nil"}],"visibility":"Public","body":"@comment = comment"}},{"html_id":"extra:Slice(UInt8)-instance-method","name":"extra","abstract":false,"location":{"filename":"src/compress/gzip/header.cr","line_number":5,"url":null},"def":{"name":"extra","visibility":"Public","body":"@extra"}},{"html_id":"extra=(extra)-instance-method","name":"extra=","abstract":false,"args":[{"name":"extra","external_name":"extra","restriction":""}],"args_string":"(extra)","args_html":"(extra)","location":{"filename":"src/compress/gzip/header.cr","line_number":5,"url":null},"def":{"name":"extra=","args":[{"name":"extra","external_name":"extra","restriction":""}],"visibility":"Public","body":"@extra = extra"}},{"html_id":"modification_time:Time-instance-method","name":"modification_time","abstract":false,"location":{"filename":"src/compress/gzip/header.cr","line_number":3,"url":null},"def":{"name":"modification_time","return_type":"Time","visibility":"Public","body":"@modification_time"}},{"html_id":"modification_time=(modification_time:Time)-instance-method","name":"modification_time=","abstract":false,"args":[{"name":"modification_time","external_name":"modification_time","restriction":"Time"}],"args_string":"(modification_time : Time)","args_html":"(modification_time : <a href=\"../../Time.html\">Time</a>)","location":{"filename":"src/compress/gzip/header.cr","line_number":3,"url":null},"def":{"name":"modification_time=","args":[{"name":"modification_time","external_name":"modification_time","restriction":"Time"}],"visibility":"Public","body":"@modification_time = modification_time"}},{"html_id":"name:String?-instance-method","name":"name","abstract":false,"location":{"filename":"src/compress/gzip/header.cr","line_number":6,"url":null},"def":{"name":"name","return_type":"String | ::Nil","visibility":"Public","body":"@name"}},{"html_id":"name=(name:String?)-instance-method","name":"name=","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String | ::Nil"}],"args_string":"(name : String?)","args_html":"(name : <a href=\"../../String.html\">String</a>?)","location":{"filename":"src/compress/gzip/header.cr","line_number":6,"url":null},"def":{"name":"name=","args":[{"name":"name","external_name":"name","restriction":"String | ::Nil"}],"visibility":"Public","body":"@name = name"}},{"html_id":"os:UInt8-instance-method","name":"os","abstract":false,"location":{"filename":"src/compress/gzip/header.cr","line_number":4,"url":null},"def":{"name":"os","return_type":"UInt8","visibility":"Public","body":"@os"}},{"html_id":"os=(os:UInt8)-instance-method","name":"os=","abstract":false,"args":[{"name":"os","external_name":"os","restriction":"UInt8"}],"args_string":"(os : UInt8)","args_html":"(os : <a href=\"../../UInt8.html\">UInt8</a>)","location":{"filename":"src/compress/gzip/header.cr","line_number":4,"url":null},"def":{"name":"os=","args":[{"name":"os","external_name":"os","restriction":"UInt8"}],"visibility":"Public","body":"@os = os"}}]},{"html_id":"Crystal/Compress/Gzip/Reader","path":"Compress/Gzip/Reader.html","kind":"class","full_name":"Compress::Gzip::Reader","name":"Reader","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/gzip/reader.cr","line_number":29,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"}],"namespace":{"html_id":"Crystal/Compress/Gzip","kind":"module","full_name":"Compress::Gzip","name":"Gzip"},"doc":"A read-only `IO` object to decompress data in the gzip format.\n\nInstances of this class wrap another IO object. When you read from this instance\ninstance, it reads data from the underlying IO, decompresses it, and returns\nit to the caller.\n\nNOTE: A gzip stream can contain zero or more members. If it contains\nno members, `header` will be `nil`. If it contains one or more\nmembers, only the first header will be recorded here. This is\nbecause gzipping multiple members is not common as one usually\ncombines gzip with tar. If, however, multiple members are present\nthen reading from this reader will return the concatenation of\nall the members.\n\n### Example: decompress a gzip file\n\n```\nrequire \"compress/gzip\"\n\nFile.write(\"file.gzip\", Bytes[31, 139, 8, 0, 0, 0, 0, 0, 0, 3, 75, 76, 74, 6, 0, 194, 65, 36, 53, 3, 0, 0, 0])\n\nstring = File.open(\"file.gzip\") do |file|\n  Compress::Gzip::Reader.open(file) do |gzip|\n    gzip.gets_to_end\n  end\nend\nstring # => \"abc\"\n```","summary":"<p>A read-only <code><a href=\"../../IO.html\">IO</a></code> object to decompress data in the gzip format.</p>","class_methods":[{"html_id":"open(io:IO,sync_close=false,&)-class-method","name":"open","doc":"Creates a new reader from the given *io*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new reader from the given <em>io</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = false, &)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, sync_close = <span class=\"n\">false</span>, &)","location":{"filename":"src/compress/gzip/reader.cr","line_number":68,"url":null},"def":{"name":"open","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"yields":1,"visibility":"Public","body":"reader = new(io, sync_close: sync_close)\nbegin\n  yield reader\nensure\n  reader.close\nend\n"}},{"html_id":"open(filename:String,&)-class-method","name":"open","doc":"Creates a new reader from the given *filename*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new reader from the given <em>filename</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"}],"args_string":"(filename : String, &)","args_html":"(filename : <a href=\"../../String.html\">String</a>, &)","location":{"filename":"src/compress/gzip/reader.cr","line_number":75,"url":null},"def":{"name":"open","args":[{"name":"filename","external_name":"filename","restriction":"String"}],"yields":1,"visibility":"Public","body":"reader = new(filename)\nbegin\n  yield reader\nensure\n  reader.close\nend\n"}}],"constructors":[{"html_id":"new(io:IO,sync_close=false)-class-method","name":"new","doc":"Creates a new reader from the given *io*.","summary":"<p>Creates a new reader from the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = false)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, sync_close = <span class=\"n\">false</span>)","location":{"filename":"src/compress/gzip/reader.cr","line_number":44,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(filename:String)-class-method","name":"new","doc":"Creates a new reader from the given *filename*.","summary":"<p>Creates a new reader from the given <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"}],"args_string":"(filename : String)","args_html":"(filename : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/compress/gzip/reader.cr","line_number":62,"url":null},"def":{"name":"new","args":[{"name":"filename","external_name":"filename","restriction":"String"}],"visibility":"Public","body":"new(::File.new(filename), sync_close: true)"}}],"instance_methods":[{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this reader is closed.","summary":"<p>Returns <code>true</code> if this reader is closed.</p>","abstract":false,"location":{"filename":"src/compress/gzip/reader.cr","line_number":36,"url":null},"def":{"name":"closed?","visibility":"Public","body":"@closed"}},{"html_id":"header:Header?-instance-method","name":"header","doc":"Returns the first header in the gzip stream, if any.","summary":"<p>Returns the first header in the gzip stream, if any.</p>","abstract":false,"location":{"filename":"src/compress/gzip/reader.cr","line_number":39,"url":null},"def":{"name":"header","return_type":"Header | ::Nil","visibility":"Public","body":"@header"}},{"html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"Whether to close the enclosed `IO` when closing this reader.","summary":"<p>Whether to close the enclosed <code><a href=\"../../IO.html\">IO</a></code> when closing this reader.</p>","abstract":false,"args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","args_html":"(sync_close)","location":{"filename":"src/compress/gzip/reader.cr","line_number":33,"url":null},"def":{"name":"sync_close=","args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"visibility":"Public","body":"@sync_close = sync_close"}},{"html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"Whether to close the enclosed `IO` when closing this reader.","summary":"<p>Whether to close the enclosed <code><a href=\"../../IO.html\">IO</a></code> when closing this reader.</p>","abstract":false,"location":{"filename":"src/compress/gzip/reader.cr","line_number":33,"url":null},"def":{"name":"sync_close?","visibility":"Public","body":"@sync_close"}},{"html_id":"unbuffered_close:Nil-instance-method","name":"unbuffered_close","doc":"Closes this reader.","summary":"<p>Closes this reader.</p>","abstract":false,"location":{"filename":"src/compress/gzip/reader.cr","line_number":141,"url":null},"def":{"name":"unbuffered_close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\n@flate_io.try(&.close)\nif @sync_close\n  @io.close\nend\n"}},{"html_id":"unbuffered_flush:NoReturn-instance-method","name":"unbuffered_flush","doc":"Flushes the wrapped `IO`.","summary":"<p>Flushes the wrapped <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/compress/gzip/reader.cr","line_number":136,"url":null},"def":{"name":"unbuffered_flush","return_type":"NoReturn","visibility":"Public","body":"raise(IO::Error.new(\"Can't flush Compress::Gzip::Reader\"))"}},{"html_id":"unbuffered_read(slice:Bytes):Int32-instance-method","name":"unbuffered_read","doc":"See `IO#read`.","summary":"<p>See <code><a href=\"../../IO.html#read%28slice%3ABytes%29-instance-method\">IO#read</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Int32","args_html":"(slice : <a href=\"../../Bytes.html\">Bytes</a>) : <a href=\"../../Int32.html\">Int32</a>","location":{"filename":"src/compress/gzip/reader.cr","line_number":81,"url":null},"def":{"name":"unbuffered_read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Int32","visibility":"Public","body":"check_open\nif slice.empty?\n  return 0\nend\nwhile true\n  flate_io = @flate_io\n  if flate_io\n  else\n    return 0\n  end\n  read_bytes = flate_io.read(slice)\n  if read_bytes == 0\n    crc32 = @io.read_bytes(UInt32, IO::ByteFormat::LittleEndian)\n    isize = @io.read_bytes(UInt32, IO::ByteFormat::LittleEndian)\n    if crc32 != @crc32\n      raise(Compress::Gzip::Error.new(\"CRC32 checksum mismatch\"))\n    end\n    if isize != @isize\n      raise(Compress::Gzip::Error.new(\"isize mismatch\"))\n    end\n    @crc32 = ::Digest::CRC32.initial\n    @isize = 0_u32\n    first_byte = @io.read_byte\n    if first_byte\n      Header.new(first_byte, @io)\n      @flate_io = Compress::Deflate::Reader.new(@io)\n    else\n      @flate_io = nil\n      break\n    end\n  else\n    @crc32 = ::Digest::CRC32.update(slice[0, read_bytes], @crc32)\n    @isize = @isize &+ read_bytes\n    break\n  end\nend\nread_bytes\n"}},{"html_id":"unbuffered_rewind:Nil-instance-method","name":"unbuffered_rewind","doc":"Rewinds the wrapped `IO`.","summary":"<p>Rewinds the wrapped <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/compress/gzip/reader.cr","line_number":149,"url":null},"def":{"name":"unbuffered_rewind","return_type":"Nil","visibility":"Public","body":"check_open\n@io.rewind\n@header = nil\n@flate_io = nil\ninitialize(@io, @sync_close)\n"}},{"html_id":"unbuffered_write(slice:Bytes):Nil-instance-method","name":"unbuffered_write","doc":"Always raises `IO::Error` because this is a read-only `IO`.","summary":"<p>Always raises <code><a href=\"../../IO/Error.html\">IO::Error</a></code> because this is a read-only <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"../../Bytes.html\">Bytes</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/compress/gzip/reader.cr","line_number":132,"url":null},"def":{"name":"unbuffered_write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"raise(IO::Error.new(\"Can't write to Compress::Gzip::Reader\"))"}}]},{"html_id":"Crystal/Compress/Gzip/Writer","path":"Compress/Gzip/Writer.html","kind":"class","full_name":"Compress::Gzip::Writer","name":"Writer","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/gzip/writer.cr","line_number":24,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Compress/Gzip","kind":"module","full_name":"Compress::Gzip","name":"Gzip"},"doc":"A write-only `IO` object to compress data in the gzip format.\n\nInstances of this class wrap another `IO` object. When you write to this\ninstance, it compresses the data and writes it to the underlying `IO`.\n\nNOTE: unless created with a block, `close` must be invoked after all\ndata has been written to a `Gzip::Writer` instance.\n\n### Example: compress a file\n\n```\nrequire \"compress/gzip\"\n\nFile.write(\"file.txt\", \"abc\")\n\nFile.open(\"./file.txt\", \"r\") do |input_file|\n  File.open(\"./file.gzip\", \"w\") do |output_file|\n    Compress::Gzip::Writer.open(output_file) do |gzip|\n      IO.copy(input_file, gzip)\n    end\n  end\nend\n```","summary":"<p>A write-only <code><a href=\"../../IO.html\">IO</a></code> object to compress data in the gzip format.</p>","class_methods":[{"html_id":"open(io:IO,level=Compress::Gzip::DEFAULT_COMPRESSION,sync_close=false,&)-class-method","name":"open","doc":"Creates a new writer to the given *io*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new writer to the given <em>io</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"level","default_value":"Compress::Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, level = Compress::Gzip::DEFAULT_COMPRESSION, sync_close = false, &)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, level = <span class=\"t\">Compress</span><span class=\"t\">::</span><span class=\"t\">Gzip</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, sync_close = <span class=\"n\">false</span>, &)","location":{"filename":"src/compress/gzip/writer.cr","line_number":53,"url":null},"def":{"name":"open","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"level","default_value":"Compress::Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"yields":1,"visibility":"Public","body":"writer = new(io, level: level, sync_close: sync_close)\nbegin\n  yield writer\nensure\n  writer.close\nend\n"}},{"html_id":"open(filename:String,level=Compress::Gzip::DEFAULT_COMPRESSION,&)-class-method","name":"open","doc":"Creates a new writer to the given *filename*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new writer to the given <em>filename</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"},{"name":"level","default_value":"Compress::Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""}],"args_string":"(filename : String, level = Compress::Gzip::DEFAULT_COMPRESSION, &)","args_html":"(filename : <a href=\"../../String.html\">String</a>, level = <span class=\"t\">Compress</span><span class=\"t\">::</span><span class=\"t\">Gzip</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, &)","location":{"filename":"src/compress/gzip/writer.cr","line_number":60,"url":null},"def":{"name":"open","args":[{"name":"filename","external_name":"filename","restriction":"String"},{"name":"level","default_value":"Compress::Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""}],"yields":1,"visibility":"Public","body":"writer = new(filename, level: level)\nbegin\n  yield writer\nensure\n  writer.close\nend\n"}}],"constructors":[{"html_id":"new(io:IO,level=Compress::Gzip::DEFAULT_COMPRESSION,sync_close=false)-class-method","name":"new","doc":"Creates a new writer to the given *io*.","summary":"<p>Creates a new writer to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"level","default_value":"Compress::Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, level = Compress::Gzip::DEFAULT_COMPRESSION, sync_close = false)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, level = <span class=\"t\">Compress</span><span class=\"t\">::</span><span class=\"t\">Gzip</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, sync_close = <span class=\"n\">false</span>)","location":{"filename":"src/compress/gzip/writer.cr","line_number":38,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"level","default_value":"Compress::Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, level, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(filename:String,level=Compress::Gzip::DEFAULT_COMPRESSION)-class-method","name":"new","doc":"Creates a new writer to the given *filename*.","summary":"<p>Creates a new writer to the given <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"},{"name":"level","default_value":"Compress::Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""}],"args_string":"(filename : String, level = Compress::Gzip::DEFAULT_COMPRESSION)","args_html":"(filename : <a href=\"../../String.html\">String</a>, level = <span class=\"t\">Compress</span><span class=\"t\">::</span><span class=\"t\">Gzip</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>)","location":{"filename":"src/compress/gzip/writer.cr","line_number":47,"url":null},"def":{"name":"new","args":[{"name":"filename","external_name":"filename","restriction":"String"},{"name":"level","default_value":"Compress::Gzip::DEFAULT_COMPRESSION","external_name":"level","restriction":""}],"visibility":"Public","body":"new(::File.new(filename, \"w\"), level: level, sync_close: true)"}}],"instance_methods":[{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes this writer. Must be invoked after all data has been written.","summary":"<p>Closes this writer.</p>","abstract":false,"location":{"filename":"src/compress/gzip/writer.cr","line_number":99,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nflate_io = write_header\nflate_io.close\n@io.write_bytes(@crc32, IO::ByteFormat::LittleEndian)\n@io.write_bytes(@isize, IO::ByteFormat::LittleEndian)\nif @sync_close\n  @io.close\nend\n"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this writer is closed.","summary":"<p>Returns <code>true</code> if this writer is closed.</p>","abstract":false,"location":{"filename":"src/compress/gzip/writer.cr","line_number":29,"url":null},"def":{"name":"closed?","visibility":"Public","body":"@closed"}},{"html_id":"flush:Nil-instance-method","name":"flush","doc":"Flushes data, forcing writing the gzip header if no\ndata has been written yet.\n\nSee `IO#flush`.","summary":"<p>Flushes data, forcing writing the gzip header if no data has been written yet.</p>","abstract":false,"location":{"filename":"src/compress/gzip/writer.cr","line_number":91,"url":null},"def":{"name":"flush","return_type":"Nil","visibility":"Public","body":"check_open\nflate_io = write_header\nflate_io.flush\n"}},{"html_id":"header:Compress::Gzip::Header-instance-method","name":"header","doc":"The header to write to the gzip stream. It will be\nwritten just before the first write to this writer.\nChanges to the header after the first write are\nignored.","summary":"<p>The header to write to the gzip stream.</p>","abstract":false,"location":{"filename":"src/compress/gzip/writer.cr","line_number":35,"url":null},"def":{"name":"header","visibility":"Public","body":"@header"}},{"html_id":"read(slice:Bytes):NoReturn-instance-method","name":"read","doc":"Always raises `IO::Error` because this is a write-only `IO`.","summary":"<p>Always raises <code><a href=\"../../IO/Error.html\">IO::Error</a></code> because this is a write-only <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : NoReturn","args_html":"(slice : <a href=\"../../Bytes.html\">Bytes</a>) : NoReturn","location":{"filename":"src/compress/gzip/writer.cr","line_number":66,"url":null},"def":{"name":"read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"NoReturn","visibility":"Public","body":"raise(IO::Error.new(\"Can't read from Gzip::Writer\"))"}},{"html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"Whether to close the enclosed `IO` when closing this writer.","summary":"<p>Whether to close the enclosed <code><a href=\"../../IO.html\">IO</a></code> when closing this writer.</p>","abstract":false,"args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","args_html":"(sync_close)","location":{"filename":"src/compress/gzip/writer.cr","line_number":26,"url":null},"def":{"name":"sync_close=","args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"visibility":"Public","body":"@sync_close = sync_close"}},{"html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"Whether to close the enclosed `IO` when closing this writer.","summary":"<p>Whether to close the enclosed <code><a href=\"../../IO.html\">IO</a></code> when closing this writer.</p>","abstract":false,"location":{"filename":"src/compress/gzip/writer.cr","line_number":26,"url":null},"def":{"name":"sync_close?","visibility":"Public","body":"@sync_close"}},{"html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"See `IO#write`.","summary":"<p>See <code><a href=\"../../IO.html#write%28slice%3ABytes%29%3ANil-instance-method\">IO#write</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"../../Bytes.html\">Bytes</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/compress/gzip/writer.cr","line_number":71,"url":null},"def":{"name":"write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"check_open\nif slice.empty?\n  return\nend\nflate_io = write_header\nflate_io.write(slice)\n@crc32 = ::Digest::CRC32.update(slice, @crc32)\n@isize = @isize &+ slice.size\n"}}]}]},{"html_id":"Crystal/Compress/Zip","path":"Compress/Zip.html","kind":"module","full_name":"Compress::Zip","name":"Zip","abstract":false,"locations":[{"filename":"src/compress/zip/checksum_reader.cr","line_number":1,"url":null},{"filename":"src/compress/zip/checksum_writer.cr","line_number":1,"url":null},{"filename":"src/compress/zip/zip.cr","line_number":29,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"CENTRAL_DIRECTORY_HEADER_SIGNATURE","name":"CENTRAL_DIRECTORY_HEADER_SIGNATURE","value":"33639248"},{"id":"END_OF_CENTRAL_DIRECTORY_HEADER_SIGNATURE","name":"END_OF_CENTRAL_DIRECTORY_HEADER_SIGNATURE","value":"101010256"},{"id":"VERSION","name":"VERSION","value":"20_u16"}],"namespace":{"html_id":"Crystal/Compress","kind":"module","full_name":"Compress","name":"Compress"},"doc":"The Compress::Zip module contains readers and writers of the zip\nfile format, described at [PKWARE's site](https://pkware.cachefly.net/webdocs/APPNOTE/APPNOTE-6.3.3.TXT).\n\n### Reading zip files\n\nTwo types are provided to read from zip files:\n* `Compress::Zip::File`: can read zip entries from a `File` or from an `IO::Memory`\nand provides random read access to its entries.\n* `Compress::Zip::Reader`: can only read zip entries sequentially from any `IO`.\n\n`Compress::Zip::File` is the preferred method to read zip files if you\ncan provide a `File`, because it's a bit more flexible and provides\nmore complete information for zip entries (such as comments).\n\nWhen reading zip files, CRC32 checksum values are automatically\nverified when finishing reading an entry, and `Compress::Zip::Error` will\nbe raised if the computed CRC32 checksum does not match.\n\n### Writer zip files\n\nUse `Compress::Zip::Writer`, which writes zip entries sequentially to\nany `IO`.\n\nNOTE: only compression methods 0 (STORED) and 8 (DEFLATED) are\nsupported. Additionally, ZIP64 is not yet supported.","summary":"<p>The Compress::Zip module contains readers and writers of the zip file format, described at <a href=\"https://pkware.cachefly.net/webdocs/APPNOTE/APPNOTE-6.3.3.TXT\">PKWARE's site</a>.</p>","types":[{"html_id":"Crystal/Compress/Zip/CompressionMethod","path":"Compress/Zip/CompressionMethod.html","kind":"enum","full_name":"Compress::Zip::CompressionMethod","name":"CompressionMethod","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/zip/compression_method.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"STORED","name":"STORED","value":"0_u16"},{"id":"DEFLATED","name":"DEFLATED","value":"8_u16"}],"namespace":{"html_id":"Crystal/Compress/Zip","kind":"module","full_name":"Compress::Zip","name":"Zip"},"doc":"Supported compression methods in the current implementation.","summary":"<p>Supported compression methods in the current implementation.</p>","instance_methods":[{"html_id":"deflated?-instance-method","name":"deflated?","abstract":false,"location":{"filename":"src/compress/zip/compression_method.cr","line_number":4,"url":null},"def":{"name":"deflated?","visibility":"Public","body":"self == DEFLATED"}},{"html_id":"stored?-instance-method","name":"stored?","abstract":false,"location":{"filename":"src/compress/zip/compression_method.cr","line_number":3,"url":null},"def":{"name":"stored?","visibility":"Public","body":"self == STORED"}}]},{"html_id":"Crystal/Compress/Zip/Error","path":"Compress/Zip/Error.html","kind":"class","full_name":"Compress::Zip::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/zip/zip.cr","line_number":34,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Compress/Zip","kind":"module","full_name":"Compress::Zip","name":"Zip"}},{"html_id":"Crystal/Compress/Zip/File","path":"Compress/Zip/File.html","kind":"class","full_name":"Compress::Zip::File","name":"File","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/zip/file.cr","line_number":27,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Compress/Zip","kind":"module","full_name":"Compress::Zip","name":"Zip"},"doc":"Provides random read access to zip file entries stores inside\na `File` or an `IO::Memory`.\n\n### Example\n\n```\nrequire \"compress/zip\"\n\nCompress::Zip::File.open(\"./file.zip\") do |file|\n  # Iterate through all entries printing their filename and contents\n  file.entries.each do |entry|\n    p entry.filename\n    entry.open do |io|\n      p io.gets_to_end\n    end\n  end\n\n  # Random access to entries by filename is also provided\n  entry = file[\"some_file.txt\"]\n  entry.open do |io|\n    p io.gets_to_end\n  end\nend\n```","summary":"<p>Provides random read access to zip file entries stores inside a <code><a href=\"../../Compress/Zip/File.html\">File</a></code> or an <code><a href=\"../../IO/Memory.html\">IO::Memory</a></code>.</p>","class_methods":[{"html_id":"open(io:IO,sync_close=false,&)-class-method","name":"open","doc":"Opens a `Zip::File` for reading from the given *io*, yields\nit to the given block, and closes it at the end.","summary":"<p>Opens a <code><a href=\"../../Compress/Zip/File.html\">Zip::File</a></code> for reading from the given <em>io</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = false, &)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, sync_close = <span class=\"n\">false</span>, &)","location":{"filename":"src/compress/zip/file.cr","line_number":53,"url":null},"def":{"name":"open","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"yields":1,"visibility":"Public","body":"zip = new(io, sync_close)\nbegin\n  yield zip\nensure\n  zip.close\nend\n"}},{"html_id":"open(filename:String,&)-class-method","name":"open","doc":"Opens a `Zip::File` for reading from the given *filename*, yields\nit to the given block, and closes it at the end.","summary":"<p>Opens a <code><a href=\"../../Compress/Zip/File.html\">Zip::File</a></code> for reading from the given <em>filename</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"}],"args_string":"(filename : String, &)","args_html":"(filename : <a href=\"../../String.html\">String</a>, &)","location":{"filename":"src/compress/zip/file.cr","line_number":60,"url":null},"def":{"name":"open","args":[{"name":"filename","external_name":"filename","restriction":"String"}],"yields":1,"visibility":"Public","body":"zip = new(filename)\nbegin\n  yield zip\nensure\n  zip.close\nend\n"}}],"constructors":[{"html_id":"new(io:IO,sync_close=false)-class-method","name":"new","doc":"Opens a `Zip::File` for reading from the given *io*.","summary":"<p>Opens a <code><a href=\"../../Compress/Zip/File.html\">Zip::File</a></code> for reading from the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = false)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, sync_close = <span class=\"n\">false</span>)","location":{"filename":"src/compress/zip/file.cr","line_number":38,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(filename:String)-class-method","name":"new","doc":"Opens a `Zip::File` for reading from the given *filename*.","summary":"<p>Opens a <code><a href=\"../../Compress/Zip/File.html\">Zip::File</a></code> for reading from the given <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"}],"args_string":"(filename : String)","args_html":"(filename : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/compress/zip/file.cr","line_number":47,"url":null},"def":{"name":"new","args":[{"name":"filename","external_name":"filename","restriction":"String"}],"visibility":"Public","body":"new(::File.new(filename), sync_close: true)"}}],"instance_methods":[{"html_id":"[](filename:String):Entry-instance-method","name":"[]","doc":"Returns the entry that has the given filename, or\nraises `KeyError` if no such entry exists.","summary":"<p>Returns the entry that has the given filename, or raises <code><a href=\"../../KeyError.html\">KeyError</a></code> if no such entry exists.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"}],"args_string":"(filename : String) : Entry","args_html":"(filename : <a href=\"../../String.html\">String</a>) : <a href=\"../../Compress/Zip/File/Entry.html\">Entry</a>","location":{"filename":"src/compress/zip/file.cr","line_number":67,"url":null},"def":{"name":"[]","args":[{"name":"filename","external_name":"filename","restriction":"String"}],"return_type":"Entry","visibility":"Public","body":"self[filename]? || (raise(KeyError.new(\"Missing zip entry: #{filename}\")))"}},{"html_id":"[]?(filename:String):Entry?-instance-method","name":"[]?","doc":"Returns the entry that has the given filename, or\n`nil` if no such entry exists.","summary":"<p>Returns the entry that has the given filename, or <code>nil</code> if no such entry exists.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"}],"args_string":"(filename : String) : Entry?","args_html":"(filename : <a href=\"../../String.html\">String</a>) : <a href=\"../../Compress/Zip/File/Entry.html\">Entry</a>?","location":{"filename":"src/compress/zip/file.cr","line_number":73,"url":null},"def":{"name":"[]?","args":[{"name":"filename","external_name":"filename","restriction":"String"}],"return_type":"Entry | ::Nil","visibility":"Public","body":"@entries_by_filename[filename]?"}},{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes this zip file.","summary":"<p>Closes this zip file.</p>","abstract":false,"location":{"filename":"src/compress/zip/file.cr","line_number":78,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nif @sync_close\n  @io.close\nend\n"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this zip file is closed.","summary":"<p>Returns <code>true</code> if this zip file is closed.</p>","abstract":false,"location":{"filename":"src/compress/zip/file.cr","line_number":32,"url":null},"def":{"name":"closed?","visibility":"Public","body":"@closed"}},{"html_id":"comment:String-instance-method","name":"comment","doc":"Returns the zip file comment.","summary":"<p>Returns the zip file comment.</p>","abstract":false,"location":{"filename":"src/compress/zip/file.cr","line_number":35,"url":null},"def":{"name":"comment","visibility":"Public","body":"@comment"}},{"html_id":"entries:Array(Entry)-instance-method","name":"entries","doc":"Returns all entries inside this zip file.","summary":"<p>Returns all entries inside this zip file.</p>","abstract":false,"location":{"filename":"src/compress/zip/file.cr","line_number":29,"url":null},"def":{"name":"entries","return_type":"Array(Entry)","visibility":"Public","body":"@entries"}}],"types":[{"html_id":"Crystal/Compress/Zip/File/Entry","path":"Compress/Zip/File/Entry.html","kind":"class","full_name":"Compress::Zip::File::Entry","name":"Entry","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Compress/Zip/FileInfo","kind":"module","full_name":"Compress::Zip::FileInfo","name":"FileInfo"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/zip/file.cr","line_number":159,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Compress/Zip/FileInfo","kind":"module","full_name":"Compress::Zip::FileInfo","name":"FileInfo"}],"namespace":{"html_id":"Crystal/Compress/Zip/File","kind":"class","full_name":"Compress::Zip::File","name":"File"},"doc":"An entry inside a `Zip::File`.\n\nUse the `open` method to read from it.","summary":"<p>An entry inside a <code><a href=\"../../../Compress/Zip/File.html\">Zip::File</a></code>.</p>","instance_methods":[{"html_id":"open(&)-instance-method","name":"open","doc":"Yields an `IO` to read this entry's contents.\nMultiple entries can be opened and read concurrently.","summary":"<p>Yields an <code><a href=\"../../../IO.html\">IO</a></code> to read this entry's contents.</p>","abstract":false,"location":{"filename":"src/compress/zip/file.cr","line_number":169,"url":null},"def":{"name":"open","yields":1,"visibility":"Public","body":"@io.read_at(data_offset.to_i32, compressed_size.to_i32) do |io|\n  io = decompressor_for(io, is_sized: true)\n  checksum_reader = ChecksumReader.new(io, filename, verify: crc32)\n  yield checksum_reader\nend"}}]}]},{"html_id":"Crystal/Compress/Zip/FileInfo","path":"Compress/Zip/FileInfo.html","kind":"module","full_name":"Compress::Zip::FileInfo","name":"FileInfo","abstract":false,"locations":[{"filename":"src/compress/zip/file_info.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"DATA_DESCRIPTOR_SIGNATURE","name":"DATA_DESCRIPTOR_SIGNATURE","value":"134695760"},{"id":"DEFLATE_END_SIGNATURE","name":"DEFLATE_END_SIGNATURE","value":"Bytes[80, 75, 7, 8, read_only: true]"},{"id":"SIGNATURE","name":"SIGNATURE","value":"67324752"}],"including_types":[{"html_id":"Crystal/Compress/Zip/File/Entry","kind":"class","full_name":"Compress::Zip::File::Entry","name":"Entry"},{"html_id":"Crystal/Compress/Zip/Reader/Entry","kind":"class","full_name":"Compress::Zip::Reader::Entry","name":"Entry"},{"html_id":"Crystal/Compress/Zip/Writer/Entry","kind":"class","full_name":"Compress::Zip::Writer::Entry","name":"Entry"}],"namespace":{"html_id":"Crystal/Compress/Zip","kind":"module","full_name":"Compress::Zip","name":"Zip"},"doc":"Base type for file information related to zip entries.","summary":"<p>Base type for file information related to zip entries.</p>","constructors":[{"html_id":"new(filename:String,time=Time.utc,comment=\"\",extra=Bytes.empty)-class-method","name":"new","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"},{"name":"time","default_value":"Time.utc","external_name":"time","restriction":""},{"name":"comment","default_value":"\"\"","external_name":"comment","restriction":""},{"name":"extra","default_value":"Bytes.empty","external_name":"extra","restriction":""}],"args_string":"(filename : String, time = Time.utc, comment = \"\", extra = Bytes.empty)","args_html":"(filename : <a href=\"../../String.html\">String</a>, time = <span class=\"t\">Time</span>.utc, comment = <span class=\"s\">&quot;&quot;</span>, extra = <span class=\"t\">Bytes</span>.empty)","location":{"filename":"src/compress/zip/file_info.cr","line_number":68,"url":null},"def":{"name":"new","args":[{"name":"filename","external_name":"filename","restriction":"String"},{"name":"time","default_value":"Time.utc","external_name":"time","restriction":""},{"name":"comment","default_value":"\"\"","external_name":"comment","restriction":""},{"name":"extra","default_value":"Bytes.empty","external_name":"extra","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(filename, time, comment, extra)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"comment-instance-method","name":"comment","abstract":false,"location":{"filename":"src/compress/zip/file_info.cr","line_number":17,"url":null},"def":{"name":"comment","visibility":"Public","body":"@comment"}},{"html_id":"comment=(comment)-instance-method","name":"comment=","abstract":false,"args":[{"name":"comment","external_name":"comment","restriction":""}],"args_string":"(comment)","args_html":"(comment)","location":{"filename":"src/compress/zip/file_info.cr","line_number":17,"url":null},"def":{"name":"comment=","args":[{"name":"comment","external_name":"comment","restriction":""}],"visibility":"Public","body":"@comment = comment"}},{"html_id":"compressed_size-instance-method","name":"compressed_size","abstract":false,"location":{"filename":"src/compress/zip/file_info.cr","line_number":13,"url":null},"def":{"name":"compressed_size","visibility":"Public","body":"@compressed_size"}},{"html_id":"compressed_size=(compressed_size)-instance-method","name":"compressed_size=","abstract":false,"args":[{"name":"compressed_size","external_name":"compressed_size","restriction":""}],"args_string":"(compressed_size)","args_html":"(compressed_size)","location":{"filename":"src/compress/zip/file_info.cr","line_number":13,"url":null},"def":{"name":"compressed_size=","args":[{"name":"compressed_size","external_name":"compressed_size","restriction":""}],"visibility":"Public","body":"@compressed_size = compressed_size"}},{"html_id":"compression_method-instance-method","name":"compression_method","abstract":false,"location":{"filename":"src/compress/zip/file_info.cr","line_number":10,"url":null},"def":{"name":"compression_method","visibility":"Public","body":"@compression_method"}},{"html_id":"compression_method=(compression_method)-instance-method","name":"compression_method=","abstract":false,"args":[{"name":"compression_method","external_name":"compression_method","restriction":""}],"args_string":"(compression_method)","args_html":"(compression_method)","location":{"filename":"src/compress/zip/file_info.cr","line_number":10,"url":null},"def":{"name":"compression_method=","args":[{"name":"compression_method","external_name":"compression_method","restriction":""}],"visibility":"Public","body":"@compression_method = compression_method"}},{"html_id":"crc32-instance-method","name":"crc32","abstract":false,"location":{"filename":"src/compress/zip/file_info.cr","line_number":12,"url":null},"def":{"name":"crc32","visibility":"Public","body":"@crc32"}},{"html_id":"crc32=(crc32)-instance-method","name":"crc32=","abstract":false,"args":[{"name":"crc32","external_name":"crc32","restriction":""}],"args_string":"(crc32)","args_html":"(crc32)","location":{"filename":"src/compress/zip/file_info.cr","line_number":12,"url":null},"def":{"name":"crc32=","args":[{"name":"crc32","external_name":"crc32","restriction":""}],"visibility":"Public","body":"@crc32 = crc32"}},{"html_id":"dir?:Bool-instance-method","name":"dir?","doc":"Returns `true` if this entry is a directory.","summary":"<p>Returns <code>true</code> if this entry is a directory.</p>","abstract":false,"location":{"filename":"src/compress/zip/file_info.cr","line_number":72,"url":null},"def":{"name":"dir?","return_type":"Bool","visibility":"Public","body":"filename.ends_with?('/')"}},{"html_id":"extra-instance-method","name":"extra","abstract":false,"location":{"filename":"src/compress/zip/file_info.cr","line_number":16,"url":null},"def":{"name":"extra","visibility":"Public","body":"@extra"}},{"html_id":"extra=(extra)-instance-method","name":"extra=","abstract":false,"args":[{"name":"extra","external_name":"extra","restriction":""}],"args_string":"(extra)","args_html":"(extra)","location":{"filename":"src/compress/zip/file_info.cr","line_number":16,"url":null},"def":{"name":"extra=","args":[{"name":"extra","external_name":"extra","restriction":""}],"visibility":"Public","body":"@extra = extra"}},{"html_id":"file?:Bool-instance-method","name":"file?","doc":"Returns `true` if this entry is a file.","summary":"<p>Returns <code>true</code> if this entry is a file.</p>","abstract":false,"location":{"filename":"src/compress/zip/file_info.cr","line_number":77,"url":null},"def":{"name":"file?","return_type":"Bool","visibility":"Public","body":"!dir?"}},{"html_id":"filename-instance-method","name":"filename","abstract":false,"location":{"filename":"src/compress/zip/file_info.cr","line_number":15,"url":null},"def":{"name":"filename","visibility":"Public","body":"@filename"}},{"html_id":"filename=(filename)-instance-method","name":"filename=","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":""}],"args_string":"(filename)","args_html":"(filename)","location":{"filename":"src/compress/zip/file_info.cr","line_number":15,"url":null},"def":{"name":"filename=","args":[{"name":"filename","external_name":"filename","restriction":""}],"visibility":"Public","body":"@filename = filename"}},{"html_id":"general_purpose_bit_flag-instance-method","name":"general_purpose_bit_flag","abstract":false,"location":{"filename":"src/compress/zip/file_info.cr","line_number":9,"url":null},"def":{"name":"general_purpose_bit_flag","visibility":"Public","body":"@general_purpose_bit_flag"}},{"html_id":"general_purpose_bit_flag=(general_purpose_bit_flag)-instance-method","name":"general_purpose_bit_flag=","abstract":false,"args":[{"name":"general_purpose_bit_flag","external_name":"general_purpose_bit_flag","restriction":""}],"args_string":"(general_purpose_bit_flag)","args_html":"(general_purpose_bit_flag)","location":{"filename":"src/compress/zip/file_info.cr","line_number":9,"url":null},"def":{"name":"general_purpose_bit_flag=","args":[{"name":"general_purpose_bit_flag","external_name":"general_purpose_bit_flag","restriction":""}],"visibility":"Public","body":"@general_purpose_bit_flag = general_purpose_bit_flag"}},{"html_id":"offset-instance-method","name":"offset","abstract":false,"location":{"filename":"src/compress/zip/file_info.cr","line_number":18,"url":null},"def":{"name":"offset","visibility":"Public","body":"@offset"}},{"html_id":"offset=(offset)-instance-method","name":"offset=","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":""}],"args_string":"(offset)","args_html":"(offset)","location":{"filename":"src/compress/zip/file_info.cr","line_number":18,"url":null},"def":{"name":"offset=","args":[{"name":"offset","external_name":"offset","restriction":""}],"visibility":"Public","body":"@offset = offset"}},{"html_id":"time:Time-instance-method","name":"time","abstract":false,"location":{"filename":"src/compress/zip/file_info.cr","line_number":11,"url":null},"def":{"name":"time","return_type":"Time","visibility":"Public","body":"@time"}},{"html_id":"time=(time:Time)-instance-method","name":"time=","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"}],"args_string":"(time : Time)","args_html":"(time : <a href=\"../../Time.html\">Time</a>)","location":{"filename":"src/compress/zip/file_info.cr","line_number":11,"url":null},"def":{"name":"time=","args":[{"name":"time","external_name":"time","restriction":"Time"}],"visibility":"Public","body":"@time = time"}},{"html_id":"uncompressed_size-instance-method","name":"uncompressed_size","abstract":false,"location":{"filename":"src/compress/zip/file_info.cr","line_number":14,"url":null},"def":{"name":"uncompressed_size","visibility":"Public","body":"@uncompressed_size"}},{"html_id":"uncompressed_size=(uncompressed_size)-instance-method","name":"uncompressed_size=","abstract":false,"args":[{"name":"uncompressed_size","external_name":"uncompressed_size","restriction":""}],"args_string":"(uncompressed_size)","args_html":"(uncompressed_size)","location":{"filename":"src/compress/zip/file_info.cr","line_number":14,"url":null},"def":{"name":"uncompressed_size=","args":[{"name":"uncompressed_size","external_name":"uncompressed_size","restriction":""}],"visibility":"Public","body":"@uncompressed_size = uncompressed_size"}},{"html_id":"version:UInt16-instance-method","name":"version","abstract":false,"location":{"filename":"src/compress/zip/file_info.cr","line_number":8,"url":null},"def":{"name":"version","return_type":"UInt16","visibility":"Public","body":"@version"}},{"html_id":"version=(version:UInt16)-instance-method","name":"version=","abstract":false,"args":[{"name":"version","external_name":"version","restriction":"UInt16"}],"args_string":"(version : UInt16)","args_html":"(version : <a href=\"../../UInt16.html\">UInt16</a>)","location":{"filename":"src/compress/zip/file_info.cr","line_number":8,"url":null},"def":{"name":"version=","args":[{"name":"version","external_name":"version","restriction":"UInt16"}],"visibility":"Public","body":"@version = version"}}]},{"html_id":"Crystal/Compress/Zip/Reader","path":"Compress/Zip/Reader.html","kind":"class","full_name":"Compress::Zip::Reader","name":"Reader","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/zip/reader.cr","line_number":25,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Compress/Zip","kind":"module","full_name":"Compress::Zip","name":"Zip"},"doc":"Reads zip file entries sequentially from an `IO`.\n\nNOTE: Entries might not have correct values\nfor crc32, compressed_size, uncompressed_size and comment,\nbecause when reading a zip file directly from a stream this\ninformation might be stored later in the zip stream.\nIf you need this information, consider using `Zip::File`.\n\n### Example\n\n```\nrequire \"compress/zip\"\n\nCompress::Zip::Reader.open(\"./file.zip\") do |zip|\n  zip.each_entry do |entry|\n    p entry.filename\n    p entry.file?\n    p entry.dir?\n    p entry.io.gets_to_end\n  end\nend\n```","summary":"<p>Reads zip file entries sequentially from an <code><a href=\"../../IO.html\">IO</a></code>.</p>","class_methods":[{"html_id":"open(io:IO,sync_close=false,&)-class-method","name":"open","doc":"Creates a new reader from the given *io*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new reader from the given <em>io</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = false, &)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, sync_close = <span class=\"n\">false</span>, &)","location":{"filename":"src/compress/zip/reader.cr","line_number":45,"url":null},"def":{"name":"open","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"yields":1,"visibility":"Public","body":"reader = new(io, sync_close: sync_close)\nbegin\n  yield reader\nensure\n  reader.close\nend\n"}},{"html_id":"open(filename:String,&)-class-method","name":"open","doc":"Creates a new reader from the given *filename*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new reader from the given <em>filename</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"}],"args_string":"(filename : String, &)","args_html":"(filename : <a href=\"../../String.html\">String</a>, &)","location":{"filename":"src/compress/zip/reader.cr","line_number":52,"url":null},"def":{"name":"open","args":[{"name":"filename","external_name":"filename","restriction":"String"}],"yields":1,"visibility":"Public","body":"reader = new(filename)\nbegin\n  yield reader\nensure\n  reader.close\nend\n"}}],"constructors":[{"html_id":"new(io:IO,sync_close=false)-class-method","name":"new","doc":"Creates a new reader from the given *io*.","summary":"<p>Creates a new reader from the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = false)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, sync_close = <span class=\"n\">false</span>)","location":{"filename":"src/compress/zip/reader.cr","line_number":33,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(filename:String)-class-method","name":"new","doc":"Creates a new reader from the given *filename*.","summary":"<p>Creates a new reader from the given <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"}],"args_string":"(filename : String)","args_html":"(filename : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/compress/zip/reader.cr","line_number":39,"url":null},"def":{"name":"new","args":[{"name":"filename","external_name":"filename","restriction":"String"}],"visibility":"Public","body":"new(::File.new(filename), sync_close: true)"}}],"instance_methods":[{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes this zip reader.","summary":"<p>Closes this zip reader.</p>","abstract":false,"location":{"filename":"src/compress/zip/reader.cr","line_number":104,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nif @sync_close\n  @io.close\nend\n"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this reader is closed.","summary":"<p>Returns <code>true</code> if this reader is closed.</p>","abstract":false,"location":{"filename":"src/compress/zip/reader.cr","line_number":30,"url":null},"def":{"name":"closed?","visibility":"Public","body":"@closed"}},{"html_id":"each_entry(&)-instance-method","name":"each_entry","doc":"Yields each entry in the zip to the given block.","summary":"<p>Yields each entry in the zip to the given block.</p>","abstract":false,"location":{"filename":"src/compress/zip/reader.cr","line_number":97,"url":null},"def":{"name":"each_entry","yields":1,"visibility":"Public","body":"while entry = next_entry\n  yield entry\nend"}},{"html_id":"next_entry:Entry?-instance-method","name":"next_entry","doc":"Reads the next entry in the zip, or `nil` if there\nare no more entries.\n\nAfter reading a next entry, previous entries can no\nlonger be read (their `IO` will be closed.)","summary":"<p>Reads the next entry in the zip, or <code>nil</code> if there are no more entries.</p>","abstract":false,"location":{"filename":"src/compress/zip/reader.cr","line_number":62,"url":null},"def":{"name":"next_entry","return_type":"Entry | ::Nil","visibility":"Public","body":"if @reached_end\n  return nil\nend\nif last_entry = @last_entry\n  last_entry.close\n  skip_data_descriptor(last_entry)\nend\nwhile true\n  signature = read(UInt32)\n  case signature\n  when FileInfo::SIGNATURE\n    break\n  when FileInfo::DATA_DESCRIPTOR_SIGNATURE\n    if last_entry && (!@read_data_descriptor)\n      read_data_descriptor(last_entry)\n      next\n    else\n      raise(Error.new(\"Unexpected data descriptor when reading zip\"))\n    end\n  else\n    @reached_end = true\n    return nil\n  end\nend\n@last_entry = Entry.new(@io)\n"}},{"html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"Whether to close the enclosed `IO` when closing this reader.","summary":"<p>Whether to close the enclosed <code><a href=\"../../IO.html\">IO</a></code> when closing this reader.</p>","abstract":false,"args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","args_html":"(sync_close)","location":{"filename":"src/compress/zip/reader.cr","line_number":27,"url":null},"def":{"name":"sync_close=","args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"visibility":"Public","body":"@sync_close = sync_close"}},{"html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"Whether to close the enclosed `IO` when closing this reader.","summary":"<p>Whether to close the enclosed <code><a href=\"../../IO.html\">IO</a></code> when closing this reader.</p>","abstract":false,"location":{"filename":"src/compress/zip/reader.cr","line_number":27,"url":null},"def":{"name":"sync_close?","visibility":"Public","body":"@sync_close"}}],"types":[{"html_id":"Crystal/Compress/Zip/Reader/Entry","path":"Compress/Zip/Reader/Entry.html","kind":"class","full_name":"Compress::Zip::Reader::Entry","name":"Entry","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Compress/Zip/FileInfo","kind":"module","full_name":"Compress::Zip::FileInfo","name":"FileInfo"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/zip/reader.cr","line_number":148,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Compress/Zip/FileInfo","kind":"module","full_name":"Compress::Zip::FileInfo","name":"FileInfo"}],"namespace":{"html_id":"Crystal/Compress/Zip/Reader","kind":"class","full_name":"Compress::Zip::Reader","name":"Reader"},"doc":"A entry inside a `Zip::Reader`.\n\nUse the `io` method to read from it.","summary":"<p>A entry inside a <code><a href=\"../../../Compress/Zip/Reader.html\">Zip::Reader</a></code>.</p>","instance_methods":[{"html_id":"io:IO-instance-method","name":"io","doc":"Returns an `IO` to the entry's data.","summary":"<p>Returns an <code><a href=\"../../../IO.html\">IO</a></code> to the entry's data.</p>","abstract":false,"location":{"filename":"src/compress/zip/reader.cr","line_number":159,"url":null},"def":{"name":"io","return_type":"IO","visibility":"Public","body":"@io"}}]}]},{"html_id":"Crystal/Compress/Zip/Writer","path":"Compress/Zip/Writer.html","kind":"class","full_name":"Compress::Zip::Writer","name":"Writer","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/zip/writer.cr","line_number":26,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Compress/Zip","kind":"module","full_name":"Compress::Zip","name":"Zip"},"doc":"Writes (streams) zip entries to an `IO`.\n\n### Example\n\n```\nrequire \"compress/zip\"\n\nFile.open(\"./file.zip\", \"w\") do |file|\n  Compress::Zip::Writer.open(file) do |zip|\n    # Add a file with a String content\n    zip.add \"foo.txt\", \"contents of foo\"\n\n    # Add a file and write data to it through an IO\n    zip.add(\"bar.txt\") do |io|\n      io << \"contents of bar\"\n    end\n\n    # Add a file by referencing a file in the filesystem\n    # (the file is automatically closed after this call)\n    zip.add(\"baz.txt\", File.open(\"./some_file.txt\"))\n  end\nend\n```","summary":"<p>Writes (streams) zip entries to an <code><a href=\"../../IO.html\">IO</a></code>.</p>","class_methods":[{"html_id":"open(io:IO,sync_close=false,&)-class-method","name":"open","doc":"Creates a new writer to the given *io*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new writer to the given <em>io</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = false, &)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, sync_close = <span class=\"n\">false</span>, &)","location":{"filename":"src/compress/zip/writer.cr","line_number":54,"url":null},"def":{"name":"open","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"yields":1,"visibility":"Public","body":"writer = new(io, sync_close: sync_close)\nbegin\n  yield writer\nensure\n  writer.close\nend\n"}},{"html_id":"open(filename:String,&)-class-method","name":"open","doc":"Creates a new writer to the given *filename*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new writer to the given <em>filename</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"}],"args_string":"(filename : String, &)","args_html":"(filename : <a href=\"../../String.html\">String</a>, &)","location":{"filename":"src/compress/zip/writer.cr","line_number":61,"url":null},"def":{"name":"open","args":[{"name":"filename","external_name":"filename","restriction":"String"}],"yields":1,"visibility":"Public","body":"writer = new(filename)\nbegin\n  yield writer\nensure\n  writer.close\nend\n"}}],"constructors":[{"html_id":"new(io:IO,sync_close=false)-class-method","name":"new","doc":"Creates a new writer to the given *io*.","summary":"<p>Creates a new writer to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, sync_close = false)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, sync_close = <span class=\"n\">false</span>)","location":{"filename":"src/compress/zip/writer.cr","line_number":37,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(filename:String)-class-method","name":"new","doc":"Creates a new writer to the given *filename*.","summary":"<p>Creates a new writer to the given <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"}],"args_string":"(filename : String)","args_html":"(filename : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/compress/zip/writer.cr","line_number":48,"url":null},"def":{"name":"new","args":[{"name":"filename","external_name":"filename","restriction":"String"}],"visibility":"Public","body":"new(::File.new(filename, \"w\"), sync_close: true)"}}],"instance_methods":[{"html_id":"add(filename:String,&)-instance-method","name":"add","doc":"Adds an entry that will have the given *filename* and current\ntime (`Time.utc`) and yields an `IO` to write that entry's\ncontents.","summary":"<p>Adds an entry that will have the given <em>filename</em> and current time (<code><a href=\"../../Time.html#utc%3ATime-class-method\">Time.utc</a></code>) and yields an <code><a href=\"../../IO.html\">IO</a></code> to write that entry's contents.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"}],"args_string":"(filename : String, &)","args_html":"(filename : <a href=\"../../String.html\">String</a>, &)","location":{"filename":"src/compress/zip/writer.cr","line_number":69,"url":null},"def":{"name":"add","args":[{"name":"filename","external_name":"filename","restriction":"String"}],"yields":1,"visibility":"Public","body":"add(Entry.new(filename)) do |io|\n  yield io\nend"}},{"html_id":"add(entry:Entry,&)-instance-method","name":"add","doc":"Adds an entry and yields `IO` to write that entry's contents.\n\nYou can choose the Entry's compression method before adding it.\n\n* If the STORED compression method is used, its crc32, compressed\nsize and uncompressed size **must** be set and be correct with\nrespect to the data that will be written to the yielded `IO`.\n* If the DEFLATED compression method is used, crc32, compressed\nsize and uncompressed size will be computed from the data\nwritten to the yielded IO.\n\nYou can also set the Entry's time (which is `Time.utc` by default)\n and extra data before adding it to the zip stream.","summary":"<p>Adds an entry and yields <code><a href=\"../../IO.html\">IO</a></code> to write that entry's contents.</p>","abstract":false,"args":[{"name":"entry","external_name":"entry","restriction":"Entry"}],"args_string":"(entry : Entry, &)","args_html":"(entry : <a href=\"../../Compress/Zip/Writer/Entry.html\">Entry</a>, &)","location":{"filename":"src/compress/zip/writer.cr","line_number":88,"url":null},"def":{"name":"add","args":[{"name":"entry","external_name":"entry","restriction":"Entry"}],"yields":1,"visibility":"Public","body":"entry.general_purpose_bit_flag = entry.general_purpose_bit_flag | (1 << 3)\nentry.general_purpose_bit_flag = entry.general_purpose_bit_flag | (1 << 11)\nentry.offset = @written\n@written = @written + (entry.to_io(@io))\ncase entry.compression_method\nwhen .stored?\n  if entry.compressed_size != entry.uncompressed_size\n    raise(Error.new(\"Entry compressed size (#{entry.compressed_size}) is not equal to its uncompressed size (#{entry.uncompressed_size})\"))\n  end\n  @uncompressed_size_counter.io = @io\n  yield @uncompressed_size_counter\nwhen .deflated?\n  @compressed_size_counter.io = @io\n  io = Compress::Deflate::Writer.new(@compressed_size_counter)\n  @uncompressed_size_counter.io = io\n  yield @uncompressed_size_counter\n  io.close\nelse\n  raise(\"Unsupported compression method: #{entry.compression_method}\")\nend\nif entry.compression_method.stored?\n  @written = @written + @uncompressed_size_counter.count\nelse\n  @written = @written + @compressed_size_counter.count\nend\ncrc32 = @uncompressed_size_counter.crc32.to_u32\nuncompressed_size = @uncompressed_size_counter.count\nif entry.compression_method.stored?\n  compressed_size = uncompressed_size\nelse\n  compressed_size = @compressed_size_counter.count\nend\nif entry.compression_method.stored?\n  if entry.crc32 != crc32\n    raise(Error.new(\"Entry CRC32 mismatch (#{entry.crc32} given but was #{crc32})\"))\n  end\n  if entry.uncompressed_size != uncompressed_size\n    raise(Error.new(\"Entry uncompressed size mismatch (#{entry.uncompressed_size} given but was #{uncompressed_size})\"))\n  end\nelse\n  entry.crc32 = crc32\n  entry.compressed_size = compressed_size\n  entry.uncompressed_size = uncompressed_size\nend\nif entry.compression_method.stored?\nelse\n  @written = @written + (entry.write_data_descriptor(@io))\nend\n@entries << entry\n"}},{"html_id":"add(filename_or_entry:String|Entry,string:String):Nil-instance-method","name":"add","doc":"Adds an entry that will have *string* as its contents.","summary":"<p>Adds an entry that will have <em>string</em> as its contents.</p>","abstract":false,"args":[{"name":"filename_or_entry","external_name":"filename_or_entry","restriction":"String | Entry"},{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(filename_or_entry : String | Entry, string : String) : Nil","args_html":"(filename_or_entry : <a href=\"../../String.html\">String</a> | <a href=\"../../Compress/Zip/Writer/Entry.html\">Entry</a>, string : <a href=\"../../String.html\">String</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/compress/zip/writer.cr","line_number":154,"url":null},"def":{"name":"add","args":[{"name":"filename_or_entry","external_name":"filename_or_entry","restriction":"String | Entry"},{"name":"string","external_name":"string","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"add(filename_or_entry) do |io|\n  io << string\nend"}},{"html_id":"add(filename_or_entry:String|Entry,bytes:Bytes):Nil-instance-method","name":"add","doc":"Adds an entry that will have *bytes* as its contents.","summary":"<p>Adds an entry that will have <em>bytes</em> as its contents.</p>","abstract":false,"args":[{"name":"filename_or_entry","external_name":"filename_or_entry","restriction":"String | Entry"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(filename_or_entry : String | Entry, bytes : Bytes) : Nil","args_html":"(filename_or_entry : <a href=\"../../String.html\">String</a> | <a href=\"../../Compress/Zip/Writer/Entry.html\">Entry</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/compress/zip/writer.cr","line_number":161,"url":null},"def":{"name":"add","args":[{"name":"filename_or_entry","external_name":"filename_or_entry","restriction":"String | Entry"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"add(filename_or_entry) do |io|\n  io.write(bytes)\nend"}},{"html_id":"add(filename_or_entry:String|Entry,data:IO):Nil-instance-method","name":"add","doc":"Adds an entry that will have its data copied from the given *data*.\nIf the given *data* is a `::File`, it is automatically closed\nafter data is copied from it.","summary":"<p>Adds an entry that will have its data copied from the given <em>data</em>.</p>","abstract":false,"args":[{"name":"filename_or_entry","external_name":"filename_or_entry","restriction":"String | Entry"},{"name":"data","external_name":"data","restriction":"IO"}],"args_string":"(filename_or_entry : String | Entry, data : IO) : Nil","args_html":"(filename_or_entry : <a href=\"../../String.html\">String</a> | <a href=\"../../Compress/Zip/Writer/Entry.html\">Entry</a>, data : <a href=\"../../IO.html\">IO</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/compress/zip/writer.cr","line_number":170,"url":null},"def":{"name":"add","args":[{"name":"filename_or_entry","external_name":"filename_or_entry","restriction":"String | Entry"},{"name":"data","external_name":"data","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"add(filename_or_entry) do |io|\n  IO.copy(data, io)\n  if data.is_a?(::File)\n    data.close\n  end\nend"}},{"html_id":"add_dir(name):Nil-instance-method","name":"add_dir","doc":"Adds a directory entry that will have the given *name*.","summary":"<p>Adds a directory entry that will have the given <em>name</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name) : Nil","args_html":"(name) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/compress/zip/writer.cr","line_number":178,"url":null},"def":{"name":"add_dir","args":[{"name":"name","external_name":"name","restriction":""}],"return_type":"Nil","visibility":"Public","body":"if name.ends_with?('/')\nelse\n  name = name + '/'\nend\nadd(Entry.new(name)) do\nend\n"}},{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes this zip writer.","summary":"<p>Closes this zip writer.</p>","abstract":false,"location":{"filename":"src/compress/zip/writer.cr","line_number":184,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nstart_offset = @written\nwrite_central_directory\nwrite_end_of_central_directory(start_offset, @written - start_offset)\nif @sync_close\n  @io.close\nend\n"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this writer is closed.","summary":"<p>Returns <code>true</code> if this writer is closed.</p>","abstract":false,"location":{"filename":"src/compress/zip/writer.cr","line_number":31,"url":null},"def":{"name":"closed?","visibility":"Public","body":"@closed"}},{"html_id":"comment=(comment)-instance-method","name":"comment=","doc":"Sets the zip file comment","summary":"<p>Sets the zip file comment</p>","abstract":false,"args":[{"name":"comment","external_name":"comment","restriction":""}],"args_string":"(comment)","args_html":"(comment)","location":{"filename":"src/compress/zip/writer.cr","line_number":34,"url":null},"def":{"name":"comment=","args":[{"name":"comment","external_name":"comment","restriction":""}],"visibility":"Public","body":"@comment = comment"}},{"html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"Whether to close the enclosed `IO` when closing this writer.","summary":"<p>Whether to close the enclosed <code><a href=\"../../IO.html\">IO</a></code> when closing this writer.</p>","abstract":false,"args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","args_html":"(sync_close)","location":{"filename":"src/compress/zip/writer.cr","line_number":28,"url":null},"def":{"name":"sync_close=","args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"visibility":"Public","body":"@sync_close = sync_close"}},{"html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"Whether to close the enclosed `IO` when closing this writer.","summary":"<p>Whether to close the enclosed <code><a href=\"../../IO.html\">IO</a></code> when closing this writer.</p>","abstract":false,"location":{"filename":"src/compress/zip/writer.cr","line_number":28,"url":null},"def":{"name":"sync_close?","visibility":"Public","body":"@sync_close"}}],"types":[{"html_id":"Crystal/Compress/Zip/Writer/Entry","path":"Compress/Zip/Writer/Entry.html","kind":"class","full_name":"Compress::Zip::Writer::Entry","name":"Entry","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Compress/Zip/FileInfo","kind":"module","full_name":"Compress::Zip::FileInfo","name":"FileInfo"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/zip/writer.cr","line_number":239,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Compress/Zip/FileInfo","kind":"module","full_name":"Compress::Zip::FileInfo","name":"FileInfo"}],"namespace":{"html_id":"Crystal/Compress/Zip/Writer","kind":"class","full_name":"Compress::Zip::Writer","name":"Writer"},"doc":"An entry to write into a `Zip::Writer`.","summary":"<p>An entry to write into a <code><a href=\"../../../Compress/Zip/Writer.html\">Zip::Writer</a></code>.</p>"}]}]},{"html_id":"Crystal/Compress/Zlib","path":"Compress/Zlib.html","kind":"module","full_name":"Compress::Zlib","name":"Zlib","abstract":false,"locations":[{"filename":"src/compress/zlib/reader.cr","line_number":6,"url":null},{"filename":"src/compress/zlib/zlib.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"BEST_COMPRESSION","name":"BEST_COMPRESSION","value":"Compress::Deflate::BEST_COMPRESSION"},{"id":"BEST_SPEED","name":"BEST_SPEED","value":"Compress::Deflate::BEST_SPEED"},{"id":"DEFAULT_COMPRESSION","name":"DEFAULT_COMPRESSION","value":"Compress::Deflate::DEFAULT_COMPRESSION"},{"id":"NO_COMPRESSION","name":"NO_COMPRESSION","value":"Compress::Deflate::NO_COMPRESSION"}],"namespace":{"html_id":"Crystal/Compress","kind":"module","full_name":"Compress","name":"Compress"},"doc":"The Compress::Zlib module contains readers and writers of zlib format compressed\ndata, as specified in [RFC 1950](https://www.ietf.org/rfc/rfc1950.txt).","summary":"<p>The Compress::Zlib module contains readers and writers of zlib format compressed data, as specified in <a href=\"https://www.ietf.org/rfc/rfc1950.txt\">RFC 1950</a>.</p>","types":[{"html_id":"Crystal/Compress/Zlib/Error","path":"Compress/Zlib/Error.html","kind":"class","full_name":"Compress::Zlib::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/zlib/zlib.cr","line_number":12,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Compress/Zlib","kind":"module","full_name":"Compress::Zlib","name":"Zlib"}},{"html_id":"Crystal/Compress/Zlib/Reader","path":"Compress/Zlib/Reader.html","kind":"class","full_name":"Compress::Zlib::Reader","name":"Reader","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/zlib/reader.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"}],"namespace":{"html_id":"Crystal/Compress/Zlib","kind":"module","full_name":"Compress::Zlib","name":"Zlib"},"doc":"A read-only `IO` object to decompress data in the zlib format.\n\nInstances of this class wrap another IO object. When you read from this instance\ninstance, it reads data from the underlying IO, decompresses it, and returns\nit to the caller.","summary":"<p>A read-only <code><a href=\"../../IO.html\">IO</a></code> object to decompress data in the zlib format.</p>","class_methods":[{"html_id":"open(io:IO,sync_close=false,dict:Bytes?=nil,&)-class-method","name":"open","doc":"Creates a new reader from the given *io*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new reader from the given <em>io</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(io : IO, sync_close = false, dict : Bytes? = nil, &)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, sync_close = <span class=\"n\">false</span>, dict : <a href=\"../../Bytes.html\">Bytes</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/compress/zlib/reader.cr","line_number":25,"url":null},"def":{"name":"open","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"yields":1,"visibility":"Public","body":"reader = new(io, sync_close: sync_close, dict: dict)\nbegin\n  yield reader\nensure\n  reader.close\nend\n"}}],"constructors":[{"html_id":"new(io:IO,sync_close=false,dict:Bytes?=nil)-class-method","name":"new","doc":"Creates a new reader from the given *io*.","summary":"<p>Creates a new reader from the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(io : IO, sync_close = false, dict : Bytes? = nil)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, sync_close = <span class=\"n\">false</span>, dict : <a href=\"../../Bytes.html\">Bytes</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/compress/zlib/reader.cr","line_number":16,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, sync_close, dict)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this reader is closed.","summary":"<p>Returns <code>true</code> if this reader is closed.</p>","abstract":false,"location":{"filename":"src/compress/zlib/reader.cr","line_number":13,"url":null},"def":{"name":"closed?","visibility":"Public","body":"@closed"}},{"html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"Whether to close the enclosed `IO` when closing this reader.","summary":"<p>Whether to close the enclosed <code><a href=\"../../IO.html\">IO</a></code> when closing this reader.</p>","abstract":false,"args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","args_html":"(sync_close)","location":{"filename":"src/compress/zlib/reader.cr","line_number":10,"url":null},"def":{"name":"sync_close=","args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"visibility":"Public","body":"@sync_close = sync_close"}},{"html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"Whether to close the enclosed `IO` when closing this reader.","summary":"<p>Whether to close the enclosed <code><a href=\"../../IO.html\">IO</a></code> when closing this reader.</p>","abstract":false,"location":{"filename":"src/compress/zlib/reader.cr","line_number":10,"url":null},"def":{"name":"sync_close?","visibility":"Public","body":"@sync_close"}},{"html_id":"unbuffered_close:Nil-instance-method","name":"unbuffered_close","doc":"Closes the wrapped `IO`.","summary":"<p>Closes the wrapped <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/compress/zlib/reader.cr","line_number":92,"url":null},"def":{"name":"unbuffered_close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\n@flate_io.close\nif @sync_close\n  @io.close\nend\n"}},{"html_id":"unbuffered_flush:NoReturn-instance-method","name":"unbuffered_flush","doc":"Flushes the wrapped `IO`.","summary":"<p>Flushes the wrapped <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/compress/zlib/reader.cr","line_number":88,"url":null},"def":{"name":"unbuffered_flush","return_type":"NoReturn","visibility":"Public","body":"raise(IO::Error.new(\"Can't flush Compress::Zlib::Reader\"))"}},{"html_id":"unbuffered_read(slice:Bytes):Int32-instance-method","name":"unbuffered_read","doc":"See `IO#read`.","summary":"<p>See <code><a href=\"../../IO.html#read%28slice%3ABytes%29-instance-method\">IO#read</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Int32","args_html":"(slice : <a href=\"../../Bytes.html\">Bytes</a>) : <a href=\"../../Int32.html\">Int32</a>","location":{"filename":"src/compress/zlib/reader.cr","line_number":61,"url":null},"def":{"name":"unbuffered_read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Int32","visibility":"Public","body":"check_open\nif slice.empty?\n  return 0\nend\nif @end\n  return 0\nend\nread_bytes = @flate_io.read(slice)\nif read_bytes == 0\n  @end = true\n  @flate_io.close\n  adler32 = @io.read_bytes(UInt32, IO::ByteFormat::BigEndian)\n  if adler32 != @adler32\n    raise(Compress::Zlib::Error.new(\"ADLER-32 checksum mismatch\"))\n  end\nelse\n  @adler32 = ::Digest::Adler32.update(slice[0, read_bytes], @adler32)\nend\nread_bytes\n"}},{"html_id":"unbuffered_rewind:Nil-instance-method","name":"unbuffered_rewind","doc":"Rewinds the wrapped `IO`.","summary":"<p>Rewinds the wrapped <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/compress/zlib/reader.cr","line_number":100,"url":null},"def":{"name":"unbuffered_rewind","return_type":"Nil","visibility":"Public","body":"check_open\n@io.rewind\ninitialize(@io, @sync_close, @flate_io.dict)\n"}},{"html_id":"unbuffered_write(slice:Bytes):NoReturn-instance-method","name":"unbuffered_write","doc":"Always raises `IO::Error` because this is a read-only `IO`.","summary":"<p>Always raises <code><a href=\"../../IO/Error.html\">IO::Error</a></code> because this is a read-only <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : NoReturn","args_html":"(slice : <a href=\"../../Bytes.html\">Bytes</a>) : NoReturn","location":{"filename":"src/compress/zlib/reader.cr","line_number":84,"url":null},"def":{"name":"unbuffered_write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"NoReturn","visibility":"Public","body":"raise(IO::Error.new(\"Can't write to Compress::Zlib::Reader\"))"}}]},{"html_id":"Crystal/Compress/Zlib/Writer","path":"Compress/Zlib/Writer.html","kind":"class","full_name":"Compress::Zlib::Writer","name":"Writer","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/compress/zlib/writer.cr","line_number":8,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Compress/Zlib","kind":"module","full_name":"Compress::Zlib","name":"Zlib"},"doc":"A write-only `IO` object to compress data in the zlib format.\n\nInstances of this class wrap another IO object. When you write to this\ninstance, it compresses the data and writes it to the underlying IO.\n\nNOTE: unless created with a block, `close` must be invoked after all\ndata has been written to a Zlib::Writer instance.","summary":"<p>A write-only <code><a href=\"../../IO.html\">IO</a></code> object to compress data in the zlib format.</p>","class_methods":[{"html_id":"open(io:IO,level=Zlib::DEFAULT_COMPRESSION,sync_close=false,dict:Bytes?=nil,&)-class-method","name":"open","doc":"Creates a new writer to the given *io*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new writer to the given <em>io</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"level","default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(io : IO, level = Zlib::DEFAULT_COMPRESSION, sync_close = false, dict : Bytes? = nil, &)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, level = <span class=\"t\">Zlib</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, sync_close = <span class=\"n\">false</span>, dict : <a href=\"../../Bytes.html\">Bytes</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/compress/zlib/writer.cr","line_number":29,"url":null},"def":{"name":"open","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"level","default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"yields":1,"visibility":"Public","body":"writer = new(io, level: level, sync_close: sync_close, dict: dict)\nbegin\n  yield writer\nensure\n  writer.close\nend\n"}},{"html_id":"open(filename:String,level=Zlib::DEFAULT_COMPRESSION,dict:Bytes?=nil,&)-class-method","name":"open","doc":"Creates a new writer to the given *filename*, yields it to the given block,\nand closes it at the end.","summary":"<p>Creates a new writer to the given <em>filename</em>, yields it to the given block, and closes it at the end.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"},{"name":"level","default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(filename : String, level = Zlib::DEFAULT_COMPRESSION, dict : Bytes? = nil, &)","args_html":"(filename : <a href=\"../../String.html\">String</a>, level = <span class=\"t\">Zlib</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, dict : <a href=\"../../Bytes.html\">Bytes</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/compress/zlib/writer.cr","line_number":36,"url":null},"def":{"name":"open","args":[{"name":"filename","external_name":"filename","restriction":"String"},{"name":"level","default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"yields":1,"visibility":"Public","body":"writer = new(filename, level: level, dict: dict)\nbegin\n  yield writer\nensure\n  writer.close\nend\n"}}],"constructors":[{"html_id":"new(io:IO,level=Zlib::DEFAULT_COMPRESSION,sync_close=false,dict:Bytes?=nil)-class-method","name":"new","doc":"Creates a new writer to the given *io*.","summary":"<p>Creates a new writer to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"level","default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(io : IO, level = Zlib::DEFAULT_COMPRESSION, sync_close = false, dict : Bytes? = nil)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, level = <span class=\"t\">Zlib</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, sync_close = <span class=\"n\">false</span>, dict : <a href=\"../../Bytes.html\">Bytes</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/compress/zlib/writer.cr","line_number":16,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"level","default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, level, sync_close, dict)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(filename:String,level=Zlib::DEFAULT_COMPRESSION,dict:Bytes?=nil)-class-method","name":"new","doc":"Creates a new writer to the given *filename*.","summary":"<p>Creates a new writer to the given <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"},{"name":"level","default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"args_string":"(filename : String, level = Zlib::DEFAULT_COMPRESSION, dict : Bytes? = nil)","args_html":"(filename : <a href=\"../../String.html\">String</a>, level = <span class=\"t\">Zlib</span><span class=\"t\">::</span><span class=\"t\">DEFAULT_COMPRESSION</span>, dict : <a href=\"../../Bytes.html\">Bytes</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/compress/zlib/writer.cr","line_number":23,"url":null},"def":{"name":"new","args":[{"name":"filename","external_name":"filename","restriction":"String"},{"name":"level","default_value":"Zlib::DEFAULT_COMPRESSION","external_name":"level","restriction":""},{"name":"dict","default_value":"nil","external_name":"dict","restriction":"Bytes | ::Nil"}],"visibility":"Public","body":"new(::File.new(filename, \"w\"), level: level, sync_close: true, dict: dict)"}}],"instance_methods":[{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes this writer. Must be invoked after all data has been written.","summary":"<p>Closes this writer.</p>","abstract":false,"location":{"filename":"src/compress/zlib/writer.cr","line_number":70,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nif @wrote_header\nelse\n  write_header\nend\n@flate_io.close\n@io.write_bytes(@adler32, IO::ByteFormat::BigEndian)\nif @sync_close\n  @io.close\nend\n"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this writer is closed.","summary":"<p>Returns <code>true</code> if this writer is closed.</p>","abstract":false,"location":{"filename":"src/compress/zlib/writer.cr","line_number":13,"url":null},"def":{"name":"closed?","visibility":"Public","body":"@closed"}},{"html_id":"flush:Nil-instance-method","name":"flush","doc":"Flushes data, forcing writing the zlib header if no\ndata has been written yet.\n\nSee `IO#flush`.","summary":"<p>Flushes data, forcing writing the zlib header if no data has been written yet.</p>","abstract":false,"location":{"filename":"src/compress/zlib/writer.cr","line_number":62,"url":null},"def":{"name":"flush","return_type":"Nil","visibility":"Public","body":"check_open\nif @wrote_header\nelse\n  write_header\nend\n@flate_io.flush\n"}},{"html_id":"read(slice:Bytes):NoReturn-instance-method","name":"read","doc":"Always raises `IO::Error` because this is a write-only `IO`.","summary":"<p>Always raises <code><a href=\"../../IO/Error.html\">IO::Error</a></code> because this is a write-only <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : NoReturn","args_html":"(slice : <a href=\"../../Bytes.html\">Bytes</a>) : NoReturn","location":{"filename":"src/compress/zlib/writer.cr","line_number":42,"url":null},"def":{"name":"read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"NoReturn","visibility":"Public","body":"raise(IO::Error.new(\"Can't read from Gzip::Writer\"))"}},{"html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"Whether to close the enclosed `IO` when closing this writer.","summary":"<p>Whether to close the enclosed <code><a href=\"../../IO.html\">IO</a></code> when closing this writer.</p>","abstract":false,"args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","args_html":"(sync_close)","location":{"filename":"src/compress/zlib/writer.cr","line_number":10,"url":null},"def":{"name":"sync_close=","args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"visibility":"Public","body":"@sync_close = sync_close"}},{"html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"Whether to close the enclosed `IO` when closing this writer.","summary":"<p>Whether to close the enclosed <code><a href=\"../../IO.html\">IO</a></code> when closing this writer.</p>","abstract":false,"location":{"filename":"src/compress/zlib/writer.cr","line_number":10,"url":null},"def":{"name":"sync_close?","visibility":"Public","body":"@sync_close"}},{"html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"See `IO#write`.","summary":"<p>See <code><a href=\"../../IO.html#write%28slice%3ABytes%29%3ANil-instance-method\">IO#write</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"../../Bytes.html\">Bytes</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/compress/zlib/writer.cr","line_number":47,"url":null},"def":{"name":"write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"check_open\nif slice.empty?\n  return\nend\nif @wrote_header\nelse\n  write_header\nend\n@flate_io.write(slice)\n@adler32 = ::Digest::Adler32.update(slice, @adler32)\n"}}]}]}]},{"html_id":"Crystal/Crypto","path":"Crypto.html","kind":"module","full_name":"Crypto","name":"Crypto","abstract":false,"locations":[{"filename":"src/crypto/subtle.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"types":[{"html_id":"Crystal/Crypto/Bcrypt","path":"Crypto/Bcrypt.html","kind":"class","full_name":"Crypto::Bcrypt","name":"Bcrypt","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/crypto/bcrypt.cr","line_number":32,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"COST_RANGE","name":"COST_RANGE","value":"4..31"},{"id":"DEFAULT_COST","name":"DEFAULT_COST","value":"11"},{"id":"PASSWORD_RANGE","name":"PASSWORD_RANGE","value":"1..72"},{"id":"SALT_SIZE","name":"SALT_SIZE","value":"16"}],"namespace":{"html_id":"Crystal/Crypto","kind":"module","full_name":"Crypto","name":"Crypto"},"doc":"Pure Crystal implementation of the Bcrypt algorithm by Niels Provos and David\nMazières, as [presented at USENIX in\n1999](https://www.usenix.org/legacy/events/usenix99/provos/provos_html/index.html).\n\nThe algorithm has a maximum password length limit of 71 characters (see\n[this comment](https://security.stackexchange.com/questions/39849/does-bcrypt-have-a-maximum-password-length#answer-39851)\non stackoverflow).\n\nRefer to `Crypto::Bcrypt::Password` for a higher level interface.\n\nAbout the Cost\n\nBcrypt, like the PBKDF2 or scrypt ciphers, are designed to be slow, so\ngenerating rainbow tables or cracking passwords is nearly impossible. Yet,\ncomputers are always getting faster and faster, so the actual cost must be\nincremented every once in a while.\nAlways use the maximum cost that is tolerable, performance wise, for your\napplication. Be sure to test and select this based on your server, not your\nhome computer.\n\nThis implementation of Bcrypt is currently 50% slower than pure C solutions,\nso keep this in mind when selecting your cost. It may be wise to test with\nRuby's [bcrypt gem](https://github.com/codahale/bcrypt-ruby)\nwhich is a binding to OpenBSD's implementation.\n\nLast but not least: beware of denial of services! Always protect your\napplication using an external strategy (eg: rate limiting), otherwise\nendpoints that verifies bcrypt hashes will be an easy target.","summary":"<p>Pure Crystal implementation of the Bcrypt algorithm by Niels Provos and David Mazières, as <a href=\"https://www.usenix.org/legacy/events/usenix99/provos/provos_html/index.html\">presented at USENIX in 1999</a>.</p>","class_methods":[{"html_id":"hash_secret(password,cost=DEFAULT_COST):String-class-method","name":"hash_secret","doc":"Hashes the *password* using bcrypt algorithm using salt obtained via `Random::Secure.random_bytes(SALT_SIZE)`.\n\n```\nrequire \"crypto/bcrypt\"\n\nCrypto::Bcrypt.hash_secret \"secret\"\n```","summary":"<p>Hashes the <em>password</em> using bcrypt algorithm using salt obtained via <code><a href=\"../Random/Secure.html#random_bytes%28buf%3ABytes%29%3ANil-instance-method\">Random::Secure.random_bytes(SALT_SIZE)</a></code>.</p>","abstract":false,"args":[{"name":"password","external_name":"password","restriction":""},{"name":"cost","default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"args_string":"(password, cost = DEFAULT_COST) : String","args_html":"(password, cost = <span class=\"t\">DEFAULT_COST</span>) : <a href=\"../String.html\">String</a>","location":{"filename":"src/crypto/bcrypt.cr","line_number":57,"url":null},"def":{"name":"hash_secret","args":[{"name":"password","external_name":"password","restriction":""},{"name":"cost","default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"return_type":"String","visibility":"Public","body":"passwordb = (password.to_unsafe.to_slice(password.bytesize + 1)).clone\nsaltb = Random::Secure.random_bytes(SALT_SIZE)\n(new(passwordb, saltb, cost)).to_s\n"}}],"constructors":[{"html_id":"new(password:String,salt:String,cost=DEFAULT_COST)-class-method","name":"new","doc":"Creates a new `Crypto::Bcrypt` object from the given *password* with *salt* and *cost*.\n\n```\nrequire \"crypto/bcrypt\"\n\npassword = Crypto::Bcrypt.new \"secret\", \"salt_of_16_chars\"\npassword.digest\n```","summary":"<p>Creates a new <code><a href=\"../Crypto/Bcrypt.html\">Crypto::Bcrypt</a></code> object from the given <em>password</em> with <em>salt</em> and <em>cost</em>.</p>","abstract":false,"args":[{"name":"password","external_name":"password","restriction":"String"},{"name":"salt","external_name":"salt","restriction":"String"},{"name":"cost","default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"args_string":"(password : String, salt : String, cost = DEFAULT_COST)","args_html":"(password : <a href=\"../String.html\">String</a>, salt : <a href=\"../String.html\">String</a>, cost = <span class=\"t\">DEFAULT_COST</span>)","location":{"filename":"src/crypto/bcrypt.cr","line_number":72,"url":null},"def":{"name":"new","args":[{"name":"password","external_name":"password","restriction":"String"},{"name":"salt","external_name":"salt","restriction":"String"},{"name":"cost","default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"visibility":"Public","body":"passwordb = (password.to_unsafe.to_slice(password.bytesize + 1)).clone\nsaltb = Base64.decode(salt, SALT_SIZE)\nnew(passwordb, saltb, cost)\n"}},{"html_id":"new(password:Bytes,salt:Bytes,cost=DEFAULT_COST)-class-method","name":"new","doc":"Creates a new `Crypto::Bcrypt` object from the given *password* with *salt* in bytes and *cost*.\n\n```\nrequire \"crypto/bcrypt\"\n\npassword = Crypto::Bcrypt.new \"secret\".to_slice, \"salt_of_16_chars\".to_slice\npassword.digest\n```","summary":"<p>Creates a new <code><a href=\"../Crypto/Bcrypt.html\">Crypto::Bcrypt</a></code> object from the given <em>password</em> with <em>salt</em> in bytes and <em>cost</em>.</p>","abstract":false,"args":[{"name":"password","external_name":"password","restriction":"Bytes"},{"name":"salt","external_name":"salt","restriction":"Bytes"},{"name":"cost","default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"args_string":"(password : Bytes, salt : Bytes, cost = DEFAULT_COST)","args_html":"(password : <a href=\"../Bytes.html\">Bytes</a>, salt : <a href=\"../Bytes.html\">Bytes</a>, cost = <span class=\"t\">DEFAULT_COST</span>)","location":{"filename":"src/crypto/bcrypt.cr","line_number":91,"url":null},"def":{"name":"new","args":[{"name":"password","external_name":"password","restriction":"Bytes"},{"name":"salt","external_name":"salt","restriction":"Bytes"},{"name":"cost","default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(password, salt, cost)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"cost:Int32-instance-method","name":"cost","abstract":false,"location":{"filename":"src/crypto/bcrypt.cr","line_number":81,"url":null},"def":{"name":"cost","return_type":"Int32","visibility":"Public","body":"@cost"}},{"html_id":"digest:Bytes-instance-method","name":"digest","abstract":false,"location":{"filename":"src/crypto/bcrypt.cr","line_number":99,"url":null},"def":{"name":"digest","return_type":"Bytes","visibility":"Public","body":"@digest || (@digest = hash_password)"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/crypto/bcrypt.cr","line_number":117,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"password:Bytes-instance-method","name":"password","abstract":false,"location":{"filename":"src/crypto/bcrypt.cr","line_number":79,"url":null},"def":{"name":"password","return_type":"Bytes","visibility":"Public","body":"@password"}},{"html_id":"salt:Bytes-instance-method","name":"salt","abstract":false,"location":{"filename":"src/crypto/bcrypt.cr","line_number":80,"url":null},"def":{"name":"salt","return_type":"Bytes","visibility":"Public","body":"@salt"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a short String representation of this object\nwhich includes its class name and its object address.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).to_s # => #<Person:0x10a199f20>\n```","summary":"<p>Appends a short String representation of this object which includes its class name and its object address.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/crypto/bcrypt.cr","line_number":113,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << to_s"}},{"html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns a string representation of this object.\n\nDescendants must usually **not** override this method. Instead,\nthey must override `to_s(io)`, which must append to the given\nIO object.","summary":"<p>Returns a string representation of this object.</p>","abstract":false,"location":{"filename":"src/crypto/bcrypt.cr","line_number":105,"url":null},"def":{"name":"to_s","return_type":"String","visibility":"Public","body":"@hash || (@hash = (begin\n  salt64 = Base64.encode(salt, salt.size)\n  digest64 = Base64.encode(digest, digest.size - 1)\n  \"$2a$%02d$%s%s\" % {cost, salt64, digest64}\nend))"}},{"html_id":"to_slice(*args,**options)-instance-method","name":"to_slice","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/crypto/bcrypt.cr","line_number":121,"url":null},"def":{"name":"to_slice","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"to_s.to_slice(*args, **options)"}},{"html_id":"to_slice(*args,**options,&)-instance-method","name":"to_slice","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/crypto/bcrypt.cr","line_number":121,"url":null},"def":{"name":"to_slice","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"to_s.to_slice(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}}],"types":[{"html_id":"Crystal/Crypto/Bcrypt/Error","path":"Crypto/Bcrypt/Error.html","kind":"class","full_name":"Crypto::Bcrypt::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/crypto/bcrypt.cr","line_number":33,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crypto/Bcrypt","kind":"class","full_name":"Crypto::Bcrypt","name":"Bcrypt"}},{"html_id":"Crystal/Crypto/Bcrypt/Password","path":"Crypto/Bcrypt/Password.html","kind":"class","full_name":"Crypto::Bcrypt::Password","name":"Password","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/crypto/bcrypt/password.cr","line_number":17,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crypto/Bcrypt","kind":"class","full_name":"Crypto::Bcrypt","name":"Bcrypt"},"doc":"Generate, read and verify `Crypto::Bcrypt` hashes.\n\n```\nrequire \"crypto/bcrypt/password\"\n\npassword = Crypto::Bcrypt::Password.create(\"super secret\", cost: 10)\n# => $2a$10$rI4xRiuAN2fyiKwynO6PPuorfuoM4L2PVv6hlnVJEmNLjqcibAfHq\n\npassword.verify(\"wrong secret\") # => false\npassword.verify(\"super secret\") # => true\n```\n\nSee `Crypto::Bcrypt` for hints to select the cost when generating hashes.","summary":"<p>Generate, read and verify <code><a href=\"../../Crypto/Bcrypt.html\">Crypto::Bcrypt</a></code> hashes.</p>","constructors":[{"html_id":"create(password,cost=DEFAULT_COST):self-class-method","name":"create","doc":"Hashes a password.\n\n```\nrequire \"crypto/bcrypt/password\"\n\npassword = Crypto::Bcrypt::Password.create(\"super secret\", cost: 10)\n# => $2a$10$rI4xRiuAN2fyiKwynO6PPuorfuoM4L2PVv6hlnVJEmNLjqcibAfHq\n```","summary":"<p>Hashes a password.</p>","abstract":false,"args":[{"name":"password","external_name":"password","restriction":""},{"name":"cost","default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"args_string":"(password, cost = DEFAULT_COST) : self","args_html":"(password, cost = <span class=\"t\">DEFAULT_COST</span>) : <span class=\"k\">self</span>","location":{"filename":"src/crypto/bcrypt/password.cr","line_number":26,"url":null},"def":{"name":"create","args":[{"name":"password","external_name":"password","restriction":""},{"name":"cost","default_value":"DEFAULT_COST","external_name":"cost","restriction":""}],"return_type":"self","visibility":"Public","body":"new((Bcrypt.hash_secret(password, cost)).to_s)"}},{"html_id":"new(raw_hash:String)-class-method","name":"new","doc":"Loads a bcrypt hash.\n\n```\nrequire \"crypto/bcrypt/password\"\n\npassword = Crypto::Bcrypt::Password.new(\"$2a$10$X6rw/jDiLBuzHV./JjBNXe8/Po4wTL0fhdDNdAdjcKN/Fup8tGCya\")\npassword.version # => \"2a\"\npassword.salt    # => \"X6rw/jDiLBuzHV./JjBNXe\"\npassword.digest  # => \"8/Po4wTL0fhdDNdAdjcKN/Fup8tGCya\"\n```","summary":"<p>Loads a bcrypt hash.</p>","abstract":false,"args":[{"name":"raw_hash","external_name":"raw_hash","restriction":"String"}],"args_string":"(raw_hash : String)","args_html":"(raw_hash : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/crypto/bcrypt/password.cr","line_number":45,"url":null},"def":{"name":"new","args":[{"name":"raw_hash","external_name":"raw_hash","restriction":"String"}],"visibility":"Public","body":"_ = allocate\n_.initialize(raw_hash)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"cost:Int32-instance-method","name":"cost","abstract":false,"location":{"filename":"src/crypto/bcrypt/password.cr","line_number":31,"url":null},"def":{"name":"cost","return_type":"Int32","visibility":"Public","body":"@cost"}},{"html_id":"digest:String-instance-method","name":"digest","abstract":false,"location":{"filename":"src/crypto/bcrypt/password.cr","line_number":33,"url":null},"def":{"name":"digest","return_type":"String","visibility":"Public","body":"@digest"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../../IO.html\">IO</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/crypto/bcrypt/password.cr","line_number":77,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"salt:String-instance-method","name":"salt","abstract":false,"location":{"filename":"src/crypto/bcrypt/password.cr","line_number":32,"url":null},"def":{"name":"salt","return_type":"String","visibility":"Public","body":"@salt"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a short String representation of this object\nwhich includes its class name and its object address.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).to_s # => #<Person:0x10a199f20>\n```","summary":"<p>Appends a short String representation of this object which includes its class name and its object address.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../../IO.html\">IO</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/crypto/bcrypt/password.cr","line_number":73,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << @raw_hash"}},{"html_id":"verify(password:String):Bool-instance-method","name":"verify","doc":"Verifies a password against the hash.\n\n```\nrequire \"crypto/bcrypt/password\"\n\npassword = Crypto::Bcrypt::Password.create(\"super secret\")\npassword.verify(\"wrong secret\") # => false\npassword.verify(\"super secret\") # => true\n```","summary":"<p>Verifies a password against the hash.</p>","abstract":false,"args":[{"name":"password","external_name":"password","restriction":"String"}],"args_string":"(password : String) : Bool","args_html":"(password : <a href=\"../../String.html\">String</a>) : <a href=\"../../Bool.html\">Bool</a>","location":{"filename":"src/crypto/bcrypt/password.cr","line_number":68,"url":null},"def":{"name":"verify","args":[{"name":"password","external_name":"password","restriction":"String"}],"return_type":"Bool","visibility":"Public","body":"hashed_password = Bcrypt.new(password, salt, cost)\nCrypto::Subtle.constant_time_compare(@raw_hash, hashed_password)\n"}},{"html_id":"version:String-instance-method","name":"version","abstract":false,"location":{"filename":"src/crypto/bcrypt/password.cr","line_number":30,"url":null},"def":{"name":"version","return_type":"String","visibility":"Public","body":"@version"}}]}]},{"html_id":"Crystal/Crypto/Blowfish","path":"Crypto/Blowfish.html","kind":"class","full_name":"Crypto::Blowfish","name":"Blowfish","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/crypto/blowfish.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"DEFAULT_ROUNDS","name":"DEFAULT_ROUNDS","value":"16"}],"namespace":{"html_id":"Crystal/Crypto","kind":"module","full_name":"Crypto","name":"Crypto"},"constructors":[{"html_id":"new(rounds=DEFAULT_ROUNDS)-class-method","name":"new","abstract":false,"args":[{"name":"rounds","default_value":"DEFAULT_ROUNDS","external_name":"rounds","restriction":""}],"args_string":"(rounds = DEFAULT_ROUNDS)","args_html":"(rounds = <span class=\"t\">DEFAULT_ROUNDS</span>)","location":{"filename":"src/crypto/blowfish.cr","line_number":10,"url":null},"def":{"name":"new","args":[{"name":"rounds","default_value":"DEFAULT_ROUNDS","external_name":"rounds","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(rounds)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"decrypt_pair(l:UInt32,r:UInt32):Tuple(UInt32,UInt32)-instance-method","name":"decrypt_pair","abstract":false,"args":[{"name":"l","external_name":"l","restriction":"UInt32"},{"name":"r","external_name":"r","restriction":"UInt32"}],"args_string":"(l : UInt32, r : UInt32) : Tuple(UInt32, UInt32)","args_html":"(l : <a href=\"../UInt32.html\">UInt32</a>, r : <a href=\"../UInt32.html\">UInt32</a>) : <a href=\"../Tuple.html\">Tuple</a>(<a href=\"../UInt32.html\">UInt32</a>, <a href=\"../UInt32.html\">UInt32</a>)","location":{"filename":"src/crypto/blowfish.cr","line_number":55,"url":null},"def":{"name":"decrypt_pair","args":[{"name":"l","external_name":"l","restriction":"UInt32"},{"name":"r","external_name":"r","restriction":"UInt32"}],"return_type":"::Tuple(UInt32, UInt32)","visibility":"Public","body":"(@rounds + 1).downto(2) do |i|\n  l = l ^ @p.to_unsafe[i]\n  r = r ^ (f(l))\n  l, r = r, l\nend\nl, r = r, l\nr = r ^ @p.to_unsafe[1]\nl = l ^ @p.to_unsafe[0]\n{l, r}\n"}},{"html_id":"encrypt_pair(l:UInt32,r:UInt32)-instance-method","name":"encrypt_pair","abstract":false,"args":[{"name":"l","external_name":"l","restriction":"UInt32"},{"name":"r","external_name":"r","restriction":"UInt32"}],"args_string":"(l : UInt32, r : UInt32)","args_html":"(l : <a href=\"../UInt32.html\">UInt32</a>, r : <a href=\"../UInt32.html\">UInt32</a>)","location":{"filename":"src/crypto/blowfish.cr","line_number":40,"url":null},"def":{"name":"encrypt_pair","args":[{"name":"l","external_name":"l","restriction":"UInt32"},{"name":"r","external_name":"r","restriction":"UInt32"}],"visibility":"Public","body":"0.upto(@rounds - 1) do |i|\n  l = l ^ @p.to_unsafe[i]\n  r = r ^ (f(l))\n  l, r = r, l\nend\nl, r = r, l\nr = r ^ @p.to_unsafe[@rounds]\nl = l ^ @p.to_unsafe[@rounds + 1]\n{l, r}\n"}},{"html_id":"expand_key(key):Nil-instance-method","name":"expand_key","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key) : Nil","args_html":"(key) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/crypto/blowfish.cr","line_number":18,"url":null},"def":{"name":"expand_key","args":[{"name":"key","external_name":"key","restriction":""}],"return_type":"Nil","visibility":"Public","body":"pos = 0\n0.upto(17) do |i|\n  __temp_43 = i\n  __temp_44 = @p.to_unsafe\n  __temp_44[__temp_43] = __temp_44[__temp_43] ^ (next_word(key, pointerof(pos)))\nend\nl, r = 0_u32, 0_u32\n(0..17).step(2) do |i|\n  l, r = encrypt_pair(l, r)\n  @p.to_unsafe[i] = l\n  @p.to_unsafe[i + 1] = r\nend\n(0..1023).step(2) do |i|\n  l, r = encrypt_pair(l, r)\n  @s.to_unsafe[i] = l\n  @s.to_unsafe[i + 1] = r\nend\n"}}]},{"html_id":"Crystal/Crypto/Subtle","path":"Crypto/Subtle.html","kind":"module","full_name":"Crypto::Subtle","name":"Subtle","abstract":false,"locations":[{"filename":"src/crypto/subtle.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crypto","kind":"module","full_name":"Crypto","name":"Crypto"},"class_methods":[{"html_id":"constant_time_byte_eq(x,y)-class-method","name":"constant_time_byte_eq","abstract":false,"args":[{"name":"x","external_name":"x","restriction":""},{"name":"y","external_name":"y","restriction":""}],"args_string":"(x, y)","args_html":"(x, y)","location":{"filename":"src/crypto/subtle.cr","line_number":26,"url":null},"def":{"name":"constant_time_byte_eq","args":[{"name":"x","external_name":"x","restriction":""},{"name":"y","external_name":"y","restriction":""}],"visibility":"Public","body":"z = ~(x ^ y)\nz = z & (z >> 4)\nz = z & (z >> 2)\nz = z & (z >> 1)\nz\n"}},{"html_id":"constant_time_compare(x,y):Bool-class-method","name":"constant_time_compare","doc":"Compares *x* and *y* in constant time and returns `true` if they are the same, and `false` if they are not.\n\n```\nrequire \"crypto/subtle\"\n\nCrypto::Subtle.constant_time_compare(\"foo\", \"bar\") # => false\nCrypto::Subtle.constant_time_compare(\"foo\", \"foo\") # => true\n```\n\nNOTE: *x* and *y* must be able to respond to `to_slice`.","summary":"<p>Compares <em>x</em> and <em>y</em> in constant time and returns <code>true</code> if they are the same, and <code>false</code> if they are not.</p>","abstract":false,"args":[{"name":"x","external_name":"x","restriction":""},{"name":"y","external_name":"y","restriction":""}],"args_string":"(x, y) : Bool","args_html":"(x, y) : <a href=\"../Bool.html\">Bool</a>","location":{"filename":"src/crypto/subtle.cr","line_number":12,"url":null},"def":{"name":"constant_time_compare","args":[{"name":"x","external_name":"x","restriction":""},{"name":"y","external_name":"y","restriction":""}],"return_type":"Bool","visibility":"Public","body":"x = x.to_slice\ny = y.to_slice\nif x.size != y.size\n  return false\nend\nv = 0_u8\nx.size.times do |i|\n  v = v | (x[i] ^ y[i])\nend\n(constant_time_byte_eq(v, 0)) == 1\n"}}]}]},{"html_id":"Crystal/Crystal","path":"Crystal.html","kind":"module","full_name":"Crystal","name":"Crystal","abstract":false,"locations":[{"filename":"src/crystal/datum.cr","line_number":1,"url":null},{"filename":"src/crystal/dwarf.cr","line_number":6,"url":null},{"filename":"src/crystal/dwarf/abbrev.cr","line_number":3,"url":null},{"filename":"src/crystal/dwarf/info.cr","line_number":4,"url":null},{"filename":"src/crystal/dwarf/line_numbers.cr","line_number":1,"url":null},{"filename":"src/crystal/dwarf/strings.cr","line_number":1,"url":null},{"filename":"src/crystal/elf.cr","line_number":1,"url":null},{"filename":"src/crystal/main.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"BUILD_COMMIT","name":"BUILD_COMMIT","value":"nil"},{"id":"BUILD_DATE","name":"BUILD_DATE","value":"\"2022-01-07\""},{"id":"CACHE_DIR","name":"CACHE_DIR","value":"\"/tmp/crystal\""},{"id":"DEFAULT_PATH","name":"DEFAULT_PATH","value":"\"lib:/usr/lib/crystal\""},{"id":"DESCRIPTION","name":"DESCRIPTION","value":"\"Crystal 1.3.0 (2022-01-07)\\n\\nLLVM: 13.0.0\\nDefault target: x86_64-pc-linux-gnu\""},{"id":"LIBRARY_PATH","name":"LIBRARY_PATH","value":"\"/usr/bin/../lib/crystal\""},{"id":"LLVM_VERSION","name":"LLVM_VERSION","value":"\"13.0.0\""},{"id":"PATH","name":"PATH","value":"\"lib:/build/crystal/src/crystal-1.3.0/src\""},{"id":"VERSION","name":"VERSION","value":"\"1.3.0\""}],"class_methods":[{"html_id":"main(&)-class-method","name":"main","doc":"Defines the main routine run by normal Crystal programs:\n\n- Initializes the GC\n- Invokes the given *block*\n- Handles unhandled exceptions\n- Invokes `at_exit` handlers\n- Flushes `STDOUT` and `STDERR`\n\nThis method can be invoked if you need to define a custom\nmain (as in C main) function, doing all the above steps.\n\nFor example:\n\n```\nfun main(argc : Int32, argv : UInt8**) : Int32\n  Crystal.main do\n    elapsed = Time.measure do\n      Crystal.main_user_code(argc, argv)\n    end\n    puts \"Time to execute program: #{elapsed}\"\n  end\nend\n```\n\nNote that the above is really just an example, almost the\nsame can be accomplished with `at_exit`. But in some cases\nredefinition of C's main is needed.","summary":"<p>Defines the main routine run by normal Crystal programs:</p>","abstract":false,"location":{"filename":"src/crystal/main.cr","line_number":34,"url":null},"def":{"name":"main","yields":0,"visibility":"Public","body":"GC.init\nstatus = begin\n  yield\n  0\nrescue ex\n  1\nend\nexit(status, ex)\n"}},{"html_id":"main(argc:Int32,argv:Pointer(Pointer(UInt8)))-class-method","name":"main","doc":"Main method run by all Crystal programs at startup.\n\nThis setups up the GC, invokes your program, rescuing\nany handled exception, and then runs `at_exit` handlers.\n\nThis method is automatically invoked for you, so you\ndon't need to invoke it.\n\nHowever, if you need to define a special main C function,\nyou can redefine main and invoke `Crystal.main` from it:\n\n```\nfun main(argc : Int32, argv : UInt8**) : Int32\n  # some setup before Crystal main\n  Crystal.main(argc, argv)\n  # some cleanup logic after Crystal main\nend\n```\n\nThe `Crystal.main` can also be passed as a callback:\n\n```\nfun main(argc : Int32, argv : UInt8**) : Int32\n  LibFoo.init_foo_and_invoke_main(argc, argv, ->Crystal.main(Int32, UInt8**))\nend\n```\n\nNote that before `Crystal.main` is invoked the GC\nis not setup yet, so nothing that allocates memory\nin Crystal (like `new` for classes) can be used.","summary":"<p>Main method run by all Crystal programs at startup.</p>","abstract":false,"args":[{"name":"argc","external_name":"argc","restriction":"Int32"},{"name":"argv","external_name":"argv","restriction":"::Pointer(::Pointer(UInt8))"}],"args_string":"(argc : Int32, argv : Pointer(Pointer(UInt8)))","args_html":"(argc : <a href=\"Int32.html\">Int32</a>, argv : <a href=\"Pointer.html\">Pointer</a>(<a href=\"Pointer.html\">Pointer</a>(<a href=\"UInt8.html\">UInt8</a>)))","location":{"filename":"src/crystal/main.cr","line_number":99,"url":null},"def":{"name":"main","args":[{"name":"argc","external_name":"argc","restriction":"Int32"},{"name":"argv","external_name":"argv","restriction":"::Pointer(::Pointer(UInt8))"}],"visibility":"Public","body":"begin\n  main do\n    main_user_code(argc, argv)\n  end\nrescue ex\n  Crystal::System.print_exception(\"Unhandled exception\", ex)\n  1\nend"}},{"html_id":"main_user_code(argc:Int32,argv:Pointer(Pointer(UInt8)))-class-method","name":"main_user_code","doc":"Executes the main user code. This normally is executed\nafter initializing the GC and before executing `at_exit` handlers.\n\nYou should never invoke this method unless you need to\nredefine C's main function. See `Crystal.main` for\nmore details.","summary":"<p>Executes the main user code.</p>","abstract":false,"args":[{"name":"argc","external_name":"argc","restriction":"Int32"},{"name":"argv","external_name":"argv","restriction":"::Pointer(::Pointer(UInt8))"}],"args_string":"(argc : Int32, argv : Pointer(Pointer(UInt8)))","args_html":"(argc : <a href=\"Int32.html\">Int32</a>, argv : <a href=\"Pointer.html\">Pointer</a>(<a href=\"Pointer.html\">Pointer</a>(<a href=\"UInt8.html\">UInt8</a>)))","location":{"filename":"src/crystal/main.cr","line_number":114,"url":null},"def":{"name":"main_user_code","args":[{"name":"argc","external_name":"argc","restriction":"Int32"},{"name":"argv","external_name":"argv","restriction":"::Pointer(::Pointer(UInt8))"}],"visibility":"Public","body":"LibCrystalMain.__crystal_main(argc, argv)"}}],"types":[{"html_id":"Crystal/Crystal/Macros","path":"Crystal/Macros.html","kind":"module","full_name":"Crystal::Macros","name":"Macros","abstract":false,"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":114,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal","kind":"module","full_name":"Crystal","name":"Crystal"},"doc":"The `Macros` module is a fictitious module used to document macros\nand macro methods.\n\nYou can invoke a **fixed subset** of methods on AST nodes at compile-time. These methods\nare documented on the classes in this module. Additionally, methods of the\n`Macros` module are top-level methods that you can invoke, like `puts` and `run`.","summary":"<p>The <code><a href=\"../Crystal/Macros.html\">Macros</a></code> module is a fictitious module used to document macros and macro methods.</p>","instance_methods":[{"html_id":"`(command):MacroId-instance-method","name":"`","doc":"Executes a system command and returns the output as a `MacroId`.\nGives a compile-time error if the command failed to execute.\n\nIt is impossible to call this method with any regular call syntax. There is an associated literal type which calls the method with the literal content as command:\n\n```\n{{ `echo hi` }} # => \"hi\\n\"\n```\n\nSee [`Command` literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/command.html) in the language reference.","summary":"<p>Executes a system command and returns the output as a <code><a href=\"../Crystal/Macros/MacroId.html\">MacroId</a></code>.</p>","abstract":false,"args":[{"name":"command","external_name":"command","restriction":""}],"args_string":"(command) : MacroId","args_html":"(command) : <a href=\"../Crystal/Macros/MacroId.html\">MacroId</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":186,"url":null},"def":{"name":"`","args":[{"name":"command","external_name":"command","restriction":""}],"return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"compare_versions(v1:StringLiteral,v2:StringLiteral):NumberLiteral-instance-method","name":"compare_versions","doc":"Compares two [semantic versions](http://semver.org/).\n\nReturns `-1`, `0` or `1` depending on whether *v1* is lower than *v2*,\nequal to *v2* or greater than *v2*.\n\n```\n{{ compare_versions(\"1.10.0\", \"1.2.0\") }} # => 1\n```","summary":"<p>Compares two <a href=\"http://semver.org/\">semantic versions</a>.</p>","abstract":false,"args":[{"name":"v1","external_name":"v1","restriction":"StringLiteral"},{"name":"v2","external_name":"v2","restriction":"StringLiteral"}],"args_string":"(v1 : StringLiteral, v2 : StringLiteral) : NumberLiteral","args_html":"(v1 : <a href=\"../Crystal/Macros/StringLiteral.html\">StringLiteral</a>, v2 : <a href=\"../Crystal/Macros/StringLiteral.html\">StringLiteral</a>) : <a href=\"../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":123,"url":null},"def":{"name":"compare_versions","args":[{"name":"v1","external_name":"v1","restriction":"StringLiteral"},{"name":"v2","external_name":"v2","restriction":"StringLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"debug(format=true):Nop-instance-method","name":"debug","doc":"Outputs the current macro's buffer to the standard output. Useful for debugging\na macro to see what's being generated.\n\nBy default, the output is tried to be formatted using Crystal's\nformatter, but you can disable this by passing `false` to this method.","summary":"<p>Outputs the current macro's buffer to the standard output.</p>","abstract":false,"args":[{"name":"format","default_value":"true","external_name":"format","restriction":""}],"args_string":"(format = true) : Nop","args_html":"(format = <span class=\"n\">true</span>) : <a href=\"../Crystal/Macros/Nop.html\">Nop</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":131,"url":null},"def":{"name":"debug","args":[{"name":"format","default_value":"true","external_name":"format","restriction":""}],"return_type":"Nop","visibility":"Public","body":""}},{"html_id":"env(name):StringLiteral|NilLiteral-instance-method","name":"env","doc":"Gets the value of an environment variable at compile-time, or `nil` if it doesn't exist.","summary":"<p>Gets the value of an environment variable at compile-time, or <code>nil</code> if it doesn't exist.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name) : StringLiteral | NilLiteral","args_html":"(name) : <a href=\"../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../Crystal/Macros/NilLiteral.html\">NilLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":135,"url":null},"def":{"name":"env","args":[{"name":"name","external_name":"name","restriction":""}],"return_type":"StringLiteral | NilLiteral","visibility":"Public","body":""}},{"html_id":"file_exists?(filename):BoolLiteral-instance-method","name":"file_exists?","doc":"Returns `true` if the given *filename* exists, `false` otherwise.","summary":"<p>Returns <code>true</code> if the given <em>filename</em> exists, <code>false</code> otherwise.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":""}],"args_string":"(filename) : BoolLiteral","args_html":"(filename) : <a href=\"../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":198,"url":null},"def":{"name":"file_exists?","args":[{"name":"filename","external_name":"filename","restriction":""}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"flag?(name):BoolLiteral-instance-method","name":"flag?","doc":"Returns whether a [compile-time flag](https://crystal-lang.org/docs/syntax_and_semantics/compile_time_flags.html) is set.\n\n```\n{{ flag?(:x86_64) }} # true or false\n```","summary":"<p>Returns whether a <a href=\"https://crystal-lang.org/docs/syntax_and_semantics/compile_time_flags.html\">compile-time flag</a> is set.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name) : BoolLiteral","args_html":"(name) : <a href=\"../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":143,"url":null},"def":{"name":"flag?","args":[{"name":"name","external_name":"name","restriction":""}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"host_flag?(name):BoolLiteral-instance-method","name":"host_flag?","doc":"Returns whether a [compile-time flag](https://crystal-lang.org/docs/syntax_and_semantics/compile_time_flags.html)\nis set for the *host* platform, which can differ from the target platform\n(`flag?`) during cross-compilation.\n\n```\n{{ host_flag?(:win32) }} # true or false\n```","summary":"<p>Returns whether a <a href=\"https://crystal-lang.org/docs/syntax_and_semantics/compile_time_flags.html\">compile-time flag</a> is set for the <em>host</em> platform, which can differ from the target platform (<code><a href=\"../Crystal/Macros.html#flag%3F%28name%29%3ABoolLiteral-instance-method\">#flag?</a></code>) during cross-compilation.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name) : BoolLiteral","args_html":"(name) : <a href=\"../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":153,"url":null},"def":{"name":"host_flag?","args":[{"name":"name","external_name":"name","restriction":""}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"p(*expressions):Nop-instance-method","name":"p","doc":"Same as `puts`.","summary":"<p>Same as <code><a href=\"../Crystal/Macros.html#puts%28%2Aexpressions%29%3ANop-instance-method\">#puts</a></code>.</p>","abstract":false,"args":[{"name":"expressions","external_name":"expressions","restriction":""}],"args_string":"(*expressions) : Nop","args_html":"(*expressions) : <a href=\"../Crystal/Macros/Nop.html\">Nop</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":161,"url":null},"def":{"name":"p","args":[{"name":"expressions","external_name":"expressions","restriction":""}],"splat_index":0,"return_type":"Nop","visibility":"Public","body":""}},{"html_id":"p!(*expressions):Nop-instance-method","name":"p!","doc":"Prints macro expressions together with their values at compile-time. Useful for debugging macros.","summary":"<p>Prints macro expressions together with their values at compile-time.</p>","abstract":false,"args":[{"name":"expressions","external_name":"expressions","restriction":""}],"args_string":"(*expressions) : Nop","args_html":"(*expressions) : <a href=\"../Crystal/Macros/Nop.html\">Nop</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":169,"url":null},"def":{"name":"p!","args":[{"name":"expressions","external_name":"expressions","restriction":""}],"splat_index":0,"return_type":"Nop","visibility":"Public","body":""}},{"html_id":"pp(*expressions):Nop-instance-method","name":"pp","doc":"Same as `puts`.","summary":"<p>Same as <code><a href=\"../Crystal/Macros.html#puts%28%2Aexpressions%29%3ANop-instance-method\">#puts</a></code>.</p>","abstract":false,"args":[{"name":"expressions","external_name":"expressions","restriction":""}],"args_string":"(*expressions) : Nop","args_html":"(*expressions) : <a href=\"../Crystal/Macros/Nop.html\">Nop</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":165,"url":null},"def":{"name":"pp","args":[{"name":"expressions","external_name":"expressions","restriction":""}],"splat_index":0,"return_type":"Nop","visibility":"Public","body":""}},{"html_id":"pp!(*expressions):Nop-instance-method","name":"pp!","doc":"Same as `p!`","summary":"<p>Same as <code><a href=\"../Crystal/Macros.html#p%21%28%2Aexpressions%29%3ANop-instance-method\">#p!</a></code></p>","abstract":false,"args":[{"name":"expressions","external_name":"expressions","restriction":""}],"args_string":"(*expressions) : Nop","args_html":"(*expressions) : <a href=\"../Crystal/Macros/Nop.html\">Nop</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":173,"url":null},"def":{"name":"pp!","args":[{"name":"expressions","external_name":"expressions","restriction":""}],"splat_index":0,"return_type":"Nop","visibility":"Public","body":""}},{"html_id":"puts(*expressions):Nop-instance-method","name":"puts","doc":"Prints AST nodes at compile-time. Useful for debugging macros.","summary":"<p>Prints AST nodes at compile-time.</p>","abstract":false,"args":[{"name":"expressions","external_name":"expressions","restriction":""}],"args_string":"(*expressions) : Nop","args_html":"(*expressions) : <a href=\"../Crystal/Macros/Nop.html\">Nop</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":157,"url":null},"def":{"name":"puts","args":[{"name":"expressions","external_name":"expressions","restriction":""}],"splat_index":0,"return_type":"Nop","visibility":"Public","body":""}},{"html_id":"raise(message):NoReturn-instance-method","name":"raise","doc":"Gives a compile-time error with the given *message*.","summary":"<p>Gives a compile-time error with the given <em>message</em>.</p>","abstract":false,"args":[{"name":"message","external_name":"message","restriction":""}],"args_string":"(message) : NoReturn","args_html":"(message) : NoReturn","location":{"filename":"src/compiler/crystal/macros.cr","line_number":194,"url":null},"def":{"name":"raise","args":[{"name":"message","external_name":"message","restriction":""}],"return_type":"NoReturn","visibility":"Public","body":""}},{"html_id":"read_file(filename):StringLiteral-instance-method","name":"read_file","doc":"Reads a file and returns a `StringLiteral` with its contents.\n\nGives a compile-time error if the file doesn't exist or if\nreading the file fails.\n\nTo read a file relative to where the macro is defined, use:\n\n```\nread_file(\"#{__DIR__}/some_file.txt\")\n```\n\nNOTE: Relative paths are resolved to the current working directory.","summary":"<p>Reads a file and returns a <code><a href=\"../Crystal/Macros/StringLiteral.html\">StringLiteral</a></code> with its contents.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":""}],"args_string":"(filename) : StringLiteral","args_html":"(filename) : <a href=\"../Crystal/Macros/StringLiteral.html\">StringLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":213,"url":null},"def":{"name":"read_file","args":[{"name":"filename","external_name":"filename","restriction":""}],"return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"read_file?(filename):StringLiteral|NilLiteral-instance-method","name":"read_file?","doc":"Same as `read_file`, except that `nil` is returned on any I/O failure\ninstead of issuing a compile-time failure.","summary":"<p>Same as <code><a href=\"../Crystal/Macros.html#read_file%28filename%29%3AStringLiteral-instance-method\">#read_file</a></code>, except that <code>nil</code> is returned on any I/O failure instead of issuing a compile-time failure.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":""}],"args_string":"(filename) : StringLiteral | NilLiteral","args_html":"(filename) : <a href=\"../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../Crystal/Macros/NilLiteral.html\">NilLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":218,"url":null},"def":{"name":"read_file?","args":[{"name":"filename","external_name":"filename","restriction":""}],"return_type":"StringLiteral | NilLiteral","visibility":"Public","body":""}},{"html_id":"run(filename,*args):MacroId-instance-method","name":"run","doc":"Compiles and execute a Crystal program and returns its output\nas a `MacroId`.\n\nThe file denoted by *filename* must be a valid Crystal program.\nThis macro invocation passes *args* to the program as regular\nprogram arguments. The program must output a valid Crystal expression.\nThis output is the result of this macro invocation, as a `MacroId`.\n\nThe `run` macro is useful when the subset of available macro methods\nare not enough for your purposes and you need something more powerful.\nWith `run` you can read files at compile time, connect to the internet\nor to a database.\n\nA simple example:\n\n```\n# read.cr\nputs File.read(ARGV[0])\n```\n\n```\n# main.cr\nmacro read_file_at_compile_time(filename)\n  {{ run(\"./read\", filename).stringify }}\nend\n\nputs read_file_at_compile_time(\"some_file.txt\")\n```\n\nThe above generates a program that will have the contents of `some_file.txt`.\nThe file, however, is read at compile time and will not be needed at runtime.\n\nNOTE: the compiler is allowed to cache the executable generated for\n*filename* and only recompile it if any of the files it depends on changes\n(their modified time). This is why it's **strongly discouraged** to use a program\nfor `run` that changes in subsequent compilations (for example, if it executes\nshell commands at compile time, or other macro run programs). It's also strongly\ndiscouraged to have a macro run program take a lot of time, because this will\nslow down compilation times. Reading files is OK, opening an HTTP connection\nat compile-time will most likely result in very slow compilations.","summary":"<p>Compiles and execute a Crystal program and returns its output as a <code><a href=\"../Crystal/Macros/MacroId.html\">MacroId</a></code>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":""},{"name":"args","external_name":"args","restriction":""}],"args_string":"(filename, *args) : MacroId","args_html":"(filename, *args) : <a href=\"../Crystal/Macros/MacroId.html\">MacroId</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":261,"url":null},"def":{"name":"run","args":[{"name":"filename","external_name":"filename","restriction":""},{"name":"args","external_name":"args","restriction":""}],"splat_index":1,"return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"skip_file:Nop-instance-method","name":"skip_file","doc":"Skips the rest of the file from which it is executed.\nTypical usage is to skip files that have platform specific code,\nwithout having to surround the most relevant code in `{% if flag?(...) %} ... {% end %}` macro blocks.\n\nExample:\n\n```\n# sth_for_osx.cr\n{% skip_file unless flag?(:darwin) %}\n\n# Class FooForMac will only be defined if we're compiling on OS X\nclass FooForMac\nend\n```","summary":"<p>Skips the rest of the file from which it is executed.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":278,"url":null},"def":{"name":"skip_file","return_type":"Nop","visibility":"Public","body":""}},{"html_id":"system(command):MacroId-instance-method","name":"system","doc":"Executes a system command and returns the output as a `MacroId`.\nGives a compile-time error if the command failed to execute.\n\nIt is impossible to call this method with any regular call syntax. There is an associated literal type which calls the method with the literal content as command:\n\n```\n{{ `echo hi` }} # => \"hi\\n\"\n```\n\nSee [`Command` literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/command.html) in the language reference.","summary":"<p>Executes a system command and returns the output as a <code><a href=\"../Crystal/Macros/MacroId.html\">MacroId</a></code>.</p>","abstract":false,"args":[{"name":"command","external_name":"command","restriction":""}],"args_string":"(command) : MacroId","args_html":"(command) : <a href=\"../Crystal/Macros/MacroId.html\">MacroId</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":190,"url":null},"def":{"name":"system","args":[{"name":"command","external_name":"command","restriction":""}],"return_type":"MacroId","visibility":"Public","body":""}}],"types":[{"html_id":"Crystal/Crystal/Macros/And","path":"Crystal/Macros/And.html","kind":"class","full_name":"Crystal::Macros::And","name":"And","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/BinaryOp","kind":"class","full_name":"Crystal::Macros::BinaryOp","name":"BinaryOp"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/BinaryOp","kind":"class","full_name":"Crystal::Macros::BinaryOp","name":"BinaryOp"},{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1074,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An `&&` (and) expression","summary":"<p>An <code>&&</code> (and) expression</p>"},{"html_id":"Crystal/Crystal/Macros/Annotation","path":"Crystal/Macros/Annotation.html","kind":"class","full_name":"Crystal::Macros::Annotation","name":"Annotation","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":890,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An annotation on top of a type or variable.","summary":"<p>An annotation on top of a type or variable.</p>","instance_methods":[{"html_id":"[](index:NumberLiteral):ASTNode-instance-method","name":"[]","doc":"Returns the value of a positional argument,\nor NilLiteral if out of bounds.","summary":"<p>Returns the value of a positional argument, or NilLiteral if out of bounds.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"NumberLiteral"}],"args_string":"(index : NumberLiteral) : ASTNode","args_html":"(index : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":897,"url":null},"def":{"name":"[]","args":[{"name":"index","external_name":"index","restriction":"NumberLiteral"}],"return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"[](name:SymbolLiteral|StringLiteral|MacroId):ASTNode-instance-method","name":"[]","doc":"Returns the value of a named argument,\nor NilLiteral if the named argument isn't\nused on `self`.","summary":"<p>Returns the value of a named argument, or NilLiteral if the named argument isn't used on <code>self</code>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"SymbolLiteral | StringLiteral | MacroId"}],"args_string":"(name : SymbolLiteral | StringLiteral | MacroId) : ASTNode","args_html":"(name : <a href=\"../../Crystal/Macros/SymbolLiteral.html\">SymbolLiteral</a> | <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>) : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":903,"url":null},"def":{"name":"[]","args":[{"name":"name","external_name":"name","restriction":"SymbolLiteral | StringLiteral | MacroId"}],"return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"args:TupleLiteral-instance-method","name":"args","doc":"Returns a `TupleLiteral` representing the positional arguments on `self`.","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/TupleLiteral.html\">TupleLiteral</a></code> representing the positional arguments on <code>self</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":907,"url":null},"def":{"name":"args","return_type":"TupleLiteral","visibility":"Public","body":""}},{"html_id":"name:Path-instance-method","name":"name","doc":"Returns the name of this annotation.","summary":"<p>Returns the name of this annotation.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":892,"url":null},"def":{"name":"name","return_type":"Path","visibility":"Public","body":""}},{"html_id":"named_args:NamedTupleLiteral-instance-method","name":"named_args","doc":"Returns a `NamedTupleLiteral` representing the named arguments on `self`.","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/NamedTupleLiteral.html\">NamedTupleLiteral</a></code> representing the named arguments on <code>self</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":911,"url":null},"def":{"name":"named_args","return_type":"NamedTupleLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Arg","path":"Crystal/Macros/Arg.html","kind":"class","full_name":"Crystal::Macros::Arg","name":"Arg","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1082,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A def argument.","summary":"<p>A def argument.</p>","instance_methods":[{"html_id":"default_value:ASTNode|Nop-instance-method","name":"default_value","doc":"Returns the default value of this argument, if any.","summary":"<p>Returns the default value of this argument, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1096,"url":null},"def":{"name":"default_value","return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"html_id":"internal_name:MacroId-instance-method","name":"internal_name","doc":"Returns the internal name of this argument.\n\nFor example, for `def write(to file)` returns `file`.","summary":"<p>Returns the internal name of this argument.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1092,"url":null},"def":{"name":"internal_name","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the external name of this argument.\n\nFor example, for `def write(to file)` returns `to`.","summary":"<p>Returns the external name of this argument.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1086,"url":null},"def":{"name":"name","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"restriction:ASTNode|Nop-instance-method","name":"restriction","doc":"Returns the type restriction of this argument, if any.","summary":"<p>Returns the type restriction of this argument, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1100,"url":null},"def":{"name":"restriction","return_type":"ASTNode | Nop","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/ArrayLiteral","path":"Crystal/Macros/ArrayLiteral.html","kind":"class","full_name":"Crystal::Macros::ArrayLiteral","name":"ArrayLiteral","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":549,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An array literal.","summary":"<p>An array literal.</p>","instance_methods":[{"html_id":"+(other:ArrayLiteral):ArrayLiteral-instance-method","name":"+","doc":"Similar to `Array#+`.","summary":"<p>Similar to <code><a href=\"../../Array.html#%2B%28other%3AArray%28U%29%29forallU-instance-method\">Array#+</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"ArrayLiteral"}],"args_string":"(other : ArrayLiteral) : ArrayLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a>) : <a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":673,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"ArrayLiteral"}],"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"<<(value:ASTNode):ArrayLiteral-instance-method","name":"<<","doc":"Similar to `Array#<<`.","summary":"<p>Similar to <code><a href=\"../../Array.html#%3C%3C%28value%3AT%29-instance-method\">Array#<<</a></code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"ASTNode"}],"args_string":"(value : ASTNode) : ArrayLiteral","args_html":"(value : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>) : <a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":669,"url":null},"def":{"name":"<<","args":[{"name":"value","external_name":"value","restriction":"ASTNode"}],"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"[](index:NumberLiteral):ASTNode-instance-method","name":"[]","doc":"Similar to `Array#[]`, but returns `NilLiteral` on out of bounds.","summary":"<p>Similar to <code><a href=\"../../Array.html#%5B%5D%28start%3AInt%2Ccount%3AInt%29%3AArray%28T%29-instance-method\">Array#[]</a></code>, but returns <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code> on out of bounds.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"NumberLiteral"}],"args_string":"(index : NumberLiteral) : ASTNode","args_html":"(index : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":649,"url":null},"def":{"name":"[]","args":[{"name":"index","external_name":"index","restriction":"NumberLiteral"}],"return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"[](index:RangeLiteral):ArrayLiteral(ASTNode)-instance-method","name":"[]","doc":"Similar to `Array#[]`.","summary":"<p>Similar to <code><a href=\"../../Array.html#%5B%5D%28start%3AInt%2Ccount%3AInt%29%3AArray%28T%29-instance-method\">Array#[]</a></code>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"RangeLiteral"}],"args_string":"(index : RangeLiteral) : ArrayLiteral(ASTNode)","args_html":"(index : <a href=\"../../Crystal/Macros/RangeLiteral.html\">RangeLiteral</a>) : <a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a>(<a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>)","location":{"filename":"src/compiler/crystal/macros.cr","line_number":653,"url":null},"def":{"name":"[]","args":[{"name":"index","external_name":"index","restriction":"RangeLiteral"}],"return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}},{"html_id":"[]=(index:NumberLiteral,value:ASTNode):ASTNode-instance-method","name":"[]=","doc":"Similar to `Array#[]=`.","summary":"<p>Similar to <code><a href=\"../../Array.html#%5B%5D%3D%28start%3AInt%2Ccount%3AInt%2Cvalues%3AArray%28T%29%29-instance-method\">Array#[]=</a></code>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"NumberLiteral"},{"name":"value","external_name":"value","restriction":"ASTNode"}],"args_string":"(index : NumberLiteral, value : ASTNode) : ASTNode","args_html":"(index : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>, value : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>) : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":657,"url":null},"def":{"name":"[]=","args":[{"name":"index","external_name":"index","restriction":"NumberLiteral"},{"name":"value","external_name":"value","restriction":"ASTNode"}],"return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"all?(&):BoolLiteral-instance-method","name":"all?","doc":"Similar to `Enumerable#all?`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#all%3F%28%26%3AT-%3E%29%3ABool-instance-method\">Enumerable#all?</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":555,"url":null},"def":{"name":"all?","yields":0,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"any?(&):BoolLiteral-instance-method","name":"any?","doc":"Similar to `Enumerable#any?`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#any%3F%28%26%3AT-%3E%29%3ABool-instance-method\">Enumerable#any?</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":551,"url":null},"def":{"name":"any?","yields":0,"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"clear:ArrayLiteral-instance-method","name":"clear","doc":"Similar to `Array#clear`","summary":"<p>Similar to <code><a href=\"../../Array.html#clear%3Aself-instance-method\">Array#clear</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":569,"url":null},"def":{"name":"clear","return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"each(&):Nil-instance-method","name":"each","doc":"Similar to `Array#each`","summary":"<p>Similar to <code>Array#each</code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":609,"url":null},"def":{"name":"each","yields":0,"return_type":"Nil","visibility":"Public","body":""}},{"html_id":"each_with_index(&):Nil-instance-method","name":"each_with_index","doc":"Similar to `Enumerable#each_with_index`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#each_with_index%28offset%3D0%2C%26%29-instance-method\">Enumerable#each_with_index</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":613,"url":null},"def":{"name":"each_with_index","yields":0,"return_type":"Nil","visibility":"Public","body":""}},{"html_id":"empty?:BoolLiteral-instance-method","name":"empty?","doc":"Similar to `Array#empty?`","summary":"<p>Similar to <code>Array#empty?</code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":573,"url":null},"def":{"name":"empty?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"find(&):ASTNode|NilLiteral-instance-method","name":"find","doc":"Similar to `Enumerable#find`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#find%28if_none%3Dnil%2C%26%3AT-%3E%29-instance-method\">Enumerable#find</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":577,"url":null},"def":{"name":"find","yields":0,"return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}},{"html_id":"first:ASTNode|NilLiteral-instance-method","name":"first","doc":"Similar to `Array#first`, but returns a `NilLiteral` if the array is empty.","summary":"<p>Similar to <code><a href=\"../../Array.html#first%28n%3AInt%29%3AArray%28T%29-instance-method\">Array#first</a></code>, but returns a <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code> if the array is empty.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":581,"url":null},"def":{"name":"first","return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}},{"html_id":"includes?(node:ASTNode):BoolLiteral-instance-method","name":"includes?","doc":"Similar to `Enumerable#includes?(obj)`.","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#includes%3F%28obj%29%3ABool-instance-method\">Enumerable#includes?(obj)</a></code>.</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":"ASTNode"}],"args_string":"(node : ASTNode) : BoolLiteral","args_html":"(node : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":585,"url":null},"def":{"name":"includes?","args":[{"name":"node","external_name":"node","restriction":"ASTNode"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"join(separator):StringLiteral-instance-method","name":"join","doc":"Similar to `Enumerable#join`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#join%28io%3AIO%2Cseparator%3D%22%22%29%3ANil-instance-method\">Enumerable#join</a></code></p>","abstract":false,"args":[{"name":"separator","external_name":"separator","restriction":""}],"args_string":"(separator) : StringLiteral","args_html":"(separator) : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":589,"url":null},"def":{"name":"join","args":[{"name":"separator","external_name":"separator","restriction":""}],"return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"last:ASTNode|NilLiteral-instance-method","name":"last","doc":"Similar to `Array#last`, but returns a `NilLiteral` if the array is empty.","summary":"<p>Similar to <code><a href=\"../../Array.html#last%28n%3AInt%29%3AArray%28T%29-instance-method\">Array#last</a></code>, but returns a <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code> if the array is empty.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":593,"url":null},"def":{"name":"last","return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}},{"html_id":"map(&):ArrayLiteral-instance-method","name":"map","doc":"Similar to `Enumerable#map`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#map%28%26%3AT-%3EU%29%3AArray%28U%29forallU-instance-method\">Enumerable#map</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":601,"url":null},"def":{"name":"map","yields":0,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"map_with_index(&):ArrayLiteral-instance-method","name":"map_with_index","doc":"Similar to `Enumerable#map_with_index`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#map_with_index%28offset%3D0%2C%26%3AT%2CInt32-%3EU%29%3AArray%28U%29forallU-instance-method\">Enumerable#map_with_index</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":605,"url":null},"def":{"name":"map_with_index","yields":0,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"of:ASTNode|Nop-instance-method","name":"of","doc":"Returns the type specified at the end of the array literal, if any.\n\nThis refers to the part after brackets in `[] of String`.","summary":"<p>Returns the type specified at the end of the array literal, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":679,"url":null},"def":{"name":"of","return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"html_id":"push(value:ASTNode):ArrayLiteral-instance-method","name":"push","doc":"Similar to `Array#push`.","summary":"<p>Similar to <code><a href=\"../../Array.html#push%28value%3AT%29-instance-method\">Array#push</a></code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"ASTNode"}],"args_string":"(value : ASTNode) : ArrayLiteral","args_html":"(value : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>) : <a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":665,"url":null},"def":{"name":"push","args":[{"name":"value","external_name":"value","restriction":"ASTNode"}],"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"reduce(memo:ASTNode,&):ASTNode-instance-method","name":"reduce","doc":"Similar to `Enumerable#reduce`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#reduce%28%26%29-instance-method\">Enumerable#reduce</a></code></p>","abstract":false,"args":[{"name":"memo","external_name":"memo","restriction":"ASTNode"}],"args_string":"(memo : ASTNode, &) : ASTNode","args_html":"(memo : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>, &) : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":629,"url":null},"def":{"name":"reduce","args":[{"name":"memo","external_name":"memo","restriction":"ASTNode"}],"yields":0,"return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"reduce(&):ASTNode-instance-method","name":"reduce","doc":"Similar to `Enumerable#reduce`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#reduce%28%26%29-instance-method\">Enumerable#reduce</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":625,"url":null},"def":{"name":"reduce","yields":0,"return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"reject(&):ArrayLiteral-instance-method","name":"reject","doc":"Similar to `Enumerable#reject`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#reject%28%26%3AT-%3E%29-instance-method\">Enumerable#reject</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":621,"url":null},"def":{"name":"reject","yields":0,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"select(&):ArrayLiteral-instance-method","name":"select","doc":"Similar to `Enumerable#select`","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#select%28%26%3AT-%3E%29-instance-method\">Enumerable#select</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":617,"url":null},"def":{"name":"select","yields":0,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"shuffle:ArrayLiteral-instance-method","name":"shuffle","doc":"Similar to `Array#shuffle`","summary":"<p>Similar to <code><a href=\"../../Array.html#shuffle%28random%3DRandom%3A%3ADEFAULT%29%3AArray%28T%29-instance-method\">Array#shuffle</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":633,"url":null},"def":{"name":"shuffle","return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"size:NumberLiteral-instance-method","name":"size","doc":"Similar to `Array#size`","summary":"<p>Similar to <code><a href=\"../../Array.html#size%3AInt32-instance-method\">Array#size</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":597,"url":null},"def":{"name":"size","return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"sort:ArrayLiteral-instance-method","name":"sort","doc":"Similar to `Array#sort`","summary":"<p>Similar to <code><a href=\"../../Array.html#sort%3AArray%28T%29-instance-method\">Array#sort</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":637,"url":null},"def":{"name":"sort","return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"sort_by(&):ArrayLiteral-instance-method","name":"sort_by","doc":"Similar to `Array#sort_by`","summary":"<p>Similar to <code><a href=\"../../Array.html#sort_by%28%26block%3AT-%3E_%29%3AArray%28T%29-instance-method\">Array#sort_by</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":641,"url":null},"def":{"name":"sort_by","yields":0,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"splat(trailing_string:StringLiteral=nil):MacroId-instance-method","name":"splat","doc":"Returns a `MacroId` with all of this array's elements joined\nby commas.\n\nIf *trailing_string* is given, it will be appended to\nthe result unless this array is empty. This lets you\nsplat an array and optionally write a trailing comma\nif needed.","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code> with all of this array's elements joined by commas.</p>","abstract":false,"args":[{"name":"trailing_string","default_value":"nil","external_name":"trailing_string","restriction":"StringLiteral"}],"args_string":"(trailing_string : StringLiteral = nil) : MacroId","args_html":"(trailing_string : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> = <span class=\"n\">nil</span>) : <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":565,"url":null},"def":{"name":"splat","args":[{"name":"trailing_string","default_value":"nil","external_name":"trailing_string","restriction":"StringLiteral"}],"return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"type:Path|Nop-instance-method","name":"type","doc":"Returns the type that receives the items of the array.\n\nThis refers to the part before brackets in `MyArray{1, 2, 3}`","summary":"<p>Returns the type that receives the items of the array.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":685,"url":null},"def":{"name":"type","return_type":"Path | Nop","visibility":"Public","body":""}},{"html_id":"uniq:ArrayLiteral-instance-method","name":"uniq","doc":"Similar to `Array#uniq`","summary":"<p>Similar to <code><a href=\"../../Array.html#uniq-instance-method\">Array#uniq</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":645,"url":null},"def":{"name":"uniq","return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"unshift(value:ASTNode):ArrayLiteral-instance-method","name":"unshift","doc":"Similar to `Array#unshift`.","summary":"<p>Similar to <code><a href=\"../../Array.html#unshift%28object%3AT%29%3Aself-instance-method\">Array#unshift</a></code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"ASTNode"}],"args_string":"(value : ASTNode) : ArrayLiteral","args_html":"(value : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>) : <a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":661,"url":null},"def":{"name":"unshift","args":[{"name":"value","external_name":"value","restriction":"ASTNode"}],"return_type":"ArrayLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Assign","path":"Crystal/Macros/Assign.html","kind":"class","full_name":"Crystal::Macros::Assign","name":"Assign","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1009,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"Assign expression.","summary":"<p>Assign expression.</p>","instance_methods":[{"html_id":"target:ASTNode-instance-method","name":"target","doc":"Returns the target assigned to.","summary":"<p>Returns the target assigned to.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1011,"url":null},"def":{"name":"target","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"value:ASTNode-instance-method","name":"value","doc":"Returns the value that is being assigned.","summary":"<p>Returns the value that is being assigned.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1015,"url":null},"def":{"name":"value","return_type":"ASTNode","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/ASTNode","path":"Crystal/Macros/ASTNode.html","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode","abstract":true,"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":283,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/Crystal/Macros/Annotation","kind":"class","full_name":"Crystal::Macros::Annotation","name":"Annotation"},{"html_id":"Crystal/Crystal/Macros/Arg","kind":"class","full_name":"Crystal::Macros::Arg","name":"Arg"},{"html_id":"Crystal/Crystal/Macros/ArrayLiteral","kind":"class","full_name":"Crystal::Macros::ArrayLiteral","name":"ArrayLiteral"},{"html_id":"Crystal/Crystal/Macros/Assign","kind":"class","full_name":"Crystal::Macros::Assign","name":"Assign"},{"html_id":"Crystal/Crystal/Macros/BinaryOp","kind":"class","full_name":"Crystal::Macros::BinaryOp","name":"BinaryOp"},{"html_id":"Crystal/Crystal/Macros/Block","kind":"class","full_name":"Crystal::Macros::Block","name":"Block"},{"html_id":"Crystal/Crystal/Macros/BoolLiteral","kind":"class","full_name":"Crystal::Macros::BoolLiteral","name":"BoolLiteral"},{"html_id":"Crystal/Crystal/Macros/Call","kind":"class","full_name":"Crystal::Macros::Call","name":"Call"},{"html_id":"Crystal/Crystal/Macros/Case","kind":"class","full_name":"Crystal::Macros::Case","name":"Case"},{"html_id":"Crystal/Crystal/Macros/Cast","kind":"class","full_name":"Crystal::Macros::Cast","name":"Cast"},{"html_id":"Crystal/Crystal/Macros/CharLiteral","kind":"class","full_name":"Crystal::Macros::CharLiteral","name":"CharLiteral"},{"html_id":"Crystal/Crystal/Macros/ClassDef","kind":"class","full_name":"Crystal::Macros::ClassDef","name":"ClassDef"},{"html_id":"Crystal/Crystal/Macros/ClassVar","kind":"class","full_name":"Crystal::Macros::ClassVar","name":"ClassVar"},{"html_id":"Crystal/Crystal/Macros/ControlExpression","kind":"class","full_name":"Crystal::Macros::ControlExpression","name":"ControlExpression"},{"html_id":"Crystal/Crystal/Macros/Def","kind":"class","full_name":"Crystal::Macros::Def","name":"Def"},{"html_id":"Crystal/Crystal/Macros/ExceptionHandler","kind":"class","full_name":"Crystal::Macros::ExceptionHandler","name":"ExceptionHandler"},{"html_id":"Crystal/Crystal/Macros/Expressions","kind":"class","full_name":"Crystal::Macros::Expressions","name":"Expressions"},{"html_id":"Crystal/Crystal/Macros/Generic","kind":"class","full_name":"Crystal::Macros::Generic","name":"Generic"},{"html_id":"Crystal/Crystal/Macros/Global","kind":"class","full_name":"Crystal::Macros::Global","name":"Global"},{"html_id":"Crystal/Crystal/Macros/HashLiteral","kind":"class","full_name":"Crystal::Macros::HashLiteral","name":"HashLiteral"},{"html_id":"Crystal/Crystal/Macros/If","kind":"class","full_name":"Crystal::Macros::If","name":"If"},{"html_id":"Crystal/Crystal/Macros/ImplicitObj","kind":"class","full_name":"Crystal::Macros::ImplicitObj","name":"ImplicitObj"},{"html_id":"Crystal/Crystal/Macros/InstanceVar","kind":"class","full_name":"Crystal::Macros::InstanceVar","name":"InstanceVar"},{"html_id":"Crystal/Crystal/Macros/IsA","kind":"class","full_name":"Crystal::Macros::IsA","name":"IsA"},{"html_id":"Crystal/Crystal/Macros/Macro","kind":"class","full_name":"Crystal::Macros::Macro","name":"Macro"},{"html_id":"Crystal/Crystal/Macros/MacroId","kind":"class","full_name":"Crystal::Macros::MacroId","name":"MacroId"},{"html_id":"Crystal/Crystal/Macros/Metaclass","kind":"class","full_name":"Crystal::Macros::Metaclass","name":"Metaclass"},{"html_id":"Crystal/Crystal/Macros/MetaVar","kind":"class","full_name":"Crystal::Macros::MetaVar","name":"MetaVar"},{"html_id":"Crystal/Crystal/Macros/MultiAssign","kind":"class","full_name":"Crystal::Macros::MultiAssign","name":"MultiAssign"},{"html_id":"Crystal/Crystal/Macros/NamedArgument","kind":"class","full_name":"Crystal::Macros::NamedArgument","name":"NamedArgument"},{"html_id":"Crystal/Crystal/Macros/NamedTupleLiteral","kind":"class","full_name":"Crystal::Macros::NamedTupleLiteral","name":"NamedTupleLiteral"},{"html_id":"Crystal/Crystal/Macros/NilableCast","kind":"class","full_name":"Crystal::Macros::NilableCast","name":"NilableCast"},{"html_id":"Crystal/Crystal/Macros/NilLiteral","kind":"class","full_name":"Crystal::Macros::NilLiteral","name":"NilLiteral"},{"html_id":"Crystal/Crystal/Macros/Nop","kind":"class","full_name":"Crystal::Macros::Nop","name":"Nop"},{"html_id":"Crystal/Crystal/Macros/NumberLiteral","kind":"class","full_name":"Crystal::Macros::NumberLiteral","name":"NumberLiteral"},{"html_id":"Crystal/Crystal/Macros/OffsetOf","kind":"class","full_name":"Crystal::Macros::OffsetOf","name":"OffsetOf"},{"html_id":"Crystal/Crystal/Macros/Path","kind":"class","full_name":"Crystal::Macros::Path","name":"Path"},{"html_id":"Crystal/Crystal/Macros/ProcLiteral","kind":"class","full_name":"Crystal::Macros::ProcLiteral","name":"ProcLiteral"},{"html_id":"Crystal/Crystal/Macros/ProcNotation","kind":"class","full_name":"Crystal::Macros::ProcNotation","name":"ProcNotation"},{"html_id":"Crystal/Crystal/Macros/ProcPointer","kind":"class","full_name":"Crystal::Macros::ProcPointer","name":"ProcPointer"},{"html_id":"Crystal/Crystal/Macros/RangeLiteral","kind":"class","full_name":"Crystal::Macros::RangeLiteral","name":"RangeLiteral"},{"html_id":"Crystal/Crystal/Macros/ReadInstanceVar","kind":"class","full_name":"Crystal::Macros::ReadInstanceVar","name":"ReadInstanceVar"},{"html_id":"Crystal/Crystal/Macros/RegexLiteral","kind":"class","full_name":"Crystal::Macros::RegexLiteral","name":"RegexLiteral"},{"html_id":"Crystal/Crystal/Macros/Require","kind":"class","full_name":"Crystal::Macros::Require","name":"Require"},{"html_id":"Crystal/Crystal/Macros/Rescue","kind":"class","full_name":"Crystal::Macros::Rescue","name":"Rescue"},{"html_id":"Crystal/Crystal/Macros/RespondsTo","kind":"class","full_name":"Crystal::Macros::RespondsTo","name":"RespondsTo"},{"html_id":"Crystal/Crystal/Macros/StringInterpolation","kind":"class","full_name":"Crystal::Macros::StringInterpolation","name":"StringInterpolation"},{"html_id":"Crystal/Crystal/Macros/StringLiteral","kind":"class","full_name":"Crystal::Macros::StringLiteral","name":"StringLiteral"},{"html_id":"Crystal/Crystal/Macros/SymbolLiteral","kind":"class","full_name":"Crystal::Macros::SymbolLiteral","name":"SymbolLiteral"},{"html_id":"Crystal/Crystal/Macros/TupleLiteral","kind":"class","full_name":"Crystal::Macros::TupleLiteral","name":"TupleLiteral"},{"html_id":"Crystal/Crystal/Macros/TypeDeclaration","kind":"class","full_name":"Crystal::Macros::TypeDeclaration","name":"TypeDeclaration"},{"html_id":"Crystal/Crystal/Macros/TypeNode","kind":"class","full_name":"Crystal::Macros::TypeNode","name":"TypeNode"},{"html_id":"Crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},{"html_id":"Crystal/Crystal/Macros/UninitializedVar","kind":"class","full_name":"Crystal::Macros::UninitializedVar","name":"UninitializedVar"},{"html_id":"Crystal/Crystal/Macros/Union","kind":"class","full_name":"Crystal::Macros::Union","name":"Union"},{"html_id":"Crystal/Crystal/Macros/Var","kind":"class","full_name":"Crystal::Macros::Var","name":"Var"},{"html_id":"Crystal/Crystal/Macros/VisibilityModifier","kind":"class","full_name":"Crystal::Macros::VisibilityModifier","name":"VisibilityModifier"},{"html_id":"Crystal/Crystal/Macros/When","kind":"class","full_name":"Crystal::Macros::When","name":"When"},{"html_id":"Crystal/Crystal/Macros/While","kind":"class","full_name":"Crystal::Macros::While","name":"While"},{"html_id":"Crystal/Crystal/Macros/Yield","kind":"class","full_name":"Crystal::Macros::Yield","name":"Yield"}],"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"This is the base class of all AST nodes. This methods are\navailable to all AST nodes.","summary":"<p>This is the base class of all AST nodes.</p>","instance_methods":[{"html_id":"!=(other:ASTNode):BoolLiteral-instance-method","name":"!=","doc":"Returns `true` if this node's textual representation is not the same as\nthe *other* node.","summary":"<p>Returns <code>true</code> if this node's textual representation is not the same as the <em>other</em> node.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"ASTNode"}],"args_string":"(other : ASTNode) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":379,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"ASTNode"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"==(other:ASTNode):BoolLiteral-instance-method","name":"==","doc":"Returns `true` if this node's textual representation is the same as\nthe *other* node.","summary":"<p>Returns <code>true</code> if this node's textual representation is the same as the <em>other</em> node.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"ASTNode"}],"args_string":"(other : ASTNode) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":374,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"ASTNode"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"class_name:StringLiteral-instance-method","name":"class_name","doc":"Returns a `StringLiteral` that contains this node's name.\n\n```\nmacro test\n  {{ \"foo\".class_name }}\nend\n\nputs test # => prints StringLiteral\n```","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a></code> that contains this node's name.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":336,"url":null},"def":{"name":"class_name","return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"column_number:StringLiteral|NilLiteral-instance-method","name":"column_number","doc":"Returns the column number where this node begins.\nMight return `nil` if the location is not known.\n\nThe first column number in a line is `1`.","summary":"<p>Returns the column number where this node begins.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":355,"url":null},"def":{"name":"column_number","return_type":"StringLiteral | NilLiteral","visibility":"Public","body":""}},{"html_id":"end_column_number:StringLiteral|NilLiteral-instance-method","name":"end_column_number","doc":"Returns the column number where this node ends.\nMight return `nil` if the location is not known.\n\nThe first column number in a line is `1`.","summary":"<p>Returns the column number where this node ends.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":369,"url":null},"def":{"name":"end_column_number","return_type":"StringLiteral | NilLiteral","visibility":"Public","body":""}},{"html_id":"end_line_number:StringLiteral|NilLiteral-instance-method","name":"end_line_number","doc":"Returns the line number where this node ends.\nMight return `nil` if the location is not known.\n\nThe first line number in a file is `1`.","summary":"<p>Returns the line number where this node ends.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":362,"url":null},"def":{"name":"end_line_number","return_type":"StringLiteral | NilLiteral","visibility":"Public","body":""}},{"html_id":"filename:StringLiteral|NilLiteral-instance-method","name":"filename","doc":"Returns the filename where this node is located.\nMight return `nil` if the location is not known.","summary":"<p>Returns the filename where this node is located.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":341,"url":null},"def":{"name":"filename","return_type":"StringLiteral | NilLiteral","visibility":"Public","body":""}},{"html_id":"id:MacroId-instance-method","name":"id","doc":"Returns this node as a `MacroId`. Useful when you need an identifier\nout of a `StringLiteral`, `SymbolLiteral`, `Var` or `Call`.\n\n```\nmacro define_method(name, content)\n  def {{name.id}}\n    {{content}}\n  end\nend\n\ndefine_method :foo, 1\ndefine_method \"bar\", 2\ndefine_method baz, 3\n\nputs foo # => prints 1\nputs bar # => prints 2\nputs baz # => prints 3\n```","summary":"<p>Returns this node as a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":302,"url":null},"def":{"name":"id","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"is_a?(type:TypeNode):BoolLiteral-instance-method","name":"is_a?","doc":"Returns `true` if this node's type is the given *type* or any of its\nsubclasses.\n\n*type* always refers to an AST node type, never a type in the program.\n\n```\n{{ 1.is_a?(NumberLiteral) }} # => true\n{{ 1.is_a?(BoolLiteral) }}   # => false\n{{ 1.is_a?(ASTNode) }}       # => true\n{{ 1.is_a?(Int32) }}         # => false\n```\nNOTE: This is a pseudo-method provided directly by the Crystal compiler.\nIt cannot be redefined nor overridden.","summary":"<p>Returns <code>true</code> if this node's type is the given <em>type</em> or any of its subclasses.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"TypeNode"}],"args_string":"(type : TypeNode) : BoolLiteral","args_html":"(type : <a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":398,"url":null},"def":{"name":"__crystal_pseudo_is_a?","args":[{"name":"type","external_name":"type","restriction":"TypeNode"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"line_number:StringLiteral|NilLiteral-instance-method","name":"line_number","doc":"Returns the line number where this node begins.\nMight return `nil` if the location is not known.\n\nThe first line number in a file is 1.","summary":"<p>Returns the line number where this node begins.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":348,"url":null},"def":{"name":"line_number","return_type":"StringLiteral | NilLiteral","visibility":"Public","body":""}},{"html_id":"nil?:BoolLiteral-instance-method","name":"nil?","doc":"Returns `true` if this node is a `NilLiteral` or `Nop`.\nNOTE: This is a pseudo-method provided directly by the Crystal compiler.\nIt cannot be redefined nor overridden.","summary":"<p>Returns <code>true</code> if this node is a <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code> or <code><a href=\"../../Crystal/Macros/Nop.html\">Nop</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":402,"url":null},"def":{"name":"__crystal_pseudo_nil?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"raise(message):NoReturn-instance-method","name":"raise","doc":"Gives a compile-time error with the given *message*. This will\nhighlight this node in the error message.","summary":"<p>Gives a compile-time error with the given <em>message</em>.</p>","abstract":false,"args":[{"name":"message","external_name":"message","restriction":""}],"args_string":"(message) : NoReturn","args_html":"(message) : NoReturn","location":{"filename":"src/compiler/crystal/macros.cr","line_number":384,"url":null},"def":{"name":"raise","args":[{"name":"message","external_name":"message","restriction":""}],"return_type":"NoReturn","visibility":"Public","body":""}},{"html_id":"stringify:StringLiteral-instance-method","name":"stringify","doc":"Returns a `StringLiteral` that contains this node's textual representation.\nNote that invoking stringify on a string literal will return a `StringLiteral`\nthat contains a string literal.\n\n```\nmacro test\n  {{ \"foo\".stringify }}\nend\n\nputs test # prints \"foo\" (including the double quotes)\n```","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a></code> that contains this node's textual representation.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":316,"url":null},"def":{"name":"stringify","return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"symbolize:SymbolLiteral-instance-method","name":"symbolize","doc":"Returns a `SymbolLiteral` that contains this node's textual representation.\n\n```\n{{ \"foo\".id.symbolize }} # => :foo\n```","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/SymbolLiteral.html\">SymbolLiteral</a></code> that contains this node's textual representation.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":324,"url":null},"def":{"name":"symbolize","return_type":"SymbolLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/BinaryOp","path":"Crystal/Macros/BinaryOp.html","kind":"class","full_name":"Crystal::Macros::BinaryOp","name":"BinaryOp","abstract":true,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1063,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/Crystal/Macros/And","kind":"class","full_name":"Crystal::Macros::And","name":"And"},{"html_id":"Crystal/Crystal/Macros/Or","kind":"class","full_name":"Crystal::Macros::Or","name":"Or"}],"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A binary expression like `And` and `Or`.","summary":"<p>A binary expression like <code><a href=\"../../Crystal/Macros/And.html\">And</a></code> and <code><a href=\"../../Crystal/Macros/Or.html\">Or</a></code>.</p>","instance_methods":[{"html_id":"left:ASTNode-instance-method","name":"left","doc":"Returns the left hand side of this node.","summary":"<p>Returns the left hand side of this node.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1065,"url":null},"def":{"name":"left","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"right:ASTNode-instance-method","name":"right","doc":"Returns the left hand side of this node.","summary":"<p>Returns the left hand side of this node.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1069,"url":null},"def":{"name":"right","return_type":"ASTNode","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Block","path":"Crystal/Macros/Block.html","kind":"class","full_name":"Crystal::Macros::Block","name":"Block","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":923,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A code block.","summary":"<p>A code block.</p>","instance_methods":[{"html_id":"args:ArrayLiteral(MacroId)-instance-method","name":"args","doc":"Returns the blocks arguments.","summary":"<p>Returns the blocks arguments.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":929,"url":null},"def":{"name":"args","return_type":"ArrayLiteral(MacroId)","visibility":"Public","body":""}},{"html_id":"body:ASTNode-instance-method","name":"body","doc":"Returns the block's body, if any.","summary":"<p>Returns the block's body, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":925,"url":null},"def":{"name":"body","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"splat_index:NumberLiteral|NilLiteral-instance-method","name":"splat_index","doc":"Returns the index of the argument with a *splat, if any.","summary":"<p>Returns the index of the argument with a *splat, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":933,"url":null},"def":{"name":"splat_index","return_type":"NumberLiteral | NilLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/BoolLiteral","path":"Crystal/Macros/BoolLiteral.html","kind":"class","full_name":"Crystal::Macros::BoolLiteral","name":"BoolLiteral","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":417,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A bool literal.","summary":"<p>A bool literal.</p>"},{"html_id":"Crystal/Crystal/Macros/Break","path":"Crystal/Macros/Break.html","kind":"class","full_name":"Crystal::Macros::Break","name":"Break","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ControlExpression","kind":"class","full_name":"Crystal::Macros::ControlExpression","name":"ControlExpression"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ControlExpression","kind":"class","full_name":"Crystal::Macros::ControlExpression","name":"ControlExpression"},{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1568,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `break` expression.","summary":"<p>A <code>break</code> expression.</p>"},{"html_id":"Crystal/Crystal/Macros/Call","path":"Crystal/Macros/Call.html","kind":"class","full_name":"Crystal::Macros::Call","name":"Call","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":945,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A method call.","summary":"<p>A method call.</p>","instance_methods":[{"html_id":"args:ArrayLiteral-instance-method","name":"args","doc":"Returns this call's arguments.","summary":"<p>Returns this call's arguments.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":963,"url":null},"def":{"name":"args","return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"block:Block|Nop-instance-method","name":"block","doc":"Returns this call's block, if any.","summary":"<p>Returns this call's block, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":971,"url":null},"def":{"name":"block","return_type":"Block | Nop","visibility":"Public","body":""}},{"html_id":"block_arg:ASTNode|Nop-instance-method","name":"block_arg","doc":"Returns this call's block argument, if any","summary":"<p>Returns this call's block argument, if any</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":975,"url":null},"def":{"name":"block_arg","return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"html_id":"global?:BoolLiteral-instance-method","name":"global?","doc":"Returns `true` if this call refers to a global method (starts with `::`).","summary":"<p>Returns <code>true</code> if this call refers to a global method (starts with <code>::</code>).</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":959,"url":null},"def":{"name":"global?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"id:MacroId-instance-method","name":"id","doc":"Returns this call's name as a `MacroId`.","summary":"<p>Returns this call's name as a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":947,"url":null},"def":{"name":"id","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the method name of this call.","summary":"<p>Returns the method name of this call.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":951,"url":null},"def":{"name":"name","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"named_args:ArrayLiteral(NamedArgument)-instance-method","name":"named_args","doc":"Returns this call's named arguments.","summary":"<p>Returns this call's named arguments.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":967,"url":null},"def":{"name":"named_args","return_type":"ArrayLiteral(NamedArgument)","visibility":"Public","body":""}},{"html_id":"receiver:ASTNode|Nop-instance-method","name":"receiver","doc":"Returns this call's receiver, if any.","summary":"<p>Returns this call's receiver, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":955,"url":null},"def":{"name":"receiver","return_type":"ASTNode | Nop","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Case","path":"Crystal/Macros/Case.html","kind":"class","full_name":"Crystal::Macros::Case","name":"Case","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1321,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `case` expression.","summary":"<p>A <code>case</code> expression.</p>","instance_methods":[{"html_id":"cond:ASTNode-instance-method","name":"cond","doc":"Returns the condition (target) of this `case`.","summary":"<p>Returns the condition (target) of this <code>case</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1323,"url":null},"def":{"name":"cond","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"else:ArrayLiteral(When)-instance-method","name":"else","doc":"Returns the `else` of this `case`.","summary":"<p>Returns the <code><a href=\"../../Crystal/Macros/Case.html#else%3AArrayLiteral%28When%29-instance-method\">#else</a></code> of this <code>case</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1331,"url":null},"def":{"name":"else","return_type":"ArrayLiteral(When)","visibility":"Public","body":""}},{"html_id":"exhaustive?:BoolLiteral-instance-method","name":"exhaustive?","doc":"Returns whether this `case` is exhaustive (`case ... in`).","summary":"<p>Returns whether this <code>case</code> is exhaustive (`case ...</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1335,"url":null},"def":{"name":"exhaustive?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"whens:ArrayLiteral(When)-instance-method","name":"whens","doc":"Returns the `when`s of this `case`.","summary":"<p>Returns the <code>when</code>s of this <code>case</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1327,"url":null},"def":{"name":"whens","return_type":"ArrayLiteral(When)","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Cast","path":"Crystal/Macros/Cast.html","kind":"class","full_name":"Crystal::Macros::Cast","name":"Cast","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1639,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A cast call: `obj.as(to)`","summary":"<p>A cast call: <code>obj.as(to)</code></p>","instance_methods":[{"html_id":"obj:ASTNode-instance-method","name":"obj","doc":"Returns the object part of the cast.","summary":"<p>Returns the object part of the cast.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1641,"url":null},"def":{"name":"obj","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"to:ASTNode-instance-method","name":"to","doc":"Returns the target type of the cast.","summary":"<p>Returns the target type of the cast.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1645,"url":null},"def":{"name":"to","return_type":"ASTNode","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/CharLiteral","path":"Crystal/Macros/CharLiteral.html","kind":"class","full_name":"Crystal::Macros::CharLiteral","name":"CharLiteral","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":514,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A character literal.","summary":"<p>A character literal.</p>","instance_methods":[{"html_id":"id:MacroId-instance-method","name":"id","doc":"Returns a `MacroId` for this character's contents.","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code> for this character's contents.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":516,"url":null},"def":{"name":"id","return_type":"MacroId","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/ClassDef","path":"Crystal/Macros/ClassDef.html","kind":"class","full_name":"Crystal::Macros::ClassDef","name":"ClassDef","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1386,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A class definition.","summary":"<p>A class definition.</p>"},{"html_id":"Crystal/Crystal/Macros/ClassVar","path":"Crystal/Macros/ClassVar.html","kind":"class","full_name":"Crystal::Macros::ClassVar","name":"ClassVar","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1049,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A class variable.","summary":"<p>A class variable.</p>","instance_methods":[{"html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of this variable.","summary":"<p>Returns the name of this variable.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1051,"url":null},"def":{"name":"name","return_type":"MacroId","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/ControlExpression","path":"Crystal/Macros/ControlExpression.html","kind":"class","full_name":"Crystal::Macros::ControlExpression","name":"ControlExpression","abstract":true,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1554,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/Crystal/Macros/Break","kind":"class","full_name":"Crystal::Macros::Break","name":"Break"},{"html_id":"Crystal/Crystal/Macros/Next","kind":"class","full_name":"Crystal::Macros::Next","name":"Next"},{"html_id":"Crystal/Crystal/Macros/Return","kind":"class","full_name":"Crystal::Macros::Return","name":"Return"}],"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"The base class of control expressions.","summary":"<p>The base class of control expressions.</p>","instance_methods":[{"html_id":"exp:ASTNode|Nop-instance-method","name":"exp","doc":"Returns the argument to this control expression, if any.\n\nIf multiple arguments are present, they are wrapped inside a single\n`TupleLiteral`.","summary":"<p>Returns the argument to this control expression, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1559,"url":null},"def":{"name":"exp","return_type":"ASTNode | Nop","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Def","path":"Crystal/Macros/Def.html","kind":"class","full_name":"Crystal::Macros::Def","name":"Def","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1126,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A method definition.","summary":"<p>A method definition.</p>","instance_methods":[{"html_id":"abstract?:BoolLiteral-instance-method","name":"abstract?","doc":"Returns `true` is this method is declared as abstract, `false` otherwise.","summary":"<p>Returns <code>true</code> is this method is declared as abstract, <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1170,"url":null},"def":{"name":"abstract?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"accepts_block?:BoolLiteral-instance-method","name":"accepts_block?","doc":"Returns `true` if this method can be called with a block, `false` otherwise.","summary":"<p>Returns <code>true</code> if this method can be called with a block, <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1148,"url":null},"def":{"name":"accepts_block?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"annotation(type:TypeNode):Annotation|NilLiteral-instance-method","name":"annotation","doc":"Returns the last `Annotation` with the given `type`\nattached to this variable or `NilLiteral` if there are none.","summary":"<p>Returns the last <code><a href=\"../../Crystal/Macros/Annotation.html\">Annotation</a></code> with the given <code>type</code> attached to this variable or <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code> if there are none.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"TypeNode"}],"args_string":"(type : TypeNode) : Annotation | NilLiteral","args_html":"(type : <a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a>) : <a href=\"../../Crystal/Macros/Annotation.html\">Annotation</a> | <a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1179,"url":null},"def":{"name":"annotation","args":[{"name":"type","external_name":"type","restriction":"TypeNode"}],"return_type":"Annotation | NilLiteral","visibility":"Public","body":""}},{"html_id":"annotations(type:TypeNode):ArrayLiteral(Annotation)-instance-method","name":"annotations","doc":"Returns an array of annotations with the given `type`\nattached to this variable, or an empty `ArrayLiteral` if there are none.","summary":"<p>Returns an array of annotations with the given <code>type</code> attached to this variable, or an empty <code><a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a></code> if there are none.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"TypeNode"}],"args_string":"(type : TypeNode) : ArrayLiteral(Annotation)","args_html":"(type : <a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a>) : <a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a>(<a href=\"../../Crystal/Macros/Annotation.html\">Annotation</a>)","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1184,"url":null},"def":{"name":"annotations","args":[{"name":"type","external_name":"type","restriction":"TypeNode"}],"return_type":"ArrayLiteral(Annotation)","visibility":"Public","body":""}},{"html_id":"args:ArrayLiteral(Arg)-instance-method","name":"args","doc":"Returns the arguments of this method.","summary":"<p>Returns the arguments of this method.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1132,"url":null},"def":{"name":"args","return_type":"ArrayLiteral(Arg)","visibility":"Public","body":""}},{"html_id":"block_arg:Arg|Nop-instance-method","name":"block_arg","doc":"Returns the block argument, if any.","summary":"<p>Returns the block argument, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1144,"url":null},"def":{"name":"block_arg","return_type":"Arg | Nop","visibility":"Public","body":""}},{"html_id":"body:ASTNode-instance-method","name":"body","doc":"Returns the body of this method.","summary":"<p>Returns the body of this method.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1161,"url":null},"def":{"name":"body","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"double_splat:Arg|Nop-instance-method","name":"double_splat","doc":"Returns the double splat argument, if any.","summary":"<p>Returns the double splat argument, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1140,"url":null},"def":{"name":"double_splat","return_type":"Arg | Nop","visibility":"Public","body":""}},{"html_id":"free_vars:ArrayLiteral(MacroId)-instance-method","name":"free_vars","doc":"Returns the free variables of this method, or an empty `ArrayLiteral` if\nthere are none.","summary":"<p>Returns the free variables of this method, or an empty <code><a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a></code> if there are none.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1157,"url":null},"def":{"name":"free_vars","return_type":"ArrayLiteral(MacroId)","visibility":"Public","body":""}},{"html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of this method.","summary":"<p>Returns the name of this method.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1128,"url":null},"def":{"name":"name","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"receiver:ASTNode|Nop-instance-method","name":"receiver","doc":"Returns the receiver (for example `self`) of this method definition,\nor `Nop` if not specified.","summary":"<p>Returns the receiver (for example <code>self</code>) of this method definition, or <code><a href=\"../../Crystal/Macros/Nop.html\">Nop</a></code> if not specified.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1166,"url":null},"def":{"name":"receiver","return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"html_id":"return_type:ASTNode|Nop-instance-method","name":"return_type","doc":"Returns the return type of the method, if specified.","summary":"<p>Returns the return type of the method, if specified.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1152,"url":null},"def":{"name":"return_type","return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"html_id":"splat_index:NumberLiteral|NilLiteral-instance-method","name":"splat_index","doc":"Returns the index of the argument with a *splat, if any.","summary":"<p>Returns the index of the argument with a *splat, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1136,"url":null},"def":{"name":"splat_index","return_type":"NumberLiteral | NilLiteral","visibility":"Public","body":""}},{"html_id":"visibility:SymbolLiteral-instance-method","name":"visibility","doc":"Returns the visibility of this def: `:public`, `:protected` or `:private`.","summary":"<p>Returns the visibility of this def: <code>:public</code>, <code>:protected</code> or <code>:private</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1174,"url":null},"def":{"name":"visibility","return_type":"SymbolLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/DoubleSplat","path":"Crystal/Macros/DoubleSplat.html","kind":"class","full_name":"Crystal::Macros::DoubleSplat","name":"DoubleSplat","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1251,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A double splat expression: `**exp`.","summary":"<p>A double splat expression: <code>**exp</code>.</p>"},{"html_id":"Crystal/Crystal/Macros/ExceptionHandler","path":"Crystal/Macros/ExceptionHandler.html","kind":"class","full_name":"Crystal::Macros::ExceptionHandler","name":"ExceptionHandler","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1480,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `begin ... end` expression with `rescue`, `else` and `ensure` clauses.","summary":"<p>A `begin ...</p>","instance_methods":[{"html_id":"body:ASTNode-instance-method","name":"body","doc":"Returns this exception handler's main body.","summary":"<p>Returns this exception handler's main body.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1482,"url":null},"def":{"name":"body","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"else:ASTNode|Nop-instance-method","name":"else","doc":"Returns this exception handler's `else` clause body, if any.","summary":"<p>Returns this exception handler's <code><a href=\"../../Crystal/Macros/ExceptionHandler.html#else%3AASTNode%7CNop-instance-method\">#else</a></code> clause body, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1490,"url":null},"def":{"name":"else","return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"html_id":"ensure:ASTNode|Nop-instance-method","name":"ensure","doc":"Returns this exception handler's `ensure` clause body, if any.","summary":"<p>Returns this exception handler's <code><a href=\"../../Crystal/Macros/ExceptionHandler.html#ensure%3AASTNode%7CNop-instance-method\">#ensure</a></code> clause body, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1494,"url":null},"def":{"name":"ensure","return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"html_id":"rescues:ArrayLiteral(Rescue)|NilLiteral-instance-method","name":"rescues","doc":"Returns this exception handler's `rescue` clauses, if any.","summary":"<p>Returns this exception handler's <code>rescue</code> clauses, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1486,"url":null},"def":{"name":"rescues","return_type":"ArrayLiteral(Rescue) | NilLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Expressions","path":"Crystal/Macros/Expressions.html","kind":"class","full_name":"Crystal::Macros::Expressions","name":"Expressions","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":938,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A group of expressions.","summary":"<p>A group of expressions.</p>","instance_methods":[{"html_id":"expressions:ArrayLiteral(ASTNode)-instance-method","name":"expressions","doc":"Returns the list of expressions in this node","summary":"<p>Returns the list of expressions in this node</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":940,"url":null},"def":{"name":"expressions","return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Generic","path":"Crystal/Macros/Generic.html","kind":"class","full_name":"Crystal::Macros::Generic","name":"Generic","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1408,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A generic instantiation, like `Foo(T)` or `Foo::Bar::Baz(T)`","summary":"<p>A generic instantiation, like <code>Foo(T)</code> or <code>Foo::Bar::Baz(T)</code></p>","instance_methods":[{"html_id":"name:Path-instance-method","name":"name","doc":"Returns the path to the generic.","summary":"<p>Returns the path to the generic.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1410,"url":null},"def":{"name":"name","return_type":"Path","visibility":"Public","body":""}},{"html_id":"named_args:NamedTupleLiteral|NilLiteral-instance-method","name":"named_args","doc":"Returns the named arguments of this instantiation, if any.","summary":"<p>Returns the named arguments of this instantiation, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1418,"url":null},"def":{"name":"named_args","return_type":"NamedTupleLiteral | NilLiteral","visibility":"Public","body":""}},{"html_id":"resolve:ASTNode-instance-method","name":"resolve","doc":"Resolves this generic to a `TypeNode` if it denotes a type,\nor otherwise gives a compile-time error.","summary":"<p>Resolves this generic to a <code><a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a></code> if it denotes a type, or otherwise gives a compile-time error.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1423,"url":null},"def":{"name":"resolve","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"resolve?:ASTNode|NilLiteral-instance-method","name":"resolve?","doc":"Resolves this path to a `TypeNode` if it denotes a type,\nor otherwise returns a `NilLiteral`.","summary":"<p>Resolves this path to a <code><a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a></code> if it denotes a type, or otherwise returns a <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1428,"url":null},"def":{"name":"resolve?","return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}},{"html_id":"type_vars:ArrayLiteral(ASTNode)-instance-method","name":"type_vars","doc":"Returns the arguments (the type variables) of this instantiation.","summary":"<p>Returns the arguments (the type variables) of this instantiation.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1414,"url":null},"def":{"name":"type_vars","return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}},{"html_id":"types:ArrayLiteral(ASTNode)-instance-method","name":"types","doc":"Returns this generic inside an array literal.\nThis method exists so you can call `types` on the type of a type\ndeclaration and get all types, whether it's a Generic, Path or Union.","summary":"<p>Returns this generic inside an array literal.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1434,"url":null},"def":{"name":"types","return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Global","path":"Crystal/Macros/Global.html","kind":"class","full_name":"Crystal::Macros::Global","name":"Global","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1056,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A global variable.","summary":"<p>A global variable.</p>","instance_methods":[{"html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of this variable.","summary":"<p>Returns the name of this variable.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1058,"url":null},"def":{"name":"name","return_type":"MacroId","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/HashLiteral","path":"Crystal/Macros/HashLiteral.html","kind":"class","full_name":"Crystal::Macros::HashLiteral","name":"HashLiteral","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":690,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A hash literal.","summary":"<p>A hash literal.</p>","instance_methods":[{"html_id":"[](key:ASTNode):ASTNode-instance-method","name":"[]","doc":"Similar to `Hash#[]?`","summary":"<p>Similar to <code><a href=\"../../Hash.html#%5B%5D%3F%28key%29-instance-method\">Hash#[]?</a></code></p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"ASTNode"}],"args_string":"(key : ASTNode) : ASTNode","args_html":"(key : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>) : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":724,"url":null},"def":{"name":"[]","args":[{"name":"key","external_name":"key","restriction":"ASTNode"}],"return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"[]=(key:ASTNode,value:ASTNode):ASTNode-instance-method","name":"[]=","doc":"Similar to `Hash#[]=`","summary":"<p>Similar to <code><a href=\"../../Hash.html#%5B%5D%3D%28key%3AK%2Cvalue%3AV%29-instance-method\">Hash#[]=</a></code></p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"ASTNode"},{"name":"value","external_name":"value","restriction":"ASTNode"}],"args_string":"(key : ASTNode, value : ASTNode) : ASTNode","args_html":"(key : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>, value : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>) : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":728,"url":null},"def":{"name":"[]=","args":[{"name":"key","external_name":"key","restriction":"ASTNode"},{"name":"value","external_name":"value","restriction":"ASTNode"}],"return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"clear:HashLiteral-instance-method","name":"clear","doc":"Similar to `Hash#clear`","summary":"<p>Similar to <code><a href=\"../../Hash.html#clear-instance-method\">Hash#clear</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":692,"url":null},"def":{"name":"clear","return_type":"HashLiteral","visibility":"Public","body":""}},{"html_id":"double_splat(trailing_string:StringLiteral=nil):MacroId-instance-method","name":"double_splat","doc":"Returns a `MacroId` with all of this hash elements joined\nby commas.\n\nIf *trailing_string* is given, it will be appended to\nthe result unless this hash is empty. This lets you\nsplat a hash and optionally write a trailing comma\nif needed.","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code> with all of this hash elements joined by commas.</p>","abstract":false,"args":[{"name":"trailing_string","default_value":"nil","external_name":"trailing_string","restriction":"StringLiteral"}],"args_string":"(trailing_string : StringLiteral = nil) : MacroId","args_html":"(trailing_string : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> = <span class=\"n\">nil</span>) : <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":756,"url":null},"def":{"name":"double_splat","args":[{"name":"trailing_string","default_value":"nil","external_name":"trailing_string","restriction":"StringLiteral"}],"return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"each(&):Nil-instance-method","name":"each","doc":"Similar to `Hash#each`","summary":"<p>Similar to <code><a href=\"../../Hash.html#each%28%26%3ATuple%28K%2CV%29-%3E%29%3ANil-instance-method\">Hash#each</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":696,"url":null},"def":{"name":"each","yields":0,"return_type":"Nil","visibility":"Public","body":""}},{"html_id":"empty?:BoolLiteral-instance-method","name":"empty?","doc":"Similar to `Hash#empty?`","summary":"<p>Similar to <code><a href=\"../../Hash.html#empty%3F%3ABool-instance-method\">Hash#empty?</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":700,"url":null},"def":{"name":"empty?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"keys:ArrayLiteral-instance-method","name":"keys","doc":"Similar to `Hash#keys`","summary":"<p>Similar to <code><a href=\"../../Hash.html#keys%3AArray%28K%29-instance-method\">Hash#keys</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":704,"url":null},"def":{"name":"keys","return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"map:ArrayLiteral-instance-method","name":"map","doc":"Similar to `Hash#map`","summary":"<p>Similar to <code>Hash#map</code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":720,"url":null},"def":{"name":"map","return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"of_key:ASTNode|Nop-instance-method","name":"of_key","doc":"Returns the type specified at the end of the Hash literal, if any.\n\nThis refers to the key type after brackets in `{} of String => Int32`.","summary":"<p>Returns the type specified at the end of the Hash literal, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":734,"url":null},"def":{"name":"of_key","return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"html_id":"of_value:ASTNode|Nop-instance-method","name":"of_value","doc":"Returns the type specified at the end of the Hash literal, if any.\n\nThis refers to the value type after brackets in `{} of String => Int32`.","summary":"<p>Returns the type specified at the end of the Hash literal, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":740,"url":null},"def":{"name":"of_value","return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"html_id":"size:NumberLiteral-instance-method","name":"size","doc":"Similar to `Hash#size`","summary":"<p>Similar to <code><a href=\"../../Hash.html#size%3AInt32-instance-method\">Hash#size</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":708,"url":null},"def":{"name":"size","return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"to_a:ArrayLiteral(TupleLiteral)-instance-method","name":"to_a","doc":"Similar to `Hash#to_a`","summary":"<p>Similar to <code><a href=\"../../Hash.html#to_a%3AArray%28Tuple%28K%2CV%29%29-instance-method\">Hash#to_a</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":712,"url":null},"def":{"name":"to_a","return_type":"ArrayLiteral(TupleLiteral)","visibility":"Public","body":""}},{"html_id":"type:Path|Nop-instance-method","name":"type","doc":"Returns the type that receives the items of the array.\n\nThis refers to the part before brackets in `MyHash{'a' => 1, 'b' => 2}`","summary":"<p>Returns the type that receives the items of the array.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":746,"url":null},"def":{"name":"type","return_type":"Path | Nop","visibility":"Public","body":""}},{"html_id":"values:ArrayLiteral-instance-method","name":"values","doc":"Similar to `Hash#values`","summary":"<p>Similar to <code><a href=\"../../Hash.html#values%3AArray%28V%29-instance-method\">Hash#values</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":716,"url":null},"def":{"name":"values","return_type":"ArrayLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/If","path":"Crystal/Macros/If.html","kind":"class","full_name":"Crystal::Macros::If","name":"If","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":991,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An if expression.","summary":"<p>An if expression.</p>","instance_methods":[{"html_id":"cond:ASTNode-instance-method","name":"cond","doc":"Returns this if's condition.","summary":"<p>Returns this if's condition.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":993,"url":null},"def":{"name":"cond","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"else:ASTNode-instance-method","name":"else","doc":"Returns this if's `else` clause's body.","summary":"<p>Returns this if's <code><a href=\"../../Crystal/Macros/If.html#else%3AASTNode-instance-method\">#else</a></code> clause's body.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1001,"url":null},"def":{"name":"else","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"then:ASTNode-instance-method","name":"then","doc":"Returns this if's `then` clause's body.","summary":"<p>Returns this if's <code><a href=\"../../Crystal/Macros/If.html#then%3AASTNode-instance-method\">#then</a></code> clause's body.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":997,"url":null},"def":{"name":"then","return_type":"ASTNode","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/ImplicitObj","path":"Crystal/Macros/ImplicitObj.html","kind":"class","full_name":"Crystal::Macros::ImplicitObj","name":"ImplicitObj","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1348,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"Node that represents an implicit object in:\n\n    case foo\n    when .bar? # this is a call with an implicit object\n    end","summary":"<p>Node that represents an implicit object in:</p>"},{"html_id":"Crystal/Crystal/Macros/InstanceSizeOf","path":"Crystal/Macros/InstanceSizeOf.html","kind":"class","full_name":"Crystal::Macros::InstanceSizeOf","name":"InstanceSizeOf","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1239,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An `instance_sizeof` expression.","summary":"<p>An <code>instance_sizeof</code> expression.</p>"},{"html_id":"Crystal/Crystal/Macros/InstanceVar","path":"Crystal/Macros/InstanceVar.html","kind":"class","full_name":"Crystal::Macros::InstanceVar","name":"InstanceVar","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1031,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An instance variable.","summary":"<p>An instance variable.</p>","instance_methods":[{"html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of this variable.","summary":"<p>Returns the name of this variable.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1033,"url":null},"def":{"name":"name","return_type":"MacroId","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/IsA","path":"Crystal/Macros/IsA.html","kind":"class","full_name":"Crystal::Macros::IsA","name":"IsA","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1277,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An `.is_a?` or `.nil?` call.","summary":"<p>An <code>.is_a?</code> or <code>.nil?</code> call.</p>","instance_methods":[{"html_id":"arg:ASTNode-instance-method","name":"arg","doc":"Returns this call's argument.","summary":"<p>Returns this call's argument.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1283,"url":null},"def":{"name":"arg","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"receiver:ASTNode-instance-method","name":"receiver","doc":"Returns this call's receiver.","summary":"<p>Returns this call's receiver.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1279,"url":null},"def":{"name":"receiver","return_type":"ASTNode","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Macro","path":"Crystal/Macros/Macro.html","kind":"class","full_name":"Crystal::Macros::Macro","name":"Macro","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1189,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A macro definition.","summary":"<p>A macro definition.</p>","instance_methods":[{"html_id":"args:ArrayLiteral(Arg)-instance-method","name":"args","doc":"Returns the arguments of this macro.","summary":"<p>Returns the arguments of this macro.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1195,"url":null},"def":{"name":"args","return_type":"ArrayLiteral(Arg)","visibility":"Public","body":""}},{"html_id":"block_arg:Arg|Nop-instance-method","name":"block_arg","doc":"Returns the block argument, if any.","summary":"<p>Returns the block argument, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1207,"url":null},"def":{"name":"block_arg","return_type":"Arg | Nop","visibility":"Public","body":""}},{"html_id":"body:ASTNode-instance-method","name":"body","doc":"Returns the body of this macro.","summary":"<p>Returns the body of this macro.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1211,"url":null},"def":{"name":"body","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"double_splat:Arg|Nop-instance-method","name":"double_splat","doc":"Returns the double splat argument, if any.","summary":"<p>Returns the double splat argument, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1203,"url":null},"def":{"name":"double_splat","return_type":"Arg | Nop","visibility":"Public","body":""}},{"html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of this macro.","summary":"<p>Returns the name of this macro.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1191,"url":null},"def":{"name":"name","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"splat_index:NumberLiteral|NilLiteral-instance-method","name":"splat_index","doc":"Returns the index of the argument with a *splat, if any.","summary":"<p>Returns the index of the argument with a *splat, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1199,"url":null},"def":{"name":"splat_index","return_type":"NumberLiteral | NilLiteral","visibility":"Public","body":""}},{"html_id":"visibility:SymbolLiteral-instance-method","name":"visibility","doc":"Returns the visibility of this macro: `:public`, `:protected` or `:private`.","summary":"<p>Returns the visibility of this macro: <code>:public</code>, <code>:protected</code> or <code>:private</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1215,"url":null},"def":{"name":"visibility","return_type":"SymbolLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/MacroId","path":"Crystal/Macros/MacroId.html","kind":"class","full_name":"Crystal::Macros::MacroId","name":"MacroId","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1734,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A fictitious node representing an identifier like, `foo`, `Bar` or `something_else`.\n\nThe parser doesn't create these nodes. Instead, you create them by invoking `id`\non some nodes. For example, invoking `id` on a `StringLiteral` returns a `MacroId`\nfor the string's content. Similarly, invoking ID on a `SymbolLiteral`, `Call`, `Var` and `Path`\nreturns a MacroId for the node's content.\n\nThis allows you to treat strings, symbols, variables and calls uniformly. For example:\n\n```text\nmacro getter(name)\n  def {{name.id}}\n    @{{name.id}}\n  end\nend\n\ngetter unicorns\ngetter :unicorns\ngetter \"unicorns\"\n```\n\nAll of the above macro calls work because we invoked `id`, and the generated code\nlooks like this:\n\n```\ndef unicorns\n  @unicorns\nend\n```\n\nIf we hadn't used `id`, the generated code would have been this:\n\n```text\ndef unicorns\n  @unicorns\nend\n\ndef :unicorns\n  @:unicorns\nend\n\ndef \"unicorns\"\n  @\"unicorns\"\nend\n```\n\nThe last two definitions are invalid and so will give a compile-time error.","summary":"<p>A fictitious node representing an identifier like, <code>foo</code>, <code>Bar</code> or <code>something_else</code>.</p>","instance_methods":[{"html_id":"+(other:StringLiteral|CharLiteral):MacroId-instance-method","name":"+","doc":"Similar to `String#+`.","summary":"<p>Similar to <code><a href=\"../../String.html#%2B%28other%3Aself%29%3AString-instance-method\">String#+</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : MacroId","args_html":"(other : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/CharLiteral.html\">CharLiteral</a>) : <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"<(other:StringLiteral|MacroId):BoolLiteral-instance-method","name":"<","doc":"Similar to `String#<`","summary":"<p>Similar to <code>String#<</code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"StringLiteral | MacroId"}],"args_string":"(other : StringLiteral | MacroId) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1742,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"StringLiteral | MacroId"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"=~(range:RegexLiteral):BoolLiteral-instance-method","name":"=~","doc":"Similar to `String#=~`.","summary":"<p>Similar to <code><a href=\"../../String.html#%3D~%28regex%3ARegex%29%3AInt32%3F-instance-method\">String#=~</a></code>.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"RegexLiteral"}],"args_string":"(range : RegexLiteral) : BoolLiteral","args_html":"(range : <a href=\"../../Crystal/Macros/RegexLiteral.html\">RegexLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"=~","args":[{"name":"range","external_name":"range","restriction":"RegexLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":">(other:StringLiteral|MacroId):BoolLiteral-instance-method","name":">","doc":"Similar to `String#>`","summary":"<p>Similar to <code>String#></code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"StringLiteral | MacroId"}],"args_string":"(other : StringLiteral | MacroId) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1738,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"StringLiteral | MacroId"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"[](range:RangeLiteral):MacroId-instance-method","name":"[]","doc":"Similar to `String#[]`.","summary":"<p>Similar to <code><a href=\"../../String.html#%5B%5D%28start%3AInt%2Ccount%3AInt%29%3AString-instance-method\">String#[]</a></code>.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"RangeLiteral"}],"args_string":"(range : RangeLiteral) : MacroId","args_html":"(range : <a href=\"../../Crystal/Macros/RangeLiteral.html\">RangeLiteral</a>) : <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"[]","args":[{"name":"range","external_name":"range","restriction":"RangeLiteral"}],"return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"camelcase(*,lower:BoolLiteral=false):MacroId-instance-method","name":"camelcase","doc":"Similar to `String#camelcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#camelcase%28io%3AIO%2Coptions%3AUnicode%3A%3ACaseOptions%3DUnicode%3A%3ACaseOptions%3A%3ANone%2C%2A%2Clower%3ABool%3Dfalse%29%3ANil-instance-method\">String#camelcase</a></code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"lower","default_value":"false","external_name":"lower","restriction":"BoolLiteral"}],"args_string":"(*, lower : BoolLiteral = false) : MacroId","args_html":"(*, lower : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a> = <span class=\"n\">false</span>) : <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"camelcase","args":[{"name":"","external_name":"","restriction":""},{"name":"lower","default_value":"false","external_name":"lower","restriction":"BoolLiteral"}],"splat_index":0,"return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"capitalize:MacroId-instance-method","name":"capitalize","doc":"Similar to `String#capitalize`.","summary":"<p>Similar to <code><a href=\"../../String.html#capitalize%28options%3AUnicode%3A%3ACaseOptions%3D%3Anone%29%3AString-instance-method\">String#capitalize</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"capitalize","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"chars:ArrayLiteral(CharLiteral)-instance-method","name":"chars","doc":"Similar to `String#chars`.","summary":"<p>Similar to <code><a href=\"../../String.html#chars%3AArray%28Char%29-instance-method\">String#chars</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"chars","return_type":"ArrayLiteral(CharLiteral)","visibility":"Public","body":""}},{"html_id":"chomp:MacroId-instance-method","name":"chomp","doc":"Similar to `String#chomp`.","summary":"<p>Similar to <code><a href=\"../../String.html#chomp%3AString-instance-method\">String#chomp</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"chomp","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"count(other:CharLiteral):NumberLiteral-instance-method","name":"count","doc":"Similar to `String#count`.","summary":"<p>Similar to <code><a href=\"../../String.html#count%28%26%29-instance-method\">String#count</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"CharLiteral"}],"args_string":"(other : CharLiteral) : NumberLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/CharLiteral.html\">CharLiteral</a>) : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"count","args":[{"name":"other","external_name":"other","restriction":"CharLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"downcase:MacroId-instance-method","name":"downcase","doc":"Similar to `String#downcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#downcase%28options%3AUnicode%3A%3ACaseOptions%3D%3Anone%29%3AString-instance-method\">String#downcase</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"downcase","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"empty?:BoolLiteral-instance-method","name":"empty?","doc":"Similar to `String#empty?`.","summary":"<p>Similar to <code><a href=\"../../String.html#empty%3F%3ABool-instance-method\">String#empty?</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"empty?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"ends_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"ends_with?","doc":"Similar to `String#ends_with?`.","summary":"<p>Similar to <code><a href=\"../../String.html#ends_with%3F%28str%3AString%29%3ABool-instance-method\">String#ends_with?</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/CharLiteral.html\">CharLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"ends_with?","args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"gsub(regex:RegexLiteral,replacement:StringLiteral):MacroId-instance-method","name":"gsub","doc":"Similar to `String#gsub`.","summary":"<p>Similar to <code><a href=\"../../String.html#gsub%28%26block%3AChar-%3E_%29-instance-method\">String#gsub</a></code>.</p>","abstract":false,"args":[{"name":"regex","external_name":"regex","restriction":"RegexLiteral"},{"name":"replacement","external_name":"replacement","restriction":"StringLiteral"}],"args_string":"(regex : RegexLiteral, replacement : StringLiteral) : MacroId","args_html":"(regex : <a href=\"../../Crystal/Macros/RegexLiteral.html\">RegexLiteral</a>, replacement : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>) : <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"gsub","args":[{"name":"regex","external_name":"regex","restriction":"RegexLiteral"},{"name":"replacement","external_name":"replacement","restriction":"StringLiteral"}],"return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"id:MacroId-instance-method","name":"id","doc":"Returns a `MacroId` for this string's contents.","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code> for this string's contents.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"id","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"includes?(search:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"includes?","doc":"Similar to `String#includes?`.","summary":"<p>Similar to <code><a href=\"../../String.html#includes%3F%28search%3AChar%7CString%29%3ABool-instance-method\">String#includes?</a></code>.</p>","abstract":false,"args":[{"name":"search","external_name":"search","restriction":"StringLiteral | CharLiteral"}],"args_string":"(search : StringLiteral | CharLiteral) : BoolLiteral","args_html":"(search : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/CharLiteral.html\">CharLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"includes?","args":[{"name":"search","external_name":"search","restriction":"StringLiteral | CharLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"lines:ArrayLiteral(StringLiteral)-instance-method","name":"lines","doc":"Similar to `String#lines`.","summary":"<p>Similar to <code><a href=\"../../String.html#lines%28chomp%3Dtrue%29%3AArray%28String%29-instance-method\">String#lines</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"lines","return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"html_id":"size:NumberLiteral-instance-method","name":"size","doc":"Similar to `String#size`.","summary":"<p>Similar to <code><a href=\"../../String.html#size%3AInt32-instance-method\">String#size</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"size","return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"split(node:ASTNode):ArrayLiteral(StringLiteral)-instance-method","name":"split","doc":"Similar to `String#split`.","summary":"<p>Similar to <code><a href=\"../../String.html#split%28limit%3AInt32%3F%3Dnil%29%3AArray%28String%29-instance-method\">String#split</a></code>.</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":"ASTNode"}],"args_string":"(node : ASTNode) : ArrayLiteral(StringLiteral)","args_html":"(node : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>) : <a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a>(<a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>)","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"split","args":[{"name":"node","external_name":"node","restriction":"ASTNode"}],"return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"html_id":"split:ArrayLiteral(StringLiteral)-instance-method","name":"split","doc":"Similar to `String#split`.","summary":"<p>Similar to <code><a href=\"../../String.html#split%28limit%3AInt32%3F%3Dnil%29%3AArray%28String%29-instance-method\">String#split</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"split","return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"html_id":"starts_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"starts_with?","doc":"Similar to `String#starts_with?`.","summary":"<p>Similar to <code><a href=\"../../String.html#starts_with%3F%28str%3AString%29%3ABool-instance-method\">String#starts_with?</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/CharLiteral.html\">CharLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"starts_with?","args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"strip:MacroId-instance-method","name":"strip","doc":"Similar to `String#strip`.","summary":"<p>Similar to <code><a href=\"../../String.html#strip%3AString-instance-method\">String#strip</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"strip","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"titleize:MacroId-instance-method","name":"titleize","doc":"Similar to `String#titleize`.","summary":"<p>Similar to <code><a href=\"../../String.html#titleize%28options%3AUnicode%3A%3ACaseOptions%3D%3Anone%29%3AString-instance-method\">String#titleize</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"titleize","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"to_i(base=10)-instance-method","name":"to_i","doc":"Similar to `String#to_i`.","summary":"<p>Similar to <code><a href=\"../../String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">String#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":""}],"args_string":"(base = 10)","args_html":"(base = <span class=\"n\">10</span>)","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"to_i","args":[{"name":"base","default_value":"10","external_name":"base","restriction":""}],"visibility":"Public","body":""}},{"html_id":"tr(from:StringLiteral,to:StringLiteral):MacroId-instance-method","name":"tr","doc":"Similar to `String#tr`.","summary":"<p>Similar to <code><a href=\"../../String.html#tr%28from%3AString%2Cto%3AString%29%3AString-instance-method\">String#tr</a></code>.</p>","abstract":false,"args":[{"name":"from","external_name":"from","restriction":"StringLiteral"},{"name":"to","external_name":"to","restriction":"StringLiteral"}],"args_string":"(from : StringLiteral, to : StringLiteral) : MacroId","args_html":"(from : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>, to : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>) : <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"tr","args":[{"name":"from","external_name":"from","restriction":"StringLiteral"},{"name":"to","external_name":"to","restriction":"StringLiteral"}],"return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"underscore:MacroId-instance-method","name":"underscore","doc":"Similar to `String#underscore`.","summary":"<p>Similar to <code><a href=\"../../String.html#underscore%28options%3AUnicode%3A%3ACaseOptions%3D%3Anone%29%3AString-instance-method\">String#underscore</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"underscore","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"upcase:MacroId-instance-method","name":"upcase","doc":"Similar to `String#upcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#upcase%28options%3AUnicode%3A%3ACaseOptions%3D%3Anone%29%3AString-instance-method\">String#upcase</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1735,"url":null},"def":{"name":"upcase","return_type":"MacroId","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Metaclass","path":"Crystal/Macros/Metaclass.html","kind":"class","full_name":"Crystal::Macros::Metaclass","name":"Metaclass","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1622,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A metaclass in a type expression: `T.class`","summary":"<p>A metaclass in a type expression: <code>T.class</code></p>","instance_methods":[{"html_id":"instance:ASTNode-instance-method","name":"instance","doc":"Returns the node representing the instance type of this metaclass.","summary":"<p>Returns the node representing the instance type of this metaclass.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1624,"url":null},"def":{"name":"instance","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"resolve:ASTNode-instance-method","name":"resolve","doc":"Resolves this metaclass to a `TypeNode` if it denotes a type,\nor otherwise gives a compile-time error.","summary":"<p>Resolves this metaclass to a <code><a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a></code> if it denotes a type, or otherwise gives a compile-time error.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1629,"url":null},"def":{"name":"resolve","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"resolve?:ASTNode|NilLiteral-instance-method","name":"resolve?","doc":"Resolves this metaclass to a `TypeNode` if it denotes a type,\nor otherwise returns a `NilLiteral`.","summary":"<p>Resolves this metaclass to a <code><a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a></code> if it denotes a type, or otherwise returns a <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1634,"url":null},"def":{"name":"resolve?","return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/MetaVar","path":"Crystal/Macros/MetaVar.html","kind":"class","full_name":"Crystal::Macros::MetaVar","name":"MetaVar","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":856,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A fictitious node representing a variable or instance\nvariable, together with type information.","summary":"<p>A fictitious node representing a variable or instance variable, together with type information.</p>","instance_methods":[{"html_id":"annotation(type:TypeNode):Annotation|NilLiteral-instance-method","name":"annotation","doc":"Returns the last `Annotation` with the given `type`\nattached to this variable or `NilLiteral` if there are none.","summary":"<p>Returns the last <code><a href=\"../../Crystal/Macros/Annotation.html\">Annotation</a></code> with the given <code><a href=\"../../Crystal/Macros/MetaVar.html#type%3ATypeNode%7CNilLiteral-instance-method\">#type</a></code> attached to this variable or <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code> if there are none.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"TypeNode"}],"args_string":"(type : TypeNode) : Annotation | NilLiteral","args_html":"(type : <a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a>) : <a href=\"../../Crystal/Macros/Annotation.html\">Annotation</a> | <a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":880,"url":null},"def":{"name":"annotation","args":[{"name":"type","external_name":"type","restriction":"TypeNode"}],"return_type":"Annotation | NilLiteral","visibility":"Public","body":""}},{"html_id":"annotations(type:TypeNode):ArrayLiteral(Annotation)-instance-method","name":"annotations","doc":"Returns an array of annotations with the given `type`\nattached to this variable, or an empty `ArrayLiteral` if there are none.","summary":"<p>Returns an array of annotations with the given <code><a href=\"../../Crystal/Macros/MetaVar.html#type%3ATypeNode%7CNilLiteral-instance-method\">#type</a></code> attached to this variable, or an empty <code><a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a></code> if there are none.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"TypeNode"}],"args_string":"(type : TypeNode) : ArrayLiteral(Annotation)","args_html":"(type : <a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a>) : <a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a>(<a href=\"../../Crystal/Macros/Annotation.html\">Annotation</a>)","location":{"filename":"src/compiler/crystal/macros.cr","line_number":885,"url":null},"def":{"name":"annotations","args":[{"name":"type","external_name":"type","restriction":"TypeNode"}],"return_type":"ArrayLiteral(Annotation)","visibility":"Public","body":""}},{"html_id":"default_value:ASTNode-instance-method","name":"default_value","doc":"Returns the default value of this variable.\nNote that if the variable doesn't have a default value,\nor the default value is `nil`, a `NilLiteral` will be\nreturned. To distinguish between these cases, use\n`has_default_value?`.","summary":"<p>Returns the default value of this variable.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":870,"url":null},"def":{"name":"default_value","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"has_default_value?:BoolLiteral-instance-method","name":"has_default_value?","doc":"Returns whether this variable has a default value\n(which can in turn be `nil`).","summary":"<p>Returns whether this variable has a default value (which can in turn be <code>nil</code>).</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":875,"url":null},"def":{"name":"has_default_value?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of this variable.","summary":"<p>Returns the name of this variable.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":858,"url":null},"def":{"name":"name","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"type:TypeNode|NilLiteral-instance-method","name":"type","doc":"Returns the type of this variable, if known, or `nil`.","summary":"<p>Returns the type of this variable, if known, or <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":862,"url":null},"def":{"name":"type","return_type":"TypeNode | NilLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/MultiAssign","path":"Crystal/Macros/MultiAssign.html","kind":"class","full_name":"Crystal::Macros::MultiAssign","name":"MultiAssign","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1020,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"Multiple assign expression.","summary":"<p>Multiple assign expression.</p>","instance_methods":[{"html_id":"targets:ArrayLiteral(ASTNode)-instance-method","name":"targets","doc":"Returns the targets assigned to.","summary":"<p>Returns the targets assigned to.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1022,"url":null},"def":{"name":"targets","return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}},{"html_id":"values:ArrayLiteral(ASTNode)-instance-method","name":"values","doc":"Returns the values that are being assigned.","summary":"<p>Returns the values that are being assigned.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1026,"url":null},"def":{"name":"values","return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/NamedArgument","path":"Crystal/Macros/NamedArgument.html","kind":"class","full_name":"Crystal::Macros::NamedArgument","name":"NamedArgument","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":980,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A call's named argument.","summary":"<p>A call's named argument.</p>","instance_methods":[{"html_id":"name:MacroId-instance-method","name":"name","doc":"Returns this named argument name.","summary":"<p>Returns this named argument name.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":982,"url":null},"def":{"name":"name","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"value:ASTNode-instance-method","name":"value","doc":"Returns this named argument value.","summary":"<p>Returns this named argument value.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":986,"url":null},"def":{"name":"value","return_type":"ASTNode","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/NamedTupleLiteral","path":"Crystal/Macros/NamedTupleLiteral.html","kind":"class","full_name":"Crystal::Macros::NamedTupleLiteral","name":"NamedTupleLiteral","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":761,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A named tuple literal.","summary":"<p>A named tuple literal.</p>","instance_methods":[{"html_id":"[](key:SymbolLiteral|StringLiteral|MacroId):ASTNode-instance-method","name":"[]","doc":"Similar to `NamedTuple#[]` but returns `NilLiteral` if *key* is undefined.","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#%5B%5D%28key%3ASymbol%7CString%29-instance-method\">NamedTuple#[]</a></code> but returns <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code> if <em>key</em> is undefined.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"SymbolLiteral | StringLiteral | MacroId"}],"args_string":"(key : SymbolLiteral | StringLiteral | MacroId) : ASTNode","args_html":"(key : <a href=\"../../Crystal/Macros/SymbolLiteral.html\">SymbolLiteral</a> | <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>) : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":799,"url":null},"def":{"name":"[]","args":[{"name":"key","external_name":"key","restriction":"SymbolLiteral | StringLiteral | MacroId"}],"return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"[]=(key:SymbolLiteral|StringLiteral|MacroId,value:ASTNode):ASTNode-instance-method","name":"[]=","doc":"Adds or replaces a key.","summary":"<p>Adds or replaces a key.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"SymbolLiteral | StringLiteral | MacroId"},{"name":"value","external_name":"value","restriction":"ASTNode"}],"args_string":"(key : SymbolLiteral | StringLiteral | MacroId, value : ASTNode) : ASTNode","args_html":"(key : <a href=\"../../Crystal/Macros/SymbolLiteral.html\">SymbolLiteral</a> | <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>, value : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>) : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":803,"url":null},"def":{"name":"[]=","args":[{"name":"key","external_name":"key","restriction":"SymbolLiteral | StringLiteral | MacroId"},{"name":"value","external_name":"value","restriction":"ASTNode"}],"return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"double_splat(trailing_string:StringLiteral=nil):MacroId-instance-method","name":"double_splat","doc":"Similar to `HashLiteral#double_splat`","summary":"<p>Similar to <code><a href=\"../../Crystal/Macros/HashLiteral.html#double_splat%28trailing_string%3AStringLiteral%3Dnil%29%3AMacroId-instance-method\">HashLiteral#double_splat</a></code></p>","abstract":false,"args":[{"name":"trailing_string","default_value":"nil","external_name":"trailing_string","restriction":"StringLiteral"}],"args_string":"(trailing_string : StringLiteral = nil) : MacroId","args_html":"(trailing_string : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> = <span class=\"n\">nil</span>) : <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":795,"url":null},"def":{"name":"double_splat","args":[{"name":"trailing_string","default_value":"nil","external_name":"trailing_string","restriction":"StringLiteral"}],"return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"each(&):Nil-instance-method","name":"each","doc":"Similar to `NamedTuple#each`","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#each%28%26%29%3ANil-instance-method\">NamedTuple#each</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":763,"url":null},"def":{"name":"each","yields":0,"return_type":"Nil","visibility":"Public","body":""}},{"html_id":"each_with_index(&):Nil-instance-method","name":"each_with_index","doc":"Similar to `NamedTuple#each_with_index`","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#each_with_index%28offset%3D0%2C%26%29-instance-method\">NamedTuple#each_with_index</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":767,"url":null},"def":{"name":"each_with_index","yields":0,"return_type":"Nil","visibility":"Public","body":""}},{"html_id":"empty?:BoolLiteral-instance-method","name":"empty?","doc":"Similar to `NamedTuple#empty?`","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#empty%3F-instance-method\">NamedTuple#empty?</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":771,"url":null},"def":{"name":"empty?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"keys:ArrayLiteral-instance-method","name":"keys","doc":"Similar to `NamedTuple#keys`","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#keys-instance-method\">NamedTuple#keys</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":775,"url":null},"def":{"name":"keys","return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"map:ArrayLiteral-instance-method","name":"map","doc":"Similar to `NamedTuple#map`","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#map%28%26%29-instance-method\">NamedTuple#map</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":791,"url":null},"def":{"name":"map","return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"size:NumberLiteral-instance-method","name":"size","doc":"Similar to `NamedTuple#size`","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#size-instance-method\">NamedTuple#size</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":779,"url":null},"def":{"name":"size","return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"to_a:ArrayLiteral(TupleLiteral)-instance-method","name":"to_a","doc":"Similar to `NamedTuple#to_a`","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#to_a-instance-method\">NamedTuple#to_a</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":783,"url":null},"def":{"name":"to_a","return_type":"ArrayLiteral(TupleLiteral)","visibility":"Public","body":""}},{"html_id":"values:ArrayLiteral-instance-method","name":"values","doc":"Similar to `NamedTuple#values`","summary":"<p>Similar to <code><a href=\"../../NamedTuple.html#values-instance-method\">NamedTuple#values</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":787,"url":null},"def":{"name":"values","return_type":"ArrayLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Next","path":"Crystal/Macros/Next.html","kind":"class","full_name":"Crystal::Macros::Next","name":"Next","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ControlExpression","kind":"class","full_name":"Crystal::Macros::ControlExpression","name":"ControlExpression"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ControlExpression","kind":"class","full_name":"Crystal::Macros::ControlExpression","name":"ControlExpression"},{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1572,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `next` expression.","summary":"<p>A <code>next</code> expression.</p>"},{"html_id":"Crystal/Crystal/Macros/NilableCast","path":"Crystal/Macros/NilableCast.html","kind":"class","full_name":"Crystal::Macros::NilableCast","name":"NilableCast","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1650,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A cast call: `obj.as?(to)`","summary":"<p>A cast call: <code>obj.as?(to)</code></p>","instance_methods":[{"html_id":"obj:ASTNode-instance-method","name":"obj","doc":"Returns the object part of the cast.","summary":"<p>Returns the object part of the cast.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1652,"url":null},"def":{"name":"obj","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"to:ASTNode-instance-method","name":"to","doc":"Returns the target type of the cast.","summary":"<p>Returns the target type of the cast.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1656,"url":null},"def":{"name":"to","return_type":"ASTNode","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/NilLiteral","path":"Crystal/Macros/NilLiteral.html","kind":"class","full_name":"Crystal::Macros::NilLiteral","name":"NilLiteral","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":413,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"The nil literal.","summary":"<p>The nil literal.</p>"},{"html_id":"Crystal/Crystal/Macros/Nop","path":"Crystal/Macros/Nop.html","kind":"class","full_name":"Crystal::Macros::Nop","name":"Nop","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":409,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"The empty node. Similar to a `NilLiteral` but its textual representation\nis the empty string. This corresponds, for example, to the missing `else` branch of\nan `if` without an `else`.","summary":"<p>The empty node.</p>"},{"html_id":"Crystal/Crystal/Macros/Not","path":"Crystal/Macros/Not.html","kind":"class","full_name":"Crystal::Macros::Not","name":"Not","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1227,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An unary `not` (`!`).","summary":"<p>An unary <code>not</code> (<code>!</code>).</p>"},{"html_id":"Crystal/Crystal/Macros/NumberLiteral","path":"Crystal/Macros/NumberLiteral.html","kind":"class","full_name":"Crystal::Macros::NumberLiteral","name":"NumberLiteral","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":421,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"Any number literal.","summary":"<p>Any number literal.</p>","instance_methods":[{"html_id":"%(other:NumberLiteral):NumberLiteral-instance-method","name":"%","doc":"Same as `Number#%`","summary":"<p>Same as <code><a href=\"../../Number.html\">Number</a>#%</code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":465,"url":null},"def":{"name":"%","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"&(other:NumberLiteral):NumberLiteral-instance-method","name":"&","doc":"Same as `Number#&`","summary":"<p>Same as <code>Number#&</code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":469,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"*(other:NumberLiteral):NumberLiteral-instance-method","name":"*","doc":"Same as `Number#*`","summary":"<p>Same as <code><a href=\"../../Number.html#%2A%28other%3ABigFloat%29%3ABigFloat-instance-method\">Number#*</a></code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":451,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"**(other:NumberLiteral):NumberLiteral-instance-method","name":"**","doc":"Same as `Number#**`","summary":"<p>Same as <code>Number#**</code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":481,"url":null},"def":{"name":"**","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"+(other:NumberLiteral):NumberLiteral-instance-method","name":"+","doc":"Same as `Number#+`","summary":"<p>Same as <code><a href=\"../../Number.html#%2B-instance-method\">Number#+</a></code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":443,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"+:NumberLiteral-instance-method","name":"+","doc":"Same as `Number#+`","summary":"<p>Same as <code><a href=\"../../Number.html#%2B-instance-method\">Number#+</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":493,"url":null},"def":{"name":"+","return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"-(other:NumberLiteral):NumberLiteral-instance-method","name":"-","doc":"Same as `Number#-`","summary":"<p>Same as <code><a href=\"../../Number.html#-%28other%3ABigFloat%29-instance-method\">Number#-</a></code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":447,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"-:NumberLiteral-instance-method","name":"-","doc":"Same as `Number#-`","summary":"<p>Same as <code><a href=\"../../Number.html#-%28other%3ABigFloat%29-instance-method\">Number#-</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":497,"url":null},"def":{"name":"-","return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"//(other:NumberLiteral):NumberLiteral-instance-method","name":"//","doc":"Same as `Number#//`","summary":"<p>Same as <code><a href=\"../../Number.html#//%28other%29-instance-method\">Number#//</a></code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":461,"url":null},"def":{"name":"//","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"<(other:NumberLiteral):BoolLiteral-instance-method","name":"<","doc":"Compares this node's value to another node's value.","summary":"<p>Compares this node's value to another node's value.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":423,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"<<(other:NumberLiteral):NumberLiteral-instance-method","name":"<<","doc":"Same as `Number#<<`","summary":"<p>Same as <code>Number#<<</code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":485,"url":null},"def":{"name":"<<","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"<=(other:NumberLiteral):BoolLiteral-instance-method","name":"<=","doc":"Compares this node's value to another node's value.","summary":"<p>Compares this node's value to another node's value.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":427,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"<=>(other:NumberLiteral):NumberLiteral-instance-method","name":"<=>","doc":"Compares this node's value to another node's value.","summary":"<p>Compares this node's value to another node's value.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":439,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":">(other:NumberLiteral):BoolLiteral-instance-method","name":">","doc":"Compares this node's value to another node's value.","summary":"<p>Compares this node's value to another node's value.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":431,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":">=(other:NumberLiteral):BoolLiteral-instance-method","name":">=","doc":"Compares this node's value to another node's value.","summary":"<p>Compares this node's value to another node's value.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":435,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":">>(other:NumberLiteral):NumberLiteral-instance-method","name":">>","doc":"Same as `Number#>>`","summary":"<p>Same as <code>Number#>></code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":489,"url":null},"def":{"name":">>","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"^(other:NumberLiteral):NumberLiteral-instance-method","name":"^","doc":"Same as `Number#^`","summary":"<p>Same as <code>Number#^</code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":477,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"kind:SymbolLiteral-instance-method","name":"kind","doc":"The type of the literal: `:i32`, `:u16`, `:f32`, `:f64`, etc.","summary":"<p>The type of the literal: <code>:i32</code>, <code>:u16</code>, <code>:f32</code>, <code>:f64</code>, etc.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":505,"url":null},"def":{"name":"kind","return_type":"SymbolLiteral","visibility":"Public","body":""}},{"html_id":"to_number:MacroId-instance-method","name":"to_number","doc":"Returns the value of this number without a type suffix.","summary":"<p>Returns the value of this number without a type suffix.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":509,"url":null},"def":{"name":"to_number","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"|(other:NumberLiteral):NumberLiteral-instance-method","name":"|","doc":"Same as `Number#|`","summary":"<p>Same as <code>Number#|</code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"args_string":"(other : NumberLiteral) : NumberLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>) : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":473,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"NumberLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"~:NumberLiteral-instance-method","name":"~","doc":"Same as `Number#~`","summary":"<p>Same as <code>Number#~</code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":501,"url":null},"def":{"name":"~","return_type":"NumberLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/OffsetOf","path":"Crystal/Macros/OffsetOf.html","kind":"class","full_name":"Crystal::Macros::OffsetOf","name":"OffsetOf","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1255,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An `offsetof` expression.","summary":"<p>An <code>offsetof</code> expression.</p>","instance_methods":[{"html_id":"offset:ASTNode-instance-method","name":"offset","doc":"Returns the offset argument used in this `offsetof` expression.","summary":"<p>Returns the offset argument used in this <code>offsetof</code> expression.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1261,"url":null},"def":{"name":"offset","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"type:ASTNode-instance-method","name":"type","doc":"Returns the type that has been used in this `offsetof` expression.","summary":"<p>Returns the type that has been used in this <code>offsetof</code> expression.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1257,"url":null},"def":{"name":"type","return_type":"ASTNode","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Or","path":"Crystal/Macros/Or.html","kind":"class","full_name":"Crystal::Macros::Or","name":"Or","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/BinaryOp","kind":"class","full_name":"Crystal::Macros::BinaryOp","name":"BinaryOp"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/BinaryOp","kind":"class","full_name":"Crystal::Macros::BinaryOp","name":"BinaryOp"},{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1078,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An `||` (or) expression","summary":"<p>An <code>||</code> (or) expression</p>"},{"html_id":"Crystal/Crystal/Macros/Out","path":"Crystal/Macros/Out.html","kind":"class","full_name":"Crystal::Macros::Out","name":"Out","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1243,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An `out` expression.","summary":"<p>An <code>out</code> expression.</p>"},{"html_id":"Crystal/Crystal/Macros/Path","path":"Crystal/Macros/Path.html","kind":"class","full_name":"Crystal::Macros::Path","name":"Path","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1352,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A Path to a constant or type, like `Foo` or `Foo::Bar::Baz`.","summary":"<p>A Path to a constant or type, like <code>Foo</code> or <code>Foo::Bar::Baz</code>.</p>","instance_methods":[{"html_id":"global:BoolLiteral-instance-method","name":"global","doc":"Returns `true` if this is a global path (starts with `::`)","summary":"<p>Returns <code>true</code> if this is a global path (starts with <code>::</code>)</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"../../Crystal/Macros/Path.html#global%3F%3ABoolLiteral-instance-method\">#global?</a></code> instead</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1363,"url":null},"def":{"name":"global","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"global?:BoolLiteral-instance-method","name":"global?","doc":"Returns `true` if this is a global path (starts with `::`)","summary":"<p>Returns <code>true</code> if this is a global path (starts with <code>::</code>)</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1358,"url":null},"def":{"name":"global?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"names:ArrayLiteral(MacroId)-instance-method","name":"names","doc":"Returns an array with each separate part of this path.","summary":"<p>Returns an array with each separate part of this path.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1354,"url":null},"def":{"name":"names","return_type":"ArrayLiteral(MacroId)","visibility":"Public","body":""}},{"html_id":"resolve:ASTNode-instance-method","name":"resolve","doc":"Resolves this path to a `TypeNode` if it denotes a type, to\nthe value of a constant if it denotes a constant, or otherwise\ngives a compile-time error.","summary":"<p>Resolves this path to a <code><a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a></code> if it denotes a type, to the value of a constant if it denotes a constant, or otherwise gives a compile-time error.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1369,"url":null},"def":{"name":"resolve","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"resolve?:ASTNode|NilLiteral-instance-method","name":"resolve?","doc":"Resolves this path to a `TypeNode` if it denotes a type, to\nthe value of a constant if it denotes a constant, or otherwise\nreturns a `NilLiteral`.","summary":"<p>Resolves this path to a <code><a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a></code> if it denotes a type, to the value of a constant if it denotes a constant, or otherwise returns a <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1375,"url":null},"def":{"name":"resolve?","return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}},{"html_id":"types:ArrayLiteral(ASTNode)-instance-method","name":"types","doc":"Returns this path inside an array literal.\nThis method exists so you can call `types` on the type of a type\ndeclaration and get all types, whether it's a Generic, Path or Union.","summary":"<p>Returns this path inside an array literal.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1381,"url":null},"def":{"name":"types","return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/PointerOf","path":"Crystal/Macros/PointerOf.html","kind":"class","full_name":"Crystal::Macros::PointerOf","name":"PointerOf","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1231,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `pointerof` expression.","summary":"<p>A <code>pointerof</code> expression.</p>"},{"html_id":"Crystal/Crystal/Macros/ProcLiteral","path":"Crystal/Macros/ProcLiteral.html","kind":"class","full_name":"Crystal::Macros::ProcLiteral","name":"ProcLiteral","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1504,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A proc method, written like:\n```\n->(arg : String) {\n  puts arg\n}\n```","summary":"<p>A proc method, written like: <code>->(arg : <a href=\"../../String.html\">String</a>) { puts arg }</code></p>","instance_methods":[{"html_id":"args:ArrayLiteral(Arg)-instance-method","name":"args","doc":"Returns the arguments of this proc.","summary":"<p>Returns the arguments of this proc.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1506,"url":null},"def":{"name":"args","return_type":"ArrayLiteral(Arg)","visibility":"Public","body":""}},{"html_id":"body:ASTNode-instance-method","name":"body","doc":"Returns the body of this proc.","summary":"<p>Returns the body of this proc.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1510,"url":null},"def":{"name":"body","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"return_type:ASTNode|Nop-instance-method","name":"return_type","doc":"Returns the return type of this proc, if specified.","summary":"<p>Returns the return type of this proc, if specified.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1514,"url":null},"def":{"name":"return_type","return_type":"ASTNode | Nop","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/ProcNotation","path":"Crystal/Macros/ProcNotation.html","kind":"class","full_name":"Crystal::Macros::ProcNotation","name":"ProcNotation","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1105,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"The type of a proc or block argument, like `String -> Int32`.","summary":"<p>The type of a proc or block argument, like <code><a href=\"../../String.html\">String</a> -> <a href=\"../../Int32.html\">Int32</a></code>.</p>","instance_methods":[{"html_id":"inputs:ArrayLiteral(ASTNode)-instance-method","name":"inputs","doc":"Returns the argument types, or an empty list if no arguments.","summary":"<p>Returns the argument types, or an empty list if no arguments.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1107,"url":null},"def":{"name":"inputs","return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}},{"html_id":"output:ASTNode|NilLiteral-instance-method","name":"output","doc":"Returns the output type, or nil if there is no return type.","summary":"<p>Returns the output type, or nil if there is no return type.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1111,"url":null},"def":{"name":"output","return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}},{"html_id":"resolve:ASTNode-instance-method","name":"resolve","doc":"Resolves this proc notation to a `TypeNode` if it denotes a type,\nor otherwise gives a compile-time error.","summary":"<p>Resolves this proc notation to a <code><a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a></code> if it denotes a type, or otherwise gives a compile-time error.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1116,"url":null},"def":{"name":"resolve","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"resolve?:ASTNode|NilLiteral-instance-method","name":"resolve?","doc":"Resolves this proc notation to a `TypeNode` if it denotes a type,\nor otherwise returns a `NilLiteral`.","summary":"<p>Resolves this proc notation to a <code><a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a></code> if it denotes a type, or otherwise returns a <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1121,"url":null},"def":{"name":"resolve?","return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/ProcPointer","path":"Crystal/Macros/ProcPointer.html","kind":"class","full_name":"Crystal::Macros::ProcPointer","name":"ProcPointer","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1519,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A proc pointer, like `->my_var.some_method(String)`","summary":"<p>A proc pointer, like <code>->my_var.some_method(<a href=\"../../String.html\">String</a>)</code></p>","instance_methods":[{"html_id":"args:ArrayLiteral(ASTNode)-instance-method","name":"args","doc":"Returns the types of the arguments of the proc.","summary":"<p>Returns the types of the arguments of the proc.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1521,"url":null},"def":{"name":"args","return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}},{"html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of the method this proc points to.","summary":"<p>Returns the name of the method this proc points to.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1529,"url":null},"def":{"name":"name","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"obj:ASTNode|NilLiteral-instance-method","name":"obj","doc":"Returns the receiver of the proc, or nil if the proc is not attached to an object.","summary":"<p>Returns the receiver of the proc, or nil if the proc is not attached to an object.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1525,"url":null},"def":{"name":"obj","return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/RangeLiteral","path":"Crystal/Macros/RangeLiteral.html","kind":"class","full_name":"Crystal::Macros::RangeLiteral","name":"RangeLiteral","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":808,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A range literal.","summary":"<p>A range literal.</p>","instance_methods":[{"html_id":"begin:ASTNode-instance-method","name":"begin","doc":"Similar to `Range#begin`","summary":"<p>Similar to <code><a href=\"../../Range.html#begin%3AB-instance-method\">Range#begin</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":810,"url":null},"def":{"name":"begin","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"each(&):Nil-instance-method","name":"each","doc":"Similar to `Range#each`","summary":"<p>Similar to <code><a href=\"../../Range.html#each%28%26%29%3ANil-instance-method\">Range#each</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":814,"url":null},"def":{"name":"each","yields":0,"return_type":"Nil","visibility":"Public","body":""}},{"html_id":"end:ASTNode-instance-method","name":"end","doc":"Similar to `Range#end`","summary":"<p>Similar to <code><a href=\"../../Range.html#end%3AE-instance-method\">Range#end</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":818,"url":null},"def":{"name":"end","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"excludes_end?:ASTNode-instance-method","name":"excludes_end?","doc":"Similar to `Range#excludes_end?`","summary":"<p>Similar to <code><a href=\"../../Range.html#excludes_end%3F%3ABool-instance-method\">Range#excludes_end?</a></code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":822,"url":null},"def":{"name":"excludes_end?","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"map(&):ArrayLiteral-instance-method","name":"map","doc":"Similar to `Enumerable#map` for a `Range`.\nOnly works on ranges of `NumberLiteral`s considered as integers.","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#map%28%26%3AT-%3EU%29%3AArray%28U%29forallU-instance-method\">Enumerable#map</a></code> for a <code><a href=\"../../Range.html\">Range</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":827,"url":null},"def":{"name":"map","yields":0,"return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"to_a:ArrayLiteral-instance-method","name":"to_a","doc":"Similar to `Enumerable#to_a` for a `Range`.\nOnly works on ranges of `NumberLiteral`s considered as integers.","summary":"<p>Similar to <code><a href=\"../../Enumerable.html#to_a-instance-method\">Enumerable#to_a</a></code> for a <code><a href=\"../../Range.html\">Range</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":832,"url":null},"def":{"name":"to_a","return_type":"ArrayLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/ReadInstanceVar","path":"Crystal/Macros/ReadInstanceVar.html","kind":"class","full_name":"Crystal::Macros::ReadInstanceVar","name":"ReadInstanceVar","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1038,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"Access to an instance variable, e.g. `obj.@var`.","summary":"<p>Access to an instance variable, e.g.</p>","instance_methods":[{"html_id":"name:MacroId-instance-method","name":"name","doc":"Returns the name of the instance variable being accessed.","summary":"<p>Returns the name of the instance variable being accessed.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1044,"url":null},"def":{"name":"name","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"obj:ASTNode-instance-method","name":"obj","doc":"Returns the object whose variable is being accessed.","summary":"<p>Returns the object whose variable is being accessed.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1040,"url":null},"def":{"name":"obj","return_type":"ASTNode","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/RegexLiteral","path":"Crystal/Macros/RegexLiteral.html","kind":"class","full_name":"Crystal::Macros::RegexLiteral","name":"RegexLiteral","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":837,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A regular expression literal.","summary":"<p>A regular expression literal.</p>","instance_methods":[{"html_id":"options:ArrayLiteral(SymbolLiteral)-instance-method","name":"options","doc":"Similar to `Regex#options`,\nbut returns an array of symbols such as `[:i, :m, :x]`","summary":"<p>Similar to <code><a href=\"../../Regex.html#options%3AOptions-instance-method\">Regex#options</a></code>, but returns an array of symbols such as <code>[:i, :m, :x]</code></p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":844,"url":null},"def":{"name":"options","return_type":"ArrayLiteral(SymbolLiteral)","visibility":"Public","body":""}},{"html_id":"source:StringLiteral|StringInterpolation-instance-method","name":"source","doc":"Similar to `Regex#source`.","summary":"<p>Similar to <code><a href=\"../../Regex.html#source%3AString-instance-method\">Regex#source</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":839,"url":null},"def":{"name":"source","return_type":"StringLiteral | StringInterpolation","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Require","path":"Crystal/Macros/Require.html","kind":"class","full_name":"Crystal::Macros::Require","name":"Require","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1299,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `require` statement.","summary":"<p>A <code>require</code> statement.</p>","instance_methods":[{"html_id":"path:StringLiteral-instance-method","name":"path","doc":"Returns the argument of the `require`.","summary":"<p>Returns the argument of the <code>require</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1301,"url":null},"def":{"name":"path","return_type":"StringLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Rescue","path":"Crystal/Macros/Rescue.html","kind":"class","full_name":"Crystal::Macros::Rescue","name":"Rescue","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1465,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `rescue` clause inside an exception handler.","summary":"<p>A <code>rescue</code> clause inside an exception handler.</p>","instance_methods":[{"html_id":"body:ASTNode-instance-method","name":"body","doc":"Returns this `rescue` clause's body.","summary":"<p>Returns this <code>rescue</code> clause's body.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1467,"url":null},"def":{"name":"body","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"name:MacroId|Nop-instance-method","name":"name","doc":"Returns the variable name of the rescued exception, if any.","summary":"<p>Returns the variable name of the rescued exception, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1475,"url":null},"def":{"name":"name","return_type":"MacroId | Nop","visibility":"Public","body":""}},{"html_id":"types:ArrayLiteral|NilLiteral-instance-method","name":"types","doc":"Returns this `rescue` clause's exception types, if any.","summary":"<p>Returns this <code>rescue</code> clause's exception types, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1471,"url":null},"def":{"name":"types","return_type":"ArrayLiteral | NilLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/RespondsTo","path":"Crystal/Macros/RespondsTo.html","kind":"class","full_name":"Crystal::Macros::RespondsTo","name":"RespondsTo","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1288,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `.responds_to?` call.","summary":"<p>A <code>.responds_to?</code> call.</p>","instance_methods":[{"html_id":"name:StringLiteral-instance-method","name":"name","doc":"Returns the method name that is being checked for.","summary":"<p>Returns the method name that is being checked for.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1294,"url":null},"def":{"name":"name","return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"receiver:ASTNode-instance-method","name":"receiver","doc":"Returns this call's receiver.","summary":"<p>Returns this call's receiver.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1290,"url":null},"def":{"name":"receiver","return_type":"ASTNode","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Return","path":"Crystal/Macros/Return.html","kind":"class","full_name":"Crystal::Macros::Return","name":"Return","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ControlExpression","kind":"class","full_name":"Crystal::Macros::ControlExpression","name":"ControlExpression"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ControlExpression","kind":"class","full_name":"Crystal::Macros::ControlExpression","name":"ControlExpression"},{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1564,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `return` expression.","summary":"<p>A <code>return</code> expression.</p>"},{"html_id":"Crystal/Crystal/Macros/SizeOf","path":"Crystal/Macros/SizeOf.html","kind":"class","full_name":"Crystal::Macros::SizeOf","name":"SizeOf","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1235,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `sizeof` expression.","summary":"<p>A <code>sizeof</code> expression.</p>"},{"html_id":"Crystal/Crystal/Macros/Splat","path":"Crystal/Macros/Splat.html","kind":"class","full_name":"Crystal::Macros::Splat","name":"Splat","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/UnaryExpression","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression"},{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1247,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A splat expression: `*exp`.","summary":"<p>A splat expression: <code>*exp</code>.</p>"},{"html_id":"Crystal/Crystal/Macros/StringInterpolation","path":"Crystal/Macros/StringInterpolation.html","kind":"class","full_name":"Crystal::Macros::StringInterpolation","name":"StringInterpolation","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":534,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An interpolated string like `\"Hello, #{name}!\"`.","summary":"<p>An interpolated string like <code>\"Hello, #{name}!\"</code>.</p>","instance_methods":[{"html_id":"expressions:ArrayLiteral(ASTNode)-instance-method","name":"expressions","doc":"Returns a list of expressions that comprise the interpolated string.\n\nThese alternate between `StringLiteral` for the plaintext parts and\n`ASTNode`s of any type for the interpolated expressions.","summary":"<p>Returns a list of expressions that comprise the interpolated string.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":539,"url":null},"def":{"name":"expressions","return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/StringLiteral","path":"Crystal/Macros/StringLiteral.html","kind":"class","full_name":"Crystal::Macros::StringLiteral","name":"StringLiteral","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":521,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A string literal.","summary":"<p>A string literal.</p>","instance_methods":[{"html_id":"+(other:StringLiteral|CharLiteral):StringLiteral-instance-method","name":"+","doc":"Similar to `String#+`.","summary":"<p>Similar to <code><a href=\"../../String.html#%2B%28other%3Aself%29%3AString-instance-method\">String#+</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : StringLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/CharLiteral.html\">CharLiteral</a>) : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"<(other:StringLiteral|MacroId):BoolLiteral-instance-method","name":"<","doc":"Similar to `String#<`","summary":"<p>Similar to <code>String#<</code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"StringLiteral | MacroId"}],"args_string":"(other : StringLiteral | MacroId) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":529,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"StringLiteral | MacroId"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"=~(range:RegexLiteral):BoolLiteral-instance-method","name":"=~","doc":"Similar to `String#=~`.","summary":"<p>Similar to <code><a href=\"../../String.html#%3D~%28regex%3ARegex%29%3AInt32%3F-instance-method\">String#=~</a></code>.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"RegexLiteral"}],"args_string":"(range : RegexLiteral) : BoolLiteral","args_html":"(range : <a href=\"../../Crystal/Macros/RegexLiteral.html\">RegexLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"=~","args":[{"name":"range","external_name":"range","restriction":"RegexLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":">(other:StringLiteral|MacroId):BoolLiteral-instance-method","name":">","doc":"Similar to `String#>`","summary":"<p>Similar to <code>String#></code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"StringLiteral | MacroId"}],"args_string":"(other : StringLiteral | MacroId) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":525,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"StringLiteral | MacroId"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"[](range:RangeLiteral):StringLiteral-instance-method","name":"[]","doc":"Similar to `String#[]`.","summary":"<p>Similar to <code><a href=\"../../String.html#%5B%5D%28start%3AInt%2Ccount%3AInt%29%3AString-instance-method\">String#[]</a></code>.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"RangeLiteral"}],"args_string":"(range : RangeLiteral) : StringLiteral","args_html":"(range : <a href=\"../../Crystal/Macros/RangeLiteral.html\">RangeLiteral</a>) : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"[]","args":[{"name":"range","external_name":"range","restriction":"RangeLiteral"}],"return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"camelcase(*,lower:BoolLiteral=false):StringLiteral-instance-method","name":"camelcase","doc":"Similar to `String#camelcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#camelcase%28io%3AIO%2Coptions%3AUnicode%3A%3ACaseOptions%3DUnicode%3A%3ACaseOptions%3A%3ANone%2C%2A%2Clower%3ABool%3Dfalse%29%3ANil-instance-method\">String#camelcase</a></code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"lower","default_value":"false","external_name":"lower","restriction":"BoolLiteral"}],"args_string":"(*, lower : BoolLiteral = false) : StringLiteral","args_html":"(*, lower : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a> = <span class=\"n\">false</span>) : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"camelcase","args":[{"name":"","external_name":"","restriction":""},{"name":"lower","default_value":"false","external_name":"lower","restriction":"BoolLiteral"}],"splat_index":0,"return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"capitalize:StringLiteral-instance-method","name":"capitalize","doc":"Similar to `String#capitalize`.","summary":"<p>Similar to <code><a href=\"../../String.html#capitalize%28options%3AUnicode%3A%3ACaseOptions%3D%3Anone%29%3AString-instance-method\">String#capitalize</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"capitalize","return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"chars:ArrayLiteral(CharLiteral)-instance-method","name":"chars","doc":"Similar to `String#chars`.","summary":"<p>Similar to <code><a href=\"../../String.html#chars%3AArray%28Char%29-instance-method\">String#chars</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"chars","return_type":"ArrayLiteral(CharLiteral)","visibility":"Public","body":""}},{"html_id":"chomp:StringLiteral-instance-method","name":"chomp","doc":"Similar to `String#chomp`.","summary":"<p>Similar to <code><a href=\"../../String.html#chomp%3AString-instance-method\">String#chomp</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"chomp","return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"count(other:CharLiteral):NumberLiteral-instance-method","name":"count","doc":"Similar to `String#count`.","summary":"<p>Similar to <code><a href=\"../../String.html#count%28%26%29-instance-method\">String#count</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"CharLiteral"}],"args_string":"(other : CharLiteral) : NumberLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/CharLiteral.html\">CharLiteral</a>) : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"count","args":[{"name":"other","external_name":"other","restriction":"CharLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"downcase:StringLiteral-instance-method","name":"downcase","doc":"Similar to `String#downcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#downcase%28options%3AUnicode%3A%3ACaseOptions%3D%3Anone%29%3AString-instance-method\">String#downcase</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"downcase","return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"empty?:BoolLiteral-instance-method","name":"empty?","doc":"Similar to `String#empty?`.","summary":"<p>Similar to <code><a href=\"../../String.html#empty%3F%3ABool-instance-method\">String#empty?</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"empty?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"ends_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"ends_with?","doc":"Similar to `String#ends_with?`.","summary":"<p>Similar to <code><a href=\"../../String.html#ends_with%3F%28str%3AString%29%3ABool-instance-method\">String#ends_with?</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/CharLiteral.html\">CharLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"ends_with?","args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"gsub(regex:RegexLiteral,replacement:StringLiteral):StringLiteral-instance-method","name":"gsub","doc":"Similar to `String#gsub`.","summary":"<p>Similar to <code><a href=\"../../String.html#gsub%28%26block%3AChar-%3E_%29-instance-method\">String#gsub</a></code>.</p>","abstract":false,"args":[{"name":"regex","external_name":"regex","restriction":"RegexLiteral"},{"name":"replacement","external_name":"replacement","restriction":"StringLiteral"}],"args_string":"(regex : RegexLiteral, replacement : StringLiteral) : StringLiteral","args_html":"(regex : <a href=\"../../Crystal/Macros/RegexLiteral.html\">RegexLiteral</a>, replacement : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>) : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"gsub","args":[{"name":"regex","external_name":"regex","restriction":"RegexLiteral"},{"name":"replacement","external_name":"replacement","restriction":"StringLiteral"}],"return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"id:MacroId-instance-method","name":"id","doc":"Returns a `MacroId` for this string's contents.","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code> for this string's contents.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"id","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"includes?(search:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"includes?","doc":"Similar to `String#includes?`.","summary":"<p>Similar to <code><a href=\"../../String.html#includes%3F%28search%3AChar%7CString%29%3ABool-instance-method\">String#includes?</a></code>.</p>","abstract":false,"args":[{"name":"search","external_name":"search","restriction":"StringLiteral | CharLiteral"}],"args_string":"(search : StringLiteral | CharLiteral) : BoolLiteral","args_html":"(search : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/CharLiteral.html\">CharLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"includes?","args":[{"name":"search","external_name":"search","restriction":"StringLiteral | CharLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"lines:ArrayLiteral(StringLiteral)-instance-method","name":"lines","doc":"Similar to `String#lines`.","summary":"<p>Similar to <code><a href=\"../../String.html#lines%28chomp%3Dtrue%29%3AArray%28String%29-instance-method\">String#lines</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"lines","return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"html_id":"size:NumberLiteral-instance-method","name":"size","doc":"Similar to `String#size`.","summary":"<p>Similar to <code><a href=\"../../String.html#size%3AInt32-instance-method\">String#size</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"size","return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"split(node:ASTNode):ArrayLiteral(StringLiteral)-instance-method","name":"split","doc":"Similar to `String#split`.","summary":"<p>Similar to <code><a href=\"../../String.html#split%28limit%3AInt32%3F%3Dnil%29%3AArray%28String%29-instance-method\">String#split</a></code>.</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":"ASTNode"}],"args_string":"(node : ASTNode) : ArrayLiteral(StringLiteral)","args_html":"(node : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>) : <a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a>(<a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>)","location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"split","args":[{"name":"node","external_name":"node","restriction":"ASTNode"}],"return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"html_id":"split:ArrayLiteral(StringLiteral)-instance-method","name":"split","doc":"Similar to `String#split`.","summary":"<p>Similar to <code><a href=\"../../String.html#split%28limit%3AInt32%3F%3Dnil%29%3AArray%28String%29-instance-method\">String#split</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"split","return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"html_id":"starts_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"starts_with?","doc":"Similar to `String#starts_with?`.","summary":"<p>Similar to <code><a href=\"../../String.html#starts_with%3F%28str%3AString%29%3ABool-instance-method\">String#starts_with?</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/CharLiteral.html\">CharLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"starts_with?","args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"strip:StringLiteral-instance-method","name":"strip","doc":"Similar to `String#strip`.","summary":"<p>Similar to <code><a href=\"../../String.html#strip%3AString-instance-method\">String#strip</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"strip","return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"titleize:StringLiteral-instance-method","name":"titleize","doc":"Similar to `String#titleize`.","summary":"<p>Similar to <code><a href=\"../../String.html#titleize%28options%3AUnicode%3A%3ACaseOptions%3D%3Anone%29%3AString-instance-method\">String#titleize</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"titleize","return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"to_i(base=10)-instance-method","name":"to_i","doc":"Similar to `String#to_i`.","summary":"<p>Similar to <code><a href=\"../../String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">String#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":""}],"args_string":"(base = 10)","args_html":"(base = <span class=\"n\">10</span>)","location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"to_i","args":[{"name":"base","default_value":"10","external_name":"base","restriction":""}],"visibility":"Public","body":""}},{"html_id":"tr(from:StringLiteral,to:StringLiteral):StringLiteral-instance-method","name":"tr","doc":"Similar to `String#tr`.","summary":"<p>Similar to <code><a href=\"../../String.html#tr%28from%3AString%2Cto%3AString%29%3AString-instance-method\">String#tr</a></code>.</p>","abstract":false,"args":[{"name":"from","external_name":"from","restriction":"StringLiteral"},{"name":"to","external_name":"to","restriction":"StringLiteral"}],"args_string":"(from : StringLiteral, to : StringLiteral) : StringLiteral","args_html":"(from : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>, to : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>) : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"tr","args":[{"name":"from","external_name":"from","restriction":"StringLiteral"},{"name":"to","external_name":"to","restriction":"StringLiteral"}],"return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"underscore:StringLiteral-instance-method","name":"underscore","doc":"Similar to `String#underscore`.","summary":"<p>Similar to <code><a href=\"../../String.html#underscore%28options%3AUnicode%3A%3ACaseOptions%3D%3Anone%29%3AString-instance-method\">String#underscore</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"underscore","return_type":"StringLiteral","visibility":"Public","body":""}},{"html_id":"upcase:StringLiteral-instance-method","name":"upcase","doc":"Similar to `String#upcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#upcase%28options%3AUnicode%3A%3ACaseOptions%3D%3Anone%29%3AString-instance-method\">String#upcase</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":522,"url":null},"def":{"name":"upcase","return_type":"StringLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/SymbolLiteral","path":"Crystal/Macros/SymbolLiteral.html","kind":"class","full_name":"Crystal::Macros::SymbolLiteral","name":"SymbolLiteral","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":544,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A symbol literal.","summary":"<p>A symbol literal.</p>","instance_methods":[{"html_id":"+(other:StringLiteral|CharLiteral):SymbolLiteral-instance-method","name":"+","doc":"Similar to `String#+`.","summary":"<p>Similar to <code><a href=\"../../String.html#%2B%28other%3Aself%29%3AString-instance-method\">String#+</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : SymbolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/CharLiteral.html\">CharLiteral</a>) : <a href=\"../../Crystal/Macros/SymbolLiteral.html\">SymbolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"return_type":"SymbolLiteral","visibility":"Public","body":""}},{"html_id":"=~(range:RegexLiteral):BoolLiteral-instance-method","name":"=~","doc":"Similar to `String#=~`.","summary":"<p>Similar to <code><a href=\"../../String.html#%3D~%28regex%3ARegex%29%3AInt32%3F-instance-method\">String#=~</a></code>.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"RegexLiteral"}],"args_string":"(range : RegexLiteral) : BoolLiteral","args_html":"(range : <a href=\"../../Crystal/Macros/RegexLiteral.html\">RegexLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"=~","args":[{"name":"range","external_name":"range","restriction":"RegexLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"[](range:RangeLiteral):SymbolLiteral-instance-method","name":"[]","doc":"Similar to `String#[]`.","summary":"<p>Similar to <code><a href=\"../../String.html#%5B%5D%28start%3AInt%2Ccount%3AInt%29%3AString-instance-method\">String#[]</a></code>.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"RangeLiteral"}],"args_string":"(range : RangeLiteral) : SymbolLiteral","args_html":"(range : <a href=\"../../Crystal/Macros/RangeLiteral.html\">RangeLiteral</a>) : <a href=\"../../Crystal/Macros/SymbolLiteral.html\">SymbolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"[]","args":[{"name":"range","external_name":"range","restriction":"RangeLiteral"}],"return_type":"SymbolLiteral","visibility":"Public","body":""}},{"html_id":"camelcase(*,lower:BoolLiteral=false):SymbolLiteral-instance-method","name":"camelcase","doc":"Similar to `String#camelcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#camelcase%28io%3AIO%2Coptions%3AUnicode%3A%3ACaseOptions%3DUnicode%3A%3ACaseOptions%3A%3ANone%2C%2A%2Clower%3ABool%3Dfalse%29%3ANil-instance-method\">String#camelcase</a></code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"lower","default_value":"false","external_name":"lower","restriction":"BoolLiteral"}],"args_string":"(*, lower : BoolLiteral = false) : SymbolLiteral","args_html":"(*, lower : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a> = <span class=\"n\">false</span>) : <a href=\"../../Crystal/Macros/SymbolLiteral.html\">SymbolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"camelcase","args":[{"name":"","external_name":"","restriction":""},{"name":"lower","default_value":"false","external_name":"lower","restriction":"BoolLiteral"}],"splat_index":0,"return_type":"SymbolLiteral","visibility":"Public","body":""}},{"html_id":"capitalize:SymbolLiteral-instance-method","name":"capitalize","doc":"Similar to `String#capitalize`.","summary":"<p>Similar to <code><a href=\"../../String.html#capitalize%28options%3AUnicode%3A%3ACaseOptions%3D%3Anone%29%3AString-instance-method\">String#capitalize</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"capitalize","return_type":"SymbolLiteral","visibility":"Public","body":""}},{"html_id":"chars:ArrayLiteral(CharLiteral)-instance-method","name":"chars","doc":"Similar to `String#chars`.","summary":"<p>Similar to <code><a href=\"../../String.html#chars%3AArray%28Char%29-instance-method\">String#chars</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"chars","return_type":"ArrayLiteral(CharLiteral)","visibility":"Public","body":""}},{"html_id":"chomp:SymbolLiteral-instance-method","name":"chomp","doc":"Similar to `String#chomp`.","summary":"<p>Similar to <code><a href=\"../../String.html#chomp%3AString-instance-method\">String#chomp</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"chomp","return_type":"SymbolLiteral","visibility":"Public","body":""}},{"html_id":"count(other:CharLiteral):NumberLiteral-instance-method","name":"count","doc":"Similar to `String#count`.","summary":"<p>Similar to <code><a href=\"../../String.html#count%28%26%29-instance-method\">String#count</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"CharLiteral"}],"args_string":"(other : CharLiteral) : NumberLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/CharLiteral.html\">CharLiteral</a>) : <a href=\"../../Crystal/Macros/NumberLiteral.html\">NumberLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"count","args":[{"name":"other","external_name":"other","restriction":"CharLiteral"}],"return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"downcase:SymbolLiteral-instance-method","name":"downcase","doc":"Similar to `String#downcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#downcase%28options%3AUnicode%3A%3ACaseOptions%3D%3Anone%29%3AString-instance-method\">String#downcase</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"downcase","return_type":"SymbolLiteral","visibility":"Public","body":""}},{"html_id":"empty?:BoolLiteral-instance-method","name":"empty?","doc":"Similar to `String#empty?`.","summary":"<p>Similar to <code><a href=\"../../String.html#empty%3F%3ABool-instance-method\">String#empty?</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"empty?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"ends_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"ends_with?","doc":"Similar to `String#ends_with?`.","summary":"<p>Similar to <code><a href=\"../../String.html#ends_with%3F%28str%3AString%29%3ABool-instance-method\">String#ends_with?</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/CharLiteral.html\">CharLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"ends_with?","args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"gsub(regex:RegexLiteral,replacement:StringLiteral):SymbolLiteral-instance-method","name":"gsub","doc":"Similar to `String#gsub`.","summary":"<p>Similar to <code><a href=\"../../String.html#gsub%28%26block%3AChar-%3E_%29-instance-method\">String#gsub</a></code>.</p>","abstract":false,"args":[{"name":"regex","external_name":"regex","restriction":"RegexLiteral"},{"name":"replacement","external_name":"replacement","restriction":"StringLiteral"}],"args_string":"(regex : RegexLiteral, replacement : StringLiteral) : SymbolLiteral","args_html":"(regex : <a href=\"../../Crystal/Macros/RegexLiteral.html\">RegexLiteral</a>, replacement : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>) : <a href=\"../../Crystal/Macros/SymbolLiteral.html\">SymbolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"gsub","args":[{"name":"regex","external_name":"regex","restriction":"RegexLiteral"},{"name":"replacement","external_name":"replacement","restriction":"StringLiteral"}],"return_type":"SymbolLiteral","visibility":"Public","body":""}},{"html_id":"id:MacroId-instance-method","name":"id","doc":"Returns a `MacroId` for this string's contents.","summary":"<p>Returns a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code> for this string's contents.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"id","return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"includes?(search:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"includes?","doc":"Similar to `String#includes?`.","summary":"<p>Similar to <code><a href=\"../../String.html#includes%3F%28search%3AChar%7CString%29%3ABool-instance-method\">String#includes?</a></code>.</p>","abstract":false,"args":[{"name":"search","external_name":"search","restriction":"StringLiteral | CharLiteral"}],"args_string":"(search : StringLiteral | CharLiteral) : BoolLiteral","args_html":"(search : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/CharLiteral.html\">CharLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"includes?","args":[{"name":"search","external_name":"search","restriction":"StringLiteral | CharLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"lines:ArrayLiteral(StringLiteral)-instance-method","name":"lines","doc":"Similar to `String#lines`.","summary":"<p>Similar to <code><a href=\"../../String.html#lines%28chomp%3Dtrue%29%3AArray%28String%29-instance-method\">String#lines</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"lines","return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"html_id":"size:NumberLiteral-instance-method","name":"size","doc":"Similar to `String#size`.","summary":"<p>Similar to <code><a href=\"../../String.html#size%3AInt32-instance-method\">String#size</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"size","return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"split(node:ASTNode):ArrayLiteral(StringLiteral)-instance-method","name":"split","doc":"Similar to `String#split`.","summary":"<p>Similar to <code><a href=\"../../String.html#split%28limit%3AInt32%3F%3Dnil%29%3AArray%28String%29-instance-method\">String#split</a></code>.</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":"ASTNode"}],"args_string":"(node : ASTNode) : ArrayLiteral(StringLiteral)","args_html":"(node : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>) : <a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a>(<a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>)","location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"split","args":[{"name":"node","external_name":"node","restriction":"ASTNode"}],"return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"html_id":"split:ArrayLiteral(StringLiteral)-instance-method","name":"split","doc":"Similar to `String#split`.","summary":"<p>Similar to <code><a href=\"../../String.html#split%28limit%3AInt32%3F%3Dnil%29%3AArray%28String%29-instance-method\">String#split</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"split","return_type":"ArrayLiteral(StringLiteral)","visibility":"Public","body":""}},{"html_id":"starts_with?(other:StringLiteral|CharLiteral):BoolLiteral-instance-method","name":"starts_with?","doc":"Similar to `String#starts_with?`.","summary":"<p>Similar to <code><a href=\"../../String.html#starts_with%3F%28str%3AString%29%3ABool-instance-method\">String#starts_with?</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"args_string":"(other : StringLiteral | CharLiteral) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/CharLiteral.html\">CharLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"starts_with?","args":[{"name":"other","external_name":"other","restriction":"StringLiteral | CharLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"strip:SymbolLiteral-instance-method","name":"strip","doc":"Similar to `String#strip`.","summary":"<p>Similar to <code><a href=\"../../String.html#strip%3AString-instance-method\">String#strip</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"strip","return_type":"SymbolLiteral","visibility":"Public","body":""}},{"html_id":"titleize:SymbolLiteral-instance-method","name":"titleize","doc":"Similar to `String#titleize`.","summary":"<p>Similar to <code><a href=\"../../String.html#titleize%28options%3AUnicode%3A%3ACaseOptions%3D%3Anone%29%3AString-instance-method\">String#titleize</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"titleize","return_type":"SymbolLiteral","visibility":"Public","body":""}},{"html_id":"to_i(base=10)-instance-method","name":"to_i","doc":"Similar to `String#to_i`.","summary":"<p>Similar to <code><a href=\"../../String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">String#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":""}],"args_string":"(base = 10)","args_html":"(base = <span class=\"n\">10</span>)","location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"to_i","args":[{"name":"base","default_value":"10","external_name":"base","restriction":""}],"visibility":"Public","body":""}},{"html_id":"tr(from:StringLiteral,to:StringLiteral):SymbolLiteral-instance-method","name":"tr","doc":"Similar to `String#tr`.","summary":"<p>Similar to <code><a href=\"../../String.html#tr%28from%3AString%2Cto%3AString%29%3AString-instance-method\">String#tr</a></code>.</p>","abstract":false,"args":[{"name":"from","external_name":"from","restriction":"StringLiteral"},{"name":"to","external_name":"to","restriction":"StringLiteral"}],"args_string":"(from : StringLiteral, to : StringLiteral) : SymbolLiteral","args_html":"(from : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>, to : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a>) : <a href=\"../../Crystal/Macros/SymbolLiteral.html\">SymbolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"tr","args":[{"name":"from","external_name":"from","restriction":"StringLiteral"},{"name":"to","external_name":"to","restriction":"StringLiteral"}],"return_type":"SymbolLiteral","visibility":"Public","body":""}},{"html_id":"underscore:SymbolLiteral-instance-method","name":"underscore","doc":"Similar to `String#underscore`.","summary":"<p>Similar to <code><a href=\"../../String.html#underscore%28options%3AUnicode%3A%3ACaseOptions%3D%3Anone%29%3AString-instance-method\">String#underscore</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"underscore","return_type":"SymbolLiteral","visibility":"Public","body":""}},{"html_id":"upcase:SymbolLiteral-instance-method","name":"upcase","doc":"Similar to `String#upcase`.","summary":"<p>Similar to <code><a href=\"../../String.html#upcase%28options%3AUnicode%3A%3ACaseOptions%3D%3Anone%29%3AString-instance-method\">String#upcase</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":545,"url":null},"def":{"name":"upcase","return_type":"SymbolLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/TupleLiteral","path":"Crystal/Macros/TupleLiteral.html","kind":"class","full_name":"Crystal::Macros::TupleLiteral","name":"TupleLiteral","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":851,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A tuple literal.\n\nIts macro methods are nearly the same as `ArrayLiteral`.","summary":"<p>A tuple literal.</p>"},{"html_id":"Crystal/Crystal/Macros/TypeDeclaration","path":"Crystal/Macros/TypeDeclaration.html","kind":"class","full_name":"Crystal::Macros::TypeDeclaration","name":"TypeDeclaration","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1439,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A type declaration like `x : Int32`","summary":"<p>A type declaration like <code>x : <a href=\"../../Int32.html\">Int32</a></code></p>","instance_methods":[{"html_id":"type:ASTNode-instance-method","name":"type","doc":"Returns the type part of the declaration.","summary":"<p>Returns the type part of the declaration.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1445,"url":null},"def":{"name":"type","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"value:ASTNode|Nop-instance-method","name":"value","doc":"The value assigned to the variable, if any.","summary":"<p>The value assigned to the variable, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1449,"url":null},"def":{"name":"value","return_type":"ASTNode | Nop","visibility":"Public","body":""}},{"html_id":"var:MacroId-instance-method","name":"var","doc":"Returns the variable part of the declaration.","summary":"<p>Returns the variable part of the declaration.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1441,"url":null},"def":{"name":"var","return_type":"MacroId","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/TypeNode","path":"Crystal/Macros/TypeNode.html","kind":"class","full_name":"Crystal::Macros::TypeNode","name":"TypeNode","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1747,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"Represents a type in the program, like `Int32` or `String`.","summary":"<p>Represents a type in the program, like <code><a href=\"../../Int32.html\">Int32</a></code> or <code><a href=\"../../String.html\">String</a></code>.</p>","instance_methods":[{"html_id":"<(other:TypeNode):BoolLiteral-instance-method","name":"<","doc":"Returns `true` if *other* is an ancestor of `self`.","summary":"<p>Returns <code>true</code> if <em>other</em> is an ancestor of <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"TypeNode"}],"args_string":"(other : TypeNode) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1990,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"TypeNode"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"<=(other:TypeNode):BoolLiteral-instance-method","name":"<=","doc":"Returns `true` if `self` is the same as *other* or if\n*other* is an ancestor of `self`.","summary":"<p>Returns <code>true</code> if <code>self</code> is the same as <em>other</em> or if <em>other</em> is an ancestor of <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"TypeNode"}],"args_string":"(other : TypeNode) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1995,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"TypeNode"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":">(other:TypeNode):BoolLiteral-instance-method","name":">","doc":"Returns `true` if `self` is an ancestor of *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is an ancestor of <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"TypeNode"}],"args_string":"(other : TypeNode) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1999,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"TypeNode"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":">=(other:TypeNode):BoolLiteral-instance-method","name":">=","doc":"Returns `true` if *other* is the same as `self` or if\n`self` is an ancestor of *other*.","summary":"<p>Returns <code>true</code> if <em>other</em> is the same as <code>self</code> or if <code>self</code> is an ancestor of <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"TypeNode"}],"args_string":"(other : TypeNode) : BoolLiteral","args_html":"(other : <a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":2004,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"TypeNode"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"[](key:SymbolLiteral|MacroId):TypeNode|NilLiteral-instance-method","name":"[]","doc":"Returns the type for the given key in this named tuple type.\nGives a compile error if this is not a named tuple type.","summary":"<p>Returns the type for the given key in this named tuple type.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"SymbolLiteral | MacroId"}],"args_string":"(key : SymbolLiteral | MacroId) : TypeNode | NilLiteral","args_html":"(key : <a href=\"../../Crystal/Macros/SymbolLiteral.html\">SymbolLiteral</a> | <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>) : <a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a> | <a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1943,"url":null},"def":{"name":"[]","args":[{"name":"key","external_name":"key","restriction":"SymbolLiteral | MacroId"}],"return_type":"TypeNode | NilLiteral","visibility":"Public","body":""}},{"html_id":"abstract?:BoolLiteral-instance-method","name":"abstract?","doc":"Returns `true` if `self` is abstract, otherwise `false`.\n\n```\nmodule One; end\n\nabstract struct Two; end\n\nclass Three; end\n\nabstract class Four; end\n\n{{One.abstract?}}   # => false\n{{Two.abstract?}}   # => true\n{{Three.abstract?}} # => false\n{{Four.abstract?}}  # => true\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is abstract, otherwise <code>false</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1764,"url":null},"def":{"name":"abstract?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"all_subclasses:ArrayLiteral(TypeNode)-instance-method","name":"all_subclasses","doc":"Returns all subclasses of this type.","summary":"<p>Returns all subclasses of this type.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1889,"url":null},"def":{"name":"all_subclasses","return_type":"ArrayLiteral(TypeNode)","visibility":"Public","body":""}},{"html_id":"ancestors:ArrayLiteral(TypeNode)-instance-method","name":"ancestors","doc":"Returns all ancestors of this type.","summary":"<p>Returns all ancestors of this type.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1873,"url":null},"def":{"name":"ancestors","return_type":"ArrayLiteral(TypeNode)","visibility":"Public","body":""}},{"html_id":"annotation(type:TypeNode):Annotation|NilLiteral-instance-method","name":"annotation","doc":"Returns the last `Annotation` with the given `type`\nattached to this variable or `NilLiteral` if there are none.","summary":"<p>Returns the last <code><a href=\"../../Crystal/Macros/Annotation.html\">Annotation</a></code> with the given <code>type</code> attached to this variable or <code><a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a></code> if there are none.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"TypeNode"}],"args_string":"(type : TypeNode) : Annotation | NilLiteral","args_html":"(type : <a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a>) : <a href=\"../../Crystal/Macros/Annotation.html\">Annotation</a> | <a href=\"../../Crystal/Macros/NilLiteral.html\">NilLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1923,"url":null},"def":{"name":"annotation","args":[{"name":"type","external_name":"type","restriction":"TypeNode"}],"return_type":"Annotation | NilLiteral","visibility":"Public","body":""}},{"html_id":"annotations(type:TypeNode):ArrayLiteral(Annotation)-instance-method","name":"annotations","doc":"Returns an array of annotations with the given `type`\nattached to this variable, or an empty `ArrayLiteral` if there are none.","summary":"<p>Returns an array of annotations with the given <code>type</code> attached to this variable, or an empty <code><a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a></code> if there are none.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"TypeNode"}],"args_string":"(type : TypeNode) : ArrayLiteral(Annotation)","args_html":"(type : <a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a>) : <a href=\"../../Crystal/Macros/ArrayLiteral.html\">ArrayLiteral</a>(<a href=\"../../Crystal/Macros/Annotation.html\">Annotation</a>)","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1928,"url":null},"def":{"name":"annotations","args":[{"name":"type","external_name":"type","restriction":"TypeNode"}],"return_type":"ArrayLiteral(Annotation)","visibility":"Public","body":""}},{"html_id":"class:TypeNode-instance-method","name":"class","doc":"Returns the class of this type. With this you can, for example, obtain class\nmethods by invoking `type.class.methods`.","summary":"<p>Returns the class of this type.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1948,"url":null},"def":{"name":"class","return_type":"TypeNode","visibility":"Public","body":""}},{"html_id":"class?:BoolLiteral-instance-method","name":"class?","doc":"Returns `true` if `self` is a `class`, otherwise `false`.\n\n```\nmodule One; end\n\nclass Two; end\n\nstruct Three; end\n\n{{One.class?}}   # => false\n{{Two.class?}}   # => true\n{{Three.class?}} # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is a <code><a href=\"../../Crystal/Macros/TypeNode.html#class%3ATypeNode-instance-method\">#class</a></code>, otherwise <code>false</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1818,"url":null},"def":{"name":"class?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"class_vars:ArrayLiteral(MetaVar)-instance-method","name":"class_vars","doc":"Returns the class variables of this type.","summary":"<p>Returns the class variables of this type.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1869,"url":null},"def":{"name":"class_vars","return_type":"ArrayLiteral(MetaVar)","visibility":"Public","body":""}},{"html_id":"constant(name:StringLiteral|SymbolLiteral|MacroId):ASTNode-instance-method","name":"constant","doc":"Returns a constant defined in this type.\n\nIf the constant is a constant (like `A = 1`), then its value\nas an `ASTNode` is returned. If the constant is a type, the\ntype is returned as a `TypeNode`. Otherwise, `NilLiteral` is returned.","summary":"<p>Returns a constant defined in this type.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"StringLiteral | SymbolLiteral | MacroId"}],"args_string":"(name : StringLiteral | SymbolLiteral | MacroId) : ASTNode","args_html":"(name : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/SymbolLiteral.html\">SymbolLiteral</a> | <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>) : <a href=\"../../Crystal/Macros/ASTNode.html\">ASTNode</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1901,"url":null},"def":{"name":"constant","args":[{"name":"name","external_name":"name","restriction":"StringLiteral | SymbolLiteral | MacroId"}],"return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"constants:ArrayLiteral(MacroId)-instance-method","name":"constants","doc":"Returns the constants and types defined by this type.","summary":"<p>Returns the constants and types defined by this type.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1893,"url":null},"def":{"name":"constants","return_type":"ArrayLiteral(MacroId)","visibility":"Public","body":""}},{"html_id":"has_constant?(name:StringLiteral|SymbolLiteral):BoolLiteral-instance-method","name":"has_constant?","doc":"Returns `true` if this type has a constant. For example `DEFAULT_OPTIONS`\n(the name you pass to this method is `\"DEFAULT_OPTIONS\"` or `:DEFAULT_OPTIONS`\nin this cases).","summary":"<p>Returns <code>true</code> if this type has a constant.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"StringLiteral | SymbolLiteral"}],"args_string":"(name : StringLiteral | SymbolLiteral) : BoolLiteral","args_html":"(name : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/SymbolLiteral.html\">SymbolLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1907,"url":null},"def":{"name":"has_constant?","args":[{"name":"name","external_name":"name","restriction":"StringLiteral | SymbolLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"has_method?(name:StringLiteral|SymbolLiteral):BoolLiteral-instance-method","name":"has_method?","doc":"Returns `true` if this type has a method. For example `default_options`\n(the name you pass to this method is `\"default_options\"` or `:default_options`\nin this cases).","summary":"<p>Returns <code>true</code> if this type has a method.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"StringLiteral | SymbolLiteral"}],"args_string":"(name : StringLiteral | SymbolLiteral) : BoolLiteral","args_html":"(name : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/SymbolLiteral.html\">SymbolLiteral</a>) : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1918,"url":null},"def":{"name":"has_method?","args":[{"name":"name","external_name":"name","restriction":"StringLiteral | SymbolLiteral"}],"return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"includers:ArrayLiteral(TypeNode)-instance-method","name":"includers","doc":"Returns all the types `self` is directly included in.","summary":"<p>Returns all the types <code>self</code> is directly included in.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1885,"url":null},"def":{"name":"includers","return_type":"ArrayLiteral(TypeNode)","visibility":"Public","body":""}},{"html_id":"instance:TypeNode-instance-method","name":"instance","doc":"Returns the instance type of this type, if it's a class type,\nor `self` otherwise. This is the opposite of `#class`.","summary":"<p>Returns the instance type of this type, if it's a class type, or <code>self</code> otherwise.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1953,"url":null},"def":{"name":"instance","return_type":"TypeNode","visibility":"Public","body":""}},{"html_id":"instance_vars:ArrayLiteral(MetaVar)-instance-method","name":"instance_vars","doc":"Returns the instance variables of this type.\nCan only be called from within methods (not top-level code), otherwise will return an empty list.","summary":"<p>Returns the instance variables of this type.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1865,"url":null},"def":{"name":"instance_vars","return_type":"ArrayLiteral(MetaVar)","visibility":"Public","body":""}},{"html_id":"keys:ArrayLiteral(MacroId)-instance-method","name":"keys","doc":"Returns the keys in this named tuple type.\nGives a compile error if this is not a named tuple type.","summary":"<p>Returns the keys in this named tuple type.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1938,"url":null},"def":{"name":"keys","return_type":"ArrayLiteral(MacroId)","visibility":"Public","body":""}},{"html_id":"methods:ArrayLiteral(Def)-instance-method","name":"methods","doc":"Returns the instance methods defined by this type, without including\ninherited methods.","summary":"<p>Returns the instance methods defined by this type, without including inherited methods.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1912,"url":null},"def":{"name":"methods","return_type":"ArrayLiteral(Def)","visibility":"Public","body":""}},{"html_id":"module?:BoolLiteral-instance-method","name":"module?","doc":"Returns `true` if `self` is a `module`, otherwise `false`.\n\n```\nmodule One; end\n\nclass Two; end\n\nstruct Three; end\n\n{{One.module?}}   # => true\n{{Two.module?}}   # => false\n{{Three.module?}} # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is a <code>module</code>, otherwise <code>false</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1802,"url":null},"def":{"name":"module?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"name(*,generic_args:BoolLiteral=true):MacroId-instance-method","name":"name","doc":"Returns the fully qualified name of this type.  Optionally without *generic_args* if `self` is a generic type; see `#type_vars`.\n\n```\nclass Foo(T); end\n\nmodule Bar::Baz; end\n\n{{Bar::Baz.name}}                 # => Bar::Baz\n{{Foo.name}}                      # => Foo(T)\n{{Foo.name(generic_args: false)}} # => Foo\n```","summary":"<p>Returns the fully qualified name of this type.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"generic_args","default_value":"true","external_name":"generic_args","restriction":"BoolLiteral"}],"args_string":"(*, generic_args : BoolLiteral = true) : MacroId","args_html":"(*, generic_args : <a href=\"../../Crystal/Macros/BoolLiteral.html\">BoolLiteral</a> = <span class=\"n\">true</span>) : <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1855,"url":null},"def":{"name":"name","args":[{"name":"","external_name":"","restriction":""},{"name":"generic_args","default_value":"true","external_name":"generic_args","restriction":"BoolLiteral"}],"splat_index":0,"return_type":"MacroId","visibility":"Public","body":""}},{"html_id":"nilable?:BoolLiteral-instance-method","name":"nilable?","doc":"Returns `true` if `self` is nilable (if it has `Nil` amongst its types), otherwise `false`.\n\n```\n{{String.nilable?}}                   # => false\n{{String?.nilable?}}                  # => true\n{{Union(String, Bool, Nil).nilable?}} # => true\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is nilable (if it has <code><a href=\"../../Nil.html\">Nil</a></code> amongst its types), otherwise <code>false</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1786,"url":null},"def":{"name":"nilable?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"overrides?(type:TypeNode,method:StringLiteral|SymbolLiteral|MacroId):Bool-instance-method","name":"overrides?","doc":"Determines if `self` overrides any method named *method* from type *type*.\n\n```\nclass Foo\n  def one\n    1\n  end\n\n  def two\n    2\n  end\nend\n\nclass Bar < Foo\n  def one\n    11\n  end\nend\n\n{{ Bar.overrides?(Foo, \"one\") }} # => true\n{{ Bar.overrides?(Foo, \"two\") }} # => false\n```","summary":"<p>Determines if <code>self</code> overrides any method named <em>method</em> from type <em>type</em>.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"TypeNode"},{"name":"method","external_name":"method","restriction":"StringLiteral | SymbolLiteral | MacroId"}],"args_string":"(type : TypeNode, method : StringLiteral | SymbolLiteral | MacroId) : Bool","args_html":"(type : <a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a>, method : <a href=\"../../Crystal/Macros/StringLiteral.html\">StringLiteral</a> | <a href=\"../../Crystal/Macros/SymbolLiteral.html\">SymbolLiteral</a> | <a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a>) : <a href=\"../../Bool.html\">Bool</a>","location":{"filename":"src/compiler/crystal/macros.cr","line_number":1978,"url":null},"def":{"name":"overrides?","args":[{"name":"type","external_name":"type","restriction":"TypeNode"},{"name":"method","external_name":"method","restriction":"StringLiteral | SymbolLiteral | MacroId"}],"return_type":"Bool","visibility":"Public","body":""}},{"html_id":"resolve:TypeNode-instance-method","name":"resolve","doc":"Returns `self`. This method exists so you can safely call `resolve` on a node and resolve it to a type, even if it's a type already.","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1982,"url":null},"def":{"name":"resolve","return_type":"TypeNode","visibility":"Public","body":""}},{"html_id":"resolve?:TypeNode-instance-method","name":"resolve?","doc":"Returns `self`. This method exists so you can safely call `resolve` on a node and resolve it to a type, even if it's a type already.","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1986,"url":null},"def":{"name":"resolve?","return_type":"TypeNode","visibility":"Public","body":""}},{"html_id":"size:NumberLiteral-instance-method","name":"size","doc":"Returns the number of elements in this tuple type or tuple metaclass type.\nGives a compile error if this is not one of those types.","summary":"<p>Returns the number of elements in this tuple type or tuple metaclass type.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1933,"url":null},"def":{"name":"size","return_type":"NumberLiteral","visibility":"Public","body":""}},{"html_id":"struct?:BoolLiteral-instance-method","name":"struct?","doc":"Returns `true` if `self` is a `struct`, otherwise `false`.\n\n```\nmodule One; end\n\nclass Two; end\n\nstruct Three; end\n\n{{One.struct?}}   # => false\n{{Two.struct?}}   # => false\n{{Three.struct?}} # => true\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is a <code>struct</code>, otherwise <code>false</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1834,"url":null},"def":{"name":"struct?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"subclasses:ArrayLiteral(TypeNode)-instance-method","name":"subclasses","doc":"Returns the direct subclasses of this type.","summary":"<p>Returns the direct subclasses of this type.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1881,"url":null},"def":{"name":"subclasses","return_type":"ArrayLiteral(TypeNode)","visibility":"Public","body":""}},{"html_id":"superclass:TypeNode|NilLiteral-instance-method","name":"superclass","doc":"Returns the direct superclass of this type.","summary":"<p>Returns the direct superclass of this type.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1877,"url":null},"def":{"name":"superclass","return_type":"TypeNode | NilLiteral","visibility":"Public","body":""}},{"html_id":"type_vars:ArrayLiteral(TypeNode)-instance-method","name":"type_vars","doc":"Returns the type variables of the generic type. If the type is not\ngeneric, an empty array is returned.","summary":"<p>Returns the type variables of the generic type.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1860,"url":null},"def":{"name":"type_vars","return_type":"ArrayLiteral(TypeNode)","visibility":"Public","body":""}},{"html_id":"union?:BoolLiteral-instance-method","name":"union?","doc":"Returns `true` if `self` is a union type, otherwise `false`.\n\nSee also: `#union_types`.\n\n```\n{{String.union?}}              # => false\n{{String?.union?}}             # => true\n{{Union(String, Bool).union?}} # => true\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is a union type, otherwise <code>false</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1776,"url":null},"def":{"name":"union?","return_type":"BoolLiteral","visibility":"Public","body":""}},{"html_id":"union_types:ArrayLiteral(TypeNode)-instance-method","name":"union_types","doc":"Returns the types forming a union type, if this is a union type.\nOtherwise returns this single type inside an array literal (so you can safely call `union_types` on any type and treat all types uniformly).\n\nSee also: `#union?`.","summary":"<p>Returns the types forming a union type, if this is a union type.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1841,"url":null},"def":{"name":"union_types","return_type":"ArrayLiteral(TypeNode)","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/UnaryExpression","path":"Crystal/Macros/UnaryExpression.html","kind":"class","full_name":"Crystal::Macros::UnaryExpression","name":"UnaryExpression","abstract":true,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1220,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/Crystal/Macros/DoubleSplat","kind":"class","full_name":"Crystal::Macros::DoubleSplat","name":"DoubleSplat"},{"html_id":"Crystal/Crystal/Macros/InstanceSizeOf","kind":"class","full_name":"Crystal::Macros::InstanceSizeOf","name":"InstanceSizeOf"},{"html_id":"Crystal/Crystal/Macros/Not","kind":"class","full_name":"Crystal::Macros::Not","name":"Not"},{"html_id":"Crystal/Crystal/Macros/Out","kind":"class","full_name":"Crystal::Macros::Out","name":"Out"},{"html_id":"Crystal/Crystal/Macros/PointerOf","kind":"class","full_name":"Crystal::Macros::PointerOf","name":"PointerOf"},{"html_id":"Crystal/Crystal/Macros/SizeOf","kind":"class","full_name":"Crystal::Macros::SizeOf","name":"SizeOf"},{"html_id":"Crystal/Crystal/Macros/Splat","kind":"class","full_name":"Crystal::Macros::Splat","name":"Splat"}],"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An unary expression","summary":"<p>An unary expression</p>","instance_methods":[{"html_id":"exp:ASTNode-instance-method","name":"exp","doc":"Returns the expression that this unary operation is applied to.","summary":"<p>Returns the expression that this unary operation is applied to.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1222,"url":null},"def":{"name":"exp","return_type":"ASTNode","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/UninitializedVar","path":"Crystal/Macros/UninitializedVar.html","kind":"class","full_name":"Crystal::Macros::UninitializedVar","name":"UninitializedVar","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1454,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"An uninitialized variable declaration: `a = uninitialized Int32`","summary":"<p>An uninitialized variable declaration: <code>a = uninitialized <a href=\"../../Int32.html\">Int32</a></code></p>","instance_methods":[{"html_id":"type:ASTNode-instance-method","name":"type","doc":"Returns the type part of the declaration.","summary":"<p>Returns the type part of the declaration.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1460,"url":null},"def":{"name":"type","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"var:MacroId-instance-method","name":"var","doc":"Returns the variable part of the declaration.","summary":"<p>Returns the variable part of the declaration.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1456,"url":null},"def":{"name":"var","return_type":"MacroId","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Union","path":"Crystal/Macros/Union.html","kind":"class","full_name":"Crystal::Macros::Union","name":"Union","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1534,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A type union, like `(Int32 | String)`.","summary":"<p>A type union, like <code>(<a href=\"../../Int32.html\">Int32</a> | <a href=\"../../String.html\">String</a>)</code>.</p>","instance_methods":[{"html_id":"resolve:ASTNode-instance-method","name":"resolve","doc":"Resolves this union to a `TypeNode`. Gives a compile-time error\nif any type inside the union can't be resolved.","summary":"<p>Resolves this union to a <code><a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1537,"url":null},"def":{"name":"resolve","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"resolve?:ASTNode|NilLiteral-instance-method","name":"resolve?","doc":"Resolves this union to a `TypeNode`. Returns a `NilLiteral`\nif any type inside the union can't be resolved.","summary":"<p>Resolves this union to a <code><a href=\"../../Crystal/Macros/TypeNode.html\">TypeNode</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1542,"url":null},"def":{"name":"resolve?","return_type":"ASTNode | NilLiteral","visibility":"Public","body":""}},{"html_id":"types:ArrayLiteral(ASTNode)-instance-method","name":"types","doc":"Returns the types of this union.","summary":"<p>Returns the types of this union.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1546,"url":null},"def":{"name":"types","return_type":"ArrayLiteral(ASTNode)","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Var","path":"Crystal/Macros/Var.html","kind":"class","full_name":"Crystal::Macros::Var","name":"Var","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":916,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A local variable or block argument.","summary":"<p>A local variable or block argument.</p>","instance_methods":[{"html_id":"id:MacroId-instance-method","name":"id","doc":"Returns this var's name as a `MacroId`.","summary":"<p>Returns this var's name as a <code><a href=\"../../Crystal/Macros/MacroId.html\">MacroId</a></code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":918,"url":null},"def":{"name":"id","return_type":"MacroId","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/VisibilityModifier","path":"Crystal/Macros/VisibilityModifier.html","kind":"class","full_name":"Crystal::Macros::VisibilityModifier","name":"VisibilityModifier","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1266,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A visibility modifier","summary":"<p>A visibility modifier</p>","instance_methods":[{"html_id":"exp:ASTNode-instance-method","name":"exp","doc":"Returns the expression that the modifier is applied to.","summary":"<p>Returns the expression that the modifier is applied to.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1272,"url":null},"def":{"name":"exp","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"visibility:SymbolLiteral-instance-method","name":"visibility","doc":"Returns the visibility of this modifier: `:public`, `:protected` or `:private`.","summary":"<p>Returns the visibility of this modifier: <code>:public</code>, <code>:protected</code> or <code>:private</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1268,"url":null},"def":{"name":"visibility","return_type":"SymbolLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/When","path":"Crystal/Macros/When.html","kind":"class","full_name":"Crystal::Macros::When","name":"When","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1306,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `when` or `in` inside a `case`.","summary":"<p>A <code>when</code> or <code>in</code> inside a <code>case</code>.</p>","instance_methods":[{"html_id":"body:ASTNode-instance-method","name":"body","doc":"Returns the body of this `when`.","summary":"<p>Returns the body of this <code>when</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1312,"url":null},"def":{"name":"body","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"conds:ArrayLiteral-instance-method","name":"conds","doc":"Returns the conditions of this `when`.","summary":"<p>Returns the conditions of this <code>when</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1308,"url":null},"def":{"name":"conds","return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"exhaustive?:BoolLiteral-instance-method","name":"exhaustive?","doc":"Returns `true` if this is an `in`, or `false` if this is a `when`.","summary":"<p>Returns <code>true</code> if this is an <code>in</code>, or <code>false</code> if this is a <code>when</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1316,"url":null},"def":{"name":"exhaustive?","return_type":"BoolLiteral","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/While","path":"Crystal/Macros/While.html","kind":"class","full_name":"Crystal::Macros::While","name":"While","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1394,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `while` expression","summary":"<p>A <code>while</code> expression</p>","instance_methods":[{"html_id":"body:ASTNode-instance-method","name":"body","doc":"Returns this while's body.","summary":"<p>Returns this while's body.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1400,"url":null},"def":{"name":"body","return_type":"ASTNode","visibility":"Public","body":""}},{"html_id":"cond:ASTNode-instance-method","name":"cond","doc":"Returns this while's condition.","summary":"<p>Returns this while's condition.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1396,"url":null},"def":{"name":"cond","return_type":"ASTNode","visibility":"Public","body":""}}]},{"html_id":"Crystal/Crystal/Macros/Yield","path":"Crystal/Macros/Yield.html","kind":"class","full_name":"Crystal::Macros::Yield","name":"Yield","abstract":false,"superclass":{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},"ancestors":[{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"}],"locations":[{"filename":"src/compiler/crystal/macros.cr","line_number":1576,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/Macros","kind":"module","full_name":"Crystal::Macros","name":"Macros"},"doc":"A `yield` expression.","summary":"<p>A <code>yield</code> expression.</p>","instance_methods":[{"html_id":"expressions:ArrayLiteral-instance-method","name":"expressions","doc":"Returns the arguments to this `yield`.","summary":"<p>Returns the arguments to this <code>yield</code>.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1578,"url":null},"def":{"name":"expressions","return_type":"ArrayLiteral","visibility":"Public","body":""}},{"html_id":"scope:ASTNode|Nop-instance-method","name":"scope","doc":"Returns the scope of this `yield`, if any.\n\nThis refers to the part after `with` in a `with ... yield` expression.","summary":"<p>Returns the scope of this <code>yield</code>, if any.</p>","abstract":false,"location":{"filename":"src/compiler/crystal/macros.cr","line_number":1584,"url":null},"def":{"name":"scope","return_type":"ASTNode | Nop","visibility":"Public","body":""}}]}]},{"html_id":"Crystal/Crystal/SyntaxHighlighter","path":"Crystal/SyntaxHighlighter.html","kind":"class","full_name":"Crystal::SyntaxHighlighter","name":"SyntaxHighlighter","abstract":true,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/crystal/syntax_highlighter.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/Crystal/SyntaxHighlighter/Colorize","kind":"class","full_name":"Crystal::SyntaxHighlighter::Colorize","name":"Colorize"},{"html_id":"Crystal/Crystal/SyntaxHighlighter/HTML","kind":"class","full_name":"Crystal::SyntaxHighlighter::HTML","name":"HTML"}],"namespace":{"html_id":"Crystal/Crystal","kind":"module","full_name":"Crystal","name":"Crystal"},"instance_methods":[{"html_id":"highlight(code:String)-instance-method","name":"highlight","doc":"Parses *code* as Crystal source code and processes it.","summary":"<p>Parses <em>code</em> as Crystal source code and processes it.</p>","abstract":false,"args":[{"name":"code","external_name":"code","restriction":"String"}],"args_string":"(code : String)","args_html":"(code : <a href=\"../String.html\">String</a>)","location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":8,"url":null},"def":{"name":"highlight","args":[{"name":"code","external_name":"code","restriction":"String"}],"visibility":"Public","body":"lexer = Lexer.new(code)\nlexer.comments_enabled = true\nlexer.count_whitespace = true\nlexer.wants_raw = true\nhighlight_normal_state(lexer)\n"}},{"html_id":"render(type:TokenType,value:String)-instance-method","name":"render","doc":"Renders *token* with text *value*.","summary":"<p>Renders <em>token</em> with text <em>value</em>.</p>","abstract":true,"args":[{"name":"type","external_name":"type","restriction":"TokenType"},{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(type : TokenType, value : String)","args_html":"(type : <a href=\"../Crystal/SyntaxHighlighter/TokenType.html\">TokenType</a>, value : <a href=\"../String.html\">String</a>)","location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":18,"url":null},"def":{"name":"render","args":[{"name":"type","external_name":"type","restriction":"TokenType"},{"name":"value","external_name":"value","restriction":"String"}],"visibility":"Public","body":""}},{"html_id":"render_delimiter(&)-instance-method","name":"render_delimiter","doc":"Renders a delimiter sequence.","summary":"<p>Renders a delimiter sequence.</p>","abstract":true,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":21,"url":null},"def":{"name":"render_delimiter","yields":0,"visibility":"Public","body":""}},{"html_id":"render_interpolation(&)-instance-method","name":"render_interpolation","doc":"Renders an interpolation sequence.","summary":"<p>Renders an interpolation sequence.</p>","abstract":true,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":24,"url":null},"def":{"name":"render_interpolation","yields":0,"visibility":"Public","body":""}},{"html_id":"render_string_array(&)-instance-method","name":"render_string_array","doc":"Renders a string array sequence.","summary":"<p>Renders a string array sequence.</p>","abstract":true,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":27,"url":null},"def":{"name":"render_string_array","yields":0,"visibility":"Public","body":""}}],"types":[{"html_id":"Crystal/Crystal/SyntaxHighlighter/Colorize","path":"Crystal/SyntaxHighlighter/Colorize.html","kind":"class","full_name":"Crystal::SyntaxHighlighter::Colorize","name":"Colorize","abstract":false,"superclass":{"html_id":"Crystal/Crystal/SyntaxHighlighter","kind":"class","full_name":"Crystal::SyntaxHighlighter","name":"SyntaxHighlighter"},"ancestors":[{"html_id":"Crystal/Crystal/SyntaxHighlighter","kind":"class","full_name":"Crystal::SyntaxHighlighter","name":"SyntaxHighlighter"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/crystal/syntax_highlighter/colorize.cr","line_number":12,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/SyntaxHighlighter","kind":"class","full_name":"Crystal::SyntaxHighlighter","name":"SyntaxHighlighter"},"doc":"A syntax highlighter that renders Crystal source code with ANSI escape codes\nsuitable for terminal highlighting.\n\n```\ncode = %(foo = bar(\"baz\\#{PI + 1}\") # comment)\ncolorized = Crystal::SyntaxHighlighter::Colorize.highlight(code)\ncolorized # => \"foo \\e[91m=\\e[0m bar(\\e[93m\\\"baz\\#{\\e[0;36mPI\\e[0;93m \\e[0;91m+\\e[0;93m \\e[0;35m1\\e[0;93m}\\\"\\e[0m) \\e[90m# comment\\e[0m\"\n```","summary":"<p>A syntax highlighter that renders Crystal source code with ANSI escape codes suitable for terminal highlighting.</p>","class_methods":[{"html_id":"highlight(io:IO,code:String)-class-method","name":"highlight","doc":"Highlights *code* and writes the result to *io*.","summary":"<p>Highlights <em>code</em> and writes the result to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"code","external_name":"code","restriction":"String"}],"args_string":"(io : IO, code : String)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, code : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/crystal/syntax_highlighter/colorize.cr","line_number":14,"url":null},"def":{"name":"highlight","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"code","external_name":"code","restriction":"String"}],"visibility":"Public","body":"(new(io)).highlight(code)"}},{"html_id":"highlight(code:String)-class-method","name":"highlight","doc":"Highlights *code* and returns the result.","summary":"<p>Highlights <em>code</em> and returns the result.</p>","abstract":false,"args":[{"name":"code","external_name":"code","restriction":"String"}],"args_string":"(code : String)","args_html":"(code : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/crystal/syntax_highlighter/colorize.cr","line_number":19,"url":null},"def":{"name":"highlight","args":[{"name":"code","external_name":"code","restriction":"String"}],"visibility":"Public","body":"String.build do |io|\n  highlight(io, code)\nend"}},{"html_id":"highlight!(code:String)-class-method","name":"highlight!","doc":"Highlights *code* or returns unhighlighted *code* on error.\n\nSame as `.highlight(code : String)` except that any error is rescued and\nreturns unhighlighted source code.","summary":"<p>Highlights <em>code</em> or returns unhighlighted <em>code</em> on error.</p>","abstract":false,"args":[{"name":"code","external_name":"code","restriction":"String"}],"args_string":"(code : String)","args_html":"(code : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/crystal/syntax_highlighter/colorize.cr","line_number":29,"url":null},"def":{"name":"highlight!","args":[{"name":"code","external_name":"code","restriction":"String"}],"visibility":"Public","body":"begin\n  highlight(code)\nrescue\n  code\nend"}}],"constructors":[{"html_id":"new(io:IO,colorize:::Colorize::Object(String)=::Colorize.with.toggle(true))-class-method","name":"new","doc":"Creates a new instance of a Colorize syntax highlighter.\n\nAppends highlighted output (when calling `#highlight`) to *io*.","summary":"<p>Creates a new instance of a Colorize syntax highlighter.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"colorize","default_value":"::Colorize.with.toggle(true)","external_name":"colorize","restriction":"::Colorize::Object(String)"}],"args_string":"(io : IO, colorize : ::Colorize::Object(String) = ::Colorize.with.toggle(true))","args_html":"(io : <a href=\"../../IO.html\">IO</a>, colorize : <a href=\"../../Colorize/Object.html\">::Colorize::Object</a>(<a href=\"../../String.html\">String</a>) = <span class=\"t\">::</span><span class=\"t\">Colorize</span>.<span class=\"k\">with</span>.toggle(<span class=\"n\">true</span>))","location":{"filename":"src/crystal/syntax_highlighter/colorize.cr","line_number":38,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"colorize","default_value":"::Colorize.with.toggle(true)","external_name":"colorize","restriction":"::Colorize::Object(String)"}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, colorize)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"colors:Hash(TokenType,::Colorize::Color)-instance-method","name":"colors","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter/colorize.cr","line_number":41,"url":null},"def":{"name":"colors","return_type":"Hash(TokenType, ::Colorize::Color)","visibility":"Public","body":"@colors"}},{"html_id":"colors=(colors:Hash(TokenType,::Colorize::Color))-instance-method","name":"colors=","abstract":false,"args":[{"name":"colors","external_name":"colors","restriction":"Hash(TokenType, ::Colorize::Color)"}],"args_string":"(colors : Hash(TokenType, ::Colorize::Color))","args_html":"(colors : <a href=\"../../Hash.html\">Hash</a>(<a href=\"../../Crystal/SyntaxHighlighter/TokenType.html\">TokenType</a>, <a href=\"../../Colorize/Color.html\">::Colorize::Color</a>))","location":{"filename":"src/crystal/syntax_highlighter/colorize.cr","line_number":41,"url":null},"def":{"name":"colors=","args":[{"name":"colors","external_name":"colors","restriction":"Hash(TokenType, ::Colorize::Color)"}],"visibility":"Public","body":"@colors = colors"}},{"html_id":"render(type:TokenType,value:String)-instance-method","name":"render","doc":"Renders *token* with text *value*.","summary":"<p>Renders <em>token</em> with text <em>value</em>.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"TokenType"},{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(type : TokenType, value : String)","args_html":"(type : <a href=\"../../Crystal/SyntaxHighlighter/TokenType.html\">TokenType</a>, value : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/crystal/syntax_highlighter/colorize.cr","line_number":56,"url":null},"def":{"name":"render","args":[{"name":"type","external_name":"type","restriction":"TokenType"},{"name":"value","external_name":"value","restriction":"String"}],"visibility":"Public","body":"colorize(type, value)"}},{"html_id":"render_delimiter(&)-instance-method","name":"render_delimiter","doc":"Renders a delimiter sequence.","summary":"<p>Renders a delimiter sequence.</p>","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter/colorize.cr","line_number":60,"url":null},"def":{"name":"render_delimiter","yields":0,"visibility":"Public","body":"(@colorize.fore(colors[TokenType::STRING])).surround(@io) do\n  yield\nend"}},{"html_id":"render_interpolation(&)-instance-method","name":"render_interpolation","doc":"Renders an interpolation sequence.","summary":"<p>Renders an interpolation sequence.</p>","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter/colorize.cr","line_number":66,"url":null},"def":{"name":"render_interpolation","yields":0,"visibility":"Public","body":"colorize(:INTERPOLATION, \"\\#{\")\nyield\ncolorize(:INTERPOLATION, \"}\")\n"}},{"html_id":"render_string_array(&)-instance-method","name":"render_string_array","doc":"Renders a string array sequence.","summary":"<p>Renders a string array sequence.</p>","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter/colorize.cr","line_number":72,"url":null},"def":{"name":"render_string_array","yields":0,"visibility":"Public","body":"(@colorize.fore(colors[TokenType::STRING])).surround(@io) do\n  yield\nend"}}]},{"html_id":"Crystal/Crystal/SyntaxHighlighter/HTML","path":"Crystal/SyntaxHighlighter/HTML.html","kind":"class","full_name":"Crystal::SyntaxHighlighter::HTML","name":"HTML","abstract":false,"superclass":{"html_id":"Crystal/Crystal/SyntaxHighlighter","kind":"class","full_name":"Crystal::SyntaxHighlighter","name":"SyntaxHighlighter"},"ancestors":[{"html_id":"Crystal/Crystal/SyntaxHighlighter","kind":"class","full_name":"Crystal::SyntaxHighlighter","name":"SyntaxHighlighter"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/crystal/syntax_highlighter/html.cr","line_number":11,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Crystal/SyntaxHighlighter","kind":"class","full_name":"Crystal::SyntaxHighlighter","name":"SyntaxHighlighter"},"doc":"A syntax highlighter that renders Crystal source code with HTML markup.\n\n```\ncode = %(foo = bar(\"baz\\#{PI + 1}\") # comment)\nhtml = Crystal::SyntaxHighlighter::HTML.highlight(code)\nhtml # => \"foo <span class=\\\"o\\\">=</span> bar(<span class=\\\"s\\\">&quot;baz</span><span class=\\\"i\\\">\\#{</span><span class=\\\"t\\\">PI</span> <span class=\\\"o\\\">+</span> <span class=\\\"n\\\">1</span><span class=\\\"i\\\">}</span><span class=\\\"s\\\">&quot;</span>) <span class=\\\"c\\\"># comment</span>\"\n```","summary":"<p>A syntax highlighter that renders Crystal source code with HTML markup.</p>","class_methods":[{"html_id":"highlight(io:IO,code:String)-class-method","name":"highlight","doc":"Highlights *code* and writes the result to *io*.","summary":"<p>Highlights <em>code</em> and writes the result to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"code","external_name":"code","restriction":"String"}],"args_string":"(io : IO, code : String)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, code : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/crystal/syntax_highlighter/html.cr","line_number":13,"url":null},"def":{"name":"highlight","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"code","external_name":"code","restriction":"String"}],"visibility":"Public","body":"(new(io)).highlight(code)"}},{"html_id":"highlight(code:String)-class-method","name":"highlight","doc":"Highlights *code* and returns the result.","summary":"<p>Highlights <em>code</em> and returns the result.</p>","abstract":false,"args":[{"name":"code","external_name":"code","restriction":"String"}],"args_string":"(code : String)","args_html":"(code : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/crystal/syntax_highlighter/html.cr","line_number":18,"url":null},"def":{"name":"highlight","args":[{"name":"code","external_name":"code","restriction":"String"}],"visibility":"Public","body":"String.build do |io|\n  highlight(io, code)\nend"}},{"html_id":"highlight!(code:String)-class-method","name":"highlight!","doc":"Highlights *code* or returns unhighlighted *code* on error.\n\nSame as `.highlight(code : String)` except that any error is rescued and\nreturns unhighlighted source code.","summary":"<p>Highlights <em>code</em> or returns unhighlighted <em>code</em> on error.</p>","abstract":false,"args":[{"name":"code","external_name":"code","restriction":"String"}],"args_string":"(code : String)","args_html":"(code : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/crystal/syntax_highlighter/html.cr","line_number":28,"url":null},"def":{"name":"highlight!","args":[{"name":"code","external_name":"code","restriction":"String"}],"visibility":"Public","body":"begin\n  highlight(code)\nrescue\n  ::HTML.escape(code)\nend"}}],"constructors":[{"html_id":"new(io:IO)-class-method","name":"new","doc":"Creates a new instance of an HTML syntax highlighter.\n\nAppends highlighted output (when calling `#highlight`) to *io*.","summary":"<p>Creates a new instance of an HTML syntax highlighter.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","args_html":"(io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/crystal/syntax_highlighter/html.cr","line_number":37,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"_ = allocate\n_.initialize(io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"render(type:TokenType,value:String)-instance-method","name":"render","doc":"Renders *token* with text *value*.","summary":"<p>Renders <em>token</em> with text <em>value</em>.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"TokenType"},{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(type : TokenType, value : String)","args_html":"(type : <a href=\"../../Crystal/SyntaxHighlighter/TokenType.html\">TokenType</a>, value : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/crystal/syntax_highlighter/html.cr","line_number":40,"url":null},"def":{"name":"render","args":[{"name":"type","external_name":"type","restriction":"TokenType"},{"name":"value","external_name":"value","restriction":"String"}],"visibility":"Public","body":"case type\nwhen .comment?\n  span(\"c\") do\n    ::HTML.escape(value, @io)\n  end\nwhen .number?\n  span(\"n\", &.print(value))\nwhen .char?\n  span(\"s\") do\n    ::HTML.escape(value, @io)\n  end\nwhen .symbol?\n  span(\"n\") do\n    ::HTML.escape(value, @io)\n  end\nwhen .const?\n  span(\"t\", &.print(value))\nwhen .string?\n  span(\"s\") do\n    ::HTML.escape(value, @io)\n  end\nwhen .ident?\n  span(\"m\", &.print(value))\nwhen .keyword?, .self?\n  span(\"k\", &.print(value))\nwhen .primitive_literal?\n  span(\"n\", &.print(value))\nwhen .operator?\n  span(\"o\") do\n    ::HTML.escape(value, @io)\n  end\nelse\n  ::HTML.escape(value, @io)\nend"}},{"html_id":"render_delimiter(&)-instance-method","name":"render_delimiter","doc":"Renders a delimiter sequence.","summary":"<p>Renders a delimiter sequence.</p>","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter/html.cr","line_number":67,"url":null},"def":{"name":"render_delimiter","yields":0,"visibility":"Public","body":"span(\"s\") do\n  yield\nend"}},{"html_id":"render_interpolation(&)-instance-method","name":"render_interpolation","doc":"Renders an interpolation sequence.","summary":"<p>Renders an interpolation sequence.</p>","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter/html.cr","line_number":73,"url":null},"def":{"name":"render_interpolation","yields":0,"visibility":"Public","body":"span_end\nspan(\"i\", &.print(\"\\#{\"))\nyield\nspan(\"i\", &.print(\"}\"))\nspan_start(\"s\")\n"}},{"html_id":"render_string_array(&)-instance-method","name":"render_string_array","doc":"Renders a string array sequence.","summary":"<p>Renders a string array sequence.</p>","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter/html.cr","line_number":81,"url":null},"def":{"name":"render_string_array","yields":0,"visibility":"Public","body":"span(\"s\") do\n  yield\nend"}}]},{"html_id":"Crystal/Crystal/SyntaxHighlighter/TokenType","path":"Crystal/SyntaxHighlighter/TokenType.html","kind":"enum","full_name":"Crystal::SyntaxHighlighter::TokenType","name":"TokenType","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/crystal/syntax_highlighter.cr","line_number":30,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"NEWLINE","name":"NEWLINE","value":"0"},{"id":"SPACE","name":"SPACE","value":"1"},{"id":"COMMENT","name":"COMMENT","value":"2"},{"id":"NUMBER","name":"NUMBER","value":"3"},{"id":"CHAR","name":"CHAR","value":"4"},{"id":"SYMBOL","name":"SYMBOL","value":"5"},{"id":"CONST","name":"CONST","value":"6"},{"id":"STRING","name":"STRING","value":"7"},{"id":"IDENT","name":"IDENT","value":"8"},{"id":"KEYWORD","name":"KEYWORD","value":"9"},{"id":"SELF","name":"SELF","value":"10"},{"id":"PRIMITIVE_LITERAL","name":"PRIMITIVE_LITERAL","value":"11"},{"id":"OPERATOR","name":"OPERATOR","value":"12"},{"id":"DELIMITER_START","name":"DELIMITER_START","value":"13"},{"id":"DELIMITED_TOKEN","name":"DELIMITED_TOKEN","value":"14"},{"id":"DELIMITER_END","name":"DELIMITER_END","value":"15"},{"id":"INTERPOLATION","name":"INTERPOLATION","value":"16"},{"id":"STRING_ARRAY_START","name":"STRING_ARRAY_START","value":"17"},{"id":"STRING_ARRAY_TOKEN","name":"STRING_ARRAY_TOKEN","value":"18"},{"id":"STRING_ARRAY_END","name":"STRING_ARRAY_END","value":"19"},{"id":"UNDERSCORE","name":"UNDERSCORE","value":"20"},{"id":"UNKNOWN","name":"UNKNOWN","value":"21"}],"namespace":{"html_id":"Crystal/Crystal/SyntaxHighlighter","kind":"class","full_name":"Crystal::SyntaxHighlighter","name":"SyntaxHighlighter"},"doc":"Describes the type of a highlighter token.","summary":"<p>Describes the type of a highlighter token.</p>","instance_methods":[{"html_id":"char?-instance-method","name":"char?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":35,"url":null},"def":{"name":"char?","visibility":"Public","body":"self == CHAR"}},{"html_id":"comment?-instance-method","name":"comment?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":33,"url":null},"def":{"name":"comment?","visibility":"Public","body":"self == COMMENT"}},{"html_id":"const?-instance-method","name":"const?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":37,"url":null},"def":{"name":"const?","visibility":"Public","body":"self == CONST"}},{"html_id":"delimited_token?-instance-method","name":"delimited_token?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":45,"url":null},"def":{"name":"delimited_token?","visibility":"Public","body":"self == DELIMITED_TOKEN"}},{"html_id":"delimiter_end?-instance-method","name":"delimiter_end?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":46,"url":null},"def":{"name":"delimiter_end?","visibility":"Public","body":"self == DELIMITER_END"}},{"html_id":"delimiter_start?-instance-method","name":"delimiter_start?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":44,"url":null},"def":{"name":"delimiter_start?","visibility":"Public","body":"self == DELIMITER_START"}},{"html_id":"ident?-instance-method","name":"ident?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":39,"url":null},"def":{"name":"ident?","visibility":"Public","body":"self == IDENT"}},{"html_id":"interpolation?-instance-method","name":"interpolation?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":47,"url":null},"def":{"name":"interpolation?","visibility":"Public","body":"self == INTERPOLATION"}},{"html_id":"keyword?-instance-method","name":"keyword?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":40,"url":null},"def":{"name":"keyword?","visibility":"Public","body":"self == KEYWORD"}},{"html_id":"newline?-instance-method","name":"newline?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":31,"url":null},"def":{"name":"newline?","visibility":"Public","body":"self == NEWLINE"}},{"html_id":"number?-instance-method","name":"number?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":34,"url":null},"def":{"name":"number?","visibility":"Public","body":"self == NUMBER"}},{"html_id":"operator?-instance-method","name":"operator?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":43,"url":null},"def":{"name":"operator?","visibility":"Public","body":"self == OPERATOR"}},{"html_id":"primitive_literal?-instance-method","name":"primitive_literal?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":42,"url":null},"def":{"name":"primitive_literal?","visibility":"Public","body":"self == PRIMITIVE_LITERAL"}},{"html_id":"self?-instance-method","name":"self?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":41,"url":null},"def":{"name":"self?","visibility":"Public","body":"self == SELF"}},{"html_id":"space?-instance-method","name":"space?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":32,"url":null},"def":{"name":"space?","visibility":"Public","body":"self == SPACE"}},{"html_id":"string?-instance-method","name":"string?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":38,"url":null},"def":{"name":"string?","visibility":"Public","body":"self == STRING"}},{"html_id":"string_array_end?-instance-method","name":"string_array_end?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":50,"url":null},"def":{"name":"string_array_end?","visibility":"Public","body":"self == STRING_ARRAY_END"}},{"html_id":"string_array_start?-instance-method","name":"string_array_start?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":48,"url":null},"def":{"name":"string_array_start?","visibility":"Public","body":"self == STRING_ARRAY_START"}},{"html_id":"string_array_token?-instance-method","name":"string_array_token?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":49,"url":null},"def":{"name":"string_array_token?","visibility":"Public","body":"self == STRING_ARRAY_TOKEN"}},{"html_id":"symbol?-instance-method","name":"symbol?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":36,"url":null},"def":{"name":"symbol?","visibility":"Public","body":"self == SYMBOL"}},{"html_id":"underscore?-instance-method","name":"underscore?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":51,"url":null},"def":{"name":"underscore?","visibility":"Public","body":"self == UNDERSCORE"}},{"html_id":"unknown?-instance-method","name":"unknown?","abstract":false,"location":{"filename":"src/crystal/syntax_highlighter.cr","line_number":52,"url":null},"def":{"name":"unknown?","visibility":"Public","body":"self == UNKNOWN"}}]}]}]},{"html_id":"Crystal/CSV","path":"CSV.html","kind":"class","full_name":"CSV","name":"CSV","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/csv.cr","line_number":58,"url":null},{"filename":"src/csv/error.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"DEFAULT_QUOTE_CHAR","name":"DEFAULT_QUOTE_CHAR","value":"'\"'"},{"id":"DEFAULT_SEPARATOR","name":"DEFAULT_SEPARATOR","value":"','"}],"doc":"Provides methods and classes for parsing and generating CSV\n(comma-separated values) strings.\n\nThis module conforms to [RFC 4180](https://tools.ietf.org/html/rfc4180).\n\n### Parsing\n\nSeveral ways of parsing CSV are provided. The most straight-forward, but\nslow or inefficient for some scenarios, is `CSV#parse`, which returns\nan array of arrays of all data.\n\nRows can be traversed in a linear fashion with `CSV#each_row`, or\nusing an `Iterator`.\n\nTo parse a CSV in an efficient way, optionally being able to access\nrow values from header names, create an instance of a `CSV`.\n\n### Parsing with `CSV#new`\n\nA CSV instance holds a cursor to the current row in the CSV. The cursor\nis advanced by invoking `#next`, which returns `true` if a next row was found,\nand `false` otherwise. A first call to `#next` is required to position the\nCSV parser in the first row.\n\nOnce positioned in a row, values can be obtained with the several `#[]` methods,\nwhich can accept a header name, column position, or header name pattern as a `Regex`.\n\nAdditionally, a `Row` object can be obtained with the `#row` method which\nprovides similar methods and can be converted to an `Array` or `Hash`.\n\n### Example\n\n```\nrequire \"csv\"\n\ncsv = CSV.new(\"Name, Age\\nJohn, 20\\nPeter, 30\", headers: true)\ncsv.next # => true\n\ncsv[\"Name\"]  # => \"John\"\ncsv[0]       # => \"John\"\ncsv[-2]      # => \"John\"\ncsv[/name/i] # => \"John\"\n\ncsv[\"Age\"] # => \" 20\"\n\ncsv.row.to_a # => [\"John\", \" 20\"]\ncsv.row.to_h # => {\"Name\" => \"John\", \"Age\" => \" 20\"}\n\ncsv.next    # => true\ncsv[\"Name\"] # => \"Peter\"\n\ncsv.next # => false\n```\n\n### Building\n\nTo create CSV data, check `CSV#build` and the `CSV::Builder` class.","summary":"<p>Provides methods and classes for parsing and generating CSV (comma-separated values) strings.</p>","class_methods":[{"html_id":"build(separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR,quoting:Builder::Quoting=Builder::Quoting::RFC,&):String-class-method","name":"build","doc":"Builds a CSV. This yields a `CSV::Builder` to the given block.\n\nTakes optional *quoting* argument to define quote behavior.\n\n```\nrequire \"csv\"\n\nresult = CSV.build do |csv|\n  csv.row \"one\", \"two\"\n  csv.row \"three\"\nend\nresult # => \"one,two\\nthree\\n\"\nresult = CSV.build(quoting: CSV::Builder::Quoting::ALL) do |csv|\n  csv.row \"one\", \"two\"\n  csv.row \"three\"\nend\nresult # => \"\\\"one\\\",\\\"two\\\"\\n\\\"three\\\"\\n\"\n```\n\nSee: `CSV::Builder::Quoting`","summary":"<p>Builds a CSV.</p>","abstract":false,"args":[{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"},{"name":"quoting","default_value":"Builder::Quoting::RFC","external_name":"quoting","restriction":"Builder::Quoting"}],"args_string":"(separator : Char = DEFAULT_SEPARATOR, quote_char : Char = DEFAULT_QUOTE_CHAR, quoting : Builder::Quoting = Builder::Quoting::RFC, &) : String","args_html":"(separator : <a href=\"Char.html\">Char</a> = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : <a href=\"Char.html\">Char</a> = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>, quoting : <a href=\"CSV/Builder/Quoting.html\">Builder::Quoting</a> = <span class=\"t\">Builder</span><span class=\"t\">::</span><span class=\"t\">Quoting</span><span class=\"t\">::</span><span class=\"t\">RFC</span>, &) : <a href=\"String.html\">String</a>","location":{"filename":"src/csv.cr","line_number":138,"url":null},"def":{"name":"build","args":[{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"},{"name":"quoting","default_value":"Builder::Quoting::RFC","external_name":"quoting","restriction":"Builder::Quoting"}],"yields":1,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  build(io, separator, quote_char, quoting) do |builder|\n    yield builder\n  end\nend"}},{"html_id":"build(io:IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR,quoting:Builder::Quoting=Builder::Quoting::RFC,&):Nil-class-method","name":"build","doc":"Appends CSV data to the given `IO`. This yields a `CSV::Builder`\nthat writes to the given `IO`.\n\n```\nrequire \"csv\"\n\nio = IO::Memory.new\nio.puts \"HEADER\"\nCSV.build(io) do |csv|\n  csv.row \"one\", \"two\"\n  csv.row \"three\"\nend\nio.to_s # => \"HEADER\\none,two\\nthree\\n\"\n```","summary":"<p>Appends CSV data to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"},{"name":"quoting","default_value":"Builder::Quoting::RFC","external_name":"quoting","restriction":"Builder::Quoting"}],"args_string":"(io : IO, separator : Char = DEFAULT_SEPARATOR, quote_char : Char = DEFAULT_QUOTE_CHAR, quoting : Builder::Quoting = Builder::Quoting::RFC, &) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, separator : <a href=\"Char.html\">Char</a> = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : <a href=\"Char.html\">Char</a> = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>, quoting : <a href=\"CSV/Builder/Quoting.html\">Builder::Quoting</a> = <span class=\"t\">Builder</span><span class=\"t\">::</span><span class=\"t\">Quoting</span><span class=\"t\">::</span><span class=\"t\">RFC</span>, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/csv.cr","line_number":158,"url":null},"def":{"name":"build","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"},{"name":"quoting","default_value":"Builder::Quoting::RFC","external_name":"quoting","restriction":"Builder::Quoting"}],"yields":1,"return_type":"Nil","visibility":"Public","body":"builder = Builder.new(io, separator, quote_char, quoting)\nyield builder\nio.flush\n"}},{"html_id":"each_row(string_or_io:String|IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR,&)-class-method","name":"each_row","doc":"Yields each of a CSV's rows as an `Array(String)`.\n\nSee `CSV.parse` about the *separator* and *quote_char* arguments.\n\n```\nrequire \"csv\"\n\nCSV.each_row(\"one,two\\nthree\") do |row|\n  puts row\nend\n```\n\nOutput:\n\n```\n[\"one\", \"two\"]\n[\"three\"]\n```","summary":"<p>Yields each of a CSV's rows as an <code><a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)</code>.</p>","abstract":false,"args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"args_string":"(string_or_io : String | IO, separator : Char = DEFAULT_SEPARATOR, quote_char : Char = DEFAULT_QUOTE_CHAR, &)","args_html":"(string_or_io : <a href=\"String.html\">String</a> | <a href=\"IO.html\">IO</a>, separator : <a href=\"Char.html\">Char</a> = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : <a href=\"Char.html\">Char</a> = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>, &)","location":{"filename":"src/csv.cr","line_number":97,"url":null},"def":{"name":"each_row","args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"yields":1,"visibility":"Public","body":"(Parser.new(string_or_io, separator, quote_char)).each_row do |row|\n  yield row\nend"}},{"html_id":"each_row(string_or_io:String|IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR)-class-method","name":"each_row","doc":"Returns an `Iterator` of `Array(String)` over a CSV's rows.\n\nSee `CSV.parse` about the *separator* and *quote_char* arguments.\n\n```\nrequire \"csv\"\n\nrows = CSV.each_row(\"one,two\\nthree\")\nrows.next # => [\"one\", \"two\"]\nrows.next # => [\"three\"]\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> of <code><a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)</code> over a CSV's rows.</p>","abstract":false,"args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"args_string":"(string_or_io : String | IO, separator : Char = DEFAULT_SEPARATOR, quote_char : Char = DEFAULT_QUOTE_CHAR)","args_html":"(string_or_io : <a href=\"String.html\">String</a> | <a href=\"IO.html\">IO</a>, separator : <a href=\"Char.html\">Char</a> = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : <a href=\"Char.html\">Char</a> = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>)","location":{"filename":"src/csv.cr","line_number":114,"url":null},"def":{"name":"each_row","args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"visibility":"Public","body":"(Parser.new(string_or_io, separator, quote_char)).each_row"}},{"html_id":"parse(string_or_io:String|IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR):Array(Array(String))-class-method","name":"parse","doc":"Parses a CSV or `IO` into an array.\n\nTakes optional *separator* and *quote_char* arguments for defining\nnon-standard csv cell separators and quote characters.\n\n```\nrequire \"csv\"\n\nCSV.parse(\"one,two\\nthree\")\n# => [[\"one\", \"two\"], [\"three\"]]\nCSV.parse(\"one;two\\n'three;'\", separator: ';', quote_char: '\\'')\n# => [[\"one\", \"two\"], [\"three;\"]]\n```","summary":"<p>Parses a CSV or <code><a href=\"IO.html\">IO</a></code> into an array.</p>","abstract":false,"args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"args_string":"(string_or_io : String | IO, separator : Char = DEFAULT_SEPARATOR, quote_char : Char = DEFAULT_QUOTE_CHAR) : Array(Array(String))","args_html":"(string_or_io : <a href=\"String.html\">String</a> | <a href=\"IO.html\">IO</a>, separator : <a href=\"Char.html\">Char</a> = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : <a href=\"Char.html\">Char</a> = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>) : <a href=\"Array.html\">Array</a>(<a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>))","location":{"filename":"src/csv.cr","line_number":75,"url":null},"def":{"name":"parse","args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"return_type":"Array(Array(String))","visibility":"Public","body":"(Parser.new(string_or_io, separator, quote_char)).parse"}}],"constructors":[{"html_id":"new(string_or_io:String|IO,headers=false,strip=false,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR)-class-method","name":"new","doc":"Creates a new instance from the given `String` or `IO`.\n\n* If *strip* is `true`, row values are stripped with `String#strip` before being\nreturned from methods.\n* If *headers* is `true`, row values can be accessed with header names or patterns.\nHeaders are always stripped.\n\nSee `CSV.parse` about the *separator* and *quote_char* arguments.","summary":"<p>Creates a new instance from the given <code><a href=\"String.html\">String</a></code> or <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"},{"name":"headers","default_value":"false","external_name":"headers","restriction":""},{"name":"strip","default_value":"false","external_name":"strip","restriction":""},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"args_string":"(string_or_io : String | IO, headers = false, strip = false, separator : Char = DEFAULT_SEPARATOR, quote_char : Char = DEFAULT_QUOTE_CHAR)","args_html":"(string_or_io : <a href=\"String.html\">String</a> | <a href=\"IO.html\">IO</a>, headers = <span class=\"n\">false</span>, strip = <span class=\"n\">false</span>, separator : <a href=\"Char.html\">Char</a> = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : <a href=\"Char.html\">Char</a> = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>)","location":{"filename":"src/csv.cr","line_number":175,"url":null},"def":{"name":"new","args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"},{"name":"headers","default_value":"false","external_name":"headers","restriction":""},{"name":"strip","default_value":"false","external_name":"strip","restriction":""},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"visibility":"Public","body":"_ = allocate\n_.initialize(string_or_io, headers, strip, separator, quote_char)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(string_or_io:String|IO,headers=false,strip=false,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR,&)-class-method","name":"new","doc":"Creates a new instance from the given `String` or `IO`, and yields it to\nthe given block once for each row in the CSV.\n\n* If *strip* is `true`, row values are stripped with `String#strip` before being\nreturned from methods.\n* If *headers* is `true`, row values can be accessed with header names or patterns.\nHeaders are always stripped.\n\nSee `CSV.parse` about the *separator* and *quote_char* arguments.","summary":"<p>Creates a new instance from the given <code><a href=\"String.html\">String</a></code> or <code><a href=\"IO.html\">IO</a></code>, and yields it to the given block once for each row in the CSV.</p>","abstract":false,"args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"},{"name":"headers","default_value":"false","external_name":"headers","restriction":""},{"name":"strip","default_value":"false","external_name":"strip","restriction":""},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"args_string":"(string_or_io : String | IO, headers = false, strip = false, separator : Char = DEFAULT_SEPARATOR, quote_char : Char = DEFAULT_QUOTE_CHAR, &)","args_html":"(string_or_io : <a href=\"String.html\">String</a> | <a href=\"IO.html\">IO</a>, headers = <span class=\"n\">false</span>, strip = <span class=\"n\">false</span>, separator : <a href=\"Char.html\">Char</a> = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : <a href=\"Char.html\">Char</a> = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>, &)","location":{"filename":"src/csv.cr","line_number":197,"url":null},"def":{"name":"new","args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"},{"name":"headers","default_value":"false","external_name":"headers","restriction":""},{"name":"strip","default_value":"false","external_name":"strip","restriction":""},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"yields":1,"visibility":"Public","body":"csv = new(string_or_io, headers, strip, separator, quote_char)\ncsv.each do\n  yield csv\nend\ncsv\n"}}],"instance_methods":[{"html_id":"[](header:String):String-instance-method","name":"[]","doc":"Returns the current row's value corresponding to the given *header* name.\nRaises `KeyError` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns the current row's value corresponding to the given <em>header</em> name.</p>","abstract":false,"args":[{"name":"header","external_name":"header","restriction":"String"}],"args_string":"(header : String) : String","args_html":"(header : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/csv.cr","line_number":238,"url":null},"def":{"name":"[]","args":[{"name":"header","external_name":"header","restriction":"String"}],"return_type":"String","visibility":"Public","body":"row_internal[header]"}},{"html_id":"[](column:Int):String-instance-method","name":"[]","doc":"Returns the current row's value at the given column index.\nA negative index counts from the end.\nRaises `IndexError` if no such column exists.","summary":"<p>Returns the current row's value at the given column index.</p>","abstract":false,"args":[{"name":"column","external_name":"column","restriction":"Int"}],"args_string":"(column : Int) : String","args_html":"(column : <a href=\"Int.html\">Int</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/csv.cr","line_number":252,"url":null},"def":{"name":"[]","args":[{"name":"column","external_name":"column","restriction":"Int"}],"return_type":"String","visibility":"Public","body":"row_internal[column]"}},{"html_id":"[](header_pattern:Regex):String-instance-method","name":"[]","doc":"Returns the current row's value corresponding to the given *header_pattern*.\nRaises `KeyError` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns the current row's value corresponding to the given <em>header_pattern</em>.</p>","abstract":false,"args":[{"name":"header_pattern","external_name":"header_pattern","restriction":"Regex"}],"args_string":"(header_pattern : Regex) : String","args_html":"(header_pattern : <a href=\"Regex.html\">Regex</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/csv.cr","line_number":266,"url":null},"def":{"name":"[]","args":[{"name":"header_pattern","external_name":"header_pattern","restriction":"Regex"}],"return_type":"String","visibility":"Public","body":"row_internal[header_pattern]"}},{"html_id":"[]?(header:String):String?-instance-method","name":"[]?","doc":"Returns the current row's value corresponding to the given *header* name.\nReturns `nil` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns the current row's value corresponding to the given <em>header</em> name.</p>","abstract":false,"args":[{"name":"header","external_name":"header","restriction":"String"}],"args_string":"(header : String) : String?","args_html":"(header : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/csv.cr","line_number":245,"url":null},"def":{"name":"[]?","args":[{"name":"header","external_name":"header","restriction":"String"}],"return_type":"String | ::Nil","visibility":"Public","body":"row_internal[header]?"}},{"html_id":"[]?(column:Int):String?-instance-method","name":"[]?","doc":"Returns the current row's value at the given column index.\nA negative index counts from the end.\nReturns `nil` if no such column exists.","summary":"<p>Returns the current row's value at the given column index.</p>","abstract":false,"args":[{"name":"column","external_name":"column","restriction":"Int"}],"args_string":"(column : Int) : String?","args_html":"(column : <a href=\"Int.html\">Int</a>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/csv.cr","line_number":259,"url":null},"def":{"name":"[]?","args":[{"name":"column","external_name":"column","restriction":"Int"}],"return_type":"String | ::Nil","visibility":"Public","body":"row_internal[column]?"}},{"html_id":"[]?(header_pattern:Regex):String?-instance-method","name":"[]?","doc":"Returns the current row's value corresponding to the given *header_pattern*.\nReturns `nil` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns the current row's value corresponding to the given <em>header_pattern</em>.</p>","abstract":false,"args":[{"name":"header_pattern","external_name":"header_pattern","restriction":"Regex"}],"args_string":"(header_pattern : Regex) : String?","args_html":"(header_pattern : <a href=\"Regex.html\">Regex</a>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/csv.cr","line_number":273,"url":null},"def":{"name":"[]?","args":[{"name":"header_pattern","external_name":"header_pattern","restriction":"Regex"}],"return_type":"String | ::Nil","visibility":"Public","body":"row_internal[header_pattern]?"}},{"html_id":"each(&):Nil-instance-method","name":"each","doc":"Invokes the block once for each row in this CSV, yielding `self`.","summary":"<p>Invokes the block once for each row in this CSV, yielding <code>self</code>.</p>","abstract":false,"location":{"filename":"src/csv.cr","line_number":212,"url":null},"def":{"name":"each","yields":1,"return_type":"Nil","visibility":"Public","body":"while self.next\n  yield self\nend"}},{"html_id":"headers:Array(String)-instance-method","name":"headers","doc":"Returns this CSV headers. Their values are always stripped.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns this CSV headers.</p>","abstract":false,"location":{"filename":"src/csv.cr","line_number":207,"url":null},"def":{"name":"headers","return_type":"Array(String)","visibility":"Public","body":"@headers || (raise(Error.new(\"Headers not requested\")))"}},{"html_id":"next:Bool-instance-method","name":"next","doc":"Advanced the cursor to the next row. Must be called once to position\nthe cursor in the first row. Returns `true` if a next row was found,\n`false` otherwise.","summary":"<p>Advanced the cursor to the next row.</p>","abstract":false,"location":{"filename":"src/csv.cr","line_number":221,"url":null},"def":{"name":"next","return_type":"Bool","visibility":"Public","body":"if @traversed\n  return false\nend\nrow = @row || (@row = [] of String)\nrow.clear\n@row = @parser.next_row(row)\nif @row\n  true\nelse\n  @traversed = true\n  false\nend\n"}},{"html_id":"rewind:Nil-instance-method","name":"rewind","doc":"Rewinds this CSV to the beginning, rewinding the underlying IO if any.","summary":"<p>Rewinds this CSV to the beginning, rewinding the underlying IO if any.</p>","abstract":false,"location":{"filename":"src/csv.cr","line_number":299,"url":null},"def":{"name":"rewind","return_type":"Nil","visibility":"Public","body":"@parser.rewind\nif @headers\n  @parser.next_row\nend\n@traversed = false\n"}},{"html_id":"row:Row-instance-method","name":"row","doc":"Returns the current row as a `Row` instance.","summary":"<p>Returns the current row as a <code><a href=\"CSV/Row.html\">Row</a></code> instance.</p>","abstract":false,"location":{"filename":"src/csv.cr","line_number":294,"url":null},"def":{"name":"row","return_type":"Row","visibility":"Public","body":"Row.new(self, current_row.dup)"}},{"html_id":"values_at(*columns:Int)-instance-method","name":"values_at","doc":"Returns a tuple of the current row's values at given indices\nA negative index counts from the end.\nRaises `IndexError` if any column doesn't exist\nThe behavior of returning a tuple is similar to `Hash#values_at`","summary":"<p>Returns a tuple of the current row's values at given indices A negative index counts from the end.</p>","abstract":false,"args":[{"name":"columns","external_name":"columns","restriction":"Int"}],"args_string":"(*columns : Int)","args_html":"(*columns : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/csv.cr","line_number":281,"url":null},"def":{"name":"values_at","args":[{"name":"columns","external_name":"columns","restriction":"Int"}],"splat_index":0,"visibility":"Public","body":"columns.map do |column|\n  row_internal[column]\nend"}},{"html_id":"values_at(*headers:String)-instance-method","name":"values_at","doc":"Returns a tuple of the current row's values corresponding to the given *headers*\nRaises `KeyError` if any header doesn't exist.\nRaises `CSV::Error` if headers were not requested\nThe behavior of returning a tuple is similar to `Hash#values_at`","summary":"<p>Returns a tuple of the current row's values corresponding to the given <em>headers</em> Raises <code><a href=\"KeyError.html\">KeyError</a></code> if any header doesn't exist.</p>","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":"String"}],"args_string":"(*headers : String)","args_html":"(*headers : <a href=\"String.html\">String</a>)","location":{"filename":"src/csv.cr","line_number":289,"url":null},"def":{"name":"values_at","args":[{"name":"headers","external_name":"headers","restriction":"String"}],"splat_index":0,"visibility":"Public","body":"headers.map do |header|\n  row_internal[header]\nend"}}],"types":[{"html_id":"Crystal/CSV/Builder","path":"CSV/Builder.html","kind":"class","full_name":"CSV::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/csv/builder.cr","line_number":37,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},"doc":"A CSV Builder writes CSV to an `IO`.\n\n```\nrequire \"csv\"\n\nresult = CSV.build do |csv|\n  # A row can be written by specifying several values\n  csv.row \"Hello\", 1, 'a', \"String with \\\"quotes\\\"\", '\"', :sym\n\n  # Or an enumerable\n  csv.row [1, 2, 3]\n\n  # Or using a block, and appending to the row\n  csv.row do |row|\n    # Appending a single value\n    row << 4\n\n    # Or multiple values\n    row.concat 5, 6\n\n    # Or an enumerable\n    row.concat [7, 8]\n  end\nend\nputs result\n```\n\nOutput:\n\n```text\nHello,1,a,\"String with \"\"quotes\"\"\",\"\"\"\",sym\n1,2,3\n4,5,6,7,8\n```","summary":"<p>A CSV Builder writes CSV to an <code><a href=\"../IO.html\">IO</a></code>.</p>","constructors":[{"html_id":"new(io:IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR,quoting:Quoting=Quoting::RFC)-class-method","name":"new","doc":"Creates a builder that will write to the given `IO`.","summary":"<p>Creates a builder that will write to the given <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"},{"name":"quoting","default_value":"Quoting::RFC","external_name":"quoting","restriction":"Quoting"}],"args_string":"(io : IO, separator : Char = DEFAULT_SEPARATOR, quote_char : Char = DEFAULT_QUOTE_CHAR, quoting : Quoting = Quoting::RFC)","args_html":"(io : <a href=\"../IO.html\">IO</a>, separator : <a href=\"../Char.html\">Char</a> = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : <a href=\"../Char.html\">Char</a> = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>, quoting : <a href=\"../CSV/Builder/Quoting.html\">Quoting</a> = <span class=\"t\">Quoting</span><span class=\"t\">::</span><span class=\"t\">RFC</span>)","location":{"filename":"src/csv/builder.cr","line_number":50,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"},{"name":"quoting","default_value":"Quoting::RFC","external_name":"quoting","restriction":"Quoting"}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, separator, quote_char, quoting)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"row(&)-instance-method","name":"row","doc":"Yields a `CSV::Row` to append a row. A newline is appended\nto `IO` after the block exits.","summary":"<p>Yields a <code><a href=\"../CSV/Row.html\">CSV::Row</a></code> to append a row.</p>","abstract":false,"location":{"filename":"src/csv/builder.cr","line_number":56,"url":null},"def":{"name":"row","yields":1,"visibility":"Public","body":"yield Row.new(self, @separator, @quote_char, @quoting)\n@io << '\\n'\n@first_cell_in_row = true\n"}},{"html_id":"row(values:Enumerable):Nil-instance-method","name":"row","doc":"Appends the given values as a single row, and then a newline.","summary":"<p>Appends the given values as a single row, and then a newline.</p>","abstract":false,"args":[{"name":"values","external_name":"values","restriction":"Enumerable"}],"args_string":"(values : Enumerable) : Nil","args_html":"(values : <a href=\"../Enumerable.html\">Enumerable</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/csv/builder.cr","line_number":63,"url":null},"def":{"name":"row","args":[{"name":"values","external_name":"values","restriction":"Enumerable"}],"return_type":"Nil","visibility":"Public","body":"row do |row|\n  values.each do |value|\n    row << value\n  end\nend"}},{"html_id":"row(*values):Nil-instance-method","name":"row","doc":"Appends the given values as a single row, and then a newline.","summary":"<p>Appends the given values as a single row, and then a newline.</p>","abstract":false,"args":[{"name":"values","external_name":"values","restriction":""}],"args_string":"(*values) : Nil","args_html":"(*values) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/csv/builder.cr","line_number":72,"url":null},"def":{"name":"row","args":[{"name":"values","external_name":"values","restriction":""}],"splat_index":0,"return_type":"Nil","visibility":"Public","body":"row(values)"}}],"types":[{"html_id":"Crystal/CSV/Builder/Quoting","path":"CSV/Builder/Quoting.html","kind":"enum","full_name":"CSV::Builder::Quoting","name":"Quoting","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/csv/builder.cr","line_number":38,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"NONE","name":"NONE","value":"0","doc":"No quotes","summary":"<p>No quotes</p>"},{"id":"RFC","name":"RFC","value":"1","doc":"Quotes according to RFC 4180 (default)","summary":"<p>Quotes according to RFC 4180 (default)</p>"},{"id":"ALL","name":"ALL","value":"2","doc":"Always quote","summary":"<p>Always quote</p>"}],"namespace":{"html_id":"Crystal/CSV/Builder","kind":"class","full_name":"CSV::Builder","name":"Builder"},"instance_methods":[{"html_id":"all?-instance-method","name":"all?","abstract":false,"location":{"filename":"src/csv/builder.cr","line_number":46,"url":null},"def":{"name":"all?","visibility":"Public","body":"self == ALL"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/csv/builder.cr","line_number":40,"url":null},"def":{"name":"none?","visibility":"Public","body":"self == NONE"}},{"html_id":"rfc?-instance-method","name":"rfc?","abstract":false,"location":{"filename":"src/csv/builder.cr","line_number":43,"url":null},"def":{"name":"rfc?","visibility":"Public","body":"self == RFC"}}]},{"html_id":"Crystal/CSV/Builder/Row","path":"CSV/Builder/Row.html","kind":"struct","full_name":"CSV::Builder::Row","name":"Row","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/csv/builder.cr","line_number":106,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/CSV/Builder","kind":"class","full_name":"CSV::Builder","name":"Builder"},"doc":"A CSV Row being built.","summary":"<p>A CSV Row being built.</p>","instance_methods":[{"html_id":"<<(value:String):Nil-instance-method","name":"<<","doc":"Appends the given value to this row.","summary":"<p>Appends the given value to this row.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(value : String) : Nil","args_html":"(value : <a href=\"../../String.html\">String</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/csv/builder.cr","line_number":114,"url":null},"def":{"name":"<<","args":[{"name":"value","external_name":"value","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"if needs_quotes?(value)\n  @builder.quote_cell(value)\nelse\n  @builder.cell do |io|\n    io << value\n  end\nend"}},{"html_id":"<<(value:Nil|Bool|Number):Nil-instance-method","name":"<<","doc":"Appends the given value to this row.","summary":"<p>Appends the given value to this row.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Nil | Bool | Number"}],"args_string":"(value : Nil | Bool | Number) : Nil","args_html":"(value : <a href=\"../../Nil.html\">Nil</a> | <a href=\"../../Bool.html\">Bool</a> | <a href=\"../../Number.html\">Number</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/csv/builder.cr","line_number":123,"url":null},"def":{"name":"<<","args":[{"name":"value","external_name":"value","restriction":"Nil | Bool | Number"}],"return_type":"Nil","visibility":"Public","body":"case @quoting\nwhen .all?\n  @builder.cell do |io|\n    io << @quote_char\n    io << value\n    io << @quote_char\n  end\nelse\n  @builder.cell do |io|\n    io << value\n  end\nend"}},{"html_id":"<<(value):Nil-instance-method","name":"<<","doc":"Appends the given value to this row.","summary":"<p>Appends the given value to this row.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : Nil","args_html":"(value) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/csv/builder.cr","line_number":137,"url":null},"def":{"name":"<<","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"Nil","visibility":"Public","body":"self << value.to_s"}},{"html_id":"concat(values:Enumerable):Nil-instance-method","name":"concat","doc":"Appends the given values to this row.","summary":"<p>Appends the given values to this row.</p>","abstract":false,"args":[{"name":"values","external_name":"values","restriction":"Enumerable"}],"args_string":"(values : Enumerable) : Nil","args_html":"(values : <a href=\"../../Enumerable.html\">Enumerable</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/csv/builder.cr","line_number":142,"url":null},"def":{"name":"concat","args":[{"name":"values","external_name":"values","restriction":"Enumerable"}],"return_type":"Nil","visibility":"Public","body":"values.each do |value|\n  self << value\nend"}},{"html_id":"concat(*values):Nil-instance-method","name":"concat","doc":"Appends the given values to this row.","summary":"<p>Appends the given values to this row.</p>","abstract":false,"args":[{"name":"values","external_name":"values","restriction":""}],"args_string":"(*values) : Nil","args_html":"(*values) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/csv/builder.cr","line_number":149,"url":null},"def":{"name":"concat","args":[{"name":"values","external_name":"values","restriction":""}],"splat_index":0,"return_type":"Nil","visibility":"Public","body":"concat(values)"}},{"html_id":"skip_cell:Nil-instance-method","name":"skip_cell","doc":"Appends a comma, thus skipping a cell.","summary":"<p>Appends a comma, thus skipping a cell.</p>","abstract":false,"location":{"filename":"src/csv/builder.cr","line_number":154,"url":null},"def":{"name":"skip_cell","return_type":"Nil","visibility":"Public","body":"self << nil"}}]}]},{"html_id":"Crystal/CSV/Error","path":"CSV/Error.html","kind":"class","full_name":"CSV::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/csv/error.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/CSV/MalformedCSVError","kind":"class","full_name":"CSV::MalformedCSVError","name":"MalformedCSVError"}],"namespace":{"html_id":"Crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},"doc":"Raises when an error related to a CSV is found.","summary":"<p>Raises when an error related to a CSV is found.</p>"},{"html_id":"Crystal/CSV/Lexer","path":"CSV/Lexer.html","kind":"class","full_name":"CSV::Lexer","name":"Lexer","abstract":true,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/csv/lexer.cr","line_number":16,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},"doc":"A CSV lexer lets you consume a CSV token by token. You can use this to efficiently\nparse a CSV without the need to allocate intermediate arrays.\n\n```\nrequire \"csv\"\n\nlexer = CSV::Lexer.new \"one,two\\nthree\"\nlexer.next_token # => CSV::Token(@kind=Cell, @value=\"one\")\nlexer.next_token # => CSV::Token(@kind=Cell, @value=\"two\")\nlexer.next_token # => CSV::Token(@kind=Newline, @value=\"two\")\nlexer.next_token # => CSV::Token(@kind=Cell, @value=\"three\")\nlexer.next_token # => CSV::Token(@kind=Eof, @value=\"three\")\n```","summary":"<p>A CSV lexer lets you consume a CSV token by token.</p>","constructors":[{"html_id":"new(string:String,separator=DEFAULT_SEPARATOR,quote_char=DEFAULT_QUOTE_CHAR)-class-method","name":"new","doc":"Creates a CSV lexer from a `String`.","summary":"<p>Creates a CSV lexer from a <code><a href=\"../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":""},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":""}],"args_string":"(string : String, separator = DEFAULT_SEPARATOR, quote_char = DEFAULT_QUOTE_CHAR)","args_html":"(string : <a href=\"../String.html\">String</a>, separator = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>)","location":{"filename":"src/csv/lexer.cr","line_number":18,"url":null},"def":{"name":"new","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":""},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":""}],"visibility":"Public","body":"StringBased.new(string, separator, quote_char)"}},{"html_id":"new(io:IO,separator=DEFAULT_SEPARATOR,quote_char=DEFAULT_QUOTE_CHAR)-class-method","name":"new","doc":"Creates a CSV lexer from an `IO`.","summary":"<p>Creates a CSV lexer from an <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":""},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":""}],"args_string":"(io : IO, separator = DEFAULT_SEPARATOR, quote_char = DEFAULT_QUOTE_CHAR)","args_html":"(io : <a href=\"../IO.html\">IO</a>, separator = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>)","location":{"filename":"src/csv/lexer.cr","line_number":23,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":""},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":""}],"visibility":"Public","body":"IOBased.new(io, separator, quote_char)"}}],"instance_methods":[{"html_id":"next_token:CSV::Token-instance-method","name":"next_token","doc":"Returns the next `Token` in this CSV.","summary":"<p>Returns the next <code><a href=\"../CSV/Token.html\">Token</a></code> in this CSV.</p>","abstract":false,"location":{"filename":"src/csv/lexer.cr","line_number":63,"url":null},"def":{"name":"next_token","return_type":"CSV::Token","visibility":"Public","body":"if @last_empty_column\n  @last_empty_column = false\n  @token.kind = Token::Kind::Cell\n  @token.value = \"\"\n  return @token\nend\nif @last_was_slash_r\n  if next_char == '\\n'\n    next_char\n  end\n  @last_was_slash_r = false\nelse\n  if @last_was_slash_n\n    next_char\n    @last_was_slash_n = false\n  end\nend\ncase current_char\nwhen '\\0'\n  @token.kind = Token::Kind::Eof\nwhen @separator\n  @token.kind = Token::Kind::Cell\n  @token.value = \"\"\n  check_last_empty_column\nwhen '\\r'\n  @token.kind = Token::Kind::Newline\n  @last_was_slash_r = true\nwhen '\\n'\n  @token.kind = Token::Kind::Newline\n  @last_was_slash_n = true\nwhen @quote_char\n  @token.kind = Token::Kind::Cell\n  @token.value = consume_quoted_cell\nelse\n  @token.kind = Token::Kind::Cell\n  @token.value = consume_unquoted_cell\nend\n@token\n"}},{"html_id":"quote_char:Char-instance-method","name":"quote_char","abstract":false,"location":{"filename":"src/csv/lexer.cr","line_number":30,"url":null},"def":{"name":"quote_char","return_type":"Char","visibility":"Public","body":"@quote_char"}},{"html_id":"rewind:Nil-instance-method","name":"rewind","doc":"Rewinds this lexer to the beginning","summary":"<p>Rewinds this lexer to the beginning</p>","abstract":false,"location":{"filename":"src/csv/lexer.cr","line_number":50,"url":null},"def":{"name":"rewind","return_type":"Nil","visibility":"Public","body":"@column_number = 1\n@line_number = 1\n@last_empty_column = false\n@last_was_slash_r = false\n@last_was_slash_n = false\n"}},{"html_id":"separator:Char-instance-method","name":"separator","abstract":false,"location":{"filename":"src/csv/lexer.cr","line_number":29,"url":null},"def":{"name":"separator","return_type":"Char","visibility":"Public","body":"@separator"}},{"html_id":"token:Token-instance-method","name":"token","doc":"Returns the current `Token`.","summary":"<p>Returns the current <code><a href=\"../CSV/Token.html\">Token</a></code>.</p>","abstract":false,"location":{"filename":"src/csv/lexer.cr","line_number":28,"url":null},"def":{"name":"token","return_type":"Token","visibility":"Public","body":"@token"}}]},{"html_id":"Crystal/CSV/MalformedCSVError","path":"CSV/MalformedCSVError.html","kind":"class","full_name":"CSV::MalformedCSVError","name":"MalformedCSVError","abstract":false,"superclass":{"html_id":"Crystal/CSV/Error","kind":"class","full_name":"CSV::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/CSV/Error","kind":"class","full_name":"CSV::Error","name":"Error"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/csv/error.cr","line_number":9,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},"doc":"Raised when an error is encountered during CSV parsing.","summary":"<p>Raised when an error is encountered during CSV parsing.</p>","constructors":[{"html_id":"new(message,line_number,column_number)-class-method","name":"new","abstract":false,"args":[{"name":"message","external_name":"message","restriction":""},{"name":"line_number","external_name":"line_number","restriction":""},{"name":"column_number","external_name":"column_number","restriction":""}],"args_string":"(message, line_number, column_number)","args_html":"(message, line_number, column_number)","location":{"filename":"src/csv/error.cr","line_number":13,"url":null},"def":{"name":"new","args":[{"name":"message","external_name":"message","restriction":""},{"name":"line_number","external_name":"line_number","restriction":""},{"name":"column_number","external_name":"column_number","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(message, line_number, column_number)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"column_number:Int32-instance-method","name":"column_number","abstract":false,"location":{"filename":"src/csv/error.cr","line_number":11,"url":null},"def":{"name":"column_number","return_type":"Int32","visibility":"Public","body":"@column_number"}},{"html_id":"line_number:Int32-instance-method","name":"line_number","abstract":false,"location":{"filename":"src/csv/error.cr","line_number":10,"url":null},"def":{"name":"line_number","return_type":"Int32","visibility":"Public","body":"@line_number"}}]},{"html_id":"Crystal/CSV/Parser","path":"CSV/Parser.html","kind":"class","full_name":"CSV::Parser","name":"Parser","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/csv/parser.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},"doc":"A CSV parser. It lets you consume a CSV row by row.\n\nMost of the time `CSV#parse` and `CSV#each_row` are more convenient.","summary":"<p>A CSV parser.</p>","constructors":[{"html_id":"new(string_or_io:String|IO,separator:Char=DEFAULT_SEPARATOR,quote_char:Char=DEFAULT_QUOTE_CHAR)-class-method","name":"new","doc":"Creates a parser from a `String` or `IO`.\nOptionally takes the optional *separator* and *quote_char* arguments for\nspecifying non-standard cell separators and quote characters","summary":"<p>Creates a parser from a <code><a href=\"../String.html\">String</a></code> or <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"args_string":"(string_or_io : String | IO, separator : Char = DEFAULT_SEPARATOR, quote_char : Char = DEFAULT_QUOTE_CHAR)","args_html":"(string_or_io : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>, separator : <a href=\"../Char.html\">Char</a> = <span class=\"t\">DEFAULT_SEPARATOR</span>, quote_char : <a href=\"../Char.html\">Char</a> = <span class=\"t\">DEFAULT_QUOTE_CHAR</span>)","location":{"filename":"src/csv/parser.cr","line_number":10,"url":null},"def":{"name":"new","args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"},{"name":"separator","default_value":"DEFAULT_SEPARATOR","external_name":"separator","restriction":"Char"},{"name":"quote_char","default_value":"DEFAULT_QUOTE_CHAR","external_name":"quote_char","restriction":"Char"}],"visibility":"Public","body":"_ = allocate\n_.initialize(string_or_io, separator, quote_char)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"each_row(&):Nil-instance-method","name":"each_row","doc":"Yields each of the remaining rows as an `Array(String)`.","summary":"<p>Yields each of the remaining rows as an <code><a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)</code>.</p>","abstract":false,"location":{"filename":"src/csv/parser.cr","line_number":23,"url":null},"def":{"name":"each_row","yields":1,"return_type":"Nil","visibility":"Public","body":"while row = next_row\n  yield row\nend"}},{"html_id":"each_row-instance-method","name":"each_row","doc":"Returns an `Iterator` of `Array(String)` for the remaining rows.","summary":"<p>Returns an <code><a href=\"../Iterator.html\">Iterator</a></code> of <code><a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)</code> for the remaining rows.</p>","abstract":false,"location":{"filename":"src/csv/parser.cr","line_number":30,"url":null},"def":{"name":"each_row","visibility":"Public","body":"RowIterator.new(self)"}},{"html_id":"next_row(array:Array(String)):Array(String)?-instance-method","name":"next_row","doc":"Reads the next row into the given *array*.\nReturns that same array, if a row was found, or `nil`.","summary":"<p>Reads the next row into the given <em>array</em>.</p>","abstract":false,"args":[{"name":"array","external_name":"array","restriction":"Array(String)"}],"args_string":"(array : Array(String)) : Array(String)?","args_html":"(array : <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)) : <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)?","location":{"filename":"src/csv/parser.cr","line_number":47,"url":null},"def":{"name":"next_row","args":[{"name":"array","external_name":"array","restriction":"Array(String)"}],"return_type":"Array(String) | Nil","visibility":"Public","body":"token = @lexer.next_token\nif token.kind == Token::Kind::Eof\n  return nil\nend\nnext_row_internal(token, array)\n"}},{"html_id":"next_row:Array(String)?-instance-method","name":"next_row","doc":"Returns the next row in the CSV, if any, or `nil`.","summary":"<p>Returns the next row in the CSV, if any, or <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/csv/parser.cr","line_number":35,"url":null},"def":{"name":"next_row","return_type":"Array(String) | Nil","visibility":"Public","body":"token = @lexer.next_token\nif token.kind == Token::Kind::Eof\n  return nil\nend\nrow = Array(String).new(@max_row_size)\nnext_row_internal(token, row)\n"}},{"html_id":"parse:Array(Array(String))-instance-method","name":"parse","doc":"Returns the remaining rows.","summary":"<p>Returns the remaining rows.</p>","abstract":false,"location":{"filename":"src/csv/parser.cr","line_number":16,"url":null},"def":{"name":"parse","return_type":"Array(Array(String))","visibility":"Public","body":"rows = [] of Array(String)\neach_row do |row|\n  rows << row\nend\nrows\n"}},{"html_id":"rewind:Nil-instance-method","name":"rewind","doc":"Rewinds this parser to the beginning.","summary":"<p>Rewinds this parser to the beginning.</p>","abstract":false,"location":{"filename":"src/csv/parser.cr","line_number":57,"url":null},"def":{"name":"rewind","return_type":"Nil","visibility":"Public","body":"@lexer.rewind"}}]},{"html_id":"Crystal/CSV/Row","path":"CSV/Row.html","kind":"struct","full_name":"CSV::Row","name":"Row","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/csv.cr","line_number":334,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},"doc":"A Row of a `CSV::WithHeaders` instance.","summary":"<p>A Row of a <code>CSV::WithHeaders</code> instance.</p>","instance_methods":[{"html_id":"[](header:String):String-instance-method","name":"[]","doc":"Returns the current row's value corresponding to the given *header* name.\nRaises `KeyError` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns the current row's value corresponding to the given <em>header</em> name.</p>","abstract":false,"args":[{"name":"header","external_name":"header","restriction":"String"}],"args_string":"(header : String) : String","args_html":"(header : <a href=\"../String.html\">String</a>) : <a href=\"../String.html\">String</a>","location":{"filename":"src/csv.cr","line_number":345,"url":null},"def":{"name":"[]","args":[{"name":"header","external_name":"header","restriction":"String"}],"return_type":"String","visibility":"Public","body":"value = self[header]?\nif value\nelse\n  raise(KeyError.new(\"Missing header: #{header}\"))\nend\nvalue\n"}},{"html_id":"[](column:Int):String-instance-method","name":"[]","doc":"Returns this row's value at the given column index.\nA negative index counts from the end.\nRaises `IndexError` if no such column exists.","summary":"<p>Returns this row's value at the given column index.</p>","abstract":false,"args":[{"name":"column","external_name":"column","restriction":"Int"}],"args_string":"(column : Int) : String","args_html":"(column : <a href=\"../Int.html\">Int</a>) : <a href=\"../String.html\">String</a>","location":{"filename":"src/csv.cr","line_number":366,"url":null},"def":{"name":"[]","args":[{"name":"column","external_name":"column","restriction":"Int"}],"return_type":"String","visibility":"Public","body":"value = self[column]?\nif value\nelse\n  raise(IndexError.new(\"Missing column index: #{column}\"))\nend\nvalue\n"}},{"html_id":"[](header_pattern:Regex):String-instance-method","name":"[]","doc":"Returns this row's value corresponding to the given *header_pattern*.\nRaises `KeyError` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns this row's value corresponding to the given <em>header_pattern</em>.</p>","abstract":false,"args":[{"name":"header_pattern","external_name":"header_pattern","restriction":"Regex"}],"args_string":"(header_pattern : Regex) : String","args_html":"(header_pattern : <a href=\"../Regex.html\">Regex</a>) : <a href=\"../String.html\">String</a>","location":{"filename":"src/csv.cr","line_number":388,"url":null},"def":{"name":"[]","args":[{"name":"header_pattern","external_name":"header_pattern","restriction":"Regex"}],"return_type":"String","visibility":"Public","body":"value = self[header_pattern]?\nif value\nelse\n  raise(KeyError.new(\"Missing header pattern: #{header_pattern}\"))\nend\nvalue\n"}},{"html_id":"[]?(header:String):String?-instance-method","name":"[]?","doc":"Returns this row's value corresponding to the given *header* name.\nReturns `nil` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns this row's value corresponding to the given <em>header</em> name.</p>","abstract":false,"args":[{"name":"header","external_name":"header","restriction":"String"}],"args_string":"(header : String) : String?","args_html":"(header : <a href=\"../String.html\">String</a>) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/csv.cr","line_number":354,"url":null},"def":{"name":"[]?","args":[{"name":"header","external_name":"header","restriction":"String"}],"return_type":"String | ::Nil","visibility":"Public","body":"index = csv.indices[header]?\nif index\n  maybe_strip(@row[index]? || \"\")\nelse\n  nil\nend\n"}},{"html_id":"[]?(column:Int):String?-instance-method","name":"[]?","doc":"Returns this row's value at the given column index.\nA negative index counts from the end.\nReturns `nil` if no such column exists.","summary":"<p>Returns this row's value at the given column index.</p>","abstract":false,"args":[{"name":"column","external_name":"column","restriction":"Int"}],"args_string":"(column : Int) : String?","args_html":"(column : <a href=\"../Int.html\">Int</a>) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/csv.cr","line_number":375,"url":null},"def":{"name":"[]?","args":[{"name":"column","external_name":"column","restriction":"Int"}],"return_type":"String | ::Nil","visibility":"Public","body":"size = csv.headers?.try(&.size) || @row.size\nif column < 0\n  column = column + size\nend\nvalue = @row[column]?\nif 0 <= column && column < size\n  value || (value = \"\")\nend\nvalue ? maybe_strip(value) : nil\n"}},{"html_id":"[]?(header_pattern:Regex):String?-instance-method","name":"[]?","doc":"Returns this row's value corresponding to the given *header_pattern*.\nReturns `nil` if no such header exists.\nRaises `CSV::Error` if headers were not requested.","summary":"<p>Returns this row's value corresponding to the given <em>header_pattern</em>.</p>","abstract":false,"args":[{"name":"header_pattern","external_name":"header_pattern","restriction":"Regex"}],"args_string":"(header_pattern : Regex) : String?","args_html":"(header_pattern : <a href=\"../Regex.html\">Regex</a>) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/csv.cr","line_number":397,"url":null},"def":{"name":"[]?","args":[{"name":"header_pattern","external_name":"header_pattern","restriction":"Regex"}],"return_type":"String | ::Nil","visibility":"Public","body":"csv.headers.each_with_index do |header, i|\n  if header =~ header_pattern\n    return maybe_strip(@row[i]? || \"\")\n  end\nend\nnil\n"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Returns the number of columns in this row, regardless of the number\nof headers (if requested).","summary":"<p>Returns the number of columns in this row, regardless of the number of headers (if requested).</p>","abstract":false,"location":{"filename":"src/csv.cr","line_number":408,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"@row.size"}},{"html_id":"to_a:Array(String)-instance-method","name":"to_a","doc":"Converts this row to an `Array`.","summary":"<p>Converts this row to an <code><a href=\"../Array.html\">Array</a></code>.</p>","abstract":false,"location":{"filename":"src/csv.cr","line_number":413,"url":null},"def":{"name":"to_a","return_type":"Array(String)","visibility":"Public","body":"if csv.strip?\n  @row.map!(&.strip)\nend\n@row\n"}},{"html_id":"to_h:Hash(String,String)-instance-method","name":"to_h","doc":"Converts this row to a `Hash`.","summary":"<p>Converts this row to a <code><a href=\"../Hash.html\">Hash</a></code>.</p>","abstract":false,"location":{"filename":"src/csv.cr","line_number":419,"url":null},"def":{"name":"to_h","return_type":"Hash(String, String)","visibility":"Public","body":"h = {} of String => String\ncsv.headers.each_with_index do |header, i|\n  h[header] = maybe_strip(@row[i]? || \"\")\nend\nh\n"}},{"html_id":"values_at(*columns:Int)-instance-method","name":"values_at","doc":"Returns a tuple of this row's values at given indices\nA negative index counts from the end.\nRaises `IndexError` if any column doesn't exist\nThe behavior of returning a tuple is similar to `Hash#values_at`","summary":"<p>Returns a tuple of this row's values at given indices A negative index counts from the end.</p>","abstract":false,"args":[{"name":"columns","external_name":"columns","restriction":"Int"}],"args_string":"(*columns : Int)","args_html":"(*columns : <a href=\"../Int.html\">Int</a>)","location":{"filename":"src/csv.cr","line_number":431,"url":null},"def":{"name":"values_at","args":[{"name":"columns","external_name":"columns","restriction":"Int"}],"splat_index":0,"visibility":"Public","body":"columns.map do |column|\n  self[column]\nend"}},{"html_id":"values_at(*headers:String)-instance-method","name":"values_at","doc":"Returns a tuple of this row's values corresponding to the given *headers*\nRaises `KeyError` if any header doesn't exist.\nRaises `CSV::Error` if headers were not requested\nThe behavior of returning a tuple is similar to `Hash#values_at`","summary":"<p>Returns a tuple of this row's values corresponding to the given <em>headers</em> Raises <code><a href=\"../KeyError.html\">KeyError</a></code> if any header doesn't exist.</p>","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":"String"}],"args_string":"(*headers : String)","args_html":"(*headers : <a href=\"../String.html\">String</a>)","location":{"filename":"src/csv.cr","line_number":439,"url":null},"def":{"name":"values_at","args":[{"name":"headers","external_name":"headers","restriction":"String"}],"splat_index":0,"visibility":"Public","body":"headers.map do |header|\n  self[header]\nend"}}]},{"html_id":"Crystal/CSV/Token","path":"CSV/Token.html","kind":"struct","full_name":"CSV::Token","name":"Token","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/csv/token.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},"doc":"A token in a CSV. It consists of a `Kind` and a value.\nThe value only makes sense when the *kind* is `Cell`.","summary":"<p>A token in a CSV.</p>","instance_methods":[{"html_id":"kind:Kind-instance-method","name":"kind","doc":"The `Kind`.","summary":"<p>The <code><a href=\"../CSV/Token/Kind.html\">Kind</a></code>.</p>","abstract":false,"location":{"filename":"src/csv/token.cr","line_number":14,"url":null},"def":{"name":"kind","return_type":"Kind","visibility":"Public","body":"@kind"}},{"html_id":"kind=(kind:Kind)-instance-method","name":"kind=","doc":"The `Kind`.","summary":"<p>The <code><a href=\"../CSV/Token/Kind.html\">Kind</a></code>.</p>","abstract":false,"args":[{"name":"kind","external_name":"kind","restriction":"Kind"}],"args_string":"(kind : Kind)","args_html":"(kind : <a href=\"../CSV/Token/Kind.html\">Kind</a>)","location":{"filename":"src/csv/token.cr","line_number":14,"url":null},"def":{"name":"kind=","args":[{"name":"kind","external_name":"kind","restriction":"Kind"}],"visibility":"Public","body":"@kind = kind"}},{"html_id":"value:String-instance-method","name":"value","doc":"The string value. Only makes sense for a `Cell`.","summary":"<p>The string value.</p>","abstract":false,"location":{"filename":"src/csv/token.cr","line_number":17,"url":null},"def":{"name":"value","return_type":"String","visibility":"Public","body":"@value"}},{"html_id":"value=(value:String)-instance-method","name":"value=","doc":"The string value. Only makes sense for a `Cell`.","summary":"<p>The string value.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(value : String)","args_html":"(value : <a href=\"../String.html\">String</a>)","location":{"filename":"src/csv/token.cr","line_number":17,"url":null},"def":{"name":"value=","args":[{"name":"value","external_name":"value","restriction":"String"}],"visibility":"Public","body":"@value = value"}}],"types":[{"html_id":"Crystal/CSV/Token/Kind","path":"CSV/Token/Kind.html","kind":"enum","full_name":"CSV::Token::Kind","name":"Kind","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/csv/token.cr","line_number":7,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Cell","name":"Cell","value":"0"},{"id":"Newline","name":"Newline","value":"1"},{"id":"Eof","name":"Eof","value":"2"}],"namespace":{"html_id":"Crystal/CSV/Token","kind":"struct","full_name":"CSV::Token","name":"Token"},"doc":"Token kinds.","summary":"<p>Token kinds.</p>","instance_methods":[{"html_id":"cell?-instance-method","name":"cell?","abstract":false,"location":{"filename":"src/csv/token.cr","line_number":8,"url":null},"def":{"name":"cell?","visibility":"Public","body":"self == Cell"}},{"html_id":"eof?-instance-method","name":"eof?","abstract":false,"location":{"filename":"src/csv/token.cr","line_number":10,"url":null},"def":{"name":"eof?","visibility":"Public","body":"self == Eof"}},{"html_id":"newline?-instance-method","name":"newline?","abstract":false,"location":{"filename":"src/csv/token.cr","line_number":9,"url":null},"def":{"name":"newline?","visibility":"Public","body":"self == Newline"}}]}]}]},{"html_id":"Crystal/Deprecated","path":"Deprecated.html","kind":"annotation","full_name":"Deprecated","name":"Deprecated","abstract":false,"locations":[{"filename":"src/annotations.cr","line_number":10,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"This annotation marks methods, classes, constants, and macros as deprecated.\n\nIt receives an optional `StringLiteral` as single argument containing a deprecation notice.\n\n```\n@[Deprecated(\"Use `#bar` instead\")]\ndef foo\nend\n```","summary":"<p>This annotation marks methods, classes, constants, and macros as deprecated.</p>"},{"html_id":"Crystal/Deque","path":"Deque.html","kind":"class","full_name":"Deque(T)","name":"Deque","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Indexable/Mutable","kind":"module","full_name":"Indexable::Mutable","name":"Mutable"},{"html_id":"Crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"},{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/deque.cr","line_number":12,"url":null},{"filename":"src/json/to_json.cr","line_number":101,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Indexable/Mutable","kind":"module","full_name":"Indexable::Mutable","name":"Mutable"}],"doc":"A Deque (\"[double-ended queue](https://en.wikipedia.org/wiki/Double-ended_queue)\") is a collection of objects of type\nT that behaves much like an Array.\n\nDeque has a subset of Array's API. It performs better than an `Array` when there are frequent insertions or deletions\nof items near the beginning or the end.\n\nThe most typical use case of a Deque is a queue: use `push` to add items to the end of the queue and `shift` to get\nand remove the item at the beginning of the queue.\n\nThis Deque is implemented with a [dynamic array](http://en.wikipedia.org/wiki/Dynamic_array) used as a\n[circular buffer](https://en.wikipedia.org/wiki/Circular_buffer).","summary":"<p>A Deque (&quot;<a href=\"https://en.wikipedia.org/wiki/Double-ended_queue\">double-ended queue</a>&quot;) is a collection of objects of type T that behaves much like an Array.</p>","class_methods":[{"html_id":"from_json(string_or_io,&):Nil-class-method","name":"from_json","abstract":false,"args":[{"name":"string_or_io","external_name":"string_or_io","restriction":""}],"args_string":"(string_or_io, &) : Nil","args_html":"(string_or_io, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/from_json.cr","line_number":61,"url":null},"def":{"name":"from_json","args":[{"name":"string_or_io","external_name":"string_or_io","restriction":""}],"yields":1,"return_type":"Nil","visibility":"Public","body":"parser = JSON::PullParser.new(string_or_io)\nnew(parser) do |element|\n  yield element\nend\n"}}],"constructors":[{"html_id":"additive_identity:self-class-method","name":"additive_identity","doc":"Returns the additive identity of this type.\n\nThis is an empty deque.","summary":"<p>Returns the additive identity of this type.</p>","abstract":false,"location":{"filename":"src/deque.cr","line_number":130,"url":null},"def":{"name":"additive_identity","return_type":"self","visibility":"Public","body":"self.new"}},{"html_id":"new(size:Int,value:T)-class-method","name":"new","doc":"Creates a new `Deque` of the given size filled with the same value in each position.\n\n```\nDeque.new(3, 'a') # => Deque{'a', 'a', 'a'}\n```","summary":"<p>Creates a new <code><a href=\"Deque.html\">Deque</a></code> of the given size filled with the same value in each position.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(size : Int, value : T)","args_html":"(size : <a href=\"Int.html\">Int</a>, value : T)","location":{"filename":"src/deque.cr","line_number":60,"url":null},"def":{"name":"new","args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"_ = Deque(T).allocate\n_.initialize(size, value)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(array:Array(T))-class-method","name":"new","doc":"Creates a new `Deque` that copies its items from an Array.\n\n```\nDeque.new([1, 2, 3]) # => Deque{1, 2, 3}\n```","summary":"<p>Creates a new <code><a href=\"Deque.html\">Deque</a></code> that copies its items from an Array.</p>","abstract":false,"args":[{"name":"array","external_name":"array","restriction":"Array(T)"}],"args_string":"(array : Array(T))","args_html":"(array : <a href=\"Array.html\">Array</a>(T))","location":{"filename":"src/deque.cr","line_number":98,"url":null},"def":{"name":"new","args":[{"name":"array","external_name":"array","restriction":"Array(T)"}],"visibility":"Public","body":"Deque(T).new(array.size) do |i|\n  array[i]\nend"}},{"html_id":"new(initial_capacity:Int)-class-method","name":"new","doc":"Creates a new empty `Deque` backed by a buffer that is initially `initial_capacity` big.\n\nThe `initial_capacity` is useful to avoid unnecessary reallocations of the internal buffer in case of growth. If you\nhave an estimate of the maximum number of elements a deque will hold, you should initialize it with that capacity\nfor improved execution performance.\n\n```\ndeq = Deque(Int32).new(5)\ndeq.size # => 0\n```","summary":"<p>Creates a new empty <code><a href=\"Deque.html\">Deque</a></code> backed by a buffer that is initially <code>initial_capacity</code> big.</p>","abstract":false,"args":[{"name":"initial_capacity","external_name":"initial_capacity","restriction":"Int"}],"args_string":"(initial_capacity : Int)","args_html":"(initial_capacity : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/deque.cr","line_number":41,"url":null},"def":{"name":"new","args":[{"name":"initial_capacity","external_name":"initial_capacity","restriction":"Int"}],"visibility":"Public","body":"_ = Deque(T).allocate\n_.initialize(initial_capacity)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":162,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"ary = new\nnew(pull) do |element|\n  ary << element\nend\nary\n"}},{"html_id":"new-class-method","name":"new","doc":"Creates a new empty Deque","summary":"<p>Creates a new empty Deque</p>","abstract":false,"location":{"filename":"src/deque.cr","line_number":25,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = Deque(T).allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(size:Int,&:Int32->T)-class-method","name":"new","doc":"Creates a new `Deque` of the given size and invokes the block once for\neach index of the deque, assigning the block's value in that index.\n\n```\nDeque.new(3) { |i| (i + 1) ** 2 } # => Deque{1, 4, 9}\n```","summary":"<p>Creates a new <code><a href=\"Deque.html\">Deque</a></code> of the given size and invokes the block once for each index of the deque, assigning the block's value in that index.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int"}],"args_string":"(size : Int, & : Int32 -> T)","args_html":"(size : <a href=\"Int.html\">Int</a>, & : <a href=\"Int32.html\">Int32</a> -> T)","location":{"filename":"src/deque.cr","line_number":80,"url":null},"def":{"name":"new","args":[{"name":"size","external_name":"size","restriction":"Int"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Int32 -> T)"},"visibility":"Public","body":"if size < 0\n  raise(ArgumentError.new(\"Negative deque size: #{size}\"))\nend\ndeque = Deque(T).new(size)\ndeque.size = size\nsize.to_i.times do |i|\n  deque.buffer[i] = yield i\nend\ndeque\n"}},{"html_id":"new(pull:JSON::PullParser,&)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser, &)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>, &)","location":{"filename":"src/json/from_json.cr","line_number":170,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"yields":1,"visibility":"Public","body":"pull.read_array do\n  yield T.new(pull)\nend"}}],"instance_methods":[{"html_id":"+(other:Deque(U))forallU-instance-method","name":"+","doc":"Concatenation. Returns a new `Deque` built by concatenating\ntwo deques together to create a third. The type of the new deque\nis the union of the types of both the other deques.","summary":"<p>Concatenation.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Deque(U)"}],"args_string":"(other : Deque(U)) forall U","args_html":"(other : <a href=\"Deque.html\">Deque</a>(U)) forall U","location":{"filename":"src/deque.cr","line_number":118,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Deque(U)"}],"visibility":"Public","body":"(Deque(T | U).new.concat(self)).concat(other)"}},{"html_id":"<<(value:T)-instance-method","name":"<<","doc":"Alias for `push`.","summary":"<p>Alias for <code><a href=\"Deque.html#push%28value%3AT%29-instance-method\">#push</a></code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T)","args_html":"(value : T)","location":{"filename":"src/deque.cr","line_number":135,"url":null},"def":{"name":"<<","args":[{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"push(value)"}},{"html_id":"==(other:Deque)-instance-method","name":"==","doc":"Returns `true` if it is passed a `Deque` and `equals?` returns `true`\nfor both deques, the caller and the argument.\n\n```\ndeq = Deque{2, 3}\ndeq.unshift 1\ndeq == Deque{1, 2, 3} # => true\ndeq == Deque{2, 3}    # => false\n```","summary":"<p>Returns <code>true</code> if it is passed a <code><a href=\"Deque.html\">Deque</a></code> and <code>equals?</code> returns <code>true</code> for both deques, the caller and the argument.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Deque"}],"args_string":"(other : Deque)","args_html":"(other : <a href=\"Deque.html\">Deque</a>)","location":{"filename":"src/deque.cr","line_number":111,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Deque"}],"visibility":"Public","body":"equals?(other) do |x, y|\n  x == y\nend"}},{"html_id":"clear-instance-method","name":"clear","doc":"Removes all elements from `self`.","summary":"<p>Removes all elements from <code>self</code>.</p>","abstract":false,"location":{"filename":"src/deque.cr","line_number":152,"url":null},"def":{"name":"clear","visibility":"Public","body":"halfs do |r|\n  (@buffer + r.begin).clear(r.end - r.begin)\nend\n@size = 0\n@start = 0\nself\n"}},{"html_id":"clone-instance-method","name":"clone","doc":"Returns a new `Deque` that has this deque's elements cloned.\nThat is, it returns a deep copy of this deque.\n\nUse `#dup` if you want a shallow copy.","summary":"<p>Returns a new <code><a href=\"Deque.html\">Deque</a></code> that has this deque's elements cloned.</p>","abstract":false,"location":{"filename":"src/deque.cr","line_number":165,"url":null},"def":{"name":"clone","visibility":"Public","body":"{% if ((((T == ::Bool) || (T == ::Char)) || (T == ::String)) || (T == ::Symbol)) || T < ::Number::Primitive %}\n      Deque(T).new(size) { |i| self[i].clone.as(T) }\n    {% else %}\n      exec_recursive_clone do |hash|\n        clone = Deque(T).new(size)\n        hash[object_id] = clone.object_id\n        each do |element|\n          clone << element.clone\n        end\n        clone\n      end\n    {% end %}"}},{"html_id":"concat(other:Enumerable(T))-instance-method","name":"concat","doc":"Appends the elements of *other* to `self`, and returns `self`.","summary":"<p>Appends the elements of <em>other</em> to <code>self</code>, and returns <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Enumerable(T)"}],"args_string":"(other : Enumerable(T))","args_html":"(other : <a href=\"Enumerable.html\">Enumerable</a>(T))","location":{"filename":"src/deque.cr","line_number":181,"url":null},"def":{"name":"concat","args":[{"name":"other","external_name":"other","restriction":"Enumerable(T)"}],"visibility":"Public","body":"other.each do |x|\n  push(x)\nend\nself\n"}},{"html_id":"delete(obj):Bool-instance-method","name":"delete","doc":"Removes all items from `self` that are equal to *obj*.\n\n```\na = Deque{\"a\", \"b\", \"b\", \"b\", \"c\"}\na.delete(\"b\") # => true\na             # => Deque{\"a\", \"c\"}\n```","summary":"<p>Removes all items from <code>self</code> that are equal to <em>obj</em>.</p>","abstract":false,"args":[{"name":"obj","external_name":"obj","restriction":""}],"args_string":"(obj) : Bool","args_html":"(obj) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/deque.cr","line_number":195,"url":null},"def":{"name":"delete","args":[{"name":"obj","external_name":"obj","restriction":""}],"return_type":"Bool","visibility":"Public","body":"match = internal_delete do |i|\n  i == obj\nend\n!match.nil?\n"}},{"html_id":"delete_at(index:Int):T-instance-method","name":"delete_at","doc":"Deletes the item that is present at the *index*. Items to the right\nof this one will have their indices decremented.\nRaises `IndexError` if trying to delete an element outside the deque's range.\n\n```\na = Deque{1, 2, 3}\na.delete_at(1) # => 2\na              # => Deque{1, 3}\n```","summary":"<p>Deletes the item that is present at the <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : T","args_html":"(index : <a href=\"Int.html\">Int</a>) : T","location":{"filename":"src/deque.cr","line_number":284,"url":null},"def":{"name":"delete_at","args":[{"name":"index","external_name":"index","restriction":"Int"}],"return_type":"T","visibility":"Public","body":"if index < 0\n  index = index + @size\nend\nif 0 <= index && index < @size\nelse\n  raise(IndexError.new)\nend\nif index == 0\n  return shift\nend\nif index == (@size - 1)\n  return pop\nend\nrindex = @start + index\nif rindex >= @capacity\n  rindex = rindex - @capacity\nend\nvalue = @buffer[rindex]\nif index > (@size // 2)\n  dst = rindex\n  finish = ((@start + @size) - 1) % @capacity\n  loop do\n    src = dst + 1\n    if src >= @capacity\n      src = src - @capacity\n    end\n    @buffer[dst] = @buffer[src]\n    if src == finish\n      break\n    end\n    dst = src\n  end\n  (@buffer + finish).clear\nelse\n  dst = rindex\n  finish = @start\n  @start = @start + 1\n  if @start >= @capacity\n    @start = @start - @capacity\n  end\n  loop do\n    src = dst - 1\n    if src < 0\n      src = src + @capacity\n    end\n    @buffer[dst] = @buffer[src]\n    if src == finish\n      break\n    end\n    dst = src\n  end\n  (@buffer + finish).clear\nend\n@size = @size - 1\nvalue\n"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a new `Deque` that has exactly this deque's elements.\nThat is, it returns a shallow copy of this deque.","summary":"<p>Returns a new <code><a href=\"Deque.html\">Deque</a></code> that has exactly this deque's elements.</p>","abstract":false,"location":{"filename":"src/deque.cr","line_number":334,"url":null},"def":{"name":"dup","visibility":"Public","body":"Deque(T).new(size) do |i|\n  self[i].as(T)\nend"}},{"html_id":"each(&:T->):Nil-instance-method","name":"each","doc":"Yields each item in this deque, from first to last.\n\nDo not modify the deque while using this variant of `each`!","summary":"<p>Yields each item in this deque, from first to last.</p>","abstract":false,"location":{"filename":"src/deque.cr","line_number":341,"url":null},"def":{"name":"each","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"Nil","visibility":"Public","body":"halfs do |r|\n  r.each do |i|\n    yield @buffer[i]\n  end\nend"}},{"html_id":"insert(index:Int,value:T):self-instance-method","name":"insert","doc":"Insert a new item before the item at *index*. Items to the right\nof this one will have their indices incremented.\n\n```\na = Deque{0, 1, 2}\na.insert(1, 7) # => Deque{0, 7, 1, 2}\n```","summary":"<p>Insert a new item before the item at <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(index : Int, value : T) : self","args_html":"(index : <a href=\"Int.html\">Int</a>, value : T) : <span class=\"k\">self</span>","location":{"filename":"src/deque.cr","line_number":356,"url":null},"def":{"name":"insert","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"return_type":"self","visibility":"Public","body":"if index < 0\n  index = index + (@size + 1)\nend\nif 0 <= index && index <= @size\nelse\n  raise(IndexError.new)\nend\nif index == 0\n  return unshift(value)\nend\nif index == @size\n  return push(value)\nend\nif @size >= @capacity\n  increase_capacity\nend\nrindex = @start + index\nif rindex >= @capacity\n  rindex = rindex - @capacity\nend\nif index > (@size // 2)\n  dst = @start + @size\n  if dst >= @capacity\n    dst = dst - @capacity\n  end\n  loop do\n    src = dst - 1\n    if src < 0\n      src = src + @capacity\n    end\n    @buffer[dst] = @buffer[src]\n    if src == rindex\n      break\n    end\n    dst = src\n  end\nelse\n  @start = @start - 1\n  if @start < 0\n    @start = @start + @capacity\n  end\n  rindex = rindex - 1\n  if rindex < 0\n    rindex = rindex + @capacity\n  end\n  dst = @start\n  loop do\n    src = dst + 1\n    if src >= @capacity\n      src = src - @capacity\n    end\n    @buffer[dst] = @buffer[src]\n    if src == rindex\n      break\n    end\n    dst = src\n  end\nend\n@size = @size + 1\n@buffer[rindex] = value\nself\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/deque.cr","line_number":404,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"executed = exec_recursive(:inspect) do\n  io << \"Deque{\"\n  join(io, \", \", &.inspect(io))\n  io << '}'\nend\nif executed\nelse\n  io << \"Deque{...}\"\nend\n"}},{"html_id":"pop(n:Int):Nil-instance-method","name":"pop","doc":"Removes the last *n* (at most) items in the deque.","summary":"<p>Removes the last <em>n</em> (at most) items in the deque.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"}],"args_string":"(n : Int) : Nil","args_html":"(n : <a href=\"Int.html\">Int</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/deque.cr","line_number":461,"url":null},"def":{"name":"pop","args":[{"name":"n","external_name":"n","restriction":"Int"}],"return_type":"Nil","visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Can't pop negative count\"))\nend\nn = Math.min(n, @size)\nn.times do\n  pop\nend\nnil\n"}},{"html_id":"pop:T-instance-method","name":"pop","doc":"Removes and returns the last item. Raises `IndexError` if empty.\n\n```\na = Deque{1, 2, 3}\na.pop # => 3\na     # => Deque{1, 2}\n```","summary":"<p>Removes and returns the last item.</p>","abstract":false,"location":{"filename":"src/deque.cr","line_number":436,"url":null},"def":{"name":"pop","return_type":"T","visibility":"Public","body":"pop do\n  raise(IndexError.new)\nend"}},{"html_id":"pop(&)-instance-method","name":"pop","doc":"Removes and returns the last item, if not empty, otherwise executes\nthe given block and returns its value.","summary":"<p>Removes and returns the last item, if not empty, otherwise executes the given block and returns its value.</p>","abstract":false,"location":{"filename":"src/deque.cr","line_number":442,"url":null},"def":{"name":"pop","yields":0,"visibility":"Public","body":"if @size == 0\n  yield\nelse\n  @size = @size - 1\n  index = @start + @size\n  if index >= @capacity\n    index = index - @capacity\n  end\n  value = @buffer[index]\n  (@buffer + index).clear\n  value\nend"}},{"html_id":"pop?:T?-instance-method","name":"pop?","doc":"Removes and returns the last item, if not empty, otherwise `nil`.","summary":"<p>Removes and returns the last item, if not empty, otherwise <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/deque.cr","line_number":456,"url":null},"def":{"name":"pop?","return_type":"T | ::Nil","visibility":"Public","body":"pop do\n  nil\nend"}},{"html_id":"pretty_print(pp)-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp)","args_html":"(pp)","location":{"filename":"src/deque.cr","line_number":413,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"visibility":"Public","body":"executed = exec_recursive(:inspect) do\n  pp.list(\"Deque{\", self, \"}\")\nend\nif executed\nelse\n  pp.text(\"Deque{...}\")\nend\n"}},{"html_id":"push(value:T)-instance-method","name":"push","doc":"Adds an item to the end of the deque.\n\n```\na = Deque{1, 2}\na.push 3 # => Deque{1, 2, 3}\n```","summary":"<p>Adds an item to the end of the deque.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T)","args_html":"(value : T)","location":{"filename":"src/deque.cr","line_number":476,"url":null},"def":{"name":"push","args":[{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"if @size >= @capacity\n  increase_capacity\nend\nindex = @start + @size\nif index >= @capacity\n  index = index - @capacity\nend\n@buffer[index] = value\n@size = @size + 1\nself\n"}},{"html_id":"reject!(&:T->):self-instance-method","name":"reject!","doc":"Modifies `self`, deleting the elements in the collection for which the\npassed block returns `true`. Returns `self`.\n\n```\na = Deque{1, 6, 2, 4, 8}\na.reject! { |x| x > 3 }\na # => Deque{1, 2}\n```\n\nSee also: `Deque#reject`.","summary":"<p>Modifies <code>self</code>, deleting the elements in the collection for which the passed block returns <code>true</code>.</p>","abstract":false,"location":{"filename":"src/deque.cr","line_number":238,"url":null},"def":{"name":"reject!","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"self","visibility":"Public","body":"internal_delete do |e|\n  yield e\nend\nself\n"}},{"html_id":"reject!(pattern):self-instance-method","name":"reject!","doc":"Modifies `self`, deleting the elements in the collection for which\n`pattern === element`.\n\n```\na = Deque{1, 6, 2, 4, 8}\na.reject!(3..7)\na # => Deque{1, 2, 8}\n```\n\nSee also: `Deque#reject`.","summary":"<p>Modifies <code>self</code>, deleting the elements in the collection for which <code>pattern === element</code>.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : self","args_html":"(pattern) : <span class=\"k\">self</span>","location":{"filename":"src/deque.cr","line_number":253,"url":null},"def":{"name":"reject!","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"self","visibility":"Public","body":"reject! do |elem|\n  pattern === elem\nend\nself\n"}},{"html_id":"rotate!(n:Int=1):Nil-instance-method","name":"rotate!","doc":"Shifts all elements of `self` to the left *n* times. Returns `self`.\n\n```\na1 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\na2 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\na3 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\n\na1.rotate!\na2.rotate!(1)\na3.rotate!(3)\n\na1 # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]\na2 # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]\na3 # => [3, 4, 5, 6, 7, 8, 9, 0, 1, 2]\n```","summary":"<p>Shifts all elements of <code>self</code> to the left <em>n</em> times.</p>","abstract":false,"args":[{"name":"n","default_value":"1","external_name":"n","restriction":"Int"}],"args_string":"(n : Int = 1) : Nil","args_html":"(n : <a href=\"Int.html\">Int</a> = <span class=\"n\">1</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/deque.cr","line_number":486,"url":null},"def":{"name":"rotate!","args":[{"name":"n","default_value":"1","external_name":"n","restriction":"Int"}],"return_type":"Nil","visibility":"Public","body":"if @size <= 1\n  return\nend\nif @size == @capacity\n  @start = (@start + n) % @capacity\nelse\n  half = @size // 2\n  if n.abs >= half\n    n = ((n + half) % @size) - half\n  end\n  while n > 0\n    push(shift)\n    n = n - 1\n  end\n  while n < 0\n    n = n + 1\n    unshift(pop)\n  end\nend\n"}},{"html_id":"select!(&:T->):self-instance-method","name":"select!","doc":"Modifies `self`, keeping only the elements in the collection for which the\npassed block returns `true`. Returns `self`.\n\n```\na = Deque{1, 6, 2, 4, 8}\na.select! { |x| x > 3 }\na # => Deque{6, 4, 8}\n```\n\nSee also: `Deque#select`.","summary":"<p>Modifies <code>self</code>, keeping only the elements in the collection for which the passed block returns <code>true</code>.</p>","abstract":false,"location":{"filename":"src/deque.cr","line_number":210,"url":null},"def":{"name":"select!","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"self","visibility":"Public","body":"reject! do |elem|\n  !(yield(elem))\nend"}},{"html_id":"select!(pattern):self-instance-method","name":"select!","doc":"Modifies `self`, keeping only the elements in the collection for which\n`pattern === element`.\n\n```\nary = [1, 6, 2, 4, 8]\nary.select!(3..7)\nary # => [6, 4]\n```\n\nSee also: `Deque#select`.","summary":"<p>Modifies <code>self</code>, keeping only the elements in the collection for which <code>pattern === element</code>.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : self","args_html":"(pattern) : <span class=\"k\">self</span>","location":{"filename":"src/deque.cr","line_number":224,"url":null},"def":{"name":"select!","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"self","visibility":"Public","body":"self.select! do |elem|\n  pattern === elem\nend"}},{"html_id":"shift(n:Int):Nil-instance-method","name":"shift","doc":"Removes the first *n* (at most) items in the deque.","summary":"<p>Removes the first <em>n</em> (at most) items in the deque.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"}],"args_string":"(n : Int) : Nil","args_html":"(n : <a href=\"Int.html\">Int</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/deque.cr","line_number":539,"url":null},"def":{"name":"shift","args":[{"name":"n","external_name":"n","restriction":"Int"}],"return_type":"Nil","visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Can't shift negative count\"))\nend\nn = Math.min(n, @size)\nn.times do\n  shift\nend\nnil\n"}},{"html_id":"shift-instance-method","name":"shift","doc":"Removes and returns the first item. Raises `IndexError` if empty.\n\n```\na = Deque{1, 2, 3}\na.shift # => 1\na       # => Deque{2, 3}\n```","summary":"<p>Removes and returns the first item.</p>","abstract":false,"location":{"filename":"src/deque.cr","line_number":514,"url":null},"def":{"name":"shift","visibility":"Public","body":"shift do\n  raise(IndexError.new)\nend"}},{"html_id":"shift(&)-instance-method","name":"shift","doc":"Removes and returns the first item, if not empty, otherwise executes\nthe given block and returns its value.","summary":"<p>Removes and returns the first item, if not empty, otherwise executes the given block and returns its value.</p>","abstract":false,"location":{"filename":"src/deque.cr","line_number":520,"url":null},"def":{"name":"shift","yields":0,"visibility":"Public","body":"if @size == 0\n  yield\nelse\n  value = @buffer[@start]\n  (@buffer + @start).clear\n  @size = @size - 1\n  @start = @start + 1\n  if @start >= @capacity\n    @start = @start - @capacity\n  end\n  value\nend"}},{"html_id":"shift?-instance-method","name":"shift?","doc":"Removes and returns the first item, if not empty, otherwise `nil`.","summary":"<p>Removes and returns the first item, if not empty, otherwise <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/deque.cr","line_number":534,"url":null},"def":{"name":"shift?","visibility":"Public","body":"shift do\n  nil\nend"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Returns the number of elements in the deque.\n\n```\nDeque{:foo, :bar}.size # => 2\n```","summary":"<p>Returns the number of elements in the deque.</p>","abstract":false,"location":{"filename":"src/deque.cr","line_number":425,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"@size"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":102,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.array do\n  each(&.to_json(json))\nend"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a short String representation of this object\nwhich includes its class name and its object address.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).to_s # => #<Person:0x10a199f20>\n```","summary":"<p>Appends a short String representation of this object which includes its class name and its object address.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/deque.cr","line_number":548,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"inspect(io)"}},{"html_id":"unsafe_fetch(index:Int):T-instance-method","name":"unsafe_fetch","doc":"Returns the element at the given *index*, without doing any bounds check.\n\n`Indexable` makes sure to invoke this method with *index* in `0...size`,\nso converting negative indices to positive ones is not needed here.\n\nClients never invoke this method directly. Instead, they access\nelements with `#[](index)` and `#[]?(index)`.\n\nThis method should only be directly invoked if you are absolutely\nsure the index is in bounds, to avoid a bounds check for a small boost\nof performance.","summary":"<p>Returns the element at the given <em>index</em>, without doing any bounds check.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : T","args_html":"(index : <a href=\"Int.html\">Int</a>) : T","location":{"filename":"src/deque.cr","line_number":139,"url":null},"def":{"name":"unsafe_fetch","args":[{"name":"index","external_name":"index","restriction":"Int"}],"return_type":"T","visibility":"Public","body":"index = index + @start\nif index >= @capacity\n  index = index - @capacity\nend\n@buffer[index]\n"}},{"html_id":"unsafe_put(index:Int,value:T)-instance-method","name":"unsafe_put","doc":"Sets the element at the given *index* to *value*, without doing any bounds\ncheck.\n\n`Indexable::Mutable` makes sure to invoke this method with *index* in\n`0...size`, so converting negative indices to positive ones is not needed\nhere.\n\nClients never invoke this method directly. Instead, they modify elements\nwith `#[]=(index, value)`.\n\nThis method should only be directly invoked if you are absolutely\nsure the index is in bounds, to avoid a bounds check for a small boost\nof performance.","summary":"<p>Sets the element at the given <em>index</em> to <em>value</em>, without doing any bounds check.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(index : Int, value : T)","args_html":"(index : <a href=\"Int.html\">Int</a>, value : T)","location":{"filename":"src/deque.cr","line_number":145,"url":null},"def":{"name":"unsafe_put","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"index = index + @start\nif index >= @capacity\n  index = index - @capacity\nend\n@buffer[index] = value\n"}},{"html_id":"unshift(value:T):self-instance-method","name":"unshift","doc":"Adds an item to the beginning of the deque.\n\n```\na = Deque{1, 2}\na.unshift 0 # => Deque{0, 1, 2}\n```","summary":"<p>Adds an item to the beginning of the deque.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T) : self","args_html":"(value : T) : <span class=\"k\">self</span>","location":{"filename":"src/deque.cr","line_number":558,"url":null},"def":{"name":"unshift","args":[{"name":"value","external_name":"value","restriction":"T"}],"return_type":"self","visibility":"Public","body":"if @size >= @capacity\n  increase_capacity\nend\n@start = @start - 1\nif @start < 0\n  @start = @start + @capacity\nend\n@buffer[@start] = value\n@size = @size + 1\nself\n"}}]},{"html_id":"Crystal/Digest","path":"Digest.html","kind":"class","full_name":"Digest","name":"Digest","abstract":true,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/digest/digest.cr","line_number":14,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/OpenSSL/Digest","kind":"class","full_name":"OpenSSL::Digest","name":"Digest"}],"doc":"`Digest` is the base type of hashing algorithms like `Digest::MD5`,\n`Digest::SHA1`, `Digest::SHA256`, or `Digest::SHA512`.\n\nA `Digest` instance holds the state of an ongoing hash calculation.\nIt can receive new data to include in the hash via `#update`, `#<<`, or `#file`.\nOnce all data is included, use `#final` to get the hash. This will mark the\nongoing calculation as finished. A finished calculation can't receive new data.\n\nA `digest.dup.final` call may be used to get an intermediate hash value.\n\nUse `#reset` to reuse the `Digest` instance for a new calculation.","summary":"<p><code><a href=\"Digest.html\">Digest</a></code> is the base type of hashing algorithms like <code><a href=\"Digest/MD5.html\">Digest::MD5</a></code>, <code><a href=\"Digest/SHA1.html\">Digest::SHA1</a></code>, <code><a href=\"Digest/SHA256.html\">Digest::SHA256</a></code>, or <code><a href=\"Digest/SHA512.html\">Digest::SHA512</a></code>.</p>","instance_methods":[{"html_id":"<<(data):self-instance-method","name":"<<","doc":"Reads the io's data and updates the digest with it.","summary":"<p>Reads the io's data and updates the digest with it.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""}],"args_string":"(data) : self","args_html":"(data) : <span class=\"k\">self</span>","location":{"filename":"src/digest/digest.cr","line_number":166,"url":null},"def":{"name":"<<","args":[{"name":"data","external_name":"data","restriction":""}],"return_type":"self","visibility":"Public","body":"update(data)"}},{"html_id":"digest_size:Int32-instance-method","name":"digest_size","doc":"Returns the digest output size in bytes.","summary":"<p>Returns the digest output size in bytes.</p>","abstract":true,"location":{"filename":"src/digest/digest.cr","line_number":181,"url":null},"def":{"name":"digest_size","return_type":"Int32","visibility":"Public","body":""}},{"html_id":"file(file_name:Path|String):self-instance-method","name":"file","doc":"Reads the file's content and updates the digest with it.","summary":"<p>Reads the file's content and updates the digest with it.</p>","abstract":false,"args":[{"name":"file_name","external_name":"file_name","restriction":"Path | String"}],"args_string":"(file_name : Path | String) : self","args_html":"(file_name : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <span class=\"k\">self</span>","location":{"filename":"src/digest/digest.cr","line_number":150,"url":null},"def":{"name":"file","args":[{"name":"file_name","external_name":"file_name","restriction":"Path | String"}],"return_type":"self","visibility":"Public","body":"File.open(file_name) do |io|\n  self << io\nend"}},{"html_id":"final(dst:Bytes):Bytes-instance-method","name":"final","abstract":false,"args":[{"name":"dst","external_name":"dst","restriction":"Bytes"}],"args_string":"(dst : Bytes) : Bytes","args_html":"(dst : <a href=\"Bytes.html\">Bytes</a>) : <a href=\"Bytes.html\">Bytes</a>","location":{"filename":"src/digest/digest.cr","line_number":136,"url":null},"def":{"name":"final","args":[{"name":"dst","external_name":"dst","restriction":"Bytes"}],"return_type":"Bytes","visibility":"Public","body":"check_finished\n@finished = true\nfinal_impl(dst)\ndst\n"}},{"html_id":"final:Bytes-instance-method","name":"final","doc":"Returns the final digest output.\n\nThis method can only be called once and raises `FinalizedError` on subsequent calls.\n\nNOTE: `.dup.final` call may be used to get an intermediate hash value.","summary":"<p>Returns the final digest output.</p>","abstract":false,"location":{"filename":"src/digest/digest.cr","line_number":131,"url":null},"def":{"name":"final","return_type":"Bytes","visibility":"Public","body":"dst = Bytes.new(digest_size)\nfinal(dst)\n"}},{"html_id":"final_impl(dst:Bytes):Nil-instance-method","name":"final_impl","doc":"Stores the output digest of #digest_size bytes in dst.","summary":"<p>Stores the output digest of #digest_size bytes in dst.</p>","abstract":true,"args":[{"name":"dst","external_name":"dst","restriction":"Bytes"}],"args_string":"(dst : Bytes) : Nil","args_html":"(dst : <a href=\"Bytes.html\">Bytes</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/digest/digest.cr","line_number":177,"url":null},"def":{"name":"final_impl","args":[{"name":"dst","external_name":"dst","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":""}},{"html_id":"reset:self-instance-method","name":"reset","abstract":false,"location":{"filename":"src/digest/digest.cr","line_number":143,"url":null},"def":{"name":"reset","return_type":"self","visibility":"Public","body":"reset_impl\n@finished = false\nself\n"}},{"html_id":"reset_impl:Nil-instance-method","name":"reset_impl","doc":"Resets the object to it's initial state.","summary":"<p>Resets the object to it's initial state.</p>","abstract":true,"location":{"filename":"src/digest/digest.cr","line_number":179,"url":null},"def":{"name":"reset_impl","return_type":"Nil","visibility":"Public","body":""}},{"html_id":"update(data:Bytes):self-instance-method","name":"update","abstract":false,"args":[{"name":"data","external_name":"data","restriction":"Bytes"}],"args_string":"(data : Bytes) : self","args_html":"(data : <a href=\"Bytes.html\">Bytes</a>) : <span class=\"k\">self</span>","location":{"filename":"src/digest/digest.cr","line_number":120,"url":null},"def":{"name":"update","args":[{"name":"data","external_name":"data","restriction":"Bytes"}],"return_type":"self","visibility":"Public","body":"check_finished\nupdate_impl(data)\nself\n"}},{"html_id":"update(io:IO):self-instance-method","name":"update","doc":"Reads the io's data and updates the digest with it.","summary":"<p>Reads the io's data and updates the digest with it.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : self","args_html":"(io : <a href=\"IO.html\">IO</a>) : <span class=\"k\">self</span>","location":{"filename":"src/digest/digest.cr","line_number":157,"url":null},"def":{"name":"update","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"self","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4096)\nwhile (read_bytes = io.read(buffer.to_slice)) > 0\n  self << buffer.to_slice[0, read_bytes]\nend\nself\n"}},{"html_id":"update(data):self-instance-method","name":"update","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""}],"args_string":"(data) : self","args_html":"(data) : <span class=\"k\">self</span>","location":{"filename":"src/digest/digest.cr","line_number":116,"url":null},"def":{"name":"update","args":[{"name":"data","external_name":"data","restriction":""}],"return_type":"self","visibility":"Public","body":"update(data.to_slice)"}},{"html_id":"update_impl(data:Bytes):Nil-instance-method","name":"update_impl","doc":"Hashes data incrementally.","summary":"<p>Hashes data incrementally.</p>","abstract":true,"args":[{"name":"data","external_name":"data","restriction":"Bytes"}],"args_string":"(data : Bytes) : Nil","args_html":"(data : <a href=\"Bytes.html\">Bytes</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/digest/digest.cr","line_number":175,"url":null},"def":{"name":"update_impl","args":[{"name":"data","external_name":"data","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":""}}],"types":[{"html_id":"Crystal/Digest/Adler32","path":"Digest/Adler32.html","kind":"module","full_name":"Digest::Adler32","name":"Adler32","abstract":false,"locations":[{"filename":"src/digest/adler32.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Digest","kind":"class","full_name":"Digest","name":"Digest"},"doc":"Implements the Adler32 checksum algorithm.","summary":"<p>Implements the Adler32 checksum algorithm.</p>","class_methods":[{"html_id":"checksum(data):UInt32-class-method","name":"checksum","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""}],"args_string":"(data) : UInt32","args_html":"(data) : <a href=\"../UInt32.html\">UInt32</a>","location":{"filename":"src/digest/adler32.cr","line_number":10,"url":null},"def":{"name":"checksum","args":[{"name":"data","external_name":"data","restriction":""}],"return_type":"UInt32","visibility":"Public","body":"update(data, initial)"}},{"html_id":"combine(adler1:UInt32,adler2:UInt32,len):UInt32-class-method","name":"combine","abstract":false,"args":[{"name":"adler1","external_name":"adler1","restriction":"UInt32"},{"name":"adler2","external_name":"adler2","restriction":"UInt32"},{"name":"len","external_name":"len","restriction":""}],"args_string":"(adler1 : UInt32, adler2 : UInt32, len) : UInt32","args_html":"(adler1 : <a href=\"../UInt32.html\">UInt32</a>, adler2 : <a href=\"../UInt32.html\">UInt32</a>, len) : <a href=\"../UInt32.html\">UInt32</a>","location":{"filename":"src/digest/adler32.cr","line_number":19,"url":null},"def":{"name":"combine","args":[{"name":"adler1","external_name":"adler1","restriction":"UInt32"},{"name":"adler2","external_name":"adler2","restriction":"UInt32"},{"name":"len","external_name":"len","restriction":""}],"return_type":"UInt32","visibility":"Public","body":"(LibZ.adler32_combine(adler1, adler2, len)).to_u32"}},{"html_id":"initial:UInt32-class-method","name":"initial","abstract":false,"location":{"filename":"src/digest/adler32.cr","line_number":6,"url":null},"def":{"name":"initial","return_type":"UInt32","visibility":"Public","body":"(LibZ.adler32(0, nil, 0)).to_u32"}},{"html_id":"update(data,adler32:UInt32):UInt32-class-method","name":"update","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""},{"name":"adler32","external_name":"adler32","restriction":"UInt32"}],"args_string":"(data, adler32 : UInt32) : UInt32","args_html":"(data, adler32 : <a href=\"../UInt32.html\">UInt32</a>) : <a href=\"../UInt32.html\">UInt32</a>","location":{"filename":"src/digest/adler32.cr","line_number":14,"url":null},"def":{"name":"update","args":[{"name":"data","external_name":"data","restriction":""},{"name":"adler32","external_name":"adler32","restriction":"UInt32"}],"return_type":"UInt32","visibility":"Public","body":"slice = data.to_slice\n(LibZ.adler32(adler32, slice, slice.size)).to_u32\n"}}]},{"html_id":"Crystal/Digest/ClassMethods","path":"Digest/ClassMethods.html","kind":"module","full_name":"Digest::ClassMethods","name":"ClassMethods","abstract":false,"locations":[{"filename":"src/digest/digest.cr","line_number":22,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Digest","kind":"class","full_name":"Digest","name":"Digest"},"doc":"The `Digest::ClassMethods` module is used in the concrete subclass of `Digest`\nthat does not require arguments in its construction.\n\nThe modules adds convenient class methods as `Digest::MD5.digest`, `Digest::MD5.hexdigest`.","summary":"<p>The <code><a href=\"../Digest/ClassMethods.html\">Digest::ClassMethods</a></code> module is used in the concrete subclass of <code><a href=\"../Digest.html\">Digest</a></code> that does not require arguments in its construction.</p>","instance_methods":[{"html_id":"base64digest(data):String-instance-method","name":"base64digest","doc":"Returns the base64-encoded hash of *data*.\n\n```\nrequire \"digest/sha1\"\n\nDigest::SHA1.base64digest(\"foo\") # => \"C+7Hteo/D9vJXQ3UfzxbwnXaijM=\"\n```","summary":"<p>Returns the base64-encoded hash of <em>data</em>.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""}],"args_string":"(data) : String","args_html":"(data) : <a href=\"../String.html\">String</a>","location":{"filename":"src/digest/digest.cr","line_number":88,"url":null},"def":{"name":"base64digest","args":[{"name":"data","external_name":"data","restriction":""}],"return_type":"String","visibility":"Public","body":"base64digest(&.update(data))"}},{"html_id":"base64digest(&:self->_):String-instance-method","name":"base64digest","doc":"Yields a context object with an `#update(data : String | Bytes)`\nmethod available. Returns the resulting digest in base64 representation\nafterwards.\n\n```\nrequire \"digest/sha1\"\n\nDigest::SHA1.base64digest do |ctx|\n  ctx.update \"f\"\n  ctx.update \"oo\"\nend\n# => \"C+7Hteo/D9vJXQ3UfzxbwnXaijM=\"\n```","summary":"<p>Yields a context object with an <code>#update(data : String | Bytes)</code> method available.</p>","abstract":false,"location":{"filename":"src/digest/digest.cr","line_number":105,"url":null},"def":{"name":"base64digest","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(self -> _)"},"return_type":"String","visibility":"Public","body":"hashsum = digest do |ctx|\n  yield ctx\nend\nBase64.strict_encode(hashsum)\n"}},{"html_id":"digest(data):Bytes-instance-method","name":"digest","doc":"Returns the hash of *data*. *data* must respond to `#to_slice`.","summary":"<p>Returns the hash of <em>data</em>.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""}],"args_string":"(data) : Bytes","args_html":"(data) : <a href=\"../Bytes.html\">Bytes</a>","location":{"filename":"src/digest/digest.cr","line_number":24,"url":null},"def":{"name":"digest","args":[{"name":"data","external_name":"data","restriction":""}],"return_type":"Bytes","visibility":"Public","body":"digest do |ctx|\n  ctx.update(data.to_slice)\nend"}},{"html_id":"digest(&:self->):Bytes-instance-method","name":"digest","doc":"Yields an instance of `self` which can receive calls to `#update(data : String | Bytes)`\nand returns the finalized digest afterwards.\n\n```\nrequire \"digest/md5\"\n\ndigest = Digest::MD5.digest do |ctx|\n  ctx.update \"f\"\n  ctx.update \"oo\"\nend\ndigest.to_slice.hexstring # => \"acbd18db4cc2f85cedef654fccc4a4d8\"\n```","summary":"<p>Yields an instance of <code>self</code> which can receive calls to <code>#update(data : String | Bytes)</code> and returns the finalized digest afterwards.</p>","abstract":false,"location":{"filename":"src/digest/digest.cr","line_number":42,"url":null},"def":{"name":"digest","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(self ->)"},"return_type":"Bytes","visibility":"Public","body":"context = new\nyield context\ncontext.final\n"}},{"html_id":"hexdigest(data):String-instance-method","name":"hexdigest","doc":"Returns the hexadecimal representation of the hash of *data*.\n\n```\nrequire \"digest/md5\"\n\nDigest::MD5.hexdigest(\"foo\") # => \"acbd18db4cc2f85cedef654fccc4a4d8\"\n```","summary":"<p>Returns the hexadecimal representation of the hash of <em>data</em>.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""}],"args_string":"(data) : String","args_html":"(data) : <a href=\"../String.html\">String</a>","location":{"filename":"src/digest/digest.cr","line_number":55,"url":null},"def":{"name":"hexdigest","args":[{"name":"data","external_name":"data","restriction":""}],"return_type":"String","visibility":"Public","body":"hexdigest(&.update(data))"}},{"html_id":"hexdigest(&:self->):String-instance-method","name":"hexdigest","doc":"Yields a context object with an `#update(data : String | Bytes)`\nmethod available. Returns the resulting digest in hexadecimal representation\nafterwards.\n\n```\nrequire \"digest/md5\"\n\nDigest::MD5.hexdigest(\"foo\") # => \"acbd18db4cc2f85cedef654fccc4a4d8\"\nDigest::MD5.hexdigest do |ctx|\n  ctx.update \"f\"\n  ctx.update \"oo\"\nend\n# => \"acbd18db4cc2f85cedef654fccc4a4d8\"\n```","summary":"<p>Yields a context object with an <code>#update(data : String | Bytes)</code> method available.</p>","abstract":false,"location":{"filename":"src/digest/digest.cr","line_number":73,"url":null},"def":{"name":"hexdigest","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(self ->)"},"return_type":"String","visibility":"Public","body":"hashsum = digest do |ctx|\n  yield ctx\nend\nhashsum.to_slice.hexstring\n"}}]},{"html_id":"Crystal/Digest/CRC32","path":"Digest/CRC32.html","kind":"module","full_name":"Digest::CRC32","name":"CRC32","abstract":false,"locations":[{"filename":"src/digest/crc32.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Digest","kind":"class","full_name":"Digest","name":"Digest"},"doc":"Implements the CRC32 checksum algorithm.","summary":"<p>Implements the CRC32 checksum algorithm.</p>","class_methods":[{"html_id":"checksum(data):UInt32-class-method","name":"checksum","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""}],"args_string":"(data) : UInt32","args_html":"(data) : <a href=\"../UInt32.html\">UInt32</a>","location":{"filename":"src/digest/crc32.cr","line_number":10,"url":null},"def":{"name":"checksum","args":[{"name":"data","external_name":"data","restriction":""}],"return_type":"UInt32","visibility":"Public","body":"update(data, initial)"}},{"html_id":"combine(crc1:UInt32,crc2:UInt32,len):UInt32-class-method","name":"combine","abstract":false,"args":[{"name":"crc1","external_name":"crc1","restriction":"UInt32"},{"name":"crc2","external_name":"crc2","restriction":"UInt32"},{"name":"len","external_name":"len","restriction":""}],"args_string":"(crc1 : UInt32, crc2 : UInt32, len) : UInt32","args_html":"(crc1 : <a href=\"../UInt32.html\">UInt32</a>, crc2 : <a href=\"../UInt32.html\">UInt32</a>, len) : <a href=\"../UInt32.html\">UInt32</a>","location":{"filename":"src/digest/crc32.cr","line_number":19,"url":null},"def":{"name":"combine","args":[{"name":"crc1","external_name":"crc1","restriction":"UInt32"},{"name":"crc2","external_name":"crc2","restriction":"UInt32"},{"name":"len","external_name":"len","restriction":""}],"return_type":"UInt32","visibility":"Public","body":"(LibZ.crc32_combine(crc1, crc2, len)).to_u32"}},{"html_id":"initial:UInt32-class-method","name":"initial","abstract":false,"location":{"filename":"src/digest/crc32.cr","line_number":6,"url":null},"def":{"name":"initial","return_type":"UInt32","visibility":"Public","body":"(LibZ.crc32(0, nil, 0)).to_u32"}},{"html_id":"update(data,crc32:UInt32):UInt32-class-method","name":"update","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""},{"name":"crc32","external_name":"crc32","restriction":"UInt32"}],"args_string":"(data, crc32 : UInt32) : UInt32","args_html":"(data, crc32 : <a href=\"../UInt32.html\">UInt32</a>) : <a href=\"../UInt32.html\">UInt32</a>","location":{"filename":"src/digest/crc32.cr","line_number":14,"url":null},"def":{"name":"update","args":[{"name":"data","external_name":"data","restriction":""},{"name":"crc32","external_name":"crc32","restriction":"UInt32"}],"return_type":"UInt32","visibility":"Public","body":"slice = data.to_slice\n(LibZ.crc32(crc32, slice, slice.size)).to_u32\n"}}]},{"html_id":"Crystal/Digest/FinalizedError","path":"Digest/FinalizedError.html","kind":"class","full_name":"Digest::FinalizedError","name":"FinalizedError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/digest/digest.cr","line_number":15,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Digest","kind":"class","full_name":"Digest","name":"Digest"}},{"html_id":"Crystal/Digest/MD5","path":"Digest/MD5.html","kind":"class","full_name":"Digest::MD5","name":"MD5","abstract":false,"superclass":{"html_id":"Crystal/OpenSSL/Digest","kind":"class","full_name":"OpenSSL::Digest","name":"Digest"},"ancestors":[{"html_id":"Crystal/OpenSSL/Digest","kind":"class","full_name":"OpenSSL::Digest","name":"Digest"},{"html_id":"Crystal/Digest","kind":"class","full_name":"Digest","name":"Digest"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/digest/md5.cr","line_number":10,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"extended_modules":[{"html_id":"Crystal/Digest/ClassMethods","kind":"module","full_name":"Digest::ClassMethods","name":"ClassMethods"}],"namespace":{"html_id":"Crystal/Digest","kind":"class","full_name":"Digest","name":"Digest"},"doc":"Implements the MD5 digest algorithm.\n\nWARNING: MD5 is no longer a cryptographically secure hash, and should not be\nused in security-related components, like password hashing. For passwords, see\n`Crypto::Bcrypt::Password`. For a generic cryptographic hash, use SHA-256 via\n`Digest::SHA256`.","summary":"<p>Implements the MD5 digest algorithm.</p>","constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/digest/md5.cr","line_number":13,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy of this object.\n\nThis allocates a new object and copies the contents of\n`self` into it.","summary":"<p>Returns a shallow copy of this object.</p>","abstract":false,"location":{"filename":"src/digest/md5.cr","line_number":21,"url":null},"def":{"name":"dup","visibility":"Public","body":"self.class.new(dup_ctx)"}}]},{"html_id":"Crystal/Digest/SHA1","path":"Digest/SHA1.html","kind":"class","full_name":"Digest::SHA1","name":"SHA1","abstract":false,"superclass":{"html_id":"Crystal/OpenSSL/Digest","kind":"class","full_name":"OpenSSL::Digest","name":"Digest"},"ancestors":[{"html_id":"Crystal/OpenSSL/Digest","kind":"class","full_name":"OpenSSL::Digest","name":"Digest"},{"html_id":"Crystal/Digest","kind":"class","full_name":"Digest","name":"Digest"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/digest/sha1.cr","line_number":10,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"extended_modules":[{"html_id":"Crystal/Digest/ClassMethods","kind":"module","full_name":"Digest::ClassMethods","name":"ClassMethods"}],"namespace":{"html_id":"Crystal/Digest","kind":"class","full_name":"Digest","name":"Digest"},"doc":"Implements the SHA1 digest algorithm.\n\nWARNING: SHA1 is no longer a cryptographically secure hash, and should not be\nused in security-related components, like password hashing. For passwords, see\n`Crypto::Bcrypt::Password`. For a generic cryptographic hash, use SHA-256 via\n`Digest::SHA256`.","summary":"<p>Implements the SHA1 digest algorithm.</p>","constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/digest/sha1.cr","line_number":13,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy of this object.\n\nThis allocates a new object and copies the contents of\n`self` into it.","summary":"<p>Returns a shallow copy of this object.</p>","abstract":false,"location":{"filename":"src/digest/sha1.cr","line_number":21,"url":null},"def":{"name":"dup","visibility":"Public","body":"self.class.new(dup_ctx)"}}]},{"html_id":"Crystal/Digest/SHA256","path":"Digest/SHA256.html","kind":"class","full_name":"Digest::SHA256","name":"SHA256","abstract":false,"superclass":{"html_id":"Crystal/OpenSSL/Digest","kind":"class","full_name":"OpenSSL::Digest","name":"Digest"},"ancestors":[{"html_id":"Crystal/OpenSSL/Digest","kind":"class","full_name":"OpenSSL::Digest","name":"Digest"},{"html_id":"Crystal/Digest","kind":"class","full_name":"Digest","name":"Digest"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/digest/sha256.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"extended_modules":[{"html_id":"Crystal/Digest/ClassMethods","kind":"module","full_name":"Digest::ClassMethods","name":"ClassMethods"}],"namespace":{"html_id":"Crystal/Digest","kind":"class","full_name":"Digest","name":"Digest"},"doc":"Implements the SHA256 digest algorithm.","summary":"<p>Implements the SHA256 digest algorithm.</p>","constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/digest/sha256.cr","line_number":8,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy of this object.\n\nThis allocates a new object and copies the contents of\n`self` into it.","summary":"<p>Returns a shallow copy of this object.</p>","abstract":false,"location":{"filename":"src/digest/sha256.cr","line_number":16,"url":null},"def":{"name":"dup","visibility":"Public","body":"self.class.new(dup_ctx)"}}]},{"html_id":"Crystal/Digest/SHA512","path":"Digest/SHA512.html","kind":"class","full_name":"Digest::SHA512","name":"SHA512","abstract":false,"superclass":{"html_id":"Crystal/OpenSSL/Digest","kind":"class","full_name":"OpenSSL::Digest","name":"Digest"},"ancestors":[{"html_id":"Crystal/OpenSSL/Digest","kind":"class","full_name":"OpenSSL::Digest","name":"Digest"},{"html_id":"Crystal/Digest","kind":"class","full_name":"Digest","name":"Digest"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/digest/sha512.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"extended_modules":[{"html_id":"Crystal/Digest/ClassMethods","kind":"module","full_name":"Digest::ClassMethods","name":"ClassMethods"}],"namespace":{"html_id":"Crystal/Digest","kind":"class","full_name":"Digest","name":"Digest"},"doc":"Implements the SHA512 digest algorithm.","summary":"<p>Implements the SHA512 digest algorithm.</p>","constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/digest/sha512.cr","line_number":8,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy of this object.\n\nThis allocates a new object and copies the contents of\n`self` into it.","summary":"<p>Returns a shallow copy of this object.</p>","abstract":false,"location":{"filename":"src/digest/sha512.cr","line_number":16,"url":null},"def":{"name":"dup","visibility":"Public","body":"self.class.new(dup_ctx)"}}]}]},{"html_id":"Crystal/Dir","path":"Dir.html","kind":"class","full_name":"Dir","name":"Dir","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/dir.cr","line_number":10,"url":null},{"filename":"src/dir/glob.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"}],"doc":"Objects of class `Dir` are directory streams representing directories in the underlying file system.\nThey provide a variety of ways to list directories and their contents.\n\nThe directory used in these examples contains the two regular files (`config.h` and `main.rb`),\nthe parent directory (`..`), and the directory itself (`.`).\n\nSee also: `File`.","summary":"<p>Objects of class <code><a href=\"Dir.html\">Dir</a></code> are directory streams representing directories in the underlying file system.</p>","class_methods":[{"html_id":"[](patterns:Enumerable,match_hidden=false,follow_symlinks=false):Array(String)-class-method","name":"[]","doc":"Returns an array of all files that match against any of *patterns*.\n\nThe pattern syntax is similar to shell filename globbing, see `File.match?` for details.\n\nNOTE: Path separator in patterns needs to be always `/`. The returned file names use system-specific path separators.","summary":"<p>Returns an array of all files that match against any of <em>patterns</em>.</p>","abstract":false,"args":[{"name":"patterns","external_name":"patterns","restriction":"Enumerable"},{"name":"match_hidden","default_value":"false","external_name":"match_hidden","restriction":""},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"args_string":"(patterns : Enumerable, match_hidden = false, follow_symlinks = false) : Array(String)","args_html":"(patterns : <a href=\"Enumerable.html\">Enumerable</a>, match_hidden = <span class=\"n\">false</span>, follow_symlinks = <span class=\"n\">false</span>) : <a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)","location":{"filename":"src/dir/glob.cr","line_number":12,"url":null},"def":{"name":"[]","args":[{"name":"patterns","external_name":"patterns","restriction":"Enumerable"},{"name":"match_hidden","default_value":"false","external_name":"match_hidden","restriction":""},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"return_type":"Array(String)","visibility":"Public","body":"glob(patterns, match_hidden: match_hidden, follow_symlinks: follow_symlinks)"}},{"html_id":"[](*patterns:Path|String,match_hidden=false,follow_symlinks=false):Array(String)-class-method","name":"[]","doc":"Returns an array of all files that match against any of *patterns*.\n\nThe pattern syntax is similar to shell filename globbing, see `File.match?` for details.\n\nNOTE: Path separator in patterns needs to be always `/`. The returned file names use system-specific path separators.","summary":"<p>Returns an array of all files that match against any of <em>patterns</em>.</p>","abstract":false,"args":[{"name":"patterns","external_name":"patterns","restriction":"Path | String"},{"name":"match_hidden","default_value":"false","external_name":"match_hidden","restriction":""},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"args_string":"(*patterns : Path | String, match_hidden = false, follow_symlinks = false) : Array(String)","args_html":"(*patterns : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, match_hidden = <span class=\"n\">false</span>, follow_symlinks = <span class=\"n\">false</span>) : <a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)","location":{"filename":"src/dir/glob.cr","line_number":7,"url":null},"def":{"name":"[]","args":[{"name":"patterns","external_name":"patterns","restriction":"Path | String"},{"name":"match_hidden","default_value":"false","external_name":"match_hidden","restriction":""},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"splat_index":0,"return_type":"Array(String)","visibility":"Public","body":"glob(patterns, match_hidden: match_hidden, follow_symlinks: follow_symlinks)"}},{"html_id":"cd(path:Path|String):String-class-method","name":"cd","doc":"Changes the current working directory of the process to the given string.","summary":"<p>Changes the current working directory of the process to the given string.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : String","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/dir.cr","line_number":146,"url":null},"def":{"name":"cd","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"String","visibility":"Public","body":"Crystal::System::Dir.current = path.to_s"}},{"html_id":"cd(path:Path|String,&)-class-method","name":"cd","doc":"Changes the current working directory of the process to the given string\nand invokes the block, restoring the original working directory\nwhen the block exits.","summary":"<p>Changes the current working directory of the process to the given string and invokes the block, restoring the original working directory when the block exits.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String, &)","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, &)","location":{"filename":"src/dir.cr","line_number":153,"url":null},"def":{"name":"cd","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"yields":0,"visibility":"Public","body":"old = current\nbegin\n  cd(path)\n  yield\nensure\n  cd(old)\nend\n"}},{"html_id":"children(dirname:Path|String):Array(String)-class-method","name":"children","doc":"See `#children`.","summary":"<p>See <code><a href=\"Dir.html#children%3AArray%28String%29-instance-method\">#children</a></code>.</p>","abstract":false,"args":[{"name":"dirname","external_name":"dirname","restriction":"Path | String"}],"args_string":"(dirname : Path | String) : Array(String)","args_html":"(dirname : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)","location":{"filename":"src/dir.cr","line_number":198,"url":null},"def":{"name":"children","args":[{"name":"dirname","external_name":"dirname","restriction":"Path | String"}],"return_type":"Array(String)","visibility":"Public","body":"Dir.open(dirname) do |dir|\n  return dir.children\nend"}},{"html_id":"current:String-class-method","name":"current","doc":"Returns the current working directory.","summary":"<p>Returns the current working directory.</p>","abstract":false,"location":{"filename":"src/dir.cr","line_number":141,"url":null},"def":{"name":"current","return_type":"String","visibility":"Public","body":"Crystal::System::Dir.current"}},{"html_id":"delete(path:Path|String):Nil-class-method","name":"delete","doc":"Removes the directory at the given path.","summary":"<p>Removes the directory at the given path.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Nil","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/dir.cr","line_number":252,"url":null},"def":{"name":"delete","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"Crystal::System::Dir.delete(path.to_s)"}},{"html_id":"each(dirname:Path|String,&:String->)-class-method","name":"each","doc":"See `#each`.","summary":"<p>See <code><a href=\"Dir.html#each%28%26%3AString-%3E%29%3ANil-instance-method\">#each</a></code>.</p>","abstract":false,"args":[{"name":"dirname","external_name":"dirname","restriction":"Path | String"}],"args_string":"(dirname : Path | String, & : String -> )","args_html":"(dirname : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, & : <a href=\"String.html\">String</a> -> )","location":{"filename":"src/dir.cr","line_number":173,"url":null},"def":{"name":"each","args":[{"name":"dirname","external_name":"dirname","restriction":"Path | String"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(String ->)"},"visibility":"Public","body":"Dir.open(dirname) do |dir|\n  dir.each do |filename|\n    yield filename\n  end\nend"}},{"html_id":"each_child(dirname:Path|String,&:String->)-class-method","name":"each_child","doc":"See `#each_child`.","summary":"<p>See <code><a href=\"Dir.html#each_child%28%26%3AString-%3E%29%3ANil-instance-method\">#each_child</a></code>.</p>","abstract":false,"args":[{"name":"dirname","external_name":"dirname","restriction":"Path | String"}],"args_string":"(dirname : Path | String, & : String -> )","args_html":"(dirname : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, & : <a href=\"String.html\">String</a> -> )","location":{"filename":"src/dir.cr","line_number":189,"url":null},"def":{"name":"each_child","args":[{"name":"dirname","external_name":"dirname","restriction":"Path | String"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(String ->)"},"visibility":"Public","body":"Dir.open(dirname) do |dir|\n  dir.each_child do |filename|\n    yield filename\n  end\nend"}},{"html_id":"empty?(path:Path|String):Bool-class-method","name":"empty?","doc":"Returns `true` if the directory at *path* is empty, otherwise returns `false`.\nRaises `File::NotFoundError` if the directory at *path* does not exist.\n\n```\nDir.mkdir(\"bar\")\nDir.empty?(\"bar\") # => true\nFile.write(\"bar/a_file\", \"The content\")\nDir.empty?(\"bar\") # => false\n```","summary":"<p>Returns <code>true</code> if the directory at <em>path</em> is empty, otherwise returns <code>false</code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Bool","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/dir.cr","line_number":222,"url":null},"def":{"name":"empty?","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Bool","visibility":"Public","body":"each_child(path) do |f|\n  return false\nend\ntrue\n"}},{"html_id":"entries(dirname:Path|String):Array(String)-class-method","name":"entries","doc":"See `#entries`.","summary":"<p>See <code><a href=\"Dir.html#entries%3AArray%28String%29-instance-method\">#entries</a></code>.</p>","abstract":false,"args":[{"name":"dirname","external_name":"dirname","restriction":"Path | String"}],"args_string":"(dirname : Path | String) : Array(String)","args_html":"(dirname : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)","location":{"filename":"src/dir.cr","line_number":182,"url":null},"def":{"name":"entries","args":[{"name":"dirname","external_name":"dirname","restriction":"Path | String"}],"return_type":"Array(String)","visibility":"Public","body":"Dir.open(dirname) do |dir|\n  return dir.entries\nend"}},{"html_id":"exists?(path:Path|String):Bool-class-method","name":"exists?","doc":"Returns `true` if the given path exists and is a directory","summary":"<p>Returns <code>true</code> if the given path exists and is a directory</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Bool","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/dir.cr","line_number":205,"url":null},"def":{"name":"exists?","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Bool","visibility":"Public","body":"if info = File.info?(path)\n  info.type.directory?\nelse\n  false\nend"}},{"html_id":"glob(patterns:Enumerable,match_hidden=false,follow_symlinks=false):Array(String)-class-method","name":"glob","doc":"Returns an array of all files that match against any of *patterns*.\n\nThe pattern syntax is similar to shell filename globbing, see `File.match?` for details.\n\nIf *match_hidden* is `true` the pattern will match hidden files and folders.\n\nNOTE: Path separator in patterns needs to be always `/`. The returned file names use system-specific path separators.","summary":"<p>Returns an array of all files that match against any of <em>patterns</em>.</p>","abstract":false,"args":[{"name":"patterns","external_name":"patterns","restriction":"Enumerable"},{"name":"match_hidden","default_value":"false","external_name":"match_hidden","restriction":""},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"args_string":"(patterns : Enumerable, match_hidden = false, follow_symlinks = false) : Array(String)","args_html":"(patterns : <a href=\"Enumerable.html\">Enumerable</a>, match_hidden = <span class=\"n\">false</span>, follow_symlinks = <span class=\"n\">false</span>) : <a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)","location":{"filename":"src/dir/glob.cr","line_number":28,"url":null},"def":{"name":"glob","args":[{"name":"patterns","external_name":"patterns","restriction":"Enumerable"},{"name":"match_hidden","default_value":"false","external_name":"match_hidden","restriction":""},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"return_type":"Array(String)","visibility":"Public","body":"paths = [] of String\nglob(patterns, match_hidden: match_hidden, follow_symlinks: follow_symlinks) do |path|\n  paths << path\nend\npaths\n"}},{"html_id":"glob(*patterns:Path|String,match_hidden=false,follow_symlinks=false):Array(String)-class-method","name":"glob","doc":"Returns an array of all files that match against any of *patterns*.\n\nThe pattern syntax is similar to shell filename globbing, see `File.match?` for details.\n\nIf *match_hidden* is `true` the pattern will match hidden files and folders.\n\nNOTE: Path separator in patterns needs to be always `/`. The returned file names use system-specific path separators.","summary":"<p>Returns an array of all files that match against any of <em>patterns</em>.</p>","abstract":false,"args":[{"name":"patterns","external_name":"patterns","restriction":"Path | String"},{"name":"match_hidden","default_value":"false","external_name":"match_hidden","restriction":""},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"args_string":"(*patterns : Path | String, match_hidden = false, follow_symlinks = false) : Array(String)","args_html":"(*patterns : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, match_hidden = <span class=\"n\">false</span>, follow_symlinks = <span class=\"n\">false</span>) : <a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)","location":{"filename":"src/dir/glob.cr","line_number":23,"url":null},"def":{"name":"glob","args":[{"name":"patterns","external_name":"patterns","restriction":"Path | String"},{"name":"match_hidden","default_value":"false","external_name":"match_hidden","restriction":""},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"splat_index":0,"return_type":"Array(String)","visibility":"Public","body":"glob(patterns, match_hidden: match_hidden, follow_symlinks: follow_symlinks)"}},{"html_id":"glob(patterns:Enumerable,match_hidden=false,follow_symlinks=false,&block:String->_)-class-method","name":"glob","doc":"Yields all files that match against any of *patterns*.\n\nThe pattern syntax is similar to shell filename globbing, see `File.match?` for details.\n\nIf *match_hidden* is `true` the pattern will match hidden files and folders.\n\nNOTE: Path separator in patterns needs to be always `/`. The returned file names use system-specific path separators.","summary":"<p>Yields all files that match against any of <em>patterns</em>.</p>","abstract":false,"args":[{"name":"patterns","external_name":"patterns","restriction":"Enumerable"},{"name":"match_hidden","default_value":"false","external_name":"match_hidden","restriction":""},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"args_string":"(patterns : Enumerable, match_hidden = false, follow_symlinks = false, &block : String -> _)","args_html":"(patterns : <a href=\"Enumerable.html\">Enumerable</a>, match_hidden = <span class=\"n\">false</span>, follow_symlinks = <span class=\"n\">false</span>, &block : <a href=\"String.html\">String</a> -> _)","location":{"filename":"src/dir/glob.cr","line_number":50,"url":null},"def":{"name":"glob","args":[{"name":"patterns","external_name":"patterns","restriction":"Enumerable"},{"name":"match_hidden","default_value":"false","external_name":"match_hidden","restriction":""},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(String -> _)"},"visibility":"Public","body":"Globber.glob(patterns, match_hidden: match_hidden, follow_symlinks: follow_symlinks) do |path|\n  yield path\nend"}},{"html_id":"glob(*patterns:Path|String,match_hidden=false,follow_symlinks=false,&block:String->_)-class-method","name":"glob","doc":"Yields all files that match against any of *patterns*.\n\nThe pattern syntax is similar to shell filename globbing, see `File.match?` for details.\n\nIf *match_hidden* is `true` the pattern will match hidden files and folders.\n\nNOTE: Path separator in patterns needs to be always `/`. The returned file names use system-specific path separators.","summary":"<p>Yields all files that match against any of <em>patterns</em>.</p>","abstract":false,"args":[{"name":"patterns","external_name":"patterns","restriction":"Path | String"},{"name":"match_hidden","default_value":"false","external_name":"match_hidden","restriction":""},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"args_string":"(*patterns : Path | String, match_hidden = false, follow_symlinks = false, &block : String -> _)","args_html":"(*patterns : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, match_hidden = <span class=\"n\">false</span>, follow_symlinks = <span class=\"n\">false</span>, &block : <a href=\"String.html\">String</a> -> _)","location":{"filename":"src/dir/glob.cr","line_number":43,"url":null},"def":{"name":"glob","args":[{"name":"patterns","external_name":"patterns","restriction":"Path | String"},{"name":"match_hidden","default_value":"false","external_name":"match_hidden","restriction":""},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"splat_index":0,"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(String -> _)"},"visibility":"Public","body":"glob(patterns, match_hidden: match_hidden, follow_symlinks: follow_symlinks) do |path|\n  yield path\nend"}},{"html_id":"mkdir(path:Path|String,mode=511):Nil-class-method","name":"mkdir","doc":"Creates a new directory at the given path. The linux-style permission mode\ncan be specified, with a default of 777 (0o777).\n\nNOTE: *mode* is ignored on windows.","summary":"<p>Creates a new directory at the given path.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"mode","default_value":"511","external_name":"mode","restriction":""}],"args_string":"(path : Path | String, mode = 511) : Nil","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, mode = <span class=\"n\">511</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/dir.cr","line_number":233,"url":null},"def":{"name":"mkdir","args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"mode","default_value":"511","external_name":"mode","restriction":""}],"return_type":"Nil","visibility":"Public","body":"Crystal::System::Dir.create(path.to_s, mode)"}},{"html_id":"mkdir_p(path:Path|String,mode=511):Nil-class-method","name":"mkdir_p","doc":"Creates a new directory at the given path, including any non-existing\nintermediate directories. The linux-style permission mode can be specified,\nwith a default of 777 (0o777).","summary":"<p>Creates a new directory at the given path, including any non-existing intermediate directories.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"mode","default_value":"511","external_name":"mode","restriction":""}],"args_string":"(path : Path | String, mode = 511) : Nil","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, mode = <span class=\"n\">511</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/dir.cr","line_number":240,"url":null},"def":{"name":"mkdir_p","args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"mode","default_value":"511","external_name":"mode","restriction":""}],"return_type":"Nil","visibility":"Public","body":"if Dir.exists?(path)\n  return\nend\npath = Path.new(path)\npath.each_parent do |parent|\n  if Dir.exists?(parent)\n  else\n    mkdir(parent, mode)\n  end\nend\nif Dir.exists?(path)\nelse\n  mkdir(path, mode)\nend\n"}},{"html_id":"open(path:Path|String,&:self->)-class-method","name":"open","doc":"Opens a directory and yields it, closing it at the end of the block.\nReturns the value of the block.","summary":"<p>Opens a directory and yields it, closing it at the end of the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String, & : self -> )","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, & : <span class=\"k\">self</span> -> )","location":{"filename":"src/dir.cr","line_number":30,"url":null},"def":{"name":"open","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(self ->)"},"visibility":"Public","body":"dir = new(path)\nbegin\n  yield dir\nensure\n  dir.close\nend\n"}},{"html_id":"tempdir:String-class-method","name":"tempdir","doc":"Returns the tmp dir used for tempfile.\n\n```\nDir.tempdir # => \"/tmp\"\n```","summary":"<p>Returns the tmp dir used for tempfile.</p>","abstract":false,"location":{"filename":"src/dir.cr","line_number":168,"url":null},"def":{"name":"tempdir","return_type":"String","visibility":"Public","body":"Crystal::System::Dir.tempdir"}}],"constructors":[{"html_id":"new(path:Path|String)-class-method","name":"new","doc":"Returns a new directory object for the named directory.","summary":"<p>Returns a new directory object for the named directory.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String)","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>)","location":{"filename":"src/dir.cr","line_number":17,"url":null},"def":{"name":"new","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"visibility":"Public","body":"_ = allocate\n_.initialize(path)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"open(path:Path|String):self-class-method","name":"open","doc":"Alias for `new(path)`","summary":"<p>Alias for <code><a href=\"Dir.html#new%28path%3APath%7CString%29-class-method\">.new(path)</a></code></p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : self","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <span class=\"k\">self</span>","location":{"filename":"src/dir.cr","line_number":24,"url":null},"def":{"name":"open","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"self","visibility":"Public","body":"new(path)"}}],"instance_methods":[{"html_id":"children:Array(String)-instance-method","name":"children","doc":"Returns an array containing all of the filenames except for `.` and `..`\nin the given directory.","summary":"<p>Returns an array containing all of the filenames except for <code>.</code> and <code>..</code> in the given directory.</p>","abstract":false,"location":{"filename":"src/dir.cr","line_number":105,"url":null},"def":{"name":"children","return_type":"Array(String)","visibility":"Public","body":"entries = [] of String\neach_child do |filename|\n  entries << filename\nend\nentries\n"}},{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes the directory stream.","summary":"<p>Closes the directory stream.</p>","abstract":false,"location":{"filename":"src/dir.cr","line_number":134,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\nCrystal::System::Dir.close(@dir, path)\n@closed = true\n"}},{"html_id":"each(&:String->):Nil-instance-method","name":"each","doc":"Calls the block once for each entry in this directory,\npassing the filename of each entry as a parameter to the block.\n\n```\nDir.mkdir(\"testdir\")\nFile.write(\"testdir/config.h\", \"\")\n\nd = Dir.new(\"testdir\")\nd.each { |x| puts \"Got #{x}\" }\n```\n\nproduces:\n\n```text\nGot .\nGot ..\nGot config.h\n```","summary":"<p>Calls the block once for each entry in this directory, passing the filename of each entry as a parameter to the block.</p>","abstract":false,"location":{"filename":"src/dir.cr","line_number":57,"url":null},"def":{"name":"each","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(String ->)"},"return_type":"Nil","visibility":"Public","body":"while entry = read\n  yield entry\nend"}},{"html_id":"each:Iterator(String)-instance-method","name":"each","doc":"Must return an `Iterator` over the elements in this collection.","summary":"<p>Must return an <code><a href=\"Iterator.html\">Iterator</a></code> over the elements in this collection.</p>","abstract":false,"location":{"filename":"src/dir.cr","line_number":63,"url":null},"def":{"name":"each","return_type":"Iterator(String)","visibility":"Public","body":"EntryIterator.new(self)"}},{"html_id":"each_child(&:String->):Nil-instance-method","name":"each_child","doc":"Calls the block once for each entry except for `.` and `..` in this directory,\npassing the filename of each entry as a parameter to the block.\n\n```\nDir.mkdir(\"testdir\")\nFile.write(\"testdir/config.h\", \"\")\n\nd = Dir.new(\"testdir\")\nd.each_child { |x| puts \"Got #{x}\" }\n```\n\nproduces:\n\n```text\nGot config.h\n```","summary":"<p>Calls the block once for each entry except for <code>.</code> and <code>..</code> in this directory, passing the filename of each entry as a parameter to the block.</p>","abstract":false,"location":{"filename":"src/dir.cr","line_number":92,"url":null},"def":{"name":"each_child","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(String ->)"},"return_type":"Nil","visibility":"Public","body":"excluded = {\".\", \"..\"}\nwhile entry = read\n  if excluded.includes?(entry)\n  else\n    yield entry\n  end\nend\n"}},{"html_id":"each_child:Iterator(String)-instance-method","name":"each_child","abstract":false,"location":{"filename":"src/dir.cr","line_number":99,"url":null},"def":{"name":"each_child","return_type":"Iterator(String)","visibility":"Public","body":"ChildIterator.new(self)"}},{"html_id":"entries:Array(String)-instance-method","name":"entries","doc":"Returns an array containing all of the filenames in the given directory.","summary":"<p>Returns an array containing all of the filenames in the given directory.</p>","abstract":false,"location":{"filename":"src/dir.cr","line_number":68,"url":null},"def":{"name":"entries","return_type":"Array(String)","visibility":"Public","body":"entries = [] of String\neach do |filename|\n  entries << filename\nend\nentries\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/dir.cr","line_number":260,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"path:String-instance-method","name":"path","abstract":false,"location":{"filename":"src/dir.cr","line_number":14,"url":null},"def":{"name":"path","return_type":"String","visibility":"Public","body":"@path"}},{"html_id":"pretty_print(pp)-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp)","args_html":"(pp)","location":{"filename":"src/dir.cr","line_number":264,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"visibility":"Public","body":"pp.text(inspect)"}},{"html_id":"read:String?-instance-method","name":"read","doc":"Reads the next entry from dir and returns it as a string. Returns `nil` at the end of the stream.\n\n```\nd = Dir.new(\"testdir\")\narray = [] of String\nwhile file = d.read\n  array << file\nend\narray.sort # => [\".\", \"..\", \"config.h\"]\n```","summary":"<p>Reads the next entry from dir and returns it as a string.</p>","abstract":false,"location":{"filename":"src/dir.cr","line_number":123,"url":null},"def":{"name":"read","return_type":"String | ::Nil","visibility":"Public","body":"Crystal::System::Dir.next(@dir, path)"}},{"html_id":"rewind:self-instance-method","name":"rewind","doc":"Repositions this directory to the first entry.","summary":"<p>Repositions this directory to the first entry.</p>","abstract":false,"location":{"filename":"src/dir.cr","line_number":128,"url":null},"def":{"name":"rewind","return_type":"self","visibility":"Public","body":"Crystal::System::Dir.rewind(@dir)\nself\n"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a short String representation of this object\nwhich includes its class name and its object address.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).to_s # => #<Person:0x10a199f20>\n```","summary":"<p>Appends a short String representation of this object which includes its class name and its object address.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/dir.cr","line_number":256,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"((io << \"#<Dir:\") << @path) << '>'"}}]},{"html_id":"Crystal/DivisionByZeroError","path":"DivisionByZeroError.html","kind":"class","full_name":"DivisionByZeroError","name":"DivisionByZeroError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/exception.cr","line_number":126,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"Raised when attempting to divide an integer by 0.\n\n```\n1 // 0 # raises DivisionByZeroError (Division by 0)\n```","summary":"<p>Raised when attempting to divide an integer by 0.</p>","constructors":[{"html_id":"new(message=\"Divisionby0\")-class-method","name":"new","abstract":false,"args":[{"name":"message","default_value":"\"Division by 0\"","external_name":"message","restriction":""}],"args_string":"(message = \"Division by 0\")","args_html":"(message = <span class=\"s\">&quot;Division by 0&quot;</span>)","location":{"filename":"src/exception.cr","line_number":127,"url":null},"def":{"name":"new","args":[{"name":"message","default_value":"\"Division by 0\"","external_name":"message","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]},{"html_id":"Crystal/ECR","path":"ECR.html","kind":"module","full_name":"ECR","name":"ECR","abstract":false,"locations":[{"filename":"src/ecr.cr","line_number":107,"url":null},{"filename":"src/ecr/macros.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"Embedded Crystal (ECR) is a template language for embedding Crystal code into other text,\nthat includes but is not limited to HTML. The template is read and transformed\nat compile time and then embedded into the binary.\n\nThere are `<%= %>` and `<% %>` syntax. The former will render returned values.\nThe latter will not, but instead serve to control the structure as we do in Crystal.\n\nUsing a dash inside `<...>` either eliminates previous indentation or removes the next newline:\n\n* `<%- ... %>`: removes previous indentation\n* `<% ... -%>`: removes next newline\n* `<%-= ... %>`: removes previous indentation\n* `<%= ... -%>`: removes next newline\n\nA comment can be created the same as normal code: `<% # hello %>` or by the special\ntag: `<%# hello %>`. An ECR tag can be inserted directly (i.e. the tag itself may be\nescaped) by using a second `%` like so: `<%% a = b %>` or `<%%= foo %>`.\n\nQuick Example:\n\nCreate a simple ECR file named `greeter.ecr`:\n\n```\nGreetings, <%= @name %>!\n```\n\nand then use it like so with the `#def_to_s` macro:\n\n```\nrequire \"ecr\"\n\nclass Greeter\n  def initialize(@name : String)\n  end\n\n  ECR.def_to_s \"greeter.ecr\"\nend\n\nGreeter.new(\"John\").to_s # => \"Greetings, John!\\n\"\n```\n\nUsing logical statements:\n\n```\n# greeter.ecr\n<%- if @name -%>\nGreetings, <%= @name %>!\n<%- else -%>\nGreetings!\n<%- end -%>\n```\n\n```\nrequire \"ecr\"\n\nclass Greeter\n  def initialize(@name : String | Nil)\n  end\n\n  ECR.def_to_s \"greeter.ecr\"\nend\n\nGreeter.new(nil).to_s    # => \"Greetings!\\n\"\nGreeter.new(\"Jill\").to_s # => \"Greetings, Jill!\\n\"\n```\n\nUsing loops:\n\n```\n# greeter.ecr\n<%- @names.each do |name| -%>\nHi, <%= name %>!\n<%- end -%>\n```\n\n```\nrequire \"ecr\"\n\nclass Greeter\n  @names : Array(String)\n\n  def initialize(*names)\n    @names = names.to_a\n  end\n\n  ECR.def_to_s \"greeter.ecr\"\nend\n\nGreeter.new(\"John\", \"Zoe\", \"Ben\").to_s # => \"Hi, John!\\nHi, Zoe!\\nHi, Ben!\\n\"\n```\n\nComments and Escapes:\n\n```\n# demo.ecr\n<%# Demonstrate use of ECR tag -%>\nA valid ECR tag looks like this: <%%= foo %>\n```\n\n```\nrequire \"ecr\"\nfoo = 2\nECR.render(\"demo.ecr\") # => \"A valid ECR tag looks like this: <%= foo %>\\n\"\n```\n\nLikewise, other Crystal logic can be implemented in ECR text.","summary":"<p>Embedded Crystal (ECR) is a template language for embedding Crystal code into other text, that includes but is not limited to HTML.</p>","macros":[{"html_id":"def_to_s(filename)-macro","name":"def_to_s","doc":"Defines a `to_s(io)` method whose body is the ECR contained\nin *filename*, translated to Crystal code.\n\n```text\n# greeting.ecr\nHello <%= @name %>!\n```\n\n```\nrequire \"ecr/macros\"\n\nclass Greeting\n  def initialize(@name : String)\n  end\n\n  ECR.def_to_s \"greeting.ecr\"\nend\n\nGreeting.new(\"World\").to_s # => \"Hello World!\"\n```\n\nThe macro basically translates the text inside the given file\nto Crystal code that appends to the IO:\n\n```\nclass Greeting\n  def to_s(io)\n    io << \"Hello \"\n    io << @name\n    io << '!'\n  end\nend\n```","summary":"<p>Defines a <code>to_s(io)</code> method whose body is the ECR contained in <em>filename</em>, translated to Crystal code.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":""}],"args_string":"(filename)","args_html":"(filename)","location":{"filename":"src/ecr/macros.cr","line_number":35,"url":null},"def":{"name":"def_to_s","args":[{"name":"filename","external_name":"filename","restriction":""}],"visibility":"Public","body":"    def to_s(__io__ : IO) : Nil\n      ECR.embed \n{{ filename }}\n, \"__io__\"\n    \nend\n  \n"}},{"html_id":"embed(filename,io_name)-macro","name":"embed","doc":"Embeds an ECR file *filename* into the program and appends the content to\nan IO in the variable *io_name*.\n\nThe generated code is the result of translating the contents of\nthe ECR file to Crystal, a program that appends to an IO.\n\n```text\n# greeting.ecr\nHello <%= name %>!\n```\n\n```\nrequire \"ecr/macros\"\n\nname = \"World\"\n\nio = IO::Memory.new\nECR.embed \"greeting.ecr\", io\nio.to_s # => \"Hello World!\"\n```\n\nThe `ECR.embed` line basically generates this Crystal code:\n\n```\nio << \"Hello \"\nio << name\nio << '!'\n```","summary":"<p>Embeds an ECR file <em>filename</em> into the program and appends the content to an IO in the variable <em>io_name</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":""},{"name":"io_name","external_name":"io_name","restriction":""}],"args_string":"(filename, io_name)","args_html":"(filename, io_name)","location":{"filename":"src/ecr/macros.cr","line_number":69,"url":null},"def":{"name":"embed","args":[{"name":"filename","external_name":"filename","restriction":""},{"name":"io_name","external_name":"io_name","restriction":""}],"visibility":"Public","body":"    \n\\{\n{ run(\"ecr/process\", \n{{ filename }}\n, \n{{ io_name.id.stringify }}\n) }}\n  \n"}},{"html_id":"render(filename)-macro","name":"render","doc":"Embeds an ECR file *filename* into the program and renders it to a string.\n\nThe generated code is the result of translating the contents of\nthe ECR file to Crystal, a program that appends to an IO and returns a string.\n\n```text\n# greeting.ecr\nHello <%= name %>!\n```\n\n```\nrequire \"ecr/macros\"\n\nname = \"World\"\n\nrendered = ECR.render \"greeting.ecr\"\nrendered # => \"Hello World!\"\n```\n\nThe `ECR.render` basically generates this Crystal code:\n\n```\nString.build do |io|\n  io << \"Hello \"\n  io << name\n  io << '!'\nend\n```","summary":"<p>Embeds an ECR file <em>filename</em> into the program and renders it to a string.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":""}],"args_string":"(filename)","args_html":"(filename)","location":{"filename":"src/ecr/macros.cr","line_number":101,"url":null},"def":{"name":"render","args":[{"name":"filename","external_name":"filename","restriction":""}],"visibility":"Public","body":"    ::String.build do |\n%io\n|\n      ::ECR.embed(\n{{ filename }}\n, \n%io\n)\n    \nend\n  \n"}}]},{"html_id":"Crystal/Enum","path":"Enum.html","kind":"struct","full_name":"Enum","name":"Enum","abstract":true,"superclass":{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/enum.cr","line_number":89,"url":null},{"filename":"src/json/to_json.cr","line_number":162,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":124,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"doc":"Enum is the base type of all enums.\n\nAn enum is a set of integer values, where each value has an associated name. For example:\n\n```\nenum Color\n  Red   # 0\n  Green # 1\n  Blue  # 2\nend\n```\n\nValues start with the value `0` and are incremented by one, but can be overwritten.\n\nTo get the underlying value you invoke value on it:\n\n```\nColor::Green.value # => 1\n```\n\nEach constant (member) in the enum has the type of the enum:\n\n```\ntypeof(Color::Red) # => Color\n```\n\n### Flags enum\n\nAn enum can be marked with the `@[Flags]` annotation. This changes the default values:\n\n```\n@[Flags]\nenum IOMode\n  Read  # 1\n  Write # 2\n  Async # 4\nend\n```\n\nAdditionally, some methods change their behaviour.\n\n### Enums from integers\n\nAn enum can be created from an integer:\n\n```\nColor.new(1).to_s # => \"Green\"\n```\n\nValues that don't correspond to enum's constants are allowed: the value\nwill still be of type Color, but when printed you will get the underlying value:\n\n```\nColor.new(10).to_s # => \"10\"\n```\n\nThis method is mainly intended to convert integers from C to enums in Crystal.\n\n### Question methods\n\nAn enum automatically defines question methods for each member, using\n`String#underscore` for the method name.\n* In the case of regular enums, this compares by equality (`==`).\n* In the case of flags enums, this invokes `includes?`.\n\nFor example:\n\n```\ncolor = Color::Blue\ncolor.red?  # => false\ncolor.blue? # => true\n\nmode = IOMode::Read | IOMode::Async\nmode.read?  # => true\nmode.write? # => false\nmode.async? # => true\n```\n\nThis is very convenient in `case` expressions:\n\n```\ncase color\nwhen .red?\n  puts \"Got red\"\nwhen .blue?\n  puts \"Got blue\"\nend\n```","summary":"<p>Enum is the base type of all enums.</p>","class_methods":[{"html_id":"each(&:self->)-class-method","name":"each","doc":"Iterates each member of the enum.\nIt won't iterate the `None` and `All` members of flags enums.\n\n```\nIOMode.each do |member, value|\n  # yield IOMode::Read, 1\n  # yield IOMode::Write, 2\n  # yield IOMode::Async, 3\nend\n```","summary":"<p>Iterates each member of the enum.</p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":482,"url":null},"def":{"name":"each","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(self ->)"},"visibility":"Public","body":"{% for member in @type.constants %}\n      {% if (@type.annotation(Flags)) && (([\"none\", \"all\"] of ::String).includes?(member.stringify.downcase)) %}{% else %}\n        yield new({{ @type.constant(member) }}), {{ @type.constant(member) }}\n      {% end %}\n    {% end %}"}},{"html_id":"names:Array(String)-class-method","name":"names","doc":"Returns all enum members as an `Array(String)`.\n\n```\nColor.names # => [\"Red\", \"Green\", \"Blue\"]\n```","summary":"<p>Returns all enum members as an <code><a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)</code>.</p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":325,"url":null},"def":{"name":"names","return_type":"Array(String)","visibility":"Public","body":"{% if @type.annotation(Flags) %}\n      {{ @type.constants.select do |e|\n  (e.stringify != \"None\") && (e.stringify != \"All\")\nend.map(&.stringify) }}\n    {% else %}\n      {{ @type.constants.map(&.stringify) }}\n    {% end %}"}},{"html_id":"valid?(value:self):Bool-class-method","name":"valid?","doc":"Returns `true` if the given *value* is an enum member, otherwise `false`.\n`false` if not member.\n\n```\nColor.valid?(Color::Red)   # => true\nColor.valid?(Color.new(4)) # => false\n```\n\nNOTE: This is a class method, not an instance method because\nan instance method `valid?` is defined by the language when a user\ndefines an enum member named `Valid`.","summary":"<p>Returns <code>true</code> if the given <em>value</em> is an enum member, otherwise <code>false</code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"self"}],"args_string":"(value : self) : Bool","args_html":"(value : <span class=\"k\">self</span>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/enum.cr","line_number":392,"url":null},"def":{"name":"valid?","args":[{"name":"value","external_name":"value","restriction":"self"}],"return_type":"Bool","visibility":"Public","body":"!(!(from_value?(value.value)))"}},{"html_id":"values:Array(self)-class-method","name":"values","doc":"Returns all enum members as an `Array(self)`.\n\n```\nColor.values # => [Color::Red, Color::Green, Color::Blue]\n```","summary":"<p>Returns all enum members as an <code><a href=\"Array.html\">Array</a>(self)</code>.</p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":338,"url":null},"def":{"name":"values","return_type":"Array(self)","visibility":"Public","body":"{% if @type.annotation(Flags) %}\n      {{ @type.constants.select do |e|\n  (e.stringify != \"None\") && (e.stringify != \"All\")\nend.map do |e|\n  \"#{@type}::#{e.id}\".id\nend }}\n    {% else %}\n      {{ @type.constants.map do |e|\n  \"#{@type}::#{e.id}\".id\nend }}\n    {% end %}"}}],"constructors":[{"html_id":"from_value(value:Int):self-class-method","name":"from_value","doc":"Returns the enum member that has the given value, or raises\nif no such member exists.\n\n```\nColor.from_value(0) # => Color::Red\nColor.from_value(1) # => Color::Green\nColor.from_value(2) # => Color::Blue\nColor.from_value(3) # raises Exception\n```","summary":"<p>Returns the enum member that has the given value, or raises if no such member exists.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Int"}],"args_string":"(value : Int) : self","args_html":"(value : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/enum.cr","line_number":377,"url":null},"def":{"name":"from_value","args":[{"name":"value","external_name":"value","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"(from_value?(value)) || (raise(\"Unknown enum #{self} value: #{value}\"))"}},{"html_id":"from_value?(value:Int):self?-class-method","name":"from_value?","doc":"Returns the enum member that has the given value, or `nil` if\nno such member exists.\n\n```\nColor.from_value?(0) # => Color::Red\nColor.from_value?(1) # => Color::Green\nColor.from_value?(2) # => Color::Blue\nColor.from_value?(3) # => nil\n```","summary":"<p>Returns the enum member that has the given value, or <code>nil</code> if no such member exists.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Int"}],"args_string":"(value : Int) : self?","args_html":"(value : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>?","location":{"filename":"src/enum.cr","line_number":355,"url":null},"def":{"name":"from_value?","args":[{"name":"value","external_name":"value","restriction":"Int"}],"return_type":"self | ::Nil","visibility":"Public","body":"{% if @type.annotation(Flags) %}\n      all_mask = {{ @type }}::All.value\n      return if all_mask & value != value\n      return new(all_mask.class.new(value))\n    {% else %}\n      {% for member in @type.constants %}\n        return new({{ @type.constant(member) }}) if {{ @type.constant(member) }} == value\n      {% end %}\n    {% end %}\nnil\n"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","doc":"Reads a serialized enum member by name from *ctx* and *node*.\n\nSee `#to_yaml` for reference.\n\nRaises `YAML::ParseException` if the deserialization fails.","summary":"<p>Reads a serialized enum member by name from <em>ctx</em> and <em>node</em>.</p>","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":227,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"{% if @type.annotation(Flags) %}\n    if node.is_a?(YAML::Nodes::Sequence)\n      value = {{ @type }}::None\n      node.each do |element|\n        string = parse_scalar(ctx, element, String)\n\n        value |= parse?(string) || element.raise \"Unknown enum #{self} value: #{string.inspect}\"\n      end\n\n      value\n    else\n      node.raise \"Expected sequence, not #{node.kind}\"\n    end\n  {% else %}\n    string = parse_scalar(ctx, node, String)\n    parse?(string) || node.raise \"Unknown enum #{self} value: #{string.inspect}\"\n  {% end %}"}},{"html_id":"new(value:self)-class-method","name":"new","doc":"Returns *value*.","summary":"<p>Returns <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"self"}],"args_string":"(value : self)","args_html":"(value : <span class=\"k\">self</span>)","location":{"filename":"src/enum.cr","line_number":93,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"self"}],"visibility":"Public","body":"value"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":"Reads a serialized enum member by name from *pull*.\n\nSee `#to_json` for reference.\n\nRaises `JSON::ParseException` if the deserialization fails.","summary":"<p>Reads a serialized enum member by name from <em>pull</em>.</p>","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":256,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"{% if @type.annotation(Flags) %}\n    value = {{ @type }}::None\n    pull.read_array do\n      value |= parse?(pull.read_string) || pull.raise \"Unknown enum #{self} value: #{pull.string_value.inspect}\"\n    end\n    value\n  {% else %}\n    parse?(pull.read_string) || pull.raise \"Unknown enum #{self} value: #{pull.string_value.inspect}\"\n  {% end %}"}},{"html_id":"parse(string:String):self-class-method","name":"parse","doc":"Returns the enum member that has the given name, or\nraises `ArgumentError` if no such member exists. The comparison is made by using\n`String#camelcase` and `String#downcase` between *string* and\nthe enum members names, so a member named \"FortyTwo\" or \"FORTY_TWO\"\nis found with any of these strings: \"forty_two\", \"FortyTwo\", \"FORTY_TWO\",\n\"FORTYTWO\", \"fortytwo\".\n\n```\nColor.parse(\"Red\")    # => Color::Red\nColor.parse(\"BLUE\")   # => Color::Blue\nColor.parse(\"Yellow\") # raises ArgumentError\n```","summary":"<p>Returns the enum member that has the given name, or raises <code><a href=\"ArgumentError.html\">ArgumentError</a></code> if no such member exists.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String) : self","args_html":"(string : <a href=\"String.html\">String</a>) : <span class=\"k\">self</span>","location":{"filename":"src/enum.cr","line_number":416,"url":null},"def":{"name":"parse","args":[{"name":"string","external_name":"string","restriction":"String"}],"return_type":"self","visibility":"Public","body":"(parse?(string)) || (raise(ArgumentError.new(\"Unknown enum #{self} value: #{string}\")))"}},{"html_id":"parse?(string:String):self?-class-method","name":"parse?","doc":"Returns the enum member that has the given name, or\n`nil` if no such member exists. The comparison is made by using\n`String#camelcase` and `String#downcase` between *string* and\nthe enum members names, so a member named \"FortyTwo\" or \"FORTY_TWO\"\nis found with any of these strings: \"forty_two\", \"FortyTwo\", \"FORTY_TWO\",\n\"FORTYTWO\", \"fortytwo\".\n\n```\nColor.parse?(\"Red\")    # => Color::Red\nColor.parse?(\"BLUE\")   # => Color::Blue\nColor.parse?(\"Yellow\") # => nil\n```\n\nIf multiple members match the same normalized string, the first one is returned.","summary":"<p>Returns the enum member that has the given name, or <code>nil</code> if no such member exists.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String) : self?","args_html":"(string : <a href=\"String.html\">String</a>) : <span class=\"k\">self</span>?","location":{"filename":"src/enum.cr","line_number":434,"url":null},"def":{"name":"parse?","args":[{"name":"string","external_name":"string","restriction":"String"}],"return_type":"self | ::Nil","visibility":"Public","body":"{% if true %}\n      case string.camelcase.downcase\n      # Temporarily map all constants to their normalized value in order to\n      # avoid duplicates in the `case` conditions.\n      # `FOO` and `Foo` members would both generate `when \"foo\"` which creates a compile time error.\n      # The first matching member is chosen, like with symbol autocasting.\n      # That's different from the predicate methods which return true for the last matching member.\n      {% constants = {} of _ => _ %}\n      {% for member in @type.constants %}\n        {% key = member.stringify.camelcase.downcase %}\n        {% unless constants[key]\n  constants[key] = member\nend %}\n      {% end %}\n      {% for name, member in constants %}\n        when {{ name }}\n          new({{ @type.constant(member) }})\n      {% end %}\n      else\n        nil\n      end\n    {% end %}"}}],"instance_methods":[{"html_id":"&(other:self):self-instance-method","name":"&","doc":"Returns the enum member that results from applying a logical\n\"and\" operation between this enum member's value and *other*.\nThis is mostly useful with flag enums.\n\n```\n(IOMode::Read | IOMode::Async) & IOMode::Read # => IOMode::Read\n```","summary":"<p>Returns the enum member that results from applying a logical &quot;and&quot; operation between this enum member's value and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self) : self","args_html":"(other : <span class=\"k\">self</span>) : <span class=\"k\">self</span>","location":{"filename":"src/enum.cr","line_number":222,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"self"}],"return_type":"self","visibility":"Public","body":"self.class.new(value & other.value)"}},{"html_id":"+(other:Int):self-instance-method","name":"+","doc":"Returns the enum member that results from adding *other*\nto this enum member's value.\n\n```\nColor::Red + 1 # => Color::Green\nColor::Red + 2 # => Color::Blue\nColor::Red + 3 # => Color.new(3)\n```","summary":"<p>Returns the enum member that results from adding <em>other</em> to this enum member's value.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : self","args_html":"(other : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/enum.cr","line_number":188,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"self.class.new(value + other)"}},{"html_id":"-(other:Int):self-instance-method","name":"-","doc":"Returns the enum member that results from subtracting *other*\nto this enum member's value.\n\n```\nColor::Blue - 1 # => Color::Green\nColor::Blue - 2 # => Color::Red\nColor::Blue - 3 # => Color.new(-1)\n```","summary":"<p>Returns the enum member that results from subtracting <em>other</em> to this enum member's value.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : self","args_html":"(other : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/enum.cr","line_number":200,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"self.class.new(value - other)"}},{"html_id":"<=>(other:self)-instance-method","name":"<=>","doc":"Compares this enum member against another, according to their underlying\nvalue.\n\n```\nColor::Red <=> Color::Blue  # => -1\nColor::Blue <=> Color::Red  # => 1\nColor::Blue <=> Color::Blue # => 0\n```","summary":"<p>Compares this enum member against another, according to their underlying value.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/enum.cr","line_number":247,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"value <=> other.value"}},{"html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this enum member and *other* have the same underlying value.\n\n```\nColor::Red == Color::Red  # => true\nColor::Red == Color::Blue # => false\n```","summary":"<p>Returns <code>true</code> if this enum member and <em>other</em> have the same underlying value.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/enum.cr","line_number":288,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"value == other.value"}},{"html_id":"==(other)-instance-method","name":"==","doc":"Returns `false`.","summary":"<p>Returns <code>false</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/enum.cr","line_number":251,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"false"}},{"html_id":"^(other:self):self-instance-method","name":"^","doc":"Returns the enum member that results from applying a logical\n\"xor\" operation between this enum member's value and *other*.\nThis is mostly useful with flag enums.","summary":"<p>Returns the enum member that results from applying a logical &quot;xor&quot; operation between this enum member's value and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self) : self","args_html":"(other : <span class=\"k\">self</span>) : <span class=\"k\">self</span>","location":{"filename":"src/enum.cr","line_number":229,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"self"}],"return_type":"self","visibility":"Public","body":"self.class.new(value ^ other.value)"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/enum.cr","line_number":457,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"each(&:self->)-instance-method","name":"each","doc":"Iterates each values in a Flags Enum.\n\n```\n(IOMode::Read | IOMode::Async).each do |member, value|\n  # yield IOMode::Read, 1\n  # yield IOMode::Async, 3\nend\n```","summary":"<p>Iterates each values in a Flags Enum.</p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":305,"url":null},"def":{"name":"each","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(self ->)"},"visibility":"Public","body":"{% if @type.annotation(Flags) %}\n      return if value == 0\n      {% for member in @type.constants %}\n        {% if member.stringify != \"All\" %}\n          if includes?(self.class.new({{ @type.constant(member) }}))\n            yield self.class.new({{ @type.constant(member) }}), {{ @type.constant(member) }}\n          end\n        {% end %}\n      {% end %}\n    {% else %}\n      {% raise(\"Can't iterate #{@type}: only Flags Enum can be iterated\") %}\n    {% end %}"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/enum.cr","line_number":293,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher.enum(self)"}},{"html_id":"includes?(other:self):Bool-instance-method","name":"includes?","doc":"Returns `true` if this enum member's value includes *other*. This\nperforms a logical \"and\" between this enum member's value and *other*'s,\nso instead of writing:\n\n```\n(member & value) != 0\n```\n\nyou can write:\n\n```\nmember.includes?(value)\n```\n\nThe above is mostly useful with flag enums.\n\nFor example:\n\n```\nmode = IOMode::Read | IOMode::Write\nmode.includes?(IOMode::Read)  # => true\nmode.includes?(IOMode::Async) # => false\n```","summary":"<p>Returns <code>true</code> if this enum member's value includes <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self) : Bool","args_html":"(other : <span class=\"k\">self</span>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/enum.cr","line_number":278,"url":null},"def":{"name":"includes?","args":[{"name":"other","external_name":"other","restriction":"self"}],"return_type":"Bool","visibility":"Public","body":"(value & other.value) != 0"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns the value of this enum member as a `Float32`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Float32.html\">Float32</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"value.to_f32"}},{"html_id":"to_f32!:Float32-instance-method","name":"to_f32!","doc":"Returns the value of this enum member as a `Float32`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Float32.html\">Float32</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_f32!","return_type":"Float32","visibility":"Public","body":"value.to_f32!"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns the value of this enum member as a `Float64`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Float64.html\">Float64</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"value.to_f64"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","doc":"Returns the value of this enum member as a `Float64`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Float64.html\">Float64</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"value.to_f64!"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns the value of this enum member as an `Int32`.\n\n```\nColor::Blue.to_i                    # => 2\n(IOMode::Read | IOMode::Write).to_i # => 3\n\nColor.new(10).to_i # => 10\n```","summary":"<p>Returns the value of this enum member as an <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":162,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"value.to_i32"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns the value of this enum member as a `Int16`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Int16.html\">Int16</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"value.to_i16"}},{"html_id":"to_i16!:Int16-instance-method","name":"to_i16!","doc":"Returns the value of this enum member as a `Int16`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Int16.html\">Int16</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_i16!","return_type":"Int16","visibility":"Public","body":"value.to_i16!"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns the value of this enum member as a `Int32`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Int32.html\">Int32</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"value.to_i32"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","doc":"Returns the value of this enum member as a `Int32`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Int32.html\">Int32</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"value.to_i32!"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns the value of this enum member as a `Int64`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Int64.html\">Int64</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"value.to_i64"}},{"html_id":"to_i64!:Int64-instance-method","name":"to_i64!","doc":"Returns the value of this enum member as a `Int64`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Int64.html\">Int64</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_i64!","return_type":"Int64","visibility":"Public","body":"value.to_i64!"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns the value of this enum member as a `Int8`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Int8.html\">Int8</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"value.to_i8"}},{"html_id":"to_i8!:Int8-instance-method","name":"to_i8!","doc":"Returns the value of this enum member as a `Int8`","summary":"<p>Returns the value of this enum member as a <code><a href=\"Int8.html\">Int8</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_i8!","return_type":"Int8","visibility":"Public","body":"value.to_i8!"}},{"html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","doc":"Serializes this enum member by name.\n\nFor non-flags enums, the serialization is a JSON string. The value is the\nmember name (see `#to_s`) transformed with `String#underscore`.\n\n```\nenum Stages\n  INITIAL\n  SECOND_STAGE\nend\n\nStages::INITIAL.to_json      # => %(\"initial\")\nStages::SECOND_STAGE.to_json # => %(\"second_stage\")\n```\n\nFor flags enums, the serialization is a JSON array including every flagged\nmember individually serialized in the same way as a member of a non-flags enum.\n`None` is serialized as an empty array, `All` as an array containing\nall members.\n\n```\n@[Flags]\nenum Sides\n  LEFT\n  RIGHT\nend\n\nSides::LEFT.to_json                  # => %([\"left\"])\n(Sides::LEFT | Sides::RIGHT).to_json # => %([\"left\",\"right\"])\nSides::All.to_json                   # => %([\"left\",\"right\"])\nSides::None.to_json                  # => %([])\n```\n\n`ValueConverter.to_json` offers a different serialization strategy based on the\nmember value.","summary":"<p>Serializes this enum member by name.</p>","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>)","location":{"filename":"src/json/to_json.cr","line_number":198,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"visibility":"Public","body":"{% if @type.annotation(Flags) %}\n      json.array do\n        each do |member, _value|\n          json.string(member.to_s.underscore)\n        end\n      end\n    {% else %}\n      json.string(to_s.underscore)\n    {% end %}"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a `String` representation of this enum member to the given *io*.\n\nSee also: `to_s`.","summary":"<p>Appends a <code><a href=\"String.html\">String</a></code> representation of this enum member to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/enum.cr","line_number":100,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"{% if @type.annotation(Flags) %}\n      if value == 0\n        io << \"None\"\n      else\n        found = false\n        {% for member in @type.constants %}\n          {% if member.stringify != \"All\" %}\n            if {{ @type.constant(member) }} != 0 && value.bits_set? {{ @type.constant(member) }}\n              io << \" | \" if found\n              io << {{ member.stringify }}\n              found = true\n            end\n          {% end %}\n        {% end %}\n        io << value unless found\n      end\n    {% else %}\n      io << to_s\n    {% end %}\nnil\n"}},{"html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns a `String` representation of this enum member.\nIn the case of regular enums, this is just the name of the member.\nIn the case of flag enums, it's the names joined by vertical bars, or \"None\",\nif the value is zero.\n\nIf an enum's value doesn't match a member's value, the raw value\nis returned as a string.\n\n```\nColor::Red.to_s                     # => \"Red\"\nIOMode::None.to_s                   # => \"None\"\n(IOMode::Read | IOMode::Write).to_s # => \"Read | Write\"\n\nColor.new(10).to_s # => \"10\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> representation of this enum member.</p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":138,"url":null},"def":{"name":"to_s","return_type":"String","visibility":"Public","body":"{% if @type.annotation(Flags) %}\n      String.build { |io| to_s(io) }\n    {% else %}\n      # Can't use `case` here because case with duplicate values do\n      # not compile, but enums can have duplicates (such as `enum Foo; FOO = 1; BAR = 1; end`).\n      {% for member, i in @type.constants %}\n        if value == {{ @type.constant(member) }}\n          return {{ member.stringify }}\n        end\n      {% end %}\n\n      value.to_s\n    {% end %}"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns the value of this enum member as a `UInt16`","summary":"<p>Returns the value of this enum member as a <code><a href=\"UInt16.html\">UInt16</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"value.to_u16"}},{"html_id":"to_u16!:UInt16-instance-method","name":"to_u16!","doc":"Returns the value of this enum member as a `UInt16`","summary":"<p>Returns the value of this enum member as a <code><a href=\"UInt16.html\">UInt16</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_u16!","return_type":"UInt16","visibility":"Public","body":"value.to_u16!"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns the value of this enum member as a `UInt32`","summary":"<p>Returns the value of this enum member as a <code><a href=\"UInt32.html\">UInt32</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"value.to_u32"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","doc":"Returns the value of this enum member as a `UInt32`","summary":"<p>Returns the value of this enum member as a <code><a href=\"UInt32.html\">UInt32</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"value.to_u32!"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns the value of this enum member as a `UInt64`","summary":"<p>Returns the value of this enum member as a <code><a href=\"UInt64.html\">UInt64</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"value.to_u64"}},{"html_id":"to_u64!:UInt64-instance-method","name":"to_u64!","doc":"Returns the value of this enum member as a `UInt64`","summary":"<p>Returns the value of this enum member as a <code><a href=\"UInt64.html\">UInt64</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_u64!","return_type":"UInt64","visibility":"Public","body":"value.to_u64!"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns the value of this enum member as a `UInt8`","summary":"<p>Returns the value of this enum member as a <code><a href=\"UInt8.html\">UInt8</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"value.to_u8"}},{"html_id":"to_u8!:UInt8-instance-method","name":"to_u8!","doc":"Returns the value of this enum member as a `UInt8`","summary":"<p>Returns the value of this enum member as a <code><a href=\"UInt8.html\">UInt8</a></code></p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":166,"url":null},"def":{"name":"to_u8!","return_type":"UInt8","visibility":"Public","body":"value.to_u8!"}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","doc":"Serializes this enum member by name.\n\nFor non-flags enums, the serialization is a YAML string. The value is the\nmember name (see `#to_s`) transformed with `String#underscore`.\n\n```\nenum Stages\n  INITIAL\n  SECOND_STAGE\nend\n\nStages::INITIAL.to_yaml      # => %(--- initial\\n)\nStages::SECOND_STAGE.to_yaml # => %(--- second_stage\\n)\n```\n\nFor flags enums, the serialization is a YAML sequence including every flagged\nmember individually serialized in the same way as a member of a non-flags enum.\n`None` is serialized as an empty sequence, `All` as a sequence containing\nall members.\n\n```\n@[Flags]\nenum Sides\n  LEFT\n  RIGHT\nend\n\nSides::LEFT.to_yaml                  # => %(--- [left]\\n)\n(Sides::LEFT | Sides::RIGHT).to_yaml # => %(--- [left, right]\\n)\nSides::All.to_yaml                   # => %(--- [left, right]\\n)\nSides::None.to_yaml                  # => %(--- []\\n)\n```\n\n`ValueConverter.to_yaml` offers a different serialization strategy based on the\nmember value.","summary":"<p>Serializes this enum member by name.</p>","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","args_html":"(yaml : <a href=\"YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>)","location":{"filename":"src/yaml/to_yaml.cr","line_number":160,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"visibility":"Public","body":"{% if @type.annotation(Flags) %}\n      yaml.sequence(style: :flow) do\n        each do |member, _value|\n          member.to_s.underscore.to_yaml(yaml)\n        end\n      end\n    {% else %}\n      to_s.underscore.to_yaml(yaml)\n    {% end %}"}},{"html_id":"|(other:self):self-instance-method","name":"|","doc":"Returns the enum member that results from applying a logical\n\"or\" operation between this enum member's value and *other*.\nThis is mostly useful with flag enums.\n\n```\n(IOMode::Read | IOMode::Async) # => IOMode::Read | IOMode::Async\n```","summary":"<p>Returns the enum member that results from applying a logical &quot;or&quot; operation between this enum member's value and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self) : self","args_html":"(other : <span class=\"k\">self</span>) : <span class=\"k\">self</span>","location":{"filename":"src/enum.cr","line_number":211,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"self"}],"return_type":"self","visibility":"Public","body":"self.class.new(value | other.value)"}},{"html_id":"~:self-instance-method","name":"~","doc":"Returns the enum member that results from applying a logical\n\"not\" operation of this enum member's value.","summary":"<p>Returns the enum member that results from applying a logical &quot;not&quot; operation of this enum member's value.</p>","abstract":false,"location":{"filename":"src/enum.cr","line_number":235,"url":null},"def":{"name":"~","return_type":"self","visibility":"Public","body":"self.class.new(~value)"}}],"macros":[{"html_id":"flags(*values)-macro","name":"flags","doc":"Convenience macro to create a combined enum (combines given members using `|` (or) logical operator)\n\n```\nIOMode.flags(Read, Write) # => IOMode::Read | IOMode::Write\n```","summary":"<p>Convenience macro to create a combined enum (combines given members using <code><a href=\"Enum.html#%7C%28other%3Aself%29%3Aself-instance-method\">#|</a></code> (or) logical operator)</p>","abstract":false,"args":[{"name":"values","external_name":"values","restriction":""}],"args_string":"(*values)","args_html":"(*values)","location":{"filename":"src/enum.cr","line_number":466,"url":null},"def":{"name":"flags","args":[{"name":"values","external_name":"values","restriction":""}],"splat_index":0,"visibility":"Public","body":"    \n{% for value, i in values %}{% if i != 0 %} | {% end %}{{ @type }}::{{ value }}{% end %}\n"}}],"types":[{"html_id":"Crystal/Enum/ValueConverter","path":"Enum/ValueConverter.html","kind":"module","full_name":"Enum::ValueConverter(T)","name":"ValueConverter","abstract":false,"locations":[{"filename":"src/json/from_json.cr","line_number":308,"url":null},{"filename":"src/json/to_json.cr","line_number":211,"url":null},{"filename":"src/yaml/from_yaml.cr","line_number":247,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":173,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},"doc":"Converter for value-based serialization and deserialization of enum type `T`.\n\nThe serialization format of `Enum#to_json` and `Enum.from_json` is based on\nthe member name. This converter offers an alternative based on the member value.\n\nThis converter can be used for its standalone serialization methods as a\nreplacement of the default strategy of `Enum`. It also works as a serialization\nconverter with `JSON::Field` and `YAML::Field`\n\n```\nrequire \"json\"\nrequire \"yaml\"\n\nenum MyEnum\n  ONE = 1\n  TWO = 2\nend\n\nclass Foo\n  include JSON::Serializable\n  include YAML::Serializable\n\n  @[JSON::Field(converter: Enum::ValueConverter(MyEnum))]\n  @[YAML::Field(converter: Enum::ValueConverter(MyEnum))]\n  property foo : MyEnum = MyEnum::ONE\n\n  def initialize(@foo)\n  end\nend\n\nfoo = Foo.new(MyEnum::ONE)\nfoo.to_json # => %({\"foo\":1})\nfoo.to_yaml # => %(---\\nfoo: 1\\n)\n```\n\nNOTE: Automatically assigned enum values are subject to change when the order\nof members by adding, removing or reordering them. This can affect the integrity\nof serialized data between two instances of a program based on different code\nversions. A way to avoid this is to explicitly assign fixed values to enum\nmembers.","summary":"<p>Converter for value-based serialization and deserialization of enum type <code>T</code>.</p>","class_methods":[{"html_id":"from_json(pull:JSON::PullParser):T-class-method","name":"from_json","doc":"Reads a serialized enum member by value from *pull*.\n\nSee `.to_json` for reference.\n\nRaises `JSON::ParseException` if the deserialization fails.","summary":"<p>Reads a serialized enum member by value from <em>pull</em>.</p>","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser) : T","args_html":"(pull : <a href=\"../JSON/PullParser.html\">JSON::PullParser</a>) : T","location":{"filename":"src/json/from_json.cr","line_number":318,"url":null},"def":{"name":"from_json","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"return_type":"T","visibility":"Public","body":"(T.from_value?(pull.read_int)) || (pull.raise(\"Unknown enum #{T} value: #{pull.int_value}\"))"}},{"html_id":"from_yaml(ctx:YAML::ParseContext,node:YAML::Nodes::Node):T-class-method","name":"from_yaml","doc":"Reads a serialized enum member by value from *ctx* and *node*.\n\nSee `.to_yaml` for reference.\n\nRaises `YAML::ParseException` if the deserialization fails.","summary":"<p>Reads a serialized enum member by value from <em>ctx</em> and <em>node</em>.</p>","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node) : T","args_html":"(ctx : <a href=\"../YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"../YAML/Nodes/Node.html\">YAML::Nodes::Node</a>) : T","location":{"filename":"src/yaml/from_yaml.cr","line_number":257,"url":null},"def":{"name":"from_yaml","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"return_type":"T","visibility":"Public","body":"value = parse_scalar(ctx, node, Int64)\n(T.from_value?(value)) || (node.raise(\"Unknown enum #{T} value: #{value}\"))\n"}},{"html_id":"to_json(value:T,io:IO)-class-method","name":"to_json","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(value : T, io : IO)","args_html":"(value : T, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/json/to_json.cr","line_number":218,"url":null},"def":{"name":"to_json","args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"JSON.build(io) do |json|\n  to_json(value, json)\nend"}},{"html_id":"to_json(member:T,json:JSON::Builder)-class-method","name":"to_json","doc":"Serializes enum member *member* by value.\n\nFor both flags enums and non-flags enums, the value of the enum member is\nused for serialization.\n\n```\nenum Stages\n  INITIAL\n  SECOND_STAGE\nend\n\nEnum::ValueConverter.to_json(Stages::INITIAL)      # => %(0)\nEnum::ValueConverter.to_json(Stages::SECOND_STAGE) # => %(1)\n\n@[Flags]\nenum Sides\n  LEFT\n  RIGHT\nend\n\nEnum::ValueConverter.to_json(Sides::LEFT)                # => %(1)\nEnum::ValueConverter.to_json(Sides::LEFT | Sides::RIGHT) # => %(3)\nEnum::ValueConverter.to_json(Sides::All)                 # => %(3)\nEnum::ValueConverter.to_json(Sides::None)                # => %(0)\n```\n\n`Enum#to_json` offers a different serialization strategy based on the member\nname.","summary":"<p>Serializes enum member <em>member</em> by value.</p>","abstract":false,"args":[{"name":"member","external_name":"member","restriction":"T"},{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(member : T, json : JSON::Builder)","args_html":"(member : T, json : <a href=\"../JSON/Builder.html\">JSON::Builder</a>)","location":{"filename":"src/json/to_json.cr","line_number":252,"url":null},"def":{"name":"to_json","args":[{"name":"member","external_name":"member","restriction":"T"},{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"visibility":"Public","body":"json.scalar(member.value)"}},{"html_id":"to_json(value:T)-class-method","name":"to_json","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T)","args_html":"(value : T)","location":{"filename":"src/json/to_json.cr","line_number":212,"url":null},"def":{"name":"to_json","args":[{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"String.build do |io|\n  to_json(value, io)\nend"}},{"html_id":"to_yaml(value:T,io:IO)-class-method","name":"to_yaml","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(value : T, io : IO)","args_html":"(value : T, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/yaml/to_yaml.cr","line_number":180,"url":null},"def":{"name":"to_yaml","args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"nodes_builder = YAML::Nodes::Builder.new\nto_yaml(value, nodes_builder)\nYAML.build(io) do |builder|\n  nodes_builder.document.to_yaml(builder)\nend\n"}},{"html_id":"to_yaml(member:T,yaml:YAML::Nodes::Builder)-class-method","name":"to_yaml","doc":"Serializes enum member *member* by value.\n\nFor both flags enums and non-flags enums, the value of the enum member is\nused for serialization.\n\n```\nenum Stages\n  INITIAL\n  SECOND_STAGE\nend\n\nEnum::ValueConverter.to_yaml(Stages::INITIAL)      # => %(--- 0\\n)\nEnum::ValueConverter.to_yaml(Stages::SECOND_STAGE) # => %(--- 1\\n)\n\n@[Flags]\nenum Sides\n  LEFT\n  RIGHT\nend\n\nEnum::ValueConverter.to_yaml(Sides::LEFT)                # => %(--- 1\\n)\nEnum::ValueConverter.to_yaml(Sides::LEFT | Sides::RIGHT) # => %(--- 3\\n)\nEnum::ValueConverter.to_yaml(Sides::All)                 # => %(--- 3\\n)\nEnum::ValueConverter.to_yaml(Sides::None)                # => %(--- 0\\n)\n```\n\n`Enum#to_yaml` offers a different serialization strategy based on the member\nname.","summary":"<p>Serializes enum member <em>member</em> by value.</p>","abstract":false,"args":[{"name":"member","external_name":"member","restriction":"T"},{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(member : T, yaml : YAML::Nodes::Builder)","args_html":"(member : T, yaml : <a href=\"../YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>)","location":{"filename":"src/yaml/to_yaml.cr","line_number":218,"url":null},"def":{"name":"to_yaml","args":[{"name":"member","external_name":"member","restriction":"T"},{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"visibility":"Public","body":"yaml.scalar(member.value)"}},{"html_id":"to_yaml(value:T)-class-method","name":"to_yaml","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T)","args_html":"(value : T)","location":{"filename":"src/yaml/to_yaml.cr","line_number":174,"url":null},"def":{"name":"to_yaml","args":[{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"String.build do |io|\n  to_yaml(value, io)\nend"}}],"constructors":[{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node):T-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node) : T","args_html":"(ctx : <a href=\"../YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"../YAML/Nodes/Node.html\">YAML::Nodes::Node</a>) : T","location":{"filename":"src/yaml/from_yaml.cr","line_number":248,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"return_type":"T","visibility":"Public","body":"from_yaml(ctx, node)"}},{"html_id":"new(pull:JSON::PullParser):T-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser) : T","args_html":"(pull : <a href=\"../JSON/PullParser.html\">JSON::PullParser</a>) : T","location":{"filename":"src/json/from_json.cr","line_number":309,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"return_type":"T","visibility":"Public","body":"from_json(pull)"}}]}]},{"html_id":"Crystal/Enumerable","path":"Enumerable.html","kind":"module","full_name":"Enumerable(T)","name":"Enumerable","abstract":false,"locations":[{"filename":"src/enumerable.cr","line_number":29,"url":null},{"filename":"src/set.cr","line_number":484,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"including_types":[{"html_id":"Crystal/Char/Reader","kind":"struct","full_name":"Char::Reader","name":"Reader"},{"html_id":"Crystal/Dir","kind":"class","full_name":"Dir","name":"Dir"},{"html_id":"Crystal/Hash","kind":"class","full_name":"Hash(K, V)","name":"Hash"},{"html_id":"Crystal/HTTP/Cookies","kind":"class","full_name":"HTTP::Cookies","name":"Cookies"},{"html_id":"Crystal/HTTP/Headers","kind":"struct","full_name":"HTTP::Headers","name":"Headers"},{"html_id":"Crystal/Indexable","kind":"module","full_name":"Indexable(T)","name":"Indexable"},{"html_id":"Crystal/Iterator","kind":"module","full_name":"Iterator(T)","name":"Iterator"},{"html_id":"Crystal/LLVM/BasicBlockCollection","kind":"struct","full_name":"LLVM::BasicBlockCollection","name":"BasicBlockCollection"},{"html_id":"Crystal/LLVM/InstructionCollection","kind":"struct","full_name":"LLVM::InstructionCollection","name":"InstructionCollection"},{"html_id":"Crystal/Log/Metadata","kind":"class","full_name":"Log::Metadata","name":"Metadata"},{"html_id":"Crystal/Range","kind":"struct","full_name":"Range(B, E)","name":"Range"},{"html_id":"Crystal/Set","kind":"struct","full_name":"Set(T)","name":"Set"},{"html_id":"Crystal/URI/Params","kind":"struct","full_name":"URI::Params","name":"Params"},{"html_id":"Crystal/XML/Attributes","kind":"class","full_name":"XML::Attributes","name":"Attributes"},{"html_id":"Crystal/XML/NodeSet","kind":"class","full_name":"XML::NodeSet","name":"NodeSet"},{"html_id":"Crystal/YAML/Nodes/Sequence","kind":"class","full_name":"YAML::Nodes::Sequence","name":"Sequence"}],"doc":"The `Enumerable` mixin provides collection classes with several traversal, searching,\nfiltering and querying methods.\n\nIncluding types must provide an `each` method, which yields successive members\nof the collection.\n\nFor example:\n\n```\nclass Three\n  include Enumerable(Int32)\n\n  def each\n    yield 1\n    yield 2\n    yield 3\n  end\nend\n\nthree = Three.new\nthree.to_a                # => [1, 2, 3]\nthree.select &.odd?       # => [1, 3]\nthree.all? { |x| x < 10 } # => true\n```\n\nNote that most search and filter methods traverse an Enumerable eagerly,\nproducing an `Array` as the result. For a lazy alternative refer to\nthe `Iterator` and `Iterable` modules.","summary":"<p>The <code><a href=\"Enumerable.html\">Enumerable</a></code> mixin provides collection classes with several traversal, searching, filtering and querying methods.</p>","class_methods":[{"html_id":"element_type(x)-class-method","name":"element_type","doc":"Returns a value with the same type as an element of *x*, even if *x* is not\nan `Enumerable`.\n\nUsed by splat expansion inside array literals. For example, this code\n\n```\n[1, *{2, 3.5}, 4]\n```\n\nwill end up calling `typeof(1, ::Enumerable.element_type({2, 3.5}), 4)`.\n\nNOTE: there should never be a need to call this method outside the standard library.","summary":"<p>Returns a value with the same type as an element of <em>x</em>, even if <em>x</em> is not an <code><a href=\"Enumerable.html\">Enumerable</a></code>.</p>","abstract":false,"args":[{"name":"x","external_name":"x","restriction":""}],"args_string":"(x)","args_html":"(x)","location":{"filename":"src/enumerable.cr","line_number":2020,"url":null},"def":{"name":"element_type","args":[{"name":"x","external_name":"x","restriction":""}],"visibility":"Public","body":"x.each do |elem|\n  return elem\nend\n::raise(\"\")\n"}}],"instance_methods":[{"html_id":"accumulate(initial:U):Array(U)forallU-instance-method","name":"accumulate","doc":"Returns an array containing *initial* and its prefix sums with the elements\nin this collection.\n\nExpects `U` to respond to the `#+` method.\n\n```\n[1, 2, 3, 4, 5].accumulate(6) # => [6, 7, 9, 12, 16, 21]\n```","summary":"<p>Returns an array containing <em>initial</em> and its prefix sums with the elements in this collection.</p>","abstract":false,"args":[{"name":"initial","external_name":"initial","restriction":"U"}],"args_string":"(initial : U) : Array(U) forall U","args_html":"(initial : U) : <a href=\"Array.html\">Array</a>(U) forall U","location":{"filename":"src/enumerable.cr","line_number":754,"url":null},"def":{"name":"accumulate","args":[{"name":"initial","external_name":"initial","restriction":"U"}],"return_type":"Array(U)","visibility":"Public","body":"accumulate(initial) do |x, y|\n  x + y\nend"}},{"html_id":"accumulate:Array(T)-instance-method","name":"accumulate","doc":"Returns an array of the prefix sums of the elements in this collection. The\nfirst element of the returned array is same as the first element of `self`.\n\nExpects all element types to respond to the `#+` method.\n\n```\n[1, 2, 3, 4, 5, 6].accumulate # => [1, 3, 6, 10, 15, 21]\n```","summary":"<p>Returns an array of the prefix sums of the elements in this collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":742,"url":null},"def":{"name":"accumulate","return_type":"Array(T)","visibility":"Public","body":"accumulate do |x, y|\n  x + y\nend"}},{"html_id":"accumulate(initial:U,&block:U,T->U):Array(U)forallU-instance-method","name":"accumulate","doc":"Returns an array containing *initial* and the successive values of applying\na binary operation, specified by the given *block*, to this collection's\nelements.\n\nSimilar to `#accumulate(&block : T, T -> T)`, except the initial value is\nprovided by an argument and needs not have the same type as the elements in\nthe collection. This initial value is always present in the returned array.\n\n```\n[1, 3, 5, 7].accumulate(9) { |x, y| x * y } # => [9, 9, 27, 135, 945]\n```","summary":"<p>Returns an array containing <em>initial</em> and the successive values of applying a binary operation, specified by the given <em>block</em>, to this collection's elements.</p>","abstract":false,"args":[{"name":"initial","external_name":"initial","restriction":"U"}],"args_string":"(initial : U, &block : U, T -> U) : Array(U) forall U","args_html":"(initial : U, &block : U, T -> U) : <a href=\"Array.html\">Array</a>(U) forall U","location":{"filename":"src/enumerable.cr","line_number":792,"url":null},"def":{"name":"accumulate","args":[{"name":"initial","external_name":"initial","restriction":"U"}],"yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(U, T -> U)"},"return_type":"Array(U)","visibility":"Public","body":"values = [initial]\neach do |elem|\n  initial = yield initial, elem\n  values << initial\nend\nvalues\n"}},{"html_id":"accumulate(&block:T,T->T):Array(T)-instance-method","name":"accumulate","doc":"Returns an array containing the successive values of applying a binary\noperation, specified by the given *block*, to this collection's elements.\n\nFor each element in the collection the block is passed an accumulator value\nand the element. The result becomes the new value for the accumulator and is\nalso appended to the returned array. The initial value for the accumulator\nis the first element in the collection.\n\n```\n[2, 3, 4, 5].accumulate { |x, y| x * y } # => [2, 6, 24, 120]\n```","summary":"<p>Returns an array containing the successive values of applying a binary operation, specified by the given <em>block</em>, to this collection's elements.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":769,"url":null},"def":{"name":"accumulate","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> T)"},"return_type":"Array(T)","visibility":"Public","body":"values = [] of T\nmemo = uninitialized T\neach do |elem|\n  memo = values.empty? ? elem : (  yield memo, elem)\n  values << memo\nend\nvalues\n"}},{"html_id":"all?(&:T->):Bool-instance-method","name":"all?","doc":"Returns `true` if the passed block returns a value other than `false` or `nil`\nfor all elements of the collection.\n\n```\n[\"ant\", \"bear\", \"cat\"].all? { |word| word.size >= 3 } # => true\n[\"ant\", \"bear\", \"cat\"].all? { |word| word.size >= 4 } # => false\n```","summary":"<p>Returns <code>true</code> if the passed block returns a value other than <code>false</code> or <code>nil</code> for all elements of the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":46,"url":null},"def":{"name":"all?","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"Bool","visibility":"Public","body":"each do |e|\n  if yield e\n  else\n    return false\n  end\nend\ntrue\n"}},{"html_id":"all?(pattern):Bool-instance-method","name":"all?","doc":"Returns `true` if `pattern === element` for all elements in\nthis enumerable.\n\n```\n[2, 3, 4].all?(1..5)        # => true\n[2, 3, 4].all?(Int32)       # => true\n[2, \"a\", 3].all?(String)    # => false\n%w[foo bar baz].all?(/o|a/) # => true\n```","summary":"<p>Returns <code>true</code> if <code>pattern === element</code> for all elements in this enumerable.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : Bool","args_html":"(pattern) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/enumerable.cr","line_number":60,"url":null},"def":{"name":"all?","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"Bool","visibility":"Public","body":"all? do |e|\n  pattern === e\nend"}},{"html_id":"all?:Bool-instance-method","name":"all?","doc":"Returns `true` if none of the elements of the collection is `false` or `nil`.\n\n```\n[nil, true, 99].all? # => false\n[15].all?            # => true\n```","summary":"<p>Returns <code>true</code> if none of the elements of the collection is <code>false</code> or <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":70,"url":null},"def":{"name":"all?","return_type":"Bool","visibility":"Public","body":"all?(&.itself)"}},{"html_id":"any?(&:T->):Bool-instance-method","name":"any?","doc":"Returns `true` if the passed block returns a value other than `false` or `nil`\nfor at least one element of the collection.\n\n```\n[\"ant\", \"bear\", \"cat\"].any? { |word| word.size >= 4 } # => true\n[\"ant\", \"bear\", \"cat\"].any? { |word| word.size > 4 }  # => false\n```","summary":"<p>Returns <code>true</code> if the passed block returns a value other than <code>false</code> or <code>nil</code> for at least one element of the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":81,"url":null},"def":{"name":"any?","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"Bool","visibility":"Public","body":"each do |e|\n  if yield e\n    return true\n  end\nend\nfalse\n"}},{"html_id":"any?(pattern):Bool-instance-method","name":"any?","doc":"Returns `true` if `pattern === element` for at least one\nelement in this enumerable.\n\n```\n[2, 3, 4].any?(1..3)      # => true\n[2, 3, 4].any?(5..10)     # => false\n[2, \"a\", 3].any?(String)  # => true\n%w[foo bar baz].any?(/a/) # => true\n```","summary":"<p>Returns <code>true</code> if <code>pattern === element</code> for at least one element in this enumerable.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : Bool","args_html":"(pattern) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/enumerable.cr","line_number":95,"url":null},"def":{"name":"any?","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"Bool","visibility":"Public","body":"any? do |e|\n  pattern === e\nend"}},{"html_id":"any?:Bool-instance-method","name":"any?","doc":"Returns `true` if at least one of the collection members is not `false` or `nil`.\n\n```\n[nil, true, 99].any? # => true\n[nil, false].any?    # => false\n```","summary":"<p>Returns <code>true</code> if at least one of the collection members is not <code>false</code> or <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":105,"url":null},"def":{"name":"any?","return_type":"Bool","visibility":"Public","body":"any?(&.itself)"}},{"html_id":"chunks(&block:T->U)forallU-instance-method","name":"chunks","doc":"Enumerates over the items, chunking them together based on\nthe return value of the block.\n\nConsecutive elements which return the same block value are chunked together.\n\nFor example, consecutive even numbers and odd numbers can be chunked as follows.\n\n```\nary = [3, 1, 4, 1, 5, 9, 2, 6, 5, 3, 5].chunks { |n| n.even? }\nary # => [{false, [3, 1]}, {true, [4]}, {false, [1, 5, 9]}, {true, [2, 6]}, {false, [5, 3, 5]}]\n```\n\nThe following key values have special meaning:\n\n* `Enumerable::Chunk::Drop` specifies that the elements should be dropped\n* `Enumerable::Chunk::Alone` specifies that the element should be chunked by itself\n\nSee also: `Iterator#chunk`.","summary":"<p>Enumerates over the items, chunking them together based on the return value of the block.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":127,"url":null},"def":{"name":"chunks","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> U)"},"visibility":"Public","body":"res = [] of Tuple(U, Array(T))\nchunks_internal(block) do |k, v|\n  res << {k, v}\nend\nres\n"}},{"html_id":"compact_map(&:T->_)-instance-method","name":"compact_map","doc":"Returns an `Array` with the results of running the block against each element\nof the collection, removing `nil` values.\n\n```\n[\"Alice\", \"Bob\"].map { |name| name.match(/^A./) }         # => [Regex::MatchData(\"Al\"), nil]\n[\"Alice\", \"Bob\"].compact_map { |name| name.match(/^A./) } # => [Regex::MatchData(\"Al\")]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with the results of running the block against each element of the collection, removing <code>nil</code> values.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":224,"url":null},"def":{"name":"compact_map","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> _)"},"visibility":"Public","body":"ary = [] of typeof((yield Enumerable.element_type(self)).not_nil!)\neach do |e|\n  v = yield e\n  if v.is_a?(Nil)\n  else\n    ary << v\n  end\nend\nary\n"}},{"html_id":"count(&:T->):Int32-instance-method","name":"count","doc":"Returns the number of elements in the collection for which\nthe passed block returns `true`.\n\n```\n[1, 2, 3, 4].count { |i| i % 2 == 0 } # => 2\n```","summary":"<p>Returns the number of elements in the collection for which the passed block returns <code>true</code>.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":241,"url":null},"def":{"name":"count","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"Int32","visibility":"Public","body":"count = 0\neach do |e|\n  if yield e\n    count = count + 1\n  end\nend\ncount\n"}},{"html_id":"count(item):Int32-instance-method","name":"count","doc":"Returns the number of times that the passed item is present in the collection.\n\n```\n[1, 2, 3, 4].count(3) # => 1\n```","summary":"<p>Returns the number of times that the passed item is present in the collection.</p>","abstract":false,"args":[{"name":"item","external_name":"item","restriction":""}],"args_string":"(item) : Int32","args_html":"(item) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/enumerable.cr","line_number":252,"url":null},"def":{"name":"count","args":[{"name":"item","external_name":"item","restriction":""}],"return_type":"Int32","visibility":"Public","body":"count do |e|\n  e == item\nend"}},{"html_id":"cycle(n,&:T->):Nil-instance-method","name":"cycle","doc":"Calls the given block for each element in this enumerable *n* times.","summary":"<p>Calls the given block for each element in this enumerable <em>n</em> times.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":""}],"args_string":"(n, & : T -> ) : Nil","args_html":"(n, & : T -> ) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/enumerable.cr","line_number":262,"url":null},"def":{"name":"cycle","args":[{"name":"n","external_name":"n","restriction":""}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"Nil","visibility":"Public","body":"n.times do\n  each do |x|\n    yield x\n  end\nend"}},{"html_id":"cycle(&:T->):Nil-instance-method","name":"cycle","doc":"Calls the given block for each element in this enumerable forever.","summary":"<p>Calls the given block for each element in this enumerable forever.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":257,"url":null},"def":{"name":"cycle","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"Nil","visibility":"Public","body":"loop do\n  each do |x|\n    yield x\n  end\nend"}},{"html_id":"each(&:T->)-instance-method","name":"each","doc":"Must yield this collection's elements to the block.","summary":"<p>Must yield this collection's elements to the block.</p>","abstract":true,"location":{"filename":"src/enumerable.cr","line_number":37,"url":null},"def":{"name":"each","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"visibility":"Public","body":""}},{"html_id":"each_cons(count:Int,reuse=false,&)-instance-method","name":"each_cons","doc":"Iterates over the collection yielding chunks of size *count*,\nbut advancing one by one.\n\n```\n[1, 2, 3, 4, 5].each_cons(2) do |cons|\n  puts cons\nend\n```\n\nPrints:\n\n```text\n[1, 2]\n[2, 3]\n[3, 4]\n[4, 5]\n```\n\nBy default, a new array is created and yielded for each consecutive slice of elements.\n* If *reuse* is given, the array can be reused\n* If *reuse* is `true`, the method will create a new array and reuse it.\n* If *reuse*  is an instance of `Array`, `Deque` or a similar collection type (implementing `#<<`, `#shift` and `#size`) it will be used.\n* If *reuse* is falsey, the array will not be reused.\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.\n\nChunks of two items can be iterated using `#each_cons_pair`, an optimized\nimplementation for the special case of `count == 2` which avoids heap\nallocations.","summary":"<p>Iterates over the collection yielding chunks of size <em>count</em>, but advancing one by one.</p>","abstract":false,"args":[{"name":"count","external_name":"count","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(count : Int, reuse = false, &)","args_html":"(count : <a href=\"Int.html\">Int</a>, reuse = <span class=\"n\">false</span>, &)","location":{"filename":"src/enumerable.cr","line_number":296,"url":null},"def":{"name":"each_cons","args":[{"name":"count","external_name":"count","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"yields":1,"visibility":"Public","body":"if count <= 0\n  raise(ArgumentError.new(\"Invalid cons size: #{count}\"))\nend\nif reuse.nil? || reuse.is_a?(Bool)\n  each_cons_internal(count, reuse, Array(T).new(count * 2)) do |slice|\n    yield slice\n  end\nelse\n  each_cons_internal(count, true, reuse) do |slice|\n    yield slice\n  end\nend\n"}},{"html_id":"each_cons_pair(&:T,T->):Nil-instance-method","name":"each_cons_pair","doc":"Iterates over the collection yielding pairs of adjacent items,\nbut advancing one by one.\n\n```\n[1, 2, 3, 4, 5].each_cons_pair do |a, b|\n  puts \"#{a}, #{b}\"\nend\n```\n\nPrints:\n\n```text\n1, 2\n2, 3\n3, 4\n4, 5\n```\n\nChunks of more than two items can be iterated using `#each_cons`.\nThis method is just an optimized implementation for the special case of\n`count == 2` to avoid heap allocations.","summary":"<p>Iterates over the collection yielding pairs of adjacent items, but advancing one by one.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":343,"url":null},"def":{"name":"each_cons_pair","yields":2,"block_arg":{"name":"","external_name":"","restriction":"(T, T ->)"},"return_type":"Nil","visibility":"Public","body":"last_elem = uninitialized T\nfirst_iteration = true\neach do |elem|\n  if first_iteration\n    first_iteration = false\n  else\n    yield last_elem, elem\n  end\n  last_elem = elem\nend\n"}},{"html_id":"each_slice(count:Int,reuse=false,&)-instance-method","name":"each_slice","doc":"Iterates over the collection in slices of size *count*,\nand runs the block for each of those.\n\n```\n[1, 2, 3, 4, 5].each_slice(2) do |slice|\n  puts slice\nend\n```\n\nPrints:\n\n```text\n[1, 2]\n[3, 4]\n[5]\n```\n\nNote that the last one can be smaller.\n\nBy default, a new array is created and yielded for each slice.\n* If *reuse* is given, the array can be reused\n* If *reuse* is an `Array`, this array will be reused\n* If *reuse* is truthy, the method will create a new array and reuse it.\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Iterates over the collection in slices of size <em>count</em>, and runs the block for each of those.</p>","abstract":false,"args":[{"name":"count","external_name":"count","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(count : Int, reuse = false, &)","args_html":"(count : <a href=\"Int.html\">Int</a>, reuse = <span class=\"n\">false</span>, &)","location":{"filename":"src/enumerable.cr","line_number":382,"url":null},"def":{"name":"each_slice","args":[{"name":"count","external_name":"count","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"yields":1,"visibility":"Public","body":"each_slice_internal(count, Array(T), reuse) do |slice|\n  yield slice\nend"}},{"html_id":"each_with_index(offset=0,&)-instance-method","name":"each_with_index","doc":"Iterates over the collection, yielding both the elements and their index.\n\n```\n[\"Alice\", \"Bob\"].each_with_index do |user, i|\n  puts \"User ##{i}: #{user}\"\nend\n```\n\nPrints:\n\n```text\nUser # 0: Alice\nUser # 1: Bob\n```\n\nAccepts an optional *offset* parameter, which tells it to start counting\nfrom there. So, a more human friendly version of the previous snippet would be:\n\n```\n[\"Alice\", \"Bob\"].each_with_index(1) do |user, i|\n  puts \"User ##{i}: #{user}\"\nend\n```\n\nWhich would print:\n\n```text\nUser # 1: Alice\nUser # 2: Bob\n```","summary":"<p>Iterates over the collection, yielding both the elements and their index.</p>","abstract":false,"args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(offset = 0, &)","args_html":"(offset = <span class=\"n\">0</span>, &)","location":{"filename":"src/enumerable.cr","line_number":443,"url":null},"def":{"name":"each_with_index","args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"yields":2,"visibility":"Public","body":"i = offset\neach do |elem|\n  yield elem, i\n  i = i + 1\nend\n"}},{"html_id":"each_with_object(obj:U,&:T,U->):UforallU-instance-method","name":"each_with_object","doc":"Iterates over the collection, passing each element and the initial object *obj*.\nReturns that object.\n\n```\nhash = [\"Alice\", \"Bob\"].each_with_object({} of String => Int32) do |user, sizes|\n  sizes[user] = user.size\nend\nhash # => {\"Alice\" => 5, \"Bob\" => 3}\n```","summary":"<p>Iterates over the collection, passing each element and the initial object <em>obj</em>.</p>","abstract":false,"args":[{"name":"obj","external_name":"obj","restriction":"U"}],"args_string":"(obj : U, & : T, U -> ) : U forall U","args_html":"(obj : U, & : T, U -> ) : U forall U","location":{"filename":"src/enumerable.cr","line_number":460,"url":null},"def":{"name":"each_with_object","args":[{"name":"obj","external_name":"obj","restriction":"U"}],"yields":2,"block_arg":{"name":"","external_name":"","restriction":"(T, U ->)"},"return_type":"U","visibility":"Public","body":"each do |elem|\n  yield elem, obj\nend\nobj\n"}},{"html_id":"empty?:Bool-instance-method","name":"empty?","doc":"Returns `true` if `self` is empty, `false` otherwise.\n\n```\n([] of Int32).empty? # => true\n([1]).empty?         # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is empty, <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1454,"url":null},"def":{"name":"empty?","return_type":"Bool","visibility":"Public","body":"each do\n  return false\nend\ntrue\n"}},{"html_id":"find(if_none=nil,&:T->)-instance-method","name":"find","doc":"Returns the first element in the collection for which the passed block is `true`.\n\nAccepts an optional parameter *if_none*, to set what gets returned if\nno element is found (defaults to `nil`).\n\n```\n[1, 2, 3, 4].find { |i| i > 2 }     # => 3\n[1, 2, 3, 4].find { |i| i > 8 }     # => nil\n[1, 2, 3, 4].find(-1) { |i| i > 8 } # => -1\n```","summary":"<p>Returns the first element in the collection for which the passed block is <code>true</code>.</p>","abstract":false,"args":[{"name":"if_none","default_value":"nil","external_name":"if_none","restriction":""}],"args_string":"(if_none = nil, & : T -> )","args_html":"(if_none = <span class=\"n\">nil</span>, & : T -> )","location":{"filename":"src/enumerable.cr","line_number":477,"url":null},"def":{"name":"find","args":[{"name":"if_none","default_value":"nil","external_name":"if_none","restriction":""}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"visibility":"Public","body":"each do |elem|\n  if yield elem\n    return elem\n  end\nend\nif_none\n"}},{"html_id":"first(&)-instance-method","name":"first","doc":"Returns the first element in the collection,\nIf the collection is empty, calls the block and returns its value.\n\n```\n([1, 2, 3]).first { 4 }   # => 1\n([] of Int32).first { 4 } # => 4\n```","summary":"<p>Returns the first element in the collection, If the collection is empty, calls the block and returns its value.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":491,"url":null},"def":{"name":"first","yields":0,"visibility":"Public","body":"each do |e|\n  return e\nend\nyield\n"}},{"html_id":"first(count:Int):Array(T)-instance-method","name":"first","doc":"Returns an `Array` with the first *count* elements in the collection.\n\nIf *count* is bigger than the number of elements in the collection,\nreturns as many as possible. This include the case of calling it over\nan empty collection, in which case it returns an empty array.","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with the first <em>count</em> elements in the collection.</p>","abstract":false,"args":[{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(count : Int) : Array(T)","args_html":"(count : <a href=\"Int.html\">Int</a>) : <a href=\"Array.html\">Array</a>(T)","location":{"filename":"src/enumerable.cr","line_number":1675,"url":null},"def":{"name":"first","args":[{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"Array(T)","visibility":"Public","body":"if count < 0\n  raise(ArgumentError.new(\"Attempt to take negative size\"))\nend\nary = Array(T).new(count)\neach_with_index do |e, i|\n  if i == count\n    break\n  end\n  ary << e\nend\nary\n"}},{"html_id":"first:T-instance-method","name":"first","doc":"Returns the first element in the collection. Raises `Enumerable::EmptyError`\nif the collection is empty.\n\n```\n([1, 2, 3]).first   # => 1\n([] of Int32).first # raises Enumerable::EmptyError\n```","summary":"<p>Returns the first element in the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":503,"url":null},"def":{"name":"first","return_type":"T","visibility":"Public","body":"first do\n  raise(Enumerable::EmptyError.new)\nend"}},{"html_id":"first?:T?-instance-method","name":"first?","doc":"Returns the first element in the collection.\nWhen the collection is empty, returns `nil`.\n\n```\n([1, 2, 3]).first?   # => 1\n([] of Int32).first? # => nil\n```","summary":"<p>Returns the first element in the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":514,"url":null},"def":{"name":"first?","return_type":"T | ::Nil","visibility":"Public","body":"first do\n  nil\nend"}},{"html_id":"flat_map(&:T->_)-instance-method","name":"flat_map","doc":"Returns a new array with the concatenated results of running the block\nonce for every element in the collection.\nOnly `Array` and `Iterator` results are concatenated; every other value is\ndirectly appended to the new array.\n\n```\narray = [\"Alice\", \"Bob\"].flat_map do |user|\n  user.chars\nend\narray # => ['A', 'l', 'i', 'c', 'e', 'B', 'o', 'b']\n```","summary":"<p>Returns a new array with the concatenated results of running the block once for every element in the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":529,"url":null},"def":{"name":"flat_map","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> _)"},"visibility":"Public","body":"ary = [] of typeof(flat_map_type(yield Enumerable.element_type(self)))\neach do |e|\n  case v = yield e\n  when Array, Iterator\n    ary.concat(v)\n  else\n    ary.push(v)\n  end\nend\nary\n"}},{"html_id":"group_by(&:T->U)forallU-instance-method","name":"group_by","doc":"Returns a `Hash` whose keys are each different value that the passed block\nreturned when run for each element in the collection, and which values are\nan `Array` of the elements for which the block returned that value.\n\n```\n[\"Alice\", \"Bob\", \"Ary\"].group_by { |name| name.size } # => {5 => [\"Alice\"], 3 => [\"Bob\", \"Ary\"]}\n```","summary":"<p>Returns a <code><a href=\"Hash.html\">Hash</a></code> whose keys are each different value that the passed block returned when run for each element in the collection, and which values are an <code><a href=\"Array.html\">Array</a></code> of the elements for which the block returned that value.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":558,"url":null},"def":{"name":"group_by","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"visibility":"Public","body":"h = Hash(U, Array(T)).new\neach do |e|\n  v = yield e\n  if h.has_key?(v)\n    h[v].push(e)\n  else\n    h[v] = [e]\n  end\nend\nh\n"}},{"html_id":"in_groups_of(size:Int,filled_up_with:U=nil)forallU-instance-method","name":"in_groups_of","doc":"Returns an `Array` with chunks in the given size, eventually filled up\nwith given value or `nil`.\n\n```\n[1, 2, 3].in_groups_of(2, 0) # => [[1, 2], [3, 0]]\n[1, 2, 3].in_groups_of(2)    # => [[1, 2], [3, nil]]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with chunks in the given size, eventually filled up with given value or <code>nil</code>.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"filled_up_with","default_value":"nil","external_name":"filled_up_with","restriction":"U"}],"args_string":"(size : Int, filled_up_with : U = nil) forall U","args_html":"(size : <a href=\"Int.html\">Int</a>, filled_up_with : U = <span class=\"n\">nil</span>) forall U","location":{"filename":"src/enumerable.cr","line_number":578,"url":null},"def":{"name":"in_groups_of","args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"filled_up_with","default_value":"nil","external_name":"filled_up_with","restriction":"U"}],"visibility":"Public","body":"if size <= 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nary = Array(Array(T | U)).new\nin_groups_of(size, filled_up_with) do |group|\n  ary << group\nend\nary\n"}},{"html_id":"in_groups_of(size:Int,filled_up_with:U=nil,reuse=false,&)forallU-instance-method","name":"in_groups_of","doc":"Yields a block with the chunks in the given size.\n\n```\n[1, 2, 4].in_groups_of(2, 0) { |e| p e.sum }\n# => 3\n# => 4\n```\n\nBy default, a new array is created and yielded for each group.\n* If *reuse* is given, the array can be reused\n* If *reuse* is an `Array`, this array will be reused\n* If *reuse* is truthy, the method will create a new array and reuse it.\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Yields a block with the chunks in the given size.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"filled_up_with","default_value":"nil","external_name":"filled_up_with","restriction":"U"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int, filled_up_with : U = nil, reuse = false, &) forall U","args_html":"(size : <a href=\"Int.html\">Int</a>, filled_up_with : U = <span class=\"n\">nil</span>, reuse = <span class=\"n\">false</span>, &) forall U","location":{"filename":"src/enumerable.cr","line_number":603,"url":null},"def":{"name":"in_groups_of","args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"filled_up_with","default_value":"nil","external_name":"filled_up_with","restriction":"U"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"yields":1,"visibility":"Public","body":"if size <= 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\neach_slice_internal(size, Array(T | U), reuse) do |slice|\n  (size - slice.size).times do\n    slice << filled_up_with\n  end\n  yield slice\nend\n"}},{"html_id":"includes?(obj):Bool-instance-method","name":"includes?","doc":"Returns `true` if the collection contains *obj*, `false` otherwise.\n\n```\n[1, 2, 3].includes?(2) # => true\n[1, 2, 3].includes?(5) # => false\n```","summary":"<p>Returns <code>true</code> if the collection contains <em>obj</em>, <code>false</code> otherwise.</p>","abstract":false,"args":[{"name":"obj","external_name":"obj","restriction":""}],"args_string":"(obj) : Bool","args_html":"(obj) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/enumerable.cr","line_number":618,"url":null},"def":{"name":"includes?","args":[{"name":"obj","external_name":"obj","restriction":""}],"return_type":"Bool","visibility":"Public","body":"any? do |e|\n  e == obj\nend"}},{"html_id":"index(&:T->):Int32?-instance-method","name":"index","doc":"Returns the index of the first element for which the passed block returns `true`.\n\n```\n[\"Alice\", \"Bob\"].index { |name| name.size < 4 } # => 1 (Bob's index)\n```\n\nReturns `nil` if the block didn't return `true` for any element.","summary":"<p>Returns the index of the first element for which the passed block returns <code>true</code>.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":629,"url":null},"def":{"name":"index","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"Int32 | ::Nil","visibility":"Public","body":"each_with_index do |e, i|\n  if yield e\n    return i\n  end\nend\nnil\n"}},{"html_id":"index(obj):Int32?-instance-method","name":"index","doc":"Returns the index of the object *obj* in the collection.\n\n```\n[\"Alice\", \"Bob\"].index(\"Alice\") # => 0\n```\n\nReturns `nil` if *obj* is not in the collection.","summary":"<p>Returns the index of the object <em>obj</em> in the collection.</p>","abstract":false,"args":[{"name":"obj","external_name":"obj","restriction":""}],"args_string":"(obj) : Int32?","args_html":"(obj) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/enumerable.cr","line_number":643,"url":null},"def":{"name":"index","args":[{"name":"obj","external_name":"obj","restriction":""}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"index do |e|\n  e == obj\nend"}},{"html_id":"index_by(&:T->U):Hash(U,T)forallU-instance-method","name":"index_by","doc":"Converts an `Enumerable` to a `Hash` by using the value returned by the block\nas the hash key.\nBe aware, if two elements return the same value as a key one will override\nthe other. If you want to keep all values, then you should probably use\n`group_by` instead.\n\n```\n[\"Anna\", \"Ary\", \"Alice\"].index_by { |e| e.size }\n# => {4 => \"Anna\", 3 => \"Ary\", 5 => \"Alice\"}\n[\"Anna\", \"Ary\", \"Alice\", \"Bob\"].index_by { |e| e.size }\n# => {4 => \"Anna\", 3 => \"Bob\", 5 => \"Alice\"}\n```","summary":"<p>Converts an <code><a href=\"Enumerable.html\">Enumerable</a></code> to a <code><a href=\"Hash.html\">Hash</a></code> by using the value returned by the block as the hash key.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":659,"url":null},"def":{"name":"index_by","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"return_type":"Hash(U, T)","visibility":"Public","body":"hash = {} of U => T\neach do |elem|\n  hash[yield elem] = elem\nend\nhash\n"}},{"html_id":"join(io:IO,separator=\"\"):Nil-instance-method","name":"join","doc":"Prints to *io* all the elements in the collection, separated by *separator*.\n\n```\n[1, 2, 3, 4, 5].join(STDOUT, \", \")\n```\n\nPrints:\n\n```text\n1, 2, 3, 4, 5\n```","summary":"<p>Prints to <em>io</em> all the elements in the collection, separated by <em>separator</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"separator","default_value":"\"\"","external_name":"separator","restriction":""}],"args_string":"(io : IO, separator = \"\") : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, separator = <span class=\"s\">&quot;&quot;</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/enumerable.cr","line_number":840,"url":null},"def":{"name":"join","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"separator","default_value":"\"\"","external_name":"separator","restriction":""}],"return_type":"Nil","visibility":"Public","body":"join(io, separator) do |elem|\n  elem.to_s(io)\nend"}},{"html_id":"join(separator,io:IO):Nil-instance-method","name":"join","doc":"Prints to *io* all the elements in the collection, separated by *separator*.\n\n```\n[1, 2, 3, 4, 5].join(STDOUT, \", \")\n```\n\nPrints:\n\n```text\n1, 2, 3, 4, 5\n```","summary":"<p>Prints to <em>io</em> all the elements in the collection, separated by <em>separator</em>.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"Enumerable.html#join%28io%3AIO%2Cseparator%3D%22%22%29%3ANil-instance-method\">#join(io : IO, separator = \"\")</a> instead</code></p>","abstract":false,"args":[{"name":"separator","external_name":"separator","restriction":""},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(separator, io : IO) : Nil","args_html":"(separator, io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/enumerable.cr","line_number":858,"url":null},"def":{"name":"join","args":[{"name":"separator","external_name":"separator","restriction":""},{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"join(io, separator)"}},{"html_id":"join(separator=\"\"):String-instance-method","name":"join","doc":"Returns a `String` created by concatenating the elements in the collection,\nseparated by *separator* (defaults to none).\n\n```\n[1, 2, 3, 4, 5].join(\", \") # => \"1, 2, 3, 4, 5\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> created by concatenating the elements in the collection, separated by <em>separator</em> (defaults to none).</p>","abstract":false,"args":[{"name":"separator","default_value":"\"\"","external_name":"separator","restriction":""}],"args_string":"(separator = \"\") : String","args_html":"(separator = <span class=\"s\">&quot;&quot;</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/enumerable.cr","line_number":809,"url":null},"def":{"name":"join","args":[{"name":"separator","default_value":"\"\"","external_name":"separator","restriction":""}],"return_type":"String","visibility":"Public","body":"String.build do |io|\n  join(io, separator)\nend"}},{"html_id":"join(io:IO,separator=\"\",&:T,IO->)-instance-method","name":"join","doc":"Prints to *io* the concatenation of the elements, with the possibility of\ncontrolling how the printing is done via a block.\n\n```\n[1, 2, 3, 4, 5].join(STDOUT, \", \") { |i, io| io << \"(#{i})\" }\n```\n\nPrints:\n\n```text\n(1), (2), (3), (4), (5)\n```","summary":"<p>Prints to <em>io</em> the concatenation of the elements, with the possibility of controlling how the printing is done via a block.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"separator","default_value":"\"\"","external_name":"separator","restriction":""}],"args_string":"(io : IO, separator = \"\", & : T, IO -> )","args_html":"(io : <a href=\"IO.html\">IO</a>, separator = <span class=\"s\">&quot;&quot;</span>, & : T, <a href=\"IO.html\">IO</a> -> )","location":{"filename":"src/enumerable.cr","line_number":874,"url":null},"def":{"name":"join","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"separator","default_value":"\"\"","external_name":"separator","restriction":""}],"yields":2,"block_arg":{"name":"","external_name":"","restriction":"(T, IO ->)"},"visibility":"Public","body":"each_with_index do |elem, i|\n  if i > 0\n    io << separator\n  end\n  yield elem, io\nend"}},{"html_id":"join(separator,io:IO,&)-instance-method","name":"join","doc":"Prints to *io* the concatenation of the elements, with the possibility of\ncontrolling how the printing is done via a block.\n\n```\n[1, 2, 3, 4, 5].join(STDOUT, \", \") { |i, io| io << \"(#{i})\" }\n```\n\nPrints:\n\n```text\n(1), (2), (3), (4), (5)\n```","summary":"<p>Prints to <em>io</em> the concatenation of the elements, with the possibility of controlling how the printing is done via a block.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code>#join(io : IO, separator = \"\", & : T, IO ->) instead</code></p>","abstract":false,"args":[{"name":"separator","external_name":"separator","restriction":""},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(separator, io : IO, &)","args_html":"(separator, io : <a href=\"IO.html\">IO</a>, &)","location":{"filename":"src/enumerable.cr","line_number":894,"url":null},"def":{"name":"join","args":[{"name":"separator","external_name":"separator","restriction":""},{"name":"io","external_name":"io","restriction":"IO"}],"yields":2,"visibility":"Public","body":"join(io, separator) do |elem, io|\n  yield elem, io\nend"}},{"html_id":"join(separator=\"\",&:T->)-instance-method","name":"join","doc":"Returns a `String` created by concatenating the results of passing the elements\nin the collection to the passed block, separated by *separator* (defaults to none).\n\n```\n[1, 2, 3, 4, 5].join(\", \") { |i| -i } # => \"-1, -2, -3, -4, -5\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> created by concatenating the results of passing the elements in the collection to the passed block, separated by <em>separator</em> (defaults to none).</p>","abstract":false,"args":[{"name":"separator","default_value":"\"\"","external_name":"separator","restriction":""}],"args_string":"(separator = \"\", & : T -> )","args_html":"(separator = <span class=\"s\">&quot;&quot;</span>, & : T -> )","location":{"filename":"src/enumerable.cr","line_number":821,"url":null},"def":{"name":"join","args":[{"name":"separator","default_value":"\"\"","external_name":"separator","restriction":""}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"visibility":"Public","body":"String.build do |io|\n  join(io, separator) do |elem|\n    io << (yield elem)\n  end\nend"}},{"html_id":"map(&:T->U):Array(U)forallU-instance-method","name":"map","doc":"Returns an `Array` with the results of running the block against each element of the collection.\n\n```\n[1, 2, 3].map { |i| i * 10 } # => [10, 20, 30]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with the results of running the block against each element of the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":905,"url":null},"def":{"name":"map","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"return_type":"Array(U)","visibility":"Public","body":"ary = [] of U\neach do |e|\n  ary << (yield e)\nend\nary\n"}},{"html_id":"map_with_index(offset=0,&:T,Int32->U):Array(U)forallU-instance-method","name":"map_with_index","doc":"Like `map`, but the block gets passed both the element and its index.\n\n```\n[\"Alice\", \"Bob\"].map_with_index { |name, i| \"User ##{i}: #{name}\" }\n# => [\"User #0: Alice\", \"User #1: Bob\"]\n```\n\nAccepts an optional *offset* parameter, which tells it to start counting\nfrom there.","summary":"<p>Like <code><a href=\"Enumerable.html#map%28%26%3AT-%3EU%29%3AArray%28U%29forallU-instance-method\">#map</a></code>, but the block gets passed both the element and its index.</p>","abstract":false,"args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(offset = 0, & : T, Int32 -> U) : Array(U) forall U","args_html":"(offset = <span class=\"n\">0</span>, & : T, <a href=\"Int32.html\">Int32</a> -> U) : <a href=\"Array.html\">Array</a>(U) forall U","location":{"filename":"src/enumerable.cr","line_number":920,"url":null},"def":{"name":"map_with_index","args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"yields":2,"block_arg":{"name":"","external_name":"","restriction":"(T, Int32 -> U)"},"return_type":"Array(U)","visibility":"Public","body":"ary = [] of U\neach_with_index(offset) do |e, i|\n  ary << (yield e, i)\nend\nary\n"}},{"html_id":"max:T-instance-method","name":"max","doc":"Returns the element with the maximum value in the collection.\n\nIt compares using `>` so it will work for any type that supports that method.\n\n```\n[1, 2, 3].max        # => 3\n[\"Alice\", \"Bob\"].max # => \"Bob\"\n```\n\nRaises `Enumerable::EmptyError` if the collection is empty.","summary":"<p>Returns the element with the maximum value in the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":936,"url":null},"def":{"name":"max","return_type":"T","visibility":"Public","body":"max_by(&.itself)"}},{"html_id":"max?:T?-instance-method","name":"max?","doc":"Like `max` but returns `nil` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#max%3AT-instance-method\">#max</a></code> but returns <code>nil</code> if the collection is empty.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":941,"url":null},"def":{"name":"max?","return_type":"T | ::Nil","visibility":"Public","body":"max_by?(&.itself)"}},{"html_id":"max_by(&:T->U):TforallU-instance-method","name":"max_by","doc":"Returns the element for which the passed block returns with the maximum value.\n\nIt compares using `>` so the block must return a type that supports that method\n\n```\n[\"Alice\", \"Bob\"].max_by { |name| name.size } # => \"Alice\"\n```\n\nRaises `Enumerable::EmptyError` if the collection is empty.","summary":"<p>Returns the element for which the passed block returns with the maximum value.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":954,"url":null},"def":{"name":"max_by","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"return_type":"T","visibility":"Public","body":"found, value = max_by_internal do |value|\n  yield value\nend\nif found\nelse\n  raise(Enumerable::EmptyError.new)\nend\nvalue\n"}},{"html_id":"max_by?(&:T->U):T?forallU-instance-method","name":"max_by?","doc":"Like `max_by` but returns `nil` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#max_by%28%26%3AT-%3EU%29%3ATforallU-instance-method\">#max_by</a></code> but returns <code>nil</code> if the collection is empty.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":961,"url":null},"def":{"name":"max_by?","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"return_type":"T | ::Nil","visibility":"Public","body":"found, value = max_by_internal do |value|\n  yield value\nend\nfound ? value : nil\n"}},{"html_id":"max_of(&:T->U):UforallU-instance-method","name":"max_of","doc":"Like `max_by` but instead of the element, returns the value returned by the block.\n\n```\n[\"Alice\", \"Bob\"].max_of { |name| name.size } # => 5 (Alice's size)\n```","summary":"<p>Like <code><a href=\"Enumerable.html#max_by%28%26%3AT-%3EU%29%3ATforallU-instance-method\">#max_by</a></code> but instead of the element, returns the value returned by the block.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":988,"url":null},"def":{"name":"max_of","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"return_type":"U","visibility":"Public","body":"found, value = max_of_internal do |value|\n  yield value\nend\nif found\nelse\n  raise(Enumerable::EmptyError.new)\nend\nvalue\n"}},{"html_id":"max_of?(&:T->U):U?forallU-instance-method","name":"max_of?","doc":"Like `max_of` but returns `nil` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#max_of%28%26%3AT-%3EU%29%3AUforallU-instance-method\">#max_of</a></code> but returns <code>nil</code> if the collection is empty.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":995,"url":null},"def":{"name":"max_of?","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"return_type":"U | ::Nil","visibility":"Public","body":"found, value = max_of_internal do |value|\n  yield value\nend\nfound ? value : nil\n"}},{"html_id":"min:T-instance-method","name":"min","doc":"Returns the element with the minimum value in the collection.\n\nIt compares using `<` so it will work for any type that supports that method.\n\n```\n[1, 2, 3].min        # => 1\n[\"Alice\", \"Bob\"].min # => \"Alice\"\n```\n\nRaises `Enumerable::EmptyError` if the collection is empty.","summary":"<p>Returns the element with the minimum value in the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1025,"url":null},"def":{"name":"min","return_type":"T","visibility":"Public","body":"min_by(&.itself)"}},{"html_id":"min?:T?-instance-method","name":"min?","doc":"Like `min` but returns `nil` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#min%3AT-instance-method\">#min</a></code> but returns <code>nil</code> if the collection is empty.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1030,"url":null},"def":{"name":"min?","return_type":"T | ::Nil","visibility":"Public","body":"min_by?(&.itself)"}},{"html_id":"min_by(&:T->U):TforallU-instance-method","name":"min_by","doc":"Returns the element for which the passed block returns with the minimum value.\n\nIt compares using `<` so the block must return a type that supports that method\n\n```\n[\"Alice\", \"Bob\"].min_by { |name| name.size } # => \"Bob\"\n```\n\nRaises `Enumerable::EmptyError` if the collection is empty.","summary":"<p>Returns the element for which the passed block returns with the minimum value.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1043,"url":null},"def":{"name":"min_by","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"return_type":"T","visibility":"Public","body":"found, value = min_by_internal do |value|\n  yield value\nend\nif found\nelse\n  raise(Enumerable::EmptyError.new)\nend\nvalue\n"}},{"html_id":"min_by?(&:T->U):T?forallU-instance-method","name":"min_by?","doc":"Like `min_by` but returns `nil` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#min_by%28%26%3AT-%3EU%29%3ATforallU-instance-method\">#min_by</a></code> but returns <code>nil</code> if the collection is empty.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1050,"url":null},"def":{"name":"min_by?","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"return_type":"T | ::Nil","visibility":"Public","body":"found, value = min_by_internal do |value|\n  yield value\nend\nfound ? value : nil\n"}},{"html_id":"min_of(&:T->U):UforallU-instance-method","name":"min_of","doc":"Like `min_by` but instead of the element, returns the value returned by the block.\n\n```\n[\"Alice\", \"Bob\"].min_of { |name| name.size } # => 3 (Bob's size)\n```","summary":"<p>Like <code><a href=\"Enumerable.html#min_by%28%26%3AT-%3EU%29%3ATforallU-instance-method\">#min_by</a></code> but instead of the element, returns the value returned by the block.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1077,"url":null},"def":{"name":"min_of","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"return_type":"U","visibility":"Public","body":"found, value = min_of_internal do |value|\n  yield value\nend\nif found\nelse\n  raise(Enumerable::EmptyError.new)\nend\nvalue\n"}},{"html_id":"min_of?(&:T->U):U?forallU-instance-method","name":"min_of?","doc":"Like `min_of` but returns `nil` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#min_of%28%26%3AT-%3EU%29%3AUforallU-instance-method\">#min_of</a></code> but returns <code>nil</code> if the collection is empty.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1084,"url":null},"def":{"name":"min_of?","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"return_type":"U | ::Nil","visibility":"Public","body":"found, value = min_of_internal do |value|\n  yield value\nend\nfound ? value : nil\n"}},{"html_id":"minmax:Tuple(T,T)-instance-method","name":"minmax","doc":"Returns a `Tuple` with both the minimum and maximum value.\n\n```\n[1, 2, 3].minmax # => {1, 3}\n```\n\nRaises `Enumerable::EmptyError` if the collection is empty.","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> with both the minimum and maximum value.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1111,"url":null},"def":{"name":"minmax","return_type":"::Tuple(T, T)","visibility":"Public","body":"minmax_by(&.itself)"}},{"html_id":"minmax?:Tuple(T?,T?)-instance-method","name":"minmax?","doc":"Like `minmax` but returns `{nil, nil}` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#minmax%3ATuple%28T%2CT%29-instance-method\">#minmax</a></code> but returns <code>{nil, nil}</code> if the collection is empty.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1116,"url":null},"def":{"name":"minmax?","return_type":"::Tuple(T | ::Nil, T | ::Nil)","visibility":"Public","body":"minmax_by?(&.itself)"}},{"html_id":"minmax_by(&:T->U):Tuple(T,T)forallU-instance-method","name":"minmax_by","doc":"Returns a `Tuple` with both the minimum and maximum values according to the passed block.\n\n```\n[\"Alice\", \"Bob\", \"Carl\"].minmax_by { |name| name.size } # => {\"Bob\", \"Alice\"}\n```\n\nRaises `Enumerable::EmptyError` if the collection is empty.","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> with both the minimum and maximum values according to the passed block.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1127,"url":null},"def":{"name":"minmax_by","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"return_type":"::Tuple(T, T)","visibility":"Public","body":"found, value = minmax_by_internal do |value|\n  yield value\nend\nif found\nelse\n  raise(Enumerable::EmptyError.new)\nend\nvalue\n"}},{"html_id":"minmax_by?(&:T->U):Tuple(T,T)|Tuple(Nil,Nil)forallU-instance-method","name":"minmax_by?","doc":"Like `minmax_by` but returns `{nil, nil}` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#minmax_by%28%26%3AT-%3EU%29%3ATuple%28T%2CT%29forallU-instance-method\">#minmax_by</a></code> but returns <code>{nil, nil}</code> if the collection is empty.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1134,"url":null},"def":{"name":"minmax_by?","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"return_type":"::Tuple(T, T) | ::Tuple(Nil, Nil)","visibility":"Public","body":"found, value = minmax_by_internal do |value|\n  yield value\nend\nfound ? value : {nil, nil}\n"}},{"html_id":"minmax_of(&:T->U):Tuple(U,U)forallU-instance-method","name":"minmax_of","doc":"Returns a `Tuple` with both the minimum and maximum value\nthe block returns when passed the elements in the collection.\n\n```\n[\"Alice\", \"Bob\", \"Carl\"].minmax_of { |name| name.size } # => {3, 5}\n```\n\nRaises `Enumerable::EmptyError` if the collection is empty.","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> with both the minimum and maximum value the block returns when passed the elements in the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1170,"url":null},"def":{"name":"minmax_of","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"return_type":"::Tuple(U, U)","visibility":"Public","body":"found, value = minmax_of_internal do |value|\n  yield value\nend\nif found\nelse\n  raise(Enumerable::EmptyError.new)\nend\nvalue\n"}},{"html_id":"minmax_of?(&:T->U):Tuple(U,U)|Tuple(Nil,Nil)forallU-instance-method","name":"minmax_of?","doc":"Like `minmax_of` but returns `{nil, nil}` if the collection is empty.","summary":"<p>Like <code><a href=\"Enumerable.html#minmax_of%28%26%3AT-%3EU%29%3ATuple%28U%2CU%29forallU-instance-method\">#minmax_of</a></code> but returns <code>{nil, nil}</code> if the collection is empty.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1177,"url":null},"def":{"name":"minmax_of?","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"return_type":"::Tuple(U, U) | ::Tuple(Nil, Nil)","visibility":"Public","body":"found, value = minmax_of_internal do |value|\n  yield value\nend\nfound ? value : {nil, nil}\n"}},{"html_id":"none?(&:T->):Bool-instance-method","name":"none?","doc":"Returns `true` if the passed block returns `true`\nfor none of the elements of the collection.\n\n```\n[1, 2, 3].none? { |i| i > 5 } # => true\n```\n\nIt's the opposite of `all?`.","summary":"<p>Returns <code>true</code> if the passed block returns <code>true</code> for none of the elements of the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1213,"url":null},"def":{"name":"none?","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"Bool","visibility":"Public","body":"each do |e|\n  if yield(e)\n    return false\n  end\nend\ntrue\n"}},{"html_id":"none?(pattern):Bool-instance-method","name":"none?","doc":"Returns `true` if `pattern === element` for no element in\nthis enumerable.\n\n```\n[2, 3, 4].none?(5..7)      # => true\n[2, \"a\", 3].none?(String)  # => false\n%w[foo bar baz].none?(/e/) # => true\n```","summary":"<p>Returns <code>true</code> if <code>pattern === element</code> for no element in this enumerable.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : Bool","args_html":"(pattern) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/enumerable.cr","line_number":1226,"url":null},"def":{"name":"none?","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"Bool","visibility":"Public","body":"none? do |e|\n  pattern === e\nend"}},{"html_id":"none?:Bool-instance-method","name":"none?","doc":"Returns `true` if all of the elements of the collection are `false` or `nil`.\n\n```\n[nil, false].none?       # => true\n[nil, false, true].none? # => false\n```\n\nIt's the opposite of `all?`.","summary":"<p>Returns <code>true</code> if all of the elements of the collection are <code>false</code> or <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1238,"url":null},"def":{"name":"none?","return_type":"Bool","visibility":"Public","body":"none?(&.itself)"}},{"html_id":"one?(&:T->):Bool-instance-method","name":"one?","doc":"Returns `true` if the passed block returns `true`\nfor exactly one of the elements of the collection.\n\n```\n[1, 2, 3].one? { |i| i > 2 } # => true\n[1, 2, 3].one? { |i| i > 1 } # => false\n```","summary":"<p>Returns <code>true</code> if the passed block returns <code>true</code> for exactly one of the elements of the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1249,"url":null},"def":{"name":"one?","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"Bool","visibility":"Public","body":"c = 0\neach do |e|\n  if yield(e)\n    c = c + 1\n  end\n  if c > 1\n    return false\n  end\nend\nc == 1\n"}},{"html_id":"one?(pattern):Bool-instance-method","name":"one?","doc":"Returns `true` if `pattern === element` for just one element\nin this enumerable.\n\n```\n[1, 10, 100].one?(7..14)   # => true\n[2, \"a\", 3].one?(Int32)    # => false\n%w[foo bar baz].one?(/oo/) # => true\n```","summary":"<p>Returns <code>true</code> if <code>pattern === element</code> for just one element in this enumerable.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : Bool","args_html":"(pattern) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/enumerable.cr","line_number":1266,"url":null},"def":{"name":"one?","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"Bool","visibility":"Public","body":"one? do |e|\n  pattern === e\nend"}},{"html_id":"one?:Bool-instance-method","name":"one?","doc":"Returns `true` if only one element in this enumerable\nis _truthy_.\n\n```\n[1, false, false].one? # => true\n[1, false, 3].one?     # => false\n[1].one?               # => true\n[false].one?           # => false\n```","summary":"<p>Returns <code>true</code> if only one element in this enumerable is <em>truthy</em>.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1279,"url":null},"def":{"name":"one?","return_type":"Bool","visibility":"Public","body":"one?(&.itself)"}},{"html_id":"partition(&:T->):Tuple(Array(T),Array(T))-instance-method","name":"partition","doc":"Returns a `Tuple` with two arrays. The first one contains the elements\nin the collection for which the passed block returned `true`,\nand the second one those for which it returned `false`.\n\n```\n[1, 2, 3, 4, 5, 6].partition { |i| i % 2 == 0 } # => {[2, 4, 6], [1, 3, 5]}\n```","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> with two arrays.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1290,"url":null},"def":{"name":"partition","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"::Tuple(Array(T), Array(T))","visibility":"Public","body":"a, b = [] of T, [] of T\neach do |e|\n  value = yield(e)\n  value ? a.push(e) : b.push(e)\nend\n{a, b}\n"}},{"html_id":"product(initial:Number)-instance-method","name":"product","doc":"Multiplies *initial* and all the elements in the collection\ntogether.  The type of *initial* will be the type of the product,\nso use this if (for instance) you need to specify a large enough\ntype to avoid overflow.\n\nExpects all element types to respond to `#*` method.\n\n```\n[1, 2, 3, 4, 5, 6].product(7) # => 5040\n```\n\nIf the collection is empty, returns *initial*.\n\n```\n([] of Int32).product(7) # => 7\n```","summary":"<p>Multiplies <em>initial</em> and all the elements in the collection together.</p>","abstract":false,"args":[{"name":"initial","external_name":"initial","restriction":"Number"}],"args_string":"(initial : Number)","args_html":"(initial : <a href=\"Number.html\">Number</a>)","location":{"filename":"src/enumerable.cr","line_number":1626,"url":null},"def":{"name":"product","args":[{"name":"initial","external_name":"initial","restriction":"Number"}],"visibility":"Public","body":"product(initial, &.itself)"}},{"html_id":"product-instance-method","name":"product","doc":"Multiplies all the elements in the collection together.\n\nExpects all element types to respond to `#*` method.\n\n```\n[1, 2, 3, 4, 5, 6].product # => 720\n```\n\nThis method calls `.multiplicative_identity` on the element type to determine the\ntype of the sum value.\n\nIf the collection is empty, returns `multiplicative_identity`.\n\n```\n([] of Int32).product # => 1\n```","summary":"<p>Multiplies all the elements in the collection together.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1606,"url":null},"def":{"name":"product","visibility":"Public","body":"product(Reflect(T).first.multiplicative_identity)"}},{"html_id":"product(initial:Number,&:T->)-instance-method","name":"product","doc":"Multiplies *initial* and all results of the passed block for each element\nin the collection.\n\n```\n[\"Alice\", \"Bob\"].product(2) { |name| name.size } # => 30 (2 * 5 * 3)\n```\n\nExpects all types returned from the block to respond to `#*` method.\n\nIf the collection is empty, returns `1`.\n\n```\n([] of String).product(1) { |name| name.size } # => 1\n```","summary":"<p>Multiplies <em>initial</em> and all results of the passed block for each element in the collection.</p>","abstract":false,"args":[{"name":"initial","external_name":"initial","restriction":"Number"}],"args_string":"(initial : Number, & : T -> )","args_html":"(initial : <a href=\"Number.html\">Number</a>, & : T -> )","location":{"filename":"src/enumerable.cr","line_number":1666,"url":null},"def":{"name":"product","args":[{"name":"initial","external_name":"initial","restriction":"Number"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"visibility":"Public","body":"reduce(initial) do |memo, e|\n  memo * (yield e)\nend"}},{"html_id":"product(&:T->_)-instance-method","name":"product","doc":"Multiplies all results of the passed block for each element in the collection.\n\n```\n[\"Alice\", \"Bob\"].product { |name| name.size } # => 15 (5 * 3)\n```\n\nExpects all types returned from the block to respond to `#*` method.\n\nThis method calls `.multiplicative_identity` on the element type to determine the\ntype of the sum value.\n\nIf the collection is empty, returns `multiplicative_identity`.\n\n```\n([] of Int32).product { |x| x + 1 } # => 1\n```","summary":"<p>Multiplies all results of the passed block for each element in the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1646,"url":null},"def":{"name":"product","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> _)"},"visibility":"Public","body":"product(Reflect(typeof(yield Enumerable.element_type(self))).first.multiplicative_identity) do |value|\n  yield value\nend"}},{"html_id":"reduce(memo,&)-instance-method","name":"reduce","doc":"Just like the other variant, but you can set the initial value of the accumulator.\n\n```\n[1, 2, 3, 4, 5].reduce(10) { |acc, i| acc + i }             # => 25\n[1, 2, 3].reduce([] of Int32) { |memo, i| memo.unshift(i) } # => [3, 2, 1]\n```","summary":"<p>Just like the other variant, but you can set the initial value of the accumulator.</p>","abstract":false,"args":[{"name":"memo","external_name":"memo","restriction":""}],"args_string":"(memo, &)","args_html":"(memo, &)","location":{"filename":"src/enumerable.cr","line_number":709,"url":null},"def":{"name":"reduce","args":[{"name":"memo","external_name":"memo","restriction":""}],"yields":2,"visibility":"Public","body":"each do |elem|\n  memo = yield memo, elem\nend\nmemo\n"}},{"html_id":"reduce(&)-instance-method","name":"reduce","doc":"Combines all elements in the collection by applying a binary operation, specified by a block, so as\nto reduce them to a single value.\n\nFor each element in the collection the block is passed an accumulator value (*memo*) and the element. The\nresult becomes the new value for *memo*. At the end of the iteration, the final value of *memo* is\nthe return value for the method. The initial value for the accumulator is the first element in the collection.\nIf the collection has only one element, that element is returned.\n\nRaises `Enumerable::EmptyError` if the collection is empty.\n\n```\n[1, 2, 3, 4, 5].reduce { |acc, i| acc + i } # => 15\n[1].reduce { |acc, i| acc + i }             # => 1\n([] of Int32).reduce { |acc, i| acc + i }   # raises Enumerable::EmptyError\n```\n\nThe block is not required to return a `T`, in which case the accumulator's\ntype includes whatever the block returns.\n\n```\n# `acc` is an `Int32 | String`\n[1, 2, 3, 4, 5].reduce { |acc, i| \"#{acc}-#{i}\" } # => \"1-2-3-4-5\"\n[1].reduce { |acc, i| \"#{acc}-#{i}\" }             # => 1\n```","summary":"<p>Combines all elements in the collection by applying a binary operation, specified by a block, so as to reduce them to a single value.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":691,"url":null},"def":{"name":"reduce","yields":2,"visibility":"Public","body":"memo = uninitialized typeof(reduce(Enumerable.element_type(self)) do |acc, i|\n  yield acc, i\nend)\nfound = false\neach do |elem|\n  memo = found ? (  yield memo, elem) : elem\n  found = true\nend\nfound ? memo : raise(Enumerable::EmptyError.new)\n"}},{"html_id":"reduce?(&)-instance-method","name":"reduce?","doc":"Similar to `reduce`, but instead of raising when the input is empty,\nreturn `nil`\n\n```\n([] of Int32).reduce? { |acc, i| acc + i } # => nil\n```","summary":"<p>Similar to <code><a href=\"Enumerable.html#reduce%28%26%29-instance-method\">#reduce</a></code>, but instead of raising when the input is empty, return <code>nil</code></p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":722,"url":null},"def":{"name":"reduce?","yields":2,"visibility":"Public","body":"memo = uninitialized typeof(reduce(Enumerable.element_type(self)) do |acc, i|\n  yield acc, i\nend)\nfound = false\neach do |elem|\n  memo = found ? (  yield memo, elem) : elem\n  found = true\nend\nfound ? memo : nil\n"}},{"html_id":"reject(&:T->)-instance-method","name":"reject","doc":"Returns an `Array` with all the elements in the collection for which\nthe passed block returns `false`.\n\n```\n[1, 2, 3, 4, 5, 6].reject { |i| i % 2 == 0 } # => [1, 3, 5]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection for which the passed block returns <code>false</code>.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1305,"url":null},"def":{"name":"reject","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"visibility":"Public","body":"ary = [] of T\neach do |e|\n  if yield e\n  else\n    ary << e\n  end\nend\nary\n"}},{"html_id":"reject(type:U.class)forallU-instance-method","name":"reject","doc":"Returns an `Array` with all the elements in the collection\nthat are **not** of the given *type*.\n\n```\nints = [1, true, 3, false].reject(Bool)\nints         # => [1, 3]\ntypeof(ints) # => Array(Int32)\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection that are <strong>not</strong> of the given <em>type</em>.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"U.class"}],"args_string":"(type : U.class) forall U","args_html":"(type : <span class=\"t\">U</span>.<span class=\"k\">class</span>) forall U","location":{"filename":"src/enumerable.cr","line_number":1319,"url":null},"def":{"name":"reject","args":[{"name":"type","external_name":"type","restriction":"U.class"}],"visibility":"Public","body":"ary = [] of typeof(begin\n  e = Enumerable.element_type(self)\n  e.is_a?(U) ? raise(\"\") : e\nend)\neach do |e|\n  if e.is_a?(U)\n  else\n    ary << e\n  end\nend\nary\n"}},{"html_id":"reject(pattern):Array(T)-instance-method","name":"reject","doc":"Returns an `Array` with all the elements in the collection for which\n`pattern === element` is false.\n\n```\n[1, 3, 2, 5, 4, 6].reject(3..5) # => [1, 2, 6]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection for which <code>pattern === element</code> is false.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : Array(T)","args_html":"(pattern) : <a href=\"Array.html\">Array</a>(T)","location":{"filename":"src/enumerable.cr","line_number":1334,"url":null},"def":{"name":"reject","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"Array(T)","visibility":"Public","body":"reject do |e|\n  pattern === e\nend"}},{"html_id":"sample(n:Int,random=Random::DEFAULT):Array(T)-instance-method","name":"sample","doc":"Returns an `Array` of *n* random elements from `self`, using the given\n*random* number generator. All elements have equal probability of being\ndrawn. Sampling is done without replacement; if *n* is larger than the size\nof this collection, the returned `Array` has the same size as `self`.\n\nRaises `ArgumentError` if *n* is negative.\n\n```\n[1, 2, 3, 4, 5].sample(2)                # => [3, 5]\n{1, 2, 3, 4, 5}.sample(2)                # => [3, 4]\n{1, 2, 3, 4, 5}.sample(2, Random.new(1)) # => [1, 5]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of <em>n</em> random elements from <code>self</code>, using the given <em>random</em> number generator.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"},{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(n : Int, random = Random::DEFAULT) : Array(T)","args_html":"(n : <a href=\"Int.html\">Int</a>, random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>) : <a href=\"Array.html\">Array</a>(T)","location":{"filename":"src/enumerable.cr","line_number":1350,"url":null},"def":{"name":"sample","args":[{"name":"n","external_name":"n","restriction":"Int"},{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"return_type":"Array(T)","visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Can't sample negative number of elements\"))\nend\nary = Array(T).new(n)\nif n == 0\n  return ary\nend\neach_with_index do |elem, i|\n  if i < n\n    ary << elem\n  else\n    j = random.rand(i + 1)\n    if j < n\n      ary.to_unsafe[j] = elem\n    end\n  end\nend\nary.shuffle!(random)\n"}},{"html_id":"sample(random=Random::DEFAULT):T-instance-method","name":"sample","doc":"Returns a random element from `self`, using the given *random* number\ngenerator. All elements have equal probability of being drawn.\n\nRaises `IndexError` if `self` is empty.\n\n```\na = [1, 2, 3]\na.sample                # => 2\na.sample                # => 1\na.sample(Random.new(1)) # => 3\n```","summary":"<p>Returns a random element from <code>self</code>, using the given <em>random</em> number generator.</p>","abstract":false,"args":[{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(random = Random::DEFAULT) : T","args_html":"(random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>) : T","location":{"filename":"src/enumerable.cr","line_number":1386,"url":null},"def":{"name":"sample","args":[{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"return_type":"T","visibility":"Public","body":"value = uninitialized T\nfound = false\neach_with_index do |elem, i|\n  if !found\n    value = elem\n    found = true\n  else\n    if (random.rand(i + 1)) == 0\n      value = elem\n    end\n  end\nend\nfound ? value : raise(IndexError.new(\"Can't sample empty collection\"))\n"}},{"html_id":"select(&:T->)-instance-method","name":"select","doc":"Returns an `Array` with all the elements in the collection for which\nthe passed block returns `true`.\n\n```\n[1, 2, 3, 4, 5, 6].select { |i| i % 2 == 0 } # => [2, 4, 6]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection for which the passed block returns <code>true</code>.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1408,"url":null},"def":{"name":"select","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"visibility":"Public","body":"ary = [] of T\neach do |e|\n  if yield e\n    ary << e\n  end\nend\nary\n"}},{"html_id":"select(type:U.class):Array(U)forallU-instance-method","name":"select","doc":"Returns an `Array` with all the elements in the collection\nthat are of the given *type*.\n\n```\nints = [1, true, nil, 3, false].select(Int32)\nints         # => [1, 3]\ntypeof(ints) # => Array(Int32)\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection that are of the given <em>type</em>.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"U.class"}],"args_string":"(type : U.class) : Array(U) forall U","args_html":"(type : <span class=\"t\">U</span>.<span class=\"k\">class</span>) : <a href=\"Array.html\">Array</a>(U) forall U","location":{"filename":"src/enumerable.cr","line_number":1422,"url":null},"def":{"name":"select","args":[{"name":"type","external_name":"type","restriction":"U.class"}],"return_type":"Array(U)","visibility":"Public","body":"ary = [] of U\neach do |e|\n  if e.is_a?(U)\n    ary << e\n  end\nend\nary\n"}},{"html_id":"select(pattern):Array(T)-instance-method","name":"select","doc":"Returns an `Array` with all the elements in the collection for which\n`pattern === element`.\n\n```\n[1, 3, 2, 5, 4, 6].select(3..5) # => [3, 5, 4]\n[\"Alice\", \"Bob\"].select(/^A/)   # => [\"Alice\"]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection for which <code>pattern === element</code>.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : Array(T)","args_html":"(pattern) : <a href=\"Array.html\">Array</a>(T)","location":{"filename":"src/enumerable.cr","line_number":1435,"url":null},"def":{"name":"select","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"Array(T)","visibility":"Public","body":"self.select do |elem|\n  pattern === elem\nend"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Returns the number of elements in the collection.\n\n```\n[1, 2, 3, 4].size # => 4\n```","summary":"<p>Returns the number of elements in the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1444,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"count do\n  true\nend"}},{"html_id":"skip(count:Int)-instance-method","name":"skip","doc":"Returns an `Array` with the first *count* elements removed\nfrom the original collection.\n\nIf *count* is bigger than the number of elements in the collection, returns an empty array.\n\n```\n[1, 2, 3, 4, 5, 6].skip(3) # => [4, 5, 6]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with the first <em>count</em> elements removed from the original collection.</p>","abstract":false,"args":[{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(count : Int)","args_html":"(count : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/enumerable.cr","line_number":1467,"url":null},"def":{"name":"skip","args":[{"name":"count","external_name":"count","restriction":"Int"}],"visibility":"Public","body":"if count < 0\n  raise(ArgumentError.new(\"Attempt to skip negative size\"))\nend\narray = Array(T).new\neach_with_index do |e, i|\n  if i >= count\n    array << e\n  end\nend\narray\n"}},{"html_id":"skip_while(&:T->):Array(T)-instance-method","name":"skip_while","doc":"Skips elements up to, but not including, the first element for which\nthe block returns `nil` or `false` and returns an `Array`\ncontaining the remaining elements.\n\n```\n[1, 2, 3, 4, 5, 0].skip_while { |i| i < 3 } # => [3, 4, 5, 0]\n```","summary":"<p>Skips elements up to, but not including, the first element for which the block returns <code>nil</code> or <code>false</code> and returns an <code><a href=\"Array.html\">Array</a></code> containing the remaining elements.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1484,"url":null},"def":{"name":"skip_while","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"Array(T)","visibility":"Public","body":"result = Array(T).new\nblock_returned_false = false\neach do |x|\n  if block_returned_false || (yield x)\n  else\n    block_returned_false = true\n  end\n  if block_returned_false\n    result << x\n  end\nend\nresult\n"}},{"html_id":"sum(initial)-instance-method","name":"sum","doc":"Adds *initial* and all the elements in the collection together.\nThe type of *initial* will be the type of the sum, so use this if\n(for instance) you need to specify a large enough type to avoid\noverflow.\n\nExpects all element types to respond to `#+` method.\n\n```\n[1, 2, 3, 4, 5, 6].sum(7) # => 28\n```\n\nIf the collection is empty, returns *initial*.\n\n```\n([] of Int32).sum(7) # => 7\n```","summary":"<p>Adds <em>initial</em> and all the elements in the collection together.</p>","abstract":false,"args":[{"name":"initial","external_name":"initial","restriction":""}],"args_string":"(initial)","args_html":"(initial)","location":{"filename":"src/enumerable.cr","line_number":1547,"url":null},"def":{"name":"sum","args":[{"name":"initial","external_name":"initial","restriction":""}],"visibility":"Public","body":"sum(initial, &.itself)"}},{"html_id":"sum-instance-method","name":"sum","doc":"Adds all the elements in the collection together.\n\nExpects all element types to respond to `#+` method.\n\n```\n[1, 2, 3, 4, 5, 6].sum # => 21\n```\n\nThis method calls `.additive_identity` on the yielded type to determine the\ntype of the sum value.\n\nIf the collection is empty, returns `additive_identity`.\n\n```\n([] of Int32).sum # => 0\n```","summary":"<p>Adds all the elements in the collection together.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1510,"url":null},"def":{"name":"sum","visibility":"Public","body":"{% if T == String %}\n      # optimize for string\n      join\n    {% else %}{% if T < Array %}\n      # optimize for array\n      flat_map &.itself\n    {% else %}\n      sum additive_identity(Reflect(T))\n    {% end %}{% end %}"}},{"html_id":"sum(initial,&:T->)-instance-method","name":"sum","doc":"Adds *initial* and all results of the passed block for each element in the collection.\n\n```\n[\"Alice\", \"Bob\"].sum(1) { |name| name.size } # => 9 (1 + 5 + 3)\n```\n\nExpects all types returned from the block to respond to `#+` method.\n\nIf the collection is empty, returns *initial*.\n\n```\n([] of String).sum(1) { |name| name.size } # => 1\n```","summary":"<p>Adds <em>initial</em> and all results of the passed block for each element in the collection.</p>","abstract":false,"args":[{"name":"initial","external_name":"initial","restriction":""}],"args_string":"(initial, & : T -> )","args_html":"(initial, & : T -> )","location":{"filename":"src/enumerable.cr","line_number":1586,"url":null},"def":{"name":"sum","args":[{"name":"initial","external_name":"initial","restriction":""}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"visibility":"Public","body":"reduce(initial) do |memo, e|\n  memo + (yield e)\nend"}},{"html_id":"sum(&:T->)-instance-method","name":"sum","doc":"Adds all results of the passed block for each element in the collection.\n\n```\n[\"Alice\", \"Bob\"].sum { |name| name.size } # => 8 (5 + 3)\n```\n\nExpects all types returned from the block to respond to `#+` method.\n\nThis method calls `.additive_identity` on the yielded type to determine the\ntype of the sum value.\n\nIf the collection is empty, returns `additive_identity`.\n\n```\n([] of Int32).sum { |x| x + 1 } # => 0\n```","summary":"<p>Adds all results of the passed block for each element in the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1567,"url":null},"def":{"name":"sum","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"visibility":"Public","body":"sum(additive_identity(Reflect(typeof(yield Enumerable.element_type(self))))) do |value|\n  yield value\nend"}},{"html_id":"take_while(&:T->):Array(T)-instance-method","name":"take_while","doc":"Passes elements to the block until the block returns `nil` or `false`,\nthen stops iterating and returns an `Array` of all prior elements.\n\n```\n[1, 2, 3, 4, 5, 0].take_while { |i| i < 3 } # => [1, 2]\n```","summary":"<p>Passes elements to the block until the block returns <code>nil</code> or <code>false</code>, then stops iterating and returns an <code><a href=\"Array.html\">Array</a></code> of all prior elements.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1692,"url":null},"def":{"name":"take_while","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"Array(T)","visibility":"Public","body":"result = Array(T).new\neach do |x|\n  if yield x\n  else\n    break\n  end\n  result << x\nend\nresult\n"}},{"html_id":"tally:Hash(T,Int32)-instance-method","name":"tally","doc":"Tallies the collection.  Returns a hash where the keys are the\nelements and the values are numbers of elements in the collection\nthat correspond to the key.\n\n```\n[\"a\", \"b\", \"c\", \"b\"].tally # => {\"a\"=>1, \"b\"=>2, \"c\"=>1}\n```","summary":"<p>Tallies the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1723,"url":null},"def":{"name":"tally","return_type":"Hash(T, Int32)","visibility":"Public","body":"tally_by do |item|\n  item\nend"}},{"html_id":"tally_by(&:T->U):Hash(U,Int32)forallU-instance-method","name":"tally_by","doc":"Tallies the collection.  Returns a hash where the keys are the\nelements and the values are numbers of elements in the collection\nthat correspond to the key after transformation by the given block.\n\n```\n[\"a\", \"A\", \"b\", \"B\"].tally_by(&.downcase) # => {\"a\" => 2, \"b\" => 2}\n```","summary":"<p>Tallies the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1708,"url":null},"def":{"name":"tally_by","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> U)"},"return_type":"Hash(U, Int32)","visibility":"Public","body":"each_with_object(Hash(U, Int32).new) do |item, hash|\n  value = yield item\n  count = hash[value]?\n  hash[value] = count ? count + 1 : 1\nend"}},{"html_id":"to_a-instance-method","name":"to_a","doc":"Returns an `Array` with all the elements in the collection.\n\n```\n(1..5).to_a # => [1, 2, 3, 4, 5]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1732,"url":null},"def":{"name":"to_a","visibility":"Public","body":"ary = [] of T\neach do |e|\n  ary << e\nend\nary\n"}},{"html_id":"to_h-instance-method","name":"to_h","doc":"Creates a `Hash` out of an Enumerable where each element is a\n2 element structure (for instance a `Tuple` or an `Array`).\n\n```\n[[:a, :b], [:c, :d]].to_h        # => {:a => :b, :c => :d}\nTuple.new({:a, 1}, {:c, 2}).to_h # => {:a => 1, :c => 2}\n```","summary":"<p>Creates a <code><a href=\"Hash.html\">Hash</a></code> out of an Enumerable where each element is a 2 element structure (for instance a <code><a href=\"Tuple.html\">Tuple</a></code> or an <code><a href=\"Array.html\">Array</a></code>).</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1745,"url":null},"def":{"name":"to_h","visibility":"Public","body":"each_with_object(Hash(typeof((Enumerable.element_type(self))[0]), typeof((Enumerable.element_type(self))[1])).new) do |item, hash|\n  hash[item[0]] = item[1]\nend"}},{"html_id":"to_h(&:T->Tuple(K,V))forallK,V-instance-method","name":"to_h","doc":"Creates a `Hash` out of `Tuple` pairs (key, value) returned from the *block*.\n\n```\n(1..3).to_h { |i| {i, i ** 2} } # => {1 => 1, 2 => 4, 3 => 9}\n```","summary":"<p>Creates a <code><a href=\"Hash.html\">Hash</a></code> out of <code><a href=\"Tuple.html\">Tuple</a></code> pairs (key, value) returned from the <em>block</em>.</p>","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":1756,"url":null},"def":{"name":"to_h","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> Tuple(K, V))"},"visibility":"Public","body":"each_with_object({} of K => V) do |item, hash|\n  key, value = yield item\n  hash[key] = value\nend"}},{"html_id":"to_set:Set(T)-instance-method","name":"to_set","doc":"Returns a new `Set` with each unique element in the enumerable.","summary":"<p>Returns a new <code><a href=\"Set.html\">Set</a></code> with each unique element in the enumerable.</p>","abstract":false,"location":{"filename":"src/set.cr","line_number":486,"url":null},"def":{"name":"to_set","return_type":"Set(T)","visibility":"Public","body":"Set.new(self)"}},{"html_id":"zip(*others:Indexable|Iterable|Iterator,&)-instance-method","name":"zip","doc":"Yields elements of `self` and *others* in tandem to the given block.\n\nRaises an `IndexError` if any of *others* doesn't have as many elements\nas `self`. See `zip?` for a version that yields `nil` instead of raising.\n\n```\na = [1, 2, 3]\nb = [\"a\", \"b\", \"c\"]\n\na.zip(b) { |x, y| puts \"#{x} -- #{y}\" }\n```\n\nThe above produces:\n\n```text\n1 -- a\n2 -- b\n3 -- c\n```\n\nAn example with multiple arguments:\n\n```\n(1..3).zip(4..6, 7..9) do |x, y, z|\n  puts \"#{x} -- #{y} -- #{z}\"\nend\n```\n\nThe above produces:\n\n```text\n1 -- 4 -- 7\n2 -- 5 -- 8\n3 -- 6 -- 9\n```","summary":"<p>Yields elements of <code>self</code> and <em>others</em> in tandem to the given block.</p>","abstract":false,"args":[{"name":"others","external_name":"others","restriction":"Indexable | Iterable | Iterator"}],"args_string":"(*others : Indexable | Iterable | Iterator, &)","args_html":"(*others : <a href=\"Indexable.html\">Indexable</a> | <a href=\"Iterable.html\">Iterable</a> | <a href=\"Iterator.html\">Iterator</a>, &)","location":{"filename":"src/enumerable.cr","line_number":1798,"url":null},"def":{"name":"zip","args":[{"name":"others","external_name":"others","restriction":"Indexable | Iterable | Iterator"}],"splat_index":0,"yields":1,"visibility":"Public","body":"Enumerable.zip(self, others) do |elems|\n  yield elems\nend"}},{"html_id":"zip(*others:Indexable|Iterable|Iterator)-instance-method","name":"zip","doc":"Returns an `Array` of tuples populated with the elements of `self` and\n*others* traversed in tandem.\n\nRaises an `IndexError` if any of *others* doesn't have as many elements\nas `self`. See `zip?` for a version that yields `nil` instead of raising.\n\n```\na = [1, 2, 3]\nb = [\"a\", \"b\", \"c\"]\n\na.zip(b) # => [{1, \"a\"}, {2, \"b\"}, {3, \"c\"}]\n```\n\nAn example with multiple arguments:\n\n```\na = [1, 2, 3]\nb = (4..6)\nc = 8.downto(3)\n\na.zip(b, c) # => [{1, 4, 8}, {2, 5, 7}, {3, 6, 6}]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of tuples populated with the elements of <code>self</code> and <em>others</em> traversed in tandem.</p>","abstract":false,"args":[{"name":"others","external_name":"others","restriction":"Indexable | Iterable | Iterator"}],"args_string":"(*others : Indexable | Iterable | Iterator)","args_html":"(*others : <a href=\"Indexable.html\">Indexable</a> | <a href=\"Iterable.html\">Iterable</a> | <a href=\"Iterator.html\">Iterator</a>)","location":{"filename":"src/enumerable.cr","line_number":1826,"url":null},"def":{"name":"zip","args":[{"name":"others","external_name":"others","restriction":"Indexable | Iterable | Iterator"}],"splat_index":0,"visibility":"Public","body":"size = self.is_a?(Indexable) ? self.size : 0\npairs = Array(typeof((zip(*others) do |e|\n  break e\nend).not_nil!)).new(size)\nzip(*others) do |e|\n  pairs << e\nend\npairs\n"}},{"html_id":"zip?(*others:Indexable|Iterable|Iterator,&)-instance-method","name":"zip?","doc":"Yields elements of `self` and *others* in tandem to the given block.\n\nAll of the elements in `self` will be yielded: if *others* don't have\nthat many elements they will be returned as `nil`.\n\n```\na = [1, 2, 3]\nb = [\"a\", \"b\"]\n\na.zip?(b) { |x, y| puts \"#{x.inspect} -- #{y.inspect}\" }\n```\n\nThe above produces:\n\n```text\n1 -- \"a\"\n2 -- \"b\"\n3 -- nil\n```\n\nAn example with multiple arguments:\n\n```\n(1..3).zip?(4..5, 7..8) do |x, y, z|\n  puts \"#{x.inspect} -- #{y.inspect} -- #{z.inspect}\"\nend\n```\n\nThe above produces:\n\n```text\n1 -- 4 -- 7\n2 -- 5 -- 8\n3 -- nil -- nil\n```","summary":"<p>Yields elements of <code>self</code> and <em>others</em> in tandem to the given block.</p>","abstract":false,"args":[{"name":"others","external_name":"others","restriction":"Indexable | Iterable | Iterator"}],"args_string":"(*others : Indexable | Iterable | Iterator, &)","args_html":"(*others : <a href=\"Indexable.html\">Indexable</a> | <a href=\"Iterable.html\">Iterable</a> | <a href=\"Iterator.html\">Iterator</a>, &)","location":{"filename":"src/enumerable.cr","line_number":1868,"url":null},"def":{"name":"zip?","args":[{"name":"others","external_name":"others","restriction":"Indexable | Iterable | Iterator"}],"splat_index":0,"yields":1,"visibility":"Public","body":"Enumerable.zip?(self, others) do |elems|\n  yield elems\nend"}},{"html_id":"zip?(*others:Indexable|Iterable|Iterator)-instance-method","name":"zip?","doc":"Returns an `Array` of tuples populated with the elements of `self` and\n*others* traversed in tandem.\n\nAll elements in `self` are returned in the Array. If matching elements\nin *others* are missing (because they don't have that many elements)\n`nil` is returned inside that tuple index.\n\n```\na = [1, 2, 3]\nb = [\"a\", \"b\"]\n\na.zip?(b) # => [{1, \"a\"}, {2, \"b\"}, {3, nil}]\n```\n\nAn example with multiple arguments:\n\n```\na = [1, 2, 3]\nb = (4..5)\nc = 8.downto(7)\n\na.zip?(b, c) # => [{1, 4, 8}, {2, 5, 7}, {3, nil, nil}]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of tuples populated with the elements of <code>self</code> and <em>others</em> traversed in tandem.</p>","abstract":false,"args":[{"name":"others","external_name":"others","restriction":"Indexable | Iterable | Iterator"}],"args_string":"(*others : Indexable | Iterable | Iterator)","args_html":"(*others : <a href=\"Indexable.html\">Indexable</a> | <a href=\"Iterable.html\">Iterable</a> | <a href=\"Iterator.html\">Iterator</a>)","location":{"filename":"src/enumerable.cr","line_number":1897,"url":null},"def":{"name":"zip?","args":[{"name":"others","external_name":"others","restriction":"Indexable | Iterable | Iterator"}],"splat_index":0,"visibility":"Public","body":"size = self.is_a?(Indexable) ? self.size : 0\npairs = Array(typeof((zip?(*others) do |e|\n  break e\nend).not_nil!)).new(size)\nzip?(*others) do |e|\n  pairs << e\nend\npairs\n"}}],"types":[{"html_id":"Crystal/Enumerable/Chunk","path":"Enumerable/Chunk.html","kind":"module","full_name":"Enumerable::Chunk","name":"Chunk","abstract":false,"locations":[{"filename":"src/enumerable.cr","line_number":133,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable(T)","name":"Enumerable"},"types":[{"html_id":"Crystal/Enumerable/Chunk/Alone","path":"Enumerable/Chunk/Alone.html","kind":"struct","full_name":"Enumerable::Chunk::Alone","name":"Alone","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/enumerable.cr","line_number":138,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Enumerable/Chunk","kind":"module","full_name":"Enumerable::Chunk","name":"Chunk"},"doc":"Can be used in `Enumerable#chunks` and specifies that the element should be chunked by itself.","summary":"<p>Can be used in <code><a href=\"../../Enumerable.html#chunks%28%26block%3AT-%3EU%29forallU-instance-method\">Enumerable#chunks</a></code> and specifies that the element should be chunked by itself.</p>","constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":138,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":138,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new"}},{"html_id":"copy_with-instance-method","name":"copy_with","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":138,"url":null},"def":{"name":"copy_with","visibility":"Public","body":"self.class.new"}}]},{"html_id":"Crystal/Enumerable/Chunk/Drop","path":"Enumerable/Chunk/Drop.html","kind":"struct","full_name":"Enumerable::Chunk::Drop","name":"Drop","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/enumerable.cr","line_number":135,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Enumerable/Chunk","kind":"module","full_name":"Enumerable::Chunk","name":"Chunk"},"doc":"Can be used in `Enumerable#chunks` and specifies that the elements should be dropped.","summary":"<p>Can be used in <code><a href=\"../../Enumerable.html#chunks%28%26block%3AT-%3EU%29forallU-instance-method\">Enumerable#chunks</a></code> and specifies that the elements should be dropped.</p>","constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":135,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":135,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new"}},{"html_id":"copy_with-instance-method","name":"copy_with","abstract":false,"location":{"filename":"src/enumerable.cr","line_number":135,"url":null},"def":{"name":"copy_with","visibility":"Public","body":"self.class.new"}}]}]},{"html_id":"Crystal/Enumerable/EmptyError","path":"Enumerable/EmptyError.html","kind":"class","full_name":"Enumerable::EmptyError","name":"EmptyError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/enumerable.cr","line_number":30,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable(T)","name":"Enumerable"},"constructors":[{"html_id":"new(message=\"Emptyenumerable\")-class-method","name":"new","abstract":false,"args":[{"name":"message","default_value":"\"Empty enumerable\"","external_name":"message","restriction":""}],"args_string":"(message = \"Empty enumerable\")","args_html":"(message = <span class=\"s\">&quot;Empty enumerable&quot;</span>)","location":{"filename":"src/enumerable.cr","line_number":31,"url":null},"def":{"name":"new","args":[{"name":"message","default_value":"\"Empty enumerable\"","external_name":"message","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]}]},{"html_id":"Crystal/ENV","path":"ENV.html","kind":"module","full_name":"ENV","name":"ENV","abstract":false,"locations":[{"filename":"src/env.cr","line_number":16,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"extended_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"doc":"`ENV` is a hash-like accessor for environment variables.\n\n### Example\n\n```\n# Set env var PORT to a default if not already set\nENV[\"PORT\"] ||= \"5000\"\n# Later use that env var.\nputs ENV[\"PORT\"].to_i\n```\n\nNOTE: All keys and values are strings. You must take care to cast other types\nat runtime, e.g. integer port numbers.","summary":"<p><code><a href=\"ENV.html\">ENV</a></code> is a hash-like accessor for environment variables.</p>","class_methods":[{"html_id":"[](key:String):String-class-method","name":"[]","doc":"Retrieves the value for environment variable named *key* as a `String`.\nRaises `KeyError` if the named variable does not exist.","summary":"<p>Retrieves the value for environment variable named <em>key</em> as a <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String) : String","args_html":"(key : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/env.cr","line_number":21,"url":null},"def":{"name":"[]","args":[{"name":"key","external_name":"key","restriction":"String"}],"return_type":"String","visibility":"Public","body":"fetch(key)"}},{"html_id":"[]=(key:String,value:String?)-class-method","name":"[]=","doc":"Sets the value for environment variable named *key* as *value*.\nOverwrites existing environment variable if already present.\nReturns *value* if successful, otherwise raises an exception.\nIf *value* is `nil`, the environment variable is deleted.\n\nIf *key* or *value* contains a null-byte an `ArgumentError` is raised.","summary":"<p>Sets the value for environment variable named <em>key</em> as <em>value</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"},{"name":"value","external_name":"value","restriction":"String | ::Nil"}],"args_string":"(key : String, value : String?)","args_html":"(key : <a href=\"String.html\">String</a>, value : <a href=\"String.html\">String</a>?)","location":{"filename":"src/env.cr","line_number":37,"url":null},"def":{"name":"[]=","args":[{"name":"key","external_name":"key","restriction":"String"},{"name":"value","external_name":"value","restriction":"String | ::Nil"}],"visibility":"Public","body":"Crystal::System::Env.set(key, value)\nvalue\n"}},{"html_id":"[]?(key:String):String?-class-method","name":"[]?","doc":"Retrieves the value for environment variable named *key* as a `String?`.\nReturns `nil` if the named variable does not exist.","summary":"<p>Retrieves the value for environment variable named <em>key</em> as a <code><a href=\"String.html\">String</a>?</code>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String) : String?","args_html":"(key : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/env.cr","line_number":27,"url":null},"def":{"name":"[]?","args":[{"name":"key","external_name":"key","restriction":"String"}],"return_type":"String | ::Nil","visibility":"Public","body":"fetch(key, nil)"}},{"html_id":"clear:Nil-class-method","name":"clear","abstract":false,"location":{"filename":"src/env.cr","line_number":112,"url":null},"def":{"name":"clear","return_type":"Nil","visibility":"Public","body":"keys.each do |k|\n  delete(k)\nend"}},{"html_id":"delete(key:String):String?-class-method","name":"delete","doc":"Removes the environment variable named *key*. Returns the previous value if\nthe environment variable existed, otherwise returns `nil`.","summary":"<p>Removes the environment variable named <em>key</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String) : String?","args_html":"(key : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/env.cr","line_number":89,"url":null},"def":{"name":"delete","args":[{"name":"key","external_name":"key","restriction":"String"}],"return_type":"String | ::Nil","visibility":"Public","body":"if value = self[key]?\n  Crystal::System::Env.set(key, nil)\n  value\nelse\n  nil\nend"}},{"html_id":"each(&:Tuple(String,String)->)-class-method","name":"each","doc":"Iterates over all `KEY=VALUE` pairs of environment variables, yielding both\nthe *key* and *value*.\n\n```\nENV.each do |key, value|\n  puts \"#{key} => #{value}\"\nend\n```","summary":"<p>Iterates over all <code>KEY=VALUE</code> pairs of environment variables, yielding both the <em>key</em> and <em>value</em>.</p>","abstract":false,"location":{"filename":"src/env.cr","line_number":106,"url":null},"def":{"name":"each","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(::Tuple(String, String) ->)"},"visibility":"Public","body":"Crystal::System::Env.each do |key, value|\n  yield({key, value})\nend"}},{"html_id":"fetch(key,default):String?-class-method","name":"fetch","doc":"Retrieves a value corresponding to the given *key*. Return the second argument's value\nif the *key* does not exist.","summary":"<p>Retrieves a value corresponding to the given <em>key</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""},{"name":"default","external_name":"default","restriction":""}],"args_string":"(key, default) : String?","args_html":"(key, default) : <a href=\"String.html\">String</a>?","location":{"filename":"src/env.cr","line_number":59,"url":null},"def":{"name":"fetch","args":[{"name":"key","external_name":"key","restriction":""},{"name":"default","external_name":"default","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"fetch(key) do\n  default\nend"}},{"html_id":"fetch(key):String-class-method","name":"fetch","doc":"Retrieves a value corresponding to the given *key*. Raises a `KeyError` exception if the\nkey does not exist.","summary":"<p>Retrieves a value corresponding to the given <em>key</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key) : String","args_html":"(key) : <a href=\"String.html\">String</a>","location":{"filename":"src/env.cr","line_number":51,"url":null},"def":{"name":"fetch","args":[{"name":"key","external_name":"key","restriction":""}],"return_type":"String","visibility":"Public","body":"fetch(key) do\n  raise(KeyError.new(\"Missing ENV key: #{key.inspect}\"))\nend"}},{"html_id":"fetch(key:String,&block:String->String?)-class-method","name":"fetch","doc":"Retrieves a value corresponding to a given *key*. Return the value of the block if\nthe *key* does not exist.","summary":"<p>Retrieves a value corresponding to a given <em>key</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String, &block : String -> String?)","args_html":"(key : <a href=\"String.html\">String</a>, &block : <a href=\"String.html\">String</a> -> <a href=\"String.html\">String</a>?)","location":{"filename":"src/env.cr","line_number":65,"url":null},"def":{"name":"fetch","args":[{"name":"key","external_name":"key","restriction":"String"}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(String -> String | ::Nil)"},"visibility":"Public","body":"if value = Crystal::System::Env.get(key)\n  return value\nelse\n  yield key\nend"}},{"html_id":"has_key?(key:String):Bool-class-method","name":"has_key?","doc":"Returns `true` if the environment variable named *key* exists and `false`\nif it doesn't.","summary":"<p>Returns <code>true</code> if the environment variable named <em>key</em> exists and <code>false</code> if it doesn't.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String) : Bool","args_html":"(key : <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/env.cr","line_number":45,"url":null},"def":{"name":"has_key?","args":[{"name":"key","external_name":"key","restriction":"String"}],"return_type":"Bool","visibility":"Public","body":"Crystal::System::Env.has_key?(key)"}},{"html_id":"inspect(io)-class-method","name":"inspect","doc":"Writes the contents of the environment to *io*.","summary":"<p>Writes the contents of the environment to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""}],"args_string":"(io)","args_html":"(io)","location":{"filename":"src/env.cr","line_number":117,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":""}],"visibility":"Public","body":"io << '{'\nfound_one = false\neach do |key, value|\n  if found_one\n    io << \", \"\n  end\n  key.inspect(io)\n  io << \" => \"\n  value.inspect(io)\n  found_one = true\nend\nio << '}'\n"}},{"html_id":"keys:Array(String)-class-method","name":"keys","doc":"Returns an array of all the environment variable names.","summary":"<p>Returns an array of all the environment variable names.</p>","abstract":false,"location":{"filename":"src/env.cr","line_number":74,"url":null},"def":{"name":"keys","return_type":"Array(String)","visibility":"Public","body":"keys = [] of String\neach do |key, v|\n  keys << key\nend\nkeys\n"}},{"html_id":"pretty_print(pp)-class-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp)","args_html":"(pp)","location":{"filename":"src/env.cr","line_number":130,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"visibility":"Public","body":"pp.list(\"{\", keys.sort, \"}\") do |key|\n  pp.group do\n    key.pretty_print(pp)\n    pp.text(\" =>\")\n    pp.nest do\n      pp.breakable\n      self[key].pretty_print(pp)\n    end\n  end\nend"}},{"html_id":"values:Array(String)-class-method","name":"values","doc":"Returns an array of all the environment variable values.","summary":"<p>Returns an array of all the environment variable values.</p>","abstract":false,"location":{"filename":"src/env.cr","line_number":81,"url":null},"def":{"name":"values","return_type":"Array(String)","visibility":"Public","body":"values = [] of String\neach do |k, value|\n  values << value\nend\nvalues\n"}}]},{"html_id":"Crystal/Errno","path":"Errno.html","kind":"enum","full_name":"Errno","name":"Errno","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/errno.cr","line_number":19,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"NONE","name":"NONE","value":"0"},{"id":"E2BIG","name":"E2BIG","value":"7"},{"id":"EPERM","name":"EPERM","value":"1"},{"id":"ENOENT","name":"ENOENT","value":"2"},{"id":"ESRCH","name":"ESRCH","value":"3"},{"id":"EINTR","name":"EINTR","value":"4"},{"id":"EIO","name":"EIO","value":"5"},{"id":"ENXIO","name":"ENXIO","value":"6"},{"id":"ENOEXEC","name":"ENOEXEC","value":"8"},{"id":"EBADF","name":"EBADF","value":"9"},{"id":"ECHILD","name":"ECHILD","value":"10"},{"id":"EDEADLK","name":"EDEADLK","value":"35"},{"id":"ENOMEM","name":"ENOMEM","value":"12"},{"id":"EACCES","name":"EACCES","value":"13"},{"id":"EFAULT","name":"EFAULT","value":"14"},{"id":"EBUSY","name":"EBUSY","value":"16"},{"id":"EEXIST","name":"EEXIST","value":"17"},{"id":"EXDEV","name":"EXDEV","value":"18"},{"id":"ENODEV","name":"ENODEV","value":"19"},{"id":"ENOTDIR","name":"ENOTDIR","value":"20"},{"id":"EISDIR","name":"EISDIR","value":"21"},{"id":"EINVAL","name":"EINVAL","value":"22"},{"id":"ENFILE","name":"ENFILE","value":"23"},{"id":"EMFILE","name":"EMFILE","value":"24"},{"id":"ENOTTY","name":"ENOTTY","value":"25"},{"id":"ETXTBSY","name":"ETXTBSY","value":"26"},{"id":"EFBIG","name":"EFBIG","value":"27"},{"id":"ENOSPC","name":"ENOSPC","value":"28"},{"id":"ESPIPE","name":"ESPIPE","value":"29"},{"id":"EROFS","name":"EROFS","value":"30"},{"id":"EMLINK","name":"EMLINK","value":"31"},{"id":"EPIPE","name":"EPIPE","value":"32"},{"id":"EDOM","name":"EDOM","value":"33"},{"id":"ERANGE","name":"ERANGE","value":"34"},{"id":"EAGAIN","name":"EAGAIN","value":"11"},{"id":"EWOULDBLOCK","name":"EWOULDBLOCK","value":"11"},{"id":"EINPROGRESS","name":"EINPROGRESS","value":"115"},{"id":"EALREADY","name":"EALREADY","value":"114"},{"id":"ENOTSOCK","name":"ENOTSOCK","value":"88"},{"id":"EDESTADDRREQ","name":"EDESTADDRREQ","value":"89"},{"id":"EMSGSIZE","name":"EMSGSIZE","value":"90"},{"id":"EPROTOTYPE","name":"EPROTOTYPE","value":"91"},{"id":"ENOPROTOOPT","name":"ENOPROTOOPT","value":"92"},{"id":"EPROTONOSUPPORT","name":"EPROTONOSUPPORT","value":"93"},{"id":"EAFNOSUPPORT","name":"EAFNOSUPPORT","value":"97"},{"id":"EADDRINUSE","name":"EADDRINUSE","value":"98"},{"id":"EADDRNOTAVAIL","name":"EADDRNOTAVAIL","value":"99"},{"id":"ENETDOWN","name":"ENETDOWN","value":"100"},{"id":"ENETUNREACH","name":"ENETUNREACH","value":"101"},{"id":"ENETRESET","name":"ENETRESET","value":"102"},{"id":"ECONNABORTED","name":"ECONNABORTED","value":"103"},{"id":"ECONNRESET","name":"ECONNRESET","value":"104"},{"id":"ENOBUFS","name":"ENOBUFS","value":"105"},{"id":"EISCONN","name":"EISCONN","value":"106"},{"id":"ENOTCONN","name":"ENOTCONN","value":"107"},{"id":"ETIMEDOUT","name":"ETIMEDOUT","value":"110"},{"id":"ECONNREFUSED","name":"ECONNREFUSED","value":"111"},{"id":"ELOOP","name":"ELOOP","value":"40"},{"id":"ENAMETOOLONG","name":"ENAMETOOLONG","value":"36"},{"id":"EHOSTUNREACH","name":"EHOSTUNREACH","value":"113"},{"id":"ENOTEMPTY","name":"ENOTEMPTY","value":"39"},{"id":"EDQUOT","name":"EDQUOT","value":"122"},{"id":"ESTALE","name":"ESTALE","value":"116"},{"id":"ENOLCK","name":"ENOLCK","value":"37"},{"id":"ENOSYS","name":"ENOSYS","value":"38"},{"id":"EOVERFLOW","name":"EOVERFLOW","value":"75"},{"id":"ECANCELED","name":"ECANCELED","value":"125"},{"id":"EIDRM","name":"EIDRM","value":"43"},{"id":"ENOMSG","name":"ENOMSG","value":"42"},{"id":"EILSEQ","name":"EILSEQ","value":"84"},{"id":"EBADMSG","name":"EBADMSG","value":"74"},{"id":"EMULTIHOP","name":"EMULTIHOP","value":"72"},{"id":"ENODATA","name":"ENODATA","value":"61"},{"id":"ENOLINK","name":"ENOLINK","value":"67"},{"id":"ENOSR","name":"ENOSR","value":"63"},{"id":"ENOSTR","name":"ENOSTR","value":"60"},{"id":"EPROTO","name":"EPROTO","value":"71"},{"id":"ETIME","name":"ETIME","value":"62"},{"id":"EOPNOTSUPP","name":"EOPNOTSUPP","value":"95"},{"id":"ENOTRECOVERABLE","name":"ENOTRECOVERABLE","value":"131"},{"id":"EOWNERDEAD","name":"EOWNERDEAD","value":"130"}],"doc":"Errno wraps and gives access to libc's errno. This is mostly useful when\ndealing with C libraries.","summary":"<p>Errno wraps and gives access to libc's errno.</p>","class_methods":[{"html_id":"value=(errno:Errno)-class-method","name":"value=","doc":"Sets the value of libc's errno.","summary":"<p>Sets the value of libc's errno.</p>","abstract":false,"args":[{"name":"errno","external_name":"errno","restriction":"Errno"}],"args_string":"(errno : Errno)","args_html":"(errno : <a href=\"Errno.html\">Errno</a>)","location":{"filename":"src/errno.cr","line_number":56,"url":null},"def":{"name":"value=","args":[{"name":"errno","external_name":"errno","restriction":"Errno"}],"visibility":"Public","body":"{% if (flag?(:linux)) || (flag?(:dragonfly)) %}\n      LibC.__errno_location.value = errno.value\n    {% else %}{% if (flag?(:darwin)) || (flag?(:bsd)) %}\n      LibC.__error.value = errno.value\n    {% else %}{% if flag?(:win32) %}\n      ret = LibC._set_errno(errno.value)\n      raise RuntimeError.from_os_error(\"_set_errno\", Errno.new(ret)) unless ret == 0\n    {% end %}{% end %}{% end %}\nerrno\n"}}],"constructors":[{"html_id":"value:self-class-method","name":"value","doc":"Returns the value of libc's errno.","summary":"<p>Returns the value of libc's errno.</p>","abstract":false,"location":{"filename":"src/errno.cr","line_number":43,"url":null},"def":{"name":"value","return_type":"self","visibility":"Public","body":"{% if (flag?(:linux)) || (flag?(:dragonfly)) %}\n      Errno.new LibC.__errno_location.value\n    {% else %}{% if (flag?(:darwin)) || (flag?(:bsd)) %}\n      Errno.new LibC.__error.value\n    {% else %}{% if flag?(:win32) %}\n      ret = LibC._get_errno(out errno)\n      raise RuntimeError.from_os_error(\"_get_errno\", Errno.new(ret)) unless ret == 0\n      Errno.new errno\n    {% end %}{% end %}{% end %}"}}],"instance_methods":[{"html_id":"e2_big?-instance-method","name":"e2_big?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"e2_big?","visibility":"Public","body":"self == E2BIG"}},{"html_id":"eacces?-instance-method","name":"eacces?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eacces?","visibility":"Public","body":"self == EACCES"}},{"html_id":"eaddrinuse?-instance-method","name":"eaddrinuse?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eaddrinuse?","visibility":"Public","body":"self == EADDRINUSE"}},{"html_id":"eaddrnotavail?-instance-method","name":"eaddrnotavail?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eaddrnotavail?","visibility":"Public","body":"self == EADDRNOTAVAIL"}},{"html_id":"eafnosupport?-instance-method","name":"eafnosupport?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eafnosupport?","visibility":"Public","body":"self == EAFNOSUPPORT"}},{"html_id":"eagain?-instance-method","name":"eagain?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eagain?","visibility":"Public","body":"self == EAGAIN"}},{"html_id":"ealready?-instance-method","name":"ealready?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"ealready?","visibility":"Public","body":"self == EALREADY"}},{"html_id":"ebadf?-instance-method","name":"ebadf?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"ebadf?","visibility":"Public","body":"self == EBADF"}},{"html_id":"ebadmsg?-instance-method","name":"ebadmsg?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"ebadmsg?","visibility":"Public","body":"self == EBADMSG"}},{"html_id":"ebusy?-instance-method","name":"ebusy?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"ebusy?","visibility":"Public","body":"self == EBUSY"}},{"html_id":"ecanceled?-instance-method","name":"ecanceled?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"ecanceled?","visibility":"Public","body":"self == ECANCELED"}},{"html_id":"echild?-instance-method","name":"echild?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"echild?","visibility":"Public","body":"self == ECHILD"}},{"html_id":"econnaborted?-instance-method","name":"econnaborted?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"econnaborted?","visibility":"Public","body":"self == ECONNABORTED"}},{"html_id":"econnrefused?-instance-method","name":"econnrefused?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"econnrefused?","visibility":"Public","body":"self == ECONNREFUSED"}},{"html_id":"econnreset?-instance-method","name":"econnreset?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"econnreset?","visibility":"Public","body":"self == ECONNRESET"}},{"html_id":"edeadlk?-instance-method","name":"edeadlk?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"edeadlk?","visibility":"Public","body":"self == EDEADLK"}},{"html_id":"edestaddrreq?-instance-method","name":"edestaddrreq?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"edestaddrreq?","visibility":"Public","body":"self == EDESTADDRREQ"}},{"html_id":"edom?-instance-method","name":"edom?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"edom?","visibility":"Public","body":"self == EDOM"}},{"html_id":"edquot?-instance-method","name":"edquot?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"edquot?","visibility":"Public","body":"self == EDQUOT"}},{"html_id":"eexist?-instance-method","name":"eexist?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eexist?","visibility":"Public","body":"self == EEXIST"}},{"html_id":"efault?-instance-method","name":"efault?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"efault?","visibility":"Public","body":"self == EFAULT"}},{"html_id":"efbig?-instance-method","name":"efbig?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"efbig?","visibility":"Public","body":"self == EFBIG"}},{"html_id":"ehostunreach?-instance-method","name":"ehostunreach?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"ehostunreach?","visibility":"Public","body":"self == EHOSTUNREACH"}},{"html_id":"eidrm?-instance-method","name":"eidrm?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eidrm?","visibility":"Public","body":"self == EIDRM"}},{"html_id":"eilseq?-instance-method","name":"eilseq?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eilseq?","visibility":"Public","body":"self == EILSEQ"}},{"html_id":"einprogress?-instance-method","name":"einprogress?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"einprogress?","visibility":"Public","body":"self == EINPROGRESS"}},{"html_id":"eintr?-instance-method","name":"eintr?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eintr?","visibility":"Public","body":"self == EINTR"}},{"html_id":"einval?-instance-method","name":"einval?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"einval?","visibility":"Public","body":"self == EINVAL"}},{"html_id":"eio?-instance-method","name":"eio?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eio?","visibility":"Public","body":"self == EIO"}},{"html_id":"eisconn?-instance-method","name":"eisconn?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eisconn?","visibility":"Public","body":"self == EISCONN"}},{"html_id":"eisdir?-instance-method","name":"eisdir?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eisdir?","visibility":"Public","body":"self == EISDIR"}},{"html_id":"eloop?-instance-method","name":"eloop?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eloop?","visibility":"Public","body":"self == ELOOP"}},{"html_id":"emfile?-instance-method","name":"emfile?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"emfile?","visibility":"Public","body":"self == EMFILE"}},{"html_id":"emlink?-instance-method","name":"emlink?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"emlink?","visibility":"Public","body":"self == EMLINK"}},{"html_id":"emsgsize?-instance-method","name":"emsgsize?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"emsgsize?","visibility":"Public","body":"self == EMSGSIZE"}},{"html_id":"emultihop?-instance-method","name":"emultihop?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"emultihop?","visibility":"Public","body":"self == EMULTIHOP"}},{"html_id":"enametoolong?-instance-method","name":"enametoolong?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enametoolong?","visibility":"Public","body":"self == ENAMETOOLONG"}},{"html_id":"enetdown?-instance-method","name":"enetdown?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enetdown?","visibility":"Public","body":"self == ENETDOWN"}},{"html_id":"enetreset?-instance-method","name":"enetreset?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enetreset?","visibility":"Public","body":"self == ENETRESET"}},{"html_id":"enetunreach?-instance-method","name":"enetunreach?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enetunreach?","visibility":"Public","body":"self == ENETUNREACH"}},{"html_id":"enfile?-instance-method","name":"enfile?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enfile?","visibility":"Public","body":"self == ENFILE"}},{"html_id":"enobufs?-instance-method","name":"enobufs?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enobufs?","visibility":"Public","body":"self == ENOBUFS"}},{"html_id":"enodata?-instance-method","name":"enodata?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enodata?","visibility":"Public","body":"self == ENODATA"}},{"html_id":"enodev?-instance-method","name":"enodev?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enodev?","visibility":"Public","body":"self == ENODEV"}},{"html_id":"enoent?-instance-method","name":"enoent?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enoent?","visibility":"Public","body":"self == ENOENT"}},{"html_id":"enoexec?-instance-method","name":"enoexec?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enoexec?","visibility":"Public","body":"self == ENOEXEC"}},{"html_id":"enolck?-instance-method","name":"enolck?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enolck?","visibility":"Public","body":"self == ENOLCK"}},{"html_id":"enolink?-instance-method","name":"enolink?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enolink?","visibility":"Public","body":"self == ENOLINK"}},{"html_id":"enomem?-instance-method","name":"enomem?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enomem?","visibility":"Public","body":"self == ENOMEM"}},{"html_id":"enomsg?-instance-method","name":"enomsg?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enomsg?","visibility":"Public","body":"self == ENOMSG"}},{"html_id":"enoprotoopt?-instance-method","name":"enoprotoopt?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enoprotoopt?","visibility":"Public","body":"self == ENOPROTOOPT"}},{"html_id":"enospc?-instance-method","name":"enospc?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enospc?","visibility":"Public","body":"self == ENOSPC"}},{"html_id":"enosr?-instance-method","name":"enosr?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enosr?","visibility":"Public","body":"self == ENOSR"}},{"html_id":"enostr?-instance-method","name":"enostr?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enostr?","visibility":"Public","body":"self == ENOSTR"}},{"html_id":"enosys?-instance-method","name":"enosys?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enosys?","visibility":"Public","body":"self == ENOSYS"}},{"html_id":"enotconn?-instance-method","name":"enotconn?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enotconn?","visibility":"Public","body":"self == ENOTCONN"}},{"html_id":"enotdir?-instance-method","name":"enotdir?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enotdir?","visibility":"Public","body":"self == ENOTDIR"}},{"html_id":"enotempty?-instance-method","name":"enotempty?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enotempty?","visibility":"Public","body":"self == ENOTEMPTY"}},{"html_id":"enotrecoverable?-instance-method","name":"enotrecoverable?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enotrecoverable?","visibility":"Public","body":"self == ENOTRECOVERABLE"}},{"html_id":"enotsock?-instance-method","name":"enotsock?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enotsock?","visibility":"Public","body":"self == ENOTSOCK"}},{"html_id":"enotty?-instance-method","name":"enotty?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enotty?","visibility":"Public","body":"self == ENOTTY"}},{"html_id":"enxio?-instance-method","name":"enxio?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"enxio?","visibility":"Public","body":"self == ENXIO"}},{"html_id":"eopnotsupp?-instance-method","name":"eopnotsupp?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eopnotsupp?","visibility":"Public","body":"self == EOPNOTSUPP"}},{"html_id":"eoverflow?-instance-method","name":"eoverflow?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eoverflow?","visibility":"Public","body":"self == EOVERFLOW"}},{"html_id":"eownerdead?-instance-method","name":"eownerdead?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eownerdead?","visibility":"Public","body":"self == EOWNERDEAD"}},{"html_id":"eperm?-instance-method","name":"eperm?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eperm?","visibility":"Public","body":"self == EPERM"}},{"html_id":"epipe?-instance-method","name":"epipe?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"epipe?","visibility":"Public","body":"self == EPIPE"}},{"html_id":"eproto?-instance-method","name":"eproto?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eproto?","visibility":"Public","body":"self == EPROTO"}},{"html_id":"eprotonosupport?-instance-method","name":"eprotonosupport?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eprotonosupport?","visibility":"Public","body":"self == EPROTONOSUPPORT"}},{"html_id":"eprototype?-instance-method","name":"eprototype?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"eprototype?","visibility":"Public","body":"self == EPROTOTYPE"}},{"html_id":"erange?-instance-method","name":"erange?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"erange?","visibility":"Public","body":"self == ERANGE"}},{"html_id":"erofs?-instance-method","name":"erofs?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"erofs?","visibility":"Public","body":"self == EROFS"}},{"html_id":"espipe?-instance-method","name":"espipe?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"espipe?","visibility":"Public","body":"self == ESPIPE"}},{"html_id":"esrch?-instance-method","name":"esrch?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"esrch?","visibility":"Public","body":"self == ESRCH"}},{"html_id":"estale?-instance-method","name":"estale?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"estale?","visibility":"Public","body":"self == ESTALE"}},{"html_id":"etime?-instance-method","name":"etime?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"etime?","visibility":"Public","body":"self == ETIME"}},{"html_id":"etimedout?-instance-method","name":"etimedout?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"etimedout?","visibility":"Public","body":"self == ETIMEDOUT"}},{"html_id":"etxtbsy?-instance-method","name":"etxtbsy?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"etxtbsy?","visibility":"Public","body":"self == ETXTBSY"}},{"html_id":"ewouldblock?-instance-method","name":"ewouldblock?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"ewouldblock?","visibility":"Public","body":"self == EWOULDBLOCK"}},{"html_id":"exdev?-instance-method","name":"exdev?","abstract":false,"location":{"filename":"src/errno.cr","line_number":22,"url":null},"def":{"name":"exdev?","visibility":"Public","body":"self == EXDEV"}},{"html_id":"message:String-instance-method","name":"message","doc":"Convert an Errno to an error message","summary":"<p>Convert an Errno to an error message</p>","abstract":false,"location":{"filename":"src/errno.cr","line_number":38,"url":null},"def":{"name":"message","return_type":"String","visibility":"Public","body":"String.new(LibC.strerror(value))"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/errno.cr","line_number":20,"url":null},"def":{"name":"none?","visibility":"Public","body":"self == NONE"}}]},{"html_id":"Crystal/Exception","path":"Exception.html","kind":"class","full_name":"Exception","name":"Exception","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/exception.cr","line_number":14,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/ArgumentError","kind":"class","full_name":"ArgumentError","name":"ArgumentError"},{"html_id":"Crystal/Base64/Error","kind":"class","full_name":"Base64::Error","name":"Error"},{"html_id":"Crystal/Channel/ClosedError","kind":"class","full_name":"Channel::ClosedError","name":"ClosedError"},{"html_id":"Crystal/Compress/Deflate/Error","kind":"class","full_name":"Compress::Deflate::Error","name":"Error"},{"html_id":"Crystal/Compress/Gzip/Error","kind":"class","full_name":"Compress::Gzip::Error","name":"Error"},{"html_id":"Crystal/Compress/Zip/Error","kind":"class","full_name":"Compress::Zip::Error","name":"Error"},{"html_id":"Crystal/Compress/Zlib/Error","kind":"class","full_name":"Compress::Zlib::Error","name":"Error"},{"html_id":"Crystal/Crypto/Bcrypt/Error","kind":"class","full_name":"Crypto::Bcrypt::Error","name":"Error"},{"html_id":"Crystal/CSV/Error","kind":"class","full_name":"CSV::Error","name":"Error"},{"html_id":"Crystal/Digest/FinalizedError","kind":"class","full_name":"Digest::FinalizedError","name":"FinalizedError"},{"html_id":"Crystal/DivisionByZeroError","kind":"class","full_name":"DivisionByZeroError","name":"DivisionByZeroError"},{"html_id":"Crystal/Enumerable/EmptyError","kind":"class","full_name":"Enumerable::EmptyError","name":"EmptyError"},{"html_id":"Crystal/File/BadPatternError","kind":"class","full_name":"File::BadPatternError","name":"BadPatternError"},{"html_id":"Crystal/HTTP/FormData/Error","kind":"class","full_name":"HTTP::FormData::Error","name":"Error"},{"html_id":"Crystal/HTTP/Server/ClientError","kind":"class","full_name":"HTTP::Server::ClientError","name":"ClientError"},{"html_id":"Crystal/IndexError","kind":"class","full_name":"IndexError","name":"IndexError"},{"html_id":"Crystal/INI/ParseException","kind":"class","full_name":"INI::ParseException","name":"ParseException"},{"html_id":"Crystal/InvalidBigDecimalException","kind":"class","full_name":"InvalidBigDecimalException","name":"InvalidBigDecimalException"},{"html_id":"Crystal/InvalidByteSequenceError","kind":"class","full_name":"InvalidByteSequenceError","name":"InvalidByteSequenceError"},{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},{"html_id":"Crystal/JSON/Error","kind":"class","full_name":"JSON::Error","name":"Error"},{"html_id":"Crystal/KeyError","kind":"class","full_name":"KeyError","name":"KeyError"},{"html_id":"Crystal/MIME/Error","kind":"class","full_name":"MIME::Error","name":"Error"},{"html_id":"Crystal/MIME/Multipart/Error","kind":"class","full_name":"MIME::Multipart::Error","name":"Error"},{"html_id":"Crystal/NilAssertionError","kind":"class","full_name":"NilAssertionError","name":"NilAssertionError"},{"html_id":"Crystal/NotImplementedError","kind":"class","full_name":"NotImplementedError","name":"NotImplementedError"},{"html_id":"Crystal/OAuth2/Error","kind":"class","full_name":"OAuth2::Error","name":"Error"},{"html_id":"Crystal/OAuth/Error","kind":"class","full_name":"OAuth::Error","name":"Error"},{"html_id":"Crystal/OpenSSL/Error","kind":"class","full_name":"OpenSSL::Error","name":"Error"},{"html_id":"Crystal/OptionParser/Exception","kind":"class","full_name":"OptionParser::Exception","name":"Exception"},{"html_id":"Crystal/OverflowError","kind":"class","full_name":"OverflowError","name":"OverflowError"},{"html_id":"Crystal/Path/Error","kind":"class","full_name":"Path::Error","name":"Error"},{"html_id":"Crystal/RuntimeError","kind":"class","full_name":"RuntimeError","name":"RuntimeError"},{"html_id":"Crystal/System/Group/NotFoundError","kind":"class","full_name":"System::Group::NotFoundError","name":"NotFoundError"},{"html_id":"Crystal/System/User/NotFoundError","kind":"class","full_name":"System::User::NotFoundError","name":"NotFoundError"},{"html_id":"Crystal/Time/FloatingTimeConversionError","kind":"class","full_name":"Time::FloatingTimeConversionError","name":"FloatingTimeConversionError"},{"html_id":"Crystal/Time/Format/Error","kind":"class","full_name":"Time::Format::Error","name":"Error"},{"html_id":"Crystal/Time/Location/InvalidLocationNameError","kind":"class","full_name":"Time::Location::InvalidLocationNameError","name":"InvalidLocationNameError"},{"html_id":"Crystal/Time/Location/InvalidTimezoneOffsetError","kind":"class","full_name":"Time::Location::InvalidTimezoneOffsetError","name":"InvalidTimezoneOffsetError"},{"html_id":"Crystal/Time/Location/InvalidTZDataError","kind":"class","full_name":"Time::Location::InvalidTZDataError","name":"InvalidTZDataError"},{"html_id":"Crystal/TypeCastError","kind":"class","full_name":"TypeCastError","name":"TypeCastError"},{"html_id":"Crystal/URI/Error","kind":"class","full_name":"URI::Error","name":"Error"},{"html_id":"Crystal/UUID/Error","kind":"class","full_name":"UUID::Error","name":"Error"},{"html_id":"Crystal/XML/Error","kind":"class","full_name":"XML::Error","name":"Error"},{"html_id":"Crystal/YAML/Error","kind":"class","full_name":"YAML::Error","name":"Error"}],"doc":"Represents errors that occur during application execution.\n\nException and its descendants are used to communicate between raise and\nrescue statements in `begin ... end` blocks.\nException objects carry information about the exception – its type (the\nexception’s class name), an optional descriptive string, and\noptional traceback information.\nException subclasses may add additional information.","summary":"<p>Represents errors that occur during application execution.</p>","constructors":[{"html_id":"new(message:String?=nil,cause:Exception?=nil)-class-method","name":"new","abstract":false,"args":[{"name":"message","default_value":"nil","external_name":"message","restriction":"String | ::Nil"},{"name":"cause","default_value":"nil","external_name":"cause","restriction":"Exception | ::Nil"}],"args_string":"(message : String? = nil, cause : Exception? = nil)","args_html":"(message : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>, cause : <a href=\"Exception.html\">Exception</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/exception.cr","line_number":24,"url":null},"def":{"name":"new","args":[{"name":"message","default_value":"nil","external_name":"message","restriction":"String | ::Nil"},{"name":"cause","default_value":"nil","external_name":"cause","restriction":"Exception | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(message, cause)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"backtrace:Array(String)-instance-method","name":"backtrace","doc":"Returns any backtrace associated with the exception.\nThe backtrace is an array of strings, each containing\n“0xAddress: Function at File Line Column”.","summary":"<p>Returns any backtrace associated with the exception.</p>","abstract":false,"location":{"filename":"src/exception.cr","line_number":30,"url":null},"def":{"name":"backtrace","return_type":"Array(String)","visibility":"Public","body":"self.backtrace?.not_nil!"}},{"html_id":"backtrace?-instance-method","name":"backtrace?","doc":"Returns any backtrace associated with the exception if the call stack exists.\nThe backtrace is an array of strings, each containing\n“0xAddress: Function at File Line Column”.","summary":"<p>Returns any backtrace associated with the exception if the call stack exists.</p>","abstract":false,"location":{"filename":"src/exception.cr","line_number":37,"url":null},"def":{"name":"backtrace?","visibility":"Public","body":"@callstack.try(&.printable_backtrace)"}},{"html_id":"cause:Exception?-instance-method","name":"cause","doc":"Returns the previous exception at the time this exception was raised.\nThis is useful for wrapping exceptions and retaining the original\nexception information.","summary":"<p>Returns the previous exception at the time this exception was raised.</p>","abstract":false,"location":{"filename":"src/exception.cr","line_number":19,"url":null},"def":{"name":"cause","return_type":"Exception | ::Nil","visibility":"Public","body":"@cause"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/exception.cr","line_number":45,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"((((io << \"#<\") << self.class.name) << ':') << message) << '>'"}},{"html_id":"inspect_with_backtrace(io:IO):Nil-instance-method","name":"inspect_with_backtrace","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/exception.cr","line_number":55,"url":null},"def":{"name":"inspect_with_backtrace","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"(((io << message) << \" (\") << self.class) << \")\\n\"\nbacktrace?.try(&.each do |frame|\n  io.print(\"  from \")\n  io.puts(frame)\nend)\nif cause = @cause\n  io << \"Caused by: \"\n  cause.inspect_with_backtrace(io)\nend\nio.flush\n"}},{"html_id":"inspect_with_backtrace:String-instance-method","name":"inspect_with_backtrace","abstract":false,"location":{"filename":"src/exception.cr","line_number":49,"url":null},"def":{"name":"inspect_with_backtrace","return_type":"String","visibility":"Public","body":"String.build do |io|\n  inspect_with_backtrace(io)\nend"}},{"html_id":"message:String?-instance-method","name":"message","abstract":false,"location":{"filename":"src/exception.cr","line_number":15,"url":null},"def":{"name":"message","return_type":"String | ::Nil","visibility":"Public","body":"@message"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a short String representation of this object\nwhich includes its class name and its object address.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).to_s # => #<Person:0x10a199f20>\n```","summary":"<p>Appends a short String representation of this object which includes its class name and its object address.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/exception.cr","line_number":41,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << message"}}]},{"html_id":"Crystal/Experimental","path":"Experimental.html","kind":"annotation","full_name":"Experimental","name":"Experimental","abstract":false,"locations":[{"filename":"src/annotations.cr","line_number":65,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"This annotation marks methods, classes, constants, and macros as experimental.\n\nExperimental features are subject to change or be removed despite the\n[https://semver.org/](https://semver.org/) guarantees.\n\n```\n@[Experimental(\"Join discussion about this topic at ...\")]\ndef foo\nend\n```","summary":"<p>This annotation marks methods, classes, constants, and macros as experimental.</p>"},{"html_id":"Crystal/Fiber","path":"Fiber.html","kind":"class","full_name":"Fiber","name":"Fiber","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/fiber.cr","line_number":46,"url":null},{"filename":"src/fiber/context.cr","line_number":1,"url":null},{"filename":"src/fiber/context/x86_64-sysv.cr","line_number":3,"url":null},{"filename":"src/fiber/stack_pool.cr","line_number":3,"url":null},{"filename":"src/log/metadata.cr","line_number":221,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"A `Fiber` is a light-weight execution unit managed by the Crystal runtime.\n\nIt is conceptually similar to an operating system thread but with less\noverhead and completely internal to the Crystal process. The runtime includes\na scheduler which schedules execution of fibers.\n\nA `Fiber` has a stack size of `8 MiB` which is usually also assigned\nto an operating system thread. But only `4KiB` are actually allocated at first\nso the memory footprint is very small.\n\nCommunication between fibers is usually passed through `Channel`.\n\n## Cooperative\n\nFibers are cooperative. That means execution can only be drawn from a fiber\nwhen it offers it. It can't be interrupted in its execution at random.\nIn order to make concurrency work, fibers must make sure to occasionally\nprovide hooks for the scheduler to swap in other fibers.\nIO operations like reading from a file descriptor are natural implementations\nfor this and the developer does not need to take further action on that. When\nIO access can't be served immediately by a buffer, the fiber will\nautomatically wait and yield execution. When IO is ready it's going to be\nresumed through the event loop.\n\nWhen a computation-intensive task has none or only rare IO operations, a fiber\nshould explicitly offer to yield execution from time to time using\n`Fiber.yield` to break up tight loops. The frequency of this call depends on\nthe application and concurrency model.\n\n## Event loop\n\nThe event loop is responsible for keeping track of sleeping fibers waiting for\nnotifications that IO is ready or a timeout reached. When a fiber can be woken,\nthe event loop enqueues it in the scheduler","summary":"<p>A <code><a href=\"Fiber.html\">Fiber</a></code> is a light-weight execution unit managed by the Crystal runtime.</p>","class_methods":[{"html_id":"cancel_timeout:Nil-class-method","name":"cancel_timeout","abstract":false,"location":{"filename":"src/fiber.cr","line_number":254,"url":null},"def":{"name":"cancel_timeout","return_type":"Nil","visibility":"Public","body":"Crystal::Scheduler.current_fiber.cancel_timeout"}},{"html_id":"timeout(timeout:Time::Span?,select_action:Channel::TimeoutAction?=nil):Nil-class-method","name":"timeout","doc":"The current fiber will resume after a period of time.\nThe timeout can be cancelled with `cancel_timeout`","summary":"<p>The current fiber will resume after a period of time.</p>","abstract":false,"args":[{"name":"timeout","external_name":"timeout","restriction":"Time::Span | ::Nil"},{"name":"select_action","default_value":"nil","external_name":"select_action","restriction":"Channel::TimeoutAction | ::Nil"}],"args_string":"(timeout : Time::Span?, select_action : Channel::TimeoutAction? = nil) : Nil","args_html":"(timeout : <a href=\"Time/Span.html\">Time::Span</a>?, select_action : Channel::TimeoutAction? = <span class=\"n\">nil</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/fiber.cr","line_number":250,"url":null},"def":{"name":"timeout","args":[{"name":"timeout","external_name":"timeout","restriction":"Time::Span | ::Nil"},{"name":"select_action","default_value":"nil","external_name":"select_action","restriction":"Channel::TimeoutAction | ::Nil"}],"return_type":"Nil","visibility":"Public","body":"Crystal::Scheduler.current_fiber.timeout(timeout, select_action)"}},{"html_id":"yield:Nil-class-method","name":"yield","doc":"Yields to the scheduler and allows it to swap execution to other\nwaiting fibers.\n\nThis is equivalent to `sleep 0.seconds`. It gives the scheduler an option\nto interrupt the current fiber's execution. If no other fibers are ready to\nbe resumed, it immediately resumes the current fiber.\n\nThis method is particularly useful to break up tight loops which are only\ncomputation intensive and don't offer natural opportunities for swapping\nfibers as with IO operations.\n\n```\ncounter = 0\nspawn name: \"status\" do\n  loop do\n    puts \"Status: #{counter}\"\n    sleep(2.seconds)\n  end\nend\n\nwhile counter < Int32::MAX\n  counter += 1\n  if counter % 1_000_000 == 0\n    # Without this, there would never be an opportunity to resume the status fiber\n    Fiber.yield\n  end\nend\n```","summary":"<p>Yields to the scheduler and allows it to swap execution to other waiting fibers.</p>","abstract":false,"location":{"filename":"src/fiber.cr","line_number":286,"url":null},"def":{"name":"yield","return_type":"Nil","visibility":"Public","body":"Crystal::Scheduler.yield"}}],"constructors":[{"html_id":"current:Fiber-class-method","name":"current","doc":"Returns the current fiber.","summary":"<p>Returns the current fiber.</p>","abstract":false,"location":{"filename":"src/fiber.cr","line_number":177,"url":null},"def":{"name":"current","return_type":"Fiber","visibility":"Public","body":"Crystal::Scheduler.current_fiber"}},{"html_id":"new(name:String?=nil,&proc:->)-class-method","name":"new","doc":"Creates a new `Fiber` instance.\n\nWhen the fiber is executed, it runs *proc* in its context.\n\n*name* is an optional and used only as an internal reference.","summary":"<p>Creates a new <code><a href=\"Fiber.html\">Fiber</a></code> instance.</p>","abstract":false,"args":[{"name":"name","default_value":"nil","external_name":"name","restriction":"String | ::Nil"}],"args_string":"(name : String? = nil, &proc :  -> )","args_html":"(name : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>, &proc :  -> )","location":{"filename":"src/fiber.cr","line_number":88,"url":null},"def":{"name":"new","args":[{"name":"name","default_value":"nil","external_name":"name","restriction":"String | ::Nil"}],"yields":0,"block_arg":{"name":"proc","external_name":"proc","restriction":"(->)"},"visibility":"Public","body":"_ = allocate\n_.initialize(name, &proc) do\n  yield\nend\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"dead?:Bool-instance-method","name":"dead?","doc":"The fiber's proc has terminated, and the fiber is now considered dead. The\nfiber is impossible to resume, ever.","summary":"<p>The fiber's proc has terminated, and the fiber is now considered dead.</p>","abstract":false,"location":{"filename":"src/fiber.cr","line_number":195,"url":null},"def":{"name":"dead?","return_type":"Bool","visibility":"Public","body":"@alive == false"}},{"html_id":"enqueue:Nil-instance-method","name":"enqueue","doc":"Adds this fiber to the scheduler's runnables queue for the current thread.\n\nThis signals to the scheduler that the fiber is eligible for being resumed\nthe next time it has the opportunity to reschedule to an other fiber. There\nare no guarantees when that will happen.","summary":"<p>Adds this fiber to the scheduler's runnables queue for the current thread.</p>","abstract":false,"location":{"filename":"src/fiber.cr","line_number":222,"url":null},"def":{"name":"enqueue","return_type":"Nil","visibility":"Public","body":"Crystal::Scheduler.enqueue(self)"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/fiber.cr","line_number":299,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"name:String?-instance-method","name":"name","doc":"The name of the fiber, used as internal reference.","summary":"<p>The name of the fiber, used as internal reference.</p>","abstract":false,"location":{"filename":"src/fiber.cr","line_number":62,"url":null},"def":{"name":"name","return_type":"String | ::Nil","visibility":"Public","body":"@name"}},{"html_id":"name=(name:String?)-instance-method","name":"name=","doc":"The name of the fiber, used as internal reference.","summary":"<p>The name of the fiber, used as internal reference.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String | ::Nil"}],"args_string":"(name : String?)","args_html":"(name : <a href=\"String.html\">String</a>?)","location":{"filename":"src/fiber.cr","line_number":62,"url":null},"def":{"name":"name=","args":[{"name":"name","external_name":"name","restriction":"String | ::Nil"}],"visibility":"Public","body":"@name = name"}},{"html_id":"resumable?:Bool-instance-method","name":"resumable?","doc":"The fiber's proc is currently not running and fully saved its context. The\nfiber can be resumed safely.","summary":"<p>The fiber's proc is currently not running and fully saved its context.</p>","abstract":false,"location":{"filename":"src/fiber.cr","line_number":189,"url":null},"def":{"name":"resumable?","return_type":"Bool","visibility":"Public","body":"@context.resumable == 1"}},{"html_id":"resume:Nil-instance-method","name":"resume","doc":"Immediately resumes execution of this fiber.\n\nThere are no provisions for resuming the current fiber (where this\nmethod is called). Unless it is explicitly added for rescheduling (for\nexample using `#enqueue`) the current fiber won't ever reach any instructions\nafter the call to this method.\n\n```\nfiber = Fiber.new do\n  puts \"in fiber\"\nend\nfiber.resume\nputs \"never reached\"\n```","summary":"<p>Immediately resumes execution of this fiber.</p>","abstract":false,"location":{"filename":"src/fiber.cr","line_number":213,"url":null},"def":{"name":"resume","return_type":"Nil","visibility":"Public","body":"Crystal::Scheduler.resume(self)"}},{"html_id":"running?:Bool-instance-method","name":"running?","doc":"The fiber's proc is currently running or didn't fully save its context. The\nfiber can't be resumed.","summary":"<p>The fiber's proc is currently running or didn't fully save its context.</p>","abstract":false,"location":{"filename":"src/fiber.cr","line_number":183,"url":null},"def":{"name":"running?","return_type":"Bool","visibility":"Public","body":"@context.resumable == 0"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a short String representation of this object\nwhich includes its class name and its object address.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).to_s # => #<Person:0x10a199f20>\n```","summary":"<p>Appends a short String representation of this object which includes its class name and its object address.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/fiber.cr","line_number":290,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"((io << \"#<\") << self.class.name) << \":0x\"\nobject_id.to_s(io, 16)\nif name = @name\n  (io << \": \") << name\nend\nio << '>'\n"}}]},{"html_id":"Crystal/File","path":"File.html","kind":"class","full_name":"File","name":"File","abstract":false,"superclass":{"html_id":"Crystal/IO/FileDescriptor","kind":"class","full_name":"IO::FileDescriptor","name":"FileDescriptor"},"ancestors":[{"html_id":"Crystal/Crystal/System/File","kind":"module","full_name":"Crystal::System::File","name":"File"},{"html_id":"Crystal/IO/FileDescriptor","kind":"class","full_name":"IO::FileDescriptor","name":"FileDescriptor"},{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"Crystal/Crystal/System/FileDescriptor","kind":"module","full_name":"Crystal::System::FileDescriptor","name":"FileDescriptor"},{"html_id":"Crystal/IO/Evented","kind":"module","full_name":"IO::Evented","name":"Evented"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/file.cr","line_number":1,"url":null},{"filename":"src/file.cr","line_number":50,"url":null},{"filename":"src/file/error.cr","line_number":1,"url":null},{"filename":"src/file/info.cr","line_number":1,"url":null},{"filename":"src/file/tempfile.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"NULL","name":"NULL","value":"{% if flag?(:win32) %}\n           \"NUL\"\n         {% else %}\n           \"/dev/null\"\n         {% end %}","doc":"The name of the null device on the host platform. `/dev/null` on UNIX and `NUL`\non win32.\n\nWhen this device is opened using `File.open`, read operations will always\nreturn EOF, and any data written will be immediately discarded.\n\n```\nFile.open(File::NULL, \"w\") do |file|\n  file.puts \"this is discarded\"\nend\n```","summary":"<p>The name of the null device on the host platform.</p>"},{"id":"SEPARATOR","name":"SEPARATOR","value":"'/'","doc":"The file/directory separator character. `'/'` on all platforms.","summary":"<p>The file/directory separator character.</p>"},{"id":"SEPARATOR_STRING","name":"SEPARATOR_STRING","value":"\"/\"","doc":"The file/directory separator string. `\"/\"` on all platforms.","summary":"<p>The file/directory separator string.</p>"}],"included_modules":[{"html_id":"Crystal/Crystal/System/File","kind":"module","full_name":"Crystal::System::File","name":"File"}],"doc":"A `File` instance represents a file entry in the local file system and allows using it as an `IO`.\n\n```\nfile = File.new(\"path/to/file\")\ncontent = file.gets_to_end\nfile.close\n\n# Implicit close with `open`\ncontent = File.open(\"path/to/file\") do |file|\n  file.gets_to_end\nend\n\n# Shortcut:\ncontent = File.read(\"path/to/file\")\n```\n\n## Temporary Files\n\nEvery tempfile is operated as a `File`, including initializing, reading and writing.\n\n```\ntempfile = File.tempfile(\"foo\")\n\nFile.size(tempfile.path)                   # => 6\nFile.info(tempfile.path).modification_time # => 2015-10-20 13:11:12 UTC\nFile.exists?(tempfile.path)                # => true\nFile.read_lines(tempfile.path)             # => [\"foobar\"]\n```\n\nFiles created from `tempfile` are stored in a directory that handles\ntemporary files (`Dir.tempdir`):\n\n```\nFile.tempfile(\"foo\").path # => \"/tmp/foo.ulBCPS\"\n```\n\nIt is encouraged to delete a tempfile after using it, which\nensures they are not left behind in your filesystem until garbage collected.\n\n```\ntempfile = File.tempfile(\"foo\")\ntempfile.delete\n```","summary":"<p>A <code><a href=\"File.html\">File</a></code> instance represents a file entry in the local file system and allows using it as an <code><a href=\"IO.html\">IO</a></code>.</p>","class_methods":[{"html_id":"basename(path:Path|String,suffix:String):String-class-method","name":"basename","doc":"Returns the last component of the given *path*.\n\nIf *suffix* is present at the end of *path*, it is removed.\n\n```\nFile.basename(\"/foo/bar/file.cr\", \".cr\") # => \"file\"\n```","summary":"<p>Returns the last component of the given <em>path</em>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"suffix","external_name":"suffix","restriction":"String"}],"args_string":"(path : Path | String, suffix : String) : String","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, suffix : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/file.cr","line_number":299,"url":null},"def":{"name":"basename","args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"suffix","external_name":"suffix","restriction":"String"}],"return_type":"String","visibility":"Public","body":"(Path.new(path)).basename(suffix.check_no_null_byte)"}},{"html_id":"basename(path:Path|String):String-class-method","name":"basename","doc":"Returns the last component of the given *path*.\n\n```\nFile.basename(\"/foo/bar/file.cr\") # => \"file.cr\"\n```","summary":"<p>Returns the last component of the given <em>path</em>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : String","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/file.cr","line_number":288,"url":null},"def":{"name":"basename","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"String","visibility":"Public","body":"(Path.new(path)).basename"}},{"html_id":"chmod(path:Path|String,permissions:Int|Permissions):Nil-class-method","name":"chmod","doc":"Changes the permissions of the specified file.\n\nSymlinks are dereferenced, so that only the permissions of the symlink\ndestination are changed, never the permissions of the symlink itself.\n\n```\nFile.chmod(\"foo\", 0o755)\nFile.info(\"foo\").permissions.value # => 0o755\n\nFile.chmod(\"foo\", 0o700)\nFile.info(\"foo\").permissions.value # => 0o700\n```","summary":"<p>Changes the permissions of the specified file.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"permissions","external_name":"permissions","restriction":"Int | Permissions"}],"args_string":"(path : Path | String, permissions : Int | Permissions) : Nil","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, permissions : <a href=\"Int.html\">Int</a> | <a href=\"File/Permissions.html\">Permissions</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file.cr","line_number":334,"url":null},"def":{"name":"chmod","args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"permissions","external_name":"permissions","restriction":"Int | Permissions"}],"return_type":"Nil","visibility":"Public","body":"Crystal::System::File.chmod(path.to_s, permissions)"}},{"html_id":"chown(path:Path|String,uid:Int=-1,gid:Int=-1,follow_symlinks=false):Nil-class-method","name":"chown","doc":"Changes the owner of the specified file.\n\n```\nFile.chown(\"/foo/bar/baz.cr\", 1001, 100)\nFile.chown(\"/foo/bar\", gid: 100)\n```\n\nUnless *follow_symlinks* is set to `true`, then the owner symlink itself will\nbe changed, otherwise the owner of the symlink destination file will be\nchanged. For example, assuming symlinks as `foo -> bar -> baz`:\n\n```\nFile.chown(\"foo\", gid: 100)                        # changes foo's gid\nFile.chown(\"foo\", gid: 100, follow_symlinks: true) # changes baz's gid\n```","summary":"<p>Changes the owner of the specified file.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"uid","default_value":"-1","external_name":"uid","restriction":"Int"},{"name":"gid","default_value":"-1","external_name":"gid","restriction":"Int"},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"args_string":"(path : Path | String, uid : Int = -1, gid : Int = -1, follow_symlinks = false) : Nil","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, uid : <a href=\"Int.html\">Int</a> = <span class=\"n\">-1</span>, gid : <a href=\"Int.html\">Int</a> = <span class=\"n\">-1</span>, follow_symlinks = <span class=\"n\">false</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file.cr","line_number":318,"url":null},"def":{"name":"chown","args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"uid","default_value":"-1","external_name":"uid","restriction":"Int"},{"name":"gid","default_value":"-1","external_name":"gid","restriction":"Int"},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"return_type":"Nil","visibility":"Public","body":"Crystal::System::File.chown(path.to_s, uid, gid, follow_symlinks)"}},{"html_id":"copy(src:String|Path,dst:String|Path):Nil-class-method","name":"copy","doc":"Copies the file *src* to the file *dst*.\nPermission bits are copied too.\n\n```\nFile.touch(\"afile\")\nFile.chmod(\"afile\", 0o600)\nFile.copy(\"afile\", \"afile_copy\")\nFile.info(\"afile_copy\").permissions.value # => 0o600\n```","summary":"<p>Copies the file <em>src</em> to the file <em>dst</em>.</p>","abstract":false,"args":[{"name":"src","external_name":"src","restriction":"String | Path"},{"name":"dst","external_name":"dst","restriction":"String | Path"}],"args_string":"(src : String | Path, dst : String | Path) : Nil","args_html":"(src : <a href=\"String.html\">String</a> | <a href=\"Path.html\">Path</a>, dst : <a href=\"String.html\">String</a> | <a href=\"Path.html\">Path</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file.cr","line_number":731,"url":null},"def":{"name":"copy","args":[{"name":"src","external_name":"src","restriction":"String | Path"},{"name":"dst","external_name":"dst","restriction":"String | Path"}],"return_type":"Nil","visibility":"Public","body":"open(src) do |s|\n  open(dst, \"wb\") do |d|\n    IO.copy(s, d)\n  end\n  chmod(dst, s.info.permissions)\nend"}},{"html_id":"delete(path:Path|String):Nil-class-method","name":"delete","doc":"Deletes the file at *path*. Deleting non-existent file will raise an exception.\n\n```\nFile.write(\"foo\", \"\")\nFile.delete(\"./foo\")\nFile.delete(\"./bar\") # raises File::NotFoundError (No such file or directory)\n```","summary":"<p>Deletes the file at <em>path</em>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Nil","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file.cr","line_number":345,"url":null},"def":{"name":"delete","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"Crystal::System::File.delete(path.to_s)"}},{"html_id":"directory?(path:Path|String):Bool-class-method","name":"directory?","doc":"Returns `true` if the given *path* exists and is a directory.\n\n```\nFile.write(\"foo\", \"\")\nDir.mkdir(\"dir2\")\nFile.directory?(\"foo\")    # => false\nFile.directory?(\"dir2\")   # => true\nFile.directory?(\"foobar\") # => false\n```","summary":"<p>Returns <code>true</code> if the given <em>path</em> exists and is a directory.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Bool","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/file.cr","line_number":270,"url":null},"def":{"name":"directory?","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Bool","visibility":"Public","body":"Dir.exists?(path)"}},{"html_id":"dirname(path:Path|String):String-class-method","name":"dirname","doc":"Returns all components of the given *path* except the last one.\n\n```\nFile.dirname(\"/foo/bar/file.cr\") # => \"/foo/bar\"\n```","summary":"<p>Returns all components of the given <em>path</em> except the last one.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : String","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/file.cr","line_number":279,"url":null},"def":{"name":"dirname","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"String","visibility":"Public","body":"(Path.new(path)).dirname"}},{"html_id":"each_line(filename:Path|String,encoding=nil,invalid=nil,chomp=true,&)-class-method","name":"each_line","doc":"Yields each line in *filename* to the given block.\n\n```\nFile.write(\"foobar\", \"foo\\nbar\")\n\narray = [] of String\nFile.each_line(\"foobar\") do |line|\n  array << line\nend\narray # => [\"foo\", \"bar\"]\n```","summary":"<p>Yields each line in <em>filename</em> to the given block.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""},{"name":"chomp","default_value":"true","external_name":"chomp","restriction":""}],"args_string":"(filename : Path | String, encoding = nil, invalid = nil, chomp = true, &)","args_html":"(filename : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>, chomp = <span class=\"n\">true</span>, &)","location":{"filename":"src/file.cr","line_number":670,"url":null},"def":{"name":"each_line","args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""},{"name":"chomp","default_value":"true","external_name":"chomp","restriction":""}],"yields":1,"visibility":"Public","body":"open(filename, \"r\", encoding: encoding, invalid: invalid) do |file|\n  file.each_line(chomp: chomp) do |line|\n    yield line\n  end\nend"}},{"html_id":"empty?(path:Path|String):Bool-class-method","name":"empty?","doc":"Returns `true` if the file at *path* is empty, otherwise returns `false`.\nRaises `File::NotFoundError` if the file at *path* does not exist.\n\n```\nFile.write(\"foo\", \"\")\nFile.empty?(\"foo\") # => true\nFile.write(\"foo\", \"foo\")\nFile.empty?(\"foo\") # => false\n```","summary":"<p>Returns <code>true</code> if the file at <em>path</em> is empty, otherwise returns <code>false</code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Bool","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/file.cr","line_number":210,"url":null},"def":{"name":"empty?","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Bool","visibility":"Public","body":"(size(path)) == 0"}},{"html_id":"executable?(path:Path|String):Bool-class-method","name":"executable?","doc":"Returns `true` if *path* is executable by the real user id of this process else returns `false`.\n\n```\nFile.write(\"foo\", \"foo\")\nFile.executable?(\"foo\") # => false\n```","summary":"<p>Returns <code>true</code> if <em>path</em> is executable by the real user id of this process else returns <code>false</code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Bool","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/file.cr","line_number":240,"url":null},"def":{"name":"executable?","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Bool","visibility":"Public","body":"Crystal::System::File.executable?(path.to_s)"}},{"html_id":"exists?(path:Path|String):Bool-class-method","name":"exists?","doc":"Returns `true` if *path* exists else returns `false`\n\n```\nFile.delete(\"foo\") if File.exists?(\"foo\")\nFile.exists?(\"foo\") # => false\nFile.write(\"foo\", \"foo\")\nFile.exists?(\"foo\") # => true\n```","summary":"<p>Returns <code>true</code> if <em>path</em> exists else returns <code>false</code></p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Bool","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/file.cr","line_number":161,"url":null},"def":{"name":"exists?","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Bool","visibility":"Public","body":"Crystal::System::File.exists?(path.to_s)"}},{"html_id":"expand_path(path:Path|String,dir=nil,*,home=false):String-class-method","name":"expand_path","doc":"Converts *path* to an absolute path. Relative paths are\nreferenced from the current working directory of the process unless\n*dir* is given, in which case it will be used as the starting point.\n\"~\" is expanded to the value passed to *home*.\nIf it is `false` (default), home is not expanded.\nIf `true`, it is expanded to the user's home directory (`Path.home`).\n\n```\nFile.expand_path(\"foo\")                 # => \"/home/.../foo\"\nFile.expand_path(\"~/foo\", home: \"/bar\") # => \"/bar/foo\"\nFile.expand_path(\"baz\", \"/foo/bar\")     # => \"/foo/bar/baz\"\n```","summary":"<p>Converts <em>path</em> to an absolute path.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"dir","default_value":"nil","external_name":"dir","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"home","default_value":"false","external_name":"home","restriction":""}],"args_string":"(path : Path | String, dir = nil, *, home = false) : String","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, dir = <span class=\"n\">nil</span>, *, home = <span class=\"n\">false</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/file.cr","line_number":370,"url":null},"def":{"name":"expand_path","args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"dir","default_value":"nil","external_name":"dir","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"home","default_value":"false","external_name":"home","restriction":""}],"splat_index":2,"return_type":"String","visibility":"Public","body":"((Path.new(path)).expand(dir || Dir.current, home: home)).to_s"}},{"html_id":"extname(filename:Path|String):String-class-method","name":"extname","doc":"Returns *filename*'s extension, or an empty string if it has no extension.\n\n```\nFile.extname(\"foo.cr\") # => \".cr\"\n```","summary":"<p>Returns <em>filename</em>'s extension, or an empty string if it has no extension.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"Path | String"}],"args_string":"(filename : Path | String) : String","args_html":"(filename : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/file.cr","line_number":354,"url":null},"def":{"name":"extname","args":[{"name":"filename","external_name":"filename","restriction":"Path | String"}],"return_type":"String","visibility":"Public","body":"(Path.new(filename)).extension"}},{"html_id":"file?(path:Path|String):Bool-class-method","name":"file?","doc":"Returns `true` if given *path* exists and is a file.\n\n```\nFile.write(\"foo\", \"\")\nDir.mkdir(\"dir1\")\nFile.file?(\"foo\")    # => true\nFile.file?(\"dir1\")   # => false\nFile.file?(\"foobar\") # => false\n```","summary":"<p>Returns <code>true</code> if given <em>path</em> exists and is a file.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Bool","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/file.cr","line_number":253,"url":null},"def":{"name":"file?","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Bool","visibility":"Public","body":"if info = info?(path)\n  info.type.file?\nelse\n  false\nend"}},{"html_id":"info(path:Path|String,follow_symlinks=true):Info-class-method","name":"info","doc":"Returns a `File::Info` object for the file given by *path* or raises\n`File::Error` in case of an error.\n\nIf *follow_symlinks* is set (the default), symbolic links are followed. Otherwise,\nsymbolic links return information on the symlink itself.\n\n```\nFile.write(\"foo\", \"foo\")\nFile.info(\"foo\").size              # => 3\nFile.info(\"foo\").modification_time # => 2015-09-23 06:24:19 UTC\n\nFile.symlink(\"foo\", \"bar\")\nFile.info(\"bar\", follow_symlinks: false).type.symlink? # => true\n```","summary":"<p>Returns a <code><a href=\"File/Info.html\">File::Info</a></code> object for the file given by <em>path</em> or raises <code><a href=\"File/Error.html\">File::Error</a></code> in case of an error.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"follow_symlinks","default_value":"true","external_name":"follow_symlinks","restriction":""}],"args_string":"(path : Path | String, follow_symlinks = true) : Info","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, follow_symlinks = <span class=\"n\">true</span>) : <a href=\"File/Info.html\">Info</a>","location":{"filename":"src/file.cr","line_number":149,"url":null},"def":{"name":"info","args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"follow_symlinks","default_value":"true","external_name":"follow_symlinks","restriction":""}],"return_type":"Info","visibility":"Public","body":"Crystal::System::File.info(path.to_s, follow_symlinks)"}},{"html_id":"info?(path:Path|String,follow_symlinks=true):Info?-class-method","name":"info?","doc":"Returns a `File::Info` object for the file given by *path* or returns `nil`\nif the file does not exist.\n\nIf *follow_symlinks* is set (the default), symbolic links are followed. Otherwise,\nsymbolic links return information on the symlink itself.\n\n```\nFile.write(\"foo\", \"foo\")\nFile.info?(\"foo\").try(&.size) # => 3\nFile.info?(\"non_existent\")    # => nil\n\nFile.symlink(\"foo\", \"bar\")\nFile.info?(\"bar\", follow_symlinks: false).try(&.type.symlink?) # => true\n```","summary":"<p>Returns a <code><a href=\"File/Info.html\">File::Info</a></code> object for the file given by <em>path</em> or returns <code>nil</code> if the file does not exist.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"follow_symlinks","default_value":"true","external_name":"follow_symlinks","restriction":""}],"args_string":"(path : Path | String, follow_symlinks = true) : Info?","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, follow_symlinks = <span class=\"n\">true</span>) : <a href=\"File/Info.html\">Info</a>?","location":{"filename":"src/file.cr","line_number":131,"url":null},"def":{"name":"info?","args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"follow_symlinks","default_value":"true","external_name":"follow_symlinks","restriction":""}],"return_type":"Info | ::Nil","visibility":"Public","body":"Crystal::System::File.info?(path.to_s, follow_symlinks)"}},{"html_id":"join(parts:Array|Tuple):String-class-method","name":"join","doc":"Returns a new string formed by joining the strings using `File::SEPARATOR`.\n\n```\nFile.join({\"foo\", \"bar\", \"baz\"})       # => \"foo/bar/baz\"\nFile.join({\"foo/\", \"/bar/\", \"/baz\"})   # => \"foo/bar/baz\"\nFile.join([\"/foo/\", \"/bar/\", \"/baz/\"]) # => \"/foo/bar/baz/\"\n```","summary":"<p>Returns a new string formed by joining the strings using <code><a href=\"File.html#SEPARATOR\">File::SEPARATOR</a></code>.</p>","abstract":false,"args":[{"name":"parts","external_name":"parts","restriction":"Array | Tuple"}],"args_string":"(parts : Array | Tuple) : String","args_html":"(parts : <a href=\"Array.html\">Array</a> | <a href=\"Tuple.html\">Tuple</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/file.cr","line_number":761,"url":null},"def":{"name":"join","args":[{"name":"parts","external_name":"parts","restriction":"Array | Tuple"}],"return_type":"String","visibility":"Public","body":"(Path.new(parts)).to_s"}},{"html_id":"join(*parts:String|Path):String-class-method","name":"join","doc":"Returns a new string formed by joining the strings using `File::SEPARATOR`.\n\n```\nFile.join(\"foo\", \"bar\", \"baz\")       # => \"foo/bar/baz\"\nFile.join(\"foo/\", \"/bar/\", \"/baz\")   # => \"foo/bar/baz\"\nFile.join(\"/foo/\", \"/bar/\", \"/baz/\") # => \"/foo/bar/baz/\"\n```","summary":"<p>Returns a new string formed by joining the strings using <code><a href=\"File.html#SEPARATOR\">File::SEPARATOR</a></code>.</p>","abstract":false,"args":[{"name":"parts","external_name":"parts","restriction":"String | Path"}],"args_string":"(*parts : String | Path) : String","args_html":"(*parts : <a href=\"String.html\">String</a> | <a href=\"Path.html\">Path</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/file.cr","line_number":750,"url":null},"def":{"name":"join","args":[{"name":"parts","external_name":"parts","restriction":"String | Path"}],"splat_index":0,"return_type":"String","visibility":"Public","body":"(Path.new(*parts)).to_s"}},{"html_id":"link(old_path:Path|String,new_path:Path|String):Nil-class-method","name":"link","doc":"Creates a new link (also known as a hard link) at *new_path* to an existing file\ngiven by *old_path*.","summary":"<p>Creates a new link (also known as a hard link) at <em>new_path</em> to an existing file given by <em>old_path</em>.</p>","abstract":false,"args":[{"name":"old_path","external_name":"old_path","restriction":"Path | String"},{"name":"new_path","external_name":"new_path","restriction":"Path | String"}],"args_string":"(old_path : Path | String, new_path : Path | String) : Nil","args_html":"(old_path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, new_path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file.cr","line_number":590,"url":null},"def":{"name":"link","args":[{"name":"old_path","external_name":"old_path","restriction":"Path | String"},{"name":"new_path","external_name":"new_path","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"Crystal::System::File.link(old_path.to_s, new_path.to_s)"}},{"html_id":"match?(pattern:String,path:Path|String):Bool-class-method","name":"match?","doc":"Matches *path* against *pattern*.\n\nThe pattern syntax is similar to shell filename globbing. It may contain the following metacharacters:\n\n* `*` matches an unlimited number of arbitrary characters excluding `/`.\n  * `\"*\"` matches all regular files.\n  * `\"c*\"` matches all files beginning with `c`.\n  * `\"*c\"` matches all files ending with `c`.\n  * `\"*c*\"` matches all files that have `c` in them (including at the beginning or end).\n* `**` matches an unlimited number of arbitrary characters including `/`.\n* `?` matches any one character excluding `/`.\n* character sets:\n  * `[abc]` matches any one of these character.\n  * `[^abc]` matches any one character other than these.\n  * `[a-z]` matches any one character in the range.\n* `{a,b}` matches subpattern `a` or `b`.\n* `\\\\` escapes the next character.\n\nNOTE: Only `/` is recognized as path separator in both *pattern* and *path*.","summary":"<p>Matches <em>path</em> against <em>pattern</em>.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":"String"},{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(pattern : String, path : Path | String) : Bool","args_html":"(pattern : <a href=\"String.html\">String</a>, path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/file.cr","line_number":396,"url":null},"def":{"name":"match?","args":[{"name":"pattern","external_name":"pattern","restriction":"String"},{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Bool","visibility":"Public","body":"expanded_patterns = [] of String\nFile.expand_brace_pattern(pattern, expanded_patterns)\nexpanded_patterns.each do |expanded_pattern|\n  if match_single_pattern(expanded_pattern, path.to_s)\n    return true\n  end\nend\nfalse\n"}},{"html_id":"open(filename:Path|String,mode=\"r\",perm=DEFAULT_CREATE_PERMISSIONS,encoding=nil,invalid=nil,&)-class-method","name":"open","doc":"Opens the file named by *filename*. If a file is being created, its initial\npermissions may be set using the *perm* parameter. Then given block will be passed the opened\nfile as an argument, the file will be automatically closed when the block returns.\n\nSee `self.new` for what *mode* can be.","summary":"<p>Opens the file named by <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"mode","default_value":"\"r\"","external_name":"mode","restriction":""},{"name":"perm","default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"args_string":"(filename : Path | String, mode = \"r\", perm = DEFAULT_CREATE_PERMISSIONS, encoding = nil, invalid = nil, &)","args_html":"(filename : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, mode = <span class=\"s\">&quot;r&quot;</span>, perm = <span class=\"t\">DEFAULT_CREATE_PERMISSIONS</span>, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>, &)","location":{"filename":"src/file.cr","line_number":626,"url":null},"def":{"name":"open","args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"mode","default_value":"\"r\"","external_name":"mode","restriction":""},{"name":"perm","default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"yields":1,"visibility":"Public","body":"file = new(filename, mode, perm, encoding, invalid)\nbegin\n  yield file\nensure\n  file.close\nend\n"}},{"html_id":"read(filename:Path|String,encoding=nil,invalid=nil):String-class-method","name":"read","doc":"Returns the content of *filename* as a string.\n\n```\nFile.write(\"bar\", \"foo\")\nFile.read(\"bar\") # => \"foo\"\n```","summary":"<p>Returns the content of <em>filename</em> as a string.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"args_string":"(filename : Path | String, encoding = nil, invalid = nil) : String","args_html":"(filename : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/file.cr","line_number":641,"url":null},"def":{"name":"read","args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"return_type":"String","visibility":"Public","body":"open(filename, \"r\") do |file|\n  if encoding\n    file.set_encoding(encoding, invalid: invalid)\n    file.gets_to_end\n  else\n    size = file.size.to_i\n    if size == 0\n      size = 256\n    end\n    String.build(size) do |io|\n      IO.copy(file, io)\n    end\n  end\nend"}},{"html_id":"read_lines(filename:Path|String,encoding=nil,invalid=nil,chomp=true):Array(String)-class-method","name":"read_lines","doc":"Returns all lines in *filename* as an array of strings.\n\n```\nFile.write(\"foobar\", \"foo\\nbar\")\nFile.read_lines(\"foobar\") # => [\"foo\", \"bar\"]\n```","summary":"<p>Returns all lines in <em>filename</em> as an array of strings.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""},{"name":"chomp","default_value":"true","external_name":"chomp","restriction":""}],"args_string":"(filename : Path | String, encoding = nil, invalid = nil, chomp = true) : Array(String)","args_html":"(filename : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>, chomp = <span class=\"n\">true</span>) : <a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)","location":{"filename":"src/file.cr","line_number":684,"url":null},"def":{"name":"read_lines","args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""},{"name":"chomp","default_value":"true","external_name":"chomp","restriction":""}],"return_type":"Array(String)","visibility":"Public","body":"lines = [] of String\neach_line(filename, encoding: encoding, invalid: invalid, chomp: chomp) do |line|\n  lines << line\nend\nlines\n"}},{"html_id":"readable?(path:Path|String):Bool-class-method","name":"readable?","doc":"Returns `true` if *path* is readable by the real user id of this process else returns `false`.\n\n```\nFile.write(\"foo\", \"foo\")\nFile.readable?(\"foo\") # => true\n```","summary":"<p>Returns <code>true</code> if <em>path</em> is readable by the real user id of this process else returns <code>false</code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Bool","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/file.cr","line_number":220,"url":null},"def":{"name":"readable?","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Bool","visibility":"Public","body":"Crystal::System::File.readable?(path.to_s)"}},{"html_id":"readlink(path:Path|String):String-class-method","name":"readlink","doc":"Returns value of a symbolic link .","summary":"<p>Returns value of a symbolic link .</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : String","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/file.cr","line_number":609,"url":null},"def":{"name":"readlink","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"String","visibility":"Public","body":"Crystal::System::File.readlink(path.to_s)"}},{"html_id":"real_path(path:Path|String):String-class-method","name":"real_path","doc":"Resolves the real path of *path* by following symbolic links.","summary":"<p>Resolves the real path of <em>path</em> by following symbolic links.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : String","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/file.cr","line_number":584,"url":null},"def":{"name":"real_path","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"String","visibility":"Public","body":"Crystal::System::File.real_path(path.to_s)"}},{"html_id":"rename(old_filename:Path|String,new_filename:Path|String):Nil-class-method","name":"rename","doc":"Moves *old_filename* to *new_filename*.\n\n```\nFile.write(\"afile\", \"foo\")\nFile.exists?(\"afile\") # => true\n\nFile.rename(\"afile\", \"afile.cr\")\nFile.exists?(\"afile\")    # => false\nFile.exists?(\"afile.cr\") # => true\n```","summary":"<p>Moves <em>old_filename</em> to <em>new_filename</em>.</p>","abstract":false,"args":[{"name":"old_filename","external_name":"old_filename","restriction":"Path | String"},{"name":"new_filename","external_name":"new_filename","restriction":"Path | String"}],"args_string":"(old_filename : Path | String, new_filename : Path | String) : Nil","args_html":"(old_filename : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, new_filename : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file.cr","line_number":775,"url":null},"def":{"name":"rename","args":[{"name":"old_filename","external_name":"old_filename","restriction":"Path | String"},{"name":"new_filename","external_name":"new_filename","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"if error = Crystal::System::File.rename(old_filename.to_s, new_filename.to_s)\n  raise(error)\nend"}},{"html_id":"same?(path1:Path|String,path2:Path|String,follow_symlinks=false):Bool-class-method","name":"same?","doc":"Returns `true` if *path1* and *path2* represents the same file.\nThe comparison take symlinks in consideration if *follow_symlinks* is `true`.","summary":"<p>Returns <code>true</code> if <em>path1</em> and <em>path2</em> represents the same file.</p>","abstract":false,"args":[{"name":"path1","external_name":"path1","restriction":"Path | String"},{"name":"path2","external_name":"path2","restriction":"Path | String"},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"args_string":"(path1 : Path | String, path2 : Path | String, follow_symlinks = false) : Bool","args_html":"(path1 : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, path2 : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, follow_symlinks = <span class=\"n\">false</span>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/file.cr","line_number":167,"url":null},"def":{"name":"same?","args":[{"name":"path1","external_name":"path1","restriction":"Path | String"},{"name":"path2","external_name":"path2","restriction":"Path | String"},{"name":"follow_symlinks","default_value":"false","external_name":"follow_symlinks","restriction":""}],"return_type":"Bool","visibility":"Public","body":"(info(path1.to_s, follow_symlinks)).same_file?(info(path2.to_s, follow_symlinks))"}},{"html_id":"same_content?(path1:Path|String,path2:Path|String):Bool-class-method","name":"same_content?","doc":"Compares two files *filename1* to *filename2* to determine if they are identical.\nReturns `true` if content are the same, `false` otherwise.\n\n```\nFile.write(\"file.cr\", \"1\")\nFile.write(\"bar.cr\", \"1\")\nFile.same_content?(\"file.cr\", \"bar.cr\") # => true\n```","summary":"<p>Compares two files <em>filename1</em> to <em>filename2</em> to determine if they are identical.</p>","abstract":false,"args":[{"name":"path1","external_name":"path1","restriction":"Path | String"},{"name":"path2","external_name":"path2","restriction":"Path | String"}],"args_string":"(path1 : Path | String, path2 : Path | String) : Bool","args_html":"(path1 : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, path2 : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/file.cr","line_number":179,"url":null},"def":{"name":"same_content?","args":[{"name":"path1","external_name":"path1","restriction":"Path | String"},{"name":"path2","external_name":"path2","restriction":"Path | String"}],"return_type":"Bool","visibility":"Public","body":"open(path1, \"rb\") do |file1|\n  open(path2, \"rb\") do |file2|\n    if file1.size == file2.size\n    else\n      return false\n    end\n    same_content?(file1, file2)\n  end\nend"}},{"html_id":"size(filename:Path|String):Int64-class-method","name":"size","doc":"Returns the size of the file at *filename* in bytes.\nRaises `File::NotFoundError` if the file at *filename* does not exist.\n\n```\nFile.size(\"foo\") # raises File::NotFoundError\nFile.write(\"foo\", \"foo\")\nFile.size(\"foo\") # => 3\n```","summary":"<p>Returns the size of the file at <em>filename</em> in bytes.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"Path | String"}],"args_string":"(filename : Path | String) : Int64","args_html":"(filename : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Int64.html\">Int64</a>","location":{"filename":"src/file.cr","line_number":197,"url":null},"def":{"name":"size","args":[{"name":"filename","external_name":"filename","restriction":"Path | String"}],"return_type":"Int64","visibility":"Public","body":"(info(filename)).size"}},{"html_id":"symlink(old_path:Path|String,new_path:Path|String):Nil-class-method","name":"symlink","doc":"Creates a symbolic link at *new_path* to an existing file given by *old_path*.","summary":"<p>Creates a symbolic link at <em>new_path</em> to an existing file given by <em>old_path</em>.</p>","abstract":false,"args":[{"name":"old_path","external_name":"old_path","restriction":"Path | String"},{"name":"new_path","external_name":"new_path","restriction":"Path | String"}],"args_string":"(old_path : Path | String, new_path : Path | String) : Nil","args_html":"(old_path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, new_path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file.cr","line_number":595,"url":null},"def":{"name":"symlink","args":[{"name":"old_path","external_name":"old_path","restriction":"Path | String"},{"name":"new_path","external_name":"new_path","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"Crystal::System::File.symlink(old_path.to_s, new_path.to_s)"}},{"html_id":"symlink?(path:Path|String):Bool-class-method","name":"symlink?","doc":"Returns `true` if the *path* is a symbolic link.","summary":"<p>Returns <code>true</code> if the <em>path</em> is a symbolic link.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Bool","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/file.cr","line_number":600,"url":null},"def":{"name":"symlink?","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Bool","visibility":"Public","body":"if info = info?(path, follow_symlinks: false)\n  info.type.symlink?\nelse\n  false\nend"}},{"html_id":"tempfile(prefix:String?,suffix:String?,*,dir:String=Dir.tempdir,encoding=nil,invalid=nil)-class-method","name":"tempfile","doc":"Creates a temporary file.\n\n```\ntempfile = File.tempfile(\"foo\", \".bar\")\ntempfile.delete\n```\n\n*prefix* and *suffix* are appended to the front and end of the file name, respectively.\nThese values may contain directory separators.\n\nThe file will be placed in *dir* which defaults to the standard temporary directory `Dir.tempdir`.\n\n*encoding* and *invalid* are passed to `IO#set_encoding`.\n\nIt is the caller's responsibility to remove the file when no longer needed.","summary":"<p>Creates a temporary file.</p>","abstract":false,"args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"suffix","external_name":"suffix","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"dir","default_value":"Dir.tempdir","external_name":"dir","restriction":"String"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"args_string":"(prefix : String?, suffix : String?, *, dir : String = Dir.tempdir, encoding = nil, invalid = nil)","args_html":"(prefix : <a href=\"String.html\">String</a>?, suffix : <a href=\"String.html\">String</a>?, *, dir : <a href=\"String.html\">String</a> = <span class=\"t\">Dir</span>.tempdir, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>)","location":{"filename":"src/file/tempfile.cr","line_number":63,"url":null},"def":{"name":"tempfile","args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"suffix","external_name":"suffix","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"dir","default_value":"Dir.tempdir","external_name":"dir","restriction":"String"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"splat_index":2,"visibility":"Public","body":"fileno, path = Crystal::System::File.mktemp(prefix, suffix, dir)\nnew(path, fileno, blocking: true, encoding: encoding, invalid: invalid)\n"}},{"html_id":"tempfile(suffix:String?=nil,*,dir:String=Dir.tempdir,encoding=nil,invalid=nil)-class-method","name":"tempfile","doc":"Creates a temporary file.\n\n```\ntempfile = File.tempfile(\".bar\")\ntempfile.delete\n```\n\n*prefix* and *suffix* are appended to the front and end of the file name, respectively.\nThese values may contain directory separators.\n\nThe file will be placed in *dir* which defaults to the standard temporary directory `Dir.tempdir`.\n\n*encoding* and *invalid* are passed to `IO#set_encoding`.\n\nIt is the caller's responsibility to remove the file when no longer needed.","summary":"<p>Creates a temporary file.</p>","abstract":false,"args":[{"name":"suffix","default_value":"nil","external_name":"suffix","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"dir","default_value":"Dir.tempdir","external_name":"dir","restriction":"String"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"args_string":"(suffix : String? = nil, *, dir : String = Dir.tempdir, encoding = nil, invalid = nil)","args_html":"(suffix : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>, *, dir : <a href=\"String.html\">String</a> = <span class=\"t\">Dir</span>.tempdir, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>)","location":{"filename":"src/file/tempfile.cr","line_number":83,"url":null},"def":{"name":"tempfile","args":[{"name":"suffix","default_value":"nil","external_name":"suffix","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"dir","default_value":"Dir.tempdir","external_name":"dir","restriction":"String"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"splat_index":1,"visibility":"Public","body":"tempfile(prefix: nil, suffix: suffix, dir: dir, encoding: encoding, invalid: invalid)"}},{"html_id":"tempfile(prefix:String?,suffix:String?,*,dir:String=Dir.tempdir,encoding=nil,invalid=nil,&)-class-method","name":"tempfile","doc":"Creates a temporary file and yields it to the given block. It is closed and returned at the end of this method call.\n\n```\ntempfile = File.tempfile(\"foo\", \".bar\") do |file|\n  file.print(\"bar\")\nend\nFile.read(tempfile.path) # => \"bar\"\ntempfile.delete\n```\n\n*prefix* and *suffix* are appended to the front and end of the file name, respectively.\nThese values may contain directory separators.\n\nThe file will be placed in *dir* which defaults to the standard temporary directory `Dir.tempdir`.\n\n*encoding* and *invalid* are passed to `IO#set_encoding`.\n\nIt is the caller's responsibility to remove the file when no longer needed.","summary":"<p>Creates a temporary file and yields it to the given block.</p>","abstract":false,"args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"suffix","external_name":"suffix","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"dir","default_value":"Dir.tempdir","external_name":"dir","restriction":"String"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"args_string":"(prefix : String?, suffix : String?, *, dir : String = Dir.tempdir, encoding = nil, invalid = nil, &)","args_html":"(prefix : <a href=\"String.html\">String</a>?, suffix : <a href=\"String.html\">String</a>?, *, dir : <a href=\"String.html\">String</a> = <span class=\"t\">Dir</span>.tempdir, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>, &)","location":{"filename":"src/file/tempfile.cr","line_number":105,"url":null},"def":{"name":"tempfile","args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"suffix","external_name":"suffix","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"dir","default_value":"Dir.tempdir","external_name":"dir","restriction":"String"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"splat_index":2,"yields":1,"visibility":"Public","body":"tempfile = tempfile(prefix: prefix, suffix: suffix, dir: dir, encoding: encoding, invalid: invalid)\nbegin\n  yield tempfile\nensure\n  tempfile.close\nend\ntempfile\n"}},{"html_id":"tempfile(suffix:String?=nil,*,dir:String=Dir.tempdir,encoding=nil,invalid=nil,&)-class-method","name":"tempfile","doc":"Creates a temporary file and yields it to the given block. It is closed and returned at the end of this method call.\n\n```\ntempfile = File.tempfile(\".bar\") do |file|\n  file.print(\"bar\")\nend\nFile.read(tempfile.path) # => \"bar\"\ntempfile.delete\n```\n\n*prefix* and *suffix* are appended to the front and end of the file name, respectively.\nThese values may contain directory separators.\n\nThe file will be placed in *dir* which defaults to the standard temporary directory `Dir.tempdir`.\n\n*encoding* and *invalid* are passed to `IO#set_encoding`.\n\nIt is the caller's responsibility to remove the file when no longer needed.","summary":"<p>Creates a temporary file and yields it to the given block.</p>","abstract":false,"args":[{"name":"suffix","default_value":"nil","external_name":"suffix","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"dir","default_value":"Dir.tempdir","external_name":"dir","restriction":"String"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"args_string":"(suffix : String? = nil, *, dir : String = Dir.tempdir, encoding = nil, invalid = nil, &)","args_html":"(suffix : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>, *, dir : <a href=\"String.html\">String</a> = <span class=\"t\">Dir</span>.tempdir, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>, &)","location":{"filename":"src/file/tempfile.cr","line_number":133,"url":null},"def":{"name":"tempfile","args":[{"name":"suffix","default_value":"nil","external_name":"suffix","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"dir","default_value":"Dir.tempdir","external_name":"dir","restriction":"String"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"splat_index":1,"yields":1,"visibility":"Public","body":"tempfile(prefix: nil, suffix: suffix, dir: dir, encoding: encoding, invalid: invalid) do |tempfile|\n  yield tempfile\nend"}},{"html_id":"tempname(prefix:String?,suffix:String?,*,dir:String=Dir.tempdir)-class-method","name":"tempname","doc":"Returns a fully-qualified path to a temporary file.\nThe file is not actually created on the file system.\n\n```\nFile.tempname(\"foo\", \".sock\") # => \"/tmp/foo20171206-1234-449386.sock\"\n```\n\n*prefix* and *suffix* are appended to the front and end of the file name, respectively.\nThese values may contain directory separators.\n\nThe path will be placed in *dir* which defaults to the standard temporary directory `Dir.tempdir`.","summary":"<p>Returns a fully-qualified path to a temporary file.</p>","abstract":false,"args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"suffix","external_name":"suffix","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"dir","default_value":"Dir.tempdir","external_name":"dir","restriction":"String"}],"args_string":"(prefix : String?, suffix : String?, *, dir : String = Dir.tempdir)","args_html":"(prefix : <a href=\"String.html\">String</a>?, suffix : <a href=\"String.html\">String</a>?, *, dir : <a href=\"String.html\">String</a> = <span class=\"t\">Dir</span>.tempdir)","location":{"filename":"src/file/tempfile.cr","line_number":13,"url":null},"def":{"name":"tempname","args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"suffix","external_name":"suffix","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"dir","default_value":"Dir.tempdir","external_name":"dir","restriction":"String"}],"splat_index":2,"visibility":"Public","body":"name = String.build do |io|\n  if prefix\n    io << prefix\n    io << '-'\n  end\n  io << (Time.local.to_s(\"%Y%m%d\"))\n  io << '-'\n  {% if flag?(:win32) %}{% else %}\n        # TODO: Remove this once Process is implemented\n        io << Process.pid\n        io << '-'\n      {% end %}\n  io << ((Random.rand(4294967296_i64)).to_s(36))\n  io << suffix\nend\nFile.join(dir, name)\n"}},{"html_id":"tempname(suffix:String?=nil,*,dir:String=Dir.tempdir)-class-method","name":"tempname","doc":"Returns a fully-qualified path to a temporary file.\nThe optional *suffix* is appended to the file name.\n\n```\nFile.tempname          # => \"/tmp/20171206-1234-449386\"\nFile.tempname(\".sock\") # => \"/tmp/20171206-1234-449386.sock\"\n```","summary":"<p>Returns a fully-qualified path to a temporary file.</p>","abstract":false,"args":[{"name":"suffix","default_value":"nil","external_name":"suffix","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"dir","default_value":"Dir.tempdir","external_name":"dir","restriction":"String"}],"args_string":"(suffix : String? = nil, *, dir : String = Dir.tempdir)","args_html":"(suffix : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>, *, dir : <a href=\"String.html\">String</a> = <span class=\"t\">Dir</span>.tempdir)","location":{"filename":"src/file/tempfile.cr","line_number":44,"url":null},"def":{"name":"tempname","args":[{"name":"suffix","default_value":"nil","external_name":"suffix","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"dir","default_value":"Dir.tempdir","external_name":"dir","restriction":"String"}],"splat_index":1,"visibility":"Public","body":"tempname(prefix: nil, suffix: suffix, dir: dir)"}},{"html_id":"touch(filename:Path|String,time:Time=Time.utc):Nil-class-method","name":"touch","doc":"Attempts to set the access and modification times of the file named\nin the *filename* parameter to the value given in *time*.\n\nIf the file does not exist, it will be created.","summary":"<p>Attempts to set the access and modification times of the file named in the <em>filename</em> parameter to the value given in <em>time</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"time","default_value":"Time.utc","external_name":"time","restriction":"Time"}],"args_string":"(filename : Path | String, time : Time = Time.utc) : Nil","args_html":"(filename : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, time : <a href=\"Time.html\">Time</a> = <span class=\"t\">Time</span>.utc) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file.cr","line_number":790,"url":null},"def":{"name":"touch","args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"time","default_value":"Time.utc","external_name":"time","restriction":"Time"}],"return_type":"Nil","visibility":"Public","body":"if exists?(filename)\nelse\n  open(filename, \"a\") do\n  end\nend\nutime(time, time, filename)\n"}},{"html_id":"utime(atime:Time,mtime:Time,filename:Path|String):Nil-class-method","name":"utime","doc":"Sets the access and modification times of *filename*.","summary":"<p>Sets the access and modification times of <em>filename</em>.</p>","abstract":false,"args":[{"name":"atime","external_name":"atime","restriction":"Time"},{"name":"mtime","external_name":"mtime","restriction":"Time"},{"name":"filename","external_name":"filename","restriction":"Path | String"}],"args_string":"(atime : Time, mtime : Time, filename : Path | String) : Nil","args_html":"(atime : <a href=\"Time.html\">Time</a>, mtime : <a href=\"Time.html\">Time</a>, filename : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file.cr","line_number":782,"url":null},"def":{"name":"utime","args":[{"name":"atime","external_name":"atime","restriction":"Time"},{"name":"mtime","external_name":"mtime","restriction":"Time"},{"name":"filename","external_name":"filename","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"Crystal::System::File.utime(atime, mtime, filename.to_s)"}},{"html_id":"writable?(path:Path|String):Bool-class-method","name":"writable?","doc":"Returns `true` if *path* is writable by the real user id of this process else returns `false`.\n\n```\nFile.write(\"foo\", \"foo\")\nFile.writable?(\"foo\") # => true\n```","summary":"<p>Returns <code>true</code> if <em>path</em> is writable by the real user id of this process else returns <code>false</code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Bool","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/file.cr","line_number":230,"url":null},"def":{"name":"writable?","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Bool","visibility":"Public","body":"Crystal::System::File.writable?(path.to_s)"}},{"html_id":"write(filename:Path|String,content,perm=DEFAULT_CREATE_PERMISSIONS,encoding=nil,invalid=nil,mode=\"w\")-class-method","name":"write","doc":"Writes the given *content* to *filename*.\n\nBy default, an existing file will be overwritten.\n\n*filename* will be created if it does not already exist.\n\n```\nFile.write(\"foo\", \"bar\")\nFile.write(\"foo\", \"baz\", mode: \"a\")\n```\n\nNOTE: If the content is a `Slice(UInt8)`, those bytes will be written.\nIf it's an `IO`, all bytes from the `IO` will be written.\nOtherwise, the string representation of *content* will be written\n(the result of invoking `to_s` on *content*).\n\nSee `self.new` for what *mode* can be.","summary":"<p>Writes the given <em>content</em> to <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"content","external_name":"content","restriction":""},{"name":"perm","default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""},{"name":"mode","default_value":"\"w\"","external_name":"mode","restriction":""}],"args_string":"(filename : Path | String, content, perm = DEFAULT_CREATE_PERMISSIONS, encoding = nil, invalid = nil, mode = \"w\")","args_html":"(filename : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, content, perm = <span class=\"t\">DEFAULT_CREATE_PERMISSIONS</span>, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>, mode = <span class=\"s\">&quot;w&quot;</span>)","location":{"filename":"src/file.cr","line_number":709,"url":null},"def":{"name":"write","args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"content","external_name":"content","restriction":""},{"name":"perm","default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""},{"name":"mode","default_value":"\"w\"","external_name":"mode","restriction":""}],"visibility":"Public","body":"open(filename, mode, perm, encoding: encoding, invalid: invalid) do |file|\n  case content\n  when Bytes\n    file.write(content)\n  when IO\n    IO.copy(content, file)\n  else\n    file.print(content)\n  end\nend"}}],"constructors":[{"html_id":"new(filename:Path|String,mode=\"r\",perm=DEFAULT_CREATE_PERMISSIONS,encoding=nil,invalid=nil)-class-method","name":"new","doc":"Opens the file named by *filename*.\n\n*mode* must be one of the following file open modes:\n\n```text\nMode | Description\n-----+------------------------------------------------------\nr    | Read-only, starts at the beginning of the file.\nr+   | Read-write, starts at the beginning of the file.\nw    | Write-only, truncates existing file to zero length or\n     | creates a new file if the file doesn't exist.\nw+   | Read-write, truncates existing file to zero length or\n     | creates a new file if the file doesn't exist.\na    | Write-only, starts at the end of the file,\n     | creates a new file if the file doesn't exist.\na+   | Read-write, starts at the end of the file,\n     | creates a new file if the file doesn't exist.\nrb   | Same as 'r' but in binary file mode.\nwb   | Same as 'w' but in binary file mode.\nab   | Same as 'a' but in binary file mode.\n```\n\nIn binary file mode, line endings are not converted to CRLF on Windows.","summary":"<p>Opens the file named by <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"mode","default_value":"\"r\"","external_name":"mode","restriction":""},{"name":"perm","default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"args_string":"(filename : Path | String, mode = \"r\", perm = DEFAULT_CREATE_PERMISSIONS, encoding = nil, invalid = nil)","args_html":"(filename : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, mode = <span class=\"s\">&quot;r&quot;</span>, perm = <span class=\"t\">DEFAULT_CREATE_PERMISSIONS</span>, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>)","location":{"filename":"src/file.cr","line_number":109,"url":null},"def":{"name":"new","args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"mode","default_value":"\"r\"","external_name":"mode","restriction":""},{"name":"perm","default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"visibility":"Public","body":"filename = filename.to_s\nfd = Crystal::System::File.open(filename, mode, perm)\nnew(filename, fd, blocking: true, encoding: encoding, invalid: invalid)\n"}},{"html_id":"open(filename:Path|String,mode=\"r\",perm=DEFAULT_CREATE_PERMISSIONS,encoding=nil,invalid=nil):self-class-method","name":"open","doc":"Opens the file named by *filename*. If a file is being created, its initial\npermissions may be set using the *perm* parameter.\n\nSee `self.new` for what *mode* can be.","summary":"<p>Opens the file named by <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"mode","default_value":"\"r\"","external_name":"mode","restriction":""},{"name":"perm","default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"args_string":"(filename : Path | String, mode = \"r\", perm = DEFAULT_CREATE_PERMISSIONS, encoding = nil, invalid = nil) : self","args_html":"(filename : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, mode = <span class=\"s\">&quot;r&quot;</span>, perm = <span class=\"t\">DEFAULT_CREATE_PERMISSIONS</span>, encoding = <span class=\"n\">nil</span>, invalid = <span class=\"n\">nil</span>) : <span class=\"k\">self</span>","location":{"filename":"src/file.cr","line_number":617,"url":null},"def":{"name":"open","args":[{"name":"filename","external_name":"filename","restriction":"Path | String"},{"name":"mode","default_value":"\"r\"","external_name":"mode","restriction":""},{"name":"perm","default_value":"DEFAULT_CREATE_PERMISSIONS","external_name":"perm","restriction":""},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":""}],"return_type":"self","visibility":"Public","body":"new(filename, mode, perm, encoding, invalid)"}}],"instance_methods":[{"html_id":"delete:Nil-instance-method","name":"delete","doc":"Deletes this file.","summary":"<p>Deletes this file.</p>","abstract":false,"location":{"filename":"src/file.cr","line_number":835,"url":null},"def":{"name":"delete","return_type":"Nil","visibility":"Public","body":"File.delete(@path)"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file.cr","line_number":828,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"(io << \"#<File:\") << @path\nif closed?\n  io << \" (closed)\"\nend\nio << '>'\n"}},{"html_id":"path:String-instance-method","name":"path","abstract":false,"location":{"filename":"src/file.cr","line_number":115,"url":null},"def":{"name":"path","return_type":"String","visibility":"Public","body":"@path"}},{"html_id":"read_at(offset,bytesize,&:IO->)-instance-method","name":"read_at","doc":"Yields an `IO` to read a section inside this file.\nMultiple sections can be read concurrently.","summary":"<p>Yields an <code><a href=\"IO.html\">IO</a></code> to read a section inside this file.</p>","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"bytesize","external_name":"bytesize","restriction":""}],"args_string":"(offset, bytesize, & : IO -> )","args_html":"(offset, bytesize, & : <a href=\"IO.html\">IO</a> -> )","location":{"filename":"src/file.cr","line_number":809,"url":null},"def":{"name":"read_at","args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"bytesize","external_name":"bytesize","restriction":""}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(IO ->)"},"visibility":"Public","body":"self_bytesize = self.size\nif 0 <= offset && offset <= self_bytesize\nelse\n  raise(ArgumentError.new(\"Offset out of bounds\"))\nend\nif bytesize < 0\n  raise(ArgumentError.new(\"Negative bytesize\"))\nend\nif 0 <= (__temp_36 = offset + bytesize) && __temp_36 <= self_bytesize\nelse\n  raise(ArgumentError.new(\"Bytesize out of bounds\"))\nend\nio = PReader.new(self, offset, bytesize)\nbegin\n  yield io\nensure\n  io.close\nend\n"}},{"html_id":"size:Int64-instance-method","name":"size","doc":"Returns the size in bytes of the currently opened file.","summary":"<p>Returns the size in bytes of the currently opened file.</p>","abstract":false,"location":{"filename":"src/file.cr","line_number":796,"url":null},"def":{"name":"size","return_type":"Int64","visibility":"Public","body":"info.size"}},{"html_id":"truncate(size=0):Nil-instance-method","name":"truncate","doc":"Truncates the file to the specified *size*. Requires that the current file is opened\nfor writing.","summary":"<p>Truncates the file to the specified <em>size</em>.</p>","abstract":false,"args":[{"name":"size","default_value":"0","external_name":"size","restriction":""}],"args_string":"(size = 0) : Nil","args_html":"(size = <span class=\"n\">0</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file.cr","line_number":802,"url":null},"def":{"name":"truncate","args":[{"name":"size","default_value":"0","external_name":"size","restriction":""}],"return_type":"Nil","visibility":"Public","body":"flush\nsystem_truncate(size)\n"}}],"types":[{"html_id":"Crystal/File/AccessDeniedError","path":"File/AccessDeniedError.html","kind":"class","full_name":"File::AccessDeniedError","name":"AccessDeniedError","abstract":false,"superclass":{"html_id":"Crystal/File/Error","kind":"class","full_name":"File::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/File/Error","kind":"class","full_name":"File::Error","name":"Error"},{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},{"html_id":"Crystal/SystemError","kind":"module","full_name":"SystemError","name":"SystemError"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/file/error.cr","line_number":41,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/File","kind":"class","full_name":"File","name":"File"}},{"html_id":"Crystal/File/AlreadyExistsError","path":"File/AlreadyExistsError.html","kind":"class","full_name":"File::AlreadyExistsError","name":"AlreadyExistsError","abstract":false,"superclass":{"html_id":"Crystal/File/Error","kind":"class","full_name":"File::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/File/Error","kind":"class","full_name":"File::Error","name":"Error"},{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},{"html_id":"Crystal/SystemError","kind":"module","full_name":"SystemError","name":"SystemError"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/file/error.cr","line_number":38,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/File","kind":"class","full_name":"File","name":"File"}},{"html_id":"Crystal/File/BadPatternError","path":"File/BadPatternError.html","kind":"class","full_name":"File::BadPatternError","name":"BadPatternError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/file.cr","line_number":374,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/File","kind":"class","full_name":"File","name":"File"}},{"html_id":"Crystal/File/Error","path":"File/Error.html","kind":"class","full_name":"File::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},{"html_id":"Crystal/SystemError","kind":"module","full_name":"SystemError","name":"SystemError"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/file/error.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/File/AccessDeniedError","kind":"class","full_name":"File::AccessDeniedError","name":"AccessDeniedError"},{"html_id":"Crystal/File/AlreadyExistsError","kind":"class","full_name":"File::AlreadyExistsError","name":"AlreadyExistsError"},{"html_id":"Crystal/File/NotFoundError","kind":"class","full_name":"File::NotFoundError","name":"NotFoundError"}],"namespace":{"html_id":"Crystal/File","kind":"class","full_name":"File","name":"File"},"constructors":[{"html_id":"new(message,*,file:String|Path,other:String?=nil)-class-method","name":"new","abstract":false,"args":[{"name":"message","external_name":"message","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"file","external_name":"file","restriction":"String | Path"},{"name":"other","default_value":"nil","external_name":"other","restriction":"String | ::Nil"}],"args_string":"(message, *, file : String | Path, other : String? = nil)","args_html":"(message, *, file : <a href=\"../String.html\">String</a> | <a href=\"../Path.html\">Path</a>, other : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/file/error.cr","line_number":29,"url":null},"def":{"name":"new","args":[{"name":"message","external_name":"message","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"file","external_name":"file","restriction":"String | Path"},{"name":"other","default_value":"nil","external_name":"other","restriction":"String | ::Nil"}],"splat_index":1,"visibility":"Public","body":"_ = allocate\n_.initialize(message, file: file, other: other)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"file:String-instance-method","name":"file","abstract":false,"location":{"filename":"src/file/error.cr","line_number":5,"url":null},"def":{"name":"file","return_type":"String","visibility":"Public","body":"@file"}},{"html_id":"other:String?-instance-method","name":"other","abstract":false,"location":{"filename":"src/file/error.cr","line_number":6,"url":null},"def":{"name":"other","return_type":"String | ::Nil","visibility":"Public","body":"@other"}}]},{"html_id":"Crystal/File/Flags","path":"File/Flags.html","kind":"enum","full_name":"File::Flags","name":"Flags","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/file/info.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"SetUser","name":"SetUser","value":"1_u8"},{"id":"SetGroup","name":"SetGroup","value":"2_u8"},{"id":"Sticky","name":"Sticky","value":"4_u8"}],"namespace":{"html_id":"Crystal/File","kind":"class","full_name":"File","name":"File"},"doc":"Represents the various behaviour-altering flags which can be set on files.\nNot all flags will be supported on all platforms.","summary":"<p>Represents the various behaviour-altering flags which can be set on files.</p>","instance_methods":[{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":5,"url":null},"def":{"name":"none?","visibility":"Public","body":"value == 0"}},{"html_id":"set_group?-instance-method","name":"set_group?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":7,"url":null},"def":{"name":"set_group?","visibility":"Public","body":"self.includes?(SetGroup)"}},{"html_id":"set_user?-instance-method","name":"set_user?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":6,"url":null},"def":{"name":"set_user?","visibility":"Public","body":"self.includes?(SetUser)"}},{"html_id":"sticky?-instance-method","name":"sticky?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":8,"url":null},"def":{"name":"sticky?","visibility":"Public","body":"self.includes?(Sticky)"}}]},{"html_id":"Crystal/File/Info","path":"File/Info.html","kind":"struct","full_name":"File::Info","name":"Info","abstract":true,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/file/info.cr","line_number":80,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/File","kind":"class","full_name":"File","name":"File"},"doc":"A `File::Info` contains metadata regarding a file.\nIt is returned by `File.info`, `File#info` and `File.info?`.","summary":"<p>A <code><a href=\"../File/Info.html\">File::Info</a></code> contains metadata regarding a file.</p>","constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/file/info.cr","line_number":80,"url":null},"def":{"name":"new","visibility":"Public","body":"x = allocate\nif x.responds_to?(:finalize)\n  ::GC.add_finalizer(x)\nend\nx\n"}}],"instance_methods":[{"html_id":"directory?-instance-method","name":"directory?","doc":"Returns true if this `Info` represents a directory. Shortcut for\n`type.directory?`.","summary":"<p>Returns true if this <code><a href=\"../File/Info.html\">Info</a></code> represents a directory.</p>","abstract":false,"location":{"filename":"src/file/info.cr","line_number":116,"url":null},"def":{"name":"directory?","visibility":"Public","body":"type.directory?"}},{"html_id":"file?-instance-method","name":"file?","doc":"Returns true if this `Info` represents a standard file. Shortcut for\n`type.file?`.","summary":"<p>Returns true if this <code><a href=\"../File/Info.html\">Info</a></code> represents a standard file.</p>","abstract":false,"location":{"filename":"src/file/info.cr","line_number":110,"url":null},"def":{"name":"file?","visibility":"Public","body":"type.file?"}},{"html_id":"flags:Flags-instance-method","name":"flags","doc":"The special flags this file has set.","summary":"<p>The special flags this file has set.</p>","abstract":true,"location":{"filename":"src/file/info.cr","line_number":91,"url":null},"def":{"name":"flags","return_type":"Flags","visibility":"Public","body":""}},{"html_id":"group_id:String-instance-method","name":"group_id","doc":"The group ID that the file belongs to.","summary":"<p>The group ID that the file belongs to.</p>","abstract":true,"location":{"filename":"src/file/info.cr","line_number":100,"url":null},"def":{"name":"group_id","return_type":"String","visibility":"Public","body":""}},{"html_id":"initialize-instance-method","name":"initialize","abstract":false,"location":{"filename":"src/file/info.cr","line_number":80,"url":null},"def":{"name":"initialize","visibility":"Public","body":""}},{"html_id":"modification_time:Time-instance-method","name":"modification_time","doc":"The last time this file was modified.","summary":"<p>The last time this file was modified.</p>","abstract":true,"location":{"filename":"src/file/info.cr","line_number":94,"url":null},"def":{"name":"modification_time","return_type":"Time","visibility":"Public","body":""}},{"html_id":"owner_id:String-instance-method","name":"owner_id","doc":"The user ID that the file belongs to.","summary":"<p>The user ID that the file belongs to.</p>","abstract":true,"location":{"filename":"src/file/info.cr","line_number":97,"url":null},"def":{"name":"owner_id","return_type":"String","visibility":"Public","body":""}},{"html_id":"permissions:Permissions-instance-method","name":"permissions","doc":"The permissions of the file.","summary":"<p>The permissions of the file.</p>","abstract":true,"location":{"filename":"src/file/info.cr","line_number":85,"url":null},"def":{"name":"permissions","return_type":"Permissions","visibility":"Public","body":""}},{"html_id":"same_file?(other:File::Info):Bool-instance-method","name":"same_file?","doc":"Returns true if this `Info` and *other* are of the same file.\n\nOn unix, this compares device and inode fields, and will compare equal for\nhard linked files.","summary":"<p>Returns true if this <code><a href=\"../File/Info.html\">Info</a></code> and <em>other</em> are of the same file.</p>","abstract":true,"args":[{"name":"other","external_name":"other","restriction":"File::Info"}],"args_string":"(other : File::Info) : Bool","args_html":"(other : <a href=\"../File/Info.html\">File::Info</a>) : <a href=\"../Bool.html\">Bool</a>","location":{"filename":"src/file/info.cr","line_number":106,"url":null},"def":{"name":"same_file?","args":[{"name":"other","external_name":"other","restriction":"File::Info"}],"return_type":"Bool","visibility":"Public","body":""}},{"html_id":"size:Int64-instance-method","name":"size","doc":"Size of the file, in bytes.","summary":"<p>Size of the file, in bytes.</p>","abstract":true,"location":{"filename":"src/file/info.cr","line_number":82,"url":null},"def":{"name":"size","return_type":"Int64","visibility":"Public","body":""}},{"html_id":"symlink?-instance-method","name":"symlink?","doc":"Returns true if this `Info` represents a symbolic link to another file.\nShortcut for `type.symlink?`.","summary":"<p>Returns true if this <code><a href=\"../File/Info.html\">Info</a></code> represents a symbolic link to another file.</p>","abstract":false,"location":{"filename":"src/file/info.cr","line_number":122,"url":null},"def":{"name":"symlink?","visibility":"Public","body":"type.symlink?"}},{"html_id":"type:Type-instance-method","name":"type","doc":"The type of the file.","summary":"<p>The type of the file.</p>","abstract":true,"location":{"filename":"src/file/info.cr","line_number":88,"url":null},"def":{"name":"type","return_type":"Type","visibility":"Public","body":""}}]},{"html_id":"Crystal/File/NotFoundError","path":"File/NotFoundError.html","kind":"class","full_name":"File::NotFoundError","name":"NotFoundError","abstract":false,"superclass":{"html_id":"Crystal/File/Error","kind":"class","full_name":"File::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/File/Error","kind":"class","full_name":"File::Error","name":"Error"},{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},{"html_id":"Crystal/SystemError","kind":"module","full_name":"SystemError","name":"SystemError"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/file/error.cr","line_number":35,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/File","kind":"class","full_name":"File","name":"File"}},{"html_id":"Crystal/File/Permissions","path":"File/Permissions.html","kind":"enum","full_name":"File::Permissions","name":"Permissions","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/file/info.cr","line_number":41,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"OtherExecute","name":"OtherExecute","value":"1_i16"},{"id":"OtherWrite","name":"OtherWrite","value":"2_i16"},{"id":"OtherRead","name":"OtherRead","value":"4_i16"},{"id":"OtherAll","name":"OtherAll","value":"7_i16"},{"id":"GroupExecute","name":"GroupExecute","value":"8_i16"},{"id":"GroupWrite","name":"GroupWrite","value":"16_i16"},{"id":"GroupRead","name":"GroupRead","value":"32_i16"},{"id":"GroupAll","name":"GroupAll","value":"56_i16"},{"id":"OwnerExecute","name":"OwnerExecute","value":"64_i16"},{"id":"OwnerWrite","name":"OwnerWrite","value":"128_i16"},{"id":"OwnerRead","name":"OwnerRead","value":"256_i16"},{"id":"OwnerAll","name":"OwnerAll","value":"448_i16"}],"namespace":{"html_id":"Crystal/File","kind":"class","full_name":"File","name":"File"},"doc":"Represents a set of access permissions for a file. Not all permission sets\nwill be supported on all platforms.\n\nThe binary representation of this enum is defined to be same representation\nas the permission bits of a unix `st_mode` field. `File::Permissions`\ncan also be compared to its underlying bitset, for example\n`File::Permissions::All == 0o777` will always be `true`.\n\nOn windows, only the `OwnerWrite` bit is effective. All file permissions\nwill either be `0o444` for read-only files or `0o666` for read-write files.\nDirectories are always mode `0o555` for read-only or `0o777`.","summary":"<p>Represents a set of access permissions for a file.</p>","constructors":[{"html_id":"new(int:Int)-class-method","name":"new","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int"}],"args_string":"(int : Int)","args_html":"(int : <a href=\"../Int.html\">Int</a>)","location":{"filename":"src/file/info.cr","line_number":57,"url":null},"def":{"name":"new","args":[{"name":"int","external_name":"int","restriction":"Int"}],"visibility":"Public","body":"new(int.to_i16)"}}],"instance_methods":[{"html_id":"group_all?-instance-method","name":"group_all?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":50,"url":null},"def":{"name":"group_all?","visibility":"Public","body":"self.includes?(GroupAll)"}},{"html_id":"group_execute?-instance-method","name":"group_execute?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":47,"url":null},"def":{"name":"group_execute?","visibility":"Public","body":"self.includes?(GroupExecute)"}},{"html_id":"group_read?-instance-method","name":"group_read?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":49,"url":null},"def":{"name":"group_read?","visibility":"Public","body":"self.includes?(GroupRead)"}},{"html_id":"group_write?-instance-method","name":"group_write?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":48,"url":null},"def":{"name":"group_write?","visibility":"Public","body":"self.includes?(GroupWrite)"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":41,"url":null},"def":{"name":"none?","visibility":"Public","body":"value == 0"}},{"html_id":"other_all?-instance-method","name":"other_all?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":45,"url":null},"def":{"name":"other_all?","visibility":"Public","body":"self.includes?(OtherAll)"}},{"html_id":"other_execute?-instance-method","name":"other_execute?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":42,"url":null},"def":{"name":"other_execute?","visibility":"Public","body":"self.includes?(OtherExecute)"}},{"html_id":"other_read?-instance-method","name":"other_read?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":44,"url":null},"def":{"name":"other_read?","visibility":"Public","body":"self.includes?(OtherRead)"}},{"html_id":"other_write?-instance-method","name":"other_write?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":43,"url":null},"def":{"name":"other_write?","visibility":"Public","body":"self.includes?(OtherWrite)"}},{"html_id":"owner_all?-instance-method","name":"owner_all?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":55,"url":null},"def":{"name":"owner_all?","visibility":"Public","body":"self.includes?(OwnerAll)"}},{"html_id":"owner_execute?-instance-method","name":"owner_execute?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":52,"url":null},"def":{"name":"owner_execute?","visibility":"Public","body":"self.includes?(OwnerExecute)"}},{"html_id":"owner_read?-instance-method","name":"owner_read?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":54,"url":null},"def":{"name":"owner_read?","visibility":"Public","body":"self.includes?(OwnerRead)"}},{"html_id":"owner_write?-instance-method","name":"owner_write?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":53,"url":null},"def":{"name":"owner_write?","visibility":"Public","body":"self.includes?(OwnerWrite)"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a `String` representation of this enum member to the given *io*.\n\nSee also: `to_s`.","summary":"<p>Appends a <code><a href=\"../String.html\">String</a></code> representation of this enum member to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/file/info.cr","line_number":61,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << (owner_read? ? 'r' : '-')\nio << (owner_write? ? 'w' : '-')\nio << (owner_execute? ? 'x' : '-')\nio << (group_read? ? 'r' : '-')\nio << (group_write? ? 'w' : '-')\nio << (group_execute? ? 'x' : '-')\nio << (other_read? ? 'r' : '-')\nio << (other_write? ? 'w' : '-')\nio << (other_execute? ? 'x' : '-')\n((io << \" (0o\") << (self.to_i.to_s(8))) << ')'\n"}}]},{"html_id":"Crystal/File/Type","path":"File/Type.html","kind":"enum","full_name":"File::Type","name":"Type","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/file/info.cr","line_number":13,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"File","name":"File","value":"0_u8"},{"id":"Directory","name":"Directory","value":"1_u8"},{"id":"Symlink","name":"Symlink","value":"2_u8"},{"id":"Socket","name":"Socket","value":"3_u8"},{"id":"Pipe","name":"Pipe","value":"4_u8"},{"id":"CharacterDevice","name":"CharacterDevice","value":"5_u8"},{"id":"BlockDevice","name":"BlockDevice","value":"6_u8"},{"id":"Unknown","name":"Unknown","value":"7_u8"}],"namespace":{"html_id":"Crystal/File","kind":"class","full_name":"File","name":"File"},"doc":"Represents the type of a file. Not all types will be supported on all\nplatforms.","summary":"<p>Represents the type of a file.</p>","instance_methods":[{"html_id":"block_device?-instance-method","name":"block_device?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":20,"url":null},"def":{"name":"block_device?","visibility":"Public","body":"self == BlockDevice"}},{"html_id":"character_device?-instance-method","name":"character_device?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":19,"url":null},"def":{"name":"character_device?","visibility":"Public","body":"self == CharacterDevice"}},{"html_id":"device?-instance-method","name":"device?","doc":"Returns true if `self` is a `CharacterDevice` or a `BlockDevice`.","summary":"<p>Returns true if <code>self</code> is a <code><a href=\"../File/Type.html#CharacterDevice\">CharacterDevice</a></code> or a <code><a href=\"../File/Type.html#BlockDevice\">BlockDevice</a></code>.</p>","abstract":false,"location":{"filename":"src/file/info.cr","line_number":24,"url":null},"def":{"name":"device?","visibility":"Public","body":"character_device? || block_device?"}},{"html_id":"directory?-instance-method","name":"directory?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":15,"url":null},"def":{"name":"directory?","visibility":"Public","body":"self == Directory"}},{"html_id":"file?-instance-method","name":"file?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":14,"url":null},"def":{"name":"file?","visibility":"Public","body":"self == File"}},{"html_id":"pipe?-instance-method","name":"pipe?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":18,"url":null},"def":{"name":"pipe?","visibility":"Public","body":"self == Pipe"}},{"html_id":"socket?-instance-method","name":"socket?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":17,"url":null},"def":{"name":"socket?","visibility":"Public","body":"self == Socket"}},{"html_id":"symlink?-instance-method","name":"symlink?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":16,"url":null},"def":{"name":"symlink?","visibility":"Public","body":"self == Symlink"}},{"html_id":"unknown?-instance-method","name":"unknown?","abstract":false,"location":{"filename":"src/file/info.cr","line_number":21,"url":null},"def":{"name":"unknown?","visibility":"Public","body":"self == Unknown"}}]}]},{"html_id":"Crystal/FileUtils","path":"FileUtils.html","kind":"module","full_name":"FileUtils","name":"FileUtils","abstract":false,"locations":[{"filename":"src/file_utils.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"extended_modules":[{"html_id":"Crystal/FileUtils","kind":"module","full_name":"FileUtils","name":"FileUtils"}],"instance_methods":[{"html_id":"cd(path:Path|String):Nil-instance-method","name":"cd","doc":"Changes the current working directory of the process to the given string *path*.\n\n```\nrequire \"file_utils\"\n\nFileUtils.cd(\"/tmp\")\n```\n\nNOTE: Alias of `Dir.cd`","summary":"<p>Changes the current working directory of the process to the given string <em>path</em>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Nil","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":13,"url":null},"def":{"name":"cd","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"Dir.cd(path)"}},{"html_id":"cd(path:Path|String,&)-instance-method","name":"cd","doc":"Changes the current working directory of the process to the given string *path*\nand invoked the block, restoring the original working directory when the block exits.\n\n```\nrequire \"file_utils\"\n\nFileUtils.cd(\"/tmp\") { Dir.current } # => \"/tmp\"\n```\n\nNOTE: Alias of `Dir.cd` with block","summary":"<p>Changes the current working directory of the process to the given string <em>path</em> and invoked the block, restoring the original working directory when the block exits.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String, &)","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, &)","location":{"filename":"src/file_utils.cr","line_number":27,"url":null},"def":{"name":"cd","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"yields":0,"visibility":"Public","body":"Dir.cd(path) do\n  yield\nend"}},{"html_id":"cmp(filename1:Path|String,filename2:Path|String):Bool-instance-method","name":"cmp","doc":"Compares two files *filename1* to *filename2* to determine if they are identical.\nReturns `true` if content are the same, `false` otherwise.\n\n```\nrequire \"file_utils\"\n\nFile.write(\"file.cr\", \"1\")\nFile.write(\"bar.cr\", \"1\")\nFileUtils.cmp(\"file.cr\", \"bar.cr\") # => true\n```\n\nNOTE: Alias of `File.same_content?`","summary":"<p>Compares two files <em>filename1</em> to <em>filename2</em> to determine if they are identical.</p>","abstract":false,"args":[{"name":"filename1","external_name":"filename1","restriction":"Path | String"},{"name":"filename2","external_name":"filename2","restriction":"Path | String"}],"args_string":"(filename1 : Path | String, filename2 : Path | String) : Bool","args_html":"(filename1 : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, filename2 : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/file_utils.cr","line_number":43,"url":null},"def":{"name":"cmp","args":[{"name":"filename1","external_name":"filename1","restriction":"Path | String"},{"name":"filename2","external_name":"filename2","restriction":"Path | String"}],"return_type":"Bool","visibility":"Public","body":"File.same_content?(filename1, filename2)"}},{"html_id":"cp(src_path:Path|String,dest:Path|String):Nil-instance-method","name":"cp","doc":"Copies the file *src_path* to the file or directory *dest*.\nIf *dest* is a directory, a file with the same basename as *src_path* is created in *dest*\nPermission bits are copied too.\n\n```\nrequire \"file_utils\"\n\nFile.touch(\"afile\")\nFile.chmod(\"afile\", 0o600)\nFileUtils.cp(\"afile\", \"afile_copy\")\nFile.info(\"afile_copy\").permissions.value # => 0o600\n```","summary":"<p>Copies the file <em>src_path</em> to the file or directory <em>dest</em>.</p>","abstract":false,"args":[{"name":"src_path","external_name":"src_path","restriction":"Path | String"},{"name":"dest","external_name":"dest","restriction":"Path | String"}],"args_string":"(src_path : Path | String, dest : Path | String) : Nil","args_html":"(src_path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, dest : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":91,"url":null},"def":{"name":"cp","args":[{"name":"src_path","external_name":"src_path","restriction":"Path | String"},{"name":"dest","external_name":"dest","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"if Dir.exists?(dest)\n  dest = Path[dest, File.basename(src_path)]\nend\nFile.copy(src_path, dest)\n"}},{"html_id":"cp(srcs:Enumerable(Path|String),dest:Path|String):Nil-instance-method","name":"cp","doc":"Copies a list of files *src* to *dest*.\n*dest* must be an existing directory.\n\n```\nrequire \"file_utils\"\n\nDir.mkdir(\"files\")\nFileUtils.cp({\"bar.cr\", \"afile\"}, \"files\")\n```","summary":"<p>Copies a list of files <em>src</em> to <em>dest</em>.</p>","abstract":false,"args":[{"name":"srcs","external_name":"srcs","restriction":"Enumerable(Path | String)"},{"name":"dest","external_name":"dest","restriction":"Path | String"}],"args_string":"(srcs : Enumerable(Path | String), dest : Path | String) : Nil","args_html":"(srcs : <a href=\"Enumerable.html\">Enumerable</a>(<a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>), dest : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":105,"url":null},"def":{"name":"cp","args":[{"name":"srcs","external_name":"srcs","restriction":"Enumerable(Path | String)"},{"name":"dest","external_name":"dest","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"if Dir.exists?(dest)\nelse\n  raise(ArgumentError.new(\"No such directory : #{dest}\"))\nend\nsrcs.each do |src|\n  cp(src, dest)\nend\n"}},{"html_id":"cp_r(src_path:Path|String,dest_path:Path|String):Nil-instance-method","name":"cp_r","doc":"Copies a file or directory *src_path* to *dest_path*.\nIf *src_path* is a directory, this method copies all its contents recursively.\nIf *dest* is a directory, copies src to dest/src.\n\n```\nrequire \"file_utils\"\n\nFileUtils.cp_r(\"files\", \"dir\")\n```","summary":"<p>Copies a file or directory <em>src_path</em> to <em>dest_path</em>.</p>","abstract":false,"args":[{"name":"src_path","external_name":"src_path","restriction":"Path | String"},{"name":"dest_path","external_name":"dest_path","restriction":"Path | String"}],"args_string":"(src_path : Path | String, dest_path : Path | String) : Nil","args_html":"(src_path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, dest_path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":121,"url":null},"def":{"name":"cp_r","args":[{"name":"src_path","external_name":"src_path","restriction":"Path | String"},{"name":"dest_path","external_name":"dest_path","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"if File.directory?(dest_path)\n  dest_path = File.join(dest_path, File.basename(src_path))\nend\ncp_recursive(src_path, dest_path)\n"}},{"html_id":"ln(src_path:Path|String,dest_path:Path|String):Nil-instance-method","name":"ln","doc":"Creates a hard link *dest_path* which points to *src_path*.\nIf *dest_path* already exists and is a directory, creates a link *dest_path/src_path*.\n\n```\nrequire \"file_utils\"\n\n# Create a hard link, pointing from /usr/bin/emacs to /usr/bin/vim\nFileUtils.ln(\"/usr/bin/vim\", \"/usr/bin/emacs\")\n# Create a hard link, pointing from /tmp/foo.c to foo.c\nFileUtils.ln(\"foo.c\", \"/tmp\")\n```","summary":"<p>Creates a hard link <em>dest_path</em> which points to <em>src_path</em>.</p>","abstract":false,"args":[{"name":"src_path","external_name":"src_path","restriction":"Path | String"},{"name":"dest_path","external_name":"dest_path","restriction":"Path | String"}],"args_string":"(src_path : Path | String, dest_path : Path | String) : Nil","args_html":"(src_path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, dest_path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":150,"url":null},"def":{"name":"ln","args":[{"name":"src_path","external_name":"src_path","restriction":"Path | String"},{"name":"dest_path","external_name":"dest_path","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"if Dir.exists?(dest_path)\n  File.link(src_path, File.join(dest_path, File.basename(src_path)))\nelse\n  File.link(src_path, dest_path)\nend"}},{"html_id":"ln(src_paths:Enumerable(Path|String),dest_dir:Path|String):Nil-instance-method","name":"ln","doc":"Creates a hard link to each path in *src_paths* inside the *dest_dir* directory.\nIf *dest_dir* is not a directory, raises an `ArgumentError`.\n\n```\nrequire \"file_utils\"\n\n# Create /usr/bin/vim, /usr/bin/emacs, and /usr/bin/nano as hard links\nFileUtils.ln([\"vim\", \"emacs\", \"nano\"], \"/usr/bin\")\n```","summary":"<p>Creates a hard link to each path in <em>src_paths</em> inside the <em>dest_dir</em> directory.</p>","abstract":false,"args":[{"name":"src_paths","external_name":"src_paths","restriction":"Enumerable(Path | String)"},{"name":"dest_dir","external_name":"dest_dir","restriction":"Path | String"}],"args_string":"(src_paths : Enumerable(Path | String), dest_dir : Path | String) : Nil","args_html":"(src_paths : <a href=\"Enumerable.html\">Enumerable</a>(<a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>), dest_dir : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":167,"url":null},"def":{"name":"ln","args":[{"name":"src_paths","external_name":"src_paths","restriction":"Enumerable(Path | String)"},{"name":"dest_dir","external_name":"dest_dir","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"if Dir.exists?(dest_dir)\nelse\n  raise(ArgumentError.new(\"No such directory : #{dest_dir}\"))\nend\nsrc_paths.each do |path|\n  ln(path, dest_dir)\nend\n"}},{"html_id":"ln_s(src_path:Path|String,dest_path:Path|String):Nil-instance-method","name":"ln_s","doc":"Creates a symbolic link *dest_path* which points to *src_path*.\nIf *dest_path* already exists and is a directory, creates a link *dest_path/src_path*.\n\n```\nrequire \"file_utils\"\n\n# Create a symbolic link pointing from logs to /var/log\nFileUtils.ln_s(\"/var/log\", \"logs\")\n# Create a symbolic link pointing from /tmp/src to src\nFileUtils.ln_s(\"src\", \"/tmp\")\n```","summary":"<p>Creates a symbolic link <em>dest_path</em> which points to <em>src_path</em>.</p>","abstract":false,"args":[{"name":"src_path","external_name":"src_path","restriction":"Path | String"},{"name":"dest_path","external_name":"dest_path","restriction":"Path | String"}],"args_string":"(src_path : Path | String, dest_path : Path | String) : Nil","args_html":"(src_path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, dest_path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":186,"url":null},"def":{"name":"ln_s","args":[{"name":"src_path","external_name":"src_path","restriction":"Path | String"},{"name":"dest_path","external_name":"dest_path","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"if Dir.exists?(dest_path)\n  File.symlink(src_path, File.join(dest_path, File.basename(src_path)))\nelse\n  File.symlink(src_path, dest_path)\nend"}},{"html_id":"ln_s(src_paths:Enumerable(Path|String),dest_dir:Path|String):Nil-instance-method","name":"ln_s","doc":"Creates a symbolic link to each path in *src_paths* inside the *dest_dir* directory.\nIf *dest_dir* is not a directory, raises an `ArgumentError`.\n\n```\nrequire \"file_utils\"\n\n# Create symbolic links in src/ pointing to every .c file in the current directory\nFileUtils.ln_s(Dir[\"*.c\"], \"src\")\n```","summary":"<p>Creates a symbolic link to each path in <em>src_paths</em> inside the <em>dest_dir</em> directory.</p>","abstract":false,"args":[{"name":"src_paths","external_name":"src_paths","restriction":"Enumerable(Path | String)"},{"name":"dest_dir","external_name":"dest_dir","restriction":"Path | String"}],"args_string":"(src_paths : Enumerable(Path | String), dest_dir : Path | String) : Nil","args_html":"(src_paths : <a href=\"Enumerable.html\">Enumerable</a>(<a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>), dest_dir : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":203,"url":null},"def":{"name":"ln_s","args":[{"name":"src_paths","external_name":"src_paths","restriction":"Enumerable(Path | String)"},{"name":"dest_dir","external_name":"dest_dir","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"if Dir.exists?(dest_dir)\nelse\n  raise(ArgumentError.new(\"No such directory : #{dest_dir}\"))\nend\nsrc_paths.each do |path|\n  ln_s(path, dest_dir)\nend\n"}},{"html_id":"ln_sf(src_path:Path|String,dest_path:Path|String):Nil-instance-method","name":"ln_sf","doc":"Like `#ln_s(Path | String, Path | String)`, but overwrites `dest_path` if it exists and is not a directory\nor if `dest_path/src_path` exists.\n\n```\nrequire \"file_utils\"\n\n# Create a symbolic link pointing from bar.c to foo.c, even if bar.c already exists\nFileUtils.ln_sf(\"foo.c\", \"bar.c\")\n```","summary":"<p>Like <code><a href=\"FileUtils.html#ln_s%28src_path%3APath%7CString%2Cdest_path%3APath%7CString%29%3ANil-instance-method\">#ln_s(Path | String, Path | String)</a></code>, but overwrites <code>dest_path</code> if it exists and is not a directory or if <code>dest_path/src_path</code> exists.</p>","abstract":false,"args":[{"name":"src_path","external_name":"src_path","restriction":"Path | String"},{"name":"dest_path","external_name":"dest_path","restriction":"Path | String"}],"args_string":"(src_path : Path | String, dest_path : Path | String) : Nil","args_html":"(src_path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, dest_path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":220,"url":null},"def":{"name":"ln_sf","args":[{"name":"src_path","external_name":"src_path","restriction":"Path | String"},{"name":"dest_path","external_name":"dest_path","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"if File.directory?(dest_path)\n  dest_path = File.join(dest_path, File.basename(src_path))\nend\nif File.file?(dest_path)\n  File.delete(dest_path)\nend\nFile.symlink(src_path, dest_path)\n"}},{"html_id":"ln_sf(src_paths:Enumerable(Path|String),dest_dir:Path|String):Nil-instance-method","name":"ln_sf","doc":"Creates a symbolic link to each path in *src_paths* inside the *dest_dir* directory,\nignoring any overwritten paths.\n\nIf *dest_dir* is not a directory, raises an `ArgumentError`.\n\n```\nrequire \"file_utils\"\n\n# Create symbolic links in src/ pointing to every .c file in the current directory,\n# even if it means overwriting files in src/\nFileUtils.ln_sf(Dir[\"*.c\"], \"src\")\n```","summary":"<p>Creates a symbolic link to each path in <em>src_paths</em> inside the <em>dest_dir</em> directory, ignoring any overwritten paths.</p>","abstract":false,"args":[{"name":"src_paths","external_name":"src_paths","restriction":"Enumerable(Path | String)"},{"name":"dest_dir","external_name":"dest_dir","restriction":"Path | String"}],"args_string":"(src_paths : Enumerable(Path | String), dest_dir : Path | String) : Nil","args_html":"(src_paths : <a href=\"Enumerable.html\">Enumerable</a>(<a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>), dest_dir : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":241,"url":null},"def":{"name":"ln_sf","args":[{"name":"src_paths","external_name":"src_paths","restriction":"Enumerable(Path | String)"},{"name":"dest_dir","external_name":"dest_dir","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"if Dir.exists?(dest_dir)\nelse\n  raise(ArgumentError.new(\"No such directory : #{dest_dir}\"))\nend\nsrc_paths.each do |path|\n  ln_sf(path, dest_dir)\nend\n"}},{"html_id":"mkdir(path:Path|String,mode=511):Nil-instance-method","name":"mkdir","doc":"Creates a new directory at the given *path*. The linux-style permission *mode*\ncan be specified, with a default of 777 (0o777).\n\n```\nrequire \"file_utils\"\n\nFileUtils.mkdir(\"src\")\n```\n\nNOTE: Alias of `Dir.mkdir`","summary":"<p>Creates a new directory at the given <em>path</em>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"mode","default_value":"511","external_name":"mode","restriction":""}],"args_string":"(path : Path | String, mode = 511) : Nil","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, mode = <span class=\"n\">511</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":259,"url":null},"def":{"name":"mkdir","args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"mode","default_value":"511","external_name":"mode","restriction":""}],"return_type":"Nil","visibility":"Public","body":"Dir.mkdir(path, mode)"}},{"html_id":"mkdir(paths:Enumerable(Path|String),mode=511):Nil-instance-method","name":"mkdir","doc":"Creates a new directory at the given *paths*. The linux-style permission *mode*\ncan be specified, with a default of 777 (0o777).\n\n```\nrequire \"file_utils\"\n\nFileUtils.mkdir([\"foo\", \"bar\"])\n```","summary":"<p>Creates a new directory at the given <em>paths</em>.</p>","abstract":false,"args":[{"name":"paths","external_name":"paths","restriction":"Enumerable(Path | String)"},{"name":"mode","default_value":"511","external_name":"mode","restriction":""}],"args_string":"(paths : Enumerable(Path | String), mode = 511) : Nil","args_html":"(paths : <a href=\"Enumerable.html\">Enumerable</a>(<a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>), mode = <span class=\"n\">511</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":271,"url":null},"def":{"name":"mkdir","args":[{"name":"paths","external_name":"paths","restriction":"Enumerable(Path | String)"},{"name":"mode","default_value":"511","external_name":"mode","restriction":""}],"return_type":"Nil","visibility":"Public","body":"paths.each do |path|\n  Dir.mkdir(path, mode)\nend"}},{"html_id":"mkdir_p(path:Path|String,mode=511):Nil-instance-method","name":"mkdir_p","doc":"Creates a new directory at the given *path*, including any non-existing\nintermediate directories. The linux-style permission *mode* can be specified,\nwith a default of 777 (0o777).\n\n```\nrequire \"file_utils\"\n\nFileUtils.mkdir_p(\"foo\")\n```\n\nNOTE: Alias of `Dir.mkdir_p`","summary":"<p>Creates a new directory at the given <em>path</em>, including any non-existing intermediate directories.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"mode","default_value":"511","external_name":"mode","restriction":""}],"args_string":"(path : Path | String, mode = 511) : Nil","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, mode = <span class=\"n\">511</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":288,"url":null},"def":{"name":"mkdir_p","args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"mode","default_value":"511","external_name":"mode","restriction":""}],"return_type":"Nil","visibility":"Public","body":"Dir.mkdir_p(path, mode)"}},{"html_id":"mkdir_p(paths:Enumerable(Path|String),mode=511):Nil-instance-method","name":"mkdir_p","doc":"Creates a new directory at the given *paths*, including any non-existing\nintermediate directories. The linux-style permission *mode* can be specified,\nwith a default of 777 (0o777).\n\n```\nrequire \"file_utils\"\n\nFileUtils.mkdir_p([\"foo\", \"bar\", \"baz\", \"dir1\", \"dir2\", \"dir3\"])\n```","summary":"<p>Creates a new directory at the given <em>paths</em>, including any non-existing intermediate directories.</p>","abstract":false,"args":[{"name":"paths","external_name":"paths","restriction":"Enumerable(Path | String)"},{"name":"mode","default_value":"511","external_name":"mode","restriction":""}],"args_string":"(paths : Enumerable(Path | String), mode = 511) : Nil","args_html":"(paths : <a href=\"Enumerable.html\">Enumerable</a>(<a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>), mode = <span class=\"n\">511</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":301,"url":null},"def":{"name":"mkdir_p","args":[{"name":"paths","external_name":"paths","restriction":"Enumerable(Path | String)"},{"name":"mode","default_value":"511","external_name":"mode","restriction":""}],"return_type":"Nil","visibility":"Public","body":"paths.each do |path|\n  Dir.mkdir_p(path, mode)\nend"}},{"html_id":"mv(src_path:Path|String,dest_path:Path|String):Nil-instance-method","name":"mv","doc":"Moves *src_path* to *dest_path*.\n\nNOTE: If *src_path* and *dest_path* exist on different mounted filesystems,\nthe file at *src_path* is copied to *dest_path* and then removed.\n\n```\nrequire \"file_utils\"\n\nFileUtils.mv(\"afile\", \"afile.cr\")\n```","summary":"<p>Moves <em>src_path</em> to <em>dest_path</em>.</p>","abstract":false,"args":[{"name":"src_path","external_name":"src_path","restriction":"Path | String"},{"name":"dest_path","external_name":"dest_path","restriction":"Path | String"}],"args_string":"(src_path : Path | String, dest_path : Path | String) : Nil","args_html":"(src_path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, dest_path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":317,"url":null},"def":{"name":"mv","args":[{"name":"src_path","external_name":"src_path","restriction":"Path | String"},{"name":"dest_path","external_name":"dest_path","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"if error = Crystal::System::File.rename(src_path.to_s, dest_path.to_s)\n  if Errno.value.in?(Errno::EXDEV, Errno::EPERM)\n  else\n    raise(error)\n  end\n  cp_r(src_path, dest_path)\n  rm_r(src_path)\nend"}},{"html_id":"mv(srcs:Enumerable(Path|String),dest:Path|String):Nil-instance-method","name":"mv","doc":"Moves every *srcs* to *dest*.\n\n```\nrequire \"file_utils\"\n\nFileUtils.mv([\"foo\", \"bar\"], \"src\")\n```","summary":"<p>Moves every <em>srcs</em> to <em>dest</em>.</p>","abstract":false,"args":[{"name":"srcs","external_name":"srcs","restriction":"Enumerable(Path | String)"},{"name":"dest","external_name":"dest","restriction":"Path | String"}],"args_string":"(srcs : Enumerable(Path | String), dest : Path | String) : Nil","args_html":"(srcs : <a href=\"Enumerable.html\">Enumerable</a>(<a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>), dest : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":332,"url":null},"def":{"name":"mv","args":[{"name":"srcs","external_name":"srcs","restriction":"Enumerable(Path | String)"},{"name":"dest","external_name":"dest","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"if Dir.exists?(dest)\nelse\n  raise(ArgumentError.new(\"No such directory : #{dest}\"))\nend\nsrcs.each do |src|\n  begin\n    mv(src, File.join(dest, File.basename(src)))\n  rescue File::Error\n  end\nend\n"}},{"html_id":"pwd:String-instance-method","name":"pwd","doc":"Returns the current working directory.\n\n```\nrequire \"file_utils\"\n\nFileUtils.pwd\n```\n\nNOTE: Alias of `Dir.current`","summary":"<p>Returns the current working directory.</p>","abstract":false,"location":{"filename":"src/file_utils.cr","line_number":351,"url":null},"def":{"name":"pwd","return_type":"String","visibility":"Public","body":"Dir.current"}},{"html_id":"rm(path:Path|String):Nil-instance-method","name":"rm","doc":"Deletes the *path* file given.\n\n```\nrequire \"file_utils\"\n\nFileUtils.rm(\"afile.cr\")\n```\n\nNOTE: Alias of `File.delete`","summary":"<p>Deletes the <em>path</em> file given.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Nil","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":364,"url":null},"def":{"name":"rm","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"File.delete(path)"}},{"html_id":"rm(paths:Enumerable(Path|String)):Nil-instance-method","name":"rm","doc":"Deletes all *paths* file given.\n\n```\nrequire \"file_utils\"\n\nFileUtils.rm([\"dir/afile\", \"afile_copy\"])\n```","summary":"<p>Deletes all <em>paths</em> file given.</p>","abstract":false,"args":[{"name":"paths","external_name":"paths","restriction":"Enumerable(Path | String)"}],"args_string":"(paths : Enumerable(Path | String)) : Nil","args_html":"(paths : <a href=\"Enumerable.html\">Enumerable</a>(<a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>)) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":375,"url":null},"def":{"name":"rm","args":[{"name":"paths","external_name":"paths","restriction":"Enumerable(Path | String)"}],"return_type":"Nil","visibility":"Public","body":"paths.each do |path|\n  File.delete(path)\nend"}},{"html_id":"rm_r(path:Path|String):Nil-instance-method","name":"rm_r","doc":"Deletes a file or directory *path*.\nIf *path* is a directory, this method removes all its contents recursively.\n\n```\nrequire \"file_utils\"\n\nFileUtils.rm_r(\"dir\")\nFileUtils.rm_r(\"file.cr\")\n```","summary":"<p>Deletes a file or directory <em>path</em>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Nil","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":390,"url":null},"def":{"name":"rm_r","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"if (Dir.exists?(path)) && (!(File.symlink?(path)))\n  Dir.each_child(path) do |entry|\n    src = File.join(path, entry)\n    rm_r(src)\n  end\n  Dir.delete(path)\nelse\n  File.delete(path)\nend"}},{"html_id":"rm_r(paths:Enumerable(Path|String)):Nil-instance-method","name":"rm_r","doc":"Deletes a list of files or directories *paths*.\nIf one path is a directory, this method removes all its contents recursively.\n\n```\nrequire \"file_utils\"\n\nFileUtils.rm_r([\"files\", \"bar.cr\"])\n```","summary":"<p>Deletes a list of files or directories <em>paths</em>.</p>","abstract":false,"args":[{"name":"paths","external_name":"paths","restriction":"Enumerable(Path | String)"}],"args_string":"(paths : Enumerable(Path | String)) : Nil","args_html":"(paths : <a href=\"Enumerable.html\">Enumerable</a>(<a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>)) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":410,"url":null},"def":{"name":"rm_r","args":[{"name":"paths","external_name":"paths","restriction":"Enumerable(Path | String)"}],"return_type":"Nil","visibility":"Public","body":"paths.each do |path|\n  rm_r(path)\nend"}},{"html_id":"rm_rf(path:Path|String):Nil-instance-method","name":"rm_rf","doc":"Deletes a file or directory *path*.\nIf *path* is a directory, this method removes all its contents recursively.\nIgnores all errors.\n\n```\nrequire \"file_utils\"\n\nFileUtils.rm_rf(\"dir\")\nFileUtils.rm_rf(\"file.cr\")\nFileUtils.rm_rf(\"non_existent_file\")\n```","summary":"<p>Deletes a file or directory <em>path</em>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Nil","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":427,"url":null},"def":{"name":"rm_rf","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"begin\n  rm_r(path)\nrescue File::Error\nend"}},{"html_id":"rm_rf(paths:Enumerable(Path|String)):Nil-instance-method","name":"rm_rf","doc":"Deletes a list of files or directories *paths*.\nIf one path is a directory, this method removes all its contents recursively.\nIgnores all errors.\n\n```\nrequire \"file_utils\"\n\nFileUtils.rm_rf([\"dir\", \"file.cr\", \"non_existent_file\"])\n```","summary":"<p>Deletes a list of files or directories <em>paths</em>.</p>","abstract":false,"args":[{"name":"paths","external_name":"paths","restriction":"Enumerable(Path | String)"}],"args_string":"(paths : Enumerable(Path | String)) : Nil","args_html":"(paths : <a href=\"Enumerable.html\">Enumerable</a>(<a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>)) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":443,"url":null},"def":{"name":"rm_rf","args":[{"name":"paths","external_name":"paths","restriction":"Enumerable(Path | String)"}],"return_type":"Nil","visibility":"Public","body":"paths.each do |path|\n  begin\n    rm_r(path)\n  rescue File::Error\n  end\nend"}},{"html_id":"rmdir(path:Path|String):Nil-instance-method","name":"rmdir","doc":"Removes the directory at the given *path*.\n\n```\nrequire \"file_utils\"\n\nFileUtils.rmdir(\"baz\")\n```\n\nNOTE: Alias of `Dir.rmdir`","summary":"<p>Removes the directory at the given <em>path</em>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"args_string":"(path : Path | String) : Nil","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":461,"url":null},"def":{"name":"rmdir","args":[{"name":"path","external_name":"path","restriction":"Path | String"}],"return_type":"Nil","visibility":"Public","body":"Dir.delete(path)"}},{"html_id":"rmdir(paths:Enumerable(Path|String)):Nil-instance-method","name":"rmdir","doc":"Removes all directories at the given *paths*.\n\n```\nrequire \"file_utils\"\n\nFileUtils.rmdir([\"dir1\", \"dir2\", \"dir3\"])\n```","summary":"<p>Removes all directories at the given <em>paths</em>.</p>","abstract":false,"args":[{"name":"paths","external_name":"paths","restriction":"Enumerable(Path | String)"}],"args_string":"(paths : Enumerable(Path | String)) : Nil","args_html":"(paths : <a href=\"Enumerable.html\">Enumerable</a>(<a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>)) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":472,"url":null},"def":{"name":"rmdir","args":[{"name":"paths","external_name":"paths","restriction":"Enumerable(Path | String)"}],"return_type":"Nil","visibility":"Public","body":"paths.each do |path|\n  Dir.delete(path)\nend"}},{"html_id":"touch(path:Path|String,time:Time=Time.utc):Nil-instance-method","name":"touch","doc":"Attempts to set the access and modification times of the file named\nin the *path* parameter to the value given in *time*.\n\nIf the file does not exist, it will be created.\n\n```\nrequire \"file_utils\"\n\nFileUtils.touch(\"afile.cr\")\n```\n\nNOTE: Alias of `File.touch`","summary":"<p>Attempts to set the access and modification times of the file named in the <em>path</em> parameter to the value given in <em>time</em>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"time","default_value":"Time.utc","external_name":"time","restriction":"Time"}],"args_string":"(path : Path | String, time : Time = Time.utc) : Nil","args_html":"(path : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, time : <a href=\"Time.html\">Time</a> = <span class=\"t\">Time</span>.utc) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":59,"url":null},"def":{"name":"touch","args":[{"name":"path","external_name":"path","restriction":"Path | String"},{"name":"time","default_value":"Time.utc","external_name":"time","restriction":"Time"}],"return_type":"Nil","visibility":"Public","body":"File.touch(path, time)"}},{"html_id":"touch(paths:Enumerable(Path|String),time:Time=Time.utc):Nil-instance-method","name":"touch","doc":"Attempts to set the access and modification times of each file given\nin the *paths* parameter to the value given in *time*.\n\nIf the file does not exist, it will be created.\n\n```\nrequire \"file_utils\"\n\nFileUtils.touch([\"foo\", \"bar\"])\n```","summary":"<p>Attempts to set the access and modification times of each file given in the <em>paths</em> parameter to the value given in <em>time</em>.</p>","abstract":false,"args":[{"name":"paths","external_name":"paths","restriction":"Enumerable(Path | String)"},{"name":"time","default_value":"Time.utc","external_name":"time","restriction":"Time"}],"args_string":"(paths : Enumerable(Path | String), time : Time = Time.utc) : Nil","args_html":"(paths : <a href=\"Enumerable.html\">Enumerable</a>(<a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>), time : <a href=\"Time.html\">Time</a> = <span class=\"t\">Time</span>.utc) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/file_utils.cr","line_number":73,"url":null},"def":{"name":"touch","args":[{"name":"paths","external_name":"paths","restriction":"Enumerable(Path | String)"},{"name":"time","default_value":"Time.utc","external_name":"time","restriction":"Time"}],"return_type":"Nil","visibility":"Public","body":"paths.each do |path|\n  touch(path, time)\nend"}}]},{"html_id":"Crystal/Flags","path":"Flags.html","kind":"annotation","full_name":"Flags","name":"Flags","abstract":false,"locations":[{"filename":"src/annotations.cr","line_number":27,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"An enum can be marked with `@[Flags]`. This changes the default values.\nThe first constant's value is 1, and successive constants are multiplied by 2.\n\n```\n@[Flags]\nenum IOMode\n  Read  # 1\n  Write # 2\n  Async # 4\nend\n\n(IOMode::Write | IOMode::Async).value # => 6\n(IOMode::Write | IOMode::Async).to_s  # => \"Write | Async\"\n```","summary":"<p>An enum can be marked with <code>@[<a href=\"Flags.html\">Flags</a>]</code>.</p>"},{"html_id":"Crystal/Float","path":"Float.html","kind":"struct","full_name":"Float","name":"Float","abstract":true,"superclass":{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/big_decimal.cr","line_number":663,"url":null},{"filename":"src/big/big_int.cr","line_number":771,"url":null},{"filename":"src/big/big_rational.cr","line_number":340,"url":null},{"filename":"src/big/number.cr","line_number":105,"url":null},{"filename":"src/float.cr","line_number":39,"url":null},{"filename":"src/json/to_json.cr","line_number":53,"url":null},{"filename":"src/time/span.cr","line_number":507,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":83,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"subclasses":[{"html_id":"Crystal/BigFloat","kind":"struct","full_name":"BigFloat","name":"BigFloat"},{"html_id":"Crystal/Float32","kind":"struct","full_name":"Float32","name":"Float32"},{"html_id":"Crystal/Float64","kind":"struct","full_name":"Float64","name":"Float64"}],"doc":"Float is the base type of all floating point numbers.\n\nThere are two floating point types, `Float32` and `Float64`,\nwhich correspond to the [binary32](http://en.wikipedia.org/wiki/Single_precision_floating-point_format)\nand [binary64](http://en.wikipedia.org/wiki/Double_precision_floating-point_format)\ntypes defined by IEEE.\n\nA floating point literal is an optional `+` or `-` sign, followed by\na sequence of numbers or underscores, followed by a dot,\nfollowed by numbers or underscores, followed by an optional exponent suffix,\nfollowed by an optional type suffix. If no suffix is present, the literal's type is `Float64`.\n\n```\n1.0     # Float64\n1.0_f32 # Float32\n1_f32   # Float32\n\n1e10   # Float64\n1.5e10 # Float64\n1.5e-7 # Float64\n\n+1.3 # Float64\n-0.5 # Float64\n```\n\nThe underscore `_` before the suffix is optional.\n\nUnderscores can be used to make some numbers more readable:\n\n```\n1_000_000.111_111 # better than 1000000.111111\n```\n\nSee [`Float` literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/floats.html) in the language reference.","summary":"<p>Float is the base type of all floating point numbers.</p>","constructors":[{"html_id":"from_io(io:IO,format:IO::ByteFormat):self-class-method","name":"from_io","doc":"Reads a float from the given *io* in the given *format*.\nSee also: `IO#read_bytes`.","summary":"<p>Reads a float from the given <em>io</em> in the given <em>format</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"format","external_name":"format","restriction":"IO::ByteFormat"}],"args_string":"(io : IO, format : IO::ByteFormat) : self","args_html":"(io : <a href=\"IO.html\">IO</a>, format : <a href=\"IO/ByteFormat.html\">IO::ByteFormat</a>) : <span class=\"k\">self</span>","location":{"filename":"src/float.cr","line_number":104,"url":null},"def":{"name":"from_io","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"format","external_name":"format","restriction":"IO::ByteFormat"}],"return_type":"self","visibility":"Public","body":"format.decode(self, io)"}}],"instance_methods":[{"html_id":"%(other)-instance-method","name":"%","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/float.cr","line_number":50,"url":null},"def":{"name":"%","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"modulo(other)"}},{"html_id":"--instance-method","name":"-","abstract":false,"location":{"filename":"src/float.cr","line_number":42,"url":null},"def":{"name":"-","visibility":"Public","body":"self.class.zero - self"}},{"html_id":"//(other)-instance-method","name":"//","doc":"Divides `self` by *other* using floored division.\n\nThe result will be of the same type as `self`.","summary":"<p>Divides <code>self</code> by <em>other</em> using floored division.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/float.cr","line_number":46,"url":null},"def":{"name":"//","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"(self.fdiv(other)).floor"}},{"html_id":"<=>(other:BigInt)-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt)","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>)","location":{"filename":"src/big/big_int.cr","line_number":774,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"visibility":"Public","body":"-(other <=> self)"}},{"html_id":"<=>(other:BigRational)-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational)","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>)","location":{"filename":"src/big/big_rational.cr","line_number":353,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"visibility":"Public","body":"-(other <=> self)"}},{"html_id":"<=>(other:BigDecimal)-instance-method","name":"<=>","doc":"The comparison operator. Returns `0` if the two objects are equal,\na negative number if this object is considered less than *other*,\na positive number if this object is considered greater than *other*,\nor `nil` if the two objects are not comparable.\n\nSubclasses define this method to provide class-specific ordering.\n\nThe comparison operator is usually used to sort values:\n\n```\n# Sort in a descending way:\n[3, 1, 2].sort { |x, y| y <=> x } # => [3, 2, 1]\n\n# Sort in an ascending way:\n[3, 1, 2].sort { |x, y| x <=> y } # => [1, 2, 3]\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal)","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>)","location":{"filename":"src/big/big_decimal.cr","line_number":666,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"visibility":"Public","body":"to_big_d <=> other"}},{"html_id":"days:Time::Span-instance-method","name":"days","doc":"Returns a `Time::Span` of `self` days.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> days.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":514,"url":null},"def":{"name":"days","return_type":"Time::Span","visibility":"Public","body":"(self * 24).hours"}},{"html_id":"fdiv(other:BigInt|BigFloat|BigDecimal|BigRational):self-instance-method","name":"fdiv","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt | BigFloat | BigDecimal | BigRational"}],"args_string":"(other : BigInt | BigFloat | BigDecimal | BigRational) : self","args_html":"(other : <a href=\"BigInt.html\">BigInt</a> | <a href=\"BigFloat.html\">BigFloat</a> | <a href=\"BigDecimal.html\">BigDecimal</a> | <a href=\"BigRational.html\">BigRational</a>) : <span class=\"k\">self</span>","location":{"filename":"src/big/number.cr","line_number":106,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"BigInt | BigFloat | BigDecimal | BigRational"}],"return_type":"self","visibility":"Public","body":"self.class.new(self / other)"}},{"html_id":"finite?:Bool-instance-method","name":"finite?","abstract":false,"location":{"filename":"src/float.cr","line_number":66,"url":null},"def":{"name":"finite?","return_type":"Bool","visibility":"Public","body":"(!nan?) && (!infinite?)"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/float.cr","line_number":92,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher.float(self)"}},{"html_id":"hours:Time::Span-instance-method","name":"hours","doc":"Returns a `Time::Span` of `self` hours.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> hours.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":519,"url":null},"def":{"name":"hours","return_type":"Time::Span","visibility":"Public","body":"(self * 60).minutes"}},{"html_id":"infinite?:Int32?-instance-method","name":"infinite?","abstract":false,"location":{"filename":"src/float.cr","line_number":58,"url":null},"def":{"name":"infinite?","return_type":"Int32 | ::Nil","visibility":"Public","body":"if (nan? || (self == 0)) || (self != (2 * self))\n  nil\nelse\n  self > 0 ? 1 : -1\nend"}},{"html_id":"microseconds:Time::Span-instance-method","name":"microseconds","doc":"Returns a `Time::Span` of `self` microseconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> microseconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":548,"url":null},"def":{"name":"microseconds","return_type":"Time::Span","visibility":"Public","body":"(self / 1000000).seconds"}},{"html_id":"milliseconds:Time::Span-instance-method","name":"milliseconds","doc":"Returns a `Time::Span` of `self` milliseconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> milliseconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":543,"url":null},"def":{"name":"milliseconds","return_type":"Time::Span","visibility":"Public","body":"(self / 1000).seconds"}},{"html_id":"minutes:Time::Span-instance-method","name":"minutes","doc":"Returns a `Time::Span` of `self` minutes.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> minutes.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":524,"url":null},"def":{"name":"minutes","return_type":"Time::Span","visibility":"Public","body":"(self * 60).seconds"}},{"html_id":"modulo(other)-instance-method","name":"modulo","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/float.cr","line_number":70,"url":null},"def":{"name":"modulo","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"if other == 0.0\n  raise(DivisionByZeroError.new)\nelse\n  self - (other * (self // other))\nend"}},{"html_id":"nan?:Bool-instance-method","name":"nan?","abstract":false,"location":{"filename":"src/float.cr","line_number":54,"url":null},"def":{"name":"nan?","return_type":"Bool","visibility":"Public","body":"!(self == self)"}},{"html_id":"nanoseconds:Time::Span-instance-method","name":"nanoseconds","doc":"Returns a `Time::Span` of `self` nanoseconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> nanoseconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":553,"url":null},"def":{"name":"nanoseconds","return_type":"Time::Span","visibility":"Public","body":"seconds = (self / Time::NANOSECONDS_PER_SECOND).to_i64\nnanoseconds = self.remainder(Time::NANOSECONDS_PER_SECOND)\nnanoseconds = (nanoseconds < 0 ? (nanoseconds - 0.5) : (nanoseconds + 0.5)).to_i64\nTime::Span.new(seconds: seconds, nanoseconds: nanoseconds)\n"}},{"html_id":"remainder(other)-instance-method","name":"remainder","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/float.cr","line_number":78,"url":null},"def":{"name":"remainder","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"if other == 0.0\n  raise(DivisionByZeroError.new)\nelse\n  mod = self % other\n  if mod == 0.0\n    return self.class.zero\n  end\n  if self > 0 && other > 0\n    return mod\n  end\n  if self < 0 && other < 0\n    return mod\n  end\n  mod - other\nend"}},{"html_id":"seconds:Time::Span-instance-method","name":"seconds","doc":"Returns a `Time::Span` of `self` seconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> seconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":529,"url":null},"def":{"name":"seconds","return_type":"Time::Span","visibility":"Public","body":"seconds = self.to_i64\nnanoseconds = (self - seconds) * Time::NANOSECONDS_PER_SECOND\nnanoseconds = (nanoseconds < 0 ? (nanoseconds - 0.5) : (nanoseconds + 0.5)).to_i64\nTime::Span.new(seconds: seconds, nanoseconds: nanoseconds)\n"}},{"html_id":"to_big_d:BigDecimal-instance-method","name":"to_big_d","doc":"Converts `self` to `BigDecimal`.\n\nNOTE: Floats are fundamentally less precise than BigDecimals,\nwhich makes conversion to them risky.\n```\nrequire \"big\"\n1212341515125412412412421.0.to_big_d\n```","summary":"<p>Converts <code>self</code> to <code><a href=\"BigDecimal.html\">BigDecimal</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":678,"url":null},"def":{"name":"to_big_d","return_type":"BigDecimal","visibility":"Public","body":"BigDecimal.new(self)"}},{"html_id":"to_big_i:BigInt-instance-method","name":"to_big_i","doc":"Returns a `BigInt` representing this float (rounded using `floor`).\n```\nrequire \"big\"\n\n1212341515125412412412421.0.to_big_i\n```","summary":"<p>Returns a <code><a href=\"BigInt.html\">BigInt</a></code> representing this float (rounded using <code>floor</code>).</p>","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":784,"url":null},"def":{"name":"to_big_i","return_type":"BigInt","visibility":"Public","body":"BigInt.new(self)"}},{"html_id":"to_big_r:BigRational-instance-method","name":"to_big_r","doc":"Returns a `BigRational` representing this float.\n```\nrequire \"big\"\n\n123.0.to_big_r\n```","summary":"<p>Returns a <code><a href=\"BigRational.html\">BigRational</a></code> representing this float.</p>","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":349,"url":null},"def":{"name":"to_big_r","return_type":"BigRational","visibility":"Public","body":"BigRational.new(self)"}},{"html_id":"to_io(io:IO,format:IO::ByteFormat):Nil-instance-method","name":"to_io","doc":"Writes this float to the given *io* in the given *format*.\nSee also: `IO#write_bytes`.","summary":"<p>Writes this float to the given <em>io</em> in the given <em>format</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"format","external_name":"format","restriction":"IO::ByteFormat"}],"args_string":"(io : IO, format : IO::ByteFormat) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, format : <a href=\"IO/ByteFormat.html\">IO::ByteFormat</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/float.cr","line_number":98,"url":null},"def":{"name":"to_io","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"format","external_name":"format","restriction":"IO::ByteFormat"}],"return_type":"Nil","visibility":"Public","body":"format.encode(self, io)"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":54,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.number(self)"}},{"html_id":"to_json_object_key:String-instance-method","name":"to_json_object_key","abstract":false,"location":{"filename":"src/json/to_json.cr","line_number":58,"url":null},"def":{"name":"to_json_object_key","return_type":"String","visibility":"Public","body":"to_s"}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder) : Nil","args_html":"(yaml : <a href=\"YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":84,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"infinite = self.infinite?\nif infinite == 1\n  yaml.scalar(\".inf\")\nelse\n  if infinite == -1\n    yaml.scalar(\"-.inf\")\n  else\n    if nan?\n      yaml.scalar(\".nan\")\n    else\n      yaml.scalar(self.to_s)\n    end\n  end\nend\n"}},{"html_id":"weeks:Time::Span-instance-method","name":"weeks","doc":"Returns a `Time::Span` of `self` weeks.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> weeks.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":509,"url":null},"def":{"name":"weeks","return_type":"Time::Span","visibility":"Public","body":"(self * 7).days"}}],"types":[{"html_id":"Crystal/Float/Primitive","path":"Float/Primitive.html","kind":"alias","full_name":"Float::Primitive","name":"Primitive","abstract":false,"locations":[{"filename":"src/float.cr","line_number":40,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(Float32 | Float64)","aliased_html":"<a href=\"../Float32.html\">Float32</a> | <a href=\"../Float64.html\">Float64</a>","const":false,"namespace":{"html_id":"Crystal/Float","kind":"struct","full_name":"Float","name":"Float"}}]},{"html_id":"Crystal/Float32","path":"Float32.html","kind":"struct","full_name":"Float32","name":"Float32","abstract":false,"superclass":{"html_id":"Crystal/Float","kind":"struct","full_name":"Float","name":"Float"},"ancestors":[{"html_id":"Crystal/Float","kind":"struct","full_name":"Float","name":"Float"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/number.cr","line_number":111,"url":null},{"filename":"src/float.cr","line_number":109,"url":null},{"filename":"src/primitives.cr","line_number":280,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"DIGITS","name":"DIGITS","value":"6","doc":"The number of decimal digits that can be represented without losing precision","summary":"<p>The number of decimal digits that can be represented without losing precision</p>"},{"id":"EPSILON","name":"EPSILON","value":"1.19209290e-07_f32","doc":"The machine epsilon (difference between 1.0 and the next representable value)","summary":"<p>The machine epsilon (difference between 1.0 and the next representable value)</p>"},{"id":"INFINITY","name":"INFINITY","value":"(1_f32 / 0_f32).as(Float32)"},{"id":"MANT_DIGITS","name":"MANT_DIGITS","value":"24","doc":"The number of digits that can be represented without losing precision (in base RADIX)","summary":"<p>The number of digits that can be represented without losing precision (in base RADIX)</p>"},{"id":"MAX","name":"MAX","value":"3.40282347e+38_f32","doc":"Largest finite value","summary":"<p>Largest finite value</p>"},{"id":"MAX_10_EXP","name":"MAX_10_EXP","value":"38","doc":"The maximum possible power of 10 exponent (such that 10**MAX_10_EXP is representable)","summary":"<p>The maximum possible power of 10 exponent (such that 10**MAX_10_EXP is representable)</p>"},{"id":"MAX_EXP","name":"MAX_EXP","value":"128","doc":"The maximum possible normal power of 2 exponent","summary":"<p>The maximum possible normal power of 2 exponent</p>"},{"id":"MIN","name":"MIN","value":"-3.40282347e+38_f32","doc":"Smallest finite value","summary":"<p>Smallest finite value</p>"},{"id":"MIN_10_EXP","name":"MIN_10_EXP","value":"-37","doc":"The minimum possible power of 10 exponent (such that 10**MIN_10_EXP is representable)","summary":"<p>The minimum possible power of 10 exponent (such that 10**MIN_10_EXP is representable)</p>"},{"id":"MIN_EXP","name":"MIN_EXP","value":"-125","doc":"The minimum possible normal power of 2 exponent","summary":"<p>The minimum possible normal power of 2 exponent</p>"},{"id":"MIN_POSITIVE","name":"MIN_POSITIVE","value":"1.17549435e-38_f32","doc":"Smallest representable positive value","summary":"<p>Smallest representable positive value</p>"},{"id":"NAN","name":"NAN","value":"(0_f32 / 0_f32).as(Float32)"},{"id":"RADIX","name":"RADIX","value":"2","doc":"The radix or integer base used by the internal representation","summary":"<p>The radix or integer base used by the internal representation</p>"}],"constructors":[{"html_id":"from_json_object_key?(key:String):Float32?-class-method","name":"from_json_object_key?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String) : Float32?","args_html":"(key : <a href=\"String.html\">String</a>) : <a href=\"Float32.html\">Float32</a>?","location":{"filename":"src/json/from_json.cr","line_number":117,"url":null},"def":{"name":"from_json_object_key?","args":[{"name":"key","external_name":"key","restriction":"String"}],"return_type":"Float32 | ::Nil","visibility":"Public","body":"key.to_f32?"}},{"html_id":"new(value:String,whitespace:Bool=true,strict:Bool=true):self-class-method","name":"new","doc":"Returns a `Float32` by invoking `String#to_f32` on *value*.\n\n```\nFloat32.new \"20\"                        # => 20.0\nFloat32.new \"  20  \", whitespace: false # => Unhandled exception: Invalid Float32:   20 (ArgumentError)\n```","summary":"<p>Returns a <code><a href=\"Float32.html\">Float32</a></code> by invoking <code><a href=\"String.html#to_f32%28whitespace%3ABool%3Dtrue%2Cstrict%3ABool%3Dtrue%29-instance-method\">String#to_f32</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"args_string":"(value : String, whitespace : Bool = true, strict : Bool = true) : self","args_html":"(value : <a href=\"String.html\">String</a>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>) : <span class=\"k\">self</span>","location":{"filename":"src/float.cr","line_number":141,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"return_type":"self","visibility":"Public","body":"value.to_f32(whitespace: whitespace, strict: strict)"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":83,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"(parse_scalar(ctx, node, Float64)).to_f32!"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":106,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"case pull.kind\nwhen .int?\n  value = pull.int_value.to_f32\n  pull.read_next\n  value\nelse\n  pull.read_float.to_f32\nend"}},{"html_id":"new(value)-class-method","name":"new","doc":"Returns a `Float32` by invoking `to_f32` on *value*.","summary":"<p>Returns a <code><a href=\"Float32.html\">Float32</a></code> by invoking <code><a href=\"Float32.html#to_f32%3AFloat32-instance-method\">#to_f32</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/float.cr","line_number":146,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"value.to_f32"}},{"html_id":"new!(value):self-class-method","name":"new!","doc":"Returns a `Float32` by invoking `to_f32!` on *value*.","summary":"<p>Returns a <code><a href=\"Float32.html\">Float32</a></code> by invoking <code><a href=\"Float32.html#to_f32%21%3AFloat32-instance-method\">#to_f32!</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/float.cr","line_number":151,"url":null},"def":{"name":"new!","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_f32!"}}],"instance_methods":[{"html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"**(other:Int32)-instance-method","name":"**","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32)","args_html":"(other : <a href=\"Int32.html\">Int32</a>)","location":{"filename":"src/float.cr","line_number":194,"url":null},"def":{"name":"**","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"visibility":"Public","body":"{% if flag?(:win32) %}\n      self ** other.to_f32\n    {% else %}\n      LibM.powi_f32(self, other)\n    {% end %}"}},{"html_id":"**(other:Float32):Float32-instance-method","name":"**","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/float.cr","line_number":202,"url":null},"def":{"name":"**","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.pow_f32(self, other)"}},{"html_id":"**(other):Float32-instance-method","name":"**","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other) : Float32","args_html":"(other) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/float.cr","line_number":206,"url":null},"def":{"name":"**","args":[{"name":"other","external_name":"other","restriction":""}],"return_type":"Float32","visibility":"Public","body":"self ** other.to_f32"}},{"html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"/(other:Float32):Float32-instance-method","name":"/","doc":"Returns the result of division `self` and *other*.","summary":"<p>Returns the result of division <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"/(other:Int8):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Float32","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/float.cr","line_number":155,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:UInt8):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Float32","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/float.cr","line_number":155,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:Int16):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Float32","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/float.cr","line_number":155,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:UInt16):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Float32","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/float.cr","line_number":155,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:Int32):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Float32","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/float.cr","line_number":155,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:UInt32):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Float32","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/float.cr","line_number":155,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:Int64):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Float32","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/float.cr","line_number":155,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:UInt64):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Float32","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/float.cr","line_number":155,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:Int128):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Float32","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/float.cr","line_number":155,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:UInt128):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Float32","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/float.cr","line_number":155,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:Float64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/float.cr","line_number":156,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:BigInt):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigFloat","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":112,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigFloat):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigFloat","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":113,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":114,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":115,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"<(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"ceil:Float32-instance-method","name":"ceil","abstract":false,"location":{"filename":"src/float.cr","line_number":158,"url":null},"def":{"name":"ceil","return_type":"Float32","visibility":"Public","body":"LibM.ceil_f32(self)"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/float.cr","line_number":220,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"fdiv(other:Int8):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:Int16):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:Int32):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:Int64):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:Int128):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:UInt8):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:UInt16):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:UInt32):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:UInt64):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:UInt128):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:Float32):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:Float64):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"floor:Float32-instance-method","name":"floor","abstract":false,"location":{"filename":"src/float.cr","line_number":162,"url":null},"def":{"name":"floor","return_type":"Float32","visibility":"Public","body":"LibM.floor_f32(self)"}},{"html_id":"next_float:Float32-instance-method","name":"next_float","doc":"Returns the least `Float32` that is greater than `self`.","summary":"<p>Returns the least <code><a href=\"Float32.html\">Float32</a></code> that is greater than <code>self</code>.</p>","abstract":false,"location":{"filename":"src/float.cr","line_number":185,"url":null},"def":{"name":"next_float","return_type":"Float32","visibility":"Public","body":"LibM.nextafter_f32(self, INFINITY)"}},{"html_id":"prev_float:Float32-instance-method","name":"prev_float","doc":"Returns the greatest `Float32` that is less than `self`.","summary":"<p>Returns the greatest <code><a href=\"Float32.html\">Float32</a></code> that is less than <code>self</code>.</p>","abstract":false,"location":{"filename":"src/float.cr","line_number":190,"url":null},"def":{"name":"prev_float","return_type":"Float32","visibility":"Public","body":"LibM.nextafter_f32(self, -INFINITY)"}},{"html_id":"round_away:Float32-instance-method","name":"round_away","doc":"Rounds towards the nearest integer. If both neighboring integers are equidistant,\nrounds away from zero.","summary":"<p>Rounds towards the nearest integer.</p>","abstract":false,"location":{"filename":"src/float.cr","line_number":176,"url":null},"def":{"name":"round_away","return_type":"Float32","visibility":"Public","body":"LibM.round_f32(self)"}},{"html_id":"round_even:Float32-instance-method","name":"round_even","doc":"Rounds towards the nearest integer. If both neighboring integers are equidistant,\nrounds towards the even neighbor (Banker's rounding).","summary":"<p>Rounds towards the nearest integer.</p>","abstract":false,"location":{"filename":"src/float.cr","line_number":168,"url":null},"def":{"name":"round_even","return_type":"Float32","visibility":"Public","body":"LibM.rint_f32(self)"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f!:Float64-instance-method","name":"to_f!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n infinity is returned.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f32!:Float32-instance-method","name":"to_f32!","doc":"Returns `self` converted to `Float32`.\nIn case of overflow\n infinity is returned.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32!","return_type":"Float32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n infinity is returned.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i!:Int32-instance-method","name":"to_i!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128","return_type":"Int128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i128!:Int128-instance-method","name":"to_i128!","doc":"Returns `self` converted to `Int128`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128!","return_type":"Int128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i16!:Int16-instance-method","name":"to_i16!","doc":"Returns `self` converted to `Int16`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16!","return_type":"Int16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i64!:Int64-instance-method","name":"to_i64!","doc":"Returns `self` converted to `Int64`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64!","return_type":"Int64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i8!:Int8-instance-method","name":"to_i8!","doc":"Returns `self` converted to `Int8`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8!","return_type":"Int8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a `String` representation of this object\nto the given `IO` object.\n\nAn object must never append itself to the io argument,\nas this will in turn call `to_s(io)` on it.","summary":"<p>Appends a <code><a href=\"String.html\">String</a></code> representation of this object to the given <code><a href=\"IO.html\">IO</a></code> object.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/float.cr","line_number":216,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"Printer.print(self, io)"}},{"html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns a string representation of this object.\n\nDescendants must usually **not** override this method. Instead,\nthey must override `to_s(io)`, which must append to the given\nIO object.","summary":"<p>Returns a string representation of this object.</p>","abstract":false,"location":{"filename":"src/float.cr","line_number":210,"url":null},"def":{"name":"to_s","return_type":"String","visibility":"Public","body":"String.build(22) do |buffer|\n  Printer.print(self, buffer)\nend"}},{"html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u!:UInt32-instance-method","name":"to_u!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128","return_type":"UInt128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u128!:UInt128-instance-method","name":"to_u128!","doc":"Returns `self` converted to `UInt128`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128!","return_type":"UInt128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u16!:UInt16-instance-method","name":"to_u16!","doc":"Returns `self` converted to `UInt16`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16!","return_type":"UInt16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u64!:UInt64-instance-method","name":"to_u64!","doc":"Returns `self` converted to `UInt64`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64!","return_type":"UInt64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u8!:UInt8-instance-method","name":"to_u8!","doc":"Returns `self` converted to `UInt8`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8!","return_type":"UInt8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"trunc:Float32-instance-method","name":"trunc","abstract":false,"location":{"filename":"src/float.cr","line_number":180,"url":null},"def":{"name":"trunc","return_type":"Float32","visibility":"Public","body":"LibM.trunc_f32(self)"}}]},{"html_id":"Crystal/Float64","path":"Float64.html","kind":"struct","full_name":"Float64","name":"Float64","abstract":false,"superclass":{"html_id":"Crystal/Float","kind":"struct","full_name":"Float","name":"Float"},"ancestors":[{"html_id":"Crystal/Float","kind":"struct","full_name":"Float","name":"Float"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/number.cr","line_number":118,"url":null},{"filename":"src/float.cr","line_number":225,"url":null},{"filename":"src/primitives.cr","line_number":280,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"DIGITS","name":"DIGITS","value":"15","doc":"The number of decimal digits that can be represented without losing precision","summary":"<p>The number of decimal digits that can be represented without losing precision</p>"},{"id":"EPSILON","name":"EPSILON","value":"2.2204460492503131e-16","doc":"The machine epsilon (difference between 1.0 and the next representable value)","summary":"<p>The machine epsilon (difference between 1.0 and the next representable value)</p>"},{"id":"INFINITY","name":"INFINITY","value":"(1_f64 / 0_f64).as(Float64)"},{"id":"MANT_DIGITS","name":"MANT_DIGITS","value":"53","doc":"The number of digits that can be represented without losing precision (in base RADIX)","summary":"<p>The number of digits that can be represented without losing precision (in base RADIX)</p>"},{"id":"MAX","name":"MAX","value":"1.7976931348623157e+308","doc":"Largest finite value","summary":"<p>Largest finite value</p>"},{"id":"MAX_10_EXP","name":"MAX_10_EXP","value":"308","doc":"The maximum possible power of 10 exponent (such that 10**MAX_10_EXP is representable)","summary":"<p>The maximum possible power of 10 exponent (such that 10**MAX_10_EXP is representable)</p>"},{"id":"MAX_EXP","name":"MAX_EXP","value":"1024","doc":"The maximum possible normal power of 2 exponent","summary":"<p>The maximum possible normal power of 2 exponent</p>"},{"id":"MIN","name":"MIN","value":"-1.7976931348623157e+308","doc":"Smallest finite value","summary":"<p>Smallest finite value</p>"},{"id":"MIN_10_EXP","name":"MIN_10_EXP","value":"-307","doc":"The minimum possible power of 10 exponent (such that 10**MIN_10_EXP is representable)","summary":"<p>The minimum possible power of 10 exponent (such that 10**MIN_10_EXP is representable)</p>"},{"id":"MIN_EXP","name":"MIN_EXP","value":"-1021","doc":"The minimum possible normal power of 2 exponent","summary":"<p>The minimum possible normal power of 2 exponent</p>"},{"id":"MIN_POSITIVE","name":"MIN_POSITIVE","value":"2.2250738585072014e-308","doc":"Smallest representable positive value","summary":"<p>Smallest representable positive value</p>"},{"id":"NAN","name":"NAN","value":"(0_f64 / 0_f64).as(Float64)"},{"id":"RADIX","name":"RADIX","value":"2","doc":"The radix or integer base used by the internal representation","summary":"<p>The radix or integer base used by the internal representation</p>"}],"constructors":[{"html_id":"from_json_object_key?(key:String):Float64?-class-method","name":"from_json_object_key?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String) : Float64?","args_html":"(key : <a href=\"String.html\">String</a>) : <a href=\"Float64.html\">Float64</a>?","location":{"filename":"src/json/from_json.cr","line_number":132,"url":null},"def":{"name":"from_json_object_key?","args":[{"name":"key","external_name":"key","restriction":"String"}],"return_type":"Float64 | ::Nil","visibility":"Public","body":"key.to_f64?"}},{"html_id":"new(value:String,whitespace:Bool=true,strict:Bool=true):self-class-method","name":"new","doc":"Returns a `Float64` by invoking `String#to_f64` on *value*.\n\n```\nFloat64.new \"20\"                        # => 20.0\nFloat64.new \"  20  \", whitespace: false # => Unhandled exception: Invalid Float64:   20 (ArgumentError)\n```","summary":"<p>Returns a <code><a href=\"Float64.html\">Float64</a></code> by invoking <code><a href=\"String.html#to_f64%28whitespace%3ABool%3Dtrue%2Cstrict%3ABool%3Dtrue%29%3AFloat64-instance-method\">String#to_f64</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"args_string":"(value : String, whitespace : Bool = true, strict : Bool = true) : self","args_html":"(value : <a href=\"String.html\">String</a>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>) : <span class=\"k\">self</span>","location":{"filename":"src/float.cr","line_number":258,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"return_type":"self","visibility":"Public","body":"value.to_f64(whitespace: whitespace, strict: strict)"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":87,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"parse_scalar(ctx, node, self)"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":121,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"case pull.kind\nwhen .int?\n  value = pull.int_value.to_f\n  pull.read_next\n  value\nelse\n  pull.read_float.to_f\nend"}},{"html_id":"new(value)-class-method","name":"new","doc":"Returns a `Float64` by invoking `to_f64` on *value*.","summary":"<p>Returns a <code><a href=\"Float64.html\">Float64</a></code> by invoking <code><a href=\"Float64.html#to_f64%3AFloat64-instance-method\">#to_f64</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/float.cr","line_number":263,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"value.to_f64"}},{"html_id":"new!(value):Float64-class-method","name":"new!","doc":"Returns a `Float64` by invoking `to_f64!` on *value*.","summary":"<p>Returns a <code><a href=\"Float64.html\">Float64</a></code> by invoking <code><a href=\"Float64.html#to_f64%21%3AFloat64-instance-method\">#to_f64!</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : Float64","args_html":"(value) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/float.cr","line_number":268,"url":null},"def":{"name":"new!","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"Float64","visibility":"Public","body":"value.to_f64!"}}],"instance_methods":[{"html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"**(other:Int32)-instance-method","name":"**","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32)","args_html":"(other : <a href=\"Int32.html\">Int32</a>)","location":{"filename":"src/float.cr","line_number":311,"url":null},"def":{"name":"**","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"visibility":"Public","body":"{% if flag?(:win32) %}\n      self ** other.to_f64\n    {% else %}\n      LibM.powi_f64(self, other)\n    {% end %}"}},{"html_id":"**(other:Float64):Float64-instance-method","name":"**","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/float.cr","line_number":319,"url":null},"def":{"name":"**","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.pow_f64(self, other)"}},{"html_id":"**(other):Float64-instance-method","name":"**","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other) : Float64","args_html":"(other) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/float.cr","line_number":323,"url":null},"def":{"name":"**","args":[{"name":"other","external_name":"other","restriction":""}],"return_type":"Float64","visibility":"Public","body":"self ** other.to_f64"}},{"html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"/(other:Float64):Float64-instance-method","name":"/","doc":"Returns the result of division `self` and *other*.","summary":"<p>Returns the result of division <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"/(other:Int8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Float64","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/float.cr","line_number":272,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Float64","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/float.cr","line_number":272,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Float64","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/float.cr","line_number":272,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Float64","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/float.cr","line_number":272,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Float64","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/float.cr","line_number":272,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Float64","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/float.cr","line_number":272,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Float64","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/float.cr","line_number":272,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Float64","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/float.cr","line_number":272,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Float64","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/float.cr","line_number":272,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Float64","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/float.cr","line_number":272,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Float32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float64","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/float.cr","line_number":273,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:BigInt):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigFloat","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":119,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigFloat):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigFloat","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":120,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":121,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":122,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"<(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"ceil:Float64-instance-method","name":"ceil","abstract":false,"location":{"filename":"src/float.cr","line_number":275,"url":null},"def":{"name":"ceil","return_type":"Float64","visibility":"Public","body":"LibM.ceil_f64(self)"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/float.cr","line_number":337,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"fdiv(other:Int8):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:Int16):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:Int32):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:Int64):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:Int128):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:UInt8):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:UInt16):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:UInt32):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:UInt64):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:UInt128):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:Float32):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : self","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"fdiv(other:Float64):self-instance-method","name":"fdiv","doc":"Returns the float division of `self` and *other*.","summary":"<p>Returns the float division of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : self","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"floor:Float64-instance-method","name":"floor","abstract":false,"location":{"filename":"src/float.cr","line_number":279,"url":null},"def":{"name":"floor","return_type":"Float64","visibility":"Public","body":"LibM.floor_f64(self)"}},{"html_id":"next_float:Float64-instance-method","name":"next_float","doc":"Returns the least `Float64` that is greater than `self`.","summary":"<p>Returns the least <code><a href=\"Float64.html\">Float64</a></code> that is greater than <code>self</code>.</p>","abstract":false,"location":{"filename":"src/float.cr","line_number":302,"url":null},"def":{"name":"next_float","return_type":"Float64","visibility":"Public","body":"LibM.nextafter_f64(self, INFINITY)"}},{"html_id":"prev_float:Float64-instance-method","name":"prev_float","doc":"Returns the greatest `Float64` that is less than `self`.","summary":"<p>Returns the greatest <code><a href=\"Float64.html\">Float64</a></code> that is less than <code>self</code>.</p>","abstract":false,"location":{"filename":"src/float.cr","line_number":307,"url":null},"def":{"name":"prev_float","return_type":"Float64","visibility":"Public","body":"LibM.nextafter_f64(self, -INFINITY)"}},{"html_id":"round_away:Float64-instance-method","name":"round_away","doc":"Rounds towards the nearest integer. If both neighboring integers are equidistant,\nrounds away from zero.","summary":"<p>Rounds towards the nearest integer.</p>","abstract":false,"location":{"filename":"src/float.cr","line_number":293,"url":null},"def":{"name":"round_away","return_type":"Float64","visibility":"Public","body":"LibM.round_f64(self)"}},{"html_id":"round_even:Float64-instance-method","name":"round_even","doc":"Rounds towards the nearest integer. If both neighboring integers are equidistant,\nrounds towards the even neighbor (Banker's rounding).","summary":"<p>Rounds towards the nearest integer.</p>","abstract":false,"location":{"filename":"src/float.cr","line_number":285,"url":null},"def":{"name":"round_even","return_type":"Float64","visibility":"Public","body":"LibM.rint_f64(self)"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f!:Float64-instance-method","name":"to_f!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n infinity is returned.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f32!:Float32-instance-method","name":"to_f32!","doc":"Returns `self` converted to `Float32`.\nIn case of overflow\n infinity is returned.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32!","return_type":"Float32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n infinity is returned.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i!:Int32-instance-method","name":"to_i!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128","return_type":"Int128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i128!:Int128-instance-method","name":"to_i128!","doc":"Returns `self` converted to `Int128`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128!","return_type":"Int128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i16!:Int16-instance-method","name":"to_i16!","doc":"Returns `self` converted to `Int16`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16!","return_type":"Int16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i64!:Int64-instance-method","name":"to_i64!","doc":"Returns `self` converted to `Int64`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64!","return_type":"Int64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i8!:Int8-instance-method","name":"to_i8!","doc":"Returns `self` converted to `Int8`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8!","return_type":"Int8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a `String` representation of this object\nto the given `IO` object.\n\nAn object must never append itself to the io argument,\nas this will in turn call `to_s(io)` on it.","summary":"<p>Appends a <code><a href=\"String.html\">String</a></code> representation of this object to the given <code><a href=\"IO.html\">IO</a></code> object.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/float.cr","line_number":333,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"Printer.print(self, io)"}},{"html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns a string representation of this object.\n\nDescendants must usually **not** override this method. Instead,\nthey must override `to_s(io)`, which must append to the given\nIO object.","summary":"<p>Returns a string representation of this object.</p>","abstract":false,"location":{"filename":"src/float.cr","line_number":327,"url":null},"def":{"name":"to_s","return_type":"String","visibility":"Public","body":"String.build(22) do |buffer|\n  Printer.print(self, buffer)\nend"}},{"html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u!:UInt32-instance-method","name":"to_u!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128","return_type":"UInt128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u128!:UInt128-instance-method","name":"to_u128!","doc":"Returns `self` converted to `UInt128`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128!","return_type":"UInt128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u16!:UInt16-instance-method","name":"to_u16!","doc":"Returns `self` converted to `UInt16`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16!","return_type":"UInt16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u64!:UInt64-instance-method","name":"to_u64!","doc":"Returns `self` converted to `UInt64`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64!","return_type":"UInt64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u8!:UInt8-instance-method","name":"to_u8!","doc":"Returns `self` converted to `UInt8`.\nIn case of overflow\n the result is undefined.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8!","return_type":"UInt8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"trunc:Float64-instance-method","name":"trunc","abstract":false,"location":{"filename":"src/float.cr","line_number":297,"url":null},"def":{"name":"trunc","return_type":"Float64","visibility":"Public","body":"LibM.trunc_f64(self)"}}]},{"html_id":"Crystal/GC","path":"GC.html","kind":"module","full_name":"GC","name":"GC","abstract":false,"locations":[{"filename":"src/gc.cr","line_number":49,"url":null},{"filename":"src/gc/boehm.cr","line_number":103,"url":null},{"filename":"src/gc/none.cr","line_number":7,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"class_methods":[{"html_id":"add_finalizer(object:Reference):Nil-class-method","name":"add_finalizer","abstract":false,"args":[{"name":"object","external_name":"object","restriction":"Reference"}],"args_string":"(object : Reference) : Nil","args_html":"(object : <a href=\"Reference.html\">Reference</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/gc/boehm.cr","line_number":162,"url":null},"def":{"name":"add_finalizer","args":[{"name":"object","external_name":"object","restriction":"Reference"}],"return_type":"Nil","visibility":"Public","body":"add_finalizer_impl(object)"}},{"html_id":"add_finalizer(object)-class-method","name":"add_finalizer","abstract":false,"args":[{"name":"object","external_name":"object","restriction":""}],"args_string":"(object)","args_html":"(object)","location":{"filename":"src/gc/none.cr","line_number":43,"url":null},"def":{"name":"add_finalizer","args":[{"name":"object","external_name":"object","restriction":""}],"visibility":"Public","body":""}},{"html_id":"add_root(object:Reference)-class-method","name":"add_root","abstract":false,"args":[{"name":"object","external_name":"object","restriction":"Reference"}],"args_string":"(object : Reference)","args_html":"(object : <a href=\"Reference.html\">Reference</a>)","location":{"filename":"src/gc/boehm.cr","line_number":177,"url":null},"def":{"name":"add_root","args":[{"name":"object","external_name":"object","restriction":"Reference"}],"visibility":"Public","body":"roots = @@roots || (@@roots = [] of Pointer(Void))\nroots << (Pointer(Void).new(object.object_id))\n"}},{"html_id":"collect-class-method","name":"collect","abstract":false,"location":{"filename":"src/gc/none.cr","line_number":26,"url":null},"def":{"name":"collect","visibility":"Public","body":""}},{"html_id":"disable-class-method","name":"disable","abstract":false,"location":{"filename":"src/gc/none.cr","line_number":32,"url":null},"def":{"name":"disable","visibility":"Public","body":""}},{"html_id":"enable-class-method","name":"enable","abstract":false,"location":{"filename":"src/gc/none.cr","line_number":29,"url":null},"def":{"name":"enable","visibility":"Public","body":""}},{"html_id":"free(pointer:Pointer(Void)):Nil-class-method","name":"free","abstract":false,"args":[{"name":"pointer","external_name":"pointer","restriction":"::Pointer(Void)"}],"args_string":"(pointer : Pointer(Void)) : Nil","args_html":"(pointer : <a href=\"Pointer.html\">Pointer</a>(Void)) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/gc/none.cr","line_number":35,"url":null},"def":{"name":"free","args":[{"name":"pointer","external_name":"pointer","restriction":"::Pointer(Void)"}],"return_type":"Nil","visibility":"Public","body":"LibC.free(pointer)"}},{"html_id":"init-class-method","name":"init","abstract":false,"location":{"filename":"src/gc/none.cr","line_number":8,"url":null},"def":{"name":"init","visibility":"Public","body":""}},{"html_id":"is_heap_ptr(pointer:Pointer(Void)):Bool-class-method","name":"is_heap_ptr","abstract":false,"args":[{"name":"pointer","external_name":"pointer","restriction":"::Pointer(Void)"}],"args_string":"(pointer : Pointer(Void)) : Bool","args_html":"(pointer : <a href=\"Pointer.html\">Pointer</a>(Void)) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/gc/none.cr","line_number":39,"url":null},"def":{"name":"is_heap_ptr","args":[{"name":"pointer","external_name":"pointer","restriction":"::Pointer(Void)"}],"return_type":"Bool","visibility":"Public","body":"false"}},{"html_id":"malloc(size:Int):Pointer(Void)-class-method","name":"malloc","doc":"Allocates and clears *size* bytes of memory.\n\nThe resulting object may contain pointers and they will be tracked by the GC.\n\nThe memory will be automatically deallocated when unreferenced.","summary":"<p>Allocates and clears <em>size</em> bytes of memory.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int"}],"args_string":"(size : Int) : Pointer(Void)","args_html":"(size : <a href=\"Int.html\">Int</a>) : <a href=\"Pointer.html\">Pointer</a>(Void)","location":{"filename":"src/gc.cr","line_number":76,"url":null},"def":{"name":"malloc","args":[{"name":"size","external_name":"size","restriction":"Int"}],"return_type":"::Pointer(Void)","visibility":"Public","body":"malloc(LibC::SizeT.new(size))"}},{"html_id":"malloc_atomic(size:Int):Pointer(Void)-class-method","name":"malloc_atomic","doc":"Allocates *size* bytes of pointer-free memory.\n\nThe client promises that the resulting object will never contain any pointers.\n\nThe memory is not cleared. It will be automatically deallocated when unreferenced.","summary":"<p>Allocates <em>size</em> bytes of pointer-free memory.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int"}],"args_string":"(size : Int) : Pointer(Void)","args_html":"(size : <a href=\"Int.html\">Int</a>) : <a href=\"Pointer.html\">Pointer</a>(Void)","location":{"filename":"src/gc.cr","line_number":85,"url":null},"def":{"name":"malloc_atomic","args":[{"name":"size","external_name":"size","restriction":"Int"}],"return_type":"::Pointer(Void)","visibility":"Public","body":"malloc_atomic(LibC::SizeT.new(size))"}},{"html_id":"prof_stats-class-method","name":"prof_stats","abstract":false,"location":{"filename":"src/gc/none.cr","line_number":54,"url":null},"def":{"name":"prof_stats","visibility":"Public","body":"zero = LibC::ULong.new(0)\nProfStats.new(heap_size: zero, free_bytes: zero, unmapped_bytes: zero, bytes_since_gc: zero, bytes_before_gc: zero, non_gc_bytes: zero, gc_no: zero, markers_m1: zero, bytes_reclaimed_since_gc: zero, reclaimed_bytes_before_gc: zero)\n"}},{"html_id":"realloc(pointer:Pointer(Void),size:Int):Pointer(Void)-class-method","name":"realloc","doc":"Changes the allocated memory size of *pointer* to *size*.\nIf this can't be done in place, it allocates *size* bytes of memory and\ncopies the content of *pointer* to the new location.\n\nIf *pointer* was allocated with `malloc_atomic`, the same constraints apply.\n\nThe return value is a pointer that may be identical to *pointer* or different.","summary":"<p>Changes the allocated memory size of <em>pointer</em> to <em>size</em>.</p>","abstract":false,"args":[{"name":"pointer","external_name":"pointer","restriction":"::Pointer(Void)"},{"name":"size","external_name":"size","restriction":"Int"}],"args_string":"(pointer : Pointer(Void), size : Int) : Pointer(Void)","args_html":"(pointer : <a href=\"Pointer.html\">Pointer</a>(Void), size : <a href=\"Int.html\">Int</a>) : <a href=\"Pointer.html\">Pointer</a>(Void)","location":{"filename":"src/gc.cr","line_number":96,"url":null},"def":{"name":"realloc","args":[{"name":"pointer","external_name":"pointer","restriction":"::Pointer(Void)"},{"name":"size","external_name":"size","restriction":"Int"}],"return_type":"::Pointer(Void)","visibility":"Public","body":"realloc(pointer, LibC::SizeT.new(size))"}},{"html_id":"register_disappearing_link(pointer:Pointer(Pointer(Void)))-class-method","name":"register_disappearing_link","abstract":false,"args":[{"name":"pointer","external_name":"pointer","restriction":"::Pointer(::Pointer(Void))"}],"args_string":"(pointer : Pointer(Pointer(Void)))","args_html":"(pointer : <a href=\"Pointer.html\">Pointer</a>(<a href=\"Pointer.html\">Pointer</a>(Void)))","location":{"filename":"src/gc/none.cr","line_number":46,"url":null},"def":{"name":"register_disappearing_link","args":[{"name":"pointer","external_name":"pointer","restriction":"::Pointer(::Pointer(Void))"}],"visibility":"Public","body":""}},{"html_id":"set_stackbottom(stack_bottom:Pointer(Void))-class-method","name":"set_stackbottom","abstract":false,"args":[{"name":"stack_bottom","external_name":"stack_bottom","restriction":"::Pointer(Void)"}],"args_string":"(stack_bottom : Pointer(Void))","args_html":"(stack_bottom : <a href=\"Pointer.html\">Pointer</a>(Void))","location":{"filename":"src/gc/none.cr","line_number":94,"url":null},"def":{"name":"set_stackbottom","args":[{"name":"stack_bottom","external_name":"stack_bottom","restriction":"::Pointer(Void)"}],"visibility":"Public","body":""}},{"html_id":"stats:GC::Stats-class-method","name":"stats","abstract":false,"location":{"filename":"src/gc/none.cr","line_number":49,"url":null},"def":{"name":"stats","return_type":"GC::Stats","visibility":"Public","body":"zero = LibC::ULong.new(0)\nStats.new(zero, zero, zero, zero, zero)\n"}}],"types":[{"html_id":"Crystal/GC/ProfStats","path":"GC/ProfStats.html","kind":"struct","full_name":"GC::ProfStats","name":"ProfStats","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/gc.cr","line_number":59,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/GC","kind":"module","full_name":"GC","name":"GC"},"constructors":[{"html_id":"new(heap_size:LibC::ULong,free_bytes:LibC::ULong,unmapped_bytes:LibC::ULong,bytes_since_gc:LibC::ULong,bytes_before_gc:LibC::ULong,non_gc_bytes:LibC::ULong,gc_no:LibC::ULong,markers_m1:LibC::ULong,bytes_reclaimed_since_gc:LibC::ULong,reclaimed_bytes_before_gc:LibC::ULong)-class-method","name":"new","abstract":false,"args":[{"name":"heap_size","external_name":"heap_size","restriction":"LibC::ULong"},{"name":"free_bytes","external_name":"free_bytes","restriction":"LibC::ULong"},{"name":"unmapped_bytes","external_name":"unmapped_bytes","restriction":"LibC::ULong"},{"name":"bytes_since_gc","external_name":"bytes_since_gc","restriction":"LibC::ULong"},{"name":"bytes_before_gc","external_name":"bytes_before_gc","restriction":"LibC::ULong"},{"name":"non_gc_bytes","external_name":"non_gc_bytes","restriction":"LibC::ULong"},{"name":"gc_no","external_name":"gc_no","restriction":"LibC::ULong"},{"name":"markers_m1","external_name":"markers_m1","restriction":"LibC::ULong"},{"name":"bytes_reclaimed_since_gc","external_name":"bytes_reclaimed_since_gc","restriction":"LibC::ULong"},{"name":"reclaimed_bytes_before_gc","external_name":"reclaimed_bytes_before_gc","restriction":"LibC::ULong"}],"args_string":"(heap_size : LibC::ULong, free_bytes : LibC::ULong, unmapped_bytes : LibC::ULong, bytes_since_gc : LibC::ULong, bytes_before_gc : LibC::ULong, non_gc_bytes : LibC::ULong, gc_no : LibC::ULong, markers_m1 : LibC::ULong, bytes_reclaimed_since_gc : LibC::ULong, reclaimed_bytes_before_gc : LibC::ULong)","args_html":"(heap_size : LibC::ULong, free_bytes : LibC::ULong, unmapped_bytes : LibC::ULong, bytes_since_gc : LibC::ULong, bytes_before_gc : LibC::ULong, non_gc_bytes : LibC::ULong, gc_no : LibC::ULong, markers_m1 : LibC::ULong, bytes_reclaimed_since_gc : LibC::ULong, reclaimed_bytes_before_gc : LibC::ULong)","location":{"filename":"src/gc.cr","line_number":59,"url":null},"def":{"name":"new","args":[{"name":"heap_size","external_name":"heap_size","restriction":"LibC::ULong"},{"name":"free_bytes","external_name":"free_bytes","restriction":"LibC::ULong"},{"name":"unmapped_bytes","external_name":"unmapped_bytes","restriction":"LibC::ULong"},{"name":"bytes_since_gc","external_name":"bytes_since_gc","restriction":"LibC::ULong"},{"name":"bytes_before_gc","external_name":"bytes_before_gc","restriction":"LibC::ULong"},{"name":"non_gc_bytes","external_name":"non_gc_bytes","restriction":"LibC::ULong"},{"name":"gc_no","external_name":"gc_no","restriction":"LibC::ULong"},{"name":"markers_m1","external_name":"markers_m1","restriction":"LibC::ULong"},{"name":"bytes_reclaimed_since_gc","external_name":"bytes_reclaimed_since_gc","restriction":"LibC::ULong"},{"name":"reclaimed_bytes_before_gc","external_name":"reclaimed_bytes_before_gc","restriction":"LibC::ULong"}],"visibility":"Public","body":"_ = allocate\n_.initialize(heap_size, free_bytes, unmapped_bytes, bytes_since_gc, bytes_before_gc, non_gc_bytes, gc_no, markers_m1, bytes_reclaimed_since_gc, reclaimed_bytes_before_gc)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"bytes_before_gc:LibC::ULong-instance-method","name":"bytes_before_gc","abstract":false,"def":{"name":"bytes_before_gc","return_type":"LibC::ULong","visibility":"Public","body":"@bytes_before_gc"}},{"html_id":"bytes_reclaimed_since_gc:LibC::ULong-instance-method","name":"bytes_reclaimed_since_gc","abstract":false,"def":{"name":"bytes_reclaimed_since_gc","return_type":"LibC::ULong","visibility":"Public","body":"@bytes_reclaimed_since_gc"}},{"html_id":"bytes_since_gc:LibC::ULong-instance-method","name":"bytes_since_gc","abstract":false,"def":{"name":"bytes_since_gc","return_type":"LibC::ULong","visibility":"Public","body":"@bytes_since_gc"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/gc.cr","line_number":59,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new(@heap_size.clone, @free_bytes.clone, @unmapped_bytes.clone, @bytes_since_gc.clone, @bytes_before_gc.clone, @non_gc_bytes.clone, @gc_no.clone, @markers_m1.clone, @bytes_reclaimed_since_gc.clone, @reclaimed_bytes_before_gc.clone)"}},{"html_id":"copy_with(heap_size_heap_size=@heap_size,free_bytes_free_bytes=@free_bytes,unmapped_bytes_unmapped_bytes=@unmapped_bytes,bytes_since_gc_bytes_since_gc=@bytes_since_gc,bytes_before_gc_bytes_before_gc=@bytes_before_gc,non_gc_bytes_non_gc_bytes=@non_gc_bytes,gc_no_gc_no=@gc_no,markers_m1_markers_m1=@markers_m1,bytes_reclaimed_since_gc_bytes_reclaimed_since_gc=@bytes_reclaimed_since_gc,reclaimed_bytes_before_gc_reclaimed_bytes_before_gc=@reclaimed_bytes_before_gc)-instance-method","name":"copy_with","abstract":false,"args":[{"name":"_heap_size","default_value":"@heap_size","external_name":"heap_size","restriction":""},{"name":"_free_bytes","default_value":"@free_bytes","external_name":"free_bytes","restriction":""},{"name":"_unmapped_bytes","default_value":"@unmapped_bytes","external_name":"unmapped_bytes","restriction":""},{"name":"_bytes_since_gc","default_value":"@bytes_since_gc","external_name":"bytes_since_gc","restriction":""},{"name":"_bytes_before_gc","default_value":"@bytes_before_gc","external_name":"bytes_before_gc","restriction":""},{"name":"_non_gc_bytes","default_value":"@non_gc_bytes","external_name":"non_gc_bytes","restriction":""},{"name":"_gc_no","default_value":"@gc_no","external_name":"gc_no","restriction":""},{"name":"_markers_m1","default_value":"@markers_m1","external_name":"markers_m1","restriction":""},{"name":"_bytes_reclaimed_since_gc","default_value":"@bytes_reclaimed_since_gc","external_name":"bytes_reclaimed_since_gc","restriction":""},{"name":"_reclaimed_bytes_before_gc","default_value":"@reclaimed_bytes_before_gc","external_name":"reclaimed_bytes_before_gc","restriction":""}],"args_string":"(heap_size _heap_size = @heap_size, free_bytes _free_bytes = @free_bytes, unmapped_bytes _unmapped_bytes = @unmapped_bytes, bytes_since_gc _bytes_since_gc = @bytes_since_gc, bytes_before_gc _bytes_before_gc = @bytes_before_gc, non_gc_bytes _non_gc_bytes = @non_gc_bytes, gc_no _gc_no = @gc_no, markers_m1 _markers_m1 = @markers_m1, bytes_reclaimed_since_gc _bytes_reclaimed_since_gc = @bytes_reclaimed_since_gc, reclaimed_bytes_before_gc _reclaimed_bytes_before_gc = @reclaimed_bytes_before_gc)","args_html":"(heap_size _heap_size = @heap_size, free_bytes _free_bytes = @free_bytes, unmapped_bytes _unmapped_bytes = @unmapped_bytes, bytes_since_gc _bytes_since_gc = @bytes_since_gc, bytes_before_gc _bytes_before_gc = @bytes_before_gc, non_gc_bytes _non_gc_bytes = @non_gc_bytes, gc_no _gc_no = @gc_no, markers_m1 _markers_m1 = @markers_m1, bytes_reclaimed_since_gc _bytes_reclaimed_since_gc = @bytes_reclaimed_since_gc, reclaimed_bytes_before_gc _reclaimed_bytes_before_gc = @reclaimed_bytes_before_gc)","location":{"filename":"src/gc.cr","line_number":59,"url":null},"def":{"name":"copy_with","args":[{"name":"_heap_size","default_value":"@heap_size","external_name":"heap_size","restriction":""},{"name":"_free_bytes","default_value":"@free_bytes","external_name":"free_bytes","restriction":""},{"name":"_unmapped_bytes","default_value":"@unmapped_bytes","external_name":"unmapped_bytes","restriction":""},{"name":"_bytes_since_gc","default_value":"@bytes_since_gc","external_name":"bytes_since_gc","restriction":""},{"name":"_bytes_before_gc","default_value":"@bytes_before_gc","external_name":"bytes_before_gc","restriction":""},{"name":"_non_gc_bytes","default_value":"@non_gc_bytes","external_name":"non_gc_bytes","restriction":""},{"name":"_gc_no","default_value":"@gc_no","external_name":"gc_no","restriction":""},{"name":"_markers_m1","default_value":"@markers_m1","external_name":"markers_m1","restriction":""},{"name":"_bytes_reclaimed_since_gc","default_value":"@bytes_reclaimed_since_gc","external_name":"bytes_reclaimed_since_gc","restriction":""},{"name":"_reclaimed_bytes_before_gc","default_value":"@reclaimed_bytes_before_gc","external_name":"reclaimed_bytes_before_gc","restriction":""}],"visibility":"Public","body":"self.class.new(_heap_size, _free_bytes, _unmapped_bytes, _bytes_since_gc, _bytes_before_gc, _non_gc_bytes, _gc_no, _markers_m1, _bytes_reclaimed_since_gc, _reclaimed_bytes_before_gc)"}},{"html_id":"free_bytes:LibC::ULong-instance-method","name":"free_bytes","abstract":false,"def":{"name":"free_bytes","return_type":"LibC::ULong","visibility":"Public","body":"@free_bytes"}},{"html_id":"gc_no:LibC::ULong-instance-method","name":"gc_no","abstract":false,"def":{"name":"gc_no","return_type":"LibC::ULong","visibility":"Public","body":"@gc_no"}},{"html_id":"heap_size:LibC::ULong-instance-method","name":"heap_size","abstract":false,"def":{"name":"heap_size","return_type":"LibC::ULong","visibility":"Public","body":"@heap_size"}},{"html_id":"markers_m1:LibC::ULong-instance-method","name":"markers_m1","abstract":false,"def":{"name":"markers_m1","return_type":"LibC::ULong","visibility":"Public","body":"@markers_m1"}},{"html_id":"non_gc_bytes:LibC::ULong-instance-method","name":"non_gc_bytes","abstract":false,"def":{"name":"non_gc_bytes","return_type":"LibC::ULong","visibility":"Public","body":"@non_gc_bytes"}},{"html_id":"reclaimed_bytes_before_gc:LibC::ULong-instance-method","name":"reclaimed_bytes_before_gc","abstract":false,"def":{"name":"reclaimed_bytes_before_gc","return_type":"LibC::ULong","visibility":"Public","body":"@reclaimed_bytes_before_gc"}},{"html_id":"unmapped_bytes:LibC::ULong-instance-method","name":"unmapped_bytes","abstract":false,"def":{"name":"unmapped_bytes","return_type":"LibC::ULong","visibility":"Public","body":"@unmapped_bytes"}}]},{"html_id":"Crystal/GC/Stats","path":"GC/Stats.html","kind":"struct","full_name":"GC::Stats","name":"Stats","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/gc.cr","line_number":50,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/GC","kind":"module","full_name":"GC","name":"GC"},"constructors":[{"html_id":"new(heap_size:LibC::ULong,free_bytes:LibC::ULong,unmapped_bytes:LibC::ULong,bytes_since_gc:LibC::ULong,total_bytes:LibC::ULong)-class-method","name":"new","abstract":false,"args":[{"name":"heap_size","external_name":"heap_size","restriction":"LibC::ULong"},{"name":"free_bytes","external_name":"free_bytes","restriction":"LibC::ULong"},{"name":"unmapped_bytes","external_name":"unmapped_bytes","restriction":"LibC::ULong"},{"name":"bytes_since_gc","external_name":"bytes_since_gc","restriction":"LibC::ULong"},{"name":"total_bytes","external_name":"total_bytes","restriction":"LibC::ULong"}],"args_string":"(heap_size : LibC::ULong, free_bytes : LibC::ULong, unmapped_bytes : LibC::ULong, bytes_since_gc : LibC::ULong, total_bytes : LibC::ULong)","args_html":"(heap_size : LibC::ULong, free_bytes : LibC::ULong, unmapped_bytes : LibC::ULong, bytes_since_gc : LibC::ULong, total_bytes : LibC::ULong)","location":{"filename":"src/gc.cr","line_number":50,"url":null},"def":{"name":"new","args":[{"name":"heap_size","external_name":"heap_size","restriction":"LibC::ULong"},{"name":"free_bytes","external_name":"free_bytes","restriction":"LibC::ULong"},{"name":"unmapped_bytes","external_name":"unmapped_bytes","restriction":"LibC::ULong"},{"name":"bytes_since_gc","external_name":"bytes_since_gc","restriction":"LibC::ULong"},{"name":"total_bytes","external_name":"total_bytes","restriction":"LibC::ULong"}],"visibility":"Public","body":"_ = allocate\n_.initialize(heap_size, free_bytes, unmapped_bytes, bytes_since_gc, total_bytes)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"bytes_since_gc:LibC::ULong-instance-method","name":"bytes_since_gc","abstract":false,"def":{"name":"bytes_since_gc","return_type":"LibC::ULong","visibility":"Public","body":"@bytes_since_gc"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/gc.cr","line_number":50,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new(@heap_size.clone, @free_bytes.clone, @unmapped_bytes.clone, @bytes_since_gc.clone, @total_bytes.clone)"}},{"html_id":"copy_with(heap_size_heap_size=@heap_size,free_bytes_free_bytes=@free_bytes,unmapped_bytes_unmapped_bytes=@unmapped_bytes,bytes_since_gc_bytes_since_gc=@bytes_since_gc,total_bytes_total_bytes=@total_bytes)-instance-method","name":"copy_with","abstract":false,"args":[{"name":"_heap_size","default_value":"@heap_size","external_name":"heap_size","restriction":""},{"name":"_free_bytes","default_value":"@free_bytes","external_name":"free_bytes","restriction":""},{"name":"_unmapped_bytes","default_value":"@unmapped_bytes","external_name":"unmapped_bytes","restriction":""},{"name":"_bytes_since_gc","default_value":"@bytes_since_gc","external_name":"bytes_since_gc","restriction":""},{"name":"_total_bytes","default_value":"@total_bytes","external_name":"total_bytes","restriction":""}],"args_string":"(heap_size _heap_size = @heap_size, free_bytes _free_bytes = @free_bytes, unmapped_bytes _unmapped_bytes = @unmapped_bytes, bytes_since_gc _bytes_since_gc = @bytes_since_gc, total_bytes _total_bytes = @total_bytes)","args_html":"(heap_size _heap_size = @heap_size, free_bytes _free_bytes = @free_bytes, unmapped_bytes _unmapped_bytes = @unmapped_bytes, bytes_since_gc _bytes_since_gc = @bytes_since_gc, total_bytes _total_bytes = @total_bytes)","location":{"filename":"src/gc.cr","line_number":50,"url":null},"def":{"name":"copy_with","args":[{"name":"_heap_size","default_value":"@heap_size","external_name":"heap_size","restriction":""},{"name":"_free_bytes","default_value":"@free_bytes","external_name":"free_bytes","restriction":""},{"name":"_unmapped_bytes","default_value":"@unmapped_bytes","external_name":"unmapped_bytes","restriction":""},{"name":"_bytes_since_gc","default_value":"@bytes_since_gc","external_name":"bytes_since_gc","restriction":""},{"name":"_total_bytes","default_value":"@total_bytes","external_name":"total_bytes","restriction":""}],"visibility":"Public","body":"self.class.new(_heap_size, _free_bytes, _unmapped_bytes, _bytes_since_gc, _total_bytes)"}},{"html_id":"free_bytes:LibC::ULong-instance-method","name":"free_bytes","abstract":false,"def":{"name":"free_bytes","return_type":"LibC::ULong","visibility":"Public","body":"@free_bytes"}},{"html_id":"heap_size:LibC::ULong-instance-method","name":"heap_size","abstract":false,"def":{"name":"heap_size","return_type":"LibC::ULong","visibility":"Public","body":"@heap_size"}},{"html_id":"total_bytes:LibC::ULong-instance-method","name":"total_bytes","abstract":false,"def":{"name":"total_bytes","return_type":"LibC::ULong","visibility":"Public","body":"@total_bytes"}},{"html_id":"unmapped_bytes:LibC::ULong-instance-method","name":"unmapped_bytes","abstract":false,"def":{"name":"unmapped_bytes","return_type":"LibC::ULong","visibility":"Public","body":"@unmapped_bytes"}}]}]},{"html_id":"Crystal/Hash","path":"Hash.html","kind":"class","full_name":"Hash(K, V)","name":"Hash","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/hash.cr","line_number":35,"url":null},{"filename":"src/json/any.cr","line_number":319,"url":null},{"filename":"src/json/to_json.cr","line_number":117,"url":null},{"filename":"src/yaml/any.cr","line_number":358,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":23,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"}],"doc":"A `Hash` represents a collection of key-value mappings, similar to a dictionary.\n\nMain operations are storing a key-value mapping (`#[]=`) and\nquerying the value associated to a key (`#[]`). Key-value mappings can also be\ndeleted (`#delete`).\nKeys are unique within a hash. When adding a key-value mapping with a key that\nis already in use, the old value will be forgotten.\n\n```\n# Create a new Hash for mapping String to Int32\nhash = Hash(String, Int32).new\nhash[\"one\"] = 1\nhash[\"two\"] = 2\nhash[\"one\"] # => 1\n```\n\n[Hash literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/hash.html)\ncan also be used to create a `Hash`:\n\n```\n{\"one\" => 1, \"two\" => 2}\n```\n\nImplementation is based on an open hash table.\nTwo objects refer to the same hash key when their hash value (`Object#hash`)\nis identical and both objects are equal to each other (`Object#==`).\n\nEnumeration follows the order that the corresponding keys were inserted.\n\nNOTE: When using mutable data types as keys, changing the value of a key after\nit was inserted into the `Hash` may lead to undefined behaviour. This can be\nrestored by re-indexing the hash with `#rehash`.","summary":"<p>A <code><a href=\"Hash.html\">Hash</a></code> represents a collection of key-value mappings, similar to a dictionary.</p>","class_methods":[{"html_id":"zip(ary1:Array(K),ary2:Array(V))-class-method","name":"zip","doc":"Zips two arrays into a `Hash`, taking keys from *ary1* and values from *ary2*.\n\n```\nHash.zip([\"key1\", \"key2\", \"key3\"], [\"value1\", \"value2\", \"value3\"])\n# => {\"key1\" => \"value1\", \"key2\" => \"value2\", \"key3\" => \"value3\"}\n```","summary":"<p>Zips two arrays into a <code><a href=\"Hash.html\">Hash</a></code>, taking keys from <em>ary1</em> and values from <em>ary2</em>.</p>","abstract":false,"args":[{"name":"ary1","external_name":"ary1","restriction":"Array(K)"},{"name":"ary2","external_name":"ary2","restriction":"Array(V)"}],"args_string":"(ary1 : Array(K), ary2 : Array(V))","args_html":"(ary1 : <a href=\"Array.html\">Array</a>(K), ary2 : <a href=\"Array.html\">Array</a>(V))","location":{"filename":"src/hash.cr","line_number":1598,"url":null},"def":{"name":"zip","args":[{"name":"ary1","external_name":"ary1","restriction":"Array(K)"},{"name":"ary2","external_name":"ary2","restriction":"Array(V)"}],"visibility":"Public","body":"hash = {} of K => V\nary1.each_with_index do |key, i|\n  hash[key] = ary2[i]\nend\nhash\n"}}],"constructors":[{"html_id":"new(default_value:V,initial_capacity=nil)-class-method","name":"new","doc":"Creates a new empty `Hash` where the *default_value* is returned if a key is missing.\n\n```\ninventory = Hash(String, Int32).new(0)\ninventory[\"socks\"] = 3\ninventory[\"pickles\"] # => 0\n```\n\nNOTE: The default value is passed by reference:\n```\narr = [1, 2, 3]\nhash = Hash(String, Array(Int32)).new(arr)\nhash[\"3\"][1] = 4\narr # => [1, 4, 3]\n```\n\nThe *initial_capacity* is useful to avoid unnecessary reallocations\nof the internal buffer in case of growth. If the number of elements\na hash will hold is known, the hash should be initialized with that\ncapacity for improved performance. Otherwise, the default is 8.\nInputs lower than 8 are ignored.","summary":"<p>Creates a new empty <code><a href=\"Hash.html\">Hash</a></code> where the <em>default_value</em> is returned if a key is missing.</p>","abstract":false,"args":[{"name":"default_value","external_name":"default_value","restriction":"V"},{"name":"initial_capacity","default_value":"nil","external_name":"initial_capacity","restriction":""}],"args_string":"(default_value : V, initial_capacity = nil)","args_html":"(default_value : V, initial_capacity = <span class=\"n\">nil</span>)","location":{"filename":"src/hash.cr","line_number":310,"url":null},"def":{"name":"new","args":[{"name":"default_value","external_name":"default_value","restriction":"V"},{"name":"initial_capacity","default_value":"nil","external_name":"initial_capacity","restriction":""}],"visibility":"Public","body":"new(initial_capacity: initial_capacity) do\n  default_value\nend"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":141,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"ctx.read_alias(node, self) do |obj|\n  return obj\nend\nhash = new\nctx.record_anchor(node, hash)\nnew(ctx, node) do |key, value|\n  hash[key] = value\nend\nhash\n"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":"Reads a Hash from the given pull parser.\n\nKeys are read by invoking `from_json_object_key?` on this hash's\nkey type (`K`), which must return a value of type `K` or `nil`.\nIf `nil` is returned a `JSON::ParseException` is raised.\n\nValues are parsed using the regular `new(pull : JSON::PullParser)` method.","summary":"<p>Reads a Hash from the given pull parser.</p>","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":191,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"hash = new\npull.read_object do |key, key_location|\n  parsed_key = K.from_json_object_key?(key)\n  if parsed_key\n  else\n    raise(JSON::ParseException.new(\"Can't convert #{key.inspect} into #{K}\", *key_location))\n  end\n  hash[parsed_key] = V.new(pull)\nend\nhash\n"}},{"html_id":"new-class-method","name":"new","doc":"Creates a new empty `Hash`.","summary":"<p>Creates a new empty <code><a href=\"Hash.html\">Hash</a></code>.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":197,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = Hash(K, V).allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(block:Hash(K,V),K->V?=nil,*,initial_capacity=nil)-class-method","name":"new","doc":"Creates a new empty `Hash` with a *block* for handling missing keys.\n\n```\nproc = ->(hash : Hash(String, Int32), key : String) { hash[key] = key.size }\nhash = Hash(String, Int32).new(proc)\n\nhash.size   # => 0\nhash[\"foo\"] # => 3\nhash.size   # => 1\nhash[\"bar\"] = 10\nhash[\"bar\"] # => 10\n```\n\nThe *initial_capacity* is useful to avoid unnecessary reallocations\nof the internal buffer in case of growth. If the number of elements\na hash will hold is known, the hash should be initialized with that\ncapacity for improved performance. Otherwise, the default is 8.\nInputs lower than 8 are ignored.","summary":"<p>Creates a new empty <code><a href=\"Hash.html\">Hash</a></code> with a <em>block</em> for handling missing keys.</p>","abstract":false,"args":[{"name":"block","default_value":"nil","external_name":"block","restriction":"(Hash(K, V), K -> V) | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"initial_capacity","default_value":"nil","external_name":"initial_capacity","restriction":""}],"args_string":"(block : Hash(K, V), K -> V? = nil, *, initial_capacity = nil)","args_html":"(block : <a href=\"Hash.html\">Hash</a>(K, V), K -> V? = <span class=\"n\">nil</span>, *, initial_capacity = <span class=\"n\">nil</span>)","location":{"filename":"src/hash.cr","line_number":225,"url":null},"def":{"name":"new","args":[{"name":"block","default_value":"nil","external_name":"block","restriction":"(Hash(K, V), K -> V) | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"initial_capacity","default_value":"nil","external_name":"initial_capacity","restriction":""}],"splat_index":1,"visibility":"Public","body":"_ = Hash(K, V).allocate\n_.initialize(block, initial_capacity: initial_capacity)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node,&)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node, &)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>, &)","location":{"filename":"src/yaml/from_yaml.cr","line_number":156,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"yields":2,"visibility":"Public","body":"if node.is_a?(YAML::Nodes::Mapping)\nelse\n  node.raise(\"Expected mapping, not #{node.kind}\")\nend\nYAML::Schema::Core.each(node) do |key, value|\n  yield K.new(ctx, key), V.new(ctx, value)\nend\n"}},{"html_id":"new(initial_capacity=nil,&block:Hash(K,V),K->V)-class-method","name":"new","doc":"Creates a new empty `Hash` with a *block* that handles missing keys.\n\n```\nhash = Hash(String, Int32).new do |hash, key|\n  hash[key] = key.size\nend\n\nhash.size   # => 0\nhash[\"foo\"] # => 3\nhash.size   # => 1\nhash[\"bar\"] = 10\nhash[\"bar\"] # => 10\n```\n\nThe *initial_capacity* is useful to avoid unnecessary reallocations\nof the internal buffer in case of growth. If the number of elements\na hash will hold is known, the hash should be initialized with that\ncapacity for improved performance. Otherwise, the default is 8.\nInputs lower than 8 are ignored.","summary":"<p>Creates a new empty <code><a href=\"Hash.html\">Hash</a></code> with a <em>block</em> that handles missing keys.</p>","abstract":false,"args":[{"name":"initial_capacity","default_value":"nil","external_name":"initial_capacity","restriction":""}],"args_string":"(initial_capacity = nil, &block : Hash(K, V), K -> V)","args_html":"(initial_capacity = <span class=\"n\">nil</span>, &block : <a href=\"Hash.html\">Hash</a>(K, V), K -> V)","location":{"filename":"src/hash.cr","line_number":285,"url":null},"def":{"name":"new","args":[{"name":"initial_capacity","default_value":"nil","external_name":"initial_capacity","restriction":""}],"yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(Hash(K, V), K -> V)"},"visibility":"Public","body":"new(block, initial_capacity: initial_capacity)"}}],"instance_methods":[{"html_id":"==(other:Hash)-instance-method","name":"==","doc":"Compares with *other*. Returns `true` if all key-value pairs are the same.","summary":"<p>Compares with <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Hash"}],"args_string":"(other : Hash)","args_html":"(other : <a href=\"Hash.html\">Hash</a>)","location":{"filename":"src/hash.cr","line_number":1741,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Hash"}],"visibility":"Public","body":"if size == other.size\nelse\n  return false\nend\neach do |key, value|\n  entry = other.find_entry(key)\n  if entry && (entry.value == value)\n  else\n    return false\n  end\nend\ntrue\n"}},{"html_id":"==(other:JSON::Any)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"JSON::Any"}],"args_string":"(other : JSON::Any)","args_html":"(other : <a href=\"JSON/Any.html\">JSON::Any</a>)","location":{"filename":"src/json/any.cr","line_number":320,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"JSON::Any"}],"visibility":"Public","body":"self == other.raw"}},{"html_id":"==(other:YAML::Any)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"YAML::Any"}],"args_string":"(other : YAML::Any)","args_html":"(other : <a href=\"YAML/Any.html\">YAML::Any</a>)","location":{"filename":"src/yaml/any.cr","line_number":359,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"YAML::Any"}],"visibility":"Public","body":"self == other.raw"}},{"html_id":"[](key)-instance-method","name":"[]","doc":"Returns the value for the key given by *key*.\nIf not found, returns the default value given by `Hash.new`, otherwise raises `KeyError`.\n\n```\nh = {\"foo\" => \"bar\"}\nh[\"foo\"] # => \"bar\"\n\nh = Hash(String, String).new(\"bar\")\nh[\"foo\"] # => \"bar\"\n\nh = Hash(String, String).new { \"bar\" }\nh[\"foo\"] # => \"bar\"\n\nh = Hash(String, String).new\nh[\"foo\"] # raises KeyError\n```","summary":"<p>Returns the value for the key given by <em>key</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key)","args_html":"(key)","location":{"filename":"src/hash.cr","line_number":1029,"url":null},"def":{"name":"[]","args":[{"name":"key","external_name":"key","restriction":""}],"visibility":"Public","body":"fetch(key) do\n  if (block = @block) && key.is_a?(K)\n    block.call(self, key.as(K))\n  else\n    raise(KeyError.new(\"Missing hash key: #{key.inspect}\"))\n  end\nend"}},{"html_id":"[]=(key:K,value:V)-instance-method","name":"[]=","doc":"Sets the value of *key* to the given *value*.\n\n```\nh = {} of String => String\nh[\"foo\"] = \"bar\"\nh[\"foo\"] # => \"bar\"\n```","summary":"<p>Sets the value of <em>key</em> to the given <em>value</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"K"},{"name":"value","external_name":"value","restriction":"V"}],"args_string":"(key : K, value : V)","args_html":"(key : K, value : V)","location":{"filename":"src/hash.cr","line_number":992,"url":null},"def":{"name":"[]=","args":[{"name":"key","external_name":"key","restriction":"K"},{"name":"value","external_name":"value","restriction":"V"}],"visibility":"Public","body":"upsert(key, value)\nvalue\n"}},{"html_id":"[]?(key)-instance-method","name":"[]?","doc":"Returns the value for the key given by *key*.\nIf not found, returns `nil`. This ignores the default value set by `Hash.new`.\n\n```\nh = {\"foo\" => \"bar\"}\nh[\"foo\"]? # => \"bar\"\nh[\"bar\"]? # => nil\n\nh = Hash(String, String).new(\"bar\")\nh[\"foo\"]? # => nil\n```","summary":"<p>Returns the value for the key given by <em>key</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key)","args_html":"(key)","location":{"filename":"src/hash.cr","line_number":1050,"url":null},"def":{"name":"[]?","args":[{"name":"key","external_name":"key","restriction":""}],"visibility":"Public","body":"fetch(key, nil)"}},{"html_id":"clear-instance-method","name":"clear","doc":"Empties a `Hash` and returns it.\n\n```\nhash = {\"foo\" => \"bar\"}\nhash.clear # => {}\n```","summary":"<p>Empties a <code><a href=\"Hash.html\">Hash</a></code> and returns it.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1735,"url":null},"def":{"name":"clear","visibility":"Public","body":"clear_impl\nself\n"}},{"html_id":"clone-instance-method","name":"clone","doc":"Similar to `#dup`, but duplicates the values as well.\n\n```\nhash_a = {\"foobar\" => {\"foo\" => \"bar\"}}\nhash_b = hash_a.clone\nhash_b[\"foobar\"][\"foo\"] = \"baz\"\nhash_a # => {\"foobar\" => {\"foo\" => \"bar\"}}\n```","summary":"<p>Similar to <code><a href=\"Hash.html#dup-instance-method\">#dup</a></code>, but duplicates the values as well.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1816,"url":null},"def":{"name":"clone","visibility":"Public","body":"{% if ((((V == ::Bool) || (V == ::Char)) || (V == ::String)) || (V == ::Symbol)) || V < ::Number::Primitive %}\n      clone = Hash(K, V).new\n      clone.initialize_clone(self)\n      clone\n    {% else %}\n      exec_recursive_clone do |hash|\n        clone = Hash(K, V).new\n        hash[object_id] = clone.object_id\n        clone.initialize_clone(self)\n        clone\n      end\n    {% end %}"}},{"html_id":"compact-instance-method","name":"compact","doc":"Returns new `Hash` without `nil` values.\n\n```\nhash = {\"hello\" => \"world\", \"foo\" => nil}\nhash.compact # => {\"hello\" => \"world\"}\n```","summary":"<p>Returns new <code><a href=\"Hash.html\">Hash</a></code> without <code>nil</code> values.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1534,"url":null},"def":{"name":"compact","visibility":"Public","body":"each_with_object({} of K => typeof(self.first_value.not_nil!)) do |__arg3, memo|\n  key = __arg3[0]\n  value = __arg3[1]\n  if value.nil?\n  else\n    memo[key] = value\n  end\nend"}},{"html_id":"compact!:self-instance-method","name":"compact!","doc":"Removes all `nil` value from `self`. Returns `self`.\n\n```\nhash = {\"hello\" => \"world\", \"foo\" => nil}\nhash.compact! # => {\"hello\" => \"world\"}\n```","summary":"<p>Removes all <code>nil</code> value from <code>self</code>.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1546,"url":null},"def":{"name":"compact!","return_type":"self","visibility":"Public","body":"reject! do |key, value|\n  value.nil?\nend"}},{"html_id":"compare_by_identity-instance-method","name":"compare_by_identity","doc":"Makes this hash compare keys using their object identity (`object_id)`\nfor types that define such method (`Reference` types, but also structs that\nmight wrap other `Reference` types and delegate the `object_id` method to them).\n\n```\nh1 = {\"foo\" => 1, \"bar\" => 2}\nh1[\"fo\" + \"o\"]? # => 1\n\nh1.compare_by_identity\nh1.compare_by_identity? # => true\nh1[\"fo\" + \"o\"]?         # => nil # not the same String instance\n```","summary":"<p>Makes this hash compare keys using their object identity (<code>object_id)</code> for types that define such method (<code><a href=\"Reference.html\">Reference</a></code> types, but also structs that might wrap other <code><a href=\"Reference.html\">Reference</a></code> types and delegate the <code>object_id</code> method to them).</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":974,"url":null},"def":{"name":"compare_by_identity","visibility":"Public","body":"@compare_by_identity = true\nrehash\nself\n"}},{"html_id":"compare_by_identity?-instance-method","name":"compare_by_identity?","doc":"Returns `true` of this Hash is comparing keys by `object_id`.\n\nSee `compare_by_identity`.","summary":"<p>Returns <code>true</code> of this Hash is comparing keys by <code>object_id</code>.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":983,"url":null},"def":{"name":"compare_by_identity?","visibility":"Public","body":"@compare_by_identity"}},{"html_id":"delete(key)-instance-method","name":"delete","doc":"Deletes the key-value pair and returns the value, otherwise returns `nil`.\n\n```\nh = {\"foo\" => \"bar\"}\nh.delete(\"foo\")     # => \"bar\"\nh.fetch(\"foo\", nil) # => nil\n```","summary":"<p>Deletes the key-value pair and returns the value, otherwise returns <code>nil</code>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key)","args_html":"(key)","location":{"filename":"src/hash.cr","line_number":1198,"url":null},"def":{"name":"delete","args":[{"name":"key","external_name":"key","restriction":""}],"visibility":"Public","body":"delete(key) do\n  nil\nend"}},{"html_id":"delete(key,&)-instance-method","name":"delete","doc":"Deletes the key-value pair and returns the value, else yields *key* with given block.\n\n```\nh = {\"foo\" => \"bar\"}\nh.delete(\"foo\") { |key| \"#{key} not found\" } # => \"bar\"\nh.fetch(\"foo\", nil)                          # => nil\nh.delete(\"baz\") { |key| \"#{key} not found\" } # => \"baz not found\"\n```","summary":"<p>Deletes the key-value pair and returns the value, else yields <em>key</em> with given block.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key, &)","args_html":"(key, &)","location":{"filename":"src/hash.cr","line_number":1210,"url":null},"def":{"name":"delete","args":[{"name":"key","external_name":"key","restriction":""}],"yields":1,"visibility":"Public","body":"entry = delete_impl(key)\nentry ? entry.value : yield key\n"}},{"html_id":"dig(key:K,*subkeys)-instance-method","name":"dig","doc":"Traverses the depth of a structure and returns the value, otherwise\nraises `KeyError`.\n\n```\nh = {\"a\" => {\"b\" => [10, 20, 30]}}\nh.dig \"a\", \"b\"                # => [10, 20, 30]\nh.dig \"a\", \"b\", \"c\", \"d\", \"e\" # raises KeyError\n```","summary":"<p>Traverses the depth of a structure and returns the value, otherwise raises <code><a href=\"KeyError.html\">KeyError</a></code>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"K"},{"name":"subkeys","external_name":"subkeys","restriction":""}],"args_string":"(key : K, *subkeys)","args_html":"(key : K, *subkeys)","location":{"filename":"src/hash.cr","line_number":1081,"url":null},"def":{"name":"dig","args":[{"name":"key","external_name":"key","restriction":"K"},{"name":"subkeys","external_name":"subkeys","restriction":""}],"splat_index":1,"visibility":"Public","body":"if (value = self[key]) && (value.responds_to?(:dig))\n  return value.dig(*subkeys)\nend\nraise(KeyError.new(\"Hash value not diggable for key: #{key.inspect}\"))\n"}},{"html_id":"dig?(key:K,*subkeys)-instance-method","name":"dig?","doc":"Traverses the depth of a structure and returns the value.\nReturns `nil` if not found.\n\n```\nh = {\"a\" => {\"b\" => [10, 20, 30]}}\nh.dig? \"a\", \"b\"                # => [10, 20, 30]\nh.dig? \"a\", \"b\", \"c\", \"d\", \"e\" # => nil\n```","summary":"<p>Traverses the depth of a structure and returns the value.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"K"},{"name":"subkeys","external_name":"subkeys","restriction":""}],"args_string":"(key : K, *subkeys)","args_html":"(key : K, *subkeys)","location":{"filename":"src/hash.cr","line_number":1062,"url":null},"def":{"name":"dig?","args":[{"name":"key","external_name":"key","restriction":"K"},{"name":"subkeys","external_name":"subkeys","restriction":""}],"splat_index":1,"visibility":"Public","body":"if (value = self[key]?) && (value.responds_to?(:\"dig?\"))\n  value.dig?(*subkeys)\nend"}},{"html_id":"dup-instance-method","name":"dup","doc":"Duplicates a `Hash`.\n\n```\nhash_a = {\"foo\" => \"bar\"}\nhash_b = hash_a.dup\nhash_b.merge!({\"baz\" => \"qux\"})\nhash_a # => {\"foo\" => \"bar\"}\n```","summary":"<p>Duplicates a <code><a href=\"Hash.html\">Hash</a></code>.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1802,"url":null},"def":{"name":"dup","visibility":"Public","body":"hash = Hash(K, V).new\nhash.initialize_dup(self)\nhash\n"}},{"html_id":"each(&:Tuple(K,V)->):Nil-instance-method","name":"each","doc":"Calls the given block for each key-value pair and passes in the key and the value.\n\n```\nh = {\"foo\" => \"bar\"}\n\nh.each do |key, value|\n  key   # => \"foo\"\n  value # => \"bar\"\nend\n\nh.each do |key_and_value|\n  key_and_value # => {\"foo\", \"bar\"}\nend\n```\n\nThe enumeration follows the order the keys were inserted.","summary":"<p>Calls the given block for each key-value pair and passes in the key and the value.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1244,"url":null},"def":{"name":"each","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(::Tuple(K, V) ->)"},"return_type":"Nil","visibility":"Public","body":"each_entry_with_index do |entry, i|\n  yield({entry.key, entry.value})\nend"}},{"html_id":"each-instance-method","name":"each","doc":"Returns an iterator over the hash entries.\nWhich behaves like an `Iterator` returning a `Tuple` consisting of the key and value types.\n\n```\nhsh = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\niterator = hsh.each\n\niterator.next # => {\"foo\", \"bar\"}\niterator.next # => {\"baz\", \"qux\"}\n```\n\nThe enumeration follows the order the keys were inserted.","summary":"<p>Returns an iterator over the hash entries.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1262,"url":null},"def":{"name":"each","visibility":"Public","body":"EntryIterator(K, V).new(self)"}},{"html_id":"each_key(&:K->)-instance-method","name":"each_key","doc":"Calls the given block for each key-value pair and passes in the key.\n\n```\nh = {\"foo\" => \"bar\"}\nh.each_key do |key|\n  key # => \"foo\"\nend\n```\n\nThe enumeration follows the order the keys were inserted.","summary":"<p>Calls the given block for each key-value pair and passes in the key.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1276,"url":null},"def":{"name":"each_key","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(K ->)"},"visibility":"Public","body":"each do |key, value|\n  yield key\nend"}},{"html_id":"each_key-instance-method","name":"each_key","doc":"Returns an iterator over the hash keys.\nWhich behaves like an `Iterator` consisting of the key's types.\n\n```\nhsh = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\niterator = hsh.each_key\n\nkey = iterator.next\nkey # => \"foo\"\n\nkey = iterator.next\nkey # => \"baz\"\n```\n\nThe enumeration follows the order the keys were inserted.","summary":"<p>Returns an iterator over the hash keys.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1297,"url":null},"def":{"name":"each_key","visibility":"Public","body":"KeyIterator(K, V).new(self)"}},{"html_id":"each_value(&:V->)-instance-method","name":"each_value","doc":"Calls the given block for each key-value pair and passes in the value.\n\n```\nh = {\"foo\" => \"bar\"}\nh.each_value do |value|\n  value # => \"bar\"\nend\n```\n\nThe enumeration follows the order the keys were inserted.","summary":"<p>Calls the given block for each key-value pair and passes in the value.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1311,"url":null},"def":{"name":"each_value","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(V ->)"},"visibility":"Public","body":"each do |key, value|\n  yield value\nend"}},{"html_id":"each_value-instance-method","name":"each_value","doc":"Returns an iterator over the hash values.\nWhich behaves like an `Iterator` consisting of the value's types.\n\n```\nhsh = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\niterator = hsh.each_value\n\nvalue = iterator.next\nvalue # => \"bar\"\n\nvalue = iterator.next\nvalue # => \"qux\"\n```\n\nThe enumeration follows the order the keys were inserted.","summary":"<p>Returns an iterator over the hash values.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1332,"url":null},"def":{"name":"each_value","visibility":"Public","body":"ValueIterator(K, V).new(self)"}},{"html_id":"empty?:Bool-instance-method","name":"empty?","doc":"Returns `true` when hash contains no key-value pairs.\n\n```\nh = Hash(String, String).new\nh.empty? # => true\n\nh = {\"foo\" => \"bar\"}\nh.empty? # => false\n```","summary":"<p>Returns <code>true</code> when hash contains no key-value pairs.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1224,"url":null},"def":{"name":"empty?","return_type":"Bool","visibility":"Public","body":"@size == 0"}},{"html_id":"fetch(key,default)-instance-method","name":"fetch","doc":"Returns the value for the key given by *key*, or when not found the value given by *default*.\nThis ignores the default value set by `Hash.new`.\n\n```\nh = {\"foo\" => \"bar\"}\nh.fetch(\"foo\", \"foo\") # => \"bar\"\nh.fetch(\"bar\", \"foo\") # => \"foo\"\n```","summary":"<p>Returns the value for the key given by <em>key</em>, or when not found the value given by <em>default</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""},{"name":"default","external_name":"default","restriction":""}],"args_string":"(key, default)","args_html":"(key, default)","location":{"filename":"src/hash.cr","line_number":1126,"url":null},"def":{"name":"fetch","args":[{"name":"key","external_name":"key","restriction":""},{"name":"default","external_name":"default","restriction":""}],"visibility":"Public","body":"fetch(key) do\n  default\nend"}},{"html_id":"fetch(key,&)-instance-method","name":"fetch","doc":"Returns the value for the key given by *key*, or when not found calls the given block with the key.\n\n```\nh = {\"foo\" => \"bar\"}\nh.fetch(\"foo\") { \"default value\" }  # => \"bar\"\nh.fetch(\"bar\") { \"default value\" }  # => \"default value\"\nh.fetch(\"bar\") { |key| key.upcase } # => \"BAR\"\n```","summary":"<p>Returns the value for the key given by <em>key</em>, or when not found calls the given block with the key.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key, &)","args_html":"(key, &)","location":{"filename":"src/hash.cr","line_number":1138,"url":null},"def":{"name":"fetch","args":[{"name":"key","external_name":"key","restriction":""}],"yields":1,"visibility":"Public","body":"entry = find_entry(key)\nentry ? entry.value : yield key\n"}},{"html_id":"first_key-instance-method","name":"first_key","doc":"Returns the first key in the hash.","summary":"<p>Returns the first key in the hash.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1607,"url":null},"def":{"name":"first_key","visibility":"Public","body":"entry = first_entry?\nentry ? entry.key : raise(\"Can't get first key of empty Hash\")\n"}},{"html_id":"first_key?:K?-instance-method","name":"first_key?","doc":"Returns the first key if it exists, or returns `nil`.\n\n```\nhash = {\"foo1\" => \"bar1\", \"foz2\" => \"baz2\"}\nhash.first_key? # => \"foo1\"\nhash.clear\nhash.first_key? # => nil\n```","summary":"<p>Returns the first key if it exists, or returns <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1620,"url":null},"def":{"name":"first_key?","return_type":"K | ::Nil","visibility":"Public","body":"first_entry?.try(&.key)"}},{"html_id":"first_value-instance-method","name":"first_value","doc":"Returns the first value in the hash.","summary":"<p>Returns the first value in the hash.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1625,"url":null},"def":{"name":"first_value","visibility":"Public","body":"entry = first_entry?\nentry ? entry.value : raise(\"Can't get first value of empty Hash\")\n"}},{"html_id":"first_value?-instance-method","name":"first_value?","doc":"Returns the first value if it exists, or returns `nil`.\n\n```\nhash = {\"foo1\" => \"bar1\", \"foz2\" => \"baz2\"}\nhash.first_value? # => \"bar1\"\nhash.clear\nhash.first_value? # => nil\n```","summary":"<p>Returns the first value if it exists, or returns <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1638,"url":null},"def":{"name":"first_value?","visibility":"Public","body":"first_entry?.try(&.value)"}},{"html_id":"has_key?(key):Bool-instance-method","name":"has_key?","doc":"Returns `true` when key given by *key* exists, otherwise `false`.\n\n```\nh = {\"foo\" => \"bar\"}\nh.has_key?(\"foo\") # => true\nh.has_key?(\"bar\") # => false\n```","summary":"<p>Returns <code>true</code> when key given by <em>key</em> exists, otherwise <code>false</code>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key) : Bool","args_html":"(key) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/hash.cr","line_number":1100,"url":null},"def":{"name":"has_key?","args":[{"name":"key","external_name":"key","restriction":""}],"return_type":"Bool","visibility":"Public","body":"!(!(find_entry(key)))"}},{"html_id":"has_value?(val):Bool-instance-method","name":"has_value?","doc":"Returns `true` when value given by *value* exists, otherwise `false`.\n\n```\nh = {\"foo\" => \"bar\"}\nh.has_value?(\"foo\") # => false\nh.has_value?(\"bar\") # => true\n```","summary":"<p>Returns <code>true</code> when value given by <em>value</em> exists, otherwise <code>false</code>.</p>","abstract":false,"args":[{"name":"val","external_name":"val","restriction":""}],"args_string":"(val) : Bool","args_html":"(val) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/hash.cr","line_number":1111,"url":null},"def":{"name":"has_value?","args":[{"name":"val","external_name":"val","restriction":""}],"return_type":"Bool","visibility":"Public","body":"each_value do |value|\n  if value == val\n    return true\n  end\nend\nfalse\n"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/hash.cr","line_number":1779,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"result = hasher.result\neach do |key, value|\n  copy = hasher\n  copy = key.hash(copy)\n  copy = value.hash(copy)\n  result = result &+ copy.result\nend\nresult.hash(hasher)\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/hash.cr","line_number":1831,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"invert:Hash(V,K)-instance-method","name":"invert","doc":"Inverts keys and values. If there are duplicated values, the last key becomes the new value.\n\n```\n{\"foo\" => \"bar\"}.invert                 # => {\"bar\" => \"foo\"}\n{\"foo\" => \"bar\", \"baz\" => \"bar\"}.invert # => {\"bar\" => \"baz\"}\n```","summary":"<p>Inverts keys and values.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1931,"url":null},"def":{"name":"invert","return_type":"Hash(V, K)","visibility":"Public","body":"hash = Hash(V, K).new(initial_capacity: @size)\nself.each do |k, v|\n  hash[v] = k\nend\nhash\n"}},{"html_id":"key_for(value):K-instance-method","name":"key_for","doc":"Returns a key with the given *value*, else raises `KeyError`.\n\n```\nhash = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\nhash.key_for(\"bar\")    # => \"foo\"\nhash.key_for(\"qux\")    # => \"baz\"\nhash.key_for(\"foobar\") # raises KeyError (Missing hash key for value: foobar)\n```","summary":"<p>Returns a key with the given <em>value</em>, else raises <code><a href=\"KeyError.html\">KeyError</a></code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : K","args_html":"(value) : K","location":{"filename":"src/hash.cr","line_number":1161,"url":null},"def":{"name":"key_for","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"K","visibility":"Public","body":"key_for(value) do\n  raise(KeyError.new(\"Missing hash key for value: #{value}\"))\nend"}},{"html_id":"key_for(value,&)-instance-method","name":"key_for","doc":"Returns a key with the given *value*, else yields *value* with the given block.\n\n```\nhash = {\"foo\" => \"bar\"}\nhash.key_for(\"bar\") { |value| value.upcase } # => \"foo\"\nhash.key_for(\"qux\") { |value| value.upcase } # => \"QUX\"\n```","summary":"<p>Returns a key with the given <em>value</em>, else yields <em>value</em> with the given block.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value, &)","args_html":"(value, &)","location":{"filename":"src/hash.cr","line_number":1184,"url":null},"def":{"name":"key_for","args":[{"name":"value","external_name":"value","restriction":""}],"yields":1,"visibility":"Public","body":"each do |k, v|\n  if v == value\n    return k\n  end\nend\nyield value\n"}},{"html_id":"key_for?(value):K?-instance-method","name":"key_for?","doc":"Returns a key with the given *value*, else `nil`.\n\n```\nhash = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\nhash.key_for?(\"bar\")    # => \"foo\"\nhash.key_for?(\"qux\")    # => \"baz\"\nhash.key_for?(\"foobar\") # => nil\n```","summary":"<p>Returns a key with the given <em>value</em>, else <code>nil</code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : K?","args_html":"(value) : K?","location":{"filename":"src/hash.cr","line_number":1173,"url":null},"def":{"name":"key_for?","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"K | ::Nil","visibility":"Public","body":"key_for(value) do\n  nil\nend"}},{"html_id":"keys:Array(K)-instance-method","name":"keys","doc":"Returns a new `Array` with all the keys.\n\n```\nh = {\"foo\" => \"bar\", \"baz\" => \"bar\"}\nh.keys # => [\"foo\", \"baz\"]\n```","summary":"<p>Returns a new <code><a href=\"Array.html\">Array</a></code> with all the keys.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1342,"url":null},"def":{"name":"keys","return_type":"Array(K)","visibility":"Public","body":"to_a_impl(&.key)"}},{"html_id":"last_key-instance-method","name":"last_key","doc":"Returns the last key in the hash.","summary":"<p>Returns the last key in the hash.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1643,"url":null},"def":{"name":"last_key","visibility":"Public","body":"entry = last_entry?\nentry ? entry.key : raise(\"Can't get last key of empty Hash\")\n"}},{"html_id":"last_key?-instance-method","name":"last_key?","doc":"Returns the last key if it exists, or returns `nil`.\n\n```\nhash = {\"foo1\" => \"bar1\", \"foz2\" => \"baz2\"}\nhash.last_key? # => \"foz2\"\nhash.clear\nhash.last_key? # => nil\n```","summary":"<p>Returns the last key if it exists, or returns <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1656,"url":null},"def":{"name":"last_key?","visibility":"Public","body":"last_entry?.try(&.key)"}},{"html_id":"last_value-instance-method","name":"last_value","doc":"Returns the last value in the hash.","summary":"<p>Returns the last value in the hash.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1661,"url":null},"def":{"name":"last_value","visibility":"Public","body":"entry = last_entry?\nentry ? entry.value : raise(\"Can't get last value of empty Hash\")\n"}},{"html_id":"last_value?-instance-method","name":"last_value?","doc":"Returns the last value if it exists, or returns `nil`.\n\n```\nhash = {\"foo1\" => \"bar1\", \"foz2\" => \"baz2\"}\nhash.last_value? # => \"baz2\"\nhash.clear\nhash.last_value? # => nil\n```","summary":"<p>Returns the last value if it exists, or returns <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1674,"url":null},"def":{"name":"last_value?","visibility":"Public","body":"last_entry?.try(&.value)"}},{"html_id":"merge(other:Hash(L,W)):Hash(K|L,V|W)forallL,W-instance-method","name":"merge","doc":"Returns a new `Hash` with the keys and values of this hash and *other* combined.\nA value in *other* takes precedence over the one in this hash.\n\n```\nhash = {\"foo\" => \"bar\"}\nhash.merge({\"baz\" => \"qux\"})\n# => {\"foo\" => \"bar\", \"baz\" => \"qux\"}\nhash\n# => {\"foo\" => \"bar\"}\n```","summary":"<p>Returns a new <code><a href=\"Hash.html\">Hash</a></code> with the keys and values of this hash and <em>other</em> combined.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Hash(L, W)"}],"args_string":"(other : Hash(L, W)) : Hash(K | L, V | W) forall L, W","args_html":"(other : <a href=\"Hash.html\">Hash</a>(L, W)) : <a href=\"Hash.html\">Hash</a>(K | L, V | W) forall L, W","location":{"filename":"src/hash.cr","line_number":1366,"url":null},"def":{"name":"merge","args":[{"name":"other","external_name":"other","restriction":"Hash(L, W)"}],"return_type":"Hash(K | L, V | W)","visibility":"Public","body":"hash = Hash(K | L, V | W).new\nhash.merge!(self)\nhash.merge!(other)\nhash\n"}},{"html_id":"merge(other:Hash(L,W),&:L,V,W->V|W):Hash(K|L,V|W)forallL,W-instance-method","name":"merge","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Hash(L, W)"}],"args_string":"(other : Hash(L, W), & : L, V, W -> V | W) : Hash(K | L, V | W) forall L, W","args_html":"(other : <a href=\"Hash.html\">Hash</a>(L, W), & : L, V, W -> V | W) : <a href=\"Hash.html\">Hash</a>(K | L, V | W) forall L, W","location":{"filename":"src/hash.cr","line_number":1373,"url":null},"def":{"name":"merge","args":[{"name":"other","external_name":"other","restriction":"Hash(L, W)"}],"yields":3,"block_arg":{"name":"","external_name":"","restriction":"(L, V, W -> V | W)"},"return_type":"Hash(K | L, V | W)","visibility":"Public","body":"hash = Hash(K | L, V | W).new\nhash.merge!(self)\nhash.merge!(other) do |k, v1, v2|\n  yield k, v1, v2\nend\nhash\n"}},{"html_id":"merge!(other:Hash):self-instance-method","name":"merge!","doc":"Similar to `#merge`, but the receiver is modified.\n\n```\nhash = {\"foo\" => \"bar\"}\nhash.merge!({\"baz\" => \"qux\"})\nhash # => {\"foo\" => \"bar\", \"baz\" => \"qux\"}\n```","summary":"<p>Similar to <code><a href=\"Hash.html#merge%28other%3AHash%28L%2CW%29%29%3AHash%28K%7CL%2CV%7CW%29forallL%2CW-instance-method\">#merge</a></code>, but the receiver is modified.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Hash"}],"args_string":"(other : Hash) : self","args_html":"(other : <a href=\"Hash.html\">Hash</a>) : <span class=\"k\">self</span>","location":{"filename":"src/hash.cr","line_number":1387,"url":null},"def":{"name":"merge!","args":[{"name":"other","external_name":"other","restriction":"Hash"}],"return_type":"self","visibility":"Public","body":"other.merge_into!(self)\nself\n"}},{"html_id":"merge!(other:Hash,&):self-instance-method","name":"merge!","doc":"Adds the contents of *other* to this hash.\nIf a key exists in both hashes, the given block is called to determine the value to be used.\nThe block arguments are the key, the value in `self` and the value in *other*.\n\n```\nhash = {\"a\" => 100, \"b\" => 200}\nother = {\"b\" => 254, \"c\" => 300}\nhash.merge!(other) { |key, v1, v2| v1 + v2 }\nhash # => {\"a\" => 100, \"b\" => 454, \"c\" => 300}\n```","summary":"<p>Adds the contents of <em>other</em> to this hash.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Hash"}],"args_string":"(other : Hash, &) : self","args_html":"(other : <a href=\"Hash.html\">Hash</a>, &) : <span class=\"k\">self</span>","location":{"filename":"src/hash.cr","line_number":1402,"url":null},"def":{"name":"merge!","args":[{"name":"other","external_name":"other","restriction":"Hash"}],"yields":3,"return_type":"self","visibility":"Public","body":"other.merge_into!(self) do |k, v1, v2|\n  yield k, v1, v2\nend\nself\n"}},{"html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","args_html":"(pp) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/hash.cr","line_number":1858,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"return_type":"Nil","visibility":"Public","body":"executed = exec_recursive(:pretty_print) do\n  pp.list(\"{\", self, \"}\") do |key, value|\n    pp.group do\n      key.pretty_print(pp)\n      pp.text(\" =>\")\n      pp.nest do\n        pp.breakable\n        value.pretty_print(pp)\n      end\n    end\n  end\nend\nif executed\nelse\n  pp.text(\"{...}\")\nend\n"}},{"html_id":"proper_subset_of?(other:Hash)-instance-method","name":"proper_subset_of?","doc":"Returns `true` if `self` is a subset of *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is a subset of <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Hash"}],"args_string":"(other : Hash)","args_html":"(other : <a href=\"Hash.html\">Hash</a>)","location":{"filename":"src/hash.cr","line_number":1751,"url":null},"def":{"name":"proper_subset_of?","args":[{"name":"other","external_name":"other","restriction":"Hash"}],"visibility":"Public","body":"if other.size <= size\n  return false\nend\nall? do |key, value|\n  other_value = other.fetch(key) do\n    return false\n  end\n  other_value == value\nend\n"}},{"html_id":"proper_superset_of?(other:Hash)-instance-method","name":"proper_superset_of?","doc":"Returns `true` if *other* is a subset of `self` or equals to `self`.","summary":"<p>Returns <code>true</code> if <em>other</em> is a subset of <code>self</code> or equals to <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Hash"}],"args_string":"(other : Hash)","args_html":"(other : <a href=\"Hash.html\">Hash</a>)","location":{"filename":"src/hash.cr","line_number":1774,"url":null},"def":{"name":"proper_superset_of?","args":[{"name":"other","external_name":"other","restriction":"Hash"}],"visibility":"Public","body":"other.proper_subset_of?(self)"}},{"html_id":"put(key:K,value:V,&)-instance-method","name":"put","doc":"Sets the value of *key* to the given *value*.\n\nIf a value already exists for `key`, that (old) value is returned.\nOtherwise the given block is invoked with *key* and its value is returned.\n\n```\nh = {} of Int32 => String\nh.put(1, \"one\") { \"didn't exist\" } # => \"didn't exist\"\nh.put(1, \"uno\") { \"didn't exist\" } # => \"one\"\nh.put(2, \"two\") { |key| key.to_s } # => \"2\"\n```","summary":"<p>Sets the value of <em>key</em> to the given <em>value</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"K"},{"name":"value","external_name":"value","restriction":"V"}],"args_string":"(key : K, value : V, &)","args_html":"(key : K, value : V, &)","location":{"filename":"src/hash.cr","line_number":1008,"url":null},"def":{"name":"put","args":[{"name":"key","external_name":"key","restriction":"K"},{"name":"value","external_name":"value","restriction":"V"}],"yields":1,"visibility":"Public","body":"updated_entry = upsert(key, value)\nupdated_entry ? updated_entry.value : yield key\n"}},{"html_id":"rehash:Nil-instance-method","name":"rehash","doc":"Rebuilds the hash table based on the current value of each key.\n\nWhen using mutable data types as keys, changing the value of a key after\nit was inserted into the `Hash` may lead to undefined behaviour.\nThis method re-indexes the hash using the current key values.","summary":"<p>Rebuilds the hash table based on the current value of each key.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1921,"url":null},"def":{"name":"rehash","return_type":"Nil","visibility":"Public","body":"do_compaction(rehash: true)"}},{"html_id":"reject(&:K,V->)-instance-method","name":"reject","doc":"Returns a new hash consisting of entries for which the block returns `false`.\n```\nh = {\"a\" => 100, \"b\" => 200, \"c\" => 300}\nh.reject { |k, v| k > \"a\" } # => {\"a\" => 100}\nh.reject { |k, v| v < 200 } # => {\"b\" => 200, \"c\" => 300}\n```","summary":"<p>Returns a new hash consisting of entries for which the block returns <code>false</code>.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1452,"url":null},"def":{"name":"reject","yields":2,"block_arg":{"name":"","external_name":"","restriction":"(K, V ->)"},"visibility":"Public","body":"each_with_object({} of K => V) do |__arg2, memo|\n  k = __arg2[0]\n  v = __arg2[1]\n  if yield k, v\n  else\n    memo[k] = v\n  end\nend"}},{"html_id":"reject(*keys):Hash(K,V)-instance-method","name":"reject","doc":"Returns a new `Hash` without the given keys.\n\n```\n{\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.reject(\"a\", \"c\") # => {\"b\" => 2, \"d\" => 4}\n```","summary":"<p>Returns a new <code><a href=\"Hash.html\">Hash</a></code> without the given keys.</p>","abstract":false,"args":[{"name":"keys","external_name":"keys","restriction":""}],"args_string":"(*keys) : Hash(K, V)","args_html":"(*keys) : <a href=\"Hash.html\">Hash</a>(K, V)","location":{"filename":"src/hash.cr","line_number":1471,"url":null},"def":{"name":"reject","args":[{"name":"keys","external_name":"keys","restriction":""}],"splat_index":0,"return_type":"Hash(K, V)","visibility":"Public","body":"hash = self.dup\nhash.reject!(*keys)\n"}},{"html_id":"reject!(&:K,V->)-instance-method","name":"reject!","doc":"Equivalent to `Hash#reject`, but makes modification on the current object rather than returning a new one. Returns `self`.","summary":"<p>Equivalent to <code><a href=\"Hash.html#reject%28%26%3AK%2CV-%3E%29-instance-method\">Hash#reject</a></code>, but makes modification on the current object rather than returning a new one.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1459,"url":null},"def":{"name":"reject!","yields":2,"block_arg":{"name":"","external_name":"","restriction":"(K, V ->)"},"visibility":"Public","body":"each do |key, value|\n  if yield(key, value)\n    delete(key)\n  end\nend\nself\n"}},{"html_id":"reject!(keys:Array|Tuple):self-instance-method","name":"reject!","doc":"Removes a list of keys out of hash.\n\n```\nh = {\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.reject!(\"a\", \"c\")\nh # => {\"b\" => 2, \"d\" => 4}\n```","summary":"<p>Removes a list of keys out of hash.</p>","abstract":false,"args":[{"name":"keys","external_name":"keys","restriction":"Array | Tuple"}],"args_string":"(keys : Array | Tuple) : self","args_html":"(keys : <a href=\"Array.html\">Array</a> | <a href=\"Tuple.html\">Tuple</a>) : <span class=\"k\">self</span>","location":{"filename":"src/hash.cr","line_number":1482,"url":null},"def":{"name":"reject!","args":[{"name":"keys","external_name":"keys","restriction":"Array | Tuple"}],"return_type":"self","visibility":"Public","body":"keys.each do |k|\n  delete(k)\nend\nself\n"}},{"html_id":"reject!(*keys):self-instance-method","name":"reject!","abstract":false,"args":[{"name":"keys","external_name":"keys","restriction":""}],"args_string":"(*keys) : self","args_html":"(*keys) : <span class=\"k\">self</span>","location":{"filename":"src/hash.cr","line_number":1487,"url":null},"def":{"name":"reject!","args":[{"name":"keys","external_name":"keys","restriction":""}],"splat_index":0,"return_type":"self","visibility":"Public","body":"reject!(keys)"}},{"html_id":"select(&:K,V->)-instance-method","name":"select","doc":"Returns a new hash consisting of entries for which the block returns `true`.\n```\nh = {\"a\" => 100, \"b\" => 200, \"c\" => 300}\nh.select { |k, v| k > \"a\" } # => {\"b\" => 200, \"c\" => 300}\nh.select { |k, v| v < 200 } # => {\"a\" => 100}\n```","summary":"<p>Returns a new hash consisting of entries for which the block returns <code>true</code>.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1437,"url":null},"def":{"name":"select","yields":2,"block_arg":{"name":"","external_name":"","restriction":"(K, V ->)"},"visibility":"Public","body":"reject do |k, v|\n  !(yield(k, v))\nend"}},{"html_id":"select(keys:Array|Tuple):Hash(K,V)-instance-method","name":"select","doc":"Returns a new `Hash` with the given keys.\n\n```\n{\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.select({\"a\", \"c\"}) # => {\"a\" => 1, \"c\" => 3}\n{\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.select(\"a\", \"c\")   # => {\"a\" => 1, \"c\" => 3}\n{\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.select([\"a\", \"c\"]) # => {\"a\" => 1, \"c\" => 3}\n```","summary":"<p>Returns a new <code><a href=\"Hash.html\">Hash</a></code> with the given keys.</p>","abstract":false,"args":[{"name":"keys","external_name":"keys","restriction":"Array | Tuple"}],"args_string":"(keys : Array | Tuple) : Hash(K, V)","args_html":"(keys : <a href=\"Array.html\">Array</a> | <a href=\"Tuple.html\">Tuple</a>) : <a href=\"Hash.html\">Hash</a>(K, V)","location":{"filename":"src/hash.cr","line_number":1498,"url":null},"def":{"name":"select","args":[{"name":"keys","external_name":"keys","restriction":"Array | Tuple"}],"return_type":"Hash(K, V)","visibility":"Public","body":"hash = {} of K => V\nkeys.each do |k|\n  if has_key?(k)\n    hash[k] = self[k]\n  end\nend\nhash\n"}},{"html_id":"select(*keys):Hash(K,V)-instance-method","name":"select","doc":"Returns a new `Hash` with the given keys.\n\n```\n{\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.select({\"a\", \"c\"}) # => {\"a\" => 1, \"c\" => 3}\n{\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.select(\"a\", \"c\")   # => {\"a\" => 1, \"c\" => 3}\n{\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.select([\"a\", \"c\"]) # => {\"a\" => 1, \"c\" => 3}\n```","summary":"<p>Returns a new <code><a href=\"Hash.html\">Hash</a></code> with the given keys.</p>","abstract":false,"args":[{"name":"keys","external_name":"keys","restriction":""}],"args_string":"(*keys) : Hash(K, V)","args_html":"(*keys) : <a href=\"Hash.html\">Hash</a>(K, V)","location":{"filename":"src/hash.cr","line_number":1505,"url":null},"def":{"name":"select","args":[{"name":"keys","external_name":"keys","restriction":""}],"splat_index":0,"return_type":"Hash(K, V)","visibility":"Public","body":"self.select(keys)"}},{"html_id":"select!(&:K,V->)-instance-method","name":"select!","doc":"Equivalent to `Hash#select` but makes modification on the current object rather than returning a new one. Returns `self`.","summary":"<p>Equivalent to <code><a href=\"Hash.html#select%28%26%3AK%2CV-%3E%29-instance-method\">Hash#select</a></code> but makes modification on the current object rather than returning a new one.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1442,"url":null},"def":{"name":"select!","yields":2,"block_arg":{"name":"","external_name":"","restriction":"(K, V ->)"},"visibility":"Public","body":"reject! do |k, v|\n  !(yield(k, v))\nend"}},{"html_id":"select!(keys:Array|Tuple):self-instance-method","name":"select!","doc":"Removes every element except the given ones.\n\n```\nh1 = {\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.select!({\"a\", \"c\"})\nh2 = {\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.select!(\"a\", \"c\")\nh3 = {\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.select!([\"a\", \"c\"])\nh1 == h2 == h3 # => true\nh1             # => {\"a\" => 1, \"c\" => 3}\n```","summary":"<p>Removes every element except the given ones.</p>","abstract":false,"args":[{"name":"keys","external_name":"keys","restriction":"Array | Tuple"}],"args_string":"(keys : Array | Tuple) : self","args_html":"(keys : <a href=\"Array.html\">Array</a> | <a href=\"Tuple.html\">Tuple</a>) : <span class=\"k\">self</span>","location":{"filename":"src/hash.cr","line_number":1518,"url":null},"def":{"name":"select!","args":[{"name":"keys","external_name":"keys","restriction":"Array | Tuple"}],"return_type":"self","visibility":"Public","body":"each do |k, v|\n  if keys.includes?(k)\n  else\n    delete(k)\n  end\nend\nself\n"}},{"html_id":"select!(*keys):self-instance-method","name":"select!","doc":"Removes every element except the given ones.\n\n```\nh1 = {\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.select!({\"a\", \"c\"})\nh2 = {\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.select!(\"a\", \"c\")\nh3 = {\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.select!([\"a\", \"c\"])\nh1 == h2 == h3 # => true\nh1             # => {\"a\" => 1, \"c\" => 3}\n```","summary":"<p>Removes every element except the given ones.</p>","abstract":false,"args":[{"name":"keys","external_name":"keys","restriction":""}],"args_string":"(*keys) : self","args_html":"(*keys) : <span class=\"k\">self</span>","location":{"filename":"src/hash.cr","line_number":1524,"url":null},"def":{"name":"select!","args":[{"name":"keys","external_name":"keys","restriction":""}],"splat_index":0,"return_type":"self","visibility":"Public","body":"select!(keys)"}},{"html_id":"shift-instance-method","name":"shift","doc":"Deletes and returns the first key-value pair in the hash,\nor raises `IndexError` if the hash is empty.\n\n```\nhash = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\nhash.shift # => {\"foo\", \"bar\"}\nhash       # => {\"baz\" => \"qux\"}\n\nhash = {} of String => String\nhash.shift # raises IndexError\n```","summary":"<p>Deletes and returns the first key-value pair in the hash, or raises <code><a href=\"IndexError.html\">IndexError</a></code> if the hash is empty.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1689,"url":null},"def":{"name":"shift","visibility":"Public","body":"shift do\n  raise(IndexError.new)\nend"}},{"html_id":"shift(&)-instance-method","name":"shift","doc":"Deletes and returns the first key-value pair in the hash.\nYields to the given block if the hash is empty.\n\n```\nhash = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\nhash.shift { true } # => {\"foo\", \"bar\"}\nhash                # => {\"baz\" => \"qux\"}\n\nhash = {} of String => String\nhash.shift { true } # => true\nhash                # => {}\n```","summary":"<p>Deletes and returns the first key-value pair in the hash.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1719,"url":null},"def":{"name":"shift","yields":0,"visibility":"Public","body":"first_entry = first_entry?\nif first_entry\n  delete_entry_and_update_counts(@first)\n  {first_entry.key, first_entry.value}\nelse\n  yield\nend\n"}},{"html_id":"shift?:Tuple(K,V)?-instance-method","name":"shift?","doc":"Same as `#shift`, but returns `nil` if the hash is empty.\n\n```\nhash = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\nhash.shift? # => {\"foo\", \"bar\"}\nhash        # => {\"baz\" => \"qux\"}\n\nhash = {} of String => String\nhash.shift? # => nil\n```","summary":"<p>Same as <code><a href=\"Hash.html#shift-instance-method\">#shift</a></code>, but returns <code>nil</code> if the hash is empty.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1703,"url":null},"def":{"name":"shift?","return_type":"::Tuple(K, V) | ::Nil","visibility":"Public","body":"shift do\n  nil\nend"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Returns the number of elements in this Hash.","summary":"<p>Returns the number of elements in this Hash.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":960,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"@size"}},{"html_id":"subset_of?(other:Hash)-instance-method","name":"subset_of?","doc":"Returns `true` if `self` is a subset of *other* or equals to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is a subset of <em>other</em> or equals to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Hash"}],"args_string":"(other : Hash)","args_html":"(other : <a href=\"Hash.html\">Hash</a>)","location":{"filename":"src/hash.cr","line_number":1760,"url":null},"def":{"name":"subset_of?","args":[{"name":"other","external_name":"other","restriction":"Hash"}],"visibility":"Public","body":"if other.size < size\n  return false\nend\nall? do |key, value|\n  other_value = other.fetch(key) do\n    return false\n  end\n  other_value == value\nend\n"}},{"html_id":"superset_of?(other:Hash)-instance-method","name":"superset_of?","doc":"Returns `true` if *other* is a subset of `self`.","summary":"<p>Returns <code>true</code> if <em>other</em> is a subset of <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Hash"}],"args_string":"(other : Hash)","args_html":"(other : <a href=\"Hash.html\">Hash</a>)","location":{"filename":"src/hash.cr","line_number":1769,"url":null},"def":{"name":"superset_of?","args":[{"name":"other","external_name":"other","restriction":"Hash"}],"visibility":"Public","body":"other.subset_of?(self)"}},{"html_id":"to_a:Array(Tuple(K,V))-instance-method","name":"to_a","doc":"Returns an array of tuples with key and values belonging to this Hash.\n\n```\nh = {1 => 'a', 2 => 'b', 3 => 'c'}\nh.to_a # => [{1, 'a'}, {2, 'b'}, {3, 'c'}]\n```\nThe order of the array follows the order the keys were inserted in the Hash.","summary":"<p>Returns an array of tuples with key and values belonging to this Hash.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1881,"url":null},"def":{"name":"to_a","return_type":"Array(::Tuple(K, V))","visibility":"Public","body":"to_a_impl do |entry|\n  {entry.key, entry.value}\nend"}},{"html_id":"to_h:self-instance-method","name":"to_h","doc":"Returns `self`.","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1912,"url":null},"def":{"name":"to_h","return_type":"self","visibility":"Public","body":"self"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","doc":"Serializes this Hash into JSON.\n\nKeys are serialized by invoking `to_json_object_key` on them.\nValues are serialized with the usual `to_json(json : JSON::Builder)`\nmethod.","summary":"<p>Serializes this Hash into JSON.</p>","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":123,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.object do\n  each do |key, value|\n    json.field(key.to_json_object_key) do\n      value.to_json(json)\n    end\n  end\nend"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Converts to a `String`.\n\n```\nh = {\"foo\" => \"bar\"}\nh.to_s       # => \"{\\\"foo\\\" => \\\"bar\\\"}\"\nh.to_s.class # => String\n```","summary":"<p>Converts to a <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/hash.cr","line_number":1842,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"executed = exec_recursive(:to_s) do\n  io << '{'\n  found_one = false\n  each do |key, value|\n    if found_one\n      io << \", \"\n    end\n    key.inspect(io)\n    io << \" => \"\n    value.inspect(io)\n    found_one = true\n  end\n  io << '}'\nend\nif executed\nelse\n  io << \"{...}\"\nend\n"}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder) : Nil","args_html":"(yaml : <a href=\"YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":24,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"yaml.mapping(reference: self) do\n  each do |key, value|\n    key.to_yaml(yaml)\n    value.to_yaml(yaml)\n  end\nend"}},{"html_id":"transform_keys(&:K->K2):Hash(K2,V)forallK2-instance-method","name":"transform_keys","doc":"Returns a new hash with all keys converted using the block operation.\nThe block can change a type of keys.\n\n```\nhash = {:a => 1, :b => 2, :c => 3}\nhash.transform_keys { |key| key.to_s } # => {\"a\" => 1, \"b\" => 2, \"c\" => 3}\n```","summary":"<p>Returns a new hash with all keys converted using the block operation.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1557,"url":null},"def":{"name":"transform_keys","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(K -> K2)"},"return_type":"Hash(K2, V)","visibility":"Public","body":"each_with_object({} of K2 => V) do |__arg4, memo|\n  key = __arg4[0]\n  value = __arg4[1]\n  memo[yield(key)] = value\nend"}},{"html_id":"transform_values(&:V->V2):Hash(K,V2)forallV2-instance-method","name":"transform_values","doc":"Returns a new hash with the results of running block once for every value.\nThe block can change a type of values.\n\n```\nhash = {:a => 1, :b => 2, :c => 3}\nhash.transform_values { |value| value + 1 } # => {:a => 2, :b => 3, :c => 4}\n```","summary":"<p>Returns a new hash with the results of running block once for every value.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1570,"url":null},"def":{"name":"transform_values","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(V -> V2)"},"return_type":"Hash(K, V2)","visibility":"Public","body":"each_with_object({} of K => V2) do |__arg5, memo|\n  key = __arg5[0]\n  value = __arg5[1]\n  memo[key] = yield(value)\nend"}},{"html_id":"transform_values!(&:V->V):self-instance-method","name":"transform_values!","doc":"Destructively transforms all values using a block. Same as transform_values but modifies in place.\nThe block cannot change a type of values.\n\n```\nhash = {:a => 1, :b => 2, :c => 3}\nhash.transform_values! { |value| value + 1 }\nhash # => {:a => 2, :b => 3, :c => 4}\n```","summary":"<p>Destructively transforms all values using a block.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1584,"url":null},"def":{"name":"transform_values!","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(V -> V)"},"return_type":"self","visibility":"Public","body":"each_entry_with_index do |entry, i|\n  new_value = yield entry.value\n  set_entry(i, Entry(K, V).new(entry.hash, entry.key, new_value))\nend\nself\n"}},{"html_id":"values:Array(V)-instance-method","name":"values","doc":"Returns only the values as an `Array`.\n\n```\nh = {\"foo\" => \"bar\", \"baz\" => \"qux\"}\nh.values # => [\"bar\", \"qux\"]\n```","summary":"<p>Returns only the values as an <code><a href=\"Array.html\">Array</a></code>.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1352,"url":null},"def":{"name":"values","return_type":"Array(V)","visibility":"Public","body":"to_a_impl(&.value)"}},{"html_id":"values_at(*keys:K)-instance-method","name":"values_at","doc":"Returns a tuple populated with the values of the given *keys*, with the same order.\nRaises if a key is not found.\n\n```\n{\"a\" => 1, \"b\" => 2, \"c\" => 3, \"d\" => 4}.values_at(\"a\", \"c\") # => {1, 3}\n```","summary":"<p>Returns a tuple populated with the values of the given <em>keys</em>, with the same order.</p>","abstract":false,"args":[{"name":"keys","external_name":"keys","restriction":"K"}],"args_string":"(*keys : K)","args_html":"(*keys : K)","location":{"filename":"src/hash.cr","line_number":1149,"url":null},"def":{"name":"values_at","args":[{"name":"keys","external_name":"keys","restriction":"K"}],"splat_index":0,"visibility":"Public","body":"keys.map do |index|\n  self[index]\nend"}}],"types":[{"html_id":"Crystal/Hash/Entry","path":"Hash/Entry.html","kind":"struct","full_name":"Hash::Entry(K, V)","name":"Entry","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/hash.cr","line_number":1939,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Hash","kind":"class","full_name":"Hash(K, V)","name":"Hash"},"class_methods":[{"html_id":"deleted-class-method","name":"deleted","abstract":false,"location":{"filename":"src/hash.cr","line_number":1945,"url":null},"def":{"name":"deleted","visibility":"Public","body":"key = uninitialized K\nvalue = uninitialized V\nnew(0_u32, key, value)\n"}}],"constructors":[{"html_id":"new(hash:UInt32,key:K,value:V)-class-method","name":"new","abstract":false,"args":[{"name":"hash","external_name":"hash","restriction":"UInt32"},{"name":"key","external_name":"key","restriction":"K"},{"name":"value","external_name":"value","restriction":"V"}],"args_string":"(hash : UInt32, key : K, value : V)","args_html":"(hash : <a href=\"../UInt32.html\">UInt32</a>, key : K, value : V)","location":{"filename":"src/hash.cr","line_number":1942,"url":null},"def":{"name":"new","args":[{"name":"hash","external_name":"hash","restriction":"UInt32"},{"name":"key","external_name":"key","restriction":"K"},{"name":"value","external_name":"value","restriction":"V"}],"visibility":"Public","body":"_ = Entry(K, V).allocate\n_.initialize(hash, key, value)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/hash.cr","line_number":1955,"url":null},"def":{"name":"clone","visibility":"Public","body":"Entry(K, V).new(hash, key, value.clone)"}},{"html_id":"deleted?:Bool-instance-method","name":"deleted?","abstract":false,"location":{"filename":"src/hash.cr","line_number":1951,"url":null},"def":{"name":"deleted?","return_type":"Bool","visibility":"Public","body":"@hash == 0_u32"}},{"html_id":"hash-instance-method","name":"hash","doc":"Generates an `UInt64` hash value for this object.\n\nThis method must have the property that `a == b` implies `a.hash == b.hash`.\n\nThe hash value is used along with `==` by the `Hash` class to determine if two objects\nreference the same hash key.\n\nSubclasses must not override this method. Instead, they must define `hash(hasher)`,\nthough usually the macro `def_hash` can be used to generate this method.","summary":"<p>Generates an <code><a href=\"../UInt64.html\">UInt64</a></code> hash value for this object.</p>","abstract":false,"location":{"filename":"src/hash.cr","line_number":1940,"url":null},"def":{"name":"hash","visibility":"Public","body":"@hash"}},{"html_id":"key-instance-method","name":"key","abstract":false,"location":{"filename":"src/hash.cr","line_number":1940,"url":null},"def":{"name":"key","visibility":"Public","body":"@key"}},{"html_id":"value-instance-method","name":"value","abstract":false,"location":{"filename":"src/hash.cr","line_number":1940,"url":null},"def":{"name":"value","visibility":"Public","body":"@value"}}]}]},{"html_id":"Crystal/HTML","path":"HTML.html","kind":"module","full_name":"HTML","name":"HTML","abstract":false,"locations":[{"filename":"src/html.cr","line_number":6,"url":null},{"filename":"src/html/entities.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"Provides HTML escaping and unescaping methods.\n\nFor HTML *parsing* see module XML, especially `XML.parse_html`.","summary":"<p>Provides HTML escaping and unescaping methods.</p>","class_methods":[{"html_id":"escape(string:String,io:IO):Nil-class-method","name":"escape","doc":"Same as `escape(string)` but outputs the result to\nthe given *io*.\n\n```\nrequire \"html\"\n\nio = IO::Memory.new\nHTML.escape(\"Crystal & You\", io) # => nil\nio.to_s                          # => \"Crystal &amp; You\"\n```","summary":"<p>Same as <code><a href=\"HTML.html#escape%28string%3AString%29%3AString-class-method\">.escape(string)</a></code> but outputs the result to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(string : String, io : IO) : Nil","args_html":"(string : <a href=\"String.html\">String</a>, io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/html.cr","line_number":37,"url":null},"def":{"name":"escape","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"string.each_char do |char|\n  io << (SUBSTITUTIONS.fetch(char, char))\nend"}},{"html_id":"escape(string:String):String-class-method","name":"escape","doc":"Escapes special characters in HTML, namely\n`&`, `<`, `>`, `\"` and `'`.\n\n```\nrequire \"html\"\n\nHTML.escape(\"Crystal & You\") # => \"Crystal &amp; You\"\n```","summary":"<p>Escapes special characters in HTML, namely <code>&</code>, <code><</code>, <code>></code>, <code>\"</code> and <code>'</code>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String) : String","args_html":"(string : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/html.cr","line_number":23,"url":null},"def":{"name":"escape","args":[{"name":"string","external_name":"string","restriction":"String"}],"return_type":"String","visibility":"Public","body":"string.gsub(SUBSTITUTIONS)"}},{"html_id":"unescape(string:String):String-class-method","name":"unescape","doc":"Returns a string where named and numeric character references\n(e.g. &amp;gt;, &amp;#62;, &amp;#x3e;) in *string* are replaced with the corresponding\nunicode characters. This method decodes all HTML5 entities including those\nwithout a trailing semicolon (such as \"&amp;copy\").\n\n```\nrequire \"html\"\n\nHTML.unescape(\"Crystal &amp; You\") # => \"Crystal & You\"\n```","summary":"<p>Returns a string where named and numeric character references (e.g.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String) : String","args_html":"(string : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/html.cr","line_number":93,"url":null},"def":{"name":"unescape","args":[{"name":"string","external_name":"string","restriction":"String"}],"return_type":"String","visibility":"Public","body":"string.gsub(/&(?:([a-zA-Z0-9]{2,32};?)|\\#([0-9]+);?|\\#[xX]([0-9A-Fa-f]+);?)/) do |string, match|\n  if code = match[1]?\n    value = named_entity(code)\n    if value || (code.ends_with?(';'))\n    else\n      removed = 0\n      while !code.empty?\n        code = code.rchop\n        removed = removed + 1\n        value = named_entity(code)\n        if value\n          value = value + string[(-removed)..-1]\n          break\n        end\n      end\n    end\n    value || string\n  else\n    if code = match[2]?\n      (decode_codepoint(code.to_i)) || string\n    else\n      if code = match[3]?\n        (decode_codepoint(code.to_i(16))) || string\n      else\n        string\n      end\n    end\n  end\nend"}}]},{"html_id":"Crystal/HTTP","path":"HTTP.html","kind":"module","full_name":"HTTP","name":"HTTP","abstract":false,"locations":[{"filename":"src/http.cr","line_number":10,"url":null},{"filename":"src/http/client.cr","line_number":72,"url":null},{"filename":"src/http/common.cr","line_number":7,"url":null},{"filename":"src/http/content.cr","line_number":3,"url":null},{"filename":"src/http/cookie.cr","line_number":3,"url":null},{"filename":"src/http/params.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"MAX_HEADERS_SIZE","name":"MAX_HEADERS_SIZE","value":"16384","doc":"Default maximum permitted combined size (in bytes) of the headers in an HTTP request.","summary":"<p>Default maximum permitted combined size (in bytes) of the headers in an HTTP request.</p>"},{"id":"MAX_REQUEST_LINE_SIZE","name":"MAX_REQUEST_LINE_SIZE","value":"8192","doc":"Default maximum permitted size (in bytes) of the request line in an HTTP request.","summary":"<p>Default maximum permitted size (in bytes) of the request line in an HTTP request.</p>"},{"id":"SUPPORTED_VERSIONS","name":"SUPPORTED_VERSIONS","value":"{\"HTTP/1.0\", \"HTTP/1.1\"}"}],"doc":"The HTTP module contains `HTTP::Client`, `HTTP::Server` and `HTTP::WebSocket` implementations.","summary":"<p>The HTTP module contains <code><a href=\"HTTP/Client.html\">HTTP::Client</a></code>, <code><a href=\"HTTP/Server.html\">HTTP::Server</a></code> and <code><a href=\"HTTP/WebSocket.html\">HTTP::WebSocket</a></code> implementations.</p>","class_methods":[{"html_id":"dequote_string(str):String-class-method","name":"dequote_string","doc":"Dequotes an [RFC 2616](https://tools.ietf.org/html/rfc2616#page-17)\nquoted-string.\n\n```\nrequire \"http\"\n\nquoted = %q(\\\"foo\\\\bar\\\")\nHTTP.dequote_string(quoted) # => %q(\"foo\\bar\")\n```","summary":"<p>Dequotes an <a href=\"https://tools.ietf.org/html/rfc2616#page-17\">RFC 2616</a> quoted-string.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":""}],"args_string":"(str) : String","args_html":"(str) : <a href=\"String.html\">String</a>","location":{"filename":"src/http/common.cr","line_number":382,"url":null},"def":{"name":"dequote_string","args":[{"name":"str","external_name":"str","restriction":""}],"return_type":"String","visibility":"Public","body":"data = str.to_slice\nquoted_pair_index = data.index('\\\\'.ord)\nif quoted_pair_index\nelse\n  return str\nend\nString.build do |io|\n  while quoted_pair_index\n    io.write(data[0, quoted_pair_index])\n    io << data[quoted_pair_index + 1].unsafe_chr\n    data = data + (quoted_pair_index + 2)\n    quoted_pair_index = data.index('\\\\'.ord)\n  end\n  io.write(data)\nend\n"}},{"html_id":"expect_continue?(headers):Bool-class-method","name":"expect_continue?","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":""}],"args_string":"(headers) : Bool","args_html":"(headers) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/http/common.cr","line_number":336,"url":null},"def":{"name":"expect_continue?","args":[{"name":"headers","external_name":"headers","restriction":""}],"return_type":"Bool","visibility":"Public","body":"headers[\"Expect\"]?.try(&.downcase) == \"100-continue\""}},{"html_id":"format_time(time:Time):String-class-method","name":"format_time","doc":"Format a `Time` object as a `String` using the format specified as `sane-cookie-date`\nby [RFC 6265](https://tools.ietf.org/html/rfc6265#section-4.1.1) which is\naccording to [RFC 2616](https://tools.ietf.org/html/rfc2616#section-3.3.1) a\n[RFC 1123](https://tools.ietf.org/html/rfc1123#page-55) format with explicit\ntimezone `GMT` (interpreted as `UTC`).\n\n```\nrequire \"http\"\n\nHTTP.format_time(Time.utc(2016, 2, 15)) # => \"Mon, 15 Feb 2016 00:00:00 GMT\"\n```\n\nUses `Time::Format::HTTP_DATE` as formatter.","summary":"<p>Format a <code><a href=\"Time.html\">Time</a></code> object as a <code><a href=\"String.html\">String</a></code> using the format specified as <code>sane-cookie-date</code> by <a href=\"https://tools.ietf.org/html/rfc6265#section-4.1.1\">RFC 6265</a> which is according to <a href=\"https://tools.ietf.org/html/rfc2616#section-3.3.1\">RFC 2616</a> a <a href=\"https://tools.ietf.org/html/rfc1123#page-55\">RFC 1123</a> format with explicit timezone <code>GMT</code> (interpreted as <code>UTC</code>).</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"}],"args_string":"(time : Time) : String","args_html":"(time : <a href=\"Time.html\">Time</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/http/common.cr","line_number":369,"url":null},"def":{"name":"format_time","args":[{"name":"time","external_name":"time","restriction":"Time"}],"return_type":"String","visibility":"Public","body":"Time::Format::HTTP_DATE.format(time)"}},{"html_id":"parse_time(time_str:String):Time?-class-method","name":"parse_time","doc":"Parse a time string using the formats specified by [RFC 2616](https://tools.ietf.org/html/rfc2616#section-3.3.1)\n\n```\nrequire \"http\"\n\nHTTP.parse_time(\"Sun, 14 Feb 2016 21:00:00 GMT\")  # => \"2016-02-14 21:00:00 UTC\"\nHTTP.parse_time(\"Sunday, 14-Feb-16 21:00:00 GMT\") # => \"2016-02-14 21:00:00 UTC\"\nHTTP.parse_time(\"Sun Feb 14 21:00:00 2016\")       # => \"2016-02-14 21:00:00 UTC\"\n```\n\nUses `Time::Format::HTTP_DATE` as parser.","summary":"<p>Parse a time string using the formats specified by <a href=\"https://tools.ietf.org/html/rfc2616#section-3.3.1\">RFC 2616</a></p>","abstract":false,"args":[{"name":"time_str","external_name":"time_str","restriction":"String"}],"args_string":"(time_str : String) : Time?","args_html":"(time_str : <a href=\"String.html\">String</a>) : <a href=\"Time.html\">Time</a>?","location":{"filename":"src/http/common.cr","line_number":351,"url":null},"def":{"name":"parse_time","args":[{"name":"time_str","external_name":"time_str","restriction":"String"}],"return_type":"Time | ::Nil","visibility":"Public","body":"begin\n  Time::Format::HTTP_DATE.parse(time_str)\nrescue Time::Format::Error\nend"}},{"html_id":"quote_string(string,io):Nil-class-method","name":"quote_string","doc":"Encodes a string to an [RFC 2616](https://tools.ietf.org/html/rfc2616#page-17)\nquoted-string. Encoded string is written to *io*. May raise when *string*\ncontains an invalid character.\n\n```\nrequire \"http\"\n\nstring = %q(\"foo\\ bar\")\nio = IO::Memory.new\nHTTP.quote_string(string, io)\nio.rewind\nio.gets_to_end # => %q(\\\"foo\\\\\\ bar\\\")\n```","summary":"<p>Encodes a string to an <a href=\"https://tools.ietf.org/html/rfc2616#page-17\">RFC 2616</a> quoted-string.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""},{"name":"io","external_name":"io","restriction":""}],"args_string":"(string, io) : Nil","args_html":"(string, io) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/http/common.cr","line_number":412,"url":null},"def":{"name":"quote_string","args":[{"name":"string","external_name":"string","restriction":""},{"name":"io","external_name":"io","restriction":""}],"return_type":"Nil","visibility":"Public","body":"string.each_char do |char|\n  case char\n  when '\\t', ' ', '\"', '\\\\'\n    io << '\\\\'\n  when '\\0'..'\\u001F', '\\u007F'\n    raise(ArgumentError.new(\"String contained invalid character #{char.inspect}\"))\n  else\n  end\n  io << char\nend"}},{"html_id":"quote_string(string):String-class-method","name":"quote_string","doc":"Encodes a string to an [RFC 2616](https://tools.ietf.org/html/rfc2616#page-17)\nquoted-string. May raise when *string* contains an invalid character.\n\n```\nrequire \"http\"\n\nstring = %q(\"foo\\ bar\")\nHTTP.quote_string(string) # => %q(\\\"foo\\\\\\ bar\\\")\n```","summary":"<p>Encodes a string to an <a href=\"https://tools.ietf.org/html/rfc2616#page-17\">RFC 2616</a> quoted-string.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""}],"args_string":"(string) : String","args_html":"(string) : <a href=\"String.html\">String</a>","location":{"filename":"src/http/common.cr","line_number":437,"url":null},"def":{"name":"quote_string","args":[{"name":"string","external_name":"string","restriction":""}],"return_type":"String","visibility":"Public","body":"String.build do |io|\n  quote_string(string, io)\nend"}},{"html_id":"serialize_chunked_body(io,body)-class-method","name":"serialize_chunked_body","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"body","external_name":"body","restriction":""}],"args_string":"(io, body)","args_html":"(io, body)","location":{"filename":"src/http/common.cr","line_number":297,"url":null},"def":{"name":"serialize_chunked_body","args":[{"name":"io","external_name":"io","restriction":""},{"name":"body","external_name":"body","restriction":""}],"visibility":"Public","body":"buf = uninitialized ::StaticArray(UInt8, 8192)\nwhile (buf_length = body.read(buf.to_slice)) > 0\n  buf_length.to_s(io, 16)\n  io << \"\\r\\n\"\n  io.write(buf.to_slice[0, buf_length])\n  io << \"\\r\\n\"\nend\nio << \"0\\r\\n\\r\\n\"\n"}},{"html_id":"serialize_headers(io,headers)-class-method","name":"serialize_headers","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"headers","external_name":"headers","restriction":""}],"args_string":"(io, headers)","args_html":"(io, headers)","location":{"filename":"src/http/common.cr","line_number":288,"url":null},"def":{"name":"serialize_headers","args":[{"name":"io","external_name":"io","restriction":""},{"name":"headers","external_name":"headers","restriction":""}],"visibility":"Public","body":"headers.each do |name, values|\n  values.each do |value|\n    (((io << name) << \": \") << value) << \"\\r\\n\"\n  end\nend\nio << \"\\r\\n\"\n"}},{"html_id":"serialize_headers_and_string_body(io,headers,body)-class-method","name":"serialize_headers_and_string_body","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"headers","external_name":"headers","restriction":""},{"name":"body","external_name":"body","restriction":""}],"args_string":"(io, headers, body)","args_html":"(io, headers, body)","location":{"filename":"src/http/common.cr","line_number":282,"url":null},"def":{"name":"serialize_headers_and_string_body","args":[{"name":"io","external_name":"io","restriction":""},{"name":"headers","external_name":"headers","restriction":""},{"name":"body","external_name":"body","restriction":""}],"visibility":"Public","body":"headers[\"Content-Length\"] = body.bytesize.to_s\nserialize_headers(io, headers)\nio << body\n"}}],"types":[{"html_id":"Crystal/HTTP/Client","path":"HTTP/Client.html","kind":"class","full_name":"HTTP::Client","name":"Client","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/client.cr","line_number":72,"url":null},{"filename":"src/http/client/response.cr","line_number":4,"url":null},{"filename":"src/http/log.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"Log","name":"Log","value":"::Log.for(self)"}],"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"An HTTP Client.\n\n### One-shot usage\n\nWithout a block, an `HTTP::Client::Response` is returned and the response's body\nis available as a `String` by invoking `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.get \"http://www.example.com\"\nresponse.status_code      # => 200\nresponse.body.lines.first # => \"<!doctype html>\"\n```\n\n### Parameters\n\nParameters can be added to any request with the `URI::Params.encode` method, which\nconverts a `Hash` or `NamedTuple` to a URL encoded HTTP query.\n\n```\nrequire \"http/client\"\n\nparams = URI::Params.encode({\"author\" => \"John Doe\", \"offset\" => \"20\"}) # => \"author=John+Doe&offset=20\"\nresponse = HTTP::Client.get URI.new(\"http\", \"www.example.com\", query: params)\nresponse.status_code # => 200\n```\n\n### Streaming\n\nWith a block, an `HTTP::Client::Response` body is returned and the response's body\nis available as an `IO` by invoking `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nHTTP::Client.get(\"http://www.example.com\") do |response|\n  response.status_code  # => 200\n  response.body_io.gets # => \"<!doctype html>\"\nend\n```\n\n### Reusing a connection\n\nSimilar to the above cases, but creating an instance of an `HTTP::Client`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.get \"/\"\nresponse.status_code      # => 200\nresponse.body.lines.first # => \"<!doctype html>\"\nclient.close\n```\n\n### Compression\n\nIf `compress` isn't set to `false`, and no `Accept-Encoding` header is explicitly specified,\nan HTTP::Client will add an `\"Accept-Encoding\": \"gzip, deflate\"` header, and automatically decompress\nthe response body/body_io.\n\n### Encoding\n\nIf a response has a `Content-Type` header with a charset, that charset is set as the encoding\nof the returned IO (or used for creating a String for the body). Invalid bytes in the given encoding\nare silently ignored when reading text content.","summary":"<p>An HTTP Client.</p>","class_methods":[{"html_id":"delete(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil):HTTP::Client::Response-class-method","name":"delete","doc":"Executes a DELETE request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.delete(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a DELETE request.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil) : HTTP::Client::Response","args_html":"(url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"delete","args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"DELETE\", url, headers, body, tls)"}},{"html_id":"delete(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil,&)-class-method","name":"delete","doc":"Executes a DELETE request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nHTTP::Client.delete(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a DELETE request and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil, &)","args_html":"(url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"delete","args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"yields":1,"visibility":"Public","body":"exec(\"DELETE\", url, headers, body, tls) do |response|\n  yield response\nend"}},{"html_id":"delete(url,headers:HTTP::Headers?=nil,tls:TLSContext=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","name":"delete","doc":"Executes a DELETE request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.delete \"http://www.example.com\", form: \"foo=bar\"\n```","summary":"<p>Executes a DELETE request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = nil, tls : TLSContext = nil, *, form : String | IO | Hash) : HTTP::Client::Response","args_html":"(url, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a> | <a href=\"../Hash.html\">Hash</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"delete","args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"splat_index":3,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.delete(path, form: form, headers: headers)\nend"}},{"html_id":"delete(url,headers:HTTP::Headers?=nil,tls:TLSContext=nil,*,form:String|IO|Hash,&)-class-method","name":"delete","doc":"Executes a DELETE request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nHTTP::Client.delete(\"http://www.example.com\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a DELETE request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = nil, tls : TLSContext = nil, *, form : String | IO | Hash, &)","args_html":"(url, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a> | <a href=\"../Hash.html\">Hash</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"delete","args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"splat_index":3,"yields":1,"visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.delete(path, form: form, headers: headers) do |response|\n    yield response\n  end\nend"}},{"html_id":"exec(method,url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil):HTTP::Client::Response-class-method","name":"exec","doc":"Executes a request.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.exec \"GET\", \"http://www.example.com\"\nresponse.body # => \"...\"\n```","summary":"<p>Executes a request.</p>","abstract":false,"args":[{"name":"method","external_name":"method","restriction":""},{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(method, url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil) : HTTP::Client::Response","args_html":"(method, url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":742,"url":null},"def":{"name":"exec","args":[{"name":"method","external_name":"method","restriction":""},{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"headers = default_one_shot_headers(headers)\nexec(url, tls) do |client, path|\n  client.exec(method, path, headers, body)\nend\n"}},{"html_id":"exec(method,url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil,&)-class-method","name":"exec","doc":"Executes a request.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nHTTP::Client.exec(\"GET\", \"http://www.example.com\") do |response|\n  response.body_io.gets # => \"...\"\nend\n```","summary":"<p>Executes a request.</p>","abstract":false,"args":[{"name":"method","external_name":"method","restriction":""},{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(method, url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil, &)","args_html":"(method, url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":759,"url":null},"def":{"name":"exec","args":[{"name":"method","external_name":"method","restriction":""},{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"yields":1,"visibility":"Public","body":"headers = default_one_shot_headers(headers)\nexec(url, tls) do |client, path|\n  client.exec(method, path, headers, body) do |response|\n    yield response\n  end\nend\n"}},{"html_id":"get(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil):HTTP::Client::Response-class-method","name":"get","doc":"Executes a GET request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.get(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a GET request.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil) : HTTP::Client::Response","args_html":"(url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"get","args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"GET\", url, headers, body, tls)"}},{"html_id":"get(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil,&)-class-method","name":"get","doc":"Executes a GET request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nHTTP::Client.get(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a GET request and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil, &)","args_html":"(url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"get","args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"yields":1,"visibility":"Public","body":"exec(\"GET\", url, headers, body, tls) do |response|\n  yield response\nend"}},{"html_id":"get(url,headers:HTTP::Headers?=nil,tls:TLSContext=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","name":"get","doc":"Executes a GET request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.get \"http://www.example.com\", form: \"foo=bar\"\n```","summary":"<p>Executes a GET request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = nil, tls : TLSContext = nil, *, form : String | IO | Hash) : HTTP::Client::Response","args_html":"(url, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a> | <a href=\"../Hash.html\">Hash</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"get","args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"splat_index":3,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.get(path, form: form, headers: headers)\nend"}},{"html_id":"get(url,headers:HTTP::Headers?=nil,tls:TLSContext=nil,*,form:String|IO|Hash,&)-class-method","name":"get","doc":"Executes a GET request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nHTTP::Client.get(\"http://www.example.com\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a GET request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = nil, tls : TLSContext = nil, *, form : String | IO | Hash, &)","args_html":"(url, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a> | <a href=\"../Hash.html\">Hash</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"get","args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"splat_index":3,"yields":1,"visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.get(path, form: form, headers: headers) do |response|\n    yield response\n  end\nend"}},{"html_id":"head(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil):HTTP::Client::Response-class-method","name":"head","doc":"Executes a HEAD request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.head(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a HEAD request.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil) : HTTP::Client::Response","args_html":"(url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"head","args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"HEAD\", url, headers, body, tls)"}},{"html_id":"head(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil,&)-class-method","name":"head","doc":"Executes a HEAD request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nHTTP::Client.head(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a HEAD request and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil, &)","args_html":"(url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"head","args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"yields":1,"visibility":"Public","body":"exec(\"HEAD\", url, headers, body, tls) do |response|\n  yield response\nend"}},{"html_id":"head(url,headers:HTTP::Headers?=nil,tls:TLSContext=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","name":"head","doc":"Executes a HEAD request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.head \"http://www.example.com\", form: \"foo=bar\"\n```","summary":"<p>Executes a HEAD request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = nil, tls : TLSContext = nil, *, form : String | IO | Hash) : HTTP::Client::Response","args_html":"(url, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a> | <a href=\"../Hash.html\">Hash</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"head","args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"splat_index":3,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.head(path, form: form, headers: headers)\nend"}},{"html_id":"head(url,headers:HTTP::Headers?=nil,tls:TLSContext=nil,*,form:String|IO|Hash,&)-class-method","name":"head","doc":"Executes a HEAD request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nHTTP::Client.head(\"http://www.example.com\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a HEAD request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = nil, tls : TLSContext = nil, *, form : String | IO | Hash, &)","args_html":"(url, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a> | <a href=\"../Hash.html\">Hash</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"head","args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"splat_index":3,"yields":1,"visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.head(path, form: form, headers: headers) do |response|\n    yield response\n  end\nend"}},{"html_id":"options(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil):HTTP::Client::Response-class-method","name":"options","doc":"Executes a OPTIONS request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.options(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a OPTIONS request.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil) : HTTP::Client::Response","args_html":"(url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"options","args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"OPTIONS\", url, headers, body, tls)"}},{"html_id":"options(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil,&)-class-method","name":"options","doc":"Executes a OPTIONS request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nHTTP::Client.options(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a OPTIONS request and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil, &)","args_html":"(url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"options","args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"yields":1,"visibility":"Public","body":"exec(\"OPTIONS\", url, headers, body, tls) do |response|\n  yield response\nend"}},{"html_id":"options(url,headers:HTTP::Headers?=nil,tls:TLSContext=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","name":"options","doc":"Executes a OPTIONS request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.options \"http://www.example.com\", form: \"foo=bar\"\n```","summary":"<p>Executes a OPTIONS request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = nil, tls : TLSContext = nil, *, form : String | IO | Hash) : HTTP::Client::Response","args_html":"(url, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a> | <a href=\"../Hash.html\">Hash</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"options","args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"splat_index":3,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.options(path, form: form, headers: headers)\nend"}},{"html_id":"options(url,headers:HTTP::Headers?=nil,tls:TLSContext=nil,*,form:String|IO|Hash,&)-class-method","name":"options","doc":"Executes a OPTIONS request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nHTTP::Client.options(\"http://www.example.com\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a OPTIONS request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = nil, tls : TLSContext = nil, *, form : String | IO | Hash, &)","args_html":"(url, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a> | <a href=\"../Hash.html\">Hash</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"options","args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"splat_index":3,"yields":1,"visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.options(path, form: form, headers: headers) do |response|\n    yield response\n  end\nend"}},{"html_id":"patch(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil):HTTP::Client::Response-class-method","name":"patch","doc":"Executes a PATCH request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.patch(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a PATCH request.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil) : HTTP::Client::Response","args_html":"(url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"patch","args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"PATCH\", url, headers, body, tls)"}},{"html_id":"patch(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil,&)-class-method","name":"patch","doc":"Executes a PATCH request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nHTTP::Client.patch(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a PATCH request and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil, &)","args_html":"(url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"patch","args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"yields":1,"visibility":"Public","body":"exec(\"PATCH\", url, headers, body, tls) do |response|\n  yield response\nend"}},{"html_id":"patch(url,headers:HTTP::Headers?=nil,tls:TLSContext=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","name":"patch","doc":"Executes a PATCH request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.patch \"http://www.example.com\", form: \"foo=bar\"\n```","summary":"<p>Executes a PATCH request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = nil, tls : TLSContext = nil, *, form : String | IO | Hash) : HTTP::Client::Response","args_html":"(url, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a> | <a href=\"../Hash.html\">Hash</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"patch","args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"splat_index":3,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.patch(path, form: form, headers: headers)\nend"}},{"html_id":"patch(url,headers:HTTP::Headers?=nil,tls:TLSContext=nil,*,form:String|IO|Hash,&)-class-method","name":"patch","doc":"Executes a PATCH request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nHTTP::Client.patch(\"http://www.example.com\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a PATCH request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = nil, tls : TLSContext = nil, *, form : String | IO | Hash, &)","args_html":"(url, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a> | <a href=\"../Hash.html\">Hash</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"patch","args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"splat_index":3,"yields":1,"visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.patch(path, form: form, headers: headers) do |response|\n    yield response\n  end\nend"}},{"html_id":"post(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil):HTTP::Client::Response-class-method","name":"post","doc":"Executes a POST request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.post(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a POST request.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil) : HTTP::Client::Response","args_html":"(url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"post","args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"POST\", url, headers, body, tls)"}},{"html_id":"post(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil,&)-class-method","name":"post","doc":"Executes a POST request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nHTTP::Client.post(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a POST request and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil, &)","args_html":"(url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"post","args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"yields":1,"visibility":"Public","body":"exec(\"POST\", url, headers, body, tls) do |response|\n  yield response\nend"}},{"html_id":"post(url,headers:HTTP::Headers?=nil,tls:TLSContext=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","name":"post","doc":"Executes a POST request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.post \"http://www.example.com\", form: \"foo=bar\"\n```","summary":"<p>Executes a POST request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = nil, tls : TLSContext = nil, *, form : String | IO | Hash) : HTTP::Client::Response","args_html":"(url, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a> | <a href=\"../Hash.html\">Hash</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"post","args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"splat_index":3,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.post(path, form: form, headers: headers)\nend"}},{"html_id":"post(url,headers:HTTP::Headers?=nil,tls:TLSContext=nil,*,form:String|IO|Hash,&)-class-method","name":"post","doc":"Executes a POST request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nHTTP::Client.post(\"http://www.example.com\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a POST request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = nil, tls : TLSContext = nil, *, form : String | IO | Hash, &)","args_html":"(url, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a> | <a href=\"../Hash.html\">Hash</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"post","args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"splat_index":3,"yields":1,"visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.post(path, form: form, headers: headers) do |response|\n    yield response\n  end\nend"}},{"html_id":"put(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil):HTTP::Client::Response-class-method","name":"put","doc":"Executes a PUT request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.put(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a PUT request.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil) : HTTP::Client::Response","args_html":"(url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"put","args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"PUT\", url, headers, body, tls)"}},{"html_id":"put(url:String|URI,headers:HTTP::Headers?=nil,body:BodyType=nil,tls:TLSContext=nil,&)-class-method","name":"put","doc":"Executes a PUT request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nHTTP::Client.put(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a PUT request and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(url : String | URI, headers : HTTP::Headers? = nil, body : BodyType = nil, tls : TLSContext = nil, &)","args_html":"(url : <a href=\"../String.html\">String</a> | <a href=\"../URI.html\">URI</a>, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"put","args":[{"name":"url","external_name":"url","restriction":"String | URI"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"yields":1,"visibility":"Public","body":"exec(\"PUT\", url, headers, body, tls) do |response|\n  yield response\nend"}},{"html_id":"put(url,headers:HTTP::Headers?=nil,tls:TLSContext=nil,*,form:String|IO|Hash):HTTP::Client::Response-class-method","name":"put","doc":"Executes a PUT request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client.put \"http://www.example.com\", form: \"foo=bar\"\n```","summary":"<p>Executes a PUT request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = nil, tls : TLSContext = nil, *, form : String | IO | Hash) : HTTP::Client::Response","args_html":"(url, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a> | <a href=\"../Hash.html\">Hash</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"put","args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"splat_index":3,"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.put(path, form: form, headers: headers)\nend"}},{"html_id":"put(url,headers:HTTP::Headers?=nil,tls:TLSContext=nil,*,form:String|IO|Hash,&)-class-method","name":"put","doc":"Executes a PUT request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nHTTP::Client.put(\"http://www.example.com\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a PUT request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"args_string":"(url, headers : HTTP::Headers? = nil, tls : TLSContext = nil, *, form : String | IO | Hash, &)","args_html":"(url, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a> | <a href=\"../Hash.html\">Hash</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"put","args":[{"name":"url","external_name":"url","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO | Hash"}],"splat_index":3,"yields":1,"visibility":"Public","body":"exec(url, tls) do |client, path|\n  client.put(path, form: form, headers: headers) do |response|\n    yield response\n  end\nend"}}],"constructors":[{"html_id":"new(host:String,port=nil,tls:TLSContext=nil)-class-method","name":"new","doc":"Creates a new HTTP client with the given *host*, *port* and *tls*\nconfigurations. If no port is given, the default one will\nbe used depending on the *tls* arguments: 80 for if *tls* is `false`,\n443 if *tls* is truthy. If *tls* is `true` a new `OpenSSL::SSL::Context::Client` will\nbe used, else the given one. In any case the active context can be accessed through `tls`.","summary":"<p>Creates a new HTTP client with the given <em>host</em>, <em>port</em> and <em>tls</em> configurations.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","default_value":"nil","external_name":"port","restriction":""},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(host : String, port = nil, tls : TLSContext = nil)","args_html":"(host : <a href=\"../String.html\">String</a>, port = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>)","location":{"filename":"src/http/client.cr","line_number":129,"url":null},"def":{"name":"new","args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","default_value":"nil","external_name":"port","restriction":""},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"visibility":"Public","body":"_ = allocate\n_.initialize(host, port, tls)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(io:IO,host=\"\",port=80)-class-method","name":"new","doc":"Creates a new HTTP client bound to an existing `IO`.\n*host* and *port* can be specified and they will be used\nto conform the `Host` header on each request.\nInstances created with this constructor cannot be reconnected. Once\n`close` is called explicitly or if the connection doesn't support keep-alive,\nthe next call to make a request will raise an exception.","summary":"<p>Creates a new HTTP client bound to an existing <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"host","default_value":"\"\"","external_name":"host","restriction":""},{"name":"port","default_value":"80","external_name":"port","restriction":""}],"args_string":"(io : IO, host = \"\", port = 80)","args_html":"(io : <a href=\"../IO.html\">IO</a>, host = <span class=\"s\">&quot;&quot;</span>, port = <span class=\"n\">80</span>)","location":{"filename":"src/http/client.cr","line_number":157,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"host","default_value":"\"\"","external_name":"host","restriction":""},{"name":"port","default_value":"80","external_name":"port","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, host, port)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(uri:URI,tls:TLSContext=nil)-class-method","name":"new","doc":"Creates a new HTTP client from a URI. Parses the *host*, *port*,\nand *tls* configuration from the URI provided. Port defaults to\n80 if not specified unless using the https protocol, which defaults\nto port 443 and sets tls to `true`.\n\n```\nrequire \"http/client\"\nrequire \"uri\"\n\nuri = URI.parse(\"https://secure.example.com\")\nclient = HTTP::Client.new(uri)\n\nclient.tls? # => #<OpenSSL::SSL::Context::Client>\nclient.get(\"/\")\n```\nThis constructor will *ignore* any path or query segments in the URI\nas those will need to be passed to the client when a request is made.\n\nIf *tls* is given it will be used, if not a new TLS context will be created.\nIf *tls* is given and *uri* is a HTTP URI, `ArgumentError` is raised.\nIn any case the active context can be accessed through `tls`.\n\nThis constructor will raise an exception if any scheme but HTTP or HTTPS\nis used.","summary":"<p>Creates a new HTTP client from a URI.</p>","abstract":false,"args":[{"name":"uri","external_name":"uri","restriction":"URI"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(uri : URI, tls : TLSContext = nil)","args_html":"(uri : <a href=\"../URI.html\">URI</a>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>)","location":{"filename":"src/http/client.cr","line_number":200,"url":null},"def":{"name":"new","args":[{"name":"uri","external_name":"uri","restriction":"URI"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"visibility":"Public","body":"tls = tls_flag(uri, tls)\nhost = validate_host(uri)\nnew(host, uri.port, tls)\n"}},{"html_id":"new(uri:URI,tls:TLSContext=nil,&)-class-method","name":"new","doc":"Creates a new HTTP client from a URI, yields it to the block and closes the\nclient afterwards. Parses the *host*, *port*, and *tls* configuration from\nthe URI provided. Port defaults to 80 if not specified unless using the\nhttps protocol, which defaults to port 443 and sets tls to `true`.\n\n```\nrequire \"http/client\"\nrequire \"uri\"\n\nuri = URI.parse(\"https://secure.example.com\")\nHTTP::Client.new(uri) do |client|\n  client.tls? # => #<OpenSSL::SSL::Context::Client>\n  client.get(\"/\")\nend\n```\nThis constructor will *ignore* any path or query segments in the URI\nas those will need to be passed to the client when a request is made.\n\nIf *tls* is given it will be used, if not a new TLS context will be created.\nIf *tls* is given and *uri* is a HTTP URI, `ArgumentError` is raised.\nIn any case the active context can be accessed through `tls`.\n\nThis constructor will raise an exception if any scheme but HTTP or HTTPS\nis used.","summary":"<p>Creates a new HTTP client from a URI, yields it to the block and closes the client afterwards.</p>","abstract":false,"args":[{"name":"uri","external_name":"uri","restriction":"URI"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(uri : URI, tls : TLSContext = nil, &)","args_html":"(uri : <a href=\"../URI.html\">URI</a>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":230,"url":null},"def":{"name":"new","args":[{"name":"uri","external_name":"uri","restriction":"URI"},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"yields":1,"visibility":"Public","body":"tls = tls_flag(uri, tls)\nhost = validate_host(uri)\nclient = new(host, uri.port, tls)\nbegin\n  yield client\nensure\n  client.close\nend\n"}},{"html_id":"new(host:String,port=nil,tls:TLSContext=nil,&)-class-method","name":"new","doc":"Creates a new HTTP client, yields it to the block, and closes\nthe client afterwards.\n\n```\nrequire \"http/client\"\n\nHTTP::Client.new(\"www.example.com\") do |client|\n  client.get \"/\"\nend\n```","summary":"<p>Creates a new HTTP client, yields it to the block, and closes the client afterwards.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","default_value":"nil","external_name":"port","restriction":""},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"args_string":"(host : String, port = nil, tls : TLSContext = nil, &)","args_html":"(host : <a href=\"../String.html\">String</a>, port = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">TLSContext</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":251,"url":null},"def":{"name":"new","args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","default_value":"nil","external_name":"port","restriction":""},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"TLSContext"}],"yields":1,"visibility":"Public","body":"client = new(host, port, tls)\nbegin\n  yield client\nensure\n  client.close\nend\n"}}],"instance_methods":[{"html_id":"basic_auth(username,password):Nil-instance-method","name":"basic_auth","doc":"Configures this client to perform basic authentication in every\nrequest.","summary":"<p>Configures this client to perform basic authentication in every request.</p>","abstract":false,"args":[{"name":"username","external_name":"username","restriction":""},{"name":"password","external_name":"password","restriction":""}],"args_string":"(username, password) : Nil","args_html":"(username, password) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/http/client.cr","line_number":262,"url":null},"def":{"name":"basic_auth","args":[{"name":"username","external_name":"username","restriction":""},{"name":"password","external_name":"password","restriction":""}],"return_type":"Nil","visibility":"Public","body":"header = \"Basic #{Base64.strict_encode(\"#{username}:#{password}\")}\"\nbefore_request do |request|\n  request.headers[\"Authorization\"] = header\nend\n"}},{"html_id":"before_request(&callback:HTTP::Request->):Nil-instance-method","name":"before_request","doc":"Adds a callback to execute before each request. This is usually\nused to set an authorization header. Any number of callbacks\ncan be added.\n\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"www.example.com\")\nclient.before_request do |request|\n  request.headers[\"Authorization\"] = \"XYZ123\"\nend\nclient.get \"/\"\n```","summary":"<p>Adds a callback to execute before each request.</p>","abstract":false,"location":{"filename":"src/http/client.cr","line_number":401,"url":null},"def":{"name":"before_request","yields":1,"block_arg":{"name":"callback","external_name":"callback","restriction":"(HTTP::Request ->)"},"return_type":"Nil","visibility":"Public","body":"before_request = @before_request || (@before_request = [] of (HTTP::Request ->))\nbefore_request << callback\n"}},{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes this client. If used again, a new connection will be opened.","summary":"<p>Closes this client.</p>","abstract":false,"location":{"filename":"src/http/client.cr","line_number":769,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"begin\n  @io.try(&.close)\nrescue IO::Error\n  nil\nensure\n  @io = nil\nend"}},{"html_id":"compress=(compress:Bool)-instance-method","name":"compress=","doc":"Whether automatic compression/decompression is enabled.","summary":"<p>Whether automatic compression/decompression is enabled.</p>","abstract":false,"args":[{"name":"compress","external_name":"compress","restriction":"Bool"}],"args_string":"(compress : Bool)","args_html":"(compress : <a href=\"../Bool.html\">Bool</a>)","location":{"filename":"src/http/client.cr","line_number":115,"url":null},"def":{"name":"compress=","args":[{"name":"compress","external_name":"compress","restriction":"Bool"}],"visibility":"Public","body":"@compress = compress"}},{"html_id":"compress?:Bool-instance-method","name":"compress?","doc":"Whether automatic compression/decompression is enabled.","summary":"<p>Whether automatic compression/decompression is enabled.</p>","abstract":false,"location":{"filename":"src/http/client.cr","line_number":115,"url":null},"def":{"name":"compress?","return_type":"Bool","visibility":"Public","body":"@compress"}},{"html_id":"connect_timeout=(connect_timeout:Number)-instance-method","name":"connect_timeout=","doc":"Sets the number of seconds to wait when connecting, before raising an `IO::TimeoutError`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"example.org\")\nclient.connect_timeout = 1.5\nbegin\n  response = client.get(\"/\")\nrescue IO::TimeoutError\n  puts \"Timeout!\"\nend\n```","summary":"<p>Sets the number of seconds to wait when connecting, before raising an <code><a href=\"../IO/TimeoutError.html\">IO::TimeoutError</a></code>.</p>","abstract":false,"args":[{"name":"connect_timeout","external_name":"connect_timeout","restriction":"Number"}],"args_string":"(connect_timeout : Number)","args_html":"(connect_timeout : <a href=\"../Number.html\">Number</a>)","location":{"filename":"src/http/client.cr","line_number":328,"url":null},"def":{"name":"connect_timeout=","args":[{"name":"connect_timeout","external_name":"connect_timeout","restriction":"Number"}],"visibility":"Public","body":"@connect_timeout = connect_timeout.to_f"}},{"html_id":"connect_timeout=(connect_timeout:Time::Span)-instance-method","name":"connect_timeout=","doc":"Sets the open timeout with a `Time::Span` to wait when connecting, before raising an `IO::TimeoutError`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"example.org\")\nclient.connect_timeout = 5.minutes\nbegin\n  response = client.get(\"/\")\nrescue IO::TimeoutError\n  puts \"Timeout!\"\nend\n```","summary":"<p>Sets the open timeout with a <code><a href=\"../Time/Span.html\">Time::Span</a></code> to wait when connecting, before raising an <code><a href=\"../IO/TimeoutError.html\">IO::TimeoutError</a></code>.</p>","abstract":false,"args":[{"name":"connect_timeout","external_name":"connect_timeout","restriction":"Time::Span"}],"args_string":"(connect_timeout : Time::Span)","args_html":"(connect_timeout : <a href=\"../Time/Span.html\">Time::Span</a>)","location":{"filename":"src/http/client.cr","line_number":345,"url":null},"def":{"name":"connect_timeout=","args":[{"name":"connect_timeout","external_name":"connect_timeout","restriction":"Time::Span"}],"visibility":"Public","body":"self.connect_timeout = connect_timeout.total_seconds"}},{"html_id":"delete(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"delete","doc":"Executes a DELETE request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"www.example.com\")\nresponse = client.delete(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a DELETE request.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = nil, body : BodyType = nil) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"delete","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"DELETE\", path, headers, body)"}},{"html_id":"delete(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&)-instance-method","name":"delete","doc":"Executes a DELETE request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"www.example.com\")\nclient.delete(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a DELETE request and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = nil, body : BodyType = nil, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"delete","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"yields":1,"visibility":"Public","body":"exec(\"DELETE\", path, headers, body) do |response|\n  yield response\nend"}},{"html_id":"delete(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","name":"delete","doc":"Executes a DELETE request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.delete \"/\", form: \"foo=bar\"\n```","summary":"<p>Executes a DELETE request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : String | IO) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"delete","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"splat_index":2,"return_type":"HTTP::Client::Response","visibility":"Public","body":"request = new_request(\"DELETE\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request)\n"}},{"html_id":"delete(path,headers:HTTP::Headers?=nil,*,form:String|IO,&)-instance-method","name":"delete","doc":"Executes a DELETE request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.delete(\"/\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a DELETE request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : String | IO, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"delete","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"splat_index":2,"yields":1,"visibility":"Public","body":"request = new_request(\"DELETE\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request) do |response|\n  yield response\nend\n"}},{"html_id":"delete(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","name":"delete","doc":"Executes a DELETE request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.delete \"/\", form: {\"foo\" => \"bar\"}\n```","summary":"<p>Executes a DELETE request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : Hash(String, String) | NamedTuple) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>) | <a href=\"../NamedTuple.html\">NamedTuple</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"delete","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"splat_index":2,"return_type":"HTTP::Client::Response","visibility":"Public","body":"body = URI::Params.encode(form)\ndelete(path, form: body, headers: headers)\n"}},{"html_id":"delete(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&)-instance-method","name":"delete","doc":"Executes a DELETE request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.delete(\"/\", form: {\"foo\" => \"bar\"}) do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a DELETE request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : Hash(String, String) | NamedTuple, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>) | <a href=\"../NamedTuple.html\">NamedTuple</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"delete","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"splat_index":2,"yields":1,"visibility":"Public","body":"body = URI::Params.encode(form)\ndelete(path, form: body, headers: headers) do |response|\n  yield response\nend\n"}},{"html_id":"dns_timeout=(dns_timeout:Number)-instance-method","name":"dns_timeout=","doc":"**This method has no effect right now**\n\nSets the number of seconds to wait when resolving a name, before raising an `IO::TimeoutError`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"example.org\")\nclient.dns_timeout = 1.5\nbegin\n  response = client.get(\"/\")\nrescue IO::TimeoutError\n  puts \"Timeout!\"\nend\n```","summary":"<p><strong>This method has no effect right now</strong></p>","abstract":false,"args":[{"name":"dns_timeout","external_name":"dns_timeout","restriction":"Number"}],"args_string":"(dns_timeout : Number)","args_html":"(dns_timeout : <a href=\"../Number.html\">Number</a>)","location":{"filename":"src/http/client.cr","line_number":364,"url":null},"def":{"name":"dns_timeout=","args":[{"name":"dns_timeout","external_name":"dns_timeout","restriction":"Number"}],"visibility":"Public","body":"@dns_timeout = dns_timeout.to_f"}},{"html_id":"dns_timeout=(dns_timeout:Time::Span)-instance-method","name":"dns_timeout=","doc":"**This method has no effect right now**\n\nSets the number of seconds to wait when resolving a name with a `Time::Span`, before raising an `IO::TimeoutError`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"example.org\")\nclient.dns_timeout = 1.5.seconds\nbegin\n  response = client.get(\"/\")\nrescue IO::TimeoutError\n  puts \"Timeout!\"\nend\n```","summary":"<p><strong>This method has no effect right now</strong></p>","abstract":false,"args":[{"name":"dns_timeout","external_name":"dns_timeout","restriction":"Time::Span"}],"args_string":"(dns_timeout : Time::Span)","args_html":"(dns_timeout : <a href=\"../Time/Span.html\">Time::Span</a>)","location":{"filename":"src/http/client.cr","line_number":383,"url":null},"def":{"name":"dns_timeout=","args":[{"name":"dns_timeout","external_name":"dns_timeout","restriction":"Time::Span"}],"visibility":"Public","body":"self.dns_timeout = dns_timeout.total_seconds"}},{"html_id":"exec(method:String,path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"exec","doc":"Executes a request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.exec \"GET\", \"/\"\nresponse.body # => \"...\"\n```","summary":"<p>Executes a request.</p>","abstract":false,"args":[{"name":"method","external_name":"method","restriction":"String"},{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(method : String, path, headers : HTTP::Headers? = nil, body : BodyType = nil) : HTTP::Client::Response","args_html":"(method : <a href=\"../String.html\">String</a>, path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":712,"url":null},"def":{"name":"exec","args":[{"name":"method","external_name":"method","restriction":"String"},{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(new_request(method, path, headers, body))"}},{"html_id":"exec(request:HTTP::Request):HTTP::Client::Response-instance-method","name":"exec","doc":"Executes a request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.exec HTTP::Request.new(\"GET\", \"/\")\nresponse.body # => \"...\"\n```","summary":"<p>Executes a request.</p>","abstract":false,"args":[{"name":"request","external_name":"request","restriction":"HTTP::Request"}],"args_string":"(request : HTTP::Request) : HTTP::Client::Response","args_html":"(request : <a href=\"../HTTP/Request.html\">HTTP::Request</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":579,"url":null},"def":{"name":"exec","args":[{"name":"request","external_name":"request","restriction":"HTTP::Request"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"around_exec(request) do\n  exec_internal(request)\nend"}},{"html_id":"exec(method:String,path,headers:HTTP::Headers?=nil,body:BodyType=nil,&)-instance-method","name":"exec","doc":"Executes a request.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.exec(\"GET\", \"/\") do |response|\n  response.body_io.gets # => \"...\"\nend\n```","summary":"<p>Executes a request.</p>","abstract":false,"args":[{"name":"method","external_name":"method","restriction":"String"},{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(method : String, path, headers : HTTP::Headers? = nil, body : BodyType = nil, &)","args_html":"(method : <a href=\"../String.html\">String</a>, path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":727,"url":null},"def":{"name":"exec","args":[{"name":"method","external_name":"method","restriction":"String"},{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"yields":1,"visibility":"Public","body":"exec(new_request(method, path, headers, body)) do |response|\n  yield response\nend"}},{"html_id":"exec(request:HTTP::Request,&)-instance-method","name":"exec","doc":"Executes a request request and yields an `HTTP::Client::Response` to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.exec(HTTP::Request.new(\"GET\", \"/\")) do |response|\n  response.body_io.gets # => \"...\"\nend\n```","summary":"<p>Executes a request request and yields an <code><a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a></code> to the block.</p>","abstract":false,"args":[{"name":"request","external_name":"request","restriction":"HTTP::Request"}],"args_string":"(request : HTTP::Request, &)","args_html":"(request : <a href=\"../HTTP/Request.html\">HTTP::Request</a>, &)","location":{"filename":"src/http/client.cr","line_number":623,"url":null},"def":{"name":"exec","args":[{"name":"request","external_name":"request","restriction":"HTTP::Request"}],"yields":1,"visibility":"Public","body":"around_exec(request) do\n  exec_internal(request) do |response|\n    yield response\n  end\nend"}},{"html_id":"get(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"get","doc":"Executes a GET request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"www.example.com\")\nresponse = client.get(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a GET request.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = nil, body : BodyType = nil) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"get","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"GET\", path, headers, body)"}},{"html_id":"get(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&)-instance-method","name":"get","doc":"Executes a GET request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"www.example.com\")\nclient.get(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a GET request and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = nil, body : BodyType = nil, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"get","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"yields":1,"visibility":"Public","body":"exec(\"GET\", path, headers, body) do |response|\n  yield response\nend"}},{"html_id":"get(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","name":"get","doc":"Executes a GET request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.get \"/\", form: \"foo=bar\"\n```","summary":"<p>Executes a GET request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : String | IO) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"get","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"splat_index":2,"return_type":"HTTP::Client::Response","visibility":"Public","body":"request = new_request(\"GET\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request)\n"}},{"html_id":"get(path,headers:HTTP::Headers?=nil,*,form:String|IO,&)-instance-method","name":"get","doc":"Executes a GET request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.get(\"/\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a GET request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : String | IO, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"get","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"splat_index":2,"yields":1,"visibility":"Public","body":"request = new_request(\"GET\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request) do |response|\n  yield response\nend\n"}},{"html_id":"get(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","name":"get","doc":"Executes a GET request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.get \"/\", form: {\"foo\" => \"bar\"}\n```","summary":"<p>Executes a GET request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : Hash(String, String) | NamedTuple) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>) | <a href=\"../NamedTuple.html\">NamedTuple</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"get","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"splat_index":2,"return_type":"HTTP::Client::Response","visibility":"Public","body":"body = URI::Params.encode(form)\nget(path, form: body, headers: headers)\n"}},{"html_id":"get(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&)-instance-method","name":"get","doc":"Executes a GET request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.get(\"/\", form: {\"foo\" => \"bar\"}) do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a GET request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : Hash(String, String) | NamedTuple, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>) | <a href=\"../NamedTuple.html\">NamedTuple</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"get","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"splat_index":2,"yields":1,"visibility":"Public","body":"body = URI::Params.encode(form)\nget(path, form: body, headers: headers) do |response|\n  yield response\nend\n"}},{"html_id":"head(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"head","doc":"Executes a HEAD request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"www.example.com\")\nresponse = client.head(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a HEAD request.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = nil, body : BodyType = nil) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"head","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"HEAD\", path, headers, body)"}},{"html_id":"head(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&)-instance-method","name":"head","doc":"Executes a HEAD request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"www.example.com\")\nclient.head(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a HEAD request and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = nil, body : BodyType = nil, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"head","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"yields":1,"visibility":"Public","body":"exec(\"HEAD\", path, headers, body) do |response|\n  yield response\nend"}},{"html_id":"head(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","name":"head","doc":"Executes a HEAD request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.head \"/\", form: \"foo=bar\"\n```","summary":"<p>Executes a HEAD request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : String | IO) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"head","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"splat_index":2,"return_type":"HTTP::Client::Response","visibility":"Public","body":"request = new_request(\"HEAD\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request)\n"}},{"html_id":"head(path,headers:HTTP::Headers?=nil,*,form:String|IO,&)-instance-method","name":"head","doc":"Executes a HEAD request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.head(\"/\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a HEAD request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : String | IO, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"head","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"splat_index":2,"yields":1,"visibility":"Public","body":"request = new_request(\"HEAD\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request) do |response|\n  yield response\nend\n"}},{"html_id":"head(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","name":"head","doc":"Executes a HEAD request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.head \"/\", form: {\"foo\" => \"bar\"}\n```","summary":"<p>Executes a HEAD request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : Hash(String, String) | NamedTuple) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>) | <a href=\"../NamedTuple.html\">NamedTuple</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"head","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"splat_index":2,"return_type":"HTTP::Client::Response","visibility":"Public","body":"body = URI::Params.encode(form)\nhead(path, form: body, headers: headers)\n"}},{"html_id":"head(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&)-instance-method","name":"head","doc":"Executes a HEAD request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.head(\"/\", form: {\"foo\" => \"bar\"}) do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a HEAD request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : Hash(String, String) | NamedTuple, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>) | <a href=\"../NamedTuple.html\">NamedTuple</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"head","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"splat_index":2,"yields":1,"visibility":"Public","body":"body = URI::Params.encode(form)\nhead(path, form: body, headers: headers) do |response|\n  yield response\nend\n"}},{"html_id":"host:String-instance-method","name":"host","doc":"Returns the target host.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.host # => \"www.example.com\"\n```","summary":"<p>Returns the target host.</p>","abstract":false,"location":{"filename":"src/http/client.cr","line_number":84,"url":null},"def":{"name":"host","return_type":"String","visibility":"Public","body":"@host"}},{"html_id":"options(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"options","doc":"Executes a OPTIONS request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"www.example.com\")\nresponse = client.options(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a OPTIONS request.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = nil, body : BodyType = nil) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"options","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"OPTIONS\", path, headers, body)"}},{"html_id":"options(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&)-instance-method","name":"options","doc":"Executes a OPTIONS request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"www.example.com\")\nclient.options(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a OPTIONS request and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = nil, body : BodyType = nil, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"options","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"yields":1,"visibility":"Public","body":"exec(\"OPTIONS\", path, headers, body) do |response|\n  yield response\nend"}},{"html_id":"options(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","name":"options","doc":"Executes a OPTIONS request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.options \"/\", form: \"foo=bar\"\n```","summary":"<p>Executes a OPTIONS request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : String | IO) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"options","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"splat_index":2,"return_type":"HTTP::Client::Response","visibility":"Public","body":"request = new_request(\"OPTIONS\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request)\n"}},{"html_id":"options(path,headers:HTTP::Headers?=nil,*,form:String|IO,&)-instance-method","name":"options","doc":"Executes a OPTIONS request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.options(\"/\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a OPTIONS request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : String | IO, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"options","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"splat_index":2,"yields":1,"visibility":"Public","body":"request = new_request(\"OPTIONS\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request) do |response|\n  yield response\nend\n"}},{"html_id":"options(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","name":"options","doc":"Executes a OPTIONS request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.options \"/\", form: {\"foo\" => \"bar\"}\n```","summary":"<p>Executes a OPTIONS request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : Hash(String, String) | NamedTuple) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>) | <a href=\"../NamedTuple.html\">NamedTuple</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"options","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"splat_index":2,"return_type":"HTTP::Client::Response","visibility":"Public","body":"body = URI::Params.encode(form)\noptions(path, form: body, headers: headers)\n"}},{"html_id":"options(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&)-instance-method","name":"options","doc":"Executes a OPTIONS request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.options(\"/\", form: {\"foo\" => \"bar\"}) do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a OPTIONS request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : Hash(String, String) | NamedTuple, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>) | <a href=\"../NamedTuple.html\">NamedTuple</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"options","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"splat_index":2,"yields":1,"visibility":"Public","body":"body = URI::Params.encode(form)\noptions(path, form: body, headers: headers) do |response|\n  yield response\nend\n"}},{"html_id":"patch(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"patch","doc":"Executes a PATCH request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"www.example.com\")\nresponse = client.patch(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a PATCH request.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = nil, body : BodyType = nil) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"patch","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"PATCH\", path, headers, body)"}},{"html_id":"patch(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&)-instance-method","name":"patch","doc":"Executes a PATCH request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"www.example.com\")\nclient.patch(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a PATCH request and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = nil, body : BodyType = nil, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"patch","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"yields":1,"visibility":"Public","body":"exec(\"PATCH\", path, headers, body) do |response|\n  yield response\nend"}},{"html_id":"patch(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","name":"patch","doc":"Executes a PATCH request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.patch \"/\", form: \"foo=bar\"\n```","summary":"<p>Executes a PATCH request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : String | IO) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"patch","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"splat_index":2,"return_type":"HTTP::Client::Response","visibility":"Public","body":"request = new_request(\"PATCH\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request)\n"}},{"html_id":"patch(path,headers:HTTP::Headers?=nil,*,form:String|IO,&)-instance-method","name":"patch","doc":"Executes a PATCH request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.patch(\"/\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a PATCH request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : String | IO, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"patch","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"splat_index":2,"yields":1,"visibility":"Public","body":"request = new_request(\"PATCH\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request) do |response|\n  yield response\nend\n"}},{"html_id":"patch(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","name":"patch","doc":"Executes a PATCH request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.patch \"/\", form: {\"foo\" => \"bar\"}\n```","summary":"<p>Executes a PATCH request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : Hash(String, String) | NamedTuple) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>) | <a href=\"../NamedTuple.html\">NamedTuple</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"patch","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"splat_index":2,"return_type":"HTTP::Client::Response","visibility":"Public","body":"body = URI::Params.encode(form)\npatch(path, form: body, headers: headers)\n"}},{"html_id":"patch(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&)-instance-method","name":"patch","doc":"Executes a PATCH request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.patch(\"/\", form: {\"foo\" => \"bar\"}) do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a PATCH request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : Hash(String, String) | NamedTuple, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>) | <a href=\"../NamedTuple.html\">NamedTuple</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"patch","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"splat_index":2,"yields":1,"visibility":"Public","body":"body = URI::Params.encode(form)\npatch(path, form: body, headers: headers) do |response|\n  yield response\nend\n"}},{"html_id":"port:Int32-instance-method","name":"port","doc":"Returns the target port.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.port # => 80\n```","summary":"<p>Returns the target port.</p>","abstract":false,"location":{"filename":"src/http/client.cr","line_number":94,"url":null},"def":{"name":"port","return_type":"Int32","visibility":"Public","body":"@port"}},{"html_id":"post(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"post","doc":"Executes a POST request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"www.example.com\")\nresponse = client.post(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a POST request.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = nil, body : BodyType = nil) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"post","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"POST\", path, headers, body)"}},{"html_id":"post(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&)-instance-method","name":"post","doc":"Executes a POST request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"www.example.com\")\nclient.post(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a POST request and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = nil, body : BodyType = nil, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"post","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"yields":1,"visibility":"Public","body":"exec(\"POST\", path, headers, body) do |response|\n  yield response\nend"}},{"html_id":"post(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","name":"post","doc":"Executes a POST request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.post \"/\", form: \"foo=bar\"\n```","summary":"<p>Executes a POST request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : String | IO) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"post","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"splat_index":2,"return_type":"HTTP::Client::Response","visibility":"Public","body":"request = new_request(\"POST\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request)\n"}},{"html_id":"post(path,headers:HTTP::Headers?=nil,*,form:String|IO,&)-instance-method","name":"post","doc":"Executes a POST request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.post(\"/\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a POST request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : String | IO, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"post","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"splat_index":2,"yields":1,"visibility":"Public","body":"request = new_request(\"POST\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request) do |response|\n  yield response\nend\n"}},{"html_id":"post(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","name":"post","doc":"Executes a POST request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.post \"/\", form: {\"foo\" => \"bar\"}\n```","summary":"<p>Executes a POST request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : Hash(String, String) | NamedTuple) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>) | <a href=\"../NamedTuple.html\">NamedTuple</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"post","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"splat_index":2,"return_type":"HTTP::Client::Response","visibility":"Public","body":"body = URI::Params.encode(form)\npost(path, form: body, headers: headers)\n"}},{"html_id":"post(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&)-instance-method","name":"post","doc":"Executes a POST request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.post(\"/\", form: {\"foo\" => \"bar\"}) do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a POST request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : Hash(String, String) | NamedTuple, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>) | <a href=\"../NamedTuple.html\">NamedTuple</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"post","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"splat_index":2,"yields":1,"visibility":"Public","body":"body = URI::Params.encode(form)\npost(path, form: body, headers: headers) do |response|\n  yield response\nend\n"}},{"html_id":"put(path,headers:HTTP::Headers?=nil,body:BodyType=nil):HTTP::Client::Response-instance-method","name":"put","doc":"Executes a PUT request.\nThe response will have its body as a `String`, accessed via `HTTP::Client::Response#body`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"www.example.com\")\nresponse = client.put(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\")\nresponse.body #=> \"...\"\n```","summary":"<p>Executes a PUT request.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = nil, body : BodyType = nil) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"put","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"return_type":"HTTP::Client::Response","visibility":"Public","body":"exec(\"PUT\", path, headers, body)"}},{"html_id":"put(path,headers:HTTP::Headers?=nil,body:BodyType=nil,&)-instance-method","name":"put","doc":"Executes a PUT request and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"www.example.com\")\nclient.put(\"/\", headers: HTTP::Headers{\"User-Agent\" => \"AwesomeApp\"}, body: \"Hello!\") do |response|\n  response.body_io.gets #=> \"...\"\nend\n```","summary":"<p>Executes a PUT request and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"args_string":"(path, headers : HTTP::Headers? = nil, body : BodyType = nil, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../HTTP/Client/BodyType.html\">BodyType</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"put","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"BodyType"}],"yields":1,"visibility":"Public","body":"exec(\"PUT\", path, headers, body) do |response|\n  yield response\nend"}},{"html_id":"put(path,headers:HTTP::Headers?=nil,*,form:String|IO):HTTP::Client::Response-instance-method","name":"put","doc":"Executes a PUT request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.put \"/\", form: \"foo=bar\"\n```","summary":"<p>Executes a PUT request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : String | IO) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"put","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"splat_index":2,"return_type":"HTTP::Client::Response","visibility":"Public","body":"request = new_request(\"PUT\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request)\n"}},{"html_id":"put(path,headers:HTTP::Headers?=nil,*,form:String|IO,&)-instance-method","name":"put","doc":"Executes a PUT request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-Type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.put(\"/\", form: \"foo=bar\") do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a PUT request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : String | IO, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"put","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"String | IO"}],"splat_index":2,"yields":1,"visibility":"Public","body":"request = new_request(\"PUT\", path, headers, form)\nrequest.headers[\"Content-Type\"] = \"application/x-www-form-urlencoded\"\nexec(request) do |response|\n  yield response\nend\n"}},{"html_id":"put(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple):HTTP::Client::Response-instance-method","name":"put","doc":"Executes a PUT request with form data and returns a `Response`. The \"Content-Type\" header is set\nto \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nresponse = client.put \"/\", form: {\"foo\" => \"bar\"}\n```","summary":"<p>Executes a PUT request with form data and returns a <code><a href=\"../HTTP/Client/Response.html\">Response</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : Hash(String, String) | NamedTuple) : HTTP::Client::Response","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>) | <a href=\"../NamedTuple.html\">NamedTuple</a>) : <a href=\"../HTTP/Client/Response.html\">HTTP::Client::Response</a>","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"put","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"splat_index":2,"return_type":"HTTP::Client::Response","visibility":"Public","body":"body = URI::Params.encode(form)\nput(path, form: body, headers: headers)\n"}},{"html_id":"put(path,headers:HTTP::Headers?=nil,*,form:Hash(String,String)|NamedTuple,&)-instance-method","name":"put","doc":"Executes a PUT request with form data and yields the response to the block.\nThe response will have its body as an `IO` accessed via `HTTP::Client::Response#body_io`.\nThe \"Content-type\" header is set to \"application/x-www-form-urlencoded\".\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new \"www.example.com\"\nclient.put(\"/\", form: {\"foo\" => \"bar\"}) do |response|\n  response.body_io.gets\nend\n```","summary":"<p>Executes a PUT request with form data and yields the response to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"args_string":"(path, headers : HTTP::Headers? = nil, *, form : Hash(String, String) | NamedTuple, &)","args_html":"(path, headers : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>? = <span class=\"n\">nil</span>, *, form : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>) | <a href=\"../NamedTuple.html\">NamedTuple</a>, &)","location":{"filename":"src/http/client.cr","line_number":406,"url":null},"def":{"name":"put","args":[{"name":"path","external_name":"path","restriction":""},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"HTTP::Headers | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"form","external_name":"form","restriction":"Hash(String, String) | NamedTuple"}],"splat_index":2,"yields":1,"visibility":"Public","body":"body = URI::Params.encode(form)\nput(path, form: body, headers: headers) do |response|\n  yield response\nend\n"}},{"html_id":"read_timeout=(read_timeout:Number)-instance-method","name":"read_timeout=","doc":"Sets the number of seconds to wait when reading before raising an `IO::TimeoutError`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"example.org\")\nclient.read_timeout = 1.5\nbegin\n  response = client.get(\"/\")\nrescue IO::TimeoutError\n  puts \"Timeout!\"\nend\n```","summary":"<p>Sets the number of seconds to wait when reading before raising an <code><a href=\"../IO/TimeoutError.html\">IO::TimeoutError</a></code>.</p>","abstract":false,"args":[{"name":"read_timeout","external_name":"read_timeout","restriction":"Number"}],"args_string":"(read_timeout : Number)","args_html":"(read_timeout : <a href=\"../Number.html\">Number</a>)","location":{"filename":"src/http/client.cr","line_number":282,"url":null},"def":{"name":"read_timeout=","args":[{"name":"read_timeout","external_name":"read_timeout","restriction":"Number"}],"visibility":"Public","body":"@read_timeout = read_timeout.to_f"}},{"html_id":"read_timeout=(read_timeout:Time::Span)-instance-method","name":"read_timeout=","doc":"Sets the read timeout with a `Time::Span`, to wait when reading before raising an `IO::TimeoutError`.\n\n```\nrequire \"http/client\"\n\nclient = HTTP::Client.new(\"example.org\")\nclient.read_timeout = 5.minutes\nbegin\n  response = client.get(\"/\")\nrescue IO::TimeoutError\n  puts \"Timeout!\"\nend\n```","summary":"<p>Sets the read timeout with a <code><a href=\"../Time/Span.html\">Time::Span</a></code>, to wait when reading before raising an <code><a href=\"../IO/TimeoutError.html\">IO::TimeoutError</a></code>.</p>","abstract":false,"args":[{"name":"read_timeout","external_name":"read_timeout","restriction":"Time::Span"}],"args_string":"(read_timeout : Time::Span)","args_html":"(read_timeout : <a href=\"../Time/Span.html\">Time::Span</a>)","location":{"filename":"src/http/client.cr","line_number":299,"url":null},"def":{"name":"read_timeout=","args":[{"name":"read_timeout","external_name":"read_timeout","restriction":"Time::Span"}],"visibility":"Public","body":"self.read_timeout = read_timeout.total_seconds"}},{"html_id":"tls:OpenSSL::SSL::Context::Client-instance-method","name":"tls","abstract":false,"def":{"name":"tls","return_type":"OpenSSL::SSL::Context::Client","visibility":"Public","body":"if (value = @tls).nil?\n  ::raise(NilAssertionError.new(\"HTTP::Client#tls cannot be nil\"))\nelse\n  value\nend"}},{"html_id":"tls?:OpenSSL::SSL::Context::Client?-instance-method","name":"tls?","abstract":false,"def":{"name":"tls?","return_type":"OpenSSL::SSL::Context::Client | ::Nil","visibility":"Public","body":"@tls"}},{"html_id":"write_timeout=(write_timeout:Number)-instance-method","name":"write_timeout=","doc":"Sets the write timeout - if any chunk of request is not written\nwithin the number of seconds provided, `IO::TimeoutError` exception is raised.","summary":"<p>Sets the write timeout - if any chunk of request is not written within the number of seconds provided, <code><a href=\"../IO/TimeoutError.html\">IO::TimeoutError</a></code> exception is raised.</p>","abstract":false,"args":[{"name":"write_timeout","external_name":"write_timeout","restriction":"Number"}],"args_string":"(write_timeout : Number)","args_html":"(write_timeout : <a href=\"../Number.html\">Number</a>)","location":{"filename":"src/http/client.cr","line_number":305,"url":null},"def":{"name":"write_timeout=","args":[{"name":"write_timeout","external_name":"write_timeout","restriction":"Number"}],"visibility":"Public","body":"@write_timeout = write_timeout.to_f"}},{"html_id":"write_timeout=(write_timeout:Time::Span)-instance-method","name":"write_timeout=","doc":"Sets the write timeout - if any chunk of request is not written\nwithin the provided `Time::Span`,  `IO::TimeoutError` exception is raised.","summary":"<p>Sets the write timeout - if any chunk of request is not written within the provided <code><a href=\"../Time/Span.html\">Time::Span</a></code>,  <code><a href=\"../IO/TimeoutError.html\">IO::TimeoutError</a></code> exception is raised.</p>","abstract":false,"args":[{"name":"write_timeout","external_name":"write_timeout","restriction":"Time::Span"}],"args_string":"(write_timeout : Time::Span)","args_html":"(write_timeout : <a href=\"../Time/Span.html\">Time::Span</a>)","location":{"filename":"src/http/client.cr","line_number":311,"url":null},"def":{"name":"write_timeout=","args":[{"name":"write_timeout","external_name":"write_timeout","restriction":"Time::Span"}],"visibility":"Public","body":"self.write_timeout = write_timeout.total_seconds"}}],"macros":[{"html_id":"def_around_exec(&block)-macro","name":"def_around_exec","doc":"This macro allows injecting code to be run before and after the execution\nof the request. It should return the yielded value. It must be called with 1\nblock argument that will be used to pass the `HTTP::Request`.\n\n```\nclass HTTP::Client\n  def_around_exec do |request|\n    # do something before exec\n    res = yield\n    # do something after exec\n    res\n  end\nend\n```","summary":"<p>This macro allows injecting code to be run before and after the execution of the request.</p>","abstract":false,"location":{"filename":"src/http/client.cr","line_number":901,"url":null},"def":{"name":"def_around_exec","block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"    protected def around_exec(\n%request\n)\n      previous_def do\n        \n{% if block.args.size != 1 %}\n          {% raise(\"Wrong number of block parameters for macro 'def_around_exec' (given #{block.args.size}, expected 1)\") %}\n        {% end %}\n\n\n        \n{{ block.args.first.id }}\n = \n%request\n\n        \n{{ block.body }}\n\n      \nend\n    \nend\n  \n"}}],"types":[{"html_id":"Crystal/HTTP/Client/BodyType","path":"HTTP/Client/BodyType.html","kind":"alias","full_name":"HTTP::Client::BodyType","name":"BodyType","abstract":false,"locations":[{"filename":"src/http/client.cr","line_number":74,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(IO | Slice(UInt8) | String | Nil)","aliased_html":"<a href=\"../../IO.html\">IO</a> | <a href=\"../../Slice.html\">Slice</a>(<a href=\"../../UInt8.html\">UInt8</a>) | <a href=\"../../String.html\">String</a> | <a href=\"../../Nil.html\">Nil</a>","const":false,"namespace":{"html_id":"Crystal/HTTP/Client","kind":"class","full_name":"HTTP::Client","name":"Client"},"doc":"The set of possible valid body types.","summary":"<p>The set of possible valid body types.</p>"},{"html_id":"Crystal/HTTP/Client/Response","path":"HTTP/Client/Response.html","kind":"class","full_name":"HTTP::Client::Response","name":"Response","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/client/response.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/HTTP/Client","kind":"class","full_name":"HTTP::Client","name":"Client"},"class_methods":[{"html_id":"from_io(io,ignore_body=false,decompress=true)-class-method","name":"from_io","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"ignore_body","default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","default_value":"true","external_name":"decompress","restriction":""}],"args_string":"(io, ignore_body = false, decompress = true)","args_html":"(io, ignore_body = <span class=\"n\">false</span>, decompress = <span class=\"n\">true</span>)","location":{"filename":"src/http/client/response.cr","line_number":94,"url":null},"def":{"name":"from_io","args":[{"name":"io","external_name":"io","restriction":""},{"name":"ignore_body","default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","default_value":"true","external_name":"decompress","restriction":""}],"visibility":"Public","body":"(from_io?(io, ignore_body, decompress)) || (raise(\"Unexpected end of http request\"))"}},{"html_id":"from_io(io,ignore_body=false,decompress=true,&)-class-method","name":"from_io","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"ignore_body","default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","default_value":"true","external_name":"decompress","restriction":""}],"args_string":"(io, ignore_body = false, decompress = true, &)","args_html":"(io, ignore_body = <span class=\"n\">false</span>, decompress = <span class=\"n\">true</span>, &)","location":{"filename":"src/http/client/response.cr","line_number":113,"url":null},"def":{"name":"from_io","args":[{"name":"io","external_name":"io","restriction":""},{"name":"ignore_body","default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","default_value":"true","external_name":"decompress","restriction":""}],"yields":1,"visibility":"Public","body":"from_io?(io, ignore_body, decompress) do |response|\n  if response\n    yield response\n  else\n    raise(\"Unexpected end of http request\")\n  end\nend"}},{"html_id":"from_io?(io,ignore_body=false,decompress=true,&)-class-method","name":"from_io?","doc":"Parses an `HTTP::Client::Response` from the given `IO` and yields\nit to the block. Might yield `nil` if there's no data in the `IO`,\nwhich probably means that the connection was closed.","summary":"<p>Parses an <code><a href=\"../../HTTP/Client/Response.html\">HTTP::Client::Response</a></code> from the given <code><a href=\"../../IO.html\">IO</a></code> and yields it to the block.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"ignore_body","default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","default_value":"true","external_name":"decompress","restriction":""}],"args_string":"(io, ignore_body = false, decompress = true, &)","args_html":"(io, ignore_body = <span class=\"n\">false</span>, decompress = <span class=\"n\">true</span>, &)","location":{"filename":"src/http/client/response.cr","line_number":126,"url":null},"def":{"name":"from_io?","args":[{"name":"io","external_name":"io","restriction":""},{"name":"ignore_body","default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","default_value":"true","external_name":"decompress","restriction":""}],"yields":1,"visibility":"Public","body":"line = io.gets(4096, chomp: true)\nif line\nelse\n  return yield nil\nend\npieces = line.split(3)\nif pieces.size < 2\n  raise(\"Invalid HTTP response\")\nend\nhttp_version = pieces[0]\nif HTTP::SUPPORTED_VERSIONS.includes?(http_version)\nelse\n  raise(\"Unsupported HTTP version: #{http_version}\")\nend\nstatus_code = pieces[1].to_i?\nif status_code && (100 <= status_code && status_code < 1000)\nelse\n  raise(\"Invalid HTTP status code: #{pieces[1]}\")\nend\nstatus = HTTP::Status.new(status_code)\nstatus_message = pieces[2]? ? pieces[2].chomp : \"\"\nbody_type = HTTP::BodyType::OnDemand\nif mandatory_body?(status)\n  body_type = HTTP::BodyType::Mandatory\nend\nif ignore_body\n  body_type = HTTP::BodyType::Prohibited\nend\nHTTP.parse_headers_and_body(io, body_type: body_type, decompress: decompress) do |headers, body|\n  return yield new(status, nil, headers, status_message, http_version, body)\nend\nnil\n"}},{"html_id":"mandatory_body?(status:HTTP::Status):Bool-class-method","name":"mandatory_body?","abstract":false,"args":[{"name":"status","external_name":"status","restriction":"HTTP::Status"}],"args_string":"(status : HTTP::Status) : Bool","args_html":"(status : <a href=\"../../HTTP/Status.html\">HTTP::Status</a>) : <a href=\"../../Bool.html\">Bool</a>","location":{"filename":"src/http/client/response.cr","line_number":86,"url":null},"def":{"name":"mandatory_body?","args":[{"name":"status","external_name":"status","restriction":"HTTP::Status"}],"return_type":"Bool","visibility":"Public","body":"!((status.informational? || status.no_content?) || status.not_modified?)"}},{"html_id":"supports_chunked?(version):Bool-class-method","name":"supports_chunked?","abstract":false,"args":[{"name":"version","external_name":"version","restriction":""}],"args_string":"(version) : Bool","args_html":"(version) : <a href=\"../../Bool.html\">Bool</a>","location":{"filename":"src/http/client/response.cr","line_number":90,"url":null},"def":{"name":"supports_chunked?","args":[{"name":"version","external_name":"version","restriction":""}],"return_type":"Bool","visibility":"Public","body":"version == \"HTTP/1.1\""}}],"constructors":[{"html_id":"from_io?(io,ignore_body=false,decompress=true):self?-class-method","name":"from_io?","doc":"Parses an `HTTP::Client::Response` from the given `IO`.\nMight return `nil` if there's no data in the `IO`,\nwhich probably means that the connection was closed.","summary":"<p>Parses an <code><a href=\"../../HTTP/Client/Response.html\">HTTP::Client::Response</a></code> from the given <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"ignore_body","default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","default_value":"true","external_name":"decompress","restriction":""}],"args_string":"(io, ignore_body = false, decompress = true) : self?","args_html":"(io, ignore_body = <span class=\"n\">false</span>, decompress = <span class=\"n\">true</span>) : <span class=\"k\">self</span>?","location":{"filename":"src/http/client/response.cr","line_number":102,"url":null},"def":{"name":"from_io?","args":[{"name":"io","external_name":"io","restriction":""},{"name":"ignore_body","default_value":"false","external_name":"ignore_body","restriction":""},{"name":"decompress","default_value":"true","external_name":"decompress","restriction":""}],"return_type":"self | ::Nil","visibility":"Public","body":"from_io?(io, ignore_body: ignore_body, decompress: decompress) do |response|\n  if response\n    response.consume_body_io\n    return response\n  else\n    return nil\n  end\nend"}},{"html_id":"new(status:HTTP::Status,body:String?=nil,headers:Headers=Headers.new,status_message=nil,version=\"HTTP/1.1\",body_io=nil)-class-method","name":"new","abstract":false,"args":[{"name":"status","external_name":"status","restriction":"HTTP::Status"},{"name":"body","default_value":"nil","external_name":"body","restriction":"String | ::Nil"},{"name":"headers","default_value":"Headers.new","external_name":"headers","restriction":"Headers"},{"name":"status_message","default_value":"nil","external_name":"status_message","restriction":""},{"name":"version","default_value":"\"HTTP/1.1\"","external_name":"version","restriction":""},{"name":"body_io","default_value":"nil","external_name":"body_io","restriction":""}],"args_string":"(status : HTTP::Status, body : String? = nil, headers : Headers = Headers.new, status_message = nil, version = \"HTTP/1.1\", body_io = nil)","args_html":"(status : <a href=\"../../HTTP/Status.html\">HTTP::Status</a>, body : <a href=\"../../String.html\">String</a>? = <span class=\"n\">nil</span>, headers : <a href=\"../../HTTP/Headers.html\">Headers</a> = <span class=\"t\">Headers</span>.<span class=\"k\">new</span>, status_message = <span class=\"n\">nil</span>, version = <span class=\"s\">&quot;HTTP/1.1&quot;</span>, body_io = <span class=\"n\">nil</span>)","location":{"filename":"src/http/client/response.cr","line_number":13,"url":null},"def":{"name":"new","args":[{"name":"status","external_name":"status","restriction":"HTTP::Status"},{"name":"body","default_value":"nil","external_name":"body","restriction":"String | ::Nil"},{"name":"headers","default_value":"Headers.new","external_name":"headers","restriction":"Headers"},{"name":"status_message","default_value":"nil","external_name":"status_message","restriction":""},{"name":"version","default_value":"\"HTTP/1.1\"","external_name":"version","restriction":""},{"name":"body_io","default_value":"nil","external_name":"body_io","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(status, body, headers, status_message, version, body_io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(status_code:Int32,body:String?=nil,headers:Headers=Headers.new,status_message=nil,version=\"HTTP/1.1\",body_io=nil)-class-method","name":"new","abstract":false,"args":[{"name":"status_code","external_name":"status_code","restriction":"Int32"},{"name":"body","default_value":"nil","external_name":"body","restriction":"String | ::Nil"},{"name":"headers","default_value":"Headers.new","external_name":"headers","restriction":"Headers"},{"name":"status_message","default_value":"nil","external_name":"status_message","restriction":""},{"name":"version","default_value":"\"HTTP/1.1\"","external_name":"version","restriction":""},{"name":"body_io","default_value":"nil","external_name":"body_io","restriction":""}],"args_string":"(status_code : Int32, body : String? = nil, headers : Headers = Headers.new, status_message = nil, version = \"HTTP/1.1\", body_io = nil)","args_html":"(status_code : <a href=\"../../Int32.html\">Int32</a>, body : <a href=\"../../String.html\">String</a>? = <span class=\"n\">nil</span>, headers : <a href=\"../../HTTP/Headers.html\">Headers</a> = <span class=\"t\">Headers</span>.<span class=\"k\">new</span>, status_message = <span class=\"n\">nil</span>, version = <span class=\"s\">&quot;HTTP/1.1&quot;</span>, body_io = <span class=\"n\">nil</span>)","location":{"filename":"src/http/client/response.cr","line_number":25,"url":null},"def":{"name":"new","args":[{"name":"status_code","external_name":"status_code","restriction":"Int32"},{"name":"body","default_value":"nil","external_name":"body","restriction":"String | ::Nil"},{"name":"headers","default_value":"Headers.new","external_name":"headers","restriction":"Headers"},{"name":"status_message","default_value":"nil","external_name":"status_message","restriction":""},{"name":"version","default_value":"\"HTTP/1.1\"","external_name":"version","restriction":""},{"name":"body_io","default_value":"nil","external_name":"body_io","restriction":""}],"visibility":"Public","body":"new(HTTP::Status.new(status_code), body, headers, status_message, version, body_io)"}}],"instance_methods":[{"html_id":"body:String-instance-method","name":"body","abstract":false,"location":{"filename":"src/http/client/response.cr","line_number":29,"url":null},"def":{"name":"body","return_type":"String","visibility":"Public","body":"@body || \"\""}},{"html_id":"body?:String?-instance-method","name":"body?","abstract":false,"location":{"filename":"src/http/client/response.cr","line_number":33,"url":null},"def":{"name":"body?","return_type":"String | ::Nil","visibility":"Public","body":"@body"}},{"html_id":"body_io:IO-instance-method","name":"body_io","abstract":false,"location":{"filename":"src/http/client/response.cr","line_number":10,"url":null},"def":{"name":"body_io","return_type":"IO","visibility":"Public","body":"if (value = @body_io).nil?\n  ::raise(NilAssertionError.new(\"HTTP::Client::Response#body_io cannot be nil\"))\nelse\n  value\nend"}},{"html_id":"body_io?:IO?-instance-method","name":"body_io?","abstract":false,"location":{"filename":"src/http/client/response.cr","line_number":10,"url":null},"def":{"name":"body_io?","return_type":"IO | ::Nil","visibility":"Public","body":"@body_io"}},{"html_id":"charset:String?-instance-method","name":"charset","abstract":false,"location":{"filename":"src/http/client/response.cr","line_number":61,"url":null},"def":{"name":"charset","return_type":"String | ::Nil","visibility":"Public","body":"mime_type.try(&.[]?(\"charset\"))"}},{"html_id":"content_type:String?-instance-method","name":"content_type","abstract":false,"location":{"filename":"src/http/client/response.cr","line_number":52,"url":null},"def":{"name":"content_type","return_type":"String | ::Nil","visibility":"Public","body":"mime_type.try(&.media_type)"}},{"html_id":"cookies:HTTP::Cookies-instance-method","name":"cookies","doc":"Returns a convenience wrapper around querying and setting cookie related\nheaders, see `HTTP::Cookies`.","summary":"<p>Returns a convenience wrapper around querying and setting cookie related headers, see <code><a href=\"../../HTTP/Cookies.html\">HTTP::Cookies</a></code>.</p>","abstract":false,"location":{"filename":"src/http/client/response.cr","line_number":44,"url":null},"def":{"name":"cookies","return_type":"HTTP::Cookies","visibility":"Public","body":"@cookies || (@cookies = Cookies.from_server_headers(headers))"}},{"html_id":"headers:Headers-instance-method","name":"headers","abstract":false,"location":{"filename":"src/http/client/response.cr","line_number":9,"url":null},"def":{"name":"headers","return_type":"Headers","visibility":"Public","body":"@headers"}},{"html_id":"keep_alive?:Bool-instance-method","name":"keep_alive?","abstract":false,"location":{"filename":"src/http/client/response.cr","line_number":48,"url":null},"def":{"name":"keep_alive?","return_type":"Bool","visibility":"Public","body":"HTTP.keep_alive?(self)"}},{"html_id":"mime_type:MIME::MediaType?-instance-method","name":"mime_type","abstract":false,"location":{"filename":"src/http/client/response.cr","line_number":65,"url":null},"def":{"name":"mime_type","return_type":"MIME::MediaType | ::Nil","visibility":"Public","body":"if content_type = headers[\"Content-Type\"]?.presence\n  MIME::MediaType.parse(content_type)\nend"}},{"html_id":"status:HTTP::Status-instance-method","name":"status","abstract":false,"location":{"filename":"src/http/client/response.cr","line_number":7,"url":null},"def":{"name":"status","return_type":"HTTP::Status","visibility":"Public","body":"@status"}},{"html_id":"status_code:Int32-instance-method","name":"status_code","doc":"Convenience method to retrieve the HTTP status code.","summary":"<p>Convenience method to retrieve the HTTP status code.</p>","abstract":false,"location":{"filename":"src/http/client/response.cr","line_number":57,"url":null},"def":{"name":"status_code","return_type":"Int32","visibility":"Public","body":"status.code"}},{"html_id":"status_message:String?-instance-method","name":"status_message","abstract":false,"location":{"filename":"src/http/client/response.cr","line_number":8,"url":null},"def":{"name":"status_message","return_type":"String | ::Nil","visibility":"Public","body":"@status_message"}},{"html_id":"success?:Bool-instance-method","name":"success?","doc":"Returns `true` if the response status code is between 200 and 299.","summary":"<p>Returns <code>true</code> if the response status code is between 200 and 299.</p>","abstract":false,"location":{"filename":"src/http/client/response.cr","line_number":38,"url":null},"def":{"name":"success?","return_type":"Bool","visibility":"Public","body":"@status.success?"}},{"html_id":"to_io(io)-instance-method","name":"to_io","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""}],"args_string":"(io)","args_html":"(io)","location":{"filename":"src/http/client/response.cr","line_number":71,"url":null},"def":{"name":"to_io","args":[{"name":"io","external_name":"io","restriction":""}],"visibility":"Public","body":"(((((io << @version) << ' ') << @status.code) << ' ') << @status_message) << \"\\r\\n\"\ncookies = @cookies\nheaders = cookies ? cookies.add_response_headers(@headers) : @headers\nHTTP.serialize_headers_and_body(io, headers, @body, @body_io, @version)\n"}},{"html_id":"version:String-instance-method","name":"version","abstract":false,"location":{"filename":"src/http/client/response.cr","line_number":6,"url":null},"def":{"name":"version","return_type":"String","visibility":"Public","body":"@version"}}]},{"html_id":"Crystal/HTTP/Client/TLSContext","path":"HTTP/Client/TLSContext.html","kind":"alias","full_name":"HTTP::Client::TLSContext","name":"TLSContext","abstract":false,"locations":[{"filename":"src/http/client.cr","line_number":106,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(Bool | OpenSSL::SSL::Context::Client | Nil)","aliased_html":"<a href=\"../../Bool.html\">Bool</a> | <a href=\"../../OpenSSL/SSL/Context/Client.html\">OpenSSL::SSL::Context::Client</a> | <a href=\"../../Nil.html\">Nil</a>","const":false,"namespace":{"html_id":"Crystal/HTTP/Client","kind":"class","full_name":"HTTP::Client","name":"Client"}}]},{"html_id":"Crystal/HTTP/CompressHandler","path":"HTTP/CompressHandler.html","kind":"class","full_name":"HTTP::CompressHandler","name":"CompressHandler","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/server/handlers/compress_handler.cr","line_number":8,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"}],"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"A handler that configures an `HTTP::Server::Response` to compress the response\noutput, either using gzip or deflate, depending on the `Accept-Encoding` request header.","summary":"<p>A handler that configures an <code><a href=\"../HTTP/Server/Response.html\">HTTP::Server::Response</a></code> to compress the response output, either using gzip or deflate, depending on the <code>Accept-Encoding</code> request header.</p>","instance_methods":[{"html_id":"call(context)-instance-method","name":"call","abstract":false,"args":[{"name":"context","external_name":"context","restriction":""}],"args_string":"(context)","args_html":"(context)","location":{"filename":"src/http/server/handlers/compress_handler.cr","line_number":11,"url":null},"def":{"name":"call","args":[{"name":"context","external_name":"context","restriction":""}],"visibility":"Public","body":"{% if flag?(:without_zlib) %}\n      call_next(context)\n    {% else %}\n      context.response.output = CompressIO.new(context.response.output, context)\n      call_next(context)\n    {% end %}"}}]},{"html_id":"Crystal/HTTP/Cookie","path":"HTTP/Cookie.html","kind":"class","full_name":"HTTP::Cookie","name":"Cookie","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/cookie.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"Represents a cookie with all its attributes. Provides convenient access and modification of them.","summary":"<p>Represents a cookie with all its attributes.</p>","constructors":[{"html_id":"new(name:String,value:String,path:String?=nil,expires:Time?=nil,domain:String?=nil,secure:Bool=false,http_only:Bool=false,samesite:SameSite?=nil,extension:String?=nil,max_age:Time::Span?=nil,creation_time=Time.utc)-class-method","name":"new","doc":"Creates a new `Cookie` instance.\n\nRaises `IO::Error` if *name* or *value* are invalid as per [RFC 6265 §4.1.1](https://tools.ietf.org/html/rfc6265#section-4.1.1).","summary":"<p>Creates a new <code><a href=\"../HTTP/Cookie.html\">Cookie</a></code> instance.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"value","external_name":"value","restriction":"String"},{"name":"path","default_value":"nil","external_name":"path","restriction":"String | ::Nil"},{"name":"expires","default_value":"nil","external_name":"expires","restriction":"Time | ::Nil"},{"name":"domain","default_value":"nil","external_name":"domain","restriction":"String | ::Nil"},{"name":"secure","default_value":"false","external_name":"secure","restriction":"Bool"},{"name":"http_only","default_value":"false","external_name":"http_only","restriction":"Bool"},{"name":"samesite","default_value":"nil","external_name":"samesite","restriction":"SameSite | ::Nil"},{"name":"extension","default_value":"nil","external_name":"extension","restriction":"String | ::Nil"},{"name":"max_age","default_value":"nil","external_name":"max_age","restriction":"Time::Span | ::Nil"},{"name":"creation_time","default_value":"Time.utc","external_name":"creation_time","restriction":""}],"args_string":"(name : String, value : String, path : String? = nil, expires : Time? = nil, domain : String? = nil, secure : Bool = false, http_only : Bool = false, samesite : SameSite? = nil, extension : String? = nil, max_age : Time::Span? = nil, creation_time = Time.utc)","args_html":"(name : <a href=\"../String.html\">String</a>, value : <a href=\"../String.html\">String</a>, path : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, expires : <a href=\"../Time.html\">Time</a>? = <span class=\"n\">nil</span>, domain : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, secure : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>, http_only : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>, samesite : <a href=\"../HTTP/Cookie/SameSite.html\">SameSite</a>? = <span class=\"n\">nil</span>, extension : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, max_age : <a href=\"../Time/Span.html\">Time::Span</a>? = <span class=\"n\">nil</span>, creation_time = <span class=\"t\">Time</span>.utc)","location":{"filename":"src/http/cookie.cr","line_number":35,"url":null},"def":{"name":"new","args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"value","external_name":"value","restriction":"String"},{"name":"path","default_value":"nil","external_name":"path","restriction":"String | ::Nil"},{"name":"expires","default_value":"nil","external_name":"expires","restriction":"Time | ::Nil"},{"name":"domain","default_value":"nil","external_name":"domain","restriction":"String | ::Nil"},{"name":"secure","default_value":"false","external_name":"secure","restriction":"Bool"},{"name":"http_only","default_value":"false","external_name":"http_only","restriction":"Bool"},{"name":"samesite","default_value":"nil","external_name":"samesite","restriction":"SameSite | ::Nil"},{"name":"extension","default_value":"nil","external_name":"extension","restriction":"String | ::Nil"},{"name":"max_age","default_value":"nil","external_name":"max_age","restriction":"Time::Span | ::Nil"},{"name":"creation_time","default_value":"Time.utc","external_name":"creation_time","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(name, value, path, expires, domain, secure, http_only, samesite, extension, max_age, creation_time)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this reference is the same as *other*. Invokes `same?`.","summary":"<p>Returns <code>true</code> if this reference is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"if same?(other)\n  return true\nend\nif name == other.name\nelse\n  return false\nend\nif value == other.value\nelse\n  return false\nend\nif path == other.path\nelse\n  return false\nend\nif expires == other.expires\nelse\n  return false\nend\nif domain == other.domain\nelse\n  return false\nend\nif secure == other.secure\nelse\n  return false\nend\nif http_only == other.http_only\nelse\n  return false\nend\nif samesite == other.samesite\nelse\n  return false\nend\nif extension == other.extension\nelse\n  return false\nend\ntrue\n"}},{"html_id":"creation_time:Time-instance-method","name":"creation_time","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":28,"url":null},"def":{"name":"creation_time","return_type":"Time","visibility":"Public","body":"@creation_time"}},{"html_id":"domain:String?-instance-method","name":"domain","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":22,"url":null},"def":{"name":"domain","return_type":"String | ::Nil","visibility":"Public","body":"@domain"}},{"html_id":"domain=(domain:String?)-instance-method","name":"domain=","abstract":false,"args":[{"name":"domain","external_name":"domain","restriction":"String | ::Nil"}],"args_string":"(domain : String?)","args_html":"(domain : <a href=\"../String.html\">String</a>?)","location":{"filename":"src/http/cookie.cr","line_number":22,"url":null},"def":{"name":"domain=","args":[{"name":"domain","external_name":"domain","restriction":"String | ::Nil"}],"visibility":"Public","body":"@domain = domain"}},{"html_id":"expiration_time:Time?-instance-method","name":"expiration_time","doc":"Returns the expiration time of this cookie.","summary":"<p>Returns the expiration time of this cookie.</p>","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":117,"url":null},"def":{"name":"expiration_time","return_type":"Time | ::Nil","visibility":"Public","body":"if max_age = @max_age\n  @creation_time + max_age\nelse\n  @expires\nend"}},{"html_id":"expired?(time_reference=Time.utc):Bool-instance-method","name":"expired?","doc":"Returns the expiration status of this cookie as a `Bool`.\n\n*time_reference* can be passed to use a different reference time for\ncomparison. Default is the current time (`Time.utc`).","summary":"<p>Returns the expiration status of this cookie as a <code><a href=\"../Bool.html\">Bool</a></code>.</p>","abstract":false,"args":[{"name":"time_reference","default_value":"Time.utc","external_name":"time_reference","restriction":""}],"args_string":"(time_reference = Time.utc) : Bool","args_html":"(time_reference = <span class=\"t\">Time</span>.utc) : <a href=\"../Bool.html\">Bool</a>","location":{"filename":"src/http/cookie.cr","line_number":129,"url":null},"def":{"name":"expired?","args":[{"name":"time_reference","default_value":"Time.utc","external_name":"time_reference","restriction":""}],"return_type":"Bool","visibility":"Public","body":"if @max_age.try(&.zero?)\n  true\nelse\n  if expiration_time = self.expiration_time\n    expiration_time <= time_reference\n  else\n    false\n  end\nend"}},{"html_id":"expires:Time?-instance-method","name":"expires","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":21,"url":null},"def":{"name":"expires","return_type":"Time | ::Nil","visibility":"Public","body":"@expires"}},{"html_id":"expires=(expires:Time?)-instance-method","name":"expires=","abstract":false,"args":[{"name":"expires","external_name":"expires","restriction":"Time | ::Nil"}],"args_string":"(expires : Time?)","args_html":"(expires : <a href=\"../Time.html\">Time</a>?)","location":{"filename":"src/http/cookie.cr","line_number":21,"url":null},"def":{"name":"expires=","args":[{"name":"expires","external_name":"expires","restriction":"Time | ::Nil"}],"visibility":"Public","body":"@expires = expires"}},{"html_id":"extension:String?-instance-method","name":"extension","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":26,"url":null},"def":{"name":"extension","return_type":"String | ::Nil","visibility":"Public","body":"@extension"}},{"html_id":"extension=(extension:String?)-instance-method","name":"extension=","abstract":false,"args":[{"name":"extension","external_name":"extension","restriction":"String | ::Nil"}],"args_string":"(extension : String?)","args_html":"(extension : <a href=\"../String.html\">String</a>?)","location":{"filename":"src/http/cookie.cr","line_number":26,"url":null},"def":{"name":"extension=","args":[{"name":"extension","external_name":"extension","restriction":"String | ::Nil"}],"visibility":"Public","body":"@extension = extension"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = name.hash(hasher)\nhasher = value.hash(hasher)\nhasher = path.hash(hasher)\nhasher = expires.hash(hasher)\nhasher = domain.hash(hasher)\nhasher = secure.hash(hasher)\nhasher = http_only.hash(hasher)\nhasher = samesite.hash(hasher)\nhasher = extension.hash(hasher)\nhasher\n"}},{"html_id":"http_only:Bool-instance-method","name":"http_only","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":24,"url":null},"def":{"name":"http_only","return_type":"Bool","visibility":"Public","body":"@http_only"}},{"html_id":"http_only=(http_only:Bool)-instance-method","name":"http_only=","abstract":false,"args":[{"name":"http_only","external_name":"http_only","restriction":"Bool"}],"args_string":"(http_only : Bool)","args_html":"(http_only : <a href=\"../Bool.html\">Bool</a>)","location":{"filename":"src/http/cookie.cr","line_number":24,"url":null},"def":{"name":"http_only=","args":[{"name":"http_only","external_name":"http_only","restriction":"Bool"}],"visibility":"Public","body":"@http_only = http_only"}},{"html_id":"max_age:Time::Span?-instance-method","name":"max_age","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":27,"url":null},"def":{"name":"max_age","return_type":"Time::Span | ::Nil","visibility":"Public","body":"@max_age"}},{"html_id":"max_age=(max_age:Time::Span?)-instance-method","name":"max_age=","abstract":false,"args":[{"name":"max_age","external_name":"max_age","restriction":"Time::Span | ::Nil"}],"args_string":"(max_age : Time::Span?)","args_html":"(max_age : <a href=\"../Time/Span.html\">Time::Span</a>?)","location":{"filename":"src/http/cookie.cr","line_number":27,"url":null},"def":{"name":"max_age=","args":[{"name":"max_age","external_name":"max_age","restriction":"Time::Span | ::Nil"}],"visibility":"Public","body":"@max_age = max_age"}},{"html_id":"name:String-instance-method","name":"name","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":18,"url":null},"def":{"name":"name","return_type":"String","visibility":"Public","body":"@name"}},{"html_id":"name=(name:String)-instance-method","name":"name=","doc":"Sets the name of this cookie.\n\nRaises `IO::Error` if the value is invalid as per [RFC 6265 §4.1.1](https://tools.ietf.org/html/rfc6265#section-4.1.1).","summary":"<p>Sets the name of this cookie.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String)","args_html":"(name : <a href=\"../String.html\">String</a>)","location":{"filename":"src/http/cookie.cr","line_number":50,"url":null},"def":{"name":"name=","args":[{"name":"name","external_name":"name","restriction":"String"}],"visibility":"Public","body":"validate_name(name)\n@name = name\n"}},{"html_id":"path:String?-instance-method","name":"path","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":20,"url":null},"def":{"name":"path","return_type":"String | ::Nil","visibility":"Public","body":"@path"}},{"html_id":"path=(path:String?)-instance-method","name":"path=","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"String | ::Nil"}],"args_string":"(path : String?)","args_html":"(path : <a href=\"../String.html\">String</a>?)","location":{"filename":"src/http/cookie.cr","line_number":20,"url":null},"def":{"name":"path=","args":[{"name":"path","external_name":"path","restriction":"String | ::Nil"}],"visibility":"Public","body":"@path = path"}},{"html_id":"samesite:SameSite?-instance-method","name":"samesite","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":25,"url":null},"def":{"name":"samesite","return_type":"SameSite | ::Nil","visibility":"Public","body":"@samesite"}},{"html_id":"samesite=(samesite:SameSite?)-instance-method","name":"samesite=","abstract":false,"args":[{"name":"samesite","external_name":"samesite","restriction":"SameSite | ::Nil"}],"args_string":"(samesite : SameSite?)","args_html":"(samesite : <a href=\"../HTTP/Cookie/SameSite.html\">SameSite</a>?)","location":{"filename":"src/http/cookie.cr","line_number":25,"url":null},"def":{"name":"samesite=","args":[{"name":"samesite","external_name":"samesite","restriction":"SameSite | ::Nil"}],"visibility":"Public","body":"@samesite = samesite"}},{"html_id":"secure:Bool-instance-method","name":"secure","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":23,"url":null},"def":{"name":"secure","return_type":"Bool","visibility":"Public","body":"@secure"}},{"html_id":"secure=(secure:Bool)-instance-method","name":"secure=","abstract":false,"args":[{"name":"secure","external_name":"secure","restriction":"Bool"}],"args_string":"(secure : Bool)","args_html":"(secure : <a href=\"../Bool.html\">Bool</a>)","location":{"filename":"src/http/cookie.cr","line_number":23,"url":null},"def":{"name":"secure=","args":[{"name":"secure","external_name":"secure","restriction":"Bool"}],"visibility":"Public","body":"@secure = secure"}},{"html_id":"to_cookie_header(io):Nil-instance-method","name":"to_cookie_header","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""}],"args_string":"(io) : Nil","args_html":"(io) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/http/cookie.cr","line_number":110,"url":null},"def":{"name":"to_cookie_header","args":[{"name":"io","external_name":"io","restriction":""}],"return_type":"Nil","visibility":"Public","body":"io << @name\nio << '='\nio << @value\n"}},{"html_id":"to_cookie_header:String-instance-method","name":"to_cookie_header","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":104,"url":null},"def":{"name":"to_cookie_header","return_type":"String","visibility":"Public","body":"String.build((@name.bytesize + @value.bytesize) + 1) do |io|\n  to_cookie_header(io)\nend"}},{"html_id":"to_set_cookie_header:String-instance-method","name":"to_set_cookie_header","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":85,"url":null},"def":{"name":"to_set_cookie_header","return_type":"String","visibility":"Public","body":"path = @path\nexpires = @expires\nmax_age = @max_age\ndomain = @domain\nsamesite = @samesite\nString.build do |header|\n  to_cookie_header(header)\n  if domain\n    header << \"; domain=#{domain}\"\n  end\n  if path\n    header << \"; path=#{path}\"\n  end\n  if expires\n    header << \"; expires=#{HTTP.format_time(expires)}\"\n  end\n  if max_age\n    header << \"; max-age=#{max_age.to_i}\"\n  end\n  if @secure\n    header << \"; Secure\"\n  end\n  if @http_only\n    header << \"; HttpOnly\"\n  end\n  if samesite\n    header << \"; SameSite=#{samesite}\"\n  end\n  if @extension\n    header << \"; #{@extension}\"\n  end\nend\n"}},{"html_id":"value:String-instance-method","name":"value","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":19,"url":null},"def":{"name":"value","return_type":"String","visibility":"Public","body":"@value"}},{"html_id":"value=(value:String)-instance-method","name":"value=","doc":"Sets the value of this cookie.\n\nRaises `IO::Error` if the value is invalid as per [RFC 6265 §4.1.1](https://tools.ietf.org/html/rfc6265#section-4.1.1).","summary":"<p>Sets the value of this cookie.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(value : String)","args_html":"(value : <a href=\"../String.html\">String</a>)","location":{"filename":"src/http/cookie.cr","line_number":70,"url":null},"def":{"name":"value=","args":[{"name":"value","external_name":"value","restriction":"String"}],"visibility":"Public","body":"validate_value(value)\n@value = value\n"}}],"types":[{"html_id":"Crystal/HTTP/Cookie/SameSite","path":"HTTP/Cookie/SameSite.html","kind":"enum","full_name":"HTTP::Cookie::SameSite","name":"SameSite","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/cookie.cr","line_number":7,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"None","name":"None","value":"0","doc":"The browser will send cookies with both cross-site requests and same-site requests.\n\nThe `None` directive requires the `secure` attribute to be `true` to mitigate risks associated with cross-site access.","summary":"<p>The browser will send cookies with both cross-site requests and same-site requests.</p>"},{"id":"Strict","name":"Strict","value":"1","doc":"Prevents the cookie from being sent by the browser in all cross-site browsing contexts.","summary":"<p>Prevents the cookie from being sent by the browser in all cross-site browsing contexts.</p>"},{"id":"Lax","name":"Lax","value":"2","doc":"Allows the cookie to be sent by the browser during top-level navigations that use a [safe](https://tools.ietf.org/html/rfc7231#section-4.2.1) HTTP method.","summary":"<p>Allows the cookie to be sent by the browser during top-level navigations that use a <a href=\"https://tools.ietf.org/html/rfc7231#section-4.2.1\">safe</a> HTTP method.</p>"}],"namespace":{"html_id":"Crystal/HTTP/Cookie","kind":"class","full_name":"HTTP::Cookie","name":"Cookie"},"doc":"Possible values for the `SameSite` cookie as described in the [Same-site Cookies Draft](https://tools.ietf.org/html/draft-west-first-party-cookies-07#section-4.1.1).","summary":"<p>Possible values for the <code><a href=\"../../HTTP/Cookie/SameSite.html\">SameSite</a></code> cookie as described in the <a href=\"https://tools.ietf.org/html/draft-west-first-party-cookies-07#section-4.1.1\">Same-site Cookies Draft</a>.</p>","instance_methods":[{"html_id":"lax?-instance-method","name":"lax?","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":15,"url":null},"def":{"name":"lax?","visibility":"Public","body":"self == Lax"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":11,"url":null},"def":{"name":"none?","visibility":"Public","body":"self == None"}},{"html_id":"strict?-instance-method","name":"strict?","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":13,"url":null},"def":{"name":"strict?","visibility":"Public","body":"self == Strict"}}]}]},{"html_id":"Crystal/HTTP/Cookies","path":"HTTP/Cookies.html","kind":"class","full_name":"HTTP::Cookies","name":"Cookies","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/cookie.cr","line_number":222,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"Represents a collection of cookies as it can be present inside\na HTTP request or response.","summary":"<p>Represents a collection of cookies as it can be present inside a HTTP request or response.</p>","constructors":[{"html_id":"from_client_headers(headers):self-class-method","name":"from_client_headers","doc":"Creates a new instance by parsing the `Cookie` headers in the given `HTTP::Headers`.\n\nSee `HTTP::Client::Response#cookies`.","summary":"<p>Creates a new instance by parsing the <code><a href=\"../HTTP/Cookie.html\">Cookie</a></code> headers in the given <code><a href=\"../HTTP/Headers.html\">HTTP::Headers</a></code>.</p>","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":""}],"args_string":"(headers) : self","args_html":"(headers) : <span class=\"k\">self</span>","location":{"filename":"src/http/cookie.cr","line_number":246,"url":null},"def":{"name":"from_client_headers","args":[{"name":"headers","external_name":"headers","restriction":""}],"return_type":"self","visibility":"Public","body":"new.tap do |cookies|\n  cookies.fill_from_client_headers(headers)\nend"}},{"html_id":"from_headers(headers):self-class-method","name":"from_headers","doc":"Creates a new instance by parsing the `Cookie` and `Set-Cookie`\nheaders in the given `HTTP::Headers`.\n\nSee `HTTP::Request#cookies` and `HTTP::Client::Response#cookies`.","summary":"<p>Creates a new instance by parsing the <code><a href=\"../HTTP/Cookie.html\">Cookie</a></code> and <code><a href=\"../Set.html\">Set</a>-<a href=\"../HTTP/Cookie.html\">Cookie</a></code> headers in the given <code><a href=\"../HTTP/Headers.html\">HTTP::Headers</a></code>.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"../HTTP/Cookies.html#from_client_headers%28headers%29%3Aself-class-method\">.from_client_headers</a></code> or <code><a href=\"../HTTP/Cookies.html#from_server_headers%28headers%29%3Aself-class-method\">.from_server_headers</a></code> instead.</p>","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":""}],"args_string":"(headers) : self","args_html":"(headers) : <span class=\"k\">self</span>","location":{"filename":"src/http/cookie.cr","line_number":230,"url":null},"def":{"name":"from_headers","args":[{"name":"headers","external_name":"headers","restriction":""}],"return_type":"self","visibility":"Public","body":"new.tap do |cookies|\n  cookies.fill_from_headers(headers)\nend"}},{"html_id":"from_server_headers(headers):self-class-method","name":"from_server_headers","doc":"Creates a new instance by parsing the `Set-Cookie` headers in the given `HTTP::Headers`.\n\nSee `HTTP::Request#cookies`.","summary":"<p>Creates a new instance by parsing the <code><a href=\"../Set.html\">Set</a>-<a href=\"../HTTP/Cookie.html\">Cookie</a></code> headers in the given <code><a href=\"../HTTP/Headers.html\">HTTP::Headers</a></code>.</p>","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":""}],"args_string":"(headers) : self","args_html":"(headers) : <span class=\"k\">self</span>","location":{"filename":"src/http/cookie.cr","line_number":263,"url":null},"def":{"name":"from_server_headers","args":[{"name":"headers","external_name":"headers","restriction":""}],"return_type":"self","visibility":"Public","body":"new.tap do |cookies|\n  cookies.fill_from_server_headers(headers)\nend"}},{"html_id":"new-class-method","name":"new","doc":"Creates a new empty instance.","summary":"<p>Creates a new empty instance.</p>","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":278,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"<<(cookie:Cookie)-instance-method","name":"<<","doc":"Adds the given *cookie* to this collection, overrides an existing cookie\nwith the same name if present.\n\n```\nresponse.cookies << HTTP::Cookie.new(\"foo\", \"bar\", http_only: true)\n```","summary":"<p>Adds the given <em>cookie</em> to this collection, overrides an existing cookie with the same name if present.</p>","abstract":false,"args":[{"name":"cookie","external_name":"cookie","restriction":"Cookie"}],"args_string":"(cookie : Cookie)","args_html":"(cookie : <a href=\"../HTTP/Cookie.html\">Cookie</a>)","location":{"filename":"src/http/cookie.cr","line_number":352,"url":null},"def":{"name":"<<","args":[{"name":"cookie","external_name":"cookie","restriction":"Cookie"}],"visibility":"Public","body":"self[cookie.name] = cookie"}},{"html_id":"[](key):Cookie-instance-method","name":"[]","doc":"Gets the current `HTTP::Cookie` for the given *key*.\n\n```\nrequest.cookies[\"foo\"].value # => \"bar\"\n```","summary":"<p>Gets the current <code><a href=\"../HTTP/Cookie.html\">HTTP::Cookie</a></code> for the given <em>key</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key) : Cookie","args_html":"(key) : <a href=\"../HTTP/Cookie.html\">Cookie</a>","location":{"filename":"src/http/cookie.cr","line_number":319,"url":null},"def":{"name":"[]","args":[{"name":"key","external_name":"key","restriction":""}],"return_type":"Cookie","visibility":"Public","body":"@cookies[key]"}},{"html_id":"[]=(key,value:String)-instance-method","name":"[]=","doc":"Sets a new cookie in the collection with a string value.\nThis creates a never expiring, insecure, not HTTP-only cookie with\nno explicit domain restriction and no path.\n\n```\nrequire \"http/client\"\n\nrequest = HTTP::Request.new \"GET\", \"/\"\nrequest.cookies[\"foo\"] = \"bar\"\n```","summary":"<p>Sets a new cookie in the collection with a string value.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(key, value : String)","args_html":"(key, value : <a href=\"../String.html\">String</a>)","location":{"filename":"src/http/cookie.cr","line_number":292,"url":null},"def":{"name":"[]=","args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"String"}],"visibility":"Public","body":"self[key] = Cookie.new(key, value)"}},{"html_id":"[]=(key,value:Cookie)-instance-method","name":"[]=","doc":"Sets a new cookie in the collection to the given `HTTP::Cookie`\ninstance. The name attribute must match the given *key*, else\n`ArgumentError` is raised.\n\n```\nrequire \"http/client\"\n\nresponse = HTTP::Client::Response.new(200)\nresponse.cookies[\"foo\"] = HTTP::Cookie.new(\"foo\", \"bar\", \"/admin\", Time.utc + 12.hours, secure: true)\n```","summary":"<p>Sets a new cookie in the collection to the given <code><a href=\"../HTTP/Cookie.html\">HTTP::Cookie</a></code> instance.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"Cookie"}],"args_string":"(key, value : Cookie)","args_html":"(key, value : <a href=\"../HTTP/Cookie.html\">Cookie</a>)","location":{"filename":"src/http/cookie.cr","line_number":306,"url":null},"def":{"name":"[]=","args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"Cookie"}],"visibility":"Public","body":"if key == value.name\nelse\n  raise(ArgumentError.new(\"Cookie name must match the given key\"))\nend\n@cookies[key] = value\n"}},{"html_id":"[]?(key):Cookie?-instance-method","name":"[]?","doc":"Gets the current `HTTP::Cookie` for the given *key* or `nil` if none is set.\n\n```\nrequire \"http/client\"\n\nrequest = HTTP::Request.new \"GET\", \"/\"\nrequest.cookies[\"foo\"]? # => nil\nrequest.cookies[\"foo\"] = \"bar\"\nrequest.cookies[\"foo\"]?.try &.value # > \"bar\"\n```","summary":"<p>Gets the current <code><a href=\"../HTTP/Cookie.html\">HTTP::Cookie</a></code> for the given <em>key</em> or <code>nil</code> if none is set.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key) : Cookie?","args_html":"(key) : <a href=\"../HTTP/Cookie.html\">Cookie</a>?","location":{"filename":"src/http/cookie.cr","line_number":333,"url":null},"def":{"name":"[]?","args":[{"name":"key","external_name":"key","restriction":""}],"return_type":"Cookie | ::Nil","visibility":"Public","body":"@cookies[key]?"}},{"html_id":"add_request_headers(headers)-instance-method","name":"add_request_headers","doc":"Adds `Cookie` headers for the cookies in this collection to the\ngiven `HTTP::Headers` instance and returns it. Removes any existing\n`Cookie` headers in it.","summary":"<p>Adds <code><a href=\"../HTTP/Cookie.html\">Cookie</a></code> headers for the cookies in this collection to the given <code><a href=\"../HTTP/Headers.html\">HTTP::Headers</a></code> instance and returns it.</p>","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":""}],"args_string":"(headers)","args_html":"(headers)","location":{"filename":"src/http/cookie.cr","line_number":393,"url":null},"def":{"name":"add_request_headers","args":[{"name":"headers","external_name":"headers","restriction":""}],"visibility":"Public","body":"if empty?\n  headers.delete(\"Cookie\")\nelse\n  capacity = sum do |cookie|\n    (cookie.name.bytesize + cookie.value.bytesize) + 1\n  end\n  capacity = capacity + ((size - 1) * 2)\n  headers[\"Cookie\"] = String.build(capacity) do |io|\n    join(io, \"; \", &.to_cookie_header(io))\n  end\nend\nheaders\n"}},{"html_id":"add_response_headers(headers)-instance-method","name":"add_response_headers","doc":"Adds `Set-Cookie` headers for the cookies in this collection to the\ngiven `HTTP::Headers` instance and returns it. Removes any existing\n`Set-Cookie` headers in it.","summary":"<p>Adds <code><a href=\"../Set.html\">Set</a>-<a href=\"../HTTP/Cookie.html\">Cookie</a></code> headers for the cookies in this collection to the given <code><a href=\"../HTTP/Headers.html\">HTTP::Headers</a></code> instance and returns it.</p>","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":""}],"args_string":"(headers)","args_html":"(headers)","location":{"filename":"src/http/cookie.cr","line_number":410,"url":null},"def":{"name":"add_response_headers","args":[{"name":"headers","external_name":"headers","restriction":""}],"visibility":"Public","body":"headers.delete(\"Set-Cookie\")\neach do |cookie|\n  headers.add(\"Set-Cookie\", cookie.to_set_cookie_header)\nend\nheaders\n"}},{"html_id":"clear:Hash(String,HTTP::Cookie)-instance-method","name":"clear","doc":"Clears the collection, removing all cookies.","summary":"<p>Clears the collection, removing all cookies.</p>","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":357,"url":null},"def":{"name":"clear","return_type":"Hash(String, HTTP::Cookie)","visibility":"Public","body":"@cookies.clear"}},{"html_id":"delete(key):Cookie?-instance-method","name":"delete","doc":"Deletes and returns the `HTTP::Cookie` for the specified *key*, or\nreturns `nil` if *key* cannot be found in the collection. Note that\n*key* should match the name attribute of the desired `HTTP::Cookie`.","summary":"<p>Deletes and returns the <code><a href=\"../HTTP/Cookie.html\">HTTP::Cookie</a></code> for the specified <em>key</em>, or returns <code>nil</code> if <em>key</em> cannot be found in the collection.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key) : Cookie?","args_html":"(key) : <a href=\"../HTTP/Cookie.html\">Cookie</a>?","location":{"filename":"src/http/cookie.cr","line_number":364,"url":null},"def":{"name":"delete","args":[{"name":"key","external_name":"key","restriction":""}],"return_type":"Cookie | ::Nil","visibility":"Public","body":"@cookies.delete(key)"}},{"html_id":"each(&:Cookie->)-instance-method","name":"each","doc":"Yields each `HTTP::Cookie` in the collection.","summary":"<p>Yields each <code><a href=\"../HTTP/Cookie.html\">HTTP::Cookie</a></code> in the collection.</p>","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":369,"url":null},"def":{"name":"each","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Cookie ->)"},"visibility":"Public","body":"@cookies.each_value do |cookie|\n  yield cookie\nend"}},{"html_id":"each-instance-method","name":"each","doc":"Returns an iterator over the cookies of this collection.","summary":"<p>Returns an iterator over the cookies of this collection.</p>","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":376,"url":null},"def":{"name":"each","visibility":"Public","body":"@cookies.each_value"}},{"html_id":"empty?:Bool-instance-method","name":"empty?","doc":"Whether the collection contains any cookies.","summary":"<p>Whether the collection contains any cookies.</p>","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":386,"url":null},"def":{"name":"empty?","return_type":"Bool","visibility":"Public","body":"@cookies.empty?"}},{"html_id":"fill_from_client_headers(headers):self-instance-method","name":"fill_from_client_headers","doc":"Filling cookies by parsing the `Cookie` headers in the given `HTTP::Headers`.","summary":"<p>Filling cookies by parsing the <code><a href=\"../HTTP/Cookie.html\">Cookie</a></code> headers in the given <code><a href=\"../HTTP/Headers.html\">HTTP::Headers</a></code>.</p>","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":""}],"args_string":"(headers) : self","args_html":"(headers) : <span class=\"k\">self</span>","location":{"filename":"src/http/cookie.cr","line_number":251,"url":null},"def":{"name":"fill_from_client_headers","args":[{"name":"headers","external_name":"headers","restriction":""}],"return_type":"self","visibility":"Public","body":"if values = headers.get?(\"Cookie\")\n  values.each do |header|\n    Cookie::Parser.parse_cookies(header) do |cookie|\n      self << cookie\n    end\n  end\nend\nself\n"}},{"html_id":"fill_from_headers(headers)-instance-method","name":"fill_from_headers","doc":"Filling cookies by parsing the `Cookie` and `Set-Cookie`\nheaders in the given `HTTP::Headers`.","summary":"<p>Filling cookies by parsing the <code><a href=\"../HTTP/Cookie.html\">Cookie</a></code> and <code><a href=\"../Set.html\">Set</a>-<a href=\"../HTTP/Cookie.html\">Cookie</a></code> headers in the given <code><a href=\"../HTTP/Headers.html\">HTTP::Headers</a></code>.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"../HTTP/Cookies.html#fill_from_client_headers%28headers%29%3Aself-instance-method\">#fill_from_client_headers</a></code> or <code><a href=\"../HTTP/Cookies.html#fill_from_server_headers%28headers%29%3Aself-instance-method\">#fill_from_server_headers</a></code> instead.</p>","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":""}],"args_string":"(headers)","args_html":"(headers)","location":{"filename":"src/http/cookie.cr","line_number":237,"url":null},"def":{"name":"fill_from_headers","args":[{"name":"headers","external_name":"headers","restriction":""}],"visibility":"Public","body":"fill_from_client_headers(headers)\nfill_from_server_headers(headers)\nself\n"}},{"html_id":"fill_from_server_headers(headers):self-instance-method","name":"fill_from_server_headers","doc":"Filling cookies by parsing the `Set-Cookie` headers in the given `HTTP::Headers`.","summary":"<p>Filling cookies by parsing the <code><a href=\"../Set.html\">Set</a>-<a href=\"../HTTP/Cookie.html\">Cookie</a></code> headers in the given <code><a href=\"../HTTP/Headers.html\">HTTP::Headers</a></code>.</p>","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":""}],"args_string":"(headers) : self","args_html":"(headers) : <span class=\"k\">self</span>","location":{"filename":"src/http/cookie.cr","line_number":268,"url":null},"def":{"name":"fill_from_server_headers","args":[{"name":"headers","external_name":"headers","restriction":""}],"return_type":"self","visibility":"Public","body":"if values = headers.get?(\"Set-Cookie\")\n  values.each do |header|\n    (Cookie::Parser.parse_set_cookie(header)).try do |cookie|\n      self << cookie\n    end\n  end\nend\nself\n"}},{"html_id":"has_key?(key):Bool-instance-method","name":"has_key?","doc":"Returns `true` if a cookie with the given *key* exists.\n\n```\nrequest.cookies.has_key?(\"foo\") # => true\n```","summary":"<p>Returns <code>true</code> if a cookie with the given <em>key</em> exists.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key) : Bool","args_html":"(key) : <a href=\"../Bool.html\">Bool</a>","location":{"filename":"src/http/cookie.cr","line_number":342,"url":null},"def":{"name":"has_key?","args":[{"name":"key","external_name":"key","restriction":""}],"return_type":"Bool","visibility":"Public","body":"@cookies.has_key?(key)"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Returns the number of cookies contained in this collection.","summary":"<p>Returns the number of cookies contained in this collection.</p>","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":381,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"@cookies.size"}},{"html_id":"to_h:Hash(String,Cookie)-instance-method","name":"to_h","doc":"Returns this collection as a plain `Hash`.","summary":"<p>Returns this collection as a plain <code><a href=\"../Hash.html\">Hash</a></code>.</p>","abstract":false,"location":{"filename":"src/http/cookie.cr","line_number":420,"url":null},"def":{"name":"to_h","return_type":"Hash(String, Cookie)","visibility":"Public","body":"@cookies.dup"}}]},{"html_id":"Crystal/HTTP/ErrorHandler","path":"HTTP/ErrorHandler.html","kind":"class","full_name":"HTTP::ErrorHandler","name":"ErrorHandler","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/server/handlers/error_handler.cr","line_number":9,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"}],"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"A handler that invokes the next handler and, if that next handler raises\nan exception, returns with a 500 (Internal Server Error) status code.\n\nIn verbose mode prints the exception with its backtrace to the response.\nOtherwise a generic error message is returned to the client.\n\nThis handler also logs the exceptions to the specified logger or\nthe logger for the source \"http.server\" by default.","summary":"<p>A handler that invokes the next handler and, if that next handler raises an exception, returns with a 500 (Internal Server Error) status code.</p>","constructors":[{"html_id":"new(verbose:Bool=false,log=Log.for(\"http.server\"))-class-method","name":"new","abstract":false,"args":[{"name":"verbose","default_value":"false","external_name":"verbose","restriction":"Bool"},{"name":"log","default_value":"Log.for(\"http.server\")","external_name":"log","restriction":""}],"args_string":"(verbose : Bool = false, log = Log.for(\"http.server\"))","args_html":"(verbose : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>, log = <span class=\"t\">Log</span>.<span class=\"k\">for</span>(<span class=\"s\">&quot;http.server&quot;</span>))","location":{"filename":"src/http/server/handlers/error_handler.cr","line_number":12,"url":null},"def":{"name":"new","args":[{"name":"verbose","default_value":"false","external_name":"verbose","restriction":"Bool"},{"name":"log","default_value":"Log.for(\"http.server\")","external_name":"log","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(verbose, log)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"call(context):Nil-instance-method","name":"call","abstract":false,"args":[{"name":"context","external_name":"context","restriction":""}],"args_string":"(context) : Nil","args_html":"(context) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/http/server/handlers/error_handler.cr","line_number":15,"url":null},"def":{"name":"call","args":[{"name":"context","external_name":"context","restriction":""}],"return_type":"Nil","visibility":"Public","body":"begin\n  call_next(context)\nrescue ex : HTTP::Server::ClientError\n  @log.debug(exception: ex.cause) do\n    ex.message\n  end\nrescue ex : Exception\n  @log.error(exception: ex) do\n    \"Unhandled exception\"\n  end\n  if context.response.closed? || context.response.wrote_headers?\n  else\n    if @verbose\n      context.response.reset\n      context.response.status = :internal_server_error\n      context.response.content_type = \"text/plain\"\n      context.response.print(\"ERROR: \")\n      context.response.puts(ex.inspect_with_backtrace)\n    else\n      context.response.respond_with_status(:internal_server_error)\n    end\n  end\nend"}}]},{"html_id":"Crystal/HTTP/FormData","path":"HTTP/FormData.html","kind":"module","full_name":"HTTP::FormData","name":"FormData","abstract":false,"locations":[{"filename":"src/http/formdata.cr","line_number":79,"url":null},{"filename":"src/http/formdata/builder.cr","line_number":1,"url":null},{"filename":"src/http/formdata/parser.cr","line_number":1,"url":null},{"filename":"src/http/formdata/part.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"Contains utilities for parsing `multipart/form-data` messages, which are\ncommonly used for encoding HTML form data.\n\n### Examples\n\nCommonly, you'll want to parse a from response from a HTTP request, and\nprocess it. An example server which performs this task is shown below.\n\n```\nrequire \"http\"\n\nserver = HTTP::Server.new do |context|\n  name = nil\n  file = nil\n  HTTP::FormData.parse(context.request) do |part|\n    case part.name\n    when \"name\"\n      name = part.body.gets_to_end\n    when \"file\"\n      file = File.tempfile(\"upload\") do |file|\n        IO.copy(part.body, file)\n      end\n    end\n  end\n\n  unless name && file\n    context.response.respond_with_status(:bad_request)\n    next\n  end\n\n  context.response << file.path\nend\n\nserver.bind_tcp 8085\nserver.listen\n```\n\nTo test the server, use the curl command below.\n\n```console\n$ curl http://localhost:8085/ -F name=foo -F file=@/path/to/test.file\n/tmp/upload.Yxn7cc\n```\n\nAnother common case is sending formdata to a server using HTTP::Client. Here\nis an example showing how to upload a file to the server above in crystal.\n\n```\nrequire \"http\"\n\nIO.pipe do |reader, writer|\n  channel = Channel(String).new(1)\n\n  spawn do\n    HTTP::FormData.build(writer) do |formdata|\n      channel.send(formdata.content_type)\n\n      formdata.field(\"name\", \"foo\")\n      File.open(\"foo.png\") do |file|\n        metadata = HTTP::FormData::FileMetadata.new(filename: \"foo.png\")\n        headers = HTTP::Headers{\"Content-Type\" => \"image/png\"}\n        formdata.file(\"file\", file, metadata, headers)\n      end\n    end\n\n    writer.close\n  end\n\n  headers = HTTP::Headers{\"Content-Type\" => channel.receive}\n  response = HTTP::Client.post(\"http://localhost:8085/\", body: reader, headers: headers)\n\n  puts \"Response code #{response.status_code}\"\n  puts \"File path: #{response.body}\"\nend\n```","summary":"<p>Contains utilities for parsing <code>multipart/form-data</code> messages, which are commonly used for encoding HTML form data.</p>","class_methods":[{"html_id":"build(response:HTTP::Server::Response,boundary=MIME::Multipart.generate_boundary,&)-class-method","name":"build","doc":"Builds a multipart/form-data message, yielding a `FormData::Builder`\nobject to the block which writes to *response* using *boundary.\nContent-Type is set on *response* and `Builder#finish` is called on the\nbuilder when the block returns.\n\n```\nrequire \"http\"\n\nio = IO::Memory.new\nresponse = HTTP::Server::Response.new io\nHTTP::FormData.build(response, \"boundary\") do |builder|\n  builder.field(\"foo\", \"bar\")\nend\nresponse.close\n\nresponse.headers[\"Content-Type\"] # => \"multipart/form-data; boundary=\\\"boundary\\\"\"\nio.to_s                          # => \"HTTP/1.1 200 OK\\r\\nContent-Type: multipart/form-data; boundary=\\\"boundary\\\"\\r\\nContent-Length: 75\\r\\n\\r\\n--boundary\\r\\nContent-Disposition: form-data; name=\\\"foo\\\"\\r\\n\\r\\nbar\\r\\n--boundary--\"\n```\n\nSee: `FormData::Builder`","summary":"<p>Builds a multipart/form-data message, yielding a <code><a href=\"../HTTP/FormData/Builder.html\">FormData::Builder</a></code> object to the block which writes to <em>response</em> using *boundary.</p>","abstract":false,"args":[{"name":"response","external_name":"response","restriction":"HTTP::Server::Response"},{"name":"boundary","default_value":"MIME::Multipart.generate_boundary","external_name":"boundary","restriction":""}],"args_string":"(response : HTTP::Server::Response, boundary = MIME::Multipart.generate_boundary, &)","args_html":"(response : <a href=\"../HTTP/Server/Response.html\">HTTP::Server::Response</a>, boundary = <span class=\"t\">MIME</span><span class=\"t\">::</span><span class=\"t\">Multipart</span>.generate_boundary, &)","location":{"filename":"src/http/formdata.cr","line_number":215,"url":null},"def":{"name":"build","args":[{"name":"response","external_name":"response","restriction":"HTTP::Server::Response"},{"name":"boundary","default_value":"MIME::Multipart.generate_boundary","external_name":"boundary","restriction":""}],"yields":1,"visibility":"Public","body":"builder = Builder.new(response, boundary)\nyield builder\nbuilder.finish\nresponse.headers[\"Content-Type\"] = builder.content_type\n"}},{"html_id":"build(io,boundary=MIME::Multipart.generate_boundary,&)-class-method","name":"build","doc":"Builds a multipart/form-data message, yielding a `FormData::Builder`\nobject to the block which writes to *io* using *boundary*.\n`Builder#finish` is called on the builder when the block returns.\n\n```\nrequire \"http\"\n\nio = IO::Memory.new\nHTTP::FormData.build(io, \"boundary\") do |builder|\n  builder.field(\"foo\", \"bar\")\nend\nio.to_s # => \"--boundary\\r\\nContent-Disposition: form-data; name=\\\"foo\\\"\\r\\n\\r\\nbar\\r\\n--boundary--\"\n```\n\nSee: `FormData::Builder`","summary":"<p>Builds a multipart/form-data message, yielding a <code><a href=\"../HTTP/FormData/Builder.html\">FormData::Builder</a></code> object to the block which writes to <em>io</em> using <em>boundary</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"boundary","default_value":"MIME::Multipart.generate_boundary","external_name":"boundary","restriction":""}],"args_string":"(io, boundary = MIME::Multipart.generate_boundary, &)","args_html":"(io, boundary = <span class=\"t\">MIME</span><span class=\"t\">::</span><span class=\"t\">Multipart</span>.generate_boundary, &)","location":{"filename":"src/http/formdata.cr","line_number":189,"url":null},"def":{"name":"build","args":[{"name":"io","external_name":"io","restriction":""},{"name":"boundary","default_value":"MIME::Multipart.generate_boundary","external_name":"boundary","restriction":""}],"yields":1,"visibility":"Public","body":"builder = Builder.new(io, boundary)\nyield builder\nbuilder.finish\n"}},{"html_id":"parse(io,boundary,&)-class-method","name":"parse","doc":"Parses a multipart/form-data message, yielding a `FormData::Part`.\n\n```\nrequire \"http\"\n\nform_data = \"--aA40\\r\\nContent-Disposition: form-data; name=\\\"field1\\\"\\r\\n\\r\\nfield data\\r\\n--aA40--\"\nHTTP::FormData.parse(IO::Memory.new(form_data), \"aA40\") do |part|\n  part.name             # => \"field1\"\n  part.body.gets_to_end # => \"field data\"\nend\n```\n\nSee: `FormData::Parser`","summary":"<p>Parses a multipart/form-data message, yielding a <code><a href=\"../HTTP/FormData/Part.html\">FormData::Part</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"boundary","external_name":"boundary","restriction":""}],"args_string":"(io, boundary, &)","args_html":"(io, boundary, &)","location":{"filename":"src/http/formdata.cr","line_number":93,"url":null},"def":{"name":"parse","args":[{"name":"io","external_name":"io","restriction":""},{"name":"boundary","external_name":"boundary","restriction":""}],"yields":1,"visibility":"Public","body":"parser = Parser.new(io, boundary)\nwhile parser.has_next?\n  parser.next do |part|\n    yield part\n  end\nend\n"}},{"html_id":"parse(request:HTTP::Request,&)-class-method","name":"parse","doc":"Parses a multipart/form-data message, yielding a `FormData::Part`.\n\n```\nrequire \"http\"\n\nheaders = HTTP::Headers{\"Content-Type\" => \"multipart/form-data; boundary=aA40\"}\nbody = \"--aA40\\r\\nContent-Disposition: form-data; name=\\\"field1\\\"\\r\\n\\r\\nfield data\\r\\n--aA40--\"\nrequest = HTTP::Request.new(\"POST\", \"/\", headers, body)\n\nHTTP::FormData.parse(request) do |part|\n  part.name             # => \"field1\"\n  part.body.gets_to_end # => \"field data\"\nend\n```\n\nSee: `FormData::Parser`","summary":"<p>Parses a multipart/form-data message, yielding a <code><a href=\"../HTTP/FormData/Part.html\">FormData::Part</a></code>.</p>","abstract":false,"args":[{"name":"request","external_name":"request","restriction":"HTTP::Request"}],"args_string":"(request : HTTP::Request, &)","args_html":"(request : <a href=\"../HTTP/Request.html\">HTTP::Request</a>, &)","location":{"filename":"src/http/formdata.cr","line_number":116,"url":null},"def":{"name":"parse","args":[{"name":"request","external_name":"request","restriction":"HTTP::Request"}],"yields":1,"visibility":"Public","body":"body = request.body\nif body\nelse\n  raise(Error.new(\"Cannot extract form-data from HTTP request: body is empty\"))\nend\nboundary = request.headers[\"Content-Type\"]?.try do |header|\n  MIME::Multipart.parse_boundary(header)\nend\nif boundary\nelse\n  raise(Error.new(\"Cannot extract form-data from HTTP request: could not find boundary in Content-Type\"))\nend\nparse(body, boundary) do |part|\n  yield part\nend\n"}},{"html_id":"parse_content_disposition(content_disposition):Tuple(String,FileMetadata)-class-method","name":"parse_content_disposition","doc":"Parses a `Content-Disposition` header string into a field name and\n`FileMetadata`. Please note that the `Content-Disposition` header for\n`multipart/form-data` is not compatible with the original definition in\n[RFC 2183](https://tools.ietf.org/html/rfc2183), but are instead specified\nin [RFC 2388](https://tools.ietf.org/html/rfc2388).","summary":"<p>Parses a <code>Content-Disposition</code> header string into a field name and <code><a href=\"../HTTP/FormData/FileMetadata.html\">FileMetadata</a></code>.</p>","abstract":false,"args":[{"name":"content_disposition","external_name":"content_disposition","restriction":""}],"args_string":"(content_disposition) : Tuple(String, FileMetadata)","args_html":"(content_disposition) : <a href=\"../Tuple.html\">Tuple</a>(<a href=\"../String.html\">String</a>, <a href=\"../HTTP/FormData/FileMetadata.html\">FileMetadata</a>)","location":{"filename":"src/http/formdata.cr","line_number":131,"url":null},"def":{"name":"parse_content_disposition","args":[{"name":"content_disposition","external_name":"content_disposition","restriction":""}],"return_type":"::Tuple(String, FileMetadata)","visibility":"Public","body":"filename = nil\ncreation_time = nil\nmodification_time = nil\nread_time = nil\nsize = nil\nname = nil\nparts = content_disposition.split(';')\ntype = parts[0]\nif type == \"form-data\"\nelse\n  raise(Error.new(\"Invalid Content-Disposition: not form-data\"))\nend\n(1...parts.size).each do |i|\n  part = parts[i]\n  key, value = part.split('=', 2)\n  key = key.strip\n  value = value.strip\n  if value[0] == '\"'\n    value = HTTP.dequote_string(value[1...-1])\n  end\n  case key\n  when \"filename\"\n    filename = value\n  when \"creation-date\"\n    creation_time = HTTP.parse_time(value)\n  when \"modification-date\"\n    modification_time = HTTP.parse_time(value)\n  when \"read-date\"\n    read_time = HTTP.parse_time(value)\n  when \"size\"\n    size = value.to_u64\n  when \"name\"\n    name = value\n  else\n  end\nend\nif name\nelse\n  raise(Error.new(\"Invalid Content-Disposition: no name field\"))\nend\n{name, FileMetadata.new(filename, creation_time, modification_time, read_time, size)}\n"}}],"types":[{"html_id":"Crystal/HTTP/FormData/Builder","path":"HTTP/FormData/Builder.html","kind":"class","full_name":"HTTP::FormData::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/formdata/builder.cr","line_number":17,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/HTTP/FormData","kind":"module","full_name":"HTTP::FormData","name":"FormData"},"doc":"Builds a multipart/form-data message.\n\n### Example\n\n```\nrequire \"http\"\n\nio = IO::Memory.new\nbuilder = HTTP::FormData::Builder.new(io, \"aA47\")\nbuilder.field(\"name\", \"joe\")\nfile = IO::Memory.new(\"file contents\")\nbuilder.file(\"upload\", file, HTTP::FormData::FileMetadata.new(filename: \"test.txt\"))\nbuilder.finish\nio.to_s # => \"--aA47\\r\\nContent-Disposition: form-data; name=\\\"name\\\"\\r\\n\\r\\njoe\\r\\n--aA47\\r\\nContent-Disposition: form-data; name=\\\"upload\\\"; filename=\\\"test.txt\\\"\\r\\n\\r\\nfile contents\\r\\n--aA47--\"\n```","summary":"<p>Builds a multipart/form-data message.</p>","constructors":[{"html_id":"new(io:IO,boundary=MIME::Multipart.generate_boundary)-class-method","name":"new","doc":"Creates a new `FormData::Builder` which writes to *io*, using the\nmultipart boundary *boundary*.","summary":"<p>Creates a new <code><a href=\"../../HTTP/FormData/Builder.html\">FormData::Builder</a></code> which writes to <em>io</em>, using the multipart boundary <em>boundary</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"boundary","default_value":"MIME::Multipart.generate_boundary","external_name":"boundary","restriction":""}],"args_string":"(io : IO, boundary = MIME::Multipart.generate_boundary)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, boundary = <span class=\"t\">MIME</span><span class=\"t\">::</span><span class=\"t\">Multipart</span>.generate_boundary)","location":{"filename":"src/http/formdata/builder.cr","line_number":20,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"boundary","default_value":"MIME::Multipart.generate_boundary","external_name":"boundary","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, boundary)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"boundary:String-instance-method","name":"boundary","abstract":false,"location":{"filename":"src/http/formdata/builder.cr","line_number":24,"url":null},"def":{"name":"boundary","visibility":"Public","body":"@boundary"}},{"html_id":"content_type:String-instance-method","name":"content_type","doc":"Returns a content type header with correct boundary parameter.\n\n```\nbuilder = HTTP::FormData::Builder.new(io, \"a4VF\")\nbuilder.content_type # => \"multipart/form-data; boundary=\\\"a4VF\\\"\"\n```","summary":"<p>Returns a content type header with correct boundary parameter.</p>","abstract":false,"location":{"filename":"src/http/formdata/builder.cr","line_number":32,"url":null},"def":{"name":"content_type","return_type":"String","visibility":"Public","body":"String.build do |str|\n  str << \"multipart/form-data; boundary=\\\"\"\n  HTTP.quote_string(@boundary, str)\n  str << '\"'\nend"}},{"html_id":"field(name:String,value,headers:HTTP::Headers=HTTP::Headers.new):Nil-instance-method","name":"field","doc":"Adds a form part with the given *name* and *value*. *Headers* can\noptionally be provided for the form part.","summary":"<p>Adds a form part with the given <em>name</em> and <em>value</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"value","external_name":"value","restriction":""},{"name":"headers","default_value":"HTTP::Headers.new","external_name":"headers","restriction":"HTTP::Headers"}],"args_string":"(name : String, value, headers : HTTP::Headers = HTTP::Headers.new) : Nil","args_html":"(name : <a href=\"../../String.html\">String</a>, value, headers : <a href=\"../../HTTP/Headers.html\">HTTP::Headers</a> = <span class=\"t\">HTTP</span><span class=\"t\">::</span><span class=\"t\">Headers</span>.<span class=\"k\">new</span>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/http/formdata/builder.cr","line_number":42,"url":null},"def":{"name":"field","args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"value","external_name":"value","restriction":""},{"name":"headers","default_value":"HTTP::Headers.new","external_name":"headers","restriction":"HTTP::Headers"}],"return_type":"Nil","visibility":"Public","body":"file(name, IO::Memory.new(value.to_s), headers: headers)"}},{"html_id":"file(name:String,io,metadata:FileMetadata=FileMetadata.new,headers:HTTP::Headers=HTTP::Headers.new)-instance-method","name":"file","doc":"Adds a form part called *name*, with data from *io* as the value.\n*Metadata* can be provided to add extra metadata about the file to the\nContent-Disposition header for the form part. Other headers can be added\nusing *headers*.","summary":"<p>Adds a form part called <em>name</em>, with data from <em>io</em> as the value.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"io","external_name":"io","restriction":""},{"name":"metadata","default_value":"FileMetadata.new","external_name":"metadata","restriction":"FileMetadata"},{"name":"headers","default_value":"HTTP::Headers.new","external_name":"headers","restriction":"HTTP::Headers"}],"args_string":"(name : String, io, metadata : FileMetadata = FileMetadata.new, headers : HTTP::Headers = HTTP::Headers.new)","args_html":"(name : <a href=\"../../String.html\">String</a>, io, metadata : <a href=\"../../HTTP/FormData/FileMetadata.html\">FileMetadata</a> = <span class=\"t\">FileMetadata</span>.<span class=\"k\">new</span>, headers : <a href=\"../../HTTP/Headers.html\">HTTP::Headers</a> = <span class=\"t\">HTTP</span><span class=\"t\">::</span><span class=\"t\">Headers</span>.<span class=\"k\">new</span>)","location":{"filename":"src/http/formdata/builder.cr","line_number":50,"url":null},"def":{"name":"file","args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"io","external_name":"io","restriction":""},{"name":"metadata","default_value":"FileMetadata.new","external_name":"metadata","restriction":"FileMetadata"},{"name":"headers","default_value":"HTTP::Headers.new","external_name":"headers","restriction":"HTTP::Headers"}],"visibility":"Public","body":"if @state == (:FINISHED)\n  fail(\"Cannot add form part: already finished\")\nend\nheaders[\"Content-Disposition\"] = generate_content_disposition(name, metadata)\nif @state == (:START)\nelse\n  @io << \"\\r\\n\"\nend\n(@io << \"--\") << @boundary\nheaders.each do |name, values|\n  values.each do |value|\n    (((@io << \"\\r\\n\") << name) << \": \") << value\n  end\nend\n@io << \"\\r\\n\\r\\n\"\nIO.copy(io, @io)\n@state = :FIELD\n"}},{"html_id":"finish:Nil-instance-method","name":"finish","doc":"Finalizes the multipart message, this method must be called before the\ngenerated multipart message written to the IO is considered valid.","summary":"<p>Finalizes the multipart message, this method must be called before the generated multipart message written to the IO is considered valid.</p>","abstract":false,"location":{"filename":"src/http/formdata/builder.cr","line_number":71,"url":null},"def":{"name":"finish","return_type":"Nil","visibility":"Public","body":"if @state == (:START)\n  fail(\"Cannot finish form-data: no body parts\")\nend\nif @state == (:FINISHED)\n  fail(\"Cannot finish form-data: already finished\")\nend\n((@io << \"\\r\\n--\") << @boundary) << \"--\"\n@state = :FINISHED\n"}}]},{"html_id":"Crystal/HTTP/FormData/Error","path":"HTTP/FormData/Error.html","kind":"class","full_name":"HTTP::FormData::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/formdata.cr","line_number":230,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/HTTP/FormData","kind":"module","full_name":"HTTP::FormData","name":"FormData"}},{"html_id":"Crystal/HTTP/FormData/FileMetadata","path":"HTTP/FormData/FileMetadata.html","kind":"struct","full_name":"HTTP::FormData::FileMetadata","name":"FileMetadata","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/formdata.cr","line_number":223,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/HTTP/FormData","kind":"module","full_name":"HTTP::FormData","name":"FormData"},"doc":"Metadata which may be available for uploaded files.","summary":"<p>Metadata which may be available for uploaded files.</p>","constructors":[{"html_id":"new(filename:String?=nil,creation_time:Time?=nil,modification_time:Time?=nil,read_time:Time?=nil,size:UInt64?=nil)-class-method","name":"new","abstract":false,"args":[{"name":"filename","default_value":"nil","external_name":"filename","restriction":"String | ::Nil"},{"name":"creation_time","default_value":"nil","external_name":"creation_time","restriction":"Time | ::Nil"},{"name":"modification_time","default_value":"nil","external_name":"modification_time","restriction":"Time | ::Nil"},{"name":"read_time","default_value":"nil","external_name":"read_time","restriction":"Time | ::Nil"},{"name":"size","default_value":"nil","external_name":"size","restriction":"UInt64 | ::Nil"}],"args_string":"(filename : String? = nil, creation_time : Time? = nil, modification_time : Time? = nil, read_time : Time? = nil, size : UInt64? = nil)","args_html":"(filename : <a href=\"../../String.html\">String</a>? = <span class=\"n\">nil</span>, creation_time : <a href=\"../../Time.html\">Time</a>? = <span class=\"n\">nil</span>, modification_time : <a href=\"../../Time.html\">Time</a>? = <span class=\"n\">nil</span>, read_time : <a href=\"../../Time.html\">Time</a>? = <span class=\"n\">nil</span>, size : <a href=\"../../UInt64.html\">UInt64</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/http/formdata.cr","line_number":223,"url":null},"def":{"name":"new","args":[{"name":"filename","default_value":"nil","external_name":"filename","restriction":"String | ::Nil"},{"name":"creation_time","default_value":"nil","external_name":"creation_time","restriction":"Time | ::Nil"},{"name":"modification_time","default_value":"nil","external_name":"modification_time","restriction":"Time | ::Nil"},{"name":"read_time","default_value":"nil","external_name":"read_time","restriction":"Time | ::Nil"},{"name":"size","default_value":"nil","external_name":"size","restriction":"UInt64 | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(filename, creation_time, modification_time, read_time, size)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/http/formdata.cr","line_number":223,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new(@filename.clone, @creation_time.clone, @modification_time.clone, @read_time.clone, @size.clone)"}},{"html_id":"copy_with(filename_filename=@filename,creation_time_creation_time=@creation_time,modification_time_modification_time=@modification_time,read_time_read_time=@read_time,size_size=@size)-instance-method","name":"copy_with","abstract":false,"args":[{"name":"_filename","default_value":"@filename","external_name":"filename","restriction":""},{"name":"_creation_time","default_value":"@creation_time","external_name":"creation_time","restriction":""},{"name":"_modification_time","default_value":"@modification_time","external_name":"modification_time","restriction":""},{"name":"_read_time","default_value":"@read_time","external_name":"read_time","restriction":""},{"name":"_size","default_value":"@size","external_name":"size","restriction":""}],"args_string":"(filename _filename = @filename, creation_time _creation_time = @creation_time, modification_time _modification_time = @modification_time, read_time _read_time = @read_time, size _size = @size)","args_html":"(filename _filename = @filename, creation_time _creation_time = @creation_time, modification_time _modification_time = @modification_time, read_time _read_time = @read_time, size _size = @size)","location":{"filename":"src/http/formdata.cr","line_number":223,"url":null},"def":{"name":"copy_with","args":[{"name":"_filename","default_value":"@filename","external_name":"filename","restriction":""},{"name":"_creation_time","default_value":"@creation_time","external_name":"creation_time","restriction":""},{"name":"_modification_time","default_value":"@modification_time","external_name":"modification_time","restriction":""},{"name":"_read_time","default_value":"@read_time","external_name":"read_time","restriction":""},{"name":"_size","default_value":"@size","external_name":"size","restriction":""}],"visibility":"Public","body":"self.class.new(_filename, _creation_time, _modification_time, _read_time, _size)"}},{"html_id":"creation_time:Time?-instance-method","name":"creation_time","abstract":false,"def":{"name":"creation_time","return_type":"Time | ::Nil","visibility":"Public","body":"@creation_time"}},{"html_id":"filename:String?-instance-method","name":"filename","abstract":false,"def":{"name":"filename","return_type":"String | ::Nil","visibility":"Public","body":"@filename"}},{"html_id":"modification_time:Time?-instance-method","name":"modification_time","abstract":false,"def":{"name":"modification_time","return_type":"Time | ::Nil","visibility":"Public","body":"@modification_time"}},{"html_id":"read_time:Time?-instance-method","name":"read_time","abstract":false,"def":{"name":"read_time","return_type":"Time | ::Nil","visibility":"Public","body":"@read_time"}},{"html_id":"size:UInt64?-instance-method","name":"size","abstract":false,"def":{"name":"size","return_type":"UInt64 | ::Nil","visibility":"Public","body":"@size"}}]},{"html_id":"Crystal/HTTP/FormData/Parser","path":"HTTP/FormData/Parser.html","kind":"class","full_name":"HTTP::FormData::Parser","name":"Parser","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/formdata/parser.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/HTTP/FormData","kind":"module","full_name":"HTTP::FormData","name":"FormData"},"constructors":[{"html_id":"new(io,boundary)-class-method","name":"new","doc":"Creates a new parser which parses *io* with multipart boundary *boundary*.","summary":"<p>Creates a new parser which parses <em>io</em> with multipart boundary <em>boundary</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"boundary","external_name":"boundary","restriction":""}],"args_string":"(io, boundary)","args_html":"(io, boundary)","location":{"filename":"src/http/formdata/parser.cr","line_number":4,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":""},{"name":"boundary","external_name":"boundary","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, boundary)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"has_next?:Bool-instance-method","name":"has_next?","doc":"True if `#next` can be called legally.","summary":"<p>True if <code><a href=\"../../HTTP/FormData/Parser.html#next%28%26%29-instance-method\">#next</a></code> can be called legally.</p>","abstract":false,"location":{"filename":"src/http/formdata/parser.cr","line_number":41,"url":null},"def":{"name":"has_next?","return_type":"Bool","visibility":"Public","body":"@multipart.has_next?"}},{"html_id":"next(&)-instance-method","name":"next","doc":"Parses the next form-data part and yields field name, io, `FileMetadata`,\nand raw headers.\n\nThis method yields once instead of returning the values, because the IO\nobject yielded to the block is only valid while the block is executing.\nThe IO object will be closed as soon as the block returns. To store the\ncontent of the body part for longer than the block, the IO must be read\ninto memory.\n\n```\nrequire \"http\"\n\nform_data = \"--aA40\\r\\nContent-Disposition: form-data; name=\\\"field1\\\"; filename=\\\"foo.txt\\\"; size=13\\r\\nContent-Type: text/plain\\r\\n\\r\\nfield data\\r\\n--aA40--\"\nparser = HTTP::FormData::Parser.new(IO::Memory.new(form_data), \"aA40\")\nparser.next do |part|\n  part.name                    # => \"field1\"\n  part.body.gets_to_end        # => \"field data\"\n  part.filename                # => \"foo.txt\"\n  part.size                    # => 13\n  part.headers[\"Content-Type\"] # => \"text/plain\"\nend\n```","summary":"<p>Parses the next form-data part and yields field name, io, <code><a href=\"../../HTTP/FormData/FileMetadata.html\">FileMetadata</a></code>, and raw headers.</p>","abstract":false,"location":{"filename":"src/http/formdata/parser.cr","line_number":30,"url":null},"def":{"name":"next","yields":1,"visibility":"Public","body":"if has_next?\nelse\n  raise(FormData::Error.new(\"Parser has already finished parsing\"))\nend\nwhile @multipart.has_next?\n  @multipart.next do |headers, io|\n    yield HTTP::FormData::Part.new(headers, io)\n  end\nend\n"}}]},{"html_id":"Crystal/HTTP/FormData/Part","path":"HTTP/FormData/Part.html","kind":"struct","full_name":"HTTP::FormData::Part","name":"Part","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/formdata/part.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/HTTP/FormData","kind":"module","full_name":"HTTP::FormData","name":"FormData"},"constructors":[{"html_id":"new(headers:HTTP::Headers,body:IO)-class-method","name":"new","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":"HTTP::Headers"},{"name":"body","external_name":"body","restriction":"IO"}],"args_string":"(headers : HTTP::Headers, body : IO)","args_html":"(headers : <a href=\"../../HTTP/Headers.html\">HTTP::Headers</a>, body : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/http/formdata/part.cr","line_number":13,"url":null},"def":{"name":"new","args":[{"name":"headers","external_name":"headers","restriction":"HTTP::Headers"},{"name":"body","external_name":"body","restriction":"IO"}],"visibility":"Public","body":"_ = allocate\n_.initialize(headers, body)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"body:IO-instance-method","name":"body","abstract":false,"location":{"filename":"src/http/formdata/part.cr","line_number":4,"url":null},"def":{"name":"body","return_type":"IO","visibility":"Public","body":"@body"}},{"html_id":"creation_time:Time?-instance-method","name":"creation_time","abstract":false,"location":{"filename":"src/http/formdata/part.cr","line_number":8,"url":null},"def":{"name":"creation_time","return_type":"Time | ::Nil","visibility":"Public","body":"@creation_time"}},{"html_id":"filename:String?-instance-method","name":"filename","abstract":false,"location":{"filename":"src/http/formdata/part.cr","line_number":7,"url":null},"def":{"name":"filename","return_type":"String | ::Nil","visibility":"Public","body":"@filename"}},{"html_id":"headers:HTTP::Headers-instance-method","name":"headers","abstract":false,"location":{"filename":"src/http/formdata/part.cr","line_number":5,"url":null},"def":{"name":"headers","return_type":"HTTP::Headers","visibility":"Public","body":"@headers"}},{"html_id":"modification_time:Time?-instance-method","name":"modification_time","abstract":false,"location":{"filename":"src/http/formdata/part.cr","line_number":9,"url":null},"def":{"name":"modification_time","return_type":"Time | ::Nil","visibility":"Public","body":"@modification_time"}},{"html_id":"name:String-instance-method","name":"name","abstract":false,"location":{"filename":"src/http/formdata/part.cr","line_number":3,"url":null},"def":{"name":"name","return_type":"String","visibility":"Public","body":"@name"}},{"html_id":"read_time:Time?-instance-method","name":"read_time","abstract":false,"location":{"filename":"src/http/formdata/part.cr","line_number":10,"url":null},"def":{"name":"read_time","return_type":"Time | ::Nil","visibility":"Public","body":"@read_time"}},{"html_id":"size:UInt64?-instance-method","name":"size","abstract":false,"location":{"filename":"src/http/formdata/part.cr","line_number":11,"url":null},"def":{"name":"size","return_type":"UInt64 | ::Nil","visibility":"Public","body":"@size"}}]}]},{"html_id":"Crystal/HTTP/Handler","path":"HTTP/Handler.html","kind":"module","full_name":"HTTP::Handler","name":"Handler","abstract":false,"locations":[{"filename":"src/http/server/handler.cr","line_number":21,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"including_types":[{"html_id":"Crystal/HTTP/CompressHandler","kind":"class","full_name":"HTTP::CompressHandler","name":"CompressHandler"},{"html_id":"Crystal/HTTP/ErrorHandler","kind":"class","full_name":"HTTP::ErrorHandler","name":"ErrorHandler"},{"html_id":"Crystal/HTTP/LogHandler","kind":"class","full_name":"HTTP::LogHandler","name":"LogHandler"},{"html_id":"Crystal/HTTP/StaticFileHandler","kind":"class","full_name":"HTTP::StaticFileHandler","name":"StaticFileHandler"},{"html_id":"Crystal/HTTP/WebSocketHandler","kind":"class","full_name":"HTTP::WebSocketHandler","name":"WebSocketHandler"}],"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"A handler is a class which includes `HTTP::Handler` and implements the `call` method.\nYou can use a handler to intercept any incoming request and can modify the response.\nThese can be used for request throttling, ip-based filtering, adding custom headers e.g.\n\n### A custom handler\n\n```\nrequire \"http/server/handler\"\n\nclass CustomHandler\n  include HTTP::Handler\n\n  def call(context)\n    puts \"Doing some stuff\"\n    call_next(context)\n  end\nend\n```","summary":"<p>A handler is a class which includes <code><a href=\"../HTTP/Handler.html\">HTTP::Handler</a></code> and implements the <code><a href=\"../HTTP/Handler.html#call%28context%3AHTTP%3A%3AServer%3A%3AContext%29-instance-method\">#call</a></code> method.</p>","instance_methods":[{"html_id":"call(context:HTTP::Server::Context)-instance-method","name":"call","abstract":true,"args":[{"name":"context","external_name":"context","restriction":"HTTP::Server::Context"}],"args_string":"(context : HTTP::Server::Context)","args_html":"(context : <a href=\"../HTTP/Server/Context.html\">HTTP::Server::Context</a>)","location":{"filename":"src/http/server/handler.cr","line_number":24,"url":null},"def":{"name":"call","args":[{"name":"context","external_name":"context","restriction":"HTTP::Server::Context"}],"visibility":"Public","body":""}},{"html_id":"call_next(context:HTTP::Server::Context)-instance-method","name":"call_next","abstract":false,"args":[{"name":"context","external_name":"context","restriction":"HTTP::Server::Context"}],"args_string":"(context : HTTP::Server::Context)","args_html":"(context : <a href=\"../HTTP/Server/Context.html\">HTTP::Server::Context</a>)","location":{"filename":"src/http/server/handler.cr","line_number":26,"url":null},"def":{"name":"call_next","args":[{"name":"context","external_name":"context","restriction":"HTTP::Server::Context"}],"visibility":"Public","body":"if next_handler = @next\n  next_handler.call(context)\nelse\n  context.response.respond_with_status(:not_found)\nend"}},{"html_id":"next:Handler|HandlerProc|Nil-instance-method","name":"next","abstract":false,"location":{"filename":"src/http/server/handler.cr","line_number":22,"url":null},"def":{"name":"next","return_type":"Handler | HandlerProc | Nil","visibility":"Public","body":"@next"}},{"html_id":"next=(next__arg0:Handler|HandlerProc|Nil)-instance-method","name":"next=","abstract":false,"args":[{"name":"__arg0","external_name":"next","restriction":"Handler | HandlerProc | Nil"}],"args_string":"(next __arg0 : Handler | HandlerProc | Nil)","args_html":"(next __arg0 : <a href=\"../HTTP/Handler.html\">Handler</a> | <a href=\"../HTTP/Handler/HandlerProc.html\">HandlerProc</a> | <a href=\"../Nil.html\">Nil</a>)","location":{"filename":"src/http/server/handler.cr","line_number":22,"url":null},"def":{"name":"next=","args":[{"name":"__arg0","external_name":"next","restriction":"Handler | HandlerProc | Nil"}],"visibility":"Public","body":"@next = __arg0"}}],"types":[{"html_id":"Crystal/HTTP/Handler/HandlerProc","path":"HTTP/Handler/HandlerProc.html","kind":"alias","full_name":"HTTP::Handler::HandlerProc","name":"HandlerProc","abstract":false,"locations":[{"filename":"src/http/server/handler.cr","line_number":34,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"Proc(HTTP::Server::Context, Nil)","aliased_html":"<a href=\"../../HTTP/Server/Context.html\">HTTP::Server::Context</a> -> <a href=\"../../Nil.html\">Nil</a>","const":false,"namespace":{"html_id":"Crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"}}]},{"html_id":"Crystal/HTTP/Headers","path":"HTTP/Headers.html","kind":"struct","full_name":"HTTP::Headers","name":"Headers","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/headers.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"A `Hash`-like object that holds HTTP headers.\n\nTwo headers are considered the same if their downcase representation is the same\n(in which `_` is the downcase version of `-`).","summary":"<p>A <code><a href=\"../Hash.html\">Hash</a></code>-like object that holds HTTP headers.</p>","constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/http/headers.cr","line_number":51,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","doc":"Equality operator.\n\nReturns `true` if *other* is equal to `self`.\n\nKeys are matched case-insensitive.\nString values are treated equal to an array values with the same string as\nsingle element.\n\n```\nHTTP::Headers{\"Foo\" => \"bar\"} == HTTP::Headers{\"Foo\" => \"bar\"}   # => true\nHTTP::Headers{\"Foo\" => \"bar\"} == HTTP::Headers{\"foo\" => \"bar\"}   # => true\nHTTP::Headers{\"Foo\" => \"bar\"} == HTTP::Headers{\"Foo\" => [\"bar\"]} # => true\nHTTP::Headers{\"Foo\" => \"bar\"} == HTTP::Headers{\"Foo\" => \"baz\"}   # => false\n```","summary":"<p>Equality operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/http/headers.cr","line_number":188,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"if @hash.size == (other.@hash).size\nelse\n  return false\nend\n(other.@hash).each do |key, value|\n  this_value = @hash.fetch(key) do\n    return false\n  end\n  case {value, this_value}\n  in {String, String}, {Array, Array}\n    if this_value == value\n    else\n      return false\n    end\n  in {String, Array}\n    if (this_value.size == 1) && ((this_value.unsafe_fetch(0)) == value)\n    else\n      return false\n    end\n  in {Array, String}\n    if (value.size == 1) && ((value.unsafe_fetch(0)) == this_value)\n    else\n      return false\n    end\n  end\nend\ntrue\n"}},{"html_id":"[](key):String-instance-method","name":"[]","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key) : String","args_html":"(key) : <a href=\"../String.html\">String</a>","location":{"filename":"src/http/headers.cr","line_number":70,"url":null},"def":{"name":"[]","args":[{"name":"key","external_name":"key","restriction":""}],"return_type":"String","visibility":"Public","body":"values = @hash[wrap(key)]\nconcat(values)\n"}},{"html_id":"[]=(key,value:String)-instance-method","name":"[]=","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(key, value : String)","args_html":"(key, value : <a href=\"../String.html\">String</a>)","location":{"filename":"src/http/headers.cr","line_number":58,"url":null},"def":{"name":"[]=","args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"String"}],"visibility":"Public","body":"check_invalid_header_content(value)\n@hash[wrap(key)] = value\n"}},{"html_id":"[]=(key,value:Array(String))-instance-method","name":"[]=","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"Array(String)"}],"args_string":"(key, value : Array(String))","args_html":"(key, value : <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>))","location":{"filename":"src/http/headers.cr","line_number":64,"url":null},"def":{"name":"[]=","args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"Array(String)"}],"visibility":"Public","body":"value.each do |val|\n  check_invalid_header_content(val)\nend\n@hash[wrap(key)] = value\n"}},{"html_id":"[]?(key):String?-instance-method","name":"[]?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key) : String?","args_html":"(key) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/http/headers.cr","line_number":75,"url":null},"def":{"name":"[]?","args":[{"name":"key","external_name":"key","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"fetch(key, nil)"}},{"html_id":"add(key,value:String):self-instance-method","name":"add","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(key, value : String) : self","args_html":"(key, value : <a href=\"../String.html\">String</a>) : <span class=\"k\">self</span>","location":{"filename":"src/http/headers.cr","line_number":121,"url":null},"def":{"name":"add","args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"String"}],"return_type":"self","visibility":"Public","body":"check_invalid_header_content(value)\nunsafe_add(key, value)\nself\n"}},{"html_id":"add(key,value:Array(String)):self-instance-method","name":"add","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"Array(String)"}],"args_string":"(key, value : Array(String)) : self","args_html":"(key, value : <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)) : <span class=\"k\">self</span>","location":{"filename":"src/http/headers.cr","line_number":127,"url":null},"def":{"name":"add","args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"Array(String)"}],"return_type":"self","visibility":"Public","body":"value.each do |val|\n  check_invalid_header_content(val)\nend\nunsafe_add(key, value)\nself\n"}},{"html_id":"add?(key,value:String):Bool-instance-method","name":"add?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(key, value : String) : Bool","args_html":"(key, value : <a href=\"../String.html\">String</a>) : <a href=\"../Bool.html\">Bool</a>","location":{"filename":"src/http/headers.cr","line_number":133,"url":null},"def":{"name":"add?","args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"String"}],"return_type":"Bool","visibility":"Public","body":"if valid_value?(value)\nelse\n  return false\nend\nunsafe_add(key, value)\ntrue\n"}},{"html_id":"add?(key,value:Array(String)):Bool-instance-method","name":"add?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"Array(String)"}],"args_string":"(key, value : Array(String)) : Bool","args_html":"(key, value : <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)) : <a href=\"../Bool.html\">Bool</a>","location":{"filename":"src/http/headers.cr","line_number":139,"url":null},"def":{"name":"add?","args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"Array(String)"}],"return_type":"Bool","visibility":"Public","body":"value.each do |val|\n  if valid_value?(val)\n  else\n    return false\n  end\nend\nunsafe_add(key, value)\ntrue\n"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/http/headers.cr","line_number":252,"url":null},"def":{"name":"clone","visibility":"Public","body":"dup"}},{"html_id":"delete(key):String?-instance-method","name":"delete","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key) : String?","args_html":"(key) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/http/headers.cr","line_number":162,"url":null},"def":{"name":"delete","args":[{"name":"key","external_name":"key","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"values = @hash.delete(wrap(key))\nvalues ? concat(values) : nil\n"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy of this object.\n\nBecause `Value` is a value type, this method returns `self`,\nwhich already involves a shallow copy of this object because\nvalue types are passed by value.","summary":"<p>Returns a shallow copy of this object.</p>","abstract":false,"location":{"filename":"src/http/headers.cr","line_number":244,"url":null},"def":{"name":"dup","visibility":"Public","body":"dup = HTTP::Headers.new\n@hash.each do |key, value|\n  (dup.@hash)[key] = value\nend\ndup\n"}},{"html_id":"each(&)-instance-method","name":"each","doc":"Must yield this collection's elements to the block.","summary":"<p>Must yield this collection's elements to the block.</p>","abstract":false,"location":{"filename":"src/http/headers.cr","line_number":230,"url":null},"def":{"name":"each","yields":1,"visibility":"Public","body":"@hash.each do |key, value|\n  yield({key.name, cast(value)})\nend"}},{"html_id":"empty?:Bool-instance-method","name":"empty?","doc":"Returns `true` if `self` is empty, `false` otherwise.\n\n```\n([] of Int32).empty? # => true\n([1]).empty?         # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is empty, <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/http/headers.cr","line_number":158,"url":null},"def":{"name":"empty?","return_type":"Bool","visibility":"Public","body":"@hash.empty?"}},{"html_id":"fetch(key,default):String?-instance-method","name":"fetch","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""},{"name":"default","external_name":"default","restriction":""}],"args_string":"(key, default) : String?","args_html":"(key, default) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/http/headers.cr","line_number":145,"url":null},"def":{"name":"fetch","args":[{"name":"key","external_name":"key","restriction":""},{"name":"default","external_name":"default","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"fetch(wrap(key)) do\n  default\nend"}},{"html_id":"fetch(key,&)-instance-method","name":"fetch","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key, &)","args_html":"(key, &)","location":{"filename":"src/http/headers.cr","line_number":149,"url":null},"def":{"name":"fetch","args":[{"name":"key","external_name":"key","restriction":""}],"yields":1,"visibility":"Public","body":"values = @hash[wrap(key)]?\nvalues ? concat(values) : yield key\n"}},{"html_id":"get(key):Array(String)-instance-method","name":"get","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key) : Array(String)","args_html":"(key) : <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)","location":{"filename":"src/http/headers.cr","line_number":236,"url":null},"def":{"name":"get","args":[{"name":"key","external_name":"key","restriction":""}],"return_type":"Array(String)","visibility":"Public","body":"cast(@hash[wrap(key)])"}},{"html_id":"get?(key):Array(String)?-instance-method","name":"get?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key) : Array(String)?","args_html":"(key) : <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)?","location":{"filename":"src/http/headers.cr","line_number":240,"url":null},"def":{"name":"get?","args":[{"name":"key","external_name":"key","restriction":""}],"return_type":"Array(String) | ::Nil","visibility":"Public","body":"@hash[wrap(key)]?.try do |value|\n  cast(value)\nend"}},{"html_id":"has_key?(key):Bool-instance-method","name":"has_key?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key) : Bool","args_html":"(key) : <a href=\"../Bool.html\">Bool</a>","location":{"filename":"src/http/headers.cr","line_number":154,"url":null},"def":{"name":"has_key?","args":[{"name":"key","external_name":"key","restriction":""}],"return_type":"Bool","visibility":"Public","body":"@hash.has_key?(wrap(key))"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/http/headers.cr","line_number":208,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"result = hasher.result\n@hash.each do |key, value|\n  copy = hasher\n  copy = key.hash(copy)\n  if value.is_a?(Array)\n    copy = value.hash(copy)\n  else\n    copy = 1.hash(copy)\n    copy = value.hash(copy)\n  end\n  result = result &+ copy.result\nend\nresult.hash(hasher)\n"}},{"html_id":"includes_word?(key,word):Bool-instance-method","name":"includes_word?","doc":"Returns if among the headers for *key* there is some that contains *word* as a value.\nThe *word* is expected to match between word boundaries (i.e. non-alphanumeric chars).\n\n```\nrequire \"http/headers\"\n\nheaders = HTTP::Headers{\"Connection\" => \"keep-alive, Upgrade\"}\nheaders.includes_word?(\"Connection\", \"Upgrade\") # => true\n```","summary":"<p>Returns if among the headers for <em>key</em> there is some that contains <em>word</em> as a value.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""},{"name":"word","external_name":"word","restriction":""}],"args_string":"(key, word) : Bool","args_html":"(key, word) : <a href=\"../Bool.html\">Bool</a>","location":{"filename":"src/http/headers.cr","line_number":88,"url":null},"def":{"name":"includes_word?","args":[{"name":"key","external_name":"key","restriction":""},{"name":"word","external_name":"word","restriction":""}],"return_type":"Bool","visibility":"Public","body":"if word.empty?\n  return false\nend\nvalues = @hash[wrap(key)]?\ncase values\nwhen Nil\n  false\nwhen String\n  includes_word_in_header_value?(word.downcase, values.downcase)\nelse\n  word = word.downcase\n  values.any? do |value|\n    includes_word_in_header_value?(word, value.downcase)\n  end\nend\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends this struct's name and instance variables names and values\nto the given IO.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np1.to_s    # \"Point(@x=1, @y=2)\"\np1.inspect # \"Point(@x=1, @y=2)\"\n```","summary":"<p>Appends this struct's name and instance variables names and values to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/http/headers.cr","line_number":280,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"merge!(other):self-instance-method","name":"merge!","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other) : self","args_html":"(other) : <span class=\"k\">self</span>","location":{"filename":"src/http/headers.cr","line_number":167,"url":null},"def":{"name":"merge!","args":[{"name":"other","external_name":"other","restriction":""}],"return_type":"self","visibility":"Public","body":"other.each do |key, value|\n  self[wrap(key)] = value\nend\nself\n"}},{"html_id":"pretty_print(pp)-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp)","args_html":"(pp)","location":{"filename":"src/http/headers.cr","line_number":284,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"visibility":"Public","body":"pp.list(\"HTTP::Headers{\", @hash.keys.sort_by(&.name), \"}\") do |key|\n  pp.group do\n    key.name.pretty_print(pp)\n    pp.text(\" =>\")\n    pp.nest do\n      pp.breakable\n      values = get(key)\n      if values.size == 1\n        values.first.pretty_print(pp)\n      else\n        values.pretty_print(pp)\n      end\n    end\n  end\nend"}},{"html_id":"same?(other:HTTP::Headers):Bool-instance-method","name":"same?","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"HTTP::Headers"}],"args_string":"(other : HTTP::Headers) : Bool","args_html":"(other : <a href=\"../HTTP/Headers.html\">HTTP::Headers</a>) : <a href=\"../Bool.html\">Bool</a>","location":{"filename":"src/http/headers.cr","line_number":256,"url":null},"def":{"name":"same?","args":[{"name":"other","external_name":"other","restriction":"HTTP::Headers"}],"return_type":"Bool","visibility":"Public","body":"object_id == other.object_id"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Same as `#inspect(io)`.","summary":"<p>Same as <code><a href=\"../HTTP/Headers.html#inspect%28io%3AIO%29%3ANil-instance-method\">#inspect(io)</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/http/headers.cr","line_number":260,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"HTTP::Headers{\"\n@hash.each_with_index do |__arg0, index|\n  key = __arg0[0]\n  values = __arg0[1]\n  if index > 0\n    io << \", \"\n  end\n  key.name.inspect(io)\n  io << \" => \"\n  case values\n  when Array\n    if values.size == 1\n      values.first.inspect(io)\n    else\n      values.inspect(io)\n    end\n  else\n    values.inspect(io)\n  end\nend\nio << '}'\n"}},{"html_id":"valid_value?(value):Bool-instance-method","name":"valid_value?","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : Bool","args_html":"(value) : <a href=\"../Bool.html\">Bool</a>","location":{"filename":"src/http/headers.cr","line_number":302,"url":null},"def":{"name":"valid_value?","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"Bool","visibility":"Public","body":"return invalid_value_char(value).nil?"}}],"macros":[{"html_id":"method_missing(call)-macro","name":"method_missing","abstract":false,"args":[{"name":"call","external_name":"call","restriction":""}],"args_string":"(call)","args_html":"(call)","location":{"filename":"src/http/headers.cr","line_number":306,"url":null},"def":{"name":"method_missing","args":[{"name":"call","external_name":"call","restriction":""}],"visibility":"Public","body":"      @hash.\n{{ call }}\n\n    \n"}}]},{"html_id":"Crystal/HTTP/LogHandler","path":"HTTP/LogHandler.html","kind":"class","full_name":"HTTP::LogHandler","name":"LogHandler","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/server/handlers/log_handler.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"}],"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"A handler that logs the request method, resource, status code, and\nthe time used to execute the next handler","summary":"<p>A handler that logs the request method, resource, status code, and the time used to execute the next handler</p>","constructors":[{"html_id":"new(log=Log.for(\"http.server\"))-class-method","name":"new","abstract":false,"args":[{"name":"log","default_value":"Log.for(\"http.server\")","external_name":"log","restriction":""}],"args_string":"(log = Log.for(\"http.server\"))","args_html":"(log = <span class=\"t\">Log</span>.<span class=\"k\">for</span>(<span class=\"s\">&quot;http.server&quot;</span>))","location":{"filename":"src/http/server/handlers/log_handler.cr","line_number":8,"url":null},"def":{"name":"new","args":[{"name":"log","default_value":"Log.for(\"http.server\")","external_name":"log","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(log)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"call(context):Nil-instance-method","name":"call","abstract":false,"args":[{"name":"context","external_name":"context","restriction":""}],"args_string":"(context) : Nil","args_html":"(context) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/http/server/handlers/log_handler.cr","line_number":11,"url":null},"def":{"name":"call","args":[{"name":"context","external_name":"context","restriction":""}],"return_type":"Nil","visibility":"Public","body":"start = Time.monotonic\nbegin\n  call_next(context)\nensure\n  elapsed = Time.monotonic - start\n  elapsed_text = elapsed_text(elapsed)\n  req = context.request\n  res = context.response\n  addr = case remote_address = req.remote_address\n  when nil\n    \"-\"\n  when Socket::IPAddress\n    remote_address.address\n  else\n    remote_address\n  end\n  @log.info do\n    \"#{addr} - #{req.method} #{req.resource} #{req.version} - #{res.status_code} (#{elapsed_text})\"\n  end\nend\n"}}]},{"html_id":"Crystal/HTTP/Params","path":"HTTP/Params.html","kind":"alias","full_name":"HTTP::Params","name":"Params","abstract":false,"locations":[{"filename":"src/http/params.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"URI::Params","aliased_html":"<a href=\"../URI/Params.html\">URI::Params</a>","const":false,"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"}},{"html_id":"Crystal/HTTP/Request","path":"HTTP/Request.html","kind":"class","full_name":"HTTP::Request","name":"Request","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/request.cr","line_number":15,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"An HTTP request.\n\nIt serves both to perform requests by an `HTTP::Client` and to\nrepresent requests received by an `HTTP::Server`.\n\nA request always holds an `IO` as a body.\nWhen creating a request with a `String` or `Bytes` its body\nwill be a `IO::Memory` wrapping these, and the `Content-Length`\nheader will be set appropriately.","summary":"<p>An HTTP request.</p>","class_methods":[{"html_id":"from_io(io,*,max_request_line_size:Int32=HTTP::MAX_REQUEST_LINE_SIZE,max_headers_size:Int32=HTTP::MAX_HEADERS_SIZE):HTTP::Request|HTTP::Status|Nil-class-method","name":"from_io","doc":"Returns a `HTTP::Request` instance if successfully parsed,\n`nil` on EOF or `HTTP::Status` otherwise.","summary":"<p>Returns a <code><a href=\"../HTTP/Request.html\">HTTP::Request</a></code> instance if successfully parsed, <code>nil</code> on EOF or <code><a href=\"../HTTP/Status.html\">HTTP::Status</a></code> otherwise.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"max_request_line_size","default_value":"HTTP::MAX_REQUEST_LINE_SIZE","external_name":"max_request_line_size","restriction":"Int32"},{"name":"max_headers_size","default_value":"HTTP::MAX_HEADERS_SIZE","external_name":"max_headers_size","restriction":"Int32"}],"args_string":"(io, *, max_request_line_size : Int32 = HTTP::MAX_REQUEST_LINE_SIZE, max_headers_size : Int32 = HTTP::MAX_HEADERS_SIZE) : HTTP::Request | HTTP::Status | Nil","args_html":"(io, *, max_request_line_size : <a href=\"../Int32.html\">Int32</a> = <span class=\"t\">HTTP</span><span class=\"t\">::</span><span class=\"t\">MAX_REQUEST_LINE_SIZE</span>, max_headers_size : <a href=\"../Int32.html\">Int32</a> = <span class=\"t\">HTTP</span><span class=\"t\">::</span><span class=\"t\">MAX_HEADERS_SIZE</span>) : <a href=\"../HTTP/Request.html\">HTTP::Request</a> | <a href=\"../HTTP/Status.html\">HTTP::Status</a> | <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/http/request.cr","line_number":131,"url":null},"def":{"name":"from_io","args":[{"name":"io","external_name":"io","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"max_request_line_size","default_value":"HTTP::MAX_REQUEST_LINE_SIZE","external_name":"max_request_line_size","restriction":"Int32"},{"name":"max_headers_size","default_value":"HTTP::MAX_HEADERS_SIZE","external_name":"max_headers_size","restriction":"Int32"}],"splat_index":1,"return_type":"HTTP::Request | HTTP::Status | Nil","visibility":"Public","body":"line = parse_request_line(io, max_request_line_size)\nif line.is_a?(RequestLine)\nelse\n  return line\nend\nstatus = HTTP.parse_headers_and_body(io, max_headers_size: max_headers_size) do |headers, body|\n  request = new(line.method, line.resource, headers, body, line.http_version, internal: nil)\n  if io.responds_to?(:remote_address)\n    request.remote_address = io.remote_address\n  end\n  if io.responds_to?(:local_address)\n    request.local_address = io.local_address\n  end\n  return request\nend\nstatus || HTTP::Status::BAD_REQUEST\n"}}],"constructors":[{"html_id":"new(method:String,resource:String,headers:Headers?=nil,body:String|Bytes|IO|Nil=nil,version=\"HTTP/1.1\")-class-method","name":"new","abstract":false,"args":[{"name":"method","external_name":"method","restriction":"String"},{"name":"resource","external_name":"resource","restriction":"String"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"String | Bytes | IO | Nil"},{"name":"version","default_value":"\"HTTP/1.1\"","external_name":"version","restriction":""}],"args_string":"(method : String, resource : String, headers : Headers? = nil, body : String | Bytes | IO | Nil = nil, version = \"HTTP/1.1\")","args_html":"(method : <a href=\"../String.html\">String</a>, resource : <a href=\"../String.html\">String</a>, headers : <a href=\"../HTTP/Headers.html\">Headers</a>? = <span class=\"n\">nil</span>, body : <a href=\"../String.html\">String</a> | <a href=\"../Bytes.html\">Bytes</a> | <a href=\"../IO.html\">IO</a> | <a href=\"../Nil.html\">Nil</a> = <span class=\"n\">nil</span>, version = <span class=\"s\">&quot;HTTP/1.1&quot;</span>)","location":{"filename":"src/http/request.cr","line_number":59,"url":null},"def":{"name":"new","args":[{"name":"method","external_name":"method","restriction":"String"},{"name":"resource","external_name":"resource","restriction":"String"},{"name":"headers","default_value":"nil","external_name":"headers","restriction":"Headers | ::Nil"},{"name":"body","default_value":"nil","external_name":"body","restriction":"String | Bytes | IO | Nil"},{"name":"version","default_value":"\"HTTP/1.1\"","external_name":"version","restriction":""}],"visibility":"Public","body":"new(method, resource, headers.try(&.dup), body, version, internal: nil)"}}],"instance_methods":[{"html_id":"body:IO?-instance-method","name":"body","abstract":false,"location":{"filename":"src/http/request.cr","line_number":18,"url":null},"def":{"name":"body","return_type":"IO | ::Nil","visibility":"Public","body":"@body"}},{"html_id":"body=(body:String)-instance-method","name":"body=","abstract":false,"args":[{"name":"body","external_name":"body","restriction":"String"}],"args_string":"(body : String)","args_html":"(body : <a href=\"../String.html\">String</a>)","location":{"filename":"src/http/request.cr","line_number":102,"url":null},"def":{"name":"body=","args":[{"name":"body","external_name":"body","restriction":"String"}],"visibility":"Public","body":"@body = IO::Memory.new(body)\nself.content_length = body.bytesize\n"}},{"html_id":"body=(body:Bytes)-instance-method","name":"body=","abstract":false,"args":[{"name":"body","external_name":"body","restriction":"Bytes"}],"args_string":"(body : Bytes)","args_html":"(body : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/http/request.cr","line_number":107,"url":null},"def":{"name":"body=","args":[{"name":"body","external_name":"body","restriction":"Bytes"}],"visibility":"Public","body":"@body = IO::Memory.new(body)\nself.content_length = body.size\n"}},{"html_id":"body=(body:IO)-instance-method","name":"body=","abstract":false,"args":[{"name":"body","external_name":"body","restriction":"IO"}],"args_string":"(body : IO)","args_html":"(body : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/http/request.cr","line_number":112,"url":null},"def":{"name":"body=","args":[{"name":"body","external_name":"body","restriction":"IO"}],"visibility":"Public","body":"@body = body"}},{"html_id":"body=(body:Nil)-instance-method","name":"body=","abstract":false,"args":[{"name":"body","external_name":"body","restriction":"Nil"}],"args_string":"(body : Nil)","args_html":"(body : <a href=\"../Nil.html\">Nil</a>)","location":{"filename":"src/http/request.cr","line_number":115,"url":null},"def":{"name":"body=","args":[{"name":"body","external_name":"body","restriction":"Nil"}],"visibility":"Public","body":"@body = body\nif (@method == \"POST\") || (@method == \"PUT\")\n  @headers[\"Content-Length\"] = \"0\"\nend\n"}},{"html_id":"content_length-instance-method","name":"content_length","abstract":false,"location":{"filename":"src/http/request.cr","line_number":98,"url":null},"def":{"name":"content_length","visibility":"Public","body":"HTTP.content_length(headers)"}},{"html_id":"content_length=(length:Int)-instance-method","name":"content_length=","abstract":false,"args":[{"name":"length","external_name":"length","restriction":"Int"}],"args_string":"(length : Int)","args_html":"(length : <a href=\"../Int.html\">Int</a>)","location":{"filename":"src/http/request.cr","line_number":94,"url":null},"def":{"name":"content_length=","args":[{"name":"length","external_name":"length","restriction":"Int"}],"visibility":"Public","body":"headers[\"Content-Length\"] = length.to_s"}},{"html_id":"cookies:HTTP::Cookies-instance-method","name":"cookies","doc":"Returns a convenience wrapper around querying and setting cookie related\nheaders, see `HTTP::Cookies`.","summary":"<p>Returns a convenience wrapper around querying and setting cookie related headers, see <code><a href=\"../HTTP/Cookies.html\">HTTP::Cookies</a></code>.</p>","abstract":false,"location":{"filename":"src/http/request.cr","line_number":71,"url":null},"def":{"name":"cookies","return_type":"HTTP::Cookies","visibility":"Public","body":"@cookies || (@cookies = Cookies.from_client_headers(headers))"}},{"html_id":"headers:Headers-instance-method","name":"headers","abstract":false,"location":{"filename":"src/http/request.cr","line_number":17,"url":null},"def":{"name":"headers","return_type":"Headers","visibility":"Public","body":"@headers"}},{"html_id":"headers=(headers:Headers)-instance-method","name":"headers=","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":"Headers"}],"args_string":"(headers : Headers)","args_html":"(headers : <a href=\"../HTTP/Headers.html\">Headers</a>)","location":{"filename":"src/http/request.cr","line_number":17,"url":null},"def":{"name":"headers=","args":[{"name":"headers","external_name":"headers","restriction":"Headers"}],"visibility":"Public","body":"@headers = headers"}},{"html_id":"host_with_port:String?-instance-method","name":"host_with_port","doc":"Returns request host with port from headers.","summary":"<p>Returns request host with port from headers.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code>headers[\"Host\"]?</code> instead.</p>","abstract":false,"location":{"filename":"src/http/request.cr","line_number":299,"url":null},"def":{"name":"host_with_port","return_type":"String | ::Nil","visibility":"Public","body":"@headers[\"Host\"]?"}},{"html_id":"hostname:String?-instance-method","name":"hostname","doc":"Extracts the hostname from `Host` header.\n\nReturns `nil` if the `Host` header is missing.\n\nIf the `Host` header contains a port number, it is stripped off.","summary":"<p>Extracts the hostname from <code>Host</code> header.</p>","abstract":false,"location":{"filename":"src/http/request.cr","line_number":278,"url":null},"def":{"name":"hostname","return_type":"String | ::Nil","visibility":"Public","body":"header = @headers[\"Host\"]?\nif header\nelse\n  return\nend\nhost, _, port = header.rpartition(\":\")\nif host.empty?\n  host = header\nelse\n  port = port.to_i?(whitespace: false)\n  if port && (Socket::IPAddress.valid_port?(port))\n  else\n    host = header\n  end\nend\nURI.unwrap_ipv6(host)\n"}},{"html_id":"if_match:Array(String)?-instance-method","name":"if_match","abstract":false,"location":{"filename":"src/http/request.cr","line_number":317,"url":null},"def":{"name":"if_match","return_type":"Array(String) | ::Nil","visibility":"Public","body":"parse_etags(\"If-Match\")"}},{"html_id":"if_none_match:Array(String)?-instance-method","name":"if_none_match","abstract":false,"location":{"filename":"src/http/request.cr","line_number":321,"url":null},"def":{"name":"if_none_match","return_type":"Array(String) | ::Nil","visibility":"Public","body":"parse_etags(\"If-None-Match\")"}},{"html_id":"ignore_body?:Bool-instance-method","name":"ignore_body?","abstract":false,"location":{"filename":"src/http/request.cr","line_number":90,"url":null},"def":{"name":"ignore_body?","return_type":"Bool","visibility":"Public","body":"@method == \"HEAD\""}},{"html_id":"keep_alive?:Bool-instance-method","name":"keep_alive?","abstract":false,"location":{"filename":"src/http/request.cr","line_number":86,"url":null},"def":{"name":"keep_alive?","return_type":"Bool","visibility":"Public","body":"HTTP.keep_alive?(self)"}},{"html_id":"local_address:Socket::Address?-instance-method","name":"local_address","doc":"The network address of the HTTP server.\n\n`HTTP::Server` will try to fill this property, and its value\nwill have a format like \"IP:port\", but this format is not guaranteed.\nMiddlewares can overwrite this value.\n\nThis property is not used by `HTTP::Client`.","summary":"<p>The network address of the HTTP server.</p>","abstract":false,"location":{"filename":"src/http/request.cr","line_number":57,"url":null},"def":{"name":"local_address","return_type":"Socket::Address | ::Nil","visibility":"Public","body":"@local_address"}},{"html_id":"local_address=(local_address:Socket::Address?)-instance-method","name":"local_address=","doc":"The network address of the HTTP server.\n\n`HTTP::Server` will try to fill this property, and its value\nwill have a format like \"IP:port\", but this format is not guaranteed.\nMiddlewares can overwrite this value.\n\nThis property is not used by `HTTP::Client`.","summary":"<p>The network address of the HTTP server.</p>","abstract":false,"args":[{"name":"local_address","external_name":"local_address","restriction":"Socket::Address | ::Nil"}],"args_string":"(local_address : Socket::Address?)","args_html":"(local_address : <a href=\"../Socket/Address.html\">Socket::Address</a>?)","location":{"filename":"src/http/request.cr","line_number":57,"url":null},"def":{"name":"local_address=","args":[{"name":"local_address","external_name":"local_address","restriction":"Socket::Address | ::Nil"}],"visibility":"Public","body":"@local_address = local_address"}},{"html_id":"method:String-instance-method","name":"method","abstract":false,"location":{"filename":"src/http/request.cr","line_number":16,"url":null},"def":{"name":"method","return_type":"String","visibility":"Public","body":"@method"}},{"html_id":"method=(method:String)-instance-method","name":"method=","abstract":false,"args":[{"name":"method","external_name":"method","restriction":"String"}],"args_string":"(method : String)","args_html":"(method : <a href=\"../String.html\">String</a>)","location":{"filename":"src/http/request.cr","line_number":16,"url":null},"def":{"name":"method=","args":[{"name":"method","external_name":"method","restriction":"String"}],"visibility":"Public","body":"@method = method"}},{"html_id":"path:String-instance-method","name":"path","doc":"Returns the request's path component.","summary":"<p>Returns the request's path component.</p>","abstract":false,"location":{"filename":"src/http/request.cr","line_number":251,"url":null},"def":{"name":"path","return_type":"String","visibility":"Public","body":"uri.path.presence || \"/\""}},{"html_id":"path=(path)-instance-method","name":"path=","doc":"Sets request's path component.","summary":"<p>Sets request's path component.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""}],"args_string":"(path)","args_html":"(path)","location":{"filename":"src/http/request.cr","line_number":256,"url":null},"def":{"name":"path=","args":[{"name":"path","external_name":"path","restriction":""}],"visibility":"Public","body":"uri.path = path"}},{"html_id":"query:String?-instance-method","name":"query","doc":"Lazily parses and returns the request's query component.","summary":"<p>Lazily parses and returns the request's query component.</p>","abstract":false,"location":{"filename":"src/http/request.cr","line_number":261,"url":null},"def":{"name":"query","return_type":"String | ::Nil","visibility":"Public","body":"update_uri\nuri.query\n"}},{"html_id":"query=(value)-instance-method","name":"query=","doc":"Sets request's query component.","summary":"<p>Sets request's query component.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/http/request.cr","line_number":267,"url":null},"def":{"name":"query=","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"uri.query = value\nupdate_query_params\nvalue\n"}},{"html_id":"query_params:URI::Params-instance-method","name":"query_params","doc":"Returns a convenience wrapper around querying and setting query params,\nsee `URI::Params`.","summary":"<p>Returns a convenience wrapper around querying and setting query params, see <code><a href=\"../URI/Params.html\">URI::Params</a></code>.</p>","abstract":false,"location":{"filename":"src/http/request.cr","line_number":77,"url":null},"def":{"name":"query_params","return_type":"URI::Params","visibility":"Public","body":"@query_params || (@query_params = uri.query_params)"}},{"html_id":"remote_address:Socket::Address?-instance-method","name":"remote_address","doc":"The network address that sent the request to an HTTP server.\n\n`HTTP::Server` will try to fill this property, and its value\nwill have a format like \"IP:port\", but this format is not guaranteed.\nMiddlewares can overwrite this value.\n\nExample:\n\n```\nclass ForwarderHandler\n  include HTTP::Handler\n\n  def call(context)\n    if ip = context.request.headers[\"X-Real-IP\"]? # When using a reverse proxy that guarantees this field.\n      context.request.remote_address = Socket::IPAddress.new(ip, 0)\n    end\n    call_next(context)\n  end\nend\n\nserver = HTTP::Server.new([ForwarderHandler.new, HTTP::LogHandler.new])\n```\n\nThis property is not used by `HTTP::Client`.","summary":"<p>The network address that sent the request to an HTTP server.</p>","abstract":false,"location":{"filename":"src/http/request.cr","line_number":48,"url":null},"def":{"name":"remote_address","return_type":"Socket::Address | ::Nil","visibility":"Public","body":"@remote_address"}},{"html_id":"remote_address=(remote_address:Socket::Address?)-instance-method","name":"remote_address=","doc":"The network address that sent the request to an HTTP server.\n\n`HTTP::Server` will try to fill this property, and its value\nwill have a format like \"IP:port\", but this format is not guaranteed.\nMiddlewares can overwrite this value.\n\nExample:\n\n```\nclass ForwarderHandler\n  include HTTP::Handler\n\n  def call(context)\n    if ip = context.request.headers[\"X-Real-IP\"]? # When using a reverse proxy that guarantees this field.\n      context.request.remote_address = Socket::IPAddress.new(ip, 0)\n    end\n    call_next(context)\n  end\nend\n\nserver = HTTP::Server.new([ForwarderHandler.new, HTTP::LogHandler.new])\n```\n\nThis property is not used by `HTTP::Client`.","summary":"<p>The network address that sent the request to an HTTP server.</p>","abstract":false,"args":[{"name":"remote_address","external_name":"remote_address","restriction":"Socket::Address | ::Nil"}],"args_string":"(remote_address : Socket::Address?)","args_html":"(remote_address : <a href=\"../Socket/Address.html\">Socket::Address</a>?)","location":{"filename":"src/http/request.cr","line_number":48,"url":null},"def":{"name":"remote_address=","args":[{"name":"remote_address","external_name":"remote_address","restriction":"Socket::Address | ::Nil"}],"visibility":"Public","body":"@remote_address = remote_address"}},{"html_id":"resource:String-instance-method","name":"resource","abstract":false,"location":{"filename":"src/http/request.cr","line_number":81,"url":null},"def":{"name":"resource","return_type":"String","visibility":"Public","body":"update_uri\n@uri.try(&.request_target) || @resource\n"}},{"html_id":"to_io(io)-instance-method","name":"to_io","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""}],"args_string":"(io)","args_html":"(io)","location":{"filename":"src/http/request.cr","line_number":119,"url":null},"def":{"name":"to_io","args":[{"name":"io","external_name":"io","restriction":""}],"visibility":"Public","body":"(((((io << @method) << ' ') << resource) << ' ') << @version) << \"\\r\\n\"\ncookies = @cookies\nheaders = cookies ? cookies.add_request_headers(@headers) : @headers\nHTTP.serialize_headers_and_body(io, headers, nil, @body, @version)\n"}},{"html_id":"version:String-instance-method","name":"version","abstract":false,"location":{"filename":"src/http/request.cr","line_number":19,"url":null},"def":{"name":"version","return_type":"String","visibility":"Public","body":"@version"}},{"html_id":"version=(version:String)-instance-method","name":"version=","abstract":false,"args":[{"name":"version","external_name":"version","restriction":"String"}],"args_string":"(version : String)","args_html":"(version : <a href=\"../String.html\">String</a>)","location":{"filename":"src/http/request.cr","line_number":19,"url":null},"def":{"name":"version=","args":[{"name":"version","external_name":"version","restriction":"String"}],"visibility":"Public","body":"@version = version"}}]},{"html_id":"Crystal/HTTP/Server","path":"HTTP/Server.html","kind":"class","full_name":"HTTP::Server","name":"Server","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/server.cr","line_number":131,"url":null},{"filename":"src/http/server/context.cr","line_number":4,"url":null},{"filename":"src/http/server/response.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"Log","name":"Log","value":"::Log.for(\"http.server\")"}],"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"A concurrent HTTP server implementation.\n\nA server is initialized with a handler chain responsible for processing each\nincoming request.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new do |context|\n  context.response.content_type = \"text/plain\"\n  context.response.print \"Hello world!\"\nend\n\naddress = server.bind_tcp 8080\nputs \"Listening on http://#{address}\"\nserver.listen\n```\n\n## Request processing\n\nThe handler chain receives an instance of `HTTP::Server::Context` that holds\nthe `HTTP::Request` to process and a `HTTP::Server::Response` which it can\nconfigure and write to.\n\nEach connection is processed concurrently in a separate `Fiber` and can handle\nmultiple subsequent requests-response cycles with connection keep-alive.\n\n### Handler chain\n\nThe handler given to a server can simply be a block that receives an `HTTP::Server::Context`,\nor it can be an instance of `HTTP::Handler`. An `HTTP::Handler` has a `#next`\nmethod to forward processing to the next handler in the chain.\n\nFor example, an initial handler might handle exceptions raised from subsequent\nhandlers and return a `500 Server Error` status (see `HTTP::ErrorHandler`).\nThe next handler might log all incoming requests (see `HTTP::LogHandler`).\nAnd the final handler deals with routing and application logic.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new([\n  HTTP::ErrorHandler.new,\n  HTTP::LogHandler.new,\n  HTTP::CompressHandler.new,\n  HTTP::StaticFileHandler.new(\".\"),\n])\n\nserver.bind_tcp \"127.0.0.1\", 8080\nserver.listen\n```\n\n### Response object\n\nThe `HTTP::Server::Response` object has `status` and `headers` properties that can be\nconfigured before writing the response body. Once any response output has been\nwritten, changing the `status` and `headers` properties has no effect.\n\nThe `HTTP::Server::Response` is a write-only `IO`, so all `IO` methods are available\non it for sending the response body.\n\n## Binding to sockets\n\nThe server can be bound to one or more server sockets (see `#bind`)\n\nSupported types:\n\n* TCP socket: `#bind_tcp`, `#bind_unused_port`\n* TCP socket with TLS/SSL: `#bind_tls`\n* Unix socket `#bind_unix`\n\n`#bind(uri : URI)` and `#bind(uri : String)` parse socket configuration for\none of these types from an `URI`. This can be useful for injecting plain text\nconfiguration values.\n\nEach of these methods returns the `Socket::Address` that was added to this\nserver.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new do |context|\n  context.response.content_type = \"text/plain\"\n  context.response.print \"Hello world!\"\nend\n\naddress = server.bind_tcp \"0.0.0.0\", 8080\nputs \"Listening on http://#{address}\"\nserver.listen\n```\n\nIt is also possible to bind a generic `Socket::Server` using\n`#bind(socket : Socket::Server)` which can be used for custom network protocol\nconfigurations.\n\n## Server loop\n\nAfter defining all server sockets to listen to, the server can be started by\ncalling `#listen`. This call blocks until the server is closed.\n\nA server can be closed by calling `#close`. This closes the server sockets and\nstops processing any new requests, even on connections with keep-alive enabled.\nCurrently processing requests are not interrupted but also not waited for.\nIn order to give them some grace period for finishing, the calling context\ncan add a timeout like `sleep 10.seconds` after `#listen` returns.\n\n### Reusing connections\n\nThe request processor supports reusing a connection for subsequent\nrequests. This is used by default for HTTP/1.1 or when requested by\nthe `Connection: keep-alive` header. This is signalled by this header being\nset on the `HTTP::Server::Response` when it's passed into the handler chain.\n\nIf in the handler chain this header is overridden to `Connection: close`, then\nthe connection will not be reused after the request has been processed.\n\nReusing the connection also requires that the request body (if present) is\nentirely consumed in the handler chain. Otherwise the connection will be closed.","summary":"<p>A concurrent HTTP server implementation.</p>","class_methods":[{"html_id":"build_middleware(handlers,last_handler:Context->?=nil)-class-method","name":"build_middleware","doc":"Builds all handlers as the middleware for `HTTP::Server`.","summary":"<p>Builds all handlers as the middleware for <code><a href=\"../HTTP/Server.html\">HTTP::Server</a></code>.</p>","abstract":false,"args":[{"name":"handlers","external_name":"handlers","restriction":""},{"name":"last_handler","default_value":"nil","external_name":"last_handler","restriction":"(Context ->) | ::Nil"}],"args_string":"(handlers, last_handler : Context -> ? = nil)","args_html":"(handlers, last_handler : <a href=\"../HTTP/Server/Context.html\">Context</a> -> ? = <span class=\"n\">nil</span>)","location":{"filename":"src/http/server.cr","line_number":534,"url":null},"def":{"name":"build_middleware","args":[{"name":"handlers","external_name":"handlers","restriction":""},{"name":"last_handler","default_value":"nil","external_name":"last_handler","restriction":"(Context ->) | ::Nil"}],"visibility":"Public","body":"if handlers.empty?\n  raise(ArgumentError.new(\"You must specify at least one HTTP Handler.\"))\nend\n0.upto(handlers.size - 2) do |i|\n  handlers[i].next = handlers[i + 1]\nend\nif last_handler\n  handlers.last.next = last_handler\nend\nhandlers.first\n"}}],"constructors":[{"html_id":"new(handlers:Array(HTTP::Handler),&handler:HTTP::Handler::HandlerProc):self-class-method","name":"new","doc":"Creates a new HTTP server with a handler chain constructed from the *handlers*\narray and the given block.","summary":"<p>Creates a new HTTP server with a handler chain constructed from the <em>handlers</em> array and the given block.</p>","abstract":false,"args":[{"name":"handlers","external_name":"handlers","restriction":"Array(HTTP::Handler)"}],"args_string":"(handlers : Array(HTTP::Handler), &handler : HTTP::Handler::HandlerProc) : self","args_html":"(handlers : <a href=\"../Array.html\">Array</a>(<a href=\"../HTTP/Handler.html\">HTTP::Handler</a>), &handler : <a href=\"../HTTP/Handler/HandlerProc.html\">HTTP::Handler::HandlerProc</a>) : <span class=\"k\">self</span>","location":{"filename":"src/http/server.cr","line_number":149,"url":null},"def":{"name":"new","args":[{"name":"handlers","external_name":"handlers","restriction":"Array(HTTP::Handler)"}],"yields":0,"block_arg":{"name":"handler","external_name":"handler","restriction":"HTTP::Handler::HandlerProc"},"return_type":"self","visibility":"Public","body":"new(HTTP::Server.build_middleware(handlers, handler))"}},{"html_id":"new(&handler:HTTP::Handler::HandlerProc):self-class-method","name":"new","doc":"Creates a new HTTP server with the given block as handler.","summary":"<p>Creates a new HTTP server with the given block as handler.</p>","abstract":false,"location":{"filename":"src/http/server.cr","line_number":143,"url":null},"def":{"name":"new","yields":0,"block_arg":{"name":"handler","external_name":"handler","restriction":"HTTP::Handler::HandlerProc"},"return_type":"self","visibility":"Public","body":"new(handler)"}},{"html_id":"new(handlers:Array(HTTP::Handler)):self-class-method","name":"new","doc":"Creates a new HTTP server with the *handlers* array as handler chain.","summary":"<p>Creates a new HTTP server with the <em>handlers</em> array as handler chain.</p>","abstract":false,"args":[{"name":"handlers","external_name":"handlers","restriction":"Array(HTTP::Handler)"}],"args_string":"(handlers : Array(HTTP::Handler)) : self","args_html":"(handlers : <a href=\"../Array.html\">Array</a>(<a href=\"../HTTP/Handler.html\">HTTP::Handler</a>)) : <span class=\"k\">self</span>","location":{"filename":"src/http/server.cr","line_number":154,"url":null},"def":{"name":"new","args":[{"name":"handlers","external_name":"handlers","restriction":"Array(HTTP::Handler)"}],"return_type":"self","visibility":"Public","body":"new(HTTP::Server.build_middleware(handlers))"}},{"html_id":"new(handler:HTTP::Handler|HTTP::Handler::HandlerProc)-class-method","name":"new","doc":"Creates a new HTTP server with the given *handler*.","summary":"<p>Creates a new HTTP server with the given <em>handler</em>.</p>","abstract":false,"args":[{"name":"handler","external_name":"handler","restriction":"HTTP::Handler | HTTP::Handler::HandlerProc"}],"args_string":"(handler : HTTP::Handler | HTTP::Handler::HandlerProc)","args_html":"(handler : <a href=\"../HTTP/Handler.html\">HTTP::Handler</a> | <a href=\"../HTTP/Handler/HandlerProc.html\">HTTP::Handler::HandlerProc</a>)","location":{"filename":"src/http/server.cr","line_number":159,"url":null},"def":{"name":"new","args":[{"name":"handler","external_name":"handler","restriction":"HTTP::Handler | HTTP::Handler::HandlerProc"}],"visibility":"Public","body":"_ = allocate\n_.initialize(handler)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"addresses:Array(Socket::Address)-instance-method","name":"addresses","abstract":false,"location":{"filename":"src/http/server.cr","line_number":418,"url":null},"def":{"name":"addresses","return_type":"Array(Socket::Address)","visibility":"Public","body":"array = [] of Socket::Address\neach_address do |address|\n  array << address\nend\narray\n"}},{"html_id":"bind(uri:String):Socket::Address-instance-method","name":"bind","doc":"Parses a socket configuration from *uri* and adds it to this server.\nReturns the effective address it is bound to.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new { }\nserver.bind(\"tcp://localhost:80\")                                                  # => Socket::IPAddress.new(\"127.0.0.1\", 8080)\nserver.bind(\"unix:///tmp/server.sock\")                                             # => Socket::UNIXAddress.new(\"/tmp/server.sock\")\nserver.bind(\"tls://127.0.0.1:443?key=private.key&cert=certificate.cert&ca=ca.crt\") # => Socket::IPAddress.new(\"127.0.0.1\", 443)\n```","summary":"<p>Parses a socket configuration from <em>uri</em> and adds it to this server.</p>","abstract":false,"args":[{"name":"uri","external_name":"uri","restriction":"String"}],"args_string":"(uri : String) : Socket::Address","args_html":"(uri : <a href=\"../String.html\">String</a>) : <a href=\"../Socket/Address.html\">Socket::Address</a>","location":{"filename":"src/http/server.cr","line_number":378,"url":null},"def":{"name":"bind","args":[{"name":"uri","external_name":"uri","restriction":"String"}],"return_type":"Socket::Address","visibility":"Public","body":"bind(URI.parse(uri))"}},{"html_id":"bind(uri:URI):Socket::Address-instance-method","name":"bind","doc":"Parses a socket configuration from *uri* and adds it to this server.\nReturns the effective address it is bound to.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new { }\nserver.bind(\"tcp://localhost:80\")                                                  # => Socket::IPAddress.new(\"127.0.0.1\", 8080)\nserver.bind(\"unix:///tmp/server.sock\")                                             # => Socket::UNIXAddress.new(\"/tmp/server.sock\")\nserver.bind(\"tls://127.0.0.1:443?key=private.key&cert=certificate.cert&ca=ca.crt\") # => Socket::IPAddress.new(\"127.0.0.1\", 443)\n```","summary":"<p>Parses a socket configuration from <em>uri</em> and adds it to this server.</p>","abstract":false,"args":[{"name":"uri","external_name":"uri","restriction":"URI"}],"args_string":"(uri : URI) : Socket::Address","args_html":"(uri : <a href=\"../URI.html\">URI</a>) : <a href=\"../Socket/Address.html\">Socket::Address</a>","location":{"filename":"src/http/server.cr","line_number":383,"url":null},"def":{"name":"bind","args":[{"name":"uri","external_name":"uri","restriction":"URI"}],"return_type":"Socket::Address","visibility":"Public","body":"case uri.scheme\nwhen \"tcp\"\n  bind_tcp(Socket::IPAddress.parse(uri))\nwhen \"unix\"\n  bind_unix(Socket::UNIXAddress.parse(uri))\nwhen \"tls\", \"ssl\"\n  address = Socket::IPAddress.parse(uri)\n  {% if flag?(:without_openssl) %}\n        raise ArgumentError.new \"Unsupported socket type: #{uri.scheme} (program was compiled without openssl support)\"\n      {% else %}\n        context = OpenSSL::SSL::Context::Server.from_hash(uri.query_params)\n\n        bind_tls(address, context)\n      {% end %}\nelse\n  raise(ArgumentError.new(\"Unsupported socket type: #{uri.scheme}\"))\nend"}},{"html_id":"bind(socket:Socket::Server):Nil-instance-method","name":"bind","doc":"Adds a `Socket::Server` *socket* to this server.","summary":"<p>Adds a <code><a href=\"../Socket/Server.html\">Socket::Server</a></code> <em>socket</em> to this server.</p>","abstract":false,"args":[{"name":"socket","external_name":"socket","restriction":"Socket::Server"}],"args_string":"(socket : Socket::Server) : Nil","args_html":"(socket : <a href=\"../Socket/Server.html\">Socket::Server</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/http/server.cr","line_number":404,"url":null},"def":{"name":"bind","args":[{"name":"socket","external_name":"socket","restriction":"Socket::Server"}],"return_type":"Nil","visibility":"Public","body":"if listening?\n  raise(\"Can't add socket to running server\")\nend\nif closed?\n  raise(\"Can't add socket to closed server\")\nend\n@sockets << socket\n"}},{"html_id":"bind_tcp(host:String,port:Int32,reuse_port:Bool=false):Socket::IPAddress-instance-method","name":"bind_tcp","doc":"Creates a `TCPServer` listening on `host:port` and adds it as a socket, returning the local address\nand port the server listens on.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new { }\nserver.bind_tcp(\"127.0.0.100\", 8080) # => Socket::IPAddress.new(\"127.0.0.100\", 8080)\n```\n\nIf *reuse_port* is `true`, it enables the `SO_REUSEPORT` socket option,\nwhich allows multiple processes to bind to the same port.","summary":"<p>Creates a <code><a href=\"../TCPServer.html\">TCPServer</a></code> listening on <code>host:port</code> and adds it as a socket, returning the local address and port the server listens on.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int32"},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"args_string":"(host : String, port : Int32, reuse_port : Bool = false) : Socket::IPAddress","args_html":"(host : <a href=\"../String.html\">String</a>, port : <a href=\"../Int32.html\">Int32</a>, reuse_port : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"../Socket/IPAddress.html\">Socket::IPAddress</a>","location":{"filename":"src/http/server.cr","line_number":210,"url":null},"def":{"name":"bind_tcp","args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int32"},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"return_type":"Socket::IPAddress","visibility":"Public","body":"tcp_server = TCPServer.new(host, port, reuse_port: reuse_port)\nbegin\n  bind(tcp_server)\nrescue exc\n  tcp_server.close\n  raise(exc)\nend\ntcp_server.local_address\n"}},{"html_id":"bind_tcp(port:Int32,reuse_port:Bool=false):Socket::IPAddress-instance-method","name":"bind_tcp","doc":"Creates a `TCPServer` listening on `127.0.0.1:port` and adds it as a socket,\nreturning the local address and port the server listens on.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new { }\nserver.bind_tcp(8080) # => Socket::IPAddress.new(\"127.0.0.1\", 8080)\n```\n\nIf *reuse_port* is `true`, it enables the `SO_REUSEPORT` socket option,\nwhich allows multiple processes to bind to the same port.","summary":"<p>Creates a <code><a href=\"../TCPServer.html\">TCPServer</a></code> listening on <code>127.0.0.1:port</code> and adds it as a socket, returning the local address and port the server listens on.</p>","abstract":false,"args":[{"name":"port","external_name":"port","restriction":"Int32"},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"args_string":"(port : Int32, reuse_port : Bool = false) : Socket::IPAddress","args_html":"(port : <a href=\"../Int32.html\">Int32</a>, reuse_port : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"../Socket/IPAddress.html\">Socket::IPAddress</a>","location":{"filename":"src/http/server.cr","line_number":235,"url":null},"def":{"name":"bind_tcp","args":[{"name":"port","external_name":"port","restriction":"Int32"},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"return_type":"Socket::IPAddress","visibility":"Public","body":"bind_tcp(Socket::IPAddress::LOOPBACK, port, reuse_port)"}},{"html_id":"bind_tcp(address:Socket::IPAddress,reuse_port:Bool=false):Socket::IPAddress-instance-method","name":"bind_tcp","doc":"Creates a `TCPServer` listening on *address* and adds it as a socket, returning the local address\nand port the server listens on.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new { }\nserver.bind_tcp(Socket::IPAddress.new(\"127.0.0.100\", 8080)) # => Socket::IPAddress.new(\"127.0.0.100\", 8080)\nserver.bind_tcp(Socket::IPAddress.new(\"127.0.0.100\", 0))    # => Socket::IPAddress.new(\"127.0.0.100\", 35487)\n```\n\nIf *reuse_port* is `true`, it enables the `SO_REUSEPORT` socket option,\nwhich allows multiple processes to bind to the same port.","summary":"<p>Creates a <code><a href=\"../TCPServer.html\">TCPServer</a></code> listening on <em>address</em> and adds it as a socket, returning the local address and port the server listens on.</p>","abstract":false,"args":[{"name":"address","external_name":"address","restriction":"Socket::IPAddress"},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"args_string":"(address : Socket::IPAddress, reuse_port : Bool = false) : Socket::IPAddress","args_html":"(address : <a href=\"../Socket/IPAddress.html\">Socket::IPAddress</a>, reuse_port : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"../Socket/IPAddress.html\">Socket::IPAddress</a>","location":{"filename":"src/http/server.cr","line_number":252,"url":null},"def":{"name":"bind_tcp","args":[{"name":"address","external_name":"address","restriction":"Socket::IPAddress"},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"return_type":"Socket::IPAddress","visibility":"Public","body":"bind_tcp(address.address, address.port, reuse_port: reuse_port)"}},{"html_id":"bind_tls(host:String,port:Int32,context:OpenSSL::SSL::Context::Server,reuse_port:Bool=false):Socket::IPAddress-instance-method","name":"bind_tls","doc":"Creates an `OpenSSL::SSL::Server` and adds it as a socket.\n\nThe SSL server wraps a `TCPServer` listening on `host:port`.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new { }\ncontext = OpenSSL::SSL::Context::Server.new\ncontext.certificate_chain = \"openssl.crt\"\ncontext.private_key = \"openssl.key\"\nserver.bind_tls \"127.0.0.1\", 8080, context\n```","summary":"<p>Creates an <code><a href=\"../OpenSSL/SSL/Server.html\">OpenSSL::SSL::Server</a></code> and adds it as a socket.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int32"},{"name":"context","external_name":"context","restriction":"OpenSSL::SSL::Context::Server"},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"args_string":"(host : String, port : Int32, context : OpenSSL::SSL::Context::Server, reuse_port : Bool = false) : Socket::IPAddress","args_html":"(host : <a href=\"../String.html\">String</a>, port : <a href=\"../Int32.html\">Int32</a>, context : <a href=\"../OpenSSL/SSL/Context/Server.html\">OpenSSL::SSL::Context::Server</a>, reuse_port : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"../Socket/IPAddress.html\">Socket::IPAddress</a>","location":{"filename":"src/http/server.cr","line_number":303,"url":null},"def":{"name":"bind_tls","args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int32"},{"name":"context","external_name":"context","restriction":"OpenSSL::SSL::Context::Server"},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"return_type":"Socket::IPAddress","visibility":"Public","body":"tcp_server = TCPServer.new(host, port, reuse_port: reuse_port)\nserver = OpenSSL::SSL::Server.new(tcp_server, context)\nserver.start_immediately = false\nbegin\n  bind(server)\nrescue exc\n  server.close\n  raise(exc)\nend\ntcp_server.local_address\n"}},{"html_id":"bind_tls(host:String,context:OpenSSL::SSL::Context::Server):Socket::IPAddress-instance-method","name":"bind_tls","doc":"Creates an `OpenSSL::SSL::Server` and adds it as a socket.\n\nThe SSL server wraps a `TCPServer` listening on an unused port on *host*.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new { }\ncontext = OpenSSL::SSL::Context::Server.new\ncontext.certificate_chain = \"openssl.crt\"\ncontext.private_key = \"openssl.key\"\naddress = server.bind_tls \"127.0.0.1\", context\n```","summary":"<p>Creates an <code><a href=\"../OpenSSL/SSL/Server.html\">OpenSSL::SSL::Server</a></code> and adds it as a socket.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"context","external_name":"context","restriction":"OpenSSL::SSL::Context::Server"}],"args_string":"(host : String, context : OpenSSL::SSL::Context::Server) : Socket::IPAddress","args_html":"(host : <a href=\"../String.html\">String</a>, context : <a href=\"../OpenSSL/SSL/Context/Server.html\">OpenSSL::SSL::Context::Server</a>) : <a href=\"../Socket/IPAddress.html\">Socket::IPAddress</a>","location":{"filename":"src/http/server.cr","line_number":303,"url":null},"def":{"name":"bind_tls","args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"context","external_name":"context","restriction":"OpenSSL::SSL::Context::Server"}],"return_type":"Socket::IPAddress","visibility":"Public","body":"bind_tls(host, 0, context)"}},{"html_id":"bind_tls(address:Socket::IPAddress,context:OpenSSL::SSL::Context::Server):Socket::IPAddress-instance-method","name":"bind_tls","doc":"Creates an `OpenSSL::SSL::Server` and adds it as a socket.\n\nThe SSL server wraps a `TCPServer` listening on an unused port on *host*.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new { }\ncontext = OpenSSL::SSL::Context::Server.new\ncontext.certificate_chain = \"openssl.crt\"\ncontext.private_key = \"openssl.key\"\naddress = server.bind_tls Socket::IPAddress.new(\"127.0.0.1\", 8000), context\n```","summary":"<p>Creates an <code><a href=\"../OpenSSL/SSL/Server.html\">OpenSSL::SSL::Server</a></code> and adds it as a socket.</p>","abstract":false,"args":[{"name":"address","external_name":"address","restriction":"Socket::IPAddress"},{"name":"context","external_name":"context","restriction":"OpenSSL::SSL::Context::Server"}],"args_string":"(address : Socket::IPAddress, context : OpenSSL::SSL::Context::Server) : Socket::IPAddress","args_html":"(address : <a href=\"../Socket/IPAddress.html\">Socket::IPAddress</a>, context : <a href=\"../OpenSSL/SSL/Context/Server.html\">OpenSSL::SSL::Context::Server</a>) : <a href=\"../Socket/IPAddress.html\">Socket::IPAddress</a>","location":{"filename":"src/http/server.cr","line_number":303,"url":null},"def":{"name":"bind_tls","args":[{"name":"address","external_name":"address","restriction":"Socket::IPAddress"},{"name":"context","external_name":"context","restriction":"OpenSSL::SSL::Context::Server"}],"return_type":"Socket::IPAddress","visibility":"Public","body":"bind_tls(address.address, address.port, context)"}},{"html_id":"bind_unix(path:String):Socket::UNIXAddress-instance-method","name":"bind_unix","doc":"Creates a `UNIXServer` bound to *path* and adds it as a socket.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new { }\nserver.bind_unix \"/tmp/my-socket.sock\"\n```","summary":"<p>Creates a <code><a href=\"../UNIXServer.html\">UNIXServer</a></code> bound to <em>path</em> and adds it as a socket.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"String"}],"args_string":"(path : String) : Socket::UNIXAddress","args_html":"(path : <a href=\"../String.html\">String</a>) : <a href=\"../Socket/UNIXAddress.html\">Socket::UNIXAddress</a>","location":{"filename":"src/http/server.cr","line_number":278,"url":null},"def":{"name":"bind_unix","args":[{"name":"path","external_name":"path","restriction":"String"}],"return_type":"Socket::UNIXAddress","visibility":"Public","body":"server = UNIXServer.new(path)\nbegin\n  bind(server)\nrescue exc\n  server.close\n  raise(exc)\nend\nserver.local_address\n"}},{"html_id":"bind_unix(address:Socket::UNIXAddress):Socket::UNIXAddress-instance-method","name":"bind_unix","doc":"Creates a `UNIXServer` bound to *address* and adds it as a socket.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new { }\nserver.bind_unix(Socket::UNIXAddress.new(\"/tmp/my-socket.sock\"))\n```","summary":"<p>Creates a <code><a href=\"../UNIXServer.html\">UNIXServer</a></code> bound to <em>address</em> and adds it as a socket.</p>","abstract":false,"args":[{"name":"address","external_name":"address","restriction":"Socket::UNIXAddress"}],"args_string":"(address : Socket::UNIXAddress) : Socket::UNIXAddress","args_html":"(address : <a href=\"../Socket/UNIXAddress.html\">Socket::UNIXAddress</a>) : <a href=\"../Socket/UNIXAddress.html\">Socket::UNIXAddress</a>","location":{"filename":"src/http/server.cr","line_number":299,"url":null},"def":{"name":"bind_unix","args":[{"name":"address","external_name":"address","restriction":"Socket::UNIXAddress"}],"return_type":"Socket::UNIXAddress","visibility":"Public","body":"bind_unix(address.path)"}},{"html_id":"bind_unused_port(host:String=Socket::IPAddress::LOOPBACK,reuse_port:Bool=false):Socket::IPAddress-instance-method","name":"bind_unused_port","doc":"Creates a `TCPServer` listening on an unused port and adds it as a socket.\n\nReturns the `Socket::IPAddress` with the determined port number.\n\n```\nrequire \"http/server\"\n\nserver = HTTP::Server.new { }\nserver.bind_unused_port # => Socket::IPAddress.new(\"127.0.0.1\", 12345)\n```","summary":"<p>Creates a <code><a href=\"../TCPServer.html\">TCPServer</a></code> listening on an unused port and adds it as a socket.</p>","abstract":false,"args":[{"name":"host","default_value":"Socket::IPAddress::LOOPBACK","external_name":"host","restriction":"String"},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"args_string":"(host : String = Socket::IPAddress::LOOPBACK, reuse_port : Bool = false) : Socket::IPAddress","args_html":"(host : <a href=\"../String.html\">String</a> = <span class=\"t\">Socket</span><span class=\"t\">::</span><span class=\"t\">IPAddress</span><span class=\"t\">::</span><span class=\"t\">LOOPBACK</span>, reuse_port : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"../Socket/IPAddress.html\">Socket::IPAddress</a>","location":{"filename":"src/http/server.cr","line_number":266,"url":null},"def":{"name":"bind_unused_port","args":[{"name":"host","default_value":"Socket::IPAddress::LOOPBACK","external_name":"host","restriction":"String"},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"return_type":"Socket::IPAddress","visibility":"Public","body":"bind_tcp(host, 0, reuse_port)"}},{"html_id":"close:Nil-instance-method","name":"close","doc":"Gracefully terminates the server. It will process currently accepted\nrequests, but it won't accept new connections.","summary":"<p>Gracefully terminates the server.</p>","abstract":false,"location":{"filename":"src/http/server.cr","line_number":483,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"if closed?\n  raise(\"Can't close server, it's already closed\")\nend\n@closed = true\n@processor.close\n@sockets.each do |socket|\n  begin\n    socket.close\n  rescue\n  end\nend\n@listening = false\n@sockets.clear\n"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this server is closed.","summary":"<p>Returns <code>true</code> if this server is closed.</p>","abstract":false,"location":{"filename":"src/http/server.cr","line_number":137,"url":null},"def":{"name":"closed?","return_type":"Bool","visibility":"Public","body":"@closed"}},{"html_id":"each_address(&block:Socket::Address->)-instance-method","name":"each_address","doc":"Enumerates all addresses this server is bound to.","summary":"<p>Enumerates all addresses this server is bound to.</p>","abstract":false,"location":{"filename":"src/http/server.cr","line_number":412,"url":null},"def":{"name":"each_address","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(Socket::Address ->)"},"visibility":"Public","body":"@sockets.each do |socket|\n  yield socket.local_address\nend"}},{"html_id":"listen(port:Int32,reuse_port:Bool=false)-instance-method","name":"listen","doc":"Creates a `TCPServer` listening on `127.0.0.1:port`, adds it as a socket\nand starts the server. Blocks until the server is closed.\n\nSee `#bind(port : Int32)` for details.","summary":"<p>Creates a <code><a href=\"../TCPServer.html\">TCPServer</a></code> listening on <code>127.0.0.1:port</code>, adds it as a socket and starts the server.</p>","abstract":false,"args":[{"name":"port","external_name":"port","restriction":"Int32"},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"args_string":"(port : Int32, reuse_port : Bool = false)","args_html":"(port : <a href=\"../Int32.html\">Int32</a>, reuse_port : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>)","location":{"filename":"src/http/server.cr","line_number":430,"url":null},"def":{"name":"listen","args":[{"name":"port","external_name":"port","restriction":"Int32"},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"visibility":"Public","body":"bind_tcp(port, reuse_port)\nlisten\n"}},{"html_id":"listen(host:String,port:Int32,reuse_port:Bool=false)-instance-method","name":"listen","doc":"Creates a `TCPServer` listening on `host:port`, adds it as a socket\nand starts the server. Blocks until the server is closed.\n\nSee `#bind(host : String, port : Int32)` for details.","summary":"<p>Creates a <code><a href=\"../TCPServer.html\">TCPServer</a></code> listening on <code>host:port</code>, adds it as a socket and starts the server.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int32"},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"args_string":"(host : String, port : Int32, reuse_port : Bool = false)","args_html":"(host : <a href=\"../String.html\">String</a>, port : <a href=\"../Int32.html\">Int32</a>, reuse_port : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>)","location":{"filename":"src/http/server.cr","line_number":440,"url":null},"def":{"name":"listen","args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int32"},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"visibility":"Public","body":"bind_tcp(host, port, reuse_port)\nlisten\n"}},{"html_id":"listen:Nil-instance-method","name":"listen","doc":"Starts the server. Blocks until the server is closed.","summary":"<p>Starts the server.</p>","abstract":false,"location":{"filename":"src/http/server.cr","line_number":447,"url":null},"def":{"name":"listen","return_type":"Nil","visibility":"Public","body":"if closed?\n  raise(\"Can't re-start closed server\")\nend\nif @sockets.empty?\n  raise(\"Can't start server with no sockets to listen to, use HTTP::Server#bind first\")\nend\nif listening?\n  raise(\"Can't start running server\")\nend\n@listening = true\ndone = Channel(Nil).new\n@sockets.each do |socket|\n  spawn do\n    begin\n      loop do\n        io = begin\n          socket.accept?\n        rescue e\n          handle_exception(e)\n          next\n        end\n        if io\n          _io = io\n          spawn(handle_client(_io))\n        else\n          break\n        end\n      end\n    ensure\n      done.send(nil)\n    end\n  end\nend\n@sockets.size.times do\n  done.receive\nend\n"}},{"html_id":"listening?:Bool-instance-method","name":"listening?","doc":"Returns `true` if this server is listening on its sockets.","summary":"<p>Returns <code>true</code> if this server is listening on its sockets.</p>","abstract":false,"location":{"filename":"src/http/server.cr","line_number":140,"url":null},"def":{"name":"listening?","return_type":"Bool","visibility":"Public","body":"@listening"}},{"html_id":"max_headers_size:Int32-instance-method","name":"max_headers_size","doc":"Returns the maximum permitted combined size for the headers in an HTTP request.\n\nWhen parsing a request, the server keeps track of the amount of total bytes\nconsumed for all headers (including line breaks).\nIf combined byte size of all headers is larger than the permitted size,\nthe server responds with the status code `432 Request Header Fields Too Large`\n(see `HTTP::Status::REQUEST_HEADER_FIELDS_TOO_LARGE`).\n\nDefault: `HTTP::MAX_HEADERS_SIZE`","summary":"<p>Returns the maximum permitted combined size for the headers in an HTTP request.</p>","abstract":false,"location":{"filename":"src/http/server.cr","line_number":189,"url":null},"def":{"name":"max_headers_size","return_type":"Int32","visibility":"Public","body":"@processor.max_headers_size"}},{"html_id":"max_headers_size=(size:Int32)-instance-method","name":"max_headers_size=","doc":"Sets the maximum permitted combined size for the headers in an HTTP request.","summary":"<p>Sets the maximum permitted combined size for the headers in an HTTP request.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int32"}],"args_string":"(size : Int32)","args_html":"(size : <a href=\"../Int32.html\">Int32</a>)","location":{"filename":"src/http/server.cr","line_number":194,"url":null},"def":{"name":"max_headers_size=","args":[{"name":"size","external_name":"size","restriction":"Int32"}],"visibility":"Public","body":"@processor.max_headers_size = size"}},{"html_id":"max_request_line_size:Int32-instance-method","name":"max_request_line_size","doc":"Returns the maximum permitted size for the request line in an HTTP request.\n\nThe request line is the first line of a request, consisting of method,\nresource and HTTP version and the delimiting line break.\nIf the request line has a larger byte size than the permitted size,\nthe server responds with the status code `414 URI Too Long` (see `HTTP::Status::URI_TOO_LONG`).\n\nDefault: `HTTP::MAX_REQUEST_LINE_SIZE`","summary":"<p>Returns the maximum permitted size for the request line in an HTTP request.</p>","abstract":false,"location":{"filename":"src/http/server.cr","line_number":171,"url":null},"def":{"name":"max_request_line_size","return_type":"Int32","visibility":"Public","body":"@processor.max_request_line_size"}},{"html_id":"max_request_line_size=(size:Int32)-instance-method","name":"max_request_line_size=","doc":"Sets the maximum permitted size for the request line in an HTTP request.","summary":"<p>Sets the maximum permitted size for the request line in an HTTP request.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int32"}],"args_string":"(size : Int32)","args_html":"(size : <a href=\"../Int32.html\">Int32</a>)","location":{"filename":"src/http/server.cr","line_number":176,"url":null},"def":{"name":"max_request_line_size=","args":[{"name":"size","external_name":"size","restriction":"Int32"}],"visibility":"Public","body":"@processor.max_request_line_size = size"}}],"types":[{"html_id":"Crystal/HTTP/Server/ClientError","path":"HTTP/Server/ClientError.html","kind":"class","full_name":"HTTP::Server::ClientError","name":"ClientError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/server/response.cr","line_number":293,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/HTTP/Server","kind":"class","full_name":"HTTP::Server","name":"Server"}},{"html_id":"Crystal/HTTP/Server/Context","path":"HTTP/Server/Context.html","kind":"class","full_name":"HTTP::Server::Context","name":"Context","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/server/context.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/HTTP/Server","kind":"class","full_name":"HTTP::Server","name":"Server"},"doc":"Instances of this class are passed to an `HTTP::Server` handler.","summary":"<p>Instances of this class are passed to an <code><a href=\"../../HTTP/Server.html\">HTTP::Server</a></code> handler.</p>","instance_methods":[{"html_id":"request:Request-instance-method","name":"request","doc":"The `HTTP::Request` to process.","summary":"<p>The <code><a href=\"../../HTTP/Request.html\">HTTP::Request</a></code> to process.</p>","abstract":false,"location":{"filename":"src/http/server/context.cr","line_number":8,"url":null},"def":{"name":"request","return_type":"Request","visibility":"Public","body":"@request"}},{"html_id":"response:Response-instance-method","name":"response","doc":"The `HTTP::Server::Response` to configure and write to.","summary":"<p>The <code><a href=\"../../HTTP/Server/Response.html\">HTTP::Server::Response</a></code> to configure and write to.</p>","abstract":false,"location":{"filename":"src/http/server/context.cr","line_number":11,"url":null},"def":{"name":"response","return_type":"Response","visibility":"Public","body":"@response"}}]},{"html_id":"Crystal/HTTP/Server/RequestProcessor","path":"HTTP/Server/RequestProcessor.html","kind":"class","full_name":"HTTP::Server::RequestProcessor","name":"RequestProcessor","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/server/request_processor.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"Log","name":"Log","value":"::Log.for(\"http.server\")"}],"namespace":{"html_id":"Crystal/HTTP/Server","kind":"class","full_name":"HTTP::Server","name":"Server"},"constructors":[{"html_id":"new(&handler:HTTP::Handler::HandlerProc)-class-method","name":"new","abstract":false,"location":{"filename":"src/http/server/request_processor.cr","line_number":13,"url":null},"def":{"name":"new","yields":0,"block_arg":{"name":"handler","external_name":"handler","restriction":"HTTP::Handler::HandlerProc"},"visibility":"Public","body":"_ = allocate\n_.initialize(&handler) do\n  yield\nend\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(handler:HTTP::Handler|HTTP::Handler::HandlerProc)-class-method","name":"new","abstract":false,"args":[{"name":"handler","external_name":"handler","restriction":"HTTP::Handler | HTTP::Handler::HandlerProc"}],"args_string":"(handler : HTTP::Handler | HTTP::Handler::HandlerProc)","args_html":"(handler : <a href=\"../../HTTP/Handler.html\">HTTP::Handler</a> | <a href=\"../../HTTP/Handler/HandlerProc.html\">HTTP::Handler::HandlerProc</a>)","location":{"filename":"src/http/server/request_processor.cr","line_number":17,"url":null},"def":{"name":"new","args":[{"name":"handler","external_name":"handler","restriction":"HTTP::Handler | HTTP::Handler::HandlerProc"}],"visibility":"Public","body":"_ = allocate\n_.initialize(handler)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"close:Nil-instance-method","name":"close","abstract":false,"location":{"filename":"src/http/server/request_processor.cr","line_number":21,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"@wants_close = true"}},{"html_id":"max_headers_size:Int32-instance-method","name":"max_headers_size","doc":"Maximum permitted combined size of the headers in an HTTP request.","summary":"<p>Maximum permitted combined size of the headers in an HTTP request.</p>","abstract":false,"location":{"filename":"src/http/server/request_processor.cr","line_number":11,"url":null},"def":{"name":"max_headers_size","visibility":"Public","body":"@max_headers_size"}},{"html_id":"max_headers_size=(max_headers_size)-instance-method","name":"max_headers_size=","doc":"Maximum permitted combined size of the headers in an HTTP request.","summary":"<p>Maximum permitted combined size of the headers in an HTTP request.</p>","abstract":false,"args":[{"name":"max_headers_size","external_name":"max_headers_size","restriction":""}],"args_string":"(max_headers_size)","args_html":"(max_headers_size)","location":{"filename":"src/http/server/request_processor.cr","line_number":11,"url":null},"def":{"name":"max_headers_size=","args":[{"name":"max_headers_size","external_name":"max_headers_size","restriction":""}],"visibility":"Public","body":"@max_headers_size = max_headers_size"}},{"html_id":"max_request_line_size:Int32-instance-method","name":"max_request_line_size","doc":"Maximum permitted size of the request line in an HTTP request.","summary":"<p>Maximum permitted size of the request line in an HTTP request.</p>","abstract":false,"location":{"filename":"src/http/server/request_processor.cr","line_number":8,"url":null},"def":{"name":"max_request_line_size","visibility":"Public","body":"@max_request_line_size"}},{"html_id":"max_request_line_size=(max_request_line_size)-instance-method","name":"max_request_line_size=","doc":"Maximum permitted size of the request line in an HTTP request.","summary":"<p>Maximum permitted size of the request line in an HTTP request.</p>","abstract":false,"args":[{"name":"max_request_line_size","external_name":"max_request_line_size","restriction":""}],"args_string":"(max_request_line_size)","args_html":"(max_request_line_size)","location":{"filename":"src/http/server/request_processor.cr","line_number":8,"url":null},"def":{"name":"max_request_line_size=","args":[{"name":"max_request_line_size","external_name":"max_request_line_size","restriction":""}],"visibility":"Public","body":"@max_request_line_size = max_request_line_size"}},{"html_id":"process(input,output):Nil-instance-method","name":"process","abstract":false,"args":[{"name":"input","external_name":"input","restriction":""},{"name":"output","external_name":"output","restriction":""}],"args_string":"(input, output) : Nil","args_html":"(input, output) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/http/server/request_processor.cr","line_number":25,"url":null},"def":{"name":"process","args":[{"name":"input","external_name":"input","restriction":""},{"name":"output","external_name":"output","restriction":""}],"return_type":"Nil","visibility":"Public","body":"response = Response.new(output)\nbegin\n  while !@wants_close\n    request = HTTP::Request.from_io(input, max_request_line_size: max_request_line_size, max_headers_size: max_headers_size)\n    if request\n    else\n      break\n    end\n    response.reset\n    if request.is_a?(HTTP::Status)\n      response.respond_with_status(request)\n      return\n    end\n    response.version = request.version\n    if request.keep_alive?\n      response.headers[\"Connection\"] = \"keep-alive\"\n    end\n    context = Context.new(request, response)\n    Log.with_context do\n      begin\n        @handler.call(context)\n      rescue ex : ClientError\n        Log.debug(exception: ex.cause) do\n          ex.message\n        end\n      rescue ex\n        Log.error(exception: ex) do\n          \"Unhandled exception on HTTP::Handler\"\n        end\n        if response.closed?\n        else\n          if response.wrote_headers?\n          else\n            response.respond_with_status(:internal_server_error)\n          end\n        end\n        return\n      ensure\n        response.output.close\n      end\n    end\n    output.flush\n    if upgrade_handler = response.upgrade_handler\n      upgrade_handler.call(output)\n      return\n    end\n    if request.keep_alive?\n    else\n      break\n    end\n    if HTTP.keep_alive?(response)\n    else\n      break\n    end\n    case body = request.body\n    when FixedLengthContent\n      if body.read_remaining > 0\n        break\n      end\n    when ChunkedContent\n      if body.closed?\n      else\n        break\n      end\n    end\n  end\nrescue IO::Error\nend\n"}}]},{"html_id":"Crystal/HTTP/Server/Response","path":"HTTP/Server/Response.html","kind":"class","full_name":"HTTP::Server::Response","name":"Response","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/server/response.cr","line_number":18,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/HTTP/Server","kind":"class","full_name":"HTTP::Server","name":"Server"},"doc":"The response to configure and write to in an `HTTP::Server` handler.\n\nThe response `status` and `headers` must be configured before writing\nthe response body. Once response output is written, changing the `status`\nand `headers` properties has no effect.\n\nThe `HTTP::Server::Response` is a write-only `IO`, so all `IO` methods are available\nin it.\n\nA response can be upgraded with the `upgrade` method. Once invoked, headers\nare written and the connection `IO` (a socket) is yielded to the given block.\nThis is useful to implement protocol upgrades, such as websockets.","summary":"<p>The response to configure and write to in an <code><a href=\"../../HTTP/Server.html\">HTTP::Server</a></code> handler.</p>","instance_methods":[{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes this response, writing headers and body if not done yet.\nThis method must be implemented if wrapping the response output.","summary":"<p>Closes this response, writing headers and body if not done yet.</p>","abstract":false,"location":{"filename":"src/http/server/response.cr","line_number":123,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"if closed?\n  return\nend\n@output.close\n"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this response has been closed.","summary":"<p>Returns <code>true</code> if this response has been closed.</p>","abstract":false,"location":{"filename":"src/http/server/response.cr","line_number":130,"url":null},"def":{"name":"closed?","return_type":"Bool","visibility":"Public","body":"@output.closed?"}},{"html_id":"content_length=(content_length:Int)-instance-method","name":"content_length=","doc":"Convenience method to set the `Content-Length` header.","summary":"<p>Convenience method to set the <code>Content-Length</code> header.</p>","abstract":false,"args":[{"name":"content_length","external_name":"content_length","restriction":"Int"}],"args_string":"(content_length : Int)","args_html":"(content_length : <a href=\"../../Int.html\">Int</a>)","location":{"filename":"src/http/server/response.cr","line_number":76,"url":null},"def":{"name":"content_length=","args":[{"name":"content_length","external_name":"content_length","restriction":"Int"}],"visibility":"Public","body":"check_headers\nheaders[\"Content-Length\"] = content_length.to_s\n"}},{"html_id":"content_type=(content_type:String)-instance-method","name":"content_type=","doc":"Convenience method to set the `Content-Type` header.","summary":"<p>Convenience method to set the <code>Content-Type</code> header.</p>","abstract":false,"args":[{"name":"content_type","external_name":"content_type","restriction":"String"}],"args_string":"(content_type : String)","args_html":"(content_type : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/http/server/response.cr","line_number":70,"url":null},"def":{"name":"content_type=","args":[{"name":"content_type","external_name":"content_type","restriction":"String"}],"visibility":"Public","body":"check_headers\nheaders[\"Content-Type\"] = content_type\n"}},{"html_id":"cookies:HTTP::Cookies-instance-method","name":"cookies","doc":"Convenience method to set cookies, see `HTTP::Cookies`.","summary":"<p>Convenience method to set cookies, see <code><a href=\"../../HTTP/Cookies.html\">HTTP::Cookies</a></code>.</p>","abstract":false,"location":{"filename":"src/http/server/response.cr","line_number":100,"url":null},"def":{"name":"cookies","return_type":"HTTP::Cookies","visibility":"Public","body":"@cookies || (@cookies = HTTP::Cookies.new)"}},{"html_id":"flush:Nil-instance-method","name":"flush","doc":"Flushes the output. This method must be implemented if wrapping the response output.","summary":"<p>Flushes the output.</p>","abstract":false,"location":{"filename":"src/http/server/response.cr","line_number":117,"url":null},"def":{"name":"flush","return_type":"Nil","visibility":"Public","body":"@output.flush"}},{"html_id":"headers:HTTP::Headers-instance-method","name":"headers","doc":"The response headers (`HTTP::Headers`). These must be set before writing to the response.","summary":"<p>The response headers (<code><a href=\"../../HTTP/Headers.html\">HTTP::Headers</a></code>).</p>","abstract":false,"location":{"filename":"src/http/server/response.cr","line_number":20,"url":null},"def":{"name":"headers","return_type":"HTTP::Headers","visibility":"Public","body":"@headers"}},{"html_id":"output:IO-instance-method","name":"output","doc":"The `IO` to which output is written. This can be changed/wrapped to filter\nthe response body (for example to compress the output).","summary":"<p>The <code><a href=\"../../IO.html\">IO</a></code> to which output is written.</p>","abstract":false,"location":{"filename":"src/http/server/response.cr","line_number":27,"url":null},"def":{"name":"output","return_type":"IO","visibility":"Public","body":"@output"}},{"html_id":"output=(output:IO)-instance-method","name":"output=","doc":"The `IO` to which output is written. This can be changed/wrapped to filter\nthe response body (for example to compress the output).","summary":"<p>The <code><a href=\"../../IO.html\">IO</a></code> to which output is written.</p>","abstract":false,"args":[{"name":"output","external_name":"output","restriction":"IO"}],"args_string":"(output : IO)","args_html":"(output : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/http/server/response.cr","line_number":27,"url":null},"def":{"name":"output=","args":[{"name":"output","external_name":"output","restriction":"IO"}],"visibility":"Public","body":"@output = output"}},{"html_id":"respond_with_status(status:HTTP::Status,message:String?=nil):Nil-instance-method","name":"respond_with_status","doc":"Sends *status* and *message* as response.\n\nThis method calls `#reset` to remove any previous settings and writes the\ngiven *status* and *message* to the response IO. Finally, it closes the\nresponse.\n\nIf *message* is `nil`, the default message for *status* is used provided\nby `HTTP::Status#description`.\n\nRaises `IO::Error` if the response is closed or headers were already\nsent.","summary":"<p>Sends <em>status</em> and <em>message</em> as response.</p>","abstract":false,"args":[{"name":"status","external_name":"status","restriction":"HTTP::Status"},{"name":"message","default_value":"nil","external_name":"message","restriction":"String | ::Nil"}],"args_string":"(status : HTTP::Status, message : String? = nil) : Nil","args_html":"(status : <a href=\"../../HTTP/Status.html\">HTTP::Status</a>, message : <a href=\"../../String.html\">String</a>? = <span class=\"n\">nil</span>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/http/server/response.cr","line_number":147,"url":null},"def":{"name":"respond_with_status","args":[{"name":"status","external_name":"status","restriction":"HTTP::Status"},{"name":"message","default_value":"nil","external_name":"message","restriction":"String | ::Nil"}],"return_type":"Nil","visibility":"Public","body":"check_headers\nreset\n@status = status\n@status_message = message || (message = @status.description)\nself.content_type = \"text/plain\"\n(((self << @status.code) << ' ') << message) << '\\n'\nclose\n"}},{"html_id":"respond_with_status(status:Int,message:String?=nil):Nil-instance-method","name":"respond_with_status","doc":"Sends *status* and *message* as response.\n\nThis method calls `#reset` to remove any previous settings and writes the\ngiven *status* and *message* to the response IO. Finally, it closes the\nresponse.\n\nIf *message* is `nil`, the default message for *status* is used provided\nby `HTTP::Status#description`.\n\nRaises `IO::Error` if the response is closed or headers were already\nsent.","summary":"<p>Sends <em>status</em> and <em>message</em> as response.</p>","abstract":false,"args":[{"name":"status","external_name":"status","restriction":"Int"},{"name":"message","default_value":"nil","external_name":"message","restriction":"String | ::Nil"}],"args_string":"(status : Int, message : String? = nil) : Nil","args_html":"(status : <a href=\"../../Int.html\">Int</a>, message : <a href=\"../../String.html\">String</a>? = <span class=\"n\">nil</span>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/http/server/response.cr","line_number":158,"url":null},"def":{"name":"respond_with_status","args":[{"name":"status","external_name":"status","restriction":"Int"},{"name":"message","default_value":"nil","external_name":"message","restriction":"String | ::Nil"}],"return_type":"Nil","visibility":"Public","body":"respond_with_status(HTTP::Status.new(status), message)"}},{"html_id":"status:HTTP::Status-instance-method","name":"status","doc":"The status code of this response, which must be set before writing the response\nbody. If not set, the default value is 200 (OK).","summary":"<p>The status code of this response, which must be set before writing the response body.</p>","abstract":false,"location":{"filename":"src/http/server/response.cr","line_number":37,"url":null},"def":{"name":"status","return_type":"HTTP::Status","visibility":"Public","body":"@status"}},{"html_id":"status=(status:HTTP::Status)-instance-method","name":"status=","abstract":false,"args":[{"name":"status","external_name":"status","restriction":"HTTP::Status"}],"args_string":"(status : HTTP::Status)","args_html":"(status : <a href=\"../../HTTP/Status.html\">HTTP::Status</a>)","location":{"filename":"src/http/server/response.cr","line_number":39,"url":null},"def":{"name":"status=","args":[{"name":"status","external_name":"status","restriction":"HTTP::Status"}],"visibility":"Public","body":"check_headers\n@status = status\n"}},{"html_id":"status_code:Int32-instance-method","name":"status_code","doc":"Convenience method to retrieve the HTTP status code.","summary":"<p>Convenience method to retrieve the HTTP status code.</p>","abstract":false,"location":{"filename":"src/http/server/response.cr","line_number":82,"url":null},"def":{"name":"status_code","return_type":"Int32","visibility":"Public","body":"status.code"}},{"html_id":"status_code=(status_code:Int32)-instance-method","name":"status_code=","doc":"Convenience method to set the HTTP status code.","summary":"<p>Convenience method to set the HTTP status code.</p>","abstract":false,"args":[{"name":"status_code","external_name":"status_code","restriction":"Int32"}],"args_string":"(status_code : Int32)","args_html":"(status_code : <a href=\"../../Int32.html\">Int32</a>)","location":{"filename":"src/http/server/response.cr","line_number":87,"url":null},"def":{"name":"status_code=","args":[{"name":"status_code","external_name":"status_code","restriction":"Int32"}],"visibility":"Public","body":"self.status = HTTP::Status.new(status_code)\nstatus_code\n"}},{"html_id":"upgrade(&block:IO->):Nil-instance-method","name":"upgrade","doc":"Upgrades this response, writing headers and yielding the connection `IO` (a socket) to the given block.\nThis is useful to implement protocol upgrades, such as websockets.","summary":"<p>Upgrades this response, writing headers and yielding the connection <code><a href=\"../../IO.html\">IO</a></code> (a socket) to the given block.</p>","abstract":false,"location":{"filename":"src/http/server/response.cr","line_number":111,"url":null},"def":{"name":"upgrade","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(IO ->)"},"return_type":"Nil","visibility":"Public","body":"write_headers\n@upgrade_handler = block\n"}},{"html_id":"version:String-instance-method","name":"version","doc":"The version of the HTTP::Request that created this response.","summary":"<p>The version of the HTTP::Request that created this response.</p>","abstract":false,"location":{"filename":"src/http/server/response.cr","line_number":23,"url":null},"def":{"name":"version","return_type":"String","visibility":"Public","body":"@version"}},{"html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"See `IO#write(slice)`.","summary":"<p>See <code><a href=\"../../IO.html#write%28slice%3ABytes%29%3ANil-instance-method\">IO#write(slice)</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"../../Bytes.html\">Bytes</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/http/server/response.cr","line_number":93,"url":null},"def":{"name":"write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"if slice.empty?\n  return\nend\n@output.write(slice)\n"}}]}]},{"html_id":"Crystal/HTTP/StaticFileHandler","path":"HTTP/StaticFileHandler.html","kind":"class","full_name":"HTTP::StaticFileHandler","name":"StaticFileHandler","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/server/handlers/static_file_handler.cr","line_number":11,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"}],"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"A handler that lists directories and serves files under a given public directory.\n\nThis handler can send precompressed content, if the client accepts it, and a file\nwith the same name and `.gz` extension appended is found in the same directory.\nPrecompressed files are only served if they are newer than the original file.","summary":"<p>A handler that lists directories and serves files under a given public directory.</p>","constructors":[{"html_id":"new(public_dir:String,fallthrough=true,directory_listing=true)-class-method","name":"new","doc":"Creates a handler that will serve files in the given *public_dir*, after\nexpanding it (using `File#expand_path`).\n\nIf *fallthrough* is `false`, this handler does not call next handler when\nrequest method is neither GET or HEAD, then serves `405 Method Not Allowed`.\nOtherwise, it calls next handler.\n\nIf *directory_listing* is `false`, directory listing is disabled. This means that\npaths matching directories are ignored and next handler is called.","summary":"<p>Creates a handler that will serve files in the given <em>public_dir</em>, after expanding it (using <code><a href=\"../File.html#expand_path%28path%3APath%7CString%2Cdir%3Dnil%2C%2A%2Chome%3Dfalse%29%3AString-class-method\">File#expand_path</a></code>).</p>","abstract":false,"args":[{"name":"public_dir","external_name":"public_dir","restriction":"String"},{"name":"fallthrough","default_value":"true","external_name":"fallthrough","restriction":""},{"name":"directory_listing","default_value":"true","external_name":"directory_listing","restriction":""}],"args_string":"(public_dir : String, fallthrough = true, directory_listing = true)","args_html":"(public_dir : <a href=\"../String.html\">String</a>, fallthrough = <span class=\"n\">true</span>, directory_listing = <span class=\"n\">true</span>)","location":{"filename":"src/http/server/handlers/static_file_handler.cr","line_number":25,"url":null},"def":{"name":"new","args":[{"name":"public_dir","external_name":"public_dir","restriction":"String"},{"name":"fallthrough","default_value":"true","external_name":"fallthrough","restriction":""},{"name":"directory_listing","default_value":"true","external_name":"directory_listing","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(public_dir, fallthrough, directory_listing)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"call(context):Nil-instance-method","name":"call","abstract":false,"args":[{"name":"context","external_name":"context","restriction":""}],"args_string":"(context) : Nil","args_html":"(context) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/http/server/handlers/static_file_handler.cr","line_number":31,"url":null},"def":{"name":"call","args":[{"name":"context","external_name":"context","restriction":""}],"return_type":"Nil","visibility":"Public","body":"if context.request.method.in?(\"GET\", \"HEAD\")\nelse\n  if @fallthrough\n    call_next(context)\n  else\n    context.response.status = :method_not_allowed\n    context.response.headers.add(\"Allow\", \"GET, HEAD\")\n  end\n  return\nend\noriginal_path = context.request.path.not_nil!\nis_dir_path = original_path.ends_with?(\"/\")\nrequest_path = self.request_path(URI.decode(original_path))\nif request_path.includes?('\\0')\n  context.response.respond_with_status(:bad_request)\n  return\nend\nrequest_path = Path.posix(request_path)\nexpanded_path = request_path.expand(\"/\")\nfile_path = @public_dir.join(expanded_path.to_kind(Path::Kind.native))\nis_dir = Dir.exists?(file_path)\nis_file = (!is_dir) && (File.exists?(file_path))\nif (request_path != expanded_path) || (is_dir && (!is_dir_path))\n  redirect_path = expanded_path\n  if is_dir && (!is_dir_path)\n    redirect_path = expanded_path.join(\"\")\n  end\n  redirect_to(context, redirect_path)\n  return\nend\nif @directory_listing && is_dir\n  context.response.content_type = \"text/html\"\n  directory_listing(context.response, request_path, file_path)\nelse\n  if is_file\n    last_modified = modification_time(file_path)\n    add_cache_headers(context.response.headers, last_modified)\n    if cache_request?(context, last_modified)\n      context.response.status = :not_modified\n      return\n    end\n    context.response.content_type = MIME.from_filename(file_path.to_s, \"application/octet-stream\")\n    if context.request.headers.includes_word?(\"Accept-Encoding\", \"gzip\")\n      gz_file_path = \"#{file_path}.gz\"\n      if (File.exists?(gz_file_path)) && (last_modified - (modification_time(gz_file_path))) < 1.millisecond\n        file_path = gz_file_path\n        context.response.headers[\"Content-Encoding\"] = \"gzip\"\n      end\n    end\n    context.response.content_length = File.size(file_path)\n    File.open(file_path) do |file|\n      IO.copy(file, context.response)\n    end\n  else\n    call_next(context)\n  end\nend\n"}}],"types":[{"html_id":"Crystal/HTTP/StaticFileHandler/DirectoryListing","path":"HTTP/StaticFileHandler/DirectoryListing.html","kind":"struct","full_name":"HTTP::StaticFileHandler::DirectoryListing","name":"DirectoryListing","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/server/handlers/static_file_handler.cr","line_number":151,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/HTTP/StaticFileHandler","kind":"class","full_name":"HTTP::StaticFileHandler","name":"StaticFileHandler"},"constructors":[{"html_id":"new(request_path:String,path:String)-class-method","name":"new","abstract":false,"args":[{"name":"request_path","external_name":"request_path","restriction":"String"},{"name":"path","external_name":"path","restriction":"String"}],"args_string":"(request_path : String, path : String)","args_html":"(request_path : <a href=\"../../String.html\">String</a>, path : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/http/server/handlers/static_file_handler.cr","line_number":151,"url":null},"def":{"name":"new","args":[{"name":"request_path","external_name":"request_path","restriction":"String"},{"name":"path","external_name":"path","restriction":"String"}],"visibility":"Public","body":"_ = allocate\n_.initialize(request_path, path)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/http/server/handlers/static_file_handler.cr","line_number":151,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new(@request_path.clone, @path.clone)"}},{"html_id":"copy_with(request_path_request_path=@request_path,path_path=@path)-instance-method","name":"copy_with","abstract":false,"args":[{"name":"_request_path","default_value":"@request_path","external_name":"request_path","restriction":""},{"name":"_path","default_value":"@path","external_name":"path","restriction":""}],"args_string":"(request_path _request_path = @request_path, path _path = @path)","args_html":"(request_path _request_path = @request_path, path _path = @path)","location":{"filename":"src/http/server/handlers/static_file_handler.cr","line_number":151,"url":null},"def":{"name":"copy_with","args":[{"name":"_request_path","default_value":"@request_path","external_name":"request_path","restriction":""},{"name":"_path","default_value":"@path","external_name":"path","restriction":""}],"visibility":"Public","body":"self.class.new(_request_path, _path)"}},{"html_id":"each_entry(&)-instance-method","name":"each_entry","abstract":false,"location":{"filename":"src/http/server/handlers/static_file_handler.cr","line_number":152,"url":null},"def":{"name":"each_entry","yields":1,"visibility":"Public","body":"Dir.each_child(path) do |entry|\n  yield entry\nend"}},{"html_id":"path:String-instance-method","name":"path","abstract":false,"def":{"name":"path","return_type":"String","visibility":"Public","body":"@path"}},{"html_id":"request_path:String-instance-method","name":"request_path","abstract":false,"def":{"name":"request_path","return_type":"String","visibility":"Public","body":"@request_path"}},{"html_id":"to_s(__io__:IO):Nil-instance-method","name":"to_s","doc":"Same as `#inspect(io)`.","summary":"<p>Same as <code>#inspect(io)</code>.</p>","abstract":false,"args":[{"name":"__io__","external_name":"__io__","restriction":"IO"}],"args_string":"(__io__ : IO) : Nil","args_html":"(__io__ : <a href=\"../../IO.html\">IO</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/http/server/handlers/static_file_handler.cr","line_number":158,"url":null},"def":{"name":"to_s","args":[{"name":"__io__","external_name":"__io__","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"ECR.embed(\"/build/crystal/src/crystal-1.3.0/src/http/server/handlers/static_file_handler.html\", \"__io__\")"}}]}]},{"html_id":"Crystal/HTTP/Status","path":"HTTP/Status.html","kind":"enum","full_name":"HTTP::Status","name":"Status","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/status.cr","line_number":7,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"CONTINUE","name":"CONTINUE","value":"100"},{"id":"SWITCHING_PROTOCOLS","name":"SWITCHING_PROTOCOLS","value":"101"},{"id":"PROCESSING","name":"PROCESSING","value":"102"},{"id":"EARLY_HINTS","name":"EARLY_HINTS","value":"103"},{"id":"OK","name":"OK","value":"200"},{"id":"CREATED","name":"CREATED","value":"201"},{"id":"ACCEPTED","name":"ACCEPTED","value":"202"},{"id":"NON_AUTHORITATIVE_INFORMATION","name":"NON_AUTHORITATIVE_INFORMATION","value":"203"},{"id":"NO_CONTENT","name":"NO_CONTENT","value":"204"},{"id":"RESET_CONTENT","name":"RESET_CONTENT","value":"205"},{"id":"PARTIAL_CONTENT","name":"PARTIAL_CONTENT","value":"206"},{"id":"MULTI_STATUS","name":"MULTI_STATUS","value":"207"},{"id":"ALREADY_REPORTED","name":"ALREADY_REPORTED","value":"208"},{"id":"IM_USED","name":"IM_USED","value":"226"},{"id":"MULTIPLE_CHOICES","name":"MULTIPLE_CHOICES","value":"300"},{"id":"MOVED_PERMANENTLY","name":"MOVED_PERMANENTLY","value":"301"},{"id":"FOUND","name":"FOUND","value":"302"},{"id":"SEE_OTHER","name":"SEE_OTHER","value":"303"},{"id":"NOT_MODIFIED","name":"NOT_MODIFIED","value":"304"},{"id":"USE_PROXY","name":"USE_PROXY","value":"305"},{"id":"SWITCH_PROXY","name":"SWITCH_PROXY","value":"306"},{"id":"TEMPORARY_REDIRECT","name":"TEMPORARY_REDIRECT","value":"307"},{"id":"PERMANENT_REDIRECT","name":"PERMANENT_REDIRECT","value":"308"},{"id":"BAD_REQUEST","name":"BAD_REQUEST","value":"400"},{"id":"UNAUTHORIZED","name":"UNAUTHORIZED","value":"401"},{"id":"PAYMENT_REQUIRED","name":"PAYMENT_REQUIRED","value":"402"},{"id":"FORBIDDEN","name":"FORBIDDEN","value":"403"},{"id":"NOT_FOUND","name":"NOT_FOUND","value":"404"},{"id":"METHOD_NOT_ALLOWED","name":"METHOD_NOT_ALLOWED","value":"405"},{"id":"NOT_ACCEPTABLE","name":"NOT_ACCEPTABLE","value":"406"},{"id":"PROXY_AUTHENTICATION_REQUIRED","name":"PROXY_AUTHENTICATION_REQUIRED","value":"407"},{"id":"REQUEST_TIMEOUT","name":"REQUEST_TIMEOUT","value":"408"},{"id":"CONFLICT","name":"CONFLICT","value":"409"},{"id":"GONE","name":"GONE","value":"410"},{"id":"LENGTH_REQUIRED","name":"LENGTH_REQUIRED","value":"411"},{"id":"PRECONDITION_FAILED","name":"PRECONDITION_FAILED","value":"412"},{"id":"PAYLOAD_TOO_LARGE","name":"PAYLOAD_TOO_LARGE","value":"413"},{"id":"URI_TOO_LONG","name":"URI_TOO_LONG","value":"414"},{"id":"UNSUPPORTED_MEDIA_TYPE","name":"UNSUPPORTED_MEDIA_TYPE","value":"415"},{"id":"RANGE_NOT_SATISFIABLE","name":"RANGE_NOT_SATISFIABLE","value":"416"},{"id":"EXPECTATION_FAILED","name":"EXPECTATION_FAILED","value":"417"},{"id":"IM_A_TEAPOT","name":"IM_A_TEAPOT","value":"418"},{"id":"MISDIRECTED_REQUEST","name":"MISDIRECTED_REQUEST","value":"421"},{"id":"UNPROCESSABLE_ENTITY","name":"UNPROCESSABLE_ENTITY","value":"422"},{"id":"LOCKED","name":"LOCKED","value":"423"},{"id":"FAILED_DEPENDENCY","name":"FAILED_DEPENDENCY","value":"424"},{"id":"UPGRADE_REQUIRED","name":"UPGRADE_REQUIRED","value":"426"},{"id":"PRECONDITION_REQUIRED","name":"PRECONDITION_REQUIRED","value":"428"},{"id":"TOO_MANY_REQUESTS","name":"TOO_MANY_REQUESTS","value":"429"},{"id":"REQUEST_HEADER_FIELDS_TOO_LARGE","name":"REQUEST_HEADER_FIELDS_TOO_LARGE","value":"431"},{"id":"UNAVAILABLE_FOR_LEGAL_REASONS","name":"UNAVAILABLE_FOR_LEGAL_REASONS","value":"451"},{"id":"INTERNAL_SERVER_ERROR","name":"INTERNAL_SERVER_ERROR","value":"500"},{"id":"NOT_IMPLEMENTED","name":"NOT_IMPLEMENTED","value":"501"},{"id":"BAD_GATEWAY","name":"BAD_GATEWAY","value":"502"},{"id":"SERVICE_UNAVAILABLE","name":"SERVICE_UNAVAILABLE","value":"503"},{"id":"GATEWAY_TIMEOUT","name":"GATEWAY_TIMEOUT","value":"504"},{"id":"HTTP_VERSION_NOT_SUPPORTED","name":"HTTP_VERSION_NOT_SUPPORTED","value":"505"},{"id":"VARIANT_ALSO_NEGOTIATES","name":"VARIANT_ALSO_NEGOTIATES","value":"506"},{"id":"INSUFFICIENT_STORAGE","name":"INSUFFICIENT_STORAGE","value":"507"},{"id":"LOOP_DETECTED","name":"LOOP_DETECTED","value":"508"},{"id":"NOT_EXTENDED","name":"NOT_EXTENDED","value":"510"},{"id":"NETWORK_AUTHENTICATION_REQUIRED","name":"NETWORK_AUTHENTICATION_REQUIRED","value":"511"}],"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"An enum that provides additional support around HTTP status codes.\n\nBased on [Hypertext Transfer Protocol (HTTP) Status Code Registry](https://www.iana.org/assignments/http-status-codes/http-status-codes.xhtml)\n\nIt provides constants for the defined HTTP status codes as well as helper\nmethods to easily identify the type of response.","summary":"<p>An enum that provides additional support around HTTP status codes.</p>","constructors":[{"html_id":"new(status_code:Int32)-class-method","name":"new","doc":"Create a new status instance with the given status code, or raise an\nerror if the status code given is not inside 100..999.\n\n```\nrequire \"http/status\"\n\nHTTP::Status.new(100)  # => CONTINUE\nHTTP::Status.new(202)  # => ACCEPTED\nHTTP::Status.new(123)  # => 123\nHTTP::Status.new(1000) # raises ArgumentError\n```","summary":"<p>Create a new status instance with the given status code, or raise an error if the status code given is not inside 100..999.</p>","abstract":false,"args":[{"name":"status_code","external_name":"status_code","restriction":"Int32"}],"args_string":"(status_code : Int32)","args_html":"(status_code : <a href=\"../Int32.html\">Int32</a>)","location":{"filename":"src/http/status.cr","line_number":82,"url":null},"def":{"name":"new","args":[{"name":"status_code","external_name":"status_code","restriction":"Int32"}],"visibility":"Public","body":"if 100 <= status_code && status_code <= 999\nelse\n  raise(ArgumentError.new(\"Invalid HTTP status code: #{status_code}\"))\nend\nprevious_def(status_code)\n"}}],"instance_methods":[{"html_id":"accepted?-instance-method","name":"accepted?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":14,"url":null},"def":{"name":"accepted?","visibility":"Public","body":"self == ACCEPTED"}},{"html_id":"already_reported?-instance-method","name":"already_reported?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":20,"url":null},"def":{"name":"already_reported?","visibility":"Public","body":"self == ALREADY_REPORTED"}},{"html_id":"bad_gateway?-instance-method","name":"bad_gateway?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":61,"url":null},"def":{"name":"bad_gateway?","visibility":"Public","body":"self == BAD_GATEWAY"}},{"html_id":"bad_request?-instance-method","name":"bad_request?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":31,"url":null},"def":{"name":"bad_request?","visibility":"Public","body":"self == BAD_REQUEST"}},{"html_id":"client_error?:Bool-instance-method","name":"client_error?","doc":"Returns `true` if the response status code is between 400 and 499.\n\n```\nrequire \"http/status\"\n\nHTTP::Status::METHOD_NOT_ALLOWED.client_error?    # => true\nHTTP::Status::INTERNAL_SERVER_ERROR.client_error? # => false\n```","summary":"<p>Returns <code>true</code> if the response status code is between 400 and 499.</p>","abstract":false,"location":{"filename":"src/http/status.cr","line_number":143,"url":null},"def":{"name":"client_error?","return_type":"Bool","visibility":"Public","body":"400 <= (__temp_63 = code) && __temp_63 <= 499"}},{"html_id":"code:Int32-instance-method","name":"code","doc":"Returns the number that represents the HTTP status code.\n\n```\nrequire \"http/status\"\n\nstatus = HTTP::Status::NO_CONTENT\nstatus.code # => 204\n```","summary":"<p>Returns the number that represents the HTTP status code.</p>","abstract":false,"location":{"filename":"src/http/status.cr","line_number":95,"url":null},"def":{"name":"code","return_type":"Int32","visibility":"Public","body":"value"}},{"html_id":"conflict?-instance-method","name":"conflict?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":40,"url":null},"def":{"name":"conflict?","visibility":"Public","body":"self == CONFLICT"}},{"html_id":"continue?-instance-method","name":"continue?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":8,"url":null},"def":{"name":"continue?","visibility":"Public","body":"self == CONTINUE"}},{"html_id":"created?-instance-method","name":"created?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":13,"url":null},"def":{"name":"created?","visibility":"Public","body":"self == CREATED"}},{"html_id":"description:String?-instance-method","name":"description","doc":"Returns the default status description of the given HTTP status code.\n\n```\nrequire \"http/status\"\n\nHTTP::Status.new(123).description               # => nil\nHTTP::Status::NO_CONTENT.description            # => \"No Content\"\nHTTP::Status::METHOD_NOT_ALLOWED.description    # => \"Method Not Allowed\"\nHTTP::Status::INTERNAL_SERVER_ERROR.description # => \"Internal Server Error\"\n```","summary":"<p>Returns the default status description of the given HTTP status code.</p>","abstract":false,"location":{"filename":"src/http/status.cr","line_number":169,"url":null},"def":{"name":"description","return_type":"String | ::Nil","visibility":"Public","body":"case code\nwhen 100\n  \"Continue\"\nwhen 101\n  \"Switching Protocols\"\nwhen 102\n  \"Processing\"\nwhen 200\n  \"OK\"\nwhen 201\n  \"Created\"\nwhen 202\n  \"Accepted\"\nwhen 203\n  \"Non-Authoritative Information\"\nwhen 204\n  \"No Content\"\nwhen 205\n  \"Reset Content\"\nwhen 206\n  \"Partial Content\"\nwhen 207\n  \"Multi-Status\"\nwhen 208\n  \"Already Reported\"\nwhen 226\n  \"IM Used\"\nwhen 300\n  \"Multiple Choices\"\nwhen 301\n  \"Moved Permanently\"\nwhen 302\n  \"Found\"\nwhen 303\n  \"See Other\"\nwhen 304\n  \"Not Modified\"\nwhen 305\n  \"Use Proxy\"\nwhen 306\n  \"Switch Proxy\"\nwhen 307\n  \"Temporary Redirect\"\nwhen 308\n  \"Permanent Redirect\"\nwhen 400\n  \"Bad Request\"\nwhen 401\n  \"Unauthorized\"\nwhen 402\n  \"Payment Required\"\nwhen 403\n  \"Forbidden\"\nwhen 404\n  \"Not Found\"\nwhen 405\n  \"Method Not Allowed\"\nwhen 406\n  \"Not Acceptable\"\nwhen 407\n  \"Proxy Authentication Required\"\nwhen 408\n  \"Request Timeout\"\nwhen 409\n  \"Conflict\"\nwhen 410\n  \"Gone\"\nwhen 411\n  \"Length Required\"\nwhen 412\n  \"Precondition Failed\"\nwhen 413\n  \"Payload Too Large\"\nwhen 414\n  \"URI Too Long\"\nwhen 415\n  \"Unsupported Media Type\"\nwhen 416\n  \"Range Not Satisfiable\"\nwhen 417\n  \"Expectation Failed\"\nwhen 418\n  \"I'm a teapot\"\nwhen 421\n  \"Misdirected Request\"\nwhen 422\n  \"Unprocessable Entity\"\nwhen 423\n  \"Locked\"\nwhen 424\n  \"Failed Dependency\"\nwhen 426\n  \"Upgrade Required\"\nwhen 428\n  \"Precondition Required\"\nwhen 429\n  \"Too Many Requests\"\nwhen 431\n  \"Request Header Fields Too Large\"\nwhen 451\n  \"Unavailable For Legal Reasons\"\nwhen 500\n  \"Internal Server Error\"\nwhen 501\n  \"Not Implemented\"\nwhen 502\n  \"Bad Gateway\"\nwhen 503\n  \"Service Unavailable\"\nwhen 504\n  \"Gateway Timeout\"\nwhen 505\n  \"HTTP Version Not Supported\"\nwhen 506\n  \"Variant Also Negotiates\"\nwhen 507\n  \"Insufficient Storage\"\nwhen 508\n  \"Loop Detected\"\nwhen 510\n  \"Not Extended\"\nwhen 511\n  \"Network Authentication Required\"\nelse\n  nil\nend"}},{"html_id":"early_hints?-instance-method","name":"early_hints?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":11,"url":null},"def":{"name":"early_hints?","visibility":"Public","body":"self == EARLY_HINTS"}},{"html_id":"expectation_failed?-instance-method","name":"expectation_failed?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":48,"url":null},"def":{"name":"expectation_failed?","visibility":"Public","body":"self == EXPECTATION_FAILED"}},{"html_id":"failed_dependency?-instance-method","name":"failed_dependency?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":53,"url":null},"def":{"name":"failed_dependency?","visibility":"Public","body":"self == FAILED_DEPENDENCY"}},{"html_id":"forbidden?-instance-method","name":"forbidden?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":34,"url":null},"def":{"name":"forbidden?","visibility":"Public","body":"self == FORBIDDEN"}},{"html_id":"found?-instance-method","name":"found?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":24,"url":null},"def":{"name":"found?","visibility":"Public","body":"self == FOUND"}},{"html_id":"gateway_timeout?-instance-method","name":"gateway_timeout?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":63,"url":null},"def":{"name":"gateway_timeout?","visibility":"Public","body":"self == GATEWAY_TIMEOUT"}},{"html_id":"gone?-instance-method","name":"gone?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":41,"url":null},"def":{"name":"gone?","visibility":"Public","body":"self == GONE"}},{"html_id":"http_version_not_supported?-instance-method","name":"http_version_not_supported?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":64,"url":null},"def":{"name":"http_version_not_supported?","visibility":"Public","body":"self == HTTP_VERSION_NOT_SUPPORTED"}},{"html_id":"im_a_teapot?-instance-method","name":"im_a_teapot?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":49,"url":null},"def":{"name":"im_a_teapot?","visibility":"Public","body":"self == IM_A_TEAPOT"}},{"html_id":"im_used?-instance-method","name":"im_used?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":21,"url":null},"def":{"name":"im_used?","visibility":"Public","body":"self == IM_USED"}},{"html_id":"informational?:Bool-instance-method","name":"informational?","doc":"Returns `true` if the response status code is between 100 and 199.\n\n```\nrequire \"http/status\"\n\nHTTP::Status::SWITCHING_PROTOCOLS.informational?   # => true\nHTTP::Status::INTERNAL_SERVER_ERROR.informational? # => false\n```","summary":"<p>Returns <code>true</code> if the response status code is between 100 and 199.</p>","abstract":false,"location":{"filename":"src/http/status.cr","line_number":107,"url":null},"def":{"name":"informational?","return_type":"Bool","visibility":"Public","body":"100 <= (__temp_60 = code) && __temp_60 <= 199"}},{"html_id":"insufficient_storage?-instance-method","name":"insufficient_storage?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":66,"url":null},"def":{"name":"insufficient_storage?","visibility":"Public","body":"self == INSUFFICIENT_STORAGE"}},{"html_id":"internal_server_error?-instance-method","name":"internal_server_error?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":59,"url":null},"def":{"name":"internal_server_error?","visibility":"Public","body":"self == INTERNAL_SERVER_ERROR"}},{"html_id":"length_required?-instance-method","name":"length_required?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":42,"url":null},"def":{"name":"length_required?","visibility":"Public","body":"self == LENGTH_REQUIRED"}},{"html_id":"locked?-instance-method","name":"locked?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":52,"url":null},"def":{"name":"locked?","visibility":"Public","body":"self == LOCKED"}},{"html_id":"loop_detected?-instance-method","name":"loop_detected?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":67,"url":null},"def":{"name":"loop_detected?","visibility":"Public","body":"self == LOOP_DETECTED"}},{"html_id":"method_not_allowed?-instance-method","name":"method_not_allowed?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":36,"url":null},"def":{"name":"method_not_allowed?","visibility":"Public","body":"self == METHOD_NOT_ALLOWED"}},{"html_id":"misdirected_request?-instance-method","name":"misdirected_request?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":50,"url":null},"def":{"name":"misdirected_request?","visibility":"Public","body":"self == MISDIRECTED_REQUEST"}},{"html_id":"moved_permanently?-instance-method","name":"moved_permanently?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":23,"url":null},"def":{"name":"moved_permanently?","visibility":"Public","body":"self == MOVED_PERMANENTLY"}},{"html_id":"multi_status?-instance-method","name":"multi_status?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":19,"url":null},"def":{"name":"multi_status?","visibility":"Public","body":"self == MULTI_STATUS"}},{"html_id":"multiple_choices?-instance-method","name":"multiple_choices?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":22,"url":null},"def":{"name":"multiple_choices?","visibility":"Public","body":"self == MULTIPLE_CHOICES"}},{"html_id":"network_authentication_required?-instance-method","name":"network_authentication_required?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":69,"url":null},"def":{"name":"network_authentication_required?","visibility":"Public","body":"self == NETWORK_AUTHENTICATION_REQUIRED"}},{"html_id":"no_content?-instance-method","name":"no_content?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":16,"url":null},"def":{"name":"no_content?","visibility":"Public","body":"self == NO_CONTENT"}},{"html_id":"non_authoritative_information?-instance-method","name":"non_authoritative_information?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":15,"url":null},"def":{"name":"non_authoritative_information?","visibility":"Public","body":"self == NON_AUTHORITATIVE_INFORMATION"}},{"html_id":"not_acceptable?-instance-method","name":"not_acceptable?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":37,"url":null},"def":{"name":"not_acceptable?","visibility":"Public","body":"self == NOT_ACCEPTABLE"}},{"html_id":"not_extended?-instance-method","name":"not_extended?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":68,"url":null},"def":{"name":"not_extended?","visibility":"Public","body":"self == NOT_EXTENDED"}},{"html_id":"not_found?-instance-method","name":"not_found?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":35,"url":null},"def":{"name":"not_found?","visibility":"Public","body":"self == NOT_FOUND"}},{"html_id":"not_implemented?-instance-method","name":"not_implemented?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":60,"url":null},"def":{"name":"not_implemented?","visibility":"Public","body":"self == NOT_IMPLEMENTED"}},{"html_id":"not_modified?-instance-method","name":"not_modified?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":26,"url":null},"def":{"name":"not_modified?","visibility":"Public","body":"self == NOT_MODIFIED"}},{"html_id":"ok?-instance-method","name":"ok?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":12,"url":null},"def":{"name":"ok?","visibility":"Public","body":"self == OK"}},{"html_id":"partial_content?-instance-method","name":"partial_content?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":18,"url":null},"def":{"name":"partial_content?","visibility":"Public","body":"self == PARTIAL_CONTENT"}},{"html_id":"payload_too_large?-instance-method","name":"payload_too_large?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":44,"url":null},"def":{"name":"payload_too_large?","visibility":"Public","body":"self == PAYLOAD_TOO_LARGE"}},{"html_id":"payment_required?-instance-method","name":"payment_required?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":33,"url":null},"def":{"name":"payment_required?","visibility":"Public","body":"self == PAYMENT_REQUIRED"}},{"html_id":"permanent_redirect?-instance-method","name":"permanent_redirect?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":30,"url":null},"def":{"name":"permanent_redirect?","visibility":"Public","body":"self == PERMANENT_REDIRECT"}},{"html_id":"precondition_failed?-instance-method","name":"precondition_failed?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":43,"url":null},"def":{"name":"precondition_failed?","visibility":"Public","body":"self == PRECONDITION_FAILED"}},{"html_id":"precondition_required?-instance-method","name":"precondition_required?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":55,"url":null},"def":{"name":"precondition_required?","visibility":"Public","body":"self == PRECONDITION_REQUIRED"}},{"html_id":"processing?-instance-method","name":"processing?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":10,"url":null},"def":{"name":"processing?","visibility":"Public","body":"self == PROCESSING"}},{"html_id":"proxy_authentication_required?-instance-method","name":"proxy_authentication_required?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":38,"url":null},"def":{"name":"proxy_authentication_required?","visibility":"Public","body":"self == PROXY_AUTHENTICATION_REQUIRED"}},{"html_id":"range_not_satisfiable?-instance-method","name":"range_not_satisfiable?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":47,"url":null},"def":{"name":"range_not_satisfiable?","visibility":"Public","body":"self == RANGE_NOT_SATISFIABLE"}},{"html_id":"redirection?:Bool-instance-method","name":"redirection?","doc":"Returns `true` if the response status code is between 300 and 399.\n\n```\nrequire \"http/status\"\n\nHTTP::Status::SWITCH_PROXY.redirection?          # => true\nHTTP::Status::INTERNAL_SERVER_ERROR.redirection? # => false\n```","summary":"<p>Returns <code>true</code> if the response status code is between 300 and 399.</p>","abstract":false,"location":{"filename":"src/http/status.cr","line_number":131,"url":null},"def":{"name":"redirection?","return_type":"Bool","visibility":"Public","body":"300 <= (__temp_62 = code) && __temp_62 <= 399"}},{"html_id":"request_header_fields_too_large?-instance-method","name":"request_header_fields_too_large?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":57,"url":null},"def":{"name":"request_header_fields_too_large?","visibility":"Public","body":"self == REQUEST_HEADER_FIELDS_TOO_LARGE"}},{"html_id":"request_timeout?-instance-method","name":"request_timeout?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":39,"url":null},"def":{"name":"request_timeout?","visibility":"Public","body":"self == REQUEST_TIMEOUT"}},{"html_id":"reset_content?-instance-method","name":"reset_content?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":17,"url":null},"def":{"name":"reset_content?","visibility":"Public","body":"self == RESET_CONTENT"}},{"html_id":"see_other?-instance-method","name":"see_other?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":25,"url":null},"def":{"name":"see_other?","visibility":"Public","body":"self == SEE_OTHER"}},{"html_id":"server_error?:Bool-instance-method","name":"server_error?","doc":"Returns `true` if the response status code is between 500 and 599.\n\n```\nrequire \"http/status\"\n\nHTTP::Status::INTERNAL_SERVER_ERROR.server_error? # => true\nHTTP::Status::METHOD_NOT_ALLOWED.server_error?    # => false\n```","summary":"<p>Returns <code>true</code> if the response status code is between 500 and 599.</p>","abstract":false,"location":{"filename":"src/http/status.cr","line_number":155,"url":null},"def":{"name":"server_error?","return_type":"Bool","visibility":"Public","body":"500 <= (__temp_64 = code) && __temp_64 <= 599"}},{"html_id":"service_unavailable?-instance-method","name":"service_unavailable?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":62,"url":null},"def":{"name":"service_unavailable?","visibility":"Public","body":"self == SERVICE_UNAVAILABLE"}},{"html_id":"success?:Bool-instance-method","name":"success?","doc":"Returns `true` if the response status code is between 200 and 299.\n\n```\nrequire \"http/status\"\n\nHTTP::Status::NO_CONTENT.success?            # => true\nHTTP::Status::INTERNAL_SERVER_ERROR.success? # => false\n```","summary":"<p>Returns <code>true</code> if the response status code is between 200 and 299.</p>","abstract":false,"location":{"filename":"src/http/status.cr","line_number":119,"url":null},"def":{"name":"success?","return_type":"Bool","visibility":"Public","body":"200 <= (__temp_61 = code) && __temp_61 <= 299"}},{"html_id":"switch_proxy?-instance-method","name":"switch_proxy?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":28,"url":null},"def":{"name":"switch_proxy?","visibility":"Public","body":"self == SWITCH_PROXY"}},{"html_id":"switching_protocols?-instance-method","name":"switching_protocols?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":9,"url":null},"def":{"name":"switching_protocols?","visibility":"Public","body":"self == SWITCHING_PROTOCOLS"}},{"html_id":"temporary_redirect?-instance-method","name":"temporary_redirect?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":29,"url":null},"def":{"name":"temporary_redirect?","visibility":"Public","body":"self == TEMPORARY_REDIRECT"}},{"html_id":"too_many_requests?-instance-method","name":"too_many_requests?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":56,"url":null},"def":{"name":"too_many_requests?","visibility":"Public","body":"self == TOO_MANY_REQUESTS"}},{"html_id":"unauthorized?-instance-method","name":"unauthorized?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":32,"url":null},"def":{"name":"unauthorized?","visibility":"Public","body":"self == UNAUTHORIZED"}},{"html_id":"unavailable_for_legal_reasons?-instance-method","name":"unavailable_for_legal_reasons?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":58,"url":null},"def":{"name":"unavailable_for_legal_reasons?","visibility":"Public","body":"self == UNAVAILABLE_FOR_LEGAL_REASONS"}},{"html_id":"unprocessable_entity?-instance-method","name":"unprocessable_entity?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":51,"url":null},"def":{"name":"unprocessable_entity?","visibility":"Public","body":"self == UNPROCESSABLE_ENTITY"}},{"html_id":"unsupported_media_type?-instance-method","name":"unsupported_media_type?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":46,"url":null},"def":{"name":"unsupported_media_type?","visibility":"Public","body":"self == UNSUPPORTED_MEDIA_TYPE"}},{"html_id":"upgrade_required?-instance-method","name":"upgrade_required?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":54,"url":null},"def":{"name":"upgrade_required?","visibility":"Public","body":"self == UPGRADE_REQUIRED"}},{"html_id":"uri_too_long?-instance-method","name":"uri_too_long?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":45,"url":null},"def":{"name":"uri_too_long?","visibility":"Public","body":"self == URI_TOO_LONG"}},{"html_id":"use_proxy?-instance-method","name":"use_proxy?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":27,"url":null},"def":{"name":"use_proxy?","visibility":"Public","body":"self == USE_PROXY"}},{"html_id":"variant_also_negotiates?-instance-method","name":"variant_also_negotiates?","abstract":false,"location":{"filename":"src/http/status.cr","line_number":65,"url":null},"def":{"name":"variant_also_negotiates?","visibility":"Public","body":"self == VARIANT_ALSO_NEGOTIATES"}}]},{"html_id":"Crystal/HTTP/WebSocket","path":"HTTP/WebSocket.html","kind":"class","full_name":"HTTP::WebSocket","name":"WebSocket","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/web_socket.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"constructors":[{"html_id":"new(host:String,path:String,port=nil,tls:HTTP::Client::TLSContext=nil,headers=HTTP::Headers.new)-class-method","name":"new","doc":"Opens a new websocket to the target host. This will also handle the handshake\nand will raise an exception if the handshake did not complete successfully.\n\n```\nrequire \"http/web_socket\"\n\nHTTP::WebSocket.new(\"websocket.example.com\", \"/chat\")            # Creates a new WebSocket to `websocket.example.com`\nHTTP::WebSocket.new(\"websocket.example.com\", \"/chat\", tls: true) # Creates a new WebSocket with TLS to `ẁebsocket.example.com`\n```","summary":"<p>Opens a new websocket to the target host.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"path","external_name":"path","restriction":"String"},{"name":"port","default_value":"nil","external_name":"port","restriction":""},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"HTTP::Client::TLSContext"},{"name":"headers","default_value":"HTTP::Headers.new","external_name":"headers","restriction":""}],"args_string":"(host : String, path : String, port = nil, tls : HTTP::Client::TLSContext = nil, headers = HTTP::Headers.new)","args_html":"(host : <a href=\"../String.html\">String</a>, path : <a href=\"../String.html\">String</a>, port = <span class=\"n\">nil</span>, tls : <a href=\"../HTTP/Client/TLSContext.html\">HTTP::Client::TLSContext</a> = <span class=\"n\">nil</span>, headers = <span class=\"t\">HTTP</span><span class=\"t\">::</span><span class=\"t\">Headers</span>.<span class=\"k\">new</span>)","location":{"filename":"src/http/web_socket.cr","line_number":49,"url":null},"def":{"name":"new","args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"path","external_name":"path","restriction":"String"},{"name":"port","default_value":"nil","external_name":"port","restriction":""},{"name":"tls","default_value":"nil","external_name":"tls","restriction":"HTTP::Client::TLSContext"},{"name":"headers","default_value":"HTTP::Headers.new","external_name":"headers","restriction":""}],"visibility":"Public","body":"new(Protocol.new(host, path, port, tls, headers))"}},{"html_id":"new(uri:URI|String,headers=HTTP::Headers.new)-class-method","name":"new","doc":"Opens a new websocket using the information provided by the URI. This will also handle the handshake\nand will raise an exception if the handshake did not complete successfully. This method will also raise\nan exception if the URI is missing the host and/or the path.\n\nPlease note that the scheme will only be used to identify if TLS should be used or not. Therefore, schemes\napart from `wss` and `https` will be treated as the default which is `ws`.\n\n```\nrequire \"http/web_socket\"\n\nHTTP::WebSocket.new(URI.parse(\"ws://websocket.example.com/chat\"))        # Creates a new WebSocket to `websocket.example.com`\nHTTP::WebSocket.new(URI.parse(\"wss://websocket.example.com/chat\"))       # Creates a new WebSocket with TLS to `websocket.example.com`\nHTTP::WebSocket.new(URI.parse(\"http://websocket.example.com:8080/chat\")) # Creates a new WebSocket to `websocket.example.com` on port `8080`\nHTTP::WebSocket.new(URI.parse(\"ws://websocket.example.com/chat\"),        # Creates a new WebSocket to `websocket.example.com` with an Authorization header\n  HTTP::Headers{\"Authorization\" => \"Bearer authtoken\"})\nHTTP::WebSocket.new(\n  URI.parse(\"ws://user:password@websocket.example.com/chat\")) # Creates a new WebSocket to `websocket.example.com` with an HTTP basic auth Authorization header\n```","summary":"<p>Opens a new websocket using the information provided by the URI.</p>","abstract":false,"args":[{"name":"uri","external_name":"uri","restriction":"URI | String"},{"name":"headers","default_value":"HTTP::Headers.new","external_name":"headers","restriction":""}],"args_string":"(uri : URI | String, headers = HTTP::Headers.new)","args_html":"(uri : <a href=\"../URI.html\">URI</a> | <a href=\"../String.html\">String</a>, headers = <span class=\"t\">HTTP</span><span class=\"t\">::</span><span class=\"t\">Headers</span>.<span class=\"k\">new</span>)","location":{"filename":"src/http/web_socket.cr","line_number":36,"url":null},"def":{"name":"new","args":[{"name":"uri","external_name":"uri","restriction":"URI | String"},{"name":"headers","default_value":"HTTP::Headers.new","external_name":"headers","restriction":""}],"visibility":"Public","body":"new(Protocol.new(uri, headers: headers))"}}],"instance_methods":[{"html_id":"close(code:CloseCode|Int?=nil,message=nil):Nil-instance-method","name":"close","doc":"Sends a close frame to the client, and closes the connection.\nThe close frame may contain a body (message) that indicates the reason for closing.","summary":"<p>Sends a close frame to the client, and closes the connection.</p>","abstract":false,"args":[{"name":"code","default_value":"nil","external_name":"code","restriction":"CloseCode | Int | ::Nil"},{"name":"message","default_value":"nil","external_name":"message","restriction":""}],"args_string":"(code : CloseCode | Int? = nil, message = nil) : Nil","args_html":"(code : <a href=\"../HTTP/WebSocket/CloseCode.html\">CloseCode</a> | <a href=\"../Int.html\">Int</a>? = <span class=\"n\">nil</span>, message = <span class=\"n\">nil</span>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/http/web_socket.cr","line_number":110,"url":null},"def":{"name":"close","args":[{"name":"code","default_value":"nil","external_name":"code","restriction":"CloseCode | Int | ::Nil"},{"name":"message","default_value":"nil","external_name":"message","restriction":""}],"return_type":"Nil","visibility":"Public","body":"if closed?\n  return\nend\n@closed = true\n@ws.close(code, message)\n"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","abstract":false,"location":{"filename":"src/http/web_socket.cr","line_number":5,"url":null},"def":{"name":"closed?","visibility":"Public","body":"@closed"}},{"html_id":"on_binary(&on_binary:Bytes->)-instance-method","name":"on_binary","doc":"Called when the server receives a binary message from a client.","summary":"<p>Called when the server receives a binary message from a client.</p>","abstract":false,"location":{"filename":"src/http/web_socket.cr","line_number":66,"url":null},"def":{"name":"on_binary","yields":1,"block_arg":{"name":"on_binary","external_name":"on_binary","restriction":"(Bytes ->)"},"visibility":"Public","body":"@on_binary = on_binary"}},{"html_id":"on_close(&on_close:CloseCode,String->)-instance-method","name":"on_close","doc":"Called when the server closes a client's connection.","summary":"<p>Called when the server closes a client's connection.</p>","abstract":false,"location":{"filename":"src/http/web_socket.cr","line_number":70,"url":null},"def":{"name":"on_close","yields":2,"block_arg":{"name":"on_close","external_name":"on_close","restriction":"(CloseCode, String ->)"},"visibility":"Public","body":"@on_close = on_close"}},{"html_id":"on_message(&on_message:String->)-instance-method","name":"on_message","doc":"Called when the server receives a text message from a client.","summary":"<p>Called when the server receives a text message from a client.</p>","abstract":false,"location":{"filename":"src/http/web_socket.cr","line_number":62,"url":null},"def":{"name":"on_message","yields":1,"block_arg":{"name":"on_message","external_name":"on_message","restriction":"(String ->)"},"visibility":"Public","body":"@on_message = on_message"}},{"html_id":"on_ping(&on_ping:String->)-instance-method","name":"on_ping","doc":"Called when the server sends a ping to a client.","summary":"<p>Called when the server sends a ping to a client.</p>","abstract":false,"location":{"filename":"src/http/web_socket.cr","line_number":54,"url":null},"def":{"name":"on_ping","yields":1,"block_arg":{"name":"on_ping","external_name":"on_ping","restriction":"(String ->)"},"visibility":"Public","body":"@on_ping = on_ping"}},{"html_id":"on_pong(&on_pong:String->)-instance-method","name":"on_pong","doc":"Called when the server receives a pong from a client.","summary":"<p>Called when the server receives a pong from a client.</p>","abstract":false,"location":{"filename":"src/http/web_socket.cr","line_number":58,"url":null},"def":{"name":"on_pong","yields":1,"block_arg":{"name":"on_pong","external_name":"on_pong","restriction":"(String ->)"},"visibility":"Public","body":"@on_pong = on_pong"}},{"html_id":"ping(message=nil)-instance-method","name":"ping","doc":"It's possible to send a PING frame, which the client must respond to\nwith a PONG, or the server can send an unsolicited PONG frame\nwhich the client should not respond to.\n\nSee `#pong`.","summary":"<p>It's possible to send a PING frame, which the client must respond to with a PONG, or the server can send an unsolicited PONG frame which the client should not respond to.</p>","abstract":false,"args":[{"name":"message","default_value":"nil","external_name":"message","restriction":""}],"args_string":"(message = nil)","args_html":"(message = <span class=\"n\">nil</span>)","location":{"filename":"src/http/web_socket.cr","line_number":88,"url":null},"def":{"name":"ping","args":[{"name":"message","default_value":"nil","external_name":"message","restriction":""}],"visibility":"Public","body":"check_open\n@ws.ping(message)\n"}},{"html_id":"pong(message=nil):Nil-instance-method","name":"pong","doc":"Server can send an unsolicited PONG frame which the client should not respond to.\n\nSee `#ping`.","summary":"<p>Server can send an unsolicited PONG frame which the client should not respond to.</p>","abstract":false,"args":[{"name":"message","default_value":"nil","external_name":"message","restriction":""}],"args_string":"(message = nil) : Nil","args_html":"(message = <span class=\"n\">nil</span>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/http/web_socket.cr","line_number":96,"url":null},"def":{"name":"pong","args":[{"name":"message","default_value":"nil","external_name":"message","restriction":""}],"return_type":"Nil","visibility":"Public","body":"check_open\n@ws.pong(message)\n"}},{"html_id":"run:Nil-instance-method","name":"run","doc":"Continuously receives messages and calls previously set callbacks until the websocket is closed.\nPing and pong messages are automatically handled.\n\n```\n# Open websocket connection\nws = HTTP::WebSocket.new(\"websocket.example.com\", \"/chat\")\n\n# Set callback\nws.on_message do |msg|\n  ws.send \"response\"\nend\n\n# Start infinite loop\nws.run\n```","summary":"<p>Continuously receives messages and calls previously set callbacks until the websocket is closed.</p>","abstract":false,"location":{"filename":"src/http/web_socket.cr","line_number":131,"url":null},"def":{"name":"run","return_type":"Nil","visibility":"Public","body":"loop do\n  begin\n    info = @ws.receive(@buffer)\n  rescue\n    @on_close.try(&.call(CloseCode::AbnormalClosure, \"\"))\n    @closed = true\n    break\n  end\n  case info.opcode\n  when .ping?\n    @current_message.write(@buffer[0, info.size])\n    if info.final\n      message = @current_message.to_s\n      @on_ping.try(&.call(message))\n      if closed?\n      else\n        pong(message)\n      end\n      @current_message.clear\n    end\n  when .pong?\n    @current_message.write(@buffer[0, info.size])\n    if info.final\n      @on_pong.try(&.call(@current_message.to_s))\n      @current_message.clear\n    end\n  when .text?\n    @current_message.write(@buffer[0, info.size])\n    if info.final\n      @on_message.try(&.call(@current_message.to_s))\n      @current_message.clear\n    end\n  when .binary?\n    @current_message.write(@buffer[0, info.size])\n    if info.final\n      @on_binary.try(&.call(@current_message.to_slice))\n      @current_message.clear\n    end\n  when .close?\n    @current_message.write(@buffer[0, info.size])\n    if info.final\n      @current_message.rewind\n      if @current_message.size >= 2\n        code = (@current_message.read_bytes(UInt16, IO::ByteFormat::NetworkEndian)).to_i\n        code = CloseCode.new(code)\n      else\n        code = CloseCode::NoStatusReceived\n      end\n      message = @current_message.gets_to_end\n      @on_close.try(&.call(code, message))\n      close\n      @current_message.clear\n      break\n    end\n  when Protocol::Opcode::CONTINUATION\n  end\nend"}},{"html_id":"send(message):Nil-instance-method","name":"send","doc":"Sends a message payload (message) to the client.","summary":"<p>Sends a message payload (message) to the client.</p>","abstract":false,"args":[{"name":"message","external_name":"message","restriction":""}],"args_string":"(message) : Nil","args_html":"(message) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/http/web_socket.cr","line_number":78,"url":null},"def":{"name":"send","args":[{"name":"message","external_name":"message","restriction":""}],"return_type":"Nil","visibility":"Public","body":"check_open\n@ws.send(message)\n"}},{"html_id":"stream(binary=true,frame_size=1024,&)-instance-method","name":"stream","abstract":false,"args":[{"name":"binary","default_value":"true","external_name":"binary","restriction":""},{"name":"frame_size","default_value":"1024","external_name":"frame_size","restriction":""}],"args_string":"(binary = true, frame_size = 1024, &)","args_html":"(binary = <span class=\"n\">true</span>, frame_size = <span class=\"n\">1024</span>, &)","location":{"filename":"src/http/web_socket.cr","line_number":101,"url":null},"def":{"name":"stream","args":[{"name":"binary","default_value":"true","external_name":"binary","restriction":""},{"name":"frame_size","default_value":"1024","external_name":"frame_size","restriction":""}],"yields":1,"visibility":"Public","body":"check_open\n@ws.stream(binary: binary, frame_size: frame_size) do |io|\n  yield io\nend\n"}}],"types":[{"html_id":"Crystal/HTTP/WebSocket/CloseCode","path":"HTTP/WebSocket/CloseCode.html","kind":"enum","full_name":"HTTP::WebSocket::CloseCode","name":"CloseCode","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/web_socket/close_code.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"NormalClosure","name":"NormalClosure","value":"1000"},{"id":"GoingAway","name":"GoingAway","value":"1001"},{"id":"ProtocolError","name":"ProtocolError","value":"1002"},{"id":"UnsupportedData","name":"UnsupportedData","value":"1003"},{"id":"NoStatusReceived","name":"NoStatusReceived","value":"1005"},{"id":"AbnormalClosure","name":"AbnormalClosure","value":"1006"},{"id":"InvalidFramePayloadData","name":"InvalidFramePayloadData","value":"1007"},{"id":"PolicyViolation","name":"PolicyViolation","value":"1008"},{"id":"MessageTooBig","name":"MessageTooBig","value":"1009"},{"id":"MandatoryExtension","name":"MandatoryExtension","value":"1010"},{"id":"InternalServerError","name":"InternalServerError","value":"1011"},{"id":"ServiceRestart","name":"ServiceRestart","value":"1012"},{"id":"TryAgainLater","name":"TryAgainLater","value":"1013"},{"id":"BadGateway","name":"BadGateway","value":"1014"},{"id":"TLSHandshake","name":"TLSHandshake","value":"1015"}],"namespace":{"html_id":"Crystal/HTTP/WebSocket","kind":"class","full_name":"HTTP::WebSocket","name":"WebSocket"},"constructors":[{"html_id":"new(close_code:Int32)-class-method","name":"new","doc":"Create a new instance with the given close code, or raise an\nerror if the close code given is not inside 0..4999.","summary":"<p>Create a new instance with the given close code, or raise an error if the close code given is not inside 0..4999.</p>","abstract":false,"args":[{"name":"close_code","external_name":"close_code","restriction":"Int32"}],"args_string":"(close_code : Int32)","args_html":"(close_code : <a href=\"../../Int32.html\">Int32</a>)","location":{"filename":"src/http/web_socket/close_code.cr","line_number":20,"url":null},"def":{"name":"new","args":[{"name":"close_code","external_name":"close_code","restriction":"Int32"}],"visibility":"Public","body":"if 0 <= close_code && close_code <= 4999\nelse\n  raise(ArgumentError.new(\"Invalid HTTP::WebSocket::CloseCode: #{close_code}\"))\nend\nprevious_def(close_code)\n"}}],"instance_methods":[{"html_id":"abnormal_closure?-instance-method","name":"abnormal_closure?","abstract":false,"location":{"filename":"src/http/web_socket/close_code.cr","line_number":7,"url":null},"def":{"name":"abnormal_closure?","visibility":"Public","body":"self == AbnormalClosure"}},{"html_id":"bad_gateway?-instance-method","name":"bad_gateway?","abstract":false,"location":{"filename":"src/http/web_socket/close_code.cr","line_number":15,"url":null},"def":{"name":"bad_gateway?","visibility":"Public","body":"self == BadGateway"}},{"html_id":"going_away?-instance-method","name":"going_away?","abstract":false,"location":{"filename":"src/http/web_socket/close_code.cr","line_number":3,"url":null},"def":{"name":"going_away?","visibility":"Public","body":"self == GoingAway"}},{"html_id":"internal_server_error?-instance-method","name":"internal_server_error?","abstract":false,"location":{"filename":"src/http/web_socket/close_code.cr","line_number":12,"url":null},"def":{"name":"internal_server_error?","visibility":"Public","body":"self == InternalServerError"}},{"html_id":"invalid_frame_payload_data?-instance-method","name":"invalid_frame_payload_data?","abstract":false,"location":{"filename":"src/http/web_socket/close_code.cr","line_number":8,"url":null},"def":{"name":"invalid_frame_payload_data?","visibility":"Public","body":"self == InvalidFramePayloadData"}},{"html_id":"mandatory_extension?-instance-method","name":"mandatory_extension?","abstract":false,"location":{"filename":"src/http/web_socket/close_code.cr","line_number":11,"url":null},"def":{"name":"mandatory_extension?","visibility":"Public","body":"self == MandatoryExtension"}},{"html_id":"message_too_big?-instance-method","name":"message_too_big?","abstract":false,"location":{"filename":"src/http/web_socket/close_code.cr","line_number":10,"url":null},"def":{"name":"message_too_big?","visibility":"Public","body":"self == MessageTooBig"}},{"html_id":"no_status_received?-instance-method","name":"no_status_received?","abstract":false,"location":{"filename":"src/http/web_socket/close_code.cr","line_number":6,"url":null},"def":{"name":"no_status_received?","visibility":"Public","body":"self == NoStatusReceived"}},{"html_id":"normal_closure?-instance-method","name":"normal_closure?","abstract":false,"location":{"filename":"src/http/web_socket/close_code.cr","line_number":2,"url":null},"def":{"name":"normal_closure?","visibility":"Public","body":"self == NormalClosure"}},{"html_id":"policy_violation?-instance-method","name":"policy_violation?","abstract":false,"location":{"filename":"src/http/web_socket/close_code.cr","line_number":9,"url":null},"def":{"name":"policy_violation?","visibility":"Public","body":"self == PolicyViolation"}},{"html_id":"protocol_error?-instance-method","name":"protocol_error?","abstract":false,"location":{"filename":"src/http/web_socket/close_code.cr","line_number":4,"url":null},"def":{"name":"protocol_error?","visibility":"Public","body":"self == ProtocolError"}},{"html_id":"service_restart?-instance-method","name":"service_restart?","abstract":false,"location":{"filename":"src/http/web_socket/close_code.cr","line_number":13,"url":null},"def":{"name":"service_restart?","visibility":"Public","body":"self == ServiceRestart"}},{"html_id":"tls_handshake?-instance-method","name":"tls_handshake?","abstract":false,"location":{"filename":"src/http/web_socket/close_code.cr","line_number":16,"url":null},"def":{"name":"tls_handshake?","visibility":"Public","body":"self == TLSHandshake"}},{"html_id":"try_again_later?-instance-method","name":"try_again_later?","abstract":false,"location":{"filename":"src/http/web_socket/close_code.cr","line_number":14,"url":null},"def":{"name":"try_again_later?","visibility":"Public","body":"self == TryAgainLater"}},{"html_id":"unsupported_data?-instance-method","name":"unsupported_data?","abstract":false,"location":{"filename":"src/http/web_socket/close_code.cr","line_number":5,"url":null},"def":{"name":"unsupported_data?","visibility":"Public","body":"self == UnsupportedData"}}]}]},{"html_id":"Crystal/HTTP/WebSocketHandler","path":"HTTP/WebSocketHandler.html","kind":"class","full_name":"HTTP::WebSocketHandler","name":"WebSocketHandler","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/http/server/handlers/websocket_handler.cr","line_number":17,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/HTTP/Handler","kind":"module","full_name":"HTTP::Handler","name":"Handler"}],"namespace":{"html_id":"Crystal/HTTP","kind":"module","full_name":"HTTP","name":"HTTP"},"doc":"A handler which adds websocket functionality to an `HTTP::Server`.\n\nWhen a request can be upgraded, the associated `HTTP::Websocket` and\n`HTTP::Server::Context` will be yielded to the block. For example:\n\n```\nws_handler = HTTP::WebSocketHandler.new do |ws, ctx|\n  ws.on_ping { ws.pong ctx.request.path }\nend\nserver = HTTP::Server.new [ws_handler]\n```","summary":"<p>A handler which adds websocket functionality to an <code><a href=\"../HTTP/Server.html\">HTTP::Server</a></code>.</p>","constructors":[{"html_id":"new(&proc:WebSocket,Server::Context->)-class-method","name":"new","abstract":false,"location":{"filename":"src/http/server/handlers/websocket_handler.cr","line_number":20,"url":null},"def":{"name":"new","yields":2,"block_arg":{"name":"proc","external_name":"proc","restriction":"(WebSocket, Server::Context ->)"},"visibility":"Public","body":"_ = allocate\n_.initialize(&proc) do |_arg0, _arg1|\n  yield _arg0, _arg1\nend\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"call(context):Nil-instance-method","name":"call","abstract":false,"args":[{"name":"context","external_name":"context","restriction":""}],"args_string":"(context) : Nil","args_html":"(context) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/http/server/handlers/websocket_handler.cr","line_number":23,"url":null},"def":{"name":"call","args":[{"name":"context","external_name":"context","restriction":""}],"return_type":"Nil","visibility":"Public","body":"if websocket_upgrade_request?(context.request)\nelse\n  return call_next(context)\nend\nresponse = context.response\nversion = context.request.headers[\"Sec-WebSocket-Version\"]?\nif version == WebSocket::Protocol::VERSION\nelse\n  response.status = :upgrade_required\n  response.headers[\"Sec-WebSocket-Version\"] = WebSocket::Protocol::VERSION\n  return\nend\nkey = context.request.headers[\"Sec-WebSocket-Key\"]?\nif key\nelse\n  response.respond_with_status(:bad_request)\n  return\nend\naccept_code = WebSocket::Protocol.key_challenge(key)\nresponse.status = :switching_protocols\nresponse.headers[\"Upgrade\"] = \"websocket\"\nresponse.headers[\"Connection\"] = \"Upgrade\"\nresponse.headers[\"Sec-WebSocket-Accept\"] = accept_code\nresponse.upgrade do |io|\n  ws_session = WebSocket.new(io, sync_close: false)\n  @proc.call(ws_session, context)\n  ws_session.run\nend\n"}}]}]},{"html_id":"Crystal/Indexable","path":"Indexable.html","kind":"module","full_name":"Indexable(T)","name":"Indexable","abstract":false,"ancestors":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"}],"locations":[{"filename":"src/indexable.cr","line_number":8,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"}],"including_types":[{"html_id":"Crystal/Indexable/Mutable","kind":"module","full_name":"Indexable::Mutable(T)","name":"Mutable"},{"html_id":"Crystal/LLVM/ParameterCollection","kind":"struct","full_name":"LLVM::ParameterCollection","name":"ParameterCollection"},{"html_id":"Crystal/Tuple","kind":"struct","full_name":"Tuple(*T)","name":"Tuple"}],"doc":"A container that allows accessing elements via a numeric index.\n\nIndexing starts at `0`. A negative index is assumed to be\nrelative to the end of the container: `-1` indicates the last element,\n`-2` is the next to last element, and so on.\n\nTypes including this module are typically `Array`-like types.","summary":"<p>A container that allows accessing elements via a numeric index.</p>","class_methods":[{"html_id":"cartesian_product(indexables:Indexable(Indexable))-class-method","name":"cartesian_product","doc":"Returns an `Array` of all ordered combinations of elements taken from each\nof the *indexables* as `Array`s.\nTraversal of elements starts from the last `Indexable`. If *indexables* is\nempty, the returned product contains exactly one empty `Array`.\n\n`#cartesian_product` is preferred over this class method when the quantity\nof *indexables* is known in advance.\n\n```\nIndexable.cartesian_product([[1, 2, 3], [4, 5]]) # => [[1, 4], [1, 5], [2, 4], [2, 5], [3, 4], [3, 5]]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of all ordered combinations of elements taken from each of the <em>indexables</em> as <code><a href=\"Array.html\">Array</a></code>s.</p>","abstract":false,"args":[{"name":"indexables","external_name":"indexables","restriction":"Indexable(Indexable)"}],"args_string":"(indexables : Indexable(Indexable))","args_html":"(indexables : <a href=\"Indexable.html\">Indexable</a>(<a href=\"Indexable.html\">Indexable</a>))","location":{"filename":"src/indexable.cr","line_number":209,"url":null},"def":{"name":"cartesian_product","args":[{"name":"indexables","external_name":"indexables","restriction":"Indexable(Indexable)"}],"visibility":"Public","body":"capacity = indexables.product(&.size)\nresult = Array(Array(typeof(Enumerable.element_type(Enumerable.element_type(indexables))))).new(capacity)\neach_cartesian(indexables) do |product|\n  result << product\nend\nresult\n"}},{"html_id":"each_cartesian(indexables:Indexable(Indexable),reuse=false,&)-class-method","name":"each_cartesian","doc":"Yields each ordered combination of the elements taken from each of the\n*indexables* as `Array`s.\nTraversal of elements starts from the last `Indexable`. If *indexables* is\nempty, yields an empty `Array` exactly once.\n\n`#each_cartesian` is preferred over this class method when the quantity of\n*indexables* is known in advance.\n\n```\nIndexable.each_cartesian([%w[Alice Bob Carol], [1, 2]]) do |name, n|\n  puts \"#{n}. #{name}\"\nend\n```\n\nPrints\n\n```text\n1. Alice\n2. Alice\n1. Bob\n2. Bob\n1. Carol\n2. Carol\n```\n\nBy default, a new `Array` is created and yielded for each combination.\n\n* If *reuse* is an `Array`, it will be reused\n* If *reuse* is truthy, the method will create a new `Array` and reuse it\n* If *reuse* is falsey, no `Array`s will be reused.\n\nThis can be used to prevent many memory allocations when each combination of\ninterest is to be used in a read-only fashion.","summary":"<p>Yields each ordered combination of the elements taken from each of the <em>indexables</em> as <code><a href=\"Array.html\">Array</a></code>s.</p>","abstract":false,"args":[{"name":"indexables","external_name":"indexables","restriction":"Indexable(Indexable)"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(indexables : Indexable(Indexable), reuse = false, &)","args_html":"(indexables : <a href=\"Indexable.html\">Indexable</a>(<a href=\"Indexable.html\">Indexable</a>), reuse = <span class=\"n\">false</span>, &)","location":{"filename":"src/indexable.cr","line_number":304,"url":null},"def":{"name":"each_cartesian","args":[{"name":"indexables","external_name":"indexables","restriction":"Indexable(Indexable)"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"yields":1,"visibility":"Public","body":"lens = indexables.map(&.size)\nif lens.any?(&.zero?)\n  return\nend\nn = indexables.size\npool = Array.new(n) do |i|\n  (indexables.unsafe_fetch(i)).unsafe_fetch(0)\nend\nindices = Array.new(n, 0)\nreuse = Indexable(typeof(pool.first)).check_reuse(reuse, n)\nwhile true\n  yield pool_slice(pool, n, reuse)\n  i = n\n  while true\n    i = i - 1\n    if i < 0\n      return\n    end\n    __temp_7 = i\n    indices[__temp_7] = indices[__temp_7] + 1\n    if move_to_next = (indices[i] >= lens[i])\n      indices[i] = 0\n    end\n    pool[i] = indexables[i].unsafe_fetch(indices[i])\n    if move_to_next\n    else\n      break\n    end\n  end\nend\n"}},{"html_id":"each_cartesian(indexables:Indexable(Indexable),reuse=false)-class-method","name":"each_cartesian","doc":"Returns an iterator that enumerates the ordered combinations of elements\ntaken from the *indexables* as `Array`s.\nTraversal of elements starts from the last `Indexable`. If *indexables* is\nempty, the returned iterator produces one empty `Array`, then stops.\n\n`#each_cartesian` is preferred over this class method when the quantity of\n*indexables* is known in advance.\n\n```\niter = Indexable.each_cartesian([%w[N S], %w[E W]])\niter.next # => [\"N\", \"E\"]\niter.next # => [\"N\", \"W\"]\niter.next # => [\"S\", \"E\"]\niter.next # => [\"S\", \"W\"]\niter.next # => Iterator::Stop::INSTANCE\n```\n\nBy default, a new `Array` is created and returned for each combination.\n\n* If *reuse* is an `Array`, it will be reused\n* If *reuse* is truthy, the method will create a new `Array` and reuse it\n* If *reuse* is falsey, no `Array`s will be reused.\n\nThis can be used to prevent many memory allocations when each combination of\ninterest is to be used in a read-only fashion.","summary":"<p>Returns an iterator that enumerates the ordered combinations of elements taken from the <em>indexables</em> as <code><a href=\"Array.html\">Array</a></code>s.</p>","abstract":false,"args":[{"name":"indexables","external_name":"indexables","restriction":"Indexable(Indexable)"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(indexables : Indexable(Indexable), reuse = false)","args_html":"(indexables : <a href=\"Indexable.html\">Indexable</a>(<a href=\"Indexable.html\">Indexable</a>), reuse = <span class=\"n\">false</span>)","location":{"filename":"src/indexable.cr","line_number":386,"url":null},"def":{"name":"each_cartesian","args":[{"name":"indexables","external_name":"indexables","restriction":"Indexable(Indexable)"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"visibility":"Public","body":"if indexables.any?(&.empty?)\n  Iterator.of(Iterator.stop)\nelse\n  CartesianProductIteratorN(typeof(indexables), typeof(Enumerable.element_type(Enumerable.element_type(indexables)))).new(indexables, reuse)\nend"}}],"instance_methods":[{"html_id":"[](index:Int)-instance-method","name":"[]","doc":"Returns the element at the given *index*.\n\nNegative indices can be used to start counting from the end of the array.\nRaises `IndexError` if trying to access an element outside the array's range.\n\n```\nary = ['a', 'b', 'c']\nary[0]  # => 'a'\nary[2]  # => 'c'\nary[-1] # => 'c'\nary[-2] # => 'b'\n\nary[3]  # raises IndexError\nary[-4] # raises IndexError\n```","summary":"<p>Returns the element at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","args_html":"(index : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/indexable.cr","line_number":72,"url":null},"def":{"name":"[]","args":[{"name":"index","external_name":"index","restriction":"Int"}],"visibility":"Public","body":"fetch(index) do\n  raise(IndexError.new)\nend"}},{"html_id":"[]?(index:Int)-instance-method","name":"[]?","doc":"Returns the element at the given *index*.\n\nNegative indices can be used to start counting from the end of the array.\nReturns `nil` if trying to access an element outside the array's range.\n\n```\nary = ['a', 'b', 'c']\nary[0]?  # => 'a'\nary[2]?  # => 'c'\nary[-1]? # => 'c'\nary[-2]? # => 'b'\n\nary[3]?  # nil\nary[-4]? # nil\n```","summary":"<p>Returns the element at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","args_html":"(index : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/indexable.cr","line_number":92,"url":null},"def":{"name":"[]?","args":[{"name":"index","external_name":"index","restriction":"Int"}],"visibility":"Public","body":"fetch(index, nil)"}},{"html_id":"bsearch(&:T->_)-instance-method","name":"bsearch","doc":"By using binary search, returns the first element\nfor which the passed block returns a truthy value.\n\nIf the block returns a falsey value, the element to be found lies\nbehind. If the block returns a truthy value, the element to be found\nis itself or lies in front.\n\nBinary search needs the collection to be sorted in regards to the search\ncriterion.\n\nReturns `nil` if the block didn't return a truthy value for any element.\n\n```\n[2, 5, 7, 10].bsearch { |x| x >= 4 } # => 5\n[2, 5, 7, 10].bsearch { |x| x > 10 } # => nil\n```","summary":"<p>By using binary search, returns the first element for which the passed block returns a truthy value.</p>","abstract":false,"location":{"filename":"src/indexable.cr","line_number":151,"url":null},"def":{"name":"bsearch","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> _)"},"visibility":"Public","body":"bsearch_index do |value|\n  yield value\nend.try do |index|\n  unsafe_fetch(index)\nend"}},{"html_id":"bsearch_index(&:T,Int32->_)-instance-method","name":"bsearch_index","doc":"By using binary search, returns the index of the first element\nfor which the passed block returns a truthy value.\n\nIf the block returns a falsey value, the element to be found lies\nbehind. If the block returns a truthy value, the element to be found\nis itself or lies in front.\n\nBinary search needs the collection to be sorted in regards to the search\ncriterion.\n\nReturns `nil` if the block didn't return a truthy value for any element.\n\n```\n[2, 5, 7, 10].bsearch_index { |x, i| x >= 4 } # => 1\n[2, 5, 7, 10].bsearch_index { |x, i| x > 10 } # => nil\n```","summary":"<p>By using binary search, returns the index of the first element for which the passed block returns a truthy value.</p>","abstract":false,"location":{"filename":"src/indexable.cr","line_number":171,"url":null},"def":{"name":"bsearch_index","yields":2,"block_arg":{"name":"","external_name":"","restriction":"(T, Int32 -> _)"},"visibility":"Public","body":"(0...size).bsearch do |index|\n  yield unsafe_fetch(index), index\nend"}},{"html_id":"cartesian_product(*others:Indexable)-instance-method","name":"cartesian_product","doc":"Returns an `Array` of all ordered combinations of elements taken from each\nof `self` and *others* as `Tuple`s.\nTraversal of elements starts from the last `Indexable` argument.\n\n```\n[1, 2, 3].cartesian_product({'a', 'b'})                     # => [{1, 'a'}, {1, 'b'}, {2, 'a'}, {2, 'b'}, {3, 'a'}, {3, 'b'}]\n['a', 'b'].cartesian_product({1, 2}, {'c', 'd'}).map &.join # => [\"a1c\", \"a1d\", \"a2c\", \"a2d\", \"b1c\", \"b1d\", \"b2c\", \"b2d\"]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of all ordered combinations of elements taken from each of <code>self</code> and <em>others</em> as <code><a href=\"Tuple.html\">Tuple</a></code>s.</p>","abstract":false,"args":[{"name":"others","external_name":"others","restriction":"Indexable"}],"args_string":"(*others : Indexable)","args_html":"(*others : <a href=\"Indexable.html\">Indexable</a>)","location":{"filename":"src/indexable.cr","line_number":183,"url":null},"def":{"name":"cartesian_product","args":[{"name":"others","external_name":"others","restriction":"Indexable"}],"splat_index":0,"visibility":"Public","body":"capacity = others.product(size, &.size)\nresult = Array(typeof(cartesian_product_type(*others))).new(capacity)\neach_cartesian(*others) do |product|\n  result << product\nend\nresult\n"}},{"html_id":"combinations(size:Int=self.size)-instance-method","name":"combinations","abstract":false,"args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"}],"args_string":"(size : Int = self.size)","args_html":"(size : <a href=\"Int.html\">Int</a> = <span class=\"k\">self</span>.size)","location":{"filename":"src/indexable.cr","line_number":1053,"url":null},"def":{"name":"combinations","args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"}],"visibility":"Public","body":"ary = [] of Array(T)\neach_combination(size) do |a|\n  ary << a\nend\nary\n"}},{"html_id":"dig(index:Int,*subindexes)-instance-method","name":"dig","doc":"Traverses the depth of a structure and returns the value, otherwise\nraises `IndexError`.\n\n```\nary = [{1, 2, 3, {4, 5, 6}}]\nary.dig(0, 3, 2) # => 6\nary.dig(0, 3, 3) # raises IndexError\n```","summary":"<p>Traverses the depth of a structure and returns the value, otherwise raises <code><a href=\"IndexError.html\">IndexError</a></code>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"subindexes","external_name":"subindexes","restriction":""}],"args_string":"(index : Int, *subindexes)","args_html":"(index : <a href=\"Int.html\">Int</a>, *subindexes)","location":{"filename":"src/indexable.cr","line_number":123,"url":null},"def":{"name":"dig","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"subindexes","external_name":"subindexes","restriction":""}],"splat_index":1,"visibility":"Public","body":"if (value = self[index]) && (value.responds_to?(:dig))\n  return value.dig(*subindexes)\nend\nraise(IndexError.new(\"Indexable value not diggable for index: #{index.inspect}\"))\n"}},{"html_id":"dig?(index:Int,*subindexes)-instance-method","name":"dig?","doc":"Traverses the depth of a structure and returns the value.\nReturns `nil` if not found.\n\n```\nary = [{1, 2, 3, {4, 5, 6}}]\nary.dig?(0, 3, 2) # => 6\nary.dig?(0, 3, 3) # => nil\n```","summary":"<p>Traverses the depth of a structure and returns the value.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"subindexes","external_name":"subindexes","restriction":""}],"args_string":"(index : Int, *subindexes)","args_html":"(index : <a href=\"Int.html\">Int</a>, *subindexes)","location":{"filename":"src/indexable.cr","line_number":104,"url":null},"def":{"name":"dig?","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"subindexes","external_name":"subindexes","restriction":""}],"splat_index":1,"visibility":"Public","body":"if (value = self[index]?) && (value.responds_to?(:\"dig?\"))\n  value.dig?(*subindexes)\nend"}},{"html_id":"each(&:T->)-instance-method","name":"each","doc":"Calls the given block once for each element in `self`, passing that\nelement as a parameter.\n\n```\na = [\"a\", \"b\", \"c\"]\na.each { |x| print x, \" -- \" }\n```\n\nproduces:\n\n```text\na -- b -- c --\n```","summary":"<p>Calls the given block once for each element in <code>self</code>, passing that element as a parameter.</p>","abstract":false,"location":{"filename":"src/indexable.cr","line_number":483,"url":null},"def":{"name":"each","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"visibility":"Public","body":"each_index do |i|\n  yield unsafe_fetch(i)\nend"}},{"html_id":"each-instance-method","name":"each","doc":"Returns an `Iterator` for the elements of `self`.\n\n```\na = [\"a\", \"b\", \"c\"]\niter = a.each\niter.next # => \"a\"\niter.next # => \"b\"\n```\n\nThe returned iterator keeps a reference to `self`: if the array\nchanges, the returned values of the iterator change as well.","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> for the elements of <code>self</code>.</p>","abstract":false,"location":{"filename":"src/indexable.cr","line_number":500,"url":null},"def":{"name":"each","visibility":"Public","body":"ItemIterator(self, T).new(self)"}},{"html_id":"each(*,start:Int,count:Int,&:T->)-instance-method","name":"each","doc":"Calls the given block once for `count` number of elements in `self`\nstarting from index `start`, passing each element as a parameter.\n\nNegative indices count backward from the end of the array. (-1 is the\nlast element).\n\nRaises `IndexError` if the starting index is out of range.\nRaises `ArgumentError` if `count` is a negative number.\n\n```\narray = [\"a\", \"b\", \"c\", \"d\", \"e\"]\narray.each(start: 1, count: 3) { |x| print x, \" -- \" }\n```\n\nproduces:\n\n```text\nb -- c -- d --\n```","summary":"<p>Calls the given block once for <code>count</code> number of elements in <code>self</code> starting from index <code>start</code>, passing each element as a parameter.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(*, start : Int, count : Int, & : T -> )","args_html":"(*, start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>, & : T -> )","location":{"filename":"src/indexable.cr","line_number":523,"url":null},"def":{"name":"each","args":[{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"splat_index":0,"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"visibility":"Public","body":"each_index(start: start, count: count) do |i|\n  yield unsafe_fetch(i)\nend"}},{"html_id":"each(*,withinrange:Range,&:T->)-instance-method","name":"each","doc":"Calls the given block once for all elements at indices within the given\n`range`, passing each element as a parameter.\n\nRaises `IndexError` if the starting index is out of range.\n\n```\narray = [\"a\", \"b\", \"c\", \"d\", \"e\"]\narray.each(within: 1..3) { |x| print x, \" -- \" }\n```\n\nproduces:\n\n```text\nb -- c -- d --\n```","summary":"<p>Calls the given block once for all elements at indices within the given <code>range</code>, passing each element as a parameter.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"range","external_name":"within","restriction":"Range"}],"args_string":"(*, within range : Range, & : T -> )","args_html":"(*, within range : <a href=\"Range.html\">Range</a>, & : T -> )","location":{"filename":"src/indexable.cr","line_number":544,"url":null},"def":{"name":"each","args":[{"name":"","external_name":"","restriction":""},{"name":"range","external_name":"within","restriction":"Range"}],"splat_index":0,"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"visibility":"Public","body":"start, count = (Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new))\neach(start: start, count: count) do |element|\n  yield element\nend\n"}},{"html_id":"each_cartesian(*others:Indexable,&)-instance-method","name":"each_cartesian","doc":"Yields each ordered combination of the elements taken from each of `self`\nand *others* as a `Tuple`.\nTraversal of elements starts from the last `Indexable` argument.\n\n```\n[\"Alice\", \"Bob\"].each_cartesian({1, 2, 3}) do |name, n|\n  puts \"#{n}. #{name}\"\nend\n```\n\nPrints\n\n```text\n1. Alice\n2. Alice\n3. Alice\n1. Bob\n2. Bob\n3. Bob\n```","summary":"<p>Yields each ordered combination of the elements taken from each of <code>self</code> and <em>others</em> as a <code><a href=\"Tuple.html\">Tuple</a></code>.</p>","abstract":false,"args":[{"name":"others","external_name":"others","restriction":"Indexable"}],"args_string":"(*others : Indexable, &)","args_html":"(*others : <a href=\"Indexable.html\">Indexable</a>, &)","location":{"filename":"src/indexable.cr","line_number":238,"url":null},"def":{"name":"each_cartesian","args":[{"name":"others","external_name":"others","restriction":"Indexable"}],"splat_index":0,"yields":1,"visibility":"Public","body":"Indexable.each_cartesian_impl(self, *others) do |v|\n  yield v\nend"}},{"html_id":"each_cartesian(*others:Indexable)-instance-method","name":"each_cartesian","doc":"Returns an iterator that enumerates the ordered combinations of elements\ntaken from each of `self` and *others* as `Tuple`s.\nTraversal of elements starts from the last `Indexable` argument.\n\n```\niter = {1, 2, 3}.each_cartesian({'a', 'b'})\niter.next # => {1, 'a'}\niter.next # => {1, 'b'}\niter.next # => {2, 'a'}\niter.next # => {2, 'b'}\niter.next # => {3, 'a'}\niter.next # => {3, 'b'}\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that enumerates the ordered combinations of elements taken from each of <code>self</code> and <em>others</em> as <code><a href=\"Tuple.html\">Tuple</a></code>s.</p>","abstract":false,"args":[{"name":"others","external_name":"others","restriction":"Indexable"}],"args_string":"(*others : Indexable)","args_html":"(*others : <a href=\"Indexable.html\">Indexable</a>)","location":{"filename":"src/indexable.cr","line_number":345,"url":null},"def":{"name":"each_cartesian","args":[{"name":"others","external_name":"others","restriction":"Indexable"}],"splat_index":0,"visibility":"Public","body":"Indexable.each_cartesian_impl(self, *others)"}},{"html_id":"each_combination(size:Int=self.size,reuse=false,&):Nil-instance-method","name":"each_combination","abstract":false,"args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int = self.size, reuse = false, &) : Nil","args_html":"(size : <a href=\"Int.html\">Int</a> = <span class=\"k\">self</span>.size, reuse = <span class=\"n\">false</span>, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/indexable.cr","line_number":1061,"url":null},"def":{"name":"each_combination","args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"yields":1,"return_type":"Nil","visibility":"Public","body":"n = self.size\nif size > n\n  return\nend\nif size < 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nreuse = Indexable(T).check_reuse(reuse, size)\ncopy = self.dup\npool = dup_as_array(self)\nindices = (0...size).to_a\nyield pool_slice(pool, size, reuse)\nwhile true\n  stop = true\n  i = size - 1\n  while i >= 0\n    if indices[i] != ((i + n) - size)\n      stop = false\n      break\n    end\n    i = i - 1\n  end\n  if stop\n    return\n  end\n  __temp_25 = i\n  indices[__temp_25] = indices[__temp_25] + 1\n  pool[i] = copy[indices[i]]\n  (i + 1).upto(size - 1) do |j|\n    indices[j] = indices[j - 1] + 1\n    pool[j] = copy[indices[j]]\n  end\n  yield pool_slice(pool, size, reuse)\nend\n"}},{"html_id":"each_combination(size:Int=self.size,reuse=false)-instance-method","name":"each_combination","abstract":false,"args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int = self.size, reuse = false)","args_html":"(size : <a href=\"Int.html\">Int</a> = <span class=\"k\">self</span>.size, reuse = <span class=\"n\">false</span>)","location":{"filename":"src/indexable.cr","line_number":1109,"url":null},"def":{"name":"each_combination","args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"visibility":"Public","body":"if size < 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nCombinationIterator(self, T).new(self, size.to_i, Indexable(T).check_reuse(reuse, size))\n"}},{"html_id":"each_index(&:Int32->):Nil-instance-method","name":"each_index","doc":"Calls the given block once for each index in `self`, passing that\nindex as a parameter.\n\n```\na = [\"a\", \"b\", \"c\"]\na.each_index { |x| print x, \" -- \" }\n```\n\nproduces:\n\n```text\n0 -- 1 -- 2 --\n```","summary":"<p>Calls the given block once for each index in <code>self</code>, passing that index as a parameter.</p>","abstract":false,"location":{"filename":"src/indexable.cr","line_number":562,"url":null},"def":{"name":"each_index","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Int32 ->)"},"return_type":"Nil","visibility":"Public","body":"i = 0\nwhile i < size\n  yield i\n  i = i + 1\nend\n"}},{"html_id":"each_index-instance-method","name":"each_index","doc":"Returns an `Iterator` for each index in `self`.\n\n```\na = [\"a\", \"b\", \"c\"]\niter = a.each_index\niter.next # => 0\niter.next # => 1\n```\n\nThe returned iterator keeps a reference to `self`. If the array\nchanges, the returned values of the iterator will change as well.","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> for each index in <code>self</code>.</p>","abstract":false,"location":{"filename":"src/indexable.cr","line_number":581,"url":null},"def":{"name":"each_index","visibility":"Public","body":"IndexIterator.new(self)"}},{"html_id":"each_index(*,start:Int,count:Int,&)-instance-method","name":"each_index","doc":"Calls the given block once for `count` number of indices in `self`\nstarting from index `start`, passing each index as a parameter.\n\nNegative indices count backward from the end of the array. (-1 is the\nlast element).\n\nRaises `IndexError` if the starting index is out of range.\nRaises `ArgumentError` if `count` is a negative number.\n\n```\narray = [\"a\", \"b\", \"c\", \"d\", \"e\"]\narray.each_index(start: -3, count: 2) { |x| print x, \" -- \" }\n```\n\nproduces:\n\n```text\n2 -- 3 --\n```","summary":"<p>Calls the given block once for <code>count</code> number of indices in <code>self</code> starting from index <code>start</code>, passing each index as a parameter.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(*, start : Int, count : Int, &)","args_html":"(*, start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>, &)","location":{"filename":"src/indexable.cr","line_number":604,"url":null},"def":{"name":"each_index","args":[{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"splat_index":0,"yields":1,"visibility":"Public","body":"if count < 0\n  raise(ArgumentError.new(\"Negative count: #{count}\"))\nend\nif start < 0\n  start = start + size\nend\nif 0 <= start && start <= size\nelse\n  raise(IndexError.new)\nend\ni = start\nwhile i < (Math.min(start + count, size))\n  yield i\n  i = i + 1\nend\nself\n"}},{"html_id":"each_permutation(size:Int=self.size,reuse=false,&):Nil-instance-method","name":"each_permutation","doc":"Yields each possible permutation of *size* of `self`.\n\n```\na = [1, 2, 3]\nsums = [] of Int32\na.each_permutation(2) { |p| sums << p.sum } # => nil\nsums                                        # => [3, 4, 3, 5, 4, 5]\n```\n\nBy default, a new array is created and yielded for each permutation.\nIf *reuse* is given, the array can be reused: if *reuse* is\nan `Array`, this array will be reused; if *reuse* if truthy,\nthe method will create a new array and reuse it. This can be\nused to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Yields each possible permutation of <em>size</em> of <code>self</code>.</p>","abstract":false,"args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int = self.size, reuse = false, &) : Nil","args_html":"(size : <a href=\"Int.html\">Int</a> = <span class=\"k\">self</span>.size, reuse = <span class=\"n\">false</span>, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/indexable.cr","line_number":994,"url":null},"def":{"name":"each_permutation","args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"yields":1,"return_type":"Nil","visibility":"Public","body":"n = self.size\nif size > n\n  return\nend\nif size < 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\npool = dup_as_array(self)\nreuse = Indexable(T).check_reuse(reuse, size)\ncycles = (((n - size) + 1)..n).to_a.reverse!\nyield pool_slice(pool, size, reuse)\nwhile true\n  stop = true\n  i = size - 1\n  while i >= 0\n    ci = ((    __temp_23 = i\n    cycles[__temp_23] = cycles[__temp_23] - 1))\n    if ci == 0\n      e = pool[i]\n      (i + 1).upto(n - 1) do |j|\n        pool[j - 1] = pool[j]\n      end\n      pool[n - 1] = e\n      cycles[i] = n - i\n    else\n      pool.swap(i, -ci)\n      yield pool_slice(pool, size, reuse)\n      stop = false\n      break\n    end\n    i = i - 1\n  end\n  if stop\n    return\n  end\nend\n"}},{"html_id":"each_permutation(size:Int=self.size,reuse=false)-instance-method","name":"each_permutation","doc":"Returns an `Iterator` over each possible permutation of *size* of `self`.\n\n```\niter = [1, 2, 3].each_permutation\niter.next # => [1, 2, 3]\niter.next # => [1, 3, 2]\niter.next # => [2, 1, 3]\niter.next # => [2, 3, 1]\niter.next # => [3, 1, 2]\niter.next # => [3, 2, 1]\niter.next # => #<Iterator::Stop>\n```\n\nBy default, a new array is created and returned for each permutation.\nIf *reuse* is given, the array can be reused: if *reuse* is\nan `Array`, this array will be reused; if *reuse* if truthy,\nthe method will create a new array and reuse it. This can be\nused to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> over each possible permutation of <em>size</em> of <code>self</code>.</p>","abstract":false,"args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int = self.size, reuse = false)","args_html":"(size : <a href=\"Int.html\">Int</a> = <span class=\"k\">self</span>.size, reuse = <span class=\"n\">false</span>)","location":{"filename":"src/indexable.cr","line_number":1047,"url":null},"def":{"name":"each_permutation","args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"visibility":"Public","body":"if size < 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nPermutationIterator(self, T).new(self, size.to_i, Indexable(T).check_reuse(reuse, size))\n"}},{"html_id":"each_repeated_combination(size:Int=self.size,reuse=false,&):Nil-instance-method","name":"each_repeated_combination","abstract":false,"args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int = self.size, reuse = false, &) : Nil","args_html":"(size : <a href=\"Int.html\">Int</a> = <span class=\"k\">self</span>.size, reuse = <span class=\"n\">false</span>, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/indexable.cr","line_number":1123,"url":null},"def":{"name":"each_repeated_combination","args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"yields":1,"return_type":"Nil","visibility":"Public","body":"n = self.size\nif size > n && (n == 0)\n  return\nend\nif size < 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nreuse = Indexable(T).check_reuse(reuse, size)\ncopy = self.dup\nindices = Array.new(size, 0)\npool = indices.map do |i|\n  copy[i]\nend\nyield pool_slice(pool, size, reuse)\nwhile true\n  stop = true\n  i = size - 1\n  while i >= 0\n    if indices[i] != (n - 1)\n      stop = false\n      break\n    end\n    i = i - 1\n  end\n  if stop\n    return\n  end\n  ii = indices[i] + 1\n  tmp = copy[ii]\n  indices.fill(i, size - i) do\n    ii\n  end\n  pool.fill(i, size - i) do\n    tmp\n  end\n  yield pool_slice(pool, size, reuse)\nend\n"}},{"html_id":"each_repeated_combination(size:Int=self.size,reuse=false)-instance-method","name":"each_repeated_combination","abstract":false,"args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int = self.size, reuse = false)","args_html":"(size : <a href=\"Int.html\">Int</a> = <span class=\"k\">self</span>.size, reuse = <span class=\"n\">false</span>)","location":{"filename":"src/indexable.cr","line_number":1157,"url":null},"def":{"name":"each_repeated_combination","args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"visibility":"Public","body":"if size < 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nRepeatedCombinationIterator(self, T).new(self, size.to_i, Indexable(T).check_reuse(reuse, size))\n"}},{"html_id":"empty?:Bool-instance-method","name":"empty?","doc":"Returns `true` if `self` is empty, `false` otherwise.\n\n```\n([] of Int32).empty? # => true\n([1]).empty?         # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is empty, <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/indexable.cr","line_number":703,"url":null},"def":{"name":"empty?","return_type":"Bool","visibility":"Public","body":"size == 0"}},{"html_id":"equals?(other:Indexable,&):Bool-instance-method","name":"equals?","doc":"Optimized version of `equals?` used when `other` is also an `Indexable`.","summary":"<p>Optimized version of <code><a href=\"Indexable.html#equals%3F%28other%3AIndexable%2C%26%29%3ABool-instance-method\">#equals?</a></code> used when <code>other</code> is also an <code><a href=\"Indexable.html\">Indexable</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Indexable"}],"args_string":"(other : Indexable, &) : Bool","args_html":"(other : <a href=\"Indexable.html\">Indexable</a>, &) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/indexable.cr","line_number":708,"url":null},"def":{"name":"equals?","args":[{"name":"other","external_name":"other","restriction":"Indexable"}],"yields":2,"return_type":"Bool","visibility":"Public","body":"if size != other.size\n  return false\nend\neach_with_index do |item, i|\n  if yield(item, other.unsafe_fetch(i))\n  else\n    return false\n  end\nend\ntrue\n"}},{"html_id":"equals?(other,&)-instance-method","name":"equals?","doc":"Determines if `self` equals *other* according to a comparison\ndone by the given block.\n\nIf `self`'s size is the same as *other*'s size, this method yields\nelements from `self` and *other* in tandem: if the block returns true\nfor all of them, this method returns `true`. Otherwise it returns `false`.\n\n```\na = [1, 2, 3]\nb = [\"a\", \"ab\", \"abc\"]\na.equals?(b) { |x, y| x == y.size } # => true\na.equals?(b) { |x, y| x == y }      # => false\n```","summary":"<p>Determines if <code>self</code> equals <em>other</em> according to a comparison done by the given block.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other, &)","args_html":"(other, &)","location":{"filename":"src/indexable.cr","line_number":729,"url":null},"def":{"name":"equals?","args":[{"name":"other","external_name":"other","restriction":""}],"yields":2,"visibility":"Public","body":"if size != other.size\n  return false\nend\neach_with_index do |item, i|\n  if yield(item, other[i])\n  else\n    return false\n  end\nend\ntrue\n"}},{"html_id":"fetch(index:Int,&)-instance-method","name":"fetch","doc":"Returns the element at the given *index*, if in bounds,\notherwise executes the given block with the index and returns its value.\n\n```\na = [:foo, :bar]\na.fetch(0) { :default_value }    # => :foo\na.fetch(2) { :default_value }    # => :default_value\na.fetch(2) { |index| index * 3 } # => 6\n```","summary":"<p>Returns the element at the given <em>index</em>, if in bounds, otherwise executes the given block with the index and returns its value.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int, &)","args_html":"(index : <a href=\"Int.html\">Int</a>, &)","location":{"filename":"src/indexable.cr","line_number":37,"url":null},"def":{"name":"fetch","args":[{"name":"index","external_name":"index","restriction":"Int"}],"yields":1,"visibility":"Public","body":"index = check_index_out_of_bounds(index) do\n  return yield index\nend\nunsafe_fetch(index)\n"}},{"html_id":"fetch(index,default)-instance-method","name":"fetch","doc":"Returns the value at the index given by *index*, or when not found the value given by *default*.\n\n```\na = [:foo, :bar]\na.fetch(0, :default_value) # => :foo\na.fetch(2, :default_value) # => :default_value\n```","summary":"<p>Returns the value at the index given by <em>index</em>, or when not found the value given by <em>default</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":""},{"name":"default","external_name":"default","restriction":""}],"args_string":"(index, default)","args_html":"(index, default)","location":{"filename":"src/indexable.cr","line_number":52,"url":null},"def":{"name":"fetch","args":[{"name":"index","external_name":"index","restriction":""},{"name":"default","external_name":"default","restriction":""}],"visibility":"Public","body":"fetch(index) do\n  default\nend"}},{"html_id":"first(&)-instance-method","name":"first","doc":":inherited:","summary":"<p>:inherited:</p>","abstract":false,"location":{"filename":"src/indexable.cr","line_number":738,"url":null},"def":{"name":"first","yields":0,"visibility":"Public","body":"size == 0 ? yield : unsafe_fetch(0)"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/indexable.cr","line_number":743,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = size.hash(hasher)\neach do |elem|\n  hasher = elem.hash(hasher)\nend\nhasher\n"}},{"html_id":"index(object,offset:Int=0)-instance-method","name":"index","doc":"Returns the index of the first appearance of *value* in `self`\nstarting from the given *offset*, or `nil` if the value is not in `self`.\n\n```\n[1, 2, 3, 1, 2, 3].index(2, offset: 2) # => 4\n```","summary":"<p>Returns the index of the first appearance of <em>value</em> in <code>self</code> starting from the given <em>offset</em>, or <code>nil</code> if the value is not in <code>self</code>.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":""},{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"args_string":"(object, offset : Int = 0)","args_html":"(object, offset : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>)","location":{"filename":"src/indexable.cr","line_number":757,"url":null},"def":{"name":"index","args":[{"name":"object","external_name":"object","restriction":""},{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"visibility":"Public","body":"index(offset) do |e|\n  e == object\nend"}},{"html_id":"index(offset:Int=0,&:T->)-instance-method","name":"index","doc":"Returns the index of the first object in `self` for which the block\nreturns `true`, starting from the given *offset*, or `nil` if no match\nis found.\n\n```\n[1, 2, 3, 1, 2, 3].index(offset: 2) { |x| x < 2 } # => 3\n```","summary":"<p>Returns the index of the first object in <code>self</code> for which the block returns <code>true</code>, starting from the given <em>offset</em>, or <code>nil</code> if no match is found.</p>","abstract":false,"args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"args_string":"(offset : Int = 0, & : T -> )","args_html":"(offset : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>, & : T -> )","location":{"filename":"src/indexable.cr","line_number":768,"url":null},"def":{"name":"index","args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"visibility":"Public","body":"if offset < 0\n  offset = offset + size\nend\nif offset < 0\n  return nil\nend\noffset.upto(size - 1) do |i|\n  if yield unsafe_fetch(i)\n    return i\n  end\nend\nnil\n"}},{"html_id":"join(separator:String|Char|Number=\"\"):String-instance-method","name":"join","doc":"Optimized version of `Enumerable#join` that performs better when\nall of the elements in this indexable are strings: the total string\nbytesize to return can be computed before creating the final string,\nwhich performs better because there's no need to do reallocations.","summary":"<p>Optimized version of <code><a href=\"Enumerable.html#join%28io%3AIO%2Cseparator%3D%22%22%29%3ANil-instance-method\">Enumerable#join</a></code> that performs better when all of the elements in this indexable are strings: the total string bytesize to return can be computed before creating the final string, which performs better because there's no need to do reallocations.</p>","abstract":false,"args":[{"name":"separator","default_value":"\"\"","external_name":"separator","restriction":"String | Char | Number"}],"args_string":"(separator : String | Char | Number = \"\") : String","args_html":"(separator : <a href=\"String.html\">String</a> | <a href=\"Char.html\">Char</a> | <a href=\"Number.html\">Number</a> = <span class=\"s\">&quot;&quot;</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/indexable.cr","line_number":627,"url":null},"def":{"name":"join","args":[{"name":"separator","default_value":"\"\"","external_name":"separator","restriction":"String | Char | Number"}],"return_type":"String","visibility":"Public","body":"if empty?\n  return \"\"\nend\n{% if T == String %}\n      join_strings(separator)\n    {% else %}{% if String < T %}\n      if all?(String)\n        join_strings(separator)\n      else\n        super(separator)\n      end\n    {% else %}\n      super(separator)\n    {% end %}{% end %}\n"}},{"html_id":"last:T-instance-method","name":"last","doc":"Returns the last element of `self` if it's not empty, or raises `IndexError`.\n\n```\n([1, 2, 3]).last   # => 3\n([] of Int32).last # raises IndexError\n```","summary":"<p>Returns the last element of <code>self</code> if it's not empty, or raises <code><a href=\"IndexError.html\">IndexError</a></code>.</p>","abstract":false,"location":{"filename":"src/indexable.cr","line_number":786,"url":null},"def":{"name":"last","return_type":"T","visibility":"Public","body":"last do\n  raise(IndexError.new)\nend"}},{"html_id":"last(&)-instance-method","name":"last","doc":"Returns the last element of `self` if it's not empty, or the given block's value.\n\n```\n([1, 2, 3]).last { 4 }   # => 3\n([] of Int32).last { 4 } # => 4\n```","summary":"<p>Returns the last element of <code>self</code> if it's not empty, or the given block's value.</p>","abstract":false,"location":{"filename":"src/indexable.cr","line_number":796,"url":null},"def":{"name":"last","yields":0,"visibility":"Public","body":"size == 0 ? yield : unsafe_fetch(size - 1)"}},{"html_id":"last?:T?-instance-method","name":"last?","doc":"Returns the last element of `self` if it's not empty, or `nil`.\n\n```\n([1, 2, 3]).last?   # => 3\n([] of Int32).last? # => nil\n```","summary":"<p>Returns the last element of <code>self</code> if it's not empty, or <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/indexable.cr","line_number":806,"url":null},"def":{"name":"last?","return_type":"T | ::Nil","visibility":"Public","body":"last do\n  nil\nend"}},{"html_id":"permutations(size:Int=self.size):Array(Array(T))-instance-method","name":"permutations","doc":"Returns an `Array` with all possible permutations of *size*.\n\n```\na = [1, 2, 3]\na.permutations    # => [[1,2,3],[1,3,2],[2,1,3],[2,3,1],[3,1,2],[3,2,1]]\na.permutations(1) # => [[1],[2],[3]]\na.permutations(2) # => [[1,2],[1,3],[2,1],[2,3],[3,1],[3,2]]\na.permutations(3) # => [[1,2,3],[1,3,2],[2,1,3],[2,3,1],[3,1,2],[3,2,1]]\na.permutations(0) # => [[]]\na.permutations(4) # => []\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all possible permutations of <em>size</em>.</p>","abstract":false,"args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"}],"args_string":"(size : Int = self.size) : Array(Array(T))","args_html":"(size : <a href=\"Int.html\">Int</a> = <span class=\"k\">self</span>.size) : <a href=\"Array.html\">Array</a>(<a href=\"Array.html\">Array</a>(T))","location":{"filename":"src/indexable.cr","line_number":971,"url":null},"def":{"name":"permutations","args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"}],"return_type":"Array(Array(T))","visibility":"Public","body":"ary = [] of Array(T)\neach_permutation(size) do |a|\n  ary << a\nend\nary\n"}},{"html_id":"repeated_combinations(size:Int=self.size):Array(Array(T))-instance-method","name":"repeated_combinations","abstract":false,"args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"}],"args_string":"(size : Int = self.size) : Array(Array(T))","args_html":"(size : <a href=\"Int.html\">Int</a> = <span class=\"k\">self</span>.size) : <a href=\"Array.html\">Array</a>(<a href=\"Array.html\">Array</a>(T))","location":{"filename":"src/indexable.cr","line_number":1115,"url":null},"def":{"name":"repeated_combinations","args":[{"name":"size","default_value":"self.size","external_name":"size","restriction":"Int"}],"return_type":"Array(Array(T))","visibility":"Public","body":"ary = [] of Array(T)\neach_repeated_combination(size) do |a|\n  ary << a\nend\nary\n"}},{"html_id":"reverse_each(&:T->):Nil-instance-method","name":"reverse_each","doc":"Same as `#each`, but works in reverse.","summary":"<p>Same as <code><a href=\"Indexable.html#each%28%26%3AT-%3E%29-instance-method\">#each</a></code>, but works in reverse.</p>","abstract":false,"location":{"filename":"src/indexable.cr","line_number":811,"url":null},"def":{"name":"reverse_each","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"Nil","visibility":"Public","body":"(size - 1).downto(0) do |i|\n  yield unsafe_fetch(i)\nend"}},{"html_id":"reverse_each-instance-method","name":"reverse_each","doc":"Returns an `Iterator` over the elements of `self` in reverse order.","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> over the elements of <code>self</code> in reverse order.</p>","abstract":false,"location":{"filename":"src/indexable.cr","line_number":818,"url":null},"def":{"name":"reverse_each","visibility":"Public","body":"ReverseItemIterator(self, T).new(self)"}},{"html_id":"rindex(value,offset=size-1)-instance-method","name":"rindex","doc":"Returns the index of the last appearance of *value* in `self`, or\n`nil` if the value is not in `self`.\n\nIf *offset* is given, it defines the position to _end_ the search\n(elements beyond this point are ignored).\n\n```\n[1, 2, 3, 2, 3].rindex(2)            # => 3\n[1, 2, 3, 2, 3].rindex(2, offset: 2) # => 1\n```","summary":"<p>Returns the index of the last appearance of <em>value</em> in <code>self</code>, or <code>nil</code> if the value is not in <code>self</code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"offset","default_value":"size - 1","external_name":"offset","restriction":""}],"args_string":"(value, offset = size - 1)","args_html":"(value, offset = size <span class=\"o\">-</span> <span class=\"n\">1</span>)","location":{"filename":"src/indexable.cr","line_number":832,"url":null},"def":{"name":"rindex","args":[{"name":"value","external_name":"value","restriction":""},{"name":"offset","default_value":"size - 1","external_name":"offset","restriction":""}],"visibility":"Public","body":"rindex(offset) do |elem|\n  elem == value\nend"}},{"html_id":"rindex(offset=size-1,&:T->)-instance-method","name":"rindex","doc":"Returns the index of the first object in `self` for which the block\nreturns `true`, starting from the last object, or `nil` if no match\nis found.\n\nIf *offset* is given, the search starts from that index towards the\nfirst elements in `self`.\n\n```\n[1, 2, 3, 2, 3].rindex { |x| x < 3 }            # => 3\n[1, 2, 3, 2, 3].rindex(offset: 2) { |x| x < 3 } # => 1\n```","summary":"<p>Returns the index of the first object in <code>self</code> for which the block returns <code>true</code>, starting from the last object, or <code>nil</code> if no match is found.</p>","abstract":false,"args":[{"name":"offset","default_value":"size - 1","external_name":"offset","restriction":""}],"args_string":"(offset = size - 1, & : T -> )","args_html":"(offset = size <span class=\"o\">-</span> <span class=\"n\">1</span>, & : T -> )","location":{"filename":"src/indexable.cr","line_number":847,"url":null},"def":{"name":"rindex","args":[{"name":"offset","default_value":"size - 1","external_name":"offset","restriction":""}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"visibility":"Public","body":"if offset < 0\n  offset = offset + size\nend\nif offset >= size\n  return nil\nend\noffset.downto(0) do |i|\n  if yield unsafe_fetch(i)\n    return i\n  end\nend\nnil\n"}},{"html_id":"sample(n:Int,random=Random::DEFAULT):Array(T)-instance-method","name":"sample","doc":"Returns an `Array` of *n* random elements from `self`, using the given\n*random* number generator. All elements have equal probability of being\ndrawn. Sampling is done without replacement; if *n* is larger than the size\nof this collection, the returned `Array` has the same size as `self`.\n\nRaises `ArgumentError` if *n* is negative.\n\n```\n[1, 2, 3, 4, 5].sample(2)                # => [3, 5]\n{1, 2, 3, 4, 5}.sample(2)                # => [3, 4]\n{1, 2, 3, 4, 5}.sample(2, Random.new(1)) # => [1, 5]\n```\n\nIf `self` is not empty and `n` is equal to 1, calls `sample(random)` exactly\nonce. Thus, *random* will be left in a different state compared to the\nimplementation in `Enumerable`.","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of <em>n</em> random elements from <code>self</code>, using the given <em>random</em> number generator.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"},{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(n : Int, random = Random::DEFAULT) : Array(T)","args_html":"(n : <a href=\"Int.html\">Int</a>, random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>) : <a href=\"Array.html\">Array</a>(T)","location":{"filename":"src/indexable.cr","line_number":877,"url":null},"def":{"name":"sample","args":[{"name":"n","external_name":"n","restriction":"Int"},{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"return_type":"Array(T)","visibility":"Public","body":"if n == 1\nelse\n  return super(n, random)\nend\nif empty?\n  [] of T\nelse\n  [sample(random)]\nend\n"}},{"html_id":"sample(random=Random::DEFAULT)-instance-method","name":"sample","doc":"Optimized version of `Enumerable#sample` that runs in O(1) time.\n\n```\na = [1, 2, 3]\na.sample                # => 3\na.sample                # => 1\na.sample(Random.new(1)) # => 2\n```","summary":"<p>Optimized version of <code><a href=\"Enumerable.html#sample%28n%3AInt%2Crandom%3DRandom%3A%3ADEFAULT%29%3AArray%28T%29-instance-method\">Enumerable#sample</a></code> that runs in O(1) time.</p>","abstract":false,"args":[{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(random = Random::DEFAULT)","args_html":"(random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>)","location":{"filename":"src/indexable.cr","line_number":867,"url":null},"def":{"name":"sample","args":[{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"visibility":"Public","body":"if size == 0\n  raise(IndexError.new(\"Can't sample empty collection\"))\nend\nunsafe_fetch(random.rand(size))\n"}},{"html_id":"size-instance-method","name":"size","doc":"Returns the number of elements in this container.","summary":"<p>Returns the number of elements in this container.</p>","abstract":true,"location":{"filename":"src/indexable.cr","line_number":13,"url":null},"def":{"name":"size","visibility":"Public","body":""}},{"html_id":"to_a:Array(T)-instance-method","name":"to_a","doc":"Returns an `Array` with all the elements in the collection.\n\n```\n{1, 2, 3}.to_a # => [1, 2, 3]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection.</p>","abstract":false,"location":{"filename":"src/indexable.cr","line_number":691,"url":null},"def":{"name":"to_a","return_type":"Array(T)","visibility":"Public","body":"ary = Array(T).new(size)\neach do |e|\n  ary << e\nend\nary\n"}},{"html_id":"unsafe_fetch(index:Int)-instance-method","name":"unsafe_fetch","doc":"Returns the element at the given *index*, without doing any bounds check.\n\n`Indexable` makes sure to invoke this method with *index* in `0...size`,\nso converting negative indices to positive ones is not needed here.\n\nClients never invoke this method directly. Instead, they access\nelements with `#[](index)` and `#[]?(index)`.\n\nThis method should only be directly invoked if you are absolutely\nsure the index is in bounds, to avoid a bounds check for a small boost\nof performance.","summary":"<p>Returns the element at the given <em>index</em>, without doing any bounds check.</p>","abstract":true,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","args_html":"(index : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/indexable.cr","line_number":26,"url":null},"def":{"name":"unsafe_fetch","args":[{"name":"index","external_name":"index","restriction":"Int"}],"visibility":"Public","body":""}},{"html_id":"values_at(*indexes:Int)-instance-method","name":"values_at","doc":"Returns a `Tuple` populated with the elements at the given indexes.\nRaises `IndexError` if any index is invalid.\n\n```\n[\"a\", \"b\", \"c\", \"d\"].values_at(0, 2) # => {\"a\", \"c\"}\n```","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> populated with the elements at the given indexes.</p>","abstract":false,"args":[{"name":"indexes","external_name":"indexes","restriction":"Int"}],"args_string":"(*indexes : Int)","args_html":"(*indexes : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/indexable.cr","line_number":893,"url":null},"def":{"name":"values_at","args":[{"name":"indexes","external_name":"indexes","restriction":"Int"}],"splat_index":0,"visibility":"Public","body":"indexes.map do |index|\n  self[index]\nend"}}],"types":[{"html_id":"Crystal/Indexable/Mutable","path":"Indexable/Mutable.html","kind":"module","full_name":"Indexable::Mutable(T)","name":"Mutable","abstract":false,"ancestors":[{"html_id":"Crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"},{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"}],"locations":[{"filename":"src/indexable/mutable.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"}],"including_types":[{"html_id":"Crystal/Array","kind":"class","full_name":"Array(T)","name":"Array"},{"html_id":"Crystal/BitArray","kind":"struct","full_name":"BitArray","name":"BitArray"},{"html_id":"Crystal/Deque","kind":"class","full_name":"Deque(T)","name":"Deque"},{"html_id":"Crystal/Slice","kind":"struct","full_name":"Slice(T)","name":"Slice"},{"html_id":"Crystal/StaticArray","kind":"struct","full_name":"StaticArray(T, N)","name":"StaticArray"}],"namespace":{"html_id":"Crystal/Indexable","kind":"module","full_name":"Indexable(T)","name":"Indexable"},"doc":"An `Indexable` container that is additionally mutable.\n\nIncluding types may write values to numeric indices, apart from reading them.\nThis module does not cover cases where the container is resized.","summary":"<p>An <code><a href=\"../Indexable.html\">Indexable</a></code> container that is additionally mutable.</p>","instance_methods":[{"html_id":"[]=(index:Int,value:T):T-instance-method","name":"[]=","doc":"Sets the given *value* at the given *index*. Returns *value*.\n\nNegative indices can be used to start counting from the end of the\ncontainer. Raises `IndexError` if trying to set an element outside the\ncontainer's range.\n\n```\nary = [1, 2, 3]\nary[0] = 5\nary # => [5, 2, 3]\n\nary[3] = 5 # raises IndexError\n```","summary":"<p>Sets the given <em>value</em> at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(index : Int, value : T) : T","args_html":"(index : <a href=\"../Int.html\">Int</a>, value : T) : T","location":{"filename":"src/indexable/mutable.cr","line_number":37,"url":null},"def":{"name":"[]=","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"return_type":"T","visibility":"Public","body":"index = check_index_out_of_bounds(index)\nunsafe_put(index, value)\nvalue\n"}},{"html_id":"fill(value:T,start:Int,count:Int):self-instance-method","name":"fill","doc":"Replaces *count* or less (if there aren't enough) elements starting at the\ngiven *start* index with *value*. Returns `self`.\n\nNegative values of *start* count from the end of the container.\n\nRaises `IndexError` if the *start* index is out of range.\n\nRaises `ArgumentError` if *count* is negative.\n\n```\narray = [1, 2, 3, 4, 5]\narray.fill(9, 2, 2) # => [1, 2, 9, 9, 5]\narray               # => [1, 2, 9, 9, 5]\n```","summary":"<p>Replaces <em>count</em> or less (if there aren't enough) elements starting at the given <em>start</em> index with <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(value : T, start : Int, count : Int) : self","args_html":"(value : T, start : <a href=\"../Int.html\">Int</a>, count : <a href=\"../Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/indexable/mutable.cr","line_number":132,"url":null},"def":{"name":"fill","args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"if count <= 0\n  return self\nend\nstart, count = normalize_start_and_count(start, count)\ncount.times do |i|\n  unsafe_put(start + i, value)\nend\nself\n"}},{"html_id":"fill(value:T,range:Range):self-instance-method","name":"fill","doc":"Replaces the elements within the given *range* with *value*. Returns `self`.\n\nNegative indices count backward from the end of the container.\n\nRaises `IndexError` if the starting index is out of range.\n\n```\narray = [1, 2, 3, 4, 5]\narray.fill(9, 2..3) # => [1, 2, 9, 9, 5]\narray               # => [1, 2, 9, 9, 5]\n```","summary":"<p>Replaces the elements within the given <em>range</em> with <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(value : T, range : Range) : self","args_html":"(value : T, range : <a href=\"../Range.html\">Range</a>) : <span class=\"k\">self</span>","location":{"filename":"src/indexable/mutable.cr","line_number":152,"url":null},"def":{"name":"fill","args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"range","external_name":"range","restriction":"Range"}],"return_type":"self","visibility":"Public","body":"fill(value, *(Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new)))"}},{"html_id":"fill(value:T):self-instance-method","name":"fill","doc":"Replaces every element in `self` with the given *value*. Returns `self`.\n\n```\narray = [1, 2, 3, 4]\narray.fill(2) # => [2, 2, 2, 2]\narray         # => [2, 2, 2, 2]\n```","summary":"<p>Replaces every element in <code>self</code> with the given <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T) : self","args_html":"(value : T) : <span class=\"k\">self</span>","location":{"filename":"src/indexable/mutable.cr","line_number":111,"url":null},"def":{"name":"fill","args":[{"name":"value","external_name":"value","restriction":"T"}],"return_type":"self","visibility":"Public","body":"each_index do |i|\n  unsafe_put(i, value)\nend\nself\n"}},{"html_id":"fill(start:Int,count:Int,&:Int32->T):self-instance-method","name":"fill","doc":"Yields each index of `self`, starting at *start* and for *count* times (or\nless if there aren't enough elements), to the given block and then assigns\nthe block's value in that position. Returns `self`.\n\nNegative values of *start* count from the end of the container.\n\nHas no effect if *count* is zero or negative.\n\nRaises `IndexError` if *start* is outside the array range.\n\n```\na = [1, 2, 3, 4, 5, 6]\na.fill(2, 3) { |i| i * i * i } # => [1, 2, 8, 27, 125, 6]\n```","summary":"<p>Yields each index of <code>self</code>, starting at <em>start</em> and for <em>count</em> times (or less if there aren't enough elements), to the given block and then assigns the block's value in that position.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int, & : Int32 -> T) : self","args_html":"(start : <a href=\"../Int.html\">Int</a>, count : <a href=\"../Int.html\">Int</a>, & : <a href=\"../Int32.html\">Int32</a> -> T) : <span class=\"k\">self</span>","location":{"filename":"src/indexable/mutable.cr","line_number":190,"url":null},"def":{"name":"fill","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Int32 -> T)"},"return_type":"self","visibility":"Public","body":"if count <= 0\n  return self\nend\nstart, count = normalize_start_and_count(start, count)\ncount.times do |i|\n  unsafe_put(start + i, yield start + i)\nend\nself\n"}},{"html_id":"fill(range:Range,&:Int32->T):self-instance-method","name":"fill","doc":"Yields each index of `self`, in the given *range*, to the given block and\nthen assigns the block's value in that position. Returns `self`.\n\nNegative indices count backward from the end of the container.\n\nRaises `IndexError` if the starting index is out of range.\n\n```\na = [1, 2, 3, 4, 5, 6]\na.fill(2..4) { |i| i * i * i } # => [1, 2, 8, 27, 125, 6]\n```","summary":"<p>Yields each index of <code>self</code>, in the given <em>range</em>, to the given block and then assigns the block's value in that position.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range, & : Int32 -> T) : self","args_html":"(range : <a href=\"../Range.html\">Range</a>, & : <a href=\"../Int32.html\">Int32</a> -> T) : <span class=\"k\">self</span>","location":{"filename":"src/indexable/mutable.cr","line_number":210,"url":null},"def":{"name":"fill","args":[{"name":"range","external_name":"range","restriction":"Range"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Int32 -> T)"},"return_type":"self","visibility":"Public","body":"fill(*(Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new))) do |i|\n  yield i\nend"}},{"html_id":"fill(*,offset:Int=0,&:Int32->T):self-instance-method","name":"fill","doc":"Yields each index of `self` to the given block and then assigns\nthe block's value in that position. Returns `self`.\n\nAccepts an optional *offset* parameter, which tells the block to start\ncounting from there.\n\n```\narray = [2, 1, 1, 1]\narray.fill { |i| i * i }            # => [0, 1, 4, 9]\narray                               # => [0, 1, 4, 9]\narray.fill(offset: 3) { |i| i * i } # => [9, 16, 25, 36]\narray                               # => [9, 16, 25, 36]\n```","summary":"<p>Yields each index of <code>self</code> to the given block and then assigns the block's value in that position.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"args_string":"(*, offset : Int = 0, & : Int32 -> T) : self","args_html":"(*, offset : <a href=\"../Int.html\">Int</a> = <span class=\"n\">0</span>, & : <a href=\"../Int32.html\">Int32</a> -> T) : <span class=\"k\">self</span>","location":{"filename":"src/indexable/mutable.cr","line_number":169,"url":null},"def":{"name":"fill","args":[{"name":"","external_name":"","restriction":""},{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"splat_index":0,"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Int32 -> T)"},"return_type":"self","visibility":"Public","body":"each_index do |i|\n  unsafe_put(i, yield offset + i)\nend\nself\n"}},{"html_id":"map!(&:T->_):self-instance-method","name":"map!","doc":"Invokes the given block for each element of `self`, replacing the element\nwith the value returned by the block. Returns `self`.\n\n```\na = [1, 2, 3]\na.map! { |x| x * x }\na # => [1, 4, 9]\n```","summary":"<p>Invokes the given block for each element of <code>self</code>, replacing the element with the value returned by the block.</p>","abstract":false,"location":{"filename":"src/indexable/mutable.cr","line_number":216,"url":null},"def":{"name":"map!","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> _)"},"return_type":"self","visibility":"Public","body":"each_index do |i|\n  unsafe_put(i, yield unsafe_fetch(i))\nend\nself\n"}},{"html_id":"map_with_index!(offset=0,&:T,Int32->_):self-instance-method","name":"map_with_index!","doc":"Like `#map!`, but the block gets passed both the element and its index.\n\nAccepts an optional *offset* parameter, which tells it to start counting\nfrom there.\n\n```\ngems = [\"crystal\", \"pearl\", \"diamond\"]\ngems.map_with_index! { |gem, i| \"#{i}: #{gem}\" }\ngems # => [\"0: crystal\", \"1: pearl\", \"2: diamond\"]\n```","summary":"<p>Like <code><a href=\"../Indexable/Mutable.html#map%21%28%26%3AT-%3E_%29%3Aself-instance-method\">#map!</a></code>, but the block gets passed both the element and its index.</p>","abstract":false,"args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(offset = 0, & : T, Int32 -> _) : self","args_html":"(offset = <span class=\"n\">0</span>, & : T, <a href=\"../Int32.html\">Int32</a> -> _) : <span class=\"k\">self</span>","location":{"filename":"src/indexable/mutable.cr","line_number":247,"url":null},"def":{"name":"map_with_index!","args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"yields":2,"block_arg":{"name":"","external_name":"","restriction":"(T, Int32 -> _)"},"return_type":"self","visibility":"Public","body":"each_index do |i|\n  unsafe_put(i, yield(unsafe_fetch(i), offset + i))\nend\nself\n"}},{"html_id":"reverse!:self-instance-method","name":"reverse!","doc":"Reverses in-place all the elements of `self`. Returns `self`.","summary":"<p>Reverses in-place all the elements of <code>self</code>.</p>","abstract":false,"location":{"filename":"src/indexable/mutable.cr","line_number":89,"url":null},"def":{"name":"reverse!","return_type":"self","visibility":"Public","body":"if size <= 1\n  return self\nend\nindex0 = 0\nindex1 = size - 1\nwhile index0 < index1\n  swap(index0, index1)\n  index0 = index0 + 1\n  index1 = index1 - 1\nend\nself\n"}},{"html_id":"rotate!(n:Int=1):self-instance-method","name":"rotate!","doc":"Shifts all elements of `self` to the left *n* times. Returns `self`.\n\n```\na1 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\na2 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\na3 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\n\na1.rotate!\na2.rotate!(1)\na3.rotate!(3)\n\na1 # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]\na2 # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]\na3 # => [3, 4, 5, 6, 7, 8, 9, 0, 1, 2]\n```","summary":"<p>Shifts all elements of <code>self</code> to the left <em>n</em> times.</p>","abstract":false,"args":[{"name":"n","default_value":"1","external_name":"n","restriction":"Int"}],"args_string":"(n : Int = 1) : self","args_html":"(n : <a href=\"../Int.html\">Int</a> = <span class=\"n\">1</span>) : <span class=\"k\">self</span>","location":{"filename":"src/indexable/mutable.cr","line_number":285,"url":null},"def":{"name":"rotate!","args":[{"name":"n","default_value":"1","external_name":"n","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"if size <= 1\n  return self\nend\nn = n % size\nif n == 0\n  return self\nend\n(size.gcd(n)).times do |i|\n  tmp = unsafe_fetch(i)\n  j = i\n  while true\n    k = j + n\n    if k >= size\n      k = k - size\n    end\n    if k == i\n      break\n    end\n    unsafe_put(j, unsafe_fetch(k))\n    j = k\n  end\n  unsafe_put(j, tmp)\nend\nself\n"}},{"html_id":"shuffle!(random=Random::DEFAULT):self-instance-method","name":"shuffle!","doc":"Modifies `self` by randomizing the order of elements in the collection\nusing the given *random* number generator. Returns `self`.\n\n```\na = [1, 2, 3, 4, 5]\na.shuffle!(Random.new(42)) # => [3, 2, 4, 5, 1]\na                          # => [3, 2, 4, 5, 1]\n```","summary":"<p>Modifies <code>self</code> by randomizing the order of elements in the collection using the given <em>random</em> number generator.</p>","abstract":false,"args":[{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(random = Random::DEFAULT) : self","args_html":"(random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>) : <span class=\"k\">self</span>","location":{"filename":"src/indexable/mutable.cr","line_number":262,"url":null},"def":{"name":"shuffle!","args":[{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"return_type":"self","visibility":"Public","body":"(size - 1).downto(1) do |i|\n  j = random.rand(i + 1)\n  swap(i, j)\nend\nself\n"}},{"html_id":"sort!:self-instance-method","name":"sort!","doc":"Sorts all elements in `self` based on the return value of the comparison\nmethod `T#<=>` (see `Comparable#<=>`), using a stable sort algorithm.\n\n```\na = [3, 1, 2]\na.sort!\na # => [1, 2, 3]\n```\n\nThis sort operation modifies `self`. See `#sort` for a non-modifying option\nthat allocates a new instance.\n\nSee `Slice#sort!` for details on the implementation.\n\nRaises `ArgumentError` if the comparison between any two elements returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the return value of the comparison method <code>T#<=></code> (see <code><a href=\"../Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">Comparable#<=></a></code>), using a stable sort algorithm.</p>","abstract":false,"location":{"filename":"src/indexable/mutable.cr","line_number":324,"url":null},"def":{"name":"sort!","return_type":"self","visibility":"Public","body":"slice = (Slice.new(size) do |i|\n  unsafe_fetch(i)\nend).sort!\neach_index do |i|\n  unsafe_put(i, slice.unsafe_fetch(i))\nend\nself\n"}},{"html_id":"sort!(&block:T,T->U):selfforallU-instance-method","name":"sort!","doc":"Sorts all elements in `self` based on the comparator in the given block, using\na stable sort algorithm.\n\nThe block must implement a comparison between two elements *a* and *b*,\nwhere `a < b` returns `-1`, `a == b` returns `0`, and `a > b` returns `1`.\nThe comparison operator `<=>` can be used for this.\n\n```\na = [3, 1, 2]\n# This is a reverse sort (forward sort would be `a <=> b`)\na.sort! { |a, b| b <=> a }\na # => [3, 2, 1]\n```\n\nThis sort operation modifies `self`. See `#sort(&block : T, T -> U)` for a\nnon-modifying option that allocates a new instance.\n\nSee `Slice#sort!(&block : T, T -> U)` for details on the implementation.\n\nRaises `ArgumentError` if for any two elements the block returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the comparator in the given block, using a stable sort algorithm.</p>","abstract":false,"location":{"filename":"src/indexable/mutable.cr","line_number":375,"url":null},"def":{"name":"sort!","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> U)"},"return_type":"self","visibility":"Public","body":"{% if U <= ::Union(Int32, ::Nil) %}{% else %}\n      {% raise(\"expected block to return Int32 or Nil, not #{U}\") %}\n    {% end %}\nslice = (Slice.new(size) do |i|\n  unsafe_fetch(i)\nend).sort!(&block)\neach_index do |i|\n  unsafe_put(i, slice.unsafe_fetch(i))\nend\nself\n"}},{"html_id":"sort_by!(&block:T->_):self-instance-method","name":"sort_by!","doc":"Sorts all elements in `self` by the output value of the\nblock. The output values are compared via the comparison method `#<=>`\n(see `Comparable#<=>`), using a stable sort algorithm.\n\n```\na = %w(apple pear fig)\na.sort_by! { |word| word.size }\na # => [\"fig\", \"pear\", \"apple\"]\n```\n\nThis sort operation modifies `self`. See `#sort_by(&block : T -> _)` for a\nnon-modifying option that allocates a new instance.\n\nIf stability is expendable, `#unstable_sort_by!(&block : T -> _)` provides a\nperformance advantage over stable sort.\n\nSee `#sort!(&block : T -> _)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two comparison values returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> by the output value of the block.</p>","abstract":false,"location":{"filename":"src/indexable/mutable.cr","line_number":438,"url":null},"def":{"name":"sort_by!","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> _)"},"return_type":"self","visibility":"Public","body":"slice = (Slice.new(size) do |i|\n  elem = unsafe_fetch(i)\n  {elem, (  yield elem)}\nend).sort! do |x, y|\n  x[1] <=> y[1]\nend\neach_index do |i|\n  unsafe_put(i, (slice.unsafe_fetch(i))[0])\nend\nself\n"}},{"html_id":"swap(index0:Int,index1:Int):self-instance-method","name":"swap","doc":"Swaps the elements at *index0* and *index1*. Returns `self`.\n\nNegative indices can be used to start counting from the end of the\ncontainer. Raises `IndexError` if either index is out of bounds.\n\n```\na = [\"first\", \"second\", \"third\"]\na.swap(1, 2)  # => [\"first\", \"third\", \"second\"]\na             # => [\"first\", \"third\", \"second\"]\na.swap(0, -1) # => [\"second\", \"third\", \"first\"]\na             # => [\"second\", \"third\", \"first\"]\na.swap(2, 3)  # raises IndexError\n```","summary":"<p>Swaps the elements at <em>index0</em> and <em>index1</em>.</p>","abstract":false,"args":[{"name":"index0","external_name":"index0","restriction":"Int"},{"name":"index1","external_name":"index1","restriction":"Int"}],"args_string":"(index0 : Int, index1 : Int) : self","args_html":"(index0 : <a href=\"../Int.html\">Int</a>, index1 : <a href=\"../Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/indexable/mutable.cr","line_number":75,"url":null},"def":{"name":"swap","args":[{"name":"index0","external_name":"index0","restriction":"Int"},{"name":"index1","external_name":"index1","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"index0 = check_index_out_of_bounds(index0)\nindex1 = check_index_out_of_bounds(index1)\nif index0 == index1\nelse\n  tmp = unsafe_fetch(index0)\n  unsafe_put(index0, unsafe_fetch(index1))\n  unsafe_put(index1, tmp)\nend\nself\n"}},{"html_id":"unsafe_put(index:Int,value:T)-instance-method","name":"unsafe_put","doc":"Sets the element at the given *index* to *value*, without doing any bounds\ncheck.\n\n`Indexable::Mutable` makes sure to invoke this method with *index* in\n`0...size`, so converting negative indices to positive ones is not needed\nhere.\n\nClients never invoke this method directly. Instead, they modify elements\nwith `#[]=(index, value)`.\n\nThis method should only be directly invoked if you are absolutely\nsure the index is in bounds, to avoid a bounds check for a small boost\nof performance.","summary":"<p>Sets the element at the given <em>index</em> to <em>value</em>, without doing any bounds check.</p>","abstract":true,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(index : Int, value : T)","args_html":"(index : <a href=\"../Int.html\">Int</a>, value : T)","location":{"filename":"src/indexable/mutable.cr","line_number":21,"url":null},"def":{"name":"unsafe_put","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":""}},{"html_id":"unstable_sort!:self-instance-method","name":"unstable_sort!","doc":"Sorts all elements in `self` based on the return value of the comparison\nmethod `T#<=>` (see `Comparable#<=>`), using an unstable sort algorithm.\n\n```\na = [3, 1, 2]\na.unstable_sort!\na # => [1, 2, 3]\n```\n\nThis sort operation modifies `self`. See `#unstable_sort` for a non-modifying\noption that allocates a new instance.\n\nSee `Slice#unstable_sort!` for details on the implementation.\n\nRaises `ArgumentError` if the comparison between any two elements returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the return value of the comparison method <code>T#<=></code> (see <code><a href=\"../Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">Comparable#<=></a></code>), using an unstable sort algorithm.</p>","abstract":false,"location":{"filename":"src/indexable/mutable.cr","line_number":347,"url":null},"def":{"name":"unstable_sort!","return_type":"self","visibility":"Public","body":"slice = (Slice.new(size) do |i|\n  unsafe_fetch(i)\nend).unstable_sort!\neach_index do |i|\n  unsafe_put(i, slice.unsafe_fetch(i))\nend\nself\n"}},{"html_id":"unstable_sort!(&block:T,T->U):selfforallU-instance-method","name":"unstable_sort!","doc":"Sorts all elements in `self` based on the comparator in the given block,\nusing an unstable sort algorithm.\n\nThe block must implement a comparison between two elements *a* and *b*,\nwhere `a < b` returns `-1`, `a == b` returns `0`, and `a > b` returns `1`.\nThe comparison operator `<=>` can be used for this.\n\n```\na = [3, 1, 2]\n# This is a reverse sort (forward sort would be `a <=> b`)\na.unstable_sort! { |a, b| b <=> a }\na # => [3, 2, 1]\n```\n\nThis sort operation modifies `self`. See `#unstable_sort(&block : T, T -> U)`\nfor a non-modifying option that allocates a new instance.\n\nSee `Slice#unstable_sort!(&block : T, T -> U)` for details on the implementation.\n\nRaises `ArgumentError` if for any two elements the block returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the comparator in the given block, using an unstable sort algorithm.</p>","abstract":false,"location":{"filename":"src/indexable/mutable.cr","line_number":407,"url":null},"def":{"name":"unstable_sort!","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> U)"},"return_type":"self","visibility":"Public","body":"{% if U <= ::Union(Int32, ::Nil) %}{% else %}\n      {% raise(\"expected block to return Int32 or Nil, not #{U}\") %}\n    {% end %}\nslice = (Slice.new(size) do |i|\n  unsafe_fetch(i)\nend).unstable_sort!(&block)\neach_index do |i|\n  unsafe_put(i, slice.unsafe_fetch(i))\nend\nself\n"}},{"html_id":"unstable_sort_by!(&block:T->_):self-instance-method","name":"unstable_sort_by!","doc":"Sorts all elements in `self` by the output value of the\nblock. The output values are compared via the comparison method `#<=>`\n(see `Comparable#<=>`), using an unstable sort algorithm.\n\n```\na = %w(apple pear fig)\na.usntable_sort_by! { |word| word.size }\na # => [\"fig\", \"pear\", \"apple\"]\n```\n\nThis sort operation modifies `self`. See `#unstable_sort_by(&block : T -> _)`\nfor a non-modifying option that allocates a new instance.\n\nIf stability is necessary, use  `#sort_by!(&block : T -> _)` instead.\n\nSee `#unstable_sort!(&block : T -> _)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two comparison values returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> by the output value of the block.</p>","abstract":false,"location":{"filename":"src/indexable/mutable.cr","line_number":468,"url":null},"def":{"name":"unstable_sort_by!","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> _)"},"return_type":"self","visibility":"Public","body":"slice = (Slice.new(size) do |i|\n  elem = unsafe_fetch(i)\n  {elem, (  yield elem)}\nend).unstable_sort! do |x, y|\n  x[1] <=> y[1]\nend\neach_index do |i|\n  unsafe_put(i, (slice.unsafe_fetch(i))[0])\nend\nself\n"}},{"html_id":"update(index:Int,&:T->_):T-instance-method","name":"update","doc":"Yields the current element at the given *index* and updates the value\nat that *index* with the block's value. Returns the new value.\n\nRaises `IndexError` if trying to set an element outside the container's\nrange.\n\n```\narray = [1, 2, 3]\narray.update(1) { |x| x * 2 } # => 4\narray                         # => [1, 4, 3]\narray.update(5) { |x| x * 2 } # raises IndexError\n```","summary":"<p>Yields the current element at the given <em>index</em> and updates the value at that <em>index</em> with the block's value.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int, & : T -> _) : T","args_html":"(index : <a href=\"../Int.html\">Int</a>, & : T -> _) : T","location":{"filename":"src/indexable/mutable.cr","line_number":55,"url":null},"def":{"name":"update","args":[{"name":"index","external_name":"index","restriction":"Int"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> _)"},"return_type":"T","visibility":"Public","body":"index = check_index_out_of_bounds(index)\nvalue = yield unsafe_fetch(index)\nunsafe_put(index, value)\nvalue\n"}}]}]},{"html_id":"Crystal/IndexError","path":"IndexError.html","kind":"class","full_name":"IndexError","name":"IndexError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/exception.cr","line_number":78,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"Raised when the given index is invalid.\n\n```\na = [:foo, :bar]\na[2] # raises IndexError\n```","summary":"<p>Raised when the given index is invalid.</p>","constructors":[{"html_id":"new(message=\"Indexoutofbounds\")-class-method","name":"new","abstract":false,"args":[{"name":"message","default_value":"\"Index out of bounds\"","external_name":"message","restriction":""}],"args_string":"(message = \"Index out of bounds\")","args_html":"(message = <span class=\"s\">&quot;Index out of bounds&quot;</span>)","location":{"filename":"src/exception.cr","line_number":79,"url":null},"def":{"name":"new","args":[{"name":"message","default_value":"\"Index out of bounds\"","external_name":"message","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]},{"html_id":"Crystal/INI","path":"INI.html","kind":"module","full_name":"INI","name":"INI","abstract":false,"locations":[{"filename":"src/ini.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"class_methods":[{"html_id":"build(ini,space:Bool=false):String-class-method","name":"build","doc":"Generates an INI-style configuration from a given hash.\n\n```\nrequire \"ini\"\n\nINI.build({\"foo\" => {\"a\" => \"1\"}}, true) # => \"[foo]\\na = 1\\n\\n\"\n```","summary":"<p>Generates an INI-style configuration from a given hash.</p>","abstract":false,"args":[{"name":"ini","external_name":"ini","restriction":""},{"name":"space","default_value":"false","external_name":"space","restriction":"Bool"}],"args_string":"(ini, space : Bool = false) : String","args_html":"(ini, space : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/ini.cr","line_number":68,"url":null},"def":{"name":"build","args":[{"name":"ini","external_name":"ini","restriction":""},{"name":"space","default_value":"false","external_name":"space","restriction":"Bool"}],"return_type":"String","visibility":"Public","body":"String.build do |str|\n  build(str, ini, space)\nend"}},{"html_id":"build(io:IO,ini,space:Bool=false):Nil-class-method","name":"build","doc":"Appends INI data to the given IO.","summary":"<p>Appends INI data to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"ini","external_name":"ini","restriction":""},{"name":"space","default_value":"false","external_name":"space","restriction":"Bool"}],"args_string":"(io : IO, ini, space : Bool = false) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, ini, space : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/ini.cr","line_number":73,"url":null},"def":{"name":"build","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"ini","external_name":"ini","restriction":""},{"name":"space","default_value":"false","external_name":"space","restriction":"Bool"}],"return_type":"Nil","visibility":"Public","body":"ini[\"\"]?.try(&.each do |key, value|\n  (((io << key) << (space ? \" = \" : '=')) << value) << '\\n'\nend)\nini.each do |section, contents|\n  if section.to_s.empty?\n    next\n  end\n  ((io << '[') << section) << \"]\\n\"\n  contents.each do |key, value|\n    (((io << key) << (space ? \" = \" : '=')) << value) << '\\n'\n  end\n  io.puts\nend\nio.flush\n"}},{"html_id":"parse(string_or_io:String|IO):Hash(String,Hash(String,String))-class-method","name":"parse","doc":"Parses INI-style configuration from the given string.\nRaises a `ParseException` on any errors.\n\n```\nrequire \"ini\"\n\nINI.parse(\"[foo]\\na = 1\") # => {\"foo\" => {\"a\" => \"1\"}}\n```","summary":"<p>Parses INI-style configuration from the given string.</p>","abstract":false,"args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"}],"args_string":"(string_or_io : String | IO) : Hash(String, Hash(String, String))","args_html":"(string_or_io : <a href=\"String.html\">String</a> | <a href=\"IO.html\">IO</a>) : <a href=\"Hash.html\">Hash</a>(<a href=\"String.html\">String</a>, <a href=\"Hash.html\">Hash</a>(<a href=\"String.html\">String</a>, <a href=\"String.html\">String</a>))","location":{"filename":"src/ini.cr","line_number":24,"url":null},"def":{"name":"parse","args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"}],"return_type":"Hash(String, Hash(String, String))","visibility":"Public","body":"ini = Hash(String, Hash(String, String)).new\ncurrent_section = ini[\"\"] = Hash(String, String).new\nlineno = 0\nstring_or_io.each_line do |line|\n  lineno = lineno + 1\n  if line.empty?\n    next\n  end\n  offset = 0\n  line.each_char do |char|\n    if char.ascii_whitespace?\n    else\n      break\n    end\n    offset = offset + 1\n  end\n  case line[offset]\n  when '#', ';'\n    next\n  when '['\n    end_idx = line.index(']', offset)\n    if end_idx\n    else\n      raise(ParseException.new(\"unterminated section\", lineno, line.size))\n    end\n    if end_idx == (line.size - 1)\n    else\n      raise(ParseException.new(\"data after section\", lineno, end_idx + 1))\n    end\n    current_section_name = line[(offset + 1)...end_idx]\n    current_section = (    __temp_101 = current_section_name\n    ini[__temp_101]? || (ini[__temp_101] = Hash(String, String).new)\n)\n  else\n    key, eq, value = line.partition('=')\n    if eq != \"=\"\n      raise(ParseException.new(\"expected declaration\", lineno, key.size))\n    end\n    current_section[key.strip] = value.strip\n  end\nend\nif ini[\"\"].empty?\n  ini.delete(\"\")\nend\nini\n"}}],"types":[{"html_id":"Crystal/INI/ParseException","path":"INI/ParseException.html","kind":"class","full_name":"INI::ParseException","name":"ParseException","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/ini.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/INI","kind":"module","full_name":"INI","name":"INI"},"doc":"Exception thrown on an INI parse error.","summary":"<p>Exception thrown on an INI parse error.</p>","constructors":[{"html_id":"new(message,line_number,column_number)-class-method","name":"new","abstract":false,"args":[{"name":"message","external_name":"message","restriction":""},{"name":"line_number","external_name":"line_number","restriction":""},{"name":"column_number","external_name":"column_number","restriction":""}],"args_string":"(message, line_number, column_number)","args_html":"(message, line_number, column_number)","location":{"filename":"src/ini.cr","line_number":7,"url":null},"def":{"name":"new","args":[{"name":"message","external_name":"message","restriction":""},{"name":"line_number","external_name":"line_number","restriction":""},{"name":"column_number","external_name":"column_number","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(message, line_number, column_number)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"column_number:Int32-instance-method","name":"column_number","abstract":false,"location":{"filename":"src/ini.cr","line_number":5,"url":null},"def":{"name":"column_number","return_type":"Int32","visibility":"Public","body":"@column_number"}},{"html_id":"line_number:Int32-instance-method","name":"line_number","abstract":false,"location":{"filename":"src/ini.cr","line_number":4,"url":null},"def":{"name":"line_number","return_type":"Int32","visibility":"Public","body":"@line_number"}},{"html_id":"location-instance-method","name":"location","abstract":false,"location":{"filename":"src/ini.cr","line_number":11,"url":null},"def":{"name":"location","visibility":"Public","body":"{line_number, column_number}"}}]}]},{"html_id":"Crystal/Int","path":"Int.html","kind":"struct","full_name":"Int","name":"Int","abstract":true,"superclass":{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/big_decimal.cr","line_number":634,"url":null},{"filename":"src/big/big_int.cr","line_number":706,"url":null},{"filename":"src/big/big_rational.cr","line_number":306,"url":null},{"filename":"src/humanize.cr","line_number":285,"url":null},{"filename":"src/int.cr","line_number":60,"url":null},{"filename":"src/json/to_json.cr","line_number":43,"url":null},{"filename":"src/time/span.cr","line_number":425,"url":null},{"filename":"src/time/span.cr","line_number":593,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"subclasses":[{"html_id":"Crystal/BigInt","kind":"struct","full_name":"BigInt","name":"BigInt"},{"html_id":"Crystal/Int128","kind":"struct","full_name":"Int128","name":"Int128"},{"html_id":"Crystal/Int16","kind":"struct","full_name":"Int16","name":"Int16"},{"html_id":"Crystal/Int32","kind":"struct","full_name":"Int32","name":"Int32"},{"html_id":"Crystal/Int64","kind":"struct","full_name":"Int64","name":"Int64"},{"html_id":"Crystal/Int8","kind":"struct","full_name":"Int8","name":"Int8"},{"html_id":"Crystal/UInt128","kind":"struct","full_name":"UInt128","name":"UInt128"},{"html_id":"Crystal/UInt16","kind":"struct","full_name":"UInt16","name":"UInt16"},{"html_id":"Crystal/UInt32","kind":"struct","full_name":"UInt32","name":"UInt32"},{"html_id":"Crystal/UInt64","kind":"struct","full_name":"UInt64","name":"UInt64"},{"html_id":"Crystal/UInt8","kind":"struct","full_name":"UInt8","name":"UInt8"}],"doc":"Int is the base type of all integer types.\n\nThere are four signed integer types: `Int8`, `Int16`, `Int32` and `Int64`,\nbeing able to represent numbers of 8, 16, 32 and 64 bits respectively.\nThere are four unsigned integer types: `UInt8`, `UInt16`, `UInt32` and `UInt64`.\n\nAn integer literal is an optional `+` or `-` sign, followed by\na sequence of digits and underscores, optionally followed by a suffix.\nIf no suffix is present, the literal's type is the lowest between `Int32`, `Int64` and `UInt64`\nin which the number fits:\n\n```\n1 # Int32\n\n1_i8  # Int8\n1_i16 # Int16\n1_i32 # Int32\n1_i64 # Int64\n\n1_u8  # UInt8\n1_u16 # UInt16\n1_u32 # UInt32\n1_u64 # UInt64\n\n+10 # Int32\n-20 # Int32\n\n2147483648          # Int64\n9223372036854775808 # UInt64\n```\n\nThe underscore `_` before the suffix is optional.\n\nUnderscores can be used to make some numbers more readable:\n\n```\n1_000_000 # better than 1000000\n```\n\nBinary numbers start with `0b`:\n\n```\n0b1101 # == 13\n```\n\nOctal numbers start with `0o`:\n\n```\n0o123 # == 83\n```\n\nHexadecimal numbers start with `0x`:\n\n```\n0xFE012D # == 16646445\n0xfe012d # == 16646445\n```\n\nSee [`Integer` literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/integers.html) in the language reference.","summary":"<p>Int is the base type of all integer types.</p>","constructors":[{"html_id":"from_io(io:IO,format:IO::ByteFormat):self-class-method","name":"from_io","doc":"Reads an integer from the given *io* in the given *format*.\n\nSee also: `IO#read_bytes`.","summary":"<p>Reads an integer from the given <em>io</em> in the given <em>format</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"format","external_name":"format","restriction":"IO::ByteFormat"}],"args_string":"(io : IO, format : IO::ByteFormat) : self","args_html":"(io : <a href=\"IO.html\">IO</a>, format : <a href=\"IO/ByteFormat.html\">IO::ByteFormat</a>) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":758,"url":null},"def":{"name":"from_io","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"format","external_name":"format","restriction":"IO::ByteFormat"}],"return_type":"self","visibility":"Public","body":"format.decode(self, io)"}}],"instance_methods":[{"html_id":"%(other:BigInt):BigInt-instance-method","name":"%","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":746,"url":null},"def":{"name":"%","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"to_big_i % other"}},{"html_id":"%(other:Int)-instance-method","name":"%","doc":"Returns `self` modulo *other*.\n\nThis uses floored division.\n\nSee `Int#/` for more details.","summary":"<p>Returns <code>self</code> modulo <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","args_html":"(other : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/int.cr","line_number":160,"url":null},"def":{"name":"%","args":[{"name":"other","external_name":"other","restriction":"Int"}],"visibility":"Public","body":"{% if true %}\n      if other == 0\n        raise DivisionByZeroError.new\n      elsif self < 0 && self == {{ @type }}::MIN && other == -1\n        self.class.new(0)\n      elsif (self < 0) == (other < 0)\n        self.unsafe_mod(other)\n      else\n        me = self.unsafe_mod(other)\n        me == 0 ? me : me + other\n      end\n    {% end %}"}},{"html_id":"&*(other:BigInt):BigInt-instance-method","name":"&*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":742,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"self * other"}},{"html_id":"&**(exponent:Int):self-instance-method","name":"&**","doc":"Returns the value of raising `self` to the power of *exponent*.\n\nRaises `ArgumentError` if *exponent* is negative: if this is needed,\neither use a float base or a float exponent.\n\nIntermediate multiplication will wrap around silently in case of overflow.\n\n```\n2 &** 3  # => 8\n2 &** 0  # => 1\n2 &** -1 # ArgumentError\n```","summary":"<p>Returns the value of raising <code>self</code> to the power of <em>exponent</em>.</p>","abstract":false,"args":[{"name":"exponent","external_name":"exponent","restriction":"Int"}],"args_string":"(exponent : Int) : self","args_html":"(exponent : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":312,"url":null},"def":{"name":"&**","args":[{"name":"exponent","external_name":"exponent","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"if exponent < 0\n  raise(ArgumentError.new(\"Cannot raise an integer to a negative integer power, use floats for that\"))\nend\nresult = self.class.new(1)\nk = self\nwhile exponent > 0\n  if (exponent & 1) != 0\n    result = result &* k\n  end\n  exponent = exponent.unsafe_shr(1)\n  if exponent > 0\n    k = k &* k\n  end\nend\nresult\n"}},{"html_id":"&+(other:BigInt):BigInt-instance-method","name":"&+","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":717,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"self + other"}},{"html_id":"&-(other:BigInt):BigInt-instance-method","name":"&-","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":734,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"self - other"}},{"html_id":"*(other:BigInt):BigInt-instance-method","name":"*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":738,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"other * self"}},{"html_id":"*(other:BigRational):BigRational-instance-method","name":"*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":335,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"other * self"}},{"html_id":"*(other:BigDecimal):BigDecimal-instance-method","name":"*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":658,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"other * self"}},{"html_id":"**(exponent:Int):self-instance-method","name":"**","doc":"Returns the value of raising `self` to the power of *exponent*.\n\nRaises `ArgumentError` if *exponent* is negative: if this is needed,\neither use a float base or a float exponent.\n\nRaises `OverflowError` in case of overflow.\n\n```\n2 ** 3  # => 8\n2 ** 0  # => 1\n2 ** -1 # ArgumentError\n```","summary":"<p>Returns the value of raising <code>self</code> to the power of <em>exponent</em>.</p>","abstract":false,"args":[{"name":"exponent","external_name":"exponent","restriction":"Int"}],"args_string":"(exponent : Int) : self","args_html":"(exponent : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":285,"url":null},"def":{"name":"**","args":[{"name":"exponent","external_name":"exponent","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"if exponent < 0\n  raise(ArgumentError.new(\"Cannot raise an integer to a negative integer power, use floats for that\"))\nend\nresult = self.class.new(1)\nk = self\nwhile exponent > 0\n  if (exponent & 1) != 0\n    result = result * k\n  end\n  exponent = exponent.unsafe_shr(1)\n  if exponent > 0\n    k = k * k\n  end\nend\nresult\n"}},{"html_id":"**(exponent:Float):Float64-instance-method","name":"**","doc":"Returns the value of raising `self` to the power of *exponent*.\n\n```\n2 ** 3.0  # => 8.0\n2 ** 0.0  # => 1.0\n2 ** -1.0 # => 0.5\n```","summary":"<p>Returns the value of raising <code>self</code> to the power of <em>exponent</em>.</p>","abstract":false,"args":[{"name":"exponent","external_name":"exponent","restriction":"Float"}],"args_string":"(exponent : Float) : Float64","args_html":"(exponent : <a href=\"Float.html\">Float</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":334,"url":null},"def":{"name":"**","args":[{"name":"exponent","external_name":"exponent","restriction":"Float"}],"return_type":"Float64","visibility":"Public","body":"to_f ** exponent"}},{"html_id":"+(other:BigInt):BigInt-instance-method","name":"+","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":713,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"other + self"}},{"html_id":"+(other:BigRational):BigRational-instance-method","name":"+","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":323,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"other + self"}},{"html_id":"+(other:BigDecimal):BigDecimal-instance-method","name":"+","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":650,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"other + self"}},{"html_id":"-(other:BigInt):BigInt-instance-method","name":"-","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":721,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"if self < 0\n  -(abs + other)\nelse\n  to_big_i - other\nend"}},{"html_id":"-(other:BigRational):BigRational-instance-method","name":"-","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/big_rational.cr","line_number":327,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"self.to_big_r - other"}},{"html_id":"-(other:BigDecimal):BigDecimal-instance-method","name":"-","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/big_decimal.cr","line_number":654,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"to_big_d - other"}},{"html_id":"/(other:BigRational)-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational)","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>)","location":{"filename":"src/big/big_rational.cr","line_number":331,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"visibility":"Public","body":"self.to_big_r / other"}},{"html_id":"//(other:Int::Primitive)-instance-method","name":"//","doc":"Divides `self` by *other* using floored division.\n\nIn floored division, given two integers x and y:\n* q = x / y is rounded toward negative infinity\n* r = x % y has the sign of the second argument\n* x == q*y + r\n\nFor example:\n\n```text\n x     y     x / y     x % y\n 5     3       1         2\n-5     3      -2         1\n 5    -3      -2        -1\n-5    -3       1        -2\n```\n\nRaises if *other* is zero, or if *other* is -1 and\n`self` is signed and is the minimum value for that\ninteger type.","summary":"<p>Divides <code>self</code> by <em>other</em> using floored division.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int::Primitive"}],"args_string":"(other : Int::Primitive)","args_html":"(other : <a href=\"Int/Primitive.html\">Int::Primitive</a>)","location":{"filename":"src/int.cr","line_number":104,"url":null},"def":{"name":"//","args":[{"name":"other","external_name":"other","restriction":"Int::Primitive"}],"visibility":"Public","body":"check_div_argument(other)\ndiv = unsafe_div(other)\nmod = unsafe_mod(other)\nif other > 0 ? mod < 0 : mod > 0\n  div = div - 1\nend\ndiv\n"}},{"html_id":"<<(count:Int)-instance-method","name":"<<","doc":"Returns the result of shifting this number's bits *count* positions to the left.\n\n* If *count* is greater than the number of bits of this integer, returns 0\n* If *count* is negative, a right shift is performed\n\n```\n8000 << 1  # => 16000\n8000 << 2  # => 32000\n8000 << 32 # => 0\n8000 << -1 # => 4000\n```","summary":"<p>Returns the result of shifting this number's bits <em>count</em> positions to the left.</p>","abstract":false,"args":[{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(count : Int)","args_html":"(count : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/int.cr","line_number":227,"url":null},"def":{"name":"<<","args":[{"name":"count","external_name":"count","restriction":"Int"}],"visibility":"Public","body":"if count < 0\n  self >> count.abs\nelse\n  if count < ((sizeof(self)) * 8)\n    self.unsafe_shl(count)\n  else\n    self.class.zero\n  end\nend"}},{"html_id":"<=>(other:BigInt)-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt)","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>)","location":{"filename":"src/big/big_int.cr","line_number":709,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"visibility":"Public","body":"-(other <=> self)"}},{"html_id":"<=>(other:Int):Int32-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int) : Int32","args_html":"(other : <a href=\"Int.html\">Int</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/int.cr","line_number":237,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Int"}],"return_type":"Int32","visibility":"Public","body":"self > other ? 1 : (self < other ? -1 : 0)"}},{"html_id":"<=>(other:BigRational)-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational)","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>)","location":{"filename":"src/big/big_rational.cr","line_number":319,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"visibility":"Public","body":"-(other <=> self)"}},{"html_id":"<=>(other:BigDecimal)-instance-method","name":"<=>","doc":"The comparison operator. Returns `0` if the two objects are equal,\na negative number if this object is considered less than *other*,\na positive number if this object is considered greater than *other*,\nor `nil` if the two objects are not comparable.\n\nSubclasses define this method to provide class-specific ordering.\n\nThe comparison operator is usually used to sort values:\n\n```\n# Sort in a descending way:\n[3, 1, 2].sort { |x, y| y <=> x } # => [3, 2, 1]\n\n# Sort in an ascending way:\n[3, 1, 2].sort { |x, y| x <=> y } # => [1, 2, 3]\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal)","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>)","location":{"filename":"src/big/big_decimal.cr","line_number":646,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"visibility":"Public","body":"to_big_d <=> other"}},{"html_id":"===(char:Char)-instance-method","name":"===","abstract":false,"args":[{"name":"char","external_name":"char","restriction":"Char"}],"args_string":"(char : Char)","args_html":"(char : <a href=\"Char.html\">Char</a>)","location":{"filename":"src/int.cr","line_number":338,"url":null},"def":{"name":"===","args":[{"name":"char","external_name":"char","restriction":"Char"}],"visibility":"Public","body":"self === char.ord"}},{"html_id":">>(count:Int)-instance-method","name":">>","doc":"Returns the result of shifting this number's bits *count* positions to the right.\nAlso known as arithmetic right shift.\n\n* If *count* is greater than the number of bits of this integer, returns 0\n* If *count* is negative, a left shift is performed\n\n```\n8000 >> 1  # => 4000\n8000 >> 2  # => 2000\n8000 >> 32 # => 0\n8000 >> -1 # => 16000\n\n-8000 >> 1 # => -4000\n```","summary":"<p>Returns the result of shifting this number's bits <em>count</em> positions to the right.</p>","abstract":false,"args":[{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(count : Int)","args_html":"(count : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/int.cr","line_number":206,"url":null},"def":{"name":">>","args":[{"name":"count","external_name":"count","restriction":"Int"}],"visibility":"Public","body":"if count < 0\n  self << count.abs\nelse\n  if count < ((sizeof(self)) * 8)\n    self.unsafe_shr(count)\n  else\n    self.class.zero\n  end\nend"}},{"html_id":"abs:self-instance-method","name":"abs","doc":"Returns the absolute value of this number.\n\n```\n123.abs  # => 123\n-123.abs # => 123\n```","summary":"<p>Returns the absolute value of this number.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":243,"url":null},"def":{"name":"abs","return_type":"self","visibility":"Public","body":"self >= 0 ? self : -self"}},{"html_id":"bit(bit)-instance-method","name":"bit","doc":"Returns this number's *bit*th bit, starting with the least-significant.\n\n```\n11.bit(0) # => 1\n11.bit(1) # => 1\n11.bit(2) # => 0\n11.bit(3) # => 1\n11.bit(4) # => 0\n```","summary":"<p>Returns this number's <em>bit</em>th bit, starting with the least-significant.</p>","abstract":false,"args":[{"name":"bit","external_name":"bit","restriction":""}],"args_string":"(bit)","args_html":"(bit)","location":{"filename":"src/int.cr","line_number":351,"url":null},"def":{"name":"bit","args":[{"name":"bit","external_name":"bit","restriction":""}],"visibility":"Public","body":"(self >> bit) & 1"}},{"html_id":"bit_length:Int32-instance-method","name":"bit_length","doc":"Returns the number of bits of this int value.\n\n“The number of bits” means that the bit position of the highest bit\nwhich is different to the sign bit.\n(The bit position of the bit 2**n is n+1.)\nIf there is no such bit (zero or minus one), zero is returned.\n\nI.e. This method returns `ceil(log2(self < 0 ? -self : self + 1))`.\n\n```\n0.bit_length # => 0\n1.bit_length # => 1\n2.bit_length # => 2\n3.bit_length # => 2\n4.bit_length # => 3\n5.bit_length # => 3\n\n# The above is the same as\n0b0.bit_length   # => 0\n0b1.bit_length   # => 1\n0b10.bit_length  # => 2\n0b11.bit_length  # => 2\n0b100.bit_length # => 3\n0b101.bit_length # => 3\n```","summary":"<p>Returns the number of bits of this int value.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":436,"url":null},"def":{"name":"bit_length","return_type":"Int32","visibility":"Public","body":"x = self < 0 ? ~self : self\nif x.is_a?(Int::Primitive)\n  Int32.new(((sizeof(self)) * 8) - x.leading_zeros_count)\nelse\n  (to_s(2)).size\nend\n"}},{"html_id":"bits(range:Range)-instance-method","name":"bits","doc":"Returns the requested range of bits\n\n```\n0b10011.bits(0..1) # => 0b11\n0b10011.bits(0..2) # => 0b11\n0b10011.bits(0..3) # => 0b11\n0b10011.bits(0..4) # => 0b10011\n0b10011.bits(0..5) # => 0b10011\n0b10011.bits(1..4) # => 0b1001\n```","summary":"<p>Returns the requested range of bits</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range)","args_html":"(range : <a href=\"Range.html\">Range</a>)","location":{"filename":"src/int.cr","line_number":365,"url":null},"def":{"name":"bits","args":[{"name":"range","external_name":"range","restriction":"Range"}],"visibility":"Public","body":"start_index = range.begin\nif start_index\n  if start_index < 0\n    raise(IndexError.new(\"start index (#{start_index}) must be positive\"))\n  end\nelse\n  start_index = 0\nend\nend_index = range.end\nif end_index\n  if end_index < 0\n    raise(IndexError.new(\"end index (#{end_index}) must be positive\"))\n  end\n  if range.exclusive?\n  else\n    end_index = end_index + 1\n  end\n  if end_index <= start_index\n    raise(IndexError.new(\"end index (#{end_index}) must be greater than start index (#{start_index})\"))\n  end\nelse\n  return self >> start_index\nend\ncount = end_index - start_index\nmask = ((self.class.new(1)) << count) &- 1\nif self < 0\n  offset = (~self) >> start_index\n  result = offset & mask\n  ~result\nelse\n  offset = self >> start_index\n  offset & mask\nend\n"}},{"html_id":"bits_set?(mask):Bool-instance-method","name":"bits_set?","doc":"Returns `true` if all bits in *mask* are set on `self`.\n\n```\n0b0110.bits_set?(0b0110) # => true\n0b1101.bits_set?(0b0111) # => false\n0b1101.bits_set?(0b1100) # => true\n```","summary":"<p>Returns <code>true</code> if all bits in <em>mask</em> are set on <code>self</code>.</p>","abstract":false,"args":[{"name":"mask","external_name":"mask","restriction":""}],"args_string":"(mask) : Bool","args_html":"(mask) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/int.cr","line_number":407,"url":null},"def":{"name":"bits_set?","args":[{"name":"mask","external_name":"mask","restriction":""}],"return_type":"Bool","visibility":"Public","body":"(self & mask) == mask"}},{"html_id":"ceil:self-instance-method","name":"ceil","abstract":false,"location":{"filename":"src/int.cr","line_number":251,"url":null},"def":{"name":"ceil","return_type":"self","visibility":"Public","body":"self"}},{"html_id":"chr:Char-instance-method","name":"chr","doc":"Returns a `Char` that has the unicode codepoint of `self`.\n\nRaises `ArgumentError` if this integer's value doesn't fit a char's range\n(`0..0xd7ff` and `0xe000..0x10ffff`).\n\n```\n97.chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":73,"url":null},"def":{"name":"chr","return_type":"Char","visibility":"Public","body":"if (0 <= self && self <= 55295) || (57344 <= self && self <= Char::MAX_CODEPOINT)\nelse\n  raise(ArgumentError.new(\"0x#{self.to_s(16)} out of char range\"))\nend\nunsafe_chr\n"}},{"html_id":"day:Time::Span-instance-method","name":"day","doc":"Returns a `Time::Span` of `self` days.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> days.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":442,"url":null},"def":{"name":"day","return_type":"Time::Span","visibility":"Public","body":"days"}},{"html_id":"days:Time::Span-instance-method","name":"days","doc":"Returns a `Time::Span` of `self` days.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> days.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":437,"url":null},"def":{"name":"days","return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(days: self)"}},{"html_id":"digits(base=10):Array(Int32)-instance-method","name":"digits","doc":"Returns the digits of a number in a given base.\nThe digits are returned as an array with the least significant digit as the first array element.\n\n```\n12345.digits      # => [5, 4, 3, 2, 1]\n12345.digits(7)   # => [4, 6, 6, 0, 5]\n12345.digits(100) # => [45, 23, 1]\n\n-12345.digits(7) # => ArgumentError\n```","summary":"<p>Returns the digits of a number in a given base.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":""}],"args_string":"(base = 10) : Array(Int32)","args_html":"(base = <span class=\"n\">10</span>) : <a href=\"Array.html\">Array</a>(<a href=\"Int32.html\">Int32</a>)","location":{"filename":"src/int.cr","line_number":591,"url":null},"def":{"name":"digits","args":[{"name":"base","default_value":"10","external_name":"base","restriction":""}],"return_type":"Array(Int32)","visibility":"Public","body":"if base < 2\n  raise(ArgumentError.new(\"Invalid base #{base}\"))\nend\nif self < 0\n  raise(ArgumentError.new(\"Can't request digits of negative number\"))\nend\nif self == 0\n  return [0]\nend\nnum = self\ndigits_count = ((Math.log(self.to_f + 1)) / (Math.log(base))).ceil.to_i\nary = Array(Int32).new(digits_count)\nwhile num != 0\n  ary << (num.remainder(base)).to_i\n  num = num.tdiv(base)\nend\nary\n"}},{"html_id":"divisible_by?(num):Bool-instance-method","name":"divisible_by?","abstract":false,"args":[{"name":"num","external_name":"num","restriction":""}],"args_string":"(num) : Bool","args_html":"(num) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/int.cr","line_number":498,"url":null},"def":{"name":"divisible_by?","args":[{"name":"num","external_name":"num","restriction":""}],"return_type":"Bool","visibility":"Public","body":"(remainder(num)) == 0"}},{"html_id":"downto(to,&block:self->):Nil-instance-method","name":"downto","abstract":false,"args":[{"name":"to","external_name":"to","restriction":""}],"args_string":"(to, &block : self -> ) : Nil","args_html":"(to, &block : <span class=\"k\">self</span> -> ) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/int.cr","line_number":549,"url":null},"def":{"name":"downto","args":[{"name":"to","external_name":"to","restriction":""}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(self ->)"},"return_type":"Nil","visibility":"Public","body":"if self >= to\nelse\n  return\nend\nx = self\nwhile true\n  yield x\n  if x == to\n    return\n  end\n  x = x - 1\nend\n"}},{"html_id":"downto(to)-instance-method","name":"downto","abstract":false,"args":[{"name":"to","external_name":"to","restriction":""}],"args_string":"(to)","args_html":"(to)","location":{"filename":"src/int.cr","line_number":559,"url":null},"def":{"name":"downto","args":[{"name":"to","external_name":"to","restriction":""}],"visibility":"Public","body":"DowntoIterator(typeof(self), typeof(to)).new(self, to)"}},{"html_id":"even?:Bool-instance-method","name":"even?","abstract":false,"location":{"filename":"src/int.cr","line_number":502,"url":null},"def":{"name":"even?","return_type":"Bool","visibility":"Public","body":"divisible_by?(2)"}},{"html_id":"fdiv(other):Float64-instance-method","name":"fdiv","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other) : Float64","args_html":"(other) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":151,"url":null},"def":{"name":"fdiv","args":[{"name":"other","external_name":"other","restriction":""}],"return_type":"Float64","visibility":"Public","body":"to_f / other"}},{"html_id":"floor:self-instance-method","name":"floor","abstract":false,"location":{"filename":"src/int.cr","line_number":255,"url":null},"def":{"name":"floor","return_type":"self","visibility":"Public","body":"self"}},{"html_id":"gcd(other:self):self-instance-method","name":"gcd","doc":"Returns the greatest common divisor of `self` and *other*. Signed\nintegers may raise `OverflowError` if either has value equal to `MIN` of\nits type.\n\n```\n5.gcd(10) # => 5\n5.gcd(7)  # => 1\n```","summary":"<p>Returns the greatest common divisor of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self) : self","args_html":"(other : <span class=\"k\">self</span>) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":455,"url":null},"def":{"name":"gcd","args":[{"name":"other","external_name":"other","restriction":"self"}],"return_type":"self","visibility":"Public","body":"u = self.abs\nv = other.abs\nif u == 0\n  return v\nend\nif v == 0\n  return u\nend\nshift = self.class.zero\nwhile ((u | v) & 1) == 0\n  shift = shift &+ 1\n  u = u.unsafe_shr(1)\n  v = v.unsafe_shr(1)\nend\nwhile (u & 1) == 0\n  u = u.unsafe_shr(1)\nend\nloop do\n  while (v & 1) == 0\n    v = v.unsafe_shr(1)\n  end\n  if u > v\n    u, v = v, u\n  end\n  v = v &- u\n  if v.zero?\n    break\n  end\nend\nu.unsafe_shl(shift)\n"}},{"html_id":"gcd(other:BigInt):Int-instance-method","name":"gcd","doc":"Returns the greatest common divisor of `self` and *other*.","summary":"<p>Returns the greatest common divisor of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : Int","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"Int.html\">Int</a>","location":{"filename":"src/big/big_int.cr","line_number":751,"url":null},"def":{"name":"gcd","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"Int","visibility":"Public","body":"other.gcd(self)"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/int.cr","line_number":511,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher.int(self)"}},{"html_id":"hour:Time::Span-instance-method","name":"hour","doc":"Returns a `Time::Span` of `self` hours.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> hours.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":452,"url":null},"def":{"name":"hour","return_type":"Time::Span","visibility":"Public","body":"hours"}},{"html_id":"hours:Time::Span-instance-method","name":"hours","doc":"Returns a `Time::Span` of `self` hours.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> hours.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":447,"url":null},"def":{"name":"hours","return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(hours: self)"}},{"html_id":"humanize_bytes(io:IO,precision:Int=3,separator='.',*,significant:Bool=true,format:BinaryPrefixFormat=:IEC):Nil-instance-method","name":"humanize_bytes","doc":"Prints this integer as a binary value in a human-readable format using\na `BinaryPrefixFormat`.\n\nValues with binary measurements such as computer storage (e.g. RAM size) are\ntypically expressed using unit prefixes based on 1024 (instead of multiples\nof 1000 as per SI standard). This method by default uses the IEC standard\nprefixes (`Ki`, `Mi`, `Gi`, `Ti`, `Pi`, `Ei`, `Zi`, `Yi`) based on powers of\n1000 (see `BinaryPrefixFormat::IEC`).\n\n*format* can be set to use the extended range of JEDEC units (`K`, `M`, `G`,\n`T`, `P`, `E`, `Z`, `Y`) which equals to the prefixes of the SI system\nexcept for uppercase `K` and is based on powers of 1024 (see\n`BinaryPrefixFormat::JEDEC`).\n\n```\n1.humanize_bytes                        # => \"1B\"\n1024.humanize_bytes                     # => \"1.0kiB\"\n1536.humanize_bytes                     # => \"1.5kiB\"\n524288.humanize_bytes                   # => \"512kiB\"\n1073741824.humanize_bytes(format: :IEC) # => \"1.0GiB\"\n```\n\nSee `Number#humanize` for more details on the behaviour and arguments.","summary":"<p>Prints this integer as a binary value in a human-readable format using a <code><a href=\"Int/BinaryPrefixFormat.html\">BinaryPrefixFormat</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"precision","default_value":"3","external_name":"precision","restriction":"Int"},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":"Bool"},{"name":"format","default_value":":IEC","external_name":"format","restriction":"BinaryPrefixFormat"}],"args_string":"(io : IO, precision : Int = 3, separator = '.', *, significant : Bool = true, format : BinaryPrefixFormat = :IEC) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, precision : <a href=\"Int.html\">Int</a> = <span class=\"n\">3</span>, separator = <span class=\"s\">&#39;.&#39;</span>, *, significant : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, format : <a href=\"Int/BinaryPrefixFormat.html\">BinaryPrefixFormat</a> = <span class=\"n\">:IEC</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/humanize.cr","line_number":320,"url":null},"def":{"name":"humanize_bytes","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"precision","default_value":"3","external_name":"precision","restriction":"Int"},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":"Bool"},{"name":"format","default_value":":IEC","external_name":"format","restriction":"BinaryPrefixFormat"}],"splat_index":3,"return_type":"Nil","visibility":"Public","body":"humanize(io, precision, separator, nil, base: 1024, significant: significant) do |magnitude|\n  magnitude = Number.prefix_index(magnitude)\n  prefix = Number.si_prefix(magnitude)\n  if prefix.nil?\n    unit = \"B\"\n  else\n    if format.iec?\n      unit = \"#{prefix}iB\"\n    else\n      unit = \"#{prefix.upcase}B\"\n    end\n  end\n  {magnitude, unit, magnitude > 0}\nend"}},{"html_id":"humanize_bytes(precision:Int=3,separator='.',*,significant:Bool=true,format:BinaryPrefixFormat=:IEC):String-instance-method","name":"humanize_bytes","doc":"Prints this integer as a binary value in a human-readable format using\na `BinaryPrefixFormat`.\n\nValues with binary measurements such as computer storage (e.g. RAM size) are\ntypically expressed using unit prefixes based on 1024 (instead of multiples\nof 1000 as per SI standard). This method by default uses the IEC standard\nprefixes (`Ki`, `Mi`, `Gi`, `Ti`, `Pi`, `Ei`, `Zi`, `Yi`) based on powers of\n1000 (see `BinaryPrefixFormat::IEC`).\n\n*format* can be set to use the extended range of JEDEC units (`K`, `M`, `G`,\n`T`, `P`, `E`, `Z`, `Y`) which equals to the prefixes of the SI system\nexcept for uppercase `K` and is based on powers of 1024 (see\n`BinaryPrefixFormat::JEDEC`).\n\n```\n1.humanize_bytes                        # => \"1B\"\n1024.humanize_bytes                     # => \"1.0kiB\"\n1536.humanize_bytes                     # => \"1.5kiB\"\n524288.humanize_bytes                   # => \"512kiB\"\n1073741824.humanize_bytes(format: :IEC) # => \"1.0GiB\"\n```\n\nSee `Number#humanize` for more details on the behaviour and arguments.","summary":"<p>Prints this integer as a binary value in a human-readable format using a <code><a href=\"Int/BinaryPrefixFormat.html\">BinaryPrefixFormat</a></code>.</p>","abstract":false,"args":[{"name":"precision","default_value":"3","external_name":"precision","restriction":"Int"},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":"Bool"},{"name":"format","default_value":":IEC","external_name":"format","restriction":"BinaryPrefixFormat"}],"args_string":"(precision : Int = 3, separator = '.', *, significant : Bool = true, format : BinaryPrefixFormat = :IEC) : String","args_html":"(precision : <a href=\"Int.html\">Int</a> = <span class=\"n\">3</span>, separator = <span class=\"s\">&#39;.&#39;</span>, *, significant : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, format : <a href=\"Int/BinaryPrefixFormat.html\">BinaryPrefixFormat</a> = <span class=\"n\">:IEC</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/humanize.cr","line_number":339,"url":null},"def":{"name":"humanize_bytes","args":[{"name":"precision","default_value":"3","external_name":"precision","restriction":"Int"},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":"Bool"},{"name":"format","default_value":":IEC","external_name":"format","restriction":"BinaryPrefixFormat"}],"splat_index":2,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  humanize_bytes(io, precision, separator, significant: significant, format: format)\nend"}},{"html_id":"lcm(other:BigInt):BigInt-instance-method","name":"lcm","doc":"Returns the least common multiple of `self` and *other*.","summary":"<p>Returns the least common multiple of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigInt","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":756,"url":null},"def":{"name":"lcm","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigInt","visibility":"Public","body":"other.lcm(self)"}},{"html_id":"lcm(other:Int)-instance-method","name":"lcm","doc":"Returns the least common multiple of `self` and *other*.\n\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the least common multiple of <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","args_html":"(other : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/int.cr","line_number":494,"url":null},"def":{"name":"lcm","args":[{"name":"other","external_name":"other","restriction":"Int"}],"visibility":"Public","body":"((self // (gcd(other))) * other).abs"}},{"html_id":"microsecond:Time::Span-instance-method","name":"microsecond","doc":"Returns a `Time::Span` of `self` microseconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> microseconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":492,"url":null},"def":{"name":"microsecond","return_type":"Time::Span","visibility":"Public","body":"microseconds"}},{"html_id":"microseconds:Time::Span-instance-method","name":"microseconds","doc":"Returns a `Time::Span` of `self` microseconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> microseconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":487,"url":null},"def":{"name":"microseconds","return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(nanoseconds: (self.to_i64 * Time::NANOSECONDS_PER_MICROSECOND))"}},{"html_id":"millisecond:Time::Span-instance-method","name":"millisecond","doc":"Returns a `Time::Span` of `self` milliseconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> milliseconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":482,"url":null},"def":{"name":"millisecond","return_type":"Time::Span","visibility":"Public","body":"milliseconds"}},{"html_id":"milliseconds:Time::Span-instance-method","name":"milliseconds","doc":"Returns a `Time::Span` of `self` milliseconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> milliseconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":477,"url":null},"def":{"name":"milliseconds","return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(nanoseconds: (self.to_i64 * Time::NANOSECONDS_PER_MILLISECOND))"}},{"html_id":"minute:Time::Span-instance-method","name":"minute","doc":"Returns a `Time::Span` of `self` minutes.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> minutes.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":462,"url":null},"def":{"name":"minute","return_type":"Time::Span","visibility":"Public","body":"minutes"}},{"html_id":"minutes:Time::Span-instance-method","name":"minutes","doc":"Returns a `Time::Span` of `self` minutes.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> minutes.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":457,"url":null},"def":{"name":"minutes","return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(minutes: self)"}},{"html_id":"modulo(other)-instance-method","name":"modulo","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/int.cr","line_number":577,"url":null},"def":{"name":"modulo","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"self % other"}},{"html_id":"month:Time::MonthSpan-instance-method","name":"month","doc":"Returns a `Time::MonthSpan` of `self` months.","summary":"<p>Returns a <code><a href=\"Time/MonthSpan.html\">Time::MonthSpan</a></code> of <code>self</code> months.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":600,"url":null},"def":{"name":"month","return_type":"Time::MonthSpan","visibility":"Public","body":"months"}},{"html_id":"months:Time::MonthSpan-instance-method","name":"months","doc":"Returns a `Time::MonthSpan` of `self` months.","summary":"<p>Returns a <code><a href=\"Time/MonthSpan.html\">Time::MonthSpan</a></code> of <code>self</code> months.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":595,"url":null},"def":{"name":"months","return_type":"Time::MonthSpan","visibility":"Public","body":"Time::MonthSpan.new(self)"}},{"html_id":"nanosecond:Time::Span-instance-method","name":"nanosecond","doc":"Returns a `Time::Span` of `self` nanoseconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> nanoseconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":502,"url":null},"def":{"name":"nanosecond","return_type":"Time::Span","visibility":"Public","body":"nanoseconds"}},{"html_id":"nanoseconds:Time::Span-instance-method","name":"nanoseconds","doc":"Returns a `Time::Span` of `self` nanoseconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> nanoseconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":497,"url":null},"def":{"name":"nanoseconds","return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(nanoseconds: self.to_i64)"}},{"html_id":"odd?:Bool-instance-method","name":"odd?","abstract":false,"location":{"filename":"src/int.cr","line_number":506,"url":null},"def":{"name":"odd?","return_type":"Bool","visibility":"Public","body":"!even?"}},{"html_id":"popcount-instance-method","name":"popcount","doc":"Counts `1`-bits in the binary representation of this integer.\n\n```\n5.popcount   # => 2\n-15.popcount # => 29\n```","summary":"<p>Counts <code>1</code>-bits in the binary representation of this integer.</p>","abstract":true,"location":{"filename":"src/int.cr","line_number":768,"url":null},"def":{"name":"popcount","visibility":"Public","body":""}},{"html_id":"pred:self-instance-method","name":"pred","abstract":false,"location":{"filename":"src/int.cr","line_number":519,"url":null},"def":{"name":"pred","return_type":"self","visibility":"Public","body":"self - 1"}},{"html_id":"remainder(other:Int)-instance-method","name":"remainder","doc":"Returns `self` remainder *other*.\n\nThis uses truncated division.\n\nSee `Int#tdiv` for more details.","summary":"<p>Returns <code>self</code> remainder <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","args_html":"(other : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/int.cr","line_number":180,"url":null},"def":{"name":"remainder","args":[{"name":"other","external_name":"other","restriction":"Int"}],"visibility":"Public","body":"{% if true %}\n      if other == 0\n        raise DivisionByZeroError.new\n      elsif self < 0 && self == {{ @type }}::MIN && other == -1\n        self.class.new(0)\n      else\n        unsafe_mod other\n      end\n    {% end %}"}},{"html_id":"round(mode:RoundingMode):self-instance-method","name":"round","doc":"Rounds `self` to an integer value using rounding *mode*.\n\nThe rounding *mode* controls the direction of the rounding. The default is\n`RoundingMode::TIES_EVEN` which rounds to the nearest integer, with ties\n(fractional value of `0.5`) being rounded to the even neighbor (Banker's rounding).","summary":"<p>Rounds <code>self</code> to an integer value using rounding <em>mode</em>.</p>","abstract":false,"args":[{"name":"mode","external_name":"mode","restriction":"RoundingMode"}],"args_string":"(mode : RoundingMode) : self","args_html":"(mode : <a href=\"Number/RoundingMode.html\">RoundingMode</a>) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":247,"url":null},"def":{"name":"round","args":[{"name":"mode","external_name":"mode","restriction":"RoundingMode"}],"return_type":"self","visibility":"Public","body":"self"}},{"html_id":"round_away-instance-method","name":"round_away","doc":"Returns `self`.","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":269,"url":null},"def":{"name":"round_away","visibility":"Public","body":"self"}},{"html_id":"round_even:self-instance-method","name":"round_even","doc":"Returns `self`.","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":264,"url":null},"def":{"name":"round_even","return_type":"self","visibility":"Public","body":"self"}},{"html_id":"second:Time::Span-instance-method","name":"second","doc":"Returns a `Time::Span` of `self` seconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> seconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":472,"url":null},"def":{"name":"second","return_type":"Time::Span","visibility":"Public","body":"seconds"}},{"html_id":"seconds:Time::Span-instance-method","name":"seconds","doc":"Returns a `Time::Span` of `self` seconds.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> seconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":467,"url":null},"def":{"name":"seconds","return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(seconds: self)"}},{"html_id":"succ:self-instance-method","name":"succ","abstract":false,"location":{"filename":"src/int.cr","line_number":515,"url":null},"def":{"name":"succ","return_type":"self","visibility":"Public","body":"self + 1"}},{"html_id":"tdiv(other:Int)-instance-method","name":"tdiv","doc":"Divides `self` by *other* using truncated division.\n\nIn truncated division, given two integers x and y:\n* `q = x.tdiv(y)` is rounded toward zero\n* `r = x.remainder(y)` has the sign of the first argument\n* `x == q*y + r`\n\nFor example:\n\n```text\n x     y     x / y     x % y\n 5     3       1         2\n-5     3      -1        -2\n 5    -3      -1         2\n-5    -3       1        -2\n```\n\nRaises if *other* is `0`, or if *other* is `-1` and\n`self` is signed and is the minimum value for that\ninteger type.","summary":"<p>Divides <code>self</code> by <em>other</em> using truncated division.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","args_html":"(other : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/int.cr","line_number":133,"url":null},"def":{"name":"tdiv","args":[{"name":"other","external_name":"other","restriction":"Int"}],"visibility":"Public","body":"check_div_argument(other)\nunsafe_div(other)\n"}},{"html_id":"times(&block:self->):Nil-instance-method","name":"times","abstract":false,"location":{"filename":"src/int.cr","line_number":523,"url":null},"def":{"name":"times","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(self ->)"},"return_type":"Nil","visibility":"Public","body":"i = self ^ self\nwhile i < self\n  yield i\n  i = i &+ 1\nend\n"}},{"html_id":"times-instance-method","name":"times","abstract":false,"location":{"filename":"src/int.cr","line_number":531,"url":null},"def":{"name":"times","visibility":"Public","body":"TimesIterator(typeof(self)).new(self)"}},{"html_id":"to(to,&block:self->):Nil-instance-method","name":"to","abstract":false,"args":[{"name":"to","external_name":"to","restriction":""}],"args_string":"(to, &block : self -> ) : Nil","args_html":"(to, &block : <span class=\"k\">self</span> -> ) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/int.cr","line_number":563,"url":null},"def":{"name":"to","args":[{"name":"to","external_name":"to","restriction":""}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(self ->)"},"return_type":"Nil","visibility":"Public","body":"if self < to\n  upto(to) do |i|\n    yield i\n  end\nelse\n  if self > to\n    downto(to) do |i|\n      yield i\n    end\n  else\n    yield self\n  end\nend"}},{"html_id":"to(to)-instance-method","name":"to","abstract":false,"args":[{"name":"to","external_name":"to","restriction":""}],"args_string":"(to)","args_html":"(to)","location":{"filename":"src/int.cr","line_number":573,"url":null},"def":{"name":"to","args":[{"name":"to","external_name":"to","restriction":""}],"visibility":"Public","body":"self <= to ? upto(to) : downto(to)"}},{"html_id":"to_big_d:BigDecimal-instance-method","name":"to_big_d","doc":"Converts `self` to `BigDecimal`.\n```\nrequire \"big\"\n12123415151254124124.to_big_d\n```","summary":"<p>Converts <code>self</code> to <code><a href=\"BigDecimal.html\">BigDecimal</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":642,"url":null},"def":{"name":"to_big_d","return_type":"BigDecimal","visibility":"Public","body":"BigDecimal.new(self)"}},{"html_id":"to_big_i:BigInt-instance-method","name":"to_big_i","doc":"Returns a `BigInt` representing this integer.\n```\nrequire \"big\"\n\n123.to_big_i\n```","summary":"<p>Returns a <code><a href=\"BigInt.html\">BigInt</a></code> representing this integer.</p>","abstract":false,"location":{"filename":"src/big/big_int.cr","line_number":766,"url":null},"def":{"name":"to_big_i","return_type":"BigInt","visibility":"Public","body":"BigInt.new(self)"}},{"html_id":"to_big_r:BigRational-instance-method","name":"to_big_r","doc":"Returns a `BigRational` representing this integer.\n```\nrequire \"big\"\n\n123.to_big_r\n```","summary":"<p>Returns a <code><a href=\"BigRational.html\">BigRational</a></code> representing this integer.</p>","abstract":false,"location":{"filename":"src/big/big_rational.cr","line_number":315,"url":null},"def":{"name":"to_big_r","return_type":"BigRational","visibility":"Public","body":"BigRational.new(self, 1)"}},{"html_id":"to_io(io:IO,format:IO::ByteFormat):Nil-instance-method","name":"to_io","doc":"Writes this integer to the given *io* in the given *format*.\n\nSee also: `IO#write_bytes`.","summary":"<p>Writes this integer to the given <em>io</em> in the given <em>format</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"format","external_name":"format","restriction":"IO::ByteFormat"}],"args_string":"(io : IO, format : IO::ByteFormat) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, format : <a href=\"IO/ByteFormat.html\">IO::ByteFormat</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/int.cr","line_number":751,"url":null},"def":{"name":"to_io","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"format","external_name":"format","restriction":"IO::ByteFormat"}],"return_type":"Nil","visibility":"Public","body":"format.encode(self, io)"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":44,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.number(self)"}},{"html_id":"to_json_object_key:String-instance-method","name":"to_json_object_key","abstract":false,"location":{"filename":"src/json/to_json.cr","line_number":48,"url":null},"def":{"name":"to_json_object_key","return_type":"String","visibility":"Public","body":"to_s"}},{"html_id":"to_s(io:IO,base:Int=10,*,precision:Int=1,upcase:Bool=false):Nil-instance-method","name":"to_s","doc":"Appends a string representation of this integer to the given *io*.\n\n*base* specifies the radix of the written string, and must be either 62 or\na number between 2 and 36. By default, digits above 9 are represented by\nASCII lowercase letters (`a` for 10, `b` for 11, etc.), but uppercase\nletters may be used if *upcase* is `true`, unless base 62 is used. In that\ncase, lowercase letters are used for 10 to 35, and uppercase ones for 36 to\n61, and *upcase* must be `false`.\n\n*precision* specifies the minimum number of digits in the written string.\nIf there are fewer digits than this number, the string is left-padded by\nzeros. If `self` and *precision* are both zero, returns an empty string.","summary":"<p>Appends a string representation of this integer to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"","external_name":"","restriction":""},{"name":"precision","default_value":"1","external_name":"precision","restriction":"Int"},{"name":"upcase","default_value":"false","external_name":"upcase","restriction":"Bool"}],"args_string":"(io : IO, base : Int = 10, *, precision : Int = 1, upcase : Bool = false) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, *, precision : <a href=\"Int.html\">Int</a> = <span class=\"n\">1</span>, upcase : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/int.cr","line_number":702,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"","external_name":"","restriction":""},{"name":"precision","default_value":"1","external_name":"precision","restriction":"Int"},{"name":"upcase","default_value":"false","external_name":"upcase","restriction":"Bool"}],"splat_index":2,"return_type":"Nil","visibility":"Public","body":"if (2 <= base && base <= 36) || (base == 62)\nelse\n  raise(ArgumentError.new(\"Invalid base #{base}\"))\nend\nif upcase && (base == 62)\n  raise(ArgumentError.new(\"upcase must be false for base 62\"))\nend\nif precision >= 0\nelse\n  raise(ArgumentError.new(\"Precision must be non-negative\"))\nend\ncase {self, precision}\nwhen {0, 0}\nwhen {0, 1}\n  io << '0'\nwhen {1, 1}\n  io << '1'\nelse\n  internal_to_s(base, precision, upcase) do |ptr, count, negative|\n    if negative\n      io << '-'\n    end\n    if precision > count\n      (precision - count).times do\n        io << '0'\n      end\n    end\n    io.write_string(Slice.new(ptr, count))\n  end\nend\n"}},{"html_id":"to_s(base:Int=10,*,precision:Int=1,upcase:Bool=false):String-instance-method","name":"to_s","doc":"Returns a string representation of this integer.\n\n*base* specifies the radix of the returned string, and must be either 62 or\na number between 2 and 36. By default, digits above 9 are represented by\nASCII lowercase letters (`a` for 10, `b` for 11, etc.), but uppercase\nletters may be used if *upcase* is `true`, unless base 62 is used. In that\ncase, lowercase letters are used for 10 to 35, and uppercase ones for 36 to\n61, and *upcase* must be `false`.\n\n*precision* specifies the minimum number of digits in the returned string.\nIf there are fewer digits than this number, the string is left-padded by\nzeros. If `self` and *precision* are both zero, returns an empty string.\n\n```\n1234.to_s                   # => \"1234\"\n1234.to_s(2)                # => \"10011010010\"\n1234.to_s(16)               # => \"4d2\"\n1234.to_s(16, upcase: true) # => \"4D2\"\n1234.to_s(36)               # => \"ya\"\n1234.to_s(62)               # => \"jU\"\n1234.to_s(precision: 2)     # => \"1234\"\n1234.to_s(precision: 6)     # => \"001234\"\n```","summary":"<p>Returns a string representation of this integer.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"","external_name":"","restriction":""},{"name":"precision","default_value":"1","external_name":"precision","restriction":"Int"},{"name":"upcase","default_value":"false","external_name":"upcase","restriction":"Bool"}],"args_string":"(base : Int = 10, *, precision : Int = 1, upcase : Bool = false) : String","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, *, precision : <a href=\"Int.html\">Int</a> = <span class=\"n\">1</span>, upcase : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/int.cr","line_number":643,"url":null},"def":{"name":"to_s","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"","external_name":"","restriction":""},{"name":"precision","default_value":"1","external_name":"precision","restriction":"Int"},{"name":"upcase","default_value":"false","external_name":"upcase","restriction":"Bool"}],"splat_index":1,"return_type":"String","visibility":"Public","body":"if (2 <= base && base <= 36) || (base == 62)\nelse\n  raise(ArgumentError.new(\"Invalid base #{base}\"))\nend\nif upcase && (base == 62)\n  raise(ArgumentError.new(\"upcase must be false for base 62\"))\nend\nif precision >= 0\nelse\n  raise(ArgumentError.new(\"Precision must be non-negative\"))\nend\ncase {self, precision}\nwhen {0, 0}\n  \"\"\nwhen {0, 1}\n  \"0\"\nwhen {1, 1}\n  \"1\"\nelse\n  internal_to_s(base, precision, upcase) do |ptr, count, negative|\n    if precision <= count || precision <= 128\n      if precision > count\n        difference = precision - count\n        ptr = ptr - difference\n        (Slice.new(ptr, difference)).fill('0'.ord.to_u8)\n        count = count + difference\n      end\n      if negative\n        ptr = ptr - 1\n        ptr.value = '-'.ord.to_u8\n        count = count + 1\n      end\n      String.new(ptr, count, count)\n    else\n      len = precision + (negative ? 1 : 0)\n      String.new(len) do |buffer|\n        if negative\n          buffer.value = '-'.ord.to_u8\n          buffer = buffer + 1\n        end\n        (Slice.new(buffer, precision - count)).fill('0'.ord.to_u8)\n        ptr.copy_to((buffer + precision) - count, count)\n        {len, len}\n      end\n    end\n  end\nend\n"}},{"html_id":"trailing_zeros_count-instance-method","name":"trailing_zeros_count","doc":"Returns the number of trailing `0`-bits.","summary":"<p>Returns the number of trailing <code>0</code>-bits.</p>","abstract":true,"location":{"filename":"src/int.cr","line_number":771,"url":null},"def":{"name":"trailing_zeros_count","visibility":"Public","body":""}},{"html_id":"trunc:self-instance-method","name":"trunc","abstract":false,"location":{"filename":"src/int.cr","line_number":259,"url":null},"def":{"name":"trunc","return_type":"self","visibility":"Public","body":"self"}},{"html_id":"upto(to,&block:self->):Nil-instance-method","name":"upto","abstract":false,"args":[{"name":"to","external_name":"to","restriction":""}],"args_string":"(to, &block : self -> ) : Nil","args_html":"(to, &block : <span class=\"k\">self</span> -> ) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/int.cr","line_number":535,"url":null},"def":{"name":"upto","args":[{"name":"to","external_name":"to","restriction":""}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(self ->)"},"return_type":"Nil","visibility":"Public","body":"if self <= to\nelse\n  return\nend\nx = self\nwhile true\n  yield x\n  if x == to\n    return\n  end\n  x = x + 1\nend\n"}},{"html_id":"upto(to)-instance-method","name":"upto","abstract":false,"args":[{"name":"to","external_name":"to","restriction":""}],"args_string":"(to)","args_html":"(to)","location":{"filename":"src/int.cr","line_number":545,"url":null},"def":{"name":"upto","args":[{"name":"to","external_name":"to","restriction":""}],"visibility":"Public","body":"UptoIterator(typeof(self), typeof(to)).new(self, to)"}},{"html_id":"week:Time::Span-instance-method","name":"week","doc":"Returns a `Time::Span` of `self` weeks.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> weeks.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":432,"url":null},"def":{"name":"week","return_type":"Time::Span","visibility":"Public","body":"weeks"}},{"html_id":"weeks:Time::Span-instance-method","name":"weeks","doc":"Returns a `Time::Span` of `self` weeks.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> of <code>self</code> weeks.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":427,"url":null},"def":{"name":"weeks","return_type":"Time::Span","visibility":"Public","body":"Time::Span.new(days: (7 * self))"}},{"html_id":"year:Time::MonthSpan-instance-method","name":"year","doc":"Returns a `Time::MonthSpan` of `self` years.","summary":"<p>Returns a <code><a href=\"Time/MonthSpan.html\">Time::MonthSpan</a></code> of <code>self</code> years.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":610,"url":null},"def":{"name":"year","return_type":"Time::MonthSpan","visibility":"Public","body":"years"}},{"html_id":"years:Time::MonthSpan-instance-method","name":"years","doc":"Returns a `Time::MonthSpan` of `self` years.","summary":"<p>Returns a <code><a href=\"Time/MonthSpan.html\">Time::MonthSpan</a></code> of <code>self</code> years.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":605,"url":null},"def":{"name":"years","return_type":"Time::MonthSpan","visibility":"Public","body":"Time::MonthSpan.new(self * 12)"}},{"html_id":"~-instance-method","name":"~","abstract":false,"location":{"filename":"src/int.cr","line_number":80,"url":null},"def":{"name":"~","visibility":"Public","body":"self ^ -1"}}],"types":[{"html_id":"Crystal/Int/BinaryPrefixFormat","path":"Int/BinaryPrefixFormat.html","kind":"enum","full_name":"Int::BinaryPrefixFormat","name":"BinaryPrefixFormat","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/humanize.cr","line_number":286,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"IEC","name":"IEC","value":"0","doc":"The IEC standard prefixes (`Ki`, `Mi`, `Gi`, `Ti`, `Pi`, `Ei`, `Zi`, `Yi`)\nbased on powers of 1000.","summary":"<p>The IEC standard prefixes (<code>Ki</code>, <code>Mi</code>, <code>Gi</code>, <code>Ti</code>, <code>Pi</code>, <code>Ei</code>, <code>Zi</code>, <code>Yi</code>) based on powers of 1000.</p>"},{"id":"JEDEC","name":"JEDEC","value":"1","doc":"Extended range of the JEDEC units (`K`, `M`, `G`, `T`, `P`, `E`, `Z`, `Y`) which equals to\nthe prefixes of the SI system except for uppercase `K` and is based on\npowers of 1024.","summary":"<p>Extended range of the JEDEC units (<code>K</code>, <code>M</code>, <code>G</code>, <code>T</code>, <code>P</code>, <code>E</code>, <code>Z</code>, <code>Y</code>) which equals to the prefixes of the SI system except for uppercase <code>K</code> and is based on powers of 1024.</p>"}],"namespace":{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"instance_methods":[{"html_id":"iec?-instance-method","name":"iec?","abstract":false,"location":{"filename":"src/humanize.cr","line_number":289,"url":null},"def":{"name":"iec?","visibility":"Public","body":"self == IEC"}},{"html_id":"jedec?-instance-method","name":"jedec?","abstract":false,"location":{"filename":"src/humanize.cr","line_number":294,"url":null},"def":{"name":"jedec?","visibility":"Public","body":"self == JEDEC"}}]},{"html_id":"Crystal/Int/Primitive","path":"Int/Primitive.html","kind":"alias","full_name":"Int::Primitive","name":"Primitive","abstract":false,"locations":[{"filename":"src/int.cr","line_number":63,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(Int128 | Int16 | Int32 | Int64 | Int8 | UInt128 | UInt16 | UInt32 | UInt64 | UInt8)","aliased_html":"<a href=\"../Int128.html\">Int128</a> | <a href=\"../Int16.html\">Int16</a> | <a href=\"../Int32.html\">Int32</a> | <a href=\"../Int64.html\">Int64</a> | <a href=\"../Int8.html\">Int8</a> | <a href=\"../UInt128.html\">UInt128</a> | <a href=\"../UInt16.html\">UInt16</a> | <a href=\"../UInt32.html\">UInt32</a> | <a href=\"../UInt64.html\">UInt64</a> | <a href=\"../UInt8.html\">UInt8</a>","const":false,"namespace":{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"}},{"html_id":"Crystal/Int/Signed","path":"Int/Signed.html","kind":"alias","full_name":"Int::Signed","name":"Signed","abstract":false,"locations":[{"filename":"src/int.cr","line_number":61,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(Int128 | Int16 | Int32 | Int64 | Int8)","aliased_html":"<a href=\"../Int128.html\">Int128</a> | <a href=\"../Int16.html\">Int16</a> | <a href=\"../Int32.html\">Int32</a> | <a href=\"../Int64.html\">Int64</a> | <a href=\"../Int8.html\">Int8</a>","const":false,"namespace":{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"}},{"html_id":"Crystal/Int/Unsigned","path":"Int/Unsigned.html","kind":"alias","full_name":"Int::Unsigned","name":"Unsigned","abstract":false,"locations":[{"filename":"src/int.cr","line_number":62,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(UInt128 | UInt16 | UInt32 | UInt64 | UInt8)","aliased_html":"<a href=\"../UInt128.html\">UInt128</a> | <a href=\"../UInt16.html\">UInt16</a> | <a href=\"../UInt32.html\">UInt32</a> | <a href=\"../UInt64.html\">UInt64</a> | <a href=\"../UInt8.html\">UInt8</a>","const":false,"namespace":{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"}}]},{"html_id":"Crystal/Int128","path":"Int128.html","kind":"struct","full_name":"Int128","name":"Int128","abstract":false,"superclass":{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/number.cr","line_number":63,"url":null},{"filename":"src/int.cr","line_number":1042,"url":null},{"filename":"src/primitives.cr","line_number":280,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"MAX","name":"MAX","value":"~MIN"},{"id":"MIN","name":"MIN","value":"(new(1)) << 127","doc":"TODO: eventually update to literals once UInt128 bit support is finished","summary":"<p><span class=\"flag orange\">TODO</span>  eventually update to literals once UInt128 bit support is finished</p>"}],"constructors":[{"html_id":"new(value:String,base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):self-class-method","name":"new","doc":"Returns an `Int128` by invoking `to_i128` on *value*.\nSee `String#to_i` for more details.\n\n```\nInt128.new \"20\"                        # => 20\nInt128.new \"  20  \", whitespace: false # => Unhandled exception: Invalid Int128:   20 (ArgumentError)\n```","summary":"<p>Returns an <code><a href=\"Int128.html\">Int128</a></code> by invoking <code><a href=\"Int128.html#to_i128%3AInt128-instance-method\">#to_i128</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(value : String, base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : self","args_html":"(value : <a href=\"String.html\">String</a>, base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1054,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"self","visibility":"Public","body":"value.to_i128(base: base, whitespace: whitespace, underscore: underscore, prefix: prefix, strict: strict, leading_zero_is_octal: leading_zero_is_octal)"}},{"html_id":"new(value):self-class-method","name":"new","doc":"Returns an `Int128` by invoking `to_i128` on *value*.","summary":"<p>Returns an <code><a href=\"Int128.html\">Int128</a></code> by invoking <code><a href=\"Int128.html#to_i128%3AInt128-instance-method\">#to_i128</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1059,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_i128"}},{"html_id":"new!(value):self-class-method","name":"new!","doc":"Returns an `Int128` by invoking `to_i128!` on *value*.","summary":"<p>Returns an <code><a href=\"Int128.html\">Int128</a></code> by invoking <code><a href=\"Int128.html#to_i128%21%3AInt128-instance-method\">#to_i128!</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1064,"url":null},"def":{"name":"new!","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_i128!"}}],"instance_methods":[{"html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"--instance-method","name":"-","abstract":false,"location":{"filename":"src/int.cr","line_number":1072,"url":null},"def":{"name":"-","visibility":"Public","body":"(Int128.new(0)) - self"}},{"html_id":"/(other:Int8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Float64","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1068,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Float64","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1068,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Float64","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1068,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Float64","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1068,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Float64","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1068,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Float64","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1068,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Float64","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1068,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Float64","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1068,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Float64","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1068,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Float64","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1068,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Float32):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/int.cr","line_number":1069,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:Float64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1070,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:BigInt):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigFloat","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":64,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigFloat):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigFloat","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":65,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":66,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":67,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"<(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/int.cr","line_number":1090,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"leading_zeros_count-instance-method","name":"leading_zeros_count","doc":"Returns the number of leading `0`-bits.","summary":"<p>Returns the number of leading <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1082,"url":null},"def":{"name":"leading_zeros_count","visibility":"Public","body":"Intrinsics.countleading128(self, false)"}},{"html_id":"popcount-instance-method","name":"popcount","doc":"Counts `1`-bits in the binary representation of this integer.\n\n```\n5.popcount   # => 2\n-15.popcount # => 29\n```","summary":"<p>Counts <code>1</code>-bits in the binary representation of this integer.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1077,"url":null},"def":{"name":"popcount","visibility":"Public","body":"Intrinsics.popcount128(self)"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f!:Float64-instance-method","name":"to_f!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f32!:Float32-instance-method","name":"to_f32!","doc":"Returns `self` converted to `Float32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32!","return_type":"Float32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i!:Int32-instance-method","name":"to_i!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128","return_type":"Int128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i128!:Int128-instance-method","name":"to_i128!","doc":"Returns `self` converted to `Int128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128!","return_type":"Int128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i16!:Int16-instance-method","name":"to_i16!","doc":"Returns `self` converted to `Int16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16!","return_type":"Int16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i64!:Int64-instance-method","name":"to_i64!","doc":"Returns `self` converted to `Int64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64!","return_type":"Int64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i8!:Int8-instance-method","name":"to_i8!","doc":"Returns `self` converted to `Int8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8!","return_type":"Int8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u!:UInt32-instance-method","name":"to_u!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128","return_type":"UInt128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u128!:UInt128-instance-method","name":"to_u128!","doc":"Returns `self` converted to `UInt128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128!","return_type":"UInt128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u16!:UInt16-instance-method","name":"to_u16!","doc":"Returns `self` converted to `UInt16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16!","return_type":"UInt16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u64!:UInt64-instance-method","name":"to_u64!","doc":"Returns `self` converted to `UInt64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64!","return_type":"UInt64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u8!:UInt8-instance-method","name":"to_u8!","doc":"Returns `self` converted to `UInt8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8!","return_type":"UInt8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"trailing_zeros_count-instance-method","name":"trailing_zeros_count","doc":"Returns the number of trailing `0`-bits.","summary":"<p>Returns the number of trailing <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1086,"url":null},"def":{"name":"trailing_zeros_count","visibility":"Public","body":"Intrinsics.counttrailing128(self, false)"}},{"html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0xd7ff` and `0xe000..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0xd7ff</code> and <code>0xe000..0x10ffff</code>).</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"unsafe_chr","return_type":"Char","visibility":"Public","body":"# primitive: convert"}},{"html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}}]},{"html_id":"Crystal/Int16","path":"Int16.html","kind":"struct","full_name":"Int16","name":"Int16","abstract":false,"superclass":{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/number.cr","line_number":42,"url":null},{"filename":"src/int.cr","line_number":889,"url":null},{"filename":"src/primitives.cr","line_number":280,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"MAX","name":"MAX","value":"32767_i16"},{"id":"MIN","name":"MIN","value":"-32768_i16"}],"class_methods":[{"html_id":"from_json_object_key?(key:String)-class-method","name":"from_json_object_key?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String)","args_html":"(key : <a href=\"String.html\">String</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"from_json_object_key?","args":[{"name":"key","external_name":"key","restriction":"String"}],"visibility":"Public","body":"key.to_i16?"}}],"constructors":[{"html_id":"new(value:String,base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):self-class-method","name":"new","doc":"Returns an `Int16` by invoking `to_i16` on *value*.\nSee `String#to_i` for more details.\n\n```\nInt16.new \"20\"                        # => 20\nInt16.new \"  20  \", whitespace: false # => Unhandled exception: Invalid Int16:   20 (ArgumentError)\n```","summary":"<p>Returns an <code><a href=\"Int16.html\">Int16</a></code> by invoking <code><a href=\"Int16.html#to_i16%3AInt16-instance-method\">#to_i16</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(value : String, base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : self","args_html":"(value : <a href=\"String.html\">String</a>, base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":900,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"self","visibility":"Public","body":"value.to_i16(base: base, whitespace: whitespace, underscore: underscore, prefix: prefix, strict: strict, leading_zero_is_octal: leading_zero_is_octal)"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":59,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"Int16.new!(parse_scalar(ctx, node, Int64))"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"location = pull.location\nvalue = pull.read_int\nbegin\n  value.to_i16\nrescue ex : OverflowError | ArgumentError\n  raise(JSON::ParseException.new(\"Can't read Int16\", *location, ex))\nend\n"}},{"html_id":"new(value):self-class-method","name":"new","doc":"Returns an `Int16` by invoking `to_i16` on *value*.","summary":"<p>Returns an <code><a href=\"Int16.html\">Int16</a></code> by invoking <code><a href=\"Int16.html#to_i16%3AInt16-instance-method\">#to_i16</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":905,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_i16"}},{"html_id":"new!(value):self-class-method","name":"new!","doc":"Returns an `Int16` by invoking `to_i16!` on *value*.","summary":"<p>Returns an <code><a href=\"Int16.html\">Int16</a></code> by invoking <code><a href=\"Int16.html#to_i16%21%3AInt16-instance-method\">#to_i16!</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":910,"url":null},"def":{"name":"new!","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_i16!"}}],"instance_methods":[{"html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-:Int16-instance-method","name":"-","abstract":false,"location":{"filename":"src/int.cr","line_number":918,"url":null},"def":{"name":"-","return_type":"Int16","visibility":"Public","body":"0_i16 - self"}},{"html_id":"/(other:Int8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Float64","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":914,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Float64","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":914,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Float64","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":914,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Float64","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":914,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Float64","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":914,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Float64","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":914,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Float64","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":914,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Float64","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":914,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Float64","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":914,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Float64","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":914,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Float32):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/int.cr","line_number":915,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:Float64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":916,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:BigInt):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigFloat","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":43,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigFloat):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigFloat","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":44,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":45,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":46,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"<(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/int.cr","line_number":935,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"leading_zeros_count-instance-method","name":"leading_zeros_count","doc":"Returns the number of leading `0`-bits.","summary":"<p>Returns the number of leading <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":927,"url":null},"def":{"name":"leading_zeros_count","visibility":"Public","body":"Intrinsics.countleading16(self, false)"}},{"html_id":"popcount:Int16-instance-method","name":"popcount","doc":"Counts `1`-bits in the binary representation of this integer.\n\n```\n5.popcount   # => 2\n-15.popcount # => 29\n```","summary":"<p>Counts <code>1</code>-bits in the binary representation of this integer.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":922,"url":null},"def":{"name":"popcount","return_type":"Int16","visibility":"Public","body":"Intrinsics.popcount16(self)"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f!:Float64-instance-method","name":"to_f!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f32!:Float32-instance-method","name":"to_f32!","doc":"Returns `self` converted to `Float32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32!","return_type":"Float32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i!:Int32-instance-method","name":"to_i!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128","return_type":"Int128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i128!:Int128-instance-method","name":"to_i128!","doc":"Returns `self` converted to `Int128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128!","return_type":"Int128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i16!:Int16-instance-method","name":"to_i16!","doc":"Returns `self` converted to `Int16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16!","return_type":"Int16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i64!:Int64-instance-method","name":"to_i64!","doc":"Returns `self` converted to `Int64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64!","return_type":"Int64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i8!:Int8-instance-method","name":"to_i8!","doc":"Returns `self` converted to `Int8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8!","return_type":"Int8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u!:UInt32-instance-method","name":"to_u!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128","return_type":"UInt128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u128!:UInt128-instance-method","name":"to_u128!","doc":"Returns `self` converted to `UInt128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128!","return_type":"UInt128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u16!:UInt16-instance-method","name":"to_u16!","doc":"Returns `self` converted to `UInt16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16!","return_type":"UInt16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u64!:UInt64-instance-method","name":"to_u64!","doc":"Returns `self` converted to `UInt64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64!","return_type":"UInt64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u8!:UInt8-instance-method","name":"to_u8!","doc":"Returns `self` converted to `UInt8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8!","return_type":"UInt8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"trailing_zeros_count-instance-method","name":"trailing_zeros_count","doc":"Returns the number of trailing `0`-bits.","summary":"<p>Returns the number of trailing <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":931,"url":null},"def":{"name":"trailing_zeros_count","visibility":"Public","body":"Intrinsics.counttrailing16(self, false)"}},{"html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0xd7ff` and `0xe000..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0xd7ff</code> and <code>0xe000..0x10ffff</code>).</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"unsafe_chr","return_type":"Char","visibility":"Public","body":"# primitive: convert"}},{"html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}}]},{"html_id":"Crystal/Int32","path":"Int32.html","kind":"struct","full_name":"Int32","name":"Int32","abstract":false,"superclass":{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/number.cr","line_number":49,"url":null},{"filename":"src/int.cr","line_number":940,"url":null},{"filename":"src/primitives.cr","line_number":280,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"MAX","name":"MAX","value":"2147483647"},{"id":"MIN","name":"MIN","value":"-2147483648"}],"class_methods":[{"html_id":"from_json_object_key?(key:String)-class-method","name":"from_json_object_key?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String)","args_html":"(key : <a href=\"String.html\">String</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"from_json_object_key?","args":[{"name":"key","external_name":"key","restriction":"String"}],"visibility":"Public","body":"key.to_i32?"}}],"constructors":[{"html_id":"new(value:String,base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):self-class-method","name":"new","doc":"Returns an `Int32` by invoking `to_i32` on *value*.\nSee `String#to_i` for more details.\n\n```\nInt32.new \"20\"                        # => 20\nInt32.new \"  20  \", whitespace: false # => Unhandled exception: Invalid Int32:   20 (ArgumentError)\n```","summary":"<p>Returns an <code><a href=\"Int32.html\">Int32</a></code> by invoking <code><a href=\"Int32.html#to_i32%3AInt32-instance-method\">#to_i32</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(value : String, base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : self","args_html":"(value : <a href=\"String.html\">String</a>, base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":951,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"self","visibility":"Public","body":"value.to_i32(base: base, whitespace: whitespace, underscore: underscore, prefix: prefix, strict: strict, leading_zero_is_octal: leading_zero_is_octal)"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":59,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"Int32.new!(parse_scalar(ctx, node, Int64))"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"location = pull.location\nvalue = pull.read_int\nbegin\n  value.to_i32\nrescue ex : OverflowError | ArgumentError\n  raise(JSON::ParseException.new(\"Can't read Int32\", *location, ex))\nend\n"}},{"html_id":"new(value):self-class-method","name":"new","doc":"Returns an `Int32` by invoking `to_i32` on *value*.","summary":"<p>Returns an <code><a href=\"Int32.html\">Int32</a></code> by invoking <code><a href=\"Int32.html#to_i32%3AInt32-instance-method\">#to_i32</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":956,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_i32"}},{"html_id":"new!(value):self-class-method","name":"new!","doc":"Returns an `Int32` by invoking `to_i32!` on *value*.","summary":"<p>Returns an <code><a href=\"Int32.html\">Int32</a></code> by invoking <code><a href=\"Int32.html#to_i32%21%3AInt32-instance-method\">#to_i32!</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":961,"url":null},"def":{"name":"new!","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_i32!"}}],"instance_methods":[{"html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-:Int32-instance-method","name":"-","abstract":false,"location":{"filename":"src/int.cr","line_number":969,"url":null},"def":{"name":"-","return_type":"Int32","visibility":"Public","body":"0 - self"}},{"html_id":"/(other:Int8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Float64","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":965,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Float64","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":965,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Float64","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":965,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Float64","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":965,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Float64","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":965,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Float64","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":965,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Float64","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":965,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Float64","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":965,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Float64","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":965,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Float64","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":965,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Float32):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/int.cr","line_number":966,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:Float64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":967,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:BigInt):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigFloat","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":50,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigFloat):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigFloat","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":51,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":52,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":53,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"<(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/int.cr","line_number":986,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"leading_zeros_count-instance-method","name":"leading_zeros_count","doc":"Returns the number of leading `0`-bits.","summary":"<p>Returns the number of leading <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":978,"url":null},"def":{"name":"leading_zeros_count","visibility":"Public","body":"Intrinsics.countleading32(self, false)"}},{"html_id":"popcount:Int32-instance-method","name":"popcount","doc":"Counts `1`-bits in the binary representation of this integer.\n\n```\n5.popcount   # => 2\n-15.popcount # => 29\n```","summary":"<p>Counts <code>1</code>-bits in the binary representation of this integer.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":973,"url":null},"def":{"name":"popcount","return_type":"Int32","visibility":"Public","body":"Intrinsics.popcount32(self)"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f!:Float64-instance-method","name":"to_f!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f32!:Float32-instance-method","name":"to_f32!","doc":"Returns `self` converted to `Float32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32!","return_type":"Float32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i!:Int32-instance-method","name":"to_i!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128","return_type":"Int128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i128!:Int128-instance-method","name":"to_i128!","doc":"Returns `self` converted to `Int128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128!","return_type":"Int128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i16!:Int16-instance-method","name":"to_i16!","doc":"Returns `self` converted to `Int16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16!","return_type":"Int16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i64!:Int64-instance-method","name":"to_i64!","doc":"Returns `self` converted to `Int64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64!","return_type":"Int64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i8!:Int8-instance-method","name":"to_i8!","doc":"Returns `self` converted to `Int8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8!","return_type":"Int8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u!:UInt32-instance-method","name":"to_u!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128","return_type":"UInt128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u128!:UInt128-instance-method","name":"to_u128!","doc":"Returns `self` converted to `UInt128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128!","return_type":"UInt128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u16!:UInt16-instance-method","name":"to_u16!","doc":"Returns `self` converted to `UInt16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16!","return_type":"UInt16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u64!:UInt64-instance-method","name":"to_u64!","doc":"Returns `self` converted to `UInt64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64!","return_type":"UInt64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u8!:UInt8-instance-method","name":"to_u8!","doc":"Returns `self` converted to `UInt8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8!","return_type":"UInt8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"trailing_zeros_count-instance-method","name":"trailing_zeros_count","doc":"Returns the number of trailing `0`-bits.","summary":"<p>Returns the number of trailing <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":982,"url":null},"def":{"name":"trailing_zeros_count","visibility":"Public","body":"Intrinsics.counttrailing32(self, false)"}},{"html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0xd7ff` and `0xe000..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0xd7ff</code> and <code>0xe000..0x10ffff</code>).</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"unsafe_chr","return_type":"Char","visibility":"Public","body":"# primitive: convert"}},{"html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}}]},{"html_id":"Crystal/Int64","path":"Int64.html","kind":"struct","full_name":"Int64","name":"Int64","abstract":false,"superclass":{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/number.cr","line_number":56,"url":null},{"filename":"src/int.cr","line_number":991,"url":null},{"filename":"src/primitives.cr","line_number":280,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"MAX","name":"MAX","value":"9223372036854775807_i64"},{"id":"MIN","name":"MIN","value":"-9223372036854775808_i64"}],"class_methods":[{"html_id":"from_json_object_key?(key:String)-class-method","name":"from_json_object_key?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String)","args_html":"(key : <a href=\"String.html\">String</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"from_json_object_key?","args":[{"name":"key","external_name":"key","restriction":"String"}],"visibility":"Public","body":"key.to_i64?"}}],"constructors":[{"html_id":"new(value:String,base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):self-class-method","name":"new","doc":"Returns an `Int64` by invoking `to_i64` on *value*.\nSee `String#to_i` for more details.\n\n```\nInt64.new \"20\"                        # => 20\nInt64.new \"  20  \", whitespace: false # => Unhandled exception: Invalid Int64:   20 (ArgumentError)\n```","summary":"<p>Returns an <code><a href=\"Int64.html\">Int64</a></code> by invoking <code><a href=\"Int64.html#to_i64%3AInt64-instance-method\">#to_i64</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(value : String, base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : self","args_html":"(value : <a href=\"String.html\">String</a>, base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1002,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"self","visibility":"Public","body":"value.to_i64(base: base, whitespace: whitespace, underscore: underscore, prefix: prefix, strict: strict, leading_zero_is_octal: leading_zero_is_octal)"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":59,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"Int64.new!(parse_scalar(ctx, node, Int64))"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"location = pull.location\nvalue = pull.read_int\nbegin\n  value.to_i64\nrescue ex : OverflowError | ArgumentError\n  raise(JSON::ParseException.new(\"Can't read Int64\", *location, ex))\nend\n"}},{"html_id":"new(value):self-class-method","name":"new","doc":"Returns an `Int64` by invoking `to_i64` on *value*.","summary":"<p>Returns an <code><a href=\"Int64.html\">Int64</a></code> by invoking <code><a href=\"Int64.html#to_i64%3AInt64-instance-method\">#to_i64</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1007,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_i64"}},{"html_id":"new!(value):self-class-method","name":"new!","doc":"Returns an `Int64` by invoking `to_i64!` on *value*.","summary":"<p>Returns an <code><a href=\"Int64.html\">Int64</a></code> by invoking <code><a href=\"Int64.html#to_i64%21%3AInt64-instance-method\">#to_i64!</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1012,"url":null},"def":{"name":"new!","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_i64!"}}],"instance_methods":[{"html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-:Int64-instance-method","name":"-","abstract":false,"location":{"filename":"src/int.cr","line_number":1020,"url":null},"def":{"name":"-","return_type":"Int64","visibility":"Public","body":"0_i64 - self"}},{"html_id":"/(other:Int8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Float64","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1016,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Float64","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1016,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Float64","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1016,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Float64","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1016,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Float64","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1016,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Float64","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1016,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Float64","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1016,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Float64","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1016,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Float64","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1016,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Float64","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1016,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Float32):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/int.cr","line_number":1017,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:Float64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1018,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:BigInt):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigFloat","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":57,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigFloat):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigFloat","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":58,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":59,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":60,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"<(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/int.cr","line_number":1037,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"leading_zeros_count-instance-method","name":"leading_zeros_count","doc":"Returns the number of leading `0`-bits.","summary":"<p>Returns the number of leading <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1029,"url":null},"def":{"name":"leading_zeros_count","visibility":"Public","body":"Intrinsics.countleading64(self, false)"}},{"html_id":"popcount:Int64-instance-method","name":"popcount","doc":"Counts `1`-bits in the binary representation of this integer.\n\n```\n5.popcount   # => 2\n-15.popcount # => 29\n```","summary":"<p>Counts <code>1</code>-bits in the binary representation of this integer.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1024,"url":null},"def":{"name":"popcount","return_type":"Int64","visibility":"Public","body":"Intrinsics.popcount64(self)"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f!:Float64-instance-method","name":"to_f!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f32!:Float32-instance-method","name":"to_f32!","doc":"Returns `self` converted to `Float32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32!","return_type":"Float32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i!:Int32-instance-method","name":"to_i!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128","return_type":"Int128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i128!:Int128-instance-method","name":"to_i128!","doc":"Returns `self` converted to `Int128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128!","return_type":"Int128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i16!:Int16-instance-method","name":"to_i16!","doc":"Returns `self` converted to `Int16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16!","return_type":"Int16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i64!:Int64-instance-method","name":"to_i64!","doc":"Returns `self` converted to `Int64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64!","return_type":"Int64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i8!:Int8-instance-method","name":"to_i8!","doc":"Returns `self` converted to `Int8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8!","return_type":"Int8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u!:UInt32-instance-method","name":"to_u!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128","return_type":"UInt128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u128!:UInt128-instance-method","name":"to_u128!","doc":"Returns `self` converted to `UInt128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128!","return_type":"UInt128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u16!:UInt16-instance-method","name":"to_u16!","doc":"Returns `self` converted to `UInt16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16!","return_type":"UInt16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u64!:UInt64-instance-method","name":"to_u64!","doc":"Returns `self` converted to `UInt64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64!","return_type":"UInt64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u8!:UInt8-instance-method","name":"to_u8!","doc":"Returns `self` converted to `UInt8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8!","return_type":"UInt8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"trailing_zeros_count-instance-method","name":"trailing_zeros_count","doc":"Returns the number of trailing `0`-bits.","summary":"<p>Returns the number of trailing <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1033,"url":null},"def":{"name":"trailing_zeros_count","visibility":"Public","body":"Intrinsics.counttrailing64(self, false)"}},{"html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0xd7ff` and `0xe000..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0xd7ff</code> and <code>0xe000..0x10ffff</code>).</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"unsafe_chr","return_type":"Char","visibility":"Public","body":"# primitive: convert"}},{"html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}}]},{"html_id":"Crystal/Int8","path":"Int8.html","kind":"struct","full_name":"Int8","name":"Int8","abstract":false,"superclass":{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/number.cr","line_number":35,"url":null},{"filename":"src/int.cr","line_number":838,"url":null},{"filename":"src/primitives.cr","line_number":280,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"MAX","name":"MAX","value":"127_i8"},{"id":"MIN","name":"MIN","value":"-128_i8"}],"class_methods":[{"html_id":"from_json_object_key?(key:String)-class-method","name":"from_json_object_key?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String)","args_html":"(key : <a href=\"String.html\">String</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"from_json_object_key?","args":[{"name":"key","external_name":"key","restriction":"String"}],"visibility":"Public","body":"key.to_i8?"}}],"constructors":[{"html_id":"new(value:String,base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):self-class-method","name":"new","doc":"Returns an `Int8` by invoking `to_i8` on *value*.\nSee `String#to_i` for more details.\n\n```\nInt8.new \"20\"                        # => 20\nInt8.new \"  20  \", whitespace: false # => Unhandled exception: Invalid Int8:   20 (ArgumentError)\n```","summary":"<p>Returns an <code><a href=\"Int8.html\">Int8</a></code> by invoking <code><a href=\"Int8.html#to_i8%3AInt8-instance-method\">#to_i8</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(value : String, base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : self","args_html":"(value : <a href=\"String.html\">String</a>, base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":849,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"self","visibility":"Public","body":"value.to_i8(base: base, whitespace: whitespace, underscore: underscore, prefix: prefix, strict: strict, leading_zero_is_octal: leading_zero_is_octal)"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":59,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"Int8.new!(parse_scalar(ctx, node, Int64))"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"location = pull.location\nvalue = pull.read_int\nbegin\n  value.to_i8\nrescue ex : OverflowError | ArgumentError\n  raise(JSON::ParseException.new(\"Can't read Int8\", *location, ex))\nend\n"}},{"html_id":"new(value):self-class-method","name":"new","doc":"Returns an `Int8` by invoking `to_i8` on *value*.","summary":"<p>Returns an <code><a href=\"Int8.html\">Int8</a></code> by invoking <code><a href=\"Int8.html#to_i8%3AInt8-instance-method\">#to_i8</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":854,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_i8"}},{"html_id":"new!(value):self-class-method","name":"new!","doc":"Returns an `Int8` by invoking `to_i8!` on *value*.","summary":"<p>Returns an <code><a href=\"Int8.html\">Int8</a></code> by invoking <code><a href=\"Int8.html#to_i8%21%3AInt8-instance-method\">#to_i8!</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":859,"url":null},"def":{"name":"new!","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_i8!"}}],"instance_methods":[{"html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-:Int8-instance-method","name":"-","abstract":false,"location":{"filename":"src/int.cr","line_number":867,"url":null},"def":{"name":"-","return_type":"Int8","visibility":"Public","body":"0_i8 - self"}},{"html_id":"/(other:Int8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Float64","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":863,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Float64","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":863,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Float64","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":863,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Float64","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":863,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Float64","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":863,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Float64","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":863,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Float64","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":863,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Float64","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":863,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Float64","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":863,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Float64","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":863,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Float32):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/int.cr","line_number":864,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:Float64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":865,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:BigInt):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigFloat","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":36,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigFloat):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigFloat","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":37,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":38,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":39,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"<(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/int.cr","line_number":884,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"leading_zeros_count-instance-method","name":"leading_zeros_count","doc":"Returns the number of leading `0`-bits.","summary":"<p>Returns the number of leading <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":876,"url":null},"def":{"name":"leading_zeros_count","visibility":"Public","body":"Intrinsics.countleading8(self, false)"}},{"html_id":"popcount:Int8-instance-method","name":"popcount","doc":"Counts `1`-bits in the binary representation of this integer.\n\n```\n5.popcount   # => 2\n-15.popcount # => 29\n```","summary":"<p>Counts <code>1</code>-bits in the binary representation of this integer.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":871,"url":null},"def":{"name":"popcount","return_type":"Int8","visibility":"Public","body":"Intrinsics.popcount8(self)"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f!:Float64-instance-method","name":"to_f!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f32!:Float32-instance-method","name":"to_f32!","doc":"Returns `self` converted to `Float32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32!","return_type":"Float32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i!:Int32-instance-method","name":"to_i!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128","return_type":"Int128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i128!:Int128-instance-method","name":"to_i128!","doc":"Returns `self` converted to `Int128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128!","return_type":"Int128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i16!:Int16-instance-method","name":"to_i16!","doc":"Returns `self` converted to `Int16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16!","return_type":"Int16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i64!:Int64-instance-method","name":"to_i64!","doc":"Returns `self` converted to `Int64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64!","return_type":"Int64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i8!:Int8-instance-method","name":"to_i8!","doc":"Returns `self` converted to `Int8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8!","return_type":"Int8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u!:UInt32-instance-method","name":"to_u!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128","return_type":"UInt128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u128!:UInt128-instance-method","name":"to_u128!","doc":"Returns `self` converted to `UInt128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128!","return_type":"UInt128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u16!:UInt16-instance-method","name":"to_u16!","doc":"Returns `self` converted to `UInt16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16!","return_type":"UInt16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u64!:UInt64-instance-method","name":"to_u64!","doc":"Returns `self` converted to `UInt64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64!","return_type":"UInt64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u8!:UInt8-instance-method","name":"to_u8!","doc":"Returns `self` converted to `UInt8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8!","return_type":"UInt8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"trailing_zeros_count-instance-method","name":"trailing_zeros_count","doc":"Returns the number of trailing `0`-bits.","summary":"<p>Returns the number of trailing <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":880,"url":null},"def":{"name":"trailing_zeros_count","visibility":"Public","body":"Intrinsics.counttrailing8(self, false)"}},{"html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0xd7ff` and `0xe000..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0xd7ff</code> and <code>0xe000..0x10ffff</code>).</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"unsafe_chr","return_type":"Char","visibility":"Public","body":"# primitive: convert"}},{"html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}}]},{"html_id":"Crystal/Intrinsics","path":"Intrinsics.html","kind":"module","full_name":"Intrinsics","name":"Intrinsics","abstract":false,"locations":[{"filename":"src/intrinsics.cr","line_number":112,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"class_methods":[{"html_id":"bitreverse16(id):UInt16-class-method","name":"bitreverse16","abstract":false,"args":[{"name":"id","external_name":"id","restriction":""}],"args_string":"(id) : UInt16","args_html":"(id) : <a href=\"UInt16.html\">UInt16</a>","location":{"filename":"src/intrinsics.cr","line_number":159,"url":null},"def":{"name":"bitreverse16","args":[{"name":"id","external_name":"id","restriction":""}],"return_type":"UInt16","visibility":"Public","body":"LibIntrinsics.bitreverse16(id)"}},{"html_id":"bitreverse32(id):UInt32-class-method","name":"bitreverse32","abstract":false,"args":[{"name":"id","external_name":"id","restriction":""}],"args_string":"(id) : UInt32","args_html":"(id) : <a href=\"UInt32.html\">UInt32</a>","location":{"filename":"src/intrinsics.cr","line_number":155,"url":null},"def":{"name":"bitreverse32","args":[{"name":"id","external_name":"id","restriction":""}],"return_type":"UInt32","visibility":"Public","body":"LibIntrinsics.bitreverse32(id)"}},{"html_id":"bitreverse64(id):UInt64-class-method","name":"bitreverse64","abstract":false,"args":[{"name":"id","external_name":"id","restriction":""}],"args_string":"(id) : UInt64","args_html":"(id) : <a href=\"UInt64.html\">UInt64</a>","location":{"filename":"src/intrinsics.cr","line_number":151,"url":null},"def":{"name":"bitreverse64","args":[{"name":"id","external_name":"id","restriction":""}],"return_type":"UInt64","visibility":"Public","body":"LibIntrinsics.bitreverse64(id)"}},{"html_id":"bswap16(id)-class-method","name":"bswap16","abstract":false,"args":[{"name":"id","external_name":"id","restriction":""}],"args_string":"(id)","args_html":"(id)","location":{"filename":"src/intrinsics.cr","line_number":167,"url":null},"def":{"name":"bswap16","args":[{"name":"id","external_name":"id","restriction":""}],"visibility":"Public","body":"LibIntrinsics.bswap16(id)"}},{"html_id":"bswap32(id):UInt32-class-method","name":"bswap32","abstract":false,"args":[{"name":"id","external_name":"id","restriction":""}],"args_string":"(id) : UInt32","args_html":"(id) : <a href=\"UInt32.html\">UInt32</a>","location":{"filename":"src/intrinsics.cr","line_number":163,"url":null},"def":{"name":"bswap32","args":[{"name":"id","external_name":"id","restriction":""}],"return_type":"UInt32","visibility":"Public","body":"LibIntrinsics.bswap32(id)"}},{"html_id":"pause-class-method","name":"pause","abstract":false,"location":{"filename":"src/intrinsics.cr","line_number":117,"url":null},"def":{"name":"pause","visibility":"Public","body":"{% if (flag?(:i386)) || (flag?(:x86_64)) %}\n      LibIntrinsics.pause\n    {% end %}"}},{"html_id":"popcount128(src)-class-method","name":"popcount128","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""}],"args_string":"(src)","args_html":"(src)","location":{"filename":"src/intrinsics.cr","line_number":187,"url":null},"def":{"name":"popcount128","args":[{"name":"src","external_name":"src","restriction":""}],"visibility":"Public","body":"LibIntrinsics.popcount128(src)"}},{"html_id":"popcount16(src):Int16-class-method","name":"popcount16","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""}],"args_string":"(src) : Int16","args_html":"(src) : <a href=\"Int16.html\">Int16</a>","location":{"filename":"src/intrinsics.cr","line_number":175,"url":null},"def":{"name":"popcount16","args":[{"name":"src","external_name":"src","restriction":""}],"return_type":"Int16","visibility":"Public","body":"LibIntrinsics.popcount16(src)"}},{"html_id":"popcount32(src):Int32-class-method","name":"popcount32","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""}],"args_string":"(src) : Int32","args_html":"(src) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/intrinsics.cr","line_number":179,"url":null},"def":{"name":"popcount32","args":[{"name":"src","external_name":"src","restriction":""}],"return_type":"Int32","visibility":"Public","body":"LibIntrinsics.popcount32(src)"}},{"html_id":"popcount64(src):Int64-class-method","name":"popcount64","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""}],"args_string":"(src) : Int64","args_html":"(src) : <a href=\"Int64.html\">Int64</a>","location":{"filename":"src/intrinsics.cr","line_number":183,"url":null},"def":{"name":"popcount64","args":[{"name":"src","external_name":"src","restriction":""}],"return_type":"Int64","visibility":"Public","body":"LibIntrinsics.popcount64(src)"}},{"html_id":"popcount8(src):Int8-class-method","name":"popcount8","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""}],"args_string":"(src) : Int8","args_html":"(src) : <a href=\"Int8.html\">Int8</a>","location":{"filename":"src/intrinsics.cr","line_number":171,"url":null},"def":{"name":"popcount8","args":[{"name":"src","external_name":"src","restriction":""}],"return_type":"Int8","visibility":"Public","body":"LibIntrinsics.popcount8(src)"}},{"html_id":"read_cycle_counter-class-method","name":"read_cycle_counter","abstract":false,"location":{"filename":"src/intrinsics.cr","line_number":147,"url":null},"def":{"name":"read_cycle_counter","visibility":"Public","body":"LibIntrinsics.read_cycle_counter"}}],"macros":[{"html_id":"countleading128(src,zero_is_undef)-macro","name":"countleading128","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"args_string":"(src, zero_is_undef)","args_html":"(src, zero_is_undef)","location":{"filename":"src/intrinsics.cr","line_number":207,"url":null},"def":{"name":"countleading128","args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"visibility":"Public","body":"    LibIntrinsics.countleading128(\n{{ src }}\n, \n{{ zero_is_undef }}\n)\n  \n"}},{"html_id":"countleading16(src,zero_is_undef)-macro","name":"countleading16","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"args_string":"(src, zero_is_undef)","args_html":"(src, zero_is_undef)","location":{"filename":"src/intrinsics.cr","line_number":195,"url":null},"def":{"name":"countleading16","args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"visibility":"Public","body":"    LibIntrinsics.countleading16(\n{{ src }}\n, \n{{ zero_is_undef }}\n)\n  \n"}},{"html_id":"countleading32(src,zero_is_undef)-macro","name":"countleading32","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"args_string":"(src, zero_is_undef)","args_html":"(src, zero_is_undef)","location":{"filename":"src/intrinsics.cr","line_number":199,"url":null},"def":{"name":"countleading32","args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"visibility":"Public","body":"    LibIntrinsics.countleading32(\n{{ src }}\n, \n{{ zero_is_undef }}\n)\n  \n"}},{"html_id":"countleading64(src,zero_is_undef)-macro","name":"countleading64","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"args_string":"(src, zero_is_undef)","args_html":"(src, zero_is_undef)","location":{"filename":"src/intrinsics.cr","line_number":203,"url":null},"def":{"name":"countleading64","args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"visibility":"Public","body":"    LibIntrinsics.countleading64(\n{{ src }}\n, \n{{ zero_is_undef }}\n)\n  \n"}},{"html_id":"countleading8(src,zero_is_undef)-macro","name":"countleading8","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"args_string":"(src, zero_is_undef)","args_html":"(src, zero_is_undef)","location":{"filename":"src/intrinsics.cr","line_number":191,"url":null},"def":{"name":"countleading8","args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"visibility":"Public","body":"    LibIntrinsics.countleading8(\n{{ src }}\n, \n{{ zero_is_undef }}\n)\n  \n"}},{"html_id":"counttrailing128(src,zero_is_undef)-macro","name":"counttrailing128","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"args_string":"(src, zero_is_undef)","args_html":"(src, zero_is_undef)","location":{"filename":"src/intrinsics.cr","line_number":227,"url":null},"def":{"name":"counttrailing128","args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"visibility":"Public","body":"    LibIntrinsics.counttrailing128(\n{{ src }}\n, \n{{ zero_is_undef }}\n)\n  \n"}},{"html_id":"counttrailing16(src,zero_is_undef)-macro","name":"counttrailing16","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"args_string":"(src, zero_is_undef)","args_html":"(src, zero_is_undef)","location":{"filename":"src/intrinsics.cr","line_number":215,"url":null},"def":{"name":"counttrailing16","args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"visibility":"Public","body":"    LibIntrinsics.counttrailing16(\n{{ src }}\n, \n{{ zero_is_undef }}\n)\n  \n"}},{"html_id":"counttrailing32(src,zero_is_undef)-macro","name":"counttrailing32","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"args_string":"(src, zero_is_undef)","args_html":"(src, zero_is_undef)","location":{"filename":"src/intrinsics.cr","line_number":219,"url":null},"def":{"name":"counttrailing32","args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"visibility":"Public","body":"    LibIntrinsics.counttrailing32(\n{{ src }}\n, \n{{ zero_is_undef }}\n)\n  \n"}},{"html_id":"counttrailing64(src,zero_is_undef)-macro","name":"counttrailing64","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"args_string":"(src, zero_is_undef)","args_html":"(src, zero_is_undef)","location":{"filename":"src/intrinsics.cr","line_number":223,"url":null},"def":{"name":"counttrailing64","args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"visibility":"Public","body":"    LibIntrinsics.counttrailing64(\n{{ src }}\n, \n{{ zero_is_undef }}\n)\n  \n"}},{"html_id":"counttrailing8(src,zero_is_undef)-macro","name":"counttrailing8","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"args_string":"(src, zero_is_undef)","args_html":"(src, zero_is_undef)","location":{"filename":"src/intrinsics.cr","line_number":211,"url":null},"def":{"name":"counttrailing8","args":[{"name":"src","external_name":"src","restriction":""},{"name":"zero_is_undef","external_name":"zero_is_undef","restriction":""}],"visibility":"Public","body":"    LibIntrinsics.counttrailing8(\n{{ src }}\n, \n{{ zero_is_undef }}\n)\n  \n"}},{"html_id":"debugtrap-macro","name":"debugtrap","abstract":false,"location":{"filename":"src/intrinsics.cr","line_number":113,"url":null},"def":{"name":"debugtrap","visibility":"Public","body":"    LibIntrinsics.debugtrap\n  "}},{"html_id":"memcpy(dest,src,len,is_volatile)-macro","name":"memcpy","abstract":false,"args":[{"name":"dest","external_name":"dest","restriction":""},{"name":"src","external_name":"src","restriction":""},{"name":"len","external_name":"len","restriction":""},{"name":"is_volatile","external_name":"is_volatile","restriction":""}],"args_string":"(dest, src, len, is_volatile)","args_html":"(dest, src, len, is_volatile)","location":{"filename":"src/intrinsics.cr","line_number":123,"url":null},"def":{"name":"memcpy","args":[{"name":"dest","external_name":"dest","restriction":""},{"name":"src","external_name":"src","restriction":""},{"name":"len","external_name":"len","restriction":""},{"name":"is_volatile","external_name":"is_volatile","restriction":""}],"visibility":"Public","body":"    \n{% if (compare_versions(Crystal::LLVM_VERSION, \"7.0.0\")) < 0 %}\n      LibIntrinsics.memcpy({{ dest }}, {{ src }}, {{ len }}, 0, {{ is_volatile }})\n    {% else %}\n      LibIntrinsics.memcpy({{ dest }}, {{ src }}, {{ len }}, {{ is_volatile }})\n    {% end %}\n\n  \n"}},{"html_id":"memmove(dest,src,len,is_volatile)-macro","name":"memmove","abstract":false,"args":[{"name":"dest","external_name":"dest","restriction":""},{"name":"src","external_name":"src","restriction":""},{"name":"len","external_name":"len","restriction":""},{"name":"is_volatile","external_name":"is_volatile","restriction":""}],"args_string":"(dest, src, len, is_volatile)","args_html":"(dest, src, len, is_volatile)","location":{"filename":"src/intrinsics.cr","line_number":131,"url":null},"def":{"name":"memmove","args":[{"name":"dest","external_name":"dest","restriction":""},{"name":"src","external_name":"src","restriction":""},{"name":"len","external_name":"len","restriction":""},{"name":"is_volatile","external_name":"is_volatile","restriction":""}],"visibility":"Public","body":"    \n{% if (compare_versions(Crystal::LLVM_VERSION, \"7.0.0\")) < 0 %}\n      LibIntrinsics.memmove({{ dest }}, {{ src }}, {{ len }}, 0, {{ is_volatile }})\n    {% else %}\n      LibIntrinsics.memmove({{ dest }}, {{ src }}, {{ len }}, {{ is_volatile }})\n    {% end %}\n\n  \n"}},{"html_id":"memset(dest,val,len,is_volatile)-macro","name":"memset","abstract":false,"args":[{"name":"dest","external_name":"dest","restriction":""},{"name":"val","external_name":"val","restriction":""},{"name":"len","external_name":"len","restriction":""},{"name":"is_volatile","external_name":"is_volatile","restriction":""}],"args_string":"(dest, val, len, is_volatile)","args_html":"(dest, val, len, is_volatile)","location":{"filename":"src/intrinsics.cr","line_number":139,"url":null},"def":{"name":"memset","args":[{"name":"dest","external_name":"dest","restriction":""},{"name":"val","external_name":"val","restriction":""},{"name":"len","external_name":"len","restriction":""},{"name":"is_volatile","external_name":"is_volatile","restriction":""}],"visibility":"Public","body":"    \n{% if (compare_versions(Crystal::LLVM_VERSION, \"7.0.0\")) < 0 %}\n      LibIntrinsics.memset({{ dest }}, {{ val }}, {{ len }}, 0, {{ is_volatile }})\n    {% else %}\n      LibIntrinsics.memset({{ dest }}, {{ val }}, {{ len }}, {{ is_volatile }})\n    {% end %}\n\n  \n"}},{"html_id":"va_end(ap)-macro","name":"va_end","abstract":false,"args":[{"name":"ap","external_name":"ap","restriction":""}],"args_string":"(ap)","args_html":"(ap)","location":{"filename":"src/intrinsics.cr","line_number":235,"url":null},"def":{"name":"va_end","args":[{"name":"ap","external_name":"ap","restriction":""}],"visibility":"Public","body":"    LibIntrinsics.va_end(\n{{ ap }}\n)\n  \n"}},{"html_id":"va_start(ap)-macro","name":"va_start","abstract":false,"args":[{"name":"ap","external_name":"ap","restriction":""}],"args_string":"(ap)","args_html":"(ap)","location":{"filename":"src/intrinsics.cr","line_number":231,"url":null},"def":{"name":"va_start","args":[{"name":"ap","external_name":"ap","restriction":""}],"visibility":"Public","body":"    LibIntrinsics.va_start(\n{{ ap }}\n)\n  \n"}}]},{"html_id":"Crystal/InvalidBigDecimalException","path":"InvalidBigDecimalException.html","kind":"class","full_name":"InvalidBigDecimalException","name":"InvalidBigDecimalException","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/big_decimal.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constructors":[{"html_id":"new(big_decimal_str:String,reason:String)-class-method","name":"new","abstract":false,"args":[{"name":"big_decimal_str","external_name":"big_decimal_str","restriction":"String"},{"name":"reason","external_name":"reason","restriction":"String"}],"args_string":"(big_decimal_str : String, reason : String)","args_html":"(big_decimal_str : <a href=\"String.html\">String</a>, reason : <a href=\"String.html\">String</a>)","location":{"filename":"src/big/big_decimal.cr","line_number":4,"url":null},"def":{"name":"new","args":[{"name":"big_decimal_str","external_name":"big_decimal_str","restriction":"String"},{"name":"reason","external_name":"reason","restriction":"String"}],"visibility":"Public","body":"_ = allocate\n_.initialize(big_decimal_str, reason)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]},{"html_id":"Crystal/InvalidByteSequenceError","path":"InvalidByteSequenceError.html","kind":"class","full_name":"InvalidByteSequenceError","name":"InvalidByteSequenceError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/exception.cr","line_number":106,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constructors":[{"html_id":"new(message=\"InvalidbytesequenceinUTF-8string\")-class-method","name":"new","abstract":false,"args":[{"name":"message","default_value":"\"Invalid byte sequence in UTF-8 string\"","external_name":"message","restriction":""}],"args_string":"(message = \"Invalid byte sequence in UTF-8 string\")","args_html":"(message = <span class=\"s\">&quot;Invalid byte sequence in UTF-8 string&quot;</span>)","location":{"filename":"src/exception.cr","line_number":107,"url":null},"def":{"name":"new","args":[{"name":"message","default_value":"\"Invalid byte sequence in UTF-8 string\"","external_name":"message","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]},{"html_id":"Crystal/IO","path":"IO.html","kind":"class","full_name":"IO","name":"IO","abstract":true,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/io.cr","line_number":60,"url":null},{"filename":"src/io/encoding.cr","line_number":5,"url":null},{"filename":"src/io/encoding.cr","line_number":28,"url":null},{"filename":"src/io/error.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/Compress/Deflate/Reader","kind":"class","full_name":"Compress::Deflate::Reader","name":"Reader"},{"html_id":"Crystal/Compress/Deflate/Writer","kind":"class","full_name":"Compress::Deflate::Writer","name":"Writer"},{"html_id":"Crystal/Compress/Gzip/Reader","kind":"class","full_name":"Compress::Gzip::Reader","name":"Reader"},{"html_id":"Crystal/Compress/Gzip/Writer","kind":"class","full_name":"Compress::Gzip::Writer","name":"Writer"},{"html_id":"Crystal/Compress/Zlib/Reader","kind":"class","full_name":"Compress::Zlib::Reader","name":"Reader"},{"html_id":"Crystal/Compress/Zlib/Writer","kind":"class","full_name":"Compress::Zlib::Writer","name":"Writer"},{"html_id":"Crystal/HTTP/Server/Response","kind":"class","full_name":"HTTP::Server::Response","name":"Response"},{"html_id":"Crystal/IO/Delimited","kind":"class","full_name":"IO::Delimited","name":"Delimited"},{"html_id":"Crystal/IO/Digest","kind":"class","full_name":"IO::Digest","name":"Digest"},{"html_id":"Crystal/IO/FileDescriptor","kind":"class","full_name":"IO::FileDescriptor","name":"FileDescriptor"},{"html_id":"Crystal/IO/Hexdump","kind":"class","full_name":"IO::Hexdump","name":"Hexdump"},{"html_id":"Crystal/IO/Memory","kind":"class","full_name":"IO::Memory","name":"Memory"},{"html_id":"Crystal/IO/MultiWriter","kind":"class","full_name":"IO::MultiWriter","name":"MultiWriter"},{"html_id":"Crystal/IO/Sized","kind":"class","full_name":"IO::Sized","name":"Sized"},{"html_id":"Crystal/IO/Stapled","kind":"class","full_name":"IO::Stapled","name":"Stapled"},{"html_id":"Crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},{"html_id":"Crystal/String/Builder","kind":"class","full_name":"String::Builder","name":"Builder"}],"doc":"The `IO` class is the basis for all input and output in Crystal.\n\nThis class is inherited by types like `File`, `Socket` and `IO::Memory` and\nprovides many useful methods for reading from and writing to an IO, like `print`, `puts`,\n`gets` and `printf`.\n\nThe only requirement for a type including the `IO` module is to define\nthese two methods:\n\n* `read(slice : Bytes)`: read at most *slice.size* bytes from IO into *slice* and return the number of bytes read\n* `write(slice : Bytes)`: write the whole *slice* into the IO\n\nFor example, this is a simple `IO` on top of a `Bytes`:\n\n```\nclass SimpleSliceIO < IO\n  def initialize(@slice : Bytes)\n  end\n\n  def read(slice : Bytes)\n    slice.size.times { |i| slice[i] = @slice[i] }\n    @slice += slice.size\n    slice.size\n  end\n\n  def write(slice : Bytes) : Nil\n    slice.size.times { |i| @slice[i] = slice[i] }\n    @slice += slice.size\n  end\nend\n\nslice = Slice.new(9) { |i| ('a'.ord + i).to_u8 }\nString.new(slice) # => \"abcdefghi\"\n\nio = SimpleSliceIO.new(slice)\nio.gets(3) # => \"abc\"\nio.print \"xyz\"\nString.new(slice) # => \"abcxyzghi\"\n```\n\n### Encoding\n\nAn `IO` can be set an encoding with the `#set_encoding` method. When this is\nset, all string operations (`gets`, `gets_to_end`, `read_char`, `<<`, `print`, `puts`\n`printf`) will write in the given encoding, and read from the given encoding.\nByte operations (`read`, `write`, `read_byte`, `write_byte`) never do\nencoding/decoding operations.\n\nIf an encoding is not set, the default one is UTF-8.\n\nMixing string and byte operations might not give correct results and should be\navoided, as string operations might need to read extra bytes in order to get characters\nin the given encoding.","summary":"<p>The <code><a href=\"IO.html\">IO</a></code> class is the basis for all input and output in Crystal.</p>","class_methods":[{"html_id":"copy(src,dst,limit:Int):Int64-class-method","name":"copy","doc":"Copy at most *limit* bytes from *src* to *dst*.\n\n```\nio = IO::Memory.new \"hello\"\nio2 = IO::Memory.new\n\nIO.copy io, io2, 3\n\nio2.to_s # => \"hel\"\n```","summary":"<p>Copy at most <em>limit</em> bytes from <em>src</em> to <em>dst</em>.</p>","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""},{"name":"dst","external_name":"dst","restriction":""},{"name":"limit","external_name":"limit","restriction":"Int"}],"args_string":"(src, dst, limit : Int) : Int64","args_html":"(src, dst, limit : <a href=\"Int.html\">Int</a>) : <a href=\"Int64.html\">Int64</a>","location":{"filename":"src/io.cr","line_number":1160,"url":null},"def":{"name":"copy","args":[{"name":"src","external_name":"src","restriction":""},{"name":"dst","external_name":"dst","restriction":""},{"name":"limit","external_name":"limit","restriction":"Int"}],"return_type":"Int64","visibility":"Public","body":"if limit < 0\n  raise(ArgumentError.new(\"Negative limit\"))\nend\nlimit = limit.to_i64\nbuffer = uninitialized ::StaticArray(UInt8, 4096)\nremaining = limit\nwhile (len = src.read(buffer.to_slice[0, Math.min(buffer.size, Math.max(remaining, 0))])) > 0\n  dst.write(buffer.to_slice[0, len])\n  remaining = remaining &- len\nend\nlimit - remaining\n"}},{"html_id":"copy(src,dst):Int64-class-method","name":"copy","doc":"Copy all contents from *src* to *dst*.\n\n```\nio = IO::Memory.new \"hello\"\nio2 = IO::Memory.new\n\nIO.copy io, io2\n\nio2.to_s # => \"hello\"\n```","summary":"<p>Copy all contents from <em>src</em> to <em>dst</em>.</p>","abstract":false,"args":[{"name":"src","external_name":"src","restriction":""},{"name":"dst","external_name":"dst","restriction":""}],"args_string":"(src, dst) : Int64","args_html":"(src, dst) : <a href=\"Int64.html\">Int64</a>","location":{"filename":"src/io.cr","line_number":1140,"url":null},"def":{"name":"copy","args":[{"name":"src","external_name":"src","restriction":""},{"name":"dst","external_name":"dst","restriction":""}],"return_type":"Int64","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4096)\ncount = 0_i64\nwhile (len = (src.read(buffer.to_slice)).to_i32) > 0\n  dst.write(buffer.to_slice[0, len])\n  count = count &+ len\nend\ncount\n"}},{"html_id":"pipe(read_blocking=false,write_blocking=false):Tuple(IO::FileDescriptor,IO::FileDescriptor)-class-method","name":"pipe","doc":"Creates a pair of pipe endpoints (connected to each other)\nand returns them as a two-element `Tuple`.\n\n```\nreader, writer = IO.pipe\nwriter.puts \"hello\"\nwriter.puts \"world\"\nreader.gets # => \"hello\"\nreader.gets # => \"world\"\n```","summary":"<p>Creates a pair of pipe endpoints (connected to each other) and returns them as a two-element <code><a href=\"Tuple.html\">Tuple</a></code>.</p>","abstract":false,"args":[{"name":"read_blocking","default_value":"false","external_name":"read_blocking","restriction":""},{"name":"write_blocking","default_value":"false","external_name":"write_blocking","restriction":""}],"args_string":"(read_blocking = false, write_blocking = false) : Tuple(IO::FileDescriptor, IO::FileDescriptor)","args_html":"(read_blocking = <span class=\"n\">false</span>, write_blocking = <span class=\"n\">false</span>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"IO/FileDescriptor.html\">IO::FileDescriptor</a>, <a href=\"IO/FileDescriptor.html\">IO::FileDescriptor</a>)","location":{"filename":"src/io.cr","line_number":137,"url":null},"def":{"name":"pipe","args":[{"name":"read_blocking","default_value":"false","external_name":"read_blocking","restriction":""},{"name":"write_blocking","default_value":"false","external_name":"write_blocking","restriction":""}],"return_type":"::Tuple(IO::FileDescriptor, IO::FileDescriptor)","visibility":"Public","body":"Crystal::System::FileDescriptor.pipe(read_blocking, write_blocking)"}},{"html_id":"pipe(read_blocking=false,write_blocking=false,&)-class-method","name":"pipe","doc":"Creates a pair of pipe endpoints (connected to each other) and passes them\nto the given block. Both endpoints are closed after the block.\n\n```\nIO.pipe do |reader, writer|\n  writer.puts \"hello\"\n  writer.puts \"world\"\n  reader.gets # => \"hello\"\n  reader.gets # => \"world\"\nend\n```","summary":"<p>Creates a pair of pipe endpoints (connected to each other) and passes them to the given block.</p>","abstract":false,"args":[{"name":"read_blocking","default_value":"false","external_name":"read_blocking","restriction":""},{"name":"write_blocking","default_value":"false","external_name":"write_blocking","restriction":""}],"args_string":"(read_blocking = false, write_blocking = false, &)","args_html":"(read_blocking = <span class=\"n\">false</span>, write_blocking = <span class=\"n\">false</span>, &)","location":{"filename":"src/io.cr","line_number":152,"url":null},"def":{"name":"pipe","args":[{"name":"read_blocking","default_value":"false","external_name":"read_blocking","restriction":""},{"name":"write_blocking","default_value":"false","external_name":"write_blocking","restriction":""}],"yields":2,"visibility":"Public","body":"r, w = IO.pipe(read_blocking, write_blocking)\nbegin\n  yield r, w\nensure\n  w.flush\n  r.close\n  w.close\nend\n"}},{"html_id":"same_content?(stream1:IO,stream2:IO):Bool-class-method","name":"same_content?","doc":"Compares two streams *stream1* to *stream2* to determine if they are identical.\nReturns `true` if content are the same, `false` otherwise.\n\n```\nFile.write(\"afile\", \"123\")\nstream1 = File.open(\"afile\")\nstream2 = IO::Memory.new(\"123\")\nIO.same_content?(stream1, stream2) # => true\n```","summary":"<p>Compares two streams <em>stream1</em> to <em>stream2</em> to determine if they are identical.</p>","abstract":false,"args":[{"name":"stream1","external_name":"stream1","restriction":"IO"},{"name":"stream2","external_name":"stream2","restriction":"IO"}],"args_string":"(stream1 : IO, stream2 : IO) : Bool","args_html":"(stream1 : <a href=\"IO.html\">IO</a>, stream2 : <a href=\"IO.html\">IO</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/io.cr","line_number":1183,"url":null},"def":{"name":"same_content?","args":[{"name":"stream1","external_name":"stream1","restriction":"IO"},{"name":"stream2","external_name":"stream2","restriction":"IO"}],"return_type":"Bool","visibility":"Public","body":"buf1 = uninitialized ::StaticArray(UInt8, 1024)\nbuf2 = uninitialized ::StaticArray(UInt8, 1024)\nwhile true\n  read1 = stream1.read(buf1.to_slice)\n  read2 = stream2.read_fully?(buf2.to_slice[0, read1])\n  if read2\n  else\n    return false\n  end\n  if (buf1.to_unsafe.memcmp(buf2.to_unsafe, read1)) != 0\n    return false\n  end\n  if read1 == 0\n    return true\n  end\nend\n"}}],"instance_methods":[{"html_id":"<<(obj):self-instance-method","name":"<<","doc":"Writes the given object into this `IO`.\nThis ends up calling `to_s(io)` on the object.\n\n```\nio = IO::Memory.new\nio << 1\nio << '-'\nio << \"Crystal\"\nio.to_s # => \"1-Crystal\"\n```","summary":"<p>Writes the given object into this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"obj","external_name":"obj","restriction":""}],"args_string":"(obj) : self","args_html":"(obj) : <span class=\"k\">self</span>","location":{"filename":"src/io.cr","line_number":173,"url":null},"def":{"name":"<<","args":[{"name":"obj","external_name":"obj","restriction":""}],"return_type":"self","visibility":"Public","body":"obj.to_s(self)\nself\n"}},{"html_id":"close-instance-method","name":"close","doc":"Closes this `IO`.\n\n`IO` defines this is a no-op method, but including types may override.","summary":"<p>Closes this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":107,"url":null},"def":{"name":"close","visibility":"Public","body":""}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this `IO` is closed.\n\n`IO` defines returns `false`, but including types may override.","summary":"<p>Returns <code>true</code> if this <code><a href=\"IO.html\">IO</a></code> is closed.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":113,"url":null},"def":{"name":"closed?","return_type":"Bool","visibility":"Public","body":"false"}},{"html_id":"each_byte(&):Nil-instance-method","name":"each_byte","doc":"Invokes the given block with each byte (`UInt8`) in this `IO`.\n\n```\nio = IO::Memory.new(\"aあ\")\nio.each_byte do |byte|\n  puts byte\nend\n```\n\nOutput:\n\n```text\n97\n227\n129\n130\n```","summary":"<p>Invokes the given block with each byte (<code><a href=\"UInt8.html\">UInt8</a></code>) in this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":997,"url":null},"def":{"name":"each_byte","yields":1,"return_type":"Nil","visibility":"Public","body":"while byte = read_byte\n  yield byte\nend"}},{"html_id":"each_byte-instance-method","name":"each_byte","doc":"Returns an `Iterator` for the bytes in this `IO`.\n\n```\nio = IO::Memory.new(\"aあ\")\niter = io.each_byte\niter.next # => 97\niter.next # => 227\niter.next # => 129\niter.next # => 130\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> for the bytes in this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":1013,"url":null},"def":{"name":"each_byte","visibility":"Public","body":"ByteIterator.new(self)"}},{"html_id":"each_char(&):Nil-instance-method","name":"each_char","doc":"Invokes the given block with each `Char` in this `IO`.\n\n```\nio = IO::Memory.new(\"あめ\")\nio.each_char do |char|\n  puts char\nend\n```\n\nOutput:\n\n```text\nあ\nめ\n```","summary":"<p>Invokes the given block with each <code><a href=\"Char.html\">Char</a></code> in this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":962,"url":null},"def":{"name":"each_char","yields":1,"return_type":"Nil","visibility":"Public","body":"while char = read_char\n  yield char\nend"}},{"html_id":"each_char-instance-method","name":"each_char","doc":"Returns an `Iterator` for the chars in this `IO`.\n\n```\nio = IO::Memory.new(\"あめ\")\niter = io.each_char\niter.next # => 'あ'\niter.next # => 'め'\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> for the chars in this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":976,"url":null},"def":{"name":"each_char","visibility":"Public","body":"CharIterator.new(self)"}},{"html_id":"each_line(*args,**options,&block:String->):Nil-instance-method","name":"each_line","doc":"Invokes the given block with each *line* in this `IO`, where a line\nis defined by the arguments passed to this method, which can be the same\nones as in the `gets` methods.\n\n```\nio = IO::Memory.new(\"hello\\nworld\")\nio.each_line do |line|\n  puts line\nend\n# output:\n# hello\n# world\n```","summary":"<p>Invokes the given block with each <em>line</em> in this <code><a href=\"IO.html\">IO</a></code>, where a line is defined by the arguments passed to this method, which can be the same ones as in the <code><a href=\"IO.html#gets%28limit%3AInt%2Cchomp%3Dfalse%29%3AString%3F-instance-method\">#gets</a></code> methods.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &block : String -> ) : Nil","args_html":"(*args, **options, &block : <a href=\"String.html\">String</a> -> ) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/io.cr","line_number":927,"url":null},"def":{"name":"each_line","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(String ->)"},"return_type":"Nil","visibility":"Public","body":"while line = gets(*args, **options)\n  yield line\nend"}},{"html_id":"each_line(*args,**options)-instance-method","name":"each_line","doc":"Returns an `Iterator` for the *lines* in this `IO`, where a line\nis defined by the arguments passed to this method, which can be the same\nones as in the `gets` methods.\n\n```\nio = IO::Memory.new(\"hello\\nworld\")\niter = io.each_line\niter.next # => \"hello\"\niter.next # => \"world\"\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> for the <em>lines</em> in this <code><a href=\"IO.html\">IO</a></code>, where a line is defined by the arguments passed to this method, which can be the same ones as in the <code><a href=\"IO.html#gets%28limit%3AInt%2Cchomp%3Dfalse%29%3AString%3F-instance-method\">#gets</a></code> methods.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/io.cr","line_number":943,"url":null},"def":{"name":"each_line","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"LineIterator.new(self, args, options)"}},{"html_id":"encoding:String-instance-method","name":"encoding","doc":"Returns this `IO`'s encoding. The default is `UTF-8`.","summary":"<p>Returns this <code><a href=\"IO.html\">IO</a></code>'s encoding.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":1045,"url":null},"def":{"name":"encoding","return_type":"String","visibility":"Public","body":"@encoding.try(&.name) || \"UTF-8\""}},{"html_id":"flush-instance-method","name":"flush","doc":"Flushes buffered data, if any.\n\n`IO` defines this is a no-op method, but including types may override.","summary":"<p>Flushes buffered data, if any.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":124,"url":null},"def":{"name":"flush","visibility":"Public","body":""}},{"html_id":"gets(limit:Int,chomp=false):String?-instance-method","name":"gets","doc":"Reads a line of at most *limit* bytes from this `IO`.\nA line is terminated by the `\\n` character.\nReturns `nil` if called at the end of this `IO`.\n\n```\nio = IO::Memory.new \"hello\\nworld\"\nio.gets(3) # => \"hel\"\nio.gets(3) # => \"lo\\n\"\nio.gets(3) # => \"wor\"\nio.gets(3) # => \"ld\"\nio.gets(3) # => nil\n```","summary":"<p>Reads a line of at most <em>limit</em> bytes from this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"limit","external_name":"limit","restriction":"Int"},{"name":"chomp","default_value":"false","external_name":"chomp","restriction":""}],"args_string":"(limit : Int, chomp = false) : String?","args_html":"(limit : <a href=\"Int.html\">Int</a>, chomp = <span class=\"n\">false</span>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/io.cr","line_number":597,"url":null},"def":{"name":"gets","args":[{"name":"limit","external_name":"limit","restriction":"Int"},{"name":"chomp","default_value":"false","external_name":"chomp","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"gets('\\n', limit: limit, chomp: chomp)"}},{"html_id":"gets(delimiter:Char,limit:Int,chomp=false):String?-instance-method","name":"gets","doc":"Reads until *delimiter* is found, *limit* bytes are read, or the end of the `IO` is reached.\nReturns `nil` if called at the end of this `IO`.\n\n```\nio = IO::Memory.new \"hello\\nworld\"\nio.gets('o', 3)  # => \"hel\"\nio.gets('r', 10) # => \"lo\\nwor\"\nio.gets('z', 10) # => \"ld\"\nio.gets('w', 10) # => nil\n```","summary":"<p>Reads until <em>delimiter</em> is found, <em>limit</em> bytes are read, or the end of the <code><a href=\"IO.html\">IO</a></code> is reached.</p>","abstract":false,"args":[{"name":"delimiter","external_name":"delimiter","restriction":"Char"},{"name":"limit","external_name":"limit","restriction":"Int"},{"name":"chomp","default_value":"false","external_name":"chomp","restriction":""}],"args_string":"(delimiter : Char, limit : Int, chomp = false) : String?","args_html":"(delimiter : <a href=\"Char.html\">Char</a>, limit : <a href=\"Int.html\">Int</a>, chomp = <span class=\"n\">false</span>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/io.cr","line_number":625,"url":null},"def":{"name":"gets","args":[{"name":"delimiter","external_name":"delimiter","restriction":"Char"},{"name":"limit","external_name":"limit","restriction":"Int"},{"name":"chomp","default_value":"false","external_name":"chomp","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"if limit < 0\n  raise(ArgumentError.new(\"Negative limit\"))\nend\nascii = delimiter.ascii?\ndecoder = decoder()\nif ascii && decoder\n  return decoder.gets(self, delimiter.ord.to_u8, limit: limit, chomp: chomp)\nend\nif (ascii && (!decoder)) && (peek = self.peek)\n  if peek.empty?\n    nil\n  else\n    gets_peek(delimiter, limit, chomp, peek)\n  end\nelse\n  gets_slow(delimiter, limit, chomp)\nend\n"}},{"html_id":"gets(delimiter:Char,chomp=false):String?-instance-method","name":"gets","doc":"Reads until *delimiter* is found, or the end of the `IO` is reached.\nReturns `nil` if called at the end of this `IO`.\n\n```\nio = IO::Memory.new \"hello\\nworld\"\nio.gets('o') # => \"hello\"\nio.gets('r') # => \"\\nwor\"\nio.gets('z') # => \"ld\"\nio.gets('w') # => nil\n```","summary":"<p>Reads until <em>delimiter</em> is found, or the end of the <code><a href=\"IO.html\">IO</a></code> is reached.</p>","abstract":false,"args":[{"name":"delimiter","external_name":"delimiter","restriction":"Char"},{"name":"chomp","default_value":"false","external_name":"chomp","restriction":""}],"args_string":"(delimiter : Char, chomp = false) : String?","args_html":"(delimiter : <a href=\"Char.html\">Char</a>, chomp = <span class=\"n\">false</span>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/io.cr","line_number":611,"url":null},"def":{"name":"gets","args":[{"name":"delimiter","external_name":"delimiter","restriction":"Char"},{"name":"chomp","default_value":"false","external_name":"chomp","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"gets(delimiter, Int32::MAX, chomp: chomp)"}},{"html_id":"gets(delimiter:String,chomp=false):String?-instance-method","name":"gets","doc":"Reads until *delimiter* is found or the end of the `IO` is reached.\nReturns `nil` if called at the end of this `IO`.\n\n```\nio = IO::Memory.new \"hello\\nworld\"\nio.gets(\"wo\") # => \"hello\\nwo\"\nio.gets(\"wo\") # => \"rld\"\nio.gets(\"wo\") # => nil\n```","summary":"<p>Reads until <em>delimiter</em> is found or the end of the <code><a href=\"IO.html\">IO</a></code> is reached.</p>","abstract":false,"args":[{"name":"delimiter","external_name":"delimiter","restriction":"String"},{"name":"chomp","default_value":"false","external_name":"chomp","restriction":""}],"args_string":"(delimiter : String, chomp = false) : String?","args_html":"(delimiter : <a href=\"String.html\">String</a>, chomp = <span class=\"n\">false</span>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/io.cr","line_number":783,"url":null},"def":{"name":"gets","args":[{"name":"delimiter","external_name":"delimiter","restriction":"String"},{"name":"chomp","default_value":"false","external_name":"chomp","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"if delimiter.empty?\n  return gets_to_end\nend\nif delimiter.bytesize == 1\n  return gets(delimiter.to_unsafe[0].unsafe_chr, chomp: chomp)\nend\nif delimiter.size == 1\n  return gets(delimiter[0], chomp: chomp)\nend\nlast_byte = delimiter.byte_at(delimiter.bytesize - 1)\ntotal_bytes = 0\nbuffer = String::Builder.new\nwhile true\n  if byte = read_utf8_byte\n  else\n    return buffer.empty? ? nil : buffer.to_s\n  end\n  buffer.write_byte(byte)\n  total_bytes = total_bytes + 1\n  if ((byte == last_byte) && (buffer.bytesize >= delimiter.bytesize)) && ((((buffer.buffer + total_bytes) - delimiter.bytesize).memcmp(delimiter.to_unsafe, delimiter.bytesize)) == 0)\n    if chomp\n      buffer.back(delimiter.bytesize)\n    end\n    break\n  end\nend\nbuffer.to_s\n"}},{"html_id":"gets(chomp=true):String?-instance-method","name":"gets","doc":"Reads a line from this `IO`. A line is terminated by the `\\n` character.\nReturns `nil` if called at the end of this `IO`.\n\nBy default the newline is removed from the returned string,\nunless *chomp* is `false`.\n\n```\nio = IO::Memory.new \"hello\\nworld\\nfoo\\n\"\nio.gets               # => \"hello\"\nio.gets(chomp: false) # => \"world\\n\"\nio.gets               # => \"foo\"\nio.gets               # => nil\n```","summary":"<p>Reads a line from this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"chomp","default_value":"true","external_name":"chomp","restriction":""}],"args_string":"(chomp = true) : String?","args_html":"(chomp = <span class=\"n\">true</span>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/io.cr","line_number":581,"url":null},"def":{"name":"gets","args":[{"name":"chomp","default_value":"true","external_name":"chomp","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"gets('\\n', chomp: chomp)"}},{"html_id":"gets_to_end:String-instance-method","name":"gets_to_end","doc":"Reads the rest of this `IO` data as a `String`.\n\n```\nio = IO::Memory.new \"hello world\"\nio.gets_to_end # => \"hello world\"\n```","summary":"<p>Reads the rest of this <code><a href=\"IO.html\">IO</a></code> data as a <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":550,"url":null},"def":{"name":"gets_to_end","return_type":"String","visibility":"Public","body":"String.build do |str|\n  if decoder = decoder()\n    while true\n      decoder.read(self)\n      if decoder.out_slice.empty?\n        break\n      end\n      decoder.write(str)\n    end\n  else\n    buffer = uninitialized ::StaticArray(UInt8, 4096)\n    while (read_bytes = read(buffer.to_slice)) > 0\n      str.write(buffer.to_slice[0, read_bytes])\n    end\n  end\nend"}},{"html_id":"peek:Bytes?-instance-method","name":"peek","doc":"Peeks into this IO, if possible.\n\nIt returns:\n- `nil` if this IO isn't peekable\n- an empty slice if it is, but EOF was reached\n- a non-empty slice if some data can be peeked\n\nThe returned bytes are only valid data until a next call\nto any method that reads from this IO is invoked.\n\nBy default this method returns `nil`, but IO implementations\nthat provide buffering or wrap other IOs should override\nthis method.","summary":"<p>Peeks into this IO, if possible.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":459,"url":null},"def":{"name":"peek","return_type":"Bytes | ::Nil","visibility":"Public","body":"nil"}},{"html_id":"pos-instance-method","name":"pos","doc":"Returns the current position (in bytes) in this `IO`.\n\nThe `IO` class raises on this method, but some subclasses, notable\n`IO::FileDescriptor` and `IO::Memory` implement it.\n\n```\nFile.write(\"testfile\", \"hello\")\n\nfile = File.new(\"testfile\")\nfile.pos     # => 0\nfile.gets(2) # => \"he\"\nfile.pos     # => 2\n```","summary":"<p>Returns the current position (in bytes) in this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":1095,"url":null},"def":{"name":"pos","visibility":"Public","body":"raise(Error.new(\"Unable to pos\"))"}},{"html_id":"pos=(value)-instance-method","name":"pos=","doc":"Sets the current position (in bytes) in this `IO`.\n\nThe `IO` class raises on this method, but some subclasses, notable\n`IO::FileDescriptor` and `IO::Memory` implement it.\n\n```\nFile.write(\"testfile\", \"hello\")\n\nfile = File.new(\"testfile\")\nfile.pos = 3\nfile.gets_to_end # => \"lo\"\n```","summary":"<p>Sets the current position (in bytes) in this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/io.cr","line_number":1111,"url":null},"def":{"name":"pos=","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"raise(Error.new(\"Unable to pos=\"))"}},{"html_id":"print(obj:_):Nil-instance-method","name":"print","doc":"Same as `<<`.\n\n```\nio = IO::Memory.new\nio.print 1\nio.print '-'\nio.print \"Crystal\"\nio.to_s # => \"1-Crystal\"\n```","summary":"<p>Same as <code><a href=\"IO.html#%3C%3C%28obj%29%3Aself-instance-method\">#<<</a></code>.</p>","abstract":false,"args":[{"name":"obj","external_name":"obj","restriction":"_"}],"args_string":"(obj : _) : Nil","args_html":"(obj : _) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/io.cr","line_number":187,"url":null},"def":{"name":"print","args":[{"name":"obj","external_name":"obj","restriction":"_"}],"return_type":"Nil","visibility":"Public","body":"self << obj\nnil\n"}},{"html_id":"print(*objects:_):Nil-instance-method","name":"print","doc":"Writes the given objects into this `IO` by invoking `to_s(io)`\non each of the objects.\n\n```\nio = IO::Memory.new\nio.print 1, '-', \"Crystal\"\nio.to_s # => \"1-Crystal\"\n```","summary":"<p>Writes the given objects into this <code><a href=\"IO.html\">IO</a></code> by invoking <code>to_s(io)</code> on each of the objects.</p>","abstract":false,"args":[{"name":"objects","external_name":"objects","restriction":"_"}],"args_string":"(*objects : _) : Nil","args_html":"(*objects : _) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/io.cr","line_number":200,"url":null},"def":{"name":"print","args":[{"name":"objects","external_name":"objects","restriction":"_"}],"splat_index":0,"return_type":"Nil","visibility":"Public","body":"objects.each do |obj|\n  print(obj)\nend\nnil\n"}},{"html_id":"printf(format_string,args:Array|Tuple):Nil-instance-method","name":"printf","doc":"Writes a formatted string to this IO.\nFor details on the format string, see top-level `::printf`.","summary":"<p>Writes a formatted string to this IO.</p>","abstract":false,"args":[{"name":"format_string","external_name":"format_string","restriction":""},{"name":"args","external_name":"args","restriction":"Array | Tuple"}],"args_string":"(format_string, args : Array | Tuple) : Nil","args_html":"(format_string, args : <a href=\"Array.html\">Array</a> | <a href=\"Tuple.html\">Tuple</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/io.cr","line_number":269,"url":null},"def":{"name":"printf","args":[{"name":"format_string","external_name":"format_string","restriction":""},{"name":"args","external_name":"args","restriction":"Array | Tuple"}],"return_type":"Nil","visibility":"Public","body":"(String::Formatter(typeof(args)).new(format_string, args, self)).format"}},{"html_id":"printf(format_string,*args):Nil-instance-method","name":"printf","doc":"Writes a formatted string to this IO.\nFor details on the format string, see top-level `::printf`.","summary":"<p>Writes a formatted string to this IO.</p>","abstract":false,"args":[{"name":"format_string","external_name":"format_string","restriction":""},{"name":"args","external_name":"args","restriction":""}],"args_string":"(format_string, *args) : Nil","args_html":"(format_string, *args) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/io.cr","line_number":264,"url":null},"def":{"name":"printf","args":[{"name":"format_string","external_name":"format_string","restriction":""},{"name":"args","external_name":"args","restriction":""}],"splat_index":1,"return_type":"Nil","visibility":"Public","body":"printf(format_string, args)"}},{"html_id":"puts(string:String):Nil-instance-method","name":"puts","doc":"Writes *string* to this `IO`, followed by a newline character\nunless the string already ends with one.\n\n```\nio = IO::Memory.new\nio.puts \"hello\\n\"\nio.puts \"world\"\nio.to_s # => \"hello\\nworld\\n\"\n```","summary":"<p>Writes <em>string</em> to this <code><a href=\"IO.html\">IO</a></code>, followed by a newline character unless the string already ends with one.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String) : Nil","args_html":"(string : <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/io.cr","line_number":216,"url":null},"def":{"name":"puts","args":[{"name":"string","external_name":"string","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"self << string\nif string.ends_with?('\\n')\nelse\n  puts\nend\nnil\n"}},{"html_id":"puts(obj:_):Nil-instance-method","name":"puts","doc":"Writes *obj* to this `IO`, followed by a newline character.\n\n```\nio = IO::Memory.new\nio.puts 1\nio.puts \"Crystal\"\nio.to_s # => \"1\\nCrystal\\n\"\n```","summary":"<p>Writes <em>obj</em> to this <code><a href=\"IO.html\">IO</a></code>, followed by a newline character.</p>","abstract":false,"args":[{"name":"obj","external_name":"obj","restriction":"_"}],"args_string":"(obj : _) : Nil","args_html":"(obj : _) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/io.cr","line_number":230,"url":null},"def":{"name":"puts","args":[{"name":"obj","external_name":"obj","restriction":"_"}],"return_type":"Nil","visibility":"Public","body":"self << obj\nputs\n"}},{"html_id":"puts:Nil-instance-method","name":"puts","doc":"Writes a newline character.\n\n```\nio = IO::Memory.new\nio.puts\nio.to_s # => \"\\n\"\n```","summary":"<p>Writes a newline character.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":242,"url":null},"def":{"name":"puts","return_type":"Nil","visibility":"Public","body":"print('\\n')\nnil\n"}},{"html_id":"puts(*objects:_):Nil-instance-method","name":"puts","doc":"Writes *objects* to this `IO`, each followed by a newline character unless\nthe object is a `String` and already ends with a newline.\n\n```\nio = IO::Memory.new\nio.puts 1, '-', \"Crystal\"\nio.to_s # => \"1\\n-\\nCrystal\\n\"\n```","summary":"<p>Writes <em>objects</em> to this <code><a href=\"IO.html\">IO</a></code>, each followed by a newline character unless the object is a <code><a href=\"String.html\">String</a></code> and already ends with a newline.</p>","abstract":false,"args":[{"name":"objects","external_name":"objects","restriction":"_"}],"args_string":"(*objects : _) : Nil","args_html":"(*objects : _) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/io.cr","line_number":255,"url":null},"def":{"name":"puts","args":[{"name":"objects","external_name":"objects","restriction":"_"}],"splat_index":0,"return_type":"Nil","visibility":"Public","body":"objects.each do |obj|\n  puts(obj)\nend\nnil\n"}},{"html_id":"read(slice:Bytes)-instance-method","name":"read","doc":"Reads at most *slice.size* bytes from this `IO` into *slice*.\nReturns the number of bytes read, which is 0 if and only if there is no\nmore data to read (so checking for 0 is the way to detect end of file).\n\n```\nio = IO::Memory.new \"hello\"\nslice = Bytes.new(4)\nio.read(slice) # => 4\nslice          # => Bytes[104, 101, 108, 108]\nio.read(slice) # => 1\nslice          # => Bytes[111, 101, 108, 108]\nio.read(slice) # => 0\n```","summary":"<p>Reads at most <em>slice.size</em> bytes from this <code><a href=\"IO.html\">IO</a></code> into <em>slice</em>.</p>","abstract":true,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","args_html":"(slice : <a href=\"Bytes.html\">Bytes</a>)","location":{"filename":"src/io.cr","line_number":92,"url":null},"def":{"name":"read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"read_at(offset,bytesize,&:IO->)-instance-method","name":"read_at","doc":"Yields an `IO` to read a section inside this IO.\n\nThe `IO` class raises on this method, but some subclasses, notable\n`File` and `IO::Memory` implement it.\n\nMultiple sections can be read concurrently.","summary":"<p>Yields an <code><a href=\"IO.html\">IO</a></code> to read a section inside this IO.</p>","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"bytesize","external_name":"bytesize","restriction":""}],"args_string":"(offset, bytesize, & : IO -> )","args_html":"(offset, bytesize, & : <a href=\"IO.html\">IO</a> -> )","location":{"filename":"src/io.cr","line_number":1126,"url":null},"def":{"name":"read_at","args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"bytesize","external_name":"bytesize","restriction":""}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(IO ->)"},"visibility":"Public","body":"raise(Error.new(\"Unable to read_at\"))"}},{"html_id":"read_byte:UInt8?-instance-method","name":"read_byte","doc":"Reads a single byte from this `IO`. Returns `nil` if there is no more\ndata to read.\n\n```\nio = IO::Memory.new \"a\"\nio.read_byte # => 97\nio.read_byte # => nil\n```","summary":"<p>Reads a single byte from this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":281,"url":null},"def":{"name":"read_byte","return_type":"UInt8 | ::Nil","visibility":"Public","body":"byte = uninitialized UInt8\nif (read(Slice.new(pointerof(byte), 1))) == 1\n  byte\nelse\n  nil\nend\n"}},{"html_id":"read_bytes(type,format:IO::ByteFormat=IO::ByteFormat::SystemEndian)-instance-method","name":"read_bytes","doc":"Reads an instance of the given *type* from this `IO` using the specified *format*.\n\nThis ends up invoking `type.from_io(self, format)`, so any type defining a\n`from_io(io : IO, format : IO::ByteFormat = IO::ByteFormat::SystemEndian)`\nmethod can be read in this way.\n\nSee `Int.from_io` and `Float.from_io`.\n\n```\nio = IO::Memory.new\nio.puts \"\\u{4}\\u{3}\\u{2}\\u{1}\"\nio.rewind\nio.read_bytes(Int32, IO::ByteFormat::LittleEndian) # => 0x01020304\n```","summary":"<p>Reads an instance of the given <em>type</em> from this <code><a href=\"IO.html\">IO</a></code> using the specified <em>format</em>.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""},{"name":"format","default_value":"IO::ByteFormat::SystemEndian","external_name":"format","restriction":"IO::ByteFormat"}],"args_string":"(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian)","args_html":"(type, format : <a href=\"IO/ByteFormat.html\">IO::ByteFormat</a> = <span class=\"t\">IO</span><span class=\"t\">::</span><span class=\"t\">ByteFormat</span><span class=\"t\">::</span><span class=\"t\">SystemEndian</span>)","location":{"filename":"src/io.cr","line_number":898,"url":null},"def":{"name":"read_bytes","args":[{"name":"type","external_name":"type","restriction":""},{"name":"format","default_value":"IO::ByteFormat::SystemEndian","external_name":"format","restriction":"IO::ByteFormat"}],"visibility":"Public","body":"type.from_io(self, format)"}},{"html_id":"read_char:Char?-instance-method","name":"read_char","doc":"Reads a single `Char` from this `IO`. Returns `nil` if there is no\nmore data to read.\n\n```\nio = IO::Memory.new \"あ\"\nio.read_char # => 'あ'\nio.read_char # => nil\n```","summary":"<p>Reads a single <code><a href=\"Char.html\">Char</a></code> from this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":298,"url":null},"def":{"name":"read_char","return_type":"Char | ::Nil","visibility":"Public","body":"if decoder\nelse\n  peek = self.peek\nend\ninfo = read_char_with_bytesize(peek)\ninfo ? info[0] : nil\n"}},{"html_id":"read_fully(slice:Bytes):Int32-instance-method","name":"read_fully","doc":"Tries to read exactly `slice.size` bytes from this `IO` into *slice*.\nRaises `EOFError` if there aren't `slice.size` bytes of data.\n\n```\nio = IO::Memory.new \"123451234\"\nslice = Bytes.new(5)\nio.read_fully(slice) # => 5\nslice                # => Bytes[49, 50, 51, 52, 53]\nio.read_fully(slice) # raises IO::EOFError\n```","summary":"<p>Tries to read exactly <code>slice.size</code> bytes from this <code><a href=\"IO.html\">IO</a></code> into <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Int32","args_html":"(slice : <a href=\"Bytes.html\">Bytes</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/io.cr","line_number":519,"url":null},"def":{"name":"read_fully","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Int32","visibility":"Public","body":"(read_fully?(slice)) || (raise(EOFError.new))"}},{"html_id":"read_fully?(slice:Bytes):Int32?-instance-method","name":"read_fully?","doc":"Tries to read exactly `slice.size` bytes from this `IO` into *slice*.\nReturns `nil` if there aren't `slice.size` bytes of data, otherwise\nreturns the number of bytes read.\n\n```\nio = IO::Memory.new \"123451234\"\nslice = Bytes.new(5)\nio.read_fully?(slice) # => 5\nslice                 # => Bytes[49, 50, 51, 52, 53]\nio.read_fully?(slice) # => nil\n```","summary":"<p>Tries to read exactly <code>slice.size</code> bytes from this <code><a href=\"IO.html\">IO</a></code> into <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Int32?","args_html":"(slice : <a href=\"Bytes.html\">Bytes</a>) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/io.cr","line_number":534,"url":null},"def":{"name":"read_fully?","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"count = slice.size\nwhile slice.size > 0\n  read_bytes = read(slice)\n  if read_bytes == 0\n    return nil\n  end\n  slice = slice + read_bytes\nend\ncount\n"}},{"html_id":"read_line(*args,**options):String-instance-method","name":"read_line","doc":"Same as `gets`, but raises `EOFError` if called at the end of this `IO`.","summary":"<p>Same as <code><a href=\"IO.html#gets%28limit%3AInt%2Cchomp%3Dfalse%29%3AString%3F-instance-method\">#gets</a></code>, but raises <code><a href=\"IO/EOFError.html\">EOFError</a></code> if called at the end of this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options) : String","args_html":"(*args, **options) : <a href=\"String.html\">String</a>","location":{"filename":"src/io.cr","line_number":823,"url":null},"def":{"name":"read_line","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"return_type":"String","visibility":"Public","body":"(gets(*args, **options)) || (raise(EOFError.new))"}},{"html_id":"read_string(bytesize:Int):String-instance-method","name":"read_string","doc":"Reads an UTF-8 encoded string of exactly *bytesize* bytes.\nRaises `EOFError` if there are not enough bytes to build\nthe string.\n\n```\nio = IO::Memory.new(\"hello world\")\nio.read_string(5) # => \"hello\"\nio.read_string(1) # => \" \"\nio.read_string(6) # raises IO::EOFError\n```","summary":"<p>Reads an UTF-8 encoded string of exactly <em>bytesize</em> bytes.</p>","abstract":false,"args":[{"name":"bytesize","external_name":"bytesize","restriction":"Int"}],"args_string":"(bytesize : Int) : String","args_html":"(bytesize : <a href=\"Int.html\">Int</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/io.cr","line_number":432,"url":null},"def":{"name":"read_string","args":[{"name":"bytesize","external_name":"bytesize","restriction":"Int"}],"return_type":"String","visibility":"Public","body":"String.new(bytesize) do |ptr|\n  if decoder = decoder()\n    read = decoder.read_utf8(self, Slice.new(ptr, bytesize))\n    if read != bytesize\n      raise(IO::EOFError.new)\n    end\n  else\n    read_fully(Slice.new(ptr, bytesize))\n  end\n  {bytesize, 0}\nend"}},{"html_id":"read_utf8(slice:Bytes)-instance-method","name":"read_utf8","doc":"Reads UTF-8 decoded bytes into the given *slice*.\nReturns the number of UTF-8 bytes read.\n\nIf no encoding is set, this is the same as `#read(slice)`.\n\n```\nbytes = \"你\".encode(\"GB2312\") # => Bytes[196, 227]\n\nio = IO::Memory.new(bytes)\nio.set_encoding(\"GB2312\")\n\nbuffer = uninitialized UInt8[1024]\nbytes_read = io.read_utf8(buffer.to_slice) # => 3\nbuffer.to_slice[0, bytes_read]             # => Bytes[228, 189, 160]\n\n\"你\".bytes # => [228, 189, 160]\n```","summary":"<p>Reads UTF-8 decoded bytes into the given <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","args_html":"(slice : <a href=\"Bytes.html\">Bytes</a>)","location":{"filename":"src/io.cr","line_number":414,"url":null},"def":{"name":"read_utf8","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"visibility":"Public","body":"if decoder = decoder()\n  decoder.read_utf8(self, slice)\nelse\n  read(slice)\nend"}},{"html_id":"read_utf8_byte:UInt8?-instance-method","name":"read_utf8_byte","doc":"Reads a single decoded UTF-8 byte from this `IO`.\nReturns `nil` if there is no more data to read.\n\nIf no encoding is set, this is the same as `#read_byte`.\n\n```\nbytes = \"你\".encode(\"GB2312\") # => Bytes[196, 227]\n\nio = IO::Memory.new(bytes)\nio.set_encoding(\"GB2312\")\nio.read_utf8_byte # => 228\nio.read_utf8_byte # => 189\nio.read_utf8_byte # => 160\nio.read_utf8_byte # => nil\n\n\"你\".bytes # => [228, 189, 160]\n```","summary":"<p>Reads a single decoded UTF-8 byte from this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":389,"url":null},"def":{"name":"read_utf8_byte","return_type":"UInt8 | ::Nil","visibility":"Public","body":"if decoder = decoder()\n  decoder.read_byte(self)\nelse\n  read_byte\nend"}},{"html_id":"rewind-instance-method","name":"rewind","doc":"Rewinds this `IO`. By default this method raises, but including types\nmay implement it.","summary":"<p>Rewinds this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":1019,"url":null},"def":{"name":"rewind","visibility":"Public","body":"raise(IO::Error.new(\"Can't rewind\"))"}},{"html_id":"seek(offset,whence:Seek=Seek::Set)-instance-method","name":"seek","doc":"Seeks to a given *offset* (in bytes) according to the *whence* argument.\n\nThe `IO` class raises on this method, but some subclasses, notable\n`IO::FileDescriptor` and `IO::Memory` implement it.\n\nReturns `self`.\n\n```\nFile.write(\"testfile\", \"abc\")\n\nfile = File.new(\"testfile\")\nfile.gets(3) # => \"abc\"\nfile.seek(1, IO::Seek::Set)\nfile.gets(2) # => \"bc\"\nfile.seek(-1, IO::Seek::Current)\nfile.gets(1) # => \"c\"\n```","summary":"<p>Seeks to a given <em>offset</em> (in bytes) according to the <em>whence</em> argument.</p>","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"whence","default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"args_string":"(offset, whence : Seek = Seek::Set)","args_html":"(offset, whence : <a href=\"IO/Seek.html\">Seek</a> = <span class=\"t\">Seek</span><span class=\"t\">::</span><span class=\"t\">Set</span>)","location":{"filename":"src/io.cr","line_number":1078,"url":null},"def":{"name":"seek","args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"whence","default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"visibility":"Public","body":"raise(Error.new(\"Unable to seek\"))"}},{"html_id":"set_encoding(encoding:String,invalid:Symbol?=nil):Nil-instance-method","name":"set_encoding","doc":"Sets the encoding of this `IO`.\n\nThe *invalid* argument can be:\n* `nil`: an exception is raised on invalid byte sequences\n* `:skip`: invalid byte sequences are ignored\n\nString operations (`gets`, `gets_to_end`, `read_char`, `<<`, `print`, `puts`\n`printf`) will use this encoding.","summary":"<p>Sets the encoding of this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"encoding","external_name":"encoding","restriction":"String"},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":"Symbol | ::Nil"}],"args_string":"(encoding : String, invalid : Symbol? = nil) : Nil","args_html":"(encoding : <a href=\"String.html\">String</a>, invalid : <a href=\"Symbol.html\">Symbol</a>? = <span class=\"n\">nil</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/io.cr","line_number":1031,"url":null},"def":{"name":"set_encoding","args":[{"name":"encoding","external_name":"encoding","restriction":"String"},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":"Symbol | ::Nil"}],"return_type":"Nil","visibility":"Public","body":"if utf8_encoding?(encoding, invalid)\n  @encoding = nil\nelse\n  @encoding = EncodingOptions.new(encoding, invalid)\nend\n@encoder.try(&.close)\n@decoder.try(&.close)\n@encoder = nil\n@decoder = nil\nnil\n"}},{"html_id":"skip(bytes_count:Int):Nil-instance-method","name":"skip","doc":"Reads and discards exactly *bytes_count* bytes.\nRaises `IO::EOFError` if there aren't at least *bytes_count* bytes.\n\n```\nio = IO::Memory.new \"hello world\"\nio.skip(6)\nio.gets    # => \"world\"\nio.skip(1) # raises IO::EOFError\n```","summary":"<p>Reads and discards exactly <em>bytes_count</em> bytes.</p>","abstract":false,"args":[{"name":"bytes_count","external_name":"bytes_count","restriction":"Int"}],"args_string":"(bytes_count : Int) : Nil","args_html":"(bytes_count : <a href=\"Int.html\">Int</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/io.cr","line_number":836,"url":null},"def":{"name":"skip","args":[{"name":"bytes_count","external_name":"bytes_count","restriction":"Int"}],"return_type":"Nil","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4096)\nwhile bytes_count > 0\n  read_count = read(buffer.to_slice[0, Math.min(bytes_count, 4096)])\n  if read_count == 0\n    raise(IO::EOFError.new)\n  end\n  bytes_count = bytes_count - read_count\nend\n"}},{"html_id":"skip_to_end:Nil-instance-method","name":"skip_to_end","doc":"Reads and discards bytes from `self` until there\nare no more bytes.","summary":"<p>Reads and discards bytes from <code>self</code> until there are no more bytes.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":848,"url":null},"def":{"name":"skip_to_end","return_type":"Nil","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4096)\nwhile (read(buffer.to_slice)) > 0\nend\n"}},{"html_id":"tell-instance-method","name":"tell","doc":"Same as `pos`.","summary":"<p>Same as <code><a href=\"IO.html#pos-instance-method\">#pos</a></code>.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":1116,"url":null},"def":{"name":"tell","visibility":"Public","body":"pos"}},{"html_id":"tty?:Bool-instance-method","name":"tty?","doc":"Returns `true` if this `IO` is associated with a terminal device (tty), `false` otherwise.\n\nIO returns `false`, but including types may override.\n\n```\nSTDIN.tty?          # => true\nIO::Memory.new.tty? # => false\n```","summary":"<p>Returns <code>true</code> if this <code><a href=\"IO.html\">IO</a></code> is associated with a terminal device (tty), <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/io.cr","line_number":910,"url":null},"def":{"name":"tty?","return_type":"Bool","visibility":"Public","body":"false"}},{"html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"Writes the contents of *slice* into this `IO`.\n\n```\nio = IO::Memory.new\nslice = Bytes.new(4) { |i| ('a'.ord + i).to_u8 }\nio.write(slice)\nio.to_s # => \"abcd\"\n```","summary":"<p>Writes the contents of <em>slice</em> into this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":true,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"Bytes.html\">Bytes</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/io.cr","line_number":102,"url":null},"def":{"name":"write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":""}},{"html_id":"write_byte(byte:UInt8):Nil-instance-method","name":"write_byte","doc":"Writes a single byte into this `IO`.\n\n```\nio = IO::Memory.new\nio.write_byte 97_u8\nio.to_s # => \"a\"\n```","summary":"<p>Writes a single byte into this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"byte","external_name":"byte","restriction":"UInt8"}],"args_string":"(byte : UInt8) : Nil","args_html":"(byte : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/io.cr","line_number":861,"url":null},"def":{"name":"write_byte","args":[{"name":"byte","external_name":"byte","restriction":"UInt8"}],"return_type":"Nil","visibility":"Public","body":"x = byte\nwrite(Slice.new(pointerof(x), 1))\n"}},{"html_id":"write_bytes(object,format:IO::ByteFormat=IO::ByteFormat::SystemEndian):Nil-instance-method","name":"write_bytes","doc":"Writes the given object to this `IO` using the specified *format*.\n\nThis ends up invoking `object.to_io(self, format)`, so any object defining a\n`to_io(io : IO, format : IO::ByteFormat = IO::ByteFormat::SystemEndian)`\nmethod can be written in this way.\n\nSee `Int#to_io` and `Float#to_io`.\n\n```\nio = IO::Memory.new\nio.write_bytes(0x01020304, IO::ByteFormat::LittleEndian)\nio.rewind\nio.gets(4) # => \"\\u{4}\\u{3}\\u{2}\\u{1}\"\n```","summary":"<p>Writes the given object to this <code><a href=\"IO.html\">IO</a></code> using the specified <em>format</em>.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":""},{"name":"format","default_value":"IO::ByteFormat::SystemEndian","external_name":"format","restriction":"IO::ByteFormat"}],"args_string":"(object, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) : Nil","args_html":"(object, format : <a href=\"IO/ByteFormat.html\">IO::ByteFormat</a> = <span class=\"t\">IO</span><span class=\"t\">::</span><span class=\"t\">ByteFormat</span><span class=\"t\">::</span><span class=\"t\">SystemEndian</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/io.cr","line_number":880,"url":null},"def":{"name":"write_bytes","args":[{"name":"object","external_name":"object","restriction":""},{"name":"format","default_value":"IO::ByteFormat::SystemEndian","external_name":"format","restriction":"IO::ByteFormat"}],"return_type":"Nil","visibility":"Public","body":"object.to_io(self, format)"}},{"html_id":"write_string(slice:Bytes):Nil-instance-method","name":"write_string","doc":"Writes the contents of *slice*, interpreted as a sequence of UTF-8 or ASCII\ncharacters, into this `IO`. The contents are transcoded into this `IO`'s\ncurrent encoding.\n\n```\nbytes = \"你\".to_slice # => Bytes[228, 189, 160]\n\nio = IO::Memory.new\nio.set_encoding(\"GB2312\")\nio.write_string(bytes)\nio.to_slice # => Bytes[196, 227]\n\n\"你\".encode(\"GB2312\") # => Bytes[196, 227]\n```","summary":"<p>Writes the contents of <em>slice</em>, interpreted as a sequence of UTF-8 or ASCII characters, into this <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"Bytes.html\">Bytes</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/io.cr","line_number":477,"url":null},"def":{"name":"write_string","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"if encoder = encoder()\n  encoder.write(self, slice)\nelse\n  write(slice)\nend\nnil\n"}},{"html_id":"write_utf8(slice:Bytes):Nil-instance-method","name":"write_utf8","doc":"Writes the contents of *slice*, interpreted as a sequence of UTF-8 or ASCII\ncharacters, into this `IO`. The contents are transcoded into this `IO`'s\ncurrent encoding.\n\n```\nbytes = \"你\".to_slice # => Bytes[228, 189, 160]\n\nio = IO::Memory.new\nio.set_encoding(\"GB2312\")\nio.write_string(bytes)\nio.to_slice # => Bytes[196, 227]\n\n\"你\".encode(\"GB2312\") # => Bytes[196, 227]\n```","summary":"<p>Writes the contents of <em>slice</em>, interpreted as a sequence of UTF-8 or ASCII characters, into this <code><a href=\"IO.html\">IO</a></code>.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"IO.html#write_string%28slice%3ABytes%29%3ANil-instance-method\">#write_string</a></code> instead.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"Bytes.html\">Bytes</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/io.cr","line_number":489,"url":null},"def":{"name":"write_utf8","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"write_string(slice)"}}],"types":[{"html_id":"Crystal/IO/Buffered","path":"IO/Buffered.html","kind":"module","full_name":"IO::Buffered","name":"Buffered","abstract":false,"locations":[{"filename":"src/io/buffered.cr","line_number":8,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"including_types":[{"html_id":"Crystal/Compress/Deflate/Reader","kind":"class","full_name":"Compress::Deflate::Reader","name":"Reader"},{"html_id":"Crystal/Compress/Gzip/Reader","kind":"class","full_name":"Compress::Gzip::Reader","name":"Reader"},{"html_id":"Crystal/Compress/Zlib/Reader","kind":"class","full_name":"Compress::Zlib::Reader","name":"Reader"},{"html_id":"Crystal/IO/FileDescriptor","kind":"class","full_name":"IO::FileDescriptor","name":"FileDescriptor"},{"html_id":"Crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"}],"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"The `IO::Buffered` mixin enhances an `IO` with input/output buffering.\n\nThe buffering behaviour can be turned on/off with the `#sync=` and\n`#read_buffering=` methods.\n\nAdditionally, several methods, like `#gets`, are implemented in a more\nefficient way.","summary":"<p>The <code><a href=\"../IO/Buffered.html\">IO::Buffered</a></code> mixin enhances an <code><a href=\"../IO.html\">IO</a></code> with input/output buffering.</p>","instance_methods":[{"html_id":"buffer_size:Int32-instance-method","name":"buffer_size","doc":"Return the buffer size used","summary":"<p>Return the buffer size used</p>","abstract":false,"location":{"filename":"src/io/buffered.cr","line_number":34,"url":null},"def":{"name":"buffer_size","return_type":"Int32","visibility":"Public","body":"@buffer_size"}},{"html_id":"buffer_size=(value)-instance-method","name":"buffer_size=","doc":"Set the buffer size of both the read and write buffer\nCannot be changed after any of the buffers have been allocated","summary":"<p>Set the buffer size of both the read and write buffer Cannot be changed after any of the buffers have been allocated</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/io/buffered.cr","line_number":40,"url":null},"def":{"name":"buffer_size=","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"if @in_buffer || @out_buffer\n  raise(ArgumentError.new(\"Cannot change buffer_size after buffers have been allocated\"))\nend\n@buffer_size = value\n"}},{"html_id":"close:Nil-instance-method","name":"close","doc":"Flushes and closes the underlying `IO`.","summary":"<p>Flushes and closes the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io/buffered.cr","line_number":224,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"begin\n  if @out_count > 0\n    flush\n  end\nensure\n  unbuffered_close\nend"}},{"html_id":"flush-instance-method","name":"flush","doc":"Flushes any buffered data and the underlying `IO`. Returns `self`.","summary":"<p>Flushes any buffered data and the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io/buffered.cr","line_number":216,"url":null},"def":{"name":"flush","visibility":"Public","body":"if @out_count > 0\n  unbuffered_write(Slice.new(out_buffer, @out_count))\nend\nunbuffered_flush\n@out_count = 0\nself\n"}},{"html_id":"flush_on_newline=(flush_on_newline)-instance-method","name":"flush_on_newline=","doc":"Turns on/off flushing the underlying `IO` when a newline is written.","summary":"<p>Turns on/off flushing the underlying <code><a href=\"../IO.html\">IO</a></code> when a newline is written.</p>","abstract":false,"args":[{"name":"flush_on_newline","external_name":"flush_on_newline","restriction":""}],"args_string":"(flush_on_newline)","args_html":"(flush_on_newline)","location":{"filename":"src/io/buffered.cr","line_number":206,"url":null},"def":{"name":"flush_on_newline=","args":[{"name":"flush_on_newline","external_name":"flush_on_newline","restriction":""}],"visibility":"Public","body":"@flush_on_newline = !(!flush_on_newline)"}},{"html_id":"flush_on_newline?:Bool-instance-method","name":"flush_on_newline?","doc":"Determines if this `IO` flushes automatically when a newline is written.","summary":"<p>Determines if this <code><a href=\"../IO.html\">IO</a></code> flushes automatically when a newline is written.</p>","abstract":false,"location":{"filename":"src/io/buffered.cr","line_number":211,"url":null},"def":{"name":"flush_on_newline?","return_type":"Bool","visibility":"Public","body":"@flush_on_newline"}},{"html_id":"peek:Bytes?-instance-method","name":"peek","doc":"Returns the bytes hold in the read buffer.\n\nThis method only performs a read to return\npeek data if the current buffer is empty:\notherwise no read is performed and whatever\nis in the buffer is returned.","summary":"<p>Returns the bytes hold in the read buffer.</p>","abstract":false,"location":{"filename":"src/io/buffered.cr","line_number":99,"url":null},"def":{"name":"peek","return_type":"Bytes | ::Nil","visibility":"Public","body":"check_open\nif @in_buffer_rem.empty?\n  fill_buffer\n  if @in_buffer_rem.empty?\n    return Bytes.empty\n  end\nend\n@in_buffer_rem\n"}},{"html_id":"read(slice:Bytes):Int32-instance-method","name":"read","doc":"Buffered implementation of `IO#read(slice)`.","summary":"<p>Buffered implementation of <code><a href=\"../IO.html#read%28slice%3ABytes%29-instance-method\">IO#read(slice)</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Int32","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/io/buffered.cr","line_number":69,"url":null},"def":{"name":"read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Int32","visibility":"Public","body":"check_open\ncount = slice.size\nif count == 0\n  return 0\nend\nif @in_buffer_rem.empty?\n  if (!read_buffering?) || count >= (@buffer_size // 2)\n    return (unbuffered_read(slice[0, count])).to_i\n  else\n    fill_buffer\n    if @in_buffer_rem.empty?\n      return 0\n    end\n  end\nend\nto_read = Math.min(count, @in_buffer_rem.size)\nslice.copy_from(@in_buffer_rem.to_unsafe, to_read)\n@in_buffer_rem = @in_buffer_rem + to_read\nto_read\n"}},{"html_id":"read_buffering=(read_buffering)-instance-method","name":"read_buffering=","doc":"Turns on/off `IO` **read** buffering.","summary":"<p>Turns on/off <code><a href=\"../IO.html\">IO</a></code> <strong>read</strong> buffering.</p>","abstract":false,"args":[{"name":"read_buffering","external_name":"read_buffering","restriction":""}],"args_string":"(read_buffering)","args_html":"(read_buffering)","location":{"filename":"src/io/buffered.cr","line_number":196,"url":null},"def":{"name":"read_buffering=","args":[{"name":"read_buffering","external_name":"read_buffering","restriction":""}],"visibility":"Public","body":"@read_buffering = !(!read_buffering)"}},{"html_id":"read_buffering?:Bool-instance-method","name":"read_buffering?","doc":"Determines whether this `IO` buffers reads.","summary":"<p>Determines whether this <code><a href=\"../IO.html\">IO</a></code> buffers reads.</p>","abstract":false,"location":{"filename":"src/io/buffered.cr","line_number":201,"url":null},"def":{"name":"read_buffering?","return_type":"Bool","visibility":"Public","body":"@read_buffering"}},{"html_id":"rewind-instance-method","name":"rewind","doc":"Rewinds the underlying `IO`. Returns `self`.","summary":"<p>Rewinds the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io/buffered.cr","line_number":231,"url":null},"def":{"name":"rewind","visibility":"Public","body":"unbuffered_rewind\n@in_buffer_rem = Bytes.empty\nself\n"}},{"html_id":"sync=(sync)-instance-method","name":"sync=","doc":"Turns on/off `IO` **write** buffering. When *sync* is set to `true`, no buffering\nwill be done (that is, writing to this `IO` is immediately synced to the\nunderlying `IO`).","summary":"<p>Turns on/off <code><a href=\"../IO.html\">IO</a></code> <strong>write</strong> buffering.</p>","abstract":false,"args":[{"name":"sync","external_name":"sync","restriction":""}],"args_string":"(sync)","args_html":"(sync)","location":{"filename":"src/io/buffered.cr","line_number":185,"url":null},"def":{"name":"sync=","args":[{"name":"sync","external_name":"sync","restriction":""}],"visibility":"Public","body":"if sync && (!@sync)\n  flush\nend\n@sync = !(!sync)\n"}},{"html_id":"sync?:Bool-instance-method","name":"sync?","doc":"Determines if this `IO` does write buffering. If `true`, no buffering is done.","summary":"<p>Determines if this <code><a href=\"../IO.html\">IO</a></code> does write buffering.</p>","abstract":false,"location":{"filename":"src/io/buffered.cr","line_number":191,"url":null},"def":{"name":"sync?","return_type":"Bool","visibility":"Public","body":"@sync"}},{"html_id":"unbuffered_close-instance-method","name":"unbuffered_close","doc":"Closes the wrapped `IO`.","summary":"<p>Closes the wrapped <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":true,"location":{"filename":"src/io/buffered.cr","line_number":28,"url":null},"def":{"name":"unbuffered_close","visibility":"Public","body":""}},{"html_id":"unbuffered_flush-instance-method","name":"unbuffered_flush","doc":"Flushes the wrapped `IO`.","summary":"<p>Flushes the wrapped <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":true,"location":{"filename":"src/io/buffered.cr","line_number":25,"url":null},"def":{"name":"unbuffered_flush","visibility":"Public","body":""}},{"html_id":"unbuffered_read(slice:Bytes)-instance-method","name":"unbuffered_read","doc":"Reads at most *slice.size* bytes from the wrapped `IO` into *slice*.\nReturns the number of bytes read.","summary":"<p>Reads at most <em>slice.size</em> bytes from the wrapped <code><a href=\"../IO.html\">IO</a></code> into <em>slice</em>.</p>","abstract":true,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/buffered.cr","line_number":18,"url":null},"def":{"name":"unbuffered_read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"unbuffered_rewind-instance-method","name":"unbuffered_rewind","doc":"Rewinds the wrapped `IO`.","summary":"<p>Rewinds the wrapped <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":true,"location":{"filename":"src/io/buffered.cr","line_number":31,"url":null},"def":{"name":"unbuffered_rewind","visibility":"Public","body":""}},{"html_id":"unbuffered_write(slice:Bytes)-instance-method","name":"unbuffered_write","doc":"Writes at most *slice.size* bytes from *slice* into the wrapped `IO`.\nReturns the number of bytes written.","summary":"<p>Writes at most <em>slice.size</em> bytes from <em>slice</em> into the wrapped <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":true,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/buffered.cr","line_number":22,"url":null},"def":{"name":"unbuffered_write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"Buffered implementation of `IO#write(slice)`.","summary":"<p>Buffered implementation of <code><a href=\"../IO.html#write%28slice%3ABytes%29%3ANil-instance-method\">IO#write(slice)</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/buffered.cr","line_number":128,"url":null},"def":{"name":"write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"check_open\nif slice.empty?\n  return\nend\ncount = slice.size\nif sync?\n  return unbuffered_write(slice)\nend\nif flush_on_newline?\n  index = slice[0, count.to_i32].rindex('\\n'.ord.to_u8)\n  if index\n    flush\n    index = index + 1\n    unbuffered_write(slice[0, index])\n    slice = slice + index\n    count = count - index\n  end\nend\nif count >= @buffer_size\n  flush\n  return unbuffered_write(slice[0, count])\nend\nif count > (@buffer_size - @out_count)\n  flush\nend\nslice.copy_to(out_buffer + @out_count, count)\n@out_count = @out_count + count\n"}}]},{"html_id":"Crystal/IO/ByteFormat","path":"IO/ByteFormat.html","kind":"module","full_name":"IO::ByteFormat","name":"ByteFormat","abstract":false,"locations":[{"filename":"src/io/byte_format.cr","line_number":35,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"Defines a byte format to encode integers and floats\nfrom/to `Bytes` and `IO`.\n\n### Decode from bytes\n\n```\nbytes = Bytes[0x34, 0x12]\nint16 = IO::ByteFormat::LittleEndian.decode(Int16, bytes)\nint16 # => 0x1234_i16\n```\n\n### Decode from an IO\n\n```\nio = IO::Memory.new(Bytes[0x34, 0x12])\nint16 = io.read_bytes(Int16, IO::ByteFormat::LittleEndian)\nint16 # => 0x1234_i16\n```\n\n### Encode to bytes\n\n```\nraw = uninitialized UInt8[2]\nIO::ByteFormat::LittleEndian.encode(0x1234_i16, raw.to_slice)\nraw # => StaticArray[0x34, 0x12]\n```\n\n### Encode to IO\n\n```\nio = IO::Memory.new\nio.write_bytes(0x1234_i16, IO::ByteFormat::LittleEndian)\nio.to_slice # => Bytes[0x34, 0x12]\n```","summary":"<p>Defines a byte format to encode integers and floats from/to <code><a href=\"../Bytes.html\">Bytes</a></code> and <code><a href=\"../IO.html\">IO</a></code>.</p>","instance_methods":[{"html_id":"decode(int:Int8.class,io:IO)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int8.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int8.class, io : IO)","args_html":"(int : <span class=\"t\">Int8</span>.<span class=\"k\">class</span>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":58,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"Int8.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"decode(int:UInt8.class,io:IO)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt8.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt8.class, io : IO)","args_html":"(int : <span class=\"t\">UInt8</span>.<span class=\"k\">class</span>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":59,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"UInt8.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"decode(int:Int16.class,io:IO)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int16.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int16.class, io : IO)","args_html":"(int : <span class=\"t\">Int16</span>.<span class=\"k\">class</span>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":60,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"Int16.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"decode(int:UInt16.class,io:IO)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt16.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt16.class, io : IO)","args_html":"(int : <span class=\"t\">UInt16</span>.<span class=\"k\">class</span>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":61,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"UInt16.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"decode(int:Int32.class,io:IO)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int32.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int32.class, io : IO)","args_html":"(int : <span class=\"t\">Int32</span>.<span class=\"k\">class</span>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":62,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"Int32.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"decode(int:UInt32.class,io:IO)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt32.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt32.class, io : IO)","args_html":"(int : <span class=\"t\">UInt32</span>.<span class=\"k\">class</span>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":63,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"UInt32.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"decode(int:Int64.class,io:IO)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int64.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int64.class, io : IO)","args_html":"(int : <span class=\"t\">Int64</span>.<span class=\"k\">class</span>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":64,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"Int64.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"decode(int:UInt64.class,io:IO)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt64.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt64.class, io : IO)","args_html":"(int : <span class=\"t\">UInt64</span>.<span class=\"k\">class</span>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":65,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"UInt64.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"decode(int:Int128.class,io:IO)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int128.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int128.class, io : IO)","args_html":"(int : <span class=\"t\">Int128</span>.<span class=\"k\">class</span>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":66,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"Int128.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"decode(int:UInt128.class,io:IO)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt128.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt128.class, io : IO)","args_html":"(int : <span class=\"t\">UInt128</span>.<span class=\"k\">class</span>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":67,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"UInt128.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"decode(int:Int8.class,bytes:Bytes)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int8.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int8.class, bytes : Bytes)","args_html":"(int : <span class=\"t\">Int8</span>.<span class=\"k\">class</span>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":69,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"Int8.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"decode(int:UInt8.class,bytes:Bytes)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt8.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt8.class, bytes : Bytes)","args_html":"(int : <span class=\"t\">UInt8</span>.<span class=\"k\">class</span>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":70,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"UInt8.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"decode(int:Int16.class,bytes:Bytes)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int16.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int16.class, bytes : Bytes)","args_html":"(int : <span class=\"t\">Int16</span>.<span class=\"k\">class</span>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":71,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"Int16.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"decode(int:UInt16.class,bytes:Bytes)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt16.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt16.class, bytes : Bytes)","args_html":"(int : <span class=\"t\">UInt16</span>.<span class=\"k\">class</span>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":72,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"UInt16.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"decode(int:Int32.class,bytes:Bytes)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int32.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int32.class, bytes : Bytes)","args_html":"(int : <span class=\"t\">Int32</span>.<span class=\"k\">class</span>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":73,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"Int32.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"decode(int:UInt32.class,bytes:Bytes)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt32.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt32.class, bytes : Bytes)","args_html":"(int : <span class=\"t\">UInt32</span>.<span class=\"k\">class</span>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":74,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"UInt32.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"decode(int:Int64.class,bytes:Bytes)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int64.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int64.class, bytes : Bytes)","args_html":"(int : <span class=\"t\">Int64</span>.<span class=\"k\">class</span>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":75,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"Int64.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"decode(int:UInt64.class,bytes:Bytes)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt64.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt64.class, bytes : Bytes)","args_html":"(int : <span class=\"t\">UInt64</span>.<span class=\"k\">class</span>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":76,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"UInt64.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"decode(int:Int128.class,bytes:Bytes)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int128.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int128.class, bytes : Bytes)","args_html":"(int : <span class=\"t\">Int128</span>.<span class=\"k\">class</span>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":77,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"Int128.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"decode(int:UInt128.class,bytes:Bytes)-instance-method","name":"decode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt128.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt128.class, bytes : Bytes)","args_html":"(int : <span class=\"t\">UInt128</span>.<span class=\"k\">class</span>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":78,"url":null},"def":{"name":"decode","args":[{"name":"int","external_name":"int","restriction":"UInt128.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"decode(type:Float32.class,io:IO):Float32-instance-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Float32.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : Float32.class, io : IO) : Float32","args_html":"(type : <span class=\"t\">Float32</span>.<span class=\"k\">class</span>, io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Float32.html\">Float32</a>","location":{"filename":"src/io/byte_format.cr","line_number":88,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Float32.class"},{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Float32","visibility":"Public","body":"(decode(Int32, io)).unsafe_as(Float32)"}},{"html_id":"decode(type:Float32.class,bytes:Bytes):Float32-instance-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Float32.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Float32.class, bytes : Bytes) : Float32","args_html":"(type : <span class=\"t\">Float32</span>.<span class=\"k\">class</span>, bytes : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Float32.html\">Float32</a>","location":{"filename":"src/io/byte_format.cr","line_number":92,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Float32.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"return_type":"Float32","visibility":"Public","body":"(decode(Int32, bytes)).unsafe_as(Float32)"}},{"html_id":"decode(type:Float64.class,io:IO):Float64-instance-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Float64.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : Float64.class, io : IO) : Float64","args_html":"(type : <span class=\"t\">Float64</span>.<span class=\"k\">class</span>, io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Float64.html\">Float64</a>","location":{"filename":"src/io/byte_format.cr","line_number":104,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Float64.class"},{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Float64","visibility":"Public","body":"(decode(Int64, io)).unsafe_as(Float64)"}},{"html_id":"decode(type:Float64.class,bytes:Bytes):Float64-instance-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Float64.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Float64.class, bytes : Bytes) : Float64","args_html":"(type : <span class=\"t\">Float64</span>.<span class=\"k\">class</span>, bytes : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Float64.html\">Float64</a>","location":{"filename":"src/io/byte_format.cr","line_number":108,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Float64.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"return_type":"Float64","visibility":"Public","body":"(decode(Int64, bytes)).unsafe_as(Float64)"}},{"html_id":"encode(int:Int8,io:IO)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int8"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int8, io : IO)","args_html":"(int : <a href=\"../Int8.html\">Int8</a>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":36,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int8"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"encode(int:UInt8,io:IO)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt8"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt8, io : IO)","args_html":"(int : <a href=\"../UInt8.html\">UInt8</a>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":37,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt8"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"encode(int:Int16,io:IO)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int16"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int16, io : IO)","args_html":"(int : <a href=\"../Int16.html\">Int16</a>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":38,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int16"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"encode(int:UInt16,io:IO)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt16"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt16, io : IO)","args_html":"(int : <a href=\"../UInt16.html\">UInt16</a>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":39,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt16"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"encode(int:Int32,io:IO)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int32"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int32, io : IO)","args_html":"(int : <a href=\"../Int32.html\">Int32</a>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":40,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int32"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"encode(int:UInt32,io:IO)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt32"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt32, io : IO)","args_html":"(int : <a href=\"../UInt32.html\">UInt32</a>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":41,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt32"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"encode(int:Int64,io:IO)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int64"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int64, io : IO)","args_html":"(int : <a href=\"../Int64.html\">Int64</a>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":42,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int64"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"encode(int:UInt64,io:IO)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt64"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt64, io : IO)","args_html":"(int : <a href=\"../UInt64.html\">UInt64</a>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":43,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt64"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"encode(int:Int128,io:IO)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int128"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int128, io : IO)","args_html":"(int : <a href=\"../Int128.html\">Int128</a>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":44,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int128"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"encode(int:UInt128,io:IO)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt128"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt128, io : IO)","args_html":"(int : <a href=\"../UInt128.html\">UInt128</a>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":45,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt128"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}},{"html_id":"encode(int:Int8,bytes:Bytes)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int8"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int8, bytes : Bytes)","args_html":"(int : <a href=\"../Int8.html\">Int8</a>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":47,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int8"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"encode(int:UInt8,bytes:Bytes)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt8"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt8, bytes : Bytes)","args_html":"(int : <a href=\"../UInt8.html\">UInt8</a>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":48,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt8"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"encode(int:Int16,bytes:Bytes)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int16"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int16, bytes : Bytes)","args_html":"(int : <a href=\"../Int16.html\">Int16</a>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":49,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int16"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"encode(int:UInt16,bytes:Bytes)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt16"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt16, bytes : Bytes)","args_html":"(int : <a href=\"../UInt16.html\">UInt16</a>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":50,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt16"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"encode(int:Int32,bytes:Bytes)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int32"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int32, bytes : Bytes)","args_html":"(int : <a href=\"../Int32.html\">Int32</a>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":51,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int32"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"encode(int:UInt32,bytes:Bytes)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt32"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt32, bytes : Bytes)","args_html":"(int : <a href=\"../UInt32.html\">UInt32</a>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":52,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt32"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"encode(int:Int64,bytes:Bytes)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int64"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int64, bytes : Bytes)","args_html":"(int : <a href=\"../Int64.html\">Int64</a>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":53,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int64"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"encode(int:UInt64,bytes:Bytes)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt64"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt64, bytes : Bytes)","args_html":"(int : <a href=\"../UInt64.html\">UInt64</a>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":54,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt64"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"encode(int:Int128,bytes:Bytes)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"Int128"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int128, bytes : Bytes)","args_html":"(int : <a href=\"../Int128.html\">Int128</a>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":55,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int128"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"encode(int:UInt128,bytes:Bytes)-instance-method","name":"encode","abstract":true,"args":[{"name":"int","external_name":"int","restriction":"UInt128"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt128, bytes : Bytes)","args_html":"(int : <a href=\"../UInt128.html\">UInt128</a>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":56,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt128"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":""}},{"html_id":"encode(float:Float32,io:IO):Nil-instance-method","name":"encode","abstract":false,"args":[{"name":"float","external_name":"float","restriction":"Float32"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(float : Float32, io : IO) : Nil","args_html":"(float : <a href=\"../Float32.html\">Float32</a>, io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/byte_format.cr","line_number":80,"url":null},"def":{"name":"encode","args":[{"name":"float","external_name":"float","restriction":"Float32"},{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"encode(float.unsafe_as(Int32), io)"}},{"html_id":"encode(float:Float32,bytes:Bytes)-instance-method","name":"encode","abstract":false,"args":[{"name":"float","external_name":"float","restriction":"Float32"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(float : Float32, bytes : Bytes)","args_html":"(float : <a href=\"../Float32.html\">Float32</a>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":84,"url":null},"def":{"name":"encode","args":[{"name":"float","external_name":"float","restriction":"Float32"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"encode(float.unsafe_as(Int32), bytes)"}},{"html_id":"encode(float:Float64,io:IO):Nil-instance-method","name":"encode","abstract":false,"args":[{"name":"float","external_name":"float","restriction":"Float64"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(float : Float64, io : IO) : Nil","args_html":"(float : <a href=\"../Float64.html\">Float64</a>, io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/byte_format.cr","line_number":96,"url":null},"def":{"name":"encode","args":[{"name":"float","external_name":"float","restriction":"Float64"},{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"encode(float.unsafe_as(Int64), io)"}},{"html_id":"encode(float:Float64,bytes:Bytes)-instance-method","name":"encode","abstract":false,"args":[{"name":"float","external_name":"float","restriction":"Float64"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(float : Float64, bytes : Bytes)","args_html":"(float : <a href=\"../Float64.html\">Float64</a>, bytes : <a href=\"../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":100,"url":null},"def":{"name":"encode","args":[{"name":"float","external_name":"float","restriction":"Float64"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"encode(float.unsafe_as(Int64), bytes)"}}],"types":[{"html_id":"Crystal/IO/ByteFormat/BigEndian","path":"IO/ByteFormat/BigEndian.html","kind":"module","full_name":"IO::ByteFormat::BigEndian","name":"BigEndian","abstract":false,"locations":[{"filename":"src/io/byte_format.cr","line_number":116,"url":null},{"filename":"src/io/byte_format.cr","line_number":123,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"extended_modules":[{"html_id":"Crystal/IO/ByteFormat","kind":"module","full_name":"IO::ByteFormat","name":"ByteFormat"}],"namespace":{"html_id":"Crystal/IO/ByteFormat","kind":"module","full_name":"IO::ByteFormat","name":"ByteFormat"},"class_methods":[{"html_id":"decode(type:Int8.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int8.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : Int8.class, io : IO)","args_html":"(type : <span class=\"t\">Int8</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int8.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int8)\n"}},{"html_id":"decode(type:Int8.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int8.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int8.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">Int8</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int8.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nbytes.to_slice[0, 1].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int8)\n"}},{"html_id":"decode(type:UInt8.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt8.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt8.class, io : IO)","args_html":"(type : <span class=\"t\">UInt8</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt8.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt8)\n"}},{"html_id":"decode(type:UInt8.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt8.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt8.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">UInt8</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt8.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nbytes.to_slice[0, 1].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt8)\n"}},{"html_id":"decode(type:Int16.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int16.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : Int16.class, io : IO)","args_html":"(type : <span class=\"t\">Int16</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int16.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int16)\n"}},{"html_id":"decode(type:Int16.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int16.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int16.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">Int16</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int16.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nbytes.to_slice[0, 2].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int16)\n"}},{"html_id":"decode(type:UInt16.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt16.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt16.class, io : IO)","args_html":"(type : <span class=\"t\">UInt16</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt16.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt16)\n"}},{"html_id":"decode(type:UInt16.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt16.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt16.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">UInt16</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt16.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nbytes.to_slice[0, 2].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt16)\n"}},{"html_id":"decode(type:Int32.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int32.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : Int32.class, io : IO)","args_html":"(type : <span class=\"t\">Int32</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int32.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int32)\n"}},{"html_id":"decode(type:Int32.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int32.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int32.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">Int32</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int32.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nbytes.to_slice[0, 4].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int32)\n"}},{"html_id":"decode(type:UInt32.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt32.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt32.class, io : IO)","args_html":"(type : <span class=\"t\">UInt32</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt32.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt32)\n"}},{"html_id":"decode(type:UInt32.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt32.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt32.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">UInt32</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt32.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nbytes.to_slice[0, 4].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt32)\n"}},{"html_id":"decode(type:Int64.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int64.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : Int64.class, io : IO)","args_html":"(type : <span class=\"t\">Int64</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int64.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int64)\n"}},{"html_id":"decode(type:Int64.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int64.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int64.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">Int64</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int64.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nbytes.to_slice[0, 8].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int64)\n"}},{"html_id":"decode(type:UInt64.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt64.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt64.class, io : IO)","args_html":"(type : <span class=\"t\">UInt64</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt64.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt64)\n"}},{"html_id":"decode(type:UInt64.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt64.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt64.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">UInt64</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt64.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nbytes.to_slice[0, 8].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt64)\n"}},{"html_id":"decode(type:Int128.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int128.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : Int128.class, io : IO)","args_html":"(type : <span class=\"t\">Int128</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int128.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int128)\n"}},{"html_id":"decode(type:Int128.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int128.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int128.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">Int128</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int128.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nbytes.to_slice[0, 16].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int128)\n"}},{"html_id":"decode(type:UInt128.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt128.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt128.class, io : IO)","args_html":"(type : <span class=\"t\">UInt128</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt128.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt128)\n"}},{"html_id":"decode(type:UInt128.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt128.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt128.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">UInt128</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt128.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nbytes.to_slice[0, 16].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt128)\n"}},{"html_id":"encode(int:Int8,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int8"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int8, io : IO)","args_html":"(int : <a href=\"../../Int8.html\">Int8</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int8"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:Int8,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int8"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int8, bytes : Bytes)","args_html":"(int : <a href=\"../../Int8.html\">Int8</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int8"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:UInt8,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt8"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt8, io : IO)","args_html":"(int : <a href=\"../../UInt8.html\">UInt8</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt8"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:UInt8,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt8"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt8, bytes : Bytes)","args_html":"(int : <a href=\"../../UInt8.html\">UInt8</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt8"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:Int16,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int16"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int16, io : IO)","args_html":"(int : <a href=\"../../Int16.html\">Int16</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int16"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:Int16,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int16"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int16, bytes : Bytes)","args_html":"(int : <a href=\"../../Int16.html\">Int16</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int16"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:UInt16,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt16"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt16, io : IO)","args_html":"(int : <a href=\"../../UInt16.html\">UInt16</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt16"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:UInt16,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt16"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt16, bytes : Bytes)","args_html":"(int : <a href=\"../../UInt16.html\">UInt16</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt16"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:Int32,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int32"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int32, io : IO)","args_html":"(int : <a href=\"../../Int32.html\">Int32</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int32"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:Int32,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int32"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int32, bytes : Bytes)","args_html":"(int : <a href=\"../../Int32.html\">Int32</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int32"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:UInt32,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt32"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt32, io : IO)","args_html":"(int : <a href=\"../../UInt32.html\">UInt32</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt32"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:UInt32,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt32"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt32, bytes : Bytes)","args_html":"(int : <a href=\"../../UInt32.html\">UInt32</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt32"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:Int64,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int64"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int64, io : IO)","args_html":"(int : <a href=\"../../Int64.html\">Int64</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int64"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:Int64,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int64"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int64, bytes : Bytes)","args_html":"(int : <a href=\"../../Int64.html\">Int64</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int64"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:UInt64,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt64"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt64, io : IO)","args_html":"(int : <a href=\"../../UInt64.html\">UInt64</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt64"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:UInt64,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt64"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt64, bytes : Bytes)","args_html":"(int : <a href=\"../../UInt64.html\">UInt64</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt64"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:Int128,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int128"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int128, io : IO)","args_html":"(int : <a href=\"../../Int128.html\">Int128</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int128"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:Int128,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int128"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int128, bytes : Bytes)","args_html":"(int : <a href=\"../../Int128.html\">Int128</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int128"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:UInt128,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt128"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt128, io : IO)","args_html":"(int : <a href=\"../../UInt128.html\">UInt128</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt128"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:UInt128,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt128"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt128, bytes : Bytes)","args_html":"(int : <a href=\"../../UInt128.html\">UInt128</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt128"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}}]},{"html_id":"Crystal/IO/ByteFormat/LittleEndian","path":"IO/ByteFormat/LittleEndian.html","kind":"module","full_name":"IO::ByteFormat::LittleEndian","name":"LittleEndian","abstract":false,"locations":[{"filename":"src/io/byte_format.cr","line_number":112,"url":null},{"filename":"src/io/byte_format.cr","line_number":123,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"extended_modules":[{"html_id":"Crystal/IO/ByteFormat","kind":"module","full_name":"IO::ByteFormat","name":"ByteFormat"}],"namespace":{"html_id":"Crystal/IO/ByteFormat","kind":"module","full_name":"IO::ByteFormat","name":"ByteFormat"},"class_methods":[{"html_id":"decode(type:Int8.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int8.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : Int8.class, io : IO)","args_html":"(type : <span class=\"t\">Int8</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int8.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int8)\n"}},{"html_id":"decode(type:Int8.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int8.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int8.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">Int8</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int8.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nbytes.to_slice[0, 1].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int8)\n"}},{"html_id":"decode(type:UInt8.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt8.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt8.class, io : IO)","args_html":"(type : <span class=\"t\">UInt8</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt8.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt8)\n"}},{"html_id":"decode(type:UInt8.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt8.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt8.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">UInt8</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt8.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 1)\nbytes.to_slice[0, 1].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt8)\n"}},{"html_id":"decode(type:Int16.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int16.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : Int16.class, io : IO)","args_html":"(type : <span class=\"t\">Int16</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int16.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int16)\n"}},{"html_id":"decode(type:Int16.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int16.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int16.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">Int16</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int16.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nbytes.to_slice[0, 2].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int16)\n"}},{"html_id":"decode(type:UInt16.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt16.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt16.class, io : IO)","args_html":"(type : <span class=\"t\">UInt16</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt16.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt16)\n"}},{"html_id":"decode(type:UInt16.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt16.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt16.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">UInt16</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt16.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 2)\nbytes.to_slice[0, 2].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt16)\n"}},{"html_id":"decode(type:Int32.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int32.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : Int32.class, io : IO)","args_html":"(type : <span class=\"t\">Int32</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int32.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int32)\n"}},{"html_id":"decode(type:Int32.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int32.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int32.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">Int32</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int32.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nbytes.to_slice[0, 4].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int32)\n"}},{"html_id":"decode(type:UInt32.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt32.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt32.class, io : IO)","args_html":"(type : <span class=\"t\">UInt32</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt32.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt32)\n"}},{"html_id":"decode(type:UInt32.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt32.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt32.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">UInt32</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt32.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 4)\nbytes.to_slice[0, 4].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt32)\n"}},{"html_id":"decode(type:Int64.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int64.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : Int64.class, io : IO)","args_html":"(type : <span class=\"t\">Int64</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int64.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int64)\n"}},{"html_id":"decode(type:Int64.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int64.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int64.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">Int64</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int64.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nbytes.to_slice[0, 8].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int64)\n"}},{"html_id":"decode(type:UInt64.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt64.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt64.class, io : IO)","args_html":"(type : <span class=\"t\">UInt64</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt64.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt64)\n"}},{"html_id":"decode(type:UInt64.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt64.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt64.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">UInt64</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt64.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 8)\nbytes.to_slice[0, 8].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt64)\n"}},{"html_id":"decode(type:Int128.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int128.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : Int128.class, io : IO)","args_html":"(type : <span class=\"t\">Int128</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int128.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int128)\n"}},{"html_id":"decode(type:Int128.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int128.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : Int128.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">Int128</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"Int128.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nbytes.to_slice[0, 16].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(Int128)\n"}},{"html_id":"decode(type:UInt128.class,io:IO)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt128.class"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(type : UInt128.class, io : IO)","args_html":"(type : <span class=\"t\">UInt128</span>.<span class=\"k\">class</span>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt128.class"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nio.read_fully(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt128)\n"}},{"html_id":"decode(type:UInt128.class,bytes:Bytes)-class-method","name":"decode","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt128.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(type : UInt128.class, bytes : Bytes)","args_html":"(type : <span class=\"t\">UInt128</span>.<span class=\"k\">class</span>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"decode","args":[{"name":"type","external_name":"type","restriction":"UInt128.class"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nbytes.to_slice[0, 16].copy_to(buffer.to_slice)\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.unsafe_as(UInt128)\n"}},{"html_id":"encode(int:Int8,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int8"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int8, io : IO)","args_html":"(int : <a href=\"../../Int8.html\">Int8</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int8"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:Int8,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int8"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int8, bytes : Bytes)","args_html":"(int : <a href=\"../../Int8.html\">Int8</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int8"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:UInt8,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt8"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt8, io : IO)","args_html":"(int : <a href=\"../../UInt8.html\">UInt8</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt8"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:UInt8,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt8"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt8, bytes : Bytes)","args_html":"(int : <a href=\"../../UInt8.html\">UInt8</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt8"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 1))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:Int16,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int16"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int16, io : IO)","args_html":"(int : <a href=\"../../Int16.html\">Int16</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int16"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:Int16,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int16"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int16, bytes : Bytes)","args_html":"(int : <a href=\"../../Int16.html\">Int16</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int16"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:UInt16,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt16"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt16, io : IO)","args_html":"(int : <a href=\"../../UInt16.html\">UInt16</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt16"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:UInt16,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt16"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt16, bytes : Bytes)","args_html":"(int : <a href=\"../../UInt16.html\">UInt16</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt16"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 2))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:Int32,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int32"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int32, io : IO)","args_html":"(int : <a href=\"../../Int32.html\">Int32</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int32"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:Int32,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int32"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int32, bytes : Bytes)","args_html":"(int : <a href=\"../../Int32.html\">Int32</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int32"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:UInt32,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt32"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt32, io : IO)","args_html":"(int : <a href=\"../../UInt32.html\">UInt32</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt32"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:UInt32,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt32"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt32, bytes : Bytes)","args_html":"(int : <a href=\"../../UInt32.html\">UInt32</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt32"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 4))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:Int64,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int64"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int64, io : IO)","args_html":"(int : <a href=\"../../Int64.html\">Int64</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int64"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:Int64,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int64"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int64, bytes : Bytes)","args_html":"(int : <a href=\"../../Int64.html\">Int64</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int64"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:UInt64,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt64"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt64, io : IO)","args_html":"(int : <a href=\"../../UInt64.html\">UInt64</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt64"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:UInt64,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt64"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt64, bytes : Bytes)","args_html":"(int : <a href=\"../../UInt64.html\">UInt64</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt64"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 8))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:Int128,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int128"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : Int128, io : IO)","args_html":"(int : <a href=\"../../Int128.html\">Int128</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int128"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:Int128,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"Int128"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : Int128, bytes : Bytes)","args_html":"(int : <a href=\"../../Int128.html\">Int128</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"Int128"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}},{"html_id":"encode(int:UInt128,io:IO)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt128"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(int : UInt128, io : IO)","args_html":"(int : <a href=\"../../UInt128.html\">UInt128</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt128"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nio.write(buffer.to_slice)\n"}},{"html_id":"encode(int:UInt128,bytes:Bytes)-class-method","name":"encode","abstract":false,"args":[{"name":"int","external_name":"int","restriction":"UInt128"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"args_string":"(int : UInt128, bytes : Bytes)","args_html":"(int : <a href=\"../../UInt128.html\">UInt128</a>, bytes : <a href=\"../../Bytes.html\">Bytes</a>)","location":{"filename":"src/io/byte_format.cr","line_number":123,"url":null},"def":{"name":"encode","args":[{"name":"int","external_name":"int","restriction":"UInt128"},{"name":"bytes","external_name":"bytes","restriction":"Bytes"}],"visibility":"Public","body":"buffer = int.unsafe_as(StaticArray(UInt8, 16))\nif SystemEndian == self\nelse\n  buffer.reverse!\nend\nbuffer.to_slice.copy_to(bytes)\n"}}]},{"html_id":"Crystal/IO/ByteFormat/NetworkEndian","path":"IO/ByteFormat/NetworkEndian.html","kind":"alias","full_name":"IO::ByteFormat::NetworkEndian","name":"NetworkEndian","abstract":false,"locations":[{"filename":"src/io/byte_format.cr","line_number":121,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"IO::ByteFormat::BigEndian","aliased_html":"<a href=\"../../IO/ByteFormat/BigEndian.html\">IO::ByteFormat::BigEndian</a>","const":false,"namespace":{"html_id":"Crystal/IO/ByteFormat","kind":"module","full_name":"IO::ByteFormat","name":"ByteFormat"}},{"html_id":"Crystal/IO/ByteFormat/SystemEndian","path":"IO/ByteFormat/SystemEndian.html","kind":"alias","full_name":"IO::ByteFormat::SystemEndian","name":"SystemEndian","abstract":false,"locations":[{"filename":"src/io/byte_format.cr","line_number":120,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"IO::ByteFormat::LittleEndian","aliased_html":"<a href=\"../../IO/ByteFormat/LittleEndian.html\">IO::ByteFormat::LittleEndian</a>","const":false,"namespace":{"html_id":"Crystal/IO/ByteFormat","kind":"module","full_name":"IO::ByteFormat","name":"ByteFormat"}}]},{"html_id":"Crystal/IO/Delimited","path":"IO/Delimited.html","kind":"class","full_name":"IO::Delimited","name":"Delimited","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/io/delimited.cr","line_number":14,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"An `IO` that wraps another `IO`, and only reads up to the beginning of a\nspecified delimiter.\n\nThis is useful for exposing part of an underlying stream to a client.\n\n```\nio = IO::Memory.new \"abc||123\"\ndelimited = IO::Delimited.new(io, read_delimiter: \"||\")\n\ndelimited.gets_to_end # => \"abc\"\ndelimited.gets_to_end # => \"\"\nio.gets_to_end        # => \"123\"\n```","summary":"<p>An <code><a href=\"../IO.html\">IO</a></code> that wraps another <code><a href=\"../IO.html\">IO</a></code>, and only reads up to the beginning of a specified delimiter.</p>","constructors":[{"html_id":"new(io:IO,read_delimiter:String,sync_close:Bool=false)-class-method","name":"new","doc":"Creates a new `IO::Delimited` which wraps *io*, and can read until the\nbyte sequence *read_delimiter* (interpreted as UTF-8) is found. If\n*sync_close* is set, calling `#close` calls `#close` on the underlying\n`IO`.","summary":"<p>Creates a new <code><a href=\"../IO/Delimited.html\">IO::Delimited</a></code> which wraps <em>io</em>, and can read until the byte sequence <em>read_delimiter</em> (interpreted as UTF-8) is found.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"read_delimiter","external_name":"read_delimiter","restriction":"String"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"}],"args_string":"(io : IO, read_delimiter : String, sync_close : Bool = false)","args_html":"(io : <a href=\"../IO.html\">IO</a>, read_delimiter : <a href=\"../String.html\">String</a>, sync_close : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>)","location":{"filename":"src/io/delimited.cr","line_number":28,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"read_delimiter","external_name":"read_delimiter","restriction":"String"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"}],"visibility":"Public","body":"new(io, read_delimiter.to_slice, sync_close)"}},{"html_id":"new(io:IO,read_delimiter:Bytes,sync_close:Bool=false)-class-method","name":"new","doc":"Creates a new `IO::Delimited` which wraps *io*, and can read until the\nbyte sequence *read_delimiter* is found. If *sync_close* is set, calling\n`#close` calls `#close` on the underlying `IO`.","summary":"<p>Creates a new <code><a href=\"../IO/Delimited.html\">IO::Delimited</a></code> which wraps <em>io</em>, and can read until the byte sequence <em>read_delimiter</em> is found.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"read_delimiter","external_name":"read_delimiter","restriction":"Bytes"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"}],"args_string":"(io : IO, read_delimiter : Bytes, sync_close : Bool = false)","args_html":"(io : <a href=\"../IO.html\">IO</a>, read_delimiter : <a href=\"../Bytes.html\">Bytes</a>, sync_close : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>)","location":{"filename":"src/io/delimited.cr","line_number":35,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"read_delimiter","external_name":"read_delimiter","restriction":"Bytes"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, read_delimiter, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes this `IO`.\n\n`IO` defines this is a no-op method, but including types may override.","summary":"<p>Closes this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io/delimited.cr","line_number":114,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nif @sync_close\n  @io.close\nend\n"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this `IO` is closed.\n\n`IO` defines returns `false`, but including types may override.","summary":"<p>Returns <code>true</code> if this <code><a href=\"../IO.html\">IO</a></code> is closed.</p>","abstract":false,"location":{"filename":"src/io/delimited.cr","line_number":19,"url":null},"def":{"name":"closed?","return_type":"Bool","visibility":"Public","body":"@closed"}},{"html_id":"read(slice:Bytes):Int32-instance-method","name":"read","doc":"Reads at most *slice.size* bytes from this `IO` into *slice*.\nReturns the number of bytes read, which is 0 if and only if there is no\nmore data to read (so checking for 0 is the way to detect end of file).\n\n```\nio = IO::Memory.new \"hello\"\nslice = Bytes.new(4)\nio.read(slice) # => 4\nslice          # => Bytes[104, 101, 108, 108]\nio.read(slice) # => 1\nslice          # => Bytes[111, 101, 108, 108]\nio.read(slice) # => 0\n```","summary":"<p>Reads at most <em>slice.size</em> bytes from this <code><a href=\"../IO.html\">IO</a></code> into <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Int32","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/io/delimited.cr","line_number":45,"url":null},"def":{"name":"read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Int32","visibility":"Public","body":"check_open\nif @finished\n  return 0\nend\nfirst_byte = @read_delimiter[0]\nread_bytes = 0\nwhile read_bytes < slice.size\n  if @active_delimiter_buffer.size > 0\n    byte = @active_delimiter_buffer[0]\n    @active_delimiter_buffer = @active_delimiter_buffer + 1\n  else\n    byte = @io.read_byte\n  end\n  if byte.nil?\n    break\n  end\n  if (byte == first_byte) && (@delimiter_buffer.size == @read_delimiter.size)\n    buffer = @delimiter_buffer\n    buffer[0] = byte\n    read_start = 1\n    if @active_delimiter_buffer.size > 0\n      (buffer + 1).move_from(@active_delimiter_buffer)\n      read_start = read_start + @active_delimiter_buffer.size\n    end\n    read_buffer = buffer + read_start\n    bytes = 0\n    while read_buffer.size > 0\n      partial_bytes = @io.read(read_buffer)\n      if partial_bytes == 0\n        break\n      end\n      read_buffer = read_buffer + partial_bytes\n      bytes = bytes + partial_bytes\n    end\n    if bytes != (buffer.size - read_start)\n      buffer = buffer[0, read_start + bytes]\n    end\n    if buffer == @read_delimiter\n      @finished = true\n      return read_bytes\n    end\n    @delimiter_buffer = buffer\n    @active_delimiter_buffer = buffer + 1\n  end\n  slice[read_bytes] = byte\n  read_bytes = read_bytes + 1\nend\nread_bytes\n"}},{"html_id":"read_delimiter:Slice(UInt8)-instance-method","name":"read_delimiter","abstract":false,"location":{"filename":"src/io/delimited.cr","line_number":18,"url":null},"def":{"name":"read_delimiter","visibility":"Public","body":"@read_delimiter"}},{"html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`.","summary":"<p>If <code><a href=\"../IO/Delimited.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","args_html":"(sync_close)","location":{"filename":"src/io/delimited.cr","line_number":16,"url":null},"def":{"name":"sync_close=","args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"visibility":"Public","body":"@sync_close = sync_close"}},{"html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`.","summary":"<p>If <code><a href=\"../IO/Delimited.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io/delimited.cr","line_number":16,"url":null},"def":{"name":"sync_close?","visibility":"Public","body":"@sync_close"}},{"html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"Writes the contents of *slice* into this `IO`.\n\n```\nio = IO::Memory.new\nslice = Bytes.new(4) { |i| ('a'.ord + i).to_u8 }\nio.write(slice)\nio.to_s # => \"abcd\"\n```","summary":"<p>Writes the contents of <em>slice</em> into this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/delimited.cr","line_number":110,"url":null},"def":{"name":"write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"raise(IO::Error.new(\"Can't write to IO::Delimited\"))"}}]},{"html_id":"Crystal/IO/Digest","path":"IO/Digest.html","kind":"class","full_name":"IO::Digest","name":"Digest","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/digest/io_digest.cr","line_number":17,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"Wraps an `IO` by calculating a specified `Digest` on read or write operations.\n\n### Example\n\n```\nrequire \"digest\"\n\nunderlying_io = IO::Memory.new(\"foo\")\nio = IO::Digest.new(underlying_io, Digest::SHA256.new)\nbuffer = Bytes.new(256)\nio.read(buffer)\nio.final.hexstring # => \"2c26b46b68ffc68ff99b453c1d30413413422d706483bfa0f98a5e886266e7ae\"\n```","summary":"<p>Wraps an <code><a href=\"../IO.html\">IO</a></code> by calculating a specified <code><a href=\"../IO/Digest.html\">Digest</a></code> on read or write operations.</p>","constructors":[{"html_id":"new(io:IO,digest_algorithm:::Digest,mode=DigestMode::Read)-class-method","name":"new","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"digest_algorithm","external_name":"digest_algorithm","restriction":"::Digest"},{"name":"mode","default_value":"DigestMode::Read","external_name":"mode","restriction":""}],"args_string":"(io : IO, digest_algorithm : ::Digest, mode = DigestMode::Read)","args_html":"(io : <a href=\"../IO.html\">IO</a>, digest_algorithm : <a href=\"../Digest.html\">::Digest</a>, mode = <span class=\"t\">DigestMode</span><span class=\"t\">::</span><span class=\"t\">Read</span>)","location":{"filename":"src/digest/io_digest.cr","line_number":30,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"digest_algorithm","external_name":"digest_algorithm","restriction":"::Digest"},{"name":"mode","default_value":"DigestMode::Read","external_name":"mode","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, digest_algorithm, mode)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"close(*args,**options)-instance-method","name":"close","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/digest/io_digest.cr","line_number":22,"url":null},"def":{"name":"close","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"@io.close(*args, **options)"}},{"html_id":"close(*args,**options,&)-instance-method","name":"close","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/digest/io_digest.cr","line_number":22,"url":null},"def":{"name":"close","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"@io.close(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"closed?(*args,**options)-instance-method","name":"closed?","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/digest/io_digest.cr","line_number":22,"url":null},"def":{"name":"closed?","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"@io.closed?(*args, **options)"}},{"html_id":"closed?(*args,**options,&)-instance-method","name":"closed?","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/digest/io_digest.cr","line_number":22,"url":null},"def":{"name":"closed?","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"@io.closed?(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"digest_algorithm:::Digest-instance-method","name":"digest_algorithm","abstract":false,"location":{"filename":"src/digest/io_digest.cr","line_number":19,"url":null},"def":{"name":"digest_algorithm","return_type":"::Digest","visibility":"Public","body":"@digest_algorithm"}},{"html_id":"final(*args,**options)-instance-method","name":"final","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/digest/io_digest.cr","line_number":23,"url":null},"def":{"name":"final","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"@digest_algorithm.final(*args, **options)"}},{"html_id":"final(*args,**options,&)-instance-method","name":"final","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/digest/io_digest.cr","line_number":23,"url":null},"def":{"name":"final","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"@digest_algorithm.final(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"flush(*args,**options)-instance-method","name":"flush","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/digest/io_digest.cr","line_number":22,"url":null},"def":{"name":"flush","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"@io.flush(*args, **options)"}},{"html_id":"flush(*args,**options,&)-instance-method","name":"flush","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/digest/io_digest.cr","line_number":22,"url":null},"def":{"name":"flush","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"@io.flush(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"io:IO-instance-method","name":"io","abstract":false,"location":{"filename":"src/digest/io_digest.cr","line_number":18,"url":null},"def":{"name":"io","return_type":"IO","visibility":"Public","body":"@io"}},{"html_id":"mode:DigestMode-instance-method","name":"mode","abstract":false,"location":{"filename":"src/digest/io_digest.cr","line_number":20,"url":null},"def":{"name":"mode","return_type":"DigestMode","visibility":"Public","body":"@mode"}},{"html_id":"peek(*args,**options)-instance-method","name":"peek","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/digest/io_digest.cr","line_number":22,"url":null},"def":{"name":"peek","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"@io.peek(*args, **options)"}},{"html_id":"peek(*args,**options,&)-instance-method","name":"peek","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/digest/io_digest.cr","line_number":22,"url":null},"def":{"name":"peek","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"@io.peek(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"read(slice:Bytes):Int32-instance-method","name":"read","doc":"Reads at most *slice.size* bytes from this `IO` into *slice*.\nReturns the number of bytes read, which is 0 if and only if there is no\nmore data to read (so checking for 0 is the way to detect end of file).\n\n```\nio = IO::Memory.new \"hello\"\nslice = Bytes.new(4)\nio.read(slice) # => 4\nslice          # => Bytes[104, 101, 108, 108]\nio.read(slice) # => 1\nslice          # => Bytes[111, 101, 108, 108]\nio.read(slice) # => 0\n```","summary":"<p>Reads at most <em>slice.size</em> bytes from this <code><a href=\"../IO.html\">IO</a></code> into <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Int32","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/digest/io_digest.cr","line_number":33,"url":null},"def":{"name":"read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Int32","visibility":"Public","body":"read_bytes = (io.read(slice)).to_i32\nif @mode.read?\n  digest_algorithm.update(slice[0, read_bytes])\nend\nread_bytes\n"}},{"html_id":"rewind(*args,**options)-instance-method","name":"rewind","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/digest/io_digest.cr","line_number":22,"url":null},"def":{"name":"rewind","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"@io.rewind(*args, **options)"}},{"html_id":"rewind(*args,**options,&)-instance-method","name":"rewind","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/digest/io_digest.cr","line_number":22,"url":null},"def":{"name":"rewind","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"@io.rewind(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"tty?(*args,**options)-instance-method","name":"tty?","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/digest/io_digest.cr","line_number":22,"url":null},"def":{"name":"tty?","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"@io.tty?(*args, **options)"}},{"html_id":"tty?(*args,**options,&)-instance-method","name":"tty?","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/digest/io_digest.cr","line_number":22,"url":null},"def":{"name":"tty?","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"@io.tty?(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"Writes the contents of *slice* into this `IO`.\n\n```\nio = IO::Memory.new\nslice = Bytes.new(4) { |i| ('a'.ord + i).to_u8 }\nio.write(slice)\nio.to_s # => \"abcd\"\n```","summary":"<p>Writes the contents of <em>slice</em> into this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/digest/io_digest.cr","line_number":41,"url":null},"def":{"name":"write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"if slice.empty?\n  return\nend\nif @mode.write?\n  digest_algorithm.update(slice)\nend\nio.write(slice)\n"}}],"types":[{"html_id":"Crystal/IO/Digest/DigestMode","path":"IO/Digest/DigestMode.html","kind":"enum","full_name":"IO::Digest::DigestMode","name":"DigestMode","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/digest/io_digest.cr","line_number":25,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Read","name":"Read","value":"0"},{"id":"Write","name":"Write","value":"1"}],"namespace":{"html_id":"Crystal/IO/Digest","kind":"class","full_name":"IO::Digest","name":"Digest"},"instance_methods":[{"html_id":"read?-instance-method","name":"read?","abstract":false,"location":{"filename":"src/digest/io_digest.cr","line_number":26,"url":null},"def":{"name":"read?","visibility":"Public","body":"self == Read"}},{"html_id":"write?-instance-method","name":"write?","abstract":false,"location":{"filename":"src/digest/io_digest.cr","line_number":27,"url":null},"def":{"name":"write?","visibility":"Public","body":"self == Write"}}]}]},{"html_id":"Crystal/IO/EncodingOptions","path":"IO/EncodingOptions.html","kind":"struct","full_name":"IO::EncodingOptions","name":"EncodingOptions","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/io/encoding.cr","line_number":7,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"Has the `name` and the `invalid` option.","summary":"<p>Has the <code><a href=\"../IO/EncodingOptions.html#name%3AString-instance-method\">#name</a></code> and the <code><a href=\"../IO/EncodingOptions.html#invalid%3ASymbol%3F-instance-method\">#invalid</a></code> option.</p>","class_methods":[{"html_id":"check_invalid(invalid):Nil-class-method","name":"check_invalid","abstract":false,"args":[{"name":"invalid","external_name":"invalid","restriction":""}],"args_string":"(invalid) : Nil","args_html":"(invalid) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/encoding.cr","line_number":15,"url":null},"def":{"name":"check_invalid","args":[{"name":"invalid","external_name":"invalid","restriction":""}],"return_type":"Nil","visibility":"Public","body":"if invalid && (invalid != (:skip))\n  raise(ArgumentError.new(\"Valid values for `invalid` option are `nil` and `:skip`, not #{invalid.inspect}\"))\nend"}}],"constructors":[{"html_id":"new(name:String,invalid:Symbol?)-class-method","name":"new","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"invalid","external_name":"invalid","restriction":"Symbol | ::Nil"}],"args_string":"(name : String, invalid : Symbol?)","args_html":"(name : <a href=\"../String.html\">String</a>, invalid : <a href=\"../Symbol.html\">Symbol</a>?)","location":{"filename":"src/io/encoding.cr","line_number":11,"url":null},"def":{"name":"new","args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"invalid","external_name":"invalid","restriction":"Symbol | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(name, invalid)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"invalid:Symbol?-instance-method","name":"invalid","abstract":false,"location":{"filename":"src/io/encoding.cr","line_number":9,"url":null},"def":{"name":"invalid","return_type":"Symbol | ::Nil","visibility":"Public","body":"@invalid"}},{"html_id":"name:String-instance-method","name":"name","abstract":false,"location":{"filename":"src/io/encoding.cr","line_number":8,"url":null},"def":{"name":"name","return_type":"String","visibility":"Public","body":"@name"}}]},{"html_id":"Crystal/IO/EOFError","path":"IO/EOFError.html","kind":"class","full_name":"IO::EOFError","name":"EOFError","abstract":false,"superclass":{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},{"html_id":"Crystal/SystemError","kind":"module","full_name":"SystemError","name":"SystemError"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/io/error.cr","line_number":15,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"constructors":[{"html_id":"new(message=\"Endoffilereached\")-class-method","name":"new","abstract":false,"args":[{"name":"message","default_value":"\"End of file reached\"","external_name":"message","restriction":""}],"args_string":"(message = \"End of file reached\")","args_html":"(message = <span class=\"s\">&quot;End of file reached&quot;</span>)","location":{"filename":"src/io/error.cr","line_number":16,"url":null},"def":{"name":"new","args":[{"name":"message","default_value":"\"End of file reached\"","external_name":"message","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]},{"html_id":"Crystal/IO/Error","path":"IO/Error.html","kind":"class","full_name":"IO::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/SystemError","kind":"module","full_name":"SystemError","name":"SystemError"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/io/error.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/SystemError","kind":"module","full_name":"SystemError","name":"SystemError"}],"extended_modules":[{"html_id":"Crystal/SystemError/ClassMethods","kind":"module","full_name":"SystemError::ClassMethods","name":"ClassMethods"}],"subclasses":[{"html_id":"Crystal/File/Error","kind":"class","full_name":"File::Error","name":"Error"},{"html_id":"Crystal/IO/EOFError","kind":"class","full_name":"IO::EOFError","name":"EOFError"},{"html_id":"Crystal/IO/TimeoutError","kind":"class","full_name":"IO::TimeoutError","name":"TimeoutError"},{"html_id":"Crystal/Socket/Error","kind":"class","full_name":"Socket::Error","name":"Error"}],"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"}},{"html_id":"Crystal/IO/Evented","path":"IO/Evented.html","kind":"module","full_name":"IO::Evented","name":"Evented","abstract":false,"locations":[{"filename":"src/io/evented.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"instance_methods":[{"html_id":"evented_close:Nil-instance-method","name":"evented_close","abstract":false,"location":{"filename":"src/io/evented.cr","line_number":172,"url":null},"def":{"name":"evented_close","return_type":"Nil","visibility":"Public","body":"@read_event.consume_each(&.free)\n@write_event.consume_each(&.free)\n@readers.consume_each do |readers|\n  Crystal::Scheduler.enqueue(readers)\nend\n@writers.consume_each do |writers|\n  Crystal::Scheduler.enqueue(writers)\nend\n"}},{"html_id":"evented_read(slice:Bytes,errno_msg:String,&):Int32-instance-method","name":"evented_read","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"},{"name":"errno_msg","external_name":"errno_msg","restriction":"String"}],"args_string":"(slice : Bytes, errno_msg : String, &) : Int32","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>, errno_msg : <a href=\"../String.html\">String</a>, &) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/io/evented.cr","line_number":50,"url":null},"def":{"name":"evented_read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"},{"name":"errno_msg","external_name":"errno_msg","restriction":"String"}],"yields":1,"return_type":"Int32","visibility":"Public","body":"begin\n  loop do\n    bytes_read = yield slice\n    if bytes_read != -1\n      return bytes_read.to_i32\n    end\n    if Errno.value == Errno::EAGAIN\n      wait_readable\n    else\n      raise(IO::Error.from_errno(errno_msg))\n    end\n  end\nensure\n  resume_pending_readers\nend"}},{"html_id":"evented_reopen:Nil-instance-method","name":"evented_reopen","abstract":false,"location":{"filename":"src/io/evented.cr","line_number":168,"url":null},"def":{"name":"evented_reopen","return_type":"Nil","visibility":"Public","body":"evented_close"}},{"html_id":"evented_send(slice:Bytes,errno_msg:String,&):Int32-instance-method","name":"evented_send","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"},{"name":"errno_msg","external_name":"errno_msg","restriction":"String"}],"args_string":"(slice : Bytes, errno_msg : String, &) : Int32","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>, errno_msg : <a href=\"../String.html\">String</a>, &) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/io/evented.cr","line_number":91,"url":null},"def":{"name":"evented_send","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"},{"name":"errno_msg","external_name":"errno_msg","restriction":"String"}],"yields":1,"return_type":"Int32","visibility":"Public","body":"begin\n  bytes_written = yield slice\n  if bytes_written == -1\n    raise(Socket::Error.from_errno(errno_msg))\n  end\n  bytes_written.to_i32\nensure\n  resume_pending_writers\nend"}},{"html_id":"evented_write(slice:Bytes,errno_msg:String,&):Nil-instance-method","name":"evented_write","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"},{"name":"errno_msg","external_name":"errno_msg","restriction":"String"}],"args_string":"(slice : Bytes, errno_msg : String, &) : Nil","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>, errno_msg : <a href=\"../String.html\">String</a>, &) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/evented.cr","line_number":68,"url":null},"def":{"name":"evented_write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"},{"name":"errno_msg","external_name":"errno_msg","restriction":"String"}],"yields":1,"return_type":"Nil","visibility":"Public","body":"if slice.empty?\n  return\nend\nbegin\n  loop do\n    bytes_written = (yield slice).to_i64\n    if bytes_written != -1\n      slice = slice + bytes_written\n      if slice.size == 0\n        return\n      end\n    else\n      if Errno.value == Errno::EAGAIN\n        wait_writable\n      else\n        raise(IO::Error.from_errno(errno_msg))\n      end\n    end\n  end\nensure\n  resume_pending_writers\nend\n"}},{"html_id":"read_timeout:Time::Span?-instance-method","name":"read_timeout","doc":"Returns the time to wait when reading before raising an `IO::TimeoutError`.","summary":"<p>Returns the time to wait when reading before raising an <code><a href=\"../IO/TimeoutError.html\">IO::TimeoutError</a></code>.</p>","abstract":false,"location":{"filename":"src/io/evented.cr","line_number":19,"url":null},"def":{"name":"read_timeout","return_type":"Time::Span | ::Nil","visibility":"Public","body":"@read_timeout"}},{"html_id":"read_timeout=(read_timeout:Number):Number-instance-method","name":"read_timeout=","doc":"Sets the number of seconds to wait when reading before raising an `IO::TimeoutError`.","summary":"<p>Sets the number of seconds to wait when reading before raising an <code><a href=\"../IO/TimeoutError.html\">IO::TimeoutError</a></code>.</p>","abstract":false,"args":[{"name":"read_timeout","external_name":"read_timeout","restriction":"Number"}],"args_string":"(read_timeout : Number) : Number","args_html":"(read_timeout : <a href=\"../Number.html\">Number</a>) : <a href=\"../Number.html\">Number</a>","location":{"filename":"src/io/evented.cr","line_number":29,"url":null},"def":{"name":"read_timeout=","args":[{"name":"read_timeout","external_name":"read_timeout","restriction":"Number"}],"return_type":"Number","visibility":"Public","body":"self.read_timeout = read_timeout.seconds\nread_timeout\n"}},{"html_id":"read_timeout=(timeout:Time::Span?):Time::Span?-instance-method","name":"read_timeout=","doc":"Sets the time to wait when reading before raising an `IO::TimeoutError`.","summary":"<p>Sets the time to wait when reading before raising an <code><a href=\"../IO/TimeoutError.html\">IO::TimeoutError</a></code>.</p>","abstract":false,"args":[{"name":"timeout","external_name":"timeout","restriction":"Time::Span | ::Nil"}],"args_string":"(timeout : Time::Span?) : Time::Span?","args_html":"(timeout : <a href=\"../Time/Span.html\">Time::Span</a>?) : <a href=\"../Time/Span.html\">Time::Span</a>?","location":{"filename":"src/io/evented.cr","line_number":24,"url":null},"def":{"name":"read_timeout=","args":[{"name":"timeout","external_name":"timeout","restriction":"Time::Span | ::Nil"}],"return_type":"::Time::Span | ::Nil","visibility":"Public","body":"@read_timeout = timeout"}},{"html_id":"write_timeout:Time::Span?-instance-method","name":"write_timeout","doc":"Returns the time to wait when writing before raising an `IO::TimeoutError`.","summary":"<p>Returns the time to wait when writing before raising an <code><a href=\"../IO/TimeoutError.html\">IO::TimeoutError</a></code>.</p>","abstract":false,"location":{"filename":"src/io/evented.cr","line_number":35,"url":null},"def":{"name":"write_timeout","return_type":"Time::Span | ::Nil","visibility":"Public","body":"@write_timeout"}},{"html_id":"write_timeout=(write_timeout:Number):Number-instance-method","name":"write_timeout=","doc":"Sets the number of seconds to wait when writing before raising an `IO::TimeoutError`.","summary":"<p>Sets the number of seconds to wait when writing before raising an <code><a href=\"../IO/TimeoutError.html\">IO::TimeoutError</a></code>.</p>","abstract":false,"args":[{"name":"write_timeout","external_name":"write_timeout","restriction":"Number"}],"args_string":"(write_timeout : Number) : Number","args_html":"(write_timeout : <a href=\"../Number.html\">Number</a>) : <a href=\"../Number.html\">Number</a>","location":{"filename":"src/io/evented.cr","line_number":45,"url":null},"def":{"name":"write_timeout=","args":[{"name":"write_timeout","external_name":"write_timeout","restriction":"Number"}],"return_type":"Number","visibility":"Public","body":"self.write_timeout = write_timeout.seconds\nwrite_timeout\n"}},{"html_id":"write_timeout=(timeout:Time::Span?):Time::Span?-instance-method","name":"write_timeout=","doc":"Sets the time to wait when writing before raising an `IO::TimeoutError`.","summary":"<p>Sets the time to wait when writing before raising an <code><a href=\"../IO/TimeoutError.html\">IO::TimeoutError</a></code>.</p>","abstract":false,"args":[{"name":"timeout","external_name":"timeout","restriction":"Time::Span | ::Nil"}],"args_string":"(timeout : Time::Span?) : Time::Span?","args_html":"(timeout : <a href=\"../Time/Span.html\">Time::Span</a>?) : <a href=\"../Time/Span.html\">Time::Span</a>?","location":{"filename":"src/io/evented.cr","line_number":40,"url":null},"def":{"name":"write_timeout=","args":[{"name":"timeout","external_name":"timeout","restriction":"Time::Span | ::Nil"}],"return_type":"::Time::Span | ::Nil","visibility":"Public","body":"@write_timeout = timeout"}}]},{"html_id":"Crystal/IO/FileDescriptor","path":"IO/FileDescriptor.html","kind":"class","full_name":"IO::FileDescriptor","name":"FileDescriptor","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"Crystal/Crystal/System/FileDescriptor","kind":"module","full_name":"Crystal::System::FileDescriptor","name":"FileDescriptor"},{"html_id":"Crystal/IO/Evented","kind":"module","full_name":"IO::Evented","name":"Evented"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/io/console.cr","line_number":5,"url":null},{"filename":"src/io/file_descriptor.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Crystal/System/FileDescriptor","kind":"module","full_name":"Crystal::System::FileDescriptor","name":"FileDescriptor"},{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"}],"subclasses":[{"html_id":"Crystal/File","kind":"class","full_name":"File","name":"File"}],"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"An `IO` over a file descriptor.","summary":"<p>An <code><a href=\"../IO.html\">IO</a></code> over a file descriptor.</p>","class_methods":[{"html_id":"fcntl(fd,cmd,arg=0)-class-method","name":"fcntl","abstract":false,"args":[{"name":"fd","external_name":"fd","restriction":""},{"name":"cmd","external_name":"cmd","restriction":""},{"name":"arg","default_value":"0","external_name":"arg","restriction":""}],"args_string":"(fd, cmd, arg = 0)","args_html":"(fd, cmd, arg = <span class=\"n\">0</span>)","location":{"filename":"src/io/file_descriptor.cr","line_number":54,"url":null},"def":{"name":"fcntl","args":[{"name":"fd","external_name":"fd","restriction":""},{"name":"cmd","external_name":"cmd","restriction":""},{"name":"arg","default_value":"0","external_name":"arg","restriction":""}],"visibility":"Public","body":"Crystal::System::FileDescriptor.fcntl(fd, cmd, arg)"}}],"constructors":[{"html_id":"new(fd,blocking=nil)-class-method","name":"new","abstract":false,"args":[{"name":"fd","external_name":"fd","restriction":""},{"name":"blocking","default_value":"nil","external_name":"blocking","restriction":""}],"args_string":"(fd, blocking = nil)","args_html":"(fd, blocking = <span class=\"n\">nil</span>)","location":{"filename":"src/io/file_descriptor.cr","line_number":14,"url":null},"def":{"name":"new","args":[{"name":"fd","external_name":"fd","restriction":""},{"name":"blocking","default_value":"nil","external_name":"blocking","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(fd, blocking)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"blocking-instance-method","name":"blocking","abstract":false,"location":{"filename":"src/io/file_descriptor.cr","line_number":38,"url":null},"def":{"name":"blocking","visibility":"Public","body":"system_blocking?"}},{"html_id":"blocking=(value)-instance-method","name":"blocking=","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/io/file_descriptor.cr","line_number":42,"url":null},"def":{"name":"blocking=","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"self.system_blocking = value"}},{"html_id":"close_on_exec=(value:Bool)-instance-method","name":"close_on_exec=","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Bool"}],"args_string":"(value : Bool)","args_html":"(value : <a href=\"../Bool.html\">Bool</a>)","location":{"filename":"src/io/file_descriptor.cr","line_number":50,"url":null},"def":{"name":"close_on_exec=","args":[{"name":"value","external_name":"value","restriction":"Bool"}],"visibility":"Public","body":"self.system_close_on_exec = value"}},{"html_id":"close_on_exec?:Bool-instance-method","name":"close_on_exec?","abstract":false,"location":{"filename":"src/io/file_descriptor.cr","line_number":46,"url":null},"def":{"name":"close_on_exec?","return_type":"Bool","visibility":"Public","body":"system_close_on_exec?"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this `IO` is closed.\n\n`IO` defines returns `false`, but including types may override.","summary":"<p>Returns <code>true</code> if this <code><a href=\"../IO.html\">IO</a></code> is closed.</p>","abstract":false,"location":{"filename":"src/io/file_descriptor.cr","line_number":196,"url":null},"def":{"name":"closed?","return_type":"Bool","visibility":"Public","body":"@closed"}},{"html_id":"cooked(&)-instance-method","name":"cooked","doc":"Enables character processing for the duration of the given block.\nThe so called cooked mode is the standard behavior of a terminal,\ndoing line wise editing by the terminal and only sending the input to\nthe program on a newline.\nOnly call this when this IO is a TTY, such as a not redirected stdin.","summary":"<p>Enables character processing for the duration of the given block.</p>","abstract":false,"location":{"filename":"src/io/console.cr","line_number":42,"url":null},"def":{"name":"cooked","yields":1,"visibility":"Public","body":"preserving_tc_mode(\"can't set IO#cooked\") do |mode|\n  cooked_from_tc_mode!\n  yield self\nend"}},{"html_id":"cooked!:Nil-instance-method","name":"cooked!","doc":"Enables character processing for this IO.\nThe so called cooked mode is the standard behavior of a terminal,\ndoing line wise editing by the terminal and only sending the input to\nthe program on a newline.\nOnly call this when this IO is a TTY, such as a not redirected stdin.","summary":"<p>Enables character processing for this IO.</p>","abstract":false,"location":{"filename":"src/io/console.cr","line_number":54,"url":null},"def":{"name":"cooked!","return_type":"Nil","visibility":"Public","body":"if (LibC.tcgetattr(fd, out mode)) != 0\n  raise(IO::Error.from_errno(\"can't set IO#cooked!\"))\nend\ncooked_from_tc_mode!\n"}},{"html_id":"fcntl(cmd,arg=0)-instance-method","name":"fcntl","abstract":false,"args":[{"name":"cmd","external_name":"cmd","restriction":""},{"name":"arg","default_value":"0","external_name":"arg","restriction":""}],"args_string":"(cmd, arg = 0)","args_html":"(cmd, arg = <span class=\"n\">0</span>)","location":{"filename":"src/io/file_descriptor.cr","line_number":54,"url":null},"def":{"name":"fcntl","args":[{"name":"cmd","external_name":"cmd","restriction":""},{"name":"arg","default_value":"0","external_name":"arg","restriction":""}],"visibility":"Public","body":"Crystal::System::FileDescriptor.fcntl(fd, cmd, arg)"}},{"html_id":"fd:Int-instance-method","name":"fd","doc":"The raw file-descriptor. It is defined to be an `Int`, but its size is\nplatform-specific.","summary":"<p>The raw file-descriptor.</p>","abstract":false,"location":{"filename":"src/io/file_descriptor.cr","line_number":10,"url":null},"def":{"name":"fd","return_type":"Int","visibility":"Public","body":"@volatile_fd.get"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/io/file_descriptor.cr","line_number":190,"url":null},"def":{"name":"finalize","visibility":"Public","body":"if closed?\n  return\nend\nbegin\n  close\nrescue\n  nil\nend\n"}},{"html_id":"flock_exclusive(blocking=true,&)-instance-method","name":"flock_exclusive","abstract":false,"args":[{"name":"blocking","default_value":"true","external_name":"blocking","restriction":""}],"args_string":"(blocking = true, &)","args_html":"(blocking = <span class=\"n\">true</span>, &)","location":{"filename":"src/io/file_descriptor.cr","line_number":170,"url":null},"def":{"name":"flock_exclusive","args":[{"name":"blocking","default_value":"true","external_name":"blocking","restriction":""}],"yields":0,"visibility":"Public","body":"flock_exclusive(blocking)\nbegin\n  yield\nensure\n  flock_unlock\nend\n"}},{"html_id":"flock_exclusive(blocking=true):Nil-instance-method","name":"flock_exclusive","doc":"Places an exclusive advisory lock. Only one process may hold an exclusive lock for a given file descriptor at a given time.\n`IO::Error` is raised if *blocking* is set to `false` and any existing lock is set.","summary":"<p>Places an exclusive advisory lock.</p>","abstract":false,"args":[{"name":"blocking","default_value":"true","external_name":"blocking","restriction":""}],"args_string":"(blocking = true) : Nil","args_html":"(blocking = <span class=\"n\">true</span>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/file_descriptor.cr","line_number":181,"url":null},"def":{"name":"flock_exclusive","args":[{"name":"blocking","default_value":"true","external_name":"blocking","restriction":""}],"return_type":"Nil","visibility":"Public","body":"system_flock_exclusive(blocking)"}},{"html_id":"flock_shared(blocking=true,&)-instance-method","name":"flock_shared","abstract":false,"args":[{"name":"blocking","default_value":"true","external_name":"blocking","restriction":""}],"args_string":"(blocking = true, &)","args_html":"(blocking = <span class=\"n\">true</span>, &)","location":{"filename":"src/io/file_descriptor.cr","line_number":155,"url":null},"def":{"name":"flock_shared","args":[{"name":"blocking","default_value":"true","external_name":"blocking","restriction":""}],"yields":0,"visibility":"Public","body":"flock_shared(blocking)\nbegin\n  yield\nensure\n  flock_unlock\nend\n"}},{"html_id":"flock_shared(blocking=true):Nil-instance-method","name":"flock_shared","doc":"Places a shared advisory lock. More than one process may hold a shared lock for a given file descriptor at a given time.\n`IO::Error` is raised if *blocking* is set to `false` and an existing exclusive lock is set.","summary":"<p>Places a shared advisory lock.</p>","abstract":false,"args":[{"name":"blocking","default_value":"true","external_name":"blocking","restriction":""}],"args_string":"(blocking = true) : Nil","args_html":"(blocking = <span class=\"n\">true</span>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/file_descriptor.cr","line_number":166,"url":null},"def":{"name":"flock_shared","args":[{"name":"blocking","default_value":"true","external_name":"blocking","restriction":""}],"return_type":"Nil","visibility":"Public","body":"system_flock_shared(blocking)"}},{"html_id":"flock_unlock:Nil-instance-method","name":"flock_unlock","doc":"Removes an existing advisory lock held by this process.","summary":"<p>Removes an existing advisory lock held by this process.</p>","abstract":false,"location":{"filename":"src/io/file_descriptor.cr","line_number":186,"url":null},"def":{"name":"flock_unlock","return_type":"Nil","visibility":"Public","body":"system_flock_unlock"}},{"html_id":"fsync(flush_metadata=true):Nil-instance-method","name":"fsync","doc":"Flushes all data written to this File Descriptor to the disk device so that\nall changed information can be retrieved even if the system\ncrashes or is rebooted. The call blocks until the device reports that\nthe transfer has completed.\nTo reduce disk activity the *flush_metadata* parameter can be set to false,\nthen the syscall *fdatasync* will be used and only data required for\nsubsequent data retrieval is flushed. Metadata such as modified time and\naccess time is not written.\n\nNOTE: Metadata is flushed even when *flush_metadata* is false on Windows\nand DragonFly BSD.","summary":"<p>Flushes all data written to this File Descriptor to the disk device so that all changed information can be retrieved even if the system crashes or is rebooted.</p>","abstract":false,"args":[{"name":"flush_metadata","default_value":"true","external_name":"flush_metadata","restriction":""}],"args_string":"(flush_metadata = true) : Nil","args_html":"(flush_metadata = <span class=\"n\">true</span>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/file_descriptor.cr","line_number":147,"url":null},"def":{"name":"fsync","args":[{"name":"flush_metadata","default_value":"true","external_name":"flush_metadata","restriction":""}],"return_type":"Nil","visibility":"Public","body":"flush\nsystem_fsync(flush_metadata)\n"}},{"html_id":"info-instance-method","name":"info","abstract":false,"location":{"filename":"src/io/file_descriptor.cr","line_number":64,"url":null},"def":{"name":"info","visibility":"Public","body":"system_info"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/file_descriptor.cr","line_number":211,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"#<IO::FileDescriptor:\"\nif closed?\n  io << \"(closed)\"\nelse\n  (io << \" fd=\") << fd\nend\nio << '>'\n"}},{"html_id":"noecho(&)-instance-method","name":"noecho","doc":"Turns off character echoing for the duration of the given block.\nThis will prevent displaying back to the user what they enter on the terminal.\nOnly call this when this IO is a TTY, such as a not redirected stdin.\n\n```\nprint \"Enter password: \"\npassword = STDIN.noecho &.gets.try &.chomp\nputs\n```","summary":"<p>Turns off character echoing for the duration of the given block.</p>","abstract":false,"location":{"filename":"src/io/console.cr","line_number":15,"url":null},"def":{"name":"noecho","yields":1,"visibility":"Public","body":"preserving_tc_mode(\"can't set IO#noecho\") do |mode|\n  noecho_from_tc_mode!\n  yield self\nend"}},{"html_id":"noecho!-instance-method","name":"noecho!","doc":"Turns off character echoing for this IO.\nThis will prevent displaying back to the user what they enter on the terminal.\nOnly call this when this IO is a TTY, such as a not redirected stdin.","summary":"<p>Turns off character echoing for this IO.</p>","abstract":false,"location":{"filename":"src/io/console.cr","line_number":25,"url":null},"def":{"name":"noecho!","visibility":"Public","body":"if (LibC.tcgetattr(fd, out mode)) != 0\n  raise(IO::Error.from_errno(\"can't set IO#noecho!\"))\nend\nnoecho_from_tc_mode!\n"}},{"html_id":"pos:Int64-instance-method","name":"pos","doc":"Returns the current position (in bytes) in this `IO`.\n\n```\nFile.write(\"testfile\", \"hello\")\n\nfile = File.new(\"testfile\")\nfile.pos     # => 0\nfile.gets(2) # => \"he\"\nfile.pos     # => 2\n```","summary":"<p>Returns the current position (in bytes) in this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io/file_descriptor.cr","line_number":116,"url":null},"def":{"name":"pos","return_type":"Int64","visibility":"Public","body":"check_open\nsystem_pos - @in_buffer_rem.size\n"}},{"html_id":"pos=(value)-instance-method","name":"pos=","doc":"Sets the current position (in bytes) in this `IO`.\n\n```\nFile.write(\"testfile\", \"hello\")\n\nfile = File.new(\"testfile\")\nfile.pos = 3\nfile.gets_to_end # => \"lo\"\n```","summary":"<p>Sets the current position (in bytes) in this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/io/file_descriptor.cr","line_number":131,"url":null},"def":{"name":"pos=","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"seek(value)\nvalue\n"}},{"html_id":"pretty_print(pp)-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp)","args_html":"(pp)","location":{"filename":"src/io/file_descriptor.cr","line_number":221,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"visibility":"Public","body":"pp.text(inspect)"}},{"html_id":"raw(&)-instance-method","name":"raw","doc":"Enables raw mode for the duration of the given block.\nIn raw mode every keypress is directly sent to the program, no interpretation\nis done by the terminal.\nOnly call this when this IO is a TTY, such as a not redirected stdin.","summary":"<p>Enables raw mode for the duration of the given block.</p>","abstract":false,"location":{"filename":"src/io/console.cr","line_number":81,"url":null},"def":{"name":"raw","yields":1,"visibility":"Public","body":"preserving_tc_mode(\"can't set IO#raw\") do |mode|\n  raw_from_tc_mode!\n  yield self\nend"}},{"html_id":"raw!-instance-method","name":"raw!","doc":"Enables raw mode for this IO.\nIn raw mode every keypress is directly sent to the program, no interpretation\nis done by the terminal.\nOnly call this when this IO is a TTY, such as a not redirected stdin.","summary":"<p>Enables raw mode for this IO.</p>","abstract":false,"location":{"filename":"src/io/console.cr","line_number":92,"url":null},"def":{"name":"raw!","visibility":"Public","body":"if (LibC.tcgetattr(fd, out mode)) != 0\n  raise(IO::Error.from_errno(\"can't set IO#raw!\"))\nend\nraw_from_tc_mode!\n"}},{"html_id":"reopen(other:IO::FileDescriptor)-instance-method","name":"reopen","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"IO::FileDescriptor"}],"args_string":"(other : IO::FileDescriptor)","args_html":"(other : <a href=\"../IO/FileDescriptor.html\">IO::FileDescriptor</a>)","location":{"filename":"src/io/file_descriptor.cr","line_number":204,"url":null},"def":{"name":"reopen","args":[{"name":"other","external_name":"other","restriction":"IO::FileDescriptor"}],"visibility":"Public","body":"if self.fd == other.fd\n  return other\nend\nsystem_reopen(other)\nother\n"}},{"html_id":"seek(offset,whence:Seek=Seek::Set)-instance-method","name":"seek","doc":"Seeks to a given *offset* (in bytes) according to the *whence* argument.\nReturns `self`.\n\n```\nFile.write(\"testfile\", \"abc\")\n\nfile = File.new(\"testfile\")\nfile.gets(3) # => \"abc\"\nfile.seek(1, IO::Seek::Set)\nfile.gets(2) # => \"bc\"\nfile.seek(-1, IO::Seek::Current)\nfile.gets(1) # => \"c\"\n```","summary":"<p>Seeks to a given <em>offset</em> (in bytes) according to the <em>whence</em> argument.</p>","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"whence","default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"args_string":"(offset, whence : Seek = Seek::Set)","args_html":"(offset, whence : <a href=\"../IO/Seek.html\">Seek</a> = <span class=\"t\">Seek</span><span class=\"t\">::</span><span class=\"t\">Set</span>)","location":{"filename":"src/io/file_descriptor.cr","line_number":81,"url":null},"def":{"name":"seek","args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"whence","default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"visibility":"Public","body":"check_open\nflush\nif whence.current?\n  offset = offset - @in_buffer_rem.size\nend\nsystem_seek(offset, whence)\n@in_buffer_rem = Bytes.empty\nself\n"}},{"html_id":"seek(offset,whence:Seek=Seek::Set,&)-instance-method","name":"seek","doc":"Same as `seek` but yields to the block after seeking and eventually seeks\nback to the original position when the block returns.","summary":"<p>Same as <code><a href=\"../IO/FileDescriptor.html#seek%28offset%2Cwhence%3ASeek%3DSeek%3A%3ASet%29-instance-method\">#seek</a></code> but yields to the block after seeking and eventually seeks back to the original position when the block returns.</p>","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"whence","default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"args_string":"(offset, whence : Seek = Seek::Set, &)","args_html":"(offset, whence : <a href=\"../IO/Seek.html\">Seek</a> = <span class=\"t\">Seek</span><span class=\"t\">::</span><span class=\"t\">Set</span>, &)","location":{"filename":"src/io/file_descriptor.cr","line_number":96,"url":null},"def":{"name":"seek","args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"whence","default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"yields":0,"visibility":"Public","body":"original_pos = tell\nbegin\n  seek(offset, whence)\n  yield\nensure\n  seek(original_pos)\nend\n"}},{"html_id":"tty?:Bool-instance-method","name":"tty?","doc":"Returns `true` if this `IO` is associated with a terminal device (tty), `false` otherwise.\n\nIO returns `false`, but including types may override.\n\n```\nSTDIN.tty?          # => true\nIO::Memory.new.tty? # => false\n```","summary":"<p>Returns <code>true</code> if this <code><a href=\"../IO.html\">IO</a></code> is associated with a terminal device (tty), <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/io/file_descriptor.cr","line_number":200,"url":null},"def":{"name":"tty?","return_type":"Bool","visibility":"Public","body":"system_tty?"}}],"macros":[{"html_id":"cooked_from_tc_mode!-macro","name":"cooked_from_tc_mode!","abstract":false,"location":{"filename":"src/io/console.cr","line_number":61,"url":null},"def":{"name":"cooked_from_tc_mode!","visibility":"Public","body":"    mode.c_iflag |= (Termios::InputMode::BRKINT |\n                    Termios::InputMode::ISTRIP |\n                    Termios::InputMode::ICRNL  |\n                    Termios::InputMode::IXON).value\n    mode.c_oflag |= Termios::OutputMode::OPOST.value\n    mode.c_lflag |= (Termios::LocalMode::ECHO   |\n                    Termios::LocalMode::ECHOE  |\n                    Termios::LocalMode::ECHOK  |\n                    Termios::LocalMode::ECHONL |\n                    Termios::LocalMode::ICANON |\n                    Termios::LocalMode::ISIG   |\n                    Termios::LocalMode::IEXTEN).value\n    LibC.tcsetattr(fd, Termios::LineControl::TCSANOW, pointerof(mode))\n  "}},{"html_id":"noecho_from_tc_mode!-macro","name":"noecho_from_tc_mode!","abstract":false,"location":{"filename":"src/io/console.cr","line_number":32,"url":null},"def":{"name":"noecho_from_tc_mode!","visibility":"Public","body":"    mode.c_lflag &= ~(Termios::LocalMode.flags(ECHO, ECHOE, ECHOK, ECHONL).value)\n    LibC.tcsetattr(fd, Termios::LineControl::TCSANOW, pointerof(mode))\n  "}},{"html_id":"raw_from_tc_mode!-macro","name":"raw_from_tc_mode!","abstract":false,"location":{"filename":"src/io/console.cr","line_number":100,"url":null},"def":{"name":"raw_from_tc_mode!","visibility":"Public","body":"    LibC.cfmakeraw(pointerof(mode))\n    LibC.tcsetattr(fd, Termios::LineControl::TCSANOW, pointerof(mode))\n  "}}]},{"html_id":"Crystal/IO/Hexdump","path":"IO/Hexdump.html","kind":"class","full_name":"IO::Hexdump","name":"Hexdump","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/io/hexdump.cr","line_number":25,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"IO object that prints an hexadecimal dump of all transferred data.\n\nEspecially useful for debugging binary protocols on an IO, to understand\nbetter when and how data is sent or received.\n\nBy default `IO::Hexdump` won't print anything; you must specify which of\n`read`, `write` or both you want to print.\n\nExample:\n```\nrequire \"io/hexdump\"\nsocket = IO::Memory.new(\"abc\")\nio = IO::Hexdump.new(socket, output: STDERR, read: true)\n```\n\nWhen data is read from *io* it will print something akin to the following on\nSTDERR:\n```text\n00000000  50 52 49 20 2a 20 48 54  54 50 2f 32 2e 30 0d 0a  PRI * HTTP/2.0..\n00000010  0d 0a 53 4d 0d 0a 0d 0a                           ..SM....\n00000000  00 00 00 04                                       ....\n00000000  00                                                .\n00000000  00 00 00 00                                       ....\n```","summary":"<p>IO object that prints an hexadecimal dump of all transferred data.</p>","constructors":[{"html_id":"new(io:IO,output:IO=STDERR,read=false,write=false)-class-method","name":"new","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"output","default_value":"STDERR","external_name":"output","restriction":"IO"},{"name":"read","default_value":"false","external_name":"read","restriction":""},{"name":"write","default_value":"false","external_name":"write","restriction":""}],"args_string":"(io : IO, output : IO = STDERR, read = false, write = false)","args_html":"(io : <a href=\"../IO.html\">IO</a>, output : <a href=\"../IO.html\">IO</a> = <span class=\"t\">STDERR</span>, read = <span class=\"n\">false</span>, write = <span class=\"n\">false</span>)","location":{"filename":"src/io/hexdump.cr","line_number":26,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"output","default_value":"STDERR","external_name":"output","restriction":"IO"},{"name":"read","default_value":"false","external_name":"read","restriction":""},{"name":"write","default_value":"false","external_name":"write","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, output, read, write)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"close(*args,**options)-instance-method","name":"close","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/io/hexdump.cr","line_number":43,"url":null},"def":{"name":"close","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"@io.close(*args, **options)"}},{"html_id":"close(*args,**options,&)-instance-method","name":"close","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/io/hexdump.cr","line_number":43,"url":null},"def":{"name":"close","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"@io.close(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"closed?(*args,**options)-instance-method","name":"closed?","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/io/hexdump.cr","line_number":43,"url":null},"def":{"name":"closed?","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"@io.closed?(*args, **options)"}},{"html_id":"closed?(*args,**options,&)-instance-method","name":"closed?","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/io/hexdump.cr","line_number":43,"url":null},"def":{"name":"closed?","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"@io.closed?(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"flush(*args,**options)-instance-method","name":"flush","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/io/hexdump.cr","line_number":43,"url":null},"def":{"name":"flush","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"@io.flush(*args, **options)"}},{"html_id":"flush(*args,**options,&)-instance-method","name":"flush","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/io/hexdump.cr","line_number":43,"url":null},"def":{"name":"flush","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"@io.flush(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"peek(*args,**options)-instance-method","name":"peek","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/io/hexdump.cr","line_number":43,"url":null},"def":{"name":"peek","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"@io.peek(*args, **options)"}},{"html_id":"peek(*args,**options,&)-instance-method","name":"peek","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/io/hexdump.cr","line_number":43,"url":null},"def":{"name":"peek","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"@io.peek(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"pos(*args,**options)-instance-method","name":"pos","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/io/hexdump.cr","line_number":43,"url":null},"def":{"name":"pos","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"@io.pos(*args, **options)"}},{"html_id":"pos(*args,**options,&)-instance-method","name":"pos","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/io/hexdump.cr","line_number":43,"url":null},"def":{"name":"pos","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"@io.pos(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"pos=(arg)-instance-method","name":"pos=","doc":"Sets the current position (in bytes) in this `IO`.\n\nThe `IO` class raises on this method, but some subclasses, notable\n`IO::FileDescriptor` and `IO::Memory` implement it.\n\n```\nFile.write(\"testfile\", \"hello\")\n\nfile = File.new(\"testfile\")\nfile.pos = 3\nfile.gets_to_end # => \"lo\"\n```","summary":"<p>Sets the current position (in bytes) in this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"arg","external_name":"arg","restriction":""}],"args_string":"(arg)","args_html":"(arg)","location":{"filename":"src/io/hexdump.cr","line_number":43,"url":null},"def":{"name":"pos=","args":[{"name":"arg","external_name":"arg","restriction":""}],"visibility":"Public","body":"@io.pos = arg"}},{"html_id":"read(buf:Bytes):Int32-instance-method","name":"read","doc":"Reads at most *slice.size* bytes from this `IO` into *slice*.\nReturns the number of bytes read, which is 0 if and only if there is no\nmore data to read (so checking for 0 is the way to detect end of file).\n\n```\nio = IO::Memory.new \"hello\"\nslice = Bytes.new(4)\nio.read(slice) # => 4\nslice          # => Bytes[104, 101, 108, 108]\nio.read(slice) # => 1\nslice          # => Bytes[111, 101, 108, 108]\nio.read(slice) # => 0\n```","summary":"<p>Reads at most <em>slice.size</em> bytes from this <code><a href=\"../IO.html\">IO</a></code> into <em>slice</em>.</p>","abstract":false,"args":[{"name":"buf","external_name":"buf","restriction":"Bytes"}],"args_string":"(buf : Bytes) : Int32","args_html":"(buf : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/io/hexdump.cr","line_number":29,"url":null},"def":{"name":"read","args":[{"name":"buf","external_name":"buf","restriction":"Bytes"}],"return_type":"Int32","visibility":"Public","body":"(@io.read(buf)).to_i32.tap do |read_bytes|\n  if @read && read_bytes\n    buf[0, read_bytes].hexdump(@output)\n  end\nend"}},{"html_id":"seek(*args,**options)-instance-method","name":"seek","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/io/hexdump.cr","line_number":43,"url":null},"def":{"name":"seek","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"@io.seek(*args, **options)"}},{"html_id":"seek(*args,**options,&)-instance-method","name":"seek","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/io/hexdump.cr","line_number":43,"url":null},"def":{"name":"seek","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"@io.seek(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"tty?(*args,**options)-instance-method","name":"tty?","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/io/hexdump.cr","line_number":43,"url":null},"def":{"name":"tty?","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"@io.tty?(*args, **options)"}},{"html_id":"tty?(*args,**options,&)-instance-method","name":"tty?","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/io/hexdump.cr","line_number":43,"url":null},"def":{"name":"tty?","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"@io.tty?(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"write(buf:Bytes):Nil-instance-method","name":"write","doc":"Writes the contents of *slice* into this `IO`.\n\n```\nio = IO::Memory.new\nslice = Bytes.new(4) { |i| ('a'.ord + i).to_u8 }\nio.write(slice)\nio.to_s # => \"abcd\"\n```","summary":"<p>Writes the contents of <em>slice</em> into this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"buf","external_name":"buf","restriction":"Bytes"}],"args_string":"(buf : Bytes) : Nil","args_html":"(buf : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/hexdump.cr","line_number":35,"url":null},"def":{"name":"write","args":[{"name":"buf","external_name":"buf","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"if buf.empty?\n  return\nend\n(@io.write(buf)).tap do\n  if @write\n    buf.hexdump(@output)\n  end\nend\n"}}]},{"html_id":"Crystal/IO/Memory","path":"IO/Memory.html","kind":"class","full_name":"IO::Memory","name":"Memory","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/io/memory.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"An `IO` that reads and writes from a buffer in memory.\n\nThe internal buffer can be resizeable and/or writeable depending\non how an `IO::Memory` is constructed.","summary":"<p>An <code><a href=\"../IO.html\">IO</a></code> that reads and writes from a buffer in memory.</p>","constructors":[{"html_id":"new(capacity:Int=64)-class-method","name":"new","doc":"Creates an empty, resizeable and writeable `IO::Memory` with the given\ninitial *capacity* for the internal buffer.\n\n```\nio = IO::Memory.new\nslice = Bytes.new(1)\nio.pos         # => 0\nio.read(slice) # => 0\nslice          # => Bytes[0]\n```","summary":"<p>Creates an empty, resizeable and writeable <code><a href=\"../IO/Memory.html\">IO::Memory</a></code> with the given initial <em>capacity</em> for the internal buffer.</p>","abstract":false,"args":[{"name":"capacity","default_value":"64","external_name":"capacity","restriction":"Int"}],"args_string":"(capacity : Int = 64)","args_html":"(capacity : <a href=\"../Int.html\">Int</a> = <span class=\"n\">64</span>)","location":{"filename":"src/io/memory.cr","line_number":24,"url":null},"def":{"name":"new","args":[{"name":"capacity","default_value":"64","external_name":"capacity","restriction":"Int"}],"visibility":"Public","body":"_ = allocate\n_.initialize(capacity)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(string:String)-class-method","name":"new","doc":"Creates an `IO::Memory` whose contents are the exact contents of *string*.\nThe created `IO::Memory` is non-resizeable and non-writeable.\n\nThe `IO` starts at position zero for reading.\n\n```\nio = IO::Memory.new \"hello\"\nio.pos        # => 0\nio.gets(2)    # => \"he\"\nio.print \"hi\" # raises IO::Error\n```","summary":"<p>Creates an <code><a href=\"../IO/Memory.html\">IO::Memory</a></code> whose contents are the exact contents of <em>string</em>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String)","args_html":"(string : <a href=\"../String.html\">String</a>)","location":{"filename":"src/io/memory.cr","line_number":68,"url":null},"def":{"name":"new","args":[{"name":"string","external_name":"string","restriction":"String"}],"visibility":"Public","body":"new(string.to_slice, writeable: false)"}},{"html_id":"new(slice:Bytes,writeable=true)-class-method","name":"new","doc":"Creates an `IO::Memory` that will read, and optionally write, from/to\nthe given slice. The created `IO::Memory` is non-resizeable.\n\nThe IO starts at position zero for reading.\n\n```\nslice = Slice.new(6) { |i| ('a'.ord + i).to_u8 }\nio = IO::Memory.new slice, writeable: false\nio.pos            # => 0\nio.read(slice)    # => 6\nString.new(slice) # => \"abcdef\"\n```","summary":"<p>Creates an <code><a href=\"../IO/Memory.html\">IO::Memory</a></code> that will read, and optionally write, from/to the given slice.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"},{"name":"writeable","default_value":"true","external_name":"writeable","restriction":""}],"args_string":"(slice : Bytes, writeable = true)","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>, writeable = <span class=\"n\">true</span>)","location":{"filename":"src/io/memory.cr","line_number":48,"url":null},"def":{"name":"new","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"},{"name":"writeable","default_value":"true","external_name":"writeable","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(slice, writeable)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"buffer:Pointer(UInt8)-instance-method","name":"buffer","doc":"Returns the internal buffer as a `Pointer(UInt8)`.","summary":"<p>Returns the internal buffer as a <code><a href=\"../Pointer.html\">Pointer</a>(<a href=\"../UInt8.html\">UInt8</a>)</code>.</p>","abstract":false,"location":{"filename":"src/io/memory.cr","line_number":7,"url":null},"def":{"name":"buffer","return_type":"Pointer(UInt8)","visibility":"Public","body":"@buffer"}},{"html_id":"bytesize:Int32-instance-method","name":"bytesize","doc":"Same as `size`.","summary":"<p>Same as <code><a href=\"../IO/Memory.html#size%3AInt32-instance-method\">#size</a></code>.</p>","abstract":false,"location":{"filename":"src/io/memory.cr","line_number":10,"url":null},"def":{"name":"bytesize","return_type":"Int32","visibility":"Public","body":"@bytesize"}},{"html_id":"clear:Nil-instance-method","name":"clear","doc":"Clears the internal buffer and resets the position to zero.\nRaises if this `IO::Memory` is non-resizeable.\n\n```\nio = IO::Memory.new\nio << \"abc\"\nio.rewind\nio.gets(1) # => \"a\"\nio.clear\nio.pos         # => 0\nio.gets_to_end # => \"\"\n\nio = IO::Memory.new \"hello\"\nio.clear # raises IO::Error\n```","summary":"<p>Clears the internal buffer and resets the position to zero.</p>","abstract":false,"location":{"filename":"src/io/memory.cr","line_number":241,"url":null},"def":{"name":"clear","return_type":"Nil","visibility":"Public","body":"check_open\ncheck_resizeable\n@bytesize = 0\n@pos = 0\n"}},{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes this `IO`. Further operations on this `IO` will raise an `IO::Error`.\n\n```\nio = IO::Memory.new \"hello\"\nio.close\nio.gets_to_end # raises IO::Error (closed stream)\n```","summary":"<p>Closes this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io/memory.cr","line_number":371,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"@closed = true"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Determines if this `IO` is closed.\n\n```\nio = IO::Memory.new \"hello\"\nio.closed? # => false\nio.close\nio.closed? # => true\n```","summary":"<p>Determines if this <code><a href=\"../IO.html\">IO</a></code> is closed.</p>","abstract":false,"location":{"filename":"src/io/memory.cr","line_number":383,"url":null},"def":{"name":"closed?","return_type":"Bool","visibility":"Public","body":"@closed"}},{"html_id":"empty?:Bool-instance-method","name":"empty?","doc":"Returns `true` if this `IO::Memory` has no contents.\n\n```\nio = IO::Memory.new\nio.empty? # => true\nio.print \"hello\"\nio.empty? # => false\n```","summary":"<p>Returns <code>true</code> if this <code><a href=\"../IO/Memory.html\">IO::Memory</a></code> has no contents.</p>","abstract":false,"location":{"filename":"src/io/memory.cr","line_number":256,"url":null},"def":{"name":"empty?","return_type":"Bool","visibility":"Public","body":"@bytesize == 0"}},{"html_id":"gets_to_end:String-instance-method","name":"gets_to_end","doc":"Reads the rest of this `IO` data as a `String`.\n\n```\nio = IO::Memory.new \"hello world\"\nio.gets_to_end # => \"hello world\"\n```","summary":"<p>Reads the rest of this <code><a href=\"../IO.html\">IO</a></code> data as a <code><a href=\"../String.html\">String</a></code>.</p>","abstract":false,"location":{"filename":"src/io/memory.cr","line_number":210,"url":null},"def":{"name":"gets_to_end","return_type":"String","visibility":"Public","body":"if @encoding\n  return super()\nend\ncheck_open\npos = Math.min(@pos, @bytesize)\nif pos == @bytesize\n  \"\"\nelse\n  (String.new(@buffer + @pos, @bytesize - @pos)).tap do\n    @pos = @bytesize\n  end\nend\n"}},{"html_id":"peek:Bytes-instance-method","name":"peek","doc":"Peeks into this IO, if possible.\n\nIt returns:\n- `nil` if this IO isn't peekable\n- an empty slice if it is, but EOF was reached\n- a non-empty slice if some data can be peeked\n\nThe returned bytes are only valid data until a next call\nto any method that reads from this IO is invoked.\n\nBy default this method returns `nil`, but IO implementations\nthat provide buffering or wrap other IOs should override\nthis method.","summary":"<p>Peeks into this IO, if possible.</p>","abstract":false,"location":{"filename":"src/io/memory.cr","line_number":186,"url":null},"def":{"name":"peek","return_type":"Bytes","visibility":"Public","body":"check_open\nSlice.new(@buffer + @pos, @bytesize - @pos, read_only: !@writeable)\n"}},{"html_id":"pos:Int32-instance-method","name":"pos","doc":"Returns the current position (in bytes) of this `IO`.\n\n```\nio = IO::Memory.new \"hello\"\nio.pos     # => 0\nio.gets(2) # => \"he\"\nio.pos     # => 2\n```","summary":"<p>Returns the current position (in bytes) of this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io/memory.cr","line_number":316,"url":null},"def":{"name":"pos","return_type":"Int32","visibility":"Public","body":"@pos"}},{"html_id":"pos=(value)-instance-method","name":"pos=","doc":"Sets the current position (in bytes) of this `IO`.\n\n```\nio = IO::Memory.new \"hello\"\nio.pos = 3\nio.gets # => \"lo\"\n```","summary":"<p>Sets the current position (in bytes) of this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/io/memory.cr","line_number":327,"url":null},"def":{"name":"pos=","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"if value < 0\n  raise(ArgumentError.new(\"Negative pos\"))\nend\n@pos = value.to_i\n"}},{"html_id":"read(slice:Bytes):Int32-instance-method","name":"read","doc":"See `IO#read(slice)`.","summary":"<p>See <code><a href=\"../IO.html#read%28slice%3ABytes%29-instance-method\">IO#read(slice)</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Int32","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/io/memory.cr","line_number":73,"url":null},"def":{"name":"read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Int32","visibility":"Public","body":"check_open\ncount = slice.size\ncount = Math.min(count, @bytesize - @pos)\nslice.copy_from(@buffer + @pos, count)\n@pos = @pos + count\ncount\n"}},{"html_id":"read_at(offset,bytesize,&:IO->)-instance-method","name":"read_at","doc":"Yields an `IO::Memory` to read a section of this `IO`'s buffer.\n\nDuring the block duration `self` becomes read-only,\nso multiple concurrent open are allowed.","summary":"<p>Yields an <code><a href=\"../IO/Memory.html\">IO::Memory</a></code> to read a section of this <code><a href=\"../IO.html\">IO</a></code>'s buffer.</p>","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"bytesize","external_name":"bytesize","restriction":""}],"args_string":"(offset, bytesize, & : IO -> )","args_html":"(offset, bytesize, & : <a href=\"../IO.html\">IO</a> -> )","location":{"filename":"src/io/memory.cr","line_number":337,"url":null},"def":{"name":"read_at","args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"bytesize","external_name":"bytesize","restriction":""}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(IO ->)"},"visibility":"Public","body":"if 0 <= offset && offset <= @bytesize\nelse\n  raise(ArgumentError.new(\"Offset out of bounds\"))\nend\nif bytesize < 0\n  raise(ArgumentError.new(\"Negative bytesize\"))\nend\nif 0 <= (__temp_32 = offset + bytesize) && __temp_32 <= @bytesize\nelse\n  raise(ArgumentError.new(\"Bytesize out of bounds\"))\nend\nold_writeable = @writeable\nold_resizeable = @resizeable\nio = IO::Memory.new(to_slice[offset, bytesize], writeable: false)\nbegin\n  @writeable = false\n  @resizeable = false\n  yield io\nensure\n  io.close\n  @writeable = old_writeable\n  @resizeable = old_resizeable\nend\n"}},{"html_id":"read_byte:UInt8?-instance-method","name":"read_byte","doc":"Reads a single byte from this `IO`. Returns `nil` if there is no more\ndata to read.\n\n```\nio = IO::Memory.new \"a\"\nio.read_byte # => 97\nio.read_byte # => nil\n```","summary":"<p>Reads a single byte from this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io/memory.cr","line_number":172,"url":null},"def":{"name":"read_byte","return_type":"UInt8 | ::Nil","visibility":"Public","body":"check_open\npos = Math.min(@pos, @bytesize)\nif pos == @bytesize\n  nil\nelse\n  byte = @buffer[@pos]\n  @pos = @pos + 1\n  byte\nend\n"}},{"html_id":"rewind:self-instance-method","name":"rewind","doc":"Rewinds this `IO` to the initial position (zero).\n\n```\nio = IO::Memory.new \"hello\"\nio.gets(2) # => \"he\"\nio.rewind\nio.gets(2) # => \"he\"\n```","summary":"<p>Rewinds this <code><a href=\"../IO.html\">IO</a></code> to the initial position (zero).</p>","abstract":false,"location":{"filename":"src/io/memory.cr","line_number":268,"url":null},"def":{"name":"rewind","return_type":"self","visibility":"Public","body":"@pos = 0\nself\n"}},{"html_id":"seek(offset,whence:Seek=Seek::Set)-instance-method","name":"seek","doc":"Seeks to a given *offset* (in bytes) according to the *whence* argument.\n\n```\nio = IO::Memory.new(\"abcdef\")\nio.gets(3) # => \"abc\"\nio.seek(1, IO::Seek::Set)\nio.gets(2) # => \"bc\"\nio.seek(-1, IO::Seek::Current)\nio.gets(1) # => \"c\"\n```","summary":"<p>Seeks to a given <em>offset</em> (in bytes) according to the <em>whence</em> argument.</p>","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"whence","default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"args_string":"(offset, whence : Seek = Seek::Set)","args_html":"(offset, whence : <a href=\"../IO/Seek.html\">Seek</a> = <span class=\"t\">Seek</span><span class=\"t\">::</span><span class=\"t\">Set</span>)","location":{"filename":"src/io/memory.cr","line_number":293,"url":null},"def":{"name":"seek","args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"whence","default_value":"Seek::Set","external_name":"whence","restriction":"Seek"}],"visibility":"Public","body":"check_open\ncase whence\nwhen Seek::Set\nwhen Seek::Current\n  offset = offset + @pos\nwhen Seek::End\n  offset = offset + @bytesize\nend\nself.pos = offset\n"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Returns the total number of bytes in this `IO`.\n\n```\nio = IO::Memory.new \"hello\"\nio.size # => 5\n```","summary":"<p>Returns the total number of bytes in this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io/memory.cr","line_number":279,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"@bytesize"}},{"html_id":"skip_to_end:Nil-instance-method","name":"skip_to_end","doc":"Reads and discards bytes from `self` until there\nare no more bytes.","summary":"<p>Reads and discards bytes from <code>self</code> until there are no more bytes.</p>","abstract":false,"location":{"filename":"src/io/memory.cr","line_number":204,"url":null},"def":{"name":"skip_to_end","return_type":"Nil","visibility":"Public","body":"check_open\n@pos = @bytesize\n"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends this internal buffer to the given `IO`.","summary":"<p>Appends this internal buffer to the given <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/memory.cr","line_number":411,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"if io == self\n  new_bytesize = bytesize * 2\n  if @capacity < new_bytesize\n    resize_to_capacity(new_bytesize)\n  end\nend\nio.write(to_slice)\n"}},{"html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns a new `String` that contains the contents of the internal buffer.\n\n```\nio = IO::Memory.new\nio.print 1, 2, 3\nio.to_s # => \"123\"\n```","summary":"<p>Returns a new <code><a href=\"../String.html\">String</a></code> that contains the contents of the internal buffer.</p>","abstract":false,"location":{"filename":"src/io/memory.cr","line_number":394,"url":null},"def":{"name":"to_s","return_type":"String","visibility":"Public","body":"String.new(@buffer, @bytesize)"}},{"html_id":"to_slice:Bytes-instance-method","name":"to_slice","doc":"Returns the underlying bytes.\n\n```\nio = IO::Memory.new\nio.print \"hello\"\n\nio.to_slice # => Bytes[104, 101, 108, 108, 111]\n```","summary":"<p>Returns the underlying bytes.</p>","abstract":false,"location":{"filename":"src/io/memory.cr","line_number":406,"url":null},"def":{"name":"to_slice","return_type":"Bytes","visibility":"Public","body":"Slice.new(@buffer, @bytesize, read_only: !@writeable)"}},{"html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"See `IO#write(slice)`. Raises if this `IO::Memory` is non-writeable,\nor if it's non-resizeable and a resize is needed.","summary":"<p>See <code><a href=\"../IO.html#write%28slice%3ABytes%29%3ANil-instance-method\">IO#write(slice)</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/memory.cr","line_number":85,"url":null},"def":{"name":"write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"check_writeable\ncheck_open\ncount = slice.size\nif count == 0\n  return\nend\nnew_bytesize = @pos + count\nif new_bytesize > @capacity\n  check_resizeable\n  resize_to_capacity(Math.pw2ceil(new_bytesize))\nend\nslice.copy_to(@buffer + @pos, count)\nif @pos > @bytesize\n  (@buffer + @bytesize).clear(@pos - @bytesize)\nend\n@pos = @pos + count\nif @pos > @bytesize\n  @bytesize = @pos\nend\n"}},{"html_id":"write_byte(byte:UInt8):Nil-instance-method","name":"write_byte","doc":"See `IO#write_byte`. Raises if this `IO::Memory` is non-writeable,\nor if it's non-resizeable and a resize is needed.","summary":"<p>See <code><a href=\"../IO.html#write_byte%28byte%3AUInt8%29%3ANil-instance-method\">IO#write_byte</a></code>.</p>","abstract":false,"args":[{"name":"byte","external_name":"byte","restriction":"UInt8"}],"args_string":"(byte : UInt8) : Nil","args_html":"(byte : <a href=\"../UInt8.html\">UInt8</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/memory.cr","line_number":111,"url":null},"def":{"name":"write_byte","args":[{"name":"byte","external_name":"byte","restriction":"UInt8"}],"return_type":"Nil","visibility":"Public","body":"check_writeable\ncheck_open\nnew_bytesize = @pos + 1\nif new_bytesize > @capacity\n  check_resizeable\n  resize_to_capacity(Math.pw2ceil(new_bytesize))\nend\n(@buffer + @pos).value = byte\nif @pos > @bytesize\n  (@buffer + @bytesize).clear(@pos - @bytesize)\nend\n@pos = @pos + 1\nif @pos > @bytesize\n  @bytesize = @pos\nend\nnil\n"}}]},{"html_id":"Crystal/IO/MultiWriter","path":"IO/MultiWriter.html","kind":"class","full_name":"IO::MultiWriter","name":"MultiWriter","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/io/multi_writer.cr","line_number":11,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"An `IO` which writes to a number of underlying writer IOs.\n\n```\nio1 = IO::Memory.new\nio2 = IO::Memory.new\nwriter = IO::MultiWriter.new(io1, io2)\nwriter.puts \"foo bar\"\nio1.to_s # => \"foo bar\\n\"\nio2.to_s # => \"foo bar\\n\"\n```","summary":"<p>An <code><a href=\"../IO.html\">IO</a></code> which writes to a number of underlying writer IOs.</p>","constructors":[{"html_id":"new(writers:Array(IO),sync_close=false)-class-method","name":"new","doc":"Creates a new `IO::MultiWriter` which writes to *writers*. If\n*sync_close* is set, calling `#close` calls `#close` on all underlying\nwriters.","summary":"<p>Creates a new <code><a href=\"../IO/MultiWriter.html\">IO::MultiWriter</a></code> which writes to <em>writers</em>.</p>","abstract":false,"args":[{"name":"writers","external_name":"writers","restriction":"Array(IO)"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(writers : Array(IO), sync_close = false)","args_html":"(writers : <a href=\"../Array.html\">Array</a>(<a href=\"../IO.html\">IO</a>), sync_close = <span class=\"n\">false</span>)","location":{"filename":"src/io/multi_writer.cr","line_number":22,"url":null},"def":{"name":"new","args":[{"name":"writers","external_name":"writers","restriction":"Array(IO)"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(writers, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(*writers:IO,sync_close=false)-class-method","name":"new","doc":"Creates a new `IO::MultiWriter` which writes to *writers*. If\n*sync_close* is set, calling `#close` calls `#close` on all underlying\nwriters.","summary":"<p>Creates a new <code><a href=\"../IO/MultiWriter.html\">IO::MultiWriter</a></code> which writes to <em>writers</em>.</p>","abstract":false,"args":[{"name":"writers","external_name":"writers","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(*writers : IO, sync_close = false)","args_html":"(*writers : <a href=\"../IO.html\">IO</a>, sync_close = <span class=\"n\">false</span>)","location":{"filename":"src/io/multi_writer.cr","line_number":28,"url":null},"def":{"name":"new","args":[{"name":"writers","external_name":"writers","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"splat_index":0,"visibility":"Public","body":"_ = allocate\n_.initialize(*writers, sync_close: sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes this `IO`.\n\n`IO` defines this is a no-op method, but including types may override.","summary":"<p>Closes this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io/multi_writer.cr","line_number":44,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nif sync_close?\n  @writers.each do |writer|\n    writer.close\n  end\nend\n"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this `IO` is closed.\n\n`IO` defines returns `false`, but including types may override.","summary":"<p>Returns <code>true</code> if this <code><a href=\"../IO.html\">IO</a></code> is closed.</p>","abstract":false,"location":{"filename":"src/io/multi_writer.cr","line_number":15,"url":null},"def":{"name":"closed?","visibility":"Public","body":"@closed"}},{"html_id":"flush:Nil-instance-method","name":"flush","doc":"Flushes buffered data, if any.\n\n`IO` defines this is a no-op method, but including types may override.","summary":"<p>Flushes buffered data, if any.</p>","abstract":false,"location":{"filename":"src/io/multi_writer.cr","line_number":51,"url":null},"def":{"name":"flush","return_type":"Nil","visibility":"Public","body":"@writers.each(&.flush)"}},{"html_id":"read(slice:Bytes):NoReturn-instance-method","name":"read","doc":"Reads at most *slice.size* bytes from this `IO` into *slice*.\nReturns the number of bytes read, which is 0 if and only if there is no\nmore data to read (so checking for 0 is the way to detect end of file).\n\n```\nio = IO::Memory.new \"hello\"\nslice = Bytes.new(4)\nio.read(slice) # => 4\nslice          # => Bytes[104, 101, 108, 108]\nio.read(slice) # => 1\nslice          # => Bytes[111, 101, 108, 108]\nio.read(slice) # => 0\n```","summary":"<p>Reads at most <em>slice.size</em> bytes from this <code><a href=\"../IO.html\">IO</a></code> into <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : NoReturn","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : NoReturn","location":{"filename":"src/io/multi_writer.cr","line_number":40,"url":null},"def":{"name":"read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"NoReturn","visibility":"Public","body":"raise(IO::Error.new(\"Can't read from IO::MultiWriter\"))"}},{"html_id":"sync_close=(sync_close)-instance-method","name":"sync_close=","doc":"If `#sync_close?` is `true`, closing this `IO` will close all of the underlying\nIOs.","summary":"<p>If <code><a href=\"../IO/MultiWriter.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close all of the underlying IOs.</p>","abstract":false,"args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"args_string":"(sync_close)","args_html":"(sync_close)","location":{"filename":"src/io/multi_writer.cr","line_number":14,"url":null},"def":{"name":"sync_close=","args":[{"name":"sync_close","external_name":"sync_close","restriction":""}],"visibility":"Public","body":"@sync_close = sync_close"}},{"html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"If `#sync_close?` is `true`, closing this `IO` will close all of the underlying\nIOs.","summary":"<p>If <code><a href=\"../IO/MultiWriter.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close all of the underlying IOs.</p>","abstract":false,"location":{"filename":"src/io/multi_writer.cr","line_number":14,"url":null},"def":{"name":"sync_close?","visibility":"Public","body":"@sync_close"}},{"html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"Writes the contents of *slice* into this `IO`.\n\n```\nio = IO::Memory.new\nslice = Bytes.new(4) { |i| ('a'.ord + i).to_u8 }\nio.write(slice)\nio.to_s # => \"abcd\"\n```","summary":"<p>Writes the contents of <em>slice</em> into this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/multi_writer.cr","line_number":32,"url":null},"def":{"name":"write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"check_open\nif slice.empty?\n  return\nend\n@writers.each do |writer|\n  writer.write(slice)\nend\n"}}]},{"html_id":"Crystal/IO/Seek","path":"IO/Seek.html","kind":"enum","full_name":"IO::Seek","name":"Seek","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/io.cr","line_number":62,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Set","name":"Set","value":"0","doc":"Seeks to an absolute location","summary":"<p>Seeks to an absolute location</p>"},{"id":"Current","name":"Current","value":"1","doc":"Seeks to a location relative to the current location\nin the stream","summary":"<p>Seeks to a location relative to the current location in the stream</p>"},{"id":"End","name":"End","value":"2","doc":"Seeks to a location relative to the end of the stream\n(you probably want a negative value for the amount)","summary":"<p>Seeks to a location relative to the end of the stream (you probably want a negative value for the amount)</p>"}],"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"Argument to a `seek` operation.","summary":"<p>Argument to a <code>seek</code> operation.</p>","instance_methods":[{"html_id":"current?-instance-method","name":"current?","abstract":false,"location":{"filename":"src/io.cr","line_number":68,"url":null},"def":{"name":"current?","visibility":"Public","body":"self == Current"}},{"html_id":"end?-instance-method","name":"end?","abstract":false,"location":{"filename":"src/io.cr","line_number":72,"url":null},"def":{"name":"end?","visibility":"Public","body":"self == End"}},{"html_id":"set?-instance-method","name":"set?","abstract":false,"location":{"filename":"src/io.cr","line_number":64,"url":null},"def":{"name":"set?","visibility":"Public","body":"self == Set"}}]},{"html_id":"Crystal/IO/Sized","path":"IO/Sized.html","kind":"class","full_name":"IO::Sized","name":"Sized","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/io/sized.cr","line_number":11,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"An `IO` that wraps another `IO`, setting a limit for the number of bytes that can be read.\n\n```\nio = IO::Memory.new \"abcde\"\nsized = IO::Sized.new(io, read_size: 3)\n\nsized.gets_to_end # => \"abc\"\nsized.gets_to_end # => \"\"\nio.gets_to_end    # => \"de\"\n```","summary":"<p>An <code><a href=\"../IO.html\">IO</a></code> that wraps another <code><a href=\"../IO.html\">IO</a></code>, setting a limit for the number of bytes that can be read.</p>","constructors":[{"html_id":"new(io:IO,read_size:Int,sync_close=false)-class-method","name":"new","doc":"Creates a new `IO::Sized` which wraps *io*, and can read a maximum of\n*read_size* bytes. If *sync_close* is set, calling `#close` calls\n`#close` on the underlying `IO`.","summary":"<p>Creates a new <code><a href=\"../IO/Sized.html\">IO::Sized</a></code> which wraps <em>io</em>, and can read a maximum of <em>read_size</em> bytes.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"read_size","external_name":"read_size","restriction":"Int"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"args_string":"(io : IO, read_size : Int, sync_close = false)","args_html":"(io : <a href=\"../IO.html\">IO</a>, read_size : <a href=\"../Int.html\">Int</a>, sync_close = <span class=\"n\">false</span>)","location":{"filename":"src/io/sized.cr","line_number":22,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"read_size","external_name":"read_size","restriction":"Int"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, read_size, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes this `IO`.\n\n`IO` defines this is a no-op method, but including types may override.","summary":"<p>Closes this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io/sized.cr","line_number":79,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nif @sync_close\n  @io.close\nend\n"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this `IO` is closed.\n\n`IO` defines returns `false`, but including types may override.","summary":"<p>Returns <code>true</code> if this <code><a href=\"../IO.html\">IO</a></code> is closed.</p>","abstract":false,"location":{"filename":"src/io/sized.cr","line_number":17,"url":null},"def":{"name":"closed?","return_type":"Bool","visibility":"Public","body":"@closed"}},{"html_id":"peek:Bytes?-instance-method","name":"peek","doc":"Peeks into this IO, if possible.\n\nIt returns:\n- `nil` if this IO isn't peekable\n- an empty slice if it is, but EOF was reached\n- a non-empty slice if some data can be peeked\n\nThe returned bytes are only valid data until a next call\nto any method that reads from this IO is invoked.\n\nBy default this method returns `nil`, but IO implementations\nthat provide buffering or wrap other IOs should override\nthis method.","summary":"<p>Peeks into this IO, if possible.</p>","abstract":false,"location":{"filename":"src/io/sized.cr","line_number":49,"url":null},"def":{"name":"peek","return_type":"Bytes | ::Nil","visibility":"Public","body":"check_open\nif @read_remaining == 0\n  return Bytes.empty\nend\npeek = @io.peek\nif peek\nelse\n  return nil\nend\nif @read_remaining < peek.size\n  peek = peek[0, @read_remaining]\nend\npeek\n"}},{"html_id":"read(slice:Bytes):Int32-instance-method","name":"read","doc":"Reads at most *slice.size* bytes from this `IO` into *slice*.\nReturns the number of bytes read, which is 0 if and only if there is no\nmore data to read (so checking for 0 is the way to detect end of file).\n\n```\nio = IO::Memory.new \"hello\"\nslice = Bytes.new(4)\nio.read(slice) # => 4\nslice          # => Bytes[104, 101, 108, 108]\nio.read(slice) # => 1\nslice          # => Bytes[111, 101, 108, 108]\nio.read(slice) # => 0\n```","summary":"<p>Reads at most <em>slice.size</em> bytes from this <code><a href=\"../IO.html\">IO</a></code> into <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Int32","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/io/sized.cr","line_number":28,"url":null},"def":{"name":"read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Int32","visibility":"Public","body":"check_open\ncount = {slice.size.to_u64, @read_remaining}.min\nbytes_read = (@io.read(slice[0, count])).to_i32\n@read_remaining = @read_remaining - bytes_read\nbytes_read\n"}},{"html_id":"read_byte:UInt8?-instance-method","name":"read_byte","doc":"Reads a single byte from this `IO`. Returns `nil` if there is no more\ndata to read.\n\n```\nio = IO::Memory.new \"a\"\nio.read_byte # => 97\nio.read_byte # => nil\n```","summary":"<p>Reads a single byte from this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io/sized.cr","line_number":37,"url":null},"def":{"name":"read_byte","return_type":"UInt8 | ::Nil","visibility":"Public","body":"check_open\nif @read_remaining > 0\n  byte = @io.read_byte\n  if byte\n    @read_remaining = @read_remaining - 1\n  end\n  byte\nelse\n  nil\nend\n"}},{"html_id":"read_remaining:UInt64-instance-method","name":"read_remaining","doc":"The number of remaining bytes to be read.","summary":"<p>The number of remaining bytes to be read.</p>","abstract":false,"location":{"filename":"src/io/sized.cr","line_number":16,"url":null},"def":{"name":"read_remaining","return_type":"UInt64","visibility":"Public","body":"@read_remaining"}},{"html_id":"read_remaining=(read_remaining:UInt64)-instance-method","name":"read_remaining=","doc":"The number of remaining bytes to be read.","summary":"<p>The number of remaining bytes to be read.</p>","abstract":false,"args":[{"name":"read_remaining","external_name":"read_remaining","restriction":"UInt64"}],"args_string":"(read_remaining : UInt64)","args_html":"(read_remaining : <a href=\"../UInt64.html\">UInt64</a>)","location":{"filename":"src/io/sized.cr","line_number":16,"url":null},"def":{"name":"read_remaining=","args":[{"name":"read_remaining","external_name":"read_remaining","restriction":"UInt64"}],"visibility":"Public","body":"@read_remaining = read_remaining"}},{"html_id":"skip(bytes_count):Nil-instance-method","name":"skip","abstract":false,"args":[{"name":"bytes_count","external_name":"bytes_count","restriction":""}],"args_string":"(bytes_count) : Nil","args_html":"(bytes_count) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/sized.cr","line_number":64,"url":null},"def":{"name":"skip","args":[{"name":"bytes_count","external_name":"bytes_count","restriction":""}],"return_type":"Nil","visibility":"Public","body":"check_open\nif bytes_count <= @read_remaining\n  @io.skip(bytes_count)\n  @read_remaining = @read_remaining - bytes_count\nelse\n  raise(IO::EOFError.new)\nend\n"}},{"html_id":"sync_close=(sync_close:Bool)-instance-method","name":"sync_close=","doc":"If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`.","summary":"<p>If <code><a href=\"../IO/Sized.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"sync_close","external_name":"sync_close","restriction":"Bool"}],"args_string":"(sync_close : Bool)","args_html":"(sync_close : <a href=\"../Bool.html\">Bool</a>)","location":{"filename":"src/io/sized.cr","line_number":13,"url":null},"def":{"name":"sync_close=","args":[{"name":"sync_close","external_name":"sync_close","restriction":"Bool"}],"visibility":"Public","body":"@sync_close = sync_close"}},{"html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`.","summary":"<p>If <code><a href=\"../IO/Sized.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io/sized.cr","line_number":13,"url":null},"def":{"name":"sync_close?","return_type":"Bool","visibility":"Public","body":"@sync_close"}},{"html_id":"write(slice:Bytes):NoReturn-instance-method","name":"write","doc":"Writes the contents of *slice* into this `IO`.\n\n```\nio = IO::Memory.new\nslice = Bytes.new(4) { |i| ('a'.ord + i).to_u8 }\nio.write(slice)\nio.to_s # => \"abcd\"\n```","summary":"<p>Writes the contents of <em>slice</em> into this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : NoReturn","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : NoReturn","location":{"filename":"src/io/sized.cr","line_number":75,"url":null},"def":{"name":"write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"NoReturn","visibility":"Public","body":"raise(IO::Error.new(\"Can't write to IO::Sized\"))"}}]},{"html_id":"Crystal/IO/Stapled","path":"IO/Stapled.html","kind":"class","full_name":"IO::Stapled","name":"Stapled","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/io/stapled.cr","line_number":12,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"This class staples together two unidirectional `IO`s to form a single,\nbidirectional `IO`.\n\nExample (loopback):\n```\nio = IO::Stapled.new(*IO.pipe)\nio.puts \"linus\"\nio.gets # => \"linus\"\n```\n\nMost methods simply delegate to the underlying `IO`s.","summary":"<p>This class staples together two unidirectional <code><a href=\"../IO.html\">IO</a></code>s to form a single, bidirectional <code><a href=\"../IO.html\">IO</a></code>.</p>","class_methods":[{"html_id":"pipe(read_blocking:Bool=false,write_blocking:Bool=false,&)-class-method","name":"pipe","doc":"Creates a pair of bidirectional pipe endpoints connected with each other\nand passes them to the given block.\n\nBoth endpoints and the underlying `IO`s are closed after the block\n(even if `sync_close?` is `false`).","summary":"<p>Creates a pair of bidirectional pipe endpoints connected with each other and passes them to the given block.</p>","abstract":false,"args":[{"name":"read_blocking","default_value":"false","external_name":"read_blocking","restriction":"Bool"},{"name":"write_blocking","default_value":"false","external_name":"write_blocking","restriction":"Bool"}],"args_string":"(read_blocking : Bool = false, write_blocking : Bool = false, &)","args_html":"(read_blocking : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>, write_blocking : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>, &)","location":{"filename":"src/io/stapled.cr","line_number":110,"url":null},"def":{"name":"pipe","args":[{"name":"read_blocking","default_value":"false","external_name":"read_blocking","restriction":"Bool"},{"name":"write_blocking","default_value":"false","external_name":"write_blocking","restriction":"Bool"}],"yields":2,"visibility":"Public","body":"IO.pipe(read_blocking, write_blocking) do |a_read, a_write|\n  IO.pipe(read_blocking, write_blocking) do |b_read, b_write|\n    a, b = new(a_read, b_write, true), new(b_read, a_write, true)\n    begin\n      yield a, b\n    ensure\n      a.close\n      b.close\n    end\n  end\nend"}},{"html_id":"pipe(read_blocking:Bool=false,write_blocking:Bool=false):Tuple(self,self)-class-method","name":"pipe","doc":"Creates a pair of bidirectional pipe endpoints connected with each other\nand returns them in a `Tuple`.","summary":"<p>Creates a pair of bidirectional pipe endpoints connected with each other and returns them in a <code><a href=\"../Tuple.html\">Tuple</a></code>.</p>","abstract":false,"args":[{"name":"read_blocking","default_value":"false","external_name":"read_blocking","restriction":"Bool"},{"name":"write_blocking","default_value":"false","external_name":"write_blocking","restriction":"Bool"}],"args_string":"(read_blocking : Bool = false, write_blocking : Bool = false) : Tuple(self, self)","args_html":"(read_blocking : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>, write_blocking : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"../Tuple.html\">Tuple</a>(<span class=\"k\">self</span>, <span class=\"k\">self</span>)","location":{"filename":"src/io/stapled.cr","line_number":126,"url":null},"def":{"name":"pipe","args":[{"name":"read_blocking","default_value":"false","external_name":"read_blocking","restriction":"Bool"},{"name":"write_blocking","default_value":"false","external_name":"write_blocking","restriction":"Bool"}],"return_type":"::Tuple(self, self)","visibility":"Public","body":"a_read, a_write = IO.pipe(read_blocking, write_blocking)\nb_read, b_write = IO.pipe(read_blocking, write_blocking)\nreturn {new(a_read, b_write, true), new(b_read, a_write, true)}\n"}}],"constructors":[{"html_id":"new(reader:IO,writer:IO,sync_close:Bool=false)-class-method","name":"new","doc":"Creates a new `IO::Stapled` which reads from *reader* and writes to *writer*.","summary":"<p>Creates a new <code><a href=\"../IO/Stapled.html\">IO::Stapled</a></code> which reads from <em>reader</em> and writes to <em>writer</em>.</p>","abstract":false,"args":[{"name":"reader","external_name":"reader","restriction":"IO"},{"name":"writer","external_name":"writer","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"}],"args_string":"(reader : IO, writer : IO, sync_close : Bool = false)","args_html":"(reader : <a href=\"../IO.html\">IO</a>, writer : <a href=\"../IO.html\">IO</a>, sync_close : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>)","location":{"filename":"src/io/stapled.cr","line_number":22,"url":null},"def":{"name":"new","args":[{"name":"reader","external_name":"reader","restriction":"IO"},{"name":"writer","external_name":"writer","restriction":"IO"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"}],"visibility":"Public","body":"_ = allocate\n_.initialize(reader, writer, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes this `IO`.\n\nIf `sync_close?` is `true`, it will also close the underlying `IO`s.","summary":"<p>Closes this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/io/stapled.cr","line_number":95,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nif @sync_close\n  @reader.close\n  @writer.close\nend\n"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this `IO` is closed.\n\nUnderlying `IO`s might have a different status.","summary":"<p>Returns <code>true</code> if this <code><a href=\"../IO.html\">IO</a></code> is closed.</p>","abstract":false,"location":{"filename":"src/io/stapled.cr","line_number":19,"url":null},"def":{"name":"closed?","return_type":"Bool","visibility":"Public","body":"@closed"}},{"html_id":"flush:self-instance-method","name":"flush","doc":"Flushes `writer`.","summary":"<p>Flushes <code>writer</code>.</p>","abstract":false,"location":{"filename":"src/io/stapled.cr","line_number":84,"url":null},"def":{"name":"flush","return_type":"self","visibility":"Public","body":"check_open\n@writer.flush\nself\n"}},{"html_id":"gets(delimiter:Char,limit:Int,chomp=false):String?-instance-method","name":"gets","doc":"Gets a string from `reader`.","summary":"<p>Gets a string from <code>reader</code>.</p>","abstract":false,"args":[{"name":"delimiter","external_name":"delimiter","restriction":"Char"},{"name":"limit","external_name":"limit","restriction":"Int"},{"name":"chomp","default_value":"false","external_name":"chomp","restriction":""}],"args_string":"(delimiter : Char, limit : Int, chomp = false) : String?","args_html":"(delimiter : <a href=\"../Char.html\">Char</a>, limit : <a href=\"../Int.html\">Int</a>, chomp = <span class=\"n\">false</span>) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/io/stapled.cr","line_number":40,"url":null},"def":{"name":"gets","args":[{"name":"delimiter","external_name":"delimiter","restriction":"Char"},{"name":"limit","external_name":"limit","restriction":"Int"},{"name":"chomp","default_value":"false","external_name":"chomp","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"check_open\n@reader.gets(delimiter, limit, chomp)\n"}},{"html_id":"peek:Bytes?-instance-method","name":"peek","doc":"Peeks into `reader`.","summary":"<p>Peeks into <code>reader</code>.</p>","abstract":false,"location":{"filename":"src/io/stapled.cr","line_number":47,"url":null},"def":{"name":"peek","return_type":"Bytes | ::Nil","visibility":"Public","body":"check_open\n@reader.peek\n"}},{"html_id":"read(slice:Bytes):Int32-instance-method","name":"read","doc":"Reads a slice from `reader`.","summary":"<p>Reads a slice from <code>reader</code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Int32","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/io/stapled.cr","line_number":33,"url":null},"def":{"name":"read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Int32","visibility":"Public","body":"check_open\n(@reader.read(slice)).to_i32\n"}},{"html_id":"read_byte:UInt8?-instance-method","name":"read_byte","doc":"Reads a single byte from `reader`.","summary":"<p>Reads a single byte from <code>reader</code>.</p>","abstract":false,"location":{"filename":"src/io/stapled.cr","line_number":26,"url":null},"def":{"name":"read_byte","return_type":"UInt8 | ::Nil","visibility":"Public","body":"check_open\n@reader.read_byte\n"}},{"html_id":"skip(bytes_count:Int):Nil-instance-method","name":"skip","doc":"Skips `reader`.","summary":"<p>Skips <code>reader</code>.</p>","abstract":false,"args":[{"name":"bytes_count","external_name":"bytes_count","restriction":"Int"}],"args_string":"(bytes_count : Int) : Nil","args_html":"(bytes_count : <a href=\"../Int.html\">Int</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/stapled.cr","line_number":54,"url":null},"def":{"name":"skip","args":[{"name":"bytes_count","external_name":"bytes_count","restriction":"Int"}],"return_type":"Nil","visibility":"Public","body":"check_open\n@reader.skip(bytes_count)\n"}},{"html_id":"skip_to_end:Nil-instance-method","name":"skip_to_end","doc":"Skips `reader`.","summary":"<p>Skips <code>reader</code>.</p>","abstract":false,"location":{"filename":"src/io/stapled.cr","line_number":61,"url":null},"def":{"name":"skip_to_end","return_type":"Nil","visibility":"Public","body":"check_open\n@reader.skip_to_end\n"}},{"html_id":"sync_close=(sync_close:Bool)-instance-method","name":"sync_close=","doc":"If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`s.","summary":"<p>If <code><a href=\"../IO/Stapled.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close the underlying <code><a href=\"../IO.html\">IO</a></code>s.</p>","abstract":false,"args":[{"name":"sync_close","external_name":"sync_close","restriction":"Bool"}],"args_string":"(sync_close : Bool)","args_html":"(sync_close : <a href=\"../Bool.html\">Bool</a>)","location":{"filename":"src/io/stapled.cr","line_number":14,"url":null},"def":{"name":"sync_close=","args":[{"name":"sync_close","external_name":"sync_close","restriction":"Bool"}],"visibility":"Public","body":"@sync_close = sync_close"}},{"html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"If `#sync_close?` is `true`, closing this `IO` will close the underlying `IO`s.","summary":"<p>If <code><a href=\"../IO/Stapled.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this <code><a href=\"../IO.html\">IO</a></code> will close the underlying <code><a href=\"../IO.html\">IO</a></code>s.</p>","abstract":false,"location":{"filename":"src/io/stapled.cr","line_number":14,"url":null},"def":{"name":"sync_close?","return_type":"Bool","visibility":"Public","body":"@sync_close"}},{"html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"Writes a slice to `writer`.","summary":"<p>Writes a slice to <code>writer</code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/stapled.cr","line_number":75,"url":null},"def":{"name":"write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"check_open\nif slice.empty?\n  return\nend\n@writer.write(slice)\n"}},{"html_id":"write_byte(byte:UInt8):Nil-instance-method","name":"write_byte","doc":"Writes a byte to `writer`.","summary":"<p>Writes a byte to <code>writer</code>.</p>","abstract":false,"args":[{"name":"byte","external_name":"byte","restriction":"UInt8"}],"args_string":"(byte : UInt8) : Nil","args_html":"(byte : <a href=\"../UInt8.html\">UInt8</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/io/stapled.cr","line_number":68,"url":null},"def":{"name":"write_byte","args":[{"name":"byte","external_name":"byte","restriction":"UInt8"}],"return_type":"Nil","visibility":"Public","body":"check_open\n@writer.write_byte(byte)\n"}}]},{"html_id":"Crystal/IO/TimeoutError","path":"IO/TimeoutError.html","kind":"class","full_name":"IO::TimeoutError","name":"TimeoutError","abstract":false,"superclass":{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},{"html_id":"Crystal/SystemError","kind":"module","full_name":"SystemError","name":"SystemError"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/io/error.cr","line_number":12,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"doc":"Raised when an `IO` operation times out.\n\n```\nSTDIN.read_timeout = 1\nSTDIN.gets # raises IO::TimeoutError (after 1 second)\n```","summary":"<p>Raised when an <code><a href=\"../IO.html\">IO</a></code> operation times out.</p>"}]},{"html_id":"Crystal/IPSocket","path":"IPSocket.html","kind":"class","full_name":"IPSocket","name":"IPSocket","abstract":false,"superclass":{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"ancestors":[{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},{"html_id":"Crystal/Crystal/System/Socket","kind":"module","full_name":"Crystal::System::Socket","name":"Socket"},{"html_id":"Crystal/IO/Evented","kind":"module","full_name":"IO::Evented","name":"Evented"},{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/ip_socket.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/TCPSocket","kind":"class","full_name":"TCPSocket","name":"TCPSocket"},{"html_id":"Crystal/UDPSocket","kind":"class","full_name":"UDPSocket","name":"UDPSocket"}],"instance_methods":[{"html_id":"bind(addr)-instance-method","name":"bind","abstract":false,"args":[{"name":"addr","external_name":"addr","restriction":""}],"args_string":"(addr)","args_html":"(addr)","location":{"filename":"src/socket/ip_socket.cr","line_number":22,"url":null},"def":{"name":"bind","args":[{"name":"addr","external_name":"addr","restriction":""}],"visibility":"Public","body":"begin\n  super(addr)\nensure\n  @local_address = nil\n  @remote_address = nil\nend"}},{"html_id":"close-instance-method","name":"close","doc":"Flushes and closes the underlying `IO`.","summary":"<p>Flushes and closes the underlying <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/socket/ip_socket.cr","line_number":8,"url":null},"def":{"name":"close","visibility":"Public","body":"begin\n  super()\nensure\n  @local_address = nil\n  @remote_address = nil\nend"}},{"html_id":"connect(addr,timeout=nil,&)-instance-method","name":"connect","doc":"Tries to connect to a remote address. Yields an `IO::TimeoutError` or an\n`Socket::ConnectError` error if the connection failed.","summary":"<p>Tries to connect to a remote address.</p>","abstract":false,"args":[{"name":"addr","external_name":"addr","restriction":""},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(addr, timeout = nil, &)","args_html":"(addr, timeout = <span class=\"n\">nil</span>, &)","location":{"filename":"src/socket/ip_socket.cr","line_number":15,"url":null},"def":{"name":"connect","args":[{"name":"addr","external_name":"addr","restriction":""},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"yields":1,"visibility":"Public","body":"begin\n  super(addr, timeout) do |error|\n    yield error\n  end\nensure\n  @local_address = nil\n  @remote_address = nil\nend"}},{"html_id":"local_address:Socket::IPAddress-instance-method","name":"local_address","doc":"Returns the `IPAddress` for the local end of the IP socket.","summary":"<p>Returns the <code><a href=\"Socket/IPAddress.html\">IPAddress</a></code> for the local end of the IP socket.</p>","abstract":false,"location":{"filename":"src/socket/ip_socket.cr","line_number":3,"url":null},"def":{"name":"local_address","return_type":"Socket::IPAddress","visibility":"Public","body":"if (value = @local_address).nil?\n  @local_address = (system_local_address)\nelse\n  value\nend"}},{"html_id":"remote_address:Socket::IPAddress-instance-method","name":"remote_address","doc":"Returns the `IPAddress` for the remote end of the IP socket.","summary":"<p>Returns the <code><a href=\"Socket/IPAddress.html\">IPAddress</a></code> for the remote end of the IP socket.</p>","abstract":false,"location":{"filename":"src/socket/ip_socket.cr","line_number":6,"url":null},"def":{"name":"remote_address","return_type":"Socket::IPAddress","visibility":"Public","body":"if (value = @remote_address).nil?\n  @remote_address = (system_remote_address)\nelse\n  value\nend"}}]},{"html_id":"Crystal/Iterable","path":"Iterable.html","kind":"module","full_name":"Iterable(T)","name":"Iterable","abstract":false,"locations":[{"filename":"src/iterable.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"including_types":[{"html_id":"Crystal/Dir","kind":"class","full_name":"Dir","name":"Dir"},{"html_id":"Crystal/Hash","kind":"class","full_name":"Hash(K, V)","name":"Hash"},{"html_id":"Crystal/Indexable","kind":"module","full_name":"Indexable(T)","name":"Indexable"},{"html_id":"Crystal/Range","kind":"struct","full_name":"Range(B, E)","name":"Range"},{"html_id":"Crystal/Set","kind":"struct","full_name":"Set(T)","name":"Set"}],"doc":"The `Iterable` mixin provides convenience methods to collection classes\nthat provide an `each` method that returns an `Iterator` over the collection.","summary":"<p>The <code><a href=\"Iterable.html\">Iterable</a></code> mixin provides convenience methods to collection classes that provide an <code><a href=\"Iterable.html#each-instance-method\">#each</a></code> method that returns an <code><a href=\"Iterator.html\">Iterator</a></code> over the collection.</p>","instance_methods":[{"html_id":"chunk(reuse=false,&block:T->U)forallU-instance-method","name":"chunk","doc":"Returns an Iterator that enumerates over the items, chunking them together\nbased on the return value of the block.\n\n```\n(0..7).chunk(&.//(3)).to_a # => [{0, [0, 1, 2]}, {1, [3, 4, 5]}, {2, [6, 7]}]\n```\n\nSee also: `Iterator#chunks`.","summary":"<p>Returns an Iterator that enumerates over the items, chunking them together based on the return value of the block.</p>","abstract":false,"args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(reuse = false, &block : T -> U) forall U","args_html":"(reuse = <span class=\"n\">false</span>, &block : T -> U) forall U","location":{"filename":"src/iterable.cr","line_number":25,"url":null},"def":{"name":"chunk","args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> U)"},"visibility":"Public","body":"each.chunk(reuse, &block)"}},{"html_id":"chunk_while(reuse:Bool|Array(T)=false,&block:T,T->B)forallB-instance-method","name":"chunk_while","doc":"Same as `each.chunk_while(reuse, &block)`.","summary":"<p>Same as <code>each.chunk_while(reuse, &block)</code>.</p>","abstract":false,"args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"args_string":"(reuse : Bool | Array(T) = false, &block : T, T -> B) forall B","args_html":"(reuse : <a href=\"Bool.html\">Bool</a> | <a href=\"Array.html\">Array</a>(T) = <span class=\"n\">false</span>, &block : T, T -> B) forall B","location":{"filename":"src/iterable.cr","line_number":75,"url":null},"def":{"name":"chunk_while","args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> B)"},"visibility":"Public","body":"each.chunk_while(reuse, &block)"}},{"html_id":"cycle(n)-instance-method","name":"cycle","doc":"Same as `each.cycle(n)`.","summary":"<p>Same as <code>each.cycle(n)</code>.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":""}],"args_string":"(n)","args_html":"(n)","location":{"filename":"src/iterable.cr","line_number":13,"url":null},"def":{"name":"cycle","args":[{"name":"n","external_name":"n","restriction":""}],"visibility":"Public","body":"each.cycle(n)"}},{"html_id":"cycle-instance-method","name":"cycle","doc":"Same as `each.cycle`.","summary":"<p>Same as <code>each.cycle</code>.</p>","abstract":false,"location":{"filename":"src/iterable.cr","line_number":8,"url":null},"def":{"name":"cycle","visibility":"Public","body":"each.cycle"}},{"html_id":"each-instance-method","name":"each","doc":"Must return an `Iterator` over the elements in this collection.","summary":"<p>Must return an <code><a href=\"Iterator.html\">Iterator</a></code> over the elements in this collection.</p>","abstract":true,"location":{"filename":"src/iterable.cr","line_number":5,"url":null},"def":{"name":"each","visibility":"Public","body":""}},{"html_id":"each_cons(count:Int,reuse=false)-instance-method","name":"each_cons","doc":"Same as `each.cons(count)`.","summary":"<p>Same as <code>each.cons(count)</code>.</p>","abstract":false,"args":[{"name":"count","external_name":"count","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(count : Int, reuse = false)","args_html":"(count : <a href=\"Int.html\">Int</a>, reuse = <span class=\"n\">false</span>)","location":{"filename":"src/iterable.cr","line_number":35,"url":null},"def":{"name":"each_cons","args":[{"name":"count","external_name":"count","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"visibility":"Public","body":"each.cons(count, reuse)"}},{"html_id":"each_slice(count:Int,reuse=false)-instance-method","name":"each_slice","doc":"Same as `each.slice(count, reuse)`.","summary":"<p>Same as <code>each.slice(count, reuse)</code>.</p>","abstract":false,"args":[{"name":"count","external_name":"count","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(count : Int, reuse = false)","args_html":"(count : <a href=\"Int.html\">Int</a>, reuse = <span class=\"n\">false</span>)","location":{"filename":"src/iterable.cr","line_number":30,"url":null},"def":{"name":"each_slice","args":[{"name":"count","external_name":"count","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"visibility":"Public","body":"each.slice(count, reuse)"}},{"html_id":"each_with_index(offset=0)-instance-method","name":"each_with_index","doc":"Same as `each.with_index(offset)`.","summary":"<p>Same as <code>each.with_index(offset)</code>.</p>","abstract":false,"args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(offset = 0)","args_html":"(offset = <span class=\"n\">0</span>)","location":{"filename":"src/iterable.cr","line_number":40,"url":null},"def":{"name":"each_with_index","args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"visibility":"Public","body":"each.with_index(offset)"}},{"html_id":"each_with_object(obj)-instance-method","name":"each_with_object","doc":"Same as `each.with_object(obj)`.","summary":"<p>Same as <code>each.with_object(obj)</code>.</p>","abstract":false,"args":[{"name":"obj","external_name":"obj","restriction":""}],"args_string":"(obj)","args_html":"(obj)","location":{"filename":"src/iterable.cr","line_number":45,"url":null},"def":{"name":"each_with_object","args":[{"name":"obj","external_name":"obj","restriction":""}],"visibility":"Public","body":"each.with_object(obj)"}},{"html_id":"slice_after(reuse:Bool|Array(T)=false,&block:T->B)forallB-instance-method","name":"slice_after","doc":"Same as `each.slice_after(reuse, &block)`.","summary":"<p>Same as <code>each.slice_after(reuse, &block)</code>.</p>","abstract":false,"args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"args_string":"(reuse : Bool | Array(T) = false, &block : T -> B) forall B","args_html":"(reuse : <a href=\"Bool.html\">Bool</a> | <a href=\"Array.html\">Array</a>(T) = <span class=\"n\">false</span>, &block : T -> B) forall B","location":{"filename":"src/iterable.cr","line_number":50,"url":null},"def":{"name":"slice_after","args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> B)"},"visibility":"Public","body":"each.slice_after(reuse, &block)"}},{"html_id":"slice_after(pattern,reuse:Bool|Array(T)=false)-instance-method","name":"slice_after","doc":"Same as `each.slice_after(pattern, reuse)`.","summary":"<p>Same as <code>each.slice_after(pattern, reuse)</code>.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"args_string":"(pattern, reuse : Bool | Array(T) = false)","args_html":"(pattern, reuse : <a href=\"Bool.html\">Bool</a> | <a href=\"Array.html\">Array</a>(T) = <span class=\"n\">false</span>)","location":{"filename":"src/iterable.cr","line_number":55,"url":null},"def":{"name":"slice_after","args":[{"name":"pattern","external_name":"pattern","restriction":""},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"visibility":"Public","body":"each.slice_after(pattern, reuse)"}},{"html_id":"slice_before(reuse:Bool|Array(T)=false,&block:T->B)forallB-instance-method","name":"slice_before","doc":"Same as `each.slice_before(reuse, &block)`.","summary":"<p>Same as <code>each.slice_before(reuse, &block)</code>.</p>","abstract":false,"args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"args_string":"(reuse : Bool | Array(T) = false, &block : T -> B) forall B","args_html":"(reuse : <a href=\"Bool.html\">Bool</a> | <a href=\"Array.html\">Array</a>(T) = <span class=\"n\">false</span>, &block : T -> B) forall B","location":{"filename":"src/iterable.cr","line_number":60,"url":null},"def":{"name":"slice_before","args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> B)"},"visibility":"Public","body":"each.slice_before(reuse, &block)"}},{"html_id":"slice_before(pattern,reuse:Bool|Array(T)=false)-instance-method","name":"slice_before","doc":"Same as `each.slice_before(pattern, reuse)`.","summary":"<p>Same as <code>each.slice_before(pattern, reuse)</code>.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"args_string":"(pattern, reuse : Bool | Array(T) = false)","args_html":"(pattern, reuse : <a href=\"Bool.html\">Bool</a> | <a href=\"Array.html\">Array</a>(T) = <span class=\"n\">false</span>)","location":{"filename":"src/iterable.cr","line_number":65,"url":null},"def":{"name":"slice_before","args":[{"name":"pattern","external_name":"pattern","restriction":""},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"visibility":"Public","body":"each.slice_before(pattern, reuse)"}},{"html_id":"slice_when(reuse:Bool|Array(T)=false,&block:T,T->B)forallB-instance-method","name":"slice_when","doc":"Same as `each.slice_when(reuse, &block)`.","summary":"<p>Same as <code>each.slice_when(reuse, &block)</code>.</p>","abstract":false,"args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"args_string":"(reuse : Bool | Array(T) = false, &block : T, T -> B) forall B","args_html":"(reuse : <a href=\"Bool.html\">Bool</a> | <a href=\"Array.html\">Array</a>(T) = <span class=\"n\">false</span>, &block : T, T -> B) forall B","location":{"filename":"src/iterable.cr","line_number":70,"url":null},"def":{"name":"slice_when","args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> B)"},"visibility":"Public","body":"each.slice_when(reuse, &block)"}}]},{"html_id":"Crystal/Iterator","path":"Iterator.html","kind":"module","full_name":"Iterator(T)","name":"Iterator","abstract":false,"ancestors":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"locations":[{"filename":"src/iterator.cr","line_number":74,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"including_types":[{"html_id":"Crystal/Steppable/StepIterator","kind":"class","full_name":"Steppable::StepIterator(T, L, B)","name":"StepIterator"}],"doc":"An `Iterator` allows processing sequences lazily, as opposed to `Enumerable` which processes\nsequences eagerly and produces an `Array` in most of its methods.\n\nAs an example, let's compute the first three numbers in the range `1..10_000_000` that are even,\nmultiplied by three. One way to do this is:\n\n```\n(1..10_000_000).select(&.even?).map { |x| x * 3 }.first(3) # => [6, 12, 18]\n```\n\nThe above works, but creates many intermediate arrays: one for the *select* call,\none for the *map* call and one for the *take* call. A more efficient way is to invoke\n`Range#each` without a block, which gives us an `Iterator` so we can process the operations\nlazily:\n\n```\n(1..10_000_000).each.select(&.even?).map { |x| x * 3 }.first(3) # => #< Iterator(T)::First...\n```\n\n`Iterator` redefines many of `Enumerable`'s method in a lazy way, returning iterators\ninstead of arrays.\n\nAt the end of the call chain we get back a new iterator: we need to consume it, either\nusing `each` or `Enumerable#to_a`:\n\n```\n(1..10_000_000).each.select(&.even?).map { |x| x * 3 }.first(3).to_a # => [6, 12, 18]\n```\n\nBecause iterators only go forward, when using methods that consume it entirely or partially –\n`to_a`, `any?`, `count`, `none?`, `one?` and `size` – subsequent calls will give a different\nresult as there will be less elements to consume.\n\n```\niter = (0...100).each\niter.size # => 100\niter.size # => 0\n```\n\nTo implement an `Iterator` you need to define a `next` method that must return the next\nelement in the sequence or `Iterator::Stop::INSTANCE`, which signals the end of the sequence\n(you can invoke `stop` inside an iterator as a shortcut).\n\nFor example, this is an iterator that returns a sequence of `N` zeros:\n\n```\nclass Zeros\n  include Iterator(Int32)\n\n  def initialize(@size : Int32)\n    @produced = 0\n  end\n\n  def next\n    if @produced < @size\n      @produced += 1\n      0\n    else\n      stop\n    end\n  end\nend\n\nzeros = Zeros.new(5)\nzeros.to_a # => [0, 0, 0, 0, 0]\n```\n\nThe standard library provides iterators for many classes, like `Array`, `Hash`, `Range`, `String` and `IO`.\nUsually to get an iterator you invoke a method that would usually yield elements to a block,\nbut without passing a block: `Array#each`, `Array#each_index`, `Hash#each`, `String#each_char`,\n`IO#each_line`, etc.","summary":"<p>An <code><a href=\"Iterator.html\">Iterator</a></code> allows processing sequences lazily, as opposed to <code><a href=\"Enumerable.html\">Enumerable</a></code> which processes sequences eagerly and produces an <code><a href=\"Array.html\">Array</a></code> in most of its methods.</p>","class_methods":[{"html_id":"chain(iters:Iterator(Iter))forallIter-class-method","name":"chain","doc":"The same as `#chain`, but have better performance when the quantity of\niterators to chain is large (usually greater than 4) or undetermined.\n\n```\narray_of_iters = [[1], [2, 3], [4, 5, 6]].each.map &.each\niter = Iterator(Int32).chain array_of_iters\niter.next # => 1\niter.next # => 2\niter.next # => 3\niter.next # => 4\n```","summary":"<p>The same as <code><a href=\"Iterator.html#chain%28other%3AIterator%28U%29%29forallU-instance-method\">#chain</a></code>, but have better performance when the quantity of iterators to chain is large (usually greater than 4) or undetermined.</p>","abstract":false,"args":[{"name":"iters","external_name":"iters","restriction":"Iterator(Iter)"}],"args_string":"(iters : Iterator(Iter)) forall Iter","args_html":"(iters : <a href=\"Iterator.html\">Iterator</a>(Iter)) forall Iter","location":{"filename":"src/iterator.cr","line_number":304,"url":null},"def":{"name":"chain","args":[{"name":"iters","external_name":"iters","restriction":"Iterator(Iter)"}],"visibility":"Public","body":"ChainsAll(Iter, typeof(iters.first.first)).new(iters)"}},{"html_id":"chain(iters:Iterable(Iter))forallIter-class-method","name":"chain","doc":"the same as `.chain(Iterator(Iter))`","summary":"<p>the same as <code><a href=\"Iterator.html#chain%28iters%3AIterator%28Iter%29%29forallIter-class-method\">.chain(Iterator(Iter)</a>)</code></p>","abstract":false,"args":[{"name":"iters","external_name":"iters","restriction":"Iterable(Iter)"}],"args_string":"(iters : Iterable(Iter)) forall Iter","args_html":"(iters : <a href=\"Iterable.html\">Iterable</a>(Iter)) forall Iter","location":{"filename":"src/iterator.cr","line_number":309,"url":null},"def":{"name":"chain","args":[{"name":"iters","external_name":"iters","restriction":"Iterable(Iter)"}],"visibility":"Public","body":"chain(iters.each)"}},{"html_id":"of(element:T)-class-method","name":"of","abstract":false,"args":[{"name":"element","external_name":"element","restriction":"T"}],"args_string":"(element : T)","args_html":"(element : T)","location":{"filename":"src/iterator.cr","line_number":107,"url":null},"def":{"name":"of","args":[{"name":"element","external_name":"element","restriction":"T"}],"visibility":"Public","body":"Singleton(T).new(element)"}},{"html_id":"of(&block:->T)-class-method","name":"of","abstract":false,"location":{"filename":"src/iterator.cr","line_number":122,"url":null},"def":{"name":"of","yields":0,"block_arg":{"name":"block","external_name":"block","restriction":"(-> T)"},"visibility":"Public","body":"SingletonProc(typeof(without_stop(&block))).new(block)"}},{"html_id":"stop-class-method","name":"stop","doc":"Shortcut for `Iterator::Stop::INSTANCE`, to signal that there are no more elements in an iterator.","summary":"<p>Shortcut for <code><a href=\"Iterator/Stop.html#INSTANCE\">Iterator::Stop::INSTANCE</a></code>, to signal that there are no more elements in an iterator.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":103,"url":null},"def":{"name":"stop","visibility":"Public","body":"Stop::INSTANCE"}}],"instance_methods":[{"html_id":"accumulate(initial:U)forallU-instance-method","name":"accumulate","doc":"Returns an iterator that returns *initial* and its prefix sums with the\noriginal iterator's elements.\n\nExpects `U` to respond to the `#+` method.\n\n```\niter = (3..6).each.accumulate(7)\niter.next # => 7\niter.next # => 10\niter.next # => 14\niter.next # => 19\niter.next # => 25\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that returns <em>initial</em> and its prefix sums with the original iterator's elements.</p>","abstract":false,"args":[{"name":"initial","external_name":"initial","restriction":"U"}],"args_string":"(initial : U) forall U","args_html":"(initial : U) forall U","location":{"filename":"src/iterator.cr","line_number":178,"url":null},"def":{"name":"accumulate","args":[{"name":"initial","external_name":"initial","restriction":"U"}],"visibility":"Public","body":"accumulate(initial) do |x, y|\n  x + y\nend"}},{"html_id":"accumulate-instance-method","name":"accumulate","doc":"Returns an iterator that returns the prefix sums of the original iterator's\nelements.\n\nExpects `T` to respond to the `#+` method.\n\n```\niter = (3..6).each.accumulate\niter.next # => 3\niter.next # => 7\niter.next # => 12\niter.next # => 18\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that returns the prefix sums of the original iterator's elements.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":160,"url":null},"def":{"name":"accumulate","visibility":"Public","body":"accumulate do |x, y|\n  x + y\nend"}},{"html_id":"accumulate(initial:U,&block:U,T->U)forallU-instance-method","name":"accumulate","doc":"Returns an iterator that accumulates *initial* with the original iterator's\nelements by the given *block*.\n\nSimilar to `#accumulate(&block : T, T -> T)`, except the initial value is\nprovided by an argument and needs not have the same type as the elements of\nthe original iterator. This initial value is returned first.\n\n```\niter = [4, 3, 2].each.accumulate(\"X\") { |x, y| x * y }\niter.next # => \"X\"\niter.next # => \"XXXX\"\niter.next # => \"XXXXXXXXXXXX\"\niter.next # => \"XXXXXXXXXXXXXXXXXXXXXXXX\"\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that accumulates <em>initial</em> with the original iterator's elements by the given <em>block</em>.</p>","abstract":false,"args":[{"name":"initial","external_name":"initial","restriction":"U"}],"args_string":"(initial : U, &block : U, T -> U) forall U","args_html":"(initial : U, &block : U, T -> U) forall U","location":{"filename":"src/iterator.cr","line_number":217,"url":null},"def":{"name":"accumulate","args":[{"name":"initial","external_name":"initial","restriction":"U"}],"yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(U, T -> U)"},"visibility":"Public","body":"AccumulateInit(typeof(self), T, U).new(self, initial, block)"}},{"html_id":"accumulate(&block:T,T->T)-instance-method","name":"accumulate","doc":"Returns an iterator that accumulates the original iterator's elements by\nthe given *block*.\n\nFor each element of the original iterator the block is passed an accumulator\nvalue and the element. The result becomes the new value for the accumulator\nand is then returned. The initial value for the accumulator is the first\nelement of the original iterator.\n\n```\niter = %w(the quick brown fox).each.accumulate { |x, y| \"#{x}, #{y}\" }\niter.next # => \"the\"\niter.next # => \"the, quick\"\niter.next # => \"the, quick, brown\"\niter.next # => \"the, quick, brown, fox\"\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that accumulates the original iterator's elements by the given <em>block</em>.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":198,"url":null},"def":{"name":"accumulate","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> T)"},"visibility":"Public","body":"Accumulate(typeof(self), T).new(self, block)"}},{"html_id":"chain(other:Iterator(U))forallU-instance-method","name":"chain","doc":"Returns an iterator that returns elements from the original iterator until\nit is exhausted and then returns the elements of the second iterator.\nCompared to `.chain(Iterator(Iter))`, it has better performance when the quantity of\niterators to chain is small (usually less than 4).\nThis method also cannot chain iterators in a loop, for that see `.chain(Iterator(Iter))`.\n\n```\niter = (1..2).each.chain(('a'..'b').each)\niter.next # => 1\niter.next # => 2\niter.next # => 'a'\niter.next # => 'b'\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that returns elements from the original iterator until it is exhausted and then returns the elements of the second iterator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Iterator(U)"}],"args_string":"(other : Iterator(U)) forall U","args_html":"(other : <a href=\"Iterator.html\">Iterator</a>(U)) forall U","location":{"filename":"src/iterator.cr","line_number":268,"url":null},"def":{"name":"chain","args":[{"name":"other","external_name":"other","restriction":"Iterator(U)"}],"visibility":"Public","body":"Chain(typeof(self), typeof(other), T, U).new(self, other)"}},{"html_id":"chunk(reuse=false,&block:T->U)forallT,U-instance-method","name":"chunk","doc":"Returns an Iterator that enumerates over the items,\nchunking them together based on the return value of the block.\n\nConsecutive elements which return the same block value are chunked together.\n\nFor example, consecutive even numbers and odd numbers can be chunked as follows.\n\n```\n[3, 1, 4, 1, 5, 9, 2, 6, 5, 3, 5].chunk(&.even?).each do |even, ary|\n  p [even, ary]\nend\n\n# => [false, [3, 1]]\n#    [true, [4]]\n#    [false, [1, 5, 9]]\n#    [true, [2, 6]]\n#    [false, [5, 3, 5]]\n```\n\nThe following key values have special meaning:\n\n* `Enumerable::Chunk::Drop` specifies that the elements should be dropped\n* `Enumerable::Chunk::Alone` specifies that the element should be chunked by itself\n\nBy default, a new array is created and yielded for each chunk when invoking `next`.\n* If *reuse* is given, the array can be reused\n* If *reuse* is an `Array`, this array will be reused\n* If *reuse* is truthy, the method will create a new array and reuse it.\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.\n\nSee also: `Enumerable#chunks`.","summary":"<p>Returns an Iterator that enumerates over the items, chunking them together based on the return value of the block.</p>","abstract":false,"args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(reuse = false, &block : T -> U) forall T, U","args_html":"(reuse = <span class=\"n\">false</span>, &block : T -> U) forall T, U","location":{"filename":"src/iterator.cr","line_number":1458,"url":null},"def":{"name":"chunk","args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> U)"},"visibility":"Public","body":"Chunk(typeof(self), T, U).new(self, reuse, &block)"}},{"html_id":"chunk_while(reuse:Bool|Array(T)=false,&block:T,T->B)forallB-instance-method","name":"chunk_while","doc":"Returns an iterator for each chunked elements where elements\nare kept in a given chunk as long as the block's value over\na pair of elements is _truthy_.\n\nFor example, one-by-one increasing subsequences can be chunked as follows:\n\n```\nary = [1, 2, 4, 9, 10, 11, 12, 15, 16, 19, 20, 21]\niter = ary.chunk_while { |i, j| i + 1 == j }\niter.next # => [1, 2]\niter.next # => [4]\niter.next # => [9, 10, 11, 12]\niter.next # => [15, 16]\niter.next # => [19, 20, 21]\niter.next # => Iterator::Stop::INSTANCE\n```\n\nBy default, a new array is created and yielded for each slice when invoking `next`.\n* If *reuse* is `false`, the method will create a new array for each chunk\n* If *reuse* is `true`, the method will create a new array and reuse it.\n* If *reuse* is an `Array`, that array will be reused\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.\n\nSee also `#slice_when`, which works similarly but the block's condition is inverted.","summary":"<p>Returns an iterator for each chunked elements where elements are kept in a given chunk as long as the block's value over a pair of elements is <em>truthy</em>.</p>","abstract":false,"args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"args_string":"(reuse : Bool | Array(T) = false, &block : T, T -> B) forall B","args_html":"(reuse : <a href=\"Bool.html\">Bool</a> | <a href=\"Array.html\">Array</a>(T) = <span class=\"n\">false</span>, &block : T, T -> B) forall B","location":{"filename":"src/iterator.cr","line_number":1780,"url":null},"def":{"name":"chunk_while","args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> B)"},"visibility":"Public","body":"SliceWhen(typeof(self), T, B).new(self, block, reuse, negate: true)"}},{"html_id":"compact_map(&func:T->_)-instance-method","name":"compact_map","doc":"Returns an iterator that applies the given function to the element and then\nreturns it unless it is `nil`. If the returned value would be `nil` it instead\nreturns the next non `nil` value.\n\n```\niter = [1, nil, 2, nil].each.compact_map { |e| e.try &.*(2) }\niter.next # => 2\niter.next # => 4\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that applies the given function to the element and then returns it unless it is <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":344,"url":null},"def":{"name":"compact_map","yields":1,"block_arg":{"name":"func","external_name":"func","restriction":"(T -> _)"},"visibility":"Public","body":"CompactMap(typeof(self), T, typeof((func.call(first)).not_nil!)).new(self, func)"}},{"html_id":"cons(n:Int,reuse=false)-instance-method","name":"cons","doc":"Returns an iterator that returns consecutive chunks of the size *n*.\n\n```\niter = (1..5).each.cons(3)\niter.next # => [1, 2, 3]\niter.next # => [2, 3, 4]\niter.next # => [3, 4, 5]\niter.next # => Iterator::Stop::INSTANCE\n```\n\nBy default, a new array is created and returned for each consecutive call of `next`.\n* If *reuse* is given, the array can be reused\n* If *reuse* is `true`, the method will create a new array and reuse it.\n* If *reuse*  is an instance of `Array`, `Deque` or a similar collection type (implementing `#<<`, `#shift` and `#size`) it will be used.\n* If *reuse* is falsey, the array will not be reused.\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.\n\nChunks of two items can be iterated using `#cons_pair`, an optimized\nimplementation for the special case of `n == 2` which avoids heap\nallocations.","summary":"<p>Returns an iterator that returns consecutive chunks of the size <em>n</em>.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(n : Int, reuse = false)","args_html":"(n : <a href=\"Int.html\">Int</a>, reuse = <span class=\"n\">false</span>)","location":{"filename":"src/iterator.cr","line_number":387,"url":null},"def":{"name":"cons","args":[{"name":"n","external_name":"n","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"visibility":"Public","body":"if n <= 0\n  raise(ArgumentError.new(\"Invalid cons size: #{n}\"))\nend\nif reuse.nil? || reuse.is_a?(Bool)\n  Cons(typeof(self), T, typeof(n), Array(T)).new(self, n, Array(T).new(n * 2), reuse)\nelse\n  Cons(typeof(self), T, typeof(n), typeof(reuse)).new(self, n, reuse, reuse)\nend\n"}},{"html_id":"cons_pair:Iterator(Tuple(T,T))-instance-method","name":"cons_pair","doc":"Returns an iterator that returns consecutive pairs of adjacent items.\n\n```\niter = (1..5).each.cons_pair\niter.next # => {1, 2}\niter.next # => {2, 3}\niter.next # => {3, 4}\niter.next # => {4, 5}\niter.next # => Iterator::Stop::INSTANCE\n```\n\nChunks of more than two items can be iterated using `#cons`.\nThis method is just an optimized implementation for the special case of\n`n == 2` to avoid heap allocations.","summary":"<p>Returns an iterator that returns consecutive pairs of adjacent items.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":437,"url":null},"def":{"name":"cons_pair","return_type":"Iterator(::Tuple(T, T))","visibility":"Public","body":"ConsTuple(typeof(self), T).new(self)"}},{"html_id":"cycle(n:Int)-instance-method","name":"cycle","doc":"Returns an iterator that repeatedly returns the elements of the original\niterator starting back at the beginning when the end was reached,\nbut only *n* times.\n\n```\niter = [\"a\", \"b\", \"c\"].each.cycle(2)\niter.next # => \"a\"\niter.next # => \"b\"\niter.next # => \"c\"\niter.next # => \"a\"\niter.next # => \"b\"\niter.next # => \"c\"\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that repeatedly returns the elements of the original iterator starting back at the beginning when the end was reached, but only <em>n</em> times.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"}],"args_string":"(n : Int)","args_html":"(n : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/iterator.cr","line_number":535,"url":null},"def":{"name":"cycle","args":[{"name":"n","external_name":"n","restriction":"Int"}],"visibility":"Public","body":"CycleN(typeof(self), T, typeof(n)).new(self, n)"}},{"html_id":"cycle-instance-method","name":"cycle","doc":"Returns an iterator that repeatedly returns the elements of the original\niterator forever starting back at the beginning when the end was reached.\n\n```\niter = [\"a\", \"b\", \"c\"].each.cycle\niter.next # => \"a\"\niter.next # => \"b\"\niter.next # => \"c\"\niter.next # => \"a\"\niter.next # => \"b\"\niter.next # => \"c\"\niter.next # => \"a\"\n# and so an and so on\n```","summary":"<p>Returns an iterator that repeatedly returns the elements of the original iterator forever starting back at the beginning when the end was reached.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":479,"url":null},"def":{"name":"cycle","visibility":"Public","body":"Cycle(typeof(self), T).new(self)"}},{"html_id":"each-instance-method","name":"each","abstract":false,"location":{"filename":"src/iterator.cr","line_number":584,"url":null},"def":{"name":"each","visibility":"Public","body":"self"}},{"html_id":"each(&:T->):Nil-instance-method","name":"each","doc":"Calls the given block once for each element, passing that element\nas a parameter.\n\n```\niter = [\"a\", \"b\", \"c\"].each\niter.each { |x| print x, \" \" } # Prints \"a b c\"\n```","summary":"<p>Calls the given block once for each element, passing that element as a parameter.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":595,"url":null},"def":{"name":"each","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"Nil","visibility":"Public","body":"while true\n  value = self.next\n  if value.is_a?(Stop)\n    break\n  end\n  yield value\nend"}},{"html_id":"each_slice(n,reuse=false)-instance-method","name":"each_slice","doc":"Returns an iterator that then returns slices of *n* elements of the initial\niterator.\n\n```\niter = (1..9).each.each_slice(3)\niter.next # => [1, 2, 3]\niter.next # => [4, 5, 6]\niter.next # => [7, 8, 9]\niter.next # => Iterator::Stop::INSTANCE\n```\n\nBy default, a new array is created and yielded for each consecutive when invoking `next`.\n* If *reuse* is given, the array can be reused\n* If *reuse* is an `Array`, this array will be reused\n* If *reuse* is truthy, the method will create a new array and reuse it.\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Returns an iterator that then returns slices of <em>n</em> elements of the initial iterator.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":""},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(n, reuse = false)","args_html":"(n, reuse = <span class=\"n\">false</span>)","location":{"filename":"src/iterator.cr","line_number":621,"url":null},"def":{"name":"each_slice","args":[{"name":"n","external_name":"n","restriction":""},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"visibility":"Public","body":"slice(n, reuse)"}},{"html_id":"first(n:Int)-instance-method","name":"first","doc":"Returns an iterator that only returns the first *n* elements of the\ninitial iterator.\n\n```\niter = [\"a\", \"b\", \"c\"].each.first 2\niter.next # => \"a\"\niter.next # => \"b\"\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns the first <em>n</em> elements of the initial iterator.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"}],"args_string":"(n : Int)","args_html":"(n : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/iterator.cr","line_number":1167,"url":null},"def":{"name":"first","args":[{"name":"n","external_name":"n","restriction":"Int"}],"visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Attempted to take negative size: #{n}\"))\nend\nFirst(typeof(self), T, typeof(n)).new(self, n)\n"}},{"html_id":"flat_map(&func:T->_)-instance-method","name":"flat_map","doc":"Returns a new iterator with the concatenated results of running the block\nonce for every element in the collection.\nOnly `Array` and `Iterator` results are concatenated; every other value is\nreturned once in the new iterator.\n\n```\niter = [1, 2, 3].each.flat_map { |x| [x, x] }\n\niter.next # => 1\niter.next # => 1\niter.next # => 2\n\niter = [1, 2, 3].each.flat_map { |x| [x, x].each }\n\niter.to_a # => [1, 1, 2, 2, 3, 3]\n```","summary":"<p>Returns a new iterator with the concatenated results of running the block once for every element in the collection.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":717,"url":null},"def":{"name":"flat_map","yields":1,"block_arg":{"name":"func","external_name":"func","restriction":"(T -> _)"},"visibility":"Public","body":"FlatMap(typeof(self), typeof(FlatMap.element_type(self, func)), typeof(FlatMap.iterator_type(self, func)), typeof(func)).new(self, func)"}},{"html_id":"flatten-instance-method","name":"flatten","doc":"Returns an iterator that flattens nested iterators and arrays into a single iterator\nwhose type is the union of the simple types of all of the nested iterators and arrays\n(and their nested iterators and arrays, and so on).\n\n```\niter = [(1..2).each, ('a'..'b').each].each.flatten\niter.next # => 1\niter.next # => 2\niter.next # => 'a'\niter.next # => 'b'\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that flattens nested iterators and arrays into a single iterator whose type is the union of the simple types of all of the nested iterators and arrays (and their nested iterators and arrays, and so on).</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":637,"url":null},"def":{"name":"flatten","visibility":"Public","body":"Flatten(typeof(Flatten.iterator_type(self)), typeof(Flatten.element_type(self))).new(self)"}},{"html_id":"in_groups_of(size:Int,filled_up_with=nil,reuse=false)-instance-method","name":"in_groups_of","doc":"Returns an iterator that chunks the iterator's elements in arrays of *size*\nfilling up the remaining elements if no element remains with `nil` or a given\noptional parameter.\n\n```\niter = (1..3).each.in_groups_of(2)\niter.next # => [1, 2]\niter.next # => [3, nil]\niter.next # => Iterator::Stop::INSTANCE\n```\n```\niter = (1..3).each.in_groups_of(2, 'z')\niter.next # => [1, 2]\niter.next # => [3, 'z']\niter.next # => Iterator::Stop::INSTANCE\n```\n\nBy default, a new array is created and yielded for each group.\n* If *reuse* is given, the array can be reused\n* If *reuse* is an `Array`, this array will be reused\n* If *reuse* is truthy, the method will create a new array and reuse it.\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Returns an iterator that chunks the iterator's elements in arrays of <em>size</em> filling up the remaining elements if no element remains with <code>nil</code> or a given optional parameter.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"filled_up_with","default_value":"nil","external_name":"filled_up_with","restriction":""},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(size : Int, filled_up_with = nil, reuse = false)","args_html":"(size : <a href=\"Int.html\">Int</a>, filled_up_with = <span class=\"n\">nil</span>, reuse = <span class=\"n\">false</span>)","location":{"filename":"src/iterator.cr","line_number":810,"url":null},"def":{"name":"in_groups_of","args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"filled_up_with","default_value":"nil","external_name":"filled_up_with","restriction":""},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"visibility":"Public","body":"if size <= 0\n  raise(ArgumentError.new(\"Size must be positive\"))\nend\nInGroupsOf(typeof(self), T, typeof(size), typeof(filled_up_with)).new(self, size, filled_up_with, reuse)\n"}},{"html_id":"map(&func:T->U)forallU-instance-method","name":"map","doc":"Returns an iterator that applies the given block to the next element and\nreturns the result.\n\n```\niter = [1, 2, 3].each.map &.*(2)\niter.next # => 2\niter.next # => 4\niter.next # => 6\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that applies the given block to the next element and returns the result.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":863,"url":null},"def":{"name":"map","yields":1,"block_arg":{"name":"func","external_name":"func","restriction":"(T -> U)"},"visibility":"Public","body":"Map(typeof(self), T, U).new(self, func)"}},{"html_id":"next-instance-method","name":"next","doc":"Returns the next element in this iterator, or `Iterator::Stop::INSTANCE` if there\nare no more elements.","summary":"<p>Returns the next element in this iterator, or <code><a href=\"Iterator/Stop.html#INSTANCE\">Iterator::Stop::INSTANCE</a></code> if there are no more elements.</p>","abstract":true,"location":{"filename":"src/iterator.cr","line_number":145,"url":null},"def":{"name":"next","visibility":"Public","body":""}},{"html_id":"reject(&func:T->U)forallU-instance-method","name":"reject","doc":"Returns an iterator that only returns elements for which the passed in\nblock returns a falsey value.\n\n```\niter = [1, 2, 3].each.reject &.odd?\niter.next # => 2\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns elements for which the passed in block returns a falsey value.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":888,"url":null},"def":{"name":"reject","yields":1,"block_arg":{"name":"func","external_name":"func","restriction":"(T -> U)"},"visibility":"Public","body":"Reject(typeof(self), T, U).new(self, func)"}},{"html_id":"reject(type:U.class)forallU-instance-method","name":"reject","doc":"Returns an iterator that only returns elements\nthat are **not** of the given *type*.\n\n```\niter = [1, false, 3, true].each.reject(Bool)\niter.next # => 1\niter.next # => 3\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns elements that are <strong>not</strong> of the given <em>type</em>.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"U.class"}],"args_string":"(type : U.class) forall U","args_html":"(type : <span class=\"t\">U</span>.<span class=\"k\">class</span>) forall U","location":{"filename":"src/iterator.cr","line_number":901,"url":null},"def":{"name":"reject","args":[{"name":"type","external_name":"type","restriction":"U.class"}],"visibility":"Public","body":"SelectType(typeof(self), typeof(begin\n  e = first\n  e.is_a?(U) ? raise(\"\") : e\nend)).new(self)"}},{"html_id":"reject(pattern)-instance-method","name":"reject","doc":"Returns an iterator that only returns elements\nwhere `pattern === element` does not hold.\n\n```\niter = [2, 3, 1, 5, 4, 6].each.reject(3..5)\niter.next # => 2\niter.next # => 1\niter.next # => 6\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns elements where <code>pattern === element</code> does not hold.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern)","args_html":"(pattern)","location":{"filename":"src/iterator.cr","line_number":918,"url":null},"def":{"name":"reject","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"visibility":"Public","body":"reject do |elem|\n  pattern === elem\nend"}},{"html_id":"select(&func:T->U)forallU-instance-method","name":"select","doc":"Returns an iterator that only returns elements for which the passed\nin block returns a truthy value.\n\n```\niter = [1, 2, 3].each.select &.odd?\niter.next # => 1\niter.next # => 3\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns elements for which the passed in block returns a truthy value.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":948,"url":null},"def":{"name":"select","yields":1,"block_arg":{"name":"func","external_name":"func","restriction":"(T -> U)"},"visibility":"Public","body":"Select(typeof(self), T, U).new(self, func)"}},{"html_id":"select(type:U.class)forallU-instance-method","name":"select","doc":"Returns an iterator that only returns elements\nof the given *type*.\n\n```\niter = [1, false, 3, nil].each.select(Int32)\niter.next # => 1\niter.next # => 3\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns elements of the given <em>type</em>.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"U.class"}],"args_string":"(type : U.class) forall U","args_html":"(type : <span class=\"t\">U</span>.<span class=\"k\">class</span>) forall U","location":{"filename":"src/iterator.cr","line_number":961,"url":null},"def":{"name":"select","args":[{"name":"type","external_name":"type","restriction":"U.class"}],"visibility":"Public","body":"SelectType(typeof(self), U).new(self)"}},{"html_id":"select(pattern)-instance-method","name":"select","doc":"Returns an iterator that only returns elements\nwhere `pattern === element`.\n\n```\niter = [1, 3, 2, 5, 4, 6].each.select(3..5)\niter.next # => 3\niter.next # => 5\niter.next # => 4\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns elements where <code>pattern === element</code>.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern)","args_html":"(pattern)","location":{"filename":"src/iterator.cr","line_number":975,"url":null},"def":{"name":"select","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"visibility":"Public","body":"self.select do |elem|\n  pattern === elem\nend"}},{"html_id":"skip(n:Int)-instance-method","name":"skip","doc":"Returns an iterator that skips the first *n* elements and only returns\nthe elements after that.\n\n```\niter = (1..3).each.skip(2)\niter.next # -> 3\niter.next # -> Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that skips the first <em>n</em> elements and only returns the elements after that.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"}],"args_string":"(n : Int)","args_html":"(n : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/iterator.cr","line_number":1021,"url":null},"def":{"name":"skip","args":[{"name":"n","external_name":"n","restriction":"Int"}],"visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Attempted to skip negative size: #{n}\"))\nend\nSkip(typeof(self), T, typeof(n)).new(self, n)\n"}},{"html_id":"skip_while(&func:T->U)forallU-instance-method","name":"skip_while","doc":"Returns an iterator that only starts to return elements once the given block\nhas returned falsey value for one element.\n\n```\niter = [1, 2, 3, 4, 0].each.skip_while { |i| i < 3 }\niter.next # => 3\niter.next # => 4\niter.next # => 0\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only starts to return elements once the given block has returned falsey value for one element.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":1053,"url":null},"def":{"name":"skip_while","yields":1,"block_arg":{"name":"func","external_name":"func","restriction":"(T -> U)"},"visibility":"Public","body":"SkipWhile(typeof(self), T, U).new(self, func)"}},{"html_id":"slice(n:Int,reuse=false)-instance-method","name":"slice","doc":"Alias of `each_slice`.","summary":"<p>Alias of <code><a href=\"Iterator.html#each_slice%28n%2Creuse%3Dfalse%29-instance-method\">#each_slice</a></code>.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"args_string":"(n : Int, reuse = false)","args_html":"(n : <a href=\"Int.html\">Int</a>, reuse = <span class=\"n\">false</span>)","location":{"filename":"src/iterator.cr","line_number":1078,"url":null},"def":{"name":"slice","args":[{"name":"n","external_name":"n","restriction":"Int"},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":""}],"visibility":"Public","body":"if n <= 0\n  raise(ArgumentError.new(\"Invalid slice size: #{n}\"))\nend\nSlice(typeof(self), T, typeof(n)).new(self, n, reuse)\n"}},{"html_id":"slice_after(reuse:Bool|Array(T)=false,&block:T->B)forallB-instance-method","name":"slice_after","doc":"Returns an iterator over chunks of elements, where each\nchunk ends right **after** the given block's value is _truthy_.\n\nFor example, to get chunks that end at each uppercase letter:\n\n```\nary = ['a', 'b', 'C', 'd', 'E', 'F', 'g', 'h']\n#                   ^         ^    ^\niter = ary.slice_after(&.uppercase?)\niter.next # => ['a', 'b', 'C']\niter.next # => ['d', 'E']\niter.next # => ['F']\niter.next # => ['g', 'h']\niter.next # => Iterator::Stop::INSTANCE\n```\n\nBy default, a new array is created and yielded for each slice when invoking `next`.\n* If *reuse* is `false`, the method will create a new array for each chunk\n* If *reuse* is `true`, the method will create a new array and reuse it.\n* If *reuse* is an `Array`, that array will be reused\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Returns an iterator over chunks of elements, where each chunk ends right <strong>after</strong> the given block's value is <em>truthy</em>.</p>","abstract":false,"args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"args_string":"(reuse : Bool | Array(T) = false, &block : T -> B) forall B","args_html":"(reuse : <a href=\"Bool.html\">Bool</a> | <a href=\"Array.html\">Array</a>(T) = <span class=\"n\">false</span>, &block : T -> B) forall B","location":{"filename":"src/iterator.cr","line_number":1530,"url":null},"def":{"name":"slice_after","args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> B)"},"visibility":"Public","body":"SliceAfter(typeof(self), T, B).new(self, block, reuse)"}},{"html_id":"slice_after(pattern,reuse:Bool|Array(T)=false)-instance-method","name":"slice_after","doc":"Returns an iterator over chunks of elements, where each\nchunk ends right **after** the given pattern is matched\nwith `pattern === element`.\n\nFor example, to get chunks that end at each ASCII uppercase letter:\n\n```\nary = ['a', 'b', 'C', 'd', 'E', 'F', 'g', 'h']\n#                   ^         ^    ^\niter = ary.slice_after('A'..'Z')\niter.next # => ['a', 'b', 'C']\niter.next # => ['d', 'E']\niter.next # => ['F']\niter.next # => ['g', 'h']\niter.next # => Iterator::Stop::INSTANCE\n```\n\nBy default, a new array is created and yielded for each slice when invoking `next`.\n* If *reuse* is `false`, the method will create a new array for each chunk\n* If *reuse* is `true`, the method will create a new array and reuse it.\n* If *reuse* is an `Array`, that array will be reused\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Returns an iterator over chunks of elements, where each chunk ends right <strong>after</strong> the given pattern is matched with <code>pattern === element</code>.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"args_string":"(pattern, reuse : Bool | Array(T) = false)","args_html":"(pattern, reuse : <a href=\"Bool.html\">Bool</a> | <a href=\"Array.html\">Array</a>(T) = <span class=\"n\">false</span>)","location":{"filename":"src/iterator.cr","line_number":1558,"url":null},"def":{"name":"slice_after","args":[{"name":"pattern","external_name":"pattern","restriction":""},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"visibility":"Public","body":"slice_after(reuse) do |elem|\n  pattern === elem\nend"}},{"html_id":"slice_before(reuse:Bool|Array(T)=false,&block:T->B)forallB-instance-method","name":"slice_before","doc":"Returns an iterator over chunks of elements, where each\nchunk ends right **before** the given block's value is _truthy_.\n\nFor example, to get chunks that end just before each uppercase letter:\n\n```\nary = ['a', 'b', 'C', 'd', 'E', 'F', 'g', 'h']\n#              ^         ^    ^\niter = ary.slice_before(&.uppercase?)\niter.next # => ['a', 'b']\niter.next # => ['C', 'd']\niter.next # => ['E']\niter.next # => ['F', 'g', 'h']\niter.next # => Iterator::Stop::INSTANCE\n```\n\nBy default, a new array is created and yielded for each slice when invoking `next`.\n* If *reuse* is `false`, the method will create a new array for each chunk\n* If *reuse* is `true`, the method will create a new array and reuse it.\n* If *reuse* is an `Array`, that array will be reused\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Returns an iterator over chunks of elements, where each chunk ends right <strong>before</strong> the given block's value is <em>truthy</em>.</p>","abstract":false,"args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"args_string":"(reuse : Bool | Array(T) = false, &block : T -> B) forall B","args_html":"(reuse : <a href=\"Bool.html\">Bool</a> | <a href=\"Array.html\">Array</a>(T) = <span class=\"n\">false</span>, &block : T -> B) forall B","location":{"filename":"src/iterator.cr","line_number":1636,"url":null},"def":{"name":"slice_before","args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> B)"},"visibility":"Public","body":"SliceBefore(typeof(self), T, B).new(self, block, reuse)"}},{"html_id":"slice_before(pattern,reuse:Bool|Array(T)=false)-instance-method","name":"slice_before","doc":"Returns an iterator over chunks of elements, where each\nchunk ends right **before** the given pattern is matched\nwith `pattern === element`.\n\nFor example, to get chunks that end just before each ASCII uppercase letter:\n\n```\nary = ['a', 'b', 'C', 'd', 'E', 'F', 'g', 'h']\n#              ^         ^    ^\niter = ary.slice_before('A'..'Z')\niter.next # => ['a', 'b']\niter.next # => ['C', 'd']\niter.next # => ['E']\niter.next # => ['F', 'g', 'h']\niter.next # => Iterator::Stop::INSTANCE\n```\n\nBy default, a new array is created and yielded for each slice when invoking `next`.\n* If *reuse* is `false`, the method will create a new array for each chunk\n* If *reuse* is `true`, the method will create a new array and reuse it.\n* If *reuse* is an `Array`, that array will be reused\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.","summary":"<p>Returns an iterator over chunks of elements, where each chunk ends right <strong>before</strong> the given pattern is matched with <code>pattern === element</code>.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"args_string":"(pattern, reuse : Bool | Array(T) = false)","args_html":"(pattern, reuse : <a href=\"Bool.html\">Bool</a> | <a href=\"Array.html\">Array</a>(T) = <span class=\"n\">false</span>)","location":{"filename":"src/iterator.cr","line_number":1664,"url":null},"def":{"name":"slice_before","args":[{"name":"pattern","external_name":"pattern","restriction":""},{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"visibility":"Public","body":"slice_before(reuse) do |elem|\n  pattern === elem\nend"}},{"html_id":"slice_when(reuse:Bool|Array(T)=false,&block:T,T->B)forallB-instance-method","name":"slice_when","doc":"Returns an iterator for each chunked elements where the ends\nof chunks are defined by the block, when the block's value\nover a pair of elements is _truthy_.\n\nFor example, one-by-one increasing subsequences can be chunked as follows:\n\n```\nary = [1, 2, 4, 9, 10, 11, 12, 15, 16, 19, 20, 21]\niter = ary.slice_when { |i, j| i + 1 != j }\niter.next # => [1, 2]\niter.next # => [4]\niter.next # => [9, 10, 11, 12]\niter.next # => [15, 16]\niter.next # => [19, 20, 21]\niter.next # => Iterator::Stop::INSTANCE\n```\n\nBy default, a new array is created and yielded for each slice when invoking `next`.\n* If *reuse* is `false`, the method will create a new array for each chunk\n* If *reuse* is `true`, the method will create a new array and reuse it.\n* If *reuse* is an `Array`, that array will be reused\n\nThis can be used to prevent many memory allocations when each slice of\ninterest is to be used in a read-only fashion.\n\nSee also `#chunk_while`, which works similarly but the block's condition is inverted.","summary":"<p>Returns an iterator for each chunked elements where the ends of chunks are defined by the block, when the block's value over a pair of elements is <em>truthy</em>.</p>","abstract":false,"args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"args_string":"(reuse : Bool | Array(T) = false, &block : T, T -> B) forall B","args_html":"(reuse : <a href=\"Bool.html\">Bool</a> | <a href=\"Array.html\">Array</a>(T) = <span class=\"n\">false</span>, &block : T, T -> B) forall B","location":{"filename":"src/iterator.cr","line_number":1750,"url":null},"def":{"name":"slice_when","args":[{"name":"reuse","default_value":"false","external_name":"reuse","restriction":"Bool | Array(T)"}],"yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> B)"},"visibility":"Public","body":"SliceWhen(typeof(self), T, B).new(self, block, reuse)"}},{"html_id":"step(n:Int)-instance-method","name":"step","doc":"Returns an iterator that only returns every *n*th element, starting with the\nfirst.\n\n```\niter = (1..6).each.step(2)\niter.next # => 1\niter.next # => 3\niter.next # => 5\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns every <em>n</em>th element, starting with the first.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"}],"args_string":"(n : Int)","args_html":"(n : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/iterator.cr","line_number":1134,"url":null},"def":{"name":"step","args":[{"name":"n","external_name":"n","restriction":"Int"}],"visibility":"Public","body":"Step(self, T, typeof(n)).new(self, n)"}},{"html_id":"stop-instance-method","name":"stop","doc":"Shortcut for `Iterator::Stop::INSTANCE`, to signal that there are no more elements in an iterator.","summary":"<p>Shortcut for <code><a href=\"Iterator/Stop.html#INSTANCE\">Iterator::Stop::INSTANCE</a></code>, to signal that there are no more elements in an iterator.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":98,"url":null},"def":{"name":"stop","visibility":"Public","body":"Iterator.stop"}},{"html_id":"take_while(&func:T->U)forallU-instance-method","name":"take_while","doc":"Returns an iterator that returns elements while the given block returns a\ntruthy value.\n\n```\niter = (1..5).each.take_while { |i| i < 3 }\niter.next # => 1\niter.next # => 2\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that returns elements while the given block returns a truthy value.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":1199,"url":null},"def":{"name":"take_while","yields":1,"block_arg":{"name":"func","external_name":"func","restriction":"(T -> U)"},"visibility":"Public","body":"TakeWhile(typeof(self), T, U).new(self, func)"}},{"html_id":"tap(&block:T->)-instance-method","name":"tap","doc":"Returns an iterator that calls the given block with the next element of the\niterator when calling `next`, still returning the original element.\n\n```\na = 0\niter = (1..3).each.tap { |x| a += x }\niter.next # => 1\na         # => 1\niter.next # => 2\na         # => 3\niter.next # => 3\na         # => 6\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that calls the given block with the next element of the iterator when calling <code><a href=\"Iterator.html#next-instance-method\">#next</a></code>, still returning the original element.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":1237,"url":null},"def":{"name":"tap","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T ->)"},"visibility":"Public","body":"Tap(typeof(self), T).new(self, block)"}},{"html_id":"uniq-instance-method","name":"uniq","doc":"Returns an iterator that only returns unique values of the original\niterator.\n\n```\niter = [1, 2, 1].each.uniq\niter.next # => 1\niter.next # => 2\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns unique values of the original iterator.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":1264,"url":null},"def":{"name":"uniq","visibility":"Public","body":"uniq(&.itself)"}},{"html_id":"uniq(&func:T->U)forallU-instance-method","name":"uniq","doc":"Returns an iterator that only returns unique values of the original\niterator. The provided block is applied to the elements to determine the\nvalue to be checked for uniqueness.\n\n```\niter = [[\"a\", \"a\"], [\"b\", \"a\"], [\"a\", \"c\"]].each.uniq &.first\niter.next # => [\"a\", \"a\"]\niter.next # => [\"b\", \"a\"]\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that only returns unique values of the original iterator.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":1278,"url":null},"def":{"name":"uniq","yields":1,"block_arg":{"name":"func","external_name":"func","restriction":"(T -> U)"},"visibility":"Public","body":"Uniq(typeof(self), T, U).new(self, func)"}},{"html_id":"with_index(offset:Int=0)-instance-method","name":"with_index","doc":"Returns an iterator that returns a `Tuple` of the element and its index.\n\n```\niter = (1..3).each.with_index\niter.next # => {1, 0}\niter.next # => {2, 1}\niter.next # => {3, 2}\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that returns a <code><a href=\"Tuple.html\">Tuple</a></code> of the element and its index.</p>","abstract":false,"args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"args_string":"(offset : Int = 0)","args_html":"(offset : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>)","location":{"filename":"src/iterator.cr","line_number":1312,"url":null},"def":{"name":"with_index","args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"visibility":"Public","body":"WithIndex(typeof(self), T, typeof(offset)).new(self, offset)"}},{"html_id":"with_index(offset:Int=0,&)-instance-method","name":"with_index","doc":"Yields each element in this iterator together with its index.","summary":"<p>Yields each element in this iterator together with its index.</p>","abstract":false,"args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"args_string":"(offset : Int = 0, &)","args_html":"(offset : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>, &)","location":{"filename":"src/iterator.cr","line_number":1317,"url":null},"def":{"name":"with_index","args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"yields":2,"visibility":"Public","body":"index = offset\neach do |value|\n  yield value, index\n  index = index + 1\nend\n"}},{"html_id":"with_object(obj)-instance-method","name":"with_object","doc":"Returns an iterator that returns a `Tuple` of the element and a given object.\n\n```\niter = (1..3).each.with_object(\"a\")\niter.next # => {1, \"a\"}\niter.next # => {2, \"a\"}\niter.next # => {3, \"a\"}\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that returns a <code><a href=\"Tuple.html\">Tuple</a></code> of the element and a given object.</p>","abstract":false,"args":[{"name":"obj","external_name":"obj","restriction":""}],"args_string":"(obj)","args_html":"(obj)","location":{"filename":"src/iterator.cr","line_number":1349,"url":null},"def":{"name":"with_object","args":[{"name":"obj","external_name":"obj","restriction":""}],"visibility":"Public","body":"WithObject(typeof(self), T, typeof(obj)).new(self, obj)"}},{"html_id":"with_object(obj,&)-instance-method","name":"with_object","doc":"Yields each element in this iterator together with *obj*. Returns that object.","summary":"<p>Yields each element in this iterator together with <em>obj</em>.</p>","abstract":false,"args":[{"name":"obj","external_name":"obj","restriction":""}],"args_string":"(obj, &)","args_html":"(obj, &)","location":{"filename":"src/iterator.cr","line_number":1354,"url":null},"def":{"name":"with_object","args":[{"name":"obj","external_name":"obj","restriction":""}],"yields":2,"visibility":"Public","body":"each do |value|\n  yield value, obj\nend\nobj\n"}},{"html_id":"zip(*others:Iterator):Iterator-instance-method","name":"zip","doc":"Returns an iterator that returns the elements of this iterator and *others*\ntraversed in tandem as `Tuple`s.\n\nIteration stops when any of the iterators runs out of elements.\n\n```\niter1 = [4, 5, 6].each\niter2 = [7, 8, 9].each\niter3 = ['a', 'b', 'c', 'd'].each\niter = iter1.zip(iter2, iter3)\niter.next # => {4, 7, 'a'}\niter.next # => {5, 8, 'b'}\niter.next # => {6, 9, 'c'}\niter.next # => Iterator::Stop::INSTANCE\n```","summary":"<p>Returns an iterator that returns the elements of this iterator and <em>others</em> traversed in tandem as <code><a href=\"Tuple.html\">Tuple</a></code>s.</p>","abstract":false,"args":[{"name":"others","external_name":"others","restriction":"Iterator"}],"args_string":"(*others : Iterator) : Iterator","args_html":"(*others : <a href=\"Iterator.html\">Iterator</a>) : <a href=\"Iterator.html\">Iterator</a>","location":{"filename":"src/iterator.cr","line_number":1389,"url":null},"def":{"name":"zip","args":[{"name":"others","external_name":"others","restriction":"Iterator"}],"splat_index":0,"return_type":"Iterator","visibility":"Public","body":"Iterator.zip_impl(self, *others)"}}],"types":[{"html_id":"Crystal/Iterator/IteratorWrapper","path":"Iterator/IteratorWrapper.html","kind":"module","full_name":"Iterator::IteratorWrapper","name":"IteratorWrapper","abstract":false,"locations":[{"filename":"src/iterator.cr","line_number":87,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Iterator","kind":"module","full_name":"Iterator(T)","name":"Iterator"},"doc":"`IteratorWrapper` eliminates some boilerplate when defining\nan `Iterator` that wraps another iterator.\n\nTo use it, include this module in your iterator and make sure that the wrapped\niterator is stored in the `@iterator` instance variable.","summary":"<p><code><a href=\"../Iterator/IteratorWrapper.html\">IteratorWrapper</a></code> eliminates some boilerplate when defining an <code><a href=\"../Iterator.html\">Iterator</a></code> that wraps another iterator.</p>","macros":[{"html_id":"wrapped_next-macro","name":"wrapped_next","doc":"Invokes `next` on the wrapped iterator and returns `stop` if\nthe given value was a `Iterator::Stop`. Otherwise, returns the value.","summary":"<p>Invokes <code>next</code> on the wrapped iterator and returns <code>stop</code> if the given value was a <code><a href=\"../Iterator/Stop.html\">Iterator::Stop</a></code>.</p>","abstract":false,"location":{"filename":"src/iterator.cr","line_number":90,"url":null},"def":{"name":"wrapped_next","visibility":"Public","body":"      \n%value\n = @iterator.next\n      return stop if \n%value\n.is_a?(Stop)\n      \n%value\n\n    \n"}}]},{"html_id":"Crystal/Iterator/Stop","path":"Iterator/Stop.html","kind":"class","full_name":"Iterator::Stop","name":"Stop","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/iterator.cr","line_number":78,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"INSTANCE","name":"INSTANCE","value":"new"}],"namespace":{"html_id":"Crystal/Iterator","kind":"module","full_name":"Iterator(T)","name":"Iterator"},"doc":"The class that signals that there are no more elements in an `Iterator`.","summary":"<p>The class that signals that there are no more elements in an <code><a href=\"../Iterator.html\">Iterator</a></code>.</p>"}]},{"html_id":"Crystal/JSON","path":"JSON.html","kind":"module","full_name":"JSON","name":"JSON","abstract":false,"locations":[{"filename":"src/json.cr","line_number":114,"url":null},{"filename":"src/json/builder.cr","line_number":383,"url":null},{"filename":"src/json/serialization.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"The JSON module allows parsing and generating [JSON](http://json.org/) documents.\n\n### General type-safe interface\n\nThe general type-safe interface for parsing JSON is to invoke `T.from_json` on a\ntarget type `T` and pass either a `String` or `IO` as an argument.\n\n```\nrequire \"json\"\n\njson_text = %([1, 2, 3])\nArray(Int32).from_json(json_text) # => [1, 2, 3]\n\njson_text = %({\"x\": 1, \"y\": 2})\nHash(String, Int32).from_json(json_text) # => {\"x\" => 1, \"y\" => 2}\n```\n\nSerializing is achieved by invoking `to_json`, which returns a `String`, or\n`to_json(io : IO)`, which will stream the JSON to an `IO`.\n\n```\nrequire \"json\"\n\n[1, 2, 3].to_json            # => \"[1,2,3]\"\n{\"x\" => 1, \"y\" => 2}.to_json # => \"{\\\"x\\\":1,\\\"y\\\":2}\"\n```\n\nMost types in the standard library implement these methods. For user-defined types\nyou can define a `self.new(pull : JSON::PullParser)` for parsing and\n`to_json(builder : JSON::Builder)` for serializing. The following sections\nshow convenient ways to do this using `JSON::Serializable`.\n\nNOTE: JSON object keys are always strings but they can still be parsed\nand deserialized to other types. To deserialize, define a\n`T.from_json_object_key?(key : String) : T?` method, which can return `nil`\nif the string can't be parsed into that type. To serialize, define a\n`to_json_object_key : String` method can be serialized that way.\nAll integer and float types in the standard library can be deserialized that way.\n\n```\nrequire \"json\"\n\njson_text = %({\"1\": 2, \"3\": 4})\nHash(Int32, Int32).from_json(json_text) # => {1 => 2, 3 => 4}\n\n{1.5 => 2}.to_json # => \"{\\\"1.5\\\":2}\"\n```\n\n### Parsing with `JSON.parse`\n\n`JSON.parse` will return an `Any`, which is a convenient wrapper around all possible JSON types,\nmaking it easy to traverse a complex JSON structure but requires some casts from time to time,\nmostly via some method invocations.\n\n```\nrequire \"json\"\n\nvalue = JSON.parse(\"[1, 2, 3]\") # : JSON::Any\n\nvalue[0]               # => 1\ntypeof(value[0])       # => JSON::Any\nvalue[0].as_i          # => 1\ntypeof(value[0].as_i)  # => Int32\nvalue[0].as_i?         # => 1\ntypeof(value[0].as_i?) # => Int32 | Nil\nvalue[0].as_s?         # => nil\ntypeof(value[0].as_s?) # => String | Nil\n\nvalue[0] + 1       # Error, because value[0] is JSON::Any\nvalue[0].as_i + 10 # => 11\n```\n\n`JSON.parse` can read from an `IO` directly (such as a file) which saves\nallocating a string:\n\n```\nrequire \"json\"\n\njson = File.open(\"path/to/file.json\") do |file|\n  JSON.parse(file)\nend\n```\n\nParsing with `JSON.parse` is useful for dealing with a dynamic JSON structure.\n\n### Generating with `JSON.build`\n\nUse `JSON.build`, which uses `JSON::Builder`, to generate JSON\nby emitting scalars, arrays and objects:\n\n```\nrequire \"json\"\n\nstring = JSON.build do |json|\n  json.object do\n    json.field \"name\", \"foo\"\n    json.field \"values\" do\n      json.array do\n        json.number 1\n        json.number 2\n        json.number 3\n      end\n    end\n  end\nend\nstring # => %<{\"name\":\"foo\",\"values\":[1,2,3]}>\n```\n\n### Generating with `to_json`\n\n`to_json`, `to_json(IO)` and `to_json(JSON::Builder)` methods are provided\nfor primitive types, but you need to define `to_json(JSON::Builder)`\nfor custom objects, either manually or using `JSON::Serializable`.","summary":"<p>The JSON module allows parsing and generating <a href=\"http://json.org/\">JSON</a> documents.</p>","class_methods":[{"html_id":"build(io:IO,indent=nil,&):Nil-class-method","name":"build","doc":"Writes JSON into the given `IO`. A `JSON::Builder` is yielded to the block.","summary":"<p>Writes JSON into the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"indent","default_value":"nil","external_name":"indent","restriction":""}],"args_string":"(io : IO, indent = nil, &) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, indent = <span class=\"n\">nil</span>, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/builder.cr","line_number":412,"url":null},"def":{"name":"build","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"indent","default_value":"nil","external_name":"indent","restriction":""}],"yields":1,"return_type":"Nil","visibility":"Public","body":"builder = JSON::Builder.new(io)\nif indent\n  builder.indent = indent\nend\nbuilder.document do\n  yield builder\nend\n"}},{"html_id":"build(indent=nil,&)-class-method","name":"build","doc":"Returns the resulting `String` of writing JSON to the yielded `JSON::Builder`.\n\n```\nrequire \"json\"\n\nstring = JSON.build do |json|\n  json.object do\n    json.field \"name\", \"foo\"\n    json.field \"values\" do\n      json.array do\n        json.number 1\n        json.number 2\n        json.number 3\n      end\n    end\n  end\nend\nstring # => %<{\"name\":\"foo\",\"values\":[1,2,3]}>\n```","summary":"<p>Returns the resulting <code><a href=\"String.html\">String</a></code> of writing JSON to the yielded <code><a href=\"JSON/Builder.html\">JSON::Builder</a></code>.</p>","abstract":false,"args":[{"name":"indent","default_value":"nil","external_name":"indent","restriction":""}],"args_string":"(indent = nil, &)","args_html":"(indent = <span class=\"n\">nil</span>, &)","location":{"filename":"src/json/builder.cr","line_number":403,"url":null},"def":{"name":"build","args":[{"name":"indent","default_value":"nil","external_name":"indent","restriction":""}],"yields":1,"visibility":"Public","body":"String.build do |str|\n  build(str, indent) do |json|\n    yield json\n  end\nend"}},{"html_id":"parse(input:String|IO):Any-class-method","name":"parse","doc":"Parses a JSON document as a `JSON::Any`.","summary":"<p>Parses a JSON document as a <code><a href=\"JSON/Any.html\">JSON::Any</a></code>.</p>","abstract":false,"args":[{"name":"input","external_name":"input","restriction":"String | IO"}],"args_string":"(input : String | IO) : Any","args_html":"(input : <a href=\"String.html\">String</a> | <a href=\"IO.html\">IO</a>) : <a href=\"JSON/Any.html\">Any</a>","location":{"filename":"src/json.cr","line_number":134,"url":null},"def":{"name":"parse","args":[{"name":"input","external_name":"input","restriction":"String | IO"}],"return_type":"Any","visibility":"Public","body":"(Parser.new(input)).parse"}}],"types":[{"html_id":"Crystal/JSON/Any","path":"JSON/Any.html","kind":"struct","full_name":"JSON::Any","name":"Any","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/any.cr","line_number":19,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":"`JSON::Any` is a convenient wrapper around all possible JSON types (`JSON::Any::Type`)\nand can be used for traversing dynamic or unknown JSON structures.\n\n```\nrequire \"json\"\n\nobj = JSON.parse(%({\"access\": [{\"name\": \"mapping\", \"speed\": \"fast\"}, {\"name\": \"any\", \"speed\": \"slow\"}]}))\nobj[\"access\"][1][\"name\"].as_s  # => \"any\"\nobj[\"access\"][1][\"speed\"].as_s # => \"slow\"\n```\n\nNote that methods used to traverse a JSON structure, `#[]` and `#[]?`,\nalways return a `JSON::Any` to allow further traversal. To convert them to `String`,\n`Int32`, etc., use the `as_` methods, such as `#as_s`, `#as_i`, which perform\na type check against the raw underlying value. This means that invoking `#as_s`\nwhen the underlying value is not a String will raise: the value won't automatically\nbe converted (parsed) to a `String`. There are also nil-able variants (`#as_i?`, `#as_s?`, ...),\nwhich return `nil` when the underlying value type won't match.","summary":"<p><code><a href=\"../JSON/Any.html\">JSON::Any</a></code> is a convenient wrapper around all possible JSON types (<code><a href=\"../JSON/Any/Type.html\">JSON::Any::Type</a></code>) and can be used for traversing dynamic or unknown JSON structures.</p>","constructors":[{"html_id":"new(raw:Type)-class-method","name":"new","doc":"Creates a `JSON::Any` that wraps the given value.","summary":"<p>Creates a <code><a href=\"../JSON/Any.html\">JSON::Any</a></code> that wraps the given value.</p>","abstract":false,"args":[{"name":"raw","external_name":"raw","restriction":"Type"}],"args_string":"(raw : Type)","args_html":"(raw : <a href=\"../JSON/Any/Type.html\">Type</a>)","location":{"filename":"src/json/any.cr","line_number":57,"url":null},"def":{"name":"new","args":[{"name":"raw","external_name":"raw","restriction":"Type"}],"visibility":"Public","body":"_ = allocate\n_.initialize(raw)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":"Reads a `JSON::Any` value from the given pull parser.","summary":"<p>Reads a <code><a href=\"../JSON/Any.html\">JSON::Any</a></code> value from the given pull parser.</p>","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"../JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/any.cr","line_number":24,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"case pull.kind\nwhen .null?\n  new(pull.read_null)\nwhen .bool?\n  new(pull.read_bool)\nwhen .int?\n  new(pull.read_int)\nwhen .float?\n  new(pull.read_float)\nwhen .string?\n  new(pull.read_string)\nwhen .begin_array?\n  ary = [] of JSON::Any\n  pull.read_array do\n    ary << (new(pull))\n  end\n  new(ary)\nwhen .begin_object?\n  hash = {} of String => JSON::Any\n  pull.read_object do |key|\n    hash[key] = new(pull)\n  end\n  new(hash)\nelse\n  raise(\"Unknown pull kind: #{pull.kind}\")\nend"}}],"instance_methods":[{"html_id":"==(other:JSON::Any)-instance-method","name":"==","doc":"Returns `true` if both `self` and *other*'s raw object are equal.","summary":"<p>Returns <code>true</code> if both <code>self</code> and <em>other</em>'s raw object are equal.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"JSON::Any"}],"args_string":"(other : JSON::Any)","args_html":"(other : <a href=\"../JSON/Any.html\">JSON::Any</a>)","location":{"filename":"src/json/any.cr","line_number":263,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"JSON::Any"}],"visibility":"Public","body":"raw == other.raw"}},{"html_id":"==(other)-instance-method","name":"==","doc":"Returns `true` if the raw object is equal to *other*.","summary":"<p>Returns <code>true</code> if the raw object is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/json/any.cr","line_number":268,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"raw == other"}},{"html_id":"[](index:Int):JSON::Any-instance-method","name":"[]","doc":"Assumes the underlying value is an `Array` and returns the element\nat the given index.\nRaises if the underlying value is not an `Array`.","summary":"<p>Assumes the underlying value is an <code><a href=\"../Array.html\">Array</a></code> and returns the element at the given index.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : JSON::Any","args_html":"(index : <a href=\"../Int.html\">Int</a>) : <a href=\"../JSON/Any.html\">JSON::Any</a>","location":{"filename":"src/json/any.cr","line_number":76,"url":null},"def":{"name":"[]","args":[{"name":"index","external_name":"index","restriction":"Int"}],"return_type":"JSON::Any","visibility":"Public","body":"case object = @raw\nwhen Array\n  object[index]\nelse\n  raise(\"Expected Array for #[](index : Int), not #{object.class}\")\nend"}},{"html_id":"[](key:String):JSON::Any-instance-method","name":"[]","doc":"Assumes the underlying value is a `Hash` and returns the element\nwith the given key.\nRaises if the underlying value is not a `Hash`.","summary":"<p>Assumes the underlying value is a <code><a href=\"../Hash.html\">Hash</a></code> and returns the element with the given key.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String) : JSON::Any","args_html":"(key : <a href=\"../String.html\">String</a>) : <a href=\"../JSON/Any.html\">JSON::Any</a>","location":{"filename":"src/json/any.cr","line_number":100,"url":null},"def":{"name":"[]","args":[{"name":"key","external_name":"key","restriction":"String"}],"return_type":"JSON::Any","visibility":"Public","body":"case object = @raw\nwhen Hash\n  object[key]\nelse\n  raise(\"Expected Hash for #[](key : String), not #{object.class}\")\nend"}},{"html_id":"[]?(index:Int):JSON::Any?-instance-method","name":"[]?","doc":"Assumes the underlying value is an `Array` and returns the element\nat the given index, or `nil` if out of bounds.\nRaises if the underlying value is not an `Array`.","summary":"<p>Assumes the underlying value is an <code><a href=\"../Array.html\">Array</a></code> and returns the element at the given index, or <code>nil</code> if out of bounds.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : JSON::Any?","args_html":"(index : <a href=\"../Int.html\">Int</a>) : <a href=\"../JSON/Any.html\">JSON::Any</a>?","location":{"filename":"src/json/any.cr","line_number":88,"url":null},"def":{"name":"[]?","args":[{"name":"index","external_name":"index","restriction":"Int"}],"return_type":"JSON::Any | ::Nil","visibility":"Public","body":"case object = @raw\nwhen Array\n  object[index]?\nelse\n  raise(\"Expected Array for #[]?(index : Int), not #{object.class}\")\nend"}},{"html_id":"[]?(key:String):JSON::Any?-instance-method","name":"[]?","doc":"Assumes the underlying value is a `Hash` and returns the element\nwith the given key, or `nil` if the key is not present.\nRaises if the underlying value is not a `Hash`.","summary":"<p>Assumes the underlying value is a <code><a href=\"../Hash.html\">Hash</a></code> and returns the element with the given key, or <code>nil</code> if the key is not present.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String) : JSON::Any?","args_html":"(key : <a href=\"../String.html\">String</a>) : <a href=\"../JSON/Any.html\">JSON::Any</a>?","location":{"filename":"src/json/any.cr","line_number":112,"url":null},"def":{"name":"[]?","args":[{"name":"key","external_name":"key","restriction":"String"}],"return_type":"JSON::Any | ::Nil","visibility":"Public","body":"case object = @raw\nwhen Hash\n  object[key]?\nelse\n  raise(\"Expected Hash for #[]?(key : String), not #{object.class}\")\nend"}},{"html_id":"as_a:Array(Any)-instance-method","name":"as_a","doc":"Checks that the underlying value is `Array`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Array.html\">Array</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":227,"url":null},"def":{"name":"as_a","return_type":"Array(Any)","visibility":"Public","body":"@raw.as(Array)"}},{"html_id":"as_a?:Array(Any)?-instance-method","name":"as_a?","doc":"Checks that the underlying value is `Array`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Array.html\">Array</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":233,"url":null},"def":{"name":"as_a?","return_type":"Array(Any) | ::Nil","visibility":"Public","body":"if @raw.is_a?(Array)\n  as_a\nend"}},{"html_id":"as_bool:Bool-instance-method","name":"as_bool","doc":"Checks that the underlying value is `Bool`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Bool.html\">Bool</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":155,"url":null},"def":{"name":"as_bool","return_type":"Bool","visibility":"Public","body":"@raw.as(Bool)"}},{"html_id":"as_bool?:Bool?-instance-method","name":"as_bool?","doc":"Checks that the underlying value is `Bool`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Bool.html\">Bool</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":161,"url":null},"def":{"name":"as_bool?","return_type":"Bool | ::Nil","visibility":"Public","body":"if @raw.is_a?(Bool)\n  as_bool\nend"}},{"html_id":"as_f:Float64-instance-method","name":"as_f","doc":"Checks that the underlying value is `Float`, and returns its value as an `Float64`.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Float.html\">Float</a></code>, and returns its value as an <code><a href=\"../Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":191,"url":null},"def":{"name":"as_f","return_type":"Float64","visibility":"Public","body":"@raw.as(Float64)"}},{"html_id":"as_f32:Float32-instance-method","name":"as_f32","doc":"Checks that the underlying value is `Float`, and returns its value as an `Float32`.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Float.html\">Float</a></code>, and returns its value as an <code><a href=\"../Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":203,"url":null},"def":{"name":"as_f32","return_type":"Float32","visibility":"Public","body":"(@raw.as(Float)).to_f32"}},{"html_id":"as_f32?:Float32?-instance-method","name":"as_f32?","doc":"Checks that the underlying value is `Float`, and returns its value as an `Float32`.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Float.html\">Float</a></code>, and returns its value as an <code><a href=\"../Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":209,"url":null},"def":{"name":"as_f32?","return_type":"Float32 | ::Nil","visibility":"Public","body":"if @raw.is_a?(Float)\n  as_f32\nend"}},{"html_id":"as_f?:Float64?-instance-method","name":"as_f?","doc":"Checks that the underlying value is `Float`, and returns its value as an `Float64`.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Float.html\">Float</a></code>, and returns its value as an <code><a href=\"../Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":197,"url":null},"def":{"name":"as_f?","return_type":"Float64 | ::Nil","visibility":"Public","body":"@raw.as?(Float64)"}},{"html_id":"as_h:Hash(String,Any)-instance-method","name":"as_h","doc":"Checks that the underlying value is `Hash`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Hash.html\">Hash</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":239,"url":null},"def":{"name":"as_h","return_type":"Hash(String, Any)","visibility":"Public","body":"@raw.as(Hash)"}},{"html_id":"as_h?:Hash(String,Any)?-instance-method","name":"as_h?","doc":"Checks that the underlying value is `Hash`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Hash.html\">Hash</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":245,"url":null},"def":{"name":"as_h?","return_type":"Hash(String, Any) | ::Nil","visibility":"Public","body":"if @raw.is_a?(Hash)\n  as_h\nend"}},{"html_id":"as_i:Int32-instance-method","name":"as_i","doc":"Checks that the underlying value is `Int`, and returns its value as an `Int32`.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int.html\">Int</a></code>, and returns its value as an <code><a href=\"../Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":167,"url":null},"def":{"name":"as_i","return_type":"Int32","visibility":"Public","body":"(@raw.as(Int)).to_i"}},{"html_id":"as_i64:Int64-instance-method","name":"as_i64","doc":"Checks that the underlying value is `Int`, and returns its value as an `Int64`.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int.html\">Int</a></code>, and returns its value as an <code><a href=\"../Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":179,"url":null},"def":{"name":"as_i64","return_type":"Int64","visibility":"Public","body":"(@raw.as(Int)).to_i64"}},{"html_id":"as_i64?:Int64?-instance-method","name":"as_i64?","doc":"Checks that the underlying value is `Int`, and returns its value as an `Int64`.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int.html\">Int</a></code>, and returns its value as an <code><a href=\"../Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":185,"url":null},"def":{"name":"as_i64?","return_type":"Int64 | ::Nil","visibility":"Public","body":"if @raw.is_a?(Int64)\n  as_i64\nend"}},{"html_id":"as_i?:Int32?-instance-method","name":"as_i?","doc":"Checks that the underlying value is `Int`, and returns its value as an `Int32`.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int.html\">Int</a></code>, and returns its value as an <code><a href=\"../Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":173,"url":null},"def":{"name":"as_i?","return_type":"Int32 | ::Nil","visibility":"Public","body":"if @raw.is_a?(Int)\n  as_i\nend"}},{"html_id":"as_nil:Nil-instance-method","name":"as_nil","doc":"Checks that the underlying value is `Nil`, and returns `nil`.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Nil.html\">Nil</a></code>, and returns <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":149,"url":null},"def":{"name":"as_nil","return_type":"Nil","visibility":"Public","body":"@raw.as(Nil)"}},{"html_id":"as_s:String-instance-method","name":"as_s","doc":"Checks that the underlying value is `String`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../String.html\">String</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":215,"url":null},"def":{"name":"as_s","return_type":"String","visibility":"Public","body":"@raw.as(String)"}},{"html_id":"as_s?:String?-instance-method","name":"as_s?","doc":"Checks that the underlying value is `String`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../String.html\">String</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":221,"url":null},"def":{"name":"as_s?","return_type":"String | ::Nil","visibility":"Public","body":"if @raw.is_a?(String)\n  as_s\nend"}},{"html_id":"clone-instance-method","name":"clone","doc":"Returns a new JSON::Any instance with the `raw` value `clone`ed.","summary":"<p>Returns a new JSON::Any instance with the <code><a href=\"../JSON/Any.html#raw%3AType-instance-method\">#raw</a></code> value <code><a href=\"../JSON/Any.html#clone-instance-method\">#clone</a></code>ed.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":290,"url":null},"def":{"name":"clone","visibility":"Public","body":"Any.new(raw.clone)"}},{"html_id":"dig(index_or_key:String|Int,*subkeys):JSON::Any-instance-method","name":"dig","doc":"Traverses the depth of a structure and returns the value, otherwise raises.","summary":"<p>Traverses the depth of a structure and returns the value, otherwise raises.</p>","abstract":false,"args":[{"name":"index_or_key","external_name":"index_or_key","restriction":"String | Int"},{"name":"subkeys","external_name":"subkeys","restriction":""}],"args_string":"(index_or_key : String | Int, *subkeys) : JSON::Any","args_html":"(index_or_key : <a href=\"../String.html\">String</a> | <a href=\"../Int.html\">Int</a>, *subkeys) : <a href=\"../JSON/Any.html\">JSON::Any</a>","location":{"filename":"src/json/any.cr","line_number":138,"url":null},"def":{"name":"dig","args":[{"name":"index_or_key","external_name":"index_or_key","restriction":"String | Int"},{"name":"subkeys","external_name":"subkeys","restriction":""}],"splat_index":1,"return_type":"JSON::Any","visibility":"Public","body":"self[index_or_key].dig(*subkeys)"}},{"html_id":"dig?(index_or_key:String|Int,*subkeys):JSON::Any?-instance-method","name":"dig?","doc":"Traverses the depth of a structure and returns the value.\nReturns `nil` if not found.","summary":"<p>Traverses the depth of a structure and returns the value.</p>","abstract":false,"args":[{"name":"index_or_key","external_name":"index_or_key","restriction":"String | Int"},{"name":"subkeys","external_name":"subkeys","restriction":""}],"args_string":"(index_or_key : String | Int, *subkeys) : JSON::Any?","args_html":"(index_or_key : <a href=\"../String.html\">String</a> | <a href=\"../Int.html\">Int</a>, *subkeys) : <a href=\"../JSON/Any.html\">JSON::Any</a>?","location":{"filename":"src/json/any.cr","line_number":123,"url":null},"def":{"name":"dig?","args":[{"name":"index_or_key","external_name":"index_or_key","restriction":"String | Int"},{"name":"subkeys","external_name":"subkeys","restriction":""}],"splat_index":1,"return_type":"JSON::Any | ::Nil","visibility":"Public","body":"self[index_or_key]?.try(&.dig?(*subkeys))"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a new JSON::Any instance with the `raw` value `dup`ed.","summary":"<p>Returns a new JSON::Any instance with the <code><a href=\"../JSON/Any.html#raw%3AType-instance-method\">#raw</a></code> value <code><a href=\"../JSON/Any.html#dup-instance-method\">#dup</a></code>ed.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":285,"url":null},"def":{"name":"dup","visibility":"Public","body":"Any.new(raw.dup)"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/json/any.cr","line_number":273,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = raw.hash(hasher)\nhasher\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends this struct's name and instance variables names and values\nto the given IO.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np1.to_s    # \"Point(@x=1, @y=2)\"\np1.inspect # \"Point(@x=1, @y=2)\"\n```","summary":"<p>Appends this struct's name and instance variables names and values to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/any.cr","line_number":249,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"@raw.inspect(io)"}},{"html_id":"raw:Type-instance-method","name":"raw","doc":"Returns the raw underlying value.","summary":"<p>Returns the raw underlying value.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":54,"url":null},"def":{"name":"raw","return_type":"Type","visibility":"Public","body":"@raw"}},{"html_id":"size:Int-instance-method","name":"size","doc":"Assumes the underlying value is an `Array` or `Hash` and returns its size.\nRaises if the underlying value is not an `Array` or `Hash`.","summary":"<p>Assumes the underlying value is an <code><a href=\"../Array.html\">Array</a></code> or <code><a href=\"../Hash.html\">Hash</a></code> and returns its size.</p>","abstract":false,"location":{"filename":"src/json/any.cr","line_number":62,"url":null},"def":{"name":"size","return_type":"Int","visibility":"Public","body":"case object = @raw\nwhen Array\n  object.size\nwhen Hash\n  object.size\nelse\n  raise(\"Expected Array or Hash for #size, not #{object.class}\")\nend"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Same as `#inspect(io)`.","summary":"<p>Same as <code><a href=\"../JSON/Any.html#inspect%28io%3AIO%29%3ANil-instance-method\">#inspect(io)</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/any.cr","line_number":253,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"@raw.to_s(io)"}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder) : Nil","args_html":"(yaml : <a href=\"../YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/any.cr","line_number":280,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"raw.to_yaml(yaml)"}}],"types":[{"html_id":"Crystal/JSON/Any/Type","path":"JSON/Any/Type.html","kind":"alias","full_name":"JSON::Any::Type","name":"Type","abstract":false,"locations":[{"filename":"src/json/any.cr","line_number":21,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(Array(JSON::Any) | Bool | Float64 | Hash(String, JSON::Any) | Int64 | String | Nil)","aliased_html":"<a href=\"../../Array.html\">Array</a>(<a href=\"../../JSON/Any.html\">JSON::Any</a>) | <a href=\"../../Bool.html\">Bool</a> | <a href=\"../../Float64.html\">Float64</a> | <a href=\"../../Hash.html\">Hash</a>(<a href=\"../../String.html\">String</a>, <a href=\"../../JSON/Any.html\">JSON::Any</a>) | <a href=\"../../Int64.html\">Int64</a> | <a href=\"../../String.html\">String</a> | <a href=\"../../Nil.html\">Nil</a>","const":false,"namespace":{"html_id":"Crystal/JSON/Any","kind":"struct","full_name":"JSON::Any","name":"Any"},"doc":"All possible JSON types.","summary":"<p>All possible JSON types.</p>"}]},{"html_id":"Crystal/JSON/ArrayConverter","path":"JSON/ArrayConverter.html","kind":"module","full_name":"JSON::ArrayConverter(Converter)","name":"ArrayConverter","abstract":false,"locations":[{"filename":"src/json/from_json.cr","line_number":398,"url":null},{"filename":"src/json/to_json.cr","line_number":288,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":"Converter to be used with `JSON::Serializable`\nto serialize the `Array(T)` elements with the custom converter.\n\n```\nrequire \"json\"\n\nclass TimestampArray\n  include JSON::Serializable\n\n  @[JSON::Field(converter: JSON::ArrayConverter(Time::EpochConverter))]\n  property dates : Array(Time)\nend\n\ntimestamp = TimestampArray.from_json(%({\"dates\":[1459859781,1567628762]}))\ntimestamp.dates   # => [2016-04-05 12:36:21 UTC, 2019-09-04 20:26:02 UTC]\ntimestamp.to_json # => %({\"dates\":[1459859781,1567628762]})\n```","summary":"<p>Converter to be used with <code><a href=\"../JSON/Serializable.html\">JSON::Serializable</a></code> to serialize the <code><a href=\"../Array.html\">Array</a>(T)</code> elements with the custom converter.</p>","class_methods":[{"html_id":"from_json(pull:JSON::PullParser)-class-method","name":"from_json","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"../JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":399,"url":null},"def":{"name":"from_json","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"ary = Array(typeof(Converter.from_json(pull))).new\npull.read_array do\n  ary << (Converter.from_json(pull))\nend\nary\n"}},{"html_id":"to_json(values:Array,builder:JSON::Builder)-class-method","name":"to_json","abstract":false,"args":[{"name":"values","external_name":"values","restriction":"Array"},{"name":"builder","external_name":"builder","restriction":"JSON::Builder"}],"args_string":"(values : Array, builder : JSON::Builder)","args_html":"(values : <a href=\"../Array.html\">Array</a>, builder : <a href=\"../JSON/Builder.html\">JSON::Builder</a>)","location":{"filename":"src/json/to_json.cr","line_number":289,"url":null},"def":{"name":"to_json","args":[{"name":"values","external_name":"values","restriction":"Array"},{"name":"builder","external_name":"builder","restriction":"JSON::Builder"}],"visibility":"Public","body":"builder.array do\n  values.each do |value|\n    Converter.to_json(value, builder)\n  end\nend"}}]},{"html_id":"Crystal/JSON/Builder","path":"JSON/Builder.html","kind":"class","full_name":"JSON::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/builder.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":"A JSON builder generates valid JSON.\n\nA `JSON::Error` is raised if attempting to generate an invalid JSON\n(for example, if invoking `end_array` without a matching `start_array`,\nor trying to use a non-string value as an object's field name).","summary":"<p>A JSON builder generates valid JSON.</p>","constructors":[{"html_id":"new(io:IO)-class-method","name":"new","doc":"Creates a `JSON::Builder` that will write to the given `IO`.","summary":"<p>Creates a <code><a href=\"../JSON/Builder.html\">JSON::Builder</a></code> that will write to the given <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","args_html":"(io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/json/builder.cr","line_number":25,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"_ = allocate\n_.initialize(io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"array(&)-instance-method","name":"array","doc":"Writes the start of an array, invokes the block,\nand the writes the end of it.","summary":"<p>Writes the start of an array, invokes the block, and the writes the end of it.</p>","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":190,"url":null},"def":{"name":"array","yields":0,"visibility":"Public","body":"start_array\n(yield).tap do\n  end_array\nend\n"}},{"html_id":"bool(value:Bool):Nil-instance-method","name":"bool","doc":"Writes a boolean value.","summary":"<p>Writes a boolean value.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Bool"}],"args_string":"(value : Bool) : Nil","args_html":"(value : <a href=\"../Bool.html\">Bool</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/builder.cr","line_number":72,"url":null},"def":{"name":"bool","args":[{"name":"value","external_name":"value","restriction":"Bool"}],"return_type":"Nil","visibility":"Public","body":"scalar do\n  @io << value\nend"}},{"html_id":"document(&)-instance-method","name":"document","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":59,"url":null},"def":{"name":"document","yields":0,"visibility":"Public","body":"start_document\n(yield).tap do\n  end_document\nend\n"}},{"html_id":"end_array:Nil-instance-method","name":"end_array","doc":"Writes the end of an array.","summary":"<p>Writes the end of an array.</p>","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":175,"url":null},"def":{"name":"end_array","return_type":"Nil","visibility":"Public","body":"case state = @state.last\nwhen ArrayState\n  @state.pop\nelse\n  raise(JSON::Error.new(\"Can't do end_array: not inside an array\"))\nend\nwrite_indent(state)\n@io << ']'\ndecrease_indent\nend_scalar\n"}},{"html_id":"end_document:Nil-instance-method","name":"end_document","doc":"Signals the end of a JSON document.","summary":"<p>Signals the end of a JSON document.</p>","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":43,"url":null},"def":{"name":"end_document","return_type":"Nil","visibility":"Public","body":"case state = @state.last\nwhen StartState\n  raise(JSON::Error.new(\"Empty JSON\"))\nwhen DocumentStartState\n  raise(JSON::Error.new(\"Empty JSON\"))\nwhen ArrayState\n  raise(JSON::Error.new(\"Unterminated JSON array\"))\nwhen ObjectState\n  raise(JSON::Error.new(\"Unterminated JSON object\"))\nwhen DocumentEndState\nend\nflush\n"}},{"html_id":"end_object:Nil-instance-method","name":"end_object","doc":"Writes the end of an object.","summary":"<p>Writes the end of an object.</p>","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":204,"url":null},"def":{"name":"end_object","return_type":"Nil","visibility":"Public","body":"case state = @state.last\nwhen ObjectState\n  if state.name\n  else\n    raise(JSON::Error.new(\"Missing object value\"))\n  end\n  @state.pop\nelse\n  raise(JSON::Error.new(\"Can't do end_object: not inside an object\"))\nend\nwrite_indent(state)\n@io << '}'\ndecrease_indent\nend_scalar\n"}},{"html_id":"field(name,value)-instance-method","name":"field","doc":"Writes an object's field and value.\nThe field's name is first converted to a `String` by invoking\n`to_s` on it.","summary":"<p>Writes an object's field and value.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"value","external_name":"value","restriction":""}],"args_string":"(name, value)","args_html":"(name, value)","location":{"filename":"src/json/builder.cr","line_number":250,"url":null},"def":{"name":"field","args":[{"name":"name","external_name":"name","restriction":""},{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"string(name)\nvalue.to_json(self)\n"}},{"html_id":"field(name,&)-instance-method","name":"field","doc":"Writes an object's field and then invokes the block.\nThis is equivalent of invoking `string(value)` and then\ninvoking the block.","summary":"<p>Writes an object's field and then invokes the block.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name, &)","args_html":"(name, &)","location":{"filename":"src/json/builder.cr","line_number":258,"url":null},"def":{"name":"field","args":[{"name":"name","external_name":"name","restriction":""}],"yields":0,"visibility":"Public","body":"string(name)\nyield\n"}},{"html_id":"flush-instance-method","name":"flush","doc":"Flushes the underlying `IO`.","summary":"<p>Flushes the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":264,"url":null},"def":{"name":"flush","visibility":"Public","body":"@io.flush"}},{"html_id":"indent=(string:String)-instance-method","name":"indent=","doc":"Sets the indent *string*.","summary":"<p>Sets the indent <em>string</em>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String)","args_html":"(string : <a href=\"../String.html\">String</a>)","location":{"filename":"src/json/builder.cr","line_number":269,"url":null},"def":{"name":"indent=","args":[{"name":"string","external_name":"string","restriction":"String"}],"visibility":"Public","body":"if string.empty?\n  @indent = nil\nelse\n  @indent = string\nend"}},{"html_id":"indent=(level:Int)-instance-method","name":"indent=","doc":"Sets the indent *level* (number of spaces).","summary":"<p>Sets the indent <em>level</em> (number of spaces).</p>","abstract":false,"args":[{"name":"level","external_name":"level","restriction":"Int"}],"args_string":"(level : Int)","args_html":"(level : <a href=\"../Int.html\">Int</a>)","location":{"filename":"src/json/builder.cr","line_number":278,"url":null},"def":{"name":"indent=","args":[{"name":"level","external_name":"level","restriction":"Int"}],"visibility":"Public","body":"if level < 0\n  @indent = nil\nelse\n  @indent = \" \" * level\nend"}},{"html_id":"max_nesting:Int32-instance-method","name":"max_nesting","doc":"By default the maximum nesting of arrays/objects is 99. Nesting more\nthan this will result in a JSON::Error. Changing the value of this property\nallows more/less nesting.","summary":"<p>By default the maximum nesting of arrays/objects is 99.</p>","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":22,"url":null},"def":{"name":"max_nesting","visibility":"Public","body":"@max_nesting"}},{"html_id":"max_nesting=(max_nesting)-instance-method","name":"max_nesting=","doc":"By default the maximum nesting of arrays/objects is 99. Nesting more\nthan this will result in a JSON::Error. Changing the value of this property\nallows more/less nesting.","summary":"<p>By default the maximum nesting of arrays/objects is 99.</p>","abstract":false,"args":[{"name":"max_nesting","external_name":"max_nesting","restriction":""}],"args_string":"(max_nesting)","args_html":"(max_nesting)","location":{"filename":"src/json/builder.cr","line_number":22,"url":null},"def":{"name":"max_nesting=","args":[{"name":"max_nesting","external_name":"max_nesting","restriction":""}],"visibility":"Public","body":"@max_nesting = max_nesting"}},{"html_id":"next_is_object_key?:Bool-instance-method","name":"next_is_object_key?","doc":"Returns `true` if the next thing that must pushed into this\nbuilder is an object key (so a string) or the end of an object.","summary":"<p>Returns <code>true</code> if the next thing that must pushed into this builder is an object key (so a string) or the end of an object.</p>","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":288,"url":null},"def":{"name":"next_is_object_key?","return_type":"Bool","visibility":"Public","body":"state = @state.last\nstate.is_a?(ObjectState) && state.name\n"}},{"html_id":"null:Nil-instance-method","name":"null","doc":"Writes a `null` value.","summary":"<p>Writes a <code><a href=\"../JSON/Builder.html#null%3ANil-instance-method\">#null</a></code> value.</p>","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":65,"url":null},"def":{"name":"null","return_type":"Nil","visibility":"Public","body":"scalar do\n  @io << \"null\"\nend"}},{"html_id":"number(number:Int):Nil-instance-method","name":"number","doc":"Writes an integer.","summary":"<p>Writes an integer.</p>","abstract":false,"args":[{"name":"number","external_name":"number","restriction":"Int"}],"args_string":"(number : Int) : Nil","args_html":"(number : <a href=\"../Int.html\">Int</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/builder.cr","line_number":79,"url":null},"def":{"name":"number","args":[{"name":"number","external_name":"number","restriction":"Int"}],"return_type":"Nil","visibility":"Public","body":"scalar do\n  @io << number\nend"}},{"html_id":"number(number:Float):Nil-instance-method","name":"number","doc":"Writes a float.","summary":"<p>Writes a float.</p>","abstract":false,"args":[{"name":"number","external_name":"number","restriction":"Float"}],"args_string":"(number : Float) : Nil","args_html":"(number : <a href=\"../Float.html\">Float</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/builder.cr","line_number":86,"url":null},"def":{"name":"number","args":[{"name":"number","external_name":"number","restriction":"Float"}],"return_type":"Nil","visibility":"Public","body":"scalar do\n  case number\n  when .nan?\n    raise(JSON::Error.new(\"NaN not allowed in JSON\"))\n  when .infinite?\n    raise(JSON::Error.new(\"Infinity not allowed in JSON\"))\n  else\n    @io << number\n  end\nend"}},{"html_id":"object(&)-instance-method","name":"object","doc":"Writes the start of an object, invokes the block,\nand the writes the end of it.","summary":"<p>Writes the start of an object, invokes the block, and the writes the end of it.</p>","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":222,"url":null},"def":{"name":"object","yields":0,"visibility":"Public","body":"start_object\n(yield).tap do\n  end_object\nend\n"}},{"html_id":"raw(string:String):Nil-instance-method","name":"raw","doc":"Writes a raw value, considered a scalar, directly into\nthe IO without processing. This is the only method that\nmight lead to invalid JSON being generated, so you must\nbe sure that *string* contains a valid JSON string.","summary":"<p>Writes a raw value, considered a scalar, directly into the IO without processing.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String) : Nil","args_html":"(string : <a href=\"../String.html\">String</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/builder.cr","line_number":160,"url":null},"def":{"name":"raw","args":[{"name":"string","external_name":"string","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"scalar do\n  @io << string\nend"}},{"html_id":"scalar(value:Nil)-instance-method","name":"scalar","doc":"Writes a scalar value.","summary":"<p>Writes a scalar value.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Nil"}],"args_string":"(value : Nil)","args_html":"(value : <a href=\"../Nil.html\">Nil</a>)","location":{"filename":"src/json/builder.cr","line_number":228,"url":null},"def":{"name":"scalar","args":[{"name":"value","external_name":"value","restriction":"Nil"}],"visibility":"Public","body":"null"}},{"html_id":"scalar(value:Bool)-instance-method","name":"scalar","doc":"Writes a scalar value.","summary":"<p>Writes a scalar value.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Bool"}],"args_string":"(value : Bool)","args_html":"(value : <a href=\"../Bool.html\">Bool</a>)","location":{"filename":"src/json/builder.cr","line_number":233,"url":null},"def":{"name":"scalar","args":[{"name":"value","external_name":"value","restriction":"Bool"}],"visibility":"Public","body":"bool(value)"}},{"html_id":"scalar(value:Int|Float):Nil-instance-method","name":"scalar","doc":"Writes a scalar value.","summary":"<p>Writes a scalar value.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Int | Float"}],"args_string":"(value : Int | Float) : Nil","args_html":"(value : <a href=\"../Int.html\">Int</a> | <a href=\"../Float.html\">Float</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/builder.cr","line_number":238,"url":null},"def":{"name":"scalar","args":[{"name":"value","external_name":"value","restriction":"Int | Float"}],"return_type":"Nil","visibility":"Public","body":"number(value)"}},{"html_id":"scalar(value:String):Nil-instance-method","name":"scalar","doc":"Writes a scalar value.","summary":"<p>Writes a scalar value.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(value : String) : Nil","args_html":"(value : <a href=\"../String.html\">String</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/builder.cr","line_number":243,"url":null},"def":{"name":"scalar","args":[{"name":"value","external_name":"value","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"string(value)"}},{"html_id":"start_array:Nil-instance-method","name":"start_array","doc":"Writes the start of an array.","summary":"<p>Writes the start of an array.</p>","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":167,"url":null},"def":{"name":"start_array","return_type":"Nil","visibility":"Public","body":"start_scalar\nincrease_indent\n@state.push(ArrayState.new(empty: true))\n@io << '['\n"}},{"html_id":"start_document:Nil-instance-method","name":"start_document","doc":"Starts a document.","summary":"<p>Starts a document.</p>","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":31,"url":null},"def":{"name":"start_document","return_type":"Nil","visibility":"Public","body":"case state = @state.last\nwhen StartState\n  @state[-1] = DocumentStartState.new\nwhen DocumentEndState\n  @state[-1] = DocumentStartState.new\nelse\n  raise(JSON::Error.new(\"Starting document before ending previous one\"))\nend"}},{"html_id":"start_object:Nil-instance-method","name":"start_object","doc":"Writes the start of an object.","summary":"<p>Writes the start of an object.</p>","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":196,"url":null},"def":{"name":"start_object","return_type":"Nil","visibility":"Public","body":"start_scalar\nincrease_indent\n@state.push(ObjectState.new(empty: true, name: true))\n@io << '{'\n"}},{"html_id":"string(value):Nil-instance-method","name":"string","doc":"Writes a string. The given *value* is first converted to a `String`\nby invoking `to_s` on it.\n\nThis method can also be used to write the name of an object field.","summary":"<p>Writes a string.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : Nil","args_html":"(value) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/builder.cr","line_number":103,"url":null},"def":{"name":"string","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"Nil","visibility":"Public","body":"string = value.to_s\nscalar(string: true) do\n  io << '\"'\n  start_pos = 0\n  reader = Char::Reader.new(string)\n  while reader.has_next?\n    case char = reader.current_char\n    when '\\\\'\n      escape = \"\\\\\\\\\"\n    when '\"'\n      escape = \"\\\\\\\"\"\n    when '\\b'\n      escape = \"\\\\b\"\n    when '\\f'\n      escape = \"\\\\f\"\n    when '\\n'\n      escape = \"\\\\n\"\n    when '\\r'\n      escape = \"\\\\r\"\n    when '\\t'\n      escape = \"\\\\t\"\n    when .ascii_control?\n      io.write_string(string.to_slice[start_pos, reader.pos - start_pos])\n      io << \"\\\\u\"\n      ord = char.ord\n      if ord < 4096\n        io << '0'\n      end\n      if ord < 256\n        io << '0'\n      end\n      if ord < 16\n        io << '0'\n      end\n      ord.to_s(io, 16)\n      reader.next_char\n      start_pos = reader.pos\n      next\n    else\n      reader.next_char\n      next\n    end\n    io.write_string(string.to_slice[start_pos, reader.pos - start_pos])\n    io << escape\n    reader.next_char\n    start_pos = reader.pos\n  end\n  io.write_string(string.to_slice[start_pos, reader.pos - start_pos])\n  io << '\"'\nend\n"}}],"types":[{"html_id":"Crystal/JSON/Builder/ArrayState","path":"JSON/Builder/ArrayState.html","kind":"struct","full_name":"JSON::Builder::ArrayState","name":"ArrayState","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/builder.cr","line_number":11,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON/Builder","kind":"class","full_name":"JSON::Builder","name":"Builder"},"constructors":[{"html_id":"new(empty:Bool)-class-method","name":"new","abstract":false,"args":[{"name":"empty","external_name":"empty","restriction":"Bool"}],"args_string":"(empty : Bool)","args_html":"(empty : <a href=\"../../Bool.html\">Bool</a>)","location":{"filename":"src/json/builder.cr","line_number":11,"url":null},"def":{"name":"new","args":[{"name":"empty","external_name":"empty","restriction":"Bool"}],"visibility":"Public","body":"_ = allocate\n_.initialize(empty)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":11,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new(@empty.clone)"}},{"html_id":"copy_with(empty_empty=@empty)-instance-method","name":"copy_with","abstract":false,"args":[{"name":"_empty","default_value":"@empty","external_name":"empty","restriction":""}],"args_string":"(empty _empty = @empty)","args_html":"(empty _empty = @empty)","location":{"filename":"src/json/builder.cr","line_number":11,"url":null},"def":{"name":"copy_with","args":[{"name":"_empty","default_value":"@empty","external_name":"empty","restriction":""}],"visibility":"Public","body":"self.class.new(_empty)"}},{"html_id":"empty:Bool-instance-method","name":"empty","abstract":false,"def":{"name":"empty","return_type":"Bool","visibility":"Public","body":"@empty"}}]},{"html_id":"Crystal/JSON/Builder/DocumentEndState","path":"JSON/Builder/DocumentEndState.html","kind":"struct","full_name":"JSON::Builder::DocumentEndState","name":"DocumentEndState","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/builder.cr","line_number":13,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON/Builder","kind":"class","full_name":"JSON::Builder","name":"Builder"},"constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":13,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":13,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new"}},{"html_id":"copy_with-instance-method","name":"copy_with","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":13,"url":null},"def":{"name":"copy_with","visibility":"Public","body":"self.class.new"}}]},{"html_id":"Crystal/JSON/Builder/DocumentStartState","path":"JSON/Builder/DocumentStartState.html","kind":"struct","full_name":"JSON::Builder::DocumentStartState","name":"DocumentStartState","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/builder.cr","line_number":10,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON/Builder","kind":"class","full_name":"JSON::Builder","name":"Builder"},"constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":10,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":10,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new"}},{"html_id":"copy_with-instance-method","name":"copy_with","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":10,"url":null},"def":{"name":"copy_with","visibility":"Public","body":"self.class.new"}}]},{"html_id":"Crystal/JSON/Builder/ObjectState","path":"JSON/Builder/ObjectState.html","kind":"struct","full_name":"JSON::Builder::ObjectState","name":"ObjectState","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/builder.cr","line_number":12,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON/Builder","kind":"class","full_name":"JSON::Builder","name":"Builder"},"constructors":[{"html_id":"new(empty:Bool,name:Bool)-class-method","name":"new","abstract":false,"args":[{"name":"empty","external_name":"empty","restriction":"Bool"},{"name":"name","external_name":"name","restriction":"Bool"}],"args_string":"(empty : Bool, name : Bool)","args_html":"(empty : <a href=\"../../Bool.html\">Bool</a>, name : <a href=\"../../Bool.html\">Bool</a>)","location":{"filename":"src/json/builder.cr","line_number":12,"url":null},"def":{"name":"new","args":[{"name":"empty","external_name":"empty","restriction":"Bool"},{"name":"name","external_name":"name","restriction":"Bool"}],"visibility":"Public","body":"_ = allocate\n_.initialize(empty, name)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":12,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new(@empty.clone, @name.clone)"}},{"html_id":"copy_with(empty_empty=@empty,name_name=@name)-instance-method","name":"copy_with","abstract":false,"args":[{"name":"_empty","default_value":"@empty","external_name":"empty","restriction":""},{"name":"_name","default_value":"@name","external_name":"name","restriction":""}],"args_string":"(empty _empty = @empty, name _name = @name)","args_html":"(empty _empty = @empty, name _name = @name)","location":{"filename":"src/json/builder.cr","line_number":12,"url":null},"def":{"name":"copy_with","args":[{"name":"_empty","default_value":"@empty","external_name":"empty","restriction":""},{"name":"_name","default_value":"@name","external_name":"name","restriction":""}],"visibility":"Public","body":"self.class.new(_empty, _name)"}},{"html_id":"empty:Bool-instance-method","name":"empty","abstract":false,"def":{"name":"empty","return_type":"Bool","visibility":"Public","body":"@empty"}},{"html_id":"name:Bool-instance-method","name":"name","abstract":false,"def":{"name":"name","return_type":"Bool","visibility":"Public","body":"@name"}}]},{"html_id":"Crystal/JSON/Builder/StartState","path":"JSON/Builder/StartState.html","kind":"struct","full_name":"JSON::Builder::StartState","name":"StartState","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/builder.cr","line_number":9,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON/Builder","kind":"class","full_name":"JSON::Builder","name":"Builder"},"constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":9,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":9,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new"}},{"html_id":"copy_with-instance-method","name":"copy_with","abstract":false,"location":{"filename":"src/json/builder.cr","line_number":9,"url":null},"def":{"name":"copy_with","visibility":"Public","body":"self.class.new"}}]},{"html_id":"Crystal/JSON/Builder/State","path":"JSON/Builder/State.html","kind":"alias","full_name":"JSON::Builder::State","name":"State","abstract":false,"locations":[{"filename":"src/json/builder.cr","line_number":15,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(JSON::Builder::ArrayState | JSON::Builder::DocumentEndState | JSON::Builder::DocumentStartState | JSON::Builder::ObjectState | JSON::Builder::StartState)","aliased_html":"<a href=\"../../JSON/Builder/ArrayState.html\">JSON::Builder::ArrayState</a> | <a href=\"../../JSON/Builder/DocumentEndState.html\">JSON::Builder::DocumentEndState</a> | <a href=\"../../JSON/Builder/DocumentStartState.html\">JSON::Builder::DocumentStartState</a> | <a href=\"../../JSON/Builder/ObjectState.html\">JSON::Builder::ObjectState</a> | <a href=\"../../JSON/Builder/StartState.html\">JSON::Builder::StartState</a>","const":false,"namespace":{"html_id":"Crystal/JSON/Builder","kind":"class","full_name":"JSON::Builder","name":"Builder"}}]},{"html_id":"Crystal/JSON/Error","path":"JSON/Error.html","kind":"class","full_name":"JSON::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json.cr","line_number":116,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/JSON/ParseException","kind":"class","full_name":"JSON::ParseException","name":"ParseException"}],"namespace":{"html_id":"Crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":"Generic JSON error.","summary":"<p>Generic JSON error.</p>"},{"html_id":"Crystal/JSON/Field","path":"JSON/Field.html","kind":"annotation","full_name":"JSON::Field","name":"Field","abstract":false,"locations":[{"filename":"src/json/serialization.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"}},{"html_id":"Crystal/JSON/HashValueConverter","path":"JSON/HashValueConverter.html","kind":"module","full_name":"JSON::HashValueConverter(Converter)","name":"HashValueConverter","abstract":false,"locations":[{"filename":"src/json/from_json.cr","line_number":408,"url":null},{"filename":"src/json/to_json.cr","line_number":315,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":"Converter to be used with `JSON::Serializable`\nto serialize the `Hash(K, V)` values elements with the custom converter.\n\n```\nrequire \"json\"\n\nclass TimestampHash\n  include JSON::Serializable\n\n  @[JSON::Field(converter: JSON::HashValueConverter(Time::EpochConverter))]\n  property birthdays : Hash(String, Time)\nend\n\ntimestamp = TimestampHash.from_json(%({\"birthdays\":{\"foo\":1459859781,\"bar\":1567628762}}))\ntimestamp.birthdays # => {\"foo\" => 2016-04-05 12:36:21 UTC, \"bar\" => 2019-09-04 20:26:02 UTC)}\ntimestamp.to_json   # => {\"birthdays\":{\"foo\":1459859781,\"bar\":1567628762}}\n```","summary":"<p>Converter to be used with <code><a href=\"../JSON/Serializable.html\">JSON::Serializable</a></code> to serialize the <code><a href=\"../Hash.html\">Hash</a>(K, V)</code> values elements with the custom converter.</p>","class_methods":[{"html_id":"from_json(pull:JSON::PullParser)-class-method","name":"from_json","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"../JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":409,"url":null},"def":{"name":"from_json","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"hash = Hash(String, typeof(Converter.from_json(pull))).new\npull.read_object do |key, key_location|\n  parsed_key = String.from_json_object_key?(key)\n  if parsed_key\n  else\n    raise(JSON::ParseException.new(\"Can't convert #{key.inspect} into String\", *key_location))\n  end\n  hash[parsed_key] = Converter.from_json(pull)\nend\nhash\n"}},{"html_id":"to_json(values:Hash,builder:JSON::Builder)-class-method","name":"to_json","abstract":false,"args":[{"name":"values","external_name":"values","restriction":"Hash"},{"name":"builder","external_name":"builder","restriction":"JSON::Builder"}],"args_string":"(values : Hash, builder : JSON::Builder)","args_html":"(values : <a href=\"../Hash.html\">Hash</a>, builder : <a href=\"../JSON/Builder.html\">JSON::Builder</a>)","location":{"filename":"src/json/to_json.cr","line_number":316,"url":null},"def":{"name":"to_json","args":[{"name":"values","external_name":"values","restriction":"Hash"},{"name":"builder","external_name":"builder","restriction":"JSON::Builder"}],"visibility":"Public","body":"builder.object do\n  values.each do |key, value|\n    builder.field(key.to_json_object_key) do\n      Converter.to_json(value, builder)\n    end\n  end\nend"}}]},{"html_id":"Crystal/JSON/Lexer","path":"JSON/Lexer.html","kind":"class","full_name":"JSON::Lexer","name":"Lexer","abstract":true,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/lexer.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"constructors":[{"html_id":"new(string:String)-class-method","name":"new","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String)","args_html":"(string : <a href=\"../String.html\">String</a>)","location":{"filename":"src/json/lexer.cr","line_number":4,"url":null},"def":{"name":"new","args":[{"name":"string","external_name":"string","restriction":"String"}],"visibility":"Public","body":"StringBased.new(string)"}},{"html_id":"new(io:IO)-class-method","name":"new","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","args_html":"(io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/json/lexer.cr","line_number":8,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"IOBased.new(io)"}},{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/json/lexer.cr","line_number":15,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"next_token:JSON::Token-instance-method","name":"next_token","abstract":false,"location":{"filename":"src/json/lexer.cr","line_number":32,"url":null},"def":{"name":"next_token","return_type":"JSON::Token","visibility":"Public","body":"skip_whitespace\n@token.line_number = @line_number\n@token.column_number = @column_number\ncase current_char\nwhen '\\0'\n  @token.kind = :EOF\nwhen '{'\n  next_char(:begin_object)\nwhen '}'\n  next_char(:end_object)\nwhen '['\n  next_char(:begin_array)\nwhen ']'\n  next_char(:end_array)\nwhen ','\n  next_char(:comma)\nwhen ':'\n  next_char(:colon)\nwhen 'f'\n  consume_false\nwhen 'n'\n  consume_null\nwhen 't'\n  consume_true\nwhen '\"'\n  @token.kind = :string\n  @skip ? consume_string_skip : consume_string\nelse\n  consume_number\nend\n@token\n"}},{"html_id":"next_token_expect_object_key-instance-method","name":"next_token_expect_object_key","doc":"Requests the next token where the parser expects a json\nobject key. In this case the lexer tries to reuse the String\ninstances by using a StringPool.","summary":"<p>Requests the next token where the parser expects a json object key.</p>","abstract":false,"location":{"filename":"src/json/lexer.cr","line_number":72,"url":null},"def":{"name":"next_token_expect_object_key","visibility":"Public","body":"@expects_object_key = true\nnext_token\n@expects_object_key = false\n@token\n"}},{"html_id":"skip:Bool-instance-method","name":"skip","abstract":false,"location":{"filename":"src/json/lexer.cr","line_number":13,"url":null},"def":{"name":"skip","return_type":"Bool","visibility":"Public","body":"@skip"}},{"html_id":"skip=(skip:Bool)-instance-method","name":"skip=","abstract":false,"args":[{"name":"skip","external_name":"skip","restriction":"Bool"}],"args_string":"(skip : Bool)","args_html":"(skip : <a href=\"../Bool.html\">Bool</a>)","location":{"filename":"src/json/lexer.cr","line_number":13,"url":null},"def":{"name":"skip=","args":[{"name":"skip","external_name":"skip","restriction":"Bool"}],"visibility":"Public","body":"@skip = skip"}},{"html_id":"token:Token-instance-method","name":"token","abstract":false,"location":{"filename":"src/json/lexer.cr","line_number":12,"url":null},"def":{"name":"token","return_type":"Token","visibility":"Public","body":"@token"}}]},{"html_id":"Crystal/JSON/ParseException","path":"JSON/ParseException.html","kind":"class","full_name":"JSON::ParseException","name":"ParseException","abstract":false,"superclass":{"html_id":"Crystal/JSON/Error","kind":"class","full_name":"JSON::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/JSON/Error","kind":"class","full_name":"JSON::Error","name":"Error"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json.cr","line_number":120,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/JSON/SerializableError","kind":"class","full_name":"JSON::SerializableError","name":"SerializableError"}],"namespace":{"html_id":"Crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":"Exception thrown on a JSON parse error.","summary":"<p>Exception thrown on a JSON parse error.</p>","constructors":[{"html_id":"new(message,line_number,column_number,cause=nil)-class-method","name":"new","abstract":false,"args":[{"name":"message","external_name":"message","restriction":""},{"name":"line_number","external_name":"line_number","restriction":""},{"name":"column_number","external_name":"column_number","restriction":""},{"name":"cause","default_value":"nil","external_name":"cause","restriction":""}],"args_string":"(message, line_number, column_number, cause = nil)","args_html":"(message, line_number, column_number, cause = <span class=\"n\">nil</span>)","location":{"filename":"src/json.cr","line_number":124,"url":null},"def":{"name":"new","args":[{"name":"message","external_name":"message","restriction":""},{"name":"line_number","external_name":"line_number","restriction":""},{"name":"column_number","external_name":"column_number","restriction":""},{"name":"cause","default_value":"nil","external_name":"cause","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(message, line_number, column_number, cause)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"column_number:Int32-instance-method","name":"column_number","abstract":false,"location":{"filename":"src/json.cr","line_number":122,"url":null},"def":{"name":"column_number","return_type":"Int32","visibility":"Public","body":"@column_number"}},{"html_id":"line_number:Int32-instance-method","name":"line_number","abstract":false,"location":{"filename":"src/json.cr","line_number":121,"url":null},"def":{"name":"line_number","return_type":"Int32","visibility":"Public","body":"@line_number"}},{"html_id":"location:Tuple(Int32,Int32)-instance-method","name":"location","abstract":false,"location":{"filename":"src/json.cr","line_number":128,"url":null},"def":{"name":"location","return_type":"::Tuple(Int32, Int32)","visibility":"Public","body":"{line_number, column_number}"}}]},{"html_id":"Crystal/JSON/Parser","path":"JSON/Parser.html","kind":"class","full_name":"JSON::Parser","name":"Parser","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/parser.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"constructors":[{"html_id":"new(string_or_io:String|IO)-class-method","name":"new","abstract":false,"args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"}],"args_string":"(string_or_io : String | IO)","args_html":"(string_or_io : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/json/parser.cr","line_number":6,"url":null},"def":{"name":"new","args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"}],"visibility":"Public","body":"_ = allocate\n_.initialize(string_or_io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"max_nesting:Int32-instance-method","name":"max_nesting","abstract":false,"location":{"filename":"src/json/parser.cr","line_number":4,"url":null},"def":{"name":"max_nesting","visibility":"Public","body":"@max_nesting"}},{"html_id":"max_nesting=(max_nesting)-instance-method","name":"max_nesting=","abstract":false,"args":[{"name":"max_nesting","external_name":"max_nesting","restriction":""}],"args_string":"(max_nesting)","args_html":"(max_nesting)","location":{"filename":"src/json/parser.cr","line_number":4,"url":null},"def":{"name":"max_nesting=","args":[{"name":"max_nesting","external_name":"max_nesting","restriction":""}],"visibility":"Public","body":"@max_nesting = max_nesting"}},{"html_id":"parse:Any-instance-method","name":"parse","abstract":false,"location":{"filename":"src/json/parser.cr","line_number":12,"url":null},"def":{"name":"parse","return_type":"Any","visibility":"Public","body":"json = parse_value\ncheck(:EOF)\njson\n"}}]},{"html_id":"Crystal/JSON/PullParser","path":"JSON/PullParser.html","kind":"class","full_name":"JSON::PullParser","name":"PullParser","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/pull_parser.cr","line_number":61,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":"This class allows you to consume JSON on demand, token by token.\n\nEach *read_** method consumes the next token.\nSometimes it consumes only one token (like `read_begin_array`), sometimes it consumes a full valid value (like `read_array`).\n\nYou must be careful when calling those methods, as they move forward into the JSON input you are pulling.\nCalling `read_string` twice will return the next two strings (if possible), not twice the same.\n\nIf you try to read a token which is not the one currently under the cursor location, an exception `ParseException` will be raised.\n\nExample:\n```\ninput = %(\n  {\n    \"type\": \"event\",\n    \"values\": [1, 4, \"three\", 10]\n  }\n)\npull = JSON::PullParser.new(input)\npull.read_begin_object\npull.read_object_key # => \"type\"\npull.read_string     # => \"event\"\n# Actually you can also use `read_string` to read a key\npull.read_string # => \"values\"\npull.read_begin_array\npull.read_int    # => 1\npull.read_int    # => 4\npull.read_string # => \"three\"\npull.read_int    # => 10\npull.read_end_array\npull.read_end_object\n```\n\nAnother example reading the same object:\n```\npull = JSON::PullParser.new(input)\npull.read_object do |key|\n  case key\n  when \"type\"\n    pull.read_string # => \"event\"\n  when \"values\"\n    pull.read_array do\n      if v = pull.read?(Int8)\n        v\n      else\n        pull.read_string\n      end\n    end\n  end\nend\n```\n\nThis example fails:\n```\npull = JSON::PullParser.new(input)\npull.read_begin_object\npull.read_object_key # => \"type\"\npull.read_string     # => \"event\"\npull.read_end_object # => raise an exception. The current token is a string (\"values\"), not the end of an object.\n```","summary":"<p>This class allows you to consume JSON on demand, token by token.</p>","constructors":[{"html_id":"new(input)-class-method","name":"new","doc":"Creates a PullParser which will consume the JSON *input*.\n\n*input* must be a `String` or an `IO`.","summary":"<p>Creates a PullParser which will consume the JSON <em>input</em>.</p>","abstract":false,"args":[{"name":"input","external_name":"input","restriction":""}],"args_string":"(input)","args_html":"(input)","location":{"filename":"src/json/pull_parser.cr","line_number":99,"url":null},"def":{"name":"new","args":[{"name":"input","external_name":"input","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(input)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"bool_value:Bool-instance-method","name":"bool_value","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":81,"url":null},"def":{"name":"bool_value","return_type":"Bool","visibility":"Public","body":"@bool_value"}},{"html_id":"column_number-instance-method","name":"column_number","doc":"Returns the current column number.","summary":"<p>Returns the current column number.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":576,"url":null},"def":{"name":"column_number","visibility":"Public","body":"@location[1]"}},{"html_id":"float_value:Float64-instance-method","name":"float_value","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":87,"url":null},"def":{"name":"float_value","return_type":"Float64","visibility":"Public","body":"token.float_value"}},{"html_id":"int_value:Int64-instance-method","name":"int_value","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":83,"url":null},"def":{"name":"int_value","return_type":"Int64","visibility":"Public","body":"token.int_value"}},{"html_id":"kind:Kind-instance-method","name":"kind","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":80,"url":null},"def":{"name":"kind","return_type":"Kind","visibility":"Public","body":"@kind"}},{"html_id":"line_number-instance-method","name":"line_number","doc":"Returns the current line number.","summary":"<p>Returns the current line number.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":571,"url":null},"def":{"name":"line_number","visibility":"Public","body":"@location[0]"}},{"html_id":"location:Tuple(Int32,Int32)-instance-method","name":"location","doc":"Returns the current location.\n\nThe location is a tuple `{line number, column number}`.","summary":"<p>Returns the current location.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":583,"url":null},"def":{"name":"location","return_type":"Tuple(Int32, Int32)","visibility":"Public","body":"@location"}},{"html_id":"max_nesting:Int32-instance-method","name":"max_nesting","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":94,"url":null},"def":{"name":"max_nesting","visibility":"Public","body":"@max_nesting"}},{"html_id":"max_nesting=(max_nesting)-instance-method","name":"max_nesting=","abstract":false,"args":[{"name":"max_nesting","external_name":"max_nesting","restriction":""}],"args_string":"(max_nesting)","args_html":"(max_nesting)","location":{"filename":"src/json/pull_parser.cr","line_number":94,"url":null},"def":{"name":"max_nesting=","args":[{"name":"max_nesting","external_name":"max_nesting","restriction":""}],"visibility":"Public","body":"@max_nesting = max_nesting"}},{"html_id":"on_key(key,&:self->_)-instance-method","name":"on_key","doc":"Reads an object keys and yield when *key* is found.\n\nAll the other object keys are skipped.\n\nReturns the return value of the block or `Nil` if the key was not read.","summary":"<p>Reads an object keys and yield when <em>key</em> is found.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key, & : self -> _)","args_html":"(key, & : <span class=\"k\">self</span> -> _)","location":{"filename":"src/json/pull_parser.cr","line_number":359,"url":null},"def":{"name":"on_key","args":[{"name":"key","external_name":"key","restriction":""}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(self -> _)"},"visibility":"Public","body":"result = nil\nread_object do |some_key|\n  if some_key == key\n    result = yield self\n  else\n    skip\n  end\nend\nresult\n"}},{"html_id":"on_key!(key,&:self->_)-instance-method","name":"on_key!","doc":"Reads an object keys and yield when *key* is found. If not found, raise an `Exception`.\n\nAll the other object keys are skipped.\n\nReturns the return value of the block.","summary":"<p>Reads an object keys and yield when <em>key</em> is found.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key, & : self -> _)","args_html":"(key, & : <span class=\"k\">self</span> -> _)","location":{"filename":"src/json/pull_parser.cr","line_number":376,"url":null},"def":{"name":"on_key!","args":[{"name":"key","external_name":"key","restriction":""}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(self -> _)"},"visibility":"Public","body":"found = false\nvalue = uninitialized typeof(yield self)\nread_object do |some_key|\n  if some_key == key\n    found = true\n    value = yield self\n  else\n    skip\n  end\nend\nif found\nelse\n  raise(\"JSON key not found: #{key}\")\nend\nvalue\n"}},{"html_id":"raise(message:String):NoReturn-instance-method","name":"raise","doc":"Raises `ParseException` with *message* at current location.","summary":"<p>Raises <code><a href=\"../JSON/ParseException.html\">ParseException</a></code> with <em>message</em> at current location.</p>","abstract":false,"args":[{"name":"message","external_name":"message","restriction":"String"}],"args_string":"(message : String) : NoReturn","args_html":"(message : <a href=\"../String.html\">String</a>) : NoReturn","location":{"filename":"src/json/pull_parser.cr","line_number":695,"url":null},"def":{"name":"raise","args":[{"name":"message","external_name":"message","restriction":"String"}],"return_type":"NoReturn","visibility":"Public","body":"::raise(ParseException.new(message, token.line_number, token.column_number))"}},{"html_id":"raw_value:String-instance-method","name":"raw_value","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":92,"url":null},"def":{"name":"raw_value","return_type":"String","visibility":"Public","body":"@raw_value"}},{"html_id":"read?(klass:Bool.class):Bool?-instance-method","name":"read?","doc":"Reads a `Bool` value and returns it.\n\nIf the value is not a `Bool`, returns `nil`.","summary":"<p>Reads a <code><a href=\"../Bool.html\">Bool</a></code> value and returns it.</p>","abstract":false,"args":[{"name":"klass","external_name":"klass","restriction":"Bool.class"}],"args_string":"(klass : Bool.class) : Bool?","args_html":"(klass : <span class=\"t\">Bool</span>.<span class=\"k\">class</span>) : <a href=\"../Bool.html\">Bool</a>?","location":{"filename":"src/json/pull_parser.cr","line_number":408,"url":null},"def":{"name":"read?","args":[{"name":"klass","external_name":"klass","restriction":"Bool.class"}],"return_type":"Bool | ::Nil","visibility":"Public","body":"if kind.bool?\n  read_bool\nend"}},{"html_id":"read?(klass:Int8.class)-instance-method","name":"read?","doc":"Reads an Int8 value and returns it.\n\nIf the value is not an integer or does not fit in a Int8 variable, it returns `nil`.","summary":"<p>Reads an Int8 value and returns it.</p>","abstract":false,"args":[{"name":"klass","external_name":"klass","restriction":"Int8.class"}],"args_string":"(klass : Int8.class)","args_html":"(klass : <span class=\"t\">Int8</span>.<span class=\"k\">class</span>)","location":{"filename":"src/json/pull_parser.cr","line_number":412,"url":null},"def":{"name":"read?","args":[{"name":"klass","external_name":"klass","restriction":"Int8.class"}],"visibility":"Public","body":"begin\n  if kind.int?\n    (Int8.new(int_value)).tap do\n      read_next\n    end\n  end\nrescue JSON::ParseException | OverflowError\n  nil\nend"}},{"html_id":"read?(klass:Int16.class)-instance-method","name":"read?","doc":"Reads an Int16 value and returns it.\n\nIf the value is not an integer or does not fit in a Int16 variable, it returns `nil`.","summary":"<p>Reads an Int16 value and returns it.</p>","abstract":false,"args":[{"name":"klass","external_name":"klass","restriction":"Int16.class"}],"args_string":"(klass : Int16.class)","args_html":"(klass : <span class=\"t\">Int16</span>.<span class=\"k\">class</span>)","location":{"filename":"src/json/pull_parser.cr","line_number":412,"url":null},"def":{"name":"read?","args":[{"name":"klass","external_name":"klass","restriction":"Int16.class"}],"visibility":"Public","body":"begin\n  if kind.int?\n    (Int16.new(int_value)).tap do\n      read_next\n    end\n  end\nrescue JSON::ParseException | OverflowError\n  nil\nend"}},{"html_id":"read?(klass:Int32.class)-instance-method","name":"read?","doc":"Reads an Int32 value and returns it.\n\nIf the value is not an integer or does not fit in a Int32 variable, it returns `nil`.","summary":"<p>Reads an Int32 value and returns it.</p>","abstract":false,"args":[{"name":"klass","external_name":"klass","restriction":"Int32.class"}],"args_string":"(klass : Int32.class)","args_html":"(klass : <span class=\"t\">Int32</span>.<span class=\"k\">class</span>)","location":{"filename":"src/json/pull_parser.cr","line_number":412,"url":null},"def":{"name":"read?","args":[{"name":"klass","external_name":"klass","restriction":"Int32.class"}],"visibility":"Public","body":"begin\n  if kind.int?\n    (Int32.new(int_value)).tap do\n      read_next\n    end\n  end\nrescue JSON::ParseException | OverflowError\n  nil\nend"}},{"html_id":"read?(klass:Int64.class)-instance-method","name":"read?","doc":"Reads an Int64 value and returns it.\n\nIf the value is not an integer or does not fit in a Int64 variable, it returns `nil`.","summary":"<p>Reads an Int64 value and returns it.</p>","abstract":false,"args":[{"name":"klass","external_name":"klass","restriction":"Int64.class"}],"args_string":"(klass : Int64.class)","args_html":"(klass : <span class=\"t\">Int64</span>.<span class=\"k\">class</span>)","location":{"filename":"src/json/pull_parser.cr","line_number":412,"url":null},"def":{"name":"read?","args":[{"name":"klass","external_name":"klass","restriction":"Int64.class"}],"visibility":"Public","body":"begin\n  if kind.int?\n    (Int64.new(int_value)).tap do\n      read_next\n    end\n  end\nrescue JSON::ParseException | OverflowError\n  nil\nend"}},{"html_id":"read?(klass:UInt8.class)-instance-method","name":"read?","doc":"Reads an UInt8 value and returns it.\n\nIf the value is not an integer or does not fit in a UInt8 variable, it returns `nil`.","summary":"<p>Reads an UInt8 value and returns it.</p>","abstract":false,"args":[{"name":"klass","external_name":"klass","restriction":"UInt8.class"}],"args_string":"(klass : UInt8.class)","args_html":"(klass : <span class=\"t\">UInt8</span>.<span class=\"k\">class</span>)","location":{"filename":"src/json/pull_parser.cr","line_number":412,"url":null},"def":{"name":"read?","args":[{"name":"klass","external_name":"klass","restriction":"UInt8.class"}],"visibility":"Public","body":"begin\n  if kind.int?\n    (UInt8.new(int_value)).tap do\n      read_next\n    end\n  end\nrescue JSON::ParseException | OverflowError\n  nil\nend"}},{"html_id":"read?(klass:UInt16.class)-instance-method","name":"read?","doc":"Reads an UInt16 value and returns it.\n\nIf the value is not an integer or does not fit in a UInt16 variable, it returns `nil`.","summary":"<p>Reads an UInt16 value and returns it.</p>","abstract":false,"args":[{"name":"klass","external_name":"klass","restriction":"UInt16.class"}],"args_string":"(klass : UInt16.class)","args_html":"(klass : <span class=\"t\">UInt16</span>.<span class=\"k\">class</span>)","location":{"filename":"src/json/pull_parser.cr","line_number":412,"url":null},"def":{"name":"read?","args":[{"name":"klass","external_name":"klass","restriction":"UInt16.class"}],"visibility":"Public","body":"begin\n  if kind.int?\n    (UInt16.new(int_value)).tap do\n      read_next\n    end\n  end\nrescue JSON::ParseException | OverflowError\n  nil\nend"}},{"html_id":"read?(klass:UInt32.class)-instance-method","name":"read?","doc":"Reads an UInt32 value and returns it.\n\nIf the value is not an integer or does not fit in a UInt32 variable, it returns `nil`.","summary":"<p>Reads an UInt32 value and returns it.</p>","abstract":false,"args":[{"name":"klass","external_name":"klass","restriction":"UInt32.class"}],"args_string":"(klass : UInt32.class)","args_html":"(klass : <span class=\"t\">UInt32</span>.<span class=\"k\">class</span>)","location":{"filename":"src/json/pull_parser.cr","line_number":412,"url":null},"def":{"name":"read?","args":[{"name":"klass","external_name":"klass","restriction":"UInt32.class"}],"visibility":"Public","body":"begin\n  if kind.int?\n    (UInt32.new(int_value)).tap do\n      read_next\n    end\n  end\nrescue JSON::ParseException | OverflowError\n  nil\nend"}},{"html_id":"read?(klass:UInt64.class):UInt64?-instance-method","name":"read?","doc":"Reads an `Int64` value and returns it.\n\nIf the value is not an integer or does not fin in an `Int64` variable, it returns `nil`.","summary":"<p>Reads an <code><a href=\"../Int64.html\">Int64</a></code> value and returns it.</p>","abstract":false,"args":[{"name":"klass","external_name":"klass","restriction":"UInt64.class"}],"args_string":"(klass : UInt64.class) : UInt64?","args_html":"(klass : <span class=\"t\">UInt64</span>.<span class=\"k\">class</span>) : <a href=\"../UInt64.html\">UInt64</a>?","location":{"filename":"src/json/pull_parser.cr","line_number":426,"url":null},"def":{"name":"read?","args":[{"name":"klass","external_name":"klass","restriction":"UInt64.class"}],"return_type":"UInt64 | ::Nil","visibility":"Public","body":"begin\n  if kind.int?\n    (UInt64.new(raw_value)).tap do\n      read_next\n    end\n  end\nrescue JSON::ParseException | ArgumentError\n  nil\nend"}},{"html_id":"read?(klass:Float32.class):Float32?-instance-method","name":"read?","doc":"Reads an `Float32` value and returns it.\n\nIf the value is not an integer or does not fit in an `Float32`, it returns `nil`.\nIf the value was actually an integer, it is converted to a float.","summary":"<p>Reads an <code><a href=\"../Float32.html\">Float32</a></code> value and returns it.</p>","abstract":false,"args":[{"name":"klass","external_name":"klass","restriction":"Float32.class"}],"args_string":"(klass : Float32.class) : Float32?","args_html":"(klass : <span class=\"t\">Float32</span>.<span class=\"k\">class</span>) : <a href=\"../Float32.html\">Float32</a>?","location":{"filename":"src/json/pull_parser.cr","line_number":437,"url":null},"def":{"name":"read?","args":[{"name":"klass","external_name":"klass","restriction":"Float32.class"}],"return_type":"Float32 | ::Nil","visibility":"Public","body":"begin\n  if kind.int?\n    return read_int.to_f32\n  end\n  if kind.float?\n    return raw_value.to_f32.tap do\n      read_next\n    end\n  end\nrescue exc : JSON::ParseException | ArgumentError\n  nil\nend"}},{"html_id":"read?(klass:Float64.class):Float64?-instance-method","name":"read?","doc":"Reads an `Float64` value and returns it.\n\nIf the value is not an integer or does not fit in a `Float64` variable, it returns `nil`.\nIf the value was actually an integer, it is converted to a float.","summary":"<p>Reads an <code><a href=\"../Float64.html\">Float64</a></code> value and returns it.</p>","abstract":false,"args":[{"name":"klass","external_name":"klass","restriction":"Float64.class"}],"args_string":"(klass : Float64.class) : Float64?","args_html":"(klass : <span class=\"t\">Float64</span>.<span class=\"k\">class</span>) : <a href=\"../Float64.html\">Float64</a>?","location":{"filename":"src/json/pull_parser.cr","line_number":448,"url":null},"def":{"name":"read?","args":[{"name":"klass","external_name":"klass","restriction":"Float64.class"}],"return_type":"Float64 | ::Nil","visibility":"Public","body":"begin\n  if kind.int?\n    return read_int.to_f64\n  end\n  if kind.float?\n    return read_float.to_f64\n  end\nrescue JSON::ParseException\n  nil\nend"}},{"html_id":"read?(klass:String.class):String?-instance-method","name":"read?","doc":"Reads a `String` value and returns it.\n\nIf the value is not a `String`, returns `nil`.","summary":"<p>Reads a <code><a href=\"../String.html\">String</a></code> value and returns it.</p>","abstract":false,"args":[{"name":"klass","external_name":"klass","restriction":"String.class"}],"args_string":"(klass : String.class) : String?","args_html":"(klass : <span class=\"t\">String</span>.<span class=\"k\">class</span>) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/json/pull_parser.cr","line_number":458,"url":null},"def":{"name":"read?","args":[{"name":"klass","external_name":"klass","restriction":"String.class"}],"return_type":"String | ::Nil","visibility":"Public","body":"if kind.string?\n  read_string\nend"}},{"html_id":"read_array(&)-instance-method","name":"read_array","doc":"Reads a whole array.\n\nIt reads the beginning of the array, yield each value of the array, and reads the end of the array.\nYou have to consumes the values, if any, so the pull parser does not fail when reading the end of the array.\n\nIf the array is empty, it does not yield.","summary":"<p>Reads a whole array.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":157,"url":null},"def":{"name":"read_array","yields":0,"visibility":"Public","body":"read_begin_array\nwhile !kind.end_array?\n  yield\nend\nread_end_array\n"}},{"html_id":"read_array_or_null(&)-instance-method","name":"read_array_or_null","doc":"Reads an array or a null value, and returns it.","summary":"<p>Reads an array or a null value, and returns it.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":335,"url":null},"def":{"name":"read_array_or_null","yields":0,"visibility":"Public","body":"read_null_or do\n  read_array do\n    yield\n  end\nend"}},{"html_id":"read_begin_array-instance-method","name":"read_begin_array","doc":"Reads the beginning of an array.","summary":"<p>Reads the beginning of an array.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":140,"url":null},"def":{"name":"read_begin_array","visibility":"Public","body":"expect_kind(:begin_array)\nread_next\n"}},{"html_id":"read_begin_object-instance-method","name":"read_begin_object","doc":"Reads the beginning of an object.","summary":"<p>Reads the beginning of an object.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":166,"url":null},"def":{"name":"read_begin_object","visibility":"Public","body":"expect_kind(:begin_object)\nread_next\n"}},{"html_id":"read_bool:Bool-instance-method","name":"read_bool","doc":"Reads a `Bool` value.","summary":"<p>Reads a <code><a href=\"../Bool.html\">Bool</a></code> value.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":206,"url":null},"def":{"name":"read_bool","return_type":"Bool","visibility":"Public","body":"expect_kind(:bool)\n@bool_value.tap do\n  read_next\nend\n"}},{"html_id":"read_bool_or_null:Bool?-instance-method","name":"read_bool_or_null","doc":"Reads a `Bool` or a null value, and returns it.","summary":"<p>Reads a <code><a href=\"../Bool.html\">Bool</a></code> or a null value, and returns it.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":315,"url":null},"def":{"name":"read_bool_or_null","return_type":"Bool | ::Nil","visibility":"Public","body":"read_null_or do\n  read_bool\nend"}},{"html_id":"read_end_array-instance-method","name":"read_end_array","doc":"Reads the end of an array.","summary":"<p>Reads the end of an array.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":146,"url":null},"def":{"name":"read_end_array","visibility":"Public","body":"expect_kind(:end_array)\nread_next\n"}},{"html_id":"read_end_object-instance-method","name":"read_end_object","doc":"Reads the end of an object.","summary":"<p>Reads the end of an object.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":172,"url":null},"def":{"name":"read_end_object","visibility":"Public","body":"expect_kind(:end_object)\nread_next\n"}},{"html_id":"read_float:Float64-instance-method","name":"read_float","doc":"Reads a float value.\n\nIf the value is actually an integer, it is converted to float.","summary":"<p>Reads a float value.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":220,"url":null},"def":{"name":"read_float","return_type":"Float64","visibility":"Public","body":"case @kind\nwhen .int?\n  int_value.to_f.tap do\n    read_next\n  end\nwhen .float?\n  float_value.tap do\n    read_next\n  end\nelse\n  raise(\"expecting int or float but was #{@kind}\")\nend"}},{"html_id":"read_float_or_null:Float64?-instance-method","name":"read_float_or_null","doc":"Reads a float or a null value, and returns it.","summary":"<p>Reads a float or a null value, and returns it.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":325,"url":null},"def":{"name":"read_float_or_null","return_type":"Float64 | ::Nil","visibility":"Public","body":"read_null_or do\n  read_float\nend"}},{"html_id":"read_int:Int64-instance-method","name":"read_int","doc":"Reads an integer value.","summary":"<p>Reads an integer value.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":212,"url":null},"def":{"name":"read_int","return_type":"Int64","visibility":"Public","body":"expect_kind(:int)\nint_value.tap do\n  read_next\nend\n"}},{"html_id":"read_int_or_null:Int64?-instance-method","name":"read_int_or_null","doc":"Reads an integer or a null value, and returns it.","summary":"<p>Reads an integer or a null value, and returns it.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":320,"url":null},"def":{"name":"read_int_or_null","return_type":"Int64 | ::Nil","visibility":"Public","body":"read_null_or do\n  read_int\nend"}},{"html_id":"read_next:Kind-instance-method","name":"read_next","doc":"Reads the next lexer's token.\n\nContrary to `read_raw`, it does not read a full value.\nFor example if the next token is the beginning of an array, it will stop there, while `read_raw` would have read the whole array.","summary":"<p>Reads the next lexer's token.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":400,"url":null},"def":{"name":"read_next","return_type":"Kind","visibility":"Public","body":"read_next_internal\n@kind\n"}},{"html_id":"read_null:Nil-instance-method","name":"read_null","doc":"Reads a null value and returns it.","summary":"<p>Reads a null value and returns it.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":199,"url":null},"def":{"name":"read_null","return_type":"Nil","visibility":"Public","body":"expect_kind(:null)\nread_next\nnil\n"}},{"html_id":"read_null_or(&)-instance-method","name":"read_null_or","doc":"Reads a null value and returns it, or executes the given block if the value is not null.","summary":"<p>Reads a null value and returns it, or executes the given block if the value is not null.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":345,"url":null},"def":{"name":"read_null_or","yields":0,"visibility":"Public","body":"if @kind.null?\n  read_next\n  nil\nelse\n  yield\nend"}},{"html_id":"read_object(&)-instance-method","name":"read_object","doc":"Reads a whole object.\n\nIt reads the beginning of the object, yield each key and key location, and reads the end of the object.\nYou have to consumes the values, if any, so the pull parser does not fail when reading the end of the object.\n\nIf the object is empty, it does not yield.","summary":"<p>Reads a whole object.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":188,"url":null},"def":{"name":"read_object","yields":2,"visibility":"Public","body":"read_begin_object\nwhile !kind.end_object?\n  key_location = location\n  key = read_object_key\n  yield key, key_location\nend\nread_end_object\n"}},{"html_id":"read_object_key:String-instance-method","name":"read_object_key","doc":"Reads an object's key and returns it.","summary":"<p>Reads an object's key and returns it.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":178,"url":null},"def":{"name":"read_object_key","return_type":"String","visibility":"Public","body":"read_string"}},{"html_id":"read_object_or_null(&)-instance-method","name":"read_object_or_null","doc":"Reads an object or a null value, and returns it.","summary":"<p>Reads an object or a null value, and returns it.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":340,"url":null},"def":{"name":"read_object_or_null","yields":1,"visibility":"Public","body":"read_null_or do\n  read_object do |key|\n    yield key\n  end\nend"}},{"html_id":"read_raw(json):Nil-instance-method","name":"read_raw","doc":"Reads the new value and fill the a JSON builder with it.\n\nUse this method with a `JSON::Builder` to read a JSON while building another one.","summary":"<p>Reads the new value and fill the a JSON builder with it.</p>","abstract":false,"args":[{"name":"json","external_name":"json","restriction":""}],"args_string":"(json) : Nil","args_html":"(json) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/pull_parser.cr","line_number":271,"url":null},"def":{"name":"read_raw","args":[{"name":"json","external_name":"json","restriction":""}],"return_type":"Nil","visibility":"Public","body":"case @kind\nwhen .null?\n  read_next\n  json.null\nwhen .bool?\n  json.bool(@bool_value)\n  read_next\nwhen .int?, .float?\n  json.raw(@raw_value)\n  read_next\nwhen .string?\n  json.string(@string_value)\n  read_next\nwhen .begin_array?\n  json.array do\n    read_begin_array\n    while !kind.end_array?\n      read_raw(json)\n    end\n    read_end_array\n  end\nwhen .begin_object?\n  json.object do\n    read_begin_object\n    while !kind.end_object?\n      json.string(@string_value)\n      read_object_key\n      read_raw(json)\n    end\n    read_end_object\n  end\nelse\n  unexpected_token\nend"}},{"html_id":"read_raw:String-instance-method","name":"read_raw","doc":"Read the next value and returns it.\n\nThe value is returned as a json string.\nIf the value is an array or an object, it returns a string representing the full value.\nIf the value in unknown, it raises a `ParseException`.\n\n```\npull = JSON::PullParser.new %([null, true, 1, \"foo\", [1, \"two\"], {\"foo\": \"bar\"}])\npull.read_begin_array\npull.read_raw # => \"null\"\npull.read_raw # => \"true\"\npull.read_raw # => \"1\"\npull.read_raw # => \"\\\"foo\\\"\"\npull.read_raw # => \"[1,\\\"two\\\"]\"\npull.read_raw # => \"{\\\"foo\\\":\\\"bar\\\"}\"\npull.read_end_array\n```","summary":"<p>Read the next value and returns it.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":248,"url":null},"def":{"name":"read_raw","return_type":"String","visibility":"Public","body":"case @kind\nwhen .null?\n  read_next\n  \"null\"\nwhen .bool?\n  @bool_value.to_s.tap do\n    read_next\n  end\nwhen .int?, .float?\n  @raw_value.tap do\n    read_next\n  end\nwhen .string?\n  @string_value.to_json.tap do\n    read_next\n  end\nwhen .begin_array?\n  JSON.build do |json|\n    read_raw(json)\n  end\nwhen .begin_object?\n  JSON.build do |json|\n    read_raw(json)\n  end\nelse\n  unexpected_token\nend"}},{"html_id":"read_string:String-instance-method","name":"read_string","doc":"Reads a string and returns it.","summary":"<p>Reads a string and returns it.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":309,"url":null},"def":{"name":"read_string","return_type":"String","visibility":"Public","body":"expect_kind(:string)\n@string_value.tap do\n  read_next\nend\n"}},{"html_id":"read_string_or_null:String?-instance-method","name":"read_string_or_null","doc":"Reads a string or a null value, and returns it.","summary":"<p>Reads a string or a null value, and returns it.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":330,"url":null},"def":{"name":"read_string_or_null","return_type":"String | ::Nil","visibility":"Public","body":"read_null_or do\n  read_string\nend"}},{"html_id":"skip:Nil-instance-method","name":"skip","doc":"Skips the next value.\n\nIt skips the whole value, not only the next lexer's token.\nFor example if the next value is an array, the whole array will be skipped.","summary":"<p>Skips the next value.</p>","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":564,"url":null},"def":{"name":"skip","return_type":"Nil","visibility":"Public","body":"@lexer.skip = true\nskip_internal\n@lexer.skip = false\n"}},{"html_id":"string_value:String-instance-method","name":"string_value","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":91,"url":null},"def":{"name":"string_value","return_type":"String","visibility":"Public","body":"@string_value"}}],"types":[{"html_id":"Crystal/JSON/PullParser/Kind","path":"JSON/PullParser/Kind.html","kind":"enum","full_name":"JSON::PullParser::Kind","name":"Kind","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/pull_parser.cr","line_number":62,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Null","name":"Null","value":"0"},{"id":"Bool","name":"Bool","value":"1"},{"id":"Int","name":"Int","value":"2"},{"id":"Float","name":"Float","value":"3"},{"id":"String","name":"String","value":"4"},{"id":"BeginArray","name":"BeginArray","value":"5"},{"id":"EndArray","name":"EndArray","value":"6"},{"id":"BeginObject","name":"BeginObject","value":"7"},{"id":"EndObject","name":"EndObject","value":"8"},{"id":"EOF","name":"EOF","value":"9"}],"namespace":{"html_id":"Crystal/JSON/PullParser","kind":"class","full_name":"JSON::PullParser","name":"PullParser"},"instance_methods":[{"html_id":"begin_array?-instance-method","name":"begin_array?","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":68,"url":null},"def":{"name":"begin_array?","visibility":"Public","body":"self == BeginArray"}},{"html_id":"begin_object?-instance-method","name":"begin_object?","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":70,"url":null},"def":{"name":"begin_object?","visibility":"Public","body":"self == BeginObject"}},{"html_id":"bool?-instance-method","name":"bool?","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":64,"url":null},"def":{"name":"bool?","visibility":"Public","body":"self == Bool"}},{"html_id":"end_array?-instance-method","name":"end_array?","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":69,"url":null},"def":{"name":"end_array?","visibility":"Public","body":"self == EndArray"}},{"html_id":"end_object?-instance-method","name":"end_object?","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":71,"url":null},"def":{"name":"end_object?","visibility":"Public","body":"self == EndObject"}},{"html_id":"eof?-instance-method","name":"eof?","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":72,"url":null},"def":{"name":"eof?","visibility":"Public","body":"self == EOF"}},{"html_id":"float?-instance-method","name":"float?","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":66,"url":null},"def":{"name":"float?","visibility":"Public","body":"self == Float"}},{"html_id":"int?-instance-method","name":"int?","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":65,"url":null},"def":{"name":"int?","visibility":"Public","body":"self == Int"}},{"html_id":"null?-instance-method","name":"null?","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":63,"url":null},"def":{"name":"null?","visibility":"Public","body":"self == Null"}},{"html_id":"string?-instance-method","name":"string?","abstract":false,"location":{"filename":"src/json/pull_parser.cr","line_number":67,"url":null},"def":{"name":"string?","visibility":"Public","body":"self == String"}}]}]},{"html_id":"Crystal/JSON/Serializable","path":"JSON/Serializable.html","kind":"module","full_name":"JSON::Serializable","name":"Serializable","abstract":false,"locations":[{"filename":"src/json/serialization.cr","line_number":129,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"doc":"The `JSON::Serializable` module automatically generates methods for JSON serialization when included.\n\n### Example\n\n```\nrequire \"json\"\n\nclass Location\n  include JSON::Serializable\n\n  @[JSON::Field(key: \"lat\")]\n  property latitude : Float64\n\n  @[JSON::Field(key: \"lng\")]\n  property longitude : Float64\nend\n\nclass House\n  include JSON::Serializable\n  property address : String\n  property location : Location?\nend\n\nhouse = House.from_json(%({\"address\": \"Crystal Road 1234\", \"location\": {\"lat\": 12.3, \"lng\": 34.5}}))\nhouse.address  # => \"Crystal Road 1234\"\nhouse.location # => #<Location:0x10cd93d80 @latitude=12.3, @longitude=34.5>\nhouse.to_json  # => %({\"address\":\"Crystal Road 1234\",\"location\":{\"lat\":12.3,\"lng\":34.5}})\n\nhouses = Array(House).from_json(%([{\"address\": \"Crystal Road 1234\", \"location\": {\"lat\": 12.3, \"lng\": 34.5}}]))\nhouses.size    # => 1\nhouses.to_json # => %([{\"address\":\"Crystal Road 1234\",\"location\":{\"lat\":12.3,\"lng\":34.5}}])\n```\n\n### Usage\n\nIncluding `JSON::Serializable` will create `#to_json` and `self.from_json` methods on the current class,\nand a constructor which takes a `JSON::PullParser`. By default, these methods serialize into a json\nobject containing the value of every instance variable, the keys being the instance variable name.\nMost primitives and collections supported as instance variable values (string, integer, array, hash, etc.),\nalong with objects which define to_json and a constructor taking a `JSON::PullParser`.\nUnion types are also supported, including unions with nil. If multiple types in a union parse correctly,\nit is undefined which one will be chosen.\n\nTo change how individual instance variables are parsed and serialized, the annotation `JSON::Field`\ncan be placed on the instance variable. Annotating property, getter and setter macros is also allowed.\n```\nrequire \"json\"\n\nclass A\n  include JSON::Serializable\n\n  @[JSON::Field(key: \"my_key\", emit_null: true)]\n  getter a : Int32?\nend\n```\n\n`JSON::Field` properties:\n* **ignore**: if `true` skip this field in serialization and deserialization (by default false)\n* **ignore_serialize**: if `true` skip this field in serialization (by default false)\n* **ignore_deserialize**: if `true` skip this field in deserialization (by default false)\n* **key**: the value of the key in the json object (by default the name of the instance variable)\n* **root**: assume the value is inside a JSON object with a given key (see `Object.from_json(string_or_io, root)`)\n* **converter**: specify an alternate type for parsing and generation. The converter must define `from_json(JSON::PullParser)` and `to_json(value, JSON::Builder)`. Examples of converters are a `Time::Format` instance and `Time::EpochConverter` for `Time`.\n* **presence**: if `true`, a `@{{key}}_present` instance variable will be generated when the key was present (even if it has a `null` value), `false` by default\n* **emit_null**: if `true`, emits a `null` value for nilable property (by default nulls are not emitted)\n\nDeserialization also respects default values of variables:\n```\nrequire \"json\"\n\nstruct A\n  include JSON::Serializable\n  @a : Int32\n  @b : Float64 = 1.0\nend\n\nA.from_json(%<{\"a\":1}>) # => A(@a=1, @b=1.0)\n```\n\n### Extensions: `JSON::Serializable::Strict` and `JSON::Serializable::Unmapped`.\n\nIf the `JSON::Serializable::Strict` module is included, unknown properties in the JSON\ndocument will raise a parse exception. By default the unknown properties\nare silently ignored.\nIf the `JSON::Serializable::Unmapped` module is included, unknown properties in the JSON\ndocument will be stored in a `Hash(String, JSON::Any)`. On serialization, any keys inside json_unmapped\nwill be serialized and appended to the current json object.\n```\nrequire \"json\"\n\nstruct A\n  include JSON::Serializable\n  include JSON::Serializable::Unmapped\n  @a : Int32\nend\n\na = A.from_json(%({\"a\":1,\"b\":2})) # => A(@json_unmapped={\"b\" => 2_i64}, @a=1)\na.to_json                         # => {\"a\":1,\"b\":2}\n```\n\n\n### Class annotation `JSON::Serializable::Options`\n\nsupported properties:\n* **emit_nulls**: if `true`, emits a `null` value for all nilable properties (by default nulls are not emitted)\n\n```\nrequire \"json\"\n\n@[JSON::Serializable::Options(emit_nulls: true)]\nclass A\n  include JSON::Serializable\n  @a : Int32?\nend\n```\n\n### Discriminator field\n\nA very common JSON serialization strategy for handling different objects\nunder a same hierarchy is to use a discriminator field. For example in\n[GeoJSON](https://tools.ietf.org/html/rfc7946) each object has a \"type\"\nfield, and the rest of the fields, and their meaning, depend on its value.\n\nYou can use `JSON::Serializable.use_json_discriminator` for this use case.","summary":"<p>The <code><a href=\"../JSON/Serializable.html\">JSON::Serializable</a></code> module automatically generates methods for JSON serialization when included.</p>","constructors":[{"html_id":"new(*,__pull_for_json_serializablepull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"pull","external_name":"__pull_for_json_serializable","restriction":"::JSON::PullParser"}],"args_string":"(*, __pull_for_json_serializable pull : JSON::PullParser)","args_html":"(*, __pull_for_json_serializable pull : <a href=\"../JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/serialization.cr","line_number":158,"url":null},"def":{"name":"new","args":[{"name":"","external_name":"","restriction":""},{"name":"pull","external_name":"__pull_for_json_serializable","restriction":"::JSON::PullParser"}],"splat_index":0,"visibility":"Public","body":"_ = allocate\n_.initialize(__pull_for_json_serializable: pull)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"::JSON::Builder"}],"args_string":"(json : JSON::Builder)","args_html":"(json : <a href=\"../JSON/Builder.html\">JSON::Builder</a>)","location":{"filename":"src/json/serialization.cr","line_number":265,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"::JSON::Builder"}],"visibility":"Public","body":"{% if true %}\n        {% options = @type.annotation(::JSON::Serializable::Options) %}\n        {% emit_nulls = options && options[:emit_nulls] %}\n\n        {% properties = {} of Nil => Nil %}\n        {% for ivar in @type.instance_vars %}\n          {% ann = ivar.annotation(::JSON::Field) %}\n          {% if ann && (ann[:ignore] || ann[:ignore_serialize]) %}{% else %}\n            {% properties[ivar.id] = {type: ivar.type, key: ((ann && ann[:key]) || ivar).id.stringify, root: ann && ann[:root], converter: ann && ann[:converter], emit_null: (ann && (ann[:emit_null] != nil) ? ann[:emit_null] : emit_nulls)} %}\n          {% end %}\n        {% end %}\n\n        json.object do\n          {% for name, value in properties %}\n            _{{ name }} = @{{ name }}\n\n            {% if value[:emit_null] %}{% else %}\n              unless _{{ name }}.nil?\n            {% end %}\n\n              json.field({{ value[:key] }}) do\n                {% if value[:root] %}\n                  {% if value[:emit_null] %}\n                    if _{{ name }}.nil?\n                      nil.to_json(json)\n                    else\n                  {% end %}\n\n                  json.object do\n                    json.field({{ value[:root] }}) do\n                {% end %}\n\n                {% if value[:converter] %}\n                  if _{{ name }}\n                    {{ value[:converter] }}.to_json(_{{ name }}, json)\n                  else\n                    nil.to_json(json)\n                  end\n                {% else %}\n                  _{{ name }}.to_json(json)\n                {% end %}\n\n                {% if value[:root] %}\n                  {% if value[:emit_null] %}\n                    end\n                  {% end %}\n                    end\n                  end\n                {% end %}\n              end\n\n            {% if value[:emit_null] %}{% else %}\n              end\n            {% end %}\n          {% end %}\n          on_to_json(json)\n        end\n      {% end %}"}}],"macros":[{"html_id":"use_json_discriminator(field,mapping)-macro","name":"use_json_discriminator","doc":"Tells this class to decode JSON by using a field as a discriminator.\n\n- *field* must be the field name to use as a discriminator\n- *mapping* must be a hash or named tuple where each key-value pair\n  maps a discriminator value to a class to deserialize\n\nFor example:\n\n```\nrequire \"json\"\n\nabstract class Shape\n  include JSON::Serializable\n\n  use_json_discriminator \"type\", {point: Point, circle: Circle}\n\n  property type : String\nend\n\nclass Point < Shape\n  property x : Int32\n  property y : Int32\nend\n\nclass Circle < Shape\n  property x : Int32\n  property y : Int32\n  property radius : Int32\nend\n\nShape.from_json(%({\"type\": \"point\", \"x\": 1, \"y\": 2}))               # => #<Point:0x10373ae20 @type=\"point\", @x=1, @y=2>\nShape.from_json(%({\"type\": \"circle\", \"x\": 1, \"y\": 2, \"radius\": 3})) # => #<Circle:0x106a4cea0 @type=\"circle\", @x=1, @y=2, @radius=3>\n```","summary":"<p>Tells this class to decode JSON by using a field as a discriminator.</p>","abstract":false,"args":[{"name":"field","external_name":"field","restriction":""},{"name":"mapping","external_name":"mapping","restriction":""}],"args_string":"(field, mapping)","args_html":"(field, mapping)","location":{"filename":"src/json/serialization.cr","line_number":392,"url":null},"def":{"name":"use_json_discriminator","args":[{"name":"field","external_name":"field","restriction":""},{"name":"mapping","external_name":"mapping","restriction":""}],"visibility":"Public","body":"      \n{% if mapping.is_a?(HashLiteral) || mapping.is_a?(NamedTupleLiteral) %}{% else %}\n        {% mapping.raise(\"mapping argument must be a HashLiteral or a NamedTupleLiteral, not #{mapping.class_name.id}\") %}\n      {% end %}\n\n\n      def self.new(pull : ::JSON::PullParser)\n        location = pull.location\n\n        discriminator_value = nil\n\n        \n# Try to find the discriminator while also getting the raw\n\n        \n# string value of the parsed JSON, so then we can pass it\n\n        \n# to the final type.\n\n        json = String.build do |io|\n          JSON.build(io) do |builder|\n            builder.start_object\n            pull.read_object do |key|\n              if key == \n{{ field.id.stringify }}\n\n                value_kind = pull.kind\n                case value_kind\n                when .string?\n                  discriminator_value = pull.string_value\n                when .int?\n                  discriminator_value = pull.int_value\n                when .bool?\n                  discriminator_value = pull.bool_value\n                \nelse\n                  raise ::JSON::SerializableError.new(\"JSON discriminator field '\n{{ field.id }}\n' has an invalid value type of #{value_kind.to_s}\", to_s, nil, *location, nil)\n                \nend\n                builder.field(key, discriminator_value)\n                pull.read_next\n              \nelse\n                builder.field(key) \n{ pull.read_raw(builder) }\n              \nend\n            \nend\n            builder.end_object\n          \nend\n        \nend\n\n        unless discriminator_value\n          raise ::JSON::SerializableError.new(\"Missing JSON discriminator field '\n{{ field.id }}\n'\", to_s, nil, *location, nil)\n        \nend\n\n        case discriminator_value\n        \n{% for key, value in mapping %}\n          {% if mapping.is_a?(NamedTupleLiteral) %}\n            when {{ key.id.stringify }}\n          {% else %}\n            {% if key.is_a?(StringLiteral) %}\n              when {{ key }}\n            {% else %}{% if key.is_a?(NumberLiteral) || key.is_a?(BoolLiteral) %}\n              when {{ key.id }}\n            {% else %}{% if key.is_a?(Path) %}\n              when {{ key.resolve }}\n            {% else %}\n              {% key.raise(\"mapping keys must be one of StringLiteral, NumberLiteral, BoolLiteral, or Path, not #{key.class_name.id}\") %}\n            {% end %}{% end %}{% end %}\n          {% end %}\n          {{ value.id }}.from_json(json)\n        {% end %}\n\n        \nelse\n          raise ::JSON::SerializableError.new(\"Unknown '\n{{ field.id }}\n' discriminator value: #{discriminator_value.inspect}\", to_s, nil, *location, nil)\n        \nend\n      \nend\n    \n"}}],"types":[{"html_id":"Crystal/JSON/Serializable/Options","path":"JSON/Serializable/Options.html","kind":"annotation","full_name":"JSON::Serializable::Options","name":"Options","abstract":false,"locations":[{"filename":"src/json/serialization.cr","line_number":130,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON/Serializable","kind":"module","full_name":"JSON::Serializable","name":"Serializable"}},{"html_id":"Crystal/JSON/Serializable/Strict","path":"JSON/Serializable/Strict.html","kind":"module","full_name":"JSON::Serializable::Strict","name":"Strict","abstract":false,"locations":[{"filename":"src/json/serialization.cr","line_number":334,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON/Serializable","kind":"module","full_name":"JSON::Serializable","name":"Serializable"}},{"html_id":"Crystal/JSON/Serializable/Unmapped","path":"JSON/Serializable/Unmapped.html","kind":"module","full_name":"JSON::Serializable::Unmapped","name":"Unmapped","abstract":false,"locations":[{"filename":"src/json/serialization.cr","line_number":340,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON/Serializable","kind":"module","full_name":"JSON::Serializable","name":"Serializable"},"instance_methods":[{"html_id":"json_unmapped-instance-method","name":"json_unmapped","abstract":false,"location":{"filename":"src/json/serialization.cr","line_number":342,"url":null},"def":{"name":"json_unmapped","visibility":"Public","body":"@json_unmapped"}},{"html_id":"json_unmapped=(json_unmapped)-instance-method","name":"json_unmapped=","abstract":false,"args":[{"name":"json_unmapped","external_name":"json_unmapped","restriction":""}],"args_string":"(json_unmapped)","args_html":"(json_unmapped)","location":{"filename":"src/json/serialization.cr","line_number":342,"url":null},"def":{"name":"json_unmapped=","args":[{"name":"json_unmapped","external_name":"json_unmapped","restriction":""}],"visibility":"Public","body":"@json_unmapped = json_unmapped"}}]}]},{"html_id":"Crystal/JSON/SerializableError","path":"JSON/SerializableError.html","kind":"class","full_name":"JSON::SerializableError","name":"SerializableError","abstract":false,"superclass":{"html_id":"Crystal/JSON/ParseException","kind":"class","full_name":"JSON::ParseException","name":"ParseException"},"ancestors":[{"html_id":"Crystal/JSON/ParseException","kind":"class","full_name":"JSON::ParseException","name":"ParseException"},{"html_id":"Crystal/JSON/Error","kind":"class","full_name":"JSON::Error","name":"Error"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/serialization.cr","line_number":459,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"constructors":[{"html_id":"new(message:String?,klass:String,attribute:String?,line_number:Int32,column_number:Int32,cause)-class-method","name":"new","abstract":false,"args":[{"name":"message","external_name":"message","restriction":"String | ::Nil"},{"name":"klass","external_name":"klass","restriction":"String"},{"name":"attribute","external_name":"attribute","restriction":"String | ::Nil"},{"name":"line_number","external_name":"line_number","restriction":"Int32"},{"name":"column_number","external_name":"column_number","restriction":"Int32"},{"name":"cause","external_name":"cause","restriction":""}],"args_string":"(message : String?, klass : String, attribute : String?, line_number : Int32, column_number : Int32, cause)","args_html":"(message : <a href=\"../String.html\">String</a>?, klass : <a href=\"../String.html\">String</a>, attribute : <a href=\"../String.html\">String</a>?, line_number : <a href=\"../Int32.html\">Int32</a>, column_number : <a href=\"../Int32.html\">Int32</a>, cause)","location":{"filename":"src/json/serialization.cr","line_number":463,"url":null},"def":{"name":"new","args":[{"name":"message","external_name":"message","restriction":"String | ::Nil"},{"name":"klass","external_name":"klass","restriction":"String"},{"name":"attribute","external_name":"attribute","restriction":"String | ::Nil"},{"name":"line_number","external_name":"line_number","restriction":"Int32"},{"name":"column_number","external_name":"column_number","restriction":"Int32"},{"name":"cause","external_name":"cause","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(message, klass, attribute, line_number, column_number, cause)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"attribute:String?-instance-method","name":"attribute","abstract":false,"location":{"filename":"src/json/serialization.cr","line_number":461,"url":null},"def":{"name":"attribute","return_type":"String | ::Nil","visibility":"Public","body":"@attribute"}},{"html_id":"klass:String-instance-method","name":"klass","abstract":false,"location":{"filename":"src/json/serialization.cr","line_number":460,"url":null},"def":{"name":"klass","return_type":"String","visibility":"Public","body":"@klass"}}]},{"html_id":"Crystal/JSON/Token","path":"JSON/Token.html","kind":"class","full_name":"JSON::Token","name":"Token","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/token.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/JSON","kind":"module","full_name":"JSON","name":"JSON"},"constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/json/token.cr","line_number":41,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"column_number:Int32-instance-method","name":"column_number","abstract":false,"location":{"filename":"src/json/token.cr","line_number":38,"url":null},"def":{"name":"column_number","return_type":"Int32","visibility":"Public","body":"@column_number"}},{"html_id":"column_number=(column_number:Int32)-instance-method","name":"column_number=","abstract":false,"args":[{"name":"column_number","external_name":"column_number","restriction":"Int32"}],"args_string":"(column_number : Int32)","args_html":"(column_number : <a href=\"../Int32.html\">Int32</a>)","location":{"filename":"src/json/token.cr","line_number":38,"url":null},"def":{"name":"column_number=","args":[{"name":"column_number","external_name":"column_number","restriction":"Int32"}],"visibility":"Public","body":"@column_number = column_number"}},{"html_id":"float_value:Float64-instance-method","name":"float_value","abstract":false,"location":{"filename":"src/json/token.cr","line_number":29,"url":null},"def":{"name":"float_value","return_type":"Float64","visibility":"Public","body":"begin\n  raw_value.to_f64\nrescue exc : ArgumentError\n  raise(ParseException.new(exc.message, line_number, column_number))\nend"}},{"html_id":"int_value:Int64-instance-method","name":"int_value","abstract":false,"location":{"filename":"src/json/token.cr","line_number":21,"url":null},"def":{"name":"int_value","return_type":"Int64","visibility":"Public","body":"begin\n  raw_value.to_i64\nrescue exc : ArgumentError\n  raise(ParseException.new(exc.message, line_number, column_number))\nend"}},{"html_id":"kind:Kind-instance-method","name":"kind","abstract":false,"location":{"filename":"src/json/token.cr","line_number":18,"url":null},"def":{"name":"kind","return_type":"Kind","visibility":"Public","body":"@kind"}},{"html_id":"kind=(kind:Kind)-instance-method","name":"kind=","abstract":false,"args":[{"name":"kind","external_name":"kind","restriction":"Kind"}],"args_string":"(kind : Kind)","args_html":"(kind : <a href=\"../JSON/Token/Kind.html\">Kind</a>)","location":{"filename":"src/json/token.cr","line_number":18,"url":null},"def":{"name":"kind=","args":[{"name":"kind","external_name":"kind","restriction":"Kind"}],"visibility":"Public","body":"@kind = kind"}},{"html_id":"line_number:Int32-instance-method","name":"line_number","abstract":false,"location":{"filename":"src/json/token.cr","line_number":37,"url":null},"def":{"name":"line_number","return_type":"Int32","visibility":"Public","body":"@line_number"}},{"html_id":"line_number=(line_number:Int32)-instance-method","name":"line_number=","abstract":false,"args":[{"name":"line_number","external_name":"line_number","restriction":"Int32"}],"args_string":"(line_number : Int32)","args_html":"(line_number : <a href=\"../Int32.html\">Int32</a>)","location":{"filename":"src/json/token.cr","line_number":37,"url":null},"def":{"name":"line_number=","args":[{"name":"line_number","external_name":"line_number","restriction":"Int32"}],"visibility":"Public","body":"@line_number = line_number"}},{"html_id":"raw_value:String-instance-method","name":"raw_value","abstract":false,"location":{"filename":"src/json/token.cr","line_number":39,"url":null},"def":{"name":"raw_value","return_type":"String","visibility":"Public","body":"@raw_value"}},{"html_id":"raw_value=(raw_value:String)-instance-method","name":"raw_value=","abstract":false,"args":[{"name":"raw_value","external_name":"raw_value","restriction":"String"}],"args_string":"(raw_value : String)","args_html":"(raw_value : <a href=\"../String.html\">String</a>)","location":{"filename":"src/json/token.cr","line_number":39,"url":null},"def":{"name":"raw_value=","args":[{"name":"raw_value","external_name":"raw_value","restriction":"String"}],"visibility":"Public","body":"@raw_value = raw_value"}},{"html_id":"string_value:String-instance-method","name":"string_value","abstract":false,"location":{"filename":"src/json/token.cr","line_number":19,"url":null},"def":{"name":"string_value","return_type":"String","visibility":"Public","body":"@string_value"}},{"html_id":"string_value=(string_value:String)-instance-method","name":"string_value=","abstract":false,"args":[{"name":"string_value","external_name":"string_value","restriction":"String"}],"args_string":"(string_value : String)","args_html":"(string_value : <a href=\"../String.html\">String</a>)","location":{"filename":"src/json/token.cr","line_number":19,"url":null},"def":{"name":"string_value=","args":[{"name":"string_value","external_name":"string_value","restriction":"String"}],"visibility":"Public","body":"@string_value = string_value"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a short String representation of this object\nwhich includes its class name and its object address.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).to_s # => #<Person:0x10a199f20>\n```","summary":"<p>Appends a short String representation of this object which includes its class name and its object address.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/token.cr","line_number":49,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"case @kind\nwhen .null?\n  io << \"null\"\nwhen .false?\n  io << \"false\"\nwhen .true?\n  io << \"true\"\nwhen .int?\n  raw_value.to_s(io)\nwhen .float?\n  raw_value.to_s(io)\nwhen .string?\n  string_value.to_s(io)\nwhen .begin_array?\n  io << '['\nwhen .end_array?\n  io << ']'\nwhen .begin_object?\n  io << '{'\nwhen .end_object?\n  io << '}'\nwhen .colon?\n  io << ':'\nwhen .comma?\n  io << ','\nwhen .eof?\n  io << \"<EOF>\"\nelse\n  raise(\"Unknown token kind: #{@kind}\")\nend"}}],"types":[{"html_id":"Crystal/JSON/Token/Kind","path":"JSON/Token/Kind.html","kind":"enum","full_name":"JSON::Token::Kind","name":"Kind","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/token.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Null","name":"Null","value":"0"},{"id":"False","name":"False","value":"1"},{"id":"True","name":"True","value":"2"},{"id":"Int","name":"Int","value":"3"},{"id":"Float","name":"Float","value":"4"},{"id":"String","name":"String","value":"5"},{"id":"BeginArray","name":"BeginArray","value":"6"},{"id":"EndArray","name":"EndArray","value":"7"},{"id":"BeginObject","name":"BeginObject","value":"8"},{"id":"EndObject","name":"EndObject","value":"9"},{"id":"Colon","name":"Colon","value":"10"},{"id":"Comma","name":"Comma","value":"11"},{"id":"EOF","name":"EOF","value":"12"}],"namespace":{"html_id":"Crystal/JSON/Token","kind":"class","full_name":"JSON::Token","name":"Token"},"instance_methods":[{"html_id":"begin_array?-instance-method","name":"begin_array?","abstract":false,"location":{"filename":"src/json/token.cr","line_number":9,"url":null},"def":{"name":"begin_array?","visibility":"Public","body":"self == BeginArray"}},{"html_id":"begin_object?-instance-method","name":"begin_object?","abstract":false,"location":{"filename":"src/json/token.cr","line_number":11,"url":null},"def":{"name":"begin_object?","visibility":"Public","body":"self == BeginObject"}},{"html_id":"colon?-instance-method","name":"colon?","abstract":false,"location":{"filename":"src/json/token.cr","line_number":13,"url":null},"def":{"name":"colon?","visibility":"Public","body":"self == Colon"}},{"html_id":"comma?-instance-method","name":"comma?","abstract":false,"location":{"filename":"src/json/token.cr","line_number":14,"url":null},"def":{"name":"comma?","visibility":"Public","body":"self == Comma"}},{"html_id":"end_array?-instance-method","name":"end_array?","abstract":false,"location":{"filename":"src/json/token.cr","line_number":10,"url":null},"def":{"name":"end_array?","visibility":"Public","body":"self == EndArray"}},{"html_id":"end_object?-instance-method","name":"end_object?","abstract":false,"location":{"filename":"src/json/token.cr","line_number":12,"url":null},"def":{"name":"end_object?","visibility":"Public","body":"self == EndObject"}},{"html_id":"eof?-instance-method","name":"eof?","abstract":false,"location":{"filename":"src/json/token.cr","line_number":15,"url":null},"def":{"name":"eof?","visibility":"Public","body":"self == EOF"}},{"html_id":"false?-instance-method","name":"false?","abstract":false,"location":{"filename":"src/json/token.cr","line_number":4,"url":null},"def":{"name":"false?","visibility":"Public","body":"self == False"}},{"html_id":"float?-instance-method","name":"float?","abstract":false,"location":{"filename":"src/json/token.cr","line_number":7,"url":null},"def":{"name":"float?","visibility":"Public","body":"self == Float"}},{"html_id":"int?-instance-method","name":"int?","abstract":false,"location":{"filename":"src/json/token.cr","line_number":6,"url":null},"def":{"name":"int?","visibility":"Public","body":"self == Int"}},{"html_id":"null?-instance-method","name":"null?","abstract":false,"location":{"filename":"src/json/token.cr","line_number":3,"url":null},"def":{"name":"null?","visibility":"Public","body":"self == Null"}},{"html_id":"string?-instance-method","name":"string?","abstract":false,"location":{"filename":"src/json/token.cr","line_number":8,"url":null},"def":{"name":"string?","visibility":"Public","body":"self == String"}},{"html_id":"true?-instance-method","name":"true?","abstract":false,"location":{"filename":"src/json/token.cr","line_number":5,"url":null},"def":{"name":"true?","visibility":"Public","body":"self == True"}}]}]}]},{"html_id":"Crystal/KeyError","path":"KeyError.html","kind":"class","full_name":"KeyError","name":"KeyError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/exception.cr","line_number":118,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"Raised when the specified key is not found.\n\n```\nh = {\"foo\" => \"bar\"}\nh[\"baz\"] # raises KeyError (Missing hash key: \"baz\")\n```","summary":"<p>Raised when the specified key is not found.</p>"},{"html_id":"Crystal/Levenshtein","path":"Levenshtein.html","kind":"module","full_name":"Levenshtein","name":"Levenshtein","abstract":false,"locations":[{"filename":"src/levenshtein.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"Levenshtein distance methods.","summary":"<p>Levenshtein distance methods.</p>","class_methods":[{"html_id":"distance(string1:String,string2:String):Int32-class-method","name":"distance","doc":"Computes the [levenshtein distance](http://en.wikipedia.org/wiki/Levenshtein_distance) of two strings.\n\n```\nrequire \"levenshtein\"\n\nLevenshtein.distance(\"algorithm\", \"altruistic\") # => 6\nLevenshtein.distance(\"hello\", \"hallo\")          # => 1\nLevenshtein.distance(\"こんにちは\", \"こんちは\")           # => 1\nLevenshtein.distance(\"hey\", \"hey\")              # => 0\n```","summary":"<p>Computes the <a href=\"http://en.wikipedia.org/wiki/Levenshtein_distance\">levenshtein distance</a> of two strings.</p>","abstract":false,"args":[{"name":"string1","external_name":"string1","restriction":"String"},{"name":"string2","external_name":"string2","restriction":"String"}],"args_string":"(string1 : String, string2 : String) : Int32","args_html":"(string1 : <a href=\"String.html\">String</a>, string2 : <a href=\"String.html\">String</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/levenshtein.cr","line_number":13,"url":null},"def":{"name":"distance","args":[{"name":"string1","external_name":"string1","restriction":"String"},{"name":"string2","external_name":"string2","restriction":"String"}],"return_type":"Int32","visibility":"Public","body":"if string1 == string2\n  return 0\nend\ns_size = string1.size\nt_size = string2.size\nif s_size == 0\n  return t_size\nend\nif t_size == 0\n  return s_size\nend\nif t_size > s_size\n  string1, string2 = string2, string1\n  t_size, s_size = s_size, t_size\nend\ncosts = Slice(Int32).new(t_size + 1) do |i|\n  i\nend\nlast_cost = 0\nif string1.single_byte_optimizable? && string2.single_byte_optimizable?\n  s = string1.to_unsafe\n  t = string2.to_unsafe\n  s_size.times do |i|\n    last_cost = i + 1\n    t_size.times do |j|\n      sub_cost = s[i] == t[j] ? 0 : 1\n      cost = Math.min(Math.min(last_cost + 1, costs[j + 1] + 1), costs[j] + sub_cost)\n      costs[j] = last_cost\n      last_cost = cost\n    end\n    costs[t_size] = last_cost\n  end\n  last_cost\nelse\n  reader = Char::Reader.new(string1)\n  chars = string2.chars\n  reader.each_with_index do |char1, i|\n    last_cost = i + 1\n    chars.each_with_index do |char2, j|\n      sub_cost = char1 == char2 ? 0 : 1\n      cost = Math.min(Math.min(last_cost + 1, costs[j + 1] + 1), costs[j] + sub_cost)\n      costs[j] = last_cost\n      last_cost = cost\n    end\n    costs[t_size] = last_cost\n  end\n  last_cost\nend\n"}},{"html_id":"find(name,tolerance=nil,&)-class-method","name":"find","doc":"Finds the best match for *name* among strings added within the given block.\n*tolerance* can be used to set maximum Levenshtein distance allowed.\n\n```\nrequire \"levenshtein\"\n\nbest_match = Levenshtein.find(\"hello\") do |l|\n  l.test \"hulk\"\n  l.test \"holk\"\n  l.test \"halka\"\n  l.test \"ello\"\nend\nbest_match # => \"ello\"\n```","summary":"<p>Finds the best match for <em>name</em> among strings added within the given block.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"tolerance","default_value":"nil","external_name":"tolerance","restriction":""}],"args_string":"(name, tolerance = nil, &)","args_html":"(name, tolerance = <span class=\"n\">nil</span>, &)","location":{"filename":"src/levenshtein.cr","line_number":140,"url":null},"def":{"name":"find","args":[{"name":"name","external_name":"name","restriction":""},{"name":"tolerance","default_value":"nil","external_name":"tolerance","restriction":""}],"yields":1,"visibility":"Public","body":"Finder.find(name, tolerance) do |sn|\n  yield sn\nend"}},{"html_id":"find(name,all_names,tolerance=nil)-class-method","name":"find","doc":"Finds the best match for *name* among strings provided in *all_names*.\n*tolerance* can be used to set maximum Levenshtein distance allowed.\n\n```\nrequire \"levenshtein\"\n\nLevenshtein.find(\"hello\", [\"hullo\", \"hel\", \"hall\", \"hell\"], 2) # => \"hullo\"\nLevenshtein.find(\"hello\", [\"hurlo\", \"hel\", \"hall\"], 1)         # => nil\n```","summary":"<p>Finds the best match for <em>name</em> among strings provided in <em>all_names</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"all_names","external_name":"all_names","restriction":""},{"name":"tolerance","default_value":"nil","external_name":"tolerance","restriction":""}],"args_string":"(name, all_names, tolerance = nil)","args_html":"(name, all_names, tolerance = <span class=\"n\">nil</span>)","location":{"filename":"src/levenshtein.cr","line_number":155,"url":null},"def":{"name":"find","args":[{"name":"name","external_name":"name","restriction":""},{"name":"all_names","external_name":"all_names","restriction":""},{"name":"tolerance","default_value":"nil","external_name":"tolerance","restriction":""}],"visibility":"Public","body":"Finder.find(name, all_names, tolerance)"}}],"types":[{"html_id":"Crystal/Levenshtein/Finder","path":"Levenshtein/Finder.html","kind":"class","full_name":"Levenshtein::Finder","name":"Finder","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/levenshtein.cr","line_number":82,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Levenshtein","kind":"module","full_name":"Levenshtein","name":"Levenshtein"},"doc":"Finds the closest string to a given string amongst many strings.\n\n```\nrequire \"levenshtein\"\n\nfinder = Levenshtein::Finder.new \"hallo\"\nfinder.test \"hay\"\nfinder.test \"hall\"\nfinder.test \"hallo world\"\n\nfinder.best_match # => \"hall\"\n```","summary":"<p>Finds the closest string to a given string amongst many strings.</p>","class_methods":[{"html_id":"find(name,tolerance=nil,&)-class-method","name":"find","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"tolerance","default_value":"nil","external_name":"tolerance","restriction":""}],"args_string":"(name, tolerance = nil, &)","args_html":"(name, tolerance = <span class=\"n\">nil</span>, &)","location":{"filename":"src/levenshtein.cr","line_number":111,"url":null},"def":{"name":"find","args":[{"name":"name","external_name":"name","restriction":""},{"name":"tolerance","default_value":"nil","external_name":"tolerance","restriction":""}],"yields":1,"visibility":"Public","body":"sn = new(name, tolerance)\nyield sn\nsn.best_match\n"}},{"html_id":"find(name,all_names,tolerance=nil):String?-class-method","name":"find","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"all_names","external_name":"all_names","restriction":""},{"name":"tolerance","default_value":"nil","external_name":"tolerance","restriction":""}],"args_string":"(name, all_names, tolerance = nil) : String?","args_html":"(name, all_names, tolerance = <span class=\"n\">nil</span>) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/levenshtein.cr","line_number":117,"url":null},"def":{"name":"find","args":[{"name":"name","external_name":"name","restriction":""},{"name":"all_names","external_name":"all_names","restriction":""},{"name":"tolerance","default_value":"nil","external_name":"tolerance","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"find(name, tolerance) do |similar|\n  all_names.each do |a_name|\n    similar.test(a_name)\n  end\nend"}}],"constructors":[{"html_id":"new(target:String,tolerance:Int?=nil)-class-method","name":"new","abstract":false,"args":[{"name":"target","external_name":"target","restriction":"String"},{"name":"tolerance","default_value":"nil","external_name":"tolerance","restriction":"Int | ::Nil"}],"args_string":"(target : String, tolerance : Int? = nil)","args_html":"(target : <a href=\"../String.html\">String</a>, tolerance : <a href=\"../Int.html\">Int</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/levenshtein.cr","line_number":90,"url":null},"def":{"name":"new","args":[{"name":"target","external_name":"target","restriction":"String"},{"name":"tolerance","default_value":"nil","external_name":"tolerance","restriction":"Int | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(target, tolerance)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"best_match:String?-instance-method","name":"best_match","abstract":false,"location":{"filename":"src/levenshtein.cr","line_number":107,"url":null},"def":{"name":"best_match","return_type":"String | ::Nil","visibility":"Public","body":"@best_entry.try(&.value)"}},{"html_id":"test(name:String,value:String=name)-instance-method","name":"test","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"value","default_value":"name","external_name":"value","restriction":"String"}],"args_string":"(name : String, value : String = name)","args_html":"(name : <a href=\"../String.html\">String</a>, value : <a href=\"../String.html\">String</a> = name)","location":{"filename":"src/levenshtein.cr","line_number":94,"url":null},"def":{"name":"test","args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"value","default_value":"name","external_name":"value","restriction":"String"}],"visibility":"Public","body":"distance = Levenshtein.distance(@target, name)\nif distance <= @tolerance\n  if best_entry = @best_entry\n    if distance < best_entry.distance\n      @best_entry = Entry.new(value, distance)\n    end\n  else\n    @best_entry = Entry.new(value, distance)\n  end\nend\n"}}]}]},{"html_id":"Crystal/Link","path":"Link.html","kind":"annotation","full_name":"Link","name":"Link","abstract":false,"locations":[{"filename":"src/annotations.cr","line_number":52,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"A `lib` can be marked with `@[Link(lib : String, *, ldflags : String, framework : String, pkg_config : String)]`\nto declare the library that should be linked when compiling the program.\n\nAt least one of the *lib*, *ldflags*, *framework* arguments needs to be specified.\n\n`@[Link(ldflags: \"-lpcre\")]` will pass `-lpcre` straight to the linker.\n\n`@[Link(\"pcre\")]` will lookup for a shared library.\n1. will lookup `pcre` using `pkg-config`, if not found\n2. will pass `-lpcre` to the linker.\n\n`@[Link(\"pcre\", pkg_config: \"libpcre\")]` will lookup for a shared library.\n1. will lookup `libpcre` using `pkg-config`, if not found\n2. will lookup `pcre` using `pkg-config`, if not found\n3. will pass `-lpcre` to the linker.\n\n`@[Link(framework: \"Cocoa\")]` will pass `-framework Cocoa` to the linker.\n\nWhen an `-l` option is passed to the linker, it will lookup the libraries in\npaths passed with the `-L` option. Any paths in `CRYSTAL_LIBRARY_PATH` are\nadded by default. Custom paths can be passed using `ldflags`:\n`@[Link(ldflags: \"-Lvendor/bin\")]`.","summary":"<p>A <code>lib</code> can be marked with <code>@[<a href=\"Link.html\">Link</a>(lib : <a href=\"String.html\">String</a>, *, ldflags : <a href=\"String.html\">String</a>, framework : <a href=\"String.html\">String</a>, pkg_config : <a href=\"String.html\">String</a>)]</code> to declare the library that should be linked when compiling the program.</p>"},{"html_id":"Crystal/LLVM","path":"LLVM.html","kind":"module","full_name":"LLVM","name":"LLVM","abstract":false,"locations":[{"filename":"src/llvm.cr","line_number":4,"url":null},{"filename":"src/llvm/abi.cr","line_number":2,"url":null},{"filename":"src/llvm/enums.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"DEBUG_METADATA_VERSION","name":"DEBUG_METADATA_VERSION","value":"3"}],"class_methods":[{"html_id":"default_target_triple:String-class-method","name":"default_target_triple","abstract":false,"location":{"filename":"src/llvm.cr","line_number":76,"url":null},"def":{"name":"default_target_triple","return_type":"String","visibility":"Public","body":"chars = LibLLVM.get_default_target_triple\ntriple = string_and_dispose(chars)\nif triple =~ (/x86_64-apple-macosx|x86_64-apple-darwin/)\n  \"x86_64-apple-macosx\"\nelse\n  triple\nend\n"}},{"html_id":"host_cpu_name:String-class-method","name":"host_cpu_name","abstract":false,"location":{"filename":"src/llvm.cr","line_number":86,"url":null},"def":{"name":"host_cpu_name","return_type":"String","visibility":"Public","body":"{% if LibLLVM::IS_LT_70 %}\n      raise \"LibLLVM.host_cpu_name requires LLVM 7.0 or newer\"\n    {% else %}\n      String.new LibLLVM.get_host_cpu_name\n    {% end %}"}},{"html_id":"init_aarch64:Nil-class-method","name":"init_aarch64","abstract":false,"location":{"filename":"src/llvm.cr","line_number":24,"url":null},"def":{"name":"init_aarch64","return_type":"Nil","visibility":"Public","body":"if @@initialized_aarch64\n  return\nend\n@@initialized_aarch64 = true\n{% if LibLLVM::BUILT_TARGETS.includes?(:aarch64) %}\n      LibLLVM.initialize_aarch64_target_info\n      LibLLVM.initialize_aarch64_target\n      LibLLVM.initialize_aarch64_target_mc\n      LibLLVM.initialize_aarch64_asm_printer\n      LibLLVM.initialize_aarch64_asm_parser\n      # LibLLVM.link_in_jit\n      LibLLVM.link_in_mc_jit\n    {% else %}\n      raise \"ERROR: LLVM was built without AArch64 target\"\n    {% end %}\n"}},{"html_id":"init_arm:Nil-class-method","name":"init_arm","abstract":false,"location":{"filename":"src/llvm.cr","line_number":41,"url":null},"def":{"name":"init_arm","return_type":"Nil","visibility":"Public","body":"if @@initialized_arm\n  return\nend\n@@initialized_arm = true\n{% if LibLLVM::BUILT_TARGETS.includes?(:arm) %}\n      LibLLVM.initialize_arm_target_info\n      LibLLVM.initialize_arm_target\n      LibLLVM.initialize_arm_target_mc\n      LibLLVM.initialize_arm_asm_printer\n      LibLLVM.initialize_arm_asm_parser\n      # LibLLVM.link_in_jit\n      LibLLVM.link_in_mc_jit\n    {% else %}\n      raise \"ERROR: LLVM was built without ARM target\"\n    {% end %}\n"}},{"html_id":"init_x86:Nil-class-method","name":"init_x86","abstract":false,"location":{"filename":"src/llvm.cr","line_number":7,"url":null},"def":{"name":"init_x86","return_type":"Nil","visibility":"Public","body":"if @@initialized_x86\n  return\nend\n@@initialized_x86 = true\n{% if LibLLVM::BUILT_TARGETS.includes?(:x86) %}\n      LibLLVM.initialize_x86_target_info\n      LibLLVM.initialize_x86_target\n      LibLLVM.initialize_x86_target_mc\n      LibLLVM.initialize_x86_asm_printer\n      LibLLVM.initialize_x86_asm_parser\n      # LibLLVM.link_in_jit\n      LibLLVM.link_in_mc_jit\n    {% else %}\n      raise \"ERROR: LLVM was built without X86 target\"\n    {% end %}\n"}},{"html_id":"multithreaded?:Bool-class-method","name":"multithreaded?","abstract":false,"location":{"filename":"src/llvm.cr","line_number":72,"url":null},"def":{"name":"multithreaded?","return_type":"Bool","visibility":"Public","body":"LibLLVM.is_multithreaded != 0"}},{"html_id":"normalize_triple(triple:String):String-class-method","name":"normalize_triple","abstract":false,"args":[{"name":"triple","external_name":"triple","restriction":"String"}],"args_string":"(triple : String) : String","args_html":"(triple : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/llvm.cr","line_number":94,"url":null},"def":{"name":"normalize_triple","args":[{"name":"triple","external_name":"triple","restriction":"String"}],"return_type":"String","visibility":"Public","body":"normalized = LibLLVMExt.normalize_target_triple(triple)\nnormalized = LLVM.string_and_dispose(normalized)\nnormalized = (normalized.split('-')).map do |c|\n  c.presence || \"unknown\"\nend.join('-')\nnormalized\n"}},{"html_id":"start_multithreaded:Bool-class-method","name":"start_multithreaded","abstract":false,"location":{"filename":"src/llvm.cr","line_number":58,"url":null},"def":{"name":"start_multithreaded","return_type":"Bool","visibility":"Public","body":"if multithreaded?\n  true\nelse\n  LibLLVM.start_multithreaded != 0\nend"}},{"html_id":"stop_multithreaded-class-method","name":"stop_multithreaded","abstract":false,"location":{"filename":"src/llvm.cr","line_number":66,"url":null},"def":{"name":"stop_multithreaded","visibility":"Public","body":"if multithreaded?\n  LibLLVM.stop_multithreaded\nend"}},{"html_id":"string_and_dispose(chars):String-class-method","name":"string_and_dispose","abstract":false,"args":[{"name":"chars","external_name":"chars","restriction":""}],"args_string":"(chars) : String","args_html":"(chars) : <a href=\"String.html\">String</a>","location":{"filename":"src/llvm.cr","line_number":110,"url":null},"def":{"name":"string_and_dispose","args":[{"name":"chars","external_name":"chars","restriction":""}],"return_type":"String","visibility":"Public","body":"string = String.new(chars)\nLibLLVM.dispose_message(chars)\nstring\n"}},{"html_id":"to_io(chars,io):Nil-class-method","name":"to_io","abstract":false,"args":[{"name":"chars","external_name":"chars","restriction":""},{"name":"io","external_name":"io","restriction":""}],"args_string":"(chars, io) : Nil","args_html":"(chars, io) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/llvm.cr","line_number":105,"url":null},"def":{"name":"to_io","args":[{"name":"chars","external_name":"chars","restriction":""},{"name":"io","external_name":"io","restriction":""}],"return_type":"Nil","visibility":"Public","body":"io.write_string(Slice.new(chars, LibC.strlen(chars)))\nLibLLVM.dispose_message(chars)\n"}}],"types":[{"html_id":"Crystal/LLVM/ABI","path":"LLVM/ABI.html","kind":"class","full_name":"LLVM::ABI","name":"ABI","abstract":true,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/abi.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/LLVM/ABI/AArch64","kind":"class","full_name":"LLVM::ABI::AArch64","name":"AArch64"},{"html_id":"Crystal/LLVM/ABI/ARM","kind":"class","full_name":"LLVM::ABI::ARM","name":"ARM"},{"html_id":"Crystal/LLVM/ABI/X86","kind":"class","full_name":"LLVM::ABI::X86","name":"X86"},{"html_id":"Crystal/LLVM/ABI/X86_64","kind":"class","full_name":"LLVM::ABI::X86_64","name":"X86_64"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":"Based on https://github.com/rust-lang/rust/blob/29ac04402d53d358a1f6200bea45a301ff05b2d1/src/librustc_trans/trans/cabi.rs","summary":"<p>Based on https://github.com/rust-lang/rust/blob/29ac04402d53d358a1f6200bea45a301ff05b2d1/src/librustc_trans/trans/cabi.rs</p>","constructors":[{"html_id":"new(target_machine:TargetMachine)-class-method","name":"new","abstract":false,"args":[{"name":"target_machine","external_name":"target_machine","restriction":"TargetMachine"}],"args_string":"(target_machine : TargetMachine)","args_html":"(target_machine : <a href=\"../LLVM/TargetMachine.html\">TargetMachine</a>)","location":{"filename":"src/llvm/abi.cr","line_number":7,"url":null},"def":{"name":"new","args":[{"name":"target_machine","external_name":"target_machine","restriction":"TargetMachine"}],"visibility":"Public","body":"_ = allocate\n_.initialize(target_machine)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"abi_info(atys:Array(Type),rty:Type,ret_def:Bool,context:Context)-instance-method","name":"abi_info","abstract":true,"args":[{"name":"atys","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","external_name":"rty","restriction":"Type"},{"name":"ret_def","external_name":"ret_def","restriction":"Bool"},{"name":"context","external_name":"context","restriction":"Context"}],"args_string":"(atys : Array(Type), rty : Type, ret_def : Bool, context : Context)","args_html":"(atys : <a href=\"../Array.html\">Array</a>(<a href=\"../LLVM/Type.html\">Type</a>), rty : <a href=\"../LLVM/Type.html\">Type</a>, ret_def : <a href=\"../Bool.html\">Bool</a>, context : <a href=\"../LLVM/Context.html\">Context</a>)","location":{"filename":"src/llvm/abi.cr","line_number":14,"url":null},"def":{"name":"abi_info","args":[{"name":"atys","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","external_name":"rty","restriction":"Type"},{"name":"ret_def","external_name":"ret_def","restriction":"Bool"},{"name":"context","external_name":"context","restriction":"Context"}],"visibility":"Public","body":""}},{"html_id":"align(type:Type,pointer_size):Int32-instance-method","name":"align","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Type"},{"name":"pointer_size","external_name":"pointer_size","restriction":""}],"args_string":"(type : Type, pointer_size) : Int32","args_html":"(type : <a href=\"../LLVM/Type.html\">Type</a>, pointer_size) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/llvm/abi.cr","line_number":51,"url":null},"def":{"name":"align","args":[{"name":"type","external_name":"type","restriction":"Type"},{"name":"pointer_size","external_name":"pointer_size","restriction":""}],"return_type":"Int32","visibility":"Public","body":"case type.kind\nwhen Type::Kind::Integer\n  (type.int_width + 7) // 8\nwhen Type::Kind::Float\n  4\nwhen Type::Kind::Double\n  8\nwhen Type::Kind::Pointer\n  pointer_size\nwhen Type::Kind::Struct\n  if type.packed_struct?\n    1\n  else\n    type.struct_element_types.reduce(1) do |memo, elem|\n      Math.max(memo, align(elem))\n    end\n  end\nwhen Type::Kind::Array\n  align(type.element_type)\nelse\n  raise(\"Unhandled Type::Kind in align: #{type.kind}\")\nend"}},{"html_id":"align(type:Type)-instance-method","name":"align","abstract":true,"args":[{"name":"type","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","args_html":"(type : <a href=\"../LLVM/Type.html\">Type</a>)","location":{"filename":"src/llvm/abi.cr","line_number":16,"url":null},"def":{"name":"align","args":[{"name":"type","external_name":"type","restriction":"Type"}],"visibility":"Public","body":""}},{"html_id":"align_offset(offset,type):Int32-instance-method","name":"align_offset","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"type","external_name":"type","restriction":""}],"args_string":"(offset, type) : Int32","args_html":"(offset, type) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/llvm/abi.cr","line_number":46,"url":null},"def":{"name":"align_offset","args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"type","external_name":"type","restriction":""}],"return_type":"Int32","visibility":"Public","body":"align = align(type)\n(((offset + align) - 1) // align) * align\n"}},{"html_id":"osx?:Bool-instance-method","name":"osx?","abstract":false,"location":{"filename":"src/llvm/abi.cr","line_number":4,"url":null},"def":{"name":"osx?","return_type":"Bool","visibility":"Public","body":"@osx"}},{"html_id":"size(type:Type,pointer_size):Int32-instance-method","name":"size","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Type"},{"name":"pointer_size","external_name":"pointer_size","restriction":""}],"args_string":"(type : Type, pointer_size) : Int32","args_html":"(type : <a href=\"../LLVM/Type.html\">Type</a>, pointer_size) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/llvm/abi.cr","line_number":18,"url":null},"def":{"name":"size","args":[{"name":"type","external_name":"type","restriction":"Type"},{"name":"pointer_size","external_name":"pointer_size","restriction":""}],"return_type":"Int32","visibility":"Public","body":"case type.kind\nwhen Type::Kind::Integer\n  (type.int_width + 7) // 8\nwhen Type::Kind::Float\n  4\nwhen Type::Kind::Double\n  8\nwhen Type::Kind::Pointer\n  pointer_size\nwhen Type::Kind::Struct\n  if type.packed_struct?\n    type.struct_element_types.reduce(0) do |memo, elem|\n      memo + (size(elem))\n    end\n  else\n    size = type.struct_element_types.reduce(0) do |memo, elem|\n      (align_offset(memo, elem)) + (size(elem))\n    end\n    align_offset(size, type)\n  end\nwhen Type::Kind::Array\n  (size(type.element_type)) * type.array_size\nelse\n  raise(\"Unhandled Type::Kind in size: #{type.kind}\")\nend"}},{"html_id":"size(type:Type)-instance-method","name":"size","abstract":true,"args":[{"name":"type","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","args_html":"(type : <a href=\"../LLVM/Type.html\">Type</a>)","location":{"filename":"src/llvm/abi.cr","line_number":15,"url":null},"def":{"name":"size","args":[{"name":"type","external_name":"type","restriction":"Type"}],"visibility":"Public","body":""}},{"html_id":"target_data:TargetData-instance-method","name":"target_data","abstract":false,"location":{"filename":"src/llvm/abi.cr","line_number":3,"url":null},"def":{"name":"target_data","return_type":"TargetData","visibility":"Public","body":"@target_data"}},{"html_id":"windows?:Bool-instance-method","name":"windows?","abstract":false,"location":{"filename":"src/llvm/abi.cr","line_number":5,"url":null},"def":{"name":"windows?","return_type":"Bool","visibility":"Public","body":"@windows"}}],"types":[{"html_id":"Crystal/LLVM/ABI/AArch64","path":"LLVM/ABI/AArch64.html","kind":"class","full_name":"LLVM::ABI::AArch64","name":"AArch64","abstract":false,"superclass":{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"ancestors":[{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/abi/aarch64.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"doc":"Based on\nhttps://github.com/rust-lang/rust/blob/master/src/librustc_trans/cabi_aarch64.rs","summary":"<p>Based on https://github.com/rust-lang/rust/blob/master/src/librustc_trans/cabi_aarch64.rs</p>","instance_methods":[{"html_id":"abi_info(atys:Array(Type),rty:Type,ret_def:Bool,context:Context):LLVM::ABI::FunctionType-instance-method","name":"abi_info","abstract":false,"args":[{"name":"atys","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","external_name":"rty","restriction":"Type"},{"name":"ret_def","external_name":"ret_def","restriction":"Bool"},{"name":"context","external_name":"context","restriction":"Context"}],"args_string":"(atys : Array(Type), rty : Type, ret_def : Bool, context : Context) : LLVM::ABI::FunctionType","args_html":"(atys : <a href=\"../../Array.html\">Array</a>(<a href=\"../../LLVM/Type.html\">Type</a>), rty : <a href=\"../../LLVM/Type.html\">Type</a>, ret_def : <a href=\"../../Bool.html\">Bool</a>, context : <a href=\"../../LLVM/Context.html\">Context</a>) : <a href=\"../../LLVM/ABI/FunctionType.html\">LLVM::ABI::FunctionType</a>","location":{"filename":"src/llvm/abi/aarch64.cr","line_number":6,"url":null},"def":{"name":"abi_info","args":[{"name":"atys","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","external_name":"rty","restriction":"Type"},{"name":"ret_def","external_name":"ret_def","restriction":"Bool"},{"name":"context","external_name":"context","restriction":"Context"}],"return_type":"LLVM::ABI::FunctionType","visibility":"Public","body":"ret_ty = compute_return_type(rty, ret_def, context)\narg_tys = atys.map do |aty|\n  compute_arg_type(aty, context)\nend\nFunctionType.new(arg_tys, ret_ty)\n"}},{"html_id":"align(type:Type):Int32-instance-method","name":"align","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Type"}],"args_string":"(type : Type) : Int32","args_html":"(type : <a href=\"../../LLVM/Type.html\">Type</a>) : <a href=\"../../Int32.html\">Int32</a>","location":{"filename":"src/llvm/abi/aarch64.cr","line_number":12,"url":null},"def":{"name":"align","args":[{"name":"type","external_name":"type","restriction":"Type"}],"return_type":"Int32","visibility":"Public","body":"align(type, 8)"}},{"html_id":"homogeneous_aggregate?(type)-instance-method","name":"homogeneous_aggregate?","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""}],"args_string":"(type)","args_html":"(type)","location":{"filename":"src/llvm/abi/aarch64.cr","line_number":20,"url":null},"def":{"name":"homogeneous_aggregate?","args":[{"name":"type","external_name":"type","restriction":""}],"visibility":"Public","body":"homog_agg : ::Tuple(Type, UInt64) | ::Nil = case type\nwhen Type::Kind::Float\n  return {type, 1_u64}\nwhen Type::Kind::Double\n  return {type, 1_u64}\nwhen Type::Kind::Array\n  check_array(type)\nwhen Type::Kind::Struct\n  check_struct(type)\nend\nif homog_agg\n  if 0 < (__temp_76 = homog_agg[1]) && __temp_76 <= 4\n    return homog_agg\n  end\nend\n"}},{"html_id":"register?(type):Bool-instance-method","name":"register?","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""}],"args_string":"(type) : Bool","args_html":"(type) : <a href=\"../../Bool.html\">Bool</a>","location":{"filename":"src/llvm/abi/aarch64.cr","line_number":142,"url":null},"def":{"name":"register?","args":[{"name":"type","external_name":"type","restriction":""}],"return_type":"Bool","visibility":"Public","body":"case type.kind\nwhen Type::Kind::Integer, Type::Kind::Float, Type::Kind::Double, Type::Kind::Pointer\n  true\nelse\n  false\nend"}},{"html_id":"size(type:Type):Int32-instance-method","name":"size","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Type"}],"args_string":"(type : Type) : Int32","args_html":"(type : <a href=\"../../LLVM/Type.html\">Type</a>) : <a href=\"../../Int32.html\">Int32</a>","location":{"filename":"src/llvm/abi/aarch64.cr","line_number":16,"url":null},"def":{"name":"size","args":[{"name":"type","external_name":"type","restriction":"Type"}],"return_type":"Int32","visibility":"Public","body":"size(type, 8)"}}]},{"html_id":"Crystal/LLVM/ABI/ArgKind","path":"LLVM/ABI/ArgKind.html","kind":"enum","full_name":"LLVM::ABI::ArgKind","name":"ArgKind","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/abi.cr","line_number":76,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Direct","name":"Direct","value":"0"},{"id":"Indirect","name":"Indirect","value":"1"},{"id":"Ignore","name":"Ignore","value":"2"}],"namespace":{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"instance_methods":[{"html_id":"direct?-instance-method","name":"direct?","abstract":false,"location":{"filename":"src/llvm/abi.cr","line_number":77,"url":null},"def":{"name":"direct?","visibility":"Public","body":"self == Direct"}},{"html_id":"ignore?-instance-method","name":"ignore?","abstract":false,"location":{"filename":"src/llvm/abi.cr","line_number":79,"url":null},"def":{"name":"ignore?","visibility":"Public","body":"self == Ignore"}},{"html_id":"indirect?-instance-method","name":"indirect?","abstract":false,"location":{"filename":"src/llvm/abi.cr","line_number":78,"url":null},"def":{"name":"indirect?","visibility":"Public","body":"self == Indirect"}}]},{"html_id":"Crystal/LLVM/ABI/ArgType","path":"LLVM/ABI/ArgType.html","kind":"struct","full_name":"LLVM::ABI::ArgType","name":"ArgType","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/abi.cr","line_number":82,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"class_methods":[{"html_id":"direct(type,cast=nil,pad=nil,attr=nil)-class-method","name":"direct","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""},{"name":"cast","default_value":"nil","external_name":"cast","restriction":""},{"name":"pad","default_value":"nil","external_name":"pad","restriction":""},{"name":"attr","default_value":"nil","external_name":"attr","restriction":""}],"args_string":"(type, cast = nil, pad = nil, attr = nil)","args_html":"(type, cast = <span class=\"n\">nil</span>, pad = <span class=\"n\">nil</span>, attr = <span class=\"n\">nil</span>)","location":{"filename":"src/llvm/abi.cr","line_number":89,"url":null},"def":{"name":"direct","args":[{"name":"type","external_name":"type","restriction":""},{"name":"cast","default_value":"nil","external_name":"cast","restriction":""},{"name":"pad","default_value":"nil","external_name":"pad","restriction":""},{"name":"attr","default_value":"nil","external_name":"attr","restriction":""}],"visibility":"Public","body":"new(ArgKind::Direct, type, cast, pad, attr)"}}],"constructors":[{"html_id":"ignore(type):self-class-method","name":"ignore","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""}],"args_string":"(type) : self","args_html":"(type) : <span class=\"k\">self</span>","location":{"filename":"src/llvm/abi.cr","line_number":97,"url":null},"def":{"name":"ignore","args":[{"name":"type","external_name":"type","restriction":""}],"return_type":"self","visibility":"Public","body":"new(ArgKind::Ignore, type)"}},{"html_id":"indirect(type,attr):self-class-method","name":"indirect","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""},{"name":"attr","external_name":"attr","restriction":""}],"args_string":"(type, attr) : self","args_html":"(type, attr) : <span class=\"k\">self</span>","location":{"filename":"src/llvm/abi.cr","line_number":93,"url":null},"def":{"name":"indirect","args":[{"name":"type","external_name":"type","restriction":""},{"name":"attr","external_name":"attr","restriction":""}],"return_type":"self","visibility":"Public","body":"new(ArgKind::Indirect, type, attr: attr)"}},{"html_id":"new(kind,type,cast=nil,pad=nil,attr=nil)-class-method","name":"new","abstract":false,"args":[{"name":"kind","external_name":"kind","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"cast","default_value":"nil","external_name":"cast","restriction":""},{"name":"pad","default_value":"nil","external_name":"pad","restriction":""},{"name":"attr","default_value":"nil","external_name":"attr","restriction":""}],"args_string":"(kind, type, cast = nil, pad = nil, attr = nil)","args_html":"(kind, type, cast = <span class=\"n\">nil</span>, pad = <span class=\"n\">nil</span>, attr = <span class=\"n\">nil</span>)","location":{"filename":"src/llvm/abi.cr","line_number":101,"url":null},"def":{"name":"new","args":[{"name":"kind","external_name":"kind","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"cast","default_value":"nil","external_name":"cast","restriction":""},{"name":"pad","default_value":"nil","external_name":"pad","restriction":""},{"name":"attr","default_value":"nil","external_name":"attr","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(kind, type, cast, pad, attr)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"attr:Attribute?-instance-method","name":"attr","abstract":false,"location":{"filename":"src/llvm/abi.cr","line_number":87,"url":null},"def":{"name":"attr","return_type":"Attribute | ::Nil","visibility":"Public","body":"@attr"}},{"html_id":"cast:Type?-instance-method","name":"cast","abstract":false,"location":{"filename":"src/llvm/abi.cr","line_number":85,"url":null},"def":{"name":"cast","return_type":"Type | ::Nil","visibility":"Public","body":"@cast"}},{"html_id":"kind:ArgKind-instance-method","name":"kind","abstract":false,"location":{"filename":"src/llvm/abi.cr","line_number":83,"url":null},"def":{"name":"kind","return_type":"ArgKind","visibility":"Public","body":"@kind"}},{"html_id":"pad:Nil-instance-method","name":"pad","abstract":false,"location":{"filename":"src/llvm/abi.cr","line_number":86,"url":null},"def":{"name":"pad","return_type":"Nil","visibility":"Public","body":"@pad"}},{"html_id":"type:Type-instance-method","name":"type","abstract":false,"location":{"filename":"src/llvm/abi.cr","line_number":84,"url":null},"def":{"name":"type","return_type":"Type","visibility":"Public","body":"@type"}}]},{"html_id":"Crystal/LLVM/ABI/ARM","path":"LLVM/ABI/ARM.html","kind":"class","full_name":"LLVM::ABI::ARM","name":"ARM","abstract":false,"superclass":{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"ancestors":[{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/abi/arm.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"doc":"Based on https://github.com/rust-lang/rust/blob/dfe8bd10fe6763e0a1d5d55fa2574ecba27d3e2e/src/librustc_trans/cabi_arm.rs","summary":"<p>Based on https://github.com/rust-lang/rust/blob/dfe8bd10fe6763e0a1d5d55fa2574ecba27d3e2e/src/librustc_trans/cabi_arm.rs</p>","instance_methods":[{"html_id":"abi_info(atys:Array(Type),rty:Type,ret_def:Bool,context:Context):LLVM::ABI::FunctionType-instance-method","name":"abi_info","abstract":false,"args":[{"name":"atys","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","external_name":"rty","restriction":"Type"},{"name":"ret_def","external_name":"ret_def","restriction":"Bool"},{"name":"context","external_name":"context","restriction":"Context"}],"args_string":"(atys : Array(Type), rty : Type, ret_def : Bool, context : Context) : LLVM::ABI::FunctionType","args_html":"(atys : <a href=\"../../Array.html\">Array</a>(<a href=\"../../LLVM/Type.html\">Type</a>), rty : <a href=\"../../LLVM/Type.html\">Type</a>, ret_def : <a href=\"../../Bool.html\">Bool</a>, context : <a href=\"../../LLVM/Context.html\">Context</a>) : <a href=\"../../LLVM/ABI/FunctionType.html\">LLVM::ABI::FunctionType</a>","location":{"filename":"src/llvm/abi/arm.cr","line_number":5,"url":null},"def":{"name":"abi_info","args":[{"name":"atys","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","external_name":"rty","restriction":"Type"},{"name":"ret_def","external_name":"ret_def","restriction":"Bool"},{"name":"context","external_name":"context","restriction":"Context"}],"return_type":"LLVM::ABI::FunctionType","visibility":"Public","body":"ret_ty = compute_return_type(rty, ret_def, context)\narg_tys = compute_arg_types(atys, context)\nFunctionType.new(arg_tys, ret_ty)\n"}},{"html_id":"align(type:Type):Int32-instance-method","name":"align","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Type"}],"args_string":"(type : Type) : Int32","args_html":"(type : <a href=\"../../LLVM/Type.html\">Type</a>) : <a href=\"../../Int32.html\">Int32</a>","location":{"filename":"src/llvm/abi/arm.cr","line_number":11,"url":null},"def":{"name":"align","args":[{"name":"type","external_name":"type","restriction":"Type"}],"return_type":"Int32","visibility":"Public","body":"align(type, 4)"}},{"html_id":"register?(type):Bool-instance-method","name":"register?","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""}],"args_string":"(type) : Bool","args_html":"(type) : <a href=\"../../Bool.html\">Bool</a>","location":{"filename":"src/llvm/abi/arm.cr","line_number":19,"url":null},"def":{"name":"register?","args":[{"name":"type","external_name":"type","restriction":""}],"return_type":"Bool","visibility":"Public","body":"case type.kind\nwhen Type::Kind::Integer, Type::Kind::Float, Type::Kind::Double, Type::Kind::Pointer\n  true\nelse\n  false\nend"}},{"html_id":"size(type:Type):Int32-instance-method","name":"size","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Type"}],"args_string":"(type : Type) : Int32","args_html":"(type : <a href=\"../../LLVM/Type.html\">Type</a>) : <a href=\"../../Int32.html\">Int32</a>","location":{"filename":"src/llvm/abi/arm.cr","line_number":15,"url":null},"def":{"name":"size","args":[{"name":"type","external_name":"type","restriction":"Type"}],"return_type":"Int32","visibility":"Public","body":"size(type, 4)"}}]},{"html_id":"Crystal/LLVM/ABI/FunctionType","path":"LLVM/ABI/FunctionType.html","kind":"class","full_name":"LLVM::ABI::FunctionType","name":"FunctionType","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/abi.cr","line_number":105,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"constructors":[{"html_id":"new(arg_types,return_type)-class-method","name":"new","abstract":false,"args":[{"name":"arg_types","external_name":"arg_types","restriction":""},{"name":"return_type","external_name":"return_type","restriction":""}],"args_string":"(arg_types, return_type)","args_html":"(arg_types, return_type)","location":{"filename":"src/llvm/abi.cr","line_number":109,"url":null},"def":{"name":"new","args":[{"name":"arg_types","external_name":"arg_types","restriction":""},{"name":"return_type","external_name":"return_type","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(arg_types, return_type)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"arg_types:Array(ArgType)-instance-method","name":"arg_types","abstract":false,"location":{"filename":"src/llvm/abi.cr","line_number":106,"url":null},"def":{"name":"arg_types","return_type":"Array(ArgType)","visibility":"Public","body":"@arg_types"}},{"html_id":"return_type:ArgType-instance-method","name":"return_type","abstract":false,"location":{"filename":"src/llvm/abi.cr","line_number":107,"url":null},"def":{"name":"return_type","return_type":"ArgType","visibility":"Public","body":"@return_type"}}]},{"html_id":"Crystal/LLVM/ABI/X86","path":"LLVM/ABI/X86.html","kind":"class","full_name":"LLVM::ABI::X86","name":"X86","abstract":false,"superclass":{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"ancestors":[{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/abi/x86.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/LLVM/ABI/X86_Win64","kind":"class","full_name":"LLVM::ABI::X86_Win64","name":"X86_Win64"}],"namespace":{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"doc":"Based on https://github.com/rust-lang/rust/blob/29ac04402d53d358a1f6200bea45a301ff05b2d1/src/librustc_trans/trans/cabi_x86.rs","summary":"<p>Based on https://github.com/rust-lang/rust/blob/29ac04402d53d358a1f6200bea45a301ff05b2d1/src/librustc_trans/trans/cabi_x86.rs</p>","instance_methods":[{"html_id":"abi_info(atys:Array(Type),rty:Type,ret_def:Bool,context:Context)-instance-method","name":"abi_info","abstract":false,"args":[{"name":"atys","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","external_name":"rty","restriction":"Type"},{"name":"ret_def","external_name":"ret_def","restriction":"Bool"},{"name":"context","external_name":"context","restriction":"Context"}],"args_string":"(atys : Array(Type), rty : Type, ret_def : Bool, context : Context)","args_html":"(atys : <a href=\"../../Array.html\">Array</a>(<a href=\"../../LLVM/Type.html\">Type</a>), rty : <a href=\"../../LLVM/Type.html\">Type</a>, ret_def : <a href=\"../../Bool.html\">Bool</a>, context : <a href=\"../../LLVM/Context.html\">Context</a>)","location":{"filename":"src/llvm/abi/x86.cr","line_number":5,"url":null},"def":{"name":"abi_info","args":[{"name":"atys","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","external_name":"rty","restriction":"Type"},{"name":"ret_def","external_name":"ret_def","restriction":"Bool"},{"name":"context","external_name":"context","restriction":"Context"}],"visibility":"Public","body":"ret_ty = compute_return_type(rty, ret_def, context)\narg_tys = compute_arg_types(atys, context)\nFunctionType.new(arg_tys, ret_ty)\n"}},{"html_id":"align(type:Type)-instance-method","name":"align","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","args_html":"(type : <a href=\"../../LLVM/Type.html\">Type</a>)","location":{"filename":"src/llvm/abi/x86.cr","line_number":15,"url":null},"def":{"name":"align","args":[{"name":"type","external_name":"type","restriction":"Type"}],"visibility":"Public","body":"(target_data.abi_alignment(type)).to_i32"}},{"html_id":"size(type:Type)-instance-method","name":"size","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Type"}],"args_string":"(type : Type)","args_html":"(type : <a href=\"../../LLVM/Type.html\">Type</a>)","location":{"filename":"src/llvm/abi/x86.cr","line_number":11,"url":null},"def":{"name":"size","args":[{"name":"type","external_name":"type","restriction":"Type"}],"visibility":"Public","body":"(target_data.abi_size(type)).to_i32"}}]},{"html_id":"Crystal/LLVM/ABI/X86_64","path":"LLVM/ABI/X86_64.html","kind":"class","full_name":"LLVM::ABI::X86_64","name":"X86_64","abstract":false,"superclass":{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"ancestors":[{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/abi/x86_64.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"MAX_INT_REGS","name":"MAX_INT_REGS","value":"6"},{"id":"MAX_SSE_REGS","name":"MAX_SSE_REGS","value":"8","doc":"%rdi, %rsi, %rdx, %rcx, %r8, %r9","summary":"<p>%rdi, %rsi, %rdx, %rcx, %r8, %r9</p>"}],"namespace":{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"doc":"Based on https://github.com/rust-lang/rust/blob/29ac04402d53d358a1f6200bea45a301ff05b2d1/src/librustc_trans/trans/cabi_x86_64.rs\nSee also, section 3.2.3 of the System V Application Binary Interface AMD64 Architecture Processor Supplement","summary":"<p>Based on https://github.com/rust-lang/rust/blob/29ac04402d53d358a1f6200bea45a301ff05b2d1/src/librustc_trans/trans/cabi_x86_64.rs See also, section 3.2.3 of the System V Application Binary Interface AMD64 Architecture Processor Supplement</p>","instance_methods":[{"html_id":"abi_info(atys:Array(Type),rty:Type,ret_def:Bool,context:Context):LLVM::ABI::FunctionType-instance-method","name":"abi_info","abstract":false,"args":[{"name":"atys","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","external_name":"rty","restriction":"Type"},{"name":"ret_def","external_name":"ret_def","restriction":"Bool"},{"name":"context","external_name":"context","restriction":"Context"}],"args_string":"(atys : Array(Type), rty : Type, ret_def : Bool, context : Context) : LLVM::ABI::FunctionType","args_html":"(atys : <a href=\"../../Array.html\">Array</a>(<a href=\"../../LLVM/Type.html\">Type</a>), rty : <a href=\"../../LLVM/Type.html\">Type</a>, ret_def : <a href=\"../../Bool.html\">Bool</a>, context : <a href=\"../../LLVM/Context.html\">Context</a>) : <a href=\"../../LLVM/ABI/FunctionType.html\">LLVM::ABI::FunctionType</a>","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":9,"url":null},"def":{"name":"abi_info","args":[{"name":"atys","external_name":"atys","restriction":"Array(Type)"},{"name":"rty","external_name":"rty","restriction":"Type"},{"name":"ret_def","external_name":"ret_def","restriction":"Bool"},{"name":"context","external_name":"context","restriction":"Context"}],"return_type":"LLVM::ABI::FunctionType","visibility":"Public","body":"available_int_regs = MAX_INT_REGS\navailable_sse_regs = MAX_SSE_REGS\nif ret_def\n  ret_ty, _, _ = x86_64_type(rty, Attribute::StructRet, context) do |cls|\n    sret?(cls)\n  end\n  if ret_ty.kind.indirect?\n    available_int_regs = available_int_regs - 1\n  end\nelse\n  ret_ty = ArgType.direct(context.void)\nend\narg_tys = Array(LLVM::Type).new(atys.size)\narg_tys = atys.map do |arg_type|\n  abi_type, needed_int_regs, needed_sse_regs = x86_64_type(arg_type, Attribute::ByVal, context) do |cls|\n    pass_by_val?(cls)\n  end\n  if available_int_regs >= needed_int_regs && available_sse_regs >= needed_sse_regs\n    available_int_regs = available_int_regs - needed_int_regs\n    available_sse_regs = available_sse_regs - needed_sse_regs\n    abi_type\n  else\n    if !(register?(arg_type))\n      ArgType.indirect(arg_type, Attribute::ByVal)\n    else\n      abi_type\n    end\n  end\nend\nFunctionType.new(arg_tys, ret_ty)\n"}},{"html_id":"align(offset,type):Int32-instance-method","name":"align","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"type","external_name":"type","restriction":""}],"args_string":"(offset, type) : Int32","args_html":"(offset, type) : <a href=\"../../Int32.html\">Int32</a>","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":324,"url":null},"def":{"name":"align","args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"type","external_name":"type","restriction":""}],"return_type":"Int32","visibility":"Public","body":"align = align(type)\n(((offset + align) - 1) // align) * align\n"}},{"html_id":"align(type:Type):Int32-instance-method","name":"align","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Type"}],"args_string":"(type : Type) : Int32","args_html":"(type : <a href=\"../../LLVM/Type.html\">Type</a>) : <a href=\"../../Int32.html\">Int32</a>","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":271,"url":null},"def":{"name":"align","args":[{"name":"type","external_name":"type","restriction":"Type"}],"return_type":"Int32","visibility":"Public","body":"case type.kind\nwhen Type::Kind::Integer\n  (type.int_width + 7) // 8\nwhen Type::Kind::Float\n  4\nwhen Type::Kind::Double\n  8\nwhen Type::Kind::Pointer\n  8\nwhen Type::Kind::Struct\n  if type.packed_struct?\n    1\n  else\n    type.struct_element_types.reduce(1) do |memo, elem|\n      Math.max(memo, align(elem))\n    end\n  end\nwhen Type::Kind::Array\n  align(type.element_type)\nelse\n  raise(\"Unhandled Type::Kind in align: #{type.kind}\")\nend"}},{"html_id":"all_mem(reg_classes)-instance-method","name":"all_mem","abstract":false,"args":[{"name":"reg_classes","external_name":"reg_classes","restriction":""}],"args_string":"(reg_classes)","args_html":"(reg_classes)","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":232,"url":null},"def":{"name":"all_mem","args":[{"name":"reg_classes","external_name":"reg_classes","restriction":""}],"visibility":"Public","body":"reg_classes.fill(RegClass::Memory)"}},{"html_id":"classify(ty,cls,ix,off)-instance-method","name":"classify","abstract":false,"args":[{"name":"ty","external_name":"ty","restriction":""},{"name":"cls","external_name":"cls","restriction":""},{"name":"ix","external_name":"ix","restriction":""},{"name":"off","external_name":"off","restriction":""}],"args_string":"(ty, cls, ix, off)","args_html":"(ty, cls, ix, off)","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":113,"url":null},"def":{"name":"classify","args":[{"name":"ty","external_name":"ty","restriction":""},{"name":"cls","external_name":"cls","restriction":""},{"name":"ix","external_name":"ix","restriction":""},{"name":"off","external_name":"off","restriction":""}],"visibility":"Public","body":"t_align = align(ty)\nt_size = size(ty)\nmisalign = off % t_align\nif misalign != 0\n  i = off // 8\n  e = ((off + t_size) + 7) // 8\n  while i < e\n    unify(cls, ix + 1, RegClass::Memory)\n    i = i + 1\n  end\n  return\nend\ncase ty.kind\nwhen Type::Kind::Integer, Type::Kind::Pointer\n  unify(cls, ix + (off // 8), RegClass::Int)\nwhen Type::Kind::Float\n  unify(cls, ix + (off // 8), (  (off % 8) == 4) ? RegClass::SSEFv : RegClass::SSEFs)\nwhen Type::Kind::Double\n  unify(cls, ix + (off // 8), RegClass::SSEDs)\nwhen Type::Kind::Struct\n  classify_struct(ty.struct_element_types, cls, ix, off, ty.packed_struct?)\nwhen Type::Kind::Array\n  len = ty.array_size\n  elt = ty.element_type\n  eltsz = size(elt)\n  i = 0\n  while i < len\n    classify(elt, cls, ix, off + (i * eltsz))\n    i = i + 1\n  end\nelse\n  raise(\"Unhandled Type::Kind in classify: #{ty.kind}\")\nend\n"}},{"html_id":"classify(type)-instance-method","name":"classify","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""}],"args_string":"(type)","args_html":"(type)","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":101,"url":null},"def":{"name":"classify","args":[{"name":"type","external_name":"type","restriction":""}],"visibility":"Public","body":"words = ((size(type)) + 7) // 8\nreg_classes = Array.new(words, RegClass::NoClass)\nif words > 4\n  all_mem(reg_classes)\nelse\n  classify(type, reg_classes, 0, 0)\n  fixup(type, reg_classes)\nend\nreg_classes\n"}},{"html_id":"classify_struct(tys,cls,i,off,packed):Nil-instance-method","name":"classify_struct","abstract":false,"args":[{"name":"tys","external_name":"tys","restriction":""},{"name":"cls","external_name":"cls","restriction":""},{"name":"i","external_name":"i","restriction":""},{"name":"off","external_name":"off","restriction":""},{"name":"packed","external_name":"packed","restriction":""}],"args_string":"(tys, cls, i, off, packed) : Nil","args_html":"(tys, cls, i, off, packed) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":151,"url":null},"def":{"name":"classify_struct","args":[{"name":"tys","external_name":"tys","restriction":""},{"name":"cls","external_name":"cls","restriction":""},{"name":"i","external_name":"i","restriction":""},{"name":"off","external_name":"off","restriction":""},{"name":"packed","external_name":"packed","restriction":""}],"return_type":"Nil","visibility":"Public","body":"field_off = off\ntys.each do |ty|\n  if packed\n  else\n    field_off = align(field_off, ty)\n  end\n  classify(ty, cls, i, field_off)\n  field_off = field_off + (size(ty))\nend\n"}},{"html_id":"fixup(ty,cls):Nil-instance-method","name":"fixup","abstract":false,"args":[{"name":"ty","external_name":"ty","restriction":""},{"name":"cls","external_name":"cls","restriction":""}],"args_string":"(ty, cls) : Nil","args_html":"(ty, cls) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":160,"url":null},"def":{"name":"fixup","args":[{"name":"ty","external_name":"ty","restriction":""},{"name":"cls","external_name":"cls","restriction":""}],"return_type":"Nil","visibility":"Public","body":"i = 0\nty_kind = ty.kind\ne = cls.size\nif e > 2 && ((ty_kind == Type::Kind::Struct) || (ty_kind == Type::Kind::Array))\n  if cls[i].sse?\n    i = i + 1\n    while i < e\n      if cls[i] != RegClass::SSEUp\n        all_mem(cls)\n        return\n      end\n      i = i + 1\n    end\n  else\n    all_mem(cls)\n    return\n  end\nelse\n  while i < e\n    case\n    when cls[i] == RegClass::Memory\n      all_mem(cls)\n      return\n    when cls[i] == RegClass::X87Up\n      all_mem(cls)\n      return\n    when cls[i] == RegClass::SSEUp\n      cls[i] = RegClass::SSEDv\n    when cls[i].sse?\n      i = i + 1\n      while (i != e) && (cls[i] == RegClass::SSEUp)\n        i = i + 1\n      end\n    when cls[i] == RegClass::X87\n      i = i + 1\n      while (i != e) && (cls[i] == RegClass::X87Up)\n        i = i + 1\n      end\n    else\n      i = i + 1\n    end\n  end\nend\n"}},{"html_id":"int_register?(type):Bool-instance-method","name":"int_register?","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""}],"args_string":"(type) : Bool","args_html":"(type) : <a href=\"../../Bool.html\">Bool</a>","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":70,"url":null},"def":{"name":"int_register?","args":[{"name":"type","external_name":"type","restriction":""}],"return_type":"Bool","visibility":"Public","body":"case type.kind\nwhen Type::Kind::Integer, Type::Kind::Pointer\n  true\nelse\n  false\nend"}},{"html_id":"llreg(context,reg_classes):LLVM::Type-instance-method","name":"llreg","abstract":false,"args":[{"name":"context","external_name":"context","restriction":""},{"name":"reg_classes","external_name":"reg_classes","restriction":""}],"args_string":"(context, reg_classes) : LLVM::Type","args_html":"(context, reg_classes) : <a href=\"../../LLVM/Type.html\">LLVM::Type</a>","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":236,"url":null},"def":{"name":"llreg","args":[{"name":"context","external_name":"context","restriction":""},{"name":"reg_classes","external_name":"reg_classes","restriction":""}],"return_type":"LLVM::Type","visibility":"Public","body":"types = Array(Type).new\ni = 0\ne = reg_classes.size\nwhile i < e\n  case reg_classes[i]\n  when RegClass::Int\n    types << context.int64\n  when RegClass::SSEFv\n    vec_len = llvec_len(reg_classes[(i + 1)..-1])\n    vec_type = context.float.vector(vec_len * 2)\n    types << vec_type\n    i = i + vec_len\n    next\n  when RegClass::SSEFs\n    types << context.float\n  when RegClass::SSEDs\n    types << context.double\n  else\n    raise(\"Unhandled RegClass: #{reg_classes[i]}\")\n  end\n  i = i + 1\nend\ncontext.struct(types)\n"}},{"html_id":"llvec_len(reg_classes):Int32-instance-method","name":"llvec_len","abstract":false,"args":[{"name":"reg_classes","external_name":"reg_classes","restriction":""}],"args_string":"(reg_classes) : Int32","args_html":"(reg_classes) : <a href=\"../../Int32.html\">Int32</a>","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":262,"url":null},"def":{"name":"llvec_len","args":[{"name":"reg_classes","external_name":"reg_classes","restriction":""}],"return_type":"Int32","visibility":"Public","body":"len = 1\nreg_classes.each do |reg_class|\n  if reg_class != RegClass::SSEUp\n    break\n  end\n  len = len + 1\nend\nlen\n"}},{"html_id":"pass_by_val?(cls):Bool-instance-method","name":"pass_by_val?","abstract":false,"args":[{"name":"cls","external_name":"cls","restriction":""}],"args_string":"(cls) : Bool","args_html":"(cls) : <a href=\"../../Bool.html\">Bool</a>","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":88,"url":null},"def":{"name":"pass_by_val?","args":[{"name":"cls","external_name":"cls","restriction":""}],"return_type":"Bool","visibility":"Public","body":"if cls.empty?\n  return false\nend\ncl = cls.first\n((cl == RegClass::Memory) || (cl == RegClass::X87)) || (cl == RegClass::ComplexX87)\n"}},{"html_id":"register?(type):Bool-instance-method","name":"register?","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""}],"args_string":"(type) : Bool","args_html":"(type) : <a href=\"../../Bool.html\">Bool</a>","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":66,"url":null},"def":{"name":"register?","args":[{"name":"type","external_name":"type","restriction":""}],"return_type":"Bool","visibility":"Public","body":"(int_register?(type)) || (sse_register?(type))"}},{"html_id":"size(type:Type):Int32-instance-method","name":"size","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Type"}],"args_string":"(type : Type) : Int32","args_html":"(type : <a href=\"../../LLVM/Type.html\">Type</a>) : <a href=\"../../Int32.html\">Int32</a>","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":296,"url":null},"def":{"name":"size","args":[{"name":"type","external_name":"type","restriction":"Type"}],"return_type":"Int32","visibility":"Public","body":"case type.kind\nwhen Type::Kind::Integer\n  (type.int_width + 7) // 8\nwhen Type::Kind::Float\n  4\nwhen Type::Kind::Double\n  8\nwhen Type::Kind::Pointer\n  8\nwhen Type::Kind::Struct\n  if type.packed_struct?\n    type.struct_element_types.reduce(0) do |memo, elem|\n      memo + (size(elem))\n    end\n  else\n    size = type.struct_element_types.reduce(0) do |memo, elem|\n      (align(memo, elem)) + (size(elem))\n    end\n    align(size, type)\n  end\nwhen Type::Kind::Array\n  (size(type.element_type)) * type.array_size\nelse\n  raise(\"Unhandled Type::Kind in size: #{type.kind}\")\nend"}},{"html_id":"sret?(cls):Bool-instance-method","name":"sret?","abstract":false,"args":[{"name":"cls","external_name":"cls","restriction":""}],"args_string":"(cls) : Bool","args_html":"(cls) : <a href=\"../../Bool.html\">Bool</a>","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":95,"url":null},"def":{"name":"sret?","args":[{"name":"cls","external_name":"cls","restriction":""}],"return_type":"Bool","visibility":"Public","body":"if cls.empty?\n  return false\nend\ncls.first == RegClass::Memory\n"}},{"html_id":"sse_register?(type):Bool-instance-method","name":"sse_register?","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""}],"args_string":"(type) : Bool","args_html":"(type) : <a href=\"../../Bool.html\">Bool</a>","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":79,"url":null},"def":{"name":"sse_register?","args":[{"name":"type","external_name":"type","restriction":""}],"return_type":"Bool","visibility":"Public","body":"case type.kind\nwhen Type::Kind::Float, Type::Kind::Double\n  true\nelse\n  false\nend"}},{"html_id":"unify(cls,i,newv)-instance-method","name":"unify","abstract":false,"args":[{"name":"cls","external_name":"cls","restriction":""},{"name":"i","external_name":"i","restriction":""},{"name":"newv","external_name":"newv","restriction":""}],"args_string":"(cls, i, newv)","args_html":"(cls, i, newv)","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":208,"url":null},"def":{"name":"unify","args":[{"name":"cls","external_name":"cls","restriction":""},{"name":"i","external_name":"i","restriction":""},{"name":"newv","external_name":"newv","restriction":""}],"visibility":"Public","body":"case\nwhen cls[i] == newv\n  return\nwhen cls[i] == RegClass::NoClass\n  cls[i] = newv\nwhen newv == RegClass::NoClass\n  return\nwhen cls[i] == RegClass::Memory, newv == RegClass::Memory\n  return\nwhen cls[i] == RegClass::Int, newv == RegClass::Int\n  return\nwhen cls[i] == RegClass::X87, cls[i] == RegClass::X87Up, cls[i] == RegClass::ComplexX87, newv == RegClass::X87, newv == RegClass::X87Up, newv == RegClass::ComplexX87\n  cls[i] = RegClass::Memory\nelse\n  cls[i] = newv\nend"}},{"html_id":"x86_64_type(type,ind_attr,context,&):Tuple(ArgType,Int32,Int32)-instance-method","name":"x86_64_type","doc":"returns the LLVM type (with attributes) and the number of integer and SSE\nregisters needed to pass this value directly (ie. not using the stack)","summary":"<p>returns the LLVM type (with attributes) and the number of integer and SSE registers needed to pass this value directly (ie.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""},{"name":"ind_attr","external_name":"ind_attr","restriction":""},{"name":"context","external_name":"context","restriction":""}],"args_string":"(type, ind_attr, context, &) : Tuple(ArgType, Int32, Int32)","args_html":"(type, ind_attr, context, &) : <a href=\"../../Tuple.html\">Tuple</a>(<a href=\"../../LLVM/ABI/ArgType.html\">ArgType</a>, <a href=\"../../Int32.html\">Int32</a>, <a href=\"../../Int32.html\">Int32</a>)","location":{"filename":"src/llvm/abi/x86_64.cr","line_number":48,"url":null},"def":{"name":"x86_64_type","args":[{"name":"type","external_name":"type","restriction":""},{"name":"ind_attr","external_name":"ind_attr","restriction":""},{"name":"context","external_name":"context","restriction":""}],"yields":1,"return_type":"Tuple(ArgType, Int32, Int32)","visibility":"Public","body":"if int_register?(type)\n  attr = type == context.int1 ? Attribute::ZExt : nil\n  {ArgType.direct(type, attr: attr), 1, 0}\nelse\n  if sse_register?(type)\n    {ArgType.direct(type), 0, 1}\n  else\n    cls = classify(type)\n    if yield cls\n      {ArgType.indirect(type, ind_attr), 0, 0}\n    else\n      needed_int_regs = cls.count(&.int?)\n      needed_sse_regs = cls.count(&.sse?)\n      {ArgType.direct(type, llreg(context, cls)), needed_int_regs, needed_sse_regs}\n    end\n  end\nend"}}],"types":[{"html_id":"Crystal/LLVM/ABI/X86_64/RegClass","path":"LLVM/ABI/X86_64/RegClass.html","kind":"enum","full_name":"LLVM::ABI::X86_64::RegClass","name":"RegClass","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/abi/x86_64.cr","line_number":329,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"NoClass","name":"NoClass","value":"0"},{"id":"Int","name":"Int","value":"1"},{"id":"SSEFs","name":"SSEFs","value":"2"},{"id":"SSEFv","name":"SSEFv","value":"3"},{"id":"SSEDs","name":"SSEDs","value":"4"},{"id":"SSEDv","name":"SSEDv","value":"5"},{"id":"SSEInt","name":"SSEInt","value":"6"},{"id":"SSEUp","name":"SSEUp","value":"7"},{"id":"X87","name":"X87","value":"8"},{"id":"X87Up","name":"X87Up","value":"9"},{"id":"ComplexX87","name":"ComplexX87","value":"10"},{"id":"Memory","name":"Memory","value":"11"}],"namespace":{"html_id":"Crystal/LLVM/ABI/X86_64","kind":"class","full_name":"LLVM::ABI::X86_64","name":"X86_64"},"instance_methods":[{"html_id":"complex_x87?-instance-method","name":"complex_x87?","abstract":false,"location":{"filename":"src/llvm/abi/x86_64.cr","line_number":340,"url":null},"def":{"name":"complex_x87?","visibility":"Public","body":"self == ComplexX87"}},{"html_id":"int?-instance-method","name":"int?","abstract":false,"location":{"filename":"src/llvm/abi/x86_64.cr","line_number":331,"url":null},"def":{"name":"int?","visibility":"Public","body":"self == Int"}},{"html_id":"memory?-instance-method","name":"memory?","abstract":false,"location":{"filename":"src/llvm/abi/x86_64.cr","line_number":341,"url":null},"def":{"name":"memory?","visibility":"Public","body":"self == Memory"}},{"html_id":"no_class?-instance-method","name":"no_class?","abstract":false,"location":{"filename":"src/llvm/abi/x86_64.cr","line_number":330,"url":null},"def":{"name":"no_class?","visibility":"Public","body":"self == NoClass"}},{"html_id":"sse?:Bool-instance-method","name":"sse?","abstract":false,"location":{"filename":"src/llvm/abi/x86_64.cr","line_number":343,"url":null},"def":{"name":"sse?","return_type":"Bool","visibility":"Public","body":"case self\nwhen SSEFs, SSEFv, SSEDs\n  true\nelse\n  false\nend"}},{"html_id":"sse_ds?-instance-method","name":"sse_ds?","abstract":false,"location":{"filename":"src/llvm/abi/x86_64.cr","line_number":334,"url":null},"def":{"name":"sse_ds?","visibility":"Public","body":"self == SSEDs"}},{"html_id":"sse_dv?-instance-method","name":"sse_dv?","abstract":false,"location":{"filename":"src/llvm/abi/x86_64.cr","line_number":335,"url":null},"def":{"name":"sse_dv?","visibility":"Public","body":"self == SSEDv"}},{"html_id":"sse_fs?-instance-method","name":"sse_fs?","abstract":false,"location":{"filename":"src/llvm/abi/x86_64.cr","line_number":332,"url":null},"def":{"name":"sse_fs?","visibility":"Public","body":"self == SSEFs"}},{"html_id":"sse_fv?-instance-method","name":"sse_fv?","abstract":false,"location":{"filename":"src/llvm/abi/x86_64.cr","line_number":333,"url":null},"def":{"name":"sse_fv?","visibility":"Public","body":"self == SSEFv"}},{"html_id":"sse_int?-instance-method","name":"sse_int?","abstract":false,"location":{"filename":"src/llvm/abi/x86_64.cr","line_number":336,"url":null},"def":{"name":"sse_int?","visibility":"Public","body":"self == SSEInt"}},{"html_id":"sse_up?-instance-method","name":"sse_up?","abstract":false,"location":{"filename":"src/llvm/abi/x86_64.cr","line_number":337,"url":null},"def":{"name":"sse_up?","visibility":"Public","body":"self == SSEUp"}},{"html_id":"x87?-instance-method","name":"x87?","abstract":false,"location":{"filename":"src/llvm/abi/x86_64.cr","line_number":338,"url":null},"def":{"name":"x87?","visibility":"Public","body":"self == X87"}},{"html_id":"x87_up?-instance-method","name":"x87_up?","abstract":false,"location":{"filename":"src/llvm/abi/x86_64.cr","line_number":339,"url":null},"def":{"name":"x87_up?","visibility":"Public","body":"self == X87Up"}}]}]},{"html_id":"Crystal/LLVM/ABI/X86_Win64","path":"LLVM/ABI/X86_Win64.html","kind":"class","full_name":"LLVM::ABI::X86_Win64","name":"X86_Win64","abstract":false,"superclass":{"html_id":"Crystal/LLVM/ABI/X86","kind":"class","full_name":"LLVM::ABI::X86","name":"X86"},"ancestors":[{"html_id":"Crystal/LLVM/ABI/X86","kind":"class","full_name":"LLVM::ABI::X86","name":"X86"},{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/abi/x86_win64.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},"doc":"Based on https://github.com/rust-lang/rust/blob/29ac04402d53d358a1f6200bea45a301ff05b2d1/src/librustc_trans/trans/cabi_x86_win64.rs","summary":"<p>Based on https://github.com/rust-lang/rust/blob/29ac04402d53d358a1f6200bea45a301ff05b2d1/src/librustc_trans/trans/cabi_x86_win64.rs</p>"}]},{"html_id":"Crystal/LLVM/AtomicOrdering","path":"LLVM/AtomicOrdering.html","kind":"enum","full_name":"LLVM::AtomicOrdering","name":"AtomicOrdering","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":364,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"NotAtomic","name":"NotAtomic","value":"0"},{"id":"Unordered","name":"Unordered","value":"1"},{"id":"Monotonic","name":"Monotonic","value":"2"},{"id":"Acquire","name":"Acquire","value":"4"},{"id":"Release","name":"Release","value":"5"},{"id":"AcquireRelease","name":"AcquireRelease","value":"6"},{"id":"SequentiallyConsistent","name":"SequentiallyConsistent","value":"7"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"acquire?-instance-method","name":"acquire?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":368,"url":null},"def":{"name":"acquire?","visibility":"Public","body":"self == Acquire"}},{"html_id":"acquire_release?-instance-method","name":"acquire_release?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":370,"url":null},"def":{"name":"acquire_release?","visibility":"Public","body":"self == AcquireRelease"}},{"html_id":"monotonic?-instance-method","name":"monotonic?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":367,"url":null},"def":{"name":"monotonic?","visibility":"Public","body":"self == Monotonic"}},{"html_id":"not_atomic?-instance-method","name":"not_atomic?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":365,"url":null},"def":{"name":"not_atomic?","visibility":"Public","body":"self == NotAtomic"}},{"html_id":"release?-instance-method","name":"release?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":369,"url":null},"def":{"name":"release?","visibility":"Public","body":"self == Release"}},{"html_id":"sequentially_consistent?-instance-method","name":"sequentially_consistent?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":371,"url":null},"def":{"name":"sequentially_consistent?","visibility":"Public","body":"self == SequentiallyConsistent"}},{"html_id":"unordered?-instance-method","name":"unordered?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":366,"url":null},"def":{"name":"unordered?","visibility":"Public","body":"self == Unordered"}}]},{"html_id":"Crystal/LLVM/AtomicRMWBinOp","path":"LLVM/AtomicRMWBinOp.html","kind":"enum","full_name":"LLVM::AtomicRMWBinOp","name":"AtomicRMWBinOp","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":374,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Xchg","name":"Xchg","value":"0"},{"id":"Add","name":"Add","value":"1"},{"id":"Sub","name":"Sub","value":"2"},{"id":"And","name":"And","value":"3"},{"id":"Nand","name":"Nand","value":"4"},{"id":"Or","name":"Or","value":"5"},{"id":"Xor","name":"Xor","value":"6"},{"id":"Max","name":"Max","value":"7"},{"id":"Min","name":"Min","value":"8"},{"id":"UMax","name":"UMax","value":"9"},{"id":"UMin","name":"UMin","value":"10"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"add?-instance-method","name":"add?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":376,"url":null},"def":{"name":"add?","visibility":"Public","body":"self == Add"}},{"html_id":"and?-instance-method","name":"and?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":378,"url":null},"def":{"name":"and?","visibility":"Public","body":"self == And"}},{"html_id":"max?-instance-method","name":"max?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":382,"url":null},"def":{"name":"max?","visibility":"Public","body":"self == Max"}},{"html_id":"min?-instance-method","name":"min?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":383,"url":null},"def":{"name":"min?","visibility":"Public","body":"self == Min"}},{"html_id":"nand?-instance-method","name":"nand?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":379,"url":null},"def":{"name":"nand?","visibility":"Public","body":"self == Nand"}},{"html_id":"or?-instance-method","name":"or?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":380,"url":null},"def":{"name":"or?","visibility":"Public","body":"self == Or"}},{"html_id":"sub?-instance-method","name":"sub?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":377,"url":null},"def":{"name":"sub?","visibility":"Public","body":"self == Sub"}},{"html_id":"u_max?-instance-method","name":"u_max?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":384,"url":null},"def":{"name":"u_max?","visibility":"Public","body":"self == UMax"}},{"html_id":"u_min?-instance-method","name":"u_min?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":385,"url":null},"def":{"name":"u_min?","visibility":"Public","body":"self == UMin"}},{"html_id":"xchg?-instance-method","name":"xchg?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":375,"url":null},"def":{"name":"xchg?","visibility":"Public","body":"self == Xchg"}},{"html_id":"xor?-instance-method","name":"xor?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":381,"url":null},"def":{"name":"xor?","visibility":"Public","body":"self == Xor"}}]},{"html_id":"Crystal/LLVM/Attribute","path":"LLVM/Attribute.html","kind":"enum","full_name":"LLVM::Attribute","name":"Attribute","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Alignment","name":"Alignment","value":"1_u64"},{"id":"AllocSize","name":"AllocSize","value":"2_u64"},{"id":"AlwaysInline","name":"AlwaysInline","value":"4_u64"},{"id":"ArgMemOnly","name":"ArgMemOnly","value":"8_u64"},{"id":"Builtin","name":"Builtin","value":"16_u64"},{"id":"ByVal","name":"ByVal","value":"32_u64"},{"id":"Cold","name":"Cold","value":"64_u64"},{"id":"Convergent","name":"Convergent","value":"128_u64"},{"id":"Dereferenceable","name":"Dereferenceable","value":"256_u64"},{"id":"DereferenceableOrNull","name":"DereferenceableOrNull","value":"512_u64"},{"id":"InAlloca","name":"InAlloca","value":"1024_u64"},{"id":"InReg","name":"InReg","value":"2048_u64"},{"id":"InaccessibleMemOnly","name":"InaccessibleMemOnly","value":"4096_u64"},{"id":"InaccessibleMemOrArgMemOnly","name":"InaccessibleMemOrArgMemOnly","value":"8192_u64"},{"id":"InlineHint","name":"InlineHint","value":"16384_u64"},{"id":"JumpTable","name":"JumpTable","value":"32768_u64"},{"id":"MinSize","name":"MinSize","value":"65536_u64"},{"id":"Naked","name":"Naked","value":"131072_u64"},{"id":"Nest","name":"Nest","value":"262144_u64"},{"id":"NoAlias","name":"NoAlias","value":"524288_u64"},{"id":"NoBuiltin","name":"NoBuiltin","value":"1048576_u64"},{"id":"NoCapture","name":"NoCapture","value":"2097152_u64"},{"id":"NoDuplicate","name":"NoDuplicate","value":"4194304_u64"},{"id":"NoFree","name":"NoFree","value":"8388608_u64"},{"id":"NoImplicitFloat","name":"NoImplicitFloat","value":"16777216_u64"},{"id":"NoInline","name":"NoInline","value":"33554432_u64"},{"id":"NoRecurse","name":"NoRecurse","value":"67108864_u64"},{"id":"NoRedZone","name":"NoRedZone","value":"134217728_u64"},{"id":"NoReturn","name":"NoReturn","value":"268435456_u64"},{"id":"NoSync","name":"NoSync","value":"536870912_u64"},{"id":"NoUnwind","name":"NoUnwind","value":"1073741824_u64"},{"id":"NonLazyBind","name":"NonLazyBind","value":"2147483648_u64"},{"id":"NonNull","name":"NonNull","value":"4294967296_u64"},{"id":"OptimizeForSize","name":"OptimizeForSize","value":"8589934592_u64"},{"id":"OptimizeNone","name":"OptimizeNone","value":"17179869184_u64"},{"id":"ReadNone","name":"ReadNone","value":"34359738368_u64"},{"id":"ReadOnly","name":"ReadOnly","value":"68719476736_u64"},{"id":"Returned","name":"Returned","value":"137438953472_u64"},{"id":"ImmArg","name":"ImmArg","value":"274877906944_u64"},{"id":"ReturnsTwice","name":"ReturnsTwice","value":"549755813888_u64"},{"id":"SExt","name":"SExt","value":"1099511627776_u64"},{"id":"SafeStack","name":"SafeStack","value":"2199023255552_u64"},{"id":"SanitizeAddress","name":"SanitizeAddress","value":"4398046511104_u64"},{"id":"SanitizeMemory","name":"SanitizeMemory","value":"8796093022208_u64"},{"id":"SanitizeThread","name":"SanitizeThread","value":"17592186044416_u64"},{"id":"StackAlignment","name":"StackAlignment","value":"35184372088832_u64"},{"id":"StackProtect","name":"StackProtect","value":"70368744177664_u64"},{"id":"StackProtectReq","name":"StackProtectReq","value":"140737488355328_u64"},{"id":"StackProtectStrong","name":"StackProtectStrong","value":"281474976710656_u64"},{"id":"StructRet","name":"StructRet","value":"562949953421312_u64"},{"id":"SwiftError","name":"SwiftError","value":"1125899906842624_u64"},{"id":"SwiftSelf","name":"SwiftSelf","value":"2251799813685248_u64"},{"id":"UWTable","name":"UWTable","value":"4503599627370496_u64"},{"id":"WillReturn","name":"WillReturn","value":"9007199254740992_u64"},{"id":"WriteOnly","name":"WriteOnly","value":"18014398509481984_u64"},{"id":"ZExt","name":"ZExt","value":"36028797018963968_u64"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"class_methods":[{"html_id":"from_kind(kind)-class-method","name":"from_kind","abstract":false,"args":[{"name":"kind","external_name":"kind","restriction":""}],"args_string":"(kind)","args_html":"(kind)","location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"from_kind","args":[{"name":"kind","external_name":"kind","restriction":""}],"visibility":"Public","body":"@@kind_ids.key_for(kind)"}},{"html_id":"kind_for(member)-class-method","name":"kind_for","abstract":false,"args":[{"name":"member","external_name":"member","restriction":""}],"args_string":"(member)","args_html":"(member)","location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"kind_for","args":[{"name":"member","external_name":"member","restriction":""}],"visibility":"Public","body":"@@kind_ids[member]"}},{"html_id":"requires_type?(kind)-class-method","name":"requires_type?","abstract":false,"args":[{"name":"kind","external_name":"kind","restriction":""}],"args_string":"(kind)","args_html":"(kind)","location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"requires_type?","args":[{"name":"kind","external_name":"kind","restriction":""}],"visibility":"Public","body":"member = from_kind(kind)\n@@typed_attrs.includes?(member)\n"}}],"instance_methods":[{"html_id":"alignment?-instance-method","name":"alignment?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"alignment?","visibility":"Public","body":"self.includes?(Alignment)"}},{"html_id":"alloc_size?-instance-method","name":"alloc_size?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"alloc_size?","visibility":"Public","body":"self.includes?(AllocSize)"}},{"html_id":"always_inline?-instance-method","name":"always_inline?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"always_inline?","visibility":"Public","body":"self.includes?(AlwaysInline)"}},{"html_id":"arg_mem_only?-instance-method","name":"arg_mem_only?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"arg_mem_only?","visibility":"Public","body":"self.includes?(ArgMemOnly)"}},{"html_id":"builtin?-instance-method","name":"builtin?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"builtin?","visibility":"Public","body":"self.includes?(Builtin)"}},{"html_id":"by_val?-instance-method","name":"by_val?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"by_val?","visibility":"Public","body":"self.includes?(ByVal)"}},{"html_id":"cold?-instance-method","name":"cold?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"cold?","visibility":"Public","body":"self.includes?(Cold)"}},{"html_id":"convergent?-instance-method","name":"convergent?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"convergent?","visibility":"Public","body":"self.includes?(Convergent)"}},{"html_id":"dereferenceable?-instance-method","name":"dereferenceable?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"dereferenceable?","visibility":"Public","body":"self.includes?(Dereferenceable)"}},{"html_id":"dereferenceable_or_null?-instance-method","name":"dereferenceable_or_null?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"dereferenceable_or_null?","visibility":"Public","body":"self.includes?(DereferenceableOrNull)"}},{"html_id":"each_kind(&)-instance-method","name":"each_kind","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"each_kind","yields":0,"visibility":"Public","body":"if value == 0\n  return\nend\n{% for member in @type.constants %}\n          {% if member.stringify != \"All\" %}\n            if includes?({{ @type }}::{{ member }})\n              yield @@kind_ids[{{ @type }}::{{ member }}]\n            end\n          {% end %}\n        {% end %}\n"}},{"html_id":"imm_arg?-instance-method","name":"imm_arg?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"imm_arg?","visibility":"Public","body":"self.includes?(ImmArg)"}},{"html_id":"in_alloca?-instance-method","name":"in_alloca?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"in_alloca?","visibility":"Public","body":"self.includes?(InAlloca)"}},{"html_id":"in_reg?-instance-method","name":"in_reg?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"in_reg?","visibility":"Public","body":"self.includes?(InReg)"}},{"html_id":"inaccessible_mem_only?-instance-method","name":"inaccessible_mem_only?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"inaccessible_mem_only?","visibility":"Public","body":"self.includes?(InaccessibleMemOnly)"}},{"html_id":"inaccessible_mem_or_arg_mem_only?-instance-method","name":"inaccessible_mem_or_arg_mem_only?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"inaccessible_mem_or_arg_mem_only?","visibility":"Public","body":"self.includes?(InaccessibleMemOrArgMemOnly)"}},{"html_id":"inline_hint?-instance-method","name":"inline_hint?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"inline_hint?","visibility":"Public","body":"self.includes?(InlineHint)"}},{"html_id":"jump_table?-instance-method","name":"jump_table?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"jump_table?","visibility":"Public","body":"self.includes?(JumpTable)"}},{"html_id":"min_size?-instance-method","name":"min_size?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"min_size?","visibility":"Public","body":"self.includes?(MinSize)"}},{"html_id":"naked?-instance-method","name":"naked?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"naked?","visibility":"Public","body":"self.includes?(Naked)"}},{"html_id":"nest?-instance-method","name":"nest?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"nest?","visibility":"Public","body":"self.includes?(Nest)"}},{"html_id":"no_alias?-instance-method","name":"no_alias?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"no_alias?","visibility":"Public","body":"self.includes?(NoAlias)"}},{"html_id":"no_builtin?-instance-method","name":"no_builtin?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"no_builtin?","visibility":"Public","body":"self.includes?(NoBuiltin)"}},{"html_id":"no_capture?-instance-method","name":"no_capture?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"no_capture?","visibility":"Public","body":"self.includes?(NoCapture)"}},{"html_id":"no_duplicate?-instance-method","name":"no_duplicate?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"no_duplicate?","visibility":"Public","body":"self.includes?(NoDuplicate)"}},{"html_id":"no_free?-instance-method","name":"no_free?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"no_free?","visibility":"Public","body":"self.includes?(NoFree)"}},{"html_id":"no_implicit_float?-instance-method","name":"no_implicit_float?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"no_implicit_float?","visibility":"Public","body":"self.includes?(NoImplicitFloat)"}},{"html_id":"no_inline?-instance-method","name":"no_inline?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"no_inline?","visibility":"Public","body":"self.includes?(NoInline)"}},{"html_id":"no_recurse?-instance-method","name":"no_recurse?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"no_recurse?","visibility":"Public","body":"self.includes?(NoRecurse)"}},{"html_id":"no_red_zone?-instance-method","name":"no_red_zone?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"no_red_zone?","visibility":"Public","body":"self.includes?(NoRedZone)"}},{"html_id":"no_return?-instance-method","name":"no_return?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"no_return?","visibility":"Public","body":"self.includes?(NoReturn)"}},{"html_id":"no_sync?-instance-method","name":"no_sync?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"no_sync?","visibility":"Public","body":"self.includes?(NoSync)"}},{"html_id":"no_unwind?-instance-method","name":"no_unwind?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"no_unwind?","visibility":"Public","body":"self.includes?(NoUnwind)"}},{"html_id":"non_lazy_bind?-instance-method","name":"non_lazy_bind?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"non_lazy_bind?","visibility":"Public","body":"self.includes?(NonLazyBind)"}},{"html_id":"non_null?-instance-method","name":"non_null?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"non_null?","visibility":"Public","body":"self.includes?(NonNull)"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"none?","visibility":"Public","body":"value == 0"}},{"html_id":"optimize_for_size?-instance-method","name":"optimize_for_size?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"optimize_for_size?","visibility":"Public","body":"self.includes?(OptimizeForSize)"}},{"html_id":"optimize_none?-instance-method","name":"optimize_none?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"optimize_none?","visibility":"Public","body":"self.includes?(OptimizeNone)"}},{"html_id":"read_none?-instance-method","name":"read_none?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"read_none?","visibility":"Public","body":"self.includes?(ReadNone)"}},{"html_id":"read_only?-instance-method","name":"read_only?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"read_only?","visibility":"Public","body":"self.includes?(ReadOnly)"}},{"html_id":"returned?-instance-method","name":"returned?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"returned?","visibility":"Public","body":"self.includes?(Returned)"}},{"html_id":"returns_twice?-instance-method","name":"returns_twice?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"returns_twice?","visibility":"Public","body":"self.includes?(ReturnsTwice)"}},{"html_id":"s_ext?-instance-method","name":"s_ext?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"s_ext?","visibility":"Public","body":"self.includes?(SExt)"}},{"html_id":"safe_stack?-instance-method","name":"safe_stack?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"safe_stack?","visibility":"Public","body":"self.includes?(SafeStack)"}},{"html_id":"sanitize_address?-instance-method","name":"sanitize_address?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"sanitize_address?","visibility":"Public","body":"self.includes?(SanitizeAddress)"}},{"html_id":"sanitize_memory?-instance-method","name":"sanitize_memory?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"sanitize_memory?","visibility":"Public","body":"self.includes?(SanitizeMemory)"}},{"html_id":"sanitize_thread?-instance-method","name":"sanitize_thread?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"sanitize_thread?","visibility":"Public","body":"self.includes?(SanitizeThread)"}},{"html_id":"stack_alignment?-instance-method","name":"stack_alignment?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"stack_alignment?","visibility":"Public","body":"self.includes?(StackAlignment)"}},{"html_id":"stack_protect?-instance-method","name":"stack_protect?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"stack_protect?","visibility":"Public","body":"self.includes?(StackProtect)"}},{"html_id":"stack_protect_req?-instance-method","name":"stack_protect_req?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"stack_protect_req?","visibility":"Public","body":"self.includes?(StackProtectReq)"}},{"html_id":"stack_protect_strong?-instance-method","name":"stack_protect_strong?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"stack_protect_strong?","visibility":"Public","body":"self.includes?(StackProtectStrong)"}},{"html_id":"struct_ret?-instance-method","name":"struct_ret?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"struct_ret?","visibility":"Public","body":"self.includes?(StructRet)"}},{"html_id":"swift_error?-instance-method","name":"swift_error?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"swift_error?","visibility":"Public","body":"self.includes?(SwiftError)"}},{"html_id":"swift_self?-instance-method","name":"swift_self?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"swift_self?","visibility":"Public","body":"self.includes?(SwiftSelf)"}},{"html_id":"uw_table?-instance-method","name":"uw_table?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"uw_table?","visibility":"Public","body":"self.includes?(UWTable)"}},{"html_id":"will_return?-instance-method","name":"will_return?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"will_return?","visibility":"Public","body":"self.includes?(WillReturn)"}},{"html_id":"write_only?-instance-method","name":"write_only?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"write_only?","visibility":"Public","body":"self.includes?(WriteOnly)"}},{"html_id":"z_ext?-instance-method","name":"z_ext?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":2,"url":null},"def":{"name":"z_ext?","visibility":"Public","body":"self.includes?(ZExt)"}}]},{"html_id":"Crystal/LLVM/AttributeIndex","path":"LLVM/AttributeIndex.html","kind":"enum","full_name":"LLVM::AttributeIndex","name":"AttributeIndex","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":207,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"ReturnIndex","name":"ReturnIndex","value":"0_u32"},{"id":"FunctionIndex","name":"FunctionIndex","value":"4294967295_u32"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"doc":"Attribute index are either ReturnIndex (0), FunctionIndex (-1) or a\nparameter number ranging from 1 to N.","summary":"<p>Attribute index are either ReturnIndex (0), FunctionIndex (-1) or a parameter number ranging from 1 to N.</p>","instance_methods":[{"html_id":"function_index?-instance-method","name":"function_index?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":209,"url":null},"def":{"name":"function_index?","visibility":"Public","body":"self == FunctionIndex"}},{"html_id":"return_index?-instance-method","name":"return_index?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":208,"url":null},"def":{"name":"return_index?","visibility":"Public","body":"self == ReturnIndex"}}]},{"html_id":"Crystal/LLVM/BasicBlock","path":"LLVM/BasicBlock.html","kind":"struct","full_name":"LLVM::BasicBlock","name":"BasicBlock","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/basic_block.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"class_methods":[{"html_id":"null-class-method","name":"null","abstract":false,"location":{"filename":"src/llvm/basic_block.cr","line_number":5,"url":null},"def":{"name":"null","visibility":"Public","body":"LLVM::BasicBlock.new(Pointer(::Void).null.as(LibLLVM::BasicBlockRef))"}}],"constructors":[{"html_id":"new(unwrap:LibLLVM::BasicBlockRef)-class-method","name":"new","abstract":false,"args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::BasicBlockRef"}],"args_string":"(unwrap : LibLLVM::BasicBlockRef)","args_html":"(unwrap : LibLLVM::BasicBlockRef)","location":{"filename":"src/llvm/basic_block.cr","line_number":2,"url":null},"def":{"name":"new","args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::BasicBlockRef"}],"visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"delete-instance-method","name":"delete","abstract":false,"location":{"filename":"src/llvm/basic_block.cr","line_number":13,"url":null},"def":{"name":"delete","visibility":"Public","body":"LibLLVM.delete_basic_block(self)"}},{"html_id":"instructions-instance-method","name":"instructions","abstract":false,"location":{"filename":"src/llvm/basic_block.cr","line_number":9,"url":null},"def":{"name":"instructions","visibility":"Public","body":"InstructionCollection.new(self)"}},{"html_id":"name-instance-method","name":"name","abstract":false,"location":{"filename":"src/llvm/basic_block.cr","line_number":21,"url":null},"def":{"name":"name","visibility":"Public","body":"block_name = LibLLVMExt.basic_block_name(self)\nblock_name ? LLVM.string_and_dispose(block_name) : nil\n"}},{"html_id":"to_unsafe:LibLLVM::BasicBlockRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/basic_block.cr","line_number":17,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}}]},{"html_id":"Crystal/LLVM/BasicBlockCollection","path":"LLVM/BasicBlockCollection.html","kind":"struct","full_name":"LLVM::BasicBlockCollection","name":"BasicBlockCollection","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/basic_block_collection.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new(function:Function)-class-method","name":"new","abstract":false,"args":[{"name":"function","external_name":"function","restriction":"Function"}],"args_string":"(function : Function)","args_html":"(function : <a href=\"../LLVM/Function.html\">Function</a>)","location":{"filename":"src/llvm/basic_block_collection.cr","line_number":6,"url":null},"def":{"name":"new","args":[{"name":"function","external_name":"function","restriction":"Function"}],"visibility":"Public","body":"_ = allocate\n_.initialize(function)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"[](name:String)-instance-method","name":"[]","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String)","args_html":"(name : <a href=\"../String.html\">String</a>)","location":{"filename":"src/llvm/basic_block_collection.cr","line_number":36,"url":null},"def":{"name":"[]","args":[{"name":"name","external_name":"name","restriction":"String"}],"visibility":"Public","body":"self[name]? || (raise(IndexError.new))"}},{"html_id":"[]?(name:String)-instance-method","name":"[]?","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String)","args_html":"(name : <a href=\"../String.html\">String</a>)","location":{"filename":"src/llvm/basic_block_collection.cr","line_number":32,"url":null},"def":{"name":"[]?","args":[{"name":"name","external_name":"name","restriction":"String"}],"visibility":"Public","body":"find() do |__arg0|\n  __arg0.name == name\nend"}},{"html_id":"append(name=\"\")-instance-method","name":"append","abstract":false,"args":[{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(name = \"\")","args_html":"(name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/basic_block_collection.cr","line_number":9,"url":null},"def":{"name":"append","args":[{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"context = LibLLVM.get_module_context(LibLLVM.get_global_parent(@function))\nBasicBlock.new(LibLLVM.append_basic_block_in_context(context, @function, name))\n"}},{"html_id":"append(name=\"\",&)-instance-method","name":"append","abstract":false,"args":[{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(name = \"\", &)","args_html":"(name = <span class=\"s\">&quot;&quot;</span>, &)","location":{"filename":"src/llvm/basic_block_collection.cr","line_number":14,"url":null},"def":{"name":"append","args":[{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"yields":1,"visibility":"Public","body":"context = LibLLVM.get_module_context(LibLLVM.get_global_parent(@function))\nblock = append(name)\nbuilder = Builder.new(LibLLVM.create_builder_in_context(context))\nbuilder.position_at_end(block)\nyield builder\nblock\n"}},{"html_id":"each(&):Nil-instance-method","name":"each","doc":"Must yield this collection's elements to the block.","summary":"<p>Must yield this collection's elements to the block.</p>","abstract":false,"location":{"filename":"src/llvm/basic_block_collection.cr","line_number":24,"url":null},"def":{"name":"each","yields":1,"return_type":"Nil","visibility":"Public","body":"bb = LibLLVM.get_first_basic_block(@function)\nwhile bb\n  yield LLVM::BasicBlock.new(bb)\n  bb = LibLLVM.get_next_basic_block(bb)\nend\n"}},{"html_id":"last?-instance-method","name":"last?","abstract":false,"location":{"filename":"src/llvm/basic_block_collection.cr","line_number":40,"url":null},"def":{"name":"last?","visibility":"Public","body":"block = nil\neach do |current_block|\n  block = current_block\nend\nblock\n"}}]},{"html_id":"Crystal/LLVM/Builder","path":"LLVM/Builder.html","kind":"class","full_name":"LLVM::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/builder.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new(unwrap:LibLLVM::BuilderRef)-class-method","name":"new","abstract":false,"args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::BuilderRef"}],"args_string":"(unwrap : LibLLVM::BuilderRef)","args_html":"(unwrap : LibLLVM::BuilderRef)","location":{"filename":"src/llvm/builder.cr","line_number":4,"url":null},"def":{"name":"new","args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::BuilderRef"}],"visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"add(lhs,rhs,name=\"\")-instance-method","name":"add","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"add","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_add(self, lhs, rhs, name))"}},{"html_id":"add_handler(catch_switch_ref,handler)-instance-method","name":"add_handler","abstract":false,"args":[{"name":"catch_switch_ref","external_name":"catch_switch_ref","restriction":""},{"name":"handler","external_name":"handler","restriction":""}],"args_string":"(catch_switch_ref, handler)","args_html":"(catch_switch_ref, handler)","location":{"filename":"src/llvm/builder.cr","line_number":206,"url":null},"def":{"name":"add_handler","args":[{"name":"catch_switch_ref","external_name":"catch_switch_ref","restriction":""},{"name":"handler","external_name":"handler","restriction":""}],"visibility":"Public","body":"LibLLVMExt.add_handler(catch_switch_ref, handler)"}},{"html_id":"alloca(type,name=\"\")-instance-method","name":"alloca","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(type, name = \"\")","args_html":"(type, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":81,"url":null},"def":{"name":"alloca","args":[{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_alloca(self, type, name))"}},{"html_id":"and(lhs,rhs,name=\"\")-instance-method","name":"and","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"and","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_and(self, lhs, rhs, name))"}},{"html_id":"ashr(lhs,rhs,name=\"\")-instance-method","name":"ashr","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"ashr","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_ashr(self, lhs, rhs, name))"}},{"html_id":"atomicrmw(op,ptr,val,ordering,singlethread)-instance-method","name":"atomicrmw","abstract":false,"args":[{"name":"op","external_name":"op","restriction":""},{"name":"ptr","external_name":"ptr","restriction":""},{"name":"val","external_name":"val","restriction":""},{"name":"ordering","external_name":"ordering","restriction":""},{"name":"singlethread","external_name":"singlethread","restriction":""}],"args_string":"(op, ptr, val, ordering, singlethread)","args_html":"(op, ptr, val, ordering, singlethread)","location":{"filename":"src/llvm/builder.cr","line_number":234,"url":null},"def":{"name":"atomicrmw","args":[{"name":"op","external_name":"op","restriction":""},{"name":"ptr","external_name":"ptr","restriction":""},{"name":"val","external_name":"val","restriction":""},{"name":"ordering","external_name":"ordering","restriction":""},{"name":"singlethread","external_name":"singlethread","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_atomicrmw(self, op, ptr, val, ordering, singlethread ? 1 : 0))"}},{"html_id":"bit_cast(value,type,name=\"\")-instance-method","name":"bit_cast","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = \"\")","args_html":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":138,"url":null},"def":{"name":"bit_cast","args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_bit_cast(self, value, type, name))"}},{"html_id":"br(block)-instance-method","name":"br","abstract":false,"args":[{"name":"block","external_name":"block","restriction":""}],"args_string":"(block)","args_html":"(block)","location":{"filename":"src/llvm/builder.cr","line_number":25,"url":null},"def":{"name":"br","args":[{"name":"block","external_name":"block","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_br(self, block))"}},{"html_id":"build_catch_ret(pad,basic_block)-instance-method","name":"build_catch_ret","abstract":false,"args":[{"name":"pad","external_name":"pad","restriction":""},{"name":"basic_block","external_name":"basic_block","restriction":""}],"args_string":"(pad, basic_block)","args_html":"(pad, basic_block)","location":{"filename":"src/llvm/builder.cr","line_number":214,"url":null},"def":{"name":"build_catch_ret","args":[{"name":"pad","external_name":"pad","restriction":""},{"name":"basic_block","external_name":"basic_block","restriction":""}],"visibility":"Public","body":"LibLLVMExt.build_catch_ret(self, pad, basic_block)"}},{"html_id":"build_operand_bundle_def(name,values:Array(LLVM::Value))-instance-method","name":"build_operand_bundle_def","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"values","external_name":"values","restriction":"Array(LLVM::Value)"}],"args_string":"(name, values : Array(LLVM::Value))","args_html":"(name, values : <a href=\"../Array.html\">Array</a>(<a href=\"../LLVM/Value.html\">LLVM::Value</a>))","location":{"filename":"src/llvm/builder.cr","line_number":210,"url":null},"def":{"name":"build_operand_bundle_def","args":[{"name":"name","external_name":"name","restriction":""},{"name":"values","external_name":"values","restriction":"Array(LLVM::Value)"}],"visibility":"Public","body":"LLVM::OperandBundleDef.new(LibLLVMExt.build_operand_bundle_def(name, values.to_unsafe.as(::Pointer(LibLLVM::ValueRef)), values.size))"}},{"html_id":"call(func,args:Array(LLVM::Value),name:String=\"\",bundle:LLVM::OperandBundleDef=LLVM::OperandBundleDef.null)-instance-method","name":"call","abstract":false,"args":[{"name":"func","external_name":"func","restriction":""},{"name":"args","external_name":"args","restriction":"Array(LLVM::Value)"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":"String"},{"name":"bundle","default_value":"LLVM::OperandBundleDef.null","external_name":"bundle","restriction":"LLVM::OperandBundleDef"}],"args_string":"(func, args : Array(LLVM::Value), name : String = \"\", bundle : LLVM::OperandBundleDef = LLVM::OperandBundleDef.null)","args_html":"(func, args : <a href=\"../Array.html\">Array</a>(<a href=\"../LLVM/Value.html\">LLVM::Value</a>), name : <a href=\"../String.html\">String</a> = <span class=\"s\">&quot;&quot;</span>, bundle : <a href=\"../LLVM/OperandBundleDef.html\">LLVM::OperandBundleDef</a> = <span class=\"t\">LLVM</span><span class=\"t\">::</span><span class=\"t\">OperandBundleDef</span>.null)","location":{"filename":"src/llvm/builder.cr","line_number":74,"url":null},"def":{"name":"call","args":[{"name":"func","external_name":"func","restriction":""},{"name":"args","external_name":"args","restriction":"Array(LLVM::Value)"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":"String"},{"name":"bundle","default_value":"LLVM::OperandBundleDef.null","external_name":"bundle","restriction":"LLVM::OperandBundleDef"}],"visibility":"Public","body":"Value.new(LibLLVMExt.build_call2(self, func.function_type, func, (args.to_unsafe.as(::Pointer(LibLLVM::ValueRef))), args.size, bundle, name))"}},{"html_id":"call(func,name:String=\"\")-instance-method","name":"call","abstract":false,"args":[{"name":"func","external_name":"func","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":"String"}],"args_string":"(func, name : String = \"\")","args_html":"(func, name : <a href=\"../String.html\">String</a> = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":52,"url":null},"def":{"name":"call","args":[{"name":"func","external_name":"func","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":"String"}],"visibility":"Public","body":"{% if LibLLVM::IS_LT_80 %}\n      Value.new LibLLVM.build_call(self, func, nil, 0, name)\n    {% else %}\n      Value.new LibLLVM.build_call2(self, func.function_type, func, nil, 0, name)\n    {% end %}"}},{"html_id":"call(func,arg:LLVM::Value,name:String=\"\")-instance-method","name":"call","abstract":false,"args":[{"name":"func","external_name":"func","restriction":""},{"name":"arg","external_name":"arg","restriction":"LLVM::Value"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":"String"}],"args_string":"(func, arg : LLVM::Value, name : String = \"\")","args_html":"(func, arg : <a href=\"../LLVM/Value.html\">LLVM::Value</a>, name : <a href=\"../String.html\">String</a> = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":62,"url":null},"def":{"name":"call","args":[{"name":"func","external_name":"func","restriction":""},{"name":"arg","external_name":"arg","restriction":"LLVM::Value"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":"String"}],"visibility":"Public","body":"value = arg.to_unsafe\n{% if LibLLVM::IS_LT_80 %}\n      Value.new LibLLVM.build_call(self, func, pointerof(value), 1, name)\n    {% else %}\n      Value.new LibLLVM.build_call2(self, func.function_type, func, pointerof(value), 1, name)\n    {% end %}\n"}},{"html_id":"catch_pad(parent_pad,args:Array(LLVM::Value),name=\"\")-instance-method","name":"catch_pad","abstract":false,"args":[{"name":"parent_pad","external_name":"parent_pad","restriction":""},{"name":"args","external_name":"args","restriction":"Array(LLVM::Value)"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(parent_pad, args : Array(LLVM::Value), name = \"\")","args_html":"(parent_pad, args : <a href=\"../Array.html\">Array</a>(<a href=\"../LLVM/Value.html\">LLVM::Value</a>), name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":202,"url":null},"def":{"name":"catch_pad","args":[{"name":"parent_pad","external_name":"parent_pad","restriction":""},{"name":"args","external_name":"args","restriction":"Array(LLVM::Value)"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVMExt.build_catch_pad(self, parent_pad, args.size, args.to_unsafe.as(::Pointer(LibLLVM::ValueRef)), name))"}},{"html_id":"catch_switch(parent_pad,basic_block,num_handlers,name=\"\")-instance-method","name":"catch_switch","abstract":false,"args":[{"name":"parent_pad","external_name":"parent_pad","restriction":""},{"name":"basic_block","external_name":"basic_block","restriction":""},{"name":"num_handlers","external_name":"num_handlers","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(parent_pad, basic_block, num_handlers, name = \"\")","args_html":"(parent_pad, basic_block, num_handlers, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":198,"url":null},"def":{"name":"catch_switch","args":[{"name":"parent_pad","external_name":"parent_pad","restriction":""},{"name":"basic_block","external_name":"basic_block","restriction":""},{"name":"num_handlers","external_name":"num_handlers","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVMExt.build_catch_switch(self, parent_pad, basic_block, num_handlers, name))"}},{"html_id":"cmpxchg(pointer,cmp,new,success_ordering,failure_ordering)-instance-method","name":"cmpxchg","abstract":false,"args":[{"name":"pointer","external_name":"pointer","restriction":""},{"name":"cmp","external_name":"cmp","restriction":""},{"name":"new","external_name":"new","restriction":""},{"name":"success_ordering","external_name":"success_ordering","restriction":""},{"name":"failure_ordering","external_name":"failure_ordering","restriction":""}],"args_string":"(pointer, cmp, new, success_ordering, failure_ordering)","args_html":"(pointer, cmp, new, success_ordering, failure_ordering)","location":{"filename":"src/llvm/builder.cr","line_number":238,"url":null},"def":{"name":"cmpxchg","args":[{"name":"pointer","external_name":"pointer","restriction":""},{"name":"cmp","external_name":"cmp","restriction":""},{"name":"new","external_name":"new","restriction":""},{"name":"success_ordering","external_name":"success_ordering","restriction":""},{"name":"failure_ordering","external_name":"failure_ordering","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVMExt.build_cmpxchg(self, pointer, cmp, new, success_ordering, failure_ordering))"}},{"html_id":"cond(cond,then_block,else_block)-instance-method","name":"cond","abstract":false,"args":[{"name":"cond","external_name":"cond","restriction":""},{"name":"then_block","external_name":"then_block","restriction":""},{"name":"else_block","external_name":"else_block","restriction":""}],"args_string":"(cond, then_block, else_block)","args_html":"(cond, then_block, else_block)","location":{"filename":"src/llvm/builder.cr","line_number":29,"url":null},"def":{"name":"cond","args":[{"name":"cond","external_name":"cond","restriction":""},{"name":"then_block","external_name":"then_block","restriction":""},{"name":"else_block","external_name":"else_block","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_cond(self, cond, then_block, else_block))"}},{"html_id":"current_debug_location-instance-method","name":"current_debug_location","abstract":false,"location":{"filename":"src/llvm/builder.cr","line_number":258,"url":null},"def":{"name":"current_debug_location","visibility":"Public","body":"Value.new(LibLLVM.get_current_debug_location(self))"}},{"html_id":"exact_sdiv(lhs,rhs,name=\"\")-instance-method","name":"exact_sdiv","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"exact_sdiv","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_exact_sdiv(self, lhs, rhs, name))"}},{"html_id":"extract_value(value,index,name=\"\")-instance-method","name":"extract_value","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"index","external_name":"index","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, index, name = \"\")","args_html":"(value, index, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":132,"url":null},"def":{"name":"extract_value","args":[{"name":"value","external_name":"value","restriction":""},{"name":"index","external_name":"index","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_extract_value(self, value, index, name))"}},{"html_id":"fadd(lhs,rhs,name=\"\")-instance-method","name":"fadd","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"fadd","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_fadd(self, lhs, rhs, name))"}},{"html_id":"fcmp(op,lhs,rhs,name=\"\")-instance-method","name":"fcmp","abstract":false,"args":[{"name":"op","external_name":"op","restriction":""},{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(op, lhs, rhs, name = \"\")","args_html":"(op, lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":156,"url":null},"def":{"name":"fcmp","args":[{"name":"op","external_name":"op","restriction":""},{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_fcmp(self, op, lhs, rhs, name))"}},{"html_id":"fdiv(lhs,rhs,name=\"\")-instance-method","name":"fdiv","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"fdiv","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_fdiv(self, lhs, rhs, name))"}},{"html_id":"fence(ordering,singlethread,name=\"\")-instance-method","name":"fence","abstract":false,"args":[{"name":"ordering","external_name":"ordering","restriction":""},{"name":"singlethread","external_name":"singlethread","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(ordering, singlethread, name = \"\")","args_html":"(ordering, singlethread, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":242,"url":null},"def":{"name":"fence","args":[{"name":"ordering","external_name":"ordering","restriction":""},{"name":"singlethread","external_name":"singlethread","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_fence(self, ordering, singlethread ? 1 : 0, name))"}},{"html_id":"fmul(lhs,rhs,name=\"\")-instance-method","name":"fmul","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"fmul","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_fmul(self, lhs, rhs, name))"}},{"html_id":"fp2si(value,type,name=\"\")-instance-method","name":"fp2si","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = \"\")","args_html":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":138,"url":null},"def":{"name":"fp2si","args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_fp2si(self, value, type, name))"}},{"html_id":"fp2ui(value,type,name=\"\")-instance-method","name":"fp2ui","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = \"\")","args_html":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":138,"url":null},"def":{"name":"fp2ui","args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_fp2ui(self, value, type, name))"}},{"html_id":"fpext(value,type,name=\"\")-instance-method","name":"fpext","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = \"\")","args_html":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":138,"url":null},"def":{"name":"fpext","args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_fpext(self, value, type, name))"}},{"html_id":"fptrunc(value,type,name=\"\")-instance-method","name":"fptrunc","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = \"\")","args_html":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":138,"url":null},"def":{"name":"fptrunc","args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_fptrunc(self, value, type, name))"}},{"html_id":"fsub(lhs,rhs,name=\"\")-instance-method","name":"fsub","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"fsub","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_fsub(self, lhs, rhs, name))"}},{"html_id":"gep(value,indices:Array(LLVM::ValueRef),name=\"\")-instance-method","name":"gep","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"indices","external_name":"indices","restriction":"Array(LLVM::ValueRef)"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, indices : Array(LLVM::ValueRef), name = \"\")","args_html":"(value, indices : <a href=\"../Array.html\">Array</a>(LLVM::ValueRef), name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":108,"url":null},"def":{"name":"gep","args":[{"name":"value","external_name":"value","restriction":""},{"name":"indices","external_name":"indices","restriction":"Array(LLVM::ValueRef)"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_gep(self, value, indices.to_unsafe.as(::Pointer(LibLLVM::ValueRef)), indices.size, name))"}},{"html_id":"gep(value,index1:LLVM::Value,index2:LLVM::Value,name=\"\")-instance-method","name":"gep","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"index1","external_name":"index1","restriction":"LLVM::Value"},{"name":"index2","external_name":"index2","restriction":"LLVM::Value"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, index1 : LLVM::Value, index2 : LLVM::Value, name = \"\")","args_html":"(value, index1 : <a href=\"../LLVM/Value.html\">LLVM::Value</a>, index2 : <a href=\"../LLVM/Value.html\">LLVM::Value</a>, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":108,"url":null},"def":{"name":"gep","args":[{"name":"value","external_name":"value","restriction":""},{"name":"index1","external_name":"index1","restriction":"LLVM::Value"},{"name":"index2","external_name":"index2","restriction":"LLVM::Value"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"indices = uninitialized ::StaticArray(LLVM::Value, 2)\nindices[0] = index1\nindices[1] = index2\nValue.new(LibLLVM.build_gep(self, value, indices.to_unsafe.as(::Pointer(LibLLVM::ValueRef)), 2, name))\n"}},{"html_id":"gep(value,index:LLVM::Value,name=\"\")-instance-method","name":"gep","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"index","external_name":"index","restriction":"LLVM::Value"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, index : LLVM::Value, name = \"\")","args_html":"(value, index : <a href=\"../LLVM/Value.html\">LLVM::Value</a>, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":108,"url":null},"def":{"name":"gep","args":[{"name":"value","external_name":"value","restriction":""},{"name":"index","external_name":"index","restriction":"LLVM::Value"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"indices = (pointerof(index)).as(::Pointer(LibLLVM::ValueRef))\nValue.new(LibLLVM.build_gep(self, value, indices, 1, name))\n"}},{"html_id":"global_string_pointer(string,name=\"\")-instance-method","name":"global_string_pointer","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(string, name = \"\")","args_html":"(string, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":183,"url":null},"def":{"name":"global_string_pointer","args":[{"name":"string","external_name":"string","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_global_string_ptr(self, string, name))"}},{"html_id":"icmp(op,lhs,rhs,name=\"\")-instance-method","name":"icmp","abstract":false,"args":[{"name":"op","external_name":"op","restriction":""},{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(op, lhs, rhs, name = \"\")","args_html":"(op, lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":156,"url":null},"def":{"name":"icmp","args":[{"name":"op","external_name":"op","restriction":""},{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_icmp(self, op, lhs, rhs, name))"}},{"html_id":"inbounds_gep(value,indices:Array(LLVM::ValueRef),name=\"\")-instance-method","name":"inbounds_gep","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"indices","external_name":"indices","restriction":"Array(LLVM::ValueRef)"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, indices : Array(LLVM::ValueRef), name = \"\")","args_html":"(value, indices : <a href=\"../Array.html\">Array</a>(LLVM::ValueRef), name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":108,"url":null},"def":{"name":"inbounds_gep","args":[{"name":"value","external_name":"value","restriction":""},{"name":"indices","external_name":"indices","restriction":"Array(LLVM::ValueRef)"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_inbounds_gep(self, value, indices.to_unsafe.as(::Pointer(LibLLVM::ValueRef)), indices.size, name))"}},{"html_id":"inbounds_gep(value,index1:LLVM::Value,index2:LLVM::Value,name=\"\")-instance-method","name":"inbounds_gep","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"index1","external_name":"index1","restriction":"LLVM::Value"},{"name":"index2","external_name":"index2","restriction":"LLVM::Value"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, index1 : LLVM::Value, index2 : LLVM::Value, name = \"\")","args_html":"(value, index1 : <a href=\"../LLVM/Value.html\">LLVM::Value</a>, index2 : <a href=\"../LLVM/Value.html\">LLVM::Value</a>, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":108,"url":null},"def":{"name":"inbounds_gep","args":[{"name":"value","external_name":"value","restriction":""},{"name":"index1","external_name":"index1","restriction":"LLVM::Value"},{"name":"index2","external_name":"index2","restriction":"LLVM::Value"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"indices = uninitialized ::StaticArray(LLVM::Value, 2)\nindices[0] = index1\nindices[1] = index2\nValue.new(LibLLVM.build_inbounds_gep(self, value, indices.to_unsafe.as(::Pointer(LibLLVM::ValueRef)), 2, name))\n"}},{"html_id":"inbounds_gep(value,index:LLVM::Value,name=\"\")-instance-method","name":"inbounds_gep","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"index","external_name":"index","restriction":"LLVM::Value"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, index : LLVM::Value, name = \"\")","args_html":"(value, index : <a href=\"../LLVM/Value.html\">LLVM::Value</a>, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":108,"url":null},"def":{"name":"inbounds_gep","args":[{"name":"value","external_name":"value","restriction":""},{"name":"index","external_name":"index","restriction":"LLVM::Value"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"indices = (pointerof(index)).as(::Pointer(LibLLVM::ValueRef))\nValue.new(LibLLVM.build_inbounds_gep(self, value, indices, 1, name))\n"}},{"html_id":"insert_block-instance-method","name":"insert_block","abstract":false,"location":{"filename":"src/llvm/builder.cr","line_number":11,"url":null},"def":{"name":"insert_block","visibility":"Public","body":"BasicBlock.new(LibLLVM.get_insert_block(self))"}},{"html_id":"int2ptr(value,type,name=\"\")-instance-method","name":"int2ptr","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = \"\")","args_html":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":138,"url":null},"def":{"name":"int2ptr","args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_int2ptr(self, value, type, name))"}},{"html_id":"invoke(fn:LLVM::Function,args:Array(LLVM::Value),a_then,a_catch,bundle:LLVM::OperandBundleDef=LLVM::OperandBundleDef.null,name=\"\")-instance-method","name":"invoke","abstract":false,"args":[{"name":"fn","external_name":"fn","restriction":"LLVM::Function"},{"name":"args","external_name":"args","restriction":"Array(LLVM::Value)"},{"name":"a_then","external_name":"a_then","restriction":""},{"name":"a_catch","external_name":"a_catch","restriction":""},{"name":"bundle","default_value":"LLVM::OperandBundleDef.null","external_name":"bundle","restriction":"LLVM::OperandBundleDef"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(fn : LLVM::Function, args : Array(LLVM::Value), a_then, a_catch, bundle : LLVM::OperandBundleDef = LLVM::OperandBundleDef.null, name = \"\")","args_html":"(fn : <a href=\"../LLVM/Function.html\">LLVM::Function</a>, args : <a href=\"../Array.html\">Array</a>(<a href=\"../LLVM/Value.html\">LLVM::Value</a>), a_then, a_catch, bundle : <a href=\"../LLVM/OperandBundleDef.html\">LLVM::OperandBundleDef</a> = <span class=\"t\">LLVM</span><span class=\"t\">::</span><span class=\"t\">OperandBundleDef</span>.null, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":218,"url":null},"def":{"name":"invoke","args":[{"name":"fn","external_name":"fn","restriction":"LLVM::Function"},{"name":"args","external_name":"args","restriction":"Array(LLVM::Value)"},{"name":"a_then","external_name":"a_then","restriction":""},{"name":"a_catch","external_name":"a_catch","restriction":""},{"name":"bundle","default_value":"LLVM::OperandBundleDef.null","external_name":"bundle","restriction":"LLVM::OperandBundleDef"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVMExt.build_invoke2(self, fn.function_type, fn, (args.to_unsafe.as(::Pointer(LibLLVM::ValueRef))), args.size, a_then, a_catch, bundle, name))"}},{"html_id":"landing_pad(type,personality,clauses,name=\"\")-instance-method","name":"landing_pad","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""},{"name":"personality","external_name":"personality","restriction":""},{"name":"clauses","external_name":"clauses","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(type, personality, clauses, name = \"\")","args_html":"(type, personality, clauses, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":187,"url":null},"def":{"name":"landing_pad","args":[{"name":"type","external_name":"type","restriction":""},{"name":"personality","external_name":"personality","restriction":""},{"name":"clauses","external_name":"clauses","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"lpad = LibLLVM.build_landing_pad(self, type, personality, clauses.size, name)\nLibLLVM.set_cleanup(lpad, 1)\nclauses.each do |clause|\n  LibLLVM.add_clause(lpad, clause)\nend\nValue.new(lpad)\n"}},{"html_id":"load(ptr,name=\"\")-instance-method","name":"load","abstract":false,"args":[{"name":"ptr","external_name":"ptr","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(ptr, name = \"\")","args_html":"(ptr, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":94,"url":null},"def":{"name":"load","args":[{"name":"ptr","external_name":"ptr","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_load(self, ptr, name))"}},{"html_id":"load_volatile(ptr,name=\"\")-instance-method","name":"load_volatile","abstract":false,"args":[{"name":"ptr","external_name":"ptr","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(ptr, name = \"\")","args_html":"(ptr, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":104,"url":null},"def":{"name":"load_volatile","args":[{"name":"ptr","external_name":"ptr","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"(load(ptr, name)).tap do |v|\n  v.volatile = true\nend"}},{"html_id":"lshr(lhs,rhs,name=\"\")-instance-method","name":"lshr","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"lshr","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_lshr(self, lhs, rhs, name))"}},{"html_id":"mul(lhs,rhs,name=\"\")-instance-method","name":"mul","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"mul","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_mul(self, lhs, rhs, name))"}},{"html_id":"not(value,name=\"\")-instance-method","name":"not","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, name = \"\")","args_html":"(value, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":165,"url":null},"def":{"name":"not","args":[{"name":"value","external_name":"value","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_not(self, value, name))"}},{"html_id":"or(lhs,rhs,name=\"\")-instance-method","name":"or","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"or","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_or(self, lhs, rhs, name))"}},{"html_id":"phi(type,incoming_blocks:Array(LLVM::BasicBlock),incoming_values:Array(LLVM::Value),name=\"\")-instance-method","name":"phi","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""},{"name":"incoming_blocks","external_name":"incoming_blocks","restriction":"Array(LLVM::BasicBlock)"},{"name":"incoming_values","external_name":"incoming_values","restriction":"Array(LLVM::Value)"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(type, incoming_blocks : Array(LLVM::BasicBlock), incoming_values : Array(LLVM::Value), name = \"\")","args_html":"(type, incoming_blocks : <a href=\"../Array.html\">Array</a>(<a href=\"../LLVM/BasicBlock.html\">LLVM::BasicBlock</a>), incoming_values : <a href=\"../Array.html\">Array</a>(<a href=\"../LLVM/Value.html\">LLVM::Value</a>), name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":41,"url":null},"def":{"name":"phi","args":[{"name":"type","external_name":"type","restriction":""},{"name":"incoming_blocks","external_name":"incoming_blocks","restriction":"Array(LLVM::BasicBlock)"},{"name":"incoming_values","external_name":"incoming_values","restriction":"Array(LLVM::Value)"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"phi_node = LibLLVM.build_phi(self, type, name)\nLibLLVM.add_incoming(phi_node, (incoming_values.to_unsafe.as(::Pointer(LibLLVM::ValueRef))), (incoming_blocks.to_unsafe.as(::Pointer(LibLLVM::BasicBlockRef))), incoming_blocks.size)\nValue.new(phi_node)\n"}},{"html_id":"phi(type,table:LLVM::PhiTable,name=\"\")-instance-method","name":"phi","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""},{"name":"table","external_name":"table","restriction":"LLVM::PhiTable"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(type, table : LLVM::PhiTable, name = \"\")","args_html":"(type, table : <a href=\"../LLVM/PhiTable.html\">LLVM::PhiTable</a>, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":35,"url":null},"def":{"name":"phi","args":[{"name":"type","external_name":"type","restriction":""},{"name":"table","external_name":"table","restriction":"LLVM::PhiTable"},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"phi(type, table.blocks, table.values, name)"}},{"html_id":"position_at_end(block)-instance-method","name":"position_at_end","abstract":false,"args":[{"name":"block","external_name":"block","restriction":""}],"args_string":"(block)","args_html":"(block)","location":{"filename":"src/llvm/builder.cr","line_number":7,"url":null},"def":{"name":"position_at_end","args":[{"name":"block","external_name":"block","restriction":""}],"visibility":"Public","body":"LibLLVM.position_builder_at_end(self, block)"}},{"html_id":"ptr2int(value,type,name=\"\")-instance-method","name":"ptr2int","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = \"\")","args_html":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":138,"url":null},"def":{"name":"ptr2int","args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_ptr2int(self, value, type, name))"}},{"html_id":"ret(value)-instance-method","name":"ret","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/llvm/builder.cr","line_number":19,"url":null},"def":{"name":"ret","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_ret(self, value))"}},{"html_id":"ret-instance-method","name":"ret","abstract":false,"location":{"filename":"src/llvm/builder.cr","line_number":15,"url":null},"def":{"name":"ret","visibility":"Public","body":"Value.new(LibLLVM.build_ret_void(self))"}},{"html_id":"sdiv(lhs,rhs,name=\"\")-instance-method","name":"sdiv","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"sdiv","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_sdiv(self, lhs, rhs, name))"}},{"html_id":"select(cond,a_then,a_else,name=\"\")-instance-method","name":"select","abstract":false,"args":[{"name":"cond","external_name":"cond","restriction":""},{"name":"a_then","external_name":"a_then","restriction":""},{"name":"a_else","external_name":"a_else","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(cond, a_then, a_else, name = \"\")","args_html":"(cond, a_then, a_else, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":175,"url":null},"def":{"name":"select","args":[{"name":"cond","external_name":"cond","restriction":""},{"name":"a_then","external_name":"a_then","restriction":""},{"name":"a_else","external_name":"a_else","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_select(self, cond, a_then, a_else, name))"}},{"html_id":"set_current_debug_location(line,column,scope,inlined_at=nil)-instance-method","name":"set_current_debug_location","abstract":false,"args":[{"name":"line","external_name":"line","restriction":""},{"name":"column","external_name":"column","restriction":""},{"name":"scope","external_name":"scope","restriction":""},{"name":"inlined_at","default_value":"nil","external_name":"inlined_at","restriction":""}],"args_string":"(line, column, scope, inlined_at = nil)","args_html":"(line, column, scope, inlined_at = <span class=\"n\">nil</span>)","location":{"filename":"src/llvm/builder.cr","line_number":250,"url":null},"def":{"name":"set_current_debug_location","args":[{"name":"line","external_name":"line","restriction":""},{"name":"column","external_name":"column","restriction":""},{"name":"scope","external_name":"scope","restriction":""},{"name":"inlined_at","default_value":"nil","external_name":"inlined_at","restriction":""}],"visibility":"Public","body":"LibLLVMExt.set_current_debug_location(self, line, column, scope, inlined_at)"}},{"html_id":"set_metadata(value,kind,node)-instance-method","name":"set_metadata","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"kind","external_name":"kind","restriction":""},{"name":"node","external_name":"node","restriction":""}],"args_string":"(value, kind, node)","args_html":"(value, kind, node)","location":{"filename":"src/llvm/builder.cr","line_number":254,"url":null},"def":{"name":"set_metadata","args":[{"name":"value","external_name":"value","restriction":""},{"name":"kind","external_name":"kind","restriction":""},{"name":"node","external_name":"node","restriction":""}],"visibility":"Public","body":"LibLLVM.set_metadata(value, kind, node)"}},{"html_id":"sext(value,type,name=\"\")-instance-method","name":"sext","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = \"\")","args_html":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":138,"url":null},"def":{"name":"sext","args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_sext(self, value, type, name))"}},{"html_id":"shl(lhs,rhs,name=\"\")-instance-method","name":"shl","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"shl","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_shl(self, lhs, rhs, name))"}},{"html_id":"si2fp(value,type,name=\"\")-instance-method","name":"si2fp","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = \"\")","args_html":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":138,"url":null},"def":{"name":"si2fp","args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_si2fp(self, value, type, name))"}},{"html_id":"srem(lhs,rhs,name=\"\")-instance-method","name":"srem","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"srem","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_srem(self, lhs, rhs, name))"}},{"html_id":"store(value,ptr)-instance-method","name":"store","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"ptr","external_name":"ptr","restriction":""}],"args_string":"(value, ptr)","args_html":"(value, ptr)","location":{"filename":"src/llvm/builder.cr","line_number":87,"url":null},"def":{"name":"store","args":[{"name":"value","external_name":"value","restriction":""},{"name":"ptr","external_name":"ptr","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_store(self, value, ptr))"}},{"html_id":"store_volatile(value,ptr)-instance-method","name":"store_volatile","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"ptr","external_name":"ptr","restriction":""}],"args_string":"(value, ptr)","args_html":"(value, ptr)","location":{"filename":"src/llvm/builder.cr","line_number":100,"url":null},"def":{"name":"store_volatile","args":[{"name":"value","external_name":"value","restriction":""},{"name":"ptr","external_name":"ptr","restriction":""}],"visibility":"Public","body":"(store(value, ptr)).tap do |v|\n  v.volatile = true\nend"}},{"html_id":"sub(lhs,rhs,name=\"\")-instance-method","name":"sub","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"sub","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_sub(self, lhs, rhs, name))"}},{"html_id":"switch(value,otherwise,cases)-instance-method","name":"switch","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"otherwise","external_name":"otherwise","restriction":""},{"name":"cases","external_name":"cases","restriction":""}],"args_string":"(value, otherwise, cases)","args_html":"(value, otherwise, cases)","location":{"filename":"src/llvm/builder.cr","line_number":224,"url":null},"def":{"name":"switch","args":[{"name":"value","external_name":"value","restriction":""},{"name":"otherwise","external_name":"otherwise","restriction":""},{"name":"cases","external_name":"cases","restriction":""}],"visibility":"Public","body":"switch = LibLLVM.build_switch(self, value, otherwise, cases.size)\ncases.each do |case_value, block|\n  LibLLVM.add_case(switch, case_value, block)\nend\nswitch\n"}},{"html_id":"to_unsafe:LibLLVM::BuilderRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/builder.cr","line_number":262,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}},{"html_id":"trunc(value,type,name=\"\")-instance-method","name":"trunc","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = \"\")","args_html":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":138,"url":null},"def":{"name":"trunc","args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_trunc(self, value, type, name))"}},{"html_id":"udiv(lhs,rhs,name=\"\")-instance-method","name":"udiv","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"udiv","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_udiv(self, lhs, rhs, name))"}},{"html_id":"ui2fp(value,type,name=\"\")-instance-method","name":"ui2fp","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = \"\")","args_html":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":138,"url":null},"def":{"name":"ui2fp","args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_ui2fp(self, value, type, name))"}},{"html_id":"unreachable-instance-method","name":"unreachable","abstract":false,"location":{"filename":"src/llvm/builder.cr","line_number":171,"url":null},"def":{"name":"unreachable","visibility":"Public","body":"Value.new(LibLLVM.build_unreachable(self))"}},{"html_id":"urem(lhs,rhs,name=\"\")-instance-method","name":"urem","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"urem","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_urem(self, lhs, rhs, name))"}},{"html_id":"va_arg(list,type,name=\"\")-instance-method","name":"va_arg","abstract":false,"args":[{"name":"list","external_name":"list","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(list, type, name = \"\")","args_html":"(list, type, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":246,"url":null},"def":{"name":"va_arg","args":[{"name":"list","external_name":"list","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_va_arg(self, list, type, name))"}},{"html_id":"xor(lhs,rhs,name=\"\")-instance-method","name":"xor","abstract":false,"args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(lhs, rhs, name = \"\")","args_html":"(lhs, rhs, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":147,"url":null},"def":{"name":"xor","args":[{"name":"lhs","external_name":"lhs","restriction":""},{"name":"rhs","external_name":"rhs","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_xor(self, lhs, rhs, name))"}},{"html_id":"zext(value,type,name=\"\")-instance-method","name":"zext","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"args_string":"(value, type, name = \"\")","args_html":"(value, type, name = <span class=\"s\">&quot;&quot;</span>)","location":{"filename":"src/llvm/builder.cr","line_number":138,"url":null},"def":{"name":"zext","args":[{"name":"value","external_name":"value","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"name","default_value":"\"\"","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.build_zext(self, value, type, name))"}}]},{"html_id":"Crystal/LLVM/CallConvention","path":"LLVM/CallConvention.html","kind":"enum","full_name":"LLVM::CallConvention","name":"CallConvention","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":329,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"C","name":"C","value":"0"},{"id":"Fast","name":"Fast","value":"8"},{"id":"Cold","name":"Cold","value":"9"},{"id":"WebKit_JS","name":"WebKit_JS","value":"12"},{"id":"AnyReg","name":"AnyReg","value":"13"},{"id":"X86_StdCall","name":"X86_StdCall","value":"64"},{"id":"X86_FastCall","name":"X86_FastCall","value":"65"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"any_reg?-instance-method","name":"any_reg?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":334,"url":null},"def":{"name":"any_reg?","visibility":"Public","body":"self == AnyReg"}},{"html_id":"c?-instance-method","name":"c?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":330,"url":null},"def":{"name":"c?","visibility":"Public","body":"self == C"}},{"html_id":"cold?-instance-method","name":"cold?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":332,"url":null},"def":{"name":"cold?","visibility":"Public","body":"self == Cold"}},{"html_id":"fast?-instance-method","name":"fast?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":331,"url":null},"def":{"name":"fast?","visibility":"Public","body":"self == Fast"}},{"html_id":"web_kit_js?-instance-method","name":"web_kit_js?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":333,"url":null},"def":{"name":"web_kit_js?","visibility":"Public","body":"self == WebKit_JS"}},{"html_id":"x86_fast_call?-instance-method","name":"x86_fast_call?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":336,"url":null},"def":{"name":"x86_fast_call?","visibility":"Public","body":"self == X86_FastCall"}},{"html_id":"x86_std_call?-instance-method","name":"x86_std_call?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":335,"url":null},"def":{"name":"x86_std_call?","visibility":"Public","body":"self == X86_StdCall"}}]},{"html_id":"Crystal/LLVM/CodeGenFileType","path":"LLVM/CodeGenFileType.html","kind":"enum","full_name":"LLVM::CodeGenFileType","name":"CodeGenFileType","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":302,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"AssemblyFile","name":"AssemblyFile","value":"0"},{"id":"ObjectFile","name":"ObjectFile","value":"1"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"assembly_file?-instance-method","name":"assembly_file?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":303,"url":null},"def":{"name":"assembly_file?","visibility":"Public","body":"self == AssemblyFile"}},{"html_id":"object_file?-instance-method","name":"object_file?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":304,"url":null},"def":{"name":"object_file?","visibility":"Public","body":"self == ObjectFile"}}]},{"html_id":"Crystal/LLVM/CodeGenOptLevel","path":"LLVM/CodeGenOptLevel.html","kind":"enum","full_name":"LLVM::CodeGenOptLevel","name":"CodeGenOptLevel","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":295,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"None","name":"None","value":"0"},{"id":"Less","name":"Less","value":"1"},{"id":"Default","name":"Default","value":"2"},{"id":"Aggressive","name":"Aggressive","value":"3"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"aggressive?-instance-method","name":"aggressive?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":299,"url":null},"def":{"name":"aggressive?","visibility":"Public","body":"self == Aggressive"}},{"html_id":"default?-instance-method","name":"default?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":298,"url":null},"def":{"name":"default?","visibility":"Public","body":"self == Default"}},{"html_id":"less?-instance-method","name":"less?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":297,"url":null},"def":{"name":"less?","visibility":"Public","body":"self == Less"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":296,"url":null},"def":{"name":"none?","visibility":"Public","body":"self == None"}}]},{"html_id":"Crystal/LLVM/CodeModel","path":"LLVM/CodeModel.html","kind":"enum","full_name":"LLVM::CodeModel","name":"CodeModel","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":314,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Default","name":"Default","value":"0"},{"id":"JITDefault","name":"JITDefault","value":"1"},{"id":"Small","name":"Small","value":"2"},{"id":"Kernel","name":"Kernel","value":"3"},{"id":"Medium","name":"Medium","value":"4"},{"id":"Large","name":"Large","value":"5"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"default?-instance-method","name":"default?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":315,"url":null},"def":{"name":"default?","visibility":"Public","body":"self == Default"}},{"html_id":"jit_default?-instance-method","name":"jit_default?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":316,"url":null},"def":{"name":"jit_default?","visibility":"Public","body":"self == JITDefault"}},{"html_id":"kernel?-instance-method","name":"kernel?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":318,"url":null},"def":{"name":"kernel?","visibility":"Public","body":"self == Kernel"}},{"html_id":"large?-instance-method","name":"large?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":320,"url":null},"def":{"name":"large?","visibility":"Public","body":"self == Large"}},{"html_id":"medium?-instance-method","name":"medium?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":319,"url":null},"def":{"name":"medium?","visibility":"Public","body":"self == Medium"}},{"html_id":"small?-instance-method","name":"small?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":317,"url":null},"def":{"name":"small?","visibility":"Public","body":"self == Small"}}]},{"html_id":"Crystal/LLVM/Context","path":"LLVM/Context.html","kind":"class","full_name":"LLVM::Context","name":"Context","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/context.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new(unwrap:LibLLVM::ContextRef,dispose_on_finalize=true)-class-method","name":"new","abstract":false,"args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::ContextRef"},{"name":"dispose_on_finalize","default_value":"true","external_name":"dispose_on_finalize","restriction":""}],"args_string":"(unwrap : LibLLVM::ContextRef, dispose_on_finalize = true)","args_html":"(unwrap : LibLLVM::ContextRef, dispose_on_finalize = <span class=\"n\">true</span>)","location":{"filename":"src/llvm/context.cr","line_number":6,"url":null},"def":{"name":"new","args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::ContextRef"},{"name":"dispose_on_finalize","default_value":"true","external_name":"dispose_on_finalize","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(unwrap, dispose_on_finalize)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/llvm/context.cr","line_number":2,"url":null},"def":{"name":"new","visibility":"Public","body":"new(LibLLVM.create_context)"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this reference is the same as *other*. Invokes `same?`.","summary":"<p>Returns <code>true</code> if this reference is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/llvm/context.cr","line_number":116,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"@unwrap == (other.@unwrap)"}},{"html_id":"const_string(string:String):Value-instance-method","name":"const_string","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String) : Value","args_html":"(string : <a href=\"../String.html\">String</a>) : <a href=\"../LLVM/Value.html\">Value</a>","location":{"filename":"src/llvm/context.cr","line_number":87,"url":null},"def":{"name":"const_string","args":[{"name":"string","external_name":"string","restriction":"String"}],"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.const_string_in_context(self, string, string.bytesize, 0))"}},{"html_id":"const_struct(values:Array(LLVM::Value),packed=false):Value-instance-method","name":"const_struct","abstract":false,"args":[{"name":"values","external_name":"values","restriction":"Array(LLVM::Value)"},{"name":"packed","default_value":"false","external_name":"packed","restriction":""}],"args_string":"(values : Array(LLVM::Value), packed = false) : Value","args_html":"(values : <a href=\"../Array.html\">Array</a>(<a href=\"../LLVM/Value.html\">LLVM::Value</a>), packed = <span class=\"n\">false</span>) : <a href=\"../LLVM/Value.html\">Value</a>","location":{"filename":"src/llvm/context.cr","line_number":91,"url":null},"def":{"name":"const_struct","args":[{"name":"values","external_name":"values","restriction":"Array(LLVM::Value)"},{"name":"packed","default_value":"false","external_name":"packed","restriction":""}],"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.const_struct_in_context(self, (values.to_unsafe.as(::Pointer(LibLLVM::ValueRef))), values.size, packed ? 1 : 0))"}},{"html_id":"double:Type-instance-method","name":"double","abstract":false,"location":{"filename":"src/llvm/context.cr","line_number":63,"url":null},"def":{"name":"double","return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.double_type_in_context(self))"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/llvm/context.cr","line_number":124,"url":null},"def":{"name":"finalize","visibility":"Public","body":"if @dispose_on_finalize\nelse\n  return\nend\nif @disposed\n  return\nend\n@disposed = true\n@builders.each(&.dispose)\nLibLLVM.dispose_context(self)\n"}},{"html_id":"float:Type-instance-method","name":"float","abstract":false,"location":{"filename":"src/llvm/context.cr","line_number":59,"url":null},"def":{"name":"float","return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.float_type_in_context(self))"}},{"html_id":"int(bits:Int):Type-instance-method","name":"int","abstract":false,"args":[{"name":"bits","external_name":"bits","restriction":"Int"}],"args_string":"(bits : Int) : Type","args_html":"(bits : <a href=\"../Int.html\">Int</a>) : <a href=\"../LLVM/Type.html\">Type</a>","location":{"filename":"src/llvm/context.cr","line_number":55,"url":null},"def":{"name":"int","args":[{"name":"bits","external_name":"bits","restriction":"Int"}],"return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.int_type_in_context(self, bits))"}},{"html_id":"int1:Type-instance-method","name":"int1","abstract":false,"location":{"filename":"src/llvm/context.cr","line_number":31,"url":null},"def":{"name":"int1","return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.int1_type_in_context(self))"}},{"html_id":"int128:Type-instance-method","name":"int128","abstract":false,"location":{"filename":"src/llvm/context.cr","line_number":51,"url":null},"def":{"name":"int128","return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.int128_type_in_context(self))"}},{"html_id":"int16:Type-instance-method","name":"int16","abstract":false,"location":{"filename":"src/llvm/context.cr","line_number":39,"url":null},"def":{"name":"int16","return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.int16_type_in_context(self))"}},{"html_id":"int32:Type-instance-method","name":"int32","abstract":false,"location":{"filename":"src/llvm/context.cr","line_number":43,"url":null},"def":{"name":"int32","return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.int32_type_in_context(self))"}},{"html_id":"int64:Type-instance-method","name":"int64","abstract":false,"location":{"filename":"src/llvm/context.cr","line_number":47,"url":null},"def":{"name":"int64","return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.int64_type_in_context(self))"}},{"html_id":"int8:Type-instance-method","name":"int8","abstract":false,"location":{"filename":"src/llvm/context.cr","line_number":35,"url":null},"def":{"name":"int8","return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.int8_type_in_context(self))"}},{"html_id":"md_node(values:Array(Value)):Value-instance-method","name":"md_node","abstract":false,"args":[{"name":"values","external_name":"values","restriction":"Array(Value)"}],"args_string":"(values : Array(Value)) : Value","args_html":"(values : <a href=\"../Array.html\">Array</a>(<a href=\"../LLVM/Value.html\">Value</a>)) : <a href=\"../LLVM/Value.html\">Value</a>","location":{"filename":"src/llvm/context.cr","line_number":99,"url":null},"def":{"name":"md_node","args":[{"name":"values","external_name":"values","restriction":"Array(Value)"}],"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.md_node_in_context(self, (values.to_unsafe.as(::Pointer(LibLLVM::ValueRef))), values.size))"}},{"html_id":"md_string(value:String):Value-instance-method","name":"md_string","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(value : String) : Value","args_html":"(value : <a href=\"../String.html\">String</a>) : <a href=\"../LLVM/Value.html\">Value</a>","location":{"filename":"src/llvm/context.cr","line_number":95,"url":null},"def":{"name":"md_string","args":[{"name":"value","external_name":"value","restriction":"String"}],"return_type":"Value","visibility":"Public","body":"LLVM::Value.new(LibLLVM.md_string_in_context(self, value, value.bytesize))"}},{"html_id":"new_builder:Builder-instance-method","name":"new_builder","abstract":false,"location":{"filename":"src/llvm/context.cr","line_number":20,"url":null},"def":{"name":"new_builder","return_type":"Builder","visibility":"Public","body":"builder = Builder.new(LibLLVM.create_builder_in_context(self))\n@builders << builder\nbuilder\n"}},{"html_id":"new_module(name:String):Module-instance-method","name":"new_module","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String) : Module","args_html":"(name : <a href=\"../String.html\">String</a>) : <a href=\"../LLVM/Module.html\">Module</a>","location":{"filename":"src/llvm/context.cr","line_number":11,"url":null},"def":{"name":"new_module","args":[{"name":"name","external_name":"name","restriction":"String"}],"return_type":"Module","visibility":"Public","body":"{% if LibLLVM::IS_38 %}\n      Module.new(LibLLVM.module_create_with_name_in_context(name, self), name, self)\n    {% else %}\n      # LLVM >= 3.9\n      Module.new(LibLLVM.module_create_with_name_in_context(name, self), self)\n    {% end %}"}},{"html_id":"parse_ir(buf:MemoryBuffer)-instance-method","name":"parse_ir","abstract":false,"args":[{"name":"buf","external_name":"buf","restriction":"MemoryBuffer"}],"args_string":"(buf : MemoryBuffer)","args_html":"(buf : <a href=\"../LLVM/MemoryBuffer.html\">MemoryBuffer</a>)","location":{"filename":"src/llvm/context.cr","line_number":103,"url":null},"def":{"name":"parse_ir","args":[{"name":"buf","external_name":"buf","restriction":"MemoryBuffer"}],"visibility":"Public","body":"ret = LibLLVM.parse_ir_in_context(self, buf, out mod, out msg)\nif (ret != 0) && msg\n  raise(LLVM.string_and_dispose(msg))\nend\n{% if LibLLVM::IS_38 %}\n      Module.new(mod, \"unknown\", self)\n    {% else %}\n      # LLVM >= 3.9\n      Module.new(mod, self)\n    {% end %}\n"}},{"html_id":"struct(name:String,packed=false,&):Type-instance-method","name":"struct","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"packed","default_value":"false","external_name":"packed","restriction":""}],"args_string":"(name : String, packed = false, &) : Type","args_html":"(name : <a href=\"../String.html\">String</a>, packed = <span class=\"n\">false</span>, &) : <a href=\"../LLVM/Type.html\">Type</a>","location":{"filename":"src/llvm/context.cr","line_number":71,"url":null},"def":{"name":"struct","args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"packed","default_value":"false","external_name":"packed","restriction":""}],"yields":1,"return_type":"Type","visibility":"Public","body":"llvm_struct = LibLLVM.struct_create_named(self, name)\nthe_struct = Type.new(llvm_struct)\nelement_types = (yield the_struct).as(Array(LLVM::Type))\nLibLLVM.struct_set_body(llvm_struct, (element_types.to_unsafe.as(::Pointer(LibLLVM::TypeRef))), element_types.size, packed ? 1 : 0)\nthe_struct\n"}},{"html_id":"struct(element_types:Array(LLVM::Type),name=nil,packed=false):Type-instance-method","name":"struct","abstract":false,"args":[{"name":"element_types","external_name":"element_types","restriction":"Array(LLVM::Type)"},{"name":"name","default_value":"nil","external_name":"name","restriction":""},{"name":"packed","default_value":"false","external_name":"packed","restriction":""}],"args_string":"(element_types : Array(LLVM::Type), name = nil, packed = false) : Type","args_html":"(element_types : <a href=\"../Array.html\">Array</a>(<a href=\"../LLVM/Type.html\">LLVM::Type</a>), name = <span class=\"n\">nil</span>, packed = <span class=\"n\">false</span>) : <a href=\"../LLVM/Type.html\">Type</a>","location":{"filename":"src/llvm/context.cr","line_number":79,"url":null},"def":{"name":"struct","args":[{"name":"element_types","external_name":"element_types","restriction":"Array(LLVM::Type)"},{"name":"name","default_value":"nil","external_name":"name","restriction":""},{"name":"packed","default_value":"false","external_name":"packed","restriction":""}],"return_type":"Type","visibility":"Public","body":"if name\n  self.struct(name, packed) do\n    element_types\n  end\nelse\n  Type.new(LibLLVM.struct_type_in_context(self, (  element_types.to_unsafe.as(::Pointer(LibLLVM::TypeRef))), element_types.size, packed ? 1 : 0))\nend"}},{"html_id":"to_unsafe:LibLLVM::ContextRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/context.cr","line_number":120,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}},{"html_id":"void:Type-instance-method","name":"void","abstract":false,"location":{"filename":"src/llvm/context.cr","line_number":27,"url":null},"def":{"name":"void","return_type":"Type","visibility":"Public","body":"Type.new(LibLLVM.void_type_in_context(self))"}},{"html_id":"void_pointer:Type-instance-method","name":"void_pointer","abstract":false,"location":{"filename":"src/llvm/context.cr","line_number":67,"url":null},"def":{"name":"void_pointer","return_type":"Type","visibility":"Public","body":"int8.pointer"}}]},{"html_id":"Crystal/LLVM/DIBuilder","path":"LLVM/DIBuilder.html","kind":"struct","full_name":"LLVM::DIBuilder","name":"DIBuilder","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/di_builder.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new(llvm_module:Module)-class-method","name":"new","abstract":false,"args":[{"name":"llvm_module","external_name":"llvm_module","restriction":"Module"}],"args_string":"(llvm_module : Module)","args_html":"(llvm_module : <a href=\"../LLVM/Module.html\">Module</a>)","location":{"filename":"src/llvm/di_builder.cr","line_number":4,"url":null},"def":{"name":"new","args":[{"name":"llvm_module","external_name":"llvm_module","restriction":"Module"}],"visibility":"Public","body":"_ = allocate\n_.initialize(llvm_module)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"create_array_type(size_in_bits,align_in_bits,type,subs)-instance-method","name":"create_array_type","abstract":false,"args":[{"name":"size_in_bits","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"subs","external_name":"subs","restriction":""}],"args_string":"(size_in_bits, align_in_bits, type, subs)","args_html":"(size_in_bits, align_in_bits, type, subs)","location":{"filename":"src/llvm/di_builder.cr","line_number":81,"url":null},"def":{"name":"create_array_type","args":[{"name":"size_in_bits","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"subs","external_name":"subs","restriction":""}],"visibility":"Public","body":"elements = self.get_or_create_array(subs)\nLibLLVMExt.di_builder_create_array_type(self, size_in_bits, align_in_bits, type, elements)\n"}},{"html_id":"create_auto_variable(scope,name,file,line,type,align_in_bits,flags=DIFlags::Zero)-instance-method","name":"create_auto_variable","abstract":false,"args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line","external_name":"line","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"flags","default_value":"DIFlags::Zero","external_name":"flags","restriction":""}],"args_string":"(scope, name, file, line, type, align_in_bits, flags = DIFlags::Zero)","args_html":"(scope, name, file, line, type, align_in_bits, flags = <span class=\"t\">DIFlags</span><span class=\"t\">::</span><span class=\"t\">Zero</span>)","location":{"filename":"src/llvm/di_builder.cr","line_number":42,"url":null},"def":{"name":"create_auto_variable","args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line","external_name":"line","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"flags","default_value":"DIFlags::Zero","external_name":"flags","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_auto_variable(self, scope, name, file, line, type, 1, flags, align_in_bits)"}},{"html_id":"create_basic_type(name,size_in_bits,align_in_bits,encoding)-instance-method","name":"create_basic_type","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"size_in_bits","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"encoding","external_name":"encoding","restriction":""}],"args_string":"(name, size_in_bits, align_in_bits, encoding)","args_html":"(name, size_in_bits, align_in_bits, encoding)","location":{"filename":"src/llvm/di_builder.cr","line_number":12,"url":null},"def":{"name":"create_basic_type","args":[{"name":"name","external_name":"name","restriction":""},{"name":"size_in_bits","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"encoding","external_name":"encoding","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_basic_type(self, name, size_in_bits, align_in_bits, encoding.value)"}},{"html_id":"create_compile_unit(lang,file,dir,producer,optimized,flags,runtime_version)-instance-method","name":"create_compile_unit","abstract":false,"args":[{"name":"lang","external_name":"lang","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"dir","external_name":"dir","restriction":""},{"name":"producer","external_name":"producer","restriction":""},{"name":"optimized","external_name":"optimized","restriction":""},{"name":"flags","external_name":"flags","restriction":""},{"name":"runtime_version","external_name":"runtime_version","restriction":""}],"args_string":"(lang, file, dir, producer, optimized, flags, runtime_version)","args_html":"(lang, file, dir, producer, optimized, flags, runtime_version)","location":{"filename":"src/llvm/di_builder.cr","line_number":8,"url":null},"def":{"name":"create_compile_unit","args":[{"name":"lang","external_name":"lang","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"dir","external_name":"dir","restriction":""},{"name":"producer","external_name":"producer","restriction":""},{"name":"optimized","external_name":"optimized","restriction":""},{"name":"flags","external_name":"flags","restriction":""},{"name":"runtime_version","external_name":"runtime_version","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_compile_unit(self, lang, file, dir, producer, optimized ? 1 : 0, flags, runtime_version)"}},{"html_id":"create_enumeration_type(scope,name,file,line_number,size_in_bits,align_in_bits,elements,underlying_type)-instance-method","name":"create_enumeration_type","abstract":false,"args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line_number","external_name":"line_number","restriction":""},{"name":"size_in_bits","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"elements","external_name":"elements","restriction":""},{"name":"underlying_type","external_name":"underlying_type","restriction":""}],"args_string":"(scope, name, file, line_number, size_in_bits, align_in_bits, elements, underlying_type)","args_html":"(scope, name, file, line_number, size_in_bits, align_in_bits, elements, underlying_type)","location":{"filename":"src/llvm/di_builder.cr","line_number":66,"url":null},"def":{"name":"create_enumeration_type","args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line_number","external_name":"line_number","restriction":""},{"name":"size_in_bits","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"elements","external_name":"elements","restriction":""},{"name":"underlying_type","external_name":"underlying_type","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_enumeration_type(self, scope, name, file, line_number, size_in_bits, align_in_bits, elements, underlying_type)"}},{"html_id":"create_enumerator(name,value)-instance-method","name":"create_enumerator","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"value","external_name":"value","restriction":""}],"args_string":"(name, value)","args_html":"(name, value)","location":{"filename":"src/llvm/di_builder.cr","line_number":62,"url":null},"def":{"name":"create_enumerator","args":[{"name":"name","external_name":"name","restriction":""},{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_enumerator(self, name, value)"}},{"html_id":"create_expression(addr,length)-instance-method","name":"create_expression","abstract":false,"args":[{"name":"addr","external_name":"addr","restriction":""},{"name":"length","external_name":"length","restriction":""}],"args_string":"(addr, length)","args_html":"(addr, length)","location":{"filename":"src/llvm/di_builder.cr","line_number":50,"url":null},"def":{"name":"create_expression","args":[{"name":"addr","external_name":"addr","restriction":""},{"name":"length","external_name":"length","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_expression(self, addr, length)"}},{"html_id":"create_file(file,dir)-instance-method","name":"create_file","abstract":false,"args":[{"name":"file","external_name":"file","restriction":""},{"name":"dir","external_name":"dir","restriction":""}],"args_string":"(file, dir)","args_html":"(file, dir)","location":{"filename":"src/llvm/di_builder.cr","line_number":24,"url":null},"def":{"name":"create_file","args":[{"name":"file","external_name":"file","restriction":""},{"name":"dir","external_name":"dir","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_file(self, file, dir)"}},{"html_id":"create_function(scope,name,linkage_name,file,line,composite_type,is_local_to_unit,is_definition,scope_line,flags,is_optimized,func)-instance-method","name":"create_function","abstract":false,"args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"linkage_name","external_name":"linkage_name","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line","external_name":"line","restriction":""},{"name":"composite_type","external_name":"composite_type","restriction":""},{"name":"is_local_to_unit","external_name":"is_local_to_unit","restriction":""},{"name":"is_definition","external_name":"is_definition","restriction":""},{"name":"scope_line","external_name":"scope_line","restriction":""},{"name":"flags","external_name":"flags","restriction":""},{"name":"is_optimized","external_name":"is_optimized","restriction":""},{"name":"func","external_name":"func","restriction":""}],"args_string":"(scope, name, linkage_name, file, line, composite_type, is_local_to_unit, is_definition, scope_line, flags, is_optimized, func)","args_html":"(scope, name, linkage_name, file, line, composite_type, is_local_to_unit, is_definition, scope_line, flags, is_optimized, func)","location":{"filename":"src/llvm/di_builder.cr","line_number":36,"url":null},"def":{"name":"create_function","args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"linkage_name","external_name":"linkage_name","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line","external_name":"line","restriction":""},{"name":"composite_type","external_name":"composite_type","restriction":""},{"name":"is_local_to_unit","external_name":"is_local_to_unit","restriction":""},{"name":"is_definition","external_name":"is_definition","restriction":""},{"name":"scope_line","external_name":"scope_line","restriction":""},{"name":"flags","external_name":"flags","restriction":""},{"name":"is_optimized","external_name":"is_optimized","restriction":""},{"name":"func","external_name":"func","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_function(self, scope, name, linkage_name, file, line, composite_type, is_local_to_unit, is_definition, scope_line, flags, is_optimized, func)"}},{"html_id":"create_lexical_block(scope,file_scope,line,column)-instance-method","name":"create_lexical_block","abstract":false,"args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"file_scope","external_name":"file_scope","restriction":""},{"name":"line","external_name":"line","restriction":""},{"name":"column","external_name":"column","restriction":""}],"args_string":"(scope, file_scope, line, column)","args_html":"(scope, file_scope, line, column)","location":{"filename":"src/llvm/di_builder.cr","line_number":28,"url":null},"def":{"name":"create_lexical_block","args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"file_scope","external_name":"file_scope","restriction":""},{"name":"line","external_name":"line","restriction":""},{"name":"column","external_name":"column","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_lexical_block(self, scope, file_scope, line, column)"}},{"html_id":"create_lexical_block_file(scope,file_scope,discriminator=0)-instance-method","name":"create_lexical_block_file","abstract":false,"args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"file_scope","external_name":"file_scope","restriction":""},{"name":"discriminator","default_value":"0","external_name":"discriminator","restriction":""}],"args_string":"(scope, file_scope, discriminator = 0)","args_html":"(scope, file_scope, discriminator = <span class=\"n\">0</span>)","location":{"filename":"src/llvm/di_builder.cr","line_number":32,"url":null},"def":{"name":"create_lexical_block_file","args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"file_scope","external_name":"file_scope","restriction":""},{"name":"discriminator","default_value":"0","external_name":"discriminator","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_lexical_block_file(self, scope, file_scope, discriminator)"}},{"html_id":"create_member_type(scope,name,file,line,size_in_bits,align_in_bits,offset_in_bits,flags,ty)-instance-method","name":"create_member_type","abstract":false,"args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line","external_name":"line","restriction":""},{"name":"size_in_bits","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"offset_in_bits","external_name":"offset_in_bits","restriction":""},{"name":"flags","external_name":"flags","restriction":""},{"name":"ty","external_name":"ty","restriction":""}],"args_string":"(scope, name, file, line, size_in_bits, align_in_bits, offset_in_bits, flags, ty)","args_html":"(scope, name, file, line, size_in_bits, align_in_bits, offset_in_bits, flags, ty)","location":{"filename":"src/llvm/di_builder.cr","line_number":86,"url":null},"def":{"name":"create_member_type","args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line","external_name":"line","restriction":""},{"name":"size_in_bits","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"offset_in_bits","external_name":"offset_in_bits","restriction":""},{"name":"flags","external_name":"flags","restriction":""},{"name":"ty","external_name":"ty","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_member_type(self, scope, name, file, line, size_in_bits, align_in_bits, offset_in_bits, flags, ty)"}},{"html_id":"create_parameter_variable(scope,name,argno,file,line,type,flags=DIFlags::Zero)-instance-method","name":"create_parameter_variable","abstract":false,"args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"argno","external_name":"argno","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line","external_name":"line","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"flags","default_value":"DIFlags::Zero","external_name":"flags","restriction":""}],"args_string":"(scope, name, argno, file, line, type, flags = DIFlags::Zero)","args_html":"(scope, name, argno, file, line, type, flags = <span class=\"t\">DIFlags</span><span class=\"t\">::</span><span class=\"t\">Zero</span>)","location":{"filename":"src/llvm/di_builder.cr","line_number":46,"url":null},"def":{"name":"create_parameter_variable","args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"argno","external_name":"argno","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line","external_name":"line","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"flags","default_value":"DIFlags::Zero","external_name":"flags","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_parameter_variable(self, scope, name, argno, file, line, type, 1, flags)"}},{"html_id":"create_pointer_type(pointee,size_in_bits,align_in_bits,name)-instance-method","name":"create_pointer_type","abstract":false,"args":[{"name":"pointee","external_name":"pointee","restriction":""},{"name":"size_in_bits","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"name","external_name":"name","restriction":""}],"args_string":"(pointee, size_in_bits, align_in_bits, name)","args_html":"(pointee, size_in_bits, align_in_bits, name)","location":{"filename":"src/llvm/di_builder.cr","line_number":91,"url":null},"def":{"name":"create_pointer_type","args":[{"name":"pointee","external_name":"pointee","restriction":""},{"name":"size_in_bits","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"name","external_name":"name","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_pointer_type(self, pointee, size_in_bits, align_in_bits, name)"}},{"html_id":"create_reference_type(debug_type)-instance-method","name":"create_reference_type","abstract":false,"args":[{"name":"debug_type","external_name":"debug_type","restriction":""}],"args_string":"(debug_type)","args_html":"(debug_type)","location":{"filename":"src/llvm/di_builder.cr","line_number":111,"url":null},"def":{"name":"create_reference_type","args":[{"name":"debug_type","external_name":"debug_type","restriction":""}],"visibility":"Public","body":"LibLLVM.di_builder_create_reference_type(self, 16, debug_type)"}},{"html_id":"create_replaceable_composite_type(scope,name,file,line)-instance-method","name":"create_replaceable_composite_type","abstract":false,"args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line","external_name":"line","restriction":""}],"args_string":"(scope, name, file, line)","args_html":"(scope, name, file, line)","location":{"filename":"src/llvm/di_builder.cr","line_number":95,"url":null},"def":{"name":"create_replaceable_composite_type","args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line","external_name":"line","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_replaceable_composite_type(self, scope, name, file, line)"}},{"html_id":"create_struct_type(scope,name,file,line,size_in_bits,align_in_bits,flags,derived_from,element_types)-instance-method","name":"create_struct_type","abstract":false,"args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line","external_name":"line","restriction":""},{"name":"size_in_bits","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"flags","external_name":"flags","restriction":""},{"name":"derived_from","external_name":"derived_from","restriction":""},{"name":"element_types","external_name":"element_types","restriction":""}],"args_string":"(scope, name, file, line, size_in_bits, align_in_bits, flags, derived_from, element_types)","args_html":"(scope, name, file, line, size_in_bits, align_in_bits, flags, derived_from, element_types)","location":{"filename":"src/llvm/di_builder.cr","line_number":71,"url":null},"def":{"name":"create_struct_type","args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line","external_name":"line","restriction":""},{"name":"size_in_bits","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"flags","external_name":"flags","restriction":""},{"name":"derived_from","external_name":"derived_from","restriction":""},{"name":"element_types","external_name":"element_types","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_struct_type(self, scope, name, file, line, size_in_bits, align_in_bits, flags, derived_from, element_types)"}},{"html_id":"create_subroutine_type(file,parameter_types)-instance-method","name":"create_subroutine_type","abstract":false,"args":[{"name":"file","external_name":"file","restriction":""},{"name":"parameter_types","external_name":"parameter_types","restriction":""}],"args_string":"(file, parameter_types)","args_html":"(file, parameter_types)","location":{"filename":"src/llvm/di_builder.cr","line_number":20,"url":null},"def":{"name":"create_subroutine_type","args":[{"name":"file","external_name":"file","restriction":""},{"name":"parameter_types","external_name":"parameter_types","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_subroutine_type(self, file, parameter_types)"}},{"html_id":"create_union_type(scope,name,file,line,size_in_bits,align_in_bits,flags,element_types)-instance-method","name":"create_union_type","abstract":false,"args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line","external_name":"line","restriction":""},{"name":"size_in_bits","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"flags","external_name":"flags","restriction":""},{"name":"element_types","external_name":"element_types","restriction":""}],"args_string":"(scope, name, file, line, size_in_bits, align_in_bits, flags, element_types)","args_html":"(scope, name, file, line, size_in_bits, align_in_bits, flags, element_types)","location":{"filename":"src/llvm/di_builder.cr","line_number":76,"url":null},"def":{"name":"create_union_type","args":[{"name":"scope","external_name":"scope","restriction":""},{"name":"name","external_name":"name","restriction":""},{"name":"file","external_name":"file","restriction":""},{"name":"line","external_name":"line","restriction":""},{"name":"size_in_bits","external_name":"size_in_bits","restriction":""},{"name":"align_in_bits","external_name":"align_in_bits","restriction":""},{"name":"flags","external_name":"flags","restriction":""},{"name":"element_types","external_name":"element_types","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_union_type(self, scope, name, file, line, size_in_bits, align_in_bits, flags, element_types)"}},{"html_id":"create_unspecified_type(name:String)-instance-method","name":"create_unspecified_type","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String)","args_html":"(name : <a href=\"../String.html\">String</a>)","location":{"filename":"src/llvm/di_builder.cr","line_number":103,"url":null},"def":{"name":"create_unspecified_type","args":[{"name":"name","external_name":"name","restriction":"String"}],"visibility":"Public","body":"LibLLVMExt.di_builder_create_unspecified_type(self, name, name.size)"}},{"html_id":"end-instance-method","name":"end","abstract":false,"location":{"filename":"src/llvm/di_builder.cr","line_number":115,"url":null},"def":{"name":"end","visibility":"Public","body":"LibLLVMExt.di_builder_finalize(self)"}},{"html_id":"get_or_create_array(elements:Array(LibLLVM::MetadataRef))-instance-method","name":"get_or_create_array","abstract":false,"args":[{"name":"elements","external_name":"elements","restriction":"Array(LibLLVM::MetadataRef)"}],"args_string":"(elements : Array(LibLLVM::MetadataRef))","args_html":"(elements : <a href=\"../Array.html\">Array</a>(LibLLVM::MetadataRef))","location":{"filename":"src/llvm/di_builder.cr","line_number":58,"url":null},"def":{"name":"get_or_create_array","args":[{"name":"elements","external_name":"elements","restriction":"Array(LibLLVM::MetadataRef)"}],"visibility":"Public","body":"LibLLVMExt.di_builder_get_or_create_array(self, elements, elements.size)"}},{"html_id":"get_or_create_array_subrange(lo,count)-instance-method","name":"get_or_create_array_subrange","abstract":false,"args":[{"name":"lo","external_name":"lo","restriction":""},{"name":"count","external_name":"count","restriction":""}],"args_string":"(lo, count)","args_html":"(lo, count)","location":{"filename":"src/llvm/di_builder.cr","line_number":107,"url":null},"def":{"name":"get_or_create_array_subrange","args":[{"name":"lo","external_name":"lo","restriction":""},{"name":"count","external_name":"count","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_get_or_create_array_subrange(self, lo, count)"}},{"html_id":"get_or_create_type_array(types:Array(LibLLVM::MetadataRef))-instance-method","name":"get_or_create_type_array","abstract":false,"args":[{"name":"types","external_name":"types","restriction":"Array(LibLLVM::MetadataRef)"}],"args_string":"(types : Array(LibLLVM::MetadataRef))","args_html":"(types : <a href=\"../Array.html\">Array</a>(LibLLVM::MetadataRef))","location":{"filename":"src/llvm/di_builder.cr","line_number":16,"url":null},"def":{"name":"get_or_create_type_array","args":[{"name":"types","external_name":"types","restriction":"Array(LibLLVM::MetadataRef)"}],"visibility":"Public","body":"LibLLVMExt.di_builder_get_or_create_type_array(self, types, types.size)"}},{"html_id":"insert_declare_at_end(storage,var_info,expr,dl,block)-instance-method","name":"insert_declare_at_end","abstract":false,"args":[{"name":"storage","external_name":"storage","restriction":""},{"name":"var_info","external_name":"var_info","restriction":""},{"name":"expr","external_name":"expr","restriction":""},{"name":"dl","external_name":"dl","restriction":""},{"name":"block","external_name":"block","restriction":""}],"args_string":"(storage, var_info, expr, dl, block)","args_html":"(storage, var_info, expr, dl, block)","location":{"filename":"src/llvm/di_builder.cr","line_number":54,"url":null},"def":{"name":"insert_declare_at_end","args":[{"name":"storage","external_name":"storage","restriction":""},{"name":"var_info","external_name":"var_info","restriction":""},{"name":"expr","external_name":"expr","restriction":""},{"name":"dl","external_name":"dl","restriction":""},{"name":"block","external_name":"block","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_insert_declare_at_end(self, storage, var_info, expr, dl, block)"}},{"html_id":"replace_temporary(from,to)-instance-method","name":"replace_temporary","abstract":false,"args":[{"name":"from","external_name":"from","restriction":""},{"name":"to","external_name":"to","restriction":""}],"args_string":"(from, to)","args_html":"(from, to)","location":{"filename":"src/llvm/di_builder.cr","line_number":99,"url":null},"def":{"name":"replace_temporary","args":[{"name":"from","external_name":"from","restriction":""},{"name":"to","external_name":"to","restriction":""}],"visibility":"Public","body":"LibLLVMExt.di_builder_replace_temporary(self, from, to)"}},{"html_id":"to_unsafe:LibLLVMExt::DIBuilder-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/di_builder.cr","line_number":119,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}}]},{"html_id":"Crystal/LLVM/DIFlags","path":"LLVM/DIFlags.html","kind":"enum","full_name":"LLVM::DIFlags","name":"DIFlags","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":388,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Zero","name":"Zero","value":"0_u32"},{"id":"Private","name":"Private","value":"1_u32"},{"id":"Protected","name":"Protected","value":"2_u32"},{"id":"Public","name":"Public","value":"3_u32"},{"id":"FwdDecl","name":"FwdDecl","value":"4_u32"},{"id":"AppleBlock","name":"AppleBlock","value":"8_u32"},{"id":"BlockByrefStruct","name":"BlockByrefStruct","value":"16_u32"},{"id":"Virtual","name":"Virtual","value":"32_u32"},{"id":"Artificial","name":"Artificial","value":"64_u32"},{"id":"Explicit","name":"Explicit","value":"128_u32"},{"id":"Prototyped","name":"Prototyped","value":"256_u32"},{"id":"ObjcClassComplete","name":"ObjcClassComplete","value":"512_u32"},{"id":"ObjectPointer","name":"ObjectPointer","value":"1024_u32"},{"id":"Vector","name":"Vector","value":"2048_u32"},{"id":"StaticMember","name":"StaticMember","value":"4096_u32"},{"id":"LValueReference","name":"LValueReference","value":"8192_u32"},{"id":"RValueReference","name":"RValueReference","value":"16384_u32"},{"id":"ExternalTypeRef","name":"ExternalTypeRef","value":"32768_u32"},{"id":"SingleInheritance","name":"SingleInheritance","value":"65536_u32"},{"id":"MultipleInheritance","name":"MultipleInheritance","value":"131072_u32"},{"id":"VirtualInheritance","name":"VirtualInheritance","value":"196608_u32"},{"id":"IntroducedVirtual","name":"IntroducedVirtual","value":"262144_u32"},{"id":"BitField","name":"BitField","value":"524288_u32"},{"id":"NoReturn","name":"NoReturn","value":"1048576_u32"},{"id":"MainSubprogram","name":"MainSubprogram","value":"2097152_u32"},{"id":"PassByValue","name":"PassByValue","value":"4194304_u32"},{"id":"TypePassByReference","name":"TypePassByReference","value":"8388608_u32"},{"id":"EnumClass","name":"EnumClass","value":"16777216_u32"},{"id":"Thunk","name":"Thunk","value":"33554432_u32"},{"id":"NonTrivial","name":"NonTrivial","value":"67108864_u32"},{"id":"BigEndian","name":"BigEndian","value":"134217728_u32"},{"id":"LittleEndian","name":"LittleEndian","value":"268435456_u32"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"apple_block?-instance-method","name":"apple_block?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":394,"url":null},"def":{"name":"apple_block?","visibility":"Public","body":"self == AppleBlock"}},{"html_id":"artificial?-instance-method","name":"artificial?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":397,"url":null},"def":{"name":"artificial?","visibility":"Public","body":"self == Artificial"}},{"html_id":"big_endian?-instance-method","name":"big_endian?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":419,"url":null},"def":{"name":"big_endian?","visibility":"Public","body":"self == BigEndian"}},{"html_id":"bit_field?-instance-method","name":"bit_field?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":411,"url":null},"def":{"name":"bit_field?","visibility":"Public","body":"self == BitField"}},{"html_id":"block_byref_struct?-instance-method","name":"block_byref_struct?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":395,"url":null},"def":{"name":"block_byref_struct?","visibility":"Public","body":"self == BlockByrefStruct"}},{"html_id":"enum_class?-instance-method","name":"enum_class?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":416,"url":null},"def":{"name":"enum_class?","visibility":"Public","body":"self == EnumClass"}},{"html_id":"explicit?-instance-method","name":"explicit?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":398,"url":null},"def":{"name":"explicit?","visibility":"Public","body":"self == Explicit"}},{"html_id":"external_type_ref?-instance-method","name":"external_type_ref?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":406,"url":null},"def":{"name":"external_type_ref?","visibility":"Public","body":"self == ExternalTypeRef"}},{"html_id":"fwd_decl?-instance-method","name":"fwd_decl?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":393,"url":null},"def":{"name":"fwd_decl?","visibility":"Public","body":"self == FwdDecl"}},{"html_id":"introduced_virtual?-instance-method","name":"introduced_virtual?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":410,"url":null},"def":{"name":"introduced_virtual?","visibility":"Public","body":"self == IntroducedVirtual"}},{"html_id":"l_value_reference?-instance-method","name":"l_value_reference?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":404,"url":null},"def":{"name":"l_value_reference?","visibility":"Public","body":"self == LValueReference"}},{"html_id":"little_endian?-instance-method","name":"little_endian?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":420,"url":null},"def":{"name":"little_endian?","visibility":"Public","body":"self == LittleEndian"}},{"html_id":"main_subprogram?-instance-method","name":"main_subprogram?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":413,"url":null},"def":{"name":"main_subprogram?","visibility":"Public","body":"self == MainSubprogram"}},{"html_id":"multiple_inheritance?-instance-method","name":"multiple_inheritance?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":408,"url":null},"def":{"name":"multiple_inheritance?","visibility":"Public","body":"self == MultipleInheritance"}},{"html_id":"no_return?-instance-method","name":"no_return?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":412,"url":null},"def":{"name":"no_return?","visibility":"Public","body":"self == NoReturn"}},{"html_id":"non_trivial?-instance-method","name":"non_trivial?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":418,"url":null},"def":{"name":"non_trivial?","visibility":"Public","body":"self == NonTrivial"}},{"html_id":"objc_class_complete?-instance-method","name":"objc_class_complete?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":400,"url":null},"def":{"name":"objc_class_complete?","visibility":"Public","body":"self == ObjcClassComplete"}},{"html_id":"object_pointer?-instance-method","name":"object_pointer?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":401,"url":null},"def":{"name":"object_pointer?","visibility":"Public","body":"self == ObjectPointer"}},{"html_id":"pass_by_value?-instance-method","name":"pass_by_value?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":414,"url":null},"def":{"name":"pass_by_value?","visibility":"Public","body":"self == PassByValue"}},{"html_id":"private?-instance-method","name":"private?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":390,"url":null},"def":{"name":"private?","visibility":"Public","body":"self == Private"}},{"html_id":"protected?-instance-method","name":"protected?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":391,"url":null},"def":{"name":"protected?","visibility":"Public","body":"self == Protected"}},{"html_id":"prototyped?-instance-method","name":"prototyped?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":399,"url":null},"def":{"name":"prototyped?","visibility":"Public","body":"self == Prototyped"}},{"html_id":"public?-instance-method","name":"public?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":392,"url":null},"def":{"name":"public?","visibility":"Public","body":"self == Public"}},{"html_id":"r_value_reference?-instance-method","name":"r_value_reference?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":405,"url":null},"def":{"name":"r_value_reference?","visibility":"Public","body":"self == RValueReference"}},{"html_id":"single_inheritance?-instance-method","name":"single_inheritance?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":407,"url":null},"def":{"name":"single_inheritance?","visibility":"Public","body":"self == SingleInheritance"}},{"html_id":"static_member?-instance-method","name":"static_member?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":403,"url":null},"def":{"name":"static_member?","visibility":"Public","body":"self == StaticMember"}},{"html_id":"thunk?-instance-method","name":"thunk?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":417,"url":null},"def":{"name":"thunk?","visibility":"Public","body":"self == Thunk"}},{"html_id":"type_pass_by_reference?-instance-method","name":"type_pass_by_reference?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":415,"url":null},"def":{"name":"type_pass_by_reference?","visibility":"Public","body":"self == TypePassByReference"}},{"html_id":"vector?-instance-method","name":"vector?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":402,"url":null},"def":{"name":"vector?","visibility":"Public","body":"self == Vector"}},{"html_id":"virtual?-instance-method","name":"virtual?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":396,"url":null},"def":{"name":"virtual?","visibility":"Public","body":"self == Virtual"}},{"html_id":"virtual_inheritance?-instance-method","name":"virtual_inheritance?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":409,"url":null},"def":{"name":"virtual_inheritance?","visibility":"Public","body":"self == VirtualInheritance"}},{"html_id":"zero?-instance-method","name":"zero?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":389,"url":null},"def":{"name":"zero?","visibility":"Public","body":"self == Zero"}}]},{"html_id":"Crystal/LLVM/DLLStorageClass","path":"LLVM/DLLStorageClass.html","kind":"enum","full_name":"LLVM::DLLStorageClass","name":"DLLStorageClass","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":232,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Default","name":"Default","value":"0"},{"id":"DLLImport","name":"DLLImport","value":"1","doc":"Function to be imported from DLL.","summary":"<p>Function to be imported from DLL.</p>"},{"id":"DLLExport","name":"DLLExport","value":"2","doc":"Function to be accessible from DLL.","summary":"<p>Function to be accessible from DLL.</p>"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"default?-instance-method","name":"default?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":233,"url":null},"def":{"name":"default?","visibility":"Public","body":"self == Default"}},{"html_id":"dll_export?-instance-method","name":"dll_export?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":239,"url":null},"def":{"name":"dll_export?","visibility":"Public","body":"self == DLLExport"}},{"html_id":"dll_import?-instance-method","name":"dll_import?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":236,"url":null},"def":{"name":"dll_import?","visibility":"Public","body":"self == DLLImport"}}]},{"html_id":"Crystal/LLVM/DwarfTag","path":"LLVM/DwarfTag.html","kind":"enum","full_name":"LLVM::DwarfTag","name":"DwarfTag","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":339,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"AutoVariable","name":"AutoVariable","value":"256"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"auto_variable?-instance-method","name":"auto_variable?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":340,"url":null},"def":{"name":"auto_variable?","visibility":"Public","body":"self == AutoVariable"}}]},{"html_id":"Crystal/LLVM/DwarfTypeEncoding","path":"LLVM/DwarfTypeEncoding.html","kind":"enum","full_name":"LLVM::DwarfTypeEncoding","name":"DwarfTypeEncoding","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":343,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Address","name":"Address","value":"1"},{"id":"Boolean","name":"Boolean","value":"2"},{"id":"ComplexFloat","name":"ComplexFloat","value":"3"},{"id":"Float","name":"Float","value":"4"},{"id":"Signed","name":"Signed","value":"5"},{"id":"SignedChar","name":"SignedChar","value":"6"},{"id":"Unsigned","name":"Unsigned","value":"7"},{"id":"UnsignedChar","name":"UnsignedChar","value":"8"},{"id":"ImaginaryFloat","name":"ImaginaryFloat","value":"9"},{"id":"PackedDecimal","name":"PackedDecimal","value":"10"},{"id":"NumericString","name":"NumericString","value":"11"},{"id":"Edited","name":"Edited","value":"12"},{"id":"SignedFixed","name":"SignedFixed","value":"13"},{"id":"UnsignedFixed","name":"UnsignedFixed","value":"14"},{"id":"DecimalFloat","name":"DecimalFloat","value":"15"},{"id":"Utf","name":"Utf","value":"16"},{"id":"LoUser","name":"LoUser","value":"128"},{"id":"HiUser","name":"HiUser","value":"255"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"address?-instance-method","name":"address?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":344,"url":null},"def":{"name":"address?","visibility":"Public","body":"self == Address"}},{"html_id":"boolean?-instance-method","name":"boolean?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":345,"url":null},"def":{"name":"boolean?","visibility":"Public","body":"self == Boolean"}},{"html_id":"complex_float?-instance-method","name":"complex_float?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":346,"url":null},"def":{"name":"complex_float?","visibility":"Public","body":"self == ComplexFloat"}},{"html_id":"decimal_float?-instance-method","name":"decimal_float?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":358,"url":null},"def":{"name":"decimal_float?","visibility":"Public","body":"self == DecimalFloat"}},{"html_id":"edited?-instance-method","name":"edited?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":355,"url":null},"def":{"name":"edited?","visibility":"Public","body":"self == Edited"}},{"html_id":"float?-instance-method","name":"float?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":347,"url":null},"def":{"name":"float?","visibility":"Public","body":"self == Float"}},{"html_id":"hi_user?-instance-method","name":"hi_user?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":361,"url":null},"def":{"name":"hi_user?","visibility":"Public","body":"self == HiUser"}},{"html_id":"imaginary_float?-instance-method","name":"imaginary_float?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":352,"url":null},"def":{"name":"imaginary_float?","visibility":"Public","body":"self == ImaginaryFloat"}},{"html_id":"lo_user?-instance-method","name":"lo_user?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":360,"url":null},"def":{"name":"lo_user?","visibility":"Public","body":"self == LoUser"}},{"html_id":"numeric_string?-instance-method","name":"numeric_string?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":354,"url":null},"def":{"name":"numeric_string?","visibility":"Public","body":"self == NumericString"}},{"html_id":"packed_decimal?-instance-method","name":"packed_decimal?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":353,"url":null},"def":{"name":"packed_decimal?","visibility":"Public","body":"self == PackedDecimal"}},{"html_id":"signed?-instance-method","name":"signed?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":348,"url":null},"def":{"name":"signed?","visibility":"Public","body":"self == Signed"}},{"html_id":"signed_char?-instance-method","name":"signed_char?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":349,"url":null},"def":{"name":"signed_char?","visibility":"Public","body":"self == SignedChar"}},{"html_id":"signed_fixed?-instance-method","name":"signed_fixed?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":356,"url":null},"def":{"name":"signed_fixed?","visibility":"Public","body":"self == SignedFixed"}},{"html_id":"unsigned?-instance-method","name":"unsigned?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":350,"url":null},"def":{"name":"unsigned?","visibility":"Public","body":"self == Unsigned"}},{"html_id":"unsigned_char?-instance-method","name":"unsigned_char?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":351,"url":null},"def":{"name":"unsigned_char?","visibility":"Public","body":"self == UnsignedChar"}},{"html_id":"unsigned_fixed?-instance-method","name":"unsigned_fixed?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":357,"url":null},"def":{"name":"unsigned_fixed?","visibility":"Public","body":"self == UnsignedFixed"}},{"html_id":"utf?-instance-method","name":"utf?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":359,"url":null},"def":{"name":"utf?","visibility":"Public","body":"self == Utf"}}]},{"html_id":"Crystal/LLVM/Function","path":"LLVM/Function.html","kind":"struct","full_name":"LLVM::Function","name":"Function","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/LLVM/ValueMethods","kind":"module","full_name":"LLVM::ValueMethods","name":"ValueMethods"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/function.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/LLVM/ValueMethods","kind":"module","full_name":"LLVM::ValueMethods","name":"ValueMethods"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"class_methods":[{"html_id":"from_value(value:LLVM::ValueMethods)-class-method","name":"from_value","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"LLVM::ValueMethods"}],"args_string":"(value : LLVM::ValueMethods)","args_html":"(value : <a href=\"../LLVM/ValueMethods.html\">LLVM::ValueMethods</a>)","location":{"filename":"src/llvm/function.cr","line_number":6,"url":null},"def":{"name":"from_value","args":[{"name":"value","external_name":"value","restriction":"LLVM::ValueMethods"}],"visibility":"Public","body":"new(value.to_unsafe)"}}],"instance_methods":[{"html_id":"add_attribute(attribute:Attribute,index=AttributeIndex::FunctionIndex,type:Type?=nil)-instance-method","name":"add_attribute","abstract":false,"args":[{"name":"attribute","external_name":"attribute","restriction":"Attribute"},{"name":"index","default_value":"AttributeIndex::FunctionIndex","external_name":"index","restriction":""},{"name":"type","default_value":"nil","external_name":"type","restriction":"Type | ::Nil"}],"args_string":"(attribute : Attribute, index = AttributeIndex::FunctionIndex, type : Type? = nil)","args_html":"(attribute : <a href=\"../LLVM/Attribute.html\">Attribute</a>, index = <span class=\"t\">AttributeIndex</span><span class=\"t\">::</span><span class=\"t\">FunctionIndex</span>, type : <a href=\"../LLVM/Type.html\">Type</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/llvm/function.cr","line_number":22,"url":null},"def":{"name":"add_attribute","args":[{"name":"attribute","external_name":"attribute","restriction":"Attribute"},{"name":"index","default_value":"AttributeIndex::FunctionIndex","external_name":"index","restriction":""},{"name":"type","default_value":"nil","external_name":"type","restriction":"Type | ::Nil"}],"visibility":"Public","body":"if attribute.value == 0\n  return\nend\n{% if LibLLVM.has_constant?(:AttributeRef) %}\n      context = LibLLVM.get_module_context(LibLLVM.get_global_parent(self))\n      attribute.each_kind do |kind|\n        if type && LLVM::Attribute.requires_type?(kind)\n          attribute_ref = LibLLVMExt.create_type_attribute(context, kind, type)\n        else\n          attribute_ref = LibLLVM.create_enum_attribute(context, kind, 0)\n        end\n        LibLLVM.add_attribute_at_index(self, index, attribute_ref)\n      end\n    {% else %}\n      case index\n      when AttributeIndex::FunctionIndex\n        LibLLVM.add_function_attr(self, attribute)\n      when AttributeIndex::ReturnIndex\n        raise \"Unsupported: can't set attributes on function return type in LLVM < 3.9\"\n      else\n        LibLLVM.add_attribute(params[index.to_i - 1], attribute)\n      end\n    {% end %}\n"}},{"html_id":"add_target_dependent_attribute(name,value)-instance-method","name":"add_target_dependent_attribute","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"value","external_name":"value","restriction":""}],"args_string":"(name, value)","args_html":"(name, value)","location":{"filename":"src/llvm/function.cr","line_number":46,"url":null},"def":{"name":"add_target_dependent_attribute","args":[{"name":"name","external_name":"name","restriction":""},{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"LibLLVM.add_target_dependent_function_attr(self, name, value)"}},{"html_id":"attributes(index=AttributeIndex::FunctionIndex)-instance-method","name":"attributes","abstract":false,"args":[{"name":"index","default_value":"AttributeIndex::FunctionIndex","external_name":"index","restriction":""}],"args_string":"(index = AttributeIndex::FunctionIndex)","args_html":"(index = <span class=\"t\">AttributeIndex</span><span class=\"t\">::</span><span class=\"t\">FunctionIndex</span>)","location":{"filename":"src/llvm/function.cr","line_number":50,"url":null},"def":{"name":"attributes","args":[{"name":"index","default_value":"AttributeIndex::FunctionIndex","external_name":"index","restriction":""}],"visibility":"Public","body":"{% if LibLLVM.has_constant?(:AttributeRef) %}\n      attrs = Attribute::None\n      0.upto(LibLLVM.get_last_enum_attribute_kind) do |kind|\n        if LibLLVM.get_enum_attribute_at_index(self, index, kind)\n          attrs |= Attribute.from_kind(kind)\n        end\n      end\n      attrs\n    {% else %}\n      case index\n      when AttributeIndex::FunctionIndex\n        LibLLVM.get_function_attr(self)\n      when AttributeIndex::ReturnIndex\n        raise \"Unsupported: can't get attributes from function return type in LLVM < 3.9\"\n      else\n        LibLLVM.get_attribute(params[index.to_i - 1])\n      end\n    {% end %}"}},{"html_id":"basic_blocks-instance-method","name":"basic_blocks","abstract":false,"location":{"filename":"src/llvm/function.cr","line_number":10,"url":null},"def":{"name":"basic_blocks","visibility":"Public","body":"BasicBlockCollection.new(self)"}},{"html_id":"call_convention-instance-method","name":"call_convention","abstract":false,"location":{"filename":"src/llvm/function.cr","line_number":14,"url":null},"def":{"name":"call_convention","visibility":"Public","body":"LLVM::CallConvention.new(LibLLVM.get_function_call_convention(self))"}},{"html_id":"call_convention=(cc)-instance-method","name":"call_convention=","abstract":false,"args":[{"name":"cc","external_name":"cc","restriction":""}],"args_string":"(cc)","args_html":"(cc)","location":{"filename":"src/llvm/function.cr","line_number":18,"url":null},"def":{"name":"call_convention=","args":[{"name":"cc","external_name":"cc","restriction":""}],"visibility":"Public","body":"LibLLVM.set_function_call_convention(self, cc)"}},{"html_id":"delete-instance-method","name":"delete","abstract":false,"location":{"filename":"src/llvm/function.cr","line_number":91,"url":null},"def":{"name":"delete","visibility":"Public","body":"LibLLVM.delete_function(self)"}},{"html_id":"function_type-instance-method","name":"function_type","abstract":false,"location":{"filename":"src/llvm/function.cr","line_number":71,"url":null},"def":{"name":"function_type","visibility":"Public","body":"Type.new(LibLLVM.get_element_type(LibLLVM.type_of(self)))"}},{"html_id":"naked?-instance-method","name":"naked?","abstract":false,"location":{"filename":"src/llvm/function.cr","line_number":95,"url":null},"def":{"name":"naked?","visibility":"Public","body":"attributes.naked?"}},{"html_id":"params-instance-method","name":"params","abstract":false,"location":{"filename":"src/llvm/function.cr","line_number":83,"url":null},"def":{"name":"params","visibility":"Public","body":"ParameterCollection.new(self)"}},{"html_id":"personality_function=(fn)-instance-method","name":"personality_function=","abstract":false,"args":[{"name":"fn","external_name":"fn","restriction":""}],"args_string":"(fn)","args_html":"(fn)","location":{"filename":"src/llvm/function.cr","line_number":87,"url":null},"def":{"name":"personality_function=","args":[{"name":"fn","external_name":"fn","restriction":""}],"visibility":"Public","body":"LibLLVM.set_personality_fn(self, fn)"}},{"html_id":"return_type-instance-method","name":"return_type","abstract":false,"location":{"filename":"src/llvm/function.cr","line_number":75,"url":null},"def":{"name":"return_type","visibility":"Public","body":"function_type.return_type"}},{"html_id":"varargs?-instance-method","name":"varargs?","abstract":false,"location":{"filename":"src/llvm/function.cr","line_number":79,"url":null},"def":{"name":"varargs?","visibility":"Public","body":"function_type.varargs?"}}]},{"html_id":"Crystal/LLVM/FunctionCollection","path":"LLVM/FunctionCollection.html","kind":"struct","full_name":"LLVM::FunctionCollection","name":"FunctionCollection","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/function_collection.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new(mod:Module)-class-method","name":"new","abstract":false,"args":[{"name":"mod","external_name":"mod","restriction":"Module"}],"args_string":"(mod : Module)","args_html":"(mod : <a href=\"../LLVM/Module.html\">Module</a>)","location":{"filename":"src/llvm/function_collection.cr","line_number":2,"url":null},"def":{"name":"new","args":[{"name":"mod","external_name":"mod","restriction":"Module"}],"visibility":"Public","body":"_ = allocate\n_.initialize(mod)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"[](name)-instance-method","name":"[]","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name)","args_html":"(name)","location":{"filename":"src/llvm/function_collection.cr","line_number":19,"url":null},"def":{"name":"[]","args":[{"name":"name","external_name":"name","restriction":""}],"visibility":"Public","body":"func = self[name]?\nfunc || (raise(\"Undefined llvm function: #{name}\"))\n"}},{"html_id":"[]?(name)-instance-method","name":"[]?","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name)","args_html":"(name)","location":{"filename":"src/llvm/function_collection.cr","line_number":24,"url":null},"def":{"name":"[]?","args":[{"name":"name","external_name":"name","restriction":""}],"visibility":"Public","body":"func = LibLLVM.get_named_function(@mod, name)\nfunc ? Function.new(func) : nil\n"}},{"html_id":"add(name,arg_types:Array(LLVM::Type),ret_type,varargs=false)-instance-method","name":"add","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"arg_types","external_name":"arg_types","restriction":"Array(LLVM::Type)"},{"name":"ret_type","external_name":"ret_type","restriction":""},{"name":"varargs","default_value":"false","external_name":"varargs","restriction":""}],"args_string":"(name, arg_types : Array(LLVM::Type), ret_type, varargs = false)","args_html":"(name, arg_types : <a href=\"../Array.html\">Array</a>(<a href=\"../LLVM/Type.html\">LLVM::Type</a>), ret_type, varargs = <span class=\"n\">false</span>)","location":{"filename":"src/llvm/function_collection.cr","line_number":5,"url":null},"def":{"name":"add","args":[{"name":"name","external_name":"name","restriction":""},{"name":"arg_types","external_name":"arg_types","restriction":"Array(LLVM::Type)"},{"name":"ret_type","external_name":"ret_type","restriction":""},{"name":"varargs","default_value":"false","external_name":"varargs","restriction":""}],"visibility":"Public","body":"fun_type = LLVM::Type.function(arg_types, ret_type, varargs)\nfunc = LibLLVM.add_function(@mod, name, fun_type)\nFunction.new(func)\n"}},{"html_id":"add(name,arg_types:Array(LLVM::Type),ret_type,varargs=false,&)-instance-method","name":"add","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"arg_types","external_name":"arg_types","restriction":"Array(LLVM::Type)"},{"name":"ret_type","external_name":"ret_type","restriction":""},{"name":"varargs","default_value":"false","external_name":"varargs","restriction":""}],"args_string":"(name, arg_types : Array(LLVM::Type), ret_type, varargs = false, &)","args_html":"(name, arg_types : <a href=\"../Array.html\">Array</a>(<a href=\"../LLVM/Type.html\">LLVM::Type</a>), ret_type, varargs = <span class=\"n\">false</span>, &)","location":{"filename":"src/llvm/function_collection.cr","line_number":13,"url":null},"def":{"name":"add","args":[{"name":"name","external_name":"name","restriction":""},{"name":"arg_types","external_name":"arg_types","restriction":"Array(LLVM::Type)"},{"name":"ret_type","external_name":"ret_type","restriction":""},{"name":"varargs","default_value":"false","external_name":"varargs","restriction":""}],"yields":1,"visibility":"Public","body":"func = add(name, arg_types, ret_type, varargs)\nyield func\nfunc\n"}},{"html_id":"each(&):Nil-instance-method","name":"each","abstract":false,"location":{"filename":"src/llvm/function_collection.cr","line_number":29,"url":null},"def":{"name":"each","yields":1,"return_type":"Nil","visibility":"Public","body":"f = LibLLVM.get_first_function(@mod)\nwhile f\n  yield LLVM::Function.new(f)\n  f = LibLLVM.get_next_function(f)\nend\n"}}]},{"html_id":"Crystal/LLVM/FunctionPassManager","path":"LLVM/FunctionPassManager.html","kind":"class","full_name":"LLVM::FunctionPassManager","name":"FunctionPassManager","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/function_pass_manager.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new(unwrap:LibLLVM::PassManagerRef)-class-method","name":"new","abstract":false,"args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::PassManagerRef"}],"args_string":"(unwrap : LibLLVM::PassManagerRef)","args_html":"(unwrap : LibLLVM::PassManagerRef)","location":{"filename":"src/llvm/function_pass_manager.cr","line_number":2,"url":null},"def":{"name":"new","args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::PassManagerRef"}],"visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/llvm/function_pass_manager.cr","line_number":30,"url":null},"def":{"name":"finalize","visibility":"Public","body":"LibLLVM.dispose_pass_manager(@unwrap)"}},{"html_id":"run(mod:Module)-instance-method","name":"run","abstract":false,"args":[{"name":"mod","external_name":"mod","restriction":"Module"}],"args_string":"(mod : Module)","args_html":"(mod : <a href=\"../LLVM/Module.html\">Module</a>)","location":{"filename":"src/llvm/function_pass_manager.cr","line_number":5,"url":null},"def":{"name":"run","args":[{"name":"mod","external_name":"mod","restriction":"Module"}],"visibility":"Public","body":"changed = false\nrun do |runner|\n  mod.functions.each do |func|\n    changed || (changed = runner.run(func))\n  end\nend\nchanged\n"}},{"html_id":"run(&)-instance-method","name":"run","abstract":false,"location":{"filename":"src/llvm/function_pass_manager.cr","line_number":15,"url":null},"def":{"name":"run","yields":1,"visibility":"Public","body":"LibLLVM.initialize_function_pass_manager(self)\nrunner = Runner.new(self)\nyield runner\nLibLLVM.finalize_function_pass_manager(self)\nself\n"}},{"html_id":"to_unsafe:LibLLVM::PassManagerRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/function_pass_manager.cr","line_number":26,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}}],"types":[{"html_id":"Crystal/LLVM/FunctionPassManager/Runner","path":"LLVM/FunctionPassManager/Runner.html","kind":"struct","full_name":"LLVM::FunctionPassManager::Runner","name":"Runner","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/function_pass_manager.cr","line_number":34,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM/FunctionPassManager","kind":"class","full_name":"LLVM::FunctionPassManager","name":"FunctionPassManager"},"constructors":[{"html_id":"new(fpm)-class-method","name":"new","abstract":false,"args":[{"name":"fpm","external_name":"fpm","restriction":""}],"args_string":"(fpm)","args_html":"(fpm)","location":{"filename":"src/llvm/function_pass_manager.cr","line_number":37,"url":null},"def":{"name":"new","args":[{"name":"fpm","external_name":"fpm","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(fpm)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"run(f:LLVM::Function)-instance-method","name":"run","abstract":false,"args":[{"name":"f","external_name":"f","restriction":"LLVM::Function"}],"args_string":"(f : LLVM::Function)","args_html":"(f : <a href=\"../../LLVM/Function.html\">LLVM::Function</a>)","location":{"filename":"src/llvm/function_pass_manager.cr","line_number":40,"url":null},"def":{"name":"run","args":[{"name":"f","external_name":"f","restriction":"LLVM::Function"}],"visibility":"Public","body":"(LibLLVM.run_function_pass_manager(@fpm, f)) != 0"}}]}]},{"html_id":"Crystal/LLVM/GenericValue","path":"LLVM/GenericValue.html","kind":"class","full_name":"LLVM::GenericValue","name":"GenericValue","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/generic_value.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new(unwrap:LibLLVM::GenericValueRef,context:LLVM::Context)-class-method","name":"new","abstract":false,"args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::GenericValueRef"},{"name":"context","external_name":"context","restriction":"LLVM::Context"}],"args_string":"(unwrap : LibLLVM::GenericValueRef, context : LLVM::Context)","args_html":"(unwrap : LibLLVM::GenericValueRef, context : <a href=\"../LLVM/Context.html\">LLVM::Context</a>)","location":{"filename":"src/llvm/generic_value.cr","line_number":2,"url":null},"def":{"name":"new","args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::GenericValueRef"},{"name":"context","external_name":"context","restriction":"LLVM::Context"}],"visibility":"Public","body":"_ = allocate\n_.initialize(unwrap, context)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/llvm/generic_value.cr","line_number":41,"url":null},"def":{"name":"finalize","visibility":"Public","body":"LibLLVM.dispose_generic_value(@unwrap)"}},{"html_id":"to_b:Bool-instance-method","name":"to_b","abstract":false,"location":{"filename":"src/llvm/generic_value.cr","line_number":17,"url":null},"def":{"name":"to_b","return_type":"Bool","visibility":"Public","body":"to_i != 0"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","abstract":false,"location":{"filename":"src/llvm/generic_value.cr","line_number":21,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"(LibLLVM.generic_value_to_float(@context.float, self)).to_f32"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","abstract":false,"location":{"filename":"src/llvm/generic_value.cr","line_number":25,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"LibLLVM.generic_value_to_float(@context.double, self)"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","abstract":false,"location":{"filename":"src/llvm/generic_value.cr","line_number":5,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"to_i64.to_i32!"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","abstract":false,"location":{"filename":"src/llvm/generic_value.cr","line_number":9,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"(LibLLVM.generic_value_to_int(self, signed: 1)).unsafe_as(Int64)"}},{"html_id":"to_pointer:Pointer(Void)-instance-method","name":"to_pointer","abstract":false,"location":{"filename":"src/llvm/generic_value.cr","line_number":33,"url":null},"def":{"name":"to_pointer","return_type":"::Pointer(Void)","visibility":"Public","body":"LibLLVM.generic_value_to_pointer(self)"}},{"html_id":"to_string:String-instance-method","name":"to_string","abstract":false,"location":{"filename":"src/llvm/generic_value.cr","line_number":29,"url":null},"def":{"name":"to_string","return_type":"String","visibility":"Public","body":"to_pointer.as(String)"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","abstract":false,"location":{"filename":"src/llvm/generic_value.cr","line_number":13,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"LibLLVM.generic_value_to_int(self, signed: 0)"}},{"html_id":"to_unsafe:LibLLVM::GenericValueRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/generic_value.cr","line_number":37,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}}]},{"html_id":"Crystal/LLVM/GlobalCollection","path":"LLVM/GlobalCollection.html","kind":"struct","full_name":"LLVM::GlobalCollection","name":"GlobalCollection","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/global_collection.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new(mod:Module)-class-method","name":"new","abstract":false,"args":[{"name":"mod","external_name":"mod","restriction":"Module"}],"args_string":"(mod : Module)","args_html":"(mod : <a href=\"../LLVM/Module.html\">Module</a>)","location":{"filename":"src/llvm/global_collection.cr","line_number":2,"url":null},"def":{"name":"new","args":[{"name":"mod","external_name":"mod","restriction":"Module"}],"visibility":"Public","body":"_ = allocate\n_.initialize(mod)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"[](name)-instance-method","name":"[]","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name)","args_html":"(name)","location":{"filename":"src/llvm/global_collection.cr","line_number":16,"url":null},"def":{"name":"[]","args":[{"name":"name","external_name":"name","restriction":""}],"visibility":"Public","body":"global = self[name]?\nif global\n  global\nelse\n  raise(\"Global not found: #{name}\")\nend\n"}},{"html_id":"[]?(name)-instance-method","name":"[]?","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name)","args_html":"(name)","location":{"filename":"src/llvm/global_collection.cr","line_number":11,"url":null},"def":{"name":"[]?","args":[{"name":"name","external_name":"name","restriction":""}],"visibility":"Public","body":"global = LibLLVM.get_named_global(@mod, name)\nglobal ? Value.new(global) : nil\n"}},{"html_id":"add(type,name)-instance-method","name":"add","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""},{"name":"name","external_name":"name","restriction":""}],"args_string":"(type, name)","args_html":"(type, name)","location":{"filename":"src/llvm/global_collection.cr","line_number":5,"url":null},"def":{"name":"add","args":[{"name":"type","external_name":"type","restriction":""},{"name":"name","external_name":"name","restriction":""}],"visibility":"Public","body":"Value.new(LibLLVM.add_global(@mod, type, name))"}}]},{"html_id":"Crystal/LLVM/InstructionCollection","path":"LLVM/InstructionCollection.html","kind":"struct","full_name":"LLVM::InstructionCollection","name":"InstructionCollection","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/instruction_collection.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new(basic_block:BasicBlock)-class-method","name":"new","abstract":false,"args":[{"name":"basic_block","external_name":"basic_block","restriction":"BasicBlock"}],"args_string":"(basic_block : BasicBlock)","args_html":"(basic_block : <a href=\"../LLVM/BasicBlock.html\">BasicBlock</a>)","location":{"filename":"src/llvm/instruction_collection.cr","line_number":4,"url":null},"def":{"name":"new","args":[{"name":"basic_block","external_name":"basic_block","restriction":"BasicBlock"}],"visibility":"Public","body":"_ = allocate\n_.initialize(basic_block)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"each(&):Nil-instance-method","name":"each","doc":"Must yield this collection's elements to the block.","summary":"<p>Must yield this collection's elements to the block.</p>","abstract":false,"location":{"filename":"src/llvm/instruction_collection.cr","line_number":11,"url":null},"def":{"name":"each","yields":1,"return_type":"Nil","visibility":"Public","body":"inst = LibLLVM.get_first_instruction(@basic_block)\nwhile inst\n  yield LLVM::Value.new(inst)\n  inst = LibLLVM.get_next_instruction(inst)\nend\n"}},{"html_id":"empty?-instance-method","name":"empty?","doc":"Returns `true` if `self` is empty, `false` otherwise.\n\n```\n([] of Int32).empty? # => true\n([1]).empty?         # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is empty, <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/llvm/instruction_collection.cr","line_number":7,"url":null},"def":{"name":"empty?","visibility":"Public","body":"first?.nil?"}}]},{"html_id":"Crystal/LLVM/IntPredicate","path":"LLVM/IntPredicate.html","kind":"enum","full_name":"LLVM::IntPredicate","name":"IntPredicate","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":242,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"EQ","name":"EQ","value":"32"},{"id":"NE","name":"NE","value":"33"},{"id":"UGT","name":"UGT","value":"34"},{"id":"UGE","name":"UGE","value":"35"},{"id":"ULT","name":"ULT","value":"36"},{"id":"ULE","name":"ULE","value":"37"},{"id":"SGT","name":"SGT","value":"38"},{"id":"SGE","name":"SGE","value":"39"},{"id":"SLT","name":"SLT","value":"40"},{"id":"SLE","name":"SLE","value":"41"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"eq?-instance-method","name":"eq?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":243,"url":null},"def":{"name":"eq?","visibility":"Public","body":"self == EQ"}},{"html_id":"ne?-instance-method","name":"ne?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":244,"url":null},"def":{"name":"ne?","visibility":"Public","body":"self == NE"}},{"html_id":"sge?-instance-method","name":"sge?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":250,"url":null},"def":{"name":"sge?","visibility":"Public","body":"self == SGE"}},{"html_id":"sgt?-instance-method","name":"sgt?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":249,"url":null},"def":{"name":"sgt?","visibility":"Public","body":"self == SGT"}},{"html_id":"sle?-instance-method","name":"sle?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":252,"url":null},"def":{"name":"sle?","visibility":"Public","body":"self == SLE"}},{"html_id":"slt?-instance-method","name":"slt?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":251,"url":null},"def":{"name":"slt?","visibility":"Public","body":"self == SLT"}},{"html_id":"uge?-instance-method","name":"uge?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":246,"url":null},"def":{"name":"uge?","visibility":"Public","body":"self == UGE"}},{"html_id":"ugt?-instance-method","name":"ugt?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":245,"url":null},"def":{"name":"ugt?","visibility":"Public","body":"self == UGT"}},{"html_id":"ule?-instance-method","name":"ule?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":248,"url":null},"def":{"name":"ule?","visibility":"Public","body":"self == ULE"}},{"html_id":"ult?-instance-method","name":"ult?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":247,"url":null},"def":{"name":"ult?","visibility":"Public","body":"self == ULT"}}]},{"html_id":"Crystal/LLVM/JITCompiler","path":"LLVM/JITCompiler.html","kind":"class","full_name":"LLVM::JITCompiler","name":"JITCompiler","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/jit_compiler.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new(mod)-class-method","name":"new","abstract":false,"args":[{"name":"mod","external_name":"mod","restriction":""}],"args_string":"(mod)","args_html":"(mod)","location":{"filename":"src/llvm/jit_compiler.cr","line_number":2,"url":null},"def":{"name":"new","args":[{"name":"mod","external_name":"mod","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(mod)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(mod,&)-class-method","name":"new","abstract":false,"args":[{"name":"mod","external_name":"mod","restriction":""}],"args_string":"(mod, &)","args_html":"(mod, &)","location":{"filename":"src/llvm/jit_compiler.cr","line_number":15,"url":null},"def":{"name":"new","args":[{"name":"mod","external_name":"mod","restriction":""}],"yields":1,"visibility":"Public","body":"jit = new(mod)\nbegin\n  yield jit\nensure\n  jit.dispose\nend\n"}}],"instance_methods":[{"html_id":"dispose-instance-method","name":"dispose","abstract":false,"location":{"filename":"src/llvm/jit_compiler.cr","line_number":38,"url":null},"def":{"name":"dispose","visibility":"Public","body":"if @finalized\n  return\nend\n@finalized = true\nfinalize\n"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/llvm/jit_compiler.cr","line_number":44,"url":null},"def":{"name":"finalize","visibility":"Public","body":"if @finalized\n  return\nend\nLibLLVM.dispose_execution_engine(@unwrap)\n"}},{"html_id":"get_pointer_to_global(value)-instance-method","name":"get_pointer_to_global","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/llvm/jit_compiler.cr","line_number":30,"url":null},"def":{"name":"get_pointer_to_global","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"LibLLVM.get_pointer_to_global(self, value)"}},{"html_id":"run_function(func,args:Array(LLVM::GenericValue),context:Context)-instance-method","name":"run_function","abstract":false,"args":[{"name":"func","external_name":"func","restriction":""},{"name":"args","external_name":"args","restriction":"Array(LLVM::GenericValue)"},{"name":"context","external_name":"context","restriction":"Context"}],"args_string":"(func, args : Array(LLVM::GenericValue), context : Context)","args_html":"(func, args : <a href=\"../Array.html\">Array</a>(<a href=\"../LLVM/GenericValue.html\">LLVM::GenericValue</a>), context : <a href=\"../LLVM/Context.html\">Context</a>)","location":{"filename":"src/llvm/jit_compiler.cr","line_number":25,"url":null},"def":{"name":"run_function","args":[{"name":"func","external_name":"func","restriction":""},{"name":"args","external_name":"args","restriction":"Array(LLVM::GenericValue)"},{"name":"context","external_name":"context","restriction":"Context"}],"visibility":"Public","body":"ret = LibLLVM.run_function(self, func, args.size, (args.to_unsafe.as(::Pointer(LibLLVM::GenericValueRef))))\nGenericValue.new(ret, context)\n"}},{"html_id":"run_function(func,context:Context)-instance-method","name":"run_function","abstract":false,"args":[{"name":"func","external_name":"func","restriction":""},{"name":"context","external_name":"context","restriction":"Context"}],"args_string":"(func, context : Context)","args_html":"(func, context : <a href=\"../LLVM/Context.html\">Context</a>)","location":{"filename":"src/llvm/jit_compiler.cr","line_number":20,"url":null},"def":{"name":"run_function","args":[{"name":"func","external_name":"func","restriction":""},{"name":"context","external_name":"context","restriction":"Context"}],"visibility":"Public","body":"ret = LibLLVM.run_function(self, func, 0, nil)\nGenericValue.new(ret, context)\n"}},{"html_id":"to_unsafe:LibLLVM::ExecutionEngineRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/jit_compiler.cr","line_number":34,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}}]},{"html_id":"Crystal/LLVM/Linkage","path":"LLVM/Linkage.html","kind":"enum","full_name":"LLVM::Linkage","name":"Linkage","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":212,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"External","name":"External","value":"0"},{"id":"AvailableExternally","name":"AvailableExternally","value":"1"},{"id":"LinkOnceAny","name":"LinkOnceAny","value":"2"},{"id":"LinkOnceODR","name":"LinkOnceODR","value":"3"},{"id":"LinkOnceODRAutoHide","name":"LinkOnceODRAutoHide","value":"4"},{"id":"WeakAny","name":"WeakAny","value":"5"},{"id":"WeakODR","name":"WeakODR","value":"6"},{"id":"Appending","name":"Appending","value":"7"},{"id":"Internal","name":"Internal","value":"8"},{"id":"Private","name":"Private","value":"9"},{"id":"DLLImport","name":"DLLImport","value":"10"},{"id":"DLLExport","name":"DLLExport","value":"11","doc":"obsolete","summary":"<p>obsolete</p>"},{"id":"ExternalWeak","name":"ExternalWeak","value":"12","doc":"obsolete","summary":"<p>obsolete</p>"},{"id":"Ghost","name":"Ghost","value":"13"},{"id":"Common","name":"Common","value":"14"},{"id":"LinkerPrivate","name":"LinkerPrivate","value":"15"},{"id":"LinkerPrivateWeak","name":"LinkerPrivateWeak","value":"16"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"appending?-instance-method","name":"appending?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":220,"url":null},"def":{"name":"appending?","visibility":"Public","body":"self == Appending"}},{"html_id":"available_externally?-instance-method","name":"available_externally?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":214,"url":null},"def":{"name":"available_externally?","visibility":"Public","body":"self == AvailableExternally"}},{"html_id":"common?-instance-method","name":"common?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":227,"url":null},"def":{"name":"common?","visibility":"Public","body":"self == Common"}},{"html_id":"dll_export?-instance-method","name":"dll_export?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":224,"url":null},"def":{"name":"dll_export?","visibility":"Public","body":"self == DLLExport"}},{"html_id":"dll_import?-instance-method","name":"dll_import?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":223,"url":null},"def":{"name":"dll_import?","visibility":"Public","body":"self == DLLImport"}},{"html_id":"external?-instance-method","name":"external?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":213,"url":null},"def":{"name":"external?","visibility":"Public","body":"self == External"}},{"html_id":"external_weak?-instance-method","name":"external_weak?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":225,"url":null},"def":{"name":"external_weak?","visibility":"Public","body":"self == ExternalWeak"}},{"html_id":"ghost?-instance-method","name":"ghost?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":226,"url":null},"def":{"name":"ghost?","visibility":"Public","body":"self == Ghost"}},{"html_id":"internal?-instance-method","name":"internal?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":221,"url":null},"def":{"name":"internal?","visibility":"Public","body":"self == Internal"}},{"html_id":"link_once_any?-instance-method","name":"link_once_any?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":215,"url":null},"def":{"name":"link_once_any?","visibility":"Public","body":"self == LinkOnceAny"}},{"html_id":"link_once_odr?-instance-method","name":"link_once_odr?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":216,"url":null},"def":{"name":"link_once_odr?","visibility":"Public","body":"self == LinkOnceODR"}},{"html_id":"link_once_odr_auto_hide?-instance-method","name":"link_once_odr_auto_hide?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":217,"url":null},"def":{"name":"link_once_odr_auto_hide?","visibility":"Public","body":"self == LinkOnceODRAutoHide"}},{"html_id":"linker_private?-instance-method","name":"linker_private?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":228,"url":null},"def":{"name":"linker_private?","visibility":"Public","body":"self == LinkerPrivate"}},{"html_id":"linker_private_weak?-instance-method","name":"linker_private_weak?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":229,"url":null},"def":{"name":"linker_private_weak?","visibility":"Public","body":"self == LinkerPrivateWeak"}},{"html_id":"private?-instance-method","name":"private?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":222,"url":null},"def":{"name":"private?","visibility":"Public","body":"self == Private"}},{"html_id":"weak_any?-instance-method","name":"weak_any?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":218,"url":null},"def":{"name":"weak_any?","visibility":"Public","body":"self == WeakAny"}},{"html_id":"weak_odr?-instance-method","name":"weak_odr?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":219,"url":null},"def":{"name":"weak_odr?","visibility":"Public","body":"self == WeakODR"}}]},{"html_id":"Crystal/LLVM/MemoryBuffer","path":"LLVM/MemoryBuffer.html","kind":"class","full_name":"LLVM::MemoryBuffer","name":"MemoryBuffer","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/memory_buffer.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"class_methods":[{"html_id":"from_file(filename:String)-class-method","name":"from_file","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"}],"args_string":"(filename : String)","args_html":"(filename : <a href=\"../String.html\">String</a>)","location":{"filename":"src/llvm/memory_buffer.cr","line_number":2,"url":null},"def":{"name":"from_file","args":[{"name":"filename","external_name":"filename","restriction":"String"}],"visibility":"Public","body":"ret = LibLLVM.create_memory_buffer_with_contents_of_file(filename, out mem_buf, out msg)\nif (ret != 0) && msg\n  raise(LLVM.string_and_dispose(msg))\nend\nnew(mem_buf)\n"}}],"constructors":[{"html_id":"new(unwrap:LibLLVM::MemoryBufferRef)-class-method","name":"new","abstract":false,"args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::MemoryBufferRef"}],"args_string":"(unwrap : LibLLVM::MemoryBufferRef)","args_html":"(unwrap : LibLLVM::MemoryBufferRef)","location":{"filename":"src/llvm/memory_buffer.cr","line_number":10,"url":null},"def":{"name":"new","args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::MemoryBufferRef"}],"visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"dispose-instance-method","name":"dispose","abstract":false,"location":{"filename":"src/llvm/memory_buffer.cr","line_number":21,"url":null},"def":{"name":"dispose","visibility":"Public","body":"if @finalized\n  return\nend\n@finalized = true\nfinalize\n"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/llvm/memory_buffer.cr","line_number":27,"url":null},"def":{"name":"finalize","visibility":"Public","body":"if @finalized\n  return\nend\nLibLLVM.dispose_memory_buffer(@unwrap)\n"}},{"html_id":"to_slice-instance-method","name":"to_slice","abstract":false,"location":{"filename":"src/llvm/memory_buffer.cr","line_number":14,"url":null},"def":{"name":"to_slice","visibility":"Public","body":"Slice.new(LibLLVM.get_buffer_start(@unwrap), LibLLVM.get_buffer_size(@unwrap))"}},{"html_id":"to_unsafe:LibLLVM::MemoryBufferRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/memory_buffer.cr","line_number":33,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}}]},{"html_id":"Crystal/LLVM/Metadata","path":"LLVM/Metadata.html","kind":"struct","full_name":"LLVM::Metadata","name":"Metadata","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":461,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":461,"url":null},"def":{"name":"new","visibility":"Public","body":"x = allocate\nif x.responds_to?(:finalize)\n  ::GC.add_finalizer(x)\nend\nx\n"}}],"instance_methods":[{"html_id":"initialize-instance-method","name":"initialize","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":461,"url":null},"def":{"name":"initialize","visibility":"Public","body":""}}],"types":[{"html_id":"Crystal/LLVM/Metadata/Type","path":"LLVM/Metadata/Type.html","kind":"enum","full_name":"LLVM::Metadata::Type","name":"Type","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":462,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Dbg","name":"Dbg","value":"0_u32"},{"id":"Tbaa","name":"Tbaa","value":"1_u32","doc":"\"dbg\"","summary":"<p>&quot;dbg&quot;</p>"},{"id":"Prof","name":"Prof","value":"2_u32","doc":"\"tbaa\"","summary":"<p>&quot;tbaa&quot;</p>"},{"id":"Fpmath","name":"Fpmath","value":"3_u32","doc":"\"prof\"","summary":"<p>&quot;prof&quot;</p>"},{"id":"Range","name":"Range","value":"4_u32","doc":"\"fpmath\"","summary":"<p>&quot;fpmath&quot;</p>"},{"id":"TbaaStruct","name":"TbaaStruct","value":"5_u32","doc":"\"range\"","summary":"<p>&quot;range&quot;</p>"},{"id":"InvariantLoad","name":"InvariantLoad","value":"6_u32","doc":"\"tbaa.struct\"","summary":"<p>&quot;tbaa.struct&quot;</p>"},{"id":"AliasScope","name":"AliasScope","value":"7_u32","doc":"\"invariant.load\"","summary":"<p>&quot;invariant.load&quot;</p>"},{"id":"Noalias","name":"Noalias","value":"8_u32","doc":"\"alias.scope\"","summary":"<p>&quot;alias.scope&quot;</p>"},{"id":"Nontemporal","name":"Nontemporal","value":"9_u32","doc":"\"noalias\"","summary":"<p>&quot;noalias&quot;</p>"},{"id":"MemParallelLoopAccess","name":"MemParallelLoopAccess","value":"10_u32","doc":"\"nontemporal\"","summary":"<p>&quot;nontemporal&quot;</p>"},{"id":"Nonnull","name":"Nonnull","value":"11_u32","doc":"\"llvm.mem.parallel_loop_access\"","summary":"<p>&quot;llvm.mem.parallel_loop_access&quot;</p>"},{"id":"Dereferenceable","name":"Dereferenceable","value":"12_u32","doc":"\"nonnull\"","summary":"<p>&quot;nonnull&quot;</p>"},{"id":"DereferenceableOrNull","name":"DereferenceableOrNull","value":"13_u32","doc":"\"dereferenceable\"","summary":"<p>&quot;dereferenceable&quot;</p>"},{"id":"MakeImplicit","name":"MakeImplicit","value":"14_u32","doc":"\"dereferenceable_or_null\"","summary":"<p>&quot;dereferenceable_or_null&quot;</p>"},{"id":"Unpredictable","name":"Unpredictable","value":"15_u32","doc":"\"make.implicit\"","summary":"<p>&quot;make.implicit&quot;</p>"},{"id":"InvariantGroup","name":"InvariantGroup","value":"16_u32","doc":"\"unpredictable\"","summary":"<p>&quot;unpredictable&quot;</p>"},{"id":"Align","name":"Align","value":"17_u32","doc":"\"invariant.group\"","summary":"<p>&quot;invariant.group&quot;</p>"},{"id":"Loop","name":"Loop","value":"18_u32","doc":"\"align\"","summary":"<p>&quot;align&quot;</p>"},{"id":"Type","name":"Type","value":"19_u32","doc":"\"llvm.loop\"","summary":"<p>&quot;llvm.loop&quot;</p>"},{"id":"SectionPrefix","name":"SectionPrefix","value":"20_u32","doc":"\"type\"","summary":"<p>&quot;type&quot;</p>"},{"id":"AbsoluteSymbol","name":"AbsoluteSymbol","value":"21_u32","doc":"\"section_prefix\"","summary":"<p>&quot;section_prefix&quot;</p>"},{"id":"Associated","name":"Associated","value":"22_u32","doc":"\"absolute_symbol\"","summary":"<p>&quot;absolute_symbol&quot;</p>"},{"id":"Callees","name":"Callees","value":"23_u32","doc":"\"associated\"","summary":"<p>&quot;associated&quot;</p>"},{"id":"IrrLoop","name":"IrrLoop","value":"24_u32","doc":"\"callees\"","summary":"<p>&quot;callees&quot;</p>"},{"id":"AccessGroup","name":"AccessGroup","value":"25_u32","doc":"\"irr_loop\"","summary":"<p>&quot;irr_loop&quot;</p>"},{"id":"Callback","name":"Callback","value":"26_u32","doc":"\"llvm.access.group\"","summary":"<p>&quot;llvm.access.group&quot;</p>"},{"id":"PreserveAccessIndex","name":"PreserveAccessIndex","value":"27_u32","doc":"\"callback\"","summary":"<p>&quot;callback&quot;</p>"}],"namespace":{"html_id":"Crystal/LLVM/Metadata","kind":"struct","full_name":"LLVM::Metadata","name":"Metadata"},"instance_methods":[{"html_id":"absolute_symbol?-instance-method","name":"absolute_symbol?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":484,"url":null},"def":{"name":"absolute_symbol?","visibility":"Public","body":"self == AbsoluteSymbol"}},{"html_id":"access_group?-instance-method","name":"access_group?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":488,"url":null},"def":{"name":"access_group?","visibility":"Public","body":"self == AccessGroup"}},{"html_id":"alias_scope?-instance-method","name":"alias_scope?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":470,"url":null},"def":{"name":"alias_scope?","visibility":"Public","body":"self == AliasScope"}},{"html_id":"align?-instance-method","name":"align?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":480,"url":null},"def":{"name":"align?","visibility":"Public","body":"self == Align"}},{"html_id":"associated?-instance-method","name":"associated?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":485,"url":null},"def":{"name":"associated?","visibility":"Public","body":"self == Associated"}},{"html_id":"callback?-instance-method","name":"callback?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":489,"url":null},"def":{"name":"callback?","visibility":"Public","body":"self == Callback"}},{"html_id":"callees?-instance-method","name":"callees?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":486,"url":null},"def":{"name":"callees?","visibility":"Public","body":"self == Callees"}},{"html_id":"dbg?-instance-method","name":"dbg?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":463,"url":null},"def":{"name":"dbg?","visibility":"Public","body":"self == Dbg"}},{"html_id":"dereferenceable?-instance-method","name":"dereferenceable?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":475,"url":null},"def":{"name":"dereferenceable?","visibility":"Public","body":"self == Dereferenceable"}},{"html_id":"dereferenceable_or_null?-instance-method","name":"dereferenceable_or_null?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":476,"url":null},"def":{"name":"dereferenceable_or_null?","visibility":"Public","body":"self == DereferenceableOrNull"}},{"html_id":"fpmath?-instance-method","name":"fpmath?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":466,"url":null},"def":{"name":"fpmath?","visibility":"Public","body":"self == Fpmath"}},{"html_id":"invariant_group?-instance-method","name":"invariant_group?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":479,"url":null},"def":{"name":"invariant_group?","visibility":"Public","body":"self == InvariantGroup"}},{"html_id":"invariant_load?-instance-method","name":"invariant_load?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":469,"url":null},"def":{"name":"invariant_load?","visibility":"Public","body":"self == InvariantLoad"}},{"html_id":"irr_loop?-instance-method","name":"irr_loop?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":487,"url":null},"def":{"name":"irr_loop?","visibility":"Public","body":"self == IrrLoop"}},{"html_id":"loop?-instance-method","name":"loop?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":481,"url":null},"def":{"name":"loop?","visibility":"Public","body":"self == Loop"}},{"html_id":"make_implicit?-instance-method","name":"make_implicit?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":477,"url":null},"def":{"name":"make_implicit?","visibility":"Public","body":"self == MakeImplicit"}},{"html_id":"mem_parallel_loop_access?-instance-method","name":"mem_parallel_loop_access?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":473,"url":null},"def":{"name":"mem_parallel_loop_access?","visibility":"Public","body":"self == MemParallelLoopAccess"}},{"html_id":"noalias?-instance-method","name":"noalias?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":471,"url":null},"def":{"name":"noalias?","visibility":"Public","body":"self == Noalias"}},{"html_id":"nonnull?-instance-method","name":"nonnull?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":474,"url":null},"def":{"name":"nonnull?","visibility":"Public","body":"self == Nonnull"}},{"html_id":"nontemporal?-instance-method","name":"nontemporal?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":472,"url":null},"def":{"name":"nontemporal?","visibility":"Public","body":"self == Nontemporal"}},{"html_id":"preserve_access_index?-instance-method","name":"preserve_access_index?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":490,"url":null},"def":{"name":"preserve_access_index?","visibility":"Public","body":"self == PreserveAccessIndex"}},{"html_id":"prof?-instance-method","name":"prof?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":465,"url":null},"def":{"name":"prof?","visibility":"Public","body":"self == Prof"}},{"html_id":"range?-instance-method","name":"range?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":467,"url":null},"def":{"name":"range?","visibility":"Public","body":"self == Range"}},{"html_id":"section_prefix?-instance-method","name":"section_prefix?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":483,"url":null},"def":{"name":"section_prefix?","visibility":"Public","body":"self == SectionPrefix"}},{"html_id":"tbaa?-instance-method","name":"tbaa?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":464,"url":null},"def":{"name":"tbaa?","visibility":"Public","body":"self == Tbaa"}},{"html_id":"tbaa_struct?-instance-method","name":"tbaa_struct?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":468,"url":null},"def":{"name":"tbaa_struct?","visibility":"Public","body":"self == TbaaStruct"}},{"html_id":"type?-instance-method","name":"type?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":482,"url":null},"def":{"name":"type?","visibility":"Public","body":"self == Type"}},{"html_id":"unpredictable?-instance-method","name":"unpredictable?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":478,"url":null},"def":{"name":"unpredictable?","visibility":"Public","body":"self == Unpredictable"}}]}]},{"html_id":"Crystal/LLVM/Module","path":"LLVM/Module.html","kind":"class","full_name":"LLVM::Module","name":"Module","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/module.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new(unwrap:LibLLVM::ModuleRef,context:Context)-class-method","name":"new","doc":"LLVM >= 3.9","summary":"<p>LLVM &gt;= 3.9</p>","abstract":false,"args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::ModuleRef"},{"name":"context","external_name":"context","restriction":"Context"}],"args_string":"(unwrap : LibLLVM::ModuleRef, context : Context)","args_html":"(unwrap : LibLLVM::ModuleRef, context : <a href=\"../LLVM/Context.html\">Context</a>)","location":{"filename":"src/llvm/module.cr","line_number":9,"url":null},"def":{"name":"new","args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::ModuleRef"},{"name":"context","external_name":"context","restriction":"Context"}],"visibility":"Public","body":"_ = allocate\n_.initialize(unwrap, context)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this reference is the same as *other*. Invokes `same?`.","summary":"<p>Returns <code>true</code> if this reference is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/llvm/module.cr","line_number":118,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"@unwrap == (other.@unwrap)"}},{"html_id":"add_flag(module_flag:ModuleFlag,key:String,val:Value)-instance-method","name":"add_flag","abstract":false,"args":[{"name":"module_flag","external_name":"module_flag","restriction":"ModuleFlag"},{"name":"key","external_name":"key","restriction":"String"},{"name":"val","external_name":"val","restriction":"Value"}],"args_string":"(module_flag : ModuleFlag, key : String, val : Value)","args_html":"(module_flag : <a href=\"../LLVM/ModuleFlag.html\">ModuleFlag</a>, key : <a href=\"../String.html\">String</a>, val : <a href=\"../LLVM/Value.html\">Value</a>)","location":{"filename":"src/llvm/module.cr","line_number":58,"url":null},"def":{"name":"add_flag","args":[{"name":"module_flag","external_name":"module_flag","restriction":"ModuleFlag"},{"name":"key","external_name":"key","restriction":"String"},{"name":"val","external_name":"val","restriction":"Value"}],"visibility":"Public","body":"{% if LibLLVM::IS_LT_70 %}\n      values = [\n        context.int32.const_int(module_flag.value),\n        context.md_string(key.to_s),\n        val,\n      ]\n      md_node = context.md_node(values)\n      LibLLVM.add_named_metadata_operand(self, \"llvm.module.flags\", md_node)\n    {% else %}\n      LibLLVM.add_module_flag(\n        self,\n        module_flag,\n        key,\n        key.bytesize,\n        LibLLVM.metadata_as_value(val.to_unsafe)\n      )\n    {% end %}"}},{"html_id":"context:Context-instance-method","name":"context","abstract":false,"location":{"filename":"src/llvm/module.cr","line_number":7,"url":null},"def":{"name":"context","return_type":"Context","visibility":"Public","body":"@context"}},{"html_id":"data_layout=(data:TargetData)-instance-method","name":"data_layout=","abstract":false,"args":[{"name":"data","external_name":"data","restriction":"TargetData"}],"args_string":"(data : TargetData)","args_html":"(data : <a href=\"../LLVM/TargetData.html\">TargetData</a>)","location":{"filename":"src/llvm/module.cr","line_number":37,"url":null},"def":{"name":"data_layout=","args":[{"name":"data","external_name":"data","restriction":"TargetData"}],"visibility":"Public","body":"{% if LibLLVM::IS_38 %}\n      LibLLVM.set_data_layout(self, data.to_data_layout_string)\n    {% else %}\n      # LLVM >= 3.9\n      LibLLVM.set_module_data_layout(self, data)\n    {% end %}"}},{"html_id":"dump-instance-method","name":"dump","abstract":false,"location":{"filename":"src/llvm/module.cr","line_number":46,"url":null},"def":{"name":"dump","visibility":"Public","body":"LibLLVM.dump_module(self)"}},{"html_id":"functions-instance-method","name":"functions","abstract":false,"location":{"filename":"src/llvm/module.cr","line_number":50,"url":null},"def":{"name":"functions","visibility":"Public","body":"FunctionCollection.new(self)"}},{"html_id":"globals-instance-method","name":"globals","abstract":false,"location":{"filename":"src/llvm/module.cr","line_number":54,"url":null},"def":{"name":"globals","visibility":"Public","body":"GlobalCollection.new(self)"}},{"html_id":"name:String-instance-method","name":"name","abstract":false,"location":{"filename":"src/llvm/module.cr","line_number":9,"url":null},"def":{"name":"name","return_type":"String","visibility":"Public","body":"bytes = LibLLVM.get_module_identifier(self, out bytesize)\nString.new(Slice.new(bytes, bytesize))\n"}},{"html_id":"name=(name:String)-instance-method","name":"name=","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String)","args_html":"(name : <a href=\"../String.html\">String</a>)","location":{"filename":"src/llvm/module.cr","line_number":9,"url":null},"def":{"name":"name=","args":[{"name":"name","external_name":"name","restriction":"String"}],"visibility":"Public","body":"LibLLVM.set_module_identifier(self, name, name.bytesize)"}},{"html_id":"new_function_pass_manager-instance-method","name":"new_function_pass_manager","abstract":false,"location":{"filename":"src/llvm/module.cr","line_number":114,"url":null},"def":{"name":"new_function_pass_manager","visibility":"Public","body":"FunctionPassManager.new(LibLLVM.create_function_pass_manager_for_module(self))"}},{"html_id":"print_to_file(filename)-instance-method","name":"print_to_file","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":""}],"args_string":"(filename)","args_html":"(filename)","location":{"filename":"src/llvm/module.cr","line_number":107,"url":null},"def":{"name":"print_to_file","args":[{"name":"filename","external_name":"filename","restriction":""}],"visibility":"Public","body":"if (LibLLVM.print_module_to_file(self, filename, out error_msg)) != 0\n  raise(LLVM.string_and_dispose(error_msg))\nend\nself\n"}},{"html_id":"take_ownership(&)-instance-method","name":"take_ownership","abstract":false,"location":{"filename":"src/llvm/module.cr","line_number":131,"url":null},"def":{"name":"take_ownership","yields":0,"visibility":"Public","body":"if @owned\n  yield\nelse\n  @owned = true\nend"}},{"html_id":"target=(target)-instance-method","name":"target=","abstract":false,"args":[{"name":"target","external_name":"target","restriction":""}],"args_string":"(target)","args_html":"(target)","location":{"filename":"src/llvm/module.cr","line_number":33,"url":null},"def":{"name":"target=","args":[{"name":"target","external_name":"target","restriction":""}],"visibility":"Public","body":"LibLLVM.set_target(self, target)"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a short String representation of this object\nwhich includes its class name and its object address.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).to_s # => #<Person:0x10a199f20>\n```","summary":"<p>Appends a short String representation of this object which includes its class name and its object address.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/llvm/module.cr","line_number":122,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"LLVM.to_io(LibLLVM.print_module_to_string(self), io)\nself\n"}},{"html_id":"to_unsafe:LibLLVM::ModuleRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/module.cr","line_number":127,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}},{"html_id":"verify-instance-method","name":"verify","abstract":false,"location":{"filename":"src/llvm/module.cr","line_number":96,"url":null},"def":{"name":"verify","visibility":"Public","body":"error = LibLLVM.verify_module(self, LLVM::VerifierFailureAction::ReturnStatusAction, out message)\nbegin\n  if error == 1\n    raise(\"Module validation failed: #{String.new(message)}\")\n  end\nensure\n  LibLLVM.dispose_message(message)\nend\n"}},{"html_id":"write_bitcode_to_fd(fd:Int,should_close=false,buffered=false)-instance-method","name":"write_bitcode_to_fd","abstract":false,"args":[{"name":"fd","external_name":"fd","restriction":"Int"},{"name":"should_close","default_value":"false","external_name":"should_close","restriction":""},{"name":"buffered","default_value":"false","external_name":"buffered","restriction":""}],"args_string":"(fd : Int, should_close = false, buffered = false)","args_html":"(fd : <a href=\"../Int.html\">Int</a>, should_close = <span class=\"n\">false</span>, buffered = <span class=\"n\">false</span>)","location":{"filename":"src/llvm/module.cr","line_number":92,"url":null},"def":{"name":"write_bitcode_to_fd","args":[{"name":"fd","external_name":"fd","restriction":"Int"},{"name":"should_close","default_value":"false","external_name":"should_close","restriction":""},{"name":"buffered","default_value":"false","external_name":"buffered","restriction":""}],"visibility":"Public","body":"LibLLVM.write_bitcode_to_fd(self, fd, should_close ? 1 : 0, buffered ? 1 : 0)"}},{"html_id":"write_bitcode_to_file(filename:String)-instance-method","name":"write_bitcode_to_file","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"}],"args_string":"(filename : String)","args_html":"(filename : <a href=\"../String.html\">String</a>)","location":{"filename":"src/llvm/module.cr","line_number":78,"url":null},"def":{"name":"write_bitcode_to_file","args":[{"name":"filename","external_name":"filename","restriction":"String"}],"visibility":"Public","body":"LibLLVM.write_bitcode_to_file(self, filename)"}},{"html_id":"write_bitcode_to_memory_buffer-instance-method","name":"write_bitcode_to_memory_buffer","abstract":false,"location":{"filename":"src/llvm/module.cr","line_number":88,"url":null},"def":{"name":"write_bitcode_to_memory_buffer","visibility":"Public","body":"MemoryBuffer.new(LibLLVM.write_bitcode_to_memory_buffer(self))"}},{"html_id":"write_bitcode_with_summary_to_file(filename:String)-instance-method","name":"write_bitcode_with_summary_to_file","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"}],"args_string":"(filename : String)","args_html":"(filename : <a href=\"../String.html\">String</a>)","location":{"filename":"src/llvm/module.cr","line_number":82,"url":null},"def":{"name":"write_bitcode_with_summary_to_file","args":[{"name":"filename","external_name":"filename","restriction":"String"}],"visibility":"Public","body":"LibLLVMExt.write_bitcode_with_summary_to_file(self, filename)"}}]},{"html_id":"Crystal/LLVM/ModuleFlag","path":"LLVM/ModuleFlag.html","kind":"enum","full_name":"LLVM::ModuleFlag","name":"ModuleFlag","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":457,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Warning","name":"Warning","value":"2"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"warning?-instance-method","name":"warning?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":458,"url":null},"def":{"name":"warning?","visibility":"Public","body":"self == Warning"}}]},{"html_id":"Crystal/LLVM/ModulePassManager","path":"LLVM/ModulePassManager.html","kind":"class","full_name":"LLVM::ModulePassManager","name":"ModulePassManager","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/module_pass_manager.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/llvm/module_pass_manager.cr","line_number":2,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/llvm/module_pass_manager.cr","line_number":14,"url":null},"def":{"name":"finalize","visibility":"Public","body":"LibLLVM.dispose_pass_manager(@unwrap)"}},{"html_id":"run(mod)-instance-method","name":"run","abstract":false,"args":[{"name":"mod","external_name":"mod","restriction":""}],"args_string":"(mod)","args_html":"(mod)","location":{"filename":"src/llvm/module_pass_manager.cr","line_number":6,"url":null},"def":{"name":"run","args":[{"name":"mod","external_name":"mod","restriction":""}],"visibility":"Public","body":"(LibLLVM.run_pass_manager(self, mod)) != 0"}},{"html_id":"to_unsafe:LibLLVM::PassManagerRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/module_pass_manager.cr","line_number":10,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}}]},{"html_id":"Crystal/LLVM/OperandBundleDef","path":"LLVM/OperandBundleDef.html","kind":"struct","full_name":"LLVM::OperandBundleDef","name":"OperandBundleDef","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/operand_bundle_def.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"class_methods":[{"html_id":"null-class-method","name":"null","abstract":false,"location":{"filename":"src/llvm/operand_bundle_def.cr","line_number":5,"url":null},"def":{"name":"null","visibility":"Public","body":"LLVM::OperandBundleDef.new(Pointer(::Void).null.as(LibLLVMExt::OperandBundleDefRef))"}}],"constructors":[{"html_id":"new(unwrap:LibLLVMExt::OperandBundleDefRef)-class-method","name":"new","abstract":false,"args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVMExt::OperandBundleDefRef"}],"args_string":"(unwrap : LibLLVMExt::OperandBundleDefRef)","args_html":"(unwrap : LibLLVMExt::OperandBundleDefRef)","location":{"filename":"src/llvm/operand_bundle_def.cr","line_number":2,"url":null},"def":{"name":"new","args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVMExt::OperandBundleDefRef"}],"visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"to_unsafe:LibLLVMExt::OperandBundleDefRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/operand_bundle_def.cr","line_number":9,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}}]},{"html_id":"Crystal/LLVM/ParameterCollection","path":"LLVM/ParameterCollection.html","kind":"struct","full_name":"LLVM::ParameterCollection","name":"ParameterCollection","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"},{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/parameter_collection.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new(function:Function)-class-method","name":"new","abstract":false,"args":[{"name":"function","external_name":"function","restriction":"Function"}],"args_string":"(function : Function)","args_html":"(function : <a href=\"../LLVM/Function.html\">Function</a>)","location":{"filename":"src/llvm/parameter_collection.cr","line_number":4,"url":null},"def":{"name":"new","args":[{"name":"function","external_name":"function","restriction":"Function"}],"visibility":"Public","body":"_ = allocate\n_.initialize(function)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"size-instance-method","name":"size","doc":"Returns the number of elements in this container.","summary":"<p>Returns the number of elements in this container.</p>","abstract":false,"location":{"filename":"src/llvm/parameter_collection.cr","line_number":7,"url":null},"def":{"name":"size","visibility":"Public","body":"@function.function_type.params_size"}},{"html_id":"to_a-instance-method","name":"to_a","doc":"Returns an `Array` with all the elements in the collection.\n\n```\n{1, 2, 3}.to_a # => [1, 2, 3]\n```","summary":"<p>Returns an <code><a href=\"../Array.html\">Array</a></code> with all the elements in the collection.</p>","abstract":false,"location":{"filename":"src/llvm/parameter_collection.cr","line_number":11,"url":null},"def":{"name":"to_a","visibility":"Public","body":"param_size = size()\nArray(LLVM::Value).build(param_size) do |buffer|\n  LibLLVM.get_params(@function, buffer.as(::Pointer(LibLLVM::ValueRef)))\n  param_size\nend\n"}},{"html_id":"types-instance-method","name":"types","abstract":false,"location":{"filename":"src/llvm/parameter_collection.cr","line_number":23,"url":null},"def":{"name":"types","visibility":"Public","body":"@function.function_type.params_types"}},{"html_id":"unsafe_fetch(index:Int)-instance-method","name":"unsafe_fetch","doc":"Returns the element at the given *index*, without doing any bounds check.\n\n`Indexable` makes sure to invoke this method with *index* in `0...size`,\nso converting negative indices to positive ones is not needed here.\n\nClients never invoke this method directly. Instead, they access\nelements with `#[](index)` and `#[]?(index)`.\n\nThis method should only be directly invoked if you are absolutely\nsure the index is in bounds, to avoid a bounds check for a small boost\nof performance.","summary":"<p>Returns the element at the given <em>index</em>, without doing any bounds check.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","args_html":"(index : <a href=\"../Int.html\">Int</a>)","location":{"filename":"src/llvm/parameter_collection.cr","line_number":19,"url":null},"def":{"name":"unsafe_fetch","args":[{"name":"index","external_name":"index","restriction":"Int"}],"visibility":"Public","body":"Value.new(LibLLVM.get_param(@function, index))"}}]},{"html_id":"Crystal/LLVM/PassManagerBuilder","path":"LLVM/PassManagerBuilder.html","kind":"class","full_name":"LLVM::PassManagerBuilder","name":"PassManagerBuilder","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/pass_manager_builder.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/llvm/pass_manager_builder.cr","line_number":2,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"disable_simplify_lib_calls=(value)-instance-method","name":"disable_simplify_lib_calls=","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/llvm/pass_manager_builder.cr","line_number":18,"url":null},"def":{"name":"disable_simplify_lib_calls=","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"LibLLVM.pass_manager_builder_set_disable_simplify_lib_calls(self, value ? 1 : 0)"}},{"html_id":"disable_unroll_loops=(value)-instance-method","name":"disable_unroll_loops=","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/llvm/pass_manager_builder.cr","line_number":14,"url":null},"def":{"name":"disable_unroll_loops=","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"LibLLVM.pass_manager_builder_set_disable_unroll_loops(self, value ? 1 : 0)"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/llvm/pass_manager_builder.cr","line_number":38,"url":null},"def":{"name":"finalize","visibility":"Public","body":"LibLLVM.dispose_pass_manager_builder(@unwrap)"}},{"html_id":"opt_level=(level)-instance-method","name":"opt_level=","abstract":false,"args":[{"name":"level","external_name":"level","restriction":""}],"args_string":"(level)","args_html":"(level)","location":{"filename":"src/llvm/pass_manager_builder.cr","line_number":6,"url":null},"def":{"name":"opt_level=","args":[{"name":"level","external_name":"level","restriction":""}],"visibility":"Public","body":"LibLLVM.pass_manager_builder_set_opt_level(self, level)"}},{"html_id":"populate(pm:FunctionPassManager)-instance-method","name":"populate","abstract":false,"args":[{"name":"pm","external_name":"pm","restriction":"FunctionPassManager"}],"args_string":"(pm : FunctionPassManager)","args_html":"(pm : <a href=\"../LLVM/FunctionPassManager.html\">FunctionPassManager</a>)","location":{"filename":"src/llvm/pass_manager_builder.cr","line_number":26,"url":null},"def":{"name":"populate","args":[{"name":"pm","external_name":"pm","restriction":"FunctionPassManager"}],"visibility":"Public","body":"LibLLVM.pass_manager_builder_populate_function_pass_manager(self, pm)"}},{"html_id":"populate(pm:ModulePassManager)-instance-method","name":"populate","abstract":false,"args":[{"name":"pm","external_name":"pm","restriction":"ModulePassManager"}],"args_string":"(pm : ModulePassManager)","args_html":"(pm : <a href=\"../LLVM/ModulePassManager.html\">ModulePassManager</a>)","location":{"filename":"src/llvm/pass_manager_builder.cr","line_number":30,"url":null},"def":{"name":"populate","args":[{"name":"pm","external_name":"pm","restriction":"ModulePassManager"}],"visibility":"Public","body":"LibLLVM.pass_manager_builder_populate_module_pass_manager(self, pm)"}},{"html_id":"size_level=(level)-instance-method","name":"size_level=","abstract":false,"args":[{"name":"level","external_name":"level","restriction":""}],"args_string":"(level)","args_html":"(level)","location":{"filename":"src/llvm/pass_manager_builder.cr","line_number":10,"url":null},"def":{"name":"size_level=","args":[{"name":"level","external_name":"level","restriction":""}],"visibility":"Public","body":"LibLLVM.pass_manager_builder_set_size_level(self, level)"}},{"html_id":"to_unsafe:LibLLVM::PassManagerBuilderRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/pass_manager_builder.cr","line_number":34,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}},{"html_id":"use_inliner_with_threshold=(threshold)-instance-method","name":"use_inliner_with_threshold=","abstract":false,"args":[{"name":"threshold","external_name":"threshold","restriction":""}],"args_string":"(threshold)","args_html":"(threshold)","location":{"filename":"src/llvm/pass_manager_builder.cr","line_number":22,"url":null},"def":{"name":"use_inliner_with_threshold=","args":[{"name":"threshold","external_name":"threshold","restriction":""}],"visibility":"Public","body":"LibLLVM.pass_manager_builder_use_inliner_with_threshold(self, threshold)"}}]},{"html_id":"Crystal/LLVM/PassRegistry","path":"LLVM/PassRegistry.html","kind":"struct","full_name":"LLVM::PassRegistry","name":"PassRegistry","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/pass_registry.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"Inits","name":"Inits","value":"[\"core\", \"transform_utils\", \"scalar_opts\", \"obj_c_arc_opts\", \"vectorization\", \"inst_combine\", \"ipo\", \"instrumentation\", \"analysis\", \"ipa\", \"code_gen\", \"target\"] of ::String"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"instance:self-class-method","name":"instance","abstract":false,"location":{"filename":"src/llvm/pass_registry.cr","line_number":2,"url":null},"def":{"name":"instance","return_type":"self","visibility":"Public","body":"new(LibLLVM.get_global_pass_registry)"}},{"html_id":"new(unwrap:LibLLVM::PassRegistryRef)-class-method","name":"new","abstract":false,"args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::PassRegistryRef"}],"args_string":"(unwrap : LibLLVM::PassRegistryRef)","args_html":"(unwrap : LibLLVM::PassRegistryRef)","location":{"filename":"src/llvm/pass_registry.cr","line_number":6,"url":null},"def":{"name":"new","args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::PassRegistryRef"}],"visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"initialize_all-instance-method","name":"initialize_all","abstract":false,"location":{"filename":"src/llvm/pass_registry.cr","line_number":17,"url":null},"def":{"name":"initialize_all","visibility":"Public","body":"{% for name in Inits %}\n      initialize_{{ name.id }}\n    {% end %}"}},{"html_id":"initialize_analysis-instance-method","name":"initialize_analysis","abstract":false,"location":{"filename":"src/llvm/pass_registry.cr","line_number":11,"url":null},"def":{"name":"initialize_analysis","visibility":"Public","body":"LibLLVM.initialize_analysis(self)"}},{"html_id":"initialize_code_gen-instance-method","name":"initialize_code_gen","abstract":false,"location":{"filename":"src/llvm/pass_registry.cr","line_number":11,"url":null},"def":{"name":"initialize_code_gen","visibility":"Public","body":"LibLLVM.initialize_code_gen(self)"}},{"html_id":"initialize_core-instance-method","name":"initialize_core","abstract":false,"location":{"filename":"src/llvm/pass_registry.cr","line_number":11,"url":null},"def":{"name":"initialize_core","visibility":"Public","body":"LibLLVM.initialize_core(self)"}},{"html_id":"initialize_inst_combine-instance-method","name":"initialize_inst_combine","abstract":false,"location":{"filename":"src/llvm/pass_registry.cr","line_number":11,"url":null},"def":{"name":"initialize_inst_combine","visibility":"Public","body":"LibLLVM.initialize_inst_combine(self)"}},{"html_id":"initialize_instrumentation-instance-method","name":"initialize_instrumentation","abstract":false,"location":{"filename":"src/llvm/pass_registry.cr","line_number":11,"url":null},"def":{"name":"initialize_instrumentation","visibility":"Public","body":"LibLLVM.initialize_instrumentation(self)"}},{"html_id":"initialize_ipa-instance-method","name":"initialize_ipa","abstract":false,"location":{"filename":"src/llvm/pass_registry.cr","line_number":11,"url":null},"def":{"name":"initialize_ipa","visibility":"Public","body":"LibLLVM.initialize_ipa(self)"}},{"html_id":"initialize_ipo-instance-method","name":"initialize_ipo","abstract":false,"location":{"filename":"src/llvm/pass_registry.cr","line_number":11,"url":null},"def":{"name":"initialize_ipo","visibility":"Public","body":"LibLLVM.initialize_ipo(self)"}},{"html_id":"initialize_obj_c_arc_opts-instance-method","name":"initialize_obj_c_arc_opts","abstract":false,"location":{"filename":"src/llvm/pass_registry.cr","line_number":11,"url":null},"def":{"name":"initialize_obj_c_arc_opts","visibility":"Public","body":"LibLLVM.initialize_obj_c_arc_opts(self)"}},{"html_id":"initialize_scalar_opts-instance-method","name":"initialize_scalar_opts","abstract":false,"location":{"filename":"src/llvm/pass_registry.cr","line_number":11,"url":null},"def":{"name":"initialize_scalar_opts","visibility":"Public","body":"LibLLVM.initialize_scalar_opts(self)"}},{"html_id":"initialize_target-instance-method","name":"initialize_target","abstract":false,"location":{"filename":"src/llvm/pass_registry.cr","line_number":11,"url":null},"def":{"name":"initialize_target","visibility":"Public","body":"LibLLVM.initialize_target(self)"}},{"html_id":"initialize_transform_utils-instance-method","name":"initialize_transform_utils","abstract":false,"location":{"filename":"src/llvm/pass_registry.cr","line_number":11,"url":null},"def":{"name":"initialize_transform_utils","visibility":"Public","body":"LibLLVM.initialize_transform_utils(self)"}},{"html_id":"initialize_vectorization-instance-method","name":"initialize_vectorization","abstract":false,"location":{"filename":"src/llvm/pass_registry.cr","line_number":11,"url":null},"def":{"name":"initialize_vectorization","visibility":"Public","body":"LibLLVM.initialize_vectorization(self)"}},{"html_id":"to_unsafe:LibLLVM::PassRegistryRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/pass_registry.cr","line_number":23,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}}]},{"html_id":"Crystal/LLVM/PhiTable","path":"LLVM/PhiTable.html","kind":"struct","full_name":"LLVM::PhiTable","name":"PhiTable","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/phi_table.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/llvm/phi_table.cr","line_number":5,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"add(block,value)-instance-method","name":"add","abstract":false,"args":[{"name":"block","external_name":"block","restriction":""},{"name":"value","external_name":"value","restriction":""}],"args_string":"(block, value)","args_html":"(block, value)","location":{"filename":"src/llvm/phi_table.cr","line_number":10,"url":null},"def":{"name":"add","args":[{"name":"block","external_name":"block","restriction":""},{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"@blocks << block\n@values << value.to_value\n"}},{"html_id":"blocks:Array(LLVM::BasicBlock)-instance-method","name":"blocks","abstract":false,"location":{"filename":"src/llvm/phi_table.cr","line_number":2,"url":null},"def":{"name":"blocks","return_type":"Array(LLVM::BasicBlock)","visibility":"Public","body":"@blocks"}},{"html_id":"empty?-instance-method","name":"empty?","abstract":false,"location":{"filename":"src/llvm/phi_table.cr","line_number":15,"url":null},"def":{"name":"empty?","visibility":"Public","body":"@blocks.empty?"}},{"html_id":"size-instance-method","name":"size","abstract":false,"location":{"filename":"src/llvm/phi_table.cr","line_number":19,"url":null},"def":{"name":"size","visibility":"Public","body":"@blocks.size"}},{"html_id":"values:Array(LLVM::Value)-instance-method","name":"values","abstract":false,"location":{"filename":"src/llvm/phi_table.cr","line_number":3,"url":null},"def":{"name":"values","return_type":"Array(LLVM::Value)","visibility":"Public","body":"@values"}}]},{"html_id":"Crystal/LLVM/RealPredicate","path":"LLVM/RealPredicate.html","kind":"enum","full_name":"LLVM::RealPredicate","name":"RealPredicate","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":255,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"PredicateFalse","name":"PredicateFalse","value":"0"},{"id":"OEQ","name":"OEQ","value":"1"},{"id":"OGT","name":"OGT","value":"2"},{"id":"OGE","name":"OGE","value":"3"},{"id":"OLT","name":"OLT","value":"4"},{"id":"OLE","name":"OLE","value":"5"},{"id":"ONE","name":"ONE","value":"6"},{"id":"ORD","name":"ORD","value":"7"},{"id":"UNO","name":"UNO","value":"8"},{"id":"UEQ","name":"UEQ","value":"9"},{"id":"UGT","name":"UGT","value":"10"},{"id":"UGE","name":"UGE","value":"11"},{"id":"ULT","name":"ULT","value":"12"},{"id":"ULE","name":"ULE","value":"13"},{"id":"UNE","name":"UNE","value":"14"},{"id":"PredicateTrue","name":"PredicateTrue","value":"15"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"oeq?-instance-method","name":"oeq?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":257,"url":null},"def":{"name":"oeq?","visibility":"Public","body":"self == OEQ"}},{"html_id":"oge?-instance-method","name":"oge?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":259,"url":null},"def":{"name":"oge?","visibility":"Public","body":"self == OGE"}},{"html_id":"ogt?-instance-method","name":"ogt?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":258,"url":null},"def":{"name":"ogt?","visibility":"Public","body":"self == OGT"}},{"html_id":"ole?-instance-method","name":"ole?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":261,"url":null},"def":{"name":"ole?","visibility":"Public","body":"self == OLE"}},{"html_id":"olt?-instance-method","name":"olt?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":260,"url":null},"def":{"name":"olt?","visibility":"Public","body":"self == OLT"}},{"html_id":"one?-instance-method","name":"one?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":262,"url":null},"def":{"name":"one?","visibility":"Public","body":"self == ONE"}},{"html_id":"ord?-instance-method","name":"ord?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":263,"url":null},"def":{"name":"ord?","visibility":"Public","body":"self == ORD"}},{"html_id":"predicate_false?-instance-method","name":"predicate_false?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":256,"url":null},"def":{"name":"predicate_false?","visibility":"Public","body":"self == PredicateFalse"}},{"html_id":"predicate_true?-instance-method","name":"predicate_true?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":271,"url":null},"def":{"name":"predicate_true?","visibility":"Public","body":"self == PredicateTrue"}},{"html_id":"ueq?-instance-method","name":"ueq?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":265,"url":null},"def":{"name":"ueq?","visibility":"Public","body":"self == UEQ"}},{"html_id":"uge?-instance-method","name":"uge?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":267,"url":null},"def":{"name":"uge?","visibility":"Public","body":"self == UGE"}},{"html_id":"ugt?-instance-method","name":"ugt?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":266,"url":null},"def":{"name":"ugt?","visibility":"Public","body":"self == UGT"}},{"html_id":"ule?-instance-method","name":"ule?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":269,"url":null},"def":{"name":"ule?","visibility":"Public","body":"self == ULE"}},{"html_id":"ult?-instance-method","name":"ult?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":268,"url":null},"def":{"name":"ult?","visibility":"Public","body":"self == ULT"}},{"html_id":"une?-instance-method","name":"une?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":270,"url":null},"def":{"name":"une?","visibility":"Public","body":"self == UNE"}},{"html_id":"uno?-instance-method","name":"uno?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":264,"url":null},"def":{"name":"uno?","visibility":"Public","body":"self == UNO"}}]},{"html_id":"Crystal/LLVM/RelocMode","path":"LLVM/RelocMode.html","kind":"enum","full_name":"LLVM::RelocMode","name":"RelocMode","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":307,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Default","name":"Default","value":"0"},{"id":"Static","name":"Static","value":"1"},{"id":"PIC","name":"PIC","value":"2"},{"id":"DynamicNoPIC","name":"DynamicNoPIC","value":"3"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"default?-instance-method","name":"default?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":308,"url":null},"def":{"name":"default?","visibility":"Public","body":"self == Default"}},{"html_id":"dynamic_no_pic?-instance-method","name":"dynamic_no_pic?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":311,"url":null},"def":{"name":"dynamic_no_pic?","visibility":"Public","body":"self == DynamicNoPIC"}},{"html_id":"pic?-instance-method","name":"pic?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":310,"url":null},"def":{"name":"pic?","visibility":"Public","body":"self == PIC"}},{"html_id":"static?-instance-method","name":"static?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":309,"url":null},"def":{"name":"static?","visibility":"Public","body":"self == Static"}}]},{"html_id":"Crystal/LLVM/Target","path":"LLVM/Target.html","kind":"struct","full_name":"LLVM::Target","name":"Target","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/target.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"class_methods":[{"html_id":"each(&)-class-method","name":"each","abstract":false,"location":{"filename":"src/llvm/target.cr","line_number":2,"url":null},"def":{"name":"each","yields":1,"visibility":"Public","body":"target = LibLLVM.get_first_target\nwhile target\n  yield Target.new(target)\n  target = LibLLVM.get_next_target(target)\nend\n"}}],"constructors":[{"html_id":"first:self-class-method","name":"first","abstract":false,"location":{"filename":"src/llvm/target.cr","line_number":10,"url":null},"def":{"name":"first","return_type":"self","visibility":"Public","body":"first? || (raise(\"No LLVM targets available (did you forget to invoke LLVM.init_x86?)\"))"}},{"html_id":"first?:self?-class-method","name":"first?","abstract":false,"location":{"filename":"src/llvm/target.cr","line_number":14,"url":null},"def":{"name":"first?","return_type":"self | ::Nil","visibility":"Public","body":"target = LibLLVM.get_first_target\ntarget ? Target.new(target) : nil\n"}},{"html_id":"from_triple(triple):self-class-method","name":"from_triple","abstract":false,"args":[{"name":"triple","external_name":"triple","restriction":""}],"args_string":"(triple) : self","args_html":"(triple) : <span class=\"k\">self</span>","location":{"filename":"src/llvm/target.cr","line_number":19,"url":null},"def":{"name":"from_triple","args":[{"name":"triple","external_name":"triple","restriction":""}],"return_type":"self","visibility":"Public","body":"return_code = LibLLVM.get_target_from_triple(triple, out target, out error)\nif return_code == 0\nelse\n  raise(ArgumentError.new(LLVM.string_and_dispose(error)))\nend\nnew(target)\n"}},{"html_id":"new(unwrap:LibLLVM::TargetRef)-class-method","name":"new","abstract":false,"args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::TargetRef"}],"args_string":"(unwrap : LibLLVM::TargetRef)","args_html":"(unwrap : LibLLVM::TargetRef)","location":{"filename":"src/llvm/target.cr","line_number":25,"url":null},"def":{"name":"new","args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::TargetRef"}],"visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"create_target_machine(triple,cpu=\"\",features=\"\",opt_level=LLVM::CodeGenOptLevel::Default,reloc=LLVM::RelocMode::PIC,code_model=LLVM::CodeModel::Default):LLVM::TargetMachine-instance-method","name":"create_target_machine","abstract":false,"args":[{"name":"triple","external_name":"triple","restriction":""},{"name":"cpu","default_value":"\"\"","external_name":"cpu","restriction":""},{"name":"features","default_value":"\"\"","external_name":"features","restriction":""},{"name":"opt_level","default_value":"LLVM::CodeGenOptLevel::Default","external_name":"opt_level","restriction":""},{"name":"reloc","default_value":"LLVM::RelocMode::PIC","external_name":"reloc","restriction":""},{"name":"code_model","default_value":"LLVM::CodeModel::Default","external_name":"code_model","restriction":""}],"args_string":"(triple, cpu = \"\", features = \"\", opt_level = LLVM::CodeGenOptLevel::Default, reloc = LLVM::RelocMode::PIC, code_model = LLVM::CodeModel::Default) : LLVM::TargetMachine","args_html":"(triple, cpu = <span class=\"s\">&quot;&quot;</span>, features = <span class=\"s\">&quot;&quot;</span>, opt_level = <span class=\"t\">LLVM</span><span class=\"t\">::</span><span class=\"t\">CodeGenOptLevel</span><span class=\"t\">::</span><span class=\"t\">Default</span>, reloc = <span class=\"t\">LLVM</span><span class=\"t\">::</span><span class=\"t\">RelocMode</span><span class=\"t\">::</span><span class=\"t\">PIC</span>, code_model = <span class=\"t\">LLVM</span><span class=\"t\">::</span><span class=\"t\">CodeModel</span><span class=\"t\">::</span><span class=\"t\">Default</span>) : <a href=\"../LLVM/TargetMachine.html\">LLVM::TargetMachine</a>","location":{"filename":"src/llvm/target.cr","line_number":36,"url":null},"def":{"name":"create_target_machine","args":[{"name":"triple","external_name":"triple","restriction":""},{"name":"cpu","default_value":"\"\"","external_name":"cpu","restriction":""},{"name":"features","default_value":"\"\"","external_name":"features","restriction":""},{"name":"opt_level","default_value":"LLVM::CodeGenOptLevel::Default","external_name":"opt_level","restriction":""},{"name":"reloc","default_value":"LLVM::RelocMode::PIC","external_name":"reloc","restriction":""},{"name":"code_model","default_value":"LLVM::CodeModel::Default","external_name":"code_model","restriction":""}],"return_type":"LLVM::TargetMachine","visibility":"Public","body":"target_machine = LibLLVM.create_target_machine(self, triple, cpu, features, opt_level, reloc, code_model)\ntarget_machine ? TargetMachine.new(target_machine) : raise(\"Couldn't create target machine\")\n"}},{"html_id":"description-instance-method","name":"description","abstract":false,"location":{"filename":"src/llvm/target.cr","line_number":32,"url":null},"def":{"name":"description","visibility":"Public","body":"String.new(LibLLVM.get_target_description(self))"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends this struct's name and instance variables names and values\nto the given IO.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np1.to_s    # \"Point(@x=1, @y=2)\"\np1.inspect # \"Point(@x=1, @y=2)\"\n```","summary":"<p>Appends this struct's name and instance variables names and values to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/llvm/target.cr","line_number":52,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"name-instance-method","name":"name","abstract":false,"location":{"filename":"src/llvm/target.cr","line_number":28,"url":null},"def":{"name":"name","visibility":"Public","body":"String.new(LibLLVM.get_target_name(self))"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Same as `#inspect(io)`.","summary":"<p>Same as <code><a href=\"../LLVM/Target.html#inspect%28io%3AIO%29%3ANil-instance-method\">#inspect(io)</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/llvm/target.cr","line_number":44,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"LLVM::Target(name=\"\nname.inspect(io)\nio << \", description=\"\ndescription.inspect(io)\nio << ')'\n"}},{"html_id":"to_unsafe:LibLLVM::TargetRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/target.cr","line_number":56,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}}]},{"html_id":"Crystal/LLVM/TargetData","path":"LLVM/TargetData.html","kind":"struct","full_name":"LLVM::TargetData","name":"TargetData","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/target_data.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new(unwrap:LibLLVM::TargetDataRef)-class-method","name":"new","abstract":false,"args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::TargetDataRef"}],"args_string":"(unwrap : LibLLVM::TargetDataRef)","args_html":"(unwrap : LibLLVM::TargetDataRef)","location":{"filename":"src/llvm/target_data.cr","line_number":2,"url":null},"def":{"name":"new","args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::TargetDataRef"}],"visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"abi_alignment(type)-instance-method","name":"abi_alignment","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""}],"args_string":"(type)","args_html":"(type)","location":{"filename":"src/llvm/target_data.cr","line_number":17,"url":null},"def":{"name":"abi_alignment","args":[{"name":"type","external_name":"type","restriction":""}],"visibility":"Public","body":"LibLLVM.abi_alignment_of_type(self, type)"}},{"html_id":"abi_size(type)-instance-method","name":"abi_size","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""}],"args_string":"(type)","args_html":"(type)","location":{"filename":"src/llvm/target_data.cr","line_number":13,"url":null},"def":{"name":"abi_size","args":[{"name":"type","external_name":"type","restriction":""}],"visibility":"Public","body":"LibLLVM.abi_size_of_type(self, type)"}},{"html_id":"offset_of_element(struct_type,element)-instance-method","name":"offset_of_element","abstract":false,"args":[{"name":"struct_type","external_name":"struct_type","restriction":""},{"name":"element","external_name":"element","restriction":""}],"args_string":"(struct_type, element)","args_html":"(struct_type, element)","location":{"filename":"src/llvm/target_data.cr","line_number":25,"url":null},"def":{"name":"offset_of_element","args":[{"name":"struct_type","external_name":"struct_type","restriction":""},{"name":"element","external_name":"element","restriction":""}],"visibility":"Public","body":"LibLLVM.offset_of_element(self, struct_type, element)"}},{"html_id":"size_in_bits(type)-instance-method","name":"size_in_bits","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""}],"args_string":"(type)","args_html":"(type)","location":{"filename":"src/llvm/target_data.cr","line_number":5,"url":null},"def":{"name":"size_in_bits","args":[{"name":"type","external_name":"type","restriction":""}],"visibility":"Public","body":"LibLLVM.size_of_type_in_bits(self, type)"}},{"html_id":"size_in_bytes(type)-instance-method","name":"size_in_bytes","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""}],"args_string":"(type)","args_html":"(type)","location":{"filename":"src/llvm/target_data.cr","line_number":9,"url":null},"def":{"name":"size_in_bytes","args":[{"name":"type","external_name":"type","restriction":""}],"visibility":"Public","body":"(size_in_bits(type)) // 8"}},{"html_id":"to_data_layout_string-instance-method","name":"to_data_layout_string","abstract":false,"location":{"filename":"src/llvm/target_data.cr","line_number":29,"url":null},"def":{"name":"to_data_layout_string","visibility":"Public","body":"String.new(LibLLVM.copy_string_rep_of_target_data(self))"}},{"html_id":"to_unsafe:LibLLVM::TargetDataRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/target_data.cr","line_number":21,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}}]},{"html_id":"Crystal/LLVM/TargetMachine","path":"LLVM/TargetMachine.html","kind":"class","full_name":"LLVM::TargetMachine","name":"TargetMachine","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/target_machine.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new(unwrap:LibLLVM::TargetMachineRef)-class-method","name":"new","abstract":false,"args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::TargetMachineRef"}],"args_string":"(unwrap : LibLLVM::TargetMachineRef)","args_html":"(unwrap : LibLLVM::TargetMachineRef)","location":{"filename":"src/llvm/target_machine.cr","line_number":2,"url":null},"def":{"name":"new","args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::TargetMachineRef"}],"visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"abi-instance-method","name":"abi","abstract":false,"location":{"filename":"src/llvm/target_machine.cr","line_number":47,"url":null},"def":{"name":"abi","visibility":"Public","body":"triple = self.triple\ncase triple\nwhen /x86_64.+windows-msvc/\n  ABI::X86_Win64.new(self)\nwhen /x86_64|amd64/\n  ABI::X86_64.new(self)\nwhen /i386|i486|i586|i686/\n  ABI::X86.new(self)\nwhen /aarch64|arm64/\n  ABI::AArch64.new(self)\nwhen /arm/\n  ABI::ARM.new(self)\nelse\n  raise(\"Unsupported ABI for target triple: #{triple}\")\nend\n"}},{"html_id":"data_layout:LLVM::TargetData-instance-method","name":"data_layout","abstract":false,"location":{"filename":"src/llvm/target_machine.cr","line_number":10,"url":null},"def":{"name":"data_layout","return_type":"LLVM::TargetData","visibility":"Public","body":"@layout || (@layout = (begin\n  layout = {% if LibLLVM::IS_38 %}\n                 LibLLVM.get_target_machine_data(self)\n               {% else %}\n                 # LLVM >= 3.9\n                 LibLLVM.create_target_data_layout(self)\n               {% end %}\n  layout ? TargetData.new(layout) : raise(\"Missing layout for #{self}\")\nend))"}},{"html_id":"emit_asm_to_file(llvm_mod,filename)-instance-method","name":"emit_asm_to_file","abstract":false,"args":[{"name":"llvm_mod","external_name":"llvm_mod","restriction":""},{"name":"filename","external_name":"filename","restriction":""}],"args_string":"(llvm_mod, filename)","args_html":"(llvm_mod, filename)","location":{"filename":"src/llvm/target_machine.cr","line_number":31,"url":null},"def":{"name":"emit_asm_to_file","args":[{"name":"llvm_mod","external_name":"llvm_mod","restriction":""},{"name":"filename","external_name":"filename","restriction":""}],"visibility":"Public","body":"emit_to_file(llvm_mod, filename, LLVM::CodeGenFileType::AssemblyFile)"}},{"html_id":"emit_obj_to_file(llvm_mod,filename)-instance-method","name":"emit_obj_to_file","abstract":false,"args":[{"name":"llvm_mod","external_name":"llvm_mod","restriction":""},{"name":"filename","external_name":"filename","restriction":""}],"args_string":"(llvm_mod, filename)","args_html":"(llvm_mod, filename)","location":{"filename":"src/llvm/target_machine.cr","line_number":27,"url":null},"def":{"name":"emit_obj_to_file","args":[{"name":"llvm_mod","external_name":"llvm_mod","restriction":""},{"name":"filename","external_name":"filename","restriction":""}],"visibility":"Public","body":"emit_to_file(llvm_mod, filename, LLVM::CodeGenFileType::ObjectFile)"}},{"html_id":"enable_global_isel=(enable:Bool)-instance-method","name":"enable_global_isel=","abstract":false,"args":[{"name":"enable","external_name":"enable","restriction":"Bool"}],"args_string":"(enable : Bool)","args_html":"(enable : <a href=\"../Bool.html\">Bool</a>)","location":{"filename":"src/llvm/target_machine.cr","line_number":35,"url":null},"def":{"name":"enable_global_isel=","args":[{"name":"enable","external_name":"enable","restriction":"Bool"}],"visibility":"Public","body":"LibLLVMExt.target_machine_enable_global_isel(self, enable)"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/llvm/target_machine.cr","line_number":69,"url":null},"def":{"name":"finalize","visibility":"Public","body":"LibLLVM.dispose_target_machine(@unwrap)"}},{"html_id":"target-instance-method","name":"target","abstract":false,"location":{"filename":"src/llvm/target_machine.cr","line_number":5,"url":null},"def":{"name":"target","visibility":"Public","body":"target = LibLLVM.get_target_machine_target(self)\ntarget ? Target.new(target) : raise(\"Couldn't get target\")\n"}},{"html_id":"to_unsafe:LibLLVM::TargetMachineRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/target_machine.cr","line_number":65,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}},{"html_id":"triple:String-instance-method","name":"triple","abstract":false,"location":{"filename":"src/llvm/target_machine.cr","line_number":22,"url":null},"def":{"name":"triple","return_type":"String","visibility":"Public","body":"triple_c = LibLLVM.get_target_machine_triple(self)\nLLVM.string_and_dispose(triple_c)\n"}}]},{"html_id":"Crystal/LLVM/Type","path":"LLVM/Type.html","kind":"struct","full_name":"LLVM::Type","name":"Type","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":274,"url":null},{"filename":"src/llvm/type.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"function(arg_types:Array(LLVM::Type),return_type,varargs=false):self-class-method","name":"function","abstract":false,"args":[{"name":"arg_types","external_name":"arg_types","restriction":"Array(LLVM::Type)"},{"name":"return_type","external_name":"return_type","restriction":""},{"name":"varargs","default_value":"false","external_name":"varargs","restriction":""}],"args_string":"(arg_types : Array(LLVM::Type), return_type, varargs = false) : self","args_html":"(arg_types : <a href=\"../Array.html\">Array</a>(<a href=\"../LLVM/Type.html\">LLVM::Type</a>), return_type, varargs = <span class=\"n\">false</span>) : <span class=\"k\">self</span>","location":{"filename":"src/llvm/type.cr","line_number":11,"url":null},"def":{"name":"function","args":[{"name":"arg_types","external_name":"arg_types","restriction":"Array(LLVM::Type)"},{"name":"return_type","external_name":"return_type","restriction":""},{"name":"varargs","default_value":"false","external_name":"varargs","restriction":""}],"return_type":"self","visibility":"Public","body":"new(LibLLVM.function_type(return_type, (arg_types.to_unsafe.as(::Pointer(LibLLVM::TypeRef))), arg_types.size, varargs ? 1 : 0))"}},{"html_id":"new(unwrap:LibLLVM::TypeRef)-class-method","name":"new","abstract":false,"args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::TypeRef"}],"args_string":"(unwrap : LibLLVM::TypeRef)","args_html":"(unwrap : LibLLVM::TypeRef)","location":{"filename":"src/llvm/type.cr","line_number":4,"url":null},"def":{"name":"new","args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::TypeRef"}],"visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"array(count):LLVM::Type-instance-method","name":"array","abstract":false,"args":[{"name":"count","external_name":"count","restriction":""}],"args_string":"(count) : LLVM::Type","args_html":"(count) : <a href=\"../LLVM/Type.html\">LLVM::Type</a>","location":{"filename":"src/llvm/type.cr","line_number":48,"url":null},"def":{"name":"array","args":[{"name":"count","external_name":"count","restriction":""}],"return_type":"LLVM::Type","visibility":"Public","body":"Type.new(LibLLVM.array_type(self, count))"}},{"html_id":"array_size:Int32-instance-method","name":"array_size","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":95,"url":null},"def":{"name":"array_size","return_type":"Int32","visibility":"Public","body":"if kind == Kind::Array\nelse\n  raise(\"Not an Array\")\nend\n(LibLLVM.get_array_length(self)).to_i32\n"}},{"html_id":"const_array(values:Array(LLVM::Value)):Value-instance-method","name":"const_array","abstract":false,"args":[{"name":"values","external_name":"values","restriction":"Array(LLVM::Value)"}],"args_string":"(values : Array(LLVM::Value)) : Value","args_html":"(values : <a href=\"../Array.html\">Array</a>(<a href=\"../LLVM/Value.html\">LLVM::Value</a>)) : <a href=\"../LLVM/Value.html\">Value</a>","location":{"filename":"src/llvm/type.cr","line_number":153,"url":null},"def":{"name":"const_array","args":[{"name":"values","external_name":"values","restriction":"Array(LLVM::Value)"}],"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.const_array(self, (values.to_unsafe.as(::Pointer(LibLLVM::ValueRef))), values.size))"}},{"html_id":"const_double(value:Float64):Value-instance-method","name":"const_double","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Value","args_html":"(value : <a href=\"../Float64.html\">Float64</a>) : <a href=\"../LLVM/Value.html\">Value</a>","location":{"filename":"src/llvm/type.cr","line_number":145,"url":null},"def":{"name":"const_double","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.const_real(self, value))"}},{"html_id":"const_double(string:String):Value-instance-method","name":"const_double","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String) : Value","args_html":"(string : <a href=\"../String.html\">String</a>) : <a href=\"../LLVM/Value.html\">Value</a>","location":{"filename":"src/llvm/type.cr","line_number":149,"url":null},"def":{"name":"const_double","args":[{"name":"string","external_name":"string","restriction":"String"}],"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.const_real_of_string(self, string))"}},{"html_id":"const_float(value:Float32):Value-instance-method","name":"const_float","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Value","args_html":"(value : <a href=\"../Float32.html\">Float32</a>) : <a href=\"../LLVM/Value.html\">Value</a>","location":{"filename":"src/llvm/type.cr","line_number":137,"url":null},"def":{"name":"const_float","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.const_real(self, value))"}},{"html_id":"const_float(value:String):Value-instance-method","name":"const_float","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(value : String) : Value","args_html":"(value : <a href=\"../String.html\">String</a>) : <a href=\"../LLVM/Value.html\">Value</a>","location":{"filename":"src/llvm/type.cr","line_number":141,"url":null},"def":{"name":"const_float","args":[{"name":"value","external_name":"value","restriction":"String"}],"return_type":"Value","visibility":"Public","body":"Value.new(LibLLVM.const_real_of_string(self, value))"}},{"html_id":"const_int(value):Value-instance-method","name":"const_int","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : Value","args_html":"(value) : <a href=\"../LLVM/Value.html\">Value</a>","location":{"filename":"src/llvm/type.cr","line_number":128,"url":null},"def":{"name":"const_int","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"Value","visibility":"Public","body":"if ((!value.is_a?(Int128)) && (!value.is_a?(UInt128))) && (int_width != 128)\n  Value.new(LibLLVM.const_int(self, value, 0))\nelse\n  encoded_value = UInt64[value & UInt64::MAX, (value >> 64) & UInt64::MAX]\n  Value.new(LibLLVM.const_int_of_arbitrary_precision(self, encoded_value.size, encoded_value))\nend"}},{"html_id":"context:Context-instance-method","name":"context","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":194,"url":null},"def":{"name":"context","return_type":"Context","visibility":"Public","body":"Context.new(LibLLVM.get_type_context(self), dispose_on_finalize: false)"}},{"html_id":"element_type:LLVM::Type-instance-method","name":"element_type","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":86,"url":null},"def":{"name":"element_type","return_type":"LLVM::Type","visibility":"Public","body":"case kind\nwhen Kind::Array, Kind::Vector, Kind::Pointer\n  Type.new(LibLLVM.get_element_type(self))\nelse\n  raise(\"Not a sequential type\")\nend"}},{"html_id":"inline_asm(asm_string,constraints,has_side_effects=false,is_align_stack=false,can_throw=false)-instance-method","name":"inline_asm","abstract":false,"args":[{"name":"asm_string","external_name":"asm_string","restriction":""},{"name":"constraints","external_name":"constraints","restriction":""},{"name":"has_side_effects","default_value":"false","external_name":"has_side_effects","restriction":""},{"name":"is_align_stack","default_value":"false","external_name":"is_align_stack","restriction":""},{"name":"can_throw","default_value":"false","external_name":"can_throw","restriction":""}],"args_string":"(asm_string, constraints, has_side_effects = false, is_align_stack = false, can_throw = false)","args_html":"(asm_string, constraints, has_side_effects = <span class=\"n\">false</span>, is_align_stack = <span class=\"n\">false</span>, can_throw = <span class=\"n\">false</span>)","location":{"filename":"src/llvm/type.cr","line_number":157,"url":null},"def":{"name":"inline_asm","args":[{"name":"asm_string","external_name":"asm_string","restriction":""},{"name":"constraints","external_name":"constraints","restriction":""},{"name":"has_side_effects","default_value":"false","external_name":"has_side_effects","restriction":""},{"name":"is_align_stack","default_value":"false","external_name":"is_align_stack","restriction":""},{"name":"can_throw","default_value":"false","external_name":"can_throw","restriction":""}],"visibility":"Public","body":"value = {% if LibLLVM::IS_LT_70 %}\n        LibLLVM.const_inline_asm(\n          self,\n          asm_string,\n          constraints,\n          (has_side_effects ? 1 : 0),\n          (is_align_stack ? 1 : 0)\n        )\n      {% else %}{% if LibLLVM::IS_LT_130 %}\n        LibLLVM.get_inline_asm(\n          self,\n          asm_string,\n          asm_string.size,\n          constraints,\n          constraints.size,\n          (has_side_effects ? 1 : 0),\n          (is_align_stack ? 1 : 0),\n          LibLLVM::InlineAsmDialect::Intel\n        )\n      {% else %}\n        LibLLVM.get_inline_asm(\n          self,\n          asm_string,\n          asm_string.size,\n          constraints,\n          constraints.size,\n          (has_side_effects ? 1 : 0),\n          (is_align_stack ? 1 : 0),\n          LibLLVM::InlineAsmDialect::Intel,\n          (can_throw ? 1 : 0)\n        )\n      {% end %}{% end %}\nValue.new(value)\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends this struct's name and instance variables names and values\nto the given IO.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np1.to_s    # \"Point(@x=1, @y=2)\"\np1.inspect # \"Point(@x=1, @y=2)\"\n```","summary":"<p>Appends this struct's name and instance variables names and values to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/llvm/type.cr","line_number":198,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"LLVM.to_io(LibLLVM.print_type_to_string(self), io)\nself\n"}},{"html_id":"int_width:Int32-instance-method","name":"int_width","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":56,"url":null},"def":{"name":"int_width","return_type":"Int32","visibility":"Public","body":"if kind == Kind::Integer\nelse\n  raise(\"Not an Integer\")\nend\n(LibLLVM.get_int_type_width(self)).to_i32\n"}},{"html_id":"kind:LLVM::Type::Kind-instance-method","name":"kind","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":24,"url":null},"def":{"name":"kind","return_type":"LLVM::Type::Kind","visibility":"Public","body":"LibLLVM.get_type_kind(self)"}},{"html_id":"null-instance-method","name":"null","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":32,"url":null},"def":{"name":"null","visibility":"Public","body":"Value.new(LibLLVM.const_null(self))"}},{"html_id":"null_pointer-instance-method","name":"null_pointer","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":36,"url":null},"def":{"name":"null_pointer","visibility":"Public","body":"Value.new(LibLLVM.const_pointer_null(self))"}},{"html_id":"packed_struct?:Bool-instance-method","name":"packed_struct?","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":61,"url":null},"def":{"name":"packed_struct?","return_type":"Bool","visibility":"Public","body":"if kind == Kind::Struct\nelse\n  raise(\"Not a Struct\")\nend\n(LibLLVM.is_packed_struct(self)) != 0\n"}},{"html_id":"params_size-instance-method","name":"params_size","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":118,"url":null},"def":{"name":"params_size","visibility":"Public","body":"if kind == Kind::Function\nelse\n  raise(\"not a Function\")\nend\n(LibLLVM.count_param_types(self)).to_i\n"}},{"html_id":"params_types-instance-method","name":"params_types","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":110,"url":null},"def":{"name":"params_types","visibility":"Public","body":"params_size = self.params_size\nArray(LLVM::Type).build(params_size) do |buffer|\n  LibLLVM.get_param_types(self, buffer.as(::Pointer(LibLLVM::TypeRef)))\n  params_size\nend\n"}},{"html_id":"pointer:LLVM::Type-instance-method","name":"pointer","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":44,"url":null},"def":{"name":"pointer","return_type":"LLVM::Type","visibility":"Public","body":"Type.new(LibLLVM.pointer_type(self, 0))"}},{"html_id":"return_type-instance-method","name":"return_type","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":105,"url":null},"def":{"name":"return_type","visibility":"Public","body":"if kind == Kind::Function\nelse\n  raise(\"not a Function\")\nend\nType.new(LibLLVM.get_return_type(self))\n"}},{"html_id":"size-instance-method","name":"size","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":15,"url":null},"def":{"name":"size","visibility":"Public","body":"if void?\n  context.int64.const_int(1)\nelse\n  Value.new(LibLLVM.size_of(self))\nend"}},{"html_id":"struct_element_types:Array(LLVM::Type)-instance-method","name":"struct_element_types","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":76,"url":null},"def":{"name":"struct_element_types","return_type":"Array(LLVM::Type)","visibility":"Public","body":"if kind == Kind::Struct\nelse\n  raise(\"Not a Struct\")\nend\ncount = LibLLVM.count_struct_element_types(self)\nArray(LLVM::Type).build(count) do |buffer|\n  LibLLVM.get_struct_element_types(self, buffer.as(::Pointer(LibLLVM::TypeRef)))\n  count\nend\n"}},{"html_id":"struct_name:String?-instance-method","name":"struct_name","doc":"Assuming this type is a struct, returns its name.\nThe name can be `nil` if the struct is anonymous.\nRaises if this type is not a struct.","summary":"<p>Assuming this type is a struct, returns its name.</p>","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":69,"url":null},"def":{"name":"struct_name","return_type":"String | ::Nil","visibility":"Public","body":"if kind == Kind::Struct\nelse\n  raise(\"not a Struct\")\nend\nname = LibLLVM.get_struct_name(self)\nname ? String.new(name) : nil\n"}},{"html_id":"to_unsafe:LibLLVM::TypeRef-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":7,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}},{"html_id":"undef-instance-method","name":"undef","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":40,"url":null},"def":{"name":"undef","visibility":"Public","body":"Value.new(LibLLVM.get_undef(self))"}},{"html_id":"unwrap:LibLLVM::TypeRef-instance-method","name":"unwrap","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":2,"url":null},"def":{"name":"unwrap","return_type":"LibLLVM::TypeRef","visibility":"Public","body":"@unwrap"}},{"html_id":"varargs?-instance-method","name":"varargs?","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":123,"url":null},"def":{"name":"varargs?","visibility":"Public","body":"if kind == Kind::Function\nelse\n  raise(\"not a Function\")\nend\n(LibLLVM.is_function_var_arg(self)) != 0\n"}},{"html_id":"vector(count):self-instance-method","name":"vector","abstract":false,"args":[{"name":"count","external_name":"count","restriction":""}],"args_string":"(count) : self","args_html":"(count) : <span class=\"k\">self</span>","location":{"filename":"src/llvm/type.cr","line_number":52,"url":null},"def":{"name":"vector","args":[{"name":"count","external_name":"count","restriction":""}],"return_type":"self","visibility":"Public","body":"Type.new(LibLLVM.vector_type(self, count))"}},{"html_id":"vector_size-instance-method","name":"vector_size","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":100,"url":null},"def":{"name":"vector_size","visibility":"Public","body":"if kind == Kind::Vector\nelse\n  raise(\"not a Vector\")\nend\n(LibLLVM.get_vector_size(self)).to_i32\n"}},{"html_id":"void?-instance-method","name":"void?","abstract":false,"location":{"filename":"src/llvm/type.cr","line_number":28,"url":null},"def":{"name":"void?","visibility":"Public","body":"kind == Kind::Void"}}],"types":[{"html_id":"Crystal/LLVM/Type/Kind","path":"LLVM/Type/Kind.html","kind":"enum","full_name":"LLVM::Type::Kind","name":"Kind","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":275,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Void","name":"Void","value":"0"},{"id":"Half","name":"Half","value":"1"},{"id":"Float","name":"Float","value":"2"},{"id":"Double","name":"Double","value":"3"},{"id":"X86_FP80","name":"X86_FP80","value":"4"},{"id":"FP128","name":"FP128","value":"5"},{"id":"PPC_FP128","name":"PPC_FP128","value":"6"},{"id":"Label","name":"Label","value":"7"},{"id":"Integer","name":"Integer","value":"8"},{"id":"Function","name":"Function","value":"9"},{"id":"Struct","name":"Struct","value":"10"},{"id":"Array","name":"Array","value":"11"},{"id":"Pointer","name":"Pointer","value":"12"},{"id":"Vector","name":"Vector","value":"13"},{"id":"Metadata","name":"Metadata","value":"14"},{"id":"X86_MMX","name":"X86_MMX","value":"15"}],"namespace":{"html_id":"Crystal/LLVM/Type","kind":"struct","full_name":"LLVM::Type","name":"Type"},"instance_methods":[{"html_id":"array?-instance-method","name":"array?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":287,"url":null},"def":{"name":"array?","visibility":"Public","body":"self == Array"}},{"html_id":"double?-instance-method","name":"double?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":279,"url":null},"def":{"name":"double?","visibility":"Public","body":"self == Double"}},{"html_id":"float?-instance-method","name":"float?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":278,"url":null},"def":{"name":"float?","visibility":"Public","body":"self == Float"}},{"html_id":"fp128?-instance-method","name":"fp128?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":281,"url":null},"def":{"name":"fp128?","visibility":"Public","body":"self == FP128"}},{"html_id":"function?-instance-method","name":"function?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":285,"url":null},"def":{"name":"function?","visibility":"Public","body":"self == Function"}},{"html_id":"half?-instance-method","name":"half?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":277,"url":null},"def":{"name":"half?","visibility":"Public","body":"self == Half"}},{"html_id":"integer?-instance-method","name":"integer?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":284,"url":null},"def":{"name":"integer?","visibility":"Public","body":"self == Integer"}},{"html_id":"label?-instance-method","name":"label?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":283,"url":null},"def":{"name":"label?","visibility":"Public","body":"self == Label"}},{"html_id":"metadata?-instance-method","name":"metadata?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":290,"url":null},"def":{"name":"metadata?","visibility":"Public","body":"self == Metadata"}},{"html_id":"pointer?-instance-method","name":"pointer?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":288,"url":null},"def":{"name":"pointer?","visibility":"Public","body":"self == Pointer"}},{"html_id":"ppc_fp128?-instance-method","name":"ppc_fp128?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":282,"url":null},"def":{"name":"ppc_fp128?","visibility":"Public","body":"self == PPC_FP128"}},{"html_id":"struct?-instance-method","name":"struct?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":286,"url":null},"def":{"name":"struct?","visibility":"Public","body":"self == Struct"}},{"html_id":"vector?-instance-method","name":"vector?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":289,"url":null},"def":{"name":"vector?","visibility":"Public","body":"self == Vector"}},{"html_id":"void?-instance-method","name":"void?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":276,"url":null},"def":{"name":"void?","visibility":"Public","body":"self == Void"}},{"html_id":"x86_fp80?-instance-method","name":"x86_fp80?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":280,"url":null},"def":{"name":"x86_fp80?","visibility":"Public","body":"self == X86_FP80"}},{"html_id":"x86_mmx?-instance-method","name":"x86_mmx?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":291,"url":null},"def":{"name":"x86_mmx?","visibility":"Public","body":"self == X86_MMX"}}]}]},{"html_id":"Crystal/LLVM/Value","path":"LLVM/Value.html","kind":"struct","full_name":"LLVM::Value","name":"Value","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/LLVM/ValueMethods","kind":"module","full_name":"LLVM::ValueMethods","name":"ValueMethods"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":423,"url":null},{"filename":"src/llvm/value.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/LLVM/ValueMethods","kind":"module","full_name":"LLVM::ValueMethods","name":"ValueMethods"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"class_methods":[{"html_id":"null-class-method","name":"null","abstract":false,"location":{"filename":"src/llvm/value.cr","line_number":6,"url":null},"def":{"name":"null","visibility":"Public","body":"LLVM::Value.new(Pointer(::Void).null.as(LibLLVM::ValueRef))"}}],"instance_methods":[{"html_id":"to_value-instance-method","name":"to_value","abstract":false,"location":{"filename":"src/llvm/value.cr","line_number":10,"url":null},"def":{"name":"to_value","visibility":"Public","body":"self"}}],"types":[{"html_id":"Crystal/LLVM/Value/Kind","path":"LLVM/Value/Kind.html","kind":"enum","full_name":"LLVM::Value::Kind","name":"Kind","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":424,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Argument","name":"Argument","value":"0"},{"id":"BasicBlock","name":"BasicBlock","value":"1"},{"id":"MemoryUse","name":"MemoryUse","value":"2"},{"id":"MemoryDef","name":"MemoryDef","value":"3"},{"id":"MemoryPhi","name":"MemoryPhi","value":"4"},{"id":"Function","name":"Function","value":"5"},{"id":"GlobalAlias","name":"GlobalAlias","value":"6"},{"id":"GlobalIFunc","name":"GlobalIFunc","value":"7"},{"id":"GlobalVariable","name":"GlobalVariable","value":"8"},{"id":"BlockAddress","name":"BlockAddress","value":"9"},{"id":"ConstantExpr","name":"ConstantExpr","value":"10"},{"id":"ConstantArray","name":"ConstantArray","value":"11"},{"id":"ConstantStruct","name":"ConstantStruct","value":"12"},{"id":"ConstantVector","name":"ConstantVector","value":"13"},{"id":"UndefValue","name":"UndefValue","value":"14"},{"id":"ConstantAggregateZero","name":"ConstantAggregateZero","value":"15"},{"id":"ConstantDataArray","name":"ConstantDataArray","value":"16"},{"id":"ConstantDataVector","name":"ConstantDataVector","value":"17"},{"id":"ConstantInt","name":"ConstantInt","value":"18"},{"id":"ConstantFP","name":"ConstantFP","value":"19"},{"id":"ConstantPointerNull","name":"ConstantPointerNull","value":"20"},{"id":"ConstantTokenNone","name":"ConstantTokenNone","value":"21"},{"id":"MetadataAsValue","name":"MetadataAsValue","value":"22"},{"id":"InlineAsm","name":"InlineAsm","value":"23"},{"id":"Instruction","name":"Instruction","value":"24"}],"namespace":{"html_id":"Crystal/LLVM/Value","kind":"struct","full_name":"LLVM::Value","name":"Value"},"instance_methods":[{"html_id":"argument?-instance-method","name":"argument?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":425,"url":null},"def":{"name":"argument?","visibility":"Public","body":"self == Argument"}},{"html_id":"basic_block?-instance-method","name":"basic_block?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":426,"url":null},"def":{"name":"basic_block?","visibility":"Public","body":"self == BasicBlock"}},{"html_id":"block_address?-instance-method","name":"block_address?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":435,"url":null},"def":{"name":"block_address?","visibility":"Public","body":"self == BlockAddress"}},{"html_id":"constant_aggregate_zero?-instance-method","name":"constant_aggregate_zero?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":442,"url":null},"def":{"name":"constant_aggregate_zero?","visibility":"Public","body":"self == ConstantAggregateZero"}},{"html_id":"constant_array?-instance-method","name":"constant_array?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":437,"url":null},"def":{"name":"constant_array?","visibility":"Public","body":"self == ConstantArray"}},{"html_id":"constant_data_array?-instance-method","name":"constant_data_array?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":443,"url":null},"def":{"name":"constant_data_array?","visibility":"Public","body":"self == ConstantDataArray"}},{"html_id":"constant_data_vector?-instance-method","name":"constant_data_vector?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":444,"url":null},"def":{"name":"constant_data_vector?","visibility":"Public","body":"self == ConstantDataVector"}},{"html_id":"constant_expr?-instance-method","name":"constant_expr?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":436,"url":null},"def":{"name":"constant_expr?","visibility":"Public","body":"self == ConstantExpr"}},{"html_id":"constant_fp?-instance-method","name":"constant_fp?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":446,"url":null},"def":{"name":"constant_fp?","visibility":"Public","body":"self == ConstantFP"}},{"html_id":"constant_int?-instance-method","name":"constant_int?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":445,"url":null},"def":{"name":"constant_int?","visibility":"Public","body":"self == ConstantInt"}},{"html_id":"constant_pointer_null?-instance-method","name":"constant_pointer_null?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":447,"url":null},"def":{"name":"constant_pointer_null?","visibility":"Public","body":"self == ConstantPointerNull"}},{"html_id":"constant_struct?-instance-method","name":"constant_struct?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":438,"url":null},"def":{"name":"constant_struct?","visibility":"Public","body":"self == ConstantStruct"}},{"html_id":"constant_token_none?-instance-method","name":"constant_token_none?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":448,"url":null},"def":{"name":"constant_token_none?","visibility":"Public","body":"self == ConstantTokenNone"}},{"html_id":"constant_vector?-instance-method","name":"constant_vector?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":439,"url":null},"def":{"name":"constant_vector?","visibility":"Public","body":"self == ConstantVector"}},{"html_id":"function?-instance-method","name":"function?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":431,"url":null},"def":{"name":"function?","visibility":"Public","body":"self == Function"}},{"html_id":"global_alias?-instance-method","name":"global_alias?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":432,"url":null},"def":{"name":"global_alias?","visibility":"Public","body":"self == GlobalAlias"}},{"html_id":"global_i_func?-instance-method","name":"global_i_func?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":433,"url":null},"def":{"name":"global_i_func?","visibility":"Public","body":"self == GlobalIFunc"}},{"html_id":"global_variable?-instance-method","name":"global_variable?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":434,"url":null},"def":{"name":"global_variable?","visibility":"Public","body":"self == GlobalVariable"}},{"html_id":"inline_asm?-instance-method","name":"inline_asm?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":451,"url":null},"def":{"name":"inline_asm?","visibility":"Public","body":"self == InlineAsm"}},{"html_id":"instruction?-instance-method","name":"instruction?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":453,"url":null},"def":{"name":"instruction?","visibility":"Public","body":"self == Instruction"}},{"html_id":"memory_def?-instance-method","name":"memory_def?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":428,"url":null},"def":{"name":"memory_def?","visibility":"Public","body":"self == MemoryDef"}},{"html_id":"memory_phi?-instance-method","name":"memory_phi?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":429,"url":null},"def":{"name":"memory_phi?","visibility":"Public","body":"self == MemoryPhi"}},{"html_id":"memory_use?-instance-method","name":"memory_use?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":427,"url":null},"def":{"name":"memory_use?","visibility":"Public","body":"self == MemoryUse"}},{"html_id":"metadata_as_value?-instance-method","name":"metadata_as_value?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":450,"url":null},"def":{"name":"metadata_as_value?","visibility":"Public","body":"self == MetadataAsValue"}},{"html_id":"undef_value?-instance-method","name":"undef_value?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":441,"url":null},"def":{"name":"undef_value?","visibility":"Public","body":"self == UndefValue"}}]}]},{"html_id":"Crystal/LLVM/ValueMethods","path":"LLVM/ValueMethods.html","kind":"module","full_name":"LLVM::ValueMethods","name":"ValueMethods","abstract":false,"locations":[{"filename":"src/llvm/value_methods.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"including_types":[{"html_id":"Crystal/LLVM/Function","kind":"struct","full_name":"LLVM::Function","name":"Function"},{"html_id":"Crystal/LLVM/Value","kind":"struct","full_name":"LLVM::Value","name":"Value"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"constructors":[{"html_id":"new(unwrap:LibLLVM::ValueRef)-class-method","name":"new","abstract":false,"args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::ValueRef"}],"args_string":"(unwrap : LibLLVM::ValueRef)","args_html":"(unwrap : LibLLVM::ValueRef)","location":{"filename":"src/llvm/value_methods.cr","line_number":2,"url":null},"def":{"name":"new","args":[{"name":"unwrap","external_name":"unwrap","restriction":"LibLLVM::ValueRef"}],"visibility":"Public","body":"_ = allocate\n_.initialize(unwrap)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"add_instruction_attribute(index:Int,attribute:LLVM::Attribute,context:LLVM::Context,type:LLVM::Type?=nil)-instance-method","name":"add_instruction_attribute","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"attribute","external_name":"attribute","restriction":"LLVM::Attribute"},{"name":"context","external_name":"context","restriction":"LLVM::Context"},{"name":"type","default_value":"nil","external_name":"type","restriction":"LLVM::Type | ::Nil"}],"args_string":"(index : Int, attribute : LLVM::Attribute, context : LLVM::Context, type : LLVM::Type? = nil)","args_html":"(index : <a href=\"../Int.html\">Int</a>, attribute : <a href=\"../LLVM/Attribute.html\">LLVM::Attribute</a>, context : <a href=\"../LLVM/Context.html\">LLVM::Context</a>, type : <a href=\"../LLVM/Type.html\">LLVM::Type</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/llvm/value_methods.cr","line_number":17,"url":null},"def":{"name":"add_instruction_attribute","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"attribute","external_name":"attribute","restriction":"LLVM::Attribute"},{"name":"context","external_name":"context","restriction":"LLVM::Context"},{"name":"type","default_value":"nil","external_name":"type","restriction":"LLVM::Type | ::Nil"}],"visibility":"Public","body":"if attribute.value == 0\n  return\nend\n{% if LibLLVM.has_constant?(:AttributeRef) %}\n      attribute.each_kind do |kind|\n        if type && LLVM::Attribute.requires_type?(kind)\n          attribute_ref = LibLLVMExt.create_type_attribute(context, kind, type)\n        else\n          attribute_ref = LibLLVM.create_enum_attribute(context, kind, 0)\n        end\n\n        LibLLVM.add_call_site_attribute(self, index, attribute_ref)\n      end\n    {% else %}\n      LibLLVM.add_instr_attribute(self, index, attribute)\n    {% end %}\n"}},{"html_id":"alignment=(bytes)-instance-method","name":"alignment=","abstract":false,"args":[{"name":"bytes","external_name":"bytes","restriction":""}],"args_string":"(bytes)","args_html":"(bytes)","location":{"filename":"src/llvm/value_methods.cr","line_number":95,"url":null},"def":{"name":"alignment=","args":[{"name":"bytes","external_name":"bytes","restriction":""}],"visibility":"Public","body":"LibLLVM.set_alignment(self, bytes)"}},{"html_id":"call_convention-instance-method","name":"call_convention","abstract":false,"location":{"filename":"src/llvm/value_methods.cr","line_number":66,"url":null},"def":{"name":"call_convention","visibility":"Public","body":"LibLLVM.get_instruction_call_convention(self)"}},{"html_id":"call_convention=(call_convention)-instance-method","name":"call_convention=","abstract":false,"args":[{"name":"call_convention","external_name":"call_convention","restriction":""}],"args_string":"(call_convention)","args_html":"(call_convention)","location":{"filename":"src/llvm/value_methods.cr","line_number":62,"url":null},"def":{"name":"call_convention=","args":[{"name":"call_convention","external_name":"call_convention","restriction":""}],"visibility":"Public","body":"LibLLVM.set_instruction_call_convention(self, call_convention)"}},{"html_id":"const_int_get_sext_value-instance-method","name":"const_int_get_sext_value","abstract":false,"location":{"filename":"src/llvm/value_methods.cr","line_number":99,"url":null},"def":{"name":"const_int_get_sext_value","visibility":"Public","body":"LibLLVM.const_int_get_sext_value(self)"}},{"html_id":"const_int_get_zext_value-instance-method","name":"const_int_get_zext_value","abstract":false,"location":{"filename":"src/llvm/value_methods.cr","line_number":103,"url":null},"def":{"name":"const_int_get_zext_value","visibility":"Public","body":"LibLLVM.const_int_get_zext_value(self)"}},{"html_id":"constant?-instance-method","name":"constant?","abstract":false,"location":{"filename":"src/llvm/value_methods.cr","line_number":34,"url":null},"def":{"name":"constant?","visibility":"Public","body":"(LibLLVM.is_constant(self)) != 0"}},{"html_id":"dll_storage_class=(storage_class)-instance-method","name":"dll_storage_class=","abstract":false,"args":[{"name":"storage_class","external_name":"storage_class","restriction":""}],"args_string":"(storage_class)","args_html":"(storage_class)","location":{"filename":"src/llvm/value_methods.cr","line_number":58,"url":null},"def":{"name":"dll_storage_class=","args":[{"name":"storage_class","external_name":"storage_class","restriction":""}],"visibility":"Public","body":"LibLLVM.set_dll_storage_class(self, storage_class)"}},{"html_id":"dump-instance-method","name":"dump","abstract":false,"location":{"filename":"src/llvm/value_methods.cr","line_number":111,"url":null},"def":{"name":"dump","visibility":"Public","body":"LibLLVM.dump_value(self)"}},{"html_id":"global_constant=(global_constant)-instance-method","name":"global_constant=","abstract":false,"args":[{"name":"global_constant","external_name":"global_constant","restriction":""}],"args_string":"(global_constant)","args_html":"(global_constant)","location":{"filename":"src/llvm/value_methods.cr","line_number":70,"url":null},"def":{"name":"global_constant=","args":[{"name":"global_constant","external_name":"global_constant","restriction":""}],"visibility":"Public","body":"LibLLVM.set_global_constant(self, global_constant ? 1 : 0)"}},{"html_id":"global_constant?-instance-method","name":"global_constant?","abstract":false,"location":{"filename":"src/llvm/value_methods.cr","line_number":74,"url":null},"def":{"name":"global_constant?","visibility":"Public","body":"(LibLLVM.is_global_constant(self)) != 0"}},{"html_id":"initializer-instance-method","name":"initializer","abstract":false,"location":{"filename":"src/llvm/value_methods.cr","line_number":82,"url":null},"def":{"name":"initializer","visibility":"Public","body":"init = LibLLVM.get_initializer(self)\ninit ? LLVM::Value.new(init) : nil\n"}},{"html_id":"initializer=(initializer)-instance-method","name":"initializer=","abstract":false,"args":[{"name":"initializer","external_name":"initializer","restriction":""}],"args_string":"(initializer)","args_html":"(initializer)","location":{"filename":"src/llvm/value_methods.cr","line_number":78,"url":null},"def":{"name":"initializer=","args":[{"name":"initializer","external_name":"initializer","restriction":""}],"visibility":"Public","body":"LibLLVM.set_initializer(self, initializer)"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/llvm/value_methods.cr","line_number":115,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"LLVM.to_io(LibLLVM.print_value_to_string(self), io)"}},{"html_id":"kind-instance-method","name":"kind","abstract":false,"location":{"filename":"src/llvm/value_methods.cr","line_number":13,"url":null},"def":{"name":"kind","visibility":"Public","body":"LibLLVM.get_value_kind(self)"}},{"html_id":"linkage-instance-method","name":"linkage","abstract":false,"location":{"filename":"src/llvm/value_methods.cr","line_number":54,"url":null},"def":{"name":"linkage","visibility":"Public","body":"LibLLVM.get_linkage(self)"}},{"html_id":"linkage=(linkage)-instance-method","name":"linkage=","abstract":false,"args":[{"name":"linkage","external_name":"linkage","restriction":""}],"args_string":"(linkage)","args_html":"(linkage)","location":{"filename":"src/llvm/value_methods.cr","line_number":50,"url":null},"def":{"name":"linkage=","args":[{"name":"linkage","external_name":"linkage","restriction":""}],"visibility":"Public","body":"LibLLVM.set_linkage(self, linkage)"}},{"html_id":"name-instance-method","name":"name","abstract":false,"location":{"filename":"src/llvm/value_methods.cr","line_number":9,"url":null},"def":{"name":"name","visibility":"Public","body":"String.new(LibLLVM.get_value_name(self))"}},{"html_id":"name=(name)-instance-method","name":"name=","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name)","args_html":"(name)","location":{"filename":"src/llvm/value_methods.cr","line_number":5,"url":null},"def":{"name":"name=","args":[{"name":"name","external_name":"name","restriction":""}],"visibility":"Public","body":"LibLLVM.set_value_name(self, name)"}},{"html_id":"ordering=(ordering)-instance-method","name":"ordering=","abstract":false,"args":[{"name":"ordering","external_name":"ordering","restriction":""}],"args_string":"(ordering)","args_html":"(ordering)","location":{"filename":"src/llvm/value_methods.cr","line_number":91,"url":null},"def":{"name":"ordering=","args":[{"name":"ordering","external_name":"ordering","restriction":""}],"visibility":"Public","body":"LibLLVMExt.set_ordering(self, ordering)"}},{"html_id":"thread_local=(thread_local)-instance-method","name":"thread_local=","abstract":false,"args":[{"name":"thread_local","external_name":"thread_local","restriction":""}],"args_string":"(thread_local)","args_html":"(thread_local)","location":{"filename":"src/llvm/value_methods.cr","line_number":42,"url":null},"def":{"name":"thread_local=","args":[{"name":"thread_local","external_name":"thread_local","restriction":""}],"visibility":"Public","body":"LibLLVM.set_thread_local(self, thread_local ? 1 : 0)"}},{"html_id":"thread_local?-instance-method","name":"thread_local?","abstract":false,"location":{"filename":"src/llvm/value_methods.cr","line_number":46,"url":null},"def":{"name":"thread_local?","visibility":"Public","body":"(LibLLVM.is_thread_local(self)) != 0"}},{"html_id":"to_unsafe-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/llvm/value_methods.cr","line_number":119,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@unwrap"}},{"html_id":"to_value-instance-method","name":"to_value","abstract":false,"location":{"filename":"src/llvm/value_methods.cr","line_number":107,"url":null},"def":{"name":"to_value","visibility":"Public","body":"LLVM::Value.new(@unwrap)"}},{"html_id":"type-instance-method","name":"type","abstract":false,"location":{"filename":"src/llvm/value_methods.cr","line_number":38,"url":null},"def":{"name":"type","visibility":"Public","body":"Type.new(LibLLVM.type_of(self))"}},{"html_id":"volatile=(volatile)-instance-method","name":"volatile=","abstract":false,"args":[{"name":"volatile","external_name":"volatile","restriction":""}],"args_string":"(volatile)","args_html":"(volatile)","location":{"filename":"src/llvm/value_methods.cr","line_number":87,"url":null},"def":{"name":"volatile=","args":[{"name":"volatile","external_name":"volatile","restriction":""}],"visibility":"Public","body":"LibLLVM.set_volatile(self, volatile ? 1 : 0)"}}]},{"html_id":"Crystal/LLVM/VerifierFailureAction","path":"LLVM/VerifierFailureAction.html","kind":"enum","full_name":"LLVM::VerifierFailureAction","name":"VerifierFailureAction","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/llvm/enums.cr","line_number":323,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"AbortProcessAction","name":"AbortProcessAction","value":"0"},{"id":"PrintMessageAction","name":"PrintMessageAction","value":"1","doc":"verifier will print to stderr and abort()","summary":"<p>verifier will print to stderr and abort()</p>"},{"id":"ReturnStatusAction","name":"ReturnStatusAction","value":"2","doc":"verifier will print to stderr and return 1","summary":"<p>verifier will print to stderr and return 1</p>"}],"namespace":{"html_id":"Crystal/LLVM","kind":"module","full_name":"LLVM","name":"LLVM"},"instance_methods":[{"html_id":"abort_process_action?-instance-method","name":"abort_process_action?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":324,"url":null},"def":{"name":"abort_process_action?","visibility":"Public","body":"self == AbortProcessAction"}},{"html_id":"print_message_action?-instance-method","name":"print_message_action?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":325,"url":null},"def":{"name":"print_message_action?","visibility":"Public","body":"self == PrintMessageAction"}},{"html_id":"return_status_action?-instance-method","name":"return_status_action?","abstract":false,"location":{"filename":"src/llvm/enums.cr","line_number":326,"url":null},"def":{"name":"return_status_action?","visibility":"Public","body":"self == ReturnStatusAction"}}]}]},{"html_id":"Crystal/Log","path":"Log.html","kind":"class","full_name":"Log","name":"Log","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log.cr","line_number":143,"url":null},{"filename":"src/log/dispatch.cr","line_number":1,"url":null},{"filename":"src/log/format.cr","line_number":1,"url":null},{"filename":"src/log/log.cr","line_number":1,"url":null},{"filename":"src/log/main.cr","line_number":1,"url":null},{"filename":"src/log/setup.cr","line_number":1,"url":null},{"filename":"src/log/spec.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"The `Log` class provides a logging utility that you can use to output messages.\n\nThe messages, or `Log::Entry` have associated levels, such as `Info` or `Error`\nthat indicate their importance. See `Log::Severity`.\n\nTo log a message `trace`, `debug`, `info`, `notice`, `warn`, `error`, and `fatal` methods\ncan be used. They expect a block that will evaluate to the message of the entry.\n\n```\nrequire \"log\"\n\nLog.info { \"Program started\" }\n```\n\nData can be associated with a log entry via the `Log::Emitter` yielded in the logging methods.\n\n```\nLog.info &.emit(\"User logged in\", user_id: 42)\n```\n\nIf you want to log an exception, you can indicate it in the `exception:` named argument.\n\n```\nLog.warn(exception: e) { \"Oh no!\" }\nLog.warn exception: e, &.emit(\"Oh no!\", user_id: 42)\n```\n\nThe block is only evaluated if the current message is to be emitted to some `Log::Backend`.\n\nTo add structured information to the message you can use the `Log::Context`.\n\nWhen creating log messages they belong to a _source_. If the top-level `Log` is used\nas in the above examples its source is the empty string.\n\nThe source can be used to identify the module or part of the application that is logging.\nYou can configure for each source a different level to filter the messages.\n\nA recommended pattern is to declare a `Log` constant in the namespace of your shard or module as follows:\n\n```\nmodule DB\n  Log = ::Log.for(\"db\") # => Log for db source\n\n  def do_something\n    Log.info { \"this is logged in db source\" }\n  end\nend\n\nDB::Log.info { \"this is also logged in db source\" }\nLog.for(\"db\").info { \"this is also logged in db source\" }\nLog.info { \"this is logged in top-level source\" }\n```\n\nThat way, any `Log.info` call within the `DB` module will use the `db` source. And not the top-level `::Log.info`.\n\nSources can be nested. Continuing the last example, to declare a `Log` constant `db.pool` source you can do as follows:\n\n```\nclass DB::Pool\n  Log = DB::Log.for(\"pool\") # => Log for db.pool source\nend\n```\n\nA `Log` will emit the messages to the `Log::Backend`s attached to it as long as\nthe configured severity filter `level` permits it.\n\nLogs can also be created from a type directly. For the type `DB::Pool` the source `db.pool` will be used.\nFor generic types as `Foo::Bar(Baz)` the source `foo.bar` will be used (i.e. without generic arguments).\n\n```\nmodule DB\n  Log = ::Log.for(self) # => Log for db source\nend\n```\n\n### Default logging configuration\n\nBy default entries from all sources with `Info` and above severity will\nbe logged to `STDOUT` using the `Log::IOBackend`.\n\nIf you need to change the default level, backend or sources call `Log.setup` upon startup.\n\nNOTE: Calling `setup` will override previous `setup` calls.\n\n```\nLog.setup(:debug)                     # Log debug and above for all sources to STDOUT\nLog.setup(\"myapp.*, http.*\", :notice) # Log notice and above for myapp.* and http.* sources only, and log nothing for any other source.\nbackend_with_formatter = Log::IOBackend.new(formatter: custom_formatter)\nLog.setup(:debug, backend_with_formatter) # Log debug and above for all sources to using a custom backend\n```\n\n### Configure logging explicitly in the code\n\nUse `Log.setup` methods to indicate which sources should go to which backends.\n\nYou can indicate actual sources or patterns.\n\n* the empty string matches only the top-level source\n* `*` matches all the sources\n* `foo.bar.*` matches `foo.bar` and every nested source\n* `foo.bar` matches `foo.bar`, but not its nested sources\n* Any comma separated combination of the above\n\nThe following configuration will setup for all sources to emit\nwarnings (or higher) to `STDOUT`, allow any of the `db.*` and\nnested source to emit debug (or higher), and to also emit for all\nsources errors (or higher) to an elasticsearch backend.\n\n```\nLog.setup do |c|\n  backend = Log::IOBackend.new\n\n  c.bind \"*\", :warn, backend\n  c.bind \"db.*\", :debug, backend\n  c.bind \"*\", :error, ElasticSearchBackend.new(\"http://localhost:9200\")\nend\n```\n\n### Configure logging from environment variables\n\nInclude the following line to allow configuration from environment variables.\n\n```\nLog.setup_from_env\n```\n\nThe environment variable `LOG_LEVEL` is used to indicate which severity level to emit.\nBy default entries from all sources with `Info` and above severity will\nbe logged to `STDOUT` using the `Log::IOBackend`.\n\nTo change the level and sources change the environment variable value:\n\n```console\n$ LOG_LEVEL=DEBUG ./bin/app\n```\n\nYou can tweak the default values (used when `LOG_LEVEL` variable is not defined):\n\n```\nLog.setup_from_env(default_level: :error)\n```\n","summary":"<p>The <code><a href=\"Log.html\">Log</a></code> class provides a logging utility that you can use to output messages.</p>","class_methods":[{"html_id":"builder:Log::Builder-class-method","name":"builder","doc":"Returns the default `Log::Builder` used for `Log.for` calls.","summary":"<p>Returns the default <code><a href=\"Log/Builder.html\">Log::Builder</a></code> used for <code><a href=\"Log.html#for%28source%3AString%2Clevel%3ASeverity%3F%3Dnil%29%3ALog-class-method\">Log.for</a></code> calls.</p>","abstract":false,"location":{"filename":"src/log/main.cr","line_number":52,"url":null},"def":{"name":"builder","return_type":"Log::Builder","visibility":"Public","body":"@@builder"}},{"html_id":"capture(source:String=\"*\",level:Severity=Log::Severity::Trace,*,builder=Log.builder,&)-class-method","name":"capture","doc":"Returns and yields an `EntriesChecker` that allows checking specific log entries\nwere emitted.\n\nThis capture will even work if there are currently no backends configured, effectively\nadding a temporary backend.\n\n```\nrequire \"spec\"\nrequire \"log\"\nrequire \"log/spec\"\n\nLog.setup(:none)\n\ndef greet(name)\n  Log.info { \"Greeting #{name}\" }\nend\n\nit \"greets\" do\n  Log.capture do |logs|\n    greet(\"Harry\")\n    greet(\"Hermione\")\n    greet(\"Ron\")\n\n    logs.check(:info, /greeting harry/i)\n    logs.next(:info, /greeting hermione/i)\n  end\nend\n```\n\nBy default logs of all sources and severities  will be captured.\n\nUse *level* to only capture of the given severity or above.\n\nUse *source* to narrow which source are captured. Values that represent single pattern like `http.*` are allowed.\n\nThe `EntriesChecker` will hold a list of emitted entries.\n\n`EntriesChecker#check` will find the next entry which matches the level and message.\n`EntriesChecker#next` will validate that the following entry in the list matches the given level and message.\n`EntriesChecker#clear` will clear the emitted and captured entries.\n\nWith these methods it is possible to express expected traces in either a strict or loose way, while checking ordering.\n\n`EntriesChecker#entry` returns the last matched `Entry`. Useful to check additional entry properties other than the message.\n\n`EntriesChecker#empty` validates there are no pending entries to match.\n\nUsing the yielded `EntriesChecker` allows clearing the entries between statements.\n\nInvocations can be nested in order to capture each source in their own `EntriesChecker`.\n","summary":"<p>Returns and yields an <code><a href=\"Log/EntriesChecker.html\">EntriesChecker</a></code> that allows checking specific log entries were emitted.</p>","abstract":false,"args":[{"name":"source","default_value":"\"*\"","external_name":"source","restriction":"String"},{"name":"level","default_value":"Log::Severity::Trace","external_name":"level","restriction":"Severity"},{"name":"","external_name":"","restriction":""},{"name":"builder","default_value":"Log.builder","external_name":"builder","restriction":""}],"args_string":"(source : String = \"*\", level : Severity = Log::Severity::Trace, *, builder = Log.builder, &)","args_html":"(source : <a href=\"String.html\">String</a> = <span class=\"s\">&quot;*&quot;</span>, level : <a href=\"Log/Severity.html\">Severity</a> = <span class=\"t\">Log</span><span class=\"t\">::</span><span class=\"t\">Severity</span><span class=\"t\">::</span><span class=\"t\">Trace</span>, *, builder = <span class=\"t\">Log</span>.builder, &)","location":{"filename":"src/log/spec.cr","line_number":55,"url":null},"def":{"name":"capture","args":[{"name":"source","default_value":"\"*\"","external_name":"source","restriction":"String"},{"name":"level","default_value":"Log::Severity::Trace","external_name":"level","restriction":"Severity"},{"name":"","external_name":"","restriction":""},{"name":"builder","default_value":"Log.builder","external_name":"builder","restriction":""}],"splat_index":2,"yields":1,"visibility":"Public","body":"mem_backend = Log::MemoryBackend.new\nbuilder.bind(source, level, mem_backend)\nbegin\n  dsl = Log::EntriesChecker.new(mem_backend.entries)\n  yield dsl\n  dsl\nensure\n  builder.unbind(source, level, mem_backend)\nend\n"}},{"html_id":"capture(level:Log::Severity=Log::Severity::Trace,*,builder:Log::Builder=Log.builder,&)-class-method","name":"capture","doc":"Returns and yields an `EntriesChecker` that allows checking specific log entries\nwere emitted.\n\nThis capture will even work if there are currently no backends configured, effectively\nadding a temporary backend.\n\n```\nrequire \"spec\"\nrequire \"log\"\nrequire \"log/spec\"\n\nLog.setup(:none)\n\ndef greet(name)\n  Log.info { \"Greeting #{name}\" }\nend\n\nit \"greets\" do\n  Log.capture do |logs|\n    greet(\"Harry\")\n    greet(\"Hermione\")\n    greet(\"Ron\")\n\n    logs.check(:info, /greeting harry/i)\n    logs.next(:info, /greeting hermione/i)\n  end\nend\n```\n\nBy default logs of all sources and severities  will be captured.\n\nUse *level* to only capture of the given severity or above.\n\nUse *source* to narrow which source are captured. Values that represent single pattern like `http.*` are allowed.\n\nThe `EntriesChecker` will hold a list of emitted entries.\n\n`EntriesChecker#check` will find the next entry which matches the level and message.\n`EntriesChecker#next` will validate that the following entry in the list matches the given level and message.\n`EntriesChecker#clear` will clear the emitted and captured entries.\n\nWith these methods it is possible to express expected traces in either a strict or loose way, while checking ordering.\n\n`EntriesChecker#entry` returns the last matched `Entry`. Useful to check additional entry properties other than the message.\n\n`EntriesChecker#empty` validates there are no pending entries to match.\n\nUsing the yielded `EntriesChecker` allows clearing the entries between statements.\n\nInvocations can be nested in order to capture each source in their own `EntriesChecker`.\n","summary":"<p>Returns and yields an <code><a href=\"Log/EntriesChecker.html\">EntriesChecker</a></code> that allows checking specific log entries were emitted.</p>","abstract":false,"args":[{"name":"level","default_value":"Log::Severity::Trace","external_name":"level","restriction":"Log::Severity"},{"name":"","external_name":"","restriction":""},{"name":"builder","default_value":"Log.builder","external_name":"builder","restriction":"Log::Builder"}],"args_string":"(level : Log::Severity = Log::Severity::Trace, *, builder : Log::Builder = Log.builder, &)","args_html":"(level : <a href=\"Log/Severity.html\">Log::Severity</a> = <span class=\"t\">Log</span><span class=\"t\">::</span><span class=\"t\">Severity</span><span class=\"t\">::</span><span class=\"t\">Trace</span>, *, builder : <a href=\"Log/Builder.html\">Log::Builder</a> = <span class=\"t\">Log</span>.builder, &)","location":{"filename":"src/log/spec.cr","line_number":68,"url":null},"def":{"name":"capture","args":[{"name":"level","default_value":"Log::Severity::Trace","external_name":"level","restriction":"Log::Severity"},{"name":"","external_name":"","restriction":""},{"name":"builder","default_value":"Log.builder","external_name":"builder","restriction":"Log::Builder"}],"splat_index":1,"yields":1,"visibility":"Public","body":"capture(\"*\", level, builder: builder) do |dsl|\n  yield dsl\nend"}},{"html_id":"context:Log::Context-class-method","name":"context","doc":"Returns the current fiber logging context.","summary":"<p>Returns the current fiber logging context.</p>","abstract":false,"location":{"filename":"src/log/main.cr","line_number":57,"url":null},"def":{"name":"context","return_type":"Log::Context","visibility":"Public","body":"Log::Context.new(Fiber.current.logging_context)"}},{"html_id":"context=(value:Log::Metadata)-class-method","name":"context=","doc":"Sets the current fiber logging context.","summary":"<p>Sets the current fiber logging context.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Log::Metadata"}],"args_string":"(value : Log::Metadata)","args_html":"(value : <a href=\"Log/Metadata.html\">Log::Metadata</a>)","location":{"filename":"src/log/main.cr","line_number":62,"url":null},"def":{"name":"context=","args":[{"name":"value","external_name":"value","restriction":"Log::Metadata"}],"visibility":"Public","body":"Fiber.current.logging_context = value"}},{"html_id":"context=(value:Log::Context)-class-method","name":"context=","doc":"Sets the current fiber logging context.","summary":"<p>Sets the current fiber logging context.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Log::Context"}],"args_string":"(value : Log::Context)","args_html":"(value : <a href=\"Log/Context.html\">Log::Context</a>)","location":{"filename":"src/log/main.cr","line_number":67,"url":null},"def":{"name":"context=","args":[{"name":"value","external_name":"value","restriction":"Log::Context"}],"visibility":"Public","body":"Log.context = value.metadata"}},{"html_id":"debug(*,exception:Exception?=nil,&)-class-method","name":"debug","doc":"See `Log#debug`.","summary":"<p>See <code><a href=\"Log.html#debug%28%2A%2Cexception%3AException%3F%3Dnil%2C%26%29-instance-method\">Log#debug</a></code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"args_string":"(*, exception : Exception? = nil, &)","args_html":"(*, exception : <a href=\"Exception.html\">Exception</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/log/main.cr","line_number":38,"url":null},"def":{"name":"debug","args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"splat_index":0,"yields":1,"visibility":"Public","body":"Top.debug(exception: exception) do |dsl|\n  yield dsl\nend"}},{"html_id":"error(*,exception:Exception?=nil,&)-class-method","name":"error","doc":"See `Log#error`.","summary":"<p>See <code><a href=\"Log.html#error%28%2A%2Cexception%3AException%3F%3Dnil%2C%26%29-instance-method\">Log#error</a></code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"args_string":"(*, exception : Exception? = nil, &)","args_html":"(*, exception : <a href=\"Exception.html\">Exception</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/log/main.cr","line_number":38,"url":null},"def":{"name":"error","args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"splat_index":0,"yields":1,"visibility":"Public","body":"Top.error(exception: exception) do |dsl|\n  yield dsl\nend"}},{"html_id":"fatal(*,exception:Exception?=nil,&)-class-method","name":"fatal","doc":"See `Log#fatal`.","summary":"<p>See <code><a href=\"Log.html#fatal%28%2A%2Cexception%3AException%3F%3Dnil%2C%26%29-instance-method\">Log#fatal</a></code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"args_string":"(*, exception : Exception? = nil, &)","args_html":"(*, exception : <a href=\"Exception.html\">Exception</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/log/main.cr","line_number":38,"url":null},"def":{"name":"fatal","args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"splat_index":0,"yields":1,"visibility":"Public","body":"Top.fatal(exception: exception) do |dsl|\n  yield dsl\nend"}},{"html_id":"info(*,exception:Exception?=nil,&)-class-method","name":"info","doc":"See `Log#info`.","summary":"<p>See <code><a href=\"Log.html#info%28%2A%2Cexception%3AException%3F%3Dnil%2C%26%29-instance-method\">Log#info</a></code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"args_string":"(*, exception : Exception? = nil, &)","args_html":"(*, exception : <a href=\"Exception.html\">Exception</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/log/main.cr","line_number":38,"url":null},"def":{"name":"info","args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"splat_index":0,"yields":1,"visibility":"Public","body":"Top.info(exception: exception) do |dsl|\n  yield dsl\nend"}},{"html_id":"notice(*,exception:Exception?=nil,&)-class-method","name":"notice","doc":"See `Log#notice`.","summary":"<p>See <code><a href=\"Log.html#notice%28%2A%2Cexception%3AException%3F%3Dnil%2C%26%29-instance-method\">Log#notice</a></code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"args_string":"(*, exception : Exception? = nil, &)","args_html":"(*, exception : <a href=\"Exception.html\">Exception</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/log/main.cr","line_number":38,"url":null},"def":{"name":"notice","args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"splat_index":0,"yields":1,"visibility":"Public","body":"Top.notice(exception: exception) do |dsl|\n  yield dsl\nend"}},{"html_id":"progname-class-method","name":"progname","doc":"The program name used for log entries\n\nDefaults to the executable name","summary":"<p>The program name used for log entries</p>","abstract":false,"location":{"filename":"src/log/format.cr","line_number":5,"url":null},"def":{"name":"progname","visibility":"Public","body":"@@progname"}},{"html_id":"progname=(progname)-class-method","name":"progname=","doc":"The program name used for log entries\n\nDefaults to the executable name","summary":"<p>The program name used for log entries</p>","abstract":false,"args":[{"name":"progname","external_name":"progname","restriction":""}],"args_string":"(progname)","args_html":"(progname)","location":{"filename":"src/log/format.cr","line_number":5,"url":null},"def":{"name":"progname=","args":[{"name":"progname","external_name":"progname","restriction":""}],"visibility":"Public","body":"@@progname = progname"}},{"html_id":"setup(*,builder:Log::Builder=Log.builder,&)-class-method","name":"setup","doc":"Setups logging bindings discarding all previous configurations.","summary":"<p>Setups logging bindings discarding all previous configurations.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"builder","default_value":"Log.builder","external_name":"builder","restriction":"Log::Builder"}],"args_string":"(*, builder : Log::Builder = Log.builder, &)","args_html":"(*, builder : <a href=\"Log/Builder.html\">Log::Builder</a> = <span class=\"t\">Log</span>.builder, &)","location":{"filename":"src/log/setup.cr","line_number":3,"url":null},"def":{"name":"setup","args":[{"name":"","external_name":"","restriction":""},{"name":"builder","default_value":"Log.builder","external_name":"builder","restriction":"Log::Builder"}],"splat_index":0,"yields":1,"visibility":"Public","body":"builder.clear\nyield builder.as(Configuration)\n"}},{"html_id":"setup(sources:String=\"*\",level:Log::Severity=Log::Severity::Info,backend:Log::Backend=IOBackend.new,*,builder:Log::Builder=Log.builder)-class-method","name":"setup","doc":"Setups logging for *sources* using the specified *level*, *backend*.","summary":"<p>Setups logging for <em>sources</em> using the specified <em>level</em>, <em>backend</em>.</p>","abstract":false,"args":[{"name":"sources","default_value":"\"*\"","external_name":"sources","restriction":"String"},{"name":"level","default_value":"Log::Severity::Info","external_name":"level","restriction":"Log::Severity"},{"name":"backend","default_value":"IOBackend.new","external_name":"backend","restriction":"Log::Backend"},{"name":"","external_name":"","restriction":""},{"name":"builder","default_value":"Log.builder","external_name":"builder","restriction":"Log::Builder"}],"args_string":"(sources : String = \"*\", level : Log::Severity = Log::Severity::Info, backend : Log::Backend = IOBackend.new, *, builder : Log::Builder = Log.builder)","args_html":"(sources : <a href=\"String.html\">String</a> = <span class=\"s\">&quot;*&quot;</span>, level : <a href=\"Log/Severity.html\">Log::Severity</a> = <span class=\"t\">Log</span><span class=\"t\">::</span><span class=\"t\">Severity</span><span class=\"t\">::</span><span class=\"t\">Info</span>, backend : <a href=\"Log/Backend.html\">Log::Backend</a> = <span class=\"t\">IOBackend</span>.<span class=\"k\">new</span>, *, builder : <a href=\"Log/Builder.html\">Log::Builder</a> = <span class=\"t\">Log</span>.builder)","location":{"filename":"src/log/setup.cr","line_number":16,"url":null},"def":{"name":"setup","args":[{"name":"sources","default_value":"\"*\"","external_name":"sources","restriction":"String"},{"name":"level","default_value":"Log::Severity::Info","external_name":"level","restriction":"Log::Severity"},{"name":"backend","default_value":"IOBackend.new","external_name":"backend","restriction":"Log::Backend"},{"name":"","external_name":"","restriction":""},{"name":"builder","default_value":"Log.builder","external_name":"builder","restriction":"Log::Builder"}],"splat_index":3,"visibility":"Public","body":"Log.setup(builder: builder) do |c|\n  sources.split(',', remove_empty: false) do |source|\n    source = source.strip\n    c.bind(source, level, backend)\n  end\nend"}},{"html_id":"setup(level:Log::Severity=Log::Severity::Info,backend:Log::Backend=IOBackend.new,*,builder:Log::Builder=Log.builder)-class-method","name":"setup","doc":"Setups logging for all sources using the specified *level*, *backend*.","summary":"<p>Setups logging for all sources using the specified <em>level</em>, <em>backend</em>.</p>","abstract":false,"args":[{"name":"level","default_value":"Log::Severity::Info","external_name":"level","restriction":"Log::Severity"},{"name":"backend","default_value":"IOBackend.new","external_name":"backend","restriction":"Log::Backend"},{"name":"","external_name":"","restriction":""},{"name":"builder","default_value":"Log.builder","external_name":"builder","restriction":"Log::Builder"}],"args_string":"(level : Log::Severity = Log::Severity::Info, backend : Log::Backend = IOBackend.new, *, builder : Log::Builder = Log.builder)","args_html":"(level : <a href=\"Log/Severity.html\">Log::Severity</a> = <span class=\"t\">Log</span><span class=\"t\">::</span><span class=\"t\">Severity</span><span class=\"t\">::</span><span class=\"t\">Info</span>, backend : <a href=\"Log/Backend.html\">Log::Backend</a> = <span class=\"t\">IOBackend</span>.<span class=\"k\">new</span>, *, builder : <a href=\"Log/Builder.html\">Log::Builder</a> = <span class=\"t\">Log</span>.builder)","location":{"filename":"src/log/setup.cr","line_number":9,"url":null},"def":{"name":"setup","args":[{"name":"level","default_value":"Log::Severity::Info","external_name":"level","restriction":"Log::Severity"},{"name":"backend","default_value":"IOBackend.new","external_name":"backend","restriction":"Log::Backend"},{"name":"","external_name":"","restriction":""},{"name":"builder","default_value":"Log.builder","external_name":"builder","restriction":"Log::Builder"}],"splat_index":2,"visibility":"Public","body":"Log.setup(\"*\", level, backend, builder: builder)"}},{"html_id":"setup_from_env(*,builder:Log::Builder=Log.builder,default_level:Log::Severity=Log::Severity::Info,default_sources=\"*\",log_level_env=\"LOG_LEVEL\",backend=Log::IOBackend.new)-class-method","name":"setup_from_env","doc":"Setups logging based on `LOG_LEVEL` environment variable.","summary":"<p>Setups logging based on <code>LOG_LEVEL</code> environment variable.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"builder","default_value":"Log.builder","external_name":"builder","restriction":"Log::Builder"},{"name":"default_level","default_value":"Log::Severity::Info","external_name":"default_level","restriction":"Log::Severity"},{"name":"default_sources","default_value":"\"*\"","external_name":"default_sources","restriction":""},{"name":"log_level_env","default_value":"\"LOG_LEVEL\"","external_name":"log_level_env","restriction":""},{"name":"backend","default_value":"Log::IOBackend.new","external_name":"backend","restriction":""}],"args_string":"(*, builder : Log::Builder = Log.builder, default_level : Log::Severity = Log::Severity::Info, default_sources = \"*\", log_level_env = \"LOG_LEVEL\", backend = Log::IOBackend.new)","args_html":"(*, builder : <a href=\"Log/Builder.html\">Log::Builder</a> = <span class=\"t\">Log</span>.builder, default_level : <a href=\"Log/Severity.html\">Log::Severity</a> = <span class=\"t\">Log</span><span class=\"t\">::</span><span class=\"t\">Severity</span><span class=\"t\">::</span><span class=\"t\">Info</span>, default_sources = <span class=\"s\">&quot;*&quot;</span>, log_level_env = <span class=\"s\">&quot;LOG_LEVEL&quot;</span>, backend = <span class=\"t\">Log</span><span class=\"t\">::</span><span class=\"t\">IOBackend</span>.<span class=\"k\">new</span>)","location":{"filename":"src/log/setup.cr","line_number":30,"url":null},"def":{"name":"setup_from_env","args":[{"name":"","external_name":"","restriction":""},{"name":"builder","default_value":"Log.builder","external_name":"builder","restriction":"Log::Builder"},{"name":"default_level","default_value":"Log::Severity::Info","external_name":"default_level","restriction":"Log::Severity"},{"name":"default_sources","default_value":"\"*\"","external_name":"default_sources","restriction":""},{"name":"log_level_env","default_value":"\"LOG_LEVEL\"","external_name":"log_level_env","restriction":""},{"name":"backend","default_value":"Log::IOBackend.new","external_name":"backend","restriction":""}],"splat_index":0,"visibility":"Public","body":"level = ENV[log_level_env]?.try do |v|\n  Log::Severity.parse(v)\nend || default_level\nLog.setup(default_sources, level, backend, builder: builder)\n"}},{"html_id":"trace(*,exception:Exception?=nil,&)-class-method","name":"trace","doc":"See `Log#trace`.","summary":"<p>See <code><a href=\"Log.html#trace%28%2A%2Cexception%3AException%3F%3Dnil%2C%26%29-instance-method\">Log#trace</a></code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"args_string":"(*, exception : Exception? = nil, &)","args_html":"(*, exception : <a href=\"Exception.html\">Exception</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/log/main.cr","line_number":38,"url":null},"def":{"name":"trace","args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"splat_index":0,"yields":1,"visibility":"Public","body":"Top.trace(exception: exception) do |dsl|\n  yield dsl\nend"}},{"html_id":"warn(*,exception:Exception?=nil,&)-class-method","name":"warn","doc":"See `Log#warn`.","summary":"<p>See <code><a href=\"Log.html#warn%28%2A%2Cexception%3AException%3F%3Dnil%2C%26%29-instance-method\">Log#warn</a></code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"args_string":"(*, exception : Exception? = nil, &)","args_html":"(*, exception : <a href=\"Exception.html\">Exception</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/log/main.cr","line_number":38,"url":null},"def":{"name":"warn","args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"splat_index":0,"yields":1,"visibility":"Public","body":"Top.warn(exception: exception) do |dsl|\n  yield dsl\nend"}},{"html_id":"with_context(values,&)-class-method","name":"with_context","doc":"Method to save and restore the current logging context.\nTemporary context for the duration of the block can be set via arguments.\n\n```\nLog.context.set a: 1\nLog.info { %(message with {\"a\" => 1} context) }\nLog.with_context(b: 2) do\n  Log.context.set c: 3\n  Log.info { %(message with {\"a\" => 1, \"b\" => 2, \"c\" => 3} context) }\nend\nLog.info { %(message with {\"a\" => 1} context) }\n```","summary":"<p>Method to save and restore the current logging context.</p>","abstract":false,"args":[{"name":"values","external_name":"values","restriction":""}],"args_string":"(values, &)","args_html":"(values, &)","location":{"filename":"src/log/main.cr","line_number":107,"url":null},"def":{"name":"with_context","args":[{"name":"values","external_name":"values","restriction":""}],"yields":0,"visibility":"Public","body":"previous = Log.context\nif values.empty?\nelse\n  Log.context.set(values)\nend\nbegin\n  yield\nensure\n  Log.context = previous\nend\n"}},{"html_id":"with_context(**kwargs,&)-class-method","name":"with_context","doc":"Method to save and restore the current logging context.\nTemporary context for the duration of the block can be set via arguments.\n\n```\nLog.context.set a: 1\nLog.info { %(message with {\"a\" => 1} context) }\nLog.with_context(b: 2) do\n  Log.context.set c: 3\n  Log.info { %(message with {\"a\" => 1, \"b\" => 2, \"c\" => 3} context) }\nend\nLog.info { %(message with {\"a\" => 1} context) }\n```","summary":"<p>Method to save and restore the current logging context.</p>","abstract":false,"location":{"filename":"src/log/main.cr","line_number":96,"url":null},"def":{"name":"with_context","double_splat":{"name":"kwargs","external_name":"kwargs","restriction":""},"yields":0,"visibility":"Public","body":"previous = Log.context\nif kwargs.empty?\nelse\n  Log.context.set(**kwargs)\nend\nbegin\n  yield\nensure\n  Log.context = previous\nend\n"}}],"constructors":[{"html_id":"for(source:String,level:Severity?=nil):Log-class-method","name":"for","doc":"Creates a `Log` for the given source.\nIf *level* is given, it will override the configuration.","summary":"<p>Creates a <code><a href=\"Log.html\">Log</a></code> for the given source.</p>","abstract":false,"args":[{"name":"source","external_name":"source","restriction":"String"},{"name":"level","default_value":"nil","external_name":"level","restriction":"Severity | ::Nil"}],"args_string":"(source : String, level : Severity? = nil) : Log","args_html":"(source : <a href=\"String.html\">String</a>, level : <a href=\"Log/Severity.html\">Severity</a>? = <span class=\"n\">nil</span>) : <a href=\"Log.html\">Log</a>","location":{"filename":"src/log/main.cr","line_number":4,"url":null},"def":{"name":"for","args":[{"name":"source","external_name":"source","restriction":"String"},{"name":"level","default_value":"nil","external_name":"level","restriction":"Severity | ::Nil"}],"return_type":"Log","visibility":"Public","body":"log = builder.for(source)\nif level\n  log.level = level\nend\nlog\n"}},{"html_id":"for(type:Class,level:Severity?=nil):Log-class-method","name":"for","doc":"Creates a `Log` for the given type.\nA type `Foo::Bar(Baz)` corresponds to the source `foo.bar`.\nIf *level* is given, it will override the configuration.","summary":"<p>Creates a <code><a href=\"Log.html\">Log</a></code> for the given type.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Class"},{"name":"level","default_value":"nil","external_name":"level","restriction":"Severity | ::Nil"}],"args_string":"(type : Class, level : Severity? = nil) : Log","args_html":"(type : <a href=\"Class.html\">Class</a>, level : <a href=\"Log/Severity.html\">Severity</a>? = <span class=\"n\">nil</span>) : <a href=\"Log.html\">Log</a>","location":{"filename":"src/log/main.cr","line_number":21,"url":null},"def":{"name":"for","args":[{"name":"type","external_name":"type","restriction":"Class"},{"name":"level","default_value":"nil","external_name":"level","restriction":"Severity | ::Nil"}],"return_type":"Log","visibility":"Public","body":"source = type.name.underscore.gsub(\"::\", \".\")\nparen = source.index('(')\nif paren\n  source = source[0...paren]\nend\n::Log.for(source, level)\n"}}],"instance_methods":[{"html_id":"backend:Backend?-instance-method","name":"backend","abstract":false,"location":{"filename":"src/log/log.cr","line_number":3,"url":null},"def":{"name":"backend","return_type":"Backend | ::Nil","visibility":"Public","body":"@backend"}},{"html_id":"context:Log::Context-instance-method","name":"context","doc":"Returns the current fiber logging context.","summary":"<p>Returns the current fiber logging context.</p>","abstract":false,"location":{"filename":"src/log/main.cr","line_number":75,"url":null},"def":{"name":"context","return_type":"Log::Context","visibility":"Public","body":"Log.context"}},{"html_id":"context=(value:Log::Metadata|Log::Context)-instance-method","name":"context=","doc":"Sets the current fiber logging context.","summary":"<p>Sets the current fiber logging context.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Log::Metadata | Log::Context"}],"args_string":"(value : Log::Metadata | Log::Context)","args_html":"(value : <a href=\"Log/Metadata.html\">Log::Metadata</a> | <a href=\"Log/Context.html\">Log::Context</a>)","location":{"filename":"src/log/main.cr","line_number":80,"url":null},"def":{"name":"context=","args":[{"name":"value","external_name":"value","restriction":"Log::Metadata | Log::Context"}],"visibility":"Public","body":"Log.context = value"}},{"html_id":"debug(*,exception:Exception?=nil,&)-instance-method","name":"debug","doc":"Logs a message if the logger's current severity is lower or equal to `1`.","summary":"<p>Logs a message if the logger's current severity is lower or equal to <code>1</code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"args_string":"(*, exception : Exception? = nil, &)","args_html":"(*, exception : <a href=\"Exception.html\">Exception</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/log/log.cr","line_number":36,"url":null},"def":{"name":"debug","args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"splat_index":0,"yields":1,"visibility":"Public","body":"severity = Severity.new(1)\nif level <= severity\nelse\n  return\nend\nif backend = @backend\nelse\n  return\nend\ndsl = Emitter.new(@source, severity, exception)\nresult = yield dsl\nentry = case result\nwhen Entry\n  result\nelse\n  dsl.emit(result.to_s)\nend\nbackend.dispatch(entry)\n"}},{"html_id":"error(*,exception:Exception?=nil,&)-instance-method","name":"error","doc":"Logs a message if the logger's current severity is lower or equal to `5`.","summary":"<p>Logs a message if the logger's current severity is lower or equal to <code>5</code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"args_string":"(*, exception : Exception? = nil, &)","args_html":"(*, exception : <a href=\"Exception.html\">Exception</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/log/log.cr","line_number":36,"url":null},"def":{"name":"error","args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"splat_index":0,"yields":1,"visibility":"Public","body":"severity = Severity.new(5)\nif level <= severity\nelse\n  return\nend\nif backend = @backend\nelse\n  return\nend\ndsl = Emitter.new(@source, severity, exception)\nresult = yield dsl\nentry = case result\nwhen Entry\n  result\nelse\n  dsl.emit(result.to_s)\nend\nbackend.dispatch(entry)\n"}},{"html_id":"fatal(*,exception:Exception?=nil,&)-instance-method","name":"fatal","doc":"Logs a message if the logger's current severity is lower or equal to `6`.","summary":"<p>Logs a message if the logger's current severity is lower or equal to <code>6</code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"args_string":"(*, exception : Exception? = nil, &)","args_html":"(*, exception : <a href=\"Exception.html\">Exception</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/log/log.cr","line_number":36,"url":null},"def":{"name":"fatal","args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"splat_index":0,"yields":1,"visibility":"Public","body":"severity = Severity.new(6)\nif level <= severity\nelse\n  return\nend\nif backend = @backend\nelse\n  return\nend\ndsl = Emitter.new(@source, severity, exception)\nresult = yield dsl\nentry = case result\nwhen Entry\n  result\nelse\n  dsl.emit(result.to_s)\nend\nbackend.dispatch(entry)\n"}},{"html_id":"for(child_source:String,level:Severity?=nil):Log-instance-method","name":"for","doc":"Creates a `Log` for the given nested source.\nIf *level* is given, it will override the configuration.","summary":"<p>Creates a <code><a href=\"Log.html\">Log</a></code> for the given nested source.</p>","abstract":false,"args":[{"name":"child_source","external_name":"child_source","restriction":"String"},{"name":"level","default_value":"nil","external_name":"level","restriction":"Severity | ::Nil"}],"args_string":"(child_source : String, level : Severity? = nil) : Log","args_html":"(child_source : <a href=\"String.html\">String</a>, level : <a href=\"Log/Severity.html\">Severity</a>? = <span class=\"n\">nil</span>) : <a href=\"Log.html\">Log</a>","location":{"filename":"src/log/main.cr","line_number":12,"url":null},"def":{"name":"for","args":[{"name":"child_source","external_name":"child_source","restriction":"String"},{"name":"level","default_value":"nil","external_name":"level","restriction":"Severity | ::Nil"}],"return_type":"Log","visibility":"Public","body":"if source.blank?\n  return ::Log.for(child_source)\nend\nif child_source.blank?\n  return ::Log.for(source)\nend\n::Log.for(\"#{source}.#{child_source}\", level)\n"}},{"html_id":"for(type:Class,level:Severity?=nil):Log-instance-method","name":"for","doc":"Creates a `Log` for the given type.\nA type `Foo::Bar(Baz)` corresponds to the source `foo.bar`.\nIf *level* is given, it will override the configuration.","summary":"<p>Creates a <code><a href=\"Log.html\">Log</a></code> for the given type.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Class"},{"name":"level","default_value":"nil","external_name":"level","restriction":"Severity | ::Nil"}],"args_string":"(type : Class, level : Severity? = nil) : Log","args_html":"(type : <a href=\"Class.html\">Class</a>, level : <a href=\"Log/Severity.html\">Severity</a>? = <span class=\"n\">nil</span>) : <a href=\"Log.html\">Log</a>","location":{"filename":"src/log/main.cr","line_number":32,"url":null},"def":{"name":"for","args":[{"name":"type","external_name":"type","restriction":"Class"},{"name":"level","default_value":"nil","external_name":"level","restriction":"Severity | ::Nil"}],"return_type":"Log","visibility":"Public","body":"::Log.for(type, level)"}},{"html_id":"info(*,exception:Exception?=nil,&)-instance-method","name":"info","doc":"Logs a message if the logger's current severity is lower or equal to `2`.","summary":"<p>Logs a message if the logger's current severity is lower or equal to <code>2</code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"args_string":"(*, exception : Exception? = nil, &)","args_html":"(*, exception : <a href=\"Exception.html\">Exception</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/log/log.cr","line_number":36,"url":null},"def":{"name":"info","args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"splat_index":0,"yields":1,"visibility":"Public","body":"severity = Severity.new(2)\nif level <= severity\nelse\n  return\nend\nif backend = @backend\nelse\n  return\nend\ndsl = Emitter.new(@source, severity, exception)\nresult = yield dsl\nentry = case result\nwhen Entry\n  result\nelse\n  dsl.emit(result.to_s)\nend\nbackend.dispatch(entry)\n"}},{"html_id":"level:Severity-instance-method","name":"level","abstract":false,"location":{"filename":"src/log/log.cr","line_number":18,"url":null},"def":{"name":"level","return_type":"Severity","visibility":"Public","body":"@level || @initial_level"}},{"html_id":"level=(value:Severity)-instance-method","name":"level=","doc":"Change this log severity level filter.","summary":"<p>Change this log severity level filter.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Severity"}],"args_string":"(value : Severity)","args_html":"(value : <a href=\"Log/Severity.html\">Severity</a>)","location":{"filename":"src/log/log.cr","line_number":23,"url":null},"def":{"name":"level=","args":[{"name":"value","external_name":"value","restriction":"Severity"}],"visibility":"Public","body":"@level = value\nif (backend = @backend).responds_to?(:\"level=\")\n  backend.level = value\nend\nvalue\n"}},{"html_id":"notice(*,exception:Exception?=nil,&)-instance-method","name":"notice","doc":"Logs a message if the logger's current severity is lower or equal to `3`.","summary":"<p>Logs a message if the logger's current severity is lower or equal to <code>3</code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"args_string":"(*, exception : Exception? = nil, &)","args_html":"(*, exception : <a href=\"Exception.html\">Exception</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/log/log.cr","line_number":36,"url":null},"def":{"name":"notice","args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"splat_index":0,"yields":1,"visibility":"Public","body":"severity = Severity.new(3)\nif level <= severity\nelse\n  return\nend\nif backend = @backend\nelse\n  return\nend\ndsl = Emitter.new(@source, severity, exception)\nresult = yield dsl\nentry = case result\nwhen Entry\n  result\nelse\n  dsl.emit(result.to_s)\nend\nbackend.dispatch(entry)\n"}},{"html_id":"source:String-instance-method","name":"source","abstract":false,"location":{"filename":"src/log/log.cr","line_number":2,"url":null},"def":{"name":"source","return_type":"String","visibility":"Public","body":"@source"}},{"html_id":"trace(*,exception:Exception?=nil,&)-instance-method","name":"trace","doc":"Logs a message if the logger's current severity is lower or equal to `0`.","summary":"<p>Logs a message if the logger's current severity is lower or equal to <code>0</code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"args_string":"(*, exception : Exception? = nil, &)","args_html":"(*, exception : <a href=\"Exception.html\">Exception</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/log/log.cr","line_number":36,"url":null},"def":{"name":"trace","args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"splat_index":0,"yields":1,"visibility":"Public","body":"severity = Severity.new(0)\nif level <= severity\nelse\n  return\nend\nif backend = @backend\nelse\n  return\nend\ndsl = Emitter.new(@source, severity, exception)\nresult = yield dsl\nentry = case result\nwhen Entry\n  result\nelse\n  dsl.emit(result.to_s)\nend\nbackend.dispatch(entry)\n"}},{"html_id":"warn(*,exception:Exception?=nil,&)-instance-method","name":"warn","doc":"Logs a message if the logger's current severity is lower or equal to `4`.","summary":"<p>Logs a message if the logger's current severity is lower or equal to <code>4</code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"args_string":"(*, exception : Exception? = nil, &)","args_html":"(*, exception : <a href=\"Exception.html\">Exception</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/log/log.cr","line_number":36,"url":null},"def":{"name":"warn","args":[{"name":"","external_name":"","restriction":""},{"name":"exception","default_value":"nil","external_name":"exception","restriction":"Exception | ::Nil"}],"splat_index":0,"yields":1,"visibility":"Public","body":"severity = Severity.new(4)\nif level <= severity\nelse\n  return\nend\nif backend = @backend\nelse\n  return\nend\ndsl = Emitter.new(@source, severity, exception)\nresult = yield dsl\nentry = case result\nwhen Entry\n  result\nelse\n  dsl.emit(result.to_s)\nend\nbackend.dispatch(entry)\n"}},{"html_id":"with_context(values,&)-instance-method","name":"with_context","doc":"Method to save and restore the current logging context.\nTemporary context for the duration of the block can be set via arguments.\n\n```\nLog.context.set a: 1\nLog.info { %(message with {\"a\" => 1} context) }\nLog.with_context(b: 2) do\n  Log.context.set c: 3\n  Log.info { %(message with {\"a\" => 1, \"b\" => 2, \"c\" => 3} context) }\nend\nLog.info { %(message with {\"a\" => 1} context) }\n```","summary":"<p>Method to save and restore the current logging context.</p>","abstract":false,"args":[{"name":"values","external_name":"values","restriction":""}],"args_string":"(values, &)","args_html":"(values, &)","location":{"filename":"src/log/main.cr","line_number":125,"url":null},"def":{"name":"with_context","args":[{"name":"values","external_name":"values","restriction":""}],"yields":0,"visibility":"Public","body":"self.class.with_context(values) do\n  yield\nend"}},{"html_id":"with_context(**kwargs,&)-instance-method","name":"with_context","doc":"Method to save and restore the current logging context.\nTemporary context for the duration of the block can be set via arguments.\n\n```\nLog.context.set a: 1\nLog.info { %(message with {\"a\" => 1} context) }\nLog.with_context(b: 2) do\n  Log.context.set c: 3\n  Log.info { %(message with {\"a\" => 1, \"b\" => 2, \"c\" => 3} context) }\nend\nLog.info { %(message with {\"a\" => 1} context) }\n```","summary":"<p>Method to save and restore the current logging context.</p>","abstract":false,"location":{"filename":"src/log/main.cr","line_number":118,"url":null},"def":{"name":"with_context","double_splat":{"name":"kwargs","external_name":"kwargs","restriction":""},"yields":0,"visibility":"Public","body":"self.class.with_context(**kwargs) do\n  yield\nend"}}],"macros":[{"html_id":"define_formatter(name,pattern)-macro","name":"define_formatter","doc":"Generate subclasses of `Log::StaticFormatter` from a string with interpolations\n\nExample:\n```\nLog.define_formatter MyFormat, \"- #{severity}: #{message}\"\n```\nSee `Log::StaticFormatter` for the available methods that can\nbe called within the interpolations.","summary":"<p>Generate subclasses of <code><a href=\"Log/StaticFormatter.html\">Log::StaticFormatter</a></code> from a string with interpolations</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(name, pattern)","args_html":"(name, pattern)","location":{"filename":"src/log/format.cr","line_number":168,"url":null},"def":{"name":"define_formatter","args":[{"name":"name","external_name":"name","restriction":""},{"name":"pattern","external_name":"pattern","restriction":""}],"visibility":"Public","body":"    struct \n{{ name }}\n < ::Log::StaticFormatter\n      def run\n        \n{% for part in pattern.expressions %}\n          {% if part.is_a?(StringLiteral) %}\n            string {{ part }}\n          {% else %}\n            {{ part }}\n          {% end %}\n        {% end %}\n\n      \nend\n    \nend\n  \n"}}],"types":[{"html_id":"Crystal/Log/AsyncDispatcher","path":"Log/AsyncDispatcher.html","kind":"class","full_name":"Log::AsyncDispatcher","name":"AsyncDispatcher","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Log/Dispatcher","kind":"module","full_name":"Log::Dispatcher","name":"Dispatcher"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/dispatch.cr","line_number":45,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Log/Dispatcher","kind":"module","full_name":"Log::Dispatcher","name":"Dispatcher"}],"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"Deliver log entries asynchronously through a channels","summary":"<p>Deliver log entries asynchronously through a channels</p>","constructors":[{"html_id":"new(buffer_size=2048)-class-method","name":"new","abstract":false,"args":[{"name":"buffer_size","default_value":"2048","external_name":"buffer_size","restriction":""}],"args_string":"(buffer_size = 2048)","args_html":"(buffer_size = <span class=\"n\">2048</span>)","location":{"filename":"src/log/dispatch.cr","line_number":48,"url":null},"def":{"name":"new","args":[{"name":"buffer_size","default_value":"2048","external_name":"buffer_size","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(buffer_size)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"close:Nil-instance-method","name":"close","doc":"Close the dispatcher, releasing resources","summary":"<p>Close the dispatcher, releasing resources</p>","abstract":false,"location":{"filename":"src/log/dispatch.cr","line_number":67,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"if @channel.closed?\nelse\n  @channel.close\n  @done.receive\nend"}},{"html_id":"dispatch(entry:Entry,backend:Backend):Nil-instance-method","name":"dispatch","doc":"Dispatch a log entry to the specified backend","summary":"<p>Dispatch a log entry to the specified backend</p>","abstract":false,"args":[{"name":"entry","external_name":"entry","restriction":"Entry"},{"name":"backend","external_name":"backend","restriction":"Backend"}],"args_string":"(entry : Entry, backend : Backend) : Nil","args_html":"(entry : <a href=\"../Log/Entry.html\">Entry</a>, backend : <a href=\"../Log/Backend.html\">Backend</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/log/dispatch.cr","line_number":54,"url":null},"def":{"name":"dispatch","args":[{"name":"entry","external_name":"entry","restriction":"Entry"},{"name":"backend","external_name":"backend","restriction":"Backend"}],"return_type":"Nil","visibility":"Public","body":"@channel.send({entry, backend})"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/log/dispatch.cr","line_number":75,"url":null},"def":{"name":"finalize","visibility":"Public","body":"close"}}]},{"html_id":"Crystal/Log/Backend","path":"Log/Backend.html","kind":"class","full_name":"Log::Backend","name":"Backend","abstract":true,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/backend.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/Log/BroadcastBackend","kind":"class","full_name":"Log::BroadcastBackend","name":"BroadcastBackend"},{"html_id":"Crystal/Log/IOBackend","kind":"class","full_name":"Log::IOBackend","name":"IOBackend"},{"html_id":"Crystal/Log/MemoryBackend","kind":"class","full_name":"Log::MemoryBackend","name":"MemoryBackend"}],"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"Base class for all backends.","summary":"<p>Base class for all backends.</p>","constructors":[{"html_id":"new(dispatch_mode:DispatchMode=:async)-class-method","name":"new","abstract":false,"args":[{"name":"dispatch_mode","default_value":":async","external_name":"dispatch_mode","restriction":"DispatchMode"}],"args_string":"(dispatch_mode : DispatchMode = :async)","args_html":"(dispatch_mode : <a href=\"../Log/DispatchMode.html\">DispatchMode</a> = <span class=\"n\">:async</span>)","location":{"filename":"src/log/backend.cr","line_number":7,"url":null},"def":{"name":"new","args":[{"name":"dispatch_mode","default_value":":async","external_name":"dispatch_mode","restriction":"DispatchMode"}],"visibility":"Public","body":"_ = allocate\n_.initialize(dispatch_mode)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(dispatcher:Dispatcher)-class-method","name":"new","abstract":false,"args":[{"name":"dispatcher","external_name":"dispatcher","restriction":"Dispatcher"}],"args_string":"(dispatcher : Dispatcher)","args_html":"(dispatcher : <a href=\"../Log/Dispatcher.html\">Dispatcher</a>)","location":{"filename":"src/log/backend.cr","line_number":11,"url":null},"def":{"name":"new","args":[{"name":"dispatcher","external_name":"dispatcher","restriction":"Dispatcher"}],"visibility":"Public","body":"_ = allocate\n_.initialize(dispatcher)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes underlying resources used by this backend.","summary":"<p>Closes underlying resources used by this backend.</p>","abstract":false,"location":{"filename":"src/log/backend.cr","line_number":18,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"@dispatcher.close"}},{"html_id":"dispatcher:Dispatcher-instance-method","name":"dispatcher","abstract":false,"location":{"filename":"src/log/backend.cr","line_number":5,"url":null},"def":{"name":"dispatcher","return_type":"Dispatcher","visibility":"Public","body":"@dispatcher"}},{"html_id":"dispatcher=(dispatcher:Dispatcher)-instance-method","name":"dispatcher=","abstract":false,"args":[{"name":"dispatcher","external_name":"dispatcher","restriction":"Dispatcher"}],"args_string":"(dispatcher : Dispatcher)","args_html":"(dispatcher : <a href=\"../Log/Dispatcher.html\">Dispatcher</a>)","location":{"filename":"src/log/backend.cr","line_number":5,"url":null},"def":{"name":"dispatcher=","args":[{"name":"dispatcher","external_name":"dispatcher","restriction":"Dispatcher"}],"visibility":"Public","body":"@dispatcher = dispatcher"}},{"html_id":"write(entry:Entry)-instance-method","name":"write","doc":"Writes the *entry* to this backend.","summary":"<p>Writes the <em>entry</em> to this backend.</p>","abstract":true,"args":[{"name":"entry","external_name":"entry","restriction":"Entry"}],"args_string":"(entry : Entry)","args_html":"(entry : <a href=\"../Log/Entry.html\">Entry</a>)","location":{"filename":"src/log/backend.cr","line_number":15,"url":null},"def":{"name":"write","args":[{"name":"entry","external_name":"entry","restriction":"Entry"}],"visibility":"Public","body":""}}]},{"html_id":"Crystal/Log/BroadcastBackend","path":"Log/BroadcastBackend.html","kind":"class","full_name":"Log::BroadcastBackend","name":"BroadcastBackend","abstract":false,"superclass":{"html_id":"Crystal/Log/Backend","kind":"class","full_name":"Log::Backend","name":"Backend"},"ancestors":[{"html_id":"Crystal/Log/Backend","kind":"class","full_name":"Log::Backend","name":"Backend"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/broadcast_backend.cr","line_number":9,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"A backend that broadcast to others backends.\nEach of the referenced backends may have a different severity level filter.\n\nWhen this backend level is set that level setting takes precedence\nover the severity filter of each referenced backend.\n\nThis backend is not to be used explicitly. It is used by `Log::Builder` configuration\nto allow a given source to emit to multiple backends.","summary":"<p>A backend that broadcast to others backends.</p>","constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/log/broadcast_backend.cr","line_number":14,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"append(backend:Log::Backend,level:Severity):Nil-instance-method","name":"append","abstract":false,"args":[{"name":"backend","external_name":"backend","restriction":"Log::Backend"},{"name":"level","external_name":"level","restriction":"Severity"}],"args_string":"(backend : Log::Backend, level : Severity) : Nil","args_html":"(backend : <a href=\"../Log/Backend.html\">Log::Backend</a>, level : <a href=\"../Log/Severity.html\">Severity</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/log/broadcast_backend.cr","line_number":18,"url":null},"def":{"name":"append","args":[{"name":"backend","external_name":"backend","restriction":"Log::Backend"},{"name":"level","external_name":"level","restriction":"Severity"}],"return_type":"Nil","visibility":"Public","body":"@backends[backend] = level"}},{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes underlying resources used by this backend.","summary":"<p>Closes underlying resources used by this backend.</p>","abstract":false,"location":{"filename":"src/log/broadcast_backend.cr","line_number":28,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"@backends.each_key(&.close)"}},{"html_id":"level:Severity?-instance-method","name":"level","abstract":false,"location":{"filename":"src/log/broadcast_backend.cr","line_number":10,"url":null},"def":{"name":"level","return_type":"Severity | ::Nil","visibility":"Public","body":"@level"}},{"html_id":"level=(level:Severity?)-instance-method","name":"level=","abstract":false,"args":[{"name":"level","external_name":"level","restriction":"Severity | ::Nil"}],"args_string":"(level : Severity?)","args_html":"(level : <a href=\"../Log/Severity.html\">Severity</a>?)","location":{"filename":"src/log/broadcast_backend.cr","line_number":10,"url":null},"def":{"name":"level=","args":[{"name":"level","external_name":"level","restriction":"Severity | ::Nil"}],"visibility":"Public","body":"@level = level"}},{"html_id":"write(entry:Entry):Nil-instance-method","name":"write","doc":"Writes the *entry* to this backend.","summary":"<p>Writes the <em>entry</em> to this backend.</p>","abstract":false,"args":[{"name":"entry","external_name":"entry","restriction":"Entry"}],"args_string":"(entry : Entry) : Nil","args_html":"(entry : <a href=\"../Log/Entry.html\">Entry</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/log/broadcast_backend.cr","line_number":22,"url":null},"def":{"name":"write","args":[{"name":"entry","external_name":"entry","restriction":"Entry"}],"return_type":"Nil","visibility":"Public","body":"@backends.each do |backend, level|\n  if (@level || level) <= entry.severity\n    backend.dispatch(entry)\n  end\nend"}}]},{"html_id":"Crystal/Log/Builder","path":"Log/Builder.html","kind":"class","full_name":"Log::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Log/Configuration","kind":"module","full_name":"Log::Configuration","name":"Configuration"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/builder.cr","line_number":12,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Log/Configuration","kind":"module","full_name":"Log::Configuration","name":"Configuration"}],"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"A `Log::Builder` creates `Log` instances for a given source.\nIt allows you to bind sources and patterns to a given backend.\nAlready created `Log` will be reconfigured as needed.","summary":"<p>A <code><a href=\"../Log/Builder.html\">Log::Builder</a></code> creates <code><a href=\"../Log.html\">Log</a></code> instances for a given source.</p>","instance_methods":[{"html_id":"bind(source:String,level:Severity,backend:Backend):Nil-instance-method","name":"bind","doc":"Binds a *source* pattern to a *backend* for all logs that are of severity equal or higher to *level*.","summary":"<p>Binds a <em>source</em> pattern to a <em>backend</em> for all logs that are of severity equal or higher to <em>level</em>.</p>","abstract":false,"args":[{"name":"source","external_name":"source","restriction":"String"},{"name":"level","external_name":"level","restriction":"Severity"},{"name":"backend","external_name":"backend","restriction":"Backend"}],"args_string":"(source : String, level : Severity, backend : Backend) : Nil","args_html":"(source : <a href=\"../String.html\">String</a>, level : <a href=\"../Log/Severity.html\">Severity</a>, backend : <a href=\"../Log/Backend.html\">Backend</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/log/builder.cr","line_number":22,"url":null},"def":{"name":"bind","args":[{"name":"source","external_name":"source","restriction":"String"},{"name":"level","external_name":"level","restriction":"Severity"},{"name":"backend","external_name":"backend","restriction":"Backend"}],"return_type":"Nil","visibility":"Public","body":"@mutex.synchronize do\n  binding = Binding.new(source: source, level: level, backend: backend)\n  @bindings << binding\n  each_log do |log|\n    if Builder.matches(log.source, binding.source)\n      append_backend(log, binding.level, binding.backend)\n    end\n  end\nend"}},{"html_id":"clear:Nil-instance-method","name":"clear","doc":"Removes all existing bindings.","summary":"<p>Removes all existing bindings.</p>","abstract":false,"location":{"filename":"src/log/builder.cr","line_number":53,"url":null},"def":{"name":"clear","return_type":"Nil","visibility":"Public","body":"@mutex.synchronize do\n  @bindings.clear\n  each_log do |log|\n    log.backend = nil\n    log.initial_level = :none\n  end\nend"}},{"html_id":"for(source:String):Log-instance-method","name":"for","doc":"Returns a `Log` for the given *source* with a severity level and\nbackend according to the bindings in *self*.\nIf new bindings are applied, the existing `Log` instances will be\nreconfigured.\nCalling this method multiple times with the same value will return\nthe same object.","summary":"<p>Returns a <code><a href=\"../Log.html\">Log</a></code> for the given <em>source</em> with a severity level and backend according to the bindings in <em>self</em>.</p>","abstract":false,"args":[{"name":"source","external_name":"source","restriction":"String"}],"args_string":"(source : String) : Log","args_html":"(source : <a href=\"../String.html\">String</a>) : <a href=\"../Log.html\">Log</a>","location":{"filename":"src/log/builder.cr","line_number":69,"url":null},"def":{"name":"for","args":[{"name":"source","external_name":"source","restriction":"String"}],"return_type":"Log","visibility":"Public","body":"@mutex.synchronize do\n  log = @logs[source]?.try(&.value)\n  if log.nil?\n    log = Log.new(source, nil, :none)\n    @bindings.each do |binding|\n      if Builder.matches(log.source, binding.source)\n      else\n        next\n      end\n      append_backend(log, binding.level, binding.backend)\n    end\n    @logs[source] = WeakRef.new(log)\n  end\n  log\nend"}}]},{"html_id":"Crystal/Log/Configuration","path":"Log/Configuration.html","kind":"module","full_name":"Log::Configuration","name":"Configuration","abstract":false,"locations":[{"filename":"src/log/builder.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"including_types":[{"html_id":"Crystal/Log/Builder","kind":"class","full_name":"Log::Builder","name":"Builder"}],"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"Used in `Log.setup` methods to configure the binding to be used.","summary":"<p>Used in <code><a href=\"../Log.html#setup%28%2A%2Cbuilder%3ALog%3A%3ABuilder%3DLog.builder%2C%26%29-class-method\">Log.setup</a></code> methods to configure the binding to be used.</p>","instance_methods":[{"html_id":"bind(source:String,level:Severity,backend:Backend)-instance-method","name":"bind","doc":"Binds a *source* pattern to a *backend* for all logs that are of severity equal or higher to *level*.","summary":"<p>Binds a <em>source</em> pattern to a <em>backend</em> for all logs that are of severity equal or higher to <em>level</em>.</p>","abstract":true,"args":[{"name":"source","external_name":"source","restriction":"String"},{"name":"level","external_name":"level","restriction":"Severity"},{"name":"backend","external_name":"backend","restriction":"Backend"}],"args_string":"(source : String, level : Severity, backend : Backend)","args_html":"(source : <a href=\"../String.html\">String</a>, level : <a href=\"../Log/Severity.html\">Severity</a>, backend : <a href=\"../Log/Backend.html\">Backend</a>)","location":{"filename":"src/log/builder.cr","line_number":6,"url":null},"def":{"name":"bind","args":[{"name":"source","external_name":"source","restriction":"String"},{"name":"level","external_name":"level","restriction":"Severity"},{"name":"backend","external_name":"backend","restriction":"Backend"}],"visibility":"Public","body":""}}]},{"html_id":"Crystal/Log/Context","path":"Log/Context.html","kind":"struct","full_name":"Log::Context","name":"Context","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/main.cr","line_number":131,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"constructors":[{"html_id":"new(metadata:Metadata)-class-method","name":"new","abstract":false,"args":[{"name":"metadata","external_name":"metadata","restriction":"Metadata"}],"args_string":"(metadata : Metadata)","args_html":"(metadata : <a href=\"../Log/Metadata.html\">Metadata</a>)","location":{"filename":"src/log/main.cr","line_number":134,"url":null},"def":{"name":"new","args":[{"name":"metadata","external_name":"metadata","restriction":"Metadata"}],"visibility":"Public","body":"_ = allocate\n_.initialize(metadata)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"clear:Nil-instance-method","name":"clear","doc":"Clears the current `Fiber` logging context.\n\n```\nLog.context.clear\nLog.info { \"message with empty context\" }\n```","summary":"<p>Clears the current <code><a href=\"../Fiber.html\">Fiber</a></code> logging context.</p>","abstract":false,"location":{"filename":"src/log/main.cr","line_number":143,"url":null},"def":{"name":"clear","return_type":"Nil","visibility":"Public","body":"Fiber.current.logging_context = @metadata = Log::Metadata.empty"}},{"html_id":"metadata:Metadata-instance-method","name":"metadata","abstract":false,"location":{"filename":"src/log/main.cr","line_number":132,"url":null},"def":{"name":"metadata","return_type":"Metadata","visibility":"Public","body":"@metadata"}},{"html_id":"set(values):Nil-instance-method","name":"set","doc":"Extends the current `Fiber` logging context.\n\n```\nLog.context.set a: 1\nLog.context.set b: 2\nLog.info { %q(message with a: 1, b: 2 context\") }\nh = {:c => \"3\"}\nLog.context.set extra: h\nLog.info { %q(message with a: 1, b: 2, extra: {\"c\" => \"3\"} context) }\nh = {\"c\" => 3}\nLog.context.set extra: h\nLog.info { %q(message with a: 1, b: 2, extra: {\"c\" => 3} context) }\n```","summary":"<p>Extends the current <code><a href=\"../Fiber.html\">Fiber</a></code> logging context.</p>","abstract":false,"args":[{"name":"values","external_name":"values","restriction":""}],"args_string":"(values) : Nil","args_html":"(values) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/log/main.cr","line_number":165,"url":null},"def":{"name":"set","args":[{"name":"values","external_name":"values","restriction":""}],"return_type":"Nil","visibility":"Public","body":"extend_fiber_context(Fiber.current, values)"}},{"html_id":"set(**kwargs)-instance-method","name":"set","doc":"Extends the current `Fiber` logging context.\n\n```\nLog.context.set a: 1\nLog.context.set b: 2\nLog.info { %q(message with a: 1, b: 2 context\") }\nh = {:c => \"3\"}\nLog.context.set extra: h\nLog.info { %q(message with a: 1, b: 2, extra: {\"c\" => \"3\"} context) }\nh = {\"c\" => 3}\nLog.context.set extra: h\nLog.info { %q(message with a: 1, b: 2, extra: {\"c\" => 3} context) }\n```","summary":"<p>Extends the current <code><a href=\"../Fiber.html\">Fiber</a></code> logging context.</p>","abstract":false,"location":{"filename":"src/log/main.cr","line_number":160,"url":null},"def":{"name":"set","double_splat":{"name":"kwargs","external_name":"kwargs","restriction":""},"visibility":"Public","body":"extend_fiber_context(Fiber.current, kwargs)"}}]},{"html_id":"Crystal/Log/DirectDispatcher","path":"Log/DirectDispatcher.html","kind":"module","full_name":"Log::DirectDispatcher","name":"DirectDispatcher","abstract":false,"locations":[{"filename":"src/log/dispatch.cr","line_number":36,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"extended_modules":[{"html_id":"Crystal/Log/Dispatcher","kind":"module","full_name":"Log::Dispatcher","name":"Dispatcher"}],"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"Stateless dispatcher that deliver log entries immediately","summary":"<p>Stateless dispatcher that deliver log entries immediately</p>","class_methods":[{"html_id":"dispatch(entry:Entry,backend:Backend)-class-method","name":"dispatch","abstract":false,"args":[{"name":"entry","external_name":"entry","restriction":"Entry"},{"name":"backend","external_name":"backend","restriction":"Backend"}],"args_string":"(entry : Entry, backend : Backend)","args_html":"(entry : <a href=\"../Log/Entry.html\">Entry</a>, backend : <a href=\"../Log/Backend.html\">Backend</a>)","location":{"filename":"src/log/dispatch.cr","line_number":39,"url":null},"def":{"name":"dispatch","args":[{"name":"entry","external_name":"entry","restriction":"Entry"},{"name":"backend","external_name":"backend","restriction":"Backend"}],"visibility":"Public","body":"backend.write(entry)"}}]},{"html_id":"Crystal/Log/Dispatcher","path":"Log/Dispatcher.html","kind":"module","full_name":"Log::Dispatcher","name":"Dispatcher","abstract":false,"locations":[{"filename":"src/log/dispatch.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"including_types":[{"html_id":"Crystal/Log/AsyncDispatcher","kind":"class","full_name":"Log::AsyncDispatcher","name":"AsyncDispatcher"},{"html_id":"Crystal/Log/SyncDispatcher","kind":"class","full_name":"Log::SyncDispatcher","name":"SyncDispatcher"}],"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"Base interface implemented by log entry dispatchers\n\nDispatchers are in charge of sending log entries according\nto different strategies.","summary":"<p>Base interface implemented by log entry dispatchers</p>","instance_methods":[{"html_id":"close-instance-method","name":"close","doc":"Close the dispatcher, releasing resources","summary":"<p>Close the dispatcher, releasing resources</p>","abstract":false,"location":{"filename":"src/log/dispatch.cr","line_number":13,"url":null},"def":{"name":"close","visibility":"Public","body":""}},{"html_id":"dispatch(entry:Entry,backend:Backend)-instance-method","name":"dispatch","doc":"Dispatch a log entry to the specified backend","summary":"<p>Dispatch a log entry to the specified backend</p>","abstract":true,"args":[{"name":"entry","external_name":"entry","restriction":"Entry"},{"name":"backend","external_name":"backend","restriction":"Backend"}],"args_string":"(entry : Entry, backend : Backend)","args_html":"(entry : <a href=\"../Log/Entry.html\">Entry</a>, backend : <a href=\"../Log/Backend.html\">Backend</a>)","location":{"filename":"src/log/dispatch.cr","line_number":10,"url":null},"def":{"name":"dispatch","args":[{"name":"entry","external_name":"entry","restriction":"Entry"},{"name":"backend","external_name":"backend","restriction":"Backend"}],"visibility":"Public","body":""}}],"types":[{"html_id":"Crystal/Log/Dispatcher/Spec","path":"Log/Dispatcher/Spec.html","kind":"alias","full_name":"Log::Dispatcher::Spec","name":"Spec","abstract":false,"locations":[{"filename":"src/log/dispatch.cr","line_number":7,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(Log::DispatchMode | Log::Dispatcher)","aliased_html":"<a href=\"../../Log/DispatchMode.html\">Log::DispatchMode</a> | <a href=\"../../Log/Dispatcher.html\">Log::Dispatcher</a>","const":false,"namespace":{"html_id":"Crystal/Log/Dispatcher","kind":"module","full_name":"Log::Dispatcher","name":"Dispatcher"}}]},{"html_id":"Crystal/Log/DispatchMode","path":"Log/DispatchMode.html","kind":"enum","full_name":"Log::DispatchMode","name":"DispatchMode","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/dispatch.cr","line_number":29,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Sync","name":"Sync","value":"0"},{"id":"Async","name":"Async","value":"1"},{"id":"Direct","name":"Direct","value":"2"}],"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"instance_methods":[{"html_id":"async?-instance-method","name":"async?","abstract":false,"location":{"filename":"src/log/dispatch.cr","line_number":31,"url":null},"def":{"name":"async?","visibility":"Public","body":"self == Async"}},{"html_id":"direct?-instance-method","name":"direct?","abstract":false,"location":{"filename":"src/log/dispatch.cr","line_number":32,"url":null},"def":{"name":"direct?","visibility":"Public","body":"self == Direct"}},{"html_id":"sync?-instance-method","name":"sync?","abstract":false,"location":{"filename":"src/log/dispatch.cr","line_number":30,"url":null},"def":{"name":"sync?","visibility":"Public","body":"self == Sync"}}]},{"html_id":"Crystal/Log/Emitter","path":"Log/Emitter.html","kind":"struct","full_name":"Log::Emitter","name":"Emitter","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/main.cr","line_number":176,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"Helper DSL module for emitting log entries with data.","summary":"<p>Helper DSL module for emitting log entries with data.</p>","instance_methods":[{"html_id":"emit(message:String,data:Metadata|Hash|NamedTuple):Entry-instance-method","name":"emit","abstract":false,"args":[{"name":"message","external_name":"message","restriction":"String"},{"name":"data","external_name":"data","restriction":"Metadata | Hash | NamedTuple"}],"args_string":"(message : String, data : Metadata | Hash | NamedTuple) : Entry","args_html":"(message : <a href=\"../String.html\">String</a>, data : <a href=\"../Log/Metadata.html\">Metadata</a> | <a href=\"../Hash.html\">Hash</a> | <a href=\"../NamedTuple.html\">NamedTuple</a>) : <a href=\"../Log/Entry.html\">Entry</a>","location":{"filename":"src/log/main.cr","line_number":197,"url":null},"def":{"name":"emit","args":[{"name":"message","external_name":"message","restriction":"String"},{"name":"data","external_name":"data","restriction":"Metadata | Hash | NamedTuple"}],"return_type":"Entry","visibility":"Public","body":"Entry.new(@source, @severity, message, Metadata.build(data), @exception)"}},{"html_id":"emit(message:String):Entry-instance-method","name":"emit","doc":"Emits a logs entry with a message, and data attached to\n\n```\nLog.info &.emit(\"Program started\")                         # No data, same as Log.info { \"Program started\" }\nLog.info &.emit(\"User logged in\", user_id: 42)             # With entry data\nLog.info &.emit(action: \"Logged in\", user_id: 42)          # Empty string message, only data\nLog.error exception: ex, &.emit(\"Oops\", account: {id: 42}) # With data and exception\n```","summary":"<p>Emits a logs entry with a message, and data attached to</p>","abstract":false,"args":[{"name":"message","external_name":"message","restriction":"String"}],"args_string":"(message : String) : Entry","args_html":"(message : <a href=\"../String.html\">String</a>) : <a href=\"../Log/Entry.html\">Entry</a>","location":{"filename":"src/log/main.cr","line_number":189,"url":null},"def":{"name":"emit","args":[{"name":"message","external_name":"message","restriction":"String"}],"return_type":"Entry","visibility":"Public","body":"emit(message, Metadata.empty)"}},{"html_id":"emit(data:Metadata|Hash|NamedTuple):Entry-instance-method","name":"emit","abstract":false,"args":[{"name":"data","external_name":"data","restriction":"Metadata | Hash | NamedTuple"}],"args_string":"(data : Metadata | Hash | NamedTuple) : Entry","args_html":"(data : <a href=\"../Log/Metadata.html\">Metadata</a> | <a href=\"../Hash.html\">Hash</a> | <a href=\"../NamedTuple.html\">NamedTuple</a>) : <a href=\"../Log/Entry.html\">Entry</a>","location":{"filename":"src/log/main.cr","line_number":205,"url":null},"def":{"name":"emit","args":[{"name":"data","external_name":"data","restriction":"Metadata | Hash | NamedTuple"}],"return_type":"Entry","visibility":"Public","body":"emit(\"\", Metadata.build(data))"}},{"html_id":"emit(message:String,**kwargs):Entry-instance-method","name":"emit","abstract":false,"args":[{"name":"message","external_name":"message","restriction":"String"}],"args_string":"(message : String, **kwargs) : Entry","args_html":"(message : <a href=\"../String.html\">String</a>, **kwargs) : <a href=\"../Log/Entry.html\">Entry</a>","location":{"filename":"src/log/main.cr","line_number":193,"url":null},"def":{"name":"emit","args":[{"name":"message","external_name":"message","restriction":"String"}],"double_splat":{"name":"kwargs","external_name":"kwargs","restriction":""},"return_type":"Entry","visibility":"Public","body":"emit(message, kwargs)"}},{"html_id":"emit(**kwargs):Entry-instance-method","name":"emit","abstract":false,"location":{"filename":"src/log/main.cr","line_number":201,"url":null},"def":{"name":"emit","double_splat":{"name":"kwargs","external_name":"kwargs","restriction":""},"return_type":"Entry","visibility":"Public","body":"emit(kwargs)"}}]},{"html_id":"Crystal/Log/EntriesChecker","path":"Log/EntriesChecker.html","kind":"class","full_name":"Log::EntriesChecker","name":"EntriesChecker","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/spec.cr","line_number":76,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"DSL for `Log.capture`","summary":"<p>DSL for <code><a href=\"../Log.html#capture%28source%3AString%3D%22%2A%22%2Clevel%3ASeverity%3DLog%3A%3ASeverity%3A%3ATrace%2C%2A%2Cbuilder%3DLog.builder%2C%26%29-class-method\">Log.capture</a></code></p>","constructors":[{"html_id":"new(entries:Array(Log::Entry))-class-method","name":"new","abstract":false,"args":[{"name":"entries","external_name":"entries","restriction":"Array(Log::Entry)"}],"args_string":"(entries : Array(Log::Entry))","args_html":"(entries : <a href=\"../Array.html\">Array</a>(<a href=\"../Log/Entry.html\">Log::Entry</a>))","location":{"filename":"src/log/spec.cr","line_number":77,"url":null},"def":{"name":"new","args":[{"name":"entries","external_name":"entries","restriction":"Array(Log::Entry)"}],"visibility":"Public","body":"_ = allocate\n_.initialize(entries)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"check(level:Severity,message:String,file=__FILE__,line=__LINE__):self-instance-method","name":"check","doc":"Validates that at some point the indicated entry was emitted","summary":"<p>Validates that at some point the indicated entry was emitted</p>","abstract":false,"args":[{"name":"level","external_name":"level","restriction":"Severity"},{"name":"message","external_name":"message","restriction":"String"},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(level : Severity, message : String, file = __FILE__, line = __LINE__) : self","args_html":"(level : <a href=\"../Log/Severity.html\">Severity</a>, message : <a href=\"../String.html\">String</a>, file = __FILE__, line = __LINE__) : <span class=\"k\">self</span>","location":{"filename":"src/log/spec.cr","line_number":100,"url":null},"def":{"name":"check","args":[{"name":"level","external_name":"level","restriction":"Severity"},{"name":"message","external_name":"message","restriction":"String"},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"return_type":"self","visibility":"Public","body":"self.check(\"#{level} with #{message.inspect}\", file, line) do |e|\n  (e.severity == level) && (e.message == message)\nend"}},{"html_id":"check(level:Severity,pattern:Regex,file=__FILE__,line=__LINE__):self-instance-method","name":"check","doc":"Validates that at some point the indicated entry was emitted","summary":"<p>Validates that at some point the indicated entry was emitted</p>","abstract":false,"args":[{"name":"level","external_name":"level","restriction":"Severity"},{"name":"pattern","external_name":"pattern","restriction":"Regex"},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(level : Severity, pattern : Regex, file = __FILE__, line = __LINE__) : self","args_html":"(level : <a href=\"../Log/Severity.html\">Severity</a>, pattern : <a href=\"../Regex.html\">Regex</a>, file = __FILE__, line = __LINE__) : <span class=\"k\">self</span>","location":{"filename":"src/log/spec.cr","line_number":105,"url":null},"def":{"name":"check","args":[{"name":"level","external_name":"level","restriction":"Severity"},{"name":"pattern","external_name":"pattern","restriction":"Regex"},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"return_type":"self","visibility":"Public","body":"self.check(\"#{level} matching #{pattern.inspect}\", file, line) do |e|\n  (e.severity == level) && (e.message.matches?(pattern))\nend"}},{"html_id":"clear-instance-method","name":"clear","doc":"Clears the emitted entries so far","summary":"<p>Clears the emitted entries so far</p>","abstract":false,"location":{"filename":"src/log/spec.cr","line_number":135,"url":null},"def":{"name":"clear","visibility":"Public","body":"@entry = nil\n@entries.clear\nself\n"}},{"html_id":"empty(file=__FILE__,line=__LINE__)-instance-method","name":"empty","doc":"Validates that there are no outstanding entries","summary":"<p>Validates that there are no outstanding entries</p>","abstract":false,"args":[{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(file = __FILE__, line = __LINE__)","args_html":"(file = __FILE__, line = __LINE__)","location":{"filename":"src/log/spec.cr","line_number":142,"url":null},"def":{"name":"empty","args":[{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"visibility":"Public","body":"@entry = nil\nif first = @entries.first?\n  fail(\"Expected no entries, but got #{first.severity} with #{first.message.inspect} in a total of #{@entries.size} entries\", file, line)\nelse\n  self\nend\n"}},{"html_id":"entry:Entry-instance-method","name":"entry","doc":"Returns the last entry matched by `#check` or `#next`","summary":"<p>Returns the last entry matched by <code><a href=\"../Log/EntriesChecker.html#check%28level%3ASeverity%2Cmessage%3AString%2Cfile%3D__FILE__%2Cline%3D__LINE__%29%3Aself-instance-method\">#check</a></code> or <code><a href=\"../Log/EntriesChecker.html#next%28level%3ASeverity%2Cmessage%3AString%2Cfile%3D__FILE__%2Cline%3D__LINE__%29%3Aself-instance-method\">#next</a></code></p>","abstract":false,"location":{"filename":"src/log/spec.cr","line_number":81,"url":null},"def":{"name":"entry","return_type":"Entry","visibility":"Public","body":"if (value = @entry).nil?\n  ::raise(NilAssertionError.new(\"Log::EntriesChecker#entry cannot be nil\"))\nelse\n  value\nend"}},{"html_id":"entry?:Entry?-instance-method","name":"entry?","doc":"Returns the last entry matched by `#check` or `#next`","summary":"<p>Returns the last entry matched by <code><a href=\"../Log/EntriesChecker.html#check%28level%3ASeverity%2Cmessage%3AString%2Cfile%3D__FILE__%2Cline%3D__LINE__%29%3Aself-instance-method\">#check</a></code> or <code><a href=\"../Log/EntriesChecker.html#next%28level%3ASeverity%2Cmessage%3AString%2Cfile%3D__FILE__%2Cline%3D__LINE__%29%3Aself-instance-method\">#next</a></code></p>","abstract":false,"location":{"filename":"src/log/spec.cr","line_number":81,"url":null},"def":{"name":"entry?","return_type":"Entry | ::Nil","visibility":"Public","body":"@entry"}},{"html_id":"next(level:Severity,message:String,file=__FILE__,line=__LINE__):self-instance-method","name":"next","doc":"Validates that the indicated entry was the next one to be emitted","summary":"<p>Validates that the indicated entry was the next one to be emitted</p>","abstract":false,"args":[{"name":"level","external_name":"level","restriction":"Severity"},{"name":"message","external_name":"message","restriction":"String"},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(level : Severity, message : String, file = __FILE__, line = __LINE__) : self","args_html":"(level : <a href=\"../Log/Severity.html\">Severity</a>, message : <a href=\"../String.html\">String</a>, file = __FILE__, line = __LINE__) : <span class=\"k\">self</span>","location":{"filename":"src/log/spec.cr","line_number":125,"url":null},"def":{"name":"next","args":[{"name":"level","external_name":"level","restriction":"Severity"},{"name":"message","external_name":"message","restriction":"String"},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"return_type":"self","visibility":"Public","body":"self.next(\"#{level} with #{message.inspect}\", file, line) do |e|\n  (e.severity == level) && (e.message == message)\nend"}},{"html_id":"next(level:Severity,pattern:Regex,file=__FILE__,line=__LINE__):self-instance-method","name":"next","doc":"Validates that the indicated entry was the next one to be emitted","summary":"<p>Validates that the indicated entry was the next one to be emitted</p>","abstract":false,"args":[{"name":"level","external_name":"level","restriction":"Severity"},{"name":"pattern","external_name":"pattern","restriction":"Regex"},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(level : Severity, pattern : Regex, file = __FILE__, line = __LINE__) : self","args_html":"(level : <a href=\"../Log/Severity.html\">Severity</a>, pattern : <a href=\"../Regex.html\">Regex</a>, file = __FILE__, line = __LINE__) : <span class=\"k\">self</span>","location":{"filename":"src/log/spec.cr","line_number":130,"url":null},"def":{"name":"next","args":[{"name":"level","external_name":"level","restriction":"Severity"},{"name":"pattern","external_name":"pattern","restriction":"Regex"},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"return_type":"self","visibility":"Public","body":"self.next(\"#{level} matching #{pattern.inspect}\", file, line) do |e|\n  (e.severity == level) && (e.message.matches?(pattern))\nend"}}]},{"html_id":"Crystal/Log/Entry","path":"Log/Entry.html","kind":"struct","full_name":"Log::Entry","name":"Entry","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/entry.cr","line_number":34,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"constructors":[{"html_id":"new(source:String,severity:Severity,message:String,data:Log::Metadata,exception:Exception?,*,timestamp=Time.local)-class-method","name":"new","abstract":false,"args":[{"name":"source","external_name":"source","restriction":"String"},{"name":"severity","external_name":"severity","restriction":"Severity"},{"name":"message","external_name":"message","restriction":"String"},{"name":"data","external_name":"data","restriction":"Log::Metadata"},{"name":"exception","external_name":"exception","restriction":"Exception | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"timestamp","default_value":"Time.local","external_name":"timestamp","restriction":""}],"args_string":"(source : String, severity : Severity, message : String, data : Log::Metadata, exception : Exception?, *, timestamp = Time.local)","args_html":"(source : <a href=\"../String.html\">String</a>, severity : <a href=\"../Log/Severity.html\">Severity</a>, message : <a href=\"../String.html\">String</a>, data : <a href=\"../Log/Metadata.html\">Log::Metadata</a>, exception : <a href=\"../Exception.html\">Exception</a>?, *, timestamp = <span class=\"t\">Time</span>.local)","location":{"filename":"src/log/entry.cr","line_number":43,"url":null},"def":{"name":"new","args":[{"name":"source","external_name":"source","restriction":"String"},{"name":"severity","external_name":"severity","restriction":"Severity"},{"name":"message","external_name":"message","restriction":"String"},{"name":"data","external_name":"data","restriction":"Log::Metadata"},{"name":"exception","external_name":"exception","restriction":"Exception | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"timestamp","default_value":"Time.local","external_name":"timestamp","restriction":""}],"splat_index":5,"visibility":"Public","body":"_ = allocate\n_.initialize(source, severity, message, data, exception, timestamp: timestamp)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"context:Metadata-instance-method","name":"context","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":39,"url":null},"def":{"name":"context","return_type":"Metadata","visibility":"Public","body":"@context"}},{"html_id":"data:Metadata-instance-method","name":"data","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":40,"url":null},"def":{"name":"data","return_type":"Metadata","visibility":"Public","body":"@data"}},{"html_id":"exception:Exception?-instance-method","name":"exception","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":41,"url":null},"def":{"name":"exception","return_type":"Exception | ::Nil","visibility":"Public","body":"@exception"}},{"html_id":"message:String-instance-method","name":"message","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":37,"url":null},"def":{"name":"message","return_type":"String","visibility":"Public","body":"@message"}},{"html_id":"severity:Severity-instance-method","name":"severity","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":36,"url":null},"def":{"name":"severity","return_type":"Severity","visibility":"Public","body":"@severity"}},{"html_id":"source:String-instance-method","name":"source","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":35,"url":null},"def":{"name":"source","return_type":"String","visibility":"Public","body":"@source"}},{"html_id":"timestamp:Time-instance-method","name":"timestamp","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":38,"url":null},"def":{"name":"timestamp","return_type":"Time","visibility":"Public","body":"@timestamp"}}]},{"html_id":"Crystal/Log/Formatter","path":"Log/Formatter.html","kind":"module","full_name":"Log::Formatter","name":"Formatter","abstract":false,"locations":[{"filename":"src/log/format.cr","line_number":11,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"Base interface to convert log entries and write them to an `IO`","summary":"<p>Base interface to convert log entries and write them to an <code><a href=\"../IO.html\">IO</a></code></p>","constructors":[{"html_id":"new(&proc:Log::Entry,IO->)-class-method","name":"new","doc":"Creates an instance of a `Log::Formatter` that calls\nthe specified `Proc` for every entry","summary":"<p>Creates an instance of a <code><a href=\"../Log/Formatter.html\">Log::Formatter</a></code> that calls the specified <code><a href=\"../Proc.html\">Proc</a></code> for every entry</p>","abstract":false,"location":{"filename":"src/log/format.cr","line_number":17,"url":null},"def":{"name":"new","yields":2,"block_arg":{"name":"proc","external_name":"proc","restriction":"(Log::Entry, IO ->)"},"visibility":"Public","body":"ProcFormatter.new(proc)"}}],"instance_methods":[{"html_id":"format(entry:Log::Entry,io:IO)-instance-method","name":"format","doc":"Writes a `Log::Entry` through an `IO`","summary":"<p>Writes a <code><a href=\"../Log/Entry.html\">Log::Entry</a></code> through an <code><a href=\"../IO.html\">IO</a></code></p>","abstract":true,"args":[{"name":"entry","external_name":"entry","restriction":"Log::Entry"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(entry : Log::Entry, io : IO)","args_html":"(entry : <a href=\"../Log/Entry.html\">Log::Entry</a>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/log/format.cr","line_number":13,"url":null},"def":{"name":"format","args":[{"name":"entry","external_name":"entry","restriction":"Log::Entry"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":""}}]},{"html_id":"Crystal/Log/IOBackend","path":"Log/IOBackend.html","kind":"class","full_name":"Log::IOBackend","name":"IOBackend","abstract":false,"superclass":{"html_id":"Crystal/Log/Backend","kind":"class","full_name":"Log::Backend","name":"Backend"},"ancestors":[{"html_id":"Crystal/Log/Backend","kind":"class","full_name":"Log::Backend","name":"Backend"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/io_backend.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"A `Log::Backend` that emits to an `IO` (defaults to STDOUT).","summary":"<p>A <code><a href=\"../Log/Backend.html\">Log::Backend</a></code> that emits to an <code><a href=\"../IO.html\">IO</a></code> (defaults to STDOUT).</p>","constructors":[{"html_id":"new(io=STDOUT,*,formatter:Formatter=ShortFormat,dispatcher:Dispatcher::Spec=DispatchMode::Async)-class-method","name":"new","abstract":false,"args":[{"name":"io","default_value":"STDOUT","external_name":"io","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"formatter","default_value":"ShortFormat","external_name":"formatter","restriction":"Formatter"},{"name":"dispatcher","default_value":"DispatchMode::Async","external_name":"dispatcher","restriction":"Dispatcher::Spec"}],"args_string":"(io = STDOUT, *, formatter : Formatter = ShortFormat, dispatcher : Dispatcher::Spec = DispatchMode::Async)","args_html":"(io = <span class=\"t\">STDOUT</span>, *, formatter : <a href=\"../Log/Formatter.html\">Formatter</a> = <span class=\"t\">ShortFormat</span>, dispatcher : <a href=\"../Log/Dispatcher/Spec.html\">Dispatcher::Spec</a> = <span class=\"t\">DispatchMode</span><span class=\"t\">::</span><span class=\"t\">Async</span>)","location":{"filename":"src/log/io_backend.cr","line_number":6,"url":null},"def":{"name":"new","args":[{"name":"io","default_value":"STDOUT","external_name":"io","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"formatter","default_value":"ShortFormat","external_name":"formatter","restriction":"Formatter"},{"name":"dispatcher","default_value":"DispatchMode::Async","external_name":"dispatcher","restriction":"Dispatcher::Spec"}],"splat_index":1,"visibility":"Public","body":"_ = allocate\n_.initialize(io, formatter: formatter, dispatcher: dispatcher)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"format(entry:Entry):Nil-instance-method","name":"format","doc":"Emits the *entry* to the given *io*.\nIt uses the `#formatter` to convert.","summary":"<p>Emits the <em>entry</em> to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"entry","external_name":"entry","restriction":"Entry"}],"args_string":"(entry : Entry) : Nil","args_html":"(entry : <a href=\"../Log/Entry.html\">Entry</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/log/io_backend.cr","line_number":25,"url":null},"def":{"name":"format","args":[{"name":"entry","external_name":"entry","restriction":"Entry"}],"return_type":"Nil","visibility":"Public","body":"@formatter.format(entry, io)"}},{"html_id":"formatter:Formatter-instance-method","name":"formatter","abstract":false,"location":{"filename":"src/log/io_backend.cr","line_number":4,"url":null},"def":{"name":"formatter","return_type":"Formatter","visibility":"Public","body":"@formatter"}},{"html_id":"formatter=(formatter:Formatter)-instance-method","name":"formatter=","abstract":false,"args":[{"name":"formatter","external_name":"formatter","restriction":"Formatter"}],"args_string":"(formatter : Formatter)","args_html":"(formatter : <a href=\"../Log/Formatter.html\">Formatter</a>)","location":{"filename":"src/log/io_backend.cr","line_number":4,"url":null},"def":{"name":"formatter=","args":[{"name":"formatter","external_name":"formatter","restriction":"Formatter"}],"visibility":"Public","body":"@formatter = formatter"}},{"html_id":"io:IO-instance-method","name":"io","abstract":false,"location":{"filename":"src/log/io_backend.cr","line_number":3,"url":null},"def":{"name":"io","return_type":"IO","visibility":"Public","body":"@io"}},{"html_id":"io=(io:IO)-instance-method","name":"io=","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","args_html":"(io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/log/io_backend.cr","line_number":3,"url":null},"def":{"name":"io=","args":[{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"@io = io"}},{"html_id":"write(entry:Entry):Nil-instance-method","name":"write","doc":"Writes the *entry* to this backend.","summary":"<p>Writes the <em>entry</em> to this backend.</p>","abstract":false,"args":[{"name":"entry","external_name":"entry","restriction":"Entry"}],"args_string":"(entry : Entry) : Nil","args_html":"(entry : <a href=\"../Log/Entry.html\">Entry</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/log/io_backend.cr","line_number":17,"url":null},"def":{"name":"write","args":[{"name":"entry","external_name":"entry","restriction":"Entry"}],"return_type":"Nil","visibility":"Public","body":"format(entry)\nio.puts\nio.flush\n"}}]},{"html_id":"Crystal/Log/MemoryBackend","path":"Log/MemoryBackend.html","kind":"class","full_name":"Log::MemoryBackend","name":"MemoryBackend","abstract":false,"superclass":{"html_id":"Crystal/Log/Backend","kind":"class","full_name":"Log::Backend","name":"Backend"},"ancestors":[{"html_id":"Crystal/Log/Backend","kind":"class","full_name":"Log::Backend","name":"Backend"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/memory_backend.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"A `Log::Backend` suitable for testing.\n","summary":"<p>A <code><a href=\"../Log/Backend.html\">Log::Backend</a></code> suitable for testing.</p>","constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/log/memory_backend.cr","line_number":6,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"entries:Array(Log::Entry)-instance-method","name":"entries","abstract":false,"location":{"filename":"src/log/memory_backend.cr","line_number":4,"url":null},"def":{"name":"entries","visibility":"Public","body":"@entries"}},{"html_id":"write(entry:Log::Entry):Nil-instance-method","name":"write","doc":"Writes the *entry* to this backend.","summary":"<p>Writes the <em>entry</em> to this backend.</p>","abstract":false,"args":[{"name":"entry","external_name":"entry","restriction":"Log::Entry"}],"args_string":"(entry : Log::Entry) : Nil","args_html":"(entry : <a href=\"../Log/Entry.html\">Log::Entry</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/log/memory_backend.cr","line_number":10,"url":null},"def":{"name":"write","args":[{"name":"entry","external_name":"entry","restriction":"Log::Entry"}],"return_type":"Nil","visibility":"Public","body":"@entries << entry"}}]},{"html_id":"Crystal/Log/Metadata","path":"Log/Metadata.html","kind":"class","full_name":"Log::Metadata","name":"Metadata","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/metadata.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"Immutable structured metadata information for logging.\n\nSee `Log.context`, `Log.context=`, `Log::Context#clear`, `Log::Context#set`, `Log.with_context`, and `Log::Emitter`.\n\nNOTE: If you'd like to format the context as JSON, remember to `require \"log/json\"`.","summary":"<p>Immutable structured metadata information for logging.</p>","class_methods":[{"html_id":"empty:Log::Metadata-class-method","name":"empty","doc":"Returns an empty `Log::Metadata`.\n\nNOTE: Since `Log::Metadata` is immutable, it's safe to share this instance.","summary":"<p>Returns an empty <code><a href=\"../Log/Metadata.html\">Log::Metadata</a></code>.</p>","abstract":false,"location":{"filename":"src/log/metadata.cr","line_number":15,"url":null},"def":{"name":"empty","return_type":"Log::Metadata","visibility":"Public","body":"@@empty"}}],"constructors":[{"html_id":"build(value:NamedTuple|Hash):self-class-method","name":"build","doc":"Returns a `Metadata` with the information of the argument.\nUsed to handle `Log::Context#set` and `Log#Emitter.emit` overloads.","summary":"<p>Returns a <code><a href=\"../Log/Metadata.html\">Metadata</a></code> with the information of the argument.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"NamedTuple | Hash"}],"args_string":"(value : NamedTuple | Hash) : self","args_html":"(value : <a href=\"../NamedTuple.html\">NamedTuple</a> | <a href=\"../Hash.html\">Hash</a>) : <span class=\"k\">self</span>","location":{"filename":"src/log/metadata.cr","line_number":58,"url":null},"def":{"name":"build","args":[{"name":"value","external_name":"value","restriction":"NamedTuple | Hash"}],"return_type":"self","visibility":"Public","body":"if value.empty?\n  return @@empty\nend\nMetadata.new(nil, value)\n"}},{"html_id":"build(value:Metadata):Metadata-class-method","name":"build","doc":"Returns a `Metadata` with the information of the argument.\nUsed to handle `Log::Context#set` and `Log#Emitter.emit` overloads.","summary":"<p>Returns a <code><a href=\"../Log/Metadata.html\">Metadata</a></code> with the information of the argument.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Metadata"}],"args_string":"(value : Metadata) : Metadata","args_html":"(value : <a href=\"../Log/Metadata.html\">Metadata</a>) : <a href=\"../Log/Metadata.html\">Metadata</a>","location":{"filename":"src/log/metadata.cr","line_number":64,"url":null},"def":{"name":"build","args":[{"name":"value","external_name":"value","restriction":"Metadata"}],"return_type":"Metadata","visibility":"Public","body":"value"}},{"html_id":"new(parent:Metadata?=nil,entries:NamedTuple|Hash=NamedTuple.new)-class-method","name":"new","abstract":false,"args":[{"name":"parent","default_value":"nil","external_name":"parent","restriction":"Metadata | ::Nil"},{"name":"entries","default_value":"NamedTuple.new","external_name":"entries","restriction":"NamedTuple | Hash"}],"args_string":"(parent : Metadata? = nil, entries : NamedTuple | Hash = NamedTuple.new)","args_html":"(parent : <a href=\"../Log/Metadata.html\">Metadata</a>? = <span class=\"n\">nil</span>, entries : <a href=\"../NamedTuple.html\">NamedTuple</a> | <a href=\"../Hash.html\">Hash</a> = <span class=\"t\">NamedTuple</span>.<span class=\"k\">new</span>)","location":{"filename":"src/log/metadata.cr","line_number":33,"url":null},"def":{"name":"new","args":[{"name":"parent","default_value":"nil","external_name":"parent","restriction":"Metadata | ::Nil"},{"name":"entries","default_value":"NamedTuple.new","external_name":"entries","restriction":"NamedTuple | Hash"}],"visibility":"Public","body":"data_size = (instance_sizeof(self)) + ((sizeof(Entry)) * {(entries.size + (parent.try(&.max_total_size) || 0)) - 1, 0}.max)\ndata = (GC.malloc(data_size)).as(self)\ndata.setup(parent, entries)\ndata\n"}}],"instance_methods":[{"html_id":"==(other:Metadata)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Metadata"}],"args_string":"(other : Metadata)","args_html":"(other : <a href=\"../Log/Metadata.html\">Metadata</a>)","location":{"filename":"src/log/metadata.cr","line_number":161,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Metadata"}],"visibility":"Public","body":"self_kv = self.to_a\nother_kv = other.to_a\nif self_kv.size != other_kv.size\n  return false\nend\nself_kv.sort_by!(&.[](0))\nother_kv.sort_by!(&.[](0))\nself_kv.each_with_index do |__arg6, i|\n  key = __arg6[0]\n  value = __arg6[1]\n  if (key == other_kv[i][0]) && (value == other_kv[i][1])\n  else\n    return false\n  end\nend\ntrue\n"}},{"html_id":"==(other)-instance-method","name":"==","doc":"Returns `false` (other can only be a `Value` here).","summary":"<p>Returns <code>false</code> (other can only be a <code><a href=\"../Log/Metadata/Value.html\">Value</a></code> here).</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/log/metadata.cr","line_number":178,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"false"}},{"html_id":"[](key:Symbol):Value-instance-method","name":"[]","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"Symbol"}],"args_string":"(key : Symbol) : Value","args_html":"(key : <a href=\"../Symbol.html\">Symbol</a>) : <a href=\"../Log/Metadata/Value.html\">Value</a>","location":{"filename":"src/log/metadata.cr","line_number":131,"url":null},"def":{"name":"[]","args":[{"name":"key","external_name":"key","restriction":"Symbol"}],"return_type":"Value","visibility":"Public","body":"fetch(key) do\n  raise(KeyError.new(\"Missing metadata key: #{key.inspect}\"))\nend"}},{"html_id":"[]?(key:Symbol):Value?-instance-method","name":"[]?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"Symbol"}],"args_string":"(key : Symbol) : Value?","args_html":"(key : <a href=\"../Symbol.html\">Symbol</a>) : <a href=\"../Log/Metadata/Value.html\">Value</a>?","location":{"filename":"src/log/metadata.cr","line_number":135,"url":null},"def":{"name":"[]?","args":[{"name":"key","external_name":"key","restriction":"Symbol"}],"return_type":"Value | ::Nil","visibility":"Public","body":"fetch(key) do\n  nil\nend"}},{"html_id":"each(&:Tuple(Symbol,Value)->)-instance-method","name":"each","doc":"Must yield this collection's elements to the block.","summary":"<p>Must yield this collection's elements to the block.</p>","abstract":false,"location":{"filename":"src/log/metadata.cr","line_number":121,"url":null},"def":{"name":"each","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(::Tuple(Symbol, Value) ->)"},"visibility":"Public","body":"defrag\nptr_entries = pointerof(@first)\n@size.times do |i|\n  entry = ptr_entries[i]\n  yield({entry[:key], entry[:value]})\nend\n"}},{"html_id":"empty?:Bool-instance-method","name":"empty?","doc":"Returns `true` if `self` is empty, `false` otherwise.\n\n```\n([] of Int32).empty? # => true\n([1]).empty?         # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is empty, <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/log/metadata.cr","line_number":77,"url":null},"def":{"name":"empty?","return_type":"Bool","visibility":"Public","body":"parent = @parent\n(@size == 0) && (parent.nil? || parent.empty?)\n"}},{"html_id":"extend(other:NamedTuple|Hash):Metadata-instance-method","name":"extend","doc":"Returns a `Log::Metadata` with all the entries of *self*\nand *other*. If a key is defined in both, the values in *other* are used.","summary":"<p>Returns a <code><a href=\"../Log/Metadata.html\">Log::Metadata</a></code> with all the entries of <em>self</em> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NamedTuple | Hash"}],"args_string":"(other : NamedTuple | Hash) : Metadata","args_html":"(other : <a href=\"../NamedTuple.html\">NamedTuple</a> | <a href=\"../Hash.html\">Hash</a>) : <a href=\"../Log/Metadata.html\">Metadata</a>","location":{"filename":"src/log/metadata.cr","line_number":70,"url":null},"def":{"name":"extend","args":[{"name":"other","external_name":"other","restriction":"NamedTuple | Hash"}],"return_type":"Metadata","visibility":"Public","body":"if self.empty?\n  return Metadata.build(other)\nend\nif other.empty?\n  return self\nend\nMetadata.new(self, other)\n"}},{"html_id":"fetch(key,&)-instance-method","name":"fetch","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key, &)","args_html":"(key, &)","location":{"filename":"src/log/metadata.cr","line_number":139,"url":null},"def":{"name":"fetch","args":[{"name":"key","external_name":"key","restriction":""}],"yields":1,"visibility":"Public","body":"entry = find_entry(key)\nentry ? entry[:value] : yield key\n"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/log/metadata.cr","line_number":182,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"to_a.sort_by!(&.[](0)).hash(hasher)"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a short String representation of this object\nwhich includes its class name and its object address.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).to_s # => #<Person:0x10a199f20>\n```","summary":"<p>Appends a short String representation of this object which includes its class name and its object address.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/log/metadata.cr","line_number":186,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"found_one = false\neach do |__arg8|\n  key = __arg8[0]\n  value = __arg8[1]\n  if found_one\n    io << \", \"\n  end\n  io << key\n  io << \": \"\n  value.inspect(io)\n  found_one = true\nend\n"}}],"types":[{"html_id":"Crystal/Log/Metadata/Entry","path":"Log/Metadata/Entry.html","kind":"alias","full_name":"Log::Metadata::Entry","name":"Entry","abstract":false,"locations":[{"filename":"src/log/metadata.cr","line_number":10,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"NamedTuple(key: Symbol, value: Log::Metadata::Value)","aliased_html":"{key: <a href=\"../../Symbol.html\">Symbol</a>, value: <a href=\"../../Log/Metadata/Value.html\">Log::Metadata::Value</a>}","const":false,"namespace":{"html_id":"Crystal/Log/Metadata","kind":"class","full_name":"Log::Metadata","name":"Metadata"}},{"html_id":"Crystal/Log/Metadata/Value","path":"Log/Metadata/Value.html","kind":"struct","full_name":"Log::Metadata::Value","name":"Value","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/metadata.cr","line_number":7,"url":null},{"filename":"src/log/metadata.cr","line_number":197,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Log/Metadata","kind":"class","full_name":"Log::Metadata","name":"Metadata"},"constructors":[{"html_id":"new(raw:Type)-class-method","name":"new","doc":"Creates a `Log::Metadata::Value` that wraps the given `Type`.","summary":"<p>Creates a <code><a href=\"../../Log/Metadata/Value.html\">Log::Metadata::Value</a></code> that wraps the given <code><a href=\"../../Log/Metadata/Value/Type.html\">Type</a></code>.</p>","abstract":false,"args":[{"name":"raw","external_name":"raw","restriction":"Type"}],"args_string":"(raw : Type)","args_html":"(raw : <a href=\"../../Log/Metadata/Value/Type.html\">Type</a>)","location":{"filename":"src/log/metadata.cr","line_number":198,"url":null},"def":{"name":"new","args":[{"name":"raw","external_name":"raw","restriction":"Type"}],"visibility":"Public","body":"_ = allocate\n_.initialize(raw)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(hash:NamedTuple|Hash)-class-method","name":"new","doc":"Creates `Log::Metadata` from the given *values*.\nAll keys are converted to `String`","summary":"<p>Creates <code><a href=\"../../Log/Metadata.html\">Log::Metadata</a></code> from the given <em>values</em>.</p>","abstract":false,"args":[{"name":"hash","external_name":"hash","restriction":"NamedTuple | Hash"}],"args_string":"(hash : NamedTuple | Hash)","args_html":"(hash : <a href=\"../../NamedTuple.html\">NamedTuple</a> | <a href=\"../../Hash.html\">Hash</a>)","location":{"filename":"src/log/metadata.cr","line_number":202,"url":null},"def":{"name":"new","args":[{"name":"hash","external_name":"hash","restriction":"NamedTuple | Hash"}],"visibility":"Public","body":"_ = allocate\n_.initialize(hash)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if both `self` and *other*'s raw object are equal.","summary":"<p>Returns <code>true</code> if both <code>self</code> and <em>other</em>'s raw object are equal.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/log/metadata.cr","line_number":198,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"raw == other.raw"}},{"html_id":"==(other)-instance-method","name":"==","doc":"Returns `true` if the raw object is equal to *other*.","summary":"<p>Returns <code>true</code> if the raw object is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/log/metadata.cr","line_number":198,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"raw == other"}},{"html_id":"[](index_or_key):self-instance-method","name":"[]","doc":"Assumes the underlying value is an `Array` or `Hash`\nand returns the element at the given *index_or_key*.\n\nRaises if the underlying value is not an `Array` nor a `Hash`.","summary":"<p>Assumes the underlying value is an <code><a href=\"../../Array.html\">Array</a></code> or <code><a href=\"../../Hash.html\">Hash</a></code> and returns the element at the given <em>index_or_key</em>.</p>","abstract":false,"args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""}],"args_string":"(index_or_key) : self","args_html":"(index_or_key) : <span class=\"k\">self</span>","location":{"filename":"src/log/metadata.cr","line_number":198,"url":null},"def":{"name":"[]","args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""}],"return_type":"self","visibility":"Public","body":"case object = @raw\nwhen Array\n  if index_or_key.is_a?(Int)\n    object[index_or_key]\n  else\n    raise(\"Expected int key for Array#[], not #{object.class}\")\n  end\nwhen Hash\n  object[index_or_key]\nelse\n  raise(\"Expected Array or Hash, not #{object.class}\")\nend"}},{"html_id":"[]?(index_or_key):self?-instance-method","name":"[]?","doc":"Assumes the underlying value is an `Array` or `Hash` and returns the element\nat the given *index_or_key*, or `nil` if out of bounds or the key is missing.\n\nRaises if the underlying value is not an `Array` nor a `Hash`.","summary":"<p>Assumes the underlying value is an <code><a href=\"../../Array.html\">Array</a></code> or <code><a href=\"../../Hash.html\">Hash</a></code> and returns the element at the given <em>index_or_key</em>, or <code>nil</code> if out of bounds or the key is missing.</p>","abstract":false,"args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""}],"args_string":"(index_or_key) : self?","args_html":"(index_or_key) : <span class=\"k\">self</span>?","location":{"filename":"src/log/metadata.cr","line_number":198,"url":null},"def":{"name":"[]?","args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""}],"return_type":"self | ::Nil","visibility":"Public","body":"case object = @raw\nwhen Array\n  if index_or_key.is_a?(Int)\n    object[index_or_key]?\n  else\n    nil\n  end\nwhen Hash\n  object[index_or_key]?\nelse\n  raise(\"Expected Array or Hash, not #{object.class}\")\nend"}},{"html_id":"as_a:Array(self)-instance-method","name":"as_a","doc":"Checks that the underlying value is `Array(self)`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Array.html\">Array</a>(self)</code>, and returns its value.</p>","abstract":false,"def":{"name":"as_a","return_type":"Array(self)","visibility":"Public","body":"@raw.as(Array(self))"}},{"html_id":"as_a?:Array(self)?-instance-method","name":"as_a?","doc":"Checks that the underlying value is `Array(self)`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Array.html\">Array</a>(self)</code>, and returns its value.</p>","abstract":false,"def":{"name":"as_a?","return_type":"Array(self) | ::Nil","visibility":"Public","body":"@raw.as?(Array(self))"}},{"html_id":"as_bool:Bool-instance-method","name":"as_bool","doc":"Checks that the underlying value is `Bool`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Bool.html\">Bool</a></code>, and returns its value.</p>","abstract":false,"def":{"name":"as_bool","return_type":"Bool","visibility":"Public","body":"@raw.as(Bool)"}},{"html_id":"as_bool?:Bool?-instance-method","name":"as_bool?","doc":"Checks that the underlying value is `Bool`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Bool.html\">Bool</a></code>, and returns its value.</p>","abstract":false,"def":{"name":"as_bool?","return_type":"Bool | ::Nil","visibility":"Public","body":"@raw.as?(Bool)"}},{"html_id":"as_f:Float32-instance-method","name":"as_f","doc":"Checks that the underlying value is `Float32`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Float32.html\">Float32</a></code>, and returns its value.</p>","abstract":false,"def":{"name":"as_f","return_type":"Float32","visibility":"Public","body":"@raw.as(Float32)"}},{"html_id":"as_f64:Float64-instance-method","name":"as_f64","doc":"Checks that the underlying value is `Float64`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Float64.html\">Float64</a></code>, and returns its value.</p>","abstract":false,"def":{"name":"as_f64","return_type":"Float64","visibility":"Public","body":"@raw.as(Float64)"}},{"html_id":"as_f64?:Float64?-instance-method","name":"as_f64?","doc":"Checks that the underlying value is `Float64`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Float64.html\">Float64</a></code>, and returns its value.</p>","abstract":false,"def":{"name":"as_f64?","return_type":"Float64 | ::Nil","visibility":"Public","body":"@raw.as?(Float64)"}},{"html_id":"as_f?:Float32?-instance-method","name":"as_f?","doc":"Checks that the underlying value is `Float32`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Float32.html\">Float32</a></code>, and returns its value.</p>","abstract":false,"def":{"name":"as_f?","return_type":"Float32 | ::Nil","visibility":"Public","body":"@raw.as?(Float32)"}},{"html_id":"as_h:Hash(String,self)-instance-method","name":"as_h","doc":"Checks that the underlying value is `Hash(String, self)`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Hash.html\">Hash</a>(<a href=\"../../String.html\">String</a>, self)</code>, and returns its value.</p>","abstract":false,"def":{"name":"as_h","return_type":"Hash(String, self)","visibility":"Public","body":"@raw.as(Hash(String, self))"}},{"html_id":"as_h?:Hash(String,self)?-instance-method","name":"as_h?","doc":"Checks that the underlying value is `Hash(String, self)`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Hash.html\">Hash</a>(<a href=\"../../String.html\">String</a>, self)</code>, and returns its value.</p>","abstract":false,"def":{"name":"as_h?","return_type":"Hash(String, self) | ::Nil","visibility":"Public","body":"@raw.as?(Hash(String, self))"}},{"html_id":"as_i:Int32-instance-method","name":"as_i","doc":"Checks that the underlying value is `Int32`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Int32.html\">Int32</a></code>, and returns its value.</p>","abstract":false,"def":{"name":"as_i","return_type":"Int32","visibility":"Public","body":"@raw.as(Int32)"}},{"html_id":"as_i64:Int64-instance-method","name":"as_i64","doc":"Checks that the underlying value is `Int64`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Int64.html\">Int64</a></code>, and returns its value.</p>","abstract":false,"def":{"name":"as_i64","return_type":"Int64","visibility":"Public","body":"@raw.as(Int64)"}},{"html_id":"as_i64?:Int64?-instance-method","name":"as_i64?","doc":"Checks that the underlying value is `Int64`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Int64.html\">Int64</a></code>, and returns its value.</p>","abstract":false,"def":{"name":"as_i64?","return_type":"Int64 | ::Nil","visibility":"Public","body":"@raw.as?(Int64)"}},{"html_id":"as_i?:Int32?-instance-method","name":"as_i?","doc":"Checks that the underlying value is `Int32`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Int32.html\">Int32</a></code>, and returns its value.</p>","abstract":false,"def":{"name":"as_i?","return_type":"Int32 | ::Nil","visibility":"Public","body":"@raw.as?(Int32)"}},{"html_id":"as_nil:Nil-instance-method","name":"as_nil","doc":"Checks that the underlying value is `Nil`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Nil.html\">Nil</a></code>, and returns its value.</p>","abstract":false,"def":{"name":"as_nil","return_type":"Nil","visibility":"Public","body":"@raw.as(Nil)"}},{"html_id":"as_s:String-instance-method","name":"as_s","doc":"Checks that the underlying value is `String`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../String.html\">String</a></code>, and returns its value.</p>","abstract":false,"def":{"name":"as_s","return_type":"String","visibility":"Public","body":"@raw.as(String)"}},{"html_id":"as_s?:String?-instance-method","name":"as_s?","doc":"Checks that the underlying value is `String`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../String.html\">String</a></code>, and returns its value.</p>","abstract":false,"def":{"name":"as_s?","return_type":"String | ::Nil","visibility":"Public","body":"@raw.as?(String)"}},{"html_id":"as_time:Time-instance-method","name":"as_time","doc":"Checks that the underlying value is `Time`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Time.html\">Time</a></code>, and returns its value.</p>","abstract":false,"def":{"name":"as_time","return_type":"Time","visibility":"Public","body":"@raw.as(Time)"}},{"html_id":"as_time?:Time?-instance-method","name":"as_time?","doc":"Checks that the underlying value is `Time`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../../Time.html\">Time</a></code>, and returns its value.</p>","abstract":false,"def":{"name":"as_time?","return_type":"Time | ::Nil","visibility":"Public","body":"@raw.as?(Time)"}},{"html_id":"clone-instance-method","name":"clone","doc":"Returns a new `Log::Metadata::Value` instance with the `raw` value `clone`ed.","summary":"<p>Returns a new <code><a href=\"../../Log/Metadata/Value.html\">Log::Metadata::Value</a></code> instance with the <code><a href=\"../../Log/Metadata/Value.html#raw%3AType-instance-method\">#raw</a></code> value <code><a href=\"../../Log/Metadata/Value.html#clone-instance-method\">#clone</a></code>ed.</p>","abstract":false,"location":{"filename":"src/log/metadata.cr","line_number":198,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new(raw.clone)"}},{"html_id":"dig(index_or_key,*subkeys):self-instance-method","name":"dig","doc":"Traverses the depth of a structure and returns the value, otherwise raises.","summary":"<p>Traverses the depth of a structure and returns the value, otherwise raises.</p>","abstract":false,"args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""},{"name":"subkeys","external_name":"subkeys","restriction":""}],"args_string":"(index_or_key, *subkeys) : self","args_html":"(index_or_key, *subkeys) : <span class=\"k\">self</span>","location":{"filename":"src/log/metadata.cr","line_number":198,"url":null},"def":{"name":"dig","args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""},{"name":"subkeys","external_name":"subkeys","restriction":""}],"splat_index":1,"return_type":"self","visibility":"Public","body":"self[index_or_key].dig(*subkeys)"}},{"html_id":"dig?(index_or_key,*subkeys):self?-instance-method","name":"dig?","doc":"Traverses the depth of a structure and returns the value.\nReturns `nil` if not found.","summary":"<p>Traverses the depth of a structure and returns the value.</p>","abstract":false,"args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""},{"name":"subkeys","external_name":"subkeys","restriction":""}],"args_string":"(index_or_key, *subkeys) : self?","args_html":"(index_or_key, *subkeys) : <span class=\"k\">self</span>?","location":{"filename":"src/log/metadata.cr","line_number":198,"url":null},"def":{"name":"dig?","args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""},{"name":"subkeys","external_name":"subkeys","restriction":""}],"splat_index":1,"return_type":"self | ::Nil","visibility":"Public","body":"self[index_or_key]?.try(&.dig?(*subkeys))"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a new `Log::Metadata::Value` instance with the `raw` value `dup`ed.","summary":"<p>Returns a new <code><a href=\"../../Log/Metadata/Value.html\">Log::Metadata::Value</a></code> instance with the <code><a href=\"../../Log/Metadata/Value.html#raw%3AType-instance-method\">#raw</a></code> value <code><a href=\"../../Log/Metadata/Value.html#dup-instance-method\">#dup</a></code>ed.</p>","abstract":false,"location":{"filename":"src/log/metadata.cr","line_number":198,"url":null},"def":{"name":"dup","visibility":"Public","body":"self.class.new(raw.dup)"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = raw.hash(hasher)\nhasher\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends this struct's name and instance variables names and values\nto the given IO.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np1.to_s    # \"Point(@x=1, @y=2)\"\np1.inspect # \"Point(@x=1, @y=2)\"\n```","summary":"<p>Appends this struct's name and instance variables names and values to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../../IO.html\">IO</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/log/metadata.cr","line_number":198,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"@raw.inspect(io)"}},{"html_id":"raw:Type-instance-method","name":"raw","doc":"Returns the raw underlying value, a `Type`.","summary":"<p>Returns the raw underlying value, a <code><a href=\"../../Log/Metadata/Value/Type.html\">Type</a></code>.</p>","abstract":false,"def":{"name":"raw","return_type":"Type","visibility":"Public","body":"@raw"}},{"html_id":"size:Int-instance-method","name":"size","doc":"Assumes the underlying value is an `Array` or `Hash` and returns its size.\n\nRaises if the underlying value is not an `Array` or `Hash`.","summary":"<p>Assumes the underlying value is an <code><a href=\"../../Array.html\">Array</a></code> or <code><a href=\"../../Hash.html\">Hash</a></code> and returns its size.</p>","abstract":false,"location":{"filename":"src/log/metadata.cr","line_number":198,"url":null},"def":{"name":"size","return_type":"Int","visibility":"Public","body":"case object = @raw\nwhen Array\n  object.size\nwhen Hash\n  object.size\nelse\n  raise(\"Expected Array or Hash for #size, not #{object.class}\")\nend"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Same as `#inspect(io)`.","summary":"<p>Same as <code><a href=\"../../Log/Metadata/Value.html#inspect%28io%3AIO%29%3ANil-instance-method\">#inspect(io)</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../../IO.html\">IO</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/log/metadata.cr","line_number":198,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"@raw.to_s(io)"}}],"types":[{"html_id":"Crystal/Log/Metadata/Value/Type","path":"Log/Metadata/Value/Type.html","kind":"alias","full_name":"Log::Metadata::Value::Type","name":"Type","abstract":false,"locations":[{"filename":"src/log/metadata.cr","line_number":198,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(Array(Log::Metadata::Value) | Bool | Float32 | Float64 | Hash(String, Log::Metadata::Value) | Int32 | Int64 | String | Time | Nil)","aliased_html":"<a href=\"../../../Array.html\">Array</a>(<a href=\"../../../Log/Metadata/Value.html\">Log::Metadata::Value</a>) | <a href=\"../../../Bool.html\">Bool</a> | <a href=\"../../../Float32.html\">Float32</a> | <a href=\"../../../Float64.html\">Float64</a> | <a href=\"../../../Hash.html\">Hash</a>(<a href=\"../../../String.html\">String</a>, <a href=\"../../../Log/Metadata/Value.html\">Log::Metadata::Value</a>) | <a href=\"../../../Int32.html\">Int32</a> | <a href=\"../../../Int64.html\">Int64</a> | <a href=\"../../../String.html\">String</a> | <a href=\"../../../Time.html\">Time</a> | <a href=\"../../../Nil.html\">Nil</a>","const":false,"namespace":{"html_id":"Crystal/Log/Metadata/Value","kind":"struct","full_name":"Log::Metadata::Value","name":"Value"},"doc":"All possible `Log::Metadata::Value` types.","summary":"<p>All possible <code><a href=\"../../../Log/Metadata/Value.html\">Log::Metadata::Value</a></code> types.</p>"}]}]},{"html_id":"Crystal/Log/Severity","path":"Log/Severity.html","kind":"enum","full_name":"Log::Severity","name":"Severity","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/entry.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Trace","name":"Trace","value":"0","doc":"Used for tracing the code and trying to find one part of a function specifically.","summary":"<p>Used for tracing the code and trying to find one part of a function specifically.</p>"},{"id":"Debug","name":"Debug","value":"1","doc":"Used for information that is diagnostically helpful to people more than just developers (IT, sysadmins, etc.).","summary":"<p>Used for information that is diagnostically helpful to people more than just developers (IT, sysadmins, etc.).</p>"},{"id":"Info","name":"Info","value":"2","doc":"Used for generally useful information to log.","summary":"<p>Used for generally useful information to log.</p>"},{"id":"Notice","name":"Notice","value":"3","doc":"Used for normal but significant conditions.","summary":"<p>Used for normal but significant conditions.</p>"},{"id":"Warn","name":"Warn","value":"4","doc":"Used for conditions that can potentially cause application oddities, but that can be automatically recovered.","summary":"<p>Used for conditions that can potentially cause application oddities, but that can be automatically recovered.</p>"},{"id":"Error","name":"Error","value":"5","doc":"Used for any error that is fatal to the operation, but not to the service or application.","summary":"<p>Used for any error that is fatal to the operation, but not to the service or application.</p>"},{"id":"Fatal","name":"Fatal","value":"6","doc":"Used for any error that is forcing a shutdown of the service or application","summary":"<p>Used for any error that is forcing a shutdown of the service or application</p>"},{"id":"None","name":"None","value":"7","doc":"Used only for severity level filter.","summary":"<p>Used only for severity level filter.</p>"}],"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"A logging severity level.","summary":"<p>A logging severity level.</p>","instance_methods":[{"html_id":"debug?-instance-method","name":"debug?","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":6,"url":null},"def":{"name":"debug?","visibility":"Public","body":"self == Debug"}},{"html_id":"error?-instance-method","name":"error?","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":14,"url":null},"def":{"name":"error?","visibility":"Public","body":"self == Error"}},{"html_id":"fatal?-instance-method","name":"fatal?","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":16,"url":null},"def":{"name":"fatal?","visibility":"Public","body":"self == Fatal"}},{"html_id":"info?-instance-method","name":"info?","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":8,"url":null},"def":{"name":"info?","visibility":"Public","body":"self == Info"}},{"html_id":"label:String-instance-method","name":"label","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":20,"url":null},"def":{"name":"label","return_type":"String","visibility":"Public","body":"case self\nin Trace\n  \"TRACE\"\nin Debug\n  \"DEBUG\"\nin Info\n  \"INFO\"\nin Notice\n  \"NOTICE\"\nin Warn\n  \"WARN\"\nin Error\n  \"ERROR\"\nin Fatal\n  \"FATAL\"\nin None\n  \"NONE\"\nend"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":18,"url":null},"def":{"name":"none?","visibility":"Public","body":"self == None"}},{"html_id":"notice?-instance-method","name":"notice?","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":10,"url":null},"def":{"name":"notice?","visibility":"Public","body":"self == Notice"}},{"html_id":"trace?-instance-method","name":"trace?","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":4,"url":null},"def":{"name":"trace?","visibility":"Public","body":"self == Trace"}},{"html_id":"warn?-instance-method","name":"warn?","abstract":false,"location":{"filename":"src/log/entry.cr","line_number":12,"url":null},"def":{"name":"warn?","visibility":"Public","body":"self == Warn"}}]},{"html_id":"Crystal/Log/ShortFormat","path":"Log/ShortFormat.html","kind":"struct","full_name":"Log::ShortFormat","name":"ShortFormat","abstract":false,"superclass":{"html_id":"Crystal/Log/StaticFormatter","kind":"struct","full_name":"Log::StaticFormatter","name":"StaticFormatter"},"ancestors":[{"html_id":"Crystal/Log/StaticFormatter","kind":"struct","full_name":"Log::StaticFormatter","name":"StaticFormatter"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/format.cr","line_number":201,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"instance_methods":[{"html_id":"run-instance-method","name":"run","doc":"Subclasses must implement this method to define the output pattern","summary":"<p>Subclasses must implement this method to define the output pattern</p>","abstract":false,"location":{"filename":"src/log/format.cr","line_number":201,"url":null},"def":{"name":"run","visibility":"Public","body":"timestamp\nstring(\" \")\nseverity\nstring(\" - \")\nsource(after: \": \")\nmessage\ndata(before: \" -- \")\ncontext(before: \" -- \")\nexception\n"}}]},{"html_id":"Crystal/Log/StaticFormatter","path":"Log/StaticFormatter.html","kind":"struct","full_name":"Log::StaticFormatter","name":"StaticFormatter","abstract":true,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/format.cr","line_number":60,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"extended_modules":[{"html_id":"Crystal/Log/Formatter","kind":"module","full_name":"Log::Formatter","name":"Formatter"}],"subclasses":[{"html_id":"Crystal/Log/ShortFormat","kind":"struct","full_name":"Log::ShortFormat","name":"ShortFormat"}],"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"Base implementation of `Log::Formatter` to convert\nlog entries into text representation\n\nThis can be used to create efficient formatters:\n```\nrequire \"log\"\n\nstruct MyFormat < Log::StaticFormatter\n  def run\n    string \"- \"\n    severity\n    string \": \"\n    message\n  end\nend\n\nLog.setup(:info, Log::IOBackend.new(formatter: MyFormat))\nLog.info { \"Hello\" }    # => -   INFO: Hello\nLog.error { \"Oh, no!\" } # => -  ERROR: Oh, no!\n```\n\nThere is also a helper macro to generate these formatters. Here's\nan example that generates the same result:\n```\nLog.define_formatter MyFormat, \"- #{severity}: #{message}\"\n```","summary":"<p>Base implementation of <code><a href=\"../Log/Formatter.html\">Log::Formatter</a></code> to convert log entries into text representation</p>","class_methods":[{"html_id":"format(entry,io):Nil-class-method","name":"format","doc":"Write the `Log::Entry` to the `IO` using this pattern","summary":"<p>Write the <code><a href=\"../Log/Entry.html\">Log::Entry</a></code> to the <code><a href=\"../IO.html\">IO</a></code> using this pattern</p>","abstract":false,"args":[{"name":"entry","external_name":"entry","restriction":""},{"name":"io","external_name":"io","restriction":""}],"args_string":"(entry, io) : Nil","args_html":"(entry, io) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/log/format.cr","line_number":152,"url":null},"def":{"name":"format","args":[{"name":"entry","external_name":"entry","restriction":""},{"name":"io","external_name":"io","restriction":""}],"return_type":"Nil","visibility":"Public","body":"(new(entry, io)).run"}}],"constructors":[{"html_id":"new(entry:Log::Entry,io:IO)-class-method","name":"new","abstract":false,"args":[{"name":"entry","external_name":"entry","restriction":"Log::Entry"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(entry : Log::Entry, io : IO)","args_html":"(entry : <a href=\"../Log/Entry.html\">Log::Entry</a>, io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/log/format.cr","line_number":63,"url":null},"def":{"name":"new","args":[{"name":"entry","external_name":"entry","restriction":"Log::Entry"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"_ = allocate\n_.initialize(entry, io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"context(*,before=nil,after=nil)-instance-method","name":"context","doc":"Write all the values from the context\n\nIt doesn't write any output if the context is empty.\nParameters `before` and `after` can be provided to be written around\nthe value.","summary":"<p>Write all the values from the context</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"before","default_value":"nil","external_name":"before","restriction":""},{"name":"after","default_value":"nil","external_name":"after","restriction":""}],"args_string":"(*, before = nil, after = nil)","args_html":"(*, before = <span class=\"n\">nil</span>, after = <span class=\"n\">nil</span>)","location":{"filename":"src/log/format.cr","line_number":121,"url":null},"def":{"name":"context","args":[{"name":"","external_name":"","restriction":""},{"name":"before","default_value":"nil","external_name":"before","restriction":""},{"name":"after","default_value":"nil","external_name":"after","restriction":""}],"splat_index":0,"visibility":"Public","body":"if @entry.context.empty?\nelse\n  ((@io << before) << @entry.context) << after\nend"}},{"html_id":"data(*,before=nil,after=nil):Nil-instance-method","name":"data","doc":"Write all the values from the entry data\n\nIt doesn't write any output if the entry data is empty.\nParameters `before` and `after` can be provided to be written around\nthe value.","summary":"<p>Write all the values from the entry data</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"before","default_value":"nil","external_name":"before","restriction":""},{"name":"after","default_value":"nil","external_name":"after","restriction":""}],"args_string":"(*, before = nil, after = nil) : Nil","args_html":"(*, before = <span class=\"n\">nil</span>, after = <span class=\"n\">nil</span>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/log/format.cr","line_number":110,"url":null},"def":{"name":"data","args":[{"name":"","external_name":"","restriction":""},{"name":"before","default_value":"nil","external_name":"before","restriction":""},{"name":"after","default_value":"nil","external_name":"after","restriction":""}],"splat_index":0,"return_type":"Nil","visibility":"Public","body":"if @entry.data.empty?\nelse\n  ((@io << before) << @entry.data) << after\nend"}},{"html_id":"exception(*,before='\\n',after=nil):Nil-instance-method","name":"exception","doc":"Write the exception, including backtrace\n\nIt doesn't write any output unless there is an exception in the entry.\nParameters `before` and `after` can be provided to be written around\nthe value. `before` defaults to `'\\n'` so the exception is written\non a separate line","summary":"<p>Write the exception, including backtrace</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"before","default_value":"'\\n'","external_name":"before","restriction":""},{"name":"after","default_value":"nil","external_name":"after","restriction":""}],"args_string":"(*, before = '\\n', after = nil) : Nil","args_html":"(*, before = <span class=\"s\">&#39;\\n&#39;</span>, after = <span class=\"n\">nil</span>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/log/format.cr","line_number":133,"url":null},"def":{"name":"exception","args":[{"name":"","external_name":"","restriction":""},{"name":"before","default_value":"'\\n'","external_name":"before","restriction":""},{"name":"after","default_value":"nil","external_name":"after","restriction":""}],"splat_index":0,"return_type":"Nil","visibility":"Public","body":"if ex = @entry.exception\n  @io << before\n  ex.inspect_with_backtrace(@io)\n  @io << after\nend"}},{"html_id":"message:Nil-instance-method","name":"message","doc":"Write the message of the entry","summary":"<p>Write the message of the entry</p>","abstract":false,"location":{"filename":"src/log/format.cr","line_number":77,"url":null},"def":{"name":"message","return_type":"Nil","visibility":"Public","body":"@io << @entry.message"}},{"html_id":"pid(*,before='#',after=nil)-instance-method","name":"pid","doc":"Write the current process identifier","summary":"<p>Write the current process identifier</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"before","default_value":"'#'","external_name":"before","restriction":""},{"name":"after","default_value":"nil","external_name":"after","restriction":""}],"args_string":"(*, before = '#', after = nil)","args_html":"(*, before = <span class=\"s\">&#39;#&#39;</span>, after = <span class=\"n\">nil</span>)","location":{"filename":"src/log/format.cr","line_number":147,"url":null},"def":{"name":"pid","args":[{"name":"","external_name":"","restriction":""},{"name":"before","default_value":"'#'","external_name":"before","restriction":""},{"name":"after","default_value":"nil","external_name":"after","restriction":""}],"splat_index":0,"visibility":"Public","body":"((@io << before) << Log.pid) << after"}},{"html_id":"progname:Nil-instance-method","name":"progname","doc":"Write the program name. See `Log.progname`.","summary":"<p>Write the program name.</p>","abstract":false,"location":{"filename":"src/log/format.cr","line_number":142,"url":null},"def":{"name":"progname","return_type":"Nil","visibility":"Public","body":"@io << Log.progname"}},{"html_id":"run-instance-method","name":"run","doc":"Subclasses must implement this method to define the output pattern","summary":"<p>Subclasses must implement this method to define the output pattern</p>","abstract":true,"location":{"filename":"src/log/format.cr","line_number":157,"url":null},"def":{"name":"run","visibility":"Public","body":""}},{"html_id":"severity:Nil-instance-method","name":"severity","doc":"Write the severity\n\nThis writes the severity in uppercase and left padded\nwith enough space so all the severities fit","summary":"<p>Write the severity</p>","abstract":false,"location":{"filename":"src/log/format.cr","line_number":85,"url":null},"def":{"name":"severity","return_type":"Nil","visibility":"Public","body":"@entry.severity.label.rjust(@io, 6)"}},{"html_id":"source(*,before=nil,after=nil)-instance-method","name":"source","doc":"Write the source for non-root entries\n\nIt doesn't write any output for entries generated from the root logger.\nParameters `before` and `after` can be provided to be written around\nthe value.\n```\nLog.define_formatter TestFormatter, \"#{source(before: '[', after: \"] \")}#{message}\"\nLog.setup(:info, Log::IOBackend.new(formatter: TestFormatter))\nLog.for(\"foo.bar\").info { \"Hello\" } # => - [foo.bar] Hello\n```","summary":"<p>Write the source for non-root entries</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"before","default_value":"nil","external_name":"before","restriction":""},{"name":"after","default_value":"nil","external_name":"after","restriction":""}],"args_string":"(*, before = nil, after = nil)","args_html":"(*, before = <span class=\"n\">nil</span>, after = <span class=\"n\">nil</span>)","location":{"filename":"src/log/format.cr","line_number":99,"url":null},"def":{"name":"source","args":[{"name":"","external_name":"","restriction":""},{"name":"before","default_value":"nil","external_name":"before","restriction":""},{"name":"after","default_value":"nil","external_name":"after","restriction":""}],"splat_index":0,"visibility":"Public","body":"if @entry.source.size > 0\n  ((@io << before) << @entry.source) << after\nend"}},{"html_id":"string(str):Nil-instance-method","name":"string","doc":"Write a fixed string","summary":"<p>Write a fixed string</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":""}],"args_string":"(str) : Nil","args_html":"(str) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/log/format.cr","line_number":72,"url":null},"def":{"name":"string","args":[{"name":"str","external_name":"str","restriction":""}],"return_type":"Nil","visibility":"Public","body":"@io << str"}},{"html_id":"timestamp:Nil-instance-method","name":"timestamp","doc":"Write the entry timestamp in RFC3339 format","summary":"<p>Write the entry timestamp in RFC3339 format</p>","abstract":false,"location":{"filename":"src/log/format.cr","line_number":67,"url":null},"def":{"name":"timestamp","return_type":"Nil","visibility":"Public","body":"@entry.timestamp.to_rfc3339(@io, fraction_digits: 6)"}}]},{"html_id":"Crystal/Log/SyncDispatcher","path":"Log/SyncDispatcher.html","kind":"class","full_name":"Log::SyncDispatcher","name":"SyncDispatcher","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Log/Dispatcher","kind":"module","full_name":"Log::Dispatcher","name":"Dispatcher"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/log/dispatch.cr","line_number":82,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Log/Dispatcher","kind":"module","full_name":"Log::Dispatcher","name":"Dispatcher"}],"namespace":{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},"doc":"Deliver log entries directly. It uses a mutex to guarantee\none entry is delivered at a time.","summary":"<p>Deliver log entries directly.</p>","constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/log/dispatch.cr","line_number":85,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"dispatch(entry:Entry,backend:Backend)-instance-method","name":"dispatch","doc":"Dispatch a log entry to the specified backend","summary":"<p>Dispatch a log entry to the specified backend</p>","abstract":false,"args":[{"name":"entry","external_name":"entry","restriction":"Entry"},{"name":"backend","external_name":"backend","restriction":"Backend"}],"args_string":"(entry : Entry, backend : Backend)","args_html":"(entry : <a href=\"../Log/Entry.html\">Entry</a>, backend : <a href=\"../Log/Backend.html\">Backend</a>)","location":{"filename":"src/log/dispatch.cr","line_number":89,"url":null},"def":{"name":"dispatch","args":[{"name":"entry","external_name":"entry","restriction":"Entry"},{"name":"backend","external_name":"backend","restriction":"Backend"}],"visibility":"Public","body":"@mutex.synchronize do\n  backend.write(entry)\nend"}}]}]},{"html_id":"Crystal/Math","path":"Math.html","kind":"module","full_name":"Math","name":"Math","abstract":false,"locations":[{"filename":"src/big/big_float.cr","line_number":395,"url":null},{"filename":"src/big/big_int.cr","line_number":803,"url":null},{"filename":"src/big/big_rational.cr","line_number":358,"url":null},{"filename":"src/complex.cr","line_number":306,"url":null},{"filename":"src/math/math.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"E","name":"E","value":"LibM.exp_f64(1.0)","doc":"Euler's number (e).","summary":"<p>Euler's number (e).</p>"},{"id":"LOG10","name":"LOG10","value":"LibM.log_f64(10.0)"},{"id":"LOG2","name":"LOG2","value":"LibM.log_f64(2.0)"},{"id":"PI","name":"PI","value":"3.14159265358979323846","doc":"Archimedes' constant (π).","summary":"<p>Archimedes' constant (π).</p>"},{"id":"TAU","name":"TAU","value":"6.283185307179586476925","doc":"The full circle constant (τ), equal to 2π.","summary":"<p>The full circle constant (τ), equal to 2π.</p>"}],"extended_modules":[{"html_id":"Crystal/Math","kind":"module","full_name":"Math","name":"Math"}],"instance_methods":[{"html_id":"acos(value:Float32):Float32-instance-method","name":"acos","doc":"Calculates the arc cosine of *value*.","summary":"<p>Calculates the arc cosine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":76,"url":null},"def":{"name":"acos","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.acos_f32(value)"}},{"html_id":"acos(value:Float64):Float64-instance-method","name":"acos","doc":"Calculates the arc cosine of *value*.","summary":"<p>Calculates the arc cosine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":81,"url":null},"def":{"name":"acos","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.acos_f64(value)"}},{"html_id":"acos(value)-instance-method","name":"acos","doc":"Calculates the arc cosine of *value*.","summary":"<p>Calculates the arc cosine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":86,"url":null},"def":{"name":"acos","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"acos(value.to_f)"}},{"html_id":"acosh(value:Float32):Float32-instance-method","name":"acosh","doc":"Calculates the inverse hyperbolic cosine of *value*.","summary":"<p>Calculates the inverse hyperbolic cosine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":181,"url":null},"def":{"name":"acosh","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.acosh_f32(value)"}},{"html_id":"acosh(value:Float64):Float64-instance-method","name":"acosh","doc":"Calculates the inverse hyperbolic cosine of *value*.","summary":"<p>Calculates the inverse hyperbolic cosine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":186,"url":null},"def":{"name":"acosh","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.acosh_f64(value)"}},{"html_id":"acosh(value)-instance-method","name":"acosh","doc":"Calculates the inverse hyperbolic cosine of *value*.","summary":"<p>Calculates the inverse hyperbolic cosine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":191,"url":null},"def":{"name":"acosh","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"acosh(value.to_f)"}},{"html_id":"asin(value:Float32):Float32-instance-method","name":"asin","doc":"Calculates the arc sine of *value*.","summary":"<p>Calculates the arc sine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":61,"url":null},"def":{"name":"asin","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.asin_f32(value)"}},{"html_id":"asin(value:Float64):Float64-instance-method","name":"asin","doc":"Calculates the arc sine of *value*.","summary":"<p>Calculates the arc sine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":66,"url":null},"def":{"name":"asin","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.asin_f64(value)"}},{"html_id":"asin(value)-instance-method","name":"asin","doc":"Calculates the arc sine of *value*.","summary":"<p>Calculates the arc sine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":71,"url":null},"def":{"name":"asin","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"asin(value.to_f)"}},{"html_id":"asinh(value:Float32):Float32-instance-method","name":"asinh","doc":"Calculates the inverse hyperbolic sine of *value*.","summary":"<p>Calculates the inverse hyperbolic sine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":166,"url":null},"def":{"name":"asinh","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.asinh_f32(value)"}},{"html_id":"asinh(value:Float64):Float64-instance-method","name":"asinh","doc":"Calculates the inverse hyperbolic sine of *value*.","summary":"<p>Calculates the inverse hyperbolic sine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":171,"url":null},"def":{"name":"asinh","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.asinh_f64(value)"}},{"html_id":"asinh(value)-instance-method","name":"asinh","doc":"Calculates the inverse hyperbolic sine of *value*.","summary":"<p>Calculates the inverse hyperbolic sine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":176,"url":null},"def":{"name":"asinh","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"asinh(value.to_f)"}},{"html_id":"atan(value:Float32):Float32-instance-method","name":"atan","doc":"Calculates the arc tangent of *value*.","summary":"<p>Calculates the arc tangent of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":91,"url":null},"def":{"name":"atan","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.atan_f32(value)"}},{"html_id":"atan(value:Float64):Float64-instance-method","name":"atan","doc":"Calculates the arc tangent of *value*.","summary":"<p>Calculates the arc tangent of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":96,"url":null},"def":{"name":"atan","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.atan_f64(value)"}},{"html_id":"atan(value)-instance-method","name":"atan","doc":"Calculates the arc tangent of *value*.","summary":"<p>Calculates the arc tangent of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":101,"url":null},"def":{"name":"atan","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"atan(value.to_f)"}},{"html_id":"atan2(y:Float32,x:Float32):Float32-instance-method","name":"atan2","doc":"Calculates the two-argument arc tangent of the ray from (0, 0) to (*x*, *y*).","summary":"<p>Calculates the two-argument arc tangent of the ray from (0, 0) to (<em>x</em>, <em>y</em>).</p>","abstract":false,"args":[{"name":"y","external_name":"y","restriction":"Float32"},{"name":"x","external_name":"x","restriction":"Float32"}],"args_string":"(y : Float32, x : Float32) : Float32","args_html":"(y : <a href=\"Float32.html\">Float32</a>, x : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":106,"url":null},"def":{"name":"atan2","args":[{"name":"y","external_name":"y","restriction":"Float32"},{"name":"x","external_name":"x","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.atan2_f32(y, x)"}},{"html_id":"atan2(y:Float64,x:Float64):Float64-instance-method","name":"atan2","doc":"Calculates the two-argument arc tangent of the ray from (0, 0) to (*x*, *y*).","summary":"<p>Calculates the two-argument arc tangent of the ray from (0, 0) to (<em>x</em>, <em>y</em>).</p>","abstract":false,"args":[{"name":"y","external_name":"y","restriction":"Float64"},{"name":"x","external_name":"x","restriction":"Float64"}],"args_string":"(y : Float64, x : Float64) : Float64","args_html":"(y : <a href=\"Float64.html\">Float64</a>, x : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":111,"url":null},"def":{"name":"atan2","args":[{"name":"y","external_name":"y","restriction":"Float64"},{"name":"x","external_name":"x","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.atan2_f64(y, x)"}},{"html_id":"atan2(y,x):Float64-instance-method","name":"atan2","doc":"Calculates the two-argument arc tangent of the ray from (0, 0) to (*x*, *y*).","summary":"<p>Calculates the two-argument arc tangent of the ray from (0, 0) to (<em>x</em>, <em>y</em>).</p>","abstract":false,"args":[{"name":"y","external_name":"y","restriction":""},{"name":"x","external_name":"x","restriction":""}],"args_string":"(y, x) : Float64","args_html":"(y, x) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":116,"url":null},"def":{"name":"atan2","args":[{"name":"y","external_name":"y","restriction":""},{"name":"x","external_name":"x","restriction":""}],"return_type":"Float64","visibility":"Public","body":"atan2(y.to_f, x.to_f)"}},{"html_id":"atanh(value:Float32):Float32-instance-method","name":"atanh","doc":"Calculates the inverse hyperbolic tangent of *value*.","summary":"<p>Calculates the inverse hyperbolic tangent of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":196,"url":null},"def":{"name":"atanh","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.atanh_f32(value)"}},{"html_id":"atanh(value:Float64):Float64-instance-method","name":"atanh","doc":"Calculates the inverse hyperbolic tangent of *value*.","summary":"<p>Calculates the inverse hyperbolic tangent of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":201,"url":null},"def":{"name":"atanh","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.atanh_f64(value)"}},{"html_id":"atanh(value)-instance-method","name":"atanh","doc":"Calculates the inverse hyperbolic tangent of *value*.","summary":"<p>Calculates the inverse hyperbolic tangent of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":206,"url":null},"def":{"name":"atanh","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"atanh(value.to_f)"}},{"html_id":"besselj(order:Int32,value:Float32)-instance-method","name":"besselj","doc":"Calculates the cylindrical Bessel function of the first kind of *value* for the given *order*.","summary":"<p>Calculates the cylindrical Bessel function of the first kind of <em>value</em> for the given <em>order</em>.</p>","abstract":false,"args":[{"name":"order","external_name":"order","restriction":"Int32"},{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(order : Int32, value : Float32)","args_html":"(order : <a href=\"Int32.html\">Int32</a>, value : <a href=\"Float32.html\">Float32</a>)","location":{"filename":"src/math/math.cr","line_number":445,"url":null},"def":{"name":"besselj","args":[{"name":"order","external_name":"order","restriction":"Int32"},{"name":"value","external_name":"value","restriction":"Float32"}],"visibility":"Public","body":"{% if (flag?(:darwin)) || (flag?(:win32)) %}\n      LibM.besselj_f64(order, value).to_f32\n    {% else %}\n      LibM.besselj_f32(order, value)\n    {% end %}"}},{"html_id":"besselj(order:Int32,value:Float64):Float64-instance-method","name":"besselj","doc":"Calculates the cylindrical Bessel function of the first kind of *value* for the given *order*.","summary":"<p>Calculates the cylindrical Bessel function of the first kind of <em>value</em> for the given <em>order</em>.</p>","abstract":false,"args":[{"name":"order","external_name":"order","restriction":"Int32"},{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(order : Int32, value : Float64) : Float64","args_html":"(order : <a href=\"Int32.html\">Int32</a>, value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":454,"url":null},"def":{"name":"besselj","args":[{"name":"order","external_name":"order","restriction":"Int32"},{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.besselj_f64(order, value)"}},{"html_id":"besselj(order,value)-instance-method","name":"besselj","doc":"Calculates the cylindrical Bessel function of the first kind of *value* for the given *order*.","summary":"<p>Calculates the cylindrical Bessel function of the first kind of <em>value</em> for the given <em>order</em>.</p>","abstract":false,"args":[{"name":"order","external_name":"order","restriction":""},{"name":"value","external_name":"value","restriction":""}],"args_string":"(order, value)","args_html":"(order, value)","location":{"filename":"src/math/math.cr","line_number":459,"url":null},"def":{"name":"besselj","args":[{"name":"order","external_name":"order","restriction":""},{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"besselj(order.to_i32, value.to_f)"}},{"html_id":"besselj0(value:Float32)-instance-method","name":"besselj0","doc":"Calculates the cylindrical Bessel function of the first kind of *value* for order 0.","summary":"<p>Calculates the cylindrical Bessel function of the first kind of <em>value</em> for order 0.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","args_html":"(value : <a href=\"Float32.html\">Float32</a>)","location":{"filename":"src/math/math.cr","line_number":464,"url":null},"def":{"name":"besselj0","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"visibility":"Public","body":"{% if (flag?(:darwin)) || (flag?(:win32)) %}\n      LibM.besselj0_f64(value).to_f32\n    {% else %}\n      LibM.besselj0_f32(value)\n    {% end %}"}},{"html_id":"besselj0(value:Float64):Float64-instance-method","name":"besselj0","doc":"Calculates the cylindrical Bessel function of the first kind of *value* for order 0.","summary":"<p>Calculates the cylindrical Bessel function of the first kind of <em>value</em> for order 0.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":473,"url":null},"def":{"name":"besselj0","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.besselj0_f64(value)"}},{"html_id":"besselj0(value)-instance-method","name":"besselj0","doc":"Calculates the cylindrical Bessel function of the first kind of *value* for order 0.","summary":"<p>Calculates the cylindrical Bessel function of the first kind of <em>value</em> for order 0.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":478,"url":null},"def":{"name":"besselj0","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"besselj0(value.to_f)"}},{"html_id":"besselj1(value:Float32)-instance-method","name":"besselj1","doc":"Calculates the cylindrical Bessel function of the first kind of *value* for order 1.","summary":"<p>Calculates the cylindrical Bessel function of the first kind of <em>value</em> for order 1.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","args_html":"(value : <a href=\"Float32.html\">Float32</a>)","location":{"filename":"src/math/math.cr","line_number":483,"url":null},"def":{"name":"besselj1","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"visibility":"Public","body":"{% if (flag?(:darwin)) || (flag?(:win32)) %}\n      LibM.besselj1_f64(value).to_f32\n    {% else %}\n      LibM.besselj1_f32(value)\n    {% end %}"}},{"html_id":"besselj1(value:Float64):Float64-instance-method","name":"besselj1","doc":"Calculates the cylindrical Bessel function of the first kind of *value* for order 1.","summary":"<p>Calculates the cylindrical Bessel function of the first kind of <em>value</em> for order 1.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":492,"url":null},"def":{"name":"besselj1","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.besselj1_f64(value)"}},{"html_id":"besselj1(value)-instance-method","name":"besselj1","doc":"Calculates the cylindrical Bessel function of the first kind of *value* for order 1.","summary":"<p>Calculates the cylindrical Bessel function of the first kind of <em>value</em> for order 1.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":497,"url":null},"def":{"name":"besselj1","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"besselj1(value.to_f)"}},{"html_id":"bessely(order:Int32,value:Float32)-instance-method","name":"bessely","doc":"Calculates the cylindrical Bessel function of the second kind of *value* for the given *order*.","summary":"<p>Calculates the cylindrical Bessel function of the second kind of <em>value</em> for the given <em>order</em>.</p>","abstract":false,"args":[{"name":"order","external_name":"order","restriction":"Int32"},{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(order : Int32, value : Float32)","args_html":"(order : <a href=\"Int32.html\">Int32</a>, value : <a href=\"Float32.html\">Float32</a>)","location":{"filename":"src/math/math.cr","line_number":502,"url":null},"def":{"name":"bessely","args":[{"name":"order","external_name":"order","restriction":"Int32"},{"name":"value","external_name":"value","restriction":"Float32"}],"visibility":"Public","body":"{% if (flag?(:darwin)) || (flag?(:win32)) %}\n      LibM.bessely_f64(order, value).to_f32\n    {% else %}\n      LibM.bessely_f32(order, value)\n    {% end %}"}},{"html_id":"bessely(order:Int32,value:Float64):Float64-instance-method","name":"bessely","doc":"Calculates the cylindrical Bessel function of the second kind of *value* for the given *order*.","summary":"<p>Calculates the cylindrical Bessel function of the second kind of <em>value</em> for the given <em>order</em>.</p>","abstract":false,"args":[{"name":"order","external_name":"order","restriction":"Int32"},{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(order : Int32, value : Float64) : Float64","args_html":"(order : <a href=\"Int32.html\">Int32</a>, value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":511,"url":null},"def":{"name":"bessely","args":[{"name":"order","external_name":"order","restriction":"Int32"},{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.bessely_f64(order, value)"}},{"html_id":"bessely(order,value)-instance-method","name":"bessely","doc":"Calculates the cylindrical Bessel function of the second kind of *value* for the given *order*.","summary":"<p>Calculates the cylindrical Bessel function of the second kind of <em>value</em> for the given <em>order</em>.</p>","abstract":false,"args":[{"name":"order","external_name":"order","restriction":""},{"name":"value","external_name":"value","restriction":""}],"args_string":"(order, value)","args_html":"(order, value)","location":{"filename":"src/math/math.cr","line_number":516,"url":null},"def":{"name":"bessely","args":[{"name":"order","external_name":"order","restriction":""},{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"bessely(order.to_i32, value.to_f)"}},{"html_id":"bessely0(value:Float32)-instance-method","name":"bessely0","doc":"Calculates the cylindrical Bessel function of the second kind of *value* for order 0.","summary":"<p>Calculates the cylindrical Bessel function of the second kind of <em>value</em> for order 0.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","args_html":"(value : <a href=\"Float32.html\">Float32</a>)","location":{"filename":"src/math/math.cr","line_number":521,"url":null},"def":{"name":"bessely0","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"visibility":"Public","body":"{% if (flag?(:darwin)) || (flag?(:win32)) %}\n      LibM.bessely0_f64(value).to_f32\n    {% else %}\n      LibM.bessely0_f32(value)\n    {% end %}"}},{"html_id":"bessely0(value:Float64):Float64-instance-method","name":"bessely0","doc":"Calculates the cylindrical Bessel function of the second kind of *value* for order 0.","summary":"<p>Calculates the cylindrical Bessel function of the second kind of <em>value</em> for order 0.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":530,"url":null},"def":{"name":"bessely0","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.bessely0_f64(value)"}},{"html_id":"bessely0(value)-instance-method","name":"bessely0","doc":"Calculates the cylindrical Bessel function of the second kind of *value* for order 0.","summary":"<p>Calculates the cylindrical Bessel function of the second kind of <em>value</em> for order 0.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":535,"url":null},"def":{"name":"bessely0","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"bessely0(value.to_f)"}},{"html_id":"bessely1(value:Float32)-instance-method","name":"bessely1","doc":"Calculates the cylindrical Bessel function of the second kind of *value* for order 1.","summary":"<p>Calculates the cylindrical Bessel function of the second kind of <em>value</em> for order 1.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","args_html":"(value : <a href=\"Float32.html\">Float32</a>)","location":{"filename":"src/math/math.cr","line_number":540,"url":null},"def":{"name":"bessely1","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"visibility":"Public","body":"{% if (flag?(:darwin)) || (flag?(:win32)) %}\n      LibM.bessely1_f64(value).to_f32\n    {% else %}\n      LibM.bessely1_f32(value)\n    {% end %}"}},{"html_id":"bessely1(value:Float64):Float64-instance-method","name":"bessely1","doc":"Calculates the cylindrical Bessel function of the second kind of *value* for order 1.","summary":"<p>Calculates the cylindrical Bessel function of the second kind of <em>value</em> for order 1.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":549,"url":null},"def":{"name":"bessely1","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.bessely1_f64(value)"}},{"html_id":"bessely1(value)-instance-method","name":"bessely1","doc":"Calculates the cylindrical Bessel function of the second kind of *value* for order 1.","summary":"<p>Calculates the cylindrical Bessel function of the second kind of <em>value</em> for order 1.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":554,"url":null},"def":{"name":"bessely1","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"bessely1(value.to_f)"}},{"html_id":"cbrt(value:Float32):Float32-instance-method","name":"cbrt","doc":"Calculates the cubic root of *value*.","summary":"<p>Calculates the cubic root of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":355,"url":null},"def":{"name":"cbrt","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.cbrt_f32(value)"}},{"html_id":"cbrt(value:Float64):Float64-instance-method","name":"cbrt","doc":"Calculates the cubic root of *value*.","summary":"<p>Calculates the cubic root of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":360,"url":null},"def":{"name":"cbrt","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.cbrt_f64(value)"}},{"html_id":"cbrt(value)-instance-method","name":"cbrt","doc":"Calculates the cubic root of *value*.","summary":"<p>Calculates the cubic root of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":365,"url":null},"def":{"name":"cbrt","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"cbrt(value.to_f)"}},{"html_id":"copysign(value1:Float32,value2:Float32)-instance-method","name":"copysign","doc":"Returns the floating-point value with the magnitude of *value1* and the sign of *value2*.","summary":"<p>Returns the floating-point value with the magnitude of <em>value1</em> and the sign of <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","external_name":"value1","restriction":"Float32"},{"name":"value2","external_name":"value2","restriction":"Float32"}],"args_string":"(value1 : Float32, value2 : Float32)","args_html":"(value1 : <a href=\"Float32.html\">Float32</a>, value2 : <a href=\"Float32.html\">Float32</a>)","location":{"filename":"src/math/math.cr","line_number":681,"url":null},"def":{"name":"copysign","args":[{"name":"value1","external_name":"value1","restriction":"Float32"},{"name":"value2","external_name":"value2","restriction":"Float32"}],"visibility":"Public","body":"LibM.copysign_f32(value1, value2)"}},{"html_id":"copysign(value1:Float64,value2:Float64):Float64-instance-method","name":"copysign","doc":"Returns the floating-point value with the magnitude of *value1* and the sign of *value2*.","summary":"<p>Returns the floating-point value with the magnitude of <em>value1</em> and the sign of <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","external_name":"value1","restriction":"Float64"},{"name":"value2","external_name":"value2","restriction":"Float64"}],"args_string":"(value1 : Float64, value2 : Float64) : Float64","args_html":"(value1 : <a href=\"Float64.html\">Float64</a>, value2 : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":686,"url":null},"def":{"name":"copysign","args":[{"name":"value1","external_name":"value1","restriction":"Float64"},{"name":"value2","external_name":"value2","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.copysign_f64(value1, value2)"}},{"html_id":"copysign(value1,value2)-instance-method","name":"copysign","doc":"Returns the floating-point value with the magnitude of *value1* and the sign of *value2*.","summary":"<p>Returns the floating-point value with the magnitude of <em>value1</em> and the sign of <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","external_name":"value1","restriction":""},{"name":"value2","external_name":"value2","restriction":""}],"args_string":"(value1, value2)","args_html":"(value1, value2)","location":{"filename":"src/math/math.cr","line_number":691,"url":null},"def":{"name":"copysign","args":[{"name":"value1","external_name":"value1","restriction":""},{"name":"value2","external_name":"value2","restriction":""}],"visibility":"Public","body":"copysign(value1.to_f, value2.to_f)"}},{"html_id":"cos(value:Float32):Float32-instance-method","name":"cos","doc":"Calculates the cosine of *value*, measured in radians.","summary":"<p>Calculates the cosine of <em>value</em>, measured in radians.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":31,"url":null},"def":{"name":"cos","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.cos_f32(value)"}},{"html_id":"cos(value:Float64):Float64-instance-method","name":"cos","doc":"Calculates the cosine of *value*, measured in radians.","summary":"<p>Calculates the cosine of <em>value</em>, measured in radians.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":36,"url":null},"def":{"name":"cos","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.cos_f64(value)"}},{"html_id":"cos(value)-instance-method","name":"cos","doc":"Calculates the cosine of *value*, measured in radians.","summary":"<p>Calculates the cosine of <em>value</em>, measured in radians.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":41,"url":null},"def":{"name":"cos","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"cos(value.to_f)"}},{"html_id":"cosh(value:Float32):Float32-instance-method","name":"cosh","doc":"Calculates the hyperbolic cosine of *value*.","summary":"<p>Calculates the hyperbolic cosine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":136,"url":null},"def":{"name":"cosh","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.cosh_f32(value)"}},{"html_id":"cosh(value:Float64):Float64-instance-method","name":"cosh","doc":"Calculates the hyperbolic cosine of *value*.","summary":"<p>Calculates the hyperbolic cosine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":141,"url":null},"def":{"name":"cosh","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.cosh_f64(value)"}},{"html_id":"cosh(value)-instance-method","name":"cosh","doc":"Calculates the hyperbolic cosine of *value*.","summary":"<p>Calculates the hyperbolic cosine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":146,"url":null},"def":{"name":"cosh","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"cosh(value.to_f)"}},{"html_id":"erf(value:Float32):Float32-instance-method","name":"erf","doc":"Calculates the error function of *value*.","summary":"<p>Calculates the error function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":370,"url":null},"def":{"name":"erf","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.erf_f32(value)"}},{"html_id":"erf(value:Float64):Float64-instance-method","name":"erf","doc":"Calculates the error function of *value*.","summary":"<p>Calculates the error function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":375,"url":null},"def":{"name":"erf","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.erf_f64(value)"}},{"html_id":"erf(value)-instance-method","name":"erf","doc":"Calculates the error function of *value*.","summary":"<p>Calculates the error function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":380,"url":null},"def":{"name":"erf","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"erf(value.to_f)"}},{"html_id":"erfc(value:Float32):Float32-instance-method","name":"erfc","doc":"Calculates 1 minus the error function of *value*.","summary":"<p>Calculates 1 minus the error function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":385,"url":null},"def":{"name":"erfc","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.erfc_f32(value)"}},{"html_id":"erfc(value:Float64):Float64-instance-method","name":"erfc","doc":"Calculates 1 minus the error function of *value*.","summary":"<p>Calculates 1 minus the error function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":390,"url":null},"def":{"name":"erfc","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.erfc_f64(value)"}},{"html_id":"erfc(value)-instance-method","name":"erfc","doc":"Calculates 1 minus the error function of *value*.","summary":"<p>Calculates 1 minus the error function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":395,"url":null},"def":{"name":"erfc","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"erfc(value.to_f)"}},{"html_id":"exp(value:Float32):Float32-instance-method","name":"exp","doc":"Calculates the exponential of *value*.","summary":"<p>Calculates the exponential of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":211,"url":null},"def":{"name":"exp","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.exp_f32(value)"}},{"html_id":"exp(value:Float64):Float64-instance-method","name":"exp","doc":"Calculates the exponential of *value*.","summary":"<p>Calculates the exponential of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":216,"url":null},"def":{"name":"exp","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.exp_f64(value)"}},{"html_id":"exp(value:Complex):Complex-instance-method","name":"exp","doc":"Calculates the exponential of *value*.\n\n```\nrequire \"complex\"\n\nMath.exp(4 + 2.i) # => -22.720847417619233 + 49.645957334580565i\n```","summary":"<p>Calculates the exponential of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Complex"}],"args_string":"(value : Complex) : Complex","args_html":"(value : <a href=\"Complex.html\">Complex</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":314,"url":null},"def":{"name":"exp","args":[{"name":"value","external_name":"value","restriction":"Complex"}],"return_type":"Complex","visibility":"Public","body":"r = exp(value.real)\nComplex.new(r * (cos(value.imag)), r * (sin(value.imag)))\n"}},{"html_id":"exp(value)-instance-method","name":"exp","doc":"Calculates the exponential of *value*.","summary":"<p>Calculates the exponential of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":221,"url":null},"def":{"name":"exp","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"exp(value.to_f)"}},{"html_id":"exp2(value:Float32):Float32-instance-method","name":"exp2","doc":"Calculates 2 raised to the power *value*.","summary":"<p>Calculates 2 raised to the power <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":241,"url":null},"def":{"name":"exp2","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.exp2_f32(value)"}},{"html_id":"exp2(value:Float64):Float64-instance-method","name":"exp2","doc":"Calculates 2 raised to the power *value*.","summary":"<p>Calculates 2 raised to the power <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":246,"url":null},"def":{"name":"exp2","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.exp2_f64(value)"}},{"html_id":"exp2(value)-instance-method","name":"exp2","doc":"Calculates 2 raised to the power *value*.","summary":"<p>Calculates 2 raised to the power <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":251,"url":null},"def":{"name":"exp2","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"exp2(value.to_f)"}},{"html_id":"expm1(value:Float32):Float32-instance-method","name":"expm1","doc":"Calculates the exponential of *value*, minus 1.","summary":"<p>Calculates the exponential of <em>value</em>, minus 1.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":226,"url":null},"def":{"name":"expm1","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.expm1_f32(value)"}},{"html_id":"expm1(value:Float64):Float64-instance-method","name":"expm1","doc":"Calculates the exponential of *value*, minus 1.","summary":"<p>Calculates the exponential of <em>value</em>, minus 1.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":231,"url":null},"def":{"name":"expm1","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.expm1_f64(value)"}},{"html_id":"expm1(value)-instance-method","name":"expm1","doc":"Calculates the exponential of *value*, minus 1.","summary":"<p>Calculates the exponential of <em>value</em>, minus 1.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":236,"url":null},"def":{"name":"expm1","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"expm1(value.to_f)"}},{"html_id":"frexp(value:Float32):Tuple(Float32,Int32)-instance-method","name":"frexp","doc":"Decomposes the given floating-point *value* into a normalized fraction and an integral power of two.","summary":"<p>Decomposes the given floating-point <em>value</em> into a normalized fraction and an integral power of two.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Tuple(Float32, Int32)","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"Float32.html\">Float32</a>, <a href=\"Int32.html\">Int32</a>)","location":{"filename":"src/math/math.cr","line_number":658,"url":null},"def":{"name":"frexp","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"::Tuple(Float32, Int32)","visibility":"Public","body":"{% if flag?(:win32) %}\n      # libucrt does not export `frexpf` and instead defines it like this\n      frac = LibM.frexp_f64(value, out exp)\n      {frac.to_f32, exp}\n    {% else %}\n      frac = LibM.frexp_f32(value, out exp)\n      {frac, exp}\n    {% end %}"}},{"html_id":"frexp(value:Float64):Tuple(Float64,Int32)-instance-method","name":"frexp","doc":"Decomposes the given floating-point *value* into a normalized fraction and an integral power of two.","summary":"<p>Decomposes the given floating-point <em>value</em> into a normalized fraction and an integral power of two.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Tuple(Float64, Int32)","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"Float64.html\">Float64</a>, <a href=\"Int32.html\">Int32</a>)","location":{"filename":"src/math/math.cr","line_number":670,"url":null},"def":{"name":"frexp","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"::Tuple(Float64, Int32)","visibility":"Public","body":"frac = LibM.frexp_f64(value, out exp)\n{frac, exp}\n"}},{"html_id":"frexp(value:BigFloat):Tuple(BigFloat,Int64)-instance-method","name":"frexp","doc":"Decomposes the given floating-point *value* into a normalized fraction and an integral power of two.","summary":"<p>Decomposes the given floating-point <em>value</em> into a normalized fraction and an integral power of two.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"BigFloat"}],"args_string":"(value : BigFloat) : Tuple(BigFloat, Int64)","args_html":"(value : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"BigFloat.html\">BigFloat</a>, <a href=\"Int64.html\">Int64</a>)","location":{"filename":"src/big/big_float.cr","line_number":397,"url":null},"def":{"name":"frexp","args":[{"name":"value","external_name":"value","restriction":"BigFloat"}],"return_type":"::Tuple(BigFloat, Int64)","visibility":"Public","body":"LibGMP.mpf_get_d_2exp(out exp, value)\nfrac = BigFloat.new do |mpf|\n  if exp >= 0\n    LibGMP.mpf_div_2exp(mpf, value, exp)\n  else\n    LibGMP.mpf_mul_2exp(mpf, value, -exp)\n  end\nend\n{frac, exp.to_i64}\n"}},{"html_id":"frexp(value)-instance-method","name":"frexp","doc":"Decomposes the given floating-point *value* into a normalized fraction and an integral power of two.","summary":"<p>Decomposes the given floating-point <em>value</em> into a normalized fraction and an integral power of two.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":676,"url":null},"def":{"name":"frexp","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"frexp(value.to_f)"}},{"html_id":"gamma(value:Float32):Float32-instance-method","name":"gamma","doc":"Calculates the gamma function of *value*.\n\nNote that `gamma(n)` is same as `fact(n - 1)` for integer `n > 0`.\nHowever `gamma(n)` returns float and can be an approximation.","summary":"<p>Calculates the gamma function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":403,"url":null},"def":{"name":"gamma","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.tgamma_f32(value)"}},{"html_id":"gamma(value:Float64):Float64-instance-method","name":"gamma","doc":"Calculates the gamma function of *value*.\n\nNote that `gamma(n)` is same as `fact(n - 1)` for integer `n > 0`.\nHowever `gamma(n)` returns float and can be an approximation.","summary":"<p>Calculates the gamma function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":408,"url":null},"def":{"name":"gamma","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.tgamma_f64(value)"}},{"html_id":"gamma(value):Float64-instance-method","name":"gamma","doc":"Calculates the gamma function of *value*.\n\nNote that `gamma(n)` is same as `fact(n - 1)` for integer `n > 0`.\nHowever `gamma(n)` returns float and can be an approximation.","summary":"<p>Calculates the gamma function of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : Float64","args_html":"(value) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":413,"url":null},"def":{"name":"gamma","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"Float64","visibility":"Public","body":"gamma(value.to_f)"}},{"html_id":"hypot(value1:Float32,value2:Float32):Float32-instance-method","name":"hypot","doc":"Calculates the length of the hypotenuse from (0, 0) to (*value1*, *value2*).\n\nEquivalent to\n```\nMath.sqrt(value1 ** 2 + value2 ** 2)\n```","summary":"<p>Calculates the length of the hypotenuse from (0, 0) to (<em>value1</em>, <em>value2</em>).</p>","abstract":false,"args":[{"name":"value1","external_name":"value1","restriction":"Float32"},{"name":"value2","external_name":"value2","restriction":"Float32"}],"args_string":"(value1 : Float32, value2 : Float32) : Float32","args_html":"(value1 : <a href=\"Float32.html\">Float32</a>, value2 : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":564,"url":null},"def":{"name":"hypot","args":[{"name":"value1","external_name":"value1","restriction":"Float32"},{"name":"value2","external_name":"value2","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.hypot_f32(value1, value2)"}},{"html_id":"hypot(value1:Float64,value2:Float64):Float64-instance-method","name":"hypot","doc":"Calculates the length of the hypotenuse from (0, 0) to (*value1*, *value2*).\n\nEquivalent to\n```\nMath.sqrt(value1 ** 2 + value2 ** 2)\n```","summary":"<p>Calculates the length of the hypotenuse from (0, 0) to (<em>value1</em>, <em>value2</em>).</p>","abstract":false,"args":[{"name":"value1","external_name":"value1","restriction":"Float64"},{"name":"value2","external_name":"value2","restriction":"Float64"}],"args_string":"(value1 : Float64, value2 : Float64) : Float64","args_html":"(value1 : <a href=\"Float64.html\">Float64</a>, value2 : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":569,"url":null},"def":{"name":"hypot","args":[{"name":"value1","external_name":"value1","restriction":"Float64"},{"name":"value2","external_name":"value2","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.hypot_f64(value1, value2)"}},{"html_id":"hypot(value1,value2)-instance-method","name":"hypot","doc":"Calculates the length of the hypotenuse from (0, 0) to (*value1*, *value2*).\n\nEquivalent to\n```\nMath.sqrt(value1 ** 2 + value2 ** 2)\n```","summary":"<p>Calculates the length of the hypotenuse from (0, 0) to (<em>value1</em>, <em>value2</em>).</p>","abstract":false,"args":[{"name":"value1","external_name":"value1","restriction":""},{"name":"value2","external_name":"value2","restriction":""}],"args_string":"(value1, value2)","args_html":"(value1, value2)","location":{"filename":"src/math/math.cr","line_number":574,"url":null},"def":{"name":"hypot","args":[{"name":"value1","external_name":"value1","restriction":""},{"name":"value2","external_name":"value2","restriction":""}],"visibility":"Public","body":"hypot(value1.to_f, value2.to_f)"}},{"html_id":"ilogb(value:Float32):Int32-instance-method","name":"ilogb","doc":"Returns the unbiased base 2 exponent of the given floating-point *value*.","summary":"<p>Returns the unbiased base 2 exponent of the given floating-point <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Int32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/math/math.cr","line_number":579,"url":null},"def":{"name":"ilogb","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Int32","visibility":"Public","body":"LibM.ilogb_f32(value)"}},{"html_id":"ilogb(value:Float64):Int32-instance-method","name":"ilogb","doc":"Returns the unbiased base 2 exponent of the given floating-point *value*.","summary":"<p>Returns the unbiased base 2 exponent of the given floating-point <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Int32","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/math/math.cr","line_number":584,"url":null},"def":{"name":"ilogb","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Int32","visibility":"Public","body":"LibM.ilogb_f64(value)"}},{"html_id":"ilogb(value)-instance-method","name":"ilogb","doc":"Returns the unbiased base 2 exponent of the given floating-point *value*.","summary":"<p>Returns the unbiased base 2 exponent of the given floating-point <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":589,"url":null},"def":{"name":"ilogb","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"ilogb(value.to_f)"}},{"html_id":"isqrt(value:Int::Primitive)-instance-method","name":"isqrt","doc":"Calculates the integer square root of *value*.","summary":"<p>Calculates the integer square root of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Int::Primitive"}],"args_string":"(value : Int::Primitive)","args_html":"(value : <a href=\"Int/Primitive.html\">Int::Primitive</a>)","location":{"filename":"src/math/math.cr","line_number":336,"url":null},"def":{"name":"isqrt","args":[{"name":"value","external_name":"value","restriction":"Int::Primitive"}],"visibility":"Public","body":"if value < 0\n  raise(ArgumentError.new(\"Input must be non-negative integer\"))\nend\nif value < 2\n  return value\nend\nres = value.class.zero\nbit = res.succ << (res.leading_zeros_count - 2)\nbit = bit >> (value.leading_zeros_count & (~3))\nwhile (bit != 0)\n  if value >= (res + bit)\n    value = value - (res + bit)\n    res = (res >> 1) + bit\n  else\n    res = res >> 1\n  end\n  bit = bit >> 2\nend\nres\n"}},{"html_id":"isqrt(value:BigInt)-instance-method","name":"isqrt","doc":"Calculates the integer square root of *value*.","summary":"<p>Calculates the integer square root of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"BigInt"}],"args_string":"(value : BigInt)","args_html":"(value : <a href=\"BigInt.html\">BigInt</a>)","location":{"filename":"src/big/big_int.cr","line_number":816,"url":null},"def":{"name":"isqrt","args":[{"name":"value","external_name":"value","restriction":"BigInt"}],"visibility":"Public","body":"BigInt.new do |mpz|\n  LibGMP.sqrt(mpz, value)\nend"}},{"html_id":"ldexp(value:Float32,exp:Int32):Float32-instance-method","name":"ldexp","doc":"Multiplies the given floating-point *value* by 2 raised to the power *exp*.","summary":"<p>Multiplies the given floating-point <em>value</em> by 2 raised to the power <em>exp</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"},{"name":"exp","external_name":"exp","restriction":"Int32"}],"args_string":"(value : Float32, exp : Int32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>, exp : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":611,"url":null},"def":{"name":"ldexp","args":[{"name":"value","external_name":"value","restriction":"Float32"},{"name":"exp","external_name":"exp","restriction":"Int32"}],"return_type":"Float32","visibility":"Public","body":"LibM.ldexp_f32(value, exp)"}},{"html_id":"ldexp(value:Float64,exp:Int32):Float64-instance-method","name":"ldexp","doc":"Multiplies the given floating-point *value* by 2 raised to the power *exp*.","summary":"<p>Multiplies the given floating-point <em>value</em> by 2 raised to the power <em>exp</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"},{"name":"exp","external_name":"exp","restriction":"Int32"}],"args_string":"(value : Float64, exp : Int32) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>, exp : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":616,"url":null},"def":{"name":"ldexp","args":[{"name":"value","external_name":"value","restriction":"Float64"},{"name":"exp","external_name":"exp","restriction":"Int32"}],"return_type":"Float64","visibility":"Public","body":"LibM.ldexp_f64(value, exp)"}},{"html_id":"ldexp(value,exp)-instance-method","name":"ldexp","doc":"Multiplies the given floating-point *value* by 2 raised to the power *exp*.","summary":"<p>Multiplies the given floating-point <em>value</em> by 2 raised to the power <em>exp</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"exp","external_name":"exp","restriction":""}],"args_string":"(value, exp)","args_html":"(value, exp)","location":{"filename":"src/math/math.cr","line_number":621,"url":null},"def":{"name":"ldexp","args":[{"name":"value","external_name":"value","restriction":""},{"name":"exp","external_name":"exp","restriction":""}],"visibility":"Public","body":"ldexp(value.to_f, exp.to_i32)"}},{"html_id":"lgamma(value:Float32)-instance-method","name":"lgamma","doc":"Calculates the logarithmic gamma of *value*.\n\n```\nMath.lgamma(2.96)\n```\nis equivalent to\n```\nMath.log(Math.gamma(2.96).abs)\n```","summary":"<p>Calculates the logarithmic gamma of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32)","args_html":"(value : <a href=\"Float32.html\">Float32</a>)","location":{"filename":"src/math/math.cr","line_number":426,"url":null},"def":{"name":"lgamma","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"visibility":"Public","body":"{% if flag?(:darwin) %}\n      LibM.gamma_f64(value).to_f32\n    {% else %}\n      LibM.gamma_f32(value)\n    {% end %}"}},{"html_id":"lgamma(value:Float64):Float64-instance-method","name":"lgamma","doc":"Calculates the logarithmic gamma of *value*.\n\n```\nMath.lgamma(2.96)\n```\nis equivalent to\n```\nMath.log(Math.gamma(2.96).abs)\n```","summary":"<p>Calculates the logarithmic gamma of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":435,"url":null},"def":{"name":"lgamma","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.gamma_f64(value)"}},{"html_id":"lgamma(value):Float64-instance-method","name":"lgamma","doc":"Calculates the logarithmic gamma of *value*.\n\n```\nMath.lgamma(2.96)\n```\nis equivalent to\n```\nMath.log(Math.gamma(2.96).abs)\n```","summary":"<p>Calculates the logarithmic gamma of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : Float64","args_html":"(value) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":440,"url":null},"def":{"name":"lgamma","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"Float64","visibility":"Public","body":"lgamma(value.to_f)"}},{"html_id":"log(value,base)-instance-method","name":"log","doc":"Calculates the logarithm of *value* to the given *base*.","summary":"<p>Calculates the logarithm of <em>value</em> to the given <em>base</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"base","external_name":"base","restriction":""}],"args_string":"(value, base)","args_html":"(value, base)","location":{"filename":"src/math/math.cr","line_number":316,"url":null},"def":{"name":"log","args":[{"name":"value","external_name":"value","restriction":""},{"name":"base","external_name":"base","restriction":""}],"visibility":"Public","body":"(log(value)) / (log(base))"}},{"html_id":"log(value:Float32):Float32-instance-method","name":"log","doc":"Calculates the natural logarithm of *value*.","summary":"<p>Calculates the natural logarithm of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":256,"url":null},"def":{"name":"log","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.log_f32(value)"}},{"html_id":"log(value:Float64):Float64-instance-method","name":"log","doc":"Calculates the natural logarithm of *value*.","summary":"<p>Calculates the natural logarithm of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":261,"url":null},"def":{"name":"log","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.log_f64(value)"}},{"html_id":"log(value:Complex):Complex-instance-method","name":"log","doc":"Calculates the natural logarithm of *value*.\n\n```\nrequire \"complex\"\n\nMath.log(4 + 2.i) # => 1.4978661367769956 + 0.4636476090008061i\n```","summary":"<p>Calculates the natural logarithm of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Complex"}],"args_string":"(value : Complex) : Complex","args_html":"(value : <a href=\"Complex.html\">Complex</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":326,"url":null},"def":{"name":"log","args":[{"name":"value","external_name":"value","restriction":"Complex"}],"return_type":"Complex","visibility":"Public","body":"Complex.new(Math.log(value.abs), value.phase)"}},{"html_id":"log(value):Float64-instance-method","name":"log","doc":"Calculates the natural logarithm of *value*.","summary":"<p>Calculates the natural logarithm of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : Float64","args_html":"(value) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":266,"url":null},"def":{"name":"log","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"Float64","visibility":"Public","body":"log(value.to_f)"}},{"html_id":"log10(value:Float32):Float32-instance-method","name":"log10","doc":"Calculates the logarithm of *value* to base 10.","summary":"<p>Calculates the logarithm of <em>value</em> to base 10.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":301,"url":null},"def":{"name":"log10","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.log10_f32(value)"}},{"html_id":"log10(value:Float64):Float64-instance-method","name":"log10","doc":"Calculates the logarithm of *value* to base 10.","summary":"<p>Calculates the logarithm of <em>value</em> to base 10.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":306,"url":null},"def":{"name":"log10","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.log10_f64(value)"}},{"html_id":"log10(value:Complex):Complex-instance-method","name":"log10","doc":"Calculates the logarithm of *value* to base 10.\n\n```\nrequire \"complex\"\n\nMath.log10(4 + 2.i) # => 0.6505149978319906 + 0.20135959813668655i\n```","summary":"<p>Calculates the logarithm of <em>value</em> to base 10.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Complex"}],"args_string":"(value : Complex) : Complex","args_html":"(value : <a href=\"Complex.html\">Complex</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":348,"url":null},"def":{"name":"log10","args":[{"name":"value","external_name":"value","restriction":"Complex"}],"return_type":"Complex","visibility":"Public","body":"(log(value)) / LOG10"}},{"html_id":"log10(value)-instance-method","name":"log10","doc":"Calculates the logarithm of *value* to base 10.","summary":"<p>Calculates the logarithm of <em>value</em> to base 10.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":311,"url":null},"def":{"name":"log10","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"log10(value.to_f)"}},{"html_id":"log1p(value:Float32):Float32-instance-method","name":"log1p","doc":"Calculates the natural logarithm of 1 plus *value*.","summary":"<p>Calculates the natural logarithm of 1 plus <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":271,"url":null},"def":{"name":"log1p","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.log1p_f32(value)"}},{"html_id":"log1p(value:Float64):Float64-instance-method","name":"log1p","doc":"Calculates the natural logarithm of 1 plus *value*.","summary":"<p>Calculates the natural logarithm of 1 plus <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":276,"url":null},"def":{"name":"log1p","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.log1p_f64(value)"}},{"html_id":"log1p(value)-instance-method","name":"log1p","doc":"Calculates the natural logarithm of 1 plus *value*.","summary":"<p>Calculates the natural logarithm of 1 plus <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":281,"url":null},"def":{"name":"log1p","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"log1p(value.to_f)"}},{"html_id":"log2(value:Float32):Float32-instance-method","name":"log2","doc":"Calculates the logarithm of *value* to base 2.","summary":"<p>Calculates the logarithm of <em>value</em> to base 2.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":286,"url":null},"def":{"name":"log2","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.log2_f32(value)"}},{"html_id":"log2(value:Float64):Float64-instance-method","name":"log2","doc":"Calculates the logarithm of *value* to base 2.","summary":"<p>Calculates the logarithm of <em>value</em> to base 2.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":291,"url":null},"def":{"name":"log2","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.log2_f64(value)"}},{"html_id":"log2(value:Complex):Complex-instance-method","name":"log2","doc":"Calculates the logarithm of *value* to base 2.\n\n```\nrequire \"complex\"\n\nMath.log2(4 + 2.i) # => 2.1609640474436813 + 0.6689021062254881i\n```","summary":"<p>Calculates the logarithm of <em>value</em> to base 2.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Complex"}],"args_string":"(value : Complex) : Complex","args_html":"(value : <a href=\"Complex.html\">Complex</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":337,"url":null},"def":{"name":"log2","args":[{"name":"value","external_name":"value","restriction":"Complex"}],"return_type":"Complex","visibility":"Public","body":"(log(value)) / LOG2"}},{"html_id":"log2(value):Float64-instance-method","name":"log2","doc":"Calculates the logarithm of *value* to base 2.","summary":"<p>Calculates the logarithm of <em>value</em> to base 2.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : Float64","args_html":"(value) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":296,"url":null},"def":{"name":"log2","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"Float64","visibility":"Public","body":"log2(value.to_f)"}},{"html_id":"logb(value:Float32):Float32-instance-method","name":"logb","doc":"Returns the unbiased radix-independent exponent of the given floating-point *value*.\n\nFor `Float32` and `Float64` this is equivalent to `ilogb`.","summary":"<p>Returns the unbiased radix-independent exponent of the given floating-point <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":596,"url":null},"def":{"name":"logb","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.logb_f32(value)"}},{"html_id":"logb(value:Float64):Float64-instance-method","name":"logb","doc":"Returns the unbiased radix-independent exponent of the given floating-point *value*.\n\nFor `Float32` and `Float64` this is equivalent to `ilogb`.","summary":"<p>Returns the unbiased radix-independent exponent of the given floating-point <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":601,"url":null},"def":{"name":"logb","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.logb_f64(value)"}},{"html_id":"logb(value)-instance-method","name":"logb","doc":"Returns the unbiased radix-independent exponent of the given floating-point *value*.\n\nFor `Float32` and `Float64` this is equivalent to `ilogb`.","summary":"<p>Returns the unbiased radix-independent exponent of the given floating-point <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":606,"url":null},"def":{"name":"logb","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"logb(value.to_f)"}},{"html_id":"max(value1:Float32,value2:Float32)-instance-method","name":"max","doc":"Returns the greater of *value1* and *value2*.","summary":"<p>Returns the greater of <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","external_name":"value1","restriction":"Float32"},{"name":"value2","external_name":"value2","restriction":"Float32"}],"args_string":"(value1 : Float32, value2 : Float32)","args_html":"(value1 : <a href=\"Float32.html\">Float32</a>, value2 : <a href=\"Float32.html\">Float32</a>)","location":{"filename":"src/math/math.cr","line_number":696,"url":null},"def":{"name":"max","args":[{"name":"value1","external_name":"value1","restriction":"Float32"},{"name":"value2","external_name":"value2","restriction":"Float32"}],"visibility":"Public","body":"LibM.max_f32(value1, value2)"}},{"html_id":"max(value1:Float64,value2:Float64):Float64-instance-method","name":"max","doc":"Returns the greater of *value1* and *value2*.","summary":"<p>Returns the greater of <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","external_name":"value1","restriction":"Float64"},{"name":"value2","external_name":"value2","restriction":"Float64"}],"args_string":"(value1 : Float64, value2 : Float64) : Float64","args_html":"(value1 : <a href=\"Float64.html\">Float64</a>, value2 : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":701,"url":null},"def":{"name":"max","args":[{"name":"value1","external_name":"value1","restriction":"Float64"},{"name":"value2","external_name":"value2","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.max_f64(value1, value2)"}},{"html_id":"max(value1,value2)-instance-method","name":"max","doc":"Returns the greater of *value1* and *value2*.","summary":"<p>Returns the greater of <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","external_name":"value1","restriction":""},{"name":"value2","external_name":"value2","restriction":""}],"args_string":"(value1, value2)","args_html":"(value1, value2)","location":{"filename":"src/math/math.cr","line_number":706,"url":null},"def":{"name":"max","args":[{"name":"value1","external_name":"value1","restriction":""},{"name":"value2","external_name":"value2","restriction":""}],"visibility":"Public","body":"value1 >= value2 ? value1 : value2"}},{"html_id":"min(value1:Float32,value2:Float32)-instance-method","name":"min","doc":"Returns the smaller of *value1* and *value2*.","summary":"<p>Returns the smaller of <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","external_name":"value1","restriction":"Float32"},{"name":"value2","external_name":"value2","restriction":"Float32"}],"args_string":"(value1 : Float32, value2 : Float32)","args_html":"(value1 : <a href=\"Float32.html\">Float32</a>, value2 : <a href=\"Float32.html\">Float32</a>)","location":{"filename":"src/math/math.cr","line_number":711,"url":null},"def":{"name":"min","args":[{"name":"value1","external_name":"value1","restriction":"Float32"},{"name":"value2","external_name":"value2","restriction":"Float32"}],"visibility":"Public","body":"LibM.min_f32(value1, value2)"}},{"html_id":"min(value1:Float64,value2:Float64):Float64-instance-method","name":"min","doc":"Returns the smaller of *value1* and *value2*.","summary":"<p>Returns the smaller of <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","external_name":"value1","restriction":"Float64"},{"name":"value2","external_name":"value2","restriction":"Float64"}],"args_string":"(value1 : Float64, value2 : Float64) : Float64","args_html":"(value1 : <a href=\"Float64.html\">Float64</a>, value2 : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":716,"url":null},"def":{"name":"min","args":[{"name":"value1","external_name":"value1","restriction":"Float64"},{"name":"value2","external_name":"value2","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.min_f64(value1, value2)"}},{"html_id":"min(value1,value2)-instance-method","name":"min","doc":"Returns the smaller of *value1* and *value2*.","summary":"<p>Returns the smaller of <em>value1</em> and <em>value2</em>.</p>","abstract":false,"args":[{"name":"value1","external_name":"value1","restriction":""},{"name":"value2","external_name":"value2","restriction":""}],"args_string":"(value1, value2)","args_html":"(value1, value2)","location":{"filename":"src/math/math.cr","line_number":721,"url":null},"def":{"name":"min","args":[{"name":"value1","external_name":"value1","restriction":""},{"name":"value2","external_name":"value2","restriction":""}],"visibility":"Public","body":"value1 <= value2 ? value1 : value2"}},{"html_id":"pw2ceil(v:Int32)-instance-method","name":"pw2ceil","doc":"Computes the next highest power of 2 of *v*.\n\n```\nMath.pw2ceil(33) # => 64\n```","summary":"<p>Computes the next highest power of 2 of <em>v</em>.</p>","abstract":false,"args":[{"name":"v","external_name":"v","restriction":"Int32"}],"args_string":"(v : Int32)","args_html":"(v : <a href=\"Int32.html\">Int32</a>)","location":{"filename":"src/math/math.cr","line_number":730,"url":null},"def":{"name":"pw2ceil","args":[{"name":"v","external_name":"v","restriction":"Int32"}],"visibility":"Public","body":"v = v - 1\nv = v | (v >> 1)\nv = v | (v >> 2)\nv = v | (v >> 4)\nv = v | (v >> 8)\nv = v | (v >> 16)\nv = v + (v == -1 ? 2 : 1)\n"}},{"html_id":"pw2ceil(v:Int64)-instance-method","name":"pw2ceil","abstract":false,"args":[{"name":"v","external_name":"v","restriction":"Int64"}],"args_string":"(v : Int64)","args_html":"(v : <a href=\"Int64.html\">Int64</a>)","location":{"filename":"src/math/math.cr","line_number":741,"url":null},"def":{"name":"pw2ceil","args":[{"name":"v","external_name":"v","restriction":"Int64"}],"visibility":"Public","body":"v = v - 1\nv = v | (v >> 1)\nv = v | (v >> 2)\nv = v | (v >> 4)\nv = v | (v >> 8)\nv = v | (v >> 16)\nv = v | (v >> 32)\nv = v + (v == -1 ? 2 : 1)\n"}},{"html_id":"scalbln(value:Float32,exp:Int64)-instance-method","name":"scalbln","doc":"Returns the floating-point *value* with its exponent raised by *exp*.\n\nFor `Float32` and `Float64` this is equivalent to `ldexp`.","summary":"<p>Returns the floating-point <em>value</em> with its exponent raised by <em>exp</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"},{"name":"exp","external_name":"exp","restriction":"Int64"}],"args_string":"(value : Float32, exp : Int64)","args_html":"(value : <a href=\"Float32.html\">Float32</a>, exp : <a href=\"Int64.html\">Int64</a>)","location":{"filename":"src/math/math.cr","line_number":643,"url":null},"def":{"name":"scalbln","args":[{"name":"value","external_name":"value","restriction":"Float32"},{"name":"exp","external_name":"exp","restriction":"Int64"}],"visibility":"Public","body":"LibM.scalbln_f32(value, exp)"}},{"html_id":"scalbln(value:Float64,exp:Int64):Float64-instance-method","name":"scalbln","doc":"Returns the floating-point *value* with its exponent raised by *exp*.\n\nFor `Float32` and `Float64` this is equivalent to `ldexp`.","summary":"<p>Returns the floating-point <em>value</em> with its exponent raised by <em>exp</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"},{"name":"exp","external_name":"exp","restriction":"Int64"}],"args_string":"(value : Float64, exp : Int64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>, exp : <a href=\"Int64.html\">Int64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":648,"url":null},"def":{"name":"scalbln","args":[{"name":"value","external_name":"value","restriction":"Float64"},{"name":"exp","external_name":"exp","restriction":"Int64"}],"return_type":"Float64","visibility":"Public","body":"LibM.scalbln_f64(value, exp)"}},{"html_id":"scalbln(value,exp):Float64-instance-method","name":"scalbln","doc":"Returns the floating-point *value* with its exponent raised by *exp*.\n\nFor `Float32` and `Float64` this is equivalent to `ldexp`.","summary":"<p>Returns the floating-point <em>value</em> with its exponent raised by <em>exp</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"exp","external_name":"exp","restriction":""}],"args_string":"(value, exp) : Float64","args_html":"(value, exp) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":653,"url":null},"def":{"name":"scalbln","args":[{"name":"value","external_name":"value","restriction":""},{"name":"exp","external_name":"exp","restriction":""}],"return_type":"Float64","visibility":"Public","body":"scalbln(value.to_f, exp.to_i64)"}},{"html_id":"scalbn(value:Float32,exp:Int32):Float32-instance-method","name":"scalbn","doc":"Returns the floating-point *value* with its exponent raised by *exp*.\n\nFor `Float32` and `Float64` this is equivalent to `ldexp`.","summary":"<p>Returns the floating-point <em>value</em> with its exponent raised by <em>exp</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"},{"name":"exp","external_name":"exp","restriction":"Int32"}],"args_string":"(value : Float32, exp : Int32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>, exp : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":628,"url":null},"def":{"name":"scalbn","args":[{"name":"value","external_name":"value","restriction":"Float32"},{"name":"exp","external_name":"exp","restriction":"Int32"}],"return_type":"Float32","visibility":"Public","body":"LibM.scalbn_f32(value, exp)"}},{"html_id":"scalbn(value:Float64,exp:Int32):Float64-instance-method","name":"scalbn","doc":"Returns the floating-point *value* with its exponent raised by *exp*.\n\nFor `Float32` and `Float64` this is equivalent to `ldexp`.","summary":"<p>Returns the floating-point <em>value</em> with its exponent raised by <em>exp</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"},{"name":"exp","external_name":"exp","restriction":"Int32"}],"args_string":"(value : Float64, exp : Int32) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>, exp : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":633,"url":null},"def":{"name":"scalbn","args":[{"name":"value","external_name":"value","restriction":"Float64"},{"name":"exp","external_name":"exp","restriction":"Int32"}],"return_type":"Float64","visibility":"Public","body":"LibM.scalbn_f64(value, exp)"}},{"html_id":"scalbn(value,exp)-instance-method","name":"scalbn","doc":"Returns the floating-point *value* with its exponent raised by *exp*.\n\nFor `Float32` and `Float64` this is equivalent to `ldexp`.","summary":"<p>Returns the floating-point <em>value</em> with its exponent raised by <em>exp</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"exp","external_name":"exp","restriction":""}],"args_string":"(value, exp)","args_html":"(value, exp)","location":{"filename":"src/math/math.cr","line_number":638,"url":null},"def":{"name":"scalbn","args":[{"name":"value","external_name":"value","restriction":""},{"name":"exp","external_name":"exp","restriction":""}],"visibility":"Public","body":"scalbn(value.to_f, exp.to_i32)"}},{"html_id":"sin(value:Float32):Float32-instance-method","name":"sin","doc":"Calculates the sine of *value*, measured in radians.","summary":"<p>Calculates the sine of <em>value</em>, measured in radians.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":16,"url":null},"def":{"name":"sin","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.sin_f32(value)"}},{"html_id":"sin(value:Float64):Float64-instance-method","name":"sin","doc":"Calculates the sine of *value*, measured in radians.","summary":"<p>Calculates the sine of <em>value</em>, measured in radians.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":21,"url":null},"def":{"name":"sin","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.sin_f64(value)"}},{"html_id":"sin(value)-instance-method","name":"sin","doc":"Calculates the sine of *value*, measured in radians.","summary":"<p>Calculates the sine of <em>value</em>, measured in radians.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":26,"url":null},"def":{"name":"sin","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"sin(value.to_f)"}},{"html_id":"sinh(value:Float32):Float32-instance-method","name":"sinh","doc":"Calculates the hyperbolic sine of *value*.","summary":"<p>Calculates the hyperbolic sine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":121,"url":null},"def":{"name":"sinh","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.sinh_f32(value)"}},{"html_id":"sinh(value:Float64):Float64-instance-method","name":"sinh","doc":"Calculates the hyperbolic sine of *value*.","summary":"<p>Calculates the hyperbolic sine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":126,"url":null},"def":{"name":"sinh","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.sinh_f64(value)"}},{"html_id":"sinh(value)-instance-method","name":"sinh","doc":"Calculates the hyperbolic sine of *value*.","summary":"<p>Calculates the hyperbolic sine of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":131,"url":null},"def":{"name":"sinh","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"sinh(value.to_f)"}},{"html_id":"sqrt(value:Float32):Float32-instance-method","name":"sqrt","doc":"Calculates the square root of *value*.","summary":"<p>Calculates the square root of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":321,"url":null},"def":{"name":"sqrt","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.sqrt_f32(value)"}},{"html_id":"sqrt(value:Float64):Float64-instance-method","name":"sqrt","doc":"Calculates the square root of *value*.","summary":"<p>Calculates the square root of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":326,"url":null},"def":{"name":"sqrt","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.sqrt_f64(value)"}},{"html_id":"sqrt(value:BigInt):BigFloat-instance-method","name":"sqrt","doc":"Calculates the square root of *value*.\n\n```\nrequire \"big\"\n\nMath.sqrt(1_000_000_000_000.to_big_i * 1_000_000_000_000.to_big_i) # => 1000000000000.0\n```","summary":"<p>Calculates the square root of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"BigInt"}],"args_string":"(value : BigInt) : BigFloat","args_html":"(value : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/big_int.cr","line_number":811,"url":null},"def":{"name":"sqrt","args":[{"name":"value","external_name":"value","restriction":"BigInt"}],"return_type":"BigFloat","visibility":"Public","body":"sqrt(value.to_big_f)"}},{"html_id":"sqrt(value:BigFloat):BigFloat-instance-method","name":"sqrt","doc":"Calculates the square root of *value*.\n\n```\nrequire \"big\"\n\nMath.sqrt(1_000_000_000_000.to_big_f * 1_000_000_000_000.to_big_f) # => 1000000000000.0\n```","summary":"<p>Calculates the square root of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"BigFloat"}],"args_string":"(value : BigFloat) : BigFloat","args_html":"(value : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/big_float.cr","line_number":416,"url":null},"def":{"name":"sqrt","args":[{"name":"value","external_name":"value","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"BigFloat.new do |mpf|\n  LibGMP.mpf_sqrt(mpf, value)\nend"}},{"html_id":"sqrt(value:BigRational):BigFloat-instance-method","name":"sqrt","doc":"Calculates the square root of *value*.\n\n```\nrequire \"big\"\n\nMath.sqrt(1_000_000_000_000.to_big_r * 1_000_000_000_000.to_big_r) # => 1000000000000.0\n```","summary":"<p>Calculates the square root of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"BigRational"}],"args_string":"(value : BigRational) : BigFloat","args_html":"(value : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/big_rational.cr","line_number":366,"url":null},"def":{"name":"sqrt","args":[{"name":"value","external_name":"value","restriction":"BigRational"}],"return_type":"BigFloat","visibility":"Public","body":"sqrt(value.to_big_f)"}},{"html_id":"sqrt(value:Complex):Complex-instance-method","name":"sqrt","doc":"Calculates the square root of *value*.\nInspired by the [following blog post](https://pavpanchekha.com/blog/casio-mathjs.html) of Pavel Panchekha on floating point precision.\n\n```\nrequire \"complex\"\n\nMath.sqrt(4 + 2.i) # => 2.0581710272714924 + 0.48586827175664565i\n```\n\nAlthough the imaginary number is defined as i = sqrt(-1),\ncalling `Math.sqrt` with a negative number will return `-NaN`.\nTo obtain the result in the complex plane, `Math.sqrt` must\nbe called with a complex number.\n\n```\nMath.sqrt(-1.0)         # => -NaN\nMath.sqrt(-1.0 + 0.0.i) # => 0.0 + 1.0i\n```","summary":"<p>Calculates the square root of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Complex"}],"args_string":"(value : Complex) : Complex","args_html":"(value : <a href=\"Complex.html\">Complex</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":370,"url":null},"def":{"name":"sqrt","args":[{"name":"value","external_name":"value","restriction":"Complex"}],"return_type":"Complex","visibility":"Public","body":"r = value.abs\nre = if value.real >= 0\n  0.5 * (sqrt(2.0 * (r + value.real)))\nelse\n  value.imag.abs / (sqrt(2.0 * (r - value.real)))\nend\nim = if value.real <= 0\n  0.5 * (sqrt(2.0 * (r - value.real)))\nelse\n  value.imag.abs / (sqrt(2.0 * (r + value.real)))\nend\nComplex.new(re, value.imag >= 0 ? im : -im)\n"}},{"html_id":"sqrt(value):Float64-instance-method","name":"sqrt","doc":"Calculates the square root of *value*.","summary":"<p>Calculates the square root of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : Float64","args_html":"(value) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":331,"url":null},"def":{"name":"sqrt","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"Float64","visibility":"Public","body":"sqrt(value.to_f)"}},{"html_id":"tan(value:Float32):Float32-instance-method","name":"tan","doc":"Calculates the tangent of *value*, measured in radians.","summary":"<p>Calculates the tangent of <em>value</em>, measured in radians.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":46,"url":null},"def":{"name":"tan","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.tan_f32(value)"}},{"html_id":"tan(value:Float64):Float64-instance-method","name":"tan","doc":"Calculates the tangent of *value*, measured in radians.","summary":"<p>Calculates the tangent of <em>value</em>, measured in radians.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":51,"url":null},"def":{"name":"tan","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.tan_f64(value)"}},{"html_id":"tan(value)-instance-method","name":"tan","doc":"Calculates the tangent of *value*, measured in radians.","summary":"<p>Calculates the tangent of <em>value</em>, measured in radians.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":56,"url":null},"def":{"name":"tan","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"tan(value.to_f)"}},{"html_id":"tanh(value:Float32):Float32-instance-method","name":"tanh","doc":"Calculates the hyperbolic tangent of *value*.","summary":"<p>Calculates the hyperbolic tangent of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float32"}],"args_string":"(value : Float32) : Float32","args_html":"(value : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/math/math.cr","line_number":151,"url":null},"def":{"name":"tanh","args":[{"name":"value","external_name":"value","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"LibM.tanh_f32(value)"}},{"html_id":"tanh(value:Float64):Float64-instance-method","name":"tanh","doc":"Calculates the hyperbolic tangent of *value*.","summary":"<p>Calculates the hyperbolic tangent of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Float64"}],"args_string":"(value : Float64) : Float64","args_html":"(value : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/math/math.cr","line_number":156,"url":null},"def":{"name":"tanh","args":[{"name":"value","external_name":"value","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"LibM.tanh_f64(value)"}},{"html_id":"tanh(value)-instance-method","name":"tanh","doc":"Calculates the hyperbolic tangent of *value*.","summary":"<p>Calculates the hyperbolic tangent of <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/math/math.cr","line_number":161,"url":null},"def":{"name":"tanh","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"tanh(value.to_f)"}}]},{"html_id":"Crystal/MIME","path":"MIME.html","kind":"module","full_name":"MIME","name":"MIME","abstract":false,"locations":[{"filename":"src/mime.cr","line_number":77,"url":null},{"filename":"src/mime/media_type.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"DEFAULT_TYPES","name":"DEFAULT_TYPES","value":"{\".css\" => \"text/css; charset=utf-8\", \".gif\" => \"image/gif\", \".htm\" => \"text/html; charset=utf-8\", \".html\" => \"text/html; charset=utf-8\", \".jpg\" => \"image/jpeg\", \".jpeg\" => \"image/jpeg\", \".js\" => \"text/javascript; charset=utf-8\", \".json\" => \"application/json\", \".pdf\" => \"application/pdf\", \".png\" => \"image/png\", \".svg\" => \"image/svg+xml\", \".txt\" => \"text/plain; charset=utf-8\", \".xml\" => \"text/xml; charset=utf-8\", \".wasm\" => \"application/wasm\", \".webp\" => \"image/webp\"}","doc":"A limited set of default MIME types.","summary":"<p>A limited set of default MIME types.</p>"}],"doc":"This module implements a global MIME registry.\n\n```\nrequire \"mime\"\n\nMIME.from_extension(\".html\")         # => \"text/html\"\nMIME.from_filename(\"path/file.html\") # => \"text/html\"\n```\n\nThe registry will be populated with some default values (see `DEFAULT_TYPES`)\nas well as the operating system's MIME database.\n\nDefault initialization can be skipped by calling `MIME.init(false)` before the first\nquery to the MIME database.\n\n## OS-provided MIME database\n\nOn a POSIX system, the following files are tried to be read in sequential order,\nstopping at the first existing file. These values override those from `DEFAULT_TYPES`.\n\n```plain\n/etc/mime.types\n/etc/httpd/mime.types                    # Mac OS X\n/etc/httpd/conf/mime.types               # Apache\n/etc/apache/mime.types                   # Apache 1\n/etc/apache2/mime.types                  # Apache 2\n/usr/local/etc/httpd/conf/mime.types\n/usr/local/lib/netscape/mime.types\n/usr/local/etc/httpd/conf/mime.types     # Apache 1.2\n/usr/local/etc/mime.types                # FreeBSD\n/usr/share/misc/mime.types               # OpenBSD\n```\n\n## Registering custom MIME types\n\nApplications can register their own MIME types:\n\n```\nrequire \"mime\"\n\nMIME.from_extension?(\".cr\")     # => nil\nMIME.extensions(\"text/crystal\") # => Set(String).new\n\nMIME.register(\".cr\", \"text/crystal\")\nMIME.from_extension?(\".cr\")     # => \"text/crystal\"\nMIME.extensions(\"text/crystal\") # => Set(String){\".cr\"}\n```\n\n## Loading a custom MIME database\n\nTo load a custom MIME database, `load_mime_database` can be called with an\n`IO` to read the database from.\n\n```\nrequire \"mime\"\n\n# Load user-defined MIME types\nFile.open(\"~/.mime.types\") do |io|\n  MIME.load_mime_database(io)\nend\n```\n\nLoaded values override previously defined mappings.\n\nThe data format must follow the format of `mime.types`: Each line declares\na MIME type followed by a whitespace-separated list of extensions mapped to\nthis type. Everything following a `#` is considered a comment until the end of\nline. Empty lines are ignored.\n\n```plain\ntext/html html htm\n\n# comment\n```","summary":"<p>This module implements a global MIME registry.</p>","class_methods":[{"html_id":"extensions(type:String):Set(String)-class-method","name":"extensions","doc":"Returns all extensions registered for *type*.","summary":"<p>Returns all extensions registered for <em>type</em>.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"String"}],"args_string":"(type : String) : Set(String)","args_html":"(type : <a href=\"String.html\">String</a>) : <a href=\"Set.html\">Set</a>(<a href=\"String.html\">String</a>)","location":{"filename":"src/mime.cr","line_number":238,"url":null},"def":{"name":"extensions","args":[{"name":"type","external_name":"type","restriction":"String"}],"return_type":"Set(String)","visibility":"Public","body":"initialize_types\n@@extensions.fetch(type) do\n  Set(String).new\nend\n"}},{"html_id":"from_extension(extension:String,default):String-class-method","name":"from_extension","doc":"Looks up the MIME type associated with *extension*.\n\nA case-sensitive search is tried first, if this yields no result, it is\nmatched case-insensitive. Returns *default* if *extension* is not registered.","summary":"<p>Looks up the MIME type associated with <em>extension</em>.</p>","abstract":false,"args":[{"name":"extension","external_name":"extension","restriction":"String"},{"name":"default","external_name":"default","restriction":""}],"args_string":"(extension : String, default) : String","args_html":"(extension : <a href=\"String.html\">String</a>, default) : <a href=\"String.html\">String</a>","location":{"filename":"src/mime.cr","line_number":149,"url":null},"def":{"name":"from_extension","args":[{"name":"extension","external_name":"extension","restriction":"String"},{"name":"default","external_name":"default","restriction":""}],"return_type":"String","visibility":"Public","body":"from_extension(extension) do\n  default\nend"}},{"html_id":"from_extension(extension:String):String-class-method","name":"from_extension","doc":"Looks up the MIME type associated with *extension*.\n\nA case-sensitive search is tried first, if this yields no result, it is\nmatched case-insensitive. Raises `KeyError` if *extension* is not registered.","summary":"<p>Looks up the MIME type associated with <em>extension</em>.</p>","abstract":false,"args":[{"name":"extension","external_name":"extension","restriction":"String"}],"args_string":"(extension : String) : String","args_html":"(extension : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/mime.cr","line_number":157,"url":null},"def":{"name":"from_extension","args":[{"name":"extension","external_name":"extension","restriction":"String"}],"return_type":"String","visibility":"Public","body":"from_extension(extension) do\n  raise(KeyError.new(\"Missing MIME type for extension #{extension.inspect}\"))\nend"}},{"html_id":"from_extension(extension:String,&)-class-method","name":"from_extension","doc":"Looks up the MIME type associated with *extension*.\n\nA case-sensitive search is tried first, if this yields no result, it is\nmatched case-insensitive. Runs the given block if *extension* is not registered.","summary":"<p>Looks up the MIME type associated with <em>extension</em>.</p>","abstract":false,"args":[{"name":"extension","external_name":"extension","restriction":"String"}],"args_string":"(extension : String, &)","args_html":"(extension : <a href=\"String.html\">String</a>, &)","location":{"filename":"src/mime.cr","line_number":173,"url":null},"def":{"name":"from_extension","args":[{"name":"extension","external_name":"extension","restriction":"String"}],"yields":1,"visibility":"Public","body":"initialize_types\n@@types.fetch(extension) do\n  @@types_lower.fetch(extension.downcase) do\n    yield extension\n  end\nend\n"}},{"html_id":"from_extension?(extension:String):String?-class-method","name":"from_extension?","doc":"Looks up the MIME type associated with *extension*.\n\nA case-sensitive search is tried first, if this yields no result, it is\nmatched case-insensitive. Returns `nil` if *extension* is not registered.","summary":"<p>Looks up the MIME type associated with <em>extension</em>.</p>","abstract":false,"args":[{"name":"extension","external_name":"extension","restriction":"String"}],"args_string":"(extension : String) : String?","args_html":"(extension : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/mime.cr","line_number":165,"url":null},"def":{"name":"from_extension?","args":[{"name":"extension","external_name":"extension","restriction":"String"}],"return_type":"String | ::Nil","visibility":"Public","body":"from_extension(extension) do\n  nil\nend"}},{"html_id":"from_filename(filename:String|Path,default):String-class-method","name":"from_filename","doc":"Looks up the MIME type associated with the extension in *filename*.\n\nA case-sensitive search is tried first, if this yields no result, it is\nmatched case-insensitive. Returns *default* if extension is not registered.","summary":"<p>Looks up the MIME type associated with the extension in <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String | Path"},{"name":"default","external_name":"default","restriction":""}],"args_string":"(filename : String | Path, default) : String","args_html":"(filename : <a href=\"String.html\">String</a> | <a href=\"Path.html\">Path</a>, default) : <a href=\"String.html\">String</a>","location":{"filename":"src/mime.cr","line_number":183,"url":null},"def":{"name":"from_filename","args":[{"name":"filename","external_name":"filename","restriction":"String | Path"},{"name":"default","external_name":"default","restriction":""}],"return_type":"String","visibility":"Public","body":"from_extension(File.extname(filename.to_s), default)"}},{"html_id":"from_filename(filename:String|Path):String-class-method","name":"from_filename","doc":"Looks up the MIME type associated with the extension in *filename*.\n\nA case-sensitive search is tried first, if this yields no result, it is\nmatched case-insensitive. Raises `KeyError` if extension is not registered.","summary":"<p>Looks up the MIME type associated with the extension in <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String | Path"}],"args_string":"(filename : String | Path) : String","args_html":"(filename : <a href=\"String.html\">String</a> | <a href=\"Path.html\">Path</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/mime.cr","line_number":191,"url":null},"def":{"name":"from_filename","args":[{"name":"filename","external_name":"filename","restriction":"String | Path"}],"return_type":"String","visibility":"Public","body":"from_extension(File.extname(filename.to_s))"}},{"html_id":"from_filename(filename:String|Path,&)-class-method","name":"from_filename","doc":"Looks up the MIME type associated with the extension in *filename*.\n\nA case-sensitive search is tried first, if this yields no result, it is\nmatched case-insensitive. Runs the given block if extension is not registered.","summary":"<p>Looks up the MIME type associated with the extension in <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String | Path"}],"args_string":"(filename : String | Path, &)","args_html":"(filename : <a href=\"String.html\">String</a> | <a href=\"Path.html\">Path</a>, &)","location":{"filename":"src/mime.cr","line_number":207,"url":null},"def":{"name":"from_filename","args":[{"name":"filename","external_name":"filename","restriction":"String | Path"}],"yields":1,"visibility":"Public","body":"from_extension(File.extname(filename.to_s)) do |extension|\n  yield extension\nend"}},{"html_id":"from_filename?(filename:String|Path):String?-class-method","name":"from_filename?","doc":"Looks up the MIME type associated with the extension in *filename*.\n\nA case-sensitive search is tried first, if this yields no result, it is\nmatched case-insensitive. Returns `nil` if extension is not registered.","summary":"<p>Looks up the MIME type associated with the extension in <em>filename</em>.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String | Path"}],"args_string":"(filename : String | Path) : String?","args_html":"(filename : <a href=\"String.html\">String</a> | <a href=\"Path.html\">Path</a>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/mime.cr","line_number":199,"url":null},"def":{"name":"from_filename?","args":[{"name":"filename","external_name":"filename","restriction":"String | Path"}],"return_type":"String | ::Nil","visibility":"Public","body":"from_extension?(File.extname(filename.to_s))"}},{"html_id":"init(load_defaults:Bool=true):Nil-class-method","name":"init","doc":"Initializes the MIME database.\n\nThe default behaviour is to load the internal defaults as well as the OS-provided\nMIME database. This can be disabled with *load_defaults* set to `false`.\n\nThis method usually doesn't need to be called explicitly when the default behaviour is expected.\nIt will be called implicitly with `load_defaults: true` when a query method\nis called and the MIME database has not been initialized before.\n\nCalling this method repeatedly is allowed.","summary":"<p>Initializes the MIME database.</p>","abstract":false,"args":[{"name":"load_defaults","default_value":"true","external_name":"load_defaults","restriction":"Bool"}],"args_string":"(load_defaults : Bool = true) : Nil","args_html":"(load_defaults : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/mime.cr","line_number":115,"url":null},"def":{"name":"init","args":[{"name":"load_defaults","default_value":"true","external_name":"load_defaults","restriction":"Bool"}],"return_type":"Nil","visibility":"Public","body":"@@initialized = true\nif load_defaults\n  DEFAULT_TYPES.each do |ext, type|\n    register(ext, type)\n  end\n  Crystal::System::MIME.load\nend\n"}},{"html_id":"init(filename:String):Nil-class-method","name":"init","doc":"Initializes the MIME database loading contents from a file.\n\nThis will neither load the internal defaults nor the OS-provided MIME database,\nonly the database at *filename* (using `.load_mime_database`).\n\nCalling this method repeatedly is allowed.","summary":"<p>Initializes the MIME database loading contents from a file.</p>","abstract":false,"args":[{"name":"filename","external_name":"filename","restriction":"String"}],"args_string":"(filename : String) : Nil","args_html":"(filename : <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/mime.cr","line_number":133,"url":null},"def":{"name":"init","args":[{"name":"filename","external_name":"filename","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"init(load_defaults: false)\nFile.open(filename, \"r\") do |file|\n  load_mime_database(file)\nend\n"}},{"html_id":"load_mime_database(io:IO):Nil-class-method","name":"load_mime_database","doc":"Reads MIME type mappings from *io* and registers the extension-to-type\nrelation (see `.register`).\n\nThe format follows that of `mime.types`: Each line is list of MIME type and\nzero or more extensions, separated by whitespace.","summary":"<p>Reads MIME type mappings from <em>io</em> and registers the extension-to-type relation (see <code><a href=\"MIME.html#register%28extension%3AString%2Ctype%3AString%29%3ANil-class-method\">.register</a></code>).</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/mime.cr","line_number":280,"url":null},"def":{"name":"load_mime_database","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"while line = io.gets\n  fields = line.split\n  fields.each_with_index do |field, i|\n    extension = field\n    if extension.starts_with?('#')\n      break\n    end\n    if i == 0\n      next\n    end\n    register(\".#{extension}\", fields[0])\n  end\nend"}},{"html_id":"register(extension:String,type:String):Nil-class-method","name":"register","doc":"Register *type* for *extension*.\n\n*extension* must start with a dot (`.`) and must not contain any null bytes.","summary":"<p>Register <em>type</em> for <em>extension</em>.</p>","abstract":false,"args":[{"name":"extension","external_name":"extension","restriction":"String"},{"name":"type","external_name":"type","restriction":"String"}],"args_string":"(extension : String, type : String) : Nil","args_html":"(extension : <a href=\"String.html\">String</a>, type : <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/mime.cr","line_number":214,"url":null},"def":{"name":"register","args":[{"name":"extension","external_name":"extension","restriction":"String"},{"name":"type","external_name":"type","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"if extension.starts_with?('.')\nelse\n  raise(ArgumentError.new(\"Extension does not start with a dot: #{extension.inspect}\"))\nend\nextension.check_no_null_byte\ninitialize_types\nif previous_type = @@types[extension]?\n  if extensions = @@extensions[parse_media_type(previous_type)]?\n    extensions.delete(extension)\n  end\nend\nmediatype = (parse_media_type(type)) || (raise(ArgumentError.new(\"Invalid media type: #{type}\")))\n@@types[extension] = type\n@@types_lower[extension.downcase] = type\ntype_extensions = (__temp_65 = mediatype\n@@extensions[__temp_65]? || (@@extensions[__temp_65] = Set(String).new)\n)\ntype_extensions << extension\n"}}],"types":[{"html_id":"Crystal/MIME/Error","path":"MIME/Error.html","kind":"class","full_name":"MIME::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/mime.cr","line_number":78,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/MIME","kind":"module","full_name":"MIME","name":"MIME"}},{"html_id":"Crystal/MIME/MediaType","path":"MIME/MediaType.html","kind":"struct","full_name":"MIME::MediaType","name":"MediaType","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/mime/media_type.cr","line_number":7,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/MIME","kind":"module","full_name":"MIME","name":"MIME"},"doc":"A `MediaType` describes a MIME content type with optional parameters.","summary":"<p>A <code><a href=\"../MIME/MediaType.html\">MediaType</a></code> describes a MIME content type with optional parameters.</p>","constructors":[{"html_id":"new(media_type,params={}ofString=>String)-class-method","name":"new","doc":"Creates a new `MediaType` instance.","summary":"<p>Creates a new <code><a href=\"../MIME/MediaType.html\">MediaType</a></code> instance.</p>","abstract":false,"args":[{"name":"media_type","external_name":"media_type","restriction":""},{"name":"params","default_value":"{} of String => String","external_name":"params","restriction":""}],"args_string":"(media_type, params = {} of String => String)","args_html":"(media_type, params = {} <span class=\"k\">of</span> <span class=\"t\">String</span> =&gt; <span class=\"t\">String</span>)","location":{"filename":"src/mime/media_type.cr","line_number":11,"url":null},"def":{"name":"new","args":[{"name":"media_type","external_name":"media_type","restriction":""},{"name":"params","default_value":"{} of String => String","external_name":"params","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(media_type, params)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"parse(string:String):MediaType-class-method","name":"parse","doc":"Parses a MIME type string representation including any optional parameters,\nper RFC 1521.\nMedia types are the values in `Content-Type` and `Content-Disposition` HTTP\nheaders (RFC 2183).\n\nMedia type is lowercased and trimmed of whitespace. Param keys are lowercased.\n\nRaises `MIME::Error` on error.","summary":"<p>Parses a MIME type string representation including any optional parameters, per RFC 1521.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String) : MediaType","args_html":"(string : <a href=\"../String.html\">String</a>) : <a href=\"../MIME/MediaType.html\">MediaType</a>","location":{"filename":"src/mime/media_type.cr","line_number":143,"url":null},"def":{"name":"parse","args":[{"name":"string","external_name":"string","restriction":"String"}],"return_type":"MediaType","visibility":"Public","body":"parse_impl(string) do |err|\n  raise(MIME::Error.new(\"Parsing error: #{err} (#{string.dump})\"))\nend"}},{"html_id":"parse?(string:String):MediaType?-class-method","name":"parse?","doc":"Parses a MIME type string representation including any optional parameters,\nper RFC 1521.\nMedia types are the values in `Content-Type` and `Content-Disposition` HTTP\nheaders (RFC 2183).\n\nMedia type is lowercased and trimmed of whitespace. Param keys are lowercased.\n\nReturns `nil` on error.","summary":"<p>Parses a MIME type string representation including any optional parameters, per RFC 1521.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String) : MediaType?","args_html":"(string : <a href=\"../String.html\">String</a>) : <a href=\"../MIME/MediaType.html\">MediaType</a>?","location":{"filename":"src/mime/media_type.cr","line_number":155,"url":null},"def":{"name":"parse?","args":[{"name":"string","external_name":"string","restriction":"String"}],"return_type":"MediaType | ::Nil","visibility":"Public","body":"parse_impl(string) do\n  return nil\nend"}}],"instance_methods":[{"html_id":"[](key:String):String-instance-method","name":"[]","doc":"Returns the value for the parameter given by *key*. If not found, raises `KeyError`.\n\n```\nrequire \"mime/media_type\"\n\nMIME::MediaType.parse(\"text/plain; charset=UTF-8\")[\"charset\"] # => \"UTF-8\"\nMIME::MediaType.parse(\"text/plain; charset=UTF-8\")[\"foo\"]     # raises KeyError\n```","summary":"<p>Returns the value for the parameter given by <em>key</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String) : String","args_html":"(key : <a href=\"../String.html\">String</a>) : <a href=\"../String.html\">String</a>","location":{"filename":"src/mime/media_type.cr","line_number":42,"url":null},"def":{"name":"[]","args":[{"name":"key","external_name":"key","restriction":"String"}],"return_type":"String","visibility":"Public","body":"@params[key]"}},{"html_id":"[]=(key:String,value:String)-instance-method","name":"[]=","doc":"Sets the value of parameter *key* to the given value.\n\n```\nrequire \"mime/media_type\"\n\nmime_type = MIME::MediaType.parse(\"x-application/example\")\nmime_type[\"foo\"] = \"bar\"\nmime_type[\"foo\"] # => \"bar\"\n```","summary":"<p>Sets the value of parameter <em>key</em> to the given value.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"},{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(key : String, value : String)","args_html":"(key : <a href=\"../String.html\">String</a>, value : <a href=\"../String.html\">String</a>)","location":{"filename":"src/mime/media_type.cr","line_number":67,"url":null},"def":{"name":"[]=","args":[{"name":"key","external_name":"key","restriction":"String"},{"name":"value","external_name":"value","restriction":"String"}],"visibility":"Public","body":"if MIME::MediaType.token?(key)\nelse\n  raise(Error.new(\"Invalid parameter name\"))\nend\n@params[key] = value\n"}},{"html_id":"[]?(key:String):String?-instance-method","name":"[]?","doc":"Returns the value for the parameter given by *key*. If not found, returns `nil`.\n\n```\nrequire \"mime/media_type\"\n\nMIME::MediaType.parse(\"text/plain; charset=UTF-8\")[\"charset\"]? # => \"UTF-8\"\nMIME::MediaType.parse(\"text/plain; charset=UTF-8\")[\"foo\"]?     # => nil\n```","summary":"<p>Returns the value for the parameter given by <em>key</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String) : String?","args_html":"(key : <a href=\"../String.html\">String</a>) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/mime/media_type.cr","line_number":54,"url":null},"def":{"name":"[]?","args":[{"name":"key","external_name":"key","restriction":"String"}],"return_type":"String | ::Nil","visibility":"Public","body":"@params[key]?"}},{"html_id":"each_parameter(&block:String,String->_):Nil-instance-method","name":"each_parameter","doc":"Calls the given block for each parameter and passes in the key and the value.","summary":"<p>Calls the given block for each parameter and passes in the key and the value.</p>","abstract":false,"location":{"filename":"src/mime/media_type.cr","line_number":97,"url":null},"def":{"name":"each_parameter","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(String, String -> _)"},"return_type":"Nil","visibility":"Public","body":"@params.each do |key, value|\n  yield key, value\nend"}},{"html_id":"each_parameter:Iterator(Tuple(String,String))-instance-method","name":"each_parameter","doc":"Returns an iterator over the parameter which behaves like an `Iterator` returning a `Tuple` of key and value.","summary":"<p>Returns an iterator over the parameter which behaves like an <code><a href=\"../Iterator.html\">Iterator</a></code> returning a <code><a href=\"../Tuple.html\">Tuple</a></code> of key and value.</p>","abstract":false,"location":{"filename":"src/mime/media_type.cr","line_number":104,"url":null},"def":{"name":"each_parameter","return_type":"Iterator(Tuple(String, String))","visibility":"Public","body":"@params.each"}},{"html_id":"fetch(key:String,default:T):String|TforallT-instance-method","name":"fetch","doc":"Returns the value for the parameter given by *key*, or when not found the value given by *default*.\n\n```\nrequire \"mime/media_type\"\n\nMIME::MediaType.parse(\"x-application/example\").fetch(\"foo\", \"baz\")          # => \"baz\"\nMIME::MediaType.parse(\"x-application/example; foo=bar\").fetch(\"foo\", \"baz\") # => \"bar\"\n```","summary":"<p>Returns the value for the parameter given by <em>key</em>, or when not found the value given by <em>default</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"},{"name":"default","external_name":"default","restriction":"T"}],"args_string":"(key : String, default : T) : String | T forall T","args_html":"(key : <a href=\"../String.html\">String</a>, default : T) : <a href=\"../String.html\">String</a> | T forall T","location":{"filename":"src/mime/media_type.cr","line_number":80,"url":null},"def":{"name":"fetch","args":[{"name":"key","external_name":"key","restriction":"String"},{"name":"default","external_name":"default","restriction":"T"}],"return_type":"String | T","visibility":"Public","body":"@params.fetch(key, default)"}},{"html_id":"fetch(key:String,&block:String->_)-instance-method","name":"fetch","doc":"Returns the value for the parameter given by *key*, or when not found calls the given block with the *key*.\n\n```\nrequire \"mime/media_type\"\n\nMIME::MediaType.parse(\"x-application/example\").fetch(\"foo\") { |key| key }          # => \"foo\"\nMIME::MediaType.parse(\"x-application/example; foo=bar\").fetch(\"foo\") { |key| key } # => \"bar\"\n```","summary":"<p>Returns the value for the parameter given by <em>key</em>, or when not found calls the given block with the <em>key</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String, &block : String -> _)","args_html":"(key : <a href=\"../String.html\">String</a>, &block : <a href=\"../String.html\">String</a> -> _)","location":{"filename":"src/mime/media_type.cr","line_number":92,"url":null},"def":{"name":"fetch","args":[{"name":"key","external_name":"key","restriction":"String"}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(String -> _)"},"visibility":"Public","body":"@params.fetch(key) do |key|\n  yield key\nend"}},{"html_id":"media_type:String-instance-method","name":"media_type","abstract":false,"location":{"filename":"src/mime/media_type.cr","line_number":8,"url":null},"def":{"name":"media_type","return_type":"String","visibility":"Public","body":"@media_type"}},{"html_id":"sub_type:String?-instance-method","name":"sub_type","doc":"Second component of `media_type` or `nil`.\n\n```\nrequire \"mime/media_type\"\n\nMIME::MediaType.new(\"text/plain\").sub_type # => \"plain\"\nMIME::MediaType.new(\"foo\").sub_type        # => nil\n```","summary":"<p>Second component of <code><a href=\"../MIME/MediaType.html#media_type%3AString-instance-method\">#media_type</a></code> or <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/mime/media_type.cr","line_number":130,"url":null},"def":{"name":"sub_type","return_type":"String | ::Nil","visibility":"Public","body":"index = (media_type.byte_index('/'.ord)) || (return)\nmedia_type.byte_slice(index + 1, (media_type.bytesize - index) - 1)\n"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Same as `#inspect(io)`.","summary":"<p>Same as <code>#inspect(io)</code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/mime/media_type.cr","line_number":17,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << media_type\n@params.each do |key, value|\n  io << \"; \"\n  (io << key.downcase) << '='\n  if MIME::MediaType.token?(value)\n    io << value\n  else\n    io << '\"'\n    MIME::MediaType.quote_string(value, io)\n    io << '\"'\n  end\nend\n"}},{"html_id":"type:String-instance-method","name":"type","doc":"First component of `media_type`.\n\n```\nrequire \"mime/media_type\"\n\nMIME::MediaType.new(\"text/plain\").type # => \"text\"\nMIME::MediaType.new(\"foo\").type        # => \"foo\"\n```\n","summary":"<p>First component of <code><a href=\"../MIME/MediaType.html#media_type%3AString-instance-method\">#media_type</a></code>.</p>","abstract":false,"location":{"filename":"src/mime/media_type.cr","line_number":117,"url":null},"def":{"name":"type","return_type":"String","visibility":"Public","body":"index = (media_type.byte_index('/'.ord)) || media_type.bytesize\nmedia_type.byte_slice(0, index)\n"}}]},{"html_id":"Crystal/MIME/Multipart","path":"MIME/Multipart.html","kind":"module","full_name":"MIME::Multipart","name":"Multipart","abstract":false,"locations":[{"filename":"src/mime/multipart.cr","line_number":9,"url":null},{"filename":"src/mime/multipart/builder.cr","line_number":1,"url":null},{"filename":"src/mime/multipart/parser.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/MIME","kind":"module","full_name":"MIME","name":"MIME"},"doc":"The `MIME::Multipart` module contains utilities for parsing MIME multipart\nmessages, which contain multiple body parts, each containing a header section\nand binary body. The `multipart/form-data` content-type has a separate set of\nutilities in the `HTTP::FormData` module.","summary":"<p>The <code><a href=\"../MIME/Multipart.html\">MIME::Multipart</a></code> module contains utilities for parsing MIME multipart messages, which contain multiple body parts, each containing a header section and binary body.</p>","class_methods":[{"html_id":"build(io:IO,boundary:String=Multipart.generate_boundary,&)-class-method","name":"build","doc":"Yields a `Multipart::Builder` to the given block, writing to *io* and\nusing *boundary*. `#finish` is automatically called on the builder.","summary":"<p>Yields a <code><a href=\"../MIME/Multipart/Builder.html\">Multipart::Builder</a></code> to the given block, writing to <em>io</em> and using <em>boundary</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"boundary","default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":"String"}],"args_string":"(io : IO, boundary : String = Multipart.generate_boundary, &)","args_html":"(io : <a href=\"../IO.html\">IO</a>, boundary : <a href=\"../String.html\">String</a> = <span class=\"t\">Multipart</span>.generate_boundary, &)","location":{"filename":"src/mime/multipart.cr","line_number":82,"url":null},"def":{"name":"build","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"boundary","default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":"String"}],"yields":1,"visibility":"Public","body":"builder = Builder.new(io, boundary)\nyield builder\nbuilder.finish\n"}},{"html_id":"build(boundary:String=Multipart.generate_boundary,&)-class-method","name":"build","doc":"Yields a `Multipart::Builder` to the given block, returning the generated\nmessage as a `String`.","summary":"<p>Yields a <code><a href=\"../MIME/Multipart/Builder.html\">Multipart::Builder</a></code> to the given block, returning the generated message as a <code><a href=\"../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"boundary","default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":"String"}],"args_string":"(boundary : String = Multipart.generate_boundary, &)","args_html":"(boundary : <a href=\"../String.html\">String</a> = <span class=\"t\">Multipart</span>.generate_boundary, &)","location":{"filename":"src/mime/multipart.cr","line_number":90,"url":null},"def":{"name":"build","args":[{"name":"boundary","default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":"String"}],"yields":1,"visibility":"Public","body":"String.build do |io|\n  build(io, boundary) do |g|\n    yield g\n  end\nend"}},{"html_id":"generate_boundary:String-class-method","name":"generate_boundary","doc":"Returns a unique string suitable for use as a multipart boundary.\n\n```\nrequire \"mime/multipart\"\n\nMIME::Multipart.generate_boundary # => \"---------------------------dQu6bXHYb4m5zrRC3xPTGwV\"\n```","summary":"<p>Returns a unique string suitable for use as a multipart boundary.</p>","abstract":false,"location":{"filename":"src/mime/multipart.cr","line_number":103,"url":null},"def":{"name":"generate_boundary","return_type":"String","visibility":"Public","body":"\"--------------------------#{Random::Secure.urlsafe_base64(18)}\""}},{"html_id":"parse(io,boundary,&)-class-method","name":"parse","doc":"Parses a MIME multipart message, yielding `HTTP::Headers` and an `IO` for\neach body part.\n\nPlease note that the IO object yielded to the block is only valid while the\nblock is executing. The IO is closed as soon as the supplied block returns.\n\n```\nrequire \"mime/multipart\"\n\nmultipart = \"--aA40\\r\\nContent-Type: text/plain\\r\\n\\r\\nbody\\r\\n--aA40--\"\nMIME::Multipart.parse(IO::Memory.new(multipart), \"aA40\") do |headers, io|\n  headers[\"Content-Type\"] # => \"text/plain\"\n  io.gets_to_end          # => \"body\"\nend\n```\n\nSee: `Multipart::Parser`","summary":"<p>Parses a MIME multipart message, yielding <code><a href=\"../HTTP/Headers.html\">HTTP::Headers</a></code> and an <code><a href=\"../IO.html\">IO</a></code> for each body part.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"boundary","external_name":"boundary","restriction":""}],"args_string":"(io, boundary, &)","args_html":"(io, boundary, &)","location":{"filename":"src/mime/multipart.cr","line_number":27,"url":null},"def":{"name":"parse","args":[{"name":"io","external_name":"io","restriction":""},{"name":"boundary","external_name":"boundary","restriction":""}],"yields":2,"visibility":"Public","body":"parser = Parser.new(io, boundary)\nwhile parser.has_next?\n  parser.next do |headers, io|\n    yield headers, io\n  end\nend\n"}},{"html_id":"parse(request:HTTP::Request,&)-class-method","name":"parse","doc":"Parses a MIME multipart message, yielding `HTTP::Headers` and an `IO` for\neach body part.\n\nPlease note that the IO object yielded to the block is only valid while the\nblock is executing. The IO is closed as soon as the supplied block returns.\n\n```\nrequire \"http\"\nrequire \"mime/multipart\"\n\nheaders = HTTP::Headers{\"Content-Type\" => \"multipart/mixed; boundary=aA40\"}\nbody = \"--aA40\\r\\nContent-Type: text/plain\\r\\n\\r\\nbody\\r\\n--aA40--\"\nrequest = HTTP::Request.new(\"POST\", \"/\", headers, body)\n\nMIME::Multipart.parse(request) do |headers, io|\n  headers[\"Content-Type\"] # => \"text/plain\"\n  io.gets_to_end          # => \"body\"\nend\n```\n\nSee: `Multipart::Parser`","summary":"<p>Parses a MIME multipart message, yielding <code><a href=\"../HTTP/Headers.html\">HTTP::Headers</a></code> and an <code><a href=\"../IO.html\">IO</a></code> for each body part.</p>","abstract":false,"args":[{"name":"request","external_name":"request","restriction":"HTTP::Request"}],"args_string":"(request : HTTP::Request, &)","args_html":"(request : <a href=\"../HTTP/Request.html\">HTTP::Request</a>, &)","location":{"filename":"src/mime/multipart.cr","line_number":71,"url":null},"def":{"name":"parse","args":[{"name":"request","external_name":"request","restriction":"HTTP::Request"}],"yields":2,"visibility":"Public","body":"boundary = parse_boundary(request.headers[\"Content-Type\"])\nif boundary\nelse\n  return nil\nend\nbody = request.body\nif body\nelse\n  return nil\nend\nparse(body, boundary) do |headers, io|\n  yield headers, io\nend\n"}},{"html_id":"parse_boundary(content_type):String?-class-method","name":"parse_boundary","doc":"Extracts the multipart boundary from the Content-Type header. May return\n`nil` is the boundary was not found.\n\n```\nrequire \"mime/multipart\"\n\nMIME::Multipart.parse_boundary(\"multipart/mixed; boundary=\\\"abcde\\\"\") # => \"abcde\"\n```","summary":"<p>Extracts the multipart boundary from the Content-Type header.</p>","abstract":false,"args":[{"name":"content_type","external_name":"content_type","restriction":""}],"args_string":"(content_type) : String?","args_html":"(content_type) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/mime/multipart.cr","line_number":42,"url":null},"def":{"name":"parse_boundary","args":[{"name":"content_type","external_name":"content_type","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"type = MIME::MediaType.parse?(content_type)\nif type && (type.type == \"multipart\")\n  type[\"boundary\"]?.presence\nend\n"}}],"types":[{"html_id":"Crystal/MIME/Multipart/Builder","path":"MIME/Multipart/Builder.html","kind":"class","full_name":"MIME::Multipart::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/mime/multipart/builder.cr","line_number":15,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/MIME/Multipart","kind":"module","full_name":"MIME::Multipart","name":"Multipart"},"doc":"Builds a multipart MIME message.\n\n### Example\n\n```\nrequire \"mime/multipart\"\n\nio = IO::Memory.new # This is a stub. Actually, any IO can be used.\nmultipart = MIME::Multipart::Builder.new(io)\nmultipart.body_part HTTP::Headers{\"Content-Type\" => \"text/plain\"}, \"hello!\"\nmultipart.finish\nio.to_s # => \"----------------------------DTf61dRTHYzprx7rwVQhTWr7\\r\\nContent-Type: text/plain\\r\\n\\r\\nhello!\\r\\n----------------------------DTf61dRTHYzprx7rwVQhTWr7--\"\n```","summary":"<p>Builds a multipart MIME message.</p>","constructors":[{"html_id":"new(io:IO,boundary=Multipart.generate_boundary)-class-method","name":"new","doc":"Creates a new `Multipart::Builder` which writes the generated multipart\nmessage to *io*, using the multipart boundary *boundary*.","summary":"<p>Creates a new <code><a href=\"../../MIME/Multipart/Builder.html\">Multipart::Builder</a></code> which writes the generated multipart message to <em>io</em>, using the multipart boundary <em>boundary</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"boundary","default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":""}],"args_string":"(io : IO, boundary = Multipart.generate_boundary)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, boundary = <span class=\"t\">Multipart</span>.generate_boundary)","location":{"filename":"src/mime/multipart/builder.cr","line_number":18,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"boundary","default_value":"Multipart.generate_boundary","external_name":"boundary","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, boundary)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"body_part(headers:HTTP::Headers,string:String):Nil-instance-method","name":"body_part","doc":"Appends a body part to the multipart message with the given *headers*\nand *string*. Throws if `#finish` or `#epilogue` is called before this\nmethod.","summary":"<p>Appends a body part to the multipart message with the given <em>headers</em> and <em>string</em>.</p>","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":"HTTP::Headers"},{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(headers : HTTP::Headers, string : String) : Nil","args_html":"(headers : <a href=\"../../HTTP/Headers.html\">HTTP::Headers</a>, string : <a href=\"../../String.html\">String</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/mime/multipart/builder.cr","line_number":77,"url":null},"def":{"name":"body_part","args":[{"name":"headers","external_name":"headers","restriction":"HTTP::Headers"},{"name":"string","external_name":"string","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"body_part_impl(headers) do |io|\n  string.to_s(io)\nend"}},{"html_id":"body_part(headers:HTTP::Headers,data:Bytes):Nil-instance-method","name":"body_part","doc":"Appends a body part to the multipart message with the given *headers*\nand *data*. Throws if `#finish` or `#epilogue` is called before this\nmethod.","summary":"<p>Appends a body part to the multipart message with the given <em>headers</em> and <em>data</em>.</p>","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":"HTTP::Headers"},{"name":"data","external_name":"data","restriction":"Bytes"}],"args_string":"(headers : HTTP::Headers, data : Bytes) : Nil","args_html":"(headers : <a href=\"../../HTTP/Headers.html\">HTTP::Headers</a>, data : <a href=\"../../Bytes.html\">Bytes</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/mime/multipart/builder.cr","line_number":84,"url":null},"def":{"name":"body_part","args":[{"name":"headers","external_name":"headers","restriction":"HTTP::Headers"},{"name":"data","external_name":"data","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"body_part_impl(headers) do |io|\n  io.write(data)\nend"}},{"html_id":"body_part(headers:HTTP::Headers,body_io:IO):Nil-instance-method","name":"body_part","doc":"Appends a body part to the multipart message with the given *headers*\nand data from *body_io*. Throws if `#finish` or `#epilogue` is called\nbefore this method.","summary":"<p>Appends a body part to the multipart message with the given <em>headers</em> and data from <em>body_io</em>.</p>","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":"HTTP::Headers"},{"name":"body_io","external_name":"body_io","restriction":"IO"}],"args_string":"(headers : HTTP::Headers, body_io : IO) : Nil","args_html":"(headers : <a href=\"../../HTTP/Headers.html\">HTTP::Headers</a>, body_io : <a href=\"../../IO.html\">IO</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/mime/multipart/builder.cr","line_number":91,"url":null},"def":{"name":"body_part","args":[{"name":"headers","external_name":"headers","restriction":"HTTP::Headers"},{"name":"body_io","external_name":"body_io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"body_part_impl(headers) do |io|\n  IO.copy(body_io, io)\nend"}},{"html_id":"body_part(headers:HTTP::Headers,&)-instance-method","name":"body_part","doc":"Yields an IO that can be used to write to a body part which is appended\nto the multipart message with the given *headers*. Throws if `#finish` or\n`#epilogue` is called before this method.","summary":"<p>Yields an IO that can be used to write to a body part which is appended to the multipart message with the given <em>headers</em>.</p>","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":"HTTP::Headers"}],"args_string":"(headers : HTTP::Headers, &)","args_html":"(headers : <a href=\"../../HTTP/Headers.html\">HTTP::Headers</a>, &)","location":{"filename":"src/mime/multipart/builder.cr","line_number":98,"url":null},"def":{"name":"body_part","args":[{"name":"headers","external_name":"headers","restriction":"HTTP::Headers"}],"yields":1,"visibility":"Public","body":"body_part_impl(headers) do |io|\n  yield io\nend"}},{"html_id":"body_part(headers:HTTP::Headers):Nil-instance-method","name":"body_part","doc":"Appends a body part to the multipart message with the given *headers*\nand no body data. Throws is `#finish` or `#epilogue` is called before\nthis method.","summary":"<p>Appends a body part to the multipart message with the given <em>headers</em> and no body data.</p>","abstract":false,"args":[{"name":"headers","external_name":"headers","restriction":"HTTP::Headers"}],"args_string":"(headers : HTTP::Headers) : Nil","args_html":"(headers : <a href=\"../../HTTP/Headers.html\">HTTP::Headers</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/mime/multipart/builder.cr","line_number":105,"url":null},"def":{"name":"body_part","args":[{"name":"headers","external_name":"headers","restriction":"HTTP::Headers"}],"return_type":"Nil","visibility":"Public","body":"body_part_impl(headers, empty: true) do\nend"}},{"html_id":"boundary:String-instance-method","name":"boundary","abstract":false,"location":{"filename":"src/mime/multipart/builder.cr","line_number":22,"url":null},"def":{"name":"boundary","visibility":"Public","body":"@boundary"}},{"html_id":"content_type(subtype=\"mixed\"):String-instance-method","name":"content_type","doc":"Returns a content type header with multipart subtype *subtype*, and\nboundary parameter added.\n\n```\nrequire \"mime/multipart\"\n\nio = IO::Memory.new # This is a stub. Actually, any IO can be used.\nbuilder = MIME::Multipart::Builder.new(io, \"a4VF\")\nbuilder.content_type(\"mixed\") # => \"multipart/mixed; boundary=a4VF\"\n```","summary":"<p>Returns a content type header with multipart subtype <em>subtype</em>, and boundary parameter added.</p>","abstract":false,"args":[{"name":"subtype","default_value":"\"mixed\"","external_name":"subtype","restriction":""}],"args_string":"(subtype = \"mixed\") : String","args_html":"(subtype = <span class=\"s\">&quot;mixed&quot;</span>) : <a href=\"../../String.html\">String</a>","location":{"filename":"src/mime/multipart/builder.cr","line_number":36,"url":null},"def":{"name":"content_type","args":[{"name":"subtype","default_value":"\"mixed\"","external_name":"subtype","restriction":""}],"return_type":"String","visibility":"Public","body":"(MIME::MediaType.new(\"multipart/#{subtype}\", {\"boundary\" => @boundary})).to_s"}},{"html_id":"epilogue(string:String):Nil-instance-method","name":"epilogue","doc":"Appends *string* to the epilogue segment of the multipart message. Throws\nif `#finish` is called before this method, or no body parts have been\nappended.\n\nCan be called multiple times to append to the epilogue multiple times.","summary":"<p>Appends <em>string</em> to the epilogue segment of the multipart message.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String) : Nil","args_html":"(string : <a href=\"../../String.html\">String</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/mime/multipart/builder.cr","line_number":134,"url":null},"def":{"name":"epilogue","args":[{"name":"string","external_name":"string","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"epilogue do |io|\n  string.to_s(io)\nend"}},{"html_id":"epilogue(data:Bytes):Nil-instance-method","name":"epilogue","doc":"Appends *data* to the epilogue segment of the multipart message. Throws\nif `#finish` is called before this method, or no body parts have been\nappended.\n\nCan be called multiple times to append to the epilogue multiple times.","summary":"<p>Appends <em>data</em> to the epilogue segment of the multipart message.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":"Bytes"}],"args_string":"(data : Bytes) : Nil","args_html":"(data : <a href=\"../../Bytes.html\">Bytes</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/mime/multipart/builder.cr","line_number":143,"url":null},"def":{"name":"epilogue","args":[{"name":"data","external_name":"data","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"epilogue do |io|\n  io.write(data)\nend"}},{"html_id":"epilogue(epilogue_io:IO):Nil-instance-method","name":"epilogue","doc":"Appends *preamble_io* to the epilogue segment of the multipart message.\nThrows if `#finish` is called before this method, or no body parts have\nbeen appended.\n\nCan be called multiple times to append to the epilogue multiple times.","summary":"<p>Appends <em>preamble_io</em> to the epilogue segment of the multipart message.</p>","abstract":false,"args":[{"name":"epilogue_io","external_name":"epilogue_io","restriction":"IO"}],"args_string":"(epilogue_io : IO) : Nil","args_html":"(epilogue_io : <a href=\"../../IO.html\">IO</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/mime/multipart/builder.cr","line_number":152,"url":null},"def":{"name":"epilogue","args":[{"name":"epilogue_io","external_name":"epilogue_io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"epilogue do |io|\n  IO.copy(epilogue_io, io)\nend"}},{"html_id":"epilogue(&)-instance-method","name":"epilogue","doc":"Yields an IO that can be used to append to the epilogue of the multipart\nmessage. Throws if `#finish` is called before this method, or no body\nparts have been appended.\n\nCan be called multiple times to append to the preamble multiple times.","summary":"<p>Yields an IO that can be used to append to the epilogue of the multipart message.</p>","abstract":false,"location":{"filename":"src/mime/multipart/builder.cr","line_number":161,"url":null},"def":{"name":"epilogue","yields":1,"visibility":"Public","body":"if @state == (:FINISHED)\n  fail(\"Cannot generate epilogue: already finished\")\nend\nif (@state == (:START)) || (@state == (:PREAMBLE))\n  fail(\"Cannot generate epilogue: no body parts\")\nend\nif @state != (:EPILOGUE)\n  ((@io << \"\\r\\n--\") << @boundary) << \"--\\r\\n\"\nend\nyield @io\n@state = :EPILOGUE\n"}},{"html_id":"finish:Nil-instance-method","name":"finish","doc":"Finalizes the multipart message, this method must be called to properly\nend the multipart message.","summary":"<p>Finalizes the multipart message, this method must be called to properly end the multipart message.</p>","abstract":false,"location":{"filename":"src/mime/multipart/builder.cr","line_number":177,"url":null},"def":{"name":"finish","return_type":"Nil","visibility":"Public","body":"if (@state == (:START)) || (@state == (:PREAMBLE))\n  fail(\"Cannot finish multipart: no body parts\")\nend\nif @state == (:FINISHED)\n  fail(\"Cannot finish multipart: already finished\")\nend\nif @state == (:BODY_PART)\n  ((@io << \"\\r\\n--\") << @boundary) << \"--\"\nend\n@state = :FINISHED\n@io.flush\n"}},{"html_id":"preamble(string:String):Nil-instance-method","name":"preamble","doc":"Appends *string* to the preamble segment of the multipart message. Throws\nif `#body_part` is called before this method.\n\nCan be called multiple times to append to the preamble multiple times.","summary":"<p>Appends <em>string</em> to the preamble segment of the multipart message.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String) : Nil","args_html":"(string : <a href=\"../../String.html\">String</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/mime/multipart/builder.cr","line_number":44,"url":null},"def":{"name":"preamble","args":[{"name":"string","external_name":"string","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"preamble do |io|\n  string.to_s(io)\nend"}},{"html_id":"preamble(data:Bytes):Nil-instance-method","name":"preamble","doc":"Appends *data* to the preamble segment of the multipart message. Throws\nif `#body_part` is called before this method.\n\nCan be called multiple times to append to the preamble multiple times.","summary":"<p>Appends <em>data</em> to the preamble segment of the multipart message.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":"Bytes"}],"args_string":"(data : Bytes) : Nil","args_html":"(data : <a href=\"../../Bytes.html\">Bytes</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/mime/multipart/builder.cr","line_number":52,"url":null},"def":{"name":"preamble","args":[{"name":"data","external_name":"data","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"preamble do |io|\n  io.write(data)\nend"}},{"html_id":"preamble(preamble_io:IO):Nil-instance-method","name":"preamble","doc":"Appends *preamble_io* to the preamble segment of the multipart message.\nThrows if `#body_part` is called before this method.\n\nCan be called multiple times to append to the preamble multiple times.","summary":"<p>Appends <em>preamble_io</em> to the preamble segment of the multipart message.</p>","abstract":false,"args":[{"name":"preamble_io","external_name":"preamble_io","restriction":"IO"}],"args_string":"(preamble_io : IO) : Nil","args_html":"(preamble_io : <a href=\"../../IO.html\">IO</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/mime/multipart/builder.cr","line_number":60,"url":null},"def":{"name":"preamble","args":[{"name":"preamble_io","external_name":"preamble_io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"preamble do |io|\n  IO.copy(preamble_io, io)\nend"}},{"html_id":"preamble(&)-instance-method","name":"preamble","doc":"Yields an IO that can be used to append to the preamble of the multipart\nmessage. Throws if `#body_part` is called before this method.\n\nCan be called multiple times to append to the preamble multiple times.","summary":"<p>Yields an IO that can be used to append to the preamble of the multipart message.</p>","abstract":false,"location":{"filename":"src/mime/multipart/builder.cr","line_number":68,"url":null},"def":{"name":"preamble","yields":1,"visibility":"Public","body":"if (@state != (:START)) && (@state != (:PREAMBLE))\n  fail(\"Cannot generate preamble: body already started\")\nend\nyield @io\n@state = :PREAMBLE\n"}}]},{"html_id":"Crystal/MIME/Multipart/Error","path":"MIME/Multipart/Error.html","kind":"class","full_name":"MIME::Multipart::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/mime/multipart.cr","line_number":107,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/MIME/Multipart","kind":"module","full_name":"MIME::Multipart","name":"Multipart"}},{"html_id":"Crystal/MIME/Multipart/Parser","path":"MIME/Multipart/Parser.html","kind":"class","full_name":"MIME::Multipart::Parser","name":"Parser","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/mime/multipart/parser.cr","line_number":22,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/MIME/Multipart","kind":"module","full_name":"MIME::Multipart","name":"Multipart"},"doc":"Parses multipart MIME messages.\n\n### Example\n\n```\nrequire \"mime/multipart\"\n\nmultipart = \"--aA40\\r\\nContent-Type: text/plain\\r\\n\\r\\nbody\\r\\n--aA40--\"\nparser = MIME::Multipart::Parser.new(IO::Memory.new(multipart), \"aA40\")\n\nwhile parser.has_next?\n  parser.next do |headers, io|\n    headers[\"Content-Type\"] # => \"text/plain\"\n    io.gets_to_end          # => \"body\"\n  end\nend\n```\n\nPlease note that the IO object yielded by `#next` is only valid until the\nblock returns.","summary":"<p>Parses multipart MIME messages.</p>","constructors":[{"html_id":"new(io:IO,boundary:String)-class-method","name":"new","doc":"Creates a new `Multipart::Parser` which parses *io* with multipart\nboundary *boundary*.","summary":"<p>Creates a new <code><a href=\"../../MIME/Multipart/Parser.html\">Multipart::Parser</a></code> which parses <em>io</em> with multipart boundary <em>boundary</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"boundary","external_name":"boundary","restriction":"String"}],"args_string":"(io : IO, boundary : String)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, boundary : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/mime/multipart/parser.cr","line_number":25,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"boundary","external_name":"boundary","restriction":"String"}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, boundary)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"has_next?:Bool-instance-method","name":"has_next?","doc":"True if `#next` can be called legally.","summary":"<p>True if <code><a href=\"../../MIME/Multipart/Parser.html#next%28%26%29-instance-method\">#next</a></code> can be called legally.</p>","abstract":false,"location":{"filename":"src/mime/multipart/parser.cr","line_number":82,"url":null},"def":{"name":"has_next?","return_type":"Bool","visibility":"Public","body":"(@state != (:FINISHED)) && (@state != (:ERRORED))"}},{"html_id":"next(&)-instance-method","name":"next","doc":"Parses the next body part and yields headers as `HTTP::Headers` and the\nbody text as an `IO`.\n\nThis method yields once instead of returning the values, because the IO\nobject yielded to the block is only valid while the block is executing.\nThe IO object will be closed as soon as the block returns. To store the\ncontent of the body part for longer than the block, the IO must be read\ninto memory.\n\n```\nrequire \"mime/multipart\"\n\nmultipart = \"--aA40\\r\\nContent-Type: text/plain\\r\\n\\r\\nbody\\r\\n--aA40--\"\nparser = MIME::Multipart::Parser.new(IO::Memory.new(multipart), \"aA40\")\nparser.next do |headers, io|\n  headers[\"Content-Type\"] # => \"text/plain\"\n  io.gets_to_end          # => \"body\"\nend\n```","summary":"<p>Parses the next body part and yields headers as <code><a href=\"../../HTTP/Headers.html\">HTTP::Headers</a></code> and the body text as an <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/mime/multipart/parser.cr","line_number":50,"url":null},"def":{"name":"next","yields":2,"visibility":"Public","body":"begin\n  if @state == (:FINISHED)\n    raise(Multipart::Error.new(\"Multipart parser already finished parsing\"))\n  end\n  if @state == (:ERRORED)\n    raise(Multipart::Error.new(\"Multipart parser is in an errored state\"))\n  end\n  if @state == (:PREAMBLE)\n    preamble_io = IO::Delimited.new(@io, read_delimiter: @dash_boundary)\n    preamble_io.skip_to_end\n    if close_delimiter?\n      fail(\"no parts\")\n    end\n    @state = :PART_START\n  end\n  if @state == (:PART_START)\n    body_io = IO::Delimited.new(@io, read_delimiter: @delimiter)\n    headers = parse_headers(body_io)\n    begin\n      yield headers, body_io\n    ensure\n      body_io.skip_to_end\n      body_io.close\n      if close_delimiter?\n        @state = :FINISHED\n      end\n    end\n  end\nrescue ex\n  @state = :ERRORED\n  raise(ex)\nend"}}]}]}]},{"html_id":"Crystal/Mutex","path":"Mutex.html","kind":"class","full_name":"Mutex","name":"Mutex","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/mutex.cr","line_number":18,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"A fiber-safe mutex.\n\nProvides deadlock protection by default. Attempting to re-lock the mutex from\nthe same fiber will raise an exception. Trying to unlock an unlocked mutex, or\na mutex locked by another fiber will raise an exception.\n\nThe reentrant protection maintains a lock count. Attempting to re-lock the\nmutex from the same fiber will increment the lock count. Attempting to unlock\nthe counter from the same fiber will decrement the lock count, eventually\nreleasing the lock when the lock count returns to 0. Attempting to unlock an\nunlocked mutex, or a mutex locked by another fiber will raise an exception.\n\nYou also disable all protections with `unchecked`. Attempting to re-lock the\nmutex from the same fiber will deadlock. Any fiber can unlock the mutex, even\nif it wasn't previously locked.","summary":"<p>A fiber-safe mutex.</p>","constructors":[{"html_id":"new(protection:Protection=:checked)-class-method","name":"new","abstract":false,"args":[{"name":"protection","default_value":":checked","external_name":"protection","restriction":"Protection"}],"args_string":"(protection : Protection = :checked)","args_html":"(protection : <a href=\"Mutex/Protection.html\">Protection</a> = <span class=\"n\">:checked</span>)","location":{"filename":"src/mutex.cr","line_number":32,"url":null},"def":{"name":"new","args":[{"name":"protection","default_value":":checked","external_name":"protection","restriction":"Protection"}],"visibility":"Public","body":"_ = allocate\n_.initialize(protection)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"lock:Nil-instance-method","name":"lock","abstract":false,"location":{"filename":"src/mutex.cr","line_number":36,"url":null},"def":{"name":"lock","return_type":"Nil","visibility":"Public","body":"if (@state.swap(1)) == 0\n  if @protection.unchecked?\n  else\n    @mutex_fiber = Fiber.current\n  end\n  return\nend\nif (!@protection.unchecked?) && (@mutex_fiber == Fiber.current)\n  if @protection.reentrant?\n    @lock_count = @lock_count + 1\n    return\n  else\n    raise(\"Attempt to lock a mutex recursively (deadlock)\")\n  end\nend\nlock_slow\nnil\n"}},{"html_id":"synchronize(&)-instance-method","name":"synchronize","abstract":false,"location":{"filename":"src/mutex.cr","line_number":131,"url":null},"def":{"name":"synchronize","yields":0,"visibility":"Public","body":"lock\nbegin\n  yield\nensure\n  unlock\nend\n"}},{"html_id":"unlock:Nil-instance-method","name":"unlock","abstract":false,"location":{"filename":"src/mutex.cr","line_number":92,"url":null},"def":{"name":"unlock","return_type":"Nil","visibility":"Public","body":"if @protection.unchecked?\nelse\n  if mutex_fiber = @mutex_fiber\n    if mutex_fiber == Fiber.current\n    else\n      raise(\"Attempt to unlock a mutex locked by another fiber\")\n    end\n  else\n    raise(\"Attempt to unlock a mutex which is not locked\")\n  end\n  if @protection.reentrant? && @lock_count > 0\n    @lock_count = @lock_count - 1\n    return\n  end\n  @mutex_fiber = nil\nend\n@state.lazy_set(0)\nif @queue_count.get == 0\n  return\nend\nfiber = nil\n@lock.sync do\n  if @queue_count.get == 0\n    return\n  end\n  if fiber = @queue.shift?\n    @queue_count.add(-1)\n  end\nend\nif fiber\n  fiber.enqueue\nend\nnil\n"}}],"types":[{"html_id":"Crystal/Mutex/Protection","path":"Mutex/Protection.html","kind":"enum","full_name":"Mutex::Protection","name":"Protection","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/mutex.cr","line_number":26,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Checked","name":"Checked","value":"0"},{"id":"Reentrant","name":"Reentrant","value":"1"},{"id":"Unchecked","name":"Unchecked","value":"2"}],"namespace":{"html_id":"Crystal/Mutex","kind":"class","full_name":"Mutex","name":"Mutex"},"instance_methods":[{"html_id":"checked?-instance-method","name":"checked?","abstract":false,"location":{"filename":"src/mutex.cr","line_number":27,"url":null},"def":{"name":"checked?","visibility":"Public","body":"self == Checked"}},{"html_id":"reentrant?-instance-method","name":"reentrant?","abstract":false,"location":{"filename":"src/mutex.cr","line_number":28,"url":null},"def":{"name":"reentrant?","visibility":"Public","body":"self == Reentrant"}},{"html_id":"unchecked?-instance-method","name":"unchecked?","abstract":false,"location":{"filename":"src/mutex.cr","line_number":29,"url":null},"def":{"name":"unchecked?","visibility":"Public","body":"self == Unchecked"}}]}]},{"html_id":"Crystal/NamedTuple","path":"NamedTuple.html","kind":"struct","full_name":"NamedTuple(**T)","name":"NamedTuple","abstract":false,"superclass":{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/to_json.cr","line_number":144,"url":null},{"filename":"src/named_tuple.cr","line_number":27,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":50,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"A named tuple is a fixed-size, immutable, stack-allocated mapping\nof a fixed set of keys to values.\n\nYou can think of a `NamedTuple` as an immutable `Hash` whose keys (which\nare of type `Symbol`), and the types for each key, are known at compile time.\n\nA named tuple can be created with a named tuple literal:\n\n```\nlanguage = {name: \"Crystal\", year: 2011} # NamedTuple(name: String, year: Int32)\n\nlanguage[:name]  # => \"Crystal\"\nlanguage[:year]  # => 2011\nlanguage[:other] # compile time error\n```\n\nSee [`NamedTuple` literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/named_tuple.html) in the language reference.\n\nThe compiler knows what types are in each key, so when indexing a named tuple\nwith a symbol literal the compiler will return the value for that key and\nwith the expected type, like in the above snippet. Indexing with a symbol\nliteral for which there's no key will give a compile-time error.\n\nIndexing with a symbol that is only known at runtime will return\na value whose type is the union of all the types in the named tuple,\nand might raise `KeyError`.","summary":"<p>A named tuple is a fixed-size, immutable, stack-allocated mapping of a fixed set of keys to values.</p>","class_methods":[{"html_id":"types-class-method","name":"types","doc":"Returns the types of this named tuple type.\n\n```\ntuple = {a: 1, b: \"hello\", c: 'x'}\ntuple.class.types # => {a: Int32, b: String, c: Char}\n```","summary":"<p>Returns the types of this named tuple type.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":264,"url":null},"def":{"name":"types","visibility":"Public","body":"NamedTuple.new(**{{ T }})"}}],"constructors":[{"html_id":"from(hash:Hash):self-class-method","name":"from","doc":"Creates a named tuple from the given hash, with elements casted to the given types.\nHere the Int32 | String union is cast to Int32.\n\n```\nnum_or_str = 42.as(Int32 | String)\nNamedTuple(name: String, val: Int32).from({\"name\" => \"number\", \"val\" => num_or_str}) # => {name: \"number\", val: 42}\n\nnum_or_str = \"a string\".as(Int32 | String)\nNamedTuple(name: String, val: Int32).from({\"name\" => \"number\", \"val\" => num_or_str}) # raises TypeCastError (cast from String to Int32 failed)\n```\nSee also: `#from`.","summary":"<p>Creates a named tuple from the given hash, with elements casted to the given types.</p>","abstract":false,"args":[{"name":"hash","external_name":"hash","restriction":"Hash"}],"args_string":"(hash : Hash) : self","args_html":"(hash : <a href=\"Hash.html\">Hash</a>) : <span class=\"k\">self</span>","location":{"filename":"src/named_tuple.cr","line_number":72,"url":null},"def":{"name":"from","args":[{"name":"hash","external_name":"hash","restriction":"Hash"}],"return_type":"self","visibility":"Public","body":"{% if true %}\n    NamedTuple.new(**{{ T }}).from(hash)\n    {% end %}"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":184,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"if node.is_a?(YAML::Nodes::Mapping)\nelse\n  node.raise(\"Expected mapping, not #{node.kind}\")\nend\n{% if true %}\n    {% for key in T.keys %}\n      %var{key.id} = nil\n      %found{key.id} = false\n    {% end %}\n\n    YAML::Schema::Core.each(node) do |key, value|\n      key = String.new(ctx, key)\n      case key\n        {% for key, type in T %}\n          when {{ key.stringify }}\n            %var{key.id} = {{ type }}.new(ctx, value)\n            %found{key.id} = true\n        {% end %}\n      else\n        # ignore the key\n      end\n    end\n\n    {% for key, type in T %}\n      if %var{key.id}.nil? && !%found{key.id} && !{{ type.nilable? }}\n        node.raise \"Missing yaml attribute: #{{{ key.id.stringify }}}\"\n      end\n    {% end %}\n\n    {\n      {% for key, type in T %}\n        {{ key.id.stringify }}: (%var{key.id}).as({{ type }}),\n      {% end %}\n    }\n  {% end %}\n"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":216,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"{% if true %}\n    {% for key in T.keys %}\n      %var{key.id} = nil\n      %found{key.id} = false\n    {% end %}\n\n    location = pull.location\n\n    pull.read_object do |key|\n      case key\n        {% for key, type in T %}\n          when {{ key.stringify }}\n            %var{key.id} = {{ type }}.new(pull)\n            %found{key.id} = true\n        {% end %}\n      else\n        pull.skip\n      end\n    end\n\n    {% for key, type in T %}\n      if %var{key.id}.nil? && !%found{key.id} && !{{ type.nilable? }}\n        raise JSON::ParseException.new(\"Missing json attribute: #{{{ key.id.stringify }}}\", *location)\n      end\n    {% end %}\n\n    {\n      {% for key, type in T %}\n        {{ key.id.stringify }}: (%var{key.id}).as({{ type }}),\n      {% end %}\n    }\n  {% end %}"}},{"html_id":"new(**options:**T)-class-method","name":"new","doc":"Creates a named tuple that will contain the given arguments.\n\nWith a named tuple literal you cannot create an empty named tuple.\nThis method doesn't have this limitation, which makes it especially\nuseful in macros and generic code.\n\n```\nNamedTuple.new(name: \"Crystal\", year: 2011) #=> {name: \"Crystal\", year: 2011}\nNamedTuple.new # => {}\n{}             # syntax error\n```","summary":"<p>Creates a named tuple that will contain the given arguments.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":39,"url":null},"def":{"name":"new","double_splat":{"name":"options","external_name":"options","restriction":"**T"},"visibility":"Public","body":"{% if @type.name(generic_args: false) == \"NamedTuple\" %}\n      # deduced type vars\n      options\n    {% else %}{% if @type.name(generic_args: false) == \"NamedTuple()\" %}\n      # special case: empty named tuple\n      options\n    {% else %}\n      # explicitly provided type vars\n      {% if true %}\n        {\n          {% for key in T %}\n            {{ key.stringify }}: options[{{ key.symbolize }}].as(typeof(begin\n              x = uninitialized self\n              x[{{ key.symbolize }}]\n            end)),\n          {% end %}\n        }\n      {% end %}\n    {% end %}{% end %}"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this tuple has the same keys as *other*, and values\nfor each key are the same in `self` and *other*.\n\n```\ntuple1 = {name: \"Crystal\", year: 2011}\ntuple2 = {year: 2011, name: \"Crystal\"}\ntuple3 = {name: \"Crystal\", year: 2012}\ntuple4 = {name: \"Crystal\", year: 2011.0}\n\ntuple1 == tuple2 # => true\ntuple1 == tuple3 # => false\ntuple1 == tuple4 # => true\n```","summary":"<p>Returns <code>true</code> if this tuple has the same keys as <em>other</em>, and values for each key are the same in <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/named_tuple.cr","line_number":568,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"{% for key in T %}\n      return false unless self[{{ key.symbolize }}] == other[{{ key.symbolize }}]\n    {% end %}\ntrue\n"}},{"html_id":"==(other:NamedTuple)-instance-method","name":"==","doc":"Returns `true` if this tuple has the same keys as *other*, and values\nfor each key are the same in `self` and *other*.\n\n```\ntuple1 = {name: \"Crystal\", year: 2011}\ntuple2 = {year: 2011, name: \"Crystal\"}\ntuple3 = {name: \"Crystal\", year: 2012}\ntuple4 = {name: \"Crystal\", year: 2011.0}\n\ntuple1 == tuple2 # => true\ntuple1 == tuple3 # => false\ntuple1 == tuple4 # => true\n```","summary":"<p>Returns <code>true</code> if this tuple has the same keys as <em>other</em>, and values for each key are the same in <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NamedTuple"}],"args_string":"(other : NamedTuple)","args_html":"(other : <a href=\"NamedTuple.html\">NamedTuple</a>)","location":{"filename":"src/named_tuple.cr","line_number":576,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"NamedTuple"}],"visibility":"Public","body":"if sorted_keys == other.sorted_keys\nelse\n  return false\nend\n{% for key in T %}\n      return false unless self[{{ key.symbolize }}] == other[{{ key.symbolize }}]?\n    {% end %}\nreturn true\n"}},{"html_id":"[](key:Symbol|String)-instance-method","name":"[]","doc":"Returns the value for the given *key*, if there's such key, otherwise raises `KeyError`.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\n\nkey = :name\ntuple[key] # => \"Crystal\"\n\nkey = \"year\"\ntuple[key] # => 2011\n\nkey = :other\ntuple[key] # raises KeyError\n```","summary":"<p>Returns the value for the given <em>key</em>, if there's such key, otherwise raises <code><a href=\"KeyError.html\">KeyError</a></code>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"Symbol | String"}],"args_string":"(key : Symbol | String)","args_html":"(key : <a href=\"Symbol.html\">Symbol</a> | <a href=\"String.html\">String</a>)","location":{"filename":"src/named_tuple.cr","line_number":123,"url":null},"def":{"name":"[]","args":[{"name":"key","external_name":"key","restriction":"Symbol | String"}],"visibility":"Public","body":"fetch(key) do\n  raise(KeyError.new(\"Missing named tuple key: #{key.inspect}\"))\nend"}},{"html_id":"[]?(key:Symbol|String)-instance-method","name":"[]?","doc":"Returns the value for the given *key*, if there's such key, otherwise returns `nil`.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\n\nkey = :name\ntuple[key]? # => \"Crystal\"\n\nkey = \"year\"\ntuple[key] # => 2011\n\nkey = :other\ntuple[key]? # => nil\n```","summary":"<p>Returns the value for the given <em>key</em>, if there's such key, otherwise returns <code>nil</code>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"Symbol | String"}],"args_string":"(key : Symbol | String)","args_html":"(key : <a href=\"Symbol.html\">Symbol</a> | <a href=\"String.html\">String</a>)","location":{"filename":"src/named_tuple.cr","line_number":141,"url":null},"def":{"name":"[]?","args":[{"name":"key","external_name":"key","restriction":"Symbol | String"}],"visibility":"Public","body":"fetch(key, nil)"}},{"html_id":"clone-instance-method","name":"clone","doc":"Returns a named tuple with the same keys but with cloned values, using the `clone` method.","summary":"<p>Returns a named tuple with the same keys but with cloned values, using the <code><a href=\"NamedTuple.html#clone-instance-method\">#clone</a></code> method.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":587,"url":null},"def":{"name":"clone","visibility":"Public","body":"{% if true %}\n      {\n        {% for key in T %}\n          {{ key.stringify }}: self[{{ key.symbolize }}].clone,\n        {% end %}\n      }\n    {% end %}"}},{"html_id":"dig(key:Symbol|String,*subkeys)-instance-method","name":"dig","doc":"Traverses the depth of a structure and returns the value, otherwise\nraises `KeyError`.\n\n```\nh = {a: {b: [10, 20, 30]}}\nh.dig \"a\", \"b\"                # => [10, 20, 30]\nh.dig \"a\", \"b\", \"c\", \"d\", \"e\" # raises KeyError\n```","summary":"<p>Traverses the depth of a structure and returns the value, otherwise raises <code><a href=\"KeyError.html\">KeyError</a></code>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"Symbol | String"},{"name":"subkeys","external_name":"subkeys","restriction":""}],"args_string":"(key : Symbol | String, *subkeys)","args_html":"(key : <a href=\"Symbol.html\">Symbol</a> | <a href=\"String.html\">String</a>, *subkeys)","location":{"filename":"src/named_tuple.cr","line_number":172,"url":null},"def":{"name":"dig","args":[{"name":"key","external_name":"key","restriction":"Symbol | String"},{"name":"subkeys","external_name":"subkeys","restriction":""}],"splat_index":1,"visibility":"Public","body":"if (value = self[key]) && (value.responds_to?(:dig))\n  return value.dig(*subkeys)\nend\nraise(KeyError.new(\"NamedTuple value not diggable for key: #{key.inspect}\"))\n"}},{"html_id":"dig?(key:Symbol|String,*subkeys)-instance-method","name":"dig?","doc":"Traverses the depth of a structure and returns the value.\nReturns `nil` if not found.\n\n```\nh = {a: {b: [10, 20, 30]}}\nh.dig? \"a\", \"b\"                # => [10, 20, 30]\nh.dig? \"a\", \"b\", \"c\", \"d\", \"e\" # => nil\n```","summary":"<p>Traverses the depth of a structure and returns the value.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"Symbol | String"},{"name":"subkeys","external_name":"subkeys","restriction":""}],"args_string":"(key : Symbol | String, *subkeys)","args_html":"(key : <a href=\"Symbol.html\">Symbol</a> | <a href=\"String.html\">String</a>, *subkeys)","location":{"filename":"src/named_tuple.cr","line_number":153,"url":null},"def":{"name":"dig?","args":[{"name":"key","external_name":"key","restriction":"Symbol | String"},{"name":"subkeys","external_name":"subkeys","restriction":""}],"splat_index":1,"visibility":"Public","body":"if (value = self[key]?) && (value.responds_to?(:\"dig?\"))\n  value.dig?(*subkeys)\nend"}},{"html_id":"each(&):Nil-instance-method","name":"each","doc":"Yields each key and value in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.each do |key, value|\n  puts \"#{key} = #{value}\"\nend\n```\n\nOutput:\n\n```text\nname = Crystal\nyear = 2011\n```","summary":"<p>Yields each key and value in this named tuple.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":405,"url":null},"def":{"name":"each","yields":0,"return_type":"Nil","visibility":"Public","body":"{% for key in T %}\n      yield {{ key.symbolize }}, self[{{ key.symbolize }}]\n    {% end %}"}},{"html_id":"each_key(&):Nil-instance-method","name":"each_key","doc":"Yields each key in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.each_key do |key|\n  puts key\nend\n```\n\nOutput:\n\n```text\nname\nyear\n```","summary":"<p>Yields each key in this named tuple.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":426,"url":null},"def":{"name":"each_key","yields":0,"return_type":"Nil","visibility":"Public","body":"{% for key in T %}\n      yield {{ key.symbolize }}\n    {% end %}"}},{"html_id":"each_value(&):Nil-instance-method","name":"each_value","doc":"Yields each value in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.each_value do |value|\n  puts value\nend\n```\n\nOutput:\n\n```text\nCrystal\n2011\n```","summary":"<p>Yields each value in this named tuple.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":447,"url":null},"def":{"name":"each_value","yields":0,"return_type":"Nil","visibility":"Public","body":"{% for key in T %}\n      yield self[{{ key.symbolize }}]\n    {% end %}"}},{"html_id":"each_with_index(offset=0,&)-instance-method","name":"each_with_index","doc":"Yields each key and value, together with an index starting at *offset*, in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.each_with_index do |key, value, i|\n  puts \"#{i + 1}) #{key} = #{value}\"\nend\n```\n\nOutput:\n\n```text\n1) name = Crystal\n2) year = 2011\n```","summary":"<p>Yields each key and value, together with an index starting at <em>offset</em>, in this named tuple.</p>","abstract":false,"args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(offset = 0, &)","args_html":"(offset = <span class=\"n\">0</span>, &)","location":{"filename":"src/named_tuple.cr","line_number":468,"url":null},"def":{"name":"each_with_index","args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"yields":3,"visibility":"Public","body":"i = offset\neach do |key, value|\n  yield key, value, i\n  i = i + 1\nend\n"}},{"html_id":"empty?-instance-method","name":"empty?","doc":"Returns `true` if this named tuple is empty.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.empty? # => false\n```","summary":"<p>Returns <code>true</code> if this named tuple is empty.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":551,"url":null},"def":{"name":"empty?","visibility":"Public","body":"size == 0"}},{"html_id":"fetch(key:Symbol|String,default_value)-instance-method","name":"fetch","doc":"Returns the value for the given *key*, if there's such key, otherwise returns *default_value*.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.fetch(:name, \"Unknown\") # => \"Crystal\"\ntuple.fetch(\"year\", 0)        # => 2011\ntuple.fetch(:other, 0)        # => 0\n```","summary":"<p>Returns the value for the given <em>key</em>, if there's such key, otherwise returns <em>default_value</em>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"Symbol | String"},{"name":"default_value","external_name":"default_value","restriction":""}],"args_string":"(key : Symbol | String, default_value)","args_html":"(key : <a href=\"Symbol.html\">Symbol</a> | <a href=\"String.html\">String</a>, default_value)","location":{"filename":"src/named_tuple.cr","line_number":192,"url":null},"def":{"name":"fetch","args":[{"name":"key","external_name":"key","restriction":"Symbol | String"},{"name":"default_value","external_name":"default_value","restriction":""}],"visibility":"Public","body":"fetch(key) do\n  default_value\nend"}},{"html_id":"fetch(key:Symbol,&)-instance-method","name":"fetch","doc":"Returns the value for the given *key*, if there's such key, otherwise the value returned by the block.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.fetch(:name) { \"Unknown\" } # => \"Crystal\"\ntuple.fetch(:other) { 0 }        # => 0\n```","summary":"<p>Returns the value for the given <em>key</em>, if there's such key, otherwise the value returned by the block.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"Symbol"}],"args_string":"(key : Symbol, &)","args_html":"(key : <a href=\"Symbol.html\">Symbol</a>, &)","location":{"filename":"src/named_tuple.cr","line_number":203,"url":null},"def":{"name":"fetch","args":[{"name":"key","external_name":"key","restriction":"Symbol"}],"yields":0,"visibility":"Public","body":"{% for key in T %}\n      return self[{{ key.symbolize }}] if {{ key.symbolize }} == key\n    {% end %}\nyield\n"}},{"html_id":"fetch(key:String,&)-instance-method","name":"fetch","doc":"Returns the value for the given *key*, if there's such key, otherwise the value returned by the block.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.fetch(\"name\") { \"Unknown\" } # => \"Crystal\"\ntuple.fetch(\"other\") { 0 }        # => 0\n```","summary":"<p>Returns the value for the given <em>key</em>, if there's such key, otherwise the value returned by the block.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String, &)","args_html":"(key : <a href=\"String.html\">String</a>, &)","location":{"filename":"src/named_tuple.cr","line_number":217,"url":null},"def":{"name":"fetch","args":[{"name":"key","external_name":"key","restriction":"String"}],"yields":0,"visibility":"Public","body":"{% for key in T %}\n      return self[{{ key.symbolize }}] if {{ key.stringify }} == key\n    {% end %}\nyield\n"}},{"html_id":"from(hash:Hash)-instance-method","name":"from","doc":"Expects to be called on a named tuple whose values are types, creates a tuple from the given hash,\nwith types casted appropriately. The hash keys must be either symbols or strings.\n\nThis allows you to easily pass a hash as individual named arguments to a method.\n\n```\nrequire \"json\"\n\ndef speak_about(thing : String, n : Int64)\n  \"I see #{n} #{thing}s\"\nend\n\nhash = JSON.parse(%({\"thing\": \"world\", \"n\": 2})).as_h # hash : Hash(String, JSON::Any)\nhash = hash.transform_values(&.raw)                   # hash : Hash(String, JSON::Any::Type)\n\nspeak_about(**{thing: String, n: Int64}.from(hash)) # => \"I see 2 worlds\"\n```","summary":"<p>Expects to be called on a named tuple whose values are types, creates a tuple from the given hash, with types casted appropriately.</p>","abstract":false,"args":[{"name":"hash","external_name":"hash","restriction":"Hash"}],"args_string":"(hash : Hash)","args_html":"(hash : <a href=\"Hash.html\">Hash</a>)","location":{"filename":"src/named_tuple.cr","line_number":95,"url":null},"def":{"name":"from","args":[{"name":"hash","external_name":"hash","restriction":"Hash"}],"visibility":"Public","body":"if size != hash.size\n  raise(ArgumentError.new(\"Expected a hash with #{size} keys but one with #{hash.size} keys was given.\"))\nend\n{% if true %}\n      NamedTuple.new(\n      {% for key, value in T %}\n        {{ key.stringify }}: self[{{ key.symbolize }}].cast(hash.fetch({{ key.symbolize }}) { hash[\"{{ key }}\"] }),\n      {% end %}\n      )\n    {% end %}\n"}},{"html_id":"has_key?(key:Symbol):Bool-instance-method","name":"has_key?","doc":"Returns `true` if this named tuple has the given *key*, `false` otherwise.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.has_key?(:name)  # => true\ntuple.has_key?(:other) # => false\n```","summary":"<p>Returns <code>true</code> if this named tuple has the given <em>key</em>, <code>false</code> otherwise.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"Symbol"}],"args_string":"(key : Symbol) : Bool","args_html":"(key : <a href=\"Symbol.html\">Symbol</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/named_tuple.cr","line_number":328,"url":null},"def":{"name":"has_key?","args":[{"name":"key","external_name":"key","restriction":"Symbol"}],"return_type":"Bool","visibility":"Public","body":"{% for key in T %}\n      return true if {{ key.symbolize }} == key\n    {% end %}\nfalse\n"}},{"html_id":"has_key?(key:String):Bool-instance-method","name":"has_key?","doc":"Returns `true` if this named tuple has the given *key*, `false` otherwise.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.has_key?(:name)  # => true\ntuple.has_key?(:other) # => false\n```","summary":"<p>Returns <code>true</code> if this named tuple has the given <em>key</em>, <code>false</code> otherwise.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String) : Bool","args_html":"(key : <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/named_tuple.cr","line_number":336,"url":null},"def":{"name":"has_key?","args":[{"name":"key","external_name":"key","restriction":"String"}],"return_type":"Bool","visibility":"Public","body":"{% for key in T %}\n      return true if {{ key.stringify }} == key\n    {% end %}\nfalse\n"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"Returns a hash value based on this name tuple's size, keys and values.\n\nSee also: `Object#hash`.\nSee `Object#hash(hasher)`","summary":"<p>Returns a hash value based on this name tuple's size, keys and values.</p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/named_tuple.cr","line_number":250,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"{% for key in T.keys.sort %}\n      hasher = {{ key.symbolize }}.hash(hasher)\n      hasher = self[{{ key.symbolize }}].hash(hasher)\n    {% end %}\nhasher\n"}},{"html_id":"inspect:String-instance-method","name":"inspect","doc":"Same as `to_s`.","summary":"<p>Same as <code><a href=\"NamedTuple.html#to_s%28io%3AIO%29%3ANil-instance-method\">#to_s</a></code>.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":269,"url":null},"def":{"name":"inspect","return_type":"String","visibility":"Public","body":"to_s"}},{"html_id":"keys-instance-method","name":"keys","doc":"Returns a `Tuple` of symbols with the keys in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.keys # => {:name, :year}\n```","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> of symbols with the keys in this named tuple.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":279,"url":null},"def":{"name":"keys","visibility":"Public","body":"{% if true %}\n      Tuple.new(\n        {% for key in T %}\n          {{ key.symbolize }},\n        {% end %}\n      )\n    {% end %}"}},{"html_id":"map(&)-instance-method","name":"map","doc":"Returns an `Array` populated with the results of each iteration in the given block,\nwhich is given each key and value in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.map { |k, v| \"#{k}: #{v}\" } # => [\"name: Crystal\", \"year: 2011\"]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> populated with the results of each iteration in the given block, which is given each key and value in this named tuple.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":483,"url":null},"def":{"name":"map","yields":0,"visibility":"Public","body":"{% if T.size == 0 %}\n      [] of NoReturn\n    {% else %}\n      [\n        {% for key in T %}\n          (yield {{ key.symbolize }}, self[{{ key.symbolize }}]),\n        {% end %}\n      ]\n    {% end %}"}},{"html_id":"merge(other:NamedTuple)-instance-method","name":"merge","doc":"Merges two named tuples into one, returning a new named tuple.\nIf a key is defined in both tuples, the value and its type is used from *other*.\n\n```\na = {foo: \"Hello\", bar: \"Old\"}\nb = {bar: \"New\", baz: \"Bye\"}\na.merge(b) # => {foo: \"Hello\", bar: \"New\", baz: \"Bye\"}\n```","summary":"<p>Merges two named tuples into one, returning a new named tuple.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"NamedTuple"}],"args_string":"(other : NamedTuple)","args_html":"(other : <a href=\"NamedTuple.html\">NamedTuple</a>)","location":{"filename":"src/named_tuple.cr","line_number":232,"url":null},"def":{"name":"merge","args":[{"name":"other","external_name":"other","restriction":"NamedTuple"}],"visibility":"Public","body":"merge(**other)"}},{"html_id":"merge(**other:**U)forallU-instance-method","name":"merge","doc":"Merges two named tuples into one, returning a new named tuple.\nIf a key is defined in both tuples, the value and its type is used from *other*.\n\n```\na = {foo: \"Hello\", bar: \"Old\"}\nb = {bar: \"New\", baz: \"Bye\"}\na.merge(b) # => {foo: \"Hello\", bar: \"New\", baz: \"Bye\"}\n```","summary":"<p>Merges two named tuples into one, returning a new named tuple.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":237,"url":null},"def":{"name":"merge","double_splat":{"name":"other","external_name":"other","restriction":"**U"},"visibility":"Public","body":"{% if true %}\n    {\n      {% for k in T %} {% if U.keys.includes?(k) %}{% else %} {{ k.stringify }}: self[{{ k.symbolize }}],{% end %} {% end %}\n      {% for k in U %} {{ k.stringify }}: other[{{ k.symbolize }}], {% end %}\n    }\n    {% end %}"}},{"html_id":"pretty_print(pp)-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp)","args_html":"(pp)","location":{"filename":"src/named_tuple.cr","line_number":367,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"visibility":"Public","body":"pp.surround(\"{\", \"}\", left_break: nil, right_break: nil) do\n  {% for key, value, i in T %}\n        {% if i > 0 %}\n          pp.comma\n        {% end %}\n        pp.group do\n          key = {{ key.stringify }}\n          if Symbol.needs_quotes_for_named_argument?(key)\n            pp.text key.inspect\n          else\n            pp.text key\n          end\n          pp.text \": \"\n          pp.nest do\n            pp.breakable \"\"\n            self[{{ key.symbolize }}].pretty_print(pp)\n          end\n        end\n      {% end %}\nend"}},{"html_id":"size-instance-method","name":"size","doc":"Returns the number of elements in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.size # => 2\n```","summary":"<p>Returns the number of elements in this named tuple.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":541,"url":null},"def":{"name":"size","visibility":"Public","body":"{{ T.size }}"}},{"html_id":"sorted_keys-instance-method","name":"sorted_keys","doc":"Returns a `Tuple` of symbols with the keys in this named tuple, sorted by name.\n\n```\ntuple = {foo: 1, bar: 2, baz: 3}\ntuple.sorted_keys # => {:bar, :baz, :foo}\n```","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> of symbols with the keys in this named tuple, sorted by name.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":295,"url":null},"def":{"name":"sorted_keys","visibility":"Public","body":"{% if true %}\n      Tuple.new(\n        {% for key in T.keys.sort %}\n          {{ key.symbolize }},\n        {% end %}\n      )\n    {% end %}"}},{"html_id":"to_a-instance-method","name":"to_a","doc":"Returns a new `Array` of tuples populated with each key-value pair.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.to_a # => [{:name, \"Crystal\"}, {:year, 2011}]\n```\n\nNOTE: `to_a` on an empty named tuple produces an `Array(Tuple(Symbol, NoReturn))`","summary":"<p>Returns a new <code><a href=\"Array.html\">Array</a></code> of tuples populated with each key-value pair.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":503,"url":null},"def":{"name":"to_a","visibility":"Public","body":"{% if T.size == 0 %}\n      [] of {Symbol, NoReturn}\n    {% else %}\n      [\n        {% for key in T %}\n          { {{ key.symbolize }}, self[{{ key.symbolize }}] },\n        {% end %}\n      ]\n    {% end %}"}},{"html_id":"to_h-instance-method","name":"to_h","doc":"Returns a `Hash` with the keys and values in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.to_h # => {:name => \"Crystal\", :year => 2011}\n```\n\nNOTE: `to_h` on an empty named tuple produces a `Hash(Symbol, NoReturn)`","summary":"<p>Returns a <code><a href=\"Hash.html\">Hash</a></code> with the keys and values in this named tuple.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":523,"url":null},"def":{"name":"to_h","visibility":"Public","body":"{% if T.size == 0 %}\n      {} of Symbol => NoReturn\n    {% else %}\n      {\n        {% for key in T %}\n          {{ key.symbolize }} => self[{{ key.symbolize }}],\n        {% end %}\n      }\n    {% end %}"}},{"html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>)","location":{"filename":"src/json/to_json.cr","line_number":145,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"visibility":"Public","body":"json.object do\n  {% for key in T.keys %}\n        json.field {{ key.stringify }} do\n          self[{{ key.symbolize }}].to_json(json)\n        end\n      {% end %}\nend"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a string representation of this named tuple to the given `IO`.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.to_s # => %({name: \"Crystal\", year: 2011})\n```","summary":"<p>Appends a string representation of this named tuple to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/named_tuple.cr","line_number":349,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << '{'\n{% for key, value, i in T %}\n      {% if i > 0 %}\n        io << \", \"\n      {% end %}\n      key = {{ key.stringify }}\n      if Symbol.needs_quotes_for_named_argument?(key)\n        key.inspect(io)\n      else\n        io << key\n      end\n      io << \": \"\n      self[{{ key.symbolize }}].inspect(io)\n    {% end %}\nio << '}'\n"}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","args_html":"(yaml : <a href=\"YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>)","location":{"filename":"src/yaml/to_yaml.cr","line_number":51,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"visibility":"Public","body":"yaml.mapping do\n  {% for key in T.keys %}\n        {{ key.symbolize }}.to_yaml(yaml)\n        self[{{ key.symbolize }}].to_yaml(yaml)\n      {% end %}\nend"}},{"html_id":"values-instance-method","name":"values","doc":"Returns a `Tuple` with the values in this named tuple.\n\n```\ntuple = {name: \"Crystal\", year: 2011}\ntuple.values # => {\"Crystal\", 2011}\n```","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> with the values in this named tuple.</p>","abstract":false,"location":{"filename":"src/named_tuple.cr","line_number":311,"url":null},"def":{"name":"values","visibility":"Public","body":"{% if true %}\n      Tuple.new(\n        {% for key in T %}\n          self[{{ key.symbolize }}],\n        {% end %}\n      )\n    {% end %}"}}]},{"html_id":"Crystal/Nil","path":"Nil.html","kind":"struct","full_name":"Nil","name":"Nil","abstract":false,"superclass":{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/to_json.cr","line_number":27,"url":null},{"filename":"src/nil.cr","line_number":44,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":98,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"The `Nil` type has only one possible value: `nil`.\n\n`nil` is commonly used to represent the absence of a value.\nFor example, `String#index` returns the position of the character or `nil` if it's not\nin the string:\n\n```\nstr = \"Hello world\"\nstr.index 'e' # => 1\nstr.index 'a' # => nil\n```\n\nIn the above example, trying to invoke a method on the returned value will\ngive a compile time error unless both `Int32` and `Nil` define that method:\n\n```\nstr = \"Hello world\"\nidx = str.index 'e'\nidx + 1 # Error: undefined method '+' for Nil\n```\n\nThe language and the standard library provide short, readable, easy ways to deal with `nil`,\nsuch as `Object#try` and `Object#not_nil!`:\n\n```\nstr = \"Hello world\"\n\n# The index of 'e' in str or 0 if not found\nidx1 = str.index('e') || 0\n\nidx2 = str.index('a')\nif idx2\n  # Compiles: idx2 can't be nil here\n  idx2 + 1\nend\n\n# Tell the compiler that we are sure the returned\n# value is not nil: raises a runtime exception\n# if our assumption doesn't hold.\nidx3 = str.index('o').not_nil!\n```\n\nSee [`Nil` literal](https://crystal-lang.org/reference/syntax_and_semantics/literals/nil.html) in the language reference.","summary":"<p>The <code><a href=\"Nil.html\">Nil</a></code> type has only one possible value: <code>nil</code>.</p>","constructors":[{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":51,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"parse_scalar(ctx, node, self)"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":68,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"pull.read_null"}}],"instance_methods":[{"html_id":"==(other:Nil)-instance-method","name":"==","doc":"Returns `true`: `Nil` has only one singleton value: `nil`.","summary":"<p>Returns <code>true</code>: <code><a href=\"Nil.html\">Nil</a></code> has only one singleton value: <code>nil</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Nil"}],"args_string":"(other : Nil)","args_html":"(other : <a href=\"Nil.html\">Nil</a>)","location":{"filename":"src/nil.cr","line_number":58,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Nil"}],"visibility":"Public","body":"true"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/nil.cr","line_number":124,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/nil.cr","line_number":73,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher.nil"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Writes `\"nil\"` to the given `IO`.","summary":"<p>Writes <code>\"nil\"</code> to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/nil.cr","line_number":93,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"nil\""}},{"html_id":"inspect:String-instance-method","name":"inspect","doc":"Returns `\"nil\"`.","summary":"<p>Returns <code>\"nil\"</code>.</p>","abstract":false,"location":{"filename":"src/nil.cr","line_number":88,"url":null},"def":{"name":"inspect","return_type":"String","visibility":"Public","body":"\"nil\""}},{"html_id":"not_nil!:NoReturn-instance-method","name":"not_nil!","doc":"Raises `NilAssertionError`.\n\nSee also: `Object#not_nil!`.","summary":"<p>Raises <code><a href=\"NilAssertionError.html\">NilAssertionError</a></code>.</p>","abstract":false,"location":{"filename":"src/nil.cr","line_number":107,"url":null},"def":{"name":"not_nil!","return_type":"NoReturn","visibility":"Public","body":"raise(NilAssertionError.new)"}},{"html_id":"object_id:UInt64-instance-method","name":"object_id","doc":"Returns `0_u64`. Even though `Nil` is not a `Reference` type, it is usually\nmixed with them to form nilable types so it's useful to have an\nobject id for `nil`.","summary":"<p>Returns <code>0_u64</code>.</p>","abstract":false,"location":{"filename":"src/nil.cr","line_number":48,"url":null},"def":{"name":"object_id","return_type":"UInt64","visibility":"Public","body":"0_u64"}},{"html_id":"presence:Nil-instance-method","name":"presence","doc":"Returns `self`.\nThis method enables to call the `presence` method (see `String#presence`) on a union with `Nil`.\nThe idea is to return `nil` when the value is `nil` or empty.\n\n```\nconfig = {\"empty\" => \"\"}\nconfig[\"empty\"]?.presence   # => nil\nconfig[\"missing\"]?.presence # => nil\n```","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/nil.cr","line_number":120,"url":null},"def":{"name":"presence","return_type":"Nil","visibility":"Public","body":"self"}},{"html_id":"same?(other:Nil)-instance-method","name":"same?","doc":"Returns `true`: `Nil` has only one singleton value: `nil`.","summary":"<p>Returns <code>true</code>: <code><a href=\"Nil.html\">Nil</a></code> has only one singleton value: <code>nil</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Nil"}],"args_string":"(other : Nil)","args_html":"(other : <a href=\"Nil.html\">Nil</a>)","location":{"filename":"src/nil.cr","line_number":63,"url":null},"def":{"name":"same?","args":[{"name":"other","external_name":"other","restriction":"Nil"}],"visibility":"Public","body":"true"}},{"html_id":"same?(other:Reference):Bool-instance-method","name":"same?","doc":"Returns `false`.","summary":"<p>Returns <code>false</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Reference"}],"args_string":"(other : Reference) : Bool","args_html":"(other : <a href=\"Reference.html\">Reference</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/nil.cr","line_number":68,"url":null},"def":{"name":"same?","args":[{"name":"other","external_name":"other","restriction":"Reference"}],"return_type":"Bool","visibility":"Public","body":"false"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":28,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.null"}},{"html_id":"to_json_object_key:String-instance-method","name":"to_json_object_key","abstract":false,"location":{"filename":"src/json/to_json.cr","line_number":32,"url":null},"def":{"name":"to_json_object_key","return_type":"String","visibility":"Public","body":"\"\""}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Doesn't write anything to the given `IO`.","summary":"<p>Doesn't write anything to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/nil.cr","line_number":83,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":""}},{"html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns an empty string.","summary":"<p>Returns an empty string.</p>","abstract":false,"location":{"filename":"src/nil.cr","line_number":78,"url":null},"def":{"name":"to_s","return_type":"String","visibility":"Public","body":"\"\""}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder) : Nil","args_html":"(yaml : <a href=\"YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":99,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"yaml.scalar(\"\")"}},{"html_id":"try(&)-instance-method","name":"try","doc":"Doesn't yield to the block.\n\nSee also: `Object#try`.","summary":"<p>Doesn't yield to the block.</p>","abstract":false,"location":{"filename":"src/nil.cr","line_number":100,"url":null},"def":{"name":"try","yields":0,"visibility":"Public","body":"self"}}]},{"html_id":"Crystal/NilAssertionError","path":"NilAssertionError.html","kind":"class","full_name":"NilAssertionError","name":"NilAssertionError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/exception.cr","line_number":161,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"Raised when a `not_nil!` assertion fails.\n\n```\n\"hello\".index('x').not_nil! # raises NilAssertionError (\"hello\" does not contain 'x')\n```","summary":"<p>Raised when a <code>not_nil!</code> assertion fails.</p>","constructors":[{"html_id":"new(message=\"Nilassertionfailed\")-class-method","name":"new","abstract":false,"args":[{"name":"message","default_value":"\"Nil assertion failed\"","external_name":"message","restriction":""}],"args_string":"(message = \"Nil assertion failed\")","args_html":"(message = <span class=\"s\">&quot;Nil assertion failed&quot;</span>)","location":{"filename":"src/exception.cr","line_number":162,"url":null},"def":{"name":"new","args":[{"name":"message","default_value":"\"Nil assertion failed\"","external_name":"message","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]},{"html_id":"Crystal/NotImplementedError","path":"NotImplementedError.html","kind":"class","full_name":"NotImplementedError","name":"NotImplementedError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/exception.cr","line_number":150,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"Raised when a method is not implemented.\n\nThis can be used either to stub out method bodies, or when the method is not\nimplemented on the current platform.","summary":"<p>Raised when a method is not implemented.</p>","constructors":[{"html_id":"new(item)-class-method","name":"new","abstract":false,"args":[{"name":"item","external_name":"item","restriction":""}],"args_string":"(item)","args_html":"(item)","location":{"filename":"src/exception.cr","line_number":151,"url":null},"def":{"name":"new","args":[{"name":"item","external_name":"item","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(item)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]},{"html_id":"Crystal/Number","path":"Number.html","kind":"struct","full_name":"Number","name":"Number","abstract":true,"superclass":{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/big_float.cr","line_number":355,"url":null},{"filename":"src/complex.cr","line_number":272,"url":null},{"filename":"src/humanize.cr","line_number":1,"url":null},{"filename":"src/number.cr","line_number":2,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":77,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"SI_PREFIXES","name":"SI_PREFIXES","value":"{ {'y', 'z', 'a', 'f', 'p', 'n', 'µ', 'm'}, {nil, 'k', 'M', 'G', 'T', 'P', 'E', 'Z', 'Y'} }","doc":"Default SI prefixes ordered by magnitude.","summary":"<p>Default SI prefixes ordered by magnitude.</p>"},{"id":"SI_PREFIXES_PADDED","name":"SI_PREFIXES_PADDED","value":"->(magnitude : Int32, _number : Float64) do\n  magnitude = Number.prefix_index(magnitude)\n  {magnitude, (  magnitude == 0 ? \" \" : si_prefix(magnitude))}\nend","doc":"SI prefixes used by `#humanize`. Equal to `SI_PREFIXES` but prepends the\nprefix with a space character.","summary":"<p>SI prefixes used by <code><a href=\"Number.html#humanize%28io%3AIO%2Cprecision%3D3%2Cseparator%3D%27.%27%2Cdelimiter%3D%27%2C%27%2C%2A%2Cbase%3D10%2A%2A3%2Csignificant%3Dtrue%2Cprefixes%3AIndexable%3DSI_PREFIXES%29%3ANil-instance-method\">#humanize</a></code>.</p>"}],"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"}],"subclasses":[{"html_id":"Crystal/BigDecimal","kind":"struct","full_name":"BigDecimal","name":"BigDecimal"},{"html_id":"Crystal/BigRational","kind":"struct","full_name":"BigRational","name":"BigRational"},{"html_id":"Crystal/Float","kind":"struct","full_name":"Float","name":"Float"},{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"}],"doc":"The top-level number type.","summary":"<p>The top-level number type.</p>","class_methods":[{"html_id":"si_prefix(magnitude:Int,prefixes=SI_PREFIXES):Char?-class-method","name":"si_prefix","doc":"Returns the SI prefix for *magnitude*.\n\n```\nNumber.si_prefix(3) # => 'k'\n```","summary":"<p>Returns the SI prefix for <em>magnitude</em>.</p>","abstract":false,"args":[{"name":"magnitude","external_name":"magnitude","restriction":"Int"},{"name":"prefixes","default_value":"SI_PREFIXES","external_name":"prefixes","restriction":""}],"args_string":"(magnitude : Int, prefixes = SI_PREFIXES) : Char?","args_html":"(magnitude : <a href=\"Int.html\">Int</a>, prefixes = <span class=\"t\">SI_PREFIXES</span>) : <a href=\"Char.html\">Char</a>?","location":{"filename":"src/humanize.cr","line_number":113,"url":null},"def":{"name":"si_prefix","args":[{"name":"magnitude","external_name":"magnitude","restriction":"Int"},{"name":"prefixes","default_value":"SI_PREFIXES","external_name":"prefixes","restriction":""}],"return_type":"Char | ::Nil","visibility":"Public","body":"index = (magnitude // 3)\nprefixes = prefixes[magnitude < 0 ? 0 : 1]\nprefixes[index.clamp(((-prefixes.size) + 1)..(prefixes.size - 1))]\n"}}],"constructors":[{"html_id":"additive_identity:self-class-method","name":"additive_identity","doc":"Returns the additive identity of this type.\n\nFor numerical types, it is the value `0` expressed in the respective type.\n\n```\nInt32.additive_identity   # => 0\nFloat64.additive_identity # => 0.0\n```","summary":"<p>Returns the additive identity of this type.</p>","abstract":false,"location":{"filename":"src/number.cr","line_number":26,"url":null},"def":{"name":"additive_identity","return_type":"self","visibility":"Public","body":"zero"}},{"html_id":"multiplicative_identity:self-class-method","name":"multiplicative_identity","doc":"Returns the multiplicative identity of this type.\n\nFor numerical types, it is the value `1` expressed in the respective type.\n\n```\nInt32.multiplicative_identity   # => 1\nFloat64.multiplicative_identity # => 1.0\n```","summary":"<p>Returns the multiplicative identity of this type.</p>","abstract":false,"location":{"filename":"src/number.cr","line_number":38,"url":null},"def":{"name":"multiplicative_identity","return_type":"self","visibility":"Public","body":"new(1)"}},{"html_id":"zero:self-class-method","name":"zero","doc":"Returns the value zero in the respective type.\n\n```\nInt32.zero   # => 0\nFloat64.zero # => 0.0\n```","summary":"<p>Returns the value zero in the respective type.</p>","abstract":false,"location":{"filename":"src/number.cr","line_number":14,"url":null},"def":{"name":"zero","return_type":"self","visibility":"Public","body":"new(0)"}}],"instance_methods":[{"html_id":"*(other:BigFloat):BigFloat-instance-method","name":"*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigFloat","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/big_float.cr","line_number":370,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"other * self"}},{"html_id":"*(other:Complex):Complex-instance-method","name":"*","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex) : Complex","args_html":"(other : <a href=\"Complex.html\">Complex</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":297,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Complex"}],"return_type":"Complex","visibility":"Public","body":"Complex.new(self * other.real, self * other.imag)"}},{"html_id":"+(other:BigFloat)-instance-method","name":"+","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat)","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>)","location":{"filename":"src/big/big_float.cr","line_number":362,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"visibility":"Public","body":"other + self"}},{"html_id":"+(other:Complex):Complex-instance-method","name":"+","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex) : Complex","args_html":"(other : <a href=\"Complex.html\">Complex</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":289,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Complex"}],"return_type":"Complex","visibility":"Public","body":"Complex.new(self + other.real, other.imag)"}},{"html_id":"+-instance-method","name":"+","doc":"Returns self.","summary":"<p>Returns self.</p>","abstract":false,"location":{"filename":"src/number.cr","line_number":43,"url":null},"def":{"name":"+","visibility":"Public","body":"self"}},{"html_id":"-(other:BigFloat)-instance-method","name":"-","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat)","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>)","location":{"filename":"src/big/big_float.cr","line_number":366,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"visibility":"Public","body":"to_big_f - other"}},{"html_id":"-(other:Complex):Complex-instance-method","name":"-","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex) : Complex","args_html":"(other : <a href=\"Complex.html\">Complex</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":293,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Complex"}],"return_type":"Complex","visibility":"Public","body":"Complex.new(self - other.real, -other.imag)"}},{"html_id":"/(other:BigFloat):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigFloat","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/big_float.cr","line_number":374,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"to_big_f / other"}},{"html_id":"/(other:Complex):Complex-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex) : Complex","args_html":"(other : <a href=\"Complex.html\">Complex</a>) : <a href=\"Complex.html\">Complex</a>","location":{"filename":"src/complex.cr","line_number":301,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Complex"}],"return_type":"Complex","visibility":"Public","body":"self * other.inv"}},{"html_id":"//(other)-instance-method","name":"//","doc":"Divides `self` by *other* using floored division.\n\nThe result will be of the same type as `self`.","summary":"<p>Divides <code>self</code> by <em>other</em> using floored division.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/number.cr","line_number":50,"url":null},"def":{"name":"//","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"self.class.new((self / other).floor)"}},{"html_id":"<=>(other:BigFloat)-instance-method","name":"<=>","doc":"The comparison operator. Returns `0` if the two objects are equal,\na negative number if this object is considered less than *other*,\na positive number if this object is considered greater than *other*,\nor `nil` if the two objects are not comparable.\n\nSubclasses define this method to provide class-specific ordering.\n\nThe comparison operator is usually used to sort values:\n\n```\n# Sort in a descending way:\n[3, 1, 2].sort { |x, y| y <=> x } # => [3, 2, 1]\n\n# Sort in an ascending way:\n[3, 1, 2].sort { |x, y| x <=> y } # => [1, 2, 3]\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat)","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>)","location":{"filename":"src/big/big_float.cr","line_number":358,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"visibility":"Public","body":"-(other <=> self)"}},{"html_id":"<=>(other):Int32?-instance-method","name":"<=>","doc":"The comparison operator.\n\nReturns:\n- `-1` if `self` is less than *other*\n- `0` if `self` is equal to *other*\n- `-1` if `self` is greater than *other*\n- `nil` if self is `NaN` or *other* is `NaN`, because `NaN` values are not comparable","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other) : Int32?","args_html":"(other) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/number.cr","line_number":200,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":""}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"if self.is_a?(Float) && self.nan?\n  return nil\nend\nif other.is_a?(Float) && other.nan?\n  return nil\nend\nself > other ? 1 : (self < other ? -1 : 0)\n"}},{"html_id":"==(other:Complex)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Complex"}],"args_string":"(other : Complex)","args_html":"(other : <a href=\"Complex.html\">Complex</a>)","location":{"filename":"src/complex.cr","line_number":281,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Complex"}],"visibility":"Public","body":"to_c == other"}},{"html_id":"abs:self-instance-method","name":"abs","doc":"Returns the absolute value of this number.\n\n```\n123.abs  # => 123\n-123.abs # => 123\n```","summary":"<p>Returns the absolute value of this number.</p>","abstract":false,"location":{"filename":"src/number.cr","line_number":154,"url":null},"def":{"name":"abs","return_type":"self","visibility":"Public","body":"self < 0 ? -self : self"}},{"html_id":"abs2-instance-method","name":"abs2","doc":"Returns the square of `self` (`self * self`).\n\n```\n4.abs2   # => 16\n1.5.abs2 # => 2.25\n```","summary":"<p>Returns the square of <code>self</code> (<code>self * self</code>).</p>","abstract":false,"location":{"filename":"src/number.cr","line_number":164,"url":null},"def":{"name":"abs2","visibility":"Public","body":"self * self"}},{"html_id":"cis:Complex-instance-method","name":"cis","abstract":false,"location":{"filename":"src/complex.cr","line_number":285,"url":null},"def":{"name":"cis","return_type":"Complex","visibility":"Public","body":"Complex.new(Math.cos(self), Math.sin(self))"}},{"html_id":"divmod(number)-instance-method","name":"divmod","doc":"Returns a `Tuple` of two elements containing the quotient\nand modulus obtained by dividing `self` by *number*.\n\n```\n11.divmod(3)  # => {3, 2}\n11.divmod(-3) # => {-4, -1}\n```","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> of two elements containing the quotient and modulus obtained by dividing <code>self</code> by <em>number</em>.</p>","abstract":false,"args":[{"name":"number","external_name":"number","restriction":""}],"args_string":"(number)","args_html":"(number)","location":{"filename":"src/number.cr","line_number":189,"url":null},"def":{"name":"divmod","args":[{"name":"number","external_name":"number","restriction":""}],"visibility":"Public","body":"{(self // number).floor, self % number}"}},{"html_id":"format(io:IO,separator='.',delimiter=',',decimal_places:Int?=nil,*,group:Int=3,only_significant:Bool=false):Nil-instance-method","name":"format","doc":"Prints this number as a `String` using a customizable format.\n\n*separator* is used as decimal separator, *delimiter* as thousands\ndelimiter between batches of *group* digits.\n\nIf *decimal_places* is `nil`, all significant decimal places are printed\n(similar to `#to_s`). If the argument has a numeric value, the number of\nvisible decimal places will be fixed to that amount.\n\nTrailing zeros are omitted if *only_significant* is `true`.\n\n```\n123_456.789.format                                            # => \"123,456.789\"\n123_456.789.format(',', '.')                                  # => \"123.456,789\"\n123_456.789.format(decimal_places: 2)                         # => \"123,456.79\"\n123_456.789.format(decimal_places: 6)                         # => \"123,456.789000\"\n123_456.789.format(decimal_places: 6, only_significant: true) # => \"123,456.789\"\n```","summary":"<p>Prints this number as a <code><a href=\"String.html\">String</a></code> using a customizable format.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"decimal_places","default_value":"nil","external_name":"decimal_places","restriction":"Int | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"group","default_value":"3","external_name":"group","restriction":"Int"},{"name":"only_significant","default_value":"false","external_name":"only_significant","restriction":"Bool"}],"args_string":"(io : IO, separator = '.', delimiter = ',', decimal_places : Int? = nil, *, group : Int = 3, only_significant : Bool = false) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, separator = <span class=\"s\">&#39;.&#39;</span>, delimiter = <span class=\"s\">&#39;,&#39;</span>, decimal_places : <a href=\"Int.html\">Int</a>? = <span class=\"n\">nil</span>, *, group : <a href=\"Int.html\">Int</a> = <span class=\"n\">3</span>, only_significant : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/humanize.cr","line_number":20,"url":null},"def":{"name":"format","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"decimal_places","default_value":"nil","external_name":"decimal_places","restriction":"Int | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"group","default_value":"3","external_name":"group","restriction":"Int"},{"name":"only_significant","default_value":"false","external_name":"only_significant","restriction":"Bool"}],"splat_index":4,"return_type":"Nil","visibility":"Public","body":"number = self\nif decimal_places\n  number = number.round(decimal_places)\nend\nif number.is_a?(Float)\n  if number.infinite?\n    if number < 0\n      io << '-'\n    end\n    io << \"Infinity\"\n    return\n  else\n    if number.nan?\n      io << \"NaN\"\n      return\n    end\n  end\n  if decimal_places && decimal_places >= 0\n    string = \"%.*f\" % {decimal_places, number.abs}\n  else\n    string = String.build do |io|\n      Float::Printer.print(number.abs, io, point_range: ..)\n    end\n    _, _, decimals = string.partition(\".\")\n    integer, _, _ = (\"%f\" % number.abs).partition(\".\")\n    string = \"#{integer}.#{decimals}\"\n  end\nelse\n  string = number.abs.to_s\nend\ninteger, _, decimals = string.partition('.')\nint_size = integer.size\ndec_size = decimals.size\nif self < 0\n  io << '-'\nend\nstart = int_size % group\nif start == 0\n  start = start + group\nend\nio.write_string(integer.to_slice[0, start])\nwhile start < int_size\n  io << delimiter\n  io.write_string(integer.to_slice[start, group])\n  start = start + group\nend\ndecimal_places || (decimal_places = dec_size)\nif decimal_places > 0\n  io << separator\n  if only_significant\n    decimals = decimals.rstrip('0')\n    if decimals.empty?\n      io << '0'\n    else\n      io << decimals\n    end\n  else\n    io << decimals\n    (decimal_places - dec_size).times do\n      io << '0'\n    end\n  end\nend\n"}},{"html_id":"format(separator='.',delimiter=',',decimal_places:Int?=nil,*,group:Int=3,only_significant:Bool=false):String-instance-method","name":"format","doc":"Prints this number as a `String` using a customizable format.\n\n*separator* is used as decimal separator, *delimiter* as thousands\ndelimiter between batches of *group* digits.\n\nIf *decimal_places* is `nil`, all significant decimal places are printed\n(similar to `#to_s`). If the argument has a numeric value, the number of\nvisible decimal places will be fixed to that amount.\n\nTrailing zeros are omitted if *only_significant* is `true`.\n\n```\n123_456.789.format                                            # => \"123,456.789\"\n123_456.789.format(',', '.')                                  # => \"123.456,789\"\n123_456.789.format(decimal_places: 2)                         # => \"123,456.79\"\n123_456.789.format(decimal_places: 6)                         # => \"123,456.789000\"\n123_456.789.format(decimal_places: 6, only_significant: true) # => \"123,456.789\"\n```","summary":"<p>Prints this number as a <code><a href=\"String.html\">String</a></code> using a customizable format.</p>","abstract":false,"args":[{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"decimal_places","default_value":"nil","external_name":"decimal_places","restriction":"Int | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"group","default_value":"3","external_name":"group","restriction":"Int"},{"name":"only_significant","default_value":"false","external_name":"only_significant","restriction":"Bool"}],"args_string":"(separator = '.', delimiter = ',', decimal_places : Int? = nil, *, group : Int = 3, only_significant : Bool = false) : String","args_html":"(separator = <span class=\"s\">&#39;.&#39;</span>, delimiter = <span class=\"s\">&#39;,&#39;</span>, decimal_places : <a href=\"Int.html\">Int</a>? = <span class=\"n\">nil</span>, *, group : <a href=\"Int.html\">Int</a> = <span class=\"n\">3</span>, only_significant : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/humanize.cr","line_number":92,"url":null},"def":{"name":"format","args":[{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"decimal_places","default_value":"nil","external_name":"decimal_places","restriction":"Int | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"group","default_value":"3","external_name":"group","restriction":"Int"},{"name":"only_significant","default_value":"false","external_name":"only_significant","restriction":"Bool"}],"splat_index":3,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  format(io, separator, delimiter, decimal_places, group: group, only_significant: only_significant)\nend"}},{"html_id":"humanize(io:IO,precision=3,separator='.',delimiter=',',*,base=10**3,significant=true,prefixes:Indexable=SI_PREFIXES):Nil-instance-method","name":"humanize","doc":"Pretty prints this number as a `String` in a human-readable format.\n\nThis is particularly useful if a number can have a wide value range and\nthe *exact* value is less relevant.\n\nIt rounds the number to the nearest thousands magnitude with *precision*\nnumber of significant digits. The order of magnitude is expressed with an\nappended quantifier.\nBy default, SI prefixes are used (see `SI_PREFIXES`).\n\n```\n1_200_000_000.humanize # => \"1.2G\"\n0.000_000_012.humanize # => \"12.0n\"\n```\n\nIf *significant* is `false`, the number of *precision* digits is preserved\nafter the decimal separator.\n\n```\n1_234.567_890.humanize(precision: 2)                     # => \"1.2k\"\n1_234.567_890.humanize(precision: 2, significant: false) # => \"1.23k\"\n```\n\n*separator* describes the decimal separator, *delimiter* the thousands\ndelimiter (see `#format`).\n\nSee `Int#humanize_bytes` to format a file size.","summary":"<p>Pretty prints this number as a <code><a href=\"String.html\">String</a></code> in a human-readable format.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"precision","default_value":"3","external_name":"precision","restriction":""},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"base","default_value":"10 ** 3","external_name":"base","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":""},{"name":"prefixes","default_value":"SI_PREFIXES","external_name":"prefixes","restriction":"Indexable"}],"args_string":"(io : IO, precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, prefixes : Indexable = SI_PREFIXES) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, precision = <span class=\"n\">3</span>, separator = <span class=\"s\">&#39;.&#39;</span>, delimiter = <span class=\"s\">&#39;,&#39;</span>, *, base = <span class=\"n\">10</span> <span class=\"o\">**</span> <span class=\"n\">3</span>, significant = <span class=\"n\">true</span>, prefixes : <a href=\"Indexable.html\">Indexable</a> = <span class=\"t\">SI_PREFIXES</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/humanize.cr","line_number":151,"url":null},"def":{"name":"humanize","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"precision","default_value":"3","external_name":"precision","restriction":""},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"base","default_value":"10 ** 3","external_name":"base","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":""},{"name":"prefixes","default_value":"SI_PREFIXES","external_name":"prefixes","restriction":"Indexable"}],"splat_index":4,"return_type":"Nil","visibility":"Public","body":"humanize(io, precision, separator, delimiter, base: base, significant: significant) do |magnitude, _|\n  magnitude = Number.prefix_index(magnitude)\n  {magnitude, Number.si_prefix(magnitude, prefixes)}\nend"}},{"html_id":"humanize(io:IO,precision=3,separator='.',delimiter=',',*,base=10**3,significant=true,prefixes:Proc):Nil-instance-method","name":"humanize","doc":"Pretty prints this number as a `String` in a human-readable format.\n\nThis is particularly useful if a number can have a wide value range and\nthe *exact* value is less relevant.\n\nIt rounds the number to the nearest thousands magnitude with *precision*\nnumber of significant digits. The order of magnitude is expressed with an\nappended quantifier.\nBy default, SI prefixes are used (see `SI_PREFIXES`).\n\n```\n1_200_000_000.humanize # => \"1.2G\"\n0.000_000_012.humanize # => \"12.0n\"\n```\n\nIf *significant* is `false`, the number of *precision* digits is preserved\nafter the decimal separator.\n\n```\n1_234.567_890.humanize(precision: 2)                     # => \"1.2k\"\n1_234.567_890.humanize(precision: 2, significant: false) # => \"1.23k\"\n```\n\n*separator* describes the decimal separator, *delimiter* the thousands\ndelimiter (see `#format`).\n\nThis methods yields the order of magnitude and `self` and expects the block\nto return a `Tuple(Int32, _)` containing the (adjusted) magnitude and unit.\nThe magnitude is typically adjusted to a multiple of `3`.\n\n```\ndef humanize_length(number)\n  number.humanize do |magnitude, number|\n    case magnitude\n    when -2, -1 then {-2, \" cm\"}\n    when .>=(4)\n      {3, \" km\"}\n    else\n      magnitude = Number.prefix_index(magnitude)\n      {magnitude, \" #{Number.si_prefix(magnitude)}m\"}\n    end\n  end\nend\n\nhumanize_length(1_420) # => \"1.42 km\"\nhumanize_length(0.23)  # => \"23.0 cm\"\n```\n\nSee `Int#humanize_bytes` to format a file size.","summary":"<p>Pretty prints this number as a <code><a href=\"String.html\">String</a></code> in a human-readable format.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"precision","default_value":"3","external_name":"precision","restriction":""},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"base","default_value":"10 ** 3","external_name":"base","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":""},{"name":"prefixes","external_name":"prefixes","restriction":"Proc"}],"args_string":"(io : IO, precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, prefixes : Proc) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, precision = <span class=\"n\">3</span>, separator = <span class=\"s\">&#39;.&#39;</span>, delimiter = <span class=\"s\">&#39;,&#39;</span>, *, base = <span class=\"n\">10</span> <span class=\"o\">**</span> <span class=\"n\">3</span>, significant = <span class=\"n\">true</span>, prefixes : <a href=\"Proc.html\">Proc</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/humanize.cr","line_number":271,"url":null},"def":{"name":"humanize","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"precision","default_value":"3","external_name":"precision","restriction":""},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"base","default_value":"10 ** 3","external_name":"base","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":""},{"name":"prefixes","external_name":"prefixes","restriction":"Proc"}],"splat_index":4,"return_type":"Nil","visibility":"Public","body":"humanize(io, precision, separator, delimiter, base: base, significant: significant) do |magnitude, number|\n  prefixes.call(magnitude, number)\nend"}},{"html_id":"humanize(precision=3,separator='.',delimiter=',',*,base=10**3,significant=true,prefixes=SI_PREFIXES):String-instance-method","name":"humanize","doc":"Pretty prints this number as a `String` in a human-readable format.\n\nThis is particularly useful if a number can have a wide value range and\nthe *exact* value is less relevant.\n\nIt rounds the number to the nearest thousands magnitude with *precision*\nnumber of significant digits. The order of magnitude is expressed with an\nappended quantifier.\nBy default, SI prefixes are used (see `SI_PREFIXES`).\n\n```\n1_200_000_000.humanize # => \"1.2G\"\n0.000_000_012.humanize # => \"12.0n\"\n```\n\nIf *significant* is `false`, the number of *precision* digits is preserved\nafter the decimal separator.\n\n```\n1_234.567_890.humanize(precision: 2)                     # => \"1.2k\"\n1_234.567_890.humanize(precision: 2, significant: false) # => \"1.23k\"\n```\n\n*separator* describes the decimal separator, *delimiter* the thousands\ndelimiter (see `#format`).\n\nSee `Int#humanize_bytes` to format a file size.","summary":"<p>Pretty prints this number as a <code><a href=\"String.html\">String</a></code> in a human-readable format.</p>","abstract":false,"args":[{"name":"precision","default_value":"3","external_name":"precision","restriction":""},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"base","default_value":"10 ** 3","external_name":"base","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":""},{"name":"prefixes","default_value":"SI_PREFIXES","external_name":"prefixes","restriction":""}],"args_string":"(precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, prefixes = SI_PREFIXES) : String","args_html":"(precision = <span class=\"n\">3</span>, separator = <span class=\"s\">&#39;.&#39;</span>, delimiter = <span class=\"s\">&#39;,&#39;</span>, *, base = <span class=\"n\">10</span> <span class=\"o\">**</span> <span class=\"n\">3</span>, significant = <span class=\"n\">true</span>, prefixes = <span class=\"t\">SI_PREFIXES</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/humanize.cr","line_number":159,"url":null},"def":{"name":"humanize","args":[{"name":"precision","default_value":"3","external_name":"precision","restriction":""},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"base","default_value":"10 ** 3","external_name":"base","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":""},{"name":"prefixes","default_value":"SI_PREFIXES","external_name":"prefixes","restriction":""}],"splat_index":3,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  humanize(io, precision, separator, delimiter, base: base, significant: significant, prefixes: prefixes)\nend"}},{"html_id":"humanize(io:IO,precision=3,separator='.',delimiter=',',*,base=10**3,significant=true,&prefixes:Int32,Float64->Tuple(Int32,_)|Tuple(Int32,_,Bool)):Nil-instance-method","name":"humanize","doc":"Pretty prints this number as a `String` in a human-readable format.\n\nThis is particularly useful if a number can have a wide value range and\nthe *exact* value is less relevant.\n\nIt rounds the number to the nearest thousands magnitude with *precision*\nnumber of significant digits. The order of magnitude is expressed with an\nappended quantifier.\nBy default, SI prefixes are used (see `SI_PREFIXES`).\n\n```\n1_200_000_000.humanize # => \"1.2G\"\n0.000_000_012.humanize # => \"12.0n\"\n```\n\nIf *significant* is `false`, the number of *precision* digits is preserved\nafter the decimal separator.\n\n```\n1_234.567_890.humanize(precision: 2)                     # => \"1.2k\"\n1_234.567_890.humanize(precision: 2, significant: false) # => \"1.23k\"\n```\n\n*separator* describes the decimal separator, *delimiter* the thousands\ndelimiter (see `#format`).\n\nThis methods yields the order of magnitude and `self` and expects the block\nto return a `Tuple(Int32, _)` containing the (adjusted) magnitude and unit.\nThe magnitude is typically adjusted to a multiple of `3`.\n\n```\ndef humanize_length(number)\n  number.humanize do |magnitude, number|\n    case magnitude\n    when -2, -1 then {-2, \" cm\"}\n    when .>=(4)\n      {3, \" km\"}\n    else\n      magnitude = Number.prefix_index(magnitude)\n      {magnitude, \" #{Number.si_prefix(magnitude)}m\"}\n    end\n  end\nend\n\nhumanize_length(1_420) # => \"1.42 km\"\nhumanize_length(0.23)  # => \"23.0 cm\"\n```\n\nSee `Int#humanize_bytes` to format a file size.","summary":"<p>Pretty prints this number as a <code><a href=\"String.html\">String</a></code> in a human-readable format.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"precision","default_value":"3","external_name":"precision","restriction":""},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"base","default_value":"10 ** 3","external_name":"base","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":""}],"args_string":"(io : IO, precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, &prefixes : Int32, Float64 -> Tuple(Int32, _) | Tuple(Int32, _, Bool)) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, precision = <span class=\"n\">3</span>, separator = <span class=\"s\">&#39;.&#39;</span>, delimiter = <span class=\"s\">&#39;,&#39;</span>, *, base = <span class=\"n\">10</span> <span class=\"o\">**</span> <span class=\"n\">3</span>, significant = <span class=\"n\">true</span>, &prefixes : <a href=\"Int32.html\">Int32</a>, <a href=\"Float64.html\">Float64</a> -> <a href=\"Tuple.html\">Tuple</a>(<a href=\"Int32.html\">Int32</a>, _) | <a href=\"Tuple.html\">Tuple</a>(<a href=\"Int32.html\">Int32</a>, _, <a href=\"Bool.html\">Bool</a>)) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/humanize.cr","line_number":214,"url":null},"def":{"name":"humanize","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"precision","default_value":"3","external_name":"precision","restriction":""},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"base","default_value":"10 ** 3","external_name":"base","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":""}],"splat_index":4,"yields":2,"block_arg":{"name":"prefixes","external_name":"prefixes","restriction":"(Int32, Float64 -> ::Tuple(Int32, _) | ::Tuple(Int32, _, Bool))"},"return_type":"Nil","visibility":"Public","body":"if zero?\n  digits = 0\nelse\n  log = Math.log10(abs)\n  digits = log.floor.to_i + 1\nend\nmagnitude = digits\nproper_fraction = 0 < (__temp_39 = abs) && __temp_39 < 1\nif proper_fraction\n  magnitude = magnitude - 1\nelse\n  if magnitude == 0\n    magnitude = 1\n  end\nend\nyield_result = yield magnitude, self.to_f\nmagnitude, unit = yield_result[0..1]\ndecimal_places = precision\nif significant\n  scrap_digits = digits - precision\n  decimal_places = decimal_places + (magnitude - digits)\nelse\n  scrap_digits = magnitude - precision\nend\nif proper_fraction\n  scrap_digits = scrap_digits * -1\nend\nexponent = 10 ** scrap_digits.to_f\nif proper_fraction\n  number = (to_f * exponent).round / exponent\nelse\n  number = (to_f / exponent).round * exponent\nend\nnumber = number / (base.to_f ** (magnitude.to_f / 3.0))\nif yield_result[2]? == false\n  decimal_places = 0\nend\nnumber.format(io, separator, delimiter, decimal_places: decimal_places, only_significant: significant)\nio << unit\n"}},{"html_id":"humanize(precision=3,separator='.',delimiter=',',*,base=10**3,significant=true,&):String-instance-method","name":"humanize","doc":"Pretty prints this number as a `String` in a human-readable format.\n\nThis is particularly useful if a number can have a wide value range and\nthe *exact* value is less relevant.\n\nIt rounds the number to the nearest thousands magnitude with *precision*\nnumber of significant digits. The order of magnitude is expressed with an\nappended quantifier.\nBy default, SI prefixes are used (see `SI_PREFIXES`).\n\n```\n1_200_000_000.humanize # => \"1.2G\"\n0.000_000_012.humanize # => \"12.0n\"\n```\n\nIf *significant* is `false`, the number of *precision* digits is preserved\nafter the decimal separator.\n\n```\n1_234.567_890.humanize(precision: 2)                     # => \"1.2k\"\n1_234.567_890.humanize(precision: 2, significant: false) # => \"1.23k\"\n```\n\n*separator* describes the decimal separator, *delimiter* the thousands\ndelimiter (see `#format`).\n\nThis methods yields the order of magnitude and `self` and expects the block\nto return a `Tuple(Int32, _)` containing the (adjusted) magnitude and unit.\nThe magnitude is typically adjusted to a multiple of `3`.\n\n```\ndef humanize_length(number)\n  number.humanize do |magnitude, number|\n    case magnitude\n    when -2, -1 then {-2, \" cm\"}\n    when .>=(4)\n      {3, \" km\"}\n    else\n      magnitude = Number.prefix_index(magnitude)\n      {magnitude, \" #{Number.si_prefix(magnitude)}m\"}\n    end\n  end\nend\n\nhumanize_length(1_420) # => \"1.42 km\"\nhumanize_length(0.23)  # => \"23.0 cm\"\n```\n\nSee `Int#humanize_bytes` to format a file size.","summary":"<p>Pretty prints this number as a <code><a href=\"String.html\">String</a></code> in a human-readable format.</p>","abstract":false,"args":[{"name":"precision","default_value":"3","external_name":"precision","restriction":""},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"base","default_value":"10 ** 3","external_name":"base","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":""}],"args_string":"(precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, &) : String","args_html":"(precision = <span class=\"n\">3</span>, separator = <span class=\"s\">&#39;.&#39;</span>, delimiter = <span class=\"s\">&#39;,&#39;</span>, *, base = <span class=\"n\">10</span> <span class=\"o\">**</span> <span class=\"n\">3</span>, significant = <span class=\"n\">true</span>, &) : <a href=\"String.html\">String</a>","location":{"filename":"src/humanize.cr","line_number":262,"url":null},"def":{"name":"humanize","args":[{"name":"precision","default_value":"3","external_name":"precision","restriction":""},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"base","default_value":"10 ** 3","external_name":"base","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":""}],"splat_index":3,"yields":2,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  humanize(io, precision, separator, delimiter, base: base, significant: significant) do |magnitude, number|\n    yield magnitude, number\n  end\nend"}},{"html_id":"humanize(precision=3,separator='.',delimiter=',',*,base=10**3,significant=true,prefixes:Proc):String-instance-method","name":"humanize","doc":"Pretty prints this number as a `String` in a human-readable format.\n\nThis is particularly useful if a number can have a wide value range and\nthe *exact* value is less relevant.\n\nIt rounds the number to the nearest thousands magnitude with *precision*\nnumber of significant digits. The order of magnitude is expressed with an\nappended quantifier.\nBy default, SI prefixes are used (see `SI_PREFIXES`).\n\n```\n1_200_000_000.humanize # => \"1.2G\"\n0.000_000_012.humanize # => \"12.0n\"\n```\n\nIf *significant* is `false`, the number of *precision* digits is preserved\nafter the decimal separator.\n\n```\n1_234.567_890.humanize(precision: 2)                     # => \"1.2k\"\n1_234.567_890.humanize(precision: 2, significant: false) # => \"1.23k\"\n```\n\n*separator* describes the decimal separator, *delimiter* the thousands\ndelimiter (see `#format`).\n\nThis methods yields the order of magnitude and `self` and expects the block\nto return a `Tuple(Int32, _)` containing the (adjusted) magnitude and unit.\nThe magnitude is typically adjusted to a multiple of `3`.\n\n```\ndef humanize_length(number)\n  number.humanize do |magnitude, number|\n    case magnitude\n    when -2, -1 then {-2, \" cm\"}\n    when .>=(4)\n      {3, \" km\"}\n    else\n      magnitude = Number.prefix_index(magnitude)\n      {magnitude, \" #{Number.si_prefix(magnitude)}m\"}\n    end\n  end\nend\n\nhumanize_length(1_420) # => \"1.42 km\"\nhumanize_length(0.23)  # => \"23.0 cm\"\n```\n\nSee `Int#humanize_bytes` to format a file size.","summary":"<p>Pretty prints this number as a <code><a href=\"String.html\">String</a></code> in a human-readable format.</p>","abstract":false,"args":[{"name":"precision","default_value":"3","external_name":"precision","restriction":""},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"base","default_value":"10 ** 3","external_name":"base","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":""},{"name":"prefixes","external_name":"prefixes","restriction":"Proc"}],"args_string":"(precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, prefixes : Proc) : String","args_html":"(precision = <span class=\"n\">3</span>, separator = <span class=\"s\">&#39;.&#39;</span>, delimiter = <span class=\"s\">&#39;,&#39;</span>, *, base = <span class=\"n\">10</span> <span class=\"o\">**</span> <span class=\"n\">3</span>, significant = <span class=\"n\">true</span>, prefixes : <a href=\"Proc.html\">Proc</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/humanize.cr","line_number":278,"url":null},"def":{"name":"humanize","args":[{"name":"precision","default_value":"3","external_name":"precision","restriction":""},{"name":"separator","default_value":"'.'","external_name":"separator","restriction":""},{"name":"delimiter","default_value":"','","external_name":"delimiter","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"base","default_value":"10 ** 3","external_name":"base","restriction":""},{"name":"significant","default_value":"true","external_name":"significant","restriction":""},{"name":"prefixes","external_name":"prefixes","restriction":"Proc"}],"splat_index":3,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  humanize(io, precision, separator, delimiter, base: base, significant: significant, prefixes: prefixes)\nend"}},{"html_id":"i:Complex-instance-method","name":"i","abstract":false,"location":{"filename":"src/complex.cr","line_number":277,"url":null},"def":{"name":"i","return_type":"Complex","visibility":"Public","body":"Complex.new(0, self)"}},{"html_id":"negative?:Bool-instance-method","name":"negative?","doc":"Returns `true` if `self` is less than zero.\n\n```\n-1.negative? # => true\n0.negative?  # => false\n1.negative?  # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is less than zero.</p>","abstract":false,"location":{"filename":"src/number.cr","line_number":351,"url":null},"def":{"name":"negative?","return_type":"Bool","visibility":"Public","body":"self < 0"}},{"html_id":"positive?:Bool-instance-method","name":"positive?","doc":"Returns `true` if `self` is greater than zero.\n\n```\n-1.positive? # => false\n0.positive?  # => false\n1.positive?  # => true\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than zero.</p>","abstract":false,"location":{"filename":"src/number.cr","line_number":340,"url":null},"def":{"name":"positive?","return_type":"Bool","visibility":"Public","body":"self > 0"}},{"html_id":"round(mode:RoundingMode=:ties_even):self-instance-method","name":"round","doc":"Rounds `self` to an integer value using rounding *mode*.\n\nThe rounding *mode* controls the direction of the rounding. The default is\n`RoundingMode::TIES_EVEN` which rounds to the nearest integer, with ties\n(fractional value of `0.5`) being rounded to the even neighbor (Banker's rounding).","summary":"<p>Rounds <code>self</code> to an integer value using rounding <em>mode</em>.</p>","abstract":false,"args":[{"name":"mode","default_value":":ties_even","external_name":"mode","restriction":"RoundingMode"}],"args_string":"(mode : RoundingMode = :ties_even) : self","args_html":"(mode : <a href=\"Number/RoundingMode.html\">RoundingMode</a> = <span class=\"n\">:ties_even</span>) : <span class=\"k\">self</span>","location":{"filename":"src/number.cr","line_number":308,"url":null},"def":{"name":"round","args":[{"name":"mode","default_value":":ties_even","external_name":"mode","restriction":"RoundingMode"}],"return_type":"self","visibility":"Public","body":"case mode\nin .to_zero?\n  trunc\nin .to_positive?\n  ceil\nin .to_negative?\n  floor\nin .ties_away?\n  round_away\nin .ties_even?\n  round_even\nend"}},{"html_id":"round(digits:Number,base=10,*,mode:RoundingMode=:ties_even)-instance-method","name":"round","doc":"Rounds this number to a given precision.\n\nRounds to the specified number of *digits* after the decimal place,\n(or before if negative), in base *base*.\n\nThe rounding *mode* controls the direction of the rounding. The default is\n`RoundingMode::TIES_EVEN` which rounds to the nearest integer, with ties\n(fractional value of `0.5`) being rounded to the even neighbor (Banker's rounding).\n\n```\n-1763.116.round(2) # => -1763.12\n```","summary":"<p>Rounds this number to a given precision.</p>","abstract":false,"args":[{"name":"digits","external_name":"digits","restriction":"Number"},{"name":"base","default_value":"10","external_name":"base","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"mode","default_value":":ties_even","external_name":"mode","restriction":"RoundingMode"}],"args_string":"(digits : Number, base = 10, *, mode : RoundingMode = :ties_even)","args_html":"(digits : <a href=\"Number.html\">Number</a>, base = <span class=\"n\">10</span>, *, mode : <a href=\"Number/RoundingMode.html\">RoundingMode</a> = <span class=\"n\">:ties_even</span>)","location":{"filename":"src/number.cr","line_number":262,"url":null},"def":{"name":"round","args":[{"name":"digits","external_name":"digits","restriction":"Number"},{"name":"base","default_value":"10","external_name":"base","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"mode","default_value":":ties_even","external_name":"mode","restriction":"RoundingMode"}],"splat_index":2,"visibility":"Public","body":"if digits < 0\n  multiplier = base.to_f ** digits.abs\n  shifted = self / multiplier\nelse\n  multiplier = base.to_f ** digits\n  shifted = self * multiplier\nend\nrounded = shifted.round(mode)\nif digits < 0\n  result = rounded * multiplier\nelse\n  result = rounded / multiplier\nend\nself.class.new(result)\n"}},{"html_id":"sign:Int32-instance-method","name":"sign","doc":"Returns the sign of this number as an `Int32`.\n* `-1` if this number is negative\n* `0` if this number is zero\n* `1` if this number is positive\n\n```\n123.sign # => 1\n0.sign   # => 0\n-42.sign # => -1\n```","summary":"<p>Returns the sign of this number as an <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/number.cr","line_number":178,"url":null},"def":{"name":"sign","return_type":"Int32","visibility":"Public","body":"self < 0 ? -1 : (self == 0 ? 0 : 1)"}},{"html_id":"significant(digits,base=10)-instance-method","name":"significant","doc":"Keeps *digits* significant digits of this number in the given *base*.\n\n```\n1234.567.significant(1) # => 1000\n1234.567.significant(2) # => 1200\n1234.567.significant(3) # => 1230\n1234.567.significant(4) # => 1235\n1234.567.significant(5) # => 1234.6\n1234.567.significant(6) # => 1234.57\n1234.567.significant(7) # => 1234.567\n1234.567.significant(8) # => 1234.567\n\n15.159.significant(1, base = 2) # => 16\n```","summary":"<p>Keeps <em>digits</em> significant digits of this number in the given <em>base</em>.</p>","abstract":false,"args":[{"name":"digits","external_name":"digits","restriction":""},{"name":"base","default_value":"10","external_name":"base","restriction":""}],"args_string":"(digits, base = 10)","args_html":"(digits, base = <span class=\"n\">10</span>)","location":{"filename":"src/number.cr","line_number":222,"url":null},"def":{"name":"significant","args":[{"name":"digits","external_name":"digits","restriction":""},{"name":"base","default_value":"10","external_name":"base","restriction":""}],"visibility":"Public","body":"if digits < 0\n  raise(ArgumentError.new(\"digits should be non-negative\"))\nend\nif zero?\n  return self\nend\nx = self.to_f\nif base == 10\n  log = Math.log10(self.abs)\nelse\n  if base == 2\n    log = Math.log2(self.abs)\n  else\n    log = (Math.log2(self.abs)) / (Math.log2(base))\n  end\nend\nexponent = ((log - digits) + 1).floor\nif exponent < 0\n  y = base ** (-exponent)\n  value = (x * y).round / y\nelse\n  y = base ** exponent\n  value = (x / y).round * y\nend\nself.class.new(value)\n"}},{"html_id":"step(*,tolimit=nil,exclusive:Bool=false,&):Nil-instance-method","name":"step","doc":"Performs a `#step` in the direction of the _limit_. For instance:\n\n```\n10.step(to: 5).to_a # => [10, 9, 8, 7, 6, 5]\n5.step(to: 10).to_a # => [5, 6, 7, 8, 9, 10]\n```","summary":"<p>Performs a <code><a href=\"Number.html#step%28%2A%2Ctolimit%3Dnil%2Cexclusive%3ABool%3Dfalse%2C%26%29%3ANil-instance-method\">#step</a></code> in the direction of the <em>limit</em>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"limit","default_value":"nil","external_name":"to","restriction":""},{"name":"exclusive","default_value":"false","external_name":"exclusive","restriction":"Bool"}],"args_string":"(*, to limit = nil, exclusive : Bool = false, &) : Nil","args_html":"(*, to limit = <span class=\"n\">nil</span>, exclusive : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/number.cr","line_number":127,"url":null},"def":{"name":"step","args":[{"name":"","external_name":"","restriction":""},{"name":"limit","default_value":"nil","external_name":"to","restriction":""},{"name":"exclusive","default_value":"false","external_name":"exclusive","restriction":"Bool"}],"splat_index":0,"yields":1,"return_type":"Nil","visibility":"Public","body":"if limit\n  direction = limit <=> self\nend\nstep = direction.try(&.sign) || 1\nstep(to: limit, by: step, exclusive: exclusive) do |x|\n  yield x\nend\n"}},{"html_id":"step(*,tolimit=nil,exclusive:Bool=false)-instance-method","name":"step","doc":"Performs a `#step` in the direction of the _limit_. For instance:\n\n```\n10.step(to: 5).to_a # => [10, 9, 8, 7, 6, 5]\n5.step(to: 10).to_a # => [5, 6, 7, 8, 9, 10]\n```","summary":"<p>Performs a <code><a href=\"Number.html#step%28%2A%2Ctolimit%3Dnil%2Cexclusive%3ABool%3Dfalse%2C%26%29%3ANil-instance-method\">#step</a></code> in the direction of the <em>limit</em>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"limit","default_value":"nil","external_name":"to","restriction":""},{"name":"exclusive","default_value":"false","external_name":"exclusive","restriction":"Bool"}],"args_string":"(*, to limit = nil, exclusive : Bool = false)","args_html":"(*, to limit = <span class=\"n\">nil</span>, exclusive : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>)","location":{"filename":"src/number.cr","line_number":139,"url":null},"def":{"name":"step","args":[{"name":"","external_name":"","restriction":""},{"name":"limit","default_value":"nil","external_name":"to","restriction":""},{"name":"exclusive","default_value":"false","external_name":"exclusive","restriction":"Bool"}],"splat_index":0,"visibility":"Public","body":"if limit\n  direction = limit <=> self\nend\nstep = direction.try(&.sign) || 1\nstep(to: limit, by: step, exclusive: exclusive)\n"}},{"html_id":"to_big_f:BigFloat-instance-method","name":"to_big_f","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":378,"url":null},"def":{"name":"to_big_f","return_type":"BigFloat","visibility":"Public","body":"BigFloat.new(self)"}},{"html_id":"to_c:Complex-instance-method","name":"to_c","abstract":false,"location":{"filename":"src/complex.cr","line_number":273,"url":null},"def":{"name":"to_c","return_type":"Complex","visibility":"Public","body":"Complex.new(self, 0)"}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder) : Nil","args_html":"(yaml : <a href=\"YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":78,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"yaml.scalar(self.to_s)"}},{"html_id":"zero?:Bool-instance-method","name":"zero?","doc":"Returns `true` if `self` is equal to zero.\n\n```\n0.zero? # => true\n5.zero? # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to zero.</p>","abstract":false,"location":{"filename":"src/number.cr","line_number":329,"url":null},"def":{"name":"zero?","return_type":"Bool","visibility":"Public","body":"self == 0"}}],"macros":[{"html_id":"[](*nums)-macro","name":"[]","doc":"Creates an `Array` of `self` with the given values, which will be casted\nto this type with the `new` method (defined in each `Number` type).\n\n```\nfloats = Float64[1, 2, 3, 4]\nfloats.class # => Array(Float64)\n\nints = Int64[1, 2, 3]\nints.class # => Array(Int64)\n```","summary":"<p>Creates an <code><a href=\"Array.html\">Array</a></code> of <code>self</code> with the given values, which will be casted to this type with the <code>new</code> method (defined in each <code><a href=\"Number.html\">Number</a></code> type).</p>","abstract":false,"args":[{"name":"nums","external_name":"nums","restriction":""}],"args_string":"(*nums)","args_html":"(*nums)","location":{"filename":"src/number.cr","line_number":74,"url":null},"def":{"name":"[]","args":[{"name":"nums","external_name":"nums","restriction":""}],"splat_index":0,"visibility":"Public","body":"    Array(\n{{ @type }}\n).build(\n{{ nums.size }}\n) do |\n%buffer\n|\n      \n{% for num, i in nums %}\n        %buffer[{{ i }}] = {{ @type }}.new({{ num }})\n      {% end %}\n\n      \n{{ nums.size }}\n\n    \nend\n  \n"}},{"html_id":"slice(*nums,read_only=false)-macro","name":"slice","doc":"Creates a `Slice` of `self` with the given values, which will be casted\nto this type with the `new` method (defined in each `Number` type).\n\nThe slice is allocated on the heap.\n\n```\nfloats = Float64.slice(1, 2, 3, 4)\nfloats.class # => Slice(Float64)\n\nints = Int64.slice(1, 2, 3)\nints.class # => Slice(Int64)\n```","summary":"<p>Creates a <code><a href=\"Slice.html\">Slice</a></code> of <code>self</code> with the given values, which will be casted to this type with the <code>new</code> method (defined in each <code><a href=\"Number.html\">Number</a></code> type).</p>","abstract":false,"args":[{"name":"nums","external_name":"nums","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(*nums, read_only = false)","args_html":"(*nums, read_only = <span class=\"n\">false</span>)","location":{"filename":"src/number.cr","line_number":95,"url":null},"def":{"name":"slice","args":[{"name":"nums","external_name":"nums","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"splat_index":0,"visibility":"Public","body":"    \n%slice\n = Slice(\n{{ @type }}\n).new(\n{{ nums.size }}\n, read_only: \n{{ read_only }}\n)\n    \n{% for num, i in nums %}\n      %slice.to_unsafe[{{ i }}] = {{ @type }}.new!({{ num }})\n    {% end %}\n\n    \n%slice\n\n  \n"}},{"html_id":"static_array(*nums)-macro","name":"static_array","doc":"Creates a `StaticArray` of `self` with the given values, which will be casted\nto this type with the `new` method (defined in each `Number` type).\n\n```\nfloats = Float64.static_array(1, 2, 3, 4)\nfloats.class # => StaticArray(Float64, 4)\n\nints = Int64.static_array(1, 2, 3)\nints.class # => StaticArray(Int64, 3)\n```","summary":"<p>Creates a <code><a href=\"StaticArray.html\">StaticArray</a></code> of <code>self</code> with the given values, which will be casted to this type with the <code>new</code> method (defined in each <code><a href=\"Number.html\">Number</a></code> type).</p>","abstract":false,"args":[{"name":"nums","external_name":"nums","restriction":""}],"args_string":"(*nums)","args_html":"(*nums)","location":{"filename":"src/number.cr","line_number":113,"url":null},"def":{"name":"static_array","args":[{"name":"nums","external_name":"nums","restriction":""}],"splat_index":0,"visibility":"Public","body":"    \n%array\n = uninitialized StaticArray(\n{{ @type }}\n, \n{{ nums.size }}\n)\n    \n{% for num, i in nums %}\n      %array.to_unsafe[{{ i }}] = {{ @type }}.new!({{ num }})\n    {% end %}\n\n    \n%array\n\n  \n"}}],"types":[{"html_id":"Crystal/Number/Primitive","path":"Number/Primitive.html","kind":"alias","full_name":"Number::Primitive","name":"Primitive","abstract":false,"locations":[{"filename":"src/number.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(Float32 | Float64 | Int128 | Int16 | Int32 | Int64 | Int8 | UInt128 | UInt16 | UInt32 | UInt64 | UInt8)","aliased_html":"<a href=\"../Float32.html\">Float32</a> | <a href=\"../Float64.html\">Float64</a> | <a href=\"../Int128.html\">Int128</a> | <a href=\"../Int16.html\">Int16</a> | <a href=\"../Int32.html\">Int32</a> | <a href=\"../Int64.html\">Int64</a> | <a href=\"../Int8.html\">Int8</a> | <a href=\"../UInt128.html\">UInt128</a> | <a href=\"../UInt16.html\">UInt16</a> | <a href=\"../UInt32.html\">UInt32</a> | <a href=\"../UInt64.html\">UInt64</a> | <a href=\"../UInt8.html\">UInt8</a>","const":false,"namespace":{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"}},{"html_id":"Crystal/Number/RoundingMode","path":"Number/RoundingMode.html","kind":"enum","full_name":"Number::RoundingMode","name":"RoundingMode","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/number.cr","line_number":284,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"TIES_EVEN","name":"TIES_EVEN","value":"0","doc":"Rounds towards the nearest integer. If both neighboring integers are equidistant,\nrounds towards the even neighbor (Banker's rounding).","summary":"<p>Rounds towards the nearest integer.</p>"},{"id":"TIES_AWAY","name":"TIES_AWAY","value":"1","doc":"Rounds towards the nearest integer. If both neighboring integers are equidistant,\nrounds away from zero.","summary":"<p>Rounds towards the nearest integer.</p>"},{"id":"TO_ZERO","name":"TO_ZERO","value":"2","doc":"Rounds towards zero (truncate).","summary":"<p>Rounds towards zero (truncate).</p>"},{"id":"TO_POSITIVE","name":"TO_POSITIVE","value":"3","doc":"Rounds towards positive infinity (ceil).","summary":"<p>Rounds towards positive infinity (ceil).</p>"},{"id":"TO_NEGATIVE","name":"TO_NEGATIVE","value":"4","doc":"Rounds towards negative infinity (floor).","summary":"<p>Rounds towards negative infinity (floor).</p>"}],"namespace":{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},"doc":"Specifies rounding behaviour for numerical operations capable of discarding\nprecision.","summary":"<p>Specifies rounding behaviour for numerical operations capable of discarding precision.</p>","instance_methods":[{"html_id":"ties_away?-instance-method","name":"ties_away?","abstract":false,"location":{"filename":"src/number.cr","line_number":291,"url":null},"def":{"name":"ties_away?","visibility":"Public","body":"self == TIES_AWAY"}},{"html_id":"ties_even?-instance-method","name":"ties_even?","abstract":false,"location":{"filename":"src/number.cr","line_number":287,"url":null},"def":{"name":"ties_even?","visibility":"Public","body":"self == TIES_EVEN"}},{"html_id":"to_negative?-instance-method","name":"to_negative?","abstract":false,"location":{"filename":"src/number.cr","line_number":300,"url":null},"def":{"name":"to_negative?","visibility":"Public","body":"self == TO_NEGATIVE"}},{"html_id":"to_positive?-instance-method","name":"to_positive?","abstract":false,"location":{"filename":"src/number.cr","line_number":297,"url":null},"def":{"name":"to_positive?","visibility":"Public","body":"self == TO_POSITIVE"}},{"html_id":"to_zero?-instance-method","name":"to_zero?","abstract":false,"location":{"filename":"src/number.cr","line_number":294,"url":null},"def":{"name":"to_zero?","visibility":"Public","body":"self == TO_ZERO"}}]}]},{"html_id":"Crystal/OAuth","path":"OAuth.html","kind":"module","full_name":"OAuth","name":"OAuth","abstract":false,"locations":[{"filename":"src/oauth/access_token.cr","line_number":1,"url":null},{"filename":"src/oauth/oauth.cr","line_number":38,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"The OAuth module provides an `OAuth::Consumer` as specified by\n[RFC 5849](https://tools.ietf.org/html/rfc5849).\n\n### Performing HTTP client requests with OAuth authentication\n\nAssuming you have an access token, its secret, the consumer key and the consumer secret,\nyou can setup an `HTTP::Client` to be authenticated with OAuth using this code:\n\n```\nrequire \"http/client\"\nrequire \"oauth\"\n\ntoken = \"some_token\"\nsecret = \"some_secret\"\nconsumer_key = \"some_consumer_key\"\nconsumer_secret = \"some_consumer_secret\"\n\n# Create an HTTP::Client as usual\nclient = HTTP::Client.new(\"api.example.com\", tls: true)\n\n# Prepare it for using OAuth authentication\nOAuth.authenticate(client, token, secret, consumer_key, consumer_secret)\n\n# Execute requests as usual: they will be authenticated\nclient.get(\"/some_path\")\n```\n\nThis is implemented with `HTTP::Client#before_request` to add an authorization\nheader to every request.\n\nAlternatively, you can create an `OAuth::Consumer` and then invoke its\n`OAuth::Consumer#authenticate` method, or create an `OAuth::AccessToken`\nand invoke its `OAuth::AccessToken#authenticate`.\n\n### Obtaining access tokens\n\nSee `OAuth::Consumer` for an example.","summary":"<p>The OAuth module provides an <code><a href=\"OAuth/Consumer.html\">OAuth::Consumer</a></code> as specified by <a href=\"https://tools.ietf.org/html/rfc5849\">RFC 5849</a>.</p>","class_methods":[{"html_id":"authenticate(client:HTTP::Client,token,token_secret,consumer_key,consumer_secret,extra_params=nil):Nil-class-method","name":"authenticate","doc":"Sets up an `HTTP::Client` to add an OAuth authorization header to every request performed.\nCheck this module's docs for an example usage.","summary":"<p>Sets up an <code><a href=\"HTTP/Client.html\">HTTP::Client</a></code> to add an OAuth authorization header to every request performed.</p>","abstract":false,"args":[{"name":"client","external_name":"client","restriction":"HTTP::Client"},{"name":"token","external_name":"token","restriction":""},{"name":"token_secret","external_name":"token_secret","restriction":""},{"name":"consumer_key","external_name":"consumer_key","restriction":""},{"name":"consumer_secret","external_name":"consumer_secret","restriction":""},{"name":"extra_params","default_value":"nil","external_name":"extra_params","restriction":""}],"args_string":"(client : HTTP::Client, token, token_secret, consumer_key, consumer_secret, extra_params = nil) : Nil","args_html":"(client : <a href=\"HTTP/Client.html\">HTTP::Client</a>, token, token_secret, consumer_key, consumer_secret, extra_params = <span class=\"n\">nil</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/oauth/oauth.cr","line_number":41,"url":null},"def":{"name":"authenticate","args":[{"name":"client","external_name":"client","restriction":"HTTP::Client"},{"name":"token","external_name":"token","restriction":""},{"name":"token_secret","external_name":"token_secret","restriction":""},{"name":"consumer_key","external_name":"consumer_key","restriction":""},{"name":"consumer_secret","external_name":"consumer_secret","restriction":""},{"name":"extra_params","default_value":"nil","external_name":"extra_params","restriction":""}],"return_type":"Nil","visibility":"Public","body":"client.before_request do |request|\n  authenticate(client, request, token, token_secret, consumer_key, consumer_secret, extra_params)\nend"}}],"types":[{"html_id":"Crystal/OAuth/AccessToken","path":"OAuth/AccessToken.html","kind":"class","full_name":"OAuth::AccessToken","name":"AccessToken","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/oauth/access_token.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OAuth","kind":"module","full_name":"OAuth","name":"OAuth"},"constructors":[{"html_id":"from_response(response:String):self-class-method","name":"from_response","abstract":false,"args":[{"name":"response","external_name":"response","restriction":"String"}],"args_string":"(response : String) : self","args_html":"(response : <a href=\"../String.html\">String</a>) : <span class=\"k\">self</span>","location":{"filename":"src/oauth/access_token.cr","line_number":16,"url":null},"def":{"name":"from_response","args":[{"name":"response","external_name":"response","restriction":"String"}],"return_type":"self","visibility":"Public","body":"token = nil\nsecret = nil\nextra = nil\nURI::Params.parse(response) do |key, value|\n  case key\n  when \"oauth_token\"\n    token = value\n  when \"oauth_token_secret\"\n    secret = value\n  else\n    extra || (extra = {} of String => String)\n    extra[key] = value\n  end\nend\nnew(token.not_nil!, secret.not_nil!, extra)\n"}},{"html_id":"new(token:String,secret:String,extra:Hash(String,String)?=nil)-class-method","name":"new","abstract":false,"args":[{"name":"token","external_name":"token","restriction":"String"},{"name":"secret","external_name":"secret","restriction":"String"},{"name":"extra","default_value":"nil","external_name":"extra","restriction":"Hash(String, String) | ::Nil"}],"args_string":"(token : String, secret : String, extra : Hash(String, String)? = nil)","args_html":"(token : <a href=\"../String.html\">String</a>, secret : <a href=\"../String.html\">String</a>, extra : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>)? = <span class=\"n\">nil</span>)","location":{"filename":"src/oauth/access_token.cr","line_number":5,"url":null},"def":{"name":"new","args":[{"name":"token","external_name":"token","restriction":"String"},{"name":"secret","external_name":"secret","restriction":"String"},{"name":"extra","default_value":"nil","external_name":"extra","restriction":"Hash(String, String) | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(token, secret, extra)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"../JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/oauth/access_token.cr","line_number":34,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"token = nil\nsecret = nil\nextra = nil\npull.read_object do |key|\n  case key\n  when \"oauth_token\"\n    token = pull.read_string\n  when \"oauth_token_secret\"\n    secret = pull.read_string\n  else\n    if pull.kind.string?\n      extra || (extra = {} of String => String)\n      extra[key] = pull.read_string\n    else\n      pull.skip\n    end\n  end\nend\nnew(token.not_nil!, secret.not_nil!, extra)\n"}}],"instance_methods":[{"html_id":"authenticate(client,consumer_key,consumer_secret,extra_params=nil)-instance-method","name":"authenticate","abstract":false,"args":[{"name":"client","external_name":"client","restriction":""},{"name":"consumer_key","external_name":"consumer_key","restriction":""},{"name":"consumer_secret","external_name":"consumer_secret","restriction":""},{"name":"extra_params","default_value":"nil","external_name":"extra_params","restriction":""}],"args_string":"(client, consumer_key, consumer_secret, extra_params = nil)","args_html":"(client, consumer_key, consumer_secret, extra_params = <span class=\"n\">nil</span>)","location":{"filename":"src/oauth/access_token.cr","line_number":8,"url":null},"def":{"name":"authenticate","args":[{"name":"client","external_name":"client","restriction":""},{"name":"consumer_key","external_name":"consumer_key","restriction":""},{"name":"consumer_secret","external_name":"consumer_secret","restriction":""},{"name":"extra_params","default_value":"nil","external_name":"extra_params","restriction":""}],"visibility":"Public","body":"OAuth.authenticate(client, @token, @secret, consumer_key, consumer_secret, extra_params)"}},{"html_id":"extra:Hash(String,String)-instance-method","name":"extra","abstract":false,"location":{"filename":"src/oauth/access_token.cr","line_number":12,"url":null},"def":{"name":"extra","return_type":"Hash(String, String)","visibility":"Public","body":"@extra || (@extra = {} of String => String)"}},{"html_id":"secret:String-instance-method","name":"secret","abstract":false,"location":{"filename":"src/oauth/access_token.cr","line_number":3,"url":null},"def":{"name":"secret","return_type":"String","visibility":"Public","body":"@secret"}},{"html_id":"to_json(json:JSON::Builder)-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder)","args_html":"(json : <a href=\"../JSON/Builder.html\">JSON::Builder</a>)","location":{"filename":"src/oauth/access_token.cr","line_number":58,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"visibility":"Public","body":"json.object do\n  json.field(\"oauth_token\", @token)\n  json.field(\"oauth_token_secret\", @secret)\n  @extra.try(&.each do |key, value|\n    json.field(key, value)\n  end)\nend"}},{"html_id":"token:String-instance-method","name":"token","abstract":false,"location":{"filename":"src/oauth/access_token.cr","line_number":2,"url":null},"def":{"name":"token","return_type":"String","visibility":"Public","body":"@token"}}]},{"html_id":"Crystal/OAuth/Consumer","path":"OAuth/Consumer.html","kind":"class","full_name":"OAuth::Consumer","name":"Consumer","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/oauth/consumer.cr","line_number":53,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OAuth","kind":"module","full_name":"OAuth","name":"OAuth"},"doc":"An OAuth consumer.\n\nFor a quick example of how to authenticate an `HTTP::Client` with OAuth if\nyou already have an access token, check the `OAuth` module description.\n\nThis class also provides methods to get request tokens, build authorize URIs\nand get access tokens, as specified by [RFC 5849](https://tools.ietf.org/html/rfc5849).\n\n### Example\n\n```\nrequire \"oauth\"\n\nconsumer_key = \"some_key\"\nconsumer_secret = \"some_secret\"\noauth_callback = \"http://some.callback\"\n\n# Create consumer, optionally pass custom URIs if needed,\n# if the request, authorize or access_token URIs are not the standard ones\n# (they can also be absolute URLs)\nconsumer = OAuth::Consumer.new(\"api.example.com\", consumer_key, consumer_secret)\n\n# Get a request token.\n# We probably need to save this somewhere to get it back in the\n# callback URL (saving token and secret should be enough)\nrequest_token = consumer.get_request_token(oauth_callback)\n\n# Build an authorize URI\nauthorize_uri = consumer.get_authorize_uri(request_token, oauth_callback)\n\n# Redirect the user to `authorize_uri`...\n#\n# ...\n#\n# When http://some.callback is hit, once the user authorized the access,\n# we resume our logic to finally get an access token. The callback URL\n# should receive an `oauth_verifier` parameter that we need to use.\noauth_verifier = request.params[\"oauth_verifier\"]\n\n# Get the access token\naccess_token = consumer.get_access_token(request_token, oauth_verifier)\n\n# Probably save the access token for reuse... This can be done\n# with `to_json` and `from_json`.\n\n# Use the token to authenticate an HTTP::Client\nclient = HTTP::Client.new(\"api.example.com\", tls: true)\naccess_token.authenticate(client, consumer_key, consumer_secret)\n\n# And do requests as usual\nclient.get \"/some_path\"\n```","summary":"<p>An OAuth consumer.</p>","constructors":[{"html_id":"new(host:String,consumer_key:String,consumer_secret:String,port:Int32?=nil,scheme:String=\"https\",request_token_uri:String=\"/oauth/request_token\",authorize_uri:String=\"/oauth/authorize\",access_token_uri:String=\"/oauth/access_token\")-class-method","name":"new","doc":"Creates an OAuth consumer.\n\nAny or all of the customizable URIs *request_token_uri*, *authorize_uri* and\n*access_token_uri* can be relative or absolute.\nIf they are relative, the given *host*, *port* and *scheme* will be used.\nIf they are absolute, the absolute URL will be used.","summary":"<p>Creates an OAuth consumer.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"consumer_key","external_name":"consumer_key","restriction":"String"},{"name":"consumer_secret","external_name":"consumer_secret","restriction":"String"},{"name":"port","default_value":"nil","external_name":"port","restriction":"Int32 | ::Nil"},{"name":"scheme","default_value":"\"https\"","external_name":"scheme","restriction":"String"},{"name":"request_token_uri","default_value":"\"/oauth/request_token\"","external_name":"request_token_uri","restriction":"String"},{"name":"authorize_uri","default_value":"\"/oauth/authorize\"","external_name":"authorize_uri","restriction":"String"},{"name":"access_token_uri","default_value":"\"/oauth/access_token\"","external_name":"access_token_uri","restriction":"String"}],"args_string":"(host : String, consumer_key : String, consumer_secret : String, port : Int32? = nil, scheme : String = \"https\", request_token_uri : String = \"/oauth/request_token\", authorize_uri : String = \"/oauth/authorize\", access_token_uri : String = \"/oauth/access_token\")","args_html":"(host : <a href=\"../String.html\">String</a>, consumer_key : <a href=\"../String.html\">String</a>, consumer_secret : <a href=\"../String.html\">String</a>, port : <a href=\"../Int32.html\">Int32</a>? = <span class=\"n\">nil</span>, scheme : <a href=\"../String.html\">String</a> = <span class=\"s\">&quot;https&quot;</span>, request_token_uri : <a href=\"../String.html\">String</a> = <span class=\"s\">&quot;/oauth/request_token&quot;</span>, authorize_uri : <a href=\"../String.html\">String</a> = <span class=\"s\">&quot;/oauth/authorize&quot;</span>, access_token_uri : <a href=\"../String.html\">String</a> = <span class=\"s\">&quot;/oauth/access_token&quot;</span>)","location":{"filename":"src/oauth/consumer.cr","line_number":62,"url":null},"def":{"name":"new","args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"consumer_key","external_name":"consumer_key","restriction":"String"},{"name":"consumer_secret","external_name":"consumer_secret","restriction":"String"},{"name":"port","default_value":"nil","external_name":"port","restriction":"Int32 | ::Nil"},{"name":"scheme","default_value":"\"https\"","external_name":"scheme","restriction":"String"},{"name":"request_token_uri","default_value":"\"/oauth/request_token\"","external_name":"request_token_uri","restriction":"String"},{"name":"authorize_uri","default_value":"\"/oauth/authorize\"","external_name":"authorize_uri","restriction":"String"},{"name":"access_token_uri","default_value":"\"/oauth/access_token\"","external_name":"access_token_uri","restriction":"String"}],"visibility":"Public","body":"_ = allocate\n_.initialize(host, consumer_key, consumer_secret, port, scheme, request_token_uri, authorize_uri, access_token_uri)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"authenticate(client:HTTP::Client,token:AccessToken):Nil-instance-method","name":"authenticate","doc":"Authenticated an `HTTP::Client` to add an OAuth authorization header, as specified by\n[RFC 5849, Section 3](https://tools.ietf.org/html/rfc5849#section-3).","summary":"<p>Authenticated an <code><a href=\"../HTTP/Client.html\">HTTP::Client</a></code> to add an OAuth authorization header, as specified by <a href=\"https://tools.ietf.org/html/rfc5849#section-3\">RFC 5849, Section 3</a>.</p>","abstract":false,"args":[{"name":"client","external_name":"client","restriction":"HTTP::Client"},{"name":"token","external_name":"token","restriction":"AccessToken"}],"args_string":"(client : HTTP::Client, token : AccessToken) : Nil","args_html":"(client : <a href=\"../HTTP/Client.html\">HTTP::Client</a>, token : <a href=\"../OAuth/AccessToken.html\">AccessToken</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/oauth/consumer.cr","line_number":129,"url":null},"def":{"name":"authenticate","args":[{"name":"client","external_name":"client","restriction":"HTTP::Client"},{"name":"token","external_name":"token","restriction":"AccessToken"}],"return_type":"Nil","visibility":"Public","body":"authenticate(client, token.token, token.secret, nil)"}},{"html_id":"get_access_token(request_token,oauth_verifier,extra_params=nil):AccessToken-instance-method","name":"get_access_token","doc":"Gets an access token from a previously obtained request token and an *oauth_verifier*\nobtained from an authorize URI, as specified by\n[RFC 5849, Section 2.3](https://tools.ietf.org/html/rfc5849#section-2.3).\n\nRaises `OAuth::Error` if there was an error getting the access token.","summary":"<p>Gets an access token from a previously obtained request token and an <em>oauth_verifier</em> obtained from an authorize URI, as specified by <a href=\"https://tools.ietf.org/html/rfc5849#section-2.3\">RFC 5849, Section 2.3</a>.</p>","abstract":false,"args":[{"name":"request_token","external_name":"request_token","restriction":""},{"name":"oauth_verifier","external_name":"oauth_verifier","restriction":""},{"name":"extra_params","default_value":"nil","external_name":"extra_params","restriction":""}],"args_string":"(request_token, oauth_verifier, extra_params = nil) : AccessToken","args_html":"(request_token, oauth_verifier, extra_params = <span class=\"n\">nil</span>) : <a href=\"../OAuth/AccessToken.html\">AccessToken</a>","location":{"filename":"src/oauth/consumer.cr","line_number":119,"url":null},"def":{"name":"get_access_token","args":[{"name":"request_token","external_name":"request_token","restriction":""},{"name":"oauth_verifier","external_name":"oauth_verifier","restriction":""},{"name":"extra_params","default_value":"nil","external_name":"extra_params","restriction":""}],"return_type":"AccessToken","visibility":"Public","body":"extra_params || (extra_params = {} of String => String)\nextra_params[\"oauth_verifier\"] = oauth_verifier\npost(request_token.token, request_token.secret, extra_params, @access_token_uri) do |response|\n  AccessToken.from_response(response.body)\nend\n"}},{"html_id":"get_authorize_uri(request_token,oauth_callback=nil):String-instance-method","name":"get_authorize_uri","doc":"Returns an authorize URI from a given request token to redirect the user\nto obtain an access token, as specified by\n[RFC 5849, Section 2.2](https://tools.ietf.org/html/rfc5849#section-2.2).","summary":"<p>Returns an authorize URI from a given request token to redirect the user to obtain an access token, as specified by <a href=\"https://tools.ietf.org/html/rfc5849#section-2.2\">RFC 5849, Section 2.2</a>.</p>","abstract":false,"args":[{"name":"request_token","external_name":"request_token","restriction":""},{"name":"oauth_callback","default_value":"nil","external_name":"oauth_callback","restriction":""}],"args_string":"(request_token, oauth_callback = nil) : String","args_html":"(request_token, oauth_callback = <span class=\"n\">nil</span>) : <a href=\"../String.html\">String</a>","location":{"filename":"src/oauth/consumer.cr","line_number":84,"url":null},"def":{"name":"get_authorize_uri","args":[{"name":"request_token","external_name":"request_token","restriction":""},{"name":"oauth_callback","default_value":"nil","external_name":"oauth_callback","restriction":""}],"return_type":"String","visibility":"Public","body":"get_authorize_uri(request_token, oauth_callback) do\nend"}},{"html_id":"get_authorize_uri(request_token,oauth_callback=nil,&block:URI::Params::Builder->):String-instance-method","name":"get_authorize_uri","doc":"Returns an authorize URI from a given request token to redirect the user\nto obtain an access token, as specified by\n[RFC 5849, Section 2.2](https://tools.ietf.org/html/rfc5849#section-2.2).\n\nYields an `URI::Params::Builder` to add extra parameters other than those\ndefined by the standard.","summary":"<p>Returns an authorize URI from a given request token to redirect the user to obtain an access token, as specified by <a href=\"https://tools.ietf.org/html/rfc5849#section-2.2\">RFC 5849, Section 2.2</a>.</p>","abstract":false,"args":[{"name":"request_token","external_name":"request_token","restriction":""},{"name":"oauth_callback","default_value":"nil","external_name":"oauth_callback","restriction":""}],"args_string":"(request_token, oauth_callback = nil, &block : URI::Params::Builder -> ) : String","args_html":"(request_token, oauth_callback = <span class=\"n\">nil</span>, &block : <a href=\"../URI/Params/Builder.html\">URI::Params::Builder</a> -> ) : <a href=\"../String.html\">String</a>","location":{"filename":"src/oauth/consumer.cr","line_number":94,"url":null},"def":{"name":"get_authorize_uri","args":[{"name":"request_token","external_name":"request_token","restriction":""},{"name":"oauth_callback","default_value":"nil","external_name":"oauth_callback","restriction":""}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(URI::Params::Builder ->)"},"return_type":"String","visibility":"Public","body":"uri = URI.parse(@authorize_uri)\nif uri.host\nelse\n  uri = URI.new(@scheme, @host, @port, @authorize_uri)\nend\nuri.query = URI::Params.build do |form|\n  form.add(\"oauth_token\", request_token.token)\n  if oauth_callback\n    form.add(\"oauth_callback\", oauth_callback)\n  end\n  uri.query_params.each do |key, value|\n    form.add(key, value)\n  end\n  yield form\nend\nuri.to_s\n"}},{"html_id":"get_request_token(oauth_callback=\"oob\")-instance-method","name":"get_request_token","doc":"Obtains a request token, also known as \"temporary credentials\", as specified by\n[RFC 5849, Section 2.1](https://tools.ietf.org/html/rfc5849#section-2.1).\n\nRaises `OAuth::Error` if there was an error getting the request token.","summary":"<p>Obtains a request token, also known as &quot;temporary credentials&quot;, as specified by <a href=\"https://tools.ietf.org/html/rfc5849#section-2.1\">RFC 5849, Section 2.1</a>.</p>","abstract":false,"args":[{"name":"oauth_callback","default_value":"\"oob\"","external_name":"oauth_callback","restriction":""}],"args_string":"(oauth_callback = \"oob\")","args_html":"(oauth_callback = <span class=\"s\">&quot;oob&quot;</span>)","location":{"filename":"src/oauth/consumer.cr","line_number":75,"url":null},"def":{"name":"get_request_token","args":[{"name":"oauth_callback","default_value":"\"oob\"","external_name":"oauth_callback","restriction":""}],"visibility":"Public","body":"post(nil, nil, {\"oauth_callback\" => oauth_callback}, @request_token_uri) do |response|\n  RequestToken.from_response(response.body)\nend"}}]},{"html_id":"Crystal/OAuth/Error","path":"OAuth/Error.html","kind":"class","full_name":"OAuth::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/oauth/error.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OAuth","kind":"module","full_name":"OAuth","name":"OAuth"},"constructors":[{"html_id":"new(response)-class-method","name":"new","abstract":false,"args":[{"name":"response","external_name":"response","restriction":""}],"args_string":"(response)","args_html":"(response)","location":{"filename":"src/oauth/error.cr","line_number":2,"url":null},"def":{"name":"new","args":[{"name":"response","external_name":"response","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(response)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]},{"html_id":"Crystal/OAuth/RequestToken","path":"OAuth/RequestToken.html","kind":"class","full_name":"OAuth::RequestToken","name":"RequestToken","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/oauth/request_token.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OAuth","kind":"module","full_name":"OAuth","name":"OAuth"},"constructors":[{"html_id":"from_response(response):self-class-method","name":"from_response","abstract":false,"args":[{"name":"response","external_name":"response","restriction":""}],"args_string":"(response) : self","args_html":"(response) : <span class=\"k\">self</span>","location":{"filename":"src/oauth/request_token.cr","line_number":8,"url":null},"def":{"name":"from_response","args":[{"name":"response","external_name":"response","restriction":""}],"return_type":"self","visibility":"Public","body":"token = nil\nsecret = nil\nURI::Params.parse(response) do |key, value|\n  case key\n  when \"oauth_token\"\n    token = value\n  when \"oauth_token_secret\"\n    secret = value\n  else\n  end\nend\nnew(token.not_nil!, secret.not_nil!)\n"}},{"html_id":"new(token:String,secret:String)-class-method","name":"new","abstract":false,"args":[{"name":"token","external_name":"token","restriction":"String"},{"name":"secret","external_name":"secret","restriction":"String"}],"args_string":"(token : String, secret : String)","args_html":"(token : <a href=\"../String.html\">String</a>, secret : <a href=\"../String.html\">String</a>)","location":{"filename":"src/oauth/request_token.cr","line_number":5,"url":null},"def":{"name":"new","args":[{"name":"token","external_name":"token","restriction":"String"},{"name":"secret","external_name":"secret","restriction":"String"}],"visibility":"Public","body":"_ = allocate\n_.initialize(token, secret)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"secret:String-instance-method","name":"secret","abstract":false,"location":{"filename":"src/oauth/request_token.cr","line_number":3,"url":null},"def":{"name":"secret","return_type":"String","visibility":"Public","body":"@secret"}},{"html_id":"token:String-instance-method","name":"token","abstract":false,"location":{"filename":"src/oauth/request_token.cr","line_number":2,"url":null},"def":{"name":"token","return_type":"String","visibility":"Public","body":"@token"}}]}]},{"html_id":"Crystal/OAuth2","path":"OAuth2.html","kind":"module","full_name":"OAuth2","name":"OAuth2","abstract":false,"locations":[{"filename":"src/oauth2/auth_scheme.cr","line_number":12,"url":null},{"filename":"src/oauth2/oauth2.cr","line_number":33,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"The OAuth module provides an `OAuth2::Client` as specified\nby [RFC 6749](https://tools.ietf.org/html/rfc6749).\n\n### Performing HTTP client requests with OAuth2 authentication\n\nAssuming you have an access token, you can setup an `HTTP::Client`\nto be authenticated with OAuth2 using this code:\n\n```\nrequire \"http/client\"\nrequire \"oauth2\"\n\n# Here we use a bearer token, but it could be a mac token. We also set the\n# expires in value to 172,800 seconds, or 48 hours\naccess_token = OAuth2::AccessToken::Bearer.new(\"some_access_token\", 172_800)\n\n# Create an HTTP::Client\nclient = HTTP::Client.new(\"api.example.com\", tls: true)\n\n# Prepare it for using OAuth2 authentication\naccess_token.authenticate(client)\n\n# Execute requests as usual: they will be authenticated\nclient.get(\"/some_path\")\n```\n\nThis is implemented with `HTTP::Client#before_request` to add an authorization\nheader to every request.\n\n### Obtaining access tokens\n\nSee `OAuth2::Client` for an example.","summary":"<p>The OAuth module provides an <code><a href=\"OAuth2/Client.html\">OAuth2::Client</a></code> as specified by <a href=\"https://tools.ietf.org/html/rfc6749\">RFC 6749</a>.</p>","types":[{"html_id":"Crystal/OAuth2/AccessToken","path":"OAuth2/AccessToken.html","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken","abstract":true,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/oauth2/access_token/access_token.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/OAuth2/AccessToken/Bearer","kind":"class","full_name":"OAuth2::AccessToken::Bearer","name":"Bearer"},{"html_id":"Crystal/OAuth2/AccessToken/Mac","kind":"class","full_name":"OAuth2::AccessToken::Mac","name":"Mac"}],"namespace":{"html_id":"Crystal/OAuth2","kind":"module","full_name":"OAuth2","name":"OAuth2"},"doc":"Base class for the two possible access tokens: Bearer and Mac.\n\nUse `#authenticate` to authenticate an `HTTP::Client`.","summary":"<p>Base class for the two possible access tokens: Bearer and Mac.</p>","constructors":[{"html_id":"new(access_token:String,expires_in:Int?,refresh_token:String?=nil,scope:String?=nil,extra=nil)-class-method","name":"new","abstract":false,"args":[{"name":"access_token","external_name":"access_token","restriction":"String"},{"name":"expires_in","external_name":"expires_in","restriction":"Int | ::Nil"},{"name":"refresh_token","default_value":"nil","external_name":"refresh_token","restriction":"String | ::Nil"},{"name":"scope","default_value":"nil","external_name":"scope","restriction":"String | ::Nil"},{"name":"extra","default_value":"nil","external_name":"extra","restriction":""}],"args_string":"(access_token : String, expires_in : Int?, refresh_token : String? = nil, scope : String? = nil, extra = nil)","args_html":"(access_token : <a href=\"../String.html\">String</a>, expires_in : <a href=\"../Int.html\">Int</a>?, refresh_token : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, scope : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, extra = <span class=\"n\">nil</span>)","location":{"filename":"src/oauth2/access_token/access_token.cr","line_number":57,"url":null},"def":{"name":"new","args":[{"name":"access_token","external_name":"access_token","restriction":"String"},{"name":"expires_in","external_name":"expires_in","restriction":"Int | ::Nil"},{"name":"refresh_token","default_value":"nil","external_name":"refresh_token","restriction":"String | ::Nil"},{"name":"scope","default_value":"nil","external_name":"scope","restriction":"String | ::Nil"},{"name":"extra","default_value":"nil","external_name":"extra","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(access_token, expires_in, refresh_token, scope, extra)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"../JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/oauth2/access_token/access_token.cr","line_number":5,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"token_type = nil\naccess_token = nil\nexpires_in = nil\nrefresh_token = nil\nscope = nil\nmac_algorithm = nil\nmac_key = nil\nextra = nil\npull.read_object do |key|\n  case key\n  when \"token_type\"\n    token_type = pull.read_string\n  when \"access_token\"\n    access_token = pull.read_string\n  when \"expires_in\"\n    expires_in = pull.read_int\n  when \"refresh_token\"\n    refresh_token = pull.read_string_or_null\n  when \"scope\"\n    scope = pull.read_string_or_null\n  when \"mac_algorithm\"\n    mac_algorithm = pull.read_string\n  when \"mac_key\"\n    mac_key = pull.read_string\n  else\n    extra || (extra = {} of String => String)\n    extra[key] = pull.read_raw\n  end\nend\naccess_token = access_token.not_nil!\ntoken_type || (token_type = \"bearer\")\ncase token_type.downcase\nwhen \"bearer\"\n  Bearer.new(access_token, expires_in, refresh_token, scope, extra)\nwhen \"mac\"\n  Mac.new(access_token, expires_in, mac_algorithm.not_nil!, mac_key.not_nil!, refresh_token, scope, Time.utc.to_unix, extra)\nelse\n  raise(\"Unknown token_type in access token json: #{token_type}\")\nend\n"}}],"instance_methods":[{"html_id":"access_token:String-instance-method","name":"access_token","abstract":false,"location":{"filename":"src/oauth2/access_token/access_token.cr","line_number":44,"url":null},"def":{"name":"access_token","return_type":"String","visibility":"Public","body":"@access_token"}},{"html_id":"access_token=(access_token:String)-instance-method","name":"access_token=","abstract":false,"args":[{"name":"access_token","external_name":"access_token","restriction":"String"}],"args_string":"(access_token : String)","args_html":"(access_token : <a href=\"../String.html\">String</a>)","location":{"filename":"src/oauth2/access_token/access_token.cr","line_number":44,"url":null},"def":{"name":"access_token=","args":[{"name":"access_token","external_name":"access_token","restriction":"String"}],"visibility":"Public","body":"@access_token = access_token"}},{"html_id":"authenticate(request:HTTP::Request,tls)-instance-method","name":"authenticate","abstract":true,"args":[{"name":"request","external_name":"request","restriction":"HTTP::Request"},{"name":"tls","external_name":"tls","restriction":""}],"args_string":"(request : HTTP::Request, tls)","args_html":"(request : <a href=\"../HTTP/Request.html\">HTTP::Request</a>, tls)","location":{"filename":"src/oauth2/access_token/access_token.cr","line_number":61,"url":null},"def":{"name":"authenticate","args":[{"name":"request","external_name":"request","restriction":"HTTP::Request"},{"name":"tls","external_name":"tls","restriction":""}],"visibility":"Public","body":""}},{"html_id":"authenticate(client:HTTP::Client)-instance-method","name":"authenticate","abstract":false,"args":[{"name":"client","external_name":"client","restriction":"HTTP::Client"}],"args_string":"(client : HTTP::Client)","args_html":"(client : <a href=\"../HTTP/Client.html\">HTTP::Client</a>)","location":{"filename":"src/oauth2/access_token/access_token.cr","line_number":63,"url":null},"def":{"name":"authenticate","args":[{"name":"client","external_name":"client","restriction":"HTTP::Client"}],"visibility":"Public","body":"client.before_request do |request|\n  authenticate(request, client.tls?)\nend"}},{"html_id":"expires_in:Int64?-instance-method","name":"expires_in","abstract":false,"location":{"filename":"src/oauth2/access_token/access_token.cr","line_number":45,"url":null},"def":{"name":"expires_in","return_type":"Int64 | ::Nil","visibility":"Public","body":"@expires_in"}},{"html_id":"expires_in=(expires_in:Int64?)-instance-method","name":"expires_in=","abstract":false,"args":[{"name":"expires_in","external_name":"expires_in","restriction":"Int64 | ::Nil"}],"args_string":"(expires_in : Int64?)","args_html":"(expires_in : <a href=\"../Int64.html\">Int64</a>?)","location":{"filename":"src/oauth2/access_token/access_token.cr","line_number":45,"url":null},"def":{"name":"expires_in=","args":[{"name":"expires_in","external_name":"expires_in","restriction":"Int64 | ::Nil"}],"visibility":"Public","body":"@expires_in = expires_in"}},{"html_id":"extra:Hash(String,String)?-instance-method","name":"extra","doc":"JSON key-value pairs that are outside of the OAuth2 spec are\nstored in this property in case they are needed. Their value\nis the raw JSON string found in the JSON value (with possible\nchanges in the string format, but preserving JSON semantic).\nFor example if the value was `[1, 2, 3]` then the value in this hash\nwill be the string \"[1,2,3]\".","summary":"<p>JSON key-value pairs that are outside of the OAuth2 spec are stored in this property in case they are needed.</p>","abstract":false,"location":{"filename":"src/oauth2/access_token/access_token.cr","line_number":55,"url":null},"def":{"name":"extra","return_type":"Hash(String, String) | ::Nil","visibility":"Public","body":"@extra"}},{"html_id":"extra=(extra:Hash(String,String)?)-instance-method","name":"extra=","doc":"JSON key-value pairs that are outside of the OAuth2 spec are\nstored in this property in case they are needed. Their value\nis the raw JSON string found in the JSON value (with possible\nchanges in the string format, but preserving JSON semantic).\nFor example if the value was `[1, 2, 3]` then the value in this hash\nwill be the string \"[1,2,3]\".","summary":"<p>JSON key-value pairs that are outside of the OAuth2 spec are stored in this property in case they are needed.</p>","abstract":false,"args":[{"name":"extra","external_name":"extra","restriction":"Hash(String, String) | ::Nil"}],"args_string":"(extra : Hash(String, String)?)","args_html":"(extra : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>)?)","location":{"filename":"src/oauth2/access_token/access_token.cr","line_number":55,"url":null},"def":{"name":"extra=","args":[{"name":"extra","external_name":"extra","restriction":"Hash(String, String) | ::Nil"}],"visibility":"Public","body":"@extra = extra"}},{"html_id":"refresh_token:String?-instance-method","name":"refresh_token","abstract":false,"location":{"filename":"src/oauth2/access_token/access_token.cr","line_number":46,"url":null},"def":{"name":"refresh_token","return_type":"String | ::Nil","visibility":"Public","body":"@refresh_token"}},{"html_id":"refresh_token=(refresh_token:String?)-instance-method","name":"refresh_token=","abstract":false,"args":[{"name":"refresh_token","external_name":"refresh_token","restriction":"String | ::Nil"}],"args_string":"(refresh_token : String?)","args_html":"(refresh_token : <a href=\"../String.html\">String</a>?)","location":{"filename":"src/oauth2/access_token/access_token.cr","line_number":46,"url":null},"def":{"name":"refresh_token=","args":[{"name":"refresh_token","external_name":"refresh_token","restriction":"String | ::Nil"}],"visibility":"Public","body":"@refresh_token = refresh_token"}},{"html_id":"scope:String?-instance-method","name":"scope","abstract":false,"location":{"filename":"src/oauth2/access_token/access_token.cr","line_number":47,"url":null},"def":{"name":"scope","return_type":"String | ::Nil","visibility":"Public","body":"@scope"}},{"html_id":"scope=(scope:String?)-instance-method","name":"scope=","abstract":false,"args":[{"name":"scope","external_name":"scope","restriction":"String | ::Nil"}],"args_string":"(scope : String?)","args_html":"(scope : <a href=\"../String.html\">String</a>?)","location":{"filename":"src/oauth2/access_token/access_token.cr","line_number":47,"url":null},"def":{"name":"scope=","args":[{"name":"scope","external_name":"scope","restriction":"String | ::Nil"}],"visibility":"Public","body":"@scope = scope"}}],"types":[{"html_id":"Crystal/OAuth2/AccessToken/Bearer","path":"OAuth2/AccessToken/Bearer.html","kind":"class","full_name":"OAuth2::AccessToken::Bearer","name":"Bearer","abstract":false,"superclass":{"html_id":"Crystal/OAuth2/AccessToken","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken"},"ancestors":[{"html_id":"Crystal/OAuth2/AccessToken","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/oauth2/access_token/bearer.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OAuth2/AccessToken","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken"},"constructors":[{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"../../JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/oauth2/access_token/bearer.cr","line_number":4,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"(OAuth2::AccessToken.new(pull)).as(self)"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this reference is the same as *other*. Invokes `same?`.","summary":"<p>Returns <code>true</code> if this reference is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"if same?(other)\n  return true\nend\nif access_token == other.access_token\nelse\n  return false\nend\nif expires_in == other.expires_in\nelse\n  return false\nend\nif refresh_token == other.refresh_token\nelse\n  return false\nend\nif scope == other.scope\nelse\n  return false\nend\ntrue\n"}},{"html_id":"authenticate(request:HTTP::Request,tls)-instance-method","name":"authenticate","abstract":false,"args":[{"name":"request","external_name":"request","restriction":"HTTP::Request"},{"name":"tls","external_name":"tls","restriction":""}],"args_string":"(request : HTTP::Request, tls)","args_html":"(request : <a href=\"../../HTTP/Request.html\">HTTP::Request</a>, tls)","location":{"filename":"src/oauth2/access_token/bearer.cr","line_number":12,"url":null},"def":{"name":"authenticate","args":[{"name":"request","external_name":"request","restriction":"HTTP::Request"},{"name":"tls","external_name":"tls","restriction":""}],"visibility":"Public","body":"request.headers[\"Authorization\"] = \"Bearer #{access_token}\""}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = access_token.hash(hasher)\nhasher = expires_in.hash(hasher)\nhasher = refresh_token.hash(hasher)\nhasher = scope.hash(hasher)\nhasher\n"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"../../JSON/Builder.html\">JSON::Builder</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/oauth2/access_token/bearer.cr","line_number":16,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.object do\n  json.field(\"token_type\", \"bearer\")\n  json.field(\"access_token\", access_token)\n  json.field(\"expires_in\", expires_in)\n  if refresh_token\n    json.field(\"refresh_token\", refresh_token)\n  end\n  if scope\n    json.field(\"scope\", scope)\n  end\nend"}},{"html_id":"token_type:String-instance-method","name":"token_type","abstract":false,"location":{"filename":"src/oauth2/access_token/bearer.cr","line_number":8,"url":null},"def":{"name":"token_type","return_type":"String","visibility":"Public","body":"\"Bearer\""}}]},{"html_id":"Crystal/OAuth2/AccessToken/Mac","path":"OAuth2/AccessToken/Mac.html","kind":"class","full_name":"OAuth2::AccessToken::Mac","name":"Mac","abstract":false,"superclass":{"html_id":"Crystal/OAuth2/AccessToken","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken"},"ancestors":[{"html_id":"Crystal/OAuth2/AccessToken","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/oauth2/access_token/mac.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OAuth2/AccessToken","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken"},"class_methods":[{"html_id":"signature(ts,nonce,method,uri,host,port,ext,mac_algorithm,mac_key):String-class-method","name":"signature","abstract":false,"args":[{"name":"ts","external_name":"ts","restriction":""},{"name":"nonce","external_name":"nonce","restriction":""},{"name":"method","external_name":"method","restriction":""},{"name":"uri","external_name":"uri","restriction":""},{"name":"host","external_name":"host","restriction":""},{"name":"port","external_name":"port","restriction":""},{"name":"ext","external_name":"ext","restriction":""},{"name":"mac_algorithm","external_name":"mac_algorithm","restriction":""},{"name":"mac_key","external_name":"mac_key","restriction":""}],"args_string":"(ts, nonce, method, uri, host, port, ext, mac_algorithm, mac_key) : String","args_html":"(ts, nonce, method, uri, host, port, ext, mac_algorithm, mac_key) : <a href=\"../../String.html\">String</a>","location":{"filename":"src/oauth2/access_token/mac.cr","line_number":37,"url":null},"def":{"name":"signature","args":[{"name":"ts","external_name":"ts","restriction":""},{"name":"nonce","external_name":"nonce","restriction":""},{"name":"method","external_name":"method","restriction":""},{"name":"uri","external_name":"uri","restriction":""},{"name":"host","external_name":"host","restriction":""},{"name":"port","external_name":"port","restriction":""},{"name":"ext","external_name":"ext","restriction":""},{"name":"mac_algorithm","external_name":"mac_algorithm","restriction":""},{"name":"mac_key","external_name":"mac_key","restriction":""}],"return_type":"String","visibility":"Public","body":"normalized_request_string = \"#{ts}\\n#{nonce}\\n#{method}\\n#{uri}\\n#{host}\\n#{port}\\n#{ext}\\n\"\ndigest = case mac_algorithm\nwhen \"hmac-sha-1\"\n  OpenSSL::Algorithm::SHA1\nwhen \"hmac-sha-256\"\n  OpenSSL::Algorithm::SHA256\nelse\n  raise(\"Unsupported algorithm: #{mac_algorithm}\")\nend\nBase64.strict_encode(OpenSSL::HMAC.digest(digest, mac_key, normalized_request_string))\n"}}],"constructors":[{"html_id":"new(access_token,expires_in,mac_algorithm,mac_key,refresh_token=nil,scope=nil,issued_at=Time.utc.to_unix,extra=nil)-class-method","name":"new","abstract":false,"args":[{"name":"access_token","external_name":"access_token","restriction":""},{"name":"expires_in","external_name":"expires_in","restriction":""},{"name":"mac_algorithm","external_name":"mac_algorithm","restriction":""},{"name":"mac_key","external_name":"mac_key","restriction":""},{"name":"refresh_token","default_value":"nil","external_name":"refresh_token","restriction":""},{"name":"scope","default_value":"nil","external_name":"scope","restriction":""},{"name":"issued_at","default_value":"Time.utc.to_unix","external_name":"issued_at","restriction":""},{"name":"extra","default_value":"nil","external_name":"extra","restriction":""}],"args_string":"(access_token, expires_in, mac_algorithm, mac_key, refresh_token = nil, scope = nil, issued_at = Time.utc.to_unix, extra = nil)","args_html":"(access_token, expires_in, mac_algorithm, mac_key, refresh_token = <span class=\"n\">nil</span>, scope = <span class=\"n\">nil</span>, issued_at = <span class=\"t\">Time</span>.utc.to_unix, extra = <span class=\"n\">nil</span>)","location":{"filename":"src/oauth2/access_token/mac.cr","line_number":15,"url":null},"def":{"name":"new","args":[{"name":"access_token","external_name":"access_token","restriction":""},{"name":"expires_in","external_name":"expires_in","restriction":""},{"name":"mac_algorithm","external_name":"mac_algorithm","restriction":""},{"name":"mac_key","external_name":"mac_key","restriction":""},{"name":"refresh_token","default_value":"nil","external_name":"refresh_token","restriction":""},{"name":"scope","default_value":"nil","external_name":"scope","restriction":""},{"name":"issued_at","default_value":"Time.utc.to_unix","external_name":"issued_at","restriction":""},{"name":"extra","default_value":"nil","external_name":"extra","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(access_token, expires_in, mac_algorithm, mac_key, refresh_token, scope, issued_at, extra)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"../../JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/oauth2/access_token/mac.cr","line_number":7,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"(OAuth2::AccessToken.new(pull)).as(self)"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this reference is the same as *other*. Invokes `same?`.","summary":"<p>Returns <code>true</code> if this reference is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"if same?(other)\n  return true\nend\nif access_token == other.access_token\nelse\n  return false\nend\nif expires_in == other.expires_in\nelse\n  return false\nend\nif mac_algorithm == other.mac_algorithm\nelse\n  return false\nend\nif mac_key == other.mac_key\nelse\n  return false\nend\nif refresh_token == other.refresh_token\nelse\n  return false\nend\nif scope == other.scope\nelse\n  return false\nend\ntrue\n"}},{"html_id":"authenticate(request:HTTP::Request,tls)-instance-method","name":"authenticate","abstract":false,"args":[{"name":"request","external_name":"request","restriction":"HTTP::Request"},{"name":"tls","external_name":"tls","restriction":""}],"args_string":"(request : HTTP::Request, tls)","args_html":"(request : <a href=\"../../HTTP/Request.html\">HTTP::Request</a>, tls)","location":{"filename":"src/oauth2/access_token/mac.cr","line_number":23,"url":null},"def":{"name":"authenticate","args":[{"name":"request","external_name":"request","restriction":"HTTP::Request"},{"name":"tls","external_name":"tls","restriction":""}],"visibility":"Public","body":"ts = Time.utc.to_unix\nnonce = \"#{ts - @issued_at}:#{Random::Secure.hex}\"\nmethod = request.method\nuri = request.resource\nhost, port = host_and_port(request, tls)\next = \"\"\nmac = Mac.signature(ts, nonce, method, uri, host, port, ext, mac_algorithm, mac_key)\nheader = \"MAC id=\\\"#{access_token}\\\", nonce=\\\"#{nonce}\\\", ts=\\\"#{ts}\\\", mac=\\\"#{mac}\\\"\"\nrequest.headers[\"Authorization\"] = header\n"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = access_token.hash(hasher)\nhasher = expires_in.hash(hasher)\nhasher = mac_algorithm.hash(hasher)\nhasher = mac_key.hash(hasher)\nhasher = refresh_token.hash(hasher)\nhasher = scope.hash(hasher)\nhasher\n"}},{"html_id":"issued_at:Int64-instance-method","name":"issued_at","abstract":false,"location":{"filename":"src/oauth2/access_token/mac.cr","line_number":13,"url":null},"def":{"name":"issued_at","return_type":"Int64","visibility":"Public","body":"@issued_at"}},{"html_id":"issued_at=(issued_at:Int64)-instance-method","name":"issued_at=","abstract":false,"args":[{"name":"issued_at","external_name":"issued_at","restriction":"Int64"}],"args_string":"(issued_at : Int64)","args_html":"(issued_at : <a href=\"../../Int64.html\">Int64</a>)","location":{"filename":"src/oauth2/access_token/mac.cr","line_number":13,"url":null},"def":{"name":"issued_at=","args":[{"name":"issued_at","external_name":"issued_at","restriction":"Int64"}],"visibility":"Public","body":"@issued_at = issued_at"}},{"html_id":"mac_algorithm:String-instance-method","name":"mac_algorithm","abstract":false,"location":{"filename":"src/oauth2/access_token/mac.cr","line_number":11,"url":null},"def":{"name":"mac_algorithm","return_type":"String","visibility":"Public","body":"@mac_algorithm"}},{"html_id":"mac_algorithm=(mac_algorithm:String)-instance-method","name":"mac_algorithm=","abstract":false,"args":[{"name":"mac_algorithm","external_name":"mac_algorithm","restriction":"String"}],"args_string":"(mac_algorithm : String)","args_html":"(mac_algorithm : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/oauth2/access_token/mac.cr","line_number":11,"url":null},"def":{"name":"mac_algorithm=","args":[{"name":"mac_algorithm","external_name":"mac_algorithm","restriction":"String"}],"visibility":"Public","body":"@mac_algorithm = mac_algorithm"}},{"html_id":"mac_key:String-instance-method","name":"mac_key","abstract":false,"location":{"filename":"src/oauth2/access_token/mac.cr","line_number":12,"url":null},"def":{"name":"mac_key","return_type":"String","visibility":"Public","body":"@mac_key"}},{"html_id":"mac_key=(mac_key:String)-instance-method","name":"mac_key=","abstract":false,"args":[{"name":"mac_key","external_name":"mac_key","restriction":"String"}],"args_string":"(mac_key : String)","args_html":"(mac_key : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/oauth2/access_token/mac.cr","line_number":12,"url":null},"def":{"name":"mac_key=","args":[{"name":"mac_key","external_name":"mac_key","restriction":"String"}],"visibility":"Public","body":"@mac_key = mac_key"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"../../JSON/Builder.html\">JSON::Builder</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/oauth2/access_token/mac.cr","line_number":48,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.object do\n  json.field(\"token_type\", \"mac\")\n  json.field(\"access_token\", access_token)\n  json.field(\"expires_in\", expires_in)\n  if refresh_token\n    json.field(\"refresh_token\", refresh_token)\n  end\n  if scope\n    json.field(\"scope\", scope)\n  end\n  json.field(\"mac_algorithm\", mac_algorithm)\n  json.field(\"mac_key\", mac_key)\nend"}},{"html_id":"token_type:String-instance-method","name":"token_type","abstract":false,"location":{"filename":"src/oauth2/access_token/mac.cr","line_number":19,"url":null},"def":{"name":"token_type","return_type":"String","visibility":"Public","body":"\"Mac\""}}]}]},{"html_id":"Crystal/OAuth2/AuthScheme","path":"OAuth2/AuthScheme.html","kind":"enum","full_name":"OAuth2::AuthScheme","name":"AuthScheme","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/oauth2/auth_scheme.cr","line_number":12,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"HTTPBasic","name":"HTTPBasic","value":"0"},{"id":"RequestBody","name":"RequestBody","value":"1"}],"namespace":{"html_id":"Crystal/OAuth2","kind":"module","full_name":"OAuth2","name":"OAuth2"},"doc":"Enum of supported mechanisms used to pass credentials to the server.\n\nAccording to https://tools.ietf.org/html/rfc6749#section-2.3.1:\n\n> \"Including the client credentials in the request-body using the\n> two parameters is NOT RECOMMENDED and SHOULD be limited to\n> clients unable to directly utilize the HTTP Basic authentication\n> scheme (or other password-based HTTP authentication schemes).\"\n\nTherefore, HTTP Basic is preferred, and Request Body should only\nbe used if the server does not support HTTP Basic.","summary":"<p>Enum of supported mechanisms used to pass credentials to the server.</p>","instance_methods":[{"html_id":"http_basic?-instance-method","name":"http_basic?","abstract":false,"location":{"filename":"src/oauth2/auth_scheme.cr","line_number":13,"url":null},"def":{"name":"http_basic?","visibility":"Public","body":"self == HTTPBasic"}},{"html_id":"request_body?-instance-method","name":"request_body?","abstract":false,"location":{"filename":"src/oauth2/auth_scheme.cr","line_number":14,"url":null},"def":{"name":"request_body?","visibility":"Public","body":"self == RequestBody"}}]},{"html_id":"Crystal/OAuth2/Client","path":"OAuth2/Client.html","kind":"class","full_name":"OAuth2::Client","name":"Client","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/oauth2/client.cr","line_number":56,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OAuth2","kind":"module","full_name":"OAuth2","name":"OAuth2"},"doc":"An OAuth2 client.\n\nFor a quick example of how to authenticate an `HTTP::Client` with OAuth2 if\nyou already have an access token, check the `OAuth2` module description.\n\nThis class also provides methods to build authorize URIs\nand get access tokens with different methods, as specified by\n[RFC 6749](https://tools.ietf.org/html/rfc6749).\n\n### Example\n\n```\nrequire \"oauth2\"\n\nclient_id = \"some_client_id\"\nclient_secret = \"some_client_secret\"\nredirect_uri = \"http://some.callback\"\n\n# Create oauth client, optionally pass custom URIs if needed,\n# if the authorize or token URIs are not the standard ones\n# (they can also be absolute URLs)\noauth2_client = OAuth2::Client.new(\"api.example.com\", client_id, client_secret,\n  redirect_uri: redirect_uri)\n\n# Build an authorize URI\nauthorize_uri = oauth2_client.get_authorize_uri\n\n# Redirect the user to `authorize_uri`...\n#\n# ...\n#\n# When http://some.callback is hit, once the user authorized the access,\n# we resume our logic to finally get an access token. The callback URL\n# should receive an `authorization_code` parameter that we need to use.\nauthorization_code = request.params[\"code\"]\n\n# Get the access token\naccess_token = oauth2_client.get_access_token_using_authorization_code(authorization_code)\n\n# Probably save the access token for reuse... This can be done\n# with `to_json` and `from_json`.\n\n# Use the token to authenticate an HTTP::Client\nclient = HTTP::Client.new(\"api.example.com\", tls: true)\naccess_token.authenticate(client)\n\n# And do requests as usual\nclient.get \"/some_path\"\n\n# If the token expires, we can refresh it\nnew_access_token = oauth2_client.get_access_token_using_refresh_token(access_token.refresh_token)\n```\n\nYou can also use an `OAuth2::Session` to automatically refresh expired\ntokens before each request.","summary":"<p>An OAuth2 client.</p>","constructors":[{"html_id":"new(host:String,client_id:String,client_secret:String,port:Int32?=nil,scheme=\"https\",authorize_uri=\"/oauth2/authorize\",token_uri=\"/oauth2/token\",redirect_uri:String?=nil,auth_scheme:AuthScheme=:http_basic)-class-method","name":"new","doc":"Creates an OAuth client.\n\nAny or all of the customizable URIs *authorize_uri* and\n*token_uri* can be relative or absolute.\nIf they are relative, the given *host*, *port* and *scheme* will be used.\nIf they are absolute, the absolute URL will be used.\n\nAs per https://tools.ietf.org/html/rfc6749#section-2.3.1,\n`AuthScheme::HTTPBasic` is the default *auth_scheme* (the mechanism used to\ntransmit the client credentials to the server). `AuthScheme::RequestBody` should\nonly be used if the server does not support HTTP Basic.","summary":"<p>Creates an OAuth client.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"client_id","external_name":"client_id","restriction":"String"},{"name":"client_secret","external_name":"client_secret","restriction":"String"},{"name":"port","default_value":"nil","external_name":"port","restriction":"Int32 | ::Nil"},{"name":"scheme","default_value":"\"https\"","external_name":"scheme","restriction":""},{"name":"authorize_uri","default_value":"\"/oauth2/authorize\"","external_name":"authorize_uri","restriction":""},{"name":"token_uri","default_value":"\"/oauth2/token\"","external_name":"token_uri","restriction":""},{"name":"redirect_uri","default_value":"nil","external_name":"redirect_uri","restriction":"String | ::Nil"},{"name":"auth_scheme","default_value":":http_basic","external_name":"auth_scheme","restriction":"AuthScheme"}],"args_string":"(host : String, client_id : String, client_secret : String, port : Int32? = nil, scheme = \"https\", authorize_uri = \"/oauth2/authorize\", token_uri = \"/oauth2/token\", redirect_uri : String? = nil, auth_scheme : AuthScheme = :http_basic)","args_html":"(host : <a href=\"../String.html\">String</a>, client_id : <a href=\"../String.html\">String</a>, client_secret : <a href=\"../String.html\">String</a>, port : <a href=\"../Int32.html\">Int32</a>? = <span class=\"n\">nil</span>, scheme = <span class=\"s\">&quot;https&quot;</span>, authorize_uri = <span class=\"s\">&quot;/oauth2/authorize&quot;</span>, token_uri = <span class=\"s\">&quot;/oauth2/token&quot;</span>, redirect_uri : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, auth_scheme : <a href=\"../OAuth2/AuthScheme.html\">AuthScheme</a> = <span class=\"n\">:http_basic</span>)","location":{"filename":"src/oauth2/client.cr","line_number":79,"url":null},"def":{"name":"new","args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"client_id","external_name":"client_id","restriction":"String"},{"name":"client_secret","external_name":"client_secret","restriction":"String"},{"name":"port","default_value":"nil","external_name":"port","restriction":"Int32 | ::Nil"},{"name":"scheme","default_value":"\"https\"","external_name":"scheme","restriction":""},{"name":"authorize_uri","default_value":"\"/oauth2/authorize\"","external_name":"authorize_uri","restriction":""},{"name":"token_uri","default_value":"\"/oauth2/token\"","external_name":"token_uri","restriction":""},{"name":"redirect_uri","default_value":"nil","external_name":"redirect_uri","restriction":"String | ::Nil"},{"name":"auth_scheme","default_value":":http_basic","external_name":"auth_scheme","restriction":"AuthScheme"}],"visibility":"Public","body":"_ = allocate\n_.initialize(host, client_id, client_secret, port, scheme, authorize_uri, token_uri, redirect_uri, auth_scheme)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"get_access_token_using_authorization_code(authorization_code:String):AccessToken-instance-method","name":"get_access_token_using_authorization_code","doc":"Gets an access token using an authorization code, as specified by\n[RFC 6749, Section 4.1.3](https://tools.ietf.org/html/rfc6749#section-4.1.3).","summary":"<p>Gets an access token using an authorization code, as specified by <a href=\"https://tools.ietf.org/html/rfc6749#section-4.1.3\">RFC 6749, Section 4.1.3</a>.</p>","abstract":false,"args":[{"name":"authorization_code","external_name":"authorization_code","restriction":"String"}],"args_string":"(authorization_code : String) : AccessToken","args_html":"(authorization_code : <a href=\"../String.html\">String</a>) : <a href=\"../OAuth2/AccessToken.html\">AccessToken</a>","location":{"filename":"src/oauth2/client.cr","line_number":124,"url":null},"def":{"name":"get_access_token_using_authorization_code","args":[{"name":"authorization_code","external_name":"authorization_code","restriction":"String"}],"return_type":"AccessToken","visibility":"Public","body":"get_access_token do |form|\n  form.add(\"redirect_uri\", @redirect_uri)\n  form.add(\"grant_type\", \"authorization_code\")\n  form.add(\"code\", authorization_code)\nend"}},{"html_id":"get_access_token_using_client_credentials(scope=nil):AccessToken-instance-method","name":"get_access_token_using_client_credentials","doc":"Gets an access token using client credentials, as specified by\n[RFC 6749, Section 4.4.2](https://tools.ietf.org/html/rfc6749#section-4.4.2).","summary":"<p>Gets an access token using client credentials, as specified by <a href=\"https://tools.ietf.org/html/rfc6749#section-4.4.2\">RFC 6749, Section 4.4.2</a>.</p>","abstract":false,"args":[{"name":"scope","default_value":"nil","external_name":"scope","restriction":""}],"args_string":"(scope = nil) : AccessToken","args_html":"(scope = <span class=\"n\">nil</span>) : <a href=\"../OAuth2/AccessToken.html\">AccessToken</a>","location":{"filename":"src/oauth2/client.cr","line_number":145,"url":null},"def":{"name":"get_access_token_using_client_credentials","args":[{"name":"scope","default_value":"nil","external_name":"scope","restriction":""}],"return_type":"AccessToken","visibility":"Public","body":"get_access_token do |form|\n  form.add(\"grant_type\", \"client_credentials\")\n  if scope.nil?\n  else\n    form.add(\"scope\", scope)\n  end\nend"}},{"html_id":"get_access_token_using_refresh_token(refresh_token,scope=nil):AccessToken-instance-method","name":"get_access_token_using_refresh_token","doc":"Gets an access token using a refresh token, as specified by\n[RFC 6749, Section 6](https://tools.ietf.org/html/rfc6749#section-6).","summary":"<p>Gets an access token using a refresh token, as specified by <a href=\"https://tools.ietf.org/html/rfc6749#section-6\">RFC 6749, Section 6</a>.</p>","abstract":false,"args":[{"name":"refresh_token","external_name":"refresh_token","restriction":""},{"name":"scope","default_value":"nil","external_name":"scope","restriction":""}],"args_string":"(refresh_token, scope = nil) : AccessToken","args_html":"(refresh_token, scope = <span class=\"n\">nil</span>) : <a href=\"../OAuth2/AccessToken.html\">AccessToken</a>","location":{"filename":"src/oauth2/client.cr","line_number":154,"url":null},"def":{"name":"get_access_token_using_refresh_token","args":[{"name":"refresh_token","external_name":"refresh_token","restriction":""},{"name":"scope","default_value":"nil","external_name":"scope","restriction":""}],"return_type":"AccessToken","visibility":"Public","body":"get_access_token do |form|\n  form.add(\"grant_type\", \"refresh_token\")\n  form.add(\"refresh_token\", refresh_token)\n  if scope.nil?\n  else\n    form.add(\"scope\", scope)\n  end\nend"}},{"html_id":"get_access_token_using_resource_owner_credentials(username:String,password:String,scope=nil):AccessToken-instance-method","name":"get_access_token_using_resource_owner_credentials","doc":"Gets an access token using the resource owner credentials, as specified by\n[RFC 6749, Section 4.3.2](https://tools.ietf.org/html/rfc6749#section-4.3.2).","summary":"<p>Gets an access token using the resource owner credentials, as specified by <a href=\"https://tools.ietf.org/html/rfc6749#section-4.3.2\">RFC 6749, Section 4.3.2</a>.</p>","abstract":false,"args":[{"name":"username","external_name":"username","restriction":"String"},{"name":"password","external_name":"password","restriction":"String"},{"name":"scope","default_value":"nil","external_name":"scope","restriction":""}],"args_string":"(username : String, password : String, scope = nil) : AccessToken","args_html":"(username : <a href=\"../String.html\">String</a>, password : <a href=\"../String.html\">String</a>, scope = <span class=\"n\">nil</span>) : <a href=\"../OAuth2/AccessToken.html\">AccessToken</a>","location":{"filename":"src/oauth2/client.cr","line_number":134,"url":null},"def":{"name":"get_access_token_using_resource_owner_credentials","args":[{"name":"username","external_name":"username","restriction":"String"},{"name":"password","external_name":"password","restriction":"String"},{"name":"scope","default_value":"nil","external_name":"scope","restriction":""}],"return_type":"AccessToken","visibility":"Public","body":"get_access_token do |form|\n  form.add(\"grant_type\", \"password\")\n  form.add(\"username\", username)\n  form.add(\"password\", password)\n  if scope.nil?\n  else\n    form.add(\"scope\", scope)\n  end\nend"}},{"html_id":"get_authorize_uri(scope=nil,state=nil):String-instance-method","name":"get_authorize_uri","doc":"Builds an authorize URI, as specified by\n[RFC 6749, Section 4.1.1](https://tools.ietf.org/html/rfc6749#section-4.1.1).","summary":"<p>Builds an authorize URI, as specified by <a href=\"https://tools.ietf.org/html/rfc6749#section-4.1.1\">RFC 6749, Section 4.1.1</a>.</p>","abstract":false,"args":[{"name":"scope","default_value":"nil","external_name":"scope","restriction":""},{"name":"state","default_value":"nil","external_name":"state","restriction":""}],"args_string":"(scope = nil, state = nil) : String","args_html":"(scope = <span class=\"n\">nil</span>, state = <span class=\"n\">nil</span>) : <a href=\"../String.html\">String</a>","location":{"filename":"src/oauth2/client.cr","line_number":90,"url":null},"def":{"name":"get_authorize_uri","args":[{"name":"scope","default_value":"nil","external_name":"scope","restriction":""},{"name":"state","default_value":"nil","external_name":"state","restriction":""}],"return_type":"String","visibility":"Public","body":"get_authorize_uri(scope, state) do\nend"}},{"html_id":"get_authorize_uri(scope=nil,state=nil,&block:URI::Params::Builder->):String-instance-method","name":"get_authorize_uri","doc":"Builds an authorize URI, as specified by\n[RFC 6749, Section 4.1.1](https://tools.ietf.org/html/rfc6749#section-4.1.1).\n\nYields an `URI::Params::Builder` to add extra parameters other than those\ndefined by the standard.","summary":"<p>Builds an authorize URI, as specified by <a href=\"https://tools.ietf.org/html/rfc6749#section-4.1.1\">RFC 6749, Section 4.1.1</a>.</p>","abstract":false,"args":[{"name":"scope","default_value":"nil","external_name":"scope","restriction":""},{"name":"state","default_value":"nil","external_name":"state","restriction":""}],"args_string":"(scope = nil, state = nil, &block : URI::Params::Builder -> ) : String","args_html":"(scope = <span class=\"n\">nil</span>, state = <span class=\"n\">nil</span>, &block : <a href=\"../URI/Params/Builder.html\">URI::Params::Builder</a> -> ) : <a href=\"../String.html\">String</a>","location":{"filename":"src/oauth2/client.cr","line_number":99,"url":null},"def":{"name":"get_authorize_uri","args":[{"name":"scope","default_value":"nil","external_name":"scope","restriction":""},{"name":"state","default_value":"nil","external_name":"state","restriction":""}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(URI::Params::Builder ->)"},"return_type":"String","visibility":"Public","body":"uri = URI.parse(@authorize_uri)\nif uri.host\nelse\n  uri = URI.new(@scheme, @host, @port, @authorize_uri)\nend\nuri.query = URI::Params.build do |form|\n  form.add(\"client_id\", @client_id)\n  form.add(\"redirect_uri\", @redirect_uri)\n  form.add(\"response_type\", \"code\")\n  if scope.nil?\n  else\n    form.add(\"scope\", scope)\n  end\n  if state.nil?\n  else\n    form.add(\"state\", state)\n  end\n  uri.query_params.each do |key, value|\n    form.add(key, value)\n  end\n  yield form\nend\nuri.to_s\n"}},{"html_id":"http_client:HTTP::Client-instance-method","name":"http_client","doc":"Returns the `HTTP::Client` to use with this client.\n\nBy default, this returns a new instance every time. To reuse the same instance,\none can be assigned with `#http_client=`.","summary":"<p>Returns the <code><a href=\"../HTTP/Client.html\">HTTP::Client</a></code> to use with this client.</p>","abstract":false,"location":{"filename":"src/oauth2/client.cr","line_number":64,"url":null},"def":{"name":"http_client","return_type":"HTTP::Client","visibility":"Public","body":"@http_client || (HTTP::Client.new(token_uri))"}},{"html_id":"http_client=(http_client:HTTP::Client?)-instance-method","name":"http_client=","doc":"Sets the `HTTP::Client` to use with this client.","summary":"<p>Sets the <code><a href=\"../HTTP/Client.html\">HTTP::Client</a></code> to use with this client.</p>","abstract":false,"args":[{"name":"http_client","external_name":"http_client","restriction":"HTTP::Client | ::Nil"}],"args_string":"(http_client : HTTP::Client?)","args_html":"(http_client : <a href=\"../HTTP/Client.html\">HTTP::Client</a>?)","location":{"filename":"src/oauth2/client.cr","line_number":58,"url":null},"def":{"name":"http_client=","args":[{"name":"http_client","external_name":"http_client","restriction":"HTTP::Client | ::Nil"}],"visibility":"Public","body":"@http_client = http_client"}}]},{"html_id":"Crystal/OAuth2/Error","path":"OAuth2/Error.html","kind":"class","full_name":"OAuth2::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/oauth2/error.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OAuth2","kind":"module","full_name":"OAuth2","name":"OAuth2"}},{"html_id":"Crystal/OAuth2/Session","path":"OAuth2/Session.html","kind":"class","full_name":"OAuth2::Session","name":"Session","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/oauth2/session.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OAuth2","kind":"module","full_name":"OAuth2","name":"OAuth2"},"doc":"An OAuth2 session makes it easy to implement APIs that need to refresh\nan access token once its expired before executing an HTTP request.","summary":"<p>An OAuth2 session makes it easy to implement APIs that need to refresh an access token once its expired before executing an HTTP request.</p>","constructors":[{"html_id":"new(oauth2_client:Client,access_token:AccessToken,expires_at=Time.utc,&callback:OAuth2::Session->)-class-method","name":"new","doc":"Creates an `OAuth2::Session`.\n\nParams:\n  * *oauth2_client*: the OAuth2::Client used to refresh an access token.\n  * *access_token*: the OAuth2::AccessToken to make requests.\n  * *expires_at*: the Time when the access token expires.\n  * *callback*: invoked when an access token is refreshed, giving you a chance to persist it.","summary":"<p>Creates an <code><a href=\"../OAuth2/Session.html\">OAuth2::Session</a></code>.</p>","abstract":false,"args":[{"name":"oauth2_client","external_name":"oauth2_client","restriction":"Client"},{"name":"access_token","external_name":"access_token","restriction":"AccessToken"},{"name":"expires_at","default_value":"Time.utc","external_name":"expires_at","restriction":""}],"args_string":"(oauth2_client : Client, access_token : AccessToken, expires_at = Time.utc, &callback : OAuth2::Session -> )","args_html":"(oauth2_client : <a href=\"../OAuth2/Client.html\">Client</a>, access_token : <a href=\"../OAuth2/AccessToken.html\">AccessToken</a>, expires_at = <span class=\"t\">Time</span>.utc, &callback : <a href=\"../OAuth2/Session.html\">OAuth2::Session</a> -> )","location":{"filename":"src/oauth2/session.cr","line_number":15,"url":null},"def":{"name":"new","args":[{"name":"oauth2_client","external_name":"oauth2_client","restriction":"Client"},{"name":"access_token","external_name":"access_token","restriction":"AccessToken"},{"name":"expires_at","default_value":"Time.utc","external_name":"expires_at","restriction":""}],"yields":1,"block_arg":{"name":"callback","external_name":"callback","restriction":"(OAuth2::Session ->)"},"visibility":"Public","body":"_ = allocate\n_.initialize(oauth2_client, access_token, expires_at, &callback) do |_arg0|\n  yield _arg0\nend\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"access_token:AccessToken-instance-method","name":"access_token","abstract":false,"location":{"filename":"src/oauth2/session.cr","line_number":5,"url":null},"def":{"name":"access_token","return_type":"AccessToken","visibility":"Public","body":"@access_token"}},{"html_id":"authenticate(http_client):Nil-instance-method","name":"authenticate","doc":"Authenticates an `HTTP::Client`, refreshing the access token if it is expired.\n\nInvoke this method on an `HTTP::Client` before executing an HTTP request.","summary":"<p>Authenticates an <code><a href=\"../HTTP/Client.html\">HTTP::Client</a></code>, refreshing the access token if it is expired.</p>","abstract":false,"args":[{"name":"http_client","external_name":"http_client","restriction":""}],"args_string":"(http_client) : Nil","args_html":"(http_client) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/oauth2/session.cr","line_number":21,"url":null},"def":{"name":"authenticate","args":[{"name":"http_client","external_name":"http_client","restriction":""}],"return_type":"Nil","visibility":"Public","body":"check_refresh_token\n@access_token.authenticate(http_client)\n"}},{"html_id":"expires_at:Time?-instance-method","name":"expires_at","abstract":false,"location":{"filename":"src/oauth2/session.cr","line_number":6,"url":null},"def":{"name":"expires_at","return_type":"Time | ::Nil","visibility":"Public","body":"@expires_at"}},{"html_id":"oauth2_client:Client-instance-method","name":"oauth2_client","abstract":false,"location":{"filename":"src/oauth2/session.cr","line_number":4,"url":null},"def":{"name":"oauth2_client","return_type":"Client","visibility":"Public","body":"@oauth2_client"}}]}]},{"html_id":"Crystal/Object","path":"Object.html","kind":"class","full_name":"Object","name":"Object","abstract":true,"ancestors":[{"html_id":"Crystal/Spec/ObjectExtensions","kind":"module","full_name":"Spec::ObjectExtensions","name":"ObjectExtensions"},{"html_id":"Crystal/Colorize/ObjectExtensions","kind":"module","full_name":"Colorize::ObjectExtensions","name":"ObjectExtensions"}],"locations":[{"filename":"src/colorize.cr","line_number":187,"url":null},{"filename":"src/docs_pseudo_methods.cr","line_number":94,"url":null},{"filename":"src/json/any.cr","line_number":295,"url":null},{"filename":"src/json/to_json.cr","line_number":1,"url":null},{"filename":"src/object.cr","line_number":2,"url":null},{"filename":"src/primitives.cr","line_number":9,"url":null},{"filename":"src/spec/expectations.cr","line_number":515,"url":null},{"filename":"src/yaml/any.cr","line_number":334,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Colorize/ObjectExtensions","kind":"module","full_name":"Colorize::ObjectExtensions","name":"ObjectExtensions"},{"html_id":"Crystal/Spec/ObjectExtensions","kind":"module","full_name":"Spec::ObjectExtensions","name":"ObjectExtensions"}],"subclasses":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"}],"doc":"`Object` is the base type of all Crystal objects.","summary":"<p><code><a href=\"Object.html\">Object</a></code> is the base type of all Crystal objects.</p>","class_methods":[{"html_id":"from_json(string_or_io,root:String)-class-method","name":"from_json","doc":"Deserializes the given JSON in *string_or_io* into\nan instance of `self`, assuming the JSON consists\nof an JSON object with key *root*, and whose value is\nthe value to deserialize.\n\n```\nInt32.from_json(%({\"main\": 1}), root: \"main\") # => 1\n```","summary":"<p>Deserializes the given JSON in <em>string_or_io</em> into an instance of <code>self</code>, assuming the JSON consists of an JSON object with key <em>root</em>, and whose value is the value to deserialize.</p>","abstract":false,"args":[{"name":"string_or_io","external_name":"string_or_io","restriction":""},{"name":"root","external_name":"root","restriction":"String"}],"args_string":"(string_or_io, root : String)","args_html":"(string_or_io, root : <a href=\"String.html\">String</a>)","location":{"filename":"src/json/from_json.cr","line_number":24,"url":null},"def":{"name":"from_json","args":[{"name":"string_or_io","external_name":"string_or_io","restriction":""},{"name":"root","external_name":"root","restriction":"String"}],"visibility":"Public","body":"parser = JSON::PullParser.new(string_or_io)\nparser.on_key!(root) do\n  new(parser)\nend\n"}},{"html_id":"from_json(string_or_io)-class-method","name":"from_json","doc":"Deserializes the given JSON in *string_or_io* into\nan instance of `self`. This simply creates a `parser = JSON::PullParser`\nand invokes `new(parser)`: classes that want to provide JSON\ndeserialization must provide an `def initialize(parser : JSON::PullParser)`\nmethod.\n\n```\nInt32.from_json(\"1\")                # => 1\nArray(Int32).from_json(\"[1, 2, 3]\") # => [1, 2, 3]\n```","summary":"<p>Deserializes the given JSON in <em>string_or_io</em> into an instance of <code>self</code>.</p>","abstract":false,"args":[{"name":"string_or_io","external_name":"string_or_io","restriction":""}],"args_string":"(string_or_io)","args_html":"(string_or_io)","location":{"filename":"src/json/from_json.cr","line_number":11,"url":null},"def":{"name":"from_json","args":[{"name":"string_or_io","external_name":"string_or_io","restriction":""}],"visibility":"Public","body":"parser = JSON::PullParser.new(string_or_io)\nnew(parser)\n"}},{"html_id":"from_yaml(string_or_io:String|IO)-class-method","name":"from_yaml","doc":"Deserializes the given YAML in *string_or_io* into\nan instance of `self`. This simply creates an instance of\n`YAML::ParseContext` and invokes `new(parser, yaml)`:\nclasses that want to provide YAML deserialization must provide an\n`def initialize(parser : YAML::ParseContext, yaml : string_or_io)`\nmethod.\n\n```\nHash(String, String).from_yaml(\"{env: production}\") # => {\"env\" => \"production\"}\n```","summary":"<p>Deserializes the given YAML in <em>string_or_io</em> into an instance of <code>self</code>.</p>","abstract":false,"args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"}],"args_string":"(string_or_io : String | IO)","args_html":"(string_or_io : <a href=\"String.html\">String</a> | <a href=\"IO.html\">IO</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":11,"url":null},"def":{"name":"from_yaml","args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"}],"visibility":"Public","body":"new(YAML::ParseContext.new, parse_yaml(string_or_io))"}}],"instance_methods":[{"html_id":"!:Bool-instance-method","name":"!","doc":"Returns the boolean negation of `self`.\n\n```\n!true  # => false\n!false # => true\n!nil   # => true\n!1     # => false\n!\"foo\" # => false\n```\n\nThis method is a unary operator and usually written in prefix notation\n(`!foo`) but it can also be written as a regular method call (`foo.!`).\nNOTE: This is a pseudo-method provided directly by the Crystal compiler.\nIt cannot be redefined nor overridden.","summary":"<p>Returns the boolean negation of <code>self</code>.</p>","abstract":false,"location":{"filename":"src/docs_pseudo_methods.cr","line_number":107,"url":null},"def":{"name":"__crystal_pseudo_!","return_type":"Bool","visibility":"Public","body":""}},{"html_id":"!=(other)-instance-method","name":"!=","doc":"Returns `true` if this object is not equal to *other*.\n\nBy default this method is implemented as `!(self == other)`\nso there's no need to override this unless there's a more efficient\nway to do it.","summary":"<p>Returns <code>true</code> if this object is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/object.cr","line_number":13,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"!(self == other)"}},{"html_id":"!~(other)-instance-method","name":"!~","doc":"Shortcut to `!(self =~ other)`.","summary":"<p>Shortcut to <code>!(self =~ other)</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/object.cr","line_number":18,"url":null},"def":{"name":"!~","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"!(self =~ other)"}},{"html_id":"==(other)-instance-method","name":"==","doc":"Returns `true` if this object is equal to *other*.\n\nSubclasses override this method to provide class-specific meaning.","summary":"<p>Returns <code>true</code> if this object is equal to <em>other</em>.</p>","abstract":true,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/object.cr","line_number":6,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":""}},{"html_id":"===(other:JSON::Any)-instance-method","name":"===","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"JSON::Any"}],"args_string":"(other : JSON::Any)","args_html":"(other : <a href=\"JSON/Any.html\">JSON::Any</a>)","location":{"filename":"src/json/any.cr","line_number":296,"url":null},"def":{"name":"===","args":[{"name":"other","external_name":"other","restriction":"JSON::Any"}],"visibility":"Public","body":"self === other.raw"}},{"html_id":"===(other:YAML::Any)-instance-method","name":"===","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"YAML::Any"}],"args_string":"(other : YAML::Any)","args_html":"(other : <a href=\"YAML/Any.html\">YAML::Any</a>)","location":{"filename":"src/yaml/any.cr","line_number":335,"url":null},"def":{"name":"===","args":[{"name":"other","external_name":"other","restriction":"YAML::Any"}],"visibility":"Public","body":"self === other.raw"}},{"html_id":"===(other)-instance-method","name":"===","doc":"Case equality.\n\nThe `===` method is used in a `case ... when ... end` expression.\n\nFor example, this code:\n\n```\ncase value\nwhen x\n  # something when x\nwhen y\n  # something when y\nend\n```\n\nIs equivalent to this code:\n\n```\nif x === value\n  # something when x\nelsif y === value\n  # something when y\nend\n```\n\nObject simply implements `===` by invoking `==`, but subclasses\n(notably `Regex`) can override it to provide meaningful case-equality semantics.","summary":"<p>Case equality.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/object.cr","line_number":49,"url":null},"def":{"name":"===","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"self == other"}},{"html_id":"=~(other)-instance-method","name":"=~","doc":"Pattern match.\n\nOverridden by descendants (notably `Regex` and `String`) to provide meaningful\npattern-match semantics.","summary":"<p>Pattern match.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/object.cr","line_number":57,"url":null},"def":{"name":"=~","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"nil"}},{"html_id":"as(type:Class)-instance-method","name":"as","doc":"Returns `self`.\n\nThe type of this expression is restricted to *type* by the compiler.\n*type* must be a constant or `typeof()` expression. It cannot be evaluated at runtime.\n\nIf *type* is not a valid restriction for the expression type, it\nis a compile-time error.\nIf *type*  is a valid restriction for the expression, but `self` can't\nbe restricted to *type*, it raises at runtime.\n*type* may be a wider restriction than the expression type, the resulting\ntype is narrowed to the minimal restriction.\n\n```\na = [1, \"foo\"][0]\ntypeof(a) # => Int32 | String\n\ntypeof(a.as(Int32)) # => Int32\na.as(Int32)         # => 1\n\ntypeof(a.as(Bool)) # Compile Error: can't cast (Int32 | String) to Bool\n\ntypeof(a.as(String)) # => String\na.as(String)         # Runtime Error: cast from Int32 to String failed\n\ntypeof(a.as(Int32 | Bool)) # => Int32\na.as(Int32 | Bool)         # => 1\n```\nNOTE: This is a pseudo-method provided directly by the Crystal compiler.\nIt cannot be redefined nor overridden.","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Class"}],"args_string":"(type : Class)","args_html":"(type : <a href=\"Class.html\">Class</a>)","location":{"filename":"src/docs_pseudo_methods.cr","line_number":162,"url":null},"def":{"name":"__crystal_pseudo_as","args":[{"name":"type","external_name":"type","restriction":"Class"}],"visibility":"Public","body":""}},{"html_id":"as?(type:Class)-instance-method","name":"as?","doc":"Returns `self` or `nil` if can't be restricted to *type*.\n\nThe type of this expression is restricted to *type* by the compiler.\nIf *type* is not a valid type restriction for the expression type, then\nit is restricted to `Nil`.\n*type* must be a constant or `typeof()` expression. It cannot be evaluated at runtime.\n\n```\na = [1, \"foo\"][0]\ntypeof(a) # => Int32 | String\n\ntypeof(a.as?(Int32)) # => Int32 | Nil\na.as?(Int32)         # => 1\n\ntypeof(a.as?(Bool)) # => Bool | Nil\na.as?(Bool)         # => nil\n\ntypeof(a.as?(String)) # => String | Nil\na.as?(String)         # nil\n\ntypeof(a.as?(Int32 | Bool)) # => Int32 | Nil\na.as?(Int32 | Bool)         # => 1\n```\nNOTE: This is a pseudo-method provided directly by the Crystal compiler.\nIt cannot be redefined nor overridden.","summary":"<p>Returns <code>self</code> or <code>nil</code> if can't be restricted to <em>type</em>.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Class"}],"args_string":"(type : Class)","args_html":"(type : <a href=\"Class.html\">Class</a>)","location":{"filename":"src/docs_pseudo_methods.cr","line_number":188,"url":null},"def":{"name":"__crystal_pseudo_as?","args":[{"name":"type","external_name":"type","restriction":"Class"}],"visibility":"Public","body":""}},{"html_id":"class-instance-method","name":"class","doc":"Returns the **runtime** `Class` of an object.\n\n```\n1.class       # => Int32\n\"hello\".class # => String\n```\n\nCompare it with `typeof`, which returns the **compile-time** type of an object:\n\n```\nrandom_value = rand # => 0.627423\nvalue = random_value < 0.5 ? 1 : \"hello\"\nvalue         # => \"hello\"\nvalue.class   # => String\ntypeof(value) # => Int32 | String\n```","summary":"<p>Returns the <strong>runtime</strong> <code><a href=\"Class.html\">Class</a></code> of an object.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":27,"url":null},"def":{"name":"class","visibility":"Public","body":"# primitive: class"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy (“duplicate”) of this object.\n\nIn order to create a new object with the same value as an existing one, there\nare two possible routes:\n\n* create a *shallow copy* (`#dup`): Constructs a new object with all its\n  properties' values identical to the original object's properties. They\n  are shared references. That means for mutable values that changes to\n  either object's values will be present in both's.\n* create a *deep copy* (`#clone`): Constructs a new object with all its\n  properties' values being recursive deep copies of the original object's\n  properties.\n  There is no shared state and the new object is a completely independent\n  copy, including everything inside it. This may not be available for every\n  type.\n\nA shallow copy is only one level deep whereas a deep copy copies everything\nbelow.\n\nThis distinction is only relevant for compound values. Primitive types\ndo not have any properties that could be shared or cloned.\nIn that case, `dup` and `clone` are exactly the same.\n\nThe `#clone` method can't be defined on `Object`. It's not\ngenerically available for every type because cycles could be involved, and\nthe clone logic might not need to clone everything.\n\nMany types in the standard library, like `Array`, `Hash`, `Set` and\n`Deque`, and all primitive types, define `dup` and `clone`.\n\nExample:\n\n```\noriginal = {\"foo\" => [1, 2, 3]}\nshallow_copy = original.dup\ndeep_copy = original.clone\n\n# \"foo\" references the same array object for both original and shallow copy,\n# but not for a deep copy:\noriginal[\"foo\"] << 4\nshallow_copy[\"foo\"] # => [1, 2, 3, 4]\ndeep_copy[\"foo\"]    # => [1, 2, 3]\n\n# Assigning new value does not share it to either copy:\noriginal[\"foo\"] = [1]\nshallow_copy[\"foo\"] # => [1, 2, 3, 4]\ndeep_copy[\"foo\"]    # => [1, 2, 3]\n```","summary":"<p>Returns a shallow copy (“duplicate”) of this object.</p>","abstract":true,"location":{"filename":"src/object.cr","line_number":293,"url":null},"def":{"name":"dup","visibility":"Public","body":""}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"Appends this object's value to *hasher*, and returns the modified *hasher*.\n\nUsually the macro `def_hash` can be used to generate this method.\nOtherwise, invoke `hash(hasher)` on each object's instance variables to\naccumulate the result:\n\n```\ndef hash(hasher)\n  hasher = @some_ivar.hash(hasher)\n  hasher = @some_other_ivar.hash(hasher)\n  hasher\nend\n```","summary":"<p>Appends this object's value to <em>hasher</em>, and returns the modified <em>hasher</em>.</p>","abstract":true,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/object.cr","line_number":74,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":""}},{"html_id":"hash-instance-method","name":"hash","doc":"Generates an `UInt64` hash value for this object.\n\nThis method must have the property that `a == b` implies `a.hash == b.hash`.\n\nThe hash value is used along with `==` by the `Hash` class to determine if two objects\nreference the same hash key.\n\nSubclasses must not override this method. Instead, they must define `hash(hasher)`,\nthough usually the macro `def_hash` can be used to generate this method.","summary":"<p>Generates an <code><a href=\"UInt64.html\">UInt64</a></code> hash value for this object.</p>","abstract":false,"location":{"filename":"src/object.cr","line_number":85,"url":null},"def":{"name":"hash","visibility":"Public","body":"(hash(Crystal::Hasher.new)).result"}},{"html_id":"in?(collection:Object):Bool-instance-method","name":"in?","doc":"Returns `true` if `self` is included in the *collection* argument.\n\n```\n10.in?(0..100)     # => true\n10.in?({0, 1, 10}) # => true\n10.in?(0, 1, 10)   # => true\n10.in?(:foo, :bar) # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is included in the <em>collection</em> argument.</p>","abstract":false,"args":[{"name":"collection","external_name":"collection","restriction":"Object"}],"args_string":"(collection : Object) : Bool","args_html":"(collection : <a href=\"Object.html\">Object</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/object.cr","line_number":212,"url":null},"def":{"name":"in?","args":[{"name":"collection","external_name":"collection","restriction":"Object"}],"return_type":"Bool","visibility":"Public","body":"collection.includes?(self)"}},{"html_id":"in?(*values:Object):Bool-instance-method","name":"in?","doc":"Returns `true` if `self` is included in the *collection* argument.\n\n```\n10.in?(0..100)     # => true\n10.in?({0, 1, 10}) # => true\n10.in?(0, 1, 10)   # => true\n10.in?(:foo, :bar) # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is included in the <em>collection</em> argument.</p>","abstract":false,"args":[{"name":"values","external_name":"values","restriction":"Object"}],"args_string":"(*values : Object) : Bool","args_html":"(*values : <a href=\"Object.html\">Object</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/object.cr","line_number":217,"url":null},"def":{"name":"in?","args":[{"name":"values","external_name":"values","restriction":"Object"}],"splat_index":0,"return_type":"Bool","visibility":"Public","body":"in?(values)"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a string representation of this object\nto the given `IO` object.\n\nSimilar to `to_s(io)`, but usually appends more information\nabout this object.\nSee `#inspect`.","summary":"<p>Appends a string representation of this object to the given <code><a href=\"IO.html\">IO</a></code> object.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/object.cr","line_number":155,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"inspect:String-instance-method","name":"inspect","doc":"Returns a `String` representation of this object suitable\nto be embedded inside other expressions, sometimes providing\nmore information about this object.\n\n`#inspect` (and `#inspect(io)`) are the methods used when\nyou invoke `#to_s` or `#inspect` on an object that holds\nother objects and wants to show them. For example when you\ninvoke `Array#to_s`, `#inspect` will be invoked on each element:\n\n```\nary = [\"one\", \"two\", \"three, etc.\"]\nary.inspect # => [\"one\", \"two\", \"three, etc.\"]\n```\n\nNote that if Array invoked `#to_s` on each of the elements\nabove, the output would have been this:\n\n```\nary = [\"one\", \"two\", \"three, etc.\"]\n# If inspect invoked to_s on each element...\nary.inspect # => [one, two, three, etc.]\n```\n\nNote that it's not clear how many elements the array has,\nor which are they, because `#to_s` doesn't guarantee that\nthe string representation is clearly delimited (in the case\nof `String` the quotes are not shown).\n\nAlso note that sometimes the output of `#inspect` will look\nlike a Crystal expression that will compile, but this isn't\nalways the case, nor is it necessary. Notably, `Reference#inspect`\nand `Struct#inspect` return values that don't compile.\n\nClasses must usually **not** override this method. Instead,\nthey must override `inspect(io)`, which must append to the\ngiven `IO` object.","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> representation of this object suitable to be embedded inside other expressions, sometimes providing more information about this object.</p>","abstract":false,"location":{"filename":"src/object.cr","line_number":143,"url":null},"def":{"name":"inspect","return_type":"String","visibility":"Public","body":"String.build do |io|\n  inspect(io)\nend"}},{"html_id":"is_a?(type:Class):Bool-instance-method","name":"is_a?","doc":"Returns `true` if `self` inherits or includes *type*.\n*type* must be a constant or `typeof()`expression. It cannot be evaluated at runtime.\n\n```\na = 1\na.class                 # => Int32\na.is_a?(Int32)          # => true\na.is_a?(String)         # => false\na.is_a?(Number)         # => true\na.is_a?(Int32 | String) # => true\n```\nNOTE: This is a pseudo-method provided directly by the Crystal compiler.\nIt cannot be redefined nor overridden.","summary":"<p>Returns <code>true</code> if <code>self</code> inherits or includes <em>type</em>.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Class"}],"args_string":"(type : Class) : Bool","args_html":"(type : <a href=\"Class.html\">Class</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/docs_pseudo_methods.cr","line_number":121,"url":null},"def":{"name":"__crystal_pseudo_is_a?","args":[{"name":"type","external_name":"type","restriction":"Class"}],"return_type":"Bool","visibility":"Public","body":""}},{"html_id":"itself-instance-method","name":"itself","doc":"Returns `self`.\n\n```\nstr = \"hello\"\nstr.itself.object_id == str.object_id # => true\n```","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/object.cr","line_number":241,"url":null},"def":{"name":"itself","visibility":"Public","body":"self"}},{"html_id":"nil?:Bool-instance-method","name":"nil?","doc":"Returns `true` if `self` is `Nil`.\n\n```\n1.nil?   # => false\nnil.nil? # => true\n```\n\nThis method is equivalent to `is_a?(Nil)`.\nNOTE: This is a pseudo-method provided directly by the Crystal compiler.\nIt cannot be redefined nor overridden.","summary":"<p>Returns <code>true</code> if <code>self</code> is <code><a href=\"Nil.html\">Nil</a></code>.</p>","abstract":false,"location":{"filename":"src/docs_pseudo_methods.cr","line_number":132,"url":null},"def":{"name":"__crystal_pseudo_nil?","return_type":"Bool","visibility":"Public","body":""}},{"html_id":"not_nil!-instance-method","name":"not_nil!","doc":"Returns `self`.\n\n`Nil` overrides this method and raises `NilAssertionError`, see `Nil#not_nil!`.\n\nThis method can be used to remove `Nil` from a union type.\nHowever, it should be avoided if possible and is often considered a code smell.\nUsually, you can write code in a way that the compiler can safely exclude `Nil` types,\nfor example using [`if var`](https://crystal-lang.org/reference/syntax_and_semantics/if_var.html).\n`not_nil!` is only meant as a last resort when there's no other way to explain this to the compiler.\nEither way, consider instead raising a concrete exception with a descriptive message.","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/object.cr","line_number":231,"url":null},"def":{"name":"not_nil!","visibility":"Public","body":"self"}},{"html_id":"pretty_inspect(width=79,newline=\"\\n\",indent=0):String-instance-method","name":"pretty_inspect","doc":"Returns a pretty printed version of `self`.","summary":"<p>Returns a pretty printed version of <code>self</code>.</p>","abstract":false,"args":[{"name":"width","default_value":"79","external_name":"width","restriction":""},{"name":"newline","default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","default_value":"0","external_name":"indent","restriction":""}],"args_string":"(width = 79, newline = \"\\n\", indent = 0) : String","args_html":"(width = <span class=\"n\">79</span>, newline = <span class=\"s\">&quot;\\n&quot;</span>, indent = <span class=\"n\">0</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/object.cr","line_number":169,"url":null},"def":{"name":"pretty_inspect","args":[{"name":"width","default_value":"79","external_name":"width","restriction":""},{"name":"newline","default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","default_value":"0","external_name":"indent","restriction":""}],"return_type":"String","visibility":"Public","body":"String.build do |io|\n  PrettyPrint.format(self, io, width, newline, indent)\nend"}},{"html_id":"pretty_print(pp:PrettyPrint):Nil-instance-method","name":"pretty_print","doc":"Pretty prints `self` into the given printer.\n\nBy default appends a text that is the result of invoking\n`#inspect` on `self`. Subclasses should override\nfor custom pretty printing.","summary":"<p>Pretty prints <code>self</code> into the given printer.</p>","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":"PrettyPrint"}],"args_string":"(pp : PrettyPrint) : Nil","args_html":"(pp : <a href=\"PrettyPrint.html\">PrettyPrint</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/object.cr","line_number":164,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":"PrettyPrint"}],"return_type":"Nil","visibility":"Public","body":"pp.text(inspect)"}},{"html_id":"responds_to?(name:Symbol):Bool-instance-method","name":"responds_to?","doc":"Returns `true` if method *name* can be called on `self`.\n\n*name* must be a symbol literal, it cannot be evaluated at runtime.\n\n```\na = 1\na.responds_to?(:abs)  # => true\na.responds_to?(:size) # => false\n```\nNOTE: This is a pseudo-method provided directly by the Crystal compiler.\nIt cannot be redefined nor overridden.","summary":"<p>Returns <code>true</code> if method <em>name</em> can be called on <code>self</code>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"Symbol"}],"args_string":"(name : Symbol) : Bool","args_html":"(name : <a href=\"Symbol.html\">Symbol</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/docs_pseudo_methods.cr","line_number":200,"url":null},"def":{"name":"__crystal_pseudo_responds_to?","args":[{"name":"name","external_name":"name","restriction":"Symbol"}],"return_type":"Bool","visibility":"Public","body":""}},{"html_id":"tap(&)-instance-method","name":"tap","doc":"Yields `self` to the block, and then returns `self`.\n\nThe primary purpose of this method is to \"tap into\" a method chain,\nin order to perform operations on intermediate results within the chain.\n\n```\n(1..10).tap { |x| puts \"original: #{x.inspect}\" }\n  .to_a.tap { |x| puts \"array: #{x.inspect}\" }\n  .select { |x| x % 2 == 0 }.tap { |x| puts \"evens: #{x.inspect}\" }\n  .map { |x| x*x }.tap { |x| puts \"squares: #{x.inspect}\" }\n```","summary":"<p>Yields <code>self</code> to the block, and then returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/object.cr","line_number":186,"url":null},"def":{"name":"tap","yields":1,"visibility":"Public","body":"yield self\nself\n"}},{"html_id":"to_json(io:IO):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":8,"url":null},"def":{"name":"to_json","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"JSON.build(io) do |json|\n  to_json(json)\nend"}},{"html_id":"to_json:String-instance-method","name":"to_json","abstract":false,"location":{"filename":"src/json/to_json.cr","line_number":2,"url":null},"def":{"name":"to_json","return_type":"String","visibility":"Public","body":"String.build do |str|\n  to_json(str)\nend"}},{"html_id":"to_pretty_json(indent:String=\"\"):String-instance-method","name":"to_pretty_json","abstract":false,"args":[{"name":"indent","default_value":"\"  \"","external_name":"indent","restriction":"String"}],"args_string":"(indent : String = \"  \") : String","args_html":"(indent : <a href=\"String.html\">String</a> = <span class=\"s\">&quot;  &quot;</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/json/to_json.cr","line_number":14,"url":null},"def":{"name":"to_pretty_json","args":[{"name":"indent","default_value":"\"  \"","external_name":"indent","restriction":"String"}],"return_type":"String","visibility":"Public","body":"String.build do |str|\n  to_pretty_json(str, indent: indent)\nend"}},{"html_id":"to_pretty_json(io:IO,indent:String=\"\"):Nil-instance-method","name":"to_pretty_json","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"indent","default_value":"\"  \"","external_name":"indent","restriction":"String"}],"args_string":"(io : IO, indent : String = \"  \") : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, indent : <a href=\"String.html\">String</a> = <span class=\"s\">&quot;  &quot;</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":20,"url":null},"def":{"name":"to_pretty_json","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"indent","default_value":"\"  \"","external_name":"indent","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"JSON.build(io, indent: indent) do |json|\n  to_json(json)\nend"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a `String` representation of this object\nto the given `IO` object.\n\nAn object must never append itself to the io argument,\nas this will in turn call `to_s(io)` on it.","summary":"<p>Appends a <code><a href=\"String.html\">String</a></code> representation of this object to the given <code><a href=\"IO.html\">IO</a></code> object.</p>","abstract":true,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/object.cr","line_number":105,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":""}},{"html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns a string representation of this object.\n\nDescendants must usually **not** override this method. Instead,\nthey must override `to_s(io)`, which must append to the given\nIO object.","summary":"<p>Returns a string representation of this object.</p>","abstract":false,"location":{"filename":"src/object.cr","line_number":94,"url":null},"def":{"name":"to_s","return_type":"String","visibility":"Public","body":"String.build do |io|\n  to_s(io)\nend"}},{"html_id":"to_yaml(io:IO):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":8,"url":null},"def":{"name":"to_yaml","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"nodes_builder = YAML::Nodes::Builder.new\nto_yaml(nodes_builder)\nYAML.build(io) do |builder|\n  nodes_builder.document.to_yaml(builder)\nend\n"}},{"html_id":"to_yaml:String-instance-method","name":"to_yaml","abstract":false,"location":{"filename":"src/yaml/to_yaml.cr","line_number":2,"url":null},"def":{"name":"to_yaml","return_type":"String","visibility":"Public","body":"String.build do |io|\n  to_yaml(io)\nend"}},{"html_id":"try(&)-instance-method","name":"try","doc":"Yields `self`. `Nil` overrides this method and doesn't yield.\n\nThis method is useful for dealing with nilable types, to safely\nperform operations only when the value is not `nil`.\n\n```\n# First program argument in downcase, or nil\nARGV[0]?.try &.downcase\n```","summary":"<p>Yields <code>self</code>.</p>","abstract":false,"location":{"filename":"src/object.cr","line_number":200,"url":null},"def":{"name":"try","yields":1,"visibility":"Public","body":"yield self"}},{"html_id":"unsafe_as(type:T.class)forallT-instance-method","name":"unsafe_as","doc":"Unsafely reinterprets the bytes of an object as being of another `type`.\n\nThis method is useful to treat a type that is represented as a chunk of\nbytes as another type where those bytes convey useful information. As an\nexample, you can check the individual bytes of an `Int32`:\n\n```\n0x01020304.unsafe_as(StaticArray(UInt8, 4)) # => StaticArray[4, 3, 2, 1]\n```\n\nOr treat the bytes of a `Float64` as an `Int64`:\n\n```\n1.234_f64.unsafe_as(Int64) # => 4608236261112822104\n```\n\nThis method is **unsafe** because it behaves unpredictably when the given\n`type` doesn't have the same bytesize as the receiver, or when the given\n`type` representation doesn't semantically match the underlying bytes.\n\nAlso note that because `unsafe_as` is a regular method, unlike the pseudo-method\n`as`, you can't specify some types in the type grammar using a short notation, so\nspecifying a static array must always be done as `StaticArray(T, N)`, a tuple\nas `Tuple(...)` and so on, never as `UInt8[4]` or `{Int32, Int32}`.","summary":"<p>Unsafely reinterprets the bytes of an object as being of another <code>type</code>.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"T.class"}],"args_string":"(type : T.class) forall T","args_html":"(type : <span class=\"t\">T</span>.<span class=\"k\">class</span>) forall T","location":{"filename":"src/object.cr","line_number":319,"url":null},"def":{"name":"unsafe_as","args":[{"name":"type","external_name":"type","restriction":"T.class"}],"visibility":"Public","body":"x = self\n((pointerof(x)).as(::Pointer(T))).value\n"}}],"macros":[{"html_id":"class_getter(*names,&block)-macro","name":"class_getter","doc":"Defines getter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  class_getter name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.name\n    @@name\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  class_getter :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  class_getter name : String\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name : String\n\n  def self.name : String\n    @@name\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  class_getter name : String = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name : String = \"John Doe\"\n\n  def self.name : String\n    @@name\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferable from the initial value:\n\n```\nclass Person\n  class_getter name = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name = \"John Doe\"\n\n  def self.name : String\n    @@name\n  end\nend\n```\n\nIf a block is given to the macro, a getter is generated\nwith a variable that is lazily initialized with\nthe block's contents:\n\n```\nclass Person\n  class_getter(birth_date) { Time.local }\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.birth_date\n    if (value = @@birth_date).nil?\n      @@birth_date = Time.local\n    else\n      value\n    end\n  end\nend\n```","summary":"<p>Defines getter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","external_name":"names","restriction":""}],"args_string":"(*names, &block)","args_html":"(*names, &block)","location":{"filename":"src/object.cr","line_number":324,"url":null},"def":{"name":"class_getter","args":[{"name":"names","external_name":"names","restriction":""}],"splat_index":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"      \n{% if block %}\n        {% if names.size != 1 %}\n          {{ raise(\"Only one argument can be passed to `getter` with a block\") }}\n        {% end %}\n\n        {% name = names[0] %}\n\n        {% if name.is_a?(TypeDeclaration) %}\n          @@{{ name.var.id }} : {{ name.type }}?\n\n          def self.{{ name.var.id }} : {{ name.type }}\n            if (value = @@{{ name.var.id }}).nil?\n              @@{{ name.var.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n        {% else %}\n          def self.{{ name.id }}\n            if (value = @@{{ name.id }}).nil?\n              @@{{ name.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n        {% end %}\n      {% else %}\n        {% for name in names %}\n          {% if name.is_a?(TypeDeclaration) %}\n            @@{{ name }}\n\n            def self.{{ name.var.id }} : {{ name.type }}\n              @@{{ name.var.id }}\n            end\n          {% else %}{% if name.is_a?(Assign) %}\n            @@{{ name }}\n\n            def self.{{ name.target.id }}\n              @@{{ name.target.id }}\n            end\n          {% else %}\n            def self.{{ name.id }}\n              @@{{ name.id }}\n            end\n          {% end %}{% end %}\n        {% end %}\n      {% end %}\n\n    \n"}},{"html_id":"class_getter!(*names)-macro","name":"class_getter!","doc":"Defines raise-on-nil and nilable getter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  class_getter! name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.name?\n    @@name\n  end\n\n  def self.name\n    @@name.not_nil!\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  class_getter! :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type, as nilable.\n\n```\nclass Person\n  class_getter! name : String\nend\n```\n\nis the same as writing:\n\n```\nclass Person\n  @@name : String?\n\n  def self.name?\n    @@name\n  end\n\n  def self.name\n    @@name.not_nil!\n  end\nend\n```","summary":"<p>Defines raise-on-nil and nilable getter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","external_name":"names","restriction":""}],"args_string":"(*names)","args_html":"(*names)","location":{"filename":"src/object.cr","line_number":324,"url":null},"def":{"name":"class_getter!","args":[{"name":"names","external_name":"names","restriction":""}],"splat_index":0,"visibility":"Public","body":"      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          @@{{ name }}?\n\n          def self.{{ name.var.id }}? : {{ name.type }}?\n            @@{{ name.var.id }}\n          end\n\n          def self.{{ name.var.id }} : {{ name.type }}\n            if (value = @@{{ name.var.id }}).nil?\n              ::raise NilAssertionError.new(\"{{ @type }}{{ \".\".id }}{{ name.var.id }} cannot be nil\")\n            else\n              value\n            end\n          end\n        {% else %}\n          def self.{{ name.id }}?\n            @@{{ name.id }}\n          end\n\n          def self.{{ name.id }}\n            if (value = @@{{ name.id }}).nil?\n              ::raise NilAssertionError.new(\"{{ @type }}{{ \".\".id }}{{ name.id }} cannot be nil\")\n            else\n              value\n            end\n          end\n        {% end %}\n      {% end %}\n\n    \n"}},{"html_id":"class_getter?(*names,&block)-macro","name":"class_getter?","doc":"Defines query getter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  class_getter? happy\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.happy?\n    @@happy\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  class_getter? :happy, \"famous\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  class_getter? happy : Bool\nend\n```\n\nis the same as writing:\n\n```\nclass Person\n  @@happy : Bool\n\n  def self.happy? : Bool\n    @@happy\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  class_getter? happy : Bool = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@happy : Bool = true\n\n  def self.happy? : Bool\n    @@happy\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferable from the initial value:\n\n```\nclass Person\n  class_getter? happy = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@happy = true\n\n  def self.happy?\n    @@happy\n  end\nend\n```\n\nIf a block is given to the macro, a getter is generated\nwith a variable that is lazily initialized with\nthe block's contents, for examples see `#class_getter`.","summary":"<p>Defines query getter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","external_name":"names","restriction":""}],"args_string":"(*names, &block)","args_html":"(*names, &block)","location":{"filename":"src/object.cr","line_number":324,"url":null},"def":{"name":"class_getter?","args":[{"name":"names","external_name":"names","restriction":""}],"splat_index":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"      \n{% if block %}\n        {% if names.size != 1 %}\n          {{ raise(\"Only one argument can be passed to `getter?` with a block\") }}\n        {% end %}\n\n        {% name = names[0] %}\n\n        {% if name.is_a?(TypeDeclaration) %}\n          @@{{ name.var.id }} : {{ name.type }}?\n\n          def self.{{ name.var.id }}? : {{ name.type }}\n            if (value = @@{{ name.var.id }}).nil?\n              @@{{ name.var.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n        {% else %}\n          def self.{{ name.id }}?\n            if (value = @@{{ name.id }}).nil?\n              @@{{ name.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n        {% end %}\n      {% else %}\n        {% for name in names %}\n          {% if name.is_a?(TypeDeclaration) %}\n            @@{{ name }}\n\n            def self.{{ name.var.id }}? : {{ name.type }}\n              @@{{ name.var.id }}\n            end\n          {% else %}{% if name.is_a?(Assign) %}\n            @@{{ name }}\n\n            def self.{{ name.target.id }}?\n              @@{{ name.target.id }}\n            end\n          {% else %}\n            def self.{{ name.id }}?\n              @@{{ name.id }}\n            end\n          {% end %}{% end %}\n        {% end %}\n      {% end %}\n\n    \n"}},{"html_id":"class_property(*names,&block)-macro","name":"class_property","doc":"Defines property methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  class_property name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.name=(@@name)\n  end\n\n  def self.name\n    @@name\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  class_property :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  class_property name : String\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name : String\n\n  def self.name=(@@name)\n  end\n\n  def self.name\n    @@name\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  class_property name : String = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name : String = \"John Doe\"\n\n  def self.name=(@@name : String)\n  end\n\n  def self.name\n    @@name\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferable from the initial value:\n\n```\nclass Person\n  class_property name = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name = \"John Doe\"\n\n  def self.name=(@@name : String)\n  end\n\n  def self.name\n    @@name\n  end\nend\n```\n\nIf a block is given to the macro, a property is generated\nwith a variable that is lazily initialized with\nthe block's contents:\n\n```\nclass Person\n  class_property(birth_date) { Time.local }\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.birth_date\n    if (value = @@birth_date).nil?\n      @@birth_date = Time.local\n    else\n      value\n    end\n  end\n\n  def self.birth_date=(@@birth_date)\n  end\nend\n```","summary":"<p>Defines property methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","external_name":"names","restriction":""}],"args_string":"(*names, &block)","args_html":"(*names, &block)","location":{"filename":"src/object.cr","line_number":324,"url":null},"def":{"name":"class_property","args":[{"name":"names","external_name":"names","restriction":""}],"splat_index":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"      \n{% if block %}\n        {% if names.size != 1 %}\n          {{ raise(\"Only one argument can be passed to `property` with a block\") }}\n        {% end %}\n\n        {% name = names[0] %}\n\n        {% if name.is_a?(TypeDeclaration) %}\n          @@{{ name.var.id }} : {{ name.type }}?\n\n          def self.{{ name.var.id }} : {{ name.type }}\n            if (value = @@{{ name.var.id }}).nil?\n              @@{{ name.var.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n\n          def self.{{ name.var.id }}=(@@{{ name.var.id }} : {{ name.type }})\n          end\n        {% else %}\n          def self.{{ name.id }}\n            if (value = @@{{ name.id }}).nil?\n              @@{{ name.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n\n          def self.{{ name.id }}=(@@{{ name.id }})\n          end\n        {% end %}\n      {% else %}\n        {% for name in names %}\n          {% if name.is_a?(TypeDeclaration) %}\n            @@{{ name }}\n\n            def self.{{ name.var.id }} : {{ name.type }}\n              @@{{ name.var.id }}\n            end\n\n            def self.{{ name.var.id }}=(@@{{ name.var.id }} : {{ name.type }})\n            end\n          {% else %}{% if name.is_a?(Assign) %}\n            @@{{ name }}\n\n            def self.{{ name.target.id }}\n              @@{{ name.target.id }}\n            end\n\n            def self.{{ name.target.id }}=(@@{{ name.target.id }})\n            end\n          {% else %}\n            def self.{{ name.id }}\n              @@{{ name.id }}\n            end\n\n            def self.{{ name.id }}=(@@{{ name.id }})\n            end\n          {% end %}{% end %}\n        {% end %}\n      {% end %}\n\n    \n"}},{"html_id":"class_property!(*names)-macro","name":"class_property!","doc":"Defines raise-on-nil property methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  class_property! name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.name=(@@name)\n  end\n\n  def self.name?\n    @@name\n  end\n\n  def self.name\n    @@name.not_nil!\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  class_property! :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type, as nilable.\n\n```\nclass Person\n  class_property! name : String\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name : String?\n\n  def self.name=(@@name)\n  end\n\n  def self.name?\n    @@name\n  end\n\n  def self.name\n    @@name.not_nil!\n  end\nend\n```","summary":"<p>Defines raise-on-nil property methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","external_name":"names","restriction":""}],"args_string":"(*names)","args_html":"(*names)","location":{"filename":"src/object.cr","line_number":324,"url":null},"def":{"name":"class_property!","args":[{"name":"names","external_name":"names","restriction":""}],"splat_index":0,"visibility":"Public","body":"      class_getter! \n{{ *names }}\n\n\n      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          def self.{{ name.var.id }}=(@@{{ name.var.id }} : {{ name.type }})\n          end\n        {% else %}\n          def self.{{ name.id }}=(@@{{ name.id }})\n          end\n        {% end %}\n      {% end %}\n\n    \n"}},{"html_id":"class_property?(*names,&block)-macro","name":"class_property?","doc":"Defines query property methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  class_property? happy\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.happy=(@@happy)\n  end\n\n  def self.happy?\n    @@happy\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  class_property? :happy, \"famous\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  class_property? happy : Bool\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@happy : Bool\n\n  def self.happy=(@@happy : Bool)\n  end\n\n  def self.happy? : Bool\n    @@happy\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  class_property? happy : Bool = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@happy : Bool = true\n\n  def self.happy=(@@happy : Bool)\n  end\n\n  def self.happy? : Bool\n    @@happy\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferable from the initial value:\n\n```\nclass Person\n  class_property? happy = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@happy = true\n\n  def self.happy=(@@happy)\n  end\n\n  def self.happy?\n    @@happy\n  end\nend\n```\n\nIf a block is given to the macro, a property is generated\nwith a variable that is lazily initialized with\nthe block's contents, for examples see `#class_property`.","summary":"<p>Defines query property methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","external_name":"names","restriction":""}],"args_string":"(*names, &block)","args_html":"(*names, &block)","location":{"filename":"src/object.cr","line_number":324,"url":null},"def":{"name":"class_property?","args":[{"name":"names","external_name":"names","restriction":""}],"splat_index":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"      \n{% if block %}\n        {% if names.size != 1 %}\n          {{ raise(\"Only one argument can be passed to `property?` with a block\") }}\n        {% end %}\n\n        {% name = names[0] %}\n\n        {% if name.is_a?(TypeDeclaration) %}\n          @@{{ name.var.id }} : {{ name.type }}?\n\n          def self.{{ name.var.id }}? : {{ name.type }}\n            if (value = @@{{ name.var.id }}).nil?\n              @@{{ name.var.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n\n          def self.{{ name.var.id }}=(@@{{ name.var.id }} : {{ name.type }})\n          end\n        {% else %}\n          def self.{{ name.id }}?\n            if (value = @@{{ name.id }}).nil?\n              @@{{ name.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n\n          def self.{{ name.id }}=(@@{{ name.id }})\n          end\n        {% end %}\n      {% else %}\n        {% for name in names %}\n          {% if name.is_a?(TypeDeclaration) %}\n            @@{{ name }}\n\n            def self.{{ name.var.id }}? : {{ name.type }}\n              @@{{ name.var.id }}\n            end\n\n            def self.{{ name.var.id }}=(@@{{ name.var.id }} : {{ name.type }})\n            end\n          {% else %}{% if name.is_a?(Assign) %}\n            @@{{ name }}\n\n            def self.{{ name.target.id }}?\n              @@{{ name.target.id }}\n            end\n\n            def self.{{ name.target.id }}=(@@{{ name.target.id }})\n            end\n          {% else %}\n            def self.{{ name.id }}?\n              @@{{ name.id }}\n            end\n\n            def self.{{ name.id }}=(@@{{ name.id }})\n            end\n          {% end %}{% end %}\n        {% end %}\n      {% end %}\n\n    \n"}},{"html_id":"class_setter(*names)-macro","name":"class_setter","doc":"Defines setter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  class_setter name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def self.name=(@@name)\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  class_setter :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  class_setter name : String\nend\n```\n\nis the same as writing:\n\n```\nclass Person\n  @@name : String\n\n  def self.name=(@@name : String)\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  class_setter name : String = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name : String = \"John Doe\"\n\n  def self.name=(@@name : String)\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferable from the initial value:\n\n```\nclass Person\n  class_setter name = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @@name = \"John Doe\"\n\n  def self.name=(@@name)\n  end\nend\n```","summary":"<p>Defines setter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","external_name":"names","restriction":""}],"args_string":"(*names)","args_html":"(*names)","location":{"filename":"src/object.cr","line_number":324,"url":null},"def":{"name":"class_setter","args":[{"name":"names","external_name":"names","restriction":""}],"splat_index":0,"visibility":"Public","body":"      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          @@{{ name }}\n\n          def self.{{ name.var.id }}=(@@{{ name.var.id }} : {{ name.type }})\n          end\n        {% else %}{% if name.is_a?(Assign) %}\n          @@{{ name }}\n\n          def self.{{ name.target.id }}=(@@{{ name.target.id }})\n          end\n        {% else %}\n          def self.{{ name.id }}=(@@{{ name.id }})\n          end\n        {% end %}{% end %}\n      {% end %}\n\n    \n"}},{"html_id":"def_clone-macro","name":"def_clone","doc":"Defines a `clone` method that returns a copy of this object with all\ninstance variables cloned (`clone` is in turn invoked on them).","summary":"<p>Defines a <code>clone</code> method that returns a copy of this object with all instance variables cloned (<code>clone</code> is in turn invoked on them).</p>","abstract":false,"location":{"filename":"src/object.cr","line_number":1403,"url":null},"def":{"name":"def_clone","visibility":"Public","body":"    \n# Returns a copy of `self` with all instance variables cloned.\n\n    def clone\n      \n\\{% if\n @type < Reference && !@type.instance_vars.map(&.type).all? \n{ |t| t == ::Bool || t == ::Char || t == ::Symbol || t == ::String || t < ::Number::Primitive } %}\n        \nexec_recursive_clone do |hash|\n          clone = \n\\{\n{@type}}.allocate\n          hash[object_id] = clone.object_id\n          clone.initialize_copy(self)\n          GC.add_finalizer(clone) if clone.responds_to?(:finalize)\n          clone\n        \nend\n      \n\\{% e\nlse %}\n        clone = \n\\{\n{@type}}.allocate\n        clone.initialize_copy(self)\n        GC.add_finalizer(clone) if clone.responds_to?(:finalize)\n        clone\n      \n\\{% end\n %}\n    \nend\n\n    protected def initialize_copy(other)\n      \n\\{% for\n ivar in @type.instance_vars %}\n        @\n\\{\n{ivar.id}} = other.@\n\\{\n{ivar.id}}.clone\n      \n\\{% end\n %}\n    \nend\n  \n"}},{"html_id":"def_equals(*fields)-macro","name":"def_equals","doc":"Defines an `==` method by comparing the given fields.\n\nThe generated `==` method has a `self` restriction.\nFor classes it will first compare by reference and return `true`\nwhen an object instance is compared with itself, without comparing\nany of the fields.\n\n```\nclass Person\n  def initialize(@name, @age)\n  end\n\n  # Define a `==` method that compares @name and @age\n  def_equals @name, @age\nend\n```","summary":"<p>Defines an <code><a href=\"Object.html#%3D%3D%28other%29-instance-method\">#==</a></code> method by comparing the given fields.</p>","abstract":false,"args":[{"name":"fields","external_name":"fields","restriction":""}],"args_string":"(*fields)","args_html":"(*fields)","location":{"filename":"src/object.cr","line_number":1350,"url":null},"def":{"name":"def_equals","args":[{"name":"fields","external_name":"fields","restriction":""}],"splat_index":0,"visibility":"Public","body":"    def ==(other : self)\n      \n{% if @type.class? %}\n        return true if same?(other)\n      {% end %}\n\n      \n{% for field in fields %}\n        return false unless {{ field.id }} == other.{{ field.id }}\n      {% end %}\n\n      true\n    \nend\n  \n"}},{"html_id":"def_equals_and_hash(*fields)-macro","name":"def_equals_and_hash","doc":"Defines `hash` and `==` method from the given fields.\n\nThe generated `==` method has a `self` restriction.\n\n```\nclass Person\n  def initialize(@name, @age)\n  end\n\n  # Define a hash method based on @name and @age\n  # Define a `==` method that compares @name and @age\n  def_equals_and_hash @name, @age\nend\n```","summary":"<p>Defines <code><a href=\"Object.html#hash-instance-method\">#hash</a></code> and <code><a href=\"Object.html#%3D%3D%28other%29-instance-method\">#==</a></code> method from the given fields.</p>","abstract":false,"args":[{"name":"fields","external_name":"fields","restriction":""}],"args_string":"(*fields)","args_html":"(*fields)","location":{"filename":"src/object.cr","line_number":1376,"url":null},"def":{"name":"def_equals_and_hash","args":[{"name":"fields","external_name":"fields","restriction":""}],"splat_index":0,"visibility":"Public","body":"    def_equals \n{{ *fields }}\n\n    def_hash \n{{ *fields }}\n\n  \n"}},{"html_id":"def_hash(*fields)-macro","name":"def_hash","doc":"Defines a `hash(hasher)` that will append a hash value for the given fields.\n\n```\nclass Person\n  def initialize(@name, @age)\n  end\n\n  # Define a hash(hasher) method based on @name and @age\n  def_hash @name, @age\nend\n```","summary":"<p>Defines a <code><a href=\"Object.html#hash%28hasher%29-instance-method\">#hash(hasher)</a></code> that will append a hash value for the given fields.</p>","abstract":false,"args":[{"name":"fields","external_name":"fields","restriction":""}],"args_string":"(*fields)","args_html":"(*fields)","location":{"filename":"src/object.cr","line_number":1325,"url":null},"def":{"name":"def_hash","args":[{"name":"fields","external_name":"fields","restriction":""}],"splat_index":0,"visibility":"Public","body":"    def hash(hasher)\n      \n{% for field in fields %}\n        hasher = {{ field.id }}.hash(hasher)\n      {% end %}\n\n      hasher\n    \nend\n  \n"}},{"html_id":"delegate(*methods,toobject)-macro","name":"delegate","doc":"Delegate *methods* to *to*.\n\nNote that due to current language limitations this is only useful\nwhen no captured blocks are involved.\n\n```\nclass StringWrapper\n  def initialize(@string : String)\n  end\n\n  delegate downcase, to: @string\n  delegate gsub, to: @string\n  delegate empty?, capitalize, to: @string\n  delegate :[], to: @string\nend\n\nwrapper = StringWrapper.new \"HELLO\"\nwrapper.downcase       # => \"hello\"\nwrapper.gsub(/E/, \"A\") # => \"HALLO\"\nwrapper.empty?         # => false\nwrapper.capitalize     # => \"Hello\"\n```","summary":"<p>Delegate <em>methods</em> to <em>to</em>.</p>","abstract":false,"args":[{"name":"methods","external_name":"methods","restriction":""},{"name":"object","external_name":"to","restriction":""}],"args_string":"(*methods, to object)","args_html":"(*methods, to object)","location":{"filename":"src/object.cr","line_number":1292,"url":null},"def":{"name":"delegate","args":[{"name":"methods","external_name":"methods","restriction":""},{"name":"object","external_name":"to","restriction":""}],"splat_index":0,"visibility":"Public","body":"    \n{% for method in methods %}\n      {% if (method.id.ends_with?('=')) && (method.id != \"[]=\") %}\n        def {{ method.id }}(arg)\n          {{ object.id }}.{{ method.id }} arg\n        end\n      {% else %}\n        def {{ method.id }}(*args, **options)\n          {{ object.id }}.{{ method.id }}(*args, **options)\n        end\n\n        {% if method.id != \"[]=\" %}\n          def {{ method.id }}(*args, **options)\n            {{ object.id }}.{{ method.id }}(*args, **options) do |*yield_args|\n              yield *yield_args\n            end\n          end\n        {% end %}\n      {% end %}\n    {% end %}\n\n  \n"}},{"html_id":"forward_missing_to(delegate)-macro","name":"forward_missing_to","doc":"Forwards missing methods to *delegate*.\n\n```\nclass StringWrapper\n  def initialize(@string : String)\n  end\n\n  forward_missing_to @string\nend\n\nwrapper = StringWrapper.new \"HELLO\"\nwrapper.downcase       # => \"hello\"\nwrapper.gsub(/E/, \"A\") # => \"HALLO\"\n```","summary":"<p>Forwards missing methods to <em>delegate</em>.</p>","abstract":false,"args":[{"name":"delegate","external_name":"delegate","restriction":""}],"args_string":"(delegate)","args_html":"(delegate)","location":{"filename":"src/object.cr","line_number":1395,"url":null},"def":{"name":"forward_missing_to","args":[{"name":"delegate","external_name":"delegate","restriction":""}],"visibility":"Public","body":"    macro method_missing(call)\n      \n{{ delegate }}\n.\n\\{\n{call}}\n    \nend\n  \n"}},{"html_id":"getter(*names,&block)-macro","name":"getter","doc":"Defines getter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  getter name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def name\n    @name\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  getter :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  getter name : String\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name : String\n\n  def name : String\n    @name\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  getter name : String = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name : String = \"John Doe\"\n\n  def name : String\n    @name\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferable from the initial value:\n\n```\nclass Person\n  getter name = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name = \"John Doe\"\n\n  def name : String\n    @name\n  end\nend\n```\n\nIf a block is given to the macro, a getter is generated\nwith a variable that is lazily initialized with\nthe block's contents:\n\n```\nclass Person\n  getter(birth_date) { Time.local }\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def birth_date\n    if (value = @birth_date).nil?\n      @birth_date = Time.local\n    else\n      value\n    end\n  end\nend\n```","summary":"<p>Defines getter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","external_name":"names","restriction":""}],"args_string":"(*names, &block)","args_html":"(*names, &block)","location":{"filename":"src/object.cr","line_number":324,"url":null},"def":{"name":"getter","args":[{"name":"names","external_name":"names","restriction":""}],"splat_index":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"      \n{% if block %}\n        {% if names.size != 1 %}\n          {{ raise(\"Only one argument can be passed to `getter` with a block\") }}\n        {% end %}\n\n        {% name = names[0] %}\n\n        {% if name.is_a?(TypeDeclaration) %}\n          @{{ name.var.id }} : {{ name.type }}?\n\n          def {{ name.var.id }} : {{ name.type }}\n            if (value = @{{ name.var.id }}).nil?\n              @{{ name.var.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n        {% else %}\n          def {{ name.id }}\n            if (value = @{{ name.id }}).nil?\n              @{{ name.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n        {% end %}\n      {% else %}\n        {% for name in names %}\n          {% if name.is_a?(TypeDeclaration) %}\n            @{{ name }}\n\n            def {{ name.var.id }} : {{ name.type }}\n              @{{ name.var.id }}\n            end\n          {% else %}{% if name.is_a?(Assign) %}\n            @{{ name }}\n\n            def {{ name.target.id }}\n              @{{ name.target.id }}\n            end\n          {% else %}\n            def {{ name.id }}\n              @{{ name.id }}\n            end\n          {% end %}{% end %}\n        {% end %}\n      {% end %}\n\n    \n"}},{"html_id":"getter!(*names)-macro","name":"getter!","doc":"Defines raise-on-nil and nilable getter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  getter! name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def name?\n    @name\n  end\n\n  def name\n    @name.not_nil!\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  getter! :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type, as nilable.\n\n```\nclass Person\n  getter! name : String\nend\n```\n\nis the same as writing:\n\n```\nclass Person\n  @name : String?\n\n  def name?\n    @name\n  end\n\n  def name\n    @name.not_nil!\n  end\nend\n```","summary":"<p>Defines raise-on-nil and nilable getter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","external_name":"names","restriction":""}],"args_string":"(*names)","args_html":"(*names)","location":{"filename":"src/object.cr","line_number":324,"url":null},"def":{"name":"getter!","args":[{"name":"names","external_name":"names","restriction":""}],"splat_index":0,"visibility":"Public","body":"      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          @{{ name }}?\n\n          def {{ name.var.id }}? : {{ name.type }}?\n            @{{ name.var.id }}\n          end\n\n          def {{ name.var.id }} : {{ name.type }}\n            if (value = @{{ name.var.id }}).nil?\n              ::raise NilAssertionError.new(\"{{ @type }}{{ \"#\".id }}{{ name.var.id }} cannot be nil\")\n            else\n              value\n            end\n          end\n        {% else %}\n          def {{ name.id }}?\n            @{{ name.id }}\n          end\n\n          def {{ name.id }}\n            if (value = @{{ name.id }}).nil?\n              ::raise NilAssertionError.new(\"{{ @type }}{{ \"#\".id }}{{ name.id }} cannot be nil\")\n            else\n              value\n            end\n          end\n        {% end %}\n      {% end %}\n\n    \n"}},{"html_id":"getter?(*names,&block)-macro","name":"getter?","doc":"Defines query getter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  getter? happy\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def happy?\n    @happy\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  getter? :happy, \"famous\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  getter? happy : Bool\nend\n```\n\nis the same as writing:\n\n```\nclass Person\n  @happy : Bool\n\n  def happy? : Bool\n    @happy\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  getter? happy : Bool = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @happy : Bool = true\n\n  def happy? : Bool\n    @happy\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferable from the initial value:\n\n```\nclass Person\n  getter? happy = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @happy = true\n\n  def happy?\n    @happy\n  end\nend\n```\n\nIf a block is given to the macro, a getter is generated\nwith a variable that is lazily initialized with\nthe block's contents, for examples see `#getter`.","summary":"<p>Defines query getter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","external_name":"names","restriction":""}],"args_string":"(*names, &block)","args_html":"(*names, &block)","location":{"filename":"src/object.cr","line_number":324,"url":null},"def":{"name":"getter?","args":[{"name":"names","external_name":"names","restriction":""}],"splat_index":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"      \n{% if block %}\n        {% if names.size != 1 %}\n          {{ raise(\"Only one argument can be passed to `getter?` with a block\") }}\n        {% end %}\n\n        {% name = names[0] %}\n\n        {% if name.is_a?(TypeDeclaration) %}\n          @{{ name.var.id }} : {{ name.type }}?\n\n          def {{ name.var.id }}? : {{ name.type }}\n            if (value = @{{ name.var.id }}).nil?\n              @{{ name.var.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n        {% else %}\n          def {{ name.id }}?\n            if (value = @{{ name.id }}).nil?\n              @{{ name.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n        {% end %}\n      {% else %}\n        {% for name in names %}\n          {% if name.is_a?(TypeDeclaration) %}\n            @{{ name }}\n\n            def {{ name.var.id }}? : {{ name.type }}\n              @{{ name.var.id }}\n            end\n          {% else %}{% if name.is_a?(Assign) %}\n            @{{ name }}\n\n            def {{ name.target.id }}?\n              @{{ name.target.id }}\n            end\n          {% else %}\n            def {{ name.id }}?\n              @{{ name.id }}\n            end\n          {% end %}{% end %}\n        {% end %}\n      {% end %}\n\n    \n"}},{"html_id":"property(*names,&block)-macro","name":"property","doc":"Defines property methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  property name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def name=(@name)\n  end\n\n  def name\n    @name\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  property :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  property name : String\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name : String\n\n  def name=(@name)\n  end\n\n  def name\n    @name\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  property name : String = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name : String = \"John Doe\"\n\n  def name=(@name : String)\n  end\n\n  def name\n    @name\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferable from the initial value:\n\n```\nclass Person\n  property name = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name = \"John Doe\"\n\n  def name=(@name : String)\n  end\n\n  def name\n    @name\n  end\nend\n```\n\nIf a block is given to the macro, a property is generated\nwith a variable that is lazily initialized with\nthe block's contents:\n\n```\nclass Person\n  property(birth_date) { Time.local }\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def birth_date\n    if (value = @birth_date).nil?\n      @birth_date = Time.local\n    else\n      value\n    end\n  end\n\n  def birth_date=(@birth_date)\n  end\nend\n```","summary":"<p>Defines property methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","external_name":"names","restriction":""}],"args_string":"(*names, &block)","args_html":"(*names, &block)","location":{"filename":"src/object.cr","line_number":324,"url":null},"def":{"name":"property","args":[{"name":"names","external_name":"names","restriction":""}],"splat_index":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"      \n{% if block %}\n        {% if names.size != 1 %}\n          {{ raise(\"Only one argument can be passed to `property` with a block\") }}\n        {% end %}\n\n        {% name = names[0] %}\n\n        {% if name.is_a?(TypeDeclaration) %}\n          @{{ name.var.id }} : {{ name.type }}?\n\n          def {{ name.var.id }} : {{ name.type }}\n            if (value = @{{ name.var.id }}).nil?\n              @{{ name.var.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n\n          def {{ name.var.id }}=(@{{ name.var.id }} : {{ name.type }})\n          end\n        {% else %}\n          def {{ name.id }}\n            if (value = @{{ name.id }}).nil?\n              @{{ name.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n\n          def {{ name.id }}=(@{{ name.id }})\n          end\n        {% end %}\n      {% else %}\n        {% for name in names %}\n          {% if name.is_a?(TypeDeclaration) %}\n            @{{ name }}\n\n            def {{ name.var.id }} : {{ name.type }}\n              @{{ name.var.id }}\n            end\n\n            def {{ name.var.id }}=(@{{ name.var.id }} : {{ name.type }})\n            end\n          {% else %}{% if name.is_a?(Assign) %}\n            @{{ name }}\n\n            def {{ name.target.id }}\n              @{{ name.target.id }}\n            end\n\n            def {{ name.target.id }}=(@{{ name.target.id }})\n            end\n          {% else %}\n            def {{ name.id }}\n              @{{ name.id }}\n            end\n\n            def {{ name.id }}=(@{{ name.id }})\n            end\n          {% end %}{% end %}\n        {% end %}\n      {% end %}\n\n    \n"}},{"html_id":"property!(*names)-macro","name":"property!","doc":"Defines raise-on-nil property methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  property! name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def name=(@name)\n  end\n\n  def name?\n    @name\n  end\n\n  def name\n    @name.not_nil!\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  property! :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type, as nilable.\n\n```\nclass Person\n  property! name : String\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name : String?\n\n  def name=(@name)\n  end\n\n  def name?\n    @name\n  end\n\n  def name\n    @name.not_nil!\n  end\nend\n```","summary":"<p>Defines raise-on-nil property methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","external_name":"names","restriction":""}],"args_string":"(*names)","args_html":"(*names)","location":{"filename":"src/object.cr","line_number":324,"url":null},"def":{"name":"property!","args":[{"name":"names","external_name":"names","restriction":""}],"splat_index":0,"visibility":"Public","body":"      getter! \n{{ *names }}\n\n\n      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          def {{ name.var.id }}=(@{{ name.var.id }} : {{ name.type }})\n          end\n        {% else %}\n          def {{ name.id }}=(@{{ name.id }})\n          end\n        {% end %}\n      {% end %}\n\n    \n"}},{"html_id":"property?(*names,&block)-macro","name":"property?","doc":"Defines query property methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  property? happy\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def happy=(@happy)\n  end\n\n  def happy?\n    @happy\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  property? :happy, \"famous\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  property? happy : Bool\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @happy : Bool\n\n  def happy=(@happy : Bool)\n  end\n\n  def happy? : Bool\n    @happy\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  property? happy : Bool = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @happy : Bool = true\n\n  def happy=(@happy : Bool)\n  end\n\n  def happy? : Bool\n    @happy\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferable from the initial value:\n\n```\nclass Person\n  property? happy = true\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @happy = true\n\n  def happy=(@happy)\n  end\n\n  def happy?\n    @happy\n  end\nend\n```\n\nIf a block is given to the macro, a property is generated\nwith a variable that is lazily initialized with\nthe block's contents, for examples see `#property`.","summary":"<p>Defines query property methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","external_name":"names","restriction":""}],"args_string":"(*names, &block)","args_html":"(*names, &block)","location":{"filename":"src/object.cr","line_number":324,"url":null},"def":{"name":"property?","args":[{"name":"names","external_name":"names","restriction":""}],"splat_index":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"      \n{% if block %}\n        {% if names.size != 1 %}\n          {{ raise(\"Only one argument can be passed to `property?` with a block\") }}\n        {% end %}\n\n        {% name = names[0] %}\n\n        {% if name.is_a?(TypeDeclaration) %}\n          @{{ name.var.id }} : {{ name.type }}?\n\n          def {{ name.var.id }}? : {{ name.type }}\n            if (value = @{{ name.var.id }}).nil?\n              @{{ name.var.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n\n          def {{ name.var.id }}=(@{{ name.var.id }} : {{ name.type }})\n          end\n        {% else %}\n          def {{ name.id }}?\n            if (value = @{{ name.id }}).nil?\n              @{{ name.id }} = {{ yield }}\n            else\n              value\n            end\n          end\n\n          def {{ name.id }}=(@{{ name.id }})\n          end\n        {% end %}\n      {% else %}\n        {% for name in names %}\n          {% if name.is_a?(TypeDeclaration) %}\n            @{{ name }}\n\n            def {{ name.var.id }}? : {{ name.type }}\n              @{{ name.var.id }}\n            end\n\n            def {{ name.var.id }}=(@{{ name.var.id }} : {{ name.type }})\n            end\n          {% else %}{% if name.is_a?(Assign) %}\n            @{{ name }}\n\n            def {{ name.target.id }}?\n              @{{ name.target.id }}\n            end\n\n            def {{ name.target.id }}=(@{{ name.target.id }})\n            end\n          {% else %}\n            def {{ name.id }}?\n              @{{ name.id }}\n            end\n\n            def {{ name.id }}=(@{{ name.id }})\n            end\n          {% end %}{% end %}\n        {% end %}\n      {% end %}\n\n    \n"}},{"html_id":"setter(*names)-macro","name":"setter","doc":"Defines setter methods for each of the given arguments.\n\nWriting:\n\n```\nclass Person\n  setter name\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  def name=(@name)\n  end\nend\n```\n\nThe arguments can be string literals, symbol literals or plain names:\n\n```\nclass Person\n  setter :name, \"age\"\nend\n```\n\nIf a type declaration is given, a variable with that name\nis declared with that type.\n\n```\nclass Person\n  setter name : String\nend\n```\n\nis the same as writing:\n\n```\nclass Person\n  @name : String\n\n  def name=(@name : String)\n  end\nend\n```\n\nThe type declaration can also include an initial value:\n\n```\nclass Person\n  setter name : String = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name : String = \"John Doe\"\n\n  def name=(@name : String)\n  end\nend\n```\n\nAn assignment can be passed too, but in this case the type of the\nvariable must be easily inferable from the initial value:\n\n```\nclass Person\n  setter name = \"John Doe\"\nend\n```\n\nIs the same as writing:\n\n```\nclass Person\n  @name = \"John Doe\"\n\n  def name=(@name)\n  end\nend\n```","summary":"<p>Defines setter methods for each of the given arguments.</p>","abstract":false,"args":[{"name":"names","external_name":"names","restriction":""}],"args_string":"(*names)","args_html":"(*names)","location":{"filename":"src/object.cr","line_number":324,"url":null},"def":{"name":"setter","args":[{"name":"names","external_name":"names","restriction":""}],"splat_index":0,"visibility":"Public","body":"      \n{% for name in names %}\n        {% if name.is_a?(TypeDeclaration) %}\n          @{{ name }}\n\n          def {{ name.var.id }}=(@{{ name.var.id }} : {{ name.type }})\n          end\n        {% else %}{% if name.is_a?(Assign) %}\n          @{{ name }}\n\n          def {{ name.target.id }}=(@{{ name.target.id }})\n          end\n        {% else %}\n          def {{ name.id }}=(@{{ name.id }})\n          end\n        {% end %}{% end %}\n      {% end %}\n\n    \n"}}]},{"html_id":"Crystal/OpenSSL","path":"OpenSSL.html","kind":"module","full_name":"OpenSSL","name":"OpenSSL","abstract":false,"locations":[{"filename":"src/openssl.cr","line_number":67,"url":null},{"filename":"src/openssl/algorithm.cr","line_number":3,"url":null},{"filename":"src/openssl/digest.cr","line_number":5,"url":null},{"filename":"src/openssl/error.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"## OpenSSL Integration\n\n- TLS sockets need a context, potentially with keys (required for servers) and configuration.\n- TLS sockets will wrap the underlying TCP socket, and any further communication must happen through the `OpenSSL::SSL::Socket` only.\n\n## Usage Example\n\nRecommended ciphers can be taken from:\n- [OWASP Wiki](https://www.owasp.org/index.php/Transport_Layer_Protection_Cheat_Sheet#Rule_-_Only_Support_Strong_Cryptographic_Ciphers)\n- [Cipherli.st](https://cipherli.st/)\n- A full list is available at the [OpenSSL Docs](https://www.openssl.org/docs/man1.1.0/apps/ciphers.html#CIPHER-STRINGS)\n\nDo note that:\n- Crystal does its best to provide sane configuration defaults (see [Mozilla-Intermediate](https://wiki.mozilla.org/Security/Server_Side_TLS#Intermediate_compatibility_.28default.29)).\n- Linked version of OpenSSL need to be checked for supporting specific protocols and ciphers.\n- If any configurations or choices in Crystal regarding SSL settings and security are found to be lacking or need\n  improvement please [open an issue](https://github.com/crystal-lang/crystal/issues/new) and let us know.\n\n### Server side\n\nNOTE: For the below example to work, a key pair should be attained.\n\n```\nrequire \"socket\"\nrequire \"openssl\"\n\ndef server\n  # Bind new TCPSocket to port 5555\n  socket = TCPServer.new(5555)\n\n  context = OpenSSL::SSL::Context::Server.new\n  context.private_key = \"/path/to/private.key\"\n  context.certificate_chain = \"/path/to/public.cert\"\n\n  puts \"Server is up\"\n\n  socket.accept do |client|\n    puts \"Got client\"\n\n    bytes = Bytes.new(20)\n\n    ssl_socket = OpenSSL::SSL::Socket::Server.new(client, context)\n    ssl_socket.read(bytes)\n\n    puts String.new(bytes)\n  end\nend\n```\n\n### Client side\n\n```\nrequire \"socket\"\nrequire \"openssl\"\n\ndef client\n  socket = TCPSocket.new(\"127.0.0.1\", 5555)\n  context = OpenSSL::SSL::Context::Client.new\n\n  ssl_socket = OpenSSL::SSL::Socket::Client.new(socket, context)\n  ssl_socket << \"Testing\"\nend\n```","summary":"<h2><a id=\"open-ssl-integration\" class=\"anchor\" href=\"#open-ssl-integration\">  <svg class=\"octicon-link\" aria-hidden=\"true\">\n    <use href=\"#octicon-link\"/>\n  </svg>\n</a>OpenSSL Integration</h2>","types":[{"html_id":"Crystal/OpenSSL/Algorithm","path":"OpenSSL/Algorithm.html","kind":"enum","full_name":"OpenSSL::Algorithm","name":"Algorithm","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/algorithm.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"MD4","name":"MD4","value":"0"},{"id":"MD5","name":"MD5","value":"1"},{"id":"RIPEMD160","name":"RIPEMD160","value":"2"},{"id":"SHA1","name":"SHA1","value":"3"},{"id":"SHA224","name":"SHA224","value":"4"},{"id":"SHA256","name":"SHA256","value":"5"},{"id":"SHA384","name":"SHA384","value":"6"},{"id":"SHA512","name":"SHA512","value":"7"}],"namespace":{"html_id":"Crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"doc":"Indicates the possible hash algorithms for `OpenSSL` digest operations.","summary":"<p>Indicates the possible hash algorithms for <code><a href=\"../OpenSSL.html\">OpenSSL</a></code> digest operations.</p>","instance_methods":[{"html_id":"md4?-instance-method","name":"md4?","abstract":false,"location":{"filename":"src/openssl/algorithm.cr","line_number":6,"url":null},"def":{"name":"md4?","visibility":"Public","body":"self == MD4"}},{"html_id":"md5?-instance-method","name":"md5?","abstract":false,"location":{"filename":"src/openssl/algorithm.cr","line_number":7,"url":null},"def":{"name":"md5?","visibility":"Public","body":"self == MD5"}},{"html_id":"ripemd160?-instance-method","name":"ripemd160?","abstract":false,"location":{"filename":"src/openssl/algorithm.cr","line_number":8,"url":null},"def":{"name":"ripemd160?","visibility":"Public","body":"self == RIPEMD160"}},{"html_id":"sha1?-instance-method","name":"sha1?","abstract":false,"location":{"filename":"src/openssl/algorithm.cr","line_number":9,"url":null},"def":{"name":"sha1?","visibility":"Public","body":"self == SHA1"}},{"html_id":"sha224?-instance-method","name":"sha224?","abstract":false,"location":{"filename":"src/openssl/algorithm.cr","line_number":10,"url":null},"def":{"name":"sha224?","visibility":"Public","body":"self == SHA224"}},{"html_id":"sha256?-instance-method","name":"sha256?","abstract":false,"location":{"filename":"src/openssl/algorithm.cr","line_number":11,"url":null},"def":{"name":"sha256?","visibility":"Public","body":"self == SHA256"}},{"html_id":"sha384?-instance-method","name":"sha384?","abstract":false,"location":{"filename":"src/openssl/algorithm.cr","line_number":12,"url":null},"def":{"name":"sha384?","visibility":"Public","body":"self == SHA384"}},{"html_id":"sha512?-instance-method","name":"sha512?","abstract":false,"location":{"filename":"src/openssl/algorithm.cr","line_number":13,"url":null},"def":{"name":"sha512?","visibility":"Public","body":"self == SHA512"}},{"html_id":"to_evp-instance-method","name":"to_evp","doc":"Returns the appropriate equivalent hash algorithm that corresponds to the\ncurrent enum value.\n\nThe internal bindings to the `LibCrypto` digest operations sometimes require a hash algorithm\nimplementation to be passed as one of the arguments.","summary":"<p>Returns the appropriate equivalent hash algorithm that corresponds to the current enum value.</p>","abstract":false,"location":{"filename":"src/openssl/algorithm.cr","line_number":20,"url":null},"def":{"name":"to_evp","visibility":"Public","body":"case self\nwhen MD4\n  LibCrypto.evp_md4\nwhen MD5\n  LibCrypto.evp_md5\nwhen RIPEMD160\n  LibCrypto.evp_ripemd160\nwhen SHA1\n  LibCrypto.evp_sha1\nwhen SHA224\n  LibCrypto.evp_sha224\nwhen SHA256\n  LibCrypto.evp_sha256\nwhen SHA384\n  LibCrypto.evp_sha384\nwhen SHA512\n  LibCrypto.evp_sha512\nelse\n  raise(\"Unsupported algorithm: #{self}\")\nend"}}]},{"html_id":"Crystal/OpenSSL/Cipher","path":"OpenSSL/Cipher.html","kind":"class","full_name":"OpenSSL::Cipher","name":"Cipher","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/cipher.cr","line_number":40,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"doc":"A class which can be used to encrypt and decrypt data using a specified cipher.\n\n```\nrequire \"random/secure\"\n\nkey = Random::Secure.random_bytes(64) # You can also use OpenSSL::Cipher#random_key to do this same thing\niv = Random::Secure.random_bytes(32)  # You can also use OpenSSL::Cipher#random_iv to do this same thing\n\ndef encrypt(data)\n  cipher = OpenSSL::Cipher.new(\"aes-256-cbc\")\n  cipher.encrypt\n  cipher.key = key\n  cipher.iv = iv\n\n  io = IO::Memory.new\n  io.write(cipher.update(data))\n  io.write(cipher.final)\n  io.rewind\n\n  io.to_slice\nend\n\ndef decrypt(data)\n  cipher = OpenSSL::Cipher.new(\"aes-256-cbc\")\n  cipher.decrypt\n  cipher.key = key\n  cipher.iv = iv\n\n  io = IO::Memory.new\n  io.write(cipher.update(data))\n  io.write(cipher.final)\n  io.rewind\n\n  io.gets_to_end\nend\n```","summary":"<p>A class which can be used to encrypt and decrypt data using a specified cipher.</p>","constructors":[{"html_id":"new(name)-class-method","name":"new","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name)","args_html":"(name)","location":{"filename":"src/openssl/cipher.cr","line_number":44,"url":null},"def":{"name":"new","args":[{"name":"name","external_name":"name","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(name)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"authenticated?:Bool-instance-method","name":"authenticated?","abstract":false,"location":{"filename":"src/openssl/cipher.cr","line_number":152,"url":null},"def":{"name":"authenticated?","return_type":"Bool","visibility":"Public","body":"(LibCrypto.evp_cipher_flags(cipher)).includes?(LibCrypto::CipherFlags::EVP_CIPH_FLAG_AEAD_CIPHER)"}},{"html_id":"block_size:Int32-instance-method","name":"block_size","abstract":false,"location":{"filename":"src/openssl/cipher.cr","line_number":133,"url":null},"def":{"name":"block_size","return_type":"Int32","visibility":"Public","body":"LibCrypto.evp_cipher_block_size(cipher)"}},{"html_id":"decrypt:Nil-instance-method","name":"decrypt","doc":"Sets this cipher to decryption mode.","summary":"<p>Sets this cipher to decryption mode.</p>","abstract":false,"location":{"filename":"src/openssl/cipher.cr","line_number":62,"url":null},"def":{"name":"decrypt","return_type":"Nil","visibility":"Public","body":"cipherinit(enc: 0)"}},{"html_id":"encrypt:Nil-instance-method","name":"encrypt","doc":"Sets this cipher to encryption mode.","summary":"<p>Sets this cipher to encryption mode.</p>","abstract":false,"location":{"filename":"src/openssl/cipher.cr","line_number":57,"url":null},"def":{"name":"encrypt","return_type":"Nil","visibility":"Public","body":"cipherinit(enc: 1)"}},{"html_id":"final:Bytes-instance-method","name":"final","doc":"Outputs the decrypted or encrypted buffer.","summary":"<p>Outputs the decrypted or encrypted buffer.</p>","abstract":false,"location":{"filename":"src/openssl/cipher.cr","line_number":108,"url":null},"def":{"name":"final","return_type":"Bytes","visibility":"Public","body":"buffer_length = block_size\nbuffer = Bytes.new(buffer_length)\nif (LibCrypto.evp_cipherfinal_ex(@ctx, buffer, pointerof(buffer_length))) != 1\n  raise(Error.new(\"EVP_CipherFinal_ex\"))\nend\nbuffer[0, buffer_length]\n"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/openssl/cipher.cr","line_number":147,"url":null},"def":{"name":"finalize","visibility":"Public","body":"if @ctx\n  LibCrypto.evp_cipher_ctx_free(@ctx)\nend\n@ctx = (typeof(@ctx)).null\n"}},{"html_id":"iv=(iv)-instance-method","name":"iv=","abstract":false,"args":[{"name":"iv","external_name":"iv","restriction":""}],"args_string":"(iv)","args_html":"(iv)","location":{"filename":"src/openssl/cipher.cr","line_number":72,"url":null},"def":{"name":"iv=","args":[{"name":"iv","external_name":"iv","restriction":""}],"visibility":"Public","body":"if iv.bytesize < iv_len\n  raise(ArgumentError.new(\"iv length too short: wanted #{iv_len}, got #{iv.bytesize}\"))\nend\ncipherinit(iv: iv)\niv\n"}},{"html_id":"iv_len:Int32-instance-method","name":"iv_len","doc":"How many bytes the iv should be.","summary":"<p>How many bytes the iv should be.</p>","abstract":false,"location":{"filename":"src/openssl/cipher.cr","line_number":143,"url":null},"def":{"name":"iv_len","return_type":"Int32","visibility":"Public","body":"LibCrypto.evp_cipher_iv_length(cipher)"}},{"html_id":"key=(key)-instance-method","name":"key=","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""}],"args_string":"(key)","args_html":"(key)","location":{"filename":"src/openssl/cipher.cr","line_number":66,"url":null},"def":{"name":"key=","args":[{"name":"key","external_name":"key","restriction":""}],"visibility":"Public","body":"if key.bytesize < key_len\n  raise(ArgumentError.new(\"Key length too short: wanted #{key_len}, got #{key.bytesize}\"))\nend\ncipherinit(key: key)\nkey\n"}},{"html_id":"key_len:Int32-instance-method","name":"key_len","doc":"How many bytes the key should be.","summary":"<p>How many bytes the key should be.</p>","abstract":false,"location":{"filename":"src/openssl/cipher.cr","line_number":138,"url":null},"def":{"name":"key_len","return_type":"Int32","visibility":"Public","body":"LibCrypto.evp_cipher_key_length(cipher)"}},{"html_id":"name:String-instance-method","name":"name","abstract":false,"location":{"filename":"src/openssl/cipher.cr","line_number":127,"url":null},"def":{"name":"name","return_type":"String","visibility":"Public","body":"nid = LibCrypto.evp_cipher_nid(cipher)\nsn = LibCrypto.obj_nid2sn(nid)\nString.new(sn)\n"}},{"html_id":"padding=(pad:Bool)-instance-method","name":"padding=","abstract":false,"args":[{"name":"pad","external_name":"pad","restriction":"Bool"}],"args_string":"(pad : Bool)","args_html":"(pad : <a href=\"../Bool.html\">Bool</a>)","location":{"filename":"src/openssl/cipher.cr","line_number":119,"url":null},"def":{"name":"padding=","args":[{"name":"pad","external_name":"pad","restriction":"Bool"}],"visibility":"Public","body":"if (LibCrypto.evp_cipher_ctx_set_padding(@ctx, pad ? 1 : 0)) != 1\n  raise(Error.new(\"EVP_CIPHER_CTX_set_padding\"))\nend\npad\n"}},{"html_id":"random_iv-instance-method","name":"random_iv","doc":"Sets the iv using `Random::Secure`.","summary":"<p>Sets the iv using <code><a href=\"../Random/Secure.html\">Random::Secure</a></code>.</p>","abstract":false,"location":{"filename":"src/openssl/cipher.cr","line_number":85,"url":null},"def":{"name":"random_iv","visibility":"Public","body":"iv = Random::Secure.random_bytes(iv_len)\nself.iv = iv\n"}},{"html_id":"random_key-instance-method","name":"random_key","doc":"Sets the key using `Random::Secure`.","summary":"<p>Sets the key using <code><a href=\"../Random/Secure.html\">Random::Secure</a></code>.</p>","abstract":false,"location":{"filename":"src/openssl/cipher.cr","line_number":79,"url":null},"def":{"name":"random_key","visibility":"Public","body":"key = Random::Secure.random_bytes(key_len)\nself.key = key\n"}},{"html_id":"reset-instance-method","name":"reset","doc":"Resets the encrypt/decrypt mode.","summary":"<p>Resets the encrypt/decrypt mode.</p>","abstract":false,"location":{"filename":"src/openssl/cipher.cr","line_number":91,"url":null},"def":{"name":"reset","visibility":"Public","body":"cipherinit"}},{"html_id":"update(data)-instance-method","name":"update","doc":"Add the data to be encrypted or decrypted to this cipher's buffer.","summary":"<p>Add the data to be encrypted or decrypted to this cipher's buffer.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":""}],"args_string":"(data)","args_html":"(data)","location":{"filename":"src/openssl/cipher.cr","line_number":96,"url":null},"def":{"name":"update","args":[{"name":"data","external_name":"data","restriction":""}],"visibility":"Public","body":"slice = data.to_slice\nbuffer_length = slice.size + block_size\nbuffer = Bytes.new(buffer_length)\nif (LibCrypto.evp_cipherupdate(@ctx, buffer, pointerof(buffer_length), slice, slice.size)) != 1\n  raise(Error.new(\"EVP_CipherUpdate\"))\nend\nbuffer[0, buffer_length]\n"}}],"types":[{"html_id":"Crystal/OpenSSL/Cipher/Error","path":"OpenSSL/Cipher/Error.html","kind":"class","full_name":"OpenSSL::Cipher::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/OpenSSL/Error","kind":"class","full_name":"OpenSSL::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/OpenSSL/Error","kind":"class","full_name":"OpenSSL::Error","name":"Error"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/cipher.cr","line_number":41,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OpenSSL/Cipher","kind":"class","full_name":"OpenSSL::Cipher","name":"Cipher"}}]},{"html_id":"Crystal/OpenSSL/Digest","path":"OpenSSL/Digest.html","kind":"class","full_name":"OpenSSL::Digest","name":"Digest","abstract":false,"superclass":{"html_id":"Crystal/Digest","kind":"class","full_name":"Digest","name":"Digest"},"ancestors":[{"html_id":"Crystal/Digest","kind":"class","full_name":"Digest","name":"Digest"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/digest.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/Digest/MD5","kind":"class","full_name":"Digest::MD5","name":"MD5"},{"html_id":"Crystal/Digest/SHA1","kind":"class","full_name":"Digest::SHA1","name":"SHA1"},{"html_id":"Crystal/Digest/SHA256","kind":"class","full_name":"Digest::SHA256","name":"SHA256"},{"html_id":"Crystal/Digest/SHA512","kind":"class","full_name":"Digest::SHA512","name":"SHA512"}],"namespace":{"html_id":"Crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"constructors":[{"html_id":"new(name:String)-class-method","name":"new","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String)","args_html":"(name : <a href=\"../String.html\">String</a>)","location":{"filename":"src/openssl/digest.cr","line_number":14,"url":null},"def":{"name":"new","args":[{"name":"name","external_name":"name","restriction":"String"}],"visibility":"Public","body":"_ = allocate\n_.initialize(name)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"block_size:Int32-instance-method","name":"block_size","abstract":false,"location":{"filename":"src/openssl/digest.cr","line_number":78,"url":null},"def":{"name":"block_size","return_type":"Int32","visibility":"Public","body":"(LibCrypto.evp_md_block_size(to_unsafe_md)).to_i"}},{"html_id":"digest_size:Int32-instance-method","name":"digest_size","doc":"Returns the digest output size in bytes.","summary":"<p>Returns the digest output size in bytes.</p>","abstract":false,"location":{"filename":"src/openssl/digest.cr","line_number":74,"url":null},"def":{"name":"digest_size","return_type":"Int32","visibility":"Public","body":"(LibCrypto.evp_md_size(to_unsafe_md)).to_i"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy of this object.\n\nThis allocates a new object and copies the contents of\n`self` into it.","summary":"<p>Returns a shallow copy of this object.</p>","abstract":false,"location":{"filename":"src/openssl/digest.cr","line_number":41,"url":null},"def":{"name":"dup","visibility":"Public","body":"Digest.new(@name, dup_ctx)"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/openssl/digest.cr","line_number":37,"url":null},"def":{"name":"finalize","visibility":"Public","body":"LibCrypto.evp_md_ctx_free(self)"}},{"html_id":"name:String-instance-method","name":"name","abstract":false,"location":{"filename":"src/openssl/digest.cr","line_number":11,"url":null},"def":{"name":"name","return_type":"String","visibility":"Public","body":"@name"}},{"html_id":"to_unsafe:Pointer(LibCrypto::EVP_MD_CTX_Struct)-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/openssl/digest.cr","line_number":86,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@ctx"}},{"html_id":"to_unsafe_md-instance-method","name":"to_unsafe_md","abstract":false,"location":{"filename":"src/openssl/digest.cr","line_number":82,"url":null},"def":{"name":"to_unsafe_md","visibility":"Public","body":"LibCrypto.evp_md_ctx_md(self)"}}],"types":[{"html_id":"Crystal/OpenSSL/Digest/Error","path":"OpenSSL/Digest/Error.html","kind":"class","full_name":"OpenSSL::Digest::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/OpenSSL/Error","kind":"class","full_name":"OpenSSL::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/OpenSSL/Error","kind":"class","full_name":"OpenSSL::Error","name":"Error"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/digest.cr","line_number":7,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/OpenSSL/Digest/UnsupportedError","kind":"class","full_name":"OpenSSL::Digest::UnsupportedError","name":"UnsupportedError"}],"namespace":{"html_id":"Crystal/OpenSSL/Digest","kind":"class","full_name":"OpenSSL::Digest","name":"Digest"}},{"html_id":"Crystal/OpenSSL/Digest/UnsupportedError","path":"OpenSSL/Digest/UnsupportedError.html","kind":"class","full_name":"OpenSSL::Digest::UnsupportedError","name":"UnsupportedError","abstract":false,"superclass":{"html_id":"Crystal/OpenSSL/Digest/Error","kind":"class","full_name":"OpenSSL::Digest::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/OpenSSL/Digest/Error","kind":"class","full_name":"OpenSSL::Digest::Error","name":"Error"},{"html_id":"Crystal/OpenSSL/Error","kind":"class","full_name":"OpenSSL::Error","name":"Error"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/digest.cr","line_number":9,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OpenSSL/Digest","kind":"class","full_name":"OpenSSL::Digest","name":"Digest"}}]},{"html_id":"Crystal/OpenSSL/Error","path":"OpenSSL/Error.html","kind":"class","full_name":"OpenSSL::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/error.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/OpenSSL/Cipher/Error","kind":"class","full_name":"OpenSSL::Cipher::Error","name":"Error"},{"html_id":"Crystal/OpenSSL/Digest/Error","kind":"class","full_name":"OpenSSL::Digest::Error","name":"Error"},{"html_id":"Crystal/OpenSSL/SSL/Error","kind":"class","full_name":"OpenSSL::SSL::Error","name":"Error"}],"namespace":{"html_id":"Crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"constructors":[{"html_id":"new(message=nil,fetched=false,cause:Exception?=nil)-class-method","name":"new","abstract":false,"args":[{"name":"message","default_value":"nil","external_name":"message","restriction":""},{"name":"fetched","default_value":"false","external_name":"fetched","restriction":""},{"name":"cause","default_value":"nil","external_name":"cause","restriction":"Exception | ::Nil"}],"args_string":"(message = nil, fetched = false, cause : Exception? = nil)","args_html":"(message = <span class=\"n\">nil</span>, fetched = <span class=\"n\">false</span>, cause : <a href=\"../Exception.html\">Exception</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/openssl/error.cr","line_number":8,"url":null},"def":{"name":"new","args":[{"name":"message","default_value":"nil","external_name":"message","restriction":""},{"name":"fetched","default_value":"false","external_name":"fetched","restriction":""},{"name":"cause","default_value":"nil","external_name":"cause","restriction":"Exception | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(message, fetched, cause)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"code:LibCrypto::ULong-instance-method","name":"code","abstract":false,"location":{"filename":"src/openssl/error.cr","line_number":6,"url":null},"def":{"name":"code","return_type":"LibCrypto::ULong","visibility":"Public","body":"if (value = @code).nil?\n  ::raise(NilAssertionError.new(\"OpenSSL::Error#code cannot be nil\"))\nelse\n  value\nend"}},{"html_id":"code?:LibCrypto::ULong?-instance-method","name":"code?","abstract":false,"location":{"filename":"src/openssl/error.cr","line_number":6,"url":null},"def":{"name":"code?","return_type":"LibCrypto::ULong | ::Nil","visibility":"Public","body":"@code"}}]},{"html_id":"Crystal/OpenSSL/HMAC","path":"OpenSSL/HMAC.html","kind":"class","full_name":"OpenSSL::HMAC","name":"HMAC","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/hmac.cr","line_number":12,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"doc":"Allows computing Hash-based Message Authentication Code (HMAC).\n\nIt is a type of message authentication code (MAC)\ninvolving a hash function in combination with a key.\n\nHMAC can be used to verify the integrity of a message as well as the authenticity.\n\nSee also [RFC2104](https://tools.ietf.org/html/rfc2104.html).","summary":"<p>Allows computing Hash-based Message Authentication Code (HMAC).</p>","class_methods":[{"html_id":"digest(algorithm:OpenSSL::Algorithm,key,data):Bytes-class-method","name":"digest","doc":"Returns the HMAC digest of *data* using the secret *key*.\n\nIt may contain non-ASCII bytes, including NUL bytes.\n\n*algorithm* specifies which `OpenSSL::Algorithm` is to be used.","summary":"<p>Returns the HMAC digest of <em>data</em> using the secret <em>key</em>.</p>","abstract":false,"args":[{"name":"algorithm","external_name":"algorithm","restriction":"OpenSSL::Algorithm"},{"name":"key","external_name":"key","restriction":""},{"name":"data","external_name":"data","restriction":""}],"args_string":"(algorithm : OpenSSL::Algorithm, key, data) : Bytes","args_html":"(algorithm : <a href=\"../OpenSSL/Algorithm.html\">OpenSSL::Algorithm</a>, key, data) : <a href=\"../Bytes.html\">Bytes</a>","location":{"filename":"src/openssl/hmac.cr","line_number":18,"url":null},"def":{"name":"digest","args":[{"name":"algorithm","external_name":"algorithm","restriction":"OpenSSL::Algorithm"},{"name":"key","external_name":"key","restriction":""},{"name":"data","external_name":"data","restriction":""}],"return_type":"Bytes","visibility":"Public","body":"evp = algorithm.to_evp\nkey_slice = key.to_slice\ndata_slice = data.to_slice\nbuffer = Bytes.new(128)\nLibCrypto.hmac(evp, key_slice, key_slice.size, data_slice, data_slice.size, buffer, out buffer_len)\nbuffer[0, buffer_len.to_i]\n"}},{"html_id":"hexdigest(algorithm:OpenSSL::Algorithm,key,data):String-class-method","name":"hexdigest","doc":"Returns the HMAC digest of *data* using the secret *key*,\nformatted as a hexadecimal string. This is necessary to safely transfer\nthe digest where binary messages are not allowed.\n\nSee also `#digest`.","summary":"<p>Returns the HMAC digest of <em>data</em> using the secret <em>key</em>, formatted as a hexadecimal string.</p>","abstract":false,"args":[{"name":"algorithm","external_name":"algorithm","restriction":"OpenSSL::Algorithm"},{"name":"key","external_name":"key","restriction":""},{"name":"data","external_name":"data","restriction":""}],"args_string":"(algorithm : OpenSSL::Algorithm, key, data) : String","args_html":"(algorithm : <a href=\"../OpenSSL/Algorithm.html\">OpenSSL::Algorithm</a>, key, data) : <a href=\"../String.html\">String</a>","location":{"filename":"src/openssl/hmac.cr","line_number":32,"url":null},"def":{"name":"hexdigest","args":[{"name":"algorithm","external_name":"algorithm","restriction":"OpenSSL::Algorithm"},{"name":"key","external_name":"key","restriction":""},{"name":"data","external_name":"data","restriction":""}],"return_type":"String","visibility":"Public","body":"(digest(algorithm, key, data)).hexstring"}}]},{"html_id":"Crystal/OpenSSL/MD5","path":"OpenSSL/MD5.html","kind":"class","full_name":"OpenSSL::MD5","name":"MD5","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/md5.cr","line_number":9,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"doc":"Binds the OpenSSL MD5 hash functions.\n\nWARNING: MD5 is no longer a cryptographically secure hash, and should not be\nused in security-related components, like password hashing. For passwords, see\n`Crypto::Bcrypt::Password`. For a generic cryptographic hash, use SHA-256 via\n`OpenSSL::Digest.new(\"SHA256\")`.","summary":"<p>Binds the OpenSSL MD5 hash functions.</p>","class_methods":[{"html_id":"hash(data:Pointer(UInt8),bytesize:Int):StaticArray(UInt8,16)-class-method","name":"hash","abstract":false,"args":[{"name":"data","external_name":"data","restriction":"::Pointer(UInt8)"},{"name":"bytesize","external_name":"bytesize","restriction":"Int"}],"args_string":"(data : Pointer(UInt8), bytesize : Int) : StaticArray(UInt8, 16)","args_html":"(data : <a href=\"../Pointer.html\">Pointer</a>(<a href=\"../UInt8.html\">UInt8</a>), bytesize : <a href=\"../Int.html\">Int</a>) : <a href=\"../StaticArray.html\">StaticArray</a>(<a href=\"../UInt8.html\">UInt8</a>, <span class=\"n\">16</span>)","location":{"filename":"src/openssl/md5.cr","line_number":14,"url":null},"def":{"name":"hash","args":[{"name":"data","external_name":"data","restriction":"::Pointer(UInt8)"},{"name":"bytesize","external_name":"bytesize","restriction":"Int"}],"return_type":"::StaticArray(UInt8, 16)","visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 16)\nLibCrypto.md5(data, bytesize, buffer)\nbuffer\n"}},{"html_id":"hash(data:String):StaticArray(UInt8,16)-class-method","name":"hash","abstract":false,"args":[{"name":"data","external_name":"data","restriction":"String"}],"args_string":"(data : String) : StaticArray(UInt8, 16)","args_html":"(data : <a href=\"../String.html\">String</a>) : <a href=\"../StaticArray.html\">StaticArray</a>(<a href=\"../UInt8.html\">UInt8</a>, <span class=\"n\">16</span>)","location":{"filename":"src/openssl/md5.cr","line_number":10,"url":null},"def":{"name":"hash","args":[{"name":"data","external_name":"data","restriction":"String"}],"return_type":"::StaticArray(UInt8, 16)","visibility":"Public","body":"hash(data.to_unsafe, data.bytesize)"}}]},{"html_id":"Crystal/OpenSSL/PKCS5","path":"OpenSSL/PKCS5.html","kind":"module","full_name":"OpenSSL::PKCS5","name":"PKCS5","abstract":false,"locations":[{"filename":"src/openssl/pkcs5.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"class_methods":[{"html_id":"pbkdf2_hmac(secret,salt,iterations=2**16,algorithm:OpenSSL::Algorithm=OpenSSL::Algorithm::SHA1,key_size=64):Bytes-class-method","name":"pbkdf2_hmac","abstract":false,"args":[{"name":"secret","external_name":"secret","restriction":""},{"name":"salt","external_name":"salt","restriction":""},{"name":"iterations","default_value":"2 ** 16","external_name":"iterations","restriction":""},{"name":"algorithm","default_value":"OpenSSL::Algorithm::SHA1","external_name":"algorithm","restriction":"OpenSSL::Algorithm"},{"name":"key_size","default_value":"64","external_name":"key_size","restriction":""}],"args_string":"(secret, salt, iterations = 2 ** 16, algorithm : OpenSSL::Algorithm = OpenSSL::Algorithm::SHA1, key_size = 64) : Bytes","args_html":"(secret, salt, iterations = <span class=\"n\">2</span> <span class=\"o\">**</span> <span class=\"n\">16</span>, algorithm : <a href=\"../OpenSSL/Algorithm.html\">OpenSSL::Algorithm</a> = <span class=\"t\">OpenSSL</span><span class=\"t\">::</span><span class=\"t\">Algorithm</span><span class=\"t\">::</span><span class=\"t\">SHA1</span>, key_size = <span class=\"n\">64</span>) : <a href=\"../Bytes.html\">Bytes</a>","location":{"filename":"src/openssl/pkcs5.cr","line_number":13,"url":null},"def":{"name":"pbkdf2_hmac","args":[{"name":"secret","external_name":"secret","restriction":""},{"name":"salt","external_name":"salt","restriction":""},{"name":"iterations","default_value":"2 ** 16","external_name":"iterations","restriction":""},{"name":"algorithm","default_value":"OpenSSL::Algorithm::SHA1","external_name":"algorithm","restriction":"OpenSSL::Algorithm"},{"name":"key_size","default_value":"64","external_name":"key_size","restriction":""}],"return_type":"Bytes","visibility":"Public","body":"{% if LibCrypto.has_method?(:pkcs5_pbkdf2_hmac) %}\n      evp = algorithm.to_evp\n      buffer = Bytes.new(key_size)\n      if LibCrypto.pkcs5_pbkdf2_hmac(secret, secret.bytesize, salt, salt.bytesize, iterations, evp, key_size, buffer) != 1\n        raise OpenSSL::Error.new \"pkcs5_pbkdf2_hmac\"\n      end\n      buffer\n    {% else %}\n      raise OpenSSL::Error.new \"Method 'pkcs5_pbkdf2_hmac' not supported with OpenSSL version #{LibSSL::OPENSSL_VERSION}\"\n    {% end %}"}},{"html_id":"pbkdf2_hmac_sha1(secret,salt,iterations=2**16,key_size=64):Bytes-class-method","name":"pbkdf2_hmac_sha1","abstract":false,"args":[{"name":"secret","external_name":"secret","restriction":""},{"name":"salt","external_name":"salt","restriction":""},{"name":"iterations","default_value":"2 ** 16","external_name":"iterations","restriction":""},{"name":"key_size","default_value":"64","external_name":"key_size","restriction":""}],"args_string":"(secret, salt, iterations = 2 ** 16, key_size = 64) : Bytes","args_html":"(secret, salt, iterations = <span class=\"n\">2</span> <span class=\"o\">**</span> <span class=\"n\">16</span>, key_size = <span class=\"n\">64</span>) : <a href=\"../Bytes.html\">Bytes</a>","location":{"filename":"src/openssl/pkcs5.cr","line_number":5,"url":null},"def":{"name":"pbkdf2_hmac_sha1","args":[{"name":"secret","external_name":"secret","restriction":""},{"name":"salt","external_name":"salt","restriction":""},{"name":"iterations","default_value":"2 ** 16","external_name":"iterations","restriction":""},{"name":"key_size","default_value":"64","external_name":"key_size","restriction":""}],"return_type":"Bytes","visibility":"Public","body":"buffer = Bytes.new(key_size)\nif (LibCrypto.pkcs5_pbkdf2_hmac_sha1(secret, secret.bytesize, salt, salt.bytesize, iterations, key_size, buffer)) != 1\n  raise(OpenSSL::Error.new(\"pkcs5_pbkdf2_hmac\"))\nend\nbuffer\n"}}]},{"html_id":"Crystal/OpenSSL/SHA1","path":"OpenSSL/SHA1.html","kind":"class","full_name":"OpenSSL::SHA1","name":"SHA1","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/sha1.cr","line_number":9,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"doc":"Binds the OpenSSL SHA1 hash functions.\n\nWARNING: SHA1 is no longer a cryptographically secure hash, and should not be\nused in security-related components, like password hashing. For passwords, see\n`Crypto::Bcrypt::Password`. For a generic cryptographic hash, use SHA-256 via\n`OpenSSL::Digest.new(\"SHA256\")`.","summary":"<p>Binds the OpenSSL SHA1 hash functions.</p>","class_methods":[{"html_id":"hash(data:Pointer(UInt8),bytesize:LibC::SizeT)-class-method","name":"hash","abstract":false,"args":[{"name":"data","external_name":"data","restriction":"::Pointer(UInt8)"},{"name":"bytesize","external_name":"bytesize","restriction":"LibC::SizeT"}],"args_string":"(data : Pointer(UInt8), bytesize : LibC::SizeT)","args_html":"(data : <a href=\"../Pointer.html\">Pointer</a>(<a href=\"../UInt8.html\">UInt8</a>), bytesize : LibC::SizeT)","location":{"filename":"src/openssl/sha1.cr","line_number":14,"url":null},"def":{"name":"hash","args":[{"name":"data","external_name":"data","restriction":"::Pointer(UInt8)"},{"name":"bytesize","external_name":"bytesize","restriction":"LibC::SizeT"}],"visibility":"Public","body":"buffer = uninitialized ::StaticArray(UInt8, 20)\nLibCrypto.sha1(data, bytesize, buffer)\nbuffer\n"}},{"html_id":"hash(data:String)-class-method","name":"hash","abstract":false,"args":[{"name":"data","external_name":"data","restriction":"String"}],"args_string":"(data : String)","args_html":"(data : <a href=\"../String.html\">String</a>)","location":{"filename":"src/openssl/sha1.cr","line_number":10,"url":null},"def":{"name":"hash","args":[{"name":"data","external_name":"data","restriction":"String"}],"visibility":"Public","body":"hash(data.to_unsafe, LibC::SizeT.new(data.bytesize))"}}]},{"html_id":"Crystal/OpenSSL/SSL","path":"OpenSSL/SSL.html","kind":"module","full_name":"OpenSSL::SSL","name":"SSL","abstract":false,"locations":[{"filename":"src/openssl.cr","line_number":68,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OpenSSL","kind":"module","full_name":"OpenSSL","name":"OpenSSL"},"types":[{"html_id":"Crystal/OpenSSL/SSL/Context","path":"OpenSSL/SSL/Context.html","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context","abstract":true,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/ssl/context.cr","line_number":9,"url":null},{"filename":"src/openssl/ssl/defaults.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"CIPHER_SUITES_INTERMEDIATE","name":"CIPHER_SUITES_INTERMEDIATE","value":"\"TLS_AES_128_GCM_SHA256:TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256\"","doc":"The list of secure ciphersuites on **intermediate** compatibility level as per Mozilla\nrecommendations.\n\nThe oldest clients supported by this configuration are:\n* Firefox 27\n* Android 4.4.2\n* Chrome 31\n* Edge\n* IE 11 on Windows 7\n* Java 8u31\n* OpenSSL 1.0.1\n* Opera 20\n* Safari 9\n\nThis list represents version 5.6 of the intermediate configuration\navailable at https://ssl-config.mozilla.org/guidelines/5.6.json.\n\nSee https://wiki.mozilla.org/Security/Server_Side_TLS for details.","summary":"<p>The list of secure ciphersuites on <strong>intermediate</strong> compatibility level as per Mozilla recommendations.</p>"},{"id":"CIPHER_SUITES_MODERN","name":"CIPHER_SUITES_MODERN","value":"\"TLS_AES_128_GCM_SHA256:TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256\"","doc":"The list of secure ciphersuites on **modern** compatibility level as per Mozilla\nrecommendations.\n\nThe oldest clients supported by this configuration are:\n* Firefox 63\n* Android 10.0\n* Chrome 70\n* Edge 75\n* Java 11\n* OpenSSL 1.1.1\n* Opera 57\n* Safari 12.1\n\nThis list represents version 5.6 of the modern configuration\navailable at https://ssl-config.mozilla.org/guidelines/5.6.json.\n\nSee https://wiki.mozilla.org/Security/Server_Side_TLS for details.","summary":"<p>The list of secure ciphersuites on <strong>modern</strong> compatibility level as per Mozilla recommendations.</p>"},{"id":"CIPHER_SUITES_OLD","name":"CIPHER_SUITES_OLD","value":"\"TLS_AES_128_GCM_SHA256:TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256\"","doc":"The list of secure ciphersuites on **old** compatibility level as per Mozilla\nrecommendations.\n\nThe oldest clients supported by this configuration are:\n* Firefox 1\n* Android 2.3\n* Chrome 1\n* Edge 12\n* IE8 on Windows XP\n* Java 6\n* OpenSSL 0.9.8\n* Opera 5\n* Safari 1\n\nThis list represents version 5.6 of the old configuration\navailable at https://ssl-config.mozilla.org/guidelines/5.6.json.\n\nSee https://wiki.mozilla.org/Security/Server_Side_TLS for details.","summary":"<p>The list of secure ciphersuites on <strong>old</strong> compatibility level as per Mozilla recommendations.</p>"},{"id":"CIPHERS_INTERMEDIATE","name":"CIPHERS_INTERMEDIATE","value":"\"TLS_AES_128_GCM_SHA256:TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:DHE-RSA-AES128-GCM-SHA256:DHE-RSA-AES256-GCM-SHA384:!RC4:!aNULL:!eNULL:!LOW:!3DES:!MD5:!EXP:!PSK:!SRP:!DSS\"","doc":"The list of secure ciphers on **intermediate** compatibility level as per Mozilla\nrecommendations.\n\nThe oldest clients supported by this configuration are:\n* Firefox 27\n* Android 4.4.2\n* Chrome 31\n* Edge\n* IE 11 on Windows 7\n* Java 8u31\n* OpenSSL 1.0.1\n* Opera 20\n* Safari 9\n\nThis list represents version 5.6 of the intermediate configuration\navailable at https://ssl-config.mozilla.org/guidelines/5.6.json.\n\nSee https://wiki.mozilla.org/Security/Server_Side_TLS for details.","summary":"<p>The list of secure ciphers on <strong>intermediate</strong> compatibility level as per Mozilla recommendations.</p>"},{"id":"CIPHERS_MODERN","name":"CIPHERS_MODERN","value":"\"TLS_AES_128_GCM_SHA256:TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256:!RC4:!aNULL:!eNULL:!LOW:!3DES:!MD5:!EXP:!PSK:!SRP:!DSS\"","doc":"The list of secure ciphers on **modern** compatibility level as per Mozilla\nrecommendations.\n\nThe oldest clients supported by this configuration are:\n* Firefox 63\n* Android 10.0\n* Chrome 70\n* Edge 75\n* Java 11\n* OpenSSL 1.1.1\n* Opera 57\n* Safari 12.1\n\nThis list represents version 5.6 of the modern configuration\navailable at https://ssl-config.mozilla.org/guidelines/5.6.json.\n\nSee https://wiki.mozilla.org/Security/Server_Side_TLS for details.","summary":"<p>The list of secure ciphers on <strong>modern</strong> compatibility level as per Mozilla recommendations.</p>"},{"id":"CIPHERS_OLD","name":"CIPHERS_OLD","value":"\"TLS_AES_128_GCM_SHA256:TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:DHE-RSA-AES128-GCM-SHA256:DHE-RSA-AES256-GCM-SHA384:DHE-RSA-CHACHA20-POLY1305:ECDHE-ECDSA-AES128-SHA256:ECDHE-RSA-AES128-SHA256:ECDHE-ECDSA-AES128-SHA:ECDHE-RSA-AES128-SHA:ECDHE-ECDSA-AES256-SHA384:ECDHE-RSA-AES256-SHA384:ECDHE-ECDSA-AES256-SHA:ECDHE-RSA-AES256-SHA:DHE-RSA-AES128-SHA256:DHE-RSA-AES256-SHA256:AES128-GCM-SHA256:AES256-GCM-SHA384:AES128-SHA256:AES256-SHA256:AES128-SHA:AES256-SHA:DES-CBC3-SHA:!RC4:!aNULL:!eNULL:!LOW:!3DES:!MD5:!EXP:!PSK:!SRP:!DSS\"","doc":"The list of secure ciphers on **old** compatibility level as per Mozilla\nrecommendations.\n\nThe oldest clients supported by this configuration are:\n* Firefox 1\n* Android 2.3\n* Chrome 1\n* Edge 12\n* IE8 on Windows XP\n* Java 6\n* OpenSSL 0.9.8\n* Opera 5\n* Safari 1\n\nThis list represents version 5.6 of the old configuration\navailable at https://ssl-config.mozilla.org/guidelines/5.6.json.\n\nSee https://wiki.mozilla.org/Security/Server_Side_TLS for details.","summary":"<p>The list of secure ciphers on <strong>old</strong> compatibility level as per Mozilla recommendations.</p>"}],"subclasses":[{"html_id":"Crystal/OpenSSL/SSL/Context/Client","kind":"class","full_name":"OpenSSL::SSL::Context::Client","name":"Client"},{"html_id":"Crystal/OpenSSL/SSL/Context/Server","kind":"class","full_name":"OpenSSL::SSL::Context::Server","name":"Server"}],"namespace":{"html_id":"Crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"},"doc":"An `SSL::Context` represents a generic secure socket protocol configuration.\n\nFor both server and client applications exist more specialized subclassses\n`SSL::Context::Server` and `SSL::Context::Client` which need to be instantiated\nappropriately.","summary":"<p>An <code><a href=\"../../OpenSSL/SSL/Context.html\">SSL::Context</a></code> represents a generic secure socket protocol configuration.</p>","instance_methods":[{"html_id":"add_modes(mode:OpenSSL::SSL::Modes)-instance-method","name":"add_modes","doc":"Adds modes to the TLS context.","summary":"<p>Adds modes to the TLS context.</p>","abstract":false,"args":[{"name":"mode","external_name":"mode","restriction":"OpenSSL::SSL::Modes"}],"args_string":"(mode : OpenSSL::SSL::Modes)","args_html":"(mode : <a href=\"../../OpenSSL/SSL/Modes.html\">OpenSSL::SSL::Modes</a>)","location":{"filename":"src/openssl/ssl/context.cr","line_number":352,"url":null},"def":{"name":"add_modes","args":[{"name":"mode","external_name":"mode","restriction":"OpenSSL::SSL::Modes"}],"visibility":"Public","body":"OpenSSL::SSL::Modes.new(LibSSL.ssl_ctx_ctrl(@handle, LibSSL::SSL_CTRL_MODE, mode, nil))"}},{"html_id":"add_options(options:OpenSSL::SSL::Options)-instance-method","name":"add_options","doc":"Adds options to the TLS context.\n\nExample:\n```\ncontext.add_options(\n  OpenSSL::SSL::Options::ALL |       # various workarounds\n  OpenSSL::SSL::Options::NO_SSL_V2 | # disable overly deprecated SSLv2\n  OpenSSL::SSL::Options::NO_SSL_V3   # disable deprecated SSLv3\n)\n```","summary":"<p>Adds options to the TLS context.</p>","abstract":false,"args":[{"name":"options","external_name":"options","restriction":"OpenSSL::SSL::Options"}],"args_string":"(options : OpenSSL::SSL::Options)","args_html":"(options : <a href=\"../../OpenSSL/SSL/Options.html\">OpenSSL::SSL::Options</a>)","location":{"filename":"src/openssl/ssl/context.cr","line_number":381,"url":null},"def":{"name":"add_options","args":[{"name":"options","external_name":"options","restriction":"OpenSSL::SSL::Options"}],"visibility":"Public","body":"opts = {% if LibSSL.has_method?(:ssl_ctx_set_options) %}\n             LibSSL.ssl_ctx_set_options(@handle, options)\n           {% else %}\n             LibSSL.ssl_ctx_ctrl(@handle, LibSSL::SSL_CTRL_OPTIONS, options, nil)\n           {% end %}\nOpenSSL::SSL::Options.new(opts)\n"}},{"html_id":"add_x509_verify_flags(flags:OpenSSL::SSL::X509VerifyFlags)-instance-method","name":"add_x509_verify_flags","doc":"Sets the given `OpenSSL::SSL::X509VerifyFlags` in this context, additionally to\nthe already set ones.","summary":"<p>Sets the given <code><a href=\"../../OpenSSL/SSL/X509VerifyFlags.html\">OpenSSL::SSL::X509VerifyFlags</a></code> in this context, additionally to the already set ones.</p>","abstract":false,"args":[{"name":"flags","external_name":"flags","restriction":"OpenSSL::SSL::X509VerifyFlags"}],"args_string":"(flags : OpenSSL::SSL::X509VerifyFlags)","args_html":"(flags : <a href=\"../../OpenSSL/SSL/X509VerifyFlags.html\">OpenSSL::SSL::X509VerifyFlags</a>)","location":{"filename":"src/openssl/ssl/context.cr","line_number":467,"url":null},"def":{"name":"add_x509_verify_flags","args":[{"name":"flags","external_name":"flags","restriction":"OpenSSL::SSL::X509VerifyFlags"}],"visibility":"Public","body":"{% if LibSSL.has_method?(:x509_verify_param_set_flags) %}\n      param = LibSSL.ssl_ctx_get0_param(@handle)\n      ret = LibCrypto.x509_verify_param_set_flags(param, flags)\n      raise OpenSSL::Error.new(\"X509_VERIFY_PARAM_set_flags)\") unless ret == 1\n    {% else %}\n      raise NotImplementedError.new(\"LibSSL.x509_verify_param_set_flags\")\n    {% end %}"}},{"html_id":"alpn_protocol=(protocol:String)-instance-method","name":"alpn_protocol=","doc":"Specifies an ALPN protocol to negotiate with the remote endpoint. This is\nrequired to negotiate HTTP/2 with browsers, since browser vendors decided\nnot to implement HTTP/2 over insecure connections.\n\nExample:\n```\ncontext.alpn_protocol = \"h2\"\n```","summary":"<p>Specifies an ALPN protocol to negotiate with the remote endpoint.</p>","abstract":false,"args":[{"name":"protocol","external_name":"protocol","restriction":"String"}],"args_string":"(protocol : String)","args_html":"(protocol : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/openssl/ssl/context.cr","line_number":425,"url":null},"def":{"name":"alpn_protocol=","args":[{"name":"protocol","external_name":"protocol","restriction":"String"}],"visibility":"Public","body":"proto = Bytes.new(protocol.bytesize + 1)\nproto[0] = protocol.bytesize.to_u8\nprotocol.to_slice.copy_to(proto.to_unsafe + 1, protocol.bytesize)\nself.alpn_protocol = proto\n"}},{"html_id":"ca_certificates=(file_path:String)-instance-method","name":"ca_certificates=","doc":"Sets the path to a file containing all CA certificates, in PEM format, used to\nvalidate the peers certificate.","summary":"<p>Sets the path to a file containing all CA certificates, in PEM format, used to validate the peers certificate.</p>","abstract":false,"args":[{"name":"file_path","external_name":"file_path","restriction":"String"}],"args_string":"(file_path : String)","args_html":"(file_path : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/openssl/ssl/context.cr","line_number":230,"url":null},"def":{"name":"ca_certificates=","args":[{"name":"file_path","external_name":"file_path","restriction":"String"}],"visibility":"Public","body":"ret = LibSSL.ssl_ctx_load_verify_locations(@handle, file_path, nil)\nif ret == 1\nelse\n  raise(OpenSSL::Error.new(\"SSL_CTX_load_verify_locations\"))\nend\n"}},{"html_id":"ca_certificates_path=(dir_path:String)-instance-method","name":"ca_certificates_path=","doc":"Sets the path to a directory containing all CA certificates used to\nvalidate the peers certificate. The certificates should be in PEM format\nand the `c_rehash(1)` utility must have been run in the directory.","summary":"<p>Sets the path to a directory containing all CA certificates used to validate the peers certificate.</p>","abstract":false,"args":[{"name":"dir_path","external_name":"dir_path","restriction":"String"}],"args_string":"(dir_path : String)","args_html":"(dir_path : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/openssl/ssl/context.cr","line_number":238,"url":null},"def":{"name":"ca_certificates_path=","args":[{"name":"dir_path","external_name":"dir_path","restriction":"String"}],"visibility":"Public","body":"ret = LibSSL.ssl_ctx_load_verify_locations(@handle, nil, dir_path)\nif ret == 1\nelse\n  raise(OpenSSL::Error.new(\"SSL_CTX_load_verify_locations\"))\nend\n"}},{"html_id":"certificate_chain=(file_path:String)-instance-method","name":"certificate_chain=","doc":"Specify the path to the certificate chain file to use. In server mode this\nis presented to the client, in client mode this used as client certificate.","summary":"<p>Specify the path to the certificate chain file to use.</p>","abstract":false,"args":[{"name":"file_path","external_name":"file_path","restriction":"String"}],"args_string":"(file_path : String)","args_html":"(file_path : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/openssl/ssl/context.cr","line_number":245,"url":null},"def":{"name":"certificate_chain=","args":[{"name":"file_path","external_name":"file_path","restriction":"String"}],"visibility":"Public","body":"ret = LibSSL.ssl_ctx_use_certificate_chain_file(@handle, file_path)\nif ret == 1\nelse\n  raise(OpenSSL::Error.new(\"SSL_CTX_use_certificate_chain_file\"))\nend\n"}},{"html_id":"cipher_suites=(cipher_suites:String)-instance-method","name":"cipher_suites=","doc":"Specify a list of TLS cipher suites to use or discard.\n\nSee `#security_level=` for some sensible system configuration.","summary":"<p>Specify a list of TLS cipher suites to use or discard.</p>","abstract":false,"args":[{"name":"cipher_suites","external_name":"cipher_suites","restriction":"String"}],"args_string":"(cipher_suites : String)","args_html":"(cipher_suites : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/openssl/ssl/context.cr","line_number":270,"url":null},"def":{"name":"cipher_suites=","args":[{"name":"cipher_suites","external_name":"cipher_suites","restriction":"String"}],"visibility":"Public","body":"{% if LibSSL.has_method?(:ssl_ctx_set_ciphersuites) %}\n      ret = LibSSL.ssl_ctx_set_ciphersuites(@handle, cipher_suites)\n      raise OpenSSL::Error.new(\"SSL_CTX_set_ciphersuites\") if ret == 0\n    {% else %}\n      Log.warn { \"SSL_CTX_set_ciphersuites not supported\" }\n    {% end %}\ncipher_suites\n"}},{"html_id":"ciphers=(ciphers:String)-instance-method","name":"ciphers=","doc":"Specify a list of TLS ciphers to use or discard.\n\nThis affects only TLSv1.2 and below. See `#security_level=` for some\nsensible system configuration.","summary":"<p>Specify a list of TLS ciphers to use or discard.</p>","abstract":false,"args":[{"name":"ciphers","external_name":"ciphers","restriction":"String"}],"args_string":"(ciphers : String)","args_html":"(ciphers : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/openssl/ssl/context.cr","line_number":261,"url":null},"def":{"name":"ciphers=","args":[{"name":"ciphers","external_name":"ciphers","restriction":"String"}],"visibility":"Public","body":"ret = LibSSL.ssl_ctx_set_cipher_list(@handle, ciphers)\nif ret == 0\n  raise(OpenSSL::Error.new(\"SSL_CTX_set_cipher_list\"))\nend\nciphers\n"}},{"html_id":"default_verify_param=(name:String)-instance-method","name":"default_verify_param=","doc":"Sets this context verify param to the default one of the given name.\n\nDepending on the OpenSSL version, the available defaults are\n`default`, `pkcs7`, `smime_sign`, `ssl_client` and `ssl_server`.","summary":"<p>Sets this context verify param to the default one of the given name.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String)","args_html":"(name : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/openssl/ssl/context.cr","line_number":454,"url":null},"def":{"name":"default_verify_param=","args":[{"name":"name","external_name":"name","restriction":"String"}],"visibility":"Public","body":"{% if LibSSL.has_method?(:x509_verify_param_lookup) %}\n      param = LibCrypto.x509_verify_param_lookup(name)\n      raise ArgumentError.new(\"#{name} is an unsupported default verify param\") unless param\n      ret = LibSSL.ssl_ctx_set1_param(@handle, param)\n      raise OpenSSL::Error.new(\"SSL_CTX_set1_param\") unless ret == 1\n    {% else %}\n      raise NotImplementedError.new(\"LibSSL.x509_verify_param_lookup\")\n    {% end %}"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/openssl/ssl/context.cr","line_number":219,"url":null},"def":{"name":"finalize","visibility":"Public","body":"LibSSL.ssl_ctx_free(@handle)"}},{"html_id":"modes:LibSSL::Modes-instance-method","name":"modes","doc":"Returns the current modes set on the TLS context.","summary":"<p>Returns the current modes set on the TLS context.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/context.cr","line_number":347,"url":null},"def":{"name":"modes","return_type":"LibSSL::Modes","visibility":"Public","body":"OpenSSL::SSL::Modes.new(LibSSL.ssl_ctx_ctrl(@handle, LibSSL::SSL_CTRL_MODE, 0, nil))"}},{"html_id":"options:LibSSL::Options-instance-method","name":"options","doc":"Returns the current options set on the TLS context.","summary":"<p>Returns the current options set on the TLS context.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/context.cr","line_number":362,"url":null},"def":{"name":"options","return_type":"LibSSL::Options","visibility":"Public","body":"opts = {% if LibSSL.has_method?(:ssl_ctx_get_options) %}\n             LibSSL.ssl_ctx_get_options(@handle)\n           {% else %}\n             LibSSL.ssl_ctx_ctrl(@handle, LibSSL::SSL_CTRL_OPTIONS, 0, nil)\n           {% end %}\nOpenSSL::SSL::Options.new(opts)\n"}},{"html_id":"private_key=(file_path:String)-instance-method","name":"private_key=","doc":"Specify the path to the private key to use. The key must in PEM format.\nThe key must correspond to the entity certificate set by `certificate_chain=`.","summary":"<p>Specify the path to the private key to use.</p>","abstract":false,"args":[{"name":"file_path","external_name":"file_path","restriction":"String"}],"args_string":"(file_path : String)","args_html":"(file_path : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/openssl/ssl/context.cr","line_number":252,"url":null},"def":{"name":"private_key=","args":[{"name":"file_path","external_name":"file_path","restriction":"String"}],"visibility":"Public","body":"ret = LibSSL.ssl_ctx_use_privatekey_file(@handle, file_path, LibSSL::SSLFileType::PEM)\nif ret == 1\nelse\n  raise(OpenSSL::Error.new(\"SSL_CTX_use_PrivateKey_file\"))\nend\n"}},{"html_id":"remove_modes(mode:OpenSSL::SSL::Modes)-instance-method","name":"remove_modes","doc":"Removes modes from the TLS context.","summary":"<p>Removes modes from the TLS context.</p>","abstract":false,"args":[{"name":"mode","external_name":"mode","restriction":"OpenSSL::SSL::Modes"}],"args_string":"(mode : OpenSSL::SSL::Modes)","args_html":"(mode : <a href=\"../../OpenSSL/SSL/Modes.html\">OpenSSL::SSL::Modes</a>)","location":{"filename":"src/openssl/ssl/context.cr","line_number":357,"url":null},"def":{"name":"remove_modes","args":[{"name":"mode","external_name":"mode","restriction":"OpenSSL::SSL::Modes"}],"visibility":"Public","body":"OpenSSL::SSL::Modes.new(LibSSL.ssl_ctx_ctrl(@handle, LibSSL::SSL_CTRL_CLEAR_MODE, mode, nil))"}},{"html_id":"remove_options(options:OpenSSL::SSL::Options)-instance-method","name":"remove_options","doc":"Removes options from the TLS context.\n\nExample:\n```\ncontext.remove_options(OpenSSL::SSL::Options::NO_SSL_V3)\n```","summary":"<p>Removes options from the TLS context.</p>","abstract":false,"args":[{"name":"options","external_name":"options","restriction":"OpenSSL::SSL::Options"}],"args_string":"(options : OpenSSL::SSL::Options)","args_html":"(options : <a href=\"../../OpenSSL/SSL/Options.html\">OpenSSL::SSL::Options</a>)","location":{"filename":"src/openssl/ssl/context.cr","line_number":396,"url":null},"def":{"name":"remove_options","args":[{"name":"options","external_name":"options","restriction":"OpenSSL::SSL::Options"}],"visibility":"Public","body":"opts = {% if LibSSL.has_method?(:ssl_ctx_clear_options) %}\n             LibSSL.ssl_ctx_clear_options(@handle, options)\n           {% else %}\n             LibSSL.ssl_ctx_ctrl(@handle, LibSSL::SSL_CTRL_CLEAR_OPTIONS, options, nil)\n           {% end %}\nOpenSSL::SSL::Options.new(opts)\n"}},{"html_id":"security_level:Int32-instance-method","name":"security_level","doc":"Returns the security level used by this TLS context.","summary":"<p>Returns the security level used by this TLS context.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/context.cr","line_number":314,"url":null},"def":{"name":"security_level","return_type":"Int32","visibility":"Public","body":"{% if LibSSL.has_method?(:ssl_ctx_get_security_level) %}\n      LibSSL.ssl_ctx_get_security_level(@handle)\n    {% else %}\n      Log.warn { \"SSL_CTX_get_security_level not supported\" }\n      0\n    {% end %}"}},{"html_id":"security_level=(value:Int32)-instance-method","name":"security_level=","doc":"Sets the security level used by this TLS context. The default system\nsecurity level might disable some ciphers.\n\n* https://www.openssl.org/docs/man1.1.1/man3/SSL_CTX_set_security_level.html\n* https://wiki.debian.org/ContinuousIntegration/TriagingTips/openssl-1.1.1","summary":"<p>Sets the security level used by this TLS context.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Int32"}],"args_string":"(value : Int32)","args_html":"(value : <a href=\"../../Int32.html\">Int32</a>)","location":{"filename":"src/openssl/ssl/context.cr","line_number":328,"url":null},"def":{"name":"security_level=","args":[{"name":"value","external_name":"value","restriction":"Int32"}],"visibility":"Public","body":"{% if LibSSL.has_method?(:ssl_ctx_set_security_level) %}\n      LibSSL.ssl_ctx_set_security_level(@handle, value)\n    {% else %}\n      Log.warn { \"SSL_CTX_set_security_level not supported\" }\n    {% end %}\nvalue\n"}},{"html_id":"set_default_verify_paths-instance-method","name":"set_default_verify_paths","doc":"Sets the default paths for `ca_certificates=` and `ca_certificates_path=`.","summary":"<p>Sets the default paths for <code><a href=\"../../OpenSSL/SSL/Context.html#ca_certificates%3D%28file_path%3AString%29-instance-method\">#ca_certificates=</a></code> and <code><a href=\"../../OpenSSL/SSL/Context.html#ca_certificates_path%3D%28dir_path%3AString%29-instance-method\">#ca_certificates_path=</a></code>.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/context.cr","line_number":224,"url":null},"def":{"name":"set_default_verify_paths","visibility":"Public","body":"LibSSL.ssl_ctx_set_default_verify_paths(@handle)"}},{"html_id":"set_intermediate_ciphers-instance-method","name":"set_intermediate_ciphers","doc":"Sets the current ciphers and ciphers suites to **intermediate** compatibility level as per Mozilla\nrecommendations. See `CIPHERS_INTERMEDIATE` and `CIPHER_SUITES_INTERMEDIATE`. See `#security_level=` for some\nsensible system configuration.","summary":"<p>Sets the current ciphers and ciphers suites to <strong>intermediate</strong> compatibility level as per Mozilla recommendations.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/context.cr","line_number":294,"url":null},"def":{"name":"set_intermediate_ciphers","visibility":"Public","body":"{% if LibSSL.has_method?(:ssl_ctx_set_ciphersuites) %}\n      self.cipher_suites = CIPHER_SUITES_INTERMEDIATE\n    {% else %}\n      self.ciphers = CIPHERS_INTERMEDIATE\n    {% end %}"}},{"html_id":"set_modern_ciphers-instance-method","name":"set_modern_ciphers","doc":"Sets the current ciphers and ciphers suites to **modern** compatibility level as per Mozilla\nrecommendations. See `CIPHERS_MODERN` and `CIPHER_SUITES_MODERN`. See `#security_level=` for some\nsensible system configuration.","summary":"<p>Sets the current ciphers and ciphers suites to <strong>modern</strong> compatibility level as per Mozilla recommendations.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/context.cr","line_number":283,"url":null},"def":{"name":"set_modern_ciphers","visibility":"Public","body":"{% if LibSSL.has_method?(:ssl_ctx_set_ciphersuites) %}\n      self.cipher_suites = CIPHER_SUITES_MODERN\n    {% else %}\n      self.ciphers = CIPHERS_MODERN\n    {% end %}"}},{"html_id":"set_old_ciphers-instance-method","name":"set_old_ciphers","doc":"Sets the current ciphers and ciphers suites to **old** compatibility level as per Mozilla\nrecommendations. See `CIPHERS_OLD` and `CIPHER_SUITES_OLD`. See `#security_level=` for some\nsensible system configuration.","summary":"<p>Sets the current ciphers and ciphers suites to <strong>old</strong> compatibility level as per Mozilla recommendations.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/context.cr","line_number":305,"url":null},"def":{"name":"set_old_ciphers","visibility":"Public","body":"{% if LibSSL.has_method?(:ssl_ctx_set_ciphersuites) %}\n      self.cipher_suites = CIPHER_SUITES_OLD\n    {% else %}\n      self.ciphers = CIPHERS_OLD\n    {% end %}"}},{"html_id":"set_tmp_ecdh_key(curve=LibCrypto::NID_X9_62_prime256v1):Nil-instance-method","name":"set_tmp_ecdh_key","doc":"Adds a temporary ECDH key curve to the TLS context. This is required to\nenable the EECDH cipher suites. By default the prime256 curve will be used.","summary":"<p>Adds a temporary ECDH key curve to the TLS context.</p>","abstract":false,"args":[{"name":"curve","default_value":"LibCrypto::NID_X9_62_prime256v1","external_name":"curve","restriction":""}],"args_string":"(curve = LibCrypto::NID_X9_62_prime256v1) : Nil","args_html":"(curve = <span class=\"t\">LibCrypto</span><span class=\"t\">::</span><span class=\"t\">NID_X9_62_prime256v1</span>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/openssl/ssl/context.cr","line_number":339,"url":null},"def":{"name":"set_tmp_ecdh_key","args":[{"name":"curve","default_value":"LibCrypto::NID_X9_62_prime256v1","external_name":"curve","restriction":""}],"return_type":"Nil","visibility":"Public","body":"key = LibCrypto.ec_key_new_by_curve_name(curve)\nif key.null?\n  raise(OpenSSL::Error.new(\"ec_key_new_by_curve_name\"))\nend\nLibSSL.ssl_ctx_ctrl(@handle, LibSSL::SSL_CTRL_SET_TMP_ECDH, 0, key)\nLibCrypto.ec_key_free(key)\n"}},{"html_id":"to_unsafe:LibSSL::SSLContext-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/openssl/ssl/context.cr","line_number":477,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@handle"}},{"html_id":"verify_mode:LibSSL::VerifyMode-instance-method","name":"verify_mode","doc":"Returns the current verify mode. See the `SSL_CTX_set_verify(3)` manpage for more details.","summary":"<p>Returns the current verify mode.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/context.cr","line_number":406,"url":null},"def":{"name":"verify_mode","return_type":"LibSSL::VerifyMode","visibility":"Public","body":"LibSSL.ssl_ctx_get_verify_mode(@handle)"}},{"html_id":"verify_mode=(mode:OpenSSL::SSL::VerifyMode)-instance-method","name":"verify_mode=","doc":"Sets the verify mode. See the `SSL_CTX_set_verify(3)` manpage for more details.","summary":"<p>Sets the verify mode.</p>","abstract":false,"args":[{"name":"mode","external_name":"mode","restriction":"OpenSSL::SSL::VerifyMode"}],"args_string":"(mode : OpenSSL::SSL::VerifyMode)","args_html":"(mode : <a href=\"../../OpenSSL/SSL/VerifyMode.html\">OpenSSL::SSL::VerifyMode</a>)","location":{"filename":"src/openssl/ssl/context.cr","line_number":411,"url":null},"def":{"name":"verify_mode=","args":[{"name":"mode","external_name":"mode","restriction":"OpenSSL::SSL::VerifyMode"}],"visibility":"Public","body":"LibSSL.ssl_ctx_set_verify(@handle, mode, nil)"}}],"types":[{"html_id":"Crystal/OpenSSL/SSL/Context/Client","path":"OpenSSL/SSL/Context/Client.html","kind":"class","full_name":"OpenSSL::SSL::Context::Client","name":"Client","abstract":false,"superclass":{"html_id":"Crystal/OpenSSL/SSL/Context","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context"},"ancestors":[{"html_id":"Crystal/OpenSSL/SSL/Context","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/ssl/context.cr","line_number":19,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OpenSSL/SSL/Context","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context"},"constructors":[{"html_id":"from_hash(params):self-class-method","name":"from_hash","doc":"Configures a client context from a hash-like interface.\n\n```\nrequire \"openssl\"\n\ncontext = OpenSSL::SSL::Context::Client.from_hash({\"key\" => \"private.key\", \"cert\" => \"certificate.crt\", \"ca\" => \"ca.pem\"})\n```\n\nParams:\n\n* `key` *(required)*: Path to private key file. See `#private_key=`.\n* `cert` *(required)*: Path to the file containing the public certificate chain. See `#certificate_chain=`.\n* `verify_mode`: Either `peer`, `force-peer`, `none` or empty (default: `peer`). See `verify_mode=`.\n* `ca`: Path to a file containing the CA certificate chain or a directory containing all CA certificates.\n   See `#ca_certificates=` and `#ca_certificates_path=`, respectively.\n   Required if `verify_mode` is `peer`, `force-peer` or empty.","summary":"<p>Configures a client context from a hash-like interface.</p>","abstract":false,"args":[{"name":"params","external_name":"params","restriction":""}],"args_string":"(params) : self","args_html":"(params) : <span class=\"k\">self</span>","location":{"filename":"src/openssl/ssl/context.cr","line_number":77,"url":null},"def":{"name":"from_hash","args":[{"name":"params","external_name":"params","restriction":""}],"return_type":"self","visibility":"Public","body":"super(params)"}},{"html_id":"insecure(method:LibSSL::SSLMethod=Context.default_method):self-class-method","name":"insecure","doc":"Returns a new TLS client context with only the given method set.\n\nFor everything else this uses the defaults of your OpenSSL.\nUse this only if undoing the defaults that `new` sets is too much hassle.","summary":"<p>Returns a new TLS client context with only the given method set.</p>","abstract":false,"args":[{"name":"method","default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"args_string":"(method : LibSSL::SSLMethod = Context.default_method) : self","args_html":"(method : LibSSL::SSLMethod = <span class=\"t\">Context</span>.default_method) : <span class=\"k\">self</span>","location":{"filename":"src/openssl/ssl/context.cr","line_number":57,"url":null},"def":{"name":"insecure","args":[{"name":"method","default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"return_type":"self","visibility":"Public","body":"super(method)"}},{"html_id":"new(method:LibSSL::SSLMethod=Context.default_method)-class-method","name":"new","doc":"Generates a new TLS client context with sane defaults for a client connection.\n\nDefaults to `TLS_method` or `SSLv23_method` (depending on OpenSSL version)\nwhich tells OpenSSL to negotiate the TLS or SSL protocol with the remote\nendpoint.\n\nDon't change the method unless you must restrict a specific protocol to be\nused (eg: TLSv1.2) and nothing else. You should specify options to disable\nspecific protocols, yet allow to negotiate from various other ones. For\nexample the following snippet will enable the TLSv1, TLSv1.1 and TLSv1.2\nprotocols but disable the deprecated SSLv2 and SSLv3 protocols:\n\n```\nrequire \"openssl\"\n\ncontext = OpenSSL::SSL::Context::Client.new\ncontext.add_options(OpenSSL::SSL::Options::NO_SSL_V2 | OpenSSL::SSL::Options::NO_SSL_V3)\n```\n\nIt uses `CIPHERS_OLD` compatibility level by default.","summary":"<p>Generates a new TLS client context with sane defaults for a client connection.</p>","abstract":false,"args":[{"name":"method","default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"args_string":"(method : LibSSL::SSLMethod = Context.default_method)","args_html":"(method : LibSSL::SSLMethod = <span class=\"t\">Context</span>.default_method)","location":{"filename":"src/openssl/ssl/context.cr","line_number":42,"url":null},"def":{"name":"new","args":[{"name":"method","default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"visibility":"Public","body":"_ = allocate\n_.initialize(method)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]},{"html_id":"Crystal/OpenSSL/SSL/Context/Server","path":"OpenSSL/SSL/Context/Server.html","kind":"class","full_name":"OpenSSL::SSL::Context::Server","name":"Server","abstract":false,"superclass":{"html_id":"Crystal/OpenSSL/SSL/Context","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context"},"ancestors":[{"html_id":"Crystal/OpenSSL/SSL/Context","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/ssl/context.cr","line_number":103,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OpenSSL/SSL/Context","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context"},"constructors":[{"html_id":"from_hash(params):self-class-method","name":"from_hash","doc":"Configures a server from a hash-like interface.\n\n```\nrequire \"openssl\"\n\ncontext = OpenSSL::SSL::Context::Client.from_hash({\"key\" => \"private.key\", \"cert\" => \"certificate.crt\", \"ca\" => \"ca.pem\"})\n```\n\nParams:\n\n* `key` *(required)*: Path to private key file. See `#private_key=`.\n* `cert` *(required)*: Path to the file containing the public certificate chain. See `#certificate_chain=`.\n* `verify_mode`: Either `peer`, `force-peer`, `none` or empty (default: `none`). See `verify_mode=`.\n* `ca`: Path to a file containing the CA certificate chain or a directory containing all CA certificates.\n   See `#ca_certificates=` and `#ca_certificates_path=`, respectively.\n   Required if `verify_mode` is `peer` or `force-peer`.","summary":"<p>Configures a server from a hash-like interface.</p>","abstract":false,"args":[{"name":"params","external_name":"params","restriction":""}],"args_string":"(params) : self","args_html":"(params) : <span class=\"k\">self</span>","location":{"filename":"src/openssl/ssl/context.cr","line_number":159,"url":null},"def":{"name":"from_hash","args":[{"name":"params","external_name":"params","restriction":""}],"return_type":"self","visibility":"Public","body":"super(params)"}},{"html_id":"insecure(method:LibSSL::SSLMethod=Context.default_method):self-class-method","name":"insecure","doc":"Returns a new TLS server context with only the given method set.\n\nFor everything else this uses the defaults of your OpenSSL.\nUse this only if undoing the defaults that `new` sets is too much hassle.","summary":"<p>Returns a new TLS server context with only the given method set.</p>","abstract":false,"args":[{"name":"method","default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"args_string":"(method : LibSSL::SSLMethod = Context.default_method) : self","args_html":"(method : LibSSL::SSLMethod = <span class=\"t\">Context</span>.default_method) : <span class=\"k\">self</span>","location":{"filename":"src/openssl/ssl/context.cr","line_number":139,"url":null},"def":{"name":"insecure","args":[{"name":"method","default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"return_type":"self","visibility":"Public","body":"super(method)"}},{"html_id":"new(method:LibSSL::SSLMethod=Context.default_method)-class-method","name":"new","doc":"Generates a new TLS server context with sane defaults for a server connection.\n\nDefaults to `TLS_method` or `SSLv23_method` (depending on OpenSSL version)\nwhich tells OpenSSL to negotiate the TLS or SSL protocol with the remote\nendpoint.\n\nDon't change the method unless you must restrict a specific protocol to be\nused (eg: TLSv1.2) and nothing else. You should specify options to disable\nspecific protocols, yet allow to negotiate from various other ones. For\nexample the following snippet will enable the TLSv1, TLSv1.1 and TLSv1.2\nprotocols but disable the deprecated SSLv2 and SSLv3 protocols:\n\n```\ncontext = OpenSSL::SSL::Context::Server.new\ncontext.add_options(OpenSSL::SSL::Options::NO_SSL_V2 | OpenSSL::SSL::Options::NO_SSL_V3)\n```\n\nIt uses `CIPHERS_INTERMEDIATE` compatibility level by default.","summary":"<p>Generates a new TLS server context with sane defaults for a server connection.</p>","abstract":false,"args":[{"name":"method","default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"args_string":"(method : LibSSL::SSLMethod = Context.default_method)","args_html":"(method : LibSSL::SSLMethod = <span class=\"t\">Context</span>.default_method)","location":{"filename":"src/openssl/ssl/context.cr","line_number":122,"url":null},"def":{"name":"new","args":[{"name":"method","default_value":"Context.default_method","external_name":"method","restriction":"LibSSL::SSLMethod"}],"visibility":"Public","body":"_ = allocate\n_.initialize(method)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"disable_session_resume_tickets:Nil-instance-method","name":"disable_session_resume_tickets","doc":"Disables all session ticket generation for this context.\nTickets are used to resume earlier sessions more quickly,\nbut in TLS 1.3 if the client connects, sends data, and closes the connection\nunidirectionally, the server connects, then sends a ticket\nafter the connect handshake, the ticket send can fail with Broken Pipe.\nSo if you have that kind of behavior (clients that never read) call this method.","summary":"<p>Disables all session ticket generation for this context.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/context.cr","line_number":169,"url":null},"def":{"name":"disable_session_resume_tickets","return_type":"Nil","visibility":"Public","body":"add_options(OpenSSL::SSL::Options::NO_TICKET)\n{% if LibSSL.has_method?(:ssl_ctx_set_num_tickets) %}\n        ret = LibSSL.ssl_ctx_set_num_tickets(self, 0) # TLS v1.3\n        raise OpenSSL::Error.new(\"SSL_CTX_set_num_tickets\") if ret != 1\n      {% end %}\n"}}]}]},{"html_id":"Crystal/OpenSSL/SSL/Error","path":"OpenSSL/SSL/Error.html","kind":"class","full_name":"OpenSSL::SSL::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/OpenSSL/Error","kind":"class","full_name":"OpenSSL::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/OpenSSL/Error","kind":"class","full_name":"OpenSSL::Error","name":"Error"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl.cr","line_number":77,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"},"constructors":[{"html_id":"new(ssl:LibSSL::SSL,return_code:LibSSL::Int,func=nil)-class-method","name":"new","abstract":false,"args":[{"name":"ssl","external_name":"ssl","restriction":"LibSSL::SSL"},{"name":"return_code","external_name":"return_code","restriction":"LibSSL::Int"},{"name":"func","default_value":"nil","external_name":"func","restriction":""}],"args_string":"(ssl : LibSSL::SSL, return_code : LibSSL::Int, func = nil)","args_html":"(ssl : LibSSL::SSL, return_code : LibSSL::Int, func = <span class=\"n\">nil</span>)","location":{"filename":"src/openssl.cr","line_number":81,"url":null},"def":{"name":"new","args":[{"name":"ssl","external_name":"ssl","restriction":"LibSSL::SSL"},{"name":"return_code","external_name":"return_code","restriction":"LibSSL::Int"},{"name":"func","default_value":"nil","external_name":"func","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(ssl, return_code, func)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"error:ErrorType-instance-method","name":"error","abstract":false,"location":{"filename":"src/openssl.cr","line_number":78,"url":null},"def":{"name":"error","return_type":"ErrorType","visibility":"Public","body":"@error"}},{"html_id":"underlying_eof?:Bool-instance-method","name":"underlying_eof?","abstract":false,"location":{"filename":"src/openssl.cr","line_number":79,"url":null},"def":{"name":"underlying_eof?","return_type":"Bool","visibility":"Public","body":"@underlying_eof"}}]},{"html_id":"Crystal/OpenSSL/SSL/ErrorType","path":"OpenSSL/SSL/ErrorType.html","kind":"alias","full_name":"OpenSSL::SSL::ErrorType","name":"ErrorType","abstract":false,"locations":[{"filename":"src/openssl.cr","line_number":72,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"LibSSL::SSLError","aliased_html":"LibSSL::SSLError","const":false,"constants":[{"id":"NONE","name":"NONE","value":"0"},{"id":"SSL","name":"SSL","value":"1"},{"id":"SYSCALL","name":"SYSCALL","value":"5"},{"id":"WANT_ACCEPT","name":"WANT_ACCEPT","value":"8"},{"id":"WANT_CONNECT","name":"WANT_CONNECT","value":"7"},{"id":"WANT_READ","name":"WANT_READ","value":"2"},{"id":"WANT_WRITE","name":"WANT_WRITE","value":"3"},{"id":"WANT_X509_LOOKUP","name":"WANT_X509_LOOKUP","value":"4"},{"id":"ZERO_RETURN","name":"ZERO_RETURN","value":"6"}],"namespace":{"html_id":"Crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"}},{"html_id":"Crystal/OpenSSL/SSL/Modes","path":"OpenSSL/SSL/Modes.html","kind":"alias","full_name":"OpenSSL::SSL::Modes","name":"Modes","abstract":false,"locations":[{"filename":"src/openssl.cr","line_number":69,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"LibSSL::Modes","aliased_html":"LibSSL::Modes","const":false,"constants":[{"id":"ACCEPT_MOVING_WRITE_BUFFER","name":"ACCEPT_MOVING_WRITE_BUFFER","value":"2_u64"},{"id":"AUTO_RETRY","name":"AUTO_RETRY","value":"4_u64"},{"id":"ENABLE_PARTIAL_WRITE","name":"ENABLE_PARTIAL_WRITE","value":"1_u64"},{"id":"NO_AUTO_CHAIN","name":"NO_AUTO_CHAIN","value":"8_u64"},{"id":"RELEASE_BUFFERS","name":"RELEASE_BUFFERS","value":"16_u64"},{"id":"SEND_CLIENTHELLO_TIME","name":"SEND_CLIENTHELLO_TIME","value":"32_u64"},{"id":"SEND_FALLBACK_SCSV","name":"SEND_FALLBACK_SCSV","value":"128_u64"},{"id":"SEND_SERVERHELLO_TIME","name":"SEND_SERVERHELLO_TIME","value":"64_u64"}],"namespace":{"html_id":"Crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"}},{"html_id":"Crystal/OpenSSL/SSL/Options","path":"OpenSSL/SSL/Options.html","kind":"alias","full_name":"OpenSSL::SSL::Options","name":"Options","abstract":false,"locations":[{"filename":"src/openssl.cr","line_number":70,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"LibSSL::Options","aliased_html":"LibSSL::Options","const":false,"constants":[{"id":"ALL","name":"ALL","value":"2147486719_u64","doc":"Various bug workarounds that should be rather harmless.\nThis used to be `0x000FFFFF` before 0.9.7","summary":"<p>Various bug workarounds that should be rather harmless.</p>"},{"id":"ALLOW_UNSAFE_LEGACY_RENEGOTIATION","name":"ALLOW_UNSAFE_LEGACY_RENEGOTIATION","value":"262144_u64"},{"id":"CIPHER_SERVER_PREFERENCE","name":"CIPHER_SERVER_PREFERENCE","value":"4194304_u64"},{"id":"CISCO_ANYCONNECT","name":"CISCO_ANYCONNECT","value":"32768_u64"},{"id":"COOKIE_EXCHANGE","name":"COOKIE_EXCHANGE","value":"8192_u64"},{"id":"CRYPTOPRO_TLSEXT_BUG","name":"CRYPTOPRO_TLSEXT_BUG","value":"2147483648_u64"},{"id":"DONT_INSERT_EMPTY_FRAGMENTS","name":"DONT_INSERT_EMPTY_FRAGMENTS","value":"2048_u64"},{"id":"LEGACY_SERVER_CONNECT","name":"LEGACY_SERVER_CONNECT","value":"4_u64"},{"id":"MICROSOFT_BIG_SSL_V3_BUFFER","name":"MICROSOFT_BIG_SSL_V3_BUFFER","value":"0_u64"},{"id":"MICROSOFT_SESS_ID_BUG","name":"MICROSOFT_SESS_ID_BUG","value":"0_u64"},{"id":"NETSCAPE_CA_DN_BUG","name":"NETSCAPE_CA_DN_BUG","value":"536870912_u64"},{"id":"NETSCAPE_CHALLENGE_BUG","name":"NETSCAPE_CHALLENGE_BUG","value":"0_u64"},{"id":"NETSCAPE_DEMO_CIPHER_CHANGE_BUG","name":"NETSCAPE_DEMO_CIPHER_CHANGE_BUG","value":"1073741824_u64"},{"id":"NETSCAPE_REUSE_CIPHER_CHANGE_BUG","name":"NETSCAPE_REUSE_CIPHER_CHANGE_BUG","value":"0_u64"},{"id":"NO_COMPRESSION","name":"NO_COMPRESSION","value":"131072_u64"},{"id":"NO_QUERY_MTU","name":"NO_QUERY_MTU","value":"4096_u64"},{"id":"NO_RENEGOTIATION","name":"NO_RENEGOTIATION","value":"1073741824_u64"},{"id":"NO_SESSION_RESUMPTION_ON_RENEGOTIATION","name":"NO_SESSION_RESUMPTION_ON_RENEGOTIATION","value":"65536_u64"},{"id":"NO_SSL_V2","name":"NO_SSL_V2","value":"0_u64"},{"id":"NO_SSL_V3","name":"NO_SSL_V3","value":"33554432_u64"},{"id":"NO_TICKET","name":"NO_TICKET","value":"16384_u64"},{"id":"NO_TLS_V1","name":"NO_TLS_V1","value":"67108864_u64"},{"id":"NO_TLS_V1_1","name":"NO_TLS_V1_1","value":"268435456_u64"},{"id":"NO_TLS_V1_2","name":"NO_TLS_V1_2","value":"134217728_u64"},{"id":"NO_TLS_V1_3","name":"NO_TLS_V1_3","value":"536870912_u64"},{"id":"SAFARI_ECDHE_ECDSA_BUG","name":"SAFARI_ECDHE_ECDSA_BUG","value":"64_u64"},{"id":"SINGLE_DH_USE","name":"SINGLE_DH_USE","value":"0_u64"},{"id":"SINGLE_ECDH_USE","name":"SINGLE_ECDH_USE","value":"0_u64"},{"id":"SSLEAY_080_CLIENT_DH_BUG","name":"SSLEAY_080_CLIENT_DH_BUG","value":"0_u64"},{"id":"SSLREF2_REUSE_CERT_TYPE_BUG","name":"SSLREF2_REUSE_CERT_TYPE_BUG","value":"0_u64"},{"id":"TLS_BLOCK_PADDING_BUG","name":"TLS_BLOCK_PADDING_BUG","value":"0_u64"},{"id":"TLS_D5_BUG","name":"TLS_D5_BUG","value":"0_u64"},{"id":"TLS_ROLLBACK_BUG","name":"TLS_ROLLBACK_BUG","value":"8388608_u64"}],"namespace":{"html_id":"Crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"}},{"html_id":"Crystal/OpenSSL/SSL/Server","path":"OpenSSL/SSL/Server.html","kind":"class","full_name":"OpenSSL::SSL::Server","name":"Server","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Socket/Server","kind":"module","full_name":"Socket::Server","name":"Server"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/ssl/server.cr","line_number":22,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Socket/Server","kind":"module","full_name":"Socket::Server","name":"Server"}],"namespace":{"html_id":"Crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"},"doc":"This class wraps another `::Socket::Server` in an SSL layer.\n\n```\nrequire \"socket\"\nrequire \"openssl\"\n\ntcp_server = TCPServer.new(0)\n\nssl_context = OpenSSL::SSL::Context::Server.new\nssl_context.certificate_chain = \"openssl.crt\"\nssl_context.private_key = \"openssl.key\"\nssl_server = OpenSSL::SSL::Server.new(tcp_server, ssl_context)\n\nputs \"SSL Server listening on #{tcp_server.local_address}\"\nwhile connection = ssl_server.accept?\n  connection.puts \"secure message\"\n  connection.close\nend\n```","summary":"<p>This class wraps another <code><a href=\"../../Socket/Server.html\">::Socket::Server</a></code> in an SSL layer.</p>","class_methods":[{"html_id":"open(wrapped:::Socket::Server,context:OpenSSL::SSL::Context::Server=OpenSSL::SSL::Context::Server.new,sync_close:Bool=true,&)-class-method","name":"open","doc":"Creates a new SSL server wrapping *wrapped*  and yields it to the block.\n\n*context* configures the SSL options, see `OpenSSL::SSL::Context::Server` for details\n\nThe server is closed after the block returns.","summary":"<p>Creates a new SSL server wrapping <em>wrapped</em>  and yields it to the block.</p>","abstract":false,"args":[{"name":"wrapped","external_name":"wrapped","restriction":"::Socket::Server"},{"name":"context","default_value":"OpenSSL::SSL::Context::Server.new","external_name":"context","restriction":"OpenSSL::SSL::Context::Server"},{"name":"sync_close","default_value":"true","external_name":"sync_close","restriction":"Bool"}],"args_string":"(wrapped : ::Socket::Server, context : OpenSSL::SSL::Context::Server = OpenSSL::SSL::Context::Server.new, sync_close : Bool = true, &)","args_html":"(wrapped : <a href=\"../../Socket/Server.html\">::Socket::Server</a>, context : <a href=\"../../OpenSSL/SSL/Context/Server.html\">OpenSSL::SSL::Context::Server</a> = <span class=\"t\">OpenSSL</span><span class=\"t\">::</span><span class=\"t\">SSL</span><span class=\"t\">::</span><span class=\"t\">Context</span><span class=\"t\">::</span><span class=\"t\">Server</span>.<span class=\"k\">new</span>, sync_close : <a href=\"../../Bool.html\">Bool</a> = <span class=\"n\">true</span>, &)","location":{"filename":"src/openssl/ssl/server.cr","line_number":52,"url":null},"def":{"name":"open","args":[{"name":"wrapped","external_name":"wrapped","restriction":"::Socket::Server"},{"name":"context","default_value":"OpenSSL::SSL::Context::Server.new","external_name":"context","restriction":"OpenSSL::SSL::Context::Server"},{"name":"sync_close","default_value":"true","external_name":"sync_close","restriction":"Bool"}],"yields":1,"visibility":"Public","body":"server = new(wrapped, context, sync_close)\nbegin\n  yield server\nensure\n  server.close\nend\n"}}],"constructors":[{"html_id":"new(wrapped:::Socket::Server,context:OpenSSL::SSL::Context::Server=OpenSSL::SSL::Context::Server.new,sync_close:Bool=true)-class-method","name":"new","doc":"Creates a new SSL server wrapping *wrapped*.\n\n*context* configures the SSL options, see `OpenSSL::SSL::Context::Server` for details","summary":"<p>Creates a new SSL server wrapping <em>wrapped</em>.</p>","abstract":false,"args":[{"name":"wrapped","external_name":"wrapped","restriction":"::Socket::Server"},{"name":"context","default_value":"OpenSSL::SSL::Context::Server.new","external_name":"context","restriction":"OpenSSL::SSL::Context::Server"},{"name":"sync_close","default_value":"true","external_name":"sync_close","restriction":"Bool"}],"args_string":"(wrapped : ::Socket::Server, context : OpenSSL::SSL::Context::Server = OpenSSL::SSL::Context::Server.new, sync_close : Bool = true)","args_html":"(wrapped : <a href=\"../../Socket/Server.html\">::Socket::Server</a>, context : <a href=\"../../OpenSSL/SSL/Context/Server.html\">OpenSSL::SSL::Context::Server</a> = <span class=\"t\">OpenSSL</span><span class=\"t\">::</span><span class=\"t\">SSL</span><span class=\"t\">::</span><span class=\"t\">Context</span><span class=\"t\">::</span><span class=\"t\">Server</span>.<span class=\"k\">new</span>, sync_close : <a href=\"../../Bool.html\">Bool</a> = <span class=\"n\">true</span>)","location":{"filename":"src/openssl/ssl/server.cr","line_number":44,"url":null},"def":{"name":"new","args":[{"name":"wrapped","external_name":"wrapped","restriction":"::Socket::Server"},{"name":"context","default_value":"OpenSSL::SSL::Context::Server.new","external_name":"context","restriction":"OpenSSL::SSL::Context::Server"},{"name":"sync_close","default_value":"true","external_name":"sync_close","restriction":"Bool"}],"visibility":"Public","body":"_ = allocate\n_.initialize(wrapped, context, sync_close)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"accept:OpenSSL::SSL::Socket::Server-instance-method","name":"accept","doc":"Implements `::Socket::Server#accept`.\n\nThis method calls `@wrapped.accept` and wraps the resulting IO in a SSL socket (`OpenSSL::SSL::Socket::Server`) with `context` configuration.","summary":"<p>Implements <code><a href=\"../../Socket/Server.html#accept%3AIO-instance-method\">::Socket::Server#accept</a></code>.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/server.cr","line_number":65,"url":null},"def":{"name":"accept","return_type":"OpenSSL::SSL::Socket::Server","visibility":"Public","body":"new_ssl_socket(@wrapped.accept)"}},{"html_id":"accept?:OpenSSL::SSL::Socket::Server?-instance-method","name":"accept?","doc":"Implements `::Socket::Server#accept?`.\n\nThis method calls `@wrapped.accept?` and wraps the resulting IO in a SSL socket (`OpenSSL::SSL::Socket::Server`) with `context` configuration.","summary":"<p>Implements <code><a href=\"../../Socket/Server.html#accept%3F%3AIO%3F-instance-method\">::Socket::Server#accept?</a></code>.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/server.cr","line_number":72,"url":null},"def":{"name":"accept?","return_type":"OpenSSL::SSL::Socket::Server | ::Nil","visibility":"Public","body":"if socket = @wrapped.accept?\n  new_ssl_socket(socket)\nend"}},{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes this SSL server.\n\nPropagates to `wrapped` if `sync_close` is `true`.","summary":"<p>Closes this SSL server.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/server.cr","line_number":85,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nif @sync_close\n  @wrapped.close\nend\n"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this SSL server has been closed.","summary":"<p>Returns <code>true</code> if this SSL server has been closed.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/server.cr","line_number":36,"url":null},"def":{"name":"closed?","return_type":"Bool","visibility":"Public","body":"@closed"}},{"html_id":"context:OpenSSL::SSL::Context::Server-instance-method","name":"context","doc":"Returns the SSL context.","summary":"<p>Returns the SSL context.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/server.cr","line_number":29,"url":null},"def":{"name":"context","return_type":"OpenSSL::SSL::Context::Server","visibility":"Public","body":"@context"}},{"html_id":"local_address:::Socket::Address-instance-method","name":"local_address","doc":"Returns local address of `wrapped`.","summary":"<p>Returns local address of <code><a href=\"../../OpenSSL/SSL/Server.html#wrapped%3A%3A%3ASocket%3A%3AServer-instance-method\">#wrapped</a></code>.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/server.cr","line_number":93,"url":null},"def":{"name":"local_address","return_type":"::Socket::Address","visibility":"Public","body":"@wrapped.local_address"}},{"html_id":"start_immediately:Bool-instance-method","name":"start_immediately","doc":"When `true` a call to `#accept` will also initiate the SSL handshake.","summary":"<p>When <code>true</code> a call to <code><a href=\"../../OpenSSL/SSL/Server.html#accept%3AOpenSSL%3A%3ASSL%3A%3ASocket%3A%3AServer-instance-method\">#accept</a></code> will also initiate the SSL handshake.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/server.cr","line_number":39,"url":null},"def":{"name":"start_immediately","return_type":"Bool","visibility":"Public","body":"@start_immediately"}},{"html_id":"start_immediately=(start_immediately:Bool)-instance-method","name":"start_immediately=","doc":"When `true` a call to `#accept` will also initiate the SSL handshake.","summary":"<p>When <code>true</code> a call to <code><a href=\"../../OpenSSL/SSL/Server.html#accept%3AOpenSSL%3A%3ASSL%3A%3ASocket%3A%3AServer-instance-method\">#accept</a></code> will also initiate the SSL handshake.</p>","abstract":false,"args":[{"name":"start_immediately","external_name":"start_immediately","restriction":"Bool"}],"args_string":"(start_immediately : Bool)","args_html":"(start_immediately : <a href=\"../../Bool.html\">Bool</a>)","location":{"filename":"src/openssl/ssl/server.cr","line_number":39,"url":null},"def":{"name":"start_immediately=","args":[{"name":"start_immediately","external_name":"start_immediately","restriction":"Bool"}],"visibility":"Public","body":"@start_immediately = start_immediately"}},{"html_id":"sync_close=(sync_close:Bool)-instance-method","name":"sync_close=","doc":"If `#sync_close?` is `true`, closing this server will\nclose the wrapped server.","summary":"<p>If <code><a href=\"../../OpenSSL/SSL/Server.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this server will close the wrapped server.</p>","abstract":false,"args":[{"name":"sync_close","external_name":"sync_close","restriction":"Bool"}],"args_string":"(sync_close : Bool)","args_html":"(sync_close : <a href=\"../../Bool.html\">Bool</a>)","location":{"filename":"src/openssl/ssl/server.cr","line_number":33,"url":null},"def":{"name":"sync_close=","args":[{"name":"sync_close","external_name":"sync_close","restriction":"Bool"}],"visibility":"Public","body":"@sync_close = sync_close"}},{"html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"If `#sync_close?` is `true`, closing this server will\nclose the wrapped server.","summary":"<p>If <code><a href=\"../../OpenSSL/SSL/Server.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this server will close the wrapped server.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/server.cr","line_number":33,"url":null},"def":{"name":"sync_close?","return_type":"Bool","visibility":"Public","body":"@sync_close"}},{"html_id":"wrapped:::Socket::Server-instance-method","name":"wrapped","doc":"Returns the wrapped server socket.","summary":"<p>Returns the wrapped server socket.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/server.cr","line_number":26,"url":null},"def":{"name":"wrapped","return_type":"::Socket::Server","visibility":"Public","body":"@wrapped"}}]},{"html_id":"Crystal/OpenSSL/SSL/Socket","path":"OpenSSL/SSL/Socket.html","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket","abstract":true,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/ssl/socket.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"}],"subclasses":[{"html_id":"Crystal/OpenSSL/SSL/Socket/Client","kind":"class","full_name":"OpenSSL::SSL::Socket::Client","name":"Client"},{"html_id":"Crystal/OpenSSL/SSL/Socket/Server","kind":"class","full_name":"OpenSSL::SSL::Socket::Server","name":"Server"}],"namespace":{"html_id":"Crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"},"instance_methods":[{"html_id":"alpn_protocol-instance-method","name":"alpn_protocol","doc":"Returns the negotiated ALPN protocol (eg: `\"h2\"`) of `nil` if no protocol was\nnegotiated.","summary":"<p>Returns the negotiated ALPN protocol (eg: <code>\"h2\"</code>) of <code>nil</code> if no protocol was negotiated.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":160,"url":null},"def":{"name":"alpn_protocol","visibility":"Public","body":"{% if LibSSL.has_method?(:ssl_get0_alpn_selected) %}\n      LibSSL.ssl_get0_alpn_selected(@ssl, out protocol, out len)\n      String.new(protocol, len) unless protocol.null?\n    {% else %}\n      raise NotImplementedError.new(\"LibSSL.ssl_get0_alpn_selected\")\n    {% end %}"}},{"html_id":"cipher:String-instance-method","name":"cipher","doc":"Returns the current cipher used by this socket.","summary":"<p>Returns the current cipher used by this socket.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":213,"url":null},"def":{"name":"cipher","return_type":"String","visibility":"Public","body":"String.new(LibSSL.ssl_cipher_get_name(LibSSL.ssl_get_current_cipher(@ssl)))"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this `IO` is closed.\n\n`IO` defines returns `false`, but including types may override.","summary":"<p>Returns <code>true</code> if this <code><a href=\"../../IO.html\">IO</a></code> is closed.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":98,"url":null},"def":{"name":"closed?","return_type":"Bool","visibility":"Public","body":"@closed"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":119,"url":null},"def":{"name":"finalize","visibility":"Public","body":"LibSSL.ssl_free(@ssl)"}},{"html_id":"hostname:String?-instance-method","name":"hostname","doc":"Returns the hostname provided through Server Name Indication (SNI)","summary":"<p>Returns the hostname provided through Server Name Indication (SNI)</p>","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":206,"url":null},"def":{"name":"hostname","return_type":"String | ::Nil","visibility":"Public","body":"if host_name = LibSSL.ssl_get_servername(@ssl, LibSSL::TLSExt::NAMETYPE_host_name)\n  String.new(host_name)\nend"}},{"html_id":"local_address-instance-method","name":"local_address","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":222,"url":null},"def":{"name":"local_address","visibility":"Public","body":"io = @bio.io\nio.responds_to?(:local_address) ? io.local_address : nil\n"}},{"html_id":"peer_certificate:OpenSSL::X509::Certificate?-instance-method","name":"peer_certificate","doc":"Returns the `OpenSSL::X509::Certificate` the peer presented, if a\nconnection was esablished.\n\nNOTE: Due to the protocol definition, a TLS/SSL server will always send a\ncertificate, if present. A client will only send a certificate when\nexplicitly requested to do so by the server (see `SSL_CTX_set_verify(3)`). If\nan anonymous cipher is used, no certificates are sent. That a certificate\nis returned does not indicate information about the verification state.","summary":"<p>Returns the <code>OpenSSL::X509::Certificate</code> the peer presented, if a connection was esablished.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":276,"url":null},"def":{"name":"peer_certificate","return_type":"OpenSSL::X509::Certificate | ::Nil","visibility":"Public","body":"cert = LibSSL.ssl_get_peer_certificate(@ssl)\nif cert\n  OpenSSL::X509::Certificate.new(cert)\nend\n"}},{"html_id":"read_timeout-instance-method","name":"read_timeout","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":232,"url":null},"def":{"name":"read_timeout","visibility":"Public","body":"io = @bio.io\nif io.responds_to?(:read_timeout)\n  io.read_timeout\nelse\n  raise(NotImplementedError.new(\"#{io.class}#read_timeout\"))\nend\n"}},{"html_id":"read_timeout=(value)-instance-method","name":"read_timeout=","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/openssl/ssl/socket.cr","line_number":241,"url":null},"def":{"name":"read_timeout=","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"io = @bio.io\nif io.responds_to?(:\"read_timeout=\")\n  io.read_timeout = value\nelse\n  raise(NotImplementedError.new(\"#{io.class}#read_timeout=\"))\nend\n"}},{"html_id":"remote_address-instance-method","name":"remote_address","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":227,"url":null},"def":{"name":"remote_address","visibility":"Public","body":"io = @bio.io\nio.responds_to?(:remote_address) ? io.remote_address : nil\n"}},{"html_id":"sync_close=(sync_close:Bool)-instance-method","name":"sync_close=","doc":"If `#sync_close?` is `true`, closing this socket will\nclose the underlying IO.","summary":"<p>If <code><a href=\"../../OpenSSL/SSL/Socket.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this socket will close the underlying IO.</p>","abstract":false,"args":[{"name":"sync_close","external_name":"sync_close","restriction":"Bool"}],"args_string":"(sync_close : Bool)","args_html":"(sync_close : <a href=\"../../Bool.html\">Bool</a>)","location":{"filename":"src/openssl/ssl/socket.cr","line_number":96,"url":null},"def":{"name":"sync_close=","args":[{"name":"sync_close","external_name":"sync_close","restriction":"Bool"}],"visibility":"Public","body":"@sync_close = sync_close"}},{"html_id":"sync_close?:Bool-instance-method","name":"sync_close?","doc":"If `#sync_close?` is `true`, closing this socket will\nclose the underlying IO.","summary":"<p>If <code><a href=\"../../OpenSSL/SSL/Socket.html#sync_close%3F%3ABool-instance-method\">#sync_close?</a></code> is <code>true</code>, closing this socket will close the underlying IO.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":96,"url":null},"def":{"name":"sync_close?","return_type":"Bool","visibility":"Public","body":"@sync_close"}},{"html_id":"tls_version:String-instance-method","name":"tls_version","doc":"Returns the name of the TLS protocol version used by this socket.","summary":"<p>Returns the name of the TLS protocol version used by this socket.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":218,"url":null},"def":{"name":"tls_version","return_type":"String","visibility":"Public","body":"String.new(LibSSL.ssl_get_version(@ssl))"}},{"html_id":"unbuffered_close:Nil-instance-method","name":"unbuffered_close","doc":"Closes the wrapped `IO`.","summary":"<p>Closes the wrapped <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":169,"url":null},"def":{"name":"unbuffered_close","return_type":"Nil","visibility":"Public","body":"if @closed\n  return\nend\n@closed = true\nbegin\n  loop do\n    begin\n      ret = LibSSL.ssl_shutdown(@ssl)\n      if ret == 1\n        break\n      end\n      if (ret == 0) && sync_close?\n        break\n      end\n      if ret < 0\n        raise(OpenSSL::SSL::Error.new(@ssl, ret, \"SSL_shutdown\"))\n      end\n    rescue e : OpenSSL::SSL::Error\n      case e.error\n      when .want_read?, .want_write?\n      when .syscall?\n        break\n      else\n        raise(e)\n      end\n    end\n  end\nrescue IO::Error\nensure\n  if @sync_close\n    @bio.io.close\n  end\nend\n"}},{"html_id":"unbuffered_flush:Nil-instance-method","name":"unbuffered_flush","doc":"Flushes the wrapped `IO`.","summary":"<p>Flushes the wrapped <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":154,"url":null},"def":{"name":"unbuffered_flush","return_type":"Nil","visibility":"Public","body":"@bio.io.flush"}},{"html_id":"unbuffered_read(slice:Bytes):Int32-instance-method","name":"unbuffered_read","doc":"Reads at most *slice.size* bytes from the wrapped `IO` into *slice*.\nReturns the number of bytes read.","summary":"<p>Reads at most <em>slice.size</em> bytes from the wrapped <code><a href=\"../../IO.html\">IO</a></code> into <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Int32","args_html":"(slice : <a href=\"../../Bytes.html\">Bytes</a>) : <a href=\"../../Int32.html\">Int32</a>","location":{"filename":"src/openssl/ssl/socket.cr","line_number":123,"url":null},"def":{"name":"unbuffered_read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Int32","visibility":"Public","body":"check_open\ncount = slice.size\nif count == 0\n  return 0\nend\n(LibSSL.ssl_read(@ssl, slice.to_unsafe, count)).tap do |bytes|\n  if bytes <= 0 && (!(LibSSL.ssl_get_error(@ssl, bytes)).zero_return?)\n    ex = OpenSSL::SSL::Error.new(@ssl, bytes, \"SSL_read\")\n    if ex.underlying_eof?\n      return 0\n    end\n    raise(ex)\n  end\nend\n"}},{"html_id":"unbuffered_rewind-instance-method","name":"unbuffered_rewind","doc":"Rewinds the wrapped `IO`.","summary":"<p>Rewinds the wrapped <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":201,"url":null},"def":{"name":"unbuffered_rewind","visibility":"Public","body":"raise(IO::Error.new(\"Can't rewind OpenSSL::SSL::Socket::Client\"))"}},{"html_id":"unbuffered_write(slice:Bytes):Nil-instance-method","name":"unbuffered_write","doc":"Writes at most *slice.size* bytes from *slice* into the wrapped `IO`.\nReturns the number of bytes written.","summary":"<p>Writes at most <em>slice.size</em> bytes from <em>slice</em> into the wrapped <code><a href=\"../../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"../../Bytes.html\">Bytes</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/openssl/ssl/socket.cr","line_number":142,"url":null},"def":{"name":"unbuffered_write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"check_open\nif slice.empty?\n  return\nend\ncount = slice.size\nbytes = LibSSL.ssl_write(@ssl, slice.to_unsafe, count)\nif bytes > 0\nelse\n  raise(OpenSSL::SSL::Error.new(@ssl, bytes, \"SSL_write\"))\nend\n"}},{"html_id":"write_timeout-instance-method","name":"write_timeout","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":250,"url":null},"def":{"name":"write_timeout","visibility":"Public","body":"io = @bio.io\nif io.responds_to?(:write_timeout)\n  io.write_timeout\nelse\n  raise(NotImplementedError.new(\"#{io.class}#write_timeout\"))\nend\n"}},{"html_id":"write_timeout=(value)-instance-method","name":"write_timeout=","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/openssl/ssl/socket.cr","line_number":259,"url":null},"def":{"name":"write_timeout=","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"io = @bio.io\nif io.responds_to?(:\"write_timeout=\")\n  io.write_timeout = value\nelse\n  raise(NotImplementedError.new(\"#{io.class}#write_timeout=\"))\nend\n"}}],"types":[{"html_id":"Crystal/OpenSSL/SSL/Socket/Client","path":"OpenSSL/SSL/Socket/Client.html","kind":"class","full_name":"OpenSSL::SSL::Socket::Client","name":"Client","abstract":false,"superclass":{"html_id":"Crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},"ancestors":[{"html_id":"Crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/ssl/socket.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},"class_methods":[{"html_id":"open(io,context:Context::Client=Context::Client.new,sync_close:Bool=false,hostname:String?=nil,&)-class-method","name":"open","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"context","default_value":"Context::Client.new","external_name":"context","restriction":"Context::Client"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"hostname","default_value":"nil","external_name":"hostname","restriction":"String | ::Nil"}],"args_string":"(io, context : Context::Client = Context::Client.new, sync_close : Bool = false, hostname : String? = nil, &)","args_html":"(io, context : <a href=\"../../../OpenSSL/SSL/Context/Client.html\">Context::Client</a> = <span class=\"t\">Context</span><span class=\"t\">::</span><span class=\"t\">Client</span>.<span class=\"k\">new</span>, sync_close : <a href=\"../../../Bool.html\">Bool</a> = <span class=\"n\">false</span>, hostname : <a href=\"../../../String.html\">String</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/openssl/ssl/socket.cr","line_number":42,"url":null},"def":{"name":"open","args":[{"name":"io","external_name":"io","restriction":""},{"name":"context","default_value":"Context::Client.new","external_name":"context","restriction":"Context::Client"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"hostname","default_value":"nil","external_name":"hostname","restriction":"String | ::Nil"}],"yields":1,"visibility":"Public","body":"socket = new(io, context, sync_close, hostname)\nbegin\n  yield socket\nensure\n  socket.close\nend\n"}}],"constructors":[{"html_id":"new(io,context:Context::Client=Context::Client.new,sync_close:Bool=false,hostname:String?=nil)-class-method","name":"new","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"context","default_value":"Context::Client.new","external_name":"context","restriction":"Context::Client"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"hostname","default_value":"nil","external_name":"hostname","restriction":"String | ::Nil"}],"args_string":"(io, context : Context::Client = Context::Client.new, sync_close : Bool = false, hostname : String? = nil)","args_html":"(io, context : <a href=\"../../../OpenSSL/SSL/Context/Client.html\">Context::Client</a> = <span class=\"t\">Context</span><span class=\"t\">::</span><span class=\"t\">Client</span>.<span class=\"k\">new</span>, sync_close : <a href=\"../../../Bool.html\">Bool</a> = <span class=\"n\">false</span>, hostname : <a href=\"../../../String.html\">String</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/openssl/ssl/socket.cr","line_number":3,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":""},{"name":"context","default_value":"Context::Client.new","external_name":"context","restriction":"Context::Client"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"hostname","default_value":"nil","external_name":"hostname","restriction":"String | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, context, sync_close, hostname)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"peer_certificate:OpenSSL::X509::Certificate-instance-method","name":"peer_certificate","doc":"Returns the `OpenSSL::X509::Certificate` the peer presented.","summary":"<p>Returns the <code>OpenSSL::X509::Certificate</code> the peer presented.</p>","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":53,"url":null},"def":{"name":"peer_certificate","return_type":"OpenSSL::X509::Certificate","visibility":"Public","body":"super().not_nil!"}}]},{"html_id":"Crystal/OpenSSL/SSL/Socket/Server","path":"OpenSSL/SSL/Socket/Server.html","kind":"class","full_name":"OpenSSL::SSL::Socket::Server","name":"Server","abstract":false,"superclass":{"html_id":"Crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},"ancestors":[{"html_id":"Crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/openssl/ssl/socket.cr","line_number":58,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OpenSSL/SSL/Socket","kind":"class","full_name":"OpenSSL::SSL::Socket","name":"Socket"},"class_methods":[{"html_id":"open(io,context:Context::Server=Context::Server.new,sync_close:Bool=false,&)-class-method","name":"open","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"context","default_value":"Context::Server.new","external_name":"context","restriction":"Context::Server"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"}],"args_string":"(io, context : Context::Server = Context::Server.new, sync_close : Bool = false, &)","args_html":"(io, context : <a href=\"../../../OpenSSL/SSL/Context/Server.html\">Context::Server</a> = <span class=\"t\">Context</span><span class=\"t\">::</span><span class=\"t\">Server</span>.<span class=\"k\">new</span>, sync_close : <a href=\"../../../Bool.html\">Bool</a> = <span class=\"n\">false</span>, &)","location":{"filename":"src/openssl/ssl/socket.cr","line_number":81,"url":null},"def":{"name":"open","args":[{"name":"io","external_name":"io","restriction":""},{"name":"context","default_value":"Context::Server.new","external_name":"context","restriction":"Context::Server"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"}],"yields":1,"visibility":"Public","body":"socket = new(io, context, sync_close)\nbegin\n  yield socket\nensure\n  socket.close\nend\n"}}],"constructors":[{"html_id":"new(io,context:Context::Server=Context::Server.new,sync_close:Bool=false,accept:Bool=true)-class-method","name":"new","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""},{"name":"context","default_value":"Context::Server.new","external_name":"context","restriction":"Context::Server"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"accept","default_value":"true","external_name":"accept","restriction":"Bool"}],"args_string":"(io, context : Context::Server = Context::Server.new, sync_close : Bool = false, accept : Bool = true)","args_html":"(io, context : <a href=\"../../../OpenSSL/SSL/Context/Server.html\">Context::Server</a> = <span class=\"t\">Context</span><span class=\"t\">::</span><span class=\"t\">Server</span>.<span class=\"k\">new</span>, sync_close : <a href=\"../../../Bool.html\">Bool</a> = <span class=\"n\">false</span>, accept : <a href=\"../../../Bool.html\">Bool</a> = <span class=\"n\">true</span>)","location":{"filename":"src/openssl/ssl/socket.cr","line_number":59,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":""},{"name":"context","default_value":"Context::Server.new","external_name":"context","restriction":"Context::Server"},{"name":"sync_close","default_value":"false","external_name":"sync_close","restriction":"Bool"},{"name":"accept","default_value":"true","external_name":"accept","restriction":"Bool"}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, context, sync_close, accept)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"accept:Nil-instance-method","name":"accept","abstract":false,"location":{"filename":"src/openssl/ssl/socket.cr","line_number":73,"url":null},"def":{"name":"accept","return_type":"Nil","visibility":"Public","body":"ret = LibSSL.ssl_accept(@ssl)\nif ret == 1\nelse\n  if @sync_close\n    @bio.io.close\n  end\n  raise(OpenSSL::SSL::Error.new(@ssl, ret, \"SSL_accept\"))\nend\n"}}]}]},{"html_id":"Crystal/OpenSSL/SSL/VerifyMode","path":"OpenSSL/SSL/VerifyMode.html","kind":"alias","full_name":"OpenSSL::SSL::VerifyMode","name":"VerifyMode","abstract":false,"locations":[{"filename":"src/openssl.cr","line_number":71,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"LibSSL::VerifyMode","aliased_html":"LibSSL::VerifyMode","const":false,"constants":[{"id":"CLIENT_ONCE","name":"CLIENT_ONCE","value":"4"},{"id":"FAIL_IF_NO_PEER_CERT","name":"FAIL_IF_NO_PEER_CERT","value":"2"},{"id":"NONE","name":"NONE","value":"0"},{"id":"PEER","name":"PEER","value":"1"}],"namespace":{"html_id":"Crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"}},{"html_id":"Crystal/OpenSSL/SSL/X509VerifyFlags","path":"OpenSSL/SSL/X509VerifyFlags.html","kind":"alias","full_name":"OpenSSL::SSL::X509VerifyFlags","name":"X509VerifyFlags","abstract":false,"locations":[{"filename":"src/openssl.cr","line_number":73,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"LibCrypto::X509VerifyFlags","aliased_html":"LibCrypto::X509VerifyFlags","const":false,"constants":[{"id":"ALLOW_PROXY_CERTS","name":"ALLOW_PROXY_CERTS","value":"64_u64"},{"id":"CB_ISSUER_CHECK","name":"CB_ISSUER_CHECK","value":"1_u64"},{"id":"CHECK_SS_SIGNATURE","name":"CHECK_SS_SIGNATURE","value":"16384_u64"},{"id":"CRL_CHECK","name":"CRL_CHECK","value":"4_u64"},{"id":"CRL_CHECK_ALL","name":"CRL_CHECK_ALL","value":"8_u64"},{"id":"EXPLICIT_POLICY","name":"EXPLICIT_POLICY","value":"256_u64"},{"id":"EXTENDED_CRL_SUPPORT","name":"EXTENDED_CRL_SUPPORT","value":"4096_u64"},{"id":"IGNORE_CRITICAL","name":"IGNORE_CRITICAL","value":"16_u64"},{"id":"INHIBIT_ANY","name":"INHIBIT_ANY","value":"512_u64"},{"id":"INHIBIT_MAP","name":"INHIBIT_MAP","value":"1024_u64"},{"id":"NO_ALT_CHAINS","name":"NO_ALT_CHAINS","value":"1048576_u64"},{"id":"NOTIFY_POLICY","name":"NOTIFY_POLICY","value":"2048_u64"},{"id":"PARTIAL_CHAIN","name":"PARTIAL_CHAIN","value":"524288_u64"},{"id":"POLICY_CHECK","name":"POLICY_CHECK","value":"128_u64"},{"id":"SUITEB_128_LOS","name":"SUITEB_128_LOS","value":"196608_u64"},{"id":"SUITEB_128_LOS_ONLY","name":"SUITEB_128_LOS_ONLY","value":"65536_u64"},{"id":"SUITEB_192_LOS","name":"SUITEB_192_LOS","value":"131072_u64"},{"id":"TRUSTED_FIRST","name":"TRUSTED_FIRST","value":"32768_u64"},{"id":"USE_CHECK_TIME","name":"USE_CHECK_TIME","value":"2_u64"},{"id":"USE_DELTAS","name":"USE_DELTAS","value":"8192_u64"},{"id":"X509_STRICT","name":"X509_STRICT","value":"32_u64"}],"namespace":{"html_id":"Crystal/OpenSSL/SSL","kind":"module","full_name":"OpenSSL::SSL","name":"SSL"}}]}]},{"html_id":"Crystal/OptionParser","path":"OptionParser.html","kind":"class","full_name":"OptionParser","name":"OptionParser","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/option_parser.cr","line_number":81,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"`OptionParser` is a class for command-line options processing. It supports:\n\n* Short and long modifier style options (example: `-h`, `--help`)\n* Passing arguments to the flags (example: `-f filename.txt`)\n* Subcommands\n* Automatic help message generation\n\nRun `crystal` for an example of a CLI built with `OptionParser`.\n\nShort example:\n\n```\nrequire \"option_parser\"\n\nupcase = false\ndestination = \"World\"\n\nOptionParser.parse do |parser|\n  parser.banner = \"Usage: salute [arguments]\"\n  parser.on(\"-u\", \"--upcase\", \"Upcases the salute\") { upcase = true }\n  parser.on(\"-t NAME\", \"--to=NAME\", \"Specifies the name to salute\") { |name| destination = name }\n  parser.on(\"-h\", \"--help\", \"Show this help\") do\n    puts parser\n    exit\n  end\n  parser.invalid_option do |flag|\n    STDERR.puts \"ERROR: #{flag} is not a valid option.\"\n    STDERR.puts parser\n    exit(1)\n  end\nend\n\ndestination = destination.upcase if upcase\nputs \"Hello #{destination}!\"\n```\n\n# Subcommands\n\n`OptionParser` also supports subcommands.\n\nShort example:\n\n```\nrequire \"option_parser\"\n\nverbose = false\nsalute = false\nwelcome = false\nname = \"World\"\nparser = OptionParser.new do |parser|\n  parser.banner = \"Usage: example [subcommand] [arguments]\"\n  parser.on(\"salute\", \"Salute a name\") do\n    salute = true\n    parser.banner = \"Usage: example salute [arguments]\"\n    parser.on(\"-t NAME\", \"--to=NAME\", \"Specify the name to salute\") { |_name| name = _name }\n  end\n  parser.on(\"welcome\", \"Print a greeting message\") do\n    welcome = true\n    parser.banner = \"Usage: example welcome\"\n  end\n  parser.on(\"-v\", \"--verbose\", \"Enabled verbose output\") { verbose = true }\n  parser.on(\"-h\", \"--help\", \"Show this help\") do\n    puts parser\n    exit\n  end\nend\n\nparser.parse\n\nif salute\n  STDERR.puts \"Saluting #{name}\" if verbose\n  puts \"Hello #{name}\"\nelsif welcome\n  STDERR.puts \"Welcoming #{name}\" if verbose\n  puts \"Welcome!\"\nelse\n  puts parser\n  exit(1)\nend\n```","summary":"<p><code><a href=\"OptionParser.html\">OptionParser</a></code> is a class for command-line options processing.</p>","constructors":[{"html_id":"new-class-method","name":"new","doc":"Creates a new parser.","summary":"<p>Creates a new parser.</p>","abstract":false,"location":{"filename":"src/option_parser.cr","line_number":119,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(&)-class-method","name":"new","doc":"Creates a new parser, with its configuration specified in the block.","summary":"<p>Creates a new parser, with its configuration specified in the block.</p>","abstract":false,"location":{"filename":"src/option_parser.cr","line_number":128,"url":null},"def":{"name":"new","yields":1,"visibility":"Public","body":"new.tap do |parser|\n  yield parser\nend"}},{"html_id":"parse(args=ARGV,&):self-class-method","name":"parse","doc":"Creates a new parser, with its configuration specified in the block,\nand uses it to parse the passed *args* (defaults to `ARGV`).","summary":"<p>Creates a new parser, with its configuration specified in the block, and uses it to parse the passed <em>args</em> (defaults to <code><a href=\"toplevel.html#ARGV\">ARGV</a></code>).</p>","abstract":false,"args":[{"name":"args","default_value":"ARGV","external_name":"args","restriction":""}],"args_string":"(args = ARGV, &) : self","args_html":"(args = <span class=\"t\">ARGV</span>, &) : <span class=\"k\">self</span>","location":{"filename":"src/option_parser.cr","line_number":111,"url":null},"def":{"name":"parse","args":[{"name":"args","default_value":"ARGV","external_name":"args","restriction":""}],"yields":1,"return_type":"self","visibility":"Public","body":"parser = OptionParser.new\nyield parser\nparser.parse(args)\nparser\n"}}],"instance_methods":[{"html_id":"banner=(banner:String?)-instance-method","name":"banner=","doc":"Establishes the initial message for the help printout.\nTypically, you want to write here the name of your program,\nand a one-line template of its invocation.\n\nExample:\n\n```\nrequire \"option_parser\"\n\nparser = OptionParser.new\nparser.banner = \"Usage: crystal [command] [switches] [program file] [--] [arguments]\"\n```","summary":"<p>Establishes the initial message for the help printout.</p>","abstract":false,"args":[{"name":"banner","external_name":"banner","restriction":"String | ::Nil"}],"args_string":"(banner : String?)","args_html":"(banner : <a href=\"String.html\">String</a>?)","location":{"filename":"src/option_parser.cr","line_number":144,"url":null},"def":{"name":"banner=","args":[{"name":"banner","external_name":"banner","restriction":"String | ::Nil"}],"visibility":"Public","body":"@banner = banner"}},{"html_id":"before_each(&before_each:String->)-instance-method","name":"before_each","doc":"Sets a handler which runs before each argument is parsed. This callback is\nnot passed flag arguments. For example, `--foo=foo_arg --bar bar_arg` would\npass `--foo=foo_arg` and `--bar` to the callback only.\n\nYou typically use this to implement advanced option parsing behaviour such\nas treating all options after a filename differently (along with `#stop`).","summary":"<p>Sets a handler which runs before each argument is parsed.</p>","abstract":false,"location":{"filename":"src/option_parser.cr","line_number":256,"url":null},"def":{"name":"before_each","yields":1,"block_arg":{"name":"before_each","external_name":"before_each","restriction":"(String ->)"},"visibility":"Public","body":"@before_each = before_each"}},{"html_id":"invalid_option(&invalid_option:String->)-instance-method","name":"invalid_option","doc":"Sets a handler for option arguments that didn't match any of the setup options.\n\nYou typically use this to display a help message.\nThe default behaviour is to raise `InvalidOption`.","summary":"<p>Sets a handler for option arguments that didn't match any of the setup options.</p>","abstract":false,"location":{"filename":"src/option_parser.cr","line_number":247,"url":null},"def":{"name":"invalid_option","yields":1,"block_arg":{"name":"invalid_option","external_name":"invalid_option","restriction":"(String ->)"},"visibility":"Public","body":"@invalid_option = invalid_option"}},{"html_id":"missing_option(&missing_option:String->)-instance-method","name":"missing_option","doc":"Sets a handler for when a option that expects an argument wasn't given any.\n\nYou typically use this to display a help message.\nThe default behaviour is to raise `MissingOption`.","summary":"<p>Sets a handler for when a option that expects an argument wasn't given any.</p>","abstract":false,"location":{"filename":"src/option_parser.cr","line_number":240,"url":null},"def":{"name":"missing_option","yields":1,"block_arg":{"name":"missing_option","external_name":"missing_option","restriction":"(String ->)"},"visibility":"Public","body":"@missing_option = missing_option"}},{"html_id":"on(short_flag:String,long_flag:String,description:String,&block:String->)-instance-method","name":"on","doc":"Establishes a handler for a pair of short and long flags.\n\nSee the other definition of `on` for examples. This method does not support\nsubcommands.","summary":"<p>Establishes a handler for a pair of short and long flags.</p>","abstract":false,"args":[{"name":"short_flag","external_name":"short_flag","restriction":"String"},{"name":"long_flag","external_name":"long_flag","restriction":"String"},{"name":"description","external_name":"description","restriction":"String"}],"args_string":"(short_flag : String, long_flag : String, description : String, &block : String -> )","args_html":"(short_flag : <a href=\"String.html\">String</a>, long_flag : <a href=\"String.html\">String</a>, description : <a href=\"String.html\">String</a>, &block : <a href=\"String.html\">String</a> -> )","location":{"filename":"src/option_parser.cr","line_number":177,"url":null},"def":{"name":"on","args":[{"name":"short_flag","external_name":"short_flag","restriction":"String"},{"name":"long_flag","external_name":"long_flag","restriction":"String"},{"name":"description","external_name":"description","restriction":"String"}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(String ->)"},"visibility":"Public","body":"check_starts_with_dash(short_flag, \"short_flag\", allow_empty: true)\ncheck_starts_with_dash(long_flag, \"long_flag\")\nappend_flag(\"#{short_flag}, #{long_flag}\", description)\nshort_flag, short_value_type = parse_flag_definition(short_flag)\nlong_flag, long_value_type = parse_flag_definition(long_flag)\nif short_value_type.required? || long_value_type.required?\n  value_type = FlagValue::Required\nelse\n  if short_value_type.optional? || long_value_type.optional?\n    value_type = FlagValue::Optional\n  else\n    value_type = FlagValue::None\n  end\nend\nhandler = Handler.new(value_type, block)\n@handlers[short_flag] = @handlers[long_flag] = handler\n"}},{"html_id":"on(flag:String,description:String,&block:String->)-instance-method","name":"on","doc":"Establishes a handler for a *flag* or subcommand.\n\nFlags must start with a dash or double dash. They can also have\nan optional argument, which will get passed to the block.\nEach flag has a description, which will be used for the help message.\n\nSubcommands are any *flag* passed which does not start with a dash. They\ncannot take arguments. When a subcommand is parsed, all subcommands are\nremoved from the OptionParser, simulating a \"tree\" of subcommands. All flags\nremain valid. For a longer example, see the examples at the top of the page.\n\nExamples of valid flags:\n\n* `-a`, `-B`\n* `--something-longer`\n* `-f FILE`, `--file FILE`, `--file=FILE` (these will yield the passed value to the block as a string)\n\nExamples of valid subcommands:\n\n* `foo`, `run`","summary":"<p>Establishes a handler for a <em>flag</em> or subcommand.</p>","abstract":false,"args":[{"name":"flag","external_name":"flag","restriction":"String"},{"name":"description","external_name":"description","restriction":"String"}],"args_string":"(flag : String, description : String, &block : String -> )","args_html":"(flag : <a href=\"String.html\">String</a>, description : <a href=\"String.html\">String</a>, &block : <a href=\"String.html\">String</a> -> )","location":{"filename":"src/option_parser.cr","line_number":166,"url":null},"def":{"name":"on","args":[{"name":"flag","external_name":"flag","restriction":"String"},{"name":"description","external_name":"description","restriction":"String"}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(String ->)"},"visibility":"Public","body":"append_flag(flag, description)\nflag, value_type = parse_flag_definition(flag)\n@handlers[flag] = Handler.new(value_type, block)\n"}},{"html_id":"parse(args=ARGV):Nil-instance-method","name":"parse","doc":"Parses the passed *args* (defaults to `ARGV`), running the handlers associated to each option.","summary":"<p>Parses the passed <em>args</em> (defaults to <code><a href=\"toplevel.html#ARGV\">ARGV</a></code>), running the handlers associated to each option.</p>","abstract":false,"args":[{"name":"args","default_value":"ARGV","external_name":"args","restriction":""}],"args_string":"(args = ARGV) : Nil","args_html":"(args = <span class=\"t\">ARGV</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/option_parser.cr","line_number":317,"url":null},"def":{"name":"parse","args":[{"name":"args","default_value":"ARGV","external_name":"args","restriction":""}],"return_type":"Nil","visibility":"Public","body":"with_preserved_state do\n  handled_args = [] of Int32\n  double_dash_index = nil\n  arg_index = 0\n  while arg_index < args.size\n    arg = args[arg_index]\n    if @stop\n      double_dash_index = arg_index - 1\n      @stop = false\n      break\n    end\n    if before_each = @before_each\n      before_each.call(arg)\n    end\n    if arg == \"--\"\n      double_dash_index = arg_index\n      handled_args << arg_index\n      break\n    end\n    if arg.starts_with?(\"--\")\n      value_index = arg.index('=')\n      if value_index\n        flag = arg[0...value_index]\n        value = arg[(value_index + 1)..-1]\n      else\n        flag = arg\n        value = nil\n      end\n    else\n      if arg.starts_with?('-')\n        if arg.size > 2\n          flag = arg[0..1]\n          value = arg[2..-1]\n        else\n          flag = arg\n          value = nil\n        end\n      else\n        flag = arg\n        value = nil\n      end\n    end\n    if (handler = @handlers[flag]?) && (!(handler.value_type.none? && value))\n      handled_args << arg_index\n      if (!value) && (!handler.value_type.none?)\n        value = args[arg_index + 1]?\n        if value\n          handled_args << (arg_index + 1)\n          arg_index = arg_index + 1\n        end\n      end\n      if handler.value_type.required? && value.nil?\n        @missing_option.call(flag)\n      end\n      if flag.starts_with?('-')\n      else\n        @handlers.select! do |k, v|\n          k.starts_with?('-')\n        end\n        @flags.select! do |flag|\n          flag.starts_with?(\"    -\")\n        end\n      end\n      handler.block.call(value || \"\")\n    end\n    arg_index = arg_index + 1\n  end\n  if double_dash_index\n    double_dash_index = double_dash_index - (handled_args.size - 1)\n  end\n  handled_args.reverse!\n  i = 0\n  args.reject! do\n    handled = i == handled_args.last?\n    if handled\n      handled_args.pop\n    end\n    i = i + 1\n    handled\n  end\n  if unknown_args = @unknown_args\n    if double_dash_index\n      before_dash = args[0...double_dash_index]\n      after_dash = args[double_dash_index..-1]\n    else\n      before_dash = args\n      after_dash = [] of String\n    end\n    unknown_args.call(before_dash, after_dash)\n  end\n  args.each_with_index do |arg, index|\n    if double_dash_index && index >= double_dash_index\n      break\n    end\n    if (arg.starts_with?('-')) && (arg != \"-\")\n      @invalid_option.call(arg)\n    end\n  end\nend"}},{"html_id":"separator(message=\"\"):Nil-instance-method","name":"separator","doc":"Adds a separator, with an optional header message, that will be used to\nprint the help. The separator is placed between the flags registered (`#on`)\nbefore, and the flags registered after the call.\n\nThis way, you can group the different options in an easier to read way.","summary":"<p>Adds a separator, with an optional header message, that will be used to print the help.</p>","abstract":false,"args":[{"name":"message","default_value":"\"\"","external_name":"message","restriction":""}],"args_string":"(message = \"\") : Nil","args_html":"(message = <span class=\"s\">&quot;&quot;</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/option_parser.cr","line_number":223,"url":null},"def":{"name":"separator","args":[{"name":"message","default_value":"\"\"","external_name":"message","restriction":""}],"return_type":"Nil","visibility":"Public","body":"@flags << message.to_s"}},{"html_id":"stop:Nil-instance-method","name":"stop","doc":"Stops the current parse and returns immediately, leaving the remaining flags\nunparsed. This is treated identically to `--` being inserted *behind* the\ncurrent parsed flag.","summary":"<p>Stops the current parse and returns immediately, leaving the remaining flags unparsed.</p>","abstract":false,"location":{"filename":"src/option_parser.cr","line_number":262,"url":null},"def":{"name":"stop","return_type":"Nil","visibility":"Public","body":"@stop = true"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Returns all the setup options, formatted in a help message.","summary":"<p>Returns all the setup options, formatted in a help message.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/option_parser.cr","line_number":267,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"if banner = @banner\n  io << banner\n  io << '\\n'\nend\n@flags.join(io, '\\n')\n"}},{"html_id":"unknown_args(&unknown_args:Array(String),Array(String)->)-instance-method","name":"unknown_args","doc":"Sets a handler for regular arguments that didn't match any of the setup options.\n\nYou typically use this to get the main arguments (not modifiers)\nthat your program expects (for example, filenames). The default behaviour\nis to do nothing. The arguments can also be extracted from the *args* array\npassed to `#parse` after parsing.","summary":"<p>Sets a handler for regular arguments that didn't match any of the setup options.</p>","abstract":false,"location":{"filename":"src/option_parser.cr","line_number":233,"url":null},"def":{"name":"unknown_args","yields":2,"block_arg":{"name":"unknown_args","external_name":"unknown_args","restriction":"(Array(String), Array(String) ->)"},"visibility":"Public","body":"@unknown_args = unknown_args"}}],"types":[{"html_id":"Crystal/OptionParser/Exception","path":"OptionParser/Exception.html","kind":"class","full_name":"OptionParser::Exception","name":"Exception","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/option_parser.cr","line_number":82,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/OptionParser/InvalidOption","kind":"class","full_name":"OptionParser::InvalidOption","name":"InvalidOption"},{"html_id":"Crystal/OptionParser/MissingOption","kind":"class","full_name":"OptionParser::MissingOption","name":"MissingOption"}],"namespace":{"html_id":"Crystal/OptionParser","kind":"class","full_name":"OptionParser","name":"OptionParser"}},{"html_id":"Crystal/OptionParser/InvalidOption","path":"OptionParser/InvalidOption.html","kind":"class","full_name":"OptionParser::InvalidOption","name":"InvalidOption","abstract":false,"superclass":{"html_id":"Crystal/OptionParser/Exception","kind":"class","full_name":"OptionParser::Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/OptionParser/Exception","kind":"class","full_name":"OptionParser::Exception","name":"Exception"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/option_parser.cr","line_number":85,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OptionParser","kind":"class","full_name":"OptionParser","name":"OptionParser"},"constructors":[{"html_id":"new(option)-class-method","name":"new","abstract":false,"args":[{"name":"option","external_name":"option","restriction":""}],"args_string":"(option)","args_html":"(option)","location":{"filename":"src/option_parser.cr","line_number":86,"url":null},"def":{"name":"new","args":[{"name":"option","external_name":"option","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(option)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]},{"html_id":"Crystal/OptionParser/MissingOption","path":"OptionParser/MissingOption.html","kind":"class","full_name":"OptionParser::MissingOption","name":"MissingOption","abstract":false,"superclass":{"html_id":"Crystal/OptionParser/Exception","kind":"class","full_name":"OptionParser::Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/OptionParser/Exception","kind":"class","full_name":"OptionParser::Exception","name":"Exception"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/option_parser.cr","line_number":91,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/OptionParser","kind":"class","full_name":"OptionParser","name":"OptionParser"},"constructors":[{"html_id":"new(option)-class-method","name":"new","abstract":false,"args":[{"name":"option","external_name":"option","restriction":""}],"args_string":"(option)","args_html":"(option)","location":{"filename":"src/option_parser.cr","line_number":92,"url":null},"def":{"name":"new","args":[{"name":"option","external_name":"option","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(option)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]}]},{"html_id":"Crystal/OverflowError","path":"OverflowError.html","kind":"class","full_name":"OverflowError","name":"OverflowError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/exception.cr","line_number":140,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"Raised when the result of an arithmetic operation is outside of the range\nthat can be represented within the given operands types.\n\n```\nInt32::MAX + 1      # raises OverflowError (Arithmetic overflow)\nInt32::MIN - 1      # raises OverflowError (Arithmetic overflow)\nFloat64::MAX.to_f32 # raises OverflowError (Arithmetic overflow)\n```","summary":"<p>Raised when the result of an arithmetic operation is outside of the range that can be represented within the given operands types.</p>","constructors":[{"html_id":"new(message=\"Arithmeticoverflow\")-class-method","name":"new","abstract":false,"args":[{"name":"message","default_value":"\"Arithmetic overflow\"","external_name":"message","restriction":""}],"args_string":"(message = \"Arithmetic overflow\")","args_html":"(message = <span class=\"s\">&quot;Arithmetic overflow&quot;</span>)","location":{"filename":"src/exception.cr","line_number":141,"url":null},"def":{"name":"new","args":[{"name":"message","default_value":"\"Arithmetic overflow\"","external_name":"message","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]},{"html_id":"Crystal/Path","path":"Path.html","kind":"struct","full_name":"Path","name":"Path","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/to_json.cr","line_number":73,"url":null},{"filename":"src/path.cr","line_number":60,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":71,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"SEPARATORS","name":"SEPARATORS","value":"separators(Kind.native)","doc":"The file/directory separator characters of the current platform.\n`{'/'}` on POSIX, `{'\\\\', '/'}` on Windows.","summary":"<p>The file/directory separator characters of the current platform.</p>"}],"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"doc":"A `Path` represents a filesystem path and allows path-handling operations\nsuch as querying its components as well as semantic manipulations.\n\nA path is hierarchical and composed of a sequence of directory and file name\nelements separated by a special separator or delimiter. A root component,\nthat identifies a file system hierarchy, may also be present.\nThe name element that is farthest from the root of the directory hierarchy is\nthe name of a file or directory. The other name elements are directory names.\nA `Path` can represent a root, a root and a sequence of names, or simply one or\nmore name elements.\nA `Path` is considered to be an empty path if it consists solely of one name\nelement that is empty or equal to `\".\"`. Accessing a file using an empty path\nis equivalent to accessing the default directory of the process.\n\n# Examples\n\n```\nPath[\"foo/bar/baz.cr\"].parent    # => Path[\"foo/bar\"]\nPath[\"foo/bar/baz.cr\"].basename  # => \"baz.cr\"\nPath[\"./foo/../bar\"].normalize   # => Path[\"bar\"]\nPath[\"~/bin\"].expand(home: true) # => Path[\"/home/crystal/bin\"]\n```\n\nFor now, its methods are purely lexical, there is no direct filesystem access.\n\nPath handling comes in different kinds depending on operating system:\n\n* `Path.posix()` creates a new POSIX path\n* `Path.windows()` creates a new Windows path\n* `Path.new()` means `Path.posix` on POSIX platforms and `Path.windows()`\n   on Windows platforms.\n\n```\n# On POSIX system:\nPath.new(\"foo\", \"bar\", \"baz.cr\") == Path.posix(\"foo/bar/baz.cr\")\n# On Windows system:\nPath.new(\"foo\", \"bar\", \"baz.cr\") == Path.windows(\"foo\\\\bar\\\\baz.cr\")\n```\n\nThe main differences between Windows and POSIX paths:\n* POSIX paths use forward slash (`/`) as only path separator, Windows paths use\n  backslash (`\\`) as default separator but also recognize forward slashes.\n* POSIX paths are generally case-sensitive, Windows paths case-insensitive\n  (see `#<=>`).\n* A POSIX path is absolute if it begins with a forward slash (`/`). A Windows path\n  is absolute if it starts with a drive letter and root (`C:\\`).\n\n```\nPath.posix(\"/foo/./bar\").normalize   # => Path.posix(\"/foo/bar\")\nPath.windows(\"/foo/./bar\").normalize # => Path.windows(\"\\\\foo\\\\bar\")\n\nPath.posix(\"/foo\").absolute?   # => true\nPath.windows(\"/foo\").absolute? # => false\n\nPath.posix(\"foo\") == Path.posix(\"FOO\")     # => false\nPath.windows(\"foo\") == Path.windows(\"FOO\") # => true\n```","summary":"<p>A <code><a href=\"Path.html\">Path</a></code> represents a filesystem path and allows path-handling operations such as querying its components as well as semantic manipulations.</p>","constructors":[{"html_id":"[](parts:Enumerable):Path-class-method","name":"[]","doc":"Creates a new `Path` of native kind.\n\nWhen compiling for a windows target, this is equal to `Path.windows()`,\notherwise `Path.posix` is used.","summary":"<p>Creates a new <code><a href=\"Path.html\">Path</a></code> of native kind.</p>","abstract":false,"args":[{"name":"parts","external_name":"parts","restriction":"Enumerable"}],"args_string":"(parts : Enumerable) : Path","args_html":"(parts : <a href=\"Enumerable.html\">Enumerable</a>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":123,"url":null},"def":{"name":"[]","args":[{"name":"parts","external_name":"parts","restriction":"Enumerable"}],"return_type":"Path","visibility":"Public","body":"new(parts)"}},{"html_id":"[](name:String|Path,*parts):Path-class-method","name":"[]","doc":"Creates a new `Path` of native kind.\n\nWhen compiling for a windows target, this is equal to `Path.windows()`,\notherwise `Path.posix` is used.","summary":"<p>Creates a new <code><a href=\"Path.html\">Path</a></code> of native kind.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String | Path"},{"name":"parts","external_name":"parts","restriction":""}],"args_string":"(name : String | Path, *parts) : Path","args_html":"(name : <a href=\"String.html\">String</a> | <a href=\"Path.html\">Path</a>, *parts) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":113,"url":null},"def":{"name":"[]","args":[{"name":"name","external_name":"name","restriction":"String | Path"},{"name":"parts","external_name":"parts","restriction":""}],"splat_index":1,"return_type":"Path","visibility":"Public","body":"new(name, *parts)"}},{"html_id":"home:Path-class-method","name":"home","doc":"Returns the path of the home directory of the current user.","summary":"<p>Returns the path of the home directory of the current user.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":1363,"url":null},"def":{"name":"home","return_type":"Path","visibility":"Public","body":"new(Crystal::System::Path.home)"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":79,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"new(String.new(ctx, node))"}},{"html_id":"new(name:String=\"\"):Path-class-method","name":"new","doc":"Creates a new `Path` of native kind.\n\nWhen compiling for a windows target, this is equal to `Path.windows()`,\notherwise `Path.posix` is used.","summary":"<p>Creates a new <code><a href=\"Path.html\">Path</a></code> of native kind.</p>","abstract":false,"args":[{"name":"name","default_value":"\"\"","external_name":"name","restriction":"String"}],"args_string":"(name : String = \"\") : Path","args_html":"(name : <a href=\"String.html\">String</a> = <span class=\"s\">&quot;&quot;</span>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":98,"url":null},"def":{"name":"new","args":[{"name":"name","default_value":"\"\"","external_name":"name","restriction":"String"}],"return_type":"Path","visibility":"Public","body":"new(name.check_no_null_byte, Kind.native)"}},{"html_id":"new(path:Path):Path-class-method","name":"new","doc":"Creates a new `Path` of native kind.\n\nWhen compiling for a windows target, this is equal to `Path.windows()`,\notherwise `Path.posix` is used.","summary":"<p>Creates a new <code><a href=\"Path.html\">Path</a></code> of native kind.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path"}],"args_string":"(path : Path) : Path","args_html":"(path : <a href=\"Path.html\">Path</a>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":103,"url":null},"def":{"name":"new","args":[{"name":"path","external_name":"path","restriction":"Path"}],"return_type":"Path","visibility":"Public","body":"path.to_native"}},{"html_id":"new(parts:Enumerable):Path-class-method","name":"new","doc":"Creates a new `Path` of native kind.\n\nWhen compiling for a windows target, this is equal to `Path.windows()`,\notherwise `Path.posix` is used.","summary":"<p>Creates a new <code><a href=\"Path.html\">Path</a></code> of native kind.</p>","abstract":false,"args":[{"name":"parts","external_name":"parts","restriction":"Enumerable"}],"args_string":"(parts : Enumerable) : Path","args_html":"(parts : <a href=\"Enumerable.html\">Enumerable</a>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":118,"url":null},"def":{"name":"new","args":[{"name":"parts","external_name":"parts","restriction":"Enumerable"}],"return_type":"Path","visibility":"Public","body":"(new(\"\")).join(parts)"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":140,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"new(pull.read_string)"}},{"html_id":"new(name:String|Path,*parts:String|Path):Path-class-method","name":"new","doc":"Creates a new `Path` of native kind.\n\nWhen compiling for a windows target, this is equal to `Path.windows()`,\notherwise `Path.posix` is used.","summary":"<p>Creates a new <code><a href=\"Path.html\">Path</a></code> of native kind.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String | Path"},{"name":"parts","external_name":"parts","restriction":"String | Path"}],"args_string":"(name : String | Path, *parts : String | Path) : Path","args_html":"(name : <a href=\"String.html\">String</a> | <a href=\"Path.html\">Path</a>, *parts : <a href=\"String.html\">String</a> | <a href=\"Path.html\">Path</a>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":108,"url":null},"def":{"name":"new","args":[{"name":"name","external_name":"name","restriction":"String | Path"},{"name":"parts","external_name":"parts","restriction":"String | Path"}],"splat_index":1,"return_type":"Path","visibility":"Public","body":"(new(name)).join(*parts)"}},{"html_id":"posix(name:String=\"\"):Path-class-method","name":"posix","doc":"Creates a new `Path` of POSIX kind.","summary":"<p>Creates a new <code><a href=\"Path.html\">Path</a></code> of POSIX kind.</p>","abstract":false,"args":[{"name":"name","default_value":"\"\"","external_name":"name","restriction":"String"}],"args_string":"(name : String = \"\") : Path","args_html":"(name : <a href=\"String.html\">String</a> = <span class=\"s\">&quot;&quot;</span>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":128,"url":null},"def":{"name":"posix","args":[{"name":"name","default_value":"\"\"","external_name":"name","restriction":"String"}],"return_type":"Path","visibility":"Public","body":"new(name.check_no_null_byte, Kind::POSIX)"}},{"html_id":"posix(path:Path):Path-class-method","name":"posix","doc":"Creates a new `Path` of POSIX kind.","summary":"<p>Creates a new <code><a href=\"Path.html\">Path</a></code> of POSIX kind.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path"}],"args_string":"(path : Path) : Path","args_html":"(path : <a href=\"Path.html\">Path</a>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":133,"url":null},"def":{"name":"posix","args":[{"name":"path","external_name":"path","restriction":"Path"}],"return_type":"Path","visibility":"Public","body":"path.to_posix"}},{"html_id":"posix(parts:Enumerable):Path-class-method","name":"posix","doc":"Creates a new `Path` of POSIX kind.","summary":"<p>Creates a new <code><a href=\"Path.html\">Path</a></code> of POSIX kind.</p>","abstract":false,"args":[{"name":"parts","external_name":"parts","restriction":"Enumerable"}],"args_string":"(parts : Enumerable) : Path","args_html":"(parts : <a href=\"Enumerable.html\">Enumerable</a>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":143,"url":null},"def":{"name":"posix","args":[{"name":"parts","external_name":"parts","restriction":"Enumerable"}],"return_type":"Path","visibility":"Public","body":"(posix(\"\")).join(parts)"}},{"html_id":"posix(name:String|Path,*parts:String|Path):Path-class-method","name":"posix","doc":"Creates a new `Path` of POSIX kind.","summary":"<p>Creates a new <code><a href=\"Path.html\">Path</a></code> of POSIX kind.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String | Path"},{"name":"parts","external_name":"parts","restriction":"String | Path"}],"args_string":"(name : String | Path, *parts : String | Path) : Path","args_html":"(name : <a href=\"String.html\">String</a> | <a href=\"Path.html\">Path</a>, *parts : <a href=\"String.html\">String</a> | <a href=\"Path.html\">Path</a>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":138,"url":null},"def":{"name":"posix","args":[{"name":"name","external_name":"name","restriction":"String | Path"},{"name":"parts","external_name":"parts","restriction":"String | Path"}],"splat_index":1,"return_type":"Path","visibility":"Public","body":"(posix(name)).join(parts)"}},{"html_id":"windows(name:String=\"\"):Path-class-method","name":"windows","doc":"Creates a new `Path` of Windows kind.","summary":"<p>Creates a new <code><a href=\"Path.html\">Path</a></code> of Windows kind.</p>","abstract":false,"args":[{"name":"name","default_value":"\"\"","external_name":"name","restriction":"String"}],"args_string":"(name : String = \"\") : Path","args_html":"(name : <a href=\"String.html\">String</a> = <span class=\"s\">&quot;&quot;</span>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":148,"url":null},"def":{"name":"windows","args":[{"name":"name","default_value":"\"\"","external_name":"name","restriction":"String"}],"return_type":"Path","visibility":"Public","body":"new(name.check_no_null_byte, Kind::WINDOWS)"}},{"html_id":"windows(path:Path):Path-class-method","name":"windows","doc":"Creates a new `Path` of Windows kind.","summary":"<p>Creates a new <code><a href=\"Path.html\">Path</a></code> of Windows kind.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"Path"}],"args_string":"(path : Path) : Path","args_html":"(path : <a href=\"Path.html\">Path</a>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":153,"url":null},"def":{"name":"windows","args":[{"name":"path","external_name":"path","restriction":"Path"}],"return_type":"Path","visibility":"Public","body":"path.to_windows"}},{"html_id":"windows(parts:Enumerable):Path-class-method","name":"windows","doc":"Creates a new `Path` of Windows kind.","summary":"<p>Creates a new <code><a href=\"Path.html\">Path</a></code> of Windows kind.</p>","abstract":false,"args":[{"name":"parts","external_name":"parts","restriction":"Enumerable"}],"args_string":"(parts : Enumerable) : Path","args_html":"(parts : <a href=\"Enumerable.html\">Enumerable</a>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":163,"url":null},"def":{"name":"windows","args":[{"name":"parts","external_name":"parts","restriction":"Enumerable"}],"return_type":"Path","visibility":"Public","body":"(windows(\"\")).join(parts)"}},{"html_id":"windows(name:String|Path,*parts:String|Path):Path-class-method","name":"windows","doc":"Creates a new `Path` of Windows kind.","summary":"<p>Creates a new <code><a href=\"Path.html\">Path</a></code> of Windows kind.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String | Path"},{"name":"parts","external_name":"parts","restriction":"String | Path"}],"args_string":"(name : String | Path, *parts : String | Path) : Path","args_html":"(name : <a href=\"String.html\">String</a> | <a href=\"Path.html\">Path</a>, *parts : <a href=\"String.html\">String</a> | <a href=\"Path.html\">Path</a>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":158,"url":null},"def":{"name":"windows","args":[{"name":"name","external_name":"name","restriction":"String | Path"},{"name":"parts","external_name":"parts","restriction":"String | Path"}],"splat_index":1,"return_type":"Path","visibility":"Public","body":"(windows(name)).join(parts)"}}],"instance_methods":[{"html_id":"/(part:Path|String):Path-instance-method","name":"/","doc":"Appends the given *part* to this path and returns the joined path.\n\n```\nPath[\"foo\"] / \"bar\" / \"baz\"     # => Path[\"foo/bar/baz\"]\nPath[\"foo/\"] / Path[\"/bar/baz\"] # => Path[\"foo/bar/baz\"]\n```\n\nSee `join(part)` for details.","summary":"<p>Appends the given <em>part</em> to this path and returns the joined path.</p>","abstract":false,"args":[{"name":"part","external_name":"part","restriction":"Path | String"}],"args_string":"(part : Path | String) : Path","args_html":"(part : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":961,"url":null},"def":{"name":"/","args":[{"name":"part","external_name":"part","restriction":"Path | String"}],"return_type":"Path","visibility":"Public","body":"join(part)"}},{"html_id":"<=>(other:Path)-instance-method","name":"<=>","doc":"Compares this path to *other*.\n\nThe comparison is performed strictly lexically: `foo` and `./foo` are *not*\ntreated as equal. Nor are paths of different `kind`.\nTo compare paths semantically, they need to be normalized and converted to\nthe same kind.\n\n```\nPath[\"foo\"] <=> Path[\"foo\"]               # => 0\nPath[\"foo\"] <=> Path[\"./foo\"]             # => 1\nPath[\"foo\"] <=> Path[\"foo/\"]              # => -1\nPath.posix(\"foo\") <=> Path.windows(\"foo\") # => -1\n```\n\nComparison is case-sensitive for POSIX paths and case-insensitive for\nWindows paths.\n\n```\nPath.posix(\"foo\") <=> Path.posix(\"FOO\")     # => 1\nPath.windows(\"foo\") <=> Path.windows(\"FOO\") # => 0\n```","summary":"<p>Compares this path to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Path"}],"args_string":"(other : Path)","args_html":"(other : <a href=\"Path.html\">Path</a>)","location":{"filename":"src/path.cr","line_number":1090,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Path"}],"visibility":"Public","body":"ord = @name.compare(other.@name, case_insensitive: windows? || other.windows?)\nif ord != 0\n  return ord\nend\n@kind <=> (other.@kind)\n"}},{"html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this path is considered equivalent to *other*.\n\nThe comparison is performed strictly lexically: `foo` and `./foo` are *not*\ntreated as equal. Nor are paths of different `kind`.\nTo compare paths semantically, they need to be normalized and converted to\nthe same kind.\n\n```\nPath[\"foo\"] == Path[\"foo\"]               # => true\nPath[\"foo\"] == Path[\"./foo\"]             # => false\nPath[\"foo\"] == Path[\"foo/\"]              # => false\nPath.posix(\"foo\") == Path.windows(\"foo\") # => false\n```\n\nComparison is case-sensitive for POSIX paths and case-insensitive for\nWindows paths.\n\n```\nPath.posix(\"foo\") == Path.posix(\"FOO\")     # => false\nPath.windows(\"foo\") == Path.windows(\"FOO\") # => true\n```","summary":"<p>Returns <code>true</code> if this path is considered equivalent to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/path.cr","line_number":1118,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"if @kind != (other.@kind)\n  return false\nend\n(@name.compare(other.@name, case_insensitive: windows? || other.windows?)) == 0\n"}},{"html_id":"absolute?:Bool-instance-method","name":"absolute?","doc":"Returns `true` if this path is absolute.\n\nA POSIX path is absolute if it begins with a forward slash (`/`).\nA Windows path is absolute if it begins with a drive letter and root (`C:\\`)\nor with a UNC share (`\\\\server\\share\\`).","summary":"<p>Returns <code>true</code> if this path is absolute.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":1272,"url":null},"def":{"name":"absolute?","return_type":"Bool","visibility":"Public","body":"separators = self.separators\nif windows?\n  first_is_separator = false\n  starts_with_double_separator = false\n  found_share_name = false\n  @name.each_char_with_index do |char, index|\n    case index\n    when 0\n      if separators.includes?(char)\n        first_is_separator = true\n      else\n        if char.ascii_letter?\n        else\n          return false\n        end\n      end\n    when 1\n      if first_is_separator && (separators.includes?(char))\n        starts_with_double_separator = true\n      else\n        if char == ':'\n        else\n          return false\n        end\n      end\n    else\n      if separators.includes?(char)\n        if index == 2\n          return (!starts_with_double_separator) && (!found_share_name)\n        else\n          if found_share_name\n            return true\n          else\n            found_share_name = true\n          end\n        end\n      end\n    end\n  end\n  false\nelse\n  separators.includes?(@name[0]?)\nend\n"}},{"html_id":"anchor:Path?-instance-method","name":"anchor","doc":"Returns the concatenation of `#drive` and `#root`.\n\n```\nPath[\"/etc/\"].anchor                           # => Path[\"/\"]\nPath.windows(\"C:Program Files\").anchor         # => Path.windows(\"C:\")\nPath.windows(\"C:\\\\Program Files\").anchor       # => Path.windows(\"C:\\\\\")\nPath.windows(\"\\\\\\\\host\\\\share\\\\folder\").anchor # => Path.windows(\"\\\\\\\\host\\\\share\\\\\")\n```","summary":"<p>Returns the concatenation of <code><a href=\"Path.html#drive%3APath%3F-instance-method\">#drive</a></code> and <code><a href=\"Path.html#root%3APath%3F-instance-method\">#root</a></code>.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":1173,"url":null},"def":{"name":"anchor","return_type":"Path | ::Nil","visibility":"Public","body":"drive, root = drive_and_root\nif root\n  if drive\n    new_instance({drive, root}.join)\n  else\n    new_instance(root)\n  end\nelse\n  if drive\n    new_instance(drive)\n  end\nend\n"}},{"html_id":"basename(suffix:String?=nil):String-instance-method","name":"basename","doc":"Returns the last component of this path.\n\nIf *suffix* is given, it is stripped from the end.\n\nIn case the last component is the empty string (i.e. the path has a trailing\nseparator), the second to last component is returned.\nFor a path that only consists of an anchor, or an empty path, the base name\nis equivalent to the full path.\n\n```\nPath[\"/foo/bar/file.cr\"].basename # => \"file.cr\"\nPath[\"/foo/bar/\"].basename        # => \"bar\"\nPath[\"/foo/bar/.\"].basename       # => \".\"\nPath[\"/\"].basename                # => \"/\"\nPath[\"\"].basename                 # => \"\"\n```","summary":"<p>Returns the last component of this path.</p>","abstract":false,"args":[{"name":"suffix","default_value":"nil","external_name":"suffix","restriction":"String | ::Nil"}],"args_string":"(suffix : String? = nil) : String","args_html":"(suffix : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/path.cr","line_number":307,"url":null},"def":{"name":"basename","args":[{"name":"suffix","default_value":"nil","external_name":"suffix","restriction":"String | ::Nil"}],"return_type":"String","visibility":"Public","body":"suffix.try(&.check_no_null_byte)\nif @name.empty?\n  return \"\"\nend\nif (@name.size == 1) && (separators.includes?(@name[0]))\n  return @name\nend\nbytes = @name.to_slice\ncurrent = bytes.size - 1\nseparators = self.separators.map(&.ord)\nwhile (separators.includes?(bytes[current])) && current > 0\n  current = current - 1\nend\nif (suffix && suffix.bytesize <= current) && (suffix == (@name.byte_slice((current - suffix.bytesize) + 1, suffix.bytesize)))\n  current = current - suffix.bytesize\nend\nif current == 0\n  return @name.byte_slice(0, 1)\nend\nend_pos = {current, 1}.max\nwhile (!(separators.includes?(bytes[current]))) && current > 0\n  current = current - 1\nend\nstart_pos = current + 1\nif (start_pos == 1) && (!(separators.includes?(bytes[current])))\n  start_pos = 0\nend\n@name.byte_slice(start_pos, (end_pos - start_pos) + 1)\n"}},{"html_id":"dirname:String-instance-method","name":"dirname","doc":"Returns all components of this path except the last one.\n\n```\nPath[\"/foo/bar/file.cr\"].dirname # => \"/foo/bar\"\n```","summary":"<p>Returns all components of this path except the last one.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":196,"url":null},"def":{"name":"dirname","return_type":"String","visibility":"Public","body":"if @name.empty?\n  return \".\"\nend\nslice = @name.to_slice\nsep = self.separators.map(&.ord)\npos = slice.size - 1\nstage = 0\nslice.reverse_each do |byte|\n  is_separator = byte.in?(sep)\n  case stage\n  when 1\n    if is_separator\n      stage = stage + 1\n    end\n  when 2\n    if is_separator\n    else\n      break\n    end\n  when 0\n    if is_separator\n    else\n      stage = stage + 1\n    end\n  end\n  pos = pos - 1\nend\ncase stage\nwhen 0\n  String.new(slice[0, 1])\nwhen 1\n  if windows? && windows_drive?\n    return anchor.to_s\n  end\n  \".\"\nelse\n  if pos == -1\n    return String.new(slice[0, 1])\n  end\n  if ((windows? && (pos == 1)) && ((slice.unsafe_fetch(pos)) === ':')) && (anchor = self.anchor)\n    return anchor.to_s\n  end\n  String.new(slice[0, pos + 1])\nend\n"}},{"html_id":"drive:Path?-instance-method","name":"drive","doc":"Returns a path representing the drive component or `nil` if this path does not contain a drive.\n\nSee `#anchor` for the combination of drive and `#root`.\n\n```\nPath.windows(\"C:\\\\Program Files\").drive       # => Path.windows(\"C:\")\nPath.windows(\"\\\\\\\\host\\\\share\\\\folder\").drive # => Path.windows(\"\\\\\\\\host\\\\share\")\n```\n\nNOTE: Drives are only available for Windows paths. It can either be a drive letter (`C:`) or a UNC share (`\\\\host\\share`).","summary":"<p>Returns a path representing the drive component or <code>nil</code> if this path does not contain a drive.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":1143,"url":null},"def":{"name":"drive","return_type":"Path | ::Nil","visibility":"Public","body":"if drive = drive_and_root[0]\n  new_instance(drive)\nend"}},{"html_id":"drive_and_root:Tuple(String?,String?)-instance-method","name":"drive_and_root","doc":"Returns a tuple of `#drive` and `#root` as strings.","summary":"<p>Returns a tuple of <code><a href=\"Path.html#drive%3APath%3F-instance-method\">#drive</a></code> and <code><a href=\"Path.html#root%3APath%3F-instance-method\">#root</a></code> as strings.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":1188,"url":null},"def":{"name":"drive_and_root","return_type":"::Tuple(String | ::Nil, String | ::Nil)","visibility":"Public","body":"if windows?\n  if windows_drive?\n    drive = @name.byte_slice(0, 2)\n    if separators.includes?((@name.byte_at?(2)).try(&.chr))\n      return {drive, @name.byte_slice(2, 1)}\n    else\n      return {drive, nil}\n    end\n  else\n    if unc_share = unc_share?\n      share_end, root_end = unc_share\n      if share_end == root_end\n        root = nil\n      else\n        root = @name.byte_slice(share_end, root_end - share_end)\n      end\n      return {@name.byte_slice(0, share_end), root}\n    else\n      if starts_with_separator?\n        return {nil, @name.byte_slice(0, 1)}\n      else\n        return {nil, nil}\n      end\n    end\n  end\nelse\n  if absolute?\n    return {nil, \"/\"}\n  else\n    return {nil, nil}\n  end\nend"}},{"html_id":"each_parent(&block:Path->)-instance-method","name":"each_parent","doc":"Yields each parent of this path beginning with the topmost parent.\n\n```\nPath[\"foo/bar/file.cr\"].each_parent { |parent| puts parent }\n# Path[\".\"]\n# Path[\"foo\"]\n# Path[\"foo/bar\"]\n```","summary":"<p>Yields each parent of this path beginning with the topmost parent.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":271,"url":null},"def":{"name":"each_parent","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(Path ->)"},"visibility":"Public","body":"if empty?\n  return\nend\nfirst_char = @name.char_at(0)\nif ((separators.includes?(first_char)) || ((first_char == '.') && (separators.includes?((@name.byte_at?(1)).try(&.unsafe_chr))))) || (windows? && (windows_drive? || unc_share?))\nelse\n  yield new_instance(\".\")\nend\npos_memo = nil\neach_part_separator_index do |start_pos, length|\n  if pos_memo\n    yield new_instance(@name.byte_slice(0, pos_memo))\n  end\n  pos_memo = start_pos + length\nend\n"}},{"html_id":"each_part(&:String->)-instance-method","name":"each_part","doc":"Yields each component of this path as a `String`.\n\n```\nPath.new(\"foo/bar/\").each_part # yields: \"foo\", \"bar\"\n```\n\nSee `#parts` for more examples.","summary":"<p>Yields each component of this path as a <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":493,"url":null},"def":{"name":"each_part","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(String ->)"},"visibility":"Public","body":"each_part_separator_index do |start_pos, length|\n  yield @name.byte_slice(start_pos, length)\nend"}},{"html_id":"each_part:Iterator(String)-instance-method","name":"each_part","doc":"Returns an iterator over all components of this path.\n\n```\nparts = Path.new(\"foo/bar/\").each_part\nparts.next # => \"foo\"\nparts.next # => \"bar\"\nparts.next # => Iterator::Stop::INSTANCE\n```\n\nSee `#parts` for more examples.","summary":"<p>Returns an iterator over all components of this path.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":525,"url":null},"def":{"name":"each_part","return_type":"Iterator(String)","visibility":"Public","body":"PartIterator.new(self)"}},{"html_id":"ends_with_separator?:Bool-instance-method","name":"ends_with_separator?","abstract":false,"location":{"filename":"src/path.cr","line_number":1316,"url":null},"def":{"name":"ends_with_separator?","return_type":"Bool","visibility":"Public","body":"ends_with_separator?(@name)"}},{"html_id":"expand(base:Path|String=Dir.current,*,home:Path|String|Bool=false,expand_base=true):Path-instance-method","name":"expand","doc":"Converts this path to an absolute path. Relative paths are\nreferenced from the current working directory of the process (`Dir.current`)\nunless *base* is given, in which case it will be used as the reference path.\n\n```\nPath[\"foo\"].expand                 # => Path[\"/current/path/foo\"]\nPath[\"~/foo\"].expand(home: \"/bar\") # => Path[\"/bar/foo\"]\nPath[\"baz\"].expand(\"/foo/bar\")     # => Path[\"/foo/bar/baz\"]\n```\n\n*home* specifies the home directory which `~` will expand to.\n\"~\" is expanded to the value passed to *home*.\nIf it is `false` (default), home is not expanded.\nIf `true`, it is expanded to the user's home directory (`Path.home`).\n\nIf *expand_base* is `true`, *base* itself will be expanded in `Dir.current`\nif it is not an absolute path. This guarantees the method returns an absolute\npath (assuming that `Dir.current` is absolute).","summary":"<p>Converts this path to an absolute path.</p>","abstract":false,"args":[{"name":"base","default_value":"Dir.current","external_name":"base","restriction":"Path | String"},{"name":"","external_name":"","restriction":""},{"name":"home","default_value":"false","external_name":"home","restriction":"Path | String | Bool"},{"name":"expand_base","default_value":"true","external_name":"expand_base","restriction":""}],"args_string":"(base : Path | String = Dir.current, *, home : Path | String | Bool = false, expand_base = true) : Path","args_html":"(base : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a> = <span class=\"t\">Dir</span>.current, *, home : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a> | <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, expand_base = <span class=\"n\">true</span>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":700,"url":null},"def":{"name":"expand","args":[{"name":"base","default_value":"Dir.current","external_name":"base","restriction":"Path | String"},{"name":"","external_name":"","restriction":""},{"name":"home","default_value":"false","external_name":"home","restriction":"Path | String | Bool"},{"name":"expand_base","default_value":"true","external_name":"expand_base","restriction":""}],"splat_index":1,"return_type":"Path","visibility":"Public","body":"if base.is_a?(Path)\nelse\n  base = Path.new(base)\nend\nbase = base.to_kind(@kind)\nif base == self\n  return (new_instance(@name)).normalize(remove_final_separator: false)\nend\nname = @name\nif home\n  if name == \"~\"\n    name = (resolve_home(home)).to_s\n  else\n    if (name.starts_with?(\"~/\")) || (windows? && (name.starts_with?(\"~\\\\\")))\n      name = ((resolve_home(home)).join(name.byte_slice(2, name.bytesize - 2))).to_s\n    end\n  end\nend\nif (new_instance(name)).absolute?\n  expanded = name\nelse\n  if base.absolute? || (!expand_base)\n  else\n    base = base.expand\n  end\n  if name.empty?\n    expanded = base\n  else\n    if windows?\n      base_drive, base_root = base.drive_and_root\n      drive, root = (new_instance(name)).drive_and_root\n      if drive && base_root\n        base_relative = base_drive ? (base.@name).lchop(base_drive) : base.@name\n        expanded = \"#{drive}#{base_relative}#{separators[0]}#{name.lchop(drive)}\"\n      else\n        if root\n          if base_drive\n            expanded = \"#{base_drive}#{name}\"\n          else\n            expanded = name\n          end\n        else\n          if base_root\n            expanded = base.join(name)\n          else\n            expanded = String.build do |io|\n              if drive\n                io << drive\n              else\n                if base_drive\n                  io << base_drive\n                end\n              end\n              base_relative = base.@name\n              if base_drive\n                base_relative = base_relative.lchop(base_drive)\n              end\n              name_relative = drive ? name.lchop(drive) : name\n              io << base_relative\n              if base_relative.empty?\n              else\n                io << separators[0]\n              end\n              io << name_relative\n            end\n          end\n        end\n      end\n    else\n      expanded = base.join(name)\n    end\n  end\nend\nif expanded.is_a?(Path)\nelse\n  expanded = new_instance(expanded)\nend\nexpanded.normalize(remove_final_separator: false)\n"}},{"html_id":"extension:String-instance-method","name":"extension","doc":"Returns the extension of this path, or an empty string if it has no extension.\n\n```\nPath[\"foo.cr\"].extension     # => \".cr\"\nPath[\"foo\"].extension        # => \"\"\nPath[\"foo.tar.gz\"].extension # => \".gz\"\n```","summary":"<p>Returns the extension of this path, or an empty string if it has no extension.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":355,"url":null},"def":{"name":"extension","return_type":"String","visibility":"Public","body":"if @name.bytesize < 3\n  return \"\"\nend\nbytes = @name.to_slice\nseparators = self.separators.map(&.ord)\noffset = bytes.size - 1\nwhile (bytes.unsafe_fetch(offset)).in?(separators)\n  if offset == 0\n    return \"\"\n  end\n  offset = offset - 1\nend\ndot_index = bytes.rindex(offset: offset) do |byte|\n  (byte === '.') || (byte.in?(separators))\nend\nif dot_index\nelse\n  return \"\"\nend\nif dot_index == 0\n  return \"\"\nend\nif dot_index == offset\n  return \"\"\nend\nif (bytes.unsafe_fetch(dot_index - 1)).in?(separators)\n  return \"\"\nend\nif (bytes.unsafe_fetch(dot_index)).in?(separators)\n  return \"\"\nend\nString.new(bytes[dot_index, (offset - dot_index) + 1])\n"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/path.cr","line_number":1124,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"name = @name\nif windows?\n  name = name.downcase\nend\nhasher = name.hash(hasher)\n@kind.hash(hasher)\n"}},{"html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":"Inspects this path to *io*.","summary":"<p>Inspects this path to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","args_html":"(io : <a href=\"IO.html\">IO</a>)","location":{"filename":"src/path.cr","line_number":1339,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"if native?\n  io << \"Path[\"\n  @name.inspect(io)\n  io << ']'\nelse\n  io << \"Path.\"\n  io << (windows? ? \"windows\" : \"posix\")\n  io << '('\n  @name.inspect(io)\n  io << ')'\nend"}},{"html_id":"join(parts:Enumerable):Path-instance-method","name":"join","doc":"Appends the given *parts* to this path and returns the joined path.\n\n```\nPath[\"foo\"].join(\"bar\", \"baz\")           # => Path[\"foo/bar/baz\"]\nPath[\"foo/\"].join(Path[\"/bar/\", \"/baz\"]) # => Path[\"foo/bar/baz\"]\nPath[\"/foo/\"].join(\"/bar/\", \"/baz/\")     # => Path[\"/foo/bar/baz/\"]\n```\n\nNon-matching paths are implicitly converted to this path's kind.\n\n```\nPath.posix(\"foo/bar\").join(Path.windows(\"baz\\\\baq\")) # => Path.posix(\"foo/bar/baz/baq\")\nPath.windows(\"foo\\\\bar\").join(Path.posix(\"baz/baq\")) # => Path.windows(\"foo\\\\bar\\\\baz/baq\")\n```\n\nSee `join(part)` for details.","summary":"<p>Appends the given <em>parts</em> to this path and returns the joined path.</p>","abstract":false,"args":[{"name":"parts","external_name":"parts","restriction":"Enumerable"}],"args_string":"(parts : Enumerable) : Path","args_html":"(parts : <a href=\"Enumerable.html\">Enumerable</a>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":887,"url":null},"def":{"name":"join","args":[{"name":"parts","external_name":"parts","restriction":"Enumerable"}],"return_type":"Path","visibility":"Public","body":"if parts.is_a?(Indexable)\n  if parts.empty?\n    return self\n  end\n  if parts.size == 1\n    return join(parts.first)\n  end\n  capacity = (@name.bytesize + parts.sum do |__arg5|\n    __arg5.to_s.bytesize\n  end) + parts.size\nelse\n  capacity = 64\nend\nnew_name = String.build(capacity) do |str|\n  str << @name\n  last_ended_with_separator = ends_with_separator?\n  parts.each_with_index do |part, index|\n    case part\n    when Path\n      if posix? && part.windows?\n        part = part.to_posix\n      end\n      part = part.@name\n    else\n      part = part.to_s\n      part.check_no_null_byte\n    end\n    if part.empty?\n      if index == (parts.size - 1)\n        if last_ended_with_separator\n        else\n          str << separators[0]\n        end\n        last_ended_with_separator = true\n      else\n        last_ended_with_separator = false\n      end\n      next\n    end\n    byte_start = 0\n    byte_count = part.bytesize\n    case {starts_with_separator?(part), last_ended_with_separator}\n    when {true, true}\n      byte_start = byte_start + 1\n      byte_count = byte_count - 1\n    when {false, false}\n      if str.bytesize == 0\n      else\n        str << separators[0]\n      end\n    else\n    end\n    last_ended_with_separator = ends_with_separator?(part)\n    str.write(part.unsafe_byte_slice(byte_start, byte_count))\n  end\nend\nnew_instance(new_name)\n"}},{"html_id":"join(part):Path-instance-method","name":"join","doc":"Appends the given *part* to this path and returns the joined path.\n\n```\nPath[\"foo\"].join(\"bar\")     # => Path[\"foo/bar\"]\nPath[\"foo/\"].join(\"/bar\")   # => Path[\"foo/bar\"]\nPath[\"/foo/\"].join(\"/bar/\") # => Path[\"/foo/bar/\"]\n```\n\nJoining an empty string (`\"\"`) appends a trailing path separator.\nIn case the path already ends with a trailing separator, no additional\nseparator is added.\n\n```\nPath[\"a/b\"].join(\"\")   # => Path[\"a/b/\"]\nPath[\"a/b/\"].join(\"\")  # => Path[\"a/b/\"]\nPath[\"a/b/\"].join(\"c\") # => Path[\"a/b/c\"]\n```","summary":"<p>Appends the given <em>part</em> to this path and returns the joined path.</p>","abstract":false,"args":[{"name":"part","external_name":"part","restriction":""}],"args_string":"(part) : Path","args_html":"(part) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":796,"url":null},"def":{"name":"join","args":[{"name":"part","external_name":"part","restriction":""}],"return_type":"Path","visibility":"Public","body":"if (part.is_a?(Path) && posix?) && part.windows?\n  part = part.to_posix.to_s\nelse\n  part = part.to_s\n  part.check_no_null_byte\nend\nif @name.empty?\n  if part.empty?\n    return new_instance(windows? ? \"\\\\\" : \"/\")\n  else\n    return new_instance(part)\n  end\nend\nbytesize = @name.bytesize + part.bytesize\nadd_separator = false\npart_ptr = part.to_unsafe\npart_bytesize = part.bytesize\ncase {ends_with_separator?, starts_with_separator?(part)}\nwhen {true, true}\n  bytesize = bytesize - 1\n  part_ptr = part_ptr + 1\n  part_bytesize = part_bytesize - 1\nwhen {false, false}\n  bytesize = bytesize + 1\n  add_separator = true\nelse\nend\nnew_name = String.new(bytesize) do |buffer|\n  buffer.copy_from(@name.to_unsafe, @name.bytesize)\n  buffer = buffer + @name.bytesize\n  if add_separator\n    buffer.value = separators[0].ord.to_u8\n    buffer = buffer + 1\n  end\n  buffer.copy_from(part_ptr, part_bytesize)\n  {bytesize, @name.single_byte_optimizable? && part.single_byte_optimizable? ? bytesize : 0}\nend\nnew_instance(new_name)\n"}},{"html_id":"join(*parts):Path-instance-method","name":"join","doc":"Appends the given *parts* to this path and returns the joined path.\n\n```\nPath[\"foo\"].join(\"bar\", \"baz\")       # => Path[\"foo/bar/baz\"]\nPath[\"foo/\"].join(\"/bar/\", \"/baz\")   # => Path[\"foo/bar/baz\"]\nPath[\"/foo/\"].join(\"/bar/\", \"/baz/\") # => Path[\"/foo/bar/baz/\"]\n```\n\nSee `join(part)` for details.","summary":"<p>Appends the given <em>parts</em> to this path and returns the joined path.</p>","abstract":false,"args":[{"name":"parts","external_name":"parts","restriction":""}],"args_string":"(*parts) : Path","args_html":"(*parts) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":867,"url":null},"def":{"name":"join","args":[{"name":"parts","external_name":"parts","restriction":""}],"splat_index":0,"return_type":"Path","visibility":"Public","body":"join(parts)"}},{"html_id":"native?:Bool-instance-method","name":"native?","doc":"Returns `true` if this is a native path for the target platform.","summary":"<p>Returns <code>true</code> if this is a native path for the target platform.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":187,"url":null},"def":{"name":"native?","return_type":"Bool","visibility":"Public","body":"@kind == Kind.native"}},{"html_id":"normalize(*,remove_final_separator:Bool=true):Path-instance-method","name":"normalize","doc":"Removes redundant elements from this path and returns the shortest equivalent path by purely lexical processing.\nIt applies the following rules iteratively until no further processing can be done:\n\n  1. Replace multiple slashes with a single slash.\n  2. Eliminate each `.` path name element (the current directory).\n  3. Eliminate each `..` path name element (the parent directory) preceded\n     by a non-`..` element along with the latter.\n  4. Eliminate `..` elements that begin a rooted path:\n     that is, replace `\"/..\"` by `\"/\"` at the beginning of a path.\n\nIf the path turns to be empty, the current directory (`\".\"`) is returned.\n\nThe returned path ends in a slash only if it is the root (`\"/\"`, `\\`, or `C:\\`).\n\nSee also Rob Pike: *[Lexical File Names in Plan 9 or Getting Dot-Dot Right](https://9p.io/sys/doc/lexnames.html)*","summary":"<p>Removes redundant elements from this path and returns the shortest equivalent path by purely lexical processing.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"remove_final_separator","default_value":"true","external_name":"remove_final_separator","restriction":"Bool"}],"args_string":"(*, remove_final_separator : Bool = true) : Path","args_html":"(*, remove_final_separator : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":411,"url":null},"def":{"name":"normalize","args":[{"name":"","external_name":"","restriction":""},{"name":"remove_final_separator","default_value":"true","external_name":"remove_final_separator","restriction":"Bool"}],"splat_index":0,"return_type":"Path","visibility":"Public","body":"if empty?\n  return new_instance(\".\")\nend\ndrive, root = drive_and_root\nreader = Char::Reader.new(@name)\ndotdot = 0\nseparators = self.separators\nadd_separator_at_end = (!remove_final_separator) && ends_with_separator?\nnew_name = String.build do |str|\n  if drive\n    str << (drive.gsub('/', '\\\\'))\n    reader.pos = reader.pos + drive.bytesize\n  end\n  if root\n    str << separators[0]\n    reader.next_char\n    dotdot = str.bytesize\n  end\n  anchor_pos = str.bytesize\n  while (char = reader.current_char) != Char::ZERO\n    curr_pos = reader.pos\n    if separators.includes?(char)\n      reader.next_char\n    else\n      if (char == '.') && (((reader.pos + 1) == @name.bytesize) || (separators.includes?(reader.peek_next_char)))\n        reader.next_char\n      else\n        if ((char == '.') && (reader.next_char == '.')) && (((reader.pos + 1) == @name.bytesize) || (separators.includes?(reader.peek_next_char)))\n          reader.next_char\n          if str.bytesize > dotdot\n            str.back(1)\n            while str.bytesize > dotdot && (!(separators.includes?((str.buffer + str.bytesize).value.unsafe_chr)))\n              str.back(1)\n            end\n          else\n            if !root\n              if str.bytesize > 0\n                str << separators[0]\n              end\n              str << \"..\"\n              dotdot = str.bytesize\n            end\n          end\n        else\n          reader.pos = curr_pos\n          if str.bytesize > anchor_pos && (!(separators.includes?(((str.buffer + str.bytesize) - 1).value.unsafe_chr)))\n            str << separators[0]\n          end\n          loop do\n            str << char\n            char = reader.next_char\n            if (separators.includes?(char)) || (char == Char::ZERO)\n              break\n            end\n          end\n        end\n      end\n    end\n  end\n  if str.empty?\n    str << '.'\n  end\n  last_char = ((str.buffer + str.bytesize) - 1).value.unsafe_chr\n  if add_separator_at_end && (!(separators.includes?(last_char)))\n    str << separators[0]\n  end\nend\nnew_instance(new_name)\n"}},{"html_id":"parent:Path-instance-method","name":"parent","doc":"Returns the parent path of this path.\n\nIf the path is empty, it returns `\".\"`. If the path is rooted\nand in the top-most hierarchy, the root path is returned.\n\n```\nPath[\"foo/bar/file.cr\"].parent # => Path[\"foo/bar\"]\nPath[\"foo\"].parent             # => Path[\".\"]\nPath[\"/foo\"].parent            # => Path[\"/\"]\nPath[\"/\"].parent               # => Path[\"/\"]\nPath[\"\"].parent                # => Path[\".\"]\nPath[\"foo/bar/.\"].parent       # => Path[\"foo/bar\"]\n```","summary":"<p>Returns the parent path of this path.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":246,"url":null},"def":{"name":"parent","return_type":"Path","visibility":"Public","body":"new_instance(dirname)"}},{"html_id":"parents:Array(Path)-instance-method","name":"parents","doc":"Returns all parent paths of this path beginning with the topmost path.\n\n```\nPath[\"foo/bar/file.cr\"].parents # => [Path[\".\"], Path[\"foo\"], Path[\"foo/bar\"]]\n```","summary":"<p>Returns all parent paths of this path beginning with the topmost path.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":255,"url":null},"def":{"name":"parents","return_type":"Array(Path)","visibility":"Public","body":"parents = [] of Path\neach_parent do |parent|\n  parents << parent\nend\nparents\n"}},{"html_id":"parts:Array(String)-instance-method","name":"parts","doc":"Returns the components of this path as an `Array(String)`.\n\n```\nPath.new(\"foo/bar/\").parts                   # => [\"foo\", \"bar\"]\nPath.new(\"/Users/foo/bar.cr\").parts          # => [\"/\", \"Users\", \"foo\", \"bar.cr\"]\nPath.windows(\"C:\\\\Users\\\\foo\\\\bar.cr\").parts # => [\"C:\\\\\", \"Users\", \"foo\", \"bar.cr\"]\nPath.posix(\"C:\\\\Users\\\\foo\\\\bar.cr\").parts   # => [\"C:\\\\Users\\\\foo\\\\bar.cr\"]\n```","summary":"<p>Returns the components of this path as an <code><a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)</code>.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":507,"url":null},"def":{"name":"parts","return_type":"Array(String)","visibility":"Public","body":"parts = [] of String\neach_part do |part|\n  parts << part\nend\nparts\n"}},{"html_id":"posix?:Bool-instance-method","name":"posix?","doc":"Returns `true` if this is a POSIX path.","summary":"<p>Returns <code>true</code> if this is a POSIX path.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":182,"url":null},"def":{"name":"posix?","return_type":"Bool","visibility":"Public","body":"@kind.posix?"}},{"html_id":"relative_to(base:Path|String):Path-instance-method","name":"relative_to","doc":"Same as `#relative_to` but returns `self` if `self` can't be expressed as\nrelative path to *base*.","summary":"<p>Same as <code><a href=\"Path.html#relative_to%28base%3APath%7CString%29%3APath-instance-method\">#relative_to</a></code> but returns <code>self</code> if <code>self</code> can't be expressed as relative path to <em>base</em>.</p>","abstract":false,"args":[{"name":"base","external_name":"base","restriction":"Path | String"}],"args_string":"(base : Path | String) : Path","args_html":"(base : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":1065,"url":null},"def":{"name":"relative_to","args":[{"name":"base","external_name":"base","restriction":"Path | String"}],"return_type":"Path","visibility":"Public","body":"(relative_to?(base)) || self"}},{"html_id":"relative_to?(base:Path):Path?-instance-method","name":"relative_to?","doc":"Returns a relative path that is lexically equivalent to `self` when joined\nto *base* with an intervening separator.\n\nThe returned path is in normalized form.\n\nThat means with normalized paths `base.join(target.relative_to(base))` is\nequivalent to `target`.\n\nReturns `nil` if `self` cannot be expressed as relative to *base* or if\nknowing the current working directory would be necessary to resolve it. The\nlatter can be avoided by expanding the paths first.","summary":"<p>Returns a relative path that is lexically equivalent to <code>self</code> when joined to <em>base</em> with an intervening separator.</p>","abstract":false,"args":[{"name":"base","external_name":"base","restriction":"Path"}],"args_string":"(base : Path) : Path?","args_html":"(base : <a href=\"Path.html\">Path</a>) : <a href=\"Path.html\">Path</a>?","location":{"filename":"src/path.cr","line_number":991,"url":null},"def":{"name":"relative_to?","args":[{"name":"base","external_name":"base","restriction":"Path"}],"return_type":"Path | ::Nil","visibility":"Public","body":"base_anchor = base.anchor\ntarget_anchor = self.anchor\nif base_anchor != target_anchor\n  return nil\nend\nbase = base.normalize\ntarget = self.normalize\nif base == target\n  return new_instance(\".\")\nend\nbase_iterator = base.each_part\ntarget_iterator = target.each_part\nif target_anchor\n  base_iterator.next\n  target_iterator.next\nend\nbase_part = base_iterator.next\ntarget_part = target_iterator.next\nwhile base_part.is_a?(String) && target_part.is_a?(String)\n  if (base_part.compare(target_part, case_insensitive: windows?)) != 0\n    break\n  end\n  base_part = base_iterator.next\n  target_part = target_iterator.next\nend\npath = new_instance(\"\")\nif base_part.is_a?(String)\n  if base_part == \"..\"\n    return nil\n  end\n  if base_part == \".\"\n  else\n    path = path / \"..\"\n  end\n  base_iterator.each do\n    path = path / \"..\"\n  end\nend\nif target_part.is_a?(String)\n  path = path / target_part\n  target_iterator.each do |part|\n    path = path / part\n  end\nend\nreturn path\n"}},{"html_id":"relative_to?(base:String):Path?-instance-method","name":"relative_to?","doc":"Returns a relative path that is lexically equivalent to `self` when joined\nto *base* with an intervening separator.\n\nThe returned path is in normalized form.\n\nThat means with normalized paths `base.join(target.relative_to(base))` is\nequivalent to `target`.\n\nReturns `nil` if `self` cannot be expressed as relative to *base* or if\nknowing the current working directory would be necessary to resolve it. The\nlatter can be avoided by expanding the paths first.","summary":"<p>Returns a relative path that is lexically equivalent to <code>self</code> when joined to <em>base</em> with an intervening separator.</p>","abstract":false,"args":[{"name":"base","external_name":"base","restriction":"String"}],"args_string":"(base : String) : Path?","args_html":"(base : <a href=\"String.html\">String</a>) : <a href=\"Path.html\">Path</a>?","location":{"filename":"src/path.cr","line_number":1059,"url":null},"def":{"name":"relative_to?","args":[{"name":"base","external_name":"base","restriction":"String"}],"return_type":"Path | ::Nil","visibility":"Public","body":"relative_to?(new_instance(base))"}},{"html_id":"root:Path?-instance-method","name":"root","doc":"Returns the root path component of this path or `nil` if it is not rooted.\n\nSee `#anchor` for the combination of `#drive` and root.\n\n```\nPath[\"/etc/\"].root                           # => Path[\"/\"]\nPath.windows(\"C:Program Files\").root         # => nil\nPath.windows(\"C:\\\\Program Files\").root       # => Path.windows(\"\\\\\")\nPath.windows(\"\\\\\\\\host\\\\share\\\\folder\").root # => Path.windows(\"\\\\\")\n```","summary":"<p>Returns the root path component of this path or <code>nil</code> if it is not rooted.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":1159,"url":null},"def":{"name":"root","return_type":"Path | ::Nil","visibility":"Public","body":"if root = drive_and_root[1]\n  new_instance(root)\nend"}},{"html_id":"sibling(name:Path|String):Path-instance-method","name":"sibling","doc":"Resolves path *name* in this path's parent directory.\n\nRaises `Path::Error` if `#parent` is `nil`.","summary":"<p>Resolves path <em>name</em> in this path's parent directory.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"Path | String"}],"args_string":"(name : Path | String) : Path","args_html":"(name : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":968,"url":null},"def":{"name":"sibling","args":[{"name":"name","external_name":"name","restriction":"Path | String"}],"return_type":"Path","visibility":"Public","body":"if parent = self.parent\n  parent.join(name)\nelse\n  raise(Error.new(\"Can't resolve sibling for a path without parent directory\"))\nend"}},{"html_id":"stem:String-instance-method","name":"stem","doc":"Returns the last component of this path without the extension.\n\nThis is equivalent to `self.basename(self.extension)`.\n\n```\nPath[\"file.cr\"].stem     # => \"file\"\nPath[\"file.tar.gz\"].stem # => \"file.tar\"\nPath[\"foo/file.cr\"].stem # => \"file\"\n```","summary":"<p>Returns the last component of this path without the extension.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":392,"url":null},"def":{"name":"stem","return_type":"String","visibility":"Public","body":"basename(extension)"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":74,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"@name.to_json(json)"}},{"html_id":"to_json_object_key:String-instance-method","name":"to_json_object_key","abstract":false,"location":{"filename":"src/json/to_json.cr","line_number":78,"url":null},"def":{"name":"to_json_object_key","visibility":"Public","body":"@name"}},{"html_id":"to_kind(kind):Path-instance-method","name":"to_kind","doc":"Converts this path to the given *kind*.\n\nSee `#to_windows` and `#to_posix` for details.","summary":"<p>Converts this path to the given <em>kind</em>.</p>","abstract":false,"args":[{"name":"kind","external_name":"kind","restriction":""}],"args_string":"(kind) : Path","args_html":"(kind) : <a href=\"Path.html\">Path</a>","location":{"filename":"src/path.cr","line_number":674,"url":null},"def":{"name":"to_kind","args":[{"name":"kind","external_name":"kind","restriction":""}],"return_type":"Path","visibility":"Public","body":"if kind.posix?\n  to_posix\nelse\n  to_windows\nend"}},{"html_id":"to_native:Path-instance-method","name":"to_native","doc":"Converts this path to a native path.","summary":"<p>Converts this path to a native path.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":635,"url":null},"def":{"name":"to_native","return_type":"Path","visibility":"Public","body":"to_kind(Kind.native)"}},{"html_id":"to_posix:Path-instance-method","name":"to_posix","doc":"Converts this path to a POSIX path.\n\n```\nPath.windows(\"foo/bar\\\\baz\").to_posix # => Path.posix(\"foo/bar/baz\")\nPath.posix(\"foo/bar\").to_posix        # => Path.posix(\"foo/bar\")\nPath.posix(\"foo/bar\\\\baz\").to_posix   # => Path.posix(\"foo/bar\\\\baz\")\n```\n\nIt returns a copy of this instance if it already has POSIX kind. Otherwise\na new instance is created with `Kind::POSIX` and all occurrences of\nbackslash file separators (`\\\\`) replaced by forward slash (`/`).","summary":"<p>Converts this path to a POSIX path.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":663,"url":null},"def":{"name":"to_posix","return_type":"Path","visibility":"Public","body":"if posix?\n  new_instance(@name, Kind::POSIX)\nelse\n  new_instance(@name.gsub((Path.separators(Kind::WINDOWS))[0], (Path.separators(Kind::POSIX))[0]), Kind::POSIX)\nend"}},{"html_id":"to_s(io:IO)-instance-method","name":"to_s","doc":"Appends the string representation of this path to *io*.","summary":"<p>Appends the string representation of this path to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","args_html":"(io : <a href=\"IO.html\">IO</a>)","location":{"filename":"src/path.cr","line_number":1334,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"io << to_s"}},{"html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns the string representation of this path.","summary":"<p>Returns the string representation of this path.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":1329,"url":null},"def":{"name":"to_s","return_type":"String","visibility":"Public","body":"@name"}},{"html_id":"to_uri:URI-instance-method","name":"to_uri","doc":"Returns a new `URI` with `file` scheme from this path.\n\nA URI can only be created with an absolute path. Raises `Path::Error` if\nthis path is not absolute.","summary":"<p>Returns a new <code><a href=\"URI.html\">URI</a></code> with <code>file</code> scheme from this path.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":1357,"url":null},"def":{"name":"to_uri","return_type":"URI","visibility":"Public","body":"if absolute?\nelse\n  raise(Error.new(\"Cannot create a URI from relative path\"))\nend\nURI.new(scheme: \"file\", path: @name)\n"}},{"html_id":"to_windows:Path-instance-method","name":"to_windows","doc":"Converts this path to a Windows path.\n\n```\nPath.posix(\"foo/bar\").to_windows   # => Path.windows(\"foo/bar\")\nPath.windows(\"foo/bar\").to_windows # => Path.windows(\"foo/bar\")\n```\n\nThis creates a new instance with the same string representation but with\n`Kind::WINDOWS`.","summary":"<p>Converts this path to a Windows path.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":648,"url":null},"def":{"name":"to_windows","return_type":"Path","visibility":"Public","body":"new_instance(@name, Kind::WINDOWS)"}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder) : Nil","args_html":"(yaml : <a href=\"YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":72,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"@name.to_yaml(yaml)"}},{"html_id":"windows?:Bool-instance-method","name":"windows?","doc":"Returns `true` if this is a Windows path.","summary":"<p>Returns <code>true</code> if this is a Windows path.</p>","abstract":false,"location":{"filename":"src/path.cr","line_number":177,"url":null},"def":{"name":"windows?","return_type":"Bool","visibility":"Public","body":"@kind.windows?"}}],"types":[{"html_id":"Crystal/Path/Error","path":"Path/Error.html","kind":"class","full_name":"Path::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/path.cr","line_number":63,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Path","kind":"struct","full_name":"Path","name":"Path"}},{"html_id":"Crystal/Path/Kind","path":"Path/Kind.html","kind":"enum","full_name":"Path::Kind","name":"Kind","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/path.cr","line_number":66,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"POSIX","name":"POSIX","value":"0_u8"},{"id":"WINDOWS","name":"WINDOWS","value":"1_u8"}],"namespace":{"html_id":"Crystal/Path","kind":"struct","full_name":"Path","name":"Path"},"constructors":[{"html_id":"native:Kind-class-method","name":"native","abstract":false,"location":{"filename":"src/path.cr","line_number":72,"url":null},"def":{"name":"native","return_type":"Kind","visibility":"Public","body":"{% if flag?(:win32) %}\n        WINDOWS\n      {% else %}\n        POSIX\n      {% end %}"}}],"instance_methods":[{"html_id":"posix?-instance-method","name":"posix?","abstract":false,"location":{"filename":"src/path.cr","line_number":69,"url":null},"def":{"name":"posix?","visibility":"Public","body":"self == POSIX"}},{"html_id":"windows?-instance-method","name":"windows?","abstract":false,"location":{"filename":"src/path.cr","line_number":70,"url":null},"def":{"name":"windows?","visibility":"Public","body":"self == WINDOWS"}}]}]},{"html_id":"Crystal/Pointer","path":"Pointer.html","kind":"struct","full_name":"Pointer(T)","name":"Pointer","abstract":false,"superclass":{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/pointer.cr","line_number":30,"url":null},{"filename":"src/primitives.cr","line_number":135,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"doc":"A typed pointer to some memory.\n\nThis is the only unsafe type in Crystal. If you are using a pointer, you are writing\nunsafe code because a pointer doesn't know where it's pointing to nor how much memory\nstarting from it is valid. However, pointers make it possible to interface with C and\nto implement efficient data structures. For example, both `Array` and `Hash` are\nimplemented using pointers.\n\nYou can obtain pointers in four ways: `#new`, `#malloc`, `pointerof` and by calling a C\nfunction that returns a pointer.\n\n`pointerof(x)`, where *x* is a variable or an instance variable, returns a pointer to\nthat variable:\n\n```\nx = 1\nptr = pointerof(x)\nptr.value = 2\nx # => 2\n```\n\nNote that a pointer is *falsey* if it's null (if its address is zero).\n\nWhen calling a C function that expects a pointer you can also pass `nil` instead of using\n`Pointer.null` to construct a null pointer.\n\nFor a safe alternative, see `Slice`, which is a pointer with a size and with bounds checking.","summary":"<p>A typed pointer to some memory.</p>","class_methods":[{"html_id":"malloc(size:Int,value:T)-class-method","name":"malloc","doc":"Allocates `size * sizeof(T)` bytes from the system's heap initialized\nto *value* and returns a pointer to the first byte from that memory.\nThe memory is allocated by the `GC`, so when there are\nno pointers to this memory, it will be automatically freed.\n\n```\n# An Int32 occupies 4 bytes, so here we are requesting 8 bytes\n# initialized to the number 42\nptr = Pointer.malloc(2, 42)\nptr[0] # => 42\nptr[1] # => 42\n```","summary":"<p>Allocates <code>size * sizeof(T)</code> bytes from the system's heap initialized to <em>value</em> and returns a pointer to the first byte from that memory.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(size : Int, value : T)","args_html":"(size : <a href=\"Int.html\">Int</a>, value : T)","location":{"filename":"src/pointer.cr","line_number":455,"url":null},"def":{"name":"malloc","args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"ptr = Pointer(T).malloc(size)\nsize.times do |i|\n  ptr[i] = value\nend\nptr\n"}},{"html_id":"malloc(size:UInt64)-class-method","name":"malloc","doc":"Allocates `size * sizeof(T)` bytes from the system's heap initialized\nto zero and returns a pointer to the first byte from that memory.\nThe memory is allocated by the `GC`, so when there are\nno pointers to this memory, it will be automatically freed.\n\n```\n# Allocate memory for an Int32: 4 bytes\nptr = Pointer(Int32).malloc(1_u64)\nptr.value # => 0\n\n# Allocate memory for 10 Int32: 40 bytes\nptr = Pointer(Int32).malloc(10_u64)\nptr[0] # => 0\n# ...\nptr[9] # => 0\n```\n\nThe implementation uses `GC.malloc` if the compiler is aware that the\nallocated type contains inner address pointers. Otherwise it uses\n`GC.malloc_atomic`. Primitive types are expected to not contain pointers,\nexcept `Void`. `Proc` and `Pointer` are expected to contain pointers.\nFor unions, structs and collection types (tuples, static array)\nit depends on the contained types. All other types, including classes are\nexpected to contain inner address pointers.\n\nTo override this implicit behaviour, `GC.malloc` and `GC.malloc_atomic`\ncan be used directly instead.","summary":"<p>Allocates <code>size * sizeof(T)</code> bytes from the system's heap initialized to zero and returns a pointer to the first byte from that memory.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"UInt64"}],"args_string":"(size : UInt64)","args_html":"(size : <a href=\"UInt64.html\">UInt64</a>)","location":{"filename":"src/primitives.cr","line_number":164,"url":null},"def":{"name":"malloc","args":[{"name":"size","external_name":"size","restriction":"UInt64"}],"visibility":"Public","body":"# primitive: pointer_malloc"}},{"html_id":"malloc(size:Int=1)-class-method","name":"malloc","doc":"Allocates `size * sizeof(T)` bytes from the system's heap initialized\nto zero and returns a pointer to the first byte from that memory.\nThe memory is allocated by the `GC`, so when there are\nno pointers to this memory, it will be automatically freed.\n\n```\n# Allocate memory for an Int32: 4 bytes\nptr = Pointer(Int32).malloc\nptr.value # => 0\n\n# Allocate memory for 10 Int32: 40 bytes\nptr = Pointer(Int32).malloc(10)\nptr[0] # => 0\n# ...\nptr[9] # => 0\n```","summary":"<p>Allocates <code>size * sizeof(T)</code> bytes from the system's heap initialized to zero and returns a pointer to the first byte from that memory.</p>","abstract":false,"args":[{"name":"size","default_value":"1","external_name":"size","restriction":"Int"}],"args_string":"(size : Int = 1)","args_html":"(size : <a href=\"Int.html\">Int</a> = <span class=\"n\">1</span>)","location":{"filename":"src/pointer.cr","line_number":435,"url":null},"def":{"name":"malloc","args":[{"name":"size","default_value":"1","external_name":"size","restriction":"Int"}],"visibility":"Public","body":"if size < 0\n  raise(ArgumentError.new(\"Negative Pointer#malloc size\"))\nend\nmalloc(size.to_u64)\n"}},{"html_id":"malloc(size:Int,&:Int32->T)-class-method","name":"malloc","doc":"Allocates `size * sizeof(T)` bytes from the system's heap initialized\nto the value returned by the block (which is invoked once with each index in the range `0...size`)\nand returns a pointer to the first byte from that memory.\nThe memory is allocated by the `GC`, so when there are\nno pointers to this memory, it will be automatically freed.\n\n```\n# An Int32 occupies 4 bytes, so here we are requesting 16 bytes.\n# i is an index in the range 0 .. 3\nptr = Pointer.malloc(4) { |i| i + 10 }\nptr[0] # => 10\nptr[1] # => 11\nptr[2] # => 12\nptr[3] # => 13\n```","summary":"<p>Allocates <code>size * sizeof(T)</code> bytes from the system's heap initialized to the value returned by the block (which is invoked once with each index in the range <code>0...size</code>) and returns a pointer to the first byte from that memory.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int"}],"args_string":"(size : Int, & : Int32 -> T)","args_html":"(size : <a href=\"Int.html\">Int</a>, & : <a href=\"Int32.html\">Int32</a> -> T)","location":{"filename":"src/pointer.cr","line_number":476,"url":null},"def":{"name":"malloc","args":[{"name":"size","external_name":"size","restriction":"Int"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Int32 -> T)"},"visibility":"Public","body":"ptr = Pointer(T).malloc(size)\nsize.times do |i|\n  ptr[i] = yield i\nend\nptr\n"}},{"html_id":"null-class-method","name":"null","doc":"Returns a pointer whose memory address is zero. This doesn't allocate memory.\n\nWhen calling a C function you can also pass `nil` instead of constructing a\nnull pointer with this method.\n\n```\nptr = Pointer(Int32).null\nptr.address # => 0\n```","summary":"<p>Returns a pointer whose memory address is zero.</p>","abstract":false,"location":{"filename":"src/pointer.cr","line_number":405,"url":null},"def":{"name":"null","visibility":"Public","body":"new(0_u64)"}}],"constructors":[{"html_id":"new(address:UInt64)-class-method","name":"new","doc":"Returns a pointer that points to the given memory address.\nThis doesn't allocate memory.\n\n```\nptr = Pointer(Int32).new(5678_u64)\nptr.address # => 5678\n```","summary":"<p>Returns a pointer that points to the given memory address.</p>","abstract":false,"args":[{"name":"address","external_name":"address","restriction":"UInt64"}],"args_string":"(address : UInt64)","args_html":"(address : <a href=\"UInt64.html\">UInt64</a>)","location":{"filename":"src/primitives.cr","line_number":175,"url":null},"def":{"name":"new","args":[{"name":"address","external_name":"address","restriction":"UInt64"}],"visibility":"Public","body":"# primitive: pointer_new"}},{"html_id":"new(address:Int)-class-method","name":"new","doc":"Returns a pointer that points to the given memory address. This doesn't allocate memory.\n\n```\nptr = Pointer(Int32).new(5678)\nptr.address # => 5678\n```","summary":"<p>Returns a pointer that points to the given memory address.</p>","abstract":false,"args":[{"name":"address","external_name":"address","restriction":"Int"}],"args_string":"(address : Int)","args_html":"(address : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/pointer.cr","line_number":415,"url":null},"def":{"name":"new","args":[{"name":"address","external_name":"address","restriction":"Int"}],"visibility":"Public","body":"new(address.to_u64!)"}},{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/primitives.cr","line_number":135,"url":null},"def":{"name":"new","visibility":"Public","body":"x = allocate\nif x.responds_to?(:finalize)\n  ::GC.add_finalizer(x)\nend\nx\n"}}],"instance_methods":[{"html_id":"+(offset:Int64):self-instance-method","name":"+","doc":"Returns a new pointer whose address is this pointer's address\nincremented by `other * sizeof(T)`.\n\n```\nptr = Pointer(Int32).new(1234)\nptr.address # => 1234\n\n# An Int32 occupies four bytes\nptr2 = ptr + 1_u64\nptr2.address # => 1238\n```","summary":"<p>Returns a new pointer whose address is this pointer's address incremented by <code>other * sizeof(T)</code>.</p>","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":"Int64"}],"args_string":"(offset : Int64) : self","args_html":"(offset : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":241,"url":null},"def":{"name":"+","args":[{"name":"offset","external_name":"offset","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: pointer_add"}},{"html_id":"+(other:Int)-instance-method","name":"+","doc":"Returns a new pointer whose address is this pointer's address incremented by `other * sizeof(T)`.\n\n```\nptr = Pointer(Int32).new(1234)\nptr.address # => 1234\n\n# An Int32 occupies four bytes\nptr2 = ptr + 1\nptr2.address # => 1238\n```","summary":"<p>Returns a new pointer whose address is this pointer's address incremented by <code>other * sizeof(T)</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","args_html":"(other : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/pointer.cr","line_number":80,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int"}],"visibility":"Public","body":"self + other.to_i64"}},{"html_id":"-(other:self):Int64-instance-method","name":"-","doc":"Returns how many T elements are there between this pointer and *other*.\nThat is, this is `(self.address - other.address) / sizeof(T)`.\n\n```\nptr1 = Pointer(Int32).malloc(4)\nptr2 = ptr1 + 2\nptr2 - ptr1 # => 2\n```","summary":"<p>Returns how many T elements are there between this pointer and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self) : Int64","args_html":"(other : <span class=\"k\">self</span>) : <a href=\"Int64.html\">Int64</a>","location":{"filename":"src/primitives.cr","line_number":253,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"self"}],"return_type":"Int64","visibility":"Public","body":"# primitive: pointer_diff"}},{"html_id":"-(other:Int)-instance-method","name":"-","doc":"Returns a new pointer whose address is this pointer's address decremented by `other * sizeof(T)`.\n\n```\nptr = Pointer(Int32).new(1234)\nptr.address # => 1234\n\n# An Int32 occupies four bytes\nptr2 = ptr - 1\nptr2.address # => 1230\n```","summary":"<p>Returns a new pointer whose address is this pointer's address decremented by <code>other * sizeof(T)</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int"}],"args_string":"(other : Int)","args_html":"(other : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/pointer.cr","line_number":94,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int"}],"visibility":"Public","body":"self + (-other.to_i64!)"}},{"html_id":"<=>(other:self)-instance-method","name":"<=>","doc":"Returns `-1`, `0` or `1` depending on whether this pointer's address is less, equal or greater than *other*'s address,\nrespectively.","summary":"<p>Returns <code>-1</code>, <code>0</code> or <code>1</code> depending on whether this pointer's address is less, equal or greater than <em>other</em>'s address, respectively.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/pointer.cr","line_number":103,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"address <=> other.address"}},{"html_id":"[](offset)-instance-method","name":"[]","doc":"Gets the value pointed at this pointer's address plus `offset * sizeof(T)`.\n\n```\nptr = Pointer.malloc(4) { |i| i + 10 }\nptr[0] # => 10\nptr[1] # => 11\nptr[2] # => 12\nptr[3] # => 13\n```","summary":"<p>Gets the value pointed at this pointer's address plus <code>offset * sizeof(T)</code>.</p>","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":""}],"args_string":"(offset)","args_html":"(offset)","location":{"filename":"src/pointer.cr","line_number":116,"url":null},"def":{"name":"[]","args":[{"name":"offset","external_name":"offset","restriction":""}],"visibility":"Public","body":"(self + offset).value"}},{"html_id":"[]=(offset,value:T)-instance-method","name":"[]=","doc":"Sets the value pointed at this pointer's address plus `offset * sizeof(T)`.\n\n```\nptr = Pointer(Int32).malloc(4) # [0, 0, 0, 0]\nptr[1] = 42\n\nptr2 = ptr + 1\nptr2.value # => 42\n```","summary":"<p>Sets the value pointed at this pointer's address plus <code>offset * sizeof(T)</code>.</p>","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(offset, value : T)","args_html":"(offset, value : T)","location":{"filename":"src/pointer.cr","line_number":129,"url":null},"def":{"name":"[]=","args":[{"name":"offset","external_name":"offset","restriction":""},{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"(self + offset).value = value"}},{"html_id":"address:UInt64-instance-method","name":"address","doc":"Returns the address of this pointer.\n\n```\nptr = Pointer(Int32).new(1234)\nptr.address # => 1234\n```","summary":"<p>Returns the address of this pointer.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":207,"url":null},"def":{"name":"address","return_type":"UInt64","visibility":"Public","body":"# primitive: pointer_address"}},{"html_id":"appender:Pointer::Appender-instance-method","name":"appender","doc":"Returns a `Pointer::Appender` for this pointer.","summary":"<p>Returns a <code><a href=\"Pointer/Appender.html\">Pointer::Appender</a></code> for this pointer.</p>","abstract":false,"location":{"filename":"src/pointer.cr","line_number":483,"url":null},"def":{"name":"appender","return_type":"Pointer::Appender","visibility":"Public","body":"Pointer::Appender.new(self)"}},{"html_id":"clear(count=1)-instance-method","name":"clear","doc":"Clears (sets to \"zero\" bytes) a number of values pointed by this pointer.\n\n```\nptr = Pointer.malloc(6) { |i| i + 10 } # [10, 11, 12, 13, 14, 15]\nptr.clear(3)\nptr.to_slice(6) # => Slice[0, 0, 0, 13, 14, 15]\n```","summary":"<p>Clears (sets to &quot;zero&quot; bytes) a number of values pointed by this pointer.</p>","abstract":false,"args":[{"name":"count","default_value":"1","external_name":"count","restriction":""}],"args_string":"(count = 1)","args_html":"(count = <span class=\"n\">1</span>)","location":{"filename":"src/pointer.cr","line_number":505,"url":null},"def":{"name":"clear","args":[{"name":"count","default_value":"1","external_name":"count","restriction":""}],"visibility":"Public","body":"Intrinsics.memset(self.as(::Pointer(Void)), 0_u8, bytesize(count), false)"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/pointer.cr","line_number":509,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"copy_from(source:Pointer(T),count:Int)-instance-method","name":"copy_from","doc":"Copies *count* elements from *source* into `self`.\nIf *source* and `self` overlap, behaviour is undefined.\nUse `#move_from` if they overlap (slower but always works).\n\n```\nptr1 = Pointer.malloc(4) { |i| i + 1 }  # [1, 2, 3, 4]\nptr2 = Pointer.malloc(4) { |i| i + 11 } # [11, 12, 13, 14]\n\n# ptr2 -> [11, 12, 13, 14]\n#          ^---^           <- copy this\n# ptr1 -> [1,  2,  3,  4]\n#          ^---^           <- here\nptr1.copy_from(ptr2, 2)\nptr1[0] # => 11\nptr1[1] # => 12\nptr1[2] # => 3\nptr1[3] # => 4\n```","summary":"<p>Copies <em>count</em> elements from <em>source</em> into <code>self</code>.</p>","abstract":false,"args":[{"name":"source","external_name":"source","restriction":"Pointer(T)"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(source : Pointer(T), count : Int)","args_html":"(source : <a href=\"Pointer.html\">Pointer</a>(T), count : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/pointer.cr","line_number":151,"url":null},"def":{"name":"copy_from","args":[{"name":"source","external_name":"source","restriction":"Pointer(T)"},{"name":"count","external_name":"count","restriction":"Int"}],"visibility":"Public","body":"source.copy_to(self, count)"}},{"html_id":"copy_to(target:Pointer,count:Int)-instance-method","name":"copy_to","doc":"Copies *count* elements from `self` into *target*.\nIf `self` and *target* overlap, behaviour is undefined.\nUse `#move_to` if they overlap (slower but always works).\n\n```\nptr1 = Pointer.malloc(4) { |i| i + 1 }  # [1, 2, 3, 4]\nptr2 = Pointer.malloc(4) { |i| i + 11 } # [11, 12, 13, 14]\n\n# ptr1 -> [1,  2,  3,  4]\n#          ^---^           <- copy this\n# ptr2 -> [11, 12, 13, 14]\n#          ^---^           <- here\nptr1.copy_to(ptr2, 2)\nptr2[0] # => 1\nptr2[1] # => 2\nptr2[2] # => 13\nptr2[3] # => 14\n```","summary":"<p>Copies <em>count</em> elements from <code>self</code> into <em>target</em>.</p>","abstract":false,"args":[{"name":"target","external_name":"target","restriction":"Pointer"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(target : Pointer, count : Int)","args_html":"(target : <a href=\"Pointer.html\">Pointer</a>, count : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/pointer.cr","line_number":182,"url":null},"def":{"name":"copy_to","args":[{"name":"target","external_name":"target","restriction":"Pointer"},{"name":"count","external_name":"count","restriction":"Int"}],"visibility":"Public","body":"target.copy_from_impl(self, count)"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"Returns the address of this pointer.\n\n```\nptr = Pointer(Int32).new(1234)\nptr.hash # => 1234\n```","summary":"<p>Returns the address of this pointer.</p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/pointer.cr","line_number":309,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = address.hash(hasher)\nhasher\n"}},{"html_id":"initialize-instance-method","name":"initialize","abstract":false,"location":{"filename":"src/primitives.cr","line_number":135,"url":null},"def":{"name":"initialize","visibility":"Public","body":""}},{"html_id":"map!(count:Int,&:T->T)-instance-method","name":"map!","doc":"Sets *count* consecutive values pointed by this pointer to the\nvalues returned by the block.\n\n```\nptr = Pointer.malloc(4) { |i| i + 1 } # [1, 2, 3, 4]\nptr.map!(4) { |value| value * 2 }\nptr # [2, 4, 6, 8]\n```","summary":"<p>Sets <em>count</em> consecutive values pointed by this pointer to the values returned by the block.</p>","abstract":false,"args":[{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(count : Int, & : T -> T)","args_html":"(count : <a href=\"Int.html\">Int</a>, & : T -> T)","location":{"filename":"src/pointer.cr","line_number":379,"url":null},"def":{"name":"map!","args":[{"name":"count","external_name":"count","restriction":"Int"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> T)"},"visibility":"Public","body":"count.times do |i|\n  self[i] = yield self[i]\nend"}},{"html_id":"map_with_index!(count:Int,offset=0,&)-instance-method","name":"map_with_index!","doc":"Like `map!`, but yields 2 arguments, the element and its index\n\nAccepts an optional *offset* parameter, which tells it to start counting\nfrom there.","summary":"<p>Like <code><a href=\"Pointer.html#map%21%28count%3AInt%2C%26%3AT-%3ET%29-instance-method\">#map!</a></code>, but yields 2 arguments, the element and its index</p>","abstract":false,"args":[{"name":"count","external_name":"count","restriction":"Int"},{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(count : Int, offset = 0, &)","args_html":"(count : <a href=\"Int.html\">Int</a>, offset = <span class=\"n\">0</span>, &)","location":{"filename":"src/pointer.cr","line_number":389,"url":null},"def":{"name":"map_with_index!","args":[{"name":"count","external_name":"count","restriction":"Int"},{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"yields":2,"visibility":"Public","body":"count.times do |i|\n  self[i] = yield self[i], offset + i\nend\nself\n"}},{"html_id":"memcmp(other:Pointer(T),count:Int):Int32-instance-method","name":"memcmp","doc":"Compares *count* elements from this pointer and *other*, byte by byte.\n\nReturns 0 if both pointers point to the same sequence of *count* bytes. Otherwise\nreturns the difference between the first two differing bytes (treated as UInt8).\n\n```\nptr1 = Pointer.malloc(4) { |i| i + 1 }  # [1, 2, 3, 4]\nptr2 = Pointer.malloc(4) { |i| i + 11 } # [11, 12, 13, 14]\n\nptr1.memcmp(ptr2, 4) # => -10\nptr2.memcmp(ptr1, 4) # => 10\nptr1.memcmp(ptr1, 4) # => 0\n```","summary":"<p>Compares <em>count</em> elements from this pointer and <em>other</em>, byte by byte.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Pointer(T)"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(other : Pointer(T), count : Int) : Int32","args_html":"(other : <a href=\"Pointer.html\">Pointer</a>(T), count : <a href=\"Int.html\">Int</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/pointer.cr","line_number":285,"url":null},"def":{"name":"memcmp","args":[{"name":"other","external_name":"other","restriction":"Pointer(T)"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"Int32","visibility":"Public","body":"LibC.memcmp(self.as(::Pointer(Void)), (other.as(::Pointer(Void))), (count * (sizeof(T))))"}},{"html_id":"move_from(source:Pointer(T),count:Int)-instance-method","name":"move_from","doc":"Copies *count* elements from *source* into `self`.\n*source* and `self` may overlap; the copy is always done in a non-destructive manner.\n\n```\nptr1 = Pointer.malloc(4) { |i| i + 1 } # ptr1 -> [1, 2, 3, 4]\nptr2 = ptr1 + 1                        #             ^--------- ptr2\n\n# [1, 2, 3, 4]\n#  ^-----^       <- copy this\n#     ^------^   <- here\nptr2.move_from(ptr1, 3)\n\nptr1[0] # => 1\nptr1[1] # => 1\nptr1[2] # => 2\nptr1[3] # => 3\n```","summary":"<p>Copies <em>count</em> elements from <em>source</em> into <code>self</code>.</p>","abstract":false,"args":[{"name":"source","external_name":"source","restriction":"Pointer(T)"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(source : Pointer(T), count : Int)","args_html":"(source : <a href=\"Pointer.html\">Pointer</a>(T), count : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/pointer.cr","line_number":203,"url":null},"def":{"name":"move_from","args":[{"name":"source","external_name":"source","restriction":"Pointer(T)"},{"name":"count","external_name":"count","restriction":"Int"}],"visibility":"Public","body":"source.move_to(self, count)"}},{"html_id":"move_to(target:Pointer,count:Int)-instance-method","name":"move_to","doc":"Copies *count* elements from `self` into *source*.\n*source* and `self` may overlap; the copy is always done in a non-destructive manner.\n\n```\nptr1 = Pointer.malloc(4) { |i| i + 1 } # ptr1 -> [1, 2, 3, 4]\nptr2 = ptr1 + 1                        #             ^--------- ptr2\n\n# [1, 2, 3, 4]\n#  ^-----^       <- copy this\n#     ^------^   <- here\nptr1.move_to(ptr2, 3)\n\nptr1[0] # => 1\nptr1[1] # => 1\nptr1[2] # => 2\nptr1[3] # => 3\n```","summary":"<p>Copies <em>count</em> elements from <code>self</code> into <em>source</em>.</p>","abstract":false,"args":[{"name":"target","external_name":"target","restriction":"Pointer"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(target : Pointer, count : Int)","args_html":"(target : <a href=\"Pointer.html\">Pointer</a>, count : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/pointer.cr","line_number":233,"url":null},"def":{"name":"move_to","args":[{"name":"target","external_name":"target","restriction":"Pointer"},{"name":"count","external_name":"count","restriction":"Int"}],"visibility":"Public","body":"target.move_from_impl(self, count)"}},{"html_id":"null?:Bool-instance-method","name":"null?","doc":"Returns `true` if this pointer's address is zero.\n\n```\na = 1\npointerof(a).null? # => false\n\nb = Pointer(Int32).new(0)\nb.null? # => true\n```","summary":"<p>Returns <code>true</code> if this pointer's address is zero.</p>","abstract":false,"location":{"filename":"src/pointer.cr","line_number":66,"url":null},"def":{"name":"null?","return_type":"Bool","visibility":"Public","body":"address == 0"}},{"html_id":"realloc(size:UInt64):self-instance-method","name":"realloc","doc":"Tries to change the size of the allocation pointed to by this pointer to *size*,\nand returns that pointer.\n\nSince the space after the end of the block may be in use, realloc may find it\nnecessary to copy the block to a new address where more free space is available.\nThe value of realloc is the new address of the block.\nIf the block needs to be moved, realloc copies the old contents.\n\nRemember to always assign the value of realloc.\n\n```\nptr = Pointer.malloc(4) { |i| i + 1 } # [1, 2, 3, 4]\nptr = ptr.realloc(8_u8)\nptr # [1, 2, 3, 4, 0, 0, 0, 0]\n```","summary":"<p>Tries to change the size of the allocation pointed to by this pointer to <em>size</em>, and returns that pointer.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"UInt64"}],"args_string":"(size : UInt64) : self","args_html":"(size : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":226,"url":null},"def":{"name":"realloc","args":[{"name":"size","external_name":"size","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: pointer_realloc"}},{"html_id":"realloc(size:Int)-instance-method","name":"realloc","doc":"Tries to change the size of the allocation pointed to by this pointer to *size*,\nand returns that pointer.\n\nSince the space after the end of the block may be in use, realloc may find it\nnecessary to copy the block to a new address where more free space is available.\nThe value of realloc is the new address of the block.\nIf the block needs to be moved, realloc copies the old contents.\n\nRemember to always assign the value of realloc.\n\n```\nptr = Pointer.malloc(4) { |i| i + 1 } # [1, 2, 3, 4]\nptr = ptr.realloc(8)\nptr # [1, 2, 3, 4, 0, 0, 0, 0]\n```","summary":"<p>Tries to change the size of the allocation pointed to by this pointer to <em>size</em>, and returns that pointer.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int"}],"args_string":"(size : Int)","args_html":"(size : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/pointer.cr","line_number":348,"url":null},"def":{"name":"realloc","args":[{"name":"size","external_name":"size","restriction":"Int"}],"visibility":"Public","body":"if size < 0\n  raise(ArgumentError.new(\"Negative size\"))\nend\nrealloc(size.to_u64)\n"}},{"html_id":"shuffle!(count:Int,random=Random::DEFAULT)-instance-method","name":"shuffle!","doc":"Shuffles *count* consecutive values pointed by this pointer.\n\n```\nptr = Pointer.malloc(4) { |i| i + 1 } # [1, 2, 3, 4]\nptr.shuffle!(4)\nptr # [3, 4, 1, 2]\n```","summary":"<p>Shuffles <em>count</em> consecutive values pointed by this pointer.</p>","abstract":false,"args":[{"name":"count","external_name":"count","restriction":"Int"},{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(count : Int, random = Random::DEFAULT)","args_html":"(count : <a href=\"Int.html\">Int</a>, random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>)","location":{"filename":"src/pointer.cr","line_number":363,"url":null},"def":{"name":"shuffle!","args":[{"name":"count","external_name":"count","restriction":"Int"},{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"visibility":"Public","body":"(count - 1).downto(1) do |i|\n  j = random.rand(i + 1)\n  swap(i, j)\nend\nself\n"}},{"html_id":"swap(i,j)-instance-method","name":"swap","doc":"Swaps the contents pointed at the offsets *i* and *j*.\n\n```\nptr = Pointer.malloc(4) { |i| i + 1 }\nptr[2] # => 3\nptr[3] # => 4\nptr.swap(2, 3)\nptr[2] # => 4\nptr[3] # => 3\n```","summary":"<p>Swaps the contents pointed at the offsets <em>i</em> and <em>j</em>.</p>","abstract":false,"args":[{"name":"i","external_name":"i","restriction":""},{"name":"j","external_name":"j","restriction":""}],"args_string":"(i, j)","args_html":"(i, j)","location":{"filename":"src/pointer.cr","line_number":299,"url":null},"def":{"name":"swap","args":[{"name":"i","external_name":"i","restriction":""},{"name":"j","external_name":"j","restriction":""}],"visibility":"Public","body":"self[i], self[j] = self[j], self[i]"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a string representation of this pointer to the given `IO`,\nincluding its type and address in hexadecimal.\n\n```\nptr1 = Pointer(Int32).new(1234)\nptr1.to_s # => \"Pointer(Int32)@0x4d2\"\n\nptr2 = Pointer(Int32).new(0)\nptr2.to_s # => \"Pointer(Int32).null\"\n```","summary":"<p>Appends a string representation of this pointer to the given <code><a href=\"IO.html\">IO</a></code>, including its type and address in hexadecimal.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/pointer.cr","line_number":321,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"Pointer(\"\nio << T.to_s\nio << ')'\nif address == 0\n  io << \".null\"\nelse\n  io << \"@0x\"\n  address.to_s(io, 16)\nend\n"}},{"html_id":"to_slice(size):Slice(T)-instance-method","name":"to_slice","doc":"Returns a `Slice` that points to this pointer and is bounded by the given *size*.\n\n```\nptr = Pointer.malloc(6) { |i| i + 10 } # [10, 11, 12, 13, 14, 15]\nslice = ptr.to_slice(4)                # => Slice[10, 11, 12, 13]\nslice.class                            # => Slice(Int32)\n```","summary":"<p>Returns a <code><a href=\"Slice.html\">Slice</a></code> that points to this pointer and is bounded by the given <em>size</em>.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":""}],"args_string":"(size) : Slice(T)","args_html":"(size) : <a href=\"Slice.html\">Slice</a>(T)","location":{"filename":"src/pointer.cr","line_number":494,"url":null},"def":{"name":"to_slice","args":[{"name":"size","external_name":"size","restriction":""}],"return_type":"Slice(T)","visibility":"Public","body":"Slice.new(self, size)"}},{"html_id":"value:T-instance-method","name":"value","doc":"Gets the value pointed by this pointer.\n\n```\nptr = Pointer(Int32).malloc(4)\nptr.value = 42\nptr.value # => 42\n```","summary":"<p>Gets the value pointed by this pointer.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":186,"url":null},"def":{"name":"value","return_type":"T","visibility":"Public","body":"# primitive: pointer_get"}},{"html_id":"value=(value:T)-instance-method","name":"value=","doc":"Sets the value pointed by this pointer.\n\n```\nptr = Pointer(Int32).malloc(4)\nptr.value = 42\nptr.value # => 42\n```","summary":"<p>Sets the value pointed by this pointer.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T)","args_html":"(value : T)","location":{"filename":"src/primitives.cr","line_number":197,"url":null},"def":{"name":"value=","args":[{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"# primitive: pointer_set"}}],"types":[{"html_id":"Crystal/Pointer/Appender","path":"Pointer/Appender.html","kind":"struct","full_name":"Pointer::Appender(T)","name":"Appender","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/pointer.cr","line_number":36,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Pointer","kind":"struct","full_name":"Pointer(T)","name":"Pointer"},"doc":"Unsafe wrapper around a `Pointer` that allows to write values to\nit while advancing the location and keeping track of how many elements\nwere written.\n\nSee also: `Pointer#appender`.","summary":"<p>Unsafe wrapper around a <code><a href=\"../Pointer.html\">Pointer</a></code> that allows to write values to it while advancing the location and keeping track of how many elements were written.</p>","constructors":[{"html_id":"new(pointer:Pointer(T))-class-method","name":"new","abstract":false,"args":[{"name":"pointer","external_name":"pointer","restriction":"Pointer(T)"}],"args_string":"(pointer : Pointer(T))","args_html":"(pointer : <a href=\"../Pointer.html\">Pointer</a>(T))","location":{"filename":"src/pointer.cr","line_number":37,"url":null},"def":{"name":"new","args":[{"name":"pointer","external_name":"pointer","restriction":"Pointer(T)"}],"visibility":"Public","body":"_ = Appender(T).allocate\n_.initialize(pointer)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"<<(value:T)-instance-method","name":"<<","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T)","args_html":"(value : T)","location":{"filename":"src/pointer.cr","line_number":41,"url":null},"def":{"name":"<<","args":[{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"@pointer.value = value\n@pointer = @pointer + 1\n"}},{"html_id":"pointer-instance-method","name":"pointer","abstract":false,"location":{"filename":"src/pointer.cr","line_number":50,"url":null},"def":{"name":"pointer","visibility":"Public","body":"@pointer"}},{"html_id":"size:Int64-instance-method","name":"size","abstract":false,"location":{"filename":"src/pointer.cr","line_number":46,"url":null},"def":{"name":"size","return_type":"Int64","visibility":"Public","body":"@pointer - @start"}}]}]},{"html_id":"Crystal/PrettyPrint","path":"PrettyPrint.html","kind":"class","full_name":"PrettyPrint","name":"PrettyPrint","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/pretty_print.cr","line_number":9,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"This class implements a pretty printing algorithm.\nIt finds line breaks and nice indentations for grouped structure.\n\n### References\n\n* [Ruby's prettyprint.rb](https://github.com/ruby/ruby/blob/master/lib/prettyprint.rb)\n* [Christian Lindig, Strictly Pretty, March 2000](http://citeseerx.ist.psu.edu/viewdoc/summary?doi=10.1.1.34.2200)\n* [Philip Wadler, A prettier printer, March 1998](http://homepages.inf.ed.ac.uk/wadler/topics/language-design.html#prettier)","summary":"<p>This class implements a pretty printing algorithm.</p>","class_methods":[{"html_id":"format(obj,io:IO,width:Int32,newline=\"\\n\",indent=0)-class-method","name":"format","doc":"Pretty prints *obj* into *io* with the given\n*width* as a limit and starting with\nthe given *indent*ation.","summary":"<p>Pretty prints <em>obj</em> into <em>io</em> with the given <em>width</em> as a limit and starting with the given <em>indent</em>ation.</p>","abstract":false,"args":[{"name":"obj","external_name":"obj","restriction":""},{"name":"io","external_name":"io","restriction":"IO"},{"name":"width","external_name":"width","restriction":"Int32"},{"name":"newline","default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","default_value":"0","external_name":"indent","restriction":""}],"args_string":"(obj, io : IO, width : Int32, newline = \"\\n\", indent = 0)","args_html":"(obj, io : <a href=\"IO.html\">IO</a>, width : <a href=\"Int32.html\">Int32</a>, newline = <span class=\"s\">&quot;\\n&quot;</span>, indent = <span class=\"n\">0</span>)","location":{"filename":"src/pretty_print.cr","line_number":293,"url":null},"def":{"name":"format","args":[{"name":"obj","external_name":"obj","restriction":""},{"name":"io","external_name":"io","restriction":"IO"},{"name":"width","external_name":"width","restriction":"Int32"},{"name":"newline","default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","default_value":"0","external_name":"indent","restriction":""}],"visibility":"Public","body":"format(io, width, newline, indent) do |printer|\n  obj.pretty_print(printer)\nend"}},{"html_id":"format(io:IO,width:Int32,newline=\"\\n\",indent=0,&)-class-method","name":"format","doc":"Creates a pretty printer and yields it to the block,\nappending any output to the given *io*.","summary":"<p>Creates a pretty printer and yields it to the block, appending any output to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"width","external_name":"width","restriction":"Int32"},{"name":"newline","default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","default_value":"0","external_name":"indent","restriction":""}],"args_string":"(io : IO, width : Int32, newline = \"\\n\", indent = 0, &)","args_html":"(io : <a href=\"IO.html\">IO</a>, width : <a href=\"Int32.html\">Int32</a>, newline = <span class=\"s\">&quot;\\n&quot;</span>, indent = <span class=\"n\">0</span>, &)","location":{"filename":"src/pretty_print.cr","line_number":301,"url":null},"def":{"name":"format","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"width","external_name":"width","restriction":"Int32"},{"name":"newline","default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","default_value":"0","external_name":"indent","restriction":""}],"yields":1,"visibility":"Public","body":"printer = PrettyPrint.new(io, width, newline, indent)\nyield printer\nprinter.flush\nio\n"}}],"constructors":[{"html_id":"new(output:IO,maxwidth=79,newline=\"\\n\",indent=0)-class-method","name":"new","doc":"Creates a new pretty printer that will write to the given *output*\nand be capped at *maxwidth*.","summary":"<p>Creates a new pretty printer that will write to the given <em>output</em> and be capped at <em>maxwidth</em>.</p>","abstract":false,"args":[{"name":"output","external_name":"output","restriction":"IO"},{"name":"maxwidth","default_value":"79","external_name":"maxwidth","restriction":""},{"name":"newline","default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","default_value":"0","external_name":"indent","restriction":""}],"args_string":"(output : IO, maxwidth = 79, newline = \"\\n\", indent = 0)","args_html":"(output : <a href=\"IO.html\">IO</a>, maxwidth = <span class=\"n\">79</span>, newline = <span class=\"s\">&quot;\\n&quot;</span>, indent = <span class=\"n\">0</span>)","location":{"filename":"src/pretty_print.cr","line_number":16,"url":null},"def":{"name":"new","args":[{"name":"output","external_name":"output","restriction":"IO"},{"name":"maxwidth","default_value":"79","external_name":"maxwidth","restriction":""},{"name":"newline","default_value":"\"\\n\"","external_name":"newline","restriction":""},{"name":"indent","default_value":"0","external_name":"indent","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(output, maxwidth, newline, indent)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"breakable(sep=\"\"):Nil-instance-method","name":"breakable","doc":"Appends an element that can turn into a newline if necessary.","summary":"<p>Appends an element that can turn into a newline if necessary.</p>","abstract":false,"args":[{"name":"sep","default_value":"\" \"","external_name":"sep","restriction":""}],"args_string":"(sep = \" \") : Nil","args_html":"(sep = <span class=\"s\">&quot; &quot;</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/pretty_print.cr","line_number":87,"url":null},"def":{"name":"breakable","args":[{"name":"sep","default_value":"\" \"","external_name":"sep","restriction":""}],"return_type":"Nil","visibility":"Public","body":"width = sep.size\ngroup = @group_stack.last\nif group.break?\n  flush\n  @output << @newline\n  @indent.times do\n    @output << ' '\n  end\n  @output_width = @indent\n  @buffer_width = 0\nelse\n  @buffer << (Breakable.new(sep, width, self))\n  @buffer_width = @buffer_width + width\n  break_outmost_groups\nend\n"}},{"html_id":"comma:Nil-instance-method","name":"comma","doc":"Same as:\n\n```\ntext \",\"\nbreakable\n```","summary":"<p>Same as:</p>","abstract":false,"location":{"filename":"src/pretty_print.cr","line_number":152,"url":null},"def":{"name":"comma","return_type":"Nil","visibility":"Public","body":"text(\",\")\nbreakable\n"}},{"html_id":"fill_breakable(sep=\"\"):Nil-instance-method","name":"fill_breakable","doc":"Similar to `#breakable` except\nthe decision to break or not is determined individually.","summary":"<p>Similar to <code><a href=\"PrettyPrint.html#breakable%28sep%3D%22%22%29%3ANil-instance-method\">#breakable</a></code> except the decision to break or not is determined individually.</p>","abstract":false,"args":[{"name":"sep","default_value":"\" \"","external_name":"sep","restriction":""}],"args_string":"(sep = \" \") : Nil","args_html":"(sep = <span class=\"s\">&quot; &quot;</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/pretty_print.cr","line_number":105,"url":null},"def":{"name":"fill_breakable","args":[{"name":"sep","default_value":"\" \"","external_name":"sep","restriction":""}],"return_type":"Nil","visibility":"Public","body":"group do\n  breakable(sep)\nend"}},{"html_id":"flush:Nil-instance-method","name":"flush","doc":"Outputs any buffered data.","summary":"<p>Outputs any buffered data.</p>","abstract":false,"location":{"filename":"src/pretty_print.cr","line_number":188,"url":null},"def":{"name":"flush","return_type":"Nil","visibility":"Public","body":"@buffer.each do |data|\n  @output_width = data.output(@output, @output_width)\nend\n@buffer.clear\n@buffer_width = 0\n@output.flush\n"}},{"html_id":"group(indent=0,open_obj=\"\",close_obj=\"\",&)-instance-method","name":"group","doc":"Creates a group of objects. Inside a group all breakable\nobjects are either turned into newlines or are output\nas is, depending on the available width.","summary":"<p>Creates a group of objects.</p>","abstract":false,"args":[{"name":"indent","default_value":"0","external_name":"indent","restriction":""},{"name":"open_obj","default_value":"\"\"","external_name":"open_obj","restriction":""},{"name":"close_obj","default_value":"\"\"","external_name":"close_obj","restriction":""}],"args_string":"(indent = 0, open_obj = \"\", close_obj = \"\", &)","args_html":"(indent = <span class=\"n\">0</span>, open_obj = <span class=\"s\">&quot;&quot;</span>, close_obj = <span class=\"s\">&quot;&quot;</span>, &)","location":{"filename":"src/pretty_print.cr","line_number":112,"url":null},"def":{"name":"group","args":[{"name":"indent","default_value":"0","external_name":"indent","restriction":""},{"name":"open_obj","default_value":"\"\"","external_name":"open_obj","restriction":""},{"name":"close_obj","default_value":"\"\"","external_name":"close_obj","restriction":""}],"yields":0,"visibility":"Public","body":"text(open_obj)\ngroup_sub do\n  nest(indent) do\n    yield\n  end\nend\ntext(close_obj)\n"}},{"html_id":"list(left,elements,right,&):Nil-instance-method","name":"list","doc":"Appends a list of elements surrounded by *left* and *right*\nand separated by commas, yielding each element to the given block.","summary":"<p>Appends a list of elements surrounded by <em>left</em> and <em>right</em> and separated by commas, yielding each element to the given block.</p>","abstract":false,"args":[{"name":"left","external_name":"left","restriction":""},{"name":"elements","external_name":"elements","restriction":""},{"name":"right","external_name":"right","restriction":""}],"args_string":"(left, elements, right, &) : Nil","args_html":"(left, elements, right, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/pretty_print.cr","line_number":170,"url":null},"def":{"name":"list","args":[{"name":"left","external_name":"left","restriction":""},{"name":"elements","external_name":"elements","restriction":""},{"name":"right","external_name":"right","restriction":""}],"yields":1,"return_type":"Nil","visibility":"Public","body":"group(1, left, right) do\n  elements.each_with_index do |elem, i|\n    if i > 0\n      comma\n    end\n    yield elem\n  end\nend"}},{"html_id":"list(left,elements,right):Nil-instance-method","name":"list","doc":"Appends a list of elements surrounded by *left* and *right*\nand separated by commas.","summary":"<p>Appends a list of elements surrounded by <em>left</em> and <em>right</em> and separated by commas.</p>","abstract":false,"args":[{"name":"left","external_name":"left","restriction":""},{"name":"elements","external_name":"elements","restriction":""},{"name":"right","external_name":"right","restriction":""}],"args_string":"(left, elements, right) : Nil","args_html":"(left, elements, right) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/pretty_print.cr","line_number":181,"url":null},"def":{"name":"list","args":[{"name":"left","external_name":"left","restriction":""},{"name":"elements","external_name":"elements","restriction":""},{"name":"right","external_name":"right","restriction":""}],"return_type":"Nil","visibility":"Public","body":"list(left, elements, right) do |elem|\n  elem.pretty_print(self)\nend"}},{"html_id":"nest(indent=1,&)-instance-method","name":"nest","doc":"Increases the indentation for breakables inside the current group.","summary":"<p>Increases the indentation for breakables inside the current group.</p>","abstract":false,"args":[{"name":"indent","default_value":"1","external_name":"indent","restriction":""}],"args_string":"(indent = 1, &)","args_html":"(indent = <span class=\"n\">1</span>, &)","location":{"filename":"src/pretty_print.cr","line_number":137,"url":null},"def":{"name":"nest","args":[{"name":"indent","default_value":"1","external_name":"indent","restriction":""}],"yields":0,"visibility":"Public","body":"@indent = @indent + indent\nbegin\n  yield\nensure\n  @indent = @indent - indent\nend\n"}},{"html_id":"surround(left,right,left_break=\"\",right_break=\"\",&):Nil-instance-method","name":"surround","doc":"Appends a group that is surrounded by the given *left* and *right*\nobjects, and optionally is surrounded by the given breakable\nobjects.","summary":"<p>Appends a group that is surrounded by the given <em>left</em> and <em>right</em> objects, and optionally is surrounded by the given breakable objects.</p>","abstract":false,"args":[{"name":"left","external_name":"left","restriction":""},{"name":"right","external_name":"right","restriction":""},{"name":"left_break","default_value":"\"\"","external_name":"left_break","restriction":""},{"name":"right_break","default_value":"\"\"","external_name":"right_break","restriction":""}],"args_string":"(left, right, left_break = \"\", right_break = \"\", &) : Nil","args_html":"(left, right, left_break = <span class=\"s\">&quot;&quot;</span>, right_break = <span class=\"s\">&quot;&quot;</span>, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/pretty_print.cr","line_number":160,"url":null},"def":{"name":"surround","args":[{"name":"left","external_name":"left","restriction":""},{"name":"right","external_name":"right","restriction":""},{"name":"left_break","default_value":"\"\"","external_name":"left_break","restriction":""},{"name":"right_break","default_value":"\"\"","external_name":"right_break","restriction":""}],"yields":0,"return_type":"Nil","visibility":"Public","body":"group(1, left, right) do\n  if left_break\n    breakable(left_break)\n  end\n  yield\n  if right_break\n    breakable(right_break)\n  end\nend"}},{"html_id":"text(obj):Nil-instance-method","name":"text","doc":"Appends a text element.","summary":"<p>Appends a text element.</p>","abstract":false,"args":[{"name":"obj","external_name":"obj","restriction":""}],"args_string":"(obj) : Nil","args_html":"(obj) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/pretty_print.cr","line_number":66,"url":null},"def":{"name":"text","args":[{"name":"obj","external_name":"obj","restriction":""}],"return_type":"Nil","visibility":"Public","body":"obj = obj.to_s\nwidth = obj.size\nif width == 0\n  return\nend\nif @buffer.empty?\n  @output << obj\n  @output_width = @output_width + width\nelse\n  text = @buffer.last\n  if text.is_a?(Text)\n  else\n    text = Text.new\n    @buffer << text\n  end\n  text.add(obj, width)\n  @buffer_width = @buffer_width + width\n  break_outmost_groups\nend\n"}}]},{"html_id":"Crystal/Proc","path":"Proc.html","kind":"struct","full_name":"Proc(*T, R)","name":"Proc","abstract":false,"superclass":{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/primitives.cr","line_number":257,"url":null},{"filename":"src/proc.cr","line_number":102,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"A `Proc` represents a function pointer with an optional context (the closure data).\nIt is typically created with a proc literal:\n\n```\n# A proc without arguments\n->{ 1 } # Proc(Int32)\n\n# A proc with one argument\n->(x : Int32) { x.to_s } # Proc(Int32, String)\n\n# A proc with two arguments:\n->(x : Int32, y : Int32) { x + y } # Proc(Int32, Int32, Int32)\n```\n\nSee [`Proc` literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/proc.html) in the language reference.\n\nThe types of the arguments (`T`) are mandatory, except when directly\nsending a proc literal to a lib fun in C bindings.\n\nThe return type (`R`) is inferred from the proc's body.\n\nA special new method is provided too:\n\n```\nProc(Int32, String).new { |x| x.to_s } # Proc(Int32, String)\n```\n\nThis form allows you to specify the return type and to check it\nagainst the proc's body.\n\nAnother way to create a `Proc` is by capturing a block:\n\n```\ndef capture(&block : Int32 -> Int32)\n  # block argument is used, so block is turned into a Proc\n  block\nend\n\nproc = capture { |x| x + 1 } # Proc(Int32, Int32)\nproc.call(1)                 # => 2\n```\n\nWhen capturing blocks, the type of the arguments and return type\nmust be specified in the capturing method block signature.\n\n### Passing a Proc to a C function\n\nPassing a `Proc` to a C function, for example as a callback, is possible\nas long as the `Proc` isn't a closure. If it is, either a compile-time or\nruntime error will happen depending on whether the compiler can check this.\nThe reason is that a `Proc` is internally represented as two void pointers,\none having the function pointer and another the closure data. If just\nthe function pointer is passed, the closure data will be missing at invocation time.\n\nMost of the time a C function that allows setting a callback also provide\nan argument for custom data. This custom data is then sent as an argument\nto the callback. For example, suppose a C function that invokes a callback\nat every tick, passing that tick:\n\n```\nlib LibTicker\n  fun on_tick(callback : (Int32, Void* ->), data : Void*)\nend\n```\n\nTo properly define a wrapper for this function we must send the `Proc` as the\ncallback data, and then convert that callback data to the `Proc` and finally invoke it.\n\n```\nmodule Ticker\n  # The callback for the user doesn't have a Void*\n  @@box : Pointer(Void)?\n\n  def self.on_tick(&callback : Int32 ->)\n    # Since Proc is a {Void*, Void*}, we can't turn that into a Void*, so we\n    # \"box\" it: we allocate memory and store the Proc there\n    boxed_data = Box.box(callback)\n\n    # We must save this in Crystal-land so the GC doesn't collect it (*)\n    @@box = boxed_data\n\n    # We pass a callback that doesn't form a closure, and pass the boxed_data as\n    # the callback data\n    LibTicker.on_tick(->(tick, data) {\n      # Now we turn data back into the Proc, using Box.unbox\n      data_as_callback = Box(typeof(callback)).unbox(data)\n      # And finally invoke the user's callback\n      data_as_callback.call(tick)\n    }, boxed_data)\n  end\nend\n\nTicker.on_tick do |tick|\n  puts tick\nend\n```\n\nNote that we save the box in `@@box`. The reason is that if we don't do it,\nand our code doesn't reference it anymore, the GC will collect it.\nThe C library will of course store the callback, but Crystal's GC has\nno way of knowing that.","summary":"<p>A <code><a href=\"Proc.html\">Proc</a></code> represents a function pointer with an optional context (the closure data).</p>","constructors":[{"html_id":"new(pointer:Pointer(Void),closure_data:Pointer(Void))-class-method","name":"new","abstract":false,"args":[{"name":"pointer","external_name":"pointer","restriction":"::Pointer(Void)"},{"name":"closure_data","external_name":"closure_data","restriction":"::Pointer(Void)"}],"args_string":"(pointer : Pointer(Void), closure_data : Pointer(Void))","args_html":"(pointer : <a href=\"Pointer.html\">Pointer</a>(Void), closure_data : <a href=\"Pointer.html\">Pointer</a>(Void))","location":{"filename":"src/proc.cr","line_number":103,"url":null},"def":{"name":"new","args":[{"name":"pointer","external_name":"pointer","restriction":"::Pointer(Void)"},{"name":"closure_data","external_name":"closure_data","restriction":"::Pointer(Void)"}],"visibility":"Public","body":"func = {pointer, closure_data}\nptr = (pointerof(func)).as(::Pointer(self))\nptr.value\n"}},{"html_id":"new(&block:self)-class-method","name":"new","doc":"Creates a `Proc` by capturing the given *block*.\n\nThe block argument types are inferred from the `Proc`'s type arguments. The\nreturn type of the block must match the return type specified in the `Proc`\ntype.\n\n```\ngt = Proc(Int32, Int32, Bool).new do |x, y|\n  x > y\nend\ngt.call(3, 1) # => true\ngt.call(1, 2) # => false\n```","summary":"<p>Creates a <code><a href=\"Proc.html\">Proc</a></code> by capturing the given <em>block</em>.</p>","abstract":false,"location":{"filename":"src/proc.cr","line_number":122,"url":null},"def":{"name":"new","yields":0,"block_arg":{"name":"block","external_name":"block","restriction":"self"},"visibility":"Public","body":"block"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/proc.cr","line_number":191,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"(pointer == other.pointer) && (closure_data == other.closure_data)"}},{"html_id":"===(other:self)-instance-method","name":"===","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/proc.cr","line_number":195,"url":null},"def":{"name":"===","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"self == other"}},{"html_id":"===(other)-instance-method","name":"===","doc":"Case equality.\n\nThe `===` method is used in a `case ... when ... end` expression.\n\nFor example, this code:\n\n```\ncase value\nwhen x\n  # something when x\nwhen y\n  # something when y\nend\n```\n\nIs equivalent to this code:\n\n```\nif x === value\n  # something when x\nelsif y === value\n  # something when y\nend\n```\n\nObject simply implements `===` by invoking `==`, but subclasses\n(notably `Regex`) can override it to provide meaningful case-equality semantics.","summary":"<p>Case equality.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/proc.cr","line_number":199,"url":null},"def":{"name":"===","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"call(other)"}},{"html_id":"arity-instance-method","name":"arity","doc":"Returns the number of arguments of this `Proc`.\n\n```\nadd = ->(x : Int32, y : Int32) { x + y }\nadd.arity # => 2\n\nneg = ->(x : Int32) { -x }\nneg.arity # => 1\n```","summary":"<p>Returns the number of arguments of this <code><a href=\"Proc.html\">Proc</a></code>.</p>","abstract":false,"location":{"filename":"src/proc.cr","line_number":169,"url":null},"def":{"name":"arity","visibility":"Public","body":"{{ T.size }}"}},{"html_id":"call(*args:*T):R-instance-method","name":"call","doc":"Invokes this `Proc` and returns the result.\n\n```\nadd = ->(x : Int32, y : Int32) { x + y }\nadd.call(1, 2) # => 3\n```","summary":"<p>Invokes this <code><a href=\"Proc.html\">Proc</a></code> and returns the result.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":"*T"}],"args_string":"(*args : *T) : R","args_html":"(*args : <span class=\"o\">*</span><span class=\"t\">T</span>) : R","location":{"filename":"src/primitives.cr","line_number":266,"url":null},"def":{"name":"call","args":[{"name":"args","external_name":"args","restriction":"*T"}],"splat_index":0,"return_type":"R","visibility":"Public","body":"# primitive: proc_call"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/proc.cr","line_number":208,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"closure?:Bool-instance-method","name":"closure?","abstract":false,"location":{"filename":"src/proc.cr","line_number":181,"url":null},"def":{"name":"closure?","return_type":"Bool","visibility":"Public","body":"!closure_data.null?"}},{"html_id":"closure_data:Pointer(Void)-instance-method","name":"closure_data","abstract":false,"location":{"filename":"src/proc.cr","line_number":177,"url":null},"def":{"name":"closure_data","return_type":"::Pointer(Void)","visibility":"Public","body":"internal_representation[1]"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/proc.cr","line_number":204,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"internal_representation.hash(hasher)"}},{"html_id":"partial(*args:*U)forallU-instance-method","name":"partial","doc":"Returns a new `Proc` that has its first arguments fixed to\nthe values given by *args*.\n\nSee [Wikipedia, Partial application](https://en.wikipedia.org/wiki/Partial_application)\n\n```\nadd = ->(x : Int32, y : Int32) { x + y }\nadd.call(1, 2) # => 3\n\nadd_one = add.partial(1)\nadd_one.call(2)  # => 3\nadd_one.call(10) # => 11\n\nadd_one_and_two = add_one.partial(2)\nadd_one_and_two.call # => 3\n```","summary":"<p>Returns a new <code><a href=\"Proc.html\">Proc</a></code> that has its first arguments fixed to the values given by <em>args</em>.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":"*U"}],"args_string":"(*args : *U) forall U","args_html":"(*args : <span class=\"o\">*</span><span class=\"t\">U</span>) forall U","location":{"filename":"src/proc.cr","line_number":142,"url":null},"def":{"name":"partial","args":[{"name":"args","external_name":"args","restriction":"*U"}],"splat_index":0,"visibility":"Public","body":"{% if true %}\n      {% remaining = (T.size - U.size) %}\n      ->(\n          {% for i in 0...remaining %}\n            arg{{ i }} : {{ T[i + U.size] }},\n          {% end %}\n        ) {\n        call(\n          *args,\n          {% for i in 0...remaining %}\n            arg{{ i }},\n          {% end %}\n        )\n      }\n    {% end %}"}},{"html_id":"pointer:Pointer(Void)-instance-method","name":"pointer","abstract":false,"location":{"filename":"src/proc.cr","line_number":173,"url":null},"def":{"name":"pointer","return_type":"::Pointer(Void)","visibility":"Public","body":"internal_representation[0]"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a `String` representation of this object\nto the given `IO` object.\n\nAn object must never append itself to the io argument,\nas this will in turn call `to_s(io)` on it.","summary":"<p>Appends a <code><a href=\"String.html\">String</a></code> representation of this object to the given <code><a href=\"IO.html\">IO</a></code> object.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/proc.cr","line_number":212,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"#<\"\nio << ({{ @type.name.stringify }})\nio << \":0x\"\npointer.address.to_s(io, 16)\nif closure?\n  io << \":closure\"\nend\nio << '>'\nnil\n"}}]},{"html_id":"Crystal/Process","path":"Process.html","kind":"class","full_name":"Process","name":"Process","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/kernel.cr","line_number":505,"url":null},{"filename":"src/process.cr","line_number":1,"url":null},{"filename":"src/process.cr","line_number":14,"url":null},{"filename":"src/process/executable_path.cr","line_number":5,"url":null},{"filename":"src/process/executable_path.cr","line_number":103,"url":null},{"filename":"src/process/shell.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"PATH_DELIMITER","name":"PATH_DELIMITER","value":"{% if flag?(:windows) %} ';' {% else %} ':' {% end %}"}],"class_methods":[{"html_id":"chroot(path:String):Nil-class-method","name":"chroot","doc":"Changes the root directory and the current working directory for the current\nprocess.\n\nAvailable only on Unix-like operating systems.\n\nSecurity: `chroot` on its own is not an effective means of mitigation. At minimum\nthe process needs to also drop privileges as soon as feasible after the `chroot`.\nChanges to the directory hierarchy or file descriptors passed via `recvmsg(2)` from\noutside the `chroot` jail may allow a restricted process to escape, even if it is\nunprivileged.\n\n```\nProcess.chroot(\"/var/empty\")\n```","summary":"<p>Changes the root directory and the current working directory for the current process.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"String"}],"args_string":"(path : String) : Nil","args_html":"(path : <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/process.cr","line_number":388,"url":null},"def":{"name":"chroot","args":[{"name":"path","external_name":"path","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"Crystal::System::Process.chroot(path)"}},{"html_id":"exec(command:String,args=nil,env:Env=nil,clear_env:Bool=false,shell:Bool=false,input:ExecStdio=Redirect::Inherit,output:ExecStdio=Redirect::Inherit,error:ExecStdio=Redirect::Inherit,chdir:String?=nil):NoReturn-class-method","name":"exec","doc":"Replaces the current process with a new one. This function never returns.\n\nAvailable only on Unix-like operating systems.\n\nRaises `IO::Error` if executing the command fails (for example if the executable doesn't exist).","summary":"<p>Replaces the current process with a new one.</p>","abstract":false,"args":[{"name":"command","external_name":"command","restriction":"String"},{"name":"args","default_value":"nil","external_name":"args","restriction":""},{"name":"env","default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","default_value":"Redirect::Inherit","external_name":"input","restriction":"ExecStdio"},{"name":"output","default_value":"Redirect::Inherit","external_name":"output","restriction":"ExecStdio"},{"name":"error","default_value":"Redirect::Inherit","external_name":"error","restriction":"ExecStdio"},{"name":"chdir","default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"args_string":"(command : String, args = nil, env : Env = nil, clear_env : Bool = false, shell : Bool = false, input : ExecStdio = Redirect::Inherit, output : ExecStdio = Redirect::Inherit, error : ExecStdio = Redirect::Inherit, chdir : String? = nil) : NoReturn","args_html":"(command : <a href=\"String.html\">String</a>, args = <span class=\"n\">nil</span>, env : <a href=\"Process/Env.html\">Env</a> = <span class=\"n\">nil</span>, clear_env : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, shell : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, input : <a href=\"Process/ExecStdio.html\">ExecStdio</a> = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Inherit</span>, output : <a href=\"Process/ExecStdio.html\">ExecStdio</a> = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Inherit</span>, error : <a href=\"Process/ExecStdio.html\">ExecStdio</a> = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Inherit</span>, chdir : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>) : NoReturn","location":{"filename":"src/process.cr","line_number":156,"url":null},"def":{"name":"exec","args":[{"name":"command","external_name":"command","restriction":"String"},{"name":"args","default_value":"nil","external_name":"args","restriction":""},{"name":"env","default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","default_value":"Redirect::Inherit","external_name":"input","restriction":"ExecStdio"},{"name":"output","default_value":"Redirect::Inherit","external_name":"output","restriction":"ExecStdio"},{"name":"error","default_value":"Redirect::Inherit","external_name":"error","restriction":"ExecStdio"},{"name":"chdir","default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"return_type":"NoReturn","visibility":"Public","body":"command_args = Crystal::System::Process.prepare_args(command, args, shell)\ninput = exec_stdio_to_fd(input, for: STDIN)\noutput = exec_stdio_to_fd(output, for: STDOUT)\nerror = exec_stdio_to_fd(error, for: STDERR)\nCrystal::System::Process.replace(command_args, env, clear_env, input, output, error, chdir)\n"}},{"html_id":"executable_path:String?-class-method","name":"executable_path","doc":"Returns an absolute path to the executable file of the currently running\nprogram. This is in opposition to `PROGRAM_NAME` which may be a relative or\nabsolute path, just the executable file name or a symlink.\n\nThe executable path will be canonicalized (all symlinks and relative paths\nwill be expanded).\n\nReturns `nil` if the file can't be found.","summary":"<p>Returns an absolute path to the executable file of the currently running program.</p>","abstract":false,"location":{"filename":"src/process/executable_path.cr","line_number":31,"url":null},"def":{"name":"executable_path","return_type":"String | ::Nil","visibility":"Public","body":"if executable = executable_path_impl\n  begin\n    File.real_path(executable)\n  rescue File::Error\n  end\nend"}},{"html_id":"exists?(pid:Int):Bool-class-method","name":"exists?","doc":"Returns `true` if the process identified by *pid* is valid for\na currently registered process, `false` otherwise. Note that this\nreturns `true` for a process in the zombie or similar state.","summary":"<p>Returns <code>true</code> if the process identified by <em>pid</em> is valid for a currently registered process, <code>false</code> otherwise.</p>","abstract":false,"args":[{"name":"pid","external_name":"pid","restriction":"Int"}],"args_string":"(pid : Int) : Bool","args_html":"(pid : <a href=\"Int.html\">Int</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/process.cr","line_number":52,"url":null},"def":{"name":"exists?","args":[{"name":"pid","external_name":"pid","restriction":"Int"}],"return_type":"Bool","visibility":"Public","body":"Crystal::System::Process.exists?(pid)"}},{"html_id":"exit(status=0):NoReturn-class-method","name":"exit","doc":"Terminate the current process immediately. All open files, pipes and sockets\nare flushed and closed, all child processes are inherited by PID 1. This does\nnot run any handlers registered with `at_exit`, use `::exit` for that.\n\n*status* is the exit status of the current process.","summary":"<p>Terminate the current process immediately.</p>","abstract":false,"args":[{"name":"status","default_value":"0","external_name":"status","restriction":""}],"args_string":"(status = 0) : NoReturn","args_html":"(status = <span class=\"n\">0</span>) : NoReturn","location":{"filename":"src/process.cr","line_number":20,"url":null},"def":{"name":"exit","args":[{"name":"status","default_value":"0","external_name":"status","restriction":""}],"return_type":"NoReturn","visibility":"Public","body":"Crystal::System::Process.exit(status)"}},{"html_id":"find_executable(name:Path|String,path:String?=ENV[\"PATH\"]?,pwd:Path|String=Dir.current):String?-class-method","name":"find_executable","doc":"Searches an executable, checking for an absolute path, a path relative to\n*pwd* or absolute path, then eventually searching in directories declared\nin *path*.","summary":"<p>Searches an executable, checking for an absolute path, a path relative to <em>pwd</em> or absolute path, then eventually searching in directories declared in <em>path</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"Path | String"},{"name":"path","default_value":"ENV[\"PATH\"]?","external_name":"path","restriction":"String | ::Nil"},{"name":"pwd","default_value":"Dir.current","external_name":"pwd","restriction":"Path | String"}],"args_string":"(name : Path | String, path : String? = ENV[\"PATH\"]?, pwd : Path | String = Dir.current) : String?","args_html":"(name : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a>, path : <a href=\"String.html\">String</a>? = <span class=\"t\">ENV</span>[<span class=\"s\">&quot;PATH&quot;</span>]?, pwd : <a href=\"Path.html\">Path</a> | <a href=\"String.html\">String</a> = <span class=\"t\">Dir</span>.current) : <a href=\"String.html\">String</a>?","location":{"filename":"src/process/executable_path.cr","line_number":56,"url":null},"def":{"name":"find_executable","args":[{"name":"name","external_name":"name","restriction":"Path | String"},{"name":"path","default_value":"ENV[\"PATH\"]?","external_name":"path","restriction":"String | ::Nil"},{"name":"pwd","default_value":"Dir.current","external_name":"pwd","restriction":"Path | String"}],"return_type":"String | ::Nil","visibility":"Public","body":"find_executable_possibilities(Path.new(name), path, pwd) do |p|\n  if is_executable_file?(p)\n    return p.to_s\n  end\nend\nnil\n"}},{"html_id":"parse_arguments(line:String):Array(String)-class-method","name":"parse_arguments","doc":"Split a *line* string into the array of tokens in the same way the POSIX shell.\n\n```\nProcess.parse_arguments(%q[\"foo bar\" '\\hello/' Fizz\\ Buzz]) # => [\"foo bar\", \"\\\\hello/\", \"Fizz Buzz\"]\n```\n\nSee https://pubs.opengroup.org/onlinepubs/009695399/utilities/xcu_chap02.html#tag_02_03","summary":"<p>Split a <em>line</em> string into the array of tokens in the same way the POSIX shell.</p>","abstract":false,"args":[{"name":"line","external_name":"line","restriction":"String"}],"args_string":"(line : String) : Array(String)","args_html":"(line : <a href=\"String.html\">String</a>) : <a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)","location":{"filename":"src/process/shell.cr","line_number":113,"url":null},"def":{"name":"parse_arguments","args":[{"name":"line","external_name":"line","restriction":"String"}],"return_type":"Array(String)","visibility":"Public","body":"tokens = [] of String\nreader = Char::Reader.new(line)\nwhile reader.has_next?\n  while reader.current_char.ascii_whitespace?\n    reader.next_char\n  end\n  if reader.has_next?\n  else\n    break\n  end\n  token = String.build do |str|\n    while reader.has_next? && (!reader.current_char.ascii_whitespace?)\n      quote = nil\n      if reader.current_char.in?('\\'', '\"')\n        quote = reader.current_char\n        reader.next_char\n      end\n      while !(((char = reader.current_char) == quote) || ((!quote) && (char.ascii_whitespace? || (char.in?('\\'', '\"')))))\n        if reader.has_next?\n        else\n          break\n        end\n        reader.next_char\n        if (char == '\\\\') && (quote != '\\'')\n          if quote == '\"'\n            str << char\n          end\n          char = reader.current_char\n          if reader.has_next?\n            reader.next_char\n          else\n            if quote == '\"'\n              break\n            end\n            char = '\\\\'\n          end\n        end\n        str << char\n      end\n      if quote\n        if reader.has_next?\n        else\n          raise(ArgumentError.new(\"Unmatched quote\"))\n        end\n        reader.next_char\n      end\n    end\n  end\n  tokens << token\nend\ntokens\n"}},{"html_id":"pgid(pid:Int):Int64-class-method","name":"pgid","doc":"Returns the process group identifier of the process identified by *pid*.","summary":"<p>Returns the process group identifier of the process identified by <em>pid</em>.</p>","abstract":false,"args":[{"name":"pid","external_name":"pid","restriction":"Int"}],"args_string":"(pid : Int) : Int64","args_html":"(pid : <a href=\"Int.html\">Int</a>) : <a href=\"Int64.html\">Int64</a>","location":{"filename":"src/process.cr","line_number":35,"url":null},"def":{"name":"pgid","args":[{"name":"pid","external_name":"pid","restriction":"Int"}],"return_type":"Int64","visibility":"Public","body":"(Crystal::System::Process.pgid(pid)).to_i64"}},{"html_id":"pgid:Int64-class-method","name":"pgid","doc":"Returns the process group identifier of the current process.","summary":"<p>Returns the process group identifier of the current process.</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":30,"url":null},"def":{"name":"pgid","return_type":"Int64","visibility":"Public","body":"Crystal::System::Process.pgid.to_i64"}},{"html_id":"pid:Int64-class-method","name":"pid","doc":"Returns the process identifier of the current process.","summary":"<p>Returns the process identifier of the current process.</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":25,"url":null},"def":{"name":"pid","return_type":"Int64","visibility":"Public","body":"Crystal::System::Process.pid.to_i64"}},{"html_id":"ppid:Int64-class-method","name":"ppid","doc":"Returns the process identifier of the parent process of the current process.","summary":"<p>Returns the process identifier of the parent process of the current process.</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":40,"url":null},"def":{"name":"ppid","return_type":"Int64","visibility":"Public","body":"Crystal::System::Process.ppid.to_i64"}},{"html_id":"quote(args:Enumerable(String)):String-class-method","name":"quote","doc":"Converts a sequence of strings to one joined string with each argument shell-quoted.\n\nThis is then safe to pass as part of the command when using `shell: true` or `system()`.\n\nNOTE: The actual return value is system-dependent, so it mustn't be relied on in other contexts.\nSee also: `quote_posix`.\n\n```\nfiles = [\"my file.txt\", \"another.txt\"]\n`grep -E 'fo+' -- #{Process.quote(files)}`\n```","summary":"<p>Converts a sequence of strings to one joined string with each argument shell-quoted.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":"Enumerable(String)"}],"args_string":"(args : Enumerable(String)) : String","args_html":"(args : <a href=\"Enumerable.html\">Enumerable</a>(<a href=\"String.html\">String</a>)) : <a href=\"String.html\">String</a>","location":{"filename":"src/process/shell.cr","line_number":13,"url":null},"def":{"name":"quote","args":[{"name":"args","external_name":"args","restriction":"Enumerable(String)"}],"return_type":"String","visibility":"Public","body":"{% if flag?(:win32) %}\n      quote_windows(args)\n    {% else %}\n      quote_posix(args)\n    {% end %}"}},{"html_id":"quote(arg:String):String-class-method","name":"quote","doc":"Shell-quotes one item, same as `quote({arg})`.","summary":"<p>Shell-quotes one item, same as <code><a href=\"Process.html#quote%28args%3AEnumerable%28String%29%29%3AString-class-method\">.quote({arg})</a></code>.</p>","abstract":false,"args":[{"name":"arg","external_name":"arg","restriction":"String"}],"args_string":"(arg : String) : String","args_html":"(arg : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/process/shell.cr","line_number":22,"url":null},"def":{"name":"quote","args":[{"name":"arg","external_name":"arg","restriction":"String"}],"return_type":"String","visibility":"Public","body":"quote({arg})"}},{"html_id":"quote_posix(args:Enumerable(String)):String-class-method","name":"quote_posix","doc":"Converts a sequence of strings to one joined string with each argument shell-quoted.\n\nThis is then safe to pass to a POSIX shell.\n\n```\nfiles = [\"my file.txt\", \"another.txt\"]\nProcess.quote_posix(files) # => \"'my file.txt' another.txt\"\n```","summary":"<p>Converts a sequence of strings to one joined string with each argument shell-quoted.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":"Enumerable(String)"}],"args_string":"(args : Enumerable(String)) : String","args_html":"(args : <a href=\"Enumerable.html\">Enumerable</a>(<a href=\"String.html\">String</a>)) : <a href=\"String.html\">String</a>","location":{"filename":"src/process/shell.cr","line_number":34,"url":null},"def":{"name":"quote_posix","args":[{"name":"args","external_name":"args","restriction":"Enumerable(String)"}],"return_type":"String","visibility":"Public","body":"args.join(' ') do |arg|\n  if arg.empty?\n    \"''\"\n  else\n    if arg.matches?(/[^a-zA-Z0-9%+,\\-.\\/:=@_]/)\n      (\"'\" + (arg.gsub(\"'\", \"'\\\"'\\\"'\"))) + \"'\"\n    else\n      arg\n    end\n  end\nend"}},{"html_id":"quote_posix(arg:String):String-class-method","name":"quote_posix","doc":"Shell-quotes one item, same as `quote_posix({arg})`.","summary":"<p>Shell-quotes one item, same as <code><a href=\"Process.html#quote_posix%28args%3AEnumerable%28String%29%29%3AString-class-method\">.quote_posix({arg})</a></code>.</p>","abstract":false,"args":[{"name":"arg","external_name":"arg","restriction":"String"}],"args_string":"(arg : String) : String","args_html":"(arg : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/process/shell.cr","line_number":47,"url":null},"def":{"name":"quote_posix","args":[{"name":"arg","external_name":"arg","restriction":"String"}],"return_type":"String","visibility":"Public","body":"quote_posix({arg})"}},{"html_id":"run(command:String,args=nil,env:Env=nil,clear_env:Bool=false,shell:Bool=false,input:Stdio=Redirect::Close,output:Stdio=Redirect::Close,error:Stdio=Redirect::Close,chdir:String?=nil):Process::Status-class-method","name":"run","doc":"Executes a process and waits for it to complete.\n\nBy default the process is configured without input, output or error.\n\nRaises `IO::Error` if executing the command fails (for example if the executable doesn't exist).","summary":"<p>Executes a process and waits for it to complete.</p>","abstract":false,"args":[{"name":"command","external_name":"command","restriction":"String"},{"name":"args","default_value":"nil","external_name":"args","restriction":""},{"name":"env","default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","default_value":"Redirect::Close","external_name":"input","restriction":"Stdio"},{"name":"output","default_value":"Redirect::Close","external_name":"output","restriction":"Stdio"},{"name":"error","default_value":"Redirect::Close","external_name":"error","restriction":"Stdio"},{"name":"chdir","default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"args_string":"(command : String, args = nil, env : Env = nil, clear_env : Bool = false, shell : Bool = false, input : Stdio = Redirect::Close, output : Stdio = Redirect::Close, error : Stdio = Redirect::Close, chdir : String? = nil) : Process::Status","args_html":"(command : <a href=\"String.html\">String</a>, args = <span class=\"n\">nil</span>, env : <a href=\"Process/Env.html\">Env</a> = <span class=\"n\">nil</span>, clear_env : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, shell : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, input : <a href=\"Process/Stdio.html\">Stdio</a> = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Close</span>, output : <a href=\"Process/Stdio.html\">Stdio</a> = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Close</span>, error : <a href=\"Process/Stdio.html\">Stdio</a> = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Close</span>, chdir : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>) : <a href=\"Process/Status.html\">Process::Status</a>","location":{"filename":"src/process.cr","line_number":123,"url":null},"def":{"name":"run","args":[{"name":"command","external_name":"command","restriction":"String"},{"name":"args","default_value":"nil","external_name":"args","restriction":""},{"name":"env","default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","default_value":"Redirect::Close","external_name":"input","restriction":"Stdio"},{"name":"output","default_value":"Redirect::Close","external_name":"output","restriction":"Stdio"},{"name":"error","default_value":"Redirect::Close","external_name":"error","restriction":"Stdio"},{"name":"chdir","default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"return_type":"Process::Status","visibility":"Public","body":"status = (new(command, args, env, clear_env, shell, input, output, error, chdir)).wait\n$? = status\nstatus\n"}},{"html_id":"run(command:String,args=nil,env:Env=nil,clear_env:Bool=false,shell:Bool=false,input:Stdio=Redirect::Pipe,output:Stdio=Redirect::Pipe,error:Stdio=Redirect::Pipe,chdir:String?=nil,&)-class-method","name":"run","doc":"Executes a process, yields the block, and then waits for it to finish.\n\nBy default the process is configured to use pipes for input, output and error. These\nwill be closed automatically at the end of the block.\n\nReturns the block's value.\n\nRaises `IO::Error` if executing the command fails (for example if the executable doesn't exist).","summary":"<p>Executes a process, yields the block, and then waits for it to finish.</p>","abstract":false,"args":[{"name":"command","external_name":"command","restriction":"String"},{"name":"args","default_value":"nil","external_name":"args","restriction":""},{"name":"env","default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","default_value":"Redirect::Pipe","external_name":"input","restriction":"Stdio"},{"name":"output","default_value":"Redirect::Pipe","external_name":"output","restriction":"Stdio"},{"name":"error","default_value":"Redirect::Pipe","external_name":"error","restriction":"Stdio"},{"name":"chdir","default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"args_string":"(command : String, args = nil, env : Env = nil, clear_env : Bool = false, shell : Bool = false, input : Stdio = Redirect::Pipe, output : Stdio = Redirect::Pipe, error : Stdio = Redirect::Pipe, chdir : String? = nil, &)","args_html":"(command : <a href=\"String.html\">String</a>, args = <span class=\"n\">nil</span>, env : <a href=\"Process/Env.html\">Env</a> = <span class=\"n\">nil</span>, clear_env : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, shell : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, input : <a href=\"Process/Stdio.html\">Stdio</a> = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Pipe</span>, output : <a href=\"Process/Stdio.html\">Stdio</a> = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Pipe</span>, error : <a href=\"Process/Stdio.html\">Stdio</a> = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Pipe</span>, chdir : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>, &)","location":{"filename":"src/process.cr","line_number":138,"url":null},"def":{"name":"run","args":[{"name":"command","external_name":"command","restriction":"String"},{"name":"args","default_value":"nil","external_name":"args","restriction":""},{"name":"env","default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","default_value":"Redirect::Pipe","external_name":"input","restriction":"Stdio"},{"name":"output","default_value":"Redirect::Pipe","external_name":"output","restriction":"Stdio"},{"name":"error","default_value":"Redirect::Pipe","external_name":"error","restriction":"Stdio"},{"name":"chdir","default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"yields":1,"visibility":"Public","body":"process = new(command, args, env, clear_env, shell, input, output, error, chdir)\nbegin\n  value = yield process\n  $? = process.wait\n  value\nrescue ex\n  process.terminate\n  raise(ex)\nend\n"}},{"html_id":"signal(signal:Signal,pid:Int):Nil-class-method","name":"signal","doc":"Sends *signal* to the process identified by *pid*.","summary":"<p>Sends <em>signal</em> to the process identified by <em>pid</em>.</p>","abstract":false,"args":[{"name":"signal","external_name":"signal","restriction":"Signal"},{"name":"pid","external_name":"pid","restriction":"Int"}],"args_string":"(signal : Signal, pid : Int) : Nil","args_html":"(signal : <a href=\"Signal.html\">Signal</a>, pid : <a href=\"Int.html\">Int</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/process.cr","line_number":45,"url":null},"def":{"name":"signal","args":[{"name":"signal","external_name":"signal","restriction":"Signal"},{"name":"pid","external_name":"pid","restriction":"Int"}],"return_type":"Nil","visibility":"Public","body":"Crystal::System::Process.signal(pid, signal.value)"}},{"html_id":"times:Tms-class-method","name":"times","doc":"Returns a `Tms` for the current process. For the children times, only those\nof terminated children are returned on Unix; they are zero on Windows.","summary":"<p>Returns a <code><a href=\"Process/Tms.html\">Tms</a></code> for the current process.</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":58,"url":null},"def":{"name":"times","return_type":"Tms","visibility":"Public","body":"Crystal::System::Process.times"}}],"constructors":[{"html_id":"new(command:String,args=nil,env:Env=nil,clear_env:Bool=false,shell:Bool=false,input:Stdio=Redirect::Close,output:Stdio=Redirect::Close,error:Stdio=Redirect::Close,chdir:String?=nil)-class-method","name":"new","doc":"Creates a process, executes it, but doesn't wait for it to complete.\n\nTo wait for it to finish, invoke `wait`.\n\nBy default the process is configured without input, output or error.\n\nIf *shell* is false, the *command* is the path to the executable to run,\nalong with a list of *args*.\n\nIf *shell* is true, the *command* should be the full command line\nincluding space-separated args.\n* On POSIX this uses `/bin/sh` to process the command string. *args* are\n  also passed to the shell, and you need to include the string `\"${@}\"` in\n  the *command* to safely insert them there.\n* On Windows this is implemented by passing the string as-is to the\n  process, and passing *args* is not supported.\n\nRaises `IO::Error` if executing the command fails (for example if the executable doesn't exist).","summary":"<p>Creates a process, executes it, but doesn't wait for it to complete.</p>","abstract":false,"args":[{"name":"command","external_name":"command","restriction":"String"},{"name":"args","default_value":"nil","external_name":"args","restriction":""},{"name":"env","default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","default_value":"Redirect::Close","external_name":"input","restriction":"Stdio"},{"name":"output","default_value":"Redirect::Close","external_name":"output","restriction":"Stdio"},{"name":"error","default_value":"Redirect::Close","external_name":"error","restriction":"Stdio"},{"name":"chdir","default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"args_string":"(command : String, args = nil, env : Env = nil, clear_env : Bool = false, shell : Bool = false, input : Stdio = Redirect::Close, output : Stdio = Redirect::Close, error : Stdio = Redirect::Close, chdir : String? = nil)","args_html":"(command : <a href=\"String.html\">String</a>, args = <span class=\"n\">nil</span>, env : <a href=\"Process/Env.html\">Env</a> = <span class=\"n\">nil</span>, clear_env : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, shell : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, input : <a href=\"Process/Stdio.html\">Stdio</a> = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Close</span>, output : <a href=\"Process/Stdio.html\">Stdio</a> = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Close</span>, error : <a href=\"Process/Stdio.html\">Stdio</a> = <span class=\"t\">Redirect</span><span class=\"t\">::</span><span class=\"t\">Close</span>, chdir : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/process.cr","line_number":221,"url":null},"def":{"name":"new","args":[{"name":"command","external_name":"command","restriction":"String"},{"name":"args","default_value":"nil","external_name":"args","restriction":""},{"name":"env","default_value":"nil","external_name":"env","restriction":"Env"},{"name":"clear_env","default_value":"false","external_name":"clear_env","restriction":"Bool"},{"name":"shell","default_value":"false","external_name":"shell","restriction":"Bool"},{"name":"input","default_value":"Redirect::Close","external_name":"input","restriction":"Stdio"},{"name":"output","default_value":"Redirect::Close","external_name":"output","restriction":"Stdio"},{"name":"error","default_value":"Redirect::Close","external_name":"error","restriction":"Stdio"},{"name":"chdir","default_value":"nil","external_name":"chdir","restriction":"String | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(command, args, env, clear_env, shell, input, output, error, chdir)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes any system resources (e.g. pipes) held for the child process.","summary":"<p>Closes any system resources (e.g.</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":323,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"close_io(@input)\nclose_io(@output)\nclose_io(@error)\n@process_info.release\n"}},{"html_id":"error:IO::FileDescriptor-instance-method","name":"error","doc":"A pipe to this process' error. Raises if a pipe wasn't asked when creating the process.","summary":"<p>A pipe to this process' error.</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":198,"url":null},"def":{"name":"error","return_type":"IO::FileDescriptor","visibility":"Public","body":"if (value = @error).nil?\n  ::raise(NilAssertionError.new(\"Process#error cannot be nil\"))\nelse\n  value\nend"}},{"html_id":"error?:IO::FileDescriptor?-instance-method","name":"error?","doc":"A pipe to this process' error. Raises if a pipe wasn't asked when creating the process.","summary":"<p>A pipe to this process' error.</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":198,"url":null},"def":{"name":"error?","return_type":"IO::FileDescriptor | ::Nil","visibility":"Public","body":"@error"}},{"html_id":"exists?:Bool-instance-method","name":"exists?","doc":"Whether the process is still registered in the system.\nNote that this returns `true` for processes in the zombie or similar state.","summary":"<p>Whether the process is still registered in the system.</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":313,"url":null},"def":{"name":"exists?","return_type":"Bool","visibility":"Public","body":"@process_info.exists?"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/process.cr","line_number":237,"url":null},"def":{"name":"finalize","visibility":"Public","body":"@process_info.release"}},{"html_id":"input:IO::FileDescriptor-instance-method","name":"input","doc":"A pipe to this process' input. Raises if a pipe wasn't asked when creating the process.","summary":"<p>A pipe to this process' input.</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":192,"url":null},"def":{"name":"input","return_type":"IO::FileDescriptor","visibility":"Public","body":"if (value = @input).nil?\n  ::raise(NilAssertionError.new(\"Process#input cannot be nil\"))\nelse\n  value\nend"}},{"html_id":"input?:IO::FileDescriptor?-instance-method","name":"input?","doc":"A pipe to this process' input. Raises if a pipe wasn't asked when creating the process.","summary":"<p>A pipe to this process' input.</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":192,"url":null},"def":{"name":"input?","return_type":"IO::FileDescriptor | ::Nil","visibility":"Public","body":"@input"}},{"html_id":"output:IO::FileDescriptor-instance-method","name":"output","doc":"A pipe to this process' output. Raises if a pipe wasn't asked when creating the process.","summary":"<p>A pipe to this process' output.</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":195,"url":null},"def":{"name":"output","return_type":"IO::FileDescriptor","visibility":"Public","body":"if (value = @output).nil?\n  ::raise(NilAssertionError.new(\"Process#output cannot be nil\"))\nelse\n  value\nend"}},{"html_id":"output?:IO::FileDescriptor?-instance-method","name":"output?","doc":"A pipe to this process' output. Raises if a pipe wasn't asked when creating the process.","summary":"<p>A pipe to this process' output.</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":195,"url":null},"def":{"name":"output?","return_type":"IO::FileDescriptor | ::Nil","visibility":"Public","body":"@output"}},{"html_id":"pid:Int64-instance-method","name":"pid","doc":"Returns the process identifier of this process.","summary":"<p>Returns the process identifier of this process.</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":187,"url":null},"def":{"name":"pid","return_type":"Int64","visibility":"Public","body":"@process_info.pid.to_i64"}},{"html_id":"signal(signal:Signal):Nil-instance-method","name":"signal","doc":"Sends *signal* to this process.","summary":"<p>Sends <em>signal</em> to this process.</p>","abstract":false,"args":[{"name":"signal","external_name":"signal","restriction":"Signal"}],"args_string":"(signal : Signal) : Nil","args_html":"(signal : <a href=\"Signal.html\">Signal</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/process.cr","line_number":292,"url":null},"def":{"name":"signal","args":[{"name":"signal","external_name":"signal","restriction":"Signal"}],"return_type":"Nil","visibility":"Public","body":"Crystal::System::Process.signal(@process_info.pid, signal)"}},{"html_id":"terminate:Nil-instance-method","name":"terminate","doc":"Asks this process to terminate gracefully","summary":"<p>Asks this process to terminate gracefully</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":331,"url":null},"def":{"name":"terminate","return_type":"Nil","visibility":"Public","body":"@process_info.terminate"}},{"html_id":"terminated?:Bool-instance-method","name":"terminated?","doc":"Whether this process is already terminated.","summary":"<p>Whether this process is already terminated.</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":318,"url":null},"def":{"name":"terminated?","return_type":"Bool","visibility":"Public","body":"!exists?"}},{"html_id":"wait:Process::Status-instance-method","name":"wait","doc":"Waits for this process to complete and closes any pipes.","summary":"<p>Waits for this process to complete and closes any pipes.</p>","abstract":false,"location":{"filename":"src/process.cr","line_number":297,"url":null},"def":{"name":"wait","return_type":"Process::Status","visibility":"Public","body":"begin\n  close_io(@input)\n  @wait_count.times do\n    ex = channel.receive\n    if ex\n      raise(ex)\n    end\n  end\n  @wait_count = 0\n  Process::Status.new(@process_info.wait)\nensure\n  close\nend"}}],"types":[{"html_id":"Crystal/Process/Env","path":"Process/Env.html","kind":"alias","full_name":"Process::Env","name":"Env","abstract":false,"locations":[{"filename":"src/process.cr","line_number":116,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(Hash(String, Nil) | Hash(String, String | Nil) | Hash(String, String) | Nil)","aliased_html":"<a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../Nil.html\">Nil</a>) | <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>?) | <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>) | <a href=\"../Nil.html\">Nil</a>","const":false,"namespace":{"html_id":"Crystal/Process","kind":"class","full_name":"Process","name":"Process"}},{"html_id":"Crystal/Process/ExecStdio","path":"Process/ExecStdio.html","kind":"alias","full_name":"Process::ExecStdio","name":"ExecStdio","abstract":false,"locations":[{"filename":"src/process.cr","line_number":115,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(IO::FileDescriptor | Process::Redirect)","aliased_html":"<a href=\"../IO/FileDescriptor.html\">IO::FileDescriptor</a> | <a href=\"../Process/Redirect.html\">Process::Redirect</a>","const":false,"namespace":{"html_id":"Crystal/Process","kind":"class","full_name":"Process","name":"Process"}},{"html_id":"Crystal/Process/Redirect","path":"Process/Redirect.html","kind":"enum","full_name":"Process::Redirect","name":"Redirect","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/process.cr","line_number":101,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Pipe","name":"Pipe","value":"0","doc":"Pipe the IO so the parent process can read (or write) to the process IO\nthrough `#input`, `#output` or `#error`.","summary":"<p>Pipe the IO so the parent process can read (or write) to the process IO through <code>#input</code>, <code>#output</code> or <code>#error</code>.</p>"},{"id":"Close","name":"Close","value":"1","doc":"Discards the IO.","summary":"<p>Discards the IO.</p>"},{"id":"Inherit","name":"Inherit","value":"2","doc":"Use the IO of the parent process.","summary":"<p>Use the IO of the parent process.</p>"}],"namespace":{"html_id":"Crystal/Process","kind":"class","full_name":"Process","name":"Process"},"doc":"How to redirect the standard input, output and error IO of a process.","summary":"<p>How to redirect the standard input, output and error IO of a process.</p>","instance_methods":[{"html_id":"close?-instance-method","name":"close?","abstract":false,"location":{"filename":"src/process.cr","line_number":107,"url":null},"def":{"name":"close?","visibility":"Public","body":"self == Close"}},{"html_id":"inherit?-instance-method","name":"inherit?","abstract":false,"location":{"filename":"src/process.cr","line_number":110,"url":null},"def":{"name":"inherit?","visibility":"Public","body":"self == Inherit"}},{"html_id":"pipe?-instance-method","name":"pipe?","abstract":false,"location":{"filename":"src/process.cr","line_number":104,"url":null},"def":{"name":"pipe?","visibility":"Public","body":"self == Pipe"}}]},{"html_id":"Crystal/Process/Status","path":"Process/Status.html","kind":"class","full_name":"Process::Status","name":"Status","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/process/status.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Process","kind":"class","full_name":"Process","name":"Process"},"doc":"The status of a terminated process. Returned by `Process#wait`.","summary":"<p>The status of a terminated process.</p>","instance_methods":[{"html_id":"exit_code:Int32-instance-method","name":"exit_code","doc":"If `normal_exit?` is `true`, returns the exit code of the process.","summary":"<p>If <code><a href=\"../Process/Status.html#normal_exit%3F%3ABool-instance-method\">#normal_exit?</a></code> is <code>true</code>, returns the exit code of the process.</p>","abstract":false,"location":{"filename":"src/process/status.cr","line_number":52,"url":null},"def":{"name":"exit_code","return_type":"Int32","visibility":"Public","body":"{% if flag?(:unix) %}\n      # define __WEXITSTATUS(status) (((status) & 0xff00) >> 8)\n      (@exit_status & 0xff00) >> 8\n    {% else %}\n      exit_status\n    {% end %}"}},{"html_id":"exit_signal:Signal-instance-method","name":"exit_signal","doc":"If `signal_exit?` is `true`, returns the *Signal* the process\nreceived and didn't handle. Will raise if `signal_exit?` is `false`.\n\nAvailable only on Unix-like operating systems.","summary":"<p>If <code><a href=\"../Process/Status.html#signal_exit%3F%3ABool-instance-method\">#signal_exit?</a></code> is <code>true</code>, returns the <em>Signal</em> the process received and didn't handle.</p>","abstract":false,"location":{"filename":"src/process/status.cr","line_number":43,"url":null},"def":{"name":"exit_signal","return_type":"Signal","visibility":"Public","body":"{% if flag?(:unix) %}\n      Signal.from_value(signal_code)\n    {% else %}\n      raise NotImplementedError.new(\"Process::Status#exit_signal\")\n    {% end %}"}},{"html_id":"exit_status:Int32-instance-method","name":"exit_status","doc":"Platform-specific exit status code, which usually contains either the exit code or a termination signal.\nThe other `Process::Status` methods extract the values from `exit_status`.","summary":"<p>Platform-specific exit status code, which usually contains either the exit code or a termination signal.</p>","abstract":false,"location":{"filename":"src/process/status.cr","line_number":5,"url":null},"def":{"name":"exit_status","return_type":"Int32","visibility":"Public","body":"@exit_status.to_i32!"}},{"html_id":"normal_exit?:Bool-instance-method","name":"normal_exit?","doc":"Returns `true` if the process terminated normally.","summary":"<p>Returns <code>true</code> if the process terminated normally.</p>","abstract":false,"location":{"filename":"src/process/status.cr","line_number":30,"url":null},"def":{"name":"normal_exit?","return_type":"Bool","visibility":"Public","body":"{% if flag?(:unix) %}\n      # define __WIFEXITED(status) (__WTERMSIG(status) == 0)\n      signal_code == 0\n    {% else %}\n      true\n    {% end %}"}},{"html_id":"signal_exit?:Bool-instance-method","name":"signal_exit?","doc":"Returns `true` if the process was terminated by a signal.","summary":"<p>Returns <code>true</code> if the process was terminated by a signal.</p>","abstract":false,"location":{"filename":"src/process/status.cr","line_number":20,"url":null},"def":{"name":"signal_exit?","return_type":"Bool","visibility":"Public","body":"{% if flag?(:unix) %}\n      # define __WIFSIGNALED(status) (((signed char) (((status) & 0x7f) + 1) >> 1) > 0)\n      ((LibC::SChar.new(@exit_status & 0x7f) + 1) >> 1) > 0\n    {% else %}\n      false\n    {% end %}"}},{"html_id":"success?:Bool-instance-method","name":"success?","doc":"Returns `true` if the process exited normally with an exit code of `0`.","summary":"<p>Returns <code>true</code> if the process exited normally with an exit code of <code>0</code>.</p>","abstract":false,"location":{"filename":"src/process/status.cr","line_number":62,"url":null},"def":{"name":"success?","return_type":"Bool","visibility":"Public","body":"normal_exit? && (exit_code == 0)"}}]},{"html_id":"Crystal/Process/Stdio","path":"Process/Stdio.html","kind":"alias","full_name":"Process::Stdio","name":"Stdio","abstract":false,"locations":[{"filename":"src/process.cr","line_number":114,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(IO | Process::Redirect)","aliased_html":"<a href=\"../IO.html\">IO</a> | <a href=\"../Process/Redirect.html\">Process::Redirect</a>","const":false,"namespace":{"html_id":"Crystal/Process","kind":"class","full_name":"Process","name":"Process"},"doc":"The standard `IO` configuration of a process.","summary":"<p>The standard <code><a href=\"../IO.html\">IO</a></code> configuration of a process.</p>"},{"html_id":"Crystal/Process/Tms","path":"Process/Tms.html","kind":"struct","full_name":"Process::Tms","name":"Tms","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/process.cr","line_number":9,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Process","kind":"class","full_name":"Process","name":"Process"},"doc":"A struct representing the CPU current times of the process,\nin fractions of seconds.\n\n* *utime*: CPU time a process spent in userland.\n* *stime*: CPU time a process spent in the kernel.\n* *cutime*: CPU time a processes terminated children (and their terminated children) spent in the userland.\n* *cstime*: CPU time a processes terminated children (and their terminated children) spent in the kernel.","summary":"<p>A struct representing the CPU current times of the process, in fractions of seconds.</p>","constructors":[{"html_id":"new(utime:Float64,stime:Float64,cutime:Float64,cstime:Float64)-class-method","name":"new","abstract":false,"args":[{"name":"utime","external_name":"utime","restriction":"Float64"},{"name":"stime","external_name":"stime","restriction":"Float64"},{"name":"cutime","external_name":"cutime","restriction":"Float64"},{"name":"cstime","external_name":"cstime","restriction":"Float64"}],"args_string":"(utime : Float64, stime : Float64, cutime : Float64, cstime : Float64)","args_html":"(utime : <a href=\"../Float64.html\">Float64</a>, stime : <a href=\"../Float64.html\">Float64</a>, cutime : <a href=\"../Float64.html\">Float64</a>, cstime : <a href=\"../Float64.html\">Float64</a>)","location":{"filename":"src/process.cr","line_number":9,"url":null},"def":{"name":"new","args":[{"name":"utime","external_name":"utime","restriction":"Float64"},{"name":"stime","external_name":"stime","restriction":"Float64"},{"name":"cutime","external_name":"cutime","restriction":"Float64"},{"name":"cstime","external_name":"cstime","restriction":"Float64"}],"visibility":"Public","body":"_ = allocate\n_.initialize(utime, stime, cutime, cstime)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/process.cr","line_number":9,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new(@utime.clone, @stime.clone, @cutime.clone, @cstime.clone)"}},{"html_id":"copy_with(utime_utime=@utime,stime_stime=@stime,cutime_cutime=@cutime,cstime_cstime=@cstime)-instance-method","name":"copy_with","abstract":false,"args":[{"name":"_utime","default_value":"@utime","external_name":"utime","restriction":""},{"name":"_stime","default_value":"@stime","external_name":"stime","restriction":""},{"name":"_cutime","default_value":"@cutime","external_name":"cutime","restriction":""},{"name":"_cstime","default_value":"@cstime","external_name":"cstime","restriction":""}],"args_string":"(utime _utime = @utime, stime _stime = @stime, cutime _cutime = @cutime, cstime _cstime = @cstime)","args_html":"(utime _utime = @utime, stime _stime = @stime, cutime _cutime = @cutime, cstime _cstime = @cstime)","location":{"filename":"src/process.cr","line_number":9,"url":null},"def":{"name":"copy_with","args":[{"name":"_utime","default_value":"@utime","external_name":"utime","restriction":""},{"name":"_stime","default_value":"@stime","external_name":"stime","restriction":""},{"name":"_cutime","default_value":"@cutime","external_name":"cutime","restriction":""},{"name":"_cstime","default_value":"@cstime","external_name":"cstime","restriction":""}],"visibility":"Public","body":"self.class.new(_utime, _stime, _cutime, _cstime)"}},{"html_id":"cstime:Float64-instance-method","name":"cstime","abstract":false,"def":{"name":"cstime","return_type":"Float64","visibility":"Public","body":"@cstime"}},{"html_id":"cutime:Float64-instance-method","name":"cutime","abstract":false,"def":{"name":"cutime","return_type":"Float64","visibility":"Public","body":"@cutime"}},{"html_id":"stime:Float64-instance-method","name":"stime","abstract":false,"def":{"name":"stime","return_type":"Float64","visibility":"Public","body":"@stime"}},{"html_id":"utime:Float64-instance-method","name":"utime","abstract":false,"def":{"name":"utime","return_type":"Float64","visibility":"Public","body":"@utime"}}]}]},{"html_id":"Crystal/Random","path":"Random.html","kind":"module","full_name":"Random","name":"Random","abstract":false,"locations":[{"filename":"src/big/big_int.cr","line_number":821,"url":null},{"filename":"src/random.cr","line_number":52,"url":null},{"filename":"src/random/secure.cr","line_number":18,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"DEFAULT","name":"DEFAULT","value":"PCG32.new"}],"including_types":[{"html_id":"Crystal/Random/ISAAC","kind":"class","full_name":"Random::ISAAC","name":"ISAAC"},{"html_id":"Crystal/Random/PCG32","kind":"class","full_name":"Random::PCG32","name":"PCG32"}],"doc":"`Random` provides an interface for random values generation, using a pseudo random number generator (PRNG).\n\n```\nRandom.rand    # => 0.167595\nRandom.rand(5) # => 2\n```\n\nThe above methods delegate to a `Random` instance.\n\n```\nr = Random.new\nr.rand      # => 0.0372991\nr.next_bool # => true\nr.next_int  # => 2223112\n```\n\nThis module also defines a global method `#rand`, which `Array#sample` and `Array#shuffle` delegates.\n\n```\nrand     # => 0.293829\nrand(10) # => 8\n```\n\nAn instance of each class that includes `Random` is a random number generator with its own state.\nUsually such RNGs can be initialized with a seed, which defines their initial state. It is\nguaranteed that after initializing two different instances with the same seed, and then executing\nthe same calls on both of them, you will get the same results. This allows exactly reproducing the\nsame seemingly random events by just keeping the seed.\n\nIt is possible to make a custom RNG by including `Random` and implementing `next_u` to return an\nunsigned number of a pre-determined type (usually `UInt32`). The numbers generated by your RNG\nmust be uniformly distributed in the whole range of possible values for that type (e.g.\n`0u32..UInt32::MAX`). This allows all other methods of `Random` to be based on this and still\nproduce uniformly distributed results. Your `Random` class should also have a way to initialize\nit. For pseudo-random number generators that will usually be an integer seed, but there are no\nrigid requirements for the initialization.\n\nThe default PRNG is `Random::PCG32` which has a good overall statistical\ndistribution (low bias of generated numbers) and is fast for overall usages on\ndifferent platforms, but isn't cryptographically secure. If a third party has\naccess to some generated numbers, she may deduce incoming numbers, putting\nyour application at risk.\n\nIt is recommended to use a secure source, such as `Random::Secure`,\n`Random::ISAAC` or ChaCha20 for anything that needs security, such as online\ngames, identification tokens, salts, initializing a PRNG, ... These PRNG are\nslower but cryptographically secure, so a third party can't deduce incoming\nnumbers.","summary":"<p><code><a href=\"Random.html\">Random</a></code> provides an interface for random values generation, using a pseudo random number generator (PRNG).</p>","class_methods":[{"html_id":"rand(x)-class-method","name":"rand","doc":"See `#rand(x)`.","summary":"<p>See <code><a href=\"Random.html#rand%28max%3AInt%29%3AInt-instance-method\">#rand(x)</a></code>.</p>","abstract":false,"args":[{"name":"x","external_name":"x","restriction":""}],"args_string":"(x)","args_html":"(x)","location":{"filename":"src/random.cr","line_number":431,"url":null},"def":{"name":"rand","args":[{"name":"x","external_name":"x","restriction":""}],"visibility":"Public","body":"DEFAULT.rand(x)"}},{"html_id":"rand:Float64-class-method","name":"rand","doc":"See `#rand`.","summary":"<p>See <code><a href=\"Random.html#rand%3AFloat64-instance-method\">#rand</a></code>.</p>","abstract":false,"location":{"filename":"src/random.cr","line_number":426,"url":null},"def":{"name":"rand","return_type":"Float64","visibility":"Public","body":"DEFAULT.rand"}}],"constructors":[{"html_id":"new(seed,sequence=0_u64)-class-method","name":"new","doc":"Initializes an instance with the given *seed* and *sequence*.","summary":"<p>Initializes an instance with the given <em>seed</em> and <em>sequence</em>.</p>","abstract":false,"args":[{"name":"seed","external_name":"seed","restriction":""},{"name":"sequence","default_value":"0_u64","external_name":"sequence","restriction":""}],"args_string":"(seed, sequence = 0_u64)","args_html":"(seed, sequence = <span class=\"n\">0_u64</span>)","location":{"filename":"src/random.cr","line_number":56,"url":null},"def":{"name":"new","args":[{"name":"seed","external_name":"seed","restriction":""},{"name":"sequence","default_value":"0_u64","external_name":"sequence","restriction":""}],"visibility":"Public","body":"PCG32.new(seed.to_u64, sequence)"}},{"html_id":"new-class-method","name":"new","doc":"Initializes an instance seeded from a system source.","summary":"<p>Initializes an instance seeded from a system source.</p>","abstract":false,"location":{"filename":"src/random.cr","line_number":61,"url":null},"def":{"name":"new","visibility":"Public","body":"PCG32.new"}}],"instance_methods":[{"html_id":"base64(n:Int=16):String-instance-method","name":"base64","doc":"Generates *n* random bytes that are encoded into base64.\n\nThe parameter *n* specifies the length, in bytes, of the random number to\nbe generated. The length of the result string is about 4/3 of *n* due to\nthe base64 encoding. The result receives a padding\nconsisting of `=` characters to fill up the string size to a multiple of 4.\n\nCheck `Base64#strict_encode` for details.\n\n```\nRandom::Secure.base64(4) # => \"fK1eYg==\"\n```\n\nIt is recommended to use the secure `Random::Secure` as a source or another\ncryptographically quality PRNG such as `Random::ISAAC` or ChaCha20.","summary":"<p>Generates <em>n</em> random bytes that are encoded into base64.</p>","abstract":false,"args":[{"name":"n","default_value":"16","external_name":"n","restriction":"Int"}],"args_string":"(n : Int = 16) : String","args_html":"(n : <a href=\"Int.html\">Int</a> = <span class=\"n\">16</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/random.cr","line_number":384,"url":null},"def":{"name":"base64","args":[{"name":"n","default_value":"16","external_name":"n","restriction":"Int"}],"return_type":"String","visibility":"Public","body":"Base64.strict_encode(random_bytes(n))"}},{"html_id":"hex(n:Int=16):String-instance-method","name":"hex","doc":"Generates a hexadecimal string based on *n* random bytes.\n\nThe bytes are encoded into a string of two-digit hexadecimal\nnumber (00-ff) per byte.\n\n```\nRandom::Secure.hex    # => \"05f100a1123f6bdbb427698ab664ff5f\"\nRandom::Secure.hex(1) # => \"1a\"\n```\n\nIt is recommended to use the secure `Random::Secure` as a source or another\ncryptographically quality PRNG such as `Random::ISAAC` or ChaCha20.","summary":"<p>Generates a hexadecimal string based on <em>n</em> random bytes.</p>","abstract":false,"args":[{"name":"n","default_value":"16","external_name":"n","restriction":"Int"}],"args_string":"(n : Int = 16) : String","args_html":"(n : <a href=\"Int.html\">Int</a> = <span class=\"n\">16</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/random.cr","line_number":421,"url":null},"def":{"name":"hex","args":[{"name":"n","default_value":"16","external_name":"n","restriction":"Int"}],"return_type":"String","visibility":"Public","body":"(random_bytes(n)).hexstring"}},{"html_id":"next_bool:Bool-instance-method","name":"next_bool","doc":"Generates a random `Bool`.\n\n```\nRandom.new.next_bool # => true\n```","summary":"<p>Generates a random <code><a href=\"Bool.html\">Bool</a></code>.</p>","abstract":false,"location":{"filename":"src/random.cr","line_number":76,"url":null},"def":{"name":"next_bool","return_type":"Bool","visibility":"Public","body":"next_u.odd?"}},{"html_id":"next_float:Float64-instance-method","name":"next_float","doc":"See `#rand`.","summary":"<p>See <code><a href=\"Random.html#rand%3AFloat64-instance-method\">#rand</a></code>.</p>","abstract":false,"location":{"filename":"src/random.cr","line_number":86,"url":null},"def":{"name":"next_float","return_type":"Float64","visibility":"Public","body":"max_prec = 1_u64 << 53\n(rand(max_prec)) / (max_prec - 1).to_f64\n"}},{"html_id":"next_int:Int32-instance-method","name":"next_int","doc":"Same as `rand(Int32::MIN..Int32::MAX)`.","summary":"<p>Same as <code><a href=\"Random.html#rand%28max%3AInt%29%3AInt-instance-method\">#rand(Int32::MIN..Int32::MAX)</a></code>.</p>","abstract":false,"location":{"filename":"src/random.cr","line_number":81,"url":null},"def":{"name":"next_int","return_type":"Int32","visibility":"Public","body":"rand_type(Int32)"}},{"html_id":"next_u-instance-method","name":"next_u","doc":"Generates a random unsigned integer.\n\nThe integers must be uniformly distributed between `0` and\nthe maximal value for the chosen type.","summary":"<p>Generates a random unsigned integer.</p>","abstract":true,"location":{"filename":"src/random.cr","line_number":69,"url":null},"def":{"name":"next_u","visibility":"Public","body":""}},{"html_id":"rand(max:Int):Int-instance-method","name":"rand","doc":"Generates a random integer which is greater than or equal to `0`\nand less than *max*.\n\nThe return type always matches the supplied argument.\n\n```\nRandom.new.rand(10)   # => 5\nRandom.new.rand(5000) # => 2243\n```","summary":"<p>Generates a random integer which is greater than or equal to <code>0</code> and less than <em>max</em>.</p>","abstract":false,"args":[{"name":"max","external_name":"max","restriction":"Int"}],"args_string":"(max : Int) : Int","args_html":"(max : <a href=\"Int.html\">Int</a>) : <a href=\"Int.html\">Int</a>","location":{"filename":"src/random.cr","line_number":111,"url":null},"def":{"name":"rand","args":[{"name":"max","external_name":"max","restriction":"Int"}],"return_type":"Int","visibility":"Public","body":"rand_int(max)"}},{"html_id":"rand(max:Float64):Float64-instance-method","name":"rand","doc":"Returns a random `Float` which is greater than or equal to `0`\nand less than *max*.\n\n```\nRandom.new.rand(3.5)    # => 2.88938\nRandom.new.rand(10.725) # => 7.70147\n```","summary":"<p>Returns a random <code><a href=\"Float.html\">Float</a></code> which is greater than or equal to <code>0</code> and less than <em>max</em>.</p>","abstract":false,"args":[{"name":"max","external_name":"max","restriction":"Float64"}],"args_string":"(max : Float64) : Float64","args_html":"(max : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/random.cr","line_number":252,"url":null},"def":{"name":"rand","args":[{"name":"max","external_name":"max","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"if max > 0\nelse\n  raise(ArgumentError.new(\"Invalid bound for rand: #{max}\"))\nend\nmax_prec = 1_u64 << 53\n((rand(max_prec)) / max_prec.to_f64) * max\n"}},{"html_id":"rand(max:Float32):Float32-instance-method","name":"rand","doc":"Returns a random `Float` which is greater than or equal to `0`\nand less than *max*.\n\n```\nRandom.new.rand(3.5)    # => 2.88938\nRandom.new.rand(10.725) # => 7.70147\n```","summary":"<p>Returns a random <code><a href=\"Float.html\">Float</a></code> which is greater than or equal to <code>0</code> and less than <em>max</em>.</p>","abstract":false,"args":[{"name":"max","external_name":"max","restriction":"Float32"}],"args_string":"(max : Float32) : Float32","args_html":"(max : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/random.cr","line_number":261,"url":null},"def":{"name":"rand","args":[{"name":"max","external_name":"max","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"if max > 0\nelse\n  raise(ArgumentError.new(\"Invalid bound for rand: #{max}\"))\nend\nmax_prec = 1_u32 << 24\n((rand(max_prec)) / max_prec.to_f32) * max\n"}},{"html_id":"rand(range:Range(Int,Int)):Int-instance-method","name":"rand","doc":"Returns a random integer in the given *range*.\n\nThe return type always matches the supplied argument.\n\n```\nRandom.new.rand(10..20)                 # => 14\nRandom.new.rand(Int64::MIN..Int64::MAX) # => -5297435808626736140\n```","summary":"<p>Returns a random integer in the given <em>range</em>.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range(Int, Int)"}],"args_string":"(range : Range(Int, Int)) : Int","args_html":"(range : <a href=\"Range.html\">Range</a>(<a href=\"Int.html\">Int</a>, <a href=\"Int.html\">Int</a>)) : <a href=\"Int.html\">Int</a>","location":{"filename":"src/random.cr","line_number":277,"url":null},"def":{"name":"rand","args":[{"name":"range","external_name":"range","restriction":"Range(Int, Int)"}],"return_type":"Int","visibility":"Public","body":"rand_range(range)"}},{"html_id":"rand(range:Range(Float,Float)):Float-instance-method","name":"rand","doc":"Returns a random `Float` in the given *range*.\n\n```\nRandom.new.rand(6.2..21.768) # => 15.2989\n```","summary":"<p>Returns a random <code><a href=\"Float.html\">Float</a></code> in the given <em>range</em>.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range(Float, Float)"}],"args_string":"(range : Range(Float, Float)) : Float","args_html":"(range : <a href=\"Range.html\">Range</a>(<a href=\"Float.html\">Float</a>, <a href=\"Float.html\">Float</a>)) : <a href=\"Float.html\">Float</a>","location":{"filename":"src/random.cr","line_number":286,"url":null},"def":{"name":"rand","args":[{"name":"range","external_name":"range","restriction":"Range(Float, Float)"}],"return_type":"Float","visibility":"Public","body":"span = range.end - range.begin\nif range.excludes_end?\n  if range.begin < range.end\n  else\n    raise(ArgumentError.new(\"Invalid range for rand: #{range}\"))\n  end\n  range.begin + (rand(span))\nelse\n  if range.begin <= range.end\n  else\n    raise(ArgumentError.new(\"Invalid range for rand: #{range}\"))\n  end\n  range.begin + (rand * span)\nend\n"}},{"html_id":"rand(type:StaticArray(Int8,_).class)-instance-method","name":"rand","doc":"Returns a StaticArray filled with random Int8 values.\n\n```\nrand(StaticArray(Int8, 4)) # => StaticArray[20, -66, 89, 19]\n```","summary":"<p>Returns a StaticArray filled with random Int8 values.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"StaticArray(Int8, _).class"}],"args_string":"(type : StaticArray(Int8, _).class)","args_html":"(type : <span class=\"t\">StaticArray</span>(<span class=\"t\">Int8</span>, _).<span class=\"k\">class</span>)","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"StaticArray(Int8, _).class"}],"visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand(type:StaticArray(UInt8,_).class)-instance-method","name":"rand","doc":"Returns a StaticArray filled with random UInt8 values.\n\n```\nrand(StaticArray(UInt8, 4)) # => StaticArray[186, 221, 127, 245]\n```","summary":"<p>Returns a StaticArray filled with random UInt8 values.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"StaticArray(UInt8, _).class"}],"args_string":"(type : StaticArray(UInt8, _).class)","args_html":"(type : <span class=\"t\">StaticArray</span>(<span class=\"t\">UInt8</span>, _).<span class=\"k\">class</span>)","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"StaticArray(UInt8, _).class"}],"visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand(type:StaticArray(Int16,_).class)-instance-method","name":"rand","doc":"Returns a StaticArray filled with random Int16 values.\n\n```\nrand(StaticArray(Int16, 4)) # => StaticArray[-32554, 32169, -20152, -7686]\n```","summary":"<p>Returns a StaticArray filled with random Int16 values.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"StaticArray(Int16, _).class"}],"args_string":"(type : StaticArray(Int16, _).class)","args_html":"(type : <span class=\"t\">StaticArray</span>(<span class=\"t\">Int16</span>, _).<span class=\"k\">class</span>)","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"StaticArray(Int16, _).class"}],"visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand(type:StaticArray(UInt16,_).class)-instance-method","name":"rand","doc":"Returns a StaticArray filled with random UInt16 values.\n\n```\nrand(StaticArray(UInt16, 4)) # => StaticArray[39546, 44091, 2874, 17348]\n```","summary":"<p>Returns a StaticArray filled with random UInt16 values.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"StaticArray(UInt16, _).class"}],"args_string":"(type : StaticArray(UInt16, _).class)","args_html":"(type : <span class=\"t\">StaticArray</span>(<span class=\"t\">UInt16</span>, _).<span class=\"k\">class</span>)","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"StaticArray(UInt16, _).class"}],"visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand(type:StaticArray(Int32,_).class)-instance-method","name":"rand","doc":"Returns a StaticArray filled with random Int32 values.\n\n```\nrand(StaticArray(Int32, 4)) # => StaticArray[1870830079, -1043532158, -867180637, -1216773590]\n```","summary":"<p>Returns a StaticArray filled with random Int32 values.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"StaticArray(Int32, _).class"}],"args_string":"(type : StaticArray(Int32, _).class)","args_html":"(type : <span class=\"t\">StaticArray</span>(<span class=\"t\">Int32</span>, _).<span class=\"k\">class</span>)","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"StaticArray(Int32, _).class"}],"visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand(type:StaticArray(UInt32,_).class)-instance-method","name":"rand","doc":"Returns a StaticArray filled with random UInt32 values.\n\n```\nrand(StaticArray(UInt32, 4)) # => StaticArray[3147957137, 4245108745, 2207809043, 3184391838]\n```","summary":"<p>Returns a StaticArray filled with random UInt32 values.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"StaticArray(UInt32, _).class"}],"args_string":"(type : StaticArray(UInt32, _).class)","args_html":"(type : <span class=\"t\">StaticArray</span>(<span class=\"t\">UInt32</span>, _).<span class=\"k\">class</span>)","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"StaticArray(UInt32, _).class"}],"visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand(type:StaticArray(Int64,_).class)-instance-method","name":"rand","doc":"Returns a StaticArray filled with random Int64 values.\n\n```\nrand(StaticArray(Int64, 4)) # => StaticArray[4438449217673515190, 8514493061600538358, -4874671083204037318, -7825896160729246667]\n```","summary":"<p>Returns a StaticArray filled with random Int64 values.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"StaticArray(Int64, _).class"}],"args_string":"(type : StaticArray(Int64, _).class)","args_html":"(type : <span class=\"t\">StaticArray</span>(<span class=\"t\">Int64</span>, _).<span class=\"k\">class</span>)","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"StaticArray(Int64, _).class"}],"visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand(type:StaticArray(UInt64,_).class)-instance-method","name":"rand","doc":"Returns a StaticArray filled with random UInt64 values.\n\n```\nrand(StaticArray(UInt64, 4)) # => StaticArray[15004487597684511003, 12027825265648206103, 11303949506191212698, 6228566501671148658]\n```","summary":"<p>Returns a StaticArray filled with random UInt64 values.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"StaticArray(UInt64, _).class"}],"args_string":"(type : StaticArray(UInt64, _).class)","args_html":"(type : <span class=\"t\">StaticArray</span>(<span class=\"t\">UInt64</span>, _).<span class=\"k\">class</span>)","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"StaticArray(UInt64, _).class"}],"visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand(type:Int8.class):Int8-instance-method","name":"rand","doc":"Returns a random Int8\n\n```\nrand(Int8) # => 20\n```","summary":"<p>Returns a random Int8</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int8.class"}],"args_string":"(type : Int8.class) : Int8","args_html":"(type : <span class=\"t\">Int8</span>.<span class=\"k\">class</span>) : <a href=\"Int8.html\">Int8</a>","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"Int8.class"}],"return_type":"Int8","visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand(type:UInt8.class):UInt8-instance-method","name":"rand","doc":"Returns a random UInt8\n\n```\nrand(UInt8) # => 186\n```","summary":"<p>Returns a random UInt8</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt8.class"}],"args_string":"(type : UInt8.class) : UInt8","args_html":"(type : <span class=\"t\">UInt8</span>.<span class=\"k\">class</span>) : <a href=\"UInt8.html\">UInt8</a>","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"UInt8.class"}],"return_type":"UInt8","visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand(type:Int16.class):Int16-instance-method","name":"rand","doc":"Returns a random Int16\n\n```\nrand(Int16) # => -32554\n```","summary":"<p>Returns a random Int16</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int16.class"}],"args_string":"(type : Int16.class) : Int16","args_html":"(type : <span class=\"t\">Int16</span>.<span class=\"k\">class</span>) : <a href=\"Int16.html\">Int16</a>","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"Int16.class"}],"return_type":"Int16","visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand(type:UInt16.class):UInt16-instance-method","name":"rand","doc":"Returns a random UInt16\n\n```\nrand(UInt16) # => 39546\n```","summary":"<p>Returns a random UInt16</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt16.class"}],"args_string":"(type : UInt16.class) : UInt16","args_html":"(type : <span class=\"t\">UInt16</span>.<span class=\"k\">class</span>) : <a href=\"UInt16.html\">UInt16</a>","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"UInt16.class"}],"return_type":"UInt16","visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand(type:Int32.class):Int32-instance-method","name":"rand","doc":"Returns a random Int32\n\n```\nrand(Int32) # => 1870830079\n```","summary":"<p>Returns a random Int32</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int32.class"}],"args_string":"(type : Int32.class) : Int32","args_html":"(type : <span class=\"t\">Int32</span>.<span class=\"k\">class</span>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"Int32.class"}],"return_type":"Int32","visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand(type:UInt32.class):UInt32-instance-method","name":"rand","doc":"Returns a random UInt32\n\n```\nrand(UInt32) # => 3147957137\n```","summary":"<p>Returns a random UInt32</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt32.class"}],"args_string":"(type : UInt32.class) : UInt32","args_html":"(type : <span class=\"t\">UInt32</span>.<span class=\"k\">class</span>) : <a href=\"UInt32.html\">UInt32</a>","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"UInt32.class"}],"return_type":"UInt32","visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand(type:Int64.class):Int64-instance-method","name":"rand","doc":"Returns a random Int64\n\n```\nrand(Int64) # => 4438449217673515190\n```","summary":"<p>Returns a random Int64</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"Int64.class"}],"args_string":"(type : Int64.class) : Int64","args_html":"(type : <span class=\"t\">Int64</span>.<span class=\"k\">class</span>) : <a href=\"Int64.html\">Int64</a>","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"Int64.class"}],"return_type":"Int64","visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand(type:UInt64.class):UInt64-instance-method","name":"rand","doc":"Returns a random UInt64\n\n```\nrand(UInt64) # => 15004487597684511003\n```","summary":"<p>Returns a random UInt64</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"UInt64.class"}],"args_string":"(type : UInt64.class) : UInt64","args_html":"(type : <span class=\"t\">UInt64</span>.<span class=\"k\">class</span>) : <a href=\"UInt64.html\">UInt64</a>","location":{"filename":"src/random.cr","line_number":301,"url":null},"def":{"name":"rand","args":[{"name":"type","external_name":"type","restriction":"UInt64.class"}],"return_type":"UInt64","visibility":"Public","body":"rand_type_from_bytes(type)"}},{"html_id":"rand:Float64-instance-method","name":"rand","doc":"Generates a random `Float64` between `0` and `1`.\n\n```\nr = Random.new\nr.rand # => 0.167595\nr.rand # => 0.0372991\n```","summary":"<p>Generates a random <code><a href=\"Float64.html\">Float64</a></code> between <code>0</code> and <code>1</code>.</p>","abstract":false,"location":{"filename":"src/random.cr","line_number":98,"url":null},"def":{"name":"rand","return_type":"Float64","visibility":"Public","body":"next_float"}},{"html_id":"random_bytes(n:Int=16):Bytes-instance-method","name":"random_bytes","doc":"Generates a slice filled with *n* random bytes.\n\n```\nRandom.new.random_bytes    # => [145, 255, 191, 133, 132, 139, 53, 136, 93, 238, 2, 37, 138, 244, 3, 216]\nRandom.new.random_bytes(4) # => [217, 118, 38, 196]\n```","summary":"<p>Generates a slice filled with <em>n</em> random bytes.</p>","abstract":false,"args":[{"name":"n","default_value":"16","external_name":"n","restriction":"Int"}],"args_string":"(n : Int = 16) : Bytes","args_html":"(n : <a href=\"Int.html\">Int</a> = <span class=\"n\">16</span>) : <a href=\"Bytes.html\">Bytes</a>","location":{"filename":"src/random.cr","line_number":364,"url":null},"def":{"name":"random_bytes","args":[{"name":"n","default_value":"16","external_name":"n","restriction":"Int"}],"return_type":"Bytes","visibility":"Public","body":"if n < 0\n  raise(ArgumentError.new(\"Negative size: #{n}\"))\nend\n(Bytes.new(n)).tap do |buf|\n  random_bytes(buf)\nend\n"}},{"html_id":"random_bytes(buf:Bytes):Nil-instance-method","name":"random_bytes","doc":"Fills a given slice with random bytes.\n\n```\nslice = Bytes.new(4) # => [0, 0, 0, 0]\nRandom.new.random_bytes(slice)\nslice # => [217, 118, 38, 196]\n```","summary":"<p>Fills a given slice with random bytes.</p>","abstract":false,"args":[{"name":"buf","external_name":"buf","restriction":"Bytes"}],"args_string":"(buf : Bytes) : Nil","args_html":"(buf : <a href=\"Bytes.html\">Bytes</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/random.cr","line_number":343,"url":null},"def":{"name":"random_bytes","args":[{"name":"buf","external_name":"buf","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"ptr = buf.to_unsafe\nfinish = buf.to_unsafe + buf.size\nwhile ptr < finish\n  random = next_u\n  rand_ptr = (pointerof(random)).as(::Pointer(UInt8))\n  if IO::ByteFormat::SystemEndian != IO::ByteFormat::LittleEndian\n    (rand_ptr.to_slice(sizeof(typeof(next_u)))).reverse!\n  end\n  rand_ptr.copy_to(ptr, {finish - ptr, sizeof(typeof(next_u))}.min)\n  ptr = ptr + (sizeof(typeof(next_u)))\nend\n"}},{"html_id":"urlsafe_base64(n:Int=16,padding=false):String-instance-method","name":"urlsafe_base64","doc":"Generates *n* random bytes that are encoded as a URL-safe base64 string.\n\nThe parameter *n* specifies the length, in bytes, of the random number to\nbe generated. The length of the result string is about 4/3 of *n* due to\nthe base64 encoding. If *padding* is `true`, the result receives a padding\nconsisting of `=` characters to fill up the string size to a multiple of 4.\n\nCheck `Base64#urlsafe_encode` for details.\n\n```\nRandom::Secure.urlsafe_base64                    # => \"MAD2bw8QaBdvITCveBNCrw\"\nRandom::Secure.urlsafe_base64(8, padding: true)  # => \"vvP1kcs841I=\"\nRandom::Secure.urlsafe_base64(16, padding: true) # => \"og2aJrELDZWSdJfVGkxNKw==\"\n```\n\nIt is recommended to use the secure `Random::Secure` as a source or another\ncryptographically quality PRNG such as `Random::ISAAC` or ChaCha20.","summary":"<p>Generates <em>n</em> random bytes that are encoded as a URL-safe base64 string.</p>","abstract":false,"args":[{"name":"n","default_value":"16","external_name":"n","restriction":"Int"},{"name":"padding","default_value":"false","external_name":"padding","restriction":""}],"args_string":"(n : Int = 16, padding = false) : String","args_html":"(n : <a href=\"Int.html\">Int</a> = <span class=\"n\">16</span>, padding = <span class=\"n\">false</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/random.cr","line_number":405,"url":null},"def":{"name":"urlsafe_base64","args":[{"name":"n","default_value":"16","external_name":"n","restriction":"Int"},{"name":"padding","default_value":"false","external_name":"padding","restriction":""}],"return_type":"String","visibility":"Public","body":"Base64.urlsafe_encode(random_bytes(n), padding)"}}],"types":[{"html_id":"Crystal/Random/ISAAC","path":"Random/ISAAC.html","kind":"class","full_name":"Random::ISAAC","name":"ISAAC","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Random","kind":"module","full_name":"Random","name":"Random"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/random/isaac.cr","line_number":7,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Random","kind":"module","full_name":"Random","name":"Random"}],"namespace":{"html_id":"Crystal/Random","kind":"module","full_name":"Random","name":"Random"},"constructors":[{"html_id":"new(seeds=random_seeds)-class-method","name":"new","abstract":false,"args":[{"name":"seeds","default_value":"random_seeds","external_name":"seeds","restriction":""}],"args_string":"(seeds = random_seeds)","args_html":"(seeds = random_seeds)","location":{"filename":"src/random/isaac.cr","line_number":19,"url":null},"def":{"name":"new","args":[{"name":"seeds","default_value":"random_seeds","external_name":"seeds","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(seeds)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"new_seed(seeds=random_seeds)-instance-method","name":"new_seed","abstract":false,"args":[{"name":"seeds","default_value":"random_seeds","external_name":"seeds","restriction":""}],"args_string":"(seeds = random_seeds)","args_html":"(seeds = random_seeds)","location":{"filename":"src/random/isaac.cr","line_number":27,"url":null},"def":{"name":"new_seed","args":[{"name":"seeds","default_value":"random_seeds","external_name":"seeds","restriction":""}],"visibility":"Public","body":"@aa = @bb = @cc = 0_u32\ninit_by_array(seeds)\n"}},{"html_id":"next_u:UInt32-instance-method","name":"next_u","doc":"Generates a random unsigned integer.\n\nThe integers must be uniformly distributed between `0` and\nthe maximal value for the chosen type.","summary":"<p>Generates a random unsigned integer.</p>","abstract":false,"location":{"filename":"src/random/isaac.cr","line_number":32,"url":null},"def":{"name":"next_u","return_type":"UInt32","visibility":"Public","body":"if (@counter = @counter - 1) == -1\n  isaac\n  @counter = 255\nend\n@rsl[counter]\n"}}]},{"html_id":"Crystal/Random/PCG32","path":"Random/PCG32.html","kind":"class","full_name":"Random::PCG32","name":"PCG32","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Random","kind":"module","full_name":"Random","name":"Random"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/random/pcg32.cr","line_number":34,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"PCG_DEFAULT_MULTIPLIER_64","name":"PCG_DEFAULT_MULTIPLIER_64","value":"6364136223846793005_u64"}],"included_modules":[{"html_id":"Crystal/Random","kind":"module","full_name":"Random","name":"Random"}],"namespace":{"html_id":"Crystal/Random","kind":"module","full_name":"Random","name":"Random"},"doc":"pcg32_random_r:\n      -  result:      32-bit unsigned int (uint32_t)\n      -  period:      2^64   (* 2^63 streams)\n      -  state type:  pcg32_random_t (16 bytes)\n      -  output func: XSH-RR","summary":"<p>pcg32_random_r:       -  result:      32-bit unsigned int (uint32_t)       -  period:      2^64   (* 2^63 streams)       -  state type:  pcg32_random_t (16 bytes)       -  output func: XSH-RR</p>","constructors":[{"html_id":"new(initstate:UInt64,initseq=0_u64)-class-method","name":"new","abstract":false,"args":[{"name":"initstate","external_name":"initstate","restriction":"UInt64"},{"name":"initseq","default_value":"0_u64","external_name":"initseq","restriction":""}],"args_string":"(initstate : UInt64, initseq = 0_u64)","args_html":"(initstate : <a href=\"../UInt64.html\">UInt64</a>, initseq = <span class=\"n\">0_u64</span>)","location":{"filename":"src/random/pcg32.cr","line_number":46,"url":null},"def":{"name":"new","args":[{"name":"initstate","external_name":"initstate","restriction":"UInt64"},{"name":"initseq","default_value":"0_u64","external_name":"initseq","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(initstate, initseq)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/random/pcg32.cr","line_number":42,"url":null},"def":{"name":"new","visibility":"Public","body":"new(Random::Secure.rand(UInt64::MIN..UInt64::MAX), Random::Secure.rand(UInt64::MIN..UInt64::MAX))"}}],"instance_methods":[{"html_id":"jump(delta)-instance-method","name":"jump","abstract":false,"args":[{"name":"delta","external_name":"delta","restriction":""}],"args_string":"(delta)","args_html":"(delta)","location":{"filename":"src/random/pcg32.cr","line_number":73,"url":null},"def":{"name":"jump","args":[{"name":"delta","external_name":"delta","restriction":""}],"visibility":"Public","body":"deltau64 = UInt64.new!(delta)\nacc_mult = 1_u64\nacc_plus = 0_u64\ncur_plus = @inc\ncur_mult = PCG_DEFAULT_MULTIPLIER_64\nwhile (deltau64 > 0)\n  if (deltau64 & 1) > 0\n    acc_mult = acc_mult &* cur_mult\n    acc_plus = (acc_plus &* cur_mult) &+ cur_plus\n  end\n  cur_plus = (cur_mult &+ 1) &* cur_plus\n  cur_mult = cur_mult &* cur_mult\n  deltau64 = deltau64 // 2\nend\n@state = (acc_mult &* @state) &+ acc_plus\n"}},{"html_id":"new_seed(initstate:UInt64,initseq=0_u64):UInt32-instance-method","name":"new_seed","abstract":false,"args":[{"name":"initstate","external_name":"initstate","restriction":"UInt64"},{"name":"initseq","default_value":"0_u64","external_name":"initseq","restriction":""}],"args_string":"(initstate : UInt64, initseq = 0_u64) : UInt32","args_html":"(initstate : <a href=\"../UInt64.html\">UInt64</a>, initseq = <span class=\"n\">0_u64</span>) : <a href=\"../UInt32.html\">UInt32</a>","location":{"filename":"src/random/pcg32.cr","line_number":57,"url":null},"def":{"name":"new_seed","args":[{"name":"initstate","external_name":"initstate","restriction":"UInt64"},{"name":"initseq","default_value":"0_u64","external_name":"initseq","restriction":""}],"return_type":"UInt32","visibility":"Public","body":"@state = 0_u64\n@inc = (initseq << 1) | 1\nnext_u\n@state = @state &+ initstate\nnext_u\n"}},{"html_id":"new_seed:UInt32-instance-method","name":"new_seed","abstract":false,"location":{"filename":"src/random/pcg32.cr","line_number":53,"url":null},"def":{"name":"new_seed","return_type":"UInt32","visibility":"Public","body":"new_seed(Random::Secure.rand(UInt64::MIN..UInt64::MAX), Random::Secure.rand(UInt64::MIN..UInt64::MAX))"}},{"html_id":"next_u:UInt32-instance-method","name":"next_u","doc":"Generates a random unsigned integer.\n\nThe integers must be uniformly distributed between `0` and\nthe maximal value for the chosen type.","summary":"<p>Generates a random unsigned integer.</p>","abstract":false,"location":{"filename":"src/random/pcg32.cr","line_number":65,"url":null},"def":{"name":"next_u","return_type":"UInt32","visibility":"Public","body":"oldstate = @state\n@state = (oldstate &* PCG_DEFAULT_MULTIPLIER_64) &+ @inc\nxorshifted = UInt32.new!(((oldstate >> 18) ^ oldstate) >> 27)\nrot = UInt32.new!(oldstate >> 59)\nreturn UInt32.new!((xorshifted >> rot) | (xorshifted << (((~rot) &+ 1) & 31)))\n"}}]},{"html_id":"Crystal/Random/Secure","path":"Random/Secure.html","kind":"module","full_name":"Random::Secure","name":"Secure","abstract":false,"locations":[{"filename":"src/random/secure.cr","line_number":18,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"extended_modules":[{"html_id":"Crystal/Random","kind":"module","full_name":"Random","name":"Random"},{"html_id":"Crystal/Random/Secure","kind":"module","full_name":"Random::Secure","name":"Secure"}],"namespace":{"html_id":"Crystal/Random","kind":"module","full_name":"Random","name":"Random"},"doc":"`Random::Secure` generates random numbers from a secure source provided by the system.\n\nIt uses a [cryptographically secure pseudorandom number generator (CSPRNG)](https://en.wikipedia.org/wiki/Cryptographically_secure_pseudorandom_number_generator)\nfor cryptography and secure usages such as generating secret keys, or to seed\nanother pseudorandom number generator (PRNG).\n\n```\nRandom::Secure.rand(6)            # => 4\n[1, 5, 6].shuffle(Random::Secure) # => [6, 1, 5]\n```\n\nOn OpenBSD, it uses [`arc4random`](https://man.openbsd.org/arc4random),\non Linux [`getrandom`](http://man7.org/linux/man-pages/man2/getrandom.2.html) (if the kernel supports it),\non Windows [`RtlGenRandom`](https://docs.microsoft.com/en-us/windows/win32/api/ntsecapi/nf-ntsecapi-rtlgenrandom),\nand falls back to reading from `/dev/urandom` on UNIX systems.","summary":"<p><code><a href=\"../Random/Secure.html\">Random::Secure</a></code> generates random numbers from a secure source provided by the system.</p>","instance_methods":[{"html_id":"next_u-instance-method","name":"next_u","abstract":false,"location":{"filename":"src/random/secure.cr","line_number":22,"url":null},"def":{"name":"next_u","visibility":"Public","body":"Crystal::System::Random.next_u"}},{"html_id":"random_bytes(buf:Bytes):Nil-instance-method","name":"random_bytes","abstract":false,"args":[{"name":"buf","external_name":"buf","restriction":"Bytes"}],"args_string":"(buf : Bytes) : Nil","args_html":"(buf : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/random/secure.cr","line_number":26,"url":null},"def":{"name":"random_bytes","args":[{"name":"buf","external_name":"buf","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"Crystal::System::Random.random_bytes(buf)"}}]}]},{"html_id":"Crystal/Range","path":"Range.html","kind":"struct","full_name":"Range(B, E)","name":"Range","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/range.cr","line_number":59,"url":null},{"filename":"src/range/bsearch.cr","line_number":70,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"}],"doc":"A `Range` represents an interval: a set of values with a beginning and an end.\n\nRanges may be constructed using the usual `new` method or with literals:\n\n```\nx..y  # an inclusive range, in mathematics: [x, y]\nx...y # an exclusive range, in mathematics: [x, y)\n(x..) # an endless range, in mathematics: >= x\n..y   # a beginless inclusive range, in mathematics: <= y\n...y  # a beginless exclusive range, in mathematics: < y\n```\n\nSee [`Range` literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/range.html) in the language reference.\n\nAn easy way to remember which one is inclusive and which one is exclusive it\nto think of the extra dot as if it pushes *y* further away, thus leaving it outside of the range.\n\nRanges typically involve integers, but can be created using arbitrary objects\nas long as they define `succ` (or `pred` for `reverse_each`), to get the\nnext element in the range, and `<` and `==`, to know when the range reached the end:\n\n```\n# Represents a string of 'x's.\nstruct Xs\n  include Comparable(Xs)\n\n  getter size\n\n  def initialize(@size : Int32)\n  end\n\n  def succ\n    Xs.new(@size + 1)\n  end\n\n  def <=>(other)\n    @size <=> other.size\n  end\n\n  def inspect(io)\n    @size.times { io << 'x' }\n  end\n\n  def to_s(io)\n    io << @size << ' '\n    inspect(io)\n  end\nend\n```\n\nAn example of using `Xs` to construct a range:\n\n```\nr = Xs.new(3)..Xs.new(6)\nr.to_s                 # => \"xxx..xxxxxx\"\nr.to_a                 # => [Xs.new(3), Xs.new(4), Xs.new(5), Xs.new(6)]\nr.includes?(Xs.new(5)) # => true\n```","summary":"<p>A <code><a href=\"Range.html\">Range</a></code> represents an interval: a set of values with a beginning and an end.</p>","constructors":[{"html_id":"new(begin__arg0:B,end__arg1:E,exclusive:Bool=false)-class-method","name":"new","doc":"Constructs a `Range` using the given beginning and end.\n\n```\nRange.new(1, 10)                  # => 1..10\nRange.new(1, 10, exclusive: true) # => 1...10\n```","summary":"<p>Constructs a <code><a href=\"Range.html\">Range</a></code> using the given beginning and end.</p>","abstract":false,"args":[{"name":"__arg0","external_name":"begin","restriction":"B"},{"name":"__arg1","external_name":"end","restriction":"E"},{"name":"exclusive","default_value":"false","external_name":"exclusive","restriction":"Bool"}],"args_string":"(begin __arg0 : B, end __arg1 : E, exclusive : Bool = false)","args_html":"(begin __arg0 : B, end __arg1 : E, exclusive : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>)","location":{"filename":"src/range.cr","line_number":89,"url":null},"def":{"name":"new","args":[{"name":"__arg0","external_name":"begin","restriction":"B"},{"name":"__arg1","external_name":"end","restriction":"E"},{"name":"exclusive","default_value":"false","external_name":"exclusive","restriction":"Bool"}],"visibility":"Public","body":"_ = Range(B, E).allocate\n_.initialize(__arg0, __arg1, exclusive)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"==(other:Range)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Range"}],"args_string":"(other : Range)","args_html":"(other : <a href=\"Range.html\">Range</a>)","location":{"filename":"src/range.cr","line_number":92,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Range"}],"visibility":"Public","body":"((@begin == (other.@begin)) && (@end == (other.@end))) && (@exclusive == (other.@exclusive))"}},{"html_id":"===(value)-instance-method","name":"===","doc":"Same as `includes?`, useful for the `case` expression.\n\n```\ncase 79\nwhen 1..50   then puts \"low\"\nwhen 51..75  then puts \"medium\"\nwhen 76..100 then puts \"high\"\nend\n```\n\nProduces:\n\n```text\nhigh\n```\n\nSee also: `Object#===`.","summary":"<p>Same as <code><a href=\"Range.html#includes%3F%28value%29%3ABool-instance-method\">#includes?</a></code>, useful for the <code>case</code> expression.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/range.cr","line_number":326,"url":null},"def":{"name":"===","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"includes?(value)"}},{"html_id":"begin:B-instance-method","name":"begin","doc":"Returns the object that defines the beginning of this range.\n\n```\n(1..10).begin  # => 1\n(1...10).begin # => 1\n```","summary":"<p>Returns the object that defines the beginning of this range.</p>","abstract":false,"location":{"filename":"src/range.cr","line_number":69,"url":null},"def":{"name":"begin","return_type":"B","visibility":"Public","body":"@begin"}},{"html_id":"bsearch(&block:B|E->_)-instance-method","name":"bsearch","doc":"By using binary search, returns the first element\nfor which the passed block returns a truthy value.\n\nIf the block returns a falsey value, the element to be found lies\nbehind. If the block returns a truthy value, the element to be found\nis itself or lies in front.\n\nReturns `nil` if the block didn't return a truthy value for any element.\n\n```\n(0..10).bsearch { |x| x >= 5 }                       # => 5\n(0..Float64::INFINITY).bsearch { |x| x ** 4 >= 256 } # => 4\n```","summary":"<p>By using binary search, returns the first element for which the passed block returns a truthy value.</p>","abstract":false,"location":{"filename":"src/range/bsearch.cr","line_number":84,"url":null},"def":{"name":"bsearch","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(B | E -> _)"},"visibility":"Public","body":"from = self.begin\nto = self.end\n{% for v in [\"from\", \"to\"] of ::String %}\n      if {{ v.id }}.is_a?(Float::Primitive)\n        return bsearch_internal from, to, self.excludes_end? do |value|\n          yield value\n        end\n      end\n    {% end %}\nsaved_to = to\nsatisfied = nil\nwhile from < to\n  mid = from + ((to - from) >> 1)\n  if yield mid\n    satisfied = mid\n    to = mid\n  else\n    from = mid + 1\n  end\nend\nif ((!self.excludes_end?) && (from == saved_to)) && (yield from)\n  satisfied = from\nend\nsatisfied\n"}},{"html_id":"clone-instance-method","name":"clone","doc":"Returns a new `Range` with `begin` and `end` cloned.","summary":"<p>Returns a new <code><a href=\"Range.html\">Range</a></code> with <code><a href=\"Range.html#begin%3AB-instance-method\">#begin</a></code> and <code><a href=\"Range.html#end%3AE-instance-method\">#end</a></code> cloned.</p>","abstract":false,"location":{"filename":"src/range.cr","line_number":412,"url":null},"def":{"name":"clone","visibility":"Public","body":"Range.new(@begin.clone, @end.clone, @exclusive)"}},{"html_id":"covers?(value)-instance-method","name":"covers?","doc":"Same as `includes?`.","summary":"<p>Same as <code><a href=\"Range.html#includes%3F%28value%29%3ABool-instance-method\">#includes?</a></code>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/range.cr","line_number":305,"url":null},"def":{"name":"covers?","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"includes?(value)"}},{"html_id":"cycle-instance-method","name":"cycle","doc":"Returns an `Iterator` that cycles over the values of this range.\n\n```\n(1..3).cycle.first(5).to_a # => [1, 2, 3, 1, 2]\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> that cycles over the values of this range.</p>","abstract":false,"location":{"filename":"src/range.cr","line_number":101,"url":null},"def":{"name":"cycle","visibility":"Public","body":"each.cycle"}},{"html_id":"each(&):Nil-instance-method","name":"each","doc":"Iterates over the elements of this range, passing each in turn to the block.\n\n```\n(10..15).each { |n| print n, ' ' }\n# prints: 10 11 12 13 14 15\n```","summary":"<p>Iterates over the elements of this range, passing each in turn to the block.</p>","abstract":false,"location":{"filename":"src/range.cr","line_number":111,"url":null},"def":{"name":"each","yields":1,"return_type":"Nil","visibility":"Public","body":"{% if B == Nil %}\n      {% raise(\"Can't each beginless range\") %}\n    {% end %}\ncurrent = @begin\nif current.nil?\n  raise(ArgumentError.new(\"Can't each beginless range\"))\nend\ntypeof(yield current)\n{% if E == Nil %}\n      while true\n        {{ \"yield current\".id }}\n        current = current.succ\n      end\n    {% else %}\n      end_value = @end\n      while end_value.nil? || current < end_value\n        {{ \"yield current\".id }}\n        current = current.succ\n      end\n      {{ \"yield current\".id }} if !@exclusive && current == end_value\n    {% end %}\n"}},{"html_id":"each-instance-method","name":"each","doc":"Returns an `Iterator` over the elements of this range.\n\n```\n(1..3).each.skip(1).to_a # => [2, 3]\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> over the elements of this range.</p>","abstract":false,"location":{"filename":"src/range.cr","line_number":144,"url":null},"def":{"name":"each","visibility":"Public","body":"{% if B == Nil %}\n      {% raise(\"Can't each beginless range\") %}\n    {% end %}\nif @begin.nil?\n  raise(ArgumentError.new(\"Can't each beginless range\"))\nend\nItemIterator.new(self)\n"}},{"html_id":"end:E-instance-method","name":"end","doc":"Returns the object that defines the end of the range.\n\n```\n(1..10).end  # => 10\n(1...10).end # => 10\n```","summary":"<p>Returns the object that defines the end of the range.</p>","abstract":false,"location":{"filename":"src/range.cr","line_number":77,"url":null},"def":{"name":"end","return_type":"E","visibility":"Public","body":"@end"}},{"html_id":"excludes_end?:Bool-instance-method","name":"excludes_end?","doc":"Returns `true` if this range excludes the *end* element.\n\n```\n(1..10).excludes_end?  # => false\n(1...10).excludes_end? # => true\n```","summary":"<p>Returns <code>true</code> if this range excludes the <em>end</em> element.</p>","abstract":false,"location":{"filename":"src/range.cr","line_number":279,"url":null},"def":{"name":"excludes_end?","return_type":"Bool","visibility":"Public","body":"@exclusive"}},{"html_id":"exclusive?:Bool-instance-method","name":"exclusive?","doc":"Returns `true` if the range is exclusive.\nReturns `false` otherwise (default).","summary":"<p>Returns <code>true</code> if the range is exclusive.</p>","abstract":false,"location":{"filename":"src/range.cr","line_number":81,"url":null},"def":{"name":"exclusive?","return_type":"Bool","visibility":"Public","body":"@exclusive"}},{"html_id":"includes?(value):Bool-instance-method","name":"includes?","doc":"Returns `true` if this range includes the given *value*.\n\n```\n(1..10).includes?(4)  # => true\n(1..10).includes?(10) # => true\n(1..10).includes?(11) # => false\n\n(1...10).includes?(9)  # => true\n(1...10).includes?(10) # => false\n```","summary":"<p>Returns <code>true</code> if this range includes the given <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : Bool","args_html":"(value) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/range.cr","line_number":293,"url":null},"def":{"name":"includes?","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"Bool","visibility":"Public","body":"begin_value = @begin\nend_value = @end\n(begin_value.nil? || value >= begin_value) && (end_value.nil? || (@exclusive ? value < end_value : value <= end_value))\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends this struct's name and instance variables names and values\nto the given IO.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np1.to_s    # \"Point(@x=1, @y=2)\"\np1.inspect # \"Point(@x=1, @y=2)\"\n```","summary":"<p>Appends this struct's name and instance variables names and values to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/range.cr","line_number":336,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"map(&block:B->U)forallU-instance-method","name":"map","doc":"Returns an `Array` with the results of running the block against each element of the collection.\n\n```\n[1, 2, 3].map { |i| i * 10 } # => [10, 20, 30]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with the results of running the block against each element of the collection.</p>","abstract":false,"location":{"filename":"src/range.cr","line_number":416,"url":null},"def":{"name":"map","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(B -> U)"},"visibility":"Public","body":"b = self.begin\ne = self.end\nif b.is_a?(Int) && e.is_a?(Int)\n  if @exclusive\n    e = e - 1\n  end\n  n = (e - b) + 1\n  if n < 0\n    n = 0\n  end\n  Array(U).new(n) do |i|\n    yield b + i\n  end\nelse\n  super() do |i|\n    yield i\n  end\nend\n"}},{"html_id":"reverse_each(&):Nil-instance-method","name":"reverse_each","doc":"Iterates over the elements of this range in reverse order,\npassing each in turn to the block.\n\n```\n(10...15).reverse_each { |n| print n, ' ' }\n# prints: 14 13 12 11 10\n```","summary":"<p>Iterates over the elements of this range in reverse order, passing each in turn to the block.</p>","abstract":false,"location":{"filename":"src/range.cr","line_number":163,"url":null},"def":{"name":"reverse_each","yields":1,"return_type":"Nil","visibility":"Public","body":"{% if E == Nil %}\n      {% raise(\"Can't reverse_each endless range\") %}\n    {% end %}\nend_value = @end\nif end_value.nil?\n  raise(ArgumentError.new(\"Can't reverse_each endless range\"))\nend\nbegin_value = @begin\nif (!@exclusive) && (begin_value.nil? || (!(end_value < begin_value)))\n  yield end_value\nend\ncurrent = end_value\n{% if B == Nil %}\n      while true\n        current = current.pred\n        {{ \"yield current\".id }}\n      end\n    {% else %}\n      while begin_value.nil? || begin_value < current\n        current = current.pred\n        {{ \"yield current\".id }}\n      end\n    {% end %}\n"}},{"html_id":"reverse_each-instance-method","name":"reverse_each","doc":"Returns a reverse `Iterator` over the elements of this range.\n\n```\n(1..3).reverse_each.skip(1).to_a # => [2, 1]\n```","summary":"<p>Returns a reverse <code><a href=\"Iterator.html\">Iterator</a></code> over the elements of this range.</p>","abstract":false,"location":{"filename":"src/range.cr","line_number":198,"url":null},"def":{"name":"reverse_each","visibility":"Public","body":"{% if E == Nil %}\n      {% raise(\"Can't reverse_each endless range\") %}\n    {% end %}\nif @end.nil?\n  raise(ArgumentError.new(\"Can't reverse_each endless range\"))\nend\nReverseIterator.new(self)\n"}},{"html_id":"sample(n:Int,random=Random::DEFAULT)-instance-method","name":"sample","doc":"Returns an `Array` of *n* random elements from `self`, using the given\n*random* number generator. All elements have equal probability of being\ndrawn. Sampling is done without replacement; if *n* is larger than the size\nof this collection, the returned `Array` has the same size as `self`.\n\nRaises `ArgumentError` if *n* is negative.\n\n```\n[1, 2, 3, 4, 5].sample(2)                # => [3, 5]\n{1, 2, 3, 4, 5}.sample(2)                # => [3, 4]\n{1, 2, 3, 4, 5}.sample(2, Random.new(1)) # => [1, 5]\n```\n\nIf `self` is not empty and `n` is equal to 1, calls `sample(random)` exactly\nonce. Thus, *random* will be left in a different state compared to the\nimplementation in `Enumerable`.","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of <em>n</em> random elements from <code>self</code>, using the given <em>random</em> number generator.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"},{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(n : Int, random = Random::DEFAULT)","args_html":"(n : <a href=\"Int.html\">Int</a>, random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>)","location":{"filename":"src/range.cr","line_number":393,"url":null},"def":{"name":"sample","args":[{"name":"n","external_name":"n","restriction":"Int"},{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"visibility":"Public","body":"{% if (B == Nil) || (E == Nil) %}\n      {% raise(\"Can't sample an open range\") %}\n    {% end %}\nif self.begin.nil? || self.end.nil?\n  raise(ArgumentError.new(\"Can't sample an open range\"))\nend\nif n == 1\nelse\n  return super(n, random)\nend\nif empty?\n  [] of B\nelse\n  [sample(random)]\nend\n"}},{"html_id":"sample(random=Random::DEFAULT)-instance-method","name":"sample","doc":"Optimized version of `Enumerable#sample` that runs in O(1) time when `self`\nis an `Int` or `Float` range. In these cases, this range is considered to be\na distribution of numeric values rather than a collection of elements, and\nthe method simply calls `random.rand(self)`.\n\nRaises `ArgumentError` if `self` is an open range.","summary":"<p>Optimized version of <code><a href=\"Enumerable.html#sample%28n%3AInt%2Crandom%3DRandom%3A%3ADEFAULT%29%3AArray%28T%29-instance-method\">Enumerable#sample</a></code> that runs in O(1) time when <code>self</code> is an <code><a href=\"Int.html\">Int</a></code> or <code><a href=\"Float.html\">Float</a></code> range.</p>","abstract":false,"args":[{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(random = Random::DEFAULT)","args_html":"(random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>)","location":{"filename":"src/range.cr","line_number":365,"url":null},"def":{"name":"sample","args":[{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"visibility":"Public","body":"{% if (B == Nil) || (E == Nil) %}\n      {% raise(\"Can't sample an open range\") %}\n    {% end %}\n{% if B < Int && E < Int %}\n      random.rand(self)\n    {% else %}{% if B < Float && E < Float %}\n      random.rand(self)\n    {% else %}{% if B.nilable? || E.nilable? %}\n      b = self.begin\n      e = self.end\n\n      if b.nil? || e.nil?\n        raise ArgumentError.new(\"Can't sample an open range\")\n      end\n\n      Range.new(b, e, @exclusive).sample(random)\n    {% else %}\n      super\n    {% end %}{% end %}{% end %}\n"}},{"html_id":"size-instance-method","name":"size","doc":"Returns the number of values in this range.\n\nIf both the beginning and the end of this range are `Int`s, runs in constant\ntime instead of linear.\n\n```\n(3..8).size  # => 5\n(3...8).size # => 6\n```","summary":"<p>Returns the number of values in this range.</p>","abstract":false,"location":{"filename":"src/range.cr","line_number":440,"url":null},"def":{"name":"size","visibility":"Public","body":"{% if (B == Nil) || (E == Nil) %}\n      {% raise(\"Can't calculate size of an open range\") %}\n    {% end %}\nb = self.begin\ne = self.end\nif b.is_a?(Int) && e.is_a?(Int)\n  if @exclusive\n    e = e - 1\n  end\n  n = (e - b) + 1\n  n < 0 ? 0 : n\nelse\n  if b.nil? || e.nil?\n    raise(ArgumentError.new(\"Can't calculate size of an open range\"))\n  end\n  super()\nend\n"}},{"html_id":"step(by=1,&):Nil-instance-method","name":"step","doc":"Iterates from `begin` to `end` incrementing by the amount of *step* on each\niteration.\n\n```\nary = [] of Int32\n(1..4).step(by: 2) do |x|\n  ary << x\nend\nary                      # => [1, 3]\n(1..4).step(by: 2).to_a  # => [1, 3]\n(1..4).step(by: 1).to_a  # => [1, 2, 3, 4]\n(1...4).step(by: 1).to_a # => [1, 2, 3]\n```\n\nIf `B` is a `Steppable`, implementation is delegated to `Steppable#step`.\nOtherwise `#succ` method is expected to be defined on `begin` and its\nsuccessors and iteration is based on calling `#succ` sequentially\n(*step* times per iteration).\n\nRaises `ArgumentError` if `begin` is `nil`.","summary":"<p>Iterates from <code><a href=\"Range.html#begin%3AB-instance-method\">#begin</a></code> to <code><a href=\"Range.html#end%3AE-instance-method\">#end</a></code> incrementing by the amount of <em>step</em> on each iteration.</p>","abstract":false,"args":[{"name":"by","default_value":"1","external_name":"by","restriction":""}],"args_string":"(by = 1, &) : Nil","args_html":"(by = <span class=\"n\">1</span>, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/range.cr","line_number":230,"url":null},"def":{"name":"step","args":[{"name":"by","default_value":"1","external_name":"by","restriction":""}],"yields":0,"return_type":"Nil","visibility":"Public","body":"current = @begin\nif current.nil?\n  raise(ArgumentError.new(\"Can't step beginless range\"))\nend\n{% if B < Steppable %}\n      current.step(to: @end, by: by, exclusive: @exclusive) do |x|\n        yield x\n      end\n    {% else %}\n      end_value = @end\n      while end_value.nil? || current < end_value\n        yield current\n        by.times do\n          current = current.succ\n          return if end_value && current > end_value\n        rescue exc : OverflowError\n          if current == end_value\n            return\n          else\n            raise exc\n          end\n        end\n      end\n      yield current if !@exclusive && current == @end\n    {% end %}\n"}},{"html_id":"step(by=1):Iterator-instance-method","name":"step","doc":"Iterates from `begin` to `end` incrementing by the amount of *step* on each\niteration.\n\n```\nary = [] of Int32\n(1..4).step(by: 2) do |x|\n  ary << x\nend\nary                      # => [1, 3]\n(1..4).step(by: 2).to_a  # => [1, 3]\n(1..4).step(by: 1).to_a  # => [1, 2, 3, 4]\n(1...4).step(by: 1).to_a # => [1, 2, 3]\n```\n\nIf `B` is a `Steppable`, implementation is delegated to `Steppable#step`.\nOtherwise `#succ` method is expected to be defined on `begin` and its\nsuccessors and iteration is based on calling `#succ` sequentially\n(*step* times per iteration).\n\nRaises `ArgumentError` if `begin` is `nil`.","summary":"<p>Iterates from <code><a href=\"Range.html#begin%3AB-instance-method\">#begin</a></code> to <code><a href=\"Range.html#end%3AE-instance-method\">#end</a></code> incrementing by the amount of <em>step</em> on each iteration.</p>","abstract":false,"args":[{"name":"by","default_value":"1","external_name":"by","restriction":""}],"args_string":"(by = 1) : Iterator","args_html":"(by = <span class=\"n\">1</span>) : <a href=\"Iterator.html\">Iterator</a>","location":{"filename":"src/range.cr","line_number":260,"url":null},"def":{"name":"step","args":[{"name":"by","default_value":"1","external_name":"by","restriction":""}],"return_type":"Iterator","visibility":"Public","body":"start = @begin\nif start.nil?\n  raise(ArgumentError.new(\"Can't step beginless range\"))\nend\n{% if B < Steppable %}\n      start.step(to: @end, by: by, exclusive: @exclusive)\n    {% else %}\n      StepIterator(self, B, typeof(by)).new(self, by)\n    {% end %}\n"}},{"html_id":"sum(initial)-instance-method","name":"sum","doc":"Optimized version of `Enumerable#sum` that runs in O(1) time when `self` is\nan `Int` range.","summary":"<p>Optimized version of <code><a href=\"Enumerable.html#sum-instance-method\">Enumerable#sum</a></code> that runs in O(1) time when <code>self</code> is an <code><a href=\"Int.html\">Int</a></code> range.</p>","abstract":false,"args":[{"name":"initial","external_name":"initial","restriction":""}],"args_string":"(initial)","args_html":"(initial)","location":{"filename":"src/range.cr","line_number":342,"url":null},"def":{"name":"sum","args":[{"name":"initial","external_name":"initial","restriction":""}],"visibility":"Public","body":"b = self.begin\ne = self.end\nif b.is_a?(Int) && e.is_a?(Int)\n  if @exclusive\n    e = e - 1\n  end\n  n = (e - b) + 1\n  if n >= 0\n    initial + ((n * (b + e)) // 2)\n  else\n    initial\n  end\nelse\n  super(initial)\nend\n"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Same as `#inspect(io)`.","summary":"<p>Same as <code><a href=\"Range.html#inspect%28io%3AIO%29%3ANil-instance-method\">#inspect(io)</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/range.cr","line_number":330,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"@begin.try(&.inspect(io))\nio << (@exclusive ? \"...\" : \"..\")\n@end.try(&.inspect(io))\n"}}]},{"html_id":"Crystal/Reference","path":"Reference.html","kind":"class","full_name":"Reference","name":"Reference","abstract":false,"superclass":{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"},"ancestors":[{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/any.cr","line_number":307,"url":null},{"filename":"src/primitives.cr","line_number":36,"url":null},{"filename":"src/reference.cr","line_number":15,"url":null},{"filename":"src/yaml/any.cr","line_number":346,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/Array","kind":"class","full_name":"Array(T)","name":"Array"},{"html_id":"Crystal/Benchmark/BM/Job","kind":"class","full_name":"Benchmark::BM::Job","name":"Job"},{"html_id":"Crystal/Benchmark/BM/Tms","kind":"class","full_name":"Benchmark::BM::Tms","name":"Tms"},{"html_id":"Crystal/Benchmark/IPS/Entry","kind":"class","full_name":"Benchmark::IPS::Entry","name":"Entry"},{"html_id":"Crystal/Benchmark/IPS/Job","kind":"class","full_name":"Benchmark::IPS::Job","name":"Job"},{"html_id":"Crystal/Box","kind":"class","full_name":"Box(T)","name":"Box"},{"html_id":"Crystal/Channel","kind":"class","full_name":"Channel(T)","name":"Channel"},{"html_id":"Crystal/Compress/Gzip/Header","kind":"class","full_name":"Compress::Gzip::Header","name":"Header"},{"html_id":"Crystal/Compress/Zip/File","kind":"class","full_name":"Compress::Zip::File","name":"File"},{"html_id":"Crystal/Compress/Zip/File/Entry","kind":"class","full_name":"Compress::Zip::File::Entry","name":"Entry"},{"html_id":"Crystal/Compress/Zip/Reader","kind":"class","full_name":"Compress::Zip::Reader","name":"Reader"},{"html_id":"Crystal/Compress/Zip/Reader/Entry","kind":"class","full_name":"Compress::Zip::Reader::Entry","name":"Entry"},{"html_id":"Crystal/Compress/Zip/Writer","kind":"class","full_name":"Compress::Zip::Writer","name":"Writer"},{"html_id":"Crystal/Compress/Zip/Writer/Entry","kind":"class","full_name":"Compress::Zip::Writer::Entry","name":"Entry"},{"html_id":"Crystal/Crypto/Bcrypt","kind":"class","full_name":"Crypto::Bcrypt","name":"Bcrypt"},{"html_id":"Crystal/Crypto/Bcrypt/Password","kind":"class","full_name":"Crypto::Bcrypt::Password","name":"Password"},{"html_id":"Crystal/Crypto/Blowfish","kind":"class","full_name":"Crypto::Blowfish","name":"Blowfish"},{"html_id":"Crystal/Crystal/Macros/ASTNode","kind":"class","full_name":"Crystal::Macros::ASTNode","name":"ASTNode"},{"html_id":"Crystal/Crystal/SyntaxHighlighter","kind":"class","full_name":"Crystal::SyntaxHighlighter","name":"SyntaxHighlighter"},{"html_id":"Crystal/CSV","kind":"class","full_name":"CSV","name":"CSV"},{"html_id":"Crystal/CSV/Builder","kind":"class","full_name":"CSV::Builder","name":"Builder"},{"html_id":"Crystal/CSV/Lexer","kind":"class","full_name":"CSV::Lexer","name":"Lexer"},{"html_id":"Crystal/CSV/Parser","kind":"class","full_name":"CSV::Parser","name":"Parser"},{"html_id":"Crystal/Deque","kind":"class","full_name":"Deque(T)","name":"Deque"},{"html_id":"Crystal/Digest","kind":"class","full_name":"Digest","name":"Digest"},{"html_id":"Crystal/Dir","kind":"class","full_name":"Dir","name":"Dir"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Fiber","kind":"class","full_name":"Fiber","name":"Fiber"},{"html_id":"Crystal/Hash","kind":"class","full_name":"Hash(K, V)","name":"Hash"},{"html_id":"Crystal/HTTP/Client","kind":"class","full_name":"HTTP::Client","name":"Client"},{"html_id":"Crystal/HTTP/Client/Response","kind":"class","full_name":"HTTP::Client::Response","name":"Response"},{"html_id":"Crystal/HTTP/CompressHandler","kind":"class","full_name":"HTTP::CompressHandler","name":"CompressHandler"},{"html_id":"Crystal/HTTP/Cookie","kind":"class","full_name":"HTTP::Cookie","name":"Cookie"},{"html_id":"Crystal/HTTP/Cookies","kind":"class","full_name":"HTTP::Cookies","name":"Cookies"},{"html_id":"Crystal/HTTP/ErrorHandler","kind":"class","full_name":"HTTP::ErrorHandler","name":"ErrorHandler"},{"html_id":"Crystal/HTTP/FormData/Builder","kind":"class","full_name":"HTTP::FormData::Builder","name":"Builder"},{"html_id":"Crystal/HTTP/FormData/Parser","kind":"class","full_name":"HTTP::FormData::Parser","name":"Parser"},{"html_id":"Crystal/HTTP/LogHandler","kind":"class","full_name":"HTTP::LogHandler","name":"LogHandler"},{"html_id":"Crystal/HTTP/Request","kind":"class","full_name":"HTTP::Request","name":"Request"},{"html_id":"Crystal/HTTP/Server","kind":"class","full_name":"HTTP::Server","name":"Server"},{"html_id":"Crystal/HTTP/Server/Context","kind":"class","full_name":"HTTP::Server::Context","name":"Context"},{"html_id":"Crystal/HTTP/Server/RequestProcessor","kind":"class","full_name":"HTTP::Server::RequestProcessor","name":"RequestProcessor"},{"html_id":"Crystal/HTTP/StaticFileHandler","kind":"class","full_name":"HTTP::StaticFileHandler","name":"StaticFileHandler"},{"html_id":"Crystal/HTTP/WebSocket","kind":"class","full_name":"HTTP::WebSocket","name":"WebSocket"},{"html_id":"Crystal/HTTP/WebSocketHandler","kind":"class","full_name":"HTTP::WebSocketHandler","name":"WebSocketHandler"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Iterator/Stop","kind":"class","full_name":"Iterator::Stop","name":"Stop"},{"html_id":"Crystal/JSON/Builder","kind":"class","full_name":"JSON::Builder","name":"Builder"},{"html_id":"Crystal/JSON/Lexer","kind":"class","full_name":"JSON::Lexer","name":"Lexer"},{"html_id":"Crystal/JSON/Parser","kind":"class","full_name":"JSON::Parser","name":"Parser"},{"html_id":"Crystal/JSON/PullParser","kind":"class","full_name":"JSON::PullParser","name":"PullParser"},{"html_id":"Crystal/JSON/Token","kind":"class","full_name":"JSON::Token","name":"Token"},{"html_id":"Crystal/Levenshtein/Finder","kind":"class","full_name":"Levenshtein::Finder","name":"Finder"},{"html_id":"Crystal/LLVM/ABI","kind":"class","full_name":"LLVM::ABI","name":"ABI"},{"html_id":"Crystal/LLVM/ABI/FunctionType","kind":"class","full_name":"LLVM::ABI::FunctionType","name":"FunctionType"},{"html_id":"Crystal/LLVM/Builder","kind":"class","full_name":"LLVM::Builder","name":"Builder"},{"html_id":"Crystal/LLVM/Context","kind":"class","full_name":"LLVM::Context","name":"Context"},{"html_id":"Crystal/LLVM/FunctionPassManager","kind":"class","full_name":"LLVM::FunctionPassManager","name":"FunctionPassManager"},{"html_id":"Crystal/LLVM/GenericValue","kind":"class","full_name":"LLVM::GenericValue","name":"GenericValue"},{"html_id":"Crystal/LLVM/JITCompiler","kind":"class","full_name":"LLVM::JITCompiler","name":"JITCompiler"},{"html_id":"Crystal/LLVM/MemoryBuffer","kind":"class","full_name":"LLVM::MemoryBuffer","name":"MemoryBuffer"},{"html_id":"Crystal/LLVM/Module","kind":"class","full_name":"LLVM::Module","name":"Module"},{"html_id":"Crystal/LLVM/ModulePassManager","kind":"class","full_name":"LLVM::ModulePassManager","name":"ModulePassManager"},{"html_id":"Crystal/LLVM/PassManagerBuilder","kind":"class","full_name":"LLVM::PassManagerBuilder","name":"PassManagerBuilder"},{"html_id":"Crystal/LLVM/TargetMachine","kind":"class","full_name":"LLVM::TargetMachine","name":"TargetMachine"},{"html_id":"Crystal/Log","kind":"class","full_name":"Log","name":"Log"},{"html_id":"Crystal/Log/AsyncDispatcher","kind":"class","full_name":"Log::AsyncDispatcher","name":"AsyncDispatcher"},{"html_id":"Crystal/Log/Backend","kind":"class","full_name":"Log::Backend","name":"Backend"},{"html_id":"Crystal/Log/Builder","kind":"class","full_name":"Log::Builder","name":"Builder"},{"html_id":"Crystal/Log/EntriesChecker","kind":"class","full_name":"Log::EntriesChecker","name":"EntriesChecker"},{"html_id":"Crystal/Log/Metadata","kind":"class","full_name":"Log::Metadata","name":"Metadata"},{"html_id":"Crystal/Log/SyncDispatcher","kind":"class","full_name":"Log::SyncDispatcher","name":"SyncDispatcher"},{"html_id":"Crystal/MIME/Multipart/Builder","kind":"class","full_name":"MIME::Multipart::Builder","name":"Builder"},{"html_id":"Crystal/MIME/Multipart/Parser","kind":"class","full_name":"MIME::Multipart::Parser","name":"Parser"},{"html_id":"Crystal/Mutex","kind":"class","full_name":"Mutex","name":"Mutex"},{"html_id":"Crystal/OAuth2/AccessToken","kind":"class","full_name":"OAuth2::AccessToken","name":"AccessToken"},{"html_id":"Crystal/OAuth2/Client","kind":"class","full_name":"OAuth2::Client","name":"Client"},{"html_id":"Crystal/OAuth2/Session","kind":"class","full_name":"OAuth2::Session","name":"Session"},{"html_id":"Crystal/OAuth/AccessToken","kind":"class","full_name":"OAuth::AccessToken","name":"AccessToken"},{"html_id":"Crystal/OAuth/Consumer","kind":"class","full_name":"OAuth::Consumer","name":"Consumer"},{"html_id":"Crystal/OAuth/RequestToken","kind":"class","full_name":"OAuth::RequestToken","name":"RequestToken"},{"html_id":"Crystal/OpenSSL/Cipher","kind":"class","full_name":"OpenSSL::Cipher","name":"Cipher"},{"html_id":"Crystal/OpenSSL/HMAC","kind":"class","full_name":"OpenSSL::HMAC","name":"HMAC"},{"html_id":"Crystal/OpenSSL/MD5","kind":"class","full_name":"OpenSSL::MD5","name":"MD5"},{"html_id":"Crystal/OpenSSL/SHA1","kind":"class","full_name":"OpenSSL::SHA1","name":"SHA1"},{"html_id":"Crystal/OpenSSL/SSL/Context","kind":"class","full_name":"OpenSSL::SSL::Context","name":"Context"},{"html_id":"Crystal/OpenSSL/SSL/Server","kind":"class","full_name":"OpenSSL::SSL::Server","name":"Server"},{"html_id":"Crystal/OptionParser","kind":"class","full_name":"OptionParser","name":"OptionParser"},{"html_id":"Crystal/PrettyPrint","kind":"class","full_name":"PrettyPrint","name":"PrettyPrint"},{"html_id":"Crystal/Process","kind":"class","full_name":"Process","name":"Process"},{"html_id":"Crystal/Process/Status","kind":"class","full_name":"Process::Status","name":"Status"},{"html_id":"Crystal/Random/ISAAC","kind":"class","full_name":"Random::ISAAC","name":"ISAAC"},{"html_id":"Crystal/Random/PCG32","kind":"class","full_name":"Random::PCG32","name":"PCG32"},{"html_id":"Crystal/Regex","kind":"class","full_name":"Regex","name":"Regex"},{"html_id":"Crystal/Spec/Context","kind":"class","full_name":"Spec::Context","name":"Context"},{"html_id":"Crystal/Spec/Example","kind":"class","full_name":"Spec::Example","name":"Example"},{"html_id":"Crystal/Steppable/StepIterator","kind":"class","full_name":"Steppable::StepIterator(T, L, B)","name":"StepIterator"},{"html_id":"Crystal/String","kind":"class","full_name":"String","name":"String"},{"html_id":"Crystal/StringPool","kind":"class","full_name":"StringPool","name":"StringPool"},{"html_id":"Crystal/StringScanner","kind":"class","full_name":"StringScanner","name":"StringScanner"},{"html_id":"Crystal/System/Group","kind":"class","full_name":"System::Group","name":"Group"},{"html_id":"Crystal/System/User","kind":"class","full_name":"System::User","name":"User"},{"html_id":"Crystal/Time/Location","kind":"class","full_name":"Time::Location","name":"Location"},{"html_id":"Crystal/URI","kind":"class","full_name":"URI","name":"URI"},{"html_id":"Crystal/URI/Params/Builder","kind":"class","full_name":"URI::Params::Builder","name":"Builder"},{"html_id":"Crystal/URI/Punycode","kind":"class","full_name":"URI::Punycode","name":"Punycode"},{"html_id":"Crystal/WeakRef","kind":"class","full_name":"WeakRef(T)","name":"WeakRef"},{"html_id":"Crystal/XML/Attributes","kind":"class","full_name":"XML::Attributes","name":"Attributes"},{"html_id":"Crystal/XML/Builder","kind":"class","full_name":"XML::Builder","name":"Builder"},{"html_id":"Crystal/XML/Namespace","kind":"class","full_name":"XML::Namespace","name":"Namespace"},{"html_id":"Crystal/XML/Node","kind":"class","full_name":"XML::Node","name":"Node"},{"html_id":"Crystal/XML/NodeSet","kind":"class","full_name":"XML::NodeSet","name":"NodeSet"},{"html_id":"Crystal/XML/Reader","kind":"class","full_name":"XML::Reader","name":"Reader"},{"html_id":"Crystal/XML/XPathContext","kind":"class","full_name":"XML::XPathContext","name":"XPathContext"},{"html_id":"Crystal/YAML/Builder","kind":"class","full_name":"YAML::Builder","name":"Builder"},{"html_id":"Crystal/YAML/Nodes/Builder","kind":"class","full_name":"YAML::Nodes::Builder","name":"Builder"},{"html_id":"Crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},{"html_id":"Crystal/YAML/ParseContext","kind":"class","full_name":"YAML::ParseContext","name":"ParseContext"},{"html_id":"Crystal/YAML/PullParser","kind":"class","full_name":"YAML::PullParser","name":"PullParser"}],"doc":"`Reference` is the base class of classes you define in your program.\nIt is set as a class' superclass when you don't specify one:\n\n```\nclass MyClass # < Reference\nend\n```\n\nA reference type is passed by reference: when you pass it to methods,\nreturn it from methods or assign it to variables, a pointer is actually passed.\n\nInvoking `new` on a `Reference` allocates a new instance on the heap.\nThe instance's memory is automatically freed (garbage-collected) when\nthe instance is no longer referred by any other entity in the program.","summary":"<p><code><a href=\"Reference.html\">Reference</a></code> is the base class of classes you define in your program.</p>","constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/primitives.cr","line_number":36,"url":null},"def":{"name":"new","visibility":"Public","body":"x = allocate\nif x.responds_to?(:finalize)\n  ::GC.add_finalizer(x)\nend\nx\n"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this reference is the same as *other*. Invokes `same?`.","summary":"<p>Returns <code>true</code> if this reference is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/reference.cr","line_number":17,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"same?(other)"}},{"html_id":"==(other:JSON::Any)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"JSON::Any"}],"args_string":"(other : JSON::Any)","args_html":"(other : <a href=\"JSON/Any.html\">JSON::Any</a>)","location":{"filename":"src/json/any.cr","line_number":308,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"JSON::Any"}],"visibility":"Public","body":"self == other.raw"}},{"html_id":"==(other:YAML::Any)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"YAML::Any"}],"args_string":"(other : YAML::Any)","args_html":"(other : <a href=\"YAML/Any.html\">YAML::Any</a>)","location":{"filename":"src/yaml/any.cr","line_number":347,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"YAML::Any"}],"visibility":"Public","body":"self == other.raw"}},{"html_id":"==(other)-instance-method","name":"==","doc":"Returns `false` (other can only be a `Value` here).","summary":"<p>Returns <code>false</code> (other can only be a <code><a href=\"Value.html\">Value</a></code> here).</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/reference.cr","line_number":22,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"false"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy of this object.\n\nThis allocates a new object and copies the contents of\n`self` into it.","summary":"<p>Returns a shallow copy of this object.</p>","abstract":false,"location":{"filename":"src/reference.cr","line_number":41,"url":null},"def":{"name":"dup","visibility":"Public","body":"{% if @type.abstract? %}\n      # This shouldn't happen, as the type is abstract,\n      # but we need to avoid the allocate invocation below\n      raise \"Can't dup {{ @type }}\"\n    {% else %}\n      dup = self.class.allocate\n      dup.as(Void*).copy_from(self.as(Void*), instance_sizeof(self))\n      GC.add_finalizer(dup) if dup.responds_to?(:finalize)\n      dup\n    {% end %}"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/reference.cr","line_number":55,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher.reference(self)"}},{"html_id":"initialize-instance-method","name":"initialize","abstract":false,"location":{"filename":"src/primitives.cr","line_number":36,"url":null},"def":{"name":"initialize","visibility":"Public","body":""}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/reference.cr","line_number":71,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"((io << \"#<\") << ({{ @type.name.id.stringify }})) << \":0x\"\nobject_id.to_s(io, 16)\nexecuted = exec_recursive(:inspect) do\n  {% for ivar, i in @type.instance_vars %}\n        {% if i > 0 %}\n          io << ','\n        {% end %}\n        io << \" @{{ ivar.id }}=\"\n        @{{ ivar.id }}.inspect io\n      {% end %}\nend\nif executed\nelse\n  io << \" ...\"\nend\nio << '>'\n"}},{"html_id":"object_id:UInt64-instance-method","name":"object_id","doc":"Returns a `UInt64` that uniquely identifies this object.\n\nThe returned value is the memory address of this object.\n\n```\nstring = \"hello\"\nstring.object_id # => 4460249568\n\npointer = Pointer(String).new(string.object_id)\nstring2 = pointer.as(String)\nstring2.object_id == string.object_id # => true\n```","summary":"<p>Returns a <code><a href=\"UInt64.html\">UInt64</a></code> that uniquely identifies this object.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":50,"url":null},"def":{"name":"object_id","return_type":"UInt64","visibility":"Public","body":"# primitive: object_id"}},{"html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","args_html":"(pp) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/reference.cr","line_number":90,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"return_type":"Nil","visibility":"Public","body":"{% if @type.overrides?(Reference, \"inspect\") %}\n      pp.text inspect\n    {% else %}\n      prefix = \"#<#{{{ @type.name.id.stringify }}}:0x#{object_id.to_s(16)}\"\n      executed = exec_recursive(:pretty_print) do\n        pp.surround(prefix, \">\", left_break: nil, right_break: nil) do\n          {% for ivar, i in @type.instance_vars.map(&.name).sort %}\n            {% if i == 0 %}\n              pp.breakable\n            {% else %}\n              pp.comma\n            {% end %}\n            pp.group do\n              pp.text \"@{{ ivar.id }}=\"\n              pp.nest do\n                pp.breakable \"\"\n                @{{ ivar.id }}.pretty_print(pp)\n              end\n            end\n          {% end %}\n        end\n      end\n      unless executed\n        pp.text \"#{prefix} ...>\"\n      end\n    {% end %}"}},{"html_id":"same?(other:Reference):Bool-instance-method","name":"same?","doc":"Returns `true` if this reference is the same as *other*. This is only\n`true` if this reference's `object_id` is the same as *other*'s.","summary":"<p>Returns <code>true</code> if this reference is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Reference"}],"args_string":"(other : Reference) : Bool","args_html":"(other : <a href=\"Reference.html\">Reference</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/reference.cr","line_number":28,"url":null},"def":{"name":"same?","args":[{"name":"other","external_name":"other","restriction":"Reference"}],"return_type":"Bool","visibility":"Public","body":"object_id == other.object_id"}},{"html_id":"same?(other:Nil)-instance-method","name":"same?","doc":"Returns `false`: a reference is never `nil`.","summary":"<p>Returns <code>false</code>: a reference is never <code>nil</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Nil"}],"args_string":"(other : Nil)","args_html":"(other : <a href=\"Nil.html\">Nil</a>)","location":{"filename":"src/reference.cr","line_number":33,"url":null},"def":{"name":"same?","args":[{"name":"other","external_name":"other","restriction":"Nil"}],"visibility":"Public","body":"false"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a short String representation of this object\nwhich includes its class name and its object address.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).to_s # => #<Person:0x10a199f20>\n```","summary":"<p>Appends a short String representation of this object which includes its class name and its object address.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/reference.cr","line_number":130,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"((io << \"#<\") << self.class.name) << \":0x\"\nobject_id.to_s(io, 16)\nio << '>'\n"}}]},{"html_id":"Crystal/Regex","path":"Regex.html","kind":"class","full_name":"Regex","name":"Regex","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/any.cr","line_number":325,"url":null},{"filename":"src/regex.cr","line_number":197,"url":null},{"filename":"src/regex/match_data.cr","line_number":1,"url":null},{"filename":"src/yaml/any.cr","line_number":364,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"SPECIAL_CHARACTERS","name":"SPECIAL_CHARACTERS","value":"{' ', '.', '\\\\', '+', '*', '?', '[', '^', ']', '$', '(', ')', '{', '}', '=', '!', '<', '>', '|', ':', '-'}","doc":"List of metacharacters that need to be escaped.\n\nSee `Regex.needs_escape?` and `Regex.escape`.","summary":"<p>List of metacharacters that need to be escaped.</p>"}],"doc":"A `Regex` represents a regular expression, a pattern that describes the\ncontents of strings. A `Regex` can determine whether or not a string matches\nits description, and extract the parts of the string that match.\n\nA `Regex` can be created using the literal syntax, in which it is delimited by\nforward slashes (`/`):\n\n```\n/hay/ =~ \"haystack\"   # => 0\n/y/.match(\"haystack\") # => Regex::MatchData(\"y\")\n```\n\nSee [`Regex` literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/regex.html) in the language reference.\n\nInterpolation works in regular expression literals just as it does in string\nliterals. Be aware that using this feature will cause an exception to be\nraised at runtime, if the resulting string would not be a valid regular\nexpression.\n\n```\nx = \"a\"\n/#{x}/.match(\"asdf\") # => Regex::MatchData(\"a\")\nx = \"(\"\n/#{x}/ # raises ArgumentError\n```\n\nWhen we check to see if a particular regular expression describes a string,\nwe can say that we are performing a match or matching one against the other.\nIf we find that a regular expression does describe a string, we say that it\nmatches, and we can refer to a part of the string that was described as\na match.\n\nHere `\"haystack\"` does not contain the pattern `/needle/`, so it doesn't match:\n\n```\n/needle/.match(\"haystack\") # => nil\n```\n\nHere `\"haystack\"` contains the pattern `/hay/`, so it matches:\n\n```\n/hay/.match(\"haystack\") # => Regex::MatchData(\"hay\")\n```\n\nRegex methods that perform a match usually return a truthy value if there was\na match and `nil` if there was no match. After performing a match, the\nspecial variable `$~` will be an instance of `Regex::MatchData` if it matched, `nil`\notherwise.\n\nWhen matching a regular expression using `=~` (either `String#=~` or\n`Regex#=~`), the returned value will be the index of the first match in the\nstring if the expression matched, `nil` otherwise.\n\n```\n/stack/ =~ \"haystack\"  # => 3\n\"haystack\" =~ /stack/  # => 3\n$~                     # => Regex::MatchData(\"stack\")\n/needle/ =~ \"haystack\" # => nil\n\"haystack\" =~ /needle/ # => nil\n$~                     # raises Exception\n```\n\nWhen matching a regular expression using `#match` (either `String#match` or\n`Regex#match`), the returned value will be a `Regex::MatchData` if the expression\nmatched, `nil` otherwise.\n\n```\n/hay/.match(\"haystack\")    # => Regex::MatchData(\"hay\")\n\"haystack\".match(/hay/)    # => Regex::MatchData(\"hay\")\n$~                         # => Regex::MatchData(\"hay\")\n/needle/.match(\"haystack\") # => nil\n\"haystack\".match(/needle/) # => nil\n$~                         # raises Exception\n```\n\n[Regular expressions](https://en.wikipedia.org/wiki/Regular_expression)\nhave their own language for describing strings.\n\nMany programming languages and tools implement their own regular expression\nlanguage, but Crystal uses [PCRE](http://www.pcre.org/), a popular C library, with\n[JIT complication](http://www.pcre.org/original/doc/html/pcrejit.html) enabled\nfor providing regular expressions. Here give a brief summary of the most\nbasic features of regular expressions - grouping, repetition, and\nalternation - but the feature set of PCRE extends far beyond these, and we\ndon't attempt to describe it in full here. For more information, refer to\nthe PCRE documentation, especially the\n[full pattern syntax](http://www.pcre.org/original/doc/html/pcrepattern.html)\nor\n[syntax quick reference](http://www.pcre.org/original/doc/html/pcresyntax.html).\n\nThe regular expression language can be used to match much more than just the\nstatic substrings in the above examples. Certain characters, called\n[metacharacters](http://www.pcre.org/original/doc/html/pcrepattern.html#SEC4),\nare given special treatment in regular expressions, and can be used to\ndescribe more complex patterns. To match metacharacters literally in a\nregular expression, they must be escaped by being preceded with a backslash\n(`\\`). `escape` will do this automatically for a given String.\n\nA group of characters (often called a capture group or\n[subpattern](http://www.pcre.org/original/doc/html/pcrepattern.html#SEC14))\ncan be identified by enclosing it in parentheses (`()`). The contents of\neach capture group can be extracted on a successful match:\n\n```\n/a(sd)f/.match(\"_asdf_\")                     # => Regex::MatchData(\"asdf\" 1:\"sd\")\n/a(sd)f/.match(\"_asdf_\").try &.[1]           # => \"sd\"\n/a(?<grp>sd)f/.match(\"_asdf_\")               # => Regex::MatchData(\"asdf\" grp:\"sd\")\n/a(?<grp>sd)f/.match(\"_asdf_\").try &.[\"grp\"] # => \"sd\"\n```\n\nCapture groups are indexed starting from 1. Methods that accept a capture\ngroup index will usually also accept 0 to refer to the full match. Capture\ngroups can also be given names, using the `(?&lt;name&gt;...)` syntax, as in the\nprevious example.\n\nFollowing a match, the special variables $N (e.g., $1, $2, $3, ...) can be used\nto access a capture group. Trying to access an invalid capture group will raise an\nexception. Note that it is possible to have a successful match with a nil capture:\n\n```\n/(spice)(s)?/.match(\"spice\") # => Regex::MatchData(\"spice\" 1:\"spice\" 2:nil)\n$1                           # => \"spice\"\n$2                           # => raises Exception\n```\n\nThis can be mitigated by using the nilable version of the above: $N?,\n(e.g., $1? $2?, $3?, ...). Changing the above to use `$2?` instead of `$2`\nwould return `nil`. `$2?.nil?` would return `true`.\n\nA character or group can be\n[repeated](http://www.pcre.org/original/doc/html/pcrepattern.html#SEC17)\nor made optional using an asterisk (`*` - zero or more), a plus sign\n(`+` - one or more), integer bounds in curly braces\n(`{n,m}`) (at least `n`, no more than `m`), or a question mark\n(`?`) (zero or one).\n\n```\n/fo*/.match(\"_f_\")         # => Regex::MatchData(\"f\")\n/fo+/.match(\"_f_\")         # => nil\n/fo*/.match(\"_foo_\")       # => Regex::MatchData(\"foo\")\n/fo{3,}/.match(\"_foo_\")    # => nil\n/fo{1,3}/.match(\"_foo_\")   # => Regex::MatchData(\"foo\")\n/fo*/.match(\"_foo_\")       # => Regex::MatchData(\"foo\")\n/fo*/.match(\"_foooooooo_\") # => Regex::MatchData(\"foooooooo\")\n/fo{,3}/.match(\"_foooo_\")  # => nil\n/f(op)*/.match(\"fopopo\")   # => Regex::MatchData(\"fopop\" 1:\"op\")\n/foo?bar/.match(\"foobar\")  # => Regex::MatchData(\"foobar\")\n/foo?bar/.match(\"fobar\")   # => Regex::MatchData(\"fobar\")\n```\n\nAlternatives can be separated using a\n[vertical bar](http://www.pcre.org/original/doc/html/pcrepattern.html#SEC12)\n(`|`). Any single character can be represented by\n[dot](http://www.pcre.org/original/doc/html/pcrepattern.html#SEC7)\n(`.`). When matching only one character, specific\nalternatives can be expressed as a\n[character class](http://www.pcre.org/original/doc/html/pcrepattern.html#SEC9),\nenclosed in square brackets (`[]`):\n\n```\n/foo|bar/.match(\"foo\")     # => Regex::MatchData(\"foo\")\n/foo|bar/.match(\"bar\")     # => Regex::MatchData(\"bar\")\n/_(x|y)_/.match(\"_x_\")     # => Regex::MatchData(\"_x_\" 1:\"x\")\n/_(x|y)_/.match(\"_y_\")     # => Regex::MatchData(\"_y_\" 1:\"y\")\n/_(x|y)_/.match(\"_(x|y)_\") # => nil\n/_(x|y)_/.match(\"_(x|y)_\") # => nil\n/_._/.match(\"_x_\")         # => Regex::MatchData(\"_x_\")\n/_[xyz]_/.match(\"_x_\")     # => Regex::MatchData(\"_x_\")\n/_[a-z]_/.match(\"_x_\")     # => Regex::MatchData(\"_x_\")\n/_[^a-z]_/.match(\"_x_\")    # => nil\n/_[^a-wy-z]_/.match(\"_x_\") # => Regex::MatchData(\"_x_\")\n```\n\nRegular expressions can be defined with these 3\n[optional flags](http://www.pcre.org/original/doc/html/pcreapi.html#SEC11):\n\n* `i`: ignore case (PCRE_CASELESS)\n* `m`: multiline (PCRE_MULTILINE and PCRE_DOTALL)\n* `x`: extended (PCRE_EXTENDED)\n\n```\n/asdf/ =~ \"ASDF\"    # => nil\n/asdf/i =~ \"ASDF\"   # => 0\n/^z/i =~ \"ASDF\\nZ\"  # => nil\n/^z/im =~ \"ASDF\\nZ\" # => 5\n```\n\nPCRE supports other encodings, but Crystal strings are UTF-8 only, so Crystal\nregular expressions are also UTF-8 only (by default).\n\nPCRE optionally permits named capture groups (named subpatterns) to not be\nunique. Crystal exposes the name table of a `Regex` as a\n`Hash` of `String` => `Int32`, and therefore requires named capture groups to have\nunique names within a single `Regex`.","summary":"<p>A <code><a href=\"Regex.html\">Regex</a></code> represents a regular expression, a pattern that describes the contents of strings.</p>","class_methods":[{"html_id":"error?(source):String?-class-method","name":"error?","doc":"Determines Regex's source validity. If it is, `nil` is returned.\nIf it's not, a `String` containing the error message is returned.\n\n```\nRegex.error?(\"(foo|bar)\") # => nil\nRegex.error?(\"(foo|bar\")  # => \"missing ) at 8\"\n```","summary":"<p>Determines Regex's source validity.</p>","abstract":false,"args":[{"name":"source","external_name":"source","restriction":""}],"args_string":"(source) : String?","args_html":"(source) : <a href=\"String.html\">String</a>?","location":{"filename":"src/regex.cr","line_number":279,"url":null},"def":{"name":"error?","args":[{"name":"source","external_name":"source","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"re = LibPCRE.compile(source, ((Options::UTF_8 | Options::NO_UTF8_CHECK) | Options::DUPNAMES), out errptr, out erroffset, nil)\nif re\n  nil\nelse\n  \"#{String.new(errptr)} at #{erroffset}\"\nend\n"}},{"html_id":"escape(str):String-class-method","name":"escape","doc":"Returns a `String` constructed by escaping any metacharacters in *str*.\n\n```\nstring = Regex.escape(\"*?{}.\") # => \"\\\\*\\\\?\\\\{\\\\}\\\\.\"\n/#{string}/                    # => /\\*\\?\\{\\}\\./\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> constructed by escaping any metacharacters in <em>str</em>.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":""}],"args_string":"(str) : String","args_html":"(str) : <a href=\"String.html\">String</a>","location":{"filename":"src/regex.cr","line_number":315,"url":null},"def":{"name":"escape","args":[{"name":"str","external_name":"str","restriction":""}],"return_type":"String","visibility":"Public","body":"String.build do |result|\n  str.each_byte do |byte|\n    {% if true %}\n          case byte.unsafe_chr\n          when {{ *SPECIAL_CHARACTERS }}\n            result << '\\\\'\n            result.write_byte byte\n          else\n            result.write_byte byte\n          end\n        {% end %}\n  end\nend"}},{"html_id":"needs_escape?(char:Char):Bool-class-method","name":"needs_escape?","doc":"Returns `true` if *char* need to be escaped, `false` otherwise.\n\n```\nRegex.needs_escape?('*') # => true\nRegex.needs_escape?('@') # => false\n```","summary":"<p>Returns <code>true</code> if <em>char</em> need to be escaped, <code>false</code> otherwise.</p>","abstract":false,"args":[{"name":"char","external_name":"char","restriction":"Char"}],"args_string":"(char : Char) : Bool","args_html":"(char : <a href=\"Char.html\">Char</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/regex.cr","line_number":294,"url":null},"def":{"name":"needs_escape?","args":[{"name":"char","external_name":"char","restriction":"Char"}],"return_type":"Bool","visibility":"Public","body":"SPECIAL_CHARACTERS.includes?(char)"}},{"html_id":"needs_escape?(str:String):Bool-class-method","name":"needs_escape?","doc":"Returns `true` if *str* need to be escaped, `false` otherwise.\n\n```\nRegex.needs_escape?(\"10$\") # => true\nRegex.needs_escape?(\"foo\") # => false\n```","summary":"<p>Returns <code>true</code> if <em>str</em> need to be escaped, <code>false</code> otherwise.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"String"}],"args_string":"(str : String) : Bool","args_html":"(str : <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/regex.cr","line_number":304,"url":null},"def":{"name":"needs_escape?","args":[{"name":"str","external_name":"str","restriction":"String"}],"return_type":"Bool","visibility":"Public","body":"str.each_char do |char|\n  if SPECIAL_CHARACTERS.includes?(char)\n    return true\n  end\nend\nfalse\n"}}],"constructors":[{"html_id":"new(source:String,options:Options=Options::None)-class-method","name":"new","doc":"Creates a new `Regex` out of the given source `String`.\n\n```\nRegex.new(\"^a-z+:\\\\s+\\\\w+\")                   # => /^a-z+:\\s+\\w+/\nRegex.new(\"cat\", Regex::Options::IGNORE_CASE) # => /cat/i\noptions = Regex::Options::IGNORE_CASE | Regex::Options::EXTENDED\nRegex.new(\"dog\", options) # => /dog/ix\n```","summary":"<p>Creates a new <code><a href=\"Regex.html\">Regex</a></code> out of the given source <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"source","external_name":"source","restriction":"String"},{"name":"options","default_value":"Options::None","external_name":"options","restriction":"Options"}],"args_string":"(source : String, options : Options = Options::None)","args_html":"(source : <a href=\"String.html\">String</a>, options : <a href=\"Regex/Options.html\">Options</a> = <span class=\"t\">Options</span><span class=\"t\">::</span><span class=\"t\">None</span>)","location":{"filename":"src/regex.cr","line_number":256,"url":null},"def":{"name":"new","args":[{"name":"source","external_name":"source","restriction":"String"},{"name":"options","default_value":"Options::None","external_name":"options","restriction":"Options"}],"visibility":"Public","body":"_ = allocate\n_.initialize(source, options)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"union(patterns:Enumerable(Regex|String)):self-class-method","name":"union","doc":"Union. Returns a `Regex` that matches any of *patterns*.\n\nAll capture groups in the patterns after the first one will have their\nindexes offset.\n\n```\nre = Regex.union([/skiing/i, \"sledding\"])\nre.match(\"Skiing\")   # => Regex::MatchData(\"Skiing\")\nre.match(\"sledding\") # => Regex::MatchData(\"sledding\")\nre = Regex.union({/skiing/i, \"sledding\"})\nre.match(\"Skiing\")   # => Regex::MatchData(\"Skiing\")\nre.match(\"sledding\") # => Regex::MatchData(\"sledding\")\n```","summary":"<p>Union.</p>","abstract":false,"args":[{"name":"patterns","external_name":"patterns","restriction":"Enumerable(Regex | String)"}],"args_string":"(patterns : Enumerable(Regex | String)) : self","args_html":"(patterns : <a href=\"Enumerable.html\">Enumerable</a>(<a href=\"Regex.html\">Regex</a> | <a href=\"String.html\">String</a>)) : <span class=\"k\">self</span>","location":{"filename":"src/regex.cr","line_number":344,"url":null},"def":{"name":"union","args":[{"name":"patterns","external_name":"patterns","restriction":"Enumerable(Regex | String)"}],"return_type":"self","visibility":"Public","body":"new(patterns.map do |pattern|\n  union_part(pattern)\nend.join('|'))"}},{"html_id":"union(*patterns:Regex|String):self-class-method","name":"union","doc":"Union. Returns a `Regex` that matches any of *patterns*.\n\nAll capture groups in the patterns after the first one will have their\nindexes offset.\n\n```\nre = Regex.union(/skiing/i, \"sledding\")\nre.match(\"Skiing\")   # => Regex::MatchData(\"Skiing\")\nre.match(\"sledding\") # => Regex::MatchData(\"sledding\")\n```","summary":"<p>Union.</p>","abstract":false,"args":[{"name":"patterns","external_name":"patterns","restriction":"Regex | String"}],"args_string":"(*patterns : Regex | String) : self","args_html":"(*patterns : <a href=\"Regex.html\">Regex</a> | <a href=\"String.html\">String</a>) : <span class=\"k\">self</span>","location":{"filename":"src/regex.cr","line_number":358,"url":null},"def":{"name":"union","args":[{"name":"patterns","external_name":"patterns","restriction":"Regex | String"}],"splat_index":0,"return_type":"self","visibility":"Public","body":"union(patterns)"}}],"instance_methods":[{"html_id":"+(other):Regex-instance-method","name":"+","doc":"Union. Returns a `Regex` that matches either of the operands.\n\nAll capture groups in the second operand will have their indexes\noffset.\n\n```\nre = /skiing/i + /sledding/\nre.match(\"Skiing\")   # => Regex::MatchData(\"Skiing\")\nre.match(\"sledding\") # => Regex::MatchData(\"sledding\")\n```","summary":"<p>Union.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other) : Regex","args_html":"(other) : <a href=\"Regex.html\">Regex</a>","location":{"filename":"src/regex.cr","line_number":380,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":""}],"return_type":"Regex","visibility":"Public","body":"Regex.union(self, other)"}},{"html_id":"==(other:Regex)-instance-method","name":"==","doc":"Equality. Two regexes are equal if their sources and options are the same.\n\n```\n/abc/ == /abc/i  # => false\n/abc/i == /ABC/i # => false\n/abc/i == /abc/i # => true\n```","summary":"<p>Equality.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Regex"}],"args_string":"(other : Regex)","args_html":"(other : <a href=\"Regex.html\">Regex</a>)","location":{"filename":"src/regex.cr","line_number":391,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Regex"}],"visibility":"Public","body":"(source == other.source) && (options == other.options)"}},{"html_id":"===(other:String)-instance-method","name":"===","doc":"Case equality. This is equivalent to `#match` or `#=~` but only returns\n`true` or `false`. Used in `case` expressions. The special variable\n`$~` will contain a `Regex::MatchData` if there was a match, `nil` otherwise.\n\n```\na = \"HELLO\"\nb = case a\n    when /^[a-z]*$/\n      \"Lower case\"\n    when /^[A-Z]*$/\n      \"Upper case\"\n    else\n      \"Mixed case\"\n    end\nb # => \"Upper case\"\n```","summary":"<p>Case equality.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"String"}],"args_string":"(other : String)","args_html":"(other : <a href=\"String.html\">String</a>)","location":{"filename":"src/regex.cr","line_number":418,"url":null},"def":{"name":"===","args":[{"name":"other","external_name":"other","restriction":"String"}],"visibility":"Public","body":"match = match(other)\n$~ = match\n!match.nil?\n"}},{"html_id":"===(other:JSON::Any)-instance-method","name":"===","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"JSON::Any"}],"args_string":"(other : JSON::Any)","args_html":"(other : <a href=\"JSON/Any.html\">JSON::Any</a>)","location":{"filename":"src/json/any.cr","line_number":326,"url":null},"def":{"name":"===","args":[{"name":"other","external_name":"other","restriction":"JSON::Any"}],"visibility":"Public","body":"value = self === other.raw\n$~ = $~\nvalue\n"}},{"html_id":"===(other:YAML::Any)-instance-method","name":"===","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"YAML::Any"}],"args_string":"(other : YAML::Any)","args_html":"(other : <a href=\"YAML/Any.html\">YAML::Any</a>)","location":{"filename":"src/yaml/any.cr","line_number":365,"url":null},"def":{"name":"===","args":[{"name":"other","external_name":"other","restriction":"YAML::Any"}],"visibility":"Public","body":"value = self === other.raw\n$~ = $~\nvalue\n"}},{"html_id":"=~(other:String):Int32?-instance-method","name":"=~","doc":"Match. Matches a regular expression against *other* and returns\nthe starting position of the match if *other* is a matching `String`,\notherwise `nil`. `$~` will contain a `Regex::MatchData` if there was a match,\n`nil` otherwise.\n\n```\n/at/ =~ \"input data\" # => 7\n/ax/ =~ \"input data\" # => nil\n```","summary":"<p>Match.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"String"}],"args_string":"(other : String) : Int32?","args_html":"(other : <a href=\"String.html\">String</a>) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/regex.cr","line_number":433,"url":null},"def":{"name":"=~","args":[{"name":"other","external_name":"other","restriction":"String"}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"match = self.match(other)\n$~ = match\nmatch.try(&.begin(0))\n"}},{"html_id":"=~(other):Nil-instance-method","name":"=~","doc":"Match. When the argument is not a `String`, always returns `nil`.\n\n```\n/at/ =~ \"input data\" # => 7\n/ax/ =~ \"input data\" # => nil\n```","summary":"<p>Match.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other) : Nil","args_html":"(other) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/regex.cr","line_number":445,"url":null},"def":{"name":"=~","args":[{"name":"other","external_name":"other","restriction":""}],"return_type":"Nil","visibility":"Public","body":"nil"}},{"html_id":"capture_count:Int32-instance-method","name":"capture_count","doc":"Returns the number of (named & non-named) capture groups.\n\n```\n/(?:.+)/.capture_count     # => 0\n/(?<foo>.+)/.capture_count # => 1\n/(.)/.capture_count        # => 1\n/(.)|(.)/.capture_count    # => 2\n```","summary":"<p>Returns the number of (named &amp; non-named) capture groups.</p>","abstract":false,"location":{"filename":"src/regex.cr","line_number":583,"url":null},"def":{"name":"capture_count","return_type":"Int32","visibility":"Public","body":"LibPCRE.full_info(@re, @extra, LibPCRE::INFO_CAPTURECOUNT, out capture_count)\ncapture_count\n"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/regex.cr","line_number":636,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy of this object.\n\nThis allocates a new object and copies the contents of\n`self` into it.","summary":"<p>Returns a shallow copy of this object.</p>","abstract":false,"location":{"filename":"src/regex.cr","line_number":632,"url":null},"def":{"name":"dup","visibility":"Public","body":"self"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/regex.cr","line_number":268,"url":null},"def":{"name":"finalize","visibility":"Public","body":"LibPCRE.free_study(@extra)"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/regex.cr","line_number":396,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = source.hash(hasher)\nhasher = options.hash(hasher)\nhasher\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Convert to `String` in literal format. Returns the source as a `String` in\nRegex literal format, delimited in forward slashes (`/`), with any\noptional flags included.\n\n```\n/ab+c/ix.inspect # => \"/ab+c/ix\"\n```","summary":"<p>Convert to <code><a href=\"String.html\">String</a></code> in literal format.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/regex.cr","line_number":456,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << '/'\nRegex.append_source(source, io)\nio << '/'\nif options.ignore_case?\n  io << 'i'\nend\nif options.multiline?\n  io << 'm'\nend\nif options.extended?\n  io << 'x'\nend\n"}},{"html_id":"match(str,pos=0,options=Regex::Options::None):MatchData?-instance-method","name":"match","doc":"Match at character index. Matches a regular expression against `String`\n*str*. Starts at the character index given by *pos* if given, otherwise at\nthe start of *str*. Returns a `Regex::MatchData` if *str* matched, otherwise\n`nil`. `$~` will contain the same value that was returned.\n\n```\n/(.)(.)(.)/.match(\"abc\").try &.[2]   # => \"b\"\n/(.)(.)/.match(\"abc\", 1).try &.[2]   # => \"c\"\n/(.)(.)/.match(\"クリスタル\", 3).try &.[2] # => \"ル\"\n```","summary":"<p>Match at character index.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":""},{"name":"pos","default_value":"0","external_name":"pos","restriction":""},{"name":"options","default_value":"Regex::Options::None","external_name":"options","restriction":""}],"args_string":"(str, pos = 0, options = Regex::Options::None) : MatchData?","args_html":"(str, pos = <span class=\"n\">0</span>, options = <span class=\"t\">Regex</span><span class=\"t\">::</span><span class=\"t\">Options</span><span class=\"t\">::</span><span class=\"t\">None</span>) : <a href=\"Regex/MatchData.html\">MatchData</a>?","location":{"filename":"src/regex.cr","line_number":475,"url":null},"def":{"name":"match","args":[{"name":"str","external_name":"str","restriction":""},{"name":"pos","default_value":"0","external_name":"pos","restriction":""},{"name":"options","default_value":"Regex::Options::None","external_name":"options","restriction":""}],"return_type":"MatchData | ::Nil","visibility":"Public","body":"if byte_index = str.char_index_to_byte_index(pos)\n  match = match_at_byte_index(str, byte_index, options)\nelse\n  match = nil\nend\n$~ = match\n"}},{"html_id":"match_at_byte_index(str,byte_index=0,options=Regex::Options::None):MatchData?-instance-method","name":"match_at_byte_index","doc":"Match at byte index. Matches a regular expression against `String`\n*str*. Starts at the byte index given by *pos* if given, otherwise at\nthe start of *str*. Returns a `Regex::MatchData` if *str* matched, otherwise\n`nil`. `$~` will contain the same value that was returned.\n\n```\n/(.)(.)(.)/.match_at_byte_index(\"abc\").try &.[2]   # => \"b\"\n/(.)(.)/.match_at_byte_index(\"abc\", 1).try &.[2]   # => \"c\"\n/(.)(.)/.match_at_byte_index(\"クリスタル\", 3).try &.[2] # => \"ス\"\n```","summary":"<p>Match at byte index.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":""},{"name":"byte_index","default_value":"0","external_name":"byte_index","restriction":""},{"name":"options","default_value":"Regex::Options::None","external_name":"options","restriction":""}],"args_string":"(str, byte_index = 0, options = Regex::Options::None) : MatchData?","args_html":"(str, byte_index = <span class=\"n\">0</span>, options = <span class=\"t\">Regex</span><span class=\"t\">::</span><span class=\"t\">Options</span><span class=\"t\">::</span><span class=\"t\">None</span>) : <a href=\"Regex/MatchData.html\">MatchData</a>?","location":{"filename":"src/regex.cr","line_number":495,"url":null},"def":{"name":"match_at_byte_index","args":[{"name":"str","external_name":"str","restriction":""},{"name":"byte_index","default_value":"0","external_name":"byte_index","restriction":""},{"name":"options","default_value":"Regex::Options::None","external_name":"options","restriction":""}],"return_type":"MatchData | ::Nil","visibility":"Public","body":"if byte_index > str.bytesize\n  return (  $~ = nil)\nend\novector_size = (@captures + 1) * 3\novector = Pointer(Int32).malloc(ovector_size)\nif internal_matches?(str, byte_index, options, ovector, ovector_size)\n  match = MatchData.new(self, @re, str, byte_index, ovector, @captures)\nelse\n  match = nil\nend\n$~ = match\n"}},{"html_id":"matches?(str,pos=0,options=Regex::Options::None):Bool-instance-method","name":"matches?","doc":"Match at character index. It behaves like `#match`, however it returns `Bool` value.\nIt neither returns `MatchData` nor assigns it to the `$~` variable.\n\n```\n/foo/.matches?(\"bar\") # => false\n/foo/.matches?(\"foo\") # => true\n\n# `$~` is not set even if last match succeeds.\n$~ # raises Exception\n```","summary":"<p>Match at character index.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":""},{"name":"pos","default_value":"0","external_name":"pos","restriction":""},{"name":"options","default_value":"Regex::Options::None","external_name":"options","restriction":""}],"args_string":"(str, pos = 0, options = Regex::Options::None) : Bool","args_html":"(str, pos = <span class=\"n\">0</span>, options = <span class=\"t\">Regex</span><span class=\"t\">::</span><span class=\"t\">Options</span><span class=\"t\">::</span><span class=\"t\">None</span>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/regex.cr","line_number":519,"url":null},"def":{"name":"matches?","args":[{"name":"str","external_name":"str","restriction":""},{"name":"pos","default_value":"0","external_name":"pos","restriction":""},{"name":"options","default_value":"Regex::Options::None","external_name":"options","restriction":""}],"return_type":"Bool","visibility":"Public","body":"if byte_index = str.char_index_to_byte_index(pos)\n  matches_at_byte_index?(str, byte_index, options)\nelse\n  false\nend"}},{"html_id":"matches_at_byte_index?(str,byte_index=0,options=Regex::Options::None):Bool-instance-method","name":"matches_at_byte_index?","doc":"Match at byte index. It behaves like `#match_at_byte_index`, however it returns `Bool` value.\nIt neither returns `MatchData` nor assigns it to the `$~` variable.","summary":"<p>Match at byte index.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":""},{"name":"byte_index","default_value":"0","external_name":"byte_index","restriction":""},{"name":"options","default_value":"Regex::Options::None","external_name":"options","restriction":""}],"args_string":"(str, byte_index = 0, options = Regex::Options::None) : Bool","args_html":"(str, byte_index = <span class=\"n\">0</span>, options = <span class=\"t\">Regex</span><span class=\"t\">::</span><span class=\"t\">Options</span><span class=\"t\">::</span><span class=\"t\">None</span>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/regex.cr","line_number":529,"url":null},"def":{"name":"matches_at_byte_index?","args":[{"name":"str","external_name":"str","restriction":""},{"name":"byte_index","default_value":"0","external_name":"byte_index","restriction":""},{"name":"options","default_value":"Regex::Options::None","external_name":"options","restriction":""}],"return_type":"Bool","visibility":"Public","body":"if byte_index > str.bytesize\n  return false\nend\ninternal_matches?(str, byte_index, options, nil, 0)\n"}},{"html_id":"name_table:Hash(Int32,String)-instance-method","name":"name_table","doc":"Returns a `Hash` where the values are the names of capture groups and the\nkeys are their indexes. Non-named capture groups will not have entries in\nthe `Hash`. Capture groups are indexed starting from `1`.\n\n```\n/(.)/.name_table                         # => {}\n/(?<foo>.)/.name_table                   # => {1 => \"foo\"}\n/(?<foo>.)(?<bar>.)/.name_table          # => {2 => \"bar\", 1 => \"foo\"}\n/(.)(?<foo>.)(.)(?<bar>.)(.)/.name_table # => {4 => \"bar\", 2 => \"foo\"}\n```","summary":"<p>Returns a <code><a href=\"Hash.html\">Hash</a></code> where the values are the names of capture groups and the keys are their indexes.</p>","abstract":false,"location":{"filename":"src/regex.cr","line_number":552,"url":null},"def":{"name":"name_table","return_type":"Hash(Int32, String)","visibility":"Public","body":"LibPCRE.full_info(@re, @extra, LibPCRE::INFO_NAMECOUNT, out name_count)\nLibPCRE.full_info(@re, @extra, LibPCRE::INFO_NAMEENTRYSIZE, out name_entry_size)\ntable_pointer = Pointer(UInt8).null\nLibPCRE.full_info(@re, @extra, LibPCRE::INFO_NAMETABLE, (pointerof(table_pointer)).as(Pointer(Int32)))\nname_table = table_pointer.to_slice(name_entry_size * name_count)\nlookup = Hash(Int32, String).new\nname_count.times do |i|\n  capture_offset = i * name_entry_size\n  capture_number = (name_table[capture_offset].to_u16 << 8).to_i32 | name_table[capture_offset + 1]\n  name_offset = capture_offset + 2\n  checked = name_table[name_offset, name_entry_size - 3]\n  name = String.new(checked.to_unsafe)\n  lookup[capture_number] = name\nend\nlookup\n"}},{"html_id":"options:Options-instance-method","name":"options","doc":"Returns a `Regex::Options` representing the optional flags applied to this `Regex`.\n\n```\n/ab+c/ix.options      # => Regex::Options::IGNORE_CASE | Regex::Options::EXTENDED\n/ab+c/ix.options.to_s # => \"IGNORE_CASE | EXTENDED\"\n```","summary":"<p>Returns a <code><a href=\"Regex/Options.html\">Regex::Options</a></code> representing the optional flags applied to this <code><a href=\"Regex.html\">Regex</a></code>.</p>","abstract":false,"location":{"filename":"src/regex.cr","line_number":239,"url":null},"def":{"name":"options","return_type":"Options","visibility":"Public","body":"@options"}},{"html_id":"source:String-instance-method","name":"source","doc":"Returns the original `String` representation of the `Regex` pattern.\n\n```\n/ab+c/x.source # => \"ab+c\"\n```","summary":"<p>Returns the original <code><a href=\"String.html\">String</a></code> representation of the <code><a href=\"Regex.html\">Regex</a></code> pattern.</p>","abstract":false,"location":{"filename":"src/regex.cr","line_number":246,"url":null},"def":{"name":"source","return_type":"String","visibility":"Public","body":"@source"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Convert to `String` in subpattern format. Produces a `String` which can be\nembedded in another `Regex` via interpolation, where it will be interpreted\nas a non-capturing subexpression in another regular expression.\n\n```\nre = /A*/i                 # => /A*/i\nre.to_s                    # => \"(?i-msx:A*)\"\n\"Crystal\".match(/t#{re}l/) # => Regex::MatchData(\"tal\")\nre = /A*/                  # => \"(?-imsx:A*)\"\n\"Crystal\".match(/t#{re}l/) # => nil\n```","summary":"<p>Convert to <code><a href=\"String.html\">String</a></code> in subpattern format.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/regex.cr","line_number":599,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"(?\"\nif options.ignore_case?\n  io << 'i'\nend\nif options.multiline?\n  io << \"ms\"\nend\nif options.extended?\n  io << 'x'\nend\nio << '-'\nif options.ignore_case?\nelse\n  io << 'i'\nend\nif options.multiline?\nelse\n  io << \"ms\"\nend\nif options.extended?\nelse\n  io << 'x'\nend\nio << ':'\nRegex.append_source(source, io)\nio << ')'\n"}}],"types":[{"html_id":"Crystal/Regex/MatchData","path":"Regex/MatchData.html","kind":"struct","full_name":"Regex::MatchData","name":"MatchData","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/regex/match_data.cr","line_number":18,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Regex","kind":"class","full_name":"Regex","name":"Regex"},"doc":"`Regex::MatchData` is the type of the special variable `$~`, and is the type\nreturned by `Regex#match` and `String#match`. It encapsulates all the\nresults of a regular expression match.\n\n```\nif md = \"Crystal\".match(/[p-s]/)\n  md.string # => \"Crystal\"\n  md[0]     # => \"r\"\n  md[1]?    # => nil\nend\n```\n\nMany `Regex::MatchData` methods deal with capture groups, and accept an integer\nargument to select the desired capture group. Capture groups are numbered\nstarting from `1`, so that `0` can be used to refer to the entire regular\nexpression without needing to capture it explicitly.","summary":"<p><code><a href=\"../Regex/MatchData.html\">Regex::MatchData</a></code> is the type of the special variable <code>$~</code>, and is the type returned by <code><a href=\"../Regex.html#match%28str%2Cpos%3D0%2Coptions%3DRegex%3A%3AOptions%3A%3ANone%29%3AMatchData%3F-instance-method\">Regex#match</a></code> and <code><a href=\"../String.html#match%28regex%3ARegex%2Cpos%3D0%29%3ARegex%3A%3AMatchData%3F-instance-method\">String#match</a></code>.</p>","instance_methods":[{"html_id":"==(other:Regex::MatchData)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Regex::MatchData"}],"args_string":"(other : Regex::MatchData)","args_html":"(other : <a href=\"../Regex/MatchData.html\">Regex::MatchData</a>)","location":{"filename":"src/regex/match_data.cr","line_number":395,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Regex::MatchData"}],"visibility":"Public","body":"if size == other.size\nelse\n  return false\nend\nif regex == other.regex\nelse\n  return false\nend\nif string == other.string\nelse\n  return false\nend\nreturn (@ovector.memcmp(other.@ovector, size * 2)) == 0\n"}},{"html_id":"[](start:Int,count:Int):Array(String)-instance-method","name":"[]","doc":"Returns count or less (if there aren't enough) matches starting at the\ngiven start index.","summary":"<p>Returns count or less (if there aren't enough) matches starting at the given start index.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int) : Array(String)","args_html":"(start : <a href=\"../Int.html\">Int</a>, count : <a href=\"../Int.html\">Int</a>) : <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)","location":{"filename":"src/regex/match_data.cr","line_number":217,"url":null},"def":{"name":"[]","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"Array(String)","visibility":"Public","body":"self[start, count]? || (raise(IndexError.new))"}},{"html_id":"[](n:Int):String-instance-method","name":"[]","doc":"Returns the match of the *n*th capture group, or raises an `IndexError`\nif there is no *n*th capture group.\n\n```\n\"Crystal\".match(/r(ys)/).not_nil![1] # => \"ys\"\n\"Crystal\".match(/r(ys)/).not_nil![2] # raises IndexError\n```","summary":"<p>Returns the match of the <em>n</em>th capture group, or raises an <code><a href=\"../IndexError.html\">IndexError</a></code> if there is no <em>n</em>th capture group.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"}],"args_string":"(n : Int) : String","args_html":"(n : <a href=\"../Int.html\">Int</a>) : <a href=\"../String.html\">String</a>","location":{"filename":"src/regex/match_data.cr","line_number":144,"url":null},"def":{"name":"[]","args":[{"name":"n","external_name":"n","restriction":"Int"}],"return_type":"String","visibility":"Public","body":"check_index_out_of_bounds(n)\nif n < 0\n  n = n + size\nend\nvalue = self[n]?\nif value.nil?\n  raise_capture_group_was_not_matched(n)\nend\nvalue\n"}},{"html_id":"[](group_name:String):String-instance-method","name":"[]","doc":"Returns the match of the capture group named by *group_name*, or\nraises an `KeyError` if there is no such named capture group.\n\n```\n\"Crystal\".match(/r(?<ok>ys)/).not_nil![\"ok\"] # => \"ys\"\n\"Crystal\".match(/r(?<ok>ys)/).not_nil![\"ng\"] # raises KeyError\n```\n\nWhen there are capture groups having same name, it returns the last\nmatched capture group.\n\n```\n\"Crystal\".match(/(?<ok>Cr).*(?<ok>al)/).not_nil![\"ok\"] # => \"al\"\n```","summary":"<p>Returns the match of the capture group named by <em>group_name</em>, or raises an <code><a href=\"../KeyError.html\">KeyError</a></code> if there is no such named capture group.</p>","abstract":false,"args":[{"name":"group_name","external_name":"group_name","restriction":"String"}],"args_string":"(group_name : String) : String","args_html":"(group_name : <a href=\"../String.html\">String</a>) : <a href=\"../String.html\">String</a>","location":{"filename":"src/regex/match_data.cr","line_number":194,"url":null},"def":{"name":"[]","args":[{"name":"group_name","external_name":"group_name","restriction":"String"}],"return_type":"String","visibility":"Public","body":"match = self[group_name]?\nif match\nelse\n  named_capture_number(group_name) do\n    raise(KeyError.new(\"Capture group '#{group_name}' was not matched\"))\n  end\n  raise(KeyError.new(\"Capture group '#{group_name}' does not exist\"))\nend\nmatch\n"}},{"html_id":"[](range:Range):Array(String)-instance-method","name":"[]","doc":"Returns all matches that are within the given range.","summary":"<p>Returns all matches that are within the given range.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range) : Array(String)","args_html":"(range : <a href=\"../Range.html\">Range</a>) : <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)","location":{"filename":"src/regex/match_data.cr","line_number":206,"url":null},"def":{"name":"[]","args":[{"name":"range","external_name":"range","restriction":"Range"}],"return_type":"Array(String)","visibility":"Public","body":"self[*(Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new))]"}},{"html_id":"[]?(start:Int,count:Int):Array(String)?-instance-method","name":"[]?","doc":"Like `#[](Int, Int)` but returns `nil` if the *start* index is out of range.","summary":"<p>Like <code><a href=\"../Regex/MatchData.html#%5B%5D%28start%3AInt%2Ccount%3AInt%29%3AArray%28String%29-instance-method\">#[](Int, Int)</a></code> but returns <code>nil</code> if the <em>start</em> index is out of range.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int) : Array(String)?","args_html":"(start : <a href=\"../Int.html\">Int</a>, count : <a href=\"../Int.html\">Int</a>) : <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)?","location":{"filename":"src/regex/match_data.cr","line_number":222,"url":null},"def":{"name":"[]?","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"Array(String) | ::Nil","visibility":"Public","body":"start, count = Indexable.normalize_start_and_count(start, count, size) do\n  return nil\nend\nArray(String).new(count) do |i|\n  self[start + i]\nend\n"}},{"html_id":"[]?(n:Int):String?-instance-method","name":"[]?","doc":"Returns the match of the *n*th capture group, or `nil` if there isn't\nan *n*th capture group.\n\nWhen *n* is `0`, returns the match for the entire `Regex`.\n\n```\n\"Crystal\".match(/r(ys)/).not_nil![0]? # => \"rys\"\n\"Crystal\".match(/r(ys)/).not_nil![1]? # => \"ys\"\n\"Crystal\".match(/r(ys)/).not_nil![2]? # => nil\n```","summary":"<p>Returns the match of the <em>n</em>th capture group, or <code>nil</code> if there isn't an <em>n</em>th capture group.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":"Int"}],"args_string":"(n : Int) : String?","args_html":"(n : <a href=\"../Int.html\">Int</a>) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/regex/match_data.cr","line_number":127,"url":null},"def":{"name":"[]?","args":[{"name":"n","external_name":"n","restriction":"Int"}],"return_type":"String | ::Nil","visibility":"Public","body":"if valid_group?(n)\nelse\n  return\nend\nif n < 0\n  n = n + size\nend\nstart = @ovector[n * 2]\nfinish = @ovector[(n * 2) + 1]\nif start < 0\n  return\nend\n@string.byte_slice(start, finish - start)\n"}},{"html_id":"[]?(group_name:String):String?-instance-method","name":"[]?","doc":"Returns the match of the capture group named by *group_name*, or\n`nil` if there is no such named capture group.\n\n```\n\"Crystal\".match(/r(?<ok>ys)/).not_nil![\"ok\"]? # => \"ys\"\n\"Crystal\".match(/r(?<ok>ys)/).not_nil![\"ng\"]? # => nil\n```\n\nWhen there are capture groups having same name, it returns the last\nmatched capture group.\n\n```\n\"Crystal\".match(/(?<ok>Cr).*(?<ok>al)/).not_nil![\"ok\"]? # => \"al\"\n```","summary":"<p>Returns the match of the capture group named by <em>group_name</em>, or <code>nil</code> if there is no such named capture group.</p>","abstract":false,"args":[{"name":"group_name","external_name":"group_name","restriction":"String"}],"args_string":"(group_name : String) : String?","args_html":"(group_name : <a href=\"../String.html\">String</a>) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/regex/match_data.cr","line_number":167,"url":null},"def":{"name":"[]?","args":[{"name":"group_name","external_name":"group_name","restriction":"String"}],"return_type":"String | ::Nil","visibility":"Public","body":"max_start = -1\nmatch = nil\nnamed_capture_number(group_name) do |n|\n  start = @ovector[n * 2]\n  if start > max_start\n    max_start = start\n    match = self[n]?\n  end\nend\nmatch\n"}},{"html_id":"[]?(range:Range):Array(String)?-instance-method","name":"[]?","doc":"Like `#[](Range)`, but returns `nil` if the range's start is out of range.","summary":"<p>Like <code><a href=\"../Regex/MatchData.html#%5B%5D%28n%3AInt%29%3AString-instance-method\">#[](Range)</a></code>, but returns <code>nil</code> if the range's start is out of range.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range) : Array(String)?","args_html":"(range : <a href=\"../Range.html\">Range</a>) : <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)?","location":{"filename":"src/regex/match_data.cr","line_number":211,"url":null},"def":{"name":"[]?","args":[{"name":"range","external_name":"range","restriction":"Range"}],"return_type":"Array(String) | ::Nil","visibility":"Public","body":"self[*(Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new))]?"}},{"html_id":"begin(n=0):Int32-instance-method","name":"begin","doc":"Returns the position of the first character of the *n*th match.\n\nWhen *n* is `0` or not given, uses the match of the entire `Regex`.\nOtherwise, uses the match of the *n*th capture group.\n\n```\n\"Crystal\".match(/r/).not_nil!.begin(0)     # => 1\n\"Crystal\".match(/r(ys)/).not_nil!.begin(1) # => 2\n\"クリスタル\".match(/リ(ス)/).not_nil!.begin(0)    # => 1\n```","summary":"<p>Returns the position of the first character of the <em>n</em>th match.</p>","abstract":false,"args":[{"name":"n","default_value":"0","external_name":"n","restriction":""}],"args_string":"(n = 0) : Int32","args_html":"(n = <span class=\"n\">0</span>) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/regex/match_data.cr","line_number":67,"url":null},"def":{"name":"begin","args":[{"name":"n","default_value":"0","external_name":"n","restriction":""}],"return_type":"Int32","visibility":"Public","body":"(@string.byte_index_to_char_index(byte_begin(n))).not_nil!"}},{"html_id":"byte_begin(n=0):Int32-instance-method","name":"byte_begin","doc":"Returns the position of the first byte of the *n*th match.\n\nWhen *n* is `0` or not given, uses the match of the entire `Regex`.\nOtherwise, uses the match of the *n*th capture group.\n\n```\n\"Crystal\".match(/r/).not_nil!.byte_begin(0)     # => 1\n\"Crystal\".match(/r(ys)/).not_nil!.byte_begin(1) # => 2\n\"クリスタル\".match(/リ(ス)/).not_nil!.byte_begin(0)    # => 3\n```","summary":"<p>Returns the position of the first byte of the <em>n</em>th match.</p>","abstract":false,"args":[{"name":"n","default_value":"0","external_name":"n","restriction":""}],"args_string":"(n = 0) : Int32","args_html":"(n = <span class=\"n\">0</span>) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/regex/match_data.cr","line_number":95,"url":null},"def":{"name":"byte_begin","args":[{"name":"n","default_value":"0","external_name":"n","restriction":""}],"return_type":"Int32","visibility":"Public","body":"check_index_out_of_bounds(n)\nif n < 0\n  n = n + size\nend\n@ovector[n * 2]\n"}},{"html_id":"byte_end(n=0):Int32-instance-method","name":"byte_end","doc":"Returns the position of the next byte after the match.\n\nWhen *n* is `0` or not given, uses the match of the entire `Regex`.\nOtherwise, uses the match of the *n*th capture group.\n\n```\n\"Crystal\".match(/r/).not_nil!.byte_end(0)     # => 2\n\"Crystal\".match(/r(ys)/).not_nil!.byte_end(1) # => 4\n\"クリスタル\".match(/リ(ス)/).not_nil!.byte_end(0)    # => 9\n```","summary":"<p>Returns the position of the next byte after the match.</p>","abstract":false,"args":[{"name":"n","default_value":"0","external_name":"n","restriction":""}],"args_string":"(n = 0) : Int32","args_html":"(n = <span class=\"n\">0</span>) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/regex/match_data.cr","line_number":111,"url":null},"def":{"name":"byte_end","args":[{"name":"n","default_value":"0","external_name":"n","restriction":""}],"return_type":"Int32","visibility":"Public","body":"check_index_out_of_bounds(n)\nif n < 0\n  n = n + size\nend\n@ovector[(n * 2) + 1]\n"}},{"html_id":"captures:Array(String?)-instance-method","name":"captures","doc":"Returns an array of unnamed capture groups.\n\nIt is a difference from `to_a` that the result array does not contain the match for the entire `Regex` (`self[0]`).\n\n```\nmatch = \"Crystal\".match(/(Cr)(?<name1>y)(st)(?<name2>al)/).not_nil!\nmatch.captures # => [\"Cr\", \"st\"]\n\n# When this regex has an optional group, result array may contain\n# a `nil` if this group is not matched.\nmatch = \"Crystal\".match(/(Cr)(stal)?/).not_nil!\nmatch.captures # => [\"Cr\", nil]\n```","summary":"<p>Returns an array of unnamed capture groups.</p>","abstract":false,"location":{"filename":"src/regex/match_data.cr","line_number":275,"url":null},"def":{"name":"captures","return_type":"Array(String | ::Nil)","visibility":"Public","body":"name_table = @regex.name_table\ncaps = [] of String | ::Nil\n(1...size).each do |i|\n  if name_table.has_key?(i)\n  else\n    caps << self[i]?\n  end\nend\ncaps\n"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/regex/match_data.cr","line_number":391,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy of this object.\n\nBecause `Value` is a value type, this method returns `self`,\nwhich already involves a shallow copy of this object because\nvalue types are passed by value.","summary":"<p>Returns a shallow copy of this object.</p>","abstract":false,"location":{"filename":"src/regex/match_data.cr","line_number":387,"url":null},"def":{"name":"dup","visibility":"Public","body":"self"}},{"html_id":"end(n=0):Int32-instance-method","name":"end","doc":"Returns the position of the next character after the match.\n\nWhen *n* is `0` or not given, uses the match of the entire `Regex`.\nOtherwise, uses the match of the *n*th capture group.\n\n```\n\"Crystal\".match(/r/).not_nil!.end(0)     # => 2\n\"Crystal\".match(/r(ys)/).not_nil!.end(1) # => 4\n\"クリスタル\".match(/リ(ス)/).not_nil!.end(0)    # => 3\n```","summary":"<p>Returns the position of the next character after the match.</p>","abstract":false,"args":[{"name":"n","default_value":"0","external_name":"n","restriction":""}],"args_string":"(n = 0) : Int32","args_html":"(n = <span class=\"n\">0</span>) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/regex/match_data.cr","line_number":81,"url":null},"def":{"name":"end","args":[{"name":"n","default_value":"0","external_name":"n","restriction":""}],"return_type":"Int32","visibility":"Public","body":"(@string.byte_index_to_char_index(byte_end(n))).not_nil!"}},{"html_id":"group_size:Int32-instance-method","name":"group_size","doc":"Returns the number of capture groups, including named capture groups.\n\n```\n\"Crystal\".match(/[p-s]/).not_nil!.group_size          # => 0\n\"Crystal\".match(/r(ys)/).not_nil!.group_size          # => 1\n\"Crystal\".match(/r(ys)(?<ok>ta)/).not_nil!.group_size # => 2\n```","summary":"<p>Returns the number of capture groups, including named capture groups.</p>","abstract":false,"location":{"filename":"src/regex/match_data.cr","line_number":33,"url":null},"def":{"name":"group_size","return_type":"Int32","visibility":"Public","body":"@group_size"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/regex/match_data.cr","line_number":404,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = regex.hash(hasher)\nhasher = string.hash(hasher)\n(Slice.new(@ovector, size * 2)).hash(hasher)\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends this struct's name and instance variables names and values\nto the given IO.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np1.to_s    # \"Point(@x=1, @y=2)\"\np1.inspect # \"Point(@x=1, @y=2)\"\n```","summary":"<p>Appends this struct's name and instance variables names and values to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/regex/match_data.cr","line_number":351,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"named_captures:Hash(String,String?)-instance-method","name":"named_captures","doc":"Returns a hash of named capture groups.\n\n```\nmatch = \"Crystal\".match(/(Cr)(?<name1>y)(st)(?<name2>al)/).not_nil!\nmatch.named_captures # => {\"name1\" => \"y\", \"name2\" => \"al\"}\n\n# When this regex has an optional group, result hash may contain\n# a `nil` if this group is not matched.\nmatch = \"Crystal\".match(/(?<name1>Cr)(?<name2>stal)?/).not_nil!\nmatch.named_captures # => {\"name1\" => \"Cr\", \"name2\" => nil}\n```","summary":"<p>Returns a hash of named capture groups.</p>","abstract":false,"location":{"filename":"src/regex/match_data.cr","line_number":297,"url":null},"def":{"name":"named_captures","return_type":"Hash(String, String | ::Nil)","visibility":"Public","body":"name_table = @regex.name_table\ncaps = {} of String => String | ::Nil\n(1...size).each do |i|\n  if (name = name_table[i]?) && (!(caps.has_key?(name)))\n    caps[name] = self[name]?\n  end\nend\ncaps\n"}},{"html_id":"post_match:String-instance-method","name":"post_match","doc":"Returns the part of the original string after the match. If the match ends\nat the end of the string, returns the empty string.\n\n```\n\"Crystal\".match(/yst/).not_nil!.post_match # => \"al\"\n```","summary":"<p>Returns the part of the original string after the match.</p>","abstract":false,"location":{"filename":"src/regex/match_data.cr","line_number":258,"url":null},"def":{"name":"post_match","return_type":"String","visibility":"Public","body":"@string.byte_slice(byte_end(0))"}},{"html_id":"pre_match:String-instance-method","name":"pre_match","doc":"Returns the part of the original string before the match. If the match\nstarts at the start of the string, returns the empty string.\n\n```\n\"Crystal\".match(/yst/).not_nil!.pre_match # => \"Cr\"\n```","summary":"<p>Returns the part of the original string before the match.</p>","abstract":false,"location":{"filename":"src/regex/match_data.cr","line_number":248,"url":null},"def":{"name":"pre_match","return_type":"String","visibility":"Public","body":"@string.byte_slice(0, byte_begin(0))"}},{"html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","args_html":"(pp) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/regex/match_data.cr","line_number":366,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"return_type":"Nil","visibility":"Public","body":"name_table = @regex.name_table\npp.surround(\"Regex::MatchData(\", \")\", left_break: nil, right_break: nil) do\n  size.times do |i|\n    if i > 0\n      pp.breakable\n    end\n    pp.group do\n      if i == 0\n        self[i].pretty_print(pp)\n      else\n        pp.text(\"#{name_table.fetch(i, i)}:\")\n        pp.nest do\n          pp.breakable(\"\")\n          self[i]?.pretty_print(pp)\n        end\n      end\n    end\n  end\nend\n"}},{"html_id":"regex:Regex-instance-method","name":"regex","doc":"Returns the original regular expression.\n\n```\n\"Crystal\".match(/[p-s]/).not_nil!.regex # => /[p-s]/\n```","summary":"<p>Returns the original regular expression.</p>","abstract":false,"location":{"filename":"src/regex/match_data.cr","line_number":24,"url":null},"def":{"name":"regex","return_type":"Regex","visibility":"Public","body":"@regex"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Returns the number of elements in this match object.\n\n```\n\"Crystal\".match(/[p-s]/).not_nil!.size          # => 1\n\"Crystal\".match(/r(ys)/).not_nil!.size          # => 2\n\"Crystal\".match(/r(ys)(?<ok>ta)/).not_nil!.size # => 3\n```","summary":"<p>Returns the number of elements in this match object.</p>","abstract":false,"location":{"filename":"src/regex/match_data.cr","line_number":53,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"group_size + 1"}},{"html_id":"string:String-instance-method","name":"string","doc":"Returns the original string.\n\n```\n\"Crystal\".match(/[p-s]/).not_nil!.string # => \"Crystal\"\n```","summary":"<p>Returns the original string.</p>","abstract":false,"location":{"filename":"src/regex/match_data.cr","line_number":40,"url":null},"def":{"name":"string","return_type":"String","visibility":"Public","body":"@string"}},{"html_id":"to_a:Array(String?)-instance-method","name":"to_a","doc":"Convert this match data into an array.\n\n```\nmatch = \"Crystal\".match(/(Cr)(?<name1>y)(st)(?<name2>al)/).not_nil!\nmatch.to_a # => [\"Crystal\", \"Cr\", \"y\", \"st\", \"al\"]\n\n# When this regex has an optional group, result array may contain\n# a `nil` if this group is not matched.\nmatch = \"Crystal\".match(/(Cr)(?<name1>stal)?/).not_nil!\nmatch.to_a # => [\"Cr\", \"Cr\", nil]\n```","summary":"<p>Convert this match data into an array.</p>","abstract":false,"location":{"filename":"src/regex/match_data.cr","line_number":321,"url":null},"def":{"name":"to_a","return_type":"Array(String | ::Nil)","visibility":"Public","body":"(0...size).map do |i|\n  self[i]?\nend"}},{"html_id":"to_h:Hash(Int32|String,String?)-instance-method","name":"to_h","doc":"Convert this match data into a hash.\n\n```\nmatch = \"Crystal\".match(/(Cr)(?<name1>y)(st)(?<name2>al)/).not_nil!\nmatch.to_h # => {0 => \"Crystal\", 1 => \"Cr\", \"name1\" => \"y\", 3 => \"st\", \"name2\" => \"al\"}\n\n# When this regex has an optional group, result array may contain\n# a `nil` if this group is not matched.\nmatch = \"Crystal\".match(/(Cr)(?<name1>stal)?/).not_nil!\nmatch.to_h # => {0 => \"Cr\", 1 => \"Cr\", \"name1\" => nil}\n```","summary":"<p>Convert this match data into a hash.</p>","abstract":false,"location":{"filename":"src/regex/match_data.cr","line_number":336,"url":null},"def":{"name":"to_h","return_type":"Hash(Int32 | String, String | ::Nil)","visibility":"Public","body":"name_table = @regex.name_table\nhash = {} of String | Int32 => String | ::Nil\n(0...size).each do |i|\n  if name = name_table[i]?\n    if hash.has_key?(name)\n    else\n      hash[name] = self[name]?\n    end\n  else\n    hash[i] = self[i]?\n  end\nend\nhash\n"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Same as `#inspect(io)`.","summary":"<p>Same as <code><a href=\"../Regex/MatchData.html#inspect%28io%3AIO%29%3ANil-instance-method\">#inspect(io)</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/regex/match_data.cr","line_number":355,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"name_table = @regex.name_table\nio << \"Regex::MatchData(\"\nsize.times do |i|\n  if i > 0\n    ((io << ' ') << (name_table.fetch(i, i))) << ':'\n  end\n  self[i]?.inspect(io)\nend\nio << ')'\n"}}]},{"html_id":"Crystal/Regex/Options","path":"Regex/Options.html","kind":"enum","full_name":"Regex::Options","name":"Options","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/regex.cr","line_number":208,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"IGNORE_CASE","name":"IGNORE_CASE","value":"1","doc":"Case insensitive match.","summary":"<p>Case insensitive match.</p>"},{"id":"MULTILINE","name":"MULTILINE","value":"6","doc":"PCRE native `PCRE_MULTILINE` flag is `2`, and `PCRE_DOTALL` is `4`\n- `PCRE_DOTALL` changes the \"`.`\" meaning\n- `PCRE_MULTILINE` changes \"`^`\" and \"`$`\" meanings\n\nCrystal modifies this meaning to have essentially one unique \"`m`\"\nflag that activates both behaviours, so here we do the same by\nmapping `MULTILINE` to `PCRE_MULTILINE | PCRE_DOTALL`.","summary":"<p>PCRE native <code>PCRE_MULTILINE</code> flag is <code>2</code>, and <code>PCRE_DOTALL</code> is <code>4</code> - <code>PCRE_DOTALL</code> changes the &quot;<code>.</code>&quot; meaning - <code>PCRE_MULTILINE</code> changes &quot;<code>^</code>&quot; and &quot;<code>$</code>&quot; meanings</p>"},{"id":"EXTENDED","name":"EXTENDED","value":"8","doc":"Ignore white space and `#` comments.","summary":"<p>Ignore white space and <code>#</code> comments.</p>"},{"id":"ANCHORED","name":"ANCHORED","value":"16","doc":"Force pattern anchoring.","summary":"<p>Force pattern anchoring.</p>"}],"namespace":{"html_id":"Crystal/Regex","kind":"class","full_name":"Regex","name":"Regex"},"instance_methods":[{"html_id":"anchored?-instance-method","name":"anchored?","abstract":false,"location":{"filename":"src/regex.cr","line_number":222,"url":null},"def":{"name":"anchored?","visibility":"Public","body":"self.includes?(ANCHORED)"}},{"html_id":"dupnames?-instance-method","name":"dupnames?","abstract":false,"location":{"filename":"src/regex.cr","line_number":228,"url":null},"def":{"name":"dupnames?","visibility":"Public","body":"self.includes?(DUPNAMES)"}},{"html_id":"extended?-instance-method","name":"extended?","abstract":false,"location":{"filename":"src/regex.cr","line_number":220,"url":null},"def":{"name":"extended?","visibility":"Public","body":"self.includes?(EXTENDED)"}},{"html_id":"ignore_case?-instance-method","name":"ignore_case?","abstract":false,"location":{"filename":"src/regex.cr","line_number":210,"url":null},"def":{"name":"ignore_case?","visibility":"Public","body":"self.includes?(IGNORE_CASE)"}},{"html_id":"multiline?-instance-method","name":"multiline?","abstract":false,"location":{"filename":"src/regex.cr","line_number":218,"url":null},"def":{"name":"multiline?","visibility":"Public","body":"self.includes?(MULTILINE)"}},{"html_id":"no_utf8_check?-instance-method","name":"no_utf8_check?","abstract":false,"location":{"filename":"src/regex.cr","line_number":226,"url":null},"def":{"name":"no_utf8_check?","visibility":"Public","body":"self.includes?(NO_UTF8_CHECK)"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/regex.cr","line_number":208,"url":null},"def":{"name":"none?","visibility":"Public","body":"value == 0"}},{"html_id":"ucp?-instance-method","name":"ucp?","abstract":false,"location":{"filename":"src/regex.cr","line_number":230,"url":null},"def":{"name":"ucp?","visibility":"Public","body":"self.includes?(UCP)"}},{"html_id":"utf_8?-instance-method","name":"utf_8?","abstract":false,"location":{"filename":"src/regex.cr","line_number":224,"url":null},"def":{"name":"utf_8?","visibility":"Public","body":"self.includes?(UTF_8)"}}]}]},{"html_id":"Crystal/RuntimeError","path":"RuntimeError.html","kind":"class","full_name":"RuntimeError","name":"RuntimeError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/SystemError","kind":"module","full_name":"SystemError","name":"SystemError"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/exception.cr","line_number":168,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/SystemError","kind":"module","full_name":"SystemError","name":"SystemError"}],"extended_modules":[{"html_id":"Crystal/SystemError/ClassMethods","kind":"module","full_name":"SystemError::ClassMethods","name":"ClassMethods"}],"doc":"Raised when there is an internal runtime error","summary":"<p>Raised when there is an internal runtime error</p>"},{"html_id":"Crystal/SemanticVersion","path":"SemanticVersion.html","kind":"struct","full_name":"SemanticVersion","name":"SemanticVersion","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/semantic_version.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"doc":"Conforms to Semantic Versioning 2.0.0\n\nSee [https://semver.org/](https://semver.org/) for more information.","summary":"<p>Conforms to Semantic Versioning 2.0.0</p>","constructors":[{"html_id":"new(major:Int,minor:Int,patch:Int,prerelease:String|Prerelease|Nil=nil,build:String?=nil)-class-method","name":"new","doc":"Creates a new `SemanticVersion` instance with the given major, minor, and patch versions\nand optionally build and pre-release version\n\nRaises `ArgumentError` if *prerelease* is invalid pre-release version","summary":"<p>Creates a new <code><a href=\"SemanticVersion.html\">SemanticVersion</a></code> instance with the given major, minor, and patch versions and optionally build and pre-release version</p>","abstract":false,"args":[{"name":"major","external_name":"major","restriction":"Int"},{"name":"minor","external_name":"minor","restriction":"Int"},{"name":"patch","external_name":"patch","restriction":"Int"},{"name":"prerelease","default_value":"nil","external_name":"prerelease","restriction":"String | Prerelease | Nil"},{"name":"build","default_value":"nil","external_name":"build","restriction":"String | ::Nil"}],"args_string":"(major : Int, minor : Int, patch : Int, prerelease : String | Prerelease | Nil = nil, build : String? = nil)","args_html":"(major : <a href=\"Int.html\">Int</a>, minor : <a href=\"Int.html\">Int</a>, patch : <a href=\"Int.html\">Int</a>, prerelease : <a href=\"String.html\">String</a> | <a href=\"SemanticVersion/Prerelease.html\">Prerelease</a> | <a href=\"Nil.html\">Nil</a> = <span class=\"n\">nil</span>, build : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/semantic_version.cr","line_number":51,"url":null},"def":{"name":"new","args":[{"name":"major","external_name":"major","restriction":"Int"},{"name":"minor","external_name":"minor","restriction":"Int"},{"name":"patch","external_name":"patch","restriction":"Int"},{"name":"prerelease","default_value":"nil","external_name":"prerelease","restriction":"String | Prerelease | Nil"},{"name":"build","default_value":"nil","external_name":"build","restriction":"String | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(major, minor, patch, prerelease, build)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"parse(str:String):self-class-method","name":"parse","doc":"Parses a `SemanticVersion` from the given semantic version string\n\n```\nrequire \"semantic_version\"\n\nsemver = SemanticVersion.parse(\"2.61.4\")\nsemver # => #<SemanticVersion:0x55b3667c9e70 @major=2, @minor=61, @patch=4, ... >\n```\n\nRaises `ArgumentError` if *str* is not a semantic version.","summary":"<p>Parses a <code><a href=\"SemanticVersion.html\">SemanticVersion</a></code> from the given semantic version string</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"String"}],"args_string":"(str : String) : self","args_html":"(str : <a href=\"String.html\">String</a>) : <span class=\"k\">self</span>","location":{"filename":"src/semantic_version.cr","line_number":32,"url":null},"def":{"name":"parse","args":[{"name":"str","external_name":"str","restriction":"String"}],"return_type":"self","visibility":"Public","body":"if m = str.match(/^(0|[1-9]\\d*)\\.(0|[1-9]\\d*)\\.(0|[1-9]\\d*)\n                      (?:-((?:0|[1-9]\\d*|\\d*[a-zA-Z-][0-9a-zA-Z-]*)(?:\\.(?:0|[1-9]\\d*|\\d*[a-zA-Z-][0-9a-zA-Z-]*))*))?\n                      (?:\\+([0-9a-zA-Z-]+(?:\\.[0-9a-zA-Z-]+)*))?$/x)\n  major = m[1].to_i\n  minor = m[2].to_i\n  patch = m[3].to_i\n  prerelease = m[4]?\n  build = m[5]?\n  new(major, minor, patch, prerelease, build)\nelse\n  raise(ArgumentError.new(\"Not a semantic version: #{str.inspect}\"))\nend"}}],"instance_methods":[{"html_id":"<=>(other:self):Int32-instance-method","name":"<=>","doc":"The comparison operator.\n\nReturns `-1`, `0` or `1` depending on whether `self`'s version is lower than *other*'s,\nequal to *other*'s version or greater than *other*'s version.\n\n```\nrequire \"semantic_version\"\n\nsemver1 = SemanticVersion.new(1, 0, 0)\nsemver2 = SemanticVersion.new(2, 0, 0)\n\nsemver1 <=> semver2 # => -1\nsemver2 <=> semver2 # => 0\nsemver2 <=> semver1 # => 1\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self) : Int32","args_html":"(other : <span class=\"k\">self</span>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/semantic_version.cr","line_number":100,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"self"}],"return_type":"Int32","visibility":"Public","body":"r = major <=> other.major\nif r.zero?\nelse\n  return r\nend\nr = minor <=> other.minor\nif r.zero?\nelse\n  return r\nend\nr = patch <=> other.patch\nif r.zero?\nelse\n  return r\nend\nprerelease <=> other.prerelease\n"}},{"html_id":"==(other:self)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"if major == other.major\nelse\n  return false\nend\nif minor == other.minor\nelse\n  return false\nend\nif patch == other.patch\nelse\n  return false\nend\nif prerelease == other.prerelease\nelse\n  return false\nend\nif build == other.build\nelse\n  return false\nend\ntrue\n"}},{"html_id":"build:String?-instance-method","name":"build","doc":"The build metadata of this semantic version","summary":"<p>The build metadata of this semantic version</p>","abstract":false,"location":{"filename":"src/semantic_version.cr","line_number":17,"url":null},"def":{"name":"build","return_type":"String | ::Nil","visibility":"Public","body":"@build"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = major.hash(hasher)\nhasher = minor.hash(hasher)\nhasher = patch.hash(hasher)\nhasher = prerelease.hash(hasher)\nhasher = build.hash(hasher)\nhasher\n"}},{"html_id":"major:Int32-instance-method","name":"major","doc":"The major version of this semantic version","summary":"<p>The major version of this semantic version</p>","abstract":false,"location":{"filename":"src/semantic_version.cr","line_number":8,"url":null},"def":{"name":"major","return_type":"Int32","visibility":"Public","body":"@major"}},{"html_id":"minor:Int32-instance-method","name":"minor","doc":"The minor version of this semantic version","summary":"<p>The minor version of this semantic version</p>","abstract":false,"location":{"filename":"src/semantic_version.cr","line_number":11,"url":null},"def":{"name":"minor","return_type":"Int32","visibility":"Public","body":"@minor"}},{"html_id":"patch:Int32-instance-method","name":"patch","doc":"The patch version of this semantic version","summary":"<p>The patch version of this semantic version</p>","abstract":false,"location":{"filename":"src/semantic_version.cr","line_number":14,"url":null},"def":{"name":"patch","return_type":"Int32","visibility":"Public","body":"@patch"}},{"html_id":"prerelease:Prerelease-instance-method","name":"prerelease","doc":"The pre-release version of this semantic version","summary":"<p>The pre-release version of this semantic version</p>","abstract":false,"location":{"filename":"src/semantic_version.cr","line_number":20,"url":null},"def":{"name":"prerelease","return_type":"Prerelease","visibility":"Public","body":"@prerelease"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Returns the string representation of this semantic version\n\n```\nrequire \"semantic_version\"\n\nsemver = SemanticVersion.parse(\"0.27.1\")\nsemver.to_s # => \"0.27.1\"\n```","summary":"<p>Returns the string representation of this semantic version</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/semantic_version.cr","line_number":74,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"((((io << major) << '.') << minor) << '.') << patch\nif prerelease.identifiers.empty?\nelse\n  io << '-'\n  prerelease.to_s(io)\nend\nif build\n  (io << '+') << build\nend\n"}}],"types":[{"html_id":"Crystal/SemanticVersion/Prerelease","path":"SemanticVersion/Prerelease.html","kind":"struct","full_name":"SemanticVersion::Prerelease","name":"Prerelease","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/semantic_version.cr","line_number":112,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"namespace":{"html_id":"Crystal/SemanticVersion","kind":"struct","full_name":"SemanticVersion","name":"SemanticVersion"},"doc":"Contains the pre-release version related to this semantic version","summary":"<p>Contains the pre-release version related to this semantic version</p>","constructors":[{"html_id":"new(identifiers:Array(String|Int32)=[]ofString|Int32)-class-method","name":"new","doc":"Creates a new `Prerelease` instance with supplied array of identifiers","summary":"<p>Creates a new <code><a href=\"../SemanticVersion/Prerelease.html\">Prerelease</a></code> instance with supplied array of identifiers</p>","abstract":false,"args":[{"name":"identifiers","default_value":"[] of String | Int32","external_name":"identifiers","restriction":"Array(String | Int32)"}],"args_string":"(identifiers : Array(String | Int32) = [] of String | Int32)","args_html":"(identifiers : <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a> | <a href=\"../Int32.html\">Int32</a>) = <span class=\"o\">[]</span> <span class=\"k\">of</span> <span class=\"t\">String</span> <span class=\"o\">|</span> <span class=\"t\">Int32</span>)","location":{"filename":"src/semantic_version.cr","line_number":139,"url":null},"def":{"name":"new","args":[{"name":"identifiers","default_value":"[] of String | Int32","external_name":"identifiers","restriction":"Array(String | Int32)"}],"visibility":"Public","body":"_ = allocate\n_.initialize(identifiers)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"parse(str:String):self-class-method","name":"parse","doc":"Parses a `Prerelease` from the given pre-release version string\n\n```\nrequire \"semantic_version\"\n\nprerelease = SemanticVersion::Prerelease.parse(\"rc.1.3\")\nprerelease # => SemanticVersion::Prerelease(@identifiers=[\"rc\", 1, 3])\n```","summary":"<p>Parses a <code><a href=\"../SemanticVersion/Prerelease.html\">Prerelease</a></code> from the given pre-release version string</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"String"}],"args_string":"(str : String) : self","args_html":"(str : <a href=\"../String.html\">String</a>) : <span class=\"k\">self</span>","location":{"filename":"src/semantic_version.cr","line_number":123,"url":null},"def":{"name":"parse","args":[{"name":"str","external_name":"str","restriction":"String"}],"return_type":"self","visibility":"Public","body":"identifiers = [] of String | Int32\n(str.split('.')).each do |val|\n  if number = val.to_i32?\n    identifiers << number\n  else\n    identifiers << val\n  end\nend\nPrerelease.new(identifiers)\n"}}],"instance_methods":[{"html_id":"<=>(other:self):Int32-instance-method","name":"<=>","doc":"The comparison operator.\n\nReturns `-1`, `0` or `1` depending on whether `self`'s pre-release is lower than *other*'s,\nequal to *other*'s pre-release or greater than *other*'s pre-release.\n\n```\nrequire \"semantic_version\"\n\nprerelease1 = SemanticVersion::Prerelease.new([\"rc\", 1])\nprerelease2 = SemanticVersion::Prerelease.new([\"rc\", 1, 2])\n\nprerelease1 <=> prerelease2 # => -1\nprerelease1 <=> prerelease1 # => 0\nprerelease2 <=> prerelease1 # => 1\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self) : Int32","args_html":"(other : <span class=\"k\">self</span>) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/semantic_version.cr","line_number":169,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"self"}],"return_type":"Int32","visibility":"Public","body":"if identifiers.empty?\n  if other.identifiers.empty?\n    return 0\n  else\n    return 1\n  end\nelse\n  if other.identifiers.empty?\n    return -1\n  end\nend\nidentifiers.each_with_index do |item, i|\n  if i >= other.identifiers.size\n    return 1\n  end\n  oitem = other.identifiers[i]\n  r = compare(item, oitem)\n  if r != 0\n    return r\n  end\nend\nif identifiers.size != other.identifiers.size\n  return -1\nend\n0\n"}},{"html_id":"identifiers:Array(String|Int32)-instance-method","name":"identifiers","doc":"Array of identifiers that make up the pre-release metadata","summary":"<p>Array of identifiers that make up the pre-release metadata</p>","abstract":false,"location":{"filename":"src/semantic_version.cr","line_number":136,"url":null},"def":{"name":"identifiers","return_type":"Array(String | Int32)","visibility":"Public","body":"@identifiers"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Returns the string representation of this semantic version's pre-release metadata\n\n```\nrequire \"semantic_version\"\n\nsemver = SemanticVersion.parse(\"0.27.1-rc.1\")\nsemver.prerelease.to_s # => \"rc.1\"\n```","summary":"<p>Returns the string representation of this semantic version's pre-release metadata</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/semantic_version.cr","line_number":150,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"identifiers.join(io, '.')"}}]}]},{"html_id":"Crystal/Set","path":"Set.html","kind":"struct","full_name":"Set(T)","name":"Set","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/to_json.cr","line_number":109,"url":null},{"filename":"src/set.cr","line_number":23,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":110,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"}],"doc":"`Set` implements a collection of unordered values with no duplicates.\n\nAn `Enumerable` object can be converted to `Set` using the `#to_set` method.\n\n`Set` uses `Hash` as storage, so you must note the following points:\n\n* Equality of elements is determined according to `Object#==` and `Object#hash`.\n* `Set` assumes that the identity of each element does not change while it is stored. Modifying an element of a set will render the set to an unreliable state.\n\n### Example\n\n```\ns1 = Set{1, 2}\ns2 = [1, 2].to_set\ns3 = Set.new [1, 2]\ns1 == s2 # => true\ns1 == s3 # => true\ns1.add(2)\ns1.concat([6, 8])\ns1.subset_of? s2 # => false\ns2.subset_of? s1 # => true\n```","summary":"<p><code><a href=\"Set.html\">Set</a></code> implements a collection of unordered values with no duplicates.</p>","constructors":[{"html_id":"additive_identity:self-class-method","name":"additive_identity","doc":"Returns the additive identity of this type.\n\nThis is an empty set.","summary":"<p>Returns the additive identity of this type.</p>","abstract":false,"location":{"filename":"src/set.cr","line_number":246,"url":null},"def":{"name":"additive_identity","return_type":"self","visibility":"Public","body":"new"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":116,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"ctx.read_alias(node, self) do |obj|\n  return obj\nend\nary = new\nctx.record_anchor(node, ary)\nnew(ctx, node) do |element|\n  ary << element\nend\nary\n"}},{"html_id":"new(other:Indexable(T))-class-method","name":"new","doc":"Optimized version of `new` used when *other* is also an `Indexable`","summary":"<p>Optimized version of <code><a href=\"Set.html#new%28ctx%3AYAML%3A%3AParseContext%2Cnode%3AYAML%3A%3ANodes%3A%3ANode%29-class-method\">.new</a></code> used when <em>other</em> is also an <code><a href=\"Indexable.html\">Indexable</a></code></p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Indexable(T)"}],"args_string":"(other : Indexable(T))","args_html":"(other : <a href=\"Indexable.html\">Indexable</a>(T))","location":{"filename":"src/set.cr","line_number":44,"url":null},"def":{"name":"new","args":[{"name":"other","external_name":"other","restriction":"Indexable(T)"}],"visibility":"Public","body":"(Set(T).new(other.size)).concat(other)"}},{"html_id":"new(enumerable:Enumerable(T))-class-method","name":"new","doc":"Creates a new set from the elements in *enumerable*.\n\n```\na = [1, 3, 5]\ns = Set.new a\ns.empty? # => false\n```","summary":"<p>Creates a new set from the elements in <em>enumerable</em>.</p>","abstract":false,"args":[{"name":"enumerable","external_name":"enumerable","restriction":"Enumerable(T)"}],"args_string":"(enumerable : Enumerable(T))","args_html":"(enumerable : <a href=\"Enumerable.html\">Enumerable</a>(T))","location":{"filename":"src/set.cr","line_number":55,"url":null},"def":{"name":"new","args":[{"name":"enumerable","external_name":"enumerable","restriction":"Enumerable(T)"}],"visibility":"Public","body":"Set(T).new.concat(enumerable)"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":176,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"set = new\npull.read_array do\n  set << (T.new(pull))\nend\nset\n"}},{"html_id":"new(initial_capacity=nil)-class-method","name":"new","doc":"Creates a new, empty `Set`.\n\n```\ns = Set(Int32).new\ns.empty? # => true\n```\n\nAn initial capacity can be specified, and it will be set as the initial capacity\nof the internal `Hash`.","summary":"<p>Creates a new, empty <code><a href=\"Set.html\">Set</a></code>.</p>","abstract":false,"args":[{"name":"initial_capacity","default_value":"nil","external_name":"initial_capacity","restriction":""}],"args_string":"(initial_capacity = nil)","args_html":"(initial_capacity = <span class=\"n\">nil</span>)","location":{"filename":"src/set.cr","line_number":36,"url":null},"def":{"name":"new","args":[{"name":"initial_capacity","default_value":"nil","external_name":"initial_capacity","restriction":""}],"visibility":"Public","body":"_ = Set(T).allocate\n_.initialize(initial_capacity)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node,&)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node, &)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>, &)","location":{"filename":"src/yaml/from_yaml.cr","line_number":131,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"yields":1,"visibility":"Public","body":"if node.is_a?(YAML::Nodes::Sequence)\nelse\n  node.raise(\"Expected sequence, not #{node.kind}\")\nend\nnode.each do |value|\n  yield T.new(ctx, value)\nend\n"}}],"instance_methods":[{"html_id":"&(other:Set)-instance-method","name":"&","doc":"Intersection: returns a new set containing elements common to both sets.\n\n```\nSet{1, 1, 3, 5} & Set{1, 2, 3}               # => Set{1, 3}\nSet{'a', 'b', 'b', 'z'} & Set{'a', 'b', 'c'} # => Set{'a', 'b'}\n```","summary":"<p>Intersection: returns a new set containing elements common to both sets.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Set"}],"args_string":"(other : Set)","args_html":"(other : <a href=\"Set.html\">Set</a>)","location":{"filename":"src/set.cr","line_number":206,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Set"}],"visibility":"Public","body":"smallest, largest = self, other\nif largest.size < smallest.size\n  smallest, largest = largest, smallest\nend\nset = Set(T).new\nsmallest.each do |value|\n  if largest.includes?(value)\n    set.add(value)\n  end\nend\nset\n"}},{"html_id":"+(other:Set(U))forallU-instance-method","name":"+","doc":"Addition: returns a new set containing the unique elements from both sets.\n\n```\nSet{1, 1, 2, 3} + Set{3, 4, 5} # => Set{1, 2, 3, 4, 5}\n```","summary":"<p>Addition: returns a new set containing the unique elements from both sets.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Set(U)"}],"args_string":"(other : Set(U)) forall U","args_html":"(other : <a href=\"Set.html\">Set</a>(U)) forall U","location":{"filename":"src/set.cr","line_number":239,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Set(U)"}],"visibility":"Public","body":"self | other"}},{"html_id":"-(other:Set)-instance-method","name":"-","doc":"Difference: returns a new set containing elements in this set that are not\npresent in the other.\n\n```\nSet{1, 2, 3, 4, 5} - Set{2, 4}               # => Set{1, 3, 5}\nSet{'a', 'b', 'b', 'z'} - Set{'a', 'b', 'c'} # => Set{'z'}\n```","summary":"<p>Difference: returns a new set containing elements in this set that are not present in the other.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Set"}],"args_string":"(other : Set)","args_html":"(other : <a href=\"Set.html\">Set</a>)","location":{"filename":"src/set.cr","line_number":257,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Set"}],"visibility":"Public","body":"set = Set(T).new\neach do |value|\n  if other.includes?(value)\n  else\n    set.add(value)\n  end\nend\nset\n"}},{"html_id":"-(other:Enumerable)-instance-method","name":"-","doc":"Difference: returns a new set containing elements in this set that are not\npresent in the other enumerable.\n\n```\nSet{1, 2, 3, 4, 5} - [2, 4]               # => Set{1, 3, 5}\nSet{'a', 'b', 'b', 'z'} - ['a', 'b', 'c'] # => Set{'z'}\n```","summary":"<p>Difference: returns a new set containing elements in this set that are not present in the other enumerable.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Enumerable"}],"args_string":"(other : Enumerable)","args_html":"(other : <a href=\"Enumerable.html\">Enumerable</a>)","location":{"filename":"src/set.cr","line_number":272,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Enumerable"}],"visibility":"Public","body":"dup.subtract(other)"}},{"html_id":"<<(object:T)-instance-method","name":"<<","doc":"Alias for `add`","summary":"<p>Alias for <code><a href=\"Set.html#add%28object%3AT%29-instance-method\">#add</a></code></p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":"T"}],"args_string":"(object : T)","args_html":"(object : T)","location":{"filename":"src/set.cr","line_number":84,"url":null},"def":{"name":"<<","args":[{"name":"object","external_name":"object","restriction":"T"}],"visibility":"Public","body":"add(object)"}},{"html_id":"==(other:Set)-instance-method","name":"==","doc":"Returns `true` if both sets have the same elements.\n\n```\nSet{1, 5} == Set{1, 5} # => true\n```","summary":"<p>Returns <code>true</code> if both sets have the same elements.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Set"}],"args_string":"(other : Set)","args_html":"(other : <a href=\"Set.html\">Set</a>)","location":{"filename":"src/set.cr","line_number":332,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Set"}],"visibility":"Public","body":"(same?(other)) || (@hash == (other.@hash))"}},{"html_id":"===(object:T)-instance-method","name":"===","doc":"Same as `#includes?`.\n\nIt is for convenience with using on `case` statement.\n\n```\nred_like = Set{\"red\", \"pink\", \"violet\"}\nblue_like = Set{\"blue\", \"azure\", \"violet\"}\n\ncase \"violet\"\nwhen red_like & blue_like\n  puts \"red & blue like color!\"\nwhen red_like\n  puts \"red like color!\"\nwhen blue_like\n  puts \"blue like color!\"\nend\n```\n\nSee also: `Object#===`.","summary":"<p>Same as <code><a href=\"Set.html#includes%3F%28object%29%3ABool-instance-method\">#includes?</a></code>.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":"T"}],"args_string":"(object : T)","args_html":"(object : T)","location":{"filename":"src/set.cr","line_number":355,"url":null},"def":{"name":"===","args":[{"name":"object","external_name":"object","restriction":"T"}],"visibility":"Public","body":"includes?(object)"}},{"html_id":"^(other:Set(U))forallU-instance-method","name":"^","doc":"Symmetric Difference: returns a new set `(self - other) | (other - self)`.\nEquivalently, returns `(self | other) - (self & other)`.\n\n```\nSet{1, 2, 3, 4, 5} ^ Set{2, 4, 6}            # => Set{1, 3, 5, 6}\nSet{'a', 'b', 'b', 'z'} ^ Set{'a', 'b', 'c'} # => Set{'z', 'c'}\n```","summary":"<p>Symmetric Difference: returns a new set <code>(self - other) | (other - self)</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Set(U)"}],"args_string":"(other : Set(U)) forall U","args_html":"(other : <a href=\"Set.html\">Set</a>(U)) forall U","location":{"filename":"src/set.cr","line_number":283,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Set(U)"}],"visibility":"Public","body":"set = Set(T | U).new\neach do |value|\n  if other.includes?(value)\n  else\n    set.add(value)\n  end\nend\nother.each do |value|\n  if includes?(value)\n  else\n    set.add(value)\n  end\nend\nset\n"}},{"html_id":"^(other:Enumerable(U))forallU-instance-method","name":"^","doc":"Symmetric Difference: returns a new set `(self - other) | (other - self)`.\nEquivalently, returns `(self | other) - (self & other)`.\n\n```\nSet{1, 2, 3, 4, 5} ^ [2, 4, 6]            # => Set{1, 3, 5, 6}\nSet{'a', 'b', 'b', 'z'} ^ ['a', 'b', 'c'] # => Set{'z', 'c'}\n```","summary":"<p>Symmetric Difference: returns a new set <code>(self - other) | (other - self)</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Enumerable(U)"}],"args_string":"(other : Enumerable(U)) forall U","args_html":"(other : <a href=\"Enumerable.html\">Enumerable</a>(U)) forall U","location":{"filename":"src/set.cr","line_number":301,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Enumerable(U)"}],"visibility":"Public","body":"set = Set(T | U).new(self)\nother.each do |value|\n  if includes?(value)\n    set.delete(value)\n  else\n    set.add(value)\n  end\nend\nset\n"}},{"html_id":"add(object:T)-instance-method","name":"add","doc":"Adds *object* to the set and returns `self`.\n\n```\ns = Set{1, 5}\ns.includes? 8 # => false\ns.add(8)\ns.includes? 8 # => true\n```","summary":"<p>Adds <em>object</em> to the set and returns <code>self</code>.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":"T"}],"args_string":"(object : T)","args_html":"(object : T)","location":{"filename":"src/set.cr","line_number":96,"url":null},"def":{"name":"add","args":[{"name":"object","external_name":"object","restriction":"T"}],"visibility":"Public","body":"@hash[object] = nil\nself\n"}},{"html_id":"add?(object:T):Bool-instance-method","name":"add?","doc":"Adds *object* to the set and returns `true` on success\nand `false` if the value was already in the set.\n\n```\ns = Set{1, 5}\ns.add? 8 # => true\ns.add? 8 # => false\n```","summary":"<p>Adds <em>object</em> to the set and returns <code>true</code> on success and <code>false</code> if the value was already in the set.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":"T"}],"args_string":"(object : T) : Bool","args_html":"(object : T) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/set.cr","line_number":109,"url":null},"def":{"name":"add?","args":[{"name":"object","external_name":"object","restriction":"T"}],"return_type":"Bool","visibility":"Public","body":"@hash.put(object, nil) do\n  return true\nend\nfalse\n"}},{"html_id":"clear:self-instance-method","name":"clear","doc":"Removes all elements in the set, and returns `self`.\n\n```\ns = Set{1, 5}\ns.size # => 2\ns.clear\ns.size # => 0\n```","summary":"<p>Removes all elements in the set, and returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/set.cr","line_number":171,"url":null},"def":{"name":"clear","return_type":"self","visibility":"Public","body":"@hash.clear\nself\n"}},{"html_id":"clone-instance-method","name":"clone","doc":"Returns a new `Set` with all of the elements cloned.","summary":"<p>Returns a new <code><a href=\"Set.html\">Set</a></code> with all of the elements cloned.</p>","abstract":false,"location":{"filename":"src/set.cr","line_number":367,"url":null},"def":{"name":"clone","visibility":"Public","body":"clone = Set(T).new(self.size)\nif compare_by_identity?\n  clone.compare_by_identity\nend\neach do |element|\n  clone << element.clone\nend\nclone\n"}},{"html_id":"compare_by_identity-instance-method","name":"compare_by_identity","doc":"Makes this set compare objects using their object identity (`object_id)`\nfor types that define such method (`Reference` types, but also structs that\nmight wrap other `Reference` types and delegate the `object_id` method to them).\n\n```\ns = Set{\"foo\", \"bar\"}\ns.includes?(\"fo\" + \"o\") # => true\n\ns.compare_by_identity\ns.compare_by_identity?  # => true\ns.includes?(\"fo\" + \"o\") # => false # not the same String instance\n```","summary":"<p>Makes this set compare objects using their object identity (<code>object_id)</code> for types that define such method (<code><a href=\"Reference.html\">Reference</a></code> types, but also structs that might wrap other <code><a href=\"Reference.html\">Reference</a></code> types and delegate the <code>object_id</code> method to them).</p>","abstract":false,"location":{"filename":"src/set.cr","line_number":71,"url":null},"def":{"name":"compare_by_identity","visibility":"Public","body":"@hash.compare_by_identity\nself\n"}},{"html_id":"compare_by_identity?:Bool-instance-method","name":"compare_by_identity?","doc":"Returns `true` of this Set is comparing objects by `object_id`.\n\nSee `compare_by_identity`.","summary":"<p>Returns <code>true</code> of this Set is comparing objects by <code>object_id</code>.</p>","abstract":false,"location":{"filename":"src/set.cr","line_number":79,"url":null},"def":{"name":"compare_by_identity?","return_type":"Bool","visibility":"Public","body":"@hash.compare_by_identity?"}},{"html_id":"concat(elems):self-instance-method","name":"concat","doc":"Adds `#each` element of *elems* to the set and returns `self`.\n\n```\ns = Set{1, 5}\ns.concat [5, 5, 8, 9]\ns.size # => 4\n```\n\nSee also: `#|` to merge two sets and return a new one.","summary":"<p>Adds <code><a href=\"Set.html#each%28%26%3AT-%3E%29%3ANil-instance-method\">#each</a></code> element of <em>elems</em> to the set and returns <code>self</code>.</p>","abstract":false,"args":[{"name":"elems","external_name":"elems","restriction":""}],"args_string":"(elems) : self","args_html":"(elems) : <span class=\"k\">self</span>","location":{"filename":"src/set.cr","line_number":123,"url":null},"def":{"name":"concat","args":[{"name":"elems","external_name":"elems","restriction":""}],"return_type":"self","visibility":"Public","body":"elems.each do |elem|\n  self << elem\nend\nself\n"}},{"html_id":"delete(object):Bool-instance-method","name":"delete","doc":"Removes the *object* from the set and returns `true` if it was present, otherwise returns `false`.\n\n```\ns = Set{1, 5}\ns.includes? 5 # => true\ns.delete 5    # => true\ns.includes? 5 # => false\ns.delete 5    # => false\n```","summary":"<p>Removes the <em>object</em> from the set and returns <code>true</code> if it was present, otherwise returns <code>false</code>.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":""}],"args_string":"(object) : Bool","args_html":"(object) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/set.cr","line_number":148,"url":null},"def":{"name":"delete","args":[{"name":"object","external_name":"object","restriction":""}],"return_type":"Bool","visibility":"Public","body":"@hash.delete(object) do\n  return false\nend\ntrue\n"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a new `Set` with all of the same elements.","summary":"<p>Returns a new <code><a href=\"Set.html\">Set</a></code> with all of the same elements.</p>","abstract":false,"location":{"filename":"src/set.cr","line_number":360,"url":null},"def":{"name":"dup","visibility":"Public","body":"set = Set(T).new(using_hash: @hash.dup)\nif compare_by_identity?\n  set.compare_by_identity\nend\nset\n"}},{"html_id":"each(&:T->):Nil-instance-method","name":"each","doc":"Yields each element of the set, and returns `nil`.","summary":"<p>Yields each element of the set, and returns <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/set.cr","line_number":189,"url":null},"def":{"name":"each","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T ->)"},"return_type":"Nil","visibility":"Public","body":"@hash.each_key do |key|\n  yield key\nend"}},{"html_id":"each-instance-method","name":"each","doc":"Returns an iterator for each element of the set.","summary":"<p>Returns an iterator for each element of the set.</p>","abstract":false,"location":{"filename":"src/set.cr","line_number":196,"url":null},"def":{"name":"each","visibility":"Public","body":"@hash.each_key"}},{"html_id":"empty?:Bool-instance-method","name":"empty?","doc":"Returns `true` if the set is empty.\n\n```\ns = Set(Int32).new\ns.empty? # => true\ns << 3\ns.empty? # => false\n```","summary":"<p>Returns <code>true</code> if the set is empty.</p>","abstract":false,"location":{"filename":"src/set.cr","line_number":184,"url":null},"def":{"name":"empty?","return_type":"Bool","visibility":"Public","body":"@hash.empty?"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/set.cr","line_number":395,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = @hash.hash(hasher)\nhasher\n"}},{"html_id":"includes?(object):Bool-instance-method","name":"includes?","doc":"Returns `true` if *object* exists in the set.\n\n```\ns = Set{1, 5}\ns.includes? 5 # => true\ns.includes? 9 # => false\n```","summary":"<p>Returns <code>true</code> if <em>object</em> exists in the set.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":""}],"args_string":"(object) : Bool","args_html":"(object) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/set.cr","line_number":135,"url":null},"def":{"name":"includes?","args":[{"name":"object","external_name":"object","restriction":""}],"return_type":"Bool","visibility":"Public","body":"@hash.has_key?(object)"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Alias of `#to_s`.","summary":"<p>Alias of <code><a href=\"Set.html#to_s%28io%3AIO%29%3ANil-instance-method\">#to_s</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/set.cr","line_number":386,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"intersects?(other:Set):Bool-instance-method","name":"intersects?","doc":"Returns `true` if the set and the given set have at least one element in\ncommon.\n\n```\nSet{1, 2, 3}.intersects? Set{4, 5} # => false\nSet{1, 2, 3}.intersects? Set{3, 4} # => true\n```","summary":"<p>Returns <code>true</code> if the set and the given set have at least one element in common.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Set"}],"args_string":"(other : Set) : Bool","args_html":"(other : <a href=\"Set.html\">Set</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/set.cr","line_number":404,"url":null},"def":{"name":"intersects?","args":[{"name":"other","external_name":"other","restriction":"Set"}],"return_type":"Bool","visibility":"Public","body":"if size < other.size\n  any? do |o|\n    other.includes?(o)\n  end\nelse\n  other.any? do |o|\n    includes?(o)\n  end\nend"}},{"html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","args_html":"(pp) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/set.cr","line_number":390,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"return_type":"Nil","visibility":"Public","body":"pp.list(\"Set{\", self, \"}\")"}},{"html_id":"proper_subset_of?(other:Set):Bool-instance-method","name":"proper_subset_of?","doc":"Returns `true` if the set is a proper subset of the *other* set.\n\nThis set must have fewer elements than the *other* set, and all\nof elements in this set must be present in the *other* set.\n\n```\nSet{1, 5}.proper_subset_of? Set{1, 3, 5}    # => true\nSet{1, 3, 5}.proper_subset_of? Set{1, 3, 5} # => false\n```","summary":"<p>Returns <code>true</code> if the set is a proper subset of the <em>other</em> set.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Set"}],"args_string":"(other : Set) : Bool","args_html":"(other : <a href=\"Set.html\">Set</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/set.cr","line_number":442,"url":null},"def":{"name":"proper_subset_of?","args":[{"name":"other","external_name":"other","restriction":"Set"}],"return_type":"Bool","visibility":"Public","body":"if other.size <= size\n  return false\nend\nall? do |value|\n  other.includes?(value)\nend\n"}},{"html_id":"proper_superset_of?(other:Set):Bool-instance-method","name":"proper_superset_of?","doc":"Returns `true` if the set is a superset of the *other* set.\n\nThe *other* must have the same or fewer elements than this set, and all of\nelements in the *other* set must be present in this set.\n\n```\nSet{1, 3, 5}.proper_superset_of? Set{1, 5}    # => true\nSet{1, 3, 5}.proper_superset_of? Set{1, 3, 5} # => false\n```","summary":"<p>Returns <code>true</code> if the set is a superset of the <em>other</em> set.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Set"}],"args_string":"(other : Set) : Bool","args_html":"(other : <a href=\"Set.html\">Set</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/set.cr","line_number":469,"url":null},"def":{"name":"proper_superset_of?","args":[{"name":"other","external_name":"other","restriction":"Set"}],"return_type":"Bool","visibility":"Public","body":"other.proper_subset_of?(self)"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Returns the number of elements in the set.\n\n```\ns = Set{1, 5}\ns.size # => 2\n```","summary":"<p>Returns the number of elements in the set.</p>","abstract":false,"location":{"filename":"src/set.cr","line_number":159,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"@hash.size"}},{"html_id":"subset_of?(other:Set):Bool-instance-method","name":"subset_of?","doc":"Returns `true` if the set is a subset of the *other* set.\n\nThis set must have the same or fewer elements than the *other* set, and all\nof elements in this set must be present in the *other* set.\n\n```\nSet{1, 5}.subset_of? Set{1, 3, 5}    # => true\nSet{1, 3, 5}.subset_of? Set{1, 3, 5} # => true\n```","summary":"<p>Returns <code>true</code> if the set is a subset of the <em>other</em> set.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Set"}],"args_string":"(other : Set) : Bool","args_html":"(other : <a href=\"Set.html\">Set</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/set.cr","line_number":428,"url":null},"def":{"name":"subset_of?","args":[{"name":"other","external_name":"other","restriction":"Set"}],"return_type":"Bool","visibility":"Public","body":"if other.size < size\n  return false\nend\nall? do |value|\n  other.includes?(value)\nend\n"}},{"html_id":"subtract(other:Enumerable)-instance-method","name":"subtract","doc":"Returns `self` after removing from it those elements that are present in\nthe given enumerable.\n\n```\nSet{'a', 'b', 'b', 'z'}.subtract Set{'a', 'b', 'c'} # => Set{'z'}\nSet{1, 2, 3, 4, 5}.subtract [2, 4, 6]               # => Set{1, 3, 5}\n```","summary":"<p>Returns <code>self</code> after removing from it those elements that are present in the given enumerable.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Enumerable"}],"args_string":"(other : Enumerable)","args_html":"(other : <a href=\"Enumerable.html\">Enumerable</a>)","location":{"filename":"src/set.cr","line_number":320,"url":null},"def":{"name":"subtract","args":[{"name":"other","external_name":"other","restriction":"Enumerable"}],"visibility":"Public","body":"other.each do |value|\n  delete(value)\nend\nself\n"}},{"html_id":"superset_of?(other:Set):Bool-instance-method","name":"superset_of?","doc":"Returns `true` if the set is a superset of the *other* set.\n\nThe *other* must have the same or fewer elements than this set, and all of\nelements in the *other* set must be present in this set.\n\n```\nSet{1, 3, 5}.superset_of? Set{1, 5}    # => true\nSet{1, 3, 5}.superset_of? Set{1, 3, 5} # => true\n```","summary":"<p>Returns <code>true</code> if the set is a superset of the <em>other</em> set.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Set"}],"args_string":"(other : Set) : Bool","args_html":"(other : <a href=\"Set.html\">Set</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/set.cr","line_number":456,"url":null},"def":{"name":"superset_of?","args":[{"name":"other","external_name":"other","restriction":"Set"}],"return_type":"Bool","visibility":"Public","body":"other.subset_of?(self)"}},{"html_id":"to_a-instance-method","name":"to_a","doc":"Returns the elements as an `Array`.\n\n```\nSet{1, 5}.to_a # => [1,5]\n```","summary":"<p>Returns the elements as an <code><a href=\"Array.html\">Array</a></code>.</p>","abstract":false,"location":{"filename":"src/set.cr","line_number":381,"url":null},"def":{"name":"to_a","visibility":"Public","body":"@hash.keys"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":110,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.array do\n  each(&.to_json(json))\nend"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Writes a string representation of the set to *io*.","summary":"<p>Writes a string representation of the set to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/set.cr","line_number":413,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"Set{\"\njoin(io, \", \", &.inspect(io))\nio << '}'\n"}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder) : Nil","args_html":"(yaml : <a href=\"YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":111,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"yaml.sequence do\n  each(&.to_yaml(yaml))\nend"}},{"html_id":"|(other:Set(U))forallU-instance-method","name":"|","doc":"Union: returns a new set containing all unique elements from both sets.\n\n```\nSet{1, 1, 3, 5} | Set{1, 2, 3}               # => Set{1, 3, 5, 2}\nSet{'a', 'b', 'b', 'z'} | Set{'a', 'b', 'c'} # => Set{'a', 'b', 'z', 'c'}\n```\n\nSee also: `#concat` to add elements from a set to `self`.","summary":"<p>Union: returns a new set containing all unique elements from both sets.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Set(U)"}],"args_string":"(other : Set(U)) forall U","args_html":"(other : <a href=\"Set.html\">Set</a>(U)) forall U","location":{"filename":"src/set.cr","line_number":227,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Set(U)"}],"visibility":"Public","body":"set = Set(T | U).new(Math.max(size, other.size))\neach do |value|\n  set.add(value)\nend\nother.each do |value|\n  set.add(value)\nend\nset\n"}}]},{"html_id":"Crystal/Signal","path":"Signal.html","kind":"enum","full_name":"Signal","name":"Signal","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/signal.cr","line_number":29,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"HUP","name":"HUP","value":"1"},{"id":"INT","name":"INT","value":"2"},{"id":"QUIT","name":"QUIT","value":"3"},{"id":"ILL","name":"ILL","value":"4"},{"id":"TRAP","name":"TRAP","value":"5"},{"id":"IOT","name":"IOT","value":"6"},{"id":"ABRT","name":"ABRT","value":"6"},{"id":"FPE","name":"FPE","value":"8"},{"id":"KILL","name":"KILL","value":"9"},{"id":"BUS","name":"BUS","value":"7"},{"id":"SEGV","name":"SEGV","value":"11"},{"id":"SYS","name":"SYS","value":"31"},{"id":"PIPE","name":"PIPE","value":"13"},{"id":"ALRM","name":"ALRM","value":"14"},{"id":"TERM","name":"TERM","value":"15"},{"id":"URG","name":"URG","value":"23"},{"id":"STOP","name":"STOP","value":"19"},{"id":"TSTP","name":"TSTP","value":"20"},{"id":"CONT","name":"CONT","value":"18"},{"id":"CHLD","name":"CHLD","value":"17"},{"id":"TTIN","name":"TTIN","value":"21"},{"id":"TTOU","name":"TTOU","value":"22"},{"id":"IO","name":"IO","value":"29"},{"id":"XCPU","name":"XCPU","value":"24"},{"id":"XFSZ","name":"XFSZ","value":"25"},{"id":"VTALRM","name":"VTALRM","value":"26"},{"id":"USR1","name":"USR1","value":"10"},{"id":"USR2","name":"USR2","value":"12"},{"id":"WINCH","name":"WINCH","value":"28"},{"id":"PWR","name":"PWR","value":"30"},{"id":"STKFLT","name":"STKFLT","value":"16"},{"id":"UNUSED","name":"UNUSED","value":"31"}],"doc":"Safely handle inter-process signals on POSIX systems.\n\nSignals are dispatched to the event loop and later processed in a dedicated\nfiber. Some received signals may never be processed when the program\nterminates.\n\n```\nputs \"Ctrl+C still has the OS default action (stops the program)\"\nsleep 3\n\nSignal::INT.trap do\n  puts \"Gotcha!\"\nend\nputs \"Ctrl+C will be caught from now on\"\nsleep 3\n\nSignal::INT.reset\nputs \"Ctrl+C is back to the OS default action\"\nsleep 3\n```\n\nNote:\n- An uncaught exception in a signal handler is a fatal error.","summary":"<p>Safely handle inter-process signals on POSIX systems.</p>","instance_methods":[{"html_id":"abrt?-instance-method","name":"abrt?","abstract":false,"location":{"filename":"src/signal.cr","line_number":36,"url":null},"def":{"name":"abrt?","visibility":"Public","body":"self == ABRT"}},{"html_id":"alrm?-instance-method","name":"alrm?","abstract":false,"location":{"filename":"src/signal.cr","line_number":43,"url":null},"def":{"name":"alrm?","visibility":"Public","body":"self == ALRM"}},{"html_id":"bus?-instance-method","name":"bus?","abstract":false,"location":{"filename":"src/signal.cr","line_number":39,"url":null},"def":{"name":"bus?","visibility":"Public","body":"self == BUS"}},{"html_id":"chld?-instance-method","name":"chld?","abstract":false,"location":{"filename":"src/signal.cr","line_number":49,"url":null},"def":{"name":"chld?","visibility":"Public","body":"self == CHLD"}},{"html_id":"cont?-instance-method","name":"cont?","abstract":false,"location":{"filename":"src/signal.cr","line_number":48,"url":null},"def":{"name":"cont?","visibility":"Public","body":"self == CONT"}},{"html_id":"fpe?-instance-method","name":"fpe?","abstract":false,"location":{"filename":"src/signal.cr","line_number":37,"url":null},"def":{"name":"fpe?","visibility":"Public","body":"self == FPE"}},{"html_id":"hup?-instance-method","name":"hup?","abstract":false,"location":{"filename":"src/signal.cr","line_number":30,"url":null},"def":{"name":"hup?","visibility":"Public","body":"self == HUP"}},{"html_id":"ignore:Nil-instance-method","name":"ignore","doc":"Clears the handler for this signal and prevents the OS default action.\n\nNote that trying to ignore `CHLD` will actually set the default crystal\nhandler that monitors and reaps child processes. This prevents zombie\nprocesses and is required by `Process#wait` for example.","summary":"<p>Clears the handler for this signal and prevents the OS default action.</p>","abstract":false,"location":{"filename":"src/signal.cr","line_number":100,"url":null},"def":{"name":"ignore","return_type":"Nil","visibility":"Public","body":"Crystal::Signal.ignore(self)"}},{"html_id":"ill?-instance-method","name":"ill?","abstract":false,"location":{"filename":"src/signal.cr","line_number":33,"url":null},"def":{"name":"ill?","visibility":"Public","body":"self == ILL"}},{"html_id":"int?-instance-method","name":"int?","abstract":false,"location":{"filename":"src/signal.cr","line_number":31,"url":null},"def":{"name":"int?","visibility":"Public","body":"self == INT"}},{"html_id":"io?-instance-method","name":"io?","abstract":false,"location":{"filename":"src/signal.cr","line_number":52,"url":null},"def":{"name":"io?","visibility":"Public","body":"self == IO"}},{"html_id":"iot?-instance-method","name":"iot?","abstract":false,"location":{"filename":"src/signal.cr","line_number":35,"url":null},"def":{"name":"iot?","visibility":"Public","body":"self == IOT"}},{"html_id":"kill?-instance-method","name":"kill?","abstract":false,"location":{"filename":"src/signal.cr","line_number":38,"url":null},"def":{"name":"kill?","visibility":"Public","body":"self == KILL"}},{"html_id":"pipe?-instance-method","name":"pipe?","abstract":false,"location":{"filename":"src/signal.cr","line_number":42,"url":null},"def":{"name":"pipe?","visibility":"Public","body":"self == PIPE"}},{"html_id":"pwr?-instance-method","name":"pwr?","abstract":false,"location":{"filename":"src/signal.cr","line_number":60,"url":null},"def":{"name":"pwr?","visibility":"Public","body":"self == PWR"}},{"html_id":"quit?-instance-method","name":"quit?","abstract":false,"location":{"filename":"src/signal.cr","line_number":32,"url":null},"def":{"name":"quit?","visibility":"Public","body":"self == QUIT"}},{"html_id":"reset:Nil-instance-method","name":"reset","doc":"Resets the handler for this signal to the OS default.\n\nNote that trying to reset `CHLD` will actually set the default crystal\nhandler that monitors and reaps child processes. This prevents zombie\nprocesses and is required by `Process#wait` for example.","summary":"<p>Resets the handler for this signal to the OS default.</p>","abstract":false,"location":{"filename":"src/signal.cr","line_number":91,"url":null},"def":{"name":"reset","return_type":"Nil","visibility":"Public","body":"Crystal::Signal.reset(self)"}},{"html_id":"segv?-instance-method","name":"segv?","abstract":false,"location":{"filename":"src/signal.cr","line_number":40,"url":null},"def":{"name":"segv?","visibility":"Public","body":"self == SEGV"}},{"html_id":"stkflt?-instance-method","name":"stkflt?","abstract":false,"location":{"filename":"src/signal.cr","line_number":60,"url":null},"def":{"name":"stkflt?","visibility":"Public","body":"self == STKFLT"}},{"html_id":"stop?-instance-method","name":"stop?","abstract":false,"location":{"filename":"src/signal.cr","line_number":46,"url":null},"def":{"name":"stop?","visibility":"Public","body":"self == STOP"}},{"html_id":"sys?-instance-method","name":"sys?","abstract":false,"location":{"filename":"src/signal.cr","line_number":41,"url":null},"def":{"name":"sys?","visibility":"Public","body":"self == SYS"}},{"html_id":"term?-instance-method","name":"term?","abstract":false,"location":{"filename":"src/signal.cr","line_number":44,"url":null},"def":{"name":"term?","visibility":"Public","body":"self == TERM"}},{"html_id":"trap(&handler:Signal->):Nil-instance-method","name":"trap","doc":"Sets the handler for this signal to the passed function.\n\nAfter executing this, whenever the current process receives the\ncorresponding signal, the passed function will be called (instead of the OS\ndefault). The handler will run in a signal-safe fiber thought the event\nloop; there is no limit to what functions can be called, unlike raw signals\nthat run on the sigaltstack.\n\nNote that `CHLD` is always trapped and child processes will always be reaped\nbefore the custom handler is called, hence a custom `CHLD` handler must\ncheck child processes using `Process.exists?`. Trying to use waitpid with a\nzero or negative value won't work.","summary":"<p>Sets the handler for this signal to the passed function.</p>","abstract":false,"location":{"filename":"src/signal.cr","line_number":78,"url":null},"def":{"name":"trap","yields":1,"block_arg":{"name":"handler","external_name":"handler","restriction":"(Signal ->)"},"return_type":"Nil","visibility":"Public","body":"if self == CHLD\n  Crystal::Signal.child_handler = handler\nelse\n  Crystal::Signal.trap(self, handler)\nend"}},{"html_id":"trap?-instance-method","name":"trap?","abstract":false,"location":{"filename":"src/signal.cr","line_number":34,"url":null},"def":{"name":"trap?","visibility":"Public","body":"self == TRAP"}},{"html_id":"tstp?-instance-method","name":"tstp?","abstract":false,"location":{"filename":"src/signal.cr","line_number":47,"url":null},"def":{"name":"tstp?","visibility":"Public","body":"self == TSTP"}},{"html_id":"ttin?-instance-method","name":"ttin?","abstract":false,"location":{"filename":"src/signal.cr","line_number":50,"url":null},"def":{"name":"ttin?","visibility":"Public","body":"self == TTIN"}},{"html_id":"ttou?-instance-method","name":"ttou?","abstract":false,"location":{"filename":"src/signal.cr","line_number":51,"url":null},"def":{"name":"ttou?","visibility":"Public","body":"self == TTOU"}},{"html_id":"unused?-instance-method","name":"unused?","abstract":false,"location":{"filename":"src/signal.cr","line_number":60,"url":null},"def":{"name":"unused?","visibility":"Public","body":"self == UNUSED"}},{"html_id":"urg?-instance-method","name":"urg?","abstract":false,"location":{"filename":"src/signal.cr","line_number":45,"url":null},"def":{"name":"urg?","visibility":"Public","body":"self == URG"}},{"html_id":"usr1?-instance-method","name":"usr1?","abstract":false,"location":{"filename":"src/signal.cr","line_number":56,"url":null},"def":{"name":"usr1?","visibility":"Public","body":"self == USR1"}},{"html_id":"usr2?-instance-method","name":"usr2?","abstract":false,"location":{"filename":"src/signal.cr","line_number":57,"url":null},"def":{"name":"usr2?","visibility":"Public","body":"self == USR2"}},{"html_id":"vtalrm?-instance-method","name":"vtalrm?","abstract":false,"location":{"filename":"src/signal.cr","line_number":55,"url":null},"def":{"name":"vtalrm?","visibility":"Public","body":"self == VTALRM"}},{"html_id":"winch?-instance-method","name":"winch?","abstract":false,"location":{"filename":"src/signal.cr","line_number":58,"url":null},"def":{"name":"winch?","visibility":"Public","body":"self == WINCH"}},{"html_id":"xcpu?-instance-method","name":"xcpu?","abstract":false,"location":{"filename":"src/signal.cr","line_number":53,"url":null},"def":{"name":"xcpu?","visibility":"Public","body":"self == XCPU"}},{"html_id":"xfsz?-instance-method","name":"xfsz?","abstract":false,"location":{"filename":"src/signal.cr","line_number":54,"url":null},"def":{"name":"xfsz?","visibility":"Public","body":"self == XFSZ"}}]},{"html_id":"Crystal/Slice","path":"Slice.html","kind":"struct","full_name":"Slice(T)","name":"Slice","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Indexable/Mutable","kind":"module","full_name":"Indexable::Mutable","name":"Mutable"},{"html_id":"Crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"},{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/slice.cr","line_number":13,"url":null},{"filename":"src/slice/sort.cr","line_number":1,"url":null},{"filename":"src/yaml/from_yaml.cr","line_number":354,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":274,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Indexable/Mutable","kind":"module","full_name":"Indexable::Mutable","name":"Mutable"}],"doc":"A `Slice` is a `Pointer` with an associated size.\n\nWhile a pointer is unsafe because no bound checks are performed when reading from and writing to it,\nreading from and writing to a slice involve bound checks.\nIn this way, a slice is a safe alternative to `Pointer`.\n\nA Slice can be created as read-only: trying to write to it\nwill raise. For example the slice of bytes returned by\n`String#to_slice` is read-only.","summary":"<p>A <code><a href=\"Slice.html\">Slice</a></code> is a <code><a href=\"Pointer.html\">Pointer</a></code> with an associated size.</p>","constructors":[{"html_id":"empty:self-class-method","name":"empty","doc":"Creates an empty slice.\n\n```\nslice = Slice(UInt8).empty\nslice.size # => 0\n```","summary":"<p>Creates an empty slice.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":153,"url":null},"def":{"name":"empty","return_type":"self","visibility":"Public","body":"new(Pointer(T).null, 0)"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":355,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"{% if T != UInt8 %}\n      {% raise(\"Can only deserialize Slice(UInt8), not #{@type}}\") %}\n    {% end %}\nparse_scalar(ctx, node, self)\n"}},{"html_id":"new(pointer:Pointer(T),size:Int,*,read_only=false)-class-method","name":"new","doc":"Creates a slice to the given *pointer*, bounded by the given *size*. This\nmethod does not allocate heap memory.\n\n```\nptr = Pointer.malloc(9) { |i| ('a'.ord + i).to_u8 }\n\nslice = Slice.new(ptr, 3)\nslice.size # => 3\nslice      # => Bytes[97, 98, 99]\n\nString.new(slice) # => \"abc\"\n```","summary":"<p>Creates a slice to the given <em>pointer</em>, bounded by the given <em>size</em>.</p>","abstract":false,"args":[{"name":"pointer","external_name":"pointer","restriction":"Pointer(T)"},{"name":"size","external_name":"size","restriction":"Int"},{"name":"","external_name":"","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(pointer : Pointer(T), size : Int, *, read_only = false)","args_html":"(pointer : <a href=\"Pointer.html\">Pointer</a>(T), size : <a href=\"Int.html\">Int</a>, *, read_only = <span class=\"n\">false</span>)","location":{"filename":"src/slice.cr","line_number":69,"url":null},"def":{"name":"new","args":[{"name":"pointer","external_name":"pointer","restriction":"Pointer(T)"},{"name":"size","external_name":"size","restriction":"Int"},{"name":"","external_name":"","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"splat_index":2,"visibility":"Public","body":"_ = Slice(T).allocate\n_.initialize(pointer, size, read_only: read_only)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(size:Int,value:T,*,read_only=false)-class-method","name":"new","doc":"Allocates `size * sizeof(T)` bytes of heap memory initialized to *value*\nand returns a slice pointing to that memory.\n\nThe memory is allocated by the `GC`, so when there are\nno pointers to this memory, it will be automatically freed.\n\n```\nslice = Slice.new(3, 10)\nslice # => Slice[10, 10, 10]\n```","summary":"<p>Allocates <code>size * sizeof(T)</code> bytes of heap memory initialized to <em>value</em> and returns a slice pointing to that memory.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"},{"name":"","external_name":"","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(size : Int, value : T, *, read_only = false)","args_html":"(size : <a href=\"Int.html\">Int</a>, value : T, *, read_only = <span class=\"n\">false</span>)","location":{"filename":"src/slice.cr","line_number":120,"url":null},"def":{"name":"new","args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"},{"name":"","external_name":"","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"splat_index":2,"visibility":"Public","body":"new(size, read_only: read_only) do\n  value\nend"}},{"html_id":"new(size:Int,*,read_only=false)-class-method","name":"new","doc":"Allocates `size * sizeof(T)` bytes of heap memory initialized to zero\nand returns a slice pointing to that memory.\n\nThe memory is allocated by the `GC`, so when there are\nno pointers to this memory, it will be automatically freed.\n\nOnly works for primitive integers and floats (`UInt8`, `Int32`, `Float64`, etc.)\n\n```\nslice = Slice(UInt8).new(3)\nslice # => Bytes[0, 0, 0]\n```","summary":"<p>Allocates <code>size * sizeof(T)</code> bytes of heap memory initialized to zero and returns a slice pointing to that memory.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"","external_name":"","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(size : Int, *, read_only = false)","args_html":"(size : <a href=\"Int.html\">Int</a>, *, read_only = <span class=\"n\">false</span>)","location":{"filename":"src/slice.cr","line_number":85,"url":null},"def":{"name":"new","args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"","external_name":"","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"splat_index":1,"visibility":"Public","body":"{% if Number::Primitive.union_types.includes?(T) %}{% else %}\n      {% raise(\"Can only use primitive integers and floats with Slice.new(size), not #{T}\") %}\n    {% end %}\npointer = Pointer(T).malloc(size)\nnew(pointer, size, read_only: read_only)\n"}},{"html_id":"new(size:Int,*,read_only=false,&)-class-method","name":"new","doc":"Allocates `size * sizeof(T)` bytes of heap memory initialized to the value\nreturned by the block (which is invoked once with each index in the range `0...size`)\nand returns a slice pointing to that memory.\n\nThe memory is allocated by the `GC`, so when there are\nno pointers to this memory, it will be automatically freed.\n\n```\nslice = Slice.new(3) { |i| i + 10 }\nslice # => Slice[10, 11, 12]\n```","summary":"<p>Allocates <code>size * sizeof(T)</code> bytes of heap memory initialized to the value returned by the block (which is invoked once with each index in the range <code>0..<a href=\"Slice.html#size%3AInt32-instance-method\">.size</a></code>) and returns a slice pointing to that memory.</p>","abstract":false,"args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"","external_name":"","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(size : Int, *, read_only = false, &)","args_html":"(size : <a href=\"Int.html\">Int</a>, *, read_only = <span class=\"n\">false</span>, &)","location":{"filename":"src/slice.cr","line_number":105,"url":null},"def":{"name":"new","args":[{"name":"size","external_name":"size","restriction":"Int"},{"name":"","external_name":"","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"splat_index":1,"yields":1,"visibility":"Public","body":"pointer = Pointer.malloc(size) do |i|\n  yield i\nend\nnew(pointer, size, read_only: read_only)\n"}}],"instance_methods":[{"html_id":"+(offset:Int):Slice(T)-instance-method","name":"+","doc":"Returns a new slice that is *offset* elements apart from this slice.\n\n```\nslice = Slice.new(5) { |i| i + 10 }\nslice # => Slice[10, 11, 12, 13, 14]\n\nslice2 = slice + 2\nslice2 # => Slice[12, 13, 14]\n```","summary":"<p>Returns a new slice that is <em>offset</em> elements apart from this slice.</p>","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":"Int"}],"args_string":"(offset : Int) : Slice(T)","args_html":"(offset : <a href=\"Int.html\">Int</a>) : <a href=\"Slice.html\">Slice</a>(T)","location":{"filename":"src/slice.cr","line_number":166,"url":null},"def":{"name":"+","args":[{"name":"offset","external_name":"offset","restriction":"Int"}],"return_type":"Slice(T)","visibility":"Public","body":"check_size(offset)\nSlice.new(@pointer + offset, @size - offset, read_only: @read_only)\n"}},{"html_id":"<=>(other:Slice(U))forallU-instance-method","name":"<=>","doc":"Combined comparison operator.\n\nReturns a negative number, `0`, or a positive number depending on\nwhether `self` is less than *other*, equals *other*.\n\nIt compares the elements of both slices in the same position using the\n`<=>` operator. As soon as one of such comparisons returns a non-zero\nvalue, that result is the return value of the comparison.\n\nIf all elements are equal, the comparison is based on the size of the arrays.\n\n```\nBytes[8] <=> Bytes[1, 2, 3] # => 7\nBytes[2] <=> Bytes[4, 2, 3] # => -2\nBytes[1, 2] <=> Bytes[1, 2] # => 0\n```","summary":"<p>Combined comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Slice(U)"}],"args_string":"(other : Slice(U)) forall U","args_html":"(other : <a href=\"Slice.html\">Slice</a>(U)) forall U","location":{"filename":"src/slice.cr","line_number":770,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Slice(U)"}],"visibility":"Public","body":"min_size = Math.min(size, other.size)\n{% if (T == UInt8) && (U == UInt8) %}\n      cmp = to_unsafe.memcmp(other.to_unsafe, min_size)\n      return cmp if cmp != 0\n    {% else %}\n      0.upto(min_size - 1) do |i|\n        n = to_unsafe[i] <=> other.to_unsafe[i]\n        return n if n != 0\n      end\n    {% end %}\nsize <=> other.size\n"}},{"html_id":"==(other:Slice(U)):BoolforallU-instance-method","name":"==","doc":"Returns `true` if `self` and *other* have the same size and all their\nelements are equal, `false` otherwise.\n\n```\nBytes[1, 2] == Bytes[1, 2]    # => true\nBytes[1, 3] == Bytes[1, 2]    # => false\nBytes[1, 2] == Bytes[1, 2, 3] # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> and <em>other</em> have the same size and all their elements are equal, <code>false</code> otherwise.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Slice(U)"}],"args_string":"(other : Slice(U)) : Bool forall U","args_html":"(other : <a href=\"Slice.html\">Slice</a>(U)) : <a href=\"Bool.html\">Bool</a> forall U","location":{"filename":"src/slice.cr","line_number":792,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Slice(U)"}],"return_type":"Bool","visibility":"Public","body":"if size != other.size\n  return false\nend\n{% if (T == UInt8) && (U == UInt8) %}\n      to_unsafe.memcmp(other.to_unsafe, size) == 0\n    {% else %}\n      each_with_index do |elem, i|\n        return false unless elem == other.to_unsafe[i]\n      end\n      true\n    {% end %}\n"}},{"html_id":"[](start:Int,count:Int):Slice(T)-instance-method","name":"[]","doc":"Returns a new slice that starts at *start* elements from this slice's start,\nand of *count* size.\n\nRaises `IndexError` if the new slice falls outside this slice.\n\n```\nslice = Slice.new(5) { |i| i + 10 }\nslice # => Slice[10, 11, 12, 13, 14]\n\nslice[1, 3]  # => Slice[11, 12, 13]\nslice[1, 33] # raises IndexError\n```","summary":"<p>Returns a new slice that starts at <em>start</em> elements from this slice's start, and of <em>count</em> size.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int) : Slice(T)","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <a href=\"Slice.html\">Slice</a>(T)","location":{"filename":"src/slice.cr","line_number":212,"url":null},"def":{"name":"[]","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"Slice(T)","visibility":"Public","body":"self[start, count]? || (raise(IndexError.new))"}},{"html_id":"[](range:Range):Slice(T)-instance-method","name":"[]","doc":"Returns a new slice with the elements in the given range.\n\nThe first element in the returned slice is `self[range.begin]` followed\nby the next elements up to index `range.end` (or `self[range.end - 1]` if\nthe range is exclusive).\nIf there are fewer elements in `self`, the returned slice is shorter than\n`range.size`.\n\n```\na = Slice[\"a\", \"b\", \"c\", \"d\", \"e\"]\na[1..3] # => Slice[\"b\", \"c\", \"d\"]\n```\n\nNegative indices count backward from the end of the slice (`-1` is the last\nelement). Additionally, an empty slice is returned when the starting index\nfor an element range is at the end of the slice.\n\nRaises `IndexError` if the new slice falls outside this slice.\n\n```\nslice = Slice.new(5) { |i| i + 10 }\nslice # => Slice[10, 11, 12, 13, 14]\n\nslice[1..3]  # => Slice[11, 12, 13]\nslice[1..33] # raises IndexError\n```","summary":"<p>Returns a new slice with the elements in the given range.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range) : Slice(T)","args_html":"(range : <a href=\"Range.html\">Range</a>) : <a href=\"Slice.html\">Slice</a>(T)","location":{"filename":"src/slice.cr","line_number":262,"url":null},"def":{"name":"[]","args":[{"name":"range","external_name":"range","restriction":"Range"}],"return_type":"Slice(T)","visibility":"Public","body":"start, count = (Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new))\nself[start, count]\n"}},{"html_id":"[]=(index:Int,value:T):T-instance-method","name":"[]=","doc":"Sets the given *value* at the given *index*. Returns *value*.\n\nNegative indices can be used to start counting from the end of the\ncontainer. Raises `IndexError` if trying to set an element outside the\ncontainer's range.\n\n```\nary = [1, 2, 3]\nary[0] = 5\nary # => [5, 2, 3]\n\nary[3] = 5 # raises IndexError\n```\n\nRaises if this slice is read-only.","summary":"<p>Sets the given <em>value</em> at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(index : Int, value : T) : T","args_html":"(index : <a href=\"Int.html\">Int</a>, value : T) : T","location":{"filename":"src/slice.cr","line_number":176,"url":null},"def":{"name":"[]=","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"return_type":"T","visibility":"Public","body":"check_writable\nsuper(index, value)\n"}},{"html_id":"[]?(start:Int,count:Int):Slice(T)?-instance-method","name":"[]?","doc":"Returns a new slice that starts at *start* elements from this slice's start,\nand of *count* size.\n\nReturns `nil` if the new slice falls outside this slice.\n\n```\nslice = Slice.new(5) { |i| i + 10 }\nslice # => Slice[10, 11, 12, 13, 14]\n\nslice[1, 3]?  # => Slice[11, 12, 13]\nslice[1, 33]? # => nil\n```","summary":"<p>Returns a new slice that starts at <em>start</em> elements from this slice's start, and of <em>count</em> size.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int) : Slice(T)?","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <a href=\"Slice.html\">Slice</a>(T)?","location":{"filename":"src/slice.cr","line_number":193,"url":null},"def":{"name":"[]?","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"Slice(T) | ::Nil","visibility":"Public","body":"if 0 <= start && start <= @size\nelse\n  return\nend\nif 0 <= count && count <= (@size - start)\nelse\n  return\nend\nSlice.new(@pointer + start, count, read_only: @read_only)\n"}},{"html_id":"[]?(range:Range)-instance-method","name":"[]?","doc":"Returns a new slice with the elements in the given range.\n\nNegative indices count backward from the end of the slice (`-1` is the last\nelement). Additionally, an empty slice is returned when the starting index\nfor an element range is at the end of the slice.\n\nReturns `nil` if the new slice falls outside this slice.\n\n```\nslice = Slice.new(5) { |i| i + 10 }\nslice # => Slice[10, 11, 12, 13, 14]\n\nslice[1..3]?  # => Slice[11, 12, 13]\nslice[1..33]? # => nil\n```","summary":"<p>Returns a new slice with the elements in the given range.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range)","args_html":"(range : <a href=\"Range.html\">Range</a>)","location":{"filename":"src/slice.cr","line_number":231,"url":null},"def":{"name":"[]?","args":[{"name":"range","external_name":"range","restriction":"Range"}],"visibility":"Public","body":"start, count = (Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new))\nself[start, count]?\n"}},{"html_id":"bytesize:Int32-instance-method","name":"bytesize","abstract":false,"location":{"filename":"src/slice.cr","line_number":750,"url":null},"def":{"name":"bytesize","return_type":"Int32","visibility":"Public","body":"(sizeof(T)) * size"}},{"html_id":"clone-instance-method","name":"clone","doc":"Returns a deep copy of this slice.\n\nThis method allocates memory for the slice copy and stores the return values\nfrom calling `#clone` on each item.","summary":"<p>Returns a deep copy of this slice.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":128,"url":null},"def":{"name":"clone","visibility":"Public","body":"pointer = Pointer(T).malloc(size)\ncopy = self.class.new(pointer, size)\neach_with_index do |item, i|\n  copy[i] = item.clone\nend\ncopy\n"}},{"html_id":"copy_from(source:Pointer(T),count)-instance-method","name":"copy_from","abstract":false,"args":[{"name":"source","external_name":"source","restriction":"Pointer(T)"},{"name":"count","external_name":"count","restriction":""}],"args_string":"(source : Pointer(T), count)","args_html":"(source : <a href=\"Pointer.html\">Pointer</a>(T), count)","location":{"filename":"src/slice.cr","line_number":448,"url":null},"def":{"name":"copy_from","args":[{"name":"source","external_name":"source","restriction":"Pointer(T)"},{"name":"count","external_name":"count","restriction":""}],"visibility":"Public","body":"check_writable\ncheck_size(count)\n@pointer.copy_from(source, count)\n"}},{"html_id":"copy_from(source:self)-instance-method","name":"copy_from","doc":"Copies the contents of *source* into this slice.\n\nRaises `IndexError` if the destination slice cannot fit the data being transferred.","summary":"<p>Copies the contents of <em>source</em> into this slice.</p>","abstract":false,"args":[{"name":"source","external_name":"source","restriction":"self"}],"args_string":"(source : self)","args_html":"(source : <span class=\"k\">self</span>)","location":{"filename":"src/slice.cr","line_number":484,"url":null},"def":{"name":"copy_from","args":[{"name":"source","external_name":"source","restriction":"self"}],"visibility":"Public","body":"source.copy_to(self)"}},{"html_id":"copy_to(target:Pointer(T),count)-instance-method","name":"copy_to","abstract":false,"args":[{"name":"target","external_name":"target","restriction":"Pointer(T)"},{"name":"count","external_name":"count","restriction":""}],"args_string":"(target : Pointer(T), count)","args_html":"(target : <a href=\"Pointer.html\">Pointer</a>(T), count)","location":{"filename":"src/slice.cr","line_number":455,"url":null},"def":{"name":"copy_to","args":[{"name":"target","external_name":"target","restriction":"Pointer(T)"},{"name":"count","external_name":"count","restriction":""}],"visibility":"Public","body":"check_size(count)\n@pointer.copy_to(target, count)\n"}},{"html_id":"copy_to(target:self)-instance-method","name":"copy_to","doc":"Copies the contents of this slice into *target*.\n\nRaises `IndexError` if the destination slice cannot fit the data being transferred\ne.g. dest.size < self.size.\n\n```\nsrc = Slice['a', 'a', 'a']\ndst = Slice['b', 'b', 'b', 'b', 'b']\nsrc.copy_to dst\ndst             # => Slice['a', 'a', 'a', 'b', 'b']\ndst.copy_to src # raises IndexError\n```","summary":"<p>Copies the contents of this slice into <em>target</em>.</p>","abstract":false,"args":[{"name":"target","external_name":"target","restriction":"self"}],"args_string":"(target : self)","args_html":"(target : <span class=\"k\">self</span>)","location":{"filename":"src/slice.cr","line_number":473,"url":null},"def":{"name":"copy_to","args":[{"name":"target","external_name":"target","restriction":"self"}],"visibility":"Public","body":"target.check_writable\nif target.size < size\n  raise(IndexError.new)\nend\n@pointer.copy_to(target.to_unsafe, size)\n"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy of this slice.\n\nThis method allocates memory for the slice copy and duplicates the values.","summary":"<p>Returns a shallow copy of this slice.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":140,"url":null},"def":{"name":"dup","visibility":"Public","body":"pointer = Pointer(T).malloc(size)\ncopy = self.class.new(pointer, size)\ncopy.copy_from(self)\ncopy\n"}},{"html_id":"fill(value:T,start:Int,count:Int):self-instance-method","name":"fill","doc":"Replaces *count* or less (if there aren't enough) elements starting at the\ngiven *start* index with *value*. Returns `self`.\n\nNegative values of *start* count from the end of the container.\n\nRaises `IndexError` if the *start* index is out of range.\n\nRaises `ArgumentError` if *count* is negative.\n\n```\narray = [1, 2, 3, 4, 5]\narray.fill(9, 2, 2) # => [1, 2, 9, 9, 5]\narray               # => [1, 2, 9, 9, 5]\n```\n\nRaises if this slice is read-only.","summary":"<p>Replaces <em>count</em> or less (if there aren't enough) elements starting at the given <em>start</em> index with <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(value : T, start : Int, count : Int) : self","args_html":"(value : T, start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/slice.cr","line_number":409,"url":null},"def":{"name":"fill","args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"start, count = normalize_start_and_count(start, count)\nself[start, count].fill(value)\nself\n"}},{"html_id":"fill(value:T,range:Range):self-instance-method","name":"fill","doc":"Replaces the elements within the given *range* with *value*. Returns `self`.\n\nNegative indices count backward from the end of the container.\n\nRaises `IndexError` if the starting index is out of range.\n\n```\narray = [1, 2, 3, 4, 5]\narray.fill(9, 2..3) # => [1, 2, 9, 9, 5]\narray               # => [1, 2, 9, 9, 5]\n```\n\nRaises if this slice is read-only.","summary":"<p>Replaces the elements within the given <em>range</em> with <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(value : T, range : Range) : self","args_html":"(value : T, range : <a href=\"Range.html\">Range</a>) : <span class=\"k\">self</span>","location":{"filename":"src/slice.cr","line_number":420,"url":null},"def":{"name":"fill","args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"range","external_name":"range","restriction":"Range"}],"return_type":"self","visibility":"Public","body":"fill(value, *(Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new)))"}},{"html_id":"fill(value:T):self-instance-method","name":"fill","doc":"Replaces every element in `self` with the given *value*. Returns `self`.\n\n```\narray = [1, 2, 3, 4]\narray.fill(2) # => [2, 2, 2, 2]\narray         # => [2, 2, 2, 2]\n```\n\nRaises if this slice is read-only.","summary":"<p>Replaces every element in <code>self</code> with the given <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T) : self","args_html":"(value : T) : <span class=\"k\">self</span>","location":{"filename":"src/slice.cr","line_number":388,"url":null},"def":{"name":"fill","args":[{"name":"value","external_name":"value","restriction":"T"}],"return_type":"self","visibility":"Public","body":"check_writable\n{% if T == UInt8 %}\n      Intrinsics.memset(to_unsafe.as(Void*), value, size, false)\n      self\n    {% else %}\n      {% if Number::Primitive.union_types.includes?(T) %}\n        if value == 0\n          to_unsafe.clear(size)\n          return self\n        end\n      {% end %}\n\n      fill { value }\n    {% end %}\n"}},{"html_id":"fill(start:Int,count:Int,&:Int32->T):self-instance-method","name":"fill","doc":"Yields each index of `self`, starting at *start* and for *count* times (or\nless if there aren't enough elements), to the given block and then assigns\nthe block's value in that position. Returns `self`.\n\nNegative values of *start* count from the end of the container.\n\nHas no effect if *count* is zero or negative.\n\nRaises `IndexError` if *start* is outside the array range.\n\n```\na = [1, 2, 3, 4, 5, 6]\na.fill(2, 3) { |i| i * i * i } # => [1, 2, 8, 27, 125, 6]\n```\n\nRaises if this slice is read-only.","summary":"<p>Yields each index of <code>self</code>, starting at <em>start</em> and for <em>count</em> times (or less if there aren't enough elements), to the given block and then assigns the block's value in that position.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int, & : Int32 -> T) : self","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>, & : <a href=\"Int32.html\">Int32</a> -> T) : <span class=\"k\">self</span>","location":{"filename":"src/slice.cr","line_number":435,"url":null},"def":{"name":"fill","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Int32 -> T)"},"return_type":"self","visibility":"Public","body":"check_writable\nsuper(start, count) do |i|\n  yield i\nend\n"}},{"html_id":"fill(range:Range,&:Int32->T):self-instance-method","name":"fill","doc":"Yields each index of `self`, in the given *range*, to the given block and\nthen assigns the block's value in that position. Returns `self`.\n\nNegative indices count backward from the end of the container.\n\nRaises `IndexError` if the starting index is out of range.\n\n```\na = [1, 2, 3, 4, 5, 6]\na.fill(2..4) { |i| i * i * i } # => [1, 2, 8, 27, 125, 6]\n```\n\nRaises if this slice is read-only.","summary":"<p>Yields each index of <code>self</code>, in the given <em>range</em>, to the given block and then assigns the block's value in that position.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range, & : Int32 -> T) : self","args_html":"(range : <a href=\"Range.html\">Range</a>, & : <a href=\"Int32.html\">Int32</a> -> T) : <span class=\"k\">self</span>","location":{"filename":"src/slice.cr","line_number":443,"url":null},"def":{"name":"fill","args":[{"name":"range","external_name":"range","restriction":"Range"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Int32 -> T)"},"return_type":"self","visibility":"Public","body":"check_writable\nsuper(range) do |i|\n  yield i\nend\n"}},{"html_id":"fill(*,offset:Int=0,&:Int32->T):self-instance-method","name":"fill","doc":"Yields each index of `self` to the given block and then assigns\nthe block's value in that position. Returns `self`.\n\nAccepts an optional *offset* parameter, which tells the block to start\ncounting from there.\n\n```\narray = [2, 1, 1, 1]\narray.fill { |i| i * i }            # => [0, 1, 4, 9]\narray                               # => [0, 1, 4, 9]\narray.fill(offset: 3) { |i| i * i } # => [9, 16, 25, 36]\narray                               # => [9, 16, 25, 36]\n```\n\nRaises if this slice is read-only.","summary":"<p>Yields each index of <code>self</code> to the given block and then assigns the block's value in that position.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"args_string":"(*, offset : Int = 0, & : Int32 -> T) : self","args_html":"(*, offset : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>, & : <a href=\"Int32.html\">Int32</a> -> T) : <span class=\"k\">self</span>","location":{"filename":"src/slice.cr","line_number":427,"url":null},"def":{"name":"fill","args":[{"name":"","external_name":"","restriction":""},{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"splat_index":0,"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Int32 -> T)"},"return_type":"self","visibility":"Public","body":"check_writable\nsuper(offset: offset) do |i|\n  yield i\nend\n"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/slice.cr","line_number":1156,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"{% if T == UInt8 %}\n      hasher.bytes(self)\n    {% else %}\n      super hasher\n    {% end %}"}},{"html_id":"hexdump(io:IO)-instance-method","name":"hexdump","doc":"Writes a hexdump of this slice to the given *io*.\n\n`self` must be a `Slice(UInt8)`. To call this method on other `Slice`s,\n`#to_unsafe_bytes` should be used first.\n\nThis method is specially useful for debugging binary data and\nincoming/outgoing data in protocols.\n\nReturns the number of bytes written to *io*.\n\n```\nslice = UInt8.slice(97, 62, 63, 8, 255)\nslice.hexdump(STDOUT)\n```\n\nPrints:\n\n```text\n00000000  61 3e 3f 08 ff                                    a>?..\n```","summary":"<p>Writes a hexdump of this slice to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","args_html":"(io : <a href=\"IO.html\">IO</a>)","location":{"filename":"src/slice.cr","line_number":680,"url":null},"def":{"name":"hexdump","args":[{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"{% if T == UInt8 %}{% else %}\n      {% raise(\"Can only call `#hexdump` on Slice(UInt8), not #{@type}\") %}\n    {% end %}\nif empty?\n  return 0\nend\nline = uninitialized ::StaticArray(UInt8, 77)\nline_slice = line.to_slice\ncount = 0\npos = 0\nwhile pos < size\n  line_bytes = hexdump_line(line_slice, pos)\n  io.write_string(line_slice[0, line_bytes])\n  count = count + line_bytes\n  pos = pos + 16\nend\nio.flush\ncount\n"}},{"html_id":"hexdump:String-instance-method","name":"hexdump","doc":"Returns a hexdump of this slice.\n\n`self` must be a `Slice(UInt8)`. To call this method on other `Slice`s,\n`#to_unsafe_bytes` should be used first.\n\nThis method is specially useful for debugging binary data and\nincoming/outgoing data in protocols.\n\n```\nslice = UInt8.slice(97, 62, 63, 8, 255)\nslice.hexdump # => \"00000000  61 3e 3f 08 ff                                    a>?..\\n\"\n\n# assume little-endian system\nslice = Int16.slice(97, 62, 1000, -2)\nslice.to_unsafe_bytes.hexdump # => \"00000000  61 00 3e 00 e8 03 fe ff                           a.>.....\\n\"\n```","summary":"<p>Returns a hexdump of this slice.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":630,"url":null},"def":{"name":"hexdump","return_type":"String","visibility":"Public","body":"{% if T == UInt8 %}{% else %}\n      {% raise(\"Can only call `#hexdump` on Slice(UInt8), not #{@type}\") %}\n    {% end %}\nif empty?\n  return \"\"\nend\nfull_lines, leftover = size.divmod(16)\nif leftover == 0\n  str_size = full_lines * 77\nelse\n  str_size = ((full_lines + 1) * 77) - (16 - leftover)\nend\nString.new(str_size) do |buf|\n  pos = 0\n  offset = 0\n  while pos < size\n    hexdump_line(Slice.new(buf + offset, {77, str_size - offset}.min), pos)\n    pos = pos + 16\n    offset = offset + 77\n  end\n  {str_size, str_size}\nend\n"}},{"html_id":"hexstring:String-instance-method","name":"hexstring","doc":"Returns a hexstring representation of this slice.\n\n`self` must be a `Slice(UInt8)`. To call this method on other `Slice`s,\n`#to_unsafe_bytes` should be used first.\n\n```\nUInt8.slice(97, 62, 63, 8, 255).hexstring # => \"613e3f08ff\"\n\n# assume little-endian system\nInt16.slice(97, 62, 1000, -2).to_unsafe_bytes.hexstring # => \"61003e00e803feff\"\n```","summary":"<p>Returns a hexstring representation of this slice.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":586,"url":null},"def":{"name":"hexstring","return_type":"String","visibility":"Public","body":"{% if T == UInt8 %}{% else %}\n      {% raise(\"Can only call `#hexstring` on Slice(UInt8), not #{@type}\") %}\n    {% end %}\nstr_size = size * 2\nString.new(str_size) do |buffer|\n  hexstring(buffer)\n  {str_size, str_size}\nend\n"}},{"html_id":"index(object,offset:Int=0)-instance-method","name":"index","doc":"Returns the index of the first appearance of *value* in `self`\nstarting from the given *offset*, or `nil` if the value is not in `self`.\n\n```\n[1, 2, 3, 1, 2, 3].index(2, offset: 2) # => 4\n```","summary":"<p>Returns the index of the first appearance of <em>value</em> in <code>self</code> starting from the given <em>offset</em>, or <code>nil</code> if the value is not in <code>self</code>.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":""},{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"args_string":"(object, offset : Int = 0)","args_html":"(object, offset : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>)","location":{"filename":"src/slice.cr","line_number":1136,"url":null},"def":{"name":"index","args":[{"name":"object","external_name":"object","restriction":""},{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"visibility":"Public","body":"if T.is_a?(UInt8.class) && (object.is_a?(UInt8) || (object.is_a?(Int) && (0 <= object && object < 256)))\n  return fast_index(object, offset)\nend\nsuper(object, offset)\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends this struct's name and instance variables names and values\nto the given IO.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np1.to_s    # \"Point(@x=1, @y=2)\"\np1.inspect # \"Point(@x=1, @y=2)\"\n```","summary":"<p>Appends this struct's name and instance variables names and values to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/slice.cr","line_number":530,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"map(*,read_only=false,&:T->_)-instance-method","name":"map","doc":"Returns a new slice where elements are mapped by the given block.\n\n```\nslice = Slice[1, 2.5, \"a\"]\nslice.map &.to_s # => Slice[\"1\", \"2.5\", \"a\"]\n```","summary":"<p>Returns a new slice where elements are mapped by the given block.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(*, read_only = false, & : T -> _)","args_html":"(*, read_only = <span class=\"n\">false</span>, & : T -> _)","location":{"filename":"src/slice.cr","line_number":365,"url":null},"def":{"name":"map","args":[{"name":"","external_name":"","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"splat_index":0,"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> _)"},"visibility":"Public","body":"Slice.new(size, read_only: read_only) do |i|\n  yield @pointer[i]\nend"}},{"html_id":"map!(&:T->_):self-instance-method","name":"map!","doc":"Invokes the given block for each element of `self`, replacing the element\nwith the value returned by the block. Returns `self`.\n\n```\na = [1, 2, 3]\na.map! { |x| x * x }\na # => [1, 4, 9]\n```\n\nRaises if this slice is read-only.","summary":"<p>Invokes the given block for each element of <code>self</code>, replacing the element with the value returned by the block.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":354,"url":null},"def":{"name":"map!","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> _)"},"return_type":"self","visibility":"Public","body":"check_writable\nsuper() do |elem|\n  yield elem\nend\n"}},{"html_id":"map_with_index(offset=0,*,read_only=false,&:T,Int32->_)-instance-method","name":"map_with_index","doc":"Like `map`, but the block gets passed both the element and its index.\n\nAccepts an optional *offset* parameter, which tells it to start counting\nfrom there.","summary":"<p>Like <code><a href=\"Slice.html#map%28%2A%2Cread_only%3Dfalse%2C%26%3AT-%3E_%29-instance-method\">#map</a></code>, but the block gets passed both the element and its index.</p>","abstract":false,"args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(offset = 0, *, read_only = false, & : T, Int32 -> _)","args_html":"(offset = <span class=\"n\">0</span>, *, read_only = <span class=\"n\">false</span>, & : T, <a href=\"Int32.html\">Int32</a> -> _)","location":{"filename":"src/slice.cr","line_number":381,"url":null},"def":{"name":"map_with_index","args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"splat_index":1,"yields":2,"block_arg":{"name":"","external_name":"","restriction":"(T, Int32 -> _)"},"visibility":"Public","body":"Slice.new(size, read_only: read_only) do |i|\n  yield @pointer[i], offset + i\nend"}},{"html_id":"map_with_index!(offset=0,&:T,Int32->_):self-instance-method","name":"map_with_index!","doc":"Like `#map!`, but the block gets passed both the element and its index.\n\nAccepts an optional *offset* parameter, which tells it to start counting\nfrom there.\n\n```\ngems = [\"crystal\", \"pearl\", \"diamond\"]\ngems.map_with_index! { |gem, i| \"#{i}: #{gem}\" }\ngems # => [\"0: crystal\", \"1: pearl\", \"2: diamond\"]\n```\n\nRaises if this slice is read-only.","summary":"<p>Like <code><a href=\"Slice.html#map%21%28%26%3AT-%3E_%29%3Aself-instance-method\">#map!</a></code>, but the block gets passed both the element and its index.</p>","abstract":false,"args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(offset = 0, & : T, Int32 -> _) : self","args_html":"(offset = <span class=\"n\">0</span>, & : T, <a href=\"Int32.html\">Int32</a> -> _) : <span class=\"k\">self</span>","location":{"filename":"src/slice.cr","line_number":372,"url":null},"def":{"name":"map_with_index!","args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"yields":2,"block_arg":{"name":"","external_name":"","restriction":"(T, Int32 -> _)"},"return_type":"self","visibility":"Public","body":"check_writable\nsuper(offset) do |elem, i|\n  yield elem, i\nend\n"}},{"html_id":"move_from(source:Pointer(T),count)-instance-method","name":"move_from","abstract":false,"args":[{"name":"source","external_name":"source","restriction":"Pointer(T)"},{"name":"count","external_name":"count","restriction":""}],"args_string":"(source : Pointer(T), count)","args_html":"(source : <a href=\"Pointer.html\">Pointer</a>(T), count)","location":{"filename":"src/slice.cr","line_number":488,"url":null},"def":{"name":"move_from","args":[{"name":"source","external_name":"source","restriction":"Pointer(T)"},{"name":"count","external_name":"count","restriction":""}],"visibility":"Public","body":"check_writable\ncheck_size(count)\n@pointer.move_from(source, count)\n"}},{"html_id":"move_from(source:self)-instance-method","name":"move_from","doc":"Moves the contents of *source* into this slice. *source* and `self` may\noverlap; the copy is always done in a non-destructive manner.\n\nRaises `IndexError` if the destination slice cannot fit the data being transferred.","summary":"<p>Moves the contents of <em>source</em> into this slice.</p>","abstract":false,"args":[{"name":"source","external_name":"source","restriction":"self"}],"args_string":"(source : self)","args_html":"(source : <span class=\"k\">self</span>)","location":{"filename":"src/slice.cr","line_number":526,"url":null},"def":{"name":"move_from","args":[{"name":"source","external_name":"source","restriction":"self"}],"visibility":"Public","body":"source.move_to(self)"}},{"html_id":"move_to(target:Pointer(T),count)-instance-method","name":"move_to","abstract":false,"args":[{"name":"target","external_name":"target","restriction":"Pointer(T)"},{"name":"count","external_name":"count","restriction":""}],"args_string":"(target : Pointer(T), count)","args_html":"(target : <a href=\"Pointer.html\">Pointer</a>(T), count)","location":{"filename":"src/slice.cr","line_number":495,"url":null},"def":{"name":"move_to","args":[{"name":"target","external_name":"target","restriction":"Pointer(T)"},{"name":"count","external_name":"count","restriction":""}],"visibility":"Public","body":"@pointer.move_to(target, count)"}},{"html_id":"move_to(target:self)-instance-method","name":"move_to","doc":"Moves the contents of this slice into *target*. *target* and `self` may\noverlap; the copy is always done in a non-destructive manner.\n\nRaises `IndexError` if the destination slice cannot fit the data being transferred\ne.g. `dest.size < self.size`.\n\n```\nsrc = Slice['a', 'a', 'a']\ndst = Slice['b', 'b', 'b', 'b', 'b']\nsrc.move_to dst\ndst             # => Slice['a', 'a', 'a', 'b', 'b']\ndst.move_to src # raises IndexError\n```\n\nSee also: `Pointer#move_to`.","summary":"<p>Moves the contents of this slice into <em>target</em>.</p>","abstract":false,"args":[{"name":"target","external_name":"target","restriction":"self"}],"args_string":"(target : self)","args_html":"(target : <span class=\"k\">self</span>)","location":{"filename":"src/slice.cr","line_number":514,"url":null},"def":{"name":"move_to","args":[{"name":"target","external_name":"target","restriction":"self"}],"visibility":"Public","body":"target.check_writable\nif target.size < size\n  raise(IndexError.new)\nend\n@pointer.move_to(target.to_unsafe, size)\n"}},{"html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","args_html":"(pp) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/slice.cr","line_number":822,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"return_type":"Nil","visibility":"Public","body":"prefix = T == UInt8 ? \"Bytes[\" : \"Slice[\"\npp.list(prefix, self, \"]\")\n"}},{"html_id":"read_only?:Bool-instance-method","name":"read_only?","doc":"Returns `true` if this slice cannot be written to.","summary":"<p>Returns <code>true</code> if this slice cannot be written to.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":55,"url":null},"def":{"name":"read_only?","return_type":"Bool","visibility":"Public","body":"@read_only"}},{"html_id":"reverse!:self-instance-method","name":"reverse!","doc":"Reverses in-place all the elements of `self`. Returns `self`.\n\nRaises if this slice is read-only.","summary":"<p>Reverses in-place all the elements of <code>self</code>.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":296,"url":null},"def":{"name":"reverse!","return_type":"self","visibility":"Public","body":"check_writable\nsuper()\n"}},{"html_id":"rotate!(n:Int=1):self-instance-method","name":"rotate!","doc":"Shifts all elements of `self` to the left *n* times. Returns `self`.\n\n```\na1 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\na2 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\na3 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\n\na1.rotate!\na2.rotate!(1)\na3.rotate!(3)\n\na1 # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]\na2 # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]\na3 # => [3, 4, 5, 6, 7, 8, 9, 0, 1, 2]\n```\n\nRaises if this slice is read-only.","summary":"<p>Shifts all elements of <code>self</code> to the left <em>n</em> times.</p>","abstract":false,"args":[{"name":"n","default_value":"1","external_name":"n","restriction":"Int"}],"args_string":"(n : Int = 1) : self","args_html":"(n : <a href=\"Int.html\">Int</a> = <span class=\"n\">1</span>) : <span class=\"k\">self</span>","location":{"filename":"src/slice.cr","line_number":312,"url":null},"def":{"name":"rotate!","args":[{"name":"n","default_value":"1","external_name":"n","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"check_writable\nif size == 0\n  return self\nend\nn = n % size\nif n == 0\nelse\n  if n == 1\n    tmp = self[0]\n    @pointer.move_from(@pointer + n, size - n)\n    self[-1] = tmp\n  else\n    if n == (size - 1)\n      tmp = self[-1]\n      ((@pointer + size) - n).move_from(@pointer, n)\n      self[0] = tmp\n    else\n      if n <= SMALL_SLICE_SIZE\n        tmp_buffer = uninitialized ::StaticArray(T, SMALL_SLICE_SIZE)\n        tmp_buffer.to_unsafe.copy_from(@pointer, n)\n        @pointer.move_from(@pointer + n, size - n)\n        ((@pointer + size) - n).copy_from(tmp_buffer.to_unsafe, n)\n      else\n        if (size - n) <= SMALL_SLICE_SIZE\n          tmp_buffer = uninitialized ::StaticArray(T, SMALL_SLICE_SIZE)\n          tmp_buffer.to_unsafe.copy_from(@pointer + n, size - n)\n          ((@pointer + size) - n).move_from(@pointer, n)\n          @pointer.copy_from(tmp_buffer.to_unsafe, size - n)\n        else\n          if n <= (size // 2)\n            tmp = self[...n].dup\n            @pointer.move_from(@pointer + n, size - n)\n            ((@pointer + size) - n).copy_from(tmp.to_unsafe, n)\n          else\n            tmp = self[n..].dup\n            ((@pointer + size) - n).move_from(@pointer, n)\n            @pointer.copy_from(tmp.to_unsafe, size - n)\n          end\n        end\n      end\n    end\n  end\nend\nself\n"}},{"html_id":"shuffle!(random=Random::DEFAULT):self-instance-method","name":"shuffle!","doc":"Modifies `self` by randomizing the order of elements in the collection\nusing the given *random* number generator. Returns `self`.\n\n```\na = [1, 2, 3, 4, 5]\na.shuffle!(Random.new(42)) # => [3, 2, 4, 5, 1]\na                          # => [3, 2, 4, 5, 1]\n```\n\nRaises if this slice is read-only.","summary":"<p>Modifies <code>self</code> by randomizing the order of elements in the collection using the given <em>random</em> number generator.</p>","abstract":false,"args":[{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"args_string":"(random = Random::DEFAULT) : self","args_html":"(random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">DEFAULT</span>) : <span class=\"k\">self</span>","location":{"filename":"src/slice.cr","line_number":304,"url":null},"def":{"name":"shuffle!","args":[{"name":"random","default_value":"Random::DEFAULT","external_name":"random","restriction":""}],"return_type":"self","visibility":"Public","body":"check_writable\nsuper(random)\n"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Returns the size of this slice.\n\n```\nSlice(UInt8).new(3).size # => 3\n```","summary":"<p>Returns the size of this slice.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":52,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"@size"}},{"html_id":"sort:self-instance-method","name":"sort","doc":"Returns a new instance with all elements sorted based on the return value of\ntheir comparison method `T#<=>` (see `Comparable#<=>`), using a stable sort algorithm.\n\n```\na = Slice[3, 1, 2]\na.sort # => Slice[1, 2, 3]\na      # => Slice[3, 1, 2]\n```\n\nSee `#sort!` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two elements returns `nil`.","summary":"<p>Returns a new instance with all elements sorted based on the return value of their comparison method <code>T#<=></code> (see <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">Comparable#<=></a></code>), using a stable sort algorithm.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":856,"url":null},"def":{"name":"sort","return_type":"self","visibility":"Public","body":"dup.sort!"}},{"html_id":"sort(&block:T,T->U):selfforallU-instance-method","name":"sort","doc":"Returns a new instance with all elements sorted based on the comparator in the\ngiven block, using a stable sort algorithm.\n\n```\na = Slice[3, 1, 2]\nb = a.sort { |a, b| b <=> a }\n\nb # => Slice[3, 2, 1]\na # => Slice[3, 1, 2]\n```\n\nSee `Indexable::Mutable#sort!(&block : T, T -> U)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if for any two elements the block returns `nil`.","summary":"<p>Returns a new instance with all elements sorted based on the comparator in the given block, using a stable sort algorithm.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":890,"url":null},"def":{"name":"sort","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> U)"},"return_type":"self","visibility":"Public","body":"{% if U <= ::Union(Int32, ::Nil) %}{% else %}\n      {% raise(\"expected block to return Int32 or Nil, not #{U}\") %}\n    {% end %}\ndup.sort!(&block)\n"}},{"html_id":"sort!:self-instance-method","name":"sort!","doc":"Sorts all elements in `self` based on the return value of the comparison\nmethod `T#<=>` (see `Comparable#<=>`), using a stable sort algorithm.\n\n```\nslice = Slice[3, 1, 2]\nslice.sort!\nslice # => Slice[1, 2, 3]\n```\n\nThis sort operation modifies `self`. See `#sort` for a non-modifying option\nthat allocates a new instance.\n\nThe sort mechanism is implemented as [*merge sort*](https://en.wikipedia.org/wiki/Merge_sort).\nIt is stable, which is typically a good default.\n\nStablility means that two elements which compare equal (i.e. `a <=> b == 0`)\nkeep their original relation. Stable sort guarantees that `[a, b].sort!`\nalways results in `[a, b]` (given they compare equal). With unstable sort,\nthe result could also be `[b, a]`.\n\nIf stability is expendable, `#unstable_sort!` provides a performance\nadvantage over stable sort.\n\nRaises `ArgumentError` if the comparison between any two elements returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the return value of the comparison method <code>T#<=></code> (see <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">Comparable#<=></a></code>), using a stable sort algorithm.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":944,"url":null},"def":{"name":"sort!","return_type":"self","visibility":"Public","body":"Slice.merge_sort!(self)\nself\n"}},{"html_id":"sort!(&block:T,T->U):selfforallU-instance-method","name":"sort!","doc":"Sorts all elements in `self` based on the comparator in the given block, using\na stable sort algorithm.\n\n```\nslice = Slice[3, 1, 2]\n# This is a reverse sort (forward sort would be `a <=> b`)\nslice.sort! { |a, b| b <=> a }\nslice # => Slice[3, 2, 1]\n```\n\nThe block must implement a comparison between two elements *a* and *b*,\nwhere `a < b` outputs a negative value, `a == b` outputs `0`, and `a > b`\noutputs a positive value.\nThe comparison operator (`Comparable#<=>`) can be used for this.\n\nThe block's output type must be `<= Int32?`, but returning an actual `nil`\nvalue is an error.\n\nThis sort operation modifies `self`. See `#sort(&block : T, T -> U)` for a\nnon-modifying option that allocates a new instance.\n\nThe sort mechanism is implemented as [*merge sort*](https://en.wikipedia.org/wiki/Merge_sort).\nIt is stable, which is typically a good default.\n\nStablility means that two elements which compare equal (i.e. `a <=> b == 0`)\nkeep their original relation. Stable sort guarantees that `[a, b].sort!`\nalways results in `[a, b]` (given they compare equal). With unstable sort,\nthe result could also be `[b, a]`.\n\nIf stability is expendable, `#unstable_sort!(&block : T, T -> U)` provides a\nperformance advantage over stable sort.\n\nRaises `ArgumentError` if for any two elements the block returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the comparator in the given block, using a stable sort algorithm.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":1013,"url":null},"def":{"name":"sort!","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> U)"},"return_type":"self","visibility":"Public","body":"{% if U <= ::Union(Int32, ::Nil) %}{% else %}\n      {% raise(\"expected block to return Int32 or Nil, not #{U}\") %}\n    {% end %}\nSlice.merge_sort!(self, block)\nself\n"}},{"html_id":"sort_by(&block:T->_):self-instance-method","name":"sort_by","doc":"Returns a new instance with all elements sorted by the output value of the\nblock. The output values are compared via the comparison method `T#<=>`\n(see `Comparable#<=>`), using a stable sort algorithm.\n\n```\na = Slice[\"apple\", \"pear\", \"fig\"]\nb = a.sort_by { |word| word.size }\nb # => Slice[\"fig\", \"pear\", \"apple\"]\na # => Slice[\"apple\", \"pear\", \"fig\"]\n```\n\nIf stability is expendable, `#unstable_sort_by(&block : T -> _)` provides a\nperformance advantage over stable sort.\n\nSee `Indexable::Mutable#sort_by!(&block : T -> _)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two comparison values returns `nil`.","summary":"<p>Returns a new instance with all elements sorted by the output value of the block.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":1083,"url":null},"def":{"name":"sort_by","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> _)"},"return_type":"self","visibility":"Public","body":"dup.sort_by! do |e|\n  yield(e)\nend"}},{"html_id":"sort_by!(&block:T->_):Slice(T)-instance-method","name":"sort_by!","doc":"Modifies `self` by sorting all elements. The given block is called for\neach element, then the comparison method `<=>` is called on the object\nreturned from the block to determine sort order.\n\n```\na = Slice[\"apple\", \"pear\", \"fig\"]\na.sort_by! { |word| word.size }\na # => Slice[\"fig\", \"pear\", \"apple\"]\n```","summary":"<p>Modifies <code>self</code> by sorting all elements.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":1116,"url":null},"def":{"name":"sort_by!","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> _)"},"return_type":"Slice(T)","visibility":"Public","body":"sorted = map do |e|\n  {e, yield(e)}\nend.sort! do |x, y|\n  x[1] <=> y[1]\nend\nsize.times do |i|\n  to_unsafe[i] = sorted.to_unsafe[i][0]\nend\nself\n"}},{"html_id":"swap(index0:Int,index1:Int):self-instance-method","name":"swap","doc":"Swaps the elements at *index0* and *index1*. Returns `self`.\n\nNegative indices can be used to start counting from the end of the\ncontainer. Raises `IndexError` if either index is out of bounds.\n\n```\na = [\"first\", \"second\", \"third\"]\na.swap(1, 2)  # => [\"first\", \"third\", \"second\"]\na             # => [\"first\", \"third\", \"second\"]\na.swap(0, -1) # => [\"second\", \"third\", \"first\"]\na             # => [\"second\", \"third\", \"first\"]\na.swap(2, 3)  # raises IndexError\n```\n\nRaises if this slice is read-only.","summary":"<p>Swaps the elements at <em>index0</em> and <em>index1</em>.</p>","abstract":false,"args":[{"name":"index0","external_name":"index0","restriction":"Int"},{"name":"index1","external_name":"index1","restriction":"Int"}],"args_string":"(index0 : Int, index1 : Int) : self","args_html":"(index0 : <a href=\"Int.html\">Int</a>, index1 : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/slice.cr","line_number":288,"url":null},"def":{"name":"swap","args":[{"name":"index0","external_name":"index0","restriction":"Int"},{"name":"index1","external_name":"index1","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"check_writable\nsuper(index0, index1)\n"}},{"html_id":"to_a-instance-method","name":"to_a","doc":"Returns an `Array` with all the elements in the collection.\n\n```\n{1, 2, 3}.to_a # => [1, 2, 3]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":827,"url":null},"def":{"name":"to_a","visibility":"Public","body":"Array(T).build(@size) do |pointer|\n  pointer.copy_from(@pointer, @size)\n  @size\nend"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Same as `#inspect(io)`.","summary":"<p>Same as <code><a href=\"Slice.html#inspect%28io%3AIO%29%3ANil-instance-method\">#inspect(io)</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/slice.cr","line_number":809,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"if T == UInt8\n  io << \"Bytes[\"\n  join(io, \", \", &.to_s(io))\n  io << ']'\nelse\n  io << \"Slice[\"\n  join(io, \", \", &.inspect(io))\n  io << ']'\nend"}},{"html_id":"to_slice:self-instance-method","name":"to_slice","abstract":false,"location":{"filename":"src/slice.cr","line_number":805,"url":null},"def":{"name":"to_slice","return_type":"self","visibility":"Public","body":"self"}},{"html_id":"to_unsafe:Pointer(T)-instance-method","name":"to_unsafe","doc":"Returns this slice's pointer.\n\n```\nslice = Slice.new(3, 10)\nslice.to_unsafe[0] # => 10\n```","summary":"<p>Returns this slice's pointer.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":840,"url":null},"def":{"name":"to_unsafe","return_type":"Pointer(T)","visibility":"Public","body":"@pointer"}},{"html_id":"to_unsafe_bytes:Bytes-instance-method","name":"to_unsafe_bytes","doc":"Returns a new `Bytes` pointing at the same contents as `self`.\n\nWARNING: This method is **unsafe**: the returned slice is writable if `self`\nis also writable, and modifications through the returned slice may violate\nthe binary representations of Crystal objects. Additionally, the same\nelements may produce different results depending on the system endianness.\n\n```\n# assume little-endian system\nints = Slice[0x01020304, 0x05060708]\nbytes = ints.to_unsafe_bytes # => Bytes[0x04, 0x03, 0x02, 0x01, 0x08, 0x07, 0x06, 0x05]\nbytes[2] = 0xAD\nints # => Slice[0x01AD0304, 0x05060708]\n```","summary":"<p>Returns a new <code><a href=\"Bytes.html\">Bytes</a></code> pointing at the same contents as <code>self</code>.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":571,"url":null},"def":{"name":"to_unsafe_bytes","return_type":"Bytes","visibility":"Public","body":"unsafe_slice_of(UInt8)"}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder) : Nil","args_html":"(yaml : <a href=\"YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":275,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"{% if T != UInt8 %}\n      {% raise(\"Can only serialize Slice(UInt8), not #{@type}}\") %}\n    {% end %}\nyaml.scalar(Base64.encode(self), tag: \"tag:yaml.org,2002:binary\")\n"}},{"html_id":"unsafe_fetch(index:Int):T-instance-method","name":"unsafe_fetch","doc":"Returns the element at the given *index*, without doing any bounds check.\n\n`Indexable` makes sure to invoke this method with *index* in `0...size`,\nso converting negative indices to positive ones is not needed here.\n\nClients never invoke this method directly. Instead, they access\nelements with `#[](index)` and `#[]?(index)`.\n\nThis method should only be directly invoked if you are absolutely\nsure the index is in bounds, to avoid a bounds check for a small boost\nof performance.","summary":"<p>Returns the element at the given <em>index</em>, without doing any bounds check.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : T","args_html":"(index : <a href=\"Int.html\">Int</a>) : T","location":{"filename":"src/slice.cr","line_number":268,"url":null},"def":{"name":"unsafe_fetch","args":[{"name":"index","external_name":"index","restriction":"Int"}],"return_type":"T","visibility":"Public","body":"@pointer[index]"}},{"html_id":"unsafe_put(index:Int,value:T)-instance-method","name":"unsafe_put","doc":"Sets the element at the given *index* to *value*, without doing any bounds\ncheck.\n\n`Indexable::Mutable` makes sure to invoke this method with *index* in\n`0...size`, so converting negative indices to positive ones is not needed\nhere.\n\nClients never invoke this method directly. Instead, they modify elements\nwith `#[]=(index, value)`.\n\nThis method should only be directly invoked if you are absolutely\nsure the index is in bounds, to avoid a bounds check for a small boost\nof performance.","summary":"<p>Sets the element at the given <em>index</em> to <em>value</em>, without doing any bounds check.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(index : Int, value : T)","args_html":"(index : <a href=\"Int.html\">Int</a>, value : T)","location":{"filename":"src/slice.cr","line_number":273,"url":null},"def":{"name":"unsafe_put","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"@pointer[index] = value"}},{"html_id":"unsafe_slice_of(type:U.class):Slice(U)forallU-instance-method","name":"unsafe_slice_of","doc":"Returns a new `Slice` pointing at the same contents as `self`, but\nreinterpreted as elements of the given *type*.\n\nThe returned slice never refers to more memory than `self`; if the last\nbytes of `self` do not fit into a `U`, they are excluded from the returned\nslice.\n\nWARNING: This method is **unsafe**: elements are reinterpreted using\n`#unsafe_as`, and the resulting slice may not be properly aligned.\nAdditionally, the same elements may produce different results depending on\nthe system endianness.\n\n```\n# assume little-endian system\nbytes = Bytes[0x01, 0x02, 0x03, 0x04, 0xFF, 0xFE]\nbytes.unsafe_slice_of(Int8)  # => Slice[1_i8, 2_i8, 3_i8, 4_i8, -1_i8, -2_i8]\nbytes.unsafe_slice_of(Int16) # => Slice[513_i16, 1027_i16, -257_i16]\nbytes.unsafe_slice_of(Int32) # => Slice[0x04030201]\n```","summary":"<p>Returns a new <code><a href=\"Slice.html\">Slice</a></code> pointing at the same contents as <code>self</code>, but reinterpreted as elements of the given <em>type</em>.</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":"U.class"}],"args_string":"(type : U.class) : Slice(U) forall U","args_html":"(type : <span class=\"t\">U</span>.<span class=\"k\">class</span>) : <a href=\"Slice.html\">Slice</a>(U) forall U","location":{"filename":"src/slice.cr","line_number":553,"url":null},"def":{"name":"unsafe_slice_of","args":[{"name":"type","external_name":"type","restriction":"U.class"}],"return_type":"Slice(U)","visibility":"Public","body":"Slice.new(to_unsafe.unsafe_as(Pointer(U)), bytesize // (sizeof(U)), read_only: @read_only)"}},{"html_id":"unstable_sort:self-instance-method","name":"unstable_sort","doc":"Returns a new instance with all elements sorted based on the return value of\ntheir comparison method `T#<=>` (see `Comparable#<=>`), using an unstable sort algorithm.\n\n```\na = Slice[3, 1, 2]\na.unstable_sort # => Slice[1, 2, 3]\na               # => Slice[3, 1, 2]\n```\n\nSee `Indexable::Mutable#unstable_sort!` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two elements returns `nil`.","summary":"<p>Returns a new instance with all elements sorted based on the return value of their comparison method <code>T#<=></code> (see <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">Comparable#<=></a></code>), using an unstable sort algorithm.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":872,"url":null},"def":{"name":"unstable_sort","return_type":"self","visibility":"Public","body":"dup.unstable_sort!"}},{"html_id":"unstable_sort(&block:T,T->U):selfforallU-instance-method","name":"unstable_sort","doc":"Returns a new instance with all elements sorted based on the comparator in the\ngiven block, using an unstable sort algorithm.\n\n```\na = Slice[3, 1, 2]\nb = a.unstable_sort { |a, b| b <=> a }\n\nb # => Slice[3, 2, 1]\na # => Slice[3, 1, 2]\n```\n\nSee `Indexable::Mutable#unstable_sort!(&block : T, T -> U)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if for any two elements the block returns `nil`.","summary":"<p>Returns a new instance with all elements sorted based on the comparator in the given block, using an unstable sort algorithm.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":912,"url":null},"def":{"name":"unstable_sort","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> U)"},"return_type":"self","visibility":"Public","body":"{% if U <= ::Union(Int32, ::Nil) %}{% else %}\n      {% raise(\"expected block to return Int32 or Nil, not #{U}\") %}\n    {% end %}\ndup.unstable_sort!(&block)\n"}},{"html_id":"unstable_sort!:self-instance-method","name":"unstable_sort!","doc":"Sorts all elements in `self` based on the return value of the comparison\nmethod `T#<=>` (see `Comparable#<=>`), using an unstable sort algorithm..\n\n```\nslice = Slice[3, 1, 2]\nslice.unstable_sort!\nslice # => Slice[1, 2, 3]\n```\n\nThis sort operation modifies `self`. See `#unstable_sort` for a non-modifying\noption that allocates a new instance.\n\nThe sort mechanism is implemented as [*introsort*](https://en.wikipedia.org/wiki/Introsort).\nIt does not guarantee stability between equally comparing elements.\nThis offers higher performance but may be unexpected in some situations.\n\nStablility means that two elements which compare equal (i.e. `a <=> b == 0`)\nkeep their original relation. Stable sort guarantees that `[a, b].sort!`\nalways results in `[a, b]` (given they compare equal). With unstable sort,\nthe result could also be `[b, a]`.\n\nIf stability is necessary, use  `#sort!` instead.\n\nRaises `ArgumentError` if the comparison between any two elements returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the return value of the comparison method <code>T#<=></code> (see <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">Comparable#<=></a></code>), using an unstable sort algorithm..</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":974,"url":null},"def":{"name":"unstable_sort!","return_type":"self","visibility":"Public","body":"Slice.intro_sort!(to_unsafe, size)\nself\n"}},{"html_id":"unstable_sort!(&block:T,T->U):selfforallU-instance-method","name":"unstable_sort!","doc":"Sorts all elements in `self` based on the comparator in the given block,\nusing an unstable sort algorithm.\n\n```\nslice = Slice[3, 1, 2]\n# This is a reverse sort (forward sort would be `a <=> b`)\nslice.unstable_sort! { |a, b| b <=> a }\nslice # => Slice[3, 2, 1]\n```\n\nThe block must implement a comparison between two elements *a* and *b*,\nwhere `a < b` outputs a negative value, `a == b` outputs `0`, and `a > b`\noutputs a positive value.\nThe comparison operator (`Comparable#<=>`) can be used for this.\n\nThe block's output type must be `<= Int32?`, but returning an actual `nil`\nvalue is an error.\n\nThis sort operation modifies `self`. See `#unstable_sort(&block : T, T -> U)`\nfor a non-modifying option that allocates a new instance.\n\nThe sort mechanism is implemented as [*introsort*](https://en.wikipedia.org/wiki/Introsort).\nIt does not guarantee stability between equally comparing elements.\nThis offers higher performance but may be unexpected in some situations.\n\nStablility means that two elements which compare equal (i.e. `a <=> b == 0`)\nkeep their original relation. Stable sort guarantees that `[a, b].sort!`\nalways results in `[a, b]` (given they compare equal). With unstable sort,\nthe result could also be `[b, a]`.\n\nIf stability is necessary, use  `#sort!(&block : T, T -> U)` instead.\n\nRaises `ArgumentError` if for any two elements the block returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the comparator in the given block, using an unstable sort algorithm.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":1056,"url":null},"def":{"name":"unstable_sort!","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> U)"},"return_type":"self","visibility":"Public","body":"{% if U <= ::Union(Int32, ::Nil) %}{% else %}\n      {% raise(\"expected block to return Int32 or Nil, not #{U}\") %}\n    {% end %}\nSlice.intro_sort!(to_unsafe, size, block)\nself\n"}},{"html_id":"unstable_sort_by(&block:T->_):self-instance-method","name":"unstable_sort_by","doc":"Returns a new instance with all elements sorted by the output value of the\nblock. The output values are compared via the comparison method `#<=>`\n(see `Comparable#<=>`), using an unstable sort algorithm.\n\n```\na = Slice[\"apple\", \"pear\", \"fig\"]\nb = a.unstable_sort_by { |word| word.size }\nb # => Slice[\"fig\", \"pear\", \"apple\"]\na # => Slice[\"apple\", \"pear\", \"fig\"]\n```\n\nIf stability is necessary, use `#sort_by(&block : T -> _)` instead.\n\nSee `Indexable::Mutable#unstable_sort!(&block : T -> _)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two comparison values returns `nil`.","summary":"<p>Returns a new instance with all elements sorted by the output value of the block.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":1103,"url":null},"def":{"name":"unstable_sort_by","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> _)"},"return_type":"self","visibility":"Public","body":"dup.unstable_sort_by! do |e|\n  yield(e)\nend"}},{"html_id":"unstable_sort_by!(&block:T->_):Slice(T)-instance-method","name":"unstable_sort_by!","doc":"Modifies `self` by sorting all elements. The given block is called for\neach element, then the comparison method `<=>` is called on the object\nreturned from the block to determine sort order.\n\n```\na = Slice[\"apple\", \"pear\", \"fig\"]\na.sort_by! { |word| word.size }\na # => Slice[\"fig\", \"pear\", \"apple\"]\n```\n\nThis method does not guarantee stability between equally sorting elements.\nWhich results in a performance advantage over stable sort.","summary":"<p>Modifies <code>self</code> by sorting all elements.</p>","abstract":false,"location":{"filename":"src/slice.cr","line_number":1128,"url":null},"def":{"name":"unstable_sort_by!","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> _)"},"return_type":"Slice(T)","visibility":"Public","body":"sorted = map do |e|\n  {e, yield(e)}\nend.unstable_sort! do |x, y|\n  x[1] <=> y[1]\nend\nsize.times do |i|\n  to_unsafe[i] = sorted.to_unsafe[i][0]\nend\nself\n"}},{"html_id":"update(index:Int,&:T->_):T-instance-method","name":"update","doc":"Yields the current element at the given *index* and updates the value\nat that *index* with the block's value. Returns the new value.\n\nRaises `IndexError` if trying to set an element outside the container's\nrange.\n\n```\narray = [1, 2, 3]\narray.update(1) { |x| x * 2 } # => 4\narray                         # => [1, 4, 3]\narray.update(5) { |x| x * 2 } # raises IndexError\n```\n\nRaises if this slice is read-only.","summary":"<p>Yields the current element at the given <em>index</em> and updates the value at that <em>index</em> with the block's value.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int, & : T -> _) : T","args_html":"(index : <a href=\"Int.html\">Int</a>, & : T -> _) : T","location":{"filename":"src/slice.cr","line_number":280,"url":null},"def":{"name":"update","args":[{"name":"index","external_name":"index","restriction":"Int"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(T -> _)"},"return_type":"T","visibility":"Public","body":"check_writable\nsuper(index) do |elem|\n  yield elem\nend\n"}}],"macros":[{"html_id":"[](*args,read_only=false)-macro","name":"[]","doc":"Creates a new `Slice` with the given *args*. The type of the\nslice will be the union of the type of the given *args*.\n\nThe slice is allocated on the heap.\n\n```\nslice = Slice[1, 'a']\nslice[0]    # => 1\nslice[1]    # => 'a'\nslice.class # => Slice(Char | Int32)\n```\n\nIf `T` is a `Number` then this is equivalent to\n`Number.slice` (numbers will be coerced to the type `T`)\n\nSee also: `Number.slice`.","summary":"<p>Creates a new <code><a href=\"Slice.html\">Slice</a></code> with the given <em>args</em>.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"args_string":"(*args, read_only = false)","args_html":"(*args, read_only = <span class=\"n\">false</span>)","location":{"filename":"src/slice.cr","line_number":33,"url":null},"def":{"name":"[]","args":[{"name":"args","external_name":"args","restriction":""},{"name":"read_only","default_value":"false","external_name":"read_only","restriction":""}],"splat_index":0,"visibility":"Public","body":"    \n# TODO: there should be a better way to check this, probably\n\n    \n# asking if @type was instantiated or if T is defined\n\n    \n{% if (@type.name != \"Slice(T)\") && T < Number %}\n      {{ T }}.slice({{ *args }}, read_only: {{ read_only }})\n    {% else %}\n      %ptr = Pointer(typeof({{ *args }})).malloc({{ args.size }})\n      {% for arg, i in args %}\n        %ptr[{{ i }}] = {{ arg }}\n      {% end %}\n      Slice.new(%ptr, {{ args.size }}, read_only: {{ read_only }})\n    {% end %}\n\n  \n"}}]},{"html_id":"Crystal/Socket","path":"Socket.html","kind":"class","full_name":"Socket","name":"Socket","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/Crystal/System/Socket","kind":"module","full_name":"Crystal::System::Socket","name":"Socket"},{"html_id":"Crystal/IO/Evented","kind":"module","full_name":"IO::Evented","name":"Evented"},{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket.cr","line_number":3,"url":null},{"filename":"src/socket/address.cr","line_number":4,"url":null},{"filename":"src/socket/addrinfo.cr","line_number":4,"url":null},{"filename":"src/socket/common.cr","line_number":10,"url":null},{"filename":"src/socket/server.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Crystal/System/Socket","kind":"module","full_name":"Crystal::System::Socket","name":"Socket"},{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"}],"subclasses":[{"html_id":"Crystal/IPSocket","kind":"class","full_name":"IPSocket","name":"IPSocket"},{"html_id":"Crystal/UNIXSocket","kind":"class","full_name":"UNIXSocket","name":"UNIXSocket"}],"class_methods":[{"html_id":"fcntl(fd,cmd,arg=0)-class-method","name":"fcntl","abstract":false,"args":[{"name":"fd","external_name":"fd","restriction":""},{"name":"cmd","external_name":"cmd","restriction":""},{"name":"arg","default_value":"0","external_name":"arg","restriction":""}],"args_string":"(fd, cmd, arg = 0)","args_html":"(fd, cmd, arg = <span class=\"n\">0</span>)","location":{"filename":"src/socket.cr","line_number":375,"url":null},"def":{"name":"fcntl","args":[{"name":"fd","external_name":"fd","restriction":""},{"name":"cmd","external_name":"cmd","restriction":""},{"name":"arg","default_value":"0","external_name":"arg","restriction":""}],"visibility":"Public","body":"Crystal::System::Socket.fcntl(fd, cmd, arg)"}},{"html_id":"ip?(string:String)-class-method","name":"ip?","doc":"Returns `true` if the string represents a valid IPv4 or IPv6 address.","summary":"<p>Returns <code>true</code> if the string represents a valid IPv4 or IPv6 address.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String)","args_html":"(string : <a href=\"String.html\">String</a>)","location":{"filename":"src/socket/address.cr","line_number":407,"url":null},"def":{"name":"ip?","args":[{"name":"string","external_name":"string","restriction":"String"}],"visibility":"Public","body":"addr = LibC::In6Addr.new\nptr = (pointerof(addr)).as(::Pointer(Void))\n(LibC.inet_pton(LibC::AF_INET, string, ptr)) > 0 || (LibC.inet_pton(LibC::AF_INET6, string, ptr)) > 0\n"}},{"html_id":"udp(family:Family,blocking=false)-class-method","name":"udp","doc":"Creates an UDP socket. Consider using `UDPSocket` unless you need full\ncontrol over the socket.","summary":"<p>Creates an UDP socket.</p>","abstract":false,"args":[{"name":"family","external_name":"family","restriction":"Family"},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"args_string":"(family : Family, blocking = false)","args_html":"(family : <a href=\"Socket/Family.html\">Family</a>, blocking = <span class=\"n\">false</span>)","location":{"filename":"src/socket.cr","line_number":34,"url":null},"def":{"name":"udp","args":[{"name":"family","external_name":"family","restriction":"Family"},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"visibility":"Public","body":"new(family, Type::DGRAM, Protocol::UDP, blocking)"}}],"constructors":[{"html_id":"new(family:Family,type:Type,protocol:Protocol=Protocol::IP,blocking=false)-class-method","name":"new","abstract":false,"args":[{"name":"family","external_name":"family","restriction":"Family"},{"name":"type","external_name":"type","restriction":"Type"},{"name":"protocol","default_value":"Protocol::IP","external_name":"protocol","restriction":"Protocol"},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"args_string":"(family : Family, type : Type, protocol : Protocol = Protocol::IP, blocking = false)","args_html":"(family : <a href=\"Socket/Family.html\">Family</a>, type : <a href=\"Socket/Type.html\">Type</a>, protocol : <a href=\"Socket/Protocol.html\">Protocol</a> = <span class=\"t\">Protocol</span><span class=\"t\">::</span><span class=\"t\">IP</span>, blocking = <span class=\"n\">false</span>)","location":{"filename":"src/socket.cr","line_number":44,"url":null},"def":{"name":"new","args":[{"name":"family","external_name":"family","restriction":"Family"},{"name":"type","external_name":"type","restriction":"Type"},{"name":"protocol","default_value":"Protocol::IP","external_name":"protocol","restriction":"Protocol"},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(family, type, protocol, blocking)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(fd,family:Family,type:Type,protocol:Protocol=Protocol::IP,blocking=false)-class-method","name":"new","doc":"Creates a Socket from an existing socket file descriptor / handle.","summary":"<p>Creates a Socket from an existing socket file descriptor / handle.</p>","abstract":false,"args":[{"name":"fd","external_name":"fd","restriction":""},{"name":"family","external_name":"family","restriction":"Family"},{"name":"type","external_name":"type","restriction":"Type"},{"name":"protocol","default_value":"Protocol::IP","external_name":"protocol","restriction":"Protocol"},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"args_string":"(fd, family : Family, type : Type, protocol : Protocol = Protocol::IP, blocking = false)","args_html":"(fd, family : <a href=\"Socket/Family.html\">Family</a>, type : <a href=\"Socket/Type.html\">Type</a>, protocol : <a href=\"Socket/Protocol.html\">Protocol</a> = <span class=\"t\">Protocol</span><span class=\"t\">::</span><span class=\"t\">IP</span>, blocking = <span class=\"n\">false</span>)","location":{"filename":"src/socket.cr","line_number":53,"url":null},"def":{"name":"new","args":[{"name":"fd","external_name":"fd","restriction":""},{"name":"family","external_name":"family","restriction":"Family"},{"name":"type","external_name":"type","restriction":"Type"},{"name":"protocol","default_value":"Protocol::IP","external_name":"protocol","restriction":"Protocol"},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(fd, family, type, protocol, blocking)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"tcp(family:Family,blocking=false):self-class-method","name":"tcp","doc":"Creates a TCP socket. Consider using `TCPSocket` or `TCPServer` unless you\nneed full control over the socket.","summary":"<p>Creates a TCP socket.</p>","abstract":false,"args":[{"name":"family","external_name":"family","restriction":"Family"},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"args_string":"(family : Family, blocking = false) : self","args_html":"(family : <a href=\"Socket/Family.html\">Family</a>, blocking = <span class=\"n\">false</span>) : <span class=\"k\">self</span>","location":{"filename":"src/socket.cr","line_number":28,"url":null},"def":{"name":"tcp","args":[{"name":"family","external_name":"family","restriction":"Family"},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"return_type":"self","visibility":"Public","body":"new(family, Type::STREAM, Protocol::TCP, blocking)"}},{"html_id":"unix(type:Type=Type::STREAM,blocking=false):self-class-method","name":"unix","doc":"Creates an UNIX socket. Consider using `UNIXSocket` or `UNIXServer` unless\nyou need full control over the socket.","summary":"<p>Creates an UNIX socket.</p>","abstract":false,"args":[{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"args_string":"(type : Type = Type::STREAM, blocking = false) : self","args_html":"(type : <a href=\"Socket/Type.html\">Type</a> = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>, blocking = <span class=\"n\">false</span>) : <span class=\"k\">self</span>","location":{"filename":"src/socket.cr","line_number":40,"url":null},"def":{"name":"unix","args":[{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"return_type":"self","visibility":"Public","body":"new(Family::UNIX, type, blocking: blocking)"}}],"instance_methods":[{"html_id":"accept:Socket-instance-method","name":"accept","doc":"Accepts an incoming connection.\n\nReturns the client socket. Raises an `IO::Error` (closed stream) exception\nif the server is closed after invoking this method.\n\n```\nrequire \"socket\"\n\nserver = TCPServer.new(2202)\nsocket = server.accept\nsocket.puts Time.utc\nsocket.close\n```","summary":"<p>Accepts an incoming connection.</p>","abstract":false,"location":{"filename":"src/socket.cr","line_number":160,"url":null},"def":{"name":"accept","return_type":"Socket","visibility":"Public","body":"accept? || (raise(Socket::Error.new(\"Closed stream\")))"}},{"html_id":"accept?:Socket?-instance-method","name":"accept?","doc":"Accepts an incoming connection.\n\nReturns the client `Socket` or `nil` if the server is closed after invoking\nthis method.\n\n```\nrequire \"socket\"\n\nserver = TCPServer.new(2202)\nif socket = server.accept?\n  socket.puts Time.utc\n  socket.close\nend\n```","summary":"<p>Accepts an incoming connection.</p>","abstract":false,"location":{"filename":"src/socket.cr","line_number":178,"url":null},"def":{"name":"accept?","return_type":"Socket | ::Nil","visibility":"Public","body":"if client_fd = system_accept\n  sock = Socket.new(client_fd, family, type, protocol, blocking)\n  sock.sync = sync?\n  sock\nend"}},{"html_id":"bind(host:String,port:Int):Nil-instance-method","name":"bind","doc":"Binds the socket to a local address.\n\n```\nrequire \"socket\"\n\nsock = Socket.tcp(Socket::Family::INET)\nsock.bind \"localhost\", 1234\n```","summary":"<p>Binds the socket to a local address.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int"}],"args_string":"(host : String, port : Int) : Nil","args_html":"(host : <a href=\"String.html\">String</a>, port : <a href=\"Int.html\">Int</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/socket.cr","line_number":104,"url":null},"def":{"name":"bind","args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int"}],"return_type":"Nil","visibility":"Public","body":"Addrinfo.resolve(host, port, @family, @type, @protocol) do |addrinfo|\n  system_bind(addrinfo, \"#{host}:#{port}\") do |errno|\n    errno\n  end\nend"}},{"html_id":"bind(port:Int)-instance-method","name":"bind","doc":"Binds the socket on *port* to all local interfaces.\n\n```\nrequire \"socket\"\n\nsock = Socket.tcp(Socket::Family::INET6)\nsock.bind 1234\n```","summary":"<p>Binds the socket on <em>port</em> to all local interfaces.</p>","abstract":false,"args":[{"name":"port","external_name":"port","restriction":"Int"}],"args_string":"(port : Int)","args_html":"(port : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/socket.cr","line_number":118,"url":null},"def":{"name":"bind","args":[{"name":"port","external_name":"port","restriction":"Int"}],"visibility":"Public","body":"Addrinfo.resolve(\"::\", port, @family, @type, @protocol) do |addrinfo|\n  system_bind(addrinfo, \"::#{port}\") do |errno|\n    errno\n  end\nend"}},{"html_id":"bind(addr:Socket::Address):Nil-instance-method","name":"bind","doc":"Binds the socket to a local address.\n\n```\nrequire \"socket\"\n\nsock = Socket.udp(Socket::Family::INET)\nsock.bind Socket::IPAddress.new(\"192.168.1.25\", 80)\n```","summary":"<p>Binds the socket to a local address.</p>","abstract":false,"args":[{"name":"addr","external_name":"addr","restriction":"Socket::Address"}],"args_string":"(addr : Socket::Address) : Nil","args_html":"(addr : <a href=\"Socket/Address.html\">Socket::Address</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/socket.cr","line_number":132,"url":null},"def":{"name":"bind","args":[{"name":"addr","external_name":"addr","restriction":"Socket::Address"}],"return_type":"Nil","visibility":"Public","body":"system_bind(addr, addr.to_s) do |errno|\n  raise(errno)\nend"}},{"html_id":"blocking-instance-method","name":"blocking","abstract":false,"location":{"filename":"src/socket.cr","line_number":359,"url":null},"def":{"name":"blocking","visibility":"Public","body":"system_blocking?"}},{"html_id":"blocking=(value)-instance-method","name":"blocking=","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/socket.cr","line_number":363,"url":null},"def":{"name":"blocking=","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"self.system_blocking = value"}},{"html_id":"broadcast=(val:Bool)-instance-method","name":"broadcast=","abstract":false,"args":[{"name":"val","external_name":"val","restriction":"Bool"}],"args_string":"(val : Bool)","args_html":"(val : <a href=\"Bool.html\">Bool</a>)","location":{"filename":"src/socket.cr","line_number":305,"url":null},"def":{"name":"broadcast=","args":[{"name":"val","external_name":"val","restriction":"Bool"}],"visibility":"Public","body":"setsockopt_bool(LibC::SO_BROADCAST, val)"}},{"html_id":"broadcast?:Bool-instance-method","name":"broadcast?","abstract":false,"location":{"filename":"src/socket.cr","line_number":301,"url":null},"def":{"name":"broadcast?","return_type":"Bool","visibility":"Public","body":"getsockopt_bool(LibC::SO_BROADCAST)"}},{"html_id":"close_on_exec=(arg:Bool)-instance-method","name":"close_on_exec=","abstract":false,"args":[{"name":"arg","external_name":"arg","restriction":"Bool"}],"args_string":"(arg : Bool)","args_html":"(arg : <a href=\"Bool.html\">Bool</a>)","location":{"filename":"src/socket.cr","line_number":371,"url":null},"def":{"name":"close_on_exec=","args":[{"name":"arg","external_name":"arg","restriction":"Bool"}],"visibility":"Public","body":"system_close_on_exec = arg"}},{"html_id":"close_on_exec?-instance-method","name":"close_on_exec?","abstract":false,"location":{"filename":"src/socket.cr","line_number":367,"url":null},"def":{"name":"close_on_exec?","visibility":"Public","body":"system_close_on_exec?"}},{"html_id":"close_read-instance-method","name":"close_read","doc":"Calls `shutdown(2)` with `SHUT_RD`","summary":"<p>Calls <code>shutdown(2)</code> with <code>SHUT_RD</code></p>","abstract":false,"location":{"filename":"src/socket.cr","line_number":254,"url":null},"def":{"name":"close_read","visibility":"Public","body":"system_close_read"}},{"html_id":"close_write-instance-method","name":"close_write","doc":"Calls `shutdown(2)` with `SHUT_WR`","summary":"<p>Calls <code>shutdown(2)</code> with <code>SHUT_WR</code></p>","abstract":false,"location":{"filename":"src/socket.cr","line_number":259,"url":null},"def":{"name":"close_write","visibility":"Public","body":"system_close_write"}},{"html_id":"closed?:Bool-instance-method","name":"closed?","doc":"Returns `true` if this `IO` is closed.\n\n`IO` defines returns `false`, but including types may override.","summary":"<p>Returns <code>true</code> if this <code><a href=\"IO.html\">IO</a></code> is closed.</p>","abstract":false,"location":{"filename":"src/socket.cr","line_number":389,"url":null},"def":{"name":"closed?","return_type":"Bool","visibility":"Public","body":"@closed"}},{"html_id":"connect(host:String,port:Int,connect_timeout=nil):Nil-instance-method","name":"connect","doc":"Connects the socket to a remote host:port.\n\n```\nrequire \"socket\"\n\nsock = Socket.tcp(Socket::Family::INET)\nsock.connect \"crystal-lang.org\", 80\n```","summary":"<p>Connects the socket to a remote host:port.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int"},{"name":"connect_timeout","default_value":"nil","external_name":"connect_timeout","restriction":""}],"args_string":"(host : String, port : Int, connect_timeout = nil) : Nil","args_html":"(host : <a href=\"String.html\">String</a>, port : <a href=\"Int.html\">Int</a>, connect_timeout = <span class=\"n\">nil</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/socket.cr","line_number":72,"url":null},"def":{"name":"connect","args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int"},{"name":"connect_timeout","default_value":"nil","external_name":"connect_timeout","restriction":""}],"return_type":"Nil","visibility":"Public","body":"Addrinfo.resolve(host, port, @family, @type, @protocol) do |addrinfo|\n  connect(addrinfo, timeout: connect_timeout) do |error|\n    error\n  end\nend"}},{"html_id":"connect(addr,timeout=nil):Nil-instance-method","name":"connect","doc":"Connects the socket to a remote address. Raises if the connection failed.\n\n```\nrequire \"socket\"\n\nsock = Socket.unix\nsock.connect Socket::UNIXAddress.new(\"/tmp/service.sock\")\n```","summary":"<p>Connects the socket to a remote address.</p>","abstract":false,"args":[{"name":"addr","external_name":"addr","restriction":""},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(addr, timeout = nil) : Nil","args_html":"(addr, timeout = <span class=\"n\">nil</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/socket.cr","line_number":86,"url":null},"def":{"name":"connect","args":[{"name":"addr","external_name":"addr","restriction":""},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"return_type":"Nil","visibility":"Public","body":"connect(addr, timeout) do |error|\n  raise(error)\nend"}},{"html_id":"connect(addr,timeout=nil,&)-instance-method","name":"connect","doc":"Tries to connect to a remote address. Yields an `IO::TimeoutError` or an\n`Socket::ConnectError` error if the connection failed.","summary":"<p>Tries to connect to a remote address.</p>","abstract":false,"args":[{"name":"addr","external_name":"addr","restriction":""},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(addr, timeout = nil, &)","args_html":"(addr, timeout = <span class=\"n\">nil</span>, &)","location":{"filename":"src/socket.cr","line_number":92,"url":null},"def":{"name":"connect","args":[{"name":"addr","external_name":"addr","restriction":""},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"yields":1,"visibility":"Public","body":"system_connect(addr, timeout) do |error|\n  yield error\nend"}},{"html_id":"family:Family-instance-method","name":"family","abstract":false,"location":{"filename":"src/socket.cr","line_number":22,"url":null},"def":{"name":"family","return_type":"Family","visibility":"Public","body":"@family"}},{"html_id":"fcntl(cmd,arg=0)-instance-method","name":"fcntl","abstract":false,"args":[{"name":"cmd","external_name":"cmd","restriction":""},{"name":"arg","default_value":"0","external_name":"arg","restriction":""}],"args_string":"(cmd, arg = 0)","args_html":"(cmd, arg = <span class=\"n\">0</span>)","location":{"filename":"src/socket.cr","line_number":379,"url":null},"def":{"name":"fcntl","args":[{"name":"cmd","external_name":"cmd","restriction":""},{"name":"arg","default_value":"0","external_name":"arg","restriction":""}],"visibility":"Public","body":"self.class.fcntl(fd, cmd, arg)"}},{"html_id":"fd-instance-method","name":"fd","doc":"Returns the handle associated with this socket from the operating system.\n\n* on POSIX platforms, this is a file descriptor (`Int32`)\n* on Windows, this is a SOCKET handle (`LibC::SOCKET`)","summary":"<p>Returns the handle associated with this socket from the operating system.</p>","abstract":false,"location":{"filename":"src/socket.cr","line_number":16,"url":null},"def":{"name":"fd","visibility":"Public","body":"@volatile_fd.get"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/socket.cr","line_number":383,"url":null},"def":{"name":"finalize","visibility":"Public","body":"if closed?\n  return\nend\nbegin\n  close\nrescue\n  nil\nend\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/socket.cr","line_number":263,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"#<#{self.class}:fd #{fd}>\""}},{"html_id":"keepalive=(val:Bool)-instance-method","name":"keepalive=","abstract":false,"args":[{"name":"val","external_name":"val","restriction":"Bool"}],"args_string":"(val : Bool)","args_html":"(val : <a href=\"Bool.html\">Bool</a>)","location":{"filename":"src/socket.cr","line_number":313,"url":null},"def":{"name":"keepalive=","args":[{"name":"val","external_name":"val","restriction":"Bool"}],"visibility":"Public","body":"setsockopt_bool(LibC::SO_KEEPALIVE, val)"}},{"html_id":"keepalive?-instance-method","name":"keepalive?","abstract":false,"location":{"filename":"src/socket.cr","line_number":309,"url":null},"def":{"name":"keepalive?","visibility":"Public","body":"getsockopt_bool(LibC::SO_KEEPALIVE)"}},{"html_id":"linger-instance-method","name":"linger","abstract":false,"location":{"filename":"src/socket.cr","line_number":317,"url":null},"def":{"name":"linger","visibility":"Public","body":"system_linger"}},{"html_id":"linger=(val:Int?)-instance-method","name":"linger=","doc":"WARNING: The behavior of `SO_LINGER` is platform specific.\nBad things may happen especially with nonblocking sockets.\nSee [Cross-Platform Testing of SO_LINGER by Nybek](https://www.nybek.com/blog/2015/04/29/so_linger-on-non-blocking-sockets/)\nfor more information.\n\n* `nil`: disable `SO_LINGER`\n* `Int`: enable `SO_LINGER` and set timeout to `Int` seconds\n  * `0`: abort on close (socket buffer is discarded and RST sent to peer). Depends on platform and whether `shutdown()` was called first.\n  * `>=1`: abort after `Int` seconds on close. Linux and Cygwin may block on close.","summary":"<p><span class=\"flag yellow\">WARNING</span>  The behavior of <code>SO_LINGER</code> is platform specific.</p>","abstract":false,"args":[{"name":"val","external_name":"val","restriction":"Int | ::Nil"}],"args_string":"(val : Int?)","args_html":"(val : <a href=\"Int.html\">Int</a>?)","location":{"filename":"src/socket.cr","line_number":330,"url":null},"def":{"name":"linger=","args":[{"name":"val","external_name":"val","restriction":"Int | ::Nil"}],"visibility":"Public","body":"self.system_linger = val"}},{"html_id":"listen(backlog:Int=SOMAXCONN):Nil-instance-method","name":"listen","doc":"Tells the previously bound socket to listen for incoming connections.","summary":"<p>Tells the previously bound socket to listen for incoming connections.</p>","abstract":false,"args":[{"name":"backlog","default_value":"SOMAXCONN","external_name":"backlog","restriction":"Int"}],"args_string":"(backlog : Int = SOMAXCONN) : Nil","args_html":"(backlog : <a href=\"Int.html\">Int</a> = <span class=\"t\">SOMAXCONN</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/socket.cr","line_number":137,"url":null},"def":{"name":"listen","args":[{"name":"backlog","default_value":"SOMAXCONN","external_name":"backlog","restriction":"Int"}],"return_type":"Nil","visibility":"Public","body":"listen(backlog) do |errno|\n  raise(errno)\nend"}},{"html_id":"listen(backlog:Int=SOMAXCONN,&)-instance-method","name":"listen","doc":"Tries to listen for connections on the previously bound socket.\nYields an `Socket::Error` on failure.","summary":"<p>Tries to listen for connections on the previously bound socket.</p>","abstract":false,"args":[{"name":"backlog","default_value":"SOMAXCONN","external_name":"backlog","restriction":"Int"}],"args_string":"(backlog : Int = SOMAXCONN, &)","args_html":"(backlog : <a href=\"Int.html\">Int</a> = <span class=\"t\">SOMAXCONN</span>, &)","location":{"filename":"src/socket.cr","line_number":143,"url":null},"def":{"name":"listen","args":[{"name":"backlog","default_value":"SOMAXCONN","external_name":"backlog","restriction":"Int"}],"yields":1,"visibility":"Public","body":"system_listen(backlog) do |err|\n  yield err\nend"}},{"html_id":"protocol:Protocol-instance-method","name":"protocol","abstract":false,"location":{"filename":"src/socket.cr","line_number":24,"url":null},"def":{"name":"protocol","return_type":"Protocol","visibility":"Public","body":"@protocol"}},{"html_id":"receive(message:Bytes):Tuple(Int32,Address)-instance-method","name":"receive","doc":"Receives a binary message from the previously bound address.\n\n```\nrequire \"socket\"\n\nserver = Socket.udp(Socket::Family::INET)\nserver.bind(\"localhost\", 1234)\n\nmessage = Bytes.new(32)\nbytes_read, client_addr = server.receive(message)\n```","summary":"<p>Receives a binary message from the previously bound address.</p>","abstract":false,"args":[{"name":"message","external_name":"message","restriction":"Bytes"}],"args_string":"(message : Bytes) : Tuple(Int32, Address)","args_html":"(message : <a href=\"Bytes.html\">Bytes</a>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"Int32.html\">Int32</a>, <a href=\"Socket/Address.html\">Address</a>)","location":{"filename":"src/socket.cr","line_number":248,"url":null},"def":{"name":"receive","args":[{"name":"message","external_name":"message","restriction":"Bytes"}],"return_type":"::Tuple(Int32, Address)","visibility":"Public","body":"bytes_read, sockaddr, addrlen = system_receive(message)\n{bytes_read, Address.from(sockaddr, addrlen)}\n"}},{"html_id":"receive(max_message_size=512):Tuple(String,Address)-instance-method","name":"receive","doc":"Receives a text message from the previously bound address.\n\n```\nrequire \"socket\"\n\nserver = Socket.udp(Socket::Family::INET)\nserver.bind(\"localhost\", 1234)\n\nmessage, client_addr = server.receive\n```","summary":"<p>Receives a text message from the previously bound address.</p>","abstract":false,"args":[{"name":"max_message_size","default_value":"512","external_name":"max_message_size","restriction":""}],"args_string":"(max_message_size = 512) : Tuple(String, Address)","args_html":"(max_message_size = <span class=\"n\">512</span>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"String.html\">String</a>, <a href=\"Socket/Address.html\">Address</a>)","location":{"filename":"src/socket.cr","line_number":227,"url":null},"def":{"name":"receive","args":[{"name":"max_message_size","default_value":"512","external_name":"max_message_size","restriction":""}],"return_type":"::Tuple(String, Address)","visibility":"Public","body":"address = nil\nmessage = String.new(max_message_size) do |buffer|\n  bytes_read, sockaddr, addrlen = system_receive(Slice.new(buffer, max_message_size))\n  address = Address.from(sockaddr, addrlen)\n  {bytes_read, 0}\nend\n{message, address.not_nil!}\n"}},{"html_id":"recv_buffer_size:Int32-instance-method","name":"recv_buffer_size","abstract":false,"location":{"filename":"src/socket.cr","line_number":276,"url":null},"def":{"name":"recv_buffer_size","return_type":"Int32","visibility":"Public","body":"getsockopt(LibC::SO_RCVBUF, 0)"}},{"html_id":"recv_buffer_size=(val:Int32)-instance-method","name":"recv_buffer_size=","abstract":false,"args":[{"name":"val","external_name":"val","restriction":"Int32"}],"args_string":"(val : Int32)","args_html":"(val : <a href=\"Int32.html\">Int32</a>)","location":{"filename":"src/socket.cr","line_number":280,"url":null},"def":{"name":"recv_buffer_size=","args":[{"name":"val","external_name":"val","restriction":"Int32"}],"visibility":"Public","body":"setsockopt(LibC::SO_RCVBUF, val)\nval\n"}},{"html_id":"reuse_address=(val:Bool)-instance-method","name":"reuse_address=","abstract":false,"args":[{"name":"val","external_name":"val","restriction":"Bool"}],"args_string":"(val : Bool)","args_html":"(val : <a href=\"Bool.html\">Bool</a>)","location":{"filename":"src/socket.cr","line_number":289,"url":null},"def":{"name":"reuse_address=","args":[{"name":"val","external_name":"val","restriction":"Bool"}],"visibility":"Public","body":"setsockopt_bool(LibC::SO_REUSEADDR, val)"}},{"html_id":"reuse_address?:Bool-instance-method","name":"reuse_address?","abstract":false,"location":{"filename":"src/socket.cr","line_number":285,"url":null},"def":{"name":"reuse_address?","return_type":"Bool","visibility":"Public","body":"getsockopt_bool(LibC::SO_REUSEADDR)"}},{"html_id":"reuse_port=(val:Bool)-instance-method","name":"reuse_port=","abstract":false,"args":[{"name":"val","external_name":"val","restriction":"Bool"}],"args_string":"(val : Bool)","args_html":"(val : <a href=\"Bool.html\">Bool</a>)","location":{"filename":"src/socket.cr","line_number":297,"url":null},"def":{"name":"reuse_port=","args":[{"name":"val","external_name":"val","restriction":"Bool"}],"visibility":"Public","body":"self.system_reuse_port = val"}},{"html_id":"reuse_port?:Bool-instance-method","name":"reuse_port?","abstract":false,"location":{"filename":"src/socket.cr","line_number":293,"url":null},"def":{"name":"reuse_port?","return_type":"Bool","visibility":"Public","body":"system_reuse_port?"}},{"html_id":"send(message,toaddr:Address):Int32-instance-method","name":"send","doc":"Sends a message to the specified remote address.\n\n```\nrequire \"socket\"\n\nserver = Socket::IPAddress.new(\"10.0.3.1\", 2022)\nsock = Socket.udp(Socket::Family::INET)\nsock.connect(\"example.com\", 2000)\nsock.send(\"text query\", to: server)\n```","summary":"<p>Sends a message to the specified remote address.</p>","abstract":false,"args":[{"name":"message","external_name":"message","restriction":""},{"name":"addr","external_name":"to","restriction":"Address"}],"args_string":"(message, to addr : Address) : Int32","args_html":"(message, to addr : <a href=\"Socket/Address.html\">Address</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/socket.cr","line_number":213,"url":null},"def":{"name":"send","args":[{"name":"message","external_name":"message","restriction":""},{"name":"addr","external_name":"to","restriction":"Address"}],"return_type":"Int32","visibility":"Public","body":"system_send_to(message.to_slice, addr)"}},{"html_id":"send(message):Int32-instance-method","name":"send","doc":"Sends a message to a previously connected remote address.\n\n```\nrequire \"socket\"\n\nsock = Socket.udp(Socket::Family::INET)\nsock.connect(\"example.com\", 2000)\nsock.send(\"text message\")\n\nsock = Socket.unix(Socket::Type::DGRAM)\nsock.connect Socket::UNIXAddress.new(\"/tmp/service.sock\")\nsock.send(Bytes[0])\n```","summary":"<p>Sends a message to a previously connected remote address.</p>","abstract":false,"args":[{"name":"message","external_name":"message","restriction":""}],"args_string":"(message) : Int32","args_html":"(message) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/socket.cr","line_number":199,"url":null},"def":{"name":"send","args":[{"name":"message","external_name":"message","restriction":""}],"return_type":"Int32","visibility":"Public","body":"system_send(message.to_slice)"}},{"html_id":"send_buffer_size:Int32-instance-method","name":"send_buffer_size","abstract":false,"location":{"filename":"src/socket.cr","line_number":267,"url":null},"def":{"name":"send_buffer_size","return_type":"Int32","visibility":"Public","body":"getsockopt(LibC::SO_SNDBUF, 0)"}},{"html_id":"send_buffer_size=(val:Int32)-instance-method","name":"send_buffer_size=","abstract":false,"args":[{"name":"val","external_name":"val","restriction":"Int32"}],"args_string":"(val : Int32)","args_html":"(val : <a href=\"Int32.html\">Int32</a>)","location":{"filename":"src/socket.cr","line_number":271,"url":null},"def":{"name":"send_buffer_size=","args":[{"name":"val","external_name":"val","restriction":"Int32"}],"visibility":"Public","body":"setsockopt(LibC::SO_SNDBUF, val)\nval\n"}},{"html_id":"tty?-instance-method","name":"tty?","doc":"Returns `true` if this `IO` is associated with a terminal device (tty), `false` otherwise.\n\nIO returns `false`, but including types may override.\n\n```\nSTDIN.tty?          # => true\nIO::Memory.new.tty? # => false\n```","summary":"<p>Returns <code>true</code> if this <code><a href=\"IO.html\">IO</a></code> is associated with a terminal device (tty), <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/socket.cr","line_number":393,"url":null},"def":{"name":"tty?","visibility":"Public","body":"system_tty?"}},{"html_id":"type:Type-instance-method","name":"type","abstract":false,"location":{"filename":"src/socket.cr","line_number":23,"url":null},"def":{"name":"type","return_type":"Type","visibility":"Public","body":"@type"}}],"types":[{"html_id":"Crystal/Socket/Address","path":"Socket/Address.html","kind":"struct","full_name":"Socket::Address","name":"Address","abstract":true,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/address.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/Socket/IPAddress","kind":"struct","full_name":"Socket::IPAddress","name":"IPAddress"},{"html_id":"Crystal/Socket/UNIXAddress","kind":"struct","full_name":"Socket::UNIXAddress","name":"UNIXAddress"}],"namespace":{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"constructors":[{"html_id":"from(sockaddr:Pointer(LibC::Sockaddr),addrlen):Address-class-method","name":"from","doc":"Returns either an `IPAddress` or `UNIXAddress` from the internal OS\nrepresentation. Only INET, INET6 and UNIX families are supported.","summary":"<p>Returns either an <code><a href=\"../Socket/IPAddress.html\">IPAddress</a></code> or <code><a href=\"../Socket/UNIXAddress.html\">UNIXAddress</a></code> from the internal OS representation.</p>","abstract":false,"args":[{"name":"sockaddr","external_name":"sockaddr","restriction":"::Pointer(LibC::Sockaddr)"},{"name":"addrlen","external_name":"addrlen","restriction":""}],"args_string":"(sockaddr : Pointer(LibC::Sockaddr), addrlen) : Address","args_html":"(sockaddr : <a href=\"../Pointer.html\">Pointer</a>(LibC::Sockaddr), addrlen) : <a href=\"../Socket/Address.html\">Address</a>","location":{"filename":"src/socket/address.cr","line_number":11,"url":null},"def":{"name":"from","args":[{"name":"sockaddr","external_name":"sockaddr","restriction":"::Pointer(LibC::Sockaddr)"},{"name":"addrlen","external_name":"addrlen","restriction":""}],"return_type":"Address","visibility":"Public","body":"case family = Family.new(sockaddr.value.sa_family)\nwhen Family::INET6\n  IPAddress.new(sockaddr.as(::Pointer(LibC::SockaddrIn6)), addrlen.to_i)\nwhen Family::INET\n  IPAddress.new(sockaddr.as(::Pointer(LibC::SockaddrIn)), addrlen.to_i)\nwhen Family::UNIX\n  UNIXAddress.new(sockaddr.as(::Pointer(LibC::SockaddrUn)), addrlen.to_i)\nelse\n  raise(\"Unsupported family type: #{family} (#{family.value})\")\nend"}},{"html_id":"new(family:Family,size:Int32)-class-method","name":"new","abstract":false,"args":[{"name":"family","external_name":"family","restriction":"Family"},{"name":"size","external_name":"size","restriction":"Int32"}],"args_string":"(family : Family, size : Int32)","args_html":"(family : <a href=\"../Socket/Family.html\">Family</a>, size : <a href=\"../Int32.html\">Int32</a>)","location":{"filename":"src/socket/address.cr","line_number":49,"url":null},"def":{"name":"new","args":[{"name":"family","external_name":"family","restriction":"Family"},{"name":"size","external_name":"size","restriction":"Int32"}],"visibility":"Public","body":"_ = allocate\n_.initialize(family, size)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"parse(uri:URI):self-class-method","name":"parse","doc":"Parses a `Socket::Address` from an URI.\n\nSupported formats:\n* `ip://<host>:<port>`\n* `tcp://<host>:<port>`\n* `udp://<host>:<port>`\n* `unix://<path>`\n\nSee `IPAddress.parse` and `UNIXAddress.parse` for details.","summary":"<p>Parses a <code><a href=\"../Socket/Address.html\">Socket::Address</a></code> from an URI.</p>","abstract":false,"args":[{"name":"uri","external_name":"uri","restriction":"URI"}],"args_string":"(uri : URI) : self","args_html":"(uri : <a href=\"../URI.html\">URI</a>) : <span class=\"k\">self</span>","location":{"filename":"src/socket/address.cr","line_number":33,"url":null},"def":{"name":"parse","args":[{"name":"uri","external_name":"uri","restriction":"URI"}],"return_type":"self","visibility":"Public","body":"case uri.scheme\nwhen \"ip\", \"tcp\", \"udp\"\n  IPAddress.parse(uri)\nwhen \"unix\"\n  UNIXAddress.parse(uri)\nelse\n  raise(Socket::Error.new(\"Unsupported address type: #{uri.scheme}\"))\nend"}},{"html_id":"parse(uri:String):self-class-method","name":"parse","doc":"Parses a `Socket::Address` from an URI.\n\nSupported formats:\n* `ip://<host>:<port>`\n* `tcp://<host>:<port>`\n* `udp://<host>:<port>`\n* `unix://<path>`\n\nSee `IPAddress.parse` and `UNIXAddress.parse` for details.","summary":"<p>Parses a <code><a href=\"../Socket/Address.html\">Socket::Address</a></code> from an URI.</p>","abstract":false,"args":[{"name":"uri","external_name":"uri","restriction":"String"}],"args_string":"(uri : String) : self","args_html":"(uri : <a href=\"../String.html\">String</a>) : <span class=\"k\">self</span>","location":{"filename":"src/socket/address.cr","line_number":45,"url":null},"def":{"name":"parse","args":[{"name":"uri","external_name":"uri","restriction":"String"}],"return_type":"self","visibility":"Public","body":"parse(URI.parse(uri))"}}],"instance_methods":[{"html_id":"family:Family-instance-method","name":"family","abstract":false,"location":{"filename":"src/socket/address.cr","line_number":6,"url":null},"def":{"name":"family","return_type":"Family","visibility":"Public","body":"@family"}},{"html_id":"size:Int32-instance-method","name":"size","abstract":false,"location":{"filename":"src/socket/address.cr","line_number":7,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"@size"}},{"html_id":"to_unsafe:Pointer(LibC::Sockaddr)-instance-method","name":"to_unsafe","abstract":true,"location":{"filename":"src/socket/address.cr","line_number":52,"url":null},"def":{"name":"to_unsafe","return_type":"::Pointer(LibC::Sockaddr)","visibility":"Public","body":""}}]},{"html_id":"Crystal/Socket/Addrinfo","path":"Socket/Addrinfo.html","kind":"struct","full_name":"Socket::Addrinfo","name":"Addrinfo","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/addrinfo.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"doc":"Domain name resolver.","summary":"<p>Domain name resolver.</p>","class_methods":[{"html_id":"resolve(domain,service,family:Family?=nil,type:Type=nil,protocol:Protocol=Protocol::IP,timeout=nil):Array(Addrinfo)-class-method","name":"resolve","doc":"Resolves a domain that best matches the given options.\n\n- *domain* may be an IP address or a domain name.\n- *service* may be a port number or a service name. It must be specified,\n  because different servers may handle the `mail` or `http` services for\n  example.\n- *family* is optional and defaults to `Family::UNSPEC`\n- *type* is the intended socket type (e.g. `Type::STREAM`) and must be\n  specified.\n- *protocol* is the intended socket protocol (e.g. `Protocol::TCP`) and\n  should be specified.\n\nExample:\n```\nrequire \"socket\"\n\naddrinfos = Socket::Addrinfo.resolve(\"example.org\", \"http\", type: Socket::Type::STREAM, protocol: Socket::Protocol::TCP)\n```","summary":"<p>Resolves a domain that best matches the given options.</p>","abstract":false,"args":[{"name":"domain","external_name":"domain","restriction":""},{"name":"service","external_name":"service","restriction":""},{"name":"family","default_value":"nil","external_name":"family","restriction":"Family | ::Nil"},{"name":"type","default_value":"nil","external_name":"type","restriction":"Type"},{"name":"protocol","default_value":"Protocol::IP","external_name":"protocol","restriction":"Protocol"},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(domain, service, family : Family? = nil, type : Type = nil, protocol : Protocol = Protocol::IP, timeout = nil) : Array(Addrinfo)","args_html":"(domain, service, family : <a href=\"../Socket/Family.html\">Family</a>? = <span class=\"n\">nil</span>, type : <a href=\"../Socket/Type.html\">Type</a> = <span class=\"n\">nil</span>, protocol : <a href=\"../Socket/Protocol.html\">Protocol</a> = <span class=\"t\">Protocol</span><span class=\"t\">::</span><span class=\"t\">IP</span>, timeout = <span class=\"n\">nil</span>) : <a href=\"../Array.html\">Array</a>(<a href=\"../Socket/Addrinfo.html\">Addrinfo</a>)","location":{"filename":"src/socket/addrinfo.cr","line_number":33,"url":null},"def":{"name":"resolve","args":[{"name":"domain","external_name":"domain","restriction":""},{"name":"service","external_name":"service","restriction":""},{"name":"family","default_value":"nil","external_name":"family","restriction":"Family | ::Nil"},{"name":"type","default_value":"nil","external_name":"type","restriction":"Type"},{"name":"protocol","default_value":"Protocol::IP","external_name":"protocol","restriction":"Protocol"},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"return_type":"Array(Addrinfo)","visibility":"Public","body":"addrinfos = [] of Addrinfo\ngetaddrinfo(domain, service, family, type, protocol, timeout) do |addrinfo|\n  loop do\n    addrinfos << addrinfo.not_nil!\n    if addrinfo = addrinfo.next?\n    else\n      return addrinfos\n    end\n  end\nend\n"}},{"html_id":"resolve(domain,service,family:Family?=nil,type:Type=nil,protocol:Protocol=Protocol::IP,timeout=nil,&)-class-method","name":"resolve","doc":"Resolves a domain that best matches the given options.\n\nYields each possible `Addrinfo` resolution since a domain may resolve to\nmany IP. Implementations are supposed to try all the addresses until the\nsocket is connected (or bound) or there are no addresses to try anymore.\n\nRaising is an expensive operation, so instead of raising on a connect or\nbind error, just to rescue it immediately after, the block is expected to\nreturn the error instead, which will be raised once there are no more\naddresses to try.\n\nThe iteration will be stopped once the block returns something that isn't\nan `Exception` (e.g. a `Socket` or `nil`).","summary":"<p>Resolves a domain that best matches the given options.</p>","abstract":false,"args":[{"name":"domain","external_name":"domain","restriction":""},{"name":"service","external_name":"service","restriction":""},{"name":"family","default_value":"nil","external_name":"family","restriction":"Family | ::Nil"},{"name":"type","default_value":"nil","external_name":"type","restriction":"Type"},{"name":"protocol","default_value":"Protocol::IP","external_name":"protocol","restriction":"Protocol"},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(domain, service, family : Family? = nil, type : Type = nil, protocol : Protocol = Protocol::IP, timeout = nil, &)","args_html":"(domain, service, family : <a href=\"../Socket/Family.html\">Family</a>? = <span class=\"n\">nil</span>, type : <a href=\"../Socket/Type.html\">Type</a> = <span class=\"n\">nil</span>, protocol : <a href=\"../Socket/Protocol.html\">Protocol</a> = <span class=\"t\">Protocol</span><span class=\"t\">::</span><span class=\"t\">IP</span>, timeout = <span class=\"n\">nil</span>, &)","location":{"filename":"src/socket/addrinfo.cr","line_number":59,"url":null},"def":{"name":"resolve","args":[{"name":"domain","external_name":"domain","restriction":""},{"name":"service","external_name":"service","restriction":""},{"name":"family","default_value":"nil","external_name":"family","restriction":"Family | ::Nil"},{"name":"type","default_value":"nil","external_name":"type","restriction":"Type"},{"name":"protocol","default_value":"Protocol::IP","external_name":"protocol","restriction":"Protocol"},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"yields":1,"visibility":"Public","body":"getaddrinfo(domain, service, family, type, protocol, timeout) do |addrinfo|\n  loop do\n    value = yield addrinfo.not_nil!\n    if value.is_a?(Exception)\n      if addrinfo = addrinfo.try(&.next?)\n      else\n        if value.is_a?(Socket::ConnectError)\n          raise(Socket::ConnectError.from_os_error(\"Error connecting to '#{domain}:#{service}'\", value.os_error))\n        else\n          {% if flag?(:win32) %}\n                  # FIXME: Workardound for https://github.com/crystal-lang/crystal/issues/11047\n                  array = StaticArray(UInt8, 0).new(0)\n                {% end %}\n          raise(value)\n        end\n      end\n    else\n      return value\n    end\n  end\nend"}},{"html_id":"tcp(domain,service,family=Family::UNSPEC,timeout=nil):Array(Addrinfo)-class-method","name":"tcp","doc":"Resolves *domain* for the TCP protocol and returns an `Array` of possible\n`Addrinfo`. See `#resolve` for details.\n\nExample:\n```\nrequire \"socket\"\n\naddrinfos = Socket::Addrinfo.tcp(\"example.org\", 80)\n```","summary":"<p>Resolves <em>domain</em> for the TCP protocol and returns an <code><a href=\"../Array.html\">Array</a></code> of possible <code><a href=\"../Socket/Addrinfo.html\">Addrinfo</a></code>.</p>","abstract":false,"args":[{"name":"domain","external_name":"domain","restriction":""},{"name":"service","external_name":"service","restriction":""},{"name":"family","default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(domain, service, family = Family::UNSPEC, timeout = nil) : Array(Addrinfo)","args_html":"(domain, service, family = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">UNSPEC</span>, timeout = <span class=\"n\">nil</span>) : <a href=\"../Array.html\">Array</a>(<a href=\"../Socket/Addrinfo.html\">Addrinfo</a>)","location":{"filename":"src/socket/addrinfo.cr","line_number":195,"url":null},"def":{"name":"tcp","args":[{"name":"domain","external_name":"domain","restriction":""},{"name":"service","external_name":"service","restriction":""},{"name":"family","default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"return_type":"Array(Addrinfo)","visibility":"Public","body":"resolve(domain, service, family, Type::STREAM, Protocol::TCP)"}},{"html_id":"tcp(domain,service,family=Family::UNSPEC,timeout=nil,&)-class-method","name":"tcp","doc":"Resolves a domain for the TCP protocol with STREAM type, and yields each\npossible `Addrinfo`. See `#resolve` for details.","summary":"<p>Resolves a domain for the TCP protocol with STREAM type, and yields each possible <code><a href=\"../Socket/Addrinfo.html\">Addrinfo</a></code>.</p>","abstract":false,"args":[{"name":"domain","external_name":"domain","restriction":""},{"name":"service","external_name":"service","restriction":""},{"name":"family","default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(domain, service, family = Family::UNSPEC, timeout = nil, &)","args_html":"(domain, service, family = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">UNSPEC</span>, timeout = <span class=\"n\">nil</span>, &)","location":{"filename":"src/socket/addrinfo.cr","line_number":201,"url":null},"def":{"name":"tcp","args":[{"name":"domain","external_name":"domain","restriction":""},{"name":"service","external_name":"service","restriction":""},{"name":"family","default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"yields":1,"visibility":"Public","body":"resolve(domain, service, family, Type::STREAM, Protocol::TCP) do |addrinfo|\n  yield addrinfo\nend"}},{"html_id":"udp(domain,service,family=Family::UNSPEC,timeout=nil):Array(Addrinfo)-class-method","name":"udp","doc":"Resolves *domain* for the UDP protocol and returns an `Array` of possible\n`Addrinfo`. See `#resolve` for details.\n\nExample:\n```\nrequire \"socket\"\n\naddrinfos = Socket::Addrinfo.udp(\"example.org\", 53)\n```","summary":"<p>Resolves <em>domain</em> for the UDP protocol and returns an <code><a href=\"../Array.html\">Array</a></code> of possible <code><a href=\"../Socket/Addrinfo.html\">Addrinfo</a></code>.</p>","abstract":false,"args":[{"name":"domain","external_name":"domain","restriction":""},{"name":"service","external_name":"service","restriction":""},{"name":"family","default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(domain, service, family = Family::UNSPEC, timeout = nil) : Array(Addrinfo)","args_html":"(domain, service, family = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">UNSPEC</span>, timeout = <span class=\"n\">nil</span>) : <a href=\"../Array.html\">Array</a>(<a href=\"../Socket/Addrinfo.html\">Addrinfo</a>)","location":{"filename":"src/socket/addrinfo.cr","line_number":214,"url":null},"def":{"name":"udp","args":[{"name":"domain","external_name":"domain","restriction":""},{"name":"service","external_name":"service","restriction":""},{"name":"family","default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"return_type":"Array(Addrinfo)","visibility":"Public","body":"resolve(domain, service, family, Type::DGRAM, Protocol::UDP)"}},{"html_id":"udp(domain,service,family=Family::UNSPEC,timeout=nil,&)-class-method","name":"udp","doc":"Resolves a domain for the UDP protocol with DGRAM type, and yields each\npossible `Addrinfo`. See `#resolve` for details.","summary":"<p>Resolves a domain for the UDP protocol with DGRAM type, and yields each possible <code><a href=\"../Socket/Addrinfo.html\">Addrinfo</a></code>.</p>","abstract":false,"args":[{"name":"domain","external_name":"domain","restriction":""},{"name":"service","external_name":"service","restriction":""},{"name":"family","default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"args_string":"(domain, service, family = Family::UNSPEC, timeout = nil, &)","args_html":"(domain, service, family = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">UNSPEC</span>, timeout = <span class=\"n\">nil</span>, &)","location":{"filename":"src/socket/addrinfo.cr","line_number":220,"url":null},"def":{"name":"udp","args":[{"name":"domain","external_name":"domain","restriction":""},{"name":"service","external_name":"service","restriction":""},{"name":"family","default_value":"Family::UNSPEC","external_name":"family","restriction":""},{"name":"timeout","default_value":"nil","external_name":"timeout","restriction":""}],"yields":1,"visibility":"Public","body":"resolve(domain, service, family, Type::DGRAM, Protocol::UDP) do |addrinfo|\n  yield addrinfo\nend"}}],"instance_methods":[{"html_id":"family:Family-instance-method","name":"family","abstract":false,"location":{"filename":"src/socket/addrinfo.cr","line_number":7,"url":null},"def":{"name":"family","return_type":"Family","visibility":"Public","body":"@family"}},{"html_id":"inspect(io:IO)-instance-method","name":"inspect","doc":"Appends this struct's name and instance variables names and values\nto the given IO.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np1.to_s    # \"Point(@x=1, @y=2)\"\np1.inspect # \"Point(@x=1, @y=2)\"\n```","summary":"<p>Appends this struct's name and instance variables names and values to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","args_html":"(io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/socket/addrinfo.cr","line_number":250,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"io << \"Socket::Addrinfo(\"\n(io << ip_address) << \", \"\n(io << family) << \", \"\n(io << type) << \", \"\nio << protocol\nio << \")\"\n"}},{"html_id":"ip_address:Socket::IPAddress-instance-method","name":"ip_address","doc":"Returns an `IPAddress` matching this addrinfo.","summary":"<p>Returns an <code><a href=\"../Socket/IPAddress.html\">IPAddress</a></code> matching this addrinfo.</p>","abstract":false,"location":{"filename":"src/socket/addrinfo.cr","line_number":246,"url":null},"def":{"name":"ip_address","return_type":"Socket::IPAddress","visibility":"Public","body":"@ip_address || (@ip_address = IPAddress.from(to_unsafe, size))"}},{"html_id":"protocol:Protocol-instance-method","name":"protocol","abstract":false,"location":{"filename":"src/socket/addrinfo.cr","line_number":9,"url":null},"def":{"name":"protocol","return_type":"Protocol","visibility":"Public","body":"@protocol"}},{"html_id":"size:Int32-instance-method","name":"size","abstract":false,"location":{"filename":"src/socket/addrinfo.cr","line_number":10,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"@size"}},{"html_id":"to_unsafe-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/socket/addrinfo.cr","line_number":259,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"(pointerof(@addr)).as(::Pointer(LibC::Sockaddr))"}},{"html_id":"type:Type-instance-method","name":"type","abstract":false,"location":{"filename":"src/socket/addrinfo.cr","line_number":8,"url":null},"def":{"name":"type","return_type":"Type","visibility":"Public","body":"@type"}}],"types":[{"html_id":"Crystal/Socket/Addrinfo/Error","path":"Socket/Addrinfo/Error.html","kind":"class","full_name":"Socket::Addrinfo::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Socket/Error","kind":"class","full_name":"Socket::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/Socket/Error","kind":"class","full_name":"Socket::Error","name":"Error"},{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},{"html_id":"Crystal/SystemError","kind":"module","full_name":"SystemError","name":"SystemError"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/addrinfo.cr","line_number":84,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Socket/Addrinfo","kind":"struct","full_name":"Socket::Addrinfo","name":"Addrinfo"},"class_methods":[{"html_id":"build_message(message,*,domain,**opts)-class-method","name":"build_message","abstract":false,"args":[{"name":"message","external_name":"message","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"domain","external_name":"domain","restriction":""}],"args_string":"(message, *, domain, **opts)","args_html":"(message, *, domain, **opts)","location":{"filename":"src/socket/addrinfo.cr","line_number":108,"url":null},"def":{"name":"build_message","args":[{"name":"message","external_name":"message","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"domain","external_name":"domain","restriction":""}],"double_splat":{"name":"opts","external_name":"opts","restriction":""},"splat_index":1,"visibility":"Public","body":"\"Hostname lookup for #{domain} failed\""}},{"html_id":"os_error_message(os_error:Errno,*,type,service,protocol,**opts)-class-method","name":"os_error_message","abstract":false,"args":[{"name":"os_error","external_name":"os_error","restriction":"Errno"},{"name":"","external_name":"","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"service","external_name":"service","restriction":""},{"name":"protocol","external_name":"protocol","restriction":""}],"args_string":"(os_error : Errno, *, type, service, protocol, **opts)","args_html":"(os_error : <a href=\"../../Errno.html\">Errno</a>, *, type, service, protocol, **opts)","location":{"filename":"src/socket/addrinfo.cr","line_number":112,"url":null},"def":{"name":"os_error_message","args":[{"name":"os_error","external_name":"os_error","restriction":"Errno"},{"name":"","external_name":"","restriction":""},{"name":"type","external_name":"type","restriction":""},{"name":"service","external_name":"service","restriction":""},{"name":"protocol","external_name":"protocol","restriction":""}],"double_splat":{"name":"opts","external_name":"opts","restriction":""},"splat_index":1,"visibility":"Public","body":"case os_error.value\nwhen LibC::EAI_NONAME\n  \"No address found\"\nwhen LibC::EAI_SOCKTYPE\n  \"The requested socket type #{type} protocol #{protocol} is not supported\"\nwhen LibC::EAI_SERVICE\n  \"The requested service #{service} is not available for the requested socket type #{type}\"\nelse\n  {% if flag?(:win32) %}{% else %}\n            # There's no need for a special win32 branch because the os_error on Windows\n            # is of type WinError, which wouldn't match this overload anyways.\n\n            String.new(LibC.gai_strerror(os_error.value))\n          {% end %}\nend"}}],"constructors":[{"html_id":"new(error_code:Int32,message,domain)-class-method","name":"new","summary":"<p><span class=\"flag red\">DEPRECATED</span>  Use <code>.from_os_error</code> instead</p>","abstract":false,"args":[{"name":"error_code","external_name":"error_code","restriction":"Int32"},{"name":"message","external_name":"message","restriction":""},{"name":"domain","external_name":"domain","restriction":""}],"args_string":"(error_code : Int32, message, domain)","args_html":"(error_code : <a href=\"../../Int32.html\">Int32</a>, message, domain)","location":{"filename":"src/socket/addrinfo.cr","line_number":91,"url":null},"def":{"name":"new","args":[{"name":"error_code","external_name":"error_code","restriction":"Int32"},{"name":"message","external_name":"message","restriction":""},{"name":"domain","external_name":"domain","restriction":""}],"visibility":"Public","body":"from_os_error(message, Errno.new(error_code), domain: domain, type: nil, service: nil, protocol: nil)"}},{"html_id":"new(error_code:Int32,domain)-class-method","name":"new","summary":"<p><span class=\"flag red\">DEPRECATED</span>  Use <code>.from_os_error</code> instead</p>","abstract":false,"args":[{"name":"error_code","external_name":"error_code","restriction":"Int32"},{"name":"domain","external_name":"domain","restriction":""}],"args_string":"(error_code : Int32, domain)","args_html":"(error_code : <a href=\"../../Int32.html\">Int32</a>, domain)","location":{"filename":"src/socket/addrinfo.cr","line_number":96,"url":null},"def":{"name":"new","args":[{"name":"error_code","external_name":"error_code","restriction":"Int32"},{"name":"domain","external_name":"domain","restriction":""}],"visibility":"Public","body":"new(error_code, nil, domain: domain)"}}],"instance_methods":[{"html_id":"error_code:Int32-instance-method","name":"error_code","summary":"<p><span class=\"flag red\">DEPRECATED</span>  Use <code>#os_error</code> instead</p>","abstract":false,"location":{"filename":"src/socket/addrinfo.cr","line_number":86,"url":null},"def":{"name":"error_code","return_type":"Int32","visibility":"Public","body":"os_error.not_nil!.value.to_i32!"}}]}]},{"html_id":"Crystal/Socket/BindError","path":"Socket/BindError.html","kind":"class","full_name":"Socket::BindError","name":"BindError","abstract":false,"superclass":{"html_id":"Crystal/Socket/Error","kind":"class","full_name":"Socket::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/Socket/Error","kind":"class","full_name":"Socket::Error","name":"Error"},{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},{"html_id":"Crystal/SystemError","kind":"module","full_name":"SystemError","name":"SystemError"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/common.cr","line_number":63,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"}},{"html_id":"Crystal/Socket/ConnectError","path":"Socket/ConnectError.html","kind":"class","full_name":"Socket::ConnectError","name":"ConnectError","abstract":false,"superclass":{"html_id":"Crystal/Socket/Error","kind":"class","full_name":"Socket::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/Socket/Error","kind":"class","full_name":"Socket::Error","name":"Error"},{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},{"html_id":"Crystal/SystemError","kind":"module","full_name":"SystemError","name":"SystemError"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/common.cr","line_number":60,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"}},{"html_id":"Crystal/Socket/Error","path":"Socket/Error.html","kind":"class","full_name":"Socket::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},{"html_id":"Crystal/SystemError","kind":"module","full_name":"SystemError","name":"SystemError"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/common.cr","line_number":47,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/Socket/Addrinfo/Error","kind":"class","full_name":"Socket::Addrinfo::Error","name":"Error"},{"html_id":"Crystal/Socket/BindError","kind":"class","full_name":"Socket::BindError","name":"BindError"},{"html_id":"Crystal/Socket/ConnectError","kind":"class","full_name":"Socket::ConnectError","name":"ConnectError"}],"namespace":{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"}},{"html_id":"Crystal/Socket/Family","path":"Socket/Family.html","kind":"enum","full_name":"Socket::Family","name":"Family","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/common.cr","line_number":33,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"UNSPEC","name":"UNSPEC","value":"0_u16"},{"id":"UNIX","name":"UNIX","value":"1_u16"},{"id":"INET","name":"INET","value":"2_u16"},{"id":"INET6","name":"INET6","value":"10_u16"}],"namespace":{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"instance_methods":[{"html_id":"inet6?-instance-method","name":"inet6?","abstract":false,"location":{"filename":"src/socket/common.cr","line_number":37,"url":null},"def":{"name":"inet6?","visibility":"Public","body":"self == INET6"}},{"html_id":"inet?-instance-method","name":"inet?","abstract":false,"location":{"filename":"src/socket/common.cr","line_number":36,"url":null},"def":{"name":"inet?","visibility":"Public","body":"self == INET"}},{"html_id":"unix?-instance-method","name":"unix?","abstract":false,"location":{"filename":"src/socket/common.cr","line_number":35,"url":null},"def":{"name":"unix?","visibility":"Public","body":"self == UNIX"}},{"html_id":"unspec?-instance-method","name":"unspec?","abstract":false,"location":{"filename":"src/socket/common.cr","line_number":34,"url":null},"def":{"name":"unspec?","visibility":"Public","body":"self == UNSPEC"}}]},{"html_id":"Crystal/Socket/FamilyT","path":"Socket/FamilyT.html","kind":"alias","full_name":"Socket::FamilyT","name":"FamilyT","abstract":false,"locations":[{"filename":"src/socket/common.cr","line_number":27,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"UInt16","aliased_html":"<a href=\"../UInt16.html\">UInt16</a>","const":false,"constants":[{"id":"MAX","name":"MAX","value":"65535_u16"},{"id":"MIN","name":"MIN","value":"0_u16"}],"namespace":{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"}},{"html_id":"Crystal/Socket/IPAddress","path":"Socket/IPAddress.html","kind":"struct","full_name":"Socket::IPAddress","name":"IPAddress","abstract":false,"superclass":{"html_id":"Crystal/Socket/Address","kind":"struct","full_name":"Socket::Address","name":"Address"},"ancestors":[{"html_id":"Crystal/Socket/Address","kind":"struct","full_name":"Socket::Address","name":"Address"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/address.cr","line_number":72,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"BROADCAST","name":"BROADCAST","value":"\"255.255.255.255\""},{"id":"BROADCAST6","name":"BROADCAST6","value":"\"ff0X::1\""},{"id":"LOOPBACK","name":"LOOPBACK","value":"\"127.0.0.1\""},{"id":"LOOPBACK6","name":"LOOPBACK6","value":"\"::1\""},{"id":"UNSPECIFIED","name":"UNSPECIFIED","value":"\"0.0.0.0\""},{"id":"UNSPECIFIED6","name":"UNSPECIFIED6","value":"\"::\""}],"namespace":{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"doc":"IP address representation.\n\nHolds a binary representation of an IP address, either translated from a\n`String`, or directly received from an opened connection (e.g.\n`Socket#local_address`, `Socket#receive`).\n\nExample:\n```\nrequire \"socket\"\n\nSocket::IPAddress.new(\"127.0.0.1\", 8080)\nSocket::IPAddress.new(\"fe80::2ab2:bdff:fe59:8e2c\", 1234)\n```\n\n`IPAddress` won't resolve domains, including `localhost`. If you must\nresolve an IP, or don't know whether a `String` contains an IP or a domain\nname, you should use `Addrinfo.resolve` instead.","summary":"<p>IP address representation.</p>","class_methods":[{"html_id":"valid_port?(port:Int):Bool-class-method","name":"valid_port?","doc":"Returns `true` if *port* is a valid port number.\n\nValid port numbers are in the range `0..65_535`.","summary":"<p>Returns <code>true</code> if <em>port</em> is a valid port number.</p>","abstract":false,"args":[{"name":"port","external_name":"port","restriction":"Int"}],"args_string":"(port : Int) : Bool","args_html":"(port : <a href=\"../Int.html\">Int</a>) : <a href=\"../Bool.html\">Bool</a>","location":{"filename":"src/socket/address.cr","line_number":312,"url":null},"def":{"name":"valid_port?","args":[{"name":"port","external_name":"port","restriction":"Int"}],"return_type":"Bool","visibility":"Public","body":"port.in?(0..UInt16::MAX)"}}],"constructors":[{"html_id":"from(sockaddr:Pointer(LibC::Sockaddr),addrlen):IPAddress-class-method","name":"from","doc":"Creates an `IPAddress` from the internal OS representation. Supports both\nINET and INET6 families.","summary":"<p>Creates an <code><a href=\"../Socket/IPAddress.html\">IPAddress</a></code> from the internal OS representation.</p>","abstract":false,"args":[{"name":"sockaddr","external_name":"sockaddr","restriction":"::Pointer(LibC::Sockaddr)"},{"name":"addrlen","external_name":"addrlen","restriction":""}],"args_string":"(sockaddr : Pointer(LibC::Sockaddr), addrlen) : IPAddress","args_html":"(sockaddr : <a href=\"../Pointer.html\">Pointer</a>(LibC::Sockaddr), addrlen) : <a href=\"../Socket/IPAddress.html\">IPAddress</a>","location":{"filename":"src/socket/address.cr","line_number":100,"url":null},"def":{"name":"from","args":[{"name":"sockaddr","external_name":"sockaddr","restriction":"::Pointer(LibC::Sockaddr)"},{"name":"addrlen","external_name":"addrlen","restriction":""}],"return_type":"IPAddress","visibility":"Public","body":"case family = Family.new(sockaddr.value.sa_family)\nwhen Family::INET6\n  new(sockaddr.as(::Pointer(LibC::SockaddrIn6)), addrlen.to_i)\nwhen Family::INET\n  new(sockaddr.as(::Pointer(LibC::SockaddrIn)), addrlen.to_i)\nelse\n  raise(\"Unsupported family type: #{family} (#{family.value})\")\nend"}},{"html_id":"new(address:String,port:Int32)-class-method","name":"new","abstract":false,"args":[{"name":"address","external_name":"address","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int32"}],"args_string":"(address : String, port : Int32)","args_html":"(address : <a href=\"../String.html\">String</a>, port : <a href=\"../Int32.html\">Int32</a>)","location":{"filename":"src/socket/address.cr","line_number":84,"url":null},"def":{"name":"new","args":[{"name":"address","external_name":"address","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int32"}],"visibility":"Public","body":"_ = allocate\n_.initialize(address, port)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"parse(uri:URI):IPAddress-class-method","name":"parse","doc":"Parses a `Socket::IPAddress` from an URI.\n\nIt expects the URI to include `<scheme>://<host>:<port>` where `scheme` as\nwell as any additional URI components (such as `path` or `query`) are ignored.\n\n`host` must be an IP address (v4 or v6), otherwise `Socket::Error` will be\nraised. Domain names will not be resolved.\n\n```\nrequire \"socket\"\n\nSocket::IPAddress.parse(\"tcp://127.0.0.1:8080\") # => Socket::IPAddress.new(\"127.0.0.1\", 8080)\nSocket::IPAddress.parse(\"udp://[::1]:8080\")     # => Socket::IPAddress.new(\"::1\", 8080)\n```","summary":"<p>Parses a <code><a href=\"../Socket/IPAddress.html\">Socket::IPAddress</a></code> from an URI.</p>","abstract":false,"args":[{"name":"uri","external_name":"uri","restriction":"URI"}],"args_string":"(uri : URI) : IPAddress","args_html":"(uri : <a href=\"../URI.html\">URI</a>) : <a href=\"../Socket/IPAddress.html\">IPAddress</a>","location":{"filename":"src/socket/address.cr","line_number":125,"url":null},"def":{"name":"parse","args":[{"name":"uri","external_name":"uri","restriction":"URI"}],"return_type":"IPAddress","visibility":"Public","body":"host = uri.host.presence\nif host\nelse\n  raise(Socket::Error.new(\"Invalid IP address: missing host\"))\nend\nport = uri.port\nif port\nelse\n  raise(Socket::Error.new(\"Invalid IP address: missing port\"))\nend\nif (host.starts_with?('[')) && (host.ends_with?(']'))\n  host = host.byte_slice(1, host.bytesize - 2)\nend\nnew(host, port)\n"}},{"html_id":"parse(uri:String):self-class-method","name":"parse","doc":"Parses a `Socket::IPAddress` from an URI.\n\nIt expects the URI to include `<scheme>://<host>:<port>` where `scheme` as\nwell as any additional URI components (such as `path` or `query`) are ignored.\n\n`host` must be an IP address (v4 or v6), otherwise `Socket::Error` will be\nraised. Domain names will not be resolved.\n\n```\nrequire \"socket\"\n\nSocket::IPAddress.parse(\"tcp://127.0.0.1:8080\") # => Socket::IPAddress.new(\"127.0.0.1\", 8080)\nSocket::IPAddress.parse(\"udp://[::1]:8080\")     # => Socket::IPAddress.new(\"::1\", 8080)\n```","summary":"<p>Parses a <code><a href=\"../Socket/IPAddress.html\">Socket::IPAddress</a></code> from an URI.</p>","abstract":false,"args":[{"name":"uri","external_name":"uri","restriction":"String"}],"args_string":"(uri : String) : self","args_html":"(uri : <a href=\"../String.html\">String</a>) : <span class=\"k\">self</span>","location":{"filename":"src/socket/address.cr","line_number":141,"url":null},"def":{"name":"parse","args":[{"name":"uri","external_name":"uri","restriction":"String"}],"return_type":"self","visibility":"Public","body":"parse(URI.parse(uri))"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"if family == other.family\nelse\n  return false\nend\nif port == other.port\nelse\n  return false\nend\nif address == other.address\nelse\n  return false\nend\ntrue\n"}},{"html_id":"address:String-instance-method","name":"address","doc":"Returns a `String` representation of the IP address.\n\nExample:\n```\nip_address = socket.remote_address\nip_address.address # => \"127.0.0.1\"\n```","summary":"<p>Returns a <code><a href=\"../String.html\">String</a></code> representation of the IP address.</p>","abstract":false,"location":{"filename":"src/socket/address.cr","line_number":184,"url":null},"def":{"name":"address","return_type":"String","visibility":"Public","body":"if (value = @address).nil?\n  @address = (address(@addr))\nelse\n  value\nend"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = family.hash(hasher)\nhasher = port.hash(hasher)\nhasher = address.hash(hasher)\nhasher\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends this struct's name and instance variables names and values\nto the given IO.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np1.to_s    # \"Point(@x=1, @y=2)\"\np1.inspect # \"Point(@x=1, @y=2)\"\n```","summary":"<p>Appends this struct's name and instance variables names and values to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/socket/address.cr","line_number":266,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"Socket::IPAddress(\"\nto_s(io)\nio << \")\"\n"}},{"html_id":"loopback?:Bool-instance-method","name":"loopback?","doc":"Returns `true` if this IP is a loopback address.\n\nIn the IPv4 family, loopback addresses are all addresses in the subnet\n`127.0.0.0/24`. In IPv6 `::1` is the loopback address.","summary":"<p>Returns <code>true</code> if this IP is a loopback address.</p>","abstract":false,"location":{"filename":"src/socket/address.cr","line_number":208,"url":null},"def":{"name":"loopback?","return_type":"Bool","visibility":"Public","body":"case addr = @addr\nin LibC::InAddr\n  (addr.s_addr & 255_u32) == 127_u32\nin LibC::In6Addr\n  (ipv6_addr8(addr)) == StaticArray[0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 1_u8]\nend"}},{"html_id":"port:Int32-instance-method","name":"port","abstract":false,"location":{"filename":"src/socket/address.cr","line_number":80,"url":null},"def":{"name":"port","return_type":"Int32","visibility":"Public","body":"@port"}},{"html_id":"pretty_print(pp)-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp)","args_html":"(pp)","location":{"filename":"src/socket/address.cr","line_number":272,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"visibility":"Public","body":"pp.text(inspect)"}},{"html_id":"private?:Bool-instance-method","name":"private?","doc":"Returns `true` if this IP is a private address.\n\nIPv4 addresses in `10.0.0.0/8`, `172.16.0.0/12` and `192.168.0.0/16` as defined in [RFC 1918](https://tools.ietf.org/html/rfc1918)\nand IPv6 Unique Local Addresses in `fc00::/7` as defined in [RFC 4193](https://tools.ietf.org/html/rfc4193) are considered private.","summary":"<p>Returns <code>true</code> if this IP is a private address.</p>","abstract":false,"location":{"filename":"src/socket/address.cr","line_number":231,"url":null},"def":{"name":"private?","return_type":"Bool","visibility":"Public","body":"case addr = @addr\nin LibC::InAddr\n  (((addr.s_addr & 255_u32) == 10_u32) || ((addr.s_addr & 61695_u32) == 4268_u32)) || ((addr.s_addr & 65535_u32) == 43200_u32)\nin LibC::In6Addr\n  ((ipv6_addr8(addr))[0] & 254_u8) == 252_u8\nend"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Same as `#inspect(io)`.","summary":"<p>Same as <code><a href=\"../Socket/IPAddress.html#inspect%28io%3AIO%29%3ANil-instance-method\">#inspect(io)</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/socket/address.cr","line_number":258,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"if family == Family::INET6\n  ((((io << '[') << address) << ']') << ':') << port\nelse\n  ((io << address) << ':') << port\nend"}},{"html_id":"to_unsafe:Pointer(LibC::Sockaddr)-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/socket/address.cr","line_number":276,"url":null},"def":{"name":"to_unsafe","return_type":"::Pointer(LibC::Sockaddr)","visibility":"Public","body":"case addr = @addr\nin LibC::InAddr\n  to_sockaddr_in(addr)\nin LibC::In6Addr\n  to_sockaddr_in6(addr)\nend"}},{"html_id":"unspecified?:Bool-instance-method","name":"unspecified?","doc":"Returns `true` if this IP is an unspecified address, either the IPv4 address `0.0.0.0` or the IPv6 address `::`.","summary":"<p>Returns <code>true</code> if this IP is an unspecified address, either the IPv4 address <code>0.0.0.0</code> or the IPv6 address <code>::</code>.</p>","abstract":false,"location":{"filename":"src/socket/address.cr","line_number":218,"url":null},"def":{"name":"unspecified?","return_type":"Bool","visibility":"Public","body":"case addr = @addr\nin LibC::InAddr\n  addr.s_addr == 0_u32\nin LibC::In6Addr\n  (ipv6_addr8(addr)) == StaticArray[0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8, 0_u8]\nend"}}]},{"html_id":"Crystal/Socket/Protocol","path":"Socket/Protocol.html","kind":"enum","full_name":"Socket::Protocol","name":"Protocol","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/common.cr","line_number":11,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"IP","name":"IP","value":"0"},{"id":"TCP","name":"TCP","value":"6"},{"id":"UDP","name":"UDP","value":"17"},{"id":"RAW","name":"RAW","value":"255"},{"id":"ICMP","name":"ICMP","value":"1"}],"namespace":{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"instance_methods":[{"html_id":"icmp?-instance-method","name":"icmp?","abstract":false,"location":{"filename":"src/socket/common.cr","line_number":13,"url":null},"def":{"name":"icmp?","visibility":"Public","body":"self == ICMP"}},{"html_id":"ip?-instance-method","name":"ip?","abstract":false,"location":{"filename":"src/socket/common.cr","line_number":12,"url":null},"def":{"name":"ip?","visibility":"Public","body":"self == IP"}},{"html_id":"raw?-instance-method","name":"raw?","abstract":false,"location":{"filename":"src/socket/common.cr","line_number":13,"url":null},"def":{"name":"raw?","visibility":"Public","body":"self == RAW"}},{"html_id":"tcp?-instance-method","name":"tcp?","abstract":false,"location":{"filename":"src/socket/common.cr","line_number":13,"url":null},"def":{"name":"tcp?","visibility":"Public","body":"self == TCP"}},{"html_id":"udp?-instance-method","name":"udp?","abstract":false,"location":{"filename":"src/socket/common.cr","line_number":13,"url":null},"def":{"name":"udp?","visibility":"Public","body":"self == UDP"}}]},{"html_id":"Crystal/Socket/Server","path":"Socket/Server.html","kind":"module","full_name":"Socket::Server","name":"Server","abstract":false,"locations":[{"filename":"src/socket/server.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"including_types":[{"html_id":"Crystal/OpenSSL/SSL/Server","kind":"class","full_name":"OpenSSL::SSL::Server","name":"Server"},{"html_id":"Crystal/TCPServer","kind":"class","full_name":"TCPServer","name":"TCPServer"},{"html_id":"Crystal/UNIXServer","kind":"class","full_name":"UNIXServer","name":"UNIXServer"}],"namespace":{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"instance_methods":[{"html_id":"accept:IO-instance-method","name":"accept","doc":"Accepts an incoming connection and returns the client socket.\n\n```\nrequire \"socket\"\n\nserver = TCPServer.new(2202)\nwhile true\n  socket = server.accept\n  socket.puts Time.utc\n  socket.close\nend\n```\n\nIf the server is closed after invoking this method, an `IO::Error` (closed stream) exception must be raised.","summary":"<p>Accepts an incoming connection and returns the client socket.</p>","abstract":true,"location":{"filename":"src/socket/server.cr","line_number":17,"url":null},"def":{"name":"accept","return_type":"IO","visibility":"Public","body":""}},{"html_id":"accept(&)-instance-method","name":"accept","doc":"Accepts an incoming connection and yields the client socket to the block.\nEventually closes the connection when the block returns.\n\nReturns the value of the block. If the server is closed after invoking this\nmethod, an `IO::Error` (closed stream) exception will be raised.\n\n```\nrequire \"socket\"\n\nserver = TCPServer.new(2202)\nserver.accept do |socket|\n  socket.puts Time.utc\nend\n```","summary":"<p>Accepts an incoming connection and yields the client socket to the block.</p>","abstract":false,"location":{"filename":"src/socket/server.cr","line_number":48,"url":null},"def":{"name":"accept","yields":1,"visibility":"Public","body":"sock = accept\nbegin\n  yield sock\nensure\n  sock.close\nend\n"}},{"html_id":"accept?:IO?-instance-method","name":"accept?","doc":"Accepts an incoming connection and returns the client socket.\n\nReturns `nil` if the server is closed after invoking this method.\n\n```\nrequire \"socket\"\n\nserver = TCPServer.new(2202)\nwhile socket = server.accept?\n  socket.puts Time.utc\n  socket.close\nend\n```","summary":"<p>Accepts an incoming connection and returns the client socket.</p>","abstract":true,"location":{"filename":"src/socket/server.cr","line_number":32,"url":null},"def":{"name":"accept?","return_type":"IO | ::Nil","visibility":"Public","body":""}},{"html_id":"accept?(&)-instance-method","name":"accept?","doc":"Accepts an incoming connection and yields the client socket to the block.\nEventually closes the connection when the block returns.\n\nReturns the value of the block or `nil` if the server is closed after\ninvoking this method.\n\n```\nrequire \"socket\"\n\nserver = UNIXServer.new(\"/tmp/service.sock\")\nserver.accept? do |socket|\n  socket.puts Time.utc\nend\n```","summary":"<p>Accepts an incoming connection and yields the client socket to the block.</p>","abstract":false,"location":{"filename":"src/socket/server.cr","line_number":71,"url":null},"def":{"name":"accept?","yields":1,"visibility":"Public","body":"sock = accept?\nif sock\nelse\n  return\nend\nbegin\n  yield sock\nensure\n  sock.close\nend\n"}}]},{"html_id":"Crystal/Socket/Type","path":"Socket/Type.html","kind":"enum","full_name":"Socket::Type","name":"Type","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/common.cr","line_number":40,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"STREAM","name":"STREAM","value":"1"},{"id":"DGRAM","name":"DGRAM","value":"2"},{"id":"RAW","name":"RAW","value":"3"},{"id":"SEQPACKET","name":"SEQPACKET","value":"5"}],"namespace":{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"instance_methods":[{"html_id":"dgram?-instance-method","name":"dgram?","abstract":false,"location":{"filename":"src/socket/common.cr","line_number":42,"url":null},"def":{"name":"dgram?","visibility":"Public","body":"self == DGRAM"}},{"html_id":"raw?-instance-method","name":"raw?","abstract":false,"location":{"filename":"src/socket/common.cr","line_number":43,"url":null},"def":{"name":"raw?","visibility":"Public","body":"self == RAW"}},{"html_id":"seqpacket?-instance-method","name":"seqpacket?","abstract":false,"location":{"filename":"src/socket/common.cr","line_number":44,"url":null},"def":{"name":"seqpacket?","visibility":"Public","body":"self == SEQPACKET"}},{"html_id":"stream?-instance-method","name":"stream?","abstract":false,"location":{"filename":"src/socket/common.cr","line_number":41,"url":null},"def":{"name":"stream?","visibility":"Public","body":"self == STREAM"}}]},{"html_id":"Crystal/Socket/UNIXAddress","path":"Socket/UNIXAddress.html","kind":"struct","full_name":"Socket::UNIXAddress","name":"UNIXAddress","abstract":false,"superclass":{"html_id":"Crystal/Socket/Address","kind":"struct","full_name":"Socket::Address","name":"Address"},"ancestors":[{"html_id":"Crystal/Socket/Address","kind":"struct","full_name":"Socket::Address","name":"Address"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/address.cr","line_number":328,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"doc":"UNIX address representation.\n\nHolds the local path of an UNIX address, usually coming from an opened\nconnection (e.g. `Socket#local_address`, `Socket#receive`).\n\nExample:\n```\nrequire \"socket\"\n\nSocket::UNIXAddress.new(\"/tmp/my.sock\")\n```","summary":"<p>UNIX address representation.</p>","constructors":[{"html_id":"from(sockaddr:Pointer(LibC::Sockaddr),addrlen):UNIXAddress-class-method","name":"from","doc":"Creates an `UNIXSocket` from the internal OS representation.","summary":"<p>Creates an <code><a href=\"../UNIXSocket.html\">UNIXSocket</a></code> from the internal OS representation.</p>","abstract":false,"args":[{"name":"sockaddr","external_name":"sockaddr","restriction":"::Pointer(LibC::Sockaddr)"},{"name":"addrlen","external_name":"addrlen","restriction":""}],"args_string":"(sockaddr : Pointer(LibC::Sockaddr), addrlen) : UNIXAddress","args_html":"(sockaddr : <a href=\"../Pointer.html\">Pointer</a>(LibC::Sockaddr), addrlen) : <a href=\"../Socket/UNIXAddress.html\">UNIXAddress</a>","location":{"filename":"src/socket/address.cr","line_number":343,"url":null},"def":{"name":"from","args":[{"name":"sockaddr","external_name":"sockaddr","restriction":"::Pointer(LibC::Sockaddr)"},{"name":"addrlen","external_name":"addrlen","restriction":""}],"return_type":"UNIXAddress","visibility":"Public","body":"new(sockaddr.as(::Pointer(LibC::SockaddrUn)), addrlen.to_i)"}},{"html_id":"new(path:String)-class-method","name":"new","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"String"}],"args_string":"(path : String)","args_html":"(path : <a href=\"../String.html\">String</a>)","location":{"filename":"src/socket/address.cr","line_number":334,"url":null},"def":{"name":"new","args":[{"name":"path","external_name":"path","restriction":"String"}],"visibility":"Public","body":"_ = allocate\n_.initialize(path)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"parse(uri:URI):UNIXAddress-class-method","name":"parse","doc":"Parses a `Socket::UNIXAddress` from an URI.\n\nIt expects the URI to include `<scheme>://<path>` where `scheme` as well\nas any additional URI components (such as `fragment` or `query`) are ignored.\n\nIf `host` is not empty, it will be prepended to `path` to form a relative\npath.\n\n```\nrequire \"socket\"\n\nSocket::UNIXAddress.parse(\"unix:///foo.sock\") # => Socket::UNIXAddress.new(\"/foo.sock\")\nSocket::UNIXAddress.parse(\"unix://foo.sock\")  # => Socket::UNIXAddress.new(\"foo.sock\")\n```","summary":"<p>Parses a <code><a href=\"../Socket/UNIXAddress.html\">Socket::UNIXAddress</a></code> from an URI.</p>","abstract":false,"args":[{"name":"uri","external_name":"uri","restriction":"URI"}],"args_string":"(uri : URI) : UNIXAddress","args_html":"(uri : <a href=\"../URI.html\">URI</a>) : <a href=\"../Socket/UNIXAddress.html\">UNIXAddress</a>","location":{"filename":"src/socket/address.cr","line_number":361,"url":null},"def":{"name":"parse","args":[{"name":"uri","external_name":"uri","restriction":"URI"}],"return_type":"UNIXAddress","visibility":"Public","body":"unix_path = String.build do |io|\n  io << uri.host\n  if port = uri.port\n    (io << ':') << port\n  end\n  if path = uri.path.presence\n    io << path\n  end\nend\nif unix_path.empty?\n  raise(Socket::Error.new(\"Invalid UNIX address: missing path\"))\nend\n{% if flag?(:unix) %}\n        UNIXAddress.new(unix_path)\n      {% else %}\n        raise NotImplementedError.new(\"UNIX address not available\")\n      {% end %}\n"}},{"html_id":"parse(uri:String):self-class-method","name":"parse","doc":"Parses a `Socket::UNIXAddress` from an URI.\n\nIt expects the URI to include `<scheme>://<path>` where `scheme` as well\nas any additional URI components (such as `fragment` or `query`) are ignored.\n\nIf `host` is not empty, it will be prepended to `path` to form a relative\npath.\n\n```\nrequire \"socket\"\n\nSocket::UNIXAddress.parse(\"unix:///foo.sock\") # => Socket::UNIXAddress.new(\"/foo.sock\")\nSocket::UNIXAddress.parse(\"unix://foo.sock\")  # => Socket::UNIXAddress.new(\"foo.sock\")\n```","summary":"<p>Parses a <code><a href=\"../Socket/UNIXAddress.html\">Socket::UNIXAddress</a></code> from an URI.</p>","abstract":false,"args":[{"name":"uri","external_name":"uri","restriction":"String"}],"args_string":"(uri : String) : self","args_html":"(uri : <a href=\"../String.html\">String</a>) : <span class=\"k\">self</span>","location":{"filename":"src/socket/address.cr","line_number":382,"url":null},"def":{"name":"parse","args":[{"name":"uri","external_name":"uri","restriction":"String"}],"return_type":"self","visibility":"Public","body":"parse(URI.parse(uri))"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"if path == other.path\nelse\n  return false\nend\ntrue\n"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = path.hash(hasher)\nhasher\n"}},{"html_id":"path:String-instance-method","name":"path","abstract":false,"location":{"filename":"src/socket/address.cr","line_number":329,"url":null},"def":{"name":"path","return_type":"String","visibility":"Public","body":"@path"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Same as `#inspect(io)`.","summary":"<p>Same as <code>#inspect(io)</code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/socket/address.cr","line_number":394,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << path"}},{"html_id":"to_unsafe:Pointer(LibC::Sockaddr)-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/socket/address.cr","line_number":398,"url":null},"def":{"name":"to_unsafe","return_type":"::Pointer(LibC::Sockaddr)","visibility":"Public","body":"sockaddr = Pointer(LibC::SockaddrUn).malloc\nsockaddr.value.sun_family = family\nsockaddr.value.sun_path.to_unsafe.copy_from(@path.to_unsafe, @path.bytesize + 1)\nsockaddr.as(::Pointer(LibC::Sockaddr))\n"}}]}]},{"html_id":"Crystal/Spec","path":"Spec.html","kind":"module","full_name":"Spec","name":"Spec","abstract":false,"locations":[{"filename":"src/spec/cli.cr","line_number":6,"url":null},{"filename":"src/spec/context.cr","line_number":3,"url":null},{"filename":"src/spec/dsl.cr","line_number":4,"url":null},{"filename":"src/spec/example.cr","line_number":3,"url":null},{"filename":"src/spec/example/procsy.cr","line_number":1,"url":null},{"filename":"src/spec/example_group/procsy.cr","line_number":1,"url":null},{"filename":"src/spec/expectations.cr","line_number":1,"url":null},{"filename":"src/spec/filters.cr","line_number":5,"url":null},{"filename":"src/spec/formatter.cr","line_number":1,"url":null},{"filename":"src/spec/item.cr","line_number":1,"url":null},{"filename":"src/spec/junit_formatter.cr","line_number":3,"url":null},{"filename":"src/spec/source.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"class_methods":[{"html_id":"add_formatter(formatter)-class-method","name":"add_formatter","abstract":false,"args":[{"name":"formatter","external_name":"formatter","restriction":""}],"args_string":"(formatter)","args_html":"(formatter)","location":{"filename":"src/spec/formatter.cr","line_number":129,"url":null},"def":{"name":"add_formatter","args":[{"name":"formatter","external_name":"formatter","restriction":""}],"visibility":"Public","body":"@@formatters << formatter"}},{"html_id":"add_split_filter(filter)-class-method","name":"add_split_filter","abstract":false,"args":[{"name":"filter","external_name":"filter","restriction":""}],"args_string":"(filter)","args_html":"(filter)","location":{"filename":"src/spec/dsl.cr","line_number":105,"url":null},"def":{"name":"add_split_filter","args":[{"name":"filter","external_name":"filter","restriction":""}],"visibility":"Public","body":"if filter\n  r, m = (filter.split('%')).map(&.to_i)\n  @@split_filter = SplitFilter.new(remainder: r, quotient: m)\nelse\n  @@split_filter = nil\nend"}},{"html_id":"after_each(&block)-class-method","name":"after_each","doc":"Instructs the spec runner to execute the given block\nafter each spec spec in the spec suite.\n\nIf multiple blocks are registered they run in the reversed\norder that they are given.\n\nFor example:\n\n```\nSpec.after_each { puts 1 }\nSpec.after_each { puts 2 }\n```\n\nwill print, just after each spec, 2 and then 1.","summary":"<p>Instructs the spec runner to execute the given block after each spec spec in the spec suite.</p>","abstract":false,"location":{"filename":"src/spec/dsl.cr","line_number":146,"url":null},"def":{"name":"after_each","yields":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"root_context.after_each(&block)"}},{"html_id":"after_suite(&block)-class-method","name":"after_suite","doc":"Instructs the spec runner to execute the given block\nafter the entire spec suite.\n\nIf multiple blocks are registered they run in the reversed\norder that they are given.\n\nFor example:\n\n```\nSpec.after_suite { puts 1 }\nSpec.after_suite { puts 2 }\n```\n\nwill print, just after the spec suite ends, 2 and then 1.","summary":"<p>Instructs the spec runner to execute the given block after the entire spec suite.</p>","abstract":false,"location":{"filename":"src/spec/dsl.cr","line_number":182,"url":null},"def":{"name":"after_suite","yields":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"root_context.after_all(&block)"}},{"html_id":"around_each(&block:Example::Procsy->)-class-method","name":"around_each","doc":"Instructs the spec runner to execute the given block when each spec in the\nspec suite runs.\n\nThe block must call `run` on the given `Example::Procsy` object.\n\nIf multiple blocks are registered they run in the reversed\norder that they are given.\n\n```\nrequire \"spec\"\n\nSpec.around_each do |example|\n  puts \"runs before each sample\"\n  example.run\n  puts \"runs after each sample\"\nend\n\nit { }\nit { }\n```","summary":"<p>Instructs the spec runner to execute the given block when each spec in the spec suite runs.</p>","abstract":false,"location":{"filename":"src/spec/dsl.cr","line_number":206,"url":null},"def":{"name":"around_each","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(Example::Procsy ->)"},"visibility":"Public","body":"root_context.around_each(&block)"}},{"html_id":"before_each(&block)-class-method","name":"before_each","doc":"Instructs the spec runner to execute the given block\nbefore each spec in the spec suite.\n\nIf multiple blocks are registered they run in the order\nthat they are given.\n\nFor example:\n\n```\nSpec.before_each { puts 1 }\nSpec.before_each { puts 2 }\n```\n\nwill print, just before each spec, 1 and then 2.","summary":"<p>Instructs the spec runner to execute the given block before each spec in the spec suite.</p>","abstract":false,"location":{"filename":"src/spec/dsl.cr","line_number":128,"url":null},"def":{"name":"before_each","yields":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"root_context.before_each(&block)"}},{"html_id":"before_suite(&block)-class-method","name":"before_suite","doc":"Instructs the spec runner to execute the given block\nbefore the entire spec suite.\n\nIf multiple blocks are registered they run in the order\nthat they are given.\n\nFor example:\n\n```\nSpec.before_suite { puts 1 }\nSpec.before_suite { puts 2 }\n```\n\nwill print, just before the spec suite starts, 1 and then 2.","summary":"<p>Instructs the spec runner to execute the given block before the entire spec suite.</p>","abstract":false,"location":{"filename":"src/spec/dsl.cr","line_number":164,"url":null},"def":{"name":"before_suite","yields":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"root_context.before_all(&block)"}},{"html_id":"finish_run-class-method","name":"finish_run","abstract":false,"location":{"filename":"src/spec/dsl.cr","line_number":259,"url":null},"def":{"name":"finish_run","visibility":"Public","body":"elapsed_time = Time.monotonic - @@start_time.not_nil!\nroot_context.finish(elapsed_time, @@aborted)\nif (!root_context.succeeded) || @@aborted\n  exit(1)\nend\n"}},{"html_id":"override_default_formatter(formatter)-class-method","name":"override_default_formatter","abstract":false,"args":[{"name":"formatter","external_name":"formatter","restriction":""}],"args_string":"(formatter)","args_html":"(formatter)","location":{"filename":"src/spec/formatter.cr","line_number":125,"url":null},"def":{"name":"override_default_formatter","args":[{"name":"formatter","external_name":"formatter","restriction":""}],"visibility":"Public","body":"@@formatters[0] = formatter"}},{"html_id":"randomizer:Random::PCG32?-class-method","name":"randomizer","abstract":false,"location":{"filename":"src/spec/cli.cr","line_number":43,"url":null},"def":{"name":"randomizer","return_type":"Random::PCG32 | ::Nil","visibility":"Public","body":"@@randomizer"}}],"types":[{"html_id":"Crystal/Spec/Context","path":"Spec/Context.html","kind":"class","full_name":"Spec::Context","name":"Context","abstract":true,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/spec/context.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/Spec/ExampleGroup","kind":"class","full_name":"Spec::ExampleGroup","name":"ExampleGroup"}],"namespace":{"html_id":"Crystal/Spec","kind":"module","full_name":"Spec","name":"Spec"},"doc":"Base type for `ExampleGroup`.","summary":"<p>Base type for <code><a href=\"../Spec/ExampleGroup.html\">ExampleGroup</a></code>.</p>","instance_methods":[{"html_id":"children:Array(Spec::Example|Spec::ExampleGroup)-instance-method","name":"children","doc":"All the children, which can be `describe`/`context` or `it`","summary":"<p>All the children, which can be <code>describe</code>/<code>context</code> or <code>it</code></p>","abstract":false,"location":{"filename":"src/spec/context.cr","line_number":7,"url":null},"def":{"name":"children","visibility":"Public","body":"@children"}},{"html_id":"randomize(randomizer)-instance-method","name":"randomize","abstract":false,"args":[{"name":"randomizer","external_name":"randomizer","restriction":""}],"args_string":"(randomizer)","args_html":"(randomizer)","location":{"filename":"src/spec/context.cr","line_number":9,"url":null},"def":{"name":"randomize","args":[{"name":"randomizer","external_name":"randomizer","restriction":""}],"visibility":"Public","body":"children.each do |child|\n  if child.is_a?(ExampleGroup)\n    child.randomize(randomizer)\n  end\nend\nchildren.shuffle!(randomizer)\n"}}]},{"html_id":"Crystal/Spec/Example","path":"Spec/Example.html","kind":"class","full_name":"Spec::Example","name":"Example","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Spec/Item","kind":"module","full_name":"Spec::Item","name":"Item"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/spec/example.cr","line_number":5,"url":null},{"filename":"src/spec/example/procsy.cr","line_number":2,"url":null},{"filename":"src/spec/filters.cr","line_number":179,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Spec/Item","kind":"module","full_name":"Spec::Item","name":"Item"}],"namespace":{"html_id":"Crystal/Spec","kind":"module","full_name":"Spec","name":"Spec"},"doc":"Each example (`it`) in a spec suite.","summary":"<p>Each example (<code>it</code>) in a spec suite.</p>","types":[{"html_id":"Crystal/Spec/Example/Procsy","path":"Spec/Example/Procsy.html","kind":"struct","full_name":"Spec::Example::Procsy","name":"Procsy","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/spec/example/procsy.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Spec/Example","kind":"class","full_name":"Spec::Example","name":"Example"},"doc":"Wraps an `Example` and a `Proc` that will eventually execute the\nexample.","summary":"<p>Wraps an <code><a href=\"../../Spec/Example.html\">Example</a></code> and a <code><a href=\"../../Proc.html\">Proc</a></code> that will eventually execute the example.</p>","instance_methods":[{"html_id":"example:Example-instance-method","name":"example","doc":"The example that will eventually run when calling `run`.","summary":"<p>The example that will eventually run when calling <code><a href=\"../../Spec/Example/Procsy.html#run-instance-method\">#run</a></code>.</p>","abstract":false,"location":{"filename":"src/spec/example/procsy.cr","line_number":7,"url":null},"def":{"name":"example","return_type":"Example","visibility":"Public","body":"@example"}},{"html_id":"run-instance-method","name":"run","doc":"Executes the wrapped example, possibly executing other\n`around_each` hooks before that.","summary":"<p>Executes the wrapped example, possibly executing other <code>around_each</code> hooks before that.</p>","abstract":false,"location":{"filename":"src/spec/example/procsy.cr","line_number":15,"url":null},"def":{"name":"run","visibility":"Public","body":"@proc.call"}}]}]},{"html_id":"Crystal/Spec/ExampleGroup","path":"Spec/ExampleGroup.html","kind":"class","full_name":"Spec::ExampleGroup","name":"ExampleGroup","abstract":false,"superclass":{"html_id":"Crystal/Spec/Context","kind":"class","full_name":"Spec::Context","name":"Context"},"ancestors":[{"html_id":"Crystal/Spec/Item","kind":"module","full_name":"Spec::Item","name":"Item"},{"html_id":"Crystal/Spec/Context","kind":"class","full_name":"Spec::Context","name":"Context"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/spec/context.cr","line_number":323,"url":null},{"filename":"src/spec/example_group/procsy.cr","line_number":2,"url":null},{"filename":"src/spec/filters.cr","line_number":81,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Spec/Item","kind":"module","full_name":"Spec::Item","name":"Item"}],"namespace":{"html_id":"Crystal/Spec","kind":"module","full_name":"Spec","name":"Spec"},"doc":"Represents a `describe` or `context`.","summary":"<p>Represents a <code>describe</code> or <code>context</code>.</p>","constructors":[{"html_id":"new(parent:Context,description:String,file:String,line:Int32,end_line:Int32,focus:Bool,tags)-class-method","name":"new","abstract":false,"args":[{"name":"parent","external_name":"parent","restriction":"Context"},{"name":"description","external_name":"description","restriction":"String"},{"name":"file","external_name":"file","restriction":"String"},{"name":"line","external_name":"line","restriction":"Int32"},{"name":"end_line","external_name":"end_line","restriction":"Int32"},{"name":"focus","external_name":"focus","restriction":"Bool"},{"name":"tags","external_name":"tags","restriction":""}],"args_string":"(parent : Context, description : String, file : String, line : Int32, end_line : Int32, focus : Bool, tags)","args_html":"(parent : <a href=\"../Spec/Context.html\">Context</a>, description : <a href=\"../String.html\">String</a>, file : <a href=\"../String.html\">String</a>, line : <a href=\"../Int32.html\">Int32</a>, end_line : <a href=\"../Int32.html\">Int32</a>, focus : <a href=\"../Bool.html\">Bool</a>, tags)","location":{"filename":"src/spec/context.cr","line_number":326,"url":null},"def":{"name":"new","args":[{"name":"parent","external_name":"parent","restriction":"Context"},{"name":"description","external_name":"description","restriction":"String"},{"name":"file","external_name":"file","restriction":"String"},{"name":"line","external_name":"line","restriction":"Int32"},{"name":"end_line","external_name":"end_line","restriction":"Int32"},{"name":"focus","external_name":"focus","restriction":"Bool"},{"name":"tags","external_name":"tags","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(parent, description, file, line, end_line, focus, tags)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"types":[{"html_id":"Crystal/Spec/ExampleGroup/Procsy","path":"Spec/ExampleGroup/Procsy.html","kind":"struct","full_name":"Spec::ExampleGroup::Procsy","name":"Procsy","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/spec/example_group/procsy.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Spec/ExampleGroup","kind":"class","full_name":"Spec::ExampleGroup","name":"ExampleGroup"},"doc":"Wraps an `ExampleGroup` and a `Proc` that will eventually execute the\ngroup.","summary":"<p>Wraps an <code><a href=\"../../Spec/ExampleGroup.html\">ExampleGroup</a></code> and a <code><a href=\"../../Proc.html\">Proc</a></code> that will eventually execute the group.</p>","instance_methods":[{"html_id":"example_group:ExampleGroup-instance-method","name":"example_group","doc":"The group that will eventually run when calling `run`.","summary":"<p>The group that will eventually run when calling <code><a href=\"../../Spec/ExampleGroup/Procsy.html#run-instance-method\">#run</a></code>.</p>","abstract":false,"location":{"filename":"src/spec/example_group/procsy.cr","line_number":7,"url":null},"def":{"name":"example_group","return_type":"ExampleGroup","visibility":"Public","body":"@example_group"}},{"html_id":"run-instance-method","name":"run","doc":"Executes the wrapped example group, possibly executing other\n`around_all` hooks before that.","summary":"<p>Executes the wrapped example group, possibly executing other <code>around_all</code> hooks before that.</p>","abstract":false,"location":{"filename":"src/spec/example_group/procsy.cr","line_number":15,"url":null},"def":{"name":"run","visibility":"Public","body":"@proc.call"}}]}]},{"html_id":"Crystal/Spec/Expectations","path":"Spec/Expectations.html","kind":"module","full_name":"Spec::Expectations","name":"Expectations","abstract":false,"locations":[{"filename":"src/spec/expectations.cr","line_number":295,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Spec","kind":"module","full_name":"Spec","name":"Spec"},"doc":"This module defines a number of methods to create expectations, which are\nautomatically included into the top level namespace.\n\nExpectations are used by `Spec::ObjectExtensions#should` and `Spec::ObjectExtensions#should_not`.","summary":"<p>This module defines a number of methods to create expectations, which are automatically included into the top level namespace.</p>","instance_methods":[{"html_id":"be(value)-instance-method","name":"be","doc":"Creates an `Expectation` that passes if actual and *value* are identical (`.same?`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual and <em>value</em> are identical (<code>.same?</code>).</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/spec/expectations.cr","line_number":302,"url":null},"def":{"name":"be","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"Spec::BeExpectation.new(value)"}},{"html_id":"be-instance-method","name":"be","doc":"Returns a factory to create a comparison `Expectation` that:\n\n* passes if actual is lesser than *value*: `be < value`\n* passes if actual is lesser than or equal *value*: `be <= value`\n* passes if actual is greater than *value*: `be > value`\n* passes if actual is greater than or equal *value*: `be >= value`","summary":"<p>Returns a factory to create a comparison <code>Expectation</code> that:</p>","abstract":false,"location":{"filename":"src/spec/expectations.cr","line_number":342,"url":null},"def":{"name":"be","visibility":"Public","body":"Spec::Be"}},{"html_id":"be_close(expected,delta)-instance-method","name":"be_close","doc":"Creates an `Expectation` that passes if actual is within *delta* of *expected*.","summary":"<p>Creates an <code>Expectation</code> that passes if actual is within <em>delta</em> of <em>expected</em>.</p>","abstract":false,"args":[{"name":"expected","external_name":"expected","restriction":""},{"name":"delta","external_name":"delta","restriction":""}],"args_string":"(expected, delta)","args_html":"(expected, delta)","location":{"filename":"src/spec/expectations.cr","line_number":332,"url":null},"def":{"name":"be_close","args":[{"name":"expected","external_name":"expected","restriction":""},{"name":"delta","external_name":"delta","restriction":""}],"visibility":"Public","body":"Spec::CloseExpectation.new(expected, delta)"}},{"html_id":"be_empty-instance-method","name":"be_empty","doc":"Creates an `Expectation` that passes if actual is empty (`.empty?`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual is empty (<code>.empty?</code>).</p>","abstract":false,"location":{"filename":"src/spec/expectations.cr","line_number":370,"url":null},"def":{"name":"be_empty","visibility":"Public","body":"Spec::BeEmptyExpectation.new"}},{"html_id":"be_false-instance-method","name":"be_false","doc":"Creates an `Expectation` that passes if actual is false (`== false`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual is false (<code>== false</code>).</p>","abstract":false,"location":{"filename":"src/spec/expectations.cr","line_number":312,"url":null},"def":{"name":"be_false","visibility":"Public","body":"eq(false)"}},{"html_id":"be_falsey-instance-method","name":"be_falsey","doc":"Creates an `Expectation` that passes if actual is falsy (`nil` or `false`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual is falsy (<code>nil</code> or <code>false</code>).</p>","abstract":false,"location":{"filename":"src/spec/expectations.cr","line_number":322,"url":null},"def":{"name":"be_falsey","visibility":"Public","body":"Spec::BeFalseyExpectation.new"}},{"html_id":"be_nil-instance-method","name":"be_nil","doc":"Creates an `Expectation` that passes if actual is nil (`== nil`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual is nil (<code>== nil</code>).</p>","abstract":false,"location":{"filename":"src/spec/expectations.cr","line_number":327,"url":null},"def":{"name":"be_nil","visibility":"Public","body":"Spec::BeNilExpectation.new"}},{"html_id":"be_true-instance-method","name":"be_true","doc":"Creates an `Expectation` that passes if actual is true (`== true`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual is true (<code>== true</code>).</p>","abstract":false,"location":{"filename":"src/spec/expectations.cr","line_number":307,"url":null},"def":{"name":"be_true","visibility":"Public","body":"eq(true)"}},{"html_id":"be_truthy-instance-method","name":"be_truthy","doc":"Creates an `Expectation` that passes if actual is truthy (neither `nil` nor `false`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual is truthy (neither <code>nil</code> nor <code>false</code>).</p>","abstract":false,"location":{"filename":"src/spec/expectations.cr","line_number":317,"url":null},"def":{"name":"be_truthy","visibility":"Public","body":"Spec::BeTruthyExpectation.new"}},{"html_id":"contain(expected)-instance-method","name":"contain","doc":"Creates an `Expectation` that passes if actual includes *expected* (`.includes?`).\nWorks on collections and `String`.","summary":"<p>Creates an <code>Expectation</code> that passes if actual includes <em>expected</em> (<code>.includes?</code>).</p>","abstract":false,"args":[{"name":"expected","external_name":"expected","restriction":""}],"args_string":"(expected)","args_html":"(expected)","location":{"filename":"src/spec/expectations.cr","line_number":353,"url":null},"def":{"name":"contain","args":[{"name":"expected","external_name":"expected","restriction":""}],"visibility":"Public","body":"Spec::ContainExpectation.new(expected)"}},{"html_id":"end_with(expected)-instance-method","name":"end_with","doc":"Creates an `Expectation` that passes if actual ends with *expected* (`.ends_with?`).\nWorks on `String`.","summary":"<p>Creates an <code>Expectation</code> that passes if actual ends with <em>expected</em> (<code>.ends_with?</code>).</p>","abstract":false,"args":[{"name":"expected","external_name":"expected","restriction":""}],"args_string":"(expected)","args_html":"(expected)","location":{"filename":"src/spec/expectations.cr","line_number":365,"url":null},"def":{"name":"end_with","args":[{"name":"expected","external_name":"expected","restriction":""}],"visibility":"Public","body":"Spec::EndWithExpectation.new(expected)"}},{"html_id":"eq(value)-instance-method","name":"eq","doc":"Creates an `Expectation` that passes if actual equals *value* (`==`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual equals <em>value</em> (<code>==</code>).</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/spec/expectations.cr","line_number":297,"url":null},"def":{"name":"eq","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"Spec::EqualExpectation.new(value)"}},{"html_id":"expect_raises(klass:T.class,message:String|Regex|Nil=nil,file=__FILE__,line=__LINE__,&)forallT-instance-method","name":"expect_raises","doc":"Runs the block and passes if it raises an exception of type *klass* and the error message matches.\n\nIf *message* is a string, it matches if the exception's error message contains that string.\nIf *message* is a regular expression, it is used to match the error message.\n\nIt returns the rescued exception.","summary":"<p>Runs the block and passes if it raises an exception of type <em>klass</em> and the error message matches.</p>","abstract":false,"args":[{"name":"klass","external_name":"klass","restriction":"T.class"},{"name":"message","default_value":"nil","external_name":"message","restriction":"String | Regex | Nil"},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(klass : T.class, message : String | Regex | Nil = nil, file = __FILE__, line = __LINE__, &) forall T","args_html":"(klass : <span class=\"t\">T</span>.<span class=\"k\">class</span>, message : <a href=\"../String.html\">String</a> | <a href=\"../Regex.html\">Regex</a> | <a href=\"../Nil.html\">Nil</a> = <span class=\"n\">nil</span>, file = __FILE__, line = __LINE__, &) forall T","location":{"filename":"src/spec/expectations.cr","line_number":385,"url":null},"def":{"name":"expect_raises","args":[{"name":"klass","external_name":"klass","restriction":"T.class"},{"name":"message","default_value":"nil","external_name":"message","restriction":"String | Regex | Nil"},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"yields":0,"visibility":"Public","body":"begin\n  yield\nrescue ex : T\n  if ex.is_a?(Spec::AssertionFailed) && (klass != Spec::AssertionFailed)\n    raise(ex)\n  end\n  if ex.is_a?(Spec::NestingSpecError) && (klass != Spec::NestingSpecError)\n    raise(ex)\n  end\n  ex_to_s = ex.to_s\n  case message\n  when Regex\n    if (    ex_to_s =~ message)\n    else\n      backtrace = ex.backtrace.join('\\n') do |f|\n        \"  # #{f}\"\n      end\n      fail(\"Expected #{klass} with message matching #{message.inspect}, got #<#{ex.class}: #{ex_to_s}> with backtrace:\\n#{backtrace}\", file, line)\n    end\n  when String\n    if ex_to_s.includes?(message)\n    else\n      backtrace = ex.backtrace.join('\\n') do |f|\n        \"  # #{f}\"\n      end\n      fail(\"Expected #{klass} with #{message.inspect}, got #<#{ex.class}: #{ex_to_s}> with backtrace:\\n#{backtrace}\", file, line)\n    end\n  when Nil\n  end\n  ex\nrescue ex\n  backtrace = ex.backtrace.join('\\n') do |f|\n    \"  # #{f}\"\n  end\n  fail(\"Expected #{klass}, got #<#{ex.class}: #{ex}> with backtrace:\\n#{backtrace}\", file, line)\nelse\n  fail(\"Expected #{klass} but nothing was raised\", file, line)\nend"}},{"html_id":"match(value)-instance-method","name":"match","doc":"Creates an `Expectation` that passes if actual matches *value* (`=~`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual matches <em>value</em> (<code>=~</code>).</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value)","args_html":"(value)","location":{"filename":"src/spec/expectations.cr","line_number":347,"url":null},"def":{"name":"match","args":[{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"Spec::MatchExpectation.new(value)"}},{"html_id":"start_with(expected)-instance-method","name":"start_with","doc":"Creates an `Expectation` that passes if actual starts with *expected* (`.starts_with?`).\nWorks on `String`.","summary":"<p>Creates an <code>Expectation</code> that passes if actual starts with <em>expected</em> (<code>.starts_with?</code>).</p>","abstract":false,"args":[{"name":"expected","external_name":"expected","restriction":""}],"args_string":"(expected)","args_html":"(expected)","location":{"filename":"src/spec/expectations.cr","line_number":359,"url":null},"def":{"name":"start_with","args":[{"name":"expected","external_name":"expected","restriction":""}],"visibility":"Public","body":"Spec::StartWithExpectation.new(expected)"}}],"macros":[{"html_id":"be_a(type)-macro","name":"be_a","doc":"Creates an `Expectation` that passes if actual is of type *type* (`is_a?`).","summary":"<p>Creates an <code>Expectation</code> that passes if actual is of type <em>type</em> (<code>is_a?</code>).</p>","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""}],"args_string":"(type)","args_html":"(type)","location":{"filename":"src/spec/expectations.cr","line_number":375,"url":null},"def":{"name":"be_a","args":[{"name":"type","external_name":"type","restriction":""}],"visibility":"Public","body":"      ::Spec::BeAExpectation(\n{{ type }}\n).new\n    \n"}}]},{"html_id":"Crystal/Spec/Item","path":"Spec/Item.html","kind":"module","full_name":"Spec::Item","name":"Item","abstract":false,"locations":[{"filename":"src/spec/filters.cr","line_number":6,"url":null},{"filename":"src/spec/item.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"including_types":[{"html_id":"Crystal/Spec/Example","kind":"class","full_name":"Spec::Example","name":"Example"},{"html_id":"Crystal/Spec/ExampleGroup","kind":"class","full_name":"Spec::ExampleGroup","name":"ExampleGroup"}],"namespace":{"html_id":"Crystal/Spec","kind":"module","full_name":"Spec","name":"Spec"},"doc":"Info that `describe`, `context` and `it` all have in common.","summary":"<p>Info that <code>describe</code>, <code>context</code> and <code>it</code> all have in common.</p>","instance_methods":[{"html_id":"description:String-instance-method","name":"description","doc":"The example or example group's description.","summary":"<p>The example or example group's description.</p>","abstract":false,"location":{"filename":"src/spec/item.cr","line_number":8,"url":null},"def":{"name":"description","return_type":"String","visibility":"Public","body":"@description"}},{"html_id":"end_line:Int32-instance-method","name":"end_line","doc":"The line where the example or example group ends.","summary":"<p>The line where the example or example group ends.</p>","abstract":false,"location":{"filename":"src/spec/item.cr","line_number":17,"url":null},"def":{"name":"end_line","return_type":"Int32","visibility":"Public","body":"@end_line"}},{"html_id":"file:String-instance-method","name":"file","doc":"The file where the example or example group is defined.","summary":"<p>The file where the example or example group is defined.</p>","abstract":false,"location":{"filename":"src/spec/item.cr","line_number":11,"url":null},"def":{"name":"file","return_type":"String","visibility":"Public","body":"@file"}},{"html_id":"focus?:Bool-instance-method","name":"focus?","doc":"Does this example or example group have `focus: true` on it?","summary":"<p>Does this example or example group have <code>focus: true</code> on it?</p>","abstract":false,"location":{"filename":"src/spec/item.cr","line_number":20,"url":null},"def":{"name":"focus?","return_type":"Bool","visibility":"Public","body":"@focus"}},{"html_id":"line:Int32-instance-method","name":"line","doc":"The line where the example or example group starts.","summary":"<p>The line where the example or example group starts.</p>","abstract":false,"location":{"filename":"src/spec/item.cr","line_number":14,"url":null},"def":{"name":"line","return_type":"Int32","visibility":"Public","body":"@line"}},{"html_id":"parent:Context-instance-method","name":"parent","doc":"The `describe`/`context` that wraps this example or example group.","summary":"<p>The <code>describe</code>/<code>context</code> that wraps this example or example group.</p>","abstract":false,"location":{"filename":"src/spec/item.cr","line_number":5,"url":null},"def":{"name":"parent","return_type":"Context","visibility":"Public","body":"@parent"}},{"html_id":"tags:Set(String)?-instance-method","name":"tags","doc":"The tags defined on this example or example group","summary":"<p>The tags defined on this example or example group</p>","abstract":false,"location":{"filename":"src/spec/item.cr","line_number":23,"url":null},"def":{"name":"tags","return_type":"Set(String) | ::Nil","visibility":"Public","body":"@tags"}}]},{"html_id":"Crystal/Spec/Methods","path":"Spec/Methods.html","kind":"module","full_name":"Spec::Methods","name":"Methods","abstract":false,"locations":[{"filename":"src/spec/helpers/iterate.cr","line_number":1,"url":null},{"filename":"src/spec/methods.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Spec","kind":"module","full_name":"Spec","name":"Spec"},"instance_methods":[{"html_id":"after_all(&block)-instance-method","name":"after_all","doc":"Executes the given block after the last spec in the current context runs.\n\nA context is defined by `describe` or `context` blocks, or outside of them\nit's the root context.\nThis is independent of the source location the specs and this hook are\ndefined.\n\nIf multiple blocks are registered on the same context, they are executed in\norder of definition.\n\n```\nrequire \"spec\"\n\nit \"sample_a\" { }\n\ndescribe \"nested_context\" do\n  after_all do\n    puts \"runs at end of nested_context\"\n  end\n\n  it \"sample_b\" { }\nend\n```","summary":"<p>Executes the given block after the last spec in the current context runs.</p>","abstract":false,"location":{"filename":"src/spec/methods.cr","line_number":216,"url":null},"def":{"name":"after_all","yields":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"if Spec.current_context.is_a?(RootContext)\n  raise(\"Can't call `after_all` outside of a describe/context\")\nend\nSpec.current_context.after_all(&block)\n"}},{"html_id":"after_each(&block)-instance-method","name":"after_each","doc":"Executes the given block after each spec in the current context runs.\n\nA context is defined by `describe` or `context` blocks, or outside of them\nit's the root context. Nested contexts inherit the `*_each` blocks of\ntheir ancestors.\n\nIf multiple blocks are registered for the same spec, the blocks defined in\nthe outermost context go first. Blocks on the same context are executed in\norder of definition.\n\n```\nrequire \"spec\"\n\nit \"sample_a\" { }\n\ndescribe \"nested_context\" do\n  after_each do\n    puts \"runs after sample_b\"\n  end\n\n  it \"sample_b\" { }\nend\n```","summary":"<p>Executes the given block after each spec in the current context runs.</p>","abstract":false,"location":{"filename":"src/spec/methods.cr","line_number":156,"url":null},"def":{"name":"after_each","yields":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"if Spec.current_context.is_a?(RootContext)\n  raise(\"Can't call `after_each` outside of a describe/context\")\nend\nSpec.current_context.after_each(&block)\n"}},{"html_id":"around_all(&block:ExampleGroup::Procsy->)-instance-method","name":"around_all","doc":"Executes the given block when the current context runs.\n\nThe block must call `run` on the given `Context::Procsy`\nobject.\n\nThis is essentially a `before_all` and `after_all` hook combined into one.\nIt is useful for example when setup and teardown steps need shared state.\n\nA context is defined by `describe` or `context` blocks. This hook does not\nwork outside such a block (i.e. in the root context).\n\nIf multiple blocks are registered for the same spec, the blocks defined in\nthe outermost context go first. Blocks on the same context are executed in\norder of definition.\n\n```\nrequire \"spec\"\n\ndescribe \"main_context\" do\n  around_each do |example|\n    puts \"runs at beginning of main_context\"\n    example.run\n    puts \"runs at end of main_context\"\n  end\n\n  it \"sample_a\" { }\n\n  describe \"nested_context\" do\n    around_each do |example|\n      puts \"runs at beginning of nested_context\"\n      example.run\n      puts \"runs at end of nested_context\"\n    end\n\n    it \"sample_b\" { }\n  end\nend\n```","summary":"<p>Executes the given block when the current context runs.</p>","abstract":false,"location":{"filename":"src/spec/methods.cr","line_number":299,"url":null},"def":{"name":"around_all","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(ExampleGroup::Procsy ->)"},"visibility":"Public","body":"if Spec.current_context.is_a?(RootContext)\n  raise(\"Can't call `around_all` outside of a describe/context\")\nend\nSpec.current_context.around_all(&block)\n"}},{"html_id":"around_each(&block:Example::Procsy->)-instance-method","name":"around_each","doc":"Executes the given block when each spec in the current context runs.\n\nThe block must call `run` on the given `Example::Procsy`\nobject.\n\nThis is essentially a `before_each` and `after_each` hook combined into one.\nIt is useful for example when setup and teardown steps need shared state.\n\nA context is defined by `describe` or `context` blocks, or outside of them\nit's the root context. Nested contexts inherit the `*_each` blocks of\ntheir ancestors.\n\nIf multiple blocks are registered for the same spec, the blocks defined in\nthe outermost context go first. Blocks on the same context are executed in\norder of definition.\n\n```\nrequire \"spec\"\n\nit \"sample_a\" { }\n\ndescribe \"nested_context\" do\n  around_each do |example|\n    puts \"runs before sample_b\"\n    example.run\n    puts \"runs after sample_b\"\n  end\n\n  it \"sample_b\" { }\nend\n```","summary":"<p>Executes the given block when each spec in the current context runs.</p>","abstract":false,"location":{"filename":"src/spec/methods.cr","line_number":254,"url":null},"def":{"name":"around_each","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(Example::Procsy ->)"},"visibility":"Public","body":"if Spec.current_context.is_a?(RootContext)\n  raise(\"Can't call `around_each` outside of a describe/context\")\nend\nSpec.current_context.around_each(&block)\n"}},{"html_id":"before_all(&block)-instance-method","name":"before_all","doc":"Executes the given block before the first spec in the current context runs.\n\nA context is defined by `describe` or `context` blocks, or outside of them\nit's the root context.\nThis is independent of the source location the specs and this hook are\ndefined.\n\nIf multiple blocks are registered on the same context, they are executed in\norder of definition.\n\n```\nrequire \"spec\"\n\nit \"sample_a\" { }\n\ndescribe \"nested_context\" do\n  before_all do\n    puts \"runs at start of nested_context\"\n  end\n\n  it \"sample_b\" { }\nend\n```","summary":"<p>Executes the given block before the first spec in the current context runs.</p>","abstract":false,"location":{"filename":"src/spec/methods.cr","line_number":186,"url":null},"def":{"name":"before_all","yields":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"if Spec.current_context.is_a?(RootContext)\n  raise(\"Can't call `before_all` outside of a describe/context\")\nend\nSpec.current_context.before_all(&block)\n"}},{"html_id":"before_each(&block)-instance-method","name":"before_each","doc":"Executes the given block before each spec in the current context runs.\n\nA context is defined by `describe` or `context` blocks, or outside of them\nit's the root context. Nested contexts inherit the `*_each` blocks of\ntheir ancestors.\n\nIf multiple blocks are registered for the same spec, the blocks defined in\nthe outermost context go first. Blocks on the same context are executed in\norder of definition.\n\n```\nrequire \"spec\"\n\nit \"sample_a\" { }\n\ndescribe \"nested_context\" do\n  before_each do\n    puts \"runs before sample_b\"\n  end\n\n  it \"sample_b\" { }\nend\n```","summary":"<p>Executes the given block before each spec in the current context runs.</p>","abstract":false,"location":{"filename":"src/spec/methods.cr","line_number":126,"url":null},"def":{"name":"before_each","yields":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"if Spec.current_context.is_a?(RootContext)\n  raise(\"Can't call `before_each` outside of a describe/context\")\nend\nSpec.current_context.before_each(&block)\n"}},{"html_id":"context(description=nil,file=__FILE__,line=__LINE__,end_line=__END_LINE__,focus:Bool=false,tags:String|Enumerable(String)|Nil=nil,&block)-instance-method","name":"context","doc":"Defines an example group that establishes a specific context,\nlike *empty array* versus *array with elements*.\nInside *&block* examples are defined by `#it` or `#pending`.\n\nIt is functionally equivalent to `#describe`.\n\nIf `focus` is `true`, only this `context`, and others marked with `focus: true`, will run.","summary":"<p>Defines an example group that establishes a specific context, like <em>empty array</em> versus <em>array with elements</em>.</p>","abstract":false,"args":[{"name":"description","default_value":"nil","external_name":"description","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","default_value":"__END_LINE__","external_name":"end_line","restriction":""},{"name":"focus","default_value":"false","external_name":"focus","restriction":"Bool"},{"name":"tags","default_value":"nil","external_name":"tags","restriction":"String | Enumerable(String) | Nil"}],"args_string":"(description = nil, file = __FILE__, line = __LINE__, end_line = __END_LINE__, focus : Bool = false, tags : String | Enumerable(String) | Nil = nil, &block)","args_html":"(description = <span class=\"n\">nil</span>, file = __FILE__, line = __LINE__, end_line = __END_LINE__, focus : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>, tags : <a href=\"../String.html\">String</a> | <a href=\"../Enumerable.html\">Enumerable</a>(<a href=\"../String.html\">String</a>) | <a href=\"../Nil.html\">Nil</a> = <span class=\"n\">nil</span>, &block)","location":{"filename":"src/spec/methods.cr","line_number":30,"url":null},"def":{"name":"context","args":[{"name":"description","default_value":"nil","external_name":"description","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","default_value":"__END_LINE__","external_name":"end_line","restriction":""},{"name":"focus","default_value":"false","external_name":"focus","restriction":"Bool"},{"name":"tags","default_value":"nil","external_name":"tags","restriction":"String | Enumerable(String) | Nil"}],"yields":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"describe(description.to_s, file, line, end_line, focus, tags, &block)"}},{"html_id":"describe(description=nil,file=__FILE__,line=__LINE__,end_line=__END_LINE__,focus:Bool=false,tags:String|Enumerable(String)|Nil=nil,&block)-instance-method","name":"describe","doc":"Defines an example group that describes a unit to be tested.\nInside *&block* examples are defined by `#it` or `#pending`.\n\nSeveral `describe` blocks can be nested.\n\nExample:\n```\nrequire \"spec\"\n\ndescribe \"Int32\" do\n  describe \"+\" do\n    it \"adds\" { (1 + 1).should eq 2 }\n  end\nend\n```\n\nIf `focus` is `true`, only this `describe`, and others marked with `focus: true`, will run.","summary":"<p>Defines an example group that describes a unit to be tested.</p>","abstract":false,"args":[{"name":"description","default_value":"nil","external_name":"description","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","default_value":"__END_LINE__","external_name":"end_line","restriction":""},{"name":"focus","default_value":"false","external_name":"focus","restriction":"Bool"},{"name":"tags","default_value":"nil","external_name":"tags","restriction":"String | Enumerable(String) | Nil"}],"args_string":"(description = nil, file = __FILE__, line = __LINE__, end_line = __END_LINE__, focus : Bool = false, tags : String | Enumerable(String) | Nil = nil, &block)","args_html":"(description = <span class=\"n\">nil</span>, file = __FILE__, line = __LINE__, end_line = __END_LINE__, focus : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>, tags : <a href=\"../String.html\">String</a> | <a href=\"../Enumerable.html\">Enumerable</a>(<a href=\"../String.html\">String</a>) | <a href=\"../Nil.html\">Nil</a> = <span class=\"n\">nil</span>, &block)","location":{"filename":"src/spec/methods.cr","line_number":19,"url":null},"def":{"name":"describe","args":[{"name":"description","default_value":"nil","external_name":"description","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","default_value":"__END_LINE__","external_name":"end_line","restriction":""},{"name":"focus","default_value":"false","external_name":"focus","restriction":"Bool"},{"name":"tags","default_value":"nil","external_name":"tags","restriction":"String | Enumerable(String) | Nil"}],"yields":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"Spec.root_context.describe(description.to_s, file, line, end_line, focus, tags, &block)"}},{"html_id":"fail(msg,file=__FILE__,line=__LINE__)-instance-method","name":"fail","doc":"Fails an example.\n\nThis method can be used to manually fail an example defined in an `#it` block.","summary":"<p>Fails an example.</p>","abstract":false,"args":[{"name":"msg","external_name":"msg","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(msg, file = __FILE__, line = __LINE__)","args_html":"(msg, file = __FILE__, line = __LINE__)","location":{"filename":"src/spec/methods.cr","line_number":81,"url":null},"def":{"name":"fail","args":[{"name":"msg","external_name":"msg","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"visibility":"Public","body":"raise(Spec::AssertionFailed.new(msg, file, line))"}},{"html_id":"it(description=\"assert\",file=__FILE__,line=__LINE__,end_line=__END_LINE__,focus:Bool=false,tags:String|Enumerable(String)|Nil=nil,&block)-instance-method","name":"it","doc":"Defines a concrete test case.\n\nThe test is performed by the block supplied to *&block*.\n\nExample:\n```\nrequire \"spec\"\n\nit \"adds\" { (1 + 1).should eq 2 }\n```\n\nIt is usually used inside a `#describe` or `#context` section.\n\nIf `focus` is `true`, only this test, and others marked with `focus: true`, will run.","summary":"<p>Defines a concrete test case.</p>","abstract":false,"args":[{"name":"description","default_value":"\"assert\"","external_name":"description","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","default_value":"__END_LINE__","external_name":"end_line","restriction":""},{"name":"focus","default_value":"false","external_name":"focus","restriction":"Bool"},{"name":"tags","default_value":"nil","external_name":"tags","restriction":"String | Enumerable(String) | Nil"}],"args_string":"(description = \"assert\", file = __FILE__, line = __LINE__, end_line = __END_LINE__, focus : Bool = false, tags : String | Enumerable(String) | Nil = nil, &block)","args_html":"(description = <span class=\"s\">&quot;assert&quot;</span>, file = __FILE__, line = __LINE__, end_line = __END_LINE__, focus : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>, tags : <a href=\"../String.html\">String</a> | <a href=\"../Enumerable.html\">Enumerable</a>(<a href=\"../String.html\">String</a>) | <a href=\"../Nil.html\">Nil</a> = <span class=\"n\">nil</span>, &block)","location":{"filename":"src/spec/methods.cr","line_number":48,"url":null},"def":{"name":"it","args":[{"name":"description","default_value":"\"assert\"","external_name":"description","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","default_value":"__END_LINE__","external_name":"end_line","restriction":""},{"name":"focus","default_value":"false","external_name":"focus","restriction":"Bool"},{"name":"tags","default_value":"nil","external_name":"tags","restriction":"String | Enumerable(String) | Nil"}],"yields":0,"block_arg":{"name":"block","external_name":"block","restriction":""},"visibility":"Public","body":"Spec.root_context.it(description.to_s, file, line, end_line, focus, tags, &block)"}},{"html_id":"pending(description=\"assert\",file=__FILE__,line=__LINE__,end_line=__END_LINE__,focus:Bool=false,tags:String|Enumerable(String)|Nil=nil,&)-instance-method","name":"pending","doc":"Defines a pending test case.\n\n*&block* is never evaluated.\nIt can be used to describe behaviour that is not yet implemented.\n\nExample:\n```\nrequire \"spec\"\n\npending \"check cat\" { cat.alive? }\n```\n\nIt is usually used inside a `#describe` or `#context` section.\n\nIf `focus` is `true`, only this test, and others marked with `focus: true`, will run.","summary":"<p>Defines a pending test case.</p>","abstract":false,"args":[{"name":"description","default_value":"\"assert\"","external_name":"description","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","default_value":"__END_LINE__","external_name":"end_line","restriction":""},{"name":"focus","default_value":"false","external_name":"focus","restriction":"Bool"},{"name":"tags","default_value":"nil","external_name":"tags","restriction":"String | Enumerable(String) | Nil"}],"args_string":"(description = \"assert\", file = __FILE__, line = __LINE__, end_line = __END_LINE__, focus : Bool = false, tags : String | Enumerable(String) | Nil = nil, &)","args_html":"(description = <span class=\"s\">&quot;assert&quot;</span>, file = __FILE__, line = __LINE__, end_line = __END_LINE__, focus : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>, tags : <a href=\"../String.html\">String</a> | <a href=\"../Enumerable.html\">Enumerable</a>(<a href=\"../String.html\">String</a>) | <a href=\"../Nil.html\">Nil</a> = <span class=\"n\">nil</span>, &)","location":{"filename":"src/spec/methods.cr","line_number":67,"url":null},"def":{"name":"pending","args":[{"name":"description","default_value":"\"assert\"","external_name":"description","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","default_value":"__END_LINE__","external_name":"end_line","restriction":""},{"name":"focus","default_value":"false","external_name":"focus","restriction":"Bool"},{"name":"tags","default_value":"nil","external_name":"tags","restriction":"String | Enumerable(String) | Nil"}],"yields":0,"visibility":"Public","body":"pending(description, file, line, end_line, focus, tags)"}},{"html_id":"pending(description=\"assert\",file=__FILE__,line=__LINE__,end_line=__END_LINE__,focus:Bool=false,tags:String|Enumerable(String)|Nil=nil)-instance-method","name":"pending","doc":"Defines a yet-to-be-implemented pending test case\n\nIf `focus` is `true`, only this test, and others marked with `focus: true`, will run.","summary":"<p>Defines a yet-to-be-implemented pending test case</p>","abstract":false,"args":[{"name":"description","default_value":"\"assert\"","external_name":"description","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","default_value":"__END_LINE__","external_name":"end_line","restriction":""},{"name":"focus","default_value":"false","external_name":"focus","restriction":"Bool"},{"name":"tags","default_value":"nil","external_name":"tags","restriction":"String | Enumerable(String) | Nil"}],"args_string":"(description = \"assert\", file = __FILE__, line = __LINE__, end_line = __END_LINE__, focus : Bool = false, tags : String | Enumerable(String) | Nil = nil)","args_html":"(description = <span class=\"s\">&quot;assert&quot;</span>, file = __FILE__, line = __LINE__, end_line = __END_LINE__, focus : <a href=\"../Bool.html\">Bool</a> = <span class=\"n\">false</span>, tags : <a href=\"../String.html\">String</a> | <a href=\"../Enumerable.html\">Enumerable</a>(<a href=\"../String.html\">String</a>) | <a href=\"../Nil.html\">Nil</a> = <span class=\"n\">nil</span>)","location":{"filename":"src/spec/methods.cr","line_number":74,"url":null},"def":{"name":"pending","args":[{"name":"description","default_value":"\"assert\"","external_name":"description","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""},{"name":"end_line","default_value":"__END_LINE__","external_name":"end_line","restriction":""},{"name":"focus","default_value":"false","external_name":"focus","restriction":"Bool"},{"name":"tags","default_value":"nil","external_name":"tags","restriction":"String | Enumerable(String) | Nil"}],"visibility":"Public","body":"Spec.root_context.pending(description.to_s, file, line, end_line, focus, tags)"}},{"html_id":"pending!(msg=\"Cannotrunexample\",file=__FILE__,line=__LINE__)-instance-method","name":"pending!","doc":"Marks the current example pending\n\nIn case an example needs to be pending on some condition that requires executing it,\nthis allows to mark it as such  rather than letting it fail or never run.\n\n```\nrequire \"spec\"\n\nit \"test git\" do\n  cmd = Process.find_executable(\"git\")\n  pending!(\"git is not available\") unless cmd\n  cmd.ends_with?(\"git\").should be_true\nend\n```","summary":"<p>Marks the current example pending</p>","abstract":false,"args":[{"name":"msg","default_value":"\"Cannot run example\"","external_name":"msg","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(msg = \"Cannot run example\", file = __FILE__, line = __LINE__)","args_html":"(msg = <span class=\"s\">&quot;Cannot run example&quot;</span>, file = __FILE__, line = __LINE__)","location":{"filename":"src/spec/methods.cr","line_number":99,"url":null},"def":{"name":"pending!","args":[{"name":"msg","default_value":"\"Cannot run example\"","external_name":"msg","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"visibility":"Public","body":"raise(Spec::ExamplePending.new(msg, file, line))"}}],"macros":[{"html_id":"assert_iterates_iterator(expected,method,*,infinite=false)-macro","name":"assert_iterates_iterator","doc":"Calls *method* expecting an iterator and compares iterated values with *expected*.\n\nSee `.it_iterates` for details.","summary":"<p>Calls <em>method</em> expecting an iterator and compares iterated values with <em>expected</em>.</p>","abstract":false,"args":[{"name":"expected","external_name":"expected","restriction":""},{"name":"method","external_name":"method","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"infinite","default_value":"false","external_name":"infinite","restriction":""}],"args_string":"(expected, method, *, infinite = false)","args_html":"(expected, method, *, infinite = <span class=\"n\">false</span>)","location":{"filename":"src/spec/helpers/iterate.cr","line_number":75,"url":null},"def":{"name":"assert_iterates_iterator","args":[{"name":"expected","external_name":"expected","restriction":""},{"name":"method","external_name":"method","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"infinite","default_value":"false","external_name":"infinite","restriction":""}],"splat_index":2,"visibility":"Public","body":"    \n%ary\n = [] of typeof(Enumerable.element_type(\n{{ expected }}\n))\n    \n%iter\n = \n{{ method.id }}\n\n    (\n{{ expected }}\n).size.times do\n      \n%v\n = \n%iter\n.next\n      if \n%v\n.is_a?(Iterator::Stop)\n        \n# Compare the actual value directly. Since there are less\n\n        \n# then expected values, the expectation will fail and raise.\n\n        \n%ary\n.should \neq(\n{{ expected }}\n)\n        raise \"unreachable\"\n      \nend\n      \n%ary\n << \n%v\n\n    \nend\n    unless \n{{ infinite }}\n\n      \n%iter\n.next.should be_a(Iterator::Stop)\n    \nend\n\n    \n%ary\n.should \neq(\n{{ expected }}\n)\n    \n%ary\n.zip(\n{{ expected }}\n).each_with_index do |(actual, \nexpected), i|\n      if actual.class != \nexpected.class\n        fail \"Mismatching type, expected: #{expected} (#{expected.class}), got: #{actual} (#{actual.class}) at #{i}\"\n      \nend\n    \nend\n  \n"}},{"html_id":"assert_iterates_yielding(expected,method,*,infinite=false,tuple=false)-macro","name":"assert_iterates_yielding","doc":"Calls *method* with a block and compares yielded values with *expected*.\n\nSee `.it_iterates` for details.","summary":"<p>Calls <em>method</em> with a block and compares yielded values with <em>expected</em>.</p>","abstract":false,"args":[{"name":"expected","external_name":"expected","restriction":""},{"name":"method","external_name":"method","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"infinite","default_value":"false","external_name":"infinite","restriction":""},{"name":"tuple","default_value":"false","external_name":"tuple","restriction":""}],"args_string":"(expected, method, *, infinite = false, tuple = false)","args_html":"(expected, method, *, infinite = <span class=\"n\">false</span>, tuple = <span class=\"n\">false</span>)","location":{"filename":"src/spec/helpers/iterate.cr","line_number":48,"url":null},"def":{"name":"assert_iterates_yielding","args":[{"name":"expected","external_name":"expected","restriction":""},{"name":"method","external_name":"method","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"infinite","default_value":"false","external_name":"infinite","restriction":""},{"name":"tuple","default_value":"false","external_name":"tuple","restriction":""}],"splat_index":2,"visibility":"Public","body":"    \n%remaining\n = (\n{{ expected }}\n).size\n    \n%ary\n = [] of typeof(Enumerable.element_type(\n{{ expected }}\n))\n    \n{{ method.id }}\n do |\n{% if tuple %}*{% end %}\nx|\n      if \n%remaining\n == 0\n        if \n{{ infinite }}\n\n          break\n        \nelse\n          fail \"Reached iteration limit #{(\n{{ expected }}\n).size} receiving value #{x.inspect}\"\n        \nend\n      \nend\n\n      \n%ary\n << x\n      \n%remaining\n -= 1\n    \nend\n\n    \n%ary\n.should \neq(\n{{ expected }}\n)\n    \n%ary\n.zip(\n{{ expected }}\n).each_with_index do |(actual, \nexpected), i|\n      if actual.class != \nexpected.class\n        fail \"Mismatching type, expected: #{expected} (#{expected.class}), got: #{actual} (#{actual.class}) at #{i}\"\n      \nend\n    \nend\n  \n"}},{"html_id":"it_iterates(description,expected,method,*,infinite=false,tuple=false)-macro","name":"it_iterates","doc":"Spec helper for generic iteration methods which tests both yielding and\niterator overloads.\n\nThis helper creates two spec examples named *description* with suffixes\n`\" yielding\"` and `\" iterator\"`.\nThe yielding example calls *method* with a block and expects the iteration\nelements to be yielded to the block. The iterator example calls *method*\nwithout a block and expects it to return an `Iterator` which it then consumes.\n\nThe iterated elements are collected in an array and compared to *expected*,\nensuring type-equality of the elements.\n\nBy default, both examples make sure that the iteration is finished after\niterating all elements from *expected*. If the iteration is infinite,\npassing `infinite: true` skips that check and allows to test a finite sample\nof an infinite iteration.\n\n```\nrequire \"spec/helpers/iterate\"\n\nit_iterates \"Array#each\", [1, 2, 3], (1..3).each\nit_iterates \"infinite #cycle\", [1, 2, 3, 1, 2, 3, 1], (1..3).cycle, infinite: true\n```\n\nIf the iteration elements are tuples (i.e. multiple values), the yielding\nvariant by default only catches the first value because of the block argument\nmechanics. Passing `tuple: true` ensures all yielded arguments are collected\nusing a splat.\n\n```\nrequire \"spec/helpers/iterate\"\n\nit_iterates \"Array#each_with_index\", [{1, 0}, {2, 1}, {3, 2}], (1..3).each_with_index, tuple: true\n```","summary":"<p>Spec helper for generic iteration methods which tests both yielding and iterator overloads.</p>","abstract":false,"args":[{"name":"description","external_name":"description","restriction":""},{"name":"expected","external_name":"expected","restriction":""},{"name":"method","external_name":"method","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"infinite","default_value":"false","external_name":"infinite","restriction":""},{"name":"tuple","default_value":"false","external_name":"tuple","restriction":""}],"args_string":"(description, expected, method, *, infinite = false, tuple = false)","args_html":"(description, expected, method, *, infinite = <span class=\"n\">false</span>, tuple = <span class=\"n\">false</span>)","location":{"filename":"src/spec/helpers/iterate.cr","line_number":36,"url":null},"def":{"name":"it_iterates","args":[{"name":"description","external_name":"description","restriction":""},{"name":"expected","external_name":"expected","restriction":""},{"name":"method","external_name":"method","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"infinite","default_value":"false","external_name":"infinite","restriction":""},{"name":"tuple","default_value":"false","external_name":"tuple","restriction":""}],"splat_index":3,"visibility":"Public","body":"    it \n{{ \"#{description} yielding\" }}\n do\n      assert_iterates_yielding \n{{ expected }}\n, \n{{ method }}\n, infinite: \n{{ infinite }}\n, tuple: \n{{ tuple }}\n\n    \nend\n    it \n{{ \"#{description} iterator\" }}\n do\n      assert_iterates_iterator \n{{ expected }}\n, \n{{ method }}\n, infinite: \n{{ infinite }}\n\n    \nend\n  \n"}}]},{"html_id":"Crystal/Spec/ObjectExtensions","path":"Spec/ObjectExtensions.html","kind":"module","full_name":"Spec::ObjectExtensions","name":"ObjectExtensions","abstract":false,"locations":[{"filename":"src/spec/expectations.cr","line_number":426,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"including_types":[{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"namespace":{"html_id":"Crystal/Spec","kind":"module","full_name":"Spec","name":"Spec"},"instance_methods":[{"html_id":"should(expectation:BeAExpectation(T),failure_message:String?=nil,*,file=__FILE__,line=__LINE__):TforallT-instance-method","name":"should","doc":"Validates an expectation and fails the example if it does not match.\n\nThis overload returns a value whose type is restricted to the expected type. For example:\n\n```\nx = 1 || 'a'\ntypeof(x) # => Int32 | Char\nx = x.should be_a(Int32)\ntypeof(x) # => Int32\n```\n\nSee `Spec::Expectations` for available expectations.","summary":"<p>Validates an expectation and fails the example if it does not match.</p>","abstract":false,"args":[{"name":"expectation","external_name":"expectation","restriction":"BeAExpectation(T)"},{"name":"failure_message","default_value":"nil","external_name":"failure_message","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(expectation : BeAExpectation(T), failure_message : String? = nil, *, file = __FILE__, line = __LINE__) : T forall T","args_html":"(expectation : BeAExpectation(T), failure_message : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, *, file = __FILE__, line = __LINE__) : T forall T","location":{"filename":"src/spec/expectations.cr","line_number":439,"url":null},"def":{"name":"should","args":[{"name":"expectation","external_name":"expectation","restriction":"BeAExpectation(T)"},{"name":"failure_message","default_value":"nil","external_name":"failure_message","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"splat_index":2,"return_type":"T","visibility":"Public","body":"if expectation.match(self)\n  self.is_a?(T) ? self : (  raise(\"Bug: expected #{self} to be a #{T}\"))\nelse\n  failure_message || (failure_message = expectation.failure_message(self))\n  fail(failure_message, file, line)\nend"}},{"html_id":"should(expectation,failure_message:String?=nil,*,file=__FILE__,line=__LINE__)-instance-method","name":"should","doc":"Validates an expectation and fails the example if it does not match.\n\nSee `Spec::Expectations` for available expectations.","summary":"<p>Validates an expectation and fails the example if it does not match.</p>","abstract":false,"args":[{"name":"expectation","external_name":"expectation","restriction":""},{"name":"failure_message","default_value":"nil","external_name":"failure_message","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(expectation, failure_message : String? = nil, *, file = __FILE__, line = __LINE__)","args_html":"(expectation, failure_message : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, *, file = __FILE__, line = __LINE__)","location":{"filename":"src/spec/expectations.cr","line_number":451,"url":null},"def":{"name":"should","args":[{"name":"expectation","external_name":"expectation","restriction":""},{"name":"failure_message","default_value":"nil","external_name":"failure_message","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"splat_index":2,"visibility":"Public","body":"if expectation.match(self)\nelse\n  failure_message || (failure_message = expectation.failure_message(self))\n  fail(failure_message, file, line)\nend"}},{"html_id":"should_not(expectation:BeAExpectation(T),failure_message:String?=nil,*,file=__FILE__,line=__LINE__)forallT-instance-method","name":"should_not","doc":"Validates an expectation and fails the example if it matches.\n\nThis overload returns a value whose type is restricted to exclude the given\ntype in `should_not be_a`. For example:\n\n```\nx = 1 || 'a'\ntypeof(x) # => Int32 | Char\nx = x.should_not be_a(Char)\ntypeof(x) # => Int32\n```\n\nSee `Spec::Expectations` for available expectations.","summary":"<p>Validates an expectation and fails the example if it matches.</p>","abstract":false,"args":[{"name":"expectation","external_name":"expectation","restriction":"BeAExpectation(T)"},{"name":"failure_message","default_value":"nil","external_name":"failure_message","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(expectation : BeAExpectation(T), failure_message : String? = nil, *, file = __FILE__, line = __LINE__) forall T","args_html":"(expectation : BeAExpectation(T), failure_message : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, *, file = __FILE__, line = __LINE__) forall T","location":{"filename":"src/spec/expectations.cr","line_number":471,"url":null},"def":{"name":"should_not","args":[{"name":"expectation","external_name":"expectation","restriction":"BeAExpectation(T)"},{"name":"failure_message","default_value":"nil","external_name":"failure_message","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"splat_index":2,"visibility":"Public","body":"if expectation.match(self)\n  failure_message || (failure_message = expectation.negative_failure_message(self))\n  fail(failure_message, file, line)\nelse\n  self.is_a?(T) ? (  raise(\"Bug: expected #{self} not to be a #{T}\")) : self\nend"}},{"html_id":"should_not(expectation:BeNilExpectation,failure_message:String?=nil,*,file=__FILE__,line=__LINE__)-instance-method","name":"should_not","doc":"Validates an expectation and fails the example if it matches.\n\nThis overload returns a value whose type is restricted to be not `Nil`. For example:\n\n```\nx = 1 || nil\ntypeof(x) # => Int32 | Nil\nx = x.should_not be_nil\ntypeof(x) # => Int32\n```\n\nSee `Spec::Expectations` for available expectations.","summary":"<p>Validates an expectation and fails the example if it matches.</p>","abstract":false,"args":[{"name":"expectation","external_name":"expectation","restriction":"BeNilExpectation"},{"name":"failure_message","default_value":"nil","external_name":"failure_message","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(expectation : BeNilExpectation, failure_message : String? = nil, *, file = __FILE__, line = __LINE__)","args_html":"(expectation : BeNilExpectation, failure_message : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, *, file = __FILE__, line = __LINE__)","location":{"filename":"src/spec/expectations.cr","line_number":492,"url":null},"def":{"name":"should_not","args":[{"name":"expectation","external_name":"expectation","restriction":"BeNilExpectation"},{"name":"failure_message","default_value":"nil","external_name":"failure_message","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"splat_index":2,"visibility":"Public","body":"if expectation.match(self)\n  failure_message || (failure_message = expectation.negative_failure_message(self))\n  fail(failure_message, file, line)\nelse\n  self.not_nil!\nend"}},{"html_id":"should_not(expectation,failure_message:String?=nil,*,file=__FILE__,line=__LINE__)-instance-method","name":"should_not","doc":"Validates an expectation and fails the example if it matches.\n\nSee `Spec::Expectations` for available expectations.","summary":"<p>Validates an expectation and fails the example if it matches.</p>","abstract":false,"args":[{"name":"expectation","external_name":"expectation","restriction":""},{"name":"failure_message","default_value":"nil","external_name":"failure_message","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"args_string":"(expectation, failure_message : String? = nil, *, file = __FILE__, line = __LINE__)","args_html":"(expectation, failure_message : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, *, file = __FILE__, line = __LINE__)","location":{"filename":"src/spec/expectations.cr","line_number":504,"url":null},"def":{"name":"should_not","args":[{"name":"expectation","external_name":"expectation","restriction":""},{"name":"failure_message","default_value":"nil","external_name":"failure_message","restriction":"String | ::Nil"},{"name":"","external_name":"","restriction":""},{"name":"file","default_value":"__FILE__","external_name":"file","restriction":""},{"name":"line","default_value":"__LINE__","external_name":"line","restriction":""}],"splat_index":2,"visibility":"Public","body":"if expectation.match(self)\n  failure_message || (failure_message = expectation.negative_failure_message(self))\n  fail(failure_message, file, line)\nend"}}]},{"html_id":"Crystal/Spec/SplitFilter","path":"Spec/SplitFilter.html","kind":"struct","full_name":"Spec::SplitFilter","name":"SplitFilter","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/spec/dsl.cr","line_number":101,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Spec","kind":"module","full_name":"Spec","name":"Spec"},"constructors":[{"html_id":"new(remainder:Int32,quotient:Int32)-class-method","name":"new","abstract":false,"args":[{"name":"remainder","external_name":"remainder","restriction":"Int32"},{"name":"quotient","external_name":"quotient","restriction":"Int32"}],"args_string":"(remainder : Int32, quotient : Int32)","args_html":"(remainder : <a href=\"../Int32.html\">Int32</a>, quotient : <a href=\"../Int32.html\">Int32</a>)","location":{"filename":"src/spec/dsl.cr","line_number":101,"url":null},"def":{"name":"new","args":[{"name":"remainder","external_name":"remainder","restriction":"Int32"},{"name":"quotient","external_name":"quotient","restriction":"Int32"}],"visibility":"Public","body":"_ = allocate\n_.initialize(remainder, quotient)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/spec/dsl.cr","line_number":101,"url":null},"def":{"name":"clone","visibility":"Public","body":"self.class.new(@remainder.clone, @quotient.clone)"}},{"html_id":"copy_with(remainder_remainder=@remainder,quotient_quotient=@quotient)-instance-method","name":"copy_with","abstract":false,"args":[{"name":"_remainder","default_value":"@remainder","external_name":"remainder","restriction":""},{"name":"_quotient","default_value":"@quotient","external_name":"quotient","restriction":""}],"args_string":"(remainder _remainder = @remainder, quotient _quotient = @quotient)","args_html":"(remainder _remainder = @remainder, quotient _quotient = @quotient)","location":{"filename":"src/spec/dsl.cr","line_number":101,"url":null},"def":{"name":"copy_with","args":[{"name":"_remainder","default_value":"@remainder","external_name":"remainder","restriction":""},{"name":"_quotient","default_value":"@quotient","external_name":"quotient","restriction":""}],"visibility":"Public","body":"self.class.new(_remainder, _quotient)"}},{"html_id":"quotient:Int32-instance-method","name":"quotient","abstract":false,"def":{"name":"quotient","return_type":"Int32","visibility":"Public","body":"@quotient"}},{"html_id":"remainder:Int32-instance-method","name":"remainder","abstract":false,"def":{"name":"remainder","return_type":"Int32","visibility":"Public","body":"@remainder"}}]}]},{"html_id":"Crystal/StaticArray","path":"StaticArray.html","kind":"struct","full_name":"StaticArray(T, N)","name":"StaticArray","abstract":false,"superclass":{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"Crystal/Indexable/Mutable","kind":"module","full_name":"Indexable::Mutable","name":"Mutable"},{"html_id":"Crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"},{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/static_array.cr","line_number":35,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Indexable/Mutable","kind":"module","full_name":"Indexable::Mutable","name":"Mutable"}],"doc":"A fixed-size, stack allocated array.\n\n`StaticArray` is a generic type with type argument `T` specifying the type of\nits elements and `N` the fixed size. For example `StaticArray(Int32, 3)`\nis a static array of `Int32` with three elements.\n\nInstantiations of this static array type:\n\n```\nStaticArray(Int32, 3).new(42)           # => StaticArray[42, 42, 42]\nStaticArray(Int32, 3).new { |i| i * 2 } # => StaticArray[0, 2, 4]\nStaticArray[0, 8, 15]                   # => StaticArray[0, 8, 15]\n```\n\nThis type can also be expressed as `Int32[3]` (only in type grammar). A typical use\ncase is in combination with `uninitialized`:\n\n```\nints = uninitialized Int32[3]\nints[0] = 0\nints[1] = 8\nints[2] = 15\n```\n\nFor number types there is also `Number.static_array` which can be used to initialize\na static array:\n\n```\nInt32.static_array(0, 8, 15) # => StaticArray[0, 8, 15]\n```\n\nThe generic argument type `N` is a special case in the type grammar as it\ndoesn't specify a type but a size. Its value can be an `Int32` literal or\nconstant.","summary":"<p>A fixed-size, stack allocated array.</p>","constructors":[{"html_id":"new(&:Int32->T)-class-method","name":"new","doc":"Creates a new static array and invokes the\nblock once for each index of the array, assigning the\nblock's value in that index.\n\n```\nStaticArray(Int32, 3).new { |i| i * 2 } # => StaticArray[0, 2, 4]\n```","summary":"<p>Creates a new static array and invokes the block once for each index of the array, assigning the block's value in that index.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":66,"url":null},"def":{"name":"new","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Int32 -> T)"},"visibility":"Public","body":"array = uninitialized self\nN.times do |i|\n  array.to_unsafe[i] = yield i\nend\narray\n"}},{"html_id":"new(value:T)-class-method","name":"new","doc":"Creates a new static array filled with the given value.\n\n```\nStaticArray(Int32, 3).new(42) # => StaticArray[42, 42, 42]\n```","summary":"<p>Creates a new static array filled with the given value.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T)","args_html":"(value : T)","location":{"filename":"src/static_array.cr","line_number":79,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"new do\n  value\nend"}}],"instance_methods":[{"html_id":"<=>(other:StaticArray)-instance-method","name":"<=>","doc":"The comparison operator. Returns `0` if the two objects are equal,\na negative number if this object is considered less than *other*,\na positive number if this object is considered greater than *other*,\nor `nil` if the two objects are not comparable.\n\nSubclasses define this method to provide class-specific ordering.\n\nThe comparison operator is usually used to sort values:\n\n```\n# Sort in a descending way:\n[3, 1, 2].sort { |x, y| y <=> x } # => [3, 2, 1]\n\n# Sort in an ascending way:\n[3, 1, 2].sort { |x, y| x <=> y } # => [1, 2, 3]\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"StaticArray"}],"args_string":"(other : StaticArray)","args_html":"(other : <a href=\"StaticArray.html\">StaticArray</a>)","location":{"filename":"src/static_array.cr","line_number":117,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"StaticArray"}],"visibility":"Public","body":"to_slice <=> other.to_slice"}},{"html_id":"==(other:StaticArray)-instance-method","name":"==","doc":"Equality. Returns `true` if each element in `self` is equal to each\ncorresponding element in *other*.\n\n```\narray = StaticArray(Int32, 3).new 0  # => StaticArray[0, 0, 0]\narray2 = StaticArray(Int32, 3).new 0 # => StaticArray[0, 0, 0]\narray3 = StaticArray(Int32, 3).new 1 # => StaticArray[1, 1, 1]\narray == array2                      # => true\narray == array3                      # => false\n```","summary":"<p>Equality.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"StaticArray"}],"args_string":"(other : StaticArray)","args_html":"(other : <a href=\"StaticArray.html\">StaticArray</a>)","location":{"filename":"src/static_array.cr","line_number":99,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"StaticArray"}],"visibility":"Public","body":"if size == other.size\nelse\n  return false\nend\neach_with_index do |e, i|\n  if e == other[i]\n  else\n    return false\n  end\nend\ntrue\n"}},{"html_id":"==(other)-instance-method","name":"==","doc":"Equality with another object. Always returns `false`.\n\n```\narray = StaticArray(Int32, 3).new 0 # => StaticArray[0, 0, 0]\narray == nil                        # => false\n```","summary":"<p>Equality with another object.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/static_array.cr","line_number":113,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"false"}},{"html_id":"clone-instance-method","name":"clone","doc":"Returns a new `StaticArray` where each element is cloned from elements in `self`.","summary":"<p>Returns a new <code><a href=\"StaticArray.html\">StaticArray</a></code> where each element is cloned from elements in <code>self</code>.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":403,"url":null},"def":{"name":"clone","visibility":"Public","body":"array = uninitialized self\nN.times do |i|\n  array.to_unsafe[i] = to_unsafe[i].clone\nend\narray\n"}},{"html_id":"fill(value:T,start:Int,count:Int):self-instance-method","name":"fill","doc":"Replaces *count* or less (if there aren't enough) elements starting at the\ngiven *start* index with *value*. Returns `self`.\n\nNegative values of *start* count from the end of the container.\n\nRaises `IndexError` if the *start* index is out of range.\n\nRaises `ArgumentError` if *count* is negative.\n\n```\narray = [1, 2, 3, 4, 5]\narray.fill(9, 2, 2) # => [1, 2, 9, 9, 5]\narray               # => [1, 2, 9, 9, 5]\n```","summary":"<p>Replaces <em>count</em> or less (if there aren't enough) elements starting at the given <em>start</em> index with <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(value : T, start : Int, count : Int) : self","args_html":"(value : T, start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <span class=\"k\">self</span>","location":{"filename":"src/static_array.cr","line_number":149,"url":null},"def":{"name":"fill","args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"to_slice.fill(value, start, count)\nself\n"}},{"html_id":"fill(value:T,range:Range):self-instance-method","name":"fill","doc":"Replaces the elements within the given *range* with *value*. Returns `self`.\n\nNegative indices count backward from the end of the container.\n\nRaises `IndexError` if the starting index is out of range.\n\n```\narray = [1, 2, 3, 4, 5]\narray.fill(9, 2..3) # => [1, 2, 9, 9, 5]\narray               # => [1, 2, 9, 9, 5]\n```","summary":"<p>Replaces the elements within the given <em>range</em> with <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(value : T, range : Range) : self","args_html":"(value : T, range : <a href=\"Range.html\">Range</a>) : <span class=\"k\">self</span>","location":{"filename":"src/static_array.cr","line_number":155,"url":null},"def":{"name":"fill","args":[{"name":"value","external_name":"value","restriction":"T"},{"name":"range","external_name":"range","restriction":"Range"}],"return_type":"self","visibility":"Public","body":"to_slice.fill(value, range)\nself\n"}},{"html_id":"fill(value:T):self-instance-method","name":"fill","doc":"Replaces every element in `self` with the given *value*. Returns `self`.\n\n```\narray = [1, 2, 3, 4]\narray.fill(2) # => [2, 2, 2, 2]\narray         # => [2, 2, 2, 2]\n```","summary":"<p>Replaces every element in <code>self</code> with the given <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(value : T) : self","args_html":"(value : T) : <span class=\"k\">self</span>","location":{"filename":"src/static_array.cr","line_number":142,"url":null},"def":{"name":"fill","args":[{"name":"value","external_name":"value","restriction":"T"}],"return_type":"self","visibility":"Public","body":"to_slice.fill(value)\nself\n"}},{"html_id":"index(object,offset:Int=0)-instance-method","name":"index","doc":"Returns the index of the first appearance of *value* in `self`\nstarting from the given *offset*, or `nil` if the value is not in `self`.\n\n```\n[1, 2, 3, 1, 2, 3].index(2, offset: 2) # => 4\n```","summary":"<p>Returns the index of the first appearance of <em>value</em> in <code>self</code> starting from the given <em>offset</em>, or <code>nil</code> if the value is not in <code>self</code>.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":""},{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"args_string":"(object, offset : Int = 0)","args_html":"(object, offset : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>)","location":{"filename":"src/static_array.cr","line_number":411,"url":null},"def":{"name":"index","args":[{"name":"object","external_name":"object","restriction":""},{"name":"offset","default_value":"0","external_name":"offset","restriction":"Int"}],"visibility":"Public","body":"if T.is_a?(UInt8.class) && (object.is_a?(UInt8) || (object.is_a?(Int) && (0 <= object && object < 256)))\n  return to_slice.fast_index(object, offset)\nend\nsuper(object, offset)\n"}},{"html_id":"map(&block:T->U):StaticArray(U,N)forallU-instance-method","name":"map","doc":"Returns a new static array where elements are mapped by the given block.\n\n```\narray = StaticArray[1, 2.5, \"a\"]\narray.map &.to_s # => StaticArray[\"1\", \"2.5\", \"a\"]\n```","summary":"<p>Returns a new static array where elements are mapped by the given block.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":166,"url":null},"def":{"name":"map","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> U)"},"return_type":"StaticArray(U, N)","visibility":"Public","body":"StaticArray(U, N).new do |i|\n  yield to_unsafe[i]\nend"}},{"html_id":"map_with_index(offset=0,&block:T,Int32->U):StaticArray(U,N)forallU-instance-method","name":"map_with_index","doc":"Like `map`, but the block gets passed both the element and its index.\n\nAccepts an optional *offset* parameter, which tells it to start counting\nfrom there.","summary":"<p>Like <code><a href=\"StaticArray.html#map%28%26block%3AT-%3EU%29%3AStaticArray%28U%2CN%29forallU-instance-method\">#map</a></code>, but the block gets passed both the element and its index.</p>","abstract":false,"args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(offset = 0, &block : T, Int32 -> U) : StaticArray(U, N) forall U","args_html":"(offset = <span class=\"n\">0</span>, &block : T, <a href=\"Int32.html\">Int32</a> -> U) : <a href=\"StaticArray.html\">StaticArray</a>(U, N) forall U","location":{"filename":"src/static_array.cr","line_number":174,"url":null},"def":{"name":"map_with_index","args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, Int32 -> U)"},"return_type":"StaticArray(U, N)","visibility":"Public","body":"StaticArray(U, N).new do |i|\n  yield to_unsafe[i], offset + i\nend"}},{"html_id":"pretty_print(pp)-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp)","args_html":"(pp)","location":{"filename":"src/static_array.cr","line_number":394,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"visibility":"Public","body":"pp.list(\"StaticArray[\", to_slice, \"]\")"}},{"html_id":"rotate!(n:Int=1):self-instance-method","name":"rotate!","doc":"Shifts all elements of `self` to the left *n* times. Returns `self`.\n\n```\na1 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\na2 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\na3 = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\n\na1.rotate!\na2.rotate!(1)\na3.rotate!(3)\n\na1 # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]\na2 # => [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]\na3 # => [3, 4, 5, 6, 7, 8, 9, 0, 1, 2]\n```","summary":"<p>Shifts all elements of <code>self</code> to the left <em>n</em> times.</p>","abstract":false,"args":[{"name":"n","default_value":"1","external_name":"n","restriction":"Int"}],"args_string":"(n : Int = 1) : self","args_html":"(n : <a href=\"Int.html\">Int</a> = <span class=\"n\">1</span>) : <span class=\"k\">self</span>","location":{"filename":"src/static_array.cr","line_number":354,"url":null},"def":{"name":"rotate!","args":[{"name":"n","default_value":"1","external_name":"n","restriction":"Int"}],"return_type":"self","visibility":"Public","body":"to_slice.rotate!(n)\nself\n"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Returns the size of `self`\n\n```\narray = StaticArray(Int32, 3).new { |i| i + 1 }\narray.size # => 3\n```","summary":"<p>Returns the size of <code>self</code></p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":137,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"N"}},{"html_id":"sort:StaticArray(T,N)-instance-method","name":"sort","doc":"Returns a new instance with all elements sorted based on the return value of\ntheir comparison method `T#<=>` (see `Comparable#<=>`), using a stable sort algorithm.\n\n```\na = StaticArray[3, 1, 2]\na.sort # => StaticArray[1, 2, 3]\na      # => StaticArray[3, 1, 2]\n```\n\nSee `Indexable::Mutable#sort!` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two elements returns `nil`.","summary":"<p>Returns a new instance with all elements sorted based on the return value of their comparison method <code>T#<=></code> (see <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">Comparable#<=></a></code>), using a stable sort algorithm.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":190,"url":null},"def":{"name":"sort","return_type":"StaticArray(T, N)","visibility":"Public","body":"ary = dup\nary.sort!\n"}},{"html_id":"sort(&block:T,T->U):StaticArray(T,N)forallU-instance-method","name":"sort","doc":"Returns a new instance with all elements sorted based on the comparator in the\ngiven block, using a stable sort algorithm.\n\n```\na = StaticArray[3, 1, 2]\nb = a.sort { |a, b| b <=> a }\n\nb # => StaticArray[3, 2, 1]\na # => StaticArray[3, 1, 2]\n```\n\nSee `Indexable::Mutable#sort!(&block : T, T -> U)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if for any two elements the block returns `nil`.=","summary":"<p>Returns a new instance with all elements sorted based on the comparator in the given block, using a stable sort algorithm.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":228,"url":null},"def":{"name":"sort","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> U)"},"return_type":"StaticArray(T, N)","visibility":"Public","body":"{% if U <= ::Union(Int32, ::Nil) %}{% else %}\n      {% raise(\"expected block to return Int32 or Nil, not #{U}\") %}\n    {% end %}\nary = dup\nary.sort!(&block)\n"}},{"html_id":"sort!:self-instance-method","name":"sort!","doc":"Sorts all elements in `self` based on the return value of the comparison\nmethod `T#<=>` (see `Comparable#<=>`), using a stable sort algorithm.\n\n```\na = [3, 1, 2]\na.sort!\na # => [1, 2, 3]\n```\n\nThis sort operation modifies `self`. See `#sort` for a non-modifying option\nthat allocates a new instance.\n\nSee `Slice#sort!` for details on the implementation.\n\nRaises `ArgumentError` if the comparison between any two elements returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the return value of the comparison method <code>T#<=></code> (see <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">Comparable#<=></a></code>), using a stable sort algorithm.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":261,"url":null},"def":{"name":"sort!","return_type":"self","visibility":"Public","body":"to_slice.sort!\nself\n"}},{"html_id":"sort!(&block:T,T->U):selfforallU-instance-method","name":"sort!","doc":"Sorts all elements in `self` based on the comparator in the given block, using\na stable sort algorithm.\n\nThe block must implement a comparison between two elements *a* and *b*,\nwhere `a < b` returns `-1`, `a == b` returns `0`, and `a > b` returns `1`.\nThe comparison operator `<=>` can be used for this.\n\n```\na = [3, 1, 2]\n# This is a reverse sort (forward sort would be `a <=> b`)\na.sort! { |a, b| b <=> a }\na # => [3, 2, 1]\n```\n\nThis sort operation modifies `self`. See `#sort(&block : T, T -> U)` for a\nnon-modifying option that allocates a new instance.\n\nSee `Slice#sort!(&block : T, T -> U)` for details on the implementation.\n\nRaises `ArgumentError` if for any two elements the block returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the comparator in the given block, using a stable sort algorithm.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":273,"url":null},"def":{"name":"sort!","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> U)"},"return_type":"self","visibility":"Public","body":"{% if U <= ::Union(Int32, ::Nil) %}{% else %}\n      {% raise(\"expected block to return Int32 or Nil, not #{U}\") %}\n    {% end %}\nto_slice.sort!(&block)\nself\n"}},{"html_id":"sort_by(&block:T->_):StaticArray(T,N)-instance-method","name":"sort_by","doc":"Returns a new instance with all elements sorted by the output value of the\nblock. The output values are compared via the comparison method `T#<=>`\n(see `Comparable#<=>`), using a stable sort algorithm.\n\n```\na = StaticArray[\"apple\", \"pear\", \"fig\"]\nb = a.sort_by { |word| word.size }\nb # => StaticArray[\"fig\", \"pear\", \"apple\"]\na # => StaticArray[\"apple\", \"pear\", \"fig\"]\n```\n\nIf stability is expendable, `#unstable_sort_by(&block : T -> _)` provides a\nperformance advantage over stable sort.\n\nSee `Indexable::Mutable#sort_by!(&block : T -> _)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two comparison values returns `nil`.","summary":"<p>Returns a new instance with all elements sorted by the output value of the block.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":309,"url":null},"def":{"name":"sort_by","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> _)"},"return_type":"StaticArray(T, N)","visibility":"Public","body":"ary = dup\nary.sort_by! do |e|\n  yield(e)\nend\n"}},{"html_id":"sort_by!(&block:T->_):self-instance-method","name":"sort_by!","doc":"Sorts all elements in `self` by the output value of the\nblock. The output values are compared via the comparison method `#<=>`\n(see `Comparable#<=>`), using a stable sort algorithm.\n\n```\na = %w(apple pear fig)\na.sort_by! { |word| word.size }\na # => [\"fig\", \"pear\", \"apple\"]\n```\n\nThis sort operation modifies `self`. See `#sort_by(&block : T -> _)` for a\nnon-modifying option that allocates a new instance.\n\nIf stability is expendable, `#unstable_sort_by!(&block : T -> _)` provides a\nperformance advantage over stable sort.\n\nSee `#sort!(&block : T -> _)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two comparison values returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> by the output value of the block.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":336,"url":null},"def":{"name":"sort_by!","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> _)"},"return_type":"self","visibility":"Public","body":"sorted = map do |e|\n  {e, yield(e)}\nend.sort! do |x, y|\n  x[1] <=> y[1]\nend\nN.times do |i|\n  to_unsafe[i] = sorted.to_unsafe[i][0]\nend\nself\n"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a string representation of this static array to the given `IO`.\n\n```\narray = StaticArray(Int32, 3).new { |i| i + 1 }\narray.to_s # => \"StaticArray[1, 2, 3]\"\n```","summary":"<p>Appends a string representation of this static array to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/static_array.cr","line_number":388,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"StaticArray[\"\njoin(io, \", \", &.inspect(io))\nio << ']'\n"}},{"html_id":"to_slice:Slice(T)-instance-method","name":"to_slice","doc":"Returns a slice that points to the elements of this static array.\nChanges made to the returned slice also affect this static array.\n\n```\narray = StaticArray(Int32, 3).new(2)\nslice = array.to_slice # => Slice[2, 2, 2]\nslice[0] = 3\narray # => StaticArray[3, 2, 2]\n```","summary":"<p>Returns a slice that points to the elements of this static array.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":368,"url":null},"def":{"name":"to_slice","return_type":"Slice(T)","visibility":"Public","body":"Slice.new(to_unsafe, size)"}},{"html_id":"to_unsafe:Pointer(T)-instance-method","name":"to_unsafe","doc":"Returns a pointer to this static array's data.\n\n```\nary = StaticArray(Int32, 3).new(42)\nary.to_unsafe[0] # => 42\n```","summary":"<p>Returns a pointer to this static array's data.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":378,"url":null},"def":{"name":"to_unsafe","return_type":"Pointer(T)","visibility":"Public","body":"pointerof(@buffer)"}},{"html_id":"unsafe_fetch(index:Int):T-instance-method","name":"unsafe_fetch","doc":"Returns the element at the given *index*, without doing any bounds check.\n\n`Indexable` makes sure to invoke this method with *index* in `0...size`,\nso converting negative indices to positive ones is not needed here.\n\nClients never invoke this method directly. Instead, they access\nelements with `#[](index)` and `#[]?(index)`.\n\nThis method should only be directly invoked if you are absolutely\nsure the index is in bounds, to avoid a bounds check for a small boost\nof performance.","summary":"<p>Returns the element at the given <em>index</em>, without doing any bounds check.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : T","args_html":"(index : <a href=\"Int.html\">Int</a>) : T","location":{"filename":"src/static_array.cr","line_number":122,"url":null},"def":{"name":"unsafe_fetch","args":[{"name":"index","external_name":"index","restriction":"Int"}],"return_type":"T","visibility":"Public","body":"to_unsafe[index]"}},{"html_id":"unsafe_put(index:Int,value:T)-instance-method","name":"unsafe_put","doc":"Sets the element at the given *index* to *value*, without doing any bounds\ncheck.\n\n`Indexable::Mutable` makes sure to invoke this method with *index* in\n`0...size`, so converting negative indices to positive ones is not needed\nhere.\n\nClients never invoke this method directly. Instead, they modify elements\nwith `#[]=(index, value)`.\n\nThis method should only be directly invoked if you are absolutely\nsure the index is in bounds, to avoid a bounds check for a small boost\nof performance.","summary":"<p>Sets the element at the given <em>index</em> to <em>value</em>, without doing any bounds check.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"args_string":"(index : Int, value : T)","args_html":"(index : <a href=\"Int.html\">Int</a>, value : T)","location":{"filename":"src/static_array.cr","line_number":127,"url":null},"def":{"name":"unsafe_put","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"value","external_name":"value","restriction":"T"}],"visibility":"Public","body":"to_unsafe[index] = value"}},{"html_id":"unstable_sort:StaticArray(T,N)-instance-method","name":"unstable_sort","doc":"Returns a new instance with all elements sorted based on the return value of\ntheir comparison method `T#<=>` (see `Comparable#<=>`), using an unstable sort algorithm.\n\n```\na = StaticArray[3, 1, 2]\na.unstable_sort # => StaticArray[1, 2, 3]\na               # => StaticArray[3, 1, 2]\n```\n\nSee `Indexable::Mutable#unstable_sort!` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two elements returns `nil`.","summary":"<p>Returns a new instance with all elements sorted based on the return value of their comparison method <code>T#<=></code> (see <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">Comparable#<=></a></code>), using an unstable sort algorithm.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":209,"url":null},"def":{"name":"unstable_sort","return_type":"StaticArray(T, N)","visibility":"Public","body":"ary = dup\nary.unstable_sort!\n"}},{"html_id":"unstable_sort(&block:T,T->U):StaticArray(T,N)forallU-instance-method","name":"unstable_sort","doc":"Returns a new instance with all elements sorted based on the comparator in the\ngiven block, using an unstable sort algorithm.\n\n```\na = StaticArray[3, 1, 2]\nb = a.unstable_sort { |a, b| b <=> a }\n\nb # => StaticArray[3, 2, 1]\na # => StaticArray[3, 1, 2]\n```\n\nSee `Indexable::Mutable#unstable_sort!(&block : T, T -> U)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if for any two elements the block returns `nil`.","summary":"<p>Returns a new instance with all elements sorted based on the comparator in the given block, using an unstable sort algorithm.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":251,"url":null},"def":{"name":"unstable_sort","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> U)"},"return_type":"StaticArray(T, N)","visibility":"Public","body":"{% if U <= ::Union(Int32, ::Nil) %}{% else %}\n      {% raise(\"expected block to return Int32 or Nil, not #{U}\") %}\n    {% end %}\nary = dup\nary.unstable_sort!(&block)\n"}},{"html_id":"unstable_sort!:self-instance-method","name":"unstable_sort!","doc":"Sorts all elements in `self` based on the return value of the comparison\nmethod `T#<=>` (see `Comparable#<=>`), using an unstable sort algorithm.\n\n```\na = [3, 1, 2]\na.unstable_sort!\na # => [1, 2, 3]\n```\n\nThis sort operation modifies `self`. See `#unstable_sort` for a non-modifying\noption that allocates a new instance.\n\nSee `Slice#unstable_sort!` for details on the implementation.\n\nRaises `ArgumentError` if the comparison between any two elements returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the return value of the comparison method <code>T#<=></code> (see <code><a href=\"Comparable.html#%3C%3D%3E%28other%3AT%29-instance-method\">Comparable#<=></a></code>), using an unstable sort algorithm.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":267,"url":null},"def":{"name":"unstable_sort!","return_type":"self","visibility":"Public","body":"to_slice.unstable_sort!\nself\n"}},{"html_id":"unstable_sort!(&block:T,T->U):selfforallU-instance-method","name":"unstable_sort!","doc":"Sorts all elements in `self` based on the comparator in the given block,\nusing an unstable sort algorithm.\n\nThe block must implement a comparison between two elements *a* and *b*,\nwhere `a < b` returns `-1`, `a == b` returns `0`, and `a > b` returns `1`.\nThe comparison operator `<=>` can be used for this.\n\n```\na = [3, 1, 2]\n# This is a reverse sort (forward sort would be `a <=> b`)\na.unstable_sort! { |a, b| b <=> a }\na # => [3, 2, 1]\n```\n\nThis sort operation modifies `self`. See `#unstable_sort(&block : T, T -> U)`\nfor a non-modifying option that allocates a new instance.\n\nSee `Slice#unstable_sort!(&block : T, T -> U)` for details on the implementation.\n\nRaises `ArgumentError` if for any two elements the block returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> based on the comparator in the given block, using an unstable sort algorithm.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":283,"url":null},"def":{"name":"unstable_sort!","yields":2,"block_arg":{"name":"block","external_name":"block","restriction":"(T, T -> U)"},"return_type":"self","visibility":"Public","body":"{% if U <= ::Union(Int32, ::Nil) %}{% else %}\n      {% raise(\"expected block to return Int32 or Nil, not #{U}\") %}\n    {% end %}\nto_slice.unstable_sort!(&block)\nself\n"}},{"html_id":"unstable_sort_by(&block:T->_):StaticArray(T,N)-instance-method","name":"unstable_sort_by","doc":"Returns a new instance with all elements sorted by the output value of the\nblock. The output values are compared via the comparison method `#<=>`\n(see `Comparable#<=>`), using an unstable sort algorithm.\n\n```\na = StaticArray[\"apple\", \"pear\", \"fig\"]\nb = a.unstable_sort_by { |word| word.size }\nb # => StaticArray[\"fig\", \"pear\", \"apple\"]\na # => StaticArray[\"apple\", \"pear\", \"fig\"]\n```\n\nIf stability is necessary, use `#sort_by(&block : T -> _)` instead.\n\nSee `Indexable::Mutable#unstable_sort!(&block : T -> _)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two comparison values returns `nil`.","summary":"<p>Returns a new instance with all elements sorted by the output value of the block.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":330,"url":null},"def":{"name":"unstable_sort_by","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> _)"},"return_type":"StaticArray(T, N)","visibility":"Public","body":"ary = dup\nary.unstable_sort_by! do |e|\n  yield(e)\nend\n"}},{"html_id":"unstable_sort_by!(&block:T->_):self-instance-method","name":"unstable_sort_by!","doc":"Sorts all elements in `self` by the output value of the\nblock. The output values are compared via the comparison method `#<=>`\n(see `Comparable#<=>`), using an unstable sort algorithm.\n\n```\na = %w(apple pear fig)\na.usntable_sort_by! { |word| word.size }\na # => [\"fig\", \"pear\", \"apple\"]\n```\n\nThis sort operation modifies `self`. See `#unstable_sort_by(&block : T -> _)`\nfor a non-modifying option that allocates a new instance.\n\nIf stability is necessary, use  `#sort_by!(&block : T -> _)` instead.\n\nSee `#unstable_sort!(&block : T -> _)` for details on the sorting mechanism.\n\nRaises `ArgumentError` if the comparison between any two comparison values returns `nil`.","summary":"<p>Sorts all elements in <code>self</code> by the output value of the block.</p>","abstract":false,"location":{"filename":"src/static_array.cr","line_number":345,"url":null},"def":{"name":"unstable_sort_by!","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(T -> _)"},"return_type":"self","visibility":"Public","body":"sorted = map do |e|\n  {e, yield(e)}\nend.unstable_sort! do |x, y|\n  x[1] <=> y[1]\nend\nN.times do |i|\n  to_unsafe[i] = sorted.to_unsafe[i][0]\nend\nself\n"}}],"macros":[{"html_id":"[](*args)-macro","name":"[]","doc":"Creates a new `StaticArray` with the given *args*. The type of the\nstatic array will be the union of the type of the given *args*,\nand its size will be the number of elements in *args*.\n\n```\nary = StaticArray[1, 'a']\nary[0]    # => 1\nary[1]    # => 'a'\nary.class # => StaticArray(Char | Int32, 2)\n```\n\nSee also: `Number.static_array`.","summary":"<p>Creates a new <code><a href=\"StaticArray.html\">StaticArray</a></code> with the given <em>args</em>.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args)","args_html":"(*args)","location":{"filename":"src/static_array.cr","line_number":51,"url":null},"def":{"name":"[]","args":[{"name":"args","external_name":"args","restriction":""}],"splat_index":0,"visibility":"Public","body":"    \n%array\n = uninitialized StaticArray(typeof(\n{{ *args }}\n), \n{{ args.size }}\n)\n    \n{% for arg, i in args %}\n      %array.to_unsafe[{{ i }}] = {{ arg }}\n    {% end %}\n\n    \n%array\n\n  \n"}}]},{"html_id":"Crystal/Steppable","path":"Steppable.html","kind":"module","full_name":"Steppable","name":"Steppable","abstract":false,"locations":[{"filename":"src/steppable.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"including_types":[{"html_id":"Crystal/Char","kind":"struct","full_name":"Char","name":"Char"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Time","kind":"struct","full_name":"Time","name":"Time"},{"html_id":"Crystal/Time/Span","kind":"struct","full_name":"Time::Span","name":"Span"}],"doc":"Implements a `#step` method for iterating from a value.","summary":"<p>Implements a <code><a href=\"Steppable.html#step%28%2A%2Ctolimit%3Dnil%2Cbystep%2Cexclusive%3ABool%3Dfalse%2C%26%29%3ANil-instance-method\">#step</a></code> method for iterating from a value.</p>","instance_methods":[{"html_id":"step(*,tolimit=nil,bystep,exclusive:Bool=false,&):Nil-instance-method","name":"step","doc":"Iterates from `self` to *limit* incrementing by the amount of *step* on each\niteration.\nIf *exclusive* is `true`, *limit* is excluded from the iteration.\n\n```\nary = [] of Int32\n1.step(to: 4, by: 2) do |x|\n  ary << x\nend\nary                                        # => [1, 3]\n1.step(to: 4, by: 2).to_a                  # => [1, 3]\n1.step(to: 4, by: 1).to_a                  # => [1, 2, 3, 4]\n1.step(to: 4, by: 1, exclusive: true).to_a # => [1, 2, 3]\n```\n\nThe type of each iterated element is `typeof(self + step)`.\n\nIf *to* is `nil`, iteration is open ended.\n\nThe starting point (`self`) is always iterated as first element, with two\nexceptions:\n* if `self` and *to* don't compare (i.e. `(self <=> to).nil?`). Example:\n  `1.0.step(Float::NAN)`\n* if the direction of *to* differs from the direction of `by`. Example:\n  `1.step(to: 2, by: -1)`\n\nIn those cases the iteration is empty.","summary":"<p>Iterates from <code>self</code> to <em>limit</em> incrementing by the amount of <em>step</em> on each iteration.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"limit","default_value":"nil","external_name":"to","restriction":""},{"name":"step","external_name":"by","restriction":""},{"name":"exclusive","default_value":"false","external_name":"exclusive","restriction":"Bool"}],"args_string":"(*, to limit = nil, by step, exclusive : Bool = false, &) : Nil","args_html":"(*, to limit = <span class=\"n\">nil</span>, by step, exclusive : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/steppable.cr","line_number":32,"url":null},"def":{"name":"step","args":[{"name":"","external_name":"","restriction":""},{"name":"limit","default_value":"nil","external_name":"to","restriction":""},{"name":"step","external_name":"by","restriction":""},{"name":"exclusive","default_value":"false","external_name":"exclusive","restriction":"Bool"}],"splat_index":0,"yields":1,"return_type":"Nil","visibility":"Public","body":"current = self + (step - step)\nif limit == current\n  if exclusive\n  else\n    yield current\n  end\n  return\nend\nif step.zero?\n  raise(ArgumentError.new(\"Zero step size\"))\nend\ndirection = step.sign\nif limit\n  if (limit <=> current).try(&.sign) == direction\n  else\n    return\n  end\n  yield current\n  while true\n    sign = ((limit - step) <=> current).try(&.sign)\n    if (sign == direction) || ((sign == 0) && (!exclusive))\n    else\n      break\n    end\n    current = current + step\n    yield current\n  end\nelse\n  while true\n    yield current\n    current = current + step\n  end\nend\nself\n"}},{"html_id":"step(*,tolimit=nil,bystep,exclusive:Bool=false)-instance-method","name":"step","doc":"Iterates from `self` to *limit* incrementing by the amount of *step* on each\niteration.\nIf *exclusive* is `true`, *limit* is excluded from the iteration.\n\n```\nary = [] of Int32\n1.step(to: 4, by: 2) do |x|\n  ary << x\nend\nary                                        # => [1, 3]\n1.step(to: 4, by: 2).to_a                  # => [1, 3]\n1.step(to: 4, by: 1).to_a                  # => [1, 2, 3, 4]\n1.step(to: 4, by: 1, exclusive: true).to_a # => [1, 2, 3]\n```\n\nThe type of each iterated element is `typeof(self + step)`.\n\nIf *to* is `nil`, iteration is open ended.\n\nThe starting point (`self`) is always iterated as first element, with two\nexceptions:\n* if `self` and *to* don't compare (i.e. `(self <=> to).nil?`). Example:\n  `1.0.step(Float::NAN)`\n* if the direction of *to* differs from the direction of `by`. Example:\n  `1.step(to: 2, by: -1)`\n\nIn those cases the iteration is empty.","summary":"<p>Iterates from <code>self</code> to <em>limit</em> incrementing by the amount of <em>step</em> on each iteration.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"limit","default_value":"nil","external_name":"to","restriction":""},{"name":"step","external_name":"by","restriction":""},{"name":"exclusive","default_value":"false","external_name":"exclusive","restriction":"Bool"}],"args_string":"(*, to limit = nil, by step, exclusive : Bool = false)","args_html":"(*, to limit = <span class=\"n\">nil</span>, by step, exclusive : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>)","location":{"filename":"src/steppable.cr","line_number":73,"url":null},"def":{"name":"step","args":[{"name":"","external_name":"","restriction":""},{"name":"limit","default_value":"nil","external_name":"to","restriction":""},{"name":"step","external_name":"by","restriction":""},{"name":"exclusive","default_value":"false","external_name":"exclusive","restriction":"Bool"}],"splat_index":0,"visibility":"Public","body":"if step.zero? && (limit != self)\n  raise(ArgumentError.new(\"Zero step size\"))\nend\nStepIterator.new(self + (step - step), limit, step, exclusive: exclusive)\n"}}],"types":[{"html_id":"Crystal/Steppable/StepIterator","path":"Steppable/StepIterator.html","kind":"class","full_name":"Steppable::StepIterator(T, L, B)","name":"StepIterator","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Iterator","kind":"module","full_name":"Iterator","name":"Iterator"},{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/steppable.cr","line_number":79,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Iterator","kind":"module","full_name":"Iterator","name":"Iterator"}],"namespace":{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},"constructors":[{"html_id":"new(current:T,limit:L,step:B,exclusive:Bool)-class-method","name":"new","abstract":false,"args":[{"name":"current","external_name":"current","restriction":"T"},{"name":"limit","external_name":"limit","restriction":"L"},{"name":"step","external_name":"step","restriction":"B"},{"name":"exclusive","external_name":"exclusive","restriction":"Bool"}],"args_string":"(current : T, limit : L, step : B, exclusive : Bool)","args_html":"(current : T, limit : L, step : B, exclusive : <a href=\"../Bool.html\">Bool</a>)","location":{"filename":"src/steppable.cr","line_number":88,"url":null},"def":{"name":"new","args":[{"name":"current","external_name":"current","restriction":"T"},{"name":"limit","external_name":"limit","restriction":"L"},{"name":"step","external_name":"step","restriction":"B"},{"name":"exclusive","external_name":"exclusive","restriction":"Bool"}],"visibility":"Public","body":"_ = StepIterator(T, L, B).allocate\n_.initialize(current, limit, step, exclusive)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"next-instance-method","name":"next","doc":"Returns the next element in this iterator, or `Iterator::Stop::INSTANCE` if there\nare no more elements.","summary":"<p>Returns the next element in this iterator, or <code><a href=\"../Iterator/Stop.html#INSTANCE\">Iterator::Stop::INSTANCE</a></code> if there are no more elements.</p>","abstract":false,"location":{"filename":"src/steppable.cr","line_number":91,"url":null},"def":{"name":"next","visibility":"Public","body":"if @reached_end\n  return stop\nend\nlimit = @limit\nif @at_start\n  @at_start = false\n  if limit\n    sign = (limit <=> @current).try(&.sign)\n    @reached_end = sign == 0\n    if ((!@reached_end) && (sign != @step.sign)) || (@reached_end && @exclusive)\n      @reached_end = true\n      return stop\n    end\n  end\n  @current\nelse\n  if limit\n    case ((limit - @step) <=> @current).try(&.sign)\n    when @step.sign\n      @current = @current + @step\n    when 0\n      @reached_end = true\n      if @exclusive\n        stop\n      else\n        @current + @step\n      end\n    else\n      @reached_end = true\n      stop\n    end\n  else\n    @current = @current + @step\n  end\nend\n"}},{"html_id":"sum(initial)-instance-method","name":"sum","doc":"Overrides `Enumerable#sum` to use more performant implementation on integer\nranges.","summary":"<p>Overrides <code><a href=\"../Enumerable.html#sum-instance-method\">Enumerable#sum</a></code> to use more performant implementation on integer ranges.</p>","abstract":false,"args":[{"name":"initial","external_name":"initial","restriction":""}],"args_string":"(initial)","args_html":"(initial)","location":{"filename":"src/steppable.cr","line_number":138,"url":null},"def":{"name":"sum","args":[{"name":"initial","external_name":"initial","restriction":""}],"visibility":"Public","body":"if @reached_end\n  return super(initial)\nend\ncurrent = @current\nlimit = @limit\nstep = @step\nif (current.is_a?(Int) && limit.is_a?(Int)) && step.is_a?(Int)\n  if @exclusive\n    limit = limit - 1\n  end\n  n = ((limit - current) // step) + 1\n  if n >= 0\n    limit = current + ((n - 1) * step)\n    initial + ((n * (current + limit)) // 2)\n  else\n    initial\n  end\nelse\n  super(initial)\nend\n"}}]}]},{"html_id":"Crystal/String","path":"String.html","kind":"class","full_name":"String","name":"String","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/big_decimal.cr","line_number":696,"url":null},{"filename":"src/big/big_float.cr","line_number":383,"url":null},{"filename":"src/big/big_int.cr","line_number":789,"url":null},{"filename":"src/json/to_json.cr","line_number":63,"url":null},{"filename":"src/string.cr","line_number":137,"url":null},{"filename":"src/string/grapheme.cr","line_number":3,"url":null},{"filename":"src/string/grapheme/grapheme.cr","line_number":3,"url":null},{"filename":"src/string/utf16.cr","line_number":1,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":61,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"doc":"A `String` represents an immutable sequence of UTF-8 characters.\n\nA `String` is typically created with a string literal, enclosing UTF-8 characters\nin double quotes:\n\n```\n\"hello world\"\n```\n\nSee [`String` literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/string.html) in the language reference.\n\nA backslash can be used to denote some characters inside the string:\n\n```\n\"\\\"\" # double quote\n\"\\\\\" # backslash\n\"\\e\" # escape\n\"\\f\" # form feed\n\"\\n\" # newline\n\"\\r\" # carriage return\n\"\\t\" # tab\n\"\\v\" # vertical tab\n```\n\nYou can use a backslash followed by an *u* and four hexadecimal characters to denote a unicode codepoint written:\n\n```\n\"\\u0041\" # == \"A\"\n```\n\nOr you can use curly braces and specify up to six hexadecimal numbers (0 to 10FFFF):\n\n```\n\"\\u{41}\" # == \"A\"\n```\n\nA string can span multiple lines:\n\n```\n\"hello\n      world\" # same as \"hello\\n      world\"\n```\n\nNote that in the above example trailing and leading spaces, as well as newlines,\nend up in the resulting string. To avoid this, you can split a string into multiple lines\nby joining multiple literals with a backslash:\n\n```\n\"hello \" \\\n\"world, \" \\\n\"no newlines\" # same as \"hello world, no newlines\"\n```\n\nAlternatively, a backslash followed by a newline can be inserted inside the string literal:\n\n```\n\"hello \\\n     world, \\\n     no newlines\" # same as \"hello world, no newlines\"\n```\n\nIn this case, leading whitespace is not included in the resulting string.\n\nIf you need to write a string that has many double quotes, parentheses, or similar\ncharacters, you can use alternative literals:\n\n```\n# Supports double quotes and nested parentheses\n%(hello (\"world\")) # same as \"hello (\\\"world\\\")\"\n\n# Supports double quotes and nested brackets\n%[hello [\"world\"]] # same as \"hello [\\\"world\\\"]\"\n\n# Supports double quotes and nested curlies\n%{hello {\"world\"}} # same as \"hello {\\\"world\\\"}\"\n\n# Supports double quotes and nested angles\n%<hello <\"world\">> # same as \"hello <\\\"world\\\">\"\n```\n\nTo create a `String` with embedded expressions, you can use string interpolation:\n\n```\na = 1\nb = 2\n\"sum = #{a + b}\" # \"sum = 3\"\n```\n\nThis ends up invoking `Object#to_s(IO)` on each expression enclosed by `#{...}`.\n\nIf you need to dynamically build a string, use `String#build` or `IO::Memory`.\n\n### Non UTF-8 valid strings\n\nString might end up being conformed of bytes which are an invalid\nbyte sequence according to UTF-8. This can happen if the string is created\nvia one of the constructors that accept bytes, or when getting a string\nfrom `String.build` or `IO::Memory`. No exception will be raised, but\ninvalid byte sequences, when asked as chars, will use the unicode replacement\nchar (value 0xFFFD). For example:\n\n```\n# here 255 is not a valid byte value in the UTF-8 encoding\nstring = String.new(Bytes[255, 97])\nstring.valid_encoding? # => false\n\n# The first char here is the unicode replacement char\nstring.chars # => ['�', 'a']\n```\n\nOne can also create strings with specific byte value in them by\nusing octal and hexadecimal escape sequences:\n\n```\n# Octal escape sequences\n\"\\101\" # # => \"A\"\n\"\\12\"  # # => \"\\n\"\n\"\\1\"   # string with one character with code point 1\n\"\\377\" # string with one byte with value 255\n\n# Hexadecimal escape sequences\n\"\\x41\" # # => \"A\"\n\"\\xFF\" # string with one byte with value 255\n```\n\nThe reason for allowing strings that don't have a valid UTF-8 sequence\nis that the world is full of content that isn't properly encoded,\nand having a program raise an exception or stop because of this\nis not good. It's better if programs are more resilient, but\nshow a replacement character when there's an error in incoming data.","summary":"<p>A <code><a href=\"String.html\">String</a></code> represents an immutable sequence of UTF-8 characters.</p>","class_methods":[{"html_id":"from_utf16(pointer:Pointer(UInt16)):Tuple(String,Pointer(UInt16))-class-method","name":"from_utf16","doc":"Decodes the given *slice* UTF-16 sequence into a String and returns the\npointer after reading. The string ends when a zero value is found.\n\n```\nslice = Slice[104_u16, 105_u16, 0_u16, 55296_u16, 56485_u16, 0_u16]\nString.from_utf16(slice) # => \"hi\\0000𐂥\"\npointer = slice.to_unsafe\nstring, pointer = String.from_utf16(pointer) # => \"hi\"\nstring, pointer = String.from_utf16(pointer) # => \"𐂥\"\n```\n\nInvalid values are encoded using the unicode replacement char with\ncodepoint `0xfffd`.","summary":"<p>Decodes the given <em>slice</em> UTF-16 sequence into a String and returns the pointer after reading.</p>","abstract":false,"args":[{"name":"pointer","external_name":"pointer","restriction":"Pointer(UInt16)"}],"args_string":"(pointer : Pointer(UInt16)) : Tuple(String, Pointer(UInt16))","args_html":"(pointer : <a href=\"Pointer.html\">Pointer</a>(<a href=\"UInt16.html\">UInt16</a>)) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"String.html\">String</a>, <a href=\"Pointer.html\">Pointer</a>(<a href=\"UInt16.html\">UInt16</a>))","location":{"filename":"src/string/utf16.cr","line_number":107,"url":null},"def":{"name":"from_utf16","args":[{"name":"pointer","external_name":"pointer","restriction":"Pointer(UInt16)"}],"return_type":"::Tuple(String, Pointer(UInt16))","visibility":"Public","body":"bytesize = 0\nsize = 0\neach_utf16_char(pointer) do |char|\n  bytesize = bytesize + char.bytesize\n  size = size + 1\nend\nstring = String.new(bytesize) do |buffer|\n  pointer = each_utf16_char(pointer) do |char|\n    char.each_byte do |byte|\n      buffer.value = byte\n      buffer = buffer + 1\n    end\n  end\n  {bytesize, size}\nend\n{string, pointer + 1}\n"}}],"constructors":[{"html_id":"build(capacity=64,&):self-class-method","name":"build","doc":"Builds a `String` by creating a `String::Builder` with the given initial capacity, yielding\nit to the block and finally getting a `String` out of it. The `String::Builder` automatically\nresizes as needed.\n\n```\nstr = String.build do |str|\n  str << \"hello \"\n  str << 1\nend\nstr # => \"hello 1\"\n```","summary":"<p>Builds a <code><a href=\"String.html\">String</a></code> by creating a <code><a href=\"String/Builder.html\">String::Builder</a></code> with the given initial capacity, yielding it to the block and finally getting a <code><a href=\"String.html\">String</a></code> out of it.</p>","abstract":false,"args":[{"name":"capacity","default_value":"64","external_name":"capacity","restriction":""}],"args_string":"(capacity = 64, &) : self","args_html":"(capacity = <span class=\"n\">64</span>, &) : <span class=\"k\">self</span>","location":{"filename":"src/string.cr","line_number":278,"url":null},"def":{"name":"build","args":[{"name":"capacity","default_value":"64","external_name":"capacity","restriction":""}],"yields":1,"return_type":"self","visibility":"Public","body":"String::Builder.build(capacity) do |builder|\n  yield builder\nend"}},{"html_id":"from_json_object_key?(key:String):String-class-method","name":"from_json_object_key?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String) : String","args_html":"(key : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/json/from_json.cr","line_number":144,"url":null},"def":{"name":"from_json_object_key?","args":[{"name":"key","external_name":"key","restriction":"String"}],"return_type":"String","visibility":"Public","body":"key"}},{"html_id":"from_utf16(slice:Slice(UInt16)):String-class-method","name":"from_utf16","doc":"Decodes the given *slice* UTF-16 sequence into a String.\n\nInvalid values are encoded using the unicode replacement char with\ncodepoint `0xfffd`.\n\n```\nslice = Slice[104_u16, 105_u16, 32_u16, 55296_u16, 56485_u16]\nString.from_utf16(slice) # => \"hi 𐂥\"\n```","summary":"<p>Decodes the given <em>slice</em> UTF-16 sequence into a String.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Slice(UInt16)"}],"args_string":"(slice : Slice(UInt16)) : String","args_html":"(slice : <a href=\"Slice.html\">Slice</a>(<a href=\"UInt16.html\">UInt16</a>)) : <a href=\"String.html\">String</a>","location":{"filename":"src/string/utf16.cr","line_number":74,"url":null},"def":{"name":"from_utf16","args":[{"name":"slice","external_name":"slice","restriction":"Slice(UInt16)"}],"return_type":"String","visibility":"Public","body":"bytesize = 0\nsize = 0\neach_utf16_char(slice) do |char|\n  bytesize = bytesize + char.bytesize\n  size = size + 1\nend\nString.new(bytesize) do |buffer|\n  each_utf16_char(slice) do |char|\n    char.each_byte do |byte|\n      buffer.value = byte\n      buffer = buffer + 1\n    end\n  end\n  {bytesize, size}\nend\n"}},{"html_id":"interpolation(value:String,char:Char):String-class-method","name":"interpolation","doc":"Implementation of string interpolation of a string and a char.\n\nFor example, this code will end up invoking this method:\n\n```\nchar = '!'\n\"hello#{char}\" # same as String.interpolation(\"hello\", char)\n```\n\nIn this case the implementation just does `value + char`.\n\nNOTE: there should never be a need to call this method instead of using string interpolation.","summary":"<p>Implementation of string interpolation of a string and a char.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"char","external_name":"char","restriction":"Char"}],"args_string":"(value : String, char : Char) : String","args_html":"(value : <a href=\"String.html\">String</a>, char : <a href=\"Char.html\">Char</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":5199,"url":null},"def":{"name":"interpolation","args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"char","external_name":"char","restriction":"Char"}],"return_type":"String","visibility":"Public","body":"value + char"}},{"html_id":"interpolation(char:Char,value:String):String-class-method","name":"interpolation","doc":"Implementation of string interpolation of a char and a string.\n\nFor example, this code will end up invoking this method:\n\n```\nchar = '!'\n\"#{char}hello\" # same as String.interpolation(char, \"hello\")\n```\n\nIn this case the implementation just does `char + value`.\n\nNOTE: there should never be a need to call this method instead of using string interpolation.","summary":"<p>Implementation of string interpolation of a char and a string.</p>","abstract":false,"args":[{"name":"char","external_name":"char","restriction":"Char"},{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(char : Char, value : String) : String","args_html":"(char : <a href=\"Char.html\">Char</a>, value : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":5215,"url":null},"def":{"name":"interpolation","args":[{"name":"char","external_name":"char","restriction":"Char"},{"name":"value","external_name":"value","restriction":"String"}],"return_type":"String","visibility":"Public","body":"char + value"}},{"html_id":"interpolation(value:String):String-class-method","name":"interpolation","doc":"Implementation of string interpolation of a single string.\n\nFor example, this code will end up invoking this method:\n\n```\nvalue = \"hello\"\n\"#{value}\" # same as String.interpolation(value)\n```\n\nIn this case the implementation just returns the same string.\n\nNOTE: there should never be a need to call this method instead of using string interpolation.","summary":"<p>Implementation of string interpolation of a single string.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(value : String) : String","args_html":"(value : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":5167,"url":null},"def":{"name":"interpolation","args":[{"name":"value","external_name":"value","restriction":"String"}],"return_type":"String","visibility":"Public","body":"value"}},{"html_id":"interpolation(value):String-class-method","name":"interpolation","doc":"Implementation of string interpolation of a single non-string value.\n\nFor example, this code will end up invoking this method:\n\n```\nvalue = 123\n\"#{value}\" # same as String.interpolation(value)\n```\n\nIn this case the implementation just returns the result of calling `value.to_s`.\n\nNOTE: there should never be a need to call this method instead of using string interpolation.","summary":"<p>Implementation of string interpolation of a single non-string value.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : String","args_html":"(value) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":5183,"url":null},"def":{"name":"interpolation","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"String","visibility":"Public","body":"value.to_s"}},{"html_id":"interpolation(*values:String):String-class-method","name":"interpolation","doc":"Implementation of string interpolation of multiple string values.\n\nFor example, this code will end up invoking this method:\n\n```\nvalue1 = \"hello\"\nvalue2 = \"world\"\n\"#{value1} #{value2}!\" # same as String.interpolation(value1, \" \", value2, \"!\")\n```\n\nIn this case the implementation can pre-compute the needed string bytesize and so\nit's a bit more performant than interpolating non-string values.\n\nNOTE: there should never be a need to call this method instead of using string interpolation.","summary":"<p>Implementation of string interpolation of multiple string values.</p>","abstract":false,"args":[{"name":"values","external_name":"values","restriction":"String"}],"args_string":"(*values : String) : String","args_html":"(*values : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":5233,"url":null},"def":{"name":"interpolation","args":[{"name":"values","external_name":"values","restriction":"String"}],"splat_index":0,"return_type":"String","visibility":"Public","body":"bytesize = values.sum(&.bytesize)\nsize = if values.all?(&.size_known?)\n  values.sum(&.size)\nelse\n  0\nend\nString.new(bytesize) do |buffer|\n  values.each do |value|\n    buffer.copy_from(value.to_unsafe, value.bytesize)\n    buffer = buffer + value.bytesize\n  end\n  {bytesize, size}\nend\n"}},{"html_id":"interpolation(*values:*T):StringforallT-class-method","name":"interpolation","doc":"Implementation of string interpolation of multiple, possibly non-string values.\n\nFor example, this code will end up invoking this method:\n\n```\nvalue1 = \"hello\"\nvalue2 = 123\n\"#{value1} #{value2}!\" # same as String.interpolation(value1, \" \", value2, \"!\")\n```\n\nIn this case the implementation will call `String.build` with the given values.\n\nNOTE: there should never be a need to call this method instead of using string interpolation.","summary":"<p>Implementation of string interpolation of multiple, possibly non-string values.</p>","abstract":false,"args":[{"name":"values","external_name":"values","restriction":"*T"}],"args_string":"(*values : *T) : String forall T","args_html":"(*values : <span class=\"o\">*</span><span class=\"t\">T</span>) : <a href=\"String.html\">String</a> forall T","location":{"filename":"src/string.cr","line_number":5262,"url":null},"def":{"name":"interpolation","args":[{"name":"values","external_name":"values","restriction":"*T"}],"splat_index":0,"return_type":"String","visibility":"Public","body":"capacity = 0\n{% for i in 0...T.size %}\n      value{{ i }} = values[{{ i }}]\n      if value{{ i }}.is_a?(String)\n        capacity += value{{ i }}.bytesize\n      else\n        capacity += 15\n      end\n    {% end %}\nString.build(capacity) do |io|\n  {% for i in 0...T.size %}\n        if value{{ i }}.is_a?(String)\n          io.write(value{{ i }}.to_slice)\n        else\n          io << value{{ i }}\n        end\n      {% end %}\nend\n"}},{"html_id":"new(bytes:Bytes,encoding:String,invalid:Symbol?=nil):String-class-method","name":"new","doc":"Creates a new `String` from the given *bytes*, which are encoded in the given *encoding*.\n\nThe *invalid* argument can be:\n* `nil`: an exception is raised on invalid byte sequences\n* `:skip`: invalid byte sequences are ignored\n\n```\nslice = Slice.new(2, 0_u8)\nslice[0] = 186_u8\nslice[1] = 195_u8\nString.new(slice, \"GB2312\") # => \"好\"\n```","summary":"<p>Creates a new <code><a href=\"String.html\">String</a></code> from the given <em>bytes</em>, which are encoded in the given <em>encoding</em>.</p>","abstract":false,"args":[{"name":"bytes","external_name":"bytes","restriction":"Bytes"},{"name":"encoding","external_name":"encoding","restriction":"String"},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":"Symbol | ::Nil"}],"args_string":"(bytes : Bytes, encoding : String, invalid : Symbol? = nil) : String","args_html":"(bytes : <a href=\"Bytes.html\">Bytes</a>, encoding : <a href=\"String.html\">String</a>, invalid : <a href=\"Symbol.html\">Symbol</a>? = <span class=\"n\">nil</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":175,"url":null},"def":{"name":"new","args":[{"name":"bytes","external_name":"bytes","restriction":"Bytes"},{"name":"encoding","external_name":"encoding","restriction":"String"},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":"Symbol | ::Nil"}],"return_type":"String","visibility":"Public","body":"String.build do |str|\n  String.encode(bytes, encoding, \"UTF-8\", str, invalid)\nend"}},{"html_id":"new(chars:Pointer(UInt8),bytesize,size=0)-class-method","name":"new","doc":"Creates a new `String` from a pointer, indicating its bytesize count\nand, optionally, the UTF-8 codepoints count (size). `Bytes` will be\ncopied from the pointer.\n\nIf the given size is zero, the amount of UTF-8 codepoints will be\nlazily computed when needed.\n\n```\nptr = Pointer.malloc(4) { |i| ('a'.ord + i).to_u8 }\nString.new(ptr, 2) # => \"ab\"\n```","summary":"<p>Creates a new <code><a href=\"String.html\">String</a></code> from a pointer, indicating its bytesize count and, optionally, the UTF-8 codepoints count (size).</p>","abstract":false,"args":[{"name":"chars","external_name":"chars","restriction":"::Pointer(UInt8)"},{"name":"bytesize","external_name":"bytesize","restriction":""},{"name":"size","default_value":"0","external_name":"size","restriction":""}],"args_string":"(chars : Pointer(UInt8), bytesize, size = 0)","args_html":"(chars : <a href=\"Pointer.html\">Pointer</a>(<a href=\"UInt8.html\">UInt8</a>), bytesize, size = <span class=\"n\">0</span>)","location":{"filename":"src/string.cr","line_number":212,"url":null},"def":{"name":"new","args":[{"name":"chars","external_name":"chars","restriction":"::Pointer(UInt8)"},{"name":"bytesize","external_name":"bytesize","restriction":""},{"name":"size","default_value":"0","external_name":"size","restriction":""}],"visibility":"Public","body":"if bytesize == 0\n  return \"\"\nend\nif chars.null?\n  raise(ArgumentError.new(\"Cannot create a string with a null pointer and a non-zero (#{bytesize}) bytesize\"))\nend\nnew(bytesize) do |buffer|\n  buffer.copy_from(chars, bytesize)\n  {bytesize, size}\nend\n"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":65,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"ctx.read_alias(node, String) do |obj|\n  return obj\nend\nif node.is_a?(YAML::Nodes::Scalar)\n  value = node.value\n  ctx.record_anchor(node, value)\n  value\nelse\n  node.raise(\"Expected String, not #{node.kind}\")\nend\n"}},{"html_id":"new(chars:Pointer(UInt8))-class-method","name":"new","doc":"Creates a `String` from a pointer. `Bytes` will be copied from the pointer.\n\nThis method is **unsafe**: the pointer must point to data that eventually\ncontains a zero byte that indicates the ends of the string. Otherwise,\nthe result of this method is undefined and might cause a segmentation fault.\n\nThis method is typically used in C bindings, where you get a `char*` from a\nlibrary and the library guarantees that this pointer eventually has an\nending zero byte.\n\n```\nptr = Pointer.malloc(5) { |i| i == 4 ? 0_u8 : ('a'.ord + i).to_u8 }\nString.new(ptr) # => \"abcd\"\n```","summary":"<p>Creates a <code><a href=\"String.html\">String</a></code> from a pointer.</p>","abstract":false,"args":[{"name":"chars","external_name":"chars","restriction":"::Pointer(UInt8)"}],"args_string":"(chars : Pointer(UInt8))","args_html":"(chars : <a href=\"Pointer.html\">Pointer</a>(<a href=\"UInt8.html\">UInt8</a>))","location":{"filename":"src/string.cr","line_number":195,"url":null},"def":{"name":"new","args":[{"name":"chars","external_name":"chars","restriction":"::Pointer(UInt8)"}],"visibility":"Public","body":"if chars.null?\n  raise(ArgumentError.new(\"Cannot create a string with a null pointer\"))\nend\nnew(chars, LibC.strlen(chars))\n"}},{"html_id":"new(slice:Bytes)-class-method","name":"new","doc":"Creates a `String` from the given *slice*. `Bytes` will be copied from the slice.\n\nThis method is always safe to call, and the resulting string will have\nthe contents and size of the slice.\n\n```\nslice = Slice.new(4) { |i| ('a'.ord + i).to_u8 }\nString.new(slice) # => \"abcd\"\n```","summary":"<p>Creates a <code><a href=\"String.html\">String</a></code> from the given <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes)","args_html":"(slice : <a href=\"Bytes.html\">Bytes</a>)","location":{"filename":"src/string.cr","line_number":159,"url":null},"def":{"name":"new","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"visibility":"Public","body":"new(slice.to_unsafe, slice.size)"}},{"html_id":"new(capacity:Int,&)-class-method","name":"new","doc":"Creates a new `String` by allocating a buffer (`Pointer(UInt8)`) with the given capacity, then\nyielding that buffer. The block must return a tuple with the bytesize and size\n(UTF-8 codepoints count) of the String. If the returned size is zero, the UTF-8 codepoints\ncount will be lazily computed.\n\nThe bytesize returned by the block must be less than or equal to the\ncapacity given to this String, otherwise `ArgumentError` is raised.\n\nIf you need to build a `String` where the maximum capacity is unknown, use `String#build`.\n\n```\nstr = String.new(4) do |buffer|\n  buffer[0] = 'a'.ord.to_u8\n  buffer[1] = 'b'.ord.to_u8\n  {2, 2}\nend\nstr # => \"ab\"\n```","summary":"<p>Creates a new <code><a href=\"String.html\">String</a></code> by allocating a buffer (<code><a href=\"Pointer.html\">Pointer</a>(<a href=\"UInt8.html\">UInt8</a>)</code>) with the given capacity, then yielding that buffer.</p>","abstract":false,"args":[{"name":"capacity","external_name":"capacity","restriction":"Int"}],"args_string":"(capacity : Int, &)","args_html":"(capacity : <a href=\"Int.html\">Int</a>, &)","location":{"filename":"src/string.cr","line_number":244,"url":null},"def":{"name":"new","args":[{"name":"capacity","external_name":"capacity","restriction":"Int"}],"yields":1,"visibility":"Public","body":"check_capacity_in_bounds(capacity)\nstr = (GC.malloc_atomic((capacity.to_u32 + HEADER_SIZE) + 1)).as(::Pointer(UInt8))\nbuffer = (str.as(String)).to_unsafe\nbytesize, size = yield buffer\nif 0 <= bytesize && bytesize <= capacity\nelse\n  raise(ArgumentError.new(\"Bytesize out of capacity bounds\"))\nend\nbuffer[bytesize] = 0_u8\nif bytesize < capacity\n  str = str.realloc((bytesize.to_u32 + HEADER_SIZE) + 1)\nend\nstr_header = str.as(::Pointer(::Tuple(Int32, Int32, Int32)))\nstr_header.value = {TYPE_ID, bytesize.to_i, size.to_i}\nstr.as(String)\n"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":136,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"pull.read_string"}}],"instance_methods":[{"html_id":"%(other):String-instance-method","name":"%","doc":"Interpolates *other* into the string using top-level `::sprintf`.\n\n```\n\"I have %d apples\" % 5                                             # => \"I have 5 apples\"\n\"%s, %s, %s, D\" % ['A', 'B', 'C']                                  # => \"A, B, C, D\"\n\"sum: %{one} + %{two} = %{three}\" % {one: 1, two: 2, three: 1 + 2} # => \"sum: 1 + 2 = 3\"\n\"I have %<apples>s apples\" % {apples: 4}                           # => \"I have 4 apples\"\n```","summary":"<p>Interpolates <em>other</em> into the string using top-level <code>::sprintf</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other) : String","args_html":"(other) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":4843,"url":null},"def":{"name":"%","args":[{"name":"other","external_name":"other","restriction":""}],"return_type":"String","visibility":"Public","body":"sprintf(self, other)"}},{"html_id":"*(times:Int):String-instance-method","name":"*","doc":"Makes a new `String` by adding *str* to itself *times* times.\n\n```\n\"Developers! \" * 4\n# => \"Developers! Developers! Developers! Developers! \"\n```","summary":"<p>Makes a new <code><a href=\"String.html\">String</a></code> by adding <em>str</em> to itself <em>times</em> times.</p>","abstract":false,"args":[{"name":"times","external_name":"times","restriction":"Int"}],"args_string":"(times : Int) : String","args_html":"(times : <a href=\"Int.html\">Int</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":3020,"url":null},"def":{"name":"*","args":[{"name":"times","external_name":"times","restriction":"Int"}],"return_type":"String","visibility":"Public","body":"if times < 0\n  raise(ArgumentError.new(\"Negative argument\"))\nend\nif (times == 0) || (bytesize == 0)\n  return \"\"\nelse\n  if bytesize == 1\n    return String.new(times) do |buffer|\n      (Slice.new(buffer, times)).fill(to_unsafe[0])\n      {times, times}\n    end\n  end\nend\ntotal_bytesize = bytesize * times\nString.new(total_bytesize) do |buffer|\n  buffer.copy_from(to_unsafe, bytesize)\n  n = bytesize\n  while n <= (total_bytesize // 2)\n    (buffer + n).copy_from(buffer, n)\n    n = n * 2\n  end\n  (buffer + n).copy_from(buffer, total_bytesize - n)\n  {total_bytesize, @length * times}\nend\n"}},{"html_id":"+(other:self):String-instance-method","name":"+","doc":"Concatenates *str* and *other*.\n\n```\n\"abc\" + \"def\" # => \"abcdef\"\n\"abc\" + 'd'   # => \"abcd\"\n```","summary":"<p>Concatenates <em>str</em> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self) : String","args_html":"(other : <span class=\"k\">self</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2981,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"self"}],"return_type":"String","visibility":"Public","body":"if other.empty?\n  return self\nend\nif self.empty?\n  return other\nend\nsize = bytesize + other.bytesize\nString.new(size) do |buffer|\n  buffer.copy_from(to_unsafe, bytesize)\n  (buffer + bytesize).copy_from(other.to_unsafe, other.bytesize)\n  if size_known? && other.size_known?\n    {size, @length + (other.@length)}\n  else\n    {size, 0}\n  end\nend\n"}},{"html_id":"+(char:Char):String-instance-method","name":"+","doc":"Concatenates *str* and *other*.\n\n```\n\"abc\" + \"def\" # => \"abcdef\"\n\"abc\" + 'd'   # => \"abcd\"\n```","summary":"<p>Concatenates <em>str</em> and <em>other</em>.</p>","abstract":false,"args":[{"name":"char","external_name":"char","restriction":"Char"}],"args_string":"(char : Char) : String","args_html":"(char : <a href=\"Char.html\">Char</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2999,"url":null},"def":{"name":"+","args":[{"name":"char","external_name":"char","restriction":"Char"}],"return_type":"String","visibility":"Public","body":"bytes, count = String.char_bytes_and_bytesize(char)\nsize = bytesize + count\nString.new(size) do |buffer|\n  buffer.copy_from(to_unsafe, bytesize)\n  (buffer + bytesize).copy_from(bytes.to_unsafe, count)\n  if size_known?\n    {size, @length + 1}\n  else\n    {size, 0}\n  end\nend\n"}},{"html_id":"<=>(other:self)-instance-method","name":"<=>","doc":"The comparison operator.\n\nCompares this string with *other*, returning `-1`, `0` or `1` depending on whether\nthis string is less, equal or greater than *other*.\n\nComparison is done byte-per-byte: if a byte is less then the other corresponding\nbyte, `-1` is returned and so on.\n\nIf the strings are of different lengths, and the strings are equal when compared\nup to the shortest length, then the longer string is considered greater than\nthe shorter one.\n\n```\n\"abcdef\" <=> \"abcde\"   # => 1\n\"abcdef\" <=> \"abcdef\"  # => 0\n\"abcdef\" <=> \"abcdefg\" # => -1\n\"abcdef\" <=> \"ABCDEF\"  # => 1\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/string.cr","line_number":2880,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"if same?(other)\n  return 0\nend\nmin_bytesize = Math.min(bytesize, other.bytesize)\ncmp = to_unsafe.memcmp(other.to_unsafe, min_bytesize)\ncmp == 0 ? (bytesize <=> other.bytesize) : cmp.sign\n"}},{"html_id":"==(other:self):Bool-instance-method","name":"==","doc":"Returns `true` if this string is equal to `*other*.\nComparison is done byte-per-byte: if a byte is different from the corresponding\nbyte, `false` is returned and so on.\n\nSee `#compare` for more comparison options.","summary":"<p>Returns <code>true</code> if this string is equal to `<em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self) : Bool","args_html":"(other : <span class=\"k\">self</span>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/string.cr","line_number":2856,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"return_type":"Bool","visibility":"Public","body":"if same?(other)\n  return true\nend\nif bytesize == other.bytesize\nelse\n  return false\nend\n(to_unsafe.memcmp(other.to_unsafe, bytesize)) == 0\n"}},{"html_id":"=~(regex:Regex):Int32?-instance-method","name":"=~","doc":"Tests whether *str* matches *regex*.\nIf successful, it returns the position of the first match.\nIf unsuccessful, it returns `nil`.\n\nIf the argument isn't a `Regex`, it returns `nil`.\n\n```\n\"Haystack\" =~ /ay/ # => 1\n\"Haystack\" =~ /z/  # => nil\n\n\"Haystack\" =~ 45 # => nil\n```","summary":"<p>Tests whether <em>str</em> matches <em>regex</em>.</p>","abstract":false,"args":[{"name":"regex","external_name":"regex","restriction":"Regex"}],"args_string":"(regex : Regex) : Int32?","args_html":"(regex : <a href=\"Regex.html\">Regex</a>) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/string.cr","line_number":2964,"url":null},"def":{"name":"=~","args":[{"name":"regex","external_name":"regex","restriction":"Regex"}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"match = regex.match(self)\n$~ = match\nmatch.try(&.begin(0))\n"}},{"html_id":"=~(other):Nil-instance-method","name":"=~","doc":"Tests whether *str* matches *regex*.\nIf successful, it returns the position of the first match.\nIf unsuccessful, it returns `nil`.\n\nIf the argument isn't a `Regex`, it returns `nil`.\n\n```\n\"Haystack\" =~ /ay/ # => 1\n\"Haystack\" =~ /z/  # => nil\n\n\"Haystack\" =~ 45 # => nil\n```","summary":"<p>Tests whether <em>str</em> matches <em>regex</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other) : Nil","args_html":"(other) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":2971,"url":null},"def":{"name":"=~","args":[{"name":"other","external_name":"other","restriction":""}],"return_type":"Nil","visibility":"Public","body":"nil"}},{"html_id":"[](start:Int,count:Int):String-instance-method","name":"[]","doc":"Returns a substring starting from the *start* character of size *count*.\n\nNegative *start* is added to `self.size`, thus it's treated as a character\nindex counting from the end, `-1` designating the last character.\n\nRaises `IndexError` if *start* index is out of bounds.\nRaises `ArgumentError` if *count* is negative.","summary":"<p>Returns a substring starting from the <em>start</em> character of size <em>count</em>.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int) : String","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":873,"url":null},"def":{"name":"[]","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"String","visibility":"Public","body":"self[start, count]? || (raise(IndexError.new))"}},{"html_id":"[](regex:Regex,group):String-instance-method","name":"[]","abstract":false,"args":[{"name":"regex","external_name":"regex","restriction":"Regex"},{"name":"group","external_name":"group","restriction":""}],"args_string":"(regex : Regex, group) : String","args_html":"(regex : <a href=\"Regex.html\">Regex</a>, group) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":919,"url":null},"def":{"name":"[]","args":[{"name":"regex","external_name":"regex","restriction":"Regex"},{"name":"group","external_name":"group","restriction":""}],"return_type":"String","visibility":"Public","body":"self[regex, group]?.not_nil!"}},{"html_id":"[](index:Int):Char-instance-method","name":"[]","doc":"Returns the `Char` at the given *index*.\n\nNegative indices can be used to start counting from the end of the string.\n\nRaises `IndexError` if the *index* is out of bounds.\n\n```\n\"hello\"[0]  # => 'h'\n\"hello\"[1]  # => 'e'\n\"hello\"[-1] # => 'o'\n\"hello\"[-2] # => 'l'\n\"hello\"[5]  # raises IndexError\n```","summary":"<p>Returns the <code><a href=\"Char.html\">Char</a></code> at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : Char","args_html":"(index : <a href=\"Int.html\">Int</a>) : <a href=\"Char.html\">Char</a>","location":{"filename":"src/string.cr","line_number":799,"url":null},"def":{"name":"[]","args":[{"name":"index","external_name":"index","restriction":"Int"}],"return_type":"Char","visibility":"Public","body":"char_at(index) do\n  raise(IndexError.new)\nend"}},{"html_id":"[](range:Range):String-instance-method","name":"[]","doc":"Returns the substring indicated by *range* as span of character indices.\n\nThe substring ranges from `self[range.begin]` to `self[range.end]`\n(or `self[range.end - 1]` if the range is exclusive). It can be smaller than\n`range.size` if the end index is larger than `self.size`.\n\n```\ns = \"abcde\"\ns[1..3] # => \"bcd\"\n# range.end > s.size\ns[3..7] # => \"de\"\n```\n\nOpen ended ranges are clamped at the start and end of `self`, respectively.\n\n```\n# open ended ranges\ns[2..] # => \"cde\"\ns[..2] # => \"abc\"\n```\n\nNegative range values are added to `self.size`, thus they are treated as\ncharacter indices counting from the end, `-1` designating the last character.\n\n```\n# negative indices, both ranges are equivalent for `s`\ns[1..3]   # => \"bcd\"\ns[-4..-2] # => \"bcd\"\n# Mixing negative and positive indices, both ranges are equivalent for `s`\ns[1..-2] # => \"bcd\"\ns[-4..3] # => \"bcd\"\n```\n\nRaises `IndexError` if the start index it out of range (`range.begin >\nself.size || range.begin < -self.size). If `range.begin == self.size` an\nempty string is returned. If `range.begin > range.end`, an empty string is\nreturned.\n\n```\n# range.begin > array.size\ns[6..10] # raise IndexError\n# range.begin == s.size\ns[5..10] # => \"\"\n# range.begin > range.end\ns[3..1]   # => \"\"\ns[-2..-4] # => \"\"\ns[-2..1]  # => \"\"\ns[3..-4]  # => \"\"\n```","summary":"<p>Returns the substring indicated by <em>range</em> as span of character indices.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range) : String","args_html":"(range : <a href=\"Range.html\">Range</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":852,"url":null},"def":{"name":"[]","args":[{"name":"range","external_name":"range","restriction":"Range"}],"return_type":"String","visibility":"Public","body":"self[*(Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new))]"}},{"html_id":"[](str:String|Char)-instance-method","name":"[]","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"String | Char"}],"args_string":"(str : String | Char)","args_html":"(str : <a href=\"String.html\">String</a> | <a href=\"Char.html\">Char</a>)","location":{"filename":"src/string.cr","line_number":911,"url":null},"def":{"name":"[]","args":[{"name":"str","external_name":"str","restriction":"String | Char"}],"visibility":"Public","body":"self[str]?.not_nil!"}},{"html_id":"[](regex:Regex):String-instance-method","name":"[]","abstract":false,"args":[{"name":"regex","external_name":"regex","restriction":"Regex"}],"args_string":"(regex : Regex) : String","args_html":"(regex : <a href=\"Regex.html\">Regex</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":915,"url":null},"def":{"name":"[]","args":[{"name":"regex","external_name":"regex","restriction":"Regex"}],"return_type":"String","visibility":"Public","body":"self[regex]?.not_nil!"}},{"html_id":"[]?(start:Int,count:Int)-instance-method","name":"[]?","doc":"Like `#[](Int, Int)` but returns `nil` if the *start* index is out of bounds.","summary":"<p>Like <code><a href=\"String.html#%5B%5D%28start%3AInt%2Ccount%3AInt%29%3AString-instance-method\">#[](Int, Int)</a></code> but returns <code>nil</code> if the <em>start</em> index is out of bounds.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int)","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/string.cr","line_number":878,"url":null},"def":{"name":"[]?","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"visibility":"Public","body":"if single_byte_optimizable?\n  return byte_slice?(start, count)\nend\nstart, count = Indexable.normalize_start_and_count(start, count, size) do\n  return nil\nend\nif count == 0\n  return \"\"\nend\nif count == size\n  return self\nend\nstart_pos, end_pos = find_start_and_end(start, count)\nbyte_count = end_pos - start_pos\nString.new(byte_count) do |buffer|\n  buffer.copy_from(to_unsafe + start_pos, byte_count)\n  {byte_count, 0}\nend\n"}},{"html_id":"[]?(regex:Regex,group):String?-instance-method","name":"[]?","abstract":false,"args":[{"name":"regex","external_name":"regex","restriction":"Regex"},{"name":"group","external_name":"group","restriction":""}],"args_string":"(regex : Regex, group) : String?","args_html":"(regex : <a href=\"Regex.html\">Regex</a>, group) : <a href=\"String.html\">String</a>?","location":{"filename":"src/string.cr","line_number":906,"url":null},"def":{"name":"[]?","args":[{"name":"regex","external_name":"regex","restriction":"Regex"},{"name":"group","external_name":"group","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"match = match(regex)\nif match\n  match[group]?\nend\n"}},{"html_id":"[]?(range:Range):String?-instance-method","name":"[]?","doc":"Like `#[](Range)`, but returns `nil` if `range.begin` is out of range.\n\n```\n\"hello\"[6..7]? # => nil\n\"hello\"[6..]?  # => nil\n```","summary":"<p>Like <code><a href=\"String.html#%5B%5D%28index%3AInt%29%3AChar-instance-method\">#[](Range)</a></code>, but returns <code>nil</code> if <code>range.begin</code> is out of range.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range) : String?","args_html":"(range : <a href=\"Range.html\">Range</a>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/string.cr","line_number":862,"url":null},"def":{"name":"[]?","args":[{"name":"range","external_name":"range","restriction":"Range"}],"return_type":"String | ::Nil","visibility":"Public","body":"self[*(Indexable.range_to_index_and_count(range, size)) || (return nil)]?"}},{"html_id":"[]?(index:Int):Char?-instance-method","name":"[]?","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : Char?","args_html":"(index : <a href=\"Int.html\">Int</a>) : <a href=\"Char.html\">Char</a>?","location":{"filename":"src/string.cr","line_number":894,"url":null},"def":{"name":"[]?","args":[{"name":"index","external_name":"index","restriction":"Int"}],"return_type":"Char | ::Nil","visibility":"Public","body":"char_at(index) do\n  nil\nend"}},{"html_id":"[]?(str:String|Char)-instance-method","name":"[]?","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"String | Char"}],"args_string":"(str : String | Char)","args_html":"(str : <a href=\"String.html\">String</a> | <a href=\"Char.html\">Char</a>)","location":{"filename":"src/string.cr","line_number":898,"url":null},"def":{"name":"[]?","args":[{"name":"str","external_name":"str","restriction":"String | Char"}],"visibility":"Public","body":"includes?(str) ? str : nil"}},{"html_id":"[]?(regex:Regex):String?-instance-method","name":"[]?","abstract":false,"args":[{"name":"regex","external_name":"regex","restriction":"Regex"}],"args_string":"(regex : Regex) : String?","args_html":"(regex : <a href=\"Regex.html\">Regex</a>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/string.cr","line_number":902,"url":null},"def":{"name":"[]?","args":[{"name":"regex","external_name":"regex","restriction":"Regex"}],"return_type":"String | ::Nil","visibility":"Public","body":"self[regex, 0]?"}},{"html_id":"ascii_only?:Bool-instance-method","name":"ascii_only?","doc":"Returns `true` if this String is comprised in its entirety\nby ASCII characters.\n\n```\n\"hello\".ascii_only? # => true\n\"你好\".ascii_only?    # => false\n```","summary":"<p>Returns <code>true</code> if this String is comprised in its entirety by ASCII characters.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4873,"url":null},"def":{"name":"ascii_only?","return_type":"Bool","visibility":"Public","body":"if @bytesize == size\n  each_byte do |byte|\n    if byte < 128\n    else\n      return false\n    end\n  end\n  true\nelse\n  false\nend"}},{"html_id":"blank?:Bool-instance-method","name":"blank?","doc":"Returns `true` if this string consists exclusively of unicode whitespace.\n\n```\n\"\".blank?        # => true\n\"   \".blank?     # => true\n\"   a   \".blank? # => false\n```","summary":"<p>Returns <code>true</code> if this string consists exclusively of unicode whitespace.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":2825,"url":null},"def":{"name":"blank?","return_type":"Bool","visibility":"Public","body":"each_char do |char|\n  if char.whitespace?\n  else\n    return false\n  end\nend\ntrue\n"}},{"html_id":"byte_at(index):UInt8-instance-method","name":"byte_at","doc":"Returns the byte at the given *index*.\n\nRaises `IndexError` if the *index* is out of bounds.\n\n```\n\"¥hello\".byte_at(0)  # => 194\n\"¥hello\".byte_at(1)  # => 165\n\"¥hello\".byte_at(2)  # => 104\n\"¥hello\".byte_at(-1) # => 111\n\"¥hello\".byte_at(6)  # => 111\n\"¥hello\".byte_at(7)  # raises IndexError\n```","summary":"<p>Returns the byte at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":""}],"args_string":"(index) : UInt8","args_html":"(index) : <a href=\"UInt8.html\">UInt8</a>","location":{"filename":"src/string.cr","line_number":1244,"url":null},"def":{"name":"byte_at","args":[{"name":"index","external_name":"index","restriction":""}],"return_type":"UInt8","visibility":"Public","body":"byte_at(index) do\n  raise(IndexError.new)\nend"}},{"html_id":"byte_at(index,&)-instance-method","name":"byte_at","doc":"Returns the byte at the given *index*, or yields if out of bounds.\n\n```\n\"¥hello\".byte_at(6) { \"OUT OF BOUNDS\" } # => 111\n\"¥hello\".byte_at(7) { \"OUT OF BOUNDS\" } # => \"OUT OF BOUNDS\"\n```","summary":"<p>Returns the byte at the given <em>index</em>, or yields if out of bounds.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":""}],"args_string":"(index, &)","args_html":"(index, &)","location":{"filename":"src/string.cr","line_number":1268,"url":null},"def":{"name":"byte_at","args":[{"name":"index","external_name":"index","restriction":""}],"yields":0,"visibility":"Public","body":"if index < 0\n  index = index + bytesize\nend\nif 0 <= index && index < bytesize\n  to_unsafe[index]\nelse\n  yield\nend\n"}},{"html_id":"byte_at?(index):UInt8?-instance-method","name":"byte_at?","doc":"Returns the byte at the given *index*, or `nil` if out of bounds.\n\n```\n\"¥hello\".byte_at?(0)  # => 194\n\"¥hello\".byte_at?(1)  # => 165\n\"¥hello\".byte_at?(2)  # => 104\n\"¥hello\".byte_at?(-1) # => 111\n\"¥hello\".byte_at?(6)  # => 111\n\"¥hello\".byte_at?(7)  # => nil\n```","summary":"<p>Returns the byte at the given <em>index</em>, or <code>nil</code> if out of bounds.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":""}],"args_string":"(index) : UInt8?","args_html":"(index) : <a href=\"UInt8.html\">UInt8</a>?","location":{"filename":"src/string.cr","line_number":1258,"url":null},"def":{"name":"byte_at?","args":[{"name":"index","external_name":"index","restriction":""}],"return_type":"UInt8 | Nil","visibility":"Public","body":"byte_at(index) do\n  nil\nend"}},{"html_id":"byte_index(byte:Int,offset=0):Int32?-instance-method","name":"byte_index","doc":"Returns the index of the _first_ occurrence of *byte* in the string, or `nil` if not present.\nIf *offset* is present, it defines the position to start the search.\n\nNegative *offset* can be used to start the search from the end of the string.\n\n```\n\"Hello, World\".byte_index(0x6f)             # => 4\n\"Hello, World\".byte_index(0x5a)             # => nil\n\"Hello, World\".byte_index(0x6f, 5)          # => 8\n\"💣\".byte_index(0xA3)                        # => 3\n\"Dizzy Miss Lizzy\".byte_index('z'.ord)      # => 2\n\"Dizzy Miss Lizzy\".byte_index('z'.ord, 3)   # => 3\n\"Dizzy Miss Lizzy\".byte_index('z'.ord, -4)  # => 13\n\"Dizzy Miss Lizzy\".byte_index('z'.ord, -17) # => nil\n```","summary":"<p>Returns the index of the <em>first</em> occurrence of <em>byte</em> in the string, or <code>nil</code> if not present.</p>","abstract":false,"args":[{"name":"byte","external_name":"byte","restriction":"Int"},{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(byte : Int, offset = 0) : Int32?","args_html":"(byte : <a href=\"Int.html\">Int</a>, offset = <span class=\"n\">0</span>) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/string.cr","line_number":3376,"url":null},"def":{"name":"byte_index","args":[{"name":"byte","external_name":"byte","restriction":"Int"},{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"if offset < 0\n  offset = offset + bytesize\nend\nif offset < 0\n  return\nend\noffset.upto(bytesize - 1) do |i|\n  if to_unsafe[i] == byte\n    return i\n  end\nend\nnil\n"}},{"html_id":"byte_index(search:String,offset=0):Int32?-instance-method","name":"byte_index","doc":"Returns the byte index of *search* in the string, or `nil` if the string is not present.\nIf *offset* is present, it defines the position to start the search.\n\nNegative *offset* can be used to start the search from the end of the string.\n\n```\n\"¥hello\".byte_index(\"hello\")              # => 2\n\"hello\".byte_index(\"world\")               # => nil\n\"Dizzy Miss Lizzy\".byte_index(\"izzy\")     # => 1\n\"Dizzy Miss Lizzy\".byte_index(\"izzy\", 2)  # => 12\n\"Dizzy Miss Lizzy\".byte_index(\"izzy\", -4) # => 12\n\"Dizzy Miss Lizzy\".byte_index(\"izzy\", -3) # => nil\n```","summary":"<p>Returns the byte index of <em>search</em> in the string, or <code>nil</code> if the string is not present.</p>","abstract":false,"args":[{"name":"search","external_name":"search","restriction":"String"},{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(search : String, offset = 0) : Int32?","args_html":"(search : <a href=\"String.html\">String</a>, offset = <span class=\"n\">0</span>) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/string.cr","line_number":3401,"url":null},"def":{"name":"byte_index","args":[{"name":"search","external_name":"search","restriction":"String"},{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"if offset < 0\n  offset = offset + bytesize\nend\nif offset < 0\n  return\nend\nif search.empty?\n  return bytesize < offset ? nil : offset\nend\nsearch_hash = 0_u32\nsearch.each_byte do |b|\n  search_hash = (search_hash &* PRIME_RK) &+ b\nend\npow = PRIME_RK &** search.bytesize\npointer = head_pointer = to_unsafe + offset\nhash_end_pointer = pointer + search.bytesize\nend_pointer = to_unsafe + bytesize\nhash = 0_u32\nif hash_end_pointer > end_pointer\n  return\nend\nwhile pointer < hash_end_pointer\n  hash = (hash &* PRIME_RK) &+ pointer.value\n  pointer = pointer + 1\nend\nwhile true\n  if (hash == search_hash) && ((head_pointer.memcmp(search.to_unsafe, search.bytesize)) == 0)\n    return offset\n  end\n  if pointer >= end_pointer\n    return\n  end\n  hash = ((hash &* PRIME_RK) &+ pointer.value) &- (pow &* head_pointer.value)\n  pointer = pointer + 1\n  head_pointer = head_pointer + 1\n  offset = offset + 1\nend\nnil\n"}},{"html_id":"byte_index_to_char_index(index):Int32?-instance-method","name":"byte_index_to_char_index","doc":"Returns the char index of a byte index, or `nil` if out of bounds.\n\nIt is valid to pass `#bytesize` to *index*, and in this case the answer\nwill be the size of this string.","summary":"<p>Returns the char index of a byte index, or <code>nil</code> if out of bounds.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":""}],"args_string":"(index) : Int32?","args_html":"(index) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/string.cr","line_number":3473,"url":null},"def":{"name":"byte_index_to_char_index","args":[{"name":"index","external_name":"index","restriction":""}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"if single_byte_optimizable?\n  return 0 <= index && index <= bytesize ? index : nil\nend\nsize = each_byte_index_and_char_index do |byte_index, char_index|\n  if index == byte_index\n    return char_index\n  end\nend\nif index == @bytesize\n  return size\nend\nnil\n"}},{"html_id":"byte_slice(start:Int,count:Int):String-instance-method","name":"byte_slice","doc":"Returns a new string built from *count* bytes starting at *start* byte.\n\n*start* can can be negative to start counting\nfrom the end of the string.\nIf *count* is bigger than the number of bytes from *start* to `#bytesize`,\nonly remaining bytes are returned.\n\nThis method should be avoided,\nunless the string is proven to be ASCII-only (for example `#ascii_only?`),\nor the byte positions are known to be at character boundaries.\nOtherwise, multi-byte characters may be split, leading to an invalid UTF-8 encoding.\n\nRaises `IndexError` if the *start* index is out of bounds.\n\nRaises `ArgumentError` if *count* is negative.\n\n```\n\"hello\".byte_slice(0, 2)   # => \"he\"\n\"hello\".byte_slice(0, 100) # => \"hello\"\n\"hello\".byte_slice(-2, 3)  # => \"he\"\n\"hello\".byte_slice(-2, 5)  # => \"he\"\n\"hello\".byte_slice(-2, 5)  # => \"he\"\n\"¥hello\".byte_slice(0, 2)  # => \"¥\"\n\"¥hello\".byte_slice(2, 2)  # => \"he\"\n\"¥hello\".byte_slice(0, 1)  # => \"�\" (invalid UTF-8 character)\n\"¥hello\".byte_slice(1, 1)  # => \"�\" (invalid UTF-8 character)\n\"¥hello\".byte_slice(1, 2)  # => \"�h\" (invalid UTF-8 character)\n\"hello\".byte_slice(6, 2)   # raises IndexError\n\"hello\".byte_slice(-6, 2)  # raises IndexError\n\"hello\".byte_slice(0, -2)  # raises ArgumentError\n```","summary":"<p>Returns a new string built from <em>count</em> bytes starting at <em>start</em> byte.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int) : String","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1159,"url":null},"def":{"name":"byte_slice","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"String","visibility":"Public","body":"(byte_slice?(start, count)) || (raise(IndexError.new))"}},{"html_id":"byte_slice(start:Int):String-instance-method","name":"byte_slice","doc":"Returns a substring starting from the *start* byte.\n\n*start* can can be negative to start counting\nfrom the end of the string.\n\nThis method should be avoided,\nunless the string is proven to be ASCII-only (for example `#ascii_only?`),\nor the byte positions are known to be at character boundaries.\nOtherwise, multi-byte characters may be split, leading to an invalid UTF-8 encoding.\n\nRaises `IndexError` if *start* index is out of bounds.\n\n```\n\"hello\".byte_slice(0)  # => \"hello\"\n\"hello\".byte_slice(2)  # => \"llo\"\n\"hello\".byte_slice(-2) # => \"lo\"\n\"¥hello\".byte_slice(2) # => \"hello\"\n\"¥hello\".byte_slice(1) # => \"�hello\" (invalid UTF-8 character)\n\"hello\".byte_slice(6)  # raises IndexError\n\"hello\".byte_slice(-6) # raises IndexError\n```","summary":"<p>Returns a substring starting from the <em>start</em> byte.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"}],"args_string":"(start : Int) : String","args_html":"(start : <a href=\"Int.html\">Int</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1209,"url":null},"def":{"name":"byte_slice","args":[{"name":"start","external_name":"start","restriction":"Int"}],"return_type":"String","visibility":"Public","body":"count = bytesize - start\nif start > 0 && count < 0\n  raise(IndexError.new)\nend\nbyte_slice(start, count)\n"}},{"html_id":"byte_slice?(start:Int,count:Int):String?-instance-method","name":"byte_slice?","doc":"Like `byte_slice(Int, Int)` but returns `Nil` if the *start* index is out of bounds.\n\nRaises `ArgumentError` if *count* is negative.\n\n```\n\"hello\".byte_slice?(0, 2)   # => \"he\"\n\"hello\".byte_slice?(0, 100) # => \"hello\"\n\"hello\".byte_slice?(6, 2)   # => nil\n\"hello\".byte_slice?(-6, 2)  # => nil\n\"hello\".byte_slice?(0, -2)  # raises ArgumentError\n```","summary":"<p>Like <code><a href=\"String.html#byte_slice%28start%3AInt%2Ccount%3AInt%29%3AString-instance-method\">#byte_slice(Int, Int)</a></code> but returns <code><a href=\"Nil.html\">Nil</a></code> if the <em>start</em> index is out of bounds.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int) : String?","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/string.cr","line_number":1174,"url":null},"def":{"name":"byte_slice?","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"String | Nil","visibility":"Public","body":"start, count = Indexable.normalize_start_and_count(start, count, bytesize) do\n  return nil\nend\nif count == 0\n  return \"\"\nend\nif count == bytesize\n  return self\nend\nsingle_byte_optimizable = single_byte_optimizable?\nString.new(count) do |buffer|\n  buffer.copy_from(to_unsafe + start, count)\n  slice_size = single_byte_optimizable ? count : 0\n  {count, slice_size}\nend\n"}},{"html_id":"bytes:Array(UInt8)-instance-method","name":"bytes","doc":"Returns this string's bytes as an `Array(UInt8)`.\n\n```\n\"hello\".bytes # => [104, 101, 108, 108, 111]\n\"你好\".bytes    # => [228, 189, 160, 229, 165, 189]\n```","summary":"<p>Returns this string's bytes as an <code><a href=\"Array.html\">Array</a>(<a href=\"UInt8.html\">UInt8</a>)</code>.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4537,"url":null},"def":{"name":"bytes","return_type":"Array(UInt8)","visibility":"Public","body":"Array.new(bytesize) do |i|\n  to_unsafe[i]\nend"}},{"html_id":"bytesize:Int32-instance-method","name":"bytesize","doc":"Returns the number of bytes in this string.\n\n```\n\"hello\".bytesize # => 5\n\"你好\".bytesize    # => 6\n```","summary":"<p>Returns the number of bytes in this string.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":290,"url":null},"def":{"name":"bytesize","return_type":"Int32","visibility":"Public","body":"@bytesize"}},{"html_id":"camelcase(io:IO,options:Unicode::CaseOptions=Unicode::CaseOptions::None,*,lower:Bool=false):Nil-instance-method","name":"camelcase","doc":"Writes an camelcased version of `self` to the given *io*.\n\nIf *lower* is true, lower camelcase will be written (the first letter is downcased).\n\n```\nio = IO::Memory.new\n\"eiffel_tower\".camelcase io\nio.to_s # => \"EiffelTower\"\n```","summary":"<p>Writes an camelcased version of <code>self</code> to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":"Unicode::CaseOptions"},{"name":"","external_name":"","restriction":""},{"name":"lower","default_value":"false","external_name":"lower","restriction":"Bool"}],"args_string":"(io : IO, options : Unicode::CaseOptions = Unicode::CaseOptions::None, *, lower : Bool = false) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, options : <a href=\"Unicode/CaseOptions.html\">Unicode::CaseOptions</a> = <span class=\"t\">Unicode</span><span class=\"t\">::</span><span class=\"t\">CaseOptions</span><span class=\"t\">::</span><span class=\"t\">None</span>, *, lower : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":4069,"url":null},"def":{"name":"camelcase","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":"Unicode::CaseOptions"},{"name":"","external_name":"","restriction":""},{"name":"lower","default_value":"false","external_name":"lower","restriction":"Bool"}],"splat_index":2,"return_type":"Nil","visibility":"Public","body":"first = true\nlast_is_underscore = false\neach_char do |char|\n  if first\n    io << (lower ? char.downcase(options) : char.upcase(options))\n  else\n    if char == '_'\n      last_is_underscore = true\n    else\n      if last_is_underscore\n        io << (char.upcase(options))\n        last_is_underscore = false\n      else\n        io << char\n      end\n    end\n  end\n  first = false\nend\n"}},{"html_id":"camelcase(options:Unicode::CaseOptions=Unicode::CaseOptions::None,*,lower:Bool=false):String-instance-method","name":"camelcase","doc":"Converts underscores to camelcase boundaries.\n\nIf *lower* is true, lower camelcase will be returned (the first letter is downcased).\n\n```\n\"eiffel_tower\".camelcase                                            # => \"EiffelTower\"\n\"empire_state_building\".camelcase(lower: true)                      # => \"empireStateBuilding\"\n\"isolated_integer\".camelcase(options: Unicode::CaseOptions::Turkic) # => \"İsolatedİnteger\"\n```","summary":"<p>Converts underscores to camelcase boundaries.</p>","abstract":false,"args":[{"name":"options","default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":"Unicode::CaseOptions"},{"name":"","external_name":"","restriction":""},{"name":"lower","default_value":"false","external_name":"lower","restriction":"Bool"}],"args_string":"(options : Unicode::CaseOptions = Unicode::CaseOptions::None, *, lower : Bool = false) : String","args_html":"(options : <a href=\"Unicode/CaseOptions.html\">Unicode::CaseOptions</a> = <span class=\"t\">Unicode</span><span class=\"t\">::</span><span class=\"t\">CaseOptions</span><span class=\"t\">::</span><span class=\"t\">None</span>, *, lower : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":4054,"url":null},"def":{"name":"camelcase","args":[{"name":"options","default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":"Unicode::CaseOptions"},{"name":"","external_name":"","restriction":""},{"name":"lower","default_value":"false","external_name":"lower","restriction":"Bool"}],"splat_index":1,"return_type":"String","visibility":"Public","body":"if empty?\n  return self\nend\nString.build(bytesize) do |io|\n  camelcase(io, options, lower: lower)\nend\n"}},{"html_id":"capitalize(options:Unicode::CaseOptions=:none):String-instance-method","name":"capitalize","doc":"Returns a new `String` with the first letter converted to uppercase and every\nsubsequent letter converted to lowercase.\n\n```\n\"hEllO\".capitalize # => \"Hello\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with the first letter converted to uppercase and every subsequent letter converted to lowercase.</p>","abstract":false,"args":[{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"args_string":"(options : Unicode::CaseOptions = :none) : String","args_html":"(options : <a href=\"Unicode/CaseOptions.html\">Unicode::CaseOptions</a> = <span class=\"n\">:none</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1359,"url":null},"def":{"name":"capitalize","args":[{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"return_type":"String","visibility":"Public","body":"if empty?\n  return self\nend\nif single_byte_optimizable? && (options.none? || options.ascii?)\n  return String.new(bytesize) do |buffer|\n    bytesize.times do |i|\n      byte = if i.zero?\n        to_unsafe[i].unsafe_chr.upcase.ord.to_u8\n      else\n        to_unsafe[i].unsafe_chr.downcase.ord.to_u8\n      end\n      buffer[i] = byte\n    end\n    {@bytesize, @length}\n  end\nend\nString.build(bytesize) do |io|\n  capitalize(io, options)\nend\n"}},{"html_id":"capitalize(io:IO,options:Unicode::CaseOptions=:none):Nil-instance-method","name":"capitalize","doc":"Writes a capitalized version of `self` to the given *io*.\n\n```\nio = IO::Memory.new\n\"hEllO\".capitalize io\nio.to_s # => \"Hello\"\n```","summary":"<p>Writes a capitalized version of <code>self</code> to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"args_string":"(io : IO, options : Unicode::CaseOptions = :none) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, options : <a href=\"Unicode/CaseOptions.html\">Unicode::CaseOptions</a> = <span class=\"n\">:none</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":1387,"url":null},"def":{"name":"capitalize","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"return_type":"Nil","visibility":"Public","body":"each_char_with_index do |char, i|\n  if i.zero?\n    char.upcase(options) do |c|\n      io << c\n    end\n  else\n    char.downcase(options) do |c|\n      io << c\n    end\n  end\nend"}},{"html_id":"center(len:Int,char:Char=''):String-instance-method","name":"center","doc":"Adds instances of *char* to left and right of the string until it is at least size of *len*.\n\n```\n\"Purple\".center(8)      # => \" Purple \"\n\"Purple\".center(8, '-') # => \"-Purple-\"\n\"Purple\".center(9, '-') # => \"-Purple--\"\n\"Aubergine\".center(8)   # => \"Aubergine\"\n```","summary":"<p>Adds instances of <em>char</em> to left and right of the string until it is at least size of <em>len</em>.</p>","abstract":false,"args":[{"name":"len","external_name":"len","restriction":"Int"},{"name":"char","default_value":"' '","external_name":"char","restriction":"Char"}],"args_string":"(len : Int, char : Char = ' ') : String","args_html":"(len : <a href=\"Int.html\">Int</a>, char : <a href=\"Char.html\">Char</a> = <span class=\"s\">&#39; &#39;</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":4174,"url":null},"def":{"name":"center","args":[{"name":"len","external_name":"len","restriction":"Int"},{"name":"char","default_value":"' '","external_name":"char","restriction":"Char"}],"return_type":"String","visibility":"Public","body":"just(len, char, 0)"}},{"html_id":"center(io:IO,len:Int,char:Char=''):Nil-instance-method","name":"center","doc":"Adds instances of *char* to left and right of the string until it is at least size of *len*,\nthen appends the result to the given IO.\n\n```\nio = IO::Memory.new\n\"Purple\".center(io, 9, '-')\nio.to_s # => \"-Purple--\"\n```","summary":"<p>Adds instances of <em>char</em> to left and right of the string until it is at least size of <em>len</em>, then appends the result to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"len","external_name":"len","restriction":"Int"},{"name":"char","default_value":"' '","external_name":"char","restriction":"Char"}],"args_string":"(io : IO, len : Int, char : Char = ' ') : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, len : <a href=\"Int.html\">Int</a>, char : <a href=\"Char.html\">Char</a> = <span class=\"s\">&#39; &#39;</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":4186,"url":null},"def":{"name":"center","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"len","external_name":"len","restriction":"Int"},{"name":"char","default_value":"' '","external_name":"char","restriction":"Char"}],"return_type":"Nil","visibility":"Public","body":"difference = len - size\nif difference <= 0\n  io << self\n  return\nend\nleft_padding = difference // 2\nright_padding = difference - left_padding\nleft_padding.times do\n  io << char\nend\nio << self\nright_padding.times do\n  io << char\nend\n"}},{"html_id":"char_at(index:Int):Char-instance-method","name":"char_at","doc":"Returns the `Char` at the given *index*.\n\nNegative indices can be used to start counting from the end of the string.\n\nRaises `IndexError` if the *index* is out of bounds.\n\n```\n\"hello\".char_at(0)  # => 'h'\n\"hello\".char_at(1)  # => 'e'\n\"hello\".char_at(-1) # => 'o'\n\"hello\".char_at(-2) # => 'l'\n\"hello\".char_at(5)  # raises IndexError\n```","summary":"<p>Returns the <code><a href=\"Char.html\">Char</a></code> at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : Char","args_html":"(index : <a href=\"Int.html\">Int</a>) : <a href=\"Char.html\">Char</a>","location":{"filename":"src/string.cr","line_number":936,"url":null},"def":{"name":"char_at","args":[{"name":"index","external_name":"index","restriction":"Int"}],"return_type":"Char","visibility":"Public","body":"char_at(index) do\n  raise(IndexError.new)\nend"}},{"html_id":"char_at(index:Int,&)-instance-method","name":"char_at","doc":"Returns the `Char` at the given *index*, or result of running the given block if out of bounds.\n\nNegative indices can be used to start counting from the end of the string.\n\n```\n\"hello\".char_at(4) { 'x' }  # => 'o'\n\"hello\".char_at(5) { 'x' }  # => 'x'\n\"hello\".char_at(-1) { 'x' } # => 'o'\n\"hello\".char_at(-5) { 'x' } # => 'h'\n\"hello\".char_at(-6) { 'x' } # => 'x'\n```","summary":"<p>Returns the <code><a href=\"Char.html\">Char</a></code> at the given <em>index</em>, or result of running the given block if out of bounds.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int, &)","args_html":"(index : <a href=\"Int.html\">Int</a>, &)","location":{"filename":"src/string.cr","line_number":951,"url":null},"def":{"name":"char_at","args":[{"name":"index","external_name":"index","restriction":"Int"}],"yields":0,"visibility":"Public","body":"if single_byte_optimizable?\n  byte = byte_at?(index)\n  if byte\n    return byte < 128 ? byte.unsafe_chr : Char::REPLACEMENT\n  else\n    return yield\n  end\nend\nif index < 0\n  index = index + size\nend\nbyte_index = char_index_to_byte_index(index)\nif byte_index && byte_index < @bytesize\n  reader = Char::Reader.new(self, pos: byte_index)\n  return reader.current_char\nelse\n  yield\nend\n"}},{"html_id":"char_index_to_byte_index(index)-instance-method","name":"char_index_to_byte_index","doc":"Returns the byte index of a char index, or `nil` if out of bounds.\n\nIt is valid to pass `#size` to *index*, and in this case the answer\nwill be the bytesize of this string.\n\n```\n\"hello\".char_index_to_byte_index(1) # => 1\n\"hello\".char_index_to_byte_index(5) # => 5\n\"こんにちは\".char_index_to_byte_index(1) # => 3\n\"こんにちは\".char_index_to_byte_index(5) # => 15\n```","summary":"<p>Returns the byte index of a char index, or <code>nil</code> if out of bounds.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":""}],"args_string":"(index)","args_html":"(index)","location":{"filename":"src/string.cr","line_number":3457,"url":null},"def":{"name":"char_index_to_byte_index","args":[{"name":"index","external_name":"index","restriction":""}],"visibility":"Public","body":"if single_byte_optimizable?\n  return 0 <= index && index <= bytesize ? index : nil\nend\nsize = each_byte_index_and_char_index do |byte_index, char_index|\n  if index == char_index\n    return byte_index\n  end\nend\nif index == size\n  return @bytesize\nend\nnil\n"}},{"html_id":"chars:Array(Char)-instance-method","name":"chars","doc":"Returns an `Array` of all characters in the string.\n\n```\n\"ab☃\".chars # => ['a', 'b', '☃']\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of all characters in the string.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4447,"url":null},"def":{"name":"chars","return_type":"Array(Char)","visibility":"Public","body":"chars = Array(Char).new(@length > 0 ? @length : bytesize)\neach_char do |char|\n  chars << char\nend\nchars\n"}},{"html_id":"check_no_null_byte(name=nil):self-instance-method","name":"check_no_null_byte","doc":"Raises an `ArgumentError` if `self` has null bytes. Returns `self` otherwise.\n\nThis method should sometimes be called before passing a `String` to a C function.","summary":"<p>Raises an <code><a href=\"ArgumentError.html\">ArgumentError</a></code> if <code>self</code> has null bytes.</p>","abstract":false,"args":[{"name":"name","default_value":"nil","external_name":"name","restriction":""}],"args_string":"(name = nil) : self","args_html":"(name = <span class=\"n\">nil</span>) : <span class=\"k\">self</span>","location":{"filename":"src/string.cr","line_number":5075,"url":null},"def":{"name":"check_no_null_byte","args":[{"name":"name","default_value":"nil","external_name":"name","restriction":""}],"return_type":"self","visibility":"Public","body":"if byte_index(0)\n  if name\n    name = \"`#{name}` \"\n  end\n  raise(ArgumentError.new(\"String #{name}contains null byte\"))\nend\nself\n"}},{"html_id":"chomp(suffix:Char):String-instance-method","name":"chomp","doc":"Returns a new `String` with *suffix* removed from the end of the string.\nIf *suffix* is `'\\n'` then `\"\\r\\n\"` is also removed if the string ends with it.\n\n```\n\"hello\".chomp('o') # => \"hell\"\n\"hello\".chomp('a') # => \"hello\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with <em>suffix</em> removed from the end of the string.</p>","abstract":false,"args":[{"name":"suffix","external_name":"suffix","restriction":"Char"}],"args_string":"(suffix : Char) : String","args_html":"(suffix : <a href=\"Char.html\">Char</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1476,"url":null},"def":{"name":"chomp","args":[{"name":"suffix","external_name":"suffix","restriction":"Char"}],"return_type":"String","visibility":"Public","body":"if suffix == '\\n'\n  chomp\nelse\n  if ends_with?(suffix)\n    unsafe_byte_slice_string(0, bytesize - suffix.bytesize)\n  else\n    self\n  end\nend"}},{"html_id":"chomp(suffix:String):String-instance-method","name":"chomp","doc":"Returns a new `String` with *suffix* removed from the end of the string.\nIf *suffix* is `\"\\n\"` then `\"\\r\\n\"` is also removed if the string ends with it.\n\n```\n\"hello\".chomp(\"llo\") # => \"he\"\n\"hello\".chomp(\"ol\")  # => \"hello\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with <em>suffix</em> removed from the end of the string.</p>","abstract":false,"args":[{"name":"suffix","external_name":"suffix","restriction":"String"}],"args_string":"(suffix : String) : String","args_html":"(suffix : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1493,"url":null},"def":{"name":"chomp","args":[{"name":"suffix","external_name":"suffix","restriction":"String"}],"return_type":"String","visibility":"Public","body":"if suffix.bytesize == 1\n  chomp(suffix.to_unsafe[0].unsafe_chr)\nelse\n  if ends_with?(suffix)\n    unsafe_byte_slice_string(0, bytesize - suffix.bytesize)\n  else\n    self\n  end\nend"}},{"html_id":"chomp:String-instance-method","name":"chomp","doc":"Returns a new `String` with the last carriage return removed (that is, it\nwill remove \\n, \\r, and \\r\\n).\n\n```\n\"string\\r\\n\".chomp # => \"string\"\n\"string\\n\\r\".chomp # => \"string\\n\"\n\"string\\n\".chomp   # => \"string\"\n\"string\".chomp     # => \"string\"\n\"x\".chomp.chomp    # => \"x\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with the last carriage return removed (that is, it will remove \\n, \\r, and \\r\\n).</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":1452,"url":null},"def":{"name":"chomp","return_type":"String","visibility":"Public","body":"if empty?\n  return self\nend\ncase to_unsafe[bytesize - 1]\nwhen '\\n'\n  if bytesize > 1 && (to_unsafe[bytesize - 2] === '\\r')\n    unsafe_byte_slice_string(0, bytesize - 2)\n  else\n    unsafe_byte_slice_string(0, bytesize - 1)\n  end\nwhen '\\r'\n  unsafe_byte_slice_string(0, bytesize - 1)\nelse\n  self\nend\n"}},{"html_id":"clone:String-instance-method","name":"clone","doc":"Returns `self`.","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":5007,"url":null},"def":{"name":"clone","return_type":"String","visibility":"Public","body":"self"}},{"html_id":"codepoint_at(index):Int32-instance-method","name":"codepoint_at","doc":"Returns the codepoint of the character at the given *index*.\n\nNegative indices can be used to start counting from the end of the string.\n\nRaises `IndexError` if the *index* is out of bounds.\n\nSee also: `Char#ord`.\n\n```\n\"hello\".codepoint_at(0)  # => 104\n\"hello\".codepoint_at(-1) # => 111\n\"hello\".codepoint_at(5)  # raises IndexError\n```","summary":"<p>Returns the codepoint of the character at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":""}],"args_string":"(index) : Int32","args_html":"(index) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/string.cr","line_number":1228,"url":null},"def":{"name":"codepoint_at","args":[{"name":"index","external_name":"index","restriction":""}],"return_type":"Int32","visibility":"Public","body":"(char_at(index)).ord"}},{"html_id":"codepoints:Array(Int32)-instance-method","name":"codepoints","doc":"Returns an `Array` of the codepoints that make the string.\n\n```\n\"ab☃\".codepoints # => [97, 98, 9731]\n```\n\nSee also: `Char#ord`.","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> of the codepoints that make the string.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4493,"url":null},"def":{"name":"codepoints","return_type":"Array(Int32)","visibility":"Public","body":"codepoints = Array(Int32).new(@length > 0 ? @length : bytesize)\neach_codepoint do |codepoint|\n  codepoints << codepoint\nend\ncodepoints\n"}},{"html_id":"compare(other:String,case_insensitive=false,options=Unicode::CaseOptions::None)-instance-method","name":"compare","doc":"Compares this string with *other*, returning `-1`, `0` or `1` depending on whether\nthis string is less, equal or greater than *other*, optionally in a *case_insensitive*\nmanner.\n\n```\n\"abcdef\".compare(\"abcde\")   # => 1\n\"abcdef\".compare(\"abcdef\")  # => 0\n\"abcdef\".compare(\"abcdefg\") # => -1\n\"abcdef\".compare(\"ABCDEF\")  # => 1\n\n\"abcdef\".compare(\"ABCDEF\", case_insensitive: true) # => 0\n\"abcdef\".compare(\"ABCDEG\", case_insensitive: true) # => -1\n\n\"heIIo\".compare(\"heııo\", case_insensitive: true, options: Unicode::CaseOptions::Turkic) # => 0\n```","summary":"<p>Compares this string with <em>other</em>, returning <code>-1</code>, <code>0</code> or <code>1</code> depending on whether this string is less, equal or greater than <em>other</em>, optionally in a <em>case_insensitive</em> manner.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"String"},{"name":"case_insensitive","default_value":"false","external_name":"case_insensitive","restriction":""},{"name":"options","default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"args_string":"(other : String, case_insensitive = false, options = Unicode::CaseOptions::None)","args_html":"(other : <a href=\"String.html\">String</a>, case_insensitive = <span class=\"n\">false</span>, options = <span class=\"t\">Unicode</span><span class=\"t\">::</span><span class=\"t\">CaseOptions</span><span class=\"t\">::</span><span class=\"t\">None</span>)","location":{"filename":"src/string.cr","line_number":2903,"url":null},"def":{"name":"compare","args":[{"name":"other","external_name":"other","restriction":"String"},{"name":"case_insensitive","default_value":"false","external_name":"case_insensitive","restriction":""},{"name":"options","default_value":"Unicode::CaseOptions::None","external_name":"options","restriction":""}],"visibility":"Public","body":"if case_insensitive\nelse\n  return self <=> other\nend\nif single_byte_optimizable? && other.single_byte_optimizable?\n  position = 0\n  while position < bytesize && position < other.bytesize\n    byte1 = to_unsafe[position]\n    byte2 = other.to_unsafe[position]\n    if 65 <= byte1 && byte1 <= 90\n      byte1 = byte1 + 32\n    end\n    if 65 <= byte2 && byte2 <= 90\n      byte2 = byte2 + 32\n    end\n    comparison = byte1 <=> byte2\n    if comparison == 0\n    else\n      return comparison\n    end\n    position = position + 1\n  end\n  bytesize <=> other.bytesize\nelse\n  reader1 = Char::Reader.new(self)\n  reader2 = Char::Reader.new(other)\n  char1 = reader1.current_char\n  char2 = reader2.current_char\n  while reader1.has_next? && reader2.has_next?\n    comparison = (char1.downcase(options)) <=> (char2.downcase(options))\n    if comparison == 0\n    else\n      return comparison.sign\n    end\n    char1 = reader1.next_char\n    char2 = reader2.next_char\n  end\n  if reader1.has_next?\n    1\n  else\n    if reader2.has_next?\n      -1\n    else\n      0\n    end\n  end\nend\n"}},{"html_id":"count(&)-instance-method","name":"count","doc":"Yields each char in this string to the block,\nreturns the number of times the block returned a truthy value.\n\n```\n\"aabbcc\".count &.in?('a', 'b') # => 4\n```","summary":"<p>Yields each char in this string to the block, returns the number of times the block returned a truthy value.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":2701,"url":null},"def":{"name":"count","yields":1,"visibility":"Public","body":"count = 0\neach_char do |char|\n  if yield char\n    count = count + 1\n  end\nend\ncount\n"}},{"html_id":"count(other:Char):Int32-instance-method","name":"count","doc":"Counts the occurrences of *other* char in this string.\n\n```\n\"aabbcc\".count('a') # => 2\n```","summary":"<p>Counts the occurrences of <em>other</em> char in this string.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Char"}],"args_string":"(other : Char) : Int32","args_html":"(other : <a href=\"Char.html\">Char</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/string.cr","line_number":2714,"url":null},"def":{"name":"count","args":[{"name":"other","external_name":"other","restriction":"Char"}],"return_type":"Int32","visibility":"Public","body":"count do |char|\n  char == other\nend"}},{"html_id":"count(*sets):Int32-instance-method","name":"count","doc":"Sets should be a list of strings following the rules\ndescribed at `Char#in_set?`. Returns the number of characters\nin this string that match the given set.","summary":"<p>Sets should be a list of strings following the rules described at <code><a href=\"Char.html#in_set%3F%28%2Asets%3AString%29%3ABool-instance-method\">Char#in_set?</a></code>.</p>","abstract":false,"args":[{"name":"sets","external_name":"sets","restriction":""}],"args_string":"(*sets) : Int32","args_html":"(*sets) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/string.cr","line_number":2721,"url":null},"def":{"name":"count","args":[{"name":"sets","external_name":"sets","restriction":""}],"splat_index":0,"return_type":"Int32","visibility":"Public","body":"count do |char|\n  char.in_set?(*sets)\nend"}},{"html_id":"delete(&)-instance-method","name":"delete","doc":"Yields each char in this string to the block.\nReturns a new `String` with all characters for which the\nblock returned a truthy value removed.\n\n```\n\"aabbcc\".delete &.in?('a', 'b') # => \"cc\"\n```","summary":"<p>Yields each char in this string to the block.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":2732,"url":null},"def":{"name":"delete","yields":1,"visibility":"Public","body":"String.build(bytesize) do |buffer|\n  each_char do |char|\n    if yield char\n    else\n      buffer << char\n    end\n  end\nend"}},{"html_id":"delete(char:Char):String-instance-method","name":"delete","doc":"Returns a new `String` with all occurrences of *char* removed.\n\n```\n\"aabbcc\".delete('b') # => \"aacc\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with all occurrences of <em>char</em> removed.</p>","abstract":false,"args":[{"name":"char","external_name":"char","restriction":"Char"}],"args_string":"(char : Char) : String","args_html":"(char : <a href=\"Char.html\">Char</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2745,"url":null},"def":{"name":"delete","args":[{"name":"char","external_name":"char","restriction":"Char"}],"return_type":"String","visibility":"Public","body":"delete do |my_char|\n  my_char == char\nend"}},{"html_id":"delete(*sets):String-instance-method","name":"delete","doc":"Sets should be a list of strings following the rules\ndescribed at `Char#in_set?`. Returns a new `String` with\nall characters that match the given set removed.\n\n```\n\"aabbccdd\".delete(\"a-c\") # => \"dd\"\n```","summary":"<p>Sets should be a list of strings following the rules described at <code><a href=\"Char.html#in_set%3F%28%2Asets%3AString%29%3ABool-instance-method\">Char#in_set?</a></code>.</p>","abstract":false,"args":[{"name":"sets","external_name":"sets","restriction":""}],"args_string":"(*sets) : String","args_html":"(*sets) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2756,"url":null},"def":{"name":"delete","args":[{"name":"sets","external_name":"sets","restriction":""}],"splat_index":0,"return_type":"String","visibility":"Public","body":"delete do |char|\n  char.in_set?(*sets)\nend"}},{"html_id":"delete_at(start:Int,count:Int):String-instance-method","name":"delete_at","doc":"Returns a new string that results from deleting *count* characters\nstarting at *start*.\n\n```\n\"abcdefg\".delete_at(1, 3) # => \"aefg\"\n```\n\nDeleting more characters than those in the string is valid, and just\nresults in deleting up to the last character:\n\n```\n\"abcdefg\".delete_at(3, 10) # => \"abc\"\n```\n\nA negative *start* counts from the end of the string:\n\n```\n\"abcdefg\".delete_at(-3, 2) # => \"abcdg\"\n```\n\nIf *count* is negative, `ArgumentError` is raised.\n\nIf *start* is outside the bounds of the string, `ArgumentError`\nis raised.\n\nHowever, *start* can be the position that is exactly the end of the string:\n\n```\n\"abcd\".delete_at(4, 3) # => \"abcd\"\n```","summary":"<p>Returns a new string that results from deleting <em>count</em> characters starting at <em>start</em>.</p>","abstract":false,"args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(start : Int, count : Int) : String","args_html":"(start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1061,"url":null},"def":{"name":"delete_at","args":[{"name":"start","external_name":"start","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"return_type":"String","visibility":"Public","body":"start, count = Indexable.normalize_start_and_count(start, count, size)\ncase count\nwhen 0\n  return self\nwhen size\n  return \"\"\nelse\n  if single_byte_optimizable?\n    byte_delete_at(start, count, count)\n  else\n    unicode_delete_at(start, count)\n  end\nend\n"}},{"html_id":"delete_at(range:Range):String-instance-method","name":"delete_at","doc":"Returns a new string that results from deleting characters\nat the given range.\n\n```\n\"abcdef\".delete_at(1..3) # => \"aef\"\n```\n\nNegative indices can be used to start counting from the end of the string:\n\n```\n\"abcdef\".delete_at(-3..-2) # => \"abcf\"\n```\n\nRaises `IndexError` if any index is outside the bounds of this string.","summary":"<p>Returns a new string that results from deleting characters at the given range.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range) : String","args_html":"(range : <a href=\"Range.html\">Range</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":986,"url":null},"def":{"name":"delete_at","args":[{"name":"range","external_name":"range","restriction":"Range"}],"return_type":"String","visibility":"Public","body":"delete_at(*(Indexable.range_to_index_and_count(range, size)) || (raise(IndexError.new)))"}},{"html_id":"delete_at(index:Int):String-instance-method","name":"delete_at","doc":"Returns a new string that results from deleting the character\nat the given *index*.\n\n```\n\"abcde\".delete_at(0) # => \"bcde\"\n\"abcde\".delete_at(2) # => \"abde\"\n\"abcde\".delete_at(4) # => \"abcd\"\n```\n\nA negative *index* counts from the end of the string:\n\n```\n\"abcde\".delete_at(-2) # => \"abce\"\n```\n\nIf *index* is outside the bounds of the string, `IndexError` is raised.","summary":"<p>Returns a new string that results from deleting the character at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : String","args_html":"(index : <a href=\"Int.html\">Int</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1006,"url":null},"def":{"name":"delete_at","args":[{"name":"index","external_name":"index","restriction":"Int"}],"return_type":"String","visibility":"Public","body":"if index < 0\n  index = index + size\nend\nbyte_index = char_index_to_byte_index(index)\nif byte_index && byte_index < @bytesize\n  char_bytesize = char_bytesize_at(byte_index)\n  new_bytesize = self.bytesize - char_bytesize\n  String.new(new_bytesize) do |buffer|\n    buffer.copy_from(to_unsafe, byte_index)\n    (buffer + byte_index).copy_from((to_unsafe + byte_index) + char_bytesize, (self.bytesize - byte_index) - char_bytesize)\n    {new_bytesize, size - 1}\n  end\nelse\n  raise(IndexError.new)\nend\n"}},{"html_id":"delete_at(*,indexstart:Int,count:Int):String-instance-method","name":"delete_at","doc":"Returns a new string that results from deleting *count* characters\nstarting at *start*.\n\n```\n\"abcdefg\".delete_at(1, 3) # => \"aefg\"\n```\n\nDeleting more characters than those in the string is valid, and just\nresults in deleting up to the last character:\n\n```\n\"abcdefg\".delete_at(3, 10) # => \"abc\"\n```\n\nA negative *start* counts from the end of the string:\n\n```\n\"abcdefg\".delete_at(-3, 2) # => \"abcdg\"\n```\n\nIf *count* is negative, `ArgumentError` is raised.\n\nIf *start* is outside the bounds of the string, `ArgumentError`\nis raised.\n\nHowever, *start* can be the position that is exactly the end of the string:\n\n```\n\"abcd\".delete_at(4, 3) # => \"abcd\"\n```","summary":"<p>Returns a new string that results from deleting <em>count</em> characters starting at <em>start</em>.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"String.html#delete_at%28start%3AInt%2Ccount%3AInt%29%3AString-instance-method\">#delete_at(start, count)</a></code> instead</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"index","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"args_string":"(*, index start : Int, count : Int) : String","args_html":"(*, index start : <a href=\"Int.html\">Int</a>, count : <a href=\"Int.html\">Int</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1080,"url":null},"def":{"name":"delete_at","args":[{"name":"","external_name":"","restriction":""},{"name":"start","external_name":"index","restriction":"Int"},{"name":"count","external_name":"count","restriction":"Int"}],"splat_index":0,"return_type":"String","visibility":"Public","body":"delete_at(start, count)"}},{"html_id":"downcase(options:Unicode::CaseOptions=:none):String-instance-method","name":"downcase","doc":"Returns a new `String` with each uppercase letter replaced with its lowercase counterpart.\n\n```\n\"hEllO\".downcase # => \"hello\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with each uppercase letter replaced with its lowercase counterpart.</p>","abstract":false,"args":[{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"args_string":"(options : Unicode::CaseOptions = :none) : String","args_html":"(options : <a href=\"Unicode/CaseOptions.html\">Unicode::CaseOptions</a> = <span class=\"n\">:none</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1288,"url":null},"def":{"name":"downcase","args":[{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"return_type":"String","visibility":"Public","body":"if empty?\n  return self\nend\nif single_byte_optimizable? && (options.none? || options.ascii?)\n  return String.new(bytesize) do |buffer|\n    bytesize.times do |i|\n      buffer[i] = to_unsafe[i].unsafe_chr.downcase.ord.to_u8\n    end\n    {@bytesize, @length}\n  end\nend\nString.build(bytesize) do |io|\n  downcase(io, options)\nend\n"}},{"html_id":"downcase(io:IO,options:Unicode::CaseOptions=:none):Nil-instance-method","name":"downcase","doc":"Writes a downcased version of `self` to the given *io*.\n\n```\nio = IO::Memory.new\n\"hEllO\".downcase io\nio.to_s # => \"hello\"\n```","summary":"<p>Writes a downcased version of <code>self</code> to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"args_string":"(io : IO, options : Unicode::CaseOptions = :none) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, options : <a href=\"Unicode/CaseOptions.html\">Unicode::CaseOptions</a> = <span class=\"n\">:none</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":1310,"url":null},"def":{"name":"downcase","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"return_type":"Nil","visibility":"Public","body":"each_char do |char|\n  char.downcase(options) do |res|\n    io << res\n  end\nend"}},{"html_id":"dump(io:IO):Nil-instance-method","name":"dump","doc":"Returns a representation of `self` as an ASCII-compatible Crystal string\nliteral, wrapped in double quotes.\n\nNon-printable characters (see `Char#printable?`) and non-ASCII characters\n(codepoints larger `U+007F`) are escaped.\n\n```\n\"\\u{1f48e} - à la carte\\n\".dump # => %(\"\\\\u{1F48E} - \\\\u00E0 la carte\\\\n\")\n```\n\nSee `Char#unicode_escape` for the format used to escape charactes without a\nspecial escape sequence.\n\n* `#dump_unquoted` omits the delimiters.\n* `#inspect` only escapes non-printable characters.","summary":"<p>Returns a representation of <code>self</code> as an ASCII-compatible Crystal string literal, wrapped in double quotes.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":4636,"url":null},"def":{"name":"dump","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"dump_or_inspect(io) do |char, error|\n  dump_char(char, error, io)\nend"}},{"html_id":"dump:String-instance-method","name":"dump","doc":"Returns a representation of `self` as an ASCII-compatible Crystal string\nliteral, wrapped in double quotes.\n\nNon-printable characters (see `Char#printable?`) and non-ASCII characters\n(codepoints larger `U+007F`) are escaped.\n\n```\n\"\\u{1f48e} - à la carte\\n\".dump # => %(\"\\\\u{1F48E} - \\\\u00E0 la carte\\\\n\")\n```\n\nSee `Char#unicode_escape` for the format used to escape charactes without a\nspecial escape sequence.\n\n* `#dump_unquoted` omits the delimiters.\n* `#inspect` only escapes non-printable characters.","summary":"<p>Returns a representation of <code>self</code> as an ASCII-compatible Crystal string literal, wrapped in double quotes.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4629,"url":null},"def":{"name":"dump","return_type":"String","visibility":"Public","body":"String.build do |io|\n  dump(io)\nend"}},{"html_id":"dump_unquoted:String-instance-method","name":"dump_unquoted","doc":"Returns a representation of `self` as the content of an ASCII-compatible\nCrystal string literal without delimiters.\n\nNon-printable characters (see `Char#printable?`) and non-ASCII characters\n(codepoints larger `U+007F`) are escaped.\n\n```\n\"\\u{1f48e} - à la carte\\n\".dump_unquoted # => %(\\\\u{1F48E} - \\\\u00E0 la carte\\\\n)\n```\n\nSee `Char#unicode_escape` for the format used to escape charactes without a\nspecial escape sequence.\n\n* `#dump` wraps the content in double quotes.\n* `#inspect_unquoted` only escapes non-printable characters.","summary":"<p>Returns a representation of <code>self</code> as the content of an ASCII-compatible Crystal string literal without delimiters.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4657,"url":null},"def":{"name":"dump_unquoted","return_type":"String","visibility":"Public","body":"String.build do |io|\n  dump_unquoted(io)\nend"}},{"html_id":"dup:String-instance-method","name":"dup","doc":"Returns `self`.","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":5012,"url":null},"def":{"name":"dup","return_type":"String","visibility":"Public","body":"self"}},{"html_id":"each_byte(&)-instance-method","name":"each_byte","doc":"Yields each byte in the string to the block.\n\n```\narray = [] of UInt8\n\"ab☃\".each_byte do |byte|\n  array << byte\nend\narray # => [97, 98, 226, 152, 131]\n```","summary":"<p>Yields each byte in the string to the block.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4510,"url":null},"def":{"name":"each_byte","yields":1,"visibility":"Public","body":"to_slice.each do |byte|\n  yield byte\nend\nnil\n"}},{"html_id":"each_byte-instance-method","name":"each_byte","doc":"Returns an `Iterator` over each byte in the string.\n\n```\nbytes = \"ab☃\".each_byte\nbytes.next # => 97\nbytes.next # => 98\nbytes.next # => 226\nbytes.next # => 152\nbytes.next # => 131\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> over each byte in the string.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4527,"url":null},"def":{"name":"each_byte","visibility":"Public","body":"to_slice.each"}},{"html_id":"each_char(&):Nil-instance-method","name":"each_char","doc":"Yields each character in the string to the block.\n\n```\narray = [] of Char\n\"ab☃\".each_char do |char|\n  array << char\nend\narray # => ['a', 'b', '☃']\n```","summary":"<p>Yields each character in the string to the block.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4399,"url":null},"def":{"name":"each_char","yields":1,"return_type":"Nil","visibility":"Public","body":"if single_byte_optimizable?\n  each_byte do |byte|\n    yield (    byte < 128 ? byte.unsafe_chr : Char::REPLACEMENT)\n  end\nelse\n  (Char::Reader.new(self)).each do |char|\n    yield char\n  end\nend"}},{"html_id":"each_char-instance-method","name":"each_char","doc":"Returns an `Iterator` over each character in the string.\n\n```\nchars = \"ab☃\".each_char\nchars.next # => 'a'\nchars.next # => 'b'\nchars.next # => '☃'\n```","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> over each character in the string.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4419,"url":null},"def":{"name":"each_char","visibility":"Public","body":"CharIterator.new(Char::Reader.new(self))"}},{"html_id":"each_char_with_index(offset=0,&)-instance-method","name":"each_char_with_index","doc":"Yields each character and its index in the string to the block.\n\n```\narray = [] of Tuple(Char, Int32)\n\"ab☃\".each_char_with_index do |char, index|\n  array << {char, index}\nend\narray # => [{'a', 0}, {'b', 1}, {'☃', 2}]\n```\n\nAccepts an optional *offset* parameter, which tells it to start counting\nfrom there.","summary":"<p>Yields each character and its index in the string to the block.</p>","abstract":false,"args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(offset = 0, &)","args_html":"(offset = <span class=\"n\">0</span>, &)","location":{"filename":"src/string.cr","line_number":4435,"url":null},"def":{"name":"each_char_with_index","args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"yields":2,"visibility":"Public","body":"each_char do |char|\n  yield char, offset\n  offset = offset + 1\nend"}},{"html_id":"each_codepoint(&)-instance-method","name":"each_codepoint","doc":"Yields each codepoint to the block.\n\n```\narray = [] of Int32\n\"ab☃\".each_codepoint do |codepoint|\n  array << codepoint\nend\narray # => [97, 98, 9731]\n```\n\nSee also: `Char#ord`.","summary":"<p>Yields each codepoint to the block.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4466,"url":null},"def":{"name":"each_codepoint","yields":1,"visibility":"Public","body":"each_char do |char|\n  yield char.ord\nend"}},{"html_id":"each_codepoint-instance-method","name":"each_codepoint","doc":"Returns an `Iterator` for each codepoint.\n\n```\ncodepoints = \"ab☃\".each_codepoint\ncodepoints.next # => 97\ncodepoints.next # => 98\ncodepoints.next # => 9731\n```\n\nSee also: `Char#ord`.","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> for each codepoint.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4482,"url":null},"def":{"name":"each_codepoint","visibility":"Public","body":"each_char.map(&.ord)"}},{"html_id":"each_grapheme(&:Grapheme->_):Nil-instance-method","name":"each_grapheme","doc":"Yields each Unicode extended grapheme cluster in this string.\n\n`Grapheme` clusters correspond to \"user-perceived characters\" and are defined\nin [Unicode Standard Annex #29](https://unicode.org/reports/tr29/). A cluster\ncan consist of multiple code points which together form a single glyph.\n\n```\n\"a👍🏼à\".each_grapheme do |cluster|\n  p! cluster\nend\n```\n\n* `#graphemes` collects all grapheme clusters in an array","summary":"<p>Yields each Unicode extended grapheme cluster in this string.</p>\n<p><span class=\"flag lime\">EXPERIMENTAL</span>  The grapheme API is still under development. Join the discussion at <a href=\"https://github.com/crystal-lang/crystal/issues/11610\">#11610</a>.</p>","abstract":false,"location":{"filename":"src/string/grapheme.cr","line_number":38,"url":null},"def":{"name":"each_grapheme","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Grapheme -> _)"},"return_type":"Nil","visibility":"Public","body":"each_grapheme_boundary do |range, last_char|\n  yield Grapheme.new(self, range, last_char)\nend"}},{"html_id":"each_grapheme:Iterator(Grapheme)-instance-method","name":"each_grapheme","doc":"Returns an iterator of this string split into Unicode extended grapheme clusters.\n\n`Grapheme` clusters correspond to \"user-perceived characters\" and are defined\nin [Unicode Standard Annex #29](https://unicode.org/reports/tr29/). A cluster\ncan consist of multiple code points which together form a single glyph.\n\n```\n\"a👍🏼à\".each_grapheme.to_a # => [String::Grapheme('a'), String::Grapheme(\"👍🏼\"), String::Grapheme(\"à\")]\n```\n\n* `#graphemes` collects all grapheme clusters in an array","summary":"<p>Returns an iterator of this string split into Unicode extended grapheme clusters.</p>\n<p><span class=\"flag lime\">EXPERIMENTAL</span>  The grapheme API is still under development. Join the discussion at <a href=\"https://github.com/crystal-lang/crystal/issues/11610\">#11610</a>.</p>","abstract":false,"location":{"filename":"src/string/grapheme.cr","line_number":68,"url":null},"def":{"name":"each_grapheme","return_type":"Iterator(Grapheme)","visibility":"Public","body":"GraphemeIterator.new(self)"}},{"html_id":"each_line(chomp=true,&block:String->):Nil-instance-method","name":"each_line","doc":"Splits the string after each newline and yields each line to a block.\n\n```\nhaiku = \"the first cold shower\neven the monkey seems to want\na little coat of straw\"\nhaiku.each_line do |stanza|\n  puts stanza\nend\n# output:\n# the first cold shower\n# even the monkey seems to want\n# a little coat of straw\n```","summary":"<p>Splits the string after each newline and yields each line to a block.</p>","abstract":false,"args":[{"name":"chomp","default_value":"true","external_name":"chomp","restriction":""}],"args_string":"(chomp = true, &block : String -> ) : Nil","args_html":"(chomp = <span class=\"n\">true</span>, &block : <a href=\"String.html\">String</a> -> ) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":3929,"url":null},"def":{"name":"each_line","args":[{"name":"chomp","default_value":"true","external_name":"chomp","restriction":""}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(String ->)"},"return_type":"Nil","visibility":"Public","body":"if empty?\n  return\nend\noffset = 0\nwhile byte_index = byte_index('\\n'.ord.to_u8, offset)\n  count = (byte_index - offset) + 1\n  if chomp\n    count = count - 1\n    if (offset + count) > 0 && (to_unsafe[(offset + count) - 1] === '\\r')\n      count = count - 1\n    end\n  end\n  yield unsafe_byte_slice_string(offset, count)\n  offset = byte_index + 1\nend\nif offset == bytesize\nelse\n  yield unsafe_byte_slice_string(offset)\nend\n"}},{"html_id":"each_line(chomp=true)-instance-method","name":"each_line","doc":"Returns an `Iterator` which yields each line of this string (see `String#each_line`).","summary":"<p>Returns an <code><a href=\"Iterator.html\">Iterator</a></code> which yields each line of this string (see <code><a href=\"String.html#each_line%28chomp%3Dtrue%2C%26block%3AString-%3E%29%3ANil-instance-method\">String#each_line</a></code>).</p>","abstract":false,"args":[{"name":"chomp","default_value":"true","external_name":"chomp","restriction":""}],"args_string":"(chomp = true)","args_html":"(chomp = <span class=\"n\">true</span>)","location":{"filename":"src/string.cr","line_number":3953,"url":null},"def":{"name":"each_line","args":[{"name":"chomp","default_value":"true","external_name":"chomp","restriction":""}],"visibility":"Public","body":"LineIterator.new(self, chomp)"}},{"html_id":"empty?:Bool-instance-method","name":"empty?","doc":"Returns `true` if this is the empty string, `\"\"`.","summary":"<p>Returns <code>true</code> if this is the empty string, <code>\"\"</code>.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":2814,"url":null},"def":{"name":"empty?","return_type":"Bool","visibility":"Public","body":"bytesize == 0"}},{"html_id":"encode(encoding:String,invalid:Symbol?=nil):Bytes-instance-method","name":"encode","doc":"Returns a slice of bytes containing this string encoded in the given encoding.\n\nThe *invalid* argument can be:\n* `nil`: an exception is raised on invalid byte sequences\n* `:skip`: invalid byte sequences are ignored\n\n```\n\"好\".encode(\"GB2312\") # => Bytes[186, 195]\n\"好\".bytes            # => [229, 165, 189]\n```","summary":"<p>Returns a slice of bytes containing this string encoded in the given encoding.</p>","abstract":false,"args":[{"name":"encoding","external_name":"encoding","restriction":"String"},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":"Symbol | ::Nil"}],"args_string":"(encoding : String, invalid : Symbol? = nil) : Bytes","args_html":"(encoding : <a href=\"String.html\">String</a>, invalid : <a href=\"Symbol.html\">Symbol</a>? = <span class=\"n\">nil</span>) : <a href=\"Bytes.html\">Bytes</a>","location":{"filename":"src/string.cr","line_number":1626,"url":null},"def":{"name":"encode","args":[{"name":"encoding","external_name":"encoding","restriction":"String"},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":"Symbol | ::Nil"}],"return_type":"Bytes","visibility":"Public","body":"io = IO::Memory.new\nString.encode(to_slice, \"UTF-8\", encoding, io, invalid)\nio.to_slice\n"}},{"html_id":"ends_with?(str:String):Bool-instance-method","name":"ends_with?","doc":"Returns `true` if this string ends with the given *str*.\n\n```\n\"hello\".ends_with?(\"o\")  # => true\n\"hello\".ends_with?(\"lo\") # => true\n\"hello\".ends_with?(\"ll\") # => false\n```","summary":"<p>Returns <code>true</code> if this string ends with the given <em>str</em>.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"String"}],"args_string":"(str : String) : Bool","args_html":"(str : <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/string.cr","line_number":4793,"url":null},"def":{"name":"ends_with?","args":[{"name":"str","external_name":"str","restriction":"String"}],"return_type":"Bool","visibility":"Public","body":"if str.bytesize > bytesize\n  return false\nend\n(((to_unsafe + bytesize) - str.bytesize).memcmp(str.to_unsafe, str.bytesize)) == 0\n"}},{"html_id":"ends_with?(char:Char):Bool-instance-method","name":"ends_with?","doc":"Returns `true` if this string ends with the given *char*.\n\n```\n\"hello\".ends_with?('o') # => true\n\"hello\".ends_with?('l') # => false\n```","summary":"<p>Returns <code>true</code> if this string ends with the given <em>char</em>.</p>","abstract":false,"args":[{"name":"char","external_name":"char","restriction":"Char"}],"args_string":"(char : Char) : Bool","args_html":"(char : <a href=\"Char.html\">Char</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/string.cr","line_number":4804,"url":null},"def":{"name":"ends_with?","args":[{"name":"char","external_name":"char","restriction":"Char"}],"return_type":"Bool","visibility":"Public","body":"if bytesize > 0\nelse\n  return false\nend\nif char.ascii? || single_byte_optimizable?\n  return to_unsafe[bytesize - 1] == char.ord\nend\nbytes, count = String.char_bytes_and_bytesize(char)\nif bytesize < count\n  return false\nend\ncount.times do |i|\n  if to_unsafe[(bytesize - count) + i] == bytes[i]\n  else\n    return false\n  end\nend\ntrue\n"}},{"html_id":"ends_with?(re:Regex):Bool-instance-method","name":"ends_with?","doc":"Returns `true` if the regular expression *re* matches at the end of this string.\n\n```\n\"22hello\".ends_with?(/[0-9]/) # => false\n\"22hello\".ends_with?(/[a-z]/) # => true\n\"22h\".ends_with?(/[a-z]/)     # => true\n\"22h\".ends_with?(/[A-Z]/)     # => false\n\"22h\".ends_with?(/[a-z]{2}/)  # => false\n\"22hh\".ends_with?(/[a-z]{2}/) # => true\n```","summary":"<p>Returns <code>true</code> if the regular expression <em>re</em> matches at the end of this string.</p>","abstract":false,"args":[{"name":"re","external_name":"re","restriction":"Regex"}],"args_string":"(re : Regex) : Bool","args_html":"(re : <a href=\"Regex.html\">Regex</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/string.cr","line_number":4831,"url":null},"def":{"name":"ends_with?","args":[{"name":"re","external_name":"re","restriction":"Regex"}],"return_type":"Bool","visibility":"Public","body":"!(!($~ = (/#{re}\\z/).match(self)))"}},{"html_id":"grapheme_size:Int32-instance-method","name":"grapheme_size","doc":"Returns the number of Unicode extended graphemes clusters in this string.\n\n* `#each_grapheme` iterates the grapheme clusters.","summary":"<p>Returns the number of Unicode extended graphemes clusters in this string.</p>\n<p><span class=\"flag lime\">EXPERIMENTAL</span>  The grapheme API is still under development. Join the discussion at <a href=\"https://github.com/crystal-lang/crystal/issues/11610\">#11610</a>.</p>","abstract":false,"location":{"filename":"src/string/grapheme.cr","line_number":48,"url":null},"def":{"name":"grapheme_size","return_type":"Int32","visibility":"Public","body":"size = 0\neach_grapheme_boundary do\n  size = size + 1\nend\nsize\n"}},{"html_id":"graphemes:Array(Grapheme)-instance-method","name":"graphemes","doc":"Returns this string split into Unicode extended grapheme clusters.\n\n`Grapheme` clusters correspond to \"user-perceived characters\" and are defined\nin [Unicode Standard Annex #29](https://unicode.org/reports/tr29/). A cluster\ncan consist of multiple code points which together form a single glyph.\n\n```\n\"a👍🏼à\".graphemes # => [String::Grapheme('a'), String::Grapheme(\"👍🏼\"), String::Grapheme(\"à\")]\n```\n\n* `#each_grapheme` iterates the grapheme clusters without allocating an array","summary":"<p>Returns this string split into Unicode extended grapheme clusters.</p>\n<p><span class=\"flag lime\">EXPERIMENTAL</span>  The grapheme API is still under development. Join the discussion at <a href=\"https://github.com/crystal-lang/crystal/issues/11610\">#11610</a>.</p>","abstract":false,"location":{"filename":"src/string/grapheme.cr","line_number":16,"url":null},"def":{"name":"graphemes","return_type":"Array(Grapheme)","visibility":"Public","body":"graphemes = [] of Grapheme\neach_grapheme do |grapheme|\n  graphemes << grapheme\nend\ngraphemes\n"}},{"html_id":"gsub(pattern:Regex,&)-instance-method","name":"gsub","doc":"Returns a `String` where all occurrences of the given *pattern* are replaced\nby the block value's value.\n\n```\n\"hello\".gsub(/./) { |s| s[0].ord.to_s + ' ' } # => \"104 101 108 108 111 \"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all occurrences of the given <em>pattern</em> are replaced by the block value's value.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"}],"args_string":"(pattern : Regex, &)","args_html":"(pattern : <a href=\"Regex.html\">Regex</a>, &)","location":{"filename":"src/string.cr","line_number":2520,"url":null},"def":{"name":"gsub","args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"}],"yields":2,"visibility":"Public","body":"gsub_append(pattern) do |string, match, buffer|\n  $~ = match\n  buffer << (yield string, match)\nend"}},{"html_id":"gsub(string:String,&)-instance-method","name":"gsub","doc":"Returns a `String` where all occurrences of the given *string* are replaced\nwith the block's value.\n\n```\n\"hello yellow\".gsub(\"ll\") { \"dd\" } # => \"heddo yeddow\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all occurrences of the given <em>string</em> are replaced with the block's value.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String, &)","args_html":"(string : <a href=\"String.html\">String</a>, &)","location":{"filename":"src/string.cr","line_number":2609,"url":null},"def":{"name":"gsub","args":[{"name":"string","external_name":"string","restriction":"String"}],"yields":1,"visibility":"Public","body":"byte_offset = 0\nindex = self.byte_index(string, byte_offset)\nif index\nelse\n  return self\nend\nlast_byte_offset = 0\nString.build(bytesize) do |buffer|\n  while index\n    buffer.write(unsafe_byte_slice(last_byte_offset, index - last_byte_offset))\n    buffer << (yield string)\n    if string.bytesize == 0\n      byte_offset = index + 1\n      last_byte_offset = index\n    else\n      byte_offset = index + string.bytesize\n      last_byte_offset = byte_offset\n    end\n    index = self.byte_index(string, byte_offset)\n  end\n  if last_byte_offset < bytesize\n    buffer.write(unsafe_byte_slice(last_byte_offset))\n  end\nend\n"}},{"html_id":"gsub(&block:Char->_)-instance-method","name":"gsub","doc":"Returns a `String` where each character yielded to the given block\nis replaced by the block's return value.\n\n```\n\"hello\".gsub { |char| char + 1 } # => \"ifmmp\"\n\"hello\".gsub { \"hi\" }            # => \"hihihihihi\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where each character yielded to the given block is replaced by the block's return value.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":2470,"url":null},"def":{"name":"gsub","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(Char -> _)"},"visibility":"Public","body":"String.build(bytesize) do |buffer|\n  each_char do |my_char|\n    buffer << (yield my_char)\n  end\nend"}},{"html_id":"gsub(char:Char,replacement):String-instance-method","name":"gsub","doc":"Returns a `String` where all occurrences of the given char are\nreplaced with the given *replacement*.\n\n```\n\"hello\".gsub('l', \"lo\")      # => \"heloloo\"\n\"hello world\".gsub('o', 'a') # => \"hella warld\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all occurrences of the given char are replaced with the given <em>replacement</em>.</p>","abstract":false,"args":[{"name":"char","external_name":"char","restriction":"Char"},{"name":"replacement","external_name":"replacement","restriction":""}],"args_string":"(char : Char, replacement) : String","args_html":"(char : <a href=\"Char.html\">Char</a>, replacement) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2485,"url":null},"def":{"name":"gsub","args":[{"name":"char","external_name":"char","restriction":"Char"},{"name":"replacement","external_name":"replacement","restriction":""}],"return_type":"String","visibility":"Public","body":"if replacement.is_a?(String) && (replacement.bytesize == 1)\n  return gsub(char, replacement.to_unsafe[0].unsafe_chr)\nend\nif includes?(char)\n  if (replacement.is_a?(Char) && char.ascii?) && replacement.ascii?\n    return gsub_ascii_char(char, replacement)\n  end\n  gsub do |my_char|\n    char == my_char ? replacement : my_char\n  end\nelse\n  self\nend\n"}},{"html_id":"gsub(pattern:Regex,hash:Hash(String,_)|NamedTuple):String-instance-method","name":"gsub","doc":"Returns a `String` where all occurrences of the given *pattern* are replaced\nwith a *hash* of replacements. If the *hash* contains the matched pattern,\nthe corresponding value is used as a replacement. Otherwise the match is\nnot included in the returned string.\n\n```\n# \"he\" and \"l\" are matched and replaced,\n# but \"o\" is not and so is not included\n\"hello\".gsub(/(he|l|o)/, {\"he\": \"ha\", \"l\": \"la\"}) # => \"halala\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all occurrences of the given <em>pattern</em> are replaced with a <em>hash</em> of replacements.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"},{"name":"hash","external_name":"hash","restriction":"Hash(String, _) | NamedTuple"}],"args_string":"(pattern : Regex, hash : Hash(String, _) | NamedTuple) : String","args_html":"(pattern : <a href=\"Regex.html\">Regex</a>, hash : <a href=\"Hash.html\">Hash</a>(<a href=\"String.html\">String</a>, _) | <a href=\"NamedTuple.html\">NamedTuple</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2583,"url":null},"def":{"name":"gsub","args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"},{"name":"hash","external_name":"hash","restriction":"Hash(String, _) | NamedTuple"}],"return_type":"String","visibility":"Public","body":"gsub(pattern) do |match|\n  hash[match]?\nend"}},{"html_id":"gsub(pattern:Regex,replacement,backreferences=true):String-instance-method","name":"gsub","doc":"Returns a `String` where all occurrences of the given *pattern* are replaced\nwith the given *replacement*.\n\n```\n\"hello\".gsub(/[aeiou]/, '*') # => \"h*ll*\"\n```\n\nWithin *replacement*, the special match variable `$~` will not refer to the\ncurrent match.\n\nIf *backreferences* is `true` (the default value), *replacement* can include backreferences:\n\n```\n\"hello\".gsub(/[aeiou]/, \"(\\\\0)\") # => \"h(e)ll(o)\"\n```\n\nWhen substitution is performed, any backreferences found in *replacement*\nwill be replaced with the contents of the corresponding capture group in\n*pattern*. Backreferences to capture groups that were not present in\n*pattern* or that did not match will be skipped. See `Regex` for information\nabout capture groups.\n\nBackreferences are expressed in the form `\"\\\\d\"`, where *d* is a group\nnumber, or `\"\\\\k<name>\"` where *name* is the name of a named capture group.\nA sequence of literal characters resembling a backreference can be\nexpressed by placing `\"\\\\\"` before the sequence.\n\n```\n\"foo\".gsub(/o/, \"x\\\\0x\")                  # => \"fxoxxox\"\n\"foofoo\".gsub(/(?<bar>oo)/, \"|\\\\k<bar>|\") # => \"f|oo|f|oo|\"\n\"foo\".gsub(/o/, \"\\\\\\\\0\")                  # => \"f\\\\0\\\\0\"\n```\n\nRaises `ArgumentError` if an incomplete named back-reference is present in\n*replacement*.\n\nRaises `IndexError` if a named group referenced in *replacement* is not present\nin *pattern*.","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all occurrences of the given <em>pattern</em> are replaced with the given <em>replacement</em>.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"},{"name":"replacement","external_name":"replacement","restriction":""},{"name":"backreferences","default_value":"true","external_name":"backreferences","restriction":""}],"args_string":"(pattern : Regex, replacement, backreferences = true) : String","args_html":"(pattern : <a href=\"Regex.html\">Regex</a>, replacement, backreferences = <span class=\"n\">true</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2565,"url":null},"def":{"name":"gsub","args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"},{"name":"replacement","external_name":"replacement","restriction":""},{"name":"backreferences","default_value":"true","external_name":"backreferences","restriction":""}],"return_type":"String","visibility":"Public","body":"if (backreferences && replacement.is_a?(String)) && replacement.has_back_references?\n  gsub_append(pattern) do |_, match, buffer|\n    scan_backreferences(replacement, match, buffer)\n  end\nelse\n  gsub(pattern) do\n    replacement\n  end\nend"}},{"html_id":"gsub(string:String,replacement):String-instance-method","name":"gsub","doc":"Returns a `String` where all occurrences of the given *string* are replaced\nwith the given *replacement*.\n\n```\n\"hello yellow\".gsub(\"ll\", \"dd\") # => \"heddo yeddow\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all occurrences of the given <em>string</em> are replaced with the given <em>replacement</em>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"replacement","external_name":"replacement","restriction":""}],"args_string":"(string : String, replacement) : String","args_html":"(string : <a href=\"String.html\">String</a>, replacement) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2595,"url":null},"def":{"name":"gsub","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"replacement","external_name":"replacement","restriction":""}],"return_type":"String","visibility":"Public","body":"if string.bytesize == 1\n  gsub(string.to_unsafe[0].unsafe_chr, replacement)\nelse\n  gsub(string) do\n    replacement\n  end\nend"}},{"html_id":"gsub(hash:Hash(Char,_)):String-instance-method","name":"gsub","doc":"Returns a `String` where all chars in the given hash are replaced\nby the corresponding *hash* values.\n\n```\n\"hello\".gsub({'e' => 'a', 'l' => 'd'}) # => \"haddo\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all chars in the given hash are replaced by the corresponding <em>hash</em> values.</p>","abstract":false,"args":[{"name":"hash","external_name":"hash","restriction":"Hash(Char, _)"}],"args_string":"(hash : Hash(Char, _)) : String","args_html":"(hash : <a href=\"Hash.html\">Hash</a>(<a href=\"Char.html\">Char</a>, _)) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2644,"url":null},"def":{"name":"gsub","args":[{"name":"hash","external_name":"hash","restriction":"Hash(Char, _)"}],"return_type":"String","visibility":"Public","body":"gsub do |char|\n  hash[char]? || char\nend"}},{"html_id":"gsub(tuple:NamedTuple):String-instance-method","name":"gsub","doc":"Returns a `String` where all chars in the given named tuple are replaced\nby the corresponding *tuple* values.\n\n```\n\"hello\".gsub({e: 'a', l: 'd'}) # => \"haddo\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where all chars in the given named tuple are replaced by the corresponding <em>tuple</em> values.</p>","abstract":false,"args":[{"name":"tuple","external_name":"tuple","restriction":"NamedTuple"}],"args_string":"(tuple : NamedTuple) : String","args_html":"(tuple : <a href=\"NamedTuple.html\">NamedTuple</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2656,"url":null},"def":{"name":"gsub","args":[{"name":"tuple","external_name":"tuple","restriction":"NamedTuple"}],"return_type":"String","visibility":"Public","body":"gsub do |char|\n  tuple[char.to_s]? || char\nend"}},{"html_id":"has_back_references?-instance-method","name":"has_back_references?","doc":"This returns `true` if this string has `'\\\\'` in it. It might not be a back reference,\nbut `'\\\\'` is probably used for back references, so this check is faster than parsing\nthe whole thing.","summary":"<p>This returns <code>true</code> if this string has <code>'\\\\'</code> in it.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":2410,"url":null},"def":{"name":"has_back_references?","visibility":"Public","body":"to_slice.index('\\\\'.ord.to_u8)"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/string.cr","line_number":4848,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher.string(self)"}},{"html_id":"hexbytes:Bytes-instance-method","name":"hexbytes","doc":"Interprets this string as containing a sequence of hexadecimal values\nand decodes it as a slice of bytes. Two consecutive bytes in the string\nrepresent a byte in the returned slice.\n\nRaises `ArgumentError` if this string does not denote an hexstring.\n\n```\n\"0102031aff\".hexbytes  # => Bytes[1, 2, 3, 26, 255]\n\"1\".hexbytes           # raises ArgumentError\n\"hello world\".hexbytes # raises ArgumentError\n```","summary":"<p>Interprets this string as containing a sequence of hexadecimal values and decodes it as a slice of bytes.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":1664,"url":null},"def":{"name":"hexbytes","return_type":"Bytes","visibility":"Public","body":"hexbytes? || (raise(ArgumentError.new(\"#{self} is not a hexstring\")))"}},{"html_id":"hexbytes?:Bytes?-instance-method","name":"hexbytes?","doc":"Interprets this string as containing a sequence of hexadecimal values\nand decodes it as a slice of bytes. Two consecutive bytes in the string\nrepresent a byte in the returned slice.\n\nReturns `nil` if this string does not denote an hexstring.\n\n```\n\"0102031aff\".hexbytes?  # => Bytes[1, 2, 3, 26, 255]\n\"1\".hexbytes?           # => nil\n\"hello world\".hexbytes? # => nil\n```","summary":"<p>Interprets this string as containing a sequence of hexadecimal values and decodes it as a slice of bytes.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":1679,"url":null},"def":{"name":"hexbytes?","return_type":"Bytes | ::Nil","visibility":"Public","body":"if bytesize.divisible_by?(2)\nelse\n  return\nend\nbytes = Bytes.new(bytesize // 2)\ni = 0\nwhile i < bytesize\n  high_nibble = to_unsafe[i].unsafe_chr.to_u8?(16)\n  low_nibble = to_unsafe[i + 1].unsafe_chr.to_u8?(16)\n  if high_nibble && low_nibble\n  else\n    return\n  end\n  bytes[i // 2] = (high_nibble << 4) | low_nibble\n  i = i + 2\nend\nbytes\n"}},{"html_id":"includes?(search:Char|String):Bool-instance-method","name":"includes?","doc":"Returns `true` if the string contains *search*.\n\n```\n\"Team\".includes?('i')            # => false\n\"Dysfunctional\".includes?(\"fun\") # => true\n```","summary":"<p>Returns <code>true</code> if the string contains <em>search</em>.</p>","abstract":false,"args":[{"name":"search","external_name":"search","restriction":"Char | String"}],"args_string":"(search : Char | String) : Bool","args_html":"(search : <a href=\"Char.html\">Char</a> | <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/string.cr","line_number":3491,"url":null},"def":{"name":"includes?","args":[{"name":"search","external_name":"search","restriction":"Char | String"}],"return_type":"Bool","visibility":"Public","body":"!(!(index(search)))"}},{"html_id":"index(search:Char,offset=0):Int32?-instance-method","name":"index","doc":"Returns the index of the _first_ occurrence of *search* in the string, or `nil` if not present.\nIf *offset* is present, it defines the position to start the search.\n\n```\n\"Hello, World\".index('o')    # => 4\n\"Hello, World\".index('Z')    # => nil\n\"Hello, World\".index(\"o\", 5) # => 8\n\"Hello, World\".index(\"H\", 2) # => nil\n\"Hello, World\".index(/[ ]+/) # => 6\n\"Hello, World\".index(/\\d+/)  # => nil\n```","summary":"<p>Returns the index of the <em>first</em> occurrence of <em>search</em> in the string, or <code>nil</code> if not present.</p>","abstract":false,"args":[{"name":"search","external_name":"search","restriction":"Char"},{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(search : Char, offset = 0) : Int32?","args_html":"(search : <a href=\"Char.html\">Char</a>, offset = <span class=\"n\">0</span>) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/string.cr","line_number":3073,"url":null},"def":{"name":"index","args":[{"name":"search","external_name":"search","restriction":"Char"},{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"if search.ascii? && single_byte_optimizable?\n  return to_slice.fast_index(search.ord.to_u8, offset)\nend\nif offset < 0\n  offset = offset + size\nend\nif offset < 0\n  return nil\nend\neach_char_with_index do |char, i|\n  if i >= offset && (char == search)\n    return i\n  end\nend\nnil\n"}},{"html_id":"index(search:String,offset=0)-instance-method","name":"index","doc":"Returns the index of the _first_ occurrence of *search* in the string, or `nil` if not present.\nIf *offset* is present, it defines the position to start the search.\n\n```\n\"Hello, World\".index('o')    # => 4\n\"Hello, World\".index('Z')    # => nil\n\"Hello, World\".index(\"o\", 5) # => 8\n\"Hello, World\".index(\"H\", 2) # => nil\n\"Hello, World\".index(/[ ]+/) # => 6\n\"Hello, World\".index(/\\d+/)  # => nil\n```","summary":"<p>Returns the index of the <em>first</em> occurrence of <em>search</em> in the string, or <code>nil</code> if not present.</p>","abstract":false,"args":[{"name":"search","external_name":"search","restriction":"String"},{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(search : String, offset = 0)","args_html":"(search : <a href=\"String.html\">String</a>, offset = <span class=\"n\">0</span>)","location":{"filename":"src/string.cr","line_number":3092,"url":null},"def":{"name":"index","args":[{"name":"search","external_name":"search","restriction":"String"},{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"visibility":"Public","body":"if offset < 0\n  offset = offset + size\nend\nif offset < 0\n  return\nend\nif search.empty?\n  return size < offset ? nil : offset\nend\nsearch_hash = 0_u32\nsearch.each_byte do |b|\n  search_hash = (search_hash &* PRIME_RK) &+ b\nend\npow = PRIME_RK &** search.bytesize\nchar_index = 0\npointer = to_unsafe\nend_pointer = pointer + bytesize\nwhile char_index < offset && pointer < end_pointer\n  char_bytesize = String.char_bytesize_at(pointer)\n  pointer = pointer + char_bytesize\n  char_index = char_index + 1\nend\nhead_pointer = pointer\nhash = 0_u32\nhash_end_pointer = pointer + search.bytesize\nif hash_end_pointer > end_pointer\n  return\nend\nwhile pointer < hash_end_pointer\n  hash = (hash &* PRIME_RK) &+ pointer.value\n  pointer = pointer + 1\nend\nwhile true\n  if (hash == search_hash) && ((head_pointer.memcmp(search.to_unsafe, search.bytesize)) == 0)\n    return char_index\n  end\n  if pointer >= end_pointer\n    return\n  end\n  byte = head_pointer.value\n  char_bytesize = String.char_bytesize_at(head_pointer)\n  case char_bytesize\n  when 1\n    update_hash(1)\n  when 2\n    update_hash(2)\n  when 3\n    update_hash(3)\n  else\n    update_hash(4)\n  end\n  char_index = char_index + 1\nend\n"}},{"html_id":"index(search:Regex,offset=0):Int32?-instance-method","name":"index","doc":"Returns the index of the _first_ occurrence of *search* in the string, or `nil` if not present.\nIf *offset* is present, it defines the position to start the search.\n\n```\n\"Hello, World\".index('o')    # => 4\n\"Hello, World\".index('Z')    # => nil\n\"Hello, World\".index(\"o\", 5) # => 8\n\"Hello, World\".index(\"H\", 2) # => nil\n\"Hello, World\".index(/[ ]+/) # => 6\n\"Hello, World\".index(/\\d+/)  # => nil\n```","summary":"<p>Returns the index of the <em>first</em> occurrence of <em>search</em> in the string, or <code>nil</code> if not present.</p>","abstract":false,"args":[{"name":"search","external_name":"search","restriction":"Regex"},{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(search : Regex, offset = 0) : Int32?","args_html":"(search : <a href=\"Regex.html\">Regex</a>, offset = <span class=\"n\">0</span>) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/string.cr","line_number":3151,"url":null},"def":{"name":"index","args":[{"name":"search","external_name":"search","restriction":"Regex"},{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"if offset < 0\n  offset = offset + size\nend\nif 0 <= offset && offset <= size\nelse\n  return nil\nend\n(self.match(search, offset)).try(&.begin)\n"}},{"html_id":"insert(index:Int,other:Char):String-instance-method","name":"insert","doc":"Returns a new `String` that results of inserting *other* in `self` at *index*.\nNegative indices count from the end of the string, and insert **after**\nthe given index.\n\nRaises `IndexError` if the index is out of bounds.\n\n```\n\"abcd\".insert(0, 'X')  # => \"Xabcd\"\n\"abcd\".insert(3, 'X')  # => \"abcXd\"\n\"abcd\".insert(4, 'X')  # => \"abcdX\"\n\"abcd\".insert(-3, 'X') # => \"abXcd\"\n\"abcd\".insert(-1, 'X') # => \"abcdX\"\n\n\"abcd\".insert(5, 'X')  # raises IndexError\n\"abcd\".insert(-6, 'X') # raises IndexError\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> that results of inserting <em>other</em> in <code>self</code> at <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"other","external_name":"other","restriction":"Char"}],"args_string":"(index : Int, other : Char) : String","args_html":"(index : <a href=\"Int.html\">Int</a>, other : <a href=\"Char.html\">Char</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1713,"url":null},"def":{"name":"insert","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"other","external_name":"other","restriction":"Char"}],"return_type":"String","visibility":"Public","body":"index = index.to_i\nif index < 0\n  index = index + (size + 1)\nend\nbyte_index = char_index_to_byte_index(index)\nif byte_index\nelse\n  raise(IndexError.new)\nend\nbytes, count = String.char_bytes_and_bytesize(other)\nnew_bytesize = bytesize + count\nnew_size = (single_byte_optimizable? && other.ascii?) ? new_bytesize : 0\ninsert_impl(byte_index, bytes.to_unsafe, count, new_bytesize, new_size)\n"}},{"html_id":"insert(index:Int,other:String):String-instance-method","name":"insert","doc":"Returns a new `String` that results of inserting *other* in `self` at *index*.\nNegative indices count from the end of the string, and insert **after**\nthe given index.\n\nRaises `IndexError` if the index is out of bounds.\n\n```\n\"abcd\".insert(0, \"FOO\")  # => \"FOOabcd\"\n\"abcd\".insert(3, \"FOO\")  # => \"abcFOOd\"\n\"abcd\".insert(4, \"FOO\")  # => \"abcdFOO\"\n\"abcd\".insert(-3, \"FOO\") # => \"abFOOcd\"\n\"abcd\".insert(-1, \"FOO\") # => \"abcdFOO\"\n\n\"abcd\".insert(5, \"FOO\")  # raises IndexError\n\"abcd\".insert(-6, \"FOO\") # raises IndexError\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> that results of inserting <em>other</em> in <code>self</code> at <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"other","external_name":"other","restriction":"String"}],"args_string":"(index : Int, other : String) : String","args_html":"(index : <a href=\"Int.html\">Int</a>, other : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1744,"url":null},"def":{"name":"insert","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"other","external_name":"other","restriction":"String"}],"return_type":"String","visibility":"Public","body":"index = index.to_i\nif index < 0\n  index = index + (size + 1)\nend\nbyte_index = char_index_to_byte_index(index)\nif byte_index\nelse\n  raise(IndexError.new)\nend\nnew_bytesize = bytesize + other.bytesize\nnew_size = single_byte_optimizable? && other.single_byte_optimizable? ? new_bytesize : 0\ninsert_impl(byte_index, other.to_unsafe, other.bytesize, new_bytesize, new_size)\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Returns a representation of `self` as a Crystal string literal, wrapped in\ndouble quotes.\n\nNon-printable characters (see `Char#printable?`) are escaped.\n\n```\n\"\\u{1f48e} - à la carte\\n\".inspect # => %(\"\\u{1F48E} - à la carte\\\\n\")\n```\n\nSee `Char#unicode_escape` for the format used to escape charactes without a\nspecial escape sequence.\n\n* `#inspect_unquoted` omits the delimiters.\n* `#dump` additionally escapes all non-ASCII characters.","summary":"<p>Returns a representation of <code>self</code> as a Crystal string literal, wrapped in double quotes.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":4581,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"dump_or_inspect(io) do |char, error|\n  inspect_char(char, error, io)\nend"}},{"html_id":"inspect:String-instance-method","name":"inspect","doc":"Returns a representation of `self` as a Crystal string literal, wrapped in\ndouble quotes.\n\nNon-printable characters (see `Char#printable?`) are escaped.\n\n```\n\"\\u{1f48e} - à la carte\\n\".inspect # => %(\"\\u{1F48E} - à la carte\\\\n\")\n```\n\nSee `Char#unicode_escape` for the format used to escape charactes without a\nspecial escape sequence.\n\n* `#inspect_unquoted` omits the delimiters.\n* `#dump` additionally escapes all non-ASCII characters.","summary":"<p>Returns a representation of <code>self</code> as a Crystal string literal, wrapped in double quotes.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4576,"url":null},"def":{"name":"inspect","return_type":"String","visibility":"Public","body":"super()"}},{"html_id":"inspect_unquoted(io:IO):Nil-instance-method","name":"inspect_unquoted","doc":"Returns a representation of `self` as the content of a Crystal string literal\nwithout delimiters.\n\nNon-printable characters (see `Char#printable?`) are escaped.\n\n```\n\"\\u{1f48e} - à la carte\\n\".inspect_unquoted # => %(\\u{1F48E} - à la carte\\\\n)\n```\n\nSee `Char#unicode_escape` for the format used to escape charactes without a\nspecial escape sequence.\n\n* `#inspect` wraps the content in double quotes.\n* `#dump_unquoted` additionally escapes all non-ASCII characters.","summary":"<p>Returns a representation of <code>self</code> as the content of a Crystal string literal without delimiters.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":4608,"url":null},"def":{"name":"inspect_unquoted","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"dump_or_inspect_unquoted(io) do |char, error|\n  inspect_char(char, error, io)\nend"}},{"html_id":"inspect_unquoted:String-instance-method","name":"inspect_unquoted","doc":"Returns a representation of `self` as the content of a Crystal string literal\nwithout delimiters.\n\nNon-printable characters (see `Char#printable?`) are escaped.\n\n```\n\"\\u{1f48e} - à la carte\\n\".inspect_unquoted # => %(\\u{1F48E} - à la carte\\\\n)\n```\n\nSee `Char#unicode_escape` for the format used to escape charactes without a\nspecial escape sequence.\n\n* `#inspect` wraps the content in double quotes.\n* `#dump_unquoted` additionally escapes all non-ASCII characters.","summary":"<p>Returns a representation of <code>self</code> as the content of a Crystal string literal without delimiters.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4601,"url":null},"def":{"name":"inspect_unquoted","return_type":"String","visibility":"Public","body":"String.build do |io|\n  inspect_unquoted(io)\nend"}},{"html_id":"lchop(prefix:Char|String):String-instance-method","name":"lchop","doc":"Returns a new `String` with *prefix* removed from the beginning of the string.\n\n```\n\"hello\".lchop('h')   # => \"ello\"\n\"hello\".lchop('g')   # => \"hello\"\n\"hello\".lchop(\"hel\") # => \"lo\"\n\"hello\".lchop(\"eh\")  # => \"hello\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with <em>prefix</em> removed from the beginning of the string.</p>","abstract":false,"args":[{"name":"prefix","external_name":"prefix","restriction":"Char | String"}],"args_string":"(prefix : Char | String) : String","args_html":"(prefix : <a href=\"Char.html\">Char</a> | <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1522,"url":null},"def":{"name":"lchop","args":[{"name":"prefix","external_name":"prefix","restriction":"Char | String"}],"return_type":"String","visibility":"Public","body":"(lchop?(prefix)) || self"}},{"html_id":"lchop:String-instance-method","name":"lchop","doc":"Returns a new `String` with the first char removed from it.\nApplying lchop to an empty string returns an empty string.\n\n```\n\"hello\".lchop # => \"ello\"\n\"\".lchop      # => \"\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with the first char removed from it.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":1510,"url":null},"def":{"name":"lchop","return_type":"String","visibility":"Public","body":"lchop? || \"\""}},{"html_id":"lchop?(prefix:Char|String):String?-instance-method","name":"lchop?","doc":"Returns a new `String` with *prefix* removed from the beginning of the string if possible, else returns `nil`.\n\n```\n\"hello\".lchop?('h')   # => \"ello\"\n\"hello\".lchop?('g')   # => nil\n\"hello\".lchop?(\"hel\") # => \"lo\"\n\"hello\".lchop?(\"eh\")  # => nil\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with <em>prefix</em> removed from the beginning of the string if possible, else returns <code>nil</code>.</p>","abstract":false,"args":[{"name":"prefix","external_name":"prefix","restriction":"Char | String"}],"args_string":"(prefix : Char | String) : String?","args_html":"(prefix : <a href=\"Char.html\">Char</a> | <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/string.cr","line_number":1551,"url":null},"def":{"name":"lchop?","args":[{"name":"prefix","external_name":"prefix","restriction":"Char | String"}],"return_type":"String | ::Nil","visibility":"Public","body":"if starts_with?(prefix)\n  unsafe_byte_slice_string(prefix.bytesize, bytesize - prefix.bytesize)\nend"}},{"html_id":"lchop?:String?-instance-method","name":"lchop?","doc":"Returns a new `String` with the first char removed from it if possible, else returns `nil`.\n\n```\n\"hello\".lchop? # => \"ello\"\n\"\".lchop?      # => nil\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with the first char removed from it if possible, else returns <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":1532,"url":null},"def":{"name":"lchop?","return_type":"String | ::Nil","visibility":"Public","body":"if empty?\n  return\nend\nif single_byte_optimizable?\n  unsafe_byte_slice_string(1, bytesize - 1)\nelse\n  reader = Char::Reader.new(self)\n  unsafe_byte_slice_string(reader.current_char_width, bytesize - reader.current_char_width)\nend\n"}},{"html_id":"lines(chomp=true):Array(String)-instance-method","name":"lines","abstract":false,"args":[{"name":"chomp","default_value":"true","external_name":"chomp","restriction":""}],"args_string":"(chomp = true) : Array(String)","args_html":"(chomp = <span class=\"n\">true</span>) : <a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)","location":{"filename":"src/string.cr","line_number":3907,"url":null},"def":{"name":"lines","args":[{"name":"chomp","default_value":"true","external_name":"chomp","restriction":""}],"return_type":"Array(String)","visibility":"Public","body":"lines = [] of String\neach_line(chomp: chomp) do |line|\n  lines << line\nend\nlines\n"}},{"html_id":"ljust(len:Int,char:Char=''):String-instance-method","name":"ljust","doc":"Adds instances of *char* to right of the string until it is at least size of *len*.\n\n```\n\"Purple\".ljust(8)      # => \"Purple  \"\n\"Purple\".ljust(8, '-') # => \"Purple--\"\n\"Aubergine\".ljust(8)   # => \"Aubergine\"\n```","summary":"<p>Adds instances of <em>char</em> to right of the string until it is at least size of <em>len</em>.</p>","abstract":false,"args":[{"name":"len","external_name":"len","restriction":"Int"},{"name":"char","default_value":"' '","external_name":"char","restriction":"Char"}],"args_string":"(len : Int, char : Char = ' ') : String","args_html":"(len : <a href=\"Int.html\">Int</a>, char : <a href=\"Char.html\">Char</a> = <span class=\"s\">&#39; &#39;</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":4125,"url":null},"def":{"name":"ljust","args":[{"name":"len","external_name":"len","restriction":"Int"},{"name":"char","default_value":"' '","external_name":"char","restriction":"Char"}],"return_type":"String","visibility":"Public","body":"just(len, char, -1)"}},{"html_id":"ljust(io:IO,len:Int,char:Char=''):Nil-instance-method","name":"ljust","doc":"Adds instances of *char* to right of the string until it is at least size of *len*,\nand then appends the result to the given IO.\n\n```\nio = IO::Memory.new\n\"Purple\".ljust(io, 8, '-')\nio.to_s # => \"Purple--\"\n```","summary":"<p>Adds instances of <em>char</em> to right of the string until it is at least size of <em>len</em>, and then appends the result to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"len","external_name":"len","restriction":"Int"},{"name":"char","default_value":"' '","external_name":"char","restriction":"Char"}],"args_string":"(io : IO, len : Int, char : Char = ' ') : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, len : <a href=\"Int.html\">Int</a>, char : <a href=\"Char.html\">Char</a> = <span class=\"s\">&#39; &#39;</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":4137,"url":null},"def":{"name":"ljust","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"len","external_name":"len","restriction":"Int"},{"name":"char","default_value":"' '","external_name":"char","restriction":"Char"}],"return_type":"Nil","visibility":"Public","body":"io << self\n(len - size).times do\n  io << char\nend\n"}},{"html_id":"lstrip(char:Char):String-instance-method","name":"lstrip","doc":"Returns a new string with leading occurrences of *char* removed.\n\n```\n\"aaabcdaaa\".lstrip('a') # => \"bcdaaa\"\n```","summary":"<p>Returns a new string with leading occurrences of <em>char</em> removed.</p>","abstract":false,"args":[{"name":"char","external_name":"char","restriction":"Char"}],"args_string":"(char : Char) : String","args_html":"(char : <a href=\"Char.html\">Char</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1914,"url":null},"def":{"name":"lstrip","args":[{"name":"char","external_name":"char","restriction":"Char"}],"return_type":"String","visibility":"Public","body":"if empty?\n  return self\nend\nremove_excess_left(calc_excess_left(char))\n"}},{"html_id":"lstrip(chars:String):String-instance-method","name":"lstrip","doc":"Returns a new string where leading occurrences of any char\nin *chars* are removed. The *chars* argument is not a suffix;\nrather; all combinations of its values are stripped.\n\n```\n\"bcadefcba\".lstrip(\"abc\") # => \"defcba\"\n```","summary":"<p>Returns a new string where leading occurrences of any char in <em>chars</em> are removed.</p>","abstract":false,"args":[{"name":"chars","external_name":"chars","restriction":"String"}],"args_string":"(chars : String) : String","args_html":"(chars : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1927,"url":null},"def":{"name":"lstrip","args":[{"name":"chars","external_name":"chars","restriction":"String"}],"return_type":"String","visibility":"Public","body":"if empty?\n  return self\nend\ncase chars.size\nwhen 0\n  self\nwhen 1\n  lstrip(chars[0])\nelse\n  remove_excess_left(calc_excess_left(chars))\nend\n"}},{"html_id":"lstrip:String-instance-method","name":"lstrip","doc":"Returns a new `String` with leading whitespace removed.\n\n```\n\"    hello    \".lstrip # => \"hello    \"\n\"\\tgoodbye\\r\\n\".lstrip # => \"goodbye\\r\\n\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with leading whitespace removed.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":1905,"url":null},"def":{"name":"lstrip","return_type":"String","visibility":"Public","body":"remove_excess_left(calc_excess_left)"}},{"html_id":"lstrip(&block:Char->_)-instance-method","name":"lstrip","doc":"Returns a new string where leading characters for which\nthe block returns a *truthy* value are removed.\n\n```\n\"bcadefcba\".lstrip { |c| 'a' <= c <= 'c' } # => \"defcba\"\n```","summary":"<p>Returns a new string where leading characters for which the block returns a <em>truthy</em> value are removed.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":1946,"url":null},"def":{"name":"lstrip","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(Char -> _)"},"visibility":"Public","body":"if empty?\n  return self\nend\nexcess_left = calc_excess_left do |c|\n  yield c\nend\nremove_excess_left(excess_left)\n"}},{"html_id":"match(regex:Regex,pos=0):Regex::MatchData?-instance-method","name":"match","doc":"Finds match of *regex*, starting at *pos*.\nIt also updates `$~` with the result.\n\n```\n\"foo\".match(/foo/) # => Regex::MatchData(\"foo\")\n$~                 # => Regex::MatchData(\"foo\")\n\n\"foo\".match(/bar/) # => nil\n$~                 # raises Exception\n```","summary":"<p>Finds match of <em>regex</em>, starting at <em>pos</em>.</p>","abstract":false,"args":[{"name":"regex","external_name":"regex","restriction":"Regex"},{"name":"pos","default_value":"0","external_name":"pos","restriction":""}],"args_string":"(regex : Regex, pos = 0) : Regex::MatchData?","args_html":"(regex : <a href=\"Regex.html\">Regex</a>, pos = <span class=\"n\">0</span>) : <a href=\"Regex/MatchData.html\">Regex::MatchData</a>?","location":{"filename":"src/string.cr","line_number":4321,"url":null},"def":{"name":"match","args":[{"name":"regex","external_name":"regex","restriction":"Regex"},{"name":"pos","default_value":"0","external_name":"pos","restriction":""}],"return_type":"Regex::MatchData | ::Nil","visibility":"Public","body":"match = regex.match(self, pos)\n$~ = match\nmatch\n"}},{"html_id":"matches?(regex:Regex,pos=0):Bool-instance-method","name":"matches?","doc":"Finds match of *regex* like `#match`, but it returns `Bool` value.\nIt neither returns `MatchData` nor assigns it to the `$~` variable.\n\n```\n\"foo\".matches?(/bar/) # => false\n\"foo\".matches?(/foo/) # => true\n\n# `$~` is not set even if last match succeeds.\n$~ # raises Exception\n```","summary":"<p>Finds match of <em>regex</em> like <code><a href=\"String.html#match%28regex%3ARegex%2Cpos%3D0%29%3ARegex%3A%3AMatchData%3F-instance-method\">#match</a></code>, but it returns <code><a href=\"Bool.html\">Bool</a></code> value.</p>","abstract":false,"args":[{"name":"regex","external_name":"regex","restriction":"Regex"},{"name":"pos","default_value":"0","external_name":"pos","restriction":""}],"args_string":"(regex : Regex, pos = 0) : Bool","args_html":"(regex : <a href=\"Regex.html\">Regex</a>, pos = <span class=\"n\">0</span>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/string.cr","line_number":4337,"url":null},"def":{"name":"matches?","args":[{"name":"regex","external_name":"regex","restriction":"Regex"},{"name":"pos","default_value":"0","external_name":"pos","restriction":""}],"return_type":"Bool","visibility":"Public","body":"regex.matches?(self, pos)"}},{"html_id":"partition(search:Char|String):Tuple(String,String,String)-instance-method","name":"partition","doc":"Searches separator or pattern (`Regex`) in the string, and returns\na `Tuple` with the part before it, the match, and the part after it.\nIf it is not found, returns str followed by two empty strings.\n\n```\n\"hello\".partition(\"l\") # => {\"he\", \"l\", \"lo\"}\n\"hello\".partition(\"x\") # => {\"hello\", \"\", \"\"}\n```","summary":"<p>Searches separator or pattern (<code><a href=\"Regex.html\">Regex</a></code>) in the string, and returns a <code><a href=\"Tuple.html\">Tuple</a></code> with the part before it, the match, and the part after it.</p>","abstract":false,"args":[{"name":"search","external_name":"search","restriction":"Char | String"}],"args_string":"(search : Char | String) : Tuple(String, String, String)","args_html":"(search : <a href=\"Char.html\">Char</a> | <a href=\"String.html\">String</a>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"String.html\">String</a>, <a href=\"String.html\">String</a>, <a href=\"String.html\">String</a>)","location":{"filename":"src/string.cr","line_number":3272,"url":null},"def":{"name":"partition","args":[{"name":"search","external_name":"search","restriction":"Char | String"}],"return_type":"Tuple(String, String, String)","visibility":"Public","body":"pre = mid = post = \"\"\nsearch_size = search.is_a?(Char) ? 1 : search.size\ncase pos = self.index(search)\nwhen .nil?\n  pre = self\nwhen 0\n  mid = search.to_s\n  post = self[(pos + search_size)..-1]\nelse\n  pre = self[0..(pos - 1)]\n  mid = search.to_s\n  post = self[(pos + search_size)..-1]\nend\n{pre, mid, post}\n"}},{"html_id":"partition(search:Regex):Tuple(String,String,String)-instance-method","name":"partition","doc":"Searches separator or pattern (`Regex`) in the string, and returns\na `Tuple` with the part before it, the match, and the part after it.\nIf it is not found, returns str followed by two empty strings.\n\n```\n\"hello\".partition(\"l\") # => {\"he\", \"l\", \"lo\"}\n\"hello\".partition(\"x\") # => {\"hello\", \"\", \"\"}\n```","summary":"<p>Searches separator or pattern (<code><a href=\"Regex.html\">Regex</a></code>) in the string, and returns a <code><a href=\"Tuple.html\">Tuple</a></code> with the part before it, the match, and the part after it.</p>","abstract":false,"args":[{"name":"search","external_name":"search","restriction":"Regex"}],"args_string":"(search : Regex) : Tuple(String, String, String)","args_html":"(search : <a href=\"Regex.html\">Regex</a>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"String.html\">String</a>, <a href=\"String.html\">String</a>, <a href=\"String.html\">String</a>)","location":{"filename":"src/string.cr","line_number":3290,"url":null},"def":{"name":"partition","args":[{"name":"search","external_name":"search","restriction":"Regex"}],"return_type":"Tuple(String, String, String)","visibility":"Public","body":"pre = mid = post = \"\"\ncase m = self.match(search)\nwhen .nil?\n  pre = self\nelse\n  pre = m.pre_match\n  mid = m[0]\n  post = m.post_match\nend\n{pre, mid, post}\n"}},{"html_id":"presence:self?-instance-method","name":"presence","doc":"Returns `self` unless `#blank?` is `true` in which case it returns `nil`.\n\n```\n\"a\".presence         # => \"a\"\n\"\".presence          # => nil\n\"   \".presence       # => nil\n\"    a    \".presence # => \"    a    \"\nnil.presence         # => nil\n\nconfig = {\"empty\" => \"\"}\nconfig[\"empty\"]?.presence || \"default\"   # => \"default\"\nconfig[\"missing\"]?.presence || \"default\" # => \"default\"\n```\n\nSee also: `Nil#presence`.","summary":"<p>Returns <code>self</code> unless <code><a href=\"String.html#blank%3F%3ABool-instance-method\">#blank?</a></code> is <code>true</code> in which case it returns <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":2847,"url":null},"def":{"name":"presence","return_type":"self | ::Nil","visibility":"Public","body":"if !blank?\n  self\nend"}},{"html_id":"pretty_print(pp:PrettyPrint):Nil-instance-method","name":"pretty_print","doc":"Pretty prints `self` into the given printer.","summary":"<p>Pretty prints <code>self</code> into the given printer.</p>","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":"PrettyPrint"}],"args_string":"(pp : PrettyPrint) : Nil","args_html":"(pp : <a href=\"PrettyPrint.html\">PrettyPrint</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":4542,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":"PrettyPrint"}],"return_type":"Nil","visibility":"Public","body":"printed_bytesize = 0\npp.group do\n  split('\\n') do |part|\n    printed_bytesize = printed_bytesize + part.bytesize\n    if printed_bytesize != bytesize\n      printed_bytesize = printed_bytesize + 1\n      pp.text('\"')\n      pp.text(part.inspect_unquoted)\n      pp.text(\"\\\\n\\\"\")\n      if printed_bytesize == bytesize\n        break\n      end\n      pp.text(\" +\")\n      pp.breakable\n    else\n      pp.text(part.inspect)\n    end\n  end\nend\n"}},{"html_id":"rchop(suffix:Char|String):String-instance-method","name":"rchop","doc":"Returns a new `String` with *suffix* removed from the end of the string.\n\n```\n\"string\".rchop('g')   # => \"strin\"\n\"string\".rchop('x')   # => \"string\"\n\"string\".rchop(\"ing\") # => \"str\"\n\"string\".rchop(\"inx\") # => \"string\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with <em>suffix</em> removed from the end of the string.</p>","abstract":false,"args":[{"name":"suffix","external_name":"suffix","restriction":"Char | String"}],"args_string":"(suffix : Char | String) : String","args_html":"(suffix : <a href=\"Char.html\">Char</a> | <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1579,"url":null},"def":{"name":"rchop","args":[{"name":"suffix","external_name":"suffix","restriction":"Char | String"}],"return_type":"String","visibility":"Public","body":"(rchop?(suffix)) || self"}},{"html_id":"rchop:String-instance-method","name":"rchop","doc":"Returns a new `String` with the last character removed.\nApplying rchop to an empty string returns an empty string.\n\n```\n\"string\\r\\n\".rchop # => \"string\\r\"\n\"string\\n\\r\".rchop # => \"string\\n\"\n\"string\\n\".rchop   # => \"string\"\n\"string\".rchop     # => \"strin\"\n\"x\".rchop.rchop    # => \"\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with the last character removed.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":1567,"url":null},"def":{"name":"rchop","return_type":"String","visibility":"Public","body":"rchop? || \"\""}},{"html_id":"rchop?(suffix:Char|String):String?-instance-method","name":"rchop?","doc":"Returns a new `String` with *suffix* removed from the end of the string if possible, else returns `nil`.\n\n```\n\"string\".rchop?('g')   # => \"strin\"\n\"string\".rchop?('x')   # => nil\n\"string\".rchop?(\"ing\") # => \"str\"\n\"string\".rchop?(\"inx\") # => nil\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with <em>suffix</em> removed from the end of the string if possible, else returns <code>nil</code>.</p>","abstract":false,"args":[{"name":"suffix","external_name":"suffix","restriction":"Char | String"}],"args_string":"(suffix : Char | String) : String?","args_html":"(suffix : <a href=\"Char.html\">Char</a> | <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>?","location":{"filename":"src/string.cr","line_number":1610,"url":null},"def":{"name":"rchop?","args":[{"name":"suffix","external_name":"suffix","restriction":"Char | String"}],"return_type":"String | ::Nil","visibility":"Public","body":"if ends_with?(suffix)\n  unsafe_byte_slice_string(0, bytesize - suffix.bytesize)\nend"}},{"html_id":"rchop?:String?-instance-method","name":"rchop?","doc":"Returns a new `String` with the last character removed if possible, else returns `nil`.\n\n```\n\"string\\r\\n\".rchop? # => \"string\\r\"\n\"string\\n\\r\".rchop? # => \"string\\n\"\n\"string\\n\".rchop?   # => \"string\"\n\"string\".rchop?     # => \"strin\"\n\"\".rchop?           # => nil\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with the last character removed if possible, else returns <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":1592,"url":null},"def":{"name":"rchop?","return_type":"String | ::Nil","visibility":"Public","body":"if empty?\n  return\nend\nif to_unsafe[bytesize - 1] < 128 || single_byte_optimizable?\n  return unsafe_byte_slice_string(0, bytesize - 1)\nend\nself[0, size - 1]\n"}},{"html_id":"reverse:String-instance-method","name":"reverse","doc":"Reverses the order of characters in the string.\n\n```\n\"Argentina\".reverse # => \"anitnegrA\"\n\"racecar\".reverse   # => \"racecar\"\n```","summary":"<p>Reverses the order of characters in the string.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4094,"url":null},"def":{"name":"reverse","return_type":"String","visibility":"Public","body":"if bytesize <= 1\n  return self\nend\nif single_byte_optimizable?\n  String.new(bytesize) do |buffer|\n    bytesize.times do |i|\n      buffer[i] = self.to_unsafe[(bytesize - i) - 1]\n    end\n    {@bytesize, @length}\n  end\nelse\n  String.new(bytesize) do |buffer|\n    buffer = buffer + bytesize\n    each_grapheme_boundary do |range|\n      buffer = buffer - range.size\n      buffer.copy_from(to_unsafe + range.begin, range.size)\n    end\n    {@bytesize, @length}\n  end\nend\n"}},{"html_id":"rindex(search:Char,offset=size-1)-instance-method","name":"rindex","doc":"Returns the index of the _last_ appearance of *search* in the string,\nIf *offset* is present, it defines the position to _end_ the search\n(characters beyond this point are ignored).\n\n```\n\"Hello, World\".rindex('o')    # => 8\n\"Hello, World\".rindex('Z')    # => nil\n\"Hello, World\".rindex(\"o\", 5) # => 4\n\"Hello, World\".rindex(\"W\", 2) # => nil\n```","summary":"<p>Returns the index of the <em>last</em> appearance of <em>search</em> in the string, If <em>offset</em> is present, it defines the position to <em>end</em> the search (characters beyond this point are ignored).</p>","abstract":false,"args":[{"name":"search","external_name":"search","restriction":"Char"},{"name":"offset","default_value":"size - 1","external_name":"offset","restriction":""}],"args_string":"(search : Char, offset = size - 1)","args_html":"(search : <a href=\"Char.html\">Char</a>, offset = size <span class=\"o\">-</span> <span class=\"n\">1</span>)","location":{"filename":"src/string.cr","line_number":3168,"url":null},"def":{"name":"rindex","args":[{"name":"search","external_name":"search","restriction":"Char"},{"name":"offset","default_value":"size - 1","external_name":"offset","restriction":""}],"visibility":"Public","body":"if search.ascii? && single_byte_optimizable?\n  return to_slice.rindex(search.ord.to_u8, offset)\nend\nif offset < 0\n  offset = offset + size\nend\nif offset < 0\n  return nil\nend\nif offset == (size - 1)\n  reader = Char::Reader.new(at_end: self)\nelse\n  byte_index = char_index_to_byte_index(offset)\n  if byte_index\n  else\n    raise(IndexError.new)\n  end\n  reader = Char::Reader.new(self, pos: byte_index)\nend\nwhile true\n  if reader.current_char == search\n    return offset\n  else\n    if reader.has_previous?\n      reader.previous_char\n      offset = offset - 1\n    else\n      return nil\n    end\n  end\nend\n"}},{"html_id":"rindex(search:String,offset=size-search.size):Int32?-instance-method","name":"rindex","doc":"Returns the index of the _last_ appearance of *search* in the string,\nIf *offset* is present, it defines the position to _end_ the search\n(characters beyond this point are ignored).\n\n```\n\"Hello, World\".rindex('o')    # => 8\n\"Hello, World\".rindex('Z')    # => nil\n\"Hello, World\".rindex(\"o\", 5) # => 4\n\"Hello, World\".rindex(\"W\", 2) # => nil\n```","summary":"<p>Returns the index of the <em>last</em> appearance of <em>search</em> in the string, If <em>offset</em> is present, it defines the position to <em>end</em> the search (characters beyond this point are ignored).</p>","abstract":false,"args":[{"name":"search","external_name":"search","restriction":"String"},{"name":"offset","default_value":"size - search.size","external_name":"offset","restriction":""}],"args_string":"(search : String, offset = size - search.size) : Int32?","args_html":"(search : <a href=\"String.html\">String</a>, offset = size <span class=\"o\">-</span> search.size) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/string.cr","line_number":3198,"url":null},"def":{"name":"rindex","args":[{"name":"search","external_name":"search","restriction":"String"},{"name":"offset","default_value":"size - search.size","external_name":"offset","restriction":""}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"if offset < 0\n  offset = offset + size\nend\nif offset < 0\n  return\nend\nsearch_hash = 0_u32\nsearch.to_slice.reverse_each do |b|\n  search_hash = (search_hash &* PRIME_RK) &+ b\nend\npow = PRIME_RK &** search.bytesize\nhash = 0_u32\nchar_index = size\nbegin_pointer = to_unsafe\npointer = begin_pointer + bytesize\ntail_pointer = pointer\nhash_begin_pointer = pointer - search.bytesize\nif hash_begin_pointer < begin_pointer\n  return\nend\nwhile hash_begin_pointer < pointer\n  pointer = pointer - 1\n  byte = pointer.value\n  if (byte & 192) != 128\n    char_index = char_index - 1\n  end\n  hash = (hash &* PRIME_RK) &+ byte\nend\nwhile true\n  if ((hash == search_hash) && char_index <= offset) && ((pointer.memcmp(search.to_unsafe, search.bytesize)) == 0)\n    return char_index\n  end\n  if begin_pointer == pointer\n    return\n  end\n  pointer = pointer - 1\n  tail_pointer = tail_pointer - 1\n  byte = pointer.value\n  if (byte & 192) != 128\n    char_index = char_index - 1\n  end\n  hash = ((hash &* PRIME_RK) &+ byte) &- (pow &* tail_pointer.value)\nend\n"}},{"html_id":"rindex(search:Regex,offset=size):Int32?-instance-method","name":"rindex","doc":"Returns the index of the _last_ appearance of *search* in the string,\nIf *offset* is present, it defines the position to _end_ the search\n(characters beyond this point are ignored).\n\n```\n\"Hello, World\".rindex('o')    # => 8\n\"Hello, World\".rindex('Z')    # => nil\n\"Hello, World\".rindex(\"o\", 5) # => 4\n\"Hello, World\".rindex(\"W\", 2) # => nil\n```","summary":"<p>Returns the index of the <em>last</em> appearance of <em>search</em> in the string, If <em>offset</em> is present, it defines the position to <em>end</em> the search (characters beyond this point are ignored).</p>","abstract":false,"args":[{"name":"search","external_name":"search","restriction":"Regex"},{"name":"offset","default_value":"size","external_name":"offset","restriction":""}],"args_string":"(search : Regex, offset = size) : Int32?","args_html":"(search : <a href=\"Regex.html\">Regex</a>, offset = size) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/string.cr","line_number":3251,"url":null},"def":{"name":"rindex","args":[{"name":"search","external_name":"search","restriction":"Regex"},{"name":"offset","default_value":"size","external_name":"offset","restriction":""}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"if offset < 0\n  offset = offset + size\nend\nif 0 <= offset && offset <= size\nelse\n  return nil\nend\nmatch_result = nil\nscan(search) do |match_data|\n  if (index = match_data.begin) && index > offset\n    break\n  end\n  match_result = match_data\nend\nmatch_result.try(&.begin)\n"}},{"html_id":"rjust(len:Int,char:Char=''):String-instance-method","name":"rjust","doc":"Adds instances of *char* to left of the string until it is at least size of *len*.\n\n```\n\"Purple\".rjust(8)      # => \"  Purple\"\n\"Purple\".rjust(8, '-') # => \"--Purple\"\n\"Aubergine\".rjust(8)   # => \"Aubergine\"\n```","summary":"<p>Adds instances of <em>char</em> to left of the string until it is at least size of <em>len</em>.</p>","abstract":false,"args":[{"name":"len","external_name":"len","restriction":"Int"},{"name":"char","default_value":"' '","external_name":"char","restriction":"Char"}],"args_string":"(len : Int, char : Char = ' ') : String","args_html":"(len : <a href=\"Int.html\">Int</a>, char : <a href=\"Char.html\">Char</a> = <span class=\"s\">&#39; &#39;</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":4149,"url":null},"def":{"name":"rjust","args":[{"name":"len","external_name":"len","restriction":"Int"},{"name":"char","default_value":"' '","external_name":"char","restriction":"Char"}],"return_type":"String","visibility":"Public","body":"just(len, char, 1)"}},{"html_id":"rjust(io:IO,len:Int,char:Char=''):Nil-instance-method","name":"rjust","doc":"Adds instances of *char* to left of the string until it is at least size of *len*,\nand then appends the result to the given IO.\n\n```\nio = IO::Memory.new\n\"Purple\".rjust(io, 8, '-')\nio.to_s # => \"--Purple\"\n```","summary":"<p>Adds instances of <em>char</em> to left of the string until it is at least size of <em>len</em>, and then appends the result to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"len","external_name":"len","restriction":"Int"},{"name":"char","default_value":"' '","external_name":"char","restriction":"Char"}],"args_string":"(io : IO, len : Int, char : Char = ' ') : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, len : <a href=\"Int.html\">Int</a>, char : <a href=\"Char.html\">Char</a> = <span class=\"s\">&#39; &#39;</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":4161,"url":null},"def":{"name":"rjust","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"len","external_name":"len","restriction":"Int"},{"name":"char","default_value":"' '","external_name":"char","restriction":"Char"}],"return_type":"Nil","visibility":"Public","body":"(len - size).times do\n  io << char\nend\nio << self\n"}},{"html_id":"rpartition(search:Char|String):Tuple(String,String,String)-instance-method","name":"rpartition","doc":"Searches separator or pattern (`Regex`) in the string from the end of the string,\nand returns a `Tuple` with the part before it, the match, and the part after it.\nIf it is not found, returns two empty strings and str.\n\n```\n\"hello\".rpartition(\"l\")  # => {\"hel\", \"l\", \"o\"}\n\"hello\".rpartition(\"x\")  # => {\"\", \"\", \"hello\"}\n\"hello\".rpartition(/.l/) # => {\"he\", \"ll\", \"o\"}\n```","summary":"<p>Searches separator or pattern (<code><a href=\"Regex.html\">Regex</a></code>) in the string from the end of the string, and returns a <code><a href=\"Tuple.html\">Tuple</a></code> with the part before it, the match, and the part after it.</p>","abstract":false,"args":[{"name":"search","external_name":"search","restriction":"Char | String"}],"args_string":"(search : Char | String) : Tuple(String, String, String)","args_html":"(search : <a href=\"Char.html\">Char</a> | <a href=\"String.html\">String</a>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"String.html\">String</a>, <a href=\"String.html\">String</a>, <a href=\"String.html\">String</a>)","location":{"filename":"src/string.cr","line_number":3312,"url":null},"def":{"name":"rpartition","args":[{"name":"search","external_name":"search","restriction":"Char | String"}],"return_type":"Tuple(String, String, String)","visibility":"Public","body":"pos = self.rindex(search)\nsearch_size = search.is_a?(Char) ? 1 : search.size\npre = mid = post = \"\"\ncase pos\nwhen .nil?\n  post = self\nwhen 0\n  mid = search.to_s\n  post = self[(pos + search_size)..-1]\nelse\n  pre = self[0..(pos - 1)]\n  mid = search.to_s\n  post = self[(pos + search_size)..-1]\nend\n{pre, mid, post}\n"}},{"html_id":"rpartition(search:Regex):Tuple(String,String,String)-instance-method","name":"rpartition","doc":"Searches separator or pattern (`Regex`) in the string from the end of the string,\nand returns a `Tuple` with the part before it, the match, and the part after it.\nIf it is not found, returns two empty strings and str.\n\n```\n\"hello\".rpartition(\"l\")  # => {\"hel\", \"l\", \"o\"}\n\"hello\".rpartition(\"x\")  # => {\"\", \"\", \"hello\"}\n\"hello\".rpartition(/.l/) # => {\"he\", \"ll\", \"o\"}\n```","summary":"<p>Searches separator or pattern (<code><a href=\"Regex.html\">Regex</a></code>) in the string from the end of the string, and returns a <code><a href=\"Tuple.html\">Tuple</a></code> with the part before it, the match, and the part after it.</p>","abstract":false,"args":[{"name":"search","external_name":"search","restriction":"Regex"}],"args_string":"(search : Regex) : Tuple(String, String, String)","args_html":"(search : <a href=\"Regex.html\">Regex</a>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"String.html\">String</a>, <a href=\"String.html\">String</a>, <a href=\"String.html\">String</a>)","location":{"filename":"src/string.cr","line_number":3333,"url":null},"def":{"name":"rpartition","args":[{"name":"search","external_name":"search","restriction":"Regex"}],"return_type":"Tuple(String, String, String)","visibility":"Public","body":"match_result = nil\npos = self.size - 1\nwhile pos >= 0\n  self[pos..-1].scan(search) do |m|\n    match_result = m\n  end\n  if match_result.nil?\n  else\n    break\n  end\n  pos = pos - 1\nend\npre = mid = post = \"\"\ncase\nwhen match_result.nil?\n  post = self\nwhen pos == 0\n  mid = match_result[0]\n  post = self[match_result[0].size..-1]\nelse\n  pre = self[0..(pos - 1)]\n  mid = match_result.not_nil![0]\n  post = self[(pos + match_result.not_nil![0].size)..-1]\nend\n{pre, mid, post}\n"}},{"html_id":"rstrip(char:Char):String-instance-method","name":"rstrip","doc":"Returns a new string with trailing occurrences of *char* removed.\n\n```\n\"aaabcdaaa\".rstrip('a') # => \"aaabcd\"\n```","summary":"<p>Returns a new string with trailing occurrences of <em>char</em> removed.</p>","abstract":false,"args":[{"name":"char","external_name":"char","restriction":"Char"}],"args_string":"(char : Char) : String","args_html":"(char : <a href=\"Char.html\">Char</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1860,"url":null},"def":{"name":"rstrip","args":[{"name":"char","external_name":"char","restriction":"Char"}],"return_type":"String","visibility":"Public","body":"if empty?\n  return self\nend\nremove_excess_right(calc_excess_right(char))\n"}},{"html_id":"rstrip(chars:String):String-instance-method","name":"rstrip","doc":"Returns a new string where trailing occurrences of any char\nin *chars* are removed. The *chars* argument is not a suffix;\nrather; all combinations of its values are stripped.\n\n```\n\"abcdefcba\".rstrip(\"abc\") # => \"abcdef\"\n```","summary":"<p>Returns a new string where trailing occurrences of any char in <em>chars</em> are removed.</p>","abstract":false,"args":[{"name":"chars","external_name":"chars","restriction":"String"}],"args_string":"(chars : String) : String","args_html":"(chars : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1873,"url":null},"def":{"name":"rstrip","args":[{"name":"chars","external_name":"chars","restriction":"String"}],"return_type":"String","visibility":"Public","body":"if empty?\n  return self\nend\ncase chars.size\nwhen 0\n  self\nwhen 1\n  rstrip(chars[0])\nelse\n  remove_excess_right(calc_excess_right(chars))\nend\n"}},{"html_id":"rstrip:String-instance-method","name":"rstrip","doc":"Returns a new `String` with trailing whitespace removed.\n\n```\n\"    hello    \".rstrip # => \"    hello\"\n\"\\tgoodbye\\r\\n\".rstrip # => \"\\tgoodbye\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with trailing whitespace removed.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":1851,"url":null},"def":{"name":"rstrip","return_type":"String","visibility":"Public","body":"remove_excess_right(calc_excess_right)"}},{"html_id":"rstrip(&block:Char->_)-instance-method","name":"rstrip","doc":"Returns a new string where trailing characters for which\nthe block returns a *truthy* value are removed.\n\n```\n\"bcadefcba\".rstrip { |c| 'a' <= c <= 'c' } # => \"bcadef\"\n```","summary":"<p>Returns a new string where trailing characters for which the block returns a <em>truthy</em> value are removed.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":1892,"url":null},"def":{"name":"rstrip","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(Char -> _)"},"visibility":"Public","body":"if empty?\n  return self\nend\nexcess_right = calc_excess_right do |c|\n  yield c\nend\nremove_excess_right(excess_right)\n"}},{"html_id":"scan(pattern:Regex,&)-instance-method","name":"scan","doc":"Searches the string for instances of *pattern*,\nyielding a `Regex::MatchData` for each match.","summary":"<p>Searches the string for instances of <em>pattern</em>, yielding a <code><a href=\"Regex/MatchData.html\">Regex::MatchData</a></code> for each match.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"}],"args_string":"(pattern : Regex, &)","args_html":"(pattern : <a href=\"Regex.html\">Regex</a>, &)","location":{"filename":"src/string.cr","line_number":4343,"url":null},"def":{"name":"scan","args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"}],"yields":1,"visibility":"Public","body":"byte_offset = 0\nwhile match = pattern.match_at_byte_index(self, byte_offset)\n  index = match.byte_begin(0)\n  $~ = match\n  yield match\n  match_bytesize = (match.byte_end(0)) - index\n  if match_bytesize == 0\n    match_bytesize = match_bytesize + 1\n  end\n  byte_offset = index + match_bytesize\nend\nself\n"}},{"html_id":"scan(pattern:Regex):Array(Regex::MatchData)-instance-method","name":"scan","doc":"Searches the string for instances of *pattern*,\nreturning an `Array` of `Regex::MatchData` for each match.","summary":"<p>Searches the string for instances of <em>pattern</em>, returning an <code><a href=\"Array.html\">Array</a></code> of <code><a href=\"Regex/MatchData.html\">Regex::MatchData</a></code> for each match.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"}],"args_string":"(pattern : Regex) : Array(Regex::MatchData)","args_html":"(pattern : <a href=\"Regex.html\">Regex</a>) : <a href=\"Array.html\">Array</a>(<a href=\"Regex/MatchData.html\">Regex::MatchData</a>)","location":{"filename":"src/string.cr","line_number":4360,"url":null},"def":{"name":"scan","args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"}],"return_type":"Array(Regex::MatchData)","visibility":"Public","body":"matches = [] of Regex::MatchData\nscan(pattern) do |match|\n  matches << match\nend\nmatches\n"}},{"html_id":"scan(pattern:String,&)-instance-method","name":"scan","doc":"Searches the string for instances of *pattern*,\nyielding the matched string for each match.","summary":"<p>Searches the string for instances of <em>pattern</em>, yielding the matched string for each match.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":"String"}],"args_string":"(pattern : String, &)","args_html":"(pattern : <a href=\"String.html\">String</a>, &)","location":{"filename":"src/string.cr","line_number":4370,"url":null},"def":{"name":"scan","args":[{"name":"pattern","external_name":"pattern","restriction":"String"}],"yields":1,"visibility":"Public","body":"if pattern.empty?\n  return self\nend\nindex = 0\nwhile index = byte_index(pattern, index)\n  yield pattern\n  index = index + pattern.bytesize\nend\nself\n"}},{"html_id":"scan(pattern:String):Array(String)-instance-method","name":"scan","doc":"Searches the string for instances of *pattern*,\nreturning an array of the matched string for each match.","summary":"<p>Searches the string for instances of <em>pattern</em>, returning an array of the matched string for each match.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":"String"}],"args_string":"(pattern : String) : Array(String)","args_html":"(pattern : <a href=\"String.html\">String</a>) : <a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)","location":{"filename":"src/string.cr","line_number":4382,"url":null},"def":{"name":"scan","args":[{"name":"pattern","external_name":"pattern","restriction":"String"}],"return_type":"Array(String)","visibility":"Public","body":"matches = [] of String\nscan(pattern) do |match|\n  matches << match\nend\nmatches\n"}},{"html_id":"scrub(replacement=Char::REPLACEMENT):String-instance-method","name":"scrub","doc":"Returns a String where bytes that are invalid in the\nUTF-8 encoding are replaced with *replacement*.","summary":"<p>Returns a String where bytes that are invalid in the UTF-8 encoding are replaced with <em>replacement</em>.</p>","abstract":false,"args":[{"name":"replacement","default_value":"Char::REPLACEMENT","external_name":"replacement","restriction":""}],"args_string":"(replacement = Char::REPLACEMENT) : String","args_html":"(replacement = <span class=\"t\">Char</span><span class=\"t\">::</span><span class=\"t\">REPLACEMENT</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":4902,"url":null},"def":{"name":"scrub","args":[{"name":"replacement","default_value":"Char::REPLACEMENT","external_name":"replacement","restriction":""}],"return_type":"String","visibility":"Public","body":"result = nil\nreader = Char::Reader.new(self)\nwhile reader.has_next?\n  if reader.error\n    if result\n    else\n      result = String::Builder.new(bytesize)\n      result.write(to_slice[0, reader.pos])\n    end\n    result << replacement\n  else\n    if result\n      result << reader.current_char\n    end\n  end\n  reader.next_char\nend\nresult ? result.to_s : self\n"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Returns the number of unicode codepoints in this string.\n\n```\n\"hello\".size # => 5\n\"你好\".size    # => 2\n```","summary":"<p>Returns the number of unicode codepoints in this string.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4858,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"if @length > 0 || (@bytesize == 0)\n  return @length\nend\n@length = each_byte_index_and_char_index do\nend\n"}},{"html_id":"split(limit:Int32?=nil):Array(String)-instance-method","name":"split","doc":"Makes an array by splitting the string on any amount of ASCII whitespace\ncharacters (and removing that whitespace).\n\nIf *limit* is present, up to *limit* new strings will be created, with the\nentire remainder added to the last string.\n\n```\nold_pond = \"\n  Old pond\n  a frog leaps in\n  water's sound\n\"\nold_pond.split    # => [\"Old\", \"pond\", \"a\", \"frog\", \"leaps\", \"in\", \"water's\", \"sound\"]\nold_pond.split(3) # => [\"Old\", \"pond\", \"a frog leaps in\\n  water's sound\\n\"]\n```","summary":"<p>Makes an array by splitting the string on any amount of ASCII whitespace characters (and removing that whitespace).</p>","abstract":false,"args":[{"name":"limit","default_value":"nil","external_name":"limit","restriction":"Int32 | ::Nil"}],"args_string":"(limit : Int32? = nil) : Array(String)","args_html":"(limit : <a href=\"Int32.html\">Int32</a>? = <span class=\"n\">nil</span>) : <a href=\"Array.html\">Array</a>(<a href=\"String.html\">String</a>)","location":{"filename":"src/string.cr","line_number":3510,"url":null},"def":{"name":"split","args":[{"name":"limit","default_value":"nil","external_name":"limit","restriction":"Int32 | ::Nil"}],"return_type":"Array(String)","visibility":"Public","body":"ary = Array(String).new\nsplit(limit) do |string|\n  ary << string\nend\nary\n"}},{"html_id":"split(limit:Int32?=nil,&block:String->_)-instance-method","name":"split","doc":"Splits the string after any amount of ASCII whitespace characters and yields\neach non-whitespace part to a block.\n\nIf *limit* is present, up to *limit* new strings will be created, with the\nentire remainder added to the last string.\n\n```\nary = [] of String\nold_pond = \"\n  Old pond\n  a frog leaps in\n  water's sound\n\"\n\nold_pond.split { |s| ary << s }\nary # => [\"Old\", \"pond\", \"a\", \"frog\", \"leaps\", \"in\", \"water's\", \"sound\"]\nary.clear\n\nold_pond.split(3) { |s| ary << s }\nary # => [\"Old\", \"pond\", \"a frog leaps in\\n  water's sound\\n\"]\n```","summary":"<p>Splits the string after any amount of ASCII whitespace characters and yields each non-whitespace part to a block.</p>","abstract":false,"args":[{"name":"limit","default_value":"nil","external_name":"limit","restriction":"Int32 | ::Nil"}],"args_string":"(limit : Int32? = nil, &block : String -> _)","args_html":"(limit : <a href=\"Int32.html\">Int32</a>? = <span class=\"n\">nil</span>, &block : <a href=\"String.html\">String</a> -> _)","location":{"filename":"src/string.cr","line_number":3539,"url":null},"def":{"name":"split","args":[{"name":"limit","default_value":"nil","external_name":"limit","restriction":"Int32 | ::Nil"}],"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(String -> _)"},"visibility":"Public","body":"if limit && limit <= 1\n  yield self\n  return\nend\nif single_byte_optimizable?\n  split_single_byte(limit) do |piece|\n    yield piece\n  end\n  return\nend\nyielded = 0\nstart_pos = 0\npiece_size = 0\nlooking_for_space = false\nreader = Char::Reader.new(self)\nreader.each do |char|\n  if char.whitespace?\n    if looking_for_space\n      piece_bytesize = reader.pos - start_pos\n      yield String.new(to_unsafe + start_pos, piece_bytesize, piece_size)\n      yielded = yielded + 1\n      looking_for_space = false\n    end\n  else\n    if looking_for_space\n      piece_size = piece_size + 1\n    else\n      start_pos = reader.pos\n      piece_size = 1\n      looking_for_space = true\n      if limit && ((yielded + 1) == limit)\n        break\n      end\n    end\n  end\nend\nif looking_for_space\n  piece_bytesize = bytesize - start_pos\n  yield String.new(to_unsafe + start_pos, piece_bytesize, piece_size)\nend\n"}},{"html_id":"split(separator:Char,limit=nil,*,remove_empty=false)-instance-method","name":"split","doc":"Makes an `Array` by splitting the string on the given character *separator*\n(and removing that character).\n\nIf *limit* is present, up to *limit* new strings will be created,\nwith the entire remainder added to the last string.\n\nIf *remove_empty* is `true`, any empty strings are removed from the result.\n\n```\n\"foo,,bar,baz\".split(',')                     # => [\"foo\", \"\", \"bar\", \"baz\"]\n\"foo,,bar,baz\".split(',', remove_empty: true) # => [\"foo\", \"bar\", \"baz\"]\n\"foo,bar,baz\".split(',', 2)                   # => [\"foo\", \"bar,baz\"]\n```","summary":"<p>Makes an <code><a href=\"Array.html\">Array</a></code> by splitting the string on the given character <em>separator</em> (and removing that character).</p>","abstract":false,"args":[{"name":"separator","external_name":"separator","restriction":"Char"},{"name":"limit","default_value":"nil","external_name":"limit","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"remove_empty","default_value":"false","external_name":"remove_empty","restriction":""}],"args_string":"(separator : Char, limit = nil, *, remove_empty = false)","args_html":"(separator : <a href=\"Char.html\">Char</a>, limit = <span class=\"n\">nil</span>, *, remove_empty = <span class=\"n\">false</span>)","location":{"filename":"src/string.cr","line_number":3642,"url":null},"def":{"name":"split","args":[{"name":"separator","external_name":"separator","restriction":"Char"},{"name":"limit","default_value":"nil","external_name":"limit","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"remove_empty","default_value":"false","external_name":"remove_empty","restriction":""}],"splat_index":2,"visibility":"Public","body":"ary = Array(String).new\nsplit(separator, limit, remove_empty: remove_empty) do |string|\n  ary << string\nend\nary\n"}},{"html_id":"split(separator:Char,limit=nil,*,remove_empty=false,&block:String->_)-instance-method","name":"split","doc":"Splits the string after each character *separator* and yields each part to a block.\n\nIf *limit* is present, up to *limit* new strings will be created,\nwith the entire remainder added to the last string.\n\nIf *remove_empty* is `true`, any empty strings are not yielded.\n\n```\nary = [] of String\n\n\"foo,,bar,baz\".split(',') { |string| ary << string }\nary # => [\"foo\", \"\", \"bar\", \"baz\"]\nary.clear\n\n\"foo,,bar,baz\".split(',', remove_empty: true) { |string| ary << string }\nary # => [\"foo\", \"bar\", \"baz\"]\nary.clear\n\n\"foo,bar,baz\".split(',', 2) { |string| ary << string }\nary # => [\"foo\", \"bar,baz\"]\n```","summary":"<p>Splits the string after each character <em>separator</em> and yields each part to a block.</p>","abstract":false,"args":[{"name":"separator","external_name":"separator","restriction":"Char"},{"name":"limit","default_value":"nil","external_name":"limit","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"remove_empty","default_value":"false","external_name":"remove_empty","restriction":""}],"args_string":"(separator : Char, limit = nil, *, remove_empty = false, &block : String -> _)","args_html":"(separator : <a href=\"Char.html\">Char</a>, limit = <span class=\"n\">nil</span>, *, remove_empty = <span class=\"n\">false</span>, &block : <a href=\"String.html\">String</a> -> _)","location":{"filename":"src/string.cr","line_number":3671,"url":null},"def":{"name":"split","args":[{"name":"separator","external_name":"separator","restriction":"Char"},{"name":"limit","default_value":"nil","external_name":"limit","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"remove_empty","default_value":"false","external_name":"remove_empty","restriction":""}],"splat_index":2,"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(String -> _)"},"visibility":"Public","body":"if empty?\n  if remove_empty\n  else\n    yield \"\"\n  end\n  return\nend\nif limit && limit <= 1\n  yield self\n  return\nend\nyielded = 0\nbyte_offset = 0\nreader = Char::Reader.new(self)\nreader.each do |char|\n  if char == separator\n    piece_bytesize = reader.pos - byte_offset\n    if remove_empty && (piece_bytesize == 0)\n    else\n      yield String.new(to_unsafe + byte_offset, piece_bytesize)\n    end\n    yielded = yielded + 1\n    byte_offset = reader.pos + reader.current_char_width\n    if limit && ((yielded + 1) == limit)\n      break\n    end\n  end\nend\npiece_bytesize = bytesize - byte_offset\nif remove_empty && (piece_bytesize == 0)\n  return\nend\nyield String.new(to_unsafe + byte_offset, piece_bytesize)\n"}},{"html_id":"split(separator:String,limit=nil,*,remove_empty=false)-instance-method","name":"split","doc":"Makes an `Array` by splitting the string on *separator* (and removing instances of *separator*).\n\nIf *limit* is present, the array will be limited to *limit* items and\nthe final item will contain the remainder of the string.\n\nIf *separator* is an empty string (`\"\"`), the string will be separated into one-character strings.\n\nIf *remove_empty* is `true`, any empty strings are removed from the result.\n\n```\nlong_river_name = \"Mississippi\"\nlong_river_name.split(\"ss\")                    # => [\"Mi\", \"i\", \"ippi\"]\nlong_river_name.split(\"i\")                     # => [\"M\", \"ss\", \"ss\", \"pp\", \"\"]\nlong_river_name.split(\"i\", remove_empty: true) # => [\"M\", \"ss\", \"ss\", \"pp\"]\nlong_river_name.split(\"\")                      # => [\"M\", \"i\", \"s\", \"s\", \"i\", \"s\", \"s\", \"i\", \"p\", \"p\", \"i\"]\n```","summary":"<p>Makes an <code><a href=\"Array.html\">Array</a></code> by splitting the string on <em>separator</em> (and removing instances of <em>separator</em>).</p>","abstract":false,"args":[{"name":"separator","external_name":"separator","restriction":"String"},{"name":"limit","default_value":"nil","external_name":"limit","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"remove_empty","default_value":"false","external_name":"remove_empty","restriction":""}],"args_string":"(separator : String, limit = nil, *, remove_empty = false)","args_html":"(separator : <a href=\"String.html\">String</a>, limit = <span class=\"n\">nil</span>, *, remove_empty = <span class=\"n\">false</span>)","location":{"filename":"src/string.cr","line_number":3717,"url":null},"def":{"name":"split","args":[{"name":"separator","external_name":"separator","restriction":"String"},{"name":"limit","default_value":"nil","external_name":"limit","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"remove_empty","default_value":"false","external_name":"remove_empty","restriction":""}],"splat_index":2,"visibility":"Public","body":"ary = Array(String).new\nsplit(separator, limit, remove_empty: remove_empty) do |string|\n  ary << string\nend\nary\n"}},{"html_id":"split(separator:String,limit=nil,*,remove_empty=false,&block:String->_)-instance-method","name":"split","doc":"Splits the string after each string *separator* and yields each part to a block.\n\nIf *limit* is present, the array will be limited to *limit* items and\nthe final item will contain the remainder of the string.\n\nIf *separator* is an empty string (`\"\"`), the string will be separated into one-character strings.\n\nIf *remove_empty* is `true`, any empty strings are removed from the result.\n\n```\nary = [] of String\nlong_river_name = \"Mississippi\"\n\nlong_river_name.split(\"ss\") { |s| ary << s }\nary # => [\"Mi\", \"i\", \"ippi\"]\nary.clear\n\nlong_river_name.split(\"i\") { |s| ary << s }\nary # => [\"M\", \"ss\", \"ss\", \"pp\", \"\"]\nary.clear\n\nlong_river_name.split(\"i\", remove_empty: true) { |s| ary << s }\nary # => [\"M\", \"ss\", \"ss\", \"pp\"]\nary.clear\n\nlong_river_name.split(\"\") { |s| ary << s }\nary # => [\"M\", \"i\", \"s\", \"s\", \"i\", \"s\", \"s\", \"i\", \"p\", \"p\", \"i\"]\n```","summary":"<p>Splits the string after each string <em>separator</em> and yields each part to a block.</p>","abstract":false,"args":[{"name":"separator","external_name":"separator","restriction":"String"},{"name":"limit","default_value":"nil","external_name":"limit","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"remove_empty","default_value":"false","external_name":"remove_empty","restriction":""}],"args_string":"(separator : String, limit = nil, *, remove_empty = false, &block : String -> _)","args_html":"(separator : <a href=\"String.html\">String</a>, limit = <span class=\"n\">nil</span>, *, remove_empty = <span class=\"n\">false</span>, &block : <a href=\"String.html\">String</a> -> _)","location":{"filename":"src/string.cr","line_number":3753,"url":null},"def":{"name":"split","args":[{"name":"separator","external_name":"separator","restriction":"String"},{"name":"limit","default_value":"nil","external_name":"limit","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"remove_empty","default_value":"false","external_name":"remove_empty","restriction":""}],"splat_index":2,"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(String -> _)"},"visibility":"Public","body":"if empty?\n  if remove_empty\n  else\n    yield \"\"\n  end\n  return\nend\nif limit && limit <= 1\n  yield self\n  return\nend\nif separator.empty?\n  split_by_empty_separator(limit) do |string|\n    yield string\n  end\n  return\nend\nyielded = 0\nbyte_offset = 0\nseparator_bytesize = separator.bytesize\nsingle_byte_optimizable = single_byte_optimizable?\ni = 0\nstop = (bytesize - separator.bytesize) + 1\nwhile i < stop\n  if ((to_unsafe + i).memcmp(separator.to_unsafe, separator_bytesize)) == 0\n    piece_bytesize = i - byte_offset\n    piece_size = single_byte_optimizable ? piece_bytesize : 0\n    if remove_empty && (piece_bytesize == 0)\n    else\n      yield String.new(to_unsafe + byte_offset, piece_bytesize, piece_size)\n    end\n    yielded = yielded + 1\n    byte_offset = i + separator_bytesize\n    i = i + (separator_bytesize - 1)\n    if limit && ((yielded + 1) == limit)\n      break\n    end\n  end\n  i = i + 1\nend\npiece_bytesize = bytesize - byte_offset\nif remove_empty && (piece_bytesize == 0)\n  return\nend\npiece_size = single_byte_optimizable ? piece_bytesize : 0\nyield String.new(to_unsafe + byte_offset, piece_bytesize, piece_size)\n"}},{"html_id":"split(separator:Regex,limit=nil,*,remove_empty=false)-instance-method","name":"split","doc":"Splits the string after each regex *separator* and yields each part to a block.\n\nIf *limit* is present, the array will be limited to *limit* items and\nthe final item will contain the remainder of the string.\n\nIf *separator* is an empty regex (`//`), the string will be separated into one-character strings.\n\nIf *remove_empty* is `true`, any empty strings are removed from the result.\n\n```\nary = [] of String\nlong_river_name = \"Mississippi\"\n\nlong_river_name.split(/s+/) { |s| ary << s }\nary # => [\"Mi\", \"i\", \"ippi\"]\nary.clear\n\nlong_river_name.split(//) { |s| ary << s }\nary # => [\"M\", \"i\", \"s\", \"s\", \"i\", \"s\", \"s\", \"i\", \"p\", \"p\", \"i\"]\n```","summary":"<p>Splits the string after each regex <em>separator</em> and yields each part to a block.</p>","abstract":false,"args":[{"name":"separator","external_name":"separator","restriction":"Regex"},{"name":"limit","default_value":"nil","external_name":"limit","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"remove_empty","default_value":"false","external_name":"remove_empty","restriction":""}],"args_string":"(separator : Regex, limit = nil, *, remove_empty = false)","args_html":"(separator : <a href=\"Regex.html\">Regex</a>, limit = <span class=\"n\">nil</span>, *, remove_empty = <span class=\"n\">false</span>)","location":{"filename":"src/string.cr","line_number":3820,"url":null},"def":{"name":"split","args":[{"name":"separator","external_name":"separator","restriction":"Regex"},{"name":"limit","default_value":"nil","external_name":"limit","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"remove_empty","default_value":"false","external_name":"remove_empty","restriction":""}],"splat_index":2,"visibility":"Public","body":"ary = Array(String).new\nsplit(separator, limit, remove_empty: remove_empty) do |string|\n  ary << string\nend\nary\n"}},{"html_id":"split(separator:Regex,limit=nil,*,remove_empty=false,&block:String->_)-instance-method","name":"split","doc":"Makes an `Array` by splitting the string on *separator* (and removing instances of *separator*).\n\nIf *limit* is present, the array will be limited to *limit* items and\nthe final item will contain the remainder of the string.\n\nIf *separator* is an empty regex (`//`), the string will be separated into one-character strings.\n\nIf *remove_empty* is `true`, any empty strings are removed from the result.\n\n```\nlong_river_name = \"Mississippi\"\nlong_river_name.split(/s+/) # => [\"Mi\", \"i\", \"ippi\"]\nlong_river_name.split(//)   # => [\"M\", \"i\", \"s\", \"s\", \"i\", \"s\", \"s\", \"i\", \"p\", \"p\", \"i\"]\n```","summary":"<p>Makes an <code><a href=\"Array.html\">Array</a></code> by splitting the string on <em>separator</em> (and removing instances of <em>separator</em>).</p>","abstract":false,"args":[{"name":"separator","external_name":"separator","restriction":"Regex"},{"name":"limit","default_value":"nil","external_name":"limit","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"remove_empty","default_value":"false","external_name":"remove_empty","restriction":""}],"args_string":"(separator : Regex, limit = nil, *, remove_empty = false, &block : String -> _)","args_html":"(separator : <a href=\"Regex.html\">Regex</a>, limit = <span class=\"n\">nil</span>, *, remove_empty = <span class=\"n\">false</span>, &block : <a href=\"String.html\">String</a> -> _)","location":{"filename":"src/string.cr","line_number":3842,"url":null},"def":{"name":"split","args":[{"name":"separator","external_name":"separator","restriction":"Regex"},{"name":"limit","default_value":"nil","external_name":"limit","restriction":""},{"name":"","external_name":"","restriction":""},{"name":"remove_empty","default_value":"false","external_name":"remove_empty","restriction":""}],"splat_index":2,"yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(String -> _)"},"visibility":"Public","body":"if empty?\n  if remove_empty\n  else\n    yield \"\"\n  end\n  return\nend\nif limit && limit <= 1\n  yield self\n  return\nend\nif separator.source.empty?\n  split_by_empty_separator(limit) do |string|\n    yield string\n  end\n  return\nend\ncount = 0\nmatch_offset = slice_offset = 0\nwhile match = separator.match_at_byte_index(self, match_offset)\n  index = match.byte_begin(0)\n  match_bytesize = (match.byte_end(0)) - index\n  next_offset = index + match_bytesize\n  if next_offset == slice_offset\n    match_offset = next_offset + (char_bytesize_at(next_offset))\n  else\n    slice_size = index - slice_offset\n    if remove_empty && (slice_size == 0)\n    else\n      yield byte_slice(slice_offset, slice_size)\n    end\n    count = count + 1\n    1.upto(match.size) do |i|\n      if group = match[i]?\n        yield group\n      end\n    end\n    slice_offset = match_offset = next_offset\n  end\n  if limit && ((count + 1) == limit)\n    break\n  end\n  if match_offset >= bytesize\n    break\n  end\nend\nif remove_empty && (slice_offset == bytesize)\nelse\n  yield byte_slice(slice_offset)\nend\n"}},{"html_id":"squeeze(&)-instance-method","name":"squeeze","doc":"Yields each char in this string to the block.\nReturns a new `String`, that has all characters removed,\nthat were the same as the previous one and for which the given\nblock returned a truthy value.\n\n```\n\"aaabbbccc\".squeeze &.in?('a', 'b') # => \"abccc\"\n\"aaabbbccc\".squeeze &.in?('a', 'c') # => \"abbbc\"\n```","summary":"<p>Yields each char in this string to the block.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":2769,"url":null},"def":{"name":"squeeze","yields":1,"visibility":"Public","body":"previous = nil\nString.build(bytesize) do |buffer|\n  each_char do |char|\n    if (yield(char)) && (previous == char)\n    else\n      buffer << char\n    end\n    previous = char\n  end\nend\n"}},{"html_id":"squeeze(char:Char):String-instance-method","name":"squeeze","doc":"Returns a new `String`, with all runs of char replaced by one instance.\n\n```\n\"a    bbb\".squeeze(' ') # => \"a bbb\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code>, with all runs of char replaced by one instance.</p>","abstract":false,"args":[{"name":"char","external_name":"char","restriction":"Char"}],"args_string":"(char : Char) : String","args_html":"(char : <a href=\"Char.html\">Char</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2784,"url":null},"def":{"name":"squeeze","args":[{"name":"char","external_name":"char","restriction":"Char"}],"return_type":"String","visibility":"Public","body":"squeeze do |my_char|\n  char == my_char\nend"}},{"html_id":"squeeze:String-instance-method","name":"squeeze","doc":"Returns a new `String`, that has all characters removed,\nthat were the same as the previous one.\n\n```\n\"a       bbb\".squeeze # => \"a b\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code>, that has all characters removed, that were the same as the previous one.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":2809,"url":null},"def":{"name":"squeeze","return_type":"String","visibility":"Public","body":"squeeze do\n  true\nend"}},{"html_id":"squeeze(*sets:String):String-instance-method","name":"squeeze","doc":"Sets should be a list of strings following the rules\ndescribed at `Char#in_set?`. Returns a new `String` with all\nruns of the same character replaced by one instance, if\nthey match the given set.\n\nIf no set is given, all characters are matched.\n\n```\n\"aaabbbcccddd\".squeeze(\"b-d\") # => \"aaabcd\"\n\"a       bbb\".squeeze         # => \"a b\"\n```","summary":"<p>Sets should be a list of strings following the rules described at <code><a href=\"Char.html#in_set%3F%28%2Asets%3AString%29%3ABool-instance-method\">Char#in_set?</a></code>.</p>","abstract":false,"args":[{"name":"sets","external_name":"sets","restriction":"String"}],"args_string":"(*sets : String) : String","args_html":"(*sets : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2799,"url":null},"def":{"name":"squeeze","args":[{"name":"sets","external_name":"sets","restriction":"String"}],"splat_index":0,"return_type":"String","visibility":"Public","body":"squeeze do |char|\n  char.in_set?(*sets)\nend"}},{"html_id":"starts_with?(str:String):Bool-instance-method","name":"starts_with?","doc":"Returns `true` if this string starts with the given *str*.\n\n```\n\"hello\".starts_with?(\"h\")  # => true\n\"hello\".starts_with?(\"he\") # => true\n\"hello\".starts_with?(\"hu\") # => false\n```","summary":"<p>Returns <code>true</code> if this string starts with the given <em>str</em>.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"String"}],"args_string":"(str : String) : Bool","args_html":"(str : <a href=\"String.html\">String</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/string.cr","line_number":4753,"url":null},"def":{"name":"starts_with?","args":[{"name":"str","external_name":"str","restriction":"String"}],"return_type":"Bool","visibility":"Public","body":"if str.bytesize > bytesize\n  return false\nend\n(to_unsafe.memcmp(str.to_unsafe, str.bytesize)) == 0\n"}},{"html_id":"starts_with?(char:Char):Bool-instance-method","name":"starts_with?","doc":"Returns `true` if this string starts with the given *char*.\n\n```\n\"hello\".starts_with?('h') # => true\n\"hello\".starts_with?('e') # => false\n```","summary":"<p>Returns <code>true</code> if this string starts with the given <em>char</em>.</p>","abstract":false,"args":[{"name":"char","external_name":"char","restriction":"Char"}],"args_string":"(char : Char) : Bool","args_html":"(char : <a href=\"Char.html\">Char</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/string.cr","line_number":4764,"url":null},"def":{"name":"starts_with?","args":[{"name":"char","external_name":"char","restriction":"Char"}],"return_type":"Bool","visibility":"Public","body":"each_char do |c|\n  return c == char\nend\nfalse\n"}},{"html_id":"starts_with?(re:Regex):Bool-instance-method","name":"starts_with?","doc":"Returns `true` if the regular expression *re* matches at the start of this string.\n\n```\n\"22hello\".starts_with?(/[0-9]/) # => true\n\"22hello\".starts_with?(/[a-z]/) # => false\n\"h22\".starts_with?(/[a-z]/)     # => true\n\"h22\".starts_with?(/[A-Z]/)     # => false\n\"h22\".starts_with?(/[a-z]{2}/)  # => false\n\"hh22\".starts_with?(/[a-z]{2}/) # => true\n```","summary":"<p>Returns <code>true</code> if the regular expression <em>re</em> matches at the start of this string.</p>","abstract":false,"args":[{"name":"re","external_name":"re","restriction":"Regex"}],"args_string":"(re : Regex) : Bool","args_html":"(re : <a href=\"Regex.html\">Regex</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/string.cr","line_number":4782,"url":null},"def":{"name":"starts_with?","args":[{"name":"re","external_name":"re","restriction":"Regex"}],"return_type":"Bool","visibility":"Public","body":"!(!($~ = re.match_at_byte_index(self, 0, Regex::Options::ANCHORED)))"}},{"html_id":"strip(char:Char):String-instance-method","name":"strip","doc":"Returns a new string where leading and trailing occurrences of *char* are removed.\n\n```\n\"aaabcdaaa\".strip('a') # => \"bcd\"\n```","summary":"<p>Returns a new string where leading and trailing occurrences of <em>char</em> are removed.</p>","abstract":false,"args":[{"name":"char","external_name":"char","restriction":"Char"}],"args_string":"(char : Char) : String","args_html":"(char : <a href=\"Char.html\">Char</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1789,"url":null},"def":{"name":"strip","args":[{"name":"char","external_name":"char","restriction":"Char"}],"return_type":"String","visibility":"Public","body":"if empty?\n  return self\nend\nexcess_left = calc_excess_left(char)\nif excess_left == bytesize\n  return \"\"\nend\nexcess_right = calc_excess_right(char)\nremove_excess(excess_left, excess_right)\n"}},{"html_id":"strip(chars:String):String-instance-method","name":"strip","doc":"Returns a new string where leading and trailing occurrences of any char\nin *chars* are removed. The *chars* argument is not a prefix or suffix;\nrather; all combinations of its values are stripped.\n\n```\n\"abcdefcba\".strip(\"abc\") # => \"def\"\n```","summary":"<p>Returns a new string where leading and trailing occurrences of any char in <em>chars</em> are removed.</p>","abstract":false,"args":[{"name":"chars","external_name":"chars","restriction":"String"}],"args_string":"(chars : String) : String","args_html":"(chars : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1808,"url":null},"def":{"name":"strip","args":[{"name":"chars","external_name":"chars","restriction":"String"}],"return_type":"String","visibility":"Public","body":"if empty?\n  return self\nend\ncase chars.size\nwhen 0\n  self\nwhen 1\n  strip(chars[0])\nelse\n  excess_left = calc_excess_left(chars)\n  if excess_left == bytesize\n    return \"\"\n  end\n  excess_right = calc_excess_right(chars)\n  remove_excess(excess_left, excess_right)\nend\n"}},{"html_id":"strip:String-instance-method","name":"strip","doc":"Returns a new `String` with leading and trailing whitespace removed.\n\n```\n\"    hello    \".strip # => \"hello\"\n\"\\tgoodbye\\r\\n\".strip # => \"goodbye\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with leading and trailing whitespace removed.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":1774,"url":null},"def":{"name":"strip","return_type":"String","visibility":"Public","body":"excess_left = calc_excess_left\nif excess_left == bytesize\n  return \"\"\nend\nexcess_right = calc_excess_right\nremove_excess(excess_left, excess_right)\n"}},{"html_id":"strip(&block:Char->_)-instance-method","name":"strip","doc":"Returns a new string where leading and trailing characters for which\nthe block returns a *truthy* value are removed.\n\n```\n\"bcadefcba\".strip { |c| 'a' <= c <= 'c' } # => \"def\"\n```","summary":"<p>Returns a new string where leading and trailing characters for which the block returns a <em>truthy</em> value are removed.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":1833,"url":null},"def":{"name":"strip","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(Char -> _)"},"visibility":"Public","body":"if empty?\n  return self\nend\nexcess_left = calc_excess_left do |c|\n  yield c\nend\nif excess_left == bytesize\n  return \"\"\nend\nexcess_right = calc_excess_right do |c|\n  yield c\nend\nremove_excess(excess_left, excess_right)\n"}},{"html_id":"sub(pattern:Regex,&)-instance-method","name":"sub","doc":"Returns a `String` where the first occurrence of *pattern* is replaced by\nthe block's return value.\n\n```\n\"hello\".sub(/./) { |s| s[0].ord.to_s + ' ' } # => \"104 ello\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where the first occurrence of <em>pattern</em> is replaced by the block's return value.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"}],"args_string":"(pattern : Regex, &)","args_html":"(pattern : <a href=\"Regex.html\">Regex</a>, &)","location":{"filename":"src/string.cr","line_number":2162,"url":null},"def":{"name":"sub","args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"}],"yields":2,"visibility":"Public","body":"sub_append(pattern) do |str, match, buffer|\n  $~ = match\n  buffer << (yield str, match)\nend"}},{"html_id":"sub(string:String,&)-instance-method","name":"sub","doc":"Returns a `String` where the first occurrences of the given *string* is replaced\nwith the block's value.\n\n```\n\"hello yellow\".sub(\"ll\") { \"dd\" } # => \"heddo yellow\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where the first occurrences of the given <em>string</em> is replaced with the block's value.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String, &)","args_html":"(string : <a href=\"String.html\">String</a>, &)","location":{"filename":"src/string.cr","line_number":2249,"url":null},"def":{"name":"sub","args":[{"name":"string","external_name":"string","restriction":"String"}],"yields":1,"visibility":"Public","body":"index = self.byte_index(string)\nif index\nelse\n  return self\nend\nString.build(bytesize) do |buffer|\n  buffer.write(unsafe_byte_slice(0, index))\n  buffer << (yield string)\n  buffer.write(unsafe_byte_slice(index + string.bytesize))\nend\n"}},{"html_id":"sub(&block:Char->_)-instance-method","name":"sub","doc":"Returns a new `String` where the first character is yielded to the given\nblock and replaced by its return value.\n\n```\n\"hello\".sub { |char| char + 1 } # => \"iello\"\n\"hello\".sub { \"hi\" }            # => \"hiello\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> where the first character is yielded to the given block and replaced by its return value.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":2117,"url":null},"def":{"name":"sub","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(Char -> _)"},"visibility":"Public","body":"if empty?\n  return self\nend\nString.build(bytesize) do |buffer|\n  reader = Char::Reader.new(self)\n  buffer << (yield reader.current_char)\n  reader.next_char\n  buffer.write(unsafe_byte_slice(reader.pos))\nend\n"}},{"html_id":"sub(char:Char,replacement):String-instance-method","name":"sub","doc":"Returns a `String` where the first occurrence of *char* is replaced by\n*replacement*.\n\n```\n\"hello\".sub('l', \"lo\")      # => \"helolo\"\n\"hello world\".sub('o', 'a') # => \"hella world\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where the first occurrence of <em>char</em> is replaced by <em>replacement</em>.</p>","abstract":false,"args":[{"name":"char","external_name":"char","restriction":"Char"},{"name":"replacement","external_name":"replacement","restriction":""}],"args_string":"(char : Char, replacement) : String","args_html":"(char : <a href=\"Char.html\">Char</a>, replacement) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2135,"url":null},"def":{"name":"sub","args":[{"name":"char","external_name":"char","restriction":"Char"},{"name":"replacement","external_name":"replacement","restriction":""}],"return_type":"String","visibility":"Public","body":"if includes?(char)\n  String.build(bytesize) do |buffer|\n    reader = Char::Reader.new(self)\n    while reader.has_next?\n      if reader.current_char == char\n        buffer << replacement\n        break\n      else\n        buffer << reader.current_char\n      end\n      reader.next_char\n    end\n    reader.next_char\n    buffer.write(unsafe_byte_slice(reader.pos))\n  end\nelse\n  self\nend"}},{"html_id":"sub(pattern:Regex,hash:Hash(String,_)|NamedTuple):String-instance-method","name":"sub","doc":"Returns a `String` where the first occurrences of the given *pattern* is replaced\nwith the matching entry from the *hash* of replacements. If the first match\nis not included in the *hash*, nothing is replaced.\n\n```\n\"hello\".sub(/(he|l|o)/, {\"he\": \"ha\", \"l\": \"la\"}) # => \"hallo\"\n\"hello\".sub(/(he|l|o)/, {\"l\": \"la\"})             # => \"hello\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where the first occurrences of the given <em>pattern</em> is replaced with the matching entry from the <em>hash</em> of replacements.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"},{"name":"hash","external_name":"hash","restriction":"Hash(String, _) | NamedTuple"}],"args_string":"(pattern : Regex, hash : Hash(String, _) | NamedTuple) : String","args_html":"(pattern : <a href=\"Regex.html\">Regex</a>, hash : <a href=\"Hash.html\">Hash</a>(<a href=\"String.html\">String</a>, _) | <a href=\"NamedTuple.html\">NamedTuple</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2223,"url":null},"def":{"name":"sub","args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"},{"name":"hash","external_name":"hash","restriction":"Hash(String, _) | NamedTuple"}],"return_type":"String","visibility":"Public","body":"sub(pattern) do |match|\n  if hash.has_key?(match)\n    hash[match]\n  else\n    return self\n  end\nend"}},{"html_id":"sub(pattern:Regex,replacement,backreferences=true):String-instance-method","name":"sub","doc":"Returns a `String` where the first occurrence of *pattern* is replaced by\n*replacement*\n\n```\n\"hello\".sub(/[aeiou]/, \"*\") # => \"h*llo\"\n```\n\nWithin *replacement*, the special match variable `$~` will not refer to the\ncurrent match.\n\nIf *backreferences* is `true` (the default value), *replacement* can include backreferences:\n\n```\n\"hello\".sub(/[aeiou]/, \"(\\\\0)\") # => \"h(e)llo\"\n```\n\nWhen substitution is performed, any backreferences found in *replacement*\nwill be replaced with the contents of the corresponding capture group in\n*pattern*. Backreferences to capture groups that were not present in\n*pattern* or that did not match will be skipped. See `Regex` for information\nabout capture groups.\n\nBackreferences are expressed in the form `\"\\\\d\"`, where *d* is a group\nnumber, or `\"\\\\k&lt;name>\"` where *name* is the name of a named capture group.\nA sequence of literal characters resembling a backreference can be\nexpressed by placing `\"\\\\\"` before the sequence.\n\n```\n\"foo\".sub(/o/, \"x\\\\0x\")                  # => \"fxoxo\"\n\"foofoo\".sub(/(?<bar>oo)/, \"|\\\\k<bar>|\") # => \"f|oo|foo\"\n\"foo\".sub(/o/, \"\\\\\\\\0\")                  # => \"f\\\\0o\"\n```\n\nRaises `ArgumentError` if an incomplete named back-reference is present in\n*replacement*.\n\nRaises `IndexError` if a named group referenced in *replacement* is not present\nin *pattern*.","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where the first occurrence of <em>pattern</em> is replaced by <em>replacement</em></p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"},{"name":"replacement","external_name":"replacement","restriction":""},{"name":"backreferences","default_value":"true","external_name":"backreferences","restriction":""}],"args_string":"(pattern : Regex, replacement, backreferences = true) : String","args_html":"(pattern : <a href=\"Regex.html\">Regex</a>, replacement, backreferences = <span class=\"n\">true</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2207,"url":null},"def":{"name":"sub","args":[{"name":"pattern","external_name":"pattern","restriction":"Regex"},{"name":"replacement","external_name":"replacement","restriction":""},{"name":"backreferences","default_value":"true","external_name":"backreferences","restriction":""}],"return_type":"String","visibility":"Public","body":"if (backreferences && replacement.is_a?(String)) && replacement.has_back_references?\n  sub_append(pattern) do |_, match, buffer|\n    scan_backreferences(replacement, match, buffer)\n  end\nelse\n  sub(pattern) do\n    replacement\n  end\nend"}},{"html_id":"sub(string:String,replacement):String-instance-method","name":"sub","doc":"Returns a `String` where the first occurrences of the given *string* is replaced\nwith the given *replacement*.\n\n```\n\"hello yellow\".sub(\"ll\", \"dd\") # => \"heddo yellow\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where the first occurrences of the given <em>string</em> is replaced with the given <em>replacement</em>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"replacement","external_name":"replacement","restriction":""}],"args_string":"(string : String, replacement) : String","args_html":"(string : <a href=\"String.html\">String</a>, replacement) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2239,"url":null},"def":{"name":"sub","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"replacement","external_name":"replacement","restriction":""}],"return_type":"String","visibility":"Public","body":"sub(string) do\n  replacement\nend"}},{"html_id":"sub(index:Int,replacement:Char):String-instance-method","name":"sub","doc":"Returns a new `String` with the character at the given index\nreplaced by *replacement*.\n\n```\n\"hello\".sub(1, 'a') # => \"hallo\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with the character at the given index replaced by <em>replacement</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"replacement","external_name":"replacement","restriction":"Char"}],"args_string":"(index : Int, replacement : Char) : String","args_html":"(index : <a href=\"Int.html\">Int</a>, replacement : <a href=\"Char.html\">Char</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2309,"url":null},"def":{"name":"sub","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"replacement","external_name":"replacement","restriction":"Char"}],"return_type":"String","visibility":"Public","body":"sub_index(index.to_i, replacement) do |buffer|\n  replacement.each_byte do |byte|\n    buffer.value = byte\n    buffer = buffer + 1\n  end\n  {buffer, @length}\nend"}},{"html_id":"sub(index:Int,replacement:String):String-instance-method","name":"sub","doc":"Returns a new `String` with the character at the given index\nreplaced by *replacement*.\n\n```\n\"hello\".sub(1, \"eee\") # => \"heeello\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with the character at the given index replaced by <em>replacement</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"replacement","external_name":"replacement","restriction":"String"}],"args_string":"(index : Int, replacement : String) : String","args_html":"(index : <a href=\"Int.html\">Int</a>, replacement : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2325,"url":null},"def":{"name":"sub","args":[{"name":"index","external_name":"index","restriction":"Int"},{"name":"replacement","external_name":"replacement","restriction":"String"}],"return_type":"String","visibility":"Public","body":"sub_index(index.to_i, replacement) do |buffer|\n  buffer.copy_from(replacement.to_unsafe, replacement.bytesize)\n  buffer = buffer + replacement.bytesize\n  {buffer, self.size_known? && replacement.size_known? ? (self.size + replacement.size) - 1 : 0}\nend"}},{"html_id":"sub(range:Range,replacement:Char):String-instance-method","name":"sub","doc":"Returns a new `String` with characters at the given range\nreplaced by *replacement*.\n\n```\n\"hello\".sub(1..2, 'a') # => \"halo\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with characters at the given range replaced by <em>replacement</em>.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"},{"name":"replacement","external_name":"replacement","restriction":"Char"}],"args_string":"(range : Range, replacement : Char) : String","args_html":"(range : <a href=\"Range.html\">Range</a>, replacement : <a href=\"Char.html\">Char</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2359,"url":null},"def":{"name":"sub","args":[{"name":"range","external_name":"range","restriction":"Range"},{"name":"replacement","external_name":"replacement","restriction":"Char"}],"return_type":"String","visibility":"Public","body":"sub_range(range, replacement) do |buffer, from_index, to_index|\n  replacement.each_byte do |byte|\n    buffer.value = byte\n    buffer = buffer + 1\n  end\n  {buffer, single_byte_optimizable? ? (bytesize - (to_index - from_index)) + 1 : 0}\nend"}},{"html_id":"sub(range:Range,replacement:String):String-instance-method","name":"sub","doc":"Returns a new `String` with characters at the given range\nreplaced by *replacement*.\n\n```\n\"hello\".sub(1..2, \"eee\") # => \"heeelo\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with characters at the given range replaced by <em>replacement</em>.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"},{"name":"replacement","external_name":"replacement","restriction":"String"}],"args_string":"(range : Range, replacement : String) : String","args_html":"(range : <a href=\"Range.html\">Range</a>, replacement : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2375,"url":null},"def":{"name":"sub","args":[{"name":"range","external_name":"range","restriction":"Range"},{"name":"replacement","external_name":"replacement","restriction":"String"}],"return_type":"String","visibility":"Public","body":"sub_range(range, replacement) do |buffer|\n  buffer.copy_from(replacement.to_unsafe, replacement.bytesize)\n  buffer = buffer + replacement.bytesize\n  {buffer, 0}\nend"}},{"html_id":"sub(hash:Hash(Char,_)):String-instance-method","name":"sub","doc":"Returns a `String` where the first char in the string matching a key in the\ngiven *hash* is replaced by the corresponding hash value.\n\n```\n\"hello\".sub({'a' => 'b', 'l' => 'd'}) # => \"hedlo\"\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> where the first char in the string matching a key in the given <em>hash</em> is replaced by the corresponding hash value.</p>","abstract":false,"args":[{"name":"hash","external_name":"hash","restriction":"Hash(Char, _)"}],"args_string":"(hash : Hash(Char, _)) : String","args_html":"(hash : <a href=\"Hash.html\">Hash</a>(<a href=\"Char.html\">Char</a>, _)) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2266,"url":null},"def":{"name":"sub","args":[{"name":"hash","external_name":"hash","restriction":"Hash(Char, _)"}],"return_type":"String","visibility":"Public","body":"if empty?\n  return self\nend\nString.build(bytesize) do |buffer|\n  reader = Char::Reader.new(self)\n  while reader.has_next?\n    if hash.has_key?(reader.current_char)\n      buffer << hash[reader.current_char]\n      reader.next_char\n      break\n    else\n      buffer << reader.current_char\n      reader.next_char\n    end\n  end\n  if reader.has_next?\n    buffer << reader.current_char\n    reader.next_char\n    buffer.write(unsafe_byte_slice(reader.pos))\n  end\nend\n"}},{"html_id":"succ:String-instance-method","name":"succ","doc":"Returns the successor of the string. The successor is calculated\nby incrementing characters starting from the rightmost alphanumeric\n(or the rightmost character if there are no alphanumerics) in the string.\nIncrementing a digit always results in another digit, and incrementing\na letter results in another letter of the same case.\n\nIf the increment generates a \"carry\", the character to the left of it is\nincremented. This process repeats until there is no carry,\nadding an additional character if necessary.\n\n```\n\"abcd\".succ      # => \"abce\"\n\"THX1138\".succ   # => \"THX1139\"\n\"((koala))\".succ # => \"((koalb))\"\n\"1999zzz\".succ   # => \"2000aaa\"\n\"ZZZ9999\".succ   # => \"AAAA0000\"\n\"***\".succ       # => \"**+\"\n```","summary":"<p>Returns the successor of the string.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4264,"url":null},"def":{"name":"succ","return_type":"String","visibility":"Public","body":"if empty?\n  return self\nend\nchars = self.chars\ncarry = nil\nlast_alnum = 0\nindex = size - 1\nwhile index >= 0\n  s = chars[index]\n  if s.ascii_alphanumeric?\n    carry = 0\n    if (('0' <= s && s < '9') || ('a' <= s && s < 'z')) || ('A' <= s && s < 'Z')\n      chars[index] = s.succ\n      break\n    else\n      if s == '9'\n        chars[index] = '0'\n        carry = '1'\n      else\n        if s == 'z'\n          chars[index] = carry = 'a'\n        else\n          if s == 'Z'\n            chars[index] = carry = 'A'\n          end\n        end\n      end\n    end\n    last_alnum = index\n  end\n  index = index - 1\nend\nif carry.nil?\n  chars[size - 1] = chars[size - 1].succ\nend\nif carry.is_a?(Char) && index < 0\n  chars.insert(last_alnum, carry)\nend\nString.build(chars.size) do |str|\n  chars.each do |char|\n    str << char\n  end\nend\n"}},{"html_id":"titleize(options:Unicode::CaseOptions=:none):String-instance-method","name":"titleize","doc":"Returns a new `String` with the first letter after any space converted to uppercase and every\nother letter converted to lowercase.\n\n```\n\"hEllO tAb\\tworld\".titleize      # => \"Hello Tab\\tWorld\"\n\"  spaces before\".titleize       # => \"  Spaces Before\"\n\"x-men: the last stand\".titleize # => \"X-men: The Last Stand\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with the first letter after any space converted to uppercase and every other letter converted to lowercase.</p>","abstract":false,"args":[{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"args_string":"(options : Unicode::CaseOptions = :none) : String","args_html":"(options : <a href=\"Unicode/CaseOptions.html\">Unicode::CaseOptions</a> = <span class=\"n\">:none</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1405,"url":null},"def":{"name":"titleize","args":[{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"return_type":"String","visibility":"Public","body":"if empty?\n  return self\nend\nif single_byte_optimizable? && (options.none? || options.ascii?)\n  upcase_next = true\n  return String.new(bytesize) do |buffer|\n    bytesize.times do |i|\n      char = to_unsafe[i].unsafe_chr\n      replaced_char = upcase_next ? char.upcase : char.downcase\n      buffer[i] = replaced_char.ord.to_u8\n      upcase_next = char.whitespace?\n    end\n    {@bytesize, @length}\n  end\nend\nString.build(bytesize) do |io|\n  titleize(io, options)\nend\n"}},{"html_id":"titleize(io:IO,options:Unicode::CaseOptions=:none):Nil-instance-method","name":"titleize","doc":"Writes a titleized version of `self` to the given *io*.\n\n```\nio = IO::Memory.new\n\"x-men: the last stand\".titleize io\nio.to_s # => \"X-men: The Last Stand\"\n```","summary":"<p>Writes a titleized version of <code>self</code> to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"args_string":"(io : IO, options : Unicode::CaseOptions = :none) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, options : <a href=\"Unicode/CaseOptions.html\">Unicode::CaseOptions</a> = <span class=\"n\">:none</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":1432,"url":null},"def":{"name":"titleize","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"return_type":"Nil","visibility":"Public","body":"upcase_next = true\neach_char_with_index do |char, i|\n  replaced_char = upcase_next ? char.upcase(options) : char.downcase(options)\n  io << replaced_char\n  upcase_next = char.whitespace?\nend\n"}},{"html_id":"to_big_d:BigDecimal-instance-method","name":"to_big_d","doc":"Converts `self` to `BigDecimal`.\n```\nrequire \"big\"\n\"1212341515125412412412421\".to_big_d\n```","summary":"<p>Converts <code>self</code> to <code><a href=\"BigDecimal.html\">BigDecimal</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_decimal.cr","line_number":702,"url":null},"def":{"name":"to_big_d","return_type":"BigDecimal","visibility":"Public","body":"BigDecimal.new(self)"}},{"html_id":"to_big_f:BigFloat-instance-method","name":"to_big_f","doc":"Converts `self` to a `BigFloat`.\n\n```\nrequire \"big\"\n\"1234.0\".to_big_f\n```","summary":"<p>Converts <code>self</code> to a <code><a href=\"BigFloat.html\">BigFloat</a></code>.</p>","abstract":false,"location":{"filename":"src/big/big_float.cr","line_number":390,"url":null},"def":{"name":"to_big_f","return_type":"BigFloat","visibility":"Public","body":"BigFloat.new(self)"}},{"html_id":"to_big_i(base=10):BigInt-instance-method","name":"to_big_i","doc":"Returns a `BigInt` from this string, in the given *base*.\n\nRaises `ArgumentError` if this string doesn't denote a valid integer.\n```\nrequire \"big\"\n\n\"3a060dbf8d1a5ac3e67bc8f18843fc48\".to_big_i(16)\n```","summary":"<p>Returns a <code><a href=\"BigInt.html\">BigInt</a></code> from this string, in the given <em>base</em>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":""}],"args_string":"(base = 10) : BigInt","args_html":"(base = <span class=\"n\">10</span>) : <a href=\"BigInt.html\">BigInt</a>","location":{"filename":"src/big/big_int.cr","line_number":798,"url":null},"def":{"name":"to_big_i","args":[{"name":"base","default_value":"10","external_name":"base","restriction":""}],"return_type":"BigInt","visibility":"Public","body":"BigInt.new(self, base)"}},{"html_id":"to_f(whitespace:Bool=true,strict:Bool=true)-instance-method","name":"to_f","doc":"Returns the result of interpreting characters in this string as a floating point number (`Float64`).\nThis method raises an exception if the string is not a valid float representation\nor exceeds the range of the data type. Values representing infinity or NaN\nare considered valid.\n\nOptions:\n* **whitespace**: if `true`, leading and trailing whitespaces are allowed\n* **strict**: if `true`, extraneous characters past the end of the number are disallowed\n\n```\n\"123.45e1\".to_f                # => 1234.5\n\"45.67 degrees\".to_f           # raises ArgumentError\n\"thx1138\".to_f(strict: false)  # raises ArgumentError\n\" 1.2\".to_f(whitespace: false) # raises ArgumentError\n\"1.2foo\".to_f(strict: false)   # => 1.2\n```","summary":"<p>Returns the result of interpreting characters in this string as a floating point number (<code><a href=\"Float64.html\">Float64</a></code>).</p>","abstract":false,"args":[{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"args_string":"(whitespace : Bool = true, strict : Bool = true)","args_html":"(whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>)","location":{"filename":"src/string.cr","line_number":688,"url":null},"def":{"name":"to_f","args":[{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"visibility":"Public","body":"to_f64(whitespace: whitespace, strict: strict)"}},{"html_id":"to_f32(whitespace:Bool=true,strict:Bool=true)-instance-method","name":"to_f32","doc":"Same as `#to_f` but returns a Float32.","summary":"<p>Same as <code><a href=\"String.html#to_f%28whitespace%3ABool%3Dtrue%2Cstrict%3ABool%3Dtrue%29-instance-method\">#to_f</a></code> but returns a Float32.</p>","abstract":false,"args":[{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"args_string":"(whitespace : Bool = true, strict : Bool = true)","args_html":"(whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>)","location":{"filename":"src/string.cr","line_number":726,"url":null},"def":{"name":"to_f32","args":[{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"visibility":"Public","body":"to_f32?(whitespace: whitespace, strict: strict) || (raise(ArgumentError.new(\"Invalid Float32: #{self}\")))"}},{"html_id":"to_f32?(whitespace:Bool=true,strict:Bool=true)-instance-method","name":"to_f32?","doc":"Same as `#to_f?` but returns a Float32.","summary":"<p>Same as <code><a href=\"String.html#to_f%3F%28whitespace%3ABool%3Dtrue%2Cstrict%3ABool%3Dtrue%29-instance-method\">#to_f?</a></code> but returns a Float32.</p>","abstract":false,"args":[{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"args_string":"(whitespace : Bool = true, strict : Bool = true)","args_html":"(whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>)","location":{"filename":"src/string.cr","line_number":731,"url":null},"def":{"name":"to_f32?","args":[{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"visibility":"Public","body":"to_f_impl(whitespace: whitespace, strict: strict) do\n  v = LibC.strtof(self, out endptr)\n  {v, endptr}\nend"}},{"html_id":"to_f64(whitespace:Bool=true,strict:Bool=true):Float64-instance-method","name":"to_f64","doc":"Returns the result of interpreting characters in this string as a floating point number (`Float64`).\nThis method raises an exception if the string is not a valid float representation\nor exceeds the range of the data type. Values representing infinity or NaN\nare considered valid.\n\nOptions:\n* **whitespace**: if `true`, leading and trailing whitespaces are allowed\n* **strict**: if `true`, extraneous characters past the end of the number are disallowed\n\n```\n\"123.45e1\".to_f                # => 1234.5\n\"45.67 degrees\".to_f           # raises ArgumentError\n\"thx1138\".to_f(strict: false)  # raises ArgumentError\n\" 1.2\".to_f(whitespace: false) # raises ArgumentError\n\"1.2foo\".to_f(strict: false)   # => 1.2\n```","summary":"<p>Returns the result of interpreting characters in this string as a floating point number (<code><a href=\"Float64.html\">Float64</a></code>).</p>","abstract":false,"args":[{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"args_string":"(whitespace : Bool = true, strict : Bool = true) : Float64","args_html":"(whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/string.cr","line_number":693,"url":null},"def":{"name":"to_f64","args":[{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"return_type":"Float64","visibility":"Public","body":"to_f64?(whitespace: whitespace, strict: strict) || (raise(ArgumentError.new(\"Invalid Float64: #{self}\")))"}},{"html_id":"to_f64?(whitespace:Bool=true,strict:Bool=true):Float64?-instance-method","name":"to_f64?","doc":"Returns the result of interpreting characters in this string as a floating point number (`Float64`).\nThis method returns `nil` if the string is not a valid float representation\nor exceeds the range of the data type. Values representing infinity or NaN\nare considered valid.\n\nOptions:\n* **whitespace**: if `true`, leading and trailing whitespaces are allowed\n* **strict**: if `true`, extraneous characters past the end of the number are disallowed\n\n```\n\"123.45e1\".to_f?                # => 1234.5\n\"45.67 degrees\".to_f?           # => nil\n\"thx1138\".to_f?                 # => nil\n\" 1.2\".to_f?(whitespace: false) # => nil\n\"1.2foo\".to_f?(strict: false)   # => 1.2\n```","summary":"<p>Returns the result of interpreting characters in this string as a floating point number (<code><a href=\"Float64.html\">Float64</a></code>).</p>","abstract":false,"args":[{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"args_string":"(whitespace : Bool = true, strict : Bool = true) : Float64?","args_html":"(whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>) : <a href=\"Float64.html\">Float64</a>?","location":{"filename":"src/string.cr","line_number":718,"url":null},"def":{"name":"to_f64?","args":[{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"return_type":"Float64 | ::Nil","visibility":"Public","body":"to_f_impl(whitespace: whitespace, strict: strict) do\n  v = LibC.strtod(self, out endptr)\n  {v, endptr}\nend"}},{"html_id":"to_f?(whitespace:Bool=true,strict:Bool=true)-instance-method","name":"to_f?","doc":"Returns the result of interpreting characters in this string as a floating point number (`Float64`).\nThis method returns `nil` if the string is not a valid float representation\nor exceeds the range of the data type. Values representing infinity or NaN\nare considered valid.\n\nOptions:\n* **whitespace**: if `true`, leading and trailing whitespaces are allowed\n* **strict**: if `true`, extraneous characters past the end of the number are disallowed\n\n```\n\"123.45e1\".to_f?                # => 1234.5\n\"45.67 degrees\".to_f?           # => nil\n\"thx1138\".to_f?                 # => nil\n\" 1.2\".to_f?(whitespace: false) # => nil\n\"1.2foo\".to_f?(strict: false)   # => 1.2\n```","summary":"<p>Returns the result of interpreting characters in this string as a floating point number (<code><a href=\"Float64.html\">Float64</a></code>).</p>","abstract":false,"args":[{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"args_string":"(whitespace : Bool = true, strict : Bool = true)","args_html":"(whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>)","location":{"filename":"src/string.cr","line_number":713,"url":null},"def":{"name":"to_f?","args":[{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"}],"visibility":"Public","body":"to_f64?(whitespace: whitespace, strict: strict)"}},{"html_id":"to_i(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false)-instance-method","name":"to_i","doc":"Returns the result of interpreting leading characters in this string as an\ninteger base *base* (between 2 and 36).\n\nIf there is not a valid number at the start of this string,\nor if the resulting integer doesn't fit an `Int32`, an `ArgumentError` is raised.\n\nOptions:\n* **whitespace**: if `true`, leading and trailing whitespaces are allowed\n* **underscore**: if `true`, underscores in numbers are allowed\n* **prefix**: if `true`, the prefixes `\"0x\"`, `\"0o\"` and `\"0b\"` override the base\n* **strict**: if `true`, extraneous characters past the end of the number are disallowed\n* **leading_zero_is_octal**: if `true`, then a number prefixed with `\"0\"` will be treated as an octal\n\n```\n\"12345\".to_i             # => 12345\n\"0a\".to_i                # raises ArgumentError\n\"hello\".to_i             # raises ArgumentError\n\"0a\".to_i(16)            # => 10\n\"1100101\".to_i(2)        # => 101\n\"1100101\".to_i(8)        # => 294977\n\"1100101\".to_i(10)       # => 1100101\n\"1100101\".to_i(base: 16) # => 17826049\n\n\"12_345\".to_i                   # raises ArgumentError\n\"12_345\".to_i(underscore: true) # => 12345\n\n\"  12345  \".to_i                    # => 12345\n\"  12345  \".to_i(whitespace: false) # raises ArgumentError\n\n\"0x123abc\".to_i               # raises ArgumentError\n\"0x123abc\".to_i(prefix: true) # => 1194684\n\n\"99 red balloons\".to_i                # raises ArgumentError\n\"99 red balloons\".to_i(strict: false) # => 99\n\n\"0755\".to_i                              # => 755\n\"0755\".to_i(leading_zero_is_octal: true) # => 493\n```","summary":"<p>Returns the result of interpreting leading characters in this string as an integer base <em>base</em> (between 2 and 36).</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>)","location":{"filename":"src/string.cr","line_number":332,"url":null},"def":{"name":"to_i","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"visibility":"Public","body":"to_i32(base, whitespace, underscore, prefix, strict, leading_zero_is_octal)"}},{"html_id":"to_i(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false,&)-instance-method","name":"to_i","doc":"Same as `#to_i`, but returns the block's value if there is not a valid number at the start\nof this string, or if the resulting integer doesn't fit an `Int32`.\n\n```\n\"12345\".to_i { 0 } # => 12345\n\"hello\".to_i { 0 } # => 0\n```","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code>, but returns the block's value if there is not a valid number at the start of this string, or if the resulting integer doesn't fit an <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false, &)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &)","location":{"filename":"src/string.cr","line_number":356,"url":null},"def":{"name":"to_i","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"yields":0,"visibility":"Public","body":"to_i32(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  yield\nend"}},{"html_id":"to_i128(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):Int128-instance-method","name":"to_i128","doc":"Same as `#to_i` but returns an `Int128`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : Int128","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Int128.html\">Int128</a>","location":{"filename":"src/string.cr","line_number":481,"url":null},"def":{"name":"to_i128","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"Int128","visibility":"Public","body":"to_i128(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  raise(ArgumentError.new(\"Invalid Int128: #{self}\"))\nend"}},{"html_id":"to_i128(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false,&)-instance-method","name":"to_i128","doc":"Same as `#to_i` but returns an `Int128` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int128.html\">Int128</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false, &)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &)","location":{"filename":"src/string.cr","line_number":491,"url":null},"def":{"name":"to_i128","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"yields":0,"visibility":"Public","body":"gen_to_(Int128, UInt128, Int128::MAX, ((UInt128.new(Int128::MAX)) + 1))"}},{"html_id":"to_i128?(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):Int128?-instance-method","name":"to_i128?","doc":"Same as `#to_i` but returns an `Int128` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int128.html\">Int128</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : Int128?","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Int128.html\">Int128</a>?","location":{"filename":"src/string.cr","line_number":486,"url":null},"def":{"name":"to_i128?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"Int128 | ::Nil","visibility":"Public","body":"to_i128(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  nil\nend"}},{"html_id":"to_i16(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):Int16-instance-method","name":"to_i16","doc":"Same as `#to_i` but returns an `Int16`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : Int16","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Int16.html\">Int16</a>","location":{"filename":"src/string.cr","line_number":391,"url":null},"def":{"name":"to_i16","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"Int16","visibility":"Public","body":"to_i16(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  raise(ArgumentError.new(\"Invalid Int16: #{self}\"))\nend"}},{"html_id":"to_i16(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false,&)-instance-method","name":"to_i16","doc":"Same as `#to_i` but returns an `Int16` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int16.html\">Int16</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false, &)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &)","location":{"filename":"src/string.cr","line_number":401,"url":null},"def":{"name":"to_i16","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"yields":0,"visibility":"Public","body":"gen_to_(Int16, UInt16, 32767, 32768)"}},{"html_id":"to_i16?(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):Int16?-instance-method","name":"to_i16?","doc":"Same as `#to_i` but returns an `Int16` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int16.html\">Int16</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : Int16?","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Int16.html\">Int16</a>?","location":{"filename":"src/string.cr","line_number":396,"url":null},"def":{"name":"to_i16?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"Int16 | ::Nil","visibility":"Public","body":"to_i16(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  nil\nend"}},{"html_id":"to_i32(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):Int32-instance-method","name":"to_i32","doc":"Same as `#to_i`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : Int32","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/string.cr","line_number":421,"url":null},"def":{"name":"to_i32","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"Int32","visibility":"Public","body":"to_i32(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  raise(ArgumentError.new(\"Invalid Int32: #{self}\"))\nend"}},{"html_id":"to_i32(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false,&)-instance-method","name":"to_i32","doc":"Same as `#to_i`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false, &)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &)","location":{"filename":"src/string.cr","line_number":431,"url":null},"def":{"name":"to_i32","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"yields":0,"visibility":"Public","body":"gen_to_(Int32, UInt32, 2147483647, 2147483648_i64)"}},{"html_id":"to_i32?(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):Int32?-instance-method","name":"to_i32?","doc":"Same as `#to_i`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : Int32?","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/string.cr","line_number":426,"url":null},"def":{"name":"to_i32?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"to_i32(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  nil\nend"}},{"html_id":"to_i64(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):Int64-instance-method","name":"to_i64","doc":"Same as `#to_i` but returns an `Int64`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : Int64","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Int64.html\">Int64</a>","location":{"filename":"src/string.cr","line_number":451,"url":null},"def":{"name":"to_i64","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"Int64","visibility":"Public","body":"to_i64(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  raise(ArgumentError.new(\"Invalid Int64: #{self}\"))\nend"}},{"html_id":"to_i64(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false,&)-instance-method","name":"to_i64","doc":"Same as `#to_i` but returns an `Int64` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int64.html\">Int64</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false, &)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &)","location":{"filename":"src/string.cr","line_number":461,"url":null},"def":{"name":"to_i64","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"yields":0,"visibility":"Public","body":"gen_to_(Int64, UInt64, 9223372036854775807_i64, 9223372036854775808_u64)"}},{"html_id":"to_i64?(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):Int64?-instance-method","name":"to_i64?","doc":"Same as `#to_i` but returns an `Int64` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int64.html\">Int64</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : Int64?","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Int64.html\">Int64</a>?","location":{"filename":"src/string.cr","line_number":456,"url":null},"def":{"name":"to_i64?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"Int64 | ::Nil","visibility":"Public","body":"to_i64(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  nil\nend"}},{"html_id":"to_i8(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):Int8-instance-method","name":"to_i8","doc":"Same as `#to_i` but returns an `Int8`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : Int8","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Int8.html\">Int8</a>","location":{"filename":"src/string.cr","line_number":361,"url":null},"def":{"name":"to_i8","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"Int8","visibility":"Public","body":"to_i8(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  raise(ArgumentError.new(\"Invalid Int8: #{self}\"))\nend"}},{"html_id":"to_i8(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false,&)-instance-method","name":"to_i8","doc":"Same as `#to_i` but returns an `Int8` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int8.html\">Int8</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false, &)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &)","location":{"filename":"src/string.cr","line_number":371,"url":null},"def":{"name":"to_i8","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"yields":0,"visibility":"Public","body":"gen_to_(Int8, UInt8, 127, 128)"}},{"html_id":"to_i8?(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):Int8?-instance-method","name":"to_i8?","doc":"Same as `#to_i` but returns an `Int8` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"Int8.html\">Int8</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : Int8?","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Int8.html\">Int8</a>?","location":{"filename":"src/string.cr","line_number":366,"url":null},"def":{"name":"to_i8?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"Int8 | ::Nil","visibility":"Public","body":"to_i8(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  nil\nend"}},{"html_id":"to_i?(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false)-instance-method","name":"to_i?","doc":"Same as `#to_i`, but returns `nil` if there is not a valid number at the start\nof this string, or if the resulting integer doesn't fit an `Int32`.\n\n```\n\"12345\".to_i?             # => 12345\n\"99 red balloons\".to_i?   # => nil\n\"0a\".to_i?(strict: false) # => 0\n\"hello\".to_i?             # => nil\n```","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code>, but returns <code>nil</code> if there is not a valid number at the start of this string, or if the resulting integer doesn't fit an <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>)","location":{"filename":"src/string.cr","line_number":345,"url":null},"def":{"name":"to_i?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"visibility":"Public","body":"to_i32?(base, whitespace, underscore, prefix, strict, leading_zero_is_octal)"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":64,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.string(self)"}},{"html_id":"to_json_object_key:String-instance-method","name":"to_json_object_key","abstract":false,"location":{"filename":"src/json/to_json.cr","line_number":68,"url":null},"def":{"name":"to_json_object_key","return_type":"String","visibility":"Public","body":"self"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends `self` to *io*.","summary":"<p>Appends <code>self</code> to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":5022,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io.write_string(to_slice)"}},{"html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns `self`.","summary":"<p>Returns <code>self</code>.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":5017,"url":null},"def":{"name":"to_s","return_type":"String","visibility":"Public","body":"self"}},{"html_id":"to_slice:Bytes-instance-method","name":"to_slice","doc":"Returns the underlying bytes of this String.\n\nThe returned slice is read-only.","summary":"<p>Returns the underlying bytes of this String.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":5029,"url":null},"def":{"name":"to_slice","return_type":"Bytes","visibility":"Public","body":"Slice.new(to_unsafe, bytesize, read_only: true)"}},{"html_id":"to_u128(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):UInt128-instance-method","name":"to_u128","doc":"Same as `#to_i` but returns an `UInt128`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : UInt128","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"UInt128.html\">UInt128</a>","location":{"filename":"src/string.cr","line_number":496,"url":null},"def":{"name":"to_u128","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"UInt128","visibility":"Public","body":"to_u128(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  raise(ArgumentError.new(\"Invalid UInt128: #{self}\"))\nend"}},{"html_id":"to_u128(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false,&)-instance-method","name":"to_u128","doc":"Same as `#to_i` but returns an `UInt128` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt128.html\">UInt128</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false, &)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &)","location":{"filename":"src/string.cr","line_number":506,"url":null},"def":{"name":"to_u128","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"yields":0,"visibility":"Public","body":"gen_to_(UInt128, UInt128)"}},{"html_id":"to_u128?(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):UInt128?-instance-method","name":"to_u128?","doc":"Same as `#to_i` but returns an `UInt128` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt128.html\">UInt128</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : UInt128?","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"UInt128.html\">UInt128</a>?","location":{"filename":"src/string.cr","line_number":501,"url":null},"def":{"name":"to_u128?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"UInt128 | ::Nil","visibility":"Public","body":"to_u128(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  nil\nend"}},{"html_id":"to_u16(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):UInt16-instance-method","name":"to_u16","doc":"Same as `#to_i` but returns an `UInt16`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : UInt16","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"UInt16.html\">UInt16</a>","location":{"filename":"src/string.cr","line_number":406,"url":null},"def":{"name":"to_u16","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"UInt16","visibility":"Public","body":"to_u16(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  raise(ArgumentError.new(\"Invalid UInt16: #{self}\"))\nend"}},{"html_id":"to_u16(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false,&)-instance-method","name":"to_u16","doc":"Same as `#to_i` but returns an `UInt16` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt16.html\">UInt16</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false, &)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &)","location":{"filename":"src/string.cr","line_number":416,"url":null},"def":{"name":"to_u16","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"yields":0,"visibility":"Public","body":"gen_to_(UInt16, UInt16)"}},{"html_id":"to_u16?(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):UInt16?-instance-method","name":"to_u16?","doc":"Same as `#to_i` but returns an `UInt16` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt16.html\">UInt16</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : UInt16?","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"UInt16.html\">UInt16</a>?","location":{"filename":"src/string.cr","line_number":411,"url":null},"def":{"name":"to_u16?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"UInt16 | ::Nil","visibility":"Public","body":"to_u16(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  nil\nend"}},{"html_id":"to_u32(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):UInt32-instance-method","name":"to_u32","doc":"Same as `#to_i` but returns an `UInt32`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : UInt32","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"UInt32.html\">UInt32</a>","location":{"filename":"src/string.cr","line_number":436,"url":null},"def":{"name":"to_u32","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"UInt32","visibility":"Public","body":"to_u32(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  raise(ArgumentError.new(\"Invalid UInt32: #{self}\"))\nend"}},{"html_id":"to_u32(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false,&)-instance-method","name":"to_u32","doc":"Same as `#to_i` but returns an `UInt32` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt32.html\">UInt32</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false, &)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &)","location":{"filename":"src/string.cr","line_number":446,"url":null},"def":{"name":"to_u32","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"yields":0,"visibility":"Public","body":"gen_to_(UInt32, UInt32)"}},{"html_id":"to_u32?(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):UInt32?-instance-method","name":"to_u32?","doc":"Same as `#to_i` but returns an `UInt32` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt32.html\">UInt32</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : UInt32?","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"UInt32.html\">UInt32</a>?","location":{"filename":"src/string.cr","line_number":441,"url":null},"def":{"name":"to_u32?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"UInt32 | ::Nil","visibility":"Public","body":"to_u32(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  nil\nend"}},{"html_id":"to_u64(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):UInt64-instance-method","name":"to_u64","doc":"Same as `#to_i` but returns an `UInt64`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : UInt64","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"UInt64.html\">UInt64</a>","location":{"filename":"src/string.cr","line_number":466,"url":null},"def":{"name":"to_u64","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"UInt64","visibility":"Public","body":"to_u64(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  raise(ArgumentError.new(\"Invalid UInt64: #{self}\"))\nend"}},{"html_id":"to_u64(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false,&)-instance-method","name":"to_u64","doc":"Same as `#to_i` but returns an `UInt64` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt64.html\">UInt64</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false, &)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &)","location":{"filename":"src/string.cr","line_number":476,"url":null},"def":{"name":"to_u64","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"yields":0,"visibility":"Public","body":"gen_to_(UInt64, UInt64)"}},{"html_id":"to_u64?(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):UInt64?-instance-method","name":"to_u64?","doc":"Same as `#to_i` but returns an `UInt64` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt64.html\">UInt64</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : UInt64?","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"UInt64.html\">UInt64</a>?","location":{"filename":"src/string.cr","line_number":471,"url":null},"def":{"name":"to_u64?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"UInt64 | ::Nil","visibility":"Public","body":"to_u64(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  nil\nend"}},{"html_id":"to_u8(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):UInt8-instance-method","name":"to_u8","doc":"Same as `#to_i` but returns an `UInt8`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : UInt8","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"UInt8.html\">UInt8</a>","location":{"filename":"src/string.cr","line_number":376,"url":null},"def":{"name":"to_u8","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"UInt8","visibility":"Public","body":"to_u8(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  raise(ArgumentError.new(\"Invalid UInt8: #{self}\"))\nend"}},{"html_id":"to_u8(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false,&)-instance-method","name":"to_u8","doc":"Same as `#to_i` but returns an `UInt8` or the block's value.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt8.html\">UInt8</a></code> or the block's value.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false, &)","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &)","location":{"filename":"src/string.cr","line_number":386,"url":null},"def":{"name":"to_u8","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"yields":0,"visibility":"Public","body":"gen_to_(UInt8, UInt8)"}},{"html_id":"to_u8?(base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):UInt8?-instance-method","name":"to_u8?","doc":"Same as `#to_i` but returns an `UInt8` or `nil`.","summary":"<p>Same as <code><a href=\"String.html#to_i%28base%3AInt%3D10%2Cwhitespace%3ABool%3Dtrue%2Cunderscore%3ABool%3Dfalse%2Cprefix%3ABool%3Dfalse%2Cstrict%3ABool%3Dtrue%2Cleading_zero_is_octal%3ABool%3Dfalse%29-instance-method\">#to_i</a></code> but returns an <code><a href=\"UInt8.html\">UInt8</a></code> or <code>nil</code>.</p>","abstract":false,"args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : UInt8?","args_html":"(base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"UInt8.html\">UInt8</a>?","location":{"filename":"src/string.cr","line_number":381,"url":null},"def":{"name":"to_u8?","args":[{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"UInt8 | ::Nil","visibility":"Public","body":"to_u8(base, whitespace, underscore, prefix, strict, leading_zero_is_octal) do\n  nil\nend"}},{"html_id":"to_unsafe:Pointer(UInt8)-instance-method","name":"to_unsafe","doc":"Returns a pointer to the underlying bytes of this String.","summary":"<p>Returns a pointer to the underlying bytes of this String.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":5034,"url":null},"def":{"name":"to_unsafe","return_type":"::Pointer(UInt8)","visibility":"Public","body":"pointerof(@c)"}},{"html_id":"to_utf16:Slice(UInt16)-instance-method","name":"to_utf16","doc":"Returns the UTF-16 encoding of the given *string*.\n\nInvalid chars (in the range U+D800..U+DFFF) are encoded with the\nunicode replacement char value `0xfffd`.\n\nThe byte following the end of this slice (but not included in it) is defined\nto be zero. This allows passing the result of this function into C functions\nthat expect a null-terminated `UInt16*`.\n\n```\n\"hi 𐂥\".to_utf16 # => Slice[104_u16, 105_u16, 32_u16, 55296_u16, 56485_u16]\n```","summary":"<p>Returns the UTF-16 encoding of the given <em>string</em>.</p>","abstract":false,"location":{"filename":"src/string/utf16.cr","line_number":14,"url":null},"def":{"name":"to_utf16","return_type":"Slice(UInt16)","visibility":"Public","body":"if ascii_only?\n  slice = Slice(UInt16).new(bytesize + 1) do |i|\n    if i == bytesize\n      0_u16\n    else\n      to_unsafe[i].to_u16\n    end\n  end\n  return slice[0, bytesize]\nend\nu16_size = 0\neach_char do |char|\n  u16_size = u16_size + (char.ord < 65536 ? 1 : 2)\nend\nslice = Slice(UInt16).new(u16_size + 1)\ni = 0\neach_char do |char|\n  ord = char.ord\n  if ord <= 55296 || (57344 <= ord && ord < 65536)\n    slice[i] = ord.to_u16\n  else\n    if ord >= 65536\n      ord = ord - 65536\n      slice[i] = 55296_u16 + ((ord >> 10) & 1023)\n      i = i + 1\n      slice[i] = 56320_u16 + (ord & 1023)\n    else\n      slice[i] = 65533_u16\n    end\n  end\n  i = i + 1\nend\nslice[i] = 0_u16\nslice[0, u16_size]\n"}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder) : Nil","args_html":"(yaml : <a href=\"YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":62,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"if YAML::Schema::Core.reserved_string?(self)\n  yaml.scalar(self, style: YAML::ScalarStyle::DOUBLE_QUOTED)\nelse\n  yaml.scalar(self)\nend"}},{"html_id":"tr(from:String,to:String):String-instance-method","name":"tr","doc":"Returns a new string _tr_anslating characters using *from* and *to* as a\nmap. If *to* is shorter than *from*, the last character in *to* is used for\nthe rest. If *to* is empty, this acts like `String#delete`.\n\n```\n\"aabbcc\".tr(\"abc\", \"xyz\") # => \"xxyyzz\"\n\"aabbcc\".tr(\"abc\", \"x\")   # => \"xxxxxx\"\n\"aabbcc\".tr(\"a\", \"xyz\")   # => \"xxbbcc\"\n```","summary":"<p>Returns a new string _tr_anslating characters using <em>from</em> and <em>to</em> as a map.</p>","abstract":false,"args":[{"name":"from","external_name":"from","restriction":"String"},{"name":"to","external_name":"to","restriction":"String"}],"args_string":"(from : String, to : String) : String","args_html":"(from : <a href=\"String.html\">String</a>, to : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":2065,"url":null},"def":{"name":"tr","args":[{"name":"from","external_name":"from","restriction":"String"},{"name":"to","external_name":"to","restriction":"String"}],"return_type":"String","visibility":"Public","body":"if to.empty?\n  return delete(from)\nend\nif from.bytesize == 1\n  return gsub(from.to_unsafe[0].unsafe_chr, to[0])\nend\nmulti = nil\ntable = StaticArray(Int32, 256).new(-1)\nreader = Char::Reader.new(to)\nchar = reader.current_char\nnext_char = reader.next_char\nfrom.each_char do |ch|\n  if ch.ord >= 256\n    multi || (multi = {} of Char => Char)\n    multi[ch] = char\n  else\n    table[ch.ord] = char.ord\n  end\n  if next_char != Char::ZERO\n    char = next_char\n    reader.next_char\n    next_char = reader.current_char\n  end\nend\nString.build(bytesize) do |buffer|\n  each_char do |ch|\n    if ch.ord < 256\n      if (a = table[ch.ord]) >= 0\n        buffer << a.unsafe_chr\n      else\n        buffer << ch\n      end\n    else\n      if a = multi.try(&.[]?(ch))\n        buffer << a\n      else\n        buffer << ch\n      end\n    end\n  end\nend\n"}},{"html_id":"underscore(options:Unicode::CaseOptions=:none):String-instance-method","name":"underscore","doc":"Converts camelcase boundaries to underscores.\n\n```\n\"DoesWhatItSaysOnTheTin\".underscore                         # => \"does_what_it_says_on_the_tin\"\n\"PartyInTheUSA\".underscore                                  # => \"party_in_the_usa\"\n\"HTTP_CLIENT\".underscore                                    # => \"http_client\"\n\"3.14IsPi\".underscore                                       # => \"3.14_is_pi\"\n\"InterestingImage\".underscore(Unicode::CaseOptions::Turkic) # => \"ınteresting_ımage\"\n```","summary":"<p>Converts camelcase boundaries to underscores.</p>","abstract":false,"args":[{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"args_string":"(options : Unicode::CaseOptions = :none) : String","args_html":"(options : <a href=\"Unicode/CaseOptions.html\">Unicode::CaseOptions</a> = <span class=\"n\">:none</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":3966,"url":null},"def":{"name":"underscore","args":[{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"return_type":"String","visibility":"Public","body":"String.build(bytesize + 10) do |io|\n  underscore(io, options)\nend"}},{"html_id":"underscore(io:IO,options:Unicode::CaseOptions=:none):Nil-instance-method","name":"underscore","doc":"Writes an underscored version of `self` to the given *io*.\n\n```\nio = IO::Memory.new\n\"DoesWhatItSaysOnTheTin\".underscore io\nio.to_s # => \"does_what_it_says_on_the_tin\"\n```","summary":"<p>Writes an underscored version of <code>self</code> to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"args_string":"(io : IO, options : Unicode::CaseOptions = :none) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, options : <a href=\"Unicode/CaseOptions.html\">Unicode::CaseOptions</a> = <span class=\"n\">:none</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":3977,"url":null},"def":{"name":"underscore","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"return_type":"Nil","visibility":"Public","body":"first = true\nlast_is_downcase = false\nlast_is_upcase = false\nlast_is_digit = false\nmem : Char | ::Nil = nil\neach_char do |char|\n  digit = char.ascii_number?\n  if options.none?\n    downcase = digit || char.ascii_lowercase?\n    upcase = char.ascii_uppercase?\n  else\n    downcase = digit || char.lowercase?\n    upcase = char.uppercase?\n  end\n  if first\n    io << (char.downcase(options))\n  else\n    if last_is_downcase && upcase\n      if mem\n        io << mem\n        mem = nil\n      end\n      io << '_'\n      io << (char.downcase(options))\n    else\n      if (last_is_upcase || last_is_digit) && (upcase || digit)\n        if mem\n          io << (mem.downcase(options))\n        end\n        mem = char\n      else\n        if mem\n          if char == '_'\n          else\n            if last_is_upcase && downcase\n              io << '_'\n            end\n          end\n          io << (mem.downcase(options))\n          mem = nil\n        end\n        io << (char.downcase(options))\n      end\n    end\n  end\n  last_is_downcase = downcase\n  last_is_upcase = upcase\n  last_is_digit = digit\n  first = false\nend\nif mem\n  io << (mem.downcase(options))\nend\n"}},{"html_id":"unsafe_byte_at(index:Int):UInt8-instance-method","name":"unsafe_byte_at","doc":"Returns the byte at the given *index* without bounds checking.","summary":"<p>Returns the byte at the given <em>index</em> without bounds checking.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code>to_unsafe[index]</code> instead.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : UInt8","args_html":"(index : <a href=\"Int.html\">Int</a>) : <a href=\"UInt8.html\">UInt8</a>","location":{"filename":"src/string.cr","line_number":1279,"url":null},"def":{"name":"unsafe_byte_at","args":[{"name":"index","external_name":"index","restriction":"Int"}],"return_type":"UInt8","visibility":"Public","body":"to_unsafe[index]"}},{"html_id":"unsafe_byte_slice(byte_offset,count):Slice-instance-method","name":"unsafe_byte_slice","doc":"Returns *count* of underlying bytes of this String starting at given *byte_offset*.\n\nThe returned slice is read-only.","summary":"<p>Returns <em>count</em> of underlying bytes of this String starting at given <em>byte_offset</em>.</p>","abstract":false,"args":[{"name":"byte_offset","external_name":"byte_offset","restriction":""},{"name":"count","external_name":"count","restriction":""}],"args_string":"(byte_offset, count) : Slice","args_html":"(byte_offset, count) : <a href=\"Slice.html\">Slice</a>","location":{"filename":"src/string.cr","line_number":5041,"url":null},"def":{"name":"unsafe_byte_slice","args":[{"name":"byte_offset","external_name":"byte_offset","restriction":""},{"name":"count","external_name":"count","restriction":""}],"return_type":"Slice","visibility":"Public","body":"Slice.new(to_unsafe + byte_offset, count, read_only: true)"}},{"html_id":"unsafe_byte_slice(byte_offset):Slice-instance-method","name":"unsafe_byte_slice","doc":"Returns the underlying bytes of this String starting at given *byte_offset*.\n\nThe returned slice is read-only.","summary":"<p>Returns the underlying bytes of this String starting at given <em>byte_offset</em>.</p>","abstract":false,"args":[{"name":"byte_offset","external_name":"byte_offset","restriction":""}],"args_string":"(byte_offset) : Slice","args_html":"(byte_offset) : <a href=\"Slice.html\">Slice</a>","location":{"filename":"src/string.cr","line_number":5048,"url":null},"def":{"name":"unsafe_byte_slice","args":[{"name":"byte_offset","external_name":"byte_offset","restriction":""}],"return_type":"Slice","visibility":"Public","body":"Slice.new(to_unsafe + byte_offset, bytesize - byte_offset, read_only: true)"}},{"html_id":"upcase(options:Unicode::CaseOptions=:none):String-instance-method","name":"upcase","doc":"Returns a new `String` with each lowercase letter replaced with its uppercase counterpart.\n\n```\n\"hEllO\".upcase # => \"HELLO\"\n```","summary":"<p>Returns a new <code><a href=\"String.html\">String</a></code> with each lowercase letter replaced with its uppercase counterpart.</p>","abstract":false,"args":[{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"args_string":"(options : Unicode::CaseOptions = :none) : String","args_html":"(options : <a href=\"Unicode/CaseOptions.html\">Unicode::CaseOptions</a> = <span class=\"n\">:none</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string.cr","line_number":1323,"url":null},"def":{"name":"upcase","args":[{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"return_type":"String","visibility":"Public","body":"if empty?\n  return self\nend\nif single_byte_optimizable? && (options.none? || options.ascii?)\n  return String.new(bytesize) do |buffer|\n    bytesize.times do |i|\n      buffer[i] = to_unsafe[i].unsafe_chr.upcase.ord.to_u8\n    end\n    {@bytesize, @length}\n  end\nend\nString.build(bytesize) do |io|\n  upcase(io, options)\nend\n"}},{"html_id":"upcase(io:IO,options:Unicode::CaseOptions=:none):Nil-instance-method","name":"upcase","doc":"Writes a upcased version of `self` to the given *io*.\n\n```\nio = IO::Memory.new\n\"hEllO\".upcase io\nio.to_s # => \"HELLO\"\n```","summary":"<p>Writes a upcased version of <code>self</code> to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"args_string":"(io : IO, options : Unicode::CaseOptions = :none) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, options : <a href=\"Unicode/CaseOptions.html\">Unicode::CaseOptions</a> = <span class=\"n\">:none</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string.cr","line_number":1345,"url":null},"def":{"name":"upcase","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":":none","external_name":"options","restriction":"Unicode::CaseOptions"}],"return_type":"Nil","visibility":"Public","body":"each_char do |char|\n  char.upcase(options) do |res|\n    io << res\n  end\nend"}},{"html_id":"valid_encoding?:Bool-instance-method","name":"valid_encoding?","doc":"Returns `true` if this String is encoded correctly\naccording to the UTF-8 encoding.","summary":"<p>Returns <code>true</code> if this String is encoded correctly according to the UTF-8 encoding.</p>","abstract":false,"location":{"filename":"src/string.cr","line_number":4891,"url":null},"def":{"name":"valid_encoding?","return_type":"Bool","visibility":"Public","body":"reader = Char::Reader.new(self)\nwhile reader.has_next?\n  if reader.error\n    return false\n  end\n  reader.next_char\nend\ntrue\n"}}],"types":[{"html_id":"Crystal/String/Builder","path":"String/Builder.html","kind":"class","full_name":"String::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},"ancestors":[{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/string/builder.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/String","kind":"class","full_name":"String","name":"String"},"doc":"Similar to `IO::Memory`, but optimized for building a single string.\n\nYou should never have to deal with this class. Instead, use `String.build`.","summary":"<p>Similar to <code><a href=\"../IO/Memory.html\">IO::Memory</a></code>, but optimized for building a single string.</p>","class_methods":[{"html_id":"build(capacity:Int=64,&):String-class-method","name":"build","abstract":false,"args":[{"name":"capacity","default_value":"64","external_name":"capacity","restriction":"Int"}],"args_string":"(capacity : Int = 64, &) : String","args_html":"(capacity : <a href=\"../Int.html\">Int</a> = <span class=\"n\">64</span>, &) : <a href=\"../String.html\">String</a>","location":{"filename":"src/string/builder.cr","line_number":25,"url":null},"def":{"name":"build","args":[{"name":"capacity","default_value":"64","external_name":"capacity","restriction":"Int"}],"yields":1,"return_type":"String","visibility":"Public","body":"builder = new(capacity)\nyield builder\nbuilder.to_s\n"}}],"constructors":[{"html_id":"new(capacity:Int=64)-class-method","name":"new","abstract":false,"args":[{"name":"capacity","default_value":"64","external_name":"capacity","restriction":"Int"}],"args_string":"(capacity : Int = 64)","args_html":"(capacity : <a href=\"../Int.html\">Int</a> = <span class=\"n\">64</span>)","location":{"filename":"src/string/builder.cr","line_number":11,"url":null},"def":{"name":"new","args":[{"name":"capacity","default_value":"64","external_name":"capacity","restriction":"Int"}],"visibility":"Public","body":"_ = allocate\n_.initialize(capacity)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(string:String)-class-method","name":"new","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String)","args_html":"(string : <a href=\"../String.html\">String</a>)","location":{"filename":"src/string/builder.cr","line_number":31,"url":null},"def":{"name":"new","args":[{"name":"string","external_name":"string","restriction":"String"}],"visibility":"Public","body":"io = new(string.bytesize)\nio << string\nio\n"}}],"instance_methods":[{"html_id":"back(amount:Int):Int32-instance-method","name":"back","doc":"Moves the write pointer, and the resulting string bytesize,\nby the given *amount*.","summary":"<p>Moves the write pointer, and the resulting string bytesize, by the given <em>amount</em>.</p>","abstract":false,"args":[{"name":"amount","external_name":"amount","restriction":"Int"}],"args_string":"(amount : Int) : Int32","args_html":"(amount : <a href=\"../Int.html\">Int</a>) : <a href=\"../Int32.html\">Int32</a>","location":{"filename":"src/string/builder.cr","line_number":100,"url":null},"def":{"name":"back","args":[{"name":"amount","external_name":"amount","restriction":"Int"}],"return_type":"Int32","visibility":"Public","body":"if 0 <= amount && amount <= @bytesize\nelse\n  raise(ArgumentError.new(\"Invalid back amount\"))\nend\n@bytesize = @bytesize - amount\n"}},{"html_id":"buffer:Pointer(UInt8)-instance-method","name":"buffer","abstract":false,"location":{"filename":"src/string/builder.cr","line_number":77,"url":null},"def":{"name":"buffer","return_type":"Pointer(UInt8)","visibility":"Public","body":"@buffer + String::HEADER_SIZE"}},{"html_id":"bytesize:Int32-instance-method","name":"bytesize","abstract":false,"location":{"filename":"src/string/builder.cr","line_number":7,"url":null},"def":{"name":"bytesize","return_type":"Int32","visibility":"Public","body":"@bytesize"}},{"html_id":"capacity:Int32-instance-method","name":"capacity","abstract":false,"location":{"filename":"src/string/builder.cr","line_number":8,"url":null},"def":{"name":"capacity","return_type":"Int32","visibility":"Public","body":"@capacity"}},{"html_id":"chomp!(byte:UInt8):self-instance-method","name":"chomp!","doc":"Chomps the last byte from the string buffer.\nIf the byte is `'\\n'` and there's a `'\\r'` before it, it is also removed.","summary":"<p>Chomps the last byte from the string buffer.</p>","abstract":false,"args":[{"name":"byte","external_name":"byte","restriction":"UInt8"}],"args_string":"(byte : UInt8) : self","args_html":"(byte : <a href=\"../UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/string/builder.cr","line_number":87,"url":null},"def":{"name":"chomp!","args":[{"name":"byte","external_name":"byte","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"if bytesize > 0 && (buffer[bytesize - 1] == byte)\n  back(1)\n  if ((byte === '\\n') && bytesize > 0) && (buffer[bytesize - 1] === '\\r')\n    back(1)\n  end\nend\nself\n"}},{"html_id":"empty?:Bool-instance-method","name":"empty?","abstract":false,"location":{"filename":"src/string/builder.cr","line_number":81,"url":null},"def":{"name":"empty?","return_type":"Bool","visibility":"Public","body":"@bytesize == 0"}},{"html_id":"read(slice:Bytes):NoReturn-instance-method","name":"read","doc":"Reads at most *slice.size* bytes from this `IO` into *slice*.\nReturns the number of bytes read, which is 0 if and only if there is no\nmore data to read (so checking for 0 is the way to detect end of file).\n\n```\nio = IO::Memory.new \"hello\"\nslice = Bytes.new(4)\nio.read(slice) # => 4\nslice          # => Bytes[104, 101, 108, 108]\nio.read(slice) # => 1\nslice          # => Bytes[111, 101, 108, 108]\nio.read(slice) # => 0\n```","summary":"<p>Reads at most <em>slice.size</em> bytes from this <code><a href=\"../IO.html\">IO</a></code> into <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : NoReturn","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : NoReturn","location":{"filename":"src/string/builder.cr","line_number":37,"url":null},"def":{"name":"read","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"NoReturn","visibility":"Public","body":"raise(\"Not implemented\")"}},{"html_id":"set_encoding(encoding:String,invalid:Symbol?=nil):Nil-instance-method","name":"set_encoding","doc":"Sets the encoding of this `IO`.\n\nThe *invalid* argument can be:\n* `nil`: an exception is raised on invalid byte sequences\n* `:skip`: invalid byte sequences are ignored\n\nString operations (`gets`, `gets_to_end`, `read_char`, `<<`, `print`, `puts`\n`printf`) will use this encoding.","summary":"<p>Sets the encoding of this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"encoding","external_name":"encoding","restriction":"String"},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":"Symbol | ::Nil"}],"args_string":"(encoding : String, invalid : Symbol? = nil) : Nil","args_html":"(encoding : <a href=\"../String.html\">String</a>, invalid : <a href=\"../Symbol.html\">Symbol</a>? = <span class=\"n\">nil</span>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/string/builder.cr","line_number":71,"url":null},"def":{"name":"set_encoding","args":[{"name":"encoding","external_name":"encoding","restriction":"String"},{"name":"invalid","default_value":"nil","external_name":"invalid","restriction":"Symbol | ::Nil"}],"return_type":"Nil","visibility":"Public","body":"if utf8_encoding?(encoding, invalid)\nelse\n  raise(\"Can't change encoding of String::Builder\")\nend"}},{"html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns a string representation of this object.\n\nDescendants must usually **not** override this method. Instead,\nthey must override `to_s(io)`, which must append to the given\nIO object.","summary":"<p>Returns a string representation of this object.</p>","abstract":false,"location":{"filename":"src/string/builder.cr","line_number":108,"url":null},"def":{"name":"to_s","return_type":"String","visibility":"Public","body":"if @finished\n  raise(\"Can only invoke 'to_s' once on String::Builder\")\nend\n@finished = true\nwrite_byte(0_u8)\nreal_bytesize = real_bytesize()\nif @capacity > real_bytesize\n  resize_to_capacity(real_bytesize)\nend\nheader = @buffer.as(::Pointer(::Tuple(Int32, Int32, Int32)))\nheader.value = {String::TYPE_ID, @bytesize - 1, 0}\n@buffer.as(String)\n"}},{"html_id":"write(slice:Bytes):Nil-instance-method","name":"write","doc":"Writes the contents of *slice* into this `IO`.\n\n```\nio = IO::Memory.new\nslice = Bytes.new(4) { |i| ('a'.ord + i).to_u8 }\nio.write(slice)\nio.to_s # => \"abcd\"\n```","summary":"<p>Writes the contents of <em>slice</em> into this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/string/builder.cr","line_number":41,"url":null},"def":{"name":"write","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"if slice.empty?\n  return\nend\ncount = slice.size\nnew_bytesize = real_bytesize + count\nif new_bytesize > @capacity\n  resize_to_capacity(Math.pw2ceil(new_bytesize))\nend\nslice.copy_to(@buffer + real_bytesize, count)\n@bytesize = @bytesize + count\n"}},{"html_id":"write_byte(byte:UInt8):Nil-instance-method","name":"write_byte","doc":"Writes a single byte into this `IO`.\n\n```\nio = IO::Memory.new\nio.write_byte 97_u8\nio.to_s # => \"a\"\n```","summary":"<p>Writes a single byte into this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"byte","external_name":"byte","restriction":"UInt8"}],"args_string":"(byte : UInt8) : Nil","args_html":"(byte : <a href=\"../UInt8.html\">UInt8</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/string/builder.cr","line_number":54,"url":null},"def":{"name":"write_byte","args":[{"name":"byte","external_name":"byte","restriction":"UInt8"}],"return_type":"Nil","visibility":"Public","body":"new_bytesize = real_bytesize + 1\nif new_bytesize > @capacity\n  resize_to_capacity(Math.pw2ceil(new_bytesize))\nend\n@buffer[real_bytesize] = byte\n@bytesize = @bytesize + 1\nnil\n"}},{"html_id":"write_string(slice:Bytes):Nil-instance-method","name":"write_string","doc":"Writes the contents of *slice*, interpreted as a sequence of UTF-8 or ASCII\ncharacters, into this `IO`. The contents are transcoded into this `IO`'s\ncurrent encoding.\n\n```\nbytes = \"你\".to_slice # => Bytes[228, 189, 160]\n\nio = IO::Memory.new\nio.set_encoding(\"GB2312\")\nio.write_string(bytes)\nio.to_slice # => Bytes[196, 227]\n\n\"你\".encode(\"GB2312\") # => Bytes[196, 227]\n```","summary":"<p>Writes the contents of <em>slice</em>, interpreted as a sequence of UTF-8 or ASCII characters, into this <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : Nil","args_html":"(slice : <a href=\"../Bytes.html\">Bytes</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/string/builder.cr","line_number":67,"url":null},"def":{"name":"write_string","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"Nil","visibility":"Public","body":"write(slice)"}}]},{"html_id":"Crystal/String/Grapheme","path":"String/Grapheme.html","kind":"struct","full_name":"String::Grapheme","name":"Grapheme","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/string/grapheme/grapheme.cr","line_number":108,"url":null},{"filename":"src/string/grapheme/properties.cr","line_number":7,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/String","kind":"class","full_name":"String","name":"String"},"doc":"`Grapheme` represents a Unicode grapheme cluster, which describes the smallest\nfunctional unit of a writing system. This is also called a *user-perceived character*.\n\nIn the latin alphabet, most graphemes consist of a single Unicode codepoint\n(equivalent to `Char`). But a grapheme can also consist of a sequence of codepoints,\nwhich combine into a single unit.\n\nFor example, the string `\"e\\u0301\"` consists of two characters, the latin small letter `e`\nand the combining acute accent `´`. Together, they form a single grapheme: `é`.\nThat same grapheme could alternatively be described in a single codepoint, `\\u00E9` (latin small letter e with acute).\nBut the combinatory possibilities are far bigger than the amount of directly\navailable codepoints.\n\n```\n\"e\\u0301\".size # => 2\n\"é\".size       # => 1\n\n\"e\\u0301\".grapheme_size # => 1\n\"é\".grapheme_size       # => 1\n```\n\nThis combination of codepoints is common in some non-latin scripts. It's also\noften used with emojies to create customized combination. For example, the\nthumbs up sign `👍` (`U+1F44D`) combined with an emoji modifier such as\n`U+1F3FC` assign a colour to the emoji.\n\nInstances of this type can be acquired via `String#each_grapheme` or `String#graphemes`.\n\nThe algorithm to determine boundaries between grapheme clusters is specified\nin the [Unicode Standard Annex #29](https://www.unicode.org/reports/tr29/tr29-37.html#Grapheme_Cluster_Boundaries),\nand implemented in Version Unicode 13.0.0.","summary":"<p><code><a href=\"../String/Grapheme.html\">Grapheme</a></code> represents a Unicode grapheme cluster, which describes the smallest functional unit of a writing system.</p>\n<p><span class=\"flag lime\">EXPERIMENTAL</span>  The grapheme API is still under development. Join the discussion at <a href=\"https://github.com/crystal-lang/crystal/issues/11610\">#11610</a>.</p>","instance_methods":[{"html_id":"==(other:self):Bool-instance-method","name":"==","doc":"Returns `true` if *other* is equivalent to `self`.\n\nTwo graphemes are considered equivalent if they contain the same sequence\nof codepoints.","summary":"<p>Returns <code>true</code> if <em>other</em> is equivalent to <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self) : Bool","args_html":"(other : <span class=\"k\">self</span>) : <a href=\"../Bool.html\">Bool</a>","location":{"filename":"src/string/grapheme/grapheme.cr","line_number":173,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"return_type":"Bool","visibility":"Public","body":"@cluster == (other.@cluster)"}},{"html_id":"bytesize:Int32-instance-method","name":"bytesize","doc":"Returns the number of bytes in the UTF-8 representation of this grapheme cluster.","summary":"<p>Returns the number of bytes in the UTF-8 representation of this grapheme cluster.</p>","abstract":false,"location":{"filename":"src/string/grapheme/grapheme.cr","line_number":165,"url":null},"def":{"name":"bytesize","return_type":"Int32","visibility":"Public","body":"@cluster.bytesize"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a representation of this grapheme cluster to *io*.","summary":"<p>Appends a representation of this grapheme cluster to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/string/grapheme/grapheme.cr","line_number":148,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"String::Grapheme(\"\n@cluster.inspect(io)\nio << \")\"\n"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Returns the number of characters in this grapheme cluster.","summary":"<p>Returns the number of characters in this grapheme cluster.</p>","abstract":false,"location":{"filename":"src/string/grapheme/grapheme.cr","line_number":155,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"case cluster = @cluster\nin Char\n  1\nin String\n  cluster.size\nend"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends the characters in this grapheme cluster to *io*.","summary":"<p>Appends the characters in this grapheme cluster to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/string/grapheme/grapheme.cr","line_number":133,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << @cluster"}},{"html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns the characters in this grapheme cluster.","summary":"<p>Returns the characters in this grapheme cluster.</p>","abstract":false,"location":{"filename":"src/string/grapheme/grapheme.cr","line_number":138,"url":null},"def":{"name":"to_s","return_type":"String","visibility":"Public","body":"case cluster = @cluster\nin Char\n  cluster.to_s\nin String\n  cluster\nend"}}]},{"html_id":"Crystal/String/RawConverter","path":"String/RawConverter.html","kind":"module","full_name":"String::RawConverter","name":"RawConverter","abstract":false,"locations":[{"filename":"src/json/from_json.cr","line_number":434,"url":null},{"filename":"src/json/to_json.cr","line_number":396,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/String","kind":"class","full_name":"String","name":"String"},"doc":"Converter to be used with `JSON::Serializable` to read the raw\nvalue of a JSON object property as a `String`.\n\nIt can be useful to read ints and floats without losing precision,\nor to read an object and deserialize it later based on some\ncondition.\n\n```\nrequire \"json\"\n\nclass Raw\n  include JSON::Serializable\n\n  @[JSON::Field(converter: String::RawConverter)]\n  property value : String\nend\n\nraw = Raw.from_json(%({\"value\": 123456789876543212345678987654321}))\nraw.value   # => \"123456789876543212345678987654321\"\nraw.to_json # => %({\"value\":123456789876543212345678987654321})\n```","summary":"<p>Converter to be used with <code><a href=\"../JSON/Serializable.html\">JSON::Serializable</a></code> to read the raw value of a JSON object property as a <code><a href=\"../String.html\">String</a></code>.</p>","class_methods":[{"html_id":"from_json(value:JSON::PullParser):String-class-method","name":"from_json","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"JSON::PullParser"}],"args_string":"(value : JSON::PullParser) : String","args_html":"(value : <a href=\"../JSON/PullParser.html\">JSON::PullParser</a>) : <a href=\"../String.html\">String</a>","location":{"filename":"src/json/from_json.cr","line_number":435,"url":null},"def":{"name":"from_json","args":[{"name":"value","external_name":"value","restriction":"JSON::PullParser"}],"return_type":"String","visibility":"Public","body":"value.read_raw"}},{"html_id":"to_json(value:String,json:JSON::Builder):Nil-class-method","name":"to_json","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(value : String, json : JSON::Builder) : Nil","args_html":"(value : <a href=\"../String.html\">String</a>, json : <a href=\"../JSON/Builder.html\">JSON::Builder</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":397,"url":null},"def":{"name":"to_json","args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.raw(value)"}}]}]},{"html_id":"Crystal/StringPool","path":"StringPool.html","kind":"class","full_name":"StringPool","name":"StringPool","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/string_pool.cr","line_number":18,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"A string pool is a collection of strings.\nIt allows a runtime to save memory by preserving strings in a pool, allowing to\nreuse an instance of a common string instead of creating a new one.\n\n```\nrequire \"string_pool\"\n\npool = StringPool.new\na = \"foo\" + \"bar\"\nb = \"foo\" + \"bar\"\na.object_id # => 136294360\nb.object_id # => 136294336\na = pool.get(a)\nb = pool.get(b)\na.object_id # => 136294312\nb.object_id # => 136294312\n```","summary":"<p>A string pool is a collection of strings.</p>","constructors":[{"html_id":"new(initial_capacity=8)-class-method","name":"new","doc":"Creates a new empty string pool.\n\nThe *initial_capacity* is useful to avoid unnecessary reallocations\nof the internal buffers in case of growth. If you have an estimate\nof the maximum number of elements the pool will hold it should\nbe initialized with that capacity for improved performance.\n\n```\npool = StringPool.new(256)\npool.size # => 0\n```","summary":"<p>Creates a new empty string pool.</p>","abstract":false,"args":[{"name":"initial_capacity","default_value":"8","external_name":"initial_capacity","restriction":""}],"args_string":"(initial_capacity = 8)","args_html":"(initial_capacity = <span class=\"n\">8</span>)","location":{"filename":"src/string_pool.cr","line_number":46,"url":null},"def":{"name":"new","args":[{"name":"initial_capacity","default_value":"8","external_name":"initial_capacity","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(initial_capacity)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"empty?:Bool-instance-method","name":"empty?","doc":"Returns `true` if the `StringPool` has no element otherwise returns `false`.\n\n```\nrequire \"string_pool\"\n\npool = StringPool.new\npool.empty? # => true\npool.get(\"crystal\")\npool.empty? # => false\n```","summary":"<p>Returns <code>true</code> if the <code><a href=\"StringPool.html\">StringPool</a></code> has no element otherwise returns <code>false</code>.</p>","abstract":false,"location":{"filename":"src/string_pool.cr","line_number":63,"url":null},"def":{"name":"empty?","return_type":"Bool","visibility":"Public","body":"@size == 0"}},{"html_id":"get(str:Pointer(UInt8),len):String-instance-method","name":"get","doc":"Returns a `String` with the contents given by the pointer *str* of size *len*.\n\nIf a string with those contents was already present in the pool, that one is returned.\nOtherwise a new string is created, put in the pool and returned.\n\n```\nrequire \"string_pool\"\n\npool = StringPool.new\npool.get(\"hey\".to_unsafe, 3)\npool.size # => 1\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> with the contents given by the pointer <em>str</em> of size <em>len</em>.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"::Pointer(UInt8)"},{"name":"len","external_name":"len","restriction":""}],"args_string":"(str : Pointer(UInt8), len) : String","args_html":"(str : <a href=\"Pointer.html\">Pointer</a>(<a href=\"UInt8.html\">UInt8</a>), len) : <a href=\"String.html\">String</a>","location":{"filename":"src/string_pool.cr","line_number":98,"url":null},"def":{"name":"get","args":[{"name":"str","external_name":"str","restriction":"::Pointer(UInt8)"},{"name":"len","external_name":"len","restriction":""}],"return_type":"String","visibility":"Public","body":"hash = hash(str, len)\nget(hash, str, len)\n"}},{"html_id":"get(slice:Bytes):String-instance-method","name":"get","doc":"Returns a `String` with the contents of the given *slice*.\n\nIf a string with those contents was already present in the pool, that one is returned.\nOtherwise a new string is created, put in the pool and returned.\n\n```\nrequire \"string_pool\"\n\npool = StringPool.new\nptr = Pointer.malloc(9) { |i| ('a'.ord + i).to_u8 }\nslice = Slice.new(ptr, 3)\npool.empty? # => true\npool.get(slice)\npool.empty? # => false\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> with the contents of the given <em>slice</em>.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"args_string":"(slice : Bytes) : String","args_html":"(slice : <a href=\"Bytes.html\">Bytes</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string_pool.cr","line_number":82,"url":null},"def":{"name":"get","args":[{"name":"slice","external_name":"slice","restriction":"Bytes"}],"return_type":"String","visibility":"Public","body":"get(slice.to_unsafe, slice.size)"}},{"html_id":"get(str:IO::Memory):String-instance-method","name":"get","doc":"Returns a `String` with the contents of the given `IO::Memory`.\n\nIf a string with those contents was already present in the pool, that one is returned.\nOtherwise a new string is created, put in the pool and returned.\n\n```\nrequire \"string_pool\"\n\npool = StringPool.new\nio = IO::Memory.new \"crystal\"\npool.empty? # => true\npool.get(io)\npool.empty? # => false\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> with the contents of the given <code><a href=\"IO/Memory.html\">IO::Memory</a></code>.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"IO::Memory"}],"args_string":"(str : IO::Memory) : String","args_html":"(str : <a href=\"IO/Memory.html\">IO::Memory</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string_pool.cr","line_number":153,"url":null},"def":{"name":"get","args":[{"name":"str","external_name":"str","restriction":"IO::Memory"}],"return_type":"String","visibility":"Public","body":"get(str.buffer, str.bytesize)"}},{"html_id":"get(str:String):String-instance-method","name":"get","doc":"Returns a `String` with the contents of the given string.\n\nIf a string with those contents was already present in the pool, that one is returned.\nOtherwise a new string is created, put in the pool and returned.\n\n```\nrequire \"string_pool\"\n\npool = StringPool.new\nstring = \"crystal\"\npool.empty? # => true\npool.get(string)\npool.empty? # => false\n```","summary":"<p>Returns a <code><a href=\"String.html\">String</a></code> with the contents of the given string.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"String"}],"args_string":"(str : String) : String","args_html":"(str : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/string_pool.cr","line_number":171,"url":null},"def":{"name":"get","args":[{"name":"str","external_name":"str","restriction":"String"}],"return_type":"String","visibility":"Public","body":"get(str.to_unsafe, str.bytesize)"}},{"html_id":"rehash:Nil-instance-method","name":"rehash","doc":"Rebuilds the hash based on the current hash values for each key,\nif values of key objects have changed since they were inserted.\n\nCall this method if you modified a string submitted to the pool.","summary":"<p>Rebuilds the hash based on the current hash values for each key, if values of key objects have changed since they were inserted.</p>","abstract":false,"location":{"filename":"src/string_pool.cr","line_number":179,"url":null},"def":{"name":"rehash","return_type":"Nil","visibility":"Public","body":"if (@capacity * 2) <= 0\n  raise(\"Hash table too big\")\nend\nold_capacity = @capacity\nold_hashes = @hashes\nold_values = @values\n@capacity = @capacity * 2\n@hashes = Pointer(UInt64).malloc(@capacity, 0_u64)\n@values = Pointer(String).malloc(@capacity, \"\")\nold_capacity.times do |i|\n  if old_hashes[i] != 0\n    put_on_rehash(old_hashes[i], old_values[i])\n  end\nend\n"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Returns the size\n\n```\nrequire \"string_pool\"\n\npool = StringPool.new\npool.size # => 0\n```","summary":"<p>Returns the size</p>","abstract":false,"location":{"filename":"src/string_pool.cr","line_number":33,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"@size"}}]},{"html_id":"Crystal/StringScanner","path":"StringScanner.html","kind":"class","full_name":"StringScanner","name":"StringScanner","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/string_scanner.cr","line_number":61,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"`StringScanner` provides for lexical scanning operations on a `String`.\n\n### Example\n\n```\nrequire \"string_scanner\"\n\ns = StringScanner.new(\"This is an example string\")\ns.eos? # => false\n\ns.scan(/\\w+/) # => \"This\"\ns.scan(/\\w+/) # => nil\ns.scan(/\\s+/) # => \" \"\ns.scan(/\\s+/) # => nil\ns.scan(/\\w+/) # => \"is\"\ns.eos?        # => false\n\ns.scan(/\\s+/) # => \" \"\ns.scan(/\\w+/) # => \"an\"\ns.scan(/\\s+/) # => \" \"\ns.scan(/\\w+/) # => \"example\"\ns.scan(/\\s+/) # => \" \"\ns.scan(/\\w+/) # => \"string\"\ns.eos?        # => true\n\ns.scan(/\\s+/) # => nil\ns.scan(/\\w+/) # => nil\n```\n\nScanning a string means remembering the position of a _scan offset_, which is\njust an index. Scanning moves the offset forward, and matches are sought\nafter the offset; usually immediately after it.\n\n### Method Categories\n\nMethods that advance the scan offset:\n* `#scan`\n* `#scan_until`\n* `#skip`\n* `#skip_until`\n\nMethods that look ahead:\n* `#peek`\n* `#check`\n* `#check_until`\n\nMethods that deal with the position of the offset:\n* `#offset`\n* `#offset=`\n* `#eos?`\n* `#reset`\n* `#terminate`\n\nMethods that deal with the last match:\n* `#[]`\n* `#[]?`\n\nMiscellaneous methods:\n* `#inspect`\n* `#string`","summary":"<p><code><a href=\"StringScanner.html\">StringScanner</a></code> provides for lexical scanning operations on a <code><a href=\"String.html\">String</a></code>.</p>","constructors":[{"html_id":"new(str:String)-class-method","name":"new","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"String"}],"args_string":"(str : String)","args_html":"(str : <a href=\"String.html\">String</a>)","location":{"filename":"src/string_scanner.cr","line_number":64,"url":null},"def":{"name":"new","args":[{"name":"str","external_name":"str","restriction":"String"}],"visibility":"Public","body":"_ = allocate\n_.initialize(str)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"[](n):String-instance-method","name":"[]","doc":"Returns the *n*-th subgroup in the most recent match.\n\nRaises an exception if there was no last match or if there is no subgroup.\n\n```\nrequire \"string_scanner\"\n\ns = StringScanner.new(\"Fri Dec 12 1975 14:39\")\nregex = /(?<wday>\\w+) (?<month>\\w+) (?<day>\\d+)/\ns.scan(regex) # => \"Fri Dec 12\"\ns[0]          # => \"Fri Dec 12\"\ns[1]          # => \"Fri\"\ns[2]          # => \"Dec\"\ns[3]          # => \"12\"\ns[\"wday\"]     # => \"Fri\"\ns[\"month\"]    # => \"Dec\"\ns[\"day\"]      # => \"12\"\n```","summary":"<p>Returns the <em>n</em>-th subgroup in the most recent match.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":""}],"args_string":"(n) : String","args_html":"(n) : <a href=\"String.html\">String</a>","location":{"filename":"src/string_scanner.cr","line_number":203,"url":null},"def":{"name":"[]","args":[{"name":"n","external_name":"n","restriction":""}],"return_type":"String","visibility":"Public","body":"@last_match.not_nil![n]"}},{"html_id":"[]?(n):String?-instance-method","name":"[]?","doc":"Returns the nilable *n*-th subgroup in the most recent match.\n\nReturns `nil` if there was no last match or if there is no subgroup.\n\n```\nrequire \"string_scanner\"\n\ns = StringScanner.new(\"Fri Dec 12 1975 14:39\")\nregex = /(?<wday>\\w+) (?<month>\\w+) (?<day>\\d+)/\ns.scan(regex)  # => \"Fri Dec 12\"\ns[0]?          # => \"Fri Dec 12\"\ns[1]?          # => \"Fri\"\ns[2]?          # => \"Dec\"\ns[3]?          # => \"12\"\ns[4]?          # => nil\ns[\"wday\"]?     # => \"Fri\"\ns[\"month\"]?    # => \"Dec\"\ns[\"day\"]?      # => \"12\"\ns[\"year\"]?     # => nil\ns.scan(/more/) # => nil\ns[0]?          # => nil\n```","summary":"<p>Returns the nilable <em>n</em>-th subgroup in the most recent match.</p>","abstract":false,"args":[{"name":"n","external_name":"n","restriction":""}],"args_string":"(n) : String?","args_html":"(n) : <a href=\"String.html\">String</a>?","location":{"filename":"src/string_scanner.cr","line_number":229,"url":null},"def":{"name":"[]?","args":[{"name":"n","external_name":"n","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"@last_match.try(&.[]?(n))"}},{"html_id":"check(pattern):String?-instance-method","name":"check","doc":"Returns the value that `#scan` would return, without advancing the scan\noffset. The last match is still saved, however.\n\n```\nrequire \"string_scanner\"\n\ns = StringScanner.new(\"this is a string\")\ns.offset = 5\ns.check(/\\w+/) # => \"is\"\ns.check(/\\w+/) # => \"is\"\n```","summary":"<p>Returns the value that <code><a href=\"StringScanner.html#scan%28pattern%29%3AString%3F-instance-method\">#scan</a></code> would return, without advancing the scan offset.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : String?","args_html":"(pattern) : <a href=\"String.html\">String</a>?","location":{"filename":"src/string_scanner.cr","line_number":167,"url":null},"def":{"name":"check","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"match(pattern, advance: false, options: Regex::Options::ANCHORED)"}},{"html_id":"check_until(pattern):String?-instance-method","name":"check_until","doc":"Returns the value that `#scan_until` would return, without advancing the\nscan offset. The last match is still saved, however.\n\n```\nrequire \"string_scanner\"\n\ns = StringScanner.new(\"test string\")\ns.check_until(/tr/) # => \"test str\"\ns.check_until(/g/)  # => \"test string\"\n```","summary":"<p>Returns the value that <code><a href=\"StringScanner.html#scan_until%28pattern%29%3AString%3F-instance-method\">#scan_until</a></code> would return, without advancing the scan offset.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : String?","args_html":"(pattern) : <a href=\"String.html\">String</a>?","location":{"filename":"src/string_scanner.cr","line_number":181,"url":null},"def":{"name":"check_until","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"match(pattern, advance: false, options: Regex::Options::None)"}},{"html_id":"eos?:Bool-instance-method","name":"eos?","doc":"Returns `true` if the scan offset is at the end of the string.\n\n```\nrequire \"string_scanner\"\n\ns = StringScanner.new(\"this is a string\")\ns.eos?                # => false\ns.scan(/(\\w+\\s?){4}/) # => \"this is a string\"\ns.eos?                # => true\n```","summary":"<p>Returns <code>true</code> if the scan offset is at the end of the string.</p>","abstract":false,"location":{"filename":"src/string_scanner.cr","line_number":243,"url":null},"def":{"name":"eos?","return_type":"Bool","visibility":"Public","body":"@byte_offset >= @str.bytesize"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Writes a representation of the scanner.\n\nIncludes the current position of the offset, the total size of the string,\nand five characters near the current position.","summary":"<p>Writes a representation of the scanner.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/string_scanner.cr","line_number":287,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"#<StringScanner \"\noffset = offset()\n((io << offset) << '/') << @str.size\nstart = Math.min(Math.max(offset - 2, 0), Math.max(0, @str.size - 5))\n((io << \" \\\"\") << @str[start, 5]) << \"\\\" >\"\n"}},{"html_id":"offset:Int32-instance-method","name":"offset","doc":"Returns the current position of the scan offset.","summary":"<p>Returns the current position of the scan offset.</p>","abstract":false,"location":{"filename":"src/string_scanner.cr","line_number":75,"url":null},"def":{"name":"offset","return_type":"Int32","visibility":"Public","body":"(@str.byte_index_to_char_index(@byte_offset)).not_nil!"}},{"html_id":"offset=(position:Int)-instance-method","name":"offset=","doc":"Sets the *position* of the scan offset.","summary":"<p>Sets the <em>position</em> of the scan offset.</p>","abstract":false,"args":[{"name":"position","external_name":"position","restriction":"Int"}],"args_string":"(position : Int)","args_html":"(position : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/string_scanner.cr","line_number":69,"url":null},"def":{"name":"offset=","args":[{"name":"position","external_name":"position","restriction":"Int"}],"visibility":"Public","body":"if position >= 0\nelse\n  raise(IndexError.new)\nend\n@byte_offset = (@str.char_index_to_byte_index(position)) || @str.bytesize\n"}},{"html_id":"peek(len):String-instance-method","name":"peek","doc":"Extracts a string corresponding to string[offset,*len*], without advancing\nthe scan offset.","summary":"<p>Extracts a string corresponding to string[offset,<em>len</em>], without advancing the scan offset.</p>","abstract":false,"args":[{"name":"len","external_name":"len","restriction":""}],"args_string":"(len) : String","args_html":"(len) : <a href=\"String.html\">String</a>","location":{"filename":"src/string_scanner.cr","line_number":266,"url":null},"def":{"name":"peek","args":[{"name":"len","external_name":"len","restriction":""}],"return_type":"String","visibility":"Public","body":"@str[offset, len]"}},{"html_id":"reset-instance-method","name":"reset","doc":"Resets the scan offset to the beginning and clears the last match.","summary":"<p>Resets the scan offset to the beginning and clears the last match.</p>","abstract":false,"location":{"filename":"src/string_scanner.cr","line_number":248,"url":null},"def":{"name":"reset","visibility":"Public","body":"@last_match = nil\n@byte_offset = 0\n"}},{"html_id":"rest:String-instance-method","name":"rest","doc":"Returns the remainder of the string after the scan offset.\n\n```\nrequire \"string_scanner\"\n\ns = StringScanner.new(\"this is a string\")\ns.scan(/(\\w+\\s?){2}/) # => \"this is \"\ns.rest                # => \"a string\"\n```","summary":"<p>Returns the remainder of the string after the scan offset.</p>","abstract":false,"location":{"filename":"src/string_scanner.cr","line_number":279,"url":null},"def":{"name":"rest","return_type":"String","visibility":"Public","body":"@str.byte_slice(@byte_offset, @str.bytesize - @byte_offset)"}},{"html_id":"scan(pattern):String?-instance-method","name":"scan","doc":"Tries to match with *pattern* at the current position. If there's a match,\nthe scanner advances the scan offset, the last match is saved, and it\nreturns the matched string. Otherwise, the scanner returns `nil`.\n\n```\nrequire \"string_scanner\"\n\ns = StringScanner.new(\"test string\")\ns.scan(/\\w+/)   # => \"test\"\ns.scan(/\\w+/)   # => nil\ns.scan(/\\s\\w+/) # => \" string\"\ns.scan(/.*/)    # => \"\"\n```","summary":"<p>Tries to match with <em>pattern</em> at the current position.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : String?","args_html":"(pattern) : <a href=\"String.html\">String</a>?","location":{"filename":"src/string_scanner.cr","line_number":92,"url":null},"def":{"name":"scan","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"match(pattern, advance: true, options: Regex::Options::ANCHORED)"}},{"html_id":"scan_until(pattern):String?-instance-method","name":"scan_until","doc":"Scans the string _until_ the *pattern* is matched. Returns the substring up\nto and including the end of the match, the last match is saved, and\nadvances the scan offset. Returns `nil` if no match.\n\n```\nrequire \"string_scanner\"\n\ns = StringScanner.new(\"test string\")\ns.scan_until(/tr/) # => \"test str\"\ns.scan_until(/tr/) # => nil\ns.scan_until(/g/)  # => \"ing\"\n```","summary":"<p>Scans the string <em>until</em> the <em>pattern</em> is matched.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : String?","args_html":"(pattern) : <a href=\"String.html\">String</a>?","location":{"filename":"src/string_scanner.cr","line_number":108,"url":null},"def":{"name":"scan_until","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"match(pattern, advance: true, options: Regex::Options::None)"}},{"html_id":"skip(pattern):Int32?-instance-method","name":"skip","doc":"Attempts to skip over the given *pattern* beginning with the scan offset.\nIn other words, the pattern is not anchored to the current scan offset.\n\nIf there's a match, the scanner advances the scan offset, the last match is\nsaved, and it returns the size of the skipped match. Otherwise it returns\n`nil` and does not advance the offset.\n\nThis method is the same as `#scan`, but without returning the matched\nstring.","summary":"<p>Attempts to skip over the given <em>pattern</em> beginning with the scan offset.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : Int32?","args_html":"(pattern) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/string_scanner.cr","line_number":135,"url":null},"def":{"name":"skip","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"match = scan(pattern)\nif match\n  match.size\nend\n"}},{"html_id":"skip_until(pattern):Int32?-instance-method","name":"skip_until","doc":"Attempts to skip _until_ the given *pattern* is found after the scan\noffset. In other words, the pattern is not anchored to the current scan\noffset.\n\nIf there's a match, the scanner advances the scan offset, the last match is\nsaved, and it returns the size of the skip. Otherwise it returns `nil`\nand does not advance the\noffset.\n\nThis method is the same as `#scan_until`, but without returning the matched\nstring.","summary":"<p>Attempts to skip <em>until</em> the given <em>pattern</em> is found after the scan offset.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":""}],"args_string":"(pattern) : Int32?","args_html":"(pattern) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/string_scanner.cr","line_number":151,"url":null},"def":{"name":"skip_until","args":[{"name":"pattern","external_name":"pattern","restriction":""}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"match = scan_until(pattern)\nif match\n  match.size\nend\n"}},{"html_id":"string:String-instance-method","name":"string","doc":"Returns the string being scanned.","summary":"<p>Returns the string being scanned.</p>","abstract":false,"location":{"filename":"src/string_scanner.cr","line_number":260,"url":null},"def":{"name":"string","return_type":"String","visibility":"Public","body":"@str"}},{"html_id":"terminate-instance-method","name":"terminate","doc":"Moves the scan offset to the end of the string and clears the last match.","summary":"<p>Moves the scan offset to the end of the string and clears the last match.</p>","abstract":false,"location":{"filename":"src/string_scanner.cr","line_number":254,"url":null},"def":{"name":"terminate","visibility":"Public","body":"@last_match = nil\n@byte_offset = @str.bytesize\n"}}]},{"html_id":"Crystal/Struct","path":"Struct.html","kind":"struct","full_name":"Struct","name":"Struct","abstract":true,"superclass":{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/struct.cr","line_number":45,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/Atomic","kind":"struct","full_name":"Atomic(T)","name":"Atomic"},{"html_id":"Crystal/Atomic/Flag","kind":"struct","full_name":"Atomic::Flag","name":"Flag"},{"html_id":"Crystal/BitArray","kind":"struct","full_name":"BitArray","name":"BitArray"},{"html_id":"Crystal/Char/Reader","kind":"struct","full_name":"Char::Reader","name":"Reader"},{"html_id":"Crystal/Colorize/Color256","kind":"struct","full_name":"Colorize::Color256","name":"Color256"},{"html_id":"Crystal/Colorize/ColorRGB","kind":"struct","full_name":"Colorize::ColorRGB","name":"ColorRGB"},{"html_id":"Crystal/Colorize/Object","kind":"struct","full_name":"Colorize::Object(T)","name":"Object"},{"html_id":"Crystal/Complex","kind":"struct","full_name":"Complex","name":"Complex"},{"html_id":"Crystal/CSV/Builder/Row","kind":"struct","full_name":"CSV::Builder::Row","name":"Row"},{"html_id":"Crystal/CSV/Row","kind":"struct","full_name":"CSV::Row","name":"Row"},{"html_id":"Crystal/CSV/Token","kind":"struct","full_name":"CSV::Token","name":"Token"},{"html_id":"Crystal/Enumerable/Chunk/Alone","kind":"struct","full_name":"Enumerable::Chunk::Alone","name":"Alone"},{"html_id":"Crystal/Enumerable/Chunk/Drop","kind":"struct","full_name":"Enumerable::Chunk::Drop","name":"Drop"},{"html_id":"Crystal/File/Info","kind":"struct","full_name":"File::Info","name":"Info"},{"html_id":"Crystal/GC/ProfStats","kind":"struct","full_name":"GC::ProfStats","name":"ProfStats"},{"html_id":"Crystal/GC/Stats","kind":"struct","full_name":"GC::Stats","name":"Stats"},{"html_id":"Crystal/Hash/Entry","kind":"struct","full_name":"Hash::Entry(K, V)","name":"Entry"},{"html_id":"Crystal/HTTP/FormData/FileMetadata","kind":"struct","full_name":"HTTP::FormData::FileMetadata","name":"FileMetadata"},{"html_id":"Crystal/HTTP/FormData/Part","kind":"struct","full_name":"HTTP::FormData::Part","name":"Part"},{"html_id":"Crystal/HTTP/Headers","kind":"struct","full_name":"HTTP::Headers","name":"Headers"},{"html_id":"Crystal/HTTP/StaticFileHandler/DirectoryListing","kind":"struct","full_name":"HTTP::StaticFileHandler::DirectoryListing","name":"DirectoryListing"},{"html_id":"Crystal/IO/EncodingOptions","kind":"struct","full_name":"IO::EncodingOptions","name":"EncodingOptions"},{"html_id":"Crystal/JSON/Any","kind":"struct","full_name":"JSON::Any","name":"Any"},{"html_id":"Crystal/JSON/Builder/ArrayState","kind":"struct","full_name":"JSON::Builder::ArrayState","name":"ArrayState"},{"html_id":"Crystal/JSON/Builder/DocumentEndState","kind":"struct","full_name":"JSON::Builder::DocumentEndState","name":"DocumentEndState"},{"html_id":"Crystal/JSON/Builder/DocumentStartState","kind":"struct","full_name":"JSON::Builder::DocumentStartState","name":"DocumentStartState"},{"html_id":"Crystal/JSON/Builder/ObjectState","kind":"struct","full_name":"JSON::Builder::ObjectState","name":"ObjectState"},{"html_id":"Crystal/JSON/Builder/StartState","kind":"struct","full_name":"JSON::Builder::StartState","name":"StartState"},{"html_id":"Crystal/LLVM/ABI/ArgType","kind":"struct","full_name":"LLVM::ABI::ArgType","name":"ArgType"},{"html_id":"Crystal/LLVM/BasicBlock","kind":"struct","full_name":"LLVM::BasicBlock","name":"BasicBlock"},{"html_id":"Crystal/LLVM/BasicBlockCollection","kind":"struct","full_name":"LLVM::BasicBlockCollection","name":"BasicBlockCollection"},{"html_id":"Crystal/LLVM/DIBuilder","kind":"struct","full_name":"LLVM::DIBuilder","name":"DIBuilder"},{"html_id":"Crystal/LLVM/Function","kind":"struct","full_name":"LLVM::Function","name":"Function"},{"html_id":"Crystal/LLVM/FunctionCollection","kind":"struct","full_name":"LLVM::FunctionCollection","name":"FunctionCollection"},{"html_id":"Crystal/LLVM/FunctionPassManager/Runner","kind":"struct","full_name":"LLVM::FunctionPassManager::Runner","name":"Runner"},{"html_id":"Crystal/LLVM/GlobalCollection","kind":"struct","full_name":"LLVM::GlobalCollection","name":"GlobalCollection"},{"html_id":"Crystal/LLVM/InstructionCollection","kind":"struct","full_name":"LLVM::InstructionCollection","name":"InstructionCollection"},{"html_id":"Crystal/LLVM/Metadata","kind":"struct","full_name":"LLVM::Metadata","name":"Metadata"},{"html_id":"Crystal/LLVM/OperandBundleDef","kind":"struct","full_name":"LLVM::OperandBundleDef","name":"OperandBundleDef"},{"html_id":"Crystal/LLVM/ParameterCollection","kind":"struct","full_name":"LLVM::ParameterCollection","name":"ParameterCollection"},{"html_id":"Crystal/LLVM/PassRegistry","kind":"struct","full_name":"LLVM::PassRegistry","name":"PassRegistry"},{"html_id":"Crystal/LLVM/PhiTable","kind":"struct","full_name":"LLVM::PhiTable","name":"PhiTable"},{"html_id":"Crystal/LLVM/Target","kind":"struct","full_name":"LLVM::Target","name":"Target"},{"html_id":"Crystal/LLVM/TargetData","kind":"struct","full_name":"LLVM::TargetData","name":"TargetData"},{"html_id":"Crystal/LLVM/Type","kind":"struct","full_name":"LLVM::Type","name":"Type"},{"html_id":"Crystal/LLVM/Value","kind":"struct","full_name":"LLVM::Value","name":"Value"},{"html_id":"Crystal/Log/Context","kind":"struct","full_name":"Log::Context","name":"Context"},{"html_id":"Crystal/Log/Emitter","kind":"struct","full_name":"Log::Emitter","name":"Emitter"},{"html_id":"Crystal/Log/Entry","kind":"struct","full_name":"Log::Entry","name":"Entry"},{"html_id":"Crystal/Log/Metadata/Value","kind":"struct","full_name":"Log::Metadata::Value","name":"Value"},{"html_id":"Crystal/Log/StaticFormatter","kind":"struct","full_name":"Log::StaticFormatter","name":"StaticFormatter"},{"html_id":"Crystal/MIME/MediaType","kind":"struct","full_name":"MIME::MediaType","name":"MediaType"},{"html_id":"Crystal/Path","kind":"struct","full_name":"Path","name":"Path"},{"html_id":"Crystal/Pointer/Appender","kind":"struct","full_name":"Pointer::Appender(T)","name":"Appender"},{"html_id":"Crystal/Process/Tms","kind":"struct","full_name":"Process::Tms","name":"Tms"},{"html_id":"Crystal/Range","kind":"struct","full_name":"Range(B, E)","name":"Range"},{"html_id":"Crystal/Regex/MatchData","kind":"struct","full_name":"Regex::MatchData","name":"MatchData"},{"html_id":"Crystal/SemanticVersion","kind":"struct","full_name":"SemanticVersion","name":"SemanticVersion"},{"html_id":"Crystal/SemanticVersion/Prerelease","kind":"struct","full_name":"SemanticVersion::Prerelease","name":"Prerelease"},{"html_id":"Crystal/Set","kind":"struct","full_name":"Set(T)","name":"Set"},{"html_id":"Crystal/Slice","kind":"struct","full_name":"Slice(T)","name":"Slice"},{"html_id":"Crystal/Socket/Address","kind":"struct","full_name":"Socket::Address","name":"Address"},{"html_id":"Crystal/Socket/Addrinfo","kind":"struct","full_name":"Socket::Addrinfo","name":"Addrinfo"},{"html_id":"Crystal/Spec/Example/Procsy","kind":"struct","full_name":"Spec::Example::Procsy","name":"Procsy"},{"html_id":"Crystal/Spec/ExampleGroup/Procsy","kind":"struct","full_name":"Spec::ExampleGroup::Procsy","name":"Procsy"},{"html_id":"Crystal/Spec/SplitFilter","kind":"struct","full_name":"Spec::SplitFilter","name":"SplitFilter"},{"html_id":"Crystal/String/Grapheme","kind":"struct","full_name":"String::Grapheme","name":"Grapheme"},{"html_id":"Crystal/Time","kind":"struct","full_name":"Time","name":"Time"},{"html_id":"Crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},{"html_id":"Crystal/Time/Location/Zone","kind":"struct","full_name":"Time::Location::Zone","name":"Zone"},{"html_id":"Crystal/Time/MonthSpan","kind":"struct","full_name":"Time::MonthSpan","name":"MonthSpan"},{"html_id":"Crystal/Time/Span","kind":"struct","full_name":"Time::Span","name":"Span"},{"html_id":"Crystal/URI/Params","kind":"struct","full_name":"URI::Params","name":"Params"},{"html_id":"Crystal/UUID","kind":"struct","full_name":"UUID","name":"UUID"},{"html_id":"Crystal/VaList","kind":"struct","full_name":"VaList","name":"VaList"},{"html_id":"Crystal/YAML/Any","kind":"struct","full_name":"YAML::Any","name":"Any"}],"doc":"`Struct` is the base type of structs you create in your program.\nIt is set as a struct's superstruct when you don't specify one:\n\n```\nstruct Foo # < Struct\nend\n```\n\nStructs inherit from `Value` so they are allocated on the stack and passed\nby value. For this reason you should prefer using structs for immutable\ndata types and/or stateless wrappers of other types.\n\nMutable structs are still allowed, but code involving them must remember\nthat passing a struct to a method actually passes a copy to it, so the\nmethod should return the modified struct:\n\n```\nstruct Mutable\n  property value\n\n  def initialize(@value : Int32)\n  end\nend\n\ndef change_bad(mutable)\n  mutable.value = 2\nend\n\ndef change_good(mutable)\n  mutable.value = 2\n  mutable\nend\n\nmut = Mutable.new 1\nchange_bad(mut)\nmut.value # => 1\n\nmut = change_good(mut)\nmut.value # => 2\n```\n\nThe standard library provides a useful `record` macro that allows you to\ncreate immutable structs with some fields, similar to a `Tuple` but using\nnames instead of indices.","summary":"<p><code><a href=\"Struct.html\">Struct</a></code> is the base type of structs you create in your program.</p>","instance_methods":[{"html_id":"==(other):Bool-instance-method","name":"==","doc":"Returns `true` if this struct is equal to *other*.\n\nBoth structs' instance vars are compared to each other. Thus, two\nstructs are considered equal if each of their instance variables are\nequal. Subclasses should override this method to provide specific\nequality semantics.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np2 = Point.new 1, 2\np3 = Point.new 3, 4\n\np1 == p2 # => true\np1 == p3 # => false\n```","summary":"<p>Returns <code>true</code> if this struct is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other) : Bool","args_html":"(other) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/struct.cr","line_number":66,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":""}],"return_type":"Bool","visibility":"Public","body":"if other.is_a?(self)\n  {% for ivar in @type.instance_vars %}\n        return false unless @{{ ivar.id }} == other.@{{ ivar.id }}\n      {% end %}\n  return true\nelse\n  return false\nend"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/struct.cr","line_number":79,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"{% for ivar in @type.instance_vars %}\n      hasher = @{{ ivar.id }}.hash(hasher)\n    {% end %}\nhasher\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends this struct's name and instance variables names and values\nto the given IO.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np1.to_s    # \"Point(@x=1, @y=2)\"\np1.inspect # \"Point(@x=1, @y=2)\"\n```","summary":"<p>Appends this struct's name and instance variables names and values to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/struct.cr","line_number":99,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"(io << ({{ @type.name.id.stringify }})) << '('\n{% for ivar, i in @type.instance_vars %}\n      {% if i > 0 %}\n        io << \", \"\n      {% end %}\n      io << \"@{{ ivar.id }}=\"\n      @{{ ivar.id }}.inspect(io)\n    {% end %}\nio << ')'\n"}},{"html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","args_html":"(pp) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/struct.cr","line_number":111,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"return_type":"Nil","visibility":"Public","body":"{% if @type.overrides?(Struct, \"inspect\") %}\n      pp.text inspect\n    {% else %}\n      prefix = \"#{{{ @type.name.id.stringify }}}(\"\n      pp.surround(prefix, \")\", left_break: \"\", right_break: nil) do\n        {% for ivar, i in @type.instance_vars.map(&.name).sort %}\n          {% if i > 0 %}\n            pp.comma\n          {% end %}\n          pp.group do\n            pp.text \"@{{ ivar.id }}=\"\n            pp.nest do\n              pp.breakable \"\"\n              @{{ ivar.id }}.pretty_print(pp)\n            end\n          end\n        {% end %}\n      end\n    {% end %}"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Same as `#inspect(io)`.","summary":"<p>Same as <code><a href=\"Struct.html#inspect%28io%3AIO%29%3ANil-instance-method\">#inspect(io)</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/struct.cr","line_number":134,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"inspect(io)"}}]},{"html_id":"Crystal/Symbol","path":"Symbol.html","kind":"struct","full_name":"Symbol","name":"Symbol","abstract":false,"superclass":{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/to_json.cr","line_number":83,"url":null},{"filename":"src/primitives.cr","line_number":108,"url":null},{"filename":"src/symbol.cr","line_number":17,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":118,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"doc":"A symbol is a constant that is identified by a name without you having to give\nit a numeric value.\n\n```\n:hello\n:welcome\n:\"123\"\n:\"symbol with spaces\"\n```\n\nSee [`Symbol` literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/symbol.html) in the language reference.\n\nInternally a symbol is represented as an `Int32`, so it's very efficient.\n\nYou can't dynamically create symbols. When you compile your program, each symbol\ngets assigned a unique number.","summary":"<p>A symbol is a constant that is identified by a name without you having to give it a numeric value.</p>","class_methods":[{"html_id":"needs_quotes?(string):Bool-class-method","name":"needs_quotes?","doc":"Determines if a string needs to be quoted to be used for a symbol literal.\n\n```\nSymbol.needs_quotes? \"string\"      # => false\nSymbol.needs_quotes? \"long string\" # => true\n```","summary":"<p>Determines if a string needs to be quoted to be used for a symbol literal.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""}],"args_string":"(string) : Bool","args_html":"(string) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/symbol.cr","line_number":65,"url":null},"def":{"name":"needs_quotes?","args":[{"name":"string","external_name":"string","restriction":""}],"return_type":"Bool","visibility":"Public","body":"case string\nwhen \"+\", \"-\", \"*\", \"&+\", \"&-\", \"&*\", \"/\", \"//\", \"==\", \"<\", \"<=\", \">\", \">=\", \"!\", \"!=\", \"=~\", \"!~\"\n  false\nwhen \"&\", \"|\", \"^\", \"~\", \"**\", \"&**\", \">>\", \"<<\", \"%\", \"[]\", \"<=>\", \"===\", \"[]?\", \"[]=\"\n  false\nwhen \"_\"\n  false\nelse\n  needs_quotes_for_named_argument?(string)\nend"}}],"instance_methods":[{"html_id":"!=(other:Symbol):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Symbol"}],"args_string":"(other : Symbol) : Bool","args_html":"(other : <a href=\"Symbol.html\">Symbol</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":116,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Symbol"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=>(other:Symbol)-instance-method","name":"<=>","doc":"Compares symbol with other based on `String#<=>` method.\nReturns `-1`, `0` or `1` depending on whether symbol is less than, equal to,\nor greater than *other*.\n\nSee `String#<=>` for more information.","summary":"<p>Compares symbol with other based on <code><a href=\"String.html#%3C%3D%3E%28other%3Aself%29-instance-method\">String#<=></a></code> method.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Symbol"}],"args_string":"(other : Symbol)","args_html":"(other : <a href=\"Symbol.html\">Symbol</a>)","location":{"filename":"src/symbol.cr","line_number":30,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Symbol"}],"visibility":"Public","body":"to_s <=> other.to_s"}},{"html_id":"==(other:Symbol):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Symbol"}],"args_string":"(other : Symbol) : Bool","args_html":"(other : <a href=\"Symbol.html\">Symbol</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":111,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Symbol"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/symbol.cr","line_number":102,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/symbol.cr","line_number":21,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher.symbol(self)"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Returns the symbol literal representation as a string.\n\n```\n:crystal.inspect # => \":crystal\"\n```","summary":"<p>Returns the symbol literal representation as a string.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/symbol.cr","line_number":39,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << ':'\nvalue = to_s\nif Symbol.needs_quotes?(value)\n  value.inspect(io)\nelse\n  value.to_s(io)\nend\n"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns a unique number for this symbol.","summary":"<p>Returns a unique number for this symbol.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":121,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":84,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.string(to_s)"}},{"html_id":"to_json_object_key:String-instance-method","name":"to_json_object_key","abstract":false,"location":{"filename":"src/json/to_json.cr","line_number":88,"url":null},"def":{"name":"to_json_object_key","return_type":"String","visibility":"Public","body":"to_s"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends the symbol's name to the passed `IO`.\n\n```\n:crystal.to_s # => \"crystal\"\n```","summary":"<p>Appends the symbol's name to the passed <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/symbol.cr","line_number":55,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << to_s"}},{"html_id":"to_s:String-instance-method","name":"to_s","doc":"Returns the symbol's name as a String.\n\n```\n:foo.to_s           # => \"foo\"\n:\"hello world\".to_s # => \"hello world\"\n```","summary":"<p>Returns the symbol's name as a String.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":131,"url":null},"def":{"name":"to_s","return_type":"String","visibility":"Public","body":"# primitive: symbol_to_s"}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder) : Nil","args_html":"(yaml : <a href=\"YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":119,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"yaml.scalar(self)"}}]},{"html_id":"Crystal/Syscall","path":"Syscall.html","kind":"module","full_name":"Syscall","name":"Syscall","abstract":false,"locations":[{"filename":"src/syscall.cr","line_number":9,"url":null},{"filename":"src/syscall/x86_64-linux.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"summary":"<p><span class=\"flag lime\">EXPERIMENTAL</span> </p>","macros":[{"html_id":"def_syscall(name,return_type,*args)-macro","name":"def_syscall","doc":"To define system calls open a module and use the `def_syscall` macro. Pass in the system call name,\nthe return type and its arguments. For example:\n\n```\nmodule YourSyscalls\n  Syscall.def_syscall pipe2, Int32, pipefd : Int32[2]*, flags : Int32\n  Syscall.def_syscall write, Int32, fd : Int32, buf : UInt8*, count : LibC::SizeT\n  Syscall.def_syscall read, Int32, fd : Int32, buf : UInt8*, count : LibC::SizeT\n  Syscall.def_syscall close, Int32, fd : Int32\nend\n```\n\nThey can then be called as methods from the `Syscall` module:\n\n```\nYourSyscalls.write(1, \"Hello!\\n\".to_unsafe, 7)\n```","summary":"<p>To define system calls open a module and use the <code><a href=\"Syscall.html#def_syscall%28name%2Creturn_type%2C%2Aargs%29-macro\">def_syscall</a></code> macro.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"return_type","external_name":"return_type","restriction":""},{"name":"args","external_name":"args","restriction":""}],"args_string":"(name, return_type, *args)","args_html":"(name, return_type, *args)","location":{"filename":"src/syscall/x86_64-linux.cr","line_number":370,"url":null},"def":{"name":"def_syscall","args":[{"name":"name","external_name":"name","restriction":""},{"name":"return_type","external_name":"return_type","restriction":""},{"name":"args","external_name":"args","restriction":""}],"splat_index":2,"visibility":"Public","body":"    @[AlwaysInline]\n    def self.\n{{ name.id }}\n(\n{{ *args }}\n) : \n{{ return_type }}\n\n      ret = uninitialized \n{{ return_type }}\n\n\n      \n{% if args.size == 0 %}\n        asm(\"syscall\" : \"={rax}\"(ret)\n                      : \"{rax}\"(::Syscall::Code::{{ name.stringify.upcase.id }})\n                      : \"rcx\", \"r11\", \"memory\"\n                      : \"volatile\")\n      {% else %}{% if args.size == 1 %}\n        asm(\"syscall\" : \"={rax}\"(ret)\n                      : \"{rax}\"(::Syscall::Code::{{ name.stringify.upcase.id }}), \"{rdi}\"({{ args[0].var.id }})\n                      : \"rcx\", \"r11\", \"memory\"\n                      : \"volatile\")\n      {% else %}{% if args.size == 2 %}\n        asm(\"syscall\" : \"={rax}\"(ret)\n                      : \"{rax}\"(::Syscall::Code::{{ name.stringify.upcase.id }}), \"{rdi}\"({{ args[0].var.id }}), \"{rsi}\"({{ args[1].var.id }})\n                      : \"rcx\", \"r11\", \"memory\"\n                      : \"volatile\")\n      {% else %}{% if args.size == 3 %}\n        asm(\"syscall\" : \"={rax}\"(ret)\n                      : \"{rax}\"(::Syscall::Code::{{ name.stringify.upcase.id }}), \"{rdi}\"({{ args[0].var.id }}), \"{rsi}\"({{ args[1].var.id }}),\n                        \"{rdx}\"({{ args[2].var.id }})\n                      : \"rcx\", \"r11\", \"memory\"\n                      : \"volatile\")\n      {% else %}{% if args.size == 4 %}\n        asm(\"syscall\" : \"={rax}\"(ret)\n                      : \"{rax}\"(::Syscall::Code::{{ name.stringify.upcase.id }}), \"{rdi}\"({{ args[0].var.id }}), \"{rsi}\"({{ args[1].var.id }}),\n                        \"{rdx}\"({{ args[2].var.id }}), \"{r10}\"({{ args[3].var.id }})\n                      : \"rcx\", \"r11\", \"memory\"\n                      : \"volatile\")\n      {% else %}{% if args.size == 5 %}\n        asm(\"syscall\" : \"={rax}\"(ret)\n                      : \"{rax}\"(::Syscall::Code::{{ name.stringify.upcase.id }}), \"{rdi}\"({{ args[0].var.id }}), \"{rsi}\"({{ args[1].var.id }}),\n                        \"{rdx}\"({{ args[2].var.id }}), \"{r10}\"({{ args[3].var.id }}), \"{r8}\"({{ args[4].var.id }})\n                      : \"rcx\", \"r11\", \"memory\"\n                      : \"volatile\")\n      {% else %}{% if args.size == 6 %}\n        asm(\"syscall\" : \"={rax}\"(ret)\n                      : \"{rax}\"(::Syscall::Code::{{ name.stringify.upcase.id }}), \"{rdi}\"({{ args[0].var.id }}), \"{rsi}\"({{ args[1].var.id }}),\n                        \"{rdx}\"({{ args[2].var.id }}), \"{r10}\"({{ args[3].var.id }}), \"{r8}\"({{ args[4].var.id }}), \"{r9}\"({{ args[5].var.id }})\n                      : \"rcx\", \"r11\", \"memory\"\n                      : \"volatile\")\n      {% else %}\n        {% raise(\"Not supported number of arguments for syscall\") %}\n      {% end %}{% end %}{% end %}{% end %}{% end %}{% end %}{% end %}\n\n\n      ret\n    \nend\n  \n"}}]},{"html_id":"Crystal/System","path":"System.html","kind":"module","full_name":"System","name":"System","abstract":false,"locations":[{"filename":"src/system.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"class_methods":[{"html_id":"cpu_count:Int-class-method","name":"cpu_count","doc":"Returns the number of logical processors available to the system.\n\n```\nSystem.cpu_count # => 4\n```","summary":"<p>Returns the number of logical processors available to the system.</p>","abstract":false,"location":{"filename":"src/system.cr","line_number":22,"url":null},"def":{"name":"cpu_count","return_type":"Int","visibility":"Public","body":"Crystal::System.cpu_count"}},{"html_id":"hostname:String-class-method","name":"hostname","doc":"Returns the hostname.\n\nNOTE: Maximum of 253 characters are allowed, with 2 bytes reserved for\nstorage.\nIn practice, many platforms will disallow anything longer than 63 characters.\n\n```\nSystem.hostname # => \"host.example.org\"\n```","summary":"<p>Returns the hostname.</p>","abstract":false,"location":{"filename":"src/system.cr","line_number":13,"url":null},"def":{"name":"hostname","return_type":"String","visibility":"Public","body":"Crystal::System.hostname"}}],"types":[{"html_id":"Crystal/System/Group","path":"System/Group.html","kind":"class","full_name":"System::Group","name":"Group","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/system/group.cr","line_number":13,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"extended_modules":[{"html_id":"Crystal/Crystal/System/Group","kind":"module","full_name":"Crystal::System::Group","name":"Group"}],"namespace":{"html_id":"Crystal/System","kind":"module","full_name":"System","name":"System"},"doc":"Represents a group of users on the host system.\n\nGroups can be retrieved by either group name or their group ID:\n\n```\nrequire \"system/group\"\n\nSystem::Group.find_by name: \"staff\"\nSystem::Group.find_by id: \"0\"\n```","summary":"<p>Represents a group of users on the host system.</p>","class_methods":[{"html_id":"find_by(*,name:String):System::Group-class-method","name":"find_by","doc":"Returns the group associated with the given name.\n\nRaises `NotFoundError` if no such group exists.","summary":"<p>Returns the group associated with the given name.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(*, name : String) : System::Group","args_html":"(*, name : <a href=\"../String.html\">String</a>) : <a href=\"../System/Group.html\">System::Group</a>","location":{"filename":"src/system/group.cr","line_number":34,"url":null},"def":{"name":"find_by","args":[{"name":"","external_name":"","restriction":""},{"name":"name","external_name":"name","restriction":"String"}],"splat_index":0,"return_type":"System::Group","visibility":"Public","body":"find_by?(name: name) || (raise(NotFoundError.new(\"No such group: #{name}\")))"}},{"html_id":"find_by(*,id:String):System::Group-class-method","name":"find_by","doc":"Returns the group associated with the given ID.\n\nRaises `NotFoundError` if no such group exists.","summary":"<p>Returns the group associated with the given ID.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"id","external_name":"id","restriction":"String"}],"args_string":"(*, id : String) : System::Group","args_html":"(*, id : <a href=\"../String.html\">String</a>) : <a href=\"../System/Group.html\">System::Group</a>","location":{"filename":"src/system/group.cr","line_number":48,"url":null},"def":{"name":"find_by","args":[{"name":"","external_name":"","restriction":""},{"name":"id","external_name":"id","restriction":"String"}],"splat_index":0,"return_type":"System::Group","visibility":"Public","body":"find_by?(id: id) || (raise(NotFoundError.new(\"No such group: #{id}\")))"}},{"html_id":"find_by?(*,name:String):System::Group?-class-method","name":"find_by?","doc":"Returns the group associated with the given name.\n\nReturns `nil` if no such group exists.","summary":"<p>Returns the group associated with the given name.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(*, name : String) : System::Group?","args_html":"(*, name : <a href=\"../String.html\">String</a>) : <a href=\"../System/Group.html\">System::Group</a>?","location":{"filename":"src/system/group.cr","line_number":41,"url":null},"def":{"name":"find_by?","args":[{"name":"","external_name":"","restriction":""},{"name":"name","external_name":"name","restriction":"String"}],"splat_index":0,"return_type":"System::Group | ::Nil","visibility":"Public","body":"from_name?(name)"}},{"html_id":"find_by?(*,id:String):System::Group?-class-method","name":"find_by?","doc":"Returns the group associated with the given ID.\n\nReturns `nil` if no such group exists.","summary":"<p>Returns the group associated with the given ID.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"id","external_name":"id","restriction":"String"}],"args_string":"(*, id : String) : System::Group?","args_html":"(*, id : <a href=\"../String.html\">String</a>) : <a href=\"../System/Group.html\">System::Group</a>?","location":{"filename":"src/system/group.cr","line_number":55,"url":null},"def":{"name":"find_by?","args":[{"name":"","external_name":"","restriction":""},{"name":"id","external_name":"id","restriction":"String"}],"splat_index":0,"return_type":"System::Group | ::Nil","visibility":"Public","body":"from_id?(id)"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this reference is the same as *other*. Invokes `same?`.","summary":"<p>Returns <code>true</code> if this reference is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"if same?(other)\n  return true\nend\nif @id == (other.@id)\nelse\n  return false\nend\ntrue\n"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = @id.hash(hasher)\nhasher\n"}},{"html_id":"id:String-instance-method","name":"id","doc":"The group's identifier.","summary":"<p>The group's identifier.</p>","abstract":false,"location":{"filename":"src/system/group.cr","line_number":24,"url":null},"def":{"name":"id","return_type":"String","visibility":"Public","body":"@id"}},{"html_id":"name:String-instance-method","name":"name","doc":"The group's name.","summary":"<p>The group's name.</p>","abstract":false,"location":{"filename":"src/system/group.cr","line_number":21,"url":null},"def":{"name":"name","return_type":"String","visibility":"Public","body":"@name"}},{"html_id":"to_s(io)-instance-method","name":"to_s","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""}],"args_string":"(io)","args_html":"(io)","location":{"filename":"src/system/group.cr","line_number":59,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":""}],"visibility":"Public","body":"(((io << name) << \" (\") << id) << ')'"}}],"types":[{"html_id":"Crystal/System/Group/NotFoundError","path":"System/Group/NotFoundError.html","kind":"class","full_name":"System::Group::NotFoundError","name":"NotFoundError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/system/group.cr","line_number":15,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/System/Group","kind":"class","full_name":"System::Group","name":"Group"},"doc":"Raised on group lookup failure.","summary":"<p>Raised on group lookup failure.</p>"}]},{"html_id":"Crystal/System/User","path":"System/User.html","kind":"class","full_name":"System::User","name":"User","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/system/user.cr","line_number":13,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"extended_modules":[{"html_id":"Crystal/Crystal/System/User","kind":"module","full_name":"Crystal::System::User","name":"User"}],"namespace":{"html_id":"Crystal/System","kind":"module","full_name":"System","name":"System"},"doc":"Represents a user on the host system.\n\nUsers can be retrieved by either username or their user ID:\n\n```\nrequire \"system/user\"\n\nSystem::User.find_by name: \"root\"\nSystem::User.find_by id: \"0\"\n```","summary":"<p>Represents a user on the host system.</p>","class_methods":[{"html_id":"find_by(*,name:String):System::User-class-method","name":"find_by","doc":"Returns the user associated with the given username.\n\nRaises `NotFoundError` if no such user exists.","summary":"<p>Returns the user associated with the given username.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(*, name : String) : System::User","args_html":"(*, name : <a href=\"../String.html\">String</a>) : <a href=\"../System/User.html\">System::User</a>","location":{"filename":"src/system/user.cr","line_number":46,"url":null},"def":{"name":"find_by","args":[{"name":"","external_name":"","restriction":""},{"name":"name","external_name":"name","restriction":"String"}],"splat_index":0,"return_type":"System::User","visibility":"Public","body":"find_by?(name: name) || (raise(NotFoundError.new(\"No such user: #{name}\")))"}},{"html_id":"find_by(*,id:String):System::User-class-method","name":"find_by","doc":"Returns the user associated with the given ID.\n\nRaises `NotFoundError` if no such user exists.","summary":"<p>Returns the user associated with the given ID.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"id","external_name":"id","restriction":"String"}],"args_string":"(*, id : String) : System::User","args_html":"(*, id : <a href=\"../String.html\">String</a>) : <a href=\"../System/User.html\">System::User</a>","location":{"filename":"src/system/user.cr","line_number":60,"url":null},"def":{"name":"find_by","args":[{"name":"","external_name":"","restriction":""},{"name":"id","external_name":"id","restriction":"String"}],"splat_index":0,"return_type":"System::User","visibility":"Public","body":"find_by?(id: id) || (raise(NotFoundError.new(\"No such user: #{id}\")))"}},{"html_id":"find_by?(*,name:String):System::User?-class-method","name":"find_by?","doc":"Returns the user associated with the given username.\n\nReturns `nil` if no such user exists.","summary":"<p>Returns the user associated with the given username.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(*, name : String) : System::User?","args_html":"(*, name : <a href=\"../String.html\">String</a>) : <a href=\"../System/User.html\">System::User</a>?","location":{"filename":"src/system/user.cr","line_number":53,"url":null},"def":{"name":"find_by?","args":[{"name":"","external_name":"","restriction":""},{"name":"name","external_name":"name","restriction":"String"}],"splat_index":0,"return_type":"System::User | ::Nil","visibility":"Public","body":"from_username?(name)"}},{"html_id":"find_by?(*,id:String):System::User?-class-method","name":"find_by?","doc":"Returns the user associated with the given ID.\n\nReturns `nil` if no such user exists.","summary":"<p>Returns the user associated with the given ID.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"id","external_name":"id","restriction":"String"}],"args_string":"(*, id : String) : System::User?","args_html":"(*, id : <a href=\"../String.html\">String</a>) : <a href=\"../System/User.html\">System::User</a>?","location":{"filename":"src/system/user.cr","line_number":67,"url":null},"def":{"name":"find_by?","args":[{"name":"","external_name":"","restriction":""},{"name":"id","external_name":"id","restriction":"String"}],"splat_index":0,"return_type":"System::User | ::Nil","visibility":"Public","body":"from_id?(id)"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this reference is the same as *other*. Invokes `same?`.","summary":"<p>Returns <code>true</code> if this reference is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"if same?(other)\n  return true\nend\nif @id == (other.@id)\nelse\n  return false\nend\ntrue\n"}},{"html_id":"group_id:String-instance-method","name":"group_id","doc":"The user's primary group identifier.","summary":"<p>The user's primary group identifier.</p>","abstract":false,"location":{"filename":"src/system/user.cr","line_number":27,"url":null},"def":{"name":"group_id","return_type":"String","visibility":"Public","body":"@group_id"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = @id.hash(hasher)\nhasher\n"}},{"html_id":"home_directory:String-instance-method","name":"home_directory","doc":"The user's home directory.","summary":"<p>The user's home directory.</p>","abstract":false,"location":{"filename":"src/system/user.cr","line_number":33,"url":null},"def":{"name":"home_directory","return_type":"String","visibility":"Public","body":"@home_directory"}},{"html_id":"id:String-instance-method","name":"id","doc":"The user's identifier.","summary":"<p>The user's identifier.</p>","abstract":false,"location":{"filename":"src/system/user.cr","line_number":24,"url":null},"def":{"name":"id","return_type":"String","visibility":"Public","body":"@id"}},{"html_id":"name:String-instance-method","name":"name","doc":"The user's real or full name.","summary":"<p>The user's real or full name.</p>","abstract":false,"location":{"filename":"src/system/user.cr","line_number":30,"url":null},"def":{"name":"name","return_type":"String","visibility":"Public","body":"@name"}},{"html_id":"shell:String-instance-method","name":"shell","doc":"The user's login shell.","summary":"<p>The user's login shell.</p>","abstract":false,"location":{"filename":"src/system/user.cr","line_number":36,"url":null},"def":{"name":"shell","return_type":"String","visibility":"Public","body":"@shell"}},{"html_id":"to_s(io)-instance-method","name":"to_s","abstract":false,"args":[{"name":"io","external_name":"io","restriction":""}],"args_string":"(io)","args_html":"(io)","location":{"filename":"src/system/user.cr","line_number":71,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":""}],"visibility":"Public","body":"(((io << username) << \" (\") << id) << ')'"}},{"html_id":"username:String-instance-method","name":"username","doc":"The user's username.","summary":"<p>The user's username.</p>","abstract":false,"location":{"filename":"src/system/user.cr","line_number":21,"url":null},"def":{"name":"username","return_type":"String","visibility":"Public","body":"@username"}}],"types":[{"html_id":"Crystal/System/User/NotFoundError","path":"System/User/NotFoundError.html","kind":"class","full_name":"System::User::NotFoundError","name":"NotFoundError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/system/user.cr","line_number":15,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/System/User","kind":"class","full_name":"System::User","name":"User"},"doc":"Raised on user lookup failure.","summary":"<p>Raised on user lookup failure.</p>"}]}]},{"html_id":"Crystal/SystemError","path":"SystemError.html","kind":"module","full_name":"SystemError","name":"SystemError","abstract":false,"locations":[{"filename":"src/system_error.cr","line_number":40,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"including_types":[{"html_id":"Crystal/IO/Error","kind":"class","full_name":"IO::Error","name":"Error"},{"html_id":"Crystal/RuntimeError","kind":"class","full_name":"RuntimeError","name":"RuntimeError"}],"doc":"This module can be included in any `Exception` subclass that is\nused to wrap some system error (`Errno` or `WinError`).\n\nIt adds an `os_error` property that contains the original system error.\nIt provides several constructor methods that set the `os_error` value:\n* `.from_os_error` receives an OS error value and creates an instance with that.\n* `.from_errno` constructs an instance with the current LibC errno value (`Errno.value`).\n* `.from_winerror` constructs an instance with the current LibC winerror value (`WinError.value`).\n\nAn error message is automatically constructed based on the system error message.\n\nFor example:\n```\nclass MyError < Exception\n  include SystemError\nend\n\nMyError.from_errno(\"Something happened\")\n```\n\n## Customization\n\nIncluding classes my override several protected methods to customize the\ninstance creation based on OS errors:\n\n* `protected def build_message(message, **opts)`\n  Prepares the message that goes before the system error description.\n  By default it returns the original message unchanged. But that could be\n  customized based on the keyword arguments passed to `from_errno` or `from_winerror`.\n* `protected def new_from_os_error(message : String?, os_error, **opts)`\n  Creates an instance of the exception that wraps a system error.\n  This is a factory method and by default it creates an instance\n  of the current class. It can be overridden to generate different\n  classes based on the `os_error` value or keyword arguments.\n* `protected def os_error_message(os_error : Errno | WinError | Nil, **opts) : String?`\n  Returns the respective error message for *os_error*.\n  By default it returns the result of `Errno#message` or `WinError#message`.\n  This method can be overridden for customization of the error message based\n  on *or_error*  and *opts*.","summary":"<p>This module can be included in any <code><a href=\"Exception.html\">Exception</a></code> subclass that is used to wrap some system error (<code><a href=\"Errno.html\">Errno</a></code> or <code><a href=\"WinError.html\">WinError</a></code>).</p>","instance_methods":[{"html_id":"os_error:Errno|WinError|Nil-instance-method","name":"os_error","doc":"The original system error wrapped by this exception","summary":"<p>The original system error wrapped by this exception</p>","abstract":false,"location":{"filename":"src/system_error.cr","line_number":46,"url":null},"def":{"name":"os_error","return_type":"Errno | WinError | Nil","visibility":"Public","body":"@os_error"}}],"types":[{"html_id":"Crystal/SystemError/ClassMethods","path":"SystemError/ClassMethods.html","kind":"module","full_name":"SystemError::ClassMethods","name":"ClassMethods","abstract":false,"locations":[{"filename":"src/system_error.cr","line_number":52,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/SystemError","kind":"module","full_name":"SystemError","name":"SystemError"},"instance_methods":[{"html_id":"from_errno(message:String,**opts)-instance-method","name":"from_errno","doc":"Builds an instance of the exception from the current system error value (`Errno.value`).\n\nThe system message corresponding to the OS error value amends the *message*.\nAdditional keyword arguments are forwarded to the exception initializer `.new_from_os_error`.","summary":"<p>Builds an instance of the exception from the current system error value (<code><a href=\"../Errno.html#value%3Aself-class-method\">Errno.value</a></code>).</p>","abstract":false,"args":[{"name":"message","external_name":"message","restriction":"String"}],"args_string":"(message : String, **opts)","args_html":"(message : <a href=\"../String.html\">String</a>, **opts)","location":{"filename":"src/system_error.cr","line_number":75,"url":null},"def":{"name":"from_errno","args":[{"name":"message","external_name":"message","restriction":"String"}],"double_splat":{"name":"opts","external_name":"opts","restriction":""},"visibility":"Public","body":"from_os_error(message, Errno.value, **opts)"}},{"html_id":"from_errno(message:String?=nil,errno:Errno?=nil,**opts)-instance-method","name":"from_errno","summary":"<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"../SystemError/ClassMethods.html#from_os_error%28message%3AString%3F%2Cos_error%3AErrno%7CWinError%7CNil%2C%2A%2Aopts%29-instance-method\">.from_os_error</a></code> instead</p>","abstract":false,"args":[{"name":"message","default_value":"nil","external_name":"message","restriction":"String | ::Nil"},{"name":"errno","default_value":"nil","external_name":"errno","restriction":"Errno | ::Nil"}],"args_string":"(message : String? = nil, errno : Errno? = nil, **opts)","args_html":"(message : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, errno : <a href=\"../Errno.html\">Errno</a>? = <span class=\"n\">nil</span>, **opts)","location":{"filename":"src/system_error.cr","line_number":80,"url":null},"def":{"name":"from_errno","args":[{"name":"message","default_value":"nil","external_name":"message","restriction":"String | ::Nil"},{"name":"errno","default_value":"nil","external_name":"errno","restriction":"Errno | ::Nil"}],"double_splat":{"name":"opts","external_name":"opts","restriction":""},"visibility":"Public","body":"from_os_error(message, errno, **opts)"}},{"html_id":"from_os_error(message:String?,os_error:Errno|WinError|Nil,**opts)-instance-method","name":"from_os_error","doc":"Builds an instance of the exception from an *os_error* value.\n\nThe system message corresponding to the OS error value amends the *message*.\nAdditional keyword arguments are forwarded to the exception initializer `.new_from_os_error`.","summary":"<p>Builds an instance of the exception from an <em>os_error</em> value.</p>","abstract":false,"args":[{"name":"message","external_name":"message","restriction":"String | ::Nil"},{"name":"os_error","external_name":"os_error","restriction":"Errno | WinError | Nil"}],"args_string":"(message : String?, os_error : Errno | WinError | Nil, **opts)","args_html":"(message : <a href=\"../String.html\">String</a>?, os_error : <a href=\"../Errno.html\">Errno</a> | <a href=\"../WinError.html\">WinError</a> | <a href=\"../Nil.html\">Nil</a>, **opts)","location":{"filename":"src/system_error.cr","line_number":57,"url":null},"def":{"name":"from_os_error","args":[{"name":"message","external_name":"message","restriction":"String | ::Nil"},{"name":"os_error","external_name":"os_error","restriction":"Errno | WinError | Nil"}],"double_splat":{"name":"opts","external_name":"opts","restriction":""},"visibility":"Public","body":"message = self.build_message(message, **opts)\nmessage = if message\n  \"#{message}: #{os_error_message(os_error, **opts)}\"\nelse\n  os_error_message(os_error, **opts)\nend\n(self.new_from_os_error(message, os_error, **opts)).tap do |e|\n  e.os_error = os_error\nend\n"}},{"html_id":"from_winerror(message:String?,**opts)-instance-method","name":"from_winerror","doc":"Builds an instance of the exception from the current windows error value (`WinError.value`).\n\nThe system message corresponding to the OS error value amends the *message*.\nAdditional keyword arguments are forwarded to the exception initializer `.new_from_os_error`.","summary":"<p>Builds an instance of the exception from the current windows error value (<code><a href=\"../WinError.html#value%3Aself-class-method\">WinError.value</a></code>).</p>","abstract":false,"args":[{"name":"message","external_name":"message","restriction":"String | ::Nil"}],"args_string":"(message : String?, **opts)","args_html":"(message : <a href=\"../String.html\">String</a>?, **opts)","location":{"filename":"src/system_error.cr","line_number":114,"url":null},"def":{"name":"from_winerror","args":[{"name":"message","external_name":"message","restriction":"String | ::Nil"}],"double_splat":{"name":"opts","external_name":"opts","restriction":""},"visibility":"Public","body":"from_os_error(message, WinError.value, **opts)"}},{"html_id":"from_wsa_error(message:String?=nil,**opts)-instance-method","name":"from_wsa_error","doc":"Builds an instance of the exception from the current Windows Socket API error value (`WinError.wsa_value`).\n\nThe system message corresponding to the OS error value amends the *message*.\nAdditional keyword arguments are forwarded to the exception initializer.","summary":"<p>Builds an instance of the exception from the current Windows Socket API error value (<code><a href=\"../WinError.html#wsa_value-class-method\">WinError.wsa_value</a></code>).</p>","abstract":false,"args":[{"name":"message","default_value":"nil","external_name":"message","restriction":"String | ::Nil"}],"args_string":"(message : String? = nil, **opts)","args_html":"(message : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, **opts)","location":{"filename":"src/system_error.cr","line_number":122,"url":null},"def":{"name":"from_wsa_error","args":[{"name":"message","default_value":"nil","external_name":"message","restriction":"String | ::Nil"}],"double_splat":{"name":"opts","external_name":"opts","restriction":""},"visibility":"Public","body":"from_os_error(message, WinError.wsa_value, **opts)"}}]}]},{"html_id":"Crystal/TCPServer","path":"TCPServer.html","kind":"class","full_name":"TCPServer","name":"TCPServer","abstract":false,"superclass":{"html_id":"Crystal/TCPSocket","kind":"class","full_name":"TCPSocket","name":"TCPSocket"},"ancestors":[{"html_id":"Crystal/Socket/Server","kind":"module","full_name":"Socket::Server","name":"Server"},{"html_id":"Crystal/TCPSocket","kind":"class","full_name":"TCPSocket","name":"TCPSocket"},{"html_id":"Crystal/IPSocket","kind":"class","full_name":"IPSocket","name":"IPSocket"},{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},{"html_id":"Crystal/Crystal/System/Socket","kind":"module","full_name":"Crystal::System::Socket","name":"Socket"},{"html_id":"Crystal/IO/Evented","kind":"module","full_name":"IO::Evented","name":"Evented"},{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/tcp_server.cr","line_number":25,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Socket/Server","kind":"module","full_name":"Socket::Server","name":"Server"}],"doc":"A Transmission Control Protocol (TCP/IP) server.\n\nUsage example:\n```\nrequire \"socket\"\n\ndef handle_client(client)\n  message = client.gets\n  client.puts message\nend\n\nserver = TCPServer.new(\"localhost\", 1234)\nwhile client = server.accept?\n  spawn handle_client(client)\nend\n```\n\nOptions:\n- *host* local interface to bind on, or `::` to bind on all local interfaces.\n- *port* specific port to bind on, or `0` to receive an \"ephemeral\" (free, assigned by kernel) port.\n- *backlog* to specify how many pending connections are allowed.\n- *reuse_port* to enable multiple processes to bind to the same port (`SO_REUSEPORT`).","summary":"<p>A Transmission Control Protocol (TCP/IP) server.</p>","class_methods":[{"html_id":"open(port:Int,backlog=SOMAXCONN,reuse_port=false,&)-class-method","name":"open","doc":"Creates a new TCP server, listening on all interfaces, and yields it to the\nblock. Eventually closes the server socket when the block returns.\n\nReturns the value of the block.","summary":"<p>Creates a new TCP server, listening on all interfaces, and yields it to the block.</p>","abstract":false,"args":[{"name":"port","external_name":"port","restriction":"Int"},{"name":"backlog","default_value":"SOMAXCONN","external_name":"backlog","restriction":""},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":""}],"args_string":"(port : Int, backlog = SOMAXCONN, reuse_port = false, &)","args_html":"(port : <a href=\"Int.html\">Int</a>, backlog = <span class=\"t\">SOMAXCONN</span>, reuse_port = <span class=\"n\">false</span>, &)","location":{"filename":"src/socket/tcp_server.cr","line_number":80,"url":null},"def":{"name":"open","args":[{"name":"port","external_name":"port","restriction":"Int"},{"name":"backlog","default_value":"SOMAXCONN","external_name":"backlog","restriction":""},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":""}],"yields":1,"visibility":"Public","body":"server = new(port, backlog, reuse_port: reuse_port)\nbegin\n  yield server\nensure\n  server.close\nend\n"}},{"html_id":"open(host,port,backlog=SOMAXCONN,reuse_port=false,&)-class-method","name":"open","doc":"Creates a new TCP server and yields it to the block. Eventually closes the\nserver socket when the block returns.\n\nReturns the value of the block.","summary":"<p>Creates a new TCP server and yields it to the block.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":""},{"name":"port","external_name":"port","restriction":""},{"name":"backlog","default_value":"SOMAXCONN","external_name":"backlog","restriction":""},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":""}],"args_string":"(host, port, backlog = SOMAXCONN, reuse_port = false, &)","args_html":"(host, port, backlog = <span class=\"t\">SOMAXCONN</span>, reuse_port = <span class=\"n\">false</span>, &)","location":{"filename":"src/socket/tcp_server.cr","line_number":67,"url":null},"def":{"name":"open","args":[{"name":"host","external_name":"host","restriction":""},{"name":"port","external_name":"port","restriction":""},{"name":"backlog","default_value":"SOMAXCONN","external_name":"backlog","restriction":""},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":""}],"yields":1,"visibility":"Public","body":"server = new(host, port, backlog, reuse_port: reuse_port)\nbegin\n  yield server\nensure\n  server.close\nend\n"}}],"constructors":[{"html_id":"new(host:String,port:Int,backlog:Int=SOMAXCONN,dns_timeout=nil,reuse_port:Bool=false)-class-method","name":"new","doc":"Binds a socket to the *host* and *port* combination.","summary":"<p>Binds a socket to the <em>host</em> and <em>port</em> combination.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int"},{"name":"backlog","default_value":"SOMAXCONN","external_name":"backlog","restriction":"Int"},{"name":"dns_timeout","default_value":"nil","external_name":"dns_timeout","restriction":""},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"args_string":"(host : String, port : Int, backlog : Int = SOMAXCONN, dns_timeout = nil, reuse_port : Bool = false)","args_html":"(host : <a href=\"String.html\">String</a>, port : <a href=\"Int.html\">Int</a>, backlog : <a href=\"Int.html\">Int</a> = <span class=\"t\">SOMAXCONN</span>, dns_timeout = <span class=\"n\">nil</span>, reuse_port : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>)","location":{"filename":"src/socket/tcp_server.cr","line_number":34,"url":null},"def":{"name":"new","args":[{"name":"host","external_name":"host","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int"},{"name":"backlog","default_value":"SOMAXCONN","external_name":"backlog","restriction":"Int"},{"name":"dns_timeout","default_value":"nil","external_name":"dns_timeout","restriction":""},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":"Bool"}],"visibility":"Public","body":"_ = allocate\n_.initialize(host, port, backlog, dns_timeout, reuse_port)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(family:Family=Family::INET)-class-method","name":"new","doc":"Creates a new `TCPServer`, waiting to be bound.","summary":"<p>Creates a new <code><a href=\"TCPServer.html\">TCPServer</a></code>, waiting to be bound.</p>","abstract":false,"args":[{"name":"family","default_value":"Family::INET","external_name":"family","restriction":"Family"}],"args_string":"(family : Family = Family::INET)","args_html":"(family : <a href=\"Socket/Family.html\">Family</a> = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">INET</span>)","location":{"filename":"src/socket/tcp_server.cr","line_number":29,"url":null},"def":{"name":"new","args":[{"name":"family","default_value":"Family::INET","external_name":"family","restriction":"Family"}],"visibility":"Public","body":"super(family)"}},{"html_id":"new(port:Int,backlog=SOMAXCONN,reuse_port=false)-class-method","name":"new","doc":"Creates a new TCP server, listening on all local interfaces (`::`).","summary":"<p>Creates a new TCP server, listening on all local interfaces (<code>::</code>).</p>","abstract":false,"args":[{"name":"port","external_name":"port","restriction":"Int"},{"name":"backlog","default_value":"SOMAXCONN","external_name":"backlog","restriction":""},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":""}],"args_string":"(port : Int, backlog = SOMAXCONN, reuse_port = false)","args_html":"(port : <a href=\"Int.html\">Int</a>, backlog = <span class=\"t\">SOMAXCONN</span>, reuse_port = <span class=\"n\">false</span>)","location":{"filename":"src/socket/tcp_server.cr","line_number":59,"url":null},"def":{"name":"new","args":[{"name":"port","external_name":"port","restriction":"Int"},{"name":"backlog","default_value":"SOMAXCONN","external_name":"backlog","restriction":""},{"name":"reuse_port","default_value":"false","external_name":"reuse_port","restriction":""}],"visibility":"Public","body":"new(\"::\", port, backlog, reuse_port: reuse_port)"}},{"html_id":"new(*,fd:Handle,family:Family=Family::INET)-class-method","name":"new","doc":"Creates a TCPServer from an already configured raw file descriptor","summary":"<p>Creates a TCPServer from an already configured raw file descriptor</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"fd","external_name":"fd","restriction":"Handle"},{"name":"family","default_value":"Family::INET","external_name":"family","restriction":"Family"}],"args_string":"(*, fd : Handle, family : Family = Family::INET)","args_html":"(*, fd : Handle, family : <a href=\"Socket/Family.html\">Family</a> = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">INET</span>)","location":{"filename":"src/socket/tcp_server.cr","line_number":54,"url":null},"def":{"name":"new","args":[{"name":"","external_name":"","restriction":""},{"name":"fd","external_name":"fd","restriction":"Handle"},{"name":"family","default_value":"Family::INET","external_name":"family","restriction":"Family"}],"splat_index":0,"visibility":"Public","body":"_ = allocate\n_.initialize(fd: fd, family: family)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"accept?:TCPSocket?-instance-method","name":"accept?","doc":"Accepts an incoming connection.\n\nReturns the client `TCPSocket` or `nil` if the server is closed after invoking\nthis method.\n\n```\nrequire \"socket\"\n\nserver = TCPServer.new(2022)\nloop do\n  if socket = server.accept?\n    # handle the client in a fiber\n    spawn handle_connection(socket)\n  else\n    # another fiber closed the server\n    break\n  end\nend\n```","summary":"<p>Accepts an incoming connection.</p>","abstract":false,"location":{"filename":"src/socket/tcp_server.cr","line_number":108,"url":null},"def":{"name":"accept?","return_type":"TCPSocket | ::Nil","visibility":"Public","body":"if client_fd = system_accept\n  sock = TCPSocket.new(fd: client_fd, family: family, type: type, protocol: protocol)\n  sock.sync = sync?\n  sock\nend"}}]},{"html_id":"Crystal/TCPSocket","path":"TCPSocket.html","kind":"class","full_name":"TCPSocket","name":"TCPSocket","abstract":false,"superclass":{"html_id":"Crystal/IPSocket","kind":"class","full_name":"IPSocket","name":"IPSocket"},"ancestors":[{"html_id":"Crystal/IPSocket","kind":"class","full_name":"IPSocket","name":"IPSocket"},{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},{"html_id":"Crystal/Crystal/System/Socket","kind":"module","full_name":"Crystal::System::Socket","name":"Socket"},{"html_id":"Crystal/IO/Evented","kind":"module","full_name":"IO::Evented","name":"Evented"},{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/tcp_socket.cr","line_number":14,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/TCPServer","kind":"class","full_name":"TCPServer","name":"TCPServer"}],"doc":"A Transmission Control Protocol (TCP/IP) socket.\n\nUsage example:\n```\nrequire \"socket\"\n\nclient = TCPSocket.new(\"localhost\", 1234)\nclient << \"message\\n\"\nresponse = client.gets\nclient.close\n```","summary":"<p>A Transmission Control Protocol (TCP/IP) socket.</p>","class_methods":[{"html_id":"open(host,port,&)-class-method","name":"open","doc":"Opens a TCP socket to a remote TCP server, yields it to the block, then\neventually closes the socket when the block returns.\n\nReturns the value of the block.","summary":"<p>Opens a TCP socket to a remote TCP server, yields it to the block, then eventually closes the socket when the block returns.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":""},{"name":"port","external_name":"port","restriction":""}],"args_string":"(host, port, &)","args_html":"(host, port, &)","location":{"filename":"src/socket/tcp_socket.cr","line_number":54,"url":null},"def":{"name":"open","args":[{"name":"host","external_name":"host","restriction":""},{"name":"port","external_name":"port","restriction":""}],"yields":1,"visibility":"Public","body":"sock = new(host, port)\nbegin\n  yield sock\nensure\n  sock.close\nend\n"}}],"constructors":[{"html_id":"new(family:Family=Family::INET,blocking=false)-class-method","name":"new","doc":"Creates a new `TCPSocket`, waiting to be connected.","summary":"<p>Creates a new <code><a href=\"TCPSocket.html\">TCPSocket</a></code>, waiting to be connected.</p>","abstract":false,"args":[{"name":"family","default_value":"Family::INET","external_name":"family","restriction":"Family"},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"args_string":"(family : Family = Family::INET, blocking = false)","args_html":"(family : <a href=\"Socket/Family.html\">Family</a> = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">INET</span>, blocking = <span class=\"n\">false</span>)","location":{"filename":"src/socket/tcp_socket.cr","line_number":16,"url":null},"def":{"name":"new","args":[{"name":"family","default_value":"Family::INET","external_name":"family","restriction":"Family"},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"visibility":"Public","body":"super(family, Type::STREAM, Protocol::TCP, blocking)"}},{"html_id":"new(host,port,dns_timeout=nil,connect_timeout=nil,blocking=false)-class-method","name":"new","doc":"Creates a new TCP connection to a remote TCP server.\n\nYou may limit the DNS resolution time with `dns_timeout` and limit the\nconnection time to the remote server with `connect_timeout`. Both values\nmust be in seconds (integers or floats).\n\nNote that `dns_timeout` is currently ignored.","summary":"<p>Creates a new TCP connection to a remote TCP server.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":""},{"name":"port","external_name":"port","restriction":""},{"name":"dns_timeout","default_value":"nil","external_name":"dns_timeout","restriction":""},{"name":"connect_timeout","default_value":"nil","external_name":"connect_timeout","restriction":""},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"args_string":"(host, port, dns_timeout = nil, connect_timeout = nil, blocking = false)","args_html":"(host, port, dns_timeout = <span class=\"n\">nil</span>, connect_timeout = <span class=\"n\">nil</span>, blocking = <span class=\"n\">false</span>)","location":{"filename":"src/socket/tcp_socket.cr","line_number":27,"url":null},"def":{"name":"new","args":[{"name":"host","external_name":"host","restriction":""},{"name":"port","external_name":"port","restriction":""},{"name":"dns_timeout","default_value":"nil","external_name":"dns_timeout","restriction":""},{"name":"connect_timeout","default_value":"nil","external_name":"connect_timeout","restriction":""},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(host, port, dns_timeout, connect_timeout, blocking)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(*,fd:Handle,family:Family=Family::INET,blocking=false)-class-method","name":"new","doc":"Creates a TCPSocket from an already configured raw file descriptor","summary":"<p>Creates a TCPSocket from an already configured raw file descriptor</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"fd","external_name":"fd","restriction":"Handle"},{"name":"family","default_value":"Family::INET","external_name":"family","restriction":"Family"},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"args_string":"(*, fd : Handle, family : Family = Family::INET, blocking = false)","args_html":"(*, fd : Handle, family : <a href=\"Socket/Family.html\">Family</a> = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">INET</span>, blocking = <span class=\"n\">false</span>)","location":{"filename":"src/socket/tcp_socket.cr","line_number":46,"url":null},"def":{"name":"new","args":[{"name":"","external_name":"","restriction":""},{"name":"fd","external_name":"fd","restriction":"Handle"},{"name":"family","default_value":"Family::INET","external_name":"family","restriction":"Family"},{"name":"blocking","default_value":"false","external_name":"blocking","restriction":""}],"splat_index":0,"visibility":"Public","body":"_ = allocate\n_.initialize(fd: fd, family: family, blocking: blocking)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"tcp_keepalive_count-instance-method","name":"tcp_keepalive_count","doc":"The number of probes sent, without response before dropping the connection.","summary":"<p>The number of probes sent, without response before dropping the connection.</p>","abstract":false,"location":{"filename":"src/socket/tcp_socket.cr","line_number":93,"url":null},"def":{"name":"tcp_keepalive_count","visibility":"Public","body":"system_tcp_keepalive_count"}},{"html_id":"tcp_keepalive_count=(val:Int)-instance-method","name":"tcp_keepalive_count=","abstract":false,"args":[{"name":"val","external_name":"val","restriction":"Int"}],"args_string":"(val : Int)","args_html":"(val : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/socket/tcp_socket.cr","line_number":97,"url":null},"def":{"name":"tcp_keepalive_count=","args":[{"name":"val","external_name":"val","restriction":"Int"}],"visibility":"Public","body":"self.system_tcp_keepalive_count = val"}},{"html_id":"tcp_keepalive_idle-instance-method","name":"tcp_keepalive_idle","doc":"The amount of time in seconds the connection must be idle before sending keepalive probes.","summary":"<p>The amount of time in seconds the connection must be idle before sending keepalive probes.</p>","abstract":false,"location":{"filename":"src/socket/tcp_socket.cr","line_number":74,"url":null},"def":{"name":"tcp_keepalive_idle","visibility":"Public","body":"system_tcp_keepalive_idle"}},{"html_id":"tcp_keepalive_idle=(val:Int)-instance-method","name":"tcp_keepalive_idle=","abstract":false,"args":[{"name":"val","external_name":"val","restriction":"Int"}],"args_string":"(val : Int)","args_html":"(val : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/socket/tcp_socket.cr","line_number":78,"url":null},"def":{"name":"tcp_keepalive_idle=","args":[{"name":"val","external_name":"val","restriction":"Int"}],"visibility":"Public","body":"self.system_tcp_keepalive_idle = val"}},{"html_id":"tcp_keepalive_interval-instance-method","name":"tcp_keepalive_interval","doc":"The amount of time in seconds between keepalive probes.","summary":"<p>The amount of time in seconds between keepalive probes.</p>","abstract":false,"location":{"filename":"src/socket/tcp_socket.cr","line_number":83,"url":null},"def":{"name":"tcp_keepalive_interval","visibility":"Public","body":"system_tcp_keepalive_interval"}},{"html_id":"tcp_keepalive_interval=(val:Int)-instance-method","name":"tcp_keepalive_interval=","abstract":false,"args":[{"name":"val","external_name":"val","restriction":"Int"}],"args_string":"(val : Int)","args_html":"(val : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/socket/tcp_socket.cr","line_number":87,"url":null},"def":{"name":"tcp_keepalive_interval=","args":[{"name":"val","external_name":"val","restriction":"Int"}],"visibility":"Public","body":"self.system_tcp_keepalive_interval = val\nval\n"}},{"html_id":"tcp_nodelay=(val:Bool)-instance-method","name":"tcp_nodelay=","doc":"Disables the Nagle algorithm when set to `true`, otherwise enables it.","summary":"<p>Disables the Nagle algorithm when set to <code>true</code>, otherwise enables it.</p>","abstract":false,"args":[{"name":"val","external_name":"val","restriction":"Bool"}],"args_string":"(val : Bool)","args_html":"(val : <a href=\"Bool.html\">Bool</a>)","location":{"filename":"src/socket/tcp_socket.cr","line_number":69,"url":null},"def":{"name":"tcp_nodelay=","args":[{"name":"val","external_name":"val","restriction":"Bool"}],"visibility":"Public","body":"setsockopt_bool(LibC::TCP_NODELAY, val, level: Protocol::TCP)"}},{"html_id":"tcp_nodelay?:Bool-instance-method","name":"tcp_nodelay?","doc":"Returns `true` if the Nagle algorithm is disabled.","summary":"<p>Returns <code>true</code> if the Nagle algorithm is disabled.</p>","abstract":false,"location":{"filename":"src/socket/tcp_socket.cr","line_number":64,"url":null},"def":{"name":"tcp_nodelay?","return_type":"Bool","visibility":"Public","body":"getsockopt_bool(LibC::TCP_NODELAY, level: Protocol::TCP)"}}]},{"html_id":"Crystal/Termios","path":"Termios.html","kind":"module","full_name":"Termios","name":"Termios","abstract":false,"locations":[{"filename":"src/termios.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"types":[{"html_id":"Crystal/Termios/AttributeSelection","path":"Termios/AttributeSelection.html","kind":"enum","full_name":"Termios::AttributeSelection","name":"AttributeSelection","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/termios.cr","line_number":136,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"TCSANOW","name":"TCSANOW","value":"0"},{"id":"TCSADRAIN","name":"TCSADRAIN","value":"1"},{"id":"TCSAFLUSH","name":"TCSAFLUSH","value":"2"}],"namespace":{"html_id":"Crystal/Termios","kind":"module","full_name":"Termios","name":"Termios"},"instance_methods":[{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/termios.cr","line_number":136,"url":null},"def":{"name":"none?","visibility":"Public","body":"value == 0"}},{"html_id":"tcsadrain?-instance-method","name":"tcsadrain?","abstract":false,"location":{"filename":"src/termios.cr","line_number":138,"url":null},"def":{"name":"tcsadrain?","visibility":"Public","body":"self.includes?(TCSADRAIN)"}},{"html_id":"tcsaflush?-instance-method","name":"tcsaflush?","abstract":false,"location":{"filename":"src/termios.cr","line_number":139,"url":null},"def":{"name":"tcsaflush?","visibility":"Public","body":"self.includes?(TCSAFLUSH)"}},{"html_id":"tcsanow?-instance-method","name":"tcsanow?","abstract":false,"location":{"filename":"src/termios.cr","line_number":137,"url":null},"def":{"name":"tcsanow?","visibility":"Public","body":"self.includes?(TCSANOW)"}}]},{"html_id":"Crystal/Termios/BaudRate","path":"Termios/BaudRate.html","kind":"enum","full_name":"Termios::BaudRate","name":"BaudRate","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/termios.cr","line_number":89,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"B0","name":"B0","value":"0"},{"id":"B50","name":"B50","value":"1"},{"id":"B75","name":"B75","value":"2"},{"id":"B110","name":"B110","value":"3"},{"id":"B134","name":"B134","value":"4"},{"id":"B150","name":"B150","value":"5"},{"id":"B200","name":"B200","value":"6"},{"id":"B300","name":"B300","value":"7"},{"id":"B600","name":"B600","value":"8"},{"id":"B1200","name":"B1200","value":"9"},{"id":"B1800","name":"B1800","value":"10"},{"id":"B2400","name":"B2400","value":"11"},{"id":"B4800","name":"B4800","value":"12"},{"id":"B9600","name":"B9600","value":"13"},{"id":"B19200","name":"B19200","value":"14"},{"id":"B38400","name":"B38400","value":"15"}],"namespace":{"html_id":"Crystal/Termios","kind":"module","full_name":"Termios","name":"Termios"},"instance_methods":[{"html_id":"b0?-instance-method","name":"b0?","abstract":false,"location":{"filename":"src/termios.cr","line_number":90,"url":null},"def":{"name":"b0?","visibility":"Public","body":"self == B0"}},{"html_id":"b110?-instance-method","name":"b110?","abstract":false,"location":{"filename":"src/termios.cr","line_number":93,"url":null},"def":{"name":"b110?","visibility":"Public","body":"self == B110"}},{"html_id":"b1200?-instance-method","name":"b1200?","abstract":false,"location":{"filename":"src/termios.cr","line_number":99,"url":null},"def":{"name":"b1200?","visibility":"Public","body":"self == B1200"}},{"html_id":"b134?-instance-method","name":"b134?","abstract":false,"location":{"filename":"src/termios.cr","line_number":94,"url":null},"def":{"name":"b134?","visibility":"Public","body":"self == B134"}},{"html_id":"b150?-instance-method","name":"b150?","abstract":false,"location":{"filename":"src/termios.cr","line_number":95,"url":null},"def":{"name":"b150?","visibility":"Public","body":"self == B150"}},{"html_id":"b1800?-instance-method","name":"b1800?","abstract":false,"location":{"filename":"src/termios.cr","line_number":100,"url":null},"def":{"name":"b1800?","visibility":"Public","body":"self == B1800"}},{"html_id":"b19200?-instance-method","name":"b19200?","abstract":false,"location":{"filename":"src/termios.cr","line_number":104,"url":null},"def":{"name":"b19200?","visibility":"Public","body":"self == B19200"}},{"html_id":"b200?-instance-method","name":"b200?","abstract":false,"location":{"filename":"src/termios.cr","line_number":96,"url":null},"def":{"name":"b200?","visibility":"Public","body":"self == B200"}},{"html_id":"b2400?-instance-method","name":"b2400?","abstract":false,"location":{"filename":"src/termios.cr","line_number":101,"url":null},"def":{"name":"b2400?","visibility":"Public","body":"self == B2400"}},{"html_id":"b300?-instance-method","name":"b300?","abstract":false,"location":{"filename":"src/termios.cr","line_number":97,"url":null},"def":{"name":"b300?","visibility":"Public","body":"self == B300"}},{"html_id":"b38400?-instance-method","name":"b38400?","abstract":false,"location":{"filename":"src/termios.cr","line_number":105,"url":null},"def":{"name":"b38400?","visibility":"Public","body":"self == B38400"}},{"html_id":"b4800?-instance-method","name":"b4800?","abstract":false,"location":{"filename":"src/termios.cr","line_number":102,"url":null},"def":{"name":"b4800?","visibility":"Public","body":"self == B4800"}},{"html_id":"b50?-instance-method","name":"b50?","abstract":false,"location":{"filename":"src/termios.cr","line_number":91,"url":null},"def":{"name":"b50?","visibility":"Public","body":"self == B50"}},{"html_id":"b600?-instance-method","name":"b600?","abstract":false,"location":{"filename":"src/termios.cr","line_number":98,"url":null},"def":{"name":"b600?","visibility":"Public","body":"self == B600"}},{"html_id":"b75?-instance-method","name":"b75?","abstract":false,"location":{"filename":"src/termios.cr","line_number":92,"url":null},"def":{"name":"b75?","visibility":"Public","body":"self == B75"}},{"html_id":"b9600?-instance-method","name":"b9600?","abstract":false,"location":{"filename":"src/termios.cr","line_number":103,"url":null},"def":{"name":"b9600?","visibility":"Public","body":"self == B9600"}}]},{"html_id":"Crystal/Termios/ControlMode","path":"Termios/ControlMode.html","kind":"enum","full_name":"Termios::ControlMode","name":"ControlMode","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/termios.cr","line_number":108,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"CSIZE","name":"CSIZE","value":"48"},{"id":"CS5","name":"CS5","value":"0"},{"id":"CS6","name":"CS6","value":"16"},{"id":"CS7","name":"CS7","value":"32"},{"id":"CS8","name":"CS8","value":"48"},{"id":"CSTOPB","name":"CSTOPB","value":"64"},{"id":"CREAD","name":"CREAD","value":"128"},{"id":"PARENB","name":"PARENB","value":"256"},{"id":"PARODD","name":"PARODD","value":"512"},{"id":"HUPCL","name":"HUPCL","value":"1024"},{"id":"CLOCAL","name":"CLOCAL","value":"2048"}],"namespace":{"html_id":"Crystal/Termios","kind":"module","full_name":"Termios","name":"Termios"},"instance_methods":[{"html_id":"clocal?-instance-method","name":"clocal?","abstract":false,"location":{"filename":"src/termios.cr","line_number":119,"url":null},"def":{"name":"clocal?","visibility":"Public","body":"self == CLOCAL"}},{"html_id":"cread?-instance-method","name":"cread?","abstract":false,"location":{"filename":"src/termios.cr","line_number":115,"url":null},"def":{"name":"cread?","visibility":"Public","body":"self == CREAD"}},{"html_id":"cs5?-instance-method","name":"cs5?","abstract":false,"location":{"filename":"src/termios.cr","line_number":110,"url":null},"def":{"name":"cs5?","visibility":"Public","body":"self == CS5"}},{"html_id":"cs6?-instance-method","name":"cs6?","abstract":false,"location":{"filename":"src/termios.cr","line_number":111,"url":null},"def":{"name":"cs6?","visibility":"Public","body":"self == CS6"}},{"html_id":"cs7?-instance-method","name":"cs7?","abstract":false,"location":{"filename":"src/termios.cr","line_number":112,"url":null},"def":{"name":"cs7?","visibility":"Public","body":"self == CS7"}},{"html_id":"cs8?-instance-method","name":"cs8?","abstract":false,"location":{"filename":"src/termios.cr","line_number":113,"url":null},"def":{"name":"cs8?","visibility":"Public","body":"self == CS8"}},{"html_id":"csize?-instance-method","name":"csize?","abstract":false,"location":{"filename":"src/termios.cr","line_number":109,"url":null},"def":{"name":"csize?","visibility":"Public","body":"self == CSIZE"}},{"html_id":"cstopb?-instance-method","name":"cstopb?","abstract":false,"location":{"filename":"src/termios.cr","line_number":114,"url":null},"def":{"name":"cstopb?","visibility":"Public","body":"self == CSTOPB"}},{"html_id":"hupcl?-instance-method","name":"hupcl?","abstract":false,"location":{"filename":"src/termios.cr","line_number":118,"url":null},"def":{"name":"hupcl?","visibility":"Public","body":"self == HUPCL"}},{"html_id":"parenb?-instance-method","name":"parenb?","abstract":false,"location":{"filename":"src/termios.cr","line_number":116,"url":null},"def":{"name":"parenb?","visibility":"Public","body":"self == PARENB"}},{"html_id":"parodd?-instance-method","name":"parodd?","abstract":false,"location":{"filename":"src/termios.cr","line_number":117,"url":null},"def":{"name":"parodd?","visibility":"Public","body":"self == PARODD"}}]},{"html_id":"Crystal/Termios/InputMode","path":"Termios/InputMode.html","kind":"enum","full_name":"Termios::InputMode","name":"InputMode","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/termios.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"BRKINT","name":"BRKINT","value":"2"},{"id":"ICRNL","name":"ICRNL","value":"256"},{"id":"IGNBRK","name":"IGNBRK","value":"1"},{"id":"IGNCR","name":"IGNCR","value":"128"},{"id":"IGNPAR","name":"IGNPAR","value":"4"},{"id":"INLCR","name":"INLCR","value":"64"},{"id":"INPCK","name":"INPCK","value":"16"},{"id":"ISTRIP","name":"ISTRIP","value":"32"},{"id":"IXANY","name":"IXANY","value":"2048"},{"id":"IXOFF","name":"IXOFF","value":"4096"},{"id":"IXON","name":"IXON","value":"1024"},{"id":"PARMRK","name":"PARMRK","value":"8"}],"namespace":{"html_id":"Crystal/Termios","kind":"module","full_name":"Termios","name":"Termios"},"instance_methods":[{"html_id":"brkint?-instance-method","name":"brkint?","abstract":false,"location":{"filename":"src/termios.cr","line_number":6,"url":null},"def":{"name":"brkint?","visibility":"Public","body":"self.includes?(BRKINT)"}},{"html_id":"icrnl?-instance-method","name":"icrnl?","abstract":false,"location":{"filename":"src/termios.cr","line_number":7,"url":null},"def":{"name":"icrnl?","visibility":"Public","body":"self.includes?(ICRNL)"}},{"html_id":"ignbrk?-instance-method","name":"ignbrk?","abstract":false,"location":{"filename":"src/termios.cr","line_number":8,"url":null},"def":{"name":"ignbrk?","visibility":"Public","body":"self.includes?(IGNBRK)"}},{"html_id":"igncr?-instance-method","name":"igncr?","abstract":false,"location":{"filename":"src/termios.cr","line_number":9,"url":null},"def":{"name":"igncr?","visibility":"Public","body":"self.includes?(IGNCR)"}},{"html_id":"ignpar?-instance-method","name":"ignpar?","abstract":false,"location":{"filename":"src/termios.cr","line_number":10,"url":null},"def":{"name":"ignpar?","visibility":"Public","body":"self.includes?(IGNPAR)"}},{"html_id":"inlcr?-instance-method","name":"inlcr?","abstract":false,"location":{"filename":"src/termios.cr","line_number":11,"url":null},"def":{"name":"inlcr?","visibility":"Public","body":"self.includes?(INLCR)"}},{"html_id":"inpck?-instance-method","name":"inpck?","abstract":false,"location":{"filename":"src/termios.cr","line_number":12,"url":null},"def":{"name":"inpck?","visibility":"Public","body":"self.includes?(INPCK)"}},{"html_id":"istrip?-instance-method","name":"istrip?","abstract":false,"location":{"filename":"src/termios.cr","line_number":13,"url":null},"def":{"name":"istrip?","visibility":"Public","body":"self.includes?(ISTRIP)"}},{"html_id":"ixany?-instance-method","name":"ixany?","abstract":false,"location":{"filename":"src/termios.cr","line_number":14,"url":null},"def":{"name":"ixany?","visibility":"Public","body":"self.includes?(IXANY)"}},{"html_id":"ixoff?-instance-method","name":"ixoff?","abstract":false,"location":{"filename":"src/termios.cr","line_number":15,"url":null},"def":{"name":"ixoff?","visibility":"Public","body":"self.includes?(IXOFF)"}},{"html_id":"ixon?-instance-method","name":"ixon?","abstract":false,"location":{"filename":"src/termios.cr","line_number":16,"url":null},"def":{"name":"ixon?","visibility":"Public","body":"self.includes?(IXON)"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/termios.cr","line_number":5,"url":null},"def":{"name":"none?","visibility":"Public","body":"value == 0"}},{"html_id":"parmrk?-instance-method","name":"parmrk?","abstract":false,"location":{"filename":"src/termios.cr","line_number":17,"url":null},"def":{"name":"parmrk?","visibility":"Public","body":"self.includes?(PARMRK)"}}]},{"html_id":"Crystal/Termios/LineControl","path":"Termios/LineControl.html","kind":"enum","full_name":"Termios::LineControl","name":"LineControl","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/termios.cr","line_number":142,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"TCSANOW","name":"TCSANOW","value":"0"},{"id":"TCSADRAIN","name":"TCSADRAIN","value":"1"},{"id":"TCSAFLUSH","name":"TCSAFLUSH","value":"2"},{"id":"TCIFLUSH","name":"TCIFLUSH","value":"0"},{"id":"TCIOFLUSH","name":"TCIOFLUSH","value":"2"},{"id":"TCOFLUSH","name":"TCOFLUSH","value":"1"},{"id":"TCIOFF","name":"TCIOFF","value":"2"},{"id":"TCION","name":"TCION","value":"3"},{"id":"TCOOFF","name":"TCOOFF","value":"0"},{"id":"TCOON","name":"TCOON","value":"1"}],"namespace":{"html_id":"Crystal/Termios","kind":"module","full_name":"Termios","name":"Termios"},"instance_methods":[{"html_id":"tciflush?-instance-method","name":"tciflush?","abstract":false,"location":{"filename":"src/termios.cr","line_number":146,"url":null},"def":{"name":"tciflush?","visibility":"Public","body":"self == TCIFLUSH"}},{"html_id":"tcioff?-instance-method","name":"tcioff?","abstract":false,"location":{"filename":"src/termios.cr","line_number":149,"url":null},"def":{"name":"tcioff?","visibility":"Public","body":"self == TCIOFF"}},{"html_id":"tcioflush?-instance-method","name":"tcioflush?","abstract":false,"location":{"filename":"src/termios.cr","line_number":147,"url":null},"def":{"name":"tcioflush?","visibility":"Public","body":"self == TCIOFLUSH"}},{"html_id":"tcion?-instance-method","name":"tcion?","abstract":false,"location":{"filename":"src/termios.cr","line_number":150,"url":null},"def":{"name":"tcion?","visibility":"Public","body":"self == TCION"}},{"html_id":"tcoflush?-instance-method","name":"tcoflush?","abstract":false,"location":{"filename":"src/termios.cr","line_number":148,"url":null},"def":{"name":"tcoflush?","visibility":"Public","body":"self == TCOFLUSH"}},{"html_id":"tcooff?-instance-method","name":"tcooff?","abstract":false,"location":{"filename":"src/termios.cr","line_number":151,"url":null},"def":{"name":"tcooff?","visibility":"Public","body":"self == TCOOFF"}},{"html_id":"tcoon?-instance-method","name":"tcoon?","abstract":false,"location":{"filename":"src/termios.cr","line_number":152,"url":null},"def":{"name":"tcoon?","visibility":"Public","body":"self == TCOON"}},{"html_id":"tcsadrain?-instance-method","name":"tcsadrain?","abstract":false,"location":{"filename":"src/termios.cr","line_number":144,"url":null},"def":{"name":"tcsadrain?","visibility":"Public","body":"self == TCSADRAIN"}},{"html_id":"tcsaflush?-instance-method","name":"tcsaflush?","abstract":false,"location":{"filename":"src/termios.cr","line_number":145,"url":null},"def":{"name":"tcsaflush?","visibility":"Public","body":"self == TCSAFLUSH"}},{"html_id":"tcsanow?-instance-method","name":"tcsanow?","abstract":false,"location":{"filename":"src/termios.cr","line_number":143,"url":null},"def":{"name":"tcsanow?","visibility":"Public","body":"self == TCSANOW"}}]},{"html_id":"Crystal/Termios/LocalMode","path":"Termios/LocalMode.html","kind":"enum","full_name":"Termios::LocalMode","name":"LocalMode","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/termios.cr","line_number":123,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"ECHO","name":"ECHO","value":"8_i64"},{"id":"ECHOE","name":"ECHOE","value":"16_i64"},{"id":"ECHOK","name":"ECHOK","value":"32_i64"},{"id":"ECHONL","name":"ECHONL","value":"64_i64"},{"id":"ICANON","name":"ICANON","value":"2_i64"},{"id":"IEXTEN","name":"IEXTEN","value":"32768_i64"},{"id":"ISIG","name":"ISIG","value":"1_i64"},{"id":"NOFLSH","name":"NOFLSH","value":"128_i64"},{"id":"TOSTOP","name":"TOSTOP","value":"256_i64"}],"namespace":{"html_id":"Crystal/Termios","kind":"module","full_name":"Termios","name":"Termios"},"instance_methods":[{"html_id":"echo?-instance-method","name":"echo?","abstract":false,"location":{"filename":"src/termios.cr","line_number":124,"url":null},"def":{"name":"echo?","visibility":"Public","body":"self.includes?(ECHO)"}},{"html_id":"echoe?-instance-method","name":"echoe?","abstract":false,"location":{"filename":"src/termios.cr","line_number":125,"url":null},"def":{"name":"echoe?","visibility":"Public","body":"self.includes?(ECHOE)"}},{"html_id":"echok?-instance-method","name":"echok?","abstract":false,"location":{"filename":"src/termios.cr","line_number":126,"url":null},"def":{"name":"echok?","visibility":"Public","body":"self.includes?(ECHOK)"}},{"html_id":"echonl?-instance-method","name":"echonl?","abstract":false,"location":{"filename":"src/termios.cr","line_number":127,"url":null},"def":{"name":"echonl?","visibility":"Public","body":"self.includes?(ECHONL)"}},{"html_id":"icanon?-instance-method","name":"icanon?","abstract":false,"location":{"filename":"src/termios.cr","line_number":128,"url":null},"def":{"name":"icanon?","visibility":"Public","body":"self.includes?(ICANON)"}},{"html_id":"iexten?-instance-method","name":"iexten?","abstract":false,"location":{"filename":"src/termios.cr","line_number":129,"url":null},"def":{"name":"iexten?","visibility":"Public","body":"self.includes?(IEXTEN)"}},{"html_id":"isig?-instance-method","name":"isig?","abstract":false,"location":{"filename":"src/termios.cr","line_number":130,"url":null},"def":{"name":"isig?","visibility":"Public","body":"self.includes?(ISIG)"}},{"html_id":"noflsh?-instance-method","name":"noflsh?","abstract":false,"location":{"filename":"src/termios.cr","line_number":131,"url":null},"def":{"name":"noflsh?","visibility":"Public","body":"self.includes?(NOFLSH)"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/termios.cr","line_number":123,"url":null},"def":{"name":"none?","visibility":"Public","body":"value == 0"}},{"html_id":"tostop?-instance-method","name":"tostop?","abstract":false,"location":{"filename":"src/termios.cr","line_number":132,"url":null},"def":{"name":"tostop?","visibility":"Public","body":"self.includes?(TOSTOP)"}}]},{"html_id":"Crystal/Termios/OutputMode","path":"Termios/OutputMode.html","kind":"enum","full_name":"Termios::OutputMode","name":"OutputMode","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/termios.cr","line_number":20,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"OPOST","name":"OPOST","value":"1"},{"id":"ONLCR","name":"ONLCR","value":"4"},{"id":"OCRNL","name":"OCRNL","value":"8"},{"id":"ONOCR","name":"ONOCR","value":"16"},{"id":"ONLRET","name":"ONLRET","value":"32"},{"id":"OFDEL","name":"OFDEL","value":"128"},{"id":"OFILL","name":"OFILL","value":"64"},{"id":"CRDLY","name":"CRDLY","value":"1536"},{"id":"CR0","name":"CR0","value":"0"},{"id":"CR1","name":"CR1","value":"512"},{"id":"CR2","name":"CR2","value":"1024"},{"id":"CR3","name":"CR3","value":"1536"},{"id":"TABDLY","name":"TABDLY","value":"6144"},{"id":"TAB0","name":"TAB0","value":"0"},{"id":"TAB1","name":"TAB1","value":"2048"},{"id":"TAB2","name":"TAB2","value":"4096"},{"id":"TAB3","name":"TAB3","value":"6144"},{"id":"BSDLY","name":"BSDLY","value":"8192"},{"id":"BS0","name":"BS0","value":"0"},{"id":"BS1","name":"BS1","value":"8192"},{"id":"VTDLY","name":"VTDLY","value":"16384"},{"id":"VT0","name":"VT0","value":"0"},{"id":"VT1","name":"VT1","value":"16384"},{"id":"FFDLY","name":"FFDLY","value":"32768"},{"id":"FF0","name":"FF0","value":"0"},{"id":"FF1","name":"FF1","value":"32768"},{"id":"NLDLY","name":"NLDLY","value":"256"},{"id":"NL0","name":"NL0","value":"0"},{"id":"NL1","name":"NL1","value":"256"}],"namespace":{"html_id":"Crystal/Termios","kind":"module","full_name":"Termios","name":"Termios"},"instance_methods":[{"html_id":"bs0?-instance-method","name":"bs0?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"bs0?","visibility":"Public","body":"self.includes?(BS0)"}},{"html_id":"bs1?-instance-method","name":"bs1?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"bs1?","visibility":"Public","body":"self.includes?(BS1)"}},{"html_id":"bsdly?-instance-method","name":"bsdly?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"bsdly?","visibility":"Public","body":"self.includes?(BSDLY)"}},{"html_id":"cr0?-instance-method","name":"cr0?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"cr0?","visibility":"Public","body":"self.includes?(CR0)"}},{"html_id":"cr1?-instance-method","name":"cr1?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"cr1?","visibility":"Public","body":"self.includes?(CR1)"}},{"html_id":"cr2?-instance-method","name":"cr2?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"cr2?","visibility":"Public","body":"self.includes?(CR2)"}},{"html_id":"cr3?-instance-method","name":"cr3?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"cr3?","visibility":"Public","body":"self.includes?(CR3)"}},{"html_id":"crdly?-instance-method","name":"crdly?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"crdly?","visibility":"Public","body":"self.includes?(CRDLY)"}},{"html_id":"ff0?-instance-method","name":"ff0?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"ff0?","visibility":"Public","body":"self.includes?(FF0)"}},{"html_id":"ff1?-instance-method","name":"ff1?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"ff1?","visibility":"Public","body":"self.includes?(FF1)"}},{"html_id":"ffdly?-instance-method","name":"ffdly?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"ffdly?","visibility":"Public","body":"self.includes?(FFDLY)"}},{"html_id":"nl0?-instance-method","name":"nl0?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"nl0?","visibility":"Public","body":"self.includes?(NL0)"}},{"html_id":"nl1?-instance-method","name":"nl1?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"nl1?","visibility":"Public","body":"self.includes?(NL1)"}},{"html_id":"nldly?-instance-method","name":"nldly?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"nldly?","visibility":"Public","body":"self.includes?(NLDLY)"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"none?","visibility":"Public","body":"value == 0"}},{"html_id":"ocrnl?-instance-method","name":"ocrnl?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"ocrnl?","visibility":"Public","body":"self.includes?(OCRNL)"}},{"html_id":"ofdel?-instance-method","name":"ofdel?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"ofdel?","visibility":"Public","body":"self.includes?(OFDEL)"}},{"html_id":"ofill?-instance-method","name":"ofill?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"ofill?","visibility":"Public","body":"self.includes?(OFILL)"}},{"html_id":"onlcr?-instance-method","name":"onlcr?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"onlcr?","visibility":"Public","body":"self.includes?(ONLCR)"}},{"html_id":"onlret?-instance-method","name":"onlret?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"onlret?","visibility":"Public","body":"self.includes?(ONLRET)"}},{"html_id":"onocr?-instance-method","name":"onocr?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"onocr?","visibility":"Public","body":"self.includes?(ONOCR)"}},{"html_id":"opost?-instance-method","name":"opost?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"opost?","visibility":"Public","body":"self.includes?(OPOST)"}},{"html_id":"tab0?-instance-method","name":"tab0?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"tab0?","visibility":"Public","body":"self.includes?(TAB0)"}},{"html_id":"tab1?-instance-method","name":"tab1?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"tab1?","visibility":"Public","body":"self.includes?(TAB1)"}},{"html_id":"tab2?-instance-method","name":"tab2?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"tab2?","visibility":"Public","body":"self.includes?(TAB2)"}},{"html_id":"tab3?-instance-method","name":"tab3?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"tab3?","visibility":"Public","body":"self.includes?(TAB3)"}},{"html_id":"tabdly?-instance-method","name":"tabdly?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"tabdly?","visibility":"Public","body":"self.includes?(TABDLY)"}},{"html_id":"vt0?-instance-method","name":"vt0?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"vt0?","visibility":"Public","body":"self.includes?(VT0)"}},{"html_id":"vt1?-instance-method","name":"vt1?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"vt1?","visibility":"Public","body":"self.includes?(VT1)"}},{"html_id":"vtdly?-instance-method","name":"vtdly?","abstract":false,"location":{"filename":"src/termios.cr","line_number":20,"url":null},"def":{"name":"vtdly?","visibility":"Public","body":"self.includes?(VTDLY)"}}]}]},{"html_id":"Crystal/Time","path":"Time.html","kind":"struct","full_name":"Time","name":"Time","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/to_json.cr","line_number":257,"url":null},{"filename":"src/time.cr","line_number":214,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":223,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"UNIX_EPOCH","name":"UNIX_EPOCH","value":"new(unsafe_utc_seconds: 62135596800_i64)","doc":"This constant is defined to be \"1970-01-01 00:00:00 UTC\".\nCan be used to create a `Time::Span` that represents an Unix Epoch time duration.\n\n```\nTime.utc - Time::UNIX_EPOCH\n```","summary":"<p>This constant is defined to be &quot;1970-01-01 00:00:00 UTC&quot;.</p>"}],"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"}],"doc":"`Time` represents a date-time instant in\n[incremental time](https://www.w3.org/International/articles/definitions-time/#incremental_time)\nobserved in a specific time zone.\n\nThe calendaric calculations are based on the rules of the proleptic Gregorian\ncalendar as specified in [ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf).\nLeap seconds are ignored.\n\nInternally, the time is stored as an `Int64` representing seconds from epoch\n(`0001-01-01 00:00:00.0 UTC`) and an `Int32` representing\nnanosecond-of-second with value range `0..999_999_999`.\n\nThe supported date range is `0001-01-01 00:00:00.0` to\n`9999-12-31 23:59:59.999_999_999` in any local time zone.\n\n### Telling the Time\n\nThere are several methods to retrieve a `Time` instance representing the\ncurrent time:\n\n```\nTime.utc                                        # returns the current time in UTC\nTime.local Time::Location.load(\"Europe/Berlin\") # returns the current time in time zone Europe/Berlin\nTime.local                                      # returns the current time in current time zone\n```\n\nIt is generally recommended to keep instances in UTC and only apply a\nlocal time zone when formatting for user display, unless the domain logic\nrequires having a specific time zone (for example for calendaric operations).\n\n### Creating a Specific Instant\n\n`Time` instances representing a specific instant can be created by\n`.utc` or `.new` with the date-time specified as individual arguments:\n\n```\ntime = Time.utc(2016, 2, 15, 10, 20, 30)\ntime.to_s # => 2016-02-15 10:20:30 UTC\ntime = Time.local(2016, 2, 15, 10, 20, 30, location: Time::Location.load(\"Europe/Berlin\"))\ntime.to_s # => 2016-02-15 10:20:30 +01:00 Europe/Berlin\n# The time-of-day can be omitted and defaults to midnight (start of day):\ntime = Time.utc(2016, 2, 15)\ntime.to_s # => 2016-02-15 00:00:00 UTC\n```\n\n### Retrieving Time Information\n\nEach `Time` instance allows querying calendar data:\n\n```\ntime = Time.utc(2016, 2, 15, 10, 20, 30)\ntime.year        # => 2016\ntime.month       # => 2\ntime.day         # => 15\ntime.hour        # => 10\ntime.minute      # => 20\ntime.second      # => 30\ntime.millisecond # => 0\ntime.nanosecond  # => 0\ntime.day_of_week # => Time::DayOfWeek::Monday\ntime.day_of_year # => 46\ntime.monday?     # => true\ntime.time_of_day # => 10:20:30\n```\n\nFor querying if a time is at a specific day of week, `Time` offers named\npredicate methods, delegating to `#day_of_week`:\n\n```\ntime.monday? # => true\n# ...\ntime.sunday? # => false\n```\n\n### Time Zones\n\nEach time is attached to a specific time zone, represented by a `Location`\n(see `#location`).\n`#zone` returns the time zone observed in this location at the current time\n(i.e. the instant represented by this `Time`).\n`#offset` returns the offset of the current zone in seconds.\n\n```\ntime = Time.local(2018, 3, 8, 22, 5, 13, location: Time::Location.load(\"Europe/Berlin\"))\ntime          # => 2018-03-08 22:05:13 +01:00 Europe/Berlin\ntime.location # => #<Time::Location Europe/Berlin>\ntime.zone     # => #<Time::Location::Zone CET +01:00 (3600s) STD>\ntime.offset   # => 3600\n```\n\nUsing `.utc`, the location is `Time::Location::UTC`:\n\n```\ntime = Time.utc(2018, 3, 8, 22, 5, 13)\ntime          # => 2018-03-08 22:05:13.0 UTC\ntime.location # => #<Time::Location UTC>\ntime.zone     # => #<Time::Location::Zone UTC +00:00 (0s) STD>\ntime.offset   # => 0\n```\n\nA `Time` instance can be transformed to a different time zone while retaining\nthe same instant using `#in`:\n\n```\ntime_de = Time.local(2018, 3, 8, 22, 5, 13, location: Time::Location.load(\"Europe/Berlin\"))\ntime_ar = time_de.in Time::Location.load(\"America/Buenos_Aires\")\ntime_de # => 2018-03-08 22:05:13 +01:00 Europe/Berlin\ntime_ar # => 2018-03-08 18:05:13 -03:00 America/Buenos_Aires\n```\n\nBoth `Time` instances show a different local date-time, but they represent\nthe same date-time in the instant time-line, therefore they are considered\nequal:\n\n```\ntime_de.to_utc     # => 2018-03-08 21:05:13 UTC\ntime_ar.to_utc     # => 2018-03-08 21:05:13 UTC\ntime_de == time_ar # => true\n```\n\nThere are also two special methods for converting to UTC and local time zone:\n\n```\ntime.to_utc   # equals time.in(Location::UTC)\ntime.to_local # equals time.in(Location.local)\n```\n\n`#to_local_in` allows changing the time zone while keeping\nthe same local date-time (wall clock) which results in a different instant\non the time line.\n\n### Formatting and Parsing Time\n\nTo make date-time instances exchangeable between different computer systems\nor readable to humans, they are usually converted to and from a string\nrepresentation.\n\nThe method `#to_s` formats the date-time according to a specified pattern.\n\n```\ntime = Time.utc(2015, 10, 12, 10, 30, 0)\ntime.to_s(\"%Y-%m-%d %H:%M:%S %:z\") # => \"2015-10-12 10:30:00 +00:00\"\n```\n\nSimilarly, `Time.parse` and `Time.parse!` are used to construct a `Time` instance from date-time\ninformation in a string, according to a specified pattern:\n\n```\nTime.parse(\"2015-10-12 10:30:00 +00:00\", \"%Y-%m-%d %H:%M:%S %z\", Time::Location::UTC)\nTime.parse!(\"2015-10-12 10:30:00 +00:00\", \"%Y-%m-%d %H:%M:%S %z\")\n```\n\nSee `Time::Format` for all directives.\n\n### Calculations\n\n```\nTime.utc(2015, 10, 10) - 5.days # => 2015-10-05 00:00:00 +00:00\n\nspan = Time.utc(2015, 10, 10) - Time.utc(2015, 9, 10)\nspan.days          # => 30\nspan.total_hours   # => 720\nspan.total_minutes # => 43200\n```\n\n## Measuring Time\n\nThe typical time representation provided by the operating system is based on\na \"wall clock\" which is subject to changes for clock synchronization.\nThis can result in discontinuous jumps in the time-line making it not\nsuitable for accurately measuring elapsed time.\n\nInstances of `Time` are focused on telling time – using a \"wall clock\".\nWhen `Time.local` is called multiple times, the difference between the\nreturned instances is not guaranteed to equal to the time elapsed between\nmaking the calls; even the order of the returned `Time` instances might\nnot reflect invocation order.\n\n```\nt1 = Time.utc\n# operation that takes 1 minute\nt2 = Time.utc\nt2 - t1 # => ?\n```\n\nThe resulting `Time::Span` could be anything, even negative, if the\ncomputer's wall clock has changed between both calls.\n\nAs an alternative, the operating system also provides a monotonic clock.\nIts time-line has no specified starting point but is strictly linearly\nincreasing.\n\nThis monotonic clock should always be used for measuring elapsed time.\n\nA reading from this clock can be taken using `.monotonic`:\n\n```\nt1 = Time.monotonic\n# operation that takes 1 minute\nt2 = Time.monotonic\nt2 - t1 # => 1.minute (approximately)\n```\n\nThe execution time of a block can be measured using `.measure`:\n\n```\nelapsed_time = Time.measure do\n  # operation that takes 20 milliseconds\nend\nelapsed_time # => 20.milliseconds (approximately)\n```","summary":"<p><code><a href=\"Time.html\">Time</a></code> represents a date-time instant in <a href=\"https://www.w3.org/International/articles/definitions-time/#incremental_time\">incremental time</a> observed in a specific time zone.</p>","class_methods":[{"html_id":"days_in_month(year:Int,month:Int):Int32-class-method","name":"days_in_month","doc":"Returns the number of days in *month* (value range: `1..12`) taking account\nof the *year*.\n\nThe returned value is either `28`, `29`, `30` or `31` depending on the\nmonth and whether *year* is leap.\n\n```\nTime.days_in_month(2016, 2) # => 29\nTime.days_in_month(1990, 4) # => 30\n```","summary":"<p>Returns the number of days in <em>month</em> (value range: <code>1..12</code>) taking account of the <em>year</em>.</p>","abstract":false,"args":[{"name":"year","external_name":"year","restriction":"Int"},{"name":"month","external_name":"month","restriction":"Int"}],"args_string":"(year : Int, month : Int) : Int32","args_html":"(year : <a href=\"Int.html\">Int</a>, month : <a href=\"Int.html\">Int</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/time.cr","line_number":1001,"url":null},"def":{"name":"days_in_month","args":[{"name":"year","external_name":"year","restriction":"Int"},{"name":"month","external_name":"month","restriction":"Int"}],"return_type":"Int32","visibility":"Public","body":"if 1 <= month && month <= 12\nelse\n  raise(ArgumentError.new(\"Invalid month\"))\nend\ndays = leap_year?(year) ? DAYS_MONTH_LEAP : DAYS_MONTH\ndays[month]\n"}},{"html_id":"days_in_year(year:Int):Int32-class-method","name":"days_in_year","doc":"Returns the number of days in *year*.\n\nA normal year has `365` days, a leap year `366` days.\n\n```\nTime.days_in_year(1990) # => 365\nTime.days_in_year(2004) # => 366\n```","summary":"<p>Returns the number of days in <em>year</em>.</p>","abstract":false,"args":[{"name":"year","external_name":"year","restriction":"Int"}],"args_string":"(year : Int) : Int32","args_html":"(year : <a href=\"Int.html\">Int</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/time.cr","line_number":1018,"url":null},"def":{"name":"days_in_year","args":[{"name":"year","external_name":"year","restriction":"Int"}],"return_type":"Int32","visibility":"Public","body":"leap_year?(year) ? 366 : 365"}},{"html_id":"leap_year?(year:Int):Bool-class-method","name":"leap_year?","doc":"Returns `true` if *year* is a leap year in the proleptic Gregorian\ncalendar.","summary":"<p>Returns <code>true</code> if <em>year</em> is a leap year in the proleptic Gregorian calendar.</p>","abstract":false,"args":[{"name":"year","external_name":"year","restriction":"Int"}],"args_string":"(year : Int) : Bool","args_html":"(year : <a href=\"Int.html\">Int</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/time.cr","line_number":1024,"url":null},"def":{"name":"leap_year?","args":[{"name":"year","external_name":"year","restriction":"Int"}],"return_type":"Bool","visibility":"Public","body":"if 1 <= year && year <= 9999\nelse\n  raise(ArgumentError.new(\"Invalid year\"))\nend\n((year % 4) == 0) && (((year % 100) != 0) || ((year % 400) == 0))\n"}},{"html_id":"measure(&):Time::Span-class-method","name":"measure","doc":"Measures the execution time of *block*.\n\nThe measurement relies on the monotonic clock and is not\naffected by fluctuations of the system clock (see `#monotonic`).\n\n```\nelapsed_time = Time.measure do\n  # operation that takes 20 milliseconds\nend\nelapsed_time # => 20.milliseconds (approximately)\n```","summary":"<p>Measures the execution time of <em>block</em>.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":354,"url":null},"def":{"name":"measure","yields":0,"return_type":"Time::Span","visibility":"Public","body":"start = monotonic\nyield\nmonotonic - start\n"}},{"html_id":"monotonic:Time::Span-class-method","name":"monotonic","doc":"Returns a reading from the monotonic clock to measure elapsed time.\n\nValues from the monotonic clock and wall clock are not comparable.\nThis method does not return a `Time` instance but a `Time::Span` amounting\nto the number of nanoseconds elapsed since the unspecified starting point\nof the monotonic clock.\nThe returned values are strictly linearly increasing.\n\nThis clock should be independent from discontinuous jumps in the\nsystem time, such as leap seconds, time zone adjustments or manual changes\nto the computer's clock.\n\nSubtracting two results from this method equals to the time elapsed between\nboth readings:\n\n```\nstart = Time.monotonic\n# operation that takes 20 milliseconds\nelapsed = Time.monotonic - start # => 20.milliseconds (approximately)\n# operation that takes 50 milliseconds\nelapsed_total = Time.monotonic - start # => 70.milliseconds (approximately)\n```\n\nThe execution time of a block can be measured using `.measure`.","summary":"<p>Returns a reading from the monotonic clock to measure elapsed time.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":338,"url":null},"def":{"name":"monotonic","return_type":"Time::Span","visibility":"Public","body":"seconds, nanoseconds = Crystal::System::Time.monotonic\nTime::Span.new(seconds: seconds, nanoseconds: nanoseconds)\n"}},{"html_id":"parse_iso8601(time:String)-class-method","name":"parse_iso8601","doc":"Parse datetime format specified by [ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf).\n\nThis is similar to `.parse_rfc3339` but RFC 3339 defines a more strict format.\nIn ISO 8601 for examples, field delimiters (`-`, `:`) are optional.\n\nUse `#to_rfc3339` to format a `Time` according to .","summary":"<p>Parse datetime format specified by <a href=\"http://xml.coverpages.org/ISO-FDIS-8601.pdf\">ISO 8601</a>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"String"}],"args_string":"(time : String)","args_html":"(time : <a href=\"String.html\">String</a>)","location":{"filename":"src/time.cr","line_number":1131,"url":null},"def":{"name":"parse_iso8601","args":[{"name":"time","external_name":"time","restriction":"String"}],"visibility":"Public","body":"Format::ISO_8601_DATE_TIME.parse(time)"}}],"constructors":[{"html_id":"local(year:Int32,month:Int32,day:Int32,hour:Int32=0,minute:Int32=0,second:Int32=0,*,nanosecond:Int32=0,location:Location=Location.local):Time-class-method","name":"local","doc":"Creates a new `Time` instance representing the given local date-time in\n*location* (defaults to local time zone).\n\n```\ntime = Time.local(2016, 2, 15, 10, 20, 30, location: Time::Location.load(\"Europe/Berlin\"))\ntime.inspect # => \"2016-02-15 10:20:30.0 +01:00 Europe/Berlin\"\n```\n\nValid value ranges for the individual fields:\n\n* `year`: `1..9999`\n* `month`: `1..12`\n* `day`: `1` - `28`/`29`/`30`/`31` (depending on month and year)\n* `hour`: `0..23`\n* `minute`: `0..59`\n* `second`: `0..59`\n* `nanosecond`: `0..999_999_999`\n\nThe time-of-day can be omitted and defaults to midnight (start of day):\n\n```\ntime = Time.utc(2016, 2, 15)\ntime.to_s # => \"2016-02-15 00:00:00 UTC\"\n```\n\nThe local date-time representation is resolved to a single instant based on\nthe offset observed in the *location* at this time.\n\nThis process can sometimes be ambiguous, mostly due skipping or repeating\ntimes at time zone transitions. For example, in `America/New_York` the\ndate-time `2011-03-13 02:15:00` never occurred, there is a gap between time\nzones. In return, `2011-11-06 01:15:00` occurred twice because of overlapping\ntime zones.\n\nIn such cases, the choice of time zone, and therefore the time, is not\nwell-defined. This method returns a time that is correct in one of the two\nzones involved in the transition, but it does not guarantee which.","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance representing the given local date-time in <em>location</em> (defaults to local time zone).</p>","abstract":false,"args":[{"name":"year","external_name":"year","restriction":"Int32"},{"name":"month","external_name":"month","restriction":"Int32"},{"name":"day","external_name":"day","restriction":"Int32"},{"name":"hour","default_value":"0","external_name":"hour","restriction":"Int32"},{"name":"minute","default_value":"0","external_name":"minute","restriction":"Int32"},{"name":"second","default_value":"0","external_name":"second","restriction":"Int32"},{"name":"","external_name":"","restriction":""},{"name":"nanosecond","default_value":"0","external_name":"nanosecond","restriction":"Int32"},{"name":"location","default_value":"Location.local","external_name":"location","restriction":"Location"}],"args_string":"(year : Int32, month : Int32, day : Int32, hour : Int32 = 0, minute : Int32 = 0, second : Int32 = 0, *, nanosecond : Int32 = 0, location : Location = Location.local) : Time","args_html":"(year : <a href=\"Int32.html\">Int32</a>, month : <a href=\"Int32.html\">Int32</a>, day : <a href=\"Int32.html\">Int32</a>, hour : <a href=\"Int32.html\">Int32</a> = <span class=\"n\">0</span>, minute : <a href=\"Int32.html\">Int32</a> = <span class=\"n\">0</span>, second : <a href=\"Int32.html\">Int32</a> = <span class=\"n\">0</span>, *, nanosecond : <a href=\"Int32.html\">Int32</a> = <span class=\"n\">0</span>, location : <a href=\"Time/Location.html\">Location</a> = <span class=\"t\">Location</span>.local) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":410,"url":null},"def":{"name":"local","args":[{"name":"year","external_name":"year","restriction":"Int32"},{"name":"month","external_name":"month","restriction":"Int32"},{"name":"day","external_name":"day","restriction":"Int32"},{"name":"hour","default_value":"0","external_name":"hour","restriction":"Int32"},{"name":"minute","default_value":"0","external_name":"minute","restriction":"Int32"},{"name":"second","default_value":"0","external_name":"second","restriction":"Int32"},{"name":"","external_name":"","restriction":""},{"name":"nanosecond","default_value":"0","external_name":"nanosecond","restriction":"Int32"},{"name":"location","default_value":"Location.local","external_name":"location","restriction":"Location"}],"splat_index":6,"return_type":"Time","visibility":"Public","body":"if ((((((1 <= year && year <= 9999) && (1 <= month && month <= 12)) && (1 <= day && day <= (Time.days_in_month(year, month)))) && ((0 <= hour && hour <= 23) || ((((hour == 24) && (minute == 0)) && (second == 0)) && (nanosecond == 0)))) && (0 <= minute && minute <= 59)) && (0 <= second && second <= 59)) && (0 <= nanosecond && nanosecond <= 999999999)\nelse\n  raise(ArgumentError.new(\"Invalid time\"))\nend\ndays = absolute_days(year, month, day)\nseconds = ((((1_i64 * SECONDS_PER_DAY) * days) + (SECONDS_PER_HOUR * hour)) + (SECONDS_PER_MINUTE * minute)) + second\nif !location.utc?\n  seconds = seconds - (zone_offset_at(seconds, location))\nend\nnew(seconds: seconds, nanoseconds: nanosecond.to_i, location: location)\n"}},{"html_id":"local(location:Location=Location.local):Time-class-method","name":"local","doc":"Creates a new `Time` instance representing the current time from the\nsystem clock observed in *location* (defaults to local time zone).","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance representing the current time from the system clock observed in <em>location</em> (defaults to local time zone).</p>","abstract":false,"args":[{"name":"location","default_value":"Location.local","external_name":"location","restriction":"Location"}],"args_string":"(location : Location = Location.local) : Time","args_html":"(location : <a href=\"Time/Location.html\">Location</a> = <span class=\"t\">Location</span>.local) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":362,"url":null},"def":{"name":"local","args":[{"name":"location","default_value":"Location.local","external_name":"location","restriction":"Location"}],"return_type":"Time","visibility":"Public","body":"seconds, nanoseconds = Crystal::System::Time.compute_utc_seconds_and_nanoseconds\nnew(seconds: seconds, nanoseconds: nanoseconds, location: location)\n"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":304,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"parse_scalar(ctx, node, Time)"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":"Reads a string from JSON parser as a time formatted according to [RFC 3339](https://tools.ietf.org/html/rfc3339)\nor other variations of [ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf).\n\nThe JSON format itself does not specify a time data type, this method just\nassumes that a string holding a ISO 8601 time format can be interpreted as a\ntime value.\n\nSee `#to_json` for reference.","summary":"<p>Reads a string from JSON parser as a time formatted according to <a href=\"https://tools.ietf.org/html/rfc3339\">RFC 3339</a> or other variations of <a href=\"http://xml.coverpages.org/ISO-FDIS-8601.pdf\">ISO 8601</a>.</p>","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":387,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"Time::Format::ISO_8601_DATE_TIME.parse(pull.read_string)"}},{"html_id":"new(*,seconds:Int64,nanoseconds:Int32,location:Location)-class-method","name":"new","doc":"Creates a new `Time` instance that corresponds to the number of *seconds*\nand *nanoseconds* elapsed from epoch (`0001-01-01 00:00:00.0 UTC`)\nobserved in *location*.\n\nValid range for *seconds* is `0..315_537_897_599`.\nFor *nanoseconds* it is `0..999_999_999`.","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance that corresponds to the number of <em>seconds</em> and <em>nanoseconds</em> elapsed from epoch (<code>0001-01-01 00:00:00.0 UTC</code>) observed in <em>location</em>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"seconds","external_name":"seconds","restriction":"Int64"},{"name":"nanoseconds","external_name":"nanoseconds","restriction":"Int32"},{"name":"location","external_name":"location","restriction":"Location"}],"args_string":"(*, seconds : Int64, nanoseconds : Int32, location : Location)","args_html":"(*, seconds : <a href=\"Int64.html\">Int64</a>, nanoseconds : <a href=\"Int32.html\">Int32</a>, location : <a href=\"Time/Location.html\">Location</a>)","location":{"filename":"src/time.cr","line_number":474,"url":null},"def":{"name":"new","args":[{"name":"","external_name":"","restriction":""},{"name":"seconds","external_name":"seconds","restriction":"Int64"},{"name":"nanoseconds","external_name":"nanoseconds","restriction":"Int32"},{"name":"location","external_name":"location","restriction":"Location"}],"splat_index":0,"visibility":"Public","body":"_ = allocate\n_.initialize(seconds: seconds, nanoseconds: nanoseconds, location: location)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"parse(time:String,pattern:String,location:Location):Time-class-method","name":"parse","doc":"Parses a `Time` from *time* string using the given *pattern*.\n\nSee `Time::Format` for details.\n\n```\nTime.parse(\"2016-04-05\", \"%F\", Time::Location.load(\"Europe/Berlin\")) # => 2016-04-05 00:00:00.0 +02:00 Europe/Berlin\n```\n\nIf there is no time zone information in the formatted time, *location* will\nbe assumed. When *location* is `nil`, in such a case the parser will raise\n`Time::Format::Error`.","summary":"<p>Parses a <code><a href=\"Time.html\">Time</a></code> from <em>time</em> string using the given <em>pattern</em>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"String"},{"name":"pattern","external_name":"pattern","restriction":"String"},{"name":"location","external_name":"location","restriction":"Location"}],"args_string":"(time : String, pattern : String, location : Location) : Time","args_html":"(time : <a href=\"String.html\">String</a>, pattern : <a href=\"String.html\">String</a>, location : <a href=\"Time/Location.html\">Location</a>) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":1172,"url":null},"def":{"name":"parse","args":[{"name":"time","external_name":"time","restriction":"String"},{"name":"pattern","external_name":"pattern","restriction":"String"},{"name":"location","external_name":"location","restriction":"Location"}],"return_type":"Time","visibility":"Public","body":"(Format.new(pattern, location)).parse(time)"}},{"html_id":"parse!(time:String,pattern:String):Time-class-method","name":"parse!","doc":"Parses a `Time` from *time* string using the given *pattern*.\n\nSee `Time::Format` for details.\n\n```\nTime.parse!(\"2016-04-05 +00:00\", \"%F %:z\") # => 2016-04-05 00:00:00.0 +00:00\nTime.parse!(\"2016-04-05\", \"%F\")            # raises Time::Format::Error\n```\n\nIf there is no time zone information in the formatted time, the parser will raise\n`Time::Format::Error`.","summary":"<p>Parses a <code><a href=\"Time.html\">Time</a></code> from <em>time</em> string using the given <em>pattern</em>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"String"},{"name":"pattern","external_name":"pattern","restriction":"String"}],"args_string":"(time : String, pattern : String) : Time","args_html":"(time : <a href=\"String.html\">String</a>, pattern : <a href=\"String.html\">String</a>) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":1187,"url":null},"def":{"name":"parse!","args":[{"name":"time","external_name":"time","restriction":"String"},{"name":"pattern","external_name":"pattern","restriction":"String"}],"return_type":"Time","visibility":"Public","body":"(Format.new(pattern, nil)).parse(time)"}},{"html_id":"parse_local(time:String,pattern:String):Time-class-method","name":"parse_local","doc":"Parses a `Time` from *time* string using the given *pattern* and\n`Time::Location.local` as default location\n\nSee `Time::Format` for details.\n\n```\nTime.parse_utc(\"2016-04-05\", \"%F\") # => 2016-04-05 00:00:00.0 +00:00\n```\n\n`Time::Location.local` will only be used as `location` if the formatted time\ndoes not contain any time zone information. The return value can't be\nassumed to be a UTC time (this can be achieved by calling `#to_local`).","summary":"<p>Parses a <code><a href=\"Time.html\">Time</a></code> from <em>time</em> string using the given <em>pattern</em> and <code><a href=\"Time/Location.html#local%3ALocation-class-method\">Time::Location.local</a></code> as default location</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"String"},{"name":"pattern","external_name":"pattern","restriction":"String"}],"args_string":"(time : String, pattern : String) : Time","args_html":"(time : <a href=\"String.html\">String</a>, pattern : <a href=\"String.html\">String</a>) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":1219,"url":null},"def":{"name":"parse_local","args":[{"name":"time","external_name":"time","restriction":"String"},{"name":"pattern","external_name":"pattern","restriction":"String"}],"return_type":"Time","visibility":"Public","body":"parse(time, pattern, Location.local)"}},{"html_id":"parse_rfc2822(time:String):self-class-method","name":"parse_rfc2822","doc":"Parse time format specified by [RFC 2822](https://www.ietf.org/rfc/rfc2822.txt).\n\nThis is also compatible to [RFC 882](https://tools.ietf.org/html/rfc882) and [RFC 1123](https://tools.ietf.org/html/rfc1123#page-55).","summary":"<p>Parse time format specified by <a href=\"https://www.ietf.org/rfc/rfc2822.txt\">RFC 2822</a>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"String"}],"args_string":"(time : String) : self","args_html":"(time : <a href=\"String.html\">String</a>) : <span class=\"k\">self</span>","location":{"filename":"src/time.cr","line_number":1157,"url":null},"def":{"name":"parse_rfc2822","args":[{"name":"time","external_name":"time","restriction":"String"}],"return_type":"self","visibility":"Public","body":"Format::RFC_2822.parse(time)"}},{"html_id":"parse_rfc3339(time:String):self-class-method","name":"parse_rfc3339","doc":"Parse time format specified by [RFC 3339](https://tools.ietf.org/html/rfc3339) ([ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf) profile).","summary":"<p>Parse time format specified by <a href=\"https://tools.ietf.org/html/rfc3339\">RFC 3339</a> (<a href=\"http://xml.coverpages.org/ISO-FDIS-8601.pdf\">ISO 8601</a> profile).</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"String"}],"args_string":"(time : String) : self","args_html":"(time : <a href=\"String.html\">String</a>) : <span class=\"k\">self</span>","location":{"filename":"src/time.cr","line_number":1121,"url":null},"def":{"name":"parse_rfc3339","args":[{"name":"time","external_name":"time","restriction":"String"}],"return_type":"self","visibility":"Public","body":"Format::RFC_3339.parse(time)"}},{"html_id":"parse_utc(time:String,pattern:String):Time-class-method","name":"parse_utc","doc":"Parses a `Time` from *time* string using the given *pattern* and\n`Time::Location::UTC` as default location.\n\nSee `Time::Format` for details.\n\n```\nTime.parse_utc(\"2016-04-05\", \"%F\") # => 2016-04-05 00:00:00.0 +00:00\n```\n\n`Time::Location::UTC` will only be used as `location` if the formatted time\ndoes not contain any time zone information. The return value can't be\nassumed to be a UTC time (this can be achieved by calling `#to_utc`).","summary":"<p>Parses a <code><a href=\"Time.html\">Time</a></code> from <em>time</em> string using the given <em>pattern</em> and <code><a href=\"Time/Location.html#UTC\">Time::Location::UTC</a></code> as default location.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"String"},{"name":"pattern","external_name":"pattern","restriction":"String"}],"args_string":"(time : String, pattern : String) : Time","args_html":"(time : <a href=\"String.html\">String</a>, pattern : <a href=\"String.html\">String</a>) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":1203,"url":null},"def":{"name":"parse_utc","args":[{"name":"time","external_name":"time","restriction":"String"},{"name":"pattern","external_name":"pattern","restriction":"String"}],"return_type":"Time","visibility":"Public","body":"parse(time, pattern, Location::UTC)"}},{"html_id":"unix(seconds:Int):Time-class-method","name":"unix","doc":"Creates a new `Time` instance that corresponds to the number of\n*seconds* elapsed since the Unix epoch (`1970-01-01 00:00:00 UTC`).\n\nThe time zone is always UTC.\n\n```\nTime.unix(981173106) # => 2001-02-03 04:05:06 UTC\n```","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance that corresponds to the number of <em>seconds</em> elapsed since the Unix epoch (<code>1970-01-01 00:00:00 UTC</code>).</p>","abstract":false,"args":[{"name":"seconds","external_name":"seconds","restriction":"Int"}],"args_string":"(seconds : Int) : Time","args_html":"(seconds : <a href=\"Int.html\">Int</a>) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":518,"url":null},"def":{"name":"unix","args":[{"name":"seconds","external_name":"seconds","restriction":"Int"}],"return_type":"Time","visibility":"Public","body":"utc(seconds: UNIX_EPOCH.total_seconds + seconds, nanoseconds: 0)"}},{"html_id":"unix_ms(milliseconds:Int):Time-class-method","name":"unix_ms","doc":"Creates a new `Time` instance that corresponds to the number of\n*milliseconds* elapsed since the Unix epoch (`1970-01-01 00:00:00 UTC`).\n\nThe time zone is always UTC.\n\n```\ntime = Time.unix_ms(981173106789) # => 2001-02-03 04:05:06.789 UTC\ntime.millisecond                  # => 789\n```","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance that corresponds to the number of <em>milliseconds</em> elapsed since the Unix epoch (<code>1970-01-01 00:00:00 UTC</code>).</p>","abstract":false,"args":[{"name":"milliseconds","external_name":"milliseconds","restriction":"Int"}],"args_string":"(milliseconds : Int) : Time","args_html":"(milliseconds : <a href=\"Int.html\">Int</a>) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":531,"url":null},"def":{"name":"unix_ms","args":[{"name":"milliseconds","external_name":"milliseconds","restriction":"Int"}],"return_type":"Time","visibility":"Public","body":"milliseconds = milliseconds.to_i64\nseconds = UNIX_EPOCH.total_seconds + (milliseconds // 1000)\nnanoseconds = (milliseconds % 1000) * NANOSECONDS_PER_MILLISECOND\nutc(seconds: seconds, nanoseconds: nanoseconds.to_i)\n"}},{"html_id":"utc(year:Int32,month:Int32,day:Int32,hour:Int32=0,minute:Int32=0,second:Int32=0,*,nanosecond:Int32=0):Time-class-method","name":"utc","doc":"Creates a new `Time` instance representing the given date-time in UTC.\n\n```\ntime = Time.utc(2016, 2, 15, 10, 20, 30)\ntime.to_s # => \"2016-02-15 10:20:30 UTC\"\n```\n\nValid value ranges for the individual fields:\n\n* `year`: `1..9999`\n* `month`: `1..12`\n* `day`: `1` - `28`/`29`/`30`/`31` (depending on month and year)\n* `hour`: `0..23`\n* `minute`: `0..59`\n* `second`: `0..59`\n* `nanosecond`: `0..999_999_999`\n\nThe time-of-day can be omitted and defaults to midnight (start of day):\n\n```\ntime = Time.utc(2016, 2, 15)\ntime.to_s # => \"2016-02-15 00:00:00 UTC\"\n```\n\nSince UTC does not have any time zone transitions, each date-time is\nunambiguously resolved.","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance representing the given date-time in UTC.</p>","abstract":false,"args":[{"name":"year","external_name":"year","restriction":"Int32"},{"name":"month","external_name":"month","restriction":"Int32"},{"name":"day","external_name":"day","restriction":"Int32"},{"name":"hour","default_value":"0","external_name":"hour","restriction":"Int32"},{"name":"minute","default_value":"0","external_name":"minute","restriction":"Int32"},{"name":"second","default_value":"0","external_name":"second","restriction":"Int32"},{"name":"","external_name":"","restriction":""},{"name":"nanosecond","default_value":"0","external_name":"nanosecond","restriction":"Int32"}],"args_string":"(year : Int32, month : Int32, day : Int32, hour : Int32 = 0, minute : Int32 = 0, second : Int32 = 0, *, nanosecond : Int32 = 0) : Time","args_html":"(year : <a href=\"Int32.html\">Int32</a>, month : <a href=\"Int32.html\">Int32</a>, day : <a href=\"Int32.html\">Int32</a>, hour : <a href=\"Int32.html\">Int32</a> = <span class=\"n\">0</span>, minute : <a href=\"Int32.html\">Int32</a> = <span class=\"n\">0</span>, second : <a href=\"Int32.html\">Int32</a> = <span class=\"n\">0</span>, *, nanosecond : <a href=\"Int32.html\">Int32</a> = <span class=\"n\">0</span>) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":464,"url":null},"def":{"name":"utc","args":[{"name":"year","external_name":"year","restriction":"Int32"},{"name":"month","external_name":"month","restriction":"Int32"},{"name":"day","external_name":"day","restriction":"Int32"},{"name":"hour","default_value":"0","external_name":"hour","restriction":"Int32"},{"name":"minute","default_value":"0","external_name":"minute","restriction":"Int32"},{"name":"second","default_value":"0","external_name":"second","restriction":"Int32"},{"name":"","external_name":"","restriction":""},{"name":"nanosecond","default_value":"0","external_name":"nanosecond","restriction":"Int32"}],"splat_index":6,"return_type":"Time","visibility":"Public","body":"local(year, month, day, hour, minute, second, nanosecond: nanosecond, location: Location::UTC)"}},{"html_id":"utc:Time-class-method","name":"utc","doc":"Creates a new `Time` instance representing the current time from the\nsystem clock in UTC.","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance representing the current time from the system clock in UTC.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":369,"url":null},"def":{"name":"utc","return_type":"Time","visibility":"Public","body":"local(Location::UTC)"}},{"html_id":"utc(*,seconds:Int64,nanoseconds:Int32):Time-class-method","name":"utc","doc":"Creates a new `Time` instance that corresponds to the number of *seconds*\nand *nanoseconds* elapsed from epoch (`0001-01-01 00:00:00.0 UTC`)\nin UTC.\n\nValid range for *seconds* is `0..315_537_897_599`.\nFor *nanoseconds* it is `0..999_999_999`.","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance that corresponds to the number of <em>seconds</em> and <em>nanoseconds</em> elapsed from epoch (<code>0001-01-01 00:00:00.0 UTC</code>) in UTC.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"seconds","external_name":"seconds","restriction":"Int64"},{"name":"nanoseconds","external_name":"nanoseconds","restriction":"Int32"}],"args_string":"(*, seconds : Int64, nanoseconds : Int32) : Time","args_html":"(*, seconds : <a href=\"Int64.html\">Int64</a>, nanoseconds : <a href=\"Int32.html\">Int32</a>) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":497,"url":null},"def":{"name":"utc","args":[{"name":"","external_name":"","restriction":""},{"name":"seconds","external_name":"seconds","restriction":"Int64"},{"name":"nanoseconds","external_name":"nanoseconds","restriction":"Int32"}],"splat_index":0,"return_type":"Time","visibility":"Public","body":"new(seconds: seconds, nanoseconds: nanoseconds, location: Location::UTC)"}},{"html_id":"week_date(year:Int32,week:Int32,day_of_week:Int32|DayOfWeek,hour:Int32=0,minute:Int32=0,second:Int32=0,*,nanosecond:Int32=0,location:Location=Location.local):self-class-method","name":"week_date","doc":"Creates an instance specified by a commercial week date consisting of ISO\ncalendar *year*, *week* and a *day_of_week*.\n\nThis equates to the results from `#calendar_week` and `#day_of_week`.\n\nValid value ranges for the individual fields:\n\n* `year`: `1..9999`\n* `week`: `1..53`\n* `day_of_week`: `1..7`","summary":"<p>Creates an instance specified by a commercial week date consisting of ISO calendar <em>year</em>, <em>week</em> and a <em>day_of_week</em>.</p>","abstract":false,"args":[{"name":"year","external_name":"year","restriction":"Int32"},{"name":"week","external_name":"week","restriction":"Int32"},{"name":"day_of_week","external_name":"day_of_week","restriction":"Int32 | DayOfWeek"},{"name":"hour","default_value":"0","external_name":"hour","restriction":"Int32"},{"name":"minute","default_value":"0","external_name":"minute","restriction":"Int32"},{"name":"second","default_value":"0","external_name":"second","restriction":"Int32"},{"name":"","external_name":"","restriction":""},{"name":"nanosecond","default_value":"0","external_name":"nanosecond","restriction":"Int32"},{"name":"location","default_value":"Location.local","external_name":"location","restriction":"Location"}],"args_string":"(year : Int32, week : Int32, day_of_week : Int32 | DayOfWeek, hour : Int32 = 0, minute : Int32 = 0, second : Int32 = 0, *, nanosecond : Int32 = 0, location : Location = Location.local) : self","args_html":"(year : <a href=\"Int32.html\">Int32</a>, week : <a href=\"Int32.html\">Int32</a>, day_of_week : <a href=\"Int32.html\">Int32</a> | <a href=\"Time/DayOfWeek.html\">DayOfWeek</a>, hour : <a href=\"Int32.html\">Int32</a> = <span class=\"n\">0</span>, minute : <a href=\"Int32.html\">Int32</a> = <span class=\"n\">0</span>, second : <a href=\"Int32.html\">Int32</a> = <span class=\"n\">0</span>, *, nanosecond : <a href=\"Int32.html\">Int32</a> = <span class=\"n\">0</span>, location : <a href=\"Time/Location.html\">Location</a> = <span class=\"t\">Location</span>.local) : <span class=\"k\">self</span>","location":{"filename":"src/time.cr","line_number":869,"url":null},"def":{"name":"week_date","args":[{"name":"year","external_name":"year","restriction":"Int32"},{"name":"week","external_name":"week","restriction":"Int32"},{"name":"day_of_week","external_name":"day_of_week","restriction":"Int32 | DayOfWeek"},{"name":"hour","default_value":"0","external_name":"hour","restriction":"Int32"},{"name":"minute","default_value":"0","external_name":"minute","restriction":"Int32"},{"name":"second","default_value":"0","external_name":"second","restriction":"Int32"},{"name":"","external_name":"","restriction":""},{"name":"nanosecond","default_value":"0","external_name":"nanosecond","restriction":"Int32"},{"name":"location","default_value":"Location.local","external_name":"location","restriction":"Location"}],"splat_index":6,"return_type":"self","visibility":"Public","body":"jan4_day_of_week = (Time.utc(year, 1, 4)).day_of_week\ncorrection = jan4_day_of_week.to_i + 4\nordinal = ((week * 7) + day_of_week.to_i) - correction\nif ordinal < 1\n  year = year - 1\n  ordinal = ordinal + (Time.days_in_year(year))\nelse\n  if ordinal > (days_in_year = Time.days_in_year(year))\n    ordinal = ordinal - days_in_year\n    year = year + 1\n  end\nend\ntime = (Time.utc(year, 1, 1, hour, minute, second, nanosecond: nanosecond)) + ordinal.days\nif location.utc?\n  return time\nend\ntime = time.in(location: location)\ntime - time.offset.seconds\n"}}],"instance_methods":[{"html_id":"+(span:Time::Span):Time-instance-method","name":"+","doc":"Returns a copy of this `Time` with *span* added.\n\nSee `#shift` for details.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> with <em>span</em> added.</p>","abstract":false,"args":[{"name":"span","external_name":"span","restriction":"Time::Span"}],"args_string":"(span : Time::Span) : Time","args_html":"(span : <a href=\"Time/Span.html\">Time::Span</a>) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":567,"url":null},"def":{"name":"+","args":[{"name":"span","external_name":"span","restriction":"Time::Span"}],"return_type":"Time","visibility":"Public","body":"shift(span.to_i, span.nanoseconds)"}},{"html_id":"+(span:Time::MonthSpan):Time-instance-method","name":"+","doc":"Returns a copy of this `Time` with *span* added.\n\nIt adds the number of months with overflow increasing the year.\nIf the resulting day-of-month would be invalid, it is adjusted to the last\nvalid day of the month.\n\nFor example, adding `1.month` to `2007-03-31` would result in the invalid\ndate `2007-04-31` which will be adjusted to `2007-04-30`.\n\nThis operates on the local time-line, such that the local date-time\nrepresentations of month and year are increased by the specified amount.\n\nIf the resulting date-time is ambiguous due to time zone transitions,\na correct time will be returned, but it does not guarantee which.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> with <em>span</em> added.</p>","abstract":false,"args":[{"name":"span","external_name":"span","restriction":"Time::MonthSpan"}],"args_string":"(span : Time::MonthSpan) : Time","args_html":"(span : <a href=\"Time/MonthSpan.html\">Time::MonthSpan</a>) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":592,"url":null},"def":{"name":"+","args":[{"name":"span","external_name":"span","restriction":"Time::MonthSpan"}],"return_type":"Time","visibility":"Public","body":"shift(months: span.value.to_i)"}},{"html_id":"-(other:Time):Time::Span-instance-method","name":"-","doc":"Returns a `Time::Span` amounting to the duration between *other* and `self`.\n\nThe time span is negative if `self` is before *other*.\n\nThe duration amounts to the actual time elapsed between both instances, on\nthe instant time-line.\nThe difference between local date-time representations may equal to a\ndifferent duration, depending on time zone transitions.","summary":"<p>Returns a <code><a href=\"Time/Span.html\">Time::Span</a></code> amounting to the duration between <em>other</em> and <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Time"}],"args_string":"(other : Time) : Time::Span","args_html":"(other : <a href=\"Time.html\">Time</a>) : <a href=\"Time/Span.html\">Time::Span</a>","location":{"filename":"src/time.cr","line_number":749,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Time"}],"return_type":"Time::Span","visibility":"Public","body":"Span.new(seconds: total_seconds - other.total_seconds, nanoseconds: nanosecond - other.nanosecond)"}},{"html_id":"-(span:Time::Span):Time-instance-method","name":"-","doc":"Returns a copy of this `Time` with *span* subtracted.\n\nSee `#shift` for details.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> with <em>span</em> subtracted.</p>","abstract":false,"args":[{"name":"span","external_name":"span","restriction":"Time::Span"}],"args_string":"(span : Time::Span) : Time","args_html":"(span : <a href=\"Time/Span.html\">Time::Span</a>) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":574,"url":null},"def":{"name":"-","args":[{"name":"span","external_name":"span","restriction":"Time::Span"}],"return_type":"Time","visibility":"Public","body":"shift(-span.to_i, -span.nanoseconds)"}},{"html_id":"-(span:Time::MonthSpan):Time-instance-method","name":"-","doc":"Returns a copy of this `Time` with *span* subtracted.\n\nIt adds the number of months with overflow decreasing the year.\nIf the resulting day-of-month would be invalid, it is adjusted to the last\nvalid day of the month.\n\nFor example, subtracting `1.month` from `2007-05-31` would result in the invalid\ndate `2007-04-31` which will be adjusted to `2007-04-30`.\n\nThis operates on the local time-line, such that the local date-time\nrepresentations of month and year are decreased by the specified amount.\n\nIf the resulting date-time is ambiguous due to time zone transitions,\na correct time will be returned, but it does not guarantee which.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> with <em>span</em> subtracted.</p>","abstract":false,"args":[{"name":"span","external_name":"span","restriction":"Time::MonthSpan"}],"args_string":"(span : Time::MonthSpan) : Time","args_html":"(span : <a href=\"Time/MonthSpan.html\">Time::MonthSpan</a>) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":610,"url":null},"def":{"name":"-","args":[{"name":"span","external_name":"span","restriction":"Time::MonthSpan"}],"return_type":"Time","visibility":"Public","body":"shift(months: -span.value.to_i)"}},{"html_id":"<=>(other:Time):Int32-instance-method","name":"<=>","doc":"Compares this `Time` with *other*.\n\nThe comparison is based on the instant time-line, even if the local\ndate-time representation (wall clock) would compare differently.\n\nTo ensure the comparison is also true for local wall clock, both date-times\nneed to be transformed to the same time zone.","summary":"<p>Compares this <code><a href=\"Time.html\">Time</a></code> with <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Time"}],"args_string":"(other : Time) : Int32","args_html":"(other : <a href=\"Time.html\">Time</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/time.cr","line_number":965,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Time"}],"return_type":"Int32","visibility":"Public","body":"cmp = total_seconds <=> other.total_seconds\nif cmp == 0\n  cmp = nanosecond <=> other.nanosecond\nend\ncmp\n"}},{"html_id":"==(other:Time):Bool-instance-method","name":"==","doc":"Compares this `Time` with *other* for equality.\n\nTwo instances are considered equal if they represent the same date-time in\nthe instant time-line, even if they show a different local date-time.\n\n```\ntime_de = Time.local(2018, 3, 8, 22, 5, 13, location: Time::Location.load(\"Europe/Berlin\"))\ntime_ar = Time.local(2018, 3, 8, 18, 5, 13, location: Time::Location.load(\"America/Buenos_Aires\"))\ntime_de == time_ar # => true\n\n# both times represent the same instant:\ntime_de.to_utc # => 2018-03-08 21:05:13 UTC\ntime_ar.to_utc # => 2018-03-08 21:05:13 UTC\n```","summary":"<p>Compares this <code><a href=\"Time.html\">Time</a></code> with <em>other</em> for equality.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Time"}],"args_string":"(other : Time) : Bool","args_html":"(other : <a href=\"Time.html\">Time</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/time.cr","line_number":985,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Time"}],"return_type":"Bool","visibility":"Public","body":"(total_seconds == other.total_seconds) && (nanosecond == other.nanosecond)"}},{"html_id":"at_beginning_of_day:Time-instance-method","name":"at_beginning_of_day","doc":"Returns a copy of this `Time` representing the beginning of the day.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the day.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1333,"url":null},"def":{"name":"at_beginning_of_day","return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.local(year, month, day, location: location)\n"}},{"html_id":"at_beginning_of_hour:Time-instance-method","name":"at_beginning_of_hour","doc":"Returns a copy of this `Time` representing the beginning of the hour.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the hour.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1334,"url":null},"def":{"name":"at_beginning_of_hour","return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.local(year, month, day, hour, location: location)\n"}},{"html_id":"at_beginning_of_minute:Time-instance-method","name":"at_beginning_of_minute","doc":"Returns a copy of this `Time` representing the beginning of the minute.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the minute.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1337,"url":null},"def":{"name":"at_beginning_of_minute","return_type":"Time","visibility":"Public","body":"Time.new(seconds: total_seconds - second, nanoseconds: 0, location: location)"}},{"html_id":"at_beginning_of_month:Time-instance-method","name":"at_beginning_of_month","doc":"Returns a copy of this `Time` representing the beginning of the month.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the month.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1332,"url":null},"def":{"name":"at_beginning_of_month","return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.local(year, month, 1, location: location)\n"}},{"html_id":"at_beginning_of_quarter:Time-instance-method","name":"at_beginning_of_quarter","doc":"Returns a copy of this `Time` representing the beginning of the quarter.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the quarter.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1331,"url":null},"def":{"name":"at_beginning_of_quarter","return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.local(year, (((month - 1) // 3) * 3) + 1, 1, location: location)\n"}},{"html_id":"at_beginning_of_second:Time-instance-method","name":"at_beginning_of_second","doc":"Returns a copy of this `Time` representing the beginning of the seconds.\n\nThis essentially resets `nanoseconds` to 0.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the seconds.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1344,"url":null},"def":{"name":"at_beginning_of_second","return_type":"Time","visibility":"Public","body":"Time.new(seconds: total_seconds, nanoseconds: 0, location: location)"}},{"html_id":"at_beginning_of_semester:Time-instance-method","name":"at_beginning_of_semester","doc":"Returns a copy of this `Time` representing the beginning of the semester.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the semester.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1330,"url":null},"def":{"name":"at_beginning_of_semester","return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.local(year, (((month - 1) // 6) * 6) + 1, 1, location: location)\n"}},{"html_id":"at_beginning_of_week:Time-instance-method","name":"at_beginning_of_week","doc":"Returns a copy of this `Time` representing the beginning of the week.\n\nTODO: Ensure correctness in local time-line.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the week.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1351,"url":null},"def":{"name":"at_beginning_of_week","return_type":"Time","visibility":"Public","body":"(self - (day_of_week.value - 1).days).at_beginning_of_day"}},{"html_id":"at_beginning_of_year:Time-instance-method","name":"at_beginning_of_year","doc":"Returns a copy of this `Time` representing the beginning of the year.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the beginning of the year.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1329,"url":null},"def":{"name":"at_beginning_of_year","return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.local(year, 1, 1, location: location)\n"}},{"html_id":"at_end_of_day:Time-instance-method","name":"at_end_of_day","doc":"Returns a copy of this `Time` representing the end of the day.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the day.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1392,"url":null},"def":{"name":"at_end_of_day","return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.local(year, month, day, 23, 59, 59, nanosecond: 999999999, location: location)\n"}},{"html_id":"at_end_of_hour:Time-instance-method","name":"at_end_of_hour","doc":"Returns a copy of this `Time` representing the end of the hour.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the hour.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1393,"url":null},"def":{"name":"at_end_of_hour","return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.local(year, month, day, hour, 59, 59, nanosecond: 999999999, location: location)\n"}},{"html_id":"at_end_of_minute:Time-instance-method","name":"at_end_of_minute","doc":"Returns a copy of this `Time` representing the end of the minute.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the minute.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1396,"url":null},"def":{"name":"at_end_of_minute","return_type":"Time","visibility":"Public","body":"Time.new(seconds: (total_seconds - second) + 59, nanoseconds: 999999999, location: location)"}},{"html_id":"at_end_of_month:Time-instance-method","name":"at_end_of_month","doc":"Returns a copy of this `Time` representing the end of the month.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the month.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1383,"url":null},"def":{"name":"at_end_of_month","return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.local(year, month, Time.days_in_month(year, month), 23, 59, 59, nanosecond: 999999999, location: location)\n"}},{"html_id":"at_end_of_quarter:Time-instance-method","name":"at_end_of_quarter","doc":"Returns a copy of this `Time` representing the end of the quarter.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the quarter.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1369,"url":null},"def":{"name":"at_end_of_quarter","return_type":"Time","visibility":"Public","body":"year, month, _, _ = year_month_day_day_year\nif month <= 3\n  month, day = 3, 31\nelse\n  if month <= 6\n    month, day = 6, 30\n  else\n    if month <= 9\n      month, day = 9, 30\n    else\n      month, day = 12, 31\n    end\n  end\nend\nTime.local(year, month, day, 23, 59, 59, nanosecond: 999999999, location: location)\n"}},{"html_id":"at_end_of_second:Time-instance-method","name":"at_end_of_second","doc":"Returns a copy of this `Time` representing the end of the second.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the second.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1401,"url":null},"def":{"name":"at_end_of_second","return_type":"Time","visibility":"Public","body":"Time.new(seconds: total_seconds, nanoseconds: 999999999, location: location)"}},{"html_id":"at_end_of_semester:Time-instance-method","name":"at_end_of_semester","doc":"Returns a copy of this `Time` representing the end of the semester.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the semester.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1358,"url":null},"def":{"name":"at_end_of_semester","return_type":"Time","visibility":"Public","body":"year, month, _, _ = year_month_day_day_year\nif month <= 6\n  month, day = 6, 30\nelse\n  month, day = 12, 31\nend\nTime.local(year, month, day, 23, 59, 59, nanosecond: 999999999, location: location)\n"}},{"html_id":"at_end_of_week:Time-instance-method","name":"at_end_of_week","doc":"Returns a copy of this `Time` representing the end of the week.\n\nTODO: Ensure correctness in local time-line.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the week.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1388,"url":null},"def":{"name":"at_end_of_week","return_type":"Time","visibility":"Public","body":"(self + (7 - day_of_week.value).days).at_end_of_day"}},{"html_id":"at_end_of_year:Time-instance-method","name":"at_end_of_year","doc":"Returns a copy of this `Time` representing the end of the year.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the end of the year.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1355,"url":null},"def":{"name":"at_end_of_year","return_type":"Time","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nTime.local(year, 12, 31, 23, 59, 59, nanosecond: 999999999, location: location)\n"}},{"html_id":"at_midday:Time-instance-method","name":"at_midday","doc":"Returns a copy of this `Time` representing midday (`12:00`) of the same day.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing midday (<code>12:00</code>) of the same day.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1406,"url":null},"def":{"name":"at_midday","return_type":"Time","visibility":"Public","body":"year, month, day, _ = year_month_day_day_year\nTime.local(year, month, day, 12, 0, 0, nanosecond: 0, location: location)\n"}},{"html_id":"calendar_week:Tuple(Int32,Int32)-instance-method","name":"calendar_week","doc":"Returns the ISO calendar year and week in which this instance occurs.\n\nThe ISO calendar year to which the week belongs is not always in the same\nas the year of the regular calendar date. The first three days of January\nsometimes belong to week 52 (or 53) of the previous year;\nequally the last three days of December sometimes are already in week 1\nof the following year.\n\nFor that reason, this method returns a tuple `year, week` consisting of the\ncalendar year to which the calendar week belongs and the ordinal number of\nthe week within that year.\n\nTogether with `#day_of_week` this represents a specific day as commercial or\nweek date format `year, week, day_of_week` in the same way as the typical\nformat `year, month, day`.\n`.week_date` creates a `Time` instance from a week date.","summary":"<p>Returns the ISO calendar year and week in which this instance occurs.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":818,"url":null},"def":{"name":"calendar_week","return_type":"::Tuple(Int32, Int32)","visibility":"Public","body":"year, month, day, day_year = year_month_day_day_year\nday_of_week = self.day_of_week\nweek_number = ((day_year - day_of_week.to_i) + 10) // 7\nif week_number == 0\n  year = year - 1\n  jan1_day_of_week = DayOfWeek.from_value(((day_of_week.to_i - day_year) + 1) % 7)\n  if (jan1_day_of_week == DayOfWeek::Friday) || ((jan1_day_of_week == DayOfWeek::Saturday) && (Time.leap_year?(year)))\n    week_number = 53\n  else\n    week_number = 52\n  end\nelse\n  if week_number == 53\n    dec31_day_of_week = ((day_of_week.to_i + 31) - day) % 7\n    if dec31_day_of_week <= DayOfWeek::Wednesday.to_i\n      year = year + 1\n      week_number = 1\n    end\n  end\nend\n{year, week_number}\n"}},{"html_id":"clone:Time-instance-method","name":"clone","abstract":false,"location":{"filename":"src/time.cr","line_number":560,"url":null},"def":{"name":"clone","return_type":"Time","visibility":"Public","body":"self"}},{"html_id":"date:Tuple(Int32,Int32,Int32)-instance-method","name":"date","doc":"Returns a `Tuple` with `year`, `month` and `day`.","summary":"<p>Returns a <code><a href=\"Tuple.html\">Tuple</a></code> with <code><a href=\"Time.html#year%3AInt32-instance-method\">#year</a></code>, <code><a href=\"Time.html#month%3AInt32-instance-method\">#month</a></code> and <code><a href=\"Time.html#day%3AInt32-instance-method\">#day</a></code>.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":757,"url":null},"def":{"name":"date","return_type":"Tuple(Int32, Int32, Int32)","visibility":"Public","body":"year, month, day, _ = year_month_day_day_year\n{year, month, day}\n"}},{"html_id":"day:Int32-instance-method","name":"day","doc":"Returns the day of the month (`1..31`).","summary":"<p>Returns the day of the month (<code>1..31</code>).</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":773,"url":null},"def":{"name":"day","return_type":"Int32","visibility":"Public","body":"year_month_day_day_year[2]"}},{"html_id":"day_of_week:Time::DayOfWeek-instance-method","name":"day_of_week","doc":"Returns the day of the week (`Monday..Sunday`).","summary":"<p>Returns the day of the week (<code>Monday..Sunday</code>).</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":921,"url":null},"def":{"name":"day_of_week","return_type":"Time::DayOfWeek","visibility":"Public","body":"days = offset_seconds // SECONDS_PER_DAY\nDayOfWeek.new((days.to_i % 7) + 1)\n"}},{"html_id":"day_of_year:Int32-instance-method","name":"day_of_year","doc":"Returns the day of the year.\n\nThe value range is `1..365` in normal years and `1..366` in leap years.","summary":"<p>Returns the day of the year.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":929,"url":null},"def":{"name":"day_of_year","return_type":"Int32","visibility":"Public","body":"year_month_day_day_year[3]"}},{"html_id":"friday?:Bool-instance-method","name":"friday?","doc":"Returns `true` if the day of week is Friday.\n\nSee `#day_of_week` for details.","summary":"<p>Returns <code>true</code> if the day of week is Friday.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1411,"url":null},"def":{"name":"friday?","return_type":"Bool","visibility":"Public","body":"day_of_week.friday?"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/time.cr","line_number":989,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = total_seconds.hash(hasher)\nhasher = nanosecond.hash(hasher)\nhasher\n"}},{"html_id":"hour:Int32-instance-method","name":"hour","doc":"Returns the hour of the day (`0..23`).","summary":"<p>Returns the hour of the day (<code>0..23</code>).</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":778,"url":null},"def":{"name":"hour","return_type":"Int32","visibility":"Public","body":"((offset_seconds % SECONDS_PER_DAY) // SECONDS_PER_HOUR).to_i"}},{"html_id":"in(location:Location):Time-instance-method","name":"in","doc":"Returns a copy of this `Time` representing the same instant observed in\n*location*.\n\nThis method changes the time zone and retains the instant, which will\nusually result in a different representation of local date-time (unless\nboth locations have the same offset).\n\nAmbiguous time zone transitions such as gaps and overlaps have no effect on\nthe result because it retains the same instant.\n\n```\ntime_de = Time.local(2018, 3, 8, 22, 5, 13, location: Time::Location.load(\"Europe/Berlin\"))\ntime_ar = time_de.in Time::Location.load(\"America/Buenos_Aires\")\ntime_de # => 2018-03-08 22:05:13 +01:00 Europe/Berlin\ntime_ar # => 2018-03-08 18:05:13 -03:00 America/Buenos_Aires\n```\n\nIn contrast, `#to_local_in` changes to a different location while\npreserving the same wall time, which results in different instants on the\ntime line.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the same instant observed in <em>location</em>.</p>","abstract":false,"args":[{"name":"location","external_name":"location","restriction":"Location"}],"args_string":"(location : Location) : Time","args_html":"(location : <a href=\"Time/Location.html\">Location</a>) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":1276,"url":null},"def":{"name":"in","args":[{"name":"location","external_name":"location","restriction":"Location"}],"return_type":"Time","visibility":"Public","body":"if location == self.location\n  return self\nend\nTime.new(seconds: total_seconds, nanoseconds: nanosecond, location: location)\n"}},{"html_id":"inspect(io:IO,with_nanoseconds=true):Nil-instance-method","name":"inspect","doc":"Prints this `Time` to *io*.\n\nThe local date-time is formatted as date string `YYYY-MM-DD HH:mm:ss.nnnnnnnnn +ZZ:ZZ:ZZ`.\nNanoseconds are omitted if *with_nanoseconds* is `false`.\nWhen the location is `UTC`, the offset is omitted. Offset seconds are omitted if `0`.\n\nThe name of the location is appended unless it is a fixed zone offset.","summary":"<p>Prints this <code><a href=\"Time.html\">Time</a></code> to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"with_nanoseconds","default_value":"true","external_name":"with_nanoseconds","restriction":""}],"args_string":"(io : IO, with_nanoseconds = true) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, with_nanoseconds = <span class=\"n\">true</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/time.cr","line_number":1039,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"with_nanoseconds","default_value":"true","external_name":"with_nanoseconds","restriction":""}],"return_type":"Nil","visibility":"Public","body":"to_s(io, \"%F %T\")\nif with_nanoseconds\n  if @nanoseconds == 0\n    io << \".0\"\n  else\n    to_s(io, \".%N\")\n  end\nend\nif utc?\n  io << \" UTC\"\nelse\n  io << ' '\n  zone.format(io)\n  if location.fixed?\n  else\n    (io << ' ') << location.name\n  end\nend\n"}},{"html_id":"local?:Bool-instance-method","name":"local?","doc":"Returns `true` if `#location` equals to the local time zone\n(`Time::Location.local`).\n\nSince the system's settings may change during a program's runtime,\nthe result may not be identical between different invocations.","summary":"<p>Returns <code>true</code> if <code><a href=\"Time.html#location%3ALocation-instance-method\">#location</a></code> equals to the local time zone (<code><a href=\"Time/Location.html#local%3ALocation-class-method\">Time::Location.local</a></code>).</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":954,"url":null},"def":{"name":"local?","return_type":"Bool","visibility":"Public","body":"location.local?"}},{"html_id":"location:Location-instance-method","name":"location","doc":"Returns `Location` representing the time-zone observed by this `Time`.","summary":"<p>Returns <code><a href=\"Time/Location.html\">Location</a></code> representing the time-zone observed by this <code><a href=\"Time.html\">Time</a></code>.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":312,"url":null},"def":{"name":"location","return_type":"Location","visibility":"Public","body":"@location"}},{"html_id":"millisecond:Int32-instance-method","name":"millisecond","doc":"Returns the millisecond of the second (`0..999`).","summary":"<p>Returns the millisecond of the second (<code>0..999</code>).</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":793,"url":null},"def":{"name":"millisecond","return_type":"Int32","visibility":"Public","body":"nanosecond // NANOSECONDS_PER_MILLISECOND"}},{"html_id":"minute:Int32-instance-method","name":"minute","doc":"Returns the minute of the hour (`0..59`).","summary":"<p>Returns the minute of the hour (<code>0..59</code>).</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":783,"url":null},"def":{"name":"minute","return_type":"Int32","visibility":"Public","body":"((offset_seconds % SECONDS_PER_HOUR) // SECONDS_PER_MINUTE).to_i"}},{"html_id":"monday?:Bool-instance-method","name":"monday?","doc":"Returns `true` if the day of week is Monday.\n\nSee `#day_of_week` for details.","summary":"<p>Returns <code>true</code> if the day of week is Monday.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1411,"url":null},"def":{"name":"monday?","return_type":"Bool","visibility":"Public","body":"day_of_week.monday?"}},{"html_id":"month:Int32-instance-method","name":"month","doc":"Returns the month of the year (`1..12`).","summary":"<p>Returns the month of the year (<code>1..12</code>).</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":768,"url":null},"def":{"name":"month","return_type":"Int32","visibility":"Public","body":"year_month_day_day_year[1]"}},{"html_id":"nanosecond:Int32-instance-method","name":"nanosecond","doc":"Returns the nanosecond of the second (`0..999_999_999`).","summary":"<p>Returns the nanosecond of the second (<code>0..999_999_999</code>).</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":798,"url":null},"def":{"name":"nanosecond","return_type":"Int32","visibility":"Public","body":"@nanoseconds"}},{"html_id":"offset:Int32-instance-method","name":"offset","doc":"Returns the offset from UTC (in seconds) in effect in `location` at\nthis instant.","summary":"<p>Returns the offset from UTC (in seconds) in effect in <code><a href=\"Time.html#location%3ALocation-instance-method\">#location</a></code> at this instant.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":940,"url":null},"def":{"name":"offset","return_type":"Int32","visibility":"Public","body":"zone.offset"}},{"html_id":"saturday?:Bool-instance-method","name":"saturday?","doc":"Returns `true` if the day of week is Saturday.\n\nSee `#day_of_week` for details.","summary":"<p>Returns <code>true</code> if the day of week is Saturday.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1411,"url":null},"def":{"name":"saturday?","return_type":"Bool","visibility":"Public","body":"day_of_week.saturday?"}},{"html_id":"second:Int32-instance-method","name":"second","doc":"Returns the second of the minute (`0..59`).","summary":"<p>Returns the second of the minute (<code>0..59</code>).</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":788,"url":null},"def":{"name":"second","return_type":"Int32","visibility":"Public","body":"(offset_seconds % SECONDS_PER_MINUTE).to_i"}},{"html_id":"shift(seconds:Int,nanoseconds:Int):Time-instance-method","name":"shift","doc":"Returns a copy of this `Time` shifted by the number of *seconds* and\n*nanoseconds*.\n\nPositive values result in a later time, negative values in an earlier time.\n\nThis operates on the instant time-line, such that adding the equivalent of\none hour will always be a duration of one hour later.\nThe local date-time representation may change by a different amount,\ndepending on time zone transitions.\n\nOverflow in *nanoseconds* will be transferred to *seconds*.\n\nThere is no explicit limit on the input values but the addition must result\nin a valid time between `0001-01-01 00:00:00.0` and\n`9999-12-31 23:59:59.999_999_999`. Otherwise `ArgumentError` is raised.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> shifted by the number of <em>seconds</em> and <em>nanoseconds</em>.</p>","abstract":false,"args":[{"name":"seconds","external_name":"seconds","restriction":"Int"},{"name":"nanoseconds","external_name":"nanoseconds","restriction":"Int"}],"args_string":"(seconds : Int, nanoseconds : Int) : Time","args_html":"(seconds : <a href=\"Int.html\">Int</a>, nanoseconds : <a href=\"Int.html\">Int</a>) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":629,"url":null},"def":{"name":"shift","args":[{"name":"seconds","external_name":"seconds","restriction":"Int"},{"name":"nanoseconds","external_name":"nanoseconds","restriction":"Int"}],"return_type":"Time","visibility":"Public","body":"if (seconds == 0) && (nanoseconds == 0)\n  return self\nend\nseconds = total_seconds + seconds\nnanoseconds = self.nanosecond.to_i64 + nanoseconds\nseconds = seconds + (nanoseconds.tdiv(NANOSECONDS_PER_SECOND))\nnanoseconds = nanoseconds.remainder(NANOSECONDS_PER_SECOND)\nif nanoseconds < 0\n  seconds = seconds - 1\n  nanoseconds = nanoseconds + NANOSECONDS_PER_SECOND\nend\nTime.new(seconds: seconds, nanoseconds: nanoseconds.to_i, location: location)\n"}},{"html_id":"shift(*,years:Int=0,months:Int=0,weeks:Int=0,days:Int=0,hours:Int=0,minutes:Int=0,seconds:Int=0,nanoseconds:Int=0)-instance-method","name":"shift","doc":"Returns a copy of this `Time` shifted by the amount of calendaric units\nprovided as arguments.\n\nPositive values result in a later time, negative values in an earlier time.\n\nThis operates on the local time-line, such that the local date-time\nrepresentation of the result will be apart by the specified amounts, but the\nelapsed time between both instances might not equal to the combined default\nduration.\nThis is the case for example when adding a day over a daylight-savings time\nchange:\n\n```\nstart = Time.new(2017, 10, 28, 13, 37, location: Time::Location.load(\"Europe/Berlin\"))\none_day_later = start.shift days: 1\n\none_day_later - start # => 25.hours\n```\n\n*years* is equivalent to `12` months and *weeks* is equivalent to `7` days.\n\nIf the day-of-month resulting from shifting by *years* and *months* would be\ninvalid, the date is adjusted to the last valid day of the month.\nFor example, adding one month to `2018-08-31` would result in the invalid\ndate `2018-09-31` which will be adjusted to `2018-09-30`:\n```\nTime.utc(2018, 7, 31).shift(months: 1) # => Time.utc(2018, 8, 31)\nTime.utc(2018, 8, 31).shift(months: 1) # => Time.utc(2018, 9, 30)\n```\n\nOverflow in smaller units is transferred to the next larger unit.\n\nChanges are applied in the same order as the arguments, sorted by increasing\ngranularity. This is relevant because the order of operations can change the result:\n\n```\nTime.utc(2018, 8, 31).shift(months: 1, days: -1)       # => Time.utc(2018, 9, 29)\nTime.utc(2018, 8, 31).shift(months: 1).shift(days: -1) # => Time.utc(2018, 9, 29)\nTime.utc(2018, 8, 31).shift(days: -1).shift(months: 1) # => Time.utc(2018, 9, 30)\n```\n\nThere is no explicit limit on the input values but the shift must result\nin a valid time between `0001-01-01 00:00:00.0` and\n`9999-12-31 23:59:59.999_999_999`. Otherwise `ArgumentError` is raised.\n\nIf the resulting date-time is ambiguous due to time zone transitions,\na correct time will be returned, but it does not guarantee which.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> shifted by the amount of calendaric units provided as arguments.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"years","default_value":"0","external_name":"years","restriction":"Int"},{"name":"months","default_value":"0","external_name":"months","restriction":"Int"},{"name":"weeks","default_value":"0","external_name":"weeks","restriction":"Int"},{"name":"days","default_value":"0","external_name":"days","restriction":"Int"},{"name":"hours","default_value":"0","external_name":"hours","restriction":"Int"},{"name":"minutes","default_value":"0","external_name":"minutes","restriction":"Int"},{"name":"seconds","default_value":"0","external_name":"seconds","restriction":"Int"},{"name":"nanoseconds","default_value":"0","external_name":"nanoseconds","restriction":"Int"}],"args_string":"(*, years : Int = 0, months : Int = 0, weeks : Int = 0, days : Int = 0, hours : Int = 0, minutes : Int = 0, seconds : Int = 0, nanoseconds : Int = 0)","args_html":"(*, years : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>, months : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>, weeks : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>, days : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>, hours : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>, minutes : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>, seconds : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>, nanoseconds : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>)","location":{"filename":"src/time.cr","line_number":697,"url":null},"def":{"name":"shift","args":[{"name":"","external_name":"","restriction":""},{"name":"years","default_value":"0","external_name":"years","restriction":"Int"},{"name":"months","default_value":"0","external_name":"months","restriction":"Int"},{"name":"weeks","default_value":"0","external_name":"weeks","restriction":"Int"},{"name":"days","default_value":"0","external_name":"days","restriction":"Int"},{"name":"hours","default_value":"0","external_name":"hours","restriction":"Int"},{"name":"minutes","default_value":"0","external_name":"minutes","restriction":"Int"},{"name":"seconds","default_value":"0","external_name":"seconds","restriction":"Int"},{"name":"nanoseconds","default_value":"0","external_name":"nanoseconds","restriction":"Int"}],"splat_index":0,"visibility":"Public","body":"seconds = seconds.to_i64\nif years.zero? && months.zero?\n  seconds = seconds + offset_seconds\nelse\n  year, month, day, _ = year_month_day_day_year\n  year = year + years\n  months = months + month\n  year = year + (months.tdiv(12))\n  month = months.remainder(12)\n  if month < 1\n    month = 12 + month\n    year = year - 1\n  end\n  maxday = Time.days_in_month(year, month)\n  if day > maxday\n    day = maxday\n  end\n  seconds = seconds + ((Time.absolute_days(year, month, day)).to_i64 * SECONDS_PER_DAY)\n  seconds = seconds + (offset_seconds % SECONDS_PER_DAY)\nend\nseconds = seconds + (weeks * SECONDS_PER_WEEK)\nseconds = seconds + (days * SECONDS_PER_DAY)\nseconds = seconds + (hours * SECONDS_PER_HOUR)\nseconds = seconds + (minutes * SECONDS_PER_MINUTE)\n(Time.utc(seconds: seconds, nanoseconds: self.nanosecond).shift(0, nanoseconds)).to_local_in(location)\n"}},{"html_id":"sunday?:Bool-instance-method","name":"sunday?","doc":"Returns `true` if the day of week is Sunday.\n\nSee `#day_of_week` for details.","summary":"<p>Returns <code>true</code> if the day of week is Sunday.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1411,"url":null},"def":{"name":"sunday?","return_type":"Bool","visibility":"Public","body":"day_of_week.sunday?"}},{"html_id":"thursday?:Bool-instance-method","name":"thursday?","doc":"Returns `true` if the day of week is Thursday.\n\nSee `#day_of_week` for details.","summary":"<p>Returns <code>true</code> if the day of week is Thursday.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1411,"url":null},"def":{"name":"thursday?","return_type":"Bool","visibility":"Public","body":"day_of_week.thursday?"}},{"html_id":"time_of_day:Time::Span-instance-method","name":"time_of_day","doc":"Returns the duration between this `Time` and midnight of the same day.\n\nThis is equivalent to creating a `Time::Span` from the time-of-day fields:\n\n```\ntime.time_of_day == Time::Span.new(hours: time.hour, minutes: time.minute, seconds: time.second, nanoseconds: time.nanosecond)\n```","summary":"<p>Returns the duration between this <code><a href=\"Time.html\">Time</a></code> and midnight of the same day.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":916,"url":null},"def":{"name":"time_of_day","return_type":"Time::Span","visibility":"Public","body":"Span.new(nanoseconds: (NANOSECONDS_PER_SECOND * (offset_seconds % SECONDS_PER_DAY)) + nanosecond)"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","doc":"Emits a string formatted according to [RFC 3339](https://tools.ietf.org/html/rfc3339)\n([ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf) profile).\n\nThe JSON format itself does not specify a time data type, this method just\nassumes that a string holding a RFC 3339 time format will be interpreted as\na time value.\n\nSee `#from_json` for reference.","summary":"<p>Emits a string formatted according to <a href=\"https://tools.ietf.org/html/rfc3339\">RFC 3339</a> (<a href=\"http://xml.coverpages.org/ISO-FDIS-8601.pdf\">ISO 8601</a> profile).</p>","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":266,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.string(Time::Format::RFC_3339.format(self, fraction_digits: 0))"}},{"html_id":"to_local:Time-instance-method","name":"to_local","doc":"Returns a copy of this `Time` representing the same instant in the local\ntime zone (`Time::Location.local`).\n\nSee `#in` for details.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the same instant in the local time zone (<code><a href=\"Time/Location.html#local%3ALocation-class-method\">Time::Location.local</a></code>).</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1305,"url":null},"def":{"name":"to_local","return_type":"Time","visibility":"Public","body":"if local?\n  self\nelse\n  self.in(Location.local)\nend"}},{"html_id":"to_local_in(location:Location):Time-instance-method","name":"to_local_in","doc":"Creates a new `Time` instance with the same local date-time representation\n(wall clock) in a different *location*.\n\nUnlike `#in`, which always preserves the same instant in time, `#to_local_in`\nadjusts the instant such that it results in the same local date-time\nrepresentation. Both instants are apart from each other by the difference in\nzone offsets.\n\n```\nnew_year = Time.utc(2019, 1, 1, 0, 0, 0)\ntokyo = new_year.to_local_in(Time::Location.load(\"Asia/Tokyo\"))\nnew_york = new_year.to_local_in(Time::Location.load(\"America/New_York\"))\ntokyo.inspect    # => \"2019-01-01 00:00:00.0 +09:00 Asia/Tokyo\"\nnew_york.inspect # => \"2019-01-01 00:00:00.0 -05:00 America/New_York\"\n```","summary":"<p>Creates a new <code><a href=\"Time.html\">Time</a></code> instance with the same local date-time representation (wall clock) in a different <em>location</em>.</p>","abstract":false,"args":[{"name":"location","external_name":"location","restriction":"Location"}],"args_string":"(location : Location) : Time","args_html":"(location : <a href=\"Time/Location.html\">Location</a>) : <a href=\"Time.html\">Time</a>","location":{"filename":"src/time.cr","line_number":553,"url":null},"def":{"name":"to_local_in","args":[{"name":"location","external_name":"location","restriction":"Location"}],"return_type":"Time","visibility":"Public","body":"local_seconds = offset_seconds\nlocal_seconds = local_seconds - (Time.zone_offset_at(local_seconds, location))\nTime.new(seconds: local_seconds, nanoseconds: nanosecond, location: location)\n"}},{"html_id":"to_rfc2822(io:IO)-instance-method","name":"to_rfc2822","doc":"Format this time using the format specified by [RFC 2822](https://www.ietf.org/rfc/rfc2822.txt)\ninto the given *io*.\n\nThis is also compatible to [RFC 882](https://tools.ietf.org/html/rfc882) and [RFC 1123](https://tools.ietf.org/html/rfc1123#page-55).","summary":"<p>Format this time using the format specified by <a href=\"https://www.ietf.org/rfc/rfc2822.txt\">RFC 2822</a> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","args_html":"(io : <a href=\"IO.html\">IO</a>)","location":{"filename":"src/time.cr","line_number":1150,"url":null},"def":{"name":"to_rfc2822","args":[{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"Format::RFC_2822.format(to_utc, io)"}},{"html_id":"to_rfc2822:String-instance-method","name":"to_rfc2822","doc":"Format this time using the format specified by [RFC 2822](https://www.ietf.org/rfc/rfc2822.txt).\n\n```\nTime.utc(2016, 2, 15).to_rfc2822 # => \"Mon, 15 Feb 2016 00:00:00 +0000\"\n```\n\nThis is also compatible to [RFC 882](https://tools.ietf.org/html/rfc882) and [RFC 1123](https://tools.ietf.org/html/rfc1123#page-55).","summary":"<p>Format this time using the format specified by <a href=\"https://www.ietf.org/rfc/rfc2822.txt\">RFC 2822</a>.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1142,"url":null},"def":{"name":"to_rfc2822","return_type":"String","visibility":"Public","body":"Format::RFC_2822.format(to_utc)"}},{"html_id":"to_rfc3339(io:IO,*,fraction_digits:Int=0):Nil-instance-method","name":"to_rfc3339","doc":"Format this time using the format specified by [RFC 3339](https://tools.ietf.org/html/rfc3339) ([ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf) profile).\ninto the given *io*.\n\n\nNumber of seconds decimals can be selected with *fraction_digits*.\nValues accepted are 0 (the default, no decimals), 3 (milliseconds), 6 (microseconds) or 9 (nanoseconds).","summary":"<p>Format this time using the format specified by <a href=\"https://tools.ietf.org/html/rfc3339\">RFC 3339</a> (<a href=\"http://xml.coverpages.org/ISO-FDIS-8601.pdf\">ISO 8601</a> profile).</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"","external_name":"","restriction":""},{"name":"fraction_digits","default_value":"0","external_name":"fraction_digits","restriction":"Int"}],"args_string":"(io : IO, *, fraction_digits : Int = 0) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, *, fraction_digits : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/time.cr","line_number":1116,"url":null},"def":{"name":"to_rfc3339","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"","external_name":"","restriction":""},{"name":"fraction_digits","default_value":"0","external_name":"fraction_digits","restriction":"Int"}],"splat_index":1,"return_type":"Nil","visibility":"Public","body":"Format::RFC_3339.format(to_utc, io, fraction_digits)"}},{"html_id":"to_rfc3339(*,fraction_digits:Int=0)-instance-method","name":"to_rfc3339","doc":"Format this time using the format specified by [RFC 3339](https://tools.ietf.org/html/rfc3339) ([ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf) profile).\n\n```\nTime.utc(2016, 2, 15).to_rfc3339 # => \"2016-02-15T00:00:00Z\"\n```\n\nISO 8601 allows some freedom over the syntax and RFC 3339 exercises that\nfreedom to rigidly define a fixed format intended for use in internet\nprotocols and standards.\n\nNumber of seconds decimals can be selected with *fraction_digits*.\nValues accepted are 0 (the default, no decimals), 3 (milliseconds), 6 (microseconds) or 9 (nanoseconds).","summary":"<p>Format this time using the format specified by <a href=\"https://tools.ietf.org/html/rfc3339\">RFC 3339</a> (<a href=\"http://xml.coverpages.org/ISO-FDIS-8601.pdf\">ISO 8601</a> profile).</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"fraction_digits","default_value":"0","external_name":"fraction_digits","restriction":"Int"}],"args_string":"(*, fraction_digits : Int = 0)","args_html":"(*, fraction_digits : <a href=\"Int.html\">Int</a> = <span class=\"n\">0</span>)","location":{"filename":"src/time.cr","line_number":1106,"url":null},"def":{"name":"to_rfc3339","args":[{"name":"","external_name":"","restriction":""},{"name":"fraction_digits","default_value":"0","external_name":"fraction_digits","restriction":"Int"}],"splat_index":0,"visibility":"Public","body":"Format::RFC_3339.format(to_utc, fraction_digits)"}},{"html_id":"to_s(io:IO,format:String):Nil-instance-method","name":"to_s","doc":"Formats this `Time` according to the pattern in *format* to the given *io*.\n\nSee `Time::Format` for details.","summary":"<p>Formats this <code><a href=\"Time.html\">Time</a></code> according to the pattern in <em>format</em> to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"format","external_name":"format","restriction":"String"}],"args_string":"(io : IO, format : String) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, format : <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/time.cr","line_number":1090,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"format","external_name":"format","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"(Format.new(format)).format(self, io)"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Prints this `Time` to *io*.\n\nThe local date-time is formatted as date string `YYYY-MM-DD HH:mm:ss +ZZ:ZZ:ZZ`.\nNanoseconds are always omitted.\nWhen the location is `UTC`, the offset is replaced with the string `UTC`.\nOffset seconds are omitted if `0`.","summary":"<p>Prints this <code><a href=\"Time.html\">Time</a></code> to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/time.cr","line_number":1065,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io, \"%F %T \")\nif utc?\n  io << \"UTC\"\nelse\n  zone.format(io)\nend\n"}},{"html_id":"to_s(format:String):String-instance-method","name":"to_s","doc":"Formats this `Time` according to the pattern in *format*.\n\nSee `Time::Format` for details.\n\n```\ntime = Time.local(2016, 4, 5)\ntime.to_s(\"%F\") # => \"2016-04-05\"\n```","summary":"<p>Formats this <code><a href=\"Time.html\">Time</a></code> according to the pattern in <em>format</em>.</p>","abstract":false,"args":[{"name":"format","external_name":"format","restriction":"String"}],"args_string":"(format : String) : String","args_html":"(format : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/time.cr","line_number":1083,"url":null},"def":{"name":"to_s","args":[{"name":"format","external_name":"format","restriction":"String"}],"return_type":"String","visibility":"Public","body":"(Format.new(format)).format(self)"}},{"html_id":"to_unix:Int64-instance-method","name":"to_unix","doc":"Returns the number of seconds since the Unix epoch\n(`1970-01-01 00:00:00 UTC`).\n\n```\ntime = Time.utc(2016, 1, 12, 3, 4, 5)\ntime.to_unix # => 1452567845\n```","summary":"<p>Returns the number of seconds since the Unix epoch (<code>1970-01-01 00:00:00 UTC</code>).</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1230,"url":null},"def":{"name":"to_unix","return_type":"Int64","visibility":"Public","body":"(total_seconds - UNIX_EPOCH.total_seconds).to_i64"}},{"html_id":"to_unix_f:Float64-instance-method","name":"to_unix_f","doc":"Returns the number of seconds since the Unix epoch\n(`1970-01-01 00:00:00 UTC`) as `Float64` with nanosecond precision.\n\n```\ntime = Time.utc(2016, 1, 12, 3, 4, 5, nanosecond: 678_000_000)\ntime.to_unix_f # => 1452567845.678\n```","summary":"<p>Returns the number of seconds since the Unix epoch (<code>1970-01-01 00:00:00 UTC</code>) as <code><a href=\"Float64.html\">Float64</a></code> with nanosecond precision.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1252,"url":null},"def":{"name":"to_unix_f","return_type":"Float64","visibility":"Public","body":"to_unix.to_f + (nanosecond.to_f / 1e9)"}},{"html_id":"to_unix_ms:Int64-instance-method","name":"to_unix_ms","doc":"Returns the number of milliseconds since the Unix epoch\n(`1970-01-01 00:00:00 UTC`).\n\n```\ntime = Time.utc(2016, 1, 12, 3, 4, 5, nanosecond: 678_000_000)\ntime.to_unix_ms # => 1452567845678\n```","summary":"<p>Returns the number of milliseconds since the Unix epoch (<code>1970-01-01 00:00:00 UTC</code>).</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1241,"url":null},"def":{"name":"to_unix_ms","return_type":"Int64","visibility":"Public","body":"(to_unix * 1000) + (nanosecond // NANOSECONDS_PER_MILLISECOND)"}},{"html_id":"to_utc:Time-instance-method","name":"to_utc","doc":"Returns a copy of this `Time` representing the same instant in UTC\n(`Time::Location::UTC`).\n\nSee `#in` for details.","summary":"<p>Returns a copy of this <code><a href=\"Time.html\">Time</a></code> representing the same instant in UTC (<code><a href=\"Time/Location.html#UTC\">Time::Location::UTC</a></code>).</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1290,"url":null},"def":{"name":"to_utc","return_type":"Time","visibility":"Public","body":"if utc?\n  self\nelse\n  Time.utc(seconds: total_seconds, nanoseconds: nanosecond)\nend"}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder) : Nil","args_html":"(yaml : <a href=\"YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":224,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"yaml.scalar(Time::Format::YAML_DATE.format(self))"}},{"html_id":"tuesday?:Bool-instance-method","name":"tuesday?","doc":"Returns `true` if the day of week is Tuesday.\n\nSee `#day_of_week` for details.","summary":"<p>Returns <code>true</code> if the day of week is Tuesday.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1411,"url":null},"def":{"name":"tuesday?","return_type":"Bool","visibility":"Public","body":"day_of_week.tuesday?"}},{"html_id":"utc?:Bool-instance-method","name":"utc?","doc":"Returns `true` if `#location` equals to `Location::UTC`.","summary":"<p>Returns <code>true</code> if <code><a href=\"Time.html#location%3ALocation-instance-method\">#location</a></code> equals to <code><a href=\"Time/Location.html#UTC\">Location::UTC</a></code>.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":945,"url":null},"def":{"name":"utc?","return_type":"Bool","visibility":"Public","body":"location.utc?"}},{"html_id":"wednesday?:Bool-instance-method","name":"wednesday?","doc":"Returns `true` if the day of week is Wednesday.\n\nSee `#day_of_week` for details.","summary":"<p>Returns <code>true</code> if the day of week is Wednesday.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":1411,"url":null},"def":{"name":"wednesday?","return_type":"Bool","visibility":"Public","body":"day_of_week.wednesday?"}},{"html_id":"year:Int32-instance-method","name":"year","doc":"Returns the year of the proleptic Georgian Calendar (`0..9999`).","summary":"<p>Returns the year of the proleptic Georgian Calendar (<code>0..9999</code>).</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":763,"url":null},"def":{"name":"year","return_type":"Int32","visibility":"Public","body":"year_month_day_day_year[0]"}},{"html_id":"zone:Time::Location::Zone-instance-method","name":"zone","doc":"Returns the time zone in effect in `location` at this instant.","summary":"<p>Returns the time zone in effect in <code><a href=\"Time.html#location%3ALocation-instance-method\">#location</a></code> at this instant.</p>","abstract":false,"location":{"filename":"src/time.cr","line_number":934,"url":null},"def":{"name":"zone","return_type":"Time::Location::Zone","visibility":"Public","body":"location.lookup(self)"}}],"types":[{"html_id":"Crystal/Time/DayOfWeek","path":"Time/DayOfWeek.html","kind":"enum","full_name":"Time::DayOfWeek","name":"DayOfWeek","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/time.cr","line_number":289,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Monday","name":"Monday","value":"1"},{"id":"Tuesday","name":"Tuesday","value":"2"},{"id":"Wednesday","name":"Wednesday","value":"3"},{"id":"Thursday","name":"Thursday","value":"4"},{"id":"Friday","name":"Friday","value":"5"},{"id":"Saturday","name":"Saturday","value":"6"},{"id":"Sunday","name":"Sunday","value":"7"}],"namespace":{"html_id":"Crystal/Time","kind":"struct","full_name":"Time","name":"Time"},"doc":"`DayOfWeek` represents a day of the week in the Gregorian calendar.\n\n```\ntime = Time.local(2016, 2, 15)\ntime.day_of_week # => Time::DayOfWeek::Monday\n```\n\nEach member is identified by its ordinal number starting from `Monday = 1`\naccording to [ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf).\n\n`#value` returns this ordinal number. It can easily be converted to the also\ncommon numbering based on `Sunday = 0` using `value % 7`.","summary":"<p><code><a href=\"../Time/DayOfWeek.html\">DayOfWeek</a></code> represents a day of the week in the Gregorian calendar.</p>","constructors":[{"html_id":"from_value(value:Int32):self-class-method","name":"from_value","doc":"Returns the day of week that has the given value, or raises if no such member exists.\n\nThis method also accepts `0` to identify `Sunday` in order to be compliant\nwith the `Sunday = 0` numbering. All other days are equal in both formats.","summary":"<p>Returns the day of week that has the given value, or raises if no such member exists.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Int32"}],"args_string":"(value : Int32) : self","args_html":"(value : <a href=\"../Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/time.cr","line_number":302,"url":null},"def":{"name":"from_value","args":[{"name":"value","external_name":"value","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"if value == 0\n  value = 7\nend\nsuper(value)\n"}}],"instance_methods":[{"html_id":"friday?-instance-method","name":"friday?","abstract":false,"location":{"filename":"src/time.cr","line_number":294,"url":null},"def":{"name":"friday?","visibility":"Public","body":"self == Friday"}},{"html_id":"monday?-instance-method","name":"monday?","abstract":false,"location":{"filename":"src/time.cr","line_number":290,"url":null},"def":{"name":"monday?","visibility":"Public","body":"self == Monday"}},{"html_id":"saturday?-instance-method","name":"saturday?","abstract":false,"location":{"filename":"src/time.cr","line_number":295,"url":null},"def":{"name":"saturday?","visibility":"Public","body":"self == Saturday"}},{"html_id":"sunday?-instance-method","name":"sunday?","abstract":false,"location":{"filename":"src/time.cr","line_number":296,"url":null},"def":{"name":"sunday?","visibility":"Public","body":"self == Sunday"}},{"html_id":"thursday?-instance-method","name":"thursday?","abstract":false,"location":{"filename":"src/time.cr","line_number":293,"url":null},"def":{"name":"thursday?","visibility":"Public","body":"self == Thursday"}},{"html_id":"tuesday?-instance-method","name":"tuesday?","abstract":false,"location":{"filename":"src/time.cr","line_number":291,"url":null},"def":{"name":"tuesday?","visibility":"Public","body":"self == Tuesday"}},{"html_id":"wednesday?-instance-method","name":"wednesday?","abstract":false,"location":{"filename":"src/time.cr","line_number":292,"url":null},"def":{"name":"wednesday?","visibility":"Public","body":"self == Wednesday"}}]},{"html_id":"Crystal/Time/EpochConverter","path":"Time/EpochConverter.html","kind":"module","full_name":"Time::EpochConverter","name":"EpochConverter","abstract":false,"locations":[{"filename":"src/json/from_json.cr","line_number":422,"url":null},{"filename":"src/json/to_json.cr","line_number":345,"url":null},{"filename":"src/yaml/from_yaml.cr","line_number":318,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":235,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time","kind":"struct","full_name":"Time","name":"Time"},"doc":"Converter to be used with `JSON::Serializable` and `YAML::Serializable`\nto serialize a `Time` instance as the number of seconds\nsince the unix epoch. See `Time#to_unix`.\n\n```\nrequire \"json\"\n\nclass Person\n  include JSON::Serializable\n\n  @[JSON::Field(converter: Time::EpochConverter)]\n  property birth_date : Time\nend\n\nperson = Person.from_json(%({\"birth_date\": 1459859781}))\nperson.birth_date # => 2016-04-05 12:36:21 UTC\nperson.to_json    # => %({\"birth_date\":1459859781})\n```","summary":"<p>Converter to be used with <code><a href=\"../JSON/Serializable.html\">JSON::Serializable</a></code> and <code><a href=\"../YAML/Serializable.html\">YAML::Serializable</a></code> to serialize a <code><a href=\"../Time.html\">Time</a></code> instance as the number of seconds since the unix epoch.</p>","class_methods":[{"html_id":"from_json(value:JSON::PullParser):Time-class-method","name":"from_json","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"JSON::PullParser"}],"args_string":"(value : JSON::PullParser) : Time","args_html":"(value : <a href=\"../JSON/PullParser.html\">JSON::PullParser</a>) : <a href=\"../Time.html\">Time</a>","location":{"filename":"src/json/from_json.cr","line_number":423,"url":null},"def":{"name":"from_json","args":[{"name":"value","external_name":"value","restriction":"JSON::PullParser"}],"return_type":"Time","visibility":"Public","body":"Time.unix(value.read_int)"}},{"html_id":"from_yaml(ctx:YAML::ParseContext,node:YAML::Nodes::Node):Time-class-method","name":"from_yaml","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node) : Time","args_html":"(ctx : <a href=\"../YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"../YAML/Nodes/Node.html\">YAML::Nodes::Node</a>) : <a href=\"../Time.html\">Time</a>","location":{"filename":"src/yaml/from_yaml.cr","line_number":319,"url":null},"def":{"name":"from_yaml","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"return_type":"Time","visibility":"Public","body":"if node.is_a?(YAML::Nodes::Scalar)\nelse\n  node.raise(\"Expected scalar, not #{node.kind}\")\nend\nTime.unix(node.value.to_i)\n"}},{"html_id":"to_json(value:Time,json:JSON::Builder):Nil-class-method","name":"to_json","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Time"},{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(value : Time, json : JSON::Builder) : Nil","args_html":"(value : <a href=\"../Time.html\">Time</a>, json : <a href=\"../JSON/Builder.html\">JSON::Builder</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":346,"url":null},"def":{"name":"to_json","args":[{"name":"value","external_name":"value","restriction":"Time"},{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.number(value.to_unix)"}},{"html_id":"to_yaml(value:Time,yaml:YAML::Nodes::Builder):Nil-class-method","name":"to_yaml","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Time"},{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(value : Time, yaml : YAML::Nodes::Builder) : Nil","args_html":"(value : <a href=\"../Time.html\">Time</a>, yaml : <a href=\"../YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":236,"url":null},"def":{"name":"to_yaml","args":[{"name":"value","external_name":"value","restriction":"Time"},{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"yaml.scalar(value.to_unix)"}}]},{"html_id":"Crystal/Time/EpochMillisConverter","path":"Time/EpochMillisConverter.html","kind":"module","full_name":"Time::EpochMillisConverter","name":"EpochMillisConverter","abstract":false,"locations":[{"filename":"src/json/from_json.cr","line_number":428,"url":null},{"filename":"src/json/to_json.cr","line_number":369,"url":null},{"filename":"src/yaml/from_yaml.cr","line_number":328,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":241,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time","kind":"struct","full_name":"Time","name":"Time"},"doc":"Converter to be used with `JSON::Serializable` and `YAML::Serializable`\nto serialize a `Time` instance as the number of milliseconds\nsince the unix epoch. See `Time#to_unix_ms`.\n\n```\nrequire \"json\"\n\nclass Timestamp\n  include JSON::Serializable\n\n  @[JSON::Field(converter: Time::EpochMillisConverter)]\n  property value : Time\nend\n\ntimestamp = Timestamp.from_json(%({\"value\": 1459860483856}))\ntimestamp.value   # => 2016-04-05 12:48:03.856 UTC\ntimestamp.to_json # => %({\"value\":1459860483856})\n```","summary":"<p>Converter to be used with <code><a href=\"../JSON/Serializable.html\">JSON::Serializable</a></code> and <code><a href=\"../YAML/Serializable.html\">YAML::Serializable</a></code> to serialize a <code><a href=\"../Time.html\">Time</a></code> instance as the number of milliseconds since the unix epoch.</p>","class_methods":[{"html_id":"from_json(value:JSON::PullParser):Time-class-method","name":"from_json","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"JSON::PullParser"}],"args_string":"(value : JSON::PullParser) : Time","args_html":"(value : <a href=\"../JSON/PullParser.html\">JSON::PullParser</a>) : <a href=\"../Time.html\">Time</a>","location":{"filename":"src/json/from_json.cr","line_number":429,"url":null},"def":{"name":"from_json","args":[{"name":"value","external_name":"value","restriction":"JSON::PullParser"}],"return_type":"Time","visibility":"Public","body":"Time.unix_ms(value.read_int)"}},{"html_id":"from_yaml(ctx:YAML::ParseContext,node:YAML::Nodes::Node):Time-class-method","name":"from_yaml","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node) : Time","args_html":"(ctx : <a href=\"../YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"../YAML/Nodes/Node.html\">YAML::Nodes::Node</a>) : <a href=\"../Time.html\">Time</a>","location":{"filename":"src/yaml/from_yaml.cr","line_number":329,"url":null},"def":{"name":"from_yaml","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"return_type":"Time","visibility":"Public","body":"if node.is_a?(YAML::Nodes::Scalar)\nelse\n  node.raise(\"Expected scalar, not #{node.kind}\")\nend\nTime.unix_ms(node.value.to_i64)\n"}},{"html_id":"to_json(value:Time,json:JSON::Builder):Nil-class-method","name":"to_json","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Time"},{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(value : Time, json : JSON::Builder) : Nil","args_html":"(value : <a href=\"../Time.html\">Time</a>, json : <a href=\"../JSON/Builder.html\">JSON::Builder</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":370,"url":null},"def":{"name":"to_json","args":[{"name":"value","external_name":"value","restriction":"Time"},{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.number(value.to_unix_ms)"}},{"html_id":"to_yaml(value:Time,yaml:YAML::Nodes::Builder):Nil-class-method","name":"to_yaml","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Time"},{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(value : Time, yaml : YAML::Nodes::Builder) : Nil","args_html":"(value : <a href=\"../Time.html\">Time</a>, yaml : <a href=\"../YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":242,"url":null},"def":{"name":"to_yaml","args":[{"name":"value","external_name":"value","restriction":"Time"},{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"yaml.scalar(value.to_unix_ms)"}}]},{"html_id":"Crystal/Time/FloatingTimeConversionError","path":"Time/FloatingTimeConversionError.html","kind":"class","full_name":"Time::FloatingTimeConversionError","name":"FloatingTimeConversionError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/time.cr","line_number":215,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time","kind":"struct","full_name":"Time","name":"Time"}},{"html_id":"Crystal/Time/Format","path":"Time/Format.html","kind":"struct","full_name":"Time::Format","name":"Format","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/from_json.cr","line_number":391,"url":null},{"filename":"src/json/to_json.cr","line_number":156,"url":null},{"filename":"src/time/format.cr","line_number":63,"url":null},{"filename":"src/time/format/custom/http_date.cr","line_number":3,"url":null},{"filename":"src/time/format/custom/iso_8601.cr","line_number":1,"url":null},{"filename":"src/time/format/custom/rfc_2822.cr","line_number":1,"url":null},{"filename":"src/time/format/custom/rfc_3339.cr","line_number":1,"url":null},{"filename":"src/time/format/custom/yaml_date.cr","line_number":1,"url":null},{"filename":"src/time/format/formatter.cr","line_number":3,"url":null},{"filename":"src/time/format/parser.cr","line_number":1,"url":null},{"filename":"src/time/format/pattern.cr","line_number":1,"url":null},{"filename":"src/yaml/from_yaml.cr","line_number":308,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":229,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time","kind":"struct","full_name":"Time","name":"Time"},"doc":"Specifies the format to convert a `Time` to and from a `String`.\n\nThe pattern of a format is a `String` with directives. Directives\nbeing with a percent (`%`) character. Any text not listed as a directive\nwill be passed/parsed through the output/input string.\n\nThe directives are:\n\n* **%a**: short day name (Sun, Mon, Tue, ...)\n* **%^a**: short day name, upcase (SUN, MON, TUE, ...)\n* **%A**: day name (Sunday, Monday, Tuesday, ...)\n* **%^A**: day name, upcase (SUNDAY, MONDAY, TUESDAY, ...)\n* **%b**: short month name (Jan, Feb, Mar, ...)\n* **%^b**: short month name, upcase (JAN, FEB, MAR, ...)\n* **%B**: month name (January, February, March, ...)\n* **%^B**: month name, upcase (JANUARY, FEBRUARY, MARCH, ...)\n* **%c**: date and time (Tue Apr  5 10:26:19 2016)\n* **%C**: year divided by 100\n* **%d**: day of month, zero padded (01, 02, ...)\n* **%-d**: day of month (1, 2, ..., 31)\n* **%D**: date (04/05/16)\n* **%e**: day of month, blank padded (\" 1\", \" 2\", ..., \"10\", \"11\", ...)\n* **%F**: ISO 8601 date (2016-04-05)\n* **%g**: week-based calendar year modulo 100 (00..99)\n* **%G**: week-based calendar year (0001..9999)\n* **%h**: (same as %b) short month name (Jan, Feb, Mar, ...)\n* **%H**: hour of the day, 24-hour clock, zero padded (00, 01, ..., 24)\n* **%I**: hour of the day, 12-hour clock, zero padded (00, 01, ..., 12)\n* **%j**: day of year, zero padded (001, 002, ..., 365)\n* **%k**: hour of the day, 24-hour clock, blank padded (\" 0\", \" 1\", ..., \"24\")\n* **%l**: hour of the day, 12-hour clock, blank padded (\" 0\", \" 1\", ..., \"12\")\n* **%L**: milliseconds, zero padded (000, 001, ..., 999) (same as **%3N**)\n* **%m**: month number, zero padded (01, 02, ..., 12)\n* **%_m**: month number, blank padded (\" 1\", \" 2\", ..., \"12\")\n* **%-m**: month number (1, 2, ..., 12)\n* **%M**: minute, zero padded (00, 01, 02, ..., 59)\n* **%3N**: milliseconds, zero padded (000, 001, ..., 999) (same as **%L**)\n* **%6N**: microseconds, zero padded (000000, 000001, ..., 999999)\n* **%9N**: nanoseconds, zero padded (000000000, 000000001, ..., 999999999)\n* **%N**: second fraction, zero padded. (Same as `%9N` but may consume more than 9 digits while parsing)\n* **%p**: am-pm (lowercase)\n* **%P**: AM-PM (uppercase)\n* **%r**: 12-hour time (03:04:05 AM)\n* **%R**: 24-hour time (13:04)\n* **%s**: seconds since unix epoch (see `Time#to_unix`)\n* **%S**: seconds, zero padded (00, 01, ..., 59)\n* **%T**: 24-hour time (13:04:05)\n* **%u**: day of week (Monday is 1, 1..7)\n* **%V**: ISO calendar week number of the week-based year (01..53)\n* **%w**: day of week (Sunday is 0, 0..6)\n* **%x**: (same as %D) date (04/05/16)\n* **%X**: (same as %T) 24-hour time (13:04:05)\n* **%y**: year modulo 100\n* **%Y**: year, zero padded\n* **%z**: time zone offset from UTC as hour and minute with no separator (+0900)\n* **%:z**: time zone offset from UTC as hour and minute separated by colon (+09:00)\n* **%::z**: time zone offset from UTC as hour, minute and second separated by colon (+09:00:00)\n* **%Z**: location name or offset (e.g. `Europe/Berlin`)\n* **%^Z**: abbreviated time zone identifier or offset (e.g. `CET`)","summary":"<p>Specifies the format to convert a <code><a href=\"../Time.html\">Time</a></code> to and from a <code><a href=\"../String.html\">String</a></code>.</p>","constructors":[{"html_id":"new(pattern:String,location:Location?=nil)-class-method","name":"new","doc":"Creates a new `Time::Format` with the given *pattern*. The given time\n*location* will be used when parsing a `Time` and no time zone is found in it.","summary":"<p>Creates a new <code><a href=\"../Time/Format.html\">Time::Format</a></code> with the given <em>pattern</em>.</p>","abstract":false,"args":[{"name":"pattern","external_name":"pattern","restriction":"String"},{"name":"location","default_value":"nil","external_name":"location","restriction":"Location | ::Nil"}],"args_string":"(pattern : String, location : Location? = nil)","args_html":"(pattern : <a href=\"../String.html\">String</a>, location : <a href=\"../Time/Location.html\">Location</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/time/format.cr","line_number":79,"url":null},"def":{"name":"new","args":[{"name":"pattern","external_name":"pattern","restriction":"String"},{"name":"location","default_value":"nil","external_name":"location","restriction":"Location | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(pattern, location)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"format(time:Time,io:IO):Nil-instance-method","name":"format","doc":"Formats a `Time` into the given *io*.","summary":"<p>Formats a <code><a href=\"../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(time : Time, io : IO) : Nil","args_html":"(time : <a href=\"../Time.html\">Time</a>, io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/time/format.cr","line_number":97,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"formatter = Formatter.new(time, io)\nformatter.visit(pattern)\n"}},{"html_id":"format(time:Time):String-instance-method","name":"format","doc":"Turns a `Time` into a `String`.","summary":"<p>Turns a <code><a href=\"../Time.html\">Time</a></code> into a <code><a href=\"../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"}],"args_string":"(time : Time) : String","args_html":"(time : <a href=\"../Time.html\">Time</a>) : <a href=\"../String.html\">String</a>","location":{"filename":"src/time/format.cr","line_number":90,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"}],"return_type":"String","visibility":"Public","body":"String.build do |str|\n  format(time, str)\nend"}},{"html_id":"from_json(pull:JSON::PullParser):Time-instance-method","name":"from_json","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser) : Time","args_html":"(pull : <a href=\"../JSON/PullParser.html\">JSON::PullParser</a>) : <a href=\"../Time.html\">Time</a>","location":{"filename":"src/json/from_json.cr","line_number":392,"url":null},"def":{"name":"from_json","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"return_type":"Time","visibility":"Public","body":"string = pull.read_string\nparse(string, Time::Location::UTC)\n"}},{"html_id":"from_yaml(ctx:YAML::ParseContext,node:YAML::Nodes::Node):Time-instance-method","name":"from_yaml","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node) : Time","args_html":"(ctx : <a href=\"../YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"../YAML/Nodes/Node.html\">YAML::Nodes::Node</a>) : <a href=\"../Time.html\">Time</a>","location":{"filename":"src/yaml/from_yaml.cr","line_number":309,"url":null},"def":{"name":"from_yaml","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"return_type":"Time","visibility":"Public","body":"if node.is_a?(YAML::Nodes::Scalar)\nelse\n  node.raise(\"Expected scalar, not #{node.kind}\")\nend\nparse(node.value, Time::Location::UTC)\n"}},{"html_id":"parse(string,location=@location):Time-instance-method","name":"parse","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""},{"name":"location","default_value":"@location","external_name":"location","restriction":""}],"args_string":"(string, location = @location) : Time","args_html":"(string, location = @location) : <a href=\"../Time.html\">Time</a>","location":{"filename":"src/time/format.cr","line_number":83,"url":null},"def":{"name":"parse","args":[{"name":"string","external_name":"string","restriction":""},{"name":"location","default_value":"@location","external_name":"location","restriction":""}],"return_type":"Time","visibility":"Public","body":"parser = Parser.new(string)\nparser.visit(pattern)\nparser.time(location)\n"}},{"html_id":"pattern:String-instance-method","name":"pattern","doc":"Returns the string pattern of this format.","summary":"<p>Returns the string pattern of this format.</p>","abstract":false,"location":{"filename":"src/time/format.cr","line_number":75,"url":null},"def":{"name":"pattern","return_type":"String","visibility":"Public","body":"@pattern"}},{"html_id":"to_json(value:Time,json:JSON::Builder):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Time"},{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(value : Time, json : JSON::Builder) : Nil","args_html":"(value : <a href=\"../Time.html\">Time</a>, json : <a href=\"../JSON/Builder.html\">JSON::Builder</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":157,"url":null},"def":{"name":"to_json","args":[{"name":"value","external_name":"value","restriction":"Time"},{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"(format(value)).to_json(json)"}},{"html_id":"to_yaml(value:Time,yaml:YAML::Nodes::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Time"},{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(value : Time, yaml : YAML::Nodes::Builder) : Nil","args_html":"(value : <a href=\"../Time.html\">Time</a>, yaml : <a href=\"../YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":230,"url":null},"def":{"name":"to_yaml","args":[{"name":"value","external_name":"value","restriction":"Time"},{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"yaml.scalar(format(value))"}}],"types":[{"html_id":"Crystal/Time/Format/Error","path":"Time/Format/Error.html","kind":"class","full_name":"Time::Format::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/time/format.cr","line_number":71,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":"Error raised when an invalid pattern is used.","summary":"<p>Error raised when an invalid pattern is used.</p>"},{"html_id":"Crystal/Time/Format/HTTP_DATE","path":"Time/Format/HTTP_DATE.html","kind":"module","full_name":"Time::Format::HTTP_DATE","name":"HTTP_DATE","abstract":false,"locations":[{"filename":"src/time/format/custom/http_date.cr","line_number":20,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":"Parse a time string using the formats specified by [RFC 2616](https://tools.ietf.org/html/rfc2616#section-3.3.1) and (non-RFC-compliant) [IIS date format](https://docs.microsoft.com/en-us/windows/desktop/wininet/http-cookies#set-cookie-header).\n\nSupported formats:\n* [RFC 1123](https://tools.ietf.org/html/rfc1123#page-55)\n* [RFC 850](https://tools.ietf.org/html/rfc850#section-2.1.4)\n* [IIS date format](https://docs.microsoft.com/en-us/windows/desktop/wininet/http-cookies#set-cookie-header)\n* [asctime](http://en.cppreference.com/w/c/chrono/asctime)\n\n```\nTime::Format::HTTP_DATE.parse(\"Sun, 14 Feb 2016 21:00:00 GMT\")  # => 2016-02-14 21:00:00 UTC\nTime::Format::HTTP_DATE.parse(\"Sunday, 14-Feb-16 21:00:00 GMT\") # => 2016-02-14 21:00:00 UTC\nTime::Format::HTTP_DATE.parse(\"Sun, 14-Feb-2016 21:00:00 GMT\")  # => 2016-02-14 21:00:00 UTC\nTime::Format::HTTP_DATE.parse(\"Sun Feb 14 21:00:00 2016\")       # => 2016-02-14 21:00:00 UTC\n\nTime::Format::HTTP_DATE.format(Time.utc(2016, 2, 15)) # => \"Mon, 15 Feb 2016 00:00:00 GMT\"\n```","summary":"<p>Parse a time string using the formats specified by <a href=\"https://tools.ietf.org/html/rfc2616#section-3.3.1\">RFC 2616</a> and (non-RFC-compliant) <a href=\"https://docs.microsoft.com/en-us/windows/desktop/wininet/http-cookies#set-cookie-header\">IIS date format</a>.</p>","class_methods":[{"html_id":"format(time:Time,io:IO)-class-method","name":"format","doc":"Formats a `Time` into the given *io*.\n\n*time* is always converted to UTC.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(time : Time, io : IO)","args_html":"(time : <a href=\"../../Time.html\">Time</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/time/format/custom/http_date.cr","line_number":31,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"formatter = Formatter.new(time.to_utc, io)\nformatter.rfc_2822(time_zone_gmt: true, two_digit_day: true)\nio\n"}},{"html_id":"format(time:Time):String-class-method","name":"format","doc":"Formats a `Time` into a `String`.\n\n*time* is always converted to UTC.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into a <code><a href=\"../../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"}],"args_string":"(time : Time) : String","args_html":"(time : <a href=\"../../Time.html\">Time</a>) : <a href=\"../../String.html\">String</a>","location":{"filename":"src/time/format/custom/http_date.cr","line_number":40,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"}],"return_type":"String","visibility":"Public","body":"String.build do |io|\n  format(time, io)\nend"}},{"html_id":"parse(string,location=Time::Location::UTC):Time-class-method","name":"parse","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""},{"name":"location","default_value":"Time::Location::UTC","external_name":"location","restriction":""}],"args_string":"(string, location = Time::Location::UTC) : Time","args_html":"(string, location = <span class=\"t\">Time</span><span class=\"t\">::</span><span class=\"t\">Location</span><span class=\"t\">::</span><span class=\"t\">UTC</span>) : <a href=\"../../Time.html\">Time</a>","location":{"filename":"src/time/format/custom/http_date.cr","line_number":22,"url":null},"def":{"name":"parse","args":[{"name":"string","external_name":"string","restriction":""},{"name":"location","default_value":"Time::Location::UTC","external_name":"location","restriction":""}],"return_type":"Time","visibility":"Public","body":"parser = Parser.new(string)\nparser.http_date\nparser.time(location)\n"}}]},{"html_id":"Crystal/Time/Format/ISO_8601_DATE","path":"Time/Format/ISO_8601_DATE.html","kind":"module","full_name":"Time::Format::ISO_8601_DATE","name":"ISO_8601_DATE","abstract":false,"locations":[{"filename":"src/time/format/custom/iso_8601.cr","line_number":119,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":"The ISO 8601 date format.","summary":"<p>The ISO 8601 date format.</p>","class_methods":[{"html_id":"format(time:Time,io:IO)-class-method","name":"format","doc":"Formats a `Time` into the given *io*.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(time : Time, io : IO)","args_html":"(time : <a href=\"../../Time.html\">Time</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/time/format/custom/iso_8601.cr","line_number":128,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"formatter = Formatter.new(time, io)\nformatter.year_month_day_iso_8601\nio\n"}},{"html_id":"format(time:Time):String-class-method","name":"format","doc":"Formats a `Time` into a `String`.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into a <code><a href=\"../../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"}],"args_string":"(time : Time) : String","args_html":"(time : <a href=\"../../Time.html\">Time</a>) : <a href=\"../../String.html\">String</a>","location":{"filename":"src/time/format/custom/iso_8601.cr","line_number":135,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"}],"return_type":"String","visibility":"Public","body":"String.build do |io|\n  format(time, io)\nend"}},{"html_id":"parse(string,location:Time::Location?=Time::Location::UTC):Time-class-method","name":"parse","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""},{"name":"location","default_value":"Time::Location::UTC","external_name":"location","restriction":"Time::Location | ::Nil"}],"args_string":"(string, location : Time::Location? = Time::Location::UTC) : Time","args_html":"(string, location : <a href=\"../../Time/Location.html\">Time::Location</a>? = <span class=\"t\">Time</span><span class=\"t\">::</span><span class=\"t\">Location</span><span class=\"t\">::</span><span class=\"t\">UTC</span>) : <a href=\"../../Time.html\">Time</a>","location":{"filename":"src/time/format/custom/iso_8601.cr","line_number":121,"url":null},"def":{"name":"parse","args":[{"name":"string","external_name":"string","restriction":""},{"name":"location","default_value":"Time::Location::UTC","external_name":"location","restriction":"Time::Location | ::Nil"}],"return_type":"Time","visibility":"Public","body":"parser = Parser.new(string)\nparser.year_month_day_iso_8601\nparser.time(location)\n"}}]},{"html_id":"Crystal/Time/Format/ISO_8601_DATE_TIME","path":"Time/Format/ISO_8601_DATE_TIME.html","kind":"module","full_name":"Time::Format::ISO_8601_DATE_TIME","name":"ISO_8601_DATE_TIME","abstract":false,"locations":[{"filename":"src/time/format/custom/iso_8601.cr","line_number":143,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":"The ISO 8601 date time format.","summary":"<p>The ISO 8601 date time format.</p>","class_methods":[{"html_id":"format(time:Time,io:IO)-class-method","name":"format","doc":"Formats a `Time` into the given *io*.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(time : Time, io : IO)","args_html":"(time : <a href=\"../../Time.html\">Time</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/time/format/custom/iso_8601.cr","line_number":152,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"formatter = Formatter.new(time, io)\nformatter.rfc_3339\nio\n"}},{"html_id":"format(time:Time):String-class-method","name":"format","doc":"Formats a `Time` into a `String`.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into a <code><a href=\"../../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"}],"args_string":"(time : Time) : String","args_html":"(time : <a href=\"../../Time.html\">Time</a>) : <a href=\"../../String.html\">String</a>","location":{"filename":"src/time/format/custom/iso_8601.cr","line_number":159,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"}],"return_type":"String","visibility":"Public","body":"String.build do |io|\n  format(time, io)\nend"}},{"html_id":"parse(string,location:Time::Location?=Time::Location::UTC):Time-class-method","name":"parse","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""},{"name":"location","default_value":"Time::Location::UTC","external_name":"location","restriction":"Time::Location | ::Nil"}],"args_string":"(string, location : Time::Location? = Time::Location::UTC) : Time","args_html":"(string, location : <a href=\"../../Time/Location.html\">Time::Location</a>? = <span class=\"t\">Time</span><span class=\"t\">::</span><span class=\"t\">Location</span><span class=\"t\">::</span><span class=\"t\">UTC</span>) : <a href=\"../../Time.html\">Time</a>","location":{"filename":"src/time/format/custom/iso_8601.cr","line_number":145,"url":null},"def":{"name":"parse","args":[{"name":"string","external_name":"string","restriction":""},{"name":"location","default_value":"Time::Location::UTC","external_name":"location","restriction":"Time::Location | ::Nil"}],"return_type":"Time","visibility":"Public","body":"parser = Parser.new(string)\nparser.date_time_iso_8601\nparser.time(location)\n"}}]},{"html_id":"Crystal/Time/Format/ISO_8601_TIME","path":"Time/Format/ISO_8601_TIME.html","kind":"module","full_name":"Time::Format::ISO_8601_TIME","name":"ISO_8601_TIME","abstract":false,"locations":[{"filename":"src/time/format/custom/iso_8601.cr","line_number":167,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":"The ISO 8601 time format.","summary":"<p>The ISO 8601 time format.</p>","class_methods":[{"html_id":"format(time:Time,io:IO)-class-method","name":"format","doc":"Formats a `Time` into the given *io*.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(time : Time, io : IO)","args_html":"(time : <a href=\"../../Time.html\">Time</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/time/format/custom/iso_8601.cr","line_number":176,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"formatter = Formatter.new(time, io)\nformatter.time_iso_8601\nio\n"}},{"html_id":"format(time:Time)-class-method","name":"format","doc":"Formats a `Time` into a `String`.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into a <code><a href=\"../../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"}],"args_string":"(time : Time)","args_html":"(time : <a href=\"../../Time.html\">Time</a>)","location":{"filename":"src/time/format/custom/iso_8601.cr","line_number":183,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"}],"visibility":"Public","body":"String.build do |io|\n  format(time, io)\nend"}},{"html_id":"parse(string,location:Time::Location?=Time::Location::UTC):Time-class-method","name":"parse","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""},{"name":"location","default_value":"Time::Location::UTC","external_name":"location","restriction":"Time::Location | ::Nil"}],"args_string":"(string, location : Time::Location? = Time::Location::UTC) : Time","args_html":"(string, location : <a href=\"../../Time/Location.html\">Time::Location</a>? = <span class=\"t\">Time</span><span class=\"t\">::</span><span class=\"t\">Location</span><span class=\"t\">::</span><span class=\"t\">UTC</span>) : <a href=\"../../Time.html\">Time</a>","location":{"filename":"src/time/format/custom/iso_8601.cr","line_number":169,"url":null},"def":{"name":"parse","args":[{"name":"string","external_name":"string","restriction":""},{"name":"location","default_value":"Time::Location::UTC","external_name":"location","restriction":"Time::Location | ::Nil"}],"return_type":"Time","visibility":"Public","body":"parser = Parser.new(string)\nparser.time_iso_8601\nparser.time(location)\n"}}]},{"html_id":"Crystal/Time/Format/RFC_2822","path":"Time/Format/RFC_2822.html","kind":"module","full_name":"Time::Format::RFC_2822","name":"RFC_2822","abstract":false,"locations":[{"filename":"src/time/format/custom/rfc_2822.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":"The [RFC 2822](https://tools.ietf.org/html/rfc2822) datetime format.\n\nThis is also compatible to [RFC 882](https://tools.ietf.org/html/rfc882) and [RFC 1123](https://tools.ietf.org/html/rfc1123#page-55).","summary":"<p>The <a href=\"https://tools.ietf.org/html/rfc2822\">RFC 2822</a> datetime format.</p>","class_methods":[{"html_id":"format(time:Time,io:IO)-class-method","name":"format","doc":"Formats a `Time` into the given *io*.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(time : Time, io : IO)","args_html":"(time : <a href=\"../../Time.html\">Time</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/time/format/custom/rfc_2822.cr","line_number":14,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"formatter = Formatter.new(time, io)\nformatter.rfc_2822\nio\n"}},{"html_id":"format(time:Time):String-class-method","name":"format","doc":"Formats a `Time` into a `String`.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into a <code><a href=\"../../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"}],"args_string":"(time : Time) : String","args_html":"(time : <a href=\"../../Time.html\">Time</a>) : <a href=\"../../String.html\">String</a>","location":{"filename":"src/time/format/custom/rfc_2822.cr","line_number":21,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"}],"return_type":"String","visibility":"Public","body":"String.build do |io|\n  format(time, io)\nend"}},{"html_id":"parse(string,kind=Time::Location::UTC):Time-class-method","name":"parse","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""},{"name":"kind","default_value":"Time::Location::UTC","external_name":"kind","restriction":""}],"args_string":"(string, kind = Time::Location::UTC) : Time","args_html":"(string, kind = <span class=\"t\">Time</span><span class=\"t\">::</span><span class=\"t\">Location</span><span class=\"t\">::</span><span class=\"t\">UTC</span>) : <a href=\"../../Time.html\">Time</a>","location":{"filename":"src/time/format/custom/rfc_2822.cr","line_number":7,"url":null},"def":{"name":"parse","args":[{"name":"string","external_name":"string","restriction":""},{"name":"kind","default_value":"Time::Location::UTC","external_name":"kind","restriction":""}],"return_type":"Time","visibility":"Public","body":"parser = Parser.new(string)\nparser.rfc_2822\nparser.time(kind)\n"}}]},{"html_id":"Crystal/Time/Format/RFC_3339","path":"Time/Format/RFC_3339.html","kind":"module","full_name":"Time::Format::RFC_3339","name":"RFC_3339","abstract":false,"locations":[{"filename":"src/time/format/custom/rfc_3339.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":"The [RFC 3339](https://tools.ietf.org/html/rfc3339) datetime format ([ISO 8601](http://xml.coverpages.org/ISO-FDIS-8601.pdf) profile).","summary":"<p>The <a href=\"https://tools.ietf.org/html/rfc3339\">RFC 3339</a> datetime format (<a href=\"http://xml.coverpages.org/ISO-FDIS-8601.pdf\">ISO 8601</a> profile).</p>","class_methods":[{"html_id":"format(time:Time,io:IO,fraction_digits=0)-class-method","name":"format","doc":"Formats a `Time` into the given *io*.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"},{"name":"fraction_digits","default_value":"0","external_name":"fraction_digits","restriction":""}],"args_string":"(time : Time, io : IO, fraction_digits = 0)","args_html":"(time : <a href=\"../../Time.html\">Time</a>, io : <a href=\"../../IO.html\">IO</a>, fraction_digits = <span class=\"n\">0</span>)","location":{"filename":"src/time/format/custom/rfc_3339.cr","line_number":12,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"},{"name":"fraction_digits","default_value":"0","external_name":"fraction_digits","restriction":""}],"visibility":"Public","body":"formatter = Formatter.new(time, io)\nformatter.rfc_3339(fraction_digits: fraction_digits)\nio\n"}},{"html_id":"format(time:Time,fraction_digits=0):String-class-method","name":"format","doc":"Formats a `Time` into a `String`.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into a <code><a href=\"../../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"fraction_digits","default_value":"0","external_name":"fraction_digits","restriction":""}],"args_string":"(time : Time, fraction_digits = 0) : String","args_html":"(time : <a href=\"../../Time.html\">Time</a>, fraction_digits = <span class=\"n\">0</span>) : <a href=\"../../String.html\">String</a>","location":{"filename":"src/time/format/custom/rfc_3339.cr","line_number":19,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"fraction_digits","default_value":"0","external_name":"fraction_digits","restriction":""}],"return_type":"String","visibility":"Public","body":"String.build do |io|\n  format(time, io, fraction_digits: fraction_digits)\nend"}},{"html_id":"parse(string,location=Time::Location::UTC):Time-class-method","name":"parse","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""},{"name":"location","default_value":"Time::Location::UTC","external_name":"location","restriction":""}],"args_string":"(string, location = Time::Location::UTC) : Time","args_html":"(string, location = <span class=\"t\">Time</span><span class=\"t\">::</span><span class=\"t\">Location</span><span class=\"t\">::</span><span class=\"t\">UTC</span>) : <a href=\"../../Time.html\">Time</a>","location":{"filename":"src/time/format/custom/rfc_3339.cr","line_number":5,"url":null},"def":{"name":"parse","args":[{"name":"string","external_name":"string","restriction":""},{"name":"location","default_value":"Time::Location::UTC","external_name":"location","restriction":""}],"return_type":"Time","visibility":"Public","body":"parser = Parser.new(string)\nparser.rfc_3339\nparser.time(location)\n"}}]},{"html_id":"Crystal/Time/Format/YAML_DATE","path":"Time/Format/YAML_DATE.html","kind":"module","full_name":"Time::Format::YAML_DATE","name":"YAML_DATE","abstract":false,"locations":[{"filename":"src/time/format/custom/yaml_date.cr","line_number":12,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time/Format","kind":"struct","full_name":"Time::Format","name":"Format"},"doc":"Even though the standard library has Time parsers given a *fixed* format,\nthe format in YAML, http://yaml.org/type/timestamp.html,\ncan consist of just the date part, and following it any number of spaces,\nor 't', or 'T' can follow, with many optional components. So, we implement\nthis in a more efficient way to avoid parsing the same string with many\npossible formats (there's also no way to specify any number of spaces\nwith Time::Format, or an \"or\" like in a Regex).\n\nAs an additional note, Ruby's Psych YAML parser also implements a\ncustom time parser, probably for this same reason.","summary":"<p>Even though the standard library has Time parsers given a <em>fixed</em> format, the format in YAML, http://yaml.org/type/timestamp.html, can consist of just the date part, and following it any number of spaces, or 't', or 'T' can follow, with many optional components.</p>","class_methods":[{"html_id":"format(time:Time,io:IO)-class-method","name":"format","doc":"Formats a `Time` into the given *io*.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into the given <em>io</em>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(time : Time, io : IO)","args_html":"(time : <a href=\"../../Time.html\">Time</a>, io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/time/format/custom/yaml_date.cr","line_number":24,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"},{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"formatter = Formatter.new(time, io)\nif (((time.hour == 0) && (time.minute == 0)) && (time.second == 0)) && (time.nanosecond == 0)\n  formatter.year_month_day_iso_8601\nelse\n  formatter.yaml_date_time\nend\n"}},{"html_id":"format(time:Time):String-class-method","name":"format","doc":"Formats a `Time` into a `String`.","summary":"<p>Formats a <code><a href=\"../../Time.html\">Time</a></code> into a <code><a href=\"../../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"}],"args_string":"(time : Time) : String","args_html":"(time : <a href=\"../../Time.html\">Time</a>) : <a href=\"../../String.html\">String</a>","location":{"filename":"src/time/format/custom/yaml_date.cr","line_number":35,"url":null},"def":{"name":"format","args":[{"name":"time","external_name":"time","restriction":"Time"}],"return_type":"String","visibility":"Public","body":"String.build do |io|\n  format(time, io)\nend"}},{"html_id":"parse?(string):Time?-class-method","name":"parse?","doc":"Parses a string into a `Time`.","summary":"<p>Parses a string into a <code><a href=\"../../Time.html\">Time</a></code>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""}],"args_string":"(string) : Time?","args_html":"(string) : <a href=\"../../Time.html\">Time</a>?","location":{"filename":"src/time/format/custom/yaml_date.cr","line_number":14,"url":null},"def":{"name":"parse?","args":[{"name":"string","external_name":"string","restriction":""}],"return_type":"Time | ::Nil","visibility":"Public","body":"parser = Parser.new(string)\nif parser.yaml_date_time?\n  begin\n    parser.time(Time::Location::UTC)\n  rescue\n    nil\n  end\nelse\n  nil\nend\n"}}]}]},{"html_id":"Crystal/Time/Location","path":"Time/Location.html","kind":"class","full_name":"Time::Location","name":"Location","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/time/location.cr","line_number":49,"url":null},{"filename":"src/time/location/loader.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"UTC","name":"UTC","value":"new(\"UTC\", [Zone::UTC])","doc":"Describes the Coordinated Universal Time (UTC).\n\nThe only time zone offset in this location is `Zone::UTC`.","summary":"<p>Describes the Coordinated Universal Time (UTC).</p>"}],"namespace":{"html_id":"Crystal/Time","kind":"struct","full_name":"Time","name":"Time"},"doc":"`Location` maps time instants to the zone in use at that time.\nIt typically represents the collection of time offsets observed in\na certain geographical area.\n\nIt contains a list of zone offsets and rules for transitioning between them.\n\nIf a location has only one offset (such as `UTC`) it is considered\n*fixed*.\n\nA `Location` instance is usually retrieved by name using\n`Time::Location.load`.\nIt loads the zone offsets and transitioning rules from the time zone database\nprovided by the operating system.\n\n```\nlocation = Time::Location.load(\"Europe/Berlin\")\nlocation # => #<Time::Location Europe/Berlin>\ntime = Time.local(2016, 2, 15, 21, 1, 10, location: location)\ntime # => 2016-02-15 21:01:10 +01:00 Europe/Berlin\n```\n\nA custom time zone database can be configured through the environment variable\n`ZONEINFO`. See `.load` for details.\n\n### Fixed Offset\n\nA fixed offset location is created using `Time::Location.fixed`:\n\n```\nlocation = Time::Location.fixed(3600)\nlocation       # => #<Time::Location +01:00>\nlocation.zones # => [#<Time::Location::Zone +01:00 (0s) STD>]\n```\n\n\n### Local Time Zone\n\nThe local time zone can be accessed as `Time::Location.local`.\n\nIt is initially configured according to system environment settings,\nbut its value can be changed:\n\n```\nlocation = Time::Location.local\nTime::Location.local = Time::Location.load(\"America/New_York\")\n```","summary":"<p><code><a href=\"../Time/Location.html\">Location</a></code> maps time instants to the zone in use at that time.</p>","class_methods":[{"html_id":"local=(local:Location)-class-method","name":"local=","doc":"Returns the `Location` representing the application's local time zone.\n\n`Time` uses this property as default value for most method arguments\nexpecting a `Location`.\n\nThe initial value depends on the current application environment, see\n`.load_local` for details.\n\nThe value can be changed to overwrite the system default:\n\n```\nTime.local.location # => #<Time::Location America/New_York>\nTime::Location.local = Time::Location.load(\"Europe/Berlin\")\nTime.local.location # => #<Time::Location Europe/Berlin>\n```","summary":"<p>Returns the <code><a href=\"../Time/Location.html\">Location</a></code> representing the application's local time zone.</p>","abstract":false,"args":[{"name":"local","external_name":"local","restriction":"Location"}],"args_string":"(local : Location)","args_html":"(local : <a href=\"../Time/Location.html\">Location</a>)","location":{"filename":"src/time/location.cr","line_number":320,"url":null},"def":{"name":"local=","args":[{"name":"local","external_name":"local","restriction":"Location"}],"visibility":"Public","body":"@@local = local"}}],"constructors":[{"html_id":"fixed(name:String,offset:Int32):Location-class-method","name":"fixed","doc":"Creates a `Location` instance named *name* with fixed *offset* in seconds\nfrom UTC.","summary":"<p>Creates a <code><a href=\"../Time/Location.html\">Location</a></code> instance named <em>name</em> with fixed <em>offset</em> in seconds from UTC.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"offset","external_name":"offset","restriction":"Int32"}],"args_string":"(name : String, offset : Int32) : Location","args_html":"(name : <a href=\"../String.html\">String</a>, offset : <a href=\"../Int32.html\">Int32</a>) : <a href=\"../Time/Location.html\">Location</a>","location":{"filename":"src/time/location.cr","line_number":219,"url":null},"def":{"name":"fixed","args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"offset","external_name":"offset","restriction":"Int32"}],"return_type":"Location","visibility":"Public","body":"new(name, [Zone.new(name, offset, false)])"}},{"html_id":"fixed(offset:Int32):self-class-method","name":"fixed","doc":"Creates a `Location` instance with fixed *offset* in seconds from UTC.\n\nThe formatted *offset* is used as name.","summary":"<p>Creates a <code><a href=\"../Time/Location.html\">Location</a></code> instance with fixed <em>offset</em> in seconds from UTC.</p>","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":"Int32"}],"args_string":"(offset : Int32) : self","args_html":"(offset : <a href=\"../Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/time/location.cr","line_number":226,"url":null},"def":{"name":"fixed","args":[{"name":"offset","external_name":"offset","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"zone = Zone.new(nil, offset, false)\nnew(zone.name, [zone])\n"}},{"html_id":"load(name:String):Location-class-method","name":"load","doc":"Loads the `Location` with the given *name*.\n\n```\nlocation = Time::Location.load(\"Europe/Berlin\")\n```\n\n*name* is understood to be a location name in the IANA Time\nZone database, such as `\"America/New_York\"`. As special cases,\n`\"UTC\"` and empty string (`\"\"`) return `Location::UTC`, and\n`\"Local\"` returns `Location.local`.\n\nThe implementation uses a list of system-specific paths to look for a time\nzone database.\nThe first time zone database entry matching the given name that is\nsuccessfully loaded and parsed is returned.\nTypical paths on Unix-based operating systems are `/usr/share/zoneinfo/`,\n`/usr/share/lib/zoneinfo/`, or `/usr/lib/locale/TZ/`.\n\nA time zone database may not be present on all systems, especially non-Unix\nsystems. In this case, you may need to distribute a copy of the database\nwith an application that depends on time zone data being available.\n\nA custom lookup path can be set as environment variable `ZONEINFO`.\nThe path can point to the root of a directory structure or an\nuncompressed ZIP file, each representing the time zone database using files\nand folders of the expected names.\n\nExample:\n\n```\n# This tries to load the file `/usr/share/zoneinfo/Custom/Location`\nENV[\"ZONEINFO\"] = \"/usr/share/zoneinfo/\"\nTime::Location.load(\"Custom/Location\")\n\n# This tries to load the file `Custom/Location` in the uncompressed ZIP\n# file at `/path/to/zoneinfo.zip`\nENV[\"ZONEINFO\"] = \"/path/to/zoneinfo.zip\"\nTime::Location.load(\"Custom/Location\")\n```\n\nIf the location name cannot be found, `InvalidLocationNameError` is raised.\nIf the loader encounters a format error in the time zone database,\n`InvalidTZDataError` is raised.\n\nFiles are cached based on the modification time, so subsequent request for\nthe same location name will most likely return the same instance of\n`Location`, unless the time zone database has been updated in between.","summary":"<p>Loads the <code><a href=\"../Time/Location.html\">Location</a></code> with the given <em>name</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String) : Location","args_html":"(name : <a href=\"../String.html\">String</a>) : <a href=\"../Time/Location.html\">Location</a>","location":{"filename":"src/time/location.cr","line_number":278,"url":null},"def":{"name":"load","args":[{"name":"name","external_name":"name","restriction":"String"}],"return_type":"Location","visibility":"Public","body":"case name\nwhen \"\", \"UTC\"\n  UTC\nwhen \"Local\"\n  local\nwhen .includes?(\"..\"), .starts_with?('/'), .starts_with?('\\\\')\n  raise(InvalidLocationNameError.new(name))\nelse\n  if zoneinfo = ENV[\"ZONEINFO\"]?\n    if location = load_from_dir_or_zip(name, zoneinfo)\n      return location\n    else\n      raise(InvalidLocationNameError.new(name, zoneinfo))\n    end\n  end\n  if location = load(name, Crystal::System::Time.zone_sources)\n    return location\n  end\n  raise(InvalidLocationNameError.new(name))\nend"}},{"html_id":"load_local:Location-class-method","name":"load_local","doc":"Loads the local time zone according to the current application environment.\n\nThe environment variable `ENV[\"TZ\"]` is consulted for finding the time zone\nto use.\n\n* `\"UTC\"` and empty string (`\"\"`) return `Location::UTC`\n* Any other value (such as `\"Europe/Berlin\"`) is tried to be resolved using\n  `Location.load`.\n* If `ENV[\"TZ\"]` is not set, the system's local time zone data will be used\n  (`/etc/localtime` on unix-based systems).\n* If no time zone data could be found (i.e. the previous methods failed),\n  `Location::UTC` is returned.","summary":"<p>Loads the local time zone according to the current application environment.</p>","abstract":false,"location":{"filename":"src/time/location.cr","line_number":334,"url":null},"def":{"name":"load_local","return_type":"Location","visibility":"Public","body":"case tz = ENV[\"TZ\"]?\nwhen \"\", \"UTC\"\n  return UTC\nwhen Nil\n  if localtime = Crystal::System::Time.load_localtime\n    return localtime\n  end\nelse\n  if zoneinfo = ENV[\"ZONEINFO\"]?\n    if location = load_from_dir_or_zip(tz, zoneinfo)\n      return location\n    end\n  end\n  if location = load?(tz, Crystal::System::Time.zone_sources)\n    return location\n  end\nend\nUTC\n"}},{"html_id":"local:Location-class-method","name":"local","doc":"Returns the `Location` representing the application's local time zone.\n\n`Time` uses this property as default value for most method arguments\nexpecting a `Location`.\n\nThe initial value depends on the current application environment, see\n`.load_local` for details.\n\nThe value can be changed to overwrite the system default:\n\n```\nTime.local.location # => #<Time::Location America/New_York>\nTime::Location.local = Time::Location.load(\"Europe/Berlin\")\nTime.local.location # => #<Time::Location Europe/Berlin>\n```","summary":"<p>Returns the <code><a href=\"../Time/Location.html\">Location</a></code> representing the application's local time zone.</p>","abstract":false,"location":{"filename":"src/time/location.cr","line_number":320,"url":null},"def":{"name":"local","return_type":"Location","visibility":"Public","body":"if (value = @@local).nil?\n  @@local = (load_local)\nelse\n  value\nend"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if *other* is equal to `self`.\n\nTwo `Location` instances are considered equal if they have the same name,\noffset zones and transition rules.","summary":"<p>Returns <code>true</code> if <em>other</em> is equal to <code>self</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"if same?(other)\n  return true\nend\nif name == other.name\nelse\n  return false\nend\nif zones == other.zones\nelse\n  return false\nend\nif transitions == other.transitions\nelse\n  return false\nend\ntrue\n"}},{"html_id":"fixed?:Bool-instance-method","name":"fixed?","doc":"Returns `true` if this location has a fixed offset.","summary":"<p>Returns <code>true</code> if this location has a fixed offset.</p>","abstract":false,"location":{"filename":"src/time/location.cr","line_number":464,"url":null},"def":{"name":"fixed?","return_type":"Bool","visibility":"Public","body":"zones.size <= 1"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"Returns `true` if *other* is equal to `self`.\n\nTwo `Location` instances are considered equal if they have the same name,\noffset zones and transition rules.","summary":"<p>Returns <code>true</code> if <em>other</em> is equal to <code>self</code>.</p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = name.hash(hasher)\nhasher = zones.hash(hasher)\nhasher = transitions.hash(hasher)\nhasher\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/time/location.cr","line_number":371,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"#<Time::Location \"\nto_s(io)\nio << '>'\n"}},{"html_id":"local?:Bool-instance-method","name":"local?","doc":"Returns `true` if this location equals to `Time::Location.local`.","summary":"<p>Returns <code>true</code> if this location equals to <code><a href=\"../Time/Location.html#local%3ALocation-class-method\">Time::Location.local</a></code>.</p>","abstract":false,"location":{"filename":"src/time/location.cr","line_number":459,"url":null},"def":{"name":"local?","return_type":"Bool","visibility":"Public","body":"self == Location.local"}},{"html_id":"lookup(time:Time):Zone-instance-method","name":"lookup","doc":"Returns the time zone offset observed at *time*.","summary":"<p>Returns the time zone offset observed at <em>time</em>.</p>","abstract":false,"args":[{"name":"time","external_name":"time","restriction":"Time"}],"args_string":"(time : Time) : Zone","args_html":"(time : <a href=\"../Time.html\">Time</a>) : <a href=\"../Time/Location/Zone.html\">Zone</a>","location":{"filename":"src/time/location.cr","line_number":384,"url":null},"def":{"name":"lookup","args":[{"name":"time","external_name":"time","restriction":"Time"}],"return_type":"Zone","visibility":"Public","body":"lookup(time.to_unix)"}},{"html_id":"lookup(unix_seconds:Int):Zone-instance-method","name":"lookup","doc":"Returns the time zone offset observed at *unix_seconds*.\n\n*unix_seconds* expresses the number of seconds since UNIX epoch\n(`1970-01-01 00:00:00 UTC`).","summary":"<p>Returns the time zone offset observed at <em>unix_seconds</em>.</p>","abstract":false,"args":[{"name":"unix_seconds","external_name":"unix_seconds","restriction":"Int"}],"args_string":"(unix_seconds : Int) : Zone","args_html":"(unix_seconds : <a href=\"../Int.html\">Int</a>) : <a href=\"../Time/Location/Zone.html\">Zone</a>","location":{"filename":"src/time/location.cr","line_number":392,"url":null},"def":{"name":"lookup","args":[{"name":"unix_seconds","external_name":"unix_seconds","restriction":"Int"}],"return_type":"Zone","visibility":"Public","body":"if @cached_range[0] <= unix_seconds && unix_seconds < @cached_range[1]\nelse\n  @cached_zone, @cached_range = lookup_with_boundaries(unix_seconds)\nend\n@cached_zone\n"}},{"html_id":"name:String-instance-method","name":"name","doc":"Returns the name of this location.\n\nIt usually consists of a continent and city name separated by a slash, for\nexample `Europe/Berlin`.","summary":"<p>Returns the name of this location.</p>","abstract":false,"location":{"filename":"src/time/location.cr","line_number":202,"url":null},"def":{"name":"name","return_type":"String","visibility":"Public","body":"@name"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Prints `name` to *io*.","summary":"<p>Prints <code><a href=\"../Time/Location.html#name%3AString-instance-method\">#name</a></code> to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/time/location.cr","line_number":367,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << name"}},{"html_id":"utc?:Bool-instance-method","name":"utc?","doc":"Returns `true` if this location equals to `UTC`.","summary":"<p>Returns <code>true</code> if this location equals to <code><a href=\"../Time/Location.html#UTC\">UTC</a></code>.</p>","abstract":false,"location":{"filename":"src/time/location.cr","line_number":454,"url":null},"def":{"name":"utc?","return_type":"Bool","visibility":"Public","body":"self == UTC"}},{"html_id":"zones:Array(Zone)-instance-method","name":"zones","doc":"Returns the array of time zone offsets (`Zone`) used in this time zone.","summary":"<p>Returns the array of time zone offsets (<code><a href=\"../Time/Location/Zone.html\">Zone</a></code>) used in this time zone.</p>","abstract":false,"location":{"filename":"src/time/location.cr","line_number":205,"url":null},"def":{"name":"zones","return_type":"Array(Zone)","visibility":"Public","body":"@zones"}}],"types":[{"html_id":"Crystal/Time/Location/InvalidLocationNameError","path":"Time/Location/InvalidLocationNameError.html","kind":"class","full_name":"Time::Location::InvalidLocationNameError","name":"InvalidLocationNameError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/time/location.cr","line_number":54,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time/Location","kind":"class","full_name":"Time::Location","name":"Location"},"doc":"`InvalidLocationNameError` is raised if a location name cannot be found in\nthe time zone database.\n\nSee `Time::Location.load` for details.","summary":"<p><code><a href=\"../../Time/Location/InvalidLocationNameError.html\">InvalidLocationNameError</a></code> is raised if a location name cannot be found in the time zone database.</p>","constructors":[{"html_id":"new(name:String,source:String?=nil)-class-method","name":"new","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"source","default_value":"nil","external_name":"source","restriction":"String | ::Nil"}],"args_string":"(name : String, source : String? = nil)","args_html":"(name : <a href=\"../../String.html\">String</a>, source : <a href=\"../../String.html\">String</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/time/location.cr","line_number":57,"url":null},"def":{"name":"new","args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"source","default_value":"nil","external_name":"source","restriction":"String | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(name, source)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"name:String-instance-method","name":"name","abstract":false,"location":{"filename":"src/time/location.cr","line_number":55,"url":null},"def":{"name":"name","visibility":"Public","body":"@name"}},{"html_id":"source:String?-instance-method","name":"source","abstract":false,"location":{"filename":"src/time/location.cr","line_number":55,"url":null},"def":{"name":"source","visibility":"Public","body":"@source"}}]},{"html_id":"Crystal/Time/Location/InvalidTimezoneOffsetError","path":"Time/Location/InvalidTimezoneOffsetError.html","kind":"class","full_name":"Time::Location::InvalidTimezoneOffsetError","name":"InvalidTimezoneOffsetError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/time/location.cr","line_number":66,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time/Location","kind":"class","full_name":"Time::Location","name":"Location"},"doc":"`InvalidTimezoneOffsetError` is raised if `Time::Location::Zone.new`\nreceives an invalid time zone offset.","summary":"<p><code><a href=\"../../Time/Location/InvalidTimezoneOffsetError.html\">InvalidTimezoneOffsetError</a></code> is raised if <code><a href=\"../../Time/Location/Zone.html#new%28name%3AString%3F%2Coffset%3AInt32%2Cdst%3ABool%29-class-method\">Time::Location::Zone.new</a></code> receives an invalid time zone offset.</p>","constructors":[{"html_id":"new(offset:Int)-class-method","name":"new","abstract":false,"args":[{"name":"offset","external_name":"offset","restriction":"Int"}],"args_string":"(offset : Int)","args_html":"(offset : <a href=\"../../Int.html\">Int</a>)","location":{"filename":"src/time/location.cr","line_number":67,"url":null},"def":{"name":"new","args":[{"name":"offset","external_name":"offset","restriction":"Int"}],"visibility":"Public","body":"_ = allocate\n_.initialize(offset)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]},{"html_id":"Crystal/Time/Location/InvalidTZDataError","path":"Time/Location/InvalidTZDataError.html","kind":"class","full_name":"Time::Location::InvalidTZDataError","name":"InvalidTZDataError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/time/location/loader.cr","line_number":8,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time/Location","kind":"class","full_name":"Time::Location","name":"Location"},"doc":"`InvalidTZDataError` is raised if a zoneinfo file contains invalid\ntime zone data.\n\nDetails on the exact cause can be found in the error message.","summary":"<p><code><a href=\"../../Time/Location/InvalidTZDataError.html\">InvalidTZDataError</a></code> is raised if a zoneinfo file contains invalid time zone data.</p>","class_methods":[{"html_id":"initialize(message:String?=\"Malformedtimezoneinformation\",cause:Exception?=nil)-class-method","name":"initialize","abstract":false,"args":[{"name":"message","default_value":"\"Malformed time zone information\"","external_name":"message","restriction":"String | ::Nil"},{"name":"cause","default_value":"nil","external_name":"cause","restriction":"Exception | ::Nil"}],"args_string":"(message : String? = \"Malformed time zone information\", cause : Exception? = nil)","args_html":"(message : <a href=\"../../String.html\">String</a>? = <span class=\"s\">&quot;Malformed time zone information&quot;</span>, cause : <a href=\"../../Exception.html\">Exception</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/time/location/loader.cr","line_number":9,"url":null},"def":{"name":"initialize","args":[{"name":"message","default_value":"\"Malformed time zone information\"","external_name":"message","restriction":"String | ::Nil"},{"name":"cause","default_value":"nil","external_name":"cause","restriction":"Exception | ::Nil"}],"visibility":"Public","body":"super(message, cause)"}}]},{"html_id":"Crystal/Time/Location/Zone","path":"Time/Location/Zone.html","kind":"struct","full_name":"Time::Location::Zone","name":"Zone","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/time/location.cr","line_number":76,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"UTC","name":"UTC","value":"new(\"UTC\", 0, false)","doc":"This is the `UTC` time zone with offset `+00:00`.\n\nIt is the only zone offset used in `Time::Location::UTC`.","summary":"<p>This is the <code><a href=\"../../Time/Location/Zone.html#UTC\">UTC</a></code> time zone with offset <code>+00:00</code>.</p>"}],"namespace":{"html_id":"Crystal/Time/Location","kind":"class","full_name":"Time::Location","name":"Location"},"doc":"A `Zone` represents a time zone offset in effect in a specific `Location`.\n\nSome zones have a `name` or abbreviation (such as `PDT`, `CEST`).\nFor an unnamed zone the formatted offset should be used as name.","summary":"<p>A <code><a href=\"../../Time/Location/Zone.html\">Zone</a></code> represents a time zone offset in effect in a specific <code><a href=\"../../Time/Location.html\">Location</a></code>.</p>","constructors":[{"html_id":"new(name:String?,offset:Int32,dst:Bool)-class-method","name":"new","doc":"Creates a new `Zone` named *name* with *offset* from UTC in seconds.\nThe parameter *dst* is used to declare this zone as daylight savings time.\n\nIf `name` is `nil`, the formatted `offset` will be used as `name` (see\n`#format`).\n\nRaises `InvalidTimezoneOffsetError` if *seconds* is outside the supported\nvalue range `-86_400..86_400` seconds (`-24:00` to `+24:00`).","summary":"<p>Creates a new <code><a href=\"../../Time/Location/Zone.html\">Zone</a></code> named <em>name</em> with <em>offset</em> from UTC in seconds.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String | ::Nil"},{"name":"offset","external_name":"offset","restriction":"Int32"},{"name":"dst","external_name":"dst","restriction":"Bool"}],"args_string":"(name : String?, offset : Int32, dst : Bool)","args_html":"(name : <a href=\"../../String.html\">String</a>?, offset : <a href=\"../../Int32.html\">Int32</a>, dst : <a href=\"../../Bool.html\">Bool</a>)","location":{"filename":"src/time/location.cr","line_number":96,"url":null},"def":{"name":"new","args":[{"name":"name","external_name":"name","restriction":"String | ::Nil"},{"name":"offset","external_name":"offset","restriction":"Int32"},{"name":"dst","external_name":"dst","restriction":"Bool"}],"visibility":"Public","body":"_ = allocate\n_.initialize(name, offset, dst)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"dst?:Bool-instance-method","name":"dst?","doc":"Returns `true` if this zone offset is daylight savings time.","summary":"<p>Returns <code>true</code> if this zone offset is daylight savings time.</p>","abstract":false,"location":{"filename":"src/time/location.cr","line_number":86,"url":null},"def":{"name":"dst?","return_type":"Bool","visibility":"Public","body":"@dst"}},{"html_id":"format(io:IO,with_colon=true,with_seconds=:auto)-instance-method","name":"format","doc":"Prints `#offset` to *io* in the format `+HH:mm:ss`.\nWhen *with_colon* is `false`, the format is `+HHmmss`.\n\nWhen *with_seconds* is `false`, seconds are omitted; when `:auto`, seconds\nare omitted if `0`.","summary":"<p>Prints <code><a href=\"../../Time/Location/Zone.html#offset%3AInt32-instance-method\">#offset</a></code> to <em>io</em> in the format <code>+HH:mm:ss</code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"with_colon","default_value":"true","external_name":"with_colon","restriction":""},{"name":"with_seconds","default_value":":auto","external_name":"with_seconds","restriction":""}],"args_string":"(io : IO, with_colon = true, with_seconds = :auto)","args_html":"(io : <a href=\"../../IO.html\">IO</a>, with_colon = <span class=\"n\">true</span>, with_seconds = <span class=\"n\">:auto</span>)","location":{"filename":"src/time/location.cr","line_number":130,"url":null},"def":{"name":"format","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"with_colon","default_value":"true","external_name":"with_colon","restriction":""},{"name":"with_seconds","default_value":":auto","external_name":"with_seconds","restriction":""}],"visibility":"Public","body":"sign, hours, minutes, seconds = sign_hours_minutes_seconds\nio << sign\nif hours < 10\n  io << '0'\nend\nio << hours\nif with_colon\n  io << ':'\nend\nif minutes < 10\n  io << '0'\nend\nio << minutes\nif (with_seconds == true) || ((seconds != 0) && (with_seconds == (:auto)))\n  if with_colon\n    io << ':'\n  end\n  if seconds < 10\n    io << '0'\n  end\n  io << seconds\nend\n"}},{"html_id":"format(with_colon=true,with_seconds=:auto)-instance-method","name":"format","doc":"Returns the `#offset` formatted as `+HH:mm:ss`.\nWhen *with_colon* is `false`, the format is `+HHmmss`.\n\nWhen *with_seconds* is `false`, seconds are omitted; when `:auto`, seconds\nare omitted if `0`.","summary":"<p>Returns the <code><a href=\"../../Time/Location/Zone.html#offset%3AInt32-instance-method\">#offset</a></code> formatted as <code>+HH:mm:ss</code>.</p>","abstract":false,"args":[{"name":"with_colon","default_value":"true","external_name":"with_colon","restriction":""},{"name":"with_seconds","default_value":":auto","external_name":"with_seconds","restriction":""}],"args_string":"(with_colon = true, with_seconds = :auto)","args_html":"(with_colon = <span class=\"n\">true</span>, with_seconds = <span class=\"n\">:auto</span>)","location":{"filename":"src/time/location.cr","line_number":152,"url":null},"def":{"name":"format","args":[{"name":"with_colon","default_value":"true","external_name":"with_colon","restriction":""},{"name":"with_seconds","default_value":":auto","external_name":"with_seconds","restriction":""}],"visibility":"Public","body":"String.build do |io|\n  format(io, with_colon: with_colon, with_seconds: with_seconds)\nend"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Prints this `Zone` to *io*.\n\nIt contains the `name`, hour-minute-second format (see `#format`),\n`offset` in seconds and `\"DST\"` if `#dst?`, otherwise `\"STD\"`.","summary":"<p>Prints this <code><a href=\"../../Time/Location/Zone.html\">Zone</a></code> to <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../../IO.html\">IO</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/time/location.cr","line_number":112,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"Time::Location::Zone(\"\nif @name.nil?\nelse\n  (io << @name) << ' '\nend\nformat(io)\n((io << \" (\") << offset) << \"s)\"\nif dst?\n  io << \" DST\"\nelse\n  io << \" STD\"\nend\nio << ')'\n"}},{"html_id":"name:String-instance-method","name":"name","doc":"Returns the name of the zone.","summary":"<p>Returns the name of the zone.</p>","abstract":false,"location":{"filename":"src/time/location.cr","line_number":104,"url":null},"def":{"name":"name","return_type":"String","visibility":"Public","body":"@name || format"}},{"html_id":"offset:Int32-instance-method","name":"offset","doc":"Returns the offset from UTC in seconds.","summary":"<p>Returns the offset from UTC in seconds.</p>","abstract":false,"location":{"filename":"src/time/location.cr","line_number":83,"url":null},"def":{"name":"offset","return_type":"Int32","visibility":"Public","body":"@offset"}}]}]},{"html_id":"Crystal/Time/MonthSpan","path":"Time/MonthSpan.html","kind":"struct","full_name":"Time::MonthSpan","name":"MonthSpan","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/time/span.cr","line_number":574,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/Time","kind":"struct","full_name":"Time","name":"Time"},"doc":"Represents a number of months passed. Used for shifting `Time`s by a\nspecified number of months.\n\n```\nTime.local(2016, 2, 1) + 13.months # => 2017-03-01 00:00:00\nTime.local(2016, 2, 29) + 2.years  # => 2018-02-28 00:00:00\n```","summary":"<p>Represents a number of months passed.</p>","constructors":[{"html_id":"new(value:Int)-class-method","name":"new","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Int"}],"args_string":"(value : Int)","args_html":"(value : <a href=\"../Int.html\">Int</a>)","location":{"filename":"src/time/span.cr","line_number":578,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"Int"}],"visibility":"Public","body":"_ = allocate\n_.initialize(value)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"ago:Time-instance-method","name":"ago","doc":"Returns a `Time` that happens N months before now.","summary":"<p>Returns a <code><a href=\"../Time.html\">Time</a></code> that happens N months before now.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":588,"url":null},"def":{"name":"ago","return_type":"Time","visibility":"Public","body":"Time.local - self"}},{"html_id":"from_now:Time-instance-method","name":"from_now","doc":"Returns a `Time` that happens N months after now.","summary":"<p>Returns a <code><a href=\"../Time.html\">Time</a></code> that happens N months after now.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":583,"url":null},"def":{"name":"from_now","return_type":"Time","visibility":"Public","body":"Time.local + self"}},{"html_id":"value:Int64-instance-method","name":"value","doc":"The number of months.","summary":"<p>The number of months.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":576,"url":null},"def":{"name":"value","return_type":"Int64","visibility":"Public","body":"@value"}}]},{"html_id":"Crystal/Time/Span","path":"Time/Span.html","kind":"struct","full_name":"Time::Span","name":"Span","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/time/span.cr","line_number":39,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"MAX","name":"MAX","value":"new(seconds: Int64::MAX, nanoseconds: 999999999)"},{"id":"MIN","name":"MIN","value":"new(seconds: Int64::MIN, nanoseconds: -999999999)"},{"id":"ZERO","name":"ZERO","value":"new(nanoseconds: 0)"}],"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"}],"namespace":{"html_id":"Crystal/Time","kind":"struct","full_name":"Time","name":"Time"},"doc":"`Time::Span` represents one period of time.\n\nA `Time::Span` initializes with the specified period.\nDifferent numbers of arguments generate a `Time::Span` in different length.\nCheck all `#new` methods for details.\n\n```\nTime::Span.new(nanoseconds: 10_000)                           # => 00:00:00.000010000\nTime::Span.new(hours: 10, minutes: 10, seconds: 10)           # => 10:10:10\nTime::Span.new(days: 10, hours: 10, minutes: 10, seconds: 10) # => 10.10:10:10\n```\n\nCalculation between `Time` also returns a `Time::Span`.\n\n```\nspan = Time.utc(2015, 10, 10) - Time.utc(2015, 9, 10)\nspan       # => 30.00:00:00\nspan.class # => Time::Span\n```\n\nInspection:\n\n```\nspan = Time::Span.new(hours: 20, minutes: 10, seconds: 10)\nspan.hours   # => 20\nspan.minutes # => 10\nspan.seconds # => 10\n```\n\nCalculation:\n\n```\na = Time::Span.new(hours: 20, minutes: 10, seconds: 10)\nb = Time::Span.new(hours: 10, minutes: 10, seconds: 10)\nc = a - b # => 10:00:00\nc.hours   # => 10\n```\n","summary":"<p><code><a href=\"../Time/Span.html\">Time::Span</a></code> represents one period of time.</p>","class_methods":[{"html_id":"zero:Time::Span-class-method","name":"zero","doc":"Creates a new `Time::Span` representing a span of zero time.","summary":"<p>Creates a new <code><a href=\"../Time/Span.html\">Time::Span</a></code> representing a span of zero time.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":387,"url":null},"def":{"name":"zero","return_type":"Time::Span","visibility":"Public","body":"ZERO"}}],"constructors":[{"html_id":"additive_identity:self-class-method","name":"additive_identity","doc":"Returns the additive identity of this type.\n\nThis is `zero`.","summary":"<p>Returns the additive identity of this type.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":285,"url":null},"def":{"name":"additive_identity","return_type":"self","visibility":"Public","body":"zero"}},{"html_id":"new(*,seconds:Int,nanoseconds:Int)-class-method","name":"new","doc":"Creates a new `Time::Span` from *seconds* and *nanoseconds*.\n\nNanoseconds get normalized in the range of `0...1_000_000_000`,\nthe nanosecond overflow gets added as seconds.\n\n```\nTime::Span.new(seconds: 30)                 # => 00:00:30\nTime::Span.new(seconds: 5, nanoseconds: 12) # => 00:00:05.000000012\n```","summary":"<p>Creates a new <code><a href=\"../Time/Span.html\">Time::Span</a></code> from <em>seconds</em> and <em>nanoseconds</em>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"seconds","external_name":"seconds","restriction":"Int"},{"name":"nanoseconds","external_name":"nanoseconds","restriction":"Int"}],"args_string":"(*, seconds : Int, nanoseconds : Int)","args_html":"(*, seconds : <a href=\"../Int.html\">Int</a>, nanoseconds : <a href=\"../Int.html\">Int</a>)","location":{"filename":"src/time/span.cr","line_number":66,"url":null},"def":{"name":"new","args":[{"name":"","external_name":"","restriction":""},{"name":"seconds","external_name":"seconds","restriction":"Int"},{"name":"nanoseconds","external_name":"nanoseconds","restriction":"Int"}],"splat_index":0,"visibility":"Public","body":"_ = allocate\n_.initialize(seconds: seconds, nanoseconds: nanoseconds)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(*,nanoseconds:Int)-class-method","name":"new","doc":"Creates a new `Time::Span` from the *nanoseconds* given\n\nNanoseconds get normalized in the range of `0...1_000_000_000`,\nthe nanosecond overflow gets added as seconds.\n\n```\nTime::Span.new(nanoseconds: 500_000_000)   # => 00:00:00.500000000\nTime::Span.new(nanoseconds: 5_500_000_000) # => 00:00:05.500000000\n```","summary":"<p>Creates a new <code><a href=\"../Time/Span.html\">Time::Span</a></code> from the <em>nanoseconds</em> given</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"nanoseconds","external_name":"nanoseconds","restriction":"Int"}],"args_string":"(*, nanoseconds : Int)","args_html":"(*, nanoseconds : <a href=\"../Int.html\">Int</a>)","location":{"filename":"src/time/span.cr","line_number":95,"url":null},"def":{"name":"new","args":[{"name":"","external_name":"","restriction":""},{"name":"nanoseconds","external_name":"nanoseconds","restriction":"Int"}],"splat_index":0,"visibility":"Public","body":"new(seconds: nanoseconds.to_i64.tdiv(NANOSECONDS_PER_SECOND), nanoseconds: nanoseconds.to_i64.remainder(NANOSECONDS_PER_SECOND))"}},{"html_id":"new(*,days:Int=0,hours:Int=0,minutes:Int=0,seconds:Int=0,nanoseconds:Int=0)-class-method","name":"new","doc":"Creates a new `Time::Span` from the *days*, *hours*, *minutes*, *seconds* and *nanoseconds* given\n\nAny time unit can be omitted.\n\n```\nTime::Span.new(days: 1)                                                   # => 1.00:00:00\nTime::Span.new(days: 1, hours: 2, minutes: 3)                             # => 01:02:03\nTime::Span.new(days: 1, hours: 2, minutes: 3, seconds: 4, nanoseconds: 5) # => 1.02:03:04.000000005\n```","summary":"<p>Creates a new <code><a href=\"../Time/Span.html\">Time::Span</a></code> from the <em>days</em>, <em>hours</em>, <em>minutes</em>, <em>seconds</em> and <em>nanoseconds</em> given</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"days","default_value":"0","external_name":"days","restriction":"Int"},{"name":"hours","default_value":"0","external_name":"hours","restriction":"Int"},{"name":"minutes","default_value":"0","external_name":"minutes","restriction":"Int"},{"name":"seconds","default_value":"0","external_name":"seconds","restriction":"Int"},{"name":"nanoseconds","default_value":"0","external_name":"nanoseconds","restriction":"Int"}],"args_string":"(*, days : Int = 0, hours : Int = 0, minutes : Int = 0, seconds : Int = 0, nanoseconds : Int = 0)","args_html":"(*, days : <a href=\"../Int.html\">Int</a> = <span class=\"n\">0</span>, hours : <a href=\"../Int.html\">Int</a> = <span class=\"n\">0</span>, minutes : <a href=\"../Int.html\">Int</a> = <span class=\"n\">0</span>, seconds : <a href=\"../Int.html\">Int</a> = <span class=\"n\">0</span>, nanoseconds : <a href=\"../Int.html\">Int</a> = <span class=\"n\">0</span>)","location":{"filename":"src/time/span.cr","line_number":111,"url":null},"def":{"name":"new","args":[{"name":"","external_name":"","restriction":""},{"name":"days","default_value":"0","external_name":"days","restriction":"Int"},{"name":"hours","default_value":"0","external_name":"hours","restriction":"Int"},{"name":"minutes","default_value":"0","external_name":"minutes","restriction":"Int"},{"name":"seconds","default_value":"0","external_name":"seconds","restriction":"Int"},{"name":"nanoseconds","default_value":"0","external_name":"nanoseconds","restriction":"Int"}],"splat_index":0,"visibility":"Public","body":"new(seconds: compute_seconds(days, hours, minutes, seconds), nanoseconds: nanoseconds.to_i64)"}}],"instance_methods":[{"html_id":"*(number:Int):Time::Span-instance-method","name":"*","doc":"Returns a `Time::Span` that is *number* times longer.","summary":"<p>Returns a <code><a href=\"../Time/Span.html\">Time::Span</a></code> that is <em>number</em> times longer.</p>","abstract":false,"args":[{"name":"number","external_name":"number","restriction":"Int"}],"args_string":"(number : Int) : Time::Span","args_html":"(number : <a href=\"../Int.html\">Int</a>) : <a href=\"../Time/Span.html\">Time::Span</a>","location":{"filename":"src/time/span.cr","line_number":294,"url":null},"def":{"name":"*","args":[{"name":"number","external_name":"number","restriction":"Int"}],"return_type":"Time::Span","visibility":"Public","body":"Span.new(seconds: to_i * number, nanoseconds: nanoseconds.to_i64 * number)"}},{"html_id":"*(number:Float):Time::Span-instance-method","name":"*","doc":"Returns a `Time::Span` that is *number* times longer.","summary":"<p>Returns a <code><a href=\"../Time/Span.html\">Time::Span</a></code> that is <em>number</em> times longer.</p>","abstract":false,"args":[{"name":"number","external_name":"number","restriction":"Float"}],"args_string":"(number : Float) : Time::Span","args_html":"(number : <a href=\"../Float.html\">Float</a>) : <a href=\"../Time/Span.html\">Time::Span</a>","location":{"filename":"src/time/span.cr","line_number":303,"url":null},"def":{"name":"*","args":[{"name":"number","external_name":"number","restriction":"Float"}],"return_type":"Time::Span","visibility":"Public","body":"(total_nanoseconds * number).nanoseconds"}},{"html_id":"+(other:self):Time::Span-instance-method","name":"+","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self) : Time::Span","args_html":"(other : <span class=\"k\">self</span>) : <a href=\"../Time/Span.html\">Time::Span</a>","location":{"filename":"src/time/span.cr","line_number":274,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"self"}],"return_type":"Time::Span","visibility":"Public","body":"Span.new(seconds: to_i + other.to_i, nanoseconds: nanoseconds + other.nanoseconds)"}},{"html_id":"+:self-instance-method","name":"+","abstract":false,"location":{"filename":"src/time/span.cr","line_number":289,"url":null},"def":{"name":"+","return_type":"self","visibility":"Public","body":"self"}},{"html_id":"-(other:self):Time::Span-instance-method","name":"-","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self) : Time::Span","args_html":"(other : <span class=\"k\">self</span>) : <a href=\"../Time/Span.html\">Time::Span</a>","location":{"filename":"src/time/span.cr","line_number":258,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"self"}],"return_type":"Time::Span","visibility":"Public","body":"Span.new(seconds: to_i - other.to_i, nanoseconds: nanoseconds - other.nanoseconds)"}},{"html_id":"-:Time::Span-instance-method","name":"-","abstract":false,"location":{"filename":"src/time/span.cr","line_number":266,"url":null},"def":{"name":"-","return_type":"Time::Span","visibility":"Public","body":"Span.new(seconds: -to_i, nanoseconds: -nanoseconds)"}},{"html_id":"/(number:Int):Time::Span-instance-method","name":"/","doc":"Returns a `Time::Span` that is divided by *number*.","summary":"<p>Returns a <code><a href=\"../Time/Span.html\">Time::Span</a></code> that is divided by <em>number</em>.</p>","abstract":false,"args":[{"name":"number","external_name":"number","restriction":"Int"}],"args_string":"(number : Int) : Time::Span","args_html":"(number : <a href=\"../Int.html\">Int</a>) : <a href=\"../Time/Span.html\">Time::Span</a>","location":{"filename":"src/time/span.cr","line_number":308,"url":null},"def":{"name":"/","args":[{"name":"number","external_name":"number","restriction":"Int"}],"return_type":"Time::Span","visibility":"Public","body":"seconds = to_i.tdiv(number)\nnanoseconds = self.nanoseconds.tdiv(number)\nremainder = to_i.remainder(number)\nnanoseconds = nanoseconds + ((remainder * NANOSECONDS_PER_SECOND) // number)\nSpan.new(seconds: seconds, nanoseconds: nanoseconds)\n"}},{"html_id":"/(number:Float):Time::Span-instance-method","name":"/","doc":"Returns a `Time::Span` that is divided by *number*.","summary":"<p>Returns a <code><a href=\"../Time/Span.html\">Time::Span</a></code> that is divided by <em>number</em>.</p>","abstract":false,"args":[{"name":"number","external_name":"number","restriction":"Float"}],"args_string":"(number : Float) : Time::Span","args_html":"(number : <a href=\"../Float.html\">Float</a>) : <a href=\"../Time/Span.html\">Time::Span</a>","location":{"filename":"src/time/span.cr","line_number":323,"url":null},"def":{"name":"/","args":[{"name":"number","external_name":"number","restriction":"Float"}],"return_type":"Time::Span","visibility":"Public","body":"(total_nanoseconds / number).nanoseconds"}},{"html_id":"/(other:self):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self) : Float64","args_html":"(other : <span class=\"k\">self</span>) : <a href=\"../Float64.html\">Float64</a>","location":{"filename":"src/time/span.cr","line_number":327,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"self"}],"return_type":"Float64","visibility":"Public","body":"total_nanoseconds.to_f64 / other.total_nanoseconds.to_f64"}},{"html_id":"<=>(other:self)-instance-method","name":"<=>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/time/span.cr","line_number":331,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"cmp = to_i <=> other.to_i\nif cmp == 0\n  cmp = nanoseconds <=> other.nanoseconds\nend\ncmp\n"}},{"html_id":"abs:Time::Span-instance-method","name":"abs","doc":"Returns the absolute (non-negative) amount of time this `Time::Span`\nrepresents by removing the sign.","summary":"<p>Returns the absolute (non-negative) amount of time this <code><a href=\"../Time/Span.html\">Time::Span</a></code> represents by removing the sign.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":233,"url":null},"def":{"name":"abs","return_type":"Time::Span","visibility":"Public","body":"Span.new(seconds: to_i.abs, nanoseconds: nanoseconds.abs)"}},{"html_id":"ago:Time-instance-method","name":"ago","doc":"Returns a `Time` that happens earlier by `self` than the current time.","summary":"<p>Returns a <code><a href=\"../Time.html\">Time</a></code> that happens earlier by <code>self</code> than the current time.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":254,"url":null},"def":{"name":"ago","return_type":"Time","visibility":"Public","body":"Time.local - self"}},{"html_id":"days:Int64-instance-method","name":"days","doc":"Returns the number of full days in this time span.\n\n```\n(5.days + 25.hours).days # => 6_i64\n```","summary":"<p>Returns the number of full days in this time span.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":133,"url":null},"def":{"name":"days","return_type":"Int64","visibility":"Public","body":"to_i.tdiv(SECONDS_PER_DAY)"}},{"html_id":"from_now:Time-instance-method","name":"from_now","doc":"Returns a `Time` that happens later by `self` than the current time.","summary":"<p>Returns a <code><a href=\"../Time.html\">Time</a></code> that happens later by <code>self</code> than the current time.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":249,"url":null},"def":{"name":"from_now","return_type":"Time","visibility":"Public","body":"Time.local + self"}},{"html_id":"hours:Int32-instance-method","name":"hours","doc":"Returns the number of full hours of the day (`0..23`) in this time span.","summary":"<p>Returns the number of full hours of the day (<code>0..23</code>) in this time span.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":138,"url":null},"def":{"name":"hours","return_type":"Int32","visibility":"Public","body":"((to_i.remainder(SECONDS_PER_DAY)).tdiv(SECONDS_PER_HOUR)).to_i"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends this struct's name and instance variables names and values\nto the given IO.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np1.to_s    # \"Point(@x=1, @y=2)\"\np1.inspect # \"Point(@x=1, @y=2)\"\n```","summary":"<p>Appends this struct's name and instance variables names and values to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/time/span.cr","line_number":341,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"if to_i < 0 || nanoseconds < 0\n  io << '-'\nend\nif days != 0\n  io << days.abs\n  io << '.'\nend\nhours = self.hours.abs\nif hours < 10\n  io << '0'\nend\nio << hours\nio << ':'\nminutes = self.minutes.abs\nif minutes < 10\n  io << '0'\nend\nio << minutes\nio << ':'\nseconds = self.seconds.abs\nif seconds < 10\n  io << '0'\nend\nio << seconds\nnanoseconds = self.nanoseconds.abs\nif nanoseconds != 0\n  io << '.'\n  if nanoseconds < 100000000\n    io << '0'\n  end\n  if nanoseconds < 10000000\n    io << '0'\n  end\n  if nanoseconds < 1000000\n    io << '0'\n  end\n  if nanoseconds < 100000\n    io << '0'\n  end\n  if nanoseconds < 10000\n    io << '0'\n  end\n  if nanoseconds < 1000\n    io << '0'\n  end\n  if nanoseconds < 100\n    io << '0'\n  end\n  if nanoseconds < 10\n    io << '0'\n  end\n  io << nanoseconds\nend\n"}},{"html_id":"microseconds:Int32-instance-method","name":"microseconds","doc":"Returns the number of microseconds of the second (`0..999999`) in this time span.","summary":"<p>Returns the number of microseconds of the second (<code>0..999999</code>) in this time span.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":163,"url":null},"def":{"name":"microseconds","return_type":"Int32","visibility":"Public","body":"nanoseconds // NANOSECONDS_PER_MICROSECOND"}},{"html_id":"milliseconds:Int32-instance-method","name":"milliseconds","doc":"Returns the number of milliseconds of the second (`0..999`) in this time span.","summary":"<p>Returns the number of milliseconds of the second (<code>0..999</code>) in this time span.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":158,"url":null},"def":{"name":"milliseconds","return_type":"Int32","visibility":"Public","body":"nanoseconds // NANOSECONDS_PER_MILLISECOND"}},{"html_id":"minutes:Int32-instance-method","name":"minutes","doc":"Returns the number of full minutes of the hour (`0..59`) in this time span.","summary":"<p>Returns the number of full minutes of the hour (<code>0..59</code>) in this time span.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":145,"url":null},"def":{"name":"minutes","return_type":"Int32","visibility":"Public","body":"((to_i.remainder(SECONDS_PER_HOUR)).tdiv(SECONDS_PER_MINUTE)).to_i"}},{"html_id":"nanoseconds:Int32-instance-method","name":"nanoseconds","doc":"Returns the number of nanoseconds of the second (`0..999_999_999`)\nin this time span.","summary":"<p>Returns the number of nanoseconds of the second (<code>0..999_999_999</code>) in this time span.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":169,"url":null},"def":{"name":"nanoseconds","return_type":"Int32","visibility":"Public","body":"@nanoseconds"}},{"html_id":"negative?:Bool-instance-method","name":"negative?","doc":"Returns `true` if `self` represents a negative time span.\n\n```\n2.hours.negative? # => false\n0.days.negative?  # => false\n-3.days.negative? # => true\n```","summary":"<p>Returns <code>true</code> if <code>self</code> represents a negative time span.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":420,"url":null},"def":{"name":"negative?","return_type":"Bool","visibility":"Public","body":"self < ZERO"}},{"html_id":"positive?:Bool-instance-method","name":"positive?","doc":"Returns `true` if `self` represents a positive time span.\n\n```\n2.hours.positive? # => true\n0.days.positive?  # => false\n-3.days.positive? # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> represents a positive time span.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":409,"url":null},"def":{"name":"positive?","return_type":"Bool","visibility":"Public","body":"self > ZERO"}},{"html_id":"seconds:Int32-instance-method","name":"seconds","doc":"Returns the number of full seconds of the minute (`0..59`) in this time span.","summary":"<p>Returns the number of full seconds of the minute (<code>0..59</code>) in this time span.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":152,"url":null},"def":{"name":"seconds","return_type":"Int32","visibility":"Public","body":"(to_i.remainder(SECONDS_PER_MINUTE)).to_i"}},{"html_id":"sign:Int32-instance-method","name":"sign","doc":"Returns the sign of this time span.\n\nValues are `-1`, `0`, `1` if `self` is smaller, equal, bigger compared to `ZERO`.","summary":"<p>Returns the sign of this time span.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":337,"url":null},"def":{"name":"sign","return_type":"Int32","visibility":"Public","body":"(self <=> ZERO).sign"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Alias of `total_seconds`.","summary":"<p>Alias of <code><a href=\"../Time/Span.html#total_seconds%3AFloat64-instance-method\">#total_seconds</a></code>.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":222,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"total_seconds"}},{"html_id":"to_i:Int64-instance-method","name":"to_i","doc":"Returns the number of full seconds.","summary":"<p>Returns the number of full seconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":227,"url":null},"def":{"name":"to_i","return_type":"Int64","visibility":"Public","body":"@seconds"}},{"html_id":"total_days:Float64-instance-method","name":"total_days","doc":"Converts to a (possibly fractional) number of days.\n\n```\n(36.hours).total_days # => 1.5\n```","summary":"<p>Converts to a (possibly fractional) number of days.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":187,"url":null},"def":{"name":"total_days","return_type":"Float64","visibility":"Public","body":"total_hours / 24"}},{"html_id":"total_hours:Float64-instance-method","name":"total_hours","doc":"Converts to a (possibly fractional) number of hours.","summary":"<p>Converts to a (possibly fractional) number of hours.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":192,"url":null},"def":{"name":"total_hours","return_type":"Float64","visibility":"Public","body":"total_minutes / 60"}},{"html_id":"total_microseconds:Float64-instance-method","name":"total_microseconds","doc":"Converts to a number of microseconds.","summary":"<p>Converts to a number of microseconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":212,"url":null},"def":{"name":"total_microseconds","return_type":"Float64","visibility":"Public","body":"total_nanoseconds / NANOSECONDS_PER_MICROSECOND"}},{"html_id":"total_milliseconds:Float64-instance-method","name":"total_milliseconds","doc":"Converts to a number of milliseconds.","summary":"<p>Converts to a number of milliseconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":207,"url":null},"def":{"name":"total_milliseconds","return_type":"Float64","visibility":"Public","body":"total_nanoseconds / NANOSECONDS_PER_MILLISECOND"}},{"html_id":"total_minutes:Float64-instance-method","name":"total_minutes","doc":"Converts to a (possibly fractional) number of minutes.","summary":"<p>Converts to a (possibly fractional) number of minutes.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":197,"url":null},"def":{"name":"total_minutes","return_type":"Float64","visibility":"Public","body":"total_seconds / 60"}},{"html_id":"total_nanoseconds:Float64-instance-method","name":"total_nanoseconds","doc":"Converts to a number of nanoseconds.","summary":"<p>Converts to a number of nanoseconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":217,"url":null},"def":{"name":"total_nanoseconds","return_type":"Float64","visibility":"Public","body":"(to_i.to_f * NANOSECONDS_PER_SECOND) + nanoseconds"}},{"html_id":"total_seconds:Float64-instance-method","name":"total_seconds","doc":"Converts to a (possibly fractional) number of seconds.","summary":"<p>Converts to a (possibly fractional) number of seconds.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":202,"url":null},"def":{"name":"total_seconds","return_type":"Float64","visibility":"Public","body":"to_i.to_f + (nanoseconds.to_f / NANOSECONDS_PER_SECOND)"}},{"html_id":"total_weeks:Float64-instance-method","name":"total_weeks","doc":"Converts to a (possibly fractional) number of weeks.\n\n```\n(4.weeks + 5.days + 6.hours).total_weeks # => 4.75\n```","summary":"<p>Converts to a (possibly fractional) number of weeks.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":178,"url":null},"def":{"name":"total_weeks","return_type":"Float64","visibility":"Public","body":"total_days / 7"}},{"html_id":"zero?:Bool-instance-method","name":"zero?","doc":"Returns `true` if `self` represents a span of zero time.\n\n```\n2.hours.zero?  # => false\n0.days.zero?   # => true\n1.second.zero? # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> represents a span of zero time.</p>","abstract":false,"location":{"filename":"src/time/span.cr","line_number":398,"url":null},"def":{"name":"zero?","return_type":"Bool","visibility":"Public","body":"self == ZERO"}}]}]},{"html_id":"Crystal/Tuple","path":"Tuple.html","kind":"struct","full_name":"Tuple(*T)","name":"Tuple","abstract":false,"superclass":{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"},{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Iterable","kind":"module","full_name":"Iterable","name":"Iterable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/to_json.cr","line_number":134,"url":null},{"filename":"src/tuple.cr","line_number":76,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":42,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Indexable","kind":"module","full_name":"Indexable","name":"Indexable"}],"doc":"A tuple is a fixed-size, immutable, stack-allocated sequence of values\nof possibly different types.\n\nYou can think of a `Tuple` as an immutable `Array` whose types for each position\nare known at compile time.\n\nA tuple can be created with the usual `new` method or with a tuple literal:\n\n```\ntuple = {1, \"hello\", 'x'} # Tuple(Int32, String, Char)\ntuple[0]                  # => 1\ntuple[1]                  # => \"hello\"\ntuple[2]                  # => 'x'\n```\n\nSee [`Tuple` literals](https://crystal-lang.org/reference/syntax_and_semantics/literals/tuple.html) in the language reference.\n\nThe compiler knows what types are in each position, so when indexing\na tuple with an integer literal the compiler will return\nthe value in that index and with the expected type, like in the above\nsnippet. Indexing with an integer literal outside the bounds of the tuple\nwill give a compile-time error.\n\nIndexing with an integer value that is only known at runtime will return\na value whose type is the union of all the types in the tuple, and might raise\n`IndexError`.\n\nIndexing with a range literal known at compile-time is also allowed, and the\nreturned value will have the correct sub-tuple type:\n\n```\ntuple = {1, \"hello\", 'x'} # Tuple(Int32, String, Char)\nsub = tuple[0..1]         # => {1, \"hello\"}\ntypeof(sub)               # => Tuple(Int32, String)\n```\n\nTuples are the preferred way to return fixed-size multiple return\nvalues because no memory is needed to be allocated for them:\n\n```\ndef one_and_hello\n  {1, \"hello\"}\nend\n\none, hello = one_and_hello\none   # => 1\nhello # => \"hello\"\n```\n\nGood examples of the above are `Number#divmod` and `Enumerable#minmax`.\n\nTuples can be splat with the `*` operator and passed to methods:\n\n```\ndef multiply(string, value)\n  string * value\nend\n\ntuple = {\"hey\", 2}\nvalue = multiply(*tuple) # same as multiply tuple[0], tuple[1]\nvalue                    # => \"heyhey\"\n```\n\nFinally, when using a splat argument in a method definition its type\nwill be a tuple of the call arguments:\n\n```\ndef splat_test(*args)\n  args\nend\n\ntuple = splat_test 1, \"hello\", 'x'\ntuple.class # => Tuple(Int32, String, Char)\ntuple       # => {1, \"hello\", 'x'}\n```","summary":"<p>A tuple is a fixed-size, immutable, stack-allocated sequence of values of possibly different types.</p>","class_methods":[{"html_id":"types-class-method","name":"types","doc":"Returns the types of this tuple type.\n\n```\ntuple = {1, \"hello\", 'x'}\ntuple.class.types # => {Int32, String, Char}\n```","summary":"<p>Returns the types of this tuple type.</p>","abstract":false,"location":{"filename":"src/tuple.cr","line_number":425,"url":null},"def":{"name":"types","visibility":"Public","body":"Tuple.new(*{{ T }})"}}],"constructors":[{"html_id":"from(array:Array):self-class-method","name":"from","doc":"Creates a tuple from the given array, with elements casted to the given types.\n\n```\nTuple(String, Int64).from([\"world\", 2_i64])       # => {\"world\", 2_i64}\nTuple(String, Int64).from([\"world\", 2_i64]).class # => Tuple(String, Int64)\n```\n\nSee also: `#from`.","summary":"<p>Creates a tuple from the given array, with elements casted to the given types.</p>","abstract":false,"args":[{"name":"array","external_name":"array","restriction":"Array"}],"args_string":"(array : Array) : self","args_html":"(array : <a href=\"Array.html\">Array</a>) : <span class=\"k\">self</span>","location":{"filename":"src/tuple.cr","line_number":121,"url":null},"def":{"name":"from","args":[{"name":"array","external_name":"array","restriction":"Array"}],"return_type":"self","visibility":"Public","body":"{% if true %}\n    Tuple.new(*{{ T }}).from(array)\n    {% end %}"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":166,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"if node.is_a?(YAML::Nodes::Sequence)\nelse\n  node.raise(\"Expected sequence, not #{node.kind}\")\nend\nif node.nodes.size != ({{ T.size }})\n  node.raise(\"Expected #{{{ T.size }}} elements, not #{node.nodes.size}\")\nend\n{% if true %}\n    Tuple.new(\n      {% for i in 0...T.size %}\n        (self[{{ i }}].new(ctx, node.nodes[{{ i }}])),\n      {% end %}\n    )\n {% end %}\n"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":203,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"{% if true %}\n    pull.read_begin_array\n    value = Tuple.new(\n      {% for i in 0...T.size %}\n        (self[{{ i }}].new(pull)),\n      {% end %}\n    )\n    pull.read_end_array\n    value\n {% end %}"}},{"html_id":"new(*args:*T)-class-method","name":"new","doc":"Creates a tuple that will contain the given values.\n\nThis method is useful in macros and generic code because with it you can\ncreate empty tuples, something that you can't do with a tuple literal.\n\n```\nTuple.new(1, \"hello\", 'x') #=> {1, \"hello\", 'x'}\nTuple.new                  #=> {}\n\n{}                         # syntax error\n```","summary":"<p>Creates a tuple that will contain the given values.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":"*T"}],"args_string":"(*args : *T)","args_html":"(*args : <span class=\"o\">*</span><span class=\"t\">T</span>)","location":{"filename":"src/tuple.cr","line_number":91,"url":null},"def":{"name":"new","args":[{"name":"args","external_name":"args","restriction":"*T"}],"splat_index":0,"visibility":"Public","body":"{% if @type.name(generic_args: false) == \"Tuple\" %}\n      # deduced type vars\n      args\n    {% else %}{% if @type.name(generic_args: false) == \"Tuple()\" %}\n      # special case: empty tuple\n      args\n    {% else %}\n      # explicitly provided type vars\n      {% if true %}\n        {\n          {% for i in 0...@type.size %}\n            args[{{ i }}].as(typeof(begin\n              x = uninitialized self\n              x[{{ i }}]\n            end)),\n          {% end %}\n        }\n      {% end %}\n    {% end %}{% end %}"}}],"instance_methods":[{"html_id":"+(other:Tuple)-instance-method","name":"+","doc":"Returns a tuple that contains `self`'s elements followed by *other*'s elements.\n\n```\nt1 = {1, 2}\nt2 = {\"foo\", \"bar\"}\nt3 = t1 + t2\nt3         # => {1, 2, \"foo\", \"bar\"}\ntypeof(t3) # => Tuple(Int32, Int32, String, String)\n```","summary":"<p>Returns a tuple that contains <code>self</code>'s elements followed by <em>other</em>'s elements.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Tuple"}],"args_string":"(other : Tuple)","args_html":"(other : <a href=\"Tuple.html\">Tuple</a>)","location":{"filename":"src/tuple.cr","line_number":393,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Tuple"}],"visibility":"Public","body":"plus_implementation(other)"}},{"html_id":"<=>(other:self)-instance-method","name":"<=>","doc":"The comparison operator.\n\nEach object in each tuple is compared using the `<=>` operator.\n\nTuples are compared in an \"element-wise\" manner; the first element of this tuple is\ncompared with the first one of *other* using the `<=>` operator, then each of the second elements,\netc. As soon as the result of any such comparison is non-zero\n(i.e. the two corresponding elements are not equal), that result is returned for the whole tuple comparison.\n\nIf all the elements are equal, then the result is based on a comparison of the tuple sizes.\nThus, two tuples are \"equal\" according to `<=>` if, and only if, they have the same size\nand the value of each element is equal to the value of the corresponding element in the other tuple.\n\n```\n{\"a\", \"a\", \"c\"} <=> {\"a\", \"b\", \"c\"} # => -1\n{1, 2, 3, 4, 5, 6} <=> {1, 2}       # => 1\n{1, 2} <=> {1, 2.0}                 # => 0\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/tuple.cr","line_number":347,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"{% for i in 0...T.size %}\n      cmp = self[{{ i }}] <=> other[{{ i }}]\n      return cmp unless cmp == 0\n    {% end %}\n0\n"}},{"html_id":"<=>(other:Tuple)-instance-method","name":"<=>","doc":"The comparison operator.\n\nEach object in each tuple is compared using the `<=>` operator.\n\nTuples are compared in an \"element-wise\" manner; the first element of this tuple is\ncompared with the first one of *other* using the `<=>` operator, then each of the second elements,\netc. As soon as the result of any such comparison is non-zero\n(i.e. the two corresponding elements are not equal), that result is returned for the whole tuple comparison.\n\nIf all the elements are equal, then the result is based on a comparison of the tuple sizes.\nThus, two tuples are \"equal\" according to `<=>` if, and only if, they have the same size\nand the value of each element is equal to the value of the corresponding element in the other tuple.\n\n```\n{\"a\", \"a\", \"c\"} <=> {\"a\", \"b\", \"c\"} # => -1\n{1, 2, 3, 4, 5, 6} <=> {1, 2}       # => 1\n{1, 2} <=> {1, 2.0}                 # => 0\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Tuple"}],"args_string":"(other : Tuple)","args_html":"(other : <a href=\"Tuple.html\">Tuple</a>)","location":{"filename":"src/tuple.cr","line_number":356,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"Tuple"}],"visibility":"Public","body":"min_size = Math.min(size, other.size)\nmin_size.times do |i|\n  cmp = self[i] <=> other[i]\n  if cmp == 0\n  else\n    return cmp\n  end\nend\nsize <=> other.size\n"}},{"html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this tuple has the same size as the other tuple\nand their elements are equal to each other when compared with `==`.\n\n```\nt1 = {1, \"hello\"}\nt2 = {1.0, \"hello\"}\nt3 = {2, \"hello\"}\n\nt1 == t2 # => true\nt1 == t3 # => false\n```","summary":"<p>Returns <code>true</code> if this tuple has the same size as the other tuple and their elements are equal to each other when compared with <code><a href=\"Tuple.html#%3D%3D%28other%3Aself%29-instance-method\">#==</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/tuple.cr","line_number":275,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"{% for i in 0...T.size %}\n      return false unless self[{{ i }}] == other[{{ i }}]\n    {% end %}\ntrue\n"}},{"html_id":"==(other:Tuple)-instance-method","name":"==","doc":"Returns `true` if this tuple has the same size as the other tuple\nand their elements are equal to each other when compared with `==`.\n\n```\nt1 = {1, \"hello\"}\nt2 = {1.0, \"hello\"}\nt3 = {2, \"hello\"}\n\nt1 == t2 # => true\nt1 == t3 # => false\n```","summary":"<p>Returns <code>true</code> if this tuple has the same size as the other tuple and their elements are equal to each other when compared with <code><a href=\"Tuple.html#%3D%3D%28other%3Aself%29-instance-method\">#==</a></code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Tuple"}],"args_string":"(other : Tuple)","args_html":"(other : <a href=\"Tuple.html\">Tuple</a>)","location":{"filename":"src/tuple.cr","line_number":283,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Tuple"}],"visibility":"Public","body":"if size == other.size\nelse\n  return false\nend\nsize.times do |i|\n  if self[i] == other[i]\n  else\n    return false\n  end\nend\ntrue\n"}},{"html_id":"==(other)-instance-method","name":"==","doc":"Returns `false`.","summary":"<p>Returns <code>false</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/tuple.cr","line_number":292,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"false"}},{"html_id":"===(other:self)-instance-method","name":"===","doc":"Returns `true` if case equality holds for the elements in `self` and *other*.\n\n```\n{1, 2} === {1, 2} # => true\n{1, 2} === {1, 3} # => false\n```\n\nSee also: `Object#===`.","summary":"<p>Returns <code>true</code> if case equality holds for the elements in <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","location":{"filename":"src/tuple.cr","line_number":304,"url":null},"def":{"name":"===","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"{% for i in 0...T.size %}\n      return false unless self[{{ i }}] === other[{{ i }}]\n    {% end %}\ntrue\n"}},{"html_id":"===(other:Tuple)-instance-method","name":"===","doc":"Returns `true` if `self` and *other* have the same size and case equality holds\nfor the elements in `self` and *other*.\n\n```\n{1, 2} === {1, 2, 3}             # => false\n{/o+/, \"bar\"} === {\"foo\", \"bar\"} # => true\n```\n\nSee also: `Object#===`.","summary":"<p>Returns <code>true</code> if <code>self</code> and <em>other</em> have the same size and case equality holds for the elements in <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Tuple"}],"args_string":"(other : Tuple)","args_html":"(other : <a href=\"Tuple.html\">Tuple</a>)","location":{"filename":"src/tuple.cr","line_number":320,"url":null},"def":{"name":"===","args":[{"name":"other","external_name":"other","restriction":"Tuple"}],"visibility":"Public","body":"if size == other.size\nelse\n  return false\nend\nsize.times do |i|\n  if self[i] === other[i]\n  else\n    return false\n  end\nend\ntrue\n"}},{"html_id":"[](index:Int)-instance-method","name":"[]","doc":"Returns the element at the given *index*. Read the type docs to understand\nthe difference between indexing with a number literal or a variable.\n\n```\ntuple = {1, \"hello\", 'x'}\ntuple[0] # => 1 (Int32)\ntuple[3] # compile error: index out of bounds for tuple {Int32, String, Char}\n\ni = 0\ntuple[i] # => 1 (Int32 | String | Char)\n\ni = 3\ntuple[i] # raises IndexError\n```","summary":"<p>Returns the element at the given <em>index</em>.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","args_html":"(index : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/tuple.cr","line_number":174,"url":null},"def":{"name":"[]","args":[{"name":"index","external_name":"index","restriction":"Int"}],"visibility":"Public","body":"at(index)"}},{"html_id":"[](range:Range)-instance-method","name":"[]","doc":"Returns all elements that are within the given *range*. *range* must be a\nrange literal whose value is known at compile-time.\n\nNegative indices count backward from the end of the array (-1 is the last\nelement). Additionally, an empty array is returned when the starting index\nfor an element range is at the end of the array.\n\nRaises a compile-time error if `range.begin` is out of range.\n\n```\ntuple = {1, \"hello\", 'x'}\ntuple[0..1] # => {1, \"hello\"}\ntuple[-2..] # => {\"hello\", 'x'}\ntuple[...1] # => {1}\ntuple[4..]  # Error: begin index out of bounds for Tuple(Int32, Char, Array(Int32), String) (5 not in -4..4)\n\ni = 0\ntuple[i..2] # Error: Tuple#[](Range) can only be called with range literals known at compile-time\n\ni = 0..2\ntuple[i] # Error: Tuple#[](Range) can only be called with range literals known at compile-time\n```","summary":"<p>Returns all elements that are within the given <em>range</em>.</p>","abstract":false,"args":[{"name":"range","external_name":"range","restriction":"Range"}],"args_string":"(range : Range)","args_html":"(range : <a href=\"Range.html\">Range</a>)","location":{"filename":"src/tuple.cr","line_number":211,"url":null},"def":{"name":"[]","args":[{"name":"range","external_name":"range","restriction":"Range"}],"visibility":"Public","body":"{% raise(\"Tuple#[](Range) can only be called with range literals known at compile-time\") %}"}},{"html_id":"[]?(index:Int)-instance-method","name":"[]?","doc":"Returns the element at the given *index* or `nil` if out of bounds.\n\n```\ntuple = {1, \"hello\", 'x'}\ntuple[0]? # => 1\ntuple[3]? # => nil\n```","summary":"<p>Returns the element at the given <em>index</em> or <code>nil</code> if out of bounds.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","args_html":"(index : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/tuple.cr","line_number":185,"url":null},"def":{"name":"[]?","args":[{"name":"index","external_name":"index","restriction":"Int"}],"visibility":"Public","body":"at(index) do\n  nil\nend"}},{"html_id":"at(index:Int)-instance-method","name":"at","doc":"Returns the element at the given *index* or raises IndexError if out of bounds.\n\n```\ntuple = {1, \"hello\", 'x'}\ntuple.at(0) # => 1\ntuple.at(3) # raises IndexError\n```","summary":"<p>Returns the element at the given <em>index</em> or raises IndexError if out of bounds.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","args_html":"(index : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/tuple.cr","line_number":222,"url":null},"def":{"name":"at","args":[{"name":"index","external_name":"index","restriction":"Int"}],"visibility":"Public","body":"at(index) do\n  raise(IndexError.new)\nend"}},{"html_id":"at(index:Int,&)-instance-method","name":"at","doc":"Returns the element at the given *index* or the value returned by the block if\nout of bounds.\n\n```\ntuple = {1, \"hello\", 'x'}\ntuple.at(0) { 10 } # => 1\ntuple.at(3) { 10 } # => 10\n```","summary":"<p>Returns the element at the given <em>index</em> or the value returned by the block if out of bounds.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int, &)","args_html":"(index : <a href=\"Int.html\">Int</a>, &)","location":{"filename":"src/tuple.cr","line_number":234,"url":null},"def":{"name":"at","args":[{"name":"index","external_name":"index","restriction":"Int"}],"yields":0,"visibility":"Public","body":"if index < 0\n  index = index + size\nend\n{% for i in 0...T.size %}\n      return self[{{ i }}] if {{ i }} == index\n    {% end %}\nyield\n"}},{"html_id":"clone-instance-method","name":"clone","doc":"Returns a tuple containing cloned elements of this tuple using the `clone` method.","summary":"<p>Returns a tuple containing cloned elements of this tuple using the <code><a href=\"Tuple.html#clone-instance-method\">#clone</a></code> method.</p>","abstract":false,"location":{"filename":"src/tuple.cr","line_number":374,"url":null},"def":{"name":"clone","visibility":"Public","body":"{% if true %}\n      Tuple.new(\n        {% for i in 0...T.size %}\n          self[{{ i }}].clone,\n        {% end %}\n      )\n    {% end %}"}},{"html_id":"each(&:Union(*T)->):Nil-instance-method","name":"each","doc":"Yields each of the elements in this tuple.\n\n```\ntuple = {1, \"hello\", 'x'}\ntuple.each do |value|\n  puts value\nend\n```\n\nOutput:\n\n```text\n1\n\"hello\"\n'x'\n```","summary":"<p>Yields each of the elements in this tuple.</p>","abstract":false,"location":{"filename":"src/tuple.cr","line_number":258,"url":null},"def":{"name":"each","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Union(*T) ->)"},"return_type":"Nil","visibility":"Public","body":"{% for i in 0...T.size %}\n      yield self[{{ i }}]\n    {% end %}"}},{"html_id":"first-instance-method","name":"first","doc":"Returns the first element of this tuple. Doesn't compile\nif the tuple is empty.\n\n```\ntuple = {1, 2.5}\ntuple.first # => 1\n```","summary":"<p>Returns the first element of this tuple.</p>","abstract":false,"location":{"filename":"src/tuple.cr","line_number":568,"url":null},"def":{"name":"first","visibility":"Public","body":"self[0]"}},{"html_id":"first?-instance-method","name":"first?","doc":"Returns the first element of this tuple, or `nil` if this\nis the empty tuple.\n\n```\ntuple = {1, 2.5}\ntuple.first? # => 1\n\nempty = Tuple.new\nempty.first? # => nil\n```","summary":"<p>Returns the first element of this tuple, or <code>nil</code> if this is the empty tuple.</p>","abstract":false,"location":{"filename":"src/tuple.cr","line_number":582,"url":null},"def":{"name":"first?","visibility":"Public","body":"{% if T.size == 0 %}\n      nil\n    {% else %}\n      self[0]\n    {% end %}"}},{"html_id":"from(array:Array)-instance-method","name":"from","doc":"Expects to be called on a tuple of types, creates a tuple from the given array,\nwith types casted appropriately.\n\nThis allows you to easily pass an array as individual arguments to a method.\n\n```\nrequire \"json\"\n\ndef speak_about(thing : String, n : Int64)\n  \"I see #{n} #{thing}s\"\nend\n\ndata = JSON.parse(%([\"world\", 2])).as_a.map(&.raw)\nspeak_about(*{String, Int64}.from(data)) # => \"I see 2 worlds\"\n```","summary":"<p>Expects to be called on a tuple of types, creates a tuple from the given array, with types casted appropriately.</p>","abstract":false,"args":[{"name":"array","external_name":"array","restriction":"Array"}],"args_string":"(array : Array)","args_html":"(array : <a href=\"Array.html\">Array</a>)","location":{"filename":"src/tuple.cr","line_number":142,"url":null},"def":{"name":"from","args":[{"name":"array","external_name":"array","restriction":"Array"}],"visibility":"Public","body":"if size != array.size\n  raise(ArgumentError.new(\"Expected array of size #{size} but one of size #{array.size} was given.\"))\nend\n{% if true %}\n    Tuple.new(\n    {% for i in 0...@type.size %}\n      self[{{ i }}].cast(array[{{ i }}]),\n    {% end %}\n    )\n    {% end %}\n"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/tuple.cr","line_number":366,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"{% for i in 0...T.size %}\n      hasher = self[{{ i }}].hash(hasher)\n    {% end %}\nhasher\n"}},{"html_id":"inspect:String-instance-method","name":"inspect","doc":"Same as `to_s`.","summary":"<p>Same as <code><a href=\"Tuple.html#to_s%28io%3AIO%29%3ANil-instance-method\">#to_s</a></code>.</p>","abstract":false,"location":{"filename":"src/tuple.cr","line_number":430,"url":null},"def":{"name":"inspect","return_type":"String","visibility":"Public","body":"to_s"}},{"html_id":"last-instance-method","name":"last","doc":"Returns the last element of this tuple. Doesn't compile\nif the tuple is empty.\n\n```\ntuple = {1, 2.5}\ntuple.last # => 2.5\n```","summary":"<p>Returns the last element of this tuple.</p>","abstract":false,"location":{"filename":"src/tuple.cr","line_number":597,"url":null},"def":{"name":"last","visibility":"Public","body":"{% if true %}\n      self[{{ T.size - 1 }}]\n    {% end %}"}},{"html_id":"last?-instance-method","name":"last?","doc":"Returns the last element of this tuple, or `nil` if this\nis the empty tuple.\n\n```\ntuple = {1, 2.5}\ntuple.last? # => 2.5\n\nempty = Tuple.new\nempty.last? # => nil\n```","summary":"<p>Returns the last element of this tuple, or <code>nil</code> if this is the empty tuple.</p>","abstract":false,"location":{"filename":"src/tuple.cr","line_number":613,"url":null},"def":{"name":"last?","visibility":"Public","body":"{% if T.size == 0 %}\n      nil\n    {% else %}\n      self[{{ T.size - 1 }}]\n    {% end %}"}},{"html_id":"map(&:Union(*T)->)-instance-method","name":"map","doc":"Returns a new tuple where elements are mapped by the given block.\n\n```\ntuple = {1, 2.5, \"a\"}\ntuple.map &.to_s # => {\"1\", \"2.5\", \"a\"}\n```","summary":"<p>Returns a new tuple where elements are mapped by the given block.</p>","abstract":false,"location":{"filename":"src/tuple.cr","line_number":465,"url":null},"def":{"name":"map","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Union(*T) ->)"},"visibility":"Public","body":"{% if true %}\n      Tuple.new(\n        {% for i in 0...T.size %}\n          (yield self[{{ i }}]),\n        {% end %}\n      )\n   {% end %}"}},{"html_id":"map_with_index(offset=0,&)-instance-method","name":"map_with_index","doc":"Like `map`, but the block gets passed both the element and its index.\n\n```\ntuple = {1, 2.5, \"a\"}\ntuple.map_with_index { |e, i| \"tuple[#{i}]: #{e}\" } # => {\"tuple[0]: 1\", \"tuple[1]: 2.5\", \"tuple[2]: a\"}\n```\n\nAccepts an optional *offset* parameter, which tells it to start counting\nfrom there.","summary":"<p>Like <code><a href=\"Tuple.html#map%28%26%3AUnion%28%2AT%29-%3E%29-instance-method\">#map</a></code>, but the block gets passed both the element and its index.</p>","abstract":false,"args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"args_string":"(offset = 0, &)","args_html":"(offset = <span class=\"n\">0</span>, &)","location":{"filename":"src/tuple.cr","line_number":484,"url":null},"def":{"name":"map_with_index","args":[{"name":"offset","default_value":"0","external_name":"offset","restriction":""}],"yields":0,"visibility":"Public","body":"{% if true %}\n      Tuple.new(\n        {% for i in 0...T.size %}\n          (yield self[{{ i }}], offset + {{ i }}),\n        {% end %}\n      )\n    {% end %}"}},{"html_id":"pretty_print(pp):Nil-instance-method","name":"pretty_print","abstract":false,"args":[{"name":"pp","external_name":"pp","restriction":""}],"args_string":"(pp) : Nil","args_html":"(pp) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/tuple.cr","line_number":455,"url":null},"def":{"name":"pretty_print","args":[{"name":"pp","external_name":"pp","restriction":""}],"return_type":"Nil","visibility":"Public","body":"pp.list(\"{\", self, \"}\")"}},{"html_id":"reduce(memo,&)-instance-method","name":"reduce","doc":"Just like the other variant, but you can set the initial value of the accumulator.\n\n```\n[1, 2, 3, 4, 5].reduce(10) { |acc, i| acc + i }             # => 25\n[1, 2, 3].reduce([] of Int32) { |memo, i| memo.unshift(i) } # => [3, 2, 1]\n```","summary":"<p>Just like the other variant, but you can set the initial value of the accumulator.</p>","abstract":false,"args":[{"name":"memo","external_name":"memo","restriction":""}],"args_string":"(memo, &)","args_html":"(memo, &)","location":{"filename":"src/tuple.cr","line_number":547,"url":null},"def":{"name":"reduce","args":[{"name":"memo","external_name":"memo","restriction":""}],"yields":0,"visibility":"Public","body":"{% for i in 0...T.size %}\n      memo = yield memo, self[{{ i }}]\n    {% end %}\nmemo\n"}},{"html_id":"reduce(&)-instance-method","name":"reduce","doc":"Combines all elements in the collection by applying a binary operation, specified by a block, so as\nto reduce them to a single value.\n\nFor each element in the collection the block is passed an accumulator value (*memo*) and the element. The\nresult becomes the new value for *memo*. At the end of the iteration, the final value of *memo* is\nthe return value for the method. The initial value for the accumulator is the first element in the collection.\nIf the collection has only one element, that element is returned.\n\nRaises `Enumerable::EmptyError` if the collection is empty.\n\n```\n[1, 2, 3, 4, 5].reduce { |acc, i| acc + i } # => 15\n[1].reduce { |acc, i| acc + i }             # => 1\n([] of Int32).reduce { |acc, i| acc + i }   # raises Enumerable::EmptyError\n```\n\nThe block is not required to return a `T`, in which case the accumulator's\ntype includes whatever the block returns.\n\n```\n# `acc` is an `Int32 | String`\n[1, 2, 3, 4, 5].reduce { |acc, i| \"#{acc}-#{i}\" } # => \"1-2-3-4-5\"\n[1].reduce { |acc, i| \"#{acc}-#{i}\" }             # => 1\n```","summary":"<p>Combines all elements in the collection by applying a binary operation, specified by a block, so as to reduce them to a single value.</p>","abstract":false,"location":{"filename":"src/tuple.cr","line_number":534,"url":null},"def":{"name":"reduce","yields":0,"visibility":"Public","body":"{% if T.empty? %}\n      raise Enumerable::EmptyError.new\n    {% else %}\n      memo = self[0]\n      {% for i in 1...T.size %}\n        memo = yield memo, self[{{ i }}]\n      {% end %}\n      memo\n    {% end %}"}},{"html_id":"reduce?(&)-instance-method","name":"reduce?","doc":"Similar to `reduce`, but instead of raising when the input is empty,\nreturn `nil`\n\n```\n([] of Int32).reduce? { |acc, i| acc + i } # => nil\n```","summary":"<p>Similar to <code><a href=\"Tuple.html#reduce%28%26%29-instance-method\">#reduce</a></code>, but instead of raising when the input is empty, return <code>nil</code></p>","abstract":false,"location":{"filename":"src/tuple.cr","line_number":555,"url":null},"def":{"name":"reduce?","yields":0,"visibility":"Public","body":"{% if T.empty? %}{% else %}\n      reduce { |memo, elem| yield memo, elem }\n    {% end %}"}},{"html_id":"reverse-instance-method","name":"reverse","doc":"Returns a new tuple where the elements are in reverse order.\n\n```\ntuple = {1, 2.5, \"a\"}\ntuple.reverse # => {\"a\", 2.5, 1}\n```","summary":"<p>Returns a new tuple where the elements are in reverse order.</p>","abstract":false,"location":{"filename":"src/tuple.cr","line_number":500,"url":null},"def":{"name":"reverse","visibility":"Public","body":"{% if true %}\n      Tuple.new(\n        {% for i in 1..T.size %}\n          self[{{ T.size - i }}],\n        {% end %}\n      )\n    {% end %}"}},{"html_id":"reverse_each(&:Union(*T)->)-instance-method","name":"reverse_each","doc":"Yields each of the elements in this tuple in reverse order.\n\n```\ntuple = {1, \"hello\", 'x'}\ntuple.reverse_each do |value|\n  puts value\nend\n```\n\nOutput:\n\n```text\n'x'\n\"hello\"\n1\n```","summary":"<p>Yields each of the elements in this tuple in reverse order.</p>","abstract":false,"location":{"filename":"src/tuple.cr","line_number":526,"url":null},"def":{"name":"reverse_each","yields":1,"block_arg":{"name":"","external_name":"","restriction":"(Union(*T) ->)"},"visibility":"Public","body":"{% for i in 1..T.size %}\n      yield self[{{ T.size - i }}]\n    {% end %}\nnil\n"}},{"html_id":"size-instance-method","name":"size","doc":"Returns the number of elements in this tuple.\n\n```\n{'a', 'b'}.size # => 2\n```","summary":"<p>Returns the number of elements in this tuple.</p>","abstract":false,"location":{"filename":"src/tuple.cr","line_number":415,"url":null},"def":{"name":"size","visibility":"Public","body":"{{ T.size }}"}},{"html_id":"to_a-instance-method","name":"to_a","doc":"Returns an `Array` with all the elements in the collection.\n\n```\n{1, 2, 3}.to_a # => [1, 2, 3]\n```","summary":"<p>Returns an <code><a href=\"Array.html\">Array</a></code> with all the elements in the collection.</p>","abstract":false,"location":{"filename":"src/tuple.cr","line_number":434,"url":null},"def":{"name":"to_a","visibility":"Public","body":"Array(Union(*T)).build(size) do |buffer|\n  {% for i in 0...T.size %}\n        buffer[{{ i }}] = self[{{ i }}]\n      {% end %}\n  size\nend"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/json/to_json.cr","line_number":135,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.array do\n  {% for i in 0...T.size %}\n        self[{{ i }}].to_json(json)\n      {% end %}\nend"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a string representation of this tuple to the given `IO`.\n\n```\ntuple = {1, \"hello\"}\ntuple.to_s # => \"{1, \\\"hello\\\"}\"\n```","summary":"<p>Appends a string representation of this tuple to the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/tuple.cr","line_number":449,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << '{'\njoin(io, \", \", &.inspect(io))\nio << '}'\n"}},{"html_id":"to_yaml(yaml:YAML::Nodes::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder) : Nil","args_html":"(yaml : <a href=\"YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml/to_yaml.cr","line_number":43,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"return_type":"Nil","visibility":"Public","body":"yaml.sequence do\n  each(&.to_yaml(yaml))\nend"}},{"html_id":"unsafe_fetch(index:Int)-instance-method","name":"unsafe_fetch","doc":"Returns the element at the given *index*, without doing any bounds check.\n\n`Indexable` makes sure to invoke this method with *index* in `0...size`,\nso converting negative indices to positive ones is not needed here.\n\nClients never invoke this method directly. Instead, they access\nelements with `#[](index)` and `#[]?(index)`.\n\nThis method should only be directly invoked if you are absolutely\nsure the index is in bounds, to avoid a bounds check for a small boost\nof performance.","summary":"<p>Returns the element at the given <em>index</em>, without doing any bounds check.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int)","args_html":"(index : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/tuple.cr","line_number":156,"url":null},"def":{"name":"unsafe_fetch","args":[{"name":"index","external_name":"index","restriction":"Int"}],"visibility":"Public","body":"self[index]"}}]},{"html_id":"Crystal/TypeCastError","path":"TypeCastError.html","kind":"class","full_name":"TypeCastError","name":"TypeCastError","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/exception.cr","line_number":100,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"Raised when the type cast failed.\n\n```\n[1, \"hi\"][1].as(Int32) # raises TypeCastError (cast to Int32 failed)\n```","summary":"<p>Raised when the type cast failed.</p>","constructors":[{"html_id":"new(message=\"TypeCasterror\")-class-method","name":"new","abstract":false,"args":[{"name":"message","default_value":"\"Type Cast error\"","external_name":"message","restriction":""}],"args_string":"(message = \"Type Cast error\")","args_html":"(message = <span class=\"s\">&quot;Type Cast error&quot;</span>)","location":{"filename":"src/exception.cr","line_number":101,"url":null},"def":{"name":"new","args":[{"name":"message","default_value":"\"Type Cast error\"","external_name":"message","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(message)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}]},{"html_id":"Crystal/UDPSocket","path":"UDPSocket.html","kind":"class","full_name":"UDPSocket","name":"UDPSocket","abstract":false,"superclass":{"html_id":"Crystal/IPSocket","kind":"class","full_name":"IPSocket","name":"IPSocket"},"ancestors":[{"html_id":"Crystal/IPSocket","kind":"class","full_name":"IPSocket","name":"IPSocket"},{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},{"html_id":"Crystal/Crystal/System/Socket","kind":"module","full_name":"Crystal::System::Socket","name":"Socket"},{"html_id":"Crystal/IO/Evented","kind":"module","full_name":"IO::Evented","name":"Evented"},{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/udp_socket.cr","line_number":53,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"A User Datagram Protocol (UDP) socket.\n\nUDP runs on top of the Internet Protocol (IP) and was developed for applications that do\nnot require reliability, acknowledgement, or flow control features at the transport layer.\nThis simple protocol provides transport layer addressing in the form of UDP ports and an\noptional checksum capability.\n\nUDP is a very simple protocol. Messages, so called datagrams, are sent to other hosts on\nan IP network without the need to set up special transmission channels or data paths\nbeforehand. The UDP socket only needs to be opened for communication. It listens for\nincoming messages and sends outgoing messages on request.\n\nThis implementation supports both IPv4 and IPv6 addresses. For IPv4 addresses you must use\n`Socket::Family::INET` family (default) or `Socket::Family::INET6` for IPv6 # addresses.\n\nUsage example:\n\n```\nrequire \"socket\"\n\n# Create server\nserver = UDPSocket.new\nserver.bind \"localhost\", 1234\n\n# Create client and connect to server\nclient = UDPSocket.new\nclient.connect \"localhost\", 1234\n\n# Send a text message to server\nclient.send \"message\"\n\n# Receive text message from client\nmessage, client_addr = server.receive\n\n# Close client and server\nclient.close\nserver.close\n```\n\nThe `send` methods may sporadically fail with `Socket::ConnectError` when sending datagrams\nto a non-listening server.\nWrap with an exception handler to prevent raising. Example:\n\n```\nbegin\n  client.send(message, @destination)\nrescue ex : Socket::ConnectError\n  p ex.inspect\nend\n```","summary":"<p>A User Datagram Protocol (UDP) socket.</p>","constructors":[{"html_id":"new(family:Family=Family::INET)-class-method","name":"new","abstract":false,"args":[{"name":"family","default_value":"Family::INET","external_name":"family","restriction":"Family"}],"args_string":"(family : Family = Family::INET)","args_html":"(family : <a href=\"Socket/Family.html\">Family</a> = <span class=\"t\">Family</span><span class=\"t\">::</span><span class=\"t\">INET</span>)","location":{"filename":"src/socket/udp_socket.cr","line_number":54,"url":null},"def":{"name":"new","args":[{"name":"family","default_value":"Family::INET","external_name":"family","restriction":"Family"}],"visibility":"Public","body":"_ = allocate\n_.initialize(family)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"join_group(address:IPAddress)-instance-method","name":"join_group","doc":"A host must become a member of a multicast group before it can receive\ndatagrams sent to the group.\nRaises `Socket::Error` if an incompatible address is provided.","summary":"<p>A host must become a member of a multicast group before it can receive datagrams sent to the group.</p>","abstract":false,"args":[{"name":"address","external_name":"address","restriction":"IPAddress"}],"args_string":"(address : IPAddress)","args_html":"(address : <a href=\"Socket/IPAddress.html\">IPAddress</a>)","location":{"filename":"src/socket/udp_socket.cr","line_number":189,"url":null},"def":{"name":"join_group","args":[{"name":"address","external_name":"address","restriction":"IPAddress"}],"visibility":"Public","body":"case @family\nwhen Family::INET\n  group_modify(address, LibC::IP_ADD_MEMBERSHIP)\nwhen Family::INET6\n  group_modify(address, LibC::IPV6_JOIN_GROUP)\nelse\n  raise(Socket::Error.new(\"Unsupported IP address family: #{@family}\"))\nend"}},{"html_id":"leave_group(address:IPAddress)-instance-method","name":"leave_group","doc":"Drops membership to the specified group. Memberships are automatically\ndropped when the socket is closed or the process exits.\nRaises `Socket::Error` if an incompatible address is provided.","summary":"<p>Drops membership to the specified group.</p>","abstract":false,"args":[{"name":"address","external_name":"address","restriction":"IPAddress"}],"args_string":"(address : IPAddress)","args_html":"(address : <a href=\"Socket/IPAddress.html\">IPAddress</a>)","location":{"filename":"src/socket/udp_socket.cr","line_number":203,"url":null},"def":{"name":"leave_group","args":[{"name":"address","external_name":"address","restriction":"IPAddress"}],"visibility":"Public","body":"case @family\nwhen Family::INET\n  group_modify(address, LibC::IP_DROP_MEMBERSHIP)\nwhen Family::INET6\n  group_modify(address, LibC::IPV6_LEAVE_GROUP)\nelse\n  raise(Socket::Error.new(\"Unsupported IP address family: #{@family}\"))\nend"}},{"html_id":"multicast_hops:Int32-instance-method","name":"multicast_hops","doc":"Returns the current value of the `hoplimit` field on uni-cast packets.\nDatagrams with a `hoplimit` of `1` are not forwarded beyond the local network.\nMulticast datagrams with a `hoplimit` of `0` will not be transmitted on any\nnetwork, but may be delivered locally if the sending host belongs to the\ndestination group and multicast loopback is enabled.","summary":"<p>Returns the current value of the <code>hoplimit</code> field on uni-cast packets.</p>","abstract":false,"location":{"filename":"src/socket/udp_socket.cr","line_number":125,"url":null},"def":{"name":"multicast_hops","return_type":"Int32","visibility":"Public","body":"case @family\nwhen Family::INET\n  getsockopt(LibC::IP_MULTICAST_TTL, 0, LibC::IPPROTO_IP)\nwhen Family::INET6\n  getsockopt(LibC::IPV6_MULTICAST_HOPS, 0, LibC::IPPROTO_IPV6)\nelse\n  raise(Socket::Error.new(\"Unsupported IP address family: #{@family}\"))\nend"}},{"html_id":"multicast_hops=(val:Int)-instance-method","name":"multicast_hops=","doc":"The multicast hops option controls the `hoplimit` field on uni-cast packets.\nIf `-1` is specified, the kernel will use a default value.\nIf a value of `0` to `255` is specified, the packet will have the specified\nvalue as `hoplimit`. Other values are considered invalid and `Socket::Error` will be raised.\nDatagrams with a `hoplimit` of `1` are not forwarded beyond the local network.\nMulticast datagrams with a `hoplimit` of `0` will not be transmitted on any\nnetwork, but may be delivered locally if the sending host belongs to the\ndestination group and multicast loopback is enabled.","summary":"<p>The multicast hops option controls the <code>hoplimit</code> field on uni-cast packets.</p>","abstract":false,"args":[{"name":"val","external_name":"val","restriction":"Int"}],"args_string":"(val : Int)","args_html":"(val : <a href=\"Int.html\">Int</a>)","location":{"filename":"src/socket/udp_socket.cr","line_number":144,"url":null},"def":{"name":"multicast_hops=","args":[{"name":"val","external_name":"val","restriction":"Int"}],"visibility":"Public","body":"case @family\nwhen Family::INET\n  setsockopt(LibC::IP_MULTICAST_TTL, val, LibC::IPPROTO_IP)\nwhen Family::INET6\n  setsockopt(LibC::IPV6_MULTICAST_HOPS, val, LibC::IPPROTO_IPV6)\nelse\n  raise(Socket::Error.new(\"Unsupported IP address family: #{@family}\"))\nend\nval\n"}},{"html_id":"multicast_interface(address:IPAddress)-instance-method","name":"multicast_interface","doc":"For hosts with multiple interfaces, each multicast transmission is sent\nfrom the primary network interface. This function overrides the default\nIPv4 interface address for subsequent transmissions. Setting the interface\nto `0.0.0.0` will select the default interface.\nRaises `Socket::Error` unless the socket is IPv4 and an IPv4 address is provided.","summary":"<p>For hosts with multiple interfaces, each multicast transmission is sent from the primary network interface.</p>","abstract":false,"args":[{"name":"address","external_name":"address","restriction":"IPAddress"}],"args_string":"(address : IPAddress)","args_html":"(address : <a href=\"Socket/IPAddress.html\">IPAddress</a>)","location":{"filename":"src/socket/udp_socket.cr","line_number":161,"url":null},"def":{"name":"multicast_interface","args":[{"name":"address","external_name":"address","restriction":"IPAddress"}],"visibility":"Public","body":"if @family == Family::INET\n  addr = address.@addr\n  if addr.is_a?(LibC::InAddr)\n    setsockopt(LibC::IP_MULTICAST_IF, addr, LibC::IPPROTO_IP)\n  else\n    raise(Socket::Error.new(\"Expecting an IPv4 interface address. Address provided: #{address.address}\"))\n  end\nelse\n  raise(Socket::Error.new(\"Unsupported IP address family: #{@family}. For use with IPv4 only\"))\nend"}},{"html_id":"multicast_interface(index:UInt32)-instance-method","name":"multicast_interface","doc":"For hosts with multiple interfaces, each multicast transmission is sent\nfrom the primary network interface. This function overrides the default\nIPv6 interface for subsequent transmissions. Setting the interface to\nindex `0` will select the default interface.","summary":"<p>For hosts with multiple interfaces, each multicast transmission is sent from the primary network interface.</p>","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"UInt32"}],"args_string":"(index : UInt32)","args_html":"(index : <a href=\"UInt32.html\">UInt32</a>)","location":{"filename":"src/socket/udp_socket.cr","line_number":178,"url":null},"def":{"name":"multicast_interface","args":[{"name":"index","external_name":"index","restriction":"UInt32"}],"visibility":"Public","body":"if @family == Family::INET6\n  setsockopt(LibC::IPV6_MULTICAST_IF, index, LibC::IPPROTO_IPV6)\nelse\n  raise(Socket::Error.new(\"Unsupported IP address family: #{@family}. For use with IPv6 only\"))\nend"}},{"html_id":"multicast_loopback=(val:Bool)-instance-method","name":"multicast_loopback=","doc":"Sets whether transmitted multicast packets should be copied and sent back\nto the originator, if the host has joined the multicast group.","summary":"<p>Sets whether transmitted multicast packets should be copied and sent back to the originator, if the host has joined the multicast group.</p>","abstract":false,"args":[{"name":"val","external_name":"val","restriction":"Bool"}],"args_string":"(val : Bool)","args_html":"(val : <a href=\"Bool.html\">Bool</a>)","location":{"filename":"src/socket/udp_socket.cr","line_number":109,"url":null},"def":{"name":"multicast_loopback=","args":[{"name":"val","external_name":"val","restriction":"Bool"}],"visibility":"Public","body":"case @family\nwhen Family::INET\n  setsockopt_bool(LibC::IP_MULTICAST_LOOP, val, LibC::IPPROTO_IP)\nwhen Family::INET6\n  setsockopt_bool(LibC::IPV6_MULTICAST_LOOP, val, LibC::IPPROTO_IPV6)\nelse\n  raise(Socket::Error.new(\"Unsupported IP address family: #{@family}\"))\nend"}},{"html_id":"multicast_loopback?:Bool-instance-method","name":"multicast_loopback?","doc":"Reports whether transmitted multicast packets should be copied and sent\nback to the originator.","summary":"<p>Reports whether transmitted multicast packets should be copied and sent back to the originator.</p>","abstract":false,"location":{"filename":"src/socket/udp_socket.cr","line_number":96,"url":null},"def":{"name":"multicast_loopback?","return_type":"Bool","visibility":"Public","body":"case @family\nwhen Family::INET\n  getsockopt_bool(LibC::IP_MULTICAST_LOOP, LibC::IPPROTO_IP)\nwhen Family::INET6\n  getsockopt_bool(LibC::IPV6_MULTICAST_LOOP, LibC::IPPROTO_IPV6)\nelse\n  raise(Socket::Error.new(\"Unsupported IP address family: #{@family}\"))\nend"}},{"html_id":"receive(message:Bytes):Tuple(Int32,IPAddress)-instance-method","name":"receive","doc":"Receives a binary message from the previously bound address.\n\n```\nrequire \"socket\"\n\nserver = UDPSocket.new\nserver.bind \"localhost\", 1234\n\nmessage = Bytes.new(32)\nbytes_read, client_addr = server.receive(message)\n```","summary":"<p>Receives a binary message from the previously bound address.</p>","abstract":false,"args":[{"name":"message","external_name":"message","restriction":"Bytes"}],"args_string":"(message : Bytes) : Tuple(Int32, IPAddress)","args_html":"(message : <a href=\"Bytes.html\">Bytes</a>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"Int32.html\">Int32</a>, <a href=\"Socket/IPAddress.html\">IPAddress</a>)","location":{"filename":"src/socket/udp_socket.cr","line_number":89,"url":null},"def":{"name":"receive","args":[{"name":"message","external_name":"message","restriction":"Bytes"}],"return_type":"::Tuple(Int32, IPAddress)","visibility":"Public","body":"bytes_read, sockaddr, addrlen = system_receive(message)\n{bytes_read, IPAddress.from(sockaddr, addrlen)}\n"}},{"html_id":"receive(max_message_size=512):Tuple(String,IPAddress)-instance-method","name":"receive","doc":"Receives a text message from the previously bound address.\n\n```\nrequire \"socket\"\n\nserver = UDPSocket.new\nserver.bind(\"localhost\", 1234)\n\nmessage, client_addr = server.receive\n```","summary":"<p>Receives a text message from the previously bound address.</p>","abstract":false,"args":[{"name":"max_message_size","default_value":"512","external_name":"max_message_size","restriction":""}],"args_string":"(max_message_size = 512) : Tuple(String, IPAddress)","args_html":"(max_message_size = <span class=\"n\">512</span>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"String.html\">String</a>, <a href=\"Socket/IPAddress.html\">IPAddress</a>)","location":{"filename":"src/socket/udp_socket.cr","line_number":68,"url":null},"def":{"name":"receive","args":[{"name":"max_message_size","default_value":"512","external_name":"max_message_size","restriction":""}],"return_type":"::Tuple(String, IPAddress)","visibility":"Public","body":"address = nil\nmessage = String.new(max_message_size) do |buffer|\n  bytes_read, sockaddr, addrlen = system_receive(Slice.new(buffer, max_message_size))\n  address = IPAddress.from(sockaddr, addrlen)\n  {bytes_read, 0}\nend\n{message, address.not_nil!}\n"}}]},{"html_id":"Crystal/UInt128","path":"UInt128.html","kind":"struct","full_name":"UInt128","name":"UInt128","abstract":false,"superclass":{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/number.cr","line_number":98,"url":null},{"filename":"src/int.cr","line_number":1315,"url":null},{"filename":"src/primitives.cr","line_number":280,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"MAX","name":"MAX","value":"~MIN"},{"id":"MIN","name":"MIN","value":"new(0)","doc":"TODO: eventually update to literals once UInt128 bit support is finished","summary":"<p><span class=\"flag orange\">TODO</span>  eventually update to literals once UInt128 bit support is finished</p>"}],"constructors":[{"html_id":"new(value:String,base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):self-class-method","name":"new","doc":"Returns an `UInt128` by invoking `to_u128` on *value*.\nSee `String#to_i` for more details.\n\n```\nUInt128.new \"20\"                        # => 20\nUInt128.new \"  20  \", whitespace: false # => Unhandled exception: Invalid UInt128:   20 (ArgumentError)\n```","summary":"<p>Returns an <code><a href=\"UInt128.html\">UInt128</a></code> by invoking <code><a href=\"UInt128.html#to_u128%3AUInt128-instance-method\">#to_u128</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(value : String, base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : self","args_html":"(value : <a href=\"String.html\">String</a>, base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1327,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"self","visibility":"Public","body":"value.to_u128(base: base, whitespace: whitespace, underscore: underscore, prefix: prefix, strict: strict, leading_zero_is_octal: leading_zero_is_octal)"}},{"html_id":"new(value):self-class-method","name":"new","doc":"Returns an `UInt128` by invoking `to_u128` on *value*.","summary":"<p>Returns an <code><a href=\"UInt128.html\">UInt128</a></code> by invoking <code><a href=\"UInt128.html#to_u128%3AUInt128-instance-method\">#to_u128</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1332,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_u128"}},{"html_id":"new!(value):self-class-method","name":"new!","doc":"Returns an `UInt128` by invoking `to_u128!` on *value*.","summary":"<p>Returns an <code><a href=\"UInt128.html\">UInt128</a></code> by invoking <code><a href=\"UInt128.html#to_u128%21%3AUInt128-instance-method\">#to_u128!</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1337,"url":null},"def":{"name":"new!","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_u128!"}}],"instance_methods":[{"html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&--instance-method","name":"&-","abstract":false,"location":{"filename":"src/int.cr","line_number":1345,"url":null},"def":{"name":"&-","visibility":"Public","body":"(UInt128.new(0)) &- self"}},{"html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"/(other:Int8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Float64","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1341,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Float64","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1341,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Float64","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1341,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Float64","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1341,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Float64","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1341,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Float64","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1341,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Float64","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1341,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Float64","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1341,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Float64","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1341,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Float64","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1341,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Float32):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/int.cr","line_number":1342,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:Float64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1343,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:BigInt):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigFloat","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":99,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigFloat):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigFloat","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":100,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":101,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":102,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"<(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"abs-instance-method","name":"abs","doc":"Returns the absolute value of this number.\n\n```\n123.abs  # => 123\n-123.abs # => 123\n```","summary":"<p>Returns the absolute value of this number.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1350,"url":null},"def":{"name":"abs","visibility":"Public","body":"self"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/int.cr","line_number":1367,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"leading_zeros_count-instance-method","name":"leading_zeros_count","doc":"Returns the number of leading `0`-bits.","summary":"<p>Returns the number of leading <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1359,"url":null},"def":{"name":"leading_zeros_count","visibility":"Public","body":"Intrinsics.countleading128(self, false)"}},{"html_id":"popcount-instance-method","name":"popcount","doc":"Counts `1`-bits in the binary representation of this integer.\n\n```\n5.popcount   # => 2\n-15.popcount # => 29\n```","summary":"<p>Counts <code>1</code>-bits in the binary representation of this integer.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1354,"url":null},"def":{"name":"popcount","visibility":"Public","body":"Intrinsics.popcount128(self)"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f!:Float64-instance-method","name":"to_f!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f32!:Float32-instance-method","name":"to_f32!","doc":"Returns `self` converted to `Float32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32!","return_type":"Float32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i!:Int32-instance-method","name":"to_i!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128","return_type":"Int128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i128!:Int128-instance-method","name":"to_i128!","doc":"Returns `self` converted to `Int128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128!","return_type":"Int128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i16!:Int16-instance-method","name":"to_i16!","doc":"Returns `self` converted to `Int16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16!","return_type":"Int16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i64!:Int64-instance-method","name":"to_i64!","doc":"Returns `self` converted to `Int64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64!","return_type":"Int64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i8!:Int8-instance-method","name":"to_i8!","doc":"Returns `self` converted to `Int8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8!","return_type":"Int8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u!:UInt32-instance-method","name":"to_u!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128","return_type":"UInt128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u128!:UInt128-instance-method","name":"to_u128!","doc":"Returns `self` converted to `UInt128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128!","return_type":"UInt128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u16!:UInt16-instance-method","name":"to_u16!","doc":"Returns `self` converted to `UInt16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16!","return_type":"UInt16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u64!:UInt64-instance-method","name":"to_u64!","doc":"Returns `self` converted to `UInt64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64!","return_type":"UInt64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u8!:UInt8-instance-method","name":"to_u8!","doc":"Returns `self` converted to `UInt8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8!","return_type":"UInt8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"trailing_zeros_count-instance-method","name":"trailing_zeros_count","doc":"Returns the number of trailing `0`-bits.","summary":"<p>Returns the number of trailing <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1363,"url":null},"def":{"name":"trailing_zeros_count","visibility":"Public","body":"Intrinsics.counttrailing128(self, false)"}},{"html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0xd7ff` and `0xe000..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0xd7ff</code> and <code>0xe000..0x10ffff</code>).</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"unsafe_chr","return_type":"Char","visibility":"Public","body":"# primitive: convert"}},{"html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}}]},{"html_id":"Crystal/UInt16","path":"UInt16.html","kind":"struct","full_name":"UInt16","name":"UInt16","abstract":false,"superclass":{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/number.cr","line_number":77,"url":null},{"filename":"src/int.cr","line_number":1150,"url":null},{"filename":"src/primitives.cr","line_number":280,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"MAX","name":"MAX","value":"65535_u16"},{"id":"MIN","name":"MIN","value":"0_u16"}],"class_methods":[{"html_id":"from_json_object_key?(key:String)-class-method","name":"from_json_object_key?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String)","args_html":"(key : <a href=\"String.html\">String</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"from_json_object_key?","args":[{"name":"key","external_name":"key","restriction":"String"}],"visibility":"Public","body":"key.to_u16?"}}],"constructors":[{"html_id":"new(value:String,base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):self-class-method","name":"new","doc":"Returns an `UInt16` by invoking `to_u16` on *value*.\nSee `String#to_i` for more details.\n\n```\nUInt16.new \"20\"                        # => 20\nUInt16.new \"  20  \", whitespace: false # => Unhandled exception: Invalid UInt16:   20 (ArgumentError)\n```","summary":"<p>Returns an <code><a href=\"UInt16.html\">UInt16</a></code> by invoking <code><a href=\"UInt16.html#to_u16%3AUInt16-instance-method\">#to_u16</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(value : String, base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : self","args_html":"(value : <a href=\"String.html\">String</a>, base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1161,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"self","visibility":"Public","body":"value.to_u16(base: base, whitespace: whitespace, underscore: underscore, prefix: prefix, strict: strict, leading_zero_is_octal: leading_zero_is_octal)"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":59,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"UInt16.new!(parse_scalar(ctx, node, Int64))"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"location = pull.location\nvalue = pull.read_int\nbegin\n  value.to_u16\nrescue ex : OverflowError | ArgumentError\n  raise(JSON::ParseException.new(\"Can't read UInt16\", *location, ex))\nend\n"}},{"html_id":"new(value):self-class-method","name":"new","doc":"Returns an `UInt16` by invoking `to_u16` on *value*.","summary":"<p>Returns an <code><a href=\"UInt16.html\">UInt16</a></code> by invoking <code><a href=\"UInt16.html#to_u16%3AUInt16-instance-method\">#to_u16</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1166,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_u16"}},{"html_id":"new!(value):self-class-method","name":"new!","doc":"Returns an `UInt16` by invoking `to_u16!` on *value*.","summary":"<p>Returns an <code><a href=\"UInt16.html\">UInt16</a></code> by invoking <code><a href=\"UInt16.html#to_u16%21%3AUInt16-instance-method\">#to_u16!</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1171,"url":null},"def":{"name":"new!","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_u16!"}}],"instance_methods":[{"html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-:UInt16-instance-method","name":"&-","abstract":false,"location":{"filename":"src/int.cr","line_number":1179,"url":null},"def":{"name":"&-","return_type":"UInt16","visibility":"Public","body":"0_u16 &- self"}},{"html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"/(other:Int8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Float64","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1175,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Float64","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1175,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Float64","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1175,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Float64","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1175,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Float64","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1175,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Float64","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1175,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Float64","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1175,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Float64","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1175,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Float64","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1175,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Float64","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1175,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Float32):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/int.cr","line_number":1176,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:Float64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1177,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:BigInt):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigFloat","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":78,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigFloat):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigFloat","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":79,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":80,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":81,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"<(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"abs:self-instance-method","name":"abs","doc":"Returns the absolute value of this number.\n\n```\n123.abs  # => 123\n-123.abs # => 123\n```","summary":"<p>Returns the absolute value of this number.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1183,"url":null},"def":{"name":"abs","return_type":"self","visibility":"Public","body":"self"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/int.cr","line_number":1200,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"leading_zeros_count-instance-method","name":"leading_zeros_count","doc":"Returns the number of leading `0`-bits.","summary":"<p>Returns the number of leading <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1192,"url":null},"def":{"name":"leading_zeros_count","visibility":"Public","body":"Intrinsics.countleading16(self, false)"}},{"html_id":"popcount:Int16-instance-method","name":"popcount","doc":"Counts `1`-bits in the binary representation of this integer.\n\n```\n5.popcount   # => 2\n-15.popcount # => 29\n```","summary":"<p>Counts <code>1</code>-bits in the binary representation of this integer.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1187,"url":null},"def":{"name":"popcount","return_type":"Int16","visibility":"Public","body":"Intrinsics.popcount16(self)"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f!:Float64-instance-method","name":"to_f!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f32!:Float32-instance-method","name":"to_f32!","doc":"Returns `self` converted to `Float32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32!","return_type":"Float32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i!:Int32-instance-method","name":"to_i!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128","return_type":"Int128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i128!:Int128-instance-method","name":"to_i128!","doc":"Returns `self` converted to `Int128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128!","return_type":"Int128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i16!:Int16-instance-method","name":"to_i16!","doc":"Returns `self` converted to `Int16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16!","return_type":"Int16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i64!:Int64-instance-method","name":"to_i64!","doc":"Returns `self` converted to `Int64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64!","return_type":"Int64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i8!:Int8-instance-method","name":"to_i8!","doc":"Returns `self` converted to `Int8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8!","return_type":"Int8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u!:UInt32-instance-method","name":"to_u!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128","return_type":"UInt128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u128!:UInt128-instance-method","name":"to_u128!","doc":"Returns `self` converted to `UInt128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128!","return_type":"UInt128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u16!:UInt16-instance-method","name":"to_u16!","doc":"Returns `self` converted to `UInt16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16!","return_type":"UInt16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u64!:UInt64-instance-method","name":"to_u64!","doc":"Returns `self` converted to `UInt64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64!","return_type":"UInt64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u8!:UInt8-instance-method","name":"to_u8!","doc":"Returns `self` converted to `UInt8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8!","return_type":"UInt8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"trailing_zeros_count-instance-method","name":"trailing_zeros_count","doc":"Returns the number of trailing `0`-bits.","summary":"<p>Returns the number of trailing <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1196,"url":null},"def":{"name":"trailing_zeros_count","visibility":"Public","body":"Intrinsics.counttrailing16(self, false)"}},{"html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0xd7ff` and `0xe000..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0xd7ff</code> and <code>0xe000..0x10ffff</code>).</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"unsafe_chr","return_type":"Char","visibility":"Public","body":"# primitive: convert"}},{"html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}}]},{"html_id":"Crystal/UInt32","path":"UInt32.html","kind":"struct","full_name":"UInt32","name":"UInt32","abstract":false,"superclass":{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/number.cr","line_number":84,"url":null},{"filename":"src/int.cr","line_number":1205,"url":null},{"filename":"src/primitives.cr","line_number":280,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"MAX","name":"MAX","value":"4294967295_u32"},{"id":"MIN","name":"MIN","value":"0_u32"}],"class_methods":[{"html_id":"from_json_object_key?(key:String)-class-method","name":"from_json_object_key?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String)","args_html":"(key : <a href=\"String.html\">String</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"from_json_object_key?","args":[{"name":"key","external_name":"key","restriction":"String"}],"visibility":"Public","body":"key.to_u32?"}}],"constructors":[{"html_id":"new(value:String,base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):self-class-method","name":"new","doc":"Returns an `UInt32` by invoking `to_u32` on *value*.\nSee `String#to_i` for more details.\n\n```\nUInt32.new \"20\"                        # => 20\nUInt32.new \"  20  \", whitespace: false # => Unhandled exception: Invalid UInt32:   20 (ArgumentError)\n```","summary":"<p>Returns an <code><a href=\"UInt32.html\">UInt32</a></code> by invoking <code><a href=\"UInt32.html#to_u32%3AUInt32-instance-method\">#to_u32</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(value : String, base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : self","args_html":"(value : <a href=\"String.html\">String</a>, base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1216,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"self","visibility":"Public","body":"value.to_u32(base: base, whitespace: whitespace, underscore: underscore, prefix: prefix, strict: strict, leading_zero_is_octal: leading_zero_is_octal)"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":59,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"UInt32.new!(parse_scalar(ctx, node, Int64))"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"location = pull.location\nvalue = pull.read_int\nbegin\n  value.to_u32\nrescue ex : OverflowError | ArgumentError\n  raise(JSON::ParseException.new(\"Can't read UInt32\", *location, ex))\nend\n"}},{"html_id":"new(value):self-class-method","name":"new","doc":"Returns an `UInt32` by invoking `to_u32` on *value*.","summary":"<p>Returns an <code><a href=\"UInt32.html\">UInt32</a></code> by invoking <code><a href=\"UInt32.html#to_u32%3AUInt32-instance-method\">#to_u32</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1221,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_u32"}},{"html_id":"new!(value):self-class-method","name":"new!","doc":"Returns an `UInt32` by invoking `to_u32!` on *value*.","summary":"<p>Returns an <code><a href=\"UInt32.html\">UInt32</a></code> by invoking <code><a href=\"UInt32.html#to_u32%21%3AUInt32-instance-method\">#to_u32!</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1226,"url":null},"def":{"name":"new!","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_u32!"}}],"instance_methods":[{"html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-:UInt32-instance-method","name":"&-","abstract":false,"location":{"filename":"src/int.cr","line_number":1234,"url":null},"def":{"name":"&-","return_type":"UInt32","visibility":"Public","body":"0_u32 &- self"}},{"html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"/(other:Int8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Float64","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1230,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Float64","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1230,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Float64","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1230,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Float64","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1230,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Float64","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1230,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Float64","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1230,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Float64","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1230,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Float64","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1230,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Float64","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1230,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Float64","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1230,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Float32):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/int.cr","line_number":1231,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:Float64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1232,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:BigInt):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigFloat","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":85,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigFloat):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigFloat","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":86,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":87,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":88,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"<(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"abs:self-instance-method","name":"abs","doc":"Returns the absolute value of this number.\n\n```\n123.abs  # => 123\n-123.abs # => 123\n```","summary":"<p>Returns the absolute value of this number.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1238,"url":null},"def":{"name":"abs","return_type":"self","visibility":"Public","body":"self"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/int.cr","line_number":1255,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"leading_zeros_count-instance-method","name":"leading_zeros_count","doc":"Returns the number of leading `0`-bits.","summary":"<p>Returns the number of leading <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1247,"url":null},"def":{"name":"leading_zeros_count","visibility":"Public","body":"Intrinsics.countleading32(self, false)"}},{"html_id":"popcount:Int32-instance-method","name":"popcount","doc":"Counts `1`-bits in the binary representation of this integer.\n\n```\n5.popcount   # => 2\n-15.popcount # => 29\n```","summary":"<p>Counts <code>1</code>-bits in the binary representation of this integer.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1242,"url":null},"def":{"name":"popcount","return_type":"Int32","visibility":"Public","body":"Intrinsics.popcount32(self)"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f!:Float64-instance-method","name":"to_f!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f32!:Float32-instance-method","name":"to_f32!","doc":"Returns `self` converted to `Float32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32!","return_type":"Float32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i!:Int32-instance-method","name":"to_i!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128","return_type":"Int128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i128!:Int128-instance-method","name":"to_i128!","doc":"Returns `self` converted to `Int128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128!","return_type":"Int128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i16!:Int16-instance-method","name":"to_i16!","doc":"Returns `self` converted to `Int16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16!","return_type":"Int16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i64!:Int64-instance-method","name":"to_i64!","doc":"Returns `self` converted to `Int64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64!","return_type":"Int64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i8!:Int8-instance-method","name":"to_i8!","doc":"Returns `self` converted to `Int8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8!","return_type":"Int8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u!:UInt32-instance-method","name":"to_u!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128","return_type":"UInt128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u128!:UInt128-instance-method","name":"to_u128!","doc":"Returns `self` converted to `UInt128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128!","return_type":"UInt128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u16!:UInt16-instance-method","name":"to_u16!","doc":"Returns `self` converted to `UInt16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16!","return_type":"UInt16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u64!:UInt64-instance-method","name":"to_u64!","doc":"Returns `self` converted to `UInt64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64!","return_type":"UInt64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u8!:UInt8-instance-method","name":"to_u8!","doc":"Returns `self` converted to `UInt8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8!","return_type":"UInt8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"trailing_zeros_count-instance-method","name":"trailing_zeros_count","doc":"Returns the number of trailing `0`-bits.","summary":"<p>Returns the number of trailing <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1251,"url":null},"def":{"name":"trailing_zeros_count","visibility":"Public","body":"Intrinsics.counttrailing32(self, false)"}},{"html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0xd7ff` and `0xe000..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0xd7ff</code> and <code>0xe000..0x10ffff</code>).</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"unsafe_chr","return_type":"Char","visibility":"Public","body":"# primitive: convert"}},{"html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}}]},{"html_id":"Crystal/UInt64","path":"UInt64.html","kind":"struct","full_name":"UInt64","name":"UInt64","abstract":false,"superclass":{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/number.cr","line_number":91,"url":null},{"filename":"src/int.cr","line_number":1260,"url":null},{"filename":"src/primitives.cr","line_number":280,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"MAX","name":"MAX","value":"18446744073709551615_u64"},{"id":"MIN","name":"MIN","value":"0_u64"}],"class_methods":[{"html_id":"from_json_object_key?(key:String)-class-method","name":"from_json_object_key?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String)","args_html":"(key : <a href=\"String.html\">String</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"from_json_object_key?","args":[{"name":"key","external_name":"key","restriction":"String"}],"visibility":"Public","body":"key.to_u64?"}}],"constructors":[{"html_id":"new(value:String,base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):self-class-method","name":"new","doc":"Returns an `UInt64` by invoking `to_u64` on *value*.\nSee `String#to_i` for more details.\n\n```\nUInt64.new \"20\"                        # => 20\nUInt64.new \"  20  \", whitespace: false # => Unhandled exception: Invalid UInt64:   20 (ArgumentError)\n```","summary":"<p>Returns an <code><a href=\"UInt64.html\">UInt64</a></code> by invoking <code><a href=\"UInt64.html#to_u64%3AUInt64-instance-method\">#to_u64</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(value : String, base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : self","args_html":"(value : <a href=\"String.html\">String</a>, base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1271,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"self","visibility":"Public","body":"value.to_u64(base: base, whitespace: whitespace, underscore: underscore, prefix: prefix, strict: strict, leading_zero_is_octal: leading_zero_is_octal)"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":59,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"UInt64.new!(parse_scalar(ctx, node, Int64))"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"location = pull.location\nvalue = pull.read_raw\nbegin\n  value.to_u64\nrescue ex : OverflowError | ArgumentError\n  raise(JSON::ParseException.new(\"Can't read UInt64\", *location, ex))\nend\n"}},{"html_id":"new(value):self-class-method","name":"new","doc":"Returns an `UInt64` by invoking `to_u64` on *value*.","summary":"<p>Returns an <code><a href=\"UInt64.html\">UInt64</a></code> by invoking <code><a href=\"UInt64.html#to_u64%3AUInt64-instance-method\">#to_u64</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1276,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_u64"}},{"html_id":"new!(value):self-class-method","name":"new!","doc":"Returns an `UInt64` by invoking `to_u64!` on *value*.","summary":"<p>Returns an <code><a href=\"UInt64.html\">UInt64</a></code> by invoking <code><a href=\"UInt64.html#to_u64%21%3AUInt64-instance-method\">#to_u64!</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1281,"url":null},"def":{"name":"new!","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_u64!"}}],"instance_methods":[{"html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-:UInt64-instance-method","name":"&-","abstract":false,"location":{"filename":"src/int.cr","line_number":1289,"url":null},"def":{"name":"&-","return_type":"UInt64","visibility":"Public","body":"0_u64 &- self"}},{"html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"/(other:Int8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Float64","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1285,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Float64","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1285,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Float64","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1285,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Float64","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1285,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Float64","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1285,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Float64","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1285,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Float64","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1285,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Float64","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1285,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Float64","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1285,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Float64","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1285,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Float32):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/int.cr","line_number":1286,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:Float64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1287,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:BigInt):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigFloat","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":92,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigFloat):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigFloat","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":93,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":94,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":95,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"<(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"abs:self-instance-method","name":"abs","doc":"Returns the absolute value of this number.\n\n```\n123.abs  # => 123\n-123.abs # => 123\n```","summary":"<p>Returns the absolute value of this number.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1293,"url":null},"def":{"name":"abs","return_type":"self","visibility":"Public","body":"self"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/int.cr","line_number":1310,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"leading_zeros_count-instance-method","name":"leading_zeros_count","doc":"Returns the number of leading `0`-bits.","summary":"<p>Returns the number of leading <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1302,"url":null},"def":{"name":"leading_zeros_count","visibility":"Public","body":"Intrinsics.countleading64(self, false)"}},{"html_id":"popcount:Int64-instance-method","name":"popcount","doc":"Counts `1`-bits in the binary representation of this integer.\n\n```\n5.popcount   # => 2\n-15.popcount # => 29\n```","summary":"<p>Counts <code>1</code>-bits in the binary representation of this integer.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1297,"url":null},"def":{"name":"popcount","return_type":"Int64","visibility":"Public","body":"Intrinsics.popcount64(self)"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f!:Float64-instance-method","name":"to_f!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f32!:Float32-instance-method","name":"to_f32!","doc":"Returns `self` converted to `Float32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32!","return_type":"Float32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i!:Int32-instance-method","name":"to_i!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128","return_type":"Int128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i128!:Int128-instance-method","name":"to_i128!","doc":"Returns `self` converted to `Int128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128!","return_type":"Int128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i16!:Int16-instance-method","name":"to_i16!","doc":"Returns `self` converted to `Int16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16!","return_type":"Int16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i64!:Int64-instance-method","name":"to_i64!","doc":"Returns `self` converted to `Int64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64!","return_type":"Int64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i8!:Int8-instance-method","name":"to_i8!","doc":"Returns `self` converted to `Int8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8!","return_type":"Int8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u!:UInt32-instance-method","name":"to_u!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128","return_type":"UInt128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u128!:UInt128-instance-method","name":"to_u128!","doc":"Returns `self` converted to `UInt128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128!","return_type":"UInt128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u16!:UInt16-instance-method","name":"to_u16!","doc":"Returns `self` converted to `UInt16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16!","return_type":"UInt16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u64!:UInt64-instance-method","name":"to_u64!","doc":"Returns `self` converted to `UInt64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64!","return_type":"UInt64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u8!:UInt8-instance-method","name":"to_u8!","doc":"Returns `self` converted to `UInt8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8!","return_type":"UInt8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"trailing_zeros_count-instance-method","name":"trailing_zeros_count","doc":"Returns the number of trailing `0`-bits.","summary":"<p>Returns the number of trailing <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1306,"url":null},"def":{"name":"trailing_zeros_count","visibility":"Public","body":"Intrinsics.counttrailing64(self, false)"}},{"html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0xd7ff` and `0xe000..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0xd7ff</code> and <code>0xe000..0x10ffff</code>).</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"unsafe_chr","return_type":"Char","visibility":"Public","body":"# primitive: convert"}},{"html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}}]},{"html_id":"Crystal/UInt8","path":"UInt8.html","kind":"struct","full_name":"UInt8","name":"UInt8","abstract":false,"superclass":{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},"ancestors":[{"html_id":"Crystal/Int","kind":"struct","full_name":"Int","name":"Int"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Steppable","kind":"module","full_name":"Steppable","name":"Steppable"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/big/number.cr","line_number":70,"url":null},{"filename":"src/int.cr","line_number":1095,"url":null},{"filename":"src/primitives.cr","line_number":280,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"MAX","name":"MAX","value":"255_u8"},{"id":"MIN","name":"MIN","value":"0_u8"}],"class_methods":[{"html_id":"from_json_object_key?(key:String)-class-method","name":"from_json_object_key?","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String)","args_html":"(key : <a href=\"String.html\">String</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"from_json_object_key?","args":[{"name":"key","external_name":"key","restriction":"String"}],"visibility":"Public","body":"key.to_u8?"}}],"constructors":[{"html_id":"new(value:String,base:Int=10,whitespace:Bool=true,underscore:Bool=false,prefix:Bool=false,strict:Bool=true,leading_zero_is_octal:Bool=false):self-class-method","name":"new","doc":"Returns an `UInt8` by invoking `to_u8` on *value*.\nSee `String#to_i` for more details.\n\n```\nUInt8.new \"20\"                        # => 20\nUInt8.new \"  20  \", whitespace: false # => Unhandled exception: Invalid UInt8:   20 (ArgumentError)\n```","summary":"<p>Returns an <code><a href=\"UInt8.html\">UInt8</a></code> by invoking <code><a href=\"UInt8.html#to_u8%3AUInt8-instance-method\">#to_u8</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"args_string":"(value : String, base : Int = 10, whitespace : Bool = true, underscore : Bool = false, prefix : Bool = false, strict : Bool = true, leading_zero_is_octal : Bool = false) : self","args_html":"(value : <a href=\"String.html\">String</a>, base : <a href=\"Int.html\">Int</a> = <span class=\"n\">10</span>, whitespace : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, underscore : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, prefix : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, strict : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>, leading_zero_is_octal : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1106,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"base","default_value":"10","external_name":"base","restriction":"Int"},{"name":"whitespace","default_value":"true","external_name":"whitespace","restriction":"Bool"},{"name":"underscore","default_value":"false","external_name":"underscore","restriction":"Bool"},{"name":"prefix","default_value":"false","external_name":"prefix","restriction":"Bool"},{"name":"strict","default_value":"true","external_name":"strict","restriction":"Bool"},{"name":"leading_zero_is_octal","default_value":"false","external_name":"leading_zero_is_octal","restriction":"Bool"}],"return_type":"self","visibility":"Public","body":"value.to_u8(base: base, whitespace: whitespace, underscore: underscore, prefix: prefix, strict: strict, leading_zero_is_octal: leading_zero_is_octal)"}},{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":59,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"UInt8.new!(parse_scalar(ctx, node, Int64))"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":76,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"location = pull.location\nvalue = pull.read_int\nbegin\n  value.to_u8\nrescue ex : OverflowError | ArgumentError\n  raise(JSON::ParseException.new(\"Can't read UInt8\", *location, ex))\nend\n"}},{"html_id":"new(value):self-class-method","name":"new","doc":"Returns an `UInt8` by invoking `to_u8` on *value*.","summary":"<p>Returns an <code><a href=\"UInt8.html\">UInt8</a></code> by invoking <code><a href=\"UInt8.html#to_u8%3AUInt8-instance-method\">#to_u8</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1111,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_u8"}},{"html_id":"new!(value):self-class-method","name":"new!","doc":"Returns an `UInt8` by invoking `to_u8!` on *value*.","summary":"<p>Returns an <code><a href=\"UInt8.html\">UInt8</a></code> by invoking <code><a href=\"UInt8.html#to_u8%21%3AUInt8-instance-method\">#to_u8!</a></code> on <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""}],"args_string":"(value) : self","args_html":"(value) : <span class=\"k\">self</span>","location":{"filename":"src/int.cr","line_number":1116,"url":null},"def":{"name":"new!","args":[{"name":"value","external_name":"value","restriction":""}],"return_type":"self","visibility":"Public","body":"value.to_u8!"}}],"instance_methods":[{"html_id":"!=(other:Int8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Int128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt8):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt16):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:UInt128):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float32):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"!=(other:Float64):Bool-instance-method","name":"!=","doc":"Returns `true` if `self` is not equal to *other*\nor if `self` and *other* are unordered.","summary":"<p>Returns <code>true</code> if <code>self</code> is not equal to <em>other</em> or if <code>self</code> and <em>other</em> are unordered.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"!=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:Int128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt8):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt16):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt32):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt64):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&(other:UInt128):self-instance-method","name":"&","doc":"Returns the result of performing a bitwise AND of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise AND of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:Int128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt8):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt16):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt32):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt64):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&*(other:UInt128):self-instance-method","name":"&*","doc":"Returns the result of multiplying `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:Int128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt8):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt16):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt32):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt64):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&+(other:UInt128):self-instance-method","name":"&+","doc":"Returns the result of adding `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:Int128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt8):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt16):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt32):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt64):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-(other:UInt128):self-instance-method","name":"&-","doc":"Returns the result of subtracting `self` and *other*.\nIn case of overflow a wrapping is performed.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"&-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"&-:UInt8-instance-method","name":"&-","abstract":false,"location":{"filename":"src/int.cr","line_number":1124,"url":null},"def":{"name":"&-","return_type":"UInt8","visibility":"Public","body":"0_u8 &- self"}},{"html_id":"*(other:Int8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Int128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt8):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt16):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt32):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt64):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:UInt128):self-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float32):Float32-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"*(other:Float64):Float64-instance-method","name":"*","doc":"Returns the result of multiplying `self` and *other*.","summary":"<p>Returns the result of multiplying <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"*","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Int128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt8):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt16):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt32):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt64):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:UInt128):self-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float32):Float32-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"+(other:Float64):Float64-instance-method","name":"+","doc":"Returns the result of adding `self` and *other*.","summary":"<p>Returns the result of adding <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"+","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Int128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt8):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt16):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt32):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt64):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:UInt128):self-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float32):Float32-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"# primitive: binary"}},{"html_id":"-(other:Float64):Float64-instance-method","name":"-","doc":"Returns the result of subtracting `self` and *other*.","summary":"<p>Returns the result of subtracting <code>self</code> and <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"-","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"# primitive: binary"}},{"html_id":"/(other:Int8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Float64","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1120,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt8):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Float64","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1120,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Float64","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1120,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt16):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Float64","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1120,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Float64","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1120,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt32):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Float64","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1120,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Float64","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1120,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Float64","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1120,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Int128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Float64","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1120,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:UInt128):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Float64","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1120,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:Float32):Float32-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Float32","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Float32.html\">Float32</a>","location":{"filename":"src/int.cr","line_number":1121,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Float32","visibility":"Public","body":"(Float32.new(self)) / (Float32.new(other))"}},{"html_id":"/(other:Float64):Float64-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Float64","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Float64.html\">Float64</a>","location":{"filename":"src/int.cr","line_number":1122,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Float64","visibility":"Public","body":"(Float64.new(self)) / (Float64.new(other))"}},{"html_id":"/(other:BigInt):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"args_string":"(other : BigInt) : BigFloat","args_html":"(other : <a href=\"BigInt.html\">BigInt</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":71,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigInt"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigFloat):BigFloat-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"args_string":"(other : BigFloat) : BigFloat","args_html":"(other : <a href=\"BigFloat.html\">BigFloat</a>) : <a href=\"BigFloat.html\">BigFloat</a>","location":{"filename":"src/big/number.cr","line_number":72,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigFloat"}],"return_type":"BigFloat","visibility":"Public","body":"(BigFloat.new(self)) / (BigFloat.new(other))"}},{"html_id":"/(other:BigDecimal):BigDecimal-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"args_string":"(other : BigDecimal) : BigDecimal","args_html":"(other : <a href=\"BigDecimal.html\">BigDecimal</a>) : <a href=\"BigDecimal.html\">BigDecimal</a>","location":{"filename":"src/big/number.cr","line_number":73,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigDecimal"}],"return_type":"BigDecimal","visibility":"Public","body":"(BigDecimal.new(self)) / (BigDecimal.new(other))"}},{"html_id":"/(other:BigRational):BigRational-instance-method","name":"/","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"args_string":"(other : BigRational) : BigRational","args_html":"(other : <a href=\"BigRational.html\">BigRational</a>) : <a href=\"BigRational.html\">BigRational</a>","location":{"filename":"src/big/number.cr","line_number":74,"url":null},"def":{"name":"/","args":[{"name":"other","external_name":"other","restriction":"BigRational"}],"return_type":"BigRational","visibility":"Public","body":"(BigRational.new(self)) / (BigRational.new(other))"}},{"html_id":"<(other:Int8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Int128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt8):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt16):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:UInt128):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float32):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<(other:Float64):Bool-instance-method","name":"<","doc":"Returns `true` if `self` is less than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Int128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt8):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt16):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:UInt128):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float32):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"<=(other:Float64):Bool-instance-method","name":"<=","doc":"Returns `true` if `self` is less than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is less than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"<=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Int128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt8):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt16):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:UInt128):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float32):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"==(other:Float64):Bool-instance-method","name":"==","doc":"Returns `true` if `self` is equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Int128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt8):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt16):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:UInt128):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float32):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">(other:Float64):Bool-instance-method","name":">","doc":"Returns `true` if `self` is greater than *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : Bool","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : Bool","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : Bool","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : Bool","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Int128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : Bool","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt8):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : Bool","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt16):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : Bool","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : Bool","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : Bool","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:UInt128):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : Bool","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float32):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float32"}],"args_string":"(other : Float32) : Bool","args_html":"(other : <a href=\"Float32.html\">Float32</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float32"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":">=(other:Float64):Bool-instance-method","name":">=","doc":"Returns `true` if `self` is greater than or equal to *other*.","summary":"<p>Returns <code>true</code> if <code>self</code> is greater than or equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Float64"}],"args_string":"(other : Float64) : Bool","args_html":"(other : <a href=\"Float64.html\">Float64</a>) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":">=","args":[{"name":"other","external_name":"other","restriction":"Float64"}],"return_type":"Bool","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:Int128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt8):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt16):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt32):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt64):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"^(other:UInt128):self-instance-method","name":"^","doc":"Returns the result of performing a bitwise XOR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise XOR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"^","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"abs:self-instance-method","name":"abs","doc":"Returns the absolute value of this number.\n\n```\n123.abs  # => 123\n-123.abs # => 123\n```","summary":"<p>Returns the absolute value of this number.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1128,"url":null},"def":{"name":"abs","return_type":"self","visibility":"Public","body":"self"}},{"html_id":"clone-instance-method","name":"clone","abstract":false,"location":{"filename":"src/int.cr","line_number":1145,"url":null},"def":{"name":"clone","visibility":"Public","body":"self"}},{"html_id":"leading_zeros_count-instance-method","name":"leading_zeros_count","doc":"Returns the number of leading `0`-bits.","summary":"<p>Returns the number of leading <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1137,"url":null},"def":{"name":"leading_zeros_count","visibility":"Public","body":"Intrinsics.countleading8(self, false)"}},{"html_id":"popcount:Int8-instance-method","name":"popcount","doc":"Counts `1`-bits in the binary representation of this integer.\n\n```\n5.popcount   # => 2\n-15.popcount # => 29\n```","summary":"<p>Counts <code>1</code>-bits in the binary representation of this integer.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1132,"url":null},"def":{"name":"popcount","return_type":"Int8","visibility":"Public","body":"Intrinsics.popcount8(self)"}},{"html_id":"to_f:Float64-instance-method","name":"to_f","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f!:Float64-instance-method","name":"to_f!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f32:Float32-instance-method","name":"to_f32","doc":"Returns `self` converted to `Float32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32","return_type":"Float32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f32!:Float32-instance-method","name":"to_f32!","doc":"Returns `self` converted to `Float32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f32!","return_type":"Float32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_f64:Float64-instance-method","name":"to_f64","doc":"Returns `self` converted to `Float64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64","return_type":"Float64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_f64!:Float64-instance-method","name":"to_f64!","doc":"Returns `self` converted to `Float64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Float64.html\">Float64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_f64!","return_type":"Float64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i:Int32-instance-method","name":"to_i","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i!:Int32-instance-method","name":"to_i!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i128:Int128-instance-method","name":"to_i128","doc":"Returns `self` converted to `Int128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128","return_type":"Int128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i128!:Int128-instance-method","name":"to_i128!","doc":"Returns `self` converted to `Int128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int128.html\">Int128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i128!","return_type":"Int128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i16:Int16-instance-method","name":"to_i16","doc":"Returns `self` converted to `Int16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16","return_type":"Int16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i16!:Int16-instance-method","name":"to_i16!","doc":"Returns `self` converted to `Int16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int16.html\">Int16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i16!","return_type":"Int16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i32:Int32-instance-method","name":"to_i32","doc":"Returns `self` converted to `Int32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32","return_type":"Int32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i32!:Int32-instance-method","name":"to_i32!","doc":"Returns `self` converted to `Int32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i32!","return_type":"Int32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i64:Int64-instance-method","name":"to_i64","doc":"Returns `self` converted to `Int64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64","return_type":"Int64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i64!:Int64-instance-method","name":"to_i64!","doc":"Returns `self` converted to `Int64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int64.html\">Int64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i64!","return_type":"Int64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_i8:Int8-instance-method","name":"to_i8","doc":"Returns `self` converted to `Int8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8","return_type":"Int8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_i8!:Int8-instance-method","name":"to_i8!","doc":"Returns `self` converted to `Int8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"Int8.html\">Int8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_i8!","return_type":"Int8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u:UInt32-instance-method","name":"to_u","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u!:UInt32-instance-method","name":"to_u!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u128:UInt128-instance-method","name":"to_u128","doc":"Returns `self` converted to `UInt128`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128","return_type":"UInt128","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u128!:UInt128-instance-method","name":"to_u128!","doc":"Returns `self` converted to `UInt128`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt128.html\">UInt128</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u128!","return_type":"UInt128","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u16:UInt16-instance-method","name":"to_u16","doc":"Returns `self` converted to `UInt16`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16","return_type":"UInt16","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u16!:UInt16-instance-method","name":"to_u16!","doc":"Returns `self` converted to `UInt16`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt16.html\">UInt16</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u16!","return_type":"UInt16","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u32:UInt32-instance-method","name":"to_u32","doc":"Returns `self` converted to `UInt32`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32","return_type":"UInt32","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u32!:UInt32-instance-method","name":"to_u32!","doc":"Returns `self` converted to `UInt32`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt32.html\">UInt32</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u32!","return_type":"UInt32","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u64:UInt64-instance-method","name":"to_u64","doc":"Returns `self` converted to `UInt64`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64","return_type":"UInt64","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u64!:UInt64-instance-method","name":"to_u64!","doc":"Returns `self` converted to `UInt64`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt64.html\">UInt64</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u64!","return_type":"UInt64","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"to_u8:UInt8-instance-method","name":"to_u8","doc":"Returns `self` converted to `UInt8`.\nRaises `OverflowError` in case of overflow.","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8","return_type":"UInt8","visibility":"Public","body":"# primitive: convert"}},{"html_id":"to_u8!:UInt8-instance-method","name":"to_u8!","doc":"Returns `self` converted to `UInt8`.\nIn case of overflow\n a wrapping is performed.\n","summary":"<p>Returns <code>self</code> converted to <code><a href=\"UInt8.html\">UInt8</a></code>.</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"to_u8!","return_type":"UInt8","visibility":"Public","body":"# primitive: unchecked_convert"}},{"html_id":"trailing_zeros_count-instance-method","name":"trailing_zeros_count","doc":"Returns the number of trailing `0`-bits.","summary":"<p>Returns the number of trailing <code>0</code>-bits.</p>","abstract":false,"location":{"filename":"src/int.cr","line_number":1141,"url":null},"def":{"name":"trailing_zeros_count","visibility":"Public","body":"Intrinsics.counttrailing8(self, false)"}},{"html_id":"unsafe_chr:Char-instance-method","name":"unsafe_chr","doc":"Returns a `Char` that has the unicode codepoint of `self`,\nwithout checking if this integer is in the range valid for\nchars (`0..0xd7ff` and `0xe000..0x10ffff`).\n\nYou should never use this method unless `chr` turns out to\nbe a bottleneck.\n\n```\n97.unsafe_chr # => 'a'\n```","summary":"<p>Returns a <code><a href=\"Char.html\">Char</a></code> that has the unicode codepoint of <code>self</code>, without checking if this integer is in the range valid for chars (<code>0..0xd7ff</code> and <code>0xe000..0x10ffff</code>).</p>","abstract":false,"location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"unsafe_chr","return_type":"Char","visibility":"Public","body":"# primitive: convert"}},{"html_id":"|(other:Int8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int8"}],"args_string":"(other : Int8) : self","args_html":"(other : <a href=\"Int8.html\">Int8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int16"}],"args_string":"(other : Int16) : self","args_html":"(other : <a href=\"Int16.html\">Int16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int32"}],"args_string":"(other : Int32) : self","args_html":"(other : <a href=\"Int32.html\">Int32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int64"}],"args_string":"(other : Int64) : self","args_html":"(other : <a href=\"Int64.html\">Int64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:Int128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Int128"}],"args_string":"(other : Int128) : self","args_html":"(other : <a href=\"Int128.html\">Int128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"Int128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt8):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"args_string":"(other : UInt8) : self","args_html":"(other : <a href=\"UInt8.html\">UInt8</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt8"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt16):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"args_string":"(other : UInt16) : self","args_html":"(other : <a href=\"UInt16.html\">UInt16</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt16"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt32):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"args_string":"(other : UInt32) : self","args_html":"(other : <a href=\"UInt32.html\">UInt32</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt32"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt64):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"args_string":"(other : UInt64) : self","args_html":"(other : <a href=\"UInt64.html\">UInt64</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt64"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}},{"html_id":"|(other:UInt128):self-instance-method","name":"|","doc":"Returns the result of performing a bitwise OR of `self`'s and *other*'s bits.","summary":"<p>Returns the result of performing a bitwise OR of <code>self</code>'s and <em>other</em>'s bits.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"args_string":"(other : UInt128) : self","args_html":"(other : <a href=\"UInt128.html\">UInt128</a>) : <span class=\"k\">self</span>","location":{"filename":"src/primitives.cr","line_number":280,"url":null},"def":{"name":"|","args":[{"name":"other","external_name":"other","restriction":"UInt128"}],"return_type":"self","visibility":"Public","body":"# primitive: binary"}}]},{"html_id":"Crystal/Unicode","path":"Unicode.html","kind":"module","full_name":"Unicode","name":"Unicode","abstract":false,"locations":[{"filename":"src/unicode/data.cr","line_number":7,"url":null},{"filename":"src/unicode/unicode.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"VERSION","name":"VERSION","value":"\"14.0.0\"","doc":"The currently supported [Unicode](https://home.unicode.org) version.","summary":"<p>The currently supported <a href=\"https://home.unicode.org\">Unicode</a> version.</p>"}],"doc":"Provides the `Unicode::CaseOptions` enum for special case conversions like Turkic.","summary":"<p>Provides the <code><a href=\"Unicode/CaseOptions.html\">Unicode::CaseOptions</a></code> enum for special case conversions like Turkic.</p>","types":[{"html_id":"Crystal/Unicode/CaseOptions","path":"Unicode/CaseOptions.html","kind":"enum","full_name":"Unicode::CaseOptions","name":"CaseOptions","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/unicode/unicode.cr","line_number":8,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"ASCII","name":"ASCII","value":"1","doc":"Only transform ASCII characters.","summary":"<p>Only transform ASCII characters.</p>"},{"id":"Turkic","name":"Turkic","value":"2","doc":"Use Turkic case rules:\n\n```\n'İ'.downcase(Unicode::CaseOptions::Turkic) # => 'i'\n'I'.downcase(Unicode::CaseOptions::Turkic) # => 'ı'\n'i'.upcase(Unicode::CaseOptions::Turkic)   # => 'İ'\n'ı'.upcase(Unicode::CaseOptions::Turkic)   # => 'I'\n```","summary":"<p>Use Turkic case rules:</p>"},{"id":"Fold","name":"Fold","value":"4","doc":"Unicode case folding, which is more far-reaching than Unicode case mapping.","summary":"<p>Unicode case folding, which is more far-reaching than Unicode case mapping.</p>"}],"namespace":{"html_id":"Crystal/Unicode","kind":"module","full_name":"Unicode","name":"Unicode"},"doc":"Case options to pass to various `Char` and `String` methods such as `upcase` or `downcase`.","summary":"<p>Case options to pass to various <code><a href=\"../Char.html\">Char</a></code> and <code><a href=\"../String.html\">String</a></code> methods such as <code>upcase</code> or <code>downcase</code>.</p>","instance_methods":[{"html_id":"ascii?-instance-method","name":"ascii?","abstract":false,"location":{"filename":"src/unicode/unicode.cr","line_number":10,"url":null},"def":{"name":"ascii?","visibility":"Public","body":"self.includes?(ASCII)"}},{"html_id":"fold?-instance-method","name":"fold?","abstract":false,"location":{"filename":"src/unicode/unicode.cr","line_number":23,"url":null},"def":{"name":"fold?","visibility":"Public","body":"self.includes?(Fold)"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/unicode/unicode.cr","line_number":8,"url":null},"def":{"name":"none?","visibility":"Public","body":"value == 0"}},{"html_id":"turkic?-instance-method","name":"turkic?","abstract":false,"location":{"filename":"src/unicode/unicode.cr","line_number":20,"url":null},"def":{"name":"turkic?","visibility":"Public","body":"self.includes?(Turkic)"}}]}]},{"html_id":"Crystal/Union","path":"Union.html","kind":"struct","full_name":"Union(*T)","name":"Union","abstract":false,"superclass":{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},"ancestors":[{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/union.cr","line_number":19,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"A union type represents the possibility of a variable or an expression\nhaving more than one possible type at compile time.\n\nWhen invoking a method on a union type, the language checks that the\nmethod exists and can be resolved (typed) for each type in the union.\nFor this reason, adding instance methods to `Union` makes no sense and\nhas no effect. However, adding class method to `Union` is possible\nand can be useful. One example is parsing `JSON` into one of many\npossible types.\n\nUnion is special in that it is a generic type but instantiating it\nmight not return a union type:\n\n```\nUnion(Int32 | String)      # => (Int32 | String)\nUnion(Int32)               # => Int32\nUnion(Int32, Int32, Int32) # => Int32\n```","summary":"<p>A union type represents the possibility of a variable or an expression having more than one possible type at compile time.</p>","class_methods":[{"html_id":"nilable?-class-method","name":"nilable?","doc":"Returns `true` if this union includes the `Nil` type.\n\n```\n(Int32 | String).nilable? # => false\n(Int32 | Nil).nilable?    # => true\n```","summary":"<p>Returns <code>true</code> if this union includes the <code><a href=\"Nil.html\">Nil</a></code> type.</p>","abstract":false,"location":{"filename":"src/union.cr","line_number":26,"url":null},"def":{"name":"nilable?","visibility":"Public","body":"{{ T.any?(&.==(::Nil)) }}"}}],"constructors":[{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/from_yaml.cr","line_number":264,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"if node.is_a?(YAML::Nodes::Alias)\n  {% for type in T %}\n      {% if type < ::Reference %}\n        ctx.read_alias?(node, {{ type }}) do |obj|\n          return obj\n        end\n      {% end %}\n    {% end %}\n  node.raise(\"Error deserializing alias\")\nend\n{% if true %}\n    # String must come last because anything can be parsed into a String.\n    # So, we give a chance first to types in the union to be parsed.\n    {% string_type = T.find do |type|\n  type == ::String\nend %}\n\n    {% for type in T %}\n      {% if type == string_type %}{% else %}\n        begin\n          return {{ type }}.new(ctx, node)\n        rescue YAML::ParseException\n          # Ignore\n        end\n      {% end %}\n    {% end %}\n\n    {% if string_type %}\n      begin\n        return {{ string_type }}.new(ctx, node)\n      rescue YAML::ParseException\n        # Ignore\n      end\n    {% end %}\n  {% end %}\nnode.raise(\"Couldn't parse #{self}\")\n"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/json/from_json.cr","line_number":323,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"location = pull.location\n{% if true %}\n    case pull.kind\n    {% if T.includes?(Nil) %}\n    when .null?\n      return pull.read_null\n    {% end %}\n    {% if T.includes?(Bool) %}\n    when .bool?\n      return pull.read_bool\n    {% end %}\n    {% if T.includes?(String) %}\n    when .string?\n      return pull.read_string\n    {% end %}\n    when .int?\n    {% type_order = [Int64, UInt64, Int32, UInt32, Int16, UInt16, Int8, UInt8, Float64, Float32] %}\n    {% for type in type_order.select do |t|\n  T.includes?(t)\nend %}\n      value = pull.read?({{ type }})\n      return value unless value.nil?\n    {% end %}\n    when .float?\n    {% type_order = [Float64, Float32] %}\n    {% for type in type_order.select do |t|\n  T.includes?(t)\nend %}\n      value = pull.read?({{ type }})\n      return value unless value.nil?\n    {% end %}\n    else\n      # no priority type\n    end\n  {% end %}\n{% if true %}\n    {% primitive_types = [Nil, Bool, String] + Number::Primitive.union_types %}\n    {% non_primitives = T.reject do |t|\n  primitive_types.includes?(t)\nend %}\n\n    # If after traversing all the types we are left with just one\n    # non-primitive type, we can parse it directly (no need to use `read_raw`)\n    {% if non_primitives.size == 1 %}\n      return {{ non_primitives[0] }}.new(pull)\n    {% else %}\n      string = pull.read_raw\n      {% for type in non_primitives %}\n        begin\n          return {{ type }}.from_json(string)\n        rescue JSON::ParseException\n          # Ignore\n        end\n      {% end %}\n      raise JSON::ParseException.new(\"Couldn't parse #{self} from #{string}\", *location)\n    {% end %}\n  {% end %}\n"}},{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/union.cr","line_number":19,"url":null},"def":{"name":"new","visibility":"Public","body":"x = allocate\nif x.responds_to?(:finalize)\n  ::GC.add_finalizer(x)\nend\nx\n"}}],"instance_methods":[{"html_id":"initialize-instance-method","name":"initialize","abstract":false,"location":{"filename":"src/union.cr","line_number":19,"url":null},"def":{"name":"initialize","visibility":"Public","body":""}}]},{"html_id":"Crystal/UNIXServer","path":"UNIXServer.html","kind":"class","full_name":"UNIXServer","name":"UNIXServer","abstract":false,"superclass":{"html_id":"Crystal/UNIXSocket","kind":"class","full_name":"UNIXSocket","name":"UNIXSocket"},"ancestors":[{"html_id":"Crystal/Socket/Server","kind":"module","full_name":"Socket::Server","name":"Server"},{"html_id":"Crystal/UNIXSocket","kind":"class","full_name":"UNIXSocket","name":"UNIXSocket"},{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},{"html_id":"Crystal/Crystal/System/Socket","kind":"module","full_name":"Crystal::System::Socket","name":"Socket"},{"html_id":"Crystal/IO/Evented","kind":"module","full_name":"IO::Evented","name":"Evented"},{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/unix_server.cr","line_number":21,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Socket/Server","kind":"module","full_name":"Socket::Server","name":"Server"}],"doc":"A local interprocess communication server socket.\n\nOnly available on UNIX and UNIX-like operating systems.\n\nExample usage:\n```\nrequire \"socket\"\n\ndef handle_client(client)\n  message = client.gets\n  client.puts message\nend\n\nserver = UNIXServer.new(\"/tmp/myapp.sock\")\nwhile client = server.accept?\n  spawn handle_client(client)\nend\n```","summary":"<p>A local interprocess communication server socket.</p>","class_methods":[{"html_id":"open(path,type:Type=Type::STREAM,backlog=128,&)-class-method","name":"open","doc":"Creates a new UNIX server and yields it to the block. Eventually closes the\nserver socket when the block returns.\n\nReturns the value of the block.","summary":"<p>Creates a new UNIX server and yields it to the block.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"backlog","default_value":"128","external_name":"backlog","restriction":""}],"args_string":"(path, type : Type = Type::STREAM, backlog = 128, &)","args_html":"(path, type : <a href=\"Socket/Type.html\">Type</a> = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>, backlog = <span class=\"n\">128</span>, &)","location":{"filename":"src/socket/unix_server.cr","line_number":58,"url":null},"def":{"name":"open","args":[{"name":"path","external_name":"path","restriction":""},{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"backlog","default_value":"128","external_name":"backlog","restriction":""}],"yields":1,"visibility":"Public","body":"server = new(path, type, backlog)\nbegin\n  yield server\nensure\n  server.close\nend\n"}}],"constructors":[{"html_id":"new(path:String,type:Type=Type::STREAM,backlog:Int=128)-class-method","name":"new","doc":"Creates a named UNIX socket, listening on a filesystem pathname.\n\nAlways deletes any existing filesystem pathname first, in order to cleanup\nany leftover socket file.\n\nThe server is of stream type by default, but this can be changed for\nanother type. For example datagram messages:\n```\nUNIXServer.new(\"/tmp/dgram.sock\", Socket::Type::DGRAM)\n```","summary":"<p>Creates a named UNIX socket, listening on a filesystem pathname.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"String"},{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"backlog","default_value":"128","external_name":"backlog","restriction":"Int"}],"args_string":"(path : String, type : Type = Type::STREAM, backlog : Int = 128)","args_html":"(path : <a href=\"String.html\">String</a>, type : <a href=\"Socket/Type.html\">Type</a> = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>, backlog : <a href=\"Int.html\">Int</a> = <span class=\"n\">128</span>)","location":{"filename":"src/socket/unix_server.cr","line_number":34,"url":null},"def":{"name":"new","args":[{"name":"path","external_name":"path","restriction":"String"},{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"backlog","default_value":"128","external_name":"backlog","restriction":"Int"}],"visibility":"Public","body":"_ = allocate\n_.initialize(path, type, backlog)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(*,fd:Handle,type:Type=Type::STREAM,path:String?=nil)-class-method","name":"new","doc":"Creates a UNIXServer from an already configured raw file descriptor","summary":"<p>Creates a UNIXServer from an already configured raw file descriptor</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"fd","external_name":"fd","restriction":"Handle"},{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"path","default_value":"nil","external_name":"path","restriction":"String | ::Nil"}],"args_string":"(*, fd : Handle, type : Type = Type::STREAM, path : String? = nil)","args_html":"(*, fd : Handle, type : <a href=\"Socket/Type.html\">Type</a> = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>, path : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/socket/unix_server.cr","line_number":50,"url":null},"def":{"name":"new","args":[{"name":"","external_name":"","restriction":""},{"name":"fd","external_name":"fd","restriction":"Handle"},{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"path","default_value":"nil","external_name":"path","restriction":"String | ::Nil"}],"splat_index":0,"visibility":"Public","body":"_ = allocate\n_.initialize(fd: fd, type: type, path: path)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"accept?:UNIXSocket?-instance-method","name":"accept?","doc":"Accepts an incoming connection.\n\nReturns the client socket or `nil` if the server is closed after invoking\nthis method.","summary":"<p>Accepts an incoming connection.</p>","abstract":false,"location":{"filename":"src/socket/unix_server.cr","line_number":71,"url":null},"def":{"name":"accept?","return_type":"UNIXSocket | ::Nil","visibility":"Public","body":"if client_fd = system_accept\n  sock = UNIXSocket.new(fd: client_fd, type: type, path: @path)\n  sock.sync = sync?\n  sock\nend"}},{"html_id":"close(delete=true):Nil-instance-method","name":"close","doc":"Closes the socket, then deletes the filesystem pathname if it exists.","summary":"<p>Closes the socket, then deletes the filesystem pathname if it exists.</p>","abstract":false,"args":[{"name":"delete","default_value":"true","external_name":"delete","restriction":""}],"args_string":"(delete = true) : Nil","args_html":"(delete = <span class=\"n\">true</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/socket/unix_server.cr","line_number":80,"url":null},"def":{"name":"close","args":[{"name":"delete","default_value":"true","external_name":"delete","restriction":""}],"return_type":"Nil","visibility":"Public","body":"begin\n  super()\nensure\n  if delete && (path = @path)\n    if File.exists?(path)\n      File.delete(path)\n    end\n    @path = nil\n  end\nend"}}]},{"html_id":"Crystal/UNIXSocket","path":"UNIXSocket.html","kind":"class","full_name":"UNIXSocket","name":"UNIXSocket","abstract":false,"superclass":{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},"ancestors":[{"html_id":"Crystal/Socket","kind":"class","full_name":"Socket","name":"Socket"},{"html_id":"Crystal/Crystal/System/Socket","kind":"module","full_name":"Crystal::System::Socket","name":"Socket"},{"html_id":"Crystal/IO/Evented","kind":"module","full_name":"IO::Evented","name":"Evented"},{"html_id":"Crystal/IO/Buffered","kind":"module","full_name":"IO::Buffered","name":"Buffered"},{"html_id":"Crystal/IO","kind":"class","full_name":"IO","name":"IO"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/socket/unix_socket.cr","line_number":14,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/UNIXServer","kind":"class","full_name":"UNIXServer","name":"UNIXServer"}],"doc":"A local interprocess communication clientsocket.\n\nOnly available on UNIX and UNIX-like operating systems.\n\nExample usage:\n```\nrequire \"socket\"\n\nsock = UNIXSocket.new(\"/tmp/myapp.sock\")\nsock.puts \"message\"\nresponse = sock.gets\nsock.close\n```","summary":"<p>A local interprocess communication clientsocket.</p>","class_methods":[{"html_id":"open(path,type:Type=Type::STREAM,&)-class-method","name":"open","doc":"Opens an UNIX socket to a filesystem pathname, yields it to the block, then\neventually closes the socket when the block returns.\n\nReturns the value of the block.","summary":"<p>Opens an UNIX socket to a filesystem pathname, yields it to the block, then eventually closes the socket when the block returns.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"args_string":"(path, type : Type = Type::STREAM, &)","args_html":"(path, type : <a href=\"Socket/Type.html\">Type</a> = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>, &)","location":{"filename":"src/socket/unix_socket.cr","line_number":40,"url":null},"def":{"name":"open","args":[{"name":"path","external_name":"path","restriction":""},{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"yields":1,"visibility":"Public","body":"sock = new(path, type)\nbegin\n  yield sock\nensure\n  sock.close\nend\n"}},{"html_id":"pair(type:Type=Type::STREAM):Tuple(UNIXSocket,UNIXSocket)-class-method","name":"pair","doc":"Returns a pair of unnamed UNIX sockets.\n\n```\nrequire \"socket\"\n\nleft, right = UNIXSocket.pair\n\nspawn do\n  # echo server\n  message = right.gets\n  right.puts message\nend\n\nleft.puts \"message\"\nleft.gets # => \"message\"\n```","summary":"<p>Returns a pair of unnamed UNIX sockets.</p>","abstract":false,"args":[{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"args_string":"(type : Type = Type::STREAM) : Tuple(UNIXSocket, UNIXSocket)","args_html":"(type : <a href=\"Socket/Type.html\">Type</a> = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>) : <a href=\"Tuple.html\">Tuple</a>(<a href=\"UNIXSocket.html\">UNIXSocket</a>, <a href=\"UNIXSocket.html\">UNIXSocket</a>)","location":{"filename":"src/socket/unix_socket.cr","line_number":65,"url":null},"def":{"name":"pair","args":[{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"return_type":"::Tuple(UNIXSocket, UNIXSocket)","visibility":"Public","body":"fds = uninitialized ::StaticArray(Int32, 2)\nsocktype = type.value\n{% if LibC.has_constant?(:SOCK_CLOEXEC) %}\n      socktype |= LibC::SOCK_CLOEXEC\n    {% end %}\nif (LibC.socketpair(Family::UNIX, socktype, 0, fds)) != 0\n  raise(Socket::Error.new(\"socketpair:\"))\nend\n{UNIXSocket.new(fd: fds[0], type: type), UNIXSocket.new(fd: fds[1], type: type)}\n"}},{"html_id":"pair(type:Type=Type::STREAM,&)-class-method","name":"pair","doc":"Creates a pair of unnamed UNIX sockets (see `pair`) and yields them to the\nblock. Eventually closes both sockets when the block returns.\n\nReturns the value of the block.","summary":"<p>Creates a pair of unnamed UNIX sockets (see <code><a href=\"UNIXSocket.html#pair%28type%3AType%3DType%3A%3ASTREAM%29%3ATuple%28UNIXSocket%2CUNIXSocket%29-class-method\">.pair</a></code>) and yields them to the block.</p>","abstract":false,"args":[{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"args_string":"(type : Type = Type::STREAM, &)","args_html":"(type : <a href=\"Socket/Type.html\">Type</a> = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>, &)","location":{"filename":"src/socket/unix_socket.cr","line_number":84,"url":null},"def":{"name":"pair","args":[{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"yields":2,"visibility":"Public","body":"left, right = pair(type)\nbegin\n  yield left, right\nensure\n  left.close\n  right.close\nend\n"}}],"constructors":[{"html_id":"new(path:String,type:Type=Type::STREAM)-class-method","name":"new","doc":"Connects a named UNIX socket, bound to a filesystem pathname.","summary":"<p>Connects a named UNIX socket, bound to a filesystem pathname.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"String"},{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"args_string":"(path : String, type : Type = Type::STREAM)","args_html":"(path : <a href=\"String.html\">String</a>, type : <a href=\"Socket/Type.html\">Type</a> = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>)","location":{"filename":"src/socket/unix_socket.cr","line_number":18,"url":null},"def":{"name":"new","args":[{"name":"path","external_name":"path","restriction":"String"},{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"}],"visibility":"Public","body":"_ = allocate\n_.initialize(path, type)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(*,fd:Handle,type:Type=Type::STREAM,path:String?=nil)-class-method","name":"new","doc":"Creates a UNIXSocket from an already configured raw file descriptor","summary":"<p>Creates a UNIXSocket from an already configured raw file descriptor</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"fd","external_name":"fd","restriction":"Handle"},{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"path","default_value":"nil","external_name":"path","restriction":"String | ::Nil"}],"args_string":"(*, fd : Handle, type : Type = Type::STREAM, path : String? = nil)","args_html":"(*, fd : Handle, type : <a href=\"Socket/Type.html\">Type</a> = <span class=\"t\">Type</span><span class=\"t\">::</span><span class=\"t\">STREAM</span>, path : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/socket/unix_socket.cr","line_number":32,"url":null},"def":{"name":"new","args":[{"name":"","external_name":"","restriction":""},{"name":"fd","external_name":"fd","restriction":"Handle"},{"name":"type","default_value":"Type::STREAM","external_name":"type","restriction":"Type"},{"name":"path","default_value":"nil","external_name":"path","restriction":"String | ::Nil"}],"splat_index":0,"visibility":"Public","body":"_ = allocate\n_.initialize(fd: fd, type: type, path: path)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"local_address:Socket::UNIXAddress-instance-method","name":"local_address","abstract":false,"location":{"filename":"src/socket/unix_socket.cr","line_number":94,"url":null},"def":{"name":"local_address","return_type":"Socket::UNIXAddress","visibility":"Public","body":"UNIXAddress.new(path.to_s)"}},{"html_id":"path:String?-instance-method","name":"path","abstract":false,"location":{"filename":"src/socket/unix_socket.cr","line_number":15,"url":null},"def":{"name":"path","return_type":"String | ::Nil","visibility":"Public","body":"@path"}},{"html_id":"receive-instance-method","name":"receive","doc":"Receives a text message from the previously bound address.\n\n```\nrequire \"socket\"\n\nserver = Socket.udp(Socket::Family::INET)\nserver.bind(\"localhost\", 1234)\n\nmessage, client_addr = server.receive\n```","summary":"<p>Receives a text message from the previously bound address.</p>","abstract":false,"location":{"filename":"src/socket/unix_socket.cr","line_number":102,"url":null},"def":{"name":"receive","visibility":"Public","body":"bytes_read, sockaddr, addrlen = recvfrom\n{bytes_read, UNIXAddress.from(sockaddr, addrlen)}\n"}},{"html_id":"remote_address:Socket::UNIXAddress-instance-method","name":"remote_address","abstract":false,"location":{"filename":"src/socket/unix_socket.cr","line_number":98,"url":null},"def":{"name":"remote_address","return_type":"Socket::UNIXAddress","visibility":"Public","body":"UNIXAddress.new(path.to_s)"}}]},{"html_id":"Crystal/URI","path":"URI.html","kind":"class","full_name":"URI","name":"URI","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/uri.cr","line_number":73,"url":null},{"filename":"src/uri/encoding.cr","line_number":1,"url":null},{"filename":"src/uri/params.cr","line_number":3,"url":null},{"filename":"src/uri/punycode.cr","line_number":1,"url":null},{"filename":"src/uri/uri_parser.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"This class represents a URI reference as defined by [RFC 3986: Uniform Resource Identifier\n(URI): Generic Syntax](https://www.ietf.org/rfc/rfc3986.txt).\n\nThis class provides constructors for creating URI instances from\ntheir components or by parsing their string forms and methods for accessing the various\ncomponents of an instance.\n\nBasic example:\n\n```\nrequire \"uri\"\n\nuri = URI.parse \"http://foo.com/posts?id=30&limit=5#time=1305298413\"\n# => #<URI:0x1003f1e40 @scheme=\"http\", @host=\"foo.com\", @port=nil, @path=\"/posts\", @query=\"id=30&limit=5\", ... >\nuri.scheme # => \"http\"\nuri.host   # => \"foo.com\"\nuri.query  # => \"id=30&limit=5\"\nuri.to_s   # => \"http://foo.com/posts?id=30&limit=5#time=1305298413\"\n```\n\n## Resolution and Relativization\n\n*Resolution* is the process of resolving one URI against another, *base* URI.\nThe resulting URI is constructed from components of both URIs in the manner specified by\n[RFC 3986 section 5.2](https://tools.ietf.org/html/rfc3986#section-5.2.2), taking components\nfrom the base URI for those not specified in the original.\nFor hierarchical URIs, the path of the original is resolved against the path of the base\nand then normalized. See `#resolve` for examples.\n\n*Relativization* is the inverse of resolution as that it procures an URI that\nresolves to the original when resolved against the base.\n\nFor normalized URIs, the following is true:\n\n```\na.relativize(a.resolve(b)) # => b\na.resolve(a.relativize(b)) # => b\n```\n\nThis operation is often useful when constructing a document containing URIs that must\nbe made relative to the base URI of the document wherever possible.\n\n# URL Encoding\n\nThis class provides a number of methods for encoding and decoding strings using\nURL Encoding (also known as Percent Encoding) as defined in [RFC 3986](https://www.ietf.org/rfc/rfc3986.txt)\nas well as [`x-www-form-urlencoded`](https://url.spec.whatwg.org/#urlencoded-serializing).\n\nEach method has two variants, one returns a string, the other writes directly\nto an IO.\n\n* `.decode(string : String, *, plus_to_space : Bool = false) : String`: Decodes a URL-encoded string.\n* `.decode(string : String, io : IO, *, plus_to_space : Bool = false) : Nil`: Decodes a URL-encoded string to an IO.\n* `.encode_path(string : String) : String`: URL-encodes a string.\n* `.encode_path(string : String, io : IO) : Nil`: URL-encodes a string to an IO.\n* `.encode_path_segment(string : String) : String`: URL-encodes a string, escaping `/`.\n* `.encode_path_segment(string : String, io : IO) : Nil`: URL-encodes a string to an IO, escaping `/`.\n* `.decode_www_form(string : String, *, plus_to_space : Bool = true) : String`: Decodes an `x-www-form-urlencoded` string component.\n* `.decode_www_form(string : String, io : IO, *, plus_to_space : Bool = true) : Nil`: Decodes an `x-www-form-urlencoded` string component to an IO.\n* `.encode_www_form(string : String, *, space_to_plus : Bool = true) : String`: Encodes a string as a `x-www-form-urlencoded` component.\n* `.encode_www_form(string : String, io : IO, *, space_to_plus : Bool = true) : Nil`: Encodes a string as a `x-www-form-urlencoded` component to an IO.\n\n`.encode_www_form` encodes white space (` `) as `+`, while `.encode_path`\nand `.encode_path_segment` encode it as `%20`. The decode methods differ regarding\nthe handling of `+` characters, respectively.\n\nNOTE: `URI::Params` provides a higher-level API for handling `x-www-form-urlencoded`\nserialized data.","summary":"<p>This class represents a URI reference as defined by <a href=\"https://www.ietf.org/rfc/rfc3986.txt\">RFC 3986: Uniform Resource Identifier (URI): Generic Syntax</a>.</p>","class_methods":[{"html_id":"decode(string:String,io:IO,*,plus_to_space:Bool=false):Nil-class-method","name":"decode","doc":"URL-decodes a string and writes the result to *io*.\n\nSee `.decode(string : String, *, plus_to_space : Bool = false) : String` for details.","summary":"<p>URL-decodes a string and writes the result to <em>io</em>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"io","external_name":"io","restriction":"IO"},{"name":"","external_name":"","restriction":""},{"name":"plus_to_space","default_value":"false","external_name":"plus_to_space","restriction":"Bool"}],"args_string":"(string : String, io : IO, *, plus_to_space : Bool = false) : Nil","args_html":"(string : <a href=\"String.html\">String</a>, io : <a href=\"IO.html\">IO</a>, *, plus_to_space : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/uri/encoding.cr","line_number":86,"url":null},"def":{"name":"decode","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"io","external_name":"io","restriction":"IO"},{"name":"","external_name":"","restriction":""},{"name":"plus_to_space","default_value":"false","external_name":"plus_to_space","restriction":"Bool"}],"splat_index":2,"return_type":"Nil","visibility":"Public","body":"self.decode(string, io, plus_to_space: plus_to_space) do\n  false\nend"}},{"html_id":"decode(string:String,*,plus_to_space:Bool=false):String-class-method","name":"decode","doc":"URL-decodes *string*.\n\n```\nrequire \"uri\"\n\nURI.decode(\"hello%20world!\")                                 # => \"hello world!\"\nURI.decode(\"put:%20it+%D0%B9\")                               # => \"put: it+й\"\nURI.decode(\"http://example.com/Crystal%20is%20awesome%20=)\") # => \"http://example.com/Crystal is awesome =)\"\n```\n\nBy default, `+` is decoded literally. If *plus_to_space* is `true`, `+` is\ndecoded as space character (`0x20`). Percent-encoded values such as `%20`\nand `%2B` are always decoded as characters with the respective codepoint.\n\n```\nrequire \"uri\"\n\nURI.decode(\"peter+%2B+paul\")                      # => \"peter+++paul\"\nURI.decode(\"peter+%2B+paul\", plus_to_space: true) # => \"peter + paul\"\n```\n\n* `.encode` is the reverse operation.\n* `.decode_www_form` encodes plus to space by default.","summary":"<p>URL-decodes <em>string</em>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"","external_name":"","restriction":""},{"name":"plus_to_space","default_value":"false","external_name":"plus_to_space","restriction":"Bool"}],"args_string":"(string : String, *, plus_to_space : Bool = false) : String","args_html":"(string : <a href=\"String.html\">String</a>, *, plus_to_space : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/uri/encoding.cr","line_number":79,"url":null},"def":{"name":"decode","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"","external_name":"","restriction":""},{"name":"plus_to_space","default_value":"false","external_name":"plus_to_space","restriction":"Bool"}],"splat_index":1,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  decode(string, io, plus_to_space: plus_to_space)\nend"}},{"html_id":"decode(string:String,io:IO,*,plus_to_space:Bool=false,&):Nil-class-method","name":"decode","doc":"URL-decodes *string* and writes the result to *io*.\n\nThe block is called for each percent-encoded ASCII character and determines\nwhether the value is to be decoded. When the return value is falsey,\nthe character is decoded. Non-ASCII characters are always decoded.\n\nBy default, `+` is decoded literally. If *plus_to_space* is `true`, `+` is\ndecoded as space character (`0x20`).\n\nThis method enables some customization, but typical use cases can be implemented\nby either `.decode(string : String, *, plus_to_space : Bool = false) : String` or\n`.decode_www_form(string : String, *, plus_to_space : Bool = true) : String`.","summary":"<p>URL-decodes <em>string</em> and writes the result to <em>io</em>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"io","external_name":"io","restriction":"IO"},{"name":"","external_name":"","restriction":""},{"name":"plus_to_space","default_value":"false","external_name":"plus_to_space","restriction":"Bool"}],"args_string":"(string : String, io : IO, *, plus_to_space : Bool = false, &) : Nil","args_html":"(string : <a href=\"String.html\">String</a>, io : <a href=\"IO.html\">IO</a>, *, plus_to_space : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/uri/encoding.cr","line_number":259,"url":null},"def":{"name":"decode","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"io","external_name":"io","restriction":"IO"},{"name":"","external_name":"","restriction":""},{"name":"plus_to_space","default_value":"false","external_name":"plus_to_space","restriction":"Bool"}],"splat_index":2,"yields":1,"return_type":"Nil","visibility":"Public","body":"i = 0\nbytesize = string.bytesize\nbuffer = IO::Memory.new(bytesize)\nwhile i < bytesize\n  byte = string.to_unsafe[i]\n  char = byte.unsafe_chr\n  i = decode_one(string, bytesize, i, byte, char, buffer, plus_to_space) do |byte|\n    yield byte\n  end\nend\nio.write_string(buffer.to_slice)\n"}},{"html_id":"decode_www_form(string:String,io:IO,*,plus_to_space:Bool=true):Nil-class-method","name":"decode_www_form","doc":"URL-decodes *string* as [`x-www-form-urlencoded`](https://url.spec.whatwg.org/#urlencoded-serializing)\nand writes the result to *io*.\n\nSee `self.decode_www_form(string : String, *, plus_to_space : Bool = true) : String`\nfor details.","summary":"<p>URL-decodes <em>string</em> as <a href=\"https://url.spec.whatwg.org/#urlencoded-serializing\"><code>x-www-form-urlencoded</code></a> and writes the result to <em>io</em>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"io","external_name":"io","restriction":"IO"},{"name":"","external_name":"","restriction":""},{"name":"plus_to_space","default_value":"true","external_name":"plus_to_space","restriction":"Bool"}],"args_string":"(string : String, io : IO, *, plus_to_space : Bool = true) : Nil","args_html":"(string : <a href=\"String.html\">String</a>, io : <a href=\"IO.html\">IO</a>, *, plus_to_space : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/uri/encoding.cr","line_number":162,"url":null},"def":{"name":"decode_www_form","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"io","external_name":"io","restriction":"IO"},{"name":"","external_name":"","restriction":""},{"name":"plus_to_space","default_value":"true","external_name":"plus_to_space","restriction":"Bool"}],"splat_index":2,"return_type":"Nil","visibility":"Public","body":"decode(string, io, plus_to_space: plus_to_space)"}},{"html_id":"decode_www_form(string:String,*,plus_to_space:Bool=true):String-class-method","name":"decode_www_form","doc":"URL-decodes *string* as [`x-www-form-urlencoded`](https://url.spec.whatwg.org/#urlencoded-serializing).\n\n```\nrequire \"uri\"\n\nURI.decode_www_form(\"hello%20world!\")                           # => \"hello world!\"\nURI.decode_www_form(\"put:%20it+%D0%B9\")                         # => \"put: it й\"\nURI.decode_www_form(\"http://example.com/Crystal+is+awesome+=)\") # => \"http://example.com/Crystal is awesome =)\"\n```\n\nBy default, `+` is decoded as space character (`0x20`). If *plus_to_space*\nis `false`, `+` is decoded literally as `+`. Percent-encoded values such as\n`%20` and `%2B` are always decoded as characters with the respective codepoint.\n\n```\nrequire \"uri\"\n\nURI.decode_www_form(\"peter+%2B+paul\")                       # => \"peter + paul\"\nURI.decode_www_form(\"peter+%2B+paul\", plus_to_space: false) # => \"peter+++paul\"\n```\n\n* `.encode_www_form` is the reverse operation.\n* `.decode` encodes plus literally by default.","summary":"<p>URL-decodes <em>string</em> as <a href=\"https://url.spec.whatwg.org/#urlencoded-serializing\"><code>x-www-form-urlencoded</code></a>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"","external_name":"","restriction":""},{"name":"plus_to_space","default_value":"true","external_name":"plus_to_space","restriction":"Bool"}],"args_string":"(string : String, *, plus_to_space : Bool = true) : String","args_html":"(string : <a href=\"String.html\">String</a>, *, plus_to_space : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/uri/encoding.cr","line_number":153,"url":null},"def":{"name":"decode_www_form","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"","external_name":"","restriction":""},{"name":"plus_to_space","default_value":"true","external_name":"plus_to_space","restriction":"Bool"}],"splat_index":1,"return_type":"String","visibility":"Public","body":"decode(string, plus_to_space: plus_to_space)"}},{"html_id":"default_port(scheme:String):Int32?-class-method","name":"default_port","doc":"Returns the default port for the given *scheme* if known,\notherwise returns `nil`.\n\n```\nrequire \"uri\"\n\nURI.default_port \"http\"  # => 80\nURI.default_port \"ponzi\" # => nil\n```","summary":"<p>Returns the default port for the given <em>scheme</em> if known, otherwise returns <code>nil</code>.</p>","abstract":false,"args":[{"name":"scheme","external_name":"scheme","restriction":"String"}],"args_string":"(scheme : String) : Int32?","args_html":"(scheme : <a href=\"String.html\">String</a>) : <a href=\"Int32.html\">Int32</a>?","location":{"filename":"src/uri.cr","line_number":697,"url":null},"def":{"name":"default_port","args":[{"name":"scheme","external_name":"scheme","restriction":"String"}],"return_type":"Int32 | ::Nil","visibility":"Public","body":"@@default_ports[scheme.downcase]?"}},{"html_id":"encode(string:String,io:IO,*,space_to_plus:Bool=false):Nil-class-method","name":"encode","doc":"URL-encodes *string* and writes the result to *io*.\n\nSee `.encode(string : String, *, space_to_plus : Bool = false) : String` for details.","summary":"<p>URL-encodes <em>string</em> and writes the result to <em>io</em>.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"URI.html#encode_path%28io%3AIO%2Cstring%3AString%29%3ANil-class-method\">.encode_path</a></code> instead.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"io","external_name":"io","restriction":"IO"},{"name":"","external_name":"","restriction":""},{"name":"space_to_plus","default_value":"false","external_name":"space_to_plus","restriction":"Bool"}],"args_string":"(string : String, io : IO, *, space_to_plus : Bool = false) : Nil","args_html":"(string : <a href=\"String.html\">String</a>, io : <a href=\"IO.html\">IO</a>, *, space_to_plus : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/uri/encoding.cr","line_number":126,"url":null},"def":{"name":"encode","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"io","external_name":"io","restriction":"IO"},{"name":"","external_name":"","restriction":""},{"name":"space_to_plus","default_value":"false","external_name":"space_to_plus","restriction":"Bool"}],"splat_index":2,"return_type":"Nil","visibility":"Public","body":"self.encode(string, io, space_to_plus: space_to_plus) do |byte|\n  (URI.reserved?(byte)) || (URI.unreserved?(byte))\nend"}},{"html_id":"encode(string:String,*,space_to_plus:Bool=false):String-class-method","name":"encode","doc":"URL-encodes *string*.\n\nReserved and unreserved characters are not escaped, so this only modifies some\nspecial characters as well as non-ASCII characters. `.reserved?` and `.unreserved?`\nprovide more details on these character classes.\n\n```\nrequire \"uri\"\n\nURI.encode(\"hello world!\")                             # => \"hello%20world!\"\nURI.encode(\"put: it+й\")                                # => \"put:%20it+%D0%B9\"\nURI.encode(\"http://example.com/Crystal is awesome =)\") # => \"http://example.com/Crystal%20is%20awesome%20=)\"\n```\n\nBy default, the space character (`0x20`) is encoded as `%20` and `+` is\nencoded literally. If *space_to_plus* is `true`, space character is encoded\nas `+` and `+` is encoded as `%2B`:\n\n```\nrequire \"uri\"\n\nURI.encode(\"peter + paul\")                      # => \"peter%20+%20paul\"\nURI.encode(\"peter + paul\", space_to_plus: true) # => \"peter+%2B+paul\"\n```\n\n* `.decode` is the reverse operation.\n* `.encode_www_form` also escapes reserved characters.","summary":"<p>URL-encodes <em>string</em>.</p>\n<p><span class=\"flag red\">DEPRECATED</span>  Use <code><a href=\"URI.html#encode_path%28io%3AIO%2Cstring%3AString%29%3ANil-class-method\">.encode_path</a></code> instead.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"","external_name":"","restriction":""},{"name":"space_to_plus","default_value":"false","external_name":"space_to_plus","restriction":"Bool"}],"args_string":"(string : String, *, space_to_plus : Bool = false) : String","args_html":"(string : <a href=\"String.html\">String</a>, *, space_to_plus : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/uri/encoding.cr","line_number":118,"url":null},"def":{"name":"encode","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"","external_name":"","restriction":""},{"name":"space_to_plus","default_value":"false","external_name":"space_to_plus","restriction":"Bool"}],"splat_index":1,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  encode(string, io, space_to_plus: space_to_plus)\nend"}},{"html_id":"encode(string:String,io:IO,space_to_plus:Bool=false,&):Nil-class-method","name":"encode","doc":"URL-encodes *string* and writes the result to an `IO`.\n\nThe block is called for each ascii character (codepoint less than `0x80`) and\ndetermines whether the value is to be encoded. When the return value is falsey,\nthe character is encoded. Non-ASCII characters are always encoded.\n\nBy default, the space character (`0x20`) is encoded as `%20` and `+` is\nencoded literally. If *space_to_plus* is `true`, space character is encoded\nas `+` and `+` is encoded as `%2B`.\n\nThis method enables some customization, but typical use cases can be implemented\nby either `.encode_path(string : String) : String`, `.encode_path_segment(string : String) : String` or\n`.encode_www_form(string : String, *, space_to_plus : Bool = true) : String`.","summary":"<p>URL-encodes <em>string</em> and writes the result to an <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"io","external_name":"io","restriction":"IO"},{"name":"space_to_plus","default_value":"false","external_name":"space_to_plus","restriction":"Bool"}],"args_string":"(string : String, io : IO, space_to_plus : Bool = false, &) : Nil","args_html":"(string : <a href=\"String.html\">String</a>, io : <a href=\"IO.html\">IO</a>, space_to_plus : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">false</span>, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/uri/encoding.cr","line_number":286,"url":null},"def":{"name":"encode","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"io","external_name":"io","restriction":"IO"},{"name":"space_to_plus","default_value":"false","external_name":"space_to_plus","restriction":"Bool"}],"yields":1,"return_type":"Nil","visibility":"Public","body":"string.each_byte do |byte|\n  char = byte.unsafe_chr\n  if (char == ' ') && space_to_plus\n    io << '+'\n  else\n    if (char.ascii? && (yield(byte))) && ((!space_to_plus) || (char != '+'))\n      io << char\n    else\n      io << '%'\n      if byte < 16\n        io << '0'\n      end\n      byte.to_s(io, 16, upcase: true)\n    end\n  end\nend\nio\n"}},{"html_id":"encode_path(io:IO,string:String):Nil-class-method","name":"encode_path","doc":"Encodes *string* so it can be safely placed as a potentially multi-segmented\nURI path, replacing special characters with URI escape sequences as needed.\n\nUnreserved characters such as ASCII letters, digits, and the characters\n`_.-~` are not encoded, as well as the character `/` which represent a\nsegment separator in hierarchical paths ([RFC 3986 §3.3](https://datatracker.ietf.org/doc/html/rfc3986#section-3.3)).\n\n```\nrequire \"uri\"\n\nURI.encode_path(\"foo/bar/baz\")  # => \"foo/bar/baz\"\nURI.encode_path(\"hello world!\") # => \"hello%20world%21\"\nURI.encode_path(\"put: it+й\")    # => \"put%3A%20it%2B%D0%B9\"\n```\n\n* `.decode` is the reverse operation.\n* `.encode_path_segment` encodes a single path segment, escaping `/`.","summary":"<p>Encodes <em>string</em> so it can be safely placed as a potentially multi-segmented URI path, replacing special characters with URI escape sequences as needed.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(io : IO, string : String) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, string : <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/uri/encoding.cr","line_number":24,"url":null},"def":{"name":"encode_path","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"string","external_name":"string","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"self.encode(string, io) do |byte|\n  (URI.unreserved?(byte)) || ('/' === byte)\nend"}},{"html_id":"encode_path(string:String):String-class-method","name":"encode_path","doc":"Encodes *string* so it can be safely placed as a potentially multi-segmented\nURI path, replacing special characters with URI escape sequences as needed.\n\nUnreserved characters such as ASCII letters, digits, and the characters\n`_.-~` are not encoded, as well as the character `/` which represent a\nsegment separator in hierarchical paths ([RFC 3986 §3.3](https://datatracker.ietf.org/doc/html/rfc3986#section-3.3)).\n\n```\nrequire \"uri\"\n\nURI.encode_path(\"foo/bar/baz\")  # => \"foo/bar/baz\"\nURI.encode_path(\"hello world!\") # => \"hello%20world%21\"\nURI.encode_path(\"put: it+й\")    # => \"put%3A%20it%2B%D0%B9\"\n```\n\n* `.decode` is the reverse operation.\n* `.encode_path_segment` encodes a single path segment, escaping `/`.","summary":"<p>Encodes <em>string</em> so it can be safely placed as a potentially multi-segmented URI path, replacing special characters with URI escape sequences as needed.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String) : String","args_html":"(string : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/uri/encoding.cr","line_number":19,"url":null},"def":{"name":"encode_path","args":[{"name":"string","external_name":"string","restriction":"String"}],"return_type":"String","visibility":"Public","body":"String.build do |io|\n  encode_path(io, string)\nend"}},{"html_id":"encode_path_segment(io:IO,string:String):Nil-class-method","name":"encode_path_segment","doc":"Encodes *string* so it can be safely placed inside a URI path segment,\nreplacing special characters (including `/`) with URI escape sequences as needed.\n\nUnreserved characters such as ASCII letters, digits, and the characters\n`_.-~` are not encoded (see `.unreserved?`).\n\n```\nrequire \"uri\"\n\nURI.encode_path_segment(\"foo;bar;baz\")  # => \"foo%3Bbar%3Bbaz\"\nURI.encode_path_segment(\"foo/bar/baz\")  # => \"foo%2Fbar%2Fbaz\"\nURI.encode_path_segment(\"foo,bar,baz\")  # => \"foo%2Cbar%2Cbaz\"\nURI.encode_path_segment(\"hello world!\") # => \"hello%20world%21\"\nURI.encode_path_segment(\"put: it+й\")    # => \"put%3A%20it%2B%D0%B9\"\n```\n\n* `.decode` is the reverse operation.\n* `.encode_path` encodes a path consisting of multiple segments, not escaping `/`.\n* `.encode_www_form` escapes space character as `+`.","summary":"<p>Encodes <em>string</em> so it can be safely placed inside a URI path segment, replacing special characters (including <code>/</code>) with URI escape sequences as needed.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(io : IO, string : String) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, string : <a href=\"String.html\">String</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/uri/encoding.cr","line_number":52,"url":null},"def":{"name":"encode_path_segment","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"string","external_name":"string","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"self.encode(string, io) do |byte|\n  URI.unreserved?(byte)\nend"}},{"html_id":"encode_path_segment(string:String):String-class-method","name":"encode_path_segment","doc":"Encodes *string* so it can be safely placed inside a URI path segment,\nreplacing special characters (including `/`) with URI escape sequences as needed.\n\nUnreserved characters such as ASCII letters, digits, and the characters\n`_.-~` are not encoded (see `.unreserved?`).\n\n```\nrequire \"uri\"\n\nURI.encode_path_segment(\"foo;bar;baz\")  # => \"foo%3Bbar%3Bbaz\"\nURI.encode_path_segment(\"foo/bar/baz\")  # => \"foo%2Fbar%2Fbaz\"\nURI.encode_path_segment(\"foo,bar,baz\")  # => \"foo%2Cbar%2Cbaz\"\nURI.encode_path_segment(\"hello world!\") # => \"hello%20world%21\"\nURI.encode_path_segment(\"put: it+й\")    # => \"put%3A%20it%2B%D0%B9\"\n```\n\n* `.decode` is the reverse operation.\n* `.encode_path` encodes a path consisting of multiple segments, not escaping `/`.\n* `.encode_www_form` escapes space character as `+`.","summary":"<p>Encodes <em>string</em> so it can be safely placed inside a URI path segment, replacing special characters (including <code>/</code>) with URI escape sequences as needed.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String) : String","args_html":"(string : <a href=\"String.html\">String</a>) : <a href=\"String.html\">String</a>","location":{"filename":"src/uri/encoding.cr","line_number":47,"url":null},"def":{"name":"encode_path_segment","args":[{"name":"string","external_name":"string","restriction":"String"}],"return_type":"String","visibility":"Public","body":"String.build do |io|\n  encode_path_segment(io, string)\nend"}},{"html_id":"encode_www_form(string:String,io:IO,*,space_to_plus:Bool=true):Nil-class-method","name":"encode_www_form","doc":"URL-encodes *string* as [`x-www-form-urlencoded`](https://url.spec.whatwg.org/#urlencoded-serializing)\nand writes the result to *io*.\n\nSee `.encode_www_form(string : String, *, space_to_plus : Bool = true)` for\ndetails.","summary":"<p>URL-encodes <em>string</em> as <a href=\"https://url.spec.whatwg.org/#urlencoded-serializing\"><code>x-www-form-urlencoded</code></a> and writes the result to <em>io</em>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"io","external_name":"io","restriction":"IO"},{"name":"","external_name":"","restriction":""},{"name":"space_to_plus","default_value":"true","external_name":"space_to_plus","restriction":"Bool"}],"args_string":"(string : String, io : IO, *, space_to_plus : Bool = true) : Nil","args_html":"(string : <a href=\"String.html\">String</a>, io : <a href=\"IO.html\">IO</a>, *, space_to_plus : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/uri/encoding.cr","line_number":208,"url":null},"def":{"name":"encode_www_form","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"io","external_name":"io","restriction":"IO"},{"name":"","external_name":"","restriction":""},{"name":"space_to_plus","default_value":"true","external_name":"space_to_plus","restriction":"Bool"}],"splat_index":2,"return_type":"Nil","visibility":"Public","body":"encode(string, io, space_to_plus: space_to_plus) do |byte|\n  URI.unreserved?(byte)\nend"}},{"html_id":"encode_www_form(string:String,*,space_to_plus:Bool=true):String-class-method","name":"encode_www_form","doc":"URL-encodes *string* as [`x-www-form-urlencoded`](https://url.spec.whatwg.org/#urlencoded-serializing).\n\nReserved characters are escaped, unreserved characters are not.\n`.reserved?` and `.unreserved?` provide more details on these character\nclasses.\n\n```\nrequire \"uri\"\n\nURI.encode_www_form(\"hello world!\")                             # => \"hello+world%21\"\nURI.encode_www_form(\"put: it+й\")                                # => \"put%3A+it%2B%D0%B9\"\nURI.encode_www_form(\"http://example.com/Crystal is awesome =)\") # => \"http%3A%2F%2Fexample.com%2FCrystal+is+awesome+%3D%29\"\n```\n\nThe encoded string returned from this method can be used as name or value\ncomponents for a `application/x-www-form-urlencoded` format serialization.\n`URI::Params` provides a higher-level API for this use case.\n\nBy default, the space character (`0x20`) is encoded as `+` and `+` is encoded\nas `%2B`. If *space_to_plus* is `false`, space character is encoded as `%20`\nand `'+'` is encoded literally.\n\n```\nrequire \"uri\"\n\nURI.encode_www_form(\"peter + paul\")                       # => \"peter+%2B+paul\"\nURI.encode_www_form(\"peter + paul\", space_to_plus: false) # => \"peter%20%2B%20paul\"\n```\n\n* `.decode_www_form` is the reverse operation.\n* `.encode_path` escapes space character as `%20`.","summary":"<p>URL-encodes <em>string</em> as <a href=\"https://url.spec.whatwg.org/#urlencoded-serializing\"><code>x-www-form-urlencoded</code></a>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"","external_name":"","restriction":""},{"name":"space_to_plus","default_value":"true","external_name":"space_to_plus","restriction":"Bool"}],"args_string":"(string : String, *, space_to_plus : Bool = true) : String","args_html":"(string : <a href=\"String.html\">String</a>, *, space_to_plus : <a href=\"Bool.html\">Bool</a> = <span class=\"n\">true</span>) : <a href=\"String.html\">String</a>","location":{"filename":"src/uri/encoding.cr","line_number":197,"url":null},"def":{"name":"encode_www_form","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"","external_name":"","restriction":""},{"name":"space_to_plus","default_value":"true","external_name":"space_to_plus","restriction":"Bool"}],"splat_index":1,"return_type":"String","visibility":"Public","body":"String.build do |io|\n  encode_www_form(string, io, space_to_plus: space_to_plus)\nend"}},{"html_id":"reserved?(byte):Bool-class-method","name":"reserved?","doc":"Returns whether given byte is reserved character defined in\n[RFC 3986 §2.2](https://datatracker.ietf.org/doc/html/rfc3986#section-2.2).\n\nReserved characters are ':', '/', '?', '#', '[', ']', '@', '!',\n'$', '&', \"'\", '(', ')', '*', '+', ',', ';' and '='.","summary":"<p>Returns whether given byte is reserved character defined in <a href=\"https://datatracker.ietf.org/doc/html/rfc3986#section-2.2\">RFC 3986 §2.2</a>.</p>","abstract":false,"args":[{"name":"byte","external_name":"byte","restriction":""}],"args_string":"(byte) : Bool","args_html":"(byte) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/uri/encoding.cr","line_number":219,"url":null},"def":{"name":"reserved?","args":[{"name":"byte","external_name":"byte","restriction":""}],"return_type":"Bool","visibility":"Public","body":"(sub_delim?(byte)) || (gen_delim?(byte))"}},{"html_id":"set_default_port(scheme:String,port:Int32?):Nil-class-method","name":"set_default_port","doc":"Registers the default port for the given *scheme*.\n\nIf *port* is `nil`, the existing default port for the\n*scheme*, if any, will be unregistered.\n\n```\nrequire \"uri\"\n\nURI.set_default_port \"ponzi\", 9999\n```","summary":"<p>Registers the default port for the given <em>scheme</em>.</p>","abstract":false,"args":[{"name":"scheme","external_name":"scheme","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int32 | ::Nil"}],"args_string":"(scheme : String, port : Int32?) : Nil","args_html":"(scheme : <a href=\"String.html\">String</a>, port : <a href=\"Int32.html\">Int32</a>?) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/uri.cr","line_number":711,"url":null},"def":{"name":"set_default_port","args":[{"name":"scheme","external_name":"scheme","restriction":"String"},{"name":"port","external_name":"port","restriction":"Int32 | ::Nil"}],"return_type":"Nil","visibility":"Public","body":"if port\n  @@default_ports[scheme.downcase] = port\nelse\n  @@default_ports.delete(scheme.downcase)\nend"}},{"html_id":"unreserved?(byte):Bool-class-method","name":"unreserved?","doc":"Returns whether given byte is unreserved character defined in\n[RFC 3986 §2.3](https://datatracker.ietf.org/doc/html/rfc3986#section-2.3).\n\nUnreserved characters are ASCII letters, ASCII digits, `_`, `.`, `-` and `~`.","summary":"<p>Returns whether given byte is unreserved character defined in <a href=\"https://datatracker.ietf.org/doc/html/rfc3986#section-2.3\">RFC 3986 §2.3</a>.</p>","abstract":false,"args":[{"name":"byte","external_name":"byte","restriction":""}],"args_string":"(byte) : Bool","args_html":"(byte) : <a href=\"Bool.html\">Bool</a>","location":{"filename":"src/uri/encoding.cr","line_number":241,"url":null},"def":{"name":"unreserved?","args":[{"name":"byte","external_name":"byte","restriction":""}],"return_type":"Bool","visibility":"Public","body":"char = byte.unsafe_chr\nchar.ascii_alphanumeric? || (char.in?('_', '.', '-', '~'))\n"}},{"html_id":"unwrap_ipv6(host):String-class-method","name":"unwrap_ipv6","doc":"Unwraps IPv6 address wrapped in square brackets.\n\nEverything that is not wrapped in square brackets is returned unchanged.\n\n```\nURI.unwrap_ipv6(\"[::1]\")       # => \"::1\"\nURI.unwrap_ipv6(\"127.0.0.1\")   # => \"127.0.0.1\"\nURI.unwrap_ipv6(\"example.com\") # => \"example.com\"\n```","summary":"<p>Unwraps IPv6 address wrapped in square brackets.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":""}],"args_string":"(host) : String","args_html":"(host) : <a href=\"String.html\">String</a>","location":{"filename":"src/uri.cr","line_number":201,"url":null},"def":{"name":"unwrap_ipv6","args":[{"name":"host","external_name":"host","restriction":""}],"return_type":"String","visibility":"Public","body":"if (host.starts_with?('[')) && (host.ends_with?(']'))\n  host.byte_slice(1, host.bytesize - 2)\nelse\n  host\nend"}}],"constructors":[{"html_id":"new(scheme=nil,host=nil,port=nil,path=\"\",query:String|Params|Nil=nil,user=nil,password=nil,fragment=nil)-class-method","name":"new","abstract":false,"args":[{"name":"scheme","default_value":"nil","external_name":"scheme","restriction":""},{"name":"host","default_value":"nil","external_name":"host","restriction":""},{"name":"port","default_value":"nil","external_name":"port","restriction":""},{"name":"path","default_value":"\"\"","external_name":"path","restriction":""},{"name":"query","default_value":"nil","external_name":"query","restriction":"String | Params | Nil"},{"name":"user","default_value":"nil","external_name":"user","restriction":""},{"name":"password","default_value":"nil","external_name":"password","restriction":""},{"name":"fragment","default_value":"nil","external_name":"fragment","restriction":""}],"args_string":"(scheme = nil, host = nil, port = nil, path = \"\", query : String | Params | Nil = nil, user = nil, password = nil, fragment = nil)","args_html":"(scheme = <span class=\"n\">nil</span>, host = <span class=\"n\">nil</span>, port = <span class=\"n\">nil</span>, path = <span class=\"s\">&quot;&quot;</span>, query : <a href=\"String.html\">String</a> | <a href=\"URI/Params.html\">Params</a> | <a href=\"Nil.html\">Nil</a> = <span class=\"n\">nil</span>, user = <span class=\"n\">nil</span>, password = <span class=\"n\">nil</span>, fragment = <span class=\"n\">nil</span>)","location":{"filename":"src/uri.cr","line_number":176,"url":null},"def":{"name":"new","args":[{"name":"scheme","default_value":"nil","external_name":"scheme","restriction":""},{"name":"host","default_value":"nil","external_name":"host","restriction":""},{"name":"port","default_value":"nil","external_name":"port","restriction":""},{"name":"path","default_value":"\"\"","external_name":"path","restriction":""},{"name":"query","default_value":"nil","external_name":"query","restriction":"String | Params | Nil"},{"name":"user","default_value":"nil","external_name":"user","restriction":""},{"name":"password","default_value":"nil","external_name":"password","restriction":""},{"name":"fragment","default_value":"nil","external_name":"fragment","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(scheme, host, port, path, query, user, password, fragment)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"parse(raw_url:String):URI-class-method","name":"parse","doc":"Parses the given *raw_url* into an URI. The *raw_url* may be relative or absolute.\n\n```\nrequire \"uri\"\n\nuri = URI.parse(\"http://crystal-lang.org\") # => #<URI:0x1068a7e40 @scheme=\"http\", @host=\"crystal-lang.org\", ... >\nuri.scheme                                 # => \"http\"\nuri.host                                   # => \"crystal-lang.org\"\n```","summary":"<p>Parses the given <em>raw_url</em> into an URI.</p>","abstract":false,"args":[{"name":"raw_url","external_name":"raw_url","restriction":"String"}],"args_string":"(raw_url : String) : URI","args_html":"(raw_url : <a href=\"String.html\">String</a>) : <a href=\"URI.html\">URI</a>","location":{"filename":"src/uri.cr","line_number":553,"url":null},"def":{"name":"parse","args":[{"name":"raw_url","external_name":"raw_url","restriction":"String"}],"return_type":"URI","visibility":"Public","body":"(URI::Parser.new(raw_url)).run.uri"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","doc":"Returns `true` if this reference is the same as *other*. Invokes `same?`.","summary":"<p>Returns <code>true</code> if this reference is the same as <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"if same?(other)\n  return true\nend\nif scheme == other.scheme\nelse\n  return false\nend\nif host == other.host\nelse\n  return false\nend\nif port == other.port\nelse\n  return false\nend\nif path == other.path\nelse\n  return false\nend\nif query == other.query\nelse\n  return false\nend\nif user == other.user\nelse\n  return false\nend\nif password == other.password\nelse\n  return false\nend\nif fragment == other.fragment\nelse\n  return false\nend\ntrue\n"}},{"html_id":"absolute?:Bool-instance-method","name":"absolute?","doc":"Returns `true` if URI has a *scheme* specified.","summary":"<p>Returns <code>true</code> if URI has a <em>scheme</em> specified.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":245,"url":null},"def":{"name":"absolute?","return_type":"Bool","visibility":"Public","body":"@scheme ? true : false"}},{"html_id":"authority(io:IO):Nil-instance-method","name":"authority","doc":"Returns the authority component of this URI.\nIt is formatted as `user:pass@host:port` with missing parts being omitted.\n\nIf the URI does not have any authority information, the result is `nil`.\n\n```\nuri = URI.parse \"http://user:pass@example.com:80/path?query\"\nuri.authority # => \"user:pass@example.com:80\"\n\nuri = URI.parse(\"/relative\")\nuri.authority # => nil\n```","summary":"<p>Returns the authority component of this URI.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/uri.cr","line_number":308,"url":null},"def":{"name":"authority","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"if user = @user\n  userinfo(user, io)\n  io << '@'\nend\nif host = @host\n  URI.encode(host, io) do |byte|\n    ((URI.unreserved?(byte)) || (URI.sub_delim?(byte))) || (byte.unsafe_chr.in?(':', '[', ']'))\n  end\nend\nif port = @port\n  (io << ':') << port\nend\n"}},{"html_id":"authority:String?-instance-method","name":"authority","doc":"Returns the authority component of this URI.\nIt is formatted as `user:pass@host:port` with missing parts being omitted.\n\nIf the URI does not have any authority information, the result is `nil`.\n\n```\nuri = URI.parse \"http://user:pass@example.com:80/path?query\"\nuri.authority # => \"user:pass@example.com:80\"\n\nuri = URI.parse(\"/relative\")\nuri.authority # => nil\n```","summary":"<p>Returns the authority component of this URI.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":299,"url":null},"def":{"name":"authority","return_type":"String | ::Nil","visibility":"Public","body":"if (@host || @user) || @port\nelse\n  return\nend\nString.build do |io|\n  authority(io)\nend\n"}},{"html_id":"fragment:String?-instance-method","name":"fragment","doc":"Returns the fragment component of the URI.\n\n```\nrequire \"uri\"\n\nURI.parse(\"http://foo.com/bar#section1\").fragment # => \"section1\"\n```","summary":"<p>Returns the fragment component of the URI.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":169,"url":null},"def":{"name":"fragment","return_type":"String | ::Nil","visibility":"Public","body":"@fragment"}},{"html_id":"fragment=(fragment:String?)-instance-method","name":"fragment=","doc":"Sets the fragment component of the URI.","summary":"<p>Sets the fragment component of the URI.</p>","abstract":false,"args":[{"name":"fragment","external_name":"fragment","restriction":"String | ::Nil"}],"args_string":"(fragment : String?)","args_html":"(fragment : <a href=\"String.html\">String</a>?)","location":{"filename":"src/uri.cr","line_number":172,"url":null},"def":{"name":"fragment=","args":[{"name":"fragment","external_name":"fragment","restriction":"String | ::Nil"}],"visibility":"Public","body":"@fragment = fragment"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = scheme.hash(hasher)\nhasher = host.hash(hasher)\nhasher = port.hash(hasher)\nhasher = path.hash(hasher)\nhasher = query.hash(hasher)\nhasher = user.hash(hasher)\nhasher = password.hash(hasher)\nhasher = fragment.hash(hasher)\nhasher\n"}},{"html_id":"host:String?-instance-method","name":"host","doc":"Returns the host component of the URI.\n\n```\nrequire \"uri\"\n\nURI.parse(\"http://foo.com\").host # => \"foo.com\"\n```","summary":"<p>Returns the host component of the URI.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":97,"url":null},"def":{"name":"host","return_type":"String | ::Nil","visibility":"Public","body":"@host"}},{"html_id":"host=(host:String?)-instance-method","name":"host=","doc":"Sets the host component of the URI.","summary":"<p>Sets the host component of the URI.</p>","abstract":false,"args":[{"name":"host","external_name":"host","restriction":"String | ::Nil"}],"args_string":"(host : String?)","args_html":"(host : <a href=\"String.html\">String</a>?)","location":{"filename":"src/uri.cr","line_number":100,"url":null},"def":{"name":"host=","args":[{"name":"host","external_name":"host","restriction":"String | ::Nil"}],"visibility":"Public","body":"@host = host"}},{"html_id":"hostname:String?-instance-method","name":"hostname","doc":"Returns the host part of the URI and unwrap brackets for IPv6 addresses.\n\n```\nrequire \"uri\"\n\nURI.parse(\"http://[::1]/bar\").hostname # => \"::1\"\nURI.parse(\"http://[::1]/bar\").host     # => \"[::1]\"\n```","summary":"<p>Returns the host part of the URI and unwrap brackets for IPv6 addresses.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":188,"url":null},"def":{"name":"hostname","return_type":"String | ::Nil","visibility":"Public","body":"host.try do |host|\n  self.class.unwrap_ipv6(host)\nend"}},{"html_id":"normalize:URI-instance-method","name":"normalize","doc":"Returns a normalized copy of this URI.\n\nSee `#normalize!` for details.","summary":"<p>Returns a normalized copy of this URI.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":360,"url":null},"def":{"name":"normalize","return_type":"URI","visibility":"Public","body":"dup.normalize!"}},{"html_id":"normalize!:URI-instance-method","name":"normalize!","doc":"Normalizes this URI instance.\n\nThe following normalizations are applied to the individual components (if available):\n\n* `scheme` is lowercased.\n* `host` is lowercased.\n* `port` is removed if it is the `.default_port?` of the scheme.\n* `path` is resolved to a minimal, semantic equivalent representation removing\n   dot segments `/.` and `/..`.\n\n```\nuri = URI.parse(\"HTTP://example.COM:80/./foo/../bar/\")\nuri.normalize!\nuri # => \"http://example.com/bar/\"\n```","summary":"<p>Normalizes this URI instance.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":379,"url":null},"def":{"name":"normalize!","return_type":"URI","visibility":"Public","body":"@scheme = @scheme.try(&.downcase)\n@host = @host.try(&.downcase)\nif default_port?\n  @port = nil\nend\n@path = remove_dot_segments(path)\nself\n"}},{"html_id":"opaque?:Bool-instance-method","name":"opaque?","doc":"Returns `true` if this URI is opaque.\n\nA URI is considered opaque if it has a `scheme` but no hierarchical part,\ni.e. no `host` and the first character of `path` is not a slash (`/`).","summary":"<p>Returns <code>true</code> if this URI is opaque.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":258,"url":null},"def":{"name":"opaque?","return_type":"Bool","visibility":"Public","body":"((!@scheme.nil?) && @host.nil?) && (!(@path.starts_with?('/')))"}},{"html_id":"password:String?-instance-method","name":"password","doc":"Returns the password component of the URI.\n\n```\nrequire \"uri\"\n\nURI.parse(\"http://admin:password@foo.com\").password # => \"password\"\n```","summary":"<p>Returns the password component of the URI.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":157,"url":null},"def":{"name":"password","return_type":"String | ::Nil","visibility":"Public","body":"@password"}},{"html_id":"password=(password:String?)-instance-method","name":"password=","doc":"Sets the password component of the URI.","summary":"<p>Sets the password component of the URI.</p>","abstract":false,"args":[{"name":"password","external_name":"password","restriction":"String | ::Nil"}],"args_string":"(password : String?)","args_html":"(password : <a href=\"String.html\">String</a>?)","location":{"filename":"src/uri.cr","line_number":160,"url":null},"def":{"name":"password=","args":[{"name":"password","external_name":"password","restriction":"String | ::Nil"}],"visibility":"Public","body":"@password = password"}},{"html_id":"path:String-instance-method","name":"path","doc":"Returns the path component of the URI.\n\n```\nrequire \"uri\"\n\nURI.parse(\"http://foo.com/bar\").path # => \"/bar\"\n```","summary":"<p>Returns the path component of the URI.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":121,"url":null},"def":{"name":"path","return_type":"String","visibility":"Public","body":"@path"}},{"html_id":"path=(path:String)-instance-method","name":"path=","doc":"Sets the path component of the URI.","summary":"<p>Sets the path component of the URI.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":"String"}],"args_string":"(path : String)","args_html":"(path : <a href=\"String.html\">String</a>)","location":{"filename":"src/uri.cr","line_number":124,"url":null},"def":{"name":"path=","args":[{"name":"path","external_name":"path","restriction":"String"}],"visibility":"Public","body":"@path = path"}},{"html_id":"port:Int32?-instance-method","name":"port","doc":"Returns the port component of the URI.\n\n```\nrequire \"uri\"\n\nURI.parse(\"http://foo.com:5432\").port # => 5432\n```","summary":"<p>Returns the port component of the URI.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":109,"url":null},"def":{"name":"port","return_type":"Int32 | ::Nil","visibility":"Public","body":"@port"}},{"html_id":"port=(port:Int32?)-instance-method","name":"port=","doc":"Sets the port component of the URI.","summary":"<p>Sets the port component of the URI.</p>","abstract":false,"args":[{"name":"port","external_name":"port","restriction":"Int32 | ::Nil"}],"args_string":"(port : Int32?)","args_html":"(port : <a href=\"Int32.html\">Int32</a>?)","location":{"filename":"src/uri.cr","line_number":112,"url":null},"def":{"name":"port=","args":[{"name":"port","external_name":"port","restriction":"Int32 | ::Nil"}],"visibility":"Public","body":"@port = port"}},{"html_id":"query:String?-instance-method","name":"query","doc":"Returns the query component of the URI.\n\n```\nrequire \"uri\"\n\nURI.parse(\"http://foo.com/bar?q=1\").query # => \"q=1\"\n```","summary":"<p>Returns the query component of the URI.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":133,"url":null},"def":{"name":"query","return_type":"String | ::Nil","visibility":"Public","body":"@query"}},{"html_id":"query=(query:String?)-instance-method","name":"query=","doc":"Sets the query component of the URI.","summary":"<p>Sets the query component of the URI.</p>","abstract":false,"args":[{"name":"query","external_name":"query","restriction":"String | ::Nil"}],"args_string":"(query : String?)","args_html":"(query : <a href=\"String.html\">String</a>?)","location":{"filename":"src/uri.cr","line_number":136,"url":null},"def":{"name":"query=","args":[{"name":"query","external_name":"query","restriction":"String | ::Nil"}],"visibility":"Public","body":"@query = query"}},{"html_id":"query_params:URI::Params-instance-method","name":"query_params","doc":"Returns a `URI::Params` of the URI#query.\n\n```\nrequire \"uri\"\n\nuri = URI.parse \"http://foo.com?id=30&limit=5#time=1305298413\"\nuri.query_params # => URI::Params(@raw_params={\"id\" => [\"30\"], \"limit\" => [\"5\"]})\n```","summary":"<p>Returns a <code><a href=\"URI/Params.html\">URI::Params</a></code> of the URI#query.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":270,"url":null},"def":{"name":"query_params","return_type":"URI::Params","visibility":"Public","body":"URI::Params.parse(@query || \"\")"}},{"html_id":"query_params=(params:URI::Params)-instance-method","name":"query_params=","doc":"Sets `query` to stringified *params*.\n\n```\nrequire \"uri\"\n\nuri = URI.new\nuri.query_params = URI::Params.parse(\"foo=bar&foo=baz\")\nuri.to_s # => \"?foo=bar&foo=baz\"\n```","summary":"<p>Sets <code><a href=\"URI.html#query%3AString%3F-instance-method\">#query</a></code> to stringified <em>params</em>.</p>","abstract":false,"args":[{"name":"params","external_name":"params","restriction":"URI::Params"}],"args_string":"(params : URI::Params)","args_html":"(params : <a href=\"URI/Params.html\">URI::Params</a>)","location":{"filename":"src/uri.cr","line_number":283,"url":null},"def":{"name":"query_params=","args":[{"name":"params","external_name":"params","restriction":"URI::Params"}],"visibility":"Public","body":"self.query = params.to_s"}},{"html_id":"relative?:Bool-instance-method","name":"relative?","doc":"Returns `true` if URI does not have a *scheme* specified.","summary":"<p>Returns <code>true</code> if URI does not have a <em>scheme</em> specified.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":250,"url":null},"def":{"name":"relative?","return_type":"Bool","visibility":"Public","body":"!absolute?"}},{"html_id":"relativize(uri:URI|String):URI-instance-method","name":"relativize","doc":"Relativizes *uri* against this URI.\n\nAn exact copy of *uri* is returned if\n* this URI or *uri* are `opaque?`, or\n* the scheme and authority (`host`, `port`, `user`, `password`) components are not identical.\n\nOtherwise a new relative hierarchical URI is constructed with `query` and `fragment` components\nfrom *uri* and with a path component that describes a minimum-difference relative\npath from `#path` to *uri*'s path.\n\n```\nURI.parse(\"http://foo.com/bar/baz\").relativize(\"http://foo.com/quux\")         # => \"../quux\"\nURI.parse(\"http://foo.com/bar/baz\").relativize(\"http://foo.com/bar/quux\")     # => \"quux\"\nURI.parse(\"http://foo.com/bar/baz\").relativize(\"http://quux.com\")             # => \"http://quux.com\"\nURI.parse(\"http://foo.com/bar/baz\").relativize(\"http://foo.com/bar/baz#quux\") # => \"#quux\"\n```\n\nThis method is the inverse operation to `#resolve` (see [Resolution and Relativization](#Resolution and Relativization)).","summary":"<p>Relativizes <em>uri</em> against this URI.</p>","abstract":false,"args":[{"name":"uri","external_name":"uri","restriction":"URI | String"}],"args_string":"(uri : URI | String) : URI","args_html":"(uri : <a href=\"URI.html\">URI</a> | <a href=\"String.html\">String</a>) : <a href=\"URI.html\">URI</a>","location":{"filename":"src/uri.cr","line_number":465,"url":null},"def":{"name":"relativize","args":[{"name":"uri","external_name":"uri","restriction":"URI | String"}],"return_type":"URI","visibility":"Public","body":"if uri.is_a?(URI)\n  uri = uri.dup\nelse\n  uri = URI.parse(uri)\nend\nif (((((uri.opaque? || opaque?) || (uri.scheme.try(&.downcase) != @scheme.try(&.downcase))) || (uri.host.try(&.downcase) != @host.try(&.downcase))) || (uri.port != @port)) || (uri.user != @user)) || (uri.password != @password)\n  return uri\nend\nquery = uri.query\nif query == @query\n  query = nil\nend\nfragment = uri.fragment\npath = relativize_path(@path, uri.path)\nURI.new(path: path, query: query, fragment: uri.fragment)\n"}},{"html_id":"request_target:String-instance-method","name":"request_target","doc":"Returns the concatenation of `path` and `query` as it would be used as a\nrequest target in an HTTP request.\n\nIf `path` is empty in an hierarchical URI, `\"/\"` is used.\n\n```\nrequire \"uri\"\n\nuri = URI.parse \"http://example.com/posts?id=30&limit=5#time=1305298413\"\nuri.request_target # => \"/posts?id=30&limit=5\"\n\nuri = URI.new(path: \"\", query: \"foo=bar\")\nuri.request_target # => \"/?foo=bar\"\n```","summary":"<p>Returns the concatenation of <code><a href=\"URI.html#path%3AString-instance-method\">#path</a></code> and <code><a href=\"URI.html#query%3AString%3F-instance-method\">#query</a></code> as it would be used as a request target in an HTTP request.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":223,"url":null},"def":{"name":"request_target","return_type":"String","visibility":"Public","body":"string_size = @path.empty? ? 1 : @path.bytesize\nif query = @query\n  string_size = string_size + (query.bytesize + 1)\nend\nString.build(string_size) do |str|\n  if @path.empty?\n    if opaque?\n    else\n      str << \"/\"\n    end\n  else\n    str << @path\n  end\n  if (query = @query) && (!query.empty?)\n    (str << '?') << query\n  end\nend\n"}},{"html_id":"resolve(uri:URI|String):URI-instance-method","name":"resolve","doc":"Resolves *uri* against this URI.\n\nIf *uri* is `absolute?`, or if this URI is `opaque?`, then an exact copy of *uri* is returned.\n\nOtherwise the URI is resolved according to the specifications in [RFC 3986 section 5.2](https://tools.ietf.org/html/rfc3986#section-5.2.2).\n\n```\nURI.parse(\"http://foo.com/bar/baz\").resolve(\"../quux\")         # => \"http://foo.com/quux\"\nURI.parse(\"http://foo.com/bar/baz\").resolve(\"/quux\")           # => \"http://foo.com/quux\"\nURI.parse(\"http://foo.com/bar/baz\").resolve(\"http://quux.com\") # => \"http://quux.com\"\nURI.parse(\"http://foo.com/bar/baz\").resolve(\"#quux\")           # => \"http://foo.com/bar/baz#quux\"\n```\n\nThis method is the inverse operation to `#relativize` (see [Resolution and Relativization](#Resolution and Relativization)).","summary":"<p>Resolves <em>uri</em> against this URI.</p>","abstract":false,"args":[{"name":"uri","external_name":"uri","restriction":"URI | String"}],"args_string":"(uri : URI | String) : URI","args_html":"(uri : <a href=\"URI.html\">URI</a> | <a href=\"String.html\">String</a>) : <a href=\"URI.html\">URI</a>","location":{"filename":"src/uri.cr","line_number":402,"url":null},"def":{"name":"resolve","args":[{"name":"uri","external_name":"uri","restriction":"URI | String"}],"return_type":"URI","visibility":"Public","body":"if uri.is_a?(URI)\n  target = uri.dup\nelse\n  target = URI.parse(uri)\nend\nif target.absolute? || opaque?\n  return target\nend\ntarget.scheme = scheme\nif target.host || target.user\nelse\n  target.host = host\n  target.port = port\n  target.user = user\n  target.password = password\n  if target.path.empty?\n    target.path = remove_dot_segments(path)\n    target.query || (target.query = query)\n  else\n    base = path\n    if base.empty? && target.absolute?\n      base = \"/\"\n    end\n    target.path = resolve_path(target.path, base: base)\n  end\nend\ntarget\n"}},{"html_id":"scheme:String?-instance-method","name":"scheme","doc":"Returns the scheme component of the URI.\n\n```\nrequire \"uri\"\n\nURI.parse(\"http://foo.com\").scheme           # => \"http\"\nURI.parse(\"mailto:alice@example.com\").scheme # => \"mailto\"\n```","summary":"<p>Returns the scheme component of the URI.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":85,"url":null},"def":{"name":"scheme","return_type":"String | ::Nil","visibility":"Public","body":"@scheme"}},{"html_id":"scheme=(scheme:String?)-instance-method","name":"scheme=","doc":"Sets the scheme component of the URI.","summary":"<p>Sets the scheme component of the URI.</p>","abstract":false,"args":[{"name":"scheme","external_name":"scheme","restriction":"String | ::Nil"}],"args_string":"(scheme : String?)","args_html":"(scheme : <a href=\"String.html\">String</a>?)","location":{"filename":"src/uri.cr","line_number":88,"url":null},"def":{"name":"scheme=","args":[{"name":"scheme","external_name":"scheme","restriction":"String | ::Nil"}],"visibility":"Public","body":"@scheme = scheme"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a short String representation of this object\nwhich includes its class name and its object address.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).to_s # => #<Person:0x10a199f20>\n```","summary":"<p>Appends a short String representation of this object which includes its class name and its object address.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/uri.cr","line_number":328,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"if scheme\n  io << scheme\n  io << ':'\nend\nhas_authority = (@host || @user) || @port\nif has_authority\n  io << \"//\"\nend\nauthority(io)\nif has_authority\n  if (!@path.empty?) && (!(@path.starts_with?('/')))\n    io << '/'\n  end\nelse\n  if @path.starts_with?(\"//\")\n    io << \"/.\"\n  end\nend\nio << @path\nif query\n  io << '?'\n  io << query\nend\nif fragment\n  io << '#'\n  io << fragment\nend\n"}},{"html_id":"user:String?-instance-method","name":"user","doc":"Returns the user component of the URI.\n\n```\nrequire \"uri\"\n\nURI.parse(\"http://admin:password@foo.com\").user # => \"admin\"\n```","summary":"<p>Returns the user component of the URI.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":145,"url":null},"def":{"name":"user","return_type":"String | ::Nil","visibility":"Public","body":"@user"}},{"html_id":"user=(user:String?)-instance-method","name":"user=","doc":"Sets the user component of the URI.","summary":"<p>Sets the user component of the URI.</p>","abstract":false,"args":[{"name":"user","external_name":"user","restriction":"String | ::Nil"}],"args_string":"(user : String?)","args_html":"(user : <a href=\"String.html\">String</a>?)","location":{"filename":"src/uri.cr","line_number":148,"url":null},"def":{"name":"user=","args":[{"name":"user","external_name":"user","restriction":"String | ::Nil"}],"visibility":"Public","body":"@user = user"}},{"html_id":"userinfo:String?-instance-method","name":"userinfo","doc":"Returns the user-information component containing\nthe provided username and password.\n\n```\nrequire \"uri\"\n\nuri = URI.parse \"http://admin:password@foo.com\"\nuri.userinfo # => \"admin:password\"\n```\n\nThe return value is URL encoded (see `#encode_www_form`).","summary":"<p>Returns the user-information component containing the provided username and password.</p>","abstract":false,"location":{"filename":"src/uri.cr","line_number":568,"url":null},"def":{"name":"userinfo","return_type":"String | ::Nil","visibility":"Public","body":"if user = @user\n  String.build do |io|\n    userinfo(user, io)\n  end\nend"}}],"types":[{"html_id":"Crystal/URI/Error","path":"URI/Error.html","kind":"class","full_name":"URI::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/uri.cr","line_number":74,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/URI","kind":"class","full_name":"URI","name":"URI"}},{"html_id":"Crystal/URI/Params","path":"URI/Params.html","kind":"struct","full_name":"URI::Params","name":"Params","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/uri/params.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"namespace":{"html_id":"Crystal/URI","kind":"class","full_name":"URI","name":"URI"},"doc":"An ordered multi-value mapped collection representing generic URI parameters.","summary":"<p>An ordered multi-value mapped collection representing generic URI parameters.</p>","class_methods":[{"html_id":"build(&block:Builder->):String-class-method","name":"build","doc":"Builds an url-encoded URI form/query.\n\nThe yielded object has an `add` method that accepts two arguments,\na key (`String`) and a value (`String` or `Nil`).\nKeys and values are escaped using `URI.encode_www_form`.\n\n```\nrequire \"uri/params\"\n\nparams = URI::Params.build do |form|\n  form.add \"color\", \"black\"\n  form.add \"name\", \"crystal\"\n  form.add \"year\", \"2012 - today\"\nend\nparams # => \"color=black&name=crystal&year=2012+-+today\"\n```","summary":"<p>Builds an url-encoded URI form/query.</p>","abstract":false,"location":{"filename":"src/uri/params.cr","line_number":129,"url":null},"def":{"name":"build","yields":1,"block_arg":{"name":"block","external_name":"block","restriction":"(Builder ->)"},"return_type":"String","visibility":"Public","body":"String.build do |io|\n  yield Builder.new(io)\nend"}},{"html_id":"encode(hash:Hash(String,String|Array(String))):String-class-method","name":"encode","doc":"Returns the given key value pairs as a url-encoded URI form/query.\n\n```\nrequire \"uri/params\"\n\nURI::Params.encode({\"foo\" => \"bar\", \"baz\" => [\"quux\", \"quuz\"]}) # => \"foo=bar&baz=quux&baz=quuz\"\n```","summary":"<p>Returns the given key value pairs as a url-encoded URI form/query.</p>","abstract":false,"args":[{"name":"hash","external_name":"hash","restriction":"Hash(String, String | Array(String))"}],"args_string":"(hash : Hash(String, String | Array(String))) : String","args_html":"(hash : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a> | <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>))) : <a href=\"../String.html\">String</a>","location":{"filename":"src/uri/params.cr","line_number":90,"url":null},"def":{"name":"encode","args":[{"name":"hash","external_name":"hash","restriction":"Hash(String, String | Array(String))"}],"return_type":"String","visibility":"Public","body":"build do |builder|\n  hash.each do |key, value|\n    builder.add(key, value)\n  end\nend"}},{"html_id":"encode(named_tuple:NamedTuple)-class-method","name":"encode","doc":"Returns the given key value pairs as a url-encoded URI form/query.\n\n```\nrequire \"uri/params\"\n\nURI::Params.encode({foo: \"bar\", baz: [\"quux\", \"quuz\"]}) # => \"foo=bar&baz=quux&baz=quuz\"\n```","summary":"<p>Returns the given key value pairs as a url-encoded URI form/query.</p>","abstract":false,"args":[{"name":"named_tuple","external_name":"named_tuple","restriction":"NamedTuple"}],"args_string":"(named_tuple : NamedTuple)","args_html":"(named_tuple : <a href=\"../NamedTuple.html\">NamedTuple</a>)","location":{"filename":"src/uri/params.cr","line_number":105,"url":null},"def":{"name":"encode","args":[{"name":"named_tuple","external_name":"named_tuple","restriction":"NamedTuple"}],"visibility":"Public","body":"build do |builder|\n  named_tuple.each do |key, value|\n    builder.add(key.to_s, value)\n  end\nend"}},{"html_id":"parse(query:String,&)-class-method","name":"parse","doc":"Parses an URI query and yields each key-value pair.\n\n```\nrequire \"uri/params\"\n\nquery = \"foo=bar&foo=baz&qux=zoo\"\nURI::Params.parse(query) do |key, value|\n  # ...\nend\n```","summary":"<p>Parses an URI query and yields each key-value pair.</p>","abstract":false,"args":[{"name":"query","external_name":"query","restriction":"String"}],"args_string":"(query : String, &)","args_html":"(query : <a href=\"../String.html\">String</a>, &)","location":{"filename":"src/uri/params.cr","line_number":35,"url":null},"def":{"name":"parse","args":[{"name":"query","external_name":"query","restriction":"String"}],"yields":2,"visibility":"Public","body":"if query.empty?\n  return\nend\nkey = nil\nbuffer = IO::Memory.new\ni = 0\nfirst_equal = true\nbytesize = query.bytesize\nwhile i < bytesize\n  byte = query.to_unsafe[i]\n  char = byte.unsafe_chr\n  case char\n  when '='\n    if first_equal\n      key = buffer.to_s\n      buffer.clear\n      i = i + 1\n      first_equal = false\n    else\n      i = decode_one_www_form_component(query, bytesize, i, byte, char, buffer)\n    end\n  when '&', ';'\n    value = buffer.to_s\n    buffer.clear\n    if key\n      yield key.not_nil!, value\n    else\n      if value.empty?\n      else\n        yield value, \"\"\n      end\n    end\n    key = nil\n    first_equal = true\n    i = i + 1\n  else\n    i = decode_one_www_form_component(query, bytesize, i, byte, char, buffer)\n  end\nend\nif key\n  yield key.not_nil!, buffer.to_s\nelse\n  if buffer.empty?\n  else\n    yield buffer.to_s, \"\"\n  end\nend\n"}}],"constructors":[{"html_id":"new(raw_params:Hash(String,Array(String)))-class-method","name":"new","abstract":false,"args":[{"name":"raw_params","external_name":"raw_params","restriction":"Hash(String, Array(String))"}],"args_string":"(raw_params : Hash(String, Array(String)))","args_html":"(raw_params : <a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)))","location":{"filename":"src/uri/params.cr","line_number":142,"url":null},"def":{"name":"new","args":[{"name":"raw_params","external_name":"raw_params","restriction":"Hash(String, Array(String))"}],"visibility":"Public","body":"_ = allocate\n_.initialize(raw_params)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new-class-method","name":"new","doc":"Returns an empty `URI::Params`.","summary":"<p>Returns an empty <code><a href=\"../URI/Params.html\">URI::Params</a></code>.</p>","abstract":false,"location":{"filename":"src/uri/params.cr","line_number":138,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"parse(query:String):self-class-method","name":"parse","doc":"Parses an URI query string into a `URI::Params`\n\n```\nrequire \"uri/params\"\n\nURI::Params.parse(\"foo=bar&foo=baz&qux=zoo\")\n# => #<URI::Params @raw_params = {\"foo\" => [\"bar\", \"baz\"], \"qux\" => [\"zoo\"]}>\n```","summary":"<p>Parses an URI query string into a <code><a href=\"../URI/Params.html\">URI::Params</a></code></p>","abstract":false,"args":[{"name":"query","external_name":"query","restriction":"String"}],"args_string":"(query : String) : self","args_html":"(query : <a href=\"../String.html\">String</a>) : <span class=\"k\">self</span>","location":{"filename":"src/uri/params.cr","line_number":16,"url":null},"def":{"name":"parse","args":[{"name":"query","external_name":"query","restriction":"String"}],"return_type":"self","visibility":"Public","body":"parsed = {} of String => Array(String)\nparse(query) do |key, value|\n  ary = (  __temp_47 = key\n  parsed[__temp_47]? || (parsed[__temp_47] = [] of String)\n)\n  ary.push(value)\nend\nParams.new(parsed)\n"}}],"instance_methods":[{"html_id":"==(other:self)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"if @raw_params == (other.@raw_params)\nelse\n  return false\nend\ntrue\n"}},{"html_id":"[](name):String-instance-method","name":"[]","doc":"Returns first value for specified param name.\n\n```\nrequire \"uri/params\"\n\nparams = URI::Params.parse(\"email=john@example.org\")\nparams[\"email\"]              # => \"john@example.org\"\nparams[\"non_existent_param\"] # KeyError\n```","summary":"<p>Returns first value for specified param name.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name) : String","args_html":"(name) : <a href=\"../String.html\">String</a>","location":{"filename":"src/uri/params.cr","line_number":193,"url":null},"def":{"name":"[]","args":[{"name":"name","external_name":"name","restriction":""}],"return_type":"String","visibility":"Public","body":"fetch(name) do\n  raise(KeyError.new(\"Missing param name: #{name.inspect}\"))\nend"}},{"html_id":"[]=(name,value:String|Array(String))-instance-method","name":"[]=","doc":"Sets the *name* key to *value*.\n\n```\nrequire \"uri/params\"\n\nparams = URI::Params{\"a\" => [\"b\", \"c\"]}\nparams[\"a\"] = \"d\"\nparams[\"a\"]           # => \"d\"\nparams.fetch_all(\"a\") # => [\"d\"]\n\nparams[\"a\"] = [\"e\", \"f\"]\nparams[\"a\"]           # => \"e\"\nparams.fetch_all(\"a\") # => [\"e\", \"f\"]\n```","summary":"<p>Sets the <em>name</em> key to <em>value</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"value","external_name":"value","restriction":"String | Array(String)"}],"args_string":"(name, value : String | Array(String))","args_html":"(name, value : <a href=\"../String.html\">String</a> | <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>))","location":{"filename":"src/uri/params.cr","line_number":237,"url":null},"def":{"name":"[]=","args":[{"name":"name","external_name":"name","restriction":""},{"name":"value","external_name":"value","restriction":"String | Array(String)"}],"visibility":"Public","body":"raw_params[name] = case value\nin String\n  [value]\nin Array(String)\n  value\nend"}},{"html_id":"[]?(name):String?-instance-method","name":"[]?","doc":"Returns first value or `nil` for specified param *name*.\n\n```\nparams[\"email\"]?              # => \"john@example.org\"\nparams[\"non_existent_param\"]? # nil\n```","summary":"<p>Returns first value or <code>nil</code> for specified param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name) : String?","args_html":"(name) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/uri/params.cr","line_number":203,"url":null},"def":{"name":"[]?","args":[{"name":"name","external_name":"name","restriction":""}],"return_type":"String | ::Nil","visibility":"Public","body":"fetch(name, nil)"}},{"html_id":"add(name,value)-instance-method","name":"add","doc":"Appends new value for specified param *name*.\nCreates param when there was no such param.\n\n```\nparams.add(\"item\", \"keychain\")\nparams.fetch_all(\"item\") # => [\"pencil\", \"book\", \"workbook\", \"keychain\"]\n```","summary":"<p>Appends new value for specified param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"value","external_name":"value","restriction":""}],"args_string":"(name, value)","args_html":"(name, value)","location":{"filename":"src/uri/params.cr","line_number":287,"url":null},"def":{"name":"add","args":[{"name":"name","external_name":"name","restriction":""},{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"__temp_49 = name\n__temp_50 = raw_params\n__temp_50[__temp_49]? || (__temp_50[__temp_49] = [] of String)\nif raw_params[name] == [\"\"]\n  raw_params[name] = [] of String\nend\nraw_params[name] << value\n"}},{"html_id":"clone:self-instance-method","name":"clone","doc":"Returns a copy of this `URI::Params` instance.\n\n```\nrequire \"uri/params\"\n\noriginal = URI::Params{\"name\" => \"Jamie\"}\nupdated = original.clone\nupdated[\"name\"] = \"Ary\"\n\noriginal[\"name\"] # => \"Jamie\"\n```\n\nIdentical to `#dup`.","summary":"<p>Returns a copy of this <code><a href=\"../URI/Params.html\">URI::Params</a></code> instance.</p>","abstract":false,"location":{"filename":"src/uri/params.cr","line_number":180,"url":null},"def":{"name":"clone","return_type":"self","visibility":"Public","body":"self.class.new(raw_params.clone)"}},{"html_id":"delete(name):String-instance-method","name":"delete","doc":"Deletes first value for provided param *name*. If there are no values left,\ndeletes param itself. Returns deleted value.\n\n```\nparams.delete(\"item\")    # => \"keychain\"\nparams.fetch_all(\"item\") # => [\"keynote\"]\n\nparams.delete(\"item\") # => \"keynote\"\nparams[\"item\"]        # KeyError\n\nparams.delete(\"non_existent_param\") # KeyError\n```","summary":"<p>Deletes first value for provided param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name) : String","args_html":"(name) : <a href=\"../String.html\">String</a>","location":{"filename":"src/uri/params.cr","line_number":335,"url":null},"def":{"name":"delete","args":[{"name":"name","external_name":"name","restriction":""}],"return_type":"String","visibility":"Public","body":"value = raw_params[name].shift\nif raw_params[name].size == 0\n  raw_params.delete(name)\nend\nvalue\n"}},{"html_id":"delete_all(name):Array(String)?-instance-method","name":"delete_all","doc":"Deletes all values for provided param *name*. Returns array of deleted\nvalues.\n\n```\nparams.set_all(\"comments\", [\"hello, world!\", \":+1:\"])\nparams.delete_all(\"comments\") # => [\"hello, world!\", \":+1:\"]\nparams.has_key?(\"comments\")   # => false\n```","summary":"<p>Deletes all values for provided param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name) : Array(String)?","args_html":"(name) : <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)?","location":{"filename":"src/uri/params.cr","line_number":349,"url":null},"def":{"name":"delete_all","args":[{"name":"name","external_name":"name","restriction":""}],"return_type":"Array(String) | ::Nil","visibility":"Public","body":"raw_params.delete(name)"}},{"html_id":"dup:self-instance-method","name":"dup","doc":"Returns a copy of this `URI::Params` instance.\n\n```\nrequire \"uri/params\"\n\noriginal = URI::Params{\"name\" => \"Jamie\"}\nupdated = original.dup\nupdated[\"name\"] = \"Ary\"\n\noriginal[\"name\"] # => \"Jamie\"\n```\n\nIdentical to `#clone`.","summary":"<p>Returns a copy of this <code><a href=\"../URI/Params.html\">URI::Params</a></code> instance.</p>","abstract":false,"location":{"filename":"src/uri/params.cr","line_number":160,"url":null},"def":{"name":"dup","return_type":"self","visibility":"Public","body":"clone"}},{"html_id":"each(&)-instance-method","name":"each","doc":"Allows to iterate over all name-value pairs.\n\n```\nparams.each do |name, value|\n  puts \"#{name} => #{value}\"\nend\n\n# Outputs:\n# email => john@example.org\n# item => keychain\n# item => keynote\n```","summary":"<p>Allows to iterate over all name-value pairs.</p>","abstract":false,"location":{"filename":"src/uri/params.cr","line_number":315,"url":null},"def":{"name":"each","yields":1,"visibility":"Public","body":"raw_params.each do |name, values|\n  values.each do |value|\n    yield({name, value})\n  end\nend"}},{"html_id":"empty?(*args,**options)-instance-method","name":"empty?","doc":"Returns `true` if params is empty.\n\n```\nURI::Params.new.empty?                              # => true\nURI::Params.parse(\"foo=bar&foo=baz&qux=zoo\").empty? # => false\n```","summary":"<p>Returns <code>true</code> if params is empty.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/uri/params.cr","line_number":221,"url":null},"def":{"name":"empty?","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"raw_params.empty?(*args, **options)"}},{"html_id":"empty?(*args,**options,&)-instance-method","name":"empty?","doc":"Returns `true` if params is empty.\n\n```\nURI::Params.new.empty?                              # => true\nURI::Params.parse(\"foo=bar&foo=baz&qux=zoo\").empty? # => false\n```","summary":"<p>Returns <code>true</code> if params is empty.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/uri/params.cr","line_number":221,"url":null},"def":{"name":"empty?","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"raw_params.empty?(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"fetch(name,default)-instance-method","name":"fetch","doc":"Returns first value for specified param *name*. Falls back to provided\n*default* value when there is no such param.\n\n```\nparams[\"email\"] = \"john@example.org\"\nparams.fetch(\"email\", \"none@example.org\")           # => \"john@example.org\"\nparams.fetch(\"non_existent_param\", \"default value\") # => \"default value\"\n```","summary":"<p>Returns first value for specified param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"default","external_name":"default","restriction":""}],"args_string":"(name, default)","args_html":"(name, default)","location":{"filename":"src/uri/params.cr","line_number":263,"url":null},"def":{"name":"fetch","args":[{"name":"name","external_name":"name","restriction":""},{"name":"default","external_name":"default","restriction":""}],"visibility":"Public","body":"fetch(name) do\n  default\nend"}},{"html_id":"fetch(name,&)-instance-method","name":"fetch","doc":"Returns first value for specified param *name*. Falls back to return value\nof provided block when there is no such param.\n\n```\nparams.delete(\"email\")\nparams.fetch(\"email\") { raise \"Email is missing\" }              # raises \"Email is missing\"\nparams.fetch(\"non_existent_param\") { \"default computed value\" } # => \"default computed value\"\n```","summary":"<p>Returns first value for specified param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name, &)","args_html":"(name, &)","location":{"filename":"src/uri/params.cr","line_number":275,"url":null},"def":{"name":"fetch","args":[{"name":"name","external_name":"name","restriction":""}],"yields":1,"visibility":"Public","body":"if has_key?(name)\nelse\n  return yield name\nend\nraw_params[name].first\n"}},{"html_id":"fetch_all(name):Array(String)-instance-method","name":"fetch_all","doc":"Returns all values for specified param *name*.\n\n```\nparams.set_all(\"item\", [\"pencil\", \"book\", \"workbook\"])\nparams.fetch_all(\"item\") # => [\"pencil\", \"book\", \"workbook\"]\n```","summary":"<p>Returns all values for specified param <em>name</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name) : Array(String)","args_html":"(name) : <a href=\"../Array.html\">Array</a>(<a href=\"../String.html\">String</a>)","location":{"filename":"src/uri/params.cr","line_number":251,"url":null},"def":{"name":"fetch_all","args":[{"name":"name","external_name":"name","restriction":""}],"return_type":"Array(String)","visibility":"Public","body":"raw_params.fetch(name) do\n  [] of String\nend"}},{"html_id":"has_key?(*args,**options)-instance-method","name":"has_key?","doc":"Returns `true` if param with provided name exists.\n\n```\nparams.has_key?(\"email\")   # => true\nparams.has_key?(\"garbage\") # => false\n```","summary":"<p>Returns <code>true</code> if param with provided name exists.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options)","args_html":"(*args, **options)","location":{"filename":"src/uri/params.cr","line_number":213,"url":null},"def":{"name":"has_key?","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"visibility":"Public","body":"raw_params.has_key?(*args, **options)"}},{"html_id":"has_key?(*args,**options,&)-instance-method","name":"has_key?","doc":"Returns `true` if param with provided name exists.\n\n```\nparams.has_key?(\"email\")   # => true\nparams.has_key?(\"garbage\") # => false\n```","summary":"<p>Returns <code>true</code> if param with provided name exists.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **options, &)","args_html":"(*args, **options, &)","location":{"filename":"src/uri/params.cr","line_number":213,"url":null},"def":{"name":"has_key?","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"options","external_name":"options","restriction":""},"splat_index":0,"yields":1,"visibility":"Public","body":"raw_params.has_key?(*args, **options) do |*yield_args|\n  yield *yield_args\nend"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = @raw_params.hash(hasher)\nhasher\n"}},{"html_id":"set_all(name,values)-instance-method","name":"set_all","doc":"Sets all *values* for specified param *name* at once.\n\n```\nparams.set_all(\"item\", [\"keychain\", \"keynote\"])\nparams.fetch_all(\"item\") # => [\"keychain\", \"keynote\"]\n```","summary":"<p>Sets all <em>values</em> for specified param <em>name</em> at once.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"values","external_name":"values","restriction":""}],"args_string":"(name, values)","args_html":"(name, values)","location":{"filename":"src/uri/params.cr","line_number":299,"url":null},"def":{"name":"set_all","args":[{"name":"name","external_name":"name","restriction":""},{"name":"values","external_name":"values","restriction":""}],"visibility":"Public","body":"raw_params[name] = values"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Serializes to string representation as http url-encoded form.\n\n```\nrequire \"uri/params\"\n\nparams = URI::Params.parse(\"item=keychain&item=keynote&email=john@example.org\")\nparams.to_s # => \"item=keychain&item=keynote&email=john%40example.org\"\n```","summary":"<p>Serializes to string representation as http url-encoded form.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/uri/params.cr","line_number":361,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"builder = Builder.new(io)\neach do |name, value|\n  builder.add(name, value)\nend\n"}}],"types":[{"html_id":"Crystal/URI/Params/Builder","path":"URI/Params/Builder.html","kind":"class","full_name":"URI::Params::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/uri/params.cr","line_number":377,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/URI/Params","kind":"struct","full_name":"URI::Params","name":"Params"},"doc":"URI params builder.\n\nEvery parameter added is directly written to an `IO`,\nwhere keys and values are properly escaped.","summary":"<p>URI params builder.</p>","constructors":[{"html_id":"new(io:IO)-class-method","name":"new","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","args_html":"(io : <a href=\"../../IO.html\">IO</a>)","location":{"filename":"src/uri/params.cr","line_number":378,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"_ = allocate\n_.initialize(io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"add(key,value:String?)-instance-method","name":"add","doc":"Adds a key-value pair to the params being built.","summary":"<p>Adds a key-value pair to the params being built.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"String | ::Nil"}],"args_string":"(key, value : String?)","args_html":"(key, value : <a href=\"../../String.html\">String</a>?)","location":{"filename":"src/uri/params.cr","line_number":383,"url":null},"def":{"name":"add","args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":"String | ::Nil"}],"visibility":"Public","body":"if @first\nelse\n  @io << '&'\nend\n@first = false\nURI.encode_www_form(key, @io)\n@io << '='\nif value\n  URI.encode_www_form(value, @io)\nend\nself\n"}},{"html_id":"add(key,values:Array)-instance-method","name":"add","doc":"Adds all of the given *values* as key-value pairs to the params being built.","summary":"<p>Adds all of the given <em>values</em> as key-value pairs to the params being built.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""},{"name":"values","external_name":"values","restriction":"Array"}],"args_string":"(key, values : Array)","args_html":"(key, values : <a href=\"../../Array.html\">Array</a>)","location":{"filename":"src/uri/params.cr","line_number":393,"url":null},"def":{"name":"add","args":[{"name":"key","external_name":"key","restriction":""},{"name":"values","external_name":"values","restriction":"Array"}],"visibility":"Public","body":"values.each do |value|\n  add(key, value)\nend\nself\n"}}]}]},{"html_id":"Crystal/URI/Punycode","path":"URI/Punycode.html","kind":"class","full_name":"URI::Punycode","name":"Punycode","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/uri/punycode.cr","line_number":5,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/URI","kind":"class","full_name":"URI","name":"URI"},"doc":"`Punycode` provides an interface for IDNA encoding ([RFC 5980](https://tools.ietf.org/html/rfc5980)), defined in [RFC 3492](https://tools.ietf.org/html/rfc3492).\n\nImplementation based on Mathias Bynens' [punnycode.js](https://github.com/bestiejs/punycode.js) project.","summary":"<p><code><a href=\"../URI/Punycode.html\">Punycode</a></code> provides an interface for IDNA encoding (<a href=\"https://tools.ietf.org/html/rfc5980\">RFC 5980</a>), defined in <a href=\"https://tools.ietf.org/html/rfc3492\">RFC 3492</a>.</p>","class_methods":[{"html_id":"decode(string):String-class-method","name":"decode","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""}],"args_string":"(string) : String","args_html":"(string) : <a href=\"../String.html\">String</a>","location":{"filename":"src/uri/punycode.cr","line_number":90,"url":null},"def":{"name":"decode","args":[{"name":"string","external_name":"string","restriction":""}],"return_type":"String","visibility":"Public","body":"output, _, rest = string.rpartition(DELIMITER)\noutput = output.chars\nn = INITIAL_N\nbias = INITIAL_BIAS\ni = 0\ninit = true\nw = oldi = k = 0\nrest.each_char do |c|\n  if init\n    w = 1\n    oldi = i\n    k = BASE\n    init = false\n  end\n  digit = case c\n  when .ascii_lowercase?\n    c.ord - 97\n  when .ascii_uppercase?\n    c.ord - 65\n  when .ascii_number?\n    (c.ord - 48) + 26\n  else\n    raise(ArgumentError.new(\"Invalid input\"))\n  end\n  i = i + (digit * w)\n  t = k <= bias ? TMIN : k >= (bias + TMAX) ? TMAX : k - bias\n  if digit < t\n    outsize = output.size + 1\n    bias = adapt(i - oldi, outsize, oldi == 0)\n    n = n + (i // outsize)\n    i = i % outsize\n    output.insert(i, n.chr)\n    i = i + 1\n    init = true\n  else\n    w = w * (BASE - t)\n    k = k + BASE\n  end\nend\nif init\nelse\n  raise(ArgumentError.new(\"Invalid input\"))\nend\noutput.join\n"}},{"html_id":"encode(string,io):Nil-class-method","name":"encode","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""},{"name":"io","external_name":"io","restriction":""}],"args_string":"(string, io) : Nil","args_html":"(string, io) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/uri/punycode.cr","line_number":33,"url":null},"def":{"name":"encode","args":[{"name":"string","external_name":"string","restriction":""},{"name":"io","external_name":"io","restriction":""}],"return_type":"Nil","visibility":"Public","body":"others = [] of Char\nstring.each_char do |c|\n  if c < '\\u0080'\n    io << c\n  else\n    others.push(c)\n  end\nend\nif others.empty?\n  return\nend\nothers.sort!\nh = (string.size - others.size) + 1\ndelta = 0_u32\nn = INITIAL_N\nbias = INITIAL_BIAS\nfirsttime = true\nprev = nil\nif h > 1\n  io << DELIMITER\nend\nothers.each do |m|\n  if m == prev\n    next\n  end\n  prev = m\n  if (m.ord - n) > ((Int32::MAX - delta) // h)\n    raise(Exception.new(\"Overflow: input needs wider integers to process\"))\n  end\n  delta = delta + ((m.ord - n) * h)\n  n = m.ord + 1\n  string.each_char do |c|\n    if c < m\n      if delta > (Int32::MAX - 1)\n        raise(Exception.new(\"Overflow: input needs wider integers to process\"))\n      end\n      delta = delta + 1\n    else\n      if c == m\n        q = delta\n        k = BASE\n        loop do\n          t = k <= bias ? TMIN : k >= (bias + TMAX) ? TMAX : k - bias\n          if q < t\n            break\n          end\n          io << BASE36[t + ((q - t) % (BASE - t))]\n          q = (q - t) // (BASE - t)\n          k = k + BASE\n        end\n        io << BASE36[q]\n        bias = adapt(delta, h, firsttime)\n        delta = 0\n        h = h + 1\n        firsttime = false\n      end\n    end\n  end\n  delta = delta + 1\nend\n"}},{"html_id":"encode(string):String-class-method","name":"encode","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""}],"args_string":"(string) : String","args_html":"(string) : <a href=\"../String.html\">String</a>","location":{"filename":"src/uri/punycode.cr","line_number":29,"url":null},"def":{"name":"encode","args":[{"name":"string","external_name":"string","restriction":""}],"return_type":"String","visibility":"Public","body":"String.build do |io|\n  encode(string, io)\nend"}},{"html_id":"to_ascii(string):String-class-method","name":"to_ascii","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""}],"args_string":"(string) : String","args_html":"(string) : <a href=\"../String.html\">String</a>","location":{"filename":"src/uri/punycode.cr","line_number":141,"url":null},"def":{"name":"to_ascii","args":[{"name":"string","external_name":"string","restriction":""}],"return_type":"String","visibility":"Public","body":"if string.ascii_only?\n  return string\nend\nString.build do |io|\n  first = true\n  string.split('.') do |part|\n    if first\n    else\n      io << '.'\n    end\n    if part.ascii_only?\n      io << part\n    else\n      io << \"xn--\"\n      encode(part, io)\n    end\n    first = false\n  end\nend\n"}}]}]},{"html_id":"Crystal/UUID","path":"UUID.html","kind":"struct","full_name":"UUID","name":"UUID","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/uuid.cr","line_number":2,"url":null},{"filename":"src/uuid/json.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"}],"doc":"Represents a UUID (Universally Unique IDentifier).","summary":"<p>Represents a UUID (Universally Unique IDentifier).</p>","class_methods":[{"html_id":"from_json_object_key?(key:String)-class-method","name":"from_json_object_key?","doc":"Deserializes the given JSON *key* into a `UUID`.\n\nNOTE: `require \"uuid/json\"` is required to opt-in to this feature.","summary":"<p>Deserializes the given JSON <em>key</em> into a <code><a href=\"UUID.html\">UUID</a></code>.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":"String"}],"args_string":"(key : String)","args_html":"(key : <a href=\"String.html\">String</a>)","location":{"filename":"src/uuid/json.cr","line_number":47,"url":null},"def":{"name":"from_json_object_key?","args":[{"name":"key","external_name":"key","restriction":"String"}],"visibility":"Public","body":"UUID.new(key)"}},{"html_id":"random(random=Random::Secure,variant=Variant::RFC4122,version=Version::V4)-class-method","name":"random","doc":"Generates RFC 4122 v4 UUID.\n\nIt is strongly recommended to use a cryptographically random source for\n*random*, such as `Random::Secure`.","summary":"<p>Generates RFC 4122 v4 UUID.</p>","abstract":false,"args":[{"name":"random","default_value":"Random::Secure","external_name":"random","restriction":""},{"name":"variant","default_value":"Variant::RFC4122","external_name":"variant","restriction":""},{"name":"version","default_value":"Version::V4","external_name":"version","restriction":""}],"args_string":"(random = Random::Secure, variant = Variant::RFC4122, version = Version::V4)","args_html":"(random = <span class=\"t\">Random</span><span class=\"t\">::</span><span class=\"t\">Secure</span>, variant = <span class=\"t\">Variant</span><span class=\"t\">::</span><span class=\"t\">RFC4122</span>, version = <span class=\"t\">Version</span><span class=\"t\">::</span><span class=\"t\">V4</span>)","location":{"filename":"src/uuid.cr","line_number":127,"url":null},"def":{"name":"random","args":[{"name":"random","default_value":"Random::Secure","external_name":"random","restriction":""},{"name":"variant","default_value":"Variant::RFC4122","external_name":"variant","restriction":""},{"name":"version","default_value":"Version::V4","external_name":"version","restriction":""}],"visibility":"Public","body":"new_bytes = uninitialized ::StaticArray(UInt8, 16)\nrandom.random_bytes(new_bytes.to_slice)\nnew(new_bytes, variant, version)\n"}}],"constructors":[{"html_id":"empty:self-class-method","name":"empty","abstract":false,"location":{"filename":"src/uuid.cr","line_number":134,"url":null},"def":{"name":"empty","return_type":"self","visibility":"Public","body":"new(StaticArray(UInt8, 16).new(0_u8), UUID::Variant::NCS, UUID::Version::V4)"}},{"html_id":"new(bytes:StaticArray(UInt8,16),variant:UUID::Variant?=nil,version:UUID::Version?=nil)-class-method","name":"new","doc":"Generates UUID from *bytes*, applying *version* and *variant* to the UUID if\npresent.","summary":"<p>Generates UUID from <em>bytes</em>, applying <em>version</em> and <em>variant</em> to the UUID if present.</p>","abstract":false,"args":[{"name":"bytes","external_name":"bytes","restriction":"StaticArray(UInt8, 16)"},{"name":"variant","default_value":"nil","external_name":"variant","restriction":"UUID::Variant | ::Nil"},{"name":"version","default_value":"nil","external_name":"version","restriction":"UUID::Version | ::Nil"}],"args_string":"(bytes : StaticArray(UInt8, 16), variant : UUID::Variant? = nil, version : UUID::Version? = nil)","args_html":"(bytes : <a href=\"StaticArray.html\">StaticArray</a>(<a href=\"UInt8.html\">UInt8</a>, <span class=\"n\">16</span>), variant : <a href=\"UUID/Variant.html\">UUID::Variant</a>? = <span class=\"n\">nil</span>, version : <a href=\"UUID/Version.html\">UUID::Version</a>? = <span class=\"n\">nil</span>)","location":{"filename":"src/uuid.cr","line_number":39,"url":null},"def":{"name":"new","args":[{"name":"bytes","external_name":"bytes","restriction":"StaticArray(UInt8, 16)"},{"name":"variant","default_value":"nil","external_name":"variant","restriction":"UUID::Variant | ::Nil"},{"name":"version","default_value":"nil","external_name":"version","restriction":"UUID::Version | ::Nil"}],"visibility":"Public","body":"_ = allocate\n_.initialize(bytes, variant, version)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(slice:Slice(UInt8),variant=nil,version=nil)-class-method","name":"new","doc":"Creates UUID from 16-bytes slice. Raises if *slice* isn't 16 bytes long. See\n`#initialize` for *variant* and *version*.","summary":"<p>Creates UUID from 16-bytes slice.</p>","abstract":false,"args":[{"name":"slice","external_name":"slice","restriction":"Slice(UInt8)"},{"name":"variant","default_value":"nil","external_name":"variant","restriction":""},{"name":"version","default_value":"nil","external_name":"version","restriction":""}],"args_string":"(slice : Slice(UInt8), variant = nil, version = nil)","args_html":"(slice : <a href=\"Slice.html\">Slice</a>(<a href=\"UInt8.html\">UInt8</a>), variant = <span class=\"n\">nil</span>, version = <span class=\"n\">nil</span>)","location":{"filename":"src/uuid.cr","line_number":63,"url":null},"def":{"name":"new","args":[{"name":"slice","external_name":"slice","restriction":"Slice(UInt8)"},{"name":"variant","default_value":"nil","external_name":"variant","restriction":""},{"name":"version","default_value":"nil","external_name":"version","restriction":""}],"visibility":"Public","body":"if slice.size == 16\nelse\n  raise(ArgumentError.new(\"Invalid bytes length #{slice.size}, expected 16\"))\nend\nbytes = uninitialized ::StaticArray(UInt8, 16)\nslice.copy_to(bytes.to_slice)\nnew(bytes, variant, version)\n"}},{"html_id":"new(uuid:UUID,variant=nil,version=nil)-class-method","name":"new","doc":"Creates another `UUID` which is a copy of *uuid*, but allows overriding\n*variant* or *version*.","summary":"<p>Creates another <code><a href=\"UUID.html\">UUID</a></code> which is a copy of <em>uuid</em>, but allows overriding <em>variant</em> or <em>version</em>.</p>","abstract":false,"args":[{"name":"uuid","external_name":"uuid","restriction":"UUID"},{"name":"variant","default_value":"nil","external_name":"variant","restriction":""},{"name":"version","default_value":"nil","external_name":"version","restriction":""}],"args_string":"(uuid : UUID, variant = nil, version = nil)","args_html":"(uuid : <a href=\"UUID.html\">UUID</a>, variant = <span class=\"n\">nil</span>, version = <span class=\"n\">nil</span>)","location":{"filename":"src/uuid.cr","line_number":74,"url":null},"def":{"name":"new","args":[{"name":"uuid","external_name":"uuid","restriction":"UUID"},{"name":"variant","default_value":"nil","external_name":"variant","restriction":""},{"name":"version","default_value":"nil","external_name":"version","restriction":""}],"visibility":"Public","body":"new(uuid.bytes, variant, version)"}},{"html_id":"new(value:String,variant=nil,version=nil)-class-method","name":"new","doc":"Creates new UUID by decoding `value` string from hyphenated (ie. `ba714f86-cac6-42c7-8956-bcf5105e1b81`),\nhexstring (ie. `89370a4ab66440c8add39e06f2bb6af6`) or URN (ie. `urn:uuid:3f9eaf9e-cdb0-45cc-8ecb-0e5b2bfb0c20`)\nformat.","summary":"<p>Creates new UUID by decoding <code>value</code> string from hyphenated (ie.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"variant","default_value":"nil","external_name":"variant","restriction":""},{"name":"version","default_value":"nil","external_name":"version","restriction":""}],"args_string":"(value : String, variant = nil, version = nil)","args_html":"(value : <a href=\"String.html\">String</a>, variant = <span class=\"n\">nil</span>, version = <span class=\"n\">nil</span>)","location":{"filename":"src/uuid.cr","line_number":81,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"String"},{"name":"variant","default_value":"nil","external_name":"variant","restriction":""},{"name":"version","default_value":"nil","external_name":"version","restriction":""}],"visibility":"Public","body":"bytes = uninitialized ::StaticArray(UInt8, 16)\ncase value.size\nwhen 36\n  {8, 13, 18, 23}.each do |offset|\n    if value[offset] != '-'\n      raise(ArgumentError.new(\"Invalid UUID string format, expected hyphen at char #{offset}\"))\n    end\n  end\n  {0, 2, 4, 6, 9, 11, 14, 16, 19, 21, 24, 26, 28, 30, 32, 34}.each_with_index do |offset, i|\n    bytes[i] = hex_pair_at(value, offset)\n  end\nwhen 32\n  16.times do |i|\n    bytes[i] = hex_pair_at(value, i * 2)\n  end\nwhen 45\n  if value.starts_with?(\"urn:uuid:\")\n  else\n    raise(ArgumentError.new(\"Invalid URN UUID format, expected string starting with \\\"urn:uuid:\\\"\"))\n  end\n  {9, 11, 13, 15, 18, 20, 23, 25, 28, 30, 33, 35, 37, 39, 41, 43}.each_with_index do |offset, i|\n    bytes[i] = hex_pair_at(value, offset)\n  end\nelse\n  raise(ArgumentError.new(\"Invalid string length #{value.size} for UUID, expected 32 (hexstring), 36 (hyphenated) or 45 (urn)\"))\nend\nnew(bytes, variant, version)\n"}},{"html_id":"new(pull:JSON::PullParser)-class-method","name":"new","doc":"Creates UUID from JSON using `JSON::PullParser`.\n\nNOTE: `require \"uuid/json\"` is required to opt-in to this feature.\n\n```\nrequire \"json\"\nrequire \"uuid\"\nrequire \"uuid/json\"\n\nclass Example\n  include JSON::Serializable\n\n  property id : UUID\nend\n\nexample = Example.from_json(%({\"id\": \"ba714f86-cac6-42c7-8956-bcf5105e1b81\"}))\nexample.id # => UUID(ba714f86-cac6-42c7-8956-bcf5105e1b81)\n```","summary":"<p>Creates UUID from JSON using <code><a href=\"JSON/PullParser.html\">JSON::PullParser</a></code>.</p>","abstract":false,"args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"args_string":"(pull : JSON::PullParser)","args_html":"(pull : <a href=\"JSON/PullParser.html\">JSON::PullParser</a>)","location":{"filename":"src/uuid/json.cr","line_number":23,"url":null},"def":{"name":"new","args":[{"name":"pull","external_name":"pull","restriction":"JSON::PullParser"}],"visibility":"Public","body":"new(pull.read_string)"}}],"instance_methods":[{"html_id":"<=>(other:UUID):Int32-instance-method","name":"<=>","doc":"The comparison operator. Returns `0` if the two objects are equal,\na negative number if this object is considered less than *other*,\na positive number if this object is considered greater than *other*,\nor `nil` if the two objects are not comparable.\n\nSubclasses define this method to provide class-specific ordering.\n\nThe comparison operator is usually used to sort values:\n\n```\n# Sort in a descending way:\n[3, 1, 2].sort { |x, y| y <=> x } # => [3, 2, 1]\n\n# Sort in an ascending way:\n[3, 1, 2].sort { |x, y| x <=> y } # => [1, 2, 3]\n```","summary":"<p>The comparison operator.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"UUID"}],"args_string":"(other : UUID) : Int32","args_html":"(other : <a href=\"UUID.html\">UUID</a>) : <a href=\"Int32.html\">Int32</a>","location":{"filename":"src/uuid.cr","line_number":212,"url":null},"def":{"name":"<=>","args":[{"name":"other","external_name":"other","restriction":"UUID"}],"return_type":"Int32","visibility":"Public","body":"@bytes <=> other.bytes"}},{"html_id":"==(other:self)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"self"}],"args_string":"(other : self)","args_html":"(other : <span class=\"k\">self</span>)","def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"self"}],"visibility":"Public","body":"if @bytes == (other.@bytes)\nelse\n  return false\nend\ntrue\n"}},{"html_id":"bytes:StaticArray(UInt8,16)-instance-method","name":"bytes","doc":"Returns the binary representation of the UUID.","summary":"<p>Returns the binary representation of the UUID.</p>","abstract":false,"location":{"filename":"src/uuid.cr","line_number":167,"url":null},"def":{"name":"bytes","return_type":"StaticArray(UInt8, 16)","visibility":"Public","body":"@bytes.dup"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = @bytes.hash(hasher)\nhasher\n"}},{"html_id":"hexstring:String-instance-method","name":"hexstring","abstract":false,"location":{"filename":"src/uuid.cr","line_number":201,"url":null},"def":{"name":"hexstring","return_type":"String","visibility":"Public","body":"@bytes.to_slice.hexstring"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Convert to `String` in literal format.","summary":"<p>Convert to <code><a href=\"String.html\">String</a></code> in literal format.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/uuid.cr","line_number":179,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"UUID(\"\nto_s(io)\nio << ')'\n"}},{"html_id":"to_json(json:JSON::Builder):Nil-instance-method","name":"to_json","doc":"Returns UUID as JSON value.\n\nNOTE: `require \"uuid/json\"` is required to opt-in to this feature.\n\n```\nuuid = UUID.new(\"87b3042b-9b9a-41b7-8b15-a93d3f17025e\")\nuuid.to_json # => \"\\\"87b3042b-9b9a-41b7-8b15-a93d3f17025e\\\"\"\n```","summary":"<p>Returns UUID as JSON value.</p>","abstract":false,"args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"args_string":"(json : JSON::Builder) : Nil","args_html":"(json : <a href=\"JSON/Builder.html\">JSON::Builder</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/uuid/json.cr","line_number":35,"url":null},"def":{"name":"to_json","args":[{"name":"json","external_name":"json","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"json.string(to_s)"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Same as `#inspect(io)`.","summary":"<p>Same as <code><a href=\"UUID.html#inspect%28io%3AIO%29%3ANil-instance-method\">#inspect(io)</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/uuid.cr","line_number":185,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"slice = @bytes.to_slice\nbuffer = uninitialized ::StaticArray(UInt8, 36)\nbuffer_ptr = buffer.to_unsafe\nbuffer_ptr[8] = buffer_ptr[13] = buffer_ptr[18] = buffer_ptr[23] = '-'.ord.to_u8\nslice[0, 4].hexstring(buffer_ptr + 0)\nslice[4, 2].hexstring(buffer_ptr + 9)\nslice[6, 2].hexstring(buffer_ptr + 14)\nslice[8, 2].hexstring(buffer_ptr + 19)\nslice[10, 6].hexstring(buffer_ptr + 24)\nio.write_string(buffer.to_slice)\n"}},{"html_id":"to_unsafe-instance-method","name":"to_unsafe","doc":"Returns unsafe pointer to 16-bytes.","summary":"<p>Returns unsafe pointer to 16-bytes.</p>","abstract":false,"location":{"filename":"src/uuid.cr","line_number":172,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@bytes.to_unsafe"}},{"html_id":"urn:String-instance-method","name":"urn","abstract":false,"location":{"filename":"src/uuid.cr","line_number":205,"url":null},"def":{"name":"urn","return_type":"String","visibility":"Public","body":"String.build(45) do |str|\n  str << \"urn:uuid:\"\n  to_s(str)\nend"}},{"html_id":"v1!-instance-method","name":"v1!","doc":"Returns `true` if UUID is a V1, raises `Error` otherwise.","summary":"<p>Returns <code>true</code> if UUID is a V1, raises <code><a href=\"UUID/Error.html\">Error</a></code> otherwise.</p>","abstract":false,"location":{"filename":"src/uuid.cr","line_number":219,"url":null},"def":{"name":"v1!","visibility":"Public","body":"if v1?\n  true\nelse\n  raise(Error.new(\"Invalid UUID variant #{variant} version #{version}, expected RFC 4122 V1\"))\nend"}},{"html_id":"v1?-instance-method","name":"v1?","doc":"Returns `true` if UUID is a V1, `false` otherwise.","summary":"<p>Returns <code>true</code> if UUID is a V1, <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/uuid.cr","line_number":219,"url":null},"def":{"name":"v1?","visibility":"Public","body":"(variant == Variant::RFC4122) && (version == Version::V1)"}},{"html_id":"v2!-instance-method","name":"v2!","doc":"Returns `true` if UUID is a V2, raises `Error` otherwise.","summary":"<p>Returns <code>true</code> if UUID is a V2, raises <code><a href=\"UUID/Error.html\">Error</a></code> otherwise.</p>","abstract":false,"location":{"filename":"src/uuid.cr","line_number":219,"url":null},"def":{"name":"v2!","visibility":"Public","body":"if v2?\n  true\nelse\n  raise(Error.new(\"Invalid UUID variant #{variant} version #{version}, expected RFC 4122 V2\"))\nend"}},{"html_id":"v2?-instance-method","name":"v2?","doc":"Returns `true` if UUID is a V2, `false` otherwise.","summary":"<p>Returns <code>true</code> if UUID is a V2, <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/uuid.cr","line_number":219,"url":null},"def":{"name":"v2?","visibility":"Public","body":"(variant == Variant::RFC4122) && (version == Version::V2)"}},{"html_id":"v3!-instance-method","name":"v3!","doc":"Returns `true` if UUID is a V3, raises `Error` otherwise.","summary":"<p>Returns <code>true</code> if UUID is a V3, raises <code><a href=\"UUID/Error.html\">Error</a></code> otherwise.</p>","abstract":false,"location":{"filename":"src/uuid.cr","line_number":219,"url":null},"def":{"name":"v3!","visibility":"Public","body":"if v3?\n  true\nelse\n  raise(Error.new(\"Invalid UUID variant #{variant} version #{version}, expected RFC 4122 V3\"))\nend"}},{"html_id":"v3?-instance-method","name":"v3?","doc":"Returns `true` if UUID is a V3, `false` otherwise.","summary":"<p>Returns <code>true</code> if UUID is a V3, <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/uuid.cr","line_number":219,"url":null},"def":{"name":"v3?","visibility":"Public","body":"(variant == Variant::RFC4122) && (version == Version::V3)"}},{"html_id":"v4!-instance-method","name":"v4!","doc":"Returns `true` if UUID is a V4, raises `Error` otherwise.","summary":"<p>Returns <code>true</code> if UUID is a V4, raises <code><a href=\"UUID/Error.html\">Error</a></code> otherwise.</p>","abstract":false,"location":{"filename":"src/uuid.cr","line_number":219,"url":null},"def":{"name":"v4!","visibility":"Public","body":"if v4?\n  true\nelse\n  raise(Error.new(\"Invalid UUID variant #{variant} version #{version}, expected RFC 4122 V4\"))\nend"}},{"html_id":"v4?-instance-method","name":"v4?","doc":"Returns `true` if UUID is a V4, `false` otherwise.","summary":"<p>Returns <code>true</code> if UUID is a V4, <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/uuid.cr","line_number":219,"url":null},"def":{"name":"v4?","visibility":"Public","body":"(variant == Variant::RFC4122) && (version == Version::V4)"}},{"html_id":"v5!-instance-method","name":"v5!","doc":"Returns `true` if UUID is a V5, raises `Error` otherwise.","summary":"<p>Returns <code>true</code> if UUID is a V5, raises <code><a href=\"UUID/Error.html\">Error</a></code> otherwise.</p>","abstract":false,"location":{"filename":"src/uuid.cr","line_number":219,"url":null},"def":{"name":"v5!","visibility":"Public","body":"if v5?\n  true\nelse\n  raise(Error.new(\"Invalid UUID variant #{variant} version #{version}, expected RFC 4122 V5\"))\nend"}},{"html_id":"v5?-instance-method","name":"v5?","doc":"Returns `true` if UUID is a V5, `false` otherwise.","summary":"<p>Returns <code>true</code> if UUID is a V5, <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/uuid.cr","line_number":219,"url":null},"def":{"name":"v5?","visibility":"Public","body":"(variant == Variant::RFC4122) && (version == Version::V5)"}},{"html_id":"variant:UUID::Variant-instance-method","name":"variant","doc":"Returns UUID variant.","summary":"<p>Returns UUID variant.</p>","abstract":false,"location":{"filename":"src/uuid.cr","line_number":139,"url":null},"def":{"name":"variant","return_type":"UUID::Variant","visibility":"Public","body":"case\nwhen (@bytes[8] & 128) == 0\n  Variant::NCS\nwhen (@bytes[8] & 192) == 128\n  Variant::RFC4122\nwhen (@bytes[8] & 224) == 192\n  Variant::Microsoft\nwhen (@bytes[8] & 224) == 224\n  Variant::Future\nelse\n  Variant::Unknown\nend"}},{"html_id":"version:UUID::Version-instance-method","name":"version","doc":"Returns version based on RFC4122 format. See also `#variant`.","summary":"<p>Returns version based on RFC4122 format.</p>","abstract":false,"location":{"filename":"src/uuid.cr","line_number":155,"url":null},"def":{"name":"version","return_type":"UUID::Version","visibility":"Public","body":"case @bytes[6] >> 4\nwhen 1\n  Version::V1\nwhen 2\n  Version::V2\nwhen 3\n  Version::V3\nwhen 4\n  Version::V4\nwhen 5\n  Version::V5\nelse\n  Version::Unknown\nend"}}],"types":[{"html_id":"Crystal/UUID/Error","path":"UUID/Error.html","kind":"class","full_name":"UUID::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/uuid.cr","line_number":216,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/UUID","kind":"struct","full_name":"UUID","name":"UUID"}},{"html_id":"Crystal/UUID/Variant","path":"UUID/Variant.html","kind":"enum","full_name":"UUID::Variant","name":"Variant","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/uuid.cr","line_number":6,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Unknown","name":"Unknown","value":"0","doc":"Unknown (i.e. custom, your own).","summary":"<p>Unknown (i.e.</p>"},{"id":"NCS","name":"NCS","value":"1","doc":"Reserved by the NCS for backward compatibility.","summary":"<p>Reserved by the NCS for backward compatibility.</p>"},{"id":"RFC4122","name":"RFC4122","value":"2","doc":"Reserved for RFC4122 Specification (default).","summary":"<p>Reserved for RFC4122 Specification (default).</p>"},{"id":"Microsoft","name":"Microsoft","value":"3","doc":"Reserved by Microsoft for backward compatibility.","summary":"<p>Reserved by Microsoft for backward compatibility.</p>"},{"id":"Future","name":"Future","value":"4","doc":"Reserved for future expansion.","summary":"<p>Reserved for future expansion.</p>"}],"namespace":{"html_id":"Crystal/UUID","kind":"struct","full_name":"UUID","name":"UUID"},"doc":"Variants with 16 bytes.","summary":"<p>Variants with 16 bytes.</p>","instance_methods":[{"html_id":"future?-instance-method","name":"future?","abstract":false,"location":{"filename":"src/uuid.cr","line_number":16,"url":null},"def":{"name":"future?","visibility":"Public","body":"self == Future"}},{"html_id":"microsoft?-instance-method","name":"microsoft?","abstract":false,"location":{"filename":"src/uuid.cr","line_number":14,"url":null},"def":{"name":"microsoft?","visibility":"Public","body":"self == Microsoft"}},{"html_id":"ncs?-instance-method","name":"ncs?","abstract":false,"location":{"filename":"src/uuid.cr","line_number":10,"url":null},"def":{"name":"ncs?","visibility":"Public","body":"self == NCS"}},{"html_id":"rfc4122?-instance-method","name":"rfc4122?","abstract":false,"location":{"filename":"src/uuid.cr","line_number":12,"url":null},"def":{"name":"rfc4122?","visibility":"Public","body":"self == RFC4122"}},{"html_id":"unknown?-instance-method","name":"unknown?","abstract":false,"location":{"filename":"src/uuid.cr","line_number":8,"url":null},"def":{"name":"unknown?","visibility":"Public","body":"self == Unknown"}}]},{"html_id":"Crystal/UUID/Version","path":"UUID/Version.html","kind":"enum","full_name":"UUID::Version","name":"Version","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/uuid.cr","line_number":20,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"Unknown","name":"Unknown","value":"0","doc":"Unknown version.","summary":"<p>Unknown version.</p>"},{"id":"V1","name":"V1","value":"1","doc":"Date-time and MAC address.","summary":"<p>Date-time and MAC address.</p>"},{"id":"V2","name":"V2","value":"2","doc":"DCE security.","summary":"<p>DCE security.</p>"},{"id":"V3","name":"V3","value":"3","doc":"MD5 hash and namespace.","summary":"<p>MD5 hash and namespace.</p>"},{"id":"V4","name":"V4","value":"4","doc":"Random.","summary":"<p>Random.</p>"},{"id":"V5","name":"V5","value":"5","doc":"SHA1 hash and namespace.","summary":"<p>SHA1 hash and namespace.</p>"}],"namespace":{"html_id":"Crystal/UUID","kind":"struct","full_name":"UUID","name":"UUID"},"doc":"RFC4122 UUID versions.","summary":"<p>RFC4122 UUID versions.</p>","instance_methods":[{"html_id":"unknown?-instance-method","name":"unknown?","abstract":false,"location":{"filename":"src/uuid.cr","line_number":22,"url":null},"def":{"name":"unknown?","visibility":"Public","body":"self == Unknown"}},{"html_id":"v1?-instance-method","name":"v1?","abstract":false,"location":{"filename":"src/uuid.cr","line_number":24,"url":null},"def":{"name":"v1?","visibility":"Public","body":"self == V1"}},{"html_id":"v2?-instance-method","name":"v2?","abstract":false,"location":{"filename":"src/uuid.cr","line_number":26,"url":null},"def":{"name":"v2?","visibility":"Public","body":"self == V2"}},{"html_id":"v3?-instance-method","name":"v3?","abstract":false,"location":{"filename":"src/uuid.cr","line_number":28,"url":null},"def":{"name":"v3?","visibility":"Public","body":"self == V3"}},{"html_id":"v4?-instance-method","name":"v4?","abstract":false,"location":{"filename":"src/uuid.cr","line_number":30,"url":null},"def":{"name":"v4?","visibility":"Public","body":"self == V4"}},{"html_id":"v5?-instance-method","name":"v5?","abstract":false,"location":{"filename":"src/uuid.cr","line_number":32,"url":null},"def":{"name":"v5?","visibility":"Public","body":"self == V5"}}]}]},{"html_id":"Crystal/VaList","path":"VaList.html","kind":"struct","full_name":"VaList","name":"VaList","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/va_list.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"class_methods":[{"html_id":"open(&)-class-method","name":"open","abstract":false,"location":{"filename":"src/va_list.cr","line_number":11,"url":null},"def":{"name":"open","yields":1,"visibility":"Public","body":"ap = uninitialized LibC::VaList\nIntrinsics.va_start(pointerof(ap))\nbegin\n  yield new(ap)\nensure\n  Intrinsics.va_end(pointerof(ap))\nend\n"}}],"instance_methods":[{"html_id":"next(type)-instance-method","name":"next","abstract":false,"args":[{"name":"type","external_name":"type","restriction":""}],"args_string":"(type)","args_html":"(type)","location":{"filename":"src/va_list.cr","line_number":21,"url":null},"def":{"name":"next","args":[{"name":"type","external_name":"type","restriction":""}],"visibility":"Public","body":"# primitive: va_arg"}}]},{"html_id":"Crystal/Value","path":"Value.html","kind":"struct","full_name":"Value","name":"Value","abstract":true,"superclass":{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"},"ancestors":[{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/json/any.cr","line_number":301,"url":null},{"filename":"src/value.cr","line_number":11,"url":null},{"filename":"src/yaml/any.cr","line_number":340,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/Bool","kind":"struct","full_name":"Bool","name":"Bool"},{"html_id":"Crystal/Char","kind":"struct","full_name":"Char","name":"Char"},{"html_id":"Crystal/Class","kind":"class","full_name":"Class","name":"Class"},{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/NamedTuple","kind":"struct","full_name":"NamedTuple(**T)","name":"NamedTuple"},{"html_id":"Crystal/Nil","kind":"struct","full_name":"Nil","name":"Nil"},{"html_id":"Crystal/Number","kind":"struct","full_name":"Number","name":"Number"},{"html_id":"Crystal/Pointer","kind":"struct","full_name":"Pointer(T)","name":"Pointer"},{"html_id":"Crystal/Proc","kind":"struct","full_name":"Proc(*T, R)","name":"Proc"},{"html_id":"Crystal/StaticArray","kind":"struct","full_name":"StaticArray(T, N)","name":"StaticArray"},{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Symbol","kind":"struct","full_name":"Symbol","name":"Symbol"},{"html_id":"Crystal/Tuple","kind":"struct","full_name":"Tuple(*T)","name":"Tuple"},{"html_id":"Crystal/Union","kind":"struct","full_name":"Union(*T)","name":"Union"}],"doc":"`Value` is the base type of the primitive types (`Nil`, `Bool`, `Char`, `Number`),\n`Symbol`, `Pointer`, `Tuple`, `StaticArray` and all structs.\n\nA `Value` is passed by value: when you pass it to methods,\nreturn it from methods or assign it to variables, a copy\nof the value is actually passed.\nThis is not important for nil, bools, integers, floats, symbols,\npointers and tuples, because they are immutable, but with a mutable\n`Struct` or with a `StaticArray` you have to be careful. Read their\ndocumentation to learn more about this.","summary":"<p><code><a href=\"Value.html\">Value</a></code> is the base type of the primitive types (<code><a href=\"Nil.html\">Nil</a></code>, <code><a href=\"Bool.html\">Bool</a></code>, <code><a href=\"Char.html\">Char</a></code>, <code><a href=\"Number.html\">Number</a></code>), <code><a href=\"Symbol.html\">Symbol</a></code>, <code><a href=\"Pointer.html\">Pointer</a></code>, <code><a href=\"Tuple.html\">Tuple</a></code>, <code><a href=\"StaticArray.html\">StaticArray</a></code> and all structs.</p>","instance_methods":[{"html_id":"==(other:JSON::Any)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"JSON::Any"}],"args_string":"(other : JSON::Any)","args_html":"(other : <a href=\"JSON/Any.html\">JSON::Any</a>)","location":{"filename":"src/json/any.cr","line_number":302,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"JSON::Any"}],"visibility":"Public","body":"self == other.raw"}},{"html_id":"==(other:YAML::Any)-instance-method","name":"==","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"YAML::Any"}],"args_string":"(other : YAML::Any)","args_html":"(other : <a href=\"YAML/Any.html\">YAML::Any</a>)","location":{"filename":"src/yaml/any.cr","line_number":341,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"YAML::Any"}],"visibility":"Public","body":"self == other.raw"}},{"html_id":"==(other)-instance-method","name":"==","doc":"Returns `false`.","summary":"<p>Returns <code>false</code>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/value.cr","line_number":13,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"false"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a shallow copy of this object.\n\nBecause `Value` is a value type, this method returns `self`,\nwhich already involves a shallow copy of this object because\nvalue types are passed by value.","summary":"<p>Returns a shallow copy of this object.</p>","abstract":false,"location":{"filename":"src/value.cr","line_number":22,"url":null},"def":{"name":"dup","visibility":"Public","body":"self"}}]},{"html_id":"Crystal/WeakRef","path":"WeakRef.html","kind":"class","full_name":"WeakRef(T)","name":"WeakRef","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/weak_ref.cr","line_number":11,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"Weak Reference class that allows a referenced object to be garbage-collected.\n\n```\nrequire \"weak_ref\"\n\nref = WeakRef.new(\"oof\".reverse)\np ref.value # => \"foo\"\nGC.collect\np ref.value # => nil\n```","summary":"<p>Weak Reference class that allows a referenced object to be garbage-collected.</p>","constructors":[{"html_id":"new(target:T)-class-method","name":"new","abstract":false,"args":[{"name":"target","external_name":"target","restriction":"T"}],"args_string":"(target : T)","args_html":"(target : T)","location":{"filename":"src/weak_ref.cr","line_number":14,"url":null},"def":{"name":"new","args":[{"name":"target","external_name":"target","restriction":"T"}],"visibility":"Public","body":"_ = WeakRef(T).allocate\n_.initialize(target)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"value-instance-method","name":"value","doc":"Returns the referenced object or `Nil` if it has been garbage-collected.","summary":"<p>Returns the referenced object or <code><a href=\"Nil.html\">Nil</a></code> if it has been garbage-collected.</p>","abstract":false,"location":{"filename":"src/weak_ref.cr","line_number":29,"url":null},"def":{"name":"value","visibility":"Public","body":"@target.as(T | ::Nil)"}}]},{"html_id":"Crystal/WinError","path":"WinError.html","kind":"enum","full_name":"WinError","name":"WinError","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/winerror.cr","line_number":8,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"ERROR_SUCCESS","name":"ERROR_SUCCESS","value":"0_u32"},{"id":"ERROR_INVALID_FUNCTION","name":"ERROR_INVALID_FUNCTION","value":"1_u32"},{"id":"ERROR_FILE_NOT_FOUND","name":"ERROR_FILE_NOT_FOUND","value":"2_u32"},{"id":"ERROR_PATH_NOT_FOUND","name":"ERROR_PATH_NOT_FOUND","value":"3_u32"},{"id":"ERROR_TOO_MANY_OPEN_FILES","name":"ERROR_TOO_MANY_OPEN_FILES","value":"4_u32"},{"id":"ERROR_ACCESS_DENIED","name":"ERROR_ACCESS_DENIED","value":"5_u32"},{"id":"ERROR_INVALID_HANDLE","name":"ERROR_INVALID_HANDLE","value":"6_u32"},{"id":"ERROR_ARENA_TRASHED","name":"ERROR_ARENA_TRASHED","value":"7_u32"},{"id":"ERROR_NOT_ENOUGH_MEMORY","name":"ERROR_NOT_ENOUGH_MEMORY","value":"8_u32"},{"id":"ERROR_INVALID_BLOCK","name":"ERROR_INVALID_BLOCK","value":"9_u32"},{"id":"ERROR_BAD_ENVIRONMENT","name":"ERROR_BAD_ENVIRONMENT","value":"10_u32"},{"id":"ERROR_BAD_FORMAT","name":"ERROR_BAD_FORMAT","value":"11_u32"},{"id":"ERROR_INVALID_ACCESS","name":"ERROR_INVALID_ACCESS","value":"12_u32"},{"id":"ERROR_INVALID_DATA","name":"ERROR_INVALID_DATA","value":"13_u32"},{"id":"ERROR_OUTOFMEMORY","name":"ERROR_OUTOFMEMORY","value":"14_u32"},{"id":"ERROR_INVALID_DRIVE","name":"ERROR_INVALID_DRIVE","value":"15_u32"},{"id":"ERROR_CURRENT_DIRECTORY","name":"ERROR_CURRENT_DIRECTORY","value":"16_u32"},{"id":"ERROR_NOT_SAME_DEVICE","name":"ERROR_NOT_SAME_DEVICE","value":"17_u32"},{"id":"ERROR_NO_MORE_FILES","name":"ERROR_NO_MORE_FILES","value":"18_u32"},{"id":"ERROR_WRITE_PROTECT","name":"ERROR_WRITE_PROTECT","value":"19_u32"},{"id":"ERROR_BAD_UNIT","name":"ERROR_BAD_UNIT","value":"20_u32"},{"id":"ERROR_NOT_READY","name":"ERROR_NOT_READY","value":"21_u32"},{"id":"ERROR_BAD_COMMAND","name":"ERROR_BAD_COMMAND","value":"22_u32"},{"id":"ERROR_CRC","name":"ERROR_CRC","value":"23_u32"},{"id":"ERROR_BAD_LENGTH","name":"ERROR_BAD_LENGTH","value":"24_u32"},{"id":"ERROR_SEEK","name":"ERROR_SEEK","value":"25_u32"},{"id":"ERROR_NOT_DOS_DISK","name":"ERROR_NOT_DOS_DISK","value":"26_u32"},{"id":"ERROR_SECTOR_NOT_FOUND","name":"ERROR_SECTOR_NOT_FOUND","value":"27_u32"},{"id":"ERROR_OUT_OF_PAPER","name":"ERROR_OUT_OF_PAPER","value":"28_u32"},{"id":"ERROR_WRITE_FAULT","name":"ERROR_WRITE_FAULT","value":"29_u32"},{"id":"ERROR_READ_FAULT","name":"ERROR_READ_FAULT","value":"30_u32"},{"id":"ERROR_GEN_FAILURE","name":"ERROR_GEN_FAILURE","value":"31_u32"},{"id":"ERROR_SHARING_VIOLATION","name":"ERROR_SHARING_VIOLATION","value":"32_u32"},{"id":"ERROR_LOCK_VIOLATION","name":"ERROR_LOCK_VIOLATION","value":"33_u32"},{"id":"ERROR_WRONG_DISK","name":"ERROR_WRONG_DISK","value":"34_u32"},{"id":"ERROR_SHARING_BUFFER_EXCEEDED","name":"ERROR_SHARING_BUFFER_EXCEEDED","value":"36_u32"},{"id":"ERROR_HANDLE_EOF","name":"ERROR_HANDLE_EOF","value":"38_u32"},{"id":"ERROR_HANDLE_DISK_FULL","name":"ERROR_HANDLE_DISK_FULL","value":"39_u32"},{"id":"ERROR_NOT_SUPPORTED","name":"ERROR_NOT_SUPPORTED","value":"50_u32"},{"id":"ERROR_REM_NOT_LIST","name":"ERROR_REM_NOT_LIST","value":"51_u32"},{"id":"ERROR_DUP_NAME","name":"ERROR_DUP_NAME","value":"52_u32"},{"id":"ERROR_BAD_NETPATH","name":"ERROR_BAD_NETPATH","value":"53_u32"},{"id":"ERROR_NETWORK_BUSY","name":"ERROR_NETWORK_BUSY","value":"54_u32"},{"id":"ERROR_DEV_NOT_EXIST","name":"ERROR_DEV_NOT_EXIST","value":"55_u32"},{"id":"ERROR_TOO_MANY_CMDS","name":"ERROR_TOO_MANY_CMDS","value":"56_u32"},{"id":"ERROR_ADAP_HDW_ERR","name":"ERROR_ADAP_HDW_ERR","value":"57_u32"},{"id":"ERROR_BAD_NET_RESP","name":"ERROR_BAD_NET_RESP","value":"58_u32"},{"id":"ERROR_UNEXP_NET_ERR","name":"ERROR_UNEXP_NET_ERR","value":"59_u32"},{"id":"ERROR_BAD_REM_ADAP","name":"ERROR_BAD_REM_ADAP","value":"60_u32"},{"id":"ERROR_PRINTQ_FULL","name":"ERROR_PRINTQ_FULL","value":"61_u32"},{"id":"ERROR_NO_SPOOL_SPACE","name":"ERROR_NO_SPOOL_SPACE","value":"62_u32"},{"id":"ERROR_PRINT_CANCELLED","name":"ERROR_PRINT_CANCELLED","value":"63_u32"},{"id":"ERROR_NETNAME_DELETED","name":"ERROR_NETNAME_DELETED","value":"64_u32"},{"id":"ERROR_NETWORK_ACCESS_DENIED","name":"ERROR_NETWORK_ACCESS_DENIED","value":"65_u32"},{"id":"ERROR_BAD_DEV_TYPE","name":"ERROR_BAD_DEV_TYPE","value":"66_u32"},{"id":"ERROR_BAD_NET_NAME","name":"ERROR_BAD_NET_NAME","value":"67_u32"},{"id":"ERROR_TOO_MANY_NAMES","name":"ERROR_TOO_MANY_NAMES","value":"68_u32"},{"id":"ERROR_TOO_MANY_SESS","name":"ERROR_TOO_MANY_SESS","value":"69_u32"},{"id":"ERROR_SHARING_PAUSED","name":"ERROR_SHARING_PAUSED","value":"70_u32"},{"id":"ERROR_REQ_NOT_ACCEP","name":"ERROR_REQ_NOT_ACCEP","value":"71_u32"},{"id":"ERROR_REDIR_PAUSED","name":"ERROR_REDIR_PAUSED","value":"72_u32"},{"id":"ERROR_FILE_EXISTS","name":"ERROR_FILE_EXISTS","value":"80_u32"},{"id":"ERROR_CANNOT_MAKE","name":"ERROR_CANNOT_MAKE","value":"82_u32"},{"id":"ERROR_FAIL_I24","name":"ERROR_FAIL_I24","value":"83_u32"},{"id":"ERROR_OUT_OF_STRUCTURES","name":"ERROR_OUT_OF_STRUCTURES","value":"84_u32"},{"id":"ERROR_ALREADY_ASSIGNED","name":"ERROR_ALREADY_ASSIGNED","value":"85_u32"},{"id":"ERROR_INVALID_PASSWORD","name":"ERROR_INVALID_PASSWORD","value":"86_u32"},{"id":"ERROR_INVALID_PARAMETER","name":"ERROR_INVALID_PARAMETER","value":"87_u32"},{"id":"ERROR_NET_WRITE_FAULT","name":"ERROR_NET_WRITE_FAULT","value":"88_u32"},{"id":"ERROR_NO_PROC_SLOTS","name":"ERROR_NO_PROC_SLOTS","value":"89_u32"},{"id":"ERROR_TOO_MANY_SEMAPHORES","name":"ERROR_TOO_MANY_SEMAPHORES","value":"100_u32"},{"id":"ERROR_EXCL_SEM_ALREADY_OWNED","name":"ERROR_EXCL_SEM_ALREADY_OWNED","value":"101_u32"},{"id":"ERROR_SEM_IS_SET","name":"ERROR_SEM_IS_SET","value":"102_u32"},{"id":"ERROR_TOO_MANY_SEM_REQUESTS","name":"ERROR_TOO_MANY_SEM_REQUESTS","value":"103_u32"},{"id":"ERROR_INVALID_AT_INTERRUPT_TIME","name":"ERROR_INVALID_AT_INTERRUPT_TIME","value":"104_u32"},{"id":"ERROR_SEM_OWNER_DIED","name":"ERROR_SEM_OWNER_DIED","value":"105_u32"},{"id":"ERROR_SEM_USER_LIMIT","name":"ERROR_SEM_USER_LIMIT","value":"106_u32"},{"id":"ERROR_DISK_CHANGE","name":"ERROR_DISK_CHANGE","value":"107_u32"},{"id":"ERROR_DRIVE_LOCKED","name":"ERROR_DRIVE_LOCKED","value":"108_u32"},{"id":"ERROR_BROKEN_PIPE","name":"ERROR_BROKEN_PIPE","value":"109_u32"},{"id":"ERROR_OPEN_FAILED","name":"ERROR_OPEN_FAILED","value":"110_u32"},{"id":"ERROR_BUFFER_OVERFLOW","name":"ERROR_BUFFER_OVERFLOW","value":"111_u32"},{"id":"ERROR_DISK_FULL","name":"ERROR_DISK_FULL","value":"112_u32"},{"id":"ERROR_NO_MORE_SEARCH_HANDLES","name":"ERROR_NO_MORE_SEARCH_HANDLES","value":"113_u32"},{"id":"ERROR_INVALID_TARGET_HANDLE","name":"ERROR_INVALID_TARGET_HANDLE","value":"114_u32"},{"id":"ERROR_INVALID_CATEGORY","name":"ERROR_INVALID_CATEGORY","value":"117_u32"},{"id":"ERROR_INVALID_VERIFY_SWITCH","name":"ERROR_INVALID_VERIFY_SWITCH","value":"118_u32"},{"id":"ERROR_BAD_DRIVER_LEVEL","name":"ERROR_BAD_DRIVER_LEVEL","value":"119_u32"},{"id":"ERROR_CALL_NOT_IMPLEMENTED","name":"ERROR_CALL_NOT_IMPLEMENTED","value":"120_u32"},{"id":"ERROR_SEM_TIMEOUT","name":"ERROR_SEM_TIMEOUT","value":"121_u32"},{"id":"ERROR_INSUFFICIENT_BUFFER","name":"ERROR_INSUFFICIENT_BUFFER","value":"122_u32"},{"id":"ERROR_INVALID_NAME","name":"ERROR_INVALID_NAME","value":"123_u32"},{"id":"ERROR_INVALID_LEVEL","name":"ERROR_INVALID_LEVEL","value":"124_u32"},{"id":"ERROR_NO_VOLUME_LABEL","name":"ERROR_NO_VOLUME_LABEL","value":"125_u32"},{"id":"ERROR_MOD_NOT_FOUND","name":"ERROR_MOD_NOT_FOUND","value":"126_u32"},{"id":"ERROR_PROC_NOT_FOUND","name":"ERROR_PROC_NOT_FOUND","value":"127_u32"},{"id":"ERROR_WAIT_NO_CHILDREN","name":"ERROR_WAIT_NO_CHILDREN","value":"128_u32"},{"id":"ERROR_CHILD_NOT_COMPLETE","name":"ERROR_CHILD_NOT_COMPLETE","value":"129_u32"},{"id":"ERROR_DIRECT_ACCESS_HANDLE","name":"ERROR_DIRECT_ACCESS_HANDLE","value":"130_u32"},{"id":"ERROR_NEGATIVE_SEEK","name":"ERROR_NEGATIVE_SEEK","value":"131_u32"},{"id":"ERROR_SEEK_ON_DEVICE","name":"ERROR_SEEK_ON_DEVICE","value":"132_u32"},{"id":"ERROR_IS_JOIN_TARGET","name":"ERROR_IS_JOIN_TARGET","value":"133_u32"},{"id":"ERROR_IS_JOINED","name":"ERROR_IS_JOINED","value":"134_u32"},{"id":"ERROR_IS_SUBSTED","name":"ERROR_IS_SUBSTED","value":"135_u32"},{"id":"ERROR_NOT_JOINED","name":"ERROR_NOT_JOINED","value":"136_u32"},{"id":"ERROR_NOT_SUBSTED","name":"ERROR_NOT_SUBSTED","value":"137_u32"},{"id":"ERROR_JOIN_TO_JOIN","name":"ERROR_JOIN_TO_JOIN","value":"138_u32"},{"id":"ERROR_SUBST_TO_SUBST","name":"ERROR_SUBST_TO_SUBST","value":"139_u32"},{"id":"ERROR_JOIN_TO_SUBST","name":"ERROR_JOIN_TO_SUBST","value":"140_u32"},{"id":"ERROR_SUBST_TO_JOIN","name":"ERROR_SUBST_TO_JOIN","value":"141_u32"},{"id":"ERROR_BUSY_DRIVE","name":"ERROR_BUSY_DRIVE","value":"142_u32"},{"id":"ERROR_SAME_DRIVE","name":"ERROR_SAME_DRIVE","value":"143_u32"},{"id":"ERROR_DIR_NOT_ROOT","name":"ERROR_DIR_NOT_ROOT","value":"144_u32"},{"id":"ERROR_DIR_NOT_EMPTY","name":"ERROR_DIR_NOT_EMPTY","value":"145_u32"},{"id":"ERROR_IS_SUBST_PATH","name":"ERROR_IS_SUBST_PATH","value":"146_u32"},{"id":"ERROR_IS_JOIN_PATH","name":"ERROR_IS_JOIN_PATH","value":"147_u32"},{"id":"ERROR_PATH_BUSY","name":"ERROR_PATH_BUSY","value":"148_u32"},{"id":"ERROR_IS_SUBST_TARGET","name":"ERROR_IS_SUBST_TARGET","value":"149_u32"},{"id":"ERROR_SYSTEM_TRACE","name":"ERROR_SYSTEM_TRACE","value":"150_u32"},{"id":"ERROR_INVALID_EVENT_COUNT","name":"ERROR_INVALID_EVENT_COUNT","value":"151_u32"},{"id":"ERROR_TOO_MANY_MUXWAITERS","name":"ERROR_TOO_MANY_MUXWAITERS","value":"152_u32"},{"id":"ERROR_INVALID_LIST_FORMAT","name":"ERROR_INVALID_LIST_FORMAT","value":"153_u32"},{"id":"ERROR_LABEL_TOO_LONG","name":"ERROR_LABEL_TOO_LONG","value":"154_u32"},{"id":"ERROR_TOO_MANY_TCBS","name":"ERROR_TOO_MANY_TCBS","value":"155_u32"},{"id":"ERROR_SIGNAL_REFUSED","name":"ERROR_SIGNAL_REFUSED","value":"156_u32"},{"id":"ERROR_DISCARDED","name":"ERROR_DISCARDED","value":"157_u32"},{"id":"ERROR_NOT_LOCKED","name":"ERROR_NOT_LOCKED","value":"158_u32"},{"id":"ERROR_BAD_THREADID_ADDR","name":"ERROR_BAD_THREADID_ADDR","value":"159_u32"},{"id":"ERROR_BAD_ARGUMENTS","name":"ERROR_BAD_ARGUMENTS","value":"160_u32"},{"id":"ERROR_BAD_PATHNAME","name":"ERROR_BAD_PATHNAME","value":"161_u32"},{"id":"ERROR_SIGNAL_PENDING","name":"ERROR_SIGNAL_PENDING","value":"162_u32"},{"id":"ERROR_MAX_THRDS_REACHED","name":"ERROR_MAX_THRDS_REACHED","value":"164_u32"},{"id":"ERROR_LOCK_FAILED","name":"ERROR_LOCK_FAILED","value":"167_u32"},{"id":"ERROR_BUSY","name":"ERROR_BUSY","value":"170_u32"},{"id":"ERROR_CANCEL_VIOLATION","name":"ERROR_CANCEL_VIOLATION","value":"173_u32"},{"id":"ERROR_ATOMIC_LOCKS_NOT_SUPPORTED","name":"ERROR_ATOMIC_LOCKS_NOT_SUPPORTED","value":"174_u32"},{"id":"ERROR_INVALID_SEGMENT_NUMBER","name":"ERROR_INVALID_SEGMENT_NUMBER","value":"180_u32"},{"id":"ERROR_INVALID_ORDINAL","name":"ERROR_INVALID_ORDINAL","value":"182_u32"},{"id":"ERROR_ALREADY_EXISTS","name":"ERROR_ALREADY_EXISTS","value":"183_u32"},{"id":"ERROR_INVALID_FLAG_NUMBER","name":"ERROR_INVALID_FLAG_NUMBER","value":"186_u32"},{"id":"ERROR_SEM_NOT_FOUND","name":"ERROR_SEM_NOT_FOUND","value":"187_u32"},{"id":"ERROR_INVALID_STARTING_CODESEG","name":"ERROR_INVALID_STARTING_CODESEG","value":"188_u32"},{"id":"ERROR_INVALID_STACKSEG","name":"ERROR_INVALID_STACKSEG","value":"189_u32"},{"id":"ERROR_INVALID_MODULETYPE","name":"ERROR_INVALID_MODULETYPE","value":"190_u32"},{"id":"ERROR_INVALID_EXE_SIGNATURE","name":"ERROR_INVALID_EXE_SIGNATURE","value":"191_u32"},{"id":"ERROR_EXE_MARKED_INVALID","name":"ERROR_EXE_MARKED_INVALID","value":"192_u32"},{"id":"ERROR_BAD_EXE_FORMAT","name":"ERROR_BAD_EXE_FORMAT","value":"193_u32"},{"id":"ERROR_ITERATED_DATA_EXCEEDS_64k","name":"ERROR_ITERATED_DATA_EXCEEDS_64k","value":"194_u32"},{"id":"ERROR_INVALID_MINALLOCSIZE","name":"ERROR_INVALID_MINALLOCSIZE","value":"195_u32"},{"id":"ERROR_DYNLINK_FROM_INVALID_RING","name":"ERROR_DYNLINK_FROM_INVALID_RING","value":"196_u32"},{"id":"ERROR_IOPL_NOT_ENABLED","name":"ERROR_IOPL_NOT_ENABLED","value":"197_u32"},{"id":"ERROR_INVALID_SEGDPL","name":"ERROR_INVALID_SEGDPL","value":"198_u32"},{"id":"ERROR_AUTODATASEG_EXCEEDS_64k","name":"ERROR_AUTODATASEG_EXCEEDS_64k","value":"199_u32"},{"id":"ERROR_RING2SEG_MUST_BE_MOVABLE","name":"ERROR_RING2SEG_MUST_BE_MOVABLE","value":"200_u32"},{"id":"ERROR_RELOC_CHAIN_XEEDS_SEGLIM","name":"ERROR_RELOC_CHAIN_XEEDS_SEGLIM","value":"201_u32"},{"id":"ERROR_INFLOOP_IN_RELOC_CHAIN","name":"ERROR_INFLOOP_IN_RELOC_CHAIN","value":"202_u32"},{"id":"ERROR_ENVVAR_NOT_FOUND","name":"ERROR_ENVVAR_NOT_FOUND","value":"203_u32"},{"id":"ERROR_NO_SIGNAL_SENT","name":"ERROR_NO_SIGNAL_SENT","value":"205_u32"},{"id":"ERROR_FILENAME_EXCED_RANGE","name":"ERROR_FILENAME_EXCED_RANGE","value":"206_u32"},{"id":"ERROR_RING2_STACK_IN_USE","name":"ERROR_RING2_STACK_IN_USE","value":"207_u32"},{"id":"ERROR_META_EXPANSION_TOO_LONG","name":"ERROR_META_EXPANSION_TOO_LONG","value":"208_u32"},{"id":"ERROR_INVALID_SIGNAL_NUMBER","name":"ERROR_INVALID_SIGNAL_NUMBER","value":"209_u32"},{"id":"ERROR_THREAD_1_INACTIVE","name":"ERROR_THREAD_1_INACTIVE","value":"210_u32"},{"id":"ERROR_LOCKED","name":"ERROR_LOCKED","value":"212_u32"},{"id":"ERROR_TOO_MANY_MODULES","name":"ERROR_TOO_MANY_MODULES","value":"214_u32"},{"id":"ERROR_NESTING_NOT_ALLOWED","name":"ERROR_NESTING_NOT_ALLOWED","value":"215_u32"},{"id":"ERROR_EXE_MACHINE_TYPE_MISMATCH","name":"ERROR_EXE_MACHINE_TYPE_MISMATCH","value":"216_u32"},{"id":"ERROR_EXE_CANNOT_MODIFY_SIGNED_BINARY","name":"ERROR_EXE_CANNOT_MODIFY_SIGNED_BINARY","value":"217_u32"},{"id":"ERROR_EXE_CANNOT_MODIFY_STRONG_SIGNED_BINARY","name":"ERROR_EXE_CANNOT_MODIFY_STRONG_SIGNED_BINARY","value":"218_u32"},{"id":"ERROR_FILE_CHECKED_OUT","name":"ERROR_FILE_CHECKED_OUT","value":"220_u32"},{"id":"ERROR_CHECKOUT_REQUIRED","name":"ERROR_CHECKOUT_REQUIRED","value":"221_u32"},{"id":"ERROR_BAD_FILE_TYPE","name":"ERROR_BAD_FILE_TYPE","value":"222_u32"},{"id":"ERROR_FILE_TOO_LARGE","name":"ERROR_FILE_TOO_LARGE","value":"223_u32"},{"id":"ERROR_FORMS_AUTH_REQUIRED","name":"ERROR_FORMS_AUTH_REQUIRED","value":"224_u32"},{"id":"ERROR_PIPE_LOCAL","name":"ERROR_PIPE_LOCAL","value":"229_u32"},{"id":"ERROR_BAD_PIPE","name":"ERROR_BAD_PIPE","value":"230_u32"},{"id":"ERROR_PIPE_BUSY","name":"ERROR_PIPE_BUSY","value":"231_u32"},{"id":"ERROR_NO_DATA","name":"ERROR_NO_DATA","value":"232_u32"},{"id":"ERROR_PIPE_NOT_CONNECTED","name":"ERROR_PIPE_NOT_CONNECTED","value":"233_u32"},{"id":"ERROR_MORE_DATA","name":"ERROR_MORE_DATA","value":"234_u32"},{"id":"ERROR_VC_DISCONNECTED","name":"ERROR_VC_DISCONNECTED","value":"240_u32"},{"id":"ERROR_INVALID_EA_NAME","name":"ERROR_INVALID_EA_NAME","value":"254_u32"},{"id":"ERROR_EA_LIST_INCONSISTENT","name":"ERROR_EA_LIST_INCONSISTENT","value":"255_u32"},{"id":"WAIT_TIMEOUT","name":"WAIT_TIMEOUT","value":"258_u32"},{"id":"ERROR_NO_MORE_ITEMS","name":"ERROR_NO_MORE_ITEMS","value":"259_u32"},{"id":"ERROR_CANNOT_COPY","name":"ERROR_CANNOT_COPY","value":"266_u32"},{"id":"ERROR_DIRECTORY","name":"ERROR_DIRECTORY","value":"267_u32"},{"id":"ERROR_EAS_DIDNT_FIT","name":"ERROR_EAS_DIDNT_FIT","value":"275_u32"},{"id":"ERROR_EA_FILE_CORRUPT","name":"ERROR_EA_FILE_CORRUPT","value":"276_u32"},{"id":"ERROR_EA_TABLE_FULL","name":"ERROR_EA_TABLE_FULL","value":"277_u32"},{"id":"ERROR_INVALID_EA_HANDLE","name":"ERROR_INVALID_EA_HANDLE","value":"278_u32"},{"id":"ERROR_EAS_NOT_SUPPORTED","name":"ERROR_EAS_NOT_SUPPORTED","value":"282_u32"},{"id":"ERROR_NOT_OWNER","name":"ERROR_NOT_OWNER","value":"288_u32"},{"id":"ERROR_TOO_MANY_POSTS","name":"ERROR_TOO_MANY_POSTS","value":"298_u32"},{"id":"ERROR_PARTIAL_COPY","name":"ERROR_PARTIAL_COPY","value":"299_u32"},{"id":"ERROR_OPLOCK_NOT_GRANTED","name":"ERROR_OPLOCK_NOT_GRANTED","value":"300_u32"},{"id":"ERROR_INVALID_OPLOCK_PROTOCOL","name":"ERROR_INVALID_OPLOCK_PROTOCOL","value":"301_u32"},{"id":"ERROR_DISK_TOO_FRAGMENTED","name":"ERROR_DISK_TOO_FRAGMENTED","value":"302_u32"},{"id":"ERROR_DELETE_PENDING","name":"ERROR_DELETE_PENDING","value":"303_u32"},{"id":"ERROR_MR_MID_NOT_FOUND","name":"ERROR_MR_MID_NOT_FOUND","value":"317_u32"},{"id":"ERROR_SCOPE_NOT_FOUND","name":"ERROR_SCOPE_NOT_FOUND","value":"318_u32"},{"id":"ERROR_INVALID_ADDRESS","name":"ERROR_INVALID_ADDRESS","value":"487_u32"},{"id":"ERROR_ARITHMETIC_OVERFLOW","name":"ERROR_ARITHMETIC_OVERFLOW","value":"534_u32"},{"id":"ERROR_PIPE_CONNECTED","name":"ERROR_PIPE_CONNECTED","value":"535_u32"},{"id":"ERROR_PIPE_LISTENING","name":"ERROR_PIPE_LISTENING","value":"536_u32"},{"id":"ERROR_WAKE_SYSTEM","name":"ERROR_WAKE_SYSTEM","value":"730_u32"},{"id":"ERROR_WAIT_1","name":"ERROR_WAIT_1","value":"731_u32"},{"id":"ERROR_WAIT_2","name":"ERROR_WAIT_2","value":"732_u32"},{"id":"ERROR_WAIT_3","name":"ERROR_WAIT_3","value":"733_u32"},{"id":"ERROR_WAIT_63","name":"ERROR_WAIT_63","value":"734_u32"},{"id":"ERROR_ABANDONED_WAIT_0","name":"ERROR_ABANDONED_WAIT_0","value":"735_u32"},{"id":"ERROR_ABANDONED_WAIT_63","name":"ERROR_ABANDONED_WAIT_63","value":"736_u32"},{"id":"ERROR_USER_APC","name":"ERROR_USER_APC","value":"737_u32"},{"id":"ERROR_KERNEL_APC","name":"ERROR_KERNEL_APC","value":"738_u32"},{"id":"ERROR_ALERTED","name":"ERROR_ALERTED","value":"739_u32"},{"id":"ERROR_EA_ACCESS_DENIED","name":"ERROR_EA_ACCESS_DENIED","value":"994_u32"},{"id":"ERROR_OPERATION_ABORTED","name":"ERROR_OPERATION_ABORTED","value":"995_u32"},{"id":"ERROR_IO_INCOMPLETE","name":"ERROR_IO_INCOMPLETE","value":"996_u32"},{"id":"ERROR_IO_PENDING","name":"ERROR_IO_PENDING","value":"997_u32"},{"id":"ERROR_NOACCESS","name":"ERROR_NOACCESS","value":"998_u32"},{"id":"ERROR_SWAPERROR","name":"ERROR_SWAPERROR","value":"999_u32"},{"id":"ERROR_STACK_OVERFLOW","name":"ERROR_STACK_OVERFLOW","value":"1001_u32"},{"id":"ERROR_INVALID_MESSAGE","name":"ERROR_INVALID_MESSAGE","value":"1002_u32"},{"id":"ERROR_CAN_NOT_COMPLETE","name":"ERROR_CAN_NOT_COMPLETE","value":"1003_u32"},{"id":"ERROR_INVALID_FLAGS","name":"ERROR_INVALID_FLAGS","value":"1004_u32"},{"id":"ERROR_UNRECOGNIZED_VOLUME","name":"ERROR_UNRECOGNIZED_VOLUME","value":"1005_u32"},{"id":"ERROR_FILE_INVALID","name":"ERROR_FILE_INVALID","value":"1006_u32"},{"id":"ERROR_FULLSCREEN_MODE","name":"ERROR_FULLSCREEN_MODE","value":"1007_u32"},{"id":"ERROR_NO_TOKEN","name":"ERROR_NO_TOKEN","value":"1008_u32"},{"id":"ERROR_BADDB","name":"ERROR_BADDB","value":"1009_u32"},{"id":"ERROR_BADKEY","name":"ERROR_BADKEY","value":"1010_u32"},{"id":"ERROR_CANTOPEN","name":"ERROR_CANTOPEN","value":"1011_u32"},{"id":"ERROR_CANTREAD","name":"ERROR_CANTREAD","value":"1012_u32"},{"id":"ERROR_CANTWRITE","name":"ERROR_CANTWRITE","value":"1013_u32"},{"id":"ERROR_REGISTRY_RECOVERED","name":"ERROR_REGISTRY_RECOVERED","value":"1014_u32"},{"id":"ERROR_REGISTRY_CORRUPT","name":"ERROR_REGISTRY_CORRUPT","value":"1015_u32"},{"id":"ERROR_REGISTRY_IO_FAILED","name":"ERROR_REGISTRY_IO_FAILED","value":"1016_u32"},{"id":"ERROR_NOT_REGISTRY_FILE","name":"ERROR_NOT_REGISTRY_FILE","value":"1017_u32"},{"id":"ERROR_KEY_DELETED","name":"ERROR_KEY_DELETED","value":"1018_u32"},{"id":"ERROR_NO_LOG_SPACE","name":"ERROR_NO_LOG_SPACE","value":"1019_u32"},{"id":"ERROR_KEY_HAS_CHILDREN","name":"ERROR_KEY_HAS_CHILDREN","value":"1020_u32"},{"id":"ERROR_CHILD_MUST_BE_VOLATILE","name":"ERROR_CHILD_MUST_BE_VOLATILE","value":"1021_u32"},{"id":"ERROR_NOTIFY_ENUM_DIR","name":"ERROR_NOTIFY_ENUM_DIR","value":"1022_u32"},{"id":"ERROR_DEPENDENT_SERVICES_RUNNING","name":"ERROR_DEPENDENT_SERVICES_RUNNING","value":"1051_u32"},{"id":"ERROR_INVALID_SERVICE_CONTROL","name":"ERROR_INVALID_SERVICE_CONTROL","value":"1052_u32"},{"id":"ERROR_SERVICE_REQUEST_TIMEOUT","name":"ERROR_SERVICE_REQUEST_TIMEOUT","value":"1053_u32"},{"id":"ERROR_SERVICE_NO_THREAD","name":"ERROR_SERVICE_NO_THREAD","value":"1054_u32"},{"id":"ERROR_SERVICE_DATABASE_LOCKED","name":"ERROR_SERVICE_DATABASE_LOCKED","value":"1055_u32"},{"id":"ERROR_SERVICE_ALREADY_RUNNING","name":"ERROR_SERVICE_ALREADY_RUNNING","value":"1056_u32"},{"id":"ERROR_INVALID_SERVICE_ACCOUNT","name":"ERROR_INVALID_SERVICE_ACCOUNT","value":"1057_u32"},{"id":"ERROR_SERVICE_DISABLED","name":"ERROR_SERVICE_DISABLED","value":"1058_u32"},{"id":"ERROR_CIRCULAR_DEPENDENCY","name":"ERROR_CIRCULAR_DEPENDENCY","value":"1059_u32"},{"id":"ERROR_SERVICE_DOES_NOT_EXIST","name":"ERROR_SERVICE_DOES_NOT_EXIST","value":"1060_u32"},{"id":"ERROR_SERVICE_CANNOT_ACCEPT_CTRL","name":"ERROR_SERVICE_CANNOT_ACCEPT_CTRL","value":"1061_u32"},{"id":"ERROR_SERVICE_NOT_ACTIVE","name":"ERROR_SERVICE_NOT_ACTIVE","value":"1062_u32"},{"id":"ERROR_FAILED_SERVICE_CONTROLLER_CONNECT","name":"ERROR_FAILED_SERVICE_CONTROLLER_CONNECT","value":"1063_u32"},{"id":"ERROR_EXCEPTION_IN_SERVICE","name":"ERROR_EXCEPTION_IN_SERVICE","value":"1064_u32"},{"id":"ERROR_DATABASE_DOES_NOT_EXIST","name":"ERROR_DATABASE_DOES_NOT_EXIST","value":"1065_u32"},{"id":"ERROR_SERVICE_SPECIFIC_ERROR","name":"ERROR_SERVICE_SPECIFIC_ERROR","value":"1066_u32"},{"id":"ERROR_PROCESS_ABORTED","name":"ERROR_PROCESS_ABORTED","value":"1067_u32"},{"id":"ERROR_SERVICE_DEPENDENCY_FAIL","name":"ERROR_SERVICE_DEPENDENCY_FAIL","value":"1068_u32"},{"id":"ERROR_SERVICE_LOGON_FAILED","name":"ERROR_SERVICE_LOGON_FAILED","value":"1069_u32"},{"id":"ERROR_SERVICE_START_HANG","name":"ERROR_SERVICE_START_HANG","value":"1070_u32"},{"id":"ERROR_INVALID_SERVICE_LOCK","name":"ERROR_INVALID_SERVICE_LOCK","value":"1071_u32"},{"id":"ERROR_SERVICE_MARKED_FOR_DELETE","name":"ERROR_SERVICE_MARKED_FOR_DELETE","value":"1072_u32"},{"id":"ERROR_SERVICE_EXISTS","name":"ERROR_SERVICE_EXISTS","value":"1073_u32"},{"id":"ERROR_ALREADY_RUNNING_LKG","name":"ERROR_ALREADY_RUNNING_LKG","value":"1074_u32"},{"id":"ERROR_SERVICE_DEPENDENCY_DELETED","name":"ERROR_SERVICE_DEPENDENCY_DELETED","value":"1075_u32"},{"id":"ERROR_BOOT_ALREADY_ACCEPTED","name":"ERROR_BOOT_ALREADY_ACCEPTED","value":"1076_u32"},{"id":"ERROR_SERVICE_NEVER_STARTED","name":"ERROR_SERVICE_NEVER_STARTED","value":"1077_u32"},{"id":"ERROR_DUPLICATE_SERVICE_NAME","name":"ERROR_DUPLICATE_SERVICE_NAME","value":"1078_u32"},{"id":"ERROR_DIFFERENT_SERVICE_ACCOUNT","name":"ERROR_DIFFERENT_SERVICE_ACCOUNT","value":"1079_u32"},{"id":"ERROR_CANNOT_DETECT_DRIVER_FAILURE","name":"ERROR_CANNOT_DETECT_DRIVER_FAILURE","value":"1080_u32"},{"id":"ERROR_CANNOT_DETECT_PROCESS_ABORT","name":"ERROR_CANNOT_DETECT_PROCESS_ABORT","value":"1081_u32"},{"id":"ERROR_NO_RECOVERY_PROGRAM","name":"ERROR_NO_RECOVERY_PROGRAM","value":"1082_u32"},{"id":"ERROR_SERVICE_NOT_IN_EXE","name":"ERROR_SERVICE_NOT_IN_EXE","value":"1083_u32"},{"id":"ERROR_NOT_SAFEBOOT_SERVICE","name":"ERROR_NOT_SAFEBOOT_SERVICE","value":"1084_u32"},{"id":"ERROR_END_OF_MEDIA","name":"ERROR_END_OF_MEDIA","value":"1100_u32"},{"id":"ERROR_FILEMARK_DETECTED","name":"ERROR_FILEMARK_DETECTED","value":"1101_u32"},{"id":"ERROR_BEGINNING_OF_MEDIA","name":"ERROR_BEGINNING_OF_MEDIA","value":"1102_u32"},{"id":"ERROR_SETMARK_DETECTED","name":"ERROR_SETMARK_DETECTED","value":"1103_u32"},{"id":"ERROR_NO_DATA_DETECTED","name":"ERROR_NO_DATA_DETECTED","value":"1104_u32"},{"id":"ERROR_PARTITION_FAILURE","name":"ERROR_PARTITION_FAILURE","value":"1105_u32"},{"id":"ERROR_INVALID_BLOCK_LENGTH","name":"ERROR_INVALID_BLOCK_LENGTH","value":"1106_u32"},{"id":"ERROR_DEVICE_NOT_PARTITIONED","name":"ERROR_DEVICE_NOT_PARTITIONED","value":"1107_u32"},{"id":"ERROR_UNABLE_TO_LOCK_MEDIA","name":"ERROR_UNABLE_TO_LOCK_MEDIA","value":"1108_u32"},{"id":"ERROR_UNABLE_TO_UNLOAD_MEDIA","name":"ERROR_UNABLE_TO_UNLOAD_MEDIA","value":"1109_u32"},{"id":"ERROR_MEDIA_CHANGED","name":"ERROR_MEDIA_CHANGED","value":"1110_u32"},{"id":"ERROR_BUS_RESET","name":"ERROR_BUS_RESET","value":"1111_u32"},{"id":"ERROR_NO_MEDIA_IN_DRIVE","name":"ERROR_NO_MEDIA_IN_DRIVE","value":"1112_u32"},{"id":"ERROR_NO_UNICODE_TRANSLATION","name":"ERROR_NO_UNICODE_TRANSLATION","value":"1113_u32"},{"id":"ERROR_DLL_INIT_FAILED","name":"ERROR_DLL_INIT_FAILED","value":"1114_u32"},{"id":"ERROR_SHUTDOWN_IN_PROGRESS","name":"ERROR_SHUTDOWN_IN_PROGRESS","value":"1115_u32"},{"id":"ERROR_NO_SHUTDOWN_IN_PROGRESS","name":"ERROR_NO_SHUTDOWN_IN_PROGRESS","value":"1116_u32"},{"id":"ERROR_IO_DEVICE","name":"ERROR_IO_DEVICE","value":"1117_u32"},{"id":"ERROR_SERIAL_NO_DEVICE","name":"ERROR_SERIAL_NO_DEVICE","value":"1118_u32"},{"id":"ERROR_IRQ_BUSY","name":"ERROR_IRQ_BUSY","value":"1119_u32"},{"id":"ERROR_MORE_WRITES","name":"ERROR_MORE_WRITES","value":"1120_u32"},{"id":"ERROR_COUNTER_TIMEOUT","name":"ERROR_COUNTER_TIMEOUT","value":"1121_u32"},{"id":"ERROR_FLOPPY_ID_MARK_NOT_FOUND","name":"ERROR_FLOPPY_ID_MARK_NOT_FOUND","value":"1122_u32"},{"id":"ERROR_FLOPPY_WRONG_CYLINDER","name":"ERROR_FLOPPY_WRONG_CYLINDER","value":"1123_u32"},{"id":"ERROR_FLOPPY_UNKNOWN_ERROR","name":"ERROR_FLOPPY_UNKNOWN_ERROR","value":"1124_u32"},{"id":"ERROR_FLOPPY_BAD_REGISTERS","name":"ERROR_FLOPPY_BAD_REGISTERS","value":"1125_u32"},{"id":"ERROR_DISK_RECALIBRATE_FAILED","name":"ERROR_DISK_RECALIBRATE_FAILED","value":"1126_u32"},{"id":"ERROR_DISK_OPERATION_FAILED","name":"ERROR_DISK_OPERATION_FAILED","value":"1127_u32"},{"id":"ERROR_DISK_RESET_FAILED","name":"ERROR_DISK_RESET_FAILED","value":"1128_u32"},{"id":"ERROR_EOM_OVERFLOW","name":"ERROR_EOM_OVERFLOW","value":"1129_u32"},{"id":"ERROR_NOT_ENOUGH_SERVER_MEMORY","name":"ERROR_NOT_ENOUGH_SERVER_MEMORY","value":"1130_u32"},{"id":"ERROR_POSSIBLE_DEADLOCK","name":"ERROR_POSSIBLE_DEADLOCK","value":"1131_u32"},{"id":"ERROR_MAPPED_ALIGNMENT","name":"ERROR_MAPPED_ALIGNMENT","value":"1132_u32"},{"id":"ERROR_SET_POWER_STATE_VETOED","name":"ERROR_SET_POWER_STATE_VETOED","value":"1140_u32"},{"id":"ERROR_SET_POWER_STATE_FAILED","name":"ERROR_SET_POWER_STATE_FAILED","value":"1141_u32"},{"id":"ERROR_TOO_MANY_LINKS","name":"ERROR_TOO_MANY_LINKS","value":"1142_u32"},{"id":"ERROR_OLD_WIN_VERSION","name":"ERROR_OLD_WIN_VERSION","value":"1150_u32"},{"id":"ERROR_APP_WRONG_OS","name":"ERROR_APP_WRONG_OS","value":"1151_u32"},{"id":"ERROR_SINGLE_INSTANCE_APP","name":"ERROR_SINGLE_INSTANCE_APP","value":"1152_u32"},{"id":"ERROR_RMODE_APP","name":"ERROR_RMODE_APP","value":"1153_u32"},{"id":"ERROR_INVALID_DLL","name":"ERROR_INVALID_DLL","value":"1154_u32"},{"id":"ERROR_NO_ASSOCIATION","name":"ERROR_NO_ASSOCIATION","value":"1155_u32"},{"id":"ERROR_DDE_FAIL","name":"ERROR_DDE_FAIL","value":"1156_u32"},{"id":"ERROR_DLL_NOT_FOUND","name":"ERROR_DLL_NOT_FOUND","value":"1157_u32"},{"id":"ERROR_NO_MORE_USER_HANDLES","name":"ERROR_NO_MORE_USER_HANDLES","value":"1158_u32"},{"id":"ERROR_MESSAGE_SYNC_ONLY","name":"ERROR_MESSAGE_SYNC_ONLY","value":"1159_u32"},{"id":"ERROR_SOURCE_ELEMENT_EMPTY","name":"ERROR_SOURCE_ELEMENT_EMPTY","value":"1160_u32"},{"id":"ERROR_DESTINATION_ELEMENT_FULL","name":"ERROR_DESTINATION_ELEMENT_FULL","value":"1161_u32"},{"id":"ERROR_ILLEGAL_ELEMENT_ADDRESS","name":"ERROR_ILLEGAL_ELEMENT_ADDRESS","value":"1162_u32"},{"id":"ERROR_MAGAZINE_NOT_PRESENT","name":"ERROR_MAGAZINE_NOT_PRESENT","value":"1163_u32"},{"id":"ERROR_DEVICE_REINITIALIZATION_NEEDED","name":"ERROR_DEVICE_REINITIALIZATION_NEEDED","value":"1164_u32"},{"id":"ERROR_DEVICE_REQUIRES_CLEANING","name":"ERROR_DEVICE_REQUIRES_CLEANING","value":"1165_u32"},{"id":"ERROR_DEVICE_DOOR_OPEN","name":"ERROR_DEVICE_DOOR_OPEN","value":"1166_u32"},{"id":"ERROR_DEVICE_NOT_CONNECTED","name":"ERROR_DEVICE_NOT_CONNECTED","value":"1167_u32"},{"id":"ERROR_NOT_FOUND","name":"ERROR_NOT_FOUND","value":"1168_u32"},{"id":"ERROR_NO_MATCH","name":"ERROR_NO_MATCH","value":"1169_u32"},{"id":"ERROR_SET_NOT_FOUND","name":"ERROR_SET_NOT_FOUND","value":"1170_u32"},{"id":"ERROR_POINT_NOT_FOUND","name":"ERROR_POINT_NOT_FOUND","value":"1171_u32"},{"id":"ERROR_NO_TRACKING_SERVICE","name":"ERROR_NO_TRACKING_SERVICE","value":"1172_u32"},{"id":"ERROR_NO_VOLUME_ID","name":"ERROR_NO_VOLUME_ID","value":"1173_u32"},{"id":"ERROR_UNABLE_TO_REMOVE_REPLACED","name":"ERROR_UNABLE_TO_REMOVE_REPLACED","value":"1175_u32"},{"id":"ERROR_UNABLE_TO_MOVE_REPLACEMENT","name":"ERROR_UNABLE_TO_MOVE_REPLACEMENT","value":"1176_u32"},{"id":"ERROR_UNABLE_TO_MOVE_REPLACEMENT_2","name":"ERROR_UNABLE_TO_MOVE_REPLACEMENT_2","value":"1177_u32"},{"id":"ERROR_JOURNAL_DELETE_IN_PROGRESS","name":"ERROR_JOURNAL_DELETE_IN_PROGRESS","value":"1178_u32"},{"id":"ERROR_JOURNAL_NOT_ACTIVE","name":"ERROR_JOURNAL_NOT_ACTIVE","value":"1179_u32"},{"id":"ERROR_POTENTIAL_FILE_FOUND","name":"ERROR_POTENTIAL_FILE_FOUND","value":"1180_u32"},{"id":"ERROR_JOURNAL_ENTRY_DELETED","name":"ERROR_JOURNAL_ENTRY_DELETED","value":"1181_u32"},{"id":"ERROR_BAD_DEVICE","name":"ERROR_BAD_DEVICE","value":"1200_u32"},{"id":"ERROR_CONNECTION_UNAVAIL","name":"ERROR_CONNECTION_UNAVAIL","value":"1201_u32"},{"id":"ERROR_DEVICE_ALREADY_REMEMBERED","name":"ERROR_DEVICE_ALREADY_REMEMBERED","value":"1202_u32"},{"id":"ERROR_NO_NET_OR_BAD_PATH","name":"ERROR_NO_NET_OR_BAD_PATH","value":"1203_u32"},{"id":"ERROR_BAD_PROVIDER","name":"ERROR_BAD_PROVIDER","value":"1204_u32"},{"id":"ERROR_CANNOT_OPEN_PROFILE","name":"ERROR_CANNOT_OPEN_PROFILE","value":"1205_u32"},{"id":"ERROR_BAD_PROFILE","name":"ERROR_BAD_PROFILE","value":"1206_u32"},{"id":"ERROR_NOT_CONTAINER","name":"ERROR_NOT_CONTAINER","value":"1207_u32"},{"id":"ERROR_EXTENDED_ERROR","name":"ERROR_EXTENDED_ERROR","value":"1208_u32"},{"id":"ERROR_INVALID_GROUPNAME","name":"ERROR_INVALID_GROUPNAME","value":"1209_u32"},{"id":"ERROR_INVALID_COMPUTERNAME","name":"ERROR_INVALID_COMPUTERNAME","value":"1210_u32"},{"id":"ERROR_INVALID_EVENTNAME","name":"ERROR_INVALID_EVENTNAME","value":"1211_u32"},{"id":"ERROR_INVALID_DOMAINNAME","name":"ERROR_INVALID_DOMAINNAME","value":"1212_u32"},{"id":"ERROR_INVALID_SERVICENAME","name":"ERROR_INVALID_SERVICENAME","value":"1213_u32"},{"id":"ERROR_INVALID_NETNAME","name":"ERROR_INVALID_NETNAME","value":"1214_u32"},{"id":"ERROR_INVALID_SHARENAME","name":"ERROR_INVALID_SHARENAME","value":"1215_u32"},{"id":"ERROR_INVALID_PASSWORDNAME","name":"ERROR_INVALID_PASSWORDNAME","value":"1216_u32"},{"id":"ERROR_INVALID_MESSAGENAME","name":"ERROR_INVALID_MESSAGENAME","value":"1217_u32"},{"id":"ERROR_INVALID_MESSAGEDEST","name":"ERROR_INVALID_MESSAGEDEST","value":"1218_u32"},{"id":"ERROR_SESSION_CREDENTIAL_CONFLICT","name":"ERROR_SESSION_CREDENTIAL_CONFLICT","value":"1219_u32"},{"id":"ERROR_REMOTE_SESSION_LIMIT_EXCEEDED","name":"ERROR_REMOTE_SESSION_LIMIT_EXCEEDED","value":"1220_u32"},{"id":"ERROR_DUP_DOMAINNAME","name":"ERROR_DUP_DOMAINNAME","value":"1221_u32"},{"id":"ERROR_NO_NETWORK","name":"ERROR_NO_NETWORK","value":"1222_u32"},{"id":"ERROR_CANCELLED","name":"ERROR_CANCELLED","value":"1223_u32"},{"id":"ERROR_USER_MAPPED_FILE","name":"ERROR_USER_MAPPED_FILE","value":"1224_u32"},{"id":"ERROR_CONNECTION_REFUSED","name":"ERROR_CONNECTION_REFUSED","value":"1225_u32"},{"id":"ERROR_GRACEFUL_DISCONNECT","name":"ERROR_GRACEFUL_DISCONNECT","value":"1226_u32"},{"id":"ERROR_ADDRESS_ALREADY_ASSOCIATED","name":"ERROR_ADDRESS_ALREADY_ASSOCIATED","value":"1227_u32"},{"id":"ERROR_ADDRESS_NOT_ASSOCIATED","name":"ERROR_ADDRESS_NOT_ASSOCIATED","value":"1228_u32"},{"id":"ERROR_CONNECTION_INVALID","name":"ERROR_CONNECTION_INVALID","value":"1229_u32"},{"id":"ERROR_CONNECTION_ACTIVE","name":"ERROR_CONNECTION_ACTIVE","value":"1230_u32"},{"id":"ERROR_NETWORK_UNREACHABLE","name":"ERROR_NETWORK_UNREACHABLE","value":"1231_u32"},{"id":"ERROR_HOST_UNREACHABLE","name":"ERROR_HOST_UNREACHABLE","value":"1232_u32"},{"id":"ERROR_PROTOCOL_UNREACHABLE","name":"ERROR_PROTOCOL_UNREACHABLE","value":"1233_u32"},{"id":"ERROR_PORT_UNREACHABLE","name":"ERROR_PORT_UNREACHABLE","value":"1234_u32"},{"id":"ERROR_REQUEST_ABORTED","name":"ERROR_REQUEST_ABORTED","value":"1235_u32"},{"id":"ERROR_CONNECTION_ABORTED","name":"ERROR_CONNECTION_ABORTED","value":"1236_u32"},{"id":"ERROR_RETRY","name":"ERROR_RETRY","value":"1237_u32"},{"id":"ERROR_CONNECTION_COUNT_LIMIT","name":"ERROR_CONNECTION_COUNT_LIMIT","value":"1238_u32"},{"id":"ERROR_LOGIN_TIME_RESTRICTION","name":"ERROR_LOGIN_TIME_RESTRICTION","value":"1239_u32"},{"id":"ERROR_LOGIN_WKSTA_RESTRICTION","name":"ERROR_LOGIN_WKSTA_RESTRICTION","value":"1240_u32"},{"id":"ERROR_INCORRECT_ADDRESS","name":"ERROR_INCORRECT_ADDRESS","value":"1241_u32"},{"id":"ERROR_ALREADY_REGISTERED","name":"ERROR_ALREADY_REGISTERED","value":"1242_u32"},{"id":"ERROR_SERVICE_NOT_FOUND","name":"ERROR_SERVICE_NOT_FOUND","value":"1243_u32"},{"id":"ERROR_NOT_AUTHENTICATED","name":"ERROR_NOT_AUTHENTICATED","value":"1244_u32"},{"id":"ERROR_NOT_LOGGED_ON","name":"ERROR_NOT_LOGGED_ON","value":"1245_u32"},{"id":"ERROR_CONTINUE","name":"ERROR_CONTINUE","value":"1246_u32"},{"id":"ERROR_ALREADY_INITIALIZED","name":"ERROR_ALREADY_INITIALIZED","value":"1247_u32"},{"id":"ERROR_NO_MORE_DEVICES","name":"ERROR_NO_MORE_DEVICES","value":"1248_u32"},{"id":"ERROR_NO_SUCH_SITE","name":"ERROR_NO_SUCH_SITE","value":"1249_u32"},{"id":"ERROR_DOMAIN_CONTROLLER_EXISTS","name":"ERROR_DOMAIN_CONTROLLER_EXISTS","value":"1250_u32"},{"id":"ERROR_ONLY_IF_CONNECTED","name":"ERROR_ONLY_IF_CONNECTED","value":"1251_u32"},{"id":"ERROR_OVERRIDE_NOCHANGES","name":"ERROR_OVERRIDE_NOCHANGES","value":"1252_u32"},{"id":"ERROR_BAD_USER_PROFILE","name":"ERROR_BAD_USER_PROFILE","value":"1253_u32"},{"id":"ERROR_NOT_SUPPORTED_ON_SBS","name":"ERROR_NOT_SUPPORTED_ON_SBS","value":"1254_u32"},{"id":"ERROR_SERVER_SHUTDOWN_IN_PROGRESS","name":"ERROR_SERVER_SHUTDOWN_IN_PROGRESS","value":"1255_u32"},{"id":"ERROR_HOST_DOWN","name":"ERROR_HOST_DOWN","value":"1256_u32"},{"id":"ERROR_NON_ACCOUNT_SID","name":"ERROR_NON_ACCOUNT_SID","value":"1257_u32"},{"id":"ERROR_NON_DOMAIN_SID","name":"ERROR_NON_DOMAIN_SID","value":"1258_u32"},{"id":"ERROR_APPHELP_BLOCK","name":"ERROR_APPHELP_BLOCK","value":"1259_u32"},{"id":"ERROR_ACCESS_DISABLED_BY_POLICY","name":"ERROR_ACCESS_DISABLED_BY_POLICY","value":"1260_u32"},{"id":"ERROR_REG_NAT_CONSUMPTION","name":"ERROR_REG_NAT_CONSUMPTION","value":"1261_u32"},{"id":"ERROR_CSCSHARE_OFFLINE","name":"ERROR_CSCSHARE_OFFLINE","value":"1262_u32"},{"id":"ERROR_PKINIT_FAILURE","name":"ERROR_PKINIT_FAILURE","value":"1263_u32"},{"id":"ERROR_SMARTCARD_SUBSYSTEM_FAILURE","name":"ERROR_SMARTCARD_SUBSYSTEM_FAILURE","value":"1264_u32"},{"id":"ERROR_DOWNGRADE_DETECTED","name":"ERROR_DOWNGRADE_DETECTED","value":"1265_u32"},{"id":"ERROR_MACHINE_LOCKED","name":"ERROR_MACHINE_LOCKED","value":"1271_u32"},{"id":"ERROR_CALLBACK_SUPPLIED_INVALID_DATA","name":"ERROR_CALLBACK_SUPPLIED_INVALID_DATA","value":"1273_u32"},{"id":"ERROR_SYNC_FOREGROUND_REFRESH_REQUIRED","name":"ERROR_SYNC_FOREGROUND_REFRESH_REQUIRED","value":"1274_u32"},{"id":"ERROR_DRIVER_BLOCKED","name":"ERROR_DRIVER_BLOCKED","value":"1275_u32"},{"id":"ERROR_INVALID_IMPORT_OF_NON_DLL","name":"ERROR_INVALID_IMPORT_OF_NON_DLL","value":"1276_u32"},{"id":"ERROR_ACCESS_DISABLED_WEBBLADE","name":"ERROR_ACCESS_DISABLED_WEBBLADE","value":"1277_u32"},{"id":"ERROR_ACCESS_DISABLED_WEBBLADE_TAMPER","name":"ERROR_ACCESS_DISABLED_WEBBLADE_TAMPER","value":"1278_u32"},{"id":"ERROR_RECOVERY_FAILURE","name":"ERROR_RECOVERY_FAILURE","value":"1279_u32"},{"id":"ERROR_ALREADY_FIBER","name":"ERROR_ALREADY_FIBER","value":"1280_u32"},{"id":"ERROR_ALREADY_THREAD","name":"ERROR_ALREADY_THREAD","value":"1281_u32"},{"id":"ERROR_STACK_BUFFER_OVERRUN","name":"ERROR_STACK_BUFFER_OVERRUN","value":"1282_u32"},{"id":"ERROR_PARAMETER_QUOTA_EXCEEDED","name":"ERROR_PARAMETER_QUOTA_EXCEEDED","value":"1283_u32"},{"id":"ERROR_DEBUGGER_INACTIVE","name":"ERROR_DEBUGGER_INACTIVE","value":"1284_u32"},{"id":"ERROR_DELAY_LOAD_FAILED","name":"ERROR_DELAY_LOAD_FAILED","value":"1285_u32"},{"id":"ERROR_VDM_DISALLOWED","name":"ERROR_VDM_DISALLOWED","value":"1286_u32"},{"id":"ERROR_UNIDENTIFIED_ERROR","name":"ERROR_UNIDENTIFIED_ERROR","value":"1287_u32"},{"id":"ERROR_NOT_ALL_ASSIGNED","name":"ERROR_NOT_ALL_ASSIGNED","value":"1300_u32"},{"id":"ERROR_SOME_NOT_MAPPED","name":"ERROR_SOME_NOT_MAPPED","value":"1301_u32"},{"id":"ERROR_NO_QUOTAS_FOR_ACCOUNT","name":"ERROR_NO_QUOTAS_FOR_ACCOUNT","value":"1302_u32"},{"id":"ERROR_LOCAL_USER_SESSION_KEY","name":"ERROR_LOCAL_USER_SESSION_KEY","value":"1303_u32"},{"id":"ERROR_NULL_LM_PASSWORD","name":"ERROR_NULL_LM_PASSWORD","value":"1304_u32"},{"id":"ERROR_UNKNOWN_REVISION","name":"ERROR_UNKNOWN_REVISION","value":"1305_u32"},{"id":"ERROR_REVISION_MISMATCH","name":"ERROR_REVISION_MISMATCH","value":"1306_u32"},{"id":"ERROR_INVALID_OWNER","name":"ERROR_INVALID_OWNER","value":"1307_u32"},{"id":"ERROR_INVALID_PRIMARY_GROUP","name":"ERROR_INVALID_PRIMARY_GROUP","value":"1308_u32"},{"id":"ERROR_NO_IMPERSONATION_TOKEN","name":"ERROR_NO_IMPERSONATION_TOKEN","value":"1309_u32"},{"id":"ERROR_CANT_DISABLE_MANDATORY","name":"ERROR_CANT_DISABLE_MANDATORY","value":"1310_u32"},{"id":"ERROR_NO_LOGON_SERVERS","name":"ERROR_NO_LOGON_SERVERS","value":"1311_u32"},{"id":"ERROR_NO_SUCH_LOGON_SESSION","name":"ERROR_NO_SUCH_LOGON_SESSION","value":"1312_u32"},{"id":"ERROR_NO_SUCH_PRIVILEGE","name":"ERROR_NO_SUCH_PRIVILEGE","value":"1313_u32"},{"id":"ERROR_PRIVILEGE_NOT_HELD","name":"ERROR_PRIVILEGE_NOT_HELD","value":"1314_u32"},{"id":"ERROR_INVALID_ACCOUNT_NAME","name":"ERROR_INVALID_ACCOUNT_NAME","value":"1315_u32"},{"id":"ERROR_USER_EXISTS","name":"ERROR_USER_EXISTS","value":"1316_u32"},{"id":"ERROR_NO_SUCH_USER","name":"ERROR_NO_SUCH_USER","value":"1317_u32"},{"id":"ERROR_GROUP_EXISTS","name":"ERROR_GROUP_EXISTS","value":"1318_u32"},{"id":"ERROR_NO_SUCH_GROUP","name":"ERROR_NO_SUCH_GROUP","value":"1319_u32"},{"id":"ERROR_MEMBER_IN_GROUP","name":"ERROR_MEMBER_IN_GROUP","value":"1320_u32"},{"id":"ERROR_MEMBER_NOT_IN_GROUP","name":"ERROR_MEMBER_NOT_IN_GROUP","value":"1321_u32"},{"id":"ERROR_LAST_ADMIN","name":"ERROR_LAST_ADMIN","value":"1322_u32"},{"id":"ERROR_WRONG_PASSWORD","name":"ERROR_WRONG_PASSWORD","value":"1323_u32"},{"id":"ERROR_ILL_FORMED_PASSWORD","name":"ERROR_ILL_FORMED_PASSWORD","value":"1324_u32"},{"id":"ERROR_PASSWORD_RESTRICTION","name":"ERROR_PASSWORD_RESTRICTION","value":"1325_u32"},{"id":"ERROR_LOGON_FAILURE","name":"ERROR_LOGON_FAILURE","value":"1326_u32"},{"id":"ERROR_ACCOUNT_RESTRICTION","name":"ERROR_ACCOUNT_RESTRICTION","value":"1327_u32"},{"id":"ERROR_INVALID_LOGON_HOURS","name":"ERROR_INVALID_LOGON_HOURS","value":"1328_u32"},{"id":"ERROR_INVALID_WORKSTATION","name":"ERROR_INVALID_WORKSTATION","value":"1329_u32"},{"id":"ERROR_PASSWORD_EXPIRED","name":"ERROR_PASSWORD_EXPIRED","value":"1330_u32"},{"id":"ERROR_ACCOUNT_DISABLED","name":"ERROR_ACCOUNT_DISABLED","value":"1331_u32"},{"id":"ERROR_NONE_MAPPED","name":"ERROR_NONE_MAPPED","value":"1332_u32"},{"id":"ERROR_TOO_MANY_LUIDS_REQUESTED","name":"ERROR_TOO_MANY_LUIDS_REQUESTED","value":"1333_u32"},{"id":"ERROR_LUIDS_EXHAUSTED","name":"ERROR_LUIDS_EXHAUSTED","value":"1334_u32"},{"id":"ERROR_INVALID_SUB_AUTHORITY","name":"ERROR_INVALID_SUB_AUTHORITY","value":"1335_u32"},{"id":"ERROR_INVALID_ACL","name":"ERROR_INVALID_ACL","value":"1336_u32"},{"id":"ERROR_INVALID_SID","name":"ERROR_INVALID_SID","value":"1337_u32"},{"id":"ERROR_INVALID_SECURITY_DESCR","name":"ERROR_INVALID_SECURITY_DESCR","value":"1338_u32"},{"id":"ERROR_BAD_INHERITANCE_ACL","name":"ERROR_BAD_INHERITANCE_ACL","value":"1340_u32"},{"id":"ERROR_SERVER_DISABLED","name":"ERROR_SERVER_DISABLED","value":"1341_u32"},{"id":"ERROR_SERVER_NOT_DISABLED","name":"ERROR_SERVER_NOT_DISABLED","value":"1342_u32"},{"id":"ERROR_INVALID_ID_AUTHORITY","name":"ERROR_INVALID_ID_AUTHORITY","value":"1343_u32"},{"id":"ERROR_ALLOTTED_SPACE_EXCEEDED","name":"ERROR_ALLOTTED_SPACE_EXCEEDED","value":"1344_u32"},{"id":"ERROR_INVALID_GROUP_ATTRIBUTES","name":"ERROR_INVALID_GROUP_ATTRIBUTES","value":"1345_u32"},{"id":"ERROR_BAD_IMPERSONATION_LEVEL","name":"ERROR_BAD_IMPERSONATION_LEVEL","value":"1346_u32"},{"id":"ERROR_CANT_OPEN_ANONYMOUS","name":"ERROR_CANT_OPEN_ANONYMOUS","value":"1347_u32"},{"id":"ERROR_BAD_VALIDATION_CLASS","name":"ERROR_BAD_VALIDATION_CLASS","value":"1348_u32"},{"id":"ERROR_BAD_TOKEN_TYPE","name":"ERROR_BAD_TOKEN_TYPE","value":"1349_u32"},{"id":"ERROR_NO_SECURITY_ON_OBJECT","name":"ERROR_NO_SECURITY_ON_OBJECT","value":"1350_u32"},{"id":"ERROR_CANT_ACCESS_DOMAIN_INFO","name":"ERROR_CANT_ACCESS_DOMAIN_INFO","value":"1351_u32"},{"id":"ERROR_INVALID_SERVER_STATE","name":"ERROR_INVALID_SERVER_STATE","value":"1352_u32"},{"id":"ERROR_INVALID_DOMAIN_STATE","name":"ERROR_INVALID_DOMAIN_STATE","value":"1353_u32"},{"id":"ERROR_INVALID_DOMAIN_ROLE","name":"ERROR_INVALID_DOMAIN_ROLE","value":"1354_u32"},{"id":"ERROR_NO_SUCH_DOMAIN","name":"ERROR_NO_SUCH_DOMAIN","value":"1355_u32"},{"id":"ERROR_DOMAIN_EXISTS","name":"ERROR_DOMAIN_EXISTS","value":"1356_u32"},{"id":"ERROR_DOMAIN_LIMIT_EXCEEDED","name":"ERROR_DOMAIN_LIMIT_EXCEEDED","value":"1357_u32"},{"id":"ERROR_INTERNAL_DB_CORRUPTION","name":"ERROR_INTERNAL_DB_CORRUPTION","value":"1358_u32"},{"id":"ERROR_INTERNAL_ERROR","name":"ERROR_INTERNAL_ERROR","value":"1359_u32"},{"id":"ERROR_GENERIC_NOT_MAPPED","name":"ERROR_GENERIC_NOT_MAPPED","value":"1360_u32"},{"id":"ERROR_BAD_DESCRIPTOR_FORMAT","name":"ERROR_BAD_DESCRIPTOR_FORMAT","value":"1361_u32"},{"id":"ERROR_NOT_LOGON_PROCESS","name":"ERROR_NOT_LOGON_PROCESS","value":"1362_u32"},{"id":"ERROR_LOGON_SESSION_EXISTS","name":"ERROR_LOGON_SESSION_EXISTS","value":"1363_u32"},{"id":"ERROR_NO_SUCH_PACKAGE","name":"ERROR_NO_SUCH_PACKAGE","value":"1364_u32"},{"id":"ERROR_BAD_LOGON_SESSION_STATE","name":"ERROR_BAD_LOGON_SESSION_STATE","value":"1365_u32"},{"id":"ERROR_LOGON_SESSION_COLLISION","name":"ERROR_LOGON_SESSION_COLLISION","value":"1366_u32"},{"id":"ERROR_INVALID_LOGON_TYPE","name":"ERROR_INVALID_LOGON_TYPE","value":"1367_u32"},{"id":"ERROR_CANNOT_IMPERSONATE","name":"ERROR_CANNOT_IMPERSONATE","value":"1368_u32"},{"id":"ERROR_RXACT_INVALID_STATE","name":"ERROR_RXACT_INVALID_STATE","value":"1369_u32"},{"id":"ERROR_RXACT_COMMIT_FAILURE","name":"ERROR_RXACT_COMMIT_FAILURE","value":"1370_u32"},{"id":"ERROR_SPECIAL_ACCOUNT","name":"ERROR_SPECIAL_ACCOUNT","value":"1371_u32"},{"id":"ERROR_SPECIAL_GROUP","name":"ERROR_SPECIAL_GROUP","value":"1372_u32"},{"id":"ERROR_SPECIAL_USER","name":"ERROR_SPECIAL_USER","value":"1373_u32"},{"id":"ERROR_MEMBERS_PRIMARY_GROUP","name":"ERROR_MEMBERS_PRIMARY_GROUP","value":"1374_u32"},{"id":"ERROR_TOKEN_ALREADY_IN_USE","name":"ERROR_TOKEN_ALREADY_IN_USE","value":"1375_u32"},{"id":"ERROR_NO_SUCH_ALIAS","name":"ERROR_NO_SUCH_ALIAS","value":"1376_u32"},{"id":"ERROR_MEMBER_NOT_IN_ALIAS","name":"ERROR_MEMBER_NOT_IN_ALIAS","value":"1377_u32"},{"id":"ERROR_MEMBER_IN_ALIAS","name":"ERROR_MEMBER_IN_ALIAS","value":"1378_u32"},{"id":"ERROR_ALIAS_EXISTS","name":"ERROR_ALIAS_EXISTS","value":"1379_u32"},{"id":"ERROR_LOGON_NOT_GRANTED","name":"ERROR_LOGON_NOT_GRANTED","value":"1380_u32"},{"id":"ERROR_TOO_MANY_SECRETS","name":"ERROR_TOO_MANY_SECRETS","value":"1381_u32"},{"id":"ERROR_SECRET_TOO_LONG","name":"ERROR_SECRET_TOO_LONG","value":"1382_u32"},{"id":"ERROR_INTERNAL_DB_ERROR","name":"ERROR_INTERNAL_DB_ERROR","value":"1383_u32"},{"id":"ERROR_TOO_MANY_CONTEXT_IDS","name":"ERROR_TOO_MANY_CONTEXT_IDS","value":"1384_u32"},{"id":"ERROR_LOGON_TYPE_NOT_GRANTED","name":"ERROR_LOGON_TYPE_NOT_GRANTED","value":"1385_u32"},{"id":"ERROR_NT_CROSS_ENCRYPTION_REQUIRED","name":"ERROR_NT_CROSS_ENCRYPTION_REQUIRED","value":"1386_u32"},{"id":"ERROR_NO_SUCH_MEMBER","name":"ERROR_NO_SUCH_MEMBER","value":"1387_u32"},{"id":"ERROR_INVALID_MEMBER","name":"ERROR_INVALID_MEMBER","value":"1388_u32"},{"id":"ERROR_TOO_MANY_SIDS","name":"ERROR_TOO_MANY_SIDS","value":"1389_u32"},{"id":"ERROR_LM_CROSS_ENCRYPTION_REQUIRED","name":"ERROR_LM_CROSS_ENCRYPTION_REQUIRED","value":"1390_u32"},{"id":"ERROR_NO_INHERITANCE","name":"ERROR_NO_INHERITANCE","value":"1391_u32"},{"id":"ERROR_FILE_CORRUPT","name":"ERROR_FILE_CORRUPT","value":"1392_u32"},{"id":"ERROR_DISK_CORRUPT","name":"ERROR_DISK_CORRUPT","value":"1393_u32"},{"id":"ERROR_NO_USER_SESSION_KEY","name":"ERROR_NO_USER_SESSION_KEY","value":"1394_u32"},{"id":"ERROR_LICENSE_QUOTA_EXCEEDED","name":"ERROR_LICENSE_QUOTA_EXCEEDED","value":"1395_u32"},{"id":"ERROR_WRONG_TARGET_NAME","name":"ERROR_WRONG_TARGET_NAME","value":"1396_u32"},{"id":"ERROR_MUTUAL_AUTH_FAILED","name":"ERROR_MUTUAL_AUTH_FAILED","value":"1397_u32"},{"id":"ERROR_TIME_SKEW","name":"ERROR_TIME_SKEW","value":"1398_u32"},{"id":"ERROR_CURRENT_DOMAIN_NOT_ALLOWED","name":"ERROR_CURRENT_DOMAIN_NOT_ALLOWED","value":"1399_u32"},{"id":"ERROR_INVALID_WINDOW_HANDLE","name":"ERROR_INVALID_WINDOW_HANDLE","value":"1400_u32"},{"id":"ERROR_INVALID_MENU_HANDLE","name":"ERROR_INVALID_MENU_HANDLE","value":"1401_u32"},{"id":"ERROR_INVALID_CURSOR_HANDLE","name":"ERROR_INVALID_CURSOR_HANDLE","value":"1402_u32"},{"id":"ERROR_INVALID_ACCEL_HANDLE","name":"ERROR_INVALID_ACCEL_HANDLE","value":"1403_u32"},{"id":"ERROR_INVALID_HOOK_HANDLE","name":"ERROR_INVALID_HOOK_HANDLE","value":"1404_u32"},{"id":"ERROR_INVALID_DWP_HANDLE","name":"ERROR_INVALID_DWP_HANDLE","value":"1405_u32"},{"id":"ERROR_TLW_WITH_WSCHILD","name":"ERROR_TLW_WITH_WSCHILD","value":"1406_u32"},{"id":"ERROR_CANNOT_FIND_WND_CLASS","name":"ERROR_CANNOT_FIND_WND_CLASS","value":"1407_u32"},{"id":"ERROR_WINDOW_OF_OTHER_THREAD","name":"ERROR_WINDOW_OF_OTHER_THREAD","value":"1408_u32"},{"id":"ERROR_HOTKEY_ALREADY_REGISTERED","name":"ERROR_HOTKEY_ALREADY_REGISTERED","value":"1409_u32"},{"id":"ERROR_CLASS_ALREADY_EXISTS","name":"ERROR_CLASS_ALREADY_EXISTS","value":"1410_u32"},{"id":"ERROR_CLASS_DOES_NOT_EXIST","name":"ERROR_CLASS_DOES_NOT_EXIST","value":"1411_u32"},{"id":"ERROR_CLASS_HAS_WINDOWS","name":"ERROR_CLASS_HAS_WINDOWS","value":"1412_u32"},{"id":"ERROR_INVALID_INDEX","name":"ERROR_INVALID_INDEX","value":"1413_u32"},{"id":"ERROR_INVALID_ICON_HANDLE","name":"ERROR_INVALID_ICON_HANDLE","value":"1414_u32"},{"id":"ERROR_PRIVATE_DIALOG_INDEX","name":"ERROR_PRIVATE_DIALOG_INDEX","value":"1415_u32"},{"id":"ERROR_LISTBOX_ID_NOT_FOUND","name":"ERROR_LISTBOX_ID_NOT_FOUND","value":"1416_u32"},{"id":"ERROR_NO_WILDCARD_CHARACTERS","name":"ERROR_NO_WILDCARD_CHARACTERS","value":"1417_u32"},{"id":"ERROR_CLIPBOARD_NOT_OPEN","name":"ERROR_CLIPBOARD_NOT_OPEN","value":"1418_u32"},{"id":"ERROR_HOTKEY_NOT_REGISTERED","name":"ERROR_HOTKEY_NOT_REGISTERED","value":"1419_u32"},{"id":"ERROR_WINDOW_NOT_DIALOG","name":"ERROR_WINDOW_NOT_DIALOG","value":"1420_u32"},{"id":"ERROR_CONTROL_ID_NOT_FOUND","name":"ERROR_CONTROL_ID_NOT_FOUND","value":"1421_u32"},{"id":"ERROR_INVALID_COMBOBOX_MESSAGE","name":"ERROR_INVALID_COMBOBOX_MESSAGE","value":"1422_u32"},{"id":"ERROR_WINDOW_NOT_COMBOBOX","name":"ERROR_WINDOW_NOT_COMBOBOX","value":"1423_u32"},{"id":"ERROR_INVALID_EDIT_HEIGHT","name":"ERROR_INVALID_EDIT_HEIGHT","value":"1424_u32"},{"id":"ERROR_DC_NOT_FOUND","name":"ERROR_DC_NOT_FOUND","value":"1425_u32"},{"id":"ERROR_INVALID_HOOK_FILTER","name":"ERROR_INVALID_HOOK_FILTER","value":"1426_u32"},{"id":"ERROR_INVALID_FILTER_PROC","name":"ERROR_INVALID_FILTER_PROC","value":"1427_u32"},{"id":"ERROR_HOOK_NEEDS_HMOD","name":"ERROR_HOOK_NEEDS_HMOD","value":"1428_u32"},{"id":"ERROR_GLOBAL_ONLY_HOOK","name":"ERROR_GLOBAL_ONLY_HOOK","value":"1429_u32"},{"id":"ERROR_JOURNAL_HOOK_SET","name":"ERROR_JOURNAL_HOOK_SET","value":"1430_u32"},{"id":"ERROR_HOOK_NOT_INSTALLED","name":"ERROR_HOOK_NOT_INSTALLED","value":"1431_u32"},{"id":"ERROR_INVALID_LB_MESSAGE","name":"ERROR_INVALID_LB_MESSAGE","value":"1432_u32"},{"id":"ERROR_SETCOUNT_ON_BAD_LB","name":"ERROR_SETCOUNT_ON_BAD_LB","value":"1433_u32"},{"id":"ERROR_LB_WITHOUT_TABSTOPS","name":"ERROR_LB_WITHOUT_TABSTOPS","value":"1434_u32"},{"id":"ERROR_DESTROY_OBJECT_OF_OTHER_THREAD","name":"ERROR_DESTROY_OBJECT_OF_OTHER_THREAD","value":"1435_u32"},{"id":"ERROR_CHILD_WINDOW_MENU","name":"ERROR_CHILD_WINDOW_MENU","value":"1436_u32"},{"id":"ERROR_NO_SYSTEM_MENU","name":"ERROR_NO_SYSTEM_MENU","value":"1437_u32"},{"id":"ERROR_INVALID_MSGBOX_STYLE","name":"ERROR_INVALID_MSGBOX_STYLE","value":"1438_u32"},{"id":"ERROR_INVALID_SPI_VALUE","name":"ERROR_INVALID_SPI_VALUE","value":"1439_u32"},{"id":"ERROR_SCREEN_ALREADY_LOCKED","name":"ERROR_SCREEN_ALREADY_LOCKED","value":"1440_u32"},{"id":"ERROR_HWNDS_HAVE_DIFF_PARENT","name":"ERROR_HWNDS_HAVE_DIFF_PARENT","value":"1441_u32"},{"id":"ERROR_NOT_CHILD_WINDOW","name":"ERROR_NOT_CHILD_WINDOW","value":"1442_u32"},{"id":"ERROR_INVALID_GW_COMMAND","name":"ERROR_INVALID_GW_COMMAND","value":"1443_u32"},{"id":"ERROR_INVALID_THREAD_ID","name":"ERROR_INVALID_THREAD_ID","value":"1444_u32"},{"id":"ERROR_NON_MDICHILD_WINDOW","name":"ERROR_NON_MDICHILD_WINDOW","value":"1445_u32"},{"id":"ERROR_POPUP_ALREADY_ACTIVE","name":"ERROR_POPUP_ALREADY_ACTIVE","value":"1446_u32"},{"id":"ERROR_NO_SCROLLBARS","name":"ERROR_NO_SCROLLBARS","value":"1447_u32"},{"id":"ERROR_INVALID_SCROLLBAR_RANGE","name":"ERROR_INVALID_SCROLLBAR_RANGE","value":"1448_u32"},{"id":"ERROR_INVALID_SHOWWIN_COMMAND","name":"ERROR_INVALID_SHOWWIN_COMMAND","value":"1449_u32"},{"id":"ERROR_NO_SYSTEM_RESOURCES","name":"ERROR_NO_SYSTEM_RESOURCES","value":"1450_u32"},{"id":"ERROR_NONPAGED_SYSTEM_RESOURCES","name":"ERROR_NONPAGED_SYSTEM_RESOURCES","value":"1451_u32"},{"id":"ERROR_PAGED_SYSTEM_RESOURCES","name":"ERROR_PAGED_SYSTEM_RESOURCES","value":"1452_u32"},{"id":"ERROR_WORKING_SET_QUOTA","name":"ERROR_WORKING_SET_QUOTA","value":"1453_u32"},{"id":"ERROR_PAGEFILE_QUOTA","name":"ERROR_PAGEFILE_QUOTA","value":"1454_u32"},{"id":"ERROR_COMMITMENT_LIMIT","name":"ERROR_COMMITMENT_LIMIT","value":"1455_u32"},{"id":"ERROR_MENU_ITEM_NOT_FOUND","name":"ERROR_MENU_ITEM_NOT_FOUND","value":"1456_u32"},{"id":"ERROR_INVALID_KEYBOARD_HANDLE","name":"ERROR_INVALID_KEYBOARD_HANDLE","value":"1457_u32"},{"id":"ERROR_HOOK_TYPE_NOT_ALLOWED","name":"ERROR_HOOK_TYPE_NOT_ALLOWED","value":"1458_u32"},{"id":"ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION","name":"ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION","value":"1459_u32"},{"id":"ERROR_TIMEOUT","name":"ERROR_TIMEOUT","value":"1460_u32"},{"id":"ERROR_INVALID_MONITOR_HANDLE","name":"ERROR_INVALID_MONITOR_HANDLE","value":"1461_u32"},{"id":"ERROR_INCORRECT_SIZE","name":"ERROR_INCORRECT_SIZE","value":"1462_u32"},{"id":"ERROR_EVENTLOG_FILE_CORRUPT","name":"ERROR_EVENTLOG_FILE_CORRUPT","value":"1500_u32"},{"id":"ERROR_EVENTLOG_CANT_START","name":"ERROR_EVENTLOG_CANT_START","value":"1501_u32"},{"id":"ERROR_LOG_FILE_FULL","name":"ERROR_LOG_FILE_FULL","value":"1502_u32"},{"id":"ERROR_EVENTLOG_FILE_CHANGED","name":"ERROR_EVENTLOG_FILE_CHANGED","value":"1503_u32"},{"id":"ERROR_INSTALL_SERVICE_FAILURE","name":"ERROR_INSTALL_SERVICE_FAILURE","value":"1601_u32"},{"id":"ERROR_INSTALL_USEREXIT","name":"ERROR_INSTALL_USEREXIT","value":"1602_u32"},{"id":"ERROR_INSTALL_FAILURE","name":"ERROR_INSTALL_FAILURE","value":"1603_u32"},{"id":"ERROR_INSTALL_SUSPEND","name":"ERROR_INSTALL_SUSPEND","value":"1604_u32"},{"id":"ERROR_UNKNOWN_PRODUCT","name":"ERROR_UNKNOWN_PRODUCT","value":"1605_u32"},{"id":"ERROR_UNKNOWN_FEATURE","name":"ERROR_UNKNOWN_FEATURE","value":"1606_u32"},{"id":"ERROR_UNKNOWN_COMPONENT","name":"ERROR_UNKNOWN_COMPONENT","value":"1607_u32"},{"id":"ERROR_UNKNOWN_PROPERTY","name":"ERROR_UNKNOWN_PROPERTY","value":"1608_u32"},{"id":"ERROR_INVALID_HANDLE_STATE","name":"ERROR_INVALID_HANDLE_STATE","value":"1609_u32"},{"id":"ERROR_BAD_CONFIGURATION","name":"ERROR_BAD_CONFIGURATION","value":"1610_u32"},{"id":"ERROR_INDEX_ABSENT","name":"ERROR_INDEX_ABSENT","value":"1611_u32"},{"id":"ERROR_INSTALL_SOURCE_ABSENT","name":"ERROR_INSTALL_SOURCE_ABSENT","value":"1612_u32"},{"id":"ERROR_INSTALL_PACKAGE_VERSION","name":"ERROR_INSTALL_PACKAGE_VERSION","value":"1613_u32"},{"id":"ERROR_PRODUCT_UNINSTALLED","name":"ERROR_PRODUCT_UNINSTALLED","value":"1614_u32"},{"id":"ERROR_BAD_QUERY_SYNTAX","name":"ERROR_BAD_QUERY_SYNTAX","value":"1615_u32"},{"id":"ERROR_INVALID_FIELD","name":"ERROR_INVALID_FIELD","value":"1616_u32"},{"id":"ERROR_DEVICE_REMOVED","name":"ERROR_DEVICE_REMOVED","value":"1617_u32"},{"id":"ERROR_INSTALL_ALREADY_RUNNING","name":"ERROR_INSTALL_ALREADY_RUNNING","value":"1618_u32"},{"id":"ERROR_INSTALL_PACKAGE_OPEN_FAILED","name":"ERROR_INSTALL_PACKAGE_OPEN_FAILED","value":"1619_u32"},{"id":"ERROR_INSTALL_PACKAGE_INVALID","name":"ERROR_INSTALL_PACKAGE_INVALID","value":"1620_u32"},{"id":"ERROR_INSTALL_UI_FAILURE","name":"ERROR_INSTALL_UI_FAILURE","value":"1621_u32"},{"id":"ERROR_INSTALL_LOG_FAILURE","name":"ERROR_INSTALL_LOG_FAILURE","value":"1622_u32"},{"id":"ERROR_INSTALL_LANGUAGE_UNSUPPORTED","name":"ERROR_INSTALL_LANGUAGE_UNSUPPORTED","value":"1623_u32"},{"id":"ERROR_INSTALL_TRANSFORM_FAILURE","name":"ERROR_INSTALL_TRANSFORM_FAILURE","value":"1624_u32"},{"id":"ERROR_INSTALL_PACKAGE_REJECTED","name":"ERROR_INSTALL_PACKAGE_REJECTED","value":"1625_u32"},{"id":"ERROR_FUNCTION_NOT_CALLED","name":"ERROR_FUNCTION_NOT_CALLED","value":"1626_u32"},{"id":"ERROR_FUNCTION_FAILED","name":"ERROR_FUNCTION_FAILED","value":"1627_u32"},{"id":"ERROR_INVALID_TABLE","name":"ERROR_INVALID_TABLE","value":"1628_u32"},{"id":"ERROR_DATATYPE_MISMATCH","name":"ERROR_DATATYPE_MISMATCH","value":"1629_u32"},{"id":"ERROR_UNSUPPORTED_TYPE","name":"ERROR_UNSUPPORTED_TYPE","value":"1630_u32"},{"id":"ERROR_CREATE_FAILED","name":"ERROR_CREATE_FAILED","value":"1631_u32"},{"id":"ERROR_INSTALL_TEMP_UNWRITABLE","name":"ERROR_INSTALL_TEMP_UNWRITABLE","value":"1632_u32"},{"id":"ERROR_INSTALL_PLATFORM_UNSUPPORTED","name":"ERROR_INSTALL_PLATFORM_UNSUPPORTED","value":"1633_u32"},{"id":"ERROR_INSTALL_NOTUSED","name":"ERROR_INSTALL_NOTUSED","value":"1634_u32"},{"id":"ERROR_PATCH_PACKAGE_OPEN_FAILED","name":"ERROR_PATCH_PACKAGE_OPEN_FAILED","value":"1635_u32"},{"id":"ERROR_PATCH_PACKAGE_INVALID","name":"ERROR_PATCH_PACKAGE_INVALID","value":"1636_u32"},{"id":"ERROR_PATCH_PACKAGE_UNSUPPORTED","name":"ERROR_PATCH_PACKAGE_UNSUPPORTED","value":"1637_u32"},{"id":"ERROR_PRODUCT_VERSION","name":"ERROR_PRODUCT_VERSION","value":"1638_u32"},{"id":"ERROR_INVALID_COMMAND_LINE","name":"ERROR_INVALID_COMMAND_LINE","value":"1639_u32"},{"id":"ERROR_INSTALL_REMOTE_DISALLOWED","name":"ERROR_INSTALL_REMOTE_DISALLOWED","value":"1640_u32"},{"id":"ERROR_SUCCESS_REBOOT_INITIATED","name":"ERROR_SUCCESS_REBOOT_INITIATED","value":"1641_u32"},{"id":"ERROR_PATCH_TARGET_NOT_FOUND","name":"ERROR_PATCH_TARGET_NOT_FOUND","value":"1642_u32"},{"id":"ERROR_PATCH_PACKAGE_REJECTED","name":"ERROR_PATCH_PACKAGE_REJECTED","value":"1643_u32"},{"id":"ERROR_INSTALL_TRANSFORM_REJECTED","name":"ERROR_INSTALL_TRANSFORM_REJECTED","value":"1644_u32"},{"id":"ERROR_INSTALL_REMOTE_PROHIBITED","name":"ERROR_INSTALL_REMOTE_PROHIBITED","value":"1645_u32"},{"id":"RPC_S_INVALID_STRING_BINDING","name":"RPC_S_INVALID_STRING_BINDING","value":"1700_u32"},{"id":"RPC_S_WRONG_KIND_OF_BINDING","name":"RPC_S_WRONG_KIND_OF_BINDING","value":"1701_u32"},{"id":"RPC_S_INVALID_BINDING","name":"RPC_S_INVALID_BINDING","value":"1702_u32"},{"id":"RPC_S_PROTSEQ_NOT_SUPPORTED","name":"RPC_S_PROTSEQ_NOT_SUPPORTED","value":"1703_u32"},{"id":"RPC_S_INVALID_RPC_PROTSEQ","name":"RPC_S_INVALID_RPC_PROTSEQ","value":"1704_u32"},{"id":"RPC_S_INVALID_STRING_UUID","name":"RPC_S_INVALID_STRING_UUID","value":"1705_u32"},{"id":"RPC_S_INVALID_ENDPOINT_FORMAT","name":"RPC_S_INVALID_ENDPOINT_FORMAT","value":"1706_u32"},{"id":"RPC_S_INVALID_NET_ADDR","name":"RPC_S_INVALID_NET_ADDR","value":"1707_u32"},{"id":"RPC_S_NO_ENDPOINT_FOUND","name":"RPC_S_NO_ENDPOINT_FOUND","value":"1708_u32"},{"id":"RPC_S_INVALID_TIMEOUT","name":"RPC_S_INVALID_TIMEOUT","value":"1709_u32"},{"id":"RPC_S_OBJECT_NOT_FOUND","name":"RPC_S_OBJECT_NOT_FOUND","value":"1710_u32"},{"id":"RPC_S_ALREADY_REGISTERED","name":"RPC_S_ALREADY_REGISTERED","value":"1711_u32"},{"id":"RPC_S_TYPE_ALREADY_REGISTERED","name":"RPC_S_TYPE_ALREADY_REGISTERED","value":"1712_u32"},{"id":"RPC_S_ALREADY_LISTENING","name":"RPC_S_ALREADY_LISTENING","value":"1713_u32"},{"id":"RPC_S_NO_PROTSEQS_REGISTERED","name":"RPC_S_NO_PROTSEQS_REGISTERED","value":"1714_u32"},{"id":"RPC_S_NOT_LISTENING","name":"RPC_S_NOT_LISTENING","value":"1715_u32"},{"id":"RPC_S_UNKNOWN_MGR_TYPE","name":"RPC_S_UNKNOWN_MGR_TYPE","value":"1716_u32"},{"id":"RPC_S_UNKNOWN_IF","name":"RPC_S_UNKNOWN_IF","value":"1717_u32"},{"id":"RPC_S_NO_BINDINGS","name":"RPC_S_NO_BINDINGS","value":"1718_u32"},{"id":"RPC_S_NO_PROTSEQS","name":"RPC_S_NO_PROTSEQS","value":"1719_u32"},{"id":"RPC_S_CANT_CREATE_ENDPOINT","name":"RPC_S_CANT_CREATE_ENDPOINT","value":"1720_u32"},{"id":"RPC_S_OUT_OF_RESOURCES","name":"RPC_S_OUT_OF_RESOURCES","value":"1721_u32"},{"id":"RPC_S_SERVER_UNAVAILABLE","name":"RPC_S_SERVER_UNAVAILABLE","value":"1722_u32"},{"id":"RPC_S_SERVER_TOO_BUSY","name":"RPC_S_SERVER_TOO_BUSY","value":"1723_u32"},{"id":"RPC_S_INVALID_NETWORK_OPTIONS","name":"RPC_S_INVALID_NETWORK_OPTIONS","value":"1724_u32"},{"id":"RPC_S_NO_CALL_ACTIVE","name":"RPC_S_NO_CALL_ACTIVE","value":"1725_u32"},{"id":"RPC_S_CALL_FAILED","name":"RPC_S_CALL_FAILED","value":"1726_u32"},{"id":"RPC_S_CALL_FAILED_DNE","name":"RPC_S_CALL_FAILED_DNE","value":"1727_u32"},{"id":"RPC_S_PROTOCOL_ERROR","name":"RPC_S_PROTOCOL_ERROR","value":"1728_u32"},{"id":"RPC_S_UNSUPPORTED_TRANS_SYN","name":"RPC_S_UNSUPPORTED_TRANS_SYN","value":"1730_u32"},{"id":"RPC_S_UNSUPPORTED_TYPE","name":"RPC_S_UNSUPPORTED_TYPE","value":"1732_u32"},{"id":"RPC_S_INVALID_TAG","name":"RPC_S_INVALID_TAG","value":"1733_u32"},{"id":"RPC_S_INVALID_BOUND","name":"RPC_S_INVALID_BOUND","value":"1734_u32"},{"id":"RPC_S_NO_ENTRY_NAME","name":"RPC_S_NO_ENTRY_NAME","value":"1735_u32"},{"id":"RPC_S_INVALID_NAME_SYNTAX","name":"RPC_S_INVALID_NAME_SYNTAX","value":"1736_u32"},{"id":"RPC_S_UNSUPPORTED_NAME_SYNTAX","name":"RPC_S_UNSUPPORTED_NAME_SYNTAX","value":"1737_u32"},{"id":"RPC_S_UUID_NO_ADDRESS","name":"RPC_S_UUID_NO_ADDRESS","value":"1739_u32"},{"id":"RPC_S_DUPLICATE_ENDPOINT","name":"RPC_S_DUPLICATE_ENDPOINT","value":"1740_u32"},{"id":"RPC_S_UNKNOWN_AUTHN_TYPE","name":"RPC_S_UNKNOWN_AUTHN_TYPE","value":"1741_u32"},{"id":"RPC_S_MAX_CALLS_TOO_SMALL","name":"RPC_S_MAX_CALLS_TOO_SMALL","value":"1742_u32"},{"id":"RPC_S_STRING_TOO_LONG","name":"RPC_S_STRING_TOO_LONG","value":"1743_u32"},{"id":"RPC_S_PROTSEQ_NOT_FOUND","name":"RPC_S_PROTSEQ_NOT_FOUND","value":"1744_u32"},{"id":"RPC_S_PROCNUM_OUT_OF_RANGE","name":"RPC_S_PROCNUM_OUT_OF_RANGE","value":"1745_u32"},{"id":"RPC_S_BINDING_HAS_NO_AUTH","name":"RPC_S_BINDING_HAS_NO_AUTH","value":"1746_u32"},{"id":"RPC_S_UNKNOWN_AUTHN_SERVICE","name":"RPC_S_UNKNOWN_AUTHN_SERVICE","value":"1747_u32"},{"id":"RPC_S_UNKNOWN_AUTHN_LEVEL","name":"RPC_S_UNKNOWN_AUTHN_LEVEL","value":"1748_u32"},{"id":"RPC_S_INVALID_AUTH_IDENTITY","name":"RPC_S_INVALID_AUTH_IDENTITY","value":"1749_u32"},{"id":"RPC_S_UNKNOWN_AUTHZ_SERVICE","name":"RPC_S_UNKNOWN_AUTHZ_SERVICE","value":"1750_u32"},{"id":"EPT_S_INVALID_ENTRY","name":"EPT_S_INVALID_ENTRY","value":"1751_u32"},{"id":"EPT_S_CANT_PERFORM_OP","name":"EPT_S_CANT_PERFORM_OP","value":"1752_u32"},{"id":"EPT_S_NOT_REGISTERED","name":"EPT_S_NOT_REGISTERED","value":"1753_u32"},{"id":"RPC_S_NOTHING_TO_EXPORT","name":"RPC_S_NOTHING_TO_EXPORT","value":"1754_u32"},{"id":"RPC_S_INCOMPLETE_NAME","name":"RPC_S_INCOMPLETE_NAME","value":"1755_u32"},{"id":"RPC_S_INVALID_VERS_OPTION","name":"RPC_S_INVALID_VERS_OPTION","value":"1756_u32"},{"id":"RPC_S_NO_MORE_MEMBERS","name":"RPC_S_NO_MORE_MEMBERS","value":"1757_u32"},{"id":"RPC_S_NOT_ALL_OBJS_UNEXPORTED","name":"RPC_S_NOT_ALL_OBJS_UNEXPORTED","value":"1758_u32"},{"id":"RPC_S_INTERFACE_NOT_FOUND","name":"RPC_S_INTERFACE_NOT_FOUND","value":"1759_u32"},{"id":"RPC_S_ENTRY_ALREADY_EXISTS","name":"RPC_S_ENTRY_ALREADY_EXISTS","value":"1760_u32"},{"id":"RPC_S_ENTRY_NOT_FOUND","name":"RPC_S_ENTRY_NOT_FOUND","value":"1761_u32"},{"id":"RPC_S_NAME_SERVICE_UNAVAILABLE","name":"RPC_S_NAME_SERVICE_UNAVAILABLE","value":"1762_u32"},{"id":"RPC_S_INVALID_NAF_ID","name":"RPC_S_INVALID_NAF_ID","value":"1763_u32"},{"id":"RPC_S_CANNOT_SUPPORT","name":"RPC_S_CANNOT_SUPPORT","value":"1764_u32"},{"id":"RPC_S_NO_CONTEXT_AVAILABLE","name":"RPC_S_NO_CONTEXT_AVAILABLE","value":"1765_u32"},{"id":"RPC_S_INTERNAL_ERROR","name":"RPC_S_INTERNAL_ERROR","value":"1766_u32"},{"id":"RPC_S_ZERO_DIVIDE","name":"RPC_S_ZERO_DIVIDE","value":"1767_u32"},{"id":"RPC_S_ADDRESS_ERROR","name":"RPC_S_ADDRESS_ERROR","value":"1768_u32"},{"id":"RPC_S_FP_DIV_ZERO","name":"RPC_S_FP_DIV_ZERO","value":"1769_u32"},{"id":"RPC_S_FP_UNDERFLOW","name":"RPC_S_FP_UNDERFLOW","value":"1770_u32"},{"id":"RPC_S_FP_OVERFLOW","name":"RPC_S_FP_OVERFLOW","value":"1771_u32"},{"id":"RPC_X_NO_MORE_ENTRIES","name":"RPC_X_NO_MORE_ENTRIES","value":"1772_u32"},{"id":"RPC_X_SS_CHAR_TRANS_OPEN_FAIL","name":"RPC_X_SS_CHAR_TRANS_OPEN_FAIL","value":"1773_u32"},{"id":"RPC_X_SS_CHAR_TRANS_SHORT_FILE","name":"RPC_X_SS_CHAR_TRANS_SHORT_FILE","value":"1774_u32"},{"id":"RPC_X_SS_IN_NULL_CONTEXT","name":"RPC_X_SS_IN_NULL_CONTEXT","value":"1775_u32"},{"id":"RPC_X_SS_CONTEXT_DAMAGED","name":"RPC_X_SS_CONTEXT_DAMAGED","value":"1777_u32"},{"id":"RPC_X_SS_HANDLES_MISMATCH","name":"RPC_X_SS_HANDLES_MISMATCH","value":"1778_u32"},{"id":"RPC_X_SS_CANNOT_GET_CALL_HANDLE","name":"RPC_X_SS_CANNOT_GET_CALL_HANDLE","value":"1779_u32"},{"id":"RPC_X_NULL_REF_POINTER","name":"RPC_X_NULL_REF_POINTER","value":"1780_u32"},{"id":"RPC_X_ENUM_VALUE_OUT_OF_RANGE","name":"RPC_X_ENUM_VALUE_OUT_OF_RANGE","value":"1781_u32"},{"id":"RPC_X_BYTE_COUNT_TOO_SMALL","name":"RPC_X_BYTE_COUNT_TOO_SMALL","value":"1782_u32"},{"id":"RPC_X_BAD_STUB_DATA","name":"RPC_X_BAD_STUB_DATA","value":"1783_u32"},{"id":"ERROR_INVALID_USER_BUFFER","name":"ERROR_INVALID_USER_BUFFER","value":"1784_u32"},{"id":"ERROR_UNRECOGNIZED_MEDIA","name":"ERROR_UNRECOGNIZED_MEDIA","value":"1785_u32"},{"id":"ERROR_NO_TRUST_LSA_SECRET","name":"ERROR_NO_TRUST_LSA_SECRET","value":"1786_u32"},{"id":"ERROR_NO_TRUST_SAM_ACCOUNT","name":"ERROR_NO_TRUST_SAM_ACCOUNT","value":"1787_u32"},{"id":"ERROR_TRUSTED_DOMAIN_FAILURE","name":"ERROR_TRUSTED_DOMAIN_FAILURE","value":"1788_u32"},{"id":"ERROR_TRUSTED_RELATIONSHIP_FAILURE","name":"ERROR_TRUSTED_RELATIONSHIP_FAILURE","value":"1789_u32"},{"id":"ERROR_TRUST_FAILURE","name":"ERROR_TRUST_FAILURE","value":"1790_u32"},{"id":"RPC_S_CALL_IN_PROGRESS","name":"RPC_S_CALL_IN_PROGRESS","value":"1791_u32"},{"id":"ERROR_NETLOGON_NOT_STARTED","name":"ERROR_NETLOGON_NOT_STARTED","value":"1792_u32"},{"id":"ERROR_ACCOUNT_EXPIRED","name":"ERROR_ACCOUNT_EXPIRED","value":"1793_u32"},{"id":"ERROR_REDIRECTOR_HAS_OPEN_HANDLES","name":"ERROR_REDIRECTOR_HAS_OPEN_HANDLES","value":"1794_u32"},{"id":"ERROR_PRINTER_DRIVER_ALREADY_INSTALLED","name":"ERROR_PRINTER_DRIVER_ALREADY_INSTALLED","value":"1795_u32"},{"id":"ERROR_UNKNOWN_PORT","name":"ERROR_UNKNOWN_PORT","value":"1796_u32"},{"id":"ERROR_UNKNOWN_PRINTER_DRIVER","name":"ERROR_UNKNOWN_PRINTER_DRIVER","value":"1797_u32"},{"id":"ERROR_UNKNOWN_PRINTPROCESSOR","name":"ERROR_UNKNOWN_PRINTPROCESSOR","value":"1798_u32"},{"id":"ERROR_INVALID_SEPARATOR_FILE","name":"ERROR_INVALID_SEPARATOR_FILE","value":"1799_u32"},{"id":"ERROR_INVALID_PRIORITY","name":"ERROR_INVALID_PRIORITY","value":"1800_u32"},{"id":"ERROR_INVALID_PRINTER_NAME","name":"ERROR_INVALID_PRINTER_NAME","value":"1801_u32"},{"id":"ERROR_PRINTER_ALREADY_EXISTS","name":"ERROR_PRINTER_ALREADY_EXISTS","value":"1802_u32"},{"id":"ERROR_INVALID_PRINTER_COMMAND","name":"ERROR_INVALID_PRINTER_COMMAND","value":"1803_u32"},{"id":"ERROR_INVALID_DATATYPE","name":"ERROR_INVALID_DATATYPE","value":"1804_u32"},{"id":"ERROR_INVALID_ENVIRONMENT","name":"ERROR_INVALID_ENVIRONMENT","value":"1805_u32"},{"id":"RPC_S_NO_MORE_BINDINGS","name":"RPC_S_NO_MORE_BINDINGS","value":"1806_u32"},{"id":"ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT","name":"ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT","value":"1807_u32"},{"id":"ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT","name":"ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT","value":"1808_u32"},{"id":"ERROR_NOLOGON_SERVER_TRUST_ACCOUNT","name":"ERROR_NOLOGON_SERVER_TRUST_ACCOUNT","value":"1809_u32"},{"id":"ERROR_DOMAIN_TRUST_INCONSISTENT","name":"ERROR_DOMAIN_TRUST_INCONSISTENT","value":"1810_u32"},{"id":"ERROR_SERVER_HAS_OPEN_HANDLES","name":"ERROR_SERVER_HAS_OPEN_HANDLES","value":"1811_u32"},{"id":"ERROR_RESOURCE_DATA_NOT_FOUND","name":"ERROR_RESOURCE_DATA_NOT_FOUND","value":"1812_u32"},{"id":"ERROR_RESOURCE_TYPE_NOT_FOUND","name":"ERROR_RESOURCE_TYPE_NOT_FOUND","value":"1813_u32"},{"id":"ERROR_RESOURCE_NAME_NOT_FOUND","name":"ERROR_RESOURCE_NAME_NOT_FOUND","value":"1814_u32"},{"id":"ERROR_RESOURCE_LANG_NOT_FOUND","name":"ERROR_RESOURCE_LANG_NOT_FOUND","value":"1815_u32"},{"id":"ERROR_NOT_ENOUGH_QUOTA","name":"ERROR_NOT_ENOUGH_QUOTA","value":"1816_u32"},{"id":"RPC_S_NO_INTERFACES","name":"RPC_S_NO_INTERFACES","value":"1817_u32"},{"id":"RPC_S_CALL_CANCELLED","name":"RPC_S_CALL_CANCELLED","value":"1818_u32"},{"id":"RPC_S_BINDING_INCOMPLETE","name":"RPC_S_BINDING_INCOMPLETE","value":"1819_u32"},{"id":"RPC_S_COMM_FAILURE","name":"RPC_S_COMM_FAILURE","value":"1820_u32"},{"id":"RPC_S_UNSUPPORTED_AUTHN_LEVEL","name":"RPC_S_UNSUPPORTED_AUTHN_LEVEL","value":"1821_u32"},{"id":"RPC_S_NO_PRINC_NAME","name":"RPC_S_NO_PRINC_NAME","value":"1822_u32"},{"id":"RPC_S_NOT_RPC_ERROR","name":"RPC_S_NOT_RPC_ERROR","value":"1823_u32"},{"id":"RPC_S_UUID_LOCAL_ONLY","name":"RPC_S_UUID_LOCAL_ONLY","value":"1824_u32"},{"id":"RPC_S_SEC_PKG_ERROR","name":"RPC_S_SEC_PKG_ERROR","value":"1825_u32"},{"id":"RPC_S_NOT_CANCELLED","name":"RPC_S_NOT_CANCELLED","value":"1826_u32"},{"id":"RPC_X_INVALID_ES_ACTION","name":"RPC_X_INVALID_ES_ACTION","value":"1827_u32"},{"id":"RPC_X_WRONG_ES_VERSION","name":"RPC_X_WRONG_ES_VERSION","value":"1828_u32"},{"id":"RPC_X_WRONG_STUB_VERSION","name":"RPC_X_WRONG_STUB_VERSION","value":"1829_u32"},{"id":"RPC_X_INVALID_PIPE_OBJECT","name":"RPC_X_INVALID_PIPE_OBJECT","value":"1830_u32"},{"id":"RPC_X_WRONG_PIPE_ORDER","name":"RPC_X_WRONG_PIPE_ORDER","value":"1831_u32"},{"id":"RPC_X_WRONG_PIPE_VERSION","name":"RPC_X_WRONG_PIPE_VERSION","value":"1832_u32"},{"id":"RPC_S_GROUP_MEMBER_NOT_FOUND","name":"RPC_S_GROUP_MEMBER_NOT_FOUND","value":"1898_u32"},{"id":"EPT_S_CANT_CREATE","name":"EPT_S_CANT_CREATE","value":"1899_u32"},{"id":"RPC_S_INVALID_OBJECT","name":"RPC_S_INVALID_OBJECT","value":"1900_u32"},{"id":"ERROR_INVALID_TIME","name":"ERROR_INVALID_TIME","value":"1901_u32"},{"id":"ERROR_INVALID_FORM_NAME","name":"ERROR_INVALID_FORM_NAME","value":"1902_u32"},{"id":"ERROR_INVALID_FORM_SIZE","name":"ERROR_INVALID_FORM_SIZE","value":"1903_u32"},{"id":"ERROR_ALREADY_WAITING","name":"ERROR_ALREADY_WAITING","value":"1904_u32"},{"id":"ERROR_PRINTER_DELETED","name":"ERROR_PRINTER_DELETED","value":"1905_u32"},{"id":"ERROR_INVALID_PRINTER_STATE","name":"ERROR_INVALID_PRINTER_STATE","value":"1906_u32"},{"id":"ERROR_PASSWORD_MUST_CHANGE","name":"ERROR_PASSWORD_MUST_CHANGE","value":"1907_u32"},{"id":"ERROR_DOMAIN_CONTROLLER_NOT_FOUND","name":"ERROR_DOMAIN_CONTROLLER_NOT_FOUND","value":"1908_u32"},{"id":"ERROR_ACCOUNT_LOCKED_OUT","name":"ERROR_ACCOUNT_LOCKED_OUT","value":"1909_u32"},{"id":"OR_INVALID_OXID","name":"OR_INVALID_OXID","value":"1910_u32"},{"id":"OR_INVALID_OID","name":"OR_INVALID_OID","value":"1911_u32"},{"id":"OR_INVALID_SET","name":"OR_INVALID_SET","value":"1912_u32"},{"id":"RPC_S_SEND_INCOMPLETE","name":"RPC_S_SEND_INCOMPLETE","value":"1913_u32"},{"id":"RPC_S_INVALID_ASYNC_HANDLE","name":"RPC_S_INVALID_ASYNC_HANDLE","value":"1914_u32"},{"id":"RPC_S_INVALID_ASYNC_CALL","name":"RPC_S_INVALID_ASYNC_CALL","value":"1915_u32"},{"id":"RPC_X_PIPE_CLOSED","name":"RPC_X_PIPE_CLOSED","value":"1916_u32"},{"id":"RPC_X_PIPE_DISCIPLINE_ERROR","name":"RPC_X_PIPE_DISCIPLINE_ERROR","value":"1917_u32"},{"id":"RPC_X_PIPE_EMPTY","name":"RPC_X_PIPE_EMPTY","value":"1918_u32"},{"id":"ERROR_NO_SITENAME","name":"ERROR_NO_SITENAME","value":"1919_u32"},{"id":"ERROR_CANT_ACCESS_FILE","name":"ERROR_CANT_ACCESS_FILE","value":"1920_u32"},{"id":"ERROR_CANT_RESOLVE_FILENAME","name":"ERROR_CANT_RESOLVE_FILENAME","value":"1921_u32"},{"id":"RPC_S_ENTRY_TYPE_MISMATCH","name":"RPC_S_ENTRY_TYPE_MISMATCH","value":"1922_u32"},{"id":"RPC_S_NOT_ALL_OBJS_EXPORTED","name":"RPC_S_NOT_ALL_OBJS_EXPORTED","value":"1923_u32"},{"id":"RPC_S_INTERFACE_NOT_EXPORTED","name":"RPC_S_INTERFACE_NOT_EXPORTED","value":"1924_u32"},{"id":"RPC_S_PROFILE_NOT_ADDED","name":"RPC_S_PROFILE_NOT_ADDED","value":"1925_u32"},{"id":"RPC_S_PRF_ELT_NOT_ADDED","name":"RPC_S_PRF_ELT_NOT_ADDED","value":"1926_u32"},{"id":"RPC_S_PRF_ELT_NOT_REMOVED","name":"RPC_S_PRF_ELT_NOT_REMOVED","value":"1927_u32"},{"id":"RPC_S_GRP_ELT_NOT_ADDED","name":"RPC_S_GRP_ELT_NOT_ADDED","value":"1928_u32"},{"id":"RPC_S_GRP_ELT_NOT_REMOVED","name":"RPC_S_GRP_ELT_NOT_REMOVED","value":"1929_u32"},{"id":"ERROR_KM_DRIVER_BLOCKED","name":"ERROR_KM_DRIVER_BLOCKED","value":"1930_u32"},{"id":"ERROR_CONTEXT_EXPIRED","name":"ERROR_CONTEXT_EXPIRED","value":"1931_u32"},{"id":"ERROR_PER_USER_TRUST_QUOTA_EXCEEDED","name":"ERROR_PER_USER_TRUST_QUOTA_EXCEEDED","value":"1932_u32"},{"id":"ERROR_ALL_USER_TRUST_QUOTA_EXCEEDED","name":"ERROR_ALL_USER_TRUST_QUOTA_EXCEEDED","value":"1933_u32"},{"id":"ERROR_USER_DELETE_TRUST_QUOTA_EXCEEDED","name":"ERROR_USER_DELETE_TRUST_QUOTA_EXCEEDED","value":"1934_u32"},{"id":"ERROR_AUTHENTICATION_FIREWALL_FAILED","name":"ERROR_AUTHENTICATION_FIREWALL_FAILED","value":"1935_u32"},{"id":"ERROR_REMOTE_PRINT_CONNECTIONS_BLOCKED","name":"ERROR_REMOTE_PRINT_CONNECTIONS_BLOCKED","value":"1936_u32"},{"id":"ERROR_INVALID_PIXEL_FORMAT","name":"ERROR_INVALID_PIXEL_FORMAT","value":"2000_u32"},{"id":"ERROR_BAD_DRIVER","name":"ERROR_BAD_DRIVER","value":"2001_u32"},{"id":"ERROR_INVALID_WINDOW_STYLE","name":"ERROR_INVALID_WINDOW_STYLE","value":"2002_u32"},{"id":"ERROR_METAFILE_NOT_SUPPORTED","name":"ERROR_METAFILE_NOT_SUPPORTED","value":"2003_u32"},{"id":"ERROR_TRANSFORM_NOT_SUPPORTED","name":"ERROR_TRANSFORM_NOT_SUPPORTED","value":"2004_u32"},{"id":"ERROR_CLIPPING_NOT_SUPPORTED","name":"ERROR_CLIPPING_NOT_SUPPORTED","value":"2005_u32"},{"id":"ERROR_INVALID_CMM","name":"ERROR_INVALID_CMM","value":"2010_u32"},{"id":"ERROR_INVALID_PROFILE","name":"ERROR_INVALID_PROFILE","value":"2011_u32"},{"id":"ERROR_TAG_NOT_FOUND","name":"ERROR_TAG_NOT_FOUND","value":"2012_u32"},{"id":"ERROR_TAG_NOT_PRESENT","name":"ERROR_TAG_NOT_PRESENT","value":"2013_u32"},{"id":"ERROR_DUPLICATE_TAG","name":"ERROR_DUPLICATE_TAG","value":"2014_u32"},{"id":"ERROR_PROFILE_NOT_ASSOCIATED_WITH_DEVICE","name":"ERROR_PROFILE_NOT_ASSOCIATED_WITH_DEVICE","value":"2015_u32"},{"id":"ERROR_PROFILE_NOT_FOUND","name":"ERROR_PROFILE_NOT_FOUND","value":"2016_u32"},{"id":"ERROR_INVALID_COLORSPACE","name":"ERROR_INVALID_COLORSPACE","value":"2017_u32"},{"id":"ERROR_ICM_NOT_ENABLED","name":"ERROR_ICM_NOT_ENABLED","value":"2018_u32"},{"id":"ERROR_DELETING_ICM_XFORM","name":"ERROR_DELETING_ICM_XFORM","value":"2019_u32"},{"id":"ERROR_INVALID_TRANSFORM","name":"ERROR_INVALID_TRANSFORM","value":"2020_u32"},{"id":"ERROR_COLORSPACE_MISMATCH","name":"ERROR_COLORSPACE_MISMATCH","value":"2021_u32"},{"id":"ERROR_INVALID_COLORINDEX","name":"ERROR_INVALID_COLORINDEX","value":"2022_u32"},{"id":"ERROR_CONNECTED_OTHER_PASSWORD","name":"ERROR_CONNECTED_OTHER_PASSWORD","value":"2108_u32"},{"id":"ERROR_CONNECTED_OTHER_PASSWORD_DEFAULT","name":"ERROR_CONNECTED_OTHER_PASSWORD_DEFAULT","value":"2109_u32"},{"id":"ERROR_BAD_USERNAME","name":"ERROR_BAD_USERNAME","value":"2202_u32"},{"id":"ERROR_NOT_CONNECTED","name":"ERROR_NOT_CONNECTED","value":"2250_u32"},{"id":"ERROR_OPEN_FILES","name":"ERROR_OPEN_FILES","value":"2401_u32"},{"id":"ERROR_ACTIVE_CONNECTIONS","name":"ERROR_ACTIVE_CONNECTIONS","value":"2402_u32"},{"id":"ERROR_DEVICE_IN_USE","name":"ERROR_DEVICE_IN_USE","value":"2404_u32"},{"id":"ERROR_UNKNOWN_PRINT_MONITOR","name":"ERROR_UNKNOWN_PRINT_MONITOR","value":"3000_u32"},{"id":"ERROR_PRINTER_DRIVER_IN_USE","name":"ERROR_PRINTER_DRIVER_IN_USE","value":"3001_u32"},{"id":"ERROR_SPOOL_FILE_NOT_FOUND","name":"ERROR_SPOOL_FILE_NOT_FOUND","value":"3002_u32"},{"id":"ERROR_SPL_NO_STARTDOC","name":"ERROR_SPL_NO_STARTDOC","value":"3003_u32"},{"id":"ERROR_SPL_NO_ADDJOB","name":"ERROR_SPL_NO_ADDJOB","value":"3004_u32"},{"id":"ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED","name":"ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED","value":"3005_u32"},{"id":"ERROR_PRINT_MONITOR_ALREADY_INSTALLED","name":"ERROR_PRINT_MONITOR_ALREADY_INSTALLED","value":"3006_u32"},{"id":"ERROR_INVALID_PRINT_MONITOR","name":"ERROR_INVALID_PRINT_MONITOR","value":"3007_u32"},{"id":"ERROR_PRINT_MONITOR_IN_USE","name":"ERROR_PRINT_MONITOR_IN_USE","value":"3008_u32"},{"id":"ERROR_PRINTER_HAS_JOBS_QUEUED","name":"ERROR_PRINTER_HAS_JOBS_QUEUED","value":"3009_u32"},{"id":"ERROR_SUCCESS_REBOOT_REQUIRED","name":"ERROR_SUCCESS_REBOOT_REQUIRED","value":"3010_u32"},{"id":"ERROR_SUCCESS_RESTART_REQUIRED","name":"ERROR_SUCCESS_RESTART_REQUIRED","value":"3011_u32"},{"id":"ERROR_PRINTER_NOT_FOUND","name":"ERROR_PRINTER_NOT_FOUND","value":"3012_u32"},{"id":"ERROR_PRINTER_DRIVER_WARNED","name":"ERROR_PRINTER_DRIVER_WARNED","value":"3013_u32"},{"id":"ERROR_PRINTER_DRIVER_BLOCKED","name":"ERROR_PRINTER_DRIVER_BLOCKED","value":"3014_u32"},{"id":"ERROR_WINS_INTERNAL","name":"ERROR_WINS_INTERNAL","value":"4000_u32"},{"id":"ERROR_CAN_NOT_DEL_LOCAL_WINS","name":"ERROR_CAN_NOT_DEL_LOCAL_WINS","value":"4001_u32"},{"id":"ERROR_STATIC_INIT","name":"ERROR_STATIC_INIT","value":"4002_u32"},{"id":"ERROR_INC_BACKUP","name":"ERROR_INC_BACKUP","value":"4003_u32"},{"id":"ERROR_FULL_BACKUP","name":"ERROR_FULL_BACKUP","value":"4004_u32"},{"id":"ERROR_REC_NON_EXISTENT","name":"ERROR_REC_NON_EXISTENT","value":"4005_u32"},{"id":"ERROR_RPL_NOT_ALLOWED","name":"ERROR_RPL_NOT_ALLOWED","value":"4006_u32"},{"id":"ERROR_DHCP_ADDRESS_CONFLICT","name":"ERROR_DHCP_ADDRESS_CONFLICT","value":"4100_u32"},{"id":"ERROR_WMI_GUID_NOT_FOUND","name":"ERROR_WMI_GUID_NOT_FOUND","value":"4200_u32"},{"id":"ERROR_WMI_INSTANCE_NOT_FOUND","name":"ERROR_WMI_INSTANCE_NOT_FOUND","value":"4201_u32"},{"id":"ERROR_WMI_ITEMID_NOT_FOUND","name":"ERROR_WMI_ITEMID_NOT_FOUND","value":"4202_u32"},{"id":"ERROR_WMI_TRY_AGAIN","name":"ERROR_WMI_TRY_AGAIN","value":"4203_u32"},{"id":"ERROR_WMI_DP_NOT_FOUND","name":"ERROR_WMI_DP_NOT_FOUND","value":"4204_u32"},{"id":"ERROR_WMI_UNRESOLVED_INSTANCE_REF","name":"ERROR_WMI_UNRESOLVED_INSTANCE_REF","value":"4205_u32"},{"id":"ERROR_WMI_ALREADY_ENABLED","name":"ERROR_WMI_ALREADY_ENABLED","value":"4206_u32"},{"id":"ERROR_WMI_GUID_DISCONNECTED","name":"ERROR_WMI_GUID_DISCONNECTED","value":"4207_u32"},{"id":"ERROR_WMI_SERVER_UNAVAILABLE","name":"ERROR_WMI_SERVER_UNAVAILABLE","value":"4208_u32"},{"id":"ERROR_WMI_DP_FAILED","name":"ERROR_WMI_DP_FAILED","value":"4209_u32"},{"id":"ERROR_WMI_INVALID_MOF","name":"ERROR_WMI_INVALID_MOF","value":"4210_u32"},{"id":"ERROR_WMI_INVALID_REGINFO","name":"ERROR_WMI_INVALID_REGINFO","value":"4211_u32"},{"id":"ERROR_WMI_ALREADY_DISABLED","name":"ERROR_WMI_ALREADY_DISABLED","value":"4212_u32"},{"id":"ERROR_WMI_READ_ONLY","name":"ERROR_WMI_READ_ONLY","value":"4213_u32"},{"id":"ERROR_WMI_SET_FAILURE","name":"ERROR_WMI_SET_FAILURE","value":"4214_u32"},{"id":"ERROR_INVALID_MEDIA","name":"ERROR_INVALID_MEDIA","value":"4300_u32"},{"id":"ERROR_INVALID_LIBRARY","name":"ERROR_INVALID_LIBRARY","value":"4301_u32"},{"id":"ERROR_INVALID_MEDIA_POOL","name":"ERROR_INVALID_MEDIA_POOL","value":"4302_u32"},{"id":"ERROR_DRIVE_MEDIA_MISMATCH","name":"ERROR_DRIVE_MEDIA_MISMATCH","value":"4303_u32"},{"id":"ERROR_MEDIA_OFFLINE","name":"ERROR_MEDIA_OFFLINE","value":"4304_u32"},{"id":"ERROR_LIBRARY_OFFLINE","name":"ERROR_LIBRARY_OFFLINE","value":"4305_u32"},{"id":"ERROR_EMPTY","name":"ERROR_EMPTY","value":"4306_u32"},{"id":"ERROR_NOT_EMPTY","name":"ERROR_NOT_EMPTY","value":"4307_u32"},{"id":"ERROR_MEDIA_UNAVAILABLE","name":"ERROR_MEDIA_UNAVAILABLE","value":"4308_u32"},{"id":"ERROR_RESOURCE_DISABLED","name":"ERROR_RESOURCE_DISABLED","value":"4309_u32"},{"id":"ERROR_INVALID_CLEANER","name":"ERROR_INVALID_CLEANER","value":"4310_u32"},{"id":"ERROR_UNABLE_TO_CLEAN","name":"ERROR_UNABLE_TO_CLEAN","value":"4311_u32"},{"id":"ERROR_OBJECT_NOT_FOUND","name":"ERROR_OBJECT_NOT_FOUND","value":"4312_u32"},{"id":"ERROR_DATABASE_FAILURE","name":"ERROR_DATABASE_FAILURE","value":"4313_u32"},{"id":"ERROR_DATABASE_FULL","name":"ERROR_DATABASE_FULL","value":"4314_u32"},{"id":"ERROR_MEDIA_INCOMPATIBLE","name":"ERROR_MEDIA_INCOMPATIBLE","value":"4315_u32"},{"id":"ERROR_RESOURCE_NOT_PRESENT","name":"ERROR_RESOURCE_NOT_PRESENT","value":"4316_u32"},{"id":"ERROR_INVALID_OPERATION","name":"ERROR_INVALID_OPERATION","value":"4317_u32"},{"id":"ERROR_MEDIA_NOT_AVAILABLE","name":"ERROR_MEDIA_NOT_AVAILABLE","value":"4318_u32"},{"id":"ERROR_DEVICE_NOT_AVAILABLE","name":"ERROR_DEVICE_NOT_AVAILABLE","value":"4319_u32"},{"id":"ERROR_REQUEST_REFUSED","name":"ERROR_REQUEST_REFUSED","value":"4320_u32"},{"id":"ERROR_INVALID_DRIVE_OBJECT","name":"ERROR_INVALID_DRIVE_OBJECT","value":"4321_u32"},{"id":"ERROR_LIBRARY_FULL","name":"ERROR_LIBRARY_FULL","value":"4322_u32"},{"id":"ERROR_MEDIUM_NOT_ACCESSIBLE","name":"ERROR_MEDIUM_NOT_ACCESSIBLE","value":"4323_u32"},{"id":"ERROR_UNABLE_TO_LOAD_MEDIUM","name":"ERROR_UNABLE_TO_LOAD_MEDIUM","value":"4324_u32"},{"id":"ERROR_UNABLE_TO_INVENTORY_DRIVE","name":"ERROR_UNABLE_TO_INVENTORY_DRIVE","value":"4325_u32"},{"id":"ERROR_UNABLE_TO_INVENTORY_SLOT","name":"ERROR_UNABLE_TO_INVENTORY_SLOT","value":"4326_u32"},{"id":"ERROR_UNABLE_TO_INVENTORY_TRANSPORT","name":"ERROR_UNABLE_TO_INVENTORY_TRANSPORT","value":"4327_u32"},{"id":"ERROR_TRANSPORT_FULL","name":"ERROR_TRANSPORT_FULL","value":"4328_u32"},{"id":"ERROR_CONTROLLING_IEPORT","name":"ERROR_CONTROLLING_IEPORT","value":"4329_u32"},{"id":"ERROR_UNABLE_TO_EJECT_MOUNTED_MEDIA","name":"ERROR_UNABLE_TO_EJECT_MOUNTED_MEDIA","value":"4330_u32"},{"id":"ERROR_CLEANER_SLOT_SET","name":"ERROR_CLEANER_SLOT_SET","value":"4331_u32"},{"id":"ERROR_CLEANER_SLOT_NOT_SET","name":"ERROR_CLEANER_SLOT_NOT_SET","value":"4332_u32"},{"id":"ERROR_CLEANER_CARTRIDGE_SPENT","name":"ERROR_CLEANER_CARTRIDGE_SPENT","value":"4333_u32"},{"id":"ERROR_UNEXPECTED_OMID","name":"ERROR_UNEXPECTED_OMID","value":"4334_u32"},{"id":"ERROR_CANT_DELETE_LAST_ITEM","name":"ERROR_CANT_DELETE_LAST_ITEM","value":"4335_u32"},{"id":"ERROR_MESSAGE_EXCEEDS_MAX_SIZE","name":"ERROR_MESSAGE_EXCEEDS_MAX_SIZE","value":"4336_u32"},{"id":"ERROR_VOLUME_CONTAINS_SYS_FILES","name":"ERROR_VOLUME_CONTAINS_SYS_FILES","value":"4337_u32"},{"id":"ERROR_INDIGENOUS_TYPE","name":"ERROR_INDIGENOUS_TYPE","value":"4338_u32"},{"id":"ERROR_NO_SUPPORTING_DRIVES","name":"ERROR_NO_SUPPORTING_DRIVES","value":"4339_u32"},{"id":"ERROR_CLEANER_CARTRIDGE_INSTALLED","name":"ERROR_CLEANER_CARTRIDGE_INSTALLED","value":"4340_u32"},{"id":"ERROR_IEPORT_FULL","name":"ERROR_IEPORT_FULL","value":"4341_u32"},{"id":"ERROR_FILE_OFFLINE","name":"ERROR_FILE_OFFLINE","value":"4350_u32"},{"id":"ERROR_REMOTE_STORAGE_NOT_ACTIVE","name":"ERROR_REMOTE_STORAGE_NOT_ACTIVE","value":"4351_u32"},{"id":"ERROR_REMOTE_STORAGE_MEDIA_ERROR","name":"ERROR_REMOTE_STORAGE_MEDIA_ERROR","value":"4352_u32"},{"id":"ERROR_NOT_A_REPARSE_POINT","name":"ERROR_NOT_A_REPARSE_POINT","value":"4390_u32"},{"id":"ERROR_REPARSE_ATTRIBUTE_CONFLICT","name":"ERROR_REPARSE_ATTRIBUTE_CONFLICT","value":"4391_u32"},{"id":"ERROR_INVALID_REPARSE_DATA","name":"ERROR_INVALID_REPARSE_DATA","value":"4392_u32"},{"id":"ERROR_REPARSE_TAG_INVALID","name":"ERROR_REPARSE_TAG_INVALID","value":"4393_u32"},{"id":"ERROR_REPARSE_TAG_MISMATCH","name":"ERROR_REPARSE_TAG_MISMATCH","value":"4394_u32"},{"id":"ERROR_VOLUME_NOT_SIS_ENABLED","name":"ERROR_VOLUME_NOT_SIS_ENABLED","value":"4500_u32"},{"id":"ERROR_DEPENDENT_RESOURCE_EXISTS","name":"ERROR_DEPENDENT_RESOURCE_EXISTS","value":"5001_u32"},{"id":"ERROR_DEPENDENCY_NOT_FOUND","name":"ERROR_DEPENDENCY_NOT_FOUND","value":"5002_u32"},{"id":"ERROR_DEPENDENCY_ALREADY_EXISTS","name":"ERROR_DEPENDENCY_ALREADY_EXISTS","value":"5003_u32"},{"id":"ERROR_RESOURCE_NOT_ONLINE","name":"ERROR_RESOURCE_NOT_ONLINE","value":"5004_u32"},{"id":"ERROR_HOST_NODE_NOT_AVAILABLE","name":"ERROR_HOST_NODE_NOT_AVAILABLE","value":"5005_u32"},{"id":"ERROR_RESOURCE_NOT_AVAILABLE","name":"ERROR_RESOURCE_NOT_AVAILABLE","value":"5006_u32"},{"id":"ERROR_RESOURCE_NOT_FOUND","name":"ERROR_RESOURCE_NOT_FOUND","value":"5007_u32"},{"id":"ERROR_SHUTDOWN_CLUSTER","name":"ERROR_SHUTDOWN_CLUSTER","value":"5008_u32"},{"id":"ERROR_CANT_EVICT_ACTIVE_NODE","name":"ERROR_CANT_EVICT_ACTIVE_NODE","value":"5009_u32"},{"id":"ERROR_OBJECT_ALREADY_EXISTS","name":"ERROR_OBJECT_ALREADY_EXISTS","value":"5010_u32"},{"id":"ERROR_OBJECT_IN_LIST","name":"ERROR_OBJECT_IN_LIST","value":"5011_u32"},{"id":"ERROR_GROUP_NOT_AVAILABLE","name":"ERROR_GROUP_NOT_AVAILABLE","value":"5012_u32"},{"id":"ERROR_GROUP_NOT_FOUND","name":"ERROR_GROUP_NOT_FOUND","value":"5013_u32"},{"id":"ERROR_GROUP_NOT_ONLINE","name":"ERROR_GROUP_NOT_ONLINE","value":"5014_u32"},{"id":"ERROR_HOST_NODE_NOT_RESOURCE_OWNER","name":"ERROR_HOST_NODE_NOT_RESOURCE_OWNER","value":"5015_u32"},{"id":"ERROR_HOST_NODE_NOT_GROUP_OWNER","name":"ERROR_HOST_NODE_NOT_GROUP_OWNER","value":"5016_u32"},{"id":"ERROR_RESMON_CREATE_FAILED","name":"ERROR_RESMON_CREATE_FAILED","value":"5017_u32"},{"id":"ERROR_RESMON_ONLINE_FAILED","name":"ERROR_RESMON_ONLINE_FAILED","value":"5018_u32"},{"id":"ERROR_RESOURCE_ONLINE","name":"ERROR_RESOURCE_ONLINE","value":"5019_u32"},{"id":"ERROR_QUORUM_RESOURCE","name":"ERROR_QUORUM_RESOURCE","value":"5020_u32"},{"id":"ERROR_NOT_QUORUM_CAPABLE","name":"ERROR_NOT_QUORUM_CAPABLE","value":"5021_u32"},{"id":"ERROR_CLUSTER_SHUTTING_DOWN","name":"ERROR_CLUSTER_SHUTTING_DOWN","value":"5022_u32"},{"id":"ERROR_INVALID_STATE","name":"ERROR_INVALID_STATE","value":"5023_u32"},{"id":"ERROR_RESOURCE_PROPERTIES_STORED","name":"ERROR_RESOURCE_PROPERTIES_STORED","value":"5024_u32"},{"id":"ERROR_NOT_QUORUM_CLASS","name":"ERROR_NOT_QUORUM_CLASS","value":"5025_u32"},{"id":"ERROR_CORE_RESOURCE","name":"ERROR_CORE_RESOURCE","value":"5026_u32"},{"id":"ERROR_QUORUM_RESOURCE_ONLINE_FAILED","name":"ERROR_QUORUM_RESOURCE_ONLINE_FAILED","value":"5027_u32"},{"id":"ERROR_QUORUMLOG_OPEN_FAILED","name":"ERROR_QUORUMLOG_OPEN_FAILED","value":"5028_u32"},{"id":"ERROR_CLUSTERLOG_CORRUPT","name":"ERROR_CLUSTERLOG_CORRUPT","value":"5029_u32"},{"id":"ERROR_CLUSTERLOG_RECORD_EXCEEDS_MAXSIZE","name":"ERROR_CLUSTERLOG_RECORD_EXCEEDS_MAXSIZE","value":"5030_u32"},{"id":"ERROR_CLUSTERLOG_EXCEEDS_MAXSIZE","name":"ERROR_CLUSTERLOG_EXCEEDS_MAXSIZE","value":"5031_u32"},{"id":"ERROR_CLUSTERLOG_CHKPOINT_NOT_FOUND","name":"ERROR_CLUSTERLOG_CHKPOINT_NOT_FOUND","value":"5032_u32"},{"id":"ERROR_CLUSTERLOG_NOT_ENOUGH_SPACE","name":"ERROR_CLUSTERLOG_NOT_ENOUGH_SPACE","value":"5033_u32"},{"id":"ERROR_QUORUM_OWNER_ALIVE","name":"ERROR_QUORUM_OWNER_ALIVE","value":"5034_u32"},{"id":"ERROR_NETWORK_NOT_AVAILABLE","name":"ERROR_NETWORK_NOT_AVAILABLE","value":"5035_u32"},{"id":"ERROR_NODE_NOT_AVAILABLE","name":"ERROR_NODE_NOT_AVAILABLE","value":"5036_u32"},{"id":"ERROR_ALL_NODES_NOT_AVAILABLE","name":"ERROR_ALL_NODES_NOT_AVAILABLE","value":"5037_u32"},{"id":"ERROR_RESOURCE_FAILED","name":"ERROR_RESOURCE_FAILED","value":"5038_u32"},{"id":"ERROR_CLUSTER_INVALID_NODE","name":"ERROR_CLUSTER_INVALID_NODE","value":"5039_u32"},{"id":"ERROR_CLUSTER_NODE_EXISTS","name":"ERROR_CLUSTER_NODE_EXISTS","value":"5040_u32"},{"id":"ERROR_CLUSTER_JOIN_IN_PROGRESS","name":"ERROR_CLUSTER_JOIN_IN_PROGRESS","value":"5041_u32"},{"id":"ERROR_CLUSTER_NODE_NOT_FOUND","name":"ERROR_CLUSTER_NODE_NOT_FOUND","value":"5042_u32"},{"id":"ERROR_CLUSTER_LOCAL_NODE_NOT_FOUND","name":"ERROR_CLUSTER_LOCAL_NODE_NOT_FOUND","value":"5043_u32"},{"id":"ERROR_CLUSTER_NETWORK_EXISTS","name":"ERROR_CLUSTER_NETWORK_EXISTS","value":"5044_u32"},{"id":"ERROR_CLUSTER_NETWORK_NOT_FOUND","name":"ERROR_CLUSTER_NETWORK_NOT_FOUND","value":"5045_u32"},{"id":"ERROR_CLUSTER_NETINTERFACE_EXISTS","name":"ERROR_CLUSTER_NETINTERFACE_EXISTS","value":"5046_u32"},{"id":"ERROR_CLUSTER_NETINTERFACE_NOT_FOUND","name":"ERROR_CLUSTER_NETINTERFACE_NOT_FOUND","value":"5047_u32"},{"id":"ERROR_CLUSTER_INVALID_REQUEST","name":"ERROR_CLUSTER_INVALID_REQUEST","value":"5048_u32"},{"id":"ERROR_CLUSTER_INVALID_NETWORK_PROVIDER","name":"ERROR_CLUSTER_INVALID_NETWORK_PROVIDER","value":"5049_u32"},{"id":"ERROR_CLUSTER_NODE_DOWN","name":"ERROR_CLUSTER_NODE_DOWN","value":"5050_u32"},{"id":"ERROR_CLUSTER_NODE_UNREACHABLE","name":"ERROR_CLUSTER_NODE_UNREACHABLE","value":"5051_u32"},{"id":"ERROR_CLUSTER_NODE_NOT_MEMBER","name":"ERROR_CLUSTER_NODE_NOT_MEMBER","value":"5052_u32"},{"id":"ERROR_CLUSTER_JOIN_NOT_IN_PROGRESS","name":"ERROR_CLUSTER_JOIN_NOT_IN_PROGRESS","value":"5053_u32"},{"id":"ERROR_CLUSTER_INVALID_NETWORK","name":"ERROR_CLUSTER_INVALID_NETWORK","value":"5054_u32"},{"id":"ERROR_CLUSTER_NODE_UP","name":"ERROR_CLUSTER_NODE_UP","value":"5056_u32"},{"id":"ERROR_CLUSTER_IPADDR_IN_USE","name":"ERROR_CLUSTER_IPADDR_IN_USE","value":"5057_u32"},{"id":"ERROR_CLUSTER_NODE_NOT_PAUSED","name":"ERROR_CLUSTER_NODE_NOT_PAUSED","value":"5058_u32"},{"id":"ERROR_CLUSTER_NO_SECURITY_CONTEXT","name":"ERROR_CLUSTER_NO_SECURITY_CONTEXT","value":"5059_u32"},{"id":"ERROR_CLUSTER_NETWORK_NOT_INTERNAL","name":"ERROR_CLUSTER_NETWORK_NOT_INTERNAL","value":"5060_u32"},{"id":"ERROR_CLUSTER_NODE_ALREADY_UP","name":"ERROR_CLUSTER_NODE_ALREADY_UP","value":"5061_u32"},{"id":"ERROR_CLUSTER_NODE_ALREADY_DOWN","name":"ERROR_CLUSTER_NODE_ALREADY_DOWN","value":"5062_u32"},{"id":"ERROR_CLUSTER_NETWORK_ALREADY_ONLINE","name":"ERROR_CLUSTER_NETWORK_ALREADY_ONLINE","value":"5063_u32"},{"id":"ERROR_CLUSTER_NETWORK_ALREADY_OFFLINE","name":"ERROR_CLUSTER_NETWORK_ALREADY_OFFLINE","value":"5064_u32"},{"id":"ERROR_CLUSTER_NODE_ALREADY_MEMBER","name":"ERROR_CLUSTER_NODE_ALREADY_MEMBER","value":"5065_u32"},{"id":"ERROR_CLUSTER_LAST_INTERNAL_NETWORK","name":"ERROR_CLUSTER_LAST_INTERNAL_NETWORK","value":"5066_u32"},{"id":"ERROR_CLUSTER_NETWORK_HAS_DEPENDENTS","name":"ERROR_CLUSTER_NETWORK_HAS_DEPENDENTS","value":"5067_u32"},{"id":"ERROR_INVALID_OPERATION_ON_QUORUM","name":"ERROR_INVALID_OPERATION_ON_QUORUM","value":"5068_u32"},{"id":"ERROR_DEPENDENCY_NOT_ALLOWED","name":"ERROR_DEPENDENCY_NOT_ALLOWED","value":"5069_u32"},{"id":"ERROR_CLUSTER_NODE_PAUSED","name":"ERROR_CLUSTER_NODE_PAUSED","value":"5070_u32"},{"id":"ERROR_NODE_CANT_HOST_RESOURCE","name":"ERROR_NODE_CANT_HOST_RESOURCE","value":"5071_u32"},{"id":"ERROR_CLUSTER_NODE_NOT_READY","name":"ERROR_CLUSTER_NODE_NOT_READY","value":"5072_u32"},{"id":"ERROR_CLUSTER_NODE_SHUTTING_DOWN","name":"ERROR_CLUSTER_NODE_SHUTTING_DOWN","value":"5073_u32"},{"id":"ERROR_CLUSTER_JOIN_ABORTED","name":"ERROR_CLUSTER_JOIN_ABORTED","value":"5074_u32"},{"id":"ERROR_CLUSTER_INCOMPATIBLE_VERSIONS","name":"ERROR_CLUSTER_INCOMPATIBLE_VERSIONS","value":"5075_u32"},{"id":"ERROR_CLUSTER_MAXNUM_OF_RESOURCES_EXCEEDED","name":"ERROR_CLUSTER_MAXNUM_OF_RESOURCES_EXCEEDED","value":"5076_u32"},{"id":"ERROR_CLUSTER_SYSTEM_CONFIG_CHANGED","name":"ERROR_CLUSTER_SYSTEM_CONFIG_CHANGED","value":"5077_u32"},{"id":"ERROR_CLUSTER_RESOURCE_TYPE_NOT_FOUND","name":"ERROR_CLUSTER_RESOURCE_TYPE_NOT_FOUND","value":"5078_u32"},{"id":"ERROR_CLUSTER_RESTYPE_NOT_SUPPORTED","name":"ERROR_CLUSTER_RESTYPE_NOT_SUPPORTED","value":"5079_u32"},{"id":"ERROR_CLUSTER_RESNAME_NOT_FOUND","name":"ERROR_CLUSTER_RESNAME_NOT_FOUND","value":"5080_u32"},{"id":"ERROR_CLUSTER_NO_RPC_PACKAGES_REGISTERED","name":"ERROR_CLUSTER_NO_RPC_PACKAGES_REGISTERED","value":"5081_u32"},{"id":"ERROR_CLUSTER_OWNER_NOT_IN_PREFLIST","name":"ERROR_CLUSTER_OWNER_NOT_IN_PREFLIST","value":"5082_u32"},{"id":"ERROR_CLUSTER_DATABASE_SEQMISMATCH","name":"ERROR_CLUSTER_DATABASE_SEQMISMATCH","value":"5083_u32"},{"id":"ERROR_RESMON_INVALID_STATE","name":"ERROR_RESMON_INVALID_STATE","value":"5084_u32"},{"id":"ERROR_CLUSTER_GUM_NOT_LOCKER","name":"ERROR_CLUSTER_GUM_NOT_LOCKER","value":"5085_u32"},{"id":"ERROR_QUORUM_DISK_NOT_FOUND","name":"ERROR_QUORUM_DISK_NOT_FOUND","value":"5086_u32"},{"id":"ERROR_DATABASE_BACKUP_CORRUPT","name":"ERROR_DATABASE_BACKUP_CORRUPT","value":"5087_u32"},{"id":"ERROR_CLUSTER_NODE_ALREADY_HAS_DFS_ROOT","name":"ERROR_CLUSTER_NODE_ALREADY_HAS_DFS_ROOT","value":"5088_u32"},{"id":"ERROR_RESOURCE_PROPERTY_UNCHANGEABLE","name":"ERROR_RESOURCE_PROPERTY_UNCHANGEABLE","value":"5089_u32"},{"id":"ERROR_CLUSTER_MEMBERSHIP_INVALID_STATE","name":"ERROR_CLUSTER_MEMBERSHIP_INVALID_STATE","value":"5890_u32"},{"id":"ERROR_CLUSTER_QUORUMLOG_NOT_FOUND","name":"ERROR_CLUSTER_QUORUMLOG_NOT_FOUND","value":"5891_u32"},{"id":"ERROR_CLUSTER_MEMBERSHIP_HALT","name":"ERROR_CLUSTER_MEMBERSHIP_HALT","value":"5892_u32"},{"id":"ERROR_CLUSTER_INSTANCE_ID_MISMATCH","name":"ERROR_CLUSTER_INSTANCE_ID_MISMATCH","value":"5893_u32"},{"id":"ERROR_CLUSTER_NETWORK_NOT_FOUND_FOR_IP","name":"ERROR_CLUSTER_NETWORK_NOT_FOUND_FOR_IP","value":"5894_u32"},{"id":"ERROR_CLUSTER_PROPERTY_DATA_TYPE_MISMATCH","name":"ERROR_CLUSTER_PROPERTY_DATA_TYPE_MISMATCH","value":"5895_u32"},{"id":"ERROR_CLUSTER_EVICT_WITHOUT_CLEANUP","name":"ERROR_CLUSTER_EVICT_WITHOUT_CLEANUP","value":"5896_u32"},{"id":"ERROR_CLUSTER_PARAMETER_MISMATCH","name":"ERROR_CLUSTER_PARAMETER_MISMATCH","value":"5897_u32"},{"id":"ERROR_NODE_CANNOT_BE_CLUSTERED","name":"ERROR_NODE_CANNOT_BE_CLUSTERED","value":"5898_u32"},{"id":"ERROR_CLUSTER_WRONG_OS_VERSION","name":"ERROR_CLUSTER_WRONG_OS_VERSION","value":"5899_u32"},{"id":"ERROR_CLUSTER_CANT_CREATE_DUP_CLUSTER_NAME","name":"ERROR_CLUSTER_CANT_CREATE_DUP_CLUSTER_NAME","value":"5900_u32"},{"id":"ERROR_CLUSCFG_ALREADY_COMMITTED","name":"ERROR_CLUSCFG_ALREADY_COMMITTED","value":"5901_u32"},{"id":"ERROR_CLUSCFG_ROLLBACK_FAILED","name":"ERROR_CLUSCFG_ROLLBACK_FAILED","value":"5902_u32"},{"id":"ERROR_CLUSCFG_SYSTEM_DISK_DRIVE_LETTER_CONFLICT","name":"ERROR_CLUSCFG_SYSTEM_DISK_DRIVE_LETTER_CONFLICT","value":"5903_u32"},{"id":"ERROR_CLUSTER_OLD_VERSION","name":"ERROR_CLUSTER_OLD_VERSION","value":"5904_u32"},{"id":"ERROR_CLUSTER_MISMATCHED_COMPUTER_ACCT_NAME","name":"ERROR_CLUSTER_MISMATCHED_COMPUTER_ACCT_NAME","value":"5905_u32"},{"id":"ERROR_ENCRYPTION_FAILED","name":"ERROR_ENCRYPTION_FAILED","value":"6000_u32"},{"id":"ERROR_DECRYPTION_FAILED","name":"ERROR_DECRYPTION_FAILED","value":"6001_u32"},{"id":"ERROR_FILE_ENCRYPTED","name":"ERROR_FILE_ENCRYPTED","value":"6002_u32"},{"id":"ERROR_NO_RECOVERY_POLICY","name":"ERROR_NO_RECOVERY_POLICY","value":"6003_u32"},{"id":"ERROR_NO_EFS","name":"ERROR_NO_EFS","value":"6004_u32"},{"id":"ERROR_WRONG_EFS","name":"ERROR_WRONG_EFS","value":"6005_u32"},{"id":"ERROR_NO_USER_KEYS","name":"ERROR_NO_USER_KEYS","value":"6006_u32"},{"id":"ERROR_FILE_NOT_ENCRYPTED","name":"ERROR_FILE_NOT_ENCRYPTED","value":"6007_u32"},{"id":"ERROR_NOT_EXPORT_FORMAT","name":"ERROR_NOT_EXPORT_FORMAT","value":"6008_u32"},{"id":"ERROR_FILE_READ_ONLY","name":"ERROR_FILE_READ_ONLY","value":"6009_u32"},{"id":"ERROR_DIR_EFS_DISALLOWED","name":"ERROR_DIR_EFS_DISALLOWED","value":"6010_u32"},{"id":"ERROR_EFS_SERVER_NOT_TRUSTED","name":"ERROR_EFS_SERVER_NOT_TRUSTED","value":"6011_u32"},{"id":"ERROR_BAD_RECOVERY_POLICY","name":"ERROR_BAD_RECOVERY_POLICY","value":"6012_u32"},{"id":"ERROR_EFS_ALG_BLOB_TOO_BIG","name":"ERROR_EFS_ALG_BLOB_TOO_BIG","value":"6013_u32"},{"id":"ERROR_VOLUME_NOT_SUPPORT_EFS","name":"ERROR_VOLUME_NOT_SUPPORT_EFS","value":"6014_u32"},{"id":"ERROR_EFS_DISABLED","name":"ERROR_EFS_DISABLED","value":"6015_u32"},{"id":"ERROR_EFS_VERSION_NOT_SUPPORT","name":"ERROR_EFS_VERSION_NOT_SUPPORT","value":"6016_u32"},{"id":"ERROR_NO_BROWSER_SERVERS_FOUND","name":"ERROR_NO_BROWSER_SERVERS_FOUND","value":"6118_u32"},{"id":"SCHED_E_SERVICE_NOT_LOCALSYSTEM","name":"SCHED_E_SERVICE_NOT_LOCALSYSTEM","value":"6200_u32"},{"id":"ERROR_CTX_WINSTATION_NAME_INVALID","name":"ERROR_CTX_WINSTATION_NAME_INVALID","value":"7001_u32"},{"id":"ERROR_CTX_INVALID_PD","name":"ERROR_CTX_INVALID_PD","value":"7002_u32"},{"id":"ERROR_CTX_PD_NOT_FOUND","name":"ERROR_CTX_PD_NOT_FOUND","value":"7003_u32"},{"id":"ERROR_CTX_WD_NOT_FOUND","name":"ERROR_CTX_WD_NOT_FOUND","value":"7004_u32"},{"id":"ERROR_CTX_CANNOT_MAKE_EVENTLOG_ENTRY","name":"ERROR_CTX_CANNOT_MAKE_EVENTLOG_ENTRY","value":"7005_u32"},{"id":"ERROR_CTX_SERVICE_NAME_COLLISION","name":"ERROR_CTX_SERVICE_NAME_COLLISION","value":"7006_u32"},{"id":"ERROR_CTX_CLOSE_PENDING","name":"ERROR_CTX_CLOSE_PENDING","value":"7007_u32"},{"id":"ERROR_CTX_NO_OUTBUF","name":"ERROR_CTX_NO_OUTBUF","value":"7008_u32"},{"id":"ERROR_CTX_MODEM_INF_NOT_FOUND","name":"ERROR_CTX_MODEM_INF_NOT_FOUND","value":"7009_u32"},{"id":"ERROR_CTX_INVALID_MODEMNAME","name":"ERROR_CTX_INVALID_MODEMNAME","value":"7010_u32"},{"id":"ERROR_CTX_MODEM_RESPONSE_ERROR","name":"ERROR_CTX_MODEM_RESPONSE_ERROR","value":"7011_u32"},{"id":"ERROR_CTX_MODEM_RESPONSE_TIMEOUT","name":"ERROR_CTX_MODEM_RESPONSE_TIMEOUT","value":"7012_u32"},{"id":"ERROR_CTX_MODEM_RESPONSE_NO_CARRIER","name":"ERROR_CTX_MODEM_RESPONSE_NO_CARRIER","value":"7013_u32"},{"id":"ERROR_CTX_MODEM_RESPONSE_NO_DIALTONE","name":"ERROR_CTX_MODEM_RESPONSE_NO_DIALTONE","value":"7014_u32"},{"id":"ERROR_CTX_MODEM_RESPONSE_BUSY","name":"ERROR_CTX_MODEM_RESPONSE_BUSY","value":"7015_u32"},{"id":"ERROR_CTX_MODEM_RESPONSE_VOICE","name":"ERROR_CTX_MODEM_RESPONSE_VOICE","value":"7016_u32"},{"id":"ERROR_CTX_TD_ERROR","name":"ERROR_CTX_TD_ERROR","value":"7017_u32"},{"id":"ERROR_CTX_WINSTATION_NOT_FOUND","name":"ERROR_CTX_WINSTATION_NOT_FOUND","value":"7022_u32"},{"id":"ERROR_CTX_WINSTATION_ALREADY_EXISTS","name":"ERROR_CTX_WINSTATION_ALREADY_EXISTS","value":"7023_u32"},{"id":"ERROR_CTX_WINSTATION_BUSY","name":"ERROR_CTX_WINSTATION_BUSY","value":"7024_u32"},{"id":"ERROR_CTX_BAD_VIDEO_MODE","name":"ERROR_CTX_BAD_VIDEO_MODE","value":"7025_u32"},{"id":"ERROR_CTX_GRAPHICS_INVALID","name":"ERROR_CTX_GRAPHICS_INVALID","value":"7035_u32"},{"id":"ERROR_CTX_LOGON_DISABLED","name":"ERROR_CTX_LOGON_DISABLED","value":"7037_u32"},{"id":"ERROR_CTX_NOT_CONSOLE","name":"ERROR_CTX_NOT_CONSOLE","value":"7038_u32"},{"id":"ERROR_CTX_CLIENT_QUERY_TIMEOUT","name":"ERROR_CTX_CLIENT_QUERY_TIMEOUT","value":"7040_u32"},{"id":"ERROR_CTX_CONSOLE_DISCONNECT","name":"ERROR_CTX_CONSOLE_DISCONNECT","value":"7041_u32"},{"id":"ERROR_CTX_CONSOLE_CONNECT","name":"ERROR_CTX_CONSOLE_CONNECT","value":"7042_u32"},{"id":"ERROR_CTX_SHADOW_DENIED","name":"ERROR_CTX_SHADOW_DENIED","value":"7044_u32"},{"id":"ERROR_CTX_WINSTATION_ACCESS_DENIED","name":"ERROR_CTX_WINSTATION_ACCESS_DENIED","value":"7045_u32"},{"id":"ERROR_CTX_INVALID_WD","name":"ERROR_CTX_INVALID_WD","value":"7049_u32"},{"id":"ERROR_CTX_SHADOW_INVALID","name":"ERROR_CTX_SHADOW_INVALID","value":"7050_u32"},{"id":"ERROR_CTX_SHADOW_DISABLED","name":"ERROR_CTX_SHADOW_DISABLED","value":"7051_u32"},{"id":"ERROR_CTX_CLIENT_LICENSE_IN_USE","name":"ERROR_CTX_CLIENT_LICENSE_IN_USE","value":"7052_u32"},{"id":"ERROR_CTX_CLIENT_LICENSE_NOT_SET","name":"ERROR_CTX_CLIENT_LICENSE_NOT_SET","value":"7053_u32"},{"id":"ERROR_CTX_LICENSE_NOT_AVAILABLE","name":"ERROR_CTX_LICENSE_NOT_AVAILABLE","value":"7054_u32"},{"id":"ERROR_CTX_LICENSE_CLIENT_INVALID","name":"ERROR_CTX_LICENSE_CLIENT_INVALID","value":"7055_u32"},{"id":"ERROR_CTX_LICENSE_EXPIRED","name":"ERROR_CTX_LICENSE_EXPIRED","value":"7056_u32"},{"id":"ERROR_CTX_SHADOW_NOT_RUNNING","name":"ERROR_CTX_SHADOW_NOT_RUNNING","value":"7057_u32"},{"id":"ERROR_CTX_SHADOW_ENDED_BY_MODE_CHANGE","name":"ERROR_CTX_SHADOW_ENDED_BY_MODE_CHANGE","value":"7058_u32"},{"id":"ERROR_ACTIVATION_COUNT_EXCEEDED","name":"ERROR_ACTIVATION_COUNT_EXCEEDED","value":"7059_u32"},{"id":"FRS_ERR_INVALID_API_SEQUENCE","name":"FRS_ERR_INVALID_API_SEQUENCE","value":"8001_u32"},{"id":"FRS_ERR_STARTING_SERVICE","name":"FRS_ERR_STARTING_SERVICE","value":"8002_u32"},{"id":"FRS_ERR_STOPPING_SERVICE","name":"FRS_ERR_STOPPING_SERVICE","value":"8003_u32"},{"id":"FRS_ERR_INTERNAL_API","name":"FRS_ERR_INTERNAL_API","value":"8004_u32"},{"id":"FRS_ERR_INTERNAL","name":"FRS_ERR_INTERNAL","value":"8005_u32"},{"id":"FRS_ERR_SERVICE_COMM","name":"FRS_ERR_SERVICE_COMM","value":"8006_u32"},{"id":"FRS_ERR_INSUFFICIENT_PRIV","name":"FRS_ERR_INSUFFICIENT_PRIV","value":"8007_u32"},{"id":"FRS_ERR_AUTHENTICATION","name":"FRS_ERR_AUTHENTICATION","value":"8008_u32"},{"id":"FRS_ERR_PARENT_INSUFFICIENT_PRIV","name":"FRS_ERR_PARENT_INSUFFICIENT_PRIV","value":"8009_u32"},{"id":"FRS_ERR_PARENT_AUTHENTICATION","name":"FRS_ERR_PARENT_AUTHENTICATION","value":"8010_u32"},{"id":"FRS_ERR_CHILD_TO_PARENT_COMM","name":"FRS_ERR_CHILD_TO_PARENT_COMM","value":"8011_u32"},{"id":"FRS_ERR_PARENT_TO_CHILD_COMM","name":"FRS_ERR_PARENT_TO_CHILD_COMM","value":"8012_u32"},{"id":"FRS_ERR_SYSVOL_POPULATE","name":"FRS_ERR_SYSVOL_POPULATE","value":"8013_u32"},{"id":"FRS_ERR_SYSVOL_POPULATE_TIMEOUT","name":"FRS_ERR_SYSVOL_POPULATE_TIMEOUT","value":"8014_u32"},{"id":"FRS_ERR_SYSVOL_IS_BUSY","name":"FRS_ERR_SYSVOL_IS_BUSY","value":"8015_u32"},{"id":"FRS_ERR_SYSVOL_DEMOTE","name":"FRS_ERR_SYSVOL_DEMOTE","value":"8016_u32"},{"id":"FRS_ERR_INVALID_SERVICE_PARAMETER","name":"FRS_ERR_INVALID_SERVICE_PARAMETER","value":"8017_u32"},{"id":"ERROR_DS_NOT_INSTALLED","name":"ERROR_DS_NOT_INSTALLED","value":"8200_u32"},{"id":"ERROR_DS_MEMBERSHIP_EVALUATED_LOCALLY","name":"ERROR_DS_MEMBERSHIP_EVALUATED_LOCALLY","value":"8201_u32"},{"id":"ERROR_DS_NO_ATTRIBUTE_OR_VALUE","name":"ERROR_DS_NO_ATTRIBUTE_OR_VALUE","value":"8202_u32"},{"id":"ERROR_DS_INVALID_ATTRIBUTE_SYNTAX","name":"ERROR_DS_INVALID_ATTRIBUTE_SYNTAX","value":"8203_u32"},{"id":"ERROR_DS_ATTRIBUTE_TYPE_UNDEFINED","name":"ERROR_DS_ATTRIBUTE_TYPE_UNDEFINED","value":"8204_u32"},{"id":"ERROR_DS_ATTRIBUTE_OR_VALUE_EXISTS","name":"ERROR_DS_ATTRIBUTE_OR_VALUE_EXISTS","value":"8205_u32"},{"id":"ERROR_DS_BUSY","name":"ERROR_DS_BUSY","value":"8206_u32"},{"id":"ERROR_DS_UNAVAILABLE","name":"ERROR_DS_UNAVAILABLE","value":"8207_u32"},{"id":"ERROR_DS_NO_RIDS_ALLOCATED","name":"ERROR_DS_NO_RIDS_ALLOCATED","value":"8208_u32"},{"id":"ERROR_DS_NO_MORE_RIDS","name":"ERROR_DS_NO_MORE_RIDS","value":"8209_u32"},{"id":"ERROR_DS_INCORRECT_ROLE_OWNER","name":"ERROR_DS_INCORRECT_ROLE_OWNER","value":"8210_u32"},{"id":"ERROR_DS_RIDMGR_INIT_ERROR","name":"ERROR_DS_RIDMGR_INIT_ERROR","value":"8211_u32"},{"id":"ERROR_DS_OBJ_CLASS_VIOLATION","name":"ERROR_DS_OBJ_CLASS_VIOLATION","value":"8212_u32"},{"id":"ERROR_DS_CANT_ON_NON_LEAF","name":"ERROR_DS_CANT_ON_NON_LEAF","value":"8213_u32"},{"id":"ERROR_DS_CANT_ON_RDN","name":"ERROR_DS_CANT_ON_RDN","value":"8214_u32"},{"id":"ERROR_DS_CANT_MOD_OBJ_CLASS","name":"ERROR_DS_CANT_MOD_OBJ_CLASS","value":"8215_u32"},{"id":"ERROR_DS_CROSS_DOM_MOVE_ERROR","name":"ERROR_DS_CROSS_DOM_MOVE_ERROR","value":"8216_u32"},{"id":"ERROR_DS_GC_NOT_AVAILABLE","name":"ERROR_DS_GC_NOT_AVAILABLE","value":"8217_u32"},{"id":"ERROR_SHARED_POLICY","name":"ERROR_SHARED_POLICY","value":"8218_u32"},{"id":"ERROR_POLICY_OBJECT_NOT_FOUND","name":"ERROR_POLICY_OBJECT_NOT_FOUND","value":"8219_u32"},{"id":"ERROR_POLICY_ONLY_IN_DS","name":"ERROR_POLICY_ONLY_IN_DS","value":"8220_u32"},{"id":"ERROR_PROMOTION_ACTIVE","name":"ERROR_PROMOTION_ACTIVE","value":"8221_u32"},{"id":"ERROR_NO_PROMOTION_ACTIVE","name":"ERROR_NO_PROMOTION_ACTIVE","value":"8222_u32"},{"id":"ERROR_DS_OPERATIONS_ERROR","name":"ERROR_DS_OPERATIONS_ERROR","value":"8224_u32"},{"id":"ERROR_DS_PROTOCOL_ERROR","name":"ERROR_DS_PROTOCOL_ERROR","value":"8225_u32"},{"id":"ERROR_DS_TIMELIMIT_EXCEEDED","name":"ERROR_DS_TIMELIMIT_EXCEEDED","value":"8226_u32"},{"id":"ERROR_DS_SIZELIMIT_EXCEEDED","name":"ERROR_DS_SIZELIMIT_EXCEEDED","value":"8227_u32"},{"id":"ERROR_DS_ADMIN_LIMIT_EXCEEDED","name":"ERROR_DS_ADMIN_LIMIT_EXCEEDED","value":"8228_u32"},{"id":"ERROR_DS_COMPARE_FALSE","name":"ERROR_DS_COMPARE_FALSE","value":"8229_u32"},{"id":"ERROR_DS_COMPARE_TRUE","name":"ERROR_DS_COMPARE_TRUE","value":"8230_u32"},{"id":"ERROR_DS_AUTH_METHOD_NOT_SUPPORTED","name":"ERROR_DS_AUTH_METHOD_NOT_SUPPORTED","value":"8231_u32"},{"id":"ERROR_DS_STRONG_AUTH_REQUIRED","name":"ERROR_DS_STRONG_AUTH_REQUIRED","value":"8232_u32"},{"id":"ERROR_DS_INAPPROPRIATE_AUTH","name":"ERROR_DS_INAPPROPRIATE_AUTH","value":"8233_u32"},{"id":"ERROR_DS_AUTH_UNKNOWN","name":"ERROR_DS_AUTH_UNKNOWN","value":"8234_u32"},{"id":"ERROR_DS_REFERRAL","name":"ERROR_DS_REFERRAL","value":"8235_u32"},{"id":"ERROR_DS_UNAVAILABLE_CRIT_EXTENSION","name":"ERROR_DS_UNAVAILABLE_CRIT_EXTENSION","value":"8236_u32"},{"id":"ERROR_DS_CONFIDENTIALITY_REQUIRED","name":"ERROR_DS_CONFIDENTIALITY_REQUIRED","value":"8237_u32"},{"id":"ERROR_DS_INAPPROPRIATE_MATCHING","name":"ERROR_DS_INAPPROPRIATE_MATCHING","value":"8238_u32"},{"id":"ERROR_DS_CONSTRAINT_VIOLATION","name":"ERROR_DS_CONSTRAINT_VIOLATION","value":"8239_u32"},{"id":"ERROR_DS_NO_SUCH_OBJECT","name":"ERROR_DS_NO_SUCH_OBJECT","value":"8240_u32"},{"id":"ERROR_DS_ALIAS_PROBLEM","name":"ERROR_DS_ALIAS_PROBLEM","value":"8241_u32"},{"id":"ERROR_DS_INVALID_DN_SYNTAX","name":"ERROR_DS_INVALID_DN_SYNTAX","value":"8242_u32"},{"id":"ERROR_DS_IS_LEAF","name":"ERROR_DS_IS_LEAF","value":"8243_u32"},{"id":"ERROR_DS_ALIAS_DEREF_PROBLEM","name":"ERROR_DS_ALIAS_DEREF_PROBLEM","value":"8244_u32"},{"id":"ERROR_DS_UNWILLING_TO_PERFORM","name":"ERROR_DS_UNWILLING_TO_PERFORM","value":"8245_u32"},{"id":"ERROR_DS_LOOP_DETECT","name":"ERROR_DS_LOOP_DETECT","value":"8246_u32"},{"id":"ERROR_DS_NAMING_VIOLATION","name":"ERROR_DS_NAMING_VIOLATION","value":"8247_u32"},{"id":"ERROR_DS_OBJECT_RESULTS_TOO_LARGE","name":"ERROR_DS_OBJECT_RESULTS_TOO_LARGE","value":"8248_u32"},{"id":"ERROR_DS_AFFECTS_MULTIPLE_DSAS","name":"ERROR_DS_AFFECTS_MULTIPLE_DSAS","value":"8249_u32"},{"id":"ERROR_DS_SERVER_DOWN","name":"ERROR_DS_SERVER_DOWN","value":"8250_u32"},{"id":"ERROR_DS_LOCAL_ERROR","name":"ERROR_DS_LOCAL_ERROR","value":"8251_u32"},{"id":"ERROR_DS_ENCODING_ERROR","name":"ERROR_DS_ENCODING_ERROR","value":"8252_u32"},{"id":"ERROR_DS_DECODING_ERROR","name":"ERROR_DS_DECODING_ERROR","value":"8253_u32"},{"id":"ERROR_DS_FILTER_UNKNOWN","name":"ERROR_DS_FILTER_UNKNOWN","value":"8254_u32"},{"id":"ERROR_DS_PARAM_ERROR","name":"ERROR_DS_PARAM_ERROR","value":"8255_u32"},{"id":"ERROR_DS_NOT_SUPPORTED","name":"ERROR_DS_NOT_SUPPORTED","value":"8256_u32"},{"id":"ERROR_DS_NO_RESULTS_RETURNED","name":"ERROR_DS_NO_RESULTS_RETURNED","value":"8257_u32"},{"id":"ERROR_DS_CONTROL_NOT_FOUND","name":"ERROR_DS_CONTROL_NOT_FOUND","value":"8258_u32"},{"id":"ERROR_DS_CLIENT_LOOP","name":"ERROR_DS_CLIENT_LOOP","value":"8259_u32"},{"id":"ERROR_DS_REFERRAL_LIMIT_EXCEEDED","name":"ERROR_DS_REFERRAL_LIMIT_EXCEEDED","value":"8260_u32"},{"id":"ERROR_DS_SORT_CONTROL_MISSING","name":"ERROR_DS_SORT_CONTROL_MISSING","value":"8261_u32"},{"id":"ERROR_DS_OFFSET_RANGE_ERROR","name":"ERROR_DS_OFFSET_RANGE_ERROR","value":"8262_u32"},{"id":"ERROR_DS_ROOT_MUST_BE_NC","name":"ERROR_DS_ROOT_MUST_BE_NC","value":"8301_u32"},{"id":"ERROR_DS_ADD_REPLICA_INHIBITED","name":"ERROR_DS_ADD_REPLICA_INHIBITED","value":"8302_u32"},{"id":"ERROR_DS_ATT_NOT_DEF_IN_SCHEMA","name":"ERROR_DS_ATT_NOT_DEF_IN_SCHEMA","value":"8303_u32"},{"id":"ERROR_DS_MAX_OBJ_SIZE_EXCEEDED","name":"ERROR_DS_MAX_OBJ_SIZE_EXCEEDED","value":"8304_u32"},{"id":"ERROR_DS_OBJ_STRING_NAME_EXISTS","name":"ERROR_DS_OBJ_STRING_NAME_EXISTS","value":"8305_u32"},{"id":"ERROR_DS_NO_RDN_DEFINED_IN_SCHEMA","name":"ERROR_DS_NO_RDN_DEFINED_IN_SCHEMA","value":"8306_u32"},{"id":"ERROR_DS_RDN_DOESNT_MATCH_SCHEMA","name":"ERROR_DS_RDN_DOESNT_MATCH_SCHEMA","value":"8307_u32"},{"id":"ERROR_DS_NO_REQUESTED_ATTS_FOUND","name":"ERROR_DS_NO_REQUESTED_ATTS_FOUND","value":"8308_u32"},{"id":"ERROR_DS_USER_BUFFER_TO_SMALL","name":"ERROR_DS_USER_BUFFER_TO_SMALL","value":"8309_u32"},{"id":"ERROR_DS_ATT_IS_NOT_ON_OBJ","name":"ERROR_DS_ATT_IS_NOT_ON_OBJ","value":"8310_u32"},{"id":"ERROR_DS_ILLEGAL_MOD_OPERATION","name":"ERROR_DS_ILLEGAL_MOD_OPERATION","value":"8311_u32"},{"id":"ERROR_DS_OBJ_TOO_LARGE","name":"ERROR_DS_OBJ_TOO_LARGE","value":"8312_u32"},{"id":"ERROR_DS_BAD_INSTANCE_TYPE","name":"ERROR_DS_BAD_INSTANCE_TYPE","value":"8313_u32"},{"id":"ERROR_DS_MASTERDSA_REQUIRED","name":"ERROR_DS_MASTERDSA_REQUIRED","value":"8314_u32"},{"id":"ERROR_DS_OBJECT_CLASS_REQUIRED","name":"ERROR_DS_OBJECT_CLASS_REQUIRED","value":"8315_u32"},{"id":"ERROR_DS_MISSING_REQUIRED_ATT","name":"ERROR_DS_MISSING_REQUIRED_ATT","value":"8316_u32"},{"id":"ERROR_DS_ATT_NOT_DEF_FOR_CLASS","name":"ERROR_DS_ATT_NOT_DEF_FOR_CLASS","value":"8317_u32"},{"id":"ERROR_DS_ATT_ALREADY_EXISTS","name":"ERROR_DS_ATT_ALREADY_EXISTS","value":"8318_u32"},{"id":"ERROR_DS_CANT_ADD_ATT_VALUES","name":"ERROR_DS_CANT_ADD_ATT_VALUES","value":"8320_u32"},{"id":"ERROR_DS_SINGLE_VALUE_CONSTRAINT","name":"ERROR_DS_SINGLE_VALUE_CONSTRAINT","value":"8321_u32"},{"id":"ERROR_DS_RANGE_CONSTRAINT","name":"ERROR_DS_RANGE_CONSTRAINT","value":"8322_u32"},{"id":"ERROR_DS_ATT_VAL_ALREADY_EXISTS","name":"ERROR_DS_ATT_VAL_ALREADY_EXISTS","value":"8323_u32"},{"id":"ERROR_DS_CANT_REM_MISSING_ATT","name":"ERROR_DS_CANT_REM_MISSING_ATT","value":"8324_u32"},{"id":"ERROR_DS_CANT_REM_MISSING_ATT_VAL","name":"ERROR_DS_CANT_REM_MISSING_ATT_VAL","value":"8325_u32"},{"id":"ERROR_DS_ROOT_CANT_BE_SUBREF","name":"ERROR_DS_ROOT_CANT_BE_SUBREF","value":"8326_u32"},{"id":"ERROR_DS_NO_CHAINING","name":"ERROR_DS_NO_CHAINING","value":"8327_u32"},{"id":"ERROR_DS_NO_CHAINED_EVAL","name":"ERROR_DS_NO_CHAINED_EVAL","value":"8328_u32"},{"id":"ERROR_DS_NO_PARENT_OBJECT","name":"ERROR_DS_NO_PARENT_OBJECT","value":"8329_u32"},{"id":"ERROR_DS_PARENT_IS_AN_ALIAS","name":"ERROR_DS_PARENT_IS_AN_ALIAS","value":"8330_u32"},{"id":"ERROR_DS_CANT_MIX_MASTER_AND_REPS","name":"ERROR_DS_CANT_MIX_MASTER_AND_REPS","value":"8331_u32"},{"id":"ERROR_DS_CHILDREN_EXIST","name":"ERROR_DS_CHILDREN_EXIST","value":"8332_u32"},{"id":"ERROR_DS_OBJ_NOT_FOUND","name":"ERROR_DS_OBJ_NOT_FOUND","value":"8333_u32"},{"id":"ERROR_DS_ALIASED_OBJ_MISSING","name":"ERROR_DS_ALIASED_OBJ_MISSING","value":"8334_u32"},{"id":"ERROR_DS_BAD_NAME_SYNTAX","name":"ERROR_DS_BAD_NAME_SYNTAX","value":"8335_u32"},{"id":"ERROR_DS_ALIAS_POINTS_TO_ALIAS","name":"ERROR_DS_ALIAS_POINTS_TO_ALIAS","value":"8336_u32"},{"id":"ERROR_DS_CANT_DEREF_ALIAS","name":"ERROR_DS_CANT_DEREF_ALIAS","value":"8337_u32"},{"id":"ERROR_DS_OUT_OF_SCOPE","name":"ERROR_DS_OUT_OF_SCOPE","value":"8338_u32"},{"id":"ERROR_DS_OBJECT_BEING_REMOVED","name":"ERROR_DS_OBJECT_BEING_REMOVED","value":"8339_u32"},{"id":"ERROR_DS_CANT_DELETE_DSA_OBJ","name":"ERROR_DS_CANT_DELETE_DSA_OBJ","value":"8340_u32"},{"id":"ERROR_DS_GENERIC_ERROR","name":"ERROR_DS_GENERIC_ERROR","value":"8341_u32"},{"id":"ERROR_DS_DSA_MUST_BE_INT_MASTER","name":"ERROR_DS_DSA_MUST_BE_INT_MASTER","value":"8342_u32"},{"id":"ERROR_DS_CLASS_NOT_DSA","name":"ERROR_DS_CLASS_NOT_DSA","value":"8343_u32"},{"id":"ERROR_DS_INSUFF_ACCESS_RIGHTS","name":"ERROR_DS_INSUFF_ACCESS_RIGHTS","value":"8344_u32"},{"id":"ERROR_DS_ILLEGAL_SUPERIOR","name":"ERROR_DS_ILLEGAL_SUPERIOR","value":"8345_u32"},{"id":"ERROR_DS_ATTRIBUTE_OWNED_BY_SAM","name":"ERROR_DS_ATTRIBUTE_OWNED_BY_SAM","value":"8346_u32"},{"id":"ERROR_DS_NAME_TOO_MANY_PARTS","name":"ERROR_DS_NAME_TOO_MANY_PARTS","value":"8347_u32"},{"id":"ERROR_DS_NAME_TOO_LONG","name":"ERROR_DS_NAME_TOO_LONG","value":"8348_u32"},{"id":"ERROR_DS_NAME_VALUE_TOO_LONG","name":"ERROR_DS_NAME_VALUE_TOO_LONG","value":"8349_u32"},{"id":"ERROR_DS_NAME_UNPARSEABLE","name":"ERROR_DS_NAME_UNPARSEABLE","value":"8350_u32"},{"id":"ERROR_DS_NAME_TYPE_UNKNOWN","name":"ERROR_DS_NAME_TYPE_UNKNOWN","value":"8351_u32"},{"id":"ERROR_DS_NOT_AN_OBJECT","name":"ERROR_DS_NOT_AN_OBJECT","value":"8352_u32"},{"id":"ERROR_DS_SEC_DESC_TOO_SHORT","name":"ERROR_DS_SEC_DESC_TOO_SHORT","value":"8353_u32"},{"id":"ERROR_DS_SEC_DESC_INVALID","name":"ERROR_DS_SEC_DESC_INVALID","value":"8354_u32"},{"id":"ERROR_DS_NO_DELETED_NAME","name":"ERROR_DS_NO_DELETED_NAME","value":"8355_u32"},{"id":"ERROR_DS_SUBREF_MUST_HAVE_PARENT","name":"ERROR_DS_SUBREF_MUST_HAVE_PARENT","value":"8356_u32"},{"id":"ERROR_DS_NCNAME_MUST_BE_NC","name":"ERROR_DS_NCNAME_MUST_BE_NC","value":"8357_u32"},{"id":"ERROR_DS_CANT_ADD_SYSTEM_ONLY","name":"ERROR_DS_CANT_ADD_SYSTEM_ONLY","value":"8358_u32"},{"id":"ERROR_DS_CLASS_MUST_BE_CONCRETE","name":"ERROR_DS_CLASS_MUST_BE_CONCRETE","value":"8359_u32"},{"id":"ERROR_DS_INVALID_DMD","name":"ERROR_DS_INVALID_DMD","value":"8360_u32"},{"id":"ERROR_DS_OBJ_GUID_EXISTS","name":"ERROR_DS_OBJ_GUID_EXISTS","value":"8361_u32"},{"id":"ERROR_DS_NOT_ON_BACKLINK","name":"ERROR_DS_NOT_ON_BACKLINK","value":"8362_u32"},{"id":"ERROR_DS_NO_CROSSREF_FOR_NC","name":"ERROR_DS_NO_CROSSREF_FOR_NC","value":"8363_u32"},{"id":"ERROR_DS_SHUTTING_DOWN","name":"ERROR_DS_SHUTTING_DOWN","value":"8364_u32"},{"id":"ERROR_DS_UNKNOWN_OPERATION","name":"ERROR_DS_UNKNOWN_OPERATION","value":"8365_u32"},{"id":"ERROR_DS_INVALID_ROLE_OWNER","name":"ERROR_DS_INVALID_ROLE_OWNER","value":"8366_u32"},{"id":"ERROR_DS_COULDNT_CONTACT_FSMO","name":"ERROR_DS_COULDNT_CONTACT_FSMO","value":"8367_u32"},{"id":"ERROR_DS_CROSS_NC_DN_RENAME","name":"ERROR_DS_CROSS_NC_DN_RENAME","value":"8368_u32"},{"id":"ERROR_DS_CANT_MOD_SYSTEM_ONLY","name":"ERROR_DS_CANT_MOD_SYSTEM_ONLY","value":"8369_u32"},{"id":"ERROR_DS_REPLICATOR_ONLY","name":"ERROR_DS_REPLICATOR_ONLY","value":"8370_u32"},{"id":"ERROR_DS_OBJ_CLASS_NOT_DEFINED","name":"ERROR_DS_OBJ_CLASS_NOT_DEFINED","value":"8371_u32"},{"id":"ERROR_DS_OBJ_CLASS_NOT_SUBCLASS","name":"ERROR_DS_OBJ_CLASS_NOT_SUBCLASS","value":"8372_u32"},{"id":"ERROR_DS_NAME_REFERENCE_INVALID","name":"ERROR_DS_NAME_REFERENCE_INVALID","value":"8373_u32"},{"id":"ERROR_DS_CROSS_REF_EXISTS","name":"ERROR_DS_CROSS_REF_EXISTS","value":"8374_u32"},{"id":"ERROR_DS_CANT_DEL_MASTER_CROSSREF","name":"ERROR_DS_CANT_DEL_MASTER_CROSSREF","value":"8375_u32"},{"id":"ERROR_DS_SUBTREE_NOTIFY_NOT_NC_HEAD","name":"ERROR_DS_SUBTREE_NOTIFY_NOT_NC_HEAD","value":"8376_u32"},{"id":"ERROR_DS_NOTIFY_FILTER_TOO_COMPLEX","name":"ERROR_DS_NOTIFY_FILTER_TOO_COMPLEX","value":"8377_u32"},{"id":"ERROR_DS_DUP_RDN","name":"ERROR_DS_DUP_RDN","value":"8378_u32"},{"id":"ERROR_DS_DUP_OID","name":"ERROR_DS_DUP_OID","value":"8379_u32"},{"id":"ERROR_DS_DUP_MAPI_ID","name":"ERROR_DS_DUP_MAPI_ID","value":"8380_u32"},{"id":"ERROR_DS_DUP_SCHEMA_ID_GUID","name":"ERROR_DS_DUP_SCHEMA_ID_GUID","value":"8381_u32"},{"id":"ERROR_DS_DUP_LDAP_DISPLAY_NAME","name":"ERROR_DS_DUP_LDAP_DISPLAY_NAME","value":"8382_u32"},{"id":"ERROR_DS_SEMANTIC_ATT_TEST","name":"ERROR_DS_SEMANTIC_ATT_TEST","value":"8383_u32"},{"id":"ERROR_DS_SYNTAX_MISMATCH","name":"ERROR_DS_SYNTAX_MISMATCH","value":"8384_u32"},{"id":"ERROR_DS_EXISTS_IN_MUST_HAVE","name":"ERROR_DS_EXISTS_IN_MUST_HAVE","value":"8385_u32"},{"id":"ERROR_DS_EXISTS_IN_MAY_HAVE","name":"ERROR_DS_EXISTS_IN_MAY_HAVE","value":"8386_u32"},{"id":"ERROR_DS_NONEXISTENT_MAY_HAVE","name":"ERROR_DS_NONEXISTENT_MAY_HAVE","value":"8387_u32"},{"id":"ERROR_DS_NONEXISTENT_MUST_HAVE","name":"ERROR_DS_NONEXISTENT_MUST_HAVE","value":"8388_u32"},{"id":"ERROR_DS_AUX_CLS_TEST_FAIL","name":"ERROR_DS_AUX_CLS_TEST_FAIL","value":"8389_u32"},{"id":"ERROR_DS_NONEXISTENT_POSS_SUP","name":"ERROR_DS_NONEXISTENT_POSS_SUP","value":"8390_u32"},{"id":"ERROR_DS_SUB_CLS_TEST_FAIL","name":"ERROR_DS_SUB_CLS_TEST_FAIL","value":"8391_u32"},{"id":"ERROR_DS_BAD_RDN_ATT_ID_SYNTAX","name":"ERROR_DS_BAD_RDN_ATT_ID_SYNTAX","value":"8392_u32"},{"id":"ERROR_DS_EXISTS_IN_AUX_CLS","name":"ERROR_DS_EXISTS_IN_AUX_CLS","value":"8393_u32"},{"id":"ERROR_DS_EXISTS_IN_SUB_CLS","name":"ERROR_DS_EXISTS_IN_SUB_CLS","value":"8394_u32"},{"id":"ERROR_DS_EXISTS_IN_POSS_SUP","name":"ERROR_DS_EXISTS_IN_POSS_SUP","value":"8395_u32"},{"id":"ERROR_DS_RECALCSCHEMA_FAILED","name":"ERROR_DS_RECALCSCHEMA_FAILED","value":"8396_u32"},{"id":"ERROR_DS_TREE_DELETE_NOT_FINISHED","name":"ERROR_DS_TREE_DELETE_NOT_FINISHED","value":"8397_u32"},{"id":"ERROR_DS_CANT_DELETE","name":"ERROR_DS_CANT_DELETE","value":"8398_u32"},{"id":"ERROR_DS_ATT_SCHEMA_REQ_ID","name":"ERROR_DS_ATT_SCHEMA_REQ_ID","value":"8399_u32"},{"id":"ERROR_DS_BAD_ATT_SCHEMA_SYNTAX","name":"ERROR_DS_BAD_ATT_SCHEMA_SYNTAX","value":"8400_u32"},{"id":"ERROR_DS_CANT_CACHE_ATT","name":"ERROR_DS_CANT_CACHE_ATT","value":"8401_u32"},{"id":"ERROR_DS_CANT_CACHE_CLASS","name":"ERROR_DS_CANT_CACHE_CLASS","value":"8402_u32"},{"id":"ERROR_DS_CANT_REMOVE_ATT_CACHE","name":"ERROR_DS_CANT_REMOVE_ATT_CACHE","value":"8403_u32"},{"id":"ERROR_DS_CANT_REMOVE_CLASS_CACHE","name":"ERROR_DS_CANT_REMOVE_CLASS_CACHE","value":"8404_u32"},{"id":"ERROR_DS_CANT_RETRIEVE_DN","name":"ERROR_DS_CANT_RETRIEVE_DN","value":"8405_u32"},{"id":"ERROR_DS_MISSING_SUPREF","name":"ERROR_DS_MISSING_SUPREF","value":"8406_u32"},{"id":"ERROR_DS_CANT_RETRIEVE_INSTANCE","name":"ERROR_DS_CANT_RETRIEVE_INSTANCE","value":"8407_u32"},{"id":"ERROR_DS_CODE_INCONSISTENCY","name":"ERROR_DS_CODE_INCONSISTENCY","value":"8408_u32"},{"id":"ERROR_DS_DATABASE_ERROR","name":"ERROR_DS_DATABASE_ERROR","value":"8409_u32"},{"id":"ERROR_DS_GOVERNSID_MISSING","name":"ERROR_DS_GOVERNSID_MISSING","value":"8410_u32"},{"id":"ERROR_DS_MISSING_EXPECTED_ATT","name":"ERROR_DS_MISSING_EXPECTED_ATT","value":"8411_u32"},{"id":"ERROR_DS_NCNAME_MISSING_CR_REF","name":"ERROR_DS_NCNAME_MISSING_CR_REF","value":"8412_u32"},{"id":"ERROR_DS_SECURITY_CHECKING_ERROR","name":"ERROR_DS_SECURITY_CHECKING_ERROR","value":"8413_u32"},{"id":"ERROR_DS_SCHEMA_NOT_LOADED","name":"ERROR_DS_SCHEMA_NOT_LOADED","value":"8414_u32"},{"id":"ERROR_DS_SCHEMA_ALLOC_FAILED","name":"ERROR_DS_SCHEMA_ALLOC_FAILED","value":"8415_u32"},{"id":"ERROR_DS_ATT_SCHEMA_REQ_SYNTAX","name":"ERROR_DS_ATT_SCHEMA_REQ_SYNTAX","value":"8416_u32"},{"id":"ERROR_DS_GCVERIFY_ERROR","name":"ERROR_DS_GCVERIFY_ERROR","value":"8417_u32"},{"id":"ERROR_DS_DRA_SCHEMA_MISMATCH","name":"ERROR_DS_DRA_SCHEMA_MISMATCH","value":"8418_u32"},{"id":"ERROR_DS_CANT_FIND_DSA_OBJ","name":"ERROR_DS_CANT_FIND_DSA_OBJ","value":"8419_u32"},{"id":"ERROR_DS_CANT_FIND_EXPECTED_NC","name":"ERROR_DS_CANT_FIND_EXPECTED_NC","value":"8420_u32"},{"id":"ERROR_DS_CANT_FIND_NC_IN_CACHE","name":"ERROR_DS_CANT_FIND_NC_IN_CACHE","value":"8421_u32"},{"id":"ERROR_DS_CANT_RETRIEVE_CHILD","name":"ERROR_DS_CANT_RETRIEVE_CHILD","value":"8422_u32"},{"id":"ERROR_DS_SECURITY_ILLEGAL_MODIFY","name":"ERROR_DS_SECURITY_ILLEGAL_MODIFY","value":"8423_u32"},{"id":"ERROR_DS_CANT_REPLACE_HIDDEN_REC","name":"ERROR_DS_CANT_REPLACE_HIDDEN_REC","value":"8424_u32"},{"id":"ERROR_DS_BAD_HIERARCHY_FILE","name":"ERROR_DS_BAD_HIERARCHY_FILE","value":"8425_u32"},{"id":"ERROR_DS_BUILD_HIERARCHY_TABLE_FAILED","name":"ERROR_DS_BUILD_HIERARCHY_TABLE_FAILED","value":"8426_u32"},{"id":"ERROR_DS_CONFIG_PARAM_MISSING","name":"ERROR_DS_CONFIG_PARAM_MISSING","value":"8427_u32"},{"id":"ERROR_DS_COUNTING_AB_INDICES_FAILED","name":"ERROR_DS_COUNTING_AB_INDICES_FAILED","value":"8428_u32"},{"id":"ERROR_DS_HIERARCHY_TABLE_MALLOC_FAILED","name":"ERROR_DS_HIERARCHY_TABLE_MALLOC_FAILED","value":"8429_u32"},{"id":"ERROR_DS_INTERNAL_FAILURE","name":"ERROR_DS_INTERNAL_FAILURE","value":"8430_u32"},{"id":"ERROR_DS_UNKNOWN_ERROR","name":"ERROR_DS_UNKNOWN_ERROR","value":"8431_u32"},{"id":"ERROR_DS_ROOT_REQUIRES_CLASS_TOP","name":"ERROR_DS_ROOT_REQUIRES_CLASS_TOP","value":"8432_u32"},{"id":"ERROR_DS_REFUSING_FSMO_ROLES","name":"ERROR_DS_REFUSING_FSMO_ROLES","value":"8433_u32"},{"id":"ERROR_DS_MISSING_FSMO_SETTINGS","name":"ERROR_DS_MISSING_FSMO_SETTINGS","value":"8434_u32"},{"id":"ERROR_DS_UNABLE_TO_SURRENDER_ROLES","name":"ERROR_DS_UNABLE_TO_SURRENDER_ROLES","value":"8435_u32"},{"id":"ERROR_DS_DRA_GENERIC","name":"ERROR_DS_DRA_GENERIC","value":"8436_u32"},{"id":"ERROR_DS_DRA_INVALID_PARAMETER","name":"ERROR_DS_DRA_INVALID_PARAMETER","value":"8437_u32"},{"id":"ERROR_DS_DRA_BUSY","name":"ERROR_DS_DRA_BUSY","value":"8438_u32"},{"id":"ERROR_DS_DRA_BAD_DN","name":"ERROR_DS_DRA_BAD_DN","value":"8439_u32"},{"id":"ERROR_DS_DRA_BAD_NC","name":"ERROR_DS_DRA_BAD_NC","value":"8440_u32"},{"id":"ERROR_DS_DRA_DN_EXISTS","name":"ERROR_DS_DRA_DN_EXISTS","value":"8441_u32"},{"id":"ERROR_DS_DRA_INTERNAL_ERROR","name":"ERROR_DS_DRA_INTERNAL_ERROR","value":"8442_u32"},{"id":"ERROR_DS_DRA_INCONSISTENT_DIT","name":"ERROR_DS_DRA_INCONSISTENT_DIT","value":"8443_u32"},{"id":"ERROR_DS_DRA_CONNECTION_FAILED","name":"ERROR_DS_DRA_CONNECTION_FAILED","value":"8444_u32"},{"id":"ERROR_DS_DRA_BAD_INSTANCE_TYPE","name":"ERROR_DS_DRA_BAD_INSTANCE_TYPE","value":"8445_u32"},{"id":"ERROR_DS_DRA_OUT_OF_MEM","name":"ERROR_DS_DRA_OUT_OF_MEM","value":"8446_u32"},{"id":"ERROR_DS_DRA_MAIL_PROBLEM","name":"ERROR_DS_DRA_MAIL_PROBLEM","value":"8447_u32"},{"id":"ERROR_DS_DRA_REF_ALREADY_EXISTS","name":"ERROR_DS_DRA_REF_ALREADY_EXISTS","value":"8448_u32"},{"id":"ERROR_DS_DRA_REF_NOT_FOUND","name":"ERROR_DS_DRA_REF_NOT_FOUND","value":"8449_u32"},{"id":"ERROR_DS_DRA_OBJ_IS_REP_SOURCE","name":"ERROR_DS_DRA_OBJ_IS_REP_SOURCE","value":"8450_u32"},{"id":"ERROR_DS_DRA_DB_ERROR","name":"ERROR_DS_DRA_DB_ERROR","value":"8451_u32"},{"id":"ERROR_DS_DRA_NO_REPLICA","name":"ERROR_DS_DRA_NO_REPLICA","value":"8452_u32"},{"id":"ERROR_DS_DRA_ACCESS_DENIED","name":"ERROR_DS_DRA_ACCESS_DENIED","value":"8453_u32"},{"id":"ERROR_DS_DRA_NOT_SUPPORTED","name":"ERROR_DS_DRA_NOT_SUPPORTED","value":"8454_u32"},{"id":"ERROR_DS_DRA_RPC_CANCELLED","name":"ERROR_DS_DRA_RPC_CANCELLED","value":"8455_u32"},{"id":"ERROR_DS_DRA_SOURCE_DISABLED","name":"ERROR_DS_DRA_SOURCE_DISABLED","value":"8456_u32"},{"id":"ERROR_DS_DRA_SINK_DISABLED","name":"ERROR_DS_DRA_SINK_DISABLED","value":"8457_u32"},{"id":"ERROR_DS_DRA_NAME_COLLISION","name":"ERROR_DS_DRA_NAME_COLLISION","value":"8458_u32"},{"id":"ERROR_DS_DRA_SOURCE_REINSTALLED","name":"ERROR_DS_DRA_SOURCE_REINSTALLED","value":"8459_u32"},{"id":"ERROR_DS_DRA_MISSING_PARENT","name":"ERROR_DS_DRA_MISSING_PARENT","value":"8460_u32"},{"id":"ERROR_DS_DRA_PREEMPTED","name":"ERROR_DS_DRA_PREEMPTED","value":"8461_u32"},{"id":"ERROR_DS_DRA_ABANDON_SYNC","name":"ERROR_DS_DRA_ABANDON_SYNC","value":"8462_u32"},{"id":"ERROR_DS_DRA_SHUTDOWN","name":"ERROR_DS_DRA_SHUTDOWN","value":"8463_u32"},{"id":"ERROR_DS_DRA_INCOMPATIBLE_PARTIAL_SET","name":"ERROR_DS_DRA_INCOMPATIBLE_PARTIAL_SET","value":"8464_u32"},{"id":"ERROR_DS_DRA_SOURCE_IS_PARTIAL_REPLICA","name":"ERROR_DS_DRA_SOURCE_IS_PARTIAL_REPLICA","value":"8465_u32"},{"id":"ERROR_DS_DRA_EXTN_CONNECTION_FAILED","name":"ERROR_DS_DRA_EXTN_CONNECTION_FAILED","value":"8466_u32"},{"id":"ERROR_DS_INSTALL_SCHEMA_MISMATCH","name":"ERROR_DS_INSTALL_SCHEMA_MISMATCH","value":"8467_u32"},{"id":"ERROR_DS_DUP_LINK_ID","name":"ERROR_DS_DUP_LINK_ID","value":"8468_u32"},{"id":"ERROR_DS_NAME_ERROR_RESOLVING","name":"ERROR_DS_NAME_ERROR_RESOLVING","value":"8469_u32"},{"id":"ERROR_DS_NAME_ERROR_NOT_FOUND","name":"ERROR_DS_NAME_ERROR_NOT_FOUND","value":"8470_u32"},{"id":"ERROR_DS_NAME_ERROR_NOT_UNIQUE","name":"ERROR_DS_NAME_ERROR_NOT_UNIQUE","value":"8471_u32"},{"id":"ERROR_DS_NAME_ERROR_NO_MAPPING","name":"ERROR_DS_NAME_ERROR_NO_MAPPING","value":"8472_u32"},{"id":"ERROR_DS_NAME_ERROR_DOMAIN_ONLY","name":"ERROR_DS_NAME_ERROR_DOMAIN_ONLY","value":"8473_u32"},{"id":"ERROR_DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING","name":"ERROR_DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING","value":"8474_u32"},{"id":"ERROR_DS_CONSTRUCTED_ATT_MOD","name":"ERROR_DS_CONSTRUCTED_ATT_MOD","value":"8475_u32"},{"id":"ERROR_DS_WRONG_OM_OBJ_CLASS","name":"ERROR_DS_WRONG_OM_OBJ_CLASS","value":"8476_u32"},{"id":"ERROR_DS_DRA_REPL_PENDING","name":"ERROR_DS_DRA_REPL_PENDING","value":"8477_u32"},{"id":"ERROR_DS_DS_REQUIRED","name":"ERROR_DS_DS_REQUIRED","value":"8478_u32"},{"id":"ERROR_DS_INVALID_LDAP_DISPLAY_NAME","name":"ERROR_DS_INVALID_LDAP_DISPLAY_NAME","value":"8479_u32"},{"id":"ERROR_DS_NON_BASE_SEARCH","name":"ERROR_DS_NON_BASE_SEARCH","value":"8480_u32"},{"id":"ERROR_DS_CANT_RETRIEVE_ATTS","name":"ERROR_DS_CANT_RETRIEVE_ATTS","value":"8481_u32"},{"id":"ERROR_DS_BACKLINK_WITHOUT_LINK","name":"ERROR_DS_BACKLINK_WITHOUT_LINK","value":"8482_u32"},{"id":"ERROR_DS_EPOCH_MISMATCH","name":"ERROR_DS_EPOCH_MISMATCH","value":"8483_u32"},{"id":"ERROR_DS_SRC_NAME_MISMATCH","name":"ERROR_DS_SRC_NAME_MISMATCH","value":"8484_u32"},{"id":"ERROR_DS_SRC_AND_DST_NC_IDENTICAL","name":"ERROR_DS_SRC_AND_DST_NC_IDENTICAL","value":"8485_u32"},{"id":"ERROR_DS_DST_NC_MISMATCH","name":"ERROR_DS_DST_NC_MISMATCH","value":"8486_u32"},{"id":"ERROR_DS_NOT_AUTHORITIVE_FOR_DST_NC","name":"ERROR_DS_NOT_AUTHORITIVE_FOR_DST_NC","value":"8487_u32"},{"id":"ERROR_DS_SRC_GUID_MISMATCH","name":"ERROR_DS_SRC_GUID_MISMATCH","value":"8488_u32"},{"id":"ERROR_DS_CANT_MOVE_DELETED_OBJECT","name":"ERROR_DS_CANT_MOVE_DELETED_OBJECT","value":"8489_u32"},{"id":"ERROR_DS_PDC_OPERATION_IN_PROGRESS","name":"ERROR_DS_PDC_OPERATION_IN_PROGRESS","value":"8490_u32"},{"id":"ERROR_DS_CROSS_DOMAIN_CLEANUP_REQD","name":"ERROR_DS_CROSS_DOMAIN_CLEANUP_REQD","value":"8491_u32"},{"id":"ERROR_DS_ILLEGAL_XDOM_MOVE_OPERATION","name":"ERROR_DS_ILLEGAL_XDOM_MOVE_OPERATION","value":"8492_u32"},{"id":"ERROR_DS_CANT_WITH_ACCT_GROUP_MEMBERSHPS","name":"ERROR_DS_CANT_WITH_ACCT_GROUP_MEMBERSHPS","value":"8493_u32"},{"id":"ERROR_DS_NC_MUST_HAVE_NC_PARENT","name":"ERROR_DS_NC_MUST_HAVE_NC_PARENT","value":"8494_u32"},{"id":"ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE","name":"ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE","value":"8495_u32"},{"id":"ERROR_DS_DST_DOMAIN_NOT_NATIVE","name":"ERROR_DS_DST_DOMAIN_NOT_NATIVE","value":"8496_u32"},{"id":"ERROR_DS_MISSING_INFRASTRUCTURE_CONTAINER","name":"ERROR_DS_MISSING_INFRASTRUCTURE_CONTAINER","value":"8497_u32"},{"id":"ERROR_DS_CANT_MOVE_ACCOUNT_GROUP","name":"ERROR_DS_CANT_MOVE_ACCOUNT_GROUP","value":"8498_u32"},{"id":"ERROR_DS_CANT_MOVE_RESOURCE_GROUP","name":"ERROR_DS_CANT_MOVE_RESOURCE_GROUP","value":"8499_u32"},{"id":"ERROR_DS_INVALID_SEARCH_FLAG","name":"ERROR_DS_INVALID_SEARCH_FLAG","value":"8500_u32"},{"id":"ERROR_DS_NO_TREE_DELETE_ABOVE_NC","name":"ERROR_DS_NO_TREE_DELETE_ABOVE_NC","value":"8501_u32"},{"id":"ERROR_DS_COULDNT_LOCK_TREE_FOR_DELETE","name":"ERROR_DS_COULDNT_LOCK_TREE_FOR_DELETE","value":"8502_u32"},{"id":"ERROR_DS_COULDNT_IDENTIFY_OBJECTS_FOR_TREE_DELETE","name":"ERROR_DS_COULDNT_IDENTIFY_OBJECTS_FOR_TREE_DELETE","value":"8503_u32"},{"id":"ERROR_DS_SAM_INIT_FAILURE","name":"ERROR_DS_SAM_INIT_FAILURE","value":"8504_u32"},{"id":"ERROR_DS_SENSITIVE_GROUP_VIOLATION","name":"ERROR_DS_SENSITIVE_GROUP_VIOLATION","value":"8505_u32"},{"id":"ERROR_DS_CANT_MOD_PRIMARYGROUPID","name":"ERROR_DS_CANT_MOD_PRIMARYGROUPID","value":"8506_u32"},{"id":"ERROR_DS_ILLEGAL_BASE_SCHEMA_MOD","name":"ERROR_DS_ILLEGAL_BASE_SCHEMA_MOD","value":"8507_u32"},{"id":"ERROR_DS_NONSAFE_SCHEMA_CHANGE","name":"ERROR_DS_NONSAFE_SCHEMA_CHANGE","value":"8508_u32"},{"id":"ERROR_DS_SCHEMA_UPDATE_DISALLOWED","name":"ERROR_DS_SCHEMA_UPDATE_DISALLOWED","value":"8509_u32"},{"id":"ERROR_DS_CANT_CREATE_UNDER_SCHEMA","name":"ERROR_DS_CANT_CREATE_UNDER_SCHEMA","value":"8510_u32"},{"id":"ERROR_DS_INSTALL_NO_SRC_SCH_VERSION","name":"ERROR_DS_INSTALL_NO_SRC_SCH_VERSION","value":"8511_u32"},{"id":"ERROR_DS_INSTALL_NO_SCH_VERSION_IN_INIFILE","name":"ERROR_DS_INSTALL_NO_SCH_VERSION_IN_INIFILE","value":"8512_u32"},{"id":"ERROR_DS_INVALID_GROUP_TYPE","name":"ERROR_DS_INVALID_GROUP_TYPE","value":"8513_u32"},{"id":"ERROR_DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN","name":"ERROR_DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN","value":"8514_u32"},{"id":"ERROR_DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN","name":"ERROR_DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN","value":"8515_u32"},{"id":"ERROR_DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER","name":"ERROR_DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER","value":"8516_u32"},{"id":"ERROR_DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER","name":"ERROR_DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER","value":"8517_u32"},{"id":"ERROR_DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER","name":"ERROR_DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER","value":"8518_u32"},{"id":"ERROR_DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER","name":"ERROR_DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER","value":"8519_u32"},{"id":"ERROR_DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER","name":"ERROR_DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER","value":"8520_u32"},{"id":"ERROR_DS_HAVE_PRIMARY_MEMBERS","name":"ERROR_DS_HAVE_PRIMARY_MEMBERS","value":"8521_u32"},{"id":"ERROR_DS_STRING_SD_CONVERSION_FAILED","name":"ERROR_DS_STRING_SD_CONVERSION_FAILED","value":"8522_u32"},{"id":"ERROR_DS_NAMING_MASTER_GC","name":"ERROR_DS_NAMING_MASTER_GC","value":"8523_u32"},{"id":"ERROR_DS_DNS_LOOKUP_FAILURE","name":"ERROR_DS_DNS_LOOKUP_FAILURE","value":"8524_u32"},{"id":"ERROR_DS_COULDNT_UPDATE_SPNS","name":"ERROR_DS_COULDNT_UPDATE_SPNS","value":"8525_u32"},{"id":"ERROR_DS_CANT_RETRIEVE_SD","name":"ERROR_DS_CANT_RETRIEVE_SD","value":"8526_u32"},{"id":"ERROR_DS_KEY_NOT_UNIQUE","name":"ERROR_DS_KEY_NOT_UNIQUE","value":"8527_u32"},{"id":"ERROR_DS_WRONG_LINKED_ATT_SYNTAX","name":"ERROR_DS_WRONG_LINKED_ATT_SYNTAX","value":"8528_u32"},{"id":"ERROR_DS_SAM_NEED_BOOTKEY_PASSWORD","name":"ERROR_DS_SAM_NEED_BOOTKEY_PASSWORD","value":"8529_u32"},{"id":"ERROR_DS_SAM_NEED_BOOTKEY_FLOPPY","name":"ERROR_DS_SAM_NEED_BOOTKEY_FLOPPY","value":"8530_u32"},{"id":"ERROR_DS_CANT_START","name":"ERROR_DS_CANT_START","value":"8531_u32"},{"id":"ERROR_DS_INIT_FAILURE","name":"ERROR_DS_INIT_FAILURE","value":"8532_u32"},{"id":"ERROR_DS_NO_PKT_PRIVACY_ON_CONNECTION","name":"ERROR_DS_NO_PKT_PRIVACY_ON_CONNECTION","value":"8533_u32"},{"id":"ERROR_DS_SOURCE_DOMAIN_IN_FOREST","name":"ERROR_DS_SOURCE_DOMAIN_IN_FOREST","value":"8534_u32"},{"id":"ERROR_DS_DESTINATION_DOMAIN_NOT_IN_FOREST","name":"ERROR_DS_DESTINATION_DOMAIN_NOT_IN_FOREST","value":"8535_u32"},{"id":"ERROR_DS_DESTINATION_AUDITING_NOT_ENABLED","name":"ERROR_DS_DESTINATION_AUDITING_NOT_ENABLED","value":"8536_u32"},{"id":"ERROR_DS_CANT_FIND_DC_FOR_SRC_DOMAIN","name":"ERROR_DS_CANT_FIND_DC_FOR_SRC_DOMAIN","value":"8537_u32"},{"id":"ERROR_DS_SRC_OBJ_NOT_GROUP_OR_USER","name":"ERROR_DS_SRC_OBJ_NOT_GROUP_OR_USER","value":"8538_u32"},{"id":"ERROR_DS_SRC_SID_EXISTS_IN_FOREST","name":"ERROR_DS_SRC_SID_EXISTS_IN_FOREST","value":"8539_u32"},{"id":"ERROR_DS_SRC_AND_DST_OBJECT_CLASS_MISMATCH","name":"ERROR_DS_SRC_AND_DST_OBJECT_CLASS_MISMATCH","value":"8540_u32"},{"id":"ERROR_SAM_INIT_FAILURE","name":"ERROR_SAM_INIT_FAILURE","value":"8541_u32"},{"id":"ERROR_DS_DRA_SCHEMA_INFO_SHIP","name":"ERROR_DS_DRA_SCHEMA_INFO_SHIP","value":"8542_u32"},{"id":"ERROR_DS_DRA_SCHEMA_CONFLICT","name":"ERROR_DS_DRA_SCHEMA_CONFLICT","value":"8543_u32"},{"id":"ERROR_DS_DRA_EARLIER_SCHEMA_CONFLICT","name":"ERROR_DS_DRA_EARLIER_SCHEMA_CONFLICT","value":"8544_u32"},{"id":"ERROR_DS_DRA_OBJ_NC_MISMATCH","name":"ERROR_DS_DRA_OBJ_NC_MISMATCH","value":"8545_u32"},{"id":"ERROR_DS_NC_STILL_HAS_DSAS","name":"ERROR_DS_NC_STILL_HAS_DSAS","value":"8546_u32"},{"id":"ERROR_DS_GC_REQUIRED","name":"ERROR_DS_GC_REQUIRED","value":"8547_u32"},{"id":"ERROR_DS_LOCAL_MEMBER_OF_LOCAL_ONLY","name":"ERROR_DS_LOCAL_MEMBER_OF_LOCAL_ONLY","value":"8548_u32"},{"id":"ERROR_DS_NO_FPO_IN_UNIVERSAL_GROUPS","name":"ERROR_DS_NO_FPO_IN_UNIVERSAL_GROUPS","value":"8549_u32"},{"id":"ERROR_DS_CANT_ADD_TO_GC","name":"ERROR_DS_CANT_ADD_TO_GC","value":"8550_u32"},{"id":"ERROR_DS_NO_CHECKPOINT_WITH_PDC","name":"ERROR_DS_NO_CHECKPOINT_WITH_PDC","value":"8551_u32"},{"id":"ERROR_DS_SOURCE_AUDITING_NOT_ENABLED","name":"ERROR_DS_SOURCE_AUDITING_NOT_ENABLED","value":"8552_u32"},{"id":"ERROR_DS_CANT_CREATE_IN_NONDOMAIN_NC","name":"ERROR_DS_CANT_CREATE_IN_NONDOMAIN_NC","value":"8553_u32"},{"id":"ERROR_DS_INVALID_NAME_FOR_SPN","name":"ERROR_DS_INVALID_NAME_FOR_SPN","value":"8554_u32"},{"id":"ERROR_DS_FILTER_USES_CONTRUCTED_ATTRS","name":"ERROR_DS_FILTER_USES_CONTRUCTED_ATTRS","value":"8555_u32"},{"id":"ERROR_DS_UNICODEPWD_NOT_IN_QUOTES","name":"ERROR_DS_UNICODEPWD_NOT_IN_QUOTES","value":"8556_u32"},{"id":"ERROR_DS_MACHINE_ACCOUNT_QUOTA_EXCEEDED","name":"ERROR_DS_MACHINE_ACCOUNT_QUOTA_EXCEEDED","value":"8557_u32"},{"id":"ERROR_DS_MUST_BE_RUN_ON_DST_DC","name":"ERROR_DS_MUST_BE_RUN_ON_DST_DC","value":"8558_u32"},{"id":"ERROR_DS_SRC_DC_MUST_BE_SP4_OR_GREATER","name":"ERROR_DS_SRC_DC_MUST_BE_SP4_OR_GREATER","value":"8559_u32"},{"id":"ERROR_DS_CANT_TREE_DELETE_CRITICAL_OBJ","name":"ERROR_DS_CANT_TREE_DELETE_CRITICAL_OBJ","value":"8560_u32"},{"id":"ERROR_DS_INIT_FAILURE_CONSOLE","name":"ERROR_DS_INIT_FAILURE_CONSOLE","value":"8561_u32"},{"id":"ERROR_DS_SAM_INIT_FAILURE_CONSOLE","name":"ERROR_DS_SAM_INIT_FAILURE_CONSOLE","value":"8562_u32"},{"id":"ERROR_DS_FOREST_VERSION_TOO_HIGH","name":"ERROR_DS_FOREST_VERSION_TOO_HIGH","value":"8563_u32"},{"id":"ERROR_DS_DOMAIN_VERSION_TOO_HIGH","name":"ERROR_DS_DOMAIN_VERSION_TOO_HIGH","value":"8564_u32"},{"id":"ERROR_DS_FOREST_VERSION_TOO_LOW","name":"ERROR_DS_FOREST_VERSION_TOO_LOW","value":"8565_u32"},{"id":"ERROR_DS_DOMAIN_VERSION_TOO_LOW","name":"ERROR_DS_DOMAIN_VERSION_TOO_LOW","value":"8566_u32"},{"id":"ERROR_DS_INCOMPATIBLE_VERSION","name":"ERROR_DS_INCOMPATIBLE_VERSION","value":"8567_u32"},{"id":"ERROR_DS_LOW_DSA_VERSION","name":"ERROR_DS_LOW_DSA_VERSION","value":"8568_u32"},{"id":"ERROR_DS_NO_BEHAVIOR_VERSION_IN_MIXEDDOMAIN","name":"ERROR_DS_NO_BEHAVIOR_VERSION_IN_MIXEDDOMAIN","value":"8569_u32"},{"id":"ERROR_DS_NOT_SUPPORTED_SORT_ORDER","name":"ERROR_DS_NOT_SUPPORTED_SORT_ORDER","value":"8570_u32"},{"id":"ERROR_DS_NAME_NOT_UNIQUE","name":"ERROR_DS_NAME_NOT_UNIQUE","value":"8571_u32"},{"id":"ERROR_DS_MACHINE_ACCOUNT_CREATED_PRENT4","name":"ERROR_DS_MACHINE_ACCOUNT_CREATED_PRENT4","value":"8572_u32"},{"id":"ERROR_DS_OUT_OF_VERSION_STORE","name":"ERROR_DS_OUT_OF_VERSION_STORE","value":"8573_u32"},{"id":"ERROR_DS_INCOMPATIBLE_CONTROLS_USED","name":"ERROR_DS_INCOMPATIBLE_CONTROLS_USED","value":"8574_u32"},{"id":"ERROR_DS_NO_REF_DOMAIN","name":"ERROR_DS_NO_REF_DOMAIN","value":"8575_u32"},{"id":"ERROR_DS_RESERVED_LINK_ID","name":"ERROR_DS_RESERVED_LINK_ID","value":"8576_u32"},{"id":"ERROR_DS_LINK_ID_NOT_AVAILABLE","name":"ERROR_DS_LINK_ID_NOT_AVAILABLE","value":"8577_u32"},{"id":"ERROR_DS_AG_CANT_HAVE_UNIVERSAL_MEMBER","name":"ERROR_DS_AG_CANT_HAVE_UNIVERSAL_MEMBER","value":"8578_u32"},{"id":"ERROR_DS_MODIFYDN_DISALLOWED_BY_INSTANCE_TYPE","name":"ERROR_DS_MODIFYDN_DISALLOWED_BY_INSTANCE_TYPE","value":"8579_u32"},{"id":"ERROR_DS_NO_OBJECT_MOVE_IN_SCHEMA_NC","name":"ERROR_DS_NO_OBJECT_MOVE_IN_SCHEMA_NC","value":"8580_u32"},{"id":"ERROR_DS_MODIFYDN_DISALLOWED_BY_FLAG","name":"ERROR_DS_MODIFYDN_DISALLOWED_BY_FLAG","value":"8581_u32"},{"id":"ERROR_DS_MODIFYDN_WRONG_GRANDPARENT","name":"ERROR_DS_MODIFYDN_WRONG_GRANDPARENT","value":"8582_u32"},{"id":"ERROR_DS_NAME_ERROR_TRUST_REFERRAL","name":"ERROR_DS_NAME_ERROR_TRUST_REFERRAL","value":"8583_u32"},{"id":"ERROR_NOT_SUPPORTED_ON_STANDARD_SERVER","name":"ERROR_NOT_SUPPORTED_ON_STANDARD_SERVER","value":"8584_u32"},{"id":"ERROR_DS_CANT_ACCESS_REMOTE_PART_OF_AD","name":"ERROR_DS_CANT_ACCESS_REMOTE_PART_OF_AD","value":"8585_u32"},{"id":"ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE_V2","name":"ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE_V2","value":"8586_u32"},{"id":"ERROR_DS_THREAD_LIMIT_EXCEEDED","name":"ERROR_DS_THREAD_LIMIT_EXCEEDED","value":"8587_u32"},{"id":"ERROR_DS_NOT_CLOSEST","name":"ERROR_DS_NOT_CLOSEST","value":"8588_u32"},{"id":"ERROR_DS_CANT_DERIVE_SPN_WITHOUT_SERVER_REF","name":"ERROR_DS_CANT_DERIVE_SPN_WITHOUT_SERVER_REF","value":"8589_u32"},{"id":"ERROR_DS_SINGLE_USER_MODE_FAILED","name":"ERROR_DS_SINGLE_USER_MODE_FAILED","value":"8590_u32"},{"id":"ERROR_DS_NTDSCRIPT_SYNTAX_ERROR","name":"ERROR_DS_NTDSCRIPT_SYNTAX_ERROR","value":"8591_u32"},{"id":"ERROR_DS_NTDSCRIPT_PROCESS_ERROR","name":"ERROR_DS_NTDSCRIPT_PROCESS_ERROR","value":"8592_u32"},{"id":"ERROR_DS_DIFFERENT_REPL_EPOCHS","name":"ERROR_DS_DIFFERENT_REPL_EPOCHS","value":"8593_u32"},{"id":"ERROR_DS_DRS_EXTENSIONS_CHANGED","name":"ERROR_DS_DRS_EXTENSIONS_CHANGED","value":"8594_u32"},{"id":"ERROR_DS_REPLICA_SET_CHANGE_NOT_ALLOWED_ON_DISABLED_CR","name":"ERROR_DS_REPLICA_SET_CHANGE_NOT_ALLOWED_ON_DISABLED_CR","value":"8595_u32"},{"id":"ERROR_DS_NO_MSDS_INTID","name":"ERROR_DS_NO_MSDS_INTID","value":"8596_u32"},{"id":"ERROR_DS_DUP_MSDS_INTID","name":"ERROR_DS_DUP_MSDS_INTID","value":"8597_u32"},{"id":"ERROR_DS_EXISTS_IN_RDNATTID","name":"ERROR_DS_EXISTS_IN_RDNATTID","value":"8598_u32"},{"id":"ERROR_DS_AUTHORIZATION_FAILED","name":"ERROR_DS_AUTHORIZATION_FAILED","value":"8599_u32"},{"id":"ERROR_DS_INVALID_SCRIPT","name":"ERROR_DS_INVALID_SCRIPT","value":"8600_u32"},{"id":"ERROR_DS_REMOTE_CROSSREF_OP_FAILED","name":"ERROR_DS_REMOTE_CROSSREF_OP_FAILED","value":"8601_u32"},{"id":"ERROR_DS_CROSS_REF_BUSY","name":"ERROR_DS_CROSS_REF_BUSY","value":"8602_u32"},{"id":"ERROR_DS_CANT_DERIVE_SPN_FOR_DELETED_DOMAIN","name":"ERROR_DS_CANT_DERIVE_SPN_FOR_DELETED_DOMAIN","value":"8603_u32"},{"id":"ERROR_DS_CANT_DEMOTE_WITH_WRITEABLE_NC","name":"ERROR_DS_CANT_DEMOTE_WITH_WRITEABLE_NC","value":"8604_u32"},{"id":"ERROR_DS_DUPLICATE_ID_FOUND","name":"ERROR_DS_DUPLICATE_ID_FOUND","value":"8605_u32"},{"id":"ERROR_DS_INSUFFICIENT_ATTR_TO_CREATE_OBJECT","name":"ERROR_DS_INSUFFICIENT_ATTR_TO_CREATE_OBJECT","value":"8606_u32"},{"id":"ERROR_DS_GROUP_CONVERSION_ERROR","name":"ERROR_DS_GROUP_CONVERSION_ERROR","value":"8607_u32"},{"id":"ERROR_DS_CANT_MOVE_APP_BASIC_GROUP","name":"ERROR_DS_CANT_MOVE_APP_BASIC_GROUP","value":"8608_u32"},{"id":"ERROR_DS_CANT_MOVE_APP_QUERY_GROUP","name":"ERROR_DS_CANT_MOVE_APP_QUERY_GROUP","value":"8609_u32"},{"id":"ERROR_DS_ROLE_NOT_VERIFIED","name":"ERROR_DS_ROLE_NOT_VERIFIED","value":"8610_u32"},{"id":"ERROR_DS_WKO_CONTAINER_CANNOT_BE_SPECIAL","name":"ERROR_DS_WKO_CONTAINER_CANNOT_BE_SPECIAL","value":"8611_u32"},{"id":"ERROR_DS_DOMAIN_RENAME_IN_PROGRESS","name":"ERROR_DS_DOMAIN_RENAME_IN_PROGRESS","value":"8612_u32"},{"id":"ERROR_DS_EXISTING_AD_CHILD_NC","name":"ERROR_DS_EXISTING_AD_CHILD_NC","value":"8613_u32"},{"id":"ERROR_DS_REPL_LIFETIME_EXCEEDED","name":"ERROR_DS_REPL_LIFETIME_EXCEEDED","value":"8614_u32"},{"id":"ERROR_DS_DISALLOWED_IN_SYSTEM_CONTAINER","name":"ERROR_DS_DISALLOWED_IN_SYSTEM_CONTAINER","value":"8615_u32"},{"id":"ERROR_DS_LDAP_SEND_QUEUE_FULL","name":"ERROR_DS_LDAP_SEND_QUEUE_FULL","value":"8616_u32"},{"id":"ERROR_DS_DRA_OUT_SCHEDULE_WINDOW","name":"ERROR_DS_DRA_OUT_SCHEDULE_WINDOW","value":"8617_u32"},{"id":"DNS_ERROR_RESPONSE_CODES_BASE","name":"DNS_ERROR_RESPONSE_CODES_BASE","value":"9000_u32"},{"id":"DNS_ERROR_MASK","name":"DNS_ERROR_MASK","value":"9000_u32"},{"id":"DNS_ERROR_RCODE_FORMAT_ERROR","name":"DNS_ERROR_RCODE_FORMAT_ERROR","value":"9001_u32"},{"id":"DNS_ERROR_RCODE_SERVER_FAILURE","name":"DNS_ERROR_RCODE_SERVER_FAILURE","value":"9002_u32"},{"id":"DNS_ERROR_RCODE_NAME_ERROR","name":"DNS_ERROR_RCODE_NAME_ERROR","value":"9003_u32"},{"id":"DNS_ERROR_RCODE_NOT_IMPLEMENTED","name":"DNS_ERROR_RCODE_NOT_IMPLEMENTED","value":"9004_u32"},{"id":"DNS_ERROR_RCODE_REFUSED","name":"DNS_ERROR_RCODE_REFUSED","value":"9005_u32"},{"id":"DNS_ERROR_RCODE_YXDOMAIN","name":"DNS_ERROR_RCODE_YXDOMAIN","value":"9006_u32"},{"id":"DNS_ERROR_RCODE_YXRRSET","name":"DNS_ERROR_RCODE_YXRRSET","value":"9007_u32"},{"id":"DNS_ERROR_RCODE_NXRRSET","name":"DNS_ERROR_RCODE_NXRRSET","value":"9008_u32"},{"id":"DNS_ERROR_RCODE_NOTAUTH","name":"DNS_ERROR_RCODE_NOTAUTH","value":"9009_u32"},{"id":"DNS_ERROR_RCODE_NOTZONE","name":"DNS_ERROR_RCODE_NOTZONE","value":"9010_u32"},{"id":"DNS_ERROR_RCODE_BADSIG","name":"DNS_ERROR_RCODE_BADSIG","value":"9016_u32"},{"id":"DNS_ERROR_RCODE_BADKEY","name":"DNS_ERROR_RCODE_BADKEY","value":"9017_u32"},{"id":"DNS_ERROR_RCODE_BADTIME","name":"DNS_ERROR_RCODE_BADTIME","value":"9018_u32"},{"id":"DNS_ERROR_RCODE_LAST","name":"DNS_ERROR_RCODE_LAST","value":"9018_u32"},{"id":"DNS_ERROR_PACKET_FMT_BASE","name":"DNS_ERROR_PACKET_FMT_BASE","value":"9500_u32"},{"id":"DNS_INFO_NO_RECORDS","name":"DNS_INFO_NO_RECORDS","value":"9501_u32"},{"id":"DNS_ERROR_BAD_PACKET","name":"DNS_ERROR_BAD_PACKET","value":"9502_u32"},{"id":"DNS_ERROR_NO_PACKET","name":"DNS_ERROR_NO_PACKET","value":"9503_u32"},{"id":"DNS_ERROR_RCODE","name":"DNS_ERROR_RCODE","value":"9504_u32"},{"id":"DNS_ERROR_UNSECURE_PACKET","name":"DNS_ERROR_UNSECURE_PACKET","value":"9505_u32"},{"id":"DNS_STATUS_PACKET_UNSECURE","name":"DNS_STATUS_PACKET_UNSECURE","value":"9505_u32"},{"id":"DNS_ERROR_NO_MEMORY","name":"DNS_ERROR_NO_MEMORY","value":"14_u32"},{"id":"DNS_ERROR_INVALID_NAME","name":"DNS_ERROR_INVALID_NAME","value":"123_u32"},{"id":"DNS_ERROR_INVALID_DATA","name":"DNS_ERROR_INVALID_DATA","value":"13_u32"},{"id":"DNS_ERROR_GENERAL_API_BASE","name":"DNS_ERROR_GENERAL_API_BASE","value":"9550_u32"},{"id":"DNS_ERROR_INVALID_TYPE","name":"DNS_ERROR_INVALID_TYPE","value":"9551_u32"},{"id":"DNS_ERROR_INVALID_IP_ADDRESS","name":"DNS_ERROR_INVALID_IP_ADDRESS","value":"9552_u32"},{"id":"DNS_ERROR_INVALID_PROPERTY","name":"DNS_ERROR_INVALID_PROPERTY","value":"9553_u32"},{"id":"DNS_ERROR_TRY_AGAIN_LATER","name":"DNS_ERROR_TRY_AGAIN_LATER","value":"9554_u32"},{"id":"DNS_ERROR_NOT_UNIQUE","name":"DNS_ERROR_NOT_UNIQUE","value":"9555_u32"},{"id":"DNS_ERROR_NON_RFC_NAME","name":"DNS_ERROR_NON_RFC_NAME","value":"9556_u32"},{"id":"DNS_STATUS_FQDN","name":"DNS_STATUS_FQDN","value":"9557_u32"},{"id":"DNS_STATUS_DOTTED_NAME","name":"DNS_STATUS_DOTTED_NAME","value":"9558_u32"},{"id":"DNS_STATUS_SINGLE_PART_NAME","name":"DNS_STATUS_SINGLE_PART_NAME","value":"9559_u32"},{"id":"DNS_ERROR_INVALID_NAME_CHAR","name":"DNS_ERROR_INVALID_NAME_CHAR","value":"9560_u32"},{"id":"DNS_ERROR_NUMERIC_NAME","name":"DNS_ERROR_NUMERIC_NAME","value":"9561_u32"},{"id":"DNS_ERROR_NOT_ALLOWED_ON_ROOT_SERVER","name":"DNS_ERROR_NOT_ALLOWED_ON_ROOT_SERVER","value":"9562_u32"},{"id":"DNS_ERROR_NOT_ALLOWED_UNDER_DELEGATION","name":"DNS_ERROR_NOT_ALLOWED_UNDER_DELEGATION","value":"9563_u32"},{"id":"DNS_ERROR_CANNOT_FIND_ROOT_HINTS","name":"DNS_ERROR_CANNOT_FIND_ROOT_HINTS","value":"9564_u32"},{"id":"DNS_ERROR_INCONSISTENT_ROOT_HINTS","name":"DNS_ERROR_INCONSISTENT_ROOT_HINTS","value":"9565_u32"},{"id":"DNS_ERROR_ZONE_BASE","name":"DNS_ERROR_ZONE_BASE","value":"9600_u32"},{"id":"DNS_ERROR_ZONE_DOES_NOT_EXIST","name":"DNS_ERROR_ZONE_DOES_NOT_EXIST","value":"9601_u32"},{"id":"DNS_ERROR_NO_ZONE_INFO","name":"DNS_ERROR_NO_ZONE_INFO","value":"9602_u32"},{"id":"DNS_ERROR_INVALID_ZONE_OPERATION","name":"DNS_ERROR_INVALID_ZONE_OPERATION","value":"9603_u32"},{"id":"DNS_ERROR_ZONE_CONFIGURATION_ERROR","name":"DNS_ERROR_ZONE_CONFIGURATION_ERROR","value":"9604_u32"},{"id":"DNS_ERROR_ZONE_HAS_NO_SOA_RECORD","name":"DNS_ERROR_ZONE_HAS_NO_SOA_RECORD","value":"9605_u32"},{"id":"DNS_ERROR_ZONE_HAS_NO_NS_RECORDS","name":"DNS_ERROR_ZONE_HAS_NO_NS_RECORDS","value":"9606_u32"},{"id":"DNS_ERROR_ZONE_LOCKED","name":"DNS_ERROR_ZONE_LOCKED","value":"9607_u32"},{"id":"DNS_ERROR_ZONE_CREATION_FAILED","name":"DNS_ERROR_ZONE_CREATION_FAILED","value":"9608_u32"},{"id":"DNS_ERROR_ZONE_ALREADY_EXISTS","name":"DNS_ERROR_ZONE_ALREADY_EXISTS","value":"9609_u32"},{"id":"DNS_ERROR_AUTOZONE_ALREADY_EXISTS","name":"DNS_ERROR_AUTOZONE_ALREADY_EXISTS","value":"9610_u32"},{"id":"DNS_ERROR_INVALID_ZONE_TYPE","name":"DNS_ERROR_INVALID_ZONE_TYPE","value":"9611_u32"},{"id":"DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP","name":"DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP","value":"9612_u32"},{"id":"DNS_ERROR_ZONE_NOT_SECONDARY","name":"DNS_ERROR_ZONE_NOT_SECONDARY","value":"9613_u32"},{"id":"DNS_ERROR_NEED_SECONDARY_ADDRESSES","name":"DNS_ERROR_NEED_SECONDARY_ADDRESSES","value":"9614_u32"},{"id":"DNS_ERROR_WINS_INIT_FAILED","name":"DNS_ERROR_WINS_INIT_FAILED","value":"9615_u32"},{"id":"DNS_ERROR_NEED_WINS_SERVERS","name":"DNS_ERROR_NEED_WINS_SERVERS","value":"9616_u32"},{"id":"DNS_ERROR_NBSTAT_INIT_FAILED","name":"DNS_ERROR_NBSTAT_INIT_FAILED","value":"9617_u32"},{"id":"DNS_ERROR_SOA_DELETE_INVALID","name":"DNS_ERROR_SOA_DELETE_INVALID","value":"9618_u32"},{"id":"DNS_ERROR_FORWARDER_ALREADY_EXISTS","name":"DNS_ERROR_FORWARDER_ALREADY_EXISTS","value":"9619_u32"},{"id":"DNS_ERROR_ZONE_REQUIRES_MASTER_IP","name":"DNS_ERROR_ZONE_REQUIRES_MASTER_IP","value":"9620_u32"},{"id":"DNS_ERROR_ZONE_IS_SHUTDOWN","name":"DNS_ERROR_ZONE_IS_SHUTDOWN","value":"9621_u32"},{"id":"DNS_ERROR_DATAFILE_BASE","name":"DNS_ERROR_DATAFILE_BASE","value":"9650_u32"},{"id":"DNS_ERROR_PRIMARY_REQUIRES_DATAFILE","name":"DNS_ERROR_PRIMARY_REQUIRES_DATAFILE","value":"9651_u32"},{"id":"DNS_ERROR_INVALID_DATAFILE_NAME","name":"DNS_ERROR_INVALID_DATAFILE_NAME","value":"9652_u32"},{"id":"DNS_ERROR_DATAFILE_OPEN_FAILURE","name":"DNS_ERROR_DATAFILE_OPEN_FAILURE","value":"9653_u32"},{"id":"DNS_ERROR_FILE_WRITEBACK_FAILED","name":"DNS_ERROR_FILE_WRITEBACK_FAILED","value":"9654_u32"},{"id":"DNS_ERROR_DATAFILE_PARSING","name":"DNS_ERROR_DATAFILE_PARSING","value":"9655_u32"},{"id":"DNS_ERROR_DATABASE_BASE","name":"DNS_ERROR_DATABASE_BASE","value":"9700_u32"},{"id":"DNS_ERROR_RECORD_DOES_NOT_EXIST","name":"DNS_ERROR_RECORD_DOES_NOT_EXIST","value":"9701_u32"},{"id":"DNS_ERROR_RECORD_FORMAT","name":"DNS_ERROR_RECORD_FORMAT","value":"9702_u32"},{"id":"DNS_ERROR_NODE_CREATION_FAILED","name":"DNS_ERROR_NODE_CREATION_FAILED","value":"9703_u32"},{"id":"DNS_ERROR_UNKNOWN_RECORD_TYPE","name":"DNS_ERROR_UNKNOWN_RECORD_TYPE","value":"9704_u32"},{"id":"DNS_ERROR_RECORD_TIMED_OUT","name":"DNS_ERROR_RECORD_TIMED_OUT","value":"9705_u32"},{"id":"DNS_ERROR_NAME_NOT_IN_ZONE","name":"DNS_ERROR_NAME_NOT_IN_ZONE","value":"9706_u32"},{"id":"DNS_ERROR_CNAME_LOOP","name":"DNS_ERROR_CNAME_LOOP","value":"9707_u32"},{"id":"DNS_ERROR_NODE_IS_CNAME","name":"DNS_ERROR_NODE_IS_CNAME","value":"9708_u32"},{"id":"DNS_ERROR_CNAME_COLLISION","name":"DNS_ERROR_CNAME_COLLISION","value":"9709_u32"},{"id":"DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT","name":"DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT","value":"9710_u32"},{"id":"DNS_ERROR_RECORD_ALREADY_EXISTS","name":"DNS_ERROR_RECORD_ALREADY_EXISTS","value":"9711_u32"},{"id":"DNS_ERROR_SECONDARY_DATA","name":"DNS_ERROR_SECONDARY_DATA","value":"9712_u32"},{"id":"DNS_ERROR_NO_CREATE_CACHE_DATA","name":"DNS_ERROR_NO_CREATE_CACHE_DATA","value":"9713_u32"},{"id":"DNS_ERROR_NAME_DOES_NOT_EXIST","name":"DNS_ERROR_NAME_DOES_NOT_EXIST","value":"9714_u32"},{"id":"DNS_WARNING_PTR_CREATE_FAILED","name":"DNS_WARNING_PTR_CREATE_FAILED","value":"9715_u32"},{"id":"DNS_WARNING_DOMAIN_UNDELETED","name":"DNS_WARNING_DOMAIN_UNDELETED","value":"9716_u32"},{"id":"DNS_ERROR_DS_UNAVAILABLE","name":"DNS_ERROR_DS_UNAVAILABLE","value":"9717_u32"},{"id":"DNS_ERROR_DS_ZONE_ALREADY_EXISTS","name":"DNS_ERROR_DS_ZONE_ALREADY_EXISTS","value":"9718_u32"},{"id":"DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE","name":"DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE","value":"9719_u32"},{"id":"DNS_ERROR_OPERATION_BASE","name":"DNS_ERROR_OPERATION_BASE","value":"9750_u32"},{"id":"DNS_INFO_AXFR_COMPLETE","name":"DNS_INFO_AXFR_COMPLETE","value":"9751_u32"},{"id":"DNS_ERROR_AXFR","name":"DNS_ERROR_AXFR","value":"9752_u32"},{"id":"DNS_INFO_ADDED_LOCAL_WINS","name":"DNS_INFO_ADDED_LOCAL_WINS","value":"9753_u32"},{"id":"DNS_ERROR_SECURE_BASE","name":"DNS_ERROR_SECURE_BASE","value":"9800_u32"},{"id":"DNS_STATUS_CONTINUE_NEEDED","name":"DNS_STATUS_CONTINUE_NEEDED","value":"9801_u32"},{"id":"DNS_ERROR_SETUP_BASE","name":"DNS_ERROR_SETUP_BASE","value":"9850_u32"},{"id":"DNS_ERROR_NO_TCPIP","name":"DNS_ERROR_NO_TCPIP","value":"9851_u32"},{"id":"DNS_ERROR_NO_DNS_SERVERS","name":"DNS_ERROR_NO_DNS_SERVERS","value":"9852_u32"},{"id":"DNS_ERROR_DP_BASE","name":"DNS_ERROR_DP_BASE","value":"9900_u32"},{"id":"DNS_ERROR_DP_DOES_NOT_EXIST","name":"DNS_ERROR_DP_DOES_NOT_EXIST","value":"9901_u32"},{"id":"DNS_ERROR_DP_ALREADY_EXISTS","name":"DNS_ERROR_DP_ALREADY_EXISTS","value":"9902_u32"},{"id":"DNS_ERROR_DP_NOT_ENLISTED","name":"DNS_ERROR_DP_NOT_ENLISTED","value":"9903_u32"},{"id":"DNS_ERROR_DP_ALREADY_ENLISTED","name":"DNS_ERROR_DP_ALREADY_ENLISTED","value":"9904_u32"},{"id":"DNS_ERROR_DP_NOT_AVAILABLE","name":"DNS_ERROR_DP_NOT_AVAILABLE","value":"9905_u32"},{"id":"DNS_ERROR_DP_FSMO_ERROR","name":"DNS_ERROR_DP_FSMO_ERROR","value":"9906_u32"},{"id":"WSABASEERR","name":"WSABASEERR","value":"10000_u32"},{"id":"WSAEINTR","name":"WSAEINTR","value":"10004_u32"},{"id":"WSAEBADF","name":"WSAEBADF","value":"10009_u32"},{"id":"WSAEACCES","name":"WSAEACCES","value":"10013_u32"},{"id":"WSAEFAULT","name":"WSAEFAULT","value":"10014_u32"},{"id":"WSAEINVAL","name":"WSAEINVAL","value":"10022_u32"},{"id":"WSAEMFILE","name":"WSAEMFILE","value":"10024_u32"},{"id":"WSAEWOULDBLOCK","name":"WSAEWOULDBLOCK","value":"10035_u32"},{"id":"WSAEINPROGRESS","name":"WSAEINPROGRESS","value":"10036_u32"},{"id":"WSAEALREADY","name":"WSAEALREADY","value":"10037_u32"},{"id":"WSAENOTSOCK","name":"WSAENOTSOCK","value":"10038_u32"},{"id":"WSAEDESTADDRREQ","name":"WSAEDESTADDRREQ","value":"10039_u32"},{"id":"WSAEMSGSIZE","name":"WSAEMSGSIZE","value":"10040_u32"},{"id":"WSAEPROTOTYPE","name":"WSAEPROTOTYPE","value":"10041_u32"},{"id":"WSAENOPROTOOPT","name":"WSAENOPROTOOPT","value":"10042_u32"},{"id":"WSAEPROTONOSUPPORT","name":"WSAEPROTONOSUPPORT","value":"10043_u32"},{"id":"WSAESOCKTNOSUPPORT","name":"WSAESOCKTNOSUPPORT","value":"10044_u32"},{"id":"WSAEOPNOTSUPP","name":"WSAEOPNOTSUPP","value":"10045_u32"},{"id":"WSAEPFNOSUPPORT","name":"WSAEPFNOSUPPORT","value":"10046_u32"},{"id":"WSAEAFNOSUPPORT","name":"WSAEAFNOSUPPORT","value":"10047_u32"},{"id":"WSAEADDRINUSE","name":"WSAEADDRINUSE","value":"10048_u32"},{"id":"WSAEADDRNOTAVAIL","name":"WSAEADDRNOTAVAIL","value":"10049_u32"},{"id":"WSAENETDOWN","name":"WSAENETDOWN","value":"10050_u32"},{"id":"WSAENETUNREACH","name":"WSAENETUNREACH","value":"10051_u32"},{"id":"WSAENETRESET","name":"WSAENETRESET","value":"10052_u32"},{"id":"WSAECONNABORTED","name":"WSAECONNABORTED","value":"10053_u32"},{"id":"WSAECONNRESET","name":"WSAECONNRESET","value":"10054_u32"},{"id":"WSAENOBUFS","name":"WSAENOBUFS","value":"10055_u32"},{"id":"WSAEISCONN","name":"WSAEISCONN","value":"10056_u32"},{"id":"WSAENOTCONN","name":"WSAENOTCONN","value":"10057_u32"},{"id":"WSAESHUTDOWN","name":"WSAESHUTDOWN","value":"10058_u32"},{"id":"WSAETOOMANYREFS","name":"WSAETOOMANYREFS","value":"10059_u32"},{"id":"WSAETIMEDOUT","name":"WSAETIMEDOUT","value":"10060_u32"},{"id":"WSAECONNREFUSED","name":"WSAECONNREFUSED","value":"10061_u32"},{"id":"WSAELOOP","name":"WSAELOOP","value":"10062_u32"},{"id":"WSAENAMETOOLONG","name":"WSAENAMETOOLONG","value":"10063_u32"},{"id":"WSAEHOSTDOWN","name":"WSAEHOSTDOWN","value":"10064_u32"},{"id":"WSAEHOSTUNREACH","name":"WSAEHOSTUNREACH","value":"10065_u32"},{"id":"WSAENOTEMPTY","name":"WSAENOTEMPTY","value":"10066_u32"},{"id":"WSAEPROCLIM","name":"WSAEPROCLIM","value":"10067_u32"},{"id":"WSAEUSERS","name":"WSAEUSERS","value":"10068_u32"},{"id":"WSAEDQUOT","name":"WSAEDQUOT","value":"10069_u32"},{"id":"WSAESTALE","name":"WSAESTALE","value":"10070_u32"},{"id":"WSAEREMOTE","name":"WSAEREMOTE","value":"10071_u32"},{"id":"WSASYSNOTREADY","name":"WSASYSNOTREADY","value":"10091_u32"},{"id":"WSAVERNOTSUPPORTED","name":"WSAVERNOTSUPPORTED","value":"10092_u32"},{"id":"WSANOTINITIALISED","name":"WSANOTINITIALISED","value":"10093_u32"},{"id":"WSAEDISCON","name":"WSAEDISCON","value":"10101_u32"},{"id":"WSAENOMORE","name":"WSAENOMORE","value":"10102_u32"},{"id":"WSAECANCELLED","name":"WSAECANCELLED","value":"10103_u32"},{"id":"WSAEINVALIDPROCTABLE","name":"WSAEINVALIDPROCTABLE","value":"10104_u32"},{"id":"WSAEINVALIDPROVIDER","name":"WSAEINVALIDPROVIDER","value":"10105_u32"},{"id":"WSAEPROVIDERFAILEDINIT","name":"WSAEPROVIDERFAILEDINIT","value":"10106_u32"},{"id":"WSASYSCALLFAILURE","name":"WSASYSCALLFAILURE","value":"10107_u32"},{"id":"WSASERVICE_NOT_FOUND","name":"WSASERVICE_NOT_FOUND","value":"10108_u32"},{"id":"WSATYPE_NOT_FOUND","name":"WSATYPE_NOT_FOUND","value":"10109_u32"},{"id":"WSA_E_NO_MORE","name":"WSA_E_NO_MORE","value":"10110_u32"},{"id":"WSA_E_CANCELLED","name":"WSA_E_CANCELLED","value":"10111_u32"},{"id":"WSAEREFUSED","name":"WSAEREFUSED","value":"10112_u32"},{"id":"WSAHOST_NOT_FOUND","name":"WSAHOST_NOT_FOUND","value":"11001_u32"},{"id":"WSATRY_AGAIN","name":"WSATRY_AGAIN","value":"11002_u32"},{"id":"WSANO_RECOVERY","name":"WSANO_RECOVERY","value":"11003_u32"},{"id":"WSANO_DATA","name":"WSANO_DATA","value":"11004_u32"},{"id":"WSA_QOS_RECEIVERS","name":"WSA_QOS_RECEIVERS","value":"11005_u32"},{"id":"WSA_QOS_SENDERS","name":"WSA_QOS_SENDERS","value":"11006_u32"},{"id":"WSA_QOS_NO_SENDERS","name":"WSA_QOS_NO_SENDERS","value":"11007_u32"},{"id":"WSA_QOS_NO_RECEIVERS","name":"WSA_QOS_NO_RECEIVERS","value":"11008_u32"},{"id":"WSA_QOS_REQUEST_CONFIRMED","name":"WSA_QOS_REQUEST_CONFIRMED","value":"11009_u32"},{"id":"WSA_QOS_ADMISSION_FAILURE","name":"WSA_QOS_ADMISSION_FAILURE","value":"11010_u32"},{"id":"WSA_QOS_POLICY_FAILURE","name":"WSA_QOS_POLICY_FAILURE","value":"11011_u32"},{"id":"WSA_QOS_BAD_STYLE","name":"WSA_QOS_BAD_STYLE","value":"11012_u32"},{"id":"WSA_QOS_BAD_OBJECT","name":"WSA_QOS_BAD_OBJECT","value":"11013_u32"},{"id":"WSA_QOS_TRAFFIC_CTRL_ERROR","name":"WSA_QOS_TRAFFIC_CTRL_ERROR","value":"11014_u32"},{"id":"WSA_QOS_GENERIC_ERROR","name":"WSA_QOS_GENERIC_ERROR","value":"11015_u32"},{"id":"WSA_QOS_ESERVICETYPE","name":"WSA_QOS_ESERVICETYPE","value":"11016_u32"},{"id":"WSA_QOS_EFLOWSPEC","name":"WSA_QOS_EFLOWSPEC","value":"11017_u32"},{"id":"WSA_QOS_EPROVSPECBUF","name":"WSA_QOS_EPROVSPECBUF","value":"11018_u32"},{"id":"WSA_QOS_EFILTERSTYLE","name":"WSA_QOS_EFILTERSTYLE","value":"11019_u32"},{"id":"WSA_QOS_EFILTERTYPE","name":"WSA_QOS_EFILTERTYPE","value":"11020_u32"},{"id":"WSA_QOS_EFILTERCOUNT","name":"WSA_QOS_EFILTERCOUNT","value":"11021_u32"},{"id":"WSA_QOS_EOBJLENGTH","name":"WSA_QOS_EOBJLENGTH","value":"11022_u32"},{"id":"WSA_QOS_EFLOWCOUNT","name":"WSA_QOS_EFLOWCOUNT","value":"11023_u32"},{"id":"WSA_QOS_EUNKNOWNPSOBJ","name":"WSA_QOS_EUNKNOWNPSOBJ","value":"11024_u32"},{"id":"WSA_QOS_EUNKOWNPSOBJ","name":"WSA_QOS_EUNKOWNPSOBJ","value":"11024_u32"},{"id":"WSA_QOS_EPOLICYOBJ","name":"WSA_QOS_EPOLICYOBJ","value":"11025_u32"},{"id":"WSA_QOS_EFLOWDESC","name":"WSA_QOS_EFLOWDESC","value":"11026_u32"},{"id":"WSA_QOS_EPSFLOWSPEC","name":"WSA_QOS_EPSFLOWSPEC","value":"11027_u32"},{"id":"WSA_QOS_EPSFILTERSPEC","name":"WSA_QOS_EPSFILTERSPEC","value":"11028_u32"},{"id":"WSA_QOS_ESDMODEOBJ","name":"WSA_QOS_ESDMODEOBJ","value":"11029_u32"},{"id":"WSA_QOS_ESHAPERATEOBJ","name":"WSA_QOS_ESHAPERATEOBJ","value":"11030_u32"},{"id":"WSA_QOS_RESERVED_PETYPE","name":"WSA_QOS_RESERVED_PETYPE","value":"11031_u32"},{"id":"ERROR_SXS_SECTION_NOT_FOUND","name":"ERROR_SXS_SECTION_NOT_FOUND","value":"14000_u32"},{"id":"ERROR_SXS_CANT_GEN_ACTCTX","name":"ERROR_SXS_CANT_GEN_ACTCTX","value":"14001_u32"},{"id":"ERROR_SXS_INVALID_ACTCTXDATA_FORMAT","name":"ERROR_SXS_INVALID_ACTCTXDATA_FORMAT","value":"14002_u32"},{"id":"ERROR_SXS_ASSEMBLY_NOT_FOUND","name":"ERROR_SXS_ASSEMBLY_NOT_FOUND","value":"14003_u32"},{"id":"ERROR_SXS_MANIFEST_FORMAT_ERROR","name":"ERROR_SXS_MANIFEST_FORMAT_ERROR","value":"14004_u32"},{"id":"ERROR_SXS_MANIFEST_PARSE_ERROR","name":"ERROR_SXS_MANIFEST_PARSE_ERROR","value":"14005_u32"},{"id":"ERROR_SXS_ACTIVATION_CONTEXT_DISABLED","name":"ERROR_SXS_ACTIVATION_CONTEXT_DISABLED","value":"14006_u32"},{"id":"ERROR_SXS_KEY_NOT_FOUND","name":"ERROR_SXS_KEY_NOT_FOUND","value":"14007_u32"},{"id":"ERROR_SXS_VERSION_CONFLICT","name":"ERROR_SXS_VERSION_CONFLICT","value":"14008_u32"},{"id":"ERROR_SXS_WRONG_SECTION_TYPE","name":"ERROR_SXS_WRONG_SECTION_TYPE","value":"14009_u32"},{"id":"ERROR_SXS_THREAD_QUERIES_DISABLED","name":"ERROR_SXS_THREAD_QUERIES_DISABLED","value":"14010_u32"},{"id":"ERROR_SXS_PROCESS_DEFAULT_ALREADY_SET","name":"ERROR_SXS_PROCESS_DEFAULT_ALREADY_SET","value":"14011_u32"},{"id":"ERROR_SXS_UNKNOWN_ENCODING_GROUP","name":"ERROR_SXS_UNKNOWN_ENCODING_GROUP","value":"14012_u32"},{"id":"ERROR_SXS_UNKNOWN_ENCODING","name":"ERROR_SXS_UNKNOWN_ENCODING","value":"14013_u32"},{"id":"ERROR_SXS_INVALID_XML_NAMESPACE_URI","name":"ERROR_SXS_INVALID_XML_NAMESPACE_URI","value":"14014_u32"},{"id":"ERROR_SXS_ROOT_MANIFEST_DEPENDENCY_NOT_INSTALLED","name":"ERROR_SXS_ROOT_MANIFEST_DEPENDENCY_NOT_INSTALLED","value":"14015_u32"},{"id":"ERROR_SXS_LEAF_MANIFEST_DEPENDENCY_NOT_INSTALLED","name":"ERROR_SXS_LEAF_MANIFEST_DEPENDENCY_NOT_INSTALLED","value":"14016_u32"},{"id":"ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE","name":"ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE","value":"14017_u32"},{"id":"ERROR_SXS_MANIFEST_MISSING_REQUIRED_DEFAULT_NAMESPACE","name":"ERROR_SXS_MANIFEST_MISSING_REQUIRED_DEFAULT_NAMESPACE","value":"14018_u32"},{"id":"ERROR_SXS_MANIFEST_INVALID_REQUIRED_DEFAULT_NAMESPACE","name":"ERROR_SXS_MANIFEST_INVALID_REQUIRED_DEFAULT_NAMESPACE","value":"14019_u32"},{"id":"ERROR_SXS_PRIVATE_MANIFEST_CROSS_PATH_WITH_REPARSE_POINT","name":"ERROR_SXS_PRIVATE_MANIFEST_CROSS_PATH_WITH_REPARSE_POINT","value":"14020_u32"},{"id":"ERROR_SXS_DUPLICATE_DLL_NAME","name":"ERROR_SXS_DUPLICATE_DLL_NAME","value":"14021_u32"},{"id":"ERROR_SXS_DUPLICATE_WINDOWCLASS_NAME","name":"ERROR_SXS_DUPLICATE_WINDOWCLASS_NAME","value":"14022_u32"},{"id":"ERROR_SXS_DUPLICATE_CLSID","name":"ERROR_SXS_DUPLICATE_CLSID","value":"14023_u32"},{"id":"ERROR_SXS_DUPLICATE_IID","name":"ERROR_SXS_DUPLICATE_IID","value":"14024_u32"},{"id":"ERROR_SXS_DUPLICATE_TLBID","name":"ERROR_SXS_DUPLICATE_TLBID","value":"14025_u32"},{"id":"ERROR_SXS_DUPLICATE_PROGID","name":"ERROR_SXS_DUPLICATE_PROGID","value":"14026_u32"},{"id":"ERROR_SXS_DUPLICATE_ASSEMBLY_NAME","name":"ERROR_SXS_DUPLICATE_ASSEMBLY_NAME","value":"14027_u32"},{"id":"ERROR_SXS_FILE_HASH_MISMATCH","name":"ERROR_SXS_FILE_HASH_MISMATCH","value":"14028_u32"},{"id":"ERROR_SXS_POLICY_PARSE_ERROR","name":"ERROR_SXS_POLICY_PARSE_ERROR","value":"14029_u32"},{"id":"ERROR_SXS_XML_E_MISSINGQUOTE","name":"ERROR_SXS_XML_E_MISSINGQUOTE","value":"14030_u32"},{"id":"ERROR_SXS_XML_E_COMMENTSYNTAX","name":"ERROR_SXS_XML_E_COMMENTSYNTAX","value":"14031_u32"},{"id":"ERROR_SXS_XML_E_BADSTARTNAMECHAR","name":"ERROR_SXS_XML_E_BADSTARTNAMECHAR","value":"14032_u32"},{"id":"ERROR_SXS_XML_E_BADNAMECHAR","name":"ERROR_SXS_XML_E_BADNAMECHAR","value":"14033_u32"},{"id":"ERROR_SXS_XML_E_BADCHARINSTRING","name":"ERROR_SXS_XML_E_BADCHARINSTRING","value":"14034_u32"},{"id":"ERROR_SXS_XML_E_XMLDECLSYNTAX","name":"ERROR_SXS_XML_E_XMLDECLSYNTAX","value":"14035_u32"},{"id":"ERROR_SXS_XML_E_BADCHARDATA","name":"ERROR_SXS_XML_E_BADCHARDATA","value":"14036_u32"},{"id":"ERROR_SXS_XML_E_MISSINGWHITESPACE","name":"ERROR_SXS_XML_E_MISSINGWHITESPACE","value":"14037_u32"},{"id":"ERROR_SXS_XML_E_EXPECTINGTAGEND","name":"ERROR_SXS_XML_E_EXPECTINGTAGEND","value":"14038_u32"},{"id":"ERROR_SXS_XML_E_MISSINGSEMICOLON","name":"ERROR_SXS_XML_E_MISSINGSEMICOLON","value":"14039_u32"},{"id":"ERROR_SXS_XML_E_UNBALANCEDPAREN","name":"ERROR_SXS_XML_E_UNBALANCEDPAREN","value":"14040_u32"},{"id":"ERROR_SXS_XML_E_INTERNALERROR","name":"ERROR_SXS_XML_E_INTERNALERROR","value":"14041_u32"},{"id":"ERROR_SXS_XML_E_UNEXPECTED_WHITESPACE","name":"ERROR_SXS_XML_E_UNEXPECTED_WHITESPACE","value":"14042_u32"},{"id":"ERROR_SXS_XML_E_INCOMPLETE_ENCODING","name":"ERROR_SXS_XML_E_INCOMPLETE_ENCODING","value":"14043_u32"},{"id":"ERROR_SXS_XML_E_MISSING_PAREN","name":"ERROR_SXS_XML_E_MISSING_PAREN","value":"14044_u32"},{"id":"ERROR_SXS_XML_E_EXPECTINGCLOSEQUOTE","name":"ERROR_SXS_XML_E_EXPECTINGCLOSEQUOTE","value":"14045_u32"},{"id":"ERROR_SXS_XML_E_MULTIPLE_COLONS","name":"ERROR_SXS_XML_E_MULTIPLE_COLONS","value":"14046_u32"},{"id":"ERROR_SXS_XML_E_INVALID_DECIMAL","name":"ERROR_SXS_XML_E_INVALID_DECIMAL","value":"14047_u32"},{"id":"ERROR_SXS_XML_E_INVALID_HEXIDECIMAL","name":"ERROR_SXS_XML_E_INVALID_HEXIDECIMAL","value":"14048_u32"},{"id":"ERROR_SXS_XML_E_INVALID_UNICODE","name":"ERROR_SXS_XML_E_INVALID_UNICODE","value":"14049_u32"},{"id":"ERROR_SXS_XML_E_WHITESPACEORQUESTIONMARK","name":"ERROR_SXS_XML_E_WHITESPACEORQUESTIONMARK","value":"14050_u32"},{"id":"ERROR_SXS_XML_E_UNEXPECTEDENDTAG","name":"ERROR_SXS_XML_E_UNEXPECTEDENDTAG","value":"14051_u32"},{"id":"ERROR_SXS_XML_E_UNCLOSEDTAG","name":"ERROR_SXS_XML_E_UNCLOSEDTAG","value":"14052_u32"},{"id":"ERROR_SXS_XML_E_DUPLICATEATTRIBUTE","name":"ERROR_SXS_XML_E_DUPLICATEATTRIBUTE","value":"14053_u32"},{"id":"ERROR_SXS_XML_E_MULTIPLEROOTS","name":"ERROR_SXS_XML_E_MULTIPLEROOTS","value":"14054_u32"},{"id":"ERROR_SXS_XML_E_INVALIDATROOTLEVEL","name":"ERROR_SXS_XML_E_INVALIDATROOTLEVEL","value":"14055_u32"},{"id":"ERROR_SXS_XML_E_BADXMLDECL","name":"ERROR_SXS_XML_E_BADXMLDECL","value":"14056_u32"},{"id":"ERROR_SXS_XML_E_MISSINGROOT","name":"ERROR_SXS_XML_E_MISSINGROOT","value":"14057_u32"},{"id":"ERROR_SXS_XML_E_UNEXPECTEDEOF","name":"ERROR_SXS_XML_E_UNEXPECTEDEOF","value":"14058_u32"},{"id":"ERROR_SXS_XML_E_BADPEREFINSUBSET","name":"ERROR_SXS_XML_E_BADPEREFINSUBSET","value":"14059_u32"},{"id":"ERROR_SXS_XML_E_UNCLOSEDSTARTTAG","name":"ERROR_SXS_XML_E_UNCLOSEDSTARTTAG","value":"14060_u32"},{"id":"ERROR_SXS_XML_E_UNCLOSEDENDTAG","name":"ERROR_SXS_XML_E_UNCLOSEDENDTAG","value":"14061_u32"},{"id":"ERROR_SXS_XML_E_UNCLOSEDSTRING","name":"ERROR_SXS_XML_E_UNCLOSEDSTRING","value":"14062_u32"},{"id":"ERROR_SXS_XML_E_UNCLOSEDCOMMENT","name":"ERROR_SXS_XML_E_UNCLOSEDCOMMENT","value":"14063_u32"},{"id":"ERROR_SXS_XML_E_UNCLOSEDDECL","name":"ERROR_SXS_XML_E_UNCLOSEDDECL","value":"14064_u32"},{"id":"ERROR_SXS_XML_E_UNCLOSEDCDATA","name":"ERROR_SXS_XML_E_UNCLOSEDCDATA","value":"14065_u32"},{"id":"ERROR_SXS_XML_E_RESERVEDNAMESPACE","name":"ERROR_SXS_XML_E_RESERVEDNAMESPACE","value":"14066_u32"},{"id":"ERROR_SXS_XML_E_INVALIDENCODING","name":"ERROR_SXS_XML_E_INVALIDENCODING","value":"14067_u32"},{"id":"ERROR_SXS_XML_E_INVALIDSWITCH","name":"ERROR_SXS_XML_E_INVALIDSWITCH","value":"14068_u32"},{"id":"ERROR_SXS_XML_E_BADXMLCASE","name":"ERROR_SXS_XML_E_BADXMLCASE","value":"14069_u32"},{"id":"ERROR_SXS_XML_E_INVALID_STANDALONE","name":"ERROR_SXS_XML_E_INVALID_STANDALONE","value":"14070_u32"},{"id":"ERROR_SXS_XML_E_UNEXPECTED_STANDALONE","name":"ERROR_SXS_XML_E_UNEXPECTED_STANDALONE","value":"14071_u32"},{"id":"ERROR_SXS_XML_E_INVALID_VERSION","name":"ERROR_SXS_XML_E_INVALID_VERSION","value":"14072_u32"},{"id":"ERROR_SXS_XML_E_MISSINGEQUALS","name":"ERROR_SXS_XML_E_MISSINGEQUALS","value":"14073_u32"},{"id":"ERROR_SXS_PROTECTION_RECOVERY_FAILED","name":"ERROR_SXS_PROTECTION_RECOVERY_FAILED","value":"14074_u32"},{"id":"ERROR_SXS_PROTECTION_PUBLIC_KEY_TOO_SHORT","name":"ERROR_SXS_PROTECTION_PUBLIC_KEY_TOO_SHORT","value":"14075_u32"},{"id":"ERROR_SXS_PROTECTION_CATALOG_NOT_VALID","name":"ERROR_SXS_PROTECTION_CATALOG_NOT_VALID","value":"14076_u32"},{"id":"ERROR_SXS_UNTRANSLATABLE_HRESULT","name":"ERROR_SXS_UNTRANSLATABLE_HRESULT","value":"14077_u32"},{"id":"ERROR_SXS_PROTECTION_CATALOG_FILE_MISSING","name":"ERROR_SXS_PROTECTION_CATALOG_FILE_MISSING","value":"14078_u32"},{"id":"ERROR_SXS_MISSING_ASSEMBLY_IDENTITY_ATTRIBUTE","name":"ERROR_SXS_MISSING_ASSEMBLY_IDENTITY_ATTRIBUTE","value":"14079_u32"},{"id":"ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE_NAME","name":"ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE_NAME","value":"14080_u32"},{"id":"ERROR_SXS_ASSEMBLY_MISSING","name":"ERROR_SXS_ASSEMBLY_MISSING","value":"14081_u32"},{"id":"ERROR_SXS_CORRUPT_ACTIVATION_STACK","name":"ERROR_SXS_CORRUPT_ACTIVATION_STACK","value":"14082_u32"},{"id":"ERROR_SXS_CORRUPTION","name":"ERROR_SXS_CORRUPTION","value":"14083_u32"},{"id":"ERROR_SXS_EARLY_DEACTIVATION","name":"ERROR_SXS_EARLY_DEACTIVATION","value":"14084_u32"},{"id":"ERROR_SXS_INVALID_DEACTIVATION","name":"ERROR_SXS_INVALID_DEACTIVATION","value":"14085_u32"},{"id":"ERROR_SXS_MULTIPLE_DEACTIVATION","name":"ERROR_SXS_MULTIPLE_DEACTIVATION","value":"14086_u32"},{"id":"ERROR_SXS_PROCESS_TERMINATION_REQUESTED","name":"ERROR_SXS_PROCESS_TERMINATION_REQUESTED","value":"14087_u32"},{"id":"ERROR_SXS_RELEASE_ACTIVATION_CONTEXT","name":"ERROR_SXS_RELEASE_ACTIVATION_CONTEXT","value":"14088_u32"},{"id":"ERROR_SXS_SYSTEM_DEFAULT_ACTIVATION_CONTEXT_EMPTY","name":"ERROR_SXS_SYSTEM_DEFAULT_ACTIVATION_CONTEXT_EMPTY","value":"14089_u32"},{"id":"ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_VALUE","name":"ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_VALUE","value":"14090_u32"},{"id":"ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_NAME","name":"ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_NAME","value":"14091_u32"},{"id":"ERROR_SXS_IDENTITY_DUPLICATE_ATTRIBUTE","name":"ERROR_SXS_IDENTITY_DUPLICATE_ATTRIBUTE","value":"14092_u32"},{"id":"ERROR_SXS_IDENTITY_PARSE_ERROR","name":"ERROR_SXS_IDENTITY_PARSE_ERROR","value":"14093_u32"},{"id":"ERROR_MALFORMED_SUBSTITUTION_STRING","name":"ERROR_MALFORMED_SUBSTITUTION_STRING","value":"14094_u32"},{"id":"ERROR_SXS_INCORRECT_PUBLIC_KEY_TOKEN","name":"ERROR_SXS_INCORRECT_PUBLIC_KEY_TOKEN","value":"14095_u32"},{"id":"ERROR_UNMAPPED_SUBSTITUTION_STRING","name":"ERROR_UNMAPPED_SUBSTITUTION_STRING","value":"14096_u32"},{"id":"ERROR_SXS_ASSEMBLY_NOT_LOCKED","name":"ERROR_SXS_ASSEMBLY_NOT_LOCKED","value":"14097_u32"},{"id":"ERROR_SXS_COMPONENT_STORE_CORRUPT","name":"ERROR_SXS_COMPONENT_STORE_CORRUPT","value":"14098_u32"},{"id":"ERROR_ADVANCED_INSTALLER_FAILED","name":"ERROR_ADVANCED_INSTALLER_FAILED","value":"14099_u32"},{"id":"ERROR_XML_ENCODING_MISMATCH","name":"ERROR_XML_ENCODING_MISMATCH","value":"14100_u32"},{"id":"ERROR_SXS_MANIFEST_IDENTITY_SAME_BUT_CONTENTS_DIFFERENT","name":"ERROR_SXS_MANIFEST_IDENTITY_SAME_BUT_CONTENTS_DIFFERENT","value":"14101_u32"},{"id":"ERROR_SXS_IDENTITIES_DIFFERENT","name":"ERROR_SXS_IDENTITIES_DIFFERENT","value":"14102_u32"},{"id":"ERROR_SXS_ASSEMBLY_IS_NOT_A_DEPLOYMENT","name":"ERROR_SXS_ASSEMBLY_IS_NOT_A_DEPLOYMENT","value":"14103_u32"},{"id":"ERROR_SXS_FILE_NOT_PART_OF_ASSEMBLY","name":"ERROR_SXS_FILE_NOT_PART_OF_ASSEMBLY","value":"14104_u32"},{"id":"ERROR_SXS_MANIFEST_TOO_BIG","name":"ERROR_SXS_MANIFEST_TOO_BIG","value":"14105_u32"},{"id":"ERROR_SXS_SETTING_NOT_REGISTERED","name":"ERROR_SXS_SETTING_NOT_REGISTERED","value":"14106_u32"},{"id":"ERROR_SXS_TRANSACTION_CLOSURE_INCOMPLETE","name":"ERROR_SXS_TRANSACTION_CLOSURE_INCOMPLETE","value":"14107_u32"},{"id":"ERROR_SMI_PRIMITIVE_INSTALLER_FAILED","name":"ERROR_SMI_PRIMITIVE_INSTALLER_FAILED","value":"14108_u32"},{"id":"ERROR_GENERIC_COMMAND_FAILED","name":"ERROR_GENERIC_COMMAND_FAILED","value":"14109_u32"},{"id":"ERROR_SXS_FILE_HASH_MISSING","name":"ERROR_SXS_FILE_HASH_MISSING","value":"14110_u32"},{"id":"ERROR_IPSEC_QM_POLICY_EXISTS","name":"ERROR_IPSEC_QM_POLICY_EXISTS","value":"13000_u32"},{"id":"ERROR_IPSEC_QM_POLICY_NOT_FOUND","name":"ERROR_IPSEC_QM_POLICY_NOT_FOUND","value":"13001_u32"},{"id":"ERROR_IPSEC_QM_POLICY_IN_USE","name":"ERROR_IPSEC_QM_POLICY_IN_USE","value":"13002_u32"},{"id":"ERROR_IPSEC_MM_POLICY_EXISTS","name":"ERROR_IPSEC_MM_POLICY_EXISTS","value":"13003_u32"},{"id":"ERROR_IPSEC_MM_POLICY_NOT_FOUND","name":"ERROR_IPSEC_MM_POLICY_NOT_FOUND","value":"13004_u32"},{"id":"ERROR_IPSEC_MM_POLICY_IN_USE","name":"ERROR_IPSEC_MM_POLICY_IN_USE","value":"13005_u32"},{"id":"ERROR_IPSEC_MM_FILTER_EXISTS","name":"ERROR_IPSEC_MM_FILTER_EXISTS","value":"13006_u32"},{"id":"ERROR_IPSEC_MM_FILTER_NOT_FOUND","name":"ERROR_IPSEC_MM_FILTER_NOT_FOUND","value":"13007_u32"},{"id":"ERROR_IPSEC_TRANSPORT_FILTER_EXISTS","name":"ERROR_IPSEC_TRANSPORT_FILTER_EXISTS","value":"13008_u32"},{"id":"ERROR_IPSEC_TRANSPORT_FILTER_NOT_FOUND","name":"ERROR_IPSEC_TRANSPORT_FILTER_NOT_FOUND","value":"13009_u32"},{"id":"ERROR_IPSEC_MM_AUTH_EXISTS","name":"ERROR_IPSEC_MM_AUTH_EXISTS","value":"13010_u32"},{"id":"ERROR_IPSEC_MM_AUTH_NOT_FOUND","name":"ERROR_IPSEC_MM_AUTH_NOT_FOUND","value":"13011_u32"},{"id":"ERROR_IPSEC_MM_AUTH_IN_USE","name":"ERROR_IPSEC_MM_AUTH_IN_USE","value":"13012_u32"},{"id":"ERROR_IPSEC_DEFAULT_MM_POLICY_NOT_FOUND","name":"ERROR_IPSEC_DEFAULT_MM_POLICY_NOT_FOUND","value":"13013_u32"},{"id":"ERROR_IPSEC_DEFAULT_MM_AUTH_NOT_FOUND","name":"ERROR_IPSEC_DEFAULT_MM_AUTH_NOT_FOUND","value":"13014_u32"},{"id":"ERROR_IPSEC_DEFAULT_QM_POLICY_NOT_FOUND","name":"ERROR_IPSEC_DEFAULT_QM_POLICY_NOT_FOUND","value":"13015_u32"},{"id":"ERROR_IPSEC_TUNNEL_FILTER_EXISTS","name":"ERROR_IPSEC_TUNNEL_FILTER_EXISTS","value":"13016_u32"},{"id":"ERROR_IPSEC_TUNNEL_FILTER_NOT_FOUND","name":"ERROR_IPSEC_TUNNEL_FILTER_NOT_FOUND","value":"13017_u32"},{"id":"ERROR_IPSEC_MM_FILTER_PENDING_DELETION","name":"ERROR_IPSEC_MM_FILTER_PENDING_DELETION","value":"13018_u32"},{"id":"ERROR_IPSEC_TRANSPORT_FILTER_PENDING_DELETION","name":"ERROR_IPSEC_TRANSPORT_FILTER_PENDING_DELETION","value":"13019_u32"},{"id":"ERROR_IPSEC_TUNNEL_FILTER_PENDING_DELETION","name":"ERROR_IPSEC_TUNNEL_FILTER_PENDING_DELETION","value":"13020_u32"},{"id":"ERROR_IPSEC_MM_POLICY_PENDING_DELETION","name":"ERROR_IPSEC_MM_POLICY_PENDING_DELETION","value":"13021_u32"},{"id":"ERROR_IPSEC_MM_AUTH_PENDING_DELETION","name":"ERROR_IPSEC_MM_AUTH_PENDING_DELETION","value":"13022_u32"},{"id":"ERROR_IPSEC_QM_POLICY_PENDING_DELETION","name":"ERROR_IPSEC_QM_POLICY_PENDING_DELETION","value":"13023_u32"},{"id":"WARNING_IPSEC_MM_POLICY_PRUNED","name":"WARNING_IPSEC_MM_POLICY_PRUNED","value":"13024_u32"},{"id":"WARNING_IPSEC_QM_POLICY_PRUNED","name":"WARNING_IPSEC_QM_POLICY_PRUNED","value":"13025_u32"},{"id":"ERROR_IPSEC_IKE_NEG_STATUS_BEGIN","name":"ERROR_IPSEC_IKE_NEG_STATUS_BEGIN","value":"13800_u32"},{"id":"ERROR_IPSEC_IKE_AUTH_FAIL","name":"ERROR_IPSEC_IKE_AUTH_FAIL","value":"13801_u32"},{"id":"ERROR_IPSEC_IKE_ATTRIB_FAIL","name":"ERROR_IPSEC_IKE_ATTRIB_FAIL","value":"13802_u32"},{"id":"ERROR_IPSEC_IKE_NEGOTIATION_PENDING","name":"ERROR_IPSEC_IKE_NEGOTIATION_PENDING","value":"13803_u32"},{"id":"ERROR_IPSEC_IKE_GENERAL_PROCESSING_ERROR","name":"ERROR_IPSEC_IKE_GENERAL_PROCESSING_ERROR","value":"13804_u32"},{"id":"ERROR_IPSEC_IKE_TIMED_OUT","name":"ERROR_IPSEC_IKE_TIMED_OUT","value":"13805_u32"},{"id":"ERROR_IPSEC_IKE_NO_CERT","name":"ERROR_IPSEC_IKE_NO_CERT","value":"13806_u32"},{"id":"ERROR_IPSEC_IKE_SA_DELETED","name":"ERROR_IPSEC_IKE_SA_DELETED","value":"13807_u32"},{"id":"ERROR_IPSEC_IKE_SA_REAPED","name":"ERROR_IPSEC_IKE_SA_REAPED","value":"13808_u32"},{"id":"ERROR_IPSEC_IKE_MM_ACQUIRE_DROP","name":"ERROR_IPSEC_IKE_MM_ACQUIRE_DROP","value":"13809_u32"},{"id":"ERROR_IPSEC_IKE_QM_ACQUIRE_DROP","name":"ERROR_IPSEC_IKE_QM_ACQUIRE_DROP","value":"13810_u32"},{"id":"ERROR_IPSEC_IKE_QUEUE_DROP_MM","name":"ERROR_IPSEC_IKE_QUEUE_DROP_MM","value":"13811_u32"},{"id":"ERROR_IPSEC_IKE_QUEUE_DROP_NO_MM","name":"ERROR_IPSEC_IKE_QUEUE_DROP_NO_MM","value":"13812_u32"},{"id":"ERROR_IPSEC_IKE_DROP_NO_RESPONSE","name":"ERROR_IPSEC_IKE_DROP_NO_RESPONSE","value":"13813_u32"},{"id":"ERROR_IPSEC_IKE_MM_DELAY_DROP","name":"ERROR_IPSEC_IKE_MM_DELAY_DROP","value":"13814_u32"},{"id":"ERROR_IPSEC_IKE_QM_DELAY_DROP","name":"ERROR_IPSEC_IKE_QM_DELAY_DROP","value":"13815_u32"},{"id":"ERROR_IPSEC_IKE_ERROR","name":"ERROR_IPSEC_IKE_ERROR","value":"13816_u32"},{"id":"ERROR_IPSEC_IKE_CRL_FAILED","name":"ERROR_IPSEC_IKE_CRL_FAILED","value":"13817_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_KEY_USAGE","name":"ERROR_IPSEC_IKE_INVALID_KEY_USAGE","value":"13818_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_CERT_TYPE","name":"ERROR_IPSEC_IKE_INVALID_CERT_TYPE","value":"13819_u32"},{"id":"ERROR_IPSEC_IKE_NO_PRIVATE_KEY","name":"ERROR_IPSEC_IKE_NO_PRIVATE_KEY","value":"13820_u32"},{"id":"ERROR_IPSEC_IKE_DH_FAIL","name":"ERROR_IPSEC_IKE_DH_FAIL","value":"13822_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_HEADER","name":"ERROR_IPSEC_IKE_INVALID_HEADER","value":"13824_u32"},{"id":"ERROR_IPSEC_IKE_NO_POLICY","name":"ERROR_IPSEC_IKE_NO_POLICY","value":"13825_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_SIGNATURE","name":"ERROR_IPSEC_IKE_INVALID_SIGNATURE","value":"13826_u32"},{"id":"ERROR_IPSEC_IKE_KERBEROS_ERROR","name":"ERROR_IPSEC_IKE_KERBEROS_ERROR","value":"13827_u32"},{"id":"ERROR_IPSEC_IKE_NO_PUBLIC_KEY","name":"ERROR_IPSEC_IKE_NO_PUBLIC_KEY","value":"13828_u32"},{"id":"ERROR_IPSEC_IKE_PROCESS_ERR","name":"ERROR_IPSEC_IKE_PROCESS_ERR","value":"13829_u32"},{"id":"ERROR_IPSEC_IKE_PROCESS_ERR_SA","name":"ERROR_IPSEC_IKE_PROCESS_ERR_SA","value":"13830_u32"},{"id":"ERROR_IPSEC_IKE_PROCESS_ERR_PROP","name":"ERROR_IPSEC_IKE_PROCESS_ERR_PROP","value":"13831_u32"},{"id":"ERROR_IPSEC_IKE_PROCESS_ERR_TRANS","name":"ERROR_IPSEC_IKE_PROCESS_ERR_TRANS","value":"13832_u32"},{"id":"ERROR_IPSEC_IKE_PROCESS_ERR_KE","name":"ERROR_IPSEC_IKE_PROCESS_ERR_KE","value":"13833_u32"},{"id":"ERROR_IPSEC_IKE_PROCESS_ERR_ID","name":"ERROR_IPSEC_IKE_PROCESS_ERR_ID","value":"13834_u32"},{"id":"ERROR_IPSEC_IKE_PROCESS_ERR_CERT","name":"ERROR_IPSEC_IKE_PROCESS_ERR_CERT","value":"13835_u32"},{"id":"ERROR_IPSEC_IKE_PROCESS_ERR_CERT_REQ","name":"ERROR_IPSEC_IKE_PROCESS_ERR_CERT_REQ","value":"13836_u32"},{"id":"ERROR_IPSEC_IKE_PROCESS_ERR_HASH","name":"ERROR_IPSEC_IKE_PROCESS_ERR_HASH","value":"13837_u32"},{"id":"ERROR_IPSEC_IKE_PROCESS_ERR_SIG","name":"ERROR_IPSEC_IKE_PROCESS_ERR_SIG","value":"13838_u32"},{"id":"ERROR_IPSEC_IKE_PROCESS_ERR_NONCE","name":"ERROR_IPSEC_IKE_PROCESS_ERR_NONCE","value":"13839_u32"},{"id":"ERROR_IPSEC_IKE_PROCESS_ERR_NOTIFY","name":"ERROR_IPSEC_IKE_PROCESS_ERR_NOTIFY","value":"13840_u32"},{"id":"ERROR_IPSEC_IKE_PROCESS_ERR_DELETE","name":"ERROR_IPSEC_IKE_PROCESS_ERR_DELETE","value":"13841_u32"},{"id":"ERROR_IPSEC_IKE_PROCESS_ERR_VENDOR","name":"ERROR_IPSEC_IKE_PROCESS_ERR_VENDOR","value":"13842_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_PAYLOAD","name":"ERROR_IPSEC_IKE_INVALID_PAYLOAD","value":"13843_u32"},{"id":"ERROR_IPSEC_IKE_LOAD_SOFT_SA","name":"ERROR_IPSEC_IKE_LOAD_SOFT_SA","value":"13844_u32"},{"id":"ERROR_IPSEC_IKE_SOFT_SA_TORN_DOWN","name":"ERROR_IPSEC_IKE_SOFT_SA_TORN_DOWN","value":"13845_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_COOKIE","name":"ERROR_IPSEC_IKE_INVALID_COOKIE","value":"13846_u32"},{"id":"ERROR_IPSEC_IKE_NO_PEER_CERT","name":"ERROR_IPSEC_IKE_NO_PEER_CERT","value":"13847_u32"},{"id":"ERROR_IPSEC_IKE_PEER_CRL_FAILED","name":"ERROR_IPSEC_IKE_PEER_CRL_FAILED","value":"13848_u32"},{"id":"ERROR_IPSEC_IKE_POLICY_CHANGE","name":"ERROR_IPSEC_IKE_POLICY_CHANGE","value":"13849_u32"},{"id":"ERROR_IPSEC_IKE_NO_MM_POLICY","name":"ERROR_IPSEC_IKE_NO_MM_POLICY","value":"13850_u32"},{"id":"ERROR_IPSEC_IKE_NOTCBPRIV","name":"ERROR_IPSEC_IKE_NOTCBPRIV","value":"13851_u32"},{"id":"ERROR_IPSEC_IKE_SECLOADFAIL","name":"ERROR_IPSEC_IKE_SECLOADFAIL","value":"13852_u32"},{"id":"ERROR_IPSEC_IKE_FAILSSPINIT","name":"ERROR_IPSEC_IKE_FAILSSPINIT","value":"13853_u32"},{"id":"ERROR_IPSEC_IKE_FAILQUERYSSP","name":"ERROR_IPSEC_IKE_FAILQUERYSSP","value":"13854_u32"},{"id":"ERROR_IPSEC_IKE_SRVACQFAIL","name":"ERROR_IPSEC_IKE_SRVACQFAIL","value":"13855_u32"},{"id":"ERROR_IPSEC_IKE_SRVQUERYCRED","name":"ERROR_IPSEC_IKE_SRVQUERYCRED","value":"13856_u32"},{"id":"ERROR_IPSEC_IKE_GETSPIFAIL","name":"ERROR_IPSEC_IKE_GETSPIFAIL","value":"13857_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_FILTER","name":"ERROR_IPSEC_IKE_INVALID_FILTER","value":"13858_u32"},{"id":"ERROR_IPSEC_IKE_OUT_OF_MEMORY","name":"ERROR_IPSEC_IKE_OUT_OF_MEMORY","value":"13859_u32"},{"id":"ERROR_IPSEC_IKE_ADD_UPDATE_KEY_FAILED","name":"ERROR_IPSEC_IKE_ADD_UPDATE_KEY_FAILED","value":"13860_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_POLICY","name":"ERROR_IPSEC_IKE_INVALID_POLICY","value":"13861_u32"},{"id":"ERROR_IPSEC_IKE_UNKNOWN_DOI","name":"ERROR_IPSEC_IKE_UNKNOWN_DOI","value":"13862_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_SITUATION","name":"ERROR_IPSEC_IKE_INVALID_SITUATION","value":"13863_u32"},{"id":"ERROR_IPSEC_IKE_DH_FAILURE","name":"ERROR_IPSEC_IKE_DH_FAILURE","value":"13864_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_GROUP","name":"ERROR_IPSEC_IKE_INVALID_GROUP","value":"13865_u32"},{"id":"ERROR_IPSEC_IKE_ENCRYPT","name":"ERROR_IPSEC_IKE_ENCRYPT","value":"13866_u32"},{"id":"ERROR_IPSEC_IKE_DECRYPT","name":"ERROR_IPSEC_IKE_DECRYPT","value":"13867_u32"},{"id":"ERROR_IPSEC_IKE_POLICY_MATCH","name":"ERROR_IPSEC_IKE_POLICY_MATCH","value":"13868_u32"},{"id":"ERROR_IPSEC_IKE_UNSUPPORTED_ID","name":"ERROR_IPSEC_IKE_UNSUPPORTED_ID","value":"13869_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_HASH","name":"ERROR_IPSEC_IKE_INVALID_HASH","value":"13870_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_HASH_ALG","name":"ERROR_IPSEC_IKE_INVALID_HASH_ALG","value":"13871_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_HASH_SIZE","name":"ERROR_IPSEC_IKE_INVALID_HASH_SIZE","value":"13872_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_ENCRYPT_ALG","name":"ERROR_IPSEC_IKE_INVALID_ENCRYPT_ALG","value":"13873_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_AUTH_ALG","name":"ERROR_IPSEC_IKE_INVALID_AUTH_ALG","value":"13874_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_SIG","name":"ERROR_IPSEC_IKE_INVALID_SIG","value":"13875_u32"},{"id":"ERROR_IPSEC_IKE_LOAD_FAILED","name":"ERROR_IPSEC_IKE_LOAD_FAILED","value":"13876_u32"},{"id":"ERROR_IPSEC_IKE_RPC_DELETE","name":"ERROR_IPSEC_IKE_RPC_DELETE","value":"13877_u32"},{"id":"ERROR_IPSEC_IKE_BENIGN_REINIT","name":"ERROR_IPSEC_IKE_BENIGN_REINIT","value":"13878_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_RESPONDER_LIFETIME_NOTIFY","name":"ERROR_IPSEC_IKE_INVALID_RESPONDER_LIFETIME_NOTIFY","value":"13879_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_CERT_KEYLEN","name":"ERROR_IPSEC_IKE_INVALID_CERT_KEYLEN","value":"13881_u32"},{"id":"ERROR_IPSEC_IKE_MM_LIMIT","name":"ERROR_IPSEC_IKE_MM_LIMIT","value":"13882_u32"},{"id":"ERROR_IPSEC_IKE_NEGOTIATION_DISABLED","name":"ERROR_IPSEC_IKE_NEGOTIATION_DISABLED","value":"13883_u32"},{"id":"ERROR_IPSEC_IKE_QM_LIMIT","name":"ERROR_IPSEC_IKE_QM_LIMIT","value":"13884_u32"},{"id":"ERROR_IPSEC_IKE_MM_EXPIRED","name":"ERROR_IPSEC_IKE_MM_EXPIRED","value":"13885_u32"},{"id":"ERROR_IPSEC_IKE_PEER_MM_ASSUMED_INVALID","name":"ERROR_IPSEC_IKE_PEER_MM_ASSUMED_INVALID","value":"13886_u32"},{"id":"ERROR_IPSEC_IKE_CERT_CHAIN_POLICY_MISMATCH","name":"ERROR_IPSEC_IKE_CERT_CHAIN_POLICY_MISMATCH","value":"13887_u32"},{"id":"ERROR_IPSEC_IKE_UNEXPECTED_MESSAGE_ID","name":"ERROR_IPSEC_IKE_UNEXPECTED_MESSAGE_ID","value":"13888_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_AUTH_PAYLOAD","name":"ERROR_IPSEC_IKE_INVALID_AUTH_PAYLOAD","value":"13889_u32"},{"id":"ERROR_IPSEC_IKE_DOS_COOKIE_SENT","name":"ERROR_IPSEC_IKE_DOS_COOKIE_SENT","value":"13890_u32"},{"id":"ERROR_IPSEC_IKE_SHUTTING_DOWN","name":"ERROR_IPSEC_IKE_SHUTTING_DOWN","value":"13891_u32"},{"id":"ERROR_IPSEC_IKE_CGA_AUTH_FAILED","name":"ERROR_IPSEC_IKE_CGA_AUTH_FAILED","value":"13892_u32"},{"id":"ERROR_IPSEC_IKE_PROCESS_ERR_NATOA","name":"ERROR_IPSEC_IKE_PROCESS_ERR_NATOA","value":"13893_u32"},{"id":"ERROR_IPSEC_IKE_INVALID_MM_FOR_QM","name":"ERROR_IPSEC_IKE_INVALID_MM_FOR_QM","value":"13894_u32"},{"id":"ERROR_IPSEC_IKE_QM_EXPIRED","name":"ERROR_IPSEC_IKE_QM_EXPIRED","value":"13895_u32"},{"id":"ERROR_IPSEC_IKE_TOO_MANY_FILTERS","name":"ERROR_IPSEC_IKE_TOO_MANY_FILTERS","value":"13896_u32"},{"id":"ERROR_IPSEC_IKE_NEG_STATUS_END","name":"ERROR_IPSEC_IKE_NEG_STATUS_END","value":"13897_u32"},{"id":"ERROR_IPSEC_IKE_KILL_DUMMY_NAP_TUNNEL","name":"ERROR_IPSEC_IKE_KILL_DUMMY_NAP_TUNNEL","value":"13898_u32"},{"id":"ERROR_IPSEC_IKE_INNER_IP_ASSIGNMENT_FAILURE","name":"ERROR_IPSEC_IKE_INNER_IP_ASSIGNMENT_FAILURE","value":"13899_u32"},{"id":"ERROR_IPSEC_IKE_REQUIRE_CP_PAYLOAD_MISSING","name":"ERROR_IPSEC_IKE_REQUIRE_CP_PAYLOAD_MISSING","value":"13900_u32"},{"id":"ERROR_IPSEC_KEY_MODULE_IMPERSONATION_NEGOTIATION_PENDING","name":"ERROR_IPSEC_KEY_MODULE_IMPERSONATION_NEGOTIATION_PENDING","value":"13901_u32"},{"id":"ERROR_IPSEC_IKE_COEXISTENCE_SUPPRESS","name":"ERROR_IPSEC_IKE_COEXISTENCE_SUPPRESS","value":"13902_u32"},{"id":"ERROR_IPSEC_IKE_RATELIMIT_DROP","name":"ERROR_IPSEC_IKE_RATELIMIT_DROP","value":"13903_u32"},{"id":"ERROR_IPSEC_IKE_PEER_DOESNT_SUPPORT_MOBIKE","name":"ERROR_IPSEC_IKE_PEER_DOESNT_SUPPORT_MOBIKE","value":"13904_u32"},{"id":"ERROR_IPSEC_IKE_AUTHORIZATION_FAILURE","name":"ERROR_IPSEC_IKE_AUTHORIZATION_FAILURE","value":"13905_u32"},{"id":"ERROR_IPSEC_IKE_STRONG_CRED_AUTHORIZATION_FAILURE","name":"ERROR_IPSEC_IKE_STRONG_CRED_AUTHORIZATION_FAILURE","value":"13906_u32"},{"id":"ERROR_IPSEC_IKE_AUTHORIZATION_FAILURE_WITH_OPTIONAL_RETRY","name":"ERROR_IPSEC_IKE_AUTHORIZATION_FAILURE_WITH_OPTIONAL_RETRY","value":"13907_u32"},{"id":"ERROR_IPSEC_IKE_STRONG_CRED_AUTHORIZATION_AND_CERTMAP_FAILURE","name":"ERROR_IPSEC_IKE_STRONG_CRED_AUTHORIZATION_AND_CERTMAP_FAILURE","value":"13908_u32"},{"id":"ERROR_IPSEC_IKE_NEG_STATUS_EXTENDED_END","name":"ERROR_IPSEC_IKE_NEG_STATUS_EXTENDED_END","value":"13909_u32"},{"id":"ERROR_IPSEC_BAD_SPI","name":"ERROR_IPSEC_BAD_SPI","value":"13910_u32"},{"id":"ERROR_IPSEC_SA_LIFETIME_EXPIRED","name":"ERROR_IPSEC_SA_LIFETIME_EXPIRED","value":"13911_u32"},{"id":"ERROR_IPSEC_WRONG_SA","name":"ERROR_IPSEC_WRONG_SA","value":"13912_u32"},{"id":"ERROR_IPSEC_REPLAY_CHECK_FAILED","name":"ERROR_IPSEC_REPLAY_CHECK_FAILED","value":"13913_u32"},{"id":"ERROR_IPSEC_INVALID_PACKET","name":"ERROR_IPSEC_INVALID_PACKET","value":"13914_u32"},{"id":"ERROR_IPSEC_INTEGRITY_CHECK_FAILED","name":"ERROR_IPSEC_INTEGRITY_CHECK_FAILED","value":"13915_u32"},{"id":"ERROR_IPSEC_CLEAR_TEXT_DROP","name":"ERROR_IPSEC_CLEAR_TEXT_DROP","value":"13916_u32"},{"id":"ERROR_IPSEC_AUTH_FIREWALL_DROP","name":"ERROR_IPSEC_AUTH_FIREWALL_DROP","value":"13917_u32"},{"id":"ERROR_IPSEC_THROTTLE_DROP","name":"ERROR_IPSEC_THROTTLE_DROP","value":"13918_u32"},{"id":"ERROR_IPSEC_DOSP_BLOCK","name":"ERROR_IPSEC_DOSP_BLOCK","value":"13925_u32"},{"id":"ERROR_IPSEC_DOSP_RECEIVED_MULTICAST","name":"ERROR_IPSEC_DOSP_RECEIVED_MULTICAST","value":"13926_u32"},{"id":"ERROR_IPSEC_DOSP_INVALID_PACKET","name":"ERROR_IPSEC_DOSP_INVALID_PACKET","value":"13927_u32"},{"id":"ERROR_IPSEC_DOSP_STATE_LOOKUP_FAILED","name":"ERROR_IPSEC_DOSP_STATE_LOOKUP_FAILED","value":"13928_u32"},{"id":"ERROR_IPSEC_DOSP_MAX_ENTRIES","name":"ERROR_IPSEC_DOSP_MAX_ENTRIES","value":"13929_u32"},{"id":"ERROR_IPSEC_DOSP_KEYMOD_NOT_ALLOWED","name":"ERROR_IPSEC_DOSP_KEYMOD_NOT_ALLOWED","value":"13930_u32"},{"id":"ERROR_IPSEC_DOSP_NOT_INSTALLED","name":"ERROR_IPSEC_DOSP_NOT_INSTALLED","value":"13931_u32"},{"id":"ERROR_IPSEC_DOSP_MAX_PER_IP_RATELIMIT_QUEUES","name":"ERROR_IPSEC_DOSP_MAX_PER_IP_RATELIMIT_QUEUES","value":"13932_u32"},{"id":"ERROR_EVT_INVALID_CHANNEL_PATH","name":"ERROR_EVT_INVALID_CHANNEL_PATH","value":"15000_u32"},{"id":"ERROR_EVT_INVALID_QUERY","name":"ERROR_EVT_INVALID_QUERY","value":"15001_u32"},{"id":"ERROR_EVT_PUBLISHER_METADATA_NOT_FOUND","name":"ERROR_EVT_PUBLISHER_METADATA_NOT_FOUND","value":"15002_u32"},{"id":"ERROR_EVT_EVENT_TEMPLATE_NOT_FOUND","name":"ERROR_EVT_EVENT_TEMPLATE_NOT_FOUND","value":"15003_u32"},{"id":"ERROR_EVT_INVALID_PUBLISHER_NAME","name":"ERROR_EVT_INVALID_PUBLISHER_NAME","value":"15004_u32"},{"id":"ERROR_EVT_INVALID_EVENT_DATA","name":"ERROR_EVT_INVALID_EVENT_DATA","value":"15005_u32"},{"id":"ERROR_EVT_CHANNEL_NOT_FOUND","name":"ERROR_EVT_CHANNEL_NOT_FOUND","value":"15007_u32"},{"id":"ERROR_EVT_MALFORMED_XML_TEXT","name":"ERROR_EVT_MALFORMED_XML_TEXT","value":"15008_u32"},{"id":"ERROR_EVT_SUBSCRIPTION_TO_DIRECT_CHANNEL","name":"ERROR_EVT_SUBSCRIPTION_TO_DIRECT_CHANNEL","value":"15009_u32"},{"id":"ERROR_EVT_CONFIGURATION_ERROR","name":"ERROR_EVT_CONFIGURATION_ERROR","value":"15010_u32"},{"id":"ERROR_EVT_QUERY_RESULT_STALE","name":"ERROR_EVT_QUERY_RESULT_STALE","value":"15011_u32"},{"id":"ERROR_EVT_QUERY_RESULT_INVALID_POSITION","name":"ERROR_EVT_QUERY_RESULT_INVALID_POSITION","value":"15012_u32"},{"id":"ERROR_EVT_NON_VALIDATING_MSXML","name":"ERROR_EVT_NON_VALIDATING_MSXML","value":"15013_u32"},{"id":"ERROR_EVT_FILTER_ALREADYSCOPED","name":"ERROR_EVT_FILTER_ALREADYSCOPED","value":"15014_u32"},{"id":"ERROR_EVT_FILTER_NOTELTSET","name":"ERROR_EVT_FILTER_NOTELTSET","value":"15015_u32"},{"id":"ERROR_EVT_FILTER_INVARG","name":"ERROR_EVT_FILTER_INVARG","value":"15016_u32"},{"id":"ERROR_EVT_FILTER_INVTEST","name":"ERROR_EVT_FILTER_INVTEST","value":"15017_u32"},{"id":"ERROR_EVT_FILTER_INVTYPE","name":"ERROR_EVT_FILTER_INVTYPE","value":"15018_u32"},{"id":"ERROR_EVT_FILTER_PARSEERR","name":"ERROR_EVT_FILTER_PARSEERR","value":"15019_u32"},{"id":"ERROR_EVT_FILTER_UNSUPPORTEDOP","name":"ERROR_EVT_FILTER_UNSUPPORTEDOP","value":"15020_u32"},{"id":"ERROR_EVT_FILTER_UNEXPECTEDTOKEN","name":"ERROR_EVT_FILTER_UNEXPECTEDTOKEN","value":"15021_u32"},{"id":"ERROR_EVT_INVALID_OPERATION_OVER_ENABLED_DIRECT_CHANNEL","name":"ERROR_EVT_INVALID_OPERATION_OVER_ENABLED_DIRECT_CHANNEL","value":"15022_u32"},{"id":"ERROR_EVT_INVALID_CHANNEL_PROPERTY_VALUE","name":"ERROR_EVT_INVALID_CHANNEL_PROPERTY_VALUE","value":"15023_u32"},{"id":"ERROR_EVT_INVALID_PUBLISHER_PROPERTY_VALUE","name":"ERROR_EVT_INVALID_PUBLISHER_PROPERTY_VALUE","value":"15024_u32"},{"id":"ERROR_EVT_CHANNEL_CANNOT_ACTIVATE","name":"ERROR_EVT_CHANNEL_CANNOT_ACTIVATE","value":"15025_u32"},{"id":"ERROR_EVT_FILTER_TOO_COMPLEX","name":"ERROR_EVT_FILTER_TOO_COMPLEX","value":"15026_u32"},{"id":"ERROR_EVT_MESSAGE_NOT_FOUND","name":"ERROR_EVT_MESSAGE_NOT_FOUND","value":"15027_u32"},{"id":"ERROR_EVT_MESSAGE_ID_NOT_FOUND","name":"ERROR_EVT_MESSAGE_ID_NOT_FOUND","value":"15028_u32"},{"id":"ERROR_EVT_UNRESOLVED_VALUE_INSERT","name":"ERROR_EVT_UNRESOLVED_VALUE_INSERT","value":"15029_u32"},{"id":"ERROR_EVT_UNRESOLVED_PARAMETER_INSERT","name":"ERROR_EVT_UNRESOLVED_PARAMETER_INSERT","value":"15030_u32"},{"id":"ERROR_EVT_MAX_INSERTS_REACHED","name":"ERROR_EVT_MAX_INSERTS_REACHED","value":"15031_u32"},{"id":"ERROR_EVT_EVENT_DEFINITION_NOT_FOUND","name":"ERROR_EVT_EVENT_DEFINITION_NOT_FOUND","value":"15032_u32"},{"id":"ERROR_EVT_MESSAGE_LOCALE_NOT_FOUND","name":"ERROR_EVT_MESSAGE_LOCALE_NOT_FOUND","value":"15033_u32"},{"id":"ERROR_EVT_VERSION_TOO_OLD","name":"ERROR_EVT_VERSION_TOO_OLD","value":"15034_u32"},{"id":"ERROR_EVT_VERSION_TOO_NEW","name":"ERROR_EVT_VERSION_TOO_NEW","value":"15035_u32"},{"id":"ERROR_EVT_CANNOT_OPEN_CHANNEL_OF_QUERY","name":"ERROR_EVT_CANNOT_OPEN_CHANNEL_OF_QUERY","value":"15036_u32"},{"id":"ERROR_EVT_PUBLISHER_DISABLED","name":"ERROR_EVT_PUBLISHER_DISABLED","value":"15037_u32"},{"id":"ERROR_EVT_FILTER_OUT_OF_RANGE","name":"ERROR_EVT_FILTER_OUT_OF_RANGE","value":"15038_u32"},{"id":"ERROR_EC_SUBSCRIPTION_CANNOT_ACTIVATE","name":"ERROR_EC_SUBSCRIPTION_CANNOT_ACTIVATE","value":"15080_u32"},{"id":"ERROR_EC_LOG_DISABLED","name":"ERROR_EC_LOG_DISABLED","value":"15081_u32"},{"id":"ERROR_EC_CIRCULAR_FORWARDING","name":"ERROR_EC_CIRCULAR_FORWARDING","value":"15082_u32"},{"id":"ERROR_EC_CREDSTORE_FULL","name":"ERROR_EC_CREDSTORE_FULL","value":"15083_u32"},{"id":"ERROR_EC_CRED_NOT_FOUND","name":"ERROR_EC_CRED_NOT_FOUND","value":"15084_u32"},{"id":"ERROR_EC_NO_ACTIVE_CHANNEL","name":"ERROR_EC_NO_ACTIVE_CHANNEL","value":"15085_u32"},{"id":"ERROR_MUI_FILE_NOT_FOUND","name":"ERROR_MUI_FILE_NOT_FOUND","value":"15100_u32"},{"id":"ERROR_MUI_INVALID_FILE","name":"ERROR_MUI_INVALID_FILE","value":"15101_u32"},{"id":"ERROR_MUI_INVALID_RC_CONFIG","name":"ERROR_MUI_INVALID_RC_CONFIG","value":"15102_u32"},{"id":"ERROR_MUI_INVALID_LOCALE_NAME","name":"ERROR_MUI_INVALID_LOCALE_NAME","value":"15103_u32"},{"id":"ERROR_MUI_INVALID_ULTIMATEFALLBACK_NAME","name":"ERROR_MUI_INVALID_ULTIMATEFALLBACK_NAME","value":"15104_u32"},{"id":"ERROR_MUI_FILE_NOT_LOADED","name":"ERROR_MUI_FILE_NOT_LOADED","value":"15105_u32"},{"id":"ERROR_RESOURCE_ENUM_USER_STOP","name":"ERROR_RESOURCE_ENUM_USER_STOP","value":"15106_u32"},{"id":"ERROR_MUI_INTLSETTINGS_UILANG_NOT_INSTALLED","name":"ERROR_MUI_INTLSETTINGS_UILANG_NOT_INSTALLED","value":"15107_u32"},{"id":"ERROR_MUI_INTLSETTINGS_INVALID_LOCALE_NAME","name":"ERROR_MUI_INTLSETTINGS_INVALID_LOCALE_NAME","value":"15108_u32"},{"id":"ERROR_MRM_RUNTIME_NO_DEFAULT_OR_NEUTRAL_RESOURCE","name":"ERROR_MRM_RUNTIME_NO_DEFAULT_OR_NEUTRAL_RESOURCE","value":"15110_u32"},{"id":"ERROR_MRM_INVALID_PRICONFIG","name":"ERROR_MRM_INVALID_PRICONFIG","value":"15111_u32"},{"id":"ERROR_MRM_INVALID_FILE_TYPE","name":"ERROR_MRM_INVALID_FILE_TYPE","value":"15112_u32"},{"id":"ERROR_MRM_UNKNOWN_QUALIFIER","name":"ERROR_MRM_UNKNOWN_QUALIFIER","value":"15113_u32"},{"id":"ERROR_MRM_INVALID_QUALIFIER_VALUE","name":"ERROR_MRM_INVALID_QUALIFIER_VALUE","value":"15114_u32"},{"id":"ERROR_MRM_NO_CANDIDATE","name":"ERROR_MRM_NO_CANDIDATE","value":"15115_u32"},{"id":"ERROR_MRM_NO_MATCH_OR_DEFAULT_CANDIDATE","name":"ERROR_MRM_NO_MATCH_OR_DEFAULT_CANDIDATE","value":"15116_u32"},{"id":"ERROR_MRM_RESOURCE_TYPE_MISMATCH","name":"ERROR_MRM_RESOURCE_TYPE_MISMATCH","value":"15117_u32"},{"id":"ERROR_MRM_DUPLICATE_MAP_NAME","name":"ERROR_MRM_DUPLICATE_MAP_NAME","value":"15118_u32"},{"id":"ERROR_MRM_DUPLICATE_ENTRY","name":"ERROR_MRM_DUPLICATE_ENTRY","value":"15119_u32"},{"id":"ERROR_MRM_INVALID_RESOURCE_IDENTIFIER","name":"ERROR_MRM_INVALID_RESOURCE_IDENTIFIER","value":"15120_u32"},{"id":"ERROR_MRM_FILEPATH_TOO_LONG","name":"ERROR_MRM_FILEPATH_TOO_LONG","value":"15121_u32"},{"id":"ERROR_MRM_UNSUPPORTED_DIRECTORY_TYPE","name":"ERROR_MRM_UNSUPPORTED_DIRECTORY_TYPE","value":"15122_u32"},{"id":"ERROR_MRM_INVALID_PRI_FILE","name":"ERROR_MRM_INVALID_PRI_FILE","value":"15126_u32"},{"id":"ERROR_MRM_NAMED_RESOURCE_NOT_FOUND","name":"ERROR_MRM_NAMED_RESOURCE_NOT_FOUND","value":"15127_u32"},{"id":"ERROR_MRM_MAP_NOT_FOUND","name":"ERROR_MRM_MAP_NOT_FOUND","value":"15135_u32"},{"id":"ERROR_MRM_UNSUPPORTED_PROFILE_TYPE","name":"ERROR_MRM_UNSUPPORTED_PROFILE_TYPE","value":"15136_u32"},{"id":"ERROR_MRM_INVALID_QUALIFIER_OPERATOR","name":"ERROR_MRM_INVALID_QUALIFIER_OPERATOR","value":"15137_u32"},{"id":"ERROR_MRM_INDETERMINATE_QUALIFIER_VALUE","name":"ERROR_MRM_INDETERMINATE_QUALIFIER_VALUE","value":"15138_u32"},{"id":"ERROR_MRM_AUTOMERGE_ENABLED","name":"ERROR_MRM_AUTOMERGE_ENABLED","value":"15139_u32"},{"id":"ERROR_MRM_TOO_MANY_RESOURCES","name":"ERROR_MRM_TOO_MANY_RESOURCES","value":"15140_u32"},{"id":"ERROR_MCA_INVALID_CAPABILITIES_STRING","name":"ERROR_MCA_INVALID_CAPABILITIES_STRING","value":"15200_u32"},{"id":"ERROR_MCA_INVALID_VCP_VERSION","name":"ERROR_MCA_INVALID_VCP_VERSION","value":"15201_u32"},{"id":"ERROR_MCA_MONITOR_VIOLATES_MCCS_SPECIFICATION","name":"ERROR_MCA_MONITOR_VIOLATES_MCCS_SPECIFICATION","value":"15202_u32"},{"id":"ERROR_MCA_MCCS_VERSION_MISMATCH","name":"ERROR_MCA_MCCS_VERSION_MISMATCH","value":"15203_u32"},{"id":"ERROR_MCA_UNSUPPORTED_MCCS_VERSION","name":"ERROR_MCA_UNSUPPORTED_MCCS_VERSION","value":"15204_u32"},{"id":"ERROR_MCA_INTERNAL_ERROR","name":"ERROR_MCA_INTERNAL_ERROR","value":"15205_u32"},{"id":"ERROR_MCA_INVALID_TECHNOLOGY_TYPE_RETURNED","name":"ERROR_MCA_INVALID_TECHNOLOGY_TYPE_RETURNED","value":"15206_u32"},{"id":"ERROR_MCA_UNSUPPORTED_COLOR_TEMPERATURE","name":"ERROR_MCA_UNSUPPORTED_COLOR_TEMPERATURE","value":"15207_u32"},{"id":"ERROR_AMBIGUOUS_SYSTEM_DEVICE","name":"ERROR_AMBIGUOUS_SYSTEM_DEVICE","value":"15250_u32"},{"id":"ERROR_SYSTEM_DEVICE_NOT_FOUND","name":"ERROR_SYSTEM_DEVICE_NOT_FOUND","value":"15299_u32"},{"id":"ERROR_HASH_NOT_SUPPORTED","name":"ERROR_HASH_NOT_SUPPORTED","value":"15300_u32"},{"id":"ERROR_HASH_NOT_PRESENT","name":"ERROR_HASH_NOT_PRESENT","value":"15301_u32"},{"id":"ERROR_SECONDARY_IC_PROVIDER_NOT_REGISTERED","name":"ERROR_SECONDARY_IC_PROVIDER_NOT_REGISTERED","value":"15321_u32"},{"id":"ERROR_GPIO_CLIENT_INFORMATION_INVALID","name":"ERROR_GPIO_CLIENT_INFORMATION_INVALID","value":"15322_u32"},{"id":"ERROR_GPIO_VERSION_NOT_SUPPORTED","name":"ERROR_GPIO_VERSION_NOT_SUPPORTED","value":"15323_u32"},{"id":"ERROR_GPIO_INVALID_REGISTRATION_PACKET","name":"ERROR_GPIO_INVALID_REGISTRATION_PACKET","value":"15324_u32"},{"id":"ERROR_GPIO_OPERATION_DENIED","name":"ERROR_GPIO_OPERATION_DENIED","value":"15325_u32"},{"id":"ERROR_GPIO_INCOMPATIBLE_CONNECT_MODE","name":"ERROR_GPIO_INCOMPATIBLE_CONNECT_MODE","value":"15326_u32"},{"id":"ERROR_GPIO_INTERRUPT_ALREADY_UNMASKED","name":"ERROR_GPIO_INTERRUPT_ALREADY_UNMASKED","value":"15327_u32"},{"id":"ERROR_CANNOT_SWITCH_RUNLEVEL","name":"ERROR_CANNOT_SWITCH_RUNLEVEL","value":"15400_u32"},{"id":"ERROR_INVALID_RUNLEVEL_SETTING","name":"ERROR_INVALID_RUNLEVEL_SETTING","value":"15401_u32"},{"id":"ERROR_RUNLEVEL_SWITCH_TIMEOUT","name":"ERROR_RUNLEVEL_SWITCH_TIMEOUT","value":"15402_u32"},{"id":"ERROR_RUNLEVEL_SWITCH_AGENT_TIMEOUT","name":"ERROR_RUNLEVEL_SWITCH_AGENT_TIMEOUT","value":"15403_u32"},{"id":"ERROR_RUNLEVEL_SWITCH_IN_PROGRESS","name":"ERROR_RUNLEVEL_SWITCH_IN_PROGRESS","value":"15404_u32"},{"id":"ERROR_SERVICES_FAILED_AUTOSTART","name":"ERROR_SERVICES_FAILED_AUTOSTART","value":"15405_u32"},{"id":"ERROR_COM_TASK_STOP_PENDING","name":"ERROR_COM_TASK_STOP_PENDING","value":"15501_u32"},{"id":"ERROR_INSTALL_OPEN_PACKAGE_FAILED","name":"ERROR_INSTALL_OPEN_PACKAGE_FAILED","value":"15600_u32"},{"id":"ERROR_INSTALL_PACKAGE_NOT_FOUND","name":"ERROR_INSTALL_PACKAGE_NOT_FOUND","value":"15601_u32"},{"id":"ERROR_INSTALL_INVALID_PACKAGE","name":"ERROR_INSTALL_INVALID_PACKAGE","value":"15602_u32"},{"id":"ERROR_INSTALL_RESOLVE_DEPENDENCY_FAILED","name":"ERROR_INSTALL_RESOLVE_DEPENDENCY_FAILED","value":"15603_u32"},{"id":"ERROR_INSTALL_OUT_OF_DISK_SPACE","name":"ERROR_INSTALL_OUT_OF_DISK_SPACE","value":"15604_u32"},{"id":"ERROR_INSTALL_NETWORK_FAILURE","name":"ERROR_INSTALL_NETWORK_FAILURE","value":"15605_u32"},{"id":"ERROR_INSTALL_REGISTRATION_FAILURE","name":"ERROR_INSTALL_REGISTRATION_FAILURE","value":"15606_u32"},{"id":"ERROR_INSTALL_DEREGISTRATION_FAILURE","name":"ERROR_INSTALL_DEREGISTRATION_FAILURE","value":"15607_u32"},{"id":"ERROR_INSTALL_CANCEL","name":"ERROR_INSTALL_CANCEL","value":"15608_u32"},{"id":"ERROR_INSTALL_FAILED","name":"ERROR_INSTALL_FAILED","value":"15609_u32"},{"id":"ERROR_REMOVE_FAILED","name":"ERROR_REMOVE_FAILED","value":"15610_u32"},{"id":"ERROR_PACKAGE_ALREADY_EXISTS","name":"ERROR_PACKAGE_ALREADY_EXISTS","value":"15611_u32"},{"id":"ERROR_NEEDS_REMEDIATION","name":"ERROR_NEEDS_REMEDIATION","value":"15612_u32"},{"id":"ERROR_INSTALL_PREREQUISITE_FAILED","name":"ERROR_INSTALL_PREREQUISITE_FAILED","value":"15613_u32"},{"id":"ERROR_PACKAGE_REPOSITORY_CORRUPTED","name":"ERROR_PACKAGE_REPOSITORY_CORRUPTED","value":"15614_u32"},{"id":"ERROR_INSTALL_POLICY_FAILURE","name":"ERROR_INSTALL_POLICY_FAILURE","value":"15615_u32"},{"id":"ERROR_PACKAGE_UPDATING","name":"ERROR_PACKAGE_UPDATING","value":"15616_u32"},{"id":"ERROR_DEPLOYMENT_BLOCKED_BY_POLICY","name":"ERROR_DEPLOYMENT_BLOCKED_BY_POLICY","value":"15617_u32"},{"id":"ERROR_PACKAGES_IN_USE","name":"ERROR_PACKAGES_IN_USE","value":"15618_u32"},{"id":"ERROR_RECOVERY_FILE_CORRUPT","name":"ERROR_RECOVERY_FILE_CORRUPT","value":"15619_u32"},{"id":"ERROR_INVALID_STAGED_SIGNATURE","name":"ERROR_INVALID_STAGED_SIGNATURE","value":"15620_u32"},{"id":"ERROR_DELETING_EXISTING_APPLICATIONDATA_STORE_FAILED","name":"ERROR_DELETING_EXISTING_APPLICATIONDATA_STORE_FAILED","value":"15621_u32"},{"id":"ERROR_INSTALL_PACKAGE_DOWNGRADE","name":"ERROR_INSTALL_PACKAGE_DOWNGRADE","value":"15622_u32"},{"id":"ERROR_SYSTEM_NEEDS_REMEDIATION","name":"ERROR_SYSTEM_NEEDS_REMEDIATION","value":"15623_u32"},{"id":"ERROR_APPX_INTEGRITY_FAILURE_CLR_NGEN","name":"ERROR_APPX_INTEGRITY_FAILURE_CLR_NGEN","value":"15624_u32"},{"id":"ERROR_RESILIENCY_FILE_CORRUPT","name":"ERROR_RESILIENCY_FILE_CORRUPT","value":"15625_u32"},{"id":"ERROR_INSTALL_FIREWALL_SERVICE_NOT_RUNNING","name":"ERROR_INSTALL_FIREWALL_SERVICE_NOT_RUNNING","value":"15626_u32"},{"id":"APPMODEL_ERROR_NO_PACKAGE","name":"APPMODEL_ERROR_NO_PACKAGE","value":"15700_u32"},{"id":"APPMODEL_ERROR_PACKAGE_RUNTIME_CORRUPT","name":"APPMODEL_ERROR_PACKAGE_RUNTIME_CORRUPT","value":"15701_u32"},{"id":"APPMODEL_ERROR_PACKAGE_IDENTITY_CORRUPT","name":"APPMODEL_ERROR_PACKAGE_IDENTITY_CORRUPT","value":"15702_u32"},{"id":"APPMODEL_ERROR_NO_APPLICATION","name":"APPMODEL_ERROR_NO_APPLICATION","value":"15703_u32"},{"id":"ERROR_STATE_LOAD_STORE_FAILED","name":"ERROR_STATE_LOAD_STORE_FAILED","value":"15800_u32"},{"id":"ERROR_STATE_GET_VERSION_FAILED","name":"ERROR_STATE_GET_VERSION_FAILED","value":"15801_u32"},{"id":"ERROR_STATE_SET_VERSION_FAILED","name":"ERROR_STATE_SET_VERSION_FAILED","value":"15802_u32"},{"id":"ERROR_STATE_STRUCTURED_RESET_FAILED","name":"ERROR_STATE_STRUCTURED_RESET_FAILED","value":"15803_u32"},{"id":"ERROR_STATE_OPEN_CONTAINER_FAILED","name":"ERROR_STATE_OPEN_CONTAINER_FAILED","value":"15804_u32"},{"id":"ERROR_STATE_CREATE_CONTAINER_FAILED","name":"ERROR_STATE_CREATE_CONTAINER_FAILED","value":"15805_u32"},{"id":"ERROR_STATE_DELETE_CONTAINER_FAILED","name":"ERROR_STATE_DELETE_CONTAINER_FAILED","value":"15806_u32"},{"id":"ERROR_STATE_READ_SETTING_FAILED","name":"ERROR_STATE_READ_SETTING_FAILED","value":"15807_u32"},{"id":"ERROR_STATE_WRITE_SETTING_FAILED","name":"ERROR_STATE_WRITE_SETTING_FAILED","value":"15808_u32"},{"id":"ERROR_STATE_DELETE_SETTING_FAILED","name":"ERROR_STATE_DELETE_SETTING_FAILED","value":"15809_u32"},{"id":"ERROR_STATE_QUERY_SETTING_FAILED","name":"ERROR_STATE_QUERY_SETTING_FAILED","value":"15810_u32"},{"id":"ERROR_STATE_READ_COMPOSITE_SETTING_FAILED","name":"ERROR_STATE_READ_COMPOSITE_SETTING_FAILED","value":"15811_u32"},{"id":"ERROR_STATE_WRITE_COMPOSITE_SETTING_FAILED","name":"ERROR_STATE_WRITE_COMPOSITE_SETTING_FAILED","value":"15812_u32"},{"id":"ERROR_STATE_ENUMERATE_CONTAINER_FAILED","name":"ERROR_STATE_ENUMERATE_CONTAINER_FAILED","value":"15813_u32"},{"id":"ERROR_STATE_ENUMERATE_SETTINGS_FAILED","name":"ERROR_STATE_ENUMERATE_SETTINGS_FAILED","value":"15814_u32"},{"id":"ERROR_STATE_COMPOSITE_SETTING_VALUE_SIZE_LIMIT_EXCEEDED","name":"ERROR_STATE_COMPOSITE_SETTING_VALUE_SIZE_LIMIT_EXCEEDED","value":"15815_u32"},{"id":"ERROR_STATE_SETTING_VALUE_SIZE_LIMIT_EXCEEDED","name":"ERROR_STATE_SETTING_VALUE_SIZE_LIMIT_EXCEEDED","value":"15816_u32"},{"id":"ERROR_STATE_SETTING_NAME_SIZE_LIMIT_EXCEEDED","name":"ERROR_STATE_SETTING_NAME_SIZE_LIMIT_EXCEEDED","value":"15817_u32"},{"id":"ERROR_STATE_CONTAINER_NAME_SIZE_LIMIT_EXCEEDED","name":"ERROR_STATE_CONTAINER_NAME_SIZE_LIMIT_EXCEEDED","value":"15818_u32"},{"id":"ERROR_API_UNAVAILABLE","name":"ERROR_API_UNAVAILABLE","value":"15841_u32"},{"id":"WSA_IO_PENDING","name":"WSA_IO_PENDING","value":"997_u32"},{"id":"WSA_IO_INCOMPLETE","name":"WSA_IO_INCOMPLETE","value":"996_u32"}],"doc":"`WinError` represents Windows' [System Error Codes](https://docs.microsoft.com/en-us/windows/win32/debug/system-error-codes#system-error-codes-1).","summary":"<p><code><a href=\"WinError.html\">WinError</a></code> represents Windows' <a href=\"https://docs.microsoft.com/en-us/windows/win32/debug/system-error-codes#system-error-codes-1\">System Error Codes</a>.</p>","class_methods":[{"html_id":"value=(winerror:self)-class-method","name":"value=","doc":"Sets the value of [`SetLastError`](https://docs.microsoft.com/en-us/windows/win32/api/errhandlingapi/nf-errhandlingapi-setlasterror)\nwhich signifies the error code of the previously called win32 function.\n\nRaises `NotImplementedError` on non-win32 platforms.","summary":"<p>Sets the value of <a href=\"https://docs.microsoft.com/en-us/windows/win32/api/errhandlingapi/nf-errhandlingapi-setlasterror\"><code>SetLastError</code></a> which signifies the error code of the previously called win32 function.</p>","abstract":false,"args":[{"name":"winerror","external_name":"winerror","restriction":"self"}],"args_string":"(winerror : self)","args_html":"(winerror : <span class=\"k\">self</span>)","location":{"filename":"src/winerror.cr","line_number":25,"url":null},"def":{"name":"value=","args":[{"name":"winerror","external_name":"winerror","restriction":"self"}],"visibility":"Public","body":"{% if flag?(:win32) %}\n      LibC.SetLastError(winerror.value)\n    {% else %}\n      raise NotImplementedError.new(\"WinError.value=\")\n    {% end %}"}},{"html_id":"wsa_value-class-method","name":"wsa_value","doc":"Returns the value of [`WSAGetLastError`](https://docs.microsoft.com/en-us/windows/win32/api/winsock2/nf-winsock2-wsagetlasterror)\nwhich is used to retrieve the error code of the previously called Windows Socket API function.\n\nRaises `NotImplementedError` on non-win32 platforms.","summary":"<p>Returns the value of <a href=\"https://docs.microsoft.com/en-us/windows/win32/api/winsock2/nf-winsock2-wsagetlasterror\"><code>WSAGetLastError</code></a> which is used to retrieve the error code of the previously called Windows Socket API function.</p>","abstract":false,"location":{"filename":"src/winerror.cr","line_number":37,"url":null},"def":{"name":"wsa_value","visibility":"Public","body":"{% if flag?(:win32) %}\n      WinError.new LibC.WSAGetLastError.to_u32!\n    {% else %}\n      raise NotImplementedError.new(\"WinError.wsa_value\")\n    {% end %}"}},{"html_id":"wsa_value=(winerror:self)-class-method","name":"wsa_value=","doc":"Sets the value of [`WSASetLastError`](https://docs.microsoft.com/en-us/windows/win32/api/winsock2/nf-winsock2-wsasetlasterror)\nwhich signifies the error code of the previously called Windows Socket API function.\n\nRaises `NotImplementedError` on non-win32 platforms.","summary":"<p>Sets the value of <a href=\"https://docs.microsoft.com/en-us/windows/win32/api/winsock2/nf-winsock2-wsasetlasterror\"><code>WSASetLastError</code></a> which signifies the error code of the previously called Windows Socket API function.</p>","abstract":false,"args":[{"name":"winerror","external_name":"winerror","restriction":"self"}],"args_string":"(winerror : self)","args_html":"(winerror : <span class=\"k\">self</span>)","location":{"filename":"src/winerror.cr","line_number":49,"url":null},"def":{"name":"wsa_value=","args":[{"name":"winerror","external_name":"winerror","restriction":"self"}],"visibility":"Public","body":"{% if flag?(:win32) %}\n      LibC.WSASetLastError(winerror.value)\n    {% else %}\n      raise NotImplementedError.new(\"WinError.value=\")\n    {% end %}"}}],"constructors":[{"html_id":"value:self-class-method","name":"value","doc":"Returns the value of [`GetLastError`](https://docs.microsoft.com/en-us/windows/win32/api/errhandlingapi/nf-errhandlingapi-getlasterror)\nwhich is used to retrieve the error code of the previously called win32 function.\n\nRaises `NotImplementedError` on non-win32 platforms.","summary":"<p>Returns the value of <a href=\"https://docs.microsoft.com/en-us/windows/win32/api/errhandlingapi/nf-errhandlingapi-getlasterror\"><code>GetLastError</code></a> which is used to retrieve the error code of the previously called win32 function.</p>","abstract":false,"location":{"filename":"src/winerror.cr","line_number":13,"url":null},"def":{"name":"value","return_type":"self","visibility":"Public","body":"{% if flag?(:win32) %}\n      WinError.new LibC.GetLastError\n    {% else %}\n      raise NotImplementedError.new(\"WinError.value\")\n    {% end %}"}}],"instance_methods":[{"html_id":"appmodel_error_no_application?-instance-method","name":"appmodel_error_no_application?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2223,"url":null},"def":{"name":"appmodel_error_no_application?","visibility":"Public","body":"self == APPMODEL_ERROR_NO_APPLICATION"}},{"html_id":"appmodel_error_no_package?-instance-method","name":"appmodel_error_no_package?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2220,"url":null},"def":{"name":"appmodel_error_no_package?","visibility":"Public","body":"self == APPMODEL_ERROR_NO_PACKAGE"}},{"html_id":"appmodel_error_package_identity_corrupt?-instance-method","name":"appmodel_error_package_identity_corrupt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2222,"url":null},"def":{"name":"appmodel_error_package_identity_corrupt?","visibility":"Public","body":"self == APPMODEL_ERROR_PACKAGE_IDENTITY_CORRUPT"}},{"html_id":"appmodel_error_package_runtime_corrupt?-instance-method","name":"appmodel_error_package_runtime_corrupt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2221,"url":null},"def":{"name":"appmodel_error_package_runtime_corrupt?","visibility":"Public","body":"self == APPMODEL_ERROR_PACKAGE_RUNTIME_CORRUPT"}},{"html_id":"dns_error_autozone_already_exists?-instance-method","name":"dns_error_autozone_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1687,"url":null},"def":{"name":"dns_error_autozone_already_exists?","visibility":"Public","body":"self == DNS_ERROR_AUTOZONE_ALREADY_EXISTS"}},{"html_id":"dns_error_axfr?-instance-method","name":"dns_error_axfr?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1727,"url":null},"def":{"name":"dns_error_axfr?","visibility":"Public","body":"self == DNS_ERROR_AXFR"}},{"html_id":"dns_error_bad_packet?-instance-method","name":"dns_error_bad_packet?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1653,"url":null},"def":{"name":"dns_error_bad_packet?","visibility":"Public","body":"self == DNS_ERROR_BAD_PACKET"}},{"html_id":"dns_error_cannot_find_root_hints?-instance-method","name":"dns_error_cannot_find_root_hints?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1675,"url":null},"def":{"name":"dns_error_cannot_find_root_hints?","visibility":"Public","body":"self == DNS_ERROR_CANNOT_FIND_ROOT_HINTS"}},{"html_id":"dns_error_cname_collision?-instance-method","name":"dns_error_cname_collision?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1714,"url":null},"def":{"name":"dns_error_cname_collision?","visibility":"Public","body":"self == DNS_ERROR_CNAME_COLLISION"}},{"html_id":"dns_error_cname_loop?-instance-method","name":"dns_error_cname_loop?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1712,"url":null},"def":{"name":"dns_error_cname_loop?","visibility":"Public","body":"self == DNS_ERROR_CNAME_LOOP"}},{"html_id":"dns_error_database_base?-instance-method","name":"dns_error_database_base?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1705,"url":null},"def":{"name":"dns_error_database_base?","visibility":"Public","body":"self == DNS_ERROR_DATABASE_BASE"}},{"html_id":"dns_error_datafile_base?-instance-method","name":"dns_error_datafile_base?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1699,"url":null},"def":{"name":"dns_error_datafile_base?","visibility":"Public","body":"self == DNS_ERROR_DATAFILE_BASE"}},{"html_id":"dns_error_datafile_open_failure?-instance-method","name":"dns_error_datafile_open_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1702,"url":null},"def":{"name":"dns_error_datafile_open_failure?","visibility":"Public","body":"self == DNS_ERROR_DATAFILE_OPEN_FAILURE"}},{"html_id":"dns_error_datafile_parsing?-instance-method","name":"dns_error_datafile_parsing?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1704,"url":null},"def":{"name":"dns_error_datafile_parsing?","visibility":"Public","body":"self == DNS_ERROR_DATAFILE_PARSING"}},{"html_id":"dns_error_dp_already_enlisted?-instance-method","name":"dns_error_dp_already_enlisted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1738,"url":null},"def":{"name":"dns_error_dp_already_enlisted?","visibility":"Public","body":"self == DNS_ERROR_DP_ALREADY_ENLISTED"}},{"html_id":"dns_error_dp_already_exists?-instance-method","name":"dns_error_dp_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1736,"url":null},"def":{"name":"dns_error_dp_already_exists?","visibility":"Public","body":"self == DNS_ERROR_DP_ALREADY_EXISTS"}},{"html_id":"dns_error_dp_base?-instance-method","name":"dns_error_dp_base?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1734,"url":null},"def":{"name":"dns_error_dp_base?","visibility":"Public","body":"self == DNS_ERROR_DP_BASE"}},{"html_id":"dns_error_dp_does_not_exist?-instance-method","name":"dns_error_dp_does_not_exist?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1735,"url":null},"def":{"name":"dns_error_dp_does_not_exist?","visibility":"Public","body":"self == DNS_ERROR_DP_DOES_NOT_EXIST"}},{"html_id":"dns_error_dp_fsmo_error?-instance-method","name":"dns_error_dp_fsmo_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1740,"url":null},"def":{"name":"dns_error_dp_fsmo_error?","visibility":"Public","body":"self == DNS_ERROR_DP_FSMO_ERROR"}},{"html_id":"dns_error_dp_not_available?-instance-method","name":"dns_error_dp_not_available?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1739,"url":null},"def":{"name":"dns_error_dp_not_available?","visibility":"Public","body":"self == DNS_ERROR_DP_NOT_AVAILABLE"}},{"html_id":"dns_error_dp_not_enlisted?-instance-method","name":"dns_error_dp_not_enlisted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1737,"url":null},"def":{"name":"dns_error_dp_not_enlisted?","visibility":"Public","body":"self == DNS_ERROR_DP_NOT_ENLISTED"}},{"html_id":"dns_error_ds_unavailable?-instance-method","name":"dns_error_ds_unavailable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1722,"url":null},"def":{"name":"dns_error_ds_unavailable?","visibility":"Public","body":"self == DNS_ERROR_DS_UNAVAILABLE"}},{"html_id":"dns_error_ds_zone_already_exists?-instance-method","name":"dns_error_ds_zone_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1723,"url":null},"def":{"name":"dns_error_ds_zone_already_exists?","visibility":"Public","body":"self == DNS_ERROR_DS_ZONE_ALREADY_EXISTS"}},{"html_id":"dns_error_file_writeback_failed?-instance-method","name":"dns_error_file_writeback_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1703,"url":null},"def":{"name":"dns_error_file_writeback_failed?","visibility":"Public","body":"self == DNS_ERROR_FILE_WRITEBACK_FAILED"}},{"html_id":"dns_error_forwarder_already_exists?-instance-method","name":"dns_error_forwarder_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1696,"url":null},"def":{"name":"dns_error_forwarder_already_exists?","visibility":"Public","body":"self == DNS_ERROR_FORWARDER_ALREADY_EXISTS"}},{"html_id":"dns_error_general_api_base?-instance-method","name":"dns_error_general_api_base?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1661,"url":null},"def":{"name":"dns_error_general_api_base?","visibility":"Public","body":"self == DNS_ERROR_GENERAL_API_BASE"}},{"html_id":"dns_error_inconsistent_root_hints?-instance-method","name":"dns_error_inconsistent_root_hints?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1676,"url":null},"def":{"name":"dns_error_inconsistent_root_hints?","visibility":"Public","body":"self == DNS_ERROR_INCONSISTENT_ROOT_HINTS"}},{"html_id":"dns_error_invalid_data?-instance-method","name":"dns_error_invalid_data?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1660,"url":null},"def":{"name":"dns_error_invalid_data?","visibility":"Public","body":"self == DNS_ERROR_INVALID_DATA"}},{"html_id":"dns_error_invalid_datafile_name?-instance-method","name":"dns_error_invalid_datafile_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1701,"url":null},"def":{"name":"dns_error_invalid_datafile_name?","visibility":"Public","body":"self == DNS_ERROR_INVALID_DATAFILE_NAME"}},{"html_id":"dns_error_invalid_ip_address?-instance-method","name":"dns_error_invalid_ip_address?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1663,"url":null},"def":{"name":"dns_error_invalid_ip_address?","visibility":"Public","body":"self == DNS_ERROR_INVALID_IP_ADDRESS"}},{"html_id":"dns_error_invalid_name?-instance-method","name":"dns_error_invalid_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1659,"url":null},"def":{"name":"dns_error_invalid_name?","visibility":"Public","body":"self == DNS_ERROR_INVALID_NAME"}},{"html_id":"dns_error_invalid_name_char?-instance-method","name":"dns_error_invalid_name_char?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1671,"url":null},"def":{"name":"dns_error_invalid_name_char?","visibility":"Public","body":"self == DNS_ERROR_INVALID_NAME_CHAR"}},{"html_id":"dns_error_invalid_property?-instance-method","name":"dns_error_invalid_property?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1664,"url":null},"def":{"name":"dns_error_invalid_property?","visibility":"Public","body":"self == DNS_ERROR_INVALID_PROPERTY"}},{"html_id":"dns_error_invalid_type?-instance-method","name":"dns_error_invalid_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1662,"url":null},"def":{"name":"dns_error_invalid_type?","visibility":"Public","body":"self == DNS_ERROR_INVALID_TYPE"}},{"html_id":"dns_error_invalid_zone_operation?-instance-method","name":"dns_error_invalid_zone_operation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1680,"url":null},"def":{"name":"dns_error_invalid_zone_operation?","visibility":"Public","body":"self == DNS_ERROR_INVALID_ZONE_OPERATION"}},{"html_id":"dns_error_invalid_zone_type?-instance-method","name":"dns_error_invalid_zone_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1688,"url":null},"def":{"name":"dns_error_invalid_zone_type?","visibility":"Public","body":"self == DNS_ERROR_INVALID_ZONE_TYPE"}},{"html_id":"dns_error_mask?-instance-method","name":"dns_error_mask?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1636,"url":null},"def":{"name":"dns_error_mask?","visibility":"Public","body":"self == DNS_ERROR_MASK"}},{"html_id":"dns_error_name_does_not_exist?-instance-method","name":"dns_error_name_does_not_exist?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1719,"url":null},"def":{"name":"dns_error_name_does_not_exist?","visibility":"Public","body":"self == DNS_ERROR_NAME_DOES_NOT_EXIST"}},{"html_id":"dns_error_name_not_in_zone?-instance-method","name":"dns_error_name_not_in_zone?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1711,"url":null},"def":{"name":"dns_error_name_not_in_zone?","visibility":"Public","body":"self == DNS_ERROR_NAME_NOT_IN_ZONE"}},{"html_id":"dns_error_nbstat_init_failed?-instance-method","name":"dns_error_nbstat_init_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1694,"url":null},"def":{"name":"dns_error_nbstat_init_failed?","visibility":"Public","body":"self == DNS_ERROR_NBSTAT_INIT_FAILED"}},{"html_id":"dns_error_need_secondary_addresses?-instance-method","name":"dns_error_need_secondary_addresses?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1691,"url":null},"def":{"name":"dns_error_need_secondary_addresses?","visibility":"Public","body":"self == DNS_ERROR_NEED_SECONDARY_ADDRESSES"}},{"html_id":"dns_error_need_wins_servers?-instance-method","name":"dns_error_need_wins_servers?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1693,"url":null},"def":{"name":"dns_error_need_wins_servers?","visibility":"Public","body":"self == DNS_ERROR_NEED_WINS_SERVERS"}},{"html_id":"dns_error_no_bootfile_if_ds_zone?-instance-method","name":"dns_error_no_bootfile_if_ds_zone?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1724,"url":null},"def":{"name":"dns_error_no_bootfile_if_ds_zone?","visibility":"Public","body":"self == DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE"}},{"html_id":"dns_error_no_create_cache_data?-instance-method","name":"dns_error_no_create_cache_data?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1718,"url":null},"def":{"name":"dns_error_no_create_cache_data?","visibility":"Public","body":"self == DNS_ERROR_NO_CREATE_CACHE_DATA"}},{"html_id":"dns_error_no_dns_servers?-instance-method","name":"dns_error_no_dns_servers?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1733,"url":null},"def":{"name":"dns_error_no_dns_servers?","visibility":"Public","body":"self == DNS_ERROR_NO_DNS_SERVERS"}},{"html_id":"dns_error_no_memory?-instance-method","name":"dns_error_no_memory?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1658,"url":null},"def":{"name":"dns_error_no_memory?","visibility":"Public","body":"self == DNS_ERROR_NO_MEMORY"}},{"html_id":"dns_error_no_packet?-instance-method","name":"dns_error_no_packet?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1654,"url":null},"def":{"name":"dns_error_no_packet?","visibility":"Public","body":"self == DNS_ERROR_NO_PACKET"}},{"html_id":"dns_error_no_tcpip?-instance-method","name":"dns_error_no_tcpip?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1732,"url":null},"def":{"name":"dns_error_no_tcpip?","visibility":"Public","body":"self == DNS_ERROR_NO_TCPIP"}},{"html_id":"dns_error_no_zone_info?-instance-method","name":"dns_error_no_zone_info?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1679,"url":null},"def":{"name":"dns_error_no_zone_info?","visibility":"Public","body":"self == DNS_ERROR_NO_ZONE_INFO"}},{"html_id":"dns_error_node_creation_failed?-instance-method","name":"dns_error_node_creation_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1708,"url":null},"def":{"name":"dns_error_node_creation_failed?","visibility":"Public","body":"self == DNS_ERROR_NODE_CREATION_FAILED"}},{"html_id":"dns_error_node_is_cname?-instance-method","name":"dns_error_node_is_cname?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1713,"url":null},"def":{"name":"dns_error_node_is_cname?","visibility":"Public","body":"self == DNS_ERROR_NODE_IS_CNAME"}},{"html_id":"dns_error_non_rfc_name?-instance-method","name":"dns_error_non_rfc_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1667,"url":null},"def":{"name":"dns_error_non_rfc_name?","visibility":"Public","body":"self == DNS_ERROR_NON_RFC_NAME"}},{"html_id":"dns_error_not_allowed_on_root_server?-instance-method","name":"dns_error_not_allowed_on_root_server?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1673,"url":null},"def":{"name":"dns_error_not_allowed_on_root_server?","visibility":"Public","body":"self == DNS_ERROR_NOT_ALLOWED_ON_ROOT_SERVER"}},{"html_id":"dns_error_not_allowed_under_delegation?-instance-method","name":"dns_error_not_allowed_under_delegation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1674,"url":null},"def":{"name":"dns_error_not_allowed_under_delegation?","visibility":"Public","body":"self == DNS_ERROR_NOT_ALLOWED_UNDER_DELEGATION"}},{"html_id":"dns_error_not_unique?-instance-method","name":"dns_error_not_unique?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1666,"url":null},"def":{"name":"dns_error_not_unique?","visibility":"Public","body":"self == DNS_ERROR_NOT_UNIQUE"}},{"html_id":"dns_error_numeric_name?-instance-method","name":"dns_error_numeric_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1672,"url":null},"def":{"name":"dns_error_numeric_name?","visibility":"Public","body":"self == DNS_ERROR_NUMERIC_NAME"}},{"html_id":"dns_error_operation_base?-instance-method","name":"dns_error_operation_base?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1725,"url":null},"def":{"name":"dns_error_operation_base?","visibility":"Public","body":"self == DNS_ERROR_OPERATION_BASE"}},{"html_id":"dns_error_packet_fmt_base?-instance-method","name":"dns_error_packet_fmt_base?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1651,"url":null},"def":{"name":"dns_error_packet_fmt_base?","visibility":"Public","body":"self == DNS_ERROR_PACKET_FMT_BASE"}},{"html_id":"dns_error_primary_requires_datafile?-instance-method","name":"dns_error_primary_requires_datafile?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1700,"url":null},"def":{"name":"dns_error_primary_requires_datafile?","visibility":"Public","body":"self == DNS_ERROR_PRIMARY_REQUIRES_DATAFILE"}},{"html_id":"dns_error_rcode?-instance-method","name":"dns_error_rcode?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1655,"url":null},"def":{"name":"dns_error_rcode?","visibility":"Public","body":"self == DNS_ERROR_RCODE"}},{"html_id":"dns_error_rcode_badkey?-instance-method","name":"dns_error_rcode_badkey?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1648,"url":null},"def":{"name":"dns_error_rcode_badkey?","visibility":"Public","body":"self == DNS_ERROR_RCODE_BADKEY"}},{"html_id":"dns_error_rcode_badsig?-instance-method","name":"dns_error_rcode_badsig?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1647,"url":null},"def":{"name":"dns_error_rcode_badsig?","visibility":"Public","body":"self == DNS_ERROR_RCODE_BADSIG"}},{"html_id":"dns_error_rcode_badtime?-instance-method","name":"dns_error_rcode_badtime?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1649,"url":null},"def":{"name":"dns_error_rcode_badtime?","visibility":"Public","body":"self == DNS_ERROR_RCODE_BADTIME"}},{"html_id":"dns_error_rcode_format_error?-instance-method","name":"dns_error_rcode_format_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1637,"url":null},"def":{"name":"dns_error_rcode_format_error?","visibility":"Public","body":"self == DNS_ERROR_RCODE_FORMAT_ERROR"}},{"html_id":"dns_error_rcode_last?-instance-method","name":"dns_error_rcode_last?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1650,"url":null},"def":{"name":"dns_error_rcode_last?","visibility":"Public","body":"self == DNS_ERROR_RCODE_LAST"}},{"html_id":"dns_error_rcode_name_error?-instance-method","name":"dns_error_rcode_name_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1639,"url":null},"def":{"name":"dns_error_rcode_name_error?","visibility":"Public","body":"self == DNS_ERROR_RCODE_NAME_ERROR"}},{"html_id":"dns_error_rcode_not_implemented?-instance-method","name":"dns_error_rcode_not_implemented?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1640,"url":null},"def":{"name":"dns_error_rcode_not_implemented?","visibility":"Public","body":"self == DNS_ERROR_RCODE_NOT_IMPLEMENTED"}},{"html_id":"dns_error_rcode_notauth?-instance-method","name":"dns_error_rcode_notauth?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1645,"url":null},"def":{"name":"dns_error_rcode_notauth?","visibility":"Public","body":"self == DNS_ERROR_RCODE_NOTAUTH"}},{"html_id":"dns_error_rcode_notzone?-instance-method","name":"dns_error_rcode_notzone?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1646,"url":null},"def":{"name":"dns_error_rcode_notzone?","visibility":"Public","body":"self == DNS_ERROR_RCODE_NOTZONE"}},{"html_id":"dns_error_rcode_nxrrset?-instance-method","name":"dns_error_rcode_nxrrset?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1644,"url":null},"def":{"name":"dns_error_rcode_nxrrset?","visibility":"Public","body":"self == DNS_ERROR_RCODE_NXRRSET"}},{"html_id":"dns_error_rcode_refused?-instance-method","name":"dns_error_rcode_refused?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1641,"url":null},"def":{"name":"dns_error_rcode_refused?","visibility":"Public","body":"self == DNS_ERROR_RCODE_REFUSED"}},{"html_id":"dns_error_rcode_server_failure?-instance-method","name":"dns_error_rcode_server_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1638,"url":null},"def":{"name":"dns_error_rcode_server_failure?","visibility":"Public","body":"self == DNS_ERROR_RCODE_SERVER_FAILURE"}},{"html_id":"dns_error_rcode_yxdomain?-instance-method","name":"dns_error_rcode_yxdomain?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1642,"url":null},"def":{"name":"dns_error_rcode_yxdomain?","visibility":"Public","body":"self == DNS_ERROR_RCODE_YXDOMAIN"}},{"html_id":"dns_error_rcode_yxrrset?-instance-method","name":"dns_error_rcode_yxrrset?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1643,"url":null},"def":{"name":"dns_error_rcode_yxrrset?","visibility":"Public","body":"self == DNS_ERROR_RCODE_YXRRSET"}},{"html_id":"dns_error_record_already_exists?-instance-method","name":"dns_error_record_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1716,"url":null},"def":{"name":"dns_error_record_already_exists?","visibility":"Public","body":"self == DNS_ERROR_RECORD_ALREADY_EXISTS"}},{"html_id":"dns_error_record_does_not_exist?-instance-method","name":"dns_error_record_does_not_exist?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1706,"url":null},"def":{"name":"dns_error_record_does_not_exist?","visibility":"Public","body":"self == DNS_ERROR_RECORD_DOES_NOT_EXIST"}},{"html_id":"dns_error_record_format?-instance-method","name":"dns_error_record_format?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1707,"url":null},"def":{"name":"dns_error_record_format?","visibility":"Public","body":"self == DNS_ERROR_RECORD_FORMAT"}},{"html_id":"dns_error_record_only_at_zone_root?-instance-method","name":"dns_error_record_only_at_zone_root?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1715,"url":null},"def":{"name":"dns_error_record_only_at_zone_root?","visibility":"Public","body":"self == DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT"}},{"html_id":"dns_error_record_timed_out?-instance-method","name":"dns_error_record_timed_out?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1710,"url":null},"def":{"name":"dns_error_record_timed_out?","visibility":"Public","body":"self == DNS_ERROR_RECORD_TIMED_OUT"}},{"html_id":"dns_error_response_codes_base?-instance-method","name":"dns_error_response_codes_base?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1635,"url":null},"def":{"name":"dns_error_response_codes_base?","visibility":"Public","body":"self == DNS_ERROR_RESPONSE_CODES_BASE"}},{"html_id":"dns_error_secondary_data?-instance-method","name":"dns_error_secondary_data?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1717,"url":null},"def":{"name":"dns_error_secondary_data?","visibility":"Public","body":"self == DNS_ERROR_SECONDARY_DATA"}},{"html_id":"dns_error_secondary_requires_master_ip?-instance-method","name":"dns_error_secondary_requires_master_ip?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1689,"url":null},"def":{"name":"dns_error_secondary_requires_master_ip?","visibility":"Public","body":"self == DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP"}},{"html_id":"dns_error_secure_base?-instance-method","name":"dns_error_secure_base?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1729,"url":null},"def":{"name":"dns_error_secure_base?","visibility":"Public","body":"self == DNS_ERROR_SECURE_BASE"}},{"html_id":"dns_error_setup_base?-instance-method","name":"dns_error_setup_base?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1731,"url":null},"def":{"name":"dns_error_setup_base?","visibility":"Public","body":"self == DNS_ERROR_SETUP_BASE"}},{"html_id":"dns_error_soa_delete_invalid?-instance-method","name":"dns_error_soa_delete_invalid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1695,"url":null},"def":{"name":"dns_error_soa_delete_invalid?","visibility":"Public","body":"self == DNS_ERROR_SOA_DELETE_INVALID"}},{"html_id":"dns_error_try_again_later?-instance-method","name":"dns_error_try_again_later?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1665,"url":null},"def":{"name":"dns_error_try_again_later?","visibility":"Public","body":"self == DNS_ERROR_TRY_AGAIN_LATER"}},{"html_id":"dns_error_unknown_record_type?-instance-method","name":"dns_error_unknown_record_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1709,"url":null},"def":{"name":"dns_error_unknown_record_type?","visibility":"Public","body":"self == DNS_ERROR_UNKNOWN_RECORD_TYPE"}},{"html_id":"dns_error_unsecure_packet?-instance-method","name":"dns_error_unsecure_packet?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1656,"url":null},"def":{"name":"dns_error_unsecure_packet?","visibility":"Public","body":"self == DNS_ERROR_UNSECURE_PACKET"}},{"html_id":"dns_error_wins_init_failed?-instance-method","name":"dns_error_wins_init_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1692,"url":null},"def":{"name":"dns_error_wins_init_failed?","visibility":"Public","body":"self == DNS_ERROR_WINS_INIT_FAILED"}},{"html_id":"dns_error_zone_already_exists?-instance-method","name":"dns_error_zone_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1686,"url":null},"def":{"name":"dns_error_zone_already_exists?","visibility":"Public","body":"self == DNS_ERROR_ZONE_ALREADY_EXISTS"}},{"html_id":"dns_error_zone_base?-instance-method","name":"dns_error_zone_base?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1677,"url":null},"def":{"name":"dns_error_zone_base?","visibility":"Public","body":"self == DNS_ERROR_ZONE_BASE"}},{"html_id":"dns_error_zone_configuration_error?-instance-method","name":"dns_error_zone_configuration_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1681,"url":null},"def":{"name":"dns_error_zone_configuration_error?","visibility":"Public","body":"self == DNS_ERROR_ZONE_CONFIGURATION_ERROR"}},{"html_id":"dns_error_zone_creation_failed?-instance-method","name":"dns_error_zone_creation_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1685,"url":null},"def":{"name":"dns_error_zone_creation_failed?","visibility":"Public","body":"self == DNS_ERROR_ZONE_CREATION_FAILED"}},{"html_id":"dns_error_zone_does_not_exist?-instance-method","name":"dns_error_zone_does_not_exist?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1678,"url":null},"def":{"name":"dns_error_zone_does_not_exist?","visibility":"Public","body":"self == DNS_ERROR_ZONE_DOES_NOT_EXIST"}},{"html_id":"dns_error_zone_has_no_ns_records?-instance-method","name":"dns_error_zone_has_no_ns_records?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1683,"url":null},"def":{"name":"dns_error_zone_has_no_ns_records?","visibility":"Public","body":"self == DNS_ERROR_ZONE_HAS_NO_NS_RECORDS"}},{"html_id":"dns_error_zone_has_no_soa_record?-instance-method","name":"dns_error_zone_has_no_soa_record?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1682,"url":null},"def":{"name":"dns_error_zone_has_no_soa_record?","visibility":"Public","body":"self == DNS_ERROR_ZONE_HAS_NO_SOA_RECORD"}},{"html_id":"dns_error_zone_is_shutdown?-instance-method","name":"dns_error_zone_is_shutdown?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1698,"url":null},"def":{"name":"dns_error_zone_is_shutdown?","visibility":"Public","body":"self == DNS_ERROR_ZONE_IS_SHUTDOWN"}},{"html_id":"dns_error_zone_locked?-instance-method","name":"dns_error_zone_locked?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1684,"url":null},"def":{"name":"dns_error_zone_locked?","visibility":"Public","body":"self == DNS_ERROR_ZONE_LOCKED"}},{"html_id":"dns_error_zone_not_secondary?-instance-method","name":"dns_error_zone_not_secondary?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1690,"url":null},"def":{"name":"dns_error_zone_not_secondary?","visibility":"Public","body":"self == DNS_ERROR_ZONE_NOT_SECONDARY"}},{"html_id":"dns_error_zone_requires_master_ip?-instance-method","name":"dns_error_zone_requires_master_ip?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1697,"url":null},"def":{"name":"dns_error_zone_requires_master_ip?","visibility":"Public","body":"self == DNS_ERROR_ZONE_REQUIRES_MASTER_IP"}},{"html_id":"dns_info_added_local_wins?-instance-method","name":"dns_info_added_local_wins?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1728,"url":null},"def":{"name":"dns_info_added_local_wins?","visibility":"Public","body":"self == DNS_INFO_ADDED_LOCAL_WINS"}},{"html_id":"dns_info_axfr_complete?-instance-method","name":"dns_info_axfr_complete?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1726,"url":null},"def":{"name":"dns_info_axfr_complete?","visibility":"Public","body":"self == DNS_INFO_AXFR_COMPLETE"}},{"html_id":"dns_info_no_records?-instance-method","name":"dns_info_no_records?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1652,"url":null},"def":{"name":"dns_info_no_records?","visibility":"Public","body":"self == DNS_INFO_NO_RECORDS"}},{"html_id":"dns_status_continue_needed?-instance-method","name":"dns_status_continue_needed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1730,"url":null},"def":{"name":"dns_status_continue_needed?","visibility":"Public","body":"self == DNS_STATUS_CONTINUE_NEEDED"}},{"html_id":"dns_status_dotted_name?-instance-method","name":"dns_status_dotted_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1669,"url":null},"def":{"name":"dns_status_dotted_name?","visibility":"Public","body":"self == DNS_STATUS_DOTTED_NAME"}},{"html_id":"dns_status_fqdn?-instance-method","name":"dns_status_fqdn?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1668,"url":null},"def":{"name":"dns_status_fqdn?","visibility":"Public","body":"self == DNS_STATUS_FQDN"}},{"html_id":"dns_status_packet_unsecure?-instance-method","name":"dns_status_packet_unsecure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1657,"url":null},"def":{"name":"dns_status_packet_unsecure?","visibility":"Public","body":"self == DNS_STATUS_PACKET_UNSECURE"}},{"html_id":"dns_status_single_part_name?-instance-method","name":"dns_status_single_part_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1670,"url":null},"def":{"name":"dns_status_single_part_name?","visibility":"Public","body":"self == DNS_STATUS_SINGLE_PART_NAME"}},{"html_id":"dns_warning_domain_undeleted?-instance-method","name":"dns_warning_domain_undeleted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1721,"url":null},"def":{"name":"dns_warning_domain_undeleted?","visibility":"Public","body":"self == DNS_WARNING_DOMAIN_UNDELETED"}},{"html_id":"dns_warning_ptr_create_failed?-instance-method","name":"dns_warning_ptr_create_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1720,"url":null},"def":{"name":"dns_warning_ptr_create_failed?","visibility":"Public","body":"self == DNS_WARNING_PTR_CREATE_FAILED"}},{"html_id":"ept_s_cant_create?-instance-method","name":"ept_s_cant_create?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":924,"url":null},"def":{"name":"ept_s_cant_create?","visibility":"Public","body":"self == EPT_S_CANT_CREATE"}},{"html_id":"ept_s_cant_perform_op?-instance-method","name":"ept_s_cant_perform_op?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":843,"url":null},"def":{"name":"ept_s_cant_perform_op?","visibility":"Public","body":"self == EPT_S_CANT_PERFORM_OP"}},{"html_id":"ept_s_invalid_entry?-instance-method","name":"ept_s_invalid_entry?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":842,"url":null},"def":{"name":"ept_s_invalid_entry?","visibility":"Public","body":"self == EPT_S_INVALID_ENTRY"}},{"html_id":"ept_s_not_registered?-instance-method","name":"ept_s_not_registered?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":844,"url":null},"def":{"name":"ept_s_not_registered?","visibility":"Public","body":"self == EPT_S_NOT_REGISTERED"}},{"html_id":"error_abandoned_wait_0?-instance-method","name":"error_abandoned_wait_0?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":367,"url":null},"def":{"name":"error_abandoned_wait_0?","visibility":"Public","body":"self == ERROR_ABANDONED_WAIT_0"}},{"html_id":"error_abandoned_wait_63?-instance-method","name":"error_abandoned_wait_63?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":368,"url":null},"def":{"name":"error_abandoned_wait_63?","visibility":"Public","body":"self == ERROR_ABANDONED_WAIT_63"}},{"html_id":"error_access_denied?-instance-method","name":"error_access_denied?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":162,"url":null},"def":{"name":"error_access_denied?","visibility":"Public","body":"self == ERROR_ACCESS_DENIED"}},{"html_id":"error_access_disabled_by_policy?-instance-method","name":"error_access_disabled_by_policy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":561,"url":null},"def":{"name":"error_access_disabled_by_policy?","visibility":"Public","body":"self == ERROR_ACCESS_DISABLED_BY_POLICY"}},{"html_id":"error_access_disabled_webblade?-instance-method","name":"error_access_disabled_webblade?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":572,"url":null},"def":{"name":"error_access_disabled_webblade?","visibility":"Public","body":"self == ERROR_ACCESS_DISABLED_WEBBLADE"}},{"html_id":"error_access_disabled_webblade_tamper?-instance-method","name":"error_access_disabled_webblade_tamper?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":573,"url":null},"def":{"name":"error_access_disabled_webblade_tamper?","visibility":"Public","body":"self == ERROR_ACCESS_DISABLED_WEBBLADE_TAMPER"}},{"html_id":"error_account_disabled?-instance-method","name":"error_account_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":614,"url":null},"def":{"name":"error_account_disabled?","visibility":"Public","body":"self == ERROR_ACCOUNT_DISABLED"}},{"html_id":"error_account_expired?-instance-method","name":"error_account_expired?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":883,"url":null},"def":{"name":"error_account_expired?","visibility":"Public","body":"self == ERROR_ACCOUNT_EXPIRED"}},{"html_id":"error_account_locked_out?-instance-method","name":"error_account_locked_out?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":934,"url":null},"def":{"name":"error_account_locked_out?","visibility":"Public","body":"self == ERROR_ACCOUNT_LOCKED_OUT"}},{"html_id":"error_account_restriction?-instance-method","name":"error_account_restriction?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":610,"url":null},"def":{"name":"error_account_restriction?","visibility":"Public","body":"self == ERROR_ACCOUNT_RESTRICTION"}},{"html_id":"error_activation_count_exceeded?-instance-method","name":"error_activation_count_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1239,"url":null},"def":{"name":"error_activation_count_exceeded?","visibility":"Public","body":"self == ERROR_ACTIVATION_COUNT_EXCEEDED"}},{"html_id":"error_active_connections?-instance-method","name":"error_active_connections?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":986,"url":null},"def":{"name":"error_active_connections?","visibility":"Public","body":"self == ERROR_ACTIVE_CONNECTIONS"}},{"html_id":"error_adap_hdw_err?-instance-method","name":"error_adap_hdw_err?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":202,"url":null},"def":{"name":"error_adap_hdw_err?","visibility":"Public","body":"self == ERROR_ADAP_HDW_ERR"}},{"html_id":"error_address_already_associated?-instance-method","name":"error_address_already_associated?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":528,"url":null},"def":{"name":"error_address_already_associated?","visibility":"Public","body":"self == ERROR_ADDRESS_ALREADY_ASSOCIATED"}},{"html_id":"error_address_not_associated?-instance-method","name":"error_address_not_associated?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":529,"url":null},"def":{"name":"error_address_not_associated?","visibility":"Public","body":"self == ERROR_ADDRESS_NOT_ASSOCIATED"}},{"html_id":"error_advanced_installer_failed?-instance-method","name":"error_advanced_installer_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1931,"url":null},"def":{"name":"error_advanced_installer_failed?","visibility":"Public","body":"self == ERROR_ADVANCED_INSTALLER_FAILED"}},{"html_id":"error_alerted?-instance-method","name":"error_alerted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":371,"url":null},"def":{"name":"error_alerted?","visibility":"Public","body":"self == ERROR_ALERTED"}},{"html_id":"error_alias_exists?-instance-method","name":"error_alias_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":661,"url":null},"def":{"name":"error_alias_exists?","visibility":"Public","body":"self == ERROR_ALIAS_EXISTS"}},{"html_id":"error_all_nodes_not_available?-instance-method","name":"error_all_nodes_not_available?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1113,"url":null},"def":{"name":"error_all_nodes_not_available?","visibility":"Public","body":"self == ERROR_ALL_NODES_NOT_AVAILABLE"}},{"html_id":"error_all_user_trust_quota_exceeded?-instance-method","name":"error_all_user_trust_quota_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":958,"url":null},"def":{"name":"error_all_user_trust_quota_exceeded?","visibility":"Public","body":"self == ERROR_ALL_USER_TRUST_QUOTA_EXCEEDED"}},{"html_id":"error_allotted_space_exceeded?-instance-method","name":"error_allotted_space_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":626,"url":null},"def":{"name":"error_allotted_space_exceeded?","visibility":"Public","body":"self == ERROR_ALLOTTED_SPACE_EXCEEDED"}},{"html_id":"error_already_assigned?-instance-method","name":"error_already_assigned?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":222,"url":null},"def":{"name":"error_already_assigned?","visibility":"Public","body":"self == ERROR_ALREADY_ASSIGNED"}},{"html_id":"error_already_exists?-instance-method","name":"error_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":295,"url":null},"def":{"name":"error_already_exists?","visibility":"Public","body":"self == ERROR_ALREADY_EXISTS"}},{"html_id":"error_already_fiber?-instance-method","name":"error_already_fiber?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":575,"url":null},"def":{"name":"error_already_fiber?","visibility":"Public","body":"self == ERROR_ALREADY_FIBER"}},{"html_id":"error_already_initialized?-instance-method","name":"error_already_initialized?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":548,"url":null},"def":{"name":"error_already_initialized?","visibility":"Public","body":"self == ERROR_ALREADY_INITIALIZED"}},{"html_id":"error_already_registered?-instance-method","name":"error_already_registered?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":543,"url":null},"def":{"name":"error_already_registered?","visibility":"Public","body":"self == ERROR_ALREADY_REGISTERED"}},{"html_id":"error_already_running_lkg?-instance-method","name":"error_already_running_lkg?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":423,"url":null},"def":{"name":"error_already_running_lkg?","visibility":"Public","body":"self == ERROR_ALREADY_RUNNING_LKG"}},{"html_id":"error_already_thread?-instance-method","name":"error_already_thread?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":576,"url":null},"def":{"name":"error_already_thread?","visibility":"Public","body":"self == ERROR_ALREADY_THREAD"}},{"html_id":"error_already_waiting?-instance-method","name":"error_already_waiting?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":929,"url":null},"def":{"name":"error_already_waiting?","visibility":"Public","body":"self == ERROR_ALREADY_WAITING"}},{"html_id":"error_ambiguous_system_device?-instance-method","name":"error_ambiguous_system_device?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2175,"url":null},"def":{"name":"error_ambiguous_system_device?","visibility":"Public","body":"self == ERROR_AMBIGUOUS_SYSTEM_DEVICE"}},{"html_id":"error_api_unavailable?-instance-method","name":"error_api_unavailable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2243,"url":null},"def":{"name":"error_api_unavailable?","visibility":"Public","body":"self == ERROR_API_UNAVAILABLE"}},{"html_id":"error_app_wrong_os?-instance-method","name":"error_app_wrong_os?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":471,"url":null},"def":{"name":"error_app_wrong_os?","visibility":"Public","body":"self == ERROR_APP_WRONG_OS"}},{"html_id":"error_apphelp_block?-instance-method","name":"error_apphelp_block?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":560,"url":null},"def":{"name":"error_apphelp_block?","visibility":"Public","body":"self == ERROR_APPHELP_BLOCK"}},{"html_id":"error_appx_integrity_failure_clr_ngen?-instance-method","name":"error_appx_integrity_failure_clr_ngen?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2217,"url":null},"def":{"name":"error_appx_integrity_failure_clr_ngen?","visibility":"Public","body":"self == ERROR_APPX_INTEGRITY_FAILURE_CLR_NGEN"}},{"html_id":"error_arena_trashed?-instance-method","name":"error_arena_trashed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":164,"url":null},"def":{"name":"error_arena_trashed?","visibility":"Public","body":"self == ERROR_ARENA_TRASHED"}},{"html_id":"error_arithmetic_overflow?-instance-method","name":"error_arithmetic_overflow?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":359,"url":null},"def":{"name":"error_arithmetic_overflow?","visibility":"Public","body":"self == ERROR_ARITHMETIC_OVERFLOW"}},{"html_id":"error_atomic_locks_not_supported?-instance-method","name":"error_atomic_locks_not_supported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":292,"url":null},"def":{"name":"error_atomic_locks_not_supported?","visibility":"Public","body":"self == ERROR_ATOMIC_LOCKS_NOT_SUPPORTED"}},{"html_id":"error_authentication_firewall_failed?-instance-method","name":"error_authentication_firewall_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":960,"url":null},"def":{"name":"error_authentication_firewall_failed?","visibility":"Public","body":"self == ERROR_AUTHENTICATION_FIREWALL_FAILED"}},{"html_id":"error_autodataseg_exceeds_64k?-instance-method","name":"error_autodataseg_exceeds_64k?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":309,"url":null},"def":{"name":"error_autodataseg_exceeds_64k?","visibility":"Public","body":"self == ERROR_AUTODATASEG_EXCEEDS_64k"}},{"html_id":"error_bad_arguments?-instance-method","name":"error_bad_arguments?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":285,"url":null},"def":{"name":"error_bad_arguments?","visibility":"Public","body":"self == ERROR_BAD_ARGUMENTS"}},{"html_id":"error_bad_command?-instance-method","name":"error_bad_command?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":179,"url":null},"def":{"name":"error_bad_command?","visibility":"Public","body":"self == ERROR_BAD_COMMAND"}},{"html_id":"error_bad_configuration?-instance-method","name":"error_bad_configuration?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":758,"url":null},"def":{"name":"error_bad_configuration?","visibility":"Public","body":"self == ERROR_BAD_CONFIGURATION"}},{"html_id":"error_bad_descriptor_format?-instance-method","name":"error_bad_descriptor_format?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":643,"url":null},"def":{"name":"error_bad_descriptor_format?","visibility":"Public","body":"self == ERROR_BAD_DESCRIPTOR_FORMAT"}},{"html_id":"error_bad_dev_type?-instance-method","name":"error_bad_dev_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":211,"url":null},"def":{"name":"error_bad_dev_type?","visibility":"Public","body":"self == ERROR_BAD_DEV_TYPE"}},{"html_id":"error_bad_device?-instance-method","name":"error_bad_device?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":501,"url":null},"def":{"name":"error_bad_device?","visibility":"Public","body":"self == ERROR_BAD_DEVICE"}},{"html_id":"error_bad_driver?-instance-method","name":"error_bad_driver?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":963,"url":null},"def":{"name":"error_bad_driver?","visibility":"Public","body":"self == ERROR_BAD_DRIVER"}},{"html_id":"error_bad_driver_level?-instance-method","name":"error_bad_driver_level?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":244,"url":null},"def":{"name":"error_bad_driver_level?","visibility":"Public","body":"self == ERROR_BAD_DRIVER_LEVEL"}},{"html_id":"error_bad_environment?-instance-method","name":"error_bad_environment?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":167,"url":null},"def":{"name":"error_bad_environment?","visibility":"Public","body":"self == ERROR_BAD_ENVIRONMENT"}},{"html_id":"error_bad_exe_format?-instance-method","name":"error_bad_exe_format?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":303,"url":null},"def":{"name":"error_bad_exe_format?","visibility":"Public","body":"self == ERROR_BAD_EXE_FORMAT"}},{"html_id":"error_bad_file_type?-instance-method","name":"error_bad_file_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":328,"url":null},"def":{"name":"error_bad_file_type?","visibility":"Public","body":"self == ERROR_BAD_FILE_TYPE"}},{"html_id":"error_bad_format?-instance-method","name":"error_bad_format?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":168,"url":null},"def":{"name":"error_bad_format?","visibility":"Public","body":"self == ERROR_BAD_FORMAT"}},{"html_id":"error_bad_impersonation_level?-instance-method","name":"error_bad_impersonation_level?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":628,"url":null},"def":{"name":"error_bad_impersonation_level?","visibility":"Public","body":"self == ERROR_BAD_IMPERSONATION_LEVEL"}},{"html_id":"error_bad_inheritance_acl?-instance-method","name":"error_bad_inheritance_acl?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":622,"url":null},"def":{"name":"error_bad_inheritance_acl?","visibility":"Public","body":"self == ERROR_BAD_INHERITANCE_ACL"}},{"html_id":"error_bad_length?-instance-method","name":"error_bad_length?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":181,"url":null},"def":{"name":"error_bad_length?","visibility":"Public","body":"self == ERROR_BAD_LENGTH"}},{"html_id":"error_bad_logon_session_state?-instance-method","name":"error_bad_logon_session_state?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":647,"url":null},"def":{"name":"error_bad_logon_session_state?","visibility":"Public","body":"self == ERROR_BAD_LOGON_SESSION_STATE"}},{"html_id":"error_bad_net_name?-instance-method","name":"error_bad_net_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":212,"url":null},"def":{"name":"error_bad_net_name?","visibility":"Public","body":"self == ERROR_BAD_NET_NAME"}},{"html_id":"error_bad_net_resp?-instance-method","name":"error_bad_net_resp?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":203,"url":null},"def":{"name":"error_bad_net_resp?","visibility":"Public","body":"self == ERROR_BAD_NET_RESP"}},{"html_id":"error_bad_netpath?-instance-method","name":"error_bad_netpath?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":198,"url":null},"def":{"name":"error_bad_netpath?","visibility":"Public","body":"self == ERROR_BAD_NETPATH"}},{"html_id":"error_bad_pathname?-instance-method","name":"error_bad_pathname?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":286,"url":null},"def":{"name":"error_bad_pathname?","visibility":"Public","body":"self == ERROR_BAD_PATHNAME"}},{"html_id":"error_bad_pipe?-instance-method","name":"error_bad_pipe?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":332,"url":null},"def":{"name":"error_bad_pipe?","visibility":"Public","body":"self == ERROR_BAD_PIPE"}},{"html_id":"error_bad_profile?-instance-method","name":"error_bad_profile?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":507,"url":null},"def":{"name":"error_bad_profile?","visibility":"Public","body":"self == ERROR_BAD_PROFILE"}},{"html_id":"error_bad_provider?-instance-method","name":"error_bad_provider?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":505,"url":null},"def":{"name":"error_bad_provider?","visibility":"Public","body":"self == ERROR_BAD_PROVIDER"}},{"html_id":"error_bad_query_syntax?-instance-method","name":"error_bad_query_syntax?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":763,"url":null},"def":{"name":"error_bad_query_syntax?","visibility":"Public","body":"self == ERROR_BAD_QUERY_SYNTAX"}},{"html_id":"error_bad_recovery_policy?-instance-method","name":"error_bad_recovery_policy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1193,"url":null},"def":{"name":"error_bad_recovery_policy?","visibility":"Public","body":"self == ERROR_BAD_RECOVERY_POLICY"}},{"html_id":"error_bad_rem_adap?-instance-method","name":"error_bad_rem_adap?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":205,"url":null},"def":{"name":"error_bad_rem_adap?","visibility":"Public","body":"self == ERROR_BAD_REM_ADAP"}},{"html_id":"error_bad_threadid_addr?-instance-method","name":"error_bad_threadid_addr?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":284,"url":null},"def":{"name":"error_bad_threadid_addr?","visibility":"Public","body":"self == ERROR_BAD_THREADID_ADDR"}},{"html_id":"error_bad_token_type?-instance-method","name":"error_bad_token_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":631,"url":null},"def":{"name":"error_bad_token_type?","visibility":"Public","body":"self == ERROR_BAD_TOKEN_TYPE"}},{"html_id":"error_bad_unit?-instance-method","name":"error_bad_unit?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":177,"url":null},"def":{"name":"error_bad_unit?","visibility":"Public","body":"self == ERROR_BAD_UNIT"}},{"html_id":"error_bad_user_profile?-instance-method","name":"error_bad_user_profile?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":554,"url":null},"def":{"name":"error_bad_user_profile?","visibility":"Public","body":"self == ERROR_BAD_USER_PROFILE"}},{"html_id":"error_bad_username?-instance-method","name":"error_bad_username?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":983,"url":null},"def":{"name":"error_bad_username?","visibility":"Public","body":"self == ERROR_BAD_USERNAME"}},{"html_id":"error_bad_validation_class?-instance-method","name":"error_bad_validation_class?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":630,"url":null},"def":{"name":"error_bad_validation_class?","visibility":"Public","body":"self == ERROR_BAD_VALIDATION_CLASS"}},{"html_id":"error_baddb?-instance-method","name":"error_baddb?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":386,"url":null},"def":{"name":"error_baddb?","visibility":"Public","body":"self == ERROR_BADDB"}},{"html_id":"error_badkey?-instance-method","name":"error_badkey?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":387,"url":null},"def":{"name":"error_badkey?","visibility":"Public","body":"self == ERROR_BADKEY"}},{"html_id":"error_beginning_of_media?-instance-method","name":"error_beginning_of_media?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":436,"url":null},"def":{"name":"error_beginning_of_media?","visibility":"Public","body":"self == ERROR_BEGINNING_OF_MEDIA"}},{"html_id":"error_boot_already_accepted?-instance-method","name":"error_boot_already_accepted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":425,"url":null},"def":{"name":"error_boot_already_accepted?","visibility":"Public","body":"self == ERROR_BOOT_ALREADY_ACCEPTED"}},{"html_id":"error_broken_pipe?-instance-method","name":"error_broken_pipe?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":236,"url":null},"def":{"name":"error_broken_pipe?","visibility":"Public","body":"self == ERROR_BROKEN_PIPE"}},{"html_id":"error_buffer_overflow?-instance-method","name":"error_buffer_overflow?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":238,"url":null},"def":{"name":"error_buffer_overflow?","visibility":"Public","body":"self == ERROR_BUFFER_OVERFLOW"}},{"html_id":"error_bus_reset?-instance-method","name":"error_bus_reset?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":445,"url":null},"def":{"name":"error_bus_reset?","visibility":"Public","body":"self == ERROR_BUS_RESET"}},{"html_id":"error_busy?-instance-method","name":"error_busy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":290,"url":null},"def":{"name":"error_busy?","visibility":"Public","body":"self == ERROR_BUSY"}},{"html_id":"error_busy_drive?-instance-method","name":"error_busy_drive?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":267,"url":null},"def":{"name":"error_busy_drive?","visibility":"Public","body":"self == ERROR_BUSY_DRIVE"}},{"html_id":"error_call_not_implemented?-instance-method","name":"error_call_not_implemented?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":245,"url":null},"def":{"name":"error_call_not_implemented?","visibility":"Public","body":"self == ERROR_CALL_NOT_IMPLEMENTED"}},{"html_id":"error_callback_supplied_invalid_data?-instance-method","name":"error_callback_supplied_invalid_data?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":568,"url":null},"def":{"name":"error_callback_supplied_invalid_data?","visibility":"Public","body":"self == ERROR_CALLBACK_SUPPLIED_INVALID_DATA"}},{"html_id":"error_can_not_complete?-instance-method","name":"error_can_not_complete?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":380,"url":null},"def":{"name":"error_can_not_complete?","visibility":"Public","body":"self == ERROR_CAN_NOT_COMPLETE"}},{"html_id":"error_can_not_del_local_wins?-instance-method","name":"error_can_not_del_local_wins?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1004,"url":null},"def":{"name":"error_can_not_del_local_wins?","visibility":"Public","body":"self == ERROR_CAN_NOT_DEL_LOCAL_WINS"}},{"html_id":"error_cancel_violation?-instance-method","name":"error_cancel_violation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":291,"url":null},"def":{"name":"error_cancel_violation?","visibility":"Public","body":"self == ERROR_CANCEL_VIOLATION"}},{"html_id":"error_cancelled?-instance-method","name":"error_cancelled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":524,"url":null},"def":{"name":"error_cancelled?","visibility":"Public","body":"self == ERROR_CANCELLED"}},{"html_id":"error_cannot_copy?-instance-method","name":"error_cannot_copy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":342,"url":null},"def":{"name":"error_cannot_copy?","visibility":"Public","body":"self == ERROR_CANNOT_COPY"}},{"html_id":"error_cannot_detect_driver_failure?-instance-method","name":"error_cannot_detect_driver_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":429,"url":null},"def":{"name":"error_cannot_detect_driver_failure?","visibility":"Public","body":"self == ERROR_CANNOT_DETECT_DRIVER_FAILURE"}},{"html_id":"error_cannot_detect_process_abort?-instance-method","name":"error_cannot_detect_process_abort?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":430,"url":null},"def":{"name":"error_cannot_detect_process_abort?","visibility":"Public","body":"self == ERROR_CANNOT_DETECT_PROCESS_ABORT"}},{"html_id":"error_cannot_find_wnd_class?-instance-method","name":"error_cannot_find_wnd_class?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":689,"url":null},"def":{"name":"error_cannot_find_wnd_class?","visibility":"Public","body":"self == ERROR_CANNOT_FIND_WND_CLASS"}},{"html_id":"error_cannot_impersonate?-instance-method","name":"error_cannot_impersonate?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":650,"url":null},"def":{"name":"error_cannot_impersonate?","visibility":"Public","body":"self == ERROR_CANNOT_IMPERSONATE"}},{"html_id":"error_cannot_make?-instance-method","name":"error_cannot_make?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":219,"url":null},"def":{"name":"error_cannot_make?","visibility":"Public","body":"self == ERROR_CANNOT_MAKE"}},{"html_id":"error_cannot_open_profile?-instance-method","name":"error_cannot_open_profile?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":506,"url":null},"def":{"name":"error_cannot_open_profile?","visibility":"Public","body":"self == ERROR_CANNOT_OPEN_PROFILE"}},{"html_id":"error_cannot_switch_runlevel?-instance-method","name":"error_cannot_switch_runlevel?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2186,"url":null},"def":{"name":"error_cannot_switch_runlevel?","visibility":"Public","body":"self == ERROR_CANNOT_SWITCH_RUNLEVEL"}},{"html_id":"error_cant_access_domain_info?-instance-method","name":"error_cant_access_domain_info?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":633,"url":null},"def":{"name":"error_cant_access_domain_info?","visibility":"Public","body":"self == ERROR_CANT_ACCESS_DOMAIN_INFO"}},{"html_id":"error_cant_access_file?-instance-method","name":"error_cant_access_file?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":945,"url":null},"def":{"name":"error_cant_access_file?","visibility":"Public","body":"self == ERROR_CANT_ACCESS_FILE"}},{"html_id":"error_cant_delete_last_item?-instance-method","name":"error_cant_delete_last_item?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1061,"url":null},"def":{"name":"error_cant_delete_last_item?","visibility":"Public","body":"self == ERROR_CANT_DELETE_LAST_ITEM"}},{"html_id":"error_cant_disable_mandatory?-instance-method","name":"error_cant_disable_mandatory?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":593,"url":null},"def":{"name":"error_cant_disable_mandatory?","visibility":"Public","body":"self == ERROR_CANT_DISABLE_MANDATORY"}},{"html_id":"error_cant_evict_active_node?-instance-method","name":"error_cant_evict_active_node?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1085,"url":null},"def":{"name":"error_cant_evict_active_node?","visibility":"Public","body":"self == ERROR_CANT_EVICT_ACTIVE_NODE"}},{"html_id":"error_cant_open_anonymous?-instance-method","name":"error_cant_open_anonymous?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":629,"url":null},"def":{"name":"error_cant_open_anonymous?","visibility":"Public","body":"self == ERROR_CANT_OPEN_ANONYMOUS"}},{"html_id":"error_cant_resolve_filename?-instance-method","name":"error_cant_resolve_filename?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":946,"url":null},"def":{"name":"error_cant_resolve_filename?","visibility":"Public","body":"self == ERROR_CANT_RESOLVE_FILENAME"}},{"html_id":"error_cantopen?-instance-method","name":"error_cantopen?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":388,"url":null},"def":{"name":"error_cantopen?","visibility":"Public","body":"self == ERROR_CANTOPEN"}},{"html_id":"error_cantread?-instance-method","name":"error_cantread?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":389,"url":null},"def":{"name":"error_cantread?","visibility":"Public","body":"self == ERROR_CANTREAD"}},{"html_id":"error_cantwrite?-instance-method","name":"error_cantwrite?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":390,"url":null},"def":{"name":"error_cantwrite?","visibility":"Public","body":"self == ERROR_CANTWRITE"}},{"html_id":"error_checkout_required?-instance-method","name":"error_checkout_required?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":327,"url":null},"def":{"name":"error_checkout_required?","visibility":"Public","body":"self == ERROR_CHECKOUT_REQUIRED"}},{"html_id":"error_child_must_be_volatile?-instance-method","name":"error_child_must_be_volatile?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":398,"url":null},"def":{"name":"error_child_must_be_volatile?","visibility":"Public","body":"self == ERROR_CHILD_MUST_BE_VOLATILE"}},{"html_id":"error_child_not_complete?-instance-method","name":"error_child_not_complete?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":254,"url":null},"def":{"name":"error_child_not_complete?","visibility":"Public","body":"self == ERROR_CHILD_NOT_COMPLETE"}},{"html_id":"error_child_window_menu?-instance-method","name":"error_child_window_menu?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":718,"url":null},"def":{"name":"error_child_window_menu?","visibility":"Public","body":"self == ERROR_CHILD_WINDOW_MENU"}},{"html_id":"error_circular_dependency?-instance-method","name":"error_circular_dependency?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":408,"url":null},"def":{"name":"error_circular_dependency?","visibility":"Public","body":"self == ERROR_CIRCULAR_DEPENDENCY"}},{"html_id":"error_class_already_exists?-instance-method","name":"error_class_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":692,"url":null},"def":{"name":"error_class_already_exists?","visibility":"Public","body":"self == ERROR_CLASS_ALREADY_EXISTS"}},{"html_id":"error_class_does_not_exist?-instance-method","name":"error_class_does_not_exist?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":693,"url":null},"def":{"name":"error_class_does_not_exist?","visibility":"Public","body":"self == ERROR_CLASS_DOES_NOT_EXIST"}},{"html_id":"error_class_has_windows?-instance-method","name":"error_class_has_windows?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":694,"url":null},"def":{"name":"error_class_has_windows?","visibility":"Public","body":"self == ERROR_CLASS_HAS_WINDOWS"}},{"html_id":"error_cleaner_cartridge_installed?-instance-method","name":"error_cleaner_cartridge_installed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1066,"url":null},"def":{"name":"error_cleaner_cartridge_installed?","visibility":"Public","body":"self == ERROR_CLEANER_CARTRIDGE_INSTALLED"}},{"html_id":"error_cleaner_cartridge_spent?-instance-method","name":"error_cleaner_cartridge_spent?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1059,"url":null},"def":{"name":"error_cleaner_cartridge_spent?","visibility":"Public","body":"self == ERROR_CLEANER_CARTRIDGE_SPENT"}},{"html_id":"error_cleaner_slot_not_set?-instance-method","name":"error_cleaner_slot_not_set?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1058,"url":null},"def":{"name":"error_cleaner_slot_not_set?","visibility":"Public","body":"self == ERROR_CLEANER_SLOT_NOT_SET"}},{"html_id":"error_cleaner_slot_set?-instance-method","name":"error_cleaner_slot_set?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1057,"url":null},"def":{"name":"error_cleaner_slot_set?","visibility":"Public","body":"self == ERROR_CLEANER_SLOT_SET"}},{"html_id":"error_clipboard_not_open?-instance-method","name":"error_clipboard_not_open?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":700,"url":null},"def":{"name":"error_clipboard_not_open?","visibility":"Public","body":"self == ERROR_CLIPBOARD_NOT_OPEN"}},{"html_id":"error_clipping_not_supported?-instance-method","name":"error_clipping_not_supported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":967,"url":null},"def":{"name":"error_clipping_not_supported?","visibility":"Public","body":"self == ERROR_CLIPPING_NOT_SUPPORTED"}},{"html_id":"error_cluscfg_already_committed?-instance-method","name":"error_cluscfg_already_committed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1176,"url":null},"def":{"name":"error_cluscfg_already_committed?","visibility":"Public","body":"self == ERROR_CLUSCFG_ALREADY_COMMITTED"}},{"html_id":"error_cluscfg_rollback_failed?-instance-method","name":"error_cluscfg_rollback_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1177,"url":null},"def":{"name":"error_cluscfg_rollback_failed?","visibility":"Public","body":"self == ERROR_CLUSCFG_ROLLBACK_FAILED"}},{"html_id":"error_cluscfg_system_disk_drive_letter_conflict?-instance-method","name":"error_cluscfg_system_disk_drive_letter_conflict?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1178,"url":null},"def":{"name":"error_cluscfg_system_disk_drive_letter_conflict?","visibility":"Public","body":"self == ERROR_CLUSCFG_SYSTEM_DISK_DRIVE_LETTER_CONFLICT"}},{"html_id":"error_cluster_cant_create_dup_cluster_name?-instance-method","name":"error_cluster_cant_create_dup_cluster_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1175,"url":null},"def":{"name":"error_cluster_cant_create_dup_cluster_name?","visibility":"Public","body":"self == ERROR_CLUSTER_CANT_CREATE_DUP_CLUSTER_NAME"}},{"html_id":"error_cluster_database_seqmismatch?-instance-method","name":"error_cluster_database_seqmismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1158,"url":null},"def":{"name":"error_cluster_database_seqmismatch?","visibility":"Public","body":"self == ERROR_CLUSTER_DATABASE_SEQMISMATCH"}},{"html_id":"error_cluster_evict_without_cleanup?-instance-method","name":"error_cluster_evict_without_cleanup?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1171,"url":null},"def":{"name":"error_cluster_evict_without_cleanup?","visibility":"Public","body":"self == ERROR_CLUSTER_EVICT_WITHOUT_CLEANUP"}},{"html_id":"error_cluster_gum_not_locker?-instance-method","name":"error_cluster_gum_not_locker?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1160,"url":null},"def":{"name":"error_cluster_gum_not_locker?","visibility":"Public","body":"self == ERROR_CLUSTER_GUM_NOT_LOCKER"}},{"html_id":"error_cluster_incompatible_versions?-instance-method","name":"error_cluster_incompatible_versions?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1150,"url":null},"def":{"name":"error_cluster_incompatible_versions?","visibility":"Public","body":"self == ERROR_CLUSTER_INCOMPATIBLE_VERSIONS"}},{"html_id":"error_cluster_instance_id_mismatch?-instance-method","name":"error_cluster_instance_id_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1168,"url":null},"def":{"name":"error_cluster_instance_id_mismatch?","visibility":"Public","body":"self == ERROR_CLUSTER_INSTANCE_ID_MISMATCH"}},{"html_id":"error_cluster_invalid_network?-instance-method","name":"error_cluster_invalid_network?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1130,"url":null},"def":{"name":"error_cluster_invalid_network?","visibility":"Public","body":"self == ERROR_CLUSTER_INVALID_NETWORK"}},{"html_id":"error_cluster_invalid_network_provider?-instance-method","name":"error_cluster_invalid_network_provider?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1125,"url":null},"def":{"name":"error_cluster_invalid_network_provider?","visibility":"Public","body":"self == ERROR_CLUSTER_INVALID_NETWORK_PROVIDER"}},{"html_id":"error_cluster_invalid_node?-instance-method","name":"error_cluster_invalid_node?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1115,"url":null},"def":{"name":"error_cluster_invalid_node?","visibility":"Public","body":"self == ERROR_CLUSTER_INVALID_NODE"}},{"html_id":"error_cluster_invalid_request?-instance-method","name":"error_cluster_invalid_request?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1124,"url":null},"def":{"name":"error_cluster_invalid_request?","visibility":"Public","body":"self == ERROR_CLUSTER_INVALID_REQUEST"}},{"html_id":"error_cluster_ipaddr_in_use?-instance-method","name":"error_cluster_ipaddr_in_use?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1132,"url":null},"def":{"name":"error_cluster_ipaddr_in_use?","visibility":"Public","body":"self == ERROR_CLUSTER_IPADDR_IN_USE"}},{"html_id":"error_cluster_join_aborted?-instance-method","name":"error_cluster_join_aborted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1149,"url":null},"def":{"name":"error_cluster_join_aborted?","visibility":"Public","body":"self == ERROR_CLUSTER_JOIN_ABORTED"}},{"html_id":"error_cluster_join_in_progress?-instance-method","name":"error_cluster_join_in_progress?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1117,"url":null},"def":{"name":"error_cluster_join_in_progress?","visibility":"Public","body":"self == ERROR_CLUSTER_JOIN_IN_PROGRESS"}},{"html_id":"error_cluster_join_not_in_progress?-instance-method","name":"error_cluster_join_not_in_progress?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1129,"url":null},"def":{"name":"error_cluster_join_not_in_progress?","visibility":"Public","body":"self == ERROR_CLUSTER_JOIN_NOT_IN_PROGRESS"}},{"html_id":"error_cluster_last_internal_network?-instance-method","name":"error_cluster_last_internal_network?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1141,"url":null},"def":{"name":"error_cluster_last_internal_network?","visibility":"Public","body":"self == ERROR_CLUSTER_LAST_INTERNAL_NETWORK"}},{"html_id":"error_cluster_local_node_not_found?-instance-method","name":"error_cluster_local_node_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1119,"url":null},"def":{"name":"error_cluster_local_node_not_found?","visibility":"Public","body":"self == ERROR_CLUSTER_LOCAL_NODE_NOT_FOUND"}},{"html_id":"error_cluster_maxnum_of_resources_exceeded?-instance-method","name":"error_cluster_maxnum_of_resources_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1151,"url":null},"def":{"name":"error_cluster_maxnum_of_resources_exceeded?","visibility":"Public","body":"self == ERROR_CLUSTER_MAXNUM_OF_RESOURCES_EXCEEDED"}},{"html_id":"error_cluster_membership_halt?-instance-method","name":"error_cluster_membership_halt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1167,"url":null},"def":{"name":"error_cluster_membership_halt?","visibility":"Public","body":"self == ERROR_CLUSTER_MEMBERSHIP_HALT"}},{"html_id":"error_cluster_membership_invalid_state?-instance-method","name":"error_cluster_membership_invalid_state?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1165,"url":null},"def":{"name":"error_cluster_membership_invalid_state?","visibility":"Public","body":"self == ERROR_CLUSTER_MEMBERSHIP_INVALID_STATE"}},{"html_id":"error_cluster_mismatched_computer_acct_name?-instance-method","name":"error_cluster_mismatched_computer_acct_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1180,"url":null},"def":{"name":"error_cluster_mismatched_computer_acct_name?","visibility":"Public","body":"self == ERROR_CLUSTER_MISMATCHED_COMPUTER_ACCT_NAME"}},{"html_id":"error_cluster_netinterface_exists?-instance-method","name":"error_cluster_netinterface_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1122,"url":null},"def":{"name":"error_cluster_netinterface_exists?","visibility":"Public","body":"self == ERROR_CLUSTER_NETINTERFACE_EXISTS"}},{"html_id":"error_cluster_netinterface_not_found?-instance-method","name":"error_cluster_netinterface_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1123,"url":null},"def":{"name":"error_cluster_netinterface_not_found?","visibility":"Public","body":"self == ERROR_CLUSTER_NETINTERFACE_NOT_FOUND"}},{"html_id":"error_cluster_network_already_offline?-instance-method","name":"error_cluster_network_already_offline?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1139,"url":null},"def":{"name":"error_cluster_network_already_offline?","visibility":"Public","body":"self == ERROR_CLUSTER_NETWORK_ALREADY_OFFLINE"}},{"html_id":"error_cluster_network_already_online?-instance-method","name":"error_cluster_network_already_online?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1138,"url":null},"def":{"name":"error_cluster_network_already_online?","visibility":"Public","body":"self == ERROR_CLUSTER_NETWORK_ALREADY_ONLINE"}},{"html_id":"error_cluster_network_exists?-instance-method","name":"error_cluster_network_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1120,"url":null},"def":{"name":"error_cluster_network_exists?","visibility":"Public","body":"self == ERROR_CLUSTER_NETWORK_EXISTS"}},{"html_id":"error_cluster_network_has_dependents?-instance-method","name":"error_cluster_network_has_dependents?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1142,"url":null},"def":{"name":"error_cluster_network_has_dependents?","visibility":"Public","body":"self == ERROR_CLUSTER_NETWORK_HAS_DEPENDENTS"}},{"html_id":"error_cluster_network_not_found?-instance-method","name":"error_cluster_network_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1121,"url":null},"def":{"name":"error_cluster_network_not_found?","visibility":"Public","body":"self == ERROR_CLUSTER_NETWORK_NOT_FOUND"}},{"html_id":"error_cluster_network_not_found_for_ip?-instance-method","name":"error_cluster_network_not_found_for_ip?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1169,"url":null},"def":{"name":"error_cluster_network_not_found_for_ip?","visibility":"Public","body":"self == ERROR_CLUSTER_NETWORK_NOT_FOUND_FOR_IP"}},{"html_id":"error_cluster_network_not_internal?-instance-method","name":"error_cluster_network_not_internal?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1135,"url":null},"def":{"name":"error_cluster_network_not_internal?","visibility":"Public","body":"self == ERROR_CLUSTER_NETWORK_NOT_INTERNAL"}},{"html_id":"error_cluster_no_rpc_packages_registered?-instance-method","name":"error_cluster_no_rpc_packages_registered?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1156,"url":null},"def":{"name":"error_cluster_no_rpc_packages_registered?","visibility":"Public","body":"self == ERROR_CLUSTER_NO_RPC_PACKAGES_REGISTERED"}},{"html_id":"error_cluster_no_security_context?-instance-method","name":"error_cluster_no_security_context?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1134,"url":null},"def":{"name":"error_cluster_no_security_context?","visibility":"Public","body":"self == ERROR_CLUSTER_NO_SECURITY_CONTEXT"}},{"html_id":"error_cluster_node_already_down?-instance-method","name":"error_cluster_node_already_down?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1137,"url":null},"def":{"name":"error_cluster_node_already_down?","visibility":"Public","body":"self == ERROR_CLUSTER_NODE_ALREADY_DOWN"}},{"html_id":"error_cluster_node_already_has_dfs_root?-instance-method","name":"error_cluster_node_already_has_dfs_root?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1163,"url":null},"def":{"name":"error_cluster_node_already_has_dfs_root?","visibility":"Public","body":"self == ERROR_CLUSTER_NODE_ALREADY_HAS_DFS_ROOT"}},{"html_id":"error_cluster_node_already_member?-instance-method","name":"error_cluster_node_already_member?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1140,"url":null},"def":{"name":"error_cluster_node_already_member?","visibility":"Public","body":"self == ERROR_CLUSTER_NODE_ALREADY_MEMBER"}},{"html_id":"error_cluster_node_already_up?-instance-method","name":"error_cluster_node_already_up?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1136,"url":null},"def":{"name":"error_cluster_node_already_up?","visibility":"Public","body":"self == ERROR_CLUSTER_NODE_ALREADY_UP"}},{"html_id":"error_cluster_node_down?-instance-method","name":"error_cluster_node_down?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1126,"url":null},"def":{"name":"error_cluster_node_down?","visibility":"Public","body":"self == ERROR_CLUSTER_NODE_DOWN"}},{"html_id":"error_cluster_node_exists?-instance-method","name":"error_cluster_node_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1116,"url":null},"def":{"name":"error_cluster_node_exists?","visibility":"Public","body":"self == ERROR_CLUSTER_NODE_EXISTS"}},{"html_id":"error_cluster_node_not_found?-instance-method","name":"error_cluster_node_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1118,"url":null},"def":{"name":"error_cluster_node_not_found?","visibility":"Public","body":"self == ERROR_CLUSTER_NODE_NOT_FOUND"}},{"html_id":"error_cluster_node_not_member?-instance-method","name":"error_cluster_node_not_member?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1128,"url":null},"def":{"name":"error_cluster_node_not_member?","visibility":"Public","body":"self == ERROR_CLUSTER_NODE_NOT_MEMBER"}},{"html_id":"error_cluster_node_not_paused?-instance-method","name":"error_cluster_node_not_paused?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1133,"url":null},"def":{"name":"error_cluster_node_not_paused?","visibility":"Public","body":"self == ERROR_CLUSTER_NODE_NOT_PAUSED"}},{"html_id":"error_cluster_node_not_ready?-instance-method","name":"error_cluster_node_not_ready?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1147,"url":null},"def":{"name":"error_cluster_node_not_ready?","visibility":"Public","body":"self == ERROR_CLUSTER_NODE_NOT_READY"}},{"html_id":"error_cluster_node_paused?-instance-method","name":"error_cluster_node_paused?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1145,"url":null},"def":{"name":"error_cluster_node_paused?","visibility":"Public","body":"self == ERROR_CLUSTER_NODE_PAUSED"}},{"html_id":"error_cluster_node_shutting_down?-instance-method","name":"error_cluster_node_shutting_down?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1148,"url":null},"def":{"name":"error_cluster_node_shutting_down?","visibility":"Public","body":"self == ERROR_CLUSTER_NODE_SHUTTING_DOWN"}},{"html_id":"error_cluster_node_unreachable?-instance-method","name":"error_cluster_node_unreachable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1127,"url":null},"def":{"name":"error_cluster_node_unreachable?","visibility":"Public","body":"self == ERROR_CLUSTER_NODE_UNREACHABLE"}},{"html_id":"error_cluster_node_up?-instance-method","name":"error_cluster_node_up?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1131,"url":null},"def":{"name":"error_cluster_node_up?","visibility":"Public","body":"self == ERROR_CLUSTER_NODE_UP"}},{"html_id":"error_cluster_old_version?-instance-method","name":"error_cluster_old_version?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1179,"url":null},"def":{"name":"error_cluster_old_version?","visibility":"Public","body":"self == ERROR_CLUSTER_OLD_VERSION"}},{"html_id":"error_cluster_owner_not_in_preflist?-instance-method","name":"error_cluster_owner_not_in_preflist?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1157,"url":null},"def":{"name":"error_cluster_owner_not_in_preflist?","visibility":"Public","body":"self == ERROR_CLUSTER_OWNER_NOT_IN_PREFLIST"}},{"html_id":"error_cluster_parameter_mismatch?-instance-method","name":"error_cluster_parameter_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1172,"url":null},"def":{"name":"error_cluster_parameter_mismatch?","visibility":"Public","body":"self == ERROR_CLUSTER_PARAMETER_MISMATCH"}},{"html_id":"error_cluster_property_data_type_mismatch?-instance-method","name":"error_cluster_property_data_type_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1170,"url":null},"def":{"name":"error_cluster_property_data_type_mismatch?","visibility":"Public","body":"self == ERROR_CLUSTER_PROPERTY_DATA_TYPE_MISMATCH"}},{"html_id":"error_cluster_quorumlog_not_found?-instance-method","name":"error_cluster_quorumlog_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1166,"url":null},"def":{"name":"error_cluster_quorumlog_not_found?","visibility":"Public","body":"self == ERROR_CLUSTER_QUORUMLOG_NOT_FOUND"}},{"html_id":"error_cluster_resname_not_found?-instance-method","name":"error_cluster_resname_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1155,"url":null},"def":{"name":"error_cluster_resname_not_found?","visibility":"Public","body":"self == ERROR_CLUSTER_RESNAME_NOT_FOUND"}},{"html_id":"error_cluster_resource_type_not_found?-instance-method","name":"error_cluster_resource_type_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1153,"url":null},"def":{"name":"error_cluster_resource_type_not_found?","visibility":"Public","body":"self == ERROR_CLUSTER_RESOURCE_TYPE_NOT_FOUND"}},{"html_id":"error_cluster_restype_not_supported?-instance-method","name":"error_cluster_restype_not_supported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1154,"url":null},"def":{"name":"error_cluster_restype_not_supported?","visibility":"Public","body":"self == ERROR_CLUSTER_RESTYPE_NOT_SUPPORTED"}},{"html_id":"error_cluster_shutting_down?-instance-method","name":"error_cluster_shutting_down?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1098,"url":null},"def":{"name":"error_cluster_shutting_down?","visibility":"Public","body":"self == ERROR_CLUSTER_SHUTTING_DOWN"}},{"html_id":"error_cluster_system_config_changed?-instance-method","name":"error_cluster_system_config_changed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1152,"url":null},"def":{"name":"error_cluster_system_config_changed?","visibility":"Public","body":"self == ERROR_CLUSTER_SYSTEM_CONFIG_CHANGED"}},{"html_id":"error_cluster_wrong_os_version?-instance-method","name":"error_cluster_wrong_os_version?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1174,"url":null},"def":{"name":"error_cluster_wrong_os_version?","visibility":"Public","body":"self == ERROR_CLUSTER_WRONG_OS_VERSION"}},{"html_id":"error_clusterlog_chkpoint_not_found?-instance-method","name":"error_clusterlog_chkpoint_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1108,"url":null},"def":{"name":"error_clusterlog_chkpoint_not_found?","visibility":"Public","body":"self == ERROR_CLUSTERLOG_CHKPOINT_NOT_FOUND"}},{"html_id":"error_clusterlog_corrupt?-instance-method","name":"error_clusterlog_corrupt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1105,"url":null},"def":{"name":"error_clusterlog_corrupt?","visibility":"Public","body":"self == ERROR_CLUSTERLOG_CORRUPT"}},{"html_id":"error_clusterlog_exceeds_maxsize?-instance-method","name":"error_clusterlog_exceeds_maxsize?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1107,"url":null},"def":{"name":"error_clusterlog_exceeds_maxsize?","visibility":"Public","body":"self == ERROR_CLUSTERLOG_EXCEEDS_MAXSIZE"}},{"html_id":"error_clusterlog_not_enough_space?-instance-method","name":"error_clusterlog_not_enough_space?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1109,"url":null},"def":{"name":"error_clusterlog_not_enough_space?","visibility":"Public","body":"self == ERROR_CLUSTERLOG_NOT_ENOUGH_SPACE"}},{"html_id":"error_clusterlog_record_exceeds_maxsize?-instance-method","name":"error_clusterlog_record_exceeds_maxsize?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1106,"url":null},"def":{"name":"error_clusterlog_record_exceeds_maxsize?","visibility":"Public","body":"self == ERROR_CLUSTERLOG_RECORD_EXCEEDS_MAXSIZE"}},{"html_id":"error_colorspace_mismatch?-instance-method","name":"error_colorspace_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":979,"url":null},"def":{"name":"error_colorspace_mismatch?","visibility":"Public","body":"self == ERROR_COLORSPACE_MISMATCH"}},{"html_id":"error_com_task_stop_pending?-instance-method","name":"error_com_task_stop_pending?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2192,"url":null},"def":{"name":"error_com_task_stop_pending?","visibility":"Public","body":"self == ERROR_COM_TASK_STOP_PENDING"}},{"html_id":"error_commitment_limit?-instance-method","name":"error_commitment_limit?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":737,"url":null},"def":{"name":"error_commitment_limit?","visibility":"Public","body":"self == ERROR_COMMITMENT_LIMIT"}},{"html_id":"error_connected_other_password?-instance-method","name":"error_connected_other_password?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":981,"url":null},"def":{"name":"error_connected_other_password?","visibility":"Public","body":"self == ERROR_CONNECTED_OTHER_PASSWORD"}},{"html_id":"error_connected_other_password_default?-instance-method","name":"error_connected_other_password_default?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":982,"url":null},"def":{"name":"error_connected_other_password_default?","visibility":"Public","body":"self == ERROR_CONNECTED_OTHER_PASSWORD_DEFAULT"}},{"html_id":"error_connection_aborted?-instance-method","name":"error_connection_aborted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":537,"url":null},"def":{"name":"error_connection_aborted?","visibility":"Public","body":"self == ERROR_CONNECTION_ABORTED"}},{"html_id":"error_connection_active?-instance-method","name":"error_connection_active?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":531,"url":null},"def":{"name":"error_connection_active?","visibility":"Public","body":"self == ERROR_CONNECTION_ACTIVE"}},{"html_id":"error_connection_count_limit?-instance-method","name":"error_connection_count_limit?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":539,"url":null},"def":{"name":"error_connection_count_limit?","visibility":"Public","body":"self == ERROR_CONNECTION_COUNT_LIMIT"}},{"html_id":"error_connection_invalid?-instance-method","name":"error_connection_invalid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":530,"url":null},"def":{"name":"error_connection_invalid?","visibility":"Public","body":"self == ERROR_CONNECTION_INVALID"}},{"html_id":"error_connection_refused?-instance-method","name":"error_connection_refused?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":526,"url":null},"def":{"name":"error_connection_refused?","visibility":"Public","body":"self == ERROR_CONNECTION_REFUSED"}},{"html_id":"error_connection_unavail?-instance-method","name":"error_connection_unavail?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":502,"url":null},"def":{"name":"error_connection_unavail?","visibility":"Public","body":"self == ERROR_CONNECTION_UNAVAIL"}},{"html_id":"error_context_expired?-instance-method","name":"error_context_expired?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":956,"url":null},"def":{"name":"error_context_expired?","visibility":"Public","body":"self == ERROR_CONTEXT_EXPIRED"}},{"html_id":"error_continue?-instance-method","name":"error_continue?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":547,"url":null},"def":{"name":"error_continue?","visibility":"Public","body":"self == ERROR_CONTINUE"}},{"html_id":"error_control_id_not_found?-instance-method","name":"error_control_id_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":703,"url":null},"def":{"name":"error_control_id_not_found?","visibility":"Public","body":"self == ERROR_CONTROL_ID_NOT_FOUND"}},{"html_id":"error_controlling_ieport?-instance-method","name":"error_controlling_ieport?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1055,"url":null},"def":{"name":"error_controlling_ieport?","visibility":"Public","body":"self == ERROR_CONTROLLING_IEPORT"}},{"html_id":"error_core_resource?-instance-method","name":"error_core_resource?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1102,"url":null},"def":{"name":"error_core_resource?","visibility":"Public","body":"self == ERROR_CORE_RESOURCE"}},{"html_id":"error_counter_timeout?-instance-method","name":"error_counter_timeout?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":455,"url":null},"def":{"name":"error_counter_timeout?","visibility":"Public","body":"self == ERROR_COUNTER_TIMEOUT"}},{"html_id":"error_crc?-instance-method","name":"error_crc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":180,"url":null},"def":{"name":"error_crc?","visibility":"Public","body":"self == ERROR_CRC"}},{"html_id":"error_create_failed?-instance-method","name":"error_create_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":779,"url":null},"def":{"name":"error_create_failed?","visibility":"Public","body":"self == ERROR_CREATE_FAILED"}},{"html_id":"error_cscshare_offline?-instance-method","name":"error_cscshare_offline?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":563,"url":null},"def":{"name":"error_cscshare_offline?","visibility":"Public","body":"self == ERROR_CSCSHARE_OFFLINE"}},{"html_id":"error_ctx_bad_video_mode?-instance-method","name":"error_ctx_bad_video_mode?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1220,"url":null},"def":{"name":"error_ctx_bad_video_mode?","visibility":"Public","body":"self == ERROR_CTX_BAD_VIDEO_MODE"}},{"html_id":"error_ctx_cannot_make_eventlog_entry?-instance-method","name":"error_ctx_cannot_make_eventlog_entry?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1204,"url":null},"def":{"name":"error_ctx_cannot_make_eventlog_entry?","visibility":"Public","body":"self == ERROR_CTX_CANNOT_MAKE_EVENTLOG_ENTRY"}},{"html_id":"error_ctx_client_license_in_use?-instance-method","name":"error_ctx_client_license_in_use?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1232,"url":null},"def":{"name":"error_ctx_client_license_in_use?","visibility":"Public","body":"self == ERROR_CTX_CLIENT_LICENSE_IN_USE"}},{"html_id":"error_ctx_client_license_not_set?-instance-method","name":"error_ctx_client_license_not_set?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1233,"url":null},"def":{"name":"error_ctx_client_license_not_set?","visibility":"Public","body":"self == ERROR_CTX_CLIENT_LICENSE_NOT_SET"}},{"html_id":"error_ctx_client_query_timeout?-instance-method","name":"error_ctx_client_query_timeout?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1224,"url":null},"def":{"name":"error_ctx_client_query_timeout?","visibility":"Public","body":"self == ERROR_CTX_CLIENT_QUERY_TIMEOUT"}},{"html_id":"error_ctx_close_pending?-instance-method","name":"error_ctx_close_pending?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1206,"url":null},"def":{"name":"error_ctx_close_pending?","visibility":"Public","body":"self == ERROR_CTX_CLOSE_PENDING"}},{"html_id":"error_ctx_console_connect?-instance-method","name":"error_ctx_console_connect?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1226,"url":null},"def":{"name":"error_ctx_console_connect?","visibility":"Public","body":"self == ERROR_CTX_CONSOLE_CONNECT"}},{"html_id":"error_ctx_console_disconnect?-instance-method","name":"error_ctx_console_disconnect?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1225,"url":null},"def":{"name":"error_ctx_console_disconnect?","visibility":"Public","body":"self == ERROR_CTX_CONSOLE_DISCONNECT"}},{"html_id":"error_ctx_graphics_invalid?-instance-method","name":"error_ctx_graphics_invalid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1221,"url":null},"def":{"name":"error_ctx_graphics_invalid?","visibility":"Public","body":"self == ERROR_CTX_GRAPHICS_INVALID"}},{"html_id":"error_ctx_invalid_modemname?-instance-method","name":"error_ctx_invalid_modemname?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1209,"url":null},"def":{"name":"error_ctx_invalid_modemname?","visibility":"Public","body":"self == ERROR_CTX_INVALID_MODEMNAME"}},{"html_id":"error_ctx_invalid_pd?-instance-method","name":"error_ctx_invalid_pd?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1201,"url":null},"def":{"name":"error_ctx_invalid_pd?","visibility":"Public","body":"self == ERROR_CTX_INVALID_PD"}},{"html_id":"error_ctx_invalid_wd?-instance-method","name":"error_ctx_invalid_wd?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1229,"url":null},"def":{"name":"error_ctx_invalid_wd?","visibility":"Public","body":"self == ERROR_CTX_INVALID_WD"}},{"html_id":"error_ctx_license_client_invalid?-instance-method","name":"error_ctx_license_client_invalid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1235,"url":null},"def":{"name":"error_ctx_license_client_invalid?","visibility":"Public","body":"self == ERROR_CTX_LICENSE_CLIENT_INVALID"}},{"html_id":"error_ctx_license_expired?-instance-method","name":"error_ctx_license_expired?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1236,"url":null},"def":{"name":"error_ctx_license_expired?","visibility":"Public","body":"self == ERROR_CTX_LICENSE_EXPIRED"}},{"html_id":"error_ctx_license_not_available?-instance-method","name":"error_ctx_license_not_available?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1234,"url":null},"def":{"name":"error_ctx_license_not_available?","visibility":"Public","body":"self == ERROR_CTX_LICENSE_NOT_AVAILABLE"}},{"html_id":"error_ctx_logon_disabled?-instance-method","name":"error_ctx_logon_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1222,"url":null},"def":{"name":"error_ctx_logon_disabled?","visibility":"Public","body":"self == ERROR_CTX_LOGON_DISABLED"}},{"html_id":"error_ctx_modem_inf_not_found?-instance-method","name":"error_ctx_modem_inf_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1208,"url":null},"def":{"name":"error_ctx_modem_inf_not_found?","visibility":"Public","body":"self == ERROR_CTX_MODEM_INF_NOT_FOUND"}},{"html_id":"error_ctx_modem_response_busy?-instance-method","name":"error_ctx_modem_response_busy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1214,"url":null},"def":{"name":"error_ctx_modem_response_busy?","visibility":"Public","body":"self == ERROR_CTX_MODEM_RESPONSE_BUSY"}},{"html_id":"error_ctx_modem_response_error?-instance-method","name":"error_ctx_modem_response_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1210,"url":null},"def":{"name":"error_ctx_modem_response_error?","visibility":"Public","body":"self == ERROR_CTX_MODEM_RESPONSE_ERROR"}},{"html_id":"error_ctx_modem_response_no_carrier?-instance-method","name":"error_ctx_modem_response_no_carrier?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1212,"url":null},"def":{"name":"error_ctx_modem_response_no_carrier?","visibility":"Public","body":"self == ERROR_CTX_MODEM_RESPONSE_NO_CARRIER"}},{"html_id":"error_ctx_modem_response_no_dialtone?-instance-method","name":"error_ctx_modem_response_no_dialtone?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1213,"url":null},"def":{"name":"error_ctx_modem_response_no_dialtone?","visibility":"Public","body":"self == ERROR_CTX_MODEM_RESPONSE_NO_DIALTONE"}},{"html_id":"error_ctx_modem_response_timeout?-instance-method","name":"error_ctx_modem_response_timeout?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1211,"url":null},"def":{"name":"error_ctx_modem_response_timeout?","visibility":"Public","body":"self == ERROR_CTX_MODEM_RESPONSE_TIMEOUT"}},{"html_id":"error_ctx_modem_response_voice?-instance-method","name":"error_ctx_modem_response_voice?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1215,"url":null},"def":{"name":"error_ctx_modem_response_voice?","visibility":"Public","body":"self == ERROR_CTX_MODEM_RESPONSE_VOICE"}},{"html_id":"error_ctx_no_outbuf?-instance-method","name":"error_ctx_no_outbuf?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1207,"url":null},"def":{"name":"error_ctx_no_outbuf?","visibility":"Public","body":"self == ERROR_CTX_NO_OUTBUF"}},{"html_id":"error_ctx_not_console?-instance-method","name":"error_ctx_not_console?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1223,"url":null},"def":{"name":"error_ctx_not_console?","visibility":"Public","body":"self == ERROR_CTX_NOT_CONSOLE"}},{"html_id":"error_ctx_pd_not_found?-instance-method","name":"error_ctx_pd_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1202,"url":null},"def":{"name":"error_ctx_pd_not_found?","visibility":"Public","body":"self == ERROR_CTX_PD_NOT_FOUND"}},{"html_id":"error_ctx_service_name_collision?-instance-method","name":"error_ctx_service_name_collision?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1205,"url":null},"def":{"name":"error_ctx_service_name_collision?","visibility":"Public","body":"self == ERROR_CTX_SERVICE_NAME_COLLISION"}},{"html_id":"error_ctx_shadow_denied?-instance-method","name":"error_ctx_shadow_denied?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1227,"url":null},"def":{"name":"error_ctx_shadow_denied?","visibility":"Public","body":"self == ERROR_CTX_SHADOW_DENIED"}},{"html_id":"error_ctx_shadow_disabled?-instance-method","name":"error_ctx_shadow_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1231,"url":null},"def":{"name":"error_ctx_shadow_disabled?","visibility":"Public","body":"self == ERROR_CTX_SHADOW_DISABLED"}},{"html_id":"error_ctx_shadow_ended_by_mode_change?-instance-method","name":"error_ctx_shadow_ended_by_mode_change?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1238,"url":null},"def":{"name":"error_ctx_shadow_ended_by_mode_change?","visibility":"Public","body":"self == ERROR_CTX_SHADOW_ENDED_BY_MODE_CHANGE"}},{"html_id":"error_ctx_shadow_invalid?-instance-method","name":"error_ctx_shadow_invalid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1230,"url":null},"def":{"name":"error_ctx_shadow_invalid?","visibility":"Public","body":"self == ERROR_CTX_SHADOW_INVALID"}},{"html_id":"error_ctx_shadow_not_running?-instance-method","name":"error_ctx_shadow_not_running?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1237,"url":null},"def":{"name":"error_ctx_shadow_not_running?","visibility":"Public","body":"self == ERROR_CTX_SHADOW_NOT_RUNNING"}},{"html_id":"error_ctx_td_error?-instance-method","name":"error_ctx_td_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1216,"url":null},"def":{"name":"error_ctx_td_error?","visibility":"Public","body":"self == ERROR_CTX_TD_ERROR"}},{"html_id":"error_ctx_wd_not_found?-instance-method","name":"error_ctx_wd_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1203,"url":null},"def":{"name":"error_ctx_wd_not_found?","visibility":"Public","body":"self == ERROR_CTX_WD_NOT_FOUND"}},{"html_id":"error_ctx_winstation_access_denied?-instance-method","name":"error_ctx_winstation_access_denied?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1228,"url":null},"def":{"name":"error_ctx_winstation_access_denied?","visibility":"Public","body":"self == ERROR_CTX_WINSTATION_ACCESS_DENIED"}},{"html_id":"error_ctx_winstation_already_exists?-instance-method","name":"error_ctx_winstation_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1218,"url":null},"def":{"name":"error_ctx_winstation_already_exists?","visibility":"Public","body":"self == ERROR_CTX_WINSTATION_ALREADY_EXISTS"}},{"html_id":"error_ctx_winstation_busy?-instance-method","name":"error_ctx_winstation_busy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1219,"url":null},"def":{"name":"error_ctx_winstation_busy?","visibility":"Public","body":"self == ERROR_CTX_WINSTATION_BUSY"}},{"html_id":"error_ctx_winstation_name_invalid?-instance-method","name":"error_ctx_winstation_name_invalid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1200,"url":null},"def":{"name":"error_ctx_winstation_name_invalid?","visibility":"Public","body":"self == ERROR_CTX_WINSTATION_NAME_INVALID"}},{"html_id":"error_ctx_winstation_not_found?-instance-method","name":"error_ctx_winstation_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1217,"url":null},"def":{"name":"error_ctx_winstation_not_found?","visibility":"Public","body":"self == ERROR_CTX_WINSTATION_NOT_FOUND"}},{"html_id":"error_current_directory?-instance-method","name":"error_current_directory?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":173,"url":null},"def":{"name":"error_current_directory?","visibility":"Public","body":"self == ERROR_CURRENT_DIRECTORY"}},{"html_id":"error_current_domain_not_allowed?-instance-method","name":"error_current_domain_not_allowed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":681,"url":null},"def":{"name":"error_current_domain_not_allowed?","visibility":"Public","body":"self == ERROR_CURRENT_DOMAIN_NOT_ALLOWED"}},{"html_id":"error_database_backup_corrupt?-instance-method","name":"error_database_backup_corrupt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1162,"url":null},"def":{"name":"error_database_backup_corrupt?","visibility":"Public","body":"self == ERROR_DATABASE_BACKUP_CORRUPT"}},{"html_id":"error_database_does_not_exist?-instance-method","name":"error_database_does_not_exist?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":414,"url":null},"def":{"name":"error_database_does_not_exist?","visibility":"Public","body":"self == ERROR_DATABASE_DOES_NOT_EXIST"}},{"html_id":"error_database_failure?-instance-method","name":"error_database_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1039,"url":null},"def":{"name":"error_database_failure?","visibility":"Public","body":"self == ERROR_DATABASE_FAILURE"}},{"html_id":"error_database_full?-instance-method","name":"error_database_full?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1040,"url":null},"def":{"name":"error_database_full?","visibility":"Public","body":"self == ERROR_DATABASE_FULL"}},{"html_id":"error_datatype_mismatch?-instance-method","name":"error_datatype_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":777,"url":null},"def":{"name":"error_datatype_mismatch?","visibility":"Public","body":"self == ERROR_DATATYPE_MISMATCH"}},{"html_id":"error_dc_not_found?-instance-method","name":"error_dc_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":707,"url":null},"def":{"name":"error_dc_not_found?","visibility":"Public","body":"self == ERROR_DC_NOT_FOUND"}},{"html_id":"error_dde_fail?-instance-method","name":"error_dde_fail?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":476,"url":null},"def":{"name":"error_dde_fail?","visibility":"Public","body":"self == ERROR_DDE_FAIL"}},{"html_id":"error_debugger_inactive?-instance-method","name":"error_debugger_inactive?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":579,"url":null},"def":{"name":"error_debugger_inactive?","visibility":"Public","body":"self == ERROR_DEBUGGER_INACTIVE"}},{"html_id":"error_decryption_failed?-instance-method","name":"error_decryption_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1182,"url":null},"def":{"name":"error_decryption_failed?","visibility":"Public","body":"self == ERROR_DECRYPTION_FAILED"}},{"html_id":"error_delay_load_failed?-instance-method","name":"error_delay_load_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":580,"url":null},"def":{"name":"error_delay_load_failed?","visibility":"Public","body":"self == ERROR_DELAY_LOAD_FAILED"}},{"html_id":"error_delete_pending?-instance-method","name":"error_delete_pending?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":355,"url":null},"def":{"name":"error_delete_pending?","visibility":"Public","body":"self == ERROR_DELETE_PENDING"}},{"html_id":"error_deleting_existing_applicationdata_store_failed?-instance-method","name":"error_deleting_existing_applicationdata_store_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2214,"url":null},"def":{"name":"error_deleting_existing_applicationdata_store_failed?","visibility":"Public","body":"self == ERROR_DELETING_EXISTING_APPLICATIONDATA_STORE_FAILED"}},{"html_id":"error_deleting_icm_xform?-instance-method","name":"error_deleting_icm_xform?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":977,"url":null},"def":{"name":"error_deleting_icm_xform?","visibility":"Public","body":"self == ERROR_DELETING_ICM_XFORM"}},{"html_id":"error_dependency_already_exists?-instance-method","name":"error_dependency_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1079,"url":null},"def":{"name":"error_dependency_already_exists?","visibility":"Public","body":"self == ERROR_DEPENDENCY_ALREADY_EXISTS"}},{"html_id":"error_dependency_not_allowed?-instance-method","name":"error_dependency_not_allowed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1144,"url":null},"def":{"name":"error_dependency_not_allowed?","visibility":"Public","body":"self == ERROR_DEPENDENCY_NOT_ALLOWED"}},{"html_id":"error_dependency_not_found?-instance-method","name":"error_dependency_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1078,"url":null},"def":{"name":"error_dependency_not_found?","visibility":"Public","body":"self == ERROR_DEPENDENCY_NOT_FOUND"}},{"html_id":"error_dependent_resource_exists?-instance-method","name":"error_dependent_resource_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1077,"url":null},"def":{"name":"error_dependent_resource_exists?","visibility":"Public","body":"self == ERROR_DEPENDENT_RESOURCE_EXISTS"}},{"html_id":"error_dependent_services_running?-instance-method","name":"error_dependent_services_running?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":400,"url":null},"def":{"name":"error_dependent_services_running?","visibility":"Public","body":"self == ERROR_DEPENDENT_SERVICES_RUNNING"}},{"html_id":"error_deployment_blocked_by_policy?-instance-method","name":"error_deployment_blocked_by_policy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2210,"url":null},"def":{"name":"error_deployment_blocked_by_policy?","visibility":"Public","body":"self == ERROR_DEPLOYMENT_BLOCKED_BY_POLICY"}},{"html_id":"error_destination_element_full?-instance-method","name":"error_destination_element_full?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":481,"url":null},"def":{"name":"error_destination_element_full?","visibility":"Public","body":"self == ERROR_DESTINATION_ELEMENT_FULL"}},{"html_id":"error_destroy_object_of_other_thread?-instance-method","name":"error_destroy_object_of_other_thread?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":717,"url":null},"def":{"name":"error_destroy_object_of_other_thread?","visibility":"Public","body":"self == ERROR_DESTROY_OBJECT_OF_OTHER_THREAD"}},{"html_id":"error_dev_not_exist?-instance-method","name":"error_dev_not_exist?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":200,"url":null},"def":{"name":"error_dev_not_exist?","visibility":"Public","body":"self == ERROR_DEV_NOT_EXIST"}},{"html_id":"error_device_already_remembered?-instance-method","name":"error_device_already_remembered?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":503,"url":null},"def":{"name":"error_device_already_remembered?","visibility":"Public","body":"self == ERROR_DEVICE_ALREADY_REMEMBERED"}},{"html_id":"error_device_door_open?-instance-method","name":"error_device_door_open?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":486,"url":null},"def":{"name":"error_device_door_open?","visibility":"Public","body":"self == ERROR_DEVICE_DOOR_OPEN"}},{"html_id":"error_device_in_use?-instance-method","name":"error_device_in_use?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":987,"url":null},"def":{"name":"error_device_in_use?","visibility":"Public","body":"self == ERROR_DEVICE_IN_USE"}},{"html_id":"error_device_not_available?-instance-method","name":"error_device_not_available?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1045,"url":null},"def":{"name":"error_device_not_available?","visibility":"Public","body":"self == ERROR_DEVICE_NOT_AVAILABLE"}},{"html_id":"error_device_not_connected?-instance-method","name":"error_device_not_connected?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":487,"url":null},"def":{"name":"error_device_not_connected?","visibility":"Public","body":"self == ERROR_DEVICE_NOT_CONNECTED"}},{"html_id":"error_device_not_partitioned?-instance-method","name":"error_device_not_partitioned?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":441,"url":null},"def":{"name":"error_device_not_partitioned?","visibility":"Public","body":"self == ERROR_DEVICE_NOT_PARTITIONED"}},{"html_id":"error_device_reinitialization_needed?-instance-method","name":"error_device_reinitialization_needed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":484,"url":null},"def":{"name":"error_device_reinitialization_needed?","visibility":"Public","body":"self == ERROR_DEVICE_REINITIALIZATION_NEEDED"}},{"html_id":"error_device_removed?-instance-method","name":"error_device_removed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":765,"url":null},"def":{"name":"error_device_removed?","visibility":"Public","body":"self == ERROR_DEVICE_REMOVED"}},{"html_id":"error_device_requires_cleaning?-instance-method","name":"error_device_requires_cleaning?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":485,"url":null},"def":{"name":"error_device_requires_cleaning?","visibility":"Public","body":"self == ERROR_DEVICE_REQUIRES_CLEANING"}},{"html_id":"error_dhcp_address_conflict?-instance-method","name":"error_dhcp_address_conflict?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1010,"url":null},"def":{"name":"error_dhcp_address_conflict?","visibility":"Public","body":"self == ERROR_DHCP_ADDRESS_CONFLICT"}},{"html_id":"error_different_service_account?-instance-method","name":"error_different_service_account?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":428,"url":null},"def":{"name":"error_different_service_account?","visibility":"Public","body":"self == ERROR_DIFFERENT_SERVICE_ACCOUNT"}},{"html_id":"error_dir_efs_disallowed?-instance-method","name":"error_dir_efs_disallowed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1191,"url":null},"def":{"name":"error_dir_efs_disallowed?","visibility":"Public","body":"self == ERROR_DIR_EFS_DISALLOWED"}},{"html_id":"error_dir_not_empty?-instance-method","name":"error_dir_not_empty?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":270,"url":null},"def":{"name":"error_dir_not_empty?","visibility":"Public","body":"self == ERROR_DIR_NOT_EMPTY"}},{"html_id":"error_dir_not_root?-instance-method","name":"error_dir_not_root?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":269,"url":null},"def":{"name":"error_dir_not_root?","visibility":"Public","body":"self == ERROR_DIR_NOT_ROOT"}},{"html_id":"error_direct_access_handle?-instance-method","name":"error_direct_access_handle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":255,"url":null},"def":{"name":"error_direct_access_handle?","visibility":"Public","body":"self == ERROR_DIRECT_ACCESS_HANDLE"}},{"html_id":"error_directory?-instance-method","name":"error_directory?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":343,"url":null},"def":{"name":"error_directory?","visibility":"Public","body":"self == ERROR_DIRECTORY"}},{"html_id":"error_discarded?-instance-method","name":"error_discarded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":282,"url":null},"def":{"name":"error_discarded?","visibility":"Public","body":"self == ERROR_DISCARDED"}},{"html_id":"error_disk_change?-instance-method","name":"error_disk_change?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":234,"url":null},"def":{"name":"error_disk_change?","visibility":"Public","body":"self == ERROR_DISK_CHANGE"}},{"html_id":"error_disk_corrupt?-instance-method","name":"error_disk_corrupt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":675,"url":null},"def":{"name":"error_disk_corrupt?","visibility":"Public","body":"self == ERROR_DISK_CORRUPT"}},{"html_id":"error_disk_full?-instance-method","name":"error_disk_full?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":239,"url":null},"def":{"name":"error_disk_full?","visibility":"Public","body":"self == ERROR_DISK_FULL"}},{"html_id":"error_disk_operation_failed?-instance-method","name":"error_disk_operation_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":461,"url":null},"def":{"name":"error_disk_operation_failed?","visibility":"Public","body":"self == ERROR_DISK_OPERATION_FAILED"}},{"html_id":"error_disk_recalibrate_failed?-instance-method","name":"error_disk_recalibrate_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":460,"url":null},"def":{"name":"error_disk_recalibrate_failed?","visibility":"Public","body":"self == ERROR_DISK_RECALIBRATE_FAILED"}},{"html_id":"error_disk_reset_failed?-instance-method","name":"error_disk_reset_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":462,"url":null},"def":{"name":"error_disk_reset_failed?","visibility":"Public","body":"self == ERROR_DISK_RESET_FAILED"}},{"html_id":"error_disk_too_fragmented?-instance-method","name":"error_disk_too_fragmented?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":354,"url":null},"def":{"name":"error_disk_too_fragmented?","visibility":"Public","body":"self == ERROR_DISK_TOO_FRAGMENTED"}},{"html_id":"error_dll_init_failed?-instance-method","name":"error_dll_init_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":448,"url":null},"def":{"name":"error_dll_init_failed?","visibility":"Public","body":"self == ERROR_DLL_INIT_FAILED"}},{"html_id":"error_dll_not_found?-instance-method","name":"error_dll_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":477,"url":null},"def":{"name":"error_dll_not_found?","visibility":"Public","body":"self == ERROR_DLL_NOT_FOUND"}},{"html_id":"error_domain_controller_exists?-instance-method","name":"error_domain_controller_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":551,"url":null},"def":{"name":"error_domain_controller_exists?","visibility":"Public","body":"self == ERROR_DOMAIN_CONTROLLER_EXISTS"}},{"html_id":"error_domain_controller_not_found?-instance-method","name":"error_domain_controller_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":933,"url":null},"def":{"name":"error_domain_controller_not_found?","visibility":"Public","body":"self == ERROR_DOMAIN_CONTROLLER_NOT_FOUND"}},{"html_id":"error_domain_exists?-instance-method","name":"error_domain_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":638,"url":null},"def":{"name":"error_domain_exists?","visibility":"Public","body":"self == ERROR_DOMAIN_EXISTS"}},{"html_id":"error_domain_limit_exceeded?-instance-method","name":"error_domain_limit_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":639,"url":null},"def":{"name":"error_domain_limit_exceeded?","visibility":"Public","body":"self == ERROR_DOMAIN_LIMIT_EXCEEDED"}},{"html_id":"error_domain_trust_inconsistent?-instance-method","name":"error_domain_trust_inconsistent?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":900,"url":null},"def":{"name":"error_domain_trust_inconsistent?","visibility":"Public","body":"self == ERROR_DOMAIN_TRUST_INCONSISTENT"}},{"html_id":"error_downgrade_detected?-instance-method","name":"error_downgrade_detected?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":566,"url":null},"def":{"name":"error_downgrade_detected?","visibility":"Public","body":"self == ERROR_DOWNGRADE_DETECTED"}},{"html_id":"error_drive_locked?-instance-method","name":"error_drive_locked?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":235,"url":null},"def":{"name":"error_drive_locked?","visibility":"Public","body":"self == ERROR_DRIVE_LOCKED"}},{"html_id":"error_drive_media_mismatch?-instance-method","name":"error_drive_media_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1029,"url":null},"def":{"name":"error_drive_media_mismatch?","visibility":"Public","body":"self == ERROR_DRIVE_MEDIA_MISMATCH"}},{"html_id":"error_driver_blocked?-instance-method","name":"error_driver_blocked?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":570,"url":null},"def":{"name":"error_driver_blocked?","visibility":"Public","body":"self == ERROR_DRIVER_BLOCKED"}},{"html_id":"error_ds_add_replica_inhibited?-instance-method","name":"error_ds_add_replica_inhibited?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1320,"url":null},"def":{"name":"error_ds_add_replica_inhibited?","visibility":"Public","body":"self == ERROR_DS_ADD_REPLICA_INHIBITED"}},{"html_id":"error_ds_admin_limit_exceeded?-instance-method","name":"error_ds_admin_limit_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1284,"url":null},"def":{"name":"error_ds_admin_limit_exceeded?","visibility":"Public","body":"self == ERROR_DS_ADMIN_LIMIT_EXCEEDED"}},{"html_id":"error_ds_affects_multiple_dsas?-instance-method","name":"error_ds_affects_multiple_dsas?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1305,"url":null},"def":{"name":"error_ds_affects_multiple_dsas?","visibility":"Public","body":"self == ERROR_DS_AFFECTS_MULTIPLE_DSAS"}},{"html_id":"error_ds_ag_cant_have_universal_member?-instance-method","name":"error_ds_ag_cant_have_universal_member?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1595,"url":null},"def":{"name":"error_ds_ag_cant_have_universal_member?","visibility":"Public","body":"self == ERROR_DS_AG_CANT_HAVE_UNIVERSAL_MEMBER"}},{"html_id":"error_ds_alias_deref_problem?-instance-method","name":"error_ds_alias_deref_problem?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1300,"url":null},"def":{"name":"error_ds_alias_deref_problem?","visibility":"Public","body":"self == ERROR_DS_ALIAS_DEREF_PROBLEM"}},{"html_id":"error_ds_alias_points_to_alias?-instance-method","name":"error_ds_alias_points_to_alias?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1353,"url":null},"def":{"name":"error_ds_alias_points_to_alias?","visibility":"Public","body":"self == ERROR_DS_ALIAS_POINTS_TO_ALIAS"}},{"html_id":"error_ds_alias_problem?-instance-method","name":"error_ds_alias_problem?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1297,"url":null},"def":{"name":"error_ds_alias_problem?","visibility":"Public","body":"self == ERROR_DS_ALIAS_PROBLEM"}},{"html_id":"error_ds_aliased_obj_missing?-instance-method","name":"error_ds_aliased_obj_missing?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1351,"url":null},"def":{"name":"error_ds_aliased_obj_missing?","visibility":"Public","body":"self == ERROR_DS_ALIASED_OBJ_MISSING"}},{"html_id":"error_ds_att_already_exists?-instance-method","name":"error_ds_att_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1336,"url":null},"def":{"name":"error_ds_att_already_exists?","visibility":"Public","body":"self == ERROR_DS_ATT_ALREADY_EXISTS"}},{"html_id":"error_ds_att_is_not_on_obj?-instance-method","name":"error_ds_att_is_not_on_obj?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1328,"url":null},"def":{"name":"error_ds_att_is_not_on_obj?","visibility":"Public","body":"self == ERROR_DS_ATT_IS_NOT_ON_OBJ"}},{"html_id":"error_ds_att_not_def_for_class?-instance-method","name":"error_ds_att_not_def_for_class?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1335,"url":null},"def":{"name":"error_ds_att_not_def_for_class?","visibility":"Public","body":"self == ERROR_DS_ATT_NOT_DEF_FOR_CLASS"}},{"html_id":"error_ds_att_not_def_in_schema?-instance-method","name":"error_ds_att_not_def_in_schema?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1321,"url":null},"def":{"name":"error_ds_att_not_def_in_schema?","visibility":"Public","body":"self == ERROR_DS_ATT_NOT_DEF_IN_SCHEMA"}},{"html_id":"error_ds_att_schema_req_id?-instance-method","name":"error_ds_att_schema_req_id?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1416,"url":null},"def":{"name":"error_ds_att_schema_req_id?","visibility":"Public","body":"self == ERROR_DS_ATT_SCHEMA_REQ_ID"}},{"html_id":"error_ds_att_schema_req_syntax?-instance-method","name":"error_ds_att_schema_req_syntax?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1433,"url":null},"def":{"name":"error_ds_att_schema_req_syntax?","visibility":"Public","body":"self == ERROR_DS_ATT_SCHEMA_REQ_SYNTAX"}},{"html_id":"error_ds_att_val_already_exists?-instance-method","name":"error_ds_att_val_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1340,"url":null},"def":{"name":"error_ds_att_val_already_exists?","visibility":"Public","body":"self == ERROR_DS_ATT_VAL_ALREADY_EXISTS"}},{"html_id":"error_ds_attribute_or_value_exists?-instance-method","name":"error_ds_attribute_or_value_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1262,"url":null},"def":{"name":"error_ds_attribute_or_value_exists?","visibility":"Public","body":"self == ERROR_DS_ATTRIBUTE_OR_VALUE_EXISTS"}},{"html_id":"error_ds_attribute_owned_by_sam?-instance-method","name":"error_ds_attribute_owned_by_sam?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1363,"url":null},"def":{"name":"error_ds_attribute_owned_by_sam?","visibility":"Public","body":"self == ERROR_DS_ATTRIBUTE_OWNED_BY_SAM"}},{"html_id":"error_ds_attribute_type_undefined?-instance-method","name":"error_ds_attribute_type_undefined?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1261,"url":null},"def":{"name":"error_ds_attribute_type_undefined?","visibility":"Public","body":"self == ERROR_DS_ATTRIBUTE_TYPE_UNDEFINED"}},{"html_id":"error_ds_auth_method_not_supported?-instance-method","name":"error_ds_auth_method_not_supported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1287,"url":null},"def":{"name":"error_ds_auth_method_not_supported?","visibility":"Public","body":"self == ERROR_DS_AUTH_METHOD_NOT_SUPPORTED"}},{"html_id":"error_ds_auth_unknown?-instance-method","name":"error_ds_auth_unknown?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1290,"url":null},"def":{"name":"error_ds_auth_unknown?","visibility":"Public","body":"self == ERROR_DS_AUTH_UNKNOWN"}},{"html_id":"error_ds_authorization_failed?-instance-method","name":"error_ds_authorization_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1616,"url":null},"def":{"name":"error_ds_authorization_failed?","visibility":"Public","body":"self == ERROR_DS_AUTHORIZATION_FAILED"}},{"html_id":"error_ds_aux_cls_test_fail?-instance-method","name":"error_ds_aux_cls_test_fail?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1406,"url":null},"def":{"name":"error_ds_aux_cls_test_fail?","visibility":"Public","body":"self == ERROR_DS_AUX_CLS_TEST_FAIL"}},{"html_id":"error_ds_backlink_without_link?-instance-method","name":"error_ds_backlink_without_link?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1499,"url":null},"def":{"name":"error_ds_backlink_without_link?","visibility":"Public","body":"self == ERROR_DS_BACKLINK_WITHOUT_LINK"}},{"html_id":"error_ds_bad_att_schema_syntax?-instance-method","name":"error_ds_bad_att_schema_syntax?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1417,"url":null},"def":{"name":"error_ds_bad_att_schema_syntax?","visibility":"Public","body":"self == ERROR_DS_BAD_ATT_SCHEMA_SYNTAX"}},{"html_id":"error_ds_bad_hierarchy_file?-instance-method","name":"error_ds_bad_hierarchy_file?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1442,"url":null},"def":{"name":"error_ds_bad_hierarchy_file?","visibility":"Public","body":"self == ERROR_DS_BAD_HIERARCHY_FILE"}},{"html_id":"error_ds_bad_instance_type?-instance-method","name":"error_ds_bad_instance_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1331,"url":null},"def":{"name":"error_ds_bad_instance_type?","visibility":"Public","body":"self == ERROR_DS_BAD_INSTANCE_TYPE"}},{"html_id":"error_ds_bad_name_syntax?-instance-method","name":"error_ds_bad_name_syntax?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1352,"url":null},"def":{"name":"error_ds_bad_name_syntax?","visibility":"Public","body":"self == ERROR_DS_BAD_NAME_SYNTAX"}},{"html_id":"error_ds_bad_rdn_att_id_syntax?-instance-method","name":"error_ds_bad_rdn_att_id_syntax?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1409,"url":null},"def":{"name":"error_ds_bad_rdn_att_id_syntax?","visibility":"Public","body":"self == ERROR_DS_BAD_RDN_ATT_ID_SYNTAX"}},{"html_id":"error_ds_build_hierarchy_table_failed?-instance-method","name":"error_ds_build_hierarchy_table_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1443,"url":null},"def":{"name":"error_ds_build_hierarchy_table_failed?","visibility":"Public","body":"self == ERROR_DS_BUILD_HIERARCHY_TABLE_FAILED"}},{"html_id":"error_ds_busy?-instance-method","name":"error_ds_busy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1263,"url":null},"def":{"name":"error_ds_busy?","visibility":"Public","body":"self == ERROR_DS_BUSY"}},{"html_id":"error_ds_cant_access_remote_part_of_ad?-instance-method","name":"error_ds_cant_access_remote_part_of_ad?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1602,"url":null},"def":{"name":"error_ds_cant_access_remote_part_of_ad?","visibility":"Public","body":"self == ERROR_DS_CANT_ACCESS_REMOTE_PART_OF_AD"}},{"html_id":"error_ds_cant_add_att_values?-instance-method","name":"error_ds_cant_add_att_values?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1337,"url":null},"def":{"name":"error_ds_cant_add_att_values?","visibility":"Public","body":"self == ERROR_DS_CANT_ADD_ATT_VALUES"}},{"html_id":"error_ds_cant_add_system_only?-instance-method","name":"error_ds_cant_add_system_only?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1375,"url":null},"def":{"name":"error_ds_cant_add_system_only?","visibility":"Public","body":"self == ERROR_DS_CANT_ADD_SYSTEM_ONLY"}},{"html_id":"error_ds_cant_add_to_gc?-instance-method","name":"error_ds_cant_add_to_gc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1567,"url":null},"def":{"name":"error_ds_cant_add_to_gc?","visibility":"Public","body":"self == ERROR_DS_CANT_ADD_TO_GC"}},{"html_id":"error_ds_cant_cache_att?-instance-method","name":"error_ds_cant_cache_att?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1418,"url":null},"def":{"name":"error_ds_cant_cache_att?","visibility":"Public","body":"self == ERROR_DS_CANT_CACHE_ATT"}},{"html_id":"error_ds_cant_cache_class?-instance-method","name":"error_ds_cant_cache_class?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1419,"url":null},"def":{"name":"error_ds_cant_cache_class?","visibility":"Public","body":"self == ERROR_DS_CANT_CACHE_CLASS"}},{"html_id":"error_ds_cant_create_in_nondomain_nc?-instance-method","name":"error_ds_cant_create_in_nondomain_nc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1570,"url":null},"def":{"name":"error_ds_cant_create_in_nondomain_nc?","visibility":"Public","body":"self == ERROR_DS_CANT_CREATE_IN_NONDOMAIN_NC"}},{"html_id":"error_ds_cant_create_under_schema?-instance-method","name":"error_ds_cant_create_under_schema?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1527,"url":null},"def":{"name":"error_ds_cant_create_under_schema?","visibility":"Public","body":"self == ERROR_DS_CANT_CREATE_UNDER_SCHEMA"}},{"html_id":"error_ds_cant_del_master_crossref?-instance-method","name":"error_ds_cant_del_master_crossref?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1392,"url":null},"def":{"name":"error_ds_cant_del_master_crossref?","visibility":"Public","body":"self == ERROR_DS_CANT_DEL_MASTER_CROSSREF"}},{"html_id":"error_ds_cant_delete?-instance-method","name":"error_ds_cant_delete?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1415,"url":null},"def":{"name":"error_ds_cant_delete?","visibility":"Public","body":"self == ERROR_DS_CANT_DELETE"}},{"html_id":"error_ds_cant_delete_dsa_obj?-instance-method","name":"error_ds_cant_delete_dsa_obj?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1357,"url":null},"def":{"name":"error_ds_cant_delete_dsa_obj?","visibility":"Public","body":"self == ERROR_DS_CANT_DELETE_DSA_OBJ"}},{"html_id":"error_ds_cant_demote_with_writeable_nc?-instance-method","name":"error_ds_cant_demote_with_writeable_nc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1621,"url":null},"def":{"name":"error_ds_cant_demote_with_writeable_nc?","visibility":"Public","body":"self == ERROR_DS_CANT_DEMOTE_WITH_WRITEABLE_NC"}},{"html_id":"error_ds_cant_deref_alias?-instance-method","name":"error_ds_cant_deref_alias?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1354,"url":null},"def":{"name":"error_ds_cant_deref_alias?","visibility":"Public","body":"self == ERROR_DS_CANT_DEREF_ALIAS"}},{"html_id":"error_ds_cant_derive_spn_for_deleted_domain?-instance-method","name":"error_ds_cant_derive_spn_for_deleted_domain?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1620,"url":null},"def":{"name":"error_ds_cant_derive_spn_for_deleted_domain?","visibility":"Public","body":"self == ERROR_DS_CANT_DERIVE_SPN_FOR_DELETED_DOMAIN"}},{"html_id":"error_ds_cant_derive_spn_without_server_ref?-instance-method","name":"error_ds_cant_derive_spn_without_server_ref?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1606,"url":null},"def":{"name":"error_ds_cant_derive_spn_without_server_ref?","visibility":"Public","body":"self == ERROR_DS_CANT_DERIVE_SPN_WITHOUT_SERVER_REF"}},{"html_id":"error_ds_cant_find_dc_for_src_domain?-instance-method","name":"error_ds_cant_find_dc_for_src_domain?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1554,"url":null},"def":{"name":"error_ds_cant_find_dc_for_src_domain?","visibility":"Public","body":"self == ERROR_DS_CANT_FIND_DC_FOR_SRC_DOMAIN"}},{"html_id":"error_ds_cant_find_dsa_obj?-instance-method","name":"error_ds_cant_find_dsa_obj?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1436,"url":null},"def":{"name":"error_ds_cant_find_dsa_obj?","visibility":"Public","body":"self == ERROR_DS_CANT_FIND_DSA_OBJ"}},{"html_id":"error_ds_cant_find_expected_nc?-instance-method","name":"error_ds_cant_find_expected_nc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1437,"url":null},"def":{"name":"error_ds_cant_find_expected_nc?","visibility":"Public","body":"self == ERROR_DS_CANT_FIND_EXPECTED_NC"}},{"html_id":"error_ds_cant_find_nc_in_cache?-instance-method","name":"error_ds_cant_find_nc_in_cache?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1438,"url":null},"def":{"name":"error_ds_cant_find_nc_in_cache?","visibility":"Public","body":"self == ERROR_DS_CANT_FIND_NC_IN_CACHE"}},{"html_id":"error_ds_cant_mix_master_and_reps?-instance-method","name":"error_ds_cant_mix_master_and_reps?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1348,"url":null},"def":{"name":"error_ds_cant_mix_master_and_reps?","visibility":"Public","body":"self == ERROR_DS_CANT_MIX_MASTER_AND_REPS"}},{"html_id":"error_ds_cant_mod_obj_class?-instance-method","name":"error_ds_cant_mod_obj_class?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1272,"url":null},"def":{"name":"error_ds_cant_mod_obj_class?","visibility":"Public","body":"self == ERROR_DS_CANT_MOD_OBJ_CLASS"}},{"html_id":"error_ds_cant_mod_primarygroupid?-instance-method","name":"error_ds_cant_mod_primarygroupid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1523,"url":null},"def":{"name":"error_ds_cant_mod_primarygroupid?","visibility":"Public","body":"self == ERROR_DS_CANT_MOD_PRIMARYGROUPID"}},{"html_id":"error_ds_cant_mod_system_only?-instance-method","name":"error_ds_cant_mod_system_only?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1386,"url":null},"def":{"name":"error_ds_cant_mod_system_only?","visibility":"Public","body":"self == ERROR_DS_CANT_MOD_SYSTEM_ONLY"}},{"html_id":"error_ds_cant_move_account_group?-instance-method","name":"error_ds_cant_move_account_group?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1515,"url":null},"def":{"name":"error_ds_cant_move_account_group?","visibility":"Public","body":"self == ERROR_DS_CANT_MOVE_ACCOUNT_GROUP"}},{"html_id":"error_ds_cant_move_app_basic_group?-instance-method","name":"error_ds_cant_move_app_basic_group?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1625,"url":null},"def":{"name":"error_ds_cant_move_app_basic_group?","visibility":"Public","body":"self == ERROR_DS_CANT_MOVE_APP_BASIC_GROUP"}},{"html_id":"error_ds_cant_move_app_query_group?-instance-method","name":"error_ds_cant_move_app_query_group?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1626,"url":null},"def":{"name":"error_ds_cant_move_app_query_group?","visibility":"Public","body":"self == ERROR_DS_CANT_MOVE_APP_QUERY_GROUP"}},{"html_id":"error_ds_cant_move_deleted_object?-instance-method","name":"error_ds_cant_move_deleted_object?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1506,"url":null},"def":{"name":"error_ds_cant_move_deleted_object?","visibility":"Public","body":"self == ERROR_DS_CANT_MOVE_DELETED_OBJECT"}},{"html_id":"error_ds_cant_move_resource_group?-instance-method","name":"error_ds_cant_move_resource_group?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1516,"url":null},"def":{"name":"error_ds_cant_move_resource_group?","visibility":"Public","body":"self == ERROR_DS_CANT_MOVE_RESOURCE_GROUP"}},{"html_id":"error_ds_cant_on_non_leaf?-instance-method","name":"error_ds_cant_on_non_leaf?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1270,"url":null},"def":{"name":"error_ds_cant_on_non_leaf?","visibility":"Public","body":"self == ERROR_DS_CANT_ON_NON_LEAF"}},{"html_id":"error_ds_cant_on_rdn?-instance-method","name":"error_ds_cant_on_rdn?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1271,"url":null},"def":{"name":"error_ds_cant_on_rdn?","visibility":"Public","body":"self == ERROR_DS_CANT_ON_RDN"}},{"html_id":"error_ds_cant_rem_missing_att?-instance-method","name":"error_ds_cant_rem_missing_att?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1341,"url":null},"def":{"name":"error_ds_cant_rem_missing_att?","visibility":"Public","body":"self == ERROR_DS_CANT_REM_MISSING_ATT"}},{"html_id":"error_ds_cant_rem_missing_att_val?-instance-method","name":"error_ds_cant_rem_missing_att_val?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1342,"url":null},"def":{"name":"error_ds_cant_rem_missing_att_val?","visibility":"Public","body":"self == ERROR_DS_CANT_REM_MISSING_ATT_VAL"}},{"html_id":"error_ds_cant_remove_att_cache?-instance-method","name":"error_ds_cant_remove_att_cache?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1420,"url":null},"def":{"name":"error_ds_cant_remove_att_cache?","visibility":"Public","body":"self == ERROR_DS_CANT_REMOVE_ATT_CACHE"}},{"html_id":"error_ds_cant_remove_class_cache?-instance-method","name":"error_ds_cant_remove_class_cache?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1421,"url":null},"def":{"name":"error_ds_cant_remove_class_cache?","visibility":"Public","body":"self == ERROR_DS_CANT_REMOVE_CLASS_CACHE"}},{"html_id":"error_ds_cant_replace_hidden_rec?-instance-method","name":"error_ds_cant_replace_hidden_rec?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1441,"url":null},"def":{"name":"error_ds_cant_replace_hidden_rec?","visibility":"Public","body":"self == ERROR_DS_CANT_REPLACE_HIDDEN_REC"}},{"html_id":"error_ds_cant_retrieve_atts?-instance-method","name":"error_ds_cant_retrieve_atts?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1498,"url":null},"def":{"name":"error_ds_cant_retrieve_atts?","visibility":"Public","body":"self == ERROR_DS_CANT_RETRIEVE_ATTS"}},{"html_id":"error_ds_cant_retrieve_child?-instance-method","name":"error_ds_cant_retrieve_child?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1439,"url":null},"def":{"name":"error_ds_cant_retrieve_child?","visibility":"Public","body":"self == ERROR_DS_CANT_RETRIEVE_CHILD"}},{"html_id":"error_ds_cant_retrieve_dn?-instance-method","name":"error_ds_cant_retrieve_dn?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1422,"url":null},"def":{"name":"error_ds_cant_retrieve_dn?","visibility":"Public","body":"self == ERROR_DS_CANT_RETRIEVE_DN"}},{"html_id":"error_ds_cant_retrieve_instance?-instance-method","name":"error_ds_cant_retrieve_instance?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1424,"url":null},"def":{"name":"error_ds_cant_retrieve_instance?","visibility":"Public","body":"self == ERROR_DS_CANT_RETRIEVE_INSTANCE"}},{"html_id":"error_ds_cant_retrieve_sd?-instance-method","name":"error_ds_cant_retrieve_sd?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1543,"url":null},"def":{"name":"error_ds_cant_retrieve_sd?","visibility":"Public","body":"self == ERROR_DS_CANT_RETRIEVE_SD"}},{"html_id":"error_ds_cant_start?-instance-method","name":"error_ds_cant_start?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1548,"url":null},"def":{"name":"error_ds_cant_start?","visibility":"Public","body":"self == ERROR_DS_CANT_START"}},{"html_id":"error_ds_cant_tree_delete_critical_obj?-instance-method","name":"error_ds_cant_tree_delete_critical_obj?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1577,"url":null},"def":{"name":"error_ds_cant_tree_delete_critical_obj?","visibility":"Public","body":"self == ERROR_DS_CANT_TREE_DELETE_CRITICAL_OBJ"}},{"html_id":"error_ds_cant_with_acct_group_membershps?-instance-method","name":"error_ds_cant_with_acct_group_membershps?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1510,"url":null},"def":{"name":"error_ds_cant_with_acct_group_membershps?","visibility":"Public","body":"self == ERROR_DS_CANT_WITH_ACCT_GROUP_MEMBERSHPS"}},{"html_id":"error_ds_children_exist?-instance-method","name":"error_ds_children_exist?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1349,"url":null},"def":{"name":"error_ds_children_exist?","visibility":"Public","body":"self == ERROR_DS_CHILDREN_EXIST"}},{"html_id":"error_ds_class_must_be_concrete?-instance-method","name":"error_ds_class_must_be_concrete?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1376,"url":null},"def":{"name":"error_ds_class_must_be_concrete?","visibility":"Public","body":"self == ERROR_DS_CLASS_MUST_BE_CONCRETE"}},{"html_id":"error_ds_class_not_dsa?-instance-method","name":"error_ds_class_not_dsa?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1360,"url":null},"def":{"name":"error_ds_class_not_dsa?","visibility":"Public","body":"self == ERROR_DS_CLASS_NOT_DSA"}},{"html_id":"error_ds_client_loop?-instance-method","name":"error_ds_client_loop?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1315,"url":null},"def":{"name":"error_ds_client_loop?","visibility":"Public","body":"self == ERROR_DS_CLIENT_LOOP"}},{"html_id":"error_ds_code_inconsistency?-instance-method","name":"error_ds_code_inconsistency?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1425,"url":null},"def":{"name":"error_ds_code_inconsistency?","visibility":"Public","body":"self == ERROR_DS_CODE_INCONSISTENCY"}},{"html_id":"error_ds_compare_false?-instance-method","name":"error_ds_compare_false?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1285,"url":null},"def":{"name":"error_ds_compare_false?","visibility":"Public","body":"self == ERROR_DS_COMPARE_FALSE"}},{"html_id":"error_ds_compare_true?-instance-method","name":"error_ds_compare_true?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1286,"url":null},"def":{"name":"error_ds_compare_true?","visibility":"Public","body":"self == ERROR_DS_COMPARE_TRUE"}},{"html_id":"error_ds_confidentiality_required?-instance-method","name":"error_ds_confidentiality_required?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1293,"url":null},"def":{"name":"error_ds_confidentiality_required?","visibility":"Public","body":"self == ERROR_DS_CONFIDENTIALITY_REQUIRED"}},{"html_id":"error_ds_config_param_missing?-instance-method","name":"error_ds_config_param_missing?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1444,"url":null},"def":{"name":"error_ds_config_param_missing?","visibility":"Public","body":"self == ERROR_DS_CONFIG_PARAM_MISSING"}},{"html_id":"error_ds_constraint_violation?-instance-method","name":"error_ds_constraint_violation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1295,"url":null},"def":{"name":"error_ds_constraint_violation?","visibility":"Public","body":"self == ERROR_DS_CONSTRAINT_VIOLATION"}},{"html_id":"error_ds_constructed_att_mod?-instance-method","name":"error_ds_constructed_att_mod?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1492,"url":null},"def":{"name":"error_ds_constructed_att_mod?","visibility":"Public","body":"self == ERROR_DS_CONSTRUCTED_ATT_MOD"}},{"html_id":"error_ds_control_not_found?-instance-method","name":"error_ds_control_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1314,"url":null},"def":{"name":"error_ds_control_not_found?","visibility":"Public","body":"self == ERROR_DS_CONTROL_NOT_FOUND"}},{"html_id":"error_ds_couldnt_contact_fsmo?-instance-method","name":"error_ds_couldnt_contact_fsmo?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1384,"url":null},"def":{"name":"error_ds_couldnt_contact_fsmo?","visibility":"Public","body":"self == ERROR_DS_COULDNT_CONTACT_FSMO"}},{"html_id":"error_ds_couldnt_identify_objects_for_tree_delete?-instance-method","name":"error_ds_couldnt_identify_objects_for_tree_delete?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1520,"url":null},"def":{"name":"error_ds_couldnt_identify_objects_for_tree_delete?","visibility":"Public","body":"self == ERROR_DS_COULDNT_IDENTIFY_OBJECTS_FOR_TREE_DELETE"}},{"html_id":"error_ds_couldnt_lock_tree_for_delete?-instance-method","name":"error_ds_couldnt_lock_tree_for_delete?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1519,"url":null},"def":{"name":"error_ds_couldnt_lock_tree_for_delete?","visibility":"Public","body":"self == ERROR_DS_COULDNT_LOCK_TREE_FOR_DELETE"}},{"html_id":"error_ds_couldnt_update_spns?-instance-method","name":"error_ds_couldnt_update_spns?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1542,"url":null},"def":{"name":"error_ds_couldnt_update_spns?","visibility":"Public","body":"self == ERROR_DS_COULDNT_UPDATE_SPNS"}},{"html_id":"error_ds_counting_ab_indices_failed?-instance-method","name":"error_ds_counting_ab_indices_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1445,"url":null},"def":{"name":"error_ds_counting_ab_indices_failed?","visibility":"Public","body":"self == ERROR_DS_COUNTING_AB_INDICES_FAILED"}},{"html_id":"error_ds_cr_impossible_to_validate?-instance-method","name":"error_ds_cr_impossible_to_validate?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1512,"url":null},"def":{"name":"error_ds_cr_impossible_to_validate?","visibility":"Public","body":"self == ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE"}},{"html_id":"error_ds_cr_impossible_to_validate_v2?-instance-method","name":"error_ds_cr_impossible_to_validate_v2?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1603,"url":null},"def":{"name":"error_ds_cr_impossible_to_validate_v2?","visibility":"Public","body":"self == ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE_V2"}},{"html_id":"error_ds_cross_dom_move_error?-instance-method","name":"error_ds_cross_dom_move_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1273,"url":null},"def":{"name":"error_ds_cross_dom_move_error?","visibility":"Public","body":"self == ERROR_DS_CROSS_DOM_MOVE_ERROR"}},{"html_id":"error_ds_cross_domain_cleanup_reqd?-instance-method","name":"error_ds_cross_domain_cleanup_reqd?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1508,"url":null},"def":{"name":"error_ds_cross_domain_cleanup_reqd?","visibility":"Public","body":"self == ERROR_DS_CROSS_DOMAIN_CLEANUP_REQD"}},{"html_id":"error_ds_cross_nc_dn_rename?-instance-method","name":"error_ds_cross_nc_dn_rename?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1385,"url":null},"def":{"name":"error_ds_cross_nc_dn_rename?","visibility":"Public","body":"self == ERROR_DS_CROSS_NC_DN_RENAME"}},{"html_id":"error_ds_cross_ref_busy?-instance-method","name":"error_ds_cross_ref_busy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1619,"url":null},"def":{"name":"error_ds_cross_ref_busy?","visibility":"Public","body":"self == ERROR_DS_CROSS_REF_BUSY"}},{"html_id":"error_ds_cross_ref_exists?-instance-method","name":"error_ds_cross_ref_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1391,"url":null},"def":{"name":"error_ds_cross_ref_exists?","visibility":"Public","body":"self == ERROR_DS_CROSS_REF_EXISTS"}},{"html_id":"error_ds_database_error?-instance-method","name":"error_ds_database_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1426,"url":null},"def":{"name":"error_ds_database_error?","visibility":"Public","body":"self == ERROR_DS_DATABASE_ERROR"}},{"html_id":"error_ds_decoding_error?-instance-method","name":"error_ds_decoding_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1309,"url":null},"def":{"name":"error_ds_decoding_error?","visibility":"Public","body":"self == ERROR_DS_DECODING_ERROR"}},{"html_id":"error_ds_destination_auditing_not_enabled?-instance-method","name":"error_ds_destination_auditing_not_enabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1553,"url":null},"def":{"name":"error_ds_destination_auditing_not_enabled?","visibility":"Public","body":"self == ERROR_DS_DESTINATION_AUDITING_NOT_ENABLED"}},{"html_id":"error_ds_destination_domain_not_in_forest?-instance-method","name":"error_ds_destination_domain_not_in_forest?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1552,"url":null},"def":{"name":"error_ds_destination_domain_not_in_forest?","visibility":"Public","body":"self == ERROR_DS_DESTINATION_DOMAIN_NOT_IN_FOREST"}},{"html_id":"error_ds_different_repl_epochs?-instance-method","name":"error_ds_different_repl_epochs?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1610,"url":null},"def":{"name":"error_ds_different_repl_epochs?","visibility":"Public","body":"self == ERROR_DS_DIFFERENT_REPL_EPOCHS"}},{"html_id":"error_ds_disallowed_in_system_container?-instance-method","name":"error_ds_disallowed_in_system_container?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1632,"url":null},"def":{"name":"error_ds_disallowed_in_system_container?","visibility":"Public","body":"self == ERROR_DS_DISALLOWED_IN_SYSTEM_CONTAINER"}},{"html_id":"error_ds_dns_lookup_failure?-instance-method","name":"error_ds_dns_lookup_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1541,"url":null},"def":{"name":"error_ds_dns_lookup_failure?","visibility":"Public","body":"self == ERROR_DS_DNS_LOOKUP_FAILURE"}},{"html_id":"error_ds_domain_rename_in_progress?-instance-method","name":"error_ds_domain_rename_in_progress?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1629,"url":null},"def":{"name":"error_ds_domain_rename_in_progress?","visibility":"Public","body":"self == ERROR_DS_DOMAIN_RENAME_IN_PROGRESS"}},{"html_id":"error_ds_domain_version_too_high?-instance-method","name":"error_ds_domain_version_too_high?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1581,"url":null},"def":{"name":"error_ds_domain_version_too_high?","visibility":"Public","body":"self == ERROR_DS_DOMAIN_VERSION_TOO_HIGH"}},{"html_id":"error_ds_domain_version_too_low?-instance-method","name":"error_ds_domain_version_too_low?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1583,"url":null},"def":{"name":"error_ds_domain_version_too_low?","visibility":"Public","body":"self == ERROR_DS_DOMAIN_VERSION_TOO_LOW"}},{"html_id":"error_ds_dra_abandon_sync?-instance-method","name":"error_ds_dra_abandon_sync?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1479,"url":null},"def":{"name":"error_ds_dra_abandon_sync?","visibility":"Public","body":"self == ERROR_DS_DRA_ABANDON_SYNC"}},{"html_id":"error_ds_dra_access_denied?-instance-method","name":"error_ds_dra_access_denied?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1470,"url":null},"def":{"name":"error_ds_dra_access_denied?","visibility":"Public","body":"self == ERROR_DS_DRA_ACCESS_DENIED"}},{"html_id":"error_ds_dra_bad_dn?-instance-method","name":"error_ds_dra_bad_dn?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1456,"url":null},"def":{"name":"error_ds_dra_bad_dn?","visibility":"Public","body":"self == ERROR_DS_DRA_BAD_DN"}},{"html_id":"error_ds_dra_bad_instance_type?-instance-method","name":"error_ds_dra_bad_instance_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1462,"url":null},"def":{"name":"error_ds_dra_bad_instance_type?","visibility":"Public","body":"self == ERROR_DS_DRA_BAD_INSTANCE_TYPE"}},{"html_id":"error_ds_dra_bad_nc?-instance-method","name":"error_ds_dra_bad_nc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1457,"url":null},"def":{"name":"error_ds_dra_bad_nc?","visibility":"Public","body":"self == ERROR_DS_DRA_BAD_NC"}},{"html_id":"error_ds_dra_busy?-instance-method","name":"error_ds_dra_busy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1455,"url":null},"def":{"name":"error_ds_dra_busy?","visibility":"Public","body":"self == ERROR_DS_DRA_BUSY"}},{"html_id":"error_ds_dra_connection_failed?-instance-method","name":"error_ds_dra_connection_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1461,"url":null},"def":{"name":"error_ds_dra_connection_failed?","visibility":"Public","body":"self == ERROR_DS_DRA_CONNECTION_FAILED"}},{"html_id":"error_ds_dra_db_error?-instance-method","name":"error_ds_dra_db_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1468,"url":null},"def":{"name":"error_ds_dra_db_error?","visibility":"Public","body":"self == ERROR_DS_DRA_DB_ERROR"}},{"html_id":"error_ds_dra_dn_exists?-instance-method","name":"error_ds_dra_dn_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1458,"url":null},"def":{"name":"error_ds_dra_dn_exists?","visibility":"Public","body":"self == ERROR_DS_DRA_DN_EXISTS"}},{"html_id":"error_ds_dra_earlier_schema_conflict?-instance-method","name":"error_ds_dra_earlier_schema_conflict?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1561,"url":null},"def":{"name":"error_ds_dra_earlier_schema_conflict?","visibility":"Public","body":"self == ERROR_DS_DRA_EARLIER_SCHEMA_CONFLICT"}},{"html_id":"error_ds_dra_extn_connection_failed?-instance-method","name":"error_ds_dra_extn_connection_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1483,"url":null},"def":{"name":"error_ds_dra_extn_connection_failed?","visibility":"Public","body":"self == ERROR_DS_DRA_EXTN_CONNECTION_FAILED"}},{"html_id":"error_ds_dra_generic?-instance-method","name":"error_ds_dra_generic?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1453,"url":null},"def":{"name":"error_ds_dra_generic?","visibility":"Public","body":"self == ERROR_DS_DRA_GENERIC"}},{"html_id":"error_ds_dra_incompatible_partial_set?-instance-method","name":"error_ds_dra_incompatible_partial_set?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1481,"url":null},"def":{"name":"error_ds_dra_incompatible_partial_set?","visibility":"Public","body":"self == ERROR_DS_DRA_INCOMPATIBLE_PARTIAL_SET"}},{"html_id":"error_ds_dra_inconsistent_dit?-instance-method","name":"error_ds_dra_inconsistent_dit?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1460,"url":null},"def":{"name":"error_ds_dra_inconsistent_dit?","visibility":"Public","body":"self == ERROR_DS_DRA_INCONSISTENT_DIT"}},{"html_id":"error_ds_dra_internal_error?-instance-method","name":"error_ds_dra_internal_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1459,"url":null},"def":{"name":"error_ds_dra_internal_error?","visibility":"Public","body":"self == ERROR_DS_DRA_INTERNAL_ERROR"}},{"html_id":"error_ds_dra_invalid_parameter?-instance-method","name":"error_ds_dra_invalid_parameter?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1454,"url":null},"def":{"name":"error_ds_dra_invalid_parameter?","visibility":"Public","body":"self == ERROR_DS_DRA_INVALID_PARAMETER"}},{"html_id":"error_ds_dra_mail_problem?-instance-method","name":"error_ds_dra_mail_problem?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1464,"url":null},"def":{"name":"error_ds_dra_mail_problem?","visibility":"Public","body":"self == ERROR_DS_DRA_MAIL_PROBLEM"}},{"html_id":"error_ds_dra_missing_parent?-instance-method","name":"error_ds_dra_missing_parent?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1477,"url":null},"def":{"name":"error_ds_dra_missing_parent?","visibility":"Public","body":"self == ERROR_DS_DRA_MISSING_PARENT"}},{"html_id":"error_ds_dra_name_collision?-instance-method","name":"error_ds_dra_name_collision?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1475,"url":null},"def":{"name":"error_ds_dra_name_collision?","visibility":"Public","body":"self == ERROR_DS_DRA_NAME_COLLISION"}},{"html_id":"error_ds_dra_no_replica?-instance-method","name":"error_ds_dra_no_replica?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1469,"url":null},"def":{"name":"error_ds_dra_no_replica?","visibility":"Public","body":"self == ERROR_DS_DRA_NO_REPLICA"}},{"html_id":"error_ds_dra_not_supported?-instance-method","name":"error_ds_dra_not_supported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1471,"url":null},"def":{"name":"error_ds_dra_not_supported?","visibility":"Public","body":"self == ERROR_DS_DRA_NOT_SUPPORTED"}},{"html_id":"error_ds_dra_obj_is_rep_source?-instance-method","name":"error_ds_dra_obj_is_rep_source?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1467,"url":null},"def":{"name":"error_ds_dra_obj_is_rep_source?","visibility":"Public","body":"self == ERROR_DS_DRA_OBJ_IS_REP_SOURCE"}},{"html_id":"error_ds_dra_obj_nc_mismatch?-instance-method","name":"error_ds_dra_obj_nc_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1562,"url":null},"def":{"name":"error_ds_dra_obj_nc_mismatch?","visibility":"Public","body":"self == ERROR_DS_DRA_OBJ_NC_MISMATCH"}},{"html_id":"error_ds_dra_out_of_mem?-instance-method","name":"error_ds_dra_out_of_mem?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1463,"url":null},"def":{"name":"error_ds_dra_out_of_mem?","visibility":"Public","body":"self == ERROR_DS_DRA_OUT_OF_MEM"}},{"html_id":"error_ds_dra_out_schedule_window?-instance-method","name":"error_ds_dra_out_schedule_window?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1634,"url":null},"def":{"name":"error_ds_dra_out_schedule_window?","visibility":"Public","body":"self == ERROR_DS_DRA_OUT_SCHEDULE_WINDOW"}},{"html_id":"error_ds_dra_preempted?-instance-method","name":"error_ds_dra_preempted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1478,"url":null},"def":{"name":"error_ds_dra_preempted?","visibility":"Public","body":"self == ERROR_DS_DRA_PREEMPTED"}},{"html_id":"error_ds_dra_ref_already_exists?-instance-method","name":"error_ds_dra_ref_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1465,"url":null},"def":{"name":"error_ds_dra_ref_already_exists?","visibility":"Public","body":"self == ERROR_DS_DRA_REF_ALREADY_EXISTS"}},{"html_id":"error_ds_dra_ref_not_found?-instance-method","name":"error_ds_dra_ref_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1466,"url":null},"def":{"name":"error_ds_dra_ref_not_found?","visibility":"Public","body":"self == ERROR_DS_DRA_REF_NOT_FOUND"}},{"html_id":"error_ds_dra_repl_pending?-instance-method","name":"error_ds_dra_repl_pending?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1494,"url":null},"def":{"name":"error_ds_dra_repl_pending?","visibility":"Public","body":"self == ERROR_DS_DRA_REPL_PENDING"}},{"html_id":"error_ds_dra_rpc_cancelled?-instance-method","name":"error_ds_dra_rpc_cancelled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1472,"url":null},"def":{"name":"error_ds_dra_rpc_cancelled?","visibility":"Public","body":"self == ERROR_DS_DRA_RPC_CANCELLED"}},{"html_id":"error_ds_dra_schema_conflict?-instance-method","name":"error_ds_dra_schema_conflict?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1560,"url":null},"def":{"name":"error_ds_dra_schema_conflict?","visibility":"Public","body":"self == ERROR_DS_DRA_SCHEMA_CONFLICT"}},{"html_id":"error_ds_dra_schema_info_ship?-instance-method","name":"error_ds_dra_schema_info_ship?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1559,"url":null},"def":{"name":"error_ds_dra_schema_info_ship?","visibility":"Public","body":"self == ERROR_DS_DRA_SCHEMA_INFO_SHIP"}},{"html_id":"error_ds_dra_schema_mismatch?-instance-method","name":"error_ds_dra_schema_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1435,"url":null},"def":{"name":"error_ds_dra_schema_mismatch?","visibility":"Public","body":"self == ERROR_DS_DRA_SCHEMA_MISMATCH"}},{"html_id":"error_ds_dra_shutdown?-instance-method","name":"error_ds_dra_shutdown?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1480,"url":null},"def":{"name":"error_ds_dra_shutdown?","visibility":"Public","body":"self == ERROR_DS_DRA_SHUTDOWN"}},{"html_id":"error_ds_dra_sink_disabled?-instance-method","name":"error_ds_dra_sink_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1474,"url":null},"def":{"name":"error_ds_dra_sink_disabled?","visibility":"Public","body":"self == ERROR_DS_DRA_SINK_DISABLED"}},{"html_id":"error_ds_dra_source_disabled?-instance-method","name":"error_ds_dra_source_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1473,"url":null},"def":{"name":"error_ds_dra_source_disabled?","visibility":"Public","body":"self == ERROR_DS_DRA_SOURCE_DISABLED"}},{"html_id":"error_ds_dra_source_is_partial_replica?-instance-method","name":"error_ds_dra_source_is_partial_replica?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1482,"url":null},"def":{"name":"error_ds_dra_source_is_partial_replica?","visibility":"Public","body":"self == ERROR_DS_DRA_SOURCE_IS_PARTIAL_REPLICA"}},{"html_id":"error_ds_dra_source_reinstalled?-instance-method","name":"error_ds_dra_source_reinstalled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1476,"url":null},"def":{"name":"error_ds_dra_source_reinstalled?","visibility":"Public","body":"self == ERROR_DS_DRA_SOURCE_REINSTALLED"}},{"html_id":"error_ds_drs_extensions_changed?-instance-method","name":"error_ds_drs_extensions_changed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1611,"url":null},"def":{"name":"error_ds_drs_extensions_changed?","visibility":"Public","body":"self == ERROR_DS_DRS_EXTENSIONS_CHANGED"}},{"html_id":"error_ds_ds_required?-instance-method","name":"error_ds_ds_required?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1495,"url":null},"def":{"name":"error_ds_ds_required?","visibility":"Public","body":"self == ERROR_DS_DS_REQUIRED"}},{"html_id":"error_ds_dsa_must_be_int_master?-instance-method","name":"error_ds_dsa_must_be_int_master?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1359,"url":null},"def":{"name":"error_ds_dsa_must_be_int_master?","visibility":"Public","body":"self == ERROR_DS_DSA_MUST_BE_INT_MASTER"}},{"html_id":"error_ds_dst_domain_not_native?-instance-method","name":"error_ds_dst_domain_not_native?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1513,"url":null},"def":{"name":"error_ds_dst_domain_not_native?","visibility":"Public","body":"self == ERROR_DS_DST_DOMAIN_NOT_NATIVE"}},{"html_id":"error_ds_dst_nc_mismatch?-instance-method","name":"error_ds_dst_nc_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1503,"url":null},"def":{"name":"error_ds_dst_nc_mismatch?","visibility":"Public","body":"self == ERROR_DS_DST_NC_MISMATCH"}},{"html_id":"error_ds_dup_ldap_display_name?-instance-method","name":"error_ds_dup_ldap_display_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1399,"url":null},"def":{"name":"error_ds_dup_ldap_display_name?","visibility":"Public","body":"self == ERROR_DS_DUP_LDAP_DISPLAY_NAME"}},{"html_id":"error_ds_dup_link_id?-instance-method","name":"error_ds_dup_link_id?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1485,"url":null},"def":{"name":"error_ds_dup_link_id?","visibility":"Public","body":"self == ERROR_DS_DUP_LINK_ID"}},{"html_id":"error_ds_dup_mapi_id?-instance-method","name":"error_ds_dup_mapi_id?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1397,"url":null},"def":{"name":"error_ds_dup_mapi_id?","visibility":"Public","body":"self == ERROR_DS_DUP_MAPI_ID"}},{"html_id":"error_ds_dup_msds_intid?-instance-method","name":"error_ds_dup_msds_intid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1614,"url":null},"def":{"name":"error_ds_dup_msds_intid?","visibility":"Public","body":"self == ERROR_DS_DUP_MSDS_INTID"}},{"html_id":"error_ds_dup_oid?-instance-method","name":"error_ds_dup_oid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1396,"url":null},"def":{"name":"error_ds_dup_oid?","visibility":"Public","body":"self == ERROR_DS_DUP_OID"}},{"html_id":"error_ds_dup_rdn?-instance-method","name":"error_ds_dup_rdn?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1395,"url":null},"def":{"name":"error_ds_dup_rdn?","visibility":"Public","body":"self == ERROR_DS_DUP_RDN"}},{"html_id":"error_ds_dup_schema_id_guid?-instance-method","name":"error_ds_dup_schema_id_guid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1398,"url":null},"def":{"name":"error_ds_dup_schema_id_guid?","visibility":"Public","body":"self == ERROR_DS_DUP_SCHEMA_ID_GUID"}},{"html_id":"error_ds_duplicate_id_found?-instance-method","name":"error_ds_duplicate_id_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1622,"url":null},"def":{"name":"error_ds_duplicate_id_found?","visibility":"Public","body":"self == ERROR_DS_DUPLICATE_ID_FOUND"}},{"html_id":"error_ds_encoding_error?-instance-method","name":"error_ds_encoding_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1308,"url":null},"def":{"name":"error_ds_encoding_error?","visibility":"Public","body":"self == ERROR_DS_ENCODING_ERROR"}},{"html_id":"error_ds_epoch_mismatch?-instance-method","name":"error_ds_epoch_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1500,"url":null},"def":{"name":"error_ds_epoch_mismatch?","visibility":"Public","body":"self == ERROR_DS_EPOCH_MISMATCH"}},{"html_id":"error_ds_existing_ad_child_nc?-instance-method","name":"error_ds_existing_ad_child_nc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1630,"url":null},"def":{"name":"error_ds_existing_ad_child_nc?","visibility":"Public","body":"self == ERROR_DS_EXISTING_AD_CHILD_NC"}},{"html_id":"error_ds_exists_in_aux_cls?-instance-method","name":"error_ds_exists_in_aux_cls?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1410,"url":null},"def":{"name":"error_ds_exists_in_aux_cls?","visibility":"Public","body":"self == ERROR_DS_EXISTS_IN_AUX_CLS"}},{"html_id":"error_ds_exists_in_may_have?-instance-method","name":"error_ds_exists_in_may_have?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1403,"url":null},"def":{"name":"error_ds_exists_in_may_have?","visibility":"Public","body":"self == ERROR_DS_EXISTS_IN_MAY_HAVE"}},{"html_id":"error_ds_exists_in_must_have?-instance-method","name":"error_ds_exists_in_must_have?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1402,"url":null},"def":{"name":"error_ds_exists_in_must_have?","visibility":"Public","body":"self == ERROR_DS_EXISTS_IN_MUST_HAVE"}},{"html_id":"error_ds_exists_in_poss_sup?-instance-method","name":"error_ds_exists_in_poss_sup?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1412,"url":null},"def":{"name":"error_ds_exists_in_poss_sup?","visibility":"Public","body":"self == ERROR_DS_EXISTS_IN_POSS_SUP"}},{"html_id":"error_ds_exists_in_rdnattid?-instance-method","name":"error_ds_exists_in_rdnattid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1615,"url":null},"def":{"name":"error_ds_exists_in_rdnattid?","visibility":"Public","body":"self == ERROR_DS_EXISTS_IN_RDNATTID"}},{"html_id":"error_ds_exists_in_sub_cls?-instance-method","name":"error_ds_exists_in_sub_cls?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1411,"url":null},"def":{"name":"error_ds_exists_in_sub_cls?","visibility":"Public","body":"self == ERROR_DS_EXISTS_IN_SUB_CLS"}},{"html_id":"error_ds_filter_unknown?-instance-method","name":"error_ds_filter_unknown?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1310,"url":null},"def":{"name":"error_ds_filter_unknown?","visibility":"Public","body":"self == ERROR_DS_FILTER_UNKNOWN"}},{"html_id":"error_ds_filter_uses_contructed_attrs?-instance-method","name":"error_ds_filter_uses_contructed_attrs?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1572,"url":null},"def":{"name":"error_ds_filter_uses_contructed_attrs?","visibility":"Public","body":"self == ERROR_DS_FILTER_USES_CONTRUCTED_ATTRS"}},{"html_id":"error_ds_forest_version_too_high?-instance-method","name":"error_ds_forest_version_too_high?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1580,"url":null},"def":{"name":"error_ds_forest_version_too_high?","visibility":"Public","body":"self == ERROR_DS_FOREST_VERSION_TOO_HIGH"}},{"html_id":"error_ds_forest_version_too_low?-instance-method","name":"error_ds_forest_version_too_low?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1582,"url":null},"def":{"name":"error_ds_forest_version_too_low?","visibility":"Public","body":"self == ERROR_DS_FOREST_VERSION_TOO_LOW"}},{"html_id":"error_ds_gc_not_available?-instance-method","name":"error_ds_gc_not_available?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1274,"url":null},"def":{"name":"error_ds_gc_not_available?","visibility":"Public","body":"self == ERROR_DS_GC_NOT_AVAILABLE"}},{"html_id":"error_ds_gc_required?-instance-method","name":"error_ds_gc_required?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1564,"url":null},"def":{"name":"error_ds_gc_required?","visibility":"Public","body":"self == ERROR_DS_GC_REQUIRED"}},{"html_id":"error_ds_gcverify_error?-instance-method","name":"error_ds_gcverify_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1434,"url":null},"def":{"name":"error_ds_gcverify_error?","visibility":"Public","body":"self == ERROR_DS_GCVERIFY_ERROR"}},{"html_id":"error_ds_generic_error?-instance-method","name":"error_ds_generic_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1358,"url":null},"def":{"name":"error_ds_generic_error?","visibility":"Public","body":"self == ERROR_DS_GENERIC_ERROR"}},{"html_id":"error_ds_global_cant_have_crossdomain_member?-instance-method","name":"error_ds_global_cant_have_crossdomain_member?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1536,"url":null},"def":{"name":"error_ds_global_cant_have_crossdomain_member?","visibility":"Public","body":"self == ERROR_DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER"}},{"html_id":"error_ds_global_cant_have_local_member?-instance-method","name":"error_ds_global_cant_have_local_member?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1533,"url":null},"def":{"name":"error_ds_global_cant_have_local_member?","visibility":"Public","body":"self == ERROR_DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER"}},{"html_id":"error_ds_global_cant_have_universal_member?-instance-method","name":"error_ds_global_cant_have_universal_member?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1534,"url":null},"def":{"name":"error_ds_global_cant_have_universal_member?","visibility":"Public","body":"self == ERROR_DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER"}},{"html_id":"error_ds_governsid_missing?-instance-method","name":"error_ds_governsid_missing?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1427,"url":null},"def":{"name":"error_ds_governsid_missing?","visibility":"Public","body":"self == ERROR_DS_GOVERNSID_MISSING"}},{"html_id":"error_ds_group_conversion_error?-instance-method","name":"error_ds_group_conversion_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1624,"url":null},"def":{"name":"error_ds_group_conversion_error?","visibility":"Public","body":"self == ERROR_DS_GROUP_CONVERSION_ERROR"}},{"html_id":"error_ds_have_primary_members?-instance-method","name":"error_ds_have_primary_members?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1538,"url":null},"def":{"name":"error_ds_have_primary_members?","visibility":"Public","body":"self == ERROR_DS_HAVE_PRIMARY_MEMBERS"}},{"html_id":"error_ds_hierarchy_table_malloc_failed?-instance-method","name":"error_ds_hierarchy_table_malloc_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1446,"url":null},"def":{"name":"error_ds_hierarchy_table_malloc_failed?","visibility":"Public","body":"self == ERROR_DS_HIERARCHY_TABLE_MALLOC_FAILED"}},{"html_id":"error_ds_illegal_base_schema_mod?-instance-method","name":"error_ds_illegal_base_schema_mod?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1524,"url":null},"def":{"name":"error_ds_illegal_base_schema_mod?","visibility":"Public","body":"self == ERROR_DS_ILLEGAL_BASE_SCHEMA_MOD"}},{"html_id":"error_ds_illegal_mod_operation?-instance-method","name":"error_ds_illegal_mod_operation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1329,"url":null},"def":{"name":"error_ds_illegal_mod_operation?","visibility":"Public","body":"self == ERROR_DS_ILLEGAL_MOD_OPERATION"}},{"html_id":"error_ds_illegal_superior?-instance-method","name":"error_ds_illegal_superior?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1362,"url":null},"def":{"name":"error_ds_illegal_superior?","visibility":"Public","body":"self == ERROR_DS_ILLEGAL_SUPERIOR"}},{"html_id":"error_ds_illegal_xdom_move_operation?-instance-method","name":"error_ds_illegal_xdom_move_operation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1509,"url":null},"def":{"name":"error_ds_illegal_xdom_move_operation?","visibility":"Public","body":"self == ERROR_DS_ILLEGAL_XDOM_MOVE_OPERATION"}},{"html_id":"error_ds_inappropriate_auth?-instance-method","name":"error_ds_inappropriate_auth?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1289,"url":null},"def":{"name":"error_ds_inappropriate_auth?","visibility":"Public","body":"self == ERROR_DS_INAPPROPRIATE_AUTH"}},{"html_id":"error_ds_inappropriate_matching?-instance-method","name":"error_ds_inappropriate_matching?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1294,"url":null},"def":{"name":"error_ds_inappropriate_matching?","visibility":"Public","body":"self == ERROR_DS_INAPPROPRIATE_MATCHING"}},{"html_id":"error_ds_incompatible_controls_used?-instance-method","name":"error_ds_incompatible_controls_used?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1591,"url":null},"def":{"name":"error_ds_incompatible_controls_used?","visibility":"Public","body":"self == ERROR_DS_INCOMPATIBLE_CONTROLS_USED"}},{"html_id":"error_ds_incompatible_version?-instance-method","name":"error_ds_incompatible_version?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1584,"url":null},"def":{"name":"error_ds_incompatible_version?","visibility":"Public","body":"self == ERROR_DS_INCOMPATIBLE_VERSION"}},{"html_id":"error_ds_incorrect_role_owner?-instance-method","name":"error_ds_incorrect_role_owner?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1267,"url":null},"def":{"name":"error_ds_incorrect_role_owner?","visibility":"Public","body":"self == ERROR_DS_INCORRECT_ROLE_OWNER"}},{"html_id":"error_ds_init_failure?-instance-method","name":"error_ds_init_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1549,"url":null},"def":{"name":"error_ds_init_failure?","visibility":"Public","body":"self == ERROR_DS_INIT_FAILURE"}},{"html_id":"error_ds_init_failure_console?-instance-method","name":"error_ds_init_failure_console?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1578,"url":null},"def":{"name":"error_ds_init_failure_console?","visibility":"Public","body":"self == ERROR_DS_INIT_FAILURE_CONSOLE"}},{"html_id":"error_ds_install_no_sch_version_in_inifile?-instance-method","name":"error_ds_install_no_sch_version_in_inifile?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1529,"url":null},"def":{"name":"error_ds_install_no_sch_version_in_inifile?","visibility":"Public","body":"self == ERROR_DS_INSTALL_NO_SCH_VERSION_IN_INIFILE"}},{"html_id":"error_ds_install_no_src_sch_version?-instance-method","name":"error_ds_install_no_src_sch_version?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1528,"url":null},"def":{"name":"error_ds_install_no_src_sch_version?","visibility":"Public","body":"self == ERROR_DS_INSTALL_NO_SRC_SCH_VERSION"}},{"html_id":"error_ds_install_schema_mismatch?-instance-method","name":"error_ds_install_schema_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1484,"url":null},"def":{"name":"error_ds_install_schema_mismatch?","visibility":"Public","body":"self == ERROR_DS_INSTALL_SCHEMA_MISMATCH"}},{"html_id":"error_ds_insuff_access_rights?-instance-method","name":"error_ds_insuff_access_rights?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1361,"url":null},"def":{"name":"error_ds_insuff_access_rights?","visibility":"Public","body":"self == ERROR_DS_INSUFF_ACCESS_RIGHTS"}},{"html_id":"error_ds_insufficient_attr_to_create_object?-instance-method","name":"error_ds_insufficient_attr_to_create_object?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1623,"url":null},"def":{"name":"error_ds_insufficient_attr_to_create_object?","visibility":"Public","body":"self == ERROR_DS_INSUFFICIENT_ATTR_TO_CREATE_OBJECT"}},{"html_id":"error_ds_internal_failure?-instance-method","name":"error_ds_internal_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1447,"url":null},"def":{"name":"error_ds_internal_failure?","visibility":"Public","body":"self == ERROR_DS_INTERNAL_FAILURE"}},{"html_id":"error_ds_invalid_attribute_syntax?-instance-method","name":"error_ds_invalid_attribute_syntax?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1260,"url":null},"def":{"name":"error_ds_invalid_attribute_syntax?","visibility":"Public","body":"self == ERROR_DS_INVALID_ATTRIBUTE_SYNTAX"}},{"html_id":"error_ds_invalid_dmd?-instance-method","name":"error_ds_invalid_dmd?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1377,"url":null},"def":{"name":"error_ds_invalid_dmd?","visibility":"Public","body":"self == ERROR_DS_INVALID_DMD"}},{"html_id":"error_ds_invalid_dn_syntax?-instance-method","name":"error_ds_invalid_dn_syntax?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1298,"url":null},"def":{"name":"error_ds_invalid_dn_syntax?","visibility":"Public","body":"self == ERROR_DS_INVALID_DN_SYNTAX"}},{"html_id":"error_ds_invalid_group_type?-instance-method","name":"error_ds_invalid_group_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1530,"url":null},"def":{"name":"error_ds_invalid_group_type?","visibility":"Public","body":"self == ERROR_DS_INVALID_GROUP_TYPE"}},{"html_id":"error_ds_invalid_ldap_display_name?-instance-method","name":"error_ds_invalid_ldap_display_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1496,"url":null},"def":{"name":"error_ds_invalid_ldap_display_name?","visibility":"Public","body":"self == ERROR_DS_INVALID_LDAP_DISPLAY_NAME"}},{"html_id":"error_ds_invalid_name_for_spn?-instance-method","name":"error_ds_invalid_name_for_spn?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1571,"url":null},"def":{"name":"error_ds_invalid_name_for_spn?","visibility":"Public","body":"self == ERROR_DS_INVALID_NAME_FOR_SPN"}},{"html_id":"error_ds_invalid_role_owner?-instance-method","name":"error_ds_invalid_role_owner?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1383,"url":null},"def":{"name":"error_ds_invalid_role_owner?","visibility":"Public","body":"self == ERROR_DS_INVALID_ROLE_OWNER"}},{"html_id":"error_ds_invalid_script?-instance-method","name":"error_ds_invalid_script?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1617,"url":null},"def":{"name":"error_ds_invalid_script?","visibility":"Public","body":"self == ERROR_DS_INVALID_SCRIPT"}},{"html_id":"error_ds_invalid_search_flag?-instance-method","name":"error_ds_invalid_search_flag?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1517,"url":null},"def":{"name":"error_ds_invalid_search_flag?","visibility":"Public","body":"self == ERROR_DS_INVALID_SEARCH_FLAG"}},{"html_id":"error_ds_is_leaf?-instance-method","name":"error_ds_is_leaf?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1299,"url":null},"def":{"name":"error_ds_is_leaf?","visibility":"Public","body":"self == ERROR_DS_IS_LEAF"}},{"html_id":"error_ds_key_not_unique?-instance-method","name":"error_ds_key_not_unique?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1544,"url":null},"def":{"name":"error_ds_key_not_unique?","visibility":"Public","body":"self == ERROR_DS_KEY_NOT_UNIQUE"}},{"html_id":"error_ds_ldap_send_queue_full?-instance-method","name":"error_ds_ldap_send_queue_full?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1633,"url":null},"def":{"name":"error_ds_ldap_send_queue_full?","visibility":"Public","body":"self == ERROR_DS_LDAP_SEND_QUEUE_FULL"}},{"html_id":"error_ds_link_id_not_available?-instance-method","name":"error_ds_link_id_not_available?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1594,"url":null},"def":{"name":"error_ds_link_id_not_available?","visibility":"Public","body":"self == ERROR_DS_LINK_ID_NOT_AVAILABLE"}},{"html_id":"error_ds_local_cant_have_crossdomain_local_member?-instance-method","name":"error_ds_local_cant_have_crossdomain_local_member?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1537,"url":null},"def":{"name":"error_ds_local_cant_have_crossdomain_local_member?","visibility":"Public","body":"self == ERROR_DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER"}},{"html_id":"error_ds_local_error?-instance-method","name":"error_ds_local_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1307,"url":null},"def":{"name":"error_ds_local_error?","visibility":"Public","body":"self == ERROR_DS_LOCAL_ERROR"}},{"html_id":"error_ds_local_member_of_local_only?-instance-method","name":"error_ds_local_member_of_local_only?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1565,"url":null},"def":{"name":"error_ds_local_member_of_local_only?","visibility":"Public","body":"self == ERROR_DS_LOCAL_MEMBER_OF_LOCAL_ONLY"}},{"html_id":"error_ds_loop_detect?-instance-method","name":"error_ds_loop_detect?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1302,"url":null},"def":{"name":"error_ds_loop_detect?","visibility":"Public","body":"self == ERROR_DS_LOOP_DETECT"}},{"html_id":"error_ds_low_dsa_version?-instance-method","name":"error_ds_low_dsa_version?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1585,"url":null},"def":{"name":"error_ds_low_dsa_version?","visibility":"Public","body":"self == ERROR_DS_LOW_DSA_VERSION"}},{"html_id":"error_ds_machine_account_created_prent4?-instance-method","name":"error_ds_machine_account_created_prent4?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1589,"url":null},"def":{"name":"error_ds_machine_account_created_prent4?","visibility":"Public","body":"self == ERROR_DS_MACHINE_ACCOUNT_CREATED_PRENT4"}},{"html_id":"error_ds_machine_account_quota_exceeded?-instance-method","name":"error_ds_machine_account_quota_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1574,"url":null},"def":{"name":"error_ds_machine_account_quota_exceeded?","visibility":"Public","body":"self == ERROR_DS_MACHINE_ACCOUNT_QUOTA_EXCEEDED"}},{"html_id":"error_ds_masterdsa_required?-instance-method","name":"error_ds_masterdsa_required?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1332,"url":null},"def":{"name":"error_ds_masterdsa_required?","visibility":"Public","body":"self == ERROR_DS_MASTERDSA_REQUIRED"}},{"html_id":"error_ds_max_obj_size_exceeded?-instance-method","name":"error_ds_max_obj_size_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1322,"url":null},"def":{"name":"error_ds_max_obj_size_exceeded?","visibility":"Public","body":"self == ERROR_DS_MAX_OBJ_SIZE_EXCEEDED"}},{"html_id":"error_ds_membership_evaluated_locally?-instance-method","name":"error_ds_membership_evaluated_locally?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1258,"url":null},"def":{"name":"error_ds_membership_evaluated_locally?","visibility":"Public","body":"self == ERROR_DS_MEMBERSHIP_EVALUATED_LOCALLY"}},{"html_id":"error_ds_missing_expected_att?-instance-method","name":"error_ds_missing_expected_att?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1428,"url":null},"def":{"name":"error_ds_missing_expected_att?","visibility":"Public","body":"self == ERROR_DS_MISSING_EXPECTED_ATT"}},{"html_id":"error_ds_missing_fsmo_settings?-instance-method","name":"error_ds_missing_fsmo_settings?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1451,"url":null},"def":{"name":"error_ds_missing_fsmo_settings?","visibility":"Public","body":"self == ERROR_DS_MISSING_FSMO_SETTINGS"}},{"html_id":"error_ds_missing_infrastructure_container?-instance-method","name":"error_ds_missing_infrastructure_container?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1514,"url":null},"def":{"name":"error_ds_missing_infrastructure_container?","visibility":"Public","body":"self == ERROR_DS_MISSING_INFRASTRUCTURE_CONTAINER"}},{"html_id":"error_ds_missing_required_att?-instance-method","name":"error_ds_missing_required_att?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1334,"url":null},"def":{"name":"error_ds_missing_required_att?","visibility":"Public","body":"self == ERROR_DS_MISSING_REQUIRED_ATT"}},{"html_id":"error_ds_missing_supref?-instance-method","name":"error_ds_missing_supref?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1423,"url":null},"def":{"name":"error_ds_missing_supref?","visibility":"Public","body":"self == ERROR_DS_MISSING_SUPREF"}},{"html_id":"error_ds_modifydn_disallowed_by_flag?-instance-method","name":"error_ds_modifydn_disallowed_by_flag?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1598,"url":null},"def":{"name":"error_ds_modifydn_disallowed_by_flag?","visibility":"Public","body":"self == ERROR_DS_MODIFYDN_DISALLOWED_BY_FLAG"}},{"html_id":"error_ds_modifydn_disallowed_by_instance_type?-instance-method","name":"error_ds_modifydn_disallowed_by_instance_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1596,"url":null},"def":{"name":"error_ds_modifydn_disallowed_by_instance_type?","visibility":"Public","body":"self == ERROR_DS_MODIFYDN_DISALLOWED_BY_INSTANCE_TYPE"}},{"html_id":"error_ds_modifydn_wrong_grandparent?-instance-method","name":"error_ds_modifydn_wrong_grandparent?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1599,"url":null},"def":{"name":"error_ds_modifydn_wrong_grandparent?","visibility":"Public","body":"self == ERROR_DS_MODIFYDN_WRONG_GRANDPARENT"}},{"html_id":"error_ds_must_be_run_on_dst_dc?-instance-method","name":"error_ds_must_be_run_on_dst_dc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1575,"url":null},"def":{"name":"error_ds_must_be_run_on_dst_dc?","visibility":"Public","body":"self == ERROR_DS_MUST_BE_RUN_ON_DST_DC"}},{"html_id":"error_ds_name_error_domain_only?-instance-method","name":"error_ds_name_error_domain_only?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1490,"url":null},"def":{"name":"error_ds_name_error_domain_only?","visibility":"Public","body":"self == ERROR_DS_NAME_ERROR_DOMAIN_ONLY"}},{"html_id":"error_ds_name_error_no_mapping?-instance-method","name":"error_ds_name_error_no_mapping?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1489,"url":null},"def":{"name":"error_ds_name_error_no_mapping?","visibility":"Public","body":"self == ERROR_DS_NAME_ERROR_NO_MAPPING"}},{"html_id":"error_ds_name_error_no_syntactical_mapping?-instance-method","name":"error_ds_name_error_no_syntactical_mapping?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1491,"url":null},"def":{"name":"error_ds_name_error_no_syntactical_mapping?","visibility":"Public","body":"self == ERROR_DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING"}},{"html_id":"error_ds_name_error_not_found?-instance-method","name":"error_ds_name_error_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1487,"url":null},"def":{"name":"error_ds_name_error_not_found?","visibility":"Public","body":"self == ERROR_DS_NAME_ERROR_NOT_FOUND"}},{"html_id":"error_ds_name_error_not_unique?-instance-method","name":"error_ds_name_error_not_unique?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1488,"url":null},"def":{"name":"error_ds_name_error_not_unique?","visibility":"Public","body":"self == ERROR_DS_NAME_ERROR_NOT_UNIQUE"}},{"html_id":"error_ds_name_error_resolving?-instance-method","name":"error_ds_name_error_resolving?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1486,"url":null},"def":{"name":"error_ds_name_error_resolving?","visibility":"Public","body":"self == ERROR_DS_NAME_ERROR_RESOLVING"}},{"html_id":"error_ds_name_error_trust_referral?-instance-method","name":"error_ds_name_error_trust_referral?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1600,"url":null},"def":{"name":"error_ds_name_error_trust_referral?","visibility":"Public","body":"self == ERROR_DS_NAME_ERROR_TRUST_REFERRAL"}},{"html_id":"error_ds_name_not_unique?-instance-method","name":"error_ds_name_not_unique?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1588,"url":null},"def":{"name":"error_ds_name_not_unique?","visibility":"Public","body":"self == ERROR_DS_NAME_NOT_UNIQUE"}},{"html_id":"error_ds_name_reference_invalid?-instance-method","name":"error_ds_name_reference_invalid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1390,"url":null},"def":{"name":"error_ds_name_reference_invalid?","visibility":"Public","body":"self == ERROR_DS_NAME_REFERENCE_INVALID"}},{"html_id":"error_ds_name_too_long?-instance-method","name":"error_ds_name_too_long?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1365,"url":null},"def":{"name":"error_ds_name_too_long?","visibility":"Public","body":"self == ERROR_DS_NAME_TOO_LONG"}},{"html_id":"error_ds_name_too_many_parts?-instance-method","name":"error_ds_name_too_many_parts?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1364,"url":null},"def":{"name":"error_ds_name_too_many_parts?","visibility":"Public","body":"self == ERROR_DS_NAME_TOO_MANY_PARTS"}},{"html_id":"error_ds_name_type_unknown?-instance-method","name":"error_ds_name_type_unknown?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1368,"url":null},"def":{"name":"error_ds_name_type_unknown?","visibility":"Public","body":"self == ERROR_DS_NAME_TYPE_UNKNOWN"}},{"html_id":"error_ds_name_unparseable?-instance-method","name":"error_ds_name_unparseable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1367,"url":null},"def":{"name":"error_ds_name_unparseable?","visibility":"Public","body":"self == ERROR_DS_NAME_UNPARSEABLE"}},{"html_id":"error_ds_name_value_too_long?-instance-method","name":"error_ds_name_value_too_long?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1366,"url":null},"def":{"name":"error_ds_name_value_too_long?","visibility":"Public","body":"self == ERROR_DS_NAME_VALUE_TOO_LONG"}},{"html_id":"error_ds_naming_master_gc?-instance-method","name":"error_ds_naming_master_gc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1540,"url":null},"def":{"name":"error_ds_naming_master_gc?","visibility":"Public","body":"self == ERROR_DS_NAMING_MASTER_GC"}},{"html_id":"error_ds_naming_violation?-instance-method","name":"error_ds_naming_violation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1303,"url":null},"def":{"name":"error_ds_naming_violation?","visibility":"Public","body":"self == ERROR_DS_NAMING_VIOLATION"}},{"html_id":"error_ds_nc_must_have_nc_parent?-instance-method","name":"error_ds_nc_must_have_nc_parent?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1511,"url":null},"def":{"name":"error_ds_nc_must_have_nc_parent?","visibility":"Public","body":"self == ERROR_DS_NC_MUST_HAVE_NC_PARENT"}},{"html_id":"error_ds_nc_still_has_dsas?-instance-method","name":"error_ds_nc_still_has_dsas?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1563,"url":null},"def":{"name":"error_ds_nc_still_has_dsas?","visibility":"Public","body":"self == ERROR_DS_NC_STILL_HAS_DSAS"}},{"html_id":"error_ds_ncname_missing_cr_ref?-instance-method","name":"error_ds_ncname_missing_cr_ref?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1429,"url":null},"def":{"name":"error_ds_ncname_missing_cr_ref?","visibility":"Public","body":"self == ERROR_DS_NCNAME_MISSING_CR_REF"}},{"html_id":"error_ds_ncname_must_be_nc?-instance-method","name":"error_ds_ncname_must_be_nc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1374,"url":null},"def":{"name":"error_ds_ncname_must_be_nc?","visibility":"Public","body":"self == ERROR_DS_NCNAME_MUST_BE_NC"}},{"html_id":"error_ds_no_attribute_or_value?-instance-method","name":"error_ds_no_attribute_or_value?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1259,"url":null},"def":{"name":"error_ds_no_attribute_or_value?","visibility":"Public","body":"self == ERROR_DS_NO_ATTRIBUTE_OR_VALUE"}},{"html_id":"error_ds_no_behavior_version_in_mixeddomain?-instance-method","name":"error_ds_no_behavior_version_in_mixeddomain?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1586,"url":null},"def":{"name":"error_ds_no_behavior_version_in_mixeddomain?","visibility":"Public","body":"self == ERROR_DS_NO_BEHAVIOR_VERSION_IN_MIXEDDOMAIN"}},{"html_id":"error_ds_no_chained_eval?-instance-method","name":"error_ds_no_chained_eval?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1345,"url":null},"def":{"name":"error_ds_no_chained_eval?","visibility":"Public","body":"self == ERROR_DS_NO_CHAINED_EVAL"}},{"html_id":"error_ds_no_chaining?-instance-method","name":"error_ds_no_chaining?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1344,"url":null},"def":{"name":"error_ds_no_chaining?","visibility":"Public","body":"self == ERROR_DS_NO_CHAINING"}},{"html_id":"error_ds_no_checkpoint_with_pdc?-instance-method","name":"error_ds_no_checkpoint_with_pdc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1568,"url":null},"def":{"name":"error_ds_no_checkpoint_with_pdc?","visibility":"Public","body":"self == ERROR_DS_NO_CHECKPOINT_WITH_PDC"}},{"html_id":"error_ds_no_crossref_for_nc?-instance-method","name":"error_ds_no_crossref_for_nc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1380,"url":null},"def":{"name":"error_ds_no_crossref_for_nc?","visibility":"Public","body":"self == ERROR_DS_NO_CROSSREF_FOR_NC"}},{"html_id":"error_ds_no_deleted_name?-instance-method","name":"error_ds_no_deleted_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1372,"url":null},"def":{"name":"error_ds_no_deleted_name?","visibility":"Public","body":"self == ERROR_DS_NO_DELETED_NAME"}},{"html_id":"error_ds_no_fpo_in_universal_groups?-instance-method","name":"error_ds_no_fpo_in_universal_groups?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1566,"url":null},"def":{"name":"error_ds_no_fpo_in_universal_groups?","visibility":"Public","body":"self == ERROR_DS_NO_FPO_IN_UNIVERSAL_GROUPS"}},{"html_id":"error_ds_no_more_rids?-instance-method","name":"error_ds_no_more_rids?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1266,"url":null},"def":{"name":"error_ds_no_more_rids?","visibility":"Public","body":"self == ERROR_DS_NO_MORE_RIDS"}},{"html_id":"error_ds_no_msds_intid?-instance-method","name":"error_ds_no_msds_intid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1613,"url":null},"def":{"name":"error_ds_no_msds_intid?","visibility":"Public","body":"self == ERROR_DS_NO_MSDS_INTID"}},{"html_id":"error_ds_no_nest_globalgroup_in_mixeddomain?-instance-method","name":"error_ds_no_nest_globalgroup_in_mixeddomain?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1531,"url":null},"def":{"name":"error_ds_no_nest_globalgroup_in_mixeddomain?","visibility":"Public","body":"self == ERROR_DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN"}},{"html_id":"error_ds_no_nest_localgroup_in_mixeddomain?-instance-method","name":"error_ds_no_nest_localgroup_in_mixeddomain?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1532,"url":null},"def":{"name":"error_ds_no_nest_localgroup_in_mixeddomain?","visibility":"Public","body":"self == ERROR_DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN"}},{"html_id":"error_ds_no_object_move_in_schema_nc?-instance-method","name":"error_ds_no_object_move_in_schema_nc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1597,"url":null},"def":{"name":"error_ds_no_object_move_in_schema_nc?","visibility":"Public","body":"self == ERROR_DS_NO_OBJECT_MOVE_IN_SCHEMA_NC"}},{"html_id":"error_ds_no_parent_object?-instance-method","name":"error_ds_no_parent_object?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1346,"url":null},"def":{"name":"error_ds_no_parent_object?","visibility":"Public","body":"self == ERROR_DS_NO_PARENT_OBJECT"}},{"html_id":"error_ds_no_pkt_privacy_on_connection?-instance-method","name":"error_ds_no_pkt_privacy_on_connection?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1550,"url":null},"def":{"name":"error_ds_no_pkt_privacy_on_connection?","visibility":"Public","body":"self == ERROR_DS_NO_PKT_PRIVACY_ON_CONNECTION"}},{"html_id":"error_ds_no_rdn_defined_in_schema?-instance-method","name":"error_ds_no_rdn_defined_in_schema?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1324,"url":null},"def":{"name":"error_ds_no_rdn_defined_in_schema?","visibility":"Public","body":"self == ERROR_DS_NO_RDN_DEFINED_IN_SCHEMA"}},{"html_id":"error_ds_no_ref_domain?-instance-method","name":"error_ds_no_ref_domain?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1592,"url":null},"def":{"name":"error_ds_no_ref_domain?","visibility":"Public","body":"self == ERROR_DS_NO_REF_DOMAIN"}},{"html_id":"error_ds_no_requested_atts_found?-instance-method","name":"error_ds_no_requested_atts_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1326,"url":null},"def":{"name":"error_ds_no_requested_atts_found?","visibility":"Public","body":"self == ERROR_DS_NO_REQUESTED_ATTS_FOUND"}},{"html_id":"error_ds_no_results_returned?-instance-method","name":"error_ds_no_results_returned?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1313,"url":null},"def":{"name":"error_ds_no_results_returned?","visibility":"Public","body":"self == ERROR_DS_NO_RESULTS_RETURNED"}},{"html_id":"error_ds_no_rids_allocated?-instance-method","name":"error_ds_no_rids_allocated?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1265,"url":null},"def":{"name":"error_ds_no_rids_allocated?","visibility":"Public","body":"self == ERROR_DS_NO_RIDS_ALLOCATED"}},{"html_id":"error_ds_no_such_object?-instance-method","name":"error_ds_no_such_object?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1296,"url":null},"def":{"name":"error_ds_no_such_object?","visibility":"Public","body":"self == ERROR_DS_NO_SUCH_OBJECT"}},{"html_id":"error_ds_no_tree_delete_above_nc?-instance-method","name":"error_ds_no_tree_delete_above_nc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1518,"url":null},"def":{"name":"error_ds_no_tree_delete_above_nc?","visibility":"Public","body":"self == ERROR_DS_NO_TREE_DELETE_ABOVE_NC"}},{"html_id":"error_ds_non_base_search?-instance-method","name":"error_ds_non_base_search?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1497,"url":null},"def":{"name":"error_ds_non_base_search?","visibility":"Public","body":"self == ERROR_DS_NON_BASE_SEARCH"}},{"html_id":"error_ds_nonexistent_may_have?-instance-method","name":"error_ds_nonexistent_may_have?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1404,"url":null},"def":{"name":"error_ds_nonexistent_may_have?","visibility":"Public","body":"self == ERROR_DS_NONEXISTENT_MAY_HAVE"}},{"html_id":"error_ds_nonexistent_must_have?-instance-method","name":"error_ds_nonexistent_must_have?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1405,"url":null},"def":{"name":"error_ds_nonexistent_must_have?","visibility":"Public","body":"self == ERROR_DS_NONEXISTENT_MUST_HAVE"}},{"html_id":"error_ds_nonexistent_poss_sup?-instance-method","name":"error_ds_nonexistent_poss_sup?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1407,"url":null},"def":{"name":"error_ds_nonexistent_poss_sup?","visibility":"Public","body":"self == ERROR_DS_NONEXISTENT_POSS_SUP"}},{"html_id":"error_ds_nonsafe_schema_change?-instance-method","name":"error_ds_nonsafe_schema_change?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1525,"url":null},"def":{"name":"error_ds_nonsafe_schema_change?","visibility":"Public","body":"self == ERROR_DS_NONSAFE_SCHEMA_CHANGE"}},{"html_id":"error_ds_not_an_object?-instance-method","name":"error_ds_not_an_object?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1369,"url":null},"def":{"name":"error_ds_not_an_object?","visibility":"Public","body":"self == ERROR_DS_NOT_AN_OBJECT"}},{"html_id":"error_ds_not_authoritive_for_dst_nc?-instance-method","name":"error_ds_not_authoritive_for_dst_nc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1504,"url":null},"def":{"name":"error_ds_not_authoritive_for_dst_nc?","visibility":"Public","body":"self == ERROR_DS_NOT_AUTHORITIVE_FOR_DST_NC"}},{"html_id":"error_ds_not_closest?-instance-method","name":"error_ds_not_closest?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1605,"url":null},"def":{"name":"error_ds_not_closest?","visibility":"Public","body":"self == ERROR_DS_NOT_CLOSEST"}},{"html_id":"error_ds_not_installed?-instance-method","name":"error_ds_not_installed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1257,"url":null},"def":{"name":"error_ds_not_installed?","visibility":"Public","body":"self == ERROR_DS_NOT_INSTALLED"}},{"html_id":"error_ds_not_on_backlink?-instance-method","name":"error_ds_not_on_backlink?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1379,"url":null},"def":{"name":"error_ds_not_on_backlink?","visibility":"Public","body":"self == ERROR_DS_NOT_ON_BACKLINK"}},{"html_id":"error_ds_not_supported?-instance-method","name":"error_ds_not_supported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1312,"url":null},"def":{"name":"error_ds_not_supported?","visibility":"Public","body":"self == ERROR_DS_NOT_SUPPORTED"}},{"html_id":"error_ds_not_supported_sort_order?-instance-method","name":"error_ds_not_supported_sort_order?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1587,"url":null},"def":{"name":"error_ds_not_supported_sort_order?","visibility":"Public","body":"self == ERROR_DS_NOT_SUPPORTED_SORT_ORDER"}},{"html_id":"error_ds_notify_filter_too_complex?-instance-method","name":"error_ds_notify_filter_too_complex?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1394,"url":null},"def":{"name":"error_ds_notify_filter_too_complex?","visibility":"Public","body":"self == ERROR_DS_NOTIFY_FILTER_TOO_COMPLEX"}},{"html_id":"error_ds_ntdscript_process_error?-instance-method","name":"error_ds_ntdscript_process_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1609,"url":null},"def":{"name":"error_ds_ntdscript_process_error?","visibility":"Public","body":"self == ERROR_DS_NTDSCRIPT_PROCESS_ERROR"}},{"html_id":"error_ds_ntdscript_syntax_error?-instance-method","name":"error_ds_ntdscript_syntax_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1608,"url":null},"def":{"name":"error_ds_ntdscript_syntax_error?","visibility":"Public","body":"self == ERROR_DS_NTDSCRIPT_SYNTAX_ERROR"}},{"html_id":"error_ds_obj_class_not_defined?-instance-method","name":"error_ds_obj_class_not_defined?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1388,"url":null},"def":{"name":"error_ds_obj_class_not_defined?","visibility":"Public","body":"self == ERROR_DS_OBJ_CLASS_NOT_DEFINED"}},{"html_id":"error_ds_obj_class_not_subclass?-instance-method","name":"error_ds_obj_class_not_subclass?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1389,"url":null},"def":{"name":"error_ds_obj_class_not_subclass?","visibility":"Public","body":"self == ERROR_DS_OBJ_CLASS_NOT_SUBCLASS"}},{"html_id":"error_ds_obj_class_violation?-instance-method","name":"error_ds_obj_class_violation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1269,"url":null},"def":{"name":"error_ds_obj_class_violation?","visibility":"Public","body":"self == ERROR_DS_OBJ_CLASS_VIOLATION"}},{"html_id":"error_ds_obj_guid_exists?-instance-method","name":"error_ds_obj_guid_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1378,"url":null},"def":{"name":"error_ds_obj_guid_exists?","visibility":"Public","body":"self == ERROR_DS_OBJ_GUID_EXISTS"}},{"html_id":"error_ds_obj_not_found?-instance-method","name":"error_ds_obj_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1350,"url":null},"def":{"name":"error_ds_obj_not_found?","visibility":"Public","body":"self == ERROR_DS_OBJ_NOT_FOUND"}},{"html_id":"error_ds_obj_string_name_exists?-instance-method","name":"error_ds_obj_string_name_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1323,"url":null},"def":{"name":"error_ds_obj_string_name_exists?","visibility":"Public","body":"self == ERROR_DS_OBJ_STRING_NAME_EXISTS"}},{"html_id":"error_ds_obj_too_large?-instance-method","name":"error_ds_obj_too_large?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1330,"url":null},"def":{"name":"error_ds_obj_too_large?","visibility":"Public","body":"self == ERROR_DS_OBJ_TOO_LARGE"}},{"html_id":"error_ds_object_being_removed?-instance-method","name":"error_ds_object_being_removed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1356,"url":null},"def":{"name":"error_ds_object_being_removed?","visibility":"Public","body":"self == ERROR_DS_OBJECT_BEING_REMOVED"}},{"html_id":"error_ds_object_class_required?-instance-method","name":"error_ds_object_class_required?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1333,"url":null},"def":{"name":"error_ds_object_class_required?","visibility":"Public","body":"self == ERROR_DS_OBJECT_CLASS_REQUIRED"}},{"html_id":"error_ds_object_results_too_large?-instance-method","name":"error_ds_object_results_too_large?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1304,"url":null},"def":{"name":"error_ds_object_results_too_large?","visibility":"Public","body":"self == ERROR_DS_OBJECT_RESULTS_TOO_LARGE"}},{"html_id":"error_ds_offset_range_error?-instance-method","name":"error_ds_offset_range_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1318,"url":null},"def":{"name":"error_ds_offset_range_error?","visibility":"Public","body":"self == ERROR_DS_OFFSET_RANGE_ERROR"}},{"html_id":"error_ds_operations_error?-instance-method","name":"error_ds_operations_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1280,"url":null},"def":{"name":"error_ds_operations_error?","visibility":"Public","body":"self == ERROR_DS_OPERATIONS_ERROR"}},{"html_id":"error_ds_out_of_scope?-instance-method","name":"error_ds_out_of_scope?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1355,"url":null},"def":{"name":"error_ds_out_of_scope?","visibility":"Public","body":"self == ERROR_DS_OUT_OF_SCOPE"}},{"html_id":"error_ds_out_of_version_store?-instance-method","name":"error_ds_out_of_version_store?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1590,"url":null},"def":{"name":"error_ds_out_of_version_store?","visibility":"Public","body":"self == ERROR_DS_OUT_OF_VERSION_STORE"}},{"html_id":"error_ds_param_error?-instance-method","name":"error_ds_param_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1311,"url":null},"def":{"name":"error_ds_param_error?","visibility":"Public","body":"self == ERROR_DS_PARAM_ERROR"}},{"html_id":"error_ds_parent_is_an_alias?-instance-method","name":"error_ds_parent_is_an_alias?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1347,"url":null},"def":{"name":"error_ds_parent_is_an_alias?","visibility":"Public","body":"self == ERROR_DS_PARENT_IS_AN_ALIAS"}},{"html_id":"error_ds_pdc_operation_in_progress?-instance-method","name":"error_ds_pdc_operation_in_progress?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1507,"url":null},"def":{"name":"error_ds_pdc_operation_in_progress?","visibility":"Public","body":"self == ERROR_DS_PDC_OPERATION_IN_PROGRESS"}},{"html_id":"error_ds_protocol_error?-instance-method","name":"error_ds_protocol_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1281,"url":null},"def":{"name":"error_ds_protocol_error?","visibility":"Public","body":"self == ERROR_DS_PROTOCOL_ERROR"}},{"html_id":"error_ds_range_constraint?-instance-method","name":"error_ds_range_constraint?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1339,"url":null},"def":{"name":"error_ds_range_constraint?","visibility":"Public","body":"self == ERROR_DS_RANGE_CONSTRAINT"}},{"html_id":"error_ds_rdn_doesnt_match_schema?-instance-method","name":"error_ds_rdn_doesnt_match_schema?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1325,"url":null},"def":{"name":"error_ds_rdn_doesnt_match_schema?","visibility":"Public","body":"self == ERROR_DS_RDN_DOESNT_MATCH_SCHEMA"}},{"html_id":"error_ds_recalcschema_failed?-instance-method","name":"error_ds_recalcschema_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1413,"url":null},"def":{"name":"error_ds_recalcschema_failed?","visibility":"Public","body":"self == ERROR_DS_RECALCSCHEMA_FAILED"}},{"html_id":"error_ds_referral?-instance-method","name":"error_ds_referral?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1291,"url":null},"def":{"name":"error_ds_referral?","visibility":"Public","body":"self == ERROR_DS_REFERRAL"}},{"html_id":"error_ds_referral_limit_exceeded?-instance-method","name":"error_ds_referral_limit_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1316,"url":null},"def":{"name":"error_ds_referral_limit_exceeded?","visibility":"Public","body":"self == ERROR_DS_REFERRAL_LIMIT_EXCEEDED"}},{"html_id":"error_ds_refusing_fsmo_roles?-instance-method","name":"error_ds_refusing_fsmo_roles?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1450,"url":null},"def":{"name":"error_ds_refusing_fsmo_roles?","visibility":"Public","body":"self == ERROR_DS_REFUSING_FSMO_ROLES"}},{"html_id":"error_ds_remote_crossref_op_failed?-instance-method","name":"error_ds_remote_crossref_op_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1618,"url":null},"def":{"name":"error_ds_remote_crossref_op_failed?","visibility":"Public","body":"self == ERROR_DS_REMOTE_CROSSREF_OP_FAILED"}},{"html_id":"error_ds_repl_lifetime_exceeded?-instance-method","name":"error_ds_repl_lifetime_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1631,"url":null},"def":{"name":"error_ds_repl_lifetime_exceeded?","visibility":"Public","body":"self == ERROR_DS_REPL_LIFETIME_EXCEEDED"}},{"html_id":"error_ds_replica_set_change_not_allowed_on_disabled_cr?-instance-method","name":"error_ds_replica_set_change_not_allowed_on_disabled_cr?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1612,"url":null},"def":{"name":"error_ds_replica_set_change_not_allowed_on_disabled_cr?","visibility":"Public","body":"self == ERROR_DS_REPLICA_SET_CHANGE_NOT_ALLOWED_ON_DISABLED_CR"}},{"html_id":"error_ds_replicator_only?-instance-method","name":"error_ds_replicator_only?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1387,"url":null},"def":{"name":"error_ds_replicator_only?","visibility":"Public","body":"self == ERROR_DS_REPLICATOR_ONLY"}},{"html_id":"error_ds_reserved_link_id?-instance-method","name":"error_ds_reserved_link_id?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1593,"url":null},"def":{"name":"error_ds_reserved_link_id?","visibility":"Public","body":"self == ERROR_DS_RESERVED_LINK_ID"}},{"html_id":"error_ds_ridmgr_init_error?-instance-method","name":"error_ds_ridmgr_init_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1268,"url":null},"def":{"name":"error_ds_ridmgr_init_error?","visibility":"Public","body":"self == ERROR_DS_RIDMGR_INIT_ERROR"}},{"html_id":"error_ds_role_not_verified?-instance-method","name":"error_ds_role_not_verified?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1627,"url":null},"def":{"name":"error_ds_role_not_verified?","visibility":"Public","body":"self == ERROR_DS_ROLE_NOT_VERIFIED"}},{"html_id":"error_ds_root_cant_be_subref?-instance-method","name":"error_ds_root_cant_be_subref?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1343,"url":null},"def":{"name":"error_ds_root_cant_be_subref?","visibility":"Public","body":"self == ERROR_DS_ROOT_CANT_BE_SUBREF"}},{"html_id":"error_ds_root_must_be_nc?-instance-method","name":"error_ds_root_must_be_nc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1319,"url":null},"def":{"name":"error_ds_root_must_be_nc?","visibility":"Public","body":"self == ERROR_DS_ROOT_MUST_BE_NC"}},{"html_id":"error_ds_root_requires_class_top?-instance-method","name":"error_ds_root_requires_class_top?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1449,"url":null},"def":{"name":"error_ds_root_requires_class_top?","visibility":"Public","body":"self == ERROR_DS_ROOT_REQUIRES_CLASS_TOP"}},{"html_id":"error_ds_sam_init_failure?-instance-method","name":"error_ds_sam_init_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1521,"url":null},"def":{"name":"error_ds_sam_init_failure?","visibility":"Public","body":"self == ERROR_DS_SAM_INIT_FAILURE"}},{"html_id":"error_ds_sam_init_failure_console?-instance-method","name":"error_ds_sam_init_failure_console?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1579,"url":null},"def":{"name":"error_ds_sam_init_failure_console?","visibility":"Public","body":"self == ERROR_DS_SAM_INIT_FAILURE_CONSOLE"}},{"html_id":"error_ds_sam_need_bootkey_floppy?-instance-method","name":"error_ds_sam_need_bootkey_floppy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1547,"url":null},"def":{"name":"error_ds_sam_need_bootkey_floppy?","visibility":"Public","body":"self == ERROR_DS_SAM_NEED_BOOTKEY_FLOPPY"}},{"html_id":"error_ds_sam_need_bootkey_password?-instance-method","name":"error_ds_sam_need_bootkey_password?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1546,"url":null},"def":{"name":"error_ds_sam_need_bootkey_password?","visibility":"Public","body":"self == ERROR_DS_SAM_NEED_BOOTKEY_PASSWORD"}},{"html_id":"error_ds_schema_alloc_failed?-instance-method","name":"error_ds_schema_alloc_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1432,"url":null},"def":{"name":"error_ds_schema_alloc_failed?","visibility":"Public","body":"self == ERROR_DS_SCHEMA_ALLOC_FAILED"}},{"html_id":"error_ds_schema_not_loaded?-instance-method","name":"error_ds_schema_not_loaded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1431,"url":null},"def":{"name":"error_ds_schema_not_loaded?","visibility":"Public","body":"self == ERROR_DS_SCHEMA_NOT_LOADED"}},{"html_id":"error_ds_schema_update_disallowed?-instance-method","name":"error_ds_schema_update_disallowed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1526,"url":null},"def":{"name":"error_ds_schema_update_disallowed?","visibility":"Public","body":"self == ERROR_DS_SCHEMA_UPDATE_DISALLOWED"}},{"html_id":"error_ds_sec_desc_invalid?-instance-method","name":"error_ds_sec_desc_invalid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1371,"url":null},"def":{"name":"error_ds_sec_desc_invalid?","visibility":"Public","body":"self == ERROR_DS_SEC_DESC_INVALID"}},{"html_id":"error_ds_sec_desc_too_short?-instance-method","name":"error_ds_sec_desc_too_short?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1370,"url":null},"def":{"name":"error_ds_sec_desc_too_short?","visibility":"Public","body":"self == ERROR_DS_SEC_DESC_TOO_SHORT"}},{"html_id":"error_ds_security_checking_error?-instance-method","name":"error_ds_security_checking_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1430,"url":null},"def":{"name":"error_ds_security_checking_error?","visibility":"Public","body":"self == ERROR_DS_SECURITY_CHECKING_ERROR"}},{"html_id":"error_ds_security_illegal_modify?-instance-method","name":"error_ds_security_illegal_modify?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1440,"url":null},"def":{"name":"error_ds_security_illegal_modify?","visibility":"Public","body":"self == ERROR_DS_SECURITY_ILLEGAL_MODIFY"}},{"html_id":"error_ds_semantic_att_test?-instance-method","name":"error_ds_semantic_att_test?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1400,"url":null},"def":{"name":"error_ds_semantic_att_test?","visibility":"Public","body":"self == ERROR_DS_SEMANTIC_ATT_TEST"}},{"html_id":"error_ds_sensitive_group_violation?-instance-method","name":"error_ds_sensitive_group_violation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1522,"url":null},"def":{"name":"error_ds_sensitive_group_violation?","visibility":"Public","body":"self == ERROR_DS_SENSITIVE_GROUP_VIOLATION"}},{"html_id":"error_ds_server_down?-instance-method","name":"error_ds_server_down?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1306,"url":null},"def":{"name":"error_ds_server_down?","visibility":"Public","body":"self == ERROR_DS_SERVER_DOWN"}},{"html_id":"error_ds_shutting_down?-instance-method","name":"error_ds_shutting_down?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1381,"url":null},"def":{"name":"error_ds_shutting_down?","visibility":"Public","body":"self == ERROR_DS_SHUTTING_DOWN"}},{"html_id":"error_ds_single_user_mode_failed?-instance-method","name":"error_ds_single_user_mode_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1607,"url":null},"def":{"name":"error_ds_single_user_mode_failed?","visibility":"Public","body":"self == ERROR_DS_SINGLE_USER_MODE_FAILED"}},{"html_id":"error_ds_single_value_constraint?-instance-method","name":"error_ds_single_value_constraint?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1338,"url":null},"def":{"name":"error_ds_single_value_constraint?","visibility":"Public","body":"self == ERROR_DS_SINGLE_VALUE_CONSTRAINT"}},{"html_id":"error_ds_sizelimit_exceeded?-instance-method","name":"error_ds_sizelimit_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1283,"url":null},"def":{"name":"error_ds_sizelimit_exceeded?","visibility":"Public","body":"self == ERROR_DS_SIZELIMIT_EXCEEDED"}},{"html_id":"error_ds_sort_control_missing?-instance-method","name":"error_ds_sort_control_missing?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1317,"url":null},"def":{"name":"error_ds_sort_control_missing?","visibility":"Public","body":"self == ERROR_DS_SORT_CONTROL_MISSING"}},{"html_id":"error_ds_source_auditing_not_enabled?-instance-method","name":"error_ds_source_auditing_not_enabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1569,"url":null},"def":{"name":"error_ds_source_auditing_not_enabled?","visibility":"Public","body":"self == ERROR_DS_SOURCE_AUDITING_NOT_ENABLED"}},{"html_id":"error_ds_source_domain_in_forest?-instance-method","name":"error_ds_source_domain_in_forest?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1551,"url":null},"def":{"name":"error_ds_source_domain_in_forest?","visibility":"Public","body":"self == ERROR_DS_SOURCE_DOMAIN_IN_FOREST"}},{"html_id":"error_ds_src_and_dst_nc_identical?-instance-method","name":"error_ds_src_and_dst_nc_identical?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1502,"url":null},"def":{"name":"error_ds_src_and_dst_nc_identical?","visibility":"Public","body":"self == ERROR_DS_SRC_AND_DST_NC_IDENTICAL"}},{"html_id":"error_ds_src_and_dst_object_class_mismatch?-instance-method","name":"error_ds_src_and_dst_object_class_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1557,"url":null},"def":{"name":"error_ds_src_and_dst_object_class_mismatch?","visibility":"Public","body":"self == ERROR_DS_SRC_AND_DST_OBJECT_CLASS_MISMATCH"}},{"html_id":"error_ds_src_dc_must_be_sp4_or_greater?-instance-method","name":"error_ds_src_dc_must_be_sp4_or_greater?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1576,"url":null},"def":{"name":"error_ds_src_dc_must_be_sp4_or_greater?","visibility":"Public","body":"self == ERROR_DS_SRC_DC_MUST_BE_SP4_OR_GREATER"}},{"html_id":"error_ds_src_guid_mismatch?-instance-method","name":"error_ds_src_guid_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1505,"url":null},"def":{"name":"error_ds_src_guid_mismatch?","visibility":"Public","body":"self == ERROR_DS_SRC_GUID_MISMATCH"}},{"html_id":"error_ds_src_name_mismatch?-instance-method","name":"error_ds_src_name_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1501,"url":null},"def":{"name":"error_ds_src_name_mismatch?","visibility":"Public","body":"self == ERROR_DS_SRC_NAME_MISMATCH"}},{"html_id":"error_ds_src_obj_not_group_or_user?-instance-method","name":"error_ds_src_obj_not_group_or_user?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1555,"url":null},"def":{"name":"error_ds_src_obj_not_group_or_user?","visibility":"Public","body":"self == ERROR_DS_SRC_OBJ_NOT_GROUP_OR_USER"}},{"html_id":"error_ds_src_sid_exists_in_forest?-instance-method","name":"error_ds_src_sid_exists_in_forest?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1556,"url":null},"def":{"name":"error_ds_src_sid_exists_in_forest?","visibility":"Public","body":"self == ERROR_DS_SRC_SID_EXISTS_IN_FOREST"}},{"html_id":"error_ds_string_sd_conversion_failed?-instance-method","name":"error_ds_string_sd_conversion_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1539,"url":null},"def":{"name":"error_ds_string_sd_conversion_failed?","visibility":"Public","body":"self == ERROR_DS_STRING_SD_CONVERSION_FAILED"}},{"html_id":"error_ds_strong_auth_required?-instance-method","name":"error_ds_strong_auth_required?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1288,"url":null},"def":{"name":"error_ds_strong_auth_required?","visibility":"Public","body":"self == ERROR_DS_STRONG_AUTH_REQUIRED"}},{"html_id":"error_ds_sub_cls_test_fail?-instance-method","name":"error_ds_sub_cls_test_fail?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1408,"url":null},"def":{"name":"error_ds_sub_cls_test_fail?","visibility":"Public","body":"self == ERROR_DS_SUB_CLS_TEST_FAIL"}},{"html_id":"error_ds_subref_must_have_parent?-instance-method","name":"error_ds_subref_must_have_parent?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1373,"url":null},"def":{"name":"error_ds_subref_must_have_parent?","visibility":"Public","body":"self == ERROR_DS_SUBREF_MUST_HAVE_PARENT"}},{"html_id":"error_ds_subtree_notify_not_nc_head?-instance-method","name":"error_ds_subtree_notify_not_nc_head?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1393,"url":null},"def":{"name":"error_ds_subtree_notify_not_nc_head?","visibility":"Public","body":"self == ERROR_DS_SUBTREE_NOTIFY_NOT_NC_HEAD"}},{"html_id":"error_ds_syntax_mismatch?-instance-method","name":"error_ds_syntax_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1401,"url":null},"def":{"name":"error_ds_syntax_mismatch?","visibility":"Public","body":"self == ERROR_DS_SYNTAX_MISMATCH"}},{"html_id":"error_ds_thread_limit_exceeded?-instance-method","name":"error_ds_thread_limit_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1604,"url":null},"def":{"name":"error_ds_thread_limit_exceeded?","visibility":"Public","body":"self == ERROR_DS_THREAD_LIMIT_EXCEEDED"}},{"html_id":"error_ds_timelimit_exceeded?-instance-method","name":"error_ds_timelimit_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1282,"url":null},"def":{"name":"error_ds_timelimit_exceeded?","visibility":"Public","body":"self == ERROR_DS_TIMELIMIT_EXCEEDED"}},{"html_id":"error_ds_tree_delete_not_finished?-instance-method","name":"error_ds_tree_delete_not_finished?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1414,"url":null},"def":{"name":"error_ds_tree_delete_not_finished?","visibility":"Public","body":"self == ERROR_DS_TREE_DELETE_NOT_FINISHED"}},{"html_id":"error_ds_unable_to_surrender_roles?-instance-method","name":"error_ds_unable_to_surrender_roles?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1452,"url":null},"def":{"name":"error_ds_unable_to_surrender_roles?","visibility":"Public","body":"self == ERROR_DS_UNABLE_TO_SURRENDER_ROLES"}},{"html_id":"error_ds_unavailable?-instance-method","name":"error_ds_unavailable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1264,"url":null},"def":{"name":"error_ds_unavailable?","visibility":"Public","body":"self == ERROR_DS_UNAVAILABLE"}},{"html_id":"error_ds_unavailable_crit_extension?-instance-method","name":"error_ds_unavailable_crit_extension?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1292,"url":null},"def":{"name":"error_ds_unavailable_crit_extension?","visibility":"Public","body":"self == ERROR_DS_UNAVAILABLE_CRIT_EXTENSION"}},{"html_id":"error_ds_unicodepwd_not_in_quotes?-instance-method","name":"error_ds_unicodepwd_not_in_quotes?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1573,"url":null},"def":{"name":"error_ds_unicodepwd_not_in_quotes?","visibility":"Public","body":"self == ERROR_DS_UNICODEPWD_NOT_IN_QUOTES"}},{"html_id":"error_ds_universal_cant_have_local_member?-instance-method","name":"error_ds_universal_cant_have_local_member?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1535,"url":null},"def":{"name":"error_ds_universal_cant_have_local_member?","visibility":"Public","body":"self == ERROR_DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER"}},{"html_id":"error_ds_unknown_error?-instance-method","name":"error_ds_unknown_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1448,"url":null},"def":{"name":"error_ds_unknown_error?","visibility":"Public","body":"self == ERROR_DS_UNKNOWN_ERROR"}},{"html_id":"error_ds_unknown_operation?-instance-method","name":"error_ds_unknown_operation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1382,"url":null},"def":{"name":"error_ds_unknown_operation?","visibility":"Public","body":"self == ERROR_DS_UNKNOWN_OPERATION"}},{"html_id":"error_ds_unwilling_to_perform?-instance-method","name":"error_ds_unwilling_to_perform?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1301,"url":null},"def":{"name":"error_ds_unwilling_to_perform?","visibility":"Public","body":"self == ERROR_DS_UNWILLING_TO_PERFORM"}},{"html_id":"error_ds_user_buffer_to_small?-instance-method","name":"error_ds_user_buffer_to_small?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1327,"url":null},"def":{"name":"error_ds_user_buffer_to_small?","visibility":"Public","body":"self == ERROR_DS_USER_BUFFER_TO_SMALL"}},{"html_id":"error_ds_wko_container_cannot_be_special?-instance-method","name":"error_ds_wko_container_cannot_be_special?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1628,"url":null},"def":{"name":"error_ds_wko_container_cannot_be_special?","visibility":"Public","body":"self == ERROR_DS_WKO_CONTAINER_CANNOT_BE_SPECIAL"}},{"html_id":"error_ds_wrong_linked_att_syntax?-instance-method","name":"error_ds_wrong_linked_att_syntax?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1545,"url":null},"def":{"name":"error_ds_wrong_linked_att_syntax?","visibility":"Public","body":"self == ERROR_DS_WRONG_LINKED_ATT_SYNTAX"}},{"html_id":"error_ds_wrong_om_obj_class?-instance-method","name":"error_ds_wrong_om_obj_class?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1493,"url":null},"def":{"name":"error_ds_wrong_om_obj_class?","visibility":"Public","body":"self == ERROR_DS_WRONG_OM_OBJ_CLASS"}},{"html_id":"error_dup_domainname?-instance-method","name":"error_dup_domainname?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":522,"url":null},"def":{"name":"error_dup_domainname?","visibility":"Public","body":"self == ERROR_DUP_DOMAINNAME"}},{"html_id":"error_dup_name?-instance-method","name":"error_dup_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":197,"url":null},"def":{"name":"error_dup_name?","visibility":"Public","body":"self == ERROR_DUP_NAME"}},{"html_id":"error_duplicate_service_name?-instance-method","name":"error_duplicate_service_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":427,"url":null},"def":{"name":"error_duplicate_service_name?","visibility":"Public","body":"self == ERROR_DUPLICATE_SERVICE_NAME"}},{"html_id":"error_duplicate_tag?-instance-method","name":"error_duplicate_tag?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":972,"url":null},"def":{"name":"error_duplicate_tag?","visibility":"Public","body":"self == ERROR_DUPLICATE_TAG"}},{"html_id":"error_dynlink_from_invalid_ring?-instance-method","name":"error_dynlink_from_invalid_ring?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":306,"url":null},"def":{"name":"error_dynlink_from_invalid_ring?","visibility":"Public","body":"self == ERROR_DYNLINK_FROM_INVALID_RING"}},{"html_id":"error_ea_access_denied?-instance-method","name":"error_ea_access_denied?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":372,"url":null},"def":{"name":"error_ea_access_denied?","visibility":"Public","body":"self == ERROR_EA_ACCESS_DENIED"}},{"html_id":"error_ea_file_corrupt?-instance-method","name":"error_ea_file_corrupt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":345,"url":null},"def":{"name":"error_ea_file_corrupt?","visibility":"Public","body":"self == ERROR_EA_FILE_CORRUPT"}},{"html_id":"error_ea_list_inconsistent?-instance-method","name":"error_ea_list_inconsistent?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":339,"url":null},"def":{"name":"error_ea_list_inconsistent?","visibility":"Public","body":"self == ERROR_EA_LIST_INCONSISTENT"}},{"html_id":"error_ea_table_full?-instance-method","name":"error_ea_table_full?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":346,"url":null},"def":{"name":"error_ea_table_full?","visibility":"Public","body":"self == ERROR_EA_TABLE_FULL"}},{"html_id":"error_eas_didnt_fit?-instance-method","name":"error_eas_didnt_fit?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":344,"url":null},"def":{"name":"error_eas_didnt_fit?","visibility":"Public","body":"self == ERROR_EAS_DIDNT_FIT"}},{"html_id":"error_eas_not_supported?-instance-method","name":"error_eas_not_supported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":348,"url":null},"def":{"name":"error_eas_not_supported?","visibility":"Public","body":"self == ERROR_EAS_NOT_SUPPORTED"}},{"html_id":"error_ec_circular_forwarding?-instance-method","name":"error_ec_circular_forwarding?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2133,"url":null},"def":{"name":"error_ec_circular_forwarding?","visibility":"Public","body":"self == ERROR_EC_CIRCULAR_FORWARDING"}},{"html_id":"error_ec_cred_not_found?-instance-method","name":"error_ec_cred_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2135,"url":null},"def":{"name":"error_ec_cred_not_found?","visibility":"Public","body":"self == ERROR_EC_CRED_NOT_FOUND"}},{"html_id":"error_ec_credstore_full?-instance-method","name":"error_ec_credstore_full?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2134,"url":null},"def":{"name":"error_ec_credstore_full?","visibility":"Public","body":"self == ERROR_EC_CREDSTORE_FULL"}},{"html_id":"error_ec_log_disabled?-instance-method","name":"error_ec_log_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2132,"url":null},"def":{"name":"error_ec_log_disabled?","visibility":"Public","body":"self == ERROR_EC_LOG_DISABLED"}},{"html_id":"error_ec_no_active_channel?-instance-method","name":"error_ec_no_active_channel?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2136,"url":null},"def":{"name":"error_ec_no_active_channel?","visibility":"Public","body":"self == ERROR_EC_NO_ACTIVE_CHANNEL"}},{"html_id":"error_ec_subscription_cannot_activate?-instance-method","name":"error_ec_subscription_cannot_activate?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2131,"url":null},"def":{"name":"error_ec_subscription_cannot_activate?","visibility":"Public","body":"self == ERROR_EC_SUBSCRIPTION_CANNOT_ACTIVATE"}},{"html_id":"error_efs_alg_blob_too_big?-instance-method","name":"error_efs_alg_blob_too_big?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1194,"url":null},"def":{"name":"error_efs_alg_blob_too_big?","visibility":"Public","body":"self == ERROR_EFS_ALG_BLOB_TOO_BIG"}},{"html_id":"error_efs_disabled?-instance-method","name":"error_efs_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1196,"url":null},"def":{"name":"error_efs_disabled?","visibility":"Public","body":"self == ERROR_EFS_DISABLED"}},{"html_id":"error_efs_server_not_trusted?-instance-method","name":"error_efs_server_not_trusted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1192,"url":null},"def":{"name":"error_efs_server_not_trusted?","visibility":"Public","body":"self == ERROR_EFS_SERVER_NOT_TRUSTED"}},{"html_id":"error_efs_version_not_support?-instance-method","name":"error_efs_version_not_support?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1197,"url":null},"def":{"name":"error_efs_version_not_support?","visibility":"Public","body":"self == ERROR_EFS_VERSION_NOT_SUPPORT"}},{"html_id":"error_empty?-instance-method","name":"error_empty?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1032,"url":null},"def":{"name":"error_empty?","visibility":"Public","body":"self == ERROR_EMPTY"}},{"html_id":"error_encryption_failed?-instance-method","name":"error_encryption_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1181,"url":null},"def":{"name":"error_encryption_failed?","visibility":"Public","body":"self == ERROR_ENCRYPTION_FAILED"}},{"html_id":"error_end_of_media?-instance-method","name":"error_end_of_media?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":434,"url":null},"def":{"name":"error_end_of_media?","visibility":"Public","body":"self == ERROR_END_OF_MEDIA"}},{"html_id":"error_envvar_not_found?-instance-method","name":"error_envvar_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":313,"url":null},"def":{"name":"error_envvar_not_found?","visibility":"Public","body":"self == ERROR_ENVVAR_NOT_FOUND"}},{"html_id":"error_eom_overflow?-instance-method","name":"error_eom_overflow?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":463,"url":null},"def":{"name":"error_eom_overflow?","visibility":"Public","body":"self == ERROR_EOM_OVERFLOW"}},{"html_id":"error_eventlog_cant_start?-instance-method","name":"error_eventlog_cant_start?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":746,"url":null},"def":{"name":"error_eventlog_cant_start?","visibility":"Public","body":"self == ERROR_EVENTLOG_CANT_START"}},{"html_id":"error_eventlog_file_changed?-instance-method","name":"error_eventlog_file_changed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":748,"url":null},"def":{"name":"error_eventlog_file_changed?","visibility":"Public","body":"self == ERROR_EVENTLOG_FILE_CHANGED"}},{"html_id":"error_eventlog_file_corrupt?-instance-method","name":"error_eventlog_file_corrupt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":745,"url":null},"def":{"name":"error_eventlog_file_corrupt?","visibility":"Public","body":"self == ERROR_EVENTLOG_FILE_CORRUPT"}},{"html_id":"error_evt_cannot_open_channel_of_query?-instance-method","name":"error_evt_cannot_open_channel_of_query?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2128,"url":null},"def":{"name":"error_evt_cannot_open_channel_of_query?","visibility":"Public","body":"self == ERROR_EVT_CANNOT_OPEN_CHANNEL_OF_QUERY"}},{"html_id":"error_evt_channel_cannot_activate?-instance-method","name":"error_evt_channel_cannot_activate?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2117,"url":null},"def":{"name":"error_evt_channel_cannot_activate?","visibility":"Public","body":"self == ERROR_EVT_CHANNEL_CANNOT_ACTIVATE"}},{"html_id":"error_evt_channel_not_found?-instance-method","name":"error_evt_channel_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2099,"url":null},"def":{"name":"error_evt_channel_not_found?","visibility":"Public","body":"self == ERROR_EVT_CHANNEL_NOT_FOUND"}},{"html_id":"error_evt_configuration_error?-instance-method","name":"error_evt_configuration_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2102,"url":null},"def":{"name":"error_evt_configuration_error?","visibility":"Public","body":"self == ERROR_EVT_CONFIGURATION_ERROR"}},{"html_id":"error_evt_event_definition_not_found?-instance-method","name":"error_evt_event_definition_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2124,"url":null},"def":{"name":"error_evt_event_definition_not_found?","visibility":"Public","body":"self == ERROR_EVT_EVENT_DEFINITION_NOT_FOUND"}},{"html_id":"error_evt_event_template_not_found?-instance-method","name":"error_evt_event_template_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2096,"url":null},"def":{"name":"error_evt_event_template_not_found?","visibility":"Public","body":"self == ERROR_EVT_EVENT_TEMPLATE_NOT_FOUND"}},{"html_id":"error_evt_filter_alreadyscoped?-instance-method","name":"error_evt_filter_alreadyscoped?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2106,"url":null},"def":{"name":"error_evt_filter_alreadyscoped?","visibility":"Public","body":"self == ERROR_EVT_FILTER_ALREADYSCOPED"}},{"html_id":"error_evt_filter_invarg?-instance-method","name":"error_evt_filter_invarg?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2108,"url":null},"def":{"name":"error_evt_filter_invarg?","visibility":"Public","body":"self == ERROR_EVT_FILTER_INVARG"}},{"html_id":"error_evt_filter_invtest?-instance-method","name":"error_evt_filter_invtest?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2109,"url":null},"def":{"name":"error_evt_filter_invtest?","visibility":"Public","body":"self == ERROR_EVT_FILTER_INVTEST"}},{"html_id":"error_evt_filter_invtype?-instance-method","name":"error_evt_filter_invtype?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2110,"url":null},"def":{"name":"error_evt_filter_invtype?","visibility":"Public","body":"self == ERROR_EVT_FILTER_INVTYPE"}},{"html_id":"error_evt_filter_noteltset?-instance-method","name":"error_evt_filter_noteltset?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2107,"url":null},"def":{"name":"error_evt_filter_noteltset?","visibility":"Public","body":"self == ERROR_EVT_FILTER_NOTELTSET"}},{"html_id":"error_evt_filter_out_of_range?-instance-method","name":"error_evt_filter_out_of_range?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2130,"url":null},"def":{"name":"error_evt_filter_out_of_range?","visibility":"Public","body":"self == ERROR_EVT_FILTER_OUT_OF_RANGE"}},{"html_id":"error_evt_filter_parseerr?-instance-method","name":"error_evt_filter_parseerr?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2111,"url":null},"def":{"name":"error_evt_filter_parseerr?","visibility":"Public","body":"self == ERROR_EVT_FILTER_PARSEERR"}},{"html_id":"error_evt_filter_too_complex?-instance-method","name":"error_evt_filter_too_complex?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2118,"url":null},"def":{"name":"error_evt_filter_too_complex?","visibility":"Public","body":"self == ERROR_EVT_FILTER_TOO_COMPLEX"}},{"html_id":"error_evt_filter_unexpectedtoken?-instance-method","name":"error_evt_filter_unexpectedtoken?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2113,"url":null},"def":{"name":"error_evt_filter_unexpectedtoken?","visibility":"Public","body":"self == ERROR_EVT_FILTER_UNEXPECTEDTOKEN"}},{"html_id":"error_evt_filter_unsupportedop?-instance-method","name":"error_evt_filter_unsupportedop?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2112,"url":null},"def":{"name":"error_evt_filter_unsupportedop?","visibility":"Public","body":"self == ERROR_EVT_FILTER_UNSUPPORTEDOP"}},{"html_id":"error_evt_invalid_channel_path?-instance-method","name":"error_evt_invalid_channel_path?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2093,"url":null},"def":{"name":"error_evt_invalid_channel_path?","visibility":"Public","body":"self == ERROR_EVT_INVALID_CHANNEL_PATH"}},{"html_id":"error_evt_invalid_channel_property_value?-instance-method","name":"error_evt_invalid_channel_property_value?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2115,"url":null},"def":{"name":"error_evt_invalid_channel_property_value?","visibility":"Public","body":"self == ERROR_EVT_INVALID_CHANNEL_PROPERTY_VALUE"}},{"html_id":"error_evt_invalid_event_data?-instance-method","name":"error_evt_invalid_event_data?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2098,"url":null},"def":{"name":"error_evt_invalid_event_data?","visibility":"Public","body":"self == ERROR_EVT_INVALID_EVENT_DATA"}},{"html_id":"error_evt_invalid_operation_over_enabled_direct_channel?-instance-method","name":"error_evt_invalid_operation_over_enabled_direct_channel?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2114,"url":null},"def":{"name":"error_evt_invalid_operation_over_enabled_direct_channel?","visibility":"Public","body":"self == ERROR_EVT_INVALID_OPERATION_OVER_ENABLED_DIRECT_CHANNEL"}},{"html_id":"error_evt_invalid_publisher_name?-instance-method","name":"error_evt_invalid_publisher_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2097,"url":null},"def":{"name":"error_evt_invalid_publisher_name?","visibility":"Public","body":"self == ERROR_EVT_INVALID_PUBLISHER_NAME"}},{"html_id":"error_evt_invalid_publisher_property_value?-instance-method","name":"error_evt_invalid_publisher_property_value?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2116,"url":null},"def":{"name":"error_evt_invalid_publisher_property_value?","visibility":"Public","body":"self == ERROR_EVT_INVALID_PUBLISHER_PROPERTY_VALUE"}},{"html_id":"error_evt_invalid_query?-instance-method","name":"error_evt_invalid_query?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2094,"url":null},"def":{"name":"error_evt_invalid_query?","visibility":"Public","body":"self == ERROR_EVT_INVALID_QUERY"}},{"html_id":"error_evt_malformed_xml_text?-instance-method","name":"error_evt_malformed_xml_text?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2100,"url":null},"def":{"name":"error_evt_malformed_xml_text?","visibility":"Public","body":"self == ERROR_EVT_MALFORMED_XML_TEXT"}},{"html_id":"error_evt_max_inserts_reached?-instance-method","name":"error_evt_max_inserts_reached?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2123,"url":null},"def":{"name":"error_evt_max_inserts_reached?","visibility":"Public","body":"self == ERROR_EVT_MAX_INSERTS_REACHED"}},{"html_id":"error_evt_message_id_not_found?-instance-method","name":"error_evt_message_id_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2120,"url":null},"def":{"name":"error_evt_message_id_not_found?","visibility":"Public","body":"self == ERROR_EVT_MESSAGE_ID_NOT_FOUND"}},{"html_id":"error_evt_message_locale_not_found?-instance-method","name":"error_evt_message_locale_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2125,"url":null},"def":{"name":"error_evt_message_locale_not_found?","visibility":"Public","body":"self == ERROR_EVT_MESSAGE_LOCALE_NOT_FOUND"}},{"html_id":"error_evt_message_not_found?-instance-method","name":"error_evt_message_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2119,"url":null},"def":{"name":"error_evt_message_not_found?","visibility":"Public","body":"self == ERROR_EVT_MESSAGE_NOT_FOUND"}},{"html_id":"error_evt_non_validating_msxml?-instance-method","name":"error_evt_non_validating_msxml?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2105,"url":null},"def":{"name":"error_evt_non_validating_msxml?","visibility":"Public","body":"self == ERROR_EVT_NON_VALIDATING_MSXML"}},{"html_id":"error_evt_publisher_disabled?-instance-method","name":"error_evt_publisher_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2129,"url":null},"def":{"name":"error_evt_publisher_disabled?","visibility":"Public","body":"self == ERROR_EVT_PUBLISHER_DISABLED"}},{"html_id":"error_evt_publisher_metadata_not_found?-instance-method","name":"error_evt_publisher_metadata_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2095,"url":null},"def":{"name":"error_evt_publisher_metadata_not_found?","visibility":"Public","body":"self == ERROR_EVT_PUBLISHER_METADATA_NOT_FOUND"}},{"html_id":"error_evt_query_result_invalid_position?-instance-method","name":"error_evt_query_result_invalid_position?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2104,"url":null},"def":{"name":"error_evt_query_result_invalid_position?","visibility":"Public","body":"self == ERROR_EVT_QUERY_RESULT_INVALID_POSITION"}},{"html_id":"error_evt_query_result_stale?-instance-method","name":"error_evt_query_result_stale?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2103,"url":null},"def":{"name":"error_evt_query_result_stale?","visibility":"Public","body":"self == ERROR_EVT_QUERY_RESULT_STALE"}},{"html_id":"error_evt_subscription_to_direct_channel?-instance-method","name":"error_evt_subscription_to_direct_channel?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2101,"url":null},"def":{"name":"error_evt_subscription_to_direct_channel?","visibility":"Public","body":"self == ERROR_EVT_SUBSCRIPTION_TO_DIRECT_CHANNEL"}},{"html_id":"error_evt_unresolved_parameter_insert?-instance-method","name":"error_evt_unresolved_parameter_insert?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2122,"url":null},"def":{"name":"error_evt_unresolved_parameter_insert?","visibility":"Public","body":"self == ERROR_EVT_UNRESOLVED_PARAMETER_INSERT"}},{"html_id":"error_evt_unresolved_value_insert?-instance-method","name":"error_evt_unresolved_value_insert?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2121,"url":null},"def":{"name":"error_evt_unresolved_value_insert?","visibility":"Public","body":"self == ERROR_EVT_UNRESOLVED_VALUE_INSERT"}},{"html_id":"error_evt_version_too_new?-instance-method","name":"error_evt_version_too_new?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2127,"url":null},"def":{"name":"error_evt_version_too_new?","visibility":"Public","body":"self == ERROR_EVT_VERSION_TOO_NEW"}},{"html_id":"error_evt_version_too_old?-instance-method","name":"error_evt_version_too_old?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2126,"url":null},"def":{"name":"error_evt_version_too_old?","visibility":"Public","body":"self == ERROR_EVT_VERSION_TOO_OLD"}},{"html_id":"error_exception_in_service?-instance-method","name":"error_exception_in_service?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":413,"url":null},"def":{"name":"error_exception_in_service?","visibility":"Public","body":"self == ERROR_EXCEPTION_IN_SERVICE"}},{"html_id":"error_excl_sem_already_owned?-instance-method","name":"error_excl_sem_already_owned?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":228,"url":null},"def":{"name":"error_excl_sem_already_owned?","visibility":"Public","body":"self == ERROR_EXCL_SEM_ALREADY_OWNED"}},{"html_id":"error_exe_cannot_modify_signed_binary?-instance-method","name":"error_exe_cannot_modify_signed_binary?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":324,"url":null},"def":{"name":"error_exe_cannot_modify_signed_binary?","visibility":"Public","body":"self == ERROR_EXE_CANNOT_MODIFY_SIGNED_BINARY"}},{"html_id":"error_exe_cannot_modify_strong_signed_binary?-instance-method","name":"error_exe_cannot_modify_strong_signed_binary?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":325,"url":null},"def":{"name":"error_exe_cannot_modify_strong_signed_binary?","visibility":"Public","body":"self == ERROR_EXE_CANNOT_MODIFY_STRONG_SIGNED_BINARY"}},{"html_id":"error_exe_machine_type_mismatch?-instance-method","name":"error_exe_machine_type_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":323,"url":null},"def":{"name":"error_exe_machine_type_mismatch?","visibility":"Public","body":"self == ERROR_EXE_MACHINE_TYPE_MISMATCH"}},{"html_id":"error_exe_marked_invalid?-instance-method","name":"error_exe_marked_invalid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":302,"url":null},"def":{"name":"error_exe_marked_invalid?","visibility":"Public","body":"self == ERROR_EXE_MARKED_INVALID"}},{"html_id":"error_extended_error?-instance-method","name":"error_extended_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":509,"url":null},"def":{"name":"error_extended_error?","visibility":"Public","body":"self == ERROR_EXTENDED_ERROR"}},{"html_id":"error_fail_i24?-instance-method","name":"error_fail_i24?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":220,"url":null},"def":{"name":"error_fail_i24?","visibility":"Public","body":"self == ERROR_FAIL_I24"}},{"html_id":"error_failed_service_controller_connect?-instance-method","name":"error_failed_service_controller_connect?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":412,"url":null},"def":{"name":"error_failed_service_controller_connect?","visibility":"Public","body":"self == ERROR_FAILED_SERVICE_CONTROLLER_CONNECT"}},{"html_id":"error_file_checked_out?-instance-method","name":"error_file_checked_out?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":326,"url":null},"def":{"name":"error_file_checked_out?","visibility":"Public","body":"self == ERROR_FILE_CHECKED_OUT"}},{"html_id":"error_file_corrupt?-instance-method","name":"error_file_corrupt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":674,"url":null},"def":{"name":"error_file_corrupt?","visibility":"Public","body":"self == ERROR_FILE_CORRUPT"}},{"html_id":"error_file_encrypted?-instance-method","name":"error_file_encrypted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1183,"url":null},"def":{"name":"error_file_encrypted?","visibility":"Public","body":"self == ERROR_FILE_ENCRYPTED"}},{"html_id":"error_file_exists?-instance-method","name":"error_file_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":218,"url":null},"def":{"name":"error_file_exists?","visibility":"Public","body":"self == ERROR_FILE_EXISTS"}},{"html_id":"error_file_invalid?-instance-method","name":"error_file_invalid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":383,"url":null},"def":{"name":"error_file_invalid?","visibility":"Public","body":"self == ERROR_FILE_INVALID"}},{"html_id":"error_file_not_encrypted?-instance-method","name":"error_file_not_encrypted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1188,"url":null},"def":{"name":"error_file_not_encrypted?","visibility":"Public","body":"self == ERROR_FILE_NOT_ENCRYPTED"}},{"html_id":"error_file_not_found?-instance-method","name":"error_file_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":159,"url":null},"def":{"name":"error_file_not_found?","visibility":"Public","body":"self == ERROR_FILE_NOT_FOUND"}},{"html_id":"error_file_offline?-instance-method","name":"error_file_offline?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1068,"url":null},"def":{"name":"error_file_offline?","visibility":"Public","body":"self == ERROR_FILE_OFFLINE"}},{"html_id":"error_file_read_only?-instance-method","name":"error_file_read_only?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1190,"url":null},"def":{"name":"error_file_read_only?","visibility":"Public","body":"self == ERROR_FILE_READ_ONLY"}},{"html_id":"error_file_too_large?-instance-method","name":"error_file_too_large?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":329,"url":null},"def":{"name":"error_file_too_large?","visibility":"Public","body":"self == ERROR_FILE_TOO_LARGE"}},{"html_id":"error_filemark_detected?-instance-method","name":"error_filemark_detected?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":435,"url":null},"def":{"name":"error_filemark_detected?","visibility":"Public","body":"self == ERROR_FILEMARK_DETECTED"}},{"html_id":"error_filename_exced_range?-instance-method","name":"error_filename_exced_range?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":315,"url":null},"def":{"name":"error_filename_exced_range?","visibility":"Public","body":"self == ERROR_FILENAME_EXCED_RANGE"}},{"html_id":"error_floppy_bad_registers?-instance-method","name":"error_floppy_bad_registers?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":459,"url":null},"def":{"name":"error_floppy_bad_registers?","visibility":"Public","body":"self == ERROR_FLOPPY_BAD_REGISTERS"}},{"html_id":"error_floppy_id_mark_not_found?-instance-method","name":"error_floppy_id_mark_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":456,"url":null},"def":{"name":"error_floppy_id_mark_not_found?","visibility":"Public","body":"self == ERROR_FLOPPY_ID_MARK_NOT_FOUND"}},{"html_id":"error_floppy_unknown_error?-instance-method","name":"error_floppy_unknown_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":458,"url":null},"def":{"name":"error_floppy_unknown_error?","visibility":"Public","body":"self == ERROR_FLOPPY_UNKNOWN_ERROR"}},{"html_id":"error_floppy_wrong_cylinder?-instance-method","name":"error_floppy_wrong_cylinder?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":457,"url":null},"def":{"name":"error_floppy_wrong_cylinder?","visibility":"Public","body":"self == ERROR_FLOPPY_WRONG_CYLINDER"}},{"html_id":"error_forms_auth_required?-instance-method","name":"error_forms_auth_required?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":330,"url":null},"def":{"name":"error_forms_auth_required?","visibility":"Public","body":"self == ERROR_FORMS_AUTH_REQUIRED"}},{"html_id":"error_full_backup?-instance-method","name":"error_full_backup?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1007,"url":null},"def":{"name":"error_full_backup?","visibility":"Public","body":"self == ERROR_FULL_BACKUP"}},{"html_id":"error_fullscreen_mode?-instance-method","name":"error_fullscreen_mode?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":384,"url":null},"def":{"name":"error_fullscreen_mode?","visibility":"Public","body":"self == ERROR_FULLSCREEN_MODE"}},{"html_id":"error_function_failed?-instance-method","name":"error_function_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":775,"url":null},"def":{"name":"error_function_failed?","visibility":"Public","body":"self == ERROR_FUNCTION_FAILED"}},{"html_id":"error_function_not_called?-instance-method","name":"error_function_not_called?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":774,"url":null},"def":{"name":"error_function_not_called?","visibility":"Public","body":"self == ERROR_FUNCTION_NOT_CALLED"}},{"html_id":"error_gen_failure?-instance-method","name":"error_gen_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":188,"url":null},"def":{"name":"error_gen_failure?","visibility":"Public","body":"self == ERROR_GEN_FAILURE"}},{"html_id":"error_generic_command_failed?-instance-method","name":"error_generic_command_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1941,"url":null},"def":{"name":"error_generic_command_failed?","visibility":"Public","body":"self == ERROR_GENERIC_COMMAND_FAILED"}},{"html_id":"error_generic_not_mapped?-instance-method","name":"error_generic_not_mapped?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":642,"url":null},"def":{"name":"error_generic_not_mapped?","visibility":"Public","body":"self == ERROR_GENERIC_NOT_MAPPED"}},{"html_id":"error_global_only_hook?-instance-method","name":"error_global_only_hook?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":711,"url":null},"def":{"name":"error_global_only_hook?","visibility":"Public","body":"self == ERROR_GLOBAL_ONLY_HOOK"}},{"html_id":"error_gpio_client_information_invalid?-instance-method","name":"error_gpio_client_information_invalid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2180,"url":null},"def":{"name":"error_gpio_client_information_invalid?","visibility":"Public","body":"self == ERROR_GPIO_CLIENT_INFORMATION_INVALID"}},{"html_id":"error_gpio_incompatible_connect_mode?-instance-method","name":"error_gpio_incompatible_connect_mode?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2184,"url":null},"def":{"name":"error_gpio_incompatible_connect_mode?","visibility":"Public","body":"self == ERROR_GPIO_INCOMPATIBLE_CONNECT_MODE"}},{"html_id":"error_gpio_interrupt_already_unmasked?-instance-method","name":"error_gpio_interrupt_already_unmasked?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2185,"url":null},"def":{"name":"error_gpio_interrupt_already_unmasked?","visibility":"Public","body":"self == ERROR_GPIO_INTERRUPT_ALREADY_UNMASKED"}},{"html_id":"error_gpio_invalid_registration_packet?-instance-method","name":"error_gpio_invalid_registration_packet?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2182,"url":null},"def":{"name":"error_gpio_invalid_registration_packet?","visibility":"Public","body":"self == ERROR_GPIO_INVALID_REGISTRATION_PACKET"}},{"html_id":"error_gpio_operation_denied?-instance-method","name":"error_gpio_operation_denied?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2183,"url":null},"def":{"name":"error_gpio_operation_denied?","visibility":"Public","body":"self == ERROR_GPIO_OPERATION_DENIED"}},{"html_id":"error_gpio_version_not_supported?-instance-method","name":"error_gpio_version_not_supported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2181,"url":null},"def":{"name":"error_gpio_version_not_supported?","visibility":"Public","body":"self == ERROR_GPIO_VERSION_NOT_SUPPORTED"}},{"html_id":"error_graceful_disconnect?-instance-method","name":"error_graceful_disconnect?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":527,"url":null},"def":{"name":"error_graceful_disconnect?","visibility":"Public","body":"self == ERROR_GRACEFUL_DISCONNECT"}},{"html_id":"error_group_exists?-instance-method","name":"error_group_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":601,"url":null},"def":{"name":"error_group_exists?","visibility":"Public","body":"self == ERROR_GROUP_EXISTS"}},{"html_id":"error_group_not_available?-instance-method","name":"error_group_not_available?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1088,"url":null},"def":{"name":"error_group_not_available?","visibility":"Public","body":"self == ERROR_GROUP_NOT_AVAILABLE"}},{"html_id":"error_group_not_found?-instance-method","name":"error_group_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1089,"url":null},"def":{"name":"error_group_not_found?","visibility":"Public","body":"self == ERROR_GROUP_NOT_FOUND"}},{"html_id":"error_group_not_online?-instance-method","name":"error_group_not_online?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1090,"url":null},"def":{"name":"error_group_not_online?","visibility":"Public","body":"self == ERROR_GROUP_NOT_ONLINE"}},{"html_id":"error_handle_disk_full?-instance-method","name":"error_handle_disk_full?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":194,"url":null},"def":{"name":"error_handle_disk_full?","visibility":"Public","body":"self == ERROR_HANDLE_DISK_FULL"}},{"html_id":"error_handle_eof?-instance-method","name":"error_handle_eof?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":193,"url":null},"def":{"name":"error_handle_eof?","visibility":"Public","body":"self == ERROR_HANDLE_EOF"}},{"html_id":"error_hash_not_present?-instance-method","name":"error_hash_not_present?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2178,"url":null},"def":{"name":"error_hash_not_present?","visibility":"Public","body":"self == ERROR_HASH_NOT_PRESENT"}},{"html_id":"error_hash_not_supported?-instance-method","name":"error_hash_not_supported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2177,"url":null},"def":{"name":"error_hash_not_supported?","visibility":"Public","body":"self == ERROR_HASH_NOT_SUPPORTED"}},{"html_id":"error_hook_needs_hmod?-instance-method","name":"error_hook_needs_hmod?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":710,"url":null},"def":{"name":"error_hook_needs_hmod?","visibility":"Public","body":"self == ERROR_HOOK_NEEDS_HMOD"}},{"html_id":"error_hook_not_installed?-instance-method","name":"error_hook_not_installed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":713,"url":null},"def":{"name":"error_hook_not_installed?","visibility":"Public","body":"self == ERROR_HOOK_NOT_INSTALLED"}},{"html_id":"error_hook_type_not_allowed?-instance-method","name":"error_hook_type_not_allowed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":740,"url":null},"def":{"name":"error_hook_type_not_allowed?","visibility":"Public","body":"self == ERROR_HOOK_TYPE_NOT_ALLOWED"}},{"html_id":"error_host_down?-instance-method","name":"error_host_down?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":557,"url":null},"def":{"name":"error_host_down?","visibility":"Public","body":"self == ERROR_HOST_DOWN"}},{"html_id":"error_host_node_not_available?-instance-method","name":"error_host_node_not_available?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1081,"url":null},"def":{"name":"error_host_node_not_available?","visibility":"Public","body":"self == ERROR_HOST_NODE_NOT_AVAILABLE"}},{"html_id":"error_host_node_not_group_owner?-instance-method","name":"error_host_node_not_group_owner?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1092,"url":null},"def":{"name":"error_host_node_not_group_owner?","visibility":"Public","body":"self == ERROR_HOST_NODE_NOT_GROUP_OWNER"}},{"html_id":"error_host_node_not_resource_owner?-instance-method","name":"error_host_node_not_resource_owner?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1091,"url":null},"def":{"name":"error_host_node_not_resource_owner?","visibility":"Public","body":"self == ERROR_HOST_NODE_NOT_RESOURCE_OWNER"}},{"html_id":"error_host_unreachable?-instance-method","name":"error_host_unreachable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":533,"url":null},"def":{"name":"error_host_unreachable?","visibility":"Public","body":"self == ERROR_HOST_UNREACHABLE"}},{"html_id":"error_hotkey_already_registered?-instance-method","name":"error_hotkey_already_registered?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":691,"url":null},"def":{"name":"error_hotkey_already_registered?","visibility":"Public","body":"self == ERROR_HOTKEY_ALREADY_REGISTERED"}},{"html_id":"error_hotkey_not_registered?-instance-method","name":"error_hotkey_not_registered?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":701,"url":null},"def":{"name":"error_hotkey_not_registered?","visibility":"Public","body":"self == ERROR_HOTKEY_NOT_REGISTERED"}},{"html_id":"error_hwnds_have_diff_parent?-instance-method","name":"error_hwnds_have_diff_parent?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":723,"url":null},"def":{"name":"error_hwnds_have_diff_parent?","visibility":"Public","body":"self == ERROR_HWNDS_HAVE_DIFF_PARENT"}},{"html_id":"error_icm_not_enabled?-instance-method","name":"error_icm_not_enabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":976,"url":null},"def":{"name":"error_icm_not_enabled?","visibility":"Public","body":"self == ERROR_ICM_NOT_ENABLED"}},{"html_id":"error_ieport_full?-instance-method","name":"error_ieport_full?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1067,"url":null},"def":{"name":"error_ieport_full?","visibility":"Public","body":"self == ERROR_IEPORT_FULL"}},{"html_id":"error_ill_formed_password?-instance-method","name":"error_ill_formed_password?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":607,"url":null},"def":{"name":"error_ill_formed_password?","visibility":"Public","body":"self == ERROR_ILL_FORMED_PASSWORD"}},{"html_id":"error_illegal_element_address?-instance-method","name":"error_illegal_element_address?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":482,"url":null},"def":{"name":"error_illegal_element_address?","visibility":"Public","body":"self == ERROR_ILLEGAL_ELEMENT_ADDRESS"}},{"html_id":"error_inc_backup?-instance-method","name":"error_inc_backup?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1006,"url":null},"def":{"name":"error_inc_backup?","visibility":"Public","body":"self == ERROR_INC_BACKUP"}},{"html_id":"error_incorrect_address?-instance-method","name":"error_incorrect_address?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":542,"url":null},"def":{"name":"error_incorrect_address?","visibility":"Public","body":"self == ERROR_INCORRECT_ADDRESS"}},{"html_id":"error_incorrect_size?-instance-method","name":"error_incorrect_size?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":744,"url":null},"def":{"name":"error_incorrect_size?","visibility":"Public","body":"self == ERROR_INCORRECT_SIZE"}},{"html_id":"error_index_absent?-instance-method","name":"error_index_absent?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":759,"url":null},"def":{"name":"error_index_absent?","visibility":"Public","body":"self == ERROR_INDEX_ABSENT"}},{"html_id":"error_indigenous_type?-instance-method","name":"error_indigenous_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1064,"url":null},"def":{"name":"error_indigenous_type?","visibility":"Public","body":"self == ERROR_INDIGENOUS_TYPE"}},{"html_id":"error_infloop_in_reloc_chain?-instance-method","name":"error_infloop_in_reloc_chain?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":312,"url":null},"def":{"name":"error_infloop_in_reloc_chain?","visibility":"Public","body":"self == ERROR_INFLOOP_IN_RELOC_CHAIN"}},{"html_id":"error_install_already_running?-instance-method","name":"error_install_already_running?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":766,"url":null},"def":{"name":"error_install_already_running?","visibility":"Public","body":"self == ERROR_INSTALL_ALREADY_RUNNING"}},{"html_id":"error_install_cancel?-instance-method","name":"error_install_cancel?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2201,"url":null},"def":{"name":"error_install_cancel?","visibility":"Public","body":"self == ERROR_INSTALL_CANCEL"}},{"html_id":"error_install_deregistration_failure?-instance-method","name":"error_install_deregistration_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2200,"url":null},"def":{"name":"error_install_deregistration_failure?","visibility":"Public","body":"self == ERROR_INSTALL_DEREGISTRATION_FAILURE"}},{"html_id":"error_install_failed?-instance-method","name":"error_install_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2202,"url":null},"def":{"name":"error_install_failed?","visibility":"Public","body":"self == ERROR_INSTALL_FAILED"}},{"html_id":"error_install_failure?-instance-method","name":"error_install_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":751,"url":null},"def":{"name":"error_install_failure?","visibility":"Public","body":"self == ERROR_INSTALL_FAILURE"}},{"html_id":"error_install_firewall_service_not_running?-instance-method","name":"error_install_firewall_service_not_running?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2219,"url":null},"def":{"name":"error_install_firewall_service_not_running?","visibility":"Public","body":"self == ERROR_INSTALL_FIREWALL_SERVICE_NOT_RUNNING"}},{"html_id":"error_install_invalid_package?-instance-method","name":"error_install_invalid_package?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2195,"url":null},"def":{"name":"error_install_invalid_package?","visibility":"Public","body":"self == ERROR_INSTALL_INVALID_PACKAGE"}},{"html_id":"error_install_language_unsupported?-instance-method","name":"error_install_language_unsupported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":771,"url":null},"def":{"name":"error_install_language_unsupported?","visibility":"Public","body":"self == ERROR_INSTALL_LANGUAGE_UNSUPPORTED"}},{"html_id":"error_install_log_failure?-instance-method","name":"error_install_log_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":770,"url":null},"def":{"name":"error_install_log_failure?","visibility":"Public","body":"self == ERROR_INSTALL_LOG_FAILURE"}},{"html_id":"error_install_network_failure?-instance-method","name":"error_install_network_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2198,"url":null},"def":{"name":"error_install_network_failure?","visibility":"Public","body":"self == ERROR_INSTALL_NETWORK_FAILURE"}},{"html_id":"error_install_notused?-instance-method","name":"error_install_notused?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":782,"url":null},"def":{"name":"error_install_notused?","visibility":"Public","body":"self == ERROR_INSTALL_NOTUSED"}},{"html_id":"error_install_open_package_failed?-instance-method","name":"error_install_open_package_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2193,"url":null},"def":{"name":"error_install_open_package_failed?","visibility":"Public","body":"self == ERROR_INSTALL_OPEN_PACKAGE_FAILED"}},{"html_id":"error_install_out_of_disk_space?-instance-method","name":"error_install_out_of_disk_space?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2197,"url":null},"def":{"name":"error_install_out_of_disk_space?","visibility":"Public","body":"self == ERROR_INSTALL_OUT_OF_DISK_SPACE"}},{"html_id":"error_install_package_downgrade?-instance-method","name":"error_install_package_downgrade?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2215,"url":null},"def":{"name":"error_install_package_downgrade?","visibility":"Public","body":"self == ERROR_INSTALL_PACKAGE_DOWNGRADE"}},{"html_id":"error_install_package_invalid?-instance-method","name":"error_install_package_invalid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":768,"url":null},"def":{"name":"error_install_package_invalid?","visibility":"Public","body":"self == ERROR_INSTALL_PACKAGE_INVALID"}},{"html_id":"error_install_package_not_found?-instance-method","name":"error_install_package_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2194,"url":null},"def":{"name":"error_install_package_not_found?","visibility":"Public","body":"self == ERROR_INSTALL_PACKAGE_NOT_FOUND"}},{"html_id":"error_install_package_open_failed?-instance-method","name":"error_install_package_open_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":767,"url":null},"def":{"name":"error_install_package_open_failed?","visibility":"Public","body":"self == ERROR_INSTALL_PACKAGE_OPEN_FAILED"}},{"html_id":"error_install_package_rejected?-instance-method","name":"error_install_package_rejected?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":773,"url":null},"def":{"name":"error_install_package_rejected?","visibility":"Public","body":"self == ERROR_INSTALL_PACKAGE_REJECTED"}},{"html_id":"error_install_package_version?-instance-method","name":"error_install_package_version?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":761,"url":null},"def":{"name":"error_install_package_version?","visibility":"Public","body":"self == ERROR_INSTALL_PACKAGE_VERSION"}},{"html_id":"error_install_platform_unsupported?-instance-method","name":"error_install_platform_unsupported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":781,"url":null},"def":{"name":"error_install_platform_unsupported?","visibility":"Public","body":"self == ERROR_INSTALL_PLATFORM_UNSUPPORTED"}},{"html_id":"error_install_policy_failure?-instance-method","name":"error_install_policy_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2208,"url":null},"def":{"name":"error_install_policy_failure?","visibility":"Public","body":"self == ERROR_INSTALL_POLICY_FAILURE"}},{"html_id":"error_install_prerequisite_failed?-instance-method","name":"error_install_prerequisite_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2206,"url":null},"def":{"name":"error_install_prerequisite_failed?","visibility":"Public","body":"self == ERROR_INSTALL_PREREQUISITE_FAILED"}},{"html_id":"error_install_registration_failure?-instance-method","name":"error_install_registration_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2199,"url":null},"def":{"name":"error_install_registration_failure?","visibility":"Public","body":"self == ERROR_INSTALL_REGISTRATION_FAILURE"}},{"html_id":"error_install_remote_disallowed?-instance-method","name":"error_install_remote_disallowed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":788,"url":null},"def":{"name":"error_install_remote_disallowed?","visibility":"Public","body":"self == ERROR_INSTALL_REMOTE_DISALLOWED"}},{"html_id":"error_install_remote_prohibited?-instance-method","name":"error_install_remote_prohibited?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":793,"url":null},"def":{"name":"error_install_remote_prohibited?","visibility":"Public","body":"self == ERROR_INSTALL_REMOTE_PROHIBITED"}},{"html_id":"error_install_resolve_dependency_failed?-instance-method","name":"error_install_resolve_dependency_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2196,"url":null},"def":{"name":"error_install_resolve_dependency_failed?","visibility":"Public","body":"self == ERROR_INSTALL_RESOLVE_DEPENDENCY_FAILED"}},{"html_id":"error_install_service_failure?-instance-method","name":"error_install_service_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":749,"url":null},"def":{"name":"error_install_service_failure?","visibility":"Public","body":"self == ERROR_INSTALL_SERVICE_FAILURE"}},{"html_id":"error_install_source_absent?-instance-method","name":"error_install_source_absent?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":760,"url":null},"def":{"name":"error_install_source_absent?","visibility":"Public","body":"self == ERROR_INSTALL_SOURCE_ABSENT"}},{"html_id":"error_install_suspend?-instance-method","name":"error_install_suspend?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":752,"url":null},"def":{"name":"error_install_suspend?","visibility":"Public","body":"self == ERROR_INSTALL_SUSPEND"}},{"html_id":"error_install_temp_unwritable?-instance-method","name":"error_install_temp_unwritable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":780,"url":null},"def":{"name":"error_install_temp_unwritable?","visibility":"Public","body":"self == ERROR_INSTALL_TEMP_UNWRITABLE"}},{"html_id":"error_install_transform_failure?-instance-method","name":"error_install_transform_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":772,"url":null},"def":{"name":"error_install_transform_failure?","visibility":"Public","body":"self == ERROR_INSTALL_TRANSFORM_FAILURE"}},{"html_id":"error_install_transform_rejected?-instance-method","name":"error_install_transform_rejected?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":792,"url":null},"def":{"name":"error_install_transform_rejected?","visibility":"Public","body":"self == ERROR_INSTALL_TRANSFORM_REJECTED"}},{"html_id":"error_install_ui_failure?-instance-method","name":"error_install_ui_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":769,"url":null},"def":{"name":"error_install_ui_failure?","visibility":"Public","body":"self == ERROR_INSTALL_UI_FAILURE"}},{"html_id":"error_install_userexit?-instance-method","name":"error_install_userexit?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":750,"url":null},"def":{"name":"error_install_userexit?","visibility":"Public","body":"self == ERROR_INSTALL_USEREXIT"}},{"html_id":"error_insufficient_buffer?-instance-method","name":"error_insufficient_buffer?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":247,"url":null},"def":{"name":"error_insufficient_buffer?","visibility":"Public","body":"self == ERROR_INSUFFICIENT_BUFFER"}},{"html_id":"error_internal_db_corruption?-instance-method","name":"error_internal_db_corruption?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":640,"url":null},"def":{"name":"error_internal_db_corruption?","visibility":"Public","body":"self == ERROR_INTERNAL_DB_CORRUPTION"}},{"html_id":"error_internal_db_error?-instance-method","name":"error_internal_db_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":665,"url":null},"def":{"name":"error_internal_db_error?","visibility":"Public","body":"self == ERROR_INTERNAL_DB_ERROR"}},{"html_id":"error_internal_error?-instance-method","name":"error_internal_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":641,"url":null},"def":{"name":"error_internal_error?","visibility":"Public","body":"self == ERROR_INTERNAL_ERROR"}},{"html_id":"error_invalid_accel_handle?-instance-method","name":"error_invalid_accel_handle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":685,"url":null},"def":{"name":"error_invalid_accel_handle?","visibility":"Public","body":"self == ERROR_INVALID_ACCEL_HANDLE"}},{"html_id":"error_invalid_access?-instance-method","name":"error_invalid_access?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":169,"url":null},"def":{"name":"error_invalid_access?","visibility":"Public","body":"self == ERROR_INVALID_ACCESS"}},{"html_id":"error_invalid_account_name?-instance-method","name":"error_invalid_account_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":598,"url":null},"def":{"name":"error_invalid_account_name?","visibility":"Public","body":"self == ERROR_INVALID_ACCOUNT_NAME"}},{"html_id":"error_invalid_acl?-instance-method","name":"error_invalid_acl?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":619,"url":null},"def":{"name":"error_invalid_acl?","visibility":"Public","body":"self == ERROR_INVALID_ACL"}},{"html_id":"error_invalid_address?-instance-method","name":"error_invalid_address?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":358,"url":null},"def":{"name":"error_invalid_address?","visibility":"Public","body":"self == ERROR_INVALID_ADDRESS"}},{"html_id":"error_invalid_at_interrupt_time?-instance-method","name":"error_invalid_at_interrupt_time?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":231,"url":null},"def":{"name":"error_invalid_at_interrupt_time?","visibility":"Public","body":"self == ERROR_INVALID_AT_INTERRUPT_TIME"}},{"html_id":"error_invalid_block?-instance-method","name":"error_invalid_block?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":166,"url":null},"def":{"name":"error_invalid_block?","visibility":"Public","body":"self == ERROR_INVALID_BLOCK"}},{"html_id":"error_invalid_block_length?-instance-method","name":"error_invalid_block_length?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":440,"url":null},"def":{"name":"error_invalid_block_length?","visibility":"Public","body":"self == ERROR_INVALID_BLOCK_LENGTH"}},{"html_id":"error_invalid_category?-instance-method","name":"error_invalid_category?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":242,"url":null},"def":{"name":"error_invalid_category?","visibility":"Public","body":"self == ERROR_INVALID_CATEGORY"}},{"html_id":"error_invalid_cleaner?-instance-method","name":"error_invalid_cleaner?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1036,"url":null},"def":{"name":"error_invalid_cleaner?","visibility":"Public","body":"self == ERROR_INVALID_CLEANER"}},{"html_id":"error_invalid_cmm?-instance-method","name":"error_invalid_cmm?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":968,"url":null},"def":{"name":"error_invalid_cmm?","visibility":"Public","body":"self == ERROR_INVALID_CMM"}},{"html_id":"error_invalid_colorindex?-instance-method","name":"error_invalid_colorindex?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":980,"url":null},"def":{"name":"error_invalid_colorindex?","visibility":"Public","body":"self == ERROR_INVALID_COLORINDEX"}},{"html_id":"error_invalid_colorspace?-instance-method","name":"error_invalid_colorspace?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":975,"url":null},"def":{"name":"error_invalid_colorspace?","visibility":"Public","body":"self == ERROR_INVALID_COLORSPACE"}},{"html_id":"error_invalid_combobox_message?-instance-method","name":"error_invalid_combobox_message?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":704,"url":null},"def":{"name":"error_invalid_combobox_message?","visibility":"Public","body":"self == ERROR_INVALID_COMBOBOX_MESSAGE"}},{"html_id":"error_invalid_command_line?-instance-method","name":"error_invalid_command_line?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":787,"url":null},"def":{"name":"error_invalid_command_line?","visibility":"Public","body":"self == ERROR_INVALID_COMMAND_LINE"}},{"html_id":"error_invalid_computername?-instance-method","name":"error_invalid_computername?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":511,"url":null},"def":{"name":"error_invalid_computername?","visibility":"Public","body":"self == ERROR_INVALID_COMPUTERNAME"}},{"html_id":"error_invalid_cursor_handle?-instance-method","name":"error_invalid_cursor_handle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":684,"url":null},"def":{"name":"error_invalid_cursor_handle?","visibility":"Public","body":"self == ERROR_INVALID_CURSOR_HANDLE"}},{"html_id":"error_invalid_data?-instance-method","name":"error_invalid_data?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":170,"url":null},"def":{"name":"error_invalid_data?","visibility":"Public","body":"self == ERROR_INVALID_DATA"}},{"html_id":"error_invalid_datatype?-instance-method","name":"error_invalid_datatype?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":894,"url":null},"def":{"name":"error_invalid_datatype?","visibility":"Public","body":"self == ERROR_INVALID_DATATYPE"}},{"html_id":"error_invalid_dll?-instance-method","name":"error_invalid_dll?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":474,"url":null},"def":{"name":"error_invalid_dll?","visibility":"Public","body":"self == ERROR_INVALID_DLL"}},{"html_id":"error_invalid_domain_role?-instance-method","name":"error_invalid_domain_role?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":636,"url":null},"def":{"name":"error_invalid_domain_role?","visibility":"Public","body":"self == ERROR_INVALID_DOMAIN_ROLE"}},{"html_id":"error_invalid_domain_state?-instance-method","name":"error_invalid_domain_state?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":635,"url":null},"def":{"name":"error_invalid_domain_state?","visibility":"Public","body":"self == ERROR_INVALID_DOMAIN_STATE"}},{"html_id":"error_invalid_domainname?-instance-method","name":"error_invalid_domainname?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":513,"url":null},"def":{"name":"error_invalid_domainname?","visibility":"Public","body":"self == ERROR_INVALID_DOMAINNAME"}},{"html_id":"error_invalid_drive?-instance-method","name":"error_invalid_drive?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":172,"url":null},"def":{"name":"error_invalid_drive?","visibility":"Public","body":"self == ERROR_INVALID_DRIVE"}},{"html_id":"error_invalid_drive_object?-instance-method","name":"error_invalid_drive_object?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1047,"url":null},"def":{"name":"error_invalid_drive_object?","visibility":"Public","body":"self == ERROR_INVALID_DRIVE_OBJECT"}},{"html_id":"error_invalid_dwp_handle?-instance-method","name":"error_invalid_dwp_handle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":687,"url":null},"def":{"name":"error_invalid_dwp_handle?","visibility":"Public","body":"self == ERROR_INVALID_DWP_HANDLE"}},{"html_id":"error_invalid_ea_handle?-instance-method","name":"error_invalid_ea_handle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":347,"url":null},"def":{"name":"error_invalid_ea_handle?","visibility":"Public","body":"self == ERROR_INVALID_EA_HANDLE"}},{"html_id":"error_invalid_ea_name?-instance-method","name":"error_invalid_ea_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":338,"url":null},"def":{"name":"error_invalid_ea_name?","visibility":"Public","body":"self == ERROR_INVALID_EA_NAME"}},{"html_id":"error_invalid_edit_height?-instance-method","name":"error_invalid_edit_height?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":706,"url":null},"def":{"name":"error_invalid_edit_height?","visibility":"Public","body":"self == ERROR_INVALID_EDIT_HEIGHT"}},{"html_id":"error_invalid_environment?-instance-method","name":"error_invalid_environment?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":895,"url":null},"def":{"name":"error_invalid_environment?","visibility":"Public","body":"self == ERROR_INVALID_ENVIRONMENT"}},{"html_id":"error_invalid_event_count?-instance-method","name":"error_invalid_event_count?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":276,"url":null},"def":{"name":"error_invalid_event_count?","visibility":"Public","body":"self == ERROR_INVALID_EVENT_COUNT"}},{"html_id":"error_invalid_eventname?-instance-method","name":"error_invalid_eventname?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":512,"url":null},"def":{"name":"error_invalid_eventname?","visibility":"Public","body":"self == ERROR_INVALID_EVENTNAME"}},{"html_id":"error_invalid_exe_signature?-instance-method","name":"error_invalid_exe_signature?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":301,"url":null},"def":{"name":"error_invalid_exe_signature?","visibility":"Public","body":"self == ERROR_INVALID_EXE_SIGNATURE"}},{"html_id":"error_invalid_field?-instance-method","name":"error_invalid_field?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":764,"url":null},"def":{"name":"error_invalid_field?","visibility":"Public","body":"self == ERROR_INVALID_FIELD"}},{"html_id":"error_invalid_filter_proc?-instance-method","name":"error_invalid_filter_proc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":709,"url":null},"def":{"name":"error_invalid_filter_proc?","visibility":"Public","body":"self == ERROR_INVALID_FILTER_PROC"}},{"html_id":"error_invalid_flag_number?-instance-method","name":"error_invalid_flag_number?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":296,"url":null},"def":{"name":"error_invalid_flag_number?","visibility":"Public","body":"self == ERROR_INVALID_FLAG_NUMBER"}},{"html_id":"error_invalid_flags?-instance-method","name":"error_invalid_flags?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":381,"url":null},"def":{"name":"error_invalid_flags?","visibility":"Public","body":"self == ERROR_INVALID_FLAGS"}},{"html_id":"error_invalid_form_name?-instance-method","name":"error_invalid_form_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":927,"url":null},"def":{"name":"error_invalid_form_name?","visibility":"Public","body":"self == ERROR_INVALID_FORM_NAME"}},{"html_id":"error_invalid_form_size?-instance-method","name":"error_invalid_form_size?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":928,"url":null},"def":{"name":"error_invalid_form_size?","visibility":"Public","body":"self == ERROR_INVALID_FORM_SIZE"}},{"html_id":"error_invalid_function?-instance-method","name":"error_invalid_function?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":158,"url":null},"def":{"name":"error_invalid_function?","visibility":"Public","body":"self == ERROR_INVALID_FUNCTION"}},{"html_id":"error_invalid_group_attributes?-instance-method","name":"error_invalid_group_attributes?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":627,"url":null},"def":{"name":"error_invalid_group_attributes?","visibility":"Public","body":"self == ERROR_INVALID_GROUP_ATTRIBUTES"}},{"html_id":"error_invalid_groupname?-instance-method","name":"error_invalid_groupname?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":510,"url":null},"def":{"name":"error_invalid_groupname?","visibility":"Public","body":"self == ERROR_INVALID_GROUPNAME"}},{"html_id":"error_invalid_gw_command?-instance-method","name":"error_invalid_gw_command?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":725,"url":null},"def":{"name":"error_invalid_gw_command?","visibility":"Public","body":"self == ERROR_INVALID_GW_COMMAND"}},{"html_id":"error_invalid_handle?-instance-method","name":"error_invalid_handle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":163,"url":null},"def":{"name":"error_invalid_handle?","visibility":"Public","body":"self == ERROR_INVALID_HANDLE"}},{"html_id":"error_invalid_handle_state?-instance-method","name":"error_invalid_handle_state?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":757,"url":null},"def":{"name":"error_invalid_handle_state?","visibility":"Public","body":"self == ERROR_INVALID_HANDLE_STATE"}},{"html_id":"error_invalid_hook_filter?-instance-method","name":"error_invalid_hook_filter?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":708,"url":null},"def":{"name":"error_invalid_hook_filter?","visibility":"Public","body":"self == ERROR_INVALID_HOOK_FILTER"}},{"html_id":"error_invalid_hook_handle?-instance-method","name":"error_invalid_hook_handle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":686,"url":null},"def":{"name":"error_invalid_hook_handle?","visibility":"Public","body":"self == ERROR_INVALID_HOOK_HANDLE"}},{"html_id":"error_invalid_icon_handle?-instance-method","name":"error_invalid_icon_handle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":696,"url":null},"def":{"name":"error_invalid_icon_handle?","visibility":"Public","body":"self == ERROR_INVALID_ICON_HANDLE"}},{"html_id":"error_invalid_id_authority?-instance-method","name":"error_invalid_id_authority?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":625,"url":null},"def":{"name":"error_invalid_id_authority?","visibility":"Public","body":"self == ERROR_INVALID_ID_AUTHORITY"}},{"html_id":"error_invalid_import_of_non_dll?-instance-method","name":"error_invalid_import_of_non_dll?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":571,"url":null},"def":{"name":"error_invalid_import_of_non_dll?","visibility":"Public","body":"self == ERROR_INVALID_IMPORT_OF_NON_DLL"}},{"html_id":"error_invalid_index?-instance-method","name":"error_invalid_index?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":695,"url":null},"def":{"name":"error_invalid_index?","visibility":"Public","body":"self == ERROR_INVALID_INDEX"}},{"html_id":"error_invalid_keyboard_handle?-instance-method","name":"error_invalid_keyboard_handle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":739,"url":null},"def":{"name":"error_invalid_keyboard_handle?","visibility":"Public","body":"self == ERROR_INVALID_KEYBOARD_HANDLE"}},{"html_id":"error_invalid_lb_message?-instance-method","name":"error_invalid_lb_message?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":714,"url":null},"def":{"name":"error_invalid_lb_message?","visibility":"Public","body":"self == ERROR_INVALID_LB_MESSAGE"}},{"html_id":"error_invalid_level?-instance-method","name":"error_invalid_level?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":249,"url":null},"def":{"name":"error_invalid_level?","visibility":"Public","body":"self == ERROR_INVALID_LEVEL"}},{"html_id":"error_invalid_library?-instance-method","name":"error_invalid_library?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1027,"url":null},"def":{"name":"error_invalid_library?","visibility":"Public","body":"self == ERROR_INVALID_LIBRARY"}},{"html_id":"error_invalid_list_format?-instance-method","name":"error_invalid_list_format?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":278,"url":null},"def":{"name":"error_invalid_list_format?","visibility":"Public","body":"self == ERROR_INVALID_LIST_FORMAT"}},{"html_id":"error_invalid_logon_hours?-instance-method","name":"error_invalid_logon_hours?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":611,"url":null},"def":{"name":"error_invalid_logon_hours?","visibility":"Public","body":"self == ERROR_INVALID_LOGON_HOURS"}},{"html_id":"error_invalid_logon_type?-instance-method","name":"error_invalid_logon_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":649,"url":null},"def":{"name":"error_invalid_logon_type?","visibility":"Public","body":"self == ERROR_INVALID_LOGON_TYPE"}},{"html_id":"error_invalid_media?-instance-method","name":"error_invalid_media?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1026,"url":null},"def":{"name":"error_invalid_media?","visibility":"Public","body":"self == ERROR_INVALID_MEDIA"}},{"html_id":"error_invalid_media_pool?-instance-method","name":"error_invalid_media_pool?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1028,"url":null},"def":{"name":"error_invalid_media_pool?","visibility":"Public","body":"self == ERROR_INVALID_MEDIA_POOL"}},{"html_id":"error_invalid_member?-instance-method","name":"error_invalid_member?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":670,"url":null},"def":{"name":"error_invalid_member?","visibility":"Public","body":"self == ERROR_INVALID_MEMBER"}},{"html_id":"error_invalid_menu_handle?-instance-method","name":"error_invalid_menu_handle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":683,"url":null},"def":{"name":"error_invalid_menu_handle?","visibility":"Public","body":"self == ERROR_INVALID_MENU_HANDLE"}},{"html_id":"error_invalid_message?-instance-method","name":"error_invalid_message?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":379,"url":null},"def":{"name":"error_invalid_message?","visibility":"Public","body":"self == ERROR_INVALID_MESSAGE"}},{"html_id":"error_invalid_messagedest?-instance-method","name":"error_invalid_messagedest?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":519,"url":null},"def":{"name":"error_invalid_messagedest?","visibility":"Public","body":"self == ERROR_INVALID_MESSAGEDEST"}},{"html_id":"error_invalid_messagename?-instance-method","name":"error_invalid_messagename?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":518,"url":null},"def":{"name":"error_invalid_messagename?","visibility":"Public","body":"self == ERROR_INVALID_MESSAGENAME"}},{"html_id":"error_invalid_minallocsize?-instance-method","name":"error_invalid_minallocsize?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":305,"url":null},"def":{"name":"error_invalid_minallocsize?","visibility":"Public","body":"self == ERROR_INVALID_MINALLOCSIZE"}},{"html_id":"error_invalid_moduletype?-instance-method","name":"error_invalid_moduletype?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":300,"url":null},"def":{"name":"error_invalid_moduletype?","visibility":"Public","body":"self == ERROR_INVALID_MODULETYPE"}},{"html_id":"error_invalid_monitor_handle?-instance-method","name":"error_invalid_monitor_handle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":743,"url":null},"def":{"name":"error_invalid_monitor_handle?","visibility":"Public","body":"self == ERROR_INVALID_MONITOR_HANDLE"}},{"html_id":"error_invalid_msgbox_style?-instance-method","name":"error_invalid_msgbox_style?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":720,"url":null},"def":{"name":"error_invalid_msgbox_style?","visibility":"Public","body":"self == ERROR_INVALID_MSGBOX_STYLE"}},{"html_id":"error_invalid_name?-instance-method","name":"error_invalid_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":248,"url":null},"def":{"name":"error_invalid_name?","visibility":"Public","body":"self == ERROR_INVALID_NAME"}},{"html_id":"error_invalid_netname?-instance-method","name":"error_invalid_netname?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":515,"url":null},"def":{"name":"error_invalid_netname?","visibility":"Public","body":"self == ERROR_INVALID_NETNAME"}},{"html_id":"error_invalid_operation?-instance-method","name":"error_invalid_operation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1043,"url":null},"def":{"name":"error_invalid_operation?","visibility":"Public","body":"self == ERROR_INVALID_OPERATION"}},{"html_id":"error_invalid_operation_on_quorum?-instance-method","name":"error_invalid_operation_on_quorum?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1143,"url":null},"def":{"name":"error_invalid_operation_on_quorum?","visibility":"Public","body":"self == ERROR_INVALID_OPERATION_ON_QUORUM"}},{"html_id":"error_invalid_oplock_protocol?-instance-method","name":"error_invalid_oplock_protocol?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":353,"url":null},"def":{"name":"error_invalid_oplock_protocol?","visibility":"Public","body":"self == ERROR_INVALID_OPLOCK_PROTOCOL"}},{"html_id":"error_invalid_ordinal?-instance-method","name":"error_invalid_ordinal?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":294,"url":null},"def":{"name":"error_invalid_ordinal?","visibility":"Public","body":"self == ERROR_INVALID_ORDINAL"}},{"html_id":"error_invalid_owner?-instance-method","name":"error_invalid_owner?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":590,"url":null},"def":{"name":"error_invalid_owner?","visibility":"Public","body":"self == ERROR_INVALID_OWNER"}},{"html_id":"error_invalid_parameter?-instance-method","name":"error_invalid_parameter?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":224,"url":null},"def":{"name":"error_invalid_parameter?","visibility":"Public","body":"self == ERROR_INVALID_PARAMETER"}},{"html_id":"error_invalid_password?-instance-method","name":"error_invalid_password?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":223,"url":null},"def":{"name":"error_invalid_password?","visibility":"Public","body":"self == ERROR_INVALID_PASSWORD"}},{"html_id":"error_invalid_passwordname?-instance-method","name":"error_invalid_passwordname?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":517,"url":null},"def":{"name":"error_invalid_passwordname?","visibility":"Public","body":"self == ERROR_INVALID_PASSWORDNAME"}},{"html_id":"error_invalid_pixel_format?-instance-method","name":"error_invalid_pixel_format?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":962,"url":null},"def":{"name":"error_invalid_pixel_format?","visibility":"Public","body":"self == ERROR_INVALID_PIXEL_FORMAT"}},{"html_id":"error_invalid_primary_group?-instance-method","name":"error_invalid_primary_group?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":591,"url":null},"def":{"name":"error_invalid_primary_group?","visibility":"Public","body":"self == ERROR_INVALID_PRIMARY_GROUP"}},{"html_id":"error_invalid_print_monitor?-instance-method","name":"error_invalid_print_monitor?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":995,"url":null},"def":{"name":"error_invalid_print_monitor?","visibility":"Public","body":"self == ERROR_INVALID_PRINT_MONITOR"}},{"html_id":"error_invalid_printer_command?-instance-method","name":"error_invalid_printer_command?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":893,"url":null},"def":{"name":"error_invalid_printer_command?","visibility":"Public","body":"self == ERROR_INVALID_PRINTER_COMMAND"}},{"html_id":"error_invalid_printer_name?-instance-method","name":"error_invalid_printer_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":891,"url":null},"def":{"name":"error_invalid_printer_name?","visibility":"Public","body":"self == ERROR_INVALID_PRINTER_NAME"}},{"html_id":"error_invalid_printer_state?-instance-method","name":"error_invalid_printer_state?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":931,"url":null},"def":{"name":"error_invalid_printer_state?","visibility":"Public","body":"self == ERROR_INVALID_PRINTER_STATE"}},{"html_id":"error_invalid_priority?-instance-method","name":"error_invalid_priority?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":890,"url":null},"def":{"name":"error_invalid_priority?","visibility":"Public","body":"self == ERROR_INVALID_PRIORITY"}},{"html_id":"error_invalid_profile?-instance-method","name":"error_invalid_profile?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":969,"url":null},"def":{"name":"error_invalid_profile?","visibility":"Public","body":"self == ERROR_INVALID_PROFILE"}},{"html_id":"error_invalid_reparse_data?-instance-method","name":"error_invalid_reparse_data?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1073,"url":null},"def":{"name":"error_invalid_reparse_data?","visibility":"Public","body":"self == ERROR_INVALID_REPARSE_DATA"}},{"html_id":"error_invalid_runlevel_setting?-instance-method","name":"error_invalid_runlevel_setting?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2187,"url":null},"def":{"name":"error_invalid_runlevel_setting?","visibility":"Public","body":"self == ERROR_INVALID_RUNLEVEL_SETTING"}},{"html_id":"error_invalid_scrollbar_range?-instance-method","name":"error_invalid_scrollbar_range?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":730,"url":null},"def":{"name":"error_invalid_scrollbar_range?","visibility":"Public","body":"self == ERROR_INVALID_SCROLLBAR_RANGE"}},{"html_id":"error_invalid_security_descr?-instance-method","name":"error_invalid_security_descr?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":621,"url":null},"def":{"name":"error_invalid_security_descr?","visibility":"Public","body":"self == ERROR_INVALID_SECURITY_DESCR"}},{"html_id":"error_invalid_segdpl?-instance-method","name":"error_invalid_segdpl?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":308,"url":null},"def":{"name":"error_invalid_segdpl?","visibility":"Public","body":"self == ERROR_INVALID_SEGDPL"}},{"html_id":"error_invalid_segment_number?-instance-method","name":"error_invalid_segment_number?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":293,"url":null},"def":{"name":"error_invalid_segment_number?","visibility":"Public","body":"self == ERROR_INVALID_SEGMENT_NUMBER"}},{"html_id":"error_invalid_separator_file?-instance-method","name":"error_invalid_separator_file?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":889,"url":null},"def":{"name":"error_invalid_separator_file?","visibility":"Public","body":"self == ERROR_INVALID_SEPARATOR_FILE"}},{"html_id":"error_invalid_server_state?-instance-method","name":"error_invalid_server_state?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":634,"url":null},"def":{"name":"error_invalid_server_state?","visibility":"Public","body":"self == ERROR_INVALID_SERVER_STATE"}},{"html_id":"error_invalid_service_account?-instance-method","name":"error_invalid_service_account?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":406,"url":null},"def":{"name":"error_invalid_service_account?","visibility":"Public","body":"self == ERROR_INVALID_SERVICE_ACCOUNT"}},{"html_id":"error_invalid_service_control?-instance-method","name":"error_invalid_service_control?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":401,"url":null},"def":{"name":"error_invalid_service_control?","visibility":"Public","body":"self == ERROR_INVALID_SERVICE_CONTROL"}},{"html_id":"error_invalid_service_lock?-instance-method","name":"error_invalid_service_lock?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":420,"url":null},"def":{"name":"error_invalid_service_lock?","visibility":"Public","body":"self == ERROR_INVALID_SERVICE_LOCK"}},{"html_id":"error_invalid_servicename?-instance-method","name":"error_invalid_servicename?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":514,"url":null},"def":{"name":"error_invalid_servicename?","visibility":"Public","body":"self == ERROR_INVALID_SERVICENAME"}},{"html_id":"error_invalid_sharename?-instance-method","name":"error_invalid_sharename?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":516,"url":null},"def":{"name":"error_invalid_sharename?","visibility":"Public","body":"self == ERROR_INVALID_SHARENAME"}},{"html_id":"error_invalid_showwin_command?-instance-method","name":"error_invalid_showwin_command?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":731,"url":null},"def":{"name":"error_invalid_showwin_command?","visibility":"Public","body":"self == ERROR_INVALID_SHOWWIN_COMMAND"}},{"html_id":"error_invalid_sid?-instance-method","name":"error_invalid_sid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":620,"url":null},"def":{"name":"error_invalid_sid?","visibility":"Public","body":"self == ERROR_INVALID_SID"}},{"html_id":"error_invalid_signal_number?-instance-method","name":"error_invalid_signal_number?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":318,"url":null},"def":{"name":"error_invalid_signal_number?","visibility":"Public","body":"self == ERROR_INVALID_SIGNAL_NUMBER"}},{"html_id":"error_invalid_spi_value?-instance-method","name":"error_invalid_spi_value?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":721,"url":null},"def":{"name":"error_invalid_spi_value?","visibility":"Public","body":"self == ERROR_INVALID_SPI_VALUE"}},{"html_id":"error_invalid_stackseg?-instance-method","name":"error_invalid_stackseg?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":299,"url":null},"def":{"name":"error_invalid_stackseg?","visibility":"Public","body":"self == ERROR_INVALID_STACKSEG"}},{"html_id":"error_invalid_staged_signature?-instance-method","name":"error_invalid_staged_signature?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2213,"url":null},"def":{"name":"error_invalid_staged_signature?","visibility":"Public","body":"self == ERROR_INVALID_STAGED_SIGNATURE"}},{"html_id":"error_invalid_starting_codeseg?-instance-method","name":"error_invalid_starting_codeseg?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":298,"url":null},"def":{"name":"error_invalid_starting_codeseg?","visibility":"Public","body":"self == ERROR_INVALID_STARTING_CODESEG"}},{"html_id":"error_invalid_state?-instance-method","name":"error_invalid_state?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1099,"url":null},"def":{"name":"error_invalid_state?","visibility":"Public","body":"self == ERROR_INVALID_STATE"}},{"html_id":"error_invalid_sub_authority?-instance-method","name":"error_invalid_sub_authority?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":618,"url":null},"def":{"name":"error_invalid_sub_authority?","visibility":"Public","body":"self == ERROR_INVALID_SUB_AUTHORITY"}},{"html_id":"error_invalid_table?-instance-method","name":"error_invalid_table?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":776,"url":null},"def":{"name":"error_invalid_table?","visibility":"Public","body":"self == ERROR_INVALID_TABLE"}},{"html_id":"error_invalid_target_handle?-instance-method","name":"error_invalid_target_handle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":241,"url":null},"def":{"name":"error_invalid_target_handle?","visibility":"Public","body":"self == ERROR_INVALID_TARGET_HANDLE"}},{"html_id":"error_invalid_thread_id?-instance-method","name":"error_invalid_thread_id?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":726,"url":null},"def":{"name":"error_invalid_thread_id?","visibility":"Public","body":"self == ERROR_INVALID_THREAD_ID"}},{"html_id":"error_invalid_time?-instance-method","name":"error_invalid_time?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":926,"url":null},"def":{"name":"error_invalid_time?","visibility":"Public","body":"self == ERROR_INVALID_TIME"}},{"html_id":"error_invalid_transform?-instance-method","name":"error_invalid_transform?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":978,"url":null},"def":{"name":"error_invalid_transform?","visibility":"Public","body":"self == ERROR_INVALID_TRANSFORM"}},{"html_id":"error_invalid_user_buffer?-instance-method","name":"error_invalid_user_buffer?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":874,"url":null},"def":{"name":"error_invalid_user_buffer?","visibility":"Public","body":"self == ERROR_INVALID_USER_BUFFER"}},{"html_id":"error_invalid_verify_switch?-instance-method","name":"error_invalid_verify_switch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":243,"url":null},"def":{"name":"error_invalid_verify_switch?","visibility":"Public","body":"self == ERROR_INVALID_VERIFY_SWITCH"}},{"html_id":"error_invalid_window_handle?-instance-method","name":"error_invalid_window_handle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":682,"url":null},"def":{"name":"error_invalid_window_handle?","visibility":"Public","body":"self == ERROR_INVALID_WINDOW_HANDLE"}},{"html_id":"error_invalid_window_style?-instance-method","name":"error_invalid_window_style?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":964,"url":null},"def":{"name":"error_invalid_window_style?","visibility":"Public","body":"self == ERROR_INVALID_WINDOW_STYLE"}},{"html_id":"error_invalid_workstation?-instance-method","name":"error_invalid_workstation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":612,"url":null},"def":{"name":"error_invalid_workstation?","visibility":"Public","body":"self == ERROR_INVALID_WORKSTATION"}},{"html_id":"error_io_device?-instance-method","name":"error_io_device?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":451,"url":null},"def":{"name":"error_io_device?","visibility":"Public","body":"self == ERROR_IO_DEVICE"}},{"html_id":"error_io_incomplete?-instance-method","name":"error_io_incomplete?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":374,"url":null},"def":{"name":"error_io_incomplete?","visibility":"Public","body":"self == ERROR_IO_INCOMPLETE"}},{"html_id":"error_io_pending?-instance-method","name":"error_io_pending?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":375,"url":null},"def":{"name":"error_io_pending?","visibility":"Public","body":"self == ERROR_IO_PENDING"}},{"html_id":"error_iopl_not_enabled?-instance-method","name":"error_iopl_not_enabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":307,"url":null},"def":{"name":"error_iopl_not_enabled?","visibility":"Public","body":"self == ERROR_IOPL_NOT_ENABLED"}},{"html_id":"error_ipsec_auth_firewall_drop?-instance-method","name":"error_ipsec_auth_firewall_drop?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2083,"url":null},"def":{"name":"error_ipsec_auth_firewall_drop?","visibility":"Public","body":"self == ERROR_IPSEC_AUTH_FIREWALL_DROP"}},{"html_id":"error_ipsec_bad_spi?-instance-method","name":"error_ipsec_bad_spi?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2076,"url":null},"def":{"name":"error_ipsec_bad_spi?","visibility":"Public","body":"self == ERROR_IPSEC_BAD_SPI"}},{"html_id":"error_ipsec_clear_text_drop?-instance-method","name":"error_ipsec_clear_text_drop?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2082,"url":null},"def":{"name":"error_ipsec_clear_text_drop?","visibility":"Public","body":"self == ERROR_IPSEC_CLEAR_TEXT_DROP"}},{"html_id":"error_ipsec_default_mm_auth_not_found?-instance-method","name":"error_ipsec_default_mm_auth_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1957,"url":null},"def":{"name":"error_ipsec_default_mm_auth_not_found?","visibility":"Public","body":"self == ERROR_IPSEC_DEFAULT_MM_AUTH_NOT_FOUND"}},{"html_id":"error_ipsec_default_mm_policy_not_found?-instance-method","name":"error_ipsec_default_mm_policy_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1956,"url":null},"def":{"name":"error_ipsec_default_mm_policy_not_found?","visibility":"Public","body":"self == ERROR_IPSEC_DEFAULT_MM_POLICY_NOT_FOUND"}},{"html_id":"error_ipsec_default_qm_policy_not_found?-instance-method","name":"error_ipsec_default_qm_policy_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1958,"url":null},"def":{"name":"error_ipsec_default_qm_policy_not_found?","visibility":"Public","body":"self == ERROR_IPSEC_DEFAULT_QM_POLICY_NOT_FOUND"}},{"html_id":"error_ipsec_dosp_block?-instance-method","name":"error_ipsec_dosp_block?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2085,"url":null},"def":{"name":"error_ipsec_dosp_block?","visibility":"Public","body":"self == ERROR_IPSEC_DOSP_BLOCK"}},{"html_id":"error_ipsec_dosp_invalid_packet?-instance-method","name":"error_ipsec_dosp_invalid_packet?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2087,"url":null},"def":{"name":"error_ipsec_dosp_invalid_packet?","visibility":"Public","body":"self == ERROR_IPSEC_DOSP_INVALID_PACKET"}},{"html_id":"error_ipsec_dosp_keymod_not_allowed?-instance-method","name":"error_ipsec_dosp_keymod_not_allowed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2090,"url":null},"def":{"name":"error_ipsec_dosp_keymod_not_allowed?","visibility":"Public","body":"self == ERROR_IPSEC_DOSP_KEYMOD_NOT_ALLOWED"}},{"html_id":"error_ipsec_dosp_max_entries?-instance-method","name":"error_ipsec_dosp_max_entries?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2089,"url":null},"def":{"name":"error_ipsec_dosp_max_entries?","visibility":"Public","body":"self == ERROR_IPSEC_DOSP_MAX_ENTRIES"}},{"html_id":"error_ipsec_dosp_max_per_ip_ratelimit_queues?-instance-method","name":"error_ipsec_dosp_max_per_ip_ratelimit_queues?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2092,"url":null},"def":{"name":"error_ipsec_dosp_max_per_ip_ratelimit_queues?","visibility":"Public","body":"self == ERROR_IPSEC_DOSP_MAX_PER_IP_RATELIMIT_QUEUES"}},{"html_id":"error_ipsec_dosp_not_installed?-instance-method","name":"error_ipsec_dosp_not_installed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2091,"url":null},"def":{"name":"error_ipsec_dosp_not_installed?","visibility":"Public","body":"self == ERROR_IPSEC_DOSP_NOT_INSTALLED"}},{"html_id":"error_ipsec_dosp_received_multicast?-instance-method","name":"error_ipsec_dosp_received_multicast?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2086,"url":null},"def":{"name":"error_ipsec_dosp_received_multicast?","visibility":"Public","body":"self == ERROR_IPSEC_DOSP_RECEIVED_MULTICAST"}},{"html_id":"error_ipsec_dosp_state_lookup_failed?-instance-method","name":"error_ipsec_dosp_state_lookup_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2088,"url":null},"def":{"name":"error_ipsec_dosp_state_lookup_failed?","visibility":"Public","body":"self == ERROR_IPSEC_DOSP_STATE_LOOKUP_FAILED"}},{"html_id":"error_ipsec_ike_add_update_key_failed?-instance-method","name":"error_ipsec_ike_add_update_key_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2027,"url":null},"def":{"name":"error_ipsec_ike_add_update_key_failed?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_ADD_UPDATE_KEY_FAILED"}},{"html_id":"error_ipsec_ike_attrib_fail?-instance-method","name":"error_ipsec_ike_attrib_fail?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1971,"url":null},"def":{"name":"error_ipsec_ike_attrib_fail?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_ATTRIB_FAIL"}},{"html_id":"error_ipsec_ike_auth_fail?-instance-method","name":"error_ipsec_ike_auth_fail?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1970,"url":null},"def":{"name":"error_ipsec_ike_auth_fail?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_AUTH_FAIL"}},{"html_id":"error_ipsec_ike_authorization_failure?-instance-method","name":"error_ipsec_ike_authorization_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2071,"url":null},"def":{"name":"error_ipsec_ike_authorization_failure?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_AUTHORIZATION_FAILURE"}},{"html_id":"error_ipsec_ike_authorization_failure_with_optional_retry?-instance-method","name":"error_ipsec_ike_authorization_failure_with_optional_retry?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2073,"url":null},"def":{"name":"error_ipsec_ike_authorization_failure_with_optional_retry?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_AUTHORIZATION_FAILURE_WITH_OPTIONAL_RETRY"}},{"html_id":"error_ipsec_ike_benign_reinit?-instance-method","name":"error_ipsec_ike_benign_reinit?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2045,"url":null},"def":{"name":"error_ipsec_ike_benign_reinit?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_BENIGN_REINIT"}},{"html_id":"error_ipsec_ike_cert_chain_policy_mismatch?-instance-method","name":"error_ipsec_ike_cert_chain_policy_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2053,"url":null},"def":{"name":"error_ipsec_ike_cert_chain_policy_mismatch?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_CERT_CHAIN_POLICY_MISMATCH"}},{"html_id":"error_ipsec_ike_cga_auth_failed?-instance-method","name":"error_ipsec_ike_cga_auth_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2058,"url":null},"def":{"name":"error_ipsec_ike_cga_auth_failed?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_CGA_AUTH_FAILED"}},{"html_id":"error_ipsec_ike_coexistence_suppress?-instance-method","name":"error_ipsec_ike_coexistence_suppress?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2068,"url":null},"def":{"name":"error_ipsec_ike_coexistence_suppress?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_COEXISTENCE_SUPPRESS"}},{"html_id":"error_ipsec_ike_crl_failed?-instance-method","name":"error_ipsec_ike_crl_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1986,"url":null},"def":{"name":"error_ipsec_ike_crl_failed?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_CRL_FAILED"}},{"html_id":"error_ipsec_ike_decrypt?-instance-method","name":"error_ipsec_ike_decrypt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2034,"url":null},"def":{"name":"error_ipsec_ike_decrypt?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_DECRYPT"}},{"html_id":"error_ipsec_ike_dh_fail?-instance-method","name":"error_ipsec_ike_dh_fail?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1990,"url":null},"def":{"name":"error_ipsec_ike_dh_fail?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_DH_FAIL"}},{"html_id":"error_ipsec_ike_dh_failure?-instance-method","name":"error_ipsec_ike_dh_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2031,"url":null},"def":{"name":"error_ipsec_ike_dh_failure?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_DH_FAILURE"}},{"html_id":"error_ipsec_ike_dos_cookie_sent?-instance-method","name":"error_ipsec_ike_dos_cookie_sent?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2056,"url":null},"def":{"name":"error_ipsec_ike_dos_cookie_sent?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_DOS_COOKIE_SENT"}},{"html_id":"error_ipsec_ike_drop_no_response?-instance-method","name":"error_ipsec_ike_drop_no_response?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1982,"url":null},"def":{"name":"error_ipsec_ike_drop_no_response?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_DROP_NO_RESPONSE"}},{"html_id":"error_ipsec_ike_encrypt?-instance-method","name":"error_ipsec_ike_encrypt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2033,"url":null},"def":{"name":"error_ipsec_ike_encrypt?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_ENCRYPT"}},{"html_id":"error_ipsec_ike_error?-instance-method","name":"error_ipsec_ike_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1985,"url":null},"def":{"name":"error_ipsec_ike_error?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_ERROR"}},{"html_id":"error_ipsec_ike_failqueryssp?-instance-method","name":"error_ipsec_ike_failqueryssp?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2021,"url":null},"def":{"name":"error_ipsec_ike_failqueryssp?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_FAILQUERYSSP"}},{"html_id":"error_ipsec_ike_failsspinit?-instance-method","name":"error_ipsec_ike_failsspinit?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2020,"url":null},"def":{"name":"error_ipsec_ike_failsspinit?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_FAILSSPINIT"}},{"html_id":"error_ipsec_ike_general_processing_error?-instance-method","name":"error_ipsec_ike_general_processing_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1973,"url":null},"def":{"name":"error_ipsec_ike_general_processing_error?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_GENERAL_PROCESSING_ERROR"}},{"html_id":"error_ipsec_ike_getspifail?-instance-method","name":"error_ipsec_ike_getspifail?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2024,"url":null},"def":{"name":"error_ipsec_ike_getspifail?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_GETSPIFAIL"}},{"html_id":"error_ipsec_ike_inner_ip_assignment_failure?-instance-method","name":"error_ipsec_ike_inner_ip_assignment_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2065,"url":null},"def":{"name":"error_ipsec_ike_inner_ip_assignment_failure?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INNER_IP_ASSIGNMENT_FAILURE"}},{"html_id":"error_ipsec_ike_invalid_auth_alg?-instance-method","name":"error_ipsec_ike_invalid_auth_alg?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2041,"url":null},"def":{"name":"error_ipsec_ike_invalid_auth_alg?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_AUTH_ALG"}},{"html_id":"error_ipsec_ike_invalid_auth_payload?-instance-method","name":"error_ipsec_ike_invalid_auth_payload?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2055,"url":null},"def":{"name":"error_ipsec_ike_invalid_auth_payload?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_AUTH_PAYLOAD"}},{"html_id":"error_ipsec_ike_invalid_cert_keylen?-instance-method","name":"error_ipsec_ike_invalid_cert_keylen?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2047,"url":null},"def":{"name":"error_ipsec_ike_invalid_cert_keylen?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_CERT_KEYLEN"}},{"html_id":"error_ipsec_ike_invalid_cert_type?-instance-method","name":"error_ipsec_ike_invalid_cert_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1988,"url":null},"def":{"name":"error_ipsec_ike_invalid_cert_type?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_CERT_TYPE"}},{"html_id":"error_ipsec_ike_invalid_cookie?-instance-method","name":"error_ipsec_ike_invalid_cookie?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2013,"url":null},"def":{"name":"error_ipsec_ike_invalid_cookie?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_COOKIE"}},{"html_id":"error_ipsec_ike_invalid_encrypt_alg?-instance-method","name":"error_ipsec_ike_invalid_encrypt_alg?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2040,"url":null},"def":{"name":"error_ipsec_ike_invalid_encrypt_alg?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_ENCRYPT_ALG"}},{"html_id":"error_ipsec_ike_invalid_filter?-instance-method","name":"error_ipsec_ike_invalid_filter?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2025,"url":null},"def":{"name":"error_ipsec_ike_invalid_filter?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_FILTER"}},{"html_id":"error_ipsec_ike_invalid_group?-instance-method","name":"error_ipsec_ike_invalid_group?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2032,"url":null},"def":{"name":"error_ipsec_ike_invalid_group?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_GROUP"}},{"html_id":"error_ipsec_ike_invalid_hash?-instance-method","name":"error_ipsec_ike_invalid_hash?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2037,"url":null},"def":{"name":"error_ipsec_ike_invalid_hash?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_HASH"}},{"html_id":"error_ipsec_ike_invalid_hash_alg?-instance-method","name":"error_ipsec_ike_invalid_hash_alg?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2038,"url":null},"def":{"name":"error_ipsec_ike_invalid_hash_alg?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_HASH_ALG"}},{"html_id":"error_ipsec_ike_invalid_hash_size?-instance-method","name":"error_ipsec_ike_invalid_hash_size?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2039,"url":null},"def":{"name":"error_ipsec_ike_invalid_hash_size?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_HASH_SIZE"}},{"html_id":"error_ipsec_ike_invalid_header?-instance-method","name":"error_ipsec_ike_invalid_header?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1991,"url":null},"def":{"name":"error_ipsec_ike_invalid_header?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_HEADER"}},{"html_id":"error_ipsec_ike_invalid_key_usage?-instance-method","name":"error_ipsec_ike_invalid_key_usage?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1987,"url":null},"def":{"name":"error_ipsec_ike_invalid_key_usage?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_KEY_USAGE"}},{"html_id":"error_ipsec_ike_invalid_mm_for_qm?-instance-method","name":"error_ipsec_ike_invalid_mm_for_qm?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2060,"url":null},"def":{"name":"error_ipsec_ike_invalid_mm_for_qm?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_MM_FOR_QM"}},{"html_id":"error_ipsec_ike_invalid_payload?-instance-method","name":"error_ipsec_ike_invalid_payload?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2010,"url":null},"def":{"name":"error_ipsec_ike_invalid_payload?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_PAYLOAD"}},{"html_id":"error_ipsec_ike_invalid_policy?-instance-method","name":"error_ipsec_ike_invalid_policy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2028,"url":null},"def":{"name":"error_ipsec_ike_invalid_policy?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_POLICY"}},{"html_id":"error_ipsec_ike_invalid_responder_lifetime_notify?-instance-method","name":"error_ipsec_ike_invalid_responder_lifetime_notify?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2046,"url":null},"def":{"name":"error_ipsec_ike_invalid_responder_lifetime_notify?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_RESPONDER_LIFETIME_NOTIFY"}},{"html_id":"error_ipsec_ike_invalid_sig?-instance-method","name":"error_ipsec_ike_invalid_sig?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2042,"url":null},"def":{"name":"error_ipsec_ike_invalid_sig?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_SIG"}},{"html_id":"error_ipsec_ike_invalid_signature?-instance-method","name":"error_ipsec_ike_invalid_signature?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1993,"url":null},"def":{"name":"error_ipsec_ike_invalid_signature?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_SIGNATURE"}},{"html_id":"error_ipsec_ike_invalid_situation?-instance-method","name":"error_ipsec_ike_invalid_situation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2030,"url":null},"def":{"name":"error_ipsec_ike_invalid_situation?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_INVALID_SITUATION"}},{"html_id":"error_ipsec_ike_kerberos_error?-instance-method","name":"error_ipsec_ike_kerberos_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1994,"url":null},"def":{"name":"error_ipsec_ike_kerberos_error?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_KERBEROS_ERROR"}},{"html_id":"error_ipsec_ike_kill_dummy_nap_tunnel?-instance-method","name":"error_ipsec_ike_kill_dummy_nap_tunnel?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2064,"url":null},"def":{"name":"error_ipsec_ike_kill_dummy_nap_tunnel?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_KILL_DUMMY_NAP_TUNNEL"}},{"html_id":"error_ipsec_ike_load_failed?-instance-method","name":"error_ipsec_ike_load_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2043,"url":null},"def":{"name":"error_ipsec_ike_load_failed?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_LOAD_FAILED"}},{"html_id":"error_ipsec_ike_load_soft_sa?-instance-method","name":"error_ipsec_ike_load_soft_sa?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2011,"url":null},"def":{"name":"error_ipsec_ike_load_soft_sa?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_LOAD_SOFT_SA"}},{"html_id":"error_ipsec_ike_mm_acquire_drop?-instance-method","name":"error_ipsec_ike_mm_acquire_drop?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1978,"url":null},"def":{"name":"error_ipsec_ike_mm_acquire_drop?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_MM_ACQUIRE_DROP"}},{"html_id":"error_ipsec_ike_mm_delay_drop?-instance-method","name":"error_ipsec_ike_mm_delay_drop?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1983,"url":null},"def":{"name":"error_ipsec_ike_mm_delay_drop?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_MM_DELAY_DROP"}},{"html_id":"error_ipsec_ike_mm_expired?-instance-method","name":"error_ipsec_ike_mm_expired?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2051,"url":null},"def":{"name":"error_ipsec_ike_mm_expired?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_MM_EXPIRED"}},{"html_id":"error_ipsec_ike_mm_limit?-instance-method","name":"error_ipsec_ike_mm_limit?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2048,"url":null},"def":{"name":"error_ipsec_ike_mm_limit?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_MM_LIMIT"}},{"html_id":"error_ipsec_ike_neg_status_begin?-instance-method","name":"error_ipsec_ike_neg_status_begin?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1969,"url":null},"def":{"name":"error_ipsec_ike_neg_status_begin?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_NEG_STATUS_BEGIN"}},{"html_id":"error_ipsec_ike_neg_status_end?-instance-method","name":"error_ipsec_ike_neg_status_end?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2063,"url":null},"def":{"name":"error_ipsec_ike_neg_status_end?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_NEG_STATUS_END"}},{"html_id":"error_ipsec_ike_neg_status_extended_end?-instance-method","name":"error_ipsec_ike_neg_status_extended_end?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2075,"url":null},"def":{"name":"error_ipsec_ike_neg_status_extended_end?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_NEG_STATUS_EXTENDED_END"}},{"html_id":"error_ipsec_ike_negotiation_disabled?-instance-method","name":"error_ipsec_ike_negotiation_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2049,"url":null},"def":{"name":"error_ipsec_ike_negotiation_disabled?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_NEGOTIATION_DISABLED"}},{"html_id":"error_ipsec_ike_negotiation_pending?-instance-method","name":"error_ipsec_ike_negotiation_pending?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1972,"url":null},"def":{"name":"error_ipsec_ike_negotiation_pending?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_NEGOTIATION_PENDING"}},{"html_id":"error_ipsec_ike_no_cert?-instance-method","name":"error_ipsec_ike_no_cert?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1975,"url":null},"def":{"name":"error_ipsec_ike_no_cert?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_NO_CERT"}},{"html_id":"error_ipsec_ike_no_mm_policy?-instance-method","name":"error_ipsec_ike_no_mm_policy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2017,"url":null},"def":{"name":"error_ipsec_ike_no_mm_policy?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_NO_MM_POLICY"}},{"html_id":"error_ipsec_ike_no_peer_cert?-instance-method","name":"error_ipsec_ike_no_peer_cert?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2014,"url":null},"def":{"name":"error_ipsec_ike_no_peer_cert?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_NO_PEER_CERT"}},{"html_id":"error_ipsec_ike_no_policy?-instance-method","name":"error_ipsec_ike_no_policy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1992,"url":null},"def":{"name":"error_ipsec_ike_no_policy?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_NO_POLICY"}},{"html_id":"error_ipsec_ike_no_private_key?-instance-method","name":"error_ipsec_ike_no_private_key?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1989,"url":null},"def":{"name":"error_ipsec_ike_no_private_key?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_NO_PRIVATE_KEY"}},{"html_id":"error_ipsec_ike_no_public_key?-instance-method","name":"error_ipsec_ike_no_public_key?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1995,"url":null},"def":{"name":"error_ipsec_ike_no_public_key?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_NO_PUBLIC_KEY"}},{"html_id":"error_ipsec_ike_notcbpriv?-instance-method","name":"error_ipsec_ike_notcbpriv?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2018,"url":null},"def":{"name":"error_ipsec_ike_notcbpriv?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_NOTCBPRIV"}},{"html_id":"error_ipsec_ike_out_of_memory?-instance-method","name":"error_ipsec_ike_out_of_memory?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2026,"url":null},"def":{"name":"error_ipsec_ike_out_of_memory?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_OUT_OF_MEMORY"}},{"html_id":"error_ipsec_ike_peer_crl_failed?-instance-method","name":"error_ipsec_ike_peer_crl_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2015,"url":null},"def":{"name":"error_ipsec_ike_peer_crl_failed?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PEER_CRL_FAILED"}},{"html_id":"error_ipsec_ike_peer_doesnt_support_mobike?-instance-method","name":"error_ipsec_ike_peer_doesnt_support_mobike?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2070,"url":null},"def":{"name":"error_ipsec_ike_peer_doesnt_support_mobike?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PEER_DOESNT_SUPPORT_MOBIKE"}},{"html_id":"error_ipsec_ike_peer_mm_assumed_invalid?-instance-method","name":"error_ipsec_ike_peer_mm_assumed_invalid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2052,"url":null},"def":{"name":"error_ipsec_ike_peer_mm_assumed_invalid?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PEER_MM_ASSUMED_INVALID"}},{"html_id":"error_ipsec_ike_policy_change?-instance-method","name":"error_ipsec_ike_policy_change?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2016,"url":null},"def":{"name":"error_ipsec_ike_policy_change?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_POLICY_CHANGE"}},{"html_id":"error_ipsec_ike_policy_match?-instance-method","name":"error_ipsec_ike_policy_match?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2035,"url":null},"def":{"name":"error_ipsec_ike_policy_match?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_POLICY_MATCH"}},{"html_id":"error_ipsec_ike_process_err?-instance-method","name":"error_ipsec_ike_process_err?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1996,"url":null},"def":{"name":"error_ipsec_ike_process_err?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PROCESS_ERR"}},{"html_id":"error_ipsec_ike_process_err_cert?-instance-method","name":"error_ipsec_ike_process_err_cert?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2002,"url":null},"def":{"name":"error_ipsec_ike_process_err_cert?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PROCESS_ERR_CERT"}},{"html_id":"error_ipsec_ike_process_err_cert_req?-instance-method","name":"error_ipsec_ike_process_err_cert_req?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2003,"url":null},"def":{"name":"error_ipsec_ike_process_err_cert_req?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PROCESS_ERR_CERT_REQ"}},{"html_id":"error_ipsec_ike_process_err_delete?-instance-method","name":"error_ipsec_ike_process_err_delete?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2008,"url":null},"def":{"name":"error_ipsec_ike_process_err_delete?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PROCESS_ERR_DELETE"}},{"html_id":"error_ipsec_ike_process_err_hash?-instance-method","name":"error_ipsec_ike_process_err_hash?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2004,"url":null},"def":{"name":"error_ipsec_ike_process_err_hash?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PROCESS_ERR_HASH"}},{"html_id":"error_ipsec_ike_process_err_id?-instance-method","name":"error_ipsec_ike_process_err_id?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2001,"url":null},"def":{"name":"error_ipsec_ike_process_err_id?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PROCESS_ERR_ID"}},{"html_id":"error_ipsec_ike_process_err_ke?-instance-method","name":"error_ipsec_ike_process_err_ke?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2000,"url":null},"def":{"name":"error_ipsec_ike_process_err_ke?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PROCESS_ERR_KE"}},{"html_id":"error_ipsec_ike_process_err_natoa?-instance-method","name":"error_ipsec_ike_process_err_natoa?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2059,"url":null},"def":{"name":"error_ipsec_ike_process_err_natoa?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PROCESS_ERR_NATOA"}},{"html_id":"error_ipsec_ike_process_err_nonce?-instance-method","name":"error_ipsec_ike_process_err_nonce?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2006,"url":null},"def":{"name":"error_ipsec_ike_process_err_nonce?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PROCESS_ERR_NONCE"}},{"html_id":"error_ipsec_ike_process_err_notify?-instance-method","name":"error_ipsec_ike_process_err_notify?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2007,"url":null},"def":{"name":"error_ipsec_ike_process_err_notify?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PROCESS_ERR_NOTIFY"}},{"html_id":"error_ipsec_ike_process_err_prop?-instance-method","name":"error_ipsec_ike_process_err_prop?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1998,"url":null},"def":{"name":"error_ipsec_ike_process_err_prop?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PROCESS_ERR_PROP"}},{"html_id":"error_ipsec_ike_process_err_sa?-instance-method","name":"error_ipsec_ike_process_err_sa?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1997,"url":null},"def":{"name":"error_ipsec_ike_process_err_sa?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PROCESS_ERR_SA"}},{"html_id":"error_ipsec_ike_process_err_sig?-instance-method","name":"error_ipsec_ike_process_err_sig?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2005,"url":null},"def":{"name":"error_ipsec_ike_process_err_sig?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PROCESS_ERR_SIG"}},{"html_id":"error_ipsec_ike_process_err_trans?-instance-method","name":"error_ipsec_ike_process_err_trans?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1999,"url":null},"def":{"name":"error_ipsec_ike_process_err_trans?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PROCESS_ERR_TRANS"}},{"html_id":"error_ipsec_ike_process_err_vendor?-instance-method","name":"error_ipsec_ike_process_err_vendor?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2009,"url":null},"def":{"name":"error_ipsec_ike_process_err_vendor?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_PROCESS_ERR_VENDOR"}},{"html_id":"error_ipsec_ike_qm_acquire_drop?-instance-method","name":"error_ipsec_ike_qm_acquire_drop?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1979,"url":null},"def":{"name":"error_ipsec_ike_qm_acquire_drop?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_QM_ACQUIRE_DROP"}},{"html_id":"error_ipsec_ike_qm_delay_drop?-instance-method","name":"error_ipsec_ike_qm_delay_drop?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1984,"url":null},"def":{"name":"error_ipsec_ike_qm_delay_drop?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_QM_DELAY_DROP"}},{"html_id":"error_ipsec_ike_qm_expired?-instance-method","name":"error_ipsec_ike_qm_expired?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2061,"url":null},"def":{"name":"error_ipsec_ike_qm_expired?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_QM_EXPIRED"}},{"html_id":"error_ipsec_ike_qm_limit?-instance-method","name":"error_ipsec_ike_qm_limit?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2050,"url":null},"def":{"name":"error_ipsec_ike_qm_limit?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_QM_LIMIT"}},{"html_id":"error_ipsec_ike_queue_drop_mm?-instance-method","name":"error_ipsec_ike_queue_drop_mm?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1980,"url":null},"def":{"name":"error_ipsec_ike_queue_drop_mm?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_QUEUE_DROP_MM"}},{"html_id":"error_ipsec_ike_queue_drop_no_mm?-instance-method","name":"error_ipsec_ike_queue_drop_no_mm?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1981,"url":null},"def":{"name":"error_ipsec_ike_queue_drop_no_mm?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_QUEUE_DROP_NO_MM"}},{"html_id":"error_ipsec_ike_ratelimit_drop?-instance-method","name":"error_ipsec_ike_ratelimit_drop?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2069,"url":null},"def":{"name":"error_ipsec_ike_ratelimit_drop?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_RATELIMIT_DROP"}},{"html_id":"error_ipsec_ike_require_cp_payload_missing?-instance-method","name":"error_ipsec_ike_require_cp_payload_missing?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2066,"url":null},"def":{"name":"error_ipsec_ike_require_cp_payload_missing?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_REQUIRE_CP_PAYLOAD_MISSING"}},{"html_id":"error_ipsec_ike_rpc_delete?-instance-method","name":"error_ipsec_ike_rpc_delete?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2044,"url":null},"def":{"name":"error_ipsec_ike_rpc_delete?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_RPC_DELETE"}},{"html_id":"error_ipsec_ike_sa_deleted?-instance-method","name":"error_ipsec_ike_sa_deleted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1976,"url":null},"def":{"name":"error_ipsec_ike_sa_deleted?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_SA_DELETED"}},{"html_id":"error_ipsec_ike_sa_reaped?-instance-method","name":"error_ipsec_ike_sa_reaped?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1977,"url":null},"def":{"name":"error_ipsec_ike_sa_reaped?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_SA_REAPED"}},{"html_id":"error_ipsec_ike_secloadfail?-instance-method","name":"error_ipsec_ike_secloadfail?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2019,"url":null},"def":{"name":"error_ipsec_ike_secloadfail?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_SECLOADFAIL"}},{"html_id":"error_ipsec_ike_shutting_down?-instance-method","name":"error_ipsec_ike_shutting_down?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2057,"url":null},"def":{"name":"error_ipsec_ike_shutting_down?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_SHUTTING_DOWN"}},{"html_id":"error_ipsec_ike_soft_sa_torn_down?-instance-method","name":"error_ipsec_ike_soft_sa_torn_down?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2012,"url":null},"def":{"name":"error_ipsec_ike_soft_sa_torn_down?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_SOFT_SA_TORN_DOWN"}},{"html_id":"error_ipsec_ike_srvacqfail?-instance-method","name":"error_ipsec_ike_srvacqfail?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2022,"url":null},"def":{"name":"error_ipsec_ike_srvacqfail?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_SRVACQFAIL"}},{"html_id":"error_ipsec_ike_srvquerycred?-instance-method","name":"error_ipsec_ike_srvquerycred?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2023,"url":null},"def":{"name":"error_ipsec_ike_srvquerycred?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_SRVQUERYCRED"}},{"html_id":"error_ipsec_ike_strong_cred_authorization_and_certmap_failure?-instance-method","name":"error_ipsec_ike_strong_cred_authorization_and_certmap_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2074,"url":null},"def":{"name":"error_ipsec_ike_strong_cred_authorization_and_certmap_failure?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_STRONG_CRED_AUTHORIZATION_AND_CERTMAP_FAILURE"}},{"html_id":"error_ipsec_ike_strong_cred_authorization_failure?-instance-method","name":"error_ipsec_ike_strong_cred_authorization_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2072,"url":null},"def":{"name":"error_ipsec_ike_strong_cred_authorization_failure?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_STRONG_CRED_AUTHORIZATION_FAILURE"}},{"html_id":"error_ipsec_ike_timed_out?-instance-method","name":"error_ipsec_ike_timed_out?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1974,"url":null},"def":{"name":"error_ipsec_ike_timed_out?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_TIMED_OUT"}},{"html_id":"error_ipsec_ike_too_many_filters?-instance-method","name":"error_ipsec_ike_too_many_filters?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2062,"url":null},"def":{"name":"error_ipsec_ike_too_many_filters?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_TOO_MANY_FILTERS"}},{"html_id":"error_ipsec_ike_unexpected_message_id?-instance-method","name":"error_ipsec_ike_unexpected_message_id?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2054,"url":null},"def":{"name":"error_ipsec_ike_unexpected_message_id?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_UNEXPECTED_MESSAGE_ID"}},{"html_id":"error_ipsec_ike_unknown_doi?-instance-method","name":"error_ipsec_ike_unknown_doi?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2029,"url":null},"def":{"name":"error_ipsec_ike_unknown_doi?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_UNKNOWN_DOI"}},{"html_id":"error_ipsec_ike_unsupported_id?-instance-method","name":"error_ipsec_ike_unsupported_id?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2036,"url":null},"def":{"name":"error_ipsec_ike_unsupported_id?","visibility":"Public","body":"self == ERROR_IPSEC_IKE_UNSUPPORTED_ID"}},{"html_id":"error_ipsec_integrity_check_failed?-instance-method","name":"error_ipsec_integrity_check_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2081,"url":null},"def":{"name":"error_ipsec_integrity_check_failed?","visibility":"Public","body":"self == ERROR_IPSEC_INTEGRITY_CHECK_FAILED"}},{"html_id":"error_ipsec_invalid_packet?-instance-method","name":"error_ipsec_invalid_packet?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2080,"url":null},"def":{"name":"error_ipsec_invalid_packet?","visibility":"Public","body":"self == ERROR_IPSEC_INVALID_PACKET"}},{"html_id":"error_ipsec_key_module_impersonation_negotiation_pending?-instance-method","name":"error_ipsec_key_module_impersonation_negotiation_pending?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2067,"url":null},"def":{"name":"error_ipsec_key_module_impersonation_negotiation_pending?","visibility":"Public","body":"self == ERROR_IPSEC_KEY_MODULE_IMPERSONATION_NEGOTIATION_PENDING"}},{"html_id":"error_ipsec_mm_auth_exists?-instance-method","name":"error_ipsec_mm_auth_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1953,"url":null},"def":{"name":"error_ipsec_mm_auth_exists?","visibility":"Public","body":"self == ERROR_IPSEC_MM_AUTH_EXISTS"}},{"html_id":"error_ipsec_mm_auth_in_use?-instance-method","name":"error_ipsec_mm_auth_in_use?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1955,"url":null},"def":{"name":"error_ipsec_mm_auth_in_use?","visibility":"Public","body":"self == ERROR_IPSEC_MM_AUTH_IN_USE"}},{"html_id":"error_ipsec_mm_auth_not_found?-instance-method","name":"error_ipsec_mm_auth_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1954,"url":null},"def":{"name":"error_ipsec_mm_auth_not_found?","visibility":"Public","body":"self == ERROR_IPSEC_MM_AUTH_NOT_FOUND"}},{"html_id":"error_ipsec_mm_auth_pending_deletion?-instance-method","name":"error_ipsec_mm_auth_pending_deletion?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1965,"url":null},"def":{"name":"error_ipsec_mm_auth_pending_deletion?","visibility":"Public","body":"self == ERROR_IPSEC_MM_AUTH_PENDING_DELETION"}},{"html_id":"error_ipsec_mm_filter_exists?-instance-method","name":"error_ipsec_mm_filter_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1949,"url":null},"def":{"name":"error_ipsec_mm_filter_exists?","visibility":"Public","body":"self == ERROR_IPSEC_MM_FILTER_EXISTS"}},{"html_id":"error_ipsec_mm_filter_not_found?-instance-method","name":"error_ipsec_mm_filter_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1950,"url":null},"def":{"name":"error_ipsec_mm_filter_not_found?","visibility":"Public","body":"self == ERROR_IPSEC_MM_FILTER_NOT_FOUND"}},{"html_id":"error_ipsec_mm_filter_pending_deletion?-instance-method","name":"error_ipsec_mm_filter_pending_deletion?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1961,"url":null},"def":{"name":"error_ipsec_mm_filter_pending_deletion?","visibility":"Public","body":"self == ERROR_IPSEC_MM_FILTER_PENDING_DELETION"}},{"html_id":"error_ipsec_mm_policy_exists?-instance-method","name":"error_ipsec_mm_policy_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1946,"url":null},"def":{"name":"error_ipsec_mm_policy_exists?","visibility":"Public","body":"self == ERROR_IPSEC_MM_POLICY_EXISTS"}},{"html_id":"error_ipsec_mm_policy_in_use?-instance-method","name":"error_ipsec_mm_policy_in_use?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1948,"url":null},"def":{"name":"error_ipsec_mm_policy_in_use?","visibility":"Public","body":"self == ERROR_IPSEC_MM_POLICY_IN_USE"}},{"html_id":"error_ipsec_mm_policy_not_found?-instance-method","name":"error_ipsec_mm_policy_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1947,"url":null},"def":{"name":"error_ipsec_mm_policy_not_found?","visibility":"Public","body":"self == ERROR_IPSEC_MM_POLICY_NOT_FOUND"}},{"html_id":"error_ipsec_mm_policy_pending_deletion?-instance-method","name":"error_ipsec_mm_policy_pending_deletion?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1964,"url":null},"def":{"name":"error_ipsec_mm_policy_pending_deletion?","visibility":"Public","body":"self == ERROR_IPSEC_MM_POLICY_PENDING_DELETION"}},{"html_id":"error_ipsec_qm_policy_exists?-instance-method","name":"error_ipsec_qm_policy_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1943,"url":null},"def":{"name":"error_ipsec_qm_policy_exists?","visibility":"Public","body":"self == ERROR_IPSEC_QM_POLICY_EXISTS"}},{"html_id":"error_ipsec_qm_policy_in_use?-instance-method","name":"error_ipsec_qm_policy_in_use?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1945,"url":null},"def":{"name":"error_ipsec_qm_policy_in_use?","visibility":"Public","body":"self == ERROR_IPSEC_QM_POLICY_IN_USE"}},{"html_id":"error_ipsec_qm_policy_not_found?-instance-method","name":"error_ipsec_qm_policy_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1944,"url":null},"def":{"name":"error_ipsec_qm_policy_not_found?","visibility":"Public","body":"self == ERROR_IPSEC_QM_POLICY_NOT_FOUND"}},{"html_id":"error_ipsec_qm_policy_pending_deletion?-instance-method","name":"error_ipsec_qm_policy_pending_deletion?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1966,"url":null},"def":{"name":"error_ipsec_qm_policy_pending_deletion?","visibility":"Public","body":"self == ERROR_IPSEC_QM_POLICY_PENDING_DELETION"}},{"html_id":"error_ipsec_replay_check_failed?-instance-method","name":"error_ipsec_replay_check_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2079,"url":null},"def":{"name":"error_ipsec_replay_check_failed?","visibility":"Public","body":"self == ERROR_IPSEC_REPLAY_CHECK_FAILED"}},{"html_id":"error_ipsec_sa_lifetime_expired?-instance-method","name":"error_ipsec_sa_lifetime_expired?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2077,"url":null},"def":{"name":"error_ipsec_sa_lifetime_expired?","visibility":"Public","body":"self == ERROR_IPSEC_SA_LIFETIME_EXPIRED"}},{"html_id":"error_ipsec_throttle_drop?-instance-method","name":"error_ipsec_throttle_drop?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2084,"url":null},"def":{"name":"error_ipsec_throttle_drop?","visibility":"Public","body":"self == ERROR_IPSEC_THROTTLE_DROP"}},{"html_id":"error_ipsec_transport_filter_exists?-instance-method","name":"error_ipsec_transport_filter_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1951,"url":null},"def":{"name":"error_ipsec_transport_filter_exists?","visibility":"Public","body":"self == ERROR_IPSEC_TRANSPORT_FILTER_EXISTS"}},{"html_id":"error_ipsec_transport_filter_not_found?-instance-method","name":"error_ipsec_transport_filter_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1952,"url":null},"def":{"name":"error_ipsec_transport_filter_not_found?","visibility":"Public","body":"self == ERROR_IPSEC_TRANSPORT_FILTER_NOT_FOUND"}},{"html_id":"error_ipsec_transport_filter_pending_deletion?-instance-method","name":"error_ipsec_transport_filter_pending_deletion?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1962,"url":null},"def":{"name":"error_ipsec_transport_filter_pending_deletion?","visibility":"Public","body":"self == ERROR_IPSEC_TRANSPORT_FILTER_PENDING_DELETION"}},{"html_id":"error_ipsec_tunnel_filter_exists?-instance-method","name":"error_ipsec_tunnel_filter_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1959,"url":null},"def":{"name":"error_ipsec_tunnel_filter_exists?","visibility":"Public","body":"self == ERROR_IPSEC_TUNNEL_FILTER_EXISTS"}},{"html_id":"error_ipsec_tunnel_filter_not_found?-instance-method","name":"error_ipsec_tunnel_filter_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1960,"url":null},"def":{"name":"error_ipsec_tunnel_filter_not_found?","visibility":"Public","body":"self == ERROR_IPSEC_TUNNEL_FILTER_NOT_FOUND"}},{"html_id":"error_ipsec_tunnel_filter_pending_deletion?-instance-method","name":"error_ipsec_tunnel_filter_pending_deletion?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1963,"url":null},"def":{"name":"error_ipsec_tunnel_filter_pending_deletion?","visibility":"Public","body":"self == ERROR_IPSEC_TUNNEL_FILTER_PENDING_DELETION"}},{"html_id":"error_ipsec_wrong_sa?-instance-method","name":"error_ipsec_wrong_sa?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2078,"url":null},"def":{"name":"error_ipsec_wrong_sa?","visibility":"Public","body":"self == ERROR_IPSEC_WRONG_SA"}},{"html_id":"error_irq_busy?-instance-method","name":"error_irq_busy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":453,"url":null},"def":{"name":"error_irq_busy?","visibility":"Public","body":"self == ERROR_IRQ_BUSY"}},{"html_id":"error_is_join_path?-instance-method","name":"error_is_join_path?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":272,"url":null},"def":{"name":"error_is_join_path?","visibility":"Public","body":"self == ERROR_IS_JOIN_PATH"}},{"html_id":"error_is_join_target?-instance-method","name":"error_is_join_target?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":258,"url":null},"def":{"name":"error_is_join_target?","visibility":"Public","body":"self == ERROR_IS_JOIN_TARGET"}},{"html_id":"error_is_joined?-instance-method","name":"error_is_joined?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":259,"url":null},"def":{"name":"error_is_joined?","visibility":"Public","body":"self == ERROR_IS_JOINED"}},{"html_id":"error_is_subst_path?-instance-method","name":"error_is_subst_path?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":271,"url":null},"def":{"name":"error_is_subst_path?","visibility":"Public","body":"self == ERROR_IS_SUBST_PATH"}},{"html_id":"error_is_subst_target?-instance-method","name":"error_is_subst_target?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":274,"url":null},"def":{"name":"error_is_subst_target?","visibility":"Public","body":"self == ERROR_IS_SUBST_TARGET"}},{"html_id":"error_is_substed?-instance-method","name":"error_is_substed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":260,"url":null},"def":{"name":"error_is_substed?","visibility":"Public","body":"self == ERROR_IS_SUBSTED"}},{"html_id":"error_iterated_data_exceeds_64k?-instance-method","name":"error_iterated_data_exceeds_64k?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":304,"url":null},"def":{"name":"error_iterated_data_exceeds_64k?","visibility":"Public","body":"self == ERROR_ITERATED_DATA_EXCEEDS_64k"}},{"html_id":"error_join_to_join?-instance-method","name":"error_join_to_join?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":263,"url":null},"def":{"name":"error_join_to_join?","visibility":"Public","body":"self == ERROR_JOIN_TO_JOIN"}},{"html_id":"error_join_to_subst?-instance-method","name":"error_join_to_subst?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":265,"url":null},"def":{"name":"error_join_to_subst?","visibility":"Public","body":"self == ERROR_JOIN_TO_SUBST"}},{"html_id":"error_journal_delete_in_progress?-instance-method","name":"error_journal_delete_in_progress?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":497,"url":null},"def":{"name":"error_journal_delete_in_progress?","visibility":"Public","body":"self == ERROR_JOURNAL_DELETE_IN_PROGRESS"}},{"html_id":"error_journal_entry_deleted?-instance-method","name":"error_journal_entry_deleted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":500,"url":null},"def":{"name":"error_journal_entry_deleted?","visibility":"Public","body":"self == ERROR_JOURNAL_ENTRY_DELETED"}},{"html_id":"error_journal_hook_set?-instance-method","name":"error_journal_hook_set?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":712,"url":null},"def":{"name":"error_journal_hook_set?","visibility":"Public","body":"self == ERROR_JOURNAL_HOOK_SET"}},{"html_id":"error_journal_not_active?-instance-method","name":"error_journal_not_active?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":498,"url":null},"def":{"name":"error_journal_not_active?","visibility":"Public","body":"self == ERROR_JOURNAL_NOT_ACTIVE"}},{"html_id":"error_kernel_apc?-instance-method","name":"error_kernel_apc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":370,"url":null},"def":{"name":"error_kernel_apc?","visibility":"Public","body":"self == ERROR_KERNEL_APC"}},{"html_id":"error_key_deleted?-instance-method","name":"error_key_deleted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":395,"url":null},"def":{"name":"error_key_deleted?","visibility":"Public","body":"self == ERROR_KEY_DELETED"}},{"html_id":"error_key_has_children?-instance-method","name":"error_key_has_children?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":397,"url":null},"def":{"name":"error_key_has_children?","visibility":"Public","body":"self == ERROR_KEY_HAS_CHILDREN"}},{"html_id":"error_km_driver_blocked?-instance-method","name":"error_km_driver_blocked?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":955,"url":null},"def":{"name":"error_km_driver_blocked?","visibility":"Public","body":"self == ERROR_KM_DRIVER_BLOCKED"}},{"html_id":"error_label_too_long?-instance-method","name":"error_label_too_long?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":279,"url":null},"def":{"name":"error_label_too_long?","visibility":"Public","body":"self == ERROR_LABEL_TOO_LONG"}},{"html_id":"error_last_admin?-instance-method","name":"error_last_admin?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":605,"url":null},"def":{"name":"error_last_admin?","visibility":"Public","body":"self == ERROR_LAST_ADMIN"}},{"html_id":"error_lb_without_tabstops?-instance-method","name":"error_lb_without_tabstops?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":716,"url":null},"def":{"name":"error_lb_without_tabstops?","visibility":"Public","body":"self == ERROR_LB_WITHOUT_TABSTOPS"}},{"html_id":"error_library_full?-instance-method","name":"error_library_full?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1048,"url":null},"def":{"name":"error_library_full?","visibility":"Public","body":"self == ERROR_LIBRARY_FULL"}},{"html_id":"error_library_offline?-instance-method","name":"error_library_offline?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1031,"url":null},"def":{"name":"error_library_offline?","visibility":"Public","body":"self == ERROR_LIBRARY_OFFLINE"}},{"html_id":"error_license_quota_exceeded?-instance-method","name":"error_license_quota_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":677,"url":null},"def":{"name":"error_license_quota_exceeded?","visibility":"Public","body":"self == ERROR_LICENSE_QUOTA_EXCEEDED"}},{"html_id":"error_listbox_id_not_found?-instance-method","name":"error_listbox_id_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":698,"url":null},"def":{"name":"error_listbox_id_not_found?","visibility":"Public","body":"self == ERROR_LISTBOX_ID_NOT_FOUND"}},{"html_id":"error_lm_cross_encryption_required?-instance-method","name":"error_lm_cross_encryption_required?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":672,"url":null},"def":{"name":"error_lm_cross_encryption_required?","visibility":"Public","body":"self == ERROR_LM_CROSS_ENCRYPTION_REQUIRED"}},{"html_id":"error_local_user_session_key?-instance-method","name":"error_local_user_session_key?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":586,"url":null},"def":{"name":"error_local_user_session_key?","visibility":"Public","body":"self == ERROR_LOCAL_USER_SESSION_KEY"}},{"html_id":"error_lock_failed?-instance-method","name":"error_lock_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":289,"url":null},"def":{"name":"error_lock_failed?","visibility":"Public","body":"self == ERROR_LOCK_FAILED"}},{"html_id":"error_lock_violation?-instance-method","name":"error_lock_violation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":190,"url":null},"def":{"name":"error_lock_violation?","visibility":"Public","body":"self == ERROR_LOCK_VIOLATION"}},{"html_id":"error_locked?-instance-method","name":"error_locked?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":320,"url":null},"def":{"name":"error_locked?","visibility":"Public","body":"self == ERROR_LOCKED"}},{"html_id":"error_log_file_full?-instance-method","name":"error_log_file_full?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":747,"url":null},"def":{"name":"error_log_file_full?","visibility":"Public","body":"self == ERROR_LOG_FILE_FULL"}},{"html_id":"error_login_time_restriction?-instance-method","name":"error_login_time_restriction?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":540,"url":null},"def":{"name":"error_login_time_restriction?","visibility":"Public","body":"self == ERROR_LOGIN_TIME_RESTRICTION"}},{"html_id":"error_login_wksta_restriction?-instance-method","name":"error_login_wksta_restriction?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":541,"url":null},"def":{"name":"error_login_wksta_restriction?","visibility":"Public","body":"self == ERROR_LOGIN_WKSTA_RESTRICTION"}},{"html_id":"error_logon_failure?-instance-method","name":"error_logon_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":609,"url":null},"def":{"name":"error_logon_failure?","visibility":"Public","body":"self == ERROR_LOGON_FAILURE"}},{"html_id":"error_logon_not_granted?-instance-method","name":"error_logon_not_granted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":662,"url":null},"def":{"name":"error_logon_not_granted?","visibility":"Public","body":"self == ERROR_LOGON_NOT_GRANTED"}},{"html_id":"error_logon_session_collision?-instance-method","name":"error_logon_session_collision?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":648,"url":null},"def":{"name":"error_logon_session_collision?","visibility":"Public","body":"self == ERROR_LOGON_SESSION_COLLISION"}},{"html_id":"error_logon_session_exists?-instance-method","name":"error_logon_session_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":645,"url":null},"def":{"name":"error_logon_session_exists?","visibility":"Public","body":"self == ERROR_LOGON_SESSION_EXISTS"}},{"html_id":"error_logon_type_not_granted?-instance-method","name":"error_logon_type_not_granted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":667,"url":null},"def":{"name":"error_logon_type_not_granted?","visibility":"Public","body":"self == ERROR_LOGON_TYPE_NOT_GRANTED"}},{"html_id":"error_luids_exhausted?-instance-method","name":"error_luids_exhausted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":617,"url":null},"def":{"name":"error_luids_exhausted?","visibility":"Public","body":"self == ERROR_LUIDS_EXHAUSTED"}},{"html_id":"error_machine_locked?-instance-method","name":"error_machine_locked?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":567,"url":null},"def":{"name":"error_machine_locked?","visibility":"Public","body":"self == ERROR_MACHINE_LOCKED"}},{"html_id":"error_magazine_not_present?-instance-method","name":"error_magazine_not_present?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":483,"url":null},"def":{"name":"error_magazine_not_present?","visibility":"Public","body":"self == ERROR_MAGAZINE_NOT_PRESENT"}},{"html_id":"error_malformed_substitution_string?-instance-method","name":"error_malformed_substitution_string?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1926,"url":null},"def":{"name":"error_malformed_substitution_string?","visibility":"Public","body":"self == ERROR_MALFORMED_SUBSTITUTION_STRING"}},{"html_id":"error_mapped_alignment?-instance-method","name":"error_mapped_alignment?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":466,"url":null},"def":{"name":"error_mapped_alignment?","visibility":"Public","body":"self == ERROR_MAPPED_ALIGNMENT"}},{"html_id":"error_max_thrds_reached?-instance-method","name":"error_max_thrds_reached?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":288,"url":null},"def":{"name":"error_max_thrds_reached?","visibility":"Public","body":"self == ERROR_MAX_THRDS_REACHED"}},{"html_id":"error_mca_internal_error?-instance-method","name":"error_mca_internal_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2172,"url":null},"def":{"name":"error_mca_internal_error?","visibility":"Public","body":"self == ERROR_MCA_INTERNAL_ERROR"}},{"html_id":"error_mca_invalid_capabilities_string?-instance-method","name":"error_mca_invalid_capabilities_string?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2167,"url":null},"def":{"name":"error_mca_invalid_capabilities_string?","visibility":"Public","body":"self == ERROR_MCA_INVALID_CAPABILITIES_STRING"}},{"html_id":"error_mca_invalid_technology_type_returned?-instance-method","name":"error_mca_invalid_technology_type_returned?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2173,"url":null},"def":{"name":"error_mca_invalid_technology_type_returned?","visibility":"Public","body":"self == ERROR_MCA_INVALID_TECHNOLOGY_TYPE_RETURNED"}},{"html_id":"error_mca_invalid_vcp_version?-instance-method","name":"error_mca_invalid_vcp_version?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2168,"url":null},"def":{"name":"error_mca_invalid_vcp_version?","visibility":"Public","body":"self == ERROR_MCA_INVALID_VCP_VERSION"}},{"html_id":"error_mca_mccs_version_mismatch?-instance-method","name":"error_mca_mccs_version_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2170,"url":null},"def":{"name":"error_mca_mccs_version_mismatch?","visibility":"Public","body":"self == ERROR_MCA_MCCS_VERSION_MISMATCH"}},{"html_id":"error_mca_monitor_violates_mccs_specification?-instance-method","name":"error_mca_monitor_violates_mccs_specification?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2169,"url":null},"def":{"name":"error_mca_monitor_violates_mccs_specification?","visibility":"Public","body":"self == ERROR_MCA_MONITOR_VIOLATES_MCCS_SPECIFICATION"}},{"html_id":"error_mca_unsupported_color_temperature?-instance-method","name":"error_mca_unsupported_color_temperature?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2174,"url":null},"def":{"name":"error_mca_unsupported_color_temperature?","visibility":"Public","body":"self == ERROR_MCA_UNSUPPORTED_COLOR_TEMPERATURE"}},{"html_id":"error_mca_unsupported_mccs_version?-instance-method","name":"error_mca_unsupported_mccs_version?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2171,"url":null},"def":{"name":"error_mca_unsupported_mccs_version?","visibility":"Public","body":"self == ERROR_MCA_UNSUPPORTED_MCCS_VERSION"}},{"html_id":"error_media_changed?-instance-method","name":"error_media_changed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":444,"url":null},"def":{"name":"error_media_changed?","visibility":"Public","body":"self == ERROR_MEDIA_CHANGED"}},{"html_id":"error_media_incompatible?-instance-method","name":"error_media_incompatible?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1041,"url":null},"def":{"name":"error_media_incompatible?","visibility":"Public","body":"self == ERROR_MEDIA_INCOMPATIBLE"}},{"html_id":"error_media_not_available?-instance-method","name":"error_media_not_available?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1044,"url":null},"def":{"name":"error_media_not_available?","visibility":"Public","body":"self == ERROR_MEDIA_NOT_AVAILABLE"}},{"html_id":"error_media_offline?-instance-method","name":"error_media_offline?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1030,"url":null},"def":{"name":"error_media_offline?","visibility":"Public","body":"self == ERROR_MEDIA_OFFLINE"}},{"html_id":"error_media_unavailable?-instance-method","name":"error_media_unavailable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1034,"url":null},"def":{"name":"error_media_unavailable?","visibility":"Public","body":"self == ERROR_MEDIA_UNAVAILABLE"}},{"html_id":"error_medium_not_accessible?-instance-method","name":"error_medium_not_accessible?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1049,"url":null},"def":{"name":"error_medium_not_accessible?","visibility":"Public","body":"self == ERROR_MEDIUM_NOT_ACCESSIBLE"}},{"html_id":"error_member_in_alias?-instance-method","name":"error_member_in_alias?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":660,"url":null},"def":{"name":"error_member_in_alias?","visibility":"Public","body":"self == ERROR_MEMBER_IN_ALIAS"}},{"html_id":"error_member_in_group?-instance-method","name":"error_member_in_group?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":603,"url":null},"def":{"name":"error_member_in_group?","visibility":"Public","body":"self == ERROR_MEMBER_IN_GROUP"}},{"html_id":"error_member_not_in_alias?-instance-method","name":"error_member_not_in_alias?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":659,"url":null},"def":{"name":"error_member_not_in_alias?","visibility":"Public","body":"self == ERROR_MEMBER_NOT_IN_ALIAS"}},{"html_id":"error_member_not_in_group?-instance-method","name":"error_member_not_in_group?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":604,"url":null},"def":{"name":"error_member_not_in_group?","visibility":"Public","body":"self == ERROR_MEMBER_NOT_IN_GROUP"}},{"html_id":"error_members_primary_group?-instance-method","name":"error_members_primary_group?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":656,"url":null},"def":{"name":"error_members_primary_group?","visibility":"Public","body":"self == ERROR_MEMBERS_PRIMARY_GROUP"}},{"html_id":"error_menu_item_not_found?-instance-method","name":"error_menu_item_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":738,"url":null},"def":{"name":"error_menu_item_not_found?","visibility":"Public","body":"self == ERROR_MENU_ITEM_NOT_FOUND"}},{"html_id":"error_message_exceeds_max_size?-instance-method","name":"error_message_exceeds_max_size?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1062,"url":null},"def":{"name":"error_message_exceeds_max_size?","visibility":"Public","body":"self == ERROR_MESSAGE_EXCEEDS_MAX_SIZE"}},{"html_id":"error_message_sync_only?-instance-method","name":"error_message_sync_only?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":479,"url":null},"def":{"name":"error_message_sync_only?","visibility":"Public","body":"self == ERROR_MESSAGE_SYNC_ONLY"}},{"html_id":"error_meta_expansion_too_long?-instance-method","name":"error_meta_expansion_too_long?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":317,"url":null},"def":{"name":"error_meta_expansion_too_long?","visibility":"Public","body":"self == ERROR_META_EXPANSION_TOO_LONG"}},{"html_id":"error_metafile_not_supported?-instance-method","name":"error_metafile_not_supported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":965,"url":null},"def":{"name":"error_metafile_not_supported?","visibility":"Public","body":"self == ERROR_METAFILE_NOT_SUPPORTED"}},{"html_id":"error_mod_not_found?-instance-method","name":"error_mod_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":251,"url":null},"def":{"name":"error_mod_not_found?","visibility":"Public","body":"self == ERROR_MOD_NOT_FOUND"}},{"html_id":"error_more_data?-instance-method","name":"error_more_data?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":336,"url":null},"def":{"name":"error_more_data?","visibility":"Public","body":"self == ERROR_MORE_DATA"}},{"html_id":"error_more_writes?-instance-method","name":"error_more_writes?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":454,"url":null},"def":{"name":"error_more_writes?","visibility":"Public","body":"self == ERROR_MORE_WRITES"}},{"html_id":"error_mr_mid_not_found?-instance-method","name":"error_mr_mid_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":356,"url":null},"def":{"name":"error_mr_mid_not_found?","visibility":"Public","body":"self == ERROR_MR_MID_NOT_FOUND"}},{"html_id":"error_mrm_automerge_enabled?-instance-method","name":"error_mrm_automerge_enabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2165,"url":null},"def":{"name":"error_mrm_automerge_enabled?","visibility":"Public","body":"self == ERROR_MRM_AUTOMERGE_ENABLED"}},{"html_id":"error_mrm_duplicate_entry?-instance-method","name":"error_mrm_duplicate_entry?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2155,"url":null},"def":{"name":"error_mrm_duplicate_entry?","visibility":"Public","body":"self == ERROR_MRM_DUPLICATE_ENTRY"}},{"html_id":"error_mrm_duplicate_map_name?-instance-method","name":"error_mrm_duplicate_map_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2154,"url":null},"def":{"name":"error_mrm_duplicate_map_name?","visibility":"Public","body":"self == ERROR_MRM_DUPLICATE_MAP_NAME"}},{"html_id":"error_mrm_filepath_too_long?-instance-method","name":"error_mrm_filepath_too_long?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2157,"url":null},"def":{"name":"error_mrm_filepath_too_long?","visibility":"Public","body":"self == ERROR_MRM_FILEPATH_TOO_LONG"}},{"html_id":"error_mrm_indeterminate_qualifier_value?-instance-method","name":"error_mrm_indeterminate_qualifier_value?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2164,"url":null},"def":{"name":"error_mrm_indeterminate_qualifier_value?","visibility":"Public","body":"self == ERROR_MRM_INDETERMINATE_QUALIFIER_VALUE"}},{"html_id":"error_mrm_invalid_file_type?-instance-method","name":"error_mrm_invalid_file_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2148,"url":null},"def":{"name":"error_mrm_invalid_file_type?","visibility":"Public","body":"self == ERROR_MRM_INVALID_FILE_TYPE"}},{"html_id":"error_mrm_invalid_pri_file?-instance-method","name":"error_mrm_invalid_pri_file?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2159,"url":null},"def":{"name":"error_mrm_invalid_pri_file?","visibility":"Public","body":"self == ERROR_MRM_INVALID_PRI_FILE"}},{"html_id":"error_mrm_invalid_priconfig?-instance-method","name":"error_mrm_invalid_priconfig?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2147,"url":null},"def":{"name":"error_mrm_invalid_priconfig?","visibility":"Public","body":"self == ERROR_MRM_INVALID_PRICONFIG"}},{"html_id":"error_mrm_invalid_qualifier_operator?-instance-method","name":"error_mrm_invalid_qualifier_operator?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2163,"url":null},"def":{"name":"error_mrm_invalid_qualifier_operator?","visibility":"Public","body":"self == ERROR_MRM_INVALID_QUALIFIER_OPERATOR"}},{"html_id":"error_mrm_invalid_qualifier_value?-instance-method","name":"error_mrm_invalid_qualifier_value?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2150,"url":null},"def":{"name":"error_mrm_invalid_qualifier_value?","visibility":"Public","body":"self == ERROR_MRM_INVALID_QUALIFIER_VALUE"}},{"html_id":"error_mrm_invalid_resource_identifier?-instance-method","name":"error_mrm_invalid_resource_identifier?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2156,"url":null},"def":{"name":"error_mrm_invalid_resource_identifier?","visibility":"Public","body":"self == ERROR_MRM_INVALID_RESOURCE_IDENTIFIER"}},{"html_id":"error_mrm_map_not_found?-instance-method","name":"error_mrm_map_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2161,"url":null},"def":{"name":"error_mrm_map_not_found?","visibility":"Public","body":"self == ERROR_MRM_MAP_NOT_FOUND"}},{"html_id":"error_mrm_named_resource_not_found?-instance-method","name":"error_mrm_named_resource_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2160,"url":null},"def":{"name":"error_mrm_named_resource_not_found?","visibility":"Public","body":"self == ERROR_MRM_NAMED_RESOURCE_NOT_FOUND"}},{"html_id":"error_mrm_no_candidate?-instance-method","name":"error_mrm_no_candidate?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2151,"url":null},"def":{"name":"error_mrm_no_candidate?","visibility":"Public","body":"self == ERROR_MRM_NO_CANDIDATE"}},{"html_id":"error_mrm_no_match_or_default_candidate?-instance-method","name":"error_mrm_no_match_or_default_candidate?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2152,"url":null},"def":{"name":"error_mrm_no_match_or_default_candidate?","visibility":"Public","body":"self == ERROR_MRM_NO_MATCH_OR_DEFAULT_CANDIDATE"}},{"html_id":"error_mrm_resource_type_mismatch?-instance-method","name":"error_mrm_resource_type_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2153,"url":null},"def":{"name":"error_mrm_resource_type_mismatch?","visibility":"Public","body":"self == ERROR_MRM_RESOURCE_TYPE_MISMATCH"}},{"html_id":"error_mrm_runtime_no_default_or_neutral_resource?-instance-method","name":"error_mrm_runtime_no_default_or_neutral_resource?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2146,"url":null},"def":{"name":"error_mrm_runtime_no_default_or_neutral_resource?","visibility":"Public","body":"self == ERROR_MRM_RUNTIME_NO_DEFAULT_OR_NEUTRAL_RESOURCE"}},{"html_id":"error_mrm_too_many_resources?-instance-method","name":"error_mrm_too_many_resources?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2166,"url":null},"def":{"name":"error_mrm_too_many_resources?","visibility":"Public","body":"self == ERROR_MRM_TOO_MANY_RESOURCES"}},{"html_id":"error_mrm_unknown_qualifier?-instance-method","name":"error_mrm_unknown_qualifier?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2149,"url":null},"def":{"name":"error_mrm_unknown_qualifier?","visibility":"Public","body":"self == ERROR_MRM_UNKNOWN_QUALIFIER"}},{"html_id":"error_mrm_unsupported_directory_type?-instance-method","name":"error_mrm_unsupported_directory_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2158,"url":null},"def":{"name":"error_mrm_unsupported_directory_type?","visibility":"Public","body":"self == ERROR_MRM_UNSUPPORTED_DIRECTORY_TYPE"}},{"html_id":"error_mrm_unsupported_profile_type?-instance-method","name":"error_mrm_unsupported_profile_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2162,"url":null},"def":{"name":"error_mrm_unsupported_profile_type?","visibility":"Public","body":"self == ERROR_MRM_UNSUPPORTED_PROFILE_TYPE"}},{"html_id":"error_mui_file_not_found?-instance-method","name":"error_mui_file_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2137,"url":null},"def":{"name":"error_mui_file_not_found?","visibility":"Public","body":"self == ERROR_MUI_FILE_NOT_FOUND"}},{"html_id":"error_mui_file_not_loaded?-instance-method","name":"error_mui_file_not_loaded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2142,"url":null},"def":{"name":"error_mui_file_not_loaded?","visibility":"Public","body":"self == ERROR_MUI_FILE_NOT_LOADED"}},{"html_id":"error_mui_intlsettings_invalid_locale_name?-instance-method","name":"error_mui_intlsettings_invalid_locale_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2145,"url":null},"def":{"name":"error_mui_intlsettings_invalid_locale_name?","visibility":"Public","body":"self == ERROR_MUI_INTLSETTINGS_INVALID_LOCALE_NAME"}},{"html_id":"error_mui_intlsettings_uilang_not_installed?-instance-method","name":"error_mui_intlsettings_uilang_not_installed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2144,"url":null},"def":{"name":"error_mui_intlsettings_uilang_not_installed?","visibility":"Public","body":"self == ERROR_MUI_INTLSETTINGS_UILANG_NOT_INSTALLED"}},{"html_id":"error_mui_invalid_file?-instance-method","name":"error_mui_invalid_file?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2138,"url":null},"def":{"name":"error_mui_invalid_file?","visibility":"Public","body":"self == ERROR_MUI_INVALID_FILE"}},{"html_id":"error_mui_invalid_locale_name?-instance-method","name":"error_mui_invalid_locale_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2140,"url":null},"def":{"name":"error_mui_invalid_locale_name?","visibility":"Public","body":"self == ERROR_MUI_INVALID_LOCALE_NAME"}},{"html_id":"error_mui_invalid_rc_config?-instance-method","name":"error_mui_invalid_rc_config?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2139,"url":null},"def":{"name":"error_mui_invalid_rc_config?","visibility":"Public","body":"self == ERROR_MUI_INVALID_RC_CONFIG"}},{"html_id":"error_mui_invalid_ultimatefallback_name?-instance-method","name":"error_mui_invalid_ultimatefallback_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2141,"url":null},"def":{"name":"error_mui_invalid_ultimatefallback_name?","visibility":"Public","body":"self == ERROR_MUI_INVALID_ULTIMATEFALLBACK_NAME"}},{"html_id":"error_mutual_auth_failed?-instance-method","name":"error_mutual_auth_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":679,"url":null},"def":{"name":"error_mutual_auth_failed?","visibility":"Public","body":"self == ERROR_MUTUAL_AUTH_FAILED"}},{"html_id":"error_needs_remediation?-instance-method","name":"error_needs_remediation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2205,"url":null},"def":{"name":"error_needs_remediation?","visibility":"Public","body":"self == ERROR_NEEDS_REMEDIATION"}},{"html_id":"error_negative_seek?-instance-method","name":"error_negative_seek?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":256,"url":null},"def":{"name":"error_negative_seek?","visibility":"Public","body":"self == ERROR_NEGATIVE_SEEK"}},{"html_id":"error_nesting_not_allowed?-instance-method","name":"error_nesting_not_allowed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":322,"url":null},"def":{"name":"error_nesting_not_allowed?","visibility":"Public","body":"self == ERROR_NESTING_NOT_ALLOWED"}},{"html_id":"error_net_write_fault?-instance-method","name":"error_net_write_fault?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":225,"url":null},"def":{"name":"error_net_write_fault?","visibility":"Public","body":"self == ERROR_NET_WRITE_FAULT"}},{"html_id":"error_netlogon_not_started?-instance-method","name":"error_netlogon_not_started?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":882,"url":null},"def":{"name":"error_netlogon_not_started?","visibility":"Public","body":"self == ERROR_NETLOGON_NOT_STARTED"}},{"html_id":"error_netname_deleted?-instance-method","name":"error_netname_deleted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":209,"url":null},"def":{"name":"error_netname_deleted?","visibility":"Public","body":"self == ERROR_NETNAME_DELETED"}},{"html_id":"error_network_access_denied?-instance-method","name":"error_network_access_denied?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":210,"url":null},"def":{"name":"error_network_access_denied?","visibility":"Public","body":"self == ERROR_NETWORK_ACCESS_DENIED"}},{"html_id":"error_network_busy?-instance-method","name":"error_network_busy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":199,"url":null},"def":{"name":"error_network_busy?","visibility":"Public","body":"self == ERROR_NETWORK_BUSY"}},{"html_id":"error_network_not_available?-instance-method","name":"error_network_not_available?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1111,"url":null},"def":{"name":"error_network_not_available?","visibility":"Public","body":"self == ERROR_NETWORK_NOT_AVAILABLE"}},{"html_id":"error_network_unreachable?-instance-method","name":"error_network_unreachable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":532,"url":null},"def":{"name":"error_network_unreachable?","visibility":"Public","body":"self == ERROR_NETWORK_UNREACHABLE"}},{"html_id":"error_no_association?-instance-method","name":"error_no_association?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":475,"url":null},"def":{"name":"error_no_association?","visibility":"Public","body":"self == ERROR_NO_ASSOCIATION"}},{"html_id":"error_no_browser_servers_found?-instance-method","name":"error_no_browser_servers_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1198,"url":null},"def":{"name":"error_no_browser_servers_found?","visibility":"Public","body":"self == ERROR_NO_BROWSER_SERVERS_FOUND"}},{"html_id":"error_no_data?-instance-method","name":"error_no_data?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":334,"url":null},"def":{"name":"error_no_data?","visibility":"Public","body":"self == ERROR_NO_DATA"}},{"html_id":"error_no_data_detected?-instance-method","name":"error_no_data_detected?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":438,"url":null},"def":{"name":"error_no_data_detected?","visibility":"Public","body":"self == ERROR_NO_DATA_DETECTED"}},{"html_id":"error_no_efs?-instance-method","name":"error_no_efs?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1185,"url":null},"def":{"name":"error_no_efs?","visibility":"Public","body":"self == ERROR_NO_EFS"}},{"html_id":"error_no_impersonation_token?-instance-method","name":"error_no_impersonation_token?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":592,"url":null},"def":{"name":"error_no_impersonation_token?","visibility":"Public","body":"self == ERROR_NO_IMPERSONATION_TOKEN"}},{"html_id":"error_no_inheritance?-instance-method","name":"error_no_inheritance?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":673,"url":null},"def":{"name":"error_no_inheritance?","visibility":"Public","body":"self == ERROR_NO_INHERITANCE"}},{"html_id":"error_no_log_space?-instance-method","name":"error_no_log_space?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":396,"url":null},"def":{"name":"error_no_log_space?","visibility":"Public","body":"self == ERROR_NO_LOG_SPACE"}},{"html_id":"error_no_logon_servers?-instance-method","name":"error_no_logon_servers?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":594,"url":null},"def":{"name":"error_no_logon_servers?","visibility":"Public","body":"self == ERROR_NO_LOGON_SERVERS"}},{"html_id":"error_no_match?-instance-method","name":"error_no_match?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":489,"url":null},"def":{"name":"error_no_match?","visibility":"Public","body":"self == ERROR_NO_MATCH"}},{"html_id":"error_no_media_in_drive?-instance-method","name":"error_no_media_in_drive?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":446,"url":null},"def":{"name":"error_no_media_in_drive?","visibility":"Public","body":"self == ERROR_NO_MEDIA_IN_DRIVE"}},{"html_id":"error_no_more_devices?-instance-method","name":"error_no_more_devices?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":549,"url":null},"def":{"name":"error_no_more_devices?","visibility":"Public","body":"self == ERROR_NO_MORE_DEVICES"}},{"html_id":"error_no_more_files?-instance-method","name":"error_no_more_files?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":175,"url":null},"def":{"name":"error_no_more_files?","visibility":"Public","body":"self == ERROR_NO_MORE_FILES"}},{"html_id":"error_no_more_items?-instance-method","name":"error_no_more_items?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":341,"url":null},"def":{"name":"error_no_more_items?","visibility":"Public","body":"self == ERROR_NO_MORE_ITEMS"}},{"html_id":"error_no_more_search_handles?-instance-method","name":"error_no_more_search_handles?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":240,"url":null},"def":{"name":"error_no_more_search_handles?","visibility":"Public","body":"self == ERROR_NO_MORE_SEARCH_HANDLES"}},{"html_id":"error_no_more_user_handles?-instance-method","name":"error_no_more_user_handles?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":478,"url":null},"def":{"name":"error_no_more_user_handles?","visibility":"Public","body":"self == ERROR_NO_MORE_USER_HANDLES"}},{"html_id":"error_no_net_or_bad_path?-instance-method","name":"error_no_net_or_bad_path?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":504,"url":null},"def":{"name":"error_no_net_or_bad_path?","visibility":"Public","body":"self == ERROR_NO_NET_OR_BAD_PATH"}},{"html_id":"error_no_network?-instance-method","name":"error_no_network?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":523,"url":null},"def":{"name":"error_no_network?","visibility":"Public","body":"self == ERROR_NO_NETWORK"}},{"html_id":"error_no_proc_slots?-instance-method","name":"error_no_proc_slots?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":226,"url":null},"def":{"name":"error_no_proc_slots?","visibility":"Public","body":"self == ERROR_NO_PROC_SLOTS"}},{"html_id":"error_no_promotion_active?-instance-method","name":"error_no_promotion_active?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1279,"url":null},"def":{"name":"error_no_promotion_active?","visibility":"Public","body":"self == ERROR_NO_PROMOTION_ACTIVE"}},{"html_id":"error_no_quotas_for_account?-instance-method","name":"error_no_quotas_for_account?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":585,"url":null},"def":{"name":"error_no_quotas_for_account?","visibility":"Public","body":"self == ERROR_NO_QUOTAS_FOR_ACCOUNT"}},{"html_id":"error_no_recovery_policy?-instance-method","name":"error_no_recovery_policy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1184,"url":null},"def":{"name":"error_no_recovery_policy?","visibility":"Public","body":"self == ERROR_NO_RECOVERY_POLICY"}},{"html_id":"error_no_recovery_program?-instance-method","name":"error_no_recovery_program?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":431,"url":null},"def":{"name":"error_no_recovery_program?","visibility":"Public","body":"self == ERROR_NO_RECOVERY_PROGRAM"}},{"html_id":"error_no_scrollbars?-instance-method","name":"error_no_scrollbars?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":729,"url":null},"def":{"name":"error_no_scrollbars?","visibility":"Public","body":"self == ERROR_NO_SCROLLBARS"}},{"html_id":"error_no_security_on_object?-instance-method","name":"error_no_security_on_object?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":632,"url":null},"def":{"name":"error_no_security_on_object?","visibility":"Public","body":"self == ERROR_NO_SECURITY_ON_OBJECT"}},{"html_id":"error_no_shutdown_in_progress?-instance-method","name":"error_no_shutdown_in_progress?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":450,"url":null},"def":{"name":"error_no_shutdown_in_progress?","visibility":"Public","body":"self == ERROR_NO_SHUTDOWN_IN_PROGRESS"}},{"html_id":"error_no_signal_sent?-instance-method","name":"error_no_signal_sent?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":314,"url":null},"def":{"name":"error_no_signal_sent?","visibility":"Public","body":"self == ERROR_NO_SIGNAL_SENT"}},{"html_id":"error_no_sitename?-instance-method","name":"error_no_sitename?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":944,"url":null},"def":{"name":"error_no_sitename?","visibility":"Public","body":"self == ERROR_NO_SITENAME"}},{"html_id":"error_no_spool_space?-instance-method","name":"error_no_spool_space?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":207,"url":null},"def":{"name":"error_no_spool_space?","visibility":"Public","body":"self == ERROR_NO_SPOOL_SPACE"}},{"html_id":"error_no_such_alias?-instance-method","name":"error_no_such_alias?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":658,"url":null},"def":{"name":"error_no_such_alias?","visibility":"Public","body":"self == ERROR_NO_SUCH_ALIAS"}},{"html_id":"error_no_such_domain?-instance-method","name":"error_no_such_domain?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":637,"url":null},"def":{"name":"error_no_such_domain?","visibility":"Public","body":"self == ERROR_NO_SUCH_DOMAIN"}},{"html_id":"error_no_such_group?-instance-method","name":"error_no_such_group?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":602,"url":null},"def":{"name":"error_no_such_group?","visibility":"Public","body":"self == ERROR_NO_SUCH_GROUP"}},{"html_id":"error_no_such_logon_session?-instance-method","name":"error_no_such_logon_session?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":595,"url":null},"def":{"name":"error_no_such_logon_session?","visibility":"Public","body":"self == ERROR_NO_SUCH_LOGON_SESSION"}},{"html_id":"error_no_such_member?-instance-method","name":"error_no_such_member?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":669,"url":null},"def":{"name":"error_no_such_member?","visibility":"Public","body":"self == ERROR_NO_SUCH_MEMBER"}},{"html_id":"error_no_such_package?-instance-method","name":"error_no_such_package?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":646,"url":null},"def":{"name":"error_no_such_package?","visibility":"Public","body":"self == ERROR_NO_SUCH_PACKAGE"}},{"html_id":"error_no_such_privilege?-instance-method","name":"error_no_such_privilege?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":596,"url":null},"def":{"name":"error_no_such_privilege?","visibility":"Public","body":"self == ERROR_NO_SUCH_PRIVILEGE"}},{"html_id":"error_no_such_site?-instance-method","name":"error_no_such_site?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":550,"url":null},"def":{"name":"error_no_such_site?","visibility":"Public","body":"self == ERROR_NO_SUCH_SITE"}},{"html_id":"error_no_such_user?-instance-method","name":"error_no_such_user?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":600,"url":null},"def":{"name":"error_no_such_user?","visibility":"Public","body":"self == ERROR_NO_SUCH_USER"}},{"html_id":"error_no_supporting_drives?-instance-method","name":"error_no_supporting_drives?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1065,"url":null},"def":{"name":"error_no_supporting_drives?","visibility":"Public","body":"self == ERROR_NO_SUPPORTING_DRIVES"}},{"html_id":"error_no_system_menu?-instance-method","name":"error_no_system_menu?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":719,"url":null},"def":{"name":"error_no_system_menu?","visibility":"Public","body":"self == ERROR_NO_SYSTEM_MENU"}},{"html_id":"error_no_system_resources?-instance-method","name":"error_no_system_resources?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":732,"url":null},"def":{"name":"error_no_system_resources?","visibility":"Public","body":"self == ERROR_NO_SYSTEM_RESOURCES"}},{"html_id":"error_no_token?-instance-method","name":"error_no_token?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":385,"url":null},"def":{"name":"error_no_token?","visibility":"Public","body":"self == ERROR_NO_TOKEN"}},{"html_id":"error_no_tracking_service?-instance-method","name":"error_no_tracking_service?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":492,"url":null},"def":{"name":"error_no_tracking_service?","visibility":"Public","body":"self == ERROR_NO_TRACKING_SERVICE"}},{"html_id":"error_no_trust_lsa_secret?-instance-method","name":"error_no_trust_lsa_secret?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":876,"url":null},"def":{"name":"error_no_trust_lsa_secret?","visibility":"Public","body":"self == ERROR_NO_TRUST_LSA_SECRET"}},{"html_id":"error_no_trust_sam_account?-instance-method","name":"error_no_trust_sam_account?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":877,"url":null},"def":{"name":"error_no_trust_sam_account?","visibility":"Public","body":"self == ERROR_NO_TRUST_SAM_ACCOUNT"}},{"html_id":"error_no_unicode_translation?-instance-method","name":"error_no_unicode_translation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":447,"url":null},"def":{"name":"error_no_unicode_translation?","visibility":"Public","body":"self == ERROR_NO_UNICODE_TRANSLATION"}},{"html_id":"error_no_user_keys?-instance-method","name":"error_no_user_keys?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1187,"url":null},"def":{"name":"error_no_user_keys?","visibility":"Public","body":"self == ERROR_NO_USER_KEYS"}},{"html_id":"error_no_user_session_key?-instance-method","name":"error_no_user_session_key?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":676,"url":null},"def":{"name":"error_no_user_session_key?","visibility":"Public","body":"self == ERROR_NO_USER_SESSION_KEY"}},{"html_id":"error_no_volume_id?-instance-method","name":"error_no_volume_id?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":493,"url":null},"def":{"name":"error_no_volume_id?","visibility":"Public","body":"self == ERROR_NO_VOLUME_ID"}},{"html_id":"error_no_volume_label?-instance-method","name":"error_no_volume_label?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":250,"url":null},"def":{"name":"error_no_volume_label?","visibility":"Public","body":"self == ERROR_NO_VOLUME_LABEL"}},{"html_id":"error_no_wildcard_characters?-instance-method","name":"error_no_wildcard_characters?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":699,"url":null},"def":{"name":"error_no_wildcard_characters?","visibility":"Public","body":"self == ERROR_NO_WILDCARD_CHARACTERS"}},{"html_id":"error_noaccess?-instance-method","name":"error_noaccess?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":376,"url":null},"def":{"name":"error_noaccess?","visibility":"Public","body":"self == ERROR_NOACCESS"}},{"html_id":"error_node_cannot_be_clustered?-instance-method","name":"error_node_cannot_be_clustered?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1173,"url":null},"def":{"name":"error_node_cannot_be_clustered?","visibility":"Public","body":"self == ERROR_NODE_CANNOT_BE_CLUSTERED"}},{"html_id":"error_node_cant_host_resource?-instance-method","name":"error_node_cant_host_resource?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1146,"url":null},"def":{"name":"error_node_cant_host_resource?","visibility":"Public","body":"self == ERROR_NODE_CANT_HOST_RESOURCE"}},{"html_id":"error_node_not_available?-instance-method","name":"error_node_not_available?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1112,"url":null},"def":{"name":"error_node_not_available?","visibility":"Public","body":"self == ERROR_NODE_NOT_AVAILABLE"}},{"html_id":"error_nologon_interdomain_trust_account?-instance-method","name":"error_nologon_interdomain_trust_account?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":897,"url":null},"def":{"name":"error_nologon_interdomain_trust_account?","visibility":"Public","body":"self == ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT"}},{"html_id":"error_nologon_server_trust_account?-instance-method","name":"error_nologon_server_trust_account?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":899,"url":null},"def":{"name":"error_nologon_server_trust_account?","visibility":"Public","body":"self == ERROR_NOLOGON_SERVER_TRUST_ACCOUNT"}},{"html_id":"error_nologon_workstation_trust_account?-instance-method","name":"error_nologon_workstation_trust_account?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":898,"url":null},"def":{"name":"error_nologon_workstation_trust_account?","visibility":"Public","body":"self == ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT"}},{"html_id":"error_non_account_sid?-instance-method","name":"error_non_account_sid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":558,"url":null},"def":{"name":"error_non_account_sid?","visibility":"Public","body":"self == ERROR_NON_ACCOUNT_SID"}},{"html_id":"error_non_domain_sid?-instance-method","name":"error_non_domain_sid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":559,"url":null},"def":{"name":"error_non_domain_sid?","visibility":"Public","body":"self == ERROR_NON_DOMAIN_SID"}},{"html_id":"error_non_mdichild_window?-instance-method","name":"error_non_mdichild_window?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":727,"url":null},"def":{"name":"error_non_mdichild_window?","visibility":"Public","body":"self == ERROR_NON_MDICHILD_WINDOW"}},{"html_id":"error_none_mapped?-instance-method","name":"error_none_mapped?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":615,"url":null},"def":{"name":"error_none_mapped?","visibility":"Public","body":"self == ERROR_NONE_MAPPED"}},{"html_id":"error_nonpaged_system_resources?-instance-method","name":"error_nonpaged_system_resources?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":733,"url":null},"def":{"name":"error_nonpaged_system_resources?","visibility":"Public","body":"self == ERROR_NONPAGED_SYSTEM_RESOURCES"}},{"html_id":"error_not_a_reparse_point?-instance-method","name":"error_not_a_reparse_point?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1071,"url":null},"def":{"name":"error_not_a_reparse_point?","visibility":"Public","body":"self == ERROR_NOT_A_REPARSE_POINT"}},{"html_id":"error_not_all_assigned?-instance-method","name":"error_not_all_assigned?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":583,"url":null},"def":{"name":"error_not_all_assigned?","visibility":"Public","body":"self == ERROR_NOT_ALL_ASSIGNED"}},{"html_id":"error_not_authenticated?-instance-method","name":"error_not_authenticated?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":545,"url":null},"def":{"name":"error_not_authenticated?","visibility":"Public","body":"self == ERROR_NOT_AUTHENTICATED"}},{"html_id":"error_not_child_window?-instance-method","name":"error_not_child_window?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":724,"url":null},"def":{"name":"error_not_child_window?","visibility":"Public","body":"self == ERROR_NOT_CHILD_WINDOW"}},{"html_id":"error_not_connected?-instance-method","name":"error_not_connected?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":984,"url":null},"def":{"name":"error_not_connected?","visibility":"Public","body":"self == ERROR_NOT_CONNECTED"}},{"html_id":"error_not_container?-instance-method","name":"error_not_container?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":508,"url":null},"def":{"name":"error_not_container?","visibility":"Public","body":"self == ERROR_NOT_CONTAINER"}},{"html_id":"error_not_dos_disk?-instance-method","name":"error_not_dos_disk?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":183,"url":null},"def":{"name":"error_not_dos_disk?","visibility":"Public","body":"self == ERROR_NOT_DOS_DISK"}},{"html_id":"error_not_empty?-instance-method","name":"error_not_empty?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1033,"url":null},"def":{"name":"error_not_empty?","visibility":"Public","body":"self == ERROR_NOT_EMPTY"}},{"html_id":"error_not_enough_memory?-instance-method","name":"error_not_enough_memory?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":165,"url":null},"def":{"name":"error_not_enough_memory?","visibility":"Public","body":"self == ERROR_NOT_ENOUGH_MEMORY"}},{"html_id":"error_not_enough_quota?-instance-method","name":"error_not_enough_quota?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":906,"url":null},"def":{"name":"error_not_enough_quota?","visibility":"Public","body":"self == ERROR_NOT_ENOUGH_QUOTA"}},{"html_id":"error_not_enough_server_memory?-instance-method","name":"error_not_enough_server_memory?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":464,"url":null},"def":{"name":"error_not_enough_server_memory?","visibility":"Public","body":"self == ERROR_NOT_ENOUGH_SERVER_MEMORY"}},{"html_id":"error_not_export_format?-instance-method","name":"error_not_export_format?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1189,"url":null},"def":{"name":"error_not_export_format?","visibility":"Public","body":"self == ERROR_NOT_EXPORT_FORMAT"}},{"html_id":"error_not_found?-instance-method","name":"error_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":488,"url":null},"def":{"name":"error_not_found?","visibility":"Public","body":"self == ERROR_NOT_FOUND"}},{"html_id":"error_not_joined?-instance-method","name":"error_not_joined?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":261,"url":null},"def":{"name":"error_not_joined?","visibility":"Public","body":"self == ERROR_NOT_JOINED"}},{"html_id":"error_not_locked?-instance-method","name":"error_not_locked?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":283,"url":null},"def":{"name":"error_not_locked?","visibility":"Public","body":"self == ERROR_NOT_LOCKED"}},{"html_id":"error_not_logged_on?-instance-method","name":"error_not_logged_on?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":546,"url":null},"def":{"name":"error_not_logged_on?","visibility":"Public","body":"self == ERROR_NOT_LOGGED_ON"}},{"html_id":"error_not_logon_process?-instance-method","name":"error_not_logon_process?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":644,"url":null},"def":{"name":"error_not_logon_process?","visibility":"Public","body":"self == ERROR_NOT_LOGON_PROCESS"}},{"html_id":"error_not_owner?-instance-method","name":"error_not_owner?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":349,"url":null},"def":{"name":"error_not_owner?","visibility":"Public","body":"self == ERROR_NOT_OWNER"}},{"html_id":"error_not_quorum_capable?-instance-method","name":"error_not_quorum_capable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1097,"url":null},"def":{"name":"error_not_quorum_capable?","visibility":"Public","body":"self == ERROR_NOT_QUORUM_CAPABLE"}},{"html_id":"error_not_quorum_class?-instance-method","name":"error_not_quorum_class?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1101,"url":null},"def":{"name":"error_not_quorum_class?","visibility":"Public","body":"self == ERROR_NOT_QUORUM_CLASS"}},{"html_id":"error_not_ready?-instance-method","name":"error_not_ready?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":178,"url":null},"def":{"name":"error_not_ready?","visibility":"Public","body":"self == ERROR_NOT_READY"}},{"html_id":"error_not_registry_file?-instance-method","name":"error_not_registry_file?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":394,"url":null},"def":{"name":"error_not_registry_file?","visibility":"Public","body":"self == ERROR_NOT_REGISTRY_FILE"}},{"html_id":"error_not_safeboot_service?-instance-method","name":"error_not_safeboot_service?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":433,"url":null},"def":{"name":"error_not_safeboot_service?","visibility":"Public","body":"self == ERROR_NOT_SAFEBOOT_SERVICE"}},{"html_id":"error_not_same_device?-instance-method","name":"error_not_same_device?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":174,"url":null},"def":{"name":"error_not_same_device?","visibility":"Public","body":"self == ERROR_NOT_SAME_DEVICE"}},{"html_id":"error_not_substed?-instance-method","name":"error_not_substed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":262,"url":null},"def":{"name":"error_not_substed?","visibility":"Public","body":"self == ERROR_NOT_SUBSTED"}},{"html_id":"error_not_supported?-instance-method","name":"error_not_supported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":195,"url":null},"def":{"name":"error_not_supported?","visibility":"Public","body":"self == ERROR_NOT_SUPPORTED"}},{"html_id":"error_not_supported_on_sbs?-instance-method","name":"error_not_supported_on_sbs?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":555,"url":null},"def":{"name":"error_not_supported_on_sbs?","visibility":"Public","body":"self == ERROR_NOT_SUPPORTED_ON_SBS"}},{"html_id":"error_not_supported_on_standard_server?-instance-method","name":"error_not_supported_on_standard_server?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1601,"url":null},"def":{"name":"error_not_supported_on_standard_server?","visibility":"Public","body":"self == ERROR_NOT_SUPPORTED_ON_STANDARD_SERVER"}},{"html_id":"error_notify_enum_dir?-instance-method","name":"error_notify_enum_dir?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":399,"url":null},"def":{"name":"error_notify_enum_dir?","visibility":"Public","body":"self == ERROR_NOTIFY_ENUM_DIR"}},{"html_id":"error_nt_cross_encryption_required?-instance-method","name":"error_nt_cross_encryption_required?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":668,"url":null},"def":{"name":"error_nt_cross_encryption_required?","visibility":"Public","body":"self == ERROR_NT_CROSS_ENCRYPTION_REQUIRED"}},{"html_id":"error_null_lm_password?-instance-method","name":"error_null_lm_password?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":587,"url":null},"def":{"name":"error_null_lm_password?","visibility":"Public","body":"self == ERROR_NULL_LM_PASSWORD"}},{"html_id":"error_object_already_exists?-instance-method","name":"error_object_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1086,"url":null},"def":{"name":"error_object_already_exists?","visibility":"Public","body":"self == ERROR_OBJECT_ALREADY_EXISTS"}},{"html_id":"error_object_in_list?-instance-method","name":"error_object_in_list?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1087,"url":null},"def":{"name":"error_object_in_list?","visibility":"Public","body":"self == ERROR_OBJECT_IN_LIST"}},{"html_id":"error_object_not_found?-instance-method","name":"error_object_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1038,"url":null},"def":{"name":"error_object_not_found?","visibility":"Public","body":"self == ERROR_OBJECT_NOT_FOUND"}},{"html_id":"error_old_win_version?-instance-method","name":"error_old_win_version?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":470,"url":null},"def":{"name":"error_old_win_version?","visibility":"Public","body":"self == ERROR_OLD_WIN_VERSION"}},{"html_id":"error_only_if_connected?-instance-method","name":"error_only_if_connected?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":552,"url":null},"def":{"name":"error_only_if_connected?","visibility":"Public","body":"self == ERROR_ONLY_IF_CONNECTED"}},{"html_id":"error_open_failed?-instance-method","name":"error_open_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":237,"url":null},"def":{"name":"error_open_failed?","visibility":"Public","body":"self == ERROR_OPEN_FAILED"}},{"html_id":"error_open_files?-instance-method","name":"error_open_files?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":985,"url":null},"def":{"name":"error_open_files?","visibility":"Public","body":"self == ERROR_OPEN_FILES"}},{"html_id":"error_operation_aborted?-instance-method","name":"error_operation_aborted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":373,"url":null},"def":{"name":"error_operation_aborted?","visibility":"Public","body":"self == ERROR_OPERATION_ABORTED"}},{"html_id":"error_oplock_not_granted?-instance-method","name":"error_oplock_not_granted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":352,"url":null},"def":{"name":"error_oplock_not_granted?","visibility":"Public","body":"self == ERROR_OPLOCK_NOT_GRANTED"}},{"html_id":"error_out_of_paper?-instance-method","name":"error_out_of_paper?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":185,"url":null},"def":{"name":"error_out_of_paper?","visibility":"Public","body":"self == ERROR_OUT_OF_PAPER"}},{"html_id":"error_out_of_structures?-instance-method","name":"error_out_of_structures?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":221,"url":null},"def":{"name":"error_out_of_structures?","visibility":"Public","body":"self == ERROR_OUT_OF_STRUCTURES"}},{"html_id":"error_outofmemory?-instance-method","name":"error_outofmemory?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":171,"url":null},"def":{"name":"error_outofmemory?","visibility":"Public","body":"self == ERROR_OUTOFMEMORY"}},{"html_id":"error_override_nochanges?-instance-method","name":"error_override_nochanges?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":553,"url":null},"def":{"name":"error_override_nochanges?","visibility":"Public","body":"self == ERROR_OVERRIDE_NOCHANGES"}},{"html_id":"error_package_already_exists?-instance-method","name":"error_package_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2204,"url":null},"def":{"name":"error_package_already_exists?","visibility":"Public","body":"self == ERROR_PACKAGE_ALREADY_EXISTS"}},{"html_id":"error_package_repository_corrupted?-instance-method","name":"error_package_repository_corrupted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2207,"url":null},"def":{"name":"error_package_repository_corrupted?","visibility":"Public","body":"self == ERROR_PACKAGE_REPOSITORY_CORRUPTED"}},{"html_id":"error_package_updating?-instance-method","name":"error_package_updating?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2209,"url":null},"def":{"name":"error_package_updating?","visibility":"Public","body":"self == ERROR_PACKAGE_UPDATING"}},{"html_id":"error_packages_in_use?-instance-method","name":"error_packages_in_use?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2211,"url":null},"def":{"name":"error_packages_in_use?","visibility":"Public","body":"self == ERROR_PACKAGES_IN_USE"}},{"html_id":"error_paged_system_resources?-instance-method","name":"error_paged_system_resources?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":734,"url":null},"def":{"name":"error_paged_system_resources?","visibility":"Public","body":"self == ERROR_PAGED_SYSTEM_RESOURCES"}},{"html_id":"error_pagefile_quota?-instance-method","name":"error_pagefile_quota?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":736,"url":null},"def":{"name":"error_pagefile_quota?","visibility":"Public","body":"self == ERROR_PAGEFILE_QUOTA"}},{"html_id":"error_parameter_quota_exceeded?-instance-method","name":"error_parameter_quota_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":578,"url":null},"def":{"name":"error_parameter_quota_exceeded?","visibility":"Public","body":"self == ERROR_PARAMETER_QUOTA_EXCEEDED"}},{"html_id":"error_partial_copy?-instance-method","name":"error_partial_copy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":351,"url":null},"def":{"name":"error_partial_copy?","visibility":"Public","body":"self == ERROR_PARTIAL_COPY"}},{"html_id":"error_partition_failure?-instance-method","name":"error_partition_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":439,"url":null},"def":{"name":"error_partition_failure?","visibility":"Public","body":"self == ERROR_PARTITION_FAILURE"}},{"html_id":"error_password_expired?-instance-method","name":"error_password_expired?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":613,"url":null},"def":{"name":"error_password_expired?","visibility":"Public","body":"self == ERROR_PASSWORD_EXPIRED"}},{"html_id":"error_password_must_change?-instance-method","name":"error_password_must_change?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":932,"url":null},"def":{"name":"error_password_must_change?","visibility":"Public","body":"self == ERROR_PASSWORD_MUST_CHANGE"}},{"html_id":"error_password_restriction?-instance-method","name":"error_password_restriction?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":608,"url":null},"def":{"name":"error_password_restriction?","visibility":"Public","body":"self == ERROR_PASSWORD_RESTRICTION"}},{"html_id":"error_patch_package_invalid?-instance-method","name":"error_patch_package_invalid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":784,"url":null},"def":{"name":"error_patch_package_invalid?","visibility":"Public","body":"self == ERROR_PATCH_PACKAGE_INVALID"}},{"html_id":"error_patch_package_open_failed?-instance-method","name":"error_patch_package_open_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":783,"url":null},"def":{"name":"error_patch_package_open_failed?","visibility":"Public","body":"self == ERROR_PATCH_PACKAGE_OPEN_FAILED"}},{"html_id":"error_patch_package_rejected?-instance-method","name":"error_patch_package_rejected?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":791,"url":null},"def":{"name":"error_patch_package_rejected?","visibility":"Public","body":"self == ERROR_PATCH_PACKAGE_REJECTED"}},{"html_id":"error_patch_package_unsupported?-instance-method","name":"error_patch_package_unsupported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":785,"url":null},"def":{"name":"error_patch_package_unsupported?","visibility":"Public","body":"self == ERROR_PATCH_PACKAGE_UNSUPPORTED"}},{"html_id":"error_patch_target_not_found?-instance-method","name":"error_patch_target_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":790,"url":null},"def":{"name":"error_patch_target_not_found?","visibility":"Public","body":"self == ERROR_PATCH_TARGET_NOT_FOUND"}},{"html_id":"error_path_busy?-instance-method","name":"error_path_busy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":273,"url":null},"def":{"name":"error_path_busy?","visibility":"Public","body":"self == ERROR_PATH_BUSY"}},{"html_id":"error_path_not_found?-instance-method","name":"error_path_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":160,"url":null},"def":{"name":"error_path_not_found?","visibility":"Public","body":"self == ERROR_PATH_NOT_FOUND"}},{"html_id":"error_per_user_trust_quota_exceeded?-instance-method","name":"error_per_user_trust_quota_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":957,"url":null},"def":{"name":"error_per_user_trust_quota_exceeded?","visibility":"Public","body":"self == ERROR_PER_USER_TRUST_QUOTA_EXCEEDED"}},{"html_id":"error_pipe_busy?-instance-method","name":"error_pipe_busy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":333,"url":null},"def":{"name":"error_pipe_busy?","visibility":"Public","body":"self == ERROR_PIPE_BUSY"}},{"html_id":"error_pipe_connected?-instance-method","name":"error_pipe_connected?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":360,"url":null},"def":{"name":"error_pipe_connected?","visibility":"Public","body":"self == ERROR_PIPE_CONNECTED"}},{"html_id":"error_pipe_listening?-instance-method","name":"error_pipe_listening?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":361,"url":null},"def":{"name":"error_pipe_listening?","visibility":"Public","body":"self == ERROR_PIPE_LISTENING"}},{"html_id":"error_pipe_local?-instance-method","name":"error_pipe_local?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":331,"url":null},"def":{"name":"error_pipe_local?","visibility":"Public","body":"self == ERROR_PIPE_LOCAL"}},{"html_id":"error_pipe_not_connected?-instance-method","name":"error_pipe_not_connected?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":335,"url":null},"def":{"name":"error_pipe_not_connected?","visibility":"Public","body":"self == ERROR_PIPE_NOT_CONNECTED"}},{"html_id":"error_pkinit_failure?-instance-method","name":"error_pkinit_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":564,"url":null},"def":{"name":"error_pkinit_failure?","visibility":"Public","body":"self == ERROR_PKINIT_FAILURE"}},{"html_id":"error_point_not_found?-instance-method","name":"error_point_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":491,"url":null},"def":{"name":"error_point_not_found?","visibility":"Public","body":"self == ERROR_POINT_NOT_FOUND"}},{"html_id":"error_policy_object_not_found?-instance-method","name":"error_policy_object_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1276,"url":null},"def":{"name":"error_policy_object_not_found?","visibility":"Public","body":"self == ERROR_POLICY_OBJECT_NOT_FOUND"}},{"html_id":"error_policy_only_in_ds?-instance-method","name":"error_policy_only_in_ds?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1277,"url":null},"def":{"name":"error_policy_only_in_ds?","visibility":"Public","body":"self == ERROR_POLICY_ONLY_IN_DS"}},{"html_id":"error_popup_already_active?-instance-method","name":"error_popup_already_active?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":728,"url":null},"def":{"name":"error_popup_already_active?","visibility":"Public","body":"self == ERROR_POPUP_ALREADY_ACTIVE"}},{"html_id":"error_port_unreachable?-instance-method","name":"error_port_unreachable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":535,"url":null},"def":{"name":"error_port_unreachable?","visibility":"Public","body":"self == ERROR_PORT_UNREACHABLE"}},{"html_id":"error_possible_deadlock?-instance-method","name":"error_possible_deadlock?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":465,"url":null},"def":{"name":"error_possible_deadlock?","visibility":"Public","body":"self == ERROR_POSSIBLE_DEADLOCK"}},{"html_id":"error_potential_file_found?-instance-method","name":"error_potential_file_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":499,"url":null},"def":{"name":"error_potential_file_found?","visibility":"Public","body":"self == ERROR_POTENTIAL_FILE_FOUND"}},{"html_id":"error_print_cancelled?-instance-method","name":"error_print_cancelled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":208,"url":null},"def":{"name":"error_print_cancelled?","visibility":"Public","body":"self == ERROR_PRINT_CANCELLED"}},{"html_id":"error_print_monitor_already_installed?-instance-method","name":"error_print_monitor_already_installed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":994,"url":null},"def":{"name":"error_print_monitor_already_installed?","visibility":"Public","body":"self == ERROR_PRINT_MONITOR_ALREADY_INSTALLED"}},{"html_id":"error_print_monitor_in_use?-instance-method","name":"error_print_monitor_in_use?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":996,"url":null},"def":{"name":"error_print_monitor_in_use?","visibility":"Public","body":"self == ERROR_PRINT_MONITOR_IN_USE"}},{"html_id":"error_print_processor_already_installed?-instance-method","name":"error_print_processor_already_installed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":993,"url":null},"def":{"name":"error_print_processor_already_installed?","visibility":"Public","body":"self == ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED"}},{"html_id":"error_printer_already_exists?-instance-method","name":"error_printer_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":892,"url":null},"def":{"name":"error_printer_already_exists?","visibility":"Public","body":"self == ERROR_PRINTER_ALREADY_EXISTS"}},{"html_id":"error_printer_deleted?-instance-method","name":"error_printer_deleted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":930,"url":null},"def":{"name":"error_printer_deleted?","visibility":"Public","body":"self == ERROR_PRINTER_DELETED"}},{"html_id":"error_printer_driver_already_installed?-instance-method","name":"error_printer_driver_already_installed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":885,"url":null},"def":{"name":"error_printer_driver_already_installed?","visibility":"Public","body":"self == ERROR_PRINTER_DRIVER_ALREADY_INSTALLED"}},{"html_id":"error_printer_driver_blocked?-instance-method","name":"error_printer_driver_blocked?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1002,"url":null},"def":{"name":"error_printer_driver_blocked?","visibility":"Public","body":"self == ERROR_PRINTER_DRIVER_BLOCKED"}},{"html_id":"error_printer_driver_in_use?-instance-method","name":"error_printer_driver_in_use?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":989,"url":null},"def":{"name":"error_printer_driver_in_use?","visibility":"Public","body":"self == ERROR_PRINTER_DRIVER_IN_USE"}},{"html_id":"error_printer_driver_warned?-instance-method","name":"error_printer_driver_warned?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1001,"url":null},"def":{"name":"error_printer_driver_warned?","visibility":"Public","body":"self == ERROR_PRINTER_DRIVER_WARNED"}},{"html_id":"error_printer_has_jobs_queued?-instance-method","name":"error_printer_has_jobs_queued?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":997,"url":null},"def":{"name":"error_printer_has_jobs_queued?","visibility":"Public","body":"self == ERROR_PRINTER_HAS_JOBS_QUEUED"}},{"html_id":"error_printer_not_found?-instance-method","name":"error_printer_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1000,"url":null},"def":{"name":"error_printer_not_found?","visibility":"Public","body":"self == ERROR_PRINTER_NOT_FOUND"}},{"html_id":"error_printq_full?-instance-method","name":"error_printq_full?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":206,"url":null},"def":{"name":"error_printq_full?","visibility":"Public","body":"self == ERROR_PRINTQ_FULL"}},{"html_id":"error_private_dialog_index?-instance-method","name":"error_private_dialog_index?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":697,"url":null},"def":{"name":"error_private_dialog_index?","visibility":"Public","body":"self == ERROR_PRIVATE_DIALOG_INDEX"}},{"html_id":"error_privilege_not_held?-instance-method","name":"error_privilege_not_held?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":597,"url":null},"def":{"name":"error_privilege_not_held?","visibility":"Public","body":"self == ERROR_PRIVILEGE_NOT_HELD"}},{"html_id":"error_proc_not_found?-instance-method","name":"error_proc_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":252,"url":null},"def":{"name":"error_proc_not_found?","visibility":"Public","body":"self == ERROR_PROC_NOT_FOUND"}},{"html_id":"error_process_aborted?-instance-method","name":"error_process_aborted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":416,"url":null},"def":{"name":"error_process_aborted?","visibility":"Public","body":"self == ERROR_PROCESS_ABORTED"}},{"html_id":"error_product_uninstalled?-instance-method","name":"error_product_uninstalled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":762,"url":null},"def":{"name":"error_product_uninstalled?","visibility":"Public","body":"self == ERROR_PRODUCT_UNINSTALLED"}},{"html_id":"error_product_version?-instance-method","name":"error_product_version?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":786,"url":null},"def":{"name":"error_product_version?","visibility":"Public","body":"self == ERROR_PRODUCT_VERSION"}},{"html_id":"error_profile_not_associated_with_device?-instance-method","name":"error_profile_not_associated_with_device?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":973,"url":null},"def":{"name":"error_profile_not_associated_with_device?","visibility":"Public","body":"self == ERROR_PROFILE_NOT_ASSOCIATED_WITH_DEVICE"}},{"html_id":"error_profile_not_found?-instance-method","name":"error_profile_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":974,"url":null},"def":{"name":"error_profile_not_found?","visibility":"Public","body":"self == ERROR_PROFILE_NOT_FOUND"}},{"html_id":"error_promotion_active?-instance-method","name":"error_promotion_active?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1278,"url":null},"def":{"name":"error_promotion_active?","visibility":"Public","body":"self == ERROR_PROMOTION_ACTIVE"}},{"html_id":"error_protocol_unreachable?-instance-method","name":"error_protocol_unreachable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":534,"url":null},"def":{"name":"error_protocol_unreachable?","visibility":"Public","body":"self == ERROR_PROTOCOL_UNREACHABLE"}},{"html_id":"error_quorum_disk_not_found?-instance-method","name":"error_quorum_disk_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1161,"url":null},"def":{"name":"error_quorum_disk_not_found?","visibility":"Public","body":"self == ERROR_QUORUM_DISK_NOT_FOUND"}},{"html_id":"error_quorum_owner_alive?-instance-method","name":"error_quorum_owner_alive?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1110,"url":null},"def":{"name":"error_quorum_owner_alive?","visibility":"Public","body":"self == ERROR_QUORUM_OWNER_ALIVE"}},{"html_id":"error_quorum_resource?-instance-method","name":"error_quorum_resource?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1096,"url":null},"def":{"name":"error_quorum_resource?","visibility":"Public","body":"self == ERROR_QUORUM_RESOURCE"}},{"html_id":"error_quorum_resource_online_failed?-instance-method","name":"error_quorum_resource_online_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1103,"url":null},"def":{"name":"error_quorum_resource_online_failed?","visibility":"Public","body":"self == ERROR_QUORUM_RESOURCE_ONLINE_FAILED"}},{"html_id":"error_quorumlog_open_failed?-instance-method","name":"error_quorumlog_open_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1104,"url":null},"def":{"name":"error_quorumlog_open_failed?","visibility":"Public","body":"self == ERROR_QUORUMLOG_OPEN_FAILED"}},{"html_id":"error_read_fault?-instance-method","name":"error_read_fault?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":187,"url":null},"def":{"name":"error_read_fault?","visibility":"Public","body":"self == ERROR_READ_FAULT"}},{"html_id":"error_rec_non_existent?-instance-method","name":"error_rec_non_existent?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1008,"url":null},"def":{"name":"error_rec_non_existent?","visibility":"Public","body":"self == ERROR_REC_NON_EXISTENT"}},{"html_id":"error_recovery_failure?-instance-method","name":"error_recovery_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":574,"url":null},"def":{"name":"error_recovery_failure?","visibility":"Public","body":"self == ERROR_RECOVERY_FAILURE"}},{"html_id":"error_recovery_file_corrupt?-instance-method","name":"error_recovery_file_corrupt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2212,"url":null},"def":{"name":"error_recovery_file_corrupt?","visibility":"Public","body":"self == ERROR_RECOVERY_FILE_CORRUPT"}},{"html_id":"error_redir_paused?-instance-method","name":"error_redir_paused?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":217,"url":null},"def":{"name":"error_redir_paused?","visibility":"Public","body":"self == ERROR_REDIR_PAUSED"}},{"html_id":"error_redirector_has_open_handles?-instance-method","name":"error_redirector_has_open_handles?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":884,"url":null},"def":{"name":"error_redirector_has_open_handles?","visibility":"Public","body":"self == ERROR_REDIRECTOR_HAS_OPEN_HANDLES"}},{"html_id":"error_reg_nat_consumption?-instance-method","name":"error_reg_nat_consumption?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":562,"url":null},"def":{"name":"error_reg_nat_consumption?","visibility":"Public","body":"self == ERROR_REG_NAT_CONSUMPTION"}},{"html_id":"error_registry_corrupt?-instance-method","name":"error_registry_corrupt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":392,"url":null},"def":{"name":"error_registry_corrupt?","visibility":"Public","body":"self == ERROR_REGISTRY_CORRUPT"}},{"html_id":"error_registry_io_failed?-instance-method","name":"error_registry_io_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":393,"url":null},"def":{"name":"error_registry_io_failed?","visibility":"Public","body":"self == ERROR_REGISTRY_IO_FAILED"}},{"html_id":"error_registry_recovered?-instance-method","name":"error_registry_recovered?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":391,"url":null},"def":{"name":"error_registry_recovered?","visibility":"Public","body":"self == ERROR_REGISTRY_RECOVERED"}},{"html_id":"error_reloc_chain_xeeds_seglim?-instance-method","name":"error_reloc_chain_xeeds_seglim?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":311,"url":null},"def":{"name":"error_reloc_chain_xeeds_seglim?","visibility":"Public","body":"self == ERROR_RELOC_CHAIN_XEEDS_SEGLIM"}},{"html_id":"error_rem_not_list?-instance-method","name":"error_rem_not_list?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":196,"url":null},"def":{"name":"error_rem_not_list?","visibility":"Public","body":"self == ERROR_REM_NOT_LIST"}},{"html_id":"error_remote_print_connections_blocked?-instance-method","name":"error_remote_print_connections_blocked?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":961,"url":null},"def":{"name":"error_remote_print_connections_blocked?","visibility":"Public","body":"self == ERROR_REMOTE_PRINT_CONNECTIONS_BLOCKED"}},{"html_id":"error_remote_session_limit_exceeded?-instance-method","name":"error_remote_session_limit_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":521,"url":null},"def":{"name":"error_remote_session_limit_exceeded?","visibility":"Public","body":"self == ERROR_REMOTE_SESSION_LIMIT_EXCEEDED"}},{"html_id":"error_remote_storage_media_error?-instance-method","name":"error_remote_storage_media_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1070,"url":null},"def":{"name":"error_remote_storage_media_error?","visibility":"Public","body":"self == ERROR_REMOTE_STORAGE_MEDIA_ERROR"}},{"html_id":"error_remote_storage_not_active?-instance-method","name":"error_remote_storage_not_active?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1069,"url":null},"def":{"name":"error_remote_storage_not_active?","visibility":"Public","body":"self == ERROR_REMOTE_STORAGE_NOT_ACTIVE"}},{"html_id":"error_remove_failed?-instance-method","name":"error_remove_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2203,"url":null},"def":{"name":"error_remove_failed?","visibility":"Public","body":"self == ERROR_REMOVE_FAILED"}},{"html_id":"error_reparse_attribute_conflict?-instance-method","name":"error_reparse_attribute_conflict?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1072,"url":null},"def":{"name":"error_reparse_attribute_conflict?","visibility":"Public","body":"self == ERROR_REPARSE_ATTRIBUTE_CONFLICT"}},{"html_id":"error_reparse_tag_invalid?-instance-method","name":"error_reparse_tag_invalid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1074,"url":null},"def":{"name":"error_reparse_tag_invalid?","visibility":"Public","body":"self == ERROR_REPARSE_TAG_INVALID"}},{"html_id":"error_reparse_tag_mismatch?-instance-method","name":"error_reparse_tag_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1075,"url":null},"def":{"name":"error_reparse_tag_mismatch?","visibility":"Public","body":"self == ERROR_REPARSE_TAG_MISMATCH"}},{"html_id":"error_req_not_accep?-instance-method","name":"error_req_not_accep?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":216,"url":null},"def":{"name":"error_req_not_accep?","visibility":"Public","body":"self == ERROR_REQ_NOT_ACCEP"}},{"html_id":"error_request_aborted?-instance-method","name":"error_request_aborted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":536,"url":null},"def":{"name":"error_request_aborted?","visibility":"Public","body":"self == ERROR_REQUEST_ABORTED"}},{"html_id":"error_request_refused?-instance-method","name":"error_request_refused?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1046,"url":null},"def":{"name":"error_request_refused?","visibility":"Public","body":"self == ERROR_REQUEST_REFUSED"}},{"html_id":"error_requires_interactive_windowstation?-instance-method","name":"error_requires_interactive_windowstation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":741,"url":null},"def":{"name":"error_requires_interactive_windowstation?","visibility":"Public","body":"self == ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION"}},{"html_id":"error_resiliency_file_corrupt?-instance-method","name":"error_resiliency_file_corrupt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2218,"url":null},"def":{"name":"error_resiliency_file_corrupt?","visibility":"Public","body":"self == ERROR_RESILIENCY_FILE_CORRUPT"}},{"html_id":"error_resmon_create_failed?-instance-method","name":"error_resmon_create_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1093,"url":null},"def":{"name":"error_resmon_create_failed?","visibility":"Public","body":"self == ERROR_RESMON_CREATE_FAILED"}},{"html_id":"error_resmon_invalid_state?-instance-method","name":"error_resmon_invalid_state?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1159,"url":null},"def":{"name":"error_resmon_invalid_state?","visibility":"Public","body":"self == ERROR_RESMON_INVALID_STATE"}},{"html_id":"error_resmon_online_failed?-instance-method","name":"error_resmon_online_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1094,"url":null},"def":{"name":"error_resmon_online_failed?","visibility":"Public","body":"self == ERROR_RESMON_ONLINE_FAILED"}},{"html_id":"error_resource_data_not_found?-instance-method","name":"error_resource_data_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":902,"url":null},"def":{"name":"error_resource_data_not_found?","visibility":"Public","body":"self == ERROR_RESOURCE_DATA_NOT_FOUND"}},{"html_id":"error_resource_disabled?-instance-method","name":"error_resource_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1035,"url":null},"def":{"name":"error_resource_disabled?","visibility":"Public","body":"self == ERROR_RESOURCE_DISABLED"}},{"html_id":"error_resource_enum_user_stop?-instance-method","name":"error_resource_enum_user_stop?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2143,"url":null},"def":{"name":"error_resource_enum_user_stop?","visibility":"Public","body":"self == ERROR_RESOURCE_ENUM_USER_STOP"}},{"html_id":"error_resource_failed?-instance-method","name":"error_resource_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1114,"url":null},"def":{"name":"error_resource_failed?","visibility":"Public","body":"self == ERROR_RESOURCE_FAILED"}},{"html_id":"error_resource_lang_not_found?-instance-method","name":"error_resource_lang_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":905,"url":null},"def":{"name":"error_resource_lang_not_found?","visibility":"Public","body":"self == ERROR_RESOURCE_LANG_NOT_FOUND"}},{"html_id":"error_resource_name_not_found?-instance-method","name":"error_resource_name_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":904,"url":null},"def":{"name":"error_resource_name_not_found?","visibility":"Public","body":"self == ERROR_RESOURCE_NAME_NOT_FOUND"}},{"html_id":"error_resource_not_available?-instance-method","name":"error_resource_not_available?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1082,"url":null},"def":{"name":"error_resource_not_available?","visibility":"Public","body":"self == ERROR_RESOURCE_NOT_AVAILABLE"}},{"html_id":"error_resource_not_found?-instance-method","name":"error_resource_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1083,"url":null},"def":{"name":"error_resource_not_found?","visibility":"Public","body":"self == ERROR_RESOURCE_NOT_FOUND"}},{"html_id":"error_resource_not_online?-instance-method","name":"error_resource_not_online?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1080,"url":null},"def":{"name":"error_resource_not_online?","visibility":"Public","body":"self == ERROR_RESOURCE_NOT_ONLINE"}},{"html_id":"error_resource_not_present?-instance-method","name":"error_resource_not_present?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1042,"url":null},"def":{"name":"error_resource_not_present?","visibility":"Public","body":"self == ERROR_RESOURCE_NOT_PRESENT"}},{"html_id":"error_resource_online?-instance-method","name":"error_resource_online?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1095,"url":null},"def":{"name":"error_resource_online?","visibility":"Public","body":"self == ERROR_RESOURCE_ONLINE"}},{"html_id":"error_resource_properties_stored?-instance-method","name":"error_resource_properties_stored?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1100,"url":null},"def":{"name":"error_resource_properties_stored?","visibility":"Public","body":"self == ERROR_RESOURCE_PROPERTIES_STORED"}},{"html_id":"error_resource_property_unchangeable?-instance-method","name":"error_resource_property_unchangeable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1164,"url":null},"def":{"name":"error_resource_property_unchangeable?","visibility":"Public","body":"self == ERROR_RESOURCE_PROPERTY_UNCHANGEABLE"}},{"html_id":"error_resource_type_not_found?-instance-method","name":"error_resource_type_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":903,"url":null},"def":{"name":"error_resource_type_not_found?","visibility":"Public","body":"self == ERROR_RESOURCE_TYPE_NOT_FOUND"}},{"html_id":"error_retry?-instance-method","name":"error_retry?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":538,"url":null},"def":{"name":"error_retry?","visibility":"Public","body":"self == ERROR_RETRY"}},{"html_id":"error_revision_mismatch?-instance-method","name":"error_revision_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":589,"url":null},"def":{"name":"error_revision_mismatch?","visibility":"Public","body":"self == ERROR_REVISION_MISMATCH"}},{"html_id":"error_ring2_seg_must_be_movable?-instance-method","name":"error_ring2_seg_must_be_movable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":310,"url":null},"def":{"name":"error_ring2_seg_must_be_movable?","visibility":"Public","body":"self == ERROR_RING2SEG_MUST_BE_MOVABLE"}},{"html_id":"error_ring2_stack_in_use?-instance-method","name":"error_ring2_stack_in_use?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":316,"url":null},"def":{"name":"error_ring2_stack_in_use?","visibility":"Public","body":"self == ERROR_RING2_STACK_IN_USE"}},{"html_id":"error_rmode_app?-instance-method","name":"error_rmode_app?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":473,"url":null},"def":{"name":"error_rmode_app?","visibility":"Public","body":"self == ERROR_RMODE_APP"}},{"html_id":"error_rpl_not_allowed?-instance-method","name":"error_rpl_not_allowed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1009,"url":null},"def":{"name":"error_rpl_not_allowed?","visibility":"Public","body":"self == ERROR_RPL_NOT_ALLOWED"}},{"html_id":"error_runlevel_switch_agent_timeout?-instance-method","name":"error_runlevel_switch_agent_timeout?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2189,"url":null},"def":{"name":"error_runlevel_switch_agent_timeout?","visibility":"Public","body":"self == ERROR_RUNLEVEL_SWITCH_AGENT_TIMEOUT"}},{"html_id":"error_runlevel_switch_in_progress?-instance-method","name":"error_runlevel_switch_in_progress?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2190,"url":null},"def":{"name":"error_runlevel_switch_in_progress?","visibility":"Public","body":"self == ERROR_RUNLEVEL_SWITCH_IN_PROGRESS"}},{"html_id":"error_runlevel_switch_timeout?-instance-method","name":"error_runlevel_switch_timeout?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2188,"url":null},"def":{"name":"error_runlevel_switch_timeout?","visibility":"Public","body":"self == ERROR_RUNLEVEL_SWITCH_TIMEOUT"}},{"html_id":"error_rxact_commit_failure?-instance-method","name":"error_rxact_commit_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":652,"url":null},"def":{"name":"error_rxact_commit_failure?","visibility":"Public","body":"self == ERROR_RXACT_COMMIT_FAILURE"}},{"html_id":"error_rxact_invalid_state?-instance-method","name":"error_rxact_invalid_state?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":651,"url":null},"def":{"name":"error_rxact_invalid_state?","visibility":"Public","body":"self == ERROR_RXACT_INVALID_STATE"}},{"html_id":"error_sam_init_failure?-instance-method","name":"error_sam_init_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1558,"url":null},"def":{"name":"error_sam_init_failure?","visibility":"Public","body":"self == ERROR_SAM_INIT_FAILURE"}},{"html_id":"error_same_drive?-instance-method","name":"error_same_drive?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":268,"url":null},"def":{"name":"error_same_drive?","visibility":"Public","body":"self == ERROR_SAME_DRIVE"}},{"html_id":"error_scope_not_found?-instance-method","name":"error_scope_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":357,"url":null},"def":{"name":"error_scope_not_found?","visibility":"Public","body":"self == ERROR_SCOPE_NOT_FOUND"}},{"html_id":"error_screen_already_locked?-instance-method","name":"error_screen_already_locked?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":722,"url":null},"def":{"name":"error_screen_already_locked?","visibility":"Public","body":"self == ERROR_SCREEN_ALREADY_LOCKED"}},{"html_id":"error_secondary_ic_provider_not_registered?-instance-method","name":"error_secondary_ic_provider_not_registered?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2179,"url":null},"def":{"name":"error_secondary_ic_provider_not_registered?","visibility":"Public","body":"self == ERROR_SECONDARY_IC_PROVIDER_NOT_REGISTERED"}},{"html_id":"error_secret_too_long?-instance-method","name":"error_secret_too_long?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":664,"url":null},"def":{"name":"error_secret_too_long?","visibility":"Public","body":"self == ERROR_SECRET_TOO_LONG"}},{"html_id":"error_sector_not_found?-instance-method","name":"error_sector_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":184,"url":null},"def":{"name":"error_sector_not_found?","visibility":"Public","body":"self == ERROR_SECTOR_NOT_FOUND"}},{"html_id":"error_seek?-instance-method","name":"error_seek?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":182,"url":null},"def":{"name":"error_seek?","visibility":"Public","body":"self == ERROR_SEEK"}},{"html_id":"error_seek_on_device?-instance-method","name":"error_seek_on_device?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":257,"url":null},"def":{"name":"error_seek_on_device?","visibility":"Public","body":"self == ERROR_SEEK_ON_DEVICE"}},{"html_id":"error_sem_is_set?-instance-method","name":"error_sem_is_set?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":229,"url":null},"def":{"name":"error_sem_is_set?","visibility":"Public","body":"self == ERROR_SEM_IS_SET"}},{"html_id":"error_sem_not_found?-instance-method","name":"error_sem_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":297,"url":null},"def":{"name":"error_sem_not_found?","visibility":"Public","body":"self == ERROR_SEM_NOT_FOUND"}},{"html_id":"error_sem_owner_died?-instance-method","name":"error_sem_owner_died?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":232,"url":null},"def":{"name":"error_sem_owner_died?","visibility":"Public","body":"self == ERROR_SEM_OWNER_DIED"}},{"html_id":"error_sem_timeout?-instance-method","name":"error_sem_timeout?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":246,"url":null},"def":{"name":"error_sem_timeout?","visibility":"Public","body":"self == ERROR_SEM_TIMEOUT"}},{"html_id":"error_sem_user_limit?-instance-method","name":"error_sem_user_limit?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":233,"url":null},"def":{"name":"error_sem_user_limit?","visibility":"Public","body":"self == ERROR_SEM_USER_LIMIT"}},{"html_id":"error_serial_no_device?-instance-method","name":"error_serial_no_device?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":452,"url":null},"def":{"name":"error_serial_no_device?","visibility":"Public","body":"self == ERROR_SERIAL_NO_DEVICE"}},{"html_id":"error_server_disabled?-instance-method","name":"error_server_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":623,"url":null},"def":{"name":"error_server_disabled?","visibility":"Public","body":"self == ERROR_SERVER_DISABLED"}},{"html_id":"error_server_has_open_handles?-instance-method","name":"error_server_has_open_handles?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":901,"url":null},"def":{"name":"error_server_has_open_handles?","visibility":"Public","body":"self == ERROR_SERVER_HAS_OPEN_HANDLES"}},{"html_id":"error_server_not_disabled?-instance-method","name":"error_server_not_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":624,"url":null},"def":{"name":"error_server_not_disabled?","visibility":"Public","body":"self == ERROR_SERVER_NOT_DISABLED"}},{"html_id":"error_server_shutdown_in_progress?-instance-method","name":"error_server_shutdown_in_progress?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":556,"url":null},"def":{"name":"error_server_shutdown_in_progress?","visibility":"Public","body":"self == ERROR_SERVER_SHUTDOWN_IN_PROGRESS"}},{"html_id":"error_service_already_running?-instance-method","name":"error_service_already_running?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":405,"url":null},"def":{"name":"error_service_already_running?","visibility":"Public","body":"self == ERROR_SERVICE_ALREADY_RUNNING"}},{"html_id":"error_service_cannot_accept_ctrl?-instance-method","name":"error_service_cannot_accept_ctrl?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":410,"url":null},"def":{"name":"error_service_cannot_accept_ctrl?","visibility":"Public","body":"self == ERROR_SERVICE_CANNOT_ACCEPT_CTRL"}},{"html_id":"error_service_database_locked?-instance-method","name":"error_service_database_locked?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":404,"url":null},"def":{"name":"error_service_database_locked?","visibility":"Public","body":"self == ERROR_SERVICE_DATABASE_LOCKED"}},{"html_id":"error_service_dependency_deleted?-instance-method","name":"error_service_dependency_deleted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":424,"url":null},"def":{"name":"error_service_dependency_deleted?","visibility":"Public","body":"self == ERROR_SERVICE_DEPENDENCY_DELETED"}},{"html_id":"error_service_dependency_fail?-instance-method","name":"error_service_dependency_fail?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":417,"url":null},"def":{"name":"error_service_dependency_fail?","visibility":"Public","body":"self == ERROR_SERVICE_DEPENDENCY_FAIL"}},{"html_id":"error_service_disabled?-instance-method","name":"error_service_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":407,"url":null},"def":{"name":"error_service_disabled?","visibility":"Public","body":"self == ERROR_SERVICE_DISABLED"}},{"html_id":"error_service_does_not_exist?-instance-method","name":"error_service_does_not_exist?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":409,"url":null},"def":{"name":"error_service_does_not_exist?","visibility":"Public","body":"self == ERROR_SERVICE_DOES_NOT_EXIST"}},{"html_id":"error_service_exists?-instance-method","name":"error_service_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":422,"url":null},"def":{"name":"error_service_exists?","visibility":"Public","body":"self == ERROR_SERVICE_EXISTS"}},{"html_id":"error_service_logon_failed?-instance-method","name":"error_service_logon_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":418,"url":null},"def":{"name":"error_service_logon_failed?","visibility":"Public","body":"self == ERROR_SERVICE_LOGON_FAILED"}},{"html_id":"error_service_marked_for_delete?-instance-method","name":"error_service_marked_for_delete?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":421,"url":null},"def":{"name":"error_service_marked_for_delete?","visibility":"Public","body":"self == ERROR_SERVICE_MARKED_FOR_DELETE"}},{"html_id":"error_service_never_started?-instance-method","name":"error_service_never_started?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":426,"url":null},"def":{"name":"error_service_never_started?","visibility":"Public","body":"self == ERROR_SERVICE_NEVER_STARTED"}},{"html_id":"error_service_no_thread?-instance-method","name":"error_service_no_thread?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":403,"url":null},"def":{"name":"error_service_no_thread?","visibility":"Public","body":"self == ERROR_SERVICE_NO_THREAD"}},{"html_id":"error_service_not_active?-instance-method","name":"error_service_not_active?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":411,"url":null},"def":{"name":"error_service_not_active?","visibility":"Public","body":"self == ERROR_SERVICE_NOT_ACTIVE"}},{"html_id":"error_service_not_found?-instance-method","name":"error_service_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":544,"url":null},"def":{"name":"error_service_not_found?","visibility":"Public","body":"self == ERROR_SERVICE_NOT_FOUND"}},{"html_id":"error_service_not_in_exe?-instance-method","name":"error_service_not_in_exe?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":432,"url":null},"def":{"name":"error_service_not_in_exe?","visibility":"Public","body":"self == ERROR_SERVICE_NOT_IN_EXE"}},{"html_id":"error_service_request_timeout?-instance-method","name":"error_service_request_timeout?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":402,"url":null},"def":{"name":"error_service_request_timeout?","visibility":"Public","body":"self == ERROR_SERVICE_REQUEST_TIMEOUT"}},{"html_id":"error_service_specific_error?-instance-method","name":"error_service_specific_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":415,"url":null},"def":{"name":"error_service_specific_error?","visibility":"Public","body":"self == ERROR_SERVICE_SPECIFIC_ERROR"}},{"html_id":"error_service_start_hang?-instance-method","name":"error_service_start_hang?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":419,"url":null},"def":{"name":"error_service_start_hang?","visibility":"Public","body":"self == ERROR_SERVICE_START_HANG"}},{"html_id":"error_services_failed_autostart?-instance-method","name":"error_services_failed_autostart?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2191,"url":null},"def":{"name":"error_services_failed_autostart?","visibility":"Public","body":"self == ERROR_SERVICES_FAILED_AUTOSTART"}},{"html_id":"error_session_credential_conflict?-instance-method","name":"error_session_credential_conflict?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":520,"url":null},"def":{"name":"error_session_credential_conflict?","visibility":"Public","body":"self == ERROR_SESSION_CREDENTIAL_CONFLICT"}},{"html_id":"error_set_not_found?-instance-method","name":"error_set_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":490,"url":null},"def":{"name":"error_set_not_found?","visibility":"Public","body":"self == ERROR_SET_NOT_FOUND"}},{"html_id":"error_set_power_state_failed?-instance-method","name":"error_set_power_state_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":468,"url":null},"def":{"name":"error_set_power_state_failed?","visibility":"Public","body":"self == ERROR_SET_POWER_STATE_FAILED"}},{"html_id":"error_set_power_state_vetoed?-instance-method","name":"error_set_power_state_vetoed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":467,"url":null},"def":{"name":"error_set_power_state_vetoed?","visibility":"Public","body":"self == ERROR_SET_POWER_STATE_VETOED"}},{"html_id":"error_setcount_on_bad_lb?-instance-method","name":"error_setcount_on_bad_lb?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":715,"url":null},"def":{"name":"error_setcount_on_bad_lb?","visibility":"Public","body":"self == ERROR_SETCOUNT_ON_BAD_LB"}},{"html_id":"error_setmark_detected?-instance-method","name":"error_setmark_detected?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":437,"url":null},"def":{"name":"error_setmark_detected?","visibility":"Public","body":"self == ERROR_SETMARK_DETECTED"}},{"html_id":"error_shared_policy?-instance-method","name":"error_shared_policy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1275,"url":null},"def":{"name":"error_shared_policy?","visibility":"Public","body":"self == ERROR_SHARED_POLICY"}},{"html_id":"error_sharing_buffer_exceeded?-instance-method","name":"error_sharing_buffer_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":192,"url":null},"def":{"name":"error_sharing_buffer_exceeded?","visibility":"Public","body":"self == ERROR_SHARING_BUFFER_EXCEEDED"}},{"html_id":"error_sharing_paused?-instance-method","name":"error_sharing_paused?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":215,"url":null},"def":{"name":"error_sharing_paused?","visibility":"Public","body":"self == ERROR_SHARING_PAUSED"}},{"html_id":"error_sharing_violation?-instance-method","name":"error_sharing_violation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":189,"url":null},"def":{"name":"error_sharing_violation?","visibility":"Public","body":"self == ERROR_SHARING_VIOLATION"}},{"html_id":"error_shutdown_cluster?-instance-method","name":"error_shutdown_cluster?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1084,"url":null},"def":{"name":"error_shutdown_cluster?","visibility":"Public","body":"self == ERROR_SHUTDOWN_CLUSTER"}},{"html_id":"error_shutdown_in_progress?-instance-method","name":"error_shutdown_in_progress?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":449,"url":null},"def":{"name":"error_shutdown_in_progress?","visibility":"Public","body":"self == ERROR_SHUTDOWN_IN_PROGRESS"}},{"html_id":"error_signal_pending?-instance-method","name":"error_signal_pending?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":287,"url":null},"def":{"name":"error_signal_pending?","visibility":"Public","body":"self == ERROR_SIGNAL_PENDING"}},{"html_id":"error_signal_refused?-instance-method","name":"error_signal_refused?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":281,"url":null},"def":{"name":"error_signal_refused?","visibility":"Public","body":"self == ERROR_SIGNAL_REFUSED"}},{"html_id":"error_single_instance_app?-instance-method","name":"error_single_instance_app?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":472,"url":null},"def":{"name":"error_single_instance_app?","visibility":"Public","body":"self == ERROR_SINGLE_INSTANCE_APP"}},{"html_id":"error_smartcard_subsystem_failure?-instance-method","name":"error_smartcard_subsystem_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":565,"url":null},"def":{"name":"error_smartcard_subsystem_failure?","visibility":"Public","body":"self == ERROR_SMARTCARD_SUBSYSTEM_FAILURE"}},{"html_id":"error_smi_primitive_installer_failed?-instance-method","name":"error_smi_primitive_installer_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1940,"url":null},"def":{"name":"error_smi_primitive_installer_failed?","visibility":"Public","body":"self == ERROR_SMI_PRIMITIVE_INSTALLER_FAILED"}},{"html_id":"error_some_not_mapped?-instance-method","name":"error_some_not_mapped?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":584,"url":null},"def":{"name":"error_some_not_mapped?","visibility":"Public","body":"self == ERROR_SOME_NOT_MAPPED"}},{"html_id":"error_source_element_empty?-instance-method","name":"error_source_element_empty?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":480,"url":null},"def":{"name":"error_source_element_empty?","visibility":"Public","body":"self == ERROR_SOURCE_ELEMENT_EMPTY"}},{"html_id":"error_special_account?-instance-method","name":"error_special_account?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":653,"url":null},"def":{"name":"error_special_account?","visibility":"Public","body":"self == ERROR_SPECIAL_ACCOUNT"}},{"html_id":"error_special_group?-instance-method","name":"error_special_group?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":654,"url":null},"def":{"name":"error_special_group?","visibility":"Public","body":"self == ERROR_SPECIAL_GROUP"}},{"html_id":"error_special_user?-instance-method","name":"error_special_user?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":655,"url":null},"def":{"name":"error_special_user?","visibility":"Public","body":"self == ERROR_SPECIAL_USER"}},{"html_id":"error_spl_no_addjob?-instance-method","name":"error_spl_no_addjob?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":992,"url":null},"def":{"name":"error_spl_no_addjob?","visibility":"Public","body":"self == ERROR_SPL_NO_ADDJOB"}},{"html_id":"error_spl_no_startdoc?-instance-method","name":"error_spl_no_startdoc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":991,"url":null},"def":{"name":"error_spl_no_startdoc?","visibility":"Public","body":"self == ERROR_SPL_NO_STARTDOC"}},{"html_id":"error_spool_file_not_found?-instance-method","name":"error_spool_file_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":990,"url":null},"def":{"name":"error_spool_file_not_found?","visibility":"Public","body":"self == ERROR_SPOOL_FILE_NOT_FOUND"}},{"html_id":"error_stack_buffer_overrun?-instance-method","name":"error_stack_buffer_overrun?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":577,"url":null},"def":{"name":"error_stack_buffer_overrun?","visibility":"Public","body":"self == ERROR_STACK_BUFFER_OVERRUN"}},{"html_id":"error_stack_overflow?-instance-method","name":"error_stack_overflow?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":378,"url":null},"def":{"name":"error_stack_overflow?","visibility":"Public","body":"self == ERROR_STACK_OVERFLOW"}},{"html_id":"error_state_composite_setting_value_size_limit_exceeded?-instance-method","name":"error_state_composite_setting_value_size_limit_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2239,"url":null},"def":{"name":"error_state_composite_setting_value_size_limit_exceeded?","visibility":"Public","body":"self == ERROR_STATE_COMPOSITE_SETTING_VALUE_SIZE_LIMIT_EXCEEDED"}},{"html_id":"error_state_container_name_size_limit_exceeded?-instance-method","name":"error_state_container_name_size_limit_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2242,"url":null},"def":{"name":"error_state_container_name_size_limit_exceeded?","visibility":"Public","body":"self == ERROR_STATE_CONTAINER_NAME_SIZE_LIMIT_EXCEEDED"}},{"html_id":"error_state_create_container_failed?-instance-method","name":"error_state_create_container_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2229,"url":null},"def":{"name":"error_state_create_container_failed?","visibility":"Public","body":"self == ERROR_STATE_CREATE_CONTAINER_FAILED"}},{"html_id":"error_state_delete_container_failed?-instance-method","name":"error_state_delete_container_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2230,"url":null},"def":{"name":"error_state_delete_container_failed?","visibility":"Public","body":"self == ERROR_STATE_DELETE_CONTAINER_FAILED"}},{"html_id":"error_state_delete_setting_failed?-instance-method","name":"error_state_delete_setting_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2233,"url":null},"def":{"name":"error_state_delete_setting_failed?","visibility":"Public","body":"self == ERROR_STATE_DELETE_SETTING_FAILED"}},{"html_id":"error_state_enumerate_container_failed?-instance-method","name":"error_state_enumerate_container_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2237,"url":null},"def":{"name":"error_state_enumerate_container_failed?","visibility":"Public","body":"self == ERROR_STATE_ENUMERATE_CONTAINER_FAILED"}},{"html_id":"error_state_enumerate_settings_failed?-instance-method","name":"error_state_enumerate_settings_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2238,"url":null},"def":{"name":"error_state_enumerate_settings_failed?","visibility":"Public","body":"self == ERROR_STATE_ENUMERATE_SETTINGS_FAILED"}},{"html_id":"error_state_get_version_failed?-instance-method","name":"error_state_get_version_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2225,"url":null},"def":{"name":"error_state_get_version_failed?","visibility":"Public","body":"self == ERROR_STATE_GET_VERSION_FAILED"}},{"html_id":"error_state_load_store_failed?-instance-method","name":"error_state_load_store_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2224,"url":null},"def":{"name":"error_state_load_store_failed?","visibility":"Public","body":"self == ERROR_STATE_LOAD_STORE_FAILED"}},{"html_id":"error_state_open_container_failed?-instance-method","name":"error_state_open_container_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2228,"url":null},"def":{"name":"error_state_open_container_failed?","visibility":"Public","body":"self == ERROR_STATE_OPEN_CONTAINER_FAILED"}},{"html_id":"error_state_query_setting_failed?-instance-method","name":"error_state_query_setting_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2234,"url":null},"def":{"name":"error_state_query_setting_failed?","visibility":"Public","body":"self == ERROR_STATE_QUERY_SETTING_FAILED"}},{"html_id":"error_state_read_composite_setting_failed?-instance-method","name":"error_state_read_composite_setting_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2235,"url":null},"def":{"name":"error_state_read_composite_setting_failed?","visibility":"Public","body":"self == ERROR_STATE_READ_COMPOSITE_SETTING_FAILED"}},{"html_id":"error_state_read_setting_failed?-instance-method","name":"error_state_read_setting_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2231,"url":null},"def":{"name":"error_state_read_setting_failed?","visibility":"Public","body":"self == ERROR_STATE_READ_SETTING_FAILED"}},{"html_id":"error_state_set_version_failed?-instance-method","name":"error_state_set_version_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2226,"url":null},"def":{"name":"error_state_set_version_failed?","visibility":"Public","body":"self == ERROR_STATE_SET_VERSION_FAILED"}},{"html_id":"error_state_setting_name_size_limit_exceeded?-instance-method","name":"error_state_setting_name_size_limit_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2241,"url":null},"def":{"name":"error_state_setting_name_size_limit_exceeded?","visibility":"Public","body":"self == ERROR_STATE_SETTING_NAME_SIZE_LIMIT_EXCEEDED"}},{"html_id":"error_state_setting_value_size_limit_exceeded?-instance-method","name":"error_state_setting_value_size_limit_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2240,"url":null},"def":{"name":"error_state_setting_value_size_limit_exceeded?","visibility":"Public","body":"self == ERROR_STATE_SETTING_VALUE_SIZE_LIMIT_EXCEEDED"}},{"html_id":"error_state_structured_reset_failed?-instance-method","name":"error_state_structured_reset_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2227,"url":null},"def":{"name":"error_state_structured_reset_failed?","visibility":"Public","body":"self == ERROR_STATE_STRUCTURED_RESET_FAILED"}},{"html_id":"error_state_write_composite_setting_failed?-instance-method","name":"error_state_write_composite_setting_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2236,"url":null},"def":{"name":"error_state_write_composite_setting_failed?","visibility":"Public","body":"self == ERROR_STATE_WRITE_COMPOSITE_SETTING_FAILED"}},{"html_id":"error_state_write_setting_failed?-instance-method","name":"error_state_write_setting_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2232,"url":null},"def":{"name":"error_state_write_setting_failed?","visibility":"Public","body":"self == ERROR_STATE_WRITE_SETTING_FAILED"}},{"html_id":"error_static_init?-instance-method","name":"error_static_init?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1005,"url":null},"def":{"name":"error_static_init?","visibility":"Public","body":"self == ERROR_STATIC_INIT"}},{"html_id":"error_subst_to_join?-instance-method","name":"error_subst_to_join?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":266,"url":null},"def":{"name":"error_subst_to_join?","visibility":"Public","body":"self == ERROR_SUBST_TO_JOIN"}},{"html_id":"error_subst_to_subst?-instance-method","name":"error_subst_to_subst?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":264,"url":null},"def":{"name":"error_subst_to_subst?","visibility":"Public","body":"self == ERROR_SUBST_TO_SUBST"}},{"html_id":"error_success?-instance-method","name":"error_success?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":157,"url":null},"def":{"name":"error_success?","visibility":"Public","body":"self == ERROR_SUCCESS"}},{"html_id":"error_success_reboot_initiated?-instance-method","name":"error_success_reboot_initiated?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":789,"url":null},"def":{"name":"error_success_reboot_initiated?","visibility":"Public","body":"self == ERROR_SUCCESS_REBOOT_INITIATED"}},{"html_id":"error_success_reboot_required?-instance-method","name":"error_success_reboot_required?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":998,"url":null},"def":{"name":"error_success_reboot_required?","visibility":"Public","body":"self == ERROR_SUCCESS_REBOOT_REQUIRED"}},{"html_id":"error_success_restart_required?-instance-method","name":"error_success_restart_required?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":999,"url":null},"def":{"name":"error_success_restart_required?","visibility":"Public","body":"self == ERROR_SUCCESS_RESTART_REQUIRED"}},{"html_id":"error_swaperror?-instance-method","name":"error_swaperror?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":377,"url":null},"def":{"name":"error_swaperror?","visibility":"Public","body":"self == ERROR_SWAPERROR"}},{"html_id":"error_sxs_activation_context_disabled?-instance-method","name":"error_sxs_activation_context_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1838,"url":null},"def":{"name":"error_sxs_activation_context_disabled?","visibility":"Public","body":"self == ERROR_SXS_ACTIVATION_CONTEXT_DISABLED"}},{"html_id":"error_sxs_assembly_is_not_a_deployment?-instance-method","name":"error_sxs_assembly_is_not_a_deployment?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1935,"url":null},"def":{"name":"error_sxs_assembly_is_not_a_deployment?","visibility":"Public","body":"self == ERROR_SXS_ASSEMBLY_IS_NOT_A_DEPLOYMENT"}},{"html_id":"error_sxs_assembly_missing?-instance-method","name":"error_sxs_assembly_missing?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1913,"url":null},"def":{"name":"error_sxs_assembly_missing?","visibility":"Public","body":"self == ERROR_SXS_ASSEMBLY_MISSING"}},{"html_id":"error_sxs_assembly_not_found?-instance-method","name":"error_sxs_assembly_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1835,"url":null},"def":{"name":"error_sxs_assembly_not_found?","visibility":"Public","body":"self == ERROR_SXS_ASSEMBLY_NOT_FOUND"}},{"html_id":"error_sxs_assembly_not_locked?-instance-method","name":"error_sxs_assembly_not_locked?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1929,"url":null},"def":{"name":"error_sxs_assembly_not_locked?","visibility":"Public","body":"self == ERROR_SXS_ASSEMBLY_NOT_LOCKED"}},{"html_id":"error_sxs_cant_gen_actctx?-instance-method","name":"error_sxs_cant_gen_actctx?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1833,"url":null},"def":{"name":"error_sxs_cant_gen_actctx?","visibility":"Public","body":"self == ERROR_SXS_CANT_GEN_ACTCTX"}},{"html_id":"error_sxs_component_store_corrupt?-instance-method","name":"error_sxs_component_store_corrupt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1930,"url":null},"def":{"name":"error_sxs_component_store_corrupt?","visibility":"Public","body":"self == ERROR_SXS_COMPONENT_STORE_CORRUPT"}},{"html_id":"error_sxs_corrupt_activation_stack?-instance-method","name":"error_sxs_corrupt_activation_stack?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1914,"url":null},"def":{"name":"error_sxs_corrupt_activation_stack?","visibility":"Public","body":"self == ERROR_SXS_CORRUPT_ACTIVATION_STACK"}},{"html_id":"error_sxs_corruption?-instance-method","name":"error_sxs_corruption?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1915,"url":null},"def":{"name":"error_sxs_corruption?","visibility":"Public","body":"self == ERROR_SXS_CORRUPTION"}},{"html_id":"error_sxs_duplicate_assembly_name?-instance-method","name":"error_sxs_duplicate_assembly_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1859,"url":null},"def":{"name":"error_sxs_duplicate_assembly_name?","visibility":"Public","body":"self == ERROR_SXS_DUPLICATE_ASSEMBLY_NAME"}},{"html_id":"error_sxs_duplicate_clsid?-instance-method","name":"error_sxs_duplicate_clsid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1855,"url":null},"def":{"name":"error_sxs_duplicate_clsid?","visibility":"Public","body":"self == ERROR_SXS_DUPLICATE_CLSID"}},{"html_id":"error_sxs_duplicate_dll_name?-instance-method","name":"error_sxs_duplicate_dll_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1853,"url":null},"def":{"name":"error_sxs_duplicate_dll_name?","visibility":"Public","body":"self == ERROR_SXS_DUPLICATE_DLL_NAME"}},{"html_id":"error_sxs_duplicate_iid?-instance-method","name":"error_sxs_duplicate_iid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1856,"url":null},"def":{"name":"error_sxs_duplicate_iid?","visibility":"Public","body":"self == ERROR_SXS_DUPLICATE_IID"}},{"html_id":"error_sxs_duplicate_progid?-instance-method","name":"error_sxs_duplicate_progid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1858,"url":null},"def":{"name":"error_sxs_duplicate_progid?","visibility":"Public","body":"self == ERROR_SXS_DUPLICATE_PROGID"}},{"html_id":"error_sxs_duplicate_tlbid?-instance-method","name":"error_sxs_duplicate_tlbid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1857,"url":null},"def":{"name":"error_sxs_duplicate_tlbid?","visibility":"Public","body":"self == ERROR_SXS_DUPLICATE_TLBID"}},{"html_id":"error_sxs_duplicate_windowclass_name?-instance-method","name":"error_sxs_duplicate_windowclass_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1854,"url":null},"def":{"name":"error_sxs_duplicate_windowclass_name?","visibility":"Public","body":"self == ERROR_SXS_DUPLICATE_WINDOWCLASS_NAME"}},{"html_id":"error_sxs_early_deactivation?-instance-method","name":"error_sxs_early_deactivation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1916,"url":null},"def":{"name":"error_sxs_early_deactivation?","visibility":"Public","body":"self == ERROR_SXS_EARLY_DEACTIVATION"}},{"html_id":"error_sxs_file_hash_mismatch?-instance-method","name":"error_sxs_file_hash_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1860,"url":null},"def":{"name":"error_sxs_file_hash_mismatch?","visibility":"Public","body":"self == ERROR_SXS_FILE_HASH_MISMATCH"}},{"html_id":"error_sxs_file_hash_missing?-instance-method","name":"error_sxs_file_hash_missing?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1942,"url":null},"def":{"name":"error_sxs_file_hash_missing?","visibility":"Public","body":"self == ERROR_SXS_FILE_HASH_MISSING"}},{"html_id":"error_sxs_file_not_part_of_assembly?-instance-method","name":"error_sxs_file_not_part_of_assembly?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1936,"url":null},"def":{"name":"error_sxs_file_not_part_of_assembly?","visibility":"Public","body":"self == ERROR_SXS_FILE_NOT_PART_OF_ASSEMBLY"}},{"html_id":"error_sxs_identities_different?-instance-method","name":"error_sxs_identities_different?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1934,"url":null},"def":{"name":"error_sxs_identities_different?","visibility":"Public","body":"self == ERROR_SXS_IDENTITIES_DIFFERENT"}},{"html_id":"error_sxs_identity_duplicate_attribute?-instance-method","name":"error_sxs_identity_duplicate_attribute?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1924,"url":null},"def":{"name":"error_sxs_identity_duplicate_attribute?","visibility":"Public","body":"self == ERROR_SXS_IDENTITY_DUPLICATE_ATTRIBUTE"}},{"html_id":"error_sxs_identity_parse_error?-instance-method","name":"error_sxs_identity_parse_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1925,"url":null},"def":{"name":"error_sxs_identity_parse_error?","visibility":"Public","body":"self == ERROR_SXS_IDENTITY_PARSE_ERROR"}},{"html_id":"error_sxs_incorrect_public_key_token?-instance-method","name":"error_sxs_incorrect_public_key_token?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1927,"url":null},"def":{"name":"error_sxs_incorrect_public_key_token?","visibility":"Public","body":"self == ERROR_SXS_INCORRECT_PUBLIC_KEY_TOKEN"}},{"html_id":"error_sxs_invalid_actctxdata_format?-instance-method","name":"error_sxs_invalid_actctxdata_format?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1834,"url":null},"def":{"name":"error_sxs_invalid_actctxdata_format?","visibility":"Public","body":"self == ERROR_SXS_INVALID_ACTCTXDATA_FORMAT"}},{"html_id":"error_sxs_invalid_assembly_identity_attribute?-instance-method","name":"error_sxs_invalid_assembly_identity_attribute?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1849,"url":null},"def":{"name":"error_sxs_invalid_assembly_identity_attribute?","visibility":"Public","body":"self == ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE"}},{"html_id":"error_sxs_invalid_assembly_identity_attribute_name?-instance-method","name":"error_sxs_invalid_assembly_identity_attribute_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1912,"url":null},"def":{"name":"error_sxs_invalid_assembly_identity_attribute_name?","visibility":"Public","body":"self == ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE_NAME"}},{"html_id":"error_sxs_invalid_deactivation?-instance-method","name":"error_sxs_invalid_deactivation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1917,"url":null},"def":{"name":"error_sxs_invalid_deactivation?","visibility":"Public","body":"self == ERROR_SXS_INVALID_DEACTIVATION"}},{"html_id":"error_sxs_invalid_identity_attribute_name?-instance-method","name":"error_sxs_invalid_identity_attribute_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1923,"url":null},"def":{"name":"error_sxs_invalid_identity_attribute_name?","visibility":"Public","body":"self == ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_NAME"}},{"html_id":"error_sxs_invalid_identity_attribute_value?-instance-method","name":"error_sxs_invalid_identity_attribute_value?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1922,"url":null},"def":{"name":"error_sxs_invalid_identity_attribute_value?","visibility":"Public","body":"self == ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_VALUE"}},{"html_id":"error_sxs_invalid_xml_namespace_uri?-instance-method","name":"error_sxs_invalid_xml_namespace_uri?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1846,"url":null},"def":{"name":"error_sxs_invalid_xml_namespace_uri?","visibility":"Public","body":"self == ERROR_SXS_INVALID_XML_NAMESPACE_URI"}},{"html_id":"error_sxs_key_not_found?-instance-method","name":"error_sxs_key_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1839,"url":null},"def":{"name":"error_sxs_key_not_found?","visibility":"Public","body":"self == ERROR_SXS_KEY_NOT_FOUND"}},{"html_id":"error_sxs_leaf_manifest_dependency_not_installed?-instance-method","name":"error_sxs_leaf_manifest_dependency_not_installed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1848,"url":null},"def":{"name":"error_sxs_leaf_manifest_dependency_not_installed?","visibility":"Public","body":"self == ERROR_SXS_LEAF_MANIFEST_DEPENDENCY_NOT_INSTALLED"}},{"html_id":"error_sxs_manifest_format_error?-instance-method","name":"error_sxs_manifest_format_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1836,"url":null},"def":{"name":"error_sxs_manifest_format_error?","visibility":"Public","body":"self == ERROR_SXS_MANIFEST_FORMAT_ERROR"}},{"html_id":"error_sxs_manifest_identity_same_but_contents_different?-instance-method","name":"error_sxs_manifest_identity_same_but_contents_different?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1933,"url":null},"def":{"name":"error_sxs_manifest_identity_same_but_contents_different?","visibility":"Public","body":"self == ERROR_SXS_MANIFEST_IDENTITY_SAME_BUT_CONTENTS_DIFFERENT"}},{"html_id":"error_sxs_manifest_invalid_required_default_namespace?-instance-method","name":"error_sxs_manifest_invalid_required_default_namespace?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1851,"url":null},"def":{"name":"error_sxs_manifest_invalid_required_default_namespace?","visibility":"Public","body":"self == ERROR_SXS_MANIFEST_INVALID_REQUIRED_DEFAULT_NAMESPACE"}},{"html_id":"error_sxs_manifest_missing_required_default_namespace?-instance-method","name":"error_sxs_manifest_missing_required_default_namespace?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1850,"url":null},"def":{"name":"error_sxs_manifest_missing_required_default_namespace?","visibility":"Public","body":"self == ERROR_SXS_MANIFEST_MISSING_REQUIRED_DEFAULT_NAMESPACE"}},{"html_id":"error_sxs_manifest_parse_error?-instance-method","name":"error_sxs_manifest_parse_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1837,"url":null},"def":{"name":"error_sxs_manifest_parse_error?","visibility":"Public","body":"self == ERROR_SXS_MANIFEST_PARSE_ERROR"}},{"html_id":"error_sxs_manifest_too_big?-instance-method","name":"error_sxs_manifest_too_big?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1937,"url":null},"def":{"name":"error_sxs_manifest_too_big?","visibility":"Public","body":"self == ERROR_SXS_MANIFEST_TOO_BIG"}},{"html_id":"error_sxs_missing_assembly_identity_attribute?-instance-method","name":"error_sxs_missing_assembly_identity_attribute?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1911,"url":null},"def":{"name":"error_sxs_missing_assembly_identity_attribute?","visibility":"Public","body":"self == ERROR_SXS_MISSING_ASSEMBLY_IDENTITY_ATTRIBUTE"}},{"html_id":"error_sxs_multiple_deactivation?-instance-method","name":"error_sxs_multiple_deactivation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1918,"url":null},"def":{"name":"error_sxs_multiple_deactivation?","visibility":"Public","body":"self == ERROR_SXS_MULTIPLE_DEACTIVATION"}},{"html_id":"error_sxs_policy_parse_error?-instance-method","name":"error_sxs_policy_parse_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1861,"url":null},"def":{"name":"error_sxs_policy_parse_error?","visibility":"Public","body":"self == ERROR_SXS_POLICY_PARSE_ERROR"}},{"html_id":"error_sxs_private_manifest_cross_path_with_reparse_point?-instance-method","name":"error_sxs_private_manifest_cross_path_with_reparse_point?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1852,"url":null},"def":{"name":"error_sxs_private_manifest_cross_path_with_reparse_point?","visibility":"Public","body":"self == ERROR_SXS_PRIVATE_MANIFEST_CROSS_PATH_WITH_REPARSE_POINT"}},{"html_id":"error_sxs_process_default_already_set?-instance-method","name":"error_sxs_process_default_already_set?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1843,"url":null},"def":{"name":"error_sxs_process_default_already_set?","visibility":"Public","body":"self == ERROR_SXS_PROCESS_DEFAULT_ALREADY_SET"}},{"html_id":"error_sxs_process_termination_requested?-instance-method","name":"error_sxs_process_termination_requested?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1919,"url":null},"def":{"name":"error_sxs_process_termination_requested?","visibility":"Public","body":"self == ERROR_SXS_PROCESS_TERMINATION_REQUESTED"}},{"html_id":"error_sxs_protection_catalog_file_missing?-instance-method","name":"error_sxs_protection_catalog_file_missing?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1910,"url":null},"def":{"name":"error_sxs_protection_catalog_file_missing?","visibility":"Public","body":"self == ERROR_SXS_PROTECTION_CATALOG_FILE_MISSING"}},{"html_id":"error_sxs_protection_catalog_not_valid?-instance-method","name":"error_sxs_protection_catalog_not_valid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1908,"url":null},"def":{"name":"error_sxs_protection_catalog_not_valid?","visibility":"Public","body":"self == ERROR_SXS_PROTECTION_CATALOG_NOT_VALID"}},{"html_id":"error_sxs_protection_public_key_too_short?-instance-method","name":"error_sxs_protection_public_key_too_short?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1907,"url":null},"def":{"name":"error_sxs_protection_public_key_too_short?","visibility":"Public","body":"self == ERROR_SXS_PROTECTION_PUBLIC_KEY_TOO_SHORT"}},{"html_id":"error_sxs_protection_recovery_failed?-instance-method","name":"error_sxs_protection_recovery_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1906,"url":null},"def":{"name":"error_sxs_protection_recovery_failed?","visibility":"Public","body":"self == ERROR_SXS_PROTECTION_RECOVERY_FAILED"}},{"html_id":"error_sxs_release_activation_context?-instance-method","name":"error_sxs_release_activation_context?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1920,"url":null},"def":{"name":"error_sxs_release_activation_context?","visibility":"Public","body":"self == ERROR_SXS_RELEASE_ACTIVATION_CONTEXT"}},{"html_id":"error_sxs_root_manifest_dependency_not_installed?-instance-method","name":"error_sxs_root_manifest_dependency_not_installed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1847,"url":null},"def":{"name":"error_sxs_root_manifest_dependency_not_installed?","visibility":"Public","body":"self == ERROR_SXS_ROOT_MANIFEST_DEPENDENCY_NOT_INSTALLED"}},{"html_id":"error_sxs_section_not_found?-instance-method","name":"error_sxs_section_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1832,"url":null},"def":{"name":"error_sxs_section_not_found?","visibility":"Public","body":"self == ERROR_SXS_SECTION_NOT_FOUND"}},{"html_id":"error_sxs_setting_not_registered?-instance-method","name":"error_sxs_setting_not_registered?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1938,"url":null},"def":{"name":"error_sxs_setting_not_registered?","visibility":"Public","body":"self == ERROR_SXS_SETTING_NOT_REGISTERED"}},{"html_id":"error_sxs_system_default_activation_context_empty?-instance-method","name":"error_sxs_system_default_activation_context_empty?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1921,"url":null},"def":{"name":"error_sxs_system_default_activation_context_empty?","visibility":"Public","body":"self == ERROR_SXS_SYSTEM_DEFAULT_ACTIVATION_CONTEXT_EMPTY"}},{"html_id":"error_sxs_thread_queries_disabled?-instance-method","name":"error_sxs_thread_queries_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1842,"url":null},"def":{"name":"error_sxs_thread_queries_disabled?","visibility":"Public","body":"self == ERROR_SXS_THREAD_QUERIES_DISABLED"}},{"html_id":"error_sxs_transaction_closure_incomplete?-instance-method","name":"error_sxs_transaction_closure_incomplete?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1939,"url":null},"def":{"name":"error_sxs_transaction_closure_incomplete?","visibility":"Public","body":"self == ERROR_SXS_TRANSACTION_CLOSURE_INCOMPLETE"}},{"html_id":"error_sxs_unknown_encoding?-instance-method","name":"error_sxs_unknown_encoding?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1845,"url":null},"def":{"name":"error_sxs_unknown_encoding?","visibility":"Public","body":"self == ERROR_SXS_UNKNOWN_ENCODING"}},{"html_id":"error_sxs_unknown_encoding_group?-instance-method","name":"error_sxs_unknown_encoding_group?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1844,"url":null},"def":{"name":"error_sxs_unknown_encoding_group?","visibility":"Public","body":"self == ERROR_SXS_UNKNOWN_ENCODING_GROUP"}},{"html_id":"error_sxs_untranslatable_hresult?-instance-method","name":"error_sxs_untranslatable_hresult?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1909,"url":null},"def":{"name":"error_sxs_untranslatable_hresult?","visibility":"Public","body":"self == ERROR_SXS_UNTRANSLATABLE_HRESULT"}},{"html_id":"error_sxs_version_conflict?-instance-method","name":"error_sxs_version_conflict?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1840,"url":null},"def":{"name":"error_sxs_version_conflict?","visibility":"Public","body":"self == ERROR_SXS_VERSION_CONFLICT"}},{"html_id":"error_sxs_wrong_section_type?-instance-method","name":"error_sxs_wrong_section_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1841,"url":null},"def":{"name":"error_sxs_wrong_section_type?","visibility":"Public","body":"self == ERROR_SXS_WRONG_SECTION_TYPE"}},{"html_id":"error_sxs_xml_e_badchardata?-instance-method","name":"error_sxs_xml_e_badchardata?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1868,"url":null},"def":{"name":"error_sxs_xml_e_badchardata?","visibility":"Public","body":"self == ERROR_SXS_XML_E_BADCHARDATA"}},{"html_id":"error_sxs_xml_e_badcharinstring?-instance-method","name":"error_sxs_xml_e_badcharinstring?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1866,"url":null},"def":{"name":"error_sxs_xml_e_badcharinstring?","visibility":"Public","body":"self == ERROR_SXS_XML_E_BADCHARINSTRING"}},{"html_id":"error_sxs_xml_e_badnamechar?-instance-method","name":"error_sxs_xml_e_badnamechar?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1865,"url":null},"def":{"name":"error_sxs_xml_e_badnamechar?","visibility":"Public","body":"self == ERROR_SXS_XML_E_BADNAMECHAR"}},{"html_id":"error_sxs_xml_e_badperefinsubset?-instance-method","name":"error_sxs_xml_e_badperefinsubset?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1891,"url":null},"def":{"name":"error_sxs_xml_e_badperefinsubset?","visibility":"Public","body":"self == ERROR_SXS_XML_E_BADPEREFINSUBSET"}},{"html_id":"error_sxs_xml_e_badstartnamechar?-instance-method","name":"error_sxs_xml_e_badstartnamechar?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1864,"url":null},"def":{"name":"error_sxs_xml_e_badstartnamechar?","visibility":"Public","body":"self == ERROR_SXS_XML_E_BADSTARTNAMECHAR"}},{"html_id":"error_sxs_xml_e_badxmlcase?-instance-method","name":"error_sxs_xml_e_badxmlcase?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1901,"url":null},"def":{"name":"error_sxs_xml_e_badxmlcase?","visibility":"Public","body":"self == ERROR_SXS_XML_E_BADXMLCASE"}},{"html_id":"error_sxs_xml_e_badxmldecl?-instance-method","name":"error_sxs_xml_e_badxmldecl?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1888,"url":null},"def":{"name":"error_sxs_xml_e_badxmldecl?","visibility":"Public","body":"self == ERROR_SXS_XML_E_BADXMLDECL"}},{"html_id":"error_sxs_xml_e_commentsyntax?-instance-method","name":"error_sxs_xml_e_commentsyntax?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1863,"url":null},"def":{"name":"error_sxs_xml_e_commentsyntax?","visibility":"Public","body":"self == ERROR_SXS_XML_E_COMMENTSYNTAX"}},{"html_id":"error_sxs_xml_e_duplicateattribute?-instance-method","name":"error_sxs_xml_e_duplicateattribute?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1885,"url":null},"def":{"name":"error_sxs_xml_e_duplicateattribute?","visibility":"Public","body":"self == ERROR_SXS_XML_E_DUPLICATEATTRIBUTE"}},{"html_id":"error_sxs_xml_e_expectingclosequote?-instance-method","name":"error_sxs_xml_e_expectingclosequote?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1877,"url":null},"def":{"name":"error_sxs_xml_e_expectingclosequote?","visibility":"Public","body":"self == ERROR_SXS_XML_E_EXPECTINGCLOSEQUOTE"}},{"html_id":"error_sxs_xml_e_expectingtagend?-instance-method","name":"error_sxs_xml_e_expectingtagend?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1870,"url":null},"def":{"name":"error_sxs_xml_e_expectingtagend?","visibility":"Public","body":"self == ERROR_SXS_XML_E_EXPECTINGTAGEND"}},{"html_id":"error_sxs_xml_e_incomplete_encoding?-instance-method","name":"error_sxs_xml_e_incomplete_encoding?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1875,"url":null},"def":{"name":"error_sxs_xml_e_incomplete_encoding?","visibility":"Public","body":"self == ERROR_SXS_XML_E_INCOMPLETE_ENCODING"}},{"html_id":"error_sxs_xml_e_internalerror?-instance-method","name":"error_sxs_xml_e_internalerror?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1873,"url":null},"def":{"name":"error_sxs_xml_e_internalerror?","visibility":"Public","body":"self == ERROR_SXS_XML_E_INTERNALERROR"}},{"html_id":"error_sxs_xml_e_invalid_decimal?-instance-method","name":"error_sxs_xml_e_invalid_decimal?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1879,"url":null},"def":{"name":"error_sxs_xml_e_invalid_decimal?","visibility":"Public","body":"self == ERROR_SXS_XML_E_INVALID_DECIMAL"}},{"html_id":"error_sxs_xml_e_invalid_hexidecimal?-instance-method","name":"error_sxs_xml_e_invalid_hexidecimal?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1880,"url":null},"def":{"name":"error_sxs_xml_e_invalid_hexidecimal?","visibility":"Public","body":"self == ERROR_SXS_XML_E_INVALID_HEXIDECIMAL"}},{"html_id":"error_sxs_xml_e_invalid_standalone?-instance-method","name":"error_sxs_xml_e_invalid_standalone?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1902,"url":null},"def":{"name":"error_sxs_xml_e_invalid_standalone?","visibility":"Public","body":"self == ERROR_SXS_XML_E_INVALID_STANDALONE"}},{"html_id":"error_sxs_xml_e_invalid_unicode?-instance-method","name":"error_sxs_xml_e_invalid_unicode?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1881,"url":null},"def":{"name":"error_sxs_xml_e_invalid_unicode?","visibility":"Public","body":"self == ERROR_SXS_XML_E_INVALID_UNICODE"}},{"html_id":"error_sxs_xml_e_invalid_version?-instance-method","name":"error_sxs_xml_e_invalid_version?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1904,"url":null},"def":{"name":"error_sxs_xml_e_invalid_version?","visibility":"Public","body":"self == ERROR_SXS_XML_E_INVALID_VERSION"}},{"html_id":"error_sxs_xml_e_invalidatrootlevel?-instance-method","name":"error_sxs_xml_e_invalidatrootlevel?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1887,"url":null},"def":{"name":"error_sxs_xml_e_invalidatrootlevel?","visibility":"Public","body":"self == ERROR_SXS_XML_E_INVALIDATROOTLEVEL"}},{"html_id":"error_sxs_xml_e_invalidencoding?-instance-method","name":"error_sxs_xml_e_invalidencoding?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1899,"url":null},"def":{"name":"error_sxs_xml_e_invalidencoding?","visibility":"Public","body":"self == ERROR_SXS_XML_E_INVALIDENCODING"}},{"html_id":"error_sxs_xml_e_invalidswitch?-instance-method","name":"error_sxs_xml_e_invalidswitch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1900,"url":null},"def":{"name":"error_sxs_xml_e_invalidswitch?","visibility":"Public","body":"self == ERROR_SXS_XML_E_INVALIDSWITCH"}},{"html_id":"error_sxs_xml_e_missing_paren?-instance-method","name":"error_sxs_xml_e_missing_paren?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1876,"url":null},"def":{"name":"error_sxs_xml_e_missing_paren?","visibility":"Public","body":"self == ERROR_SXS_XML_E_MISSING_PAREN"}},{"html_id":"error_sxs_xml_e_missingequals?-instance-method","name":"error_sxs_xml_e_missingequals?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1905,"url":null},"def":{"name":"error_sxs_xml_e_missingequals?","visibility":"Public","body":"self == ERROR_SXS_XML_E_MISSINGEQUALS"}},{"html_id":"error_sxs_xml_e_missingquote?-instance-method","name":"error_sxs_xml_e_missingquote?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1862,"url":null},"def":{"name":"error_sxs_xml_e_missingquote?","visibility":"Public","body":"self == ERROR_SXS_XML_E_MISSINGQUOTE"}},{"html_id":"error_sxs_xml_e_missingroot?-instance-method","name":"error_sxs_xml_e_missingroot?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1889,"url":null},"def":{"name":"error_sxs_xml_e_missingroot?","visibility":"Public","body":"self == ERROR_SXS_XML_E_MISSINGROOT"}},{"html_id":"error_sxs_xml_e_missingsemicolon?-instance-method","name":"error_sxs_xml_e_missingsemicolon?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1871,"url":null},"def":{"name":"error_sxs_xml_e_missingsemicolon?","visibility":"Public","body":"self == ERROR_SXS_XML_E_MISSINGSEMICOLON"}},{"html_id":"error_sxs_xml_e_missingwhitespace?-instance-method","name":"error_sxs_xml_e_missingwhitespace?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1869,"url":null},"def":{"name":"error_sxs_xml_e_missingwhitespace?","visibility":"Public","body":"self == ERROR_SXS_XML_E_MISSINGWHITESPACE"}},{"html_id":"error_sxs_xml_e_multiple_colons?-instance-method","name":"error_sxs_xml_e_multiple_colons?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1878,"url":null},"def":{"name":"error_sxs_xml_e_multiple_colons?","visibility":"Public","body":"self == ERROR_SXS_XML_E_MULTIPLE_COLONS"}},{"html_id":"error_sxs_xml_e_multipleroots?-instance-method","name":"error_sxs_xml_e_multipleroots?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1886,"url":null},"def":{"name":"error_sxs_xml_e_multipleroots?","visibility":"Public","body":"self == ERROR_SXS_XML_E_MULTIPLEROOTS"}},{"html_id":"error_sxs_xml_e_reservednamespace?-instance-method","name":"error_sxs_xml_e_reservednamespace?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1898,"url":null},"def":{"name":"error_sxs_xml_e_reservednamespace?","visibility":"Public","body":"self == ERROR_SXS_XML_E_RESERVEDNAMESPACE"}},{"html_id":"error_sxs_xml_e_unbalancedparen?-instance-method","name":"error_sxs_xml_e_unbalancedparen?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1872,"url":null},"def":{"name":"error_sxs_xml_e_unbalancedparen?","visibility":"Public","body":"self == ERROR_SXS_XML_E_UNBALANCEDPAREN"}},{"html_id":"error_sxs_xml_e_unclosedcdata?-instance-method","name":"error_sxs_xml_e_unclosedcdata?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1897,"url":null},"def":{"name":"error_sxs_xml_e_unclosedcdata?","visibility":"Public","body":"self == ERROR_SXS_XML_E_UNCLOSEDCDATA"}},{"html_id":"error_sxs_xml_e_unclosedcomment?-instance-method","name":"error_sxs_xml_e_unclosedcomment?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1895,"url":null},"def":{"name":"error_sxs_xml_e_unclosedcomment?","visibility":"Public","body":"self == ERROR_SXS_XML_E_UNCLOSEDCOMMENT"}},{"html_id":"error_sxs_xml_e_uncloseddecl?-instance-method","name":"error_sxs_xml_e_uncloseddecl?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1896,"url":null},"def":{"name":"error_sxs_xml_e_uncloseddecl?","visibility":"Public","body":"self == ERROR_SXS_XML_E_UNCLOSEDDECL"}},{"html_id":"error_sxs_xml_e_unclosedendtag?-instance-method","name":"error_sxs_xml_e_unclosedendtag?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1893,"url":null},"def":{"name":"error_sxs_xml_e_unclosedendtag?","visibility":"Public","body":"self == ERROR_SXS_XML_E_UNCLOSEDENDTAG"}},{"html_id":"error_sxs_xml_e_unclosedstarttag?-instance-method","name":"error_sxs_xml_e_unclosedstarttag?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1892,"url":null},"def":{"name":"error_sxs_xml_e_unclosedstarttag?","visibility":"Public","body":"self == ERROR_SXS_XML_E_UNCLOSEDSTARTTAG"}},{"html_id":"error_sxs_xml_e_unclosedstring?-instance-method","name":"error_sxs_xml_e_unclosedstring?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1894,"url":null},"def":{"name":"error_sxs_xml_e_unclosedstring?","visibility":"Public","body":"self == ERROR_SXS_XML_E_UNCLOSEDSTRING"}},{"html_id":"error_sxs_xml_e_unclosedtag?-instance-method","name":"error_sxs_xml_e_unclosedtag?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1884,"url":null},"def":{"name":"error_sxs_xml_e_unclosedtag?","visibility":"Public","body":"self == ERROR_SXS_XML_E_UNCLOSEDTAG"}},{"html_id":"error_sxs_xml_e_unexpected_standalone?-instance-method","name":"error_sxs_xml_e_unexpected_standalone?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1903,"url":null},"def":{"name":"error_sxs_xml_e_unexpected_standalone?","visibility":"Public","body":"self == ERROR_SXS_XML_E_UNEXPECTED_STANDALONE"}},{"html_id":"error_sxs_xml_e_unexpected_whitespace?-instance-method","name":"error_sxs_xml_e_unexpected_whitespace?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1874,"url":null},"def":{"name":"error_sxs_xml_e_unexpected_whitespace?","visibility":"Public","body":"self == ERROR_SXS_XML_E_UNEXPECTED_WHITESPACE"}},{"html_id":"error_sxs_xml_e_unexpectedendtag?-instance-method","name":"error_sxs_xml_e_unexpectedendtag?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1883,"url":null},"def":{"name":"error_sxs_xml_e_unexpectedendtag?","visibility":"Public","body":"self == ERROR_SXS_XML_E_UNEXPECTEDENDTAG"}},{"html_id":"error_sxs_xml_e_unexpectedeof?-instance-method","name":"error_sxs_xml_e_unexpectedeof?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1890,"url":null},"def":{"name":"error_sxs_xml_e_unexpectedeof?","visibility":"Public","body":"self == ERROR_SXS_XML_E_UNEXPECTEDEOF"}},{"html_id":"error_sxs_xml_e_whitespaceorquestionmark?-instance-method","name":"error_sxs_xml_e_whitespaceorquestionmark?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1882,"url":null},"def":{"name":"error_sxs_xml_e_whitespaceorquestionmark?","visibility":"Public","body":"self == ERROR_SXS_XML_E_WHITESPACEORQUESTIONMARK"}},{"html_id":"error_sxs_xml_e_xmldeclsyntax?-instance-method","name":"error_sxs_xml_e_xmldeclsyntax?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1867,"url":null},"def":{"name":"error_sxs_xml_e_xmldeclsyntax?","visibility":"Public","body":"self == ERROR_SXS_XML_E_XMLDECLSYNTAX"}},{"html_id":"error_sync_foreground_refresh_required?-instance-method","name":"error_sync_foreground_refresh_required?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":569,"url":null},"def":{"name":"error_sync_foreground_refresh_required?","visibility":"Public","body":"self == ERROR_SYNC_FOREGROUND_REFRESH_REQUIRED"}},{"html_id":"error_system_device_not_found?-instance-method","name":"error_system_device_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2176,"url":null},"def":{"name":"error_system_device_not_found?","visibility":"Public","body":"self == ERROR_SYSTEM_DEVICE_NOT_FOUND"}},{"html_id":"error_system_needs_remediation?-instance-method","name":"error_system_needs_remediation?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2216,"url":null},"def":{"name":"error_system_needs_remediation?","visibility":"Public","body":"self == ERROR_SYSTEM_NEEDS_REMEDIATION"}},{"html_id":"error_system_trace?-instance-method","name":"error_system_trace?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":275,"url":null},"def":{"name":"error_system_trace?","visibility":"Public","body":"self == ERROR_SYSTEM_TRACE"}},{"html_id":"error_tag_not_found?-instance-method","name":"error_tag_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":970,"url":null},"def":{"name":"error_tag_not_found?","visibility":"Public","body":"self == ERROR_TAG_NOT_FOUND"}},{"html_id":"error_tag_not_present?-instance-method","name":"error_tag_not_present?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":971,"url":null},"def":{"name":"error_tag_not_present?","visibility":"Public","body":"self == ERROR_TAG_NOT_PRESENT"}},{"html_id":"error_thread_1_inactive?-instance-method","name":"error_thread_1_inactive?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":319,"url":null},"def":{"name":"error_thread_1_inactive?","visibility":"Public","body":"self == ERROR_THREAD_1_INACTIVE"}},{"html_id":"error_time_skew?-instance-method","name":"error_time_skew?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":680,"url":null},"def":{"name":"error_time_skew?","visibility":"Public","body":"self == ERROR_TIME_SKEW"}},{"html_id":"error_timeout?-instance-method","name":"error_timeout?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":742,"url":null},"def":{"name":"error_timeout?","visibility":"Public","body":"self == ERROR_TIMEOUT"}},{"html_id":"error_tlw_with_wschild?-instance-method","name":"error_tlw_with_wschild?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":688,"url":null},"def":{"name":"error_tlw_with_wschild?","visibility":"Public","body":"self == ERROR_TLW_WITH_WSCHILD"}},{"html_id":"error_token_already_in_use?-instance-method","name":"error_token_already_in_use?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":657,"url":null},"def":{"name":"error_token_already_in_use?","visibility":"Public","body":"self == ERROR_TOKEN_ALREADY_IN_USE"}},{"html_id":"error_too_many_cmds?-instance-method","name":"error_too_many_cmds?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":201,"url":null},"def":{"name":"error_too_many_cmds?","visibility":"Public","body":"self == ERROR_TOO_MANY_CMDS"}},{"html_id":"error_too_many_context_ids?-instance-method","name":"error_too_many_context_ids?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":666,"url":null},"def":{"name":"error_too_many_context_ids?","visibility":"Public","body":"self == ERROR_TOO_MANY_CONTEXT_IDS"}},{"html_id":"error_too_many_links?-instance-method","name":"error_too_many_links?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":469,"url":null},"def":{"name":"error_too_many_links?","visibility":"Public","body":"self == ERROR_TOO_MANY_LINKS"}},{"html_id":"error_too_many_luids_requested?-instance-method","name":"error_too_many_luids_requested?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":616,"url":null},"def":{"name":"error_too_many_luids_requested?","visibility":"Public","body":"self == ERROR_TOO_MANY_LUIDS_REQUESTED"}},{"html_id":"error_too_many_modules?-instance-method","name":"error_too_many_modules?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":321,"url":null},"def":{"name":"error_too_many_modules?","visibility":"Public","body":"self == ERROR_TOO_MANY_MODULES"}},{"html_id":"error_too_many_muxwaiters?-instance-method","name":"error_too_many_muxwaiters?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":277,"url":null},"def":{"name":"error_too_many_muxwaiters?","visibility":"Public","body":"self == ERROR_TOO_MANY_MUXWAITERS"}},{"html_id":"error_too_many_names?-instance-method","name":"error_too_many_names?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":213,"url":null},"def":{"name":"error_too_many_names?","visibility":"Public","body":"self == ERROR_TOO_MANY_NAMES"}},{"html_id":"error_too_many_open_files?-instance-method","name":"error_too_many_open_files?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":161,"url":null},"def":{"name":"error_too_many_open_files?","visibility":"Public","body":"self == ERROR_TOO_MANY_OPEN_FILES"}},{"html_id":"error_too_many_posts?-instance-method","name":"error_too_many_posts?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":350,"url":null},"def":{"name":"error_too_many_posts?","visibility":"Public","body":"self == ERROR_TOO_MANY_POSTS"}},{"html_id":"error_too_many_secrets?-instance-method","name":"error_too_many_secrets?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":663,"url":null},"def":{"name":"error_too_many_secrets?","visibility":"Public","body":"self == ERROR_TOO_MANY_SECRETS"}},{"html_id":"error_too_many_sem_requests?-instance-method","name":"error_too_many_sem_requests?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":230,"url":null},"def":{"name":"error_too_many_sem_requests?","visibility":"Public","body":"self == ERROR_TOO_MANY_SEM_REQUESTS"}},{"html_id":"error_too_many_semaphores?-instance-method","name":"error_too_many_semaphores?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":227,"url":null},"def":{"name":"error_too_many_semaphores?","visibility":"Public","body":"self == ERROR_TOO_MANY_SEMAPHORES"}},{"html_id":"error_too_many_sess?-instance-method","name":"error_too_many_sess?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":214,"url":null},"def":{"name":"error_too_many_sess?","visibility":"Public","body":"self == ERROR_TOO_MANY_SESS"}},{"html_id":"error_too_many_sids?-instance-method","name":"error_too_many_sids?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":671,"url":null},"def":{"name":"error_too_many_sids?","visibility":"Public","body":"self == ERROR_TOO_MANY_SIDS"}},{"html_id":"error_too_many_tcbs?-instance-method","name":"error_too_many_tcbs?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":280,"url":null},"def":{"name":"error_too_many_tcbs?","visibility":"Public","body":"self == ERROR_TOO_MANY_TCBS"}},{"html_id":"error_transform_not_supported?-instance-method","name":"error_transform_not_supported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":966,"url":null},"def":{"name":"error_transform_not_supported?","visibility":"Public","body":"self == ERROR_TRANSFORM_NOT_SUPPORTED"}},{"html_id":"error_transport_full?-instance-method","name":"error_transport_full?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1054,"url":null},"def":{"name":"error_transport_full?","visibility":"Public","body":"self == ERROR_TRANSPORT_FULL"}},{"html_id":"error_trust_failure?-instance-method","name":"error_trust_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":880,"url":null},"def":{"name":"error_trust_failure?","visibility":"Public","body":"self == ERROR_TRUST_FAILURE"}},{"html_id":"error_trusted_domain_failure?-instance-method","name":"error_trusted_domain_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":878,"url":null},"def":{"name":"error_trusted_domain_failure?","visibility":"Public","body":"self == ERROR_TRUSTED_DOMAIN_FAILURE"}},{"html_id":"error_trusted_relationship_failure?-instance-method","name":"error_trusted_relationship_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":879,"url":null},"def":{"name":"error_trusted_relationship_failure?","visibility":"Public","body":"self == ERROR_TRUSTED_RELATIONSHIP_FAILURE"}},{"html_id":"error_unable_to_clean?-instance-method","name":"error_unable_to_clean?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1037,"url":null},"def":{"name":"error_unable_to_clean?","visibility":"Public","body":"self == ERROR_UNABLE_TO_CLEAN"}},{"html_id":"error_unable_to_eject_mounted_media?-instance-method","name":"error_unable_to_eject_mounted_media?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1056,"url":null},"def":{"name":"error_unable_to_eject_mounted_media?","visibility":"Public","body":"self == ERROR_UNABLE_TO_EJECT_MOUNTED_MEDIA"}},{"html_id":"error_unable_to_inventory_drive?-instance-method","name":"error_unable_to_inventory_drive?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1051,"url":null},"def":{"name":"error_unable_to_inventory_drive?","visibility":"Public","body":"self == ERROR_UNABLE_TO_INVENTORY_DRIVE"}},{"html_id":"error_unable_to_inventory_slot?-instance-method","name":"error_unable_to_inventory_slot?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1052,"url":null},"def":{"name":"error_unable_to_inventory_slot?","visibility":"Public","body":"self == ERROR_UNABLE_TO_INVENTORY_SLOT"}},{"html_id":"error_unable_to_inventory_transport?-instance-method","name":"error_unable_to_inventory_transport?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1053,"url":null},"def":{"name":"error_unable_to_inventory_transport?","visibility":"Public","body":"self == ERROR_UNABLE_TO_INVENTORY_TRANSPORT"}},{"html_id":"error_unable_to_load_medium?-instance-method","name":"error_unable_to_load_medium?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1050,"url":null},"def":{"name":"error_unable_to_load_medium?","visibility":"Public","body":"self == ERROR_UNABLE_TO_LOAD_MEDIUM"}},{"html_id":"error_unable_to_lock_media?-instance-method","name":"error_unable_to_lock_media?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":442,"url":null},"def":{"name":"error_unable_to_lock_media?","visibility":"Public","body":"self == ERROR_UNABLE_TO_LOCK_MEDIA"}},{"html_id":"error_unable_to_move_replacement?-instance-method","name":"error_unable_to_move_replacement?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":495,"url":null},"def":{"name":"error_unable_to_move_replacement?","visibility":"Public","body":"self == ERROR_UNABLE_TO_MOVE_REPLACEMENT"}},{"html_id":"error_unable_to_move_replacement_2?-instance-method","name":"error_unable_to_move_replacement_2?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":496,"url":null},"def":{"name":"error_unable_to_move_replacement_2?","visibility":"Public","body":"self == ERROR_UNABLE_TO_MOVE_REPLACEMENT_2"}},{"html_id":"error_unable_to_remove_replaced?-instance-method","name":"error_unable_to_remove_replaced?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":494,"url":null},"def":{"name":"error_unable_to_remove_replaced?","visibility":"Public","body":"self == ERROR_UNABLE_TO_REMOVE_REPLACED"}},{"html_id":"error_unable_to_unload_media?-instance-method","name":"error_unable_to_unload_media?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":443,"url":null},"def":{"name":"error_unable_to_unload_media?","visibility":"Public","body":"self == ERROR_UNABLE_TO_UNLOAD_MEDIA"}},{"html_id":"error_unexp_net_err?-instance-method","name":"error_unexp_net_err?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":204,"url":null},"def":{"name":"error_unexp_net_err?","visibility":"Public","body":"self == ERROR_UNEXP_NET_ERR"}},{"html_id":"error_unexpected_omid?-instance-method","name":"error_unexpected_omid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1060,"url":null},"def":{"name":"error_unexpected_omid?","visibility":"Public","body":"self == ERROR_UNEXPECTED_OMID"}},{"html_id":"error_unidentified_error?-instance-method","name":"error_unidentified_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":582,"url":null},"def":{"name":"error_unidentified_error?","visibility":"Public","body":"self == ERROR_UNIDENTIFIED_ERROR"}},{"html_id":"error_unknown_component?-instance-method","name":"error_unknown_component?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":755,"url":null},"def":{"name":"error_unknown_component?","visibility":"Public","body":"self == ERROR_UNKNOWN_COMPONENT"}},{"html_id":"error_unknown_feature?-instance-method","name":"error_unknown_feature?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":754,"url":null},"def":{"name":"error_unknown_feature?","visibility":"Public","body":"self == ERROR_UNKNOWN_FEATURE"}},{"html_id":"error_unknown_port?-instance-method","name":"error_unknown_port?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":886,"url":null},"def":{"name":"error_unknown_port?","visibility":"Public","body":"self == ERROR_UNKNOWN_PORT"}},{"html_id":"error_unknown_print_monitor?-instance-method","name":"error_unknown_print_monitor?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":988,"url":null},"def":{"name":"error_unknown_print_monitor?","visibility":"Public","body":"self == ERROR_UNKNOWN_PRINT_MONITOR"}},{"html_id":"error_unknown_printer_driver?-instance-method","name":"error_unknown_printer_driver?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":887,"url":null},"def":{"name":"error_unknown_printer_driver?","visibility":"Public","body":"self == ERROR_UNKNOWN_PRINTER_DRIVER"}},{"html_id":"error_unknown_printprocessor?-instance-method","name":"error_unknown_printprocessor?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":888,"url":null},"def":{"name":"error_unknown_printprocessor?","visibility":"Public","body":"self == ERROR_UNKNOWN_PRINTPROCESSOR"}},{"html_id":"error_unknown_product?-instance-method","name":"error_unknown_product?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":753,"url":null},"def":{"name":"error_unknown_product?","visibility":"Public","body":"self == ERROR_UNKNOWN_PRODUCT"}},{"html_id":"error_unknown_property?-instance-method","name":"error_unknown_property?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":756,"url":null},"def":{"name":"error_unknown_property?","visibility":"Public","body":"self == ERROR_UNKNOWN_PROPERTY"}},{"html_id":"error_unknown_revision?-instance-method","name":"error_unknown_revision?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":588,"url":null},"def":{"name":"error_unknown_revision?","visibility":"Public","body":"self == ERROR_UNKNOWN_REVISION"}},{"html_id":"error_unmapped_substitution_string?-instance-method","name":"error_unmapped_substitution_string?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1928,"url":null},"def":{"name":"error_unmapped_substitution_string?","visibility":"Public","body":"self == ERROR_UNMAPPED_SUBSTITUTION_STRING"}},{"html_id":"error_unrecognized_media?-instance-method","name":"error_unrecognized_media?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":875,"url":null},"def":{"name":"error_unrecognized_media?","visibility":"Public","body":"self == ERROR_UNRECOGNIZED_MEDIA"}},{"html_id":"error_unrecognized_volume?-instance-method","name":"error_unrecognized_volume?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":382,"url":null},"def":{"name":"error_unrecognized_volume?","visibility":"Public","body":"self == ERROR_UNRECOGNIZED_VOLUME"}},{"html_id":"error_unsupported_type?-instance-method","name":"error_unsupported_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":778,"url":null},"def":{"name":"error_unsupported_type?","visibility":"Public","body":"self == ERROR_UNSUPPORTED_TYPE"}},{"html_id":"error_user_apc?-instance-method","name":"error_user_apc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":369,"url":null},"def":{"name":"error_user_apc?","visibility":"Public","body":"self == ERROR_USER_APC"}},{"html_id":"error_user_delete_trust_quota_exceeded?-instance-method","name":"error_user_delete_trust_quota_exceeded?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":959,"url":null},"def":{"name":"error_user_delete_trust_quota_exceeded?","visibility":"Public","body":"self == ERROR_USER_DELETE_TRUST_QUOTA_EXCEEDED"}},{"html_id":"error_user_exists?-instance-method","name":"error_user_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":599,"url":null},"def":{"name":"error_user_exists?","visibility":"Public","body":"self == ERROR_USER_EXISTS"}},{"html_id":"error_user_mapped_file?-instance-method","name":"error_user_mapped_file?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":525,"url":null},"def":{"name":"error_user_mapped_file?","visibility":"Public","body":"self == ERROR_USER_MAPPED_FILE"}},{"html_id":"error_vc_disconnected?-instance-method","name":"error_vc_disconnected?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":337,"url":null},"def":{"name":"error_vc_disconnected?","visibility":"Public","body":"self == ERROR_VC_DISCONNECTED"}},{"html_id":"error_vdm_disallowed?-instance-method","name":"error_vdm_disallowed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":581,"url":null},"def":{"name":"error_vdm_disallowed?","visibility":"Public","body":"self == ERROR_VDM_DISALLOWED"}},{"html_id":"error_volume_contains_sys_files?-instance-method","name":"error_volume_contains_sys_files?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1063,"url":null},"def":{"name":"error_volume_contains_sys_files?","visibility":"Public","body":"self == ERROR_VOLUME_CONTAINS_SYS_FILES"}},{"html_id":"error_volume_not_sis_enabled?-instance-method","name":"error_volume_not_sis_enabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1076,"url":null},"def":{"name":"error_volume_not_sis_enabled?","visibility":"Public","body":"self == ERROR_VOLUME_NOT_SIS_ENABLED"}},{"html_id":"error_volume_not_support_efs?-instance-method","name":"error_volume_not_support_efs?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1195,"url":null},"def":{"name":"error_volume_not_support_efs?","visibility":"Public","body":"self == ERROR_VOLUME_NOT_SUPPORT_EFS"}},{"html_id":"error_wait_1?-instance-method","name":"error_wait_1?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":363,"url":null},"def":{"name":"error_wait_1?","visibility":"Public","body":"self == ERROR_WAIT_1"}},{"html_id":"error_wait_2?-instance-method","name":"error_wait_2?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":364,"url":null},"def":{"name":"error_wait_2?","visibility":"Public","body":"self == ERROR_WAIT_2"}},{"html_id":"error_wait_3?-instance-method","name":"error_wait_3?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":365,"url":null},"def":{"name":"error_wait_3?","visibility":"Public","body":"self == ERROR_WAIT_3"}},{"html_id":"error_wait_63?-instance-method","name":"error_wait_63?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":366,"url":null},"def":{"name":"error_wait_63?","visibility":"Public","body":"self == ERROR_WAIT_63"}},{"html_id":"error_wait_no_children?-instance-method","name":"error_wait_no_children?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":253,"url":null},"def":{"name":"error_wait_no_children?","visibility":"Public","body":"self == ERROR_WAIT_NO_CHILDREN"}},{"html_id":"error_wake_system?-instance-method","name":"error_wake_system?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":362,"url":null},"def":{"name":"error_wake_system?","visibility":"Public","body":"self == ERROR_WAKE_SYSTEM"}},{"html_id":"error_window_not_combobox?-instance-method","name":"error_window_not_combobox?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":705,"url":null},"def":{"name":"error_window_not_combobox?","visibility":"Public","body":"self == ERROR_WINDOW_NOT_COMBOBOX"}},{"html_id":"error_window_not_dialog?-instance-method","name":"error_window_not_dialog?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":702,"url":null},"def":{"name":"error_window_not_dialog?","visibility":"Public","body":"self == ERROR_WINDOW_NOT_DIALOG"}},{"html_id":"error_window_of_other_thread?-instance-method","name":"error_window_of_other_thread?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":690,"url":null},"def":{"name":"error_window_of_other_thread?","visibility":"Public","body":"self == ERROR_WINDOW_OF_OTHER_THREAD"}},{"html_id":"error_wins_internal?-instance-method","name":"error_wins_internal?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1003,"url":null},"def":{"name":"error_wins_internal?","visibility":"Public","body":"self == ERROR_WINS_INTERNAL"}},{"html_id":"error_wmi_already_disabled?-instance-method","name":"error_wmi_already_disabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1023,"url":null},"def":{"name":"error_wmi_already_disabled?","visibility":"Public","body":"self == ERROR_WMI_ALREADY_DISABLED"}},{"html_id":"error_wmi_already_enabled?-instance-method","name":"error_wmi_already_enabled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1017,"url":null},"def":{"name":"error_wmi_already_enabled?","visibility":"Public","body":"self == ERROR_WMI_ALREADY_ENABLED"}},{"html_id":"error_wmi_dp_failed?-instance-method","name":"error_wmi_dp_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1020,"url":null},"def":{"name":"error_wmi_dp_failed?","visibility":"Public","body":"self == ERROR_WMI_DP_FAILED"}},{"html_id":"error_wmi_dp_not_found?-instance-method","name":"error_wmi_dp_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1015,"url":null},"def":{"name":"error_wmi_dp_not_found?","visibility":"Public","body":"self == ERROR_WMI_DP_NOT_FOUND"}},{"html_id":"error_wmi_guid_disconnected?-instance-method","name":"error_wmi_guid_disconnected?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1018,"url":null},"def":{"name":"error_wmi_guid_disconnected?","visibility":"Public","body":"self == ERROR_WMI_GUID_DISCONNECTED"}},{"html_id":"error_wmi_guid_not_found?-instance-method","name":"error_wmi_guid_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1011,"url":null},"def":{"name":"error_wmi_guid_not_found?","visibility":"Public","body":"self == ERROR_WMI_GUID_NOT_FOUND"}},{"html_id":"error_wmi_instance_not_found?-instance-method","name":"error_wmi_instance_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1012,"url":null},"def":{"name":"error_wmi_instance_not_found?","visibility":"Public","body":"self == ERROR_WMI_INSTANCE_NOT_FOUND"}},{"html_id":"error_wmi_invalid_mof?-instance-method","name":"error_wmi_invalid_mof?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1021,"url":null},"def":{"name":"error_wmi_invalid_mof?","visibility":"Public","body":"self == ERROR_WMI_INVALID_MOF"}},{"html_id":"error_wmi_invalid_reginfo?-instance-method","name":"error_wmi_invalid_reginfo?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1022,"url":null},"def":{"name":"error_wmi_invalid_reginfo?","visibility":"Public","body":"self == ERROR_WMI_INVALID_REGINFO"}},{"html_id":"error_wmi_itemid_not_found?-instance-method","name":"error_wmi_itemid_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1013,"url":null},"def":{"name":"error_wmi_itemid_not_found?","visibility":"Public","body":"self == ERROR_WMI_ITEMID_NOT_FOUND"}},{"html_id":"error_wmi_read_only?-instance-method","name":"error_wmi_read_only?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1024,"url":null},"def":{"name":"error_wmi_read_only?","visibility":"Public","body":"self == ERROR_WMI_READ_ONLY"}},{"html_id":"error_wmi_server_unavailable?-instance-method","name":"error_wmi_server_unavailable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1019,"url":null},"def":{"name":"error_wmi_server_unavailable?","visibility":"Public","body":"self == ERROR_WMI_SERVER_UNAVAILABLE"}},{"html_id":"error_wmi_set_failure?-instance-method","name":"error_wmi_set_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1025,"url":null},"def":{"name":"error_wmi_set_failure?","visibility":"Public","body":"self == ERROR_WMI_SET_FAILURE"}},{"html_id":"error_wmi_try_again?-instance-method","name":"error_wmi_try_again?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1014,"url":null},"def":{"name":"error_wmi_try_again?","visibility":"Public","body":"self == ERROR_WMI_TRY_AGAIN"}},{"html_id":"error_wmi_unresolved_instance_ref?-instance-method","name":"error_wmi_unresolved_instance_ref?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1016,"url":null},"def":{"name":"error_wmi_unresolved_instance_ref?","visibility":"Public","body":"self == ERROR_WMI_UNRESOLVED_INSTANCE_REF"}},{"html_id":"error_working_set_quota?-instance-method","name":"error_working_set_quota?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":735,"url":null},"def":{"name":"error_working_set_quota?","visibility":"Public","body":"self == ERROR_WORKING_SET_QUOTA"}},{"html_id":"error_write_fault?-instance-method","name":"error_write_fault?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":186,"url":null},"def":{"name":"error_write_fault?","visibility":"Public","body":"self == ERROR_WRITE_FAULT"}},{"html_id":"error_write_protect?-instance-method","name":"error_write_protect?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":176,"url":null},"def":{"name":"error_write_protect?","visibility":"Public","body":"self == ERROR_WRITE_PROTECT"}},{"html_id":"error_wrong_disk?-instance-method","name":"error_wrong_disk?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":191,"url":null},"def":{"name":"error_wrong_disk?","visibility":"Public","body":"self == ERROR_WRONG_DISK"}},{"html_id":"error_wrong_efs?-instance-method","name":"error_wrong_efs?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1186,"url":null},"def":{"name":"error_wrong_efs?","visibility":"Public","body":"self == ERROR_WRONG_EFS"}},{"html_id":"error_wrong_password?-instance-method","name":"error_wrong_password?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":606,"url":null},"def":{"name":"error_wrong_password?","visibility":"Public","body":"self == ERROR_WRONG_PASSWORD"}},{"html_id":"error_wrong_target_name?-instance-method","name":"error_wrong_target_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":678,"url":null},"def":{"name":"error_wrong_target_name?","visibility":"Public","body":"self == ERROR_WRONG_TARGET_NAME"}},{"html_id":"error_xml_encoding_mismatch?-instance-method","name":"error_xml_encoding_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1932,"url":null},"def":{"name":"error_xml_encoding_mismatch?","visibility":"Public","body":"self == ERROR_XML_ENCODING_MISMATCH"}},{"html_id":"frs_err_authentication?-instance-method","name":"frs_err_authentication?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1247,"url":null},"def":{"name":"frs_err_authentication?","visibility":"Public","body":"self == FRS_ERR_AUTHENTICATION"}},{"html_id":"frs_err_child_to_parent_comm?-instance-method","name":"frs_err_child_to_parent_comm?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1250,"url":null},"def":{"name":"frs_err_child_to_parent_comm?","visibility":"Public","body":"self == FRS_ERR_CHILD_TO_PARENT_COMM"}},{"html_id":"frs_err_insufficient_priv?-instance-method","name":"frs_err_insufficient_priv?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1246,"url":null},"def":{"name":"frs_err_insufficient_priv?","visibility":"Public","body":"self == FRS_ERR_INSUFFICIENT_PRIV"}},{"html_id":"frs_err_internal?-instance-method","name":"frs_err_internal?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1244,"url":null},"def":{"name":"frs_err_internal?","visibility":"Public","body":"self == FRS_ERR_INTERNAL"}},{"html_id":"frs_err_internal_api?-instance-method","name":"frs_err_internal_api?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1243,"url":null},"def":{"name":"frs_err_internal_api?","visibility":"Public","body":"self == FRS_ERR_INTERNAL_API"}},{"html_id":"frs_err_invalid_api_sequence?-instance-method","name":"frs_err_invalid_api_sequence?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1240,"url":null},"def":{"name":"frs_err_invalid_api_sequence?","visibility":"Public","body":"self == FRS_ERR_INVALID_API_SEQUENCE"}},{"html_id":"frs_err_invalid_service_parameter?-instance-method","name":"frs_err_invalid_service_parameter?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1256,"url":null},"def":{"name":"frs_err_invalid_service_parameter?","visibility":"Public","body":"self == FRS_ERR_INVALID_SERVICE_PARAMETER"}},{"html_id":"frs_err_parent_authentication?-instance-method","name":"frs_err_parent_authentication?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1249,"url":null},"def":{"name":"frs_err_parent_authentication?","visibility":"Public","body":"self == FRS_ERR_PARENT_AUTHENTICATION"}},{"html_id":"frs_err_parent_insufficient_priv?-instance-method","name":"frs_err_parent_insufficient_priv?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1248,"url":null},"def":{"name":"frs_err_parent_insufficient_priv?","visibility":"Public","body":"self == FRS_ERR_PARENT_INSUFFICIENT_PRIV"}},{"html_id":"frs_err_parent_to_child_comm?-instance-method","name":"frs_err_parent_to_child_comm?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1251,"url":null},"def":{"name":"frs_err_parent_to_child_comm?","visibility":"Public","body":"self == FRS_ERR_PARENT_TO_CHILD_COMM"}},{"html_id":"frs_err_service_comm?-instance-method","name":"frs_err_service_comm?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1245,"url":null},"def":{"name":"frs_err_service_comm?","visibility":"Public","body":"self == FRS_ERR_SERVICE_COMM"}},{"html_id":"frs_err_starting_service?-instance-method","name":"frs_err_starting_service?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1241,"url":null},"def":{"name":"frs_err_starting_service?","visibility":"Public","body":"self == FRS_ERR_STARTING_SERVICE"}},{"html_id":"frs_err_stopping_service?-instance-method","name":"frs_err_stopping_service?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1242,"url":null},"def":{"name":"frs_err_stopping_service?","visibility":"Public","body":"self == FRS_ERR_STOPPING_SERVICE"}},{"html_id":"frs_err_sysvol_demote?-instance-method","name":"frs_err_sysvol_demote?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1255,"url":null},"def":{"name":"frs_err_sysvol_demote?","visibility":"Public","body":"self == FRS_ERR_SYSVOL_DEMOTE"}},{"html_id":"frs_err_sysvol_is_busy?-instance-method","name":"frs_err_sysvol_is_busy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1254,"url":null},"def":{"name":"frs_err_sysvol_is_busy?","visibility":"Public","body":"self == FRS_ERR_SYSVOL_IS_BUSY"}},{"html_id":"frs_err_sysvol_populate?-instance-method","name":"frs_err_sysvol_populate?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1252,"url":null},"def":{"name":"frs_err_sysvol_populate?","visibility":"Public","body":"self == FRS_ERR_SYSVOL_POPULATE"}},{"html_id":"frs_err_sysvol_populate_timeout?-instance-method","name":"frs_err_sysvol_populate_timeout?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1253,"url":null},"def":{"name":"frs_err_sysvol_populate_timeout?","visibility":"Public","body":"self == FRS_ERR_SYSVOL_POPULATE_TIMEOUT"}},{"html_id":"message:String-instance-method","name":"message","doc":"Returns the system error message associated with this error code.\n\nThe message is retrieved via [`FormatMessageW`](https://docs.microsoft.com/en-us/windows/win32/api/winbase/nf-winbase-formatmessagew)\nusing the current default `LANGID`.\n\nOn non-win32 platforms the result is always an empty string.","summary":"<p>Returns the system error message associated with this error code.</p>","abstract":false,"location":{"filename":"src/winerror.cr","line_number":63,"url":null},"def":{"name":"message","return_type":"String","visibility":"Public","body":"{% if flag?(:win32) %}\n      buffer = uninitialized UInt16[256]\n      size = LibC.FormatMessageW(LibC::FORMAT_MESSAGE_FROM_SYSTEM, nil, value, 0, buffer, buffer.size, nil)\n      String.from_utf16(buffer.to_slice[0, size]).strip\n    {% else %}\n      \"\"\n    {% end %}"}},{"html_id":"or_invalid_oid?-instance-method","name":"or_invalid_oid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":936,"url":null},"def":{"name":"or_invalid_oid?","visibility":"Public","body":"self == OR_INVALID_OID"}},{"html_id":"or_invalid_oxid?-instance-method","name":"or_invalid_oxid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":935,"url":null},"def":{"name":"or_invalid_oxid?","visibility":"Public","body":"self == OR_INVALID_OXID"}},{"html_id":"or_invalid_set?-instance-method","name":"or_invalid_set?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":937,"url":null},"def":{"name":"or_invalid_set?","visibility":"Public","body":"self == OR_INVALID_SET"}},{"html_id":"rpc_s_address_error?-instance-method","name":"rpc_s_address_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":859,"url":null},"def":{"name":"rpc_s_address_error?","visibility":"Public","body":"self == RPC_S_ADDRESS_ERROR"}},{"html_id":"rpc_s_already_listening?-instance-method","name":"rpc_s_already_listening?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":807,"url":null},"def":{"name":"rpc_s_already_listening?","visibility":"Public","body":"self == RPC_S_ALREADY_LISTENING"}},{"html_id":"rpc_s_already_registered?-instance-method","name":"rpc_s_already_registered?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":805,"url":null},"def":{"name":"rpc_s_already_registered?","visibility":"Public","body":"self == RPC_S_ALREADY_REGISTERED"}},{"html_id":"rpc_s_binding_has_no_auth?-instance-method","name":"rpc_s_binding_has_no_auth?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":837,"url":null},"def":{"name":"rpc_s_binding_has_no_auth?","visibility":"Public","body":"self == RPC_S_BINDING_HAS_NO_AUTH"}},{"html_id":"rpc_s_binding_incomplete?-instance-method","name":"rpc_s_binding_incomplete?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":909,"url":null},"def":{"name":"rpc_s_binding_incomplete?","visibility":"Public","body":"self == RPC_S_BINDING_INCOMPLETE"}},{"html_id":"rpc_s_call_cancelled?-instance-method","name":"rpc_s_call_cancelled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":908,"url":null},"def":{"name":"rpc_s_call_cancelled?","visibility":"Public","body":"self == RPC_S_CALL_CANCELLED"}},{"html_id":"rpc_s_call_failed?-instance-method","name":"rpc_s_call_failed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":820,"url":null},"def":{"name":"rpc_s_call_failed?","visibility":"Public","body":"self == RPC_S_CALL_FAILED"}},{"html_id":"rpc_s_call_failed_dne?-instance-method","name":"rpc_s_call_failed_dne?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":821,"url":null},"def":{"name":"rpc_s_call_failed_dne?","visibility":"Public","body":"self == RPC_S_CALL_FAILED_DNE"}},{"html_id":"rpc_s_call_in_progress?-instance-method","name":"rpc_s_call_in_progress?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":881,"url":null},"def":{"name":"rpc_s_call_in_progress?","visibility":"Public","body":"self == RPC_S_CALL_IN_PROGRESS"}},{"html_id":"rpc_s_cannot_support?-instance-method","name":"rpc_s_cannot_support?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":855,"url":null},"def":{"name":"rpc_s_cannot_support?","visibility":"Public","body":"self == RPC_S_CANNOT_SUPPORT"}},{"html_id":"rpc_s_cant_create_endpoint?-instance-method","name":"rpc_s_cant_create_endpoint?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":814,"url":null},"def":{"name":"rpc_s_cant_create_endpoint?","visibility":"Public","body":"self == RPC_S_CANT_CREATE_ENDPOINT"}},{"html_id":"rpc_s_comm_failure?-instance-method","name":"rpc_s_comm_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":910,"url":null},"def":{"name":"rpc_s_comm_failure?","visibility":"Public","body":"self == RPC_S_COMM_FAILURE"}},{"html_id":"rpc_s_duplicate_endpoint?-instance-method","name":"rpc_s_duplicate_endpoint?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":831,"url":null},"def":{"name":"rpc_s_duplicate_endpoint?","visibility":"Public","body":"self == RPC_S_DUPLICATE_ENDPOINT"}},{"html_id":"rpc_s_entry_already_exists?-instance-method","name":"rpc_s_entry_already_exists?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":851,"url":null},"def":{"name":"rpc_s_entry_already_exists?","visibility":"Public","body":"self == RPC_S_ENTRY_ALREADY_EXISTS"}},{"html_id":"rpc_s_entry_not_found?-instance-method","name":"rpc_s_entry_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":852,"url":null},"def":{"name":"rpc_s_entry_not_found?","visibility":"Public","body":"self == RPC_S_ENTRY_NOT_FOUND"}},{"html_id":"rpc_s_entry_type_mismatch?-instance-method","name":"rpc_s_entry_type_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":947,"url":null},"def":{"name":"rpc_s_entry_type_mismatch?","visibility":"Public","body":"self == RPC_S_ENTRY_TYPE_MISMATCH"}},{"html_id":"rpc_s_fp_div_zero?-instance-method","name":"rpc_s_fp_div_zero?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":860,"url":null},"def":{"name":"rpc_s_fp_div_zero?","visibility":"Public","body":"self == RPC_S_FP_DIV_ZERO"}},{"html_id":"rpc_s_fp_overflow?-instance-method","name":"rpc_s_fp_overflow?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":862,"url":null},"def":{"name":"rpc_s_fp_overflow?","visibility":"Public","body":"self == RPC_S_FP_OVERFLOW"}},{"html_id":"rpc_s_fp_underflow?-instance-method","name":"rpc_s_fp_underflow?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":861,"url":null},"def":{"name":"rpc_s_fp_underflow?","visibility":"Public","body":"self == RPC_S_FP_UNDERFLOW"}},{"html_id":"rpc_s_group_member_not_found?-instance-method","name":"rpc_s_group_member_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":923,"url":null},"def":{"name":"rpc_s_group_member_not_found?","visibility":"Public","body":"self == RPC_S_GROUP_MEMBER_NOT_FOUND"}},{"html_id":"rpc_s_grp_elt_not_added?-instance-method","name":"rpc_s_grp_elt_not_added?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":953,"url":null},"def":{"name":"rpc_s_grp_elt_not_added?","visibility":"Public","body":"self == RPC_S_GRP_ELT_NOT_ADDED"}},{"html_id":"rpc_s_grp_elt_not_removed?-instance-method","name":"rpc_s_grp_elt_not_removed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":954,"url":null},"def":{"name":"rpc_s_grp_elt_not_removed?","visibility":"Public","body":"self == RPC_S_GRP_ELT_NOT_REMOVED"}},{"html_id":"rpc_s_incomplete_name?-instance-method","name":"rpc_s_incomplete_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":846,"url":null},"def":{"name":"rpc_s_incomplete_name?","visibility":"Public","body":"self == RPC_S_INCOMPLETE_NAME"}},{"html_id":"rpc_s_interface_not_exported?-instance-method","name":"rpc_s_interface_not_exported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":949,"url":null},"def":{"name":"rpc_s_interface_not_exported?","visibility":"Public","body":"self == RPC_S_INTERFACE_NOT_EXPORTED"}},{"html_id":"rpc_s_interface_not_found?-instance-method","name":"rpc_s_interface_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":850,"url":null},"def":{"name":"rpc_s_interface_not_found?","visibility":"Public","body":"self == RPC_S_INTERFACE_NOT_FOUND"}},{"html_id":"rpc_s_internal_error?-instance-method","name":"rpc_s_internal_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":857,"url":null},"def":{"name":"rpc_s_internal_error?","visibility":"Public","body":"self == RPC_S_INTERNAL_ERROR"}},{"html_id":"rpc_s_invalid_async_call?-instance-method","name":"rpc_s_invalid_async_call?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":940,"url":null},"def":{"name":"rpc_s_invalid_async_call?","visibility":"Public","body":"self == RPC_S_INVALID_ASYNC_CALL"}},{"html_id":"rpc_s_invalid_async_handle?-instance-method","name":"rpc_s_invalid_async_handle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":939,"url":null},"def":{"name":"rpc_s_invalid_async_handle?","visibility":"Public","body":"self == RPC_S_INVALID_ASYNC_HANDLE"}},{"html_id":"rpc_s_invalid_auth_identity?-instance-method","name":"rpc_s_invalid_auth_identity?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":840,"url":null},"def":{"name":"rpc_s_invalid_auth_identity?","visibility":"Public","body":"self == RPC_S_INVALID_AUTH_IDENTITY"}},{"html_id":"rpc_s_invalid_binding?-instance-method","name":"rpc_s_invalid_binding?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":796,"url":null},"def":{"name":"rpc_s_invalid_binding?","visibility":"Public","body":"self == RPC_S_INVALID_BINDING"}},{"html_id":"rpc_s_invalid_bound?-instance-method","name":"rpc_s_invalid_bound?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":826,"url":null},"def":{"name":"rpc_s_invalid_bound?","visibility":"Public","body":"self == RPC_S_INVALID_BOUND"}},{"html_id":"rpc_s_invalid_endpoint_format?-instance-method","name":"rpc_s_invalid_endpoint_format?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":800,"url":null},"def":{"name":"rpc_s_invalid_endpoint_format?","visibility":"Public","body":"self == RPC_S_INVALID_ENDPOINT_FORMAT"}},{"html_id":"rpc_s_invalid_naf_id?-instance-method","name":"rpc_s_invalid_naf_id?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":854,"url":null},"def":{"name":"rpc_s_invalid_naf_id?","visibility":"Public","body":"self == RPC_S_INVALID_NAF_ID"}},{"html_id":"rpc_s_invalid_name_syntax?-instance-method","name":"rpc_s_invalid_name_syntax?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":828,"url":null},"def":{"name":"rpc_s_invalid_name_syntax?","visibility":"Public","body":"self == RPC_S_INVALID_NAME_SYNTAX"}},{"html_id":"rpc_s_invalid_net_addr?-instance-method","name":"rpc_s_invalid_net_addr?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":801,"url":null},"def":{"name":"rpc_s_invalid_net_addr?","visibility":"Public","body":"self == RPC_S_INVALID_NET_ADDR"}},{"html_id":"rpc_s_invalid_network_options?-instance-method","name":"rpc_s_invalid_network_options?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":818,"url":null},"def":{"name":"rpc_s_invalid_network_options?","visibility":"Public","body":"self == RPC_S_INVALID_NETWORK_OPTIONS"}},{"html_id":"rpc_s_invalid_object?-instance-method","name":"rpc_s_invalid_object?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":925,"url":null},"def":{"name":"rpc_s_invalid_object?","visibility":"Public","body":"self == RPC_S_INVALID_OBJECT"}},{"html_id":"rpc_s_invalid_rpc_protseq?-instance-method","name":"rpc_s_invalid_rpc_protseq?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":798,"url":null},"def":{"name":"rpc_s_invalid_rpc_protseq?","visibility":"Public","body":"self == RPC_S_INVALID_RPC_PROTSEQ"}},{"html_id":"rpc_s_invalid_string_binding?-instance-method","name":"rpc_s_invalid_string_binding?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":794,"url":null},"def":{"name":"rpc_s_invalid_string_binding?","visibility":"Public","body":"self == RPC_S_INVALID_STRING_BINDING"}},{"html_id":"rpc_s_invalid_string_uuid?-instance-method","name":"rpc_s_invalid_string_uuid?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":799,"url":null},"def":{"name":"rpc_s_invalid_string_uuid?","visibility":"Public","body":"self == RPC_S_INVALID_STRING_UUID"}},{"html_id":"rpc_s_invalid_tag?-instance-method","name":"rpc_s_invalid_tag?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":825,"url":null},"def":{"name":"rpc_s_invalid_tag?","visibility":"Public","body":"self == RPC_S_INVALID_TAG"}},{"html_id":"rpc_s_invalid_timeout?-instance-method","name":"rpc_s_invalid_timeout?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":803,"url":null},"def":{"name":"rpc_s_invalid_timeout?","visibility":"Public","body":"self == RPC_S_INVALID_TIMEOUT"}},{"html_id":"rpc_s_invalid_vers_option?-instance-method","name":"rpc_s_invalid_vers_option?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":847,"url":null},"def":{"name":"rpc_s_invalid_vers_option?","visibility":"Public","body":"self == RPC_S_INVALID_VERS_OPTION"}},{"html_id":"rpc_s_max_calls_too_small?-instance-method","name":"rpc_s_max_calls_too_small?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":833,"url":null},"def":{"name":"rpc_s_max_calls_too_small?","visibility":"Public","body":"self == RPC_S_MAX_CALLS_TOO_SMALL"}},{"html_id":"rpc_s_name_service_unavailable?-instance-method","name":"rpc_s_name_service_unavailable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":853,"url":null},"def":{"name":"rpc_s_name_service_unavailable?","visibility":"Public","body":"self == RPC_S_NAME_SERVICE_UNAVAILABLE"}},{"html_id":"rpc_s_no_bindings?-instance-method","name":"rpc_s_no_bindings?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":812,"url":null},"def":{"name":"rpc_s_no_bindings?","visibility":"Public","body":"self == RPC_S_NO_BINDINGS"}},{"html_id":"rpc_s_no_call_active?-instance-method","name":"rpc_s_no_call_active?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":819,"url":null},"def":{"name":"rpc_s_no_call_active?","visibility":"Public","body":"self == RPC_S_NO_CALL_ACTIVE"}},{"html_id":"rpc_s_no_context_available?-instance-method","name":"rpc_s_no_context_available?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":856,"url":null},"def":{"name":"rpc_s_no_context_available?","visibility":"Public","body":"self == RPC_S_NO_CONTEXT_AVAILABLE"}},{"html_id":"rpc_s_no_endpoint_found?-instance-method","name":"rpc_s_no_endpoint_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":802,"url":null},"def":{"name":"rpc_s_no_endpoint_found?","visibility":"Public","body":"self == RPC_S_NO_ENDPOINT_FOUND"}},{"html_id":"rpc_s_no_entry_name?-instance-method","name":"rpc_s_no_entry_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":827,"url":null},"def":{"name":"rpc_s_no_entry_name?","visibility":"Public","body":"self == RPC_S_NO_ENTRY_NAME"}},{"html_id":"rpc_s_no_interfaces?-instance-method","name":"rpc_s_no_interfaces?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":907,"url":null},"def":{"name":"rpc_s_no_interfaces?","visibility":"Public","body":"self == RPC_S_NO_INTERFACES"}},{"html_id":"rpc_s_no_more_bindings?-instance-method","name":"rpc_s_no_more_bindings?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":896,"url":null},"def":{"name":"rpc_s_no_more_bindings?","visibility":"Public","body":"self == RPC_S_NO_MORE_BINDINGS"}},{"html_id":"rpc_s_no_more_members?-instance-method","name":"rpc_s_no_more_members?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":848,"url":null},"def":{"name":"rpc_s_no_more_members?","visibility":"Public","body":"self == RPC_S_NO_MORE_MEMBERS"}},{"html_id":"rpc_s_no_princ_name?-instance-method","name":"rpc_s_no_princ_name?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":912,"url":null},"def":{"name":"rpc_s_no_princ_name?","visibility":"Public","body":"self == RPC_S_NO_PRINC_NAME"}},{"html_id":"rpc_s_no_protseqs?-instance-method","name":"rpc_s_no_protseqs?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":813,"url":null},"def":{"name":"rpc_s_no_protseqs?","visibility":"Public","body":"self == RPC_S_NO_PROTSEQS"}},{"html_id":"rpc_s_no_protseqs_registered?-instance-method","name":"rpc_s_no_protseqs_registered?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":808,"url":null},"def":{"name":"rpc_s_no_protseqs_registered?","visibility":"Public","body":"self == RPC_S_NO_PROTSEQS_REGISTERED"}},{"html_id":"rpc_s_not_all_objs_exported?-instance-method","name":"rpc_s_not_all_objs_exported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":948,"url":null},"def":{"name":"rpc_s_not_all_objs_exported?","visibility":"Public","body":"self == RPC_S_NOT_ALL_OBJS_EXPORTED"}},{"html_id":"rpc_s_not_all_objs_unexported?-instance-method","name":"rpc_s_not_all_objs_unexported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":849,"url":null},"def":{"name":"rpc_s_not_all_objs_unexported?","visibility":"Public","body":"self == RPC_S_NOT_ALL_OBJS_UNEXPORTED"}},{"html_id":"rpc_s_not_cancelled?-instance-method","name":"rpc_s_not_cancelled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":916,"url":null},"def":{"name":"rpc_s_not_cancelled?","visibility":"Public","body":"self == RPC_S_NOT_CANCELLED"}},{"html_id":"rpc_s_not_listening?-instance-method","name":"rpc_s_not_listening?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":809,"url":null},"def":{"name":"rpc_s_not_listening?","visibility":"Public","body":"self == RPC_S_NOT_LISTENING"}},{"html_id":"rpc_s_not_rpc_error?-instance-method","name":"rpc_s_not_rpc_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":913,"url":null},"def":{"name":"rpc_s_not_rpc_error?","visibility":"Public","body":"self == RPC_S_NOT_RPC_ERROR"}},{"html_id":"rpc_s_nothing_to_export?-instance-method","name":"rpc_s_nothing_to_export?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":845,"url":null},"def":{"name":"rpc_s_nothing_to_export?","visibility":"Public","body":"self == RPC_S_NOTHING_TO_EXPORT"}},{"html_id":"rpc_s_object_not_found?-instance-method","name":"rpc_s_object_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":804,"url":null},"def":{"name":"rpc_s_object_not_found?","visibility":"Public","body":"self == RPC_S_OBJECT_NOT_FOUND"}},{"html_id":"rpc_s_out_of_resources?-instance-method","name":"rpc_s_out_of_resources?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":815,"url":null},"def":{"name":"rpc_s_out_of_resources?","visibility":"Public","body":"self == RPC_S_OUT_OF_RESOURCES"}},{"html_id":"rpc_s_prf_elt_not_added?-instance-method","name":"rpc_s_prf_elt_not_added?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":951,"url":null},"def":{"name":"rpc_s_prf_elt_not_added?","visibility":"Public","body":"self == RPC_S_PRF_ELT_NOT_ADDED"}},{"html_id":"rpc_s_prf_elt_not_removed?-instance-method","name":"rpc_s_prf_elt_not_removed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":952,"url":null},"def":{"name":"rpc_s_prf_elt_not_removed?","visibility":"Public","body":"self == RPC_S_PRF_ELT_NOT_REMOVED"}},{"html_id":"rpc_s_procnum_out_of_range?-instance-method","name":"rpc_s_procnum_out_of_range?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":836,"url":null},"def":{"name":"rpc_s_procnum_out_of_range?","visibility":"Public","body":"self == RPC_S_PROCNUM_OUT_OF_RANGE"}},{"html_id":"rpc_s_profile_not_added?-instance-method","name":"rpc_s_profile_not_added?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":950,"url":null},"def":{"name":"rpc_s_profile_not_added?","visibility":"Public","body":"self == RPC_S_PROFILE_NOT_ADDED"}},{"html_id":"rpc_s_protocol_error?-instance-method","name":"rpc_s_protocol_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":822,"url":null},"def":{"name":"rpc_s_protocol_error?","visibility":"Public","body":"self == RPC_S_PROTOCOL_ERROR"}},{"html_id":"rpc_s_protseq_not_found?-instance-method","name":"rpc_s_protseq_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":835,"url":null},"def":{"name":"rpc_s_protseq_not_found?","visibility":"Public","body":"self == RPC_S_PROTSEQ_NOT_FOUND"}},{"html_id":"rpc_s_protseq_not_supported?-instance-method","name":"rpc_s_protseq_not_supported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":797,"url":null},"def":{"name":"rpc_s_protseq_not_supported?","visibility":"Public","body":"self == RPC_S_PROTSEQ_NOT_SUPPORTED"}},{"html_id":"rpc_s_sec_pkg_error?-instance-method","name":"rpc_s_sec_pkg_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":915,"url":null},"def":{"name":"rpc_s_sec_pkg_error?","visibility":"Public","body":"self == RPC_S_SEC_PKG_ERROR"}},{"html_id":"rpc_s_send_incomplete?-instance-method","name":"rpc_s_send_incomplete?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":938,"url":null},"def":{"name":"rpc_s_send_incomplete?","visibility":"Public","body":"self == RPC_S_SEND_INCOMPLETE"}},{"html_id":"rpc_s_server_too_busy?-instance-method","name":"rpc_s_server_too_busy?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":817,"url":null},"def":{"name":"rpc_s_server_too_busy?","visibility":"Public","body":"self == RPC_S_SERVER_TOO_BUSY"}},{"html_id":"rpc_s_server_unavailable?-instance-method","name":"rpc_s_server_unavailable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":816,"url":null},"def":{"name":"rpc_s_server_unavailable?","visibility":"Public","body":"self == RPC_S_SERVER_UNAVAILABLE"}},{"html_id":"rpc_s_string_too_long?-instance-method","name":"rpc_s_string_too_long?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":834,"url":null},"def":{"name":"rpc_s_string_too_long?","visibility":"Public","body":"self == RPC_S_STRING_TOO_LONG"}},{"html_id":"rpc_s_type_already_registered?-instance-method","name":"rpc_s_type_already_registered?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":806,"url":null},"def":{"name":"rpc_s_type_already_registered?","visibility":"Public","body":"self == RPC_S_TYPE_ALREADY_REGISTERED"}},{"html_id":"rpc_s_unknown_authn_level?-instance-method","name":"rpc_s_unknown_authn_level?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":839,"url":null},"def":{"name":"rpc_s_unknown_authn_level?","visibility":"Public","body":"self == RPC_S_UNKNOWN_AUTHN_LEVEL"}},{"html_id":"rpc_s_unknown_authn_service?-instance-method","name":"rpc_s_unknown_authn_service?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":838,"url":null},"def":{"name":"rpc_s_unknown_authn_service?","visibility":"Public","body":"self == RPC_S_UNKNOWN_AUTHN_SERVICE"}},{"html_id":"rpc_s_unknown_authn_type?-instance-method","name":"rpc_s_unknown_authn_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":832,"url":null},"def":{"name":"rpc_s_unknown_authn_type?","visibility":"Public","body":"self == RPC_S_UNKNOWN_AUTHN_TYPE"}},{"html_id":"rpc_s_unknown_authz_service?-instance-method","name":"rpc_s_unknown_authz_service?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":841,"url":null},"def":{"name":"rpc_s_unknown_authz_service?","visibility":"Public","body":"self == RPC_S_UNKNOWN_AUTHZ_SERVICE"}},{"html_id":"rpc_s_unknown_if?-instance-method","name":"rpc_s_unknown_if?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":811,"url":null},"def":{"name":"rpc_s_unknown_if?","visibility":"Public","body":"self == RPC_S_UNKNOWN_IF"}},{"html_id":"rpc_s_unknown_mgr_type?-instance-method","name":"rpc_s_unknown_mgr_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":810,"url":null},"def":{"name":"rpc_s_unknown_mgr_type?","visibility":"Public","body":"self == RPC_S_UNKNOWN_MGR_TYPE"}},{"html_id":"rpc_s_unsupported_authn_level?-instance-method","name":"rpc_s_unsupported_authn_level?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":911,"url":null},"def":{"name":"rpc_s_unsupported_authn_level?","visibility":"Public","body":"self == RPC_S_UNSUPPORTED_AUTHN_LEVEL"}},{"html_id":"rpc_s_unsupported_name_syntax?-instance-method","name":"rpc_s_unsupported_name_syntax?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":829,"url":null},"def":{"name":"rpc_s_unsupported_name_syntax?","visibility":"Public","body":"self == RPC_S_UNSUPPORTED_NAME_SYNTAX"}},{"html_id":"rpc_s_unsupported_trans_syn?-instance-method","name":"rpc_s_unsupported_trans_syn?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":823,"url":null},"def":{"name":"rpc_s_unsupported_trans_syn?","visibility":"Public","body":"self == RPC_S_UNSUPPORTED_TRANS_SYN"}},{"html_id":"rpc_s_unsupported_type?-instance-method","name":"rpc_s_unsupported_type?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":824,"url":null},"def":{"name":"rpc_s_unsupported_type?","visibility":"Public","body":"self == RPC_S_UNSUPPORTED_TYPE"}},{"html_id":"rpc_s_uuid_local_only?-instance-method","name":"rpc_s_uuid_local_only?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":914,"url":null},"def":{"name":"rpc_s_uuid_local_only?","visibility":"Public","body":"self == RPC_S_UUID_LOCAL_ONLY"}},{"html_id":"rpc_s_uuid_no_address?-instance-method","name":"rpc_s_uuid_no_address?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":830,"url":null},"def":{"name":"rpc_s_uuid_no_address?","visibility":"Public","body":"self == RPC_S_UUID_NO_ADDRESS"}},{"html_id":"rpc_s_wrong_kind_of_binding?-instance-method","name":"rpc_s_wrong_kind_of_binding?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":795,"url":null},"def":{"name":"rpc_s_wrong_kind_of_binding?","visibility":"Public","body":"self == RPC_S_WRONG_KIND_OF_BINDING"}},{"html_id":"rpc_s_zero_divide?-instance-method","name":"rpc_s_zero_divide?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":858,"url":null},"def":{"name":"rpc_s_zero_divide?","visibility":"Public","body":"self == RPC_S_ZERO_DIVIDE"}},{"html_id":"rpc_x_bad_stub_data?-instance-method","name":"rpc_x_bad_stub_data?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":873,"url":null},"def":{"name":"rpc_x_bad_stub_data?","visibility":"Public","body":"self == RPC_X_BAD_STUB_DATA"}},{"html_id":"rpc_x_byte_count_too_small?-instance-method","name":"rpc_x_byte_count_too_small?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":872,"url":null},"def":{"name":"rpc_x_byte_count_too_small?","visibility":"Public","body":"self == RPC_X_BYTE_COUNT_TOO_SMALL"}},{"html_id":"rpc_x_enum_value_out_of_range?-instance-method","name":"rpc_x_enum_value_out_of_range?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":871,"url":null},"def":{"name":"rpc_x_enum_value_out_of_range?","visibility":"Public","body":"self == RPC_X_ENUM_VALUE_OUT_OF_RANGE"}},{"html_id":"rpc_x_invalid_es_action?-instance-method","name":"rpc_x_invalid_es_action?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":917,"url":null},"def":{"name":"rpc_x_invalid_es_action?","visibility":"Public","body":"self == RPC_X_INVALID_ES_ACTION"}},{"html_id":"rpc_x_invalid_pipe_object?-instance-method","name":"rpc_x_invalid_pipe_object?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":920,"url":null},"def":{"name":"rpc_x_invalid_pipe_object?","visibility":"Public","body":"self == RPC_X_INVALID_PIPE_OBJECT"}},{"html_id":"rpc_x_no_more_entries?-instance-method","name":"rpc_x_no_more_entries?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":863,"url":null},"def":{"name":"rpc_x_no_more_entries?","visibility":"Public","body":"self == RPC_X_NO_MORE_ENTRIES"}},{"html_id":"rpc_x_null_ref_pointer?-instance-method","name":"rpc_x_null_ref_pointer?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":870,"url":null},"def":{"name":"rpc_x_null_ref_pointer?","visibility":"Public","body":"self == RPC_X_NULL_REF_POINTER"}},{"html_id":"rpc_x_pipe_closed?-instance-method","name":"rpc_x_pipe_closed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":941,"url":null},"def":{"name":"rpc_x_pipe_closed?","visibility":"Public","body":"self == RPC_X_PIPE_CLOSED"}},{"html_id":"rpc_x_pipe_discipline_error?-instance-method","name":"rpc_x_pipe_discipline_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":942,"url":null},"def":{"name":"rpc_x_pipe_discipline_error?","visibility":"Public","body":"self == RPC_X_PIPE_DISCIPLINE_ERROR"}},{"html_id":"rpc_x_pipe_empty?-instance-method","name":"rpc_x_pipe_empty?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":943,"url":null},"def":{"name":"rpc_x_pipe_empty?","visibility":"Public","body":"self == RPC_X_PIPE_EMPTY"}},{"html_id":"rpc_x_ss_cannot_get_call_handle?-instance-method","name":"rpc_x_ss_cannot_get_call_handle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":869,"url":null},"def":{"name":"rpc_x_ss_cannot_get_call_handle?","visibility":"Public","body":"self == RPC_X_SS_CANNOT_GET_CALL_HANDLE"}},{"html_id":"rpc_x_ss_char_trans_open_fail?-instance-method","name":"rpc_x_ss_char_trans_open_fail?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":864,"url":null},"def":{"name":"rpc_x_ss_char_trans_open_fail?","visibility":"Public","body":"self == RPC_X_SS_CHAR_TRANS_OPEN_FAIL"}},{"html_id":"rpc_x_ss_char_trans_short_file?-instance-method","name":"rpc_x_ss_char_trans_short_file?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":865,"url":null},"def":{"name":"rpc_x_ss_char_trans_short_file?","visibility":"Public","body":"self == RPC_X_SS_CHAR_TRANS_SHORT_FILE"}},{"html_id":"rpc_x_ss_context_damaged?-instance-method","name":"rpc_x_ss_context_damaged?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":867,"url":null},"def":{"name":"rpc_x_ss_context_damaged?","visibility":"Public","body":"self == RPC_X_SS_CONTEXT_DAMAGED"}},{"html_id":"rpc_x_ss_handles_mismatch?-instance-method","name":"rpc_x_ss_handles_mismatch?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":868,"url":null},"def":{"name":"rpc_x_ss_handles_mismatch?","visibility":"Public","body":"self == RPC_X_SS_HANDLES_MISMATCH"}},{"html_id":"rpc_x_ss_in_null_context?-instance-method","name":"rpc_x_ss_in_null_context?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":866,"url":null},"def":{"name":"rpc_x_ss_in_null_context?","visibility":"Public","body":"self == RPC_X_SS_IN_NULL_CONTEXT"}},{"html_id":"rpc_x_wrong_es_version?-instance-method","name":"rpc_x_wrong_es_version?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":918,"url":null},"def":{"name":"rpc_x_wrong_es_version?","visibility":"Public","body":"self == RPC_X_WRONG_ES_VERSION"}},{"html_id":"rpc_x_wrong_pipe_order?-instance-method","name":"rpc_x_wrong_pipe_order?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":921,"url":null},"def":{"name":"rpc_x_wrong_pipe_order?","visibility":"Public","body":"self == RPC_X_WRONG_PIPE_ORDER"}},{"html_id":"rpc_x_wrong_pipe_version?-instance-method","name":"rpc_x_wrong_pipe_version?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":922,"url":null},"def":{"name":"rpc_x_wrong_pipe_version?","visibility":"Public","body":"self == RPC_X_WRONG_PIPE_VERSION"}},{"html_id":"rpc_x_wrong_stub_version?-instance-method","name":"rpc_x_wrong_stub_version?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":919,"url":null},"def":{"name":"rpc_x_wrong_stub_version?","visibility":"Public","body":"self == RPC_X_WRONG_STUB_VERSION"}},{"html_id":"sched_e_service_not_localsystem?-instance-method","name":"sched_e_service_not_localsystem?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1199,"url":null},"def":{"name":"sched_e_service_not_localsystem?","visibility":"Public","body":"self == SCHED_E_SERVICE_NOT_LOCALSYSTEM"}},{"html_id":"to_errno:Errno-instance-method","name":"to_errno","doc":"Transforms this `WinError` value to the equivalent `Errno` value.\n\nThis is only defined for some values. If no transformation is defined for\na specific value, the default result is `Errno::EINVAL`.","summary":"<p>Transforms this <code><a href=\"WinError.html\">WinError</a></code> value to the equivalent <code><a href=\"Errno.html\">Errno</a></code> value.</p>","abstract":false,"location":{"filename":"src/winerror.cr","line_number":77,"url":null},"def":{"name":"to_errno","return_type":"Errno","visibility":"Public","body":"case self\nwhen ERROR_FILE_NOT_FOUND\n  Errno::ENOENT\nwhen ERROR_PATH_NOT_FOUND\n  Errno::ENOENT\nwhen ERROR_TOO_MANY_OPEN_FILES\n  Errno::EMFILE\nwhen ERROR_ACCESS_DENIED\n  Errno::EACCES\nwhen ERROR_INVALID_HANDLE\n  Errno::EBADF\nwhen ERROR_ARENA_TRASHED\n  Errno::ENOMEM\nwhen ERROR_NOT_ENOUGH_MEMORY\n  Errno::ENOMEM\nwhen ERROR_INVALID_BLOCK\n  Errno::ENOMEM\nwhen ERROR_BAD_ENVIRONMENT\n  Errno::E2BIG\nwhen ERROR_BAD_FORMAT\n  Errno::ENOEXEC\nwhen ERROR_INVALID_DRIVE\n  Errno::ENOENT\nwhen ERROR_CURRENT_DIRECTORY\n  Errno::EACCES\nwhen ERROR_NOT_SAME_DEVICE\n  Errno::EXDEV\nwhen ERROR_NO_MORE_FILES\n  Errno::ENOENT\nwhen ERROR_WRITE_PROTECT\n  Errno::EACCES\nwhen ERROR_BAD_UNIT\n  Errno::EACCES\nwhen ERROR_NOT_READY\n  Errno::EACCES\nwhen ERROR_BAD_COMMAND\n  Errno::EACCES\nwhen ERROR_CRC\n  Errno::EACCES\nwhen ERROR_BAD_LENGTH\n  Errno::EACCES\nwhen ERROR_SEEK\n  Errno::EACCES\nwhen ERROR_NOT_DOS_DISK\n  Errno::EACCES\nwhen ERROR_SECTOR_NOT_FOUND\n  Errno::EACCES\nwhen ERROR_OUT_OF_PAPER\n  Errno::EACCES\nwhen ERROR_WRITE_FAULT\n  Errno::EACCES\nwhen ERROR_READ_FAULT\n  Errno::EACCES\nwhen ERROR_GEN_FAILURE\n  Errno::EACCES\nwhen ERROR_SHARING_VIOLATION\n  Errno::EACCES\nwhen ERROR_LOCK_VIOLATION\n  Errno::EACCES\nwhen ERROR_WRONG_DISK\n  Errno::EACCES\nwhen ERROR_SHARING_BUFFER_EXCEEDED\n  Errno::EACCES\nwhen ERROR_BAD_NETPATH\n  Errno::ENOENT\nwhen ERROR_NETWORK_ACCESS_DENIED\n  Errno::EACCES\nwhen ERROR_BAD_NET_NAME\n  Errno::ENOENT\nwhen ERROR_FILE_EXISTS\n  Errno::EEXIST\nwhen ERROR_CANNOT_MAKE\n  Errno::EACCES\nwhen ERROR_FAIL_I24\n  Errno::EACCES\nwhen ERROR_NO_PROC_SLOTS\n  Errno::EAGAIN\nwhen ERROR_DRIVE_LOCKED\n  Errno::EACCES\nwhen ERROR_BROKEN_PIPE\n  Errno::EPIPE\nwhen ERROR_DISK_FULL\n  Errno::ENOSPC\nwhen ERROR_INVALID_TARGET_HANDLE\n  Errno::EBADF\nwhen ERROR_WAIT_NO_CHILDREN\n  Errno::ECHILD\nwhen ERROR_CHILD_NOT_COMPLETE\n  Errno::ECHILD\nwhen ERROR_DIRECT_ACCESS_HANDLE\n  Errno::EBADF\nwhen ERROR_SEEK_ON_DEVICE\n  Errno::EACCES\nwhen ERROR_DIR_NOT_EMPTY\n  Errno::ENOTEMPTY\nwhen ERROR_NOT_LOCKED\n  Errno::EACCES\nwhen ERROR_BAD_PATHNAME\n  Errno::ENOENT\nwhen ERROR_MAX_THRDS_REACHED\n  Errno::EAGAIN\nwhen ERROR_LOCK_FAILED\n  Errno::EACCES\nwhen ERROR_ALREADY_EXISTS\n  Errno::EEXIST\nwhen ERROR_INVALID_STARTING_CODESEG\n  Errno::ENOEXEC\nwhen ERROR_INVALID_STACKSEG\n  Errno::ENOEXEC\nwhen ERROR_INVALID_MODULETYPE\n  Errno::ENOEXEC\nwhen ERROR_INVALID_EXE_SIGNATURE\n  Errno::ENOEXEC\nwhen ERROR_EXE_MARKED_INVALID\n  Errno::ENOEXEC\nwhen ERROR_BAD_EXE_FORMAT\n  Errno::ENOEXEC\nwhen ERROR_ITERATED_DATA_EXCEEDS_64k\n  Errno::ENOEXEC\nwhen ERROR_INVALID_MINALLOCSIZE\n  Errno::ENOEXEC\nwhen ERROR_DYNLINK_FROM_INVALID_RING\n  Errno::ENOEXEC\nwhen ERROR_IOPL_NOT_ENABLED\n  Errno::ENOEXEC\nwhen ERROR_INVALID_SEGDPL\n  Errno::ENOEXEC\nwhen ERROR_AUTODATASEG_EXCEEDS_64k\n  Errno::ENOEXEC\nwhen ERROR_RING2SEG_MUST_BE_MOVABLE\n  Errno::ENOEXEC\nwhen ERROR_RELOC_CHAIN_XEEDS_SEGLIM\n  Errno::ENOEXEC\nwhen ERROR_INFLOOP_IN_RELOC_CHAIN\n  Errno::ENOEXEC\nwhen ERROR_FILENAME_EXCED_RANGE\n  Errno::ENOENT\nwhen ERROR_NESTING_NOT_ALLOWED\n  Errno::EAGAIN\nwhen ERROR_NO_DATA\n  Errno::EPIPE\nwhen ERROR_DIRECTORY\n  Errno::ENOTDIR\nwhen ERROR_NOT_ENOUGH_QUOTA\n  Errno::ENOMEM\nelse\n  Errno::EINVAL\nend"}},{"html_id":"wait_timeout?-instance-method","name":"wait_timeout?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":340,"url":null},"def":{"name":"wait_timeout?","visibility":"Public","body":"self == WAIT_TIMEOUT"}},{"html_id":"warning_ipsec_mm_policy_pruned?-instance-method","name":"warning_ipsec_mm_policy_pruned?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1967,"url":null},"def":{"name":"warning_ipsec_mm_policy_pruned?","visibility":"Public","body":"self == WARNING_IPSEC_MM_POLICY_PRUNED"}},{"html_id":"warning_ipsec_qm_policy_pruned?-instance-method","name":"warning_ipsec_qm_policy_pruned?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1968,"url":null},"def":{"name":"warning_ipsec_qm_policy_pruned?","visibility":"Public","body":"self == WARNING_IPSEC_QM_POLICY_PRUNED"}},{"html_id":"wsa_e_cancelled?-instance-method","name":"wsa_e_cancelled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1798,"url":null},"def":{"name":"wsa_e_cancelled?","visibility":"Public","body":"self == WSA_E_CANCELLED"}},{"html_id":"wsa_e_no_more?-instance-method","name":"wsa_e_no_more?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1797,"url":null},"def":{"name":"wsa_e_no_more?","visibility":"Public","body":"self == WSA_E_NO_MORE"}},{"html_id":"wsa_io_incomplete?-instance-method","name":"wsa_io_incomplete?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2246,"url":null},"def":{"name":"wsa_io_incomplete?","visibility":"Public","body":"self == WSA_IO_INCOMPLETE"}},{"html_id":"wsa_io_pending?-instance-method","name":"wsa_io_pending?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":2245,"url":null},"def":{"name":"wsa_io_pending?","visibility":"Public","body":"self == WSA_IO_PENDING"}},{"html_id":"wsa_qos_admission_failure?-instance-method","name":"wsa_qos_admission_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1809,"url":null},"def":{"name":"wsa_qos_admission_failure?","visibility":"Public","body":"self == WSA_QOS_ADMISSION_FAILURE"}},{"html_id":"wsa_qos_bad_object?-instance-method","name":"wsa_qos_bad_object?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1812,"url":null},"def":{"name":"wsa_qos_bad_object?","visibility":"Public","body":"self == WSA_QOS_BAD_OBJECT"}},{"html_id":"wsa_qos_bad_style?-instance-method","name":"wsa_qos_bad_style?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1811,"url":null},"def":{"name":"wsa_qos_bad_style?","visibility":"Public","body":"self == WSA_QOS_BAD_STYLE"}},{"html_id":"wsa_qos_efiltercount?-instance-method","name":"wsa_qos_efiltercount?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1820,"url":null},"def":{"name":"wsa_qos_efiltercount?","visibility":"Public","body":"self == WSA_QOS_EFILTERCOUNT"}},{"html_id":"wsa_qos_efilterstyle?-instance-method","name":"wsa_qos_efilterstyle?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1818,"url":null},"def":{"name":"wsa_qos_efilterstyle?","visibility":"Public","body":"self == WSA_QOS_EFILTERSTYLE"}},{"html_id":"wsa_qos_efiltertype?-instance-method","name":"wsa_qos_efiltertype?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1819,"url":null},"def":{"name":"wsa_qos_efiltertype?","visibility":"Public","body":"self == WSA_QOS_EFILTERTYPE"}},{"html_id":"wsa_qos_eflowcount?-instance-method","name":"wsa_qos_eflowcount?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1822,"url":null},"def":{"name":"wsa_qos_eflowcount?","visibility":"Public","body":"self == WSA_QOS_EFLOWCOUNT"}},{"html_id":"wsa_qos_eflowdesc?-instance-method","name":"wsa_qos_eflowdesc?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1826,"url":null},"def":{"name":"wsa_qos_eflowdesc?","visibility":"Public","body":"self == WSA_QOS_EFLOWDESC"}},{"html_id":"wsa_qos_eflowspec?-instance-method","name":"wsa_qos_eflowspec?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1816,"url":null},"def":{"name":"wsa_qos_eflowspec?","visibility":"Public","body":"self == WSA_QOS_EFLOWSPEC"}},{"html_id":"wsa_qos_eobjlength?-instance-method","name":"wsa_qos_eobjlength?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1821,"url":null},"def":{"name":"wsa_qos_eobjlength?","visibility":"Public","body":"self == WSA_QOS_EOBJLENGTH"}},{"html_id":"wsa_qos_epolicyobj?-instance-method","name":"wsa_qos_epolicyobj?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1825,"url":null},"def":{"name":"wsa_qos_epolicyobj?","visibility":"Public","body":"self == WSA_QOS_EPOLICYOBJ"}},{"html_id":"wsa_qos_eprovspecbuf?-instance-method","name":"wsa_qos_eprovspecbuf?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1817,"url":null},"def":{"name":"wsa_qos_eprovspecbuf?","visibility":"Public","body":"self == WSA_QOS_EPROVSPECBUF"}},{"html_id":"wsa_qos_epsfilterspec?-instance-method","name":"wsa_qos_epsfilterspec?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1828,"url":null},"def":{"name":"wsa_qos_epsfilterspec?","visibility":"Public","body":"self == WSA_QOS_EPSFILTERSPEC"}},{"html_id":"wsa_qos_epsflowspec?-instance-method","name":"wsa_qos_epsflowspec?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1827,"url":null},"def":{"name":"wsa_qos_epsflowspec?","visibility":"Public","body":"self == WSA_QOS_EPSFLOWSPEC"}},{"html_id":"wsa_qos_esdmodeobj?-instance-method","name":"wsa_qos_esdmodeobj?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1829,"url":null},"def":{"name":"wsa_qos_esdmodeobj?","visibility":"Public","body":"self == WSA_QOS_ESDMODEOBJ"}},{"html_id":"wsa_qos_eservicetype?-instance-method","name":"wsa_qos_eservicetype?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1815,"url":null},"def":{"name":"wsa_qos_eservicetype?","visibility":"Public","body":"self == WSA_QOS_ESERVICETYPE"}},{"html_id":"wsa_qos_eshaperateobj?-instance-method","name":"wsa_qos_eshaperateobj?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1830,"url":null},"def":{"name":"wsa_qos_eshaperateobj?","visibility":"Public","body":"self == WSA_QOS_ESHAPERATEOBJ"}},{"html_id":"wsa_qos_eunknownpsobj?-instance-method","name":"wsa_qos_eunknownpsobj?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1823,"url":null},"def":{"name":"wsa_qos_eunknownpsobj?","visibility":"Public","body":"self == WSA_QOS_EUNKNOWNPSOBJ"}},{"html_id":"wsa_qos_eunkownpsobj?-instance-method","name":"wsa_qos_eunkownpsobj?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1824,"url":null},"def":{"name":"wsa_qos_eunkownpsobj?","visibility":"Public","body":"self == WSA_QOS_EUNKOWNPSOBJ"}},{"html_id":"wsa_qos_generic_error?-instance-method","name":"wsa_qos_generic_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1814,"url":null},"def":{"name":"wsa_qos_generic_error?","visibility":"Public","body":"self == WSA_QOS_GENERIC_ERROR"}},{"html_id":"wsa_qos_no_receivers?-instance-method","name":"wsa_qos_no_receivers?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1807,"url":null},"def":{"name":"wsa_qos_no_receivers?","visibility":"Public","body":"self == WSA_QOS_NO_RECEIVERS"}},{"html_id":"wsa_qos_no_senders?-instance-method","name":"wsa_qos_no_senders?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1806,"url":null},"def":{"name":"wsa_qos_no_senders?","visibility":"Public","body":"self == WSA_QOS_NO_SENDERS"}},{"html_id":"wsa_qos_policy_failure?-instance-method","name":"wsa_qos_policy_failure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1810,"url":null},"def":{"name":"wsa_qos_policy_failure?","visibility":"Public","body":"self == WSA_QOS_POLICY_FAILURE"}},{"html_id":"wsa_qos_receivers?-instance-method","name":"wsa_qos_receivers?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1804,"url":null},"def":{"name":"wsa_qos_receivers?","visibility":"Public","body":"self == WSA_QOS_RECEIVERS"}},{"html_id":"wsa_qos_request_confirmed?-instance-method","name":"wsa_qos_request_confirmed?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1808,"url":null},"def":{"name":"wsa_qos_request_confirmed?","visibility":"Public","body":"self == WSA_QOS_REQUEST_CONFIRMED"}},{"html_id":"wsa_qos_reserved_petype?-instance-method","name":"wsa_qos_reserved_petype?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1831,"url":null},"def":{"name":"wsa_qos_reserved_petype?","visibility":"Public","body":"self == WSA_QOS_RESERVED_PETYPE"}},{"html_id":"wsa_qos_senders?-instance-method","name":"wsa_qos_senders?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1805,"url":null},"def":{"name":"wsa_qos_senders?","visibility":"Public","body":"self == WSA_QOS_SENDERS"}},{"html_id":"wsa_qos_traffic_ctrl_error?-instance-method","name":"wsa_qos_traffic_ctrl_error?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1813,"url":null},"def":{"name":"wsa_qos_traffic_ctrl_error?","visibility":"Public","body":"self == WSA_QOS_TRAFFIC_CTRL_ERROR"}},{"html_id":"wsabaseerr?-instance-method","name":"wsabaseerr?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1741,"url":null},"def":{"name":"wsabaseerr?","visibility":"Public","body":"self == WSABASEERR"}},{"html_id":"wsaeacces?-instance-method","name":"wsaeacces?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1744,"url":null},"def":{"name":"wsaeacces?","visibility":"Public","body":"self == WSAEACCES"}},{"html_id":"wsaeaddrinuse?-instance-method","name":"wsaeaddrinuse?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1761,"url":null},"def":{"name":"wsaeaddrinuse?","visibility":"Public","body":"self == WSAEADDRINUSE"}},{"html_id":"wsaeaddrnotavail?-instance-method","name":"wsaeaddrnotavail?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1762,"url":null},"def":{"name":"wsaeaddrnotavail?","visibility":"Public","body":"self == WSAEADDRNOTAVAIL"}},{"html_id":"wsaeafnosupport?-instance-method","name":"wsaeafnosupport?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1760,"url":null},"def":{"name":"wsaeafnosupport?","visibility":"Public","body":"self == WSAEAFNOSUPPORT"}},{"html_id":"wsaealready?-instance-method","name":"wsaealready?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1750,"url":null},"def":{"name":"wsaealready?","visibility":"Public","body":"self == WSAEALREADY"}},{"html_id":"wsaebadf?-instance-method","name":"wsaebadf?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1743,"url":null},"def":{"name":"wsaebadf?","visibility":"Public","body":"self == WSAEBADF"}},{"html_id":"wsaecancelled?-instance-method","name":"wsaecancelled?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1790,"url":null},"def":{"name":"wsaecancelled?","visibility":"Public","body":"self == WSAECANCELLED"}},{"html_id":"wsaeconnaborted?-instance-method","name":"wsaeconnaborted?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1766,"url":null},"def":{"name":"wsaeconnaborted?","visibility":"Public","body":"self == WSAECONNABORTED"}},{"html_id":"wsaeconnrefused?-instance-method","name":"wsaeconnrefused?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1774,"url":null},"def":{"name":"wsaeconnrefused?","visibility":"Public","body":"self == WSAECONNREFUSED"}},{"html_id":"wsaeconnreset?-instance-method","name":"wsaeconnreset?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1767,"url":null},"def":{"name":"wsaeconnreset?","visibility":"Public","body":"self == WSAECONNRESET"}},{"html_id":"wsaedestaddrreq?-instance-method","name":"wsaedestaddrreq?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1752,"url":null},"def":{"name":"wsaedestaddrreq?","visibility":"Public","body":"self == WSAEDESTADDRREQ"}},{"html_id":"wsaediscon?-instance-method","name":"wsaediscon?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1788,"url":null},"def":{"name":"wsaediscon?","visibility":"Public","body":"self == WSAEDISCON"}},{"html_id":"wsaedquot?-instance-method","name":"wsaedquot?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1782,"url":null},"def":{"name":"wsaedquot?","visibility":"Public","body":"self == WSAEDQUOT"}},{"html_id":"wsaefault?-instance-method","name":"wsaefault?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1745,"url":null},"def":{"name":"wsaefault?","visibility":"Public","body":"self == WSAEFAULT"}},{"html_id":"wsaehostdown?-instance-method","name":"wsaehostdown?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1777,"url":null},"def":{"name":"wsaehostdown?","visibility":"Public","body":"self == WSAEHOSTDOWN"}},{"html_id":"wsaehostunreach?-instance-method","name":"wsaehostunreach?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1778,"url":null},"def":{"name":"wsaehostunreach?","visibility":"Public","body":"self == WSAEHOSTUNREACH"}},{"html_id":"wsaeinprogress?-instance-method","name":"wsaeinprogress?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1749,"url":null},"def":{"name":"wsaeinprogress?","visibility":"Public","body":"self == WSAEINPROGRESS"}},{"html_id":"wsaeintr?-instance-method","name":"wsaeintr?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1742,"url":null},"def":{"name":"wsaeintr?","visibility":"Public","body":"self == WSAEINTR"}},{"html_id":"wsaeinval?-instance-method","name":"wsaeinval?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1746,"url":null},"def":{"name":"wsaeinval?","visibility":"Public","body":"self == WSAEINVAL"}},{"html_id":"wsaeinvalidproctable?-instance-method","name":"wsaeinvalidproctable?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1791,"url":null},"def":{"name":"wsaeinvalidproctable?","visibility":"Public","body":"self == WSAEINVALIDPROCTABLE"}},{"html_id":"wsaeinvalidprovider?-instance-method","name":"wsaeinvalidprovider?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1792,"url":null},"def":{"name":"wsaeinvalidprovider?","visibility":"Public","body":"self == WSAEINVALIDPROVIDER"}},{"html_id":"wsaeisconn?-instance-method","name":"wsaeisconn?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1769,"url":null},"def":{"name":"wsaeisconn?","visibility":"Public","body":"self == WSAEISCONN"}},{"html_id":"wsaeloop?-instance-method","name":"wsaeloop?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1775,"url":null},"def":{"name":"wsaeloop?","visibility":"Public","body":"self == WSAELOOP"}},{"html_id":"wsaemfile?-instance-method","name":"wsaemfile?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1747,"url":null},"def":{"name":"wsaemfile?","visibility":"Public","body":"self == WSAEMFILE"}},{"html_id":"wsaemsgsize?-instance-method","name":"wsaemsgsize?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1753,"url":null},"def":{"name":"wsaemsgsize?","visibility":"Public","body":"self == WSAEMSGSIZE"}},{"html_id":"wsaenametoolong?-instance-method","name":"wsaenametoolong?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1776,"url":null},"def":{"name":"wsaenametoolong?","visibility":"Public","body":"self == WSAENAMETOOLONG"}},{"html_id":"wsaenetdown?-instance-method","name":"wsaenetdown?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1763,"url":null},"def":{"name":"wsaenetdown?","visibility":"Public","body":"self == WSAENETDOWN"}},{"html_id":"wsaenetreset?-instance-method","name":"wsaenetreset?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1765,"url":null},"def":{"name":"wsaenetreset?","visibility":"Public","body":"self == WSAENETRESET"}},{"html_id":"wsaenetunreach?-instance-method","name":"wsaenetunreach?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1764,"url":null},"def":{"name":"wsaenetunreach?","visibility":"Public","body":"self == WSAENETUNREACH"}},{"html_id":"wsaenobufs?-instance-method","name":"wsaenobufs?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1768,"url":null},"def":{"name":"wsaenobufs?","visibility":"Public","body":"self == WSAENOBUFS"}},{"html_id":"wsaenomore?-instance-method","name":"wsaenomore?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1789,"url":null},"def":{"name":"wsaenomore?","visibility":"Public","body":"self == WSAENOMORE"}},{"html_id":"wsaenoprotoopt?-instance-method","name":"wsaenoprotoopt?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1755,"url":null},"def":{"name":"wsaenoprotoopt?","visibility":"Public","body":"self == WSAENOPROTOOPT"}},{"html_id":"wsaenotconn?-instance-method","name":"wsaenotconn?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1770,"url":null},"def":{"name":"wsaenotconn?","visibility":"Public","body":"self == WSAENOTCONN"}},{"html_id":"wsaenotempty?-instance-method","name":"wsaenotempty?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1779,"url":null},"def":{"name":"wsaenotempty?","visibility":"Public","body":"self == WSAENOTEMPTY"}},{"html_id":"wsaenotsock?-instance-method","name":"wsaenotsock?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1751,"url":null},"def":{"name":"wsaenotsock?","visibility":"Public","body":"self == WSAENOTSOCK"}},{"html_id":"wsaeopnotsupp?-instance-method","name":"wsaeopnotsupp?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1758,"url":null},"def":{"name":"wsaeopnotsupp?","visibility":"Public","body":"self == WSAEOPNOTSUPP"}},{"html_id":"wsaepfnosupport?-instance-method","name":"wsaepfnosupport?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1759,"url":null},"def":{"name":"wsaepfnosupport?","visibility":"Public","body":"self == WSAEPFNOSUPPORT"}},{"html_id":"wsaeproclim?-instance-method","name":"wsaeproclim?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1780,"url":null},"def":{"name":"wsaeproclim?","visibility":"Public","body":"self == WSAEPROCLIM"}},{"html_id":"wsaeprotonosupport?-instance-method","name":"wsaeprotonosupport?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1756,"url":null},"def":{"name":"wsaeprotonosupport?","visibility":"Public","body":"self == WSAEPROTONOSUPPORT"}},{"html_id":"wsaeprototype?-instance-method","name":"wsaeprototype?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1754,"url":null},"def":{"name":"wsaeprototype?","visibility":"Public","body":"self == WSAEPROTOTYPE"}},{"html_id":"wsaeproviderfailedinit?-instance-method","name":"wsaeproviderfailedinit?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1793,"url":null},"def":{"name":"wsaeproviderfailedinit?","visibility":"Public","body":"self == WSAEPROVIDERFAILEDINIT"}},{"html_id":"wsaerefused?-instance-method","name":"wsaerefused?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1799,"url":null},"def":{"name":"wsaerefused?","visibility":"Public","body":"self == WSAEREFUSED"}},{"html_id":"wsaeremote?-instance-method","name":"wsaeremote?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1784,"url":null},"def":{"name":"wsaeremote?","visibility":"Public","body":"self == WSAEREMOTE"}},{"html_id":"wsaeshutdown?-instance-method","name":"wsaeshutdown?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1771,"url":null},"def":{"name":"wsaeshutdown?","visibility":"Public","body":"self == WSAESHUTDOWN"}},{"html_id":"wsaesocktnosupport?-instance-method","name":"wsaesocktnosupport?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1757,"url":null},"def":{"name":"wsaesocktnosupport?","visibility":"Public","body":"self == WSAESOCKTNOSUPPORT"}},{"html_id":"wsaestale?-instance-method","name":"wsaestale?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1783,"url":null},"def":{"name":"wsaestale?","visibility":"Public","body":"self == WSAESTALE"}},{"html_id":"wsaetimedout?-instance-method","name":"wsaetimedout?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1773,"url":null},"def":{"name":"wsaetimedout?","visibility":"Public","body":"self == WSAETIMEDOUT"}},{"html_id":"wsaetoomanyrefs?-instance-method","name":"wsaetoomanyrefs?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1772,"url":null},"def":{"name":"wsaetoomanyrefs?","visibility":"Public","body":"self == WSAETOOMANYREFS"}},{"html_id":"wsaeusers?-instance-method","name":"wsaeusers?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1781,"url":null},"def":{"name":"wsaeusers?","visibility":"Public","body":"self == WSAEUSERS"}},{"html_id":"wsaewouldblock?-instance-method","name":"wsaewouldblock?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1748,"url":null},"def":{"name":"wsaewouldblock?","visibility":"Public","body":"self == WSAEWOULDBLOCK"}},{"html_id":"wsahost_not_found?-instance-method","name":"wsahost_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1800,"url":null},"def":{"name":"wsahost_not_found?","visibility":"Public","body":"self == WSAHOST_NOT_FOUND"}},{"html_id":"wsano_data?-instance-method","name":"wsano_data?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1803,"url":null},"def":{"name":"wsano_data?","visibility":"Public","body":"self == WSANO_DATA"}},{"html_id":"wsano_recovery?-instance-method","name":"wsano_recovery?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1802,"url":null},"def":{"name":"wsano_recovery?","visibility":"Public","body":"self == WSANO_RECOVERY"}},{"html_id":"wsanotinitialised?-instance-method","name":"wsanotinitialised?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1787,"url":null},"def":{"name":"wsanotinitialised?","visibility":"Public","body":"self == WSANOTINITIALISED"}},{"html_id":"wsaservice_not_found?-instance-method","name":"wsaservice_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1795,"url":null},"def":{"name":"wsaservice_not_found?","visibility":"Public","body":"self == WSASERVICE_NOT_FOUND"}},{"html_id":"wsasyscallfailure?-instance-method","name":"wsasyscallfailure?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1794,"url":null},"def":{"name":"wsasyscallfailure?","visibility":"Public","body":"self == WSASYSCALLFAILURE"}},{"html_id":"wsasysnotready?-instance-method","name":"wsasysnotready?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1785,"url":null},"def":{"name":"wsasysnotready?","visibility":"Public","body":"self == WSASYSNOTREADY"}},{"html_id":"wsatry_again?-instance-method","name":"wsatry_again?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1801,"url":null},"def":{"name":"wsatry_again?","visibility":"Public","body":"self == WSATRY_AGAIN"}},{"html_id":"wsatype_not_found?-instance-method","name":"wsatype_not_found?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1796,"url":null},"def":{"name":"wsatype_not_found?","visibility":"Public","body":"self == WSATYPE_NOT_FOUND"}},{"html_id":"wsavernotsupported?-instance-method","name":"wsavernotsupported?","abstract":false,"location":{"filename":"src/winerror.cr","line_number":1786,"url":null},"def":{"name":"wsavernotsupported?","visibility":"Public","body":"self == WSAVERNOTSUPPORTED"}}]},{"html_id":"Crystal/XML","path":"XML.html","kind":"module","full_name":"XML","name":"XML","abstract":false,"locations":[{"filename":"src/xml.cr","line_number":49,"url":null},{"filename":"src/xml/builder.cr","line_number":308,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"The XML module allows parsing and generating [XML](https://www.w3.org/XML/) documents.\n\n### Parsing\n\n`XML#parse` will parse xml from `String` or `IO` and return xml document as an `XML::Node` which represents all kinds of xml nodes.\n\nExample:\n\n```\nrequire \"xml\"\n\nxml = <<-XML\n <person id=\"1\">\n  <firstname>Jane</firstname>\n  <lastname>Doe</lastname>\n </person>\nXML\n\ndocument = XML.parse(xml)             # : XML::Node\nperson = document.first_element_child # : XML::Node?\nif person\n  puts person[\"id\"] # \"1\" : String?\n\n  puts typeof(person.children)                       # XML::NodeSet\n  person.children.select(&.element?).each do |child| # Select only element children\n    puts typeof(child)                               # XML::Node\n    puts child.name                                  # firstname : String\n    puts child.content                               # Jane : String?\n  end\nend\n```\n\n## Generating\n\nUse `XML.build`, which uses an `XML::Builder`:\n\n```\nrequire \"xml\"\n\nstring = XML.build(indent: \"  \") do |xml|\n  xml.element(\"person\", id: 1) do\n    xml.element(\"firstname\") { xml.text \"Jane\" }\n    xml.element(\"lastname\") { xml.text \"Doe\" }\n  end\nend\n\nstring # => \"<?xml version=\\\"1.0\\\"?>\\n<person id=\\\"1\\\">\\n  <firstname>Jane</firstname>\\n  <lastname>Doe</lastname>\\n</person>\\n\"\n```","summary":"<p>The XML module allows parsing and generating <a href=\"https://www.w3.org/XML/\">XML</a> documents.</p>","class_methods":[{"html_id":"build(version:String?=nil,encoding:String?=nil,indent=nil,quote_char=nil,&)-class-method","name":"build","doc":"Returns the resulting `String` of writing XML to the yielded `XML::Builder`.\n\nBuilds an XML document (see `#document`) including XML declaration (`<?xml?>`).\n\n```\nrequire \"xml\"\n\nstring = XML.build(indent: \"  \") do |xml|\n  xml.element(\"person\", id: 1) do\n    xml.element(\"firstname\") { xml.text \"Jane\" }\n    xml.element(\"lastname\") { xml.text \"Doe\" }\n  end\nend\n\nstring # => \"<?xml version=\\\"1.0\\\"?>\\n<person id=\\\"1\\\">\\n  <firstname>Jane</firstname>\\n  <lastname>Doe</lastname>\\n</person>\\n\"\n```","summary":"<p>Returns the resulting <code><a href=\"String.html\">String</a></code> of writing XML to the yielded <code><a href=\"XML/Builder.html\">XML::Builder</a></code>.</p>","abstract":false,"args":[{"name":"version","default_value":"nil","external_name":"version","restriction":"String | ::Nil"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":"String | ::Nil"},{"name":"indent","default_value":"nil","external_name":"indent","restriction":""},{"name":"quote_char","default_value":"nil","external_name":"quote_char","restriction":""}],"args_string":"(version : String? = nil, encoding : String? = nil, indent = nil, quote_char = nil, &)","args_html":"(version : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>, encoding : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>, indent = <span class=\"n\">nil</span>, quote_char = <span class=\"n\">nil</span>, &)","location":{"filename":"src/xml/builder.cr","line_number":325,"url":null},"def":{"name":"build","args":[{"name":"version","default_value":"nil","external_name":"version","restriction":"String | ::Nil"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":"String | ::Nil"},{"name":"indent","default_value":"nil","external_name":"indent","restriction":""},{"name":"quote_char","default_value":"nil","external_name":"quote_char","restriction":""}],"yields":1,"visibility":"Public","body":"String.build do |str|\n  build(str, version, encoding, indent, quote_char) do |xml|\n    yield xml\n  end\nend"}},{"html_id":"build(io:IO,version:String?=nil,encoding:String?=nil,indent=nil,quote_char=nil,&):Nil-class-method","name":"build","doc":"Writes XML document into the given `IO`. An `XML::Builder` is yielded to the block.\n\nBuilds an XML document (see `#document`) including XML declaration (`<?xml?>`).","summary":"<p>Writes XML document into the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"version","default_value":"nil","external_name":"version","restriction":"String | ::Nil"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":"String | ::Nil"},{"name":"indent","default_value":"nil","external_name":"indent","restriction":""},{"name":"quote_char","default_value":"nil","external_name":"quote_char","restriction":""}],"args_string":"(io : IO, version : String? = nil, encoding : String? = nil, indent = nil, quote_char = nil, &) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, version : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>, encoding : <a href=\"String.html\">String</a>? = <span class=\"n\">nil</span>, indent = <span class=\"n\">nil</span>, quote_char = <span class=\"n\">nil</span>, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":360,"url":null},"def":{"name":"build","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"version","default_value":"nil","external_name":"version","restriction":"String | ::Nil"},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":"String | ::Nil"},{"name":"indent","default_value":"nil","external_name":"indent","restriction":""},{"name":"quote_char","default_value":"nil","external_name":"quote_char","restriction":""}],"yields":1,"return_type":"Nil","visibility":"Public","body":"build_fragment(io, indent: indent, quote_char: quote_char) do |xml|\n  xml.start_document(version, encoding)\n  yield xml\nend"}},{"html_id":"build_fragment(io:IO,*,indent=nil,quote_char=nil,&):Nil-class-method","name":"build_fragment","doc":"Writes XML fragment into the given `IO`. An `XML::Builder` is yielded to the block.\n\nBuilds an XML fragment without XML declaration (`<?xml?>`).","summary":"<p>Writes XML fragment into the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"","external_name":"","restriction":""},{"name":"indent","default_value":"nil","external_name":"indent","restriction":""},{"name":"quote_char","default_value":"nil","external_name":"quote_char","restriction":""}],"args_string":"(io : IO, *, indent = nil, quote_char = nil, &) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, *, indent = <span class=\"n\">nil</span>, quote_char = <span class=\"n\">nil</span>, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":371,"url":null},"def":{"name":"build_fragment","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"","external_name":"","restriction":""},{"name":"indent","default_value":"nil","external_name":"indent","restriction":""},{"name":"quote_char","default_value":"nil","external_name":"quote_char","restriction":""}],"splat_index":1,"yields":1,"return_type":"Nil","visibility":"Public","body":"xml = XML::Builder.new(io)\nif indent\n  xml.indent = indent\nend\nif quote_char\n  xml.quote_char = quote_char\nend\nv = yield xml\nxml.end_document\nxml.flush\nv\n"}},{"html_id":"build_fragment(*,indent=nil,quote_char=nil,&)-class-method","name":"build_fragment","doc":"Returns the resulting `String` of writing XML to the yielded `XML::Builder`.\n\nBuilds an XML fragment without XML declaration (`<?xml?>`).\n\n```\nrequire \"xml\"\n\nstring = XML.build_fragment(indent: \"  \") do |xml|\n  xml.element(\"person\", id: 1) do\n    xml.element(\"firstname\") { xml.text \"Jane\" }\n    xml.element(\"lastname\") { xml.text \"Doe\" }\n  end\nend\n\nstring # => \"<person id=\\\"1\\\">\\n  <firstname>Jane</firstname>\\n  <lastname>Doe</lastname>\\n</person>\\n\"\n```","summary":"<p>Returns the resulting <code><a href=\"String.html\">String</a></code> of writing XML to the yielded <code><a href=\"XML/Builder.html\">XML::Builder</a></code>.</p>","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"indent","default_value":"nil","external_name":"indent","restriction":""},{"name":"quote_char","default_value":"nil","external_name":"quote_char","restriction":""}],"args_string":"(*, indent = nil, quote_char = nil, &)","args_html":"(*, indent = <span class=\"n\">nil</span>, quote_char = <span class=\"n\">nil</span>, &)","location":{"filename":"src/xml/builder.cr","line_number":349,"url":null},"def":{"name":"build_fragment","args":[{"name":"","external_name":"","restriction":""},{"name":"indent","default_value":"nil","external_name":"indent","restriction":""},{"name":"quote_char","default_value":"nil","external_name":"quote_char","restriction":""}],"splat_index":0,"yields":1,"visibility":"Public","body":"String.build do |str|\n  build_fragment(str, indent: indent, quote_char: quote_char) do |xml|\n    yield xml\n  end\nend"}},{"html_id":"parse(string:String,options:ParserOptions=ParserOptions.default):Node-class-method","name":"parse","doc":"Parses an XML document from *string* with *options* into an `XML::Node`.\n\nSee `ParserOptions.default` for default options.","summary":"<p>Parses an XML document from <em>string</em> with <em>options</em> into an <code><a href=\"XML/Node.html\">XML::Node</a></code>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"options","default_value":"ParserOptions.default","external_name":"options","restriction":"ParserOptions"}],"args_string":"(string : String, options : ParserOptions = ParserOptions.default) : Node","args_html":"(string : <a href=\"String.html\">String</a>, options : <a href=\"XML/ParserOptions.html\">ParserOptions</a> = <span class=\"t\">ParserOptions</span>.default) : <a href=\"XML/Node.html\">Node</a>","location":{"filename":"src/xml.cr","line_number":53,"url":null},"def":{"name":"parse","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"options","default_value":"ParserOptions.default","external_name":"options","restriction":"ParserOptions"}],"return_type":"Node","visibility":"Public","body":"if string.empty?\n  raise(XML::Error.new(\"Document is empty\", 0))\nend\nfrom_ptr(LibXML.xmlReadMemory(string, string.bytesize, nil, nil, options))\n"}},{"html_id":"parse(io:IO,options:ParserOptions=ParserOptions.default):Node-class-method","name":"parse","doc":"Parses an XML document from *io* with *options* into an `XML::Node`.\n\nSee `ParserOptions.default` for default options.","summary":"<p>Parses an XML document from <em>io</em> with <em>options</em> into an <code><a href=\"XML/Node.html\">XML::Node</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":"ParserOptions.default","external_name":"options","restriction":"ParserOptions"}],"args_string":"(io : IO, options : ParserOptions = ParserOptions.default) : Node","args_html":"(io : <a href=\"IO.html\">IO</a>, options : <a href=\"XML/ParserOptions.html\">ParserOptions</a> = <span class=\"t\">ParserOptions</span>.default) : <a href=\"XML/Node.html\">Node</a>","location":{"filename":"src/xml.cr","line_number":61,"url":null},"def":{"name":"parse","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":"ParserOptions.default","external_name":"options","restriction":"ParserOptions"}],"return_type":"Node","visibility":"Public","body":"from_ptr(LibXML.xmlReadIO(->(ctx, buffer, len) do\n  LibC::Int.new((Box(IO).unbox(ctx)).read(Slice.new(buffer, len)))\nend, ->(ctx) do\n  0\nend, Box(IO).box(io), nil, nil, options))"}},{"html_id":"parse_html(string:String,options:HTMLParserOptions=HTMLParserOptions.default):Node-class-method","name":"parse_html","doc":"Parses an HTML document from *string* with *options* into an `XML::Node`.\n\nSee `HTMLParserOptions.default` for default options.","summary":"<p>Parses an HTML document from <em>string</em> with <em>options</em> into an <code><a href=\"XML/Node.html\">XML::Node</a></code>.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"options","default_value":"HTMLParserOptions.default","external_name":"options","restriction":"HTMLParserOptions"}],"args_string":"(string : String, options : HTMLParserOptions = HTMLParserOptions.default) : Node","args_html":"(string : <a href=\"String.html\">String</a>, options : <a href=\"XML/HTMLParserOptions.html\">HTMLParserOptions</a> = <span class=\"t\">HTMLParserOptions</span>.default) : <a href=\"XML/Node.html\">Node</a>","location":{"filename":"src/xml.cr","line_number":77,"url":null},"def":{"name":"parse_html","args":[{"name":"string","external_name":"string","restriction":"String"},{"name":"options","default_value":"HTMLParserOptions.default","external_name":"options","restriction":"HTMLParserOptions"}],"return_type":"Node","visibility":"Public","body":"if string.empty?\n  raise(XML::Error.new(\"Document is empty\", 0))\nend\nfrom_ptr(LibXML.htmlReadMemory(string, string.bytesize, nil, nil, options))\n"}},{"html_id":"parse_html(io:IO,options:HTMLParserOptions=HTMLParserOptions.default):Node-class-method","name":"parse_html","doc":"Parses an HTML document from *io* with *options* into an `XML::Node`.\n\nSee `HTMLParserOptions.default` for default options.","summary":"<p>Parses an HTML document from <em>io</em> with <em>options</em> into an <code><a href=\"XML/Node.html\">XML::Node</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":"HTMLParserOptions.default","external_name":"options","restriction":"HTMLParserOptions"}],"args_string":"(io : IO, options : HTMLParserOptions = HTMLParserOptions.default) : Node","args_html":"(io : <a href=\"IO.html\">IO</a>, options : <a href=\"XML/HTMLParserOptions.html\">HTMLParserOptions</a> = <span class=\"t\">HTMLParserOptions</span>.default) : <a href=\"XML/Node.html\">Node</a>","location":{"filename":"src/xml.cr","line_number":85,"url":null},"def":{"name":"parse_html","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":"HTMLParserOptions.default","external_name":"options","restriction":"HTMLParserOptions"}],"return_type":"Node","visibility":"Public","body":"from_ptr(LibXML.htmlReadIO(->(ctx, buffer, len) do\n  LibC::Int.new((Box(IO).unbox(ctx)).read(Slice.new(buffer, len)))\nend, ->(ctx) do\n  0\nend, Box(IO).box(io), nil, nil, options))"}}],"types":[{"html_id":"Crystal/XML/Attributes","path":"XML/Attributes.html","kind":"class","full_name":"XML::Attributes","name":"Attributes","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/xml/attributes.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"namespace":{"html_id":"Crystal/XML","kind":"module","full_name":"XML","name":"XML"},"constructors":[{"html_id":"new(node:Node)-class-method","name":"new","abstract":false,"args":[{"name":"node","external_name":"node","restriction":"Node"}],"args_string":"(node : Node)","args_html":"(node : <a href=\"../XML/Node.html\">Node</a>)","location":{"filename":"src/xml/attributes.cr","line_number":6,"url":null},"def":{"name":"new","args":[{"name":"node","external_name":"node","restriction":"Node"}],"visibility":"Public","body":"_ = allocate\n_.initialize(node)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"[](index:Int):XML::Node-instance-method","name":"[]","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : XML::Node","args_html":"(index : <a href=\"../Int.html\">Int</a>) : <a href=\"../XML/Node.html\">XML::Node</a>","location":{"filename":"src/xml/attributes.cr","line_number":16,"url":null},"def":{"name":"[]","args":[{"name":"index","external_name":"index","restriction":"Int"}],"return_type":"XML::Node","visibility":"Public","body":"size = self.size\nif index < 0\n  index = index + size\nend\nif 0 <= index && index < size\nelse\n  raise(IndexError.new)\nend\neach_with_index do |node, i|\n  if i == index\n    return node\n  end\nend\nraise(IndexError.new)\n"}},{"html_id":"[](name:String):XML::Node-instance-method","name":"[]","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String) : XML::Node","args_html":"(name : <a href=\"../String.html\">String</a>) : <a href=\"../XML/Node.html\">XML::Node</a>","location":{"filename":"src/xml/attributes.cr","line_number":33,"url":null},"def":{"name":"[]","args":[{"name":"name","external_name":"name","restriction":"String"}],"return_type":"XML::Node","visibility":"Public","body":"self[name]? || (raise(KeyError.new(\"Missing attribute: #{name}\")))"}},{"html_id":"[]=(name:String,value)-instance-method","name":"[]=","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"value","external_name":"value","restriction":""}],"args_string":"(name : String, value)","args_html":"(name : <a href=\"../String.html\">String</a>, value)","location":{"filename":"src/xml/attributes.cr","line_number":41,"url":null},"def":{"name":"[]=","args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"LibXML.xmlSetProp(@node, name, value.to_s)\nvalue\n"}},{"html_id":"[]?(name:String):XML::Node?-instance-method","name":"[]?","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String) : XML::Node?","args_html":"(name : <a href=\"../String.html\">String</a>) : <a href=\"../XML/Node.html\">XML::Node</a>?","location":{"filename":"src/xml/attributes.cr","line_number":37,"url":null},"def":{"name":"[]?","args":[{"name":"name","external_name":"name","restriction":"String"}],"return_type":"XML::Node | ::Nil","visibility":"Public","body":"find do |node|\n  node.name == name\nend"}},{"html_id":"delete(name:String):String?-instance-method","name":"delete","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String) : String?","args_html":"(name : <a href=\"../String.html\">String</a>) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/xml/attributes.cr","line_number":46,"url":null},"def":{"name":"delete","args":[{"name":"name","external_name":"name","restriction":"String"}],"return_type":"String | ::Nil","visibility":"Public","body":"value = self[name]?.try(&.content)\nres = LibXML.xmlUnsetProp(@node, name)\nif res == 0\n  value\nend\n"}},{"html_id":"each(&):Nil-instance-method","name":"each","doc":"Must yield this collection's elements to the block.","summary":"<p>Must yield this collection's elements to the block.</p>","abstract":false,"location":{"filename":"src/xml/attributes.cr","line_number":52,"url":null},"def":{"name":"each","yields":1,"return_type":"Nil","visibility":"Public","body":"if @node.element?\nelse\n  return\nend\nprops = self.props\nwhile !props.null?\n  yield Node.new(props)\n  props = props.value.next\nend\n"}},{"html_id":"empty?:Bool-instance-method","name":"empty?","doc":"Returns `true` if `self` is empty, `false` otherwise.\n\n```\n([] of Int32).empty? # => true\n([1]).empty?         # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is empty, <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/xml/attributes.cr","line_number":9,"url":null},"def":{"name":"empty?","return_type":"Bool","visibility":"Public","body":"if @node.element?\nelse\n  return true\nend\nprops = self.props\nprops.null?\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/attributes.cr","line_number":68,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a short String representation of this object\nwhich includes its class name and its object address.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).to_s # => #<Person:0x10a199f20>\n```","summary":"<p>Appends a short String representation of this object which includes its class name and its object address.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/attributes.cr","line_number":62,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << '['\njoin(io, \", \", &.inspect(io))\nio << ']'\n"}}]},{"html_id":"Crystal/XML/AttributeType","path":"XML/AttributeType.html","kind":"enum","full_name":"XML::AttributeType","name":"AttributeType","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/xml/attribute_type.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"CDATA","name":"CDATA","value":"1"},{"id":"ID","name":"ID","value":"2"},{"id":"IDREF","name":"IDREF","value":"3"},{"id":"IDREFS","name":"IDREFS","value":"4"},{"id":"ENTITY","name":"ENTITY","value":"5"},{"id":"ENTITIES","name":"ENTITIES","value":"6"},{"id":"NMTOKEN","name":"NMTOKEN","value":"7"},{"id":"NMTOKENS","name":"NMTOKENS","value":"8"},{"id":"ENUMERATION","name":"ENUMERATION","value":"9"},{"id":"NOTATION","name":"NOTATION","value":"10"}],"namespace":{"html_id":"Crystal/XML","kind":"module","full_name":"XML","name":"XML"},"instance_methods":[{"html_id":"cdata?-instance-method","name":"cdata?","abstract":false,"location":{"filename":"src/xml/attribute_type.cr","line_number":2,"url":null},"def":{"name":"cdata?","visibility":"Public","body":"self == CDATA"}},{"html_id":"entities?-instance-method","name":"entities?","abstract":false,"location":{"filename":"src/xml/attribute_type.cr","line_number":7,"url":null},"def":{"name":"entities?","visibility":"Public","body":"self == ENTITIES"}},{"html_id":"entity?-instance-method","name":"entity?","abstract":false,"location":{"filename":"src/xml/attribute_type.cr","line_number":6,"url":null},"def":{"name":"entity?","visibility":"Public","body":"self == ENTITY"}},{"html_id":"enumeration?-instance-method","name":"enumeration?","abstract":false,"location":{"filename":"src/xml/attribute_type.cr","line_number":10,"url":null},"def":{"name":"enumeration?","visibility":"Public","body":"self == ENUMERATION"}},{"html_id":"id?-instance-method","name":"id?","abstract":false,"location":{"filename":"src/xml/attribute_type.cr","line_number":3,"url":null},"def":{"name":"id?","visibility":"Public","body":"self == ID"}},{"html_id":"idref?-instance-method","name":"idref?","abstract":false,"location":{"filename":"src/xml/attribute_type.cr","line_number":4,"url":null},"def":{"name":"idref?","visibility":"Public","body":"self == IDREF"}},{"html_id":"idrefs?-instance-method","name":"idrefs?","abstract":false,"location":{"filename":"src/xml/attribute_type.cr","line_number":5,"url":null},"def":{"name":"idrefs?","visibility":"Public","body":"self == IDREFS"}},{"html_id":"nmtoken?-instance-method","name":"nmtoken?","abstract":false,"location":{"filename":"src/xml/attribute_type.cr","line_number":8,"url":null},"def":{"name":"nmtoken?","visibility":"Public","body":"self == NMTOKEN"}},{"html_id":"nmtokens?-instance-method","name":"nmtokens?","abstract":false,"location":{"filename":"src/xml/attribute_type.cr","line_number":9,"url":null},"def":{"name":"nmtokens?","visibility":"Public","body":"self == NMTOKENS"}},{"html_id":"notation?-instance-method","name":"notation?","abstract":false,"location":{"filename":"src/xml/attribute_type.cr","line_number":11,"url":null},"def":{"name":"notation?","visibility":"Public","body":"self == NOTATION"}}]},{"html_id":"Crystal/XML/Builder","path":"XML/Builder.html","kind":"class","full_name":"XML::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/xml/builder.cr","line_number":7,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/XML","kind":"module","full_name":"XML","name":"XML"},"doc":"An XML builder generates valid XML.\n\nAn `XML::Error` is raised if attempting to generate\nan invalid XML (for example, if invoking `end_element`\nwithout a matching `start_element`, or trying to use\na non-string value as an object's field name)","summary":"<p>An XML builder generates valid XML.</p>","constructors":[{"html_id":"new(io:IO)-class-method","name":"new","doc":"Creates a builder that writes to the given *io*.","summary":"<p>Creates a builder that writes to the given <em>io</em>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","args_html":"(io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/xml/builder.cr","line_number":14,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"_ = allocate\n_.initialize(io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"attribute(*args,**nargs,&)-instance-method","name":"attribute","doc":"Emits the start of an attribute, invokes the block,\nand then emits the end of the attribute.","summary":"<p>Emits the start of an attribute, invokes the block, and then emits the end of the attribute.</p>","abstract":false,"args":[{"name":"args","external_name":"args","restriction":""}],"args_string":"(*args, **nargs, &)","args_html":"(*args, **nargs, &)","location":{"filename":"src/xml/builder.cr","line_number":140,"url":null},"def":{"name":"attribute","args":[{"name":"args","external_name":"args","restriction":""}],"double_splat":{"name":"nargs","external_name":"nargs","restriction":""},"splat_index":0,"yields":0,"visibility":"Public","body":"start_attribute(*args, **nargs)\n(yield).tap do\n  end_attribute\nend\n"}},{"html_id":"attribute(prefix:String?,name:String,namespace_uri:String?,value):Nil-instance-method","name":"attribute","doc":"Emits an attribute with namespace info and a *value*.","summary":"<p>Emits an attribute with namespace info and a <em>value</em>.</p>","abstract":false,"args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","external_name":"name","restriction":"String"},{"name":"namespace_uri","external_name":"namespace_uri","restriction":"String | ::Nil"},{"name":"value","external_name":"value","restriction":""}],"args_string":"(prefix : String?, name : String, namespace_uri : String?, value) : Nil","args_html":"(prefix : <a href=\"../String.html\">String</a>?, name : <a href=\"../String.html\">String</a>, namespace_uri : <a href=\"../String.html\">String</a>?, value) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":151,"url":null},"def":{"name":"attribute","args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","external_name":"name","restriction":"String"},{"name":"namespace_uri","external_name":"namespace_uri","restriction":"String | ::Nil"},{"name":"value","external_name":"value","restriction":""}],"return_type":"Nil","visibility":"Public","body":"call(WriteAttributeNS, string_to_unsafe(prefix), string_to_unsafe(name), string_to_unsafe(namespace_uri), string_to_unsafe(value.to_s))"}},{"html_id":"attribute(name:String,value):Nil-instance-method","name":"attribute","doc":"Emits an attribute with a *value*.","summary":"<p>Emits an attribute with a <em>value</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"value","external_name":"value","restriction":""}],"args_string":"(name : String, value) : Nil","args_html":"(name : <a href=\"../String.html\">String</a>, value) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":146,"url":null},"def":{"name":"attribute","args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"value","external_name":"value","restriction":""}],"return_type":"Nil","visibility":"Public","body":"call(WriteAttribute, string_to_unsafe(name), string_to_unsafe(value.to_s))"}},{"html_id":"attributes(attributes:Hash|NamedTuple):Nil-instance-method","name":"attributes","doc":"Emits the given *attributes* with their values.","summary":"<p>Emits the given <em>attributes</em> with their values.</p>","abstract":false,"args":[{"name":"attributes","external_name":"attributes","restriction":"Hash | NamedTuple"}],"args_string":"(attributes : Hash | NamedTuple) : Nil","args_html":"(attributes : <a href=\"../Hash.html\">Hash</a> | <a href=\"../NamedTuple.html\">NamedTuple</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":161,"url":null},"def":{"name":"attributes","args":[{"name":"attributes","external_name":"attributes","restriction":"Hash | NamedTuple"}],"return_type":"Nil","visibility":"Public","body":"attributes.each do |key, value|\n  attribute(key.to_s, value)\nend"}},{"html_id":"attributes(**attributes)-instance-method","name":"attributes","doc":"Emits the given *attributes* with their values.","summary":"<p>Emits the given <em>attributes</em> with their values.</p>","abstract":false,"location":{"filename":"src/xml/builder.cr","line_number":156,"url":null},"def":{"name":"attributes","double_splat":{"name":"attributes","external_name":"attributes","restriction":""},"visibility":"Public","body":"attributes(attributes)"}},{"html_id":"cdata(&)-instance-method","name":"cdata","doc":"Emits the start of a `CDATA` section, invokes the block\nand then emits the end of the `CDATA` section.\n\nNOTE: `CDATA` end sequences written within the block\nneed to be escaped manually.","summary":"<p>Emits the start of a <code>CDATA</code> section, invokes the block and then emits the end of the <code>CDATA</code> section.</p>","abstract":false,"location":{"filename":"src/xml/builder.cr","line_number":189,"url":null},"def":{"name":"cdata","yields":0,"visibility":"Public","body":"start_cdata\n(yield).tap do\n  end_cdata\nend\n"}},{"html_id":"cdata(text:String):Nil-instance-method","name":"cdata","doc":"Emits a `CDATA` section.  Escapes nested `CDATA` end sequences.","summary":"<p>Emits a <code>CDATA</code> section.</p>","abstract":false,"args":[{"name":"text","external_name":"text","restriction":"String"}],"args_string":"(text : String) : Nil","args_html":"(text : <a href=\"../String.html\">String</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":195,"url":null},"def":{"name":"cdata","args":[{"name":"text","external_name":"text","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"call(WriteCDATA, string_to_unsafe(text.gsub(CDATA_END, CDATA_ESCAPE)))"}},{"html_id":"comment(&)-instance-method","name":"comment","doc":"Emits the start of a comment, invokes the block\nand then emits the end of the comment.","summary":"<p>Emits the start of a comment, invokes the block and then emits the end of the comment.</p>","abstract":false,"location":{"filename":"src/xml/builder.cr","line_number":211,"url":null},"def":{"name":"comment","yields":0,"visibility":"Public","body":"start_comment\n(yield).tap do\n  end_comment\nend\n"}},{"html_id":"comment(text:String):Nil-instance-method","name":"comment","doc":"Emits a comment.","summary":"<p>Emits a comment.</p>","abstract":false,"args":[{"name":"text","external_name":"text","restriction":"String"}],"args_string":"(text : String) : Nil","args_html":"(text : <a href=\"../String.html\">String</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":217,"url":null},"def":{"name":"comment","args":[{"name":"text","external_name":"text","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"call(WriteComment, string_to_unsafe(text))"}},{"html_id":"document(version=nil,encoding=nil,&)-instance-method","name":"document","doc":"Emits the start of the document, invokes the block,\nand then emits the end of the document.","summary":"<p>Emits the start of the document, invokes the block, and then emits the end of the document.</p>","abstract":false,"args":[{"name":"version","default_value":"nil","external_name":"version","restriction":""},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""}],"args_string":"(version = nil, encoding = nil, &)","args_html":"(version = <span class=\"n\">nil</span>, encoding = <span class=\"n\">nil</span>, &)","location":{"filename":"src/xml/builder.cr","line_number":43,"url":null},"def":{"name":"document","args":[{"name":"version","default_value":"nil","external_name":"version","restriction":""},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""}],"yields":0,"visibility":"Public","body":"start_document(version, encoding)\n(yield).tap do\n  end_document\nend\n"}},{"html_id":"dtd(name:String,pubid:String,sysid:String,&):Nil-instance-method","name":"dtd","doc":"Emits the start of a `DTD`, invokes the block\nand then emits the end of the `DTD`.","summary":"<p>Emits the start of a <code>DTD</code>, invokes the block and then emits the end of the <code>DTD</code>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"pubid","external_name":"pubid","restriction":"String"},{"name":"sysid","external_name":"sysid","restriction":"String"}],"args_string":"(name : String, pubid : String, sysid : String, &) : Nil","args_html":"(name : <a href=\"../String.html\">String</a>, pubid : <a href=\"../String.html\">String</a>, sysid : <a href=\"../String.html\">String</a>, &) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":233,"url":null},"def":{"name":"dtd","args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"pubid","external_name":"pubid","restriction":"String"},{"name":"sysid","external_name":"sysid","restriction":"String"}],"yields":0,"return_type":"Nil","visibility":"Public","body":"start_dtd(name, pubid, sysid)\n(yield).tap do\n  end_dtd\nend\n"}},{"html_id":"dtd(name:String,pubid:String,sysid:String,subset:String?=nil):Nil-instance-method","name":"dtd","doc":"Emits a `DTD`.","summary":"<p>Emits a <code>DTD</code>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"pubid","external_name":"pubid","restriction":"String"},{"name":"sysid","external_name":"sysid","restriction":"String"},{"name":"subset","default_value":"nil","external_name":"subset","restriction":"String | ::Nil"}],"args_string":"(name : String, pubid : String, sysid : String, subset : String? = nil) : Nil","args_html":"(name : <a href=\"../String.html\">String</a>, pubid : <a href=\"../String.html\">String</a>, sysid : <a href=\"../String.html\">String</a>, subset : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":239,"url":null},"def":{"name":"dtd","args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"pubid","external_name":"pubid","restriction":"String"},{"name":"sysid","external_name":"sysid","restriction":"String"},{"name":"subset","default_value":"nil","external_name":"subset","restriction":"String | ::Nil"}],"return_type":"Nil","visibility":"Public","body":"call(WriteDTD, string_to_unsafe(name), string_to_unsafe(pubid), string_to_unsafe(sysid), string_to_unsafe(subset))"}},{"html_id":"element(__prefix__:String?,__name__:String,__namespace_uri__:String?,attributes:Hash|NamedTuple,&)-instance-method","name":"element","doc":"Emits the start of an element with namespace info with the given *attributes*,\ninvokes the block and then emits the end of the element.","summary":"<p>Emits the start of an element with namespace info with the given <em>attributes</em>, invokes the block and then emits the end of the element.</p>","abstract":false,"args":[{"name":"__prefix__","external_name":"__prefix__","restriction":"String | ::Nil"},{"name":"__name__","external_name":"__name__","restriction":"String"},{"name":"__namespace_uri__","external_name":"__namespace_uri__","restriction":"String | ::Nil"},{"name":"attributes","external_name":"attributes","restriction":"Hash | NamedTuple"}],"args_string":"(__prefix__ : String?, __name__ : String, __namespace_uri__ : String?, attributes : Hash | NamedTuple, &)","args_html":"(__prefix__ : <a href=\"../String.html\">String</a>?, __name__ : <a href=\"../String.html\">String</a>, __namespace_uri__ : <a href=\"../String.html\">String</a>?, attributes : <a href=\"../Hash.html\">Hash</a> | <a href=\"../NamedTuple.html\">NamedTuple</a>, &)","location":{"filename":"src/xml/builder.cr","line_number":105,"url":null},"def":{"name":"element","args":[{"name":"__prefix__","external_name":"__prefix__","restriction":"String | ::Nil"},{"name":"__name__","external_name":"__name__","restriction":"String"},{"name":"__namespace_uri__","external_name":"__namespace_uri__","restriction":"String | ::Nil"},{"name":"attributes","external_name":"attributes","restriction":"Hash | NamedTuple"}],"yields":0,"visibility":"Public","body":"start_element(__prefix__, __name__, __namespace_uri__)\nattributes(attributes)\n(yield).tap do\n  end_element\nend\n"}},{"html_id":"element(__prefix__:String?,__name__:String,__namespace_uri__:String?,**attributes,&)-instance-method","name":"element","doc":"Emits the start of an element with namespace info with the given *attributes*,\ninvokes the block and then emits the end of the element.","summary":"<p>Emits the start of an element with namespace info with the given <em>attributes</em>, invokes the block and then emits the end of the element.</p>","abstract":false,"args":[{"name":"__prefix__","external_name":"__prefix__","restriction":"String | ::Nil"},{"name":"__name__","external_name":"__name__","restriction":"String"},{"name":"__namespace_uri__","external_name":"__namespace_uri__","restriction":"String | ::Nil"}],"args_string":"(__prefix__ : String?, __name__ : String, __namespace_uri__ : String?, **attributes, &)","args_html":"(__prefix__ : <a href=\"../String.html\">String</a>?, __name__ : <a href=\"../String.html\">String</a>, __namespace_uri__ : <a href=\"../String.html\">String</a>?, **attributes, &)","location":{"filename":"src/xml/builder.cr","line_number":98,"url":null},"def":{"name":"element","args":[{"name":"__prefix__","external_name":"__prefix__","restriction":"String | ::Nil"},{"name":"__name__","external_name":"__name__","restriction":"String"},{"name":"__namespace_uri__","external_name":"__namespace_uri__","restriction":"String | ::Nil"}],"double_splat":{"name":"attributes","external_name":"attributes","restriction":""},"yields":0,"visibility":"Public","body":"element(__prefix__, __name__, __namespace_uri__, attributes) do\n  yield\nend"}},{"html_id":"element(__name__:String,attributes:Hash|NamedTuple,&)-instance-method","name":"element","doc":"Emits the start of an element with the given *attributes*,\ninvokes the block and then emits the end of the element.","summary":"<p>Emits the start of an element with the given <em>attributes</em>, invokes the block and then emits the end of the element.</p>","abstract":false,"args":[{"name":"__name__","external_name":"__name__","restriction":"String"},{"name":"attributes","external_name":"attributes","restriction":"Hash | NamedTuple"}],"args_string":"(__name__ : String, attributes : Hash | NamedTuple, &)","args_html":"(__name__ : <a href=\"../String.html\">String</a>, attributes : <a href=\"../Hash.html\">Hash</a> | <a href=\"../NamedTuple.html\">NamedTuple</a>, &)","location":{"filename":"src/xml/builder.cr","line_number":80,"url":null},"def":{"name":"element","args":[{"name":"__name__","external_name":"__name__","restriction":"String"},{"name":"attributes","external_name":"attributes","restriction":"Hash | NamedTuple"}],"yields":0,"visibility":"Public","body":"start_element(__name__)\nattributes(attributes)\n(yield).tap do\n  end_element\nend\n"}},{"html_id":"element(__name__:String,**attributes,&)-instance-method","name":"element","doc":"Emits the start of an element with the given *attributes*,\ninvokes the block and then emits the end of the element.","summary":"<p>Emits the start of an element with the given <em>attributes</em>, invokes the block and then emits the end of the element.</p>","abstract":false,"args":[{"name":"__name__","external_name":"__name__","restriction":"String"}],"args_string":"(__name__ : String, **attributes, &)","args_html":"(__name__ : <a href=\"../String.html\">String</a>, **attributes, &)","location":{"filename":"src/xml/builder.cr","line_number":73,"url":null},"def":{"name":"element","args":[{"name":"__name__","external_name":"__name__","restriction":"String"}],"double_splat":{"name":"attributes","external_name":"attributes","restriction":""},"yields":0,"visibility":"Public","body":"element(__name__, attributes) do\n  yield\nend"}},{"html_id":"element(prefix:String?,name:String,namespace_uri:String?,attributes:Hash|NamedTuple):Nil-instance-method","name":"element","doc":"Emits an element with namespace info with the given *attributes*.","summary":"<p>Emits an element with namespace info with the given <em>attributes</em>.</p>","abstract":false,"args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","external_name":"name","restriction":"String"},{"name":"namespace_uri","external_name":"namespace_uri","restriction":"String | ::Nil"},{"name":"attributes","external_name":"attributes","restriction":"Hash | NamedTuple"}],"args_string":"(prefix : String?, name : String, namespace_uri : String?, attributes : Hash | NamedTuple) : Nil","args_html":"(prefix : <a href=\"../String.html\">String</a>?, name : <a href=\"../String.html\">String</a>, namespace_uri : <a href=\"../String.html\">String</a>?, attributes : <a href=\"../Hash.html\">Hash</a> | <a href=\"../NamedTuple.html\">NamedTuple</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":117,"url":null},"def":{"name":"element","args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","external_name":"name","restriction":"String"},{"name":"namespace_uri","external_name":"namespace_uri","restriction":"String | ::Nil"},{"name":"attributes","external_name":"attributes","restriction":"Hash | NamedTuple"}],"return_type":"Nil","visibility":"Public","body":"start_element(prefix, name, namespace_uri)\nattributes(attributes)\nend_element\n"}},{"html_id":"element(prefix:String?,name:String,namespace_uri:String?,**attributes):Nil-instance-method","name":"element","doc":"Emits an element with namespace info with the given *attributes*.","summary":"<p>Emits an element with namespace info with the given <em>attributes</em>.</p>","abstract":false,"args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","external_name":"name","restriction":"String"},{"name":"namespace_uri","external_name":"namespace_uri","restriction":"String | ::Nil"}],"args_string":"(prefix : String?, name : String, namespace_uri : String?, **attributes) : Nil","args_html":"(prefix : <a href=\"../String.html\">String</a>?, name : <a href=\"../String.html\">String</a>, namespace_uri : <a href=\"../String.html\">String</a>?, **attributes) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":112,"url":null},"def":{"name":"element","args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","external_name":"name","restriction":"String"},{"name":"namespace_uri","external_name":"namespace_uri","restriction":"String | ::Nil"}],"double_splat":{"name":"attributes","external_name":"attributes","restriction":""},"return_type":"Nil","visibility":"Public","body":"element(prefix, name, namespace_uri, attributes)"}},{"html_id":"element(name:String,attributes:Hash|NamedTuple):Nil-instance-method","name":"element","doc":"Emits an element with the given *attributes*.","summary":"<p>Emits an element with the given <em>attributes</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"attributes","external_name":"attributes","restriction":"Hash | NamedTuple"}],"args_string":"(name : String, attributes : Hash | NamedTuple) : Nil","args_html":"(name : <a href=\"../String.html\">String</a>, attributes : <a href=\"../Hash.html\">Hash</a> | <a href=\"../NamedTuple.html\">NamedTuple</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":92,"url":null},"def":{"name":"element","args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"attributes","external_name":"attributes","restriction":"Hash | NamedTuple"}],"return_type":"Nil","visibility":"Public","body":"element(name, attributes) do\nend"}},{"html_id":"element(__name__:String,**attributes)-instance-method","name":"element","doc":"Emits an element with the given *attributes*.","summary":"<p>Emits an element with the given <em>attributes</em>.</p>","abstract":false,"args":[{"name":"__name__","external_name":"__name__","restriction":"String"}],"args_string":"(__name__ : String, **attributes)","args_html":"(__name__ : <a href=\"../String.html\">String</a>, **attributes)","location":{"filename":"src/xml/builder.cr","line_number":87,"url":null},"def":{"name":"element","args":[{"name":"__name__","external_name":"__name__","restriction":"String"}],"double_splat":{"name":"attributes","external_name":"attributes","restriction":""},"visibility":"Public","body":"element(__name__, attributes)"}},{"html_id":"end_attribute:Nil-instance-method","name":"end_attribute","doc":"Emits the end of an attribute.","summary":"<p>Emits the end of an attribute.</p>","abstract":false,"location":{"filename":"src/xml/builder.cr","line_number":134,"url":null},"def":{"name":"end_attribute","return_type":"Nil","visibility":"Public","body":"call(EndAttribute)"}},{"html_id":"end_cdata:Nil-instance-method","name":"end_cdata","doc":"Emits the end of a `CDATA` section.","summary":"<p>Emits the end of a <code>CDATA</code> section.</p>","abstract":false,"location":{"filename":"src/xml/builder.cr","line_number":180,"url":null},"def":{"name":"end_cdata","return_type":"Nil","visibility":"Public","body":"call(EndCDATA)"}},{"html_id":"end_comment:Nil-instance-method","name":"end_comment","doc":"Emits the end of a comment.","summary":"<p>Emits the end of a comment.</p>","abstract":false,"location":{"filename":"src/xml/builder.cr","line_number":205,"url":null},"def":{"name":"end_comment","return_type":"Nil","visibility":"Public","body":"call(EndComment)"}},{"html_id":"end_document:Nil-instance-method","name":"end_document","doc":"Emits the end of a document.","summary":"<p>Emits the end of a document.</p>","abstract":false,"location":{"filename":"src/xml/builder.cr","line_number":37,"url":null},"def":{"name":"end_document","return_type":"Nil","visibility":"Public","body":"call(EndDocument)"}},{"html_id":"end_dtd:Nil-instance-method","name":"end_dtd","doc":"Emits the end of a `DTD`.","summary":"<p>Emits the end of a <code>DTD</code>.</p>","abstract":false,"location":{"filename":"src/xml/builder.cr","line_number":227,"url":null},"def":{"name":"end_dtd","return_type":"Nil","visibility":"Public","body":"call(EndDTD)"}},{"html_id":"end_element:Nil-instance-method","name":"end_element","doc":"Emits the end of an element.","summary":"<p>Emits the end of an element.</p>","abstract":false,"location":{"filename":"src/xml/builder.cr","line_number":67,"url":null},"def":{"name":"end_element","return_type":"Nil","visibility":"Public","body":"call(EndElement)"}},{"html_id":"flush:Nil-instance-method","name":"flush","doc":"Forces content written to this writer to be flushed to\nthis writer's `IO`.","summary":"<p>Forces content written to this writer to be flushed to this writer's <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/xml/builder.cr","line_number":250,"url":null},"def":{"name":"flush","return_type":"Nil","visibility":"Public","body":"call(Flush)\n@io.flush\n"}},{"html_id":"indent=(str:String)-instance-method","name":"indent=","doc":"Sets the indent string.","summary":"<p>Sets the indent string.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"String"}],"args_string":"(str : String)","args_html":"(str : <a href=\"../String.html\">String</a>)","location":{"filename":"src/xml/builder.cr","line_number":257,"url":null},"def":{"name":"indent=","args":[{"name":"str","external_name":"str","restriction":"String"}],"visibility":"Public","body":"if str.empty?\n  call(SetIndent, 0)\nelse\n  call(SetIndent, 1)\n  call(SetIndentString, string_to_unsafe(str))\nend"}},{"html_id":"indent=(level:Int)-instance-method","name":"indent=","doc":"Sets the indent *level* (number of spaces).","summary":"<p>Sets the indent <em>level</em> (number of spaces).</p>","abstract":false,"args":[{"name":"level","external_name":"level","restriction":"Int"}],"args_string":"(level : Int)","args_html":"(level : <a href=\"../Int.html\">Int</a>)","location":{"filename":"src/xml/builder.cr","line_number":267,"url":null},"def":{"name":"indent=","args":[{"name":"level","external_name":"level","restriction":"Int"}],"visibility":"Public","body":"if level <= 0\n  call(SetIndent, 0)\nelse\n  call(SetIndent, 1)\n  call(SetIndentString, \" \" * level)\nend"}},{"html_id":"namespace(prefix,uri):Nil-instance-method","name":"namespace","doc":"Emits a namespace.","summary":"<p>Emits a namespace.</p>","abstract":false,"args":[{"name":"prefix","external_name":"prefix","restriction":""},{"name":"uri","external_name":"uri","restriction":""}],"args_string":"(prefix, uri) : Nil","args_html":"(prefix, uri) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":244,"url":null},"def":{"name":"namespace","args":[{"name":"prefix","external_name":"prefix","restriction":""},{"name":"uri","external_name":"uri","restriction":""}],"return_type":"Nil","visibility":"Public","body":"attribute(\"xmlns\", prefix, nil, uri)"}},{"html_id":"quote_char=(char:Char)-instance-method","name":"quote_char=","doc":"Sets the quote char to use, either `'` or `\"`.","summary":"<p>Sets the quote char to use, either <code>'</code> or <code>\"</code>.</p>","abstract":false,"args":[{"name":"char","external_name":"char","restriction":"Char"}],"args_string":"(char : Char)","args_html":"(char : <a href=\"../Char.html\">Char</a>)","location":{"filename":"src/xml/builder.cr","line_number":277,"url":null},"def":{"name":"quote_char=","args":[{"name":"char","external_name":"char","restriction":"Char"}],"visibility":"Public","body":"if (char == '\\'') || (char == '\"')\nelse\n  raise(ArgumentError.new(\"Quote char must be ' or \\\", not #{char}\"))\nend\ncall(SetQuoteChar, char.ord)\n"}},{"html_id":"start_attribute(prefix:String?,name:String,namespace_uri:String?)-instance-method","name":"start_attribute","doc":"Emits the start of an attribute with namespace info.","summary":"<p>Emits the start of an attribute with namespace info.</p>","abstract":false,"args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","external_name":"name","restriction":"String"},{"name":"namespace_uri","external_name":"namespace_uri","restriction":"String | ::Nil"}],"args_string":"(prefix : String?, name : String, namespace_uri : String?)","args_html":"(prefix : <a href=\"../String.html\">String</a>?, name : <a href=\"../String.html\">String</a>, namespace_uri : <a href=\"../String.html\">String</a>?)","location":{"filename":"src/xml/builder.cr","line_number":129,"url":null},"def":{"name":"start_attribute","args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","external_name":"name","restriction":"String"},{"name":"namespace_uri","external_name":"namespace_uri","restriction":"String | ::Nil"}],"visibility":"Public","body":"call(StartAttributeNS, string_to_unsafe(prefix), string_to_unsafe(name), string_to_unsafe(namespace_uri))"}},{"html_id":"start_attribute(name:String):Nil-instance-method","name":"start_attribute","doc":"Emits the start of an attribute.","summary":"<p>Emits the start of an attribute.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String) : Nil","args_html":"(name : <a href=\"../String.html\">String</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":124,"url":null},"def":{"name":"start_attribute","args":[{"name":"name","external_name":"name","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"call(StartAttribute, string_to_unsafe(name))"}},{"html_id":"start_cdata:Nil-instance-method","name":"start_cdata","doc":"Emits the start of a `CDATA` section.","summary":"<p>Emits the start of a <code>CDATA</code> section.</p>","abstract":false,"location":{"filename":"src/xml/builder.cr","line_number":175,"url":null},"def":{"name":"start_cdata","return_type":"Nil","visibility":"Public","body":"call(StartCDATA)"}},{"html_id":"start_comment:Nil-instance-method","name":"start_comment","doc":"Emits the start of a comment.","summary":"<p>Emits the start of a comment.</p>","abstract":false,"location":{"filename":"src/xml/builder.cr","line_number":200,"url":null},"def":{"name":"start_comment","return_type":"Nil","visibility":"Public","body":"call(StartComment)"}},{"html_id":"start_document(version=nil,encoding=nil):Nil-instance-method","name":"start_document","doc":"Emits the start of the document.","summary":"<p>Emits the start of the document.</p>","abstract":false,"args":[{"name":"version","default_value":"nil","external_name":"version","restriction":""},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""}],"args_string":"(version = nil, encoding = nil) : Nil","args_html":"(version = <span class=\"n\">nil</span>, encoding = <span class=\"n\">nil</span>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":32,"url":null},"def":{"name":"start_document","args":[{"name":"version","default_value":"nil","external_name":"version","restriction":""},{"name":"encoding","default_value":"nil","external_name":"encoding","restriction":""}],"return_type":"Nil","visibility":"Public","body":"call(StartDocument, string_to_unsafe(version), string_to_unsafe(encoding), nil)"}},{"html_id":"start_dtd(name:String,pubid:String,sysid:String):Nil-instance-method","name":"start_dtd","doc":"Emits the start of a `DTD`.","summary":"<p>Emits the start of a <code>DTD</code>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"pubid","external_name":"pubid","restriction":"String"},{"name":"sysid","external_name":"sysid","restriction":"String"}],"args_string":"(name : String, pubid : String, sysid : String) : Nil","args_html":"(name : <a href=\"../String.html\">String</a>, pubid : <a href=\"../String.html\">String</a>, sysid : <a href=\"../String.html\">String</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":222,"url":null},"def":{"name":"start_dtd","args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"pubid","external_name":"pubid","restriction":"String"},{"name":"sysid","external_name":"sysid","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"call(StartDTD, string_to_unsafe(name), string_to_unsafe(pubid), string_to_unsafe(sysid))"}},{"html_id":"start_element(prefix:String?,name:String,namespace_uri:String?):Nil-instance-method","name":"start_element","doc":"Emits the start of an element with namespace info.","summary":"<p>Emits the start of an element with namespace info.</p>","abstract":false,"args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","external_name":"name","restriction":"String"},{"name":"namespace_uri","external_name":"namespace_uri","restriction":"String | ::Nil"}],"args_string":"(prefix : String?, name : String, namespace_uri : String?) : Nil","args_html":"(prefix : <a href=\"../String.html\">String</a>?, name : <a href=\"../String.html\">String</a>, namespace_uri : <a href=\"../String.html\">String</a>?) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":56,"url":null},"def":{"name":"start_element","args":[{"name":"prefix","external_name":"prefix","restriction":"String | ::Nil"},{"name":"name","external_name":"name","restriction":"String"},{"name":"namespace_uri","external_name":"namespace_uri","restriction":"String | ::Nil"}],"return_type":"Nil","visibility":"Public","body":"unsafe_name = string_to_unsafe(name)\nunsafe_prefix = string_to_unsafe(prefix)\ncheck_valid_element_name(name, unsafe_name, \"element name\")\nif prefix\n  check_valid_element_name(prefix, unsafe_prefix, \"prefix\")\nend\ncall(StartElementNS, unsafe_prefix, unsafe_name, string_to_unsafe(namespace_uri))\n"}},{"html_id":"start_element(name:String):Nil-instance-method","name":"start_element","doc":"Emits the start of an element.","summary":"<p>Emits the start of an element.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String) : Nil","args_html":"(name : <a href=\"../String.html\">String</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":49,"url":null},"def":{"name":"start_element","args":[{"name":"name","external_name":"name","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"unsafe_name = string_to_unsafe(name)\ncheck_valid_element_name(name, unsafe_name, \"element name\")\ncall(StartElement, unsafe_name)\n"}},{"html_id":"text(content:String):Nil-instance-method","name":"text","doc":"Emits text content.\n\nText content can happen inside of an `element`, `attribute` value, `cdata`, `dtd`, etc.","summary":"<p>Emits text content.</p>","abstract":false,"args":[{"name":"content","external_name":"content","restriction":"String"}],"args_string":"(content : String) : Nil","args_html":"(content : <a href=\"../String.html\">String</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/builder.cr","line_number":170,"url":null},"def":{"name":"text","args":[{"name":"content","external_name":"content","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"call(WriteString, string_to_unsafe(content))"}}]},{"html_id":"Crystal/XML/Error","path":"XML/Error.html","kind":"class","full_name":"XML::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/xml/error.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/XML","kind":"module","full_name":"XML","name":"XML"},"class_methods":[{"html_id":"errors:Array(XML::Error)?-class-method","name":"errors","abstract":false,"location":{"filename":"src/xml/error.cr","line_number":43,"url":null},"def":{"name":"errors","return_type":"Array(XML::Error) | ::Nil","visibility":"Public","body":"if @@errors.empty?\n  nil\nelse\n  errors = @@errors.dup\n  @@errors.clear\n  errors\nend"}}],"constructors":[{"html_id":"new(message,line_number)-class-method","name":"new","abstract":false,"args":[{"name":"message","external_name":"message","restriction":""},{"name":"line_number","external_name":"line_number","restriction":""}],"args_string":"(message, line_number)","args_html":"(message, line_number)","location":{"filename":"src/xml/error.cr","line_number":10,"url":null},"def":{"name":"new","args":[{"name":"message","external_name":"message","restriction":""},{"name":"line_number","external_name":"line_number","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(message, line_number)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(error:Pointer(LibXML::Error))-class-method","name":"new","abstract":false,"args":[{"name":"error","external_name":"error","restriction":"::Pointer(LibXML::Error)"}],"args_string":"(error : Pointer(LibXML::Error))","args_html":"(error : <a href=\"../Pointer.html\">Pointer</a>(LibXML::Error))","location":{"filename":"src/xml/error.cr","line_number":6,"url":null},"def":{"name":"new","args":[{"name":"error","external_name":"error","restriction":"::Pointer(LibXML::Error)"}],"visibility":"Public","body":"new((String.new(error.value.message)).chomp, error.value.line)"}}],"instance_methods":[{"html_id":"line_number:Int32-instance-method","name":"line_number","abstract":false,"location":{"filename":"src/xml/error.cr","line_number":4,"url":null},"def":{"name":"line_number","return_type":"Int32","visibility":"Public","body":"@line_number"}}]},{"html_id":"Crystal/XML/HTMLParserOptions","path":"XML/HTMLParserOptions.html","kind":"enum","full_name":"XML::HTMLParserOptions","name":"HTMLParserOptions","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/xml/html_parser_options.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"RECOVER","name":"RECOVER","value":"1","doc":"Relaxed parsing","summary":"<p>Relaxed parsing</p>"},{"id":"NODEFDTD","name":"NODEFDTD","value":"4","doc":"Do not default a doctype if not found","summary":"<p>Do not default a doctype if not found</p>"},{"id":"NOERROR","name":"NOERROR","value":"32","doc":"Suppress error reports","summary":"<p>Suppress error reports</p>"},{"id":"NOWARNING","name":"NOWARNING","value":"64","doc":"Suppress warning reports","summary":"<p>Suppress warning reports</p>"},{"id":"PEDANTIC","name":"PEDANTIC","value":"128","doc":"Pedantic error reporting","summary":"<p>Pedantic error reporting</p>"},{"id":"NOBLANKS","name":"NOBLANKS","value":"256","doc":"Remove blank nodes","summary":"<p>Remove blank nodes</p>"},{"id":"NONET","name":"NONET","value":"2048","doc":"Forbid network access","summary":"<p>Forbid network access</p>"},{"id":"NOIMPLIED","name":"NOIMPLIED","value":"8192","doc":"Do not add implied html/body... elements","summary":"<p>Do not add implied html/body...</p>"},{"id":"COMPACT","name":"COMPACT","value":"65536","doc":"Compact small text nodes","summary":"<p>Compact small text nodes</p>"},{"id":"IGNORE_ENC","name":"IGNORE_ENC","value":"2097152","doc":"Ignore internal document encoding hint","summary":"<p>Ignore internal document encoding hint</p>"}],"namespace":{"html_id":"Crystal/XML","kind":"module","full_name":"XML","name":"XML"},"constructors":[{"html_id":"default:self-class-method","name":"default","doc":"Returns default options for parsing HTML documents.\n\nDefault flags are: `RECOVER` | `NOERROR` | `NOWARNING`","summary":"<p>Returns default options for parsing HTML documents.</p>","abstract":false,"location":{"filename":"src/xml/html_parser_options.cr","line_number":36,"url":null},"def":{"name":"default","return_type":"self","visibility":"Public","body":"(RECOVER | NOERROR) | NOWARNING"}}],"instance_methods":[{"html_id":"compact?-instance-method","name":"compact?","abstract":false,"location":{"filename":"src/xml/html_parser_options.cr","line_number":28,"url":null},"def":{"name":"compact?","visibility":"Public","body":"self.includes?(COMPACT)"}},{"html_id":"ignore_enc?-instance-method","name":"ignore_enc?","abstract":false,"location":{"filename":"src/xml/html_parser_options.cr","line_number":31,"url":null},"def":{"name":"ignore_enc?","visibility":"Public","body":"self.includes?(IGNORE_ENC)"}},{"html_id":"noblanks?-instance-method","name":"noblanks?","abstract":false,"location":{"filename":"src/xml/html_parser_options.cr","line_number":19,"url":null},"def":{"name":"noblanks?","visibility":"Public","body":"self.includes?(NOBLANKS)"}},{"html_id":"nodefdtd?-instance-method","name":"nodefdtd?","abstract":false,"location":{"filename":"src/xml/html_parser_options.cr","line_number":7,"url":null},"def":{"name":"nodefdtd?","visibility":"Public","body":"self.includes?(NODEFDTD)"}},{"html_id":"noerror?-instance-method","name":"noerror?","abstract":false,"location":{"filename":"src/xml/html_parser_options.cr","line_number":10,"url":null},"def":{"name":"noerror?","visibility":"Public","body":"self.includes?(NOERROR)"}},{"html_id":"noimplied?-instance-method","name":"noimplied?","abstract":false,"location":{"filename":"src/xml/html_parser_options.cr","line_number":25,"url":null},"def":{"name":"noimplied?","visibility":"Public","body":"self.includes?(NOIMPLIED)"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/xml/html_parser_options.cr","line_number":2,"url":null},"def":{"name":"none?","visibility":"Public","body":"value == 0"}},{"html_id":"nonet?-instance-method","name":"nonet?","abstract":false,"location":{"filename":"src/xml/html_parser_options.cr","line_number":22,"url":null},"def":{"name":"nonet?","visibility":"Public","body":"self.includes?(NONET)"}},{"html_id":"nowarning?-instance-method","name":"nowarning?","abstract":false,"location":{"filename":"src/xml/html_parser_options.cr","line_number":13,"url":null},"def":{"name":"nowarning?","visibility":"Public","body":"self.includes?(NOWARNING)"}},{"html_id":"pedantic?-instance-method","name":"pedantic?","abstract":false,"location":{"filename":"src/xml/html_parser_options.cr","line_number":16,"url":null},"def":{"name":"pedantic?","visibility":"Public","body":"self.includes?(PEDANTIC)"}},{"html_id":"recover?-instance-method","name":"recover?","abstract":false,"location":{"filename":"src/xml/html_parser_options.cr","line_number":4,"url":null},"def":{"name":"recover?","visibility":"Public","body":"self.includes?(RECOVER)"}}]},{"html_id":"Crystal/XML/Namespace","path":"XML/Namespace.html","kind":"class","full_name":"XML::Namespace","name":"Namespace","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/xml/namespace.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/XML","kind":"module","full_name":"XML","name":"XML"},"constructors":[{"html_id":"new(document:Node,ns:Pointer(LibXML::NS))-class-method","name":"new","abstract":false,"args":[{"name":"document","external_name":"document","restriction":"Node"},{"name":"ns","external_name":"ns","restriction":"::Pointer(LibXML::NS)"}],"args_string":"(document : Node, ns : Pointer(LibXML::NS))","args_html":"(document : <a href=\"../XML/Node.html\">Node</a>, ns : <a href=\"../Pointer.html\">Pointer</a>(LibXML::NS))","location":{"filename":"src/xml/namespace.cr","line_number":4,"url":null},"def":{"name":"new","args":[{"name":"document","external_name":"document","restriction":"Node"},{"name":"ns","external_name":"ns","restriction":"::Pointer(LibXML::NS)"}],"visibility":"Public","body":"_ = allocate\n_.initialize(document, ns)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"document:Node-instance-method","name":"document","abstract":false,"location":{"filename":"src/xml/namespace.cr","line_number":2,"url":null},"def":{"name":"document","return_type":"Node","visibility":"Public","body":"@document"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/xml/namespace.cr","line_number":8,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = object_id.hash(hasher)\nhasher\n"}},{"html_id":"href:String?-instance-method","name":"href","abstract":false,"location":{"filename":"src/xml/namespace.cr","line_number":10,"url":null},"def":{"name":"href","return_type":"String | ::Nil","visibility":"Public","body":"@ns.value.href ? String.new(@ns.value.href) : nil"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/namespace.cr","line_number":39,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_s(io)"}},{"html_id":"object_id:UInt64-instance-method","name":"object_id","doc":"Returns a `UInt64` that uniquely identifies this object.\n\nThe returned value is the memory address of this object.\n\n```\nstring = \"hello\"\nstring.object_id # => 4460249568\n\npointer = Pointer(String).new(string.object_id)\nstring2 = pointer.as(String)\nstring2.object_id == string.object_id # => true\n```","summary":"<p>Returns a <code><a href=\"../UInt64.html\">UInt64</a></code> that uniquely identifies this object.</p>","abstract":false,"location":{"filename":"src/xml/namespace.cr","line_number":14,"url":null},"def":{"name":"object_id","return_type":"UInt64","visibility":"Public","body":"@ns.address"}},{"html_id":"prefix:String?-instance-method","name":"prefix","abstract":false,"location":{"filename":"src/xml/namespace.cr","line_number":18,"url":null},"def":{"name":"prefix","return_type":"String | ::Nil","visibility":"Public","body":"@ns.value.prefix ? String.new(@ns.value.prefix) : nil"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a short String representation of this object\nwhich includes its class name and its object address.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).to_s # => #<Person:0x10a199f20>\n```","summary":"<p>Appends a short String representation of this object which includes its class name and its object address.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/namespace.cr","line_number":22,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"#<XML::Namespace:0x\"\nobject_id.to_s(io, 16)\nif prefix = self.prefix\n  io << \" prefix=\"\n  prefix.inspect(io)\nend\nif href = self.href\n  io << \" href=\"\n  href.inspect(io)\nend\nio << '>'\n"}}]},{"html_id":"Crystal/XML/Node","path":"XML/Node.html","kind":"class","full_name":"XML::Node","name":"Node","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/xml/node.cr","line_number":1,"url":null},{"filename":"src/xml/node/type.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"constants":[{"id":"LOOKS_LIKE_XPATH","name":"LOOKS_LIKE_XPATH","value":"/^(\\.\\/|\\/|\\.\\.|\\.$)/"}],"namespace":{"html_id":"Crystal/XML","kind":"module","full_name":"XML","name":"XML"},"constructors":[{"html_id":"new(node:Pointer(LibXML::Attr))-class-method","name":"new","doc":"Creates a new node.","summary":"<p>Creates a new node.</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":"::Pointer(LibXML::Attr)"}],"args_string":"(node : Pointer(LibXML::Attr))","args_html":"(node : <a href=\"../Pointer.html\">Pointer</a>(LibXML::Attr))","location":{"filename":"src/xml/node.cr","line_number":5,"url":null},"def":{"name":"new","args":[{"name":"node","external_name":"node","restriction":"::Pointer(LibXML::Attr)"}],"visibility":"Public","body":"_ = allocate\n_.initialize(node)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(node:Pointer(LibXML::Doc))-class-method","name":"new","doc":"Creates a new node.","summary":"<p>Creates a new node.</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":"::Pointer(LibXML::Doc)"}],"args_string":"(node : Pointer(LibXML::Doc))","args_html":"(node : <a href=\"../Pointer.html\">Pointer</a>(LibXML::Doc))","location":{"filename":"src/xml/node.cr","line_number":10,"url":null},"def":{"name":"new","args":[{"name":"node","external_name":"node","restriction":"::Pointer(LibXML::Doc)"}],"visibility":"Public","body":"_ = allocate\n_.initialize(node)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(node:Pointer(LibXML::Node))-class-method","name":"new","doc":"Creates a new node.","summary":"<p>Creates a new node.</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":"::Pointer(LibXML::Node)"}],"args_string":"(node : Pointer(LibXML::Node))","args_html":"(node : <a href=\"../Pointer.html\">Pointer</a>(LibXML::Node))","location":{"filename":"src/xml/node.cr","line_number":15,"url":null},"def":{"name":"new","args":[{"name":"node","external_name":"node","restriction":"::Pointer(LibXML::Node)"}],"visibility":"Public","body":"_ = allocate\n_.initialize(node)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"==(other:Node)-instance-method","name":"==","doc":"Compares with *other*.","summary":"<p>Compares with <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"Node"}],"args_string":"(other : Node)","args_html":"(other : <a href=\"../XML/Node.html\">Node</a>)","location":{"filename":"src/xml/node.cr","line_number":44,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"Node"}],"visibility":"Public","body":"@node == (other.@node)"}},{"html_id":"[](attribute:String):String-instance-method","name":"[]","doc":"Gets the attribute content for the *attribute* given by name.\nRaises `KeyError` if attribute is not found.","summary":"<p>Gets the attribute content for the <em>attribute</em> given by name.</p>","abstract":false,"args":[{"name":"attribute","external_name":"attribute","restriction":"String"}],"args_string":"(attribute : String) : String","args_html":"(attribute : <a href=\"../String.html\">String</a>) : <a href=\"../String.html\">String</a>","location":{"filename":"src/xml/node.cr","line_number":20,"url":null},"def":{"name":"[]","args":[{"name":"attribute","external_name":"attribute","restriction":"String"}],"return_type":"String","visibility":"Public","body":"attributes[attribute].content || (raise(KeyError.new(\"Missing attribute: #{attribute}\")))"}},{"html_id":"[]=(name:String,value)-instance-method","name":"[]=","doc":"Sets *attribute* of this node to *value*.\nRaises `XML::Error` if this node does not support attributes.","summary":"<p>Sets <em>attribute</em> of this node to <em>value</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"value","external_name":"value","restriction":""}],"args_string":"(name : String, value)","args_html":"(name : <a href=\"../String.html\">String</a>, value)","location":{"filename":"src/xml/node.cr","line_number":32,"url":null},"def":{"name":"[]=","args":[{"name":"name","external_name":"name","restriction":"String"},{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"if element?\nelse\n  raise(XML::Error.new(\"Can't set attribute of #{type}\", 0))\nend\nattributes[name] = value\n"}},{"html_id":"[]?(attribute:String):String?-instance-method","name":"[]?","doc":"Gets the attribute content for the *attribute* given by name.\nReturns `nil` if attribute is not found.","summary":"<p>Gets the attribute content for the <em>attribute</em> given by name.</p>","abstract":false,"args":[{"name":"attribute","external_name":"attribute","restriction":"String"}],"args_string":"(attribute : String) : String?","args_html":"(attribute : <a href=\"../String.html\">String</a>) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/xml/node.cr","line_number":26,"url":null},"def":{"name":"[]?","args":[{"name":"attribute","external_name":"attribute","restriction":"String"}],"return_type":"String | ::Nil","visibility":"Public","body":"attributes[attribute]?.try(&.content)"}},{"html_id":"attribute?:Bool-instance-method","name":"attribute?","doc":"Returns `true` if this is an attribute node.","summary":"<p>Returns <code>true</code> if this is an attribute node.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":54,"url":null},"def":{"name":"attribute?","return_type":"Bool","visibility":"Public","body":"type == XML::Node::Type::ATTRIBUTE_NODE"}},{"html_id":"attributes:XML::Attributes-instance-method","name":"attributes","doc":"Returns attributes of this node as an `XML::Attributes`.","summary":"<p>Returns attributes of this node as an <code><a href=\"../XML/Attributes.html\">XML::Attributes</a></code>.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":49,"url":null},"def":{"name":"attributes","return_type":"XML::Attributes","visibility":"Public","body":"Attributes.new(self)"}},{"html_id":"cdata?:Bool-instance-method","name":"cdata?","doc":"Returns `true` if this is a `CDATA` section node.","summary":"<p>Returns <code>true</code> if this is a <code>CDATA</code> section node.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":59,"url":null},"def":{"name":"cdata?","return_type":"Bool","visibility":"Public","body":"type == XML::Node::Type::CDATA_SECTION_NODE"}},{"html_id":"children:XML::NodeSet-instance-method","name":"children","doc":"Gets the list of children for this node as a `XML::NodeSet`.","summary":"<p>Gets the list of children for this node as a <code><a href=\"../XML/NodeSet.html\">XML::NodeSet</a></code>.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":64,"url":null},"def":{"name":"children","return_type":"XML::NodeSet","visibility":"Public","body":"child = @node.value.children\nset = LibXML.xmlXPathNodeSetCreate(child)\nif child\n  child = child.value.next\n  while child\n    LibXML.xmlXPathNodeSetAddUnique(set, child)\n    child = child.value.next\n  end\nend\nNodeSet.new(document, set)\n"}},{"html_id":"comment?-instance-method","name":"comment?","doc":"Returns `true` if this is a comment node.","summary":"<p>Returns <code>true</code> if this is a comment node.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":81,"url":null},"def":{"name":"comment?","visibility":"Public","body":"type == XML::Node::Type::COMMENT_NODE"}},{"html_id":"content:String-instance-method","name":"content","doc":"Returns the content for this Node. An empty string is\nreturned if the node has no content.","summary":"<p>Returns the content for this Node.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":87,"url":null},"def":{"name":"content","return_type":"String","visibility":"Public","body":"content = LibXML.xmlNodeGetContent(self)\ncontent ? String.new(content) : \"\"\n"}},{"html_id":"content=(content)-instance-method","name":"content=","doc":"Sets the Node's content to a Text node containing string.\nThe string gets XML escaped, not interpreted as markup.","summary":"<p>Sets the Node's content to a Text node containing string.</p>","abstract":false,"args":[{"name":"content","external_name":"content","restriction":""}],"args_string":"(content)","args_html":"(content)","location":{"filename":"src/xml/node.cr","line_number":94,"url":null},"def":{"name":"content=","args":[{"name":"content","external_name":"content","restriction":""}],"visibility":"Public","body":"check_no_null_byte(content)\nLibXML.xmlNodeSetContent(self, content)\n"}},{"html_id":"delete(name:String):String?-instance-method","name":"delete","doc":"Deletes attribute given by *name*.\nReturns attributes value, or `nil` if attribute not found.","summary":"<p>Deletes attribute given by <em>name</em>.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String) : String?","args_html":"(name : <a href=\"../String.html\">String</a>) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/xml/node.cr","line_number":39,"url":null},"def":{"name":"delete","args":[{"name":"name","external_name":"name","restriction":"String"}],"return_type":"String | ::Nil","visibility":"Public","body":"attributes.delete(name)"}},{"html_id":"document:XML::Node-instance-method","name":"document","doc":"Gets the document for this Node as a `XML::Node`.","summary":"<p>Gets the document for this Node as a <code><a href=\"../XML/Node.html\">XML::Node</a></code>.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":100,"url":null},"def":{"name":"document","return_type":"XML::Node","visibility":"Public","body":"Node.new(@node.value.doc)"}},{"html_id":"document?:Bool-instance-method","name":"document?","doc":"Returns `true` if this is a Document or HTML Document node.","summary":"<p>Returns <code>true</code> if this is a Document or HTML Document node.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":105,"url":null},"def":{"name":"document?","return_type":"Bool","visibility":"Public","body":"case type\nwhen XML::Node::Type::DOCUMENT_NODE, XML::Node::Type::HTML_DOCUMENT_NODE\n  true\nelse\n  false\nend"}},{"html_id":"element?:Bool-instance-method","name":"element?","doc":"Returns `true` if this is an Element node.","summary":"<p>Returns <code>true</code> if this is an Element node.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":136,"url":null},"def":{"name":"element?","return_type":"Bool","visibility":"Public","body":"type == XML::Node::Type::ELEMENT_NODE"}},{"html_id":"encoding:String?-instance-method","name":"encoding","doc":"Returns the encoding of this node's document.","summary":"<p>Returns the encoding of this node's document.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":116,"url":null},"def":{"name":"encoding","return_type":"String | ::Nil","visibility":"Public","body":"if document?\n  encoding = (@node.as(::Pointer(LibXML::Doc))).value.encoding\n  encoding ? String.new(encoding) : nil\nelse\n  document.encoding\nend"}},{"html_id":"errors:Array(XML::Error)?-instance-method","name":"errors","doc":"Returns the list of `XML::Error` found when parsing this document.\nReturns `nil` if no errors were found.","summary":"<p>Returns the list of <code><a href=\"../XML/Error.html\">XML::Error</a></code> found when parsing this document.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":586,"url":null},"def":{"name":"errors","return_type":"Array(XML::Error) | ::Nil","visibility":"Public","body":"ptr = @node.value._private\nptr ? (ptr.as(Array(XML::Error))) : nil\n"}},{"html_id":"first_element_child:XML::Node?-instance-method","name":"first_element_child","doc":"Returns the first child node of this node that is an element.\nReturns `nil` if not found.","summary":"<p>Returns the first child node of this node that is an element.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":142,"url":null},"def":{"name":"first_element_child","return_type":"XML::Node | ::Nil","visibility":"Public","body":"child = @node.value.children\nwhile child\n  if child.value.type == XML::Node::Type::ELEMENT_NODE\n    return Node.new(child)\n  end\n  child = child.value.next\nend\nnil\n"}},{"html_id":"fragment?:Bool-instance-method","name":"fragment?","doc":"Returns `true` if this is a DocumentFragment.","summary":"<p>Returns <code>true</code> if this is a DocumentFragment.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":154,"url":null},"def":{"name":"fragment?","return_type":"Bool","visibility":"Public","body":"type == XML::Node::Type::DOCUMENT_FRAG_NODE"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/xml/node.cr","line_number":159,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = object_id.hash(hasher)\nhasher\n"}},{"html_id":"inner_text:String-instance-method","name":"inner_text","doc":"Returns the content for this Node.","summary":"<p>Returns the content for this Node.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":162,"url":null},"def":{"name":"inner_text","return_type":"String","visibility":"Public","body":"content"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Returns detailed information for this node including node type, name, attributes and children.","summary":"<p>Returns detailed information for this node including node type, name, attributes and children.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/node.cr","line_number":167,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << \"#<XML::\"\ncase type\nwhen XML::Node::Type::NONE\n  io << \"None\"\nwhen XML::Node::Type::ELEMENT_NODE\n  io << \"Element\"\nwhen XML::Node::Type::ATTRIBUTE_NODE\n  io << \"Attribute\"\nwhen XML::Node::Type::TEXT_NODE\n  io << \"Text\"\nwhen XML::Node::Type::CDATA_SECTION_NODE\n  io << \"CData\"\nwhen XML::Node::Type::ENTITY_REF_NODE\n  io << \"EntityRef\"\nwhen XML::Node::Type::ENTITY_NODE\n  io << \"Entity\"\nwhen XML::Node::Type::PI_NODE\n  io << \"ProcessingInstruction\"\nwhen XML::Node::Type::COMMENT_NODE\n  io << \"Comment\"\nwhen XML::Node::Type::DOCUMENT_NODE\n  io << \"Document\"\nwhen XML::Node::Type::DOCUMENT_TYPE_NODE\n  io << \"DocumentType\"\nwhen XML::Node::Type::DOCUMENT_FRAG_NODE\n  io << \"DocumentFragment\"\nwhen XML::Node::Type::NOTATION_NODE\n  io << \"Notation\"\nwhen XML::Node::Type::HTML_DOCUMENT_NODE\n  io << \"HTMLDocument\"\nwhen XML::Node::Type::DTD_NODE\n  io << \"DTD\"\nwhen XML::Node::Type::ELEMENT_DECL\n  io << \"Element\"\nwhen XML::Node::Type::ATTRIBUTE_DECL\n  io << \"AttributeDecl\"\nwhen XML::Node::Type::ENTITY_DECL\n  io << \"EntityDecl\"\nwhen XML::Node::Type::NAMESPACE_DECL\n  io << \"NamespaceDecl\"\nwhen XML::Node::Type::XINCLUDE_START\n  io << \"XIncludeStart\"\nwhen XML::Node::Type::XINCLUDE_END\n  io << \"XIncludeEnd\"\nwhen XML::Node::Type::DOCB_DOCUMENT_NODE\n  io << \"DOCBDocument\"\nend\nio << \":0x\"\nobject_id.to_s(io, 16)\nif text?\n  io << ' '\n  content.inspect(io)\nelse\n  if document?\n  else\n    io << \" name=\"\n    name.inspect(io)\n  end\n  if attribute?\n    io << \" content=\"\n    content.inspect(io)\n  else\n    attributes = self.attributes\n    if attributes.empty?\n    else\n      io << \" attributes=\"\n      attributes.inspect(io)\n    end\n    children = self.children\n    if children.empty?\n    else\n      io << \" children=\"\n      children.inspect(io)\n    end\n  end\nend\nio << '>'\n"}},{"html_id":"name:String-instance-method","name":"name","doc":"Returns the name for this Node.","summary":"<p>Returns the name for this Node.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":251,"url":null},"def":{"name":"name","return_type":"String","visibility":"Public","body":"if document?\n  \"document\"\nelse\n  if text?\n    \"text\"\n  else\n    if cdata?\n      \"#cdata-section\"\n    else\n      if fragment?\n        \"#document-fragment\"\n      else\n        if @node.value && @node.value.name\n          String.new(@node.value.name)\n        else\n          \"\"\n        end\n      end\n    end\n  end\nend"}},{"html_id":"name=(name)-instance-method","name":"name=","doc":"Sets the name for this Node.","summary":"<p>Sets the name for this Node.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""}],"args_string":"(name)","args_html":"(name)","location":{"filename":"src/xml/node.cr","line_number":268,"url":null},"def":{"name":"name=","args":[{"name":"name","external_name":"name","restriction":""}],"visibility":"Public","body":"if ((document? || text?) || cdata?) || fragment?\n  raise(XML::Error.new(\"Can't set name of XML #{type}\", 0))\nend\nname = name.to_s\nif name.includes?('\\0')\n  raise(XML::Error.new(\"Invalid node name: #{name.inspect} (contains null character)\", 0))\nend\nif (LibXML.xmlValidateNameValue(name)) == 0\n  raise(XML::Error.new(\"Invalid node name: #{name.inspect}\", 0))\nend\nLibXML.xmlNodeSetName(self, name)\n"}},{"html_id":"namespace:Namespace?-instance-method","name":"namespace","doc":"Returns the namespace for this node or `nil` if not found.","summary":"<p>Returns the namespace for this node or <code>nil</code> if not found.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":287,"url":null},"def":{"name":"namespace","return_type":"Namespace | ::Nil","visibility":"Public","body":"case type\nwhen Type::DOCUMENT_NODE, Type::ATTRIBUTE_DECL, Type::DTD_NODE, Type::ELEMENT_DECL\n  nil\nelse\n  ns = @node.value.ns\n  ns ? Namespace.new(document, ns) : nil\nend"}},{"html_id":"namespace_definitions:Array(Namespace)-instance-method","name":"namespace_definitions","doc":"Returns namespaces defined on self element directly.","summary":"<p>Returns namespaces defined on self element directly.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":298,"url":null},"def":{"name":"namespace_definitions","return_type":"Array(Namespace)","visibility":"Public","body":"namespaces = [] of Namespace\nns = @node.value.ns_def\nwhile ns\n  namespaces << (Namespace.new(document, ns))\n  ns = ns.value.next\nend\nnamespaces\n"}},{"html_id":"namespace_scopes:Array(Namespace)-instance-method","name":"namespace_scopes","doc":"Returns namespaces in scope for self – those defined on self element\ndirectly or any ancestor node – as an `Array` of `XML::Namespace` objects.\n\nDefault namespaces (`\"xmlns=\"` style) for self are included in this array;\nDefault namespaces for ancestors, however, are not.\n\nSee also `#namespaces`","summary":"<p>Returns namespaces in scope for self – those defined on self element directly or any ancestor node – as an <code><a href=\"../Array.html\">Array</a></code> of <code><a href=\"../XML/Namespace.html\">XML::Namespace</a></code> objects.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":317,"url":null},"def":{"name":"namespace_scopes","return_type":"Array(Namespace)","visibility":"Public","body":"scopes = [] of Namespace\neach_namespace do |namespace|\n  scopes << namespace\nend\nscopes\n"}},{"html_id":"namespaces:Hash(String,String?)-instance-method","name":"namespaces","doc":"Returns a `Hash(String, String?) of prefix => href` for all namespaces\non this node and its ancestors.\n\nThis method returns the same namespaces as `#namespace_scopes`.\n\nReturns namespaces in scope for self – those defined on self element\ndirectly or any ancestor node – as a `Hash` of attribute-name/value pairs.\n\nNOTE: Note that the keys in this hash XML attributes that would be used to\ndefine this namespace, such as `\"xmlns:prefix\"`, not just the prefix.","summary":"<p>Returns a <code><a href=\"../Hash.html\">Hash</a>(<a href=\"../String.html\">String</a>, <a href=\"../String.html\">String</a>?) of prefix => href</code> for all namespaces on this node and its ancestors.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":337,"url":null},"def":{"name":"namespaces","return_type":"Hash(String, String | ::Nil)","visibility":"Public","body":"namespaces = {} of String => String | ::Nil\neach_namespace do |namespace|\n  prefix = namespace.prefix ? \"xmlns:#{namespace.prefix}\" : \"xmlns\"\n  namespaces[prefix] = namespace.href\nend\nnamespaces\n"}},{"html_id":"next:XML::Node?-instance-method","name":"next","doc":"Returns the next sibling node or `nil` if not found.","summary":"<p>Returns the next sibling node or <code>nil</code> if not found.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":228,"url":null},"def":{"name":"next","return_type":"XML::Node | ::Nil","visibility":"Public","body":"next_node = @node.value.next\nnext_node ? Node.new(next_node) : nil\n"}},{"html_id":"next_element:XML::Node?-instance-method","name":"next_element","doc":"Returns the next element node sibling or `nil` if not found.","summary":"<p>Returns the next element node sibling or <code>nil</code> if not found.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":239,"url":null},"def":{"name":"next_element","return_type":"XML::Node | ::Nil","visibility":"Public","body":"next_node = @node.value.next\nwhile next_node\n  if next_node.value.type == XML::Node::Type::ELEMENT_NODE\n    return Node.new(next_node)\n  end\n  next_node = next_node.value.next\nend\nnil\n"}},{"html_id":"next_sibling:XML::Node?-instance-method","name":"next_sibling","doc":"Returns the next sibling node or `nil` if not found.","summary":"<p>Returns the next sibling node or <code>nil</code> if not found.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":234,"url":null},"def":{"name":"next_sibling","return_type":"XML::Node | ::Nil","visibility":"Public","body":"self.next"}},{"html_id":"object_id:UInt64-instance-method","name":"object_id","doc":"Returns the address of underlying `LibXML::Node*` in memory.","summary":"<p>Returns the address of underlying <code>LibXML::Node*</code> in memory.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":358,"url":null},"def":{"name":"object_id","return_type":"UInt64","visibility":"Public","body":"@node.address"}},{"html_id":"parent:XML::Node?-instance-method","name":"parent","doc":"Returns the parent node or `nil` if not found.","summary":"<p>Returns the parent node or <code>nil</code> if not found.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":363,"url":null},"def":{"name":"parent","return_type":"XML::Node | ::Nil","visibility":"Public","body":"parent = @node.value.parent\nparent ? Node.new(parent) : nil\n"}},{"html_id":"previous:XML::Node?-instance-method","name":"previous","doc":"Returns the previous sibling node or `nil` if not found.","summary":"<p>Returns the previous sibling node or <code>nil</code> if not found.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":369,"url":null},"def":{"name":"previous","return_type":"XML::Node | ::Nil","visibility":"Public","body":"prev_node = @node.value.prev\nprev_node ? Node.new(prev_node) : nil\n"}},{"html_id":"previous_element:XML::Node?-instance-method","name":"previous_element","doc":"Returns the previous sibling node that is an element or `nil` if not found.","summary":"<p>Returns the previous sibling node that is an element or <code>nil</code> if not found.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":375,"url":null},"def":{"name":"previous_element","return_type":"XML::Node | ::Nil","visibility":"Public","body":"prev_node = @node.value.prev\nwhile prev_node\n  if prev_node.value.type == XML::Node::Type::ELEMENT_NODE\n    return Node.new(prev_node)\n  end\n  prev_node = prev_node.value.prev\nend\nnil\n"}},{"html_id":"previous_sibling:XML::Node?-instance-method","name":"previous_sibling","doc":"Returns the previous sibling node or `nil` if not found.\nSame with `#previous`.","summary":"<p>Returns the previous sibling node or <code>nil</code> if not found.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":388,"url":null},"def":{"name":"previous_sibling","return_type":"XML::Node | ::Nil","visibility":"Public","body":"previous"}},{"html_id":"processing_instruction?-instance-method","name":"processing_instruction?","doc":"Returns `true` if this is a Processing Instruction node.","summary":"<p>Returns <code>true</code> if this is a Processing Instruction node.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":393,"url":null},"def":{"name":"processing_instruction?","visibility":"Public","body":"type == XML::Node::Type::PI_NODE"}},{"html_id":"root:XML::Node?-instance-method","name":"root","doc":"Returns the root node for this document or `nil`.","summary":"<p>Returns the root node for this document or <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":398,"url":null},"def":{"name":"root","return_type":"XML::Node | ::Nil","visibility":"Public","body":"root = LibXML.xmlDocGetRootElement(@node.value.doc)\nroot ? Node.new(root) : nil\n"}},{"html_id":"text:String-instance-method","name":"text","doc":"Same as `#content`.","summary":"<p>Same as <code><a href=\"../XML/Node.html#content%3AString-instance-method\">#content</a></code>.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":404,"url":null},"def":{"name":"text","return_type":"String","visibility":"Public","body":"content"}},{"html_id":"text=(text)-instance-method","name":"text=","doc":"Same as `#content=`.","summary":"<p>Same as <code><a href=\"../XML/Node.html#content%3D%28content%29-instance-method\">#content=</a></code>.</p>","abstract":false,"args":[{"name":"text","external_name":"text","restriction":""}],"args_string":"(text)","args_html":"(text)","location":{"filename":"src/xml/node.cr","line_number":409,"url":null},"def":{"name":"text=","args":[{"name":"text","external_name":"text","restriction":""}],"visibility":"Public","body":"self.content = text"}},{"html_id":"text?:Bool-instance-method","name":"text?","doc":"Returns `true` if this is a Text node.","summary":"<p>Returns <code>true</code> if this is a Text node.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":414,"url":null},"def":{"name":"text?","return_type":"Bool","visibility":"Public","body":"type == XML::Node::Type::TEXT_NODE"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Serialize this Node as XML to *io* using default options.\n\nSee `#to_xml`.","summary":"<p>Serialize this Node as XML to <em>io</em> using default options.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/node.cr","line_number":421,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"to_xml(io)"}},{"html_id":"to_unsafe:Pointer(LibXML::Node)-instance-method","name":"to_unsafe","doc":"Returns underlying `LibXML::Node*` instance.","summary":"<p>Returns underlying <code>LibXML::Node*</code> instance.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":472,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@node"}},{"html_id":"to_xml(indent:Int=2,indent_text=\"\",options:SaveOptions=SaveOptions.xml_default):String-instance-method","name":"to_xml","doc":"Serialize this Node as XML and return a `String` using default options.\n\nSee `XML::SaveOptions.xml_default` for default options.","summary":"<p>Serialize this Node as XML and return a <code><a href=\"../String.html\">String</a></code> using default options.</p>","abstract":false,"args":[{"name":"indent","default_value":"2","external_name":"indent","restriction":"Int"},{"name":"indent_text","default_value":"\" \"","external_name":"indent_text","restriction":""},{"name":"options","default_value":"SaveOptions.xml_default","external_name":"options","restriction":"SaveOptions"}],"args_string":"(indent : Int = 2, indent_text = \" \", options : SaveOptions = SaveOptions.xml_default) : String","args_html":"(indent : <a href=\"../Int.html\">Int</a> = <span class=\"n\">2</span>, indent_text = <span class=\"s\">&quot; &quot;</span>, options : <a href=\"../XML/SaveOptions.html\">SaveOptions</a> = <span class=\"t\">SaveOptions</span>.xml_default) : <a href=\"../String.html\">String</a>","location":{"filename":"src/xml/node.cr","line_number":428,"url":null},"def":{"name":"to_xml","args":[{"name":"indent","default_value":"2","external_name":"indent","restriction":"Int"},{"name":"indent_text","default_value":"\" \"","external_name":"indent_text","restriction":""},{"name":"options","default_value":"SaveOptions.xml_default","external_name":"options","restriction":"SaveOptions"}],"return_type":"String","visibility":"Public","body":"String.build do |str|\n  to_xml(str, indent, indent_text, options)\nend"}},{"html_id":"to_xml(io:IO,indent=2,indent_text=\"\",options:SaveOptions=SaveOptions.xml_default)-instance-method","name":"to_xml","doc":"Serialize this Node as XML to *io* using default options.\n\nSee `XML::SaveOptions.xml_default` for default options.","summary":"<p>Serialize this Node as XML to <em>io</em> using default options.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"indent","default_value":"2","external_name":"indent","restriction":""},{"name":"indent_text","default_value":"\" \"","external_name":"indent_text","restriction":""},{"name":"options","default_value":"SaveOptions.xml_default","external_name":"options","restriction":"SaveOptions"}],"args_string":"(io : IO, indent = 2, indent_text = \" \", options : SaveOptions = SaveOptions.xml_default)","args_html":"(io : <a href=\"../IO.html\">IO</a>, indent = <span class=\"n\">2</span>, indent_text = <span class=\"s\">&quot; &quot;</span>, options : <a href=\"../XML/SaveOptions.html\">SaveOptions</a> = <span class=\"t\">SaveOptions</span>.xml_default)","location":{"filename":"src/xml/node.cr","line_number":440,"url":null},"def":{"name":"to_xml","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"indent","default_value":"2","external_name":"indent","restriction":""},{"name":"indent_text","default_value":"\" \"","external_name":"indent_text","restriction":""},{"name":"options","default_value":"SaveOptions.xml_default","external_name":"options","restriction":"SaveOptions"}],"visibility":"Public","body":"SAVE_MUTEX.synchronize do\n  oldXmlIndentTreeOutput = LibXML.xmlIndentTreeOutput\n  LibXML.xmlIndentTreeOutput = 1\n  oldXmlTreeIndentString = LibXML.xmlTreeIndentString\n  LibXML.xmlTreeIndentString = (indent_text * indent).to_unsafe\n  save_ctx = LibXML.xmlSaveToIO(->(ctx, buffer, len) do\n    (Box(IO).unbox(ctx)).write_string(Slice.new(buffer, len))\n    len\n  end, ->(ctx) do\n    (Box(IO).unbox(ctx)).flush\n    0\n  end, Box(IO).box(io), @node.value.doc.value.encoding, options)\n  LibXML.xmlSaveTree(save_ctx, self)\n  LibXML.xmlSaveClose(save_ctx)\n  LibXML.xmlIndentTreeOutput = oldXmlIndentTreeOutput\n  LibXML.xmlTreeIndentString = oldXmlTreeIndentString\nend\nio\n"}},{"html_id":"type:XML::Node::Type-instance-method","name":"type","doc":"Returns the type for this Node as `XML::Node::Type`.","summary":"<p>Returns the type for this Node as <code><a href=\"../XML/Node/Type.html\">XML::Node::Type</a></code>.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":477,"url":null},"def":{"name":"type","return_type":"XML::Node::Type","visibility":"Public","body":"@node.value.type"}},{"html_id":"unlink:Nil-instance-method","name":"unlink","doc":"Removes the node from the XML document.","summary":"<p>Removes the node from the XML document.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":482,"url":null},"def":{"name":"unlink","return_type":"Nil","visibility":"Public","body":"LibXML.xmlUnlinkNode(self)"}},{"html_id":"version:String?-instance-method","name":"version","doc":"Returns the version of this node's document.","summary":"<p>Returns the version of this node's document.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":126,"url":null},"def":{"name":"version","return_type":"String | ::Nil","visibility":"Public","body":"if document?\n  version = (@node.as(::Pointer(LibXML::Doc))).value.version\n  version ? String.new(version) : nil\nelse\n  document.version\nend"}},{"html_id":"xml?-instance-method","name":"xml?","doc":"Returns `true` if this is an xml Document node.","summary":"<p>Returns <code>true</code> if this is an xml Document node.</p>","abstract":false,"location":{"filename":"src/xml/node.cr","line_number":487,"url":null},"def":{"name":"xml?","visibility":"Public","body":"type == XML::Node::Type::DOCUMENT_NODE"}},{"html_id":"xpath(path,namespaces=nil,variables=nil)-instance-method","name":"xpath","doc":"Searches this node for XPath *path*. Returns result with appropriate type\n(`Bool | Float64 | String | XML::NodeSet`).\n\nRaises `XML::Error` on evaluation error.","summary":"<p>Searches this node for XPath <em>path</em>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"namespaces","default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","default_value":"nil","external_name":"variables","restriction":""}],"args_string":"(path, namespaces = nil, variables = nil)","args_html":"(path, namespaces = <span class=\"n\">nil</span>, variables = <span class=\"n\">nil</span>)","location":{"filename":"src/xml/node.cr","line_number":495,"url":null},"def":{"name":"xpath","args":[{"name":"path","external_name":"path","restriction":""},{"name":"namespaces","default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","default_value":"nil","external_name":"variables","restriction":""}],"visibility":"Public","body":"ctx = XPathContext.new(self)\nif namespaces\n  ctx.register_namespaces(namespaces)\nelse\n  root.try(&.each_namespace do |namespace|\n    ctx.register_namespace(namespace.prefix || \"xmlns\", namespace.href)\n  end)\nend\nif variables\n  ctx.register_variables(variables)\nend\nctx.evaluate(path)\n"}},{"html_id":"xpath_bool(path,namespaces=nil,variables=nil)-instance-method","name":"xpath_bool","doc":"Searches this node for XPath *path* and restricts the return type to `Bool`.\n\n```\nrequire \"xml\"\n\ndoc = XML.parse(\"<person></person>\")\n\ndoc.xpath_bool(\"count(//person) > 0\") # => true\n```","summary":"<p>Searches this node for XPath <em>path</em> and restricts the return type to <code><a href=\"../Bool.html\">Bool</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"namespaces","default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","default_value":"nil","external_name":"variables","restriction":""}],"args_string":"(path, namespaces = nil, variables = nil)","args_html":"(path, namespaces = <span class=\"n\">nil</span>, variables = <span class=\"n\">nil</span>)","location":{"filename":"src/xml/node.cr","line_number":519,"url":null},"def":{"name":"xpath_bool","args":[{"name":"path","external_name":"path","restriction":""},{"name":"namespaces","default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","default_value":"nil","external_name":"variables","restriction":""}],"visibility":"Public","body":"(xpath(path, namespaces, variables)).as(Bool)"}},{"html_id":"xpath_float(path,namespaces=nil,variables=nil)-instance-method","name":"xpath_float","doc":"Searches this node for XPath *path* and restricts the return type to `Float64`.\n\n```\nrequire \"xml\"\n\ndoc = XML.parse(\"<person></person>\")\n\ndoc.xpath_float(\"count(//person)\") # => 1.0\n```","summary":"<p>Searches this node for XPath <em>path</em> and restricts the return type to <code><a href=\"../Float64.html\">Float64</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"namespaces","default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","default_value":"nil","external_name":"variables","restriction":""}],"args_string":"(path, namespaces = nil, variables = nil)","args_html":"(path, namespaces = <span class=\"n\">nil</span>, variables = <span class=\"n\">nil</span>)","location":{"filename":"src/xml/node.cr","line_number":532,"url":null},"def":{"name":"xpath_float","args":[{"name":"path","external_name":"path","restriction":""},{"name":"namespaces","default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","default_value":"nil","external_name":"variables","restriction":""}],"visibility":"Public","body":"(xpath(path, namespaces, variables)).as(Float64)"}},{"html_id":"xpath_node(path,namespaces=nil,variables=nil)-instance-method","name":"xpath_node","doc":"Searches this node for XPath *path* for nodes and returns the first one.\nor `nil` if not found\n\n```\nrequire \"xml\"\n\ndoc = XML.parse(\"<person></person>\")\n\ndoc.xpath_node(\"//person\")  # => #<XML::Node:0x2013e80 name=\"person\">\ndoc.xpath_node(\"//invalid\") # => nil\n```","summary":"<p>Searches this node for XPath <em>path</em> for nodes and returns the first one.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"namespaces","default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","default_value":"nil","external_name":"variables","restriction":""}],"args_string":"(path, namespaces = nil, variables = nil)","args_html":"(path, namespaces = <span class=\"n\">nil</span>, variables = <span class=\"n\">nil</span>)","location":{"filename":"src/xml/node.cr","line_number":562,"url":null},"def":{"name":"xpath_node","args":[{"name":"path","external_name":"path","restriction":""},{"name":"namespaces","default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","default_value":"nil","external_name":"variables","restriction":""}],"visibility":"Public","body":"(xpath_nodes(path, namespaces, variables)).first?"}},{"html_id":"xpath_nodes(path,namespaces=nil,variables=nil)-instance-method","name":"xpath_nodes","doc":"Searches this node for XPath *path* and restricts the return type to `NodeSet`.\n\n```\nrequire \"xml\"\n\ndoc = XML.parse(\"<person></person>\")\n\nnodes = doc.xpath_nodes(\"//person\")\nnodes.class       # => XML::NodeSet\nnodes.map(&.name) # => [\"person\"]\n```","summary":"<p>Searches this node for XPath <em>path</em> and restricts the return type to <code><a href=\"../XML/NodeSet.html\">NodeSet</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"namespaces","default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","default_value":"nil","external_name":"variables","restriction":""}],"args_string":"(path, namespaces = nil, variables = nil)","args_html":"(path, namespaces = <span class=\"n\">nil</span>, variables = <span class=\"n\">nil</span>)","location":{"filename":"src/xml/node.cr","line_number":547,"url":null},"def":{"name":"xpath_nodes","args":[{"name":"path","external_name":"path","restriction":""},{"name":"namespaces","default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","default_value":"nil","external_name":"variables","restriction":""}],"visibility":"Public","body":"(xpath(path, namespaces, variables)).as(NodeSet)"}},{"html_id":"xpath_string(path,namespaces=nil,variables=nil)-instance-method","name":"xpath_string","doc":"Searches this node for XPath *path* and restricts the return type to `String`.\n\n```\nrequire \"xml\"\n\ndoc = XML.parse(\"<person></person>\")\n\ndoc.xpath_string(\"string(/persons/person[1])\")\n```","summary":"<p>Searches this node for XPath <em>path</em> and restricts the return type to <code><a href=\"../String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"path","external_name":"path","restriction":""},{"name":"namespaces","default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","default_value":"nil","external_name":"variables","restriction":""}],"args_string":"(path, namespaces = nil, variables = nil)","args_html":"(path, namespaces = <span class=\"n\">nil</span>, variables = <span class=\"n\">nil</span>)","location":{"filename":"src/xml/node.cr","line_number":575,"url":null},"def":{"name":"xpath_string","args":[{"name":"path","external_name":"path","restriction":""},{"name":"namespaces","default_value":"nil","external_name":"namespaces","restriction":""},{"name":"variables","default_value":"nil","external_name":"variables","restriction":""}],"visibility":"Public","body":"(xpath(path, namespaces, variables)).as(String)"}}],"types":[{"html_id":"Crystal/XML/Node/Type","path":"XML/Node/Type.html","kind":"enum","full_name":"XML::Node::Type","name":"Type","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/xml/node/type.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"NONE","name":"NONE","value":"0"},{"id":"ELEMENT_NODE","name":"ELEMENT_NODE","value":"1"},{"id":"ATTRIBUTE_NODE","name":"ATTRIBUTE_NODE","value":"2"},{"id":"TEXT_NODE","name":"TEXT_NODE","value":"3"},{"id":"CDATA_SECTION_NODE","name":"CDATA_SECTION_NODE","value":"4"},{"id":"ENTITY_REF_NODE","name":"ENTITY_REF_NODE","value":"5"},{"id":"ENTITY_NODE","name":"ENTITY_NODE","value":"6"},{"id":"PI_NODE","name":"PI_NODE","value":"7"},{"id":"COMMENT_NODE","name":"COMMENT_NODE","value":"8"},{"id":"DOCUMENT_NODE","name":"DOCUMENT_NODE","value":"9"},{"id":"DOCUMENT_TYPE_NODE","name":"DOCUMENT_TYPE_NODE","value":"10"},{"id":"DOCUMENT_FRAG_NODE","name":"DOCUMENT_FRAG_NODE","value":"11"},{"id":"NOTATION_NODE","name":"NOTATION_NODE","value":"12"},{"id":"HTML_DOCUMENT_NODE","name":"HTML_DOCUMENT_NODE","value":"13"},{"id":"DTD_NODE","name":"DTD_NODE","value":"14"},{"id":"ELEMENT_DECL","name":"ELEMENT_DECL","value":"15"},{"id":"ATTRIBUTE_DECL","name":"ATTRIBUTE_DECL","value":"16"},{"id":"ENTITY_DECL","name":"ENTITY_DECL","value":"17"},{"id":"NAMESPACE_DECL","name":"NAMESPACE_DECL","value":"18"},{"id":"XINCLUDE_START","name":"XINCLUDE_START","value":"19"},{"id":"XINCLUDE_END","name":"XINCLUDE_END","value":"20"},{"id":"DOCB_DOCUMENT_NODE","name":"DOCB_DOCUMENT_NODE","value":"21"}],"namespace":{"html_id":"Crystal/XML/Node","kind":"class","full_name":"XML::Node","name":"Node"},"instance_methods":[{"html_id":"attribute_decl?-instance-method","name":"attribute_decl?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":19,"url":null},"def":{"name":"attribute_decl?","visibility":"Public","body":"self == ATTRIBUTE_DECL"}},{"html_id":"attribute_node?-instance-method","name":"attribute_node?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":5,"url":null},"def":{"name":"attribute_node?","visibility":"Public","body":"self == ATTRIBUTE_NODE"}},{"html_id":"cdata_section_node?-instance-method","name":"cdata_section_node?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":7,"url":null},"def":{"name":"cdata_section_node?","visibility":"Public","body":"self == CDATA_SECTION_NODE"}},{"html_id":"comment_node?-instance-method","name":"comment_node?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":11,"url":null},"def":{"name":"comment_node?","visibility":"Public","body":"self == COMMENT_NODE"}},{"html_id":"docb_document_node?-instance-method","name":"docb_document_node?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":24,"url":null},"def":{"name":"docb_document_node?","visibility":"Public","body":"self == DOCB_DOCUMENT_NODE"}},{"html_id":"document_frag_node?-instance-method","name":"document_frag_node?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":14,"url":null},"def":{"name":"document_frag_node?","visibility":"Public","body":"self == DOCUMENT_FRAG_NODE"}},{"html_id":"document_node?-instance-method","name":"document_node?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":12,"url":null},"def":{"name":"document_node?","visibility":"Public","body":"self == DOCUMENT_NODE"}},{"html_id":"document_type_node?-instance-method","name":"document_type_node?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":13,"url":null},"def":{"name":"document_type_node?","visibility":"Public","body":"self == DOCUMENT_TYPE_NODE"}},{"html_id":"dtd_node?-instance-method","name":"dtd_node?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":17,"url":null},"def":{"name":"dtd_node?","visibility":"Public","body":"self == DTD_NODE"}},{"html_id":"element_decl?-instance-method","name":"element_decl?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":18,"url":null},"def":{"name":"element_decl?","visibility":"Public","body":"self == ELEMENT_DECL"}},{"html_id":"element_node?-instance-method","name":"element_node?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":4,"url":null},"def":{"name":"element_node?","visibility":"Public","body":"self == ELEMENT_NODE"}},{"html_id":"entity_decl?-instance-method","name":"entity_decl?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":20,"url":null},"def":{"name":"entity_decl?","visibility":"Public","body":"self == ENTITY_DECL"}},{"html_id":"entity_node?-instance-method","name":"entity_node?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":9,"url":null},"def":{"name":"entity_node?","visibility":"Public","body":"self == ENTITY_NODE"}},{"html_id":"entity_ref_node?-instance-method","name":"entity_ref_node?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":8,"url":null},"def":{"name":"entity_ref_node?","visibility":"Public","body":"self == ENTITY_REF_NODE"}},{"html_id":"html_document_node?-instance-method","name":"html_document_node?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":16,"url":null},"def":{"name":"html_document_node?","visibility":"Public","body":"self == HTML_DOCUMENT_NODE"}},{"html_id":"namespace_decl?-instance-method","name":"namespace_decl?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":21,"url":null},"def":{"name":"namespace_decl?","visibility":"Public","body":"self == NAMESPACE_DECL"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":3,"url":null},"def":{"name":"none?","visibility":"Public","body":"self == NONE"}},{"html_id":"notation_node?-instance-method","name":"notation_node?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":15,"url":null},"def":{"name":"notation_node?","visibility":"Public","body":"self == NOTATION_NODE"}},{"html_id":"pi_node?-instance-method","name":"pi_node?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":10,"url":null},"def":{"name":"pi_node?","visibility":"Public","body":"self == PI_NODE"}},{"html_id":"text_node?-instance-method","name":"text_node?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":6,"url":null},"def":{"name":"text_node?","visibility":"Public","body":"self == TEXT_NODE"}},{"html_id":"xinclude_end?-instance-method","name":"xinclude_end?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":23,"url":null},"def":{"name":"xinclude_end?","visibility":"Public","body":"self == XINCLUDE_END"}},{"html_id":"xinclude_start?-instance-method","name":"xinclude_start?","abstract":false,"location":{"filename":"src/xml/node/type.cr","line_number":22,"url":null},"def":{"name":"xinclude_start?","visibility":"Public","body":"self == XINCLUDE_START"}}]}]},{"html_id":"Crystal/XML/NodeSet","path":"XML/NodeSet.html","kind":"class","full_name":"XML::NodeSet","name":"NodeSet","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/xml/node_set.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"namespace":{"html_id":"Crystal/XML","kind":"module","full_name":"XML","name":"XML"},"constructors":[{"html_id":"new(doc:Node,set:Pointer(LibXML::NodeSet))-class-method","name":"new","abstract":false,"args":[{"name":"doc","external_name":"doc","restriction":"Node"},{"name":"set","external_name":"set","restriction":"::Pointer(LibXML::NodeSet)"}],"args_string":"(doc : Node, set : Pointer(LibXML::NodeSet))","args_html":"(doc : <a href=\"../XML/Node.html\">Node</a>, set : <a href=\"../Pointer.html\">Pointer</a>(LibXML::NodeSet))","location":{"filename":"src/xml/node_set.cr","line_number":4,"url":null},"def":{"name":"new","args":[{"name":"doc","external_name":"doc","restriction":"Node"},{"name":"set","external_name":"set","restriction":"::Pointer(LibXML::NodeSet)"}],"visibility":"Public","body":"_ = allocate\n_.initialize(doc, set)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(doc:Node)-class-method","name":"new","abstract":false,"args":[{"name":"doc","external_name":"doc","restriction":"Node"}],"args_string":"(doc : Node)","args_html":"(doc : <a href=\"../XML/Node.html\">Node</a>)","location":{"filename":"src/xml/node_set.cr","line_number":7,"url":null},"def":{"name":"new","args":[{"name":"doc","external_name":"doc","restriction":"Node"}],"visibility":"Public","body":"new(doc, LibXML.xmlXPathNodeSetCreate(nil))"}}],"instance_methods":[{"html_id":"[](index:Int):XML::Node-instance-method","name":"[]","abstract":false,"args":[{"name":"index","external_name":"index","restriction":"Int"}],"args_string":"(index : Int) : XML::Node","args_html":"(index : <a href=\"../Int.html\">Int</a>) : <a href=\"../XML/Node.html\">XML::Node</a>","location":{"filename":"src/xml/node_set.cr","line_number":11,"url":null},"def":{"name":"[]","args":[{"name":"index","external_name":"index","restriction":"Int"}],"return_type":"XML::Node","visibility":"Public","body":"if index < 0\n  index = index + size\nend\nif 0 <= index && index < size\nelse\n  raise(IndexError.new)\nend\ninternal_at(index)\n"}},{"html_id":"each(&):Nil-instance-method","name":"each","doc":"Must yield this collection's elements to the block.","summary":"<p>Must yield this collection's elements to the block.</p>","abstract":false,"location":{"filename":"src/xml/node_set.cr","line_number":21,"url":null},"def":{"name":"each","yields":1,"return_type":"Nil","visibility":"Public","body":"size.times do |i|\n  yield internal_at(i)\nend"}},{"html_id":"empty?:Bool-instance-method","name":"empty?","doc":"Returns `true` if `self` is empty, `false` otherwise.\n\n```\n([] of Int32).empty? # => true\n([1]).empty?         # => false\n```","summary":"<p>Returns <code>true</code> if <code>self</code> is empty, <code>false</code> otherwise.</p>","abstract":false,"location":{"filename":"src/xml/node_set.cr","line_number":27,"url":null},"def":{"name":"empty?","return_type":"Bool","visibility":"Public","body":"size == 0"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/xml/node_set.cr","line_number":32,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = object_id.hash(hasher)\nhasher\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends a String representation of this object\nwhich includes its class name, its object address\nand the values of all instance variables.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).inspect # => #<Person:0x10fd31f20 @name=\"John\", @age=32>\n```","summary":"<p>Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/node_set.cr","line_number":34,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"io << '['\njoin(io, \", \", &.inspect(io))\nio << ']'\n"}},{"html_id":"object_id-instance-method","name":"object_id","doc":"Returns a `UInt64` that uniquely identifies this object.\n\nThe returned value is the memory address of this object.\n\n```\nstring = \"hello\"\nstring.object_id # => 4460249568\n\npointer = Pointer(String).new(string.object_id)\nstring2 = pointer.as(String)\nstring2.object_id == string.object_id # => true\n```","summary":"<p>Returns a <code><a href=\"../UInt64.html\">UInt64</a></code> that uniquely identifies this object.</p>","abstract":false,"location":{"filename":"src/xml/node_set.cr","line_number":44,"url":null},"def":{"name":"object_id","visibility":"Public","body":"@set.address"}},{"html_id":"size:Int32-instance-method","name":"size","doc":"Returns the number of elements in the collection.\n\n```\n[1, 2, 3, 4].size # => 4\n```","summary":"<p>Returns the number of elements in the collection.</p>","abstract":false,"location":{"filename":"src/xml/node_set.cr","line_number":40,"url":null},"def":{"name":"size","return_type":"Int32","visibility":"Public","body":"@set.value.node_nr"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Appends a short String representation of this object\nwhich includes its class name and its object address.\n\n```\nclass Person\n  def initialize(@name : String, @age : Int32)\n  end\nend\n\nPerson.new(\"John\", 32).to_s # => #<Person:0x10a199f20>\n```","summary":"<p>Appends a short String representation of this object which includes its class name and its object address.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/node_set.cr","line_number":48,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"join(io, '\\n')"}},{"html_id":"to_unsafe:Pointer(LibXML::NodeSet)-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/xml/node_set.cr","line_number":52,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@set"}}]},{"html_id":"Crystal/XML/ParserOptions","path":"XML/ParserOptions.html","kind":"enum","full_name":"XML::ParserOptions","name":"ParserOptions","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/xml/parser_options.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"RECOVER","name":"RECOVER","value":"1","doc":"Recover on errors","summary":"<p>Recover on errors</p>"},{"id":"NOENT","name":"NOENT","value":"2","doc":"Substitute entities","summary":"<p>Substitute entities</p>"},{"id":"DTDLOAD","name":"DTDLOAD","value":"4","doc":"Load the external subset","summary":"<p>Load the external subset</p>"},{"id":"DTDATTR","name":"DTDATTR","value":"8","doc":"Default DTD attributes","summary":"<p>Default DTD attributes</p>"},{"id":"DTDVALID","name":"DTDVALID","value":"16","doc":"Validate with the DTD","summary":"<p>Validate with the DTD</p>"},{"id":"NOERROR","name":"NOERROR","value":"32","doc":"Suppress error reports","summary":"<p>Suppress error reports</p>"},{"id":"NOWARNING","name":"NOWARNING","value":"64","doc":"Suppress warning reports","summary":"<p>Suppress warning reports</p>"},{"id":"PEDANTIC","name":"PEDANTIC","value":"128","doc":"Pedantic error reporting","summary":"<p>Pedantic error reporting</p>"},{"id":"NOBLANKS","name":"NOBLANKS","value":"256","doc":"Remove blank nodes","summary":"<p>Remove blank nodes</p>"},{"id":"SAX1","name":"SAX1","value":"512","doc":"Use the SAX1 interface internally","summary":"<p>Use the SAX1 interface internally</p>"},{"id":"XINCLUDE","name":"XINCLUDE","value":"1024","doc":"Implement XInclude substitution","summary":"<p>Implement XInclude substitution</p>"},{"id":"NONET","name":"NONET","value":"2048","doc":"Forbid network access","summary":"<p>Forbid network access</p>"},{"id":"NODICT","name":"NODICT","value":"4096","doc":"Do not reuse the context dictionary","summary":"<p>Do not reuse the context dictionary</p>"},{"id":"NSCLEAN","name":"NSCLEAN","value":"8192","doc":"Remove redundant namespaces declarations","summary":"<p>Remove redundant namespaces declarations</p>"},{"id":"NOCDATA","name":"NOCDATA","value":"16384","doc":"Merge CDATA as text nodes","summary":"<p>Merge CDATA as text nodes</p>"},{"id":"NOXINCNODE","name":"NOXINCNODE","value":"32768","doc":"Do not generate XINCLUDE START/END nodes","summary":"<p>Do not generate XINCLUDE START/END nodes</p>"},{"id":"COMPACT","name":"COMPACT","value":"65536","doc":"Compact small text nodes; no modification of the tree allowed afterwards (will possibly crash if you try to modify the tree)","summary":"<p>Compact small text nodes; no modification of the tree allowed afterwards (will possibly crash if you try to modify the tree)</p>"},{"id":"OLD10","name":"OLD10","value":"131072","doc":"Parse using XML-1.0 before update 5","summary":"<p>Parse using XML-1.0 before update 5</p>"},{"id":"NOBASEFIX","name":"NOBASEFIX","value":"262144","doc":"Do not fixup XINCLUDE xml:base uris","summary":"<p>Do not fixup XINCLUDE xml:base uris</p>"},{"id":"HUGE","name":"HUGE","value":"524288","doc":"Relax any hardcoded limit from the parser","summary":"<p>Relax any hardcoded limit from the parser</p>"},{"id":"OLDSAX","name":"OLDSAX","value":"1048576","doc":"Parse using SAX2 interface before 2.7.0","summary":"<p>Parse using SAX2 interface before 2.7.0</p>"},{"id":"IGNORE_ENC","name":"IGNORE_ENC","value":"2097152","doc":"Ignore internal document encoding hint","summary":"<p>Ignore internal document encoding hint</p>"},{"id":"BIG_LINES","name":"BIG_LINES","value":"4194304","doc":"Store big lines numbers in text PSVI field","summary":"<p>Store big lines numbers in text PSVI field</p>"}],"namespace":{"html_id":"Crystal/XML","kind":"module","full_name":"XML","name":"XML"},"constructors":[{"html_id":"default:self-class-method","name":"default","doc":"Returns default options for parsing XML documents.\n\nDefault flags are: `RECOVER` | `NOERROR` | `NOWARNING` | `NONET`","summary":"<p>Returns default options for parsing XML documents.</p>","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":75,"url":null},"def":{"name":"default","return_type":"self","visibility":"Public","body":"((RECOVER | NOERROR) | NOWARNING) | NONET"}}],"instance_methods":[{"html_id":"big_lines?-instance-method","name":"big_lines?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":70,"url":null},"def":{"name":"big_lines?","visibility":"Public","body":"self.includes?(BIG_LINES)"}},{"html_id":"compact?-instance-method","name":"compact?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":52,"url":null},"def":{"name":"compact?","visibility":"Public","body":"self.includes?(COMPACT)"}},{"html_id":"dtdattr?-instance-method","name":"dtdattr?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":13,"url":null},"def":{"name":"dtdattr?","visibility":"Public","body":"self.includes?(DTDATTR)"}},{"html_id":"dtdload?-instance-method","name":"dtdload?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":10,"url":null},"def":{"name":"dtdload?","visibility":"Public","body":"self.includes?(DTDLOAD)"}},{"html_id":"dtdvalid?-instance-method","name":"dtdvalid?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":16,"url":null},"def":{"name":"dtdvalid?","visibility":"Public","body":"self.includes?(DTDVALID)"}},{"html_id":"huge?-instance-method","name":"huge?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":61,"url":null},"def":{"name":"huge?","visibility":"Public","body":"self.includes?(HUGE)"}},{"html_id":"ignore_enc?-instance-method","name":"ignore_enc?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":67,"url":null},"def":{"name":"ignore_enc?","visibility":"Public","body":"self.includes?(IGNORE_ENC)"}},{"html_id":"nobasefix?-instance-method","name":"nobasefix?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":58,"url":null},"def":{"name":"nobasefix?","visibility":"Public","body":"self.includes?(NOBASEFIX)"}},{"html_id":"noblanks?-instance-method","name":"noblanks?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":28,"url":null},"def":{"name":"noblanks?","visibility":"Public","body":"self.includes?(NOBLANKS)"}},{"html_id":"nocdata?-instance-method","name":"nocdata?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":46,"url":null},"def":{"name":"nocdata?","visibility":"Public","body":"self.includes?(NOCDATA)"}},{"html_id":"nodict?-instance-method","name":"nodict?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":40,"url":null},"def":{"name":"nodict?","visibility":"Public","body":"self.includes?(NODICT)"}},{"html_id":"noent?-instance-method","name":"noent?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":7,"url":null},"def":{"name":"noent?","visibility":"Public","body":"self.includes?(NOENT)"}},{"html_id":"noerror?-instance-method","name":"noerror?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":19,"url":null},"def":{"name":"noerror?","visibility":"Public","body":"self.includes?(NOERROR)"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":2,"url":null},"def":{"name":"none?","visibility":"Public","body":"value == 0"}},{"html_id":"nonet?-instance-method","name":"nonet?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":37,"url":null},"def":{"name":"nonet?","visibility":"Public","body":"self.includes?(NONET)"}},{"html_id":"nowarning?-instance-method","name":"nowarning?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":22,"url":null},"def":{"name":"nowarning?","visibility":"Public","body":"self.includes?(NOWARNING)"}},{"html_id":"noxincnode?-instance-method","name":"noxincnode?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":49,"url":null},"def":{"name":"noxincnode?","visibility":"Public","body":"self.includes?(NOXINCNODE)"}},{"html_id":"nsclean?-instance-method","name":"nsclean?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":43,"url":null},"def":{"name":"nsclean?","visibility":"Public","body":"self.includes?(NSCLEAN)"}},{"html_id":"old10?-instance-method","name":"old10?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":55,"url":null},"def":{"name":"old10?","visibility":"Public","body":"self.includes?(OLD10)"}},{"html_id":"oldsax?-instance-method","name":"oldsax?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":64,"url":null},"def":{"name":"oldsax?","visibility":"Public","body":"self.includes?(OLDSAX)"}},{"html_id":"pedantic?-instance-method","name":"pedantic?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":25,"url":null},"def":{"name":"pedantic?","visibility":"Public","body":"self.includes?(PEDANTIC)"}},{"html_id":"recover?-instance-method","name":"recover?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":4,"url":null},"def":{"name":"recover?","visibility":"Public","body":"self.includes?(RECOVER)"}},{"html_id":"sax1?-instance-method","name":"sax1?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":31,"url":null},"def":{"name":"sax1?","visibility":"Public","body":"self.includes?(SAX1)"}},{"html_id":"xinclude?-instance-method","name":"xinclude?","abstract":false,"location":{"filename":"src/xml/parser_options.cr","line_number":34,"url":null},"def":{"name":"xinclude?","visibility":"Public","body":"self.includes?(XINCLUDE)"}}]},{"html_id":"Crystal/XML/Reader","path":"XML/Reader.html","kind":"class","full_name":"XML::Reader","name":"Reader","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/xml/reader.cr","line_number":4,"url":null},{"filename":"src/xml/reader/type.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/XML","kind":"module","full_name":"XML","name":"XML"},"constructors":[{"html_id":"new(str:String,options:XML::ParserOptions=XML::ParserOptions.default)-class-method","name":"new","doc":"Creates a new reader from a string.\n\nSee `XML::ParserOptions.default` for default options.","summary":"<p>Creates a new reader from a string.</p>","abstract":false,"args":[{"name":"str","external_name":"str","restriction":"String"},{"name":"options","default_value":"XML::ParserOptions.default","external_name":"options","restriction":"XML::ParserOptions"}],"args_string":"(str : String, options : XML::ParserOptions = XML::ParserOptions.default)","args_html":"(str : <a href=\"../String.html\">String</a>, options : <a href=\"../XML/ParserOptions.html\">XML::ParserOptions</a> = <span class=\"t\">XML</span><span class=\"t\">::</span><span class=\"t\">ParserOptions</span>.default)","location":{"filename":"src/xml/reader.cr","line_number":8,"url":null},"def":{"name":"new","args":[{"name":"str","external_name":"str","restriction":"String"},{"name":"options","default_value":"XML::ParserOptions.default","external_name":"options","restriction":"XML::ParserOptions"}],"visibility":"Public","body":"_ = allocate\n_.initialize(str, options)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(io:IO,options:XML::ParserOptions=XML::ParserOptions.default)-class-method","name":"new","doc":"Creates a new reader from an IO.\n\nSee `XML::ParserOptions.default` for default options.","summary":"<p>Creates a new reader from an IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":"XML::ParserOptions.default","external_name":"options","restriction":"XML::ParserOptions"}],"args_string":"(io : IO, options : XML::ParserOptions = XML::ParserOptions.default)","args_html":"(io : <a href=\"../IO.html\">IO</a>, options : <a href=\"../XML/ParserOptions.html\">XML::ParserOptions</a> = <span class=\"t\">XML</span><span class=\"t\">::</span><span class=\"t\">ParserOptions</span>.default)","location":{"filename":"src/xml/reader.cr","line_number":20,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"},{"name":"options","default_value":"XML::ParserOptions.default","external_name":"options","restriction":"XML::ParserOptions"}],"visibility":"Public","body":"_ = allocate\n_.initialize(io, options)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"[](attribute:String):String-instance-method","name":"[]","doc":"Gets the attribute content for the *attribute* given by name.\nRaises `KeyError` if attribute is not found.","summary":"<p>Gets the attribute content for the <em>attribute</em> given by name.</p>","abstract":false,"args":[{"name":"attribute","external_name":"attribute","restriction":"String"}],"args_string":"(attribute : String) : String","args_html":"(attribute : <a href=\"../String.html\">String</a>) : <a href=\"../String.html\">String</a>","location":{"filename":"src/xml/reader.cr","line_number":103,"url":null},"def":{"name":"[]","args":[{"name":"attribute","external_name":"attribute","restriction":"String"}],"return_type":"String","visibility":"Public","body":"self[attribute]? || (raise(KeyError.new(\"Missing attribute: #{attribute}\")))"}},{"html_id":"[]?(attribute:String):String?-instance-method","name":"[]?","doc":"Gets the attribute content for the *attribute* given by name.\nReturns `nil` if attribute is not found.","summary":"<p>Gets the attribute content for the <em>attribute</em> given by name.</p>","abstract":false,"args":[{"name":"attribute","external_name":"attribute","restriction":"String"}],"args_string":"(attribute : String) : String?","args_html":"(attribute : <a href=\"../String.html\">String</a>) : <a href=\"../String.html\">String</a>?","location":{"filename":"src/xml/reader.cr","line_number":109,"url":null},"def":{"name":"[]?","args":[{"name":"attribute","external_name":"attribute","restriction":"String"}],"return_type":"String | ::Nil","visibility":"Public","body":"value = LibXML.xmlTextReaderGetAttribute(@reader, attribute)\nif value\n  String.new(value)\nend\n"}},{"html_id":"attributes_count:Int32-instance-method","name":"attributes_count","doc":"Returns attribute count of the node.","summary":"<p>Returns attribute count of the node.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":82,"url":null},"def":{"name":"attributes_count","return_type":"Int32","visibility":"Public","body":"LibXML.xmlTextReaderAttributeCount(@reader)"}},{"html_id":"depth:Int32-instance-method","name":"depth","doc":"Returns the current nesting depth of the reader.","summary":"<p>Returns the current nesting depth of the reader.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":120,"url":null},"def":{"name":"depth","return_type":"Int32","visibility":"Public","body":"LibXML.xmlTextReaderDepth(@reader)"}},{"html_id":"empty_element?:Bool-instance-method","name":"empty_element?","doc":"Checks if the node is an empty element.","summary":"<p>Checks if the node is an empty element.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":72,"url":null},"def":{"name":"empty_element?","return_type":"Bool","visibility":"Public","body":"(LibXML.xmlTextReaderIsEmptyElement(@reader)) == 1"}},{"html_id":"expand:XML::Node-instance-method","name":"expand","doc":"Expands the node to a `XML::Node` that can be searched with XPath etc.\nThe returned `XML::Node` is only valid until the next call to `#read`.\n\nRaises a `XML::Error` if the node could not be expanded.","summary":"<p>Expands the node to a <code><a href=\"../XML/Node.html\">XML::Node</a></code> that can be searched with XPath etc.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":150,"url":null},"def":{"name":"expand","return_type":"XML::Node","visibility":"Public","body":"expand? || (raise(XML::Error.new(LibXML.xmlGetLastError)))"}},{"html_id":"expand?:XML::Node?-instance-method","name":"expand?","doc":"Expands the node to a `XML::Node` that can be searched with XPath etc.\nThe returned `XML::Node` is only valid until the next call to `#read`.\n\nReturns `nil` if the node could not be expanded.","summary":"<p>Expands the node to a <code><a href=\"../XML/Node.html\">XML::Node</a></code> that can be searched with XPath etc.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":158,"url":null},"def":{"name":"expand?","return_type":"XML::Node | ::Nil","visibility":"Public","body":"xml = LibXML.xmlTextReaderExpand(@reader)\nif xml\n  XML::Node.new(xml)\nend\n"}},{"html_id":"has_attributes?:Bool-instance-method","name":"has_attributes?","doc":"Checks if the node has any attributes.","summary":"<p>Checks if the node has any attributes.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":77,"url":null},"def":{"name":"has_attributes?","return_type":"Bool","visibility":"Public","body":"(LibXML.xmlTextReaderHasAttributes(@reader)) == 1"}},{"html_id":"move_to_attribute(name:String):Bool-instance-method","name":"move_to_attribute","doc":"Moves to the `XML::Reader::Type::ATTRIBUTE` with the specified name.","summary":"<p>Moves to the <code><a href=\"../XML/Reader/Type.html#ATTRIBUTE\">XML::Reader::Type::ATTRIBUTE</a></code> with the specified name.</p>","abstract":false,"args":[{"name":"name","external_name":"name","restriction":"String"}],"args_string":"(name : String) : Bool","args_html":"(name : <a href=\"../String.html\">String</a>) : <a href=\"../Bool.html\">Bool</a>","location":{"filename":"src/xml/reader.cr","line_number":97,"url":null},"def":{"name":"move_to_attribute","args":[{"name":"name","external_name":"name","restriction":"String"}],"return_type":"Bool","visibility":"Public","body":"(LibXML.xmlTextReaderMoveToAttribute(@reader, name)) == 1"}},{"html_id":"move_to_element:Bool-instance-method","name":"move_to_element","doc":"Moves from the `XML::Reader::Type::ATTRIBUTE` to its containing `XML::Reader::Type::ELEMENT`.","summary":"<p>Moves from the <code><a href=\"../XML/Reader/Type.html#ATTRIBUTE\">XML::Reader::Type::ATTRIBUTE</a></code> to its containing <code><a href=\"../XML/Reader/Type.html#ELEMENT\">XML::Reader::Type::ELEMENT</a></code>.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":115,"url":null},"def":{"name":"move_to_element","return_type":"Bool","visibility":"Public","body":"(LibXML.xmlTextReaderMoveToElement(@reader)) == 1"}},{"html_id":"move_to_first_attribute:Bool-instance-method","name":"move_to_first_attribute","doc":"Moves to the first `XML::Reader::Type::ATTRIBUTE` of the node.","summary":"<p>Moves to the first <code><a href=\"../XML/Reader/Type.html#ATTRIBUTE\">XML::Reader::Type::ATTRIBUTE</a></code> of the node.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":87,"url":null},"def":{"name":"move_to_first_attribute","return_type":"Bool","visibility":"Public","body":"(LibXML.xmlTextReaderMoveToFirstAttribute(@reader)) == 1"}},{"html_id":"move_to_next_attribute:Bool-instance-method","name":"move_to_next_attribute","doc":"Moves to the next `XML::Reader::Type::ATTRIBUTE` of the node.","summary":"<p>Moves to the next <code><a href=\"../XML/Reader/Type.html#ATTRIBUTE\">XML::Reader::Type::ATTRIBUTE</a></code> of the node.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":92,"url":null},"def":{"name":"move_to_next_attribute","return_type":"Bool","visibility":"Public","body":"(LibXML.xmlTextReaderMoveToNextAttribute(@reader)) == 1"}},{"html_id":"name:String-instance-method","name":"name","doc":"Returns the name of the node.","summary":"<p>Returns the name of the node.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":66,"url":null},"def":{"name":"name","return_type":"String","visibility":"Public","body":"value = LibXML.xmlTextReaderConstName(@reader)\nvalue ? String.new(value) : \"\"\n"}},{"html_id":"next:Bool-instance-method","name":"next","doc":"Moves the reader to the next node while skipping subtrees.","summary":"<p>Moves the reader to the next node while skipping subtrees.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":37,"url":null},"def":{"name":"next","return_type":"Bool","visibility":"Public","body":"(LibXML.xmlTextReaderNext(@reader)) == 1"}},{"html_id":"next_sibling:Bool-instance-method","name":"next_sibling","doc":"Moves the reader to the next sibling node while skipping subtrees.","summary":"<p>Moves the reader to the next sibling node while skipping subtrees.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":42,"url":null},"def":{"name":"next_sibling","return_type":"Bool","visibility":"Public","body":"result = LibXML.xmlTextReaderNextSibling(@reader)\nif result == -1\n  node = LibXML.xmlTextReaderCurrentNode(@reader)\n  if node.null?\n    (LibXML.xmlTextReaderRead(@reader)) == 1\n  else\n    if !node.value.next.null?\n      (LibXML.xmlTextReaderNext(@reader)) == 1\n    else\n      false\n    end\n  end\nelse\n  result == 1\nend\n"}},{"html_id":"node_type:XML::Reader::Type-instance-method","name":"node_type","doc":"Returns the `XML::Reader::Type` of the node.","summary":"<p>Returns the <code><a href=\"../XML/Reader/Type.html\">XML::Reader::Type</a></code> of the node.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":61,"url":null},"def":{"name":"node_type","return_type":"XML::Reader::Type","visibility":"Public","body":"LibXML.xmlTextReaderNodeType(@reader)"}},{"html_id":"read:Bool-instance-method","name":"read","doc":"Moves the reader to the next node.","summary":"<p>Moves the reader to the next node.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":32,"url":null},"def":{"name":"read","return_type":"Bool","visibility":"Public","body":"(LibXML.xmlTextReaderRead(@reader)) == 1"}},{"html_id":"read_inner_xml:String-instance-method","name":"read_inner_xml","doc":"Returns the node's XML content including subtrees.","summary":"<p>Returns the node's XML content including subtrees.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":125,"url":null},"def":{"name":"read_inner_xml","return_type":"String","visibility":"Public","body":"xml = LibXML.xmlTextReaderReadInnerXml(@reader)\nxml ? String.new(xml) : \"\"\n"}},{"html_id":"read_outer_xml:String-instance-method","name":"read_outer_xml","doc":"Returns the XML for the node and its content including subtrees.","summary":"<p>Returns the XML for the node and its content including subtrees.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":131,"url":null},"def":{"name":"read_outer_xml","return_type":"String","visibility":"Public","body":"if node_type.none?\n  return \"\"\nend\nxml = LibXML.xmlTextReaderReadOuterXml(@reader)\nxml ? String.new(xml) : \"\"\n"}},{"html_id":"to_unsafe:LibXML::XMLTextReader-instance-method","name":"to_unsafe","doc":"Returns a reference to the underlying `LibXML::XMLTextReader`.","summary":"<p>Returns a reference to the underlying <code>LibXML::XMLTextReader</code>.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":170,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@reader"}},{"html_id":"value:String-instance-method","name":"value","doc":"Returns the text content of the node.","summary":"<p>Returns the text content of the node.</p>","abstract":false,"location":{"filename":"src/xml/reader.cr","line_number":164,"url":null},"def":{"name":"value","return_type":"String","visibility":"Public","body":"value = LibXML.xmlTextReaderConstValue(@reader)\nvalue ? String.new(value) : \"\"\n"}}],"types":[{"html_id":"Crystal/XML/Reader/Type","path":"XML/Reader/Type.html","kind":"enum","full_name":"XML::Reader::Type","name":"Type","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/xml/reader/type.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"NONE","name":"NONE","value":"0"},{"id":"ELEMENT","name":"ELEMENT","value":"1"},{"id":"ATTRIBUTE","name":"ATTRIBUTE","value":"2"},{"id":"TEXT","name":"TEXT","value":"3"},{"id":"CDATA","name":"CDATA","value":"4"},{"id":"ENTITY_REFERENCE","name":"ENTITY_REFERENCE","value":"5"},{"id":"ENTITY","name":"ENTITY","value":"6"},{"id":"PROCESSING_INSTRUCTION","name":"PROCESSING_INSTRUCTION","value":"7"},{"id":"COMMENT","name":"COMMENT","value":"8"},{"id":"DOCUMENT","name":"DOCUMENT","value":"9"},{"id":"DOCUMENT_TYPE","name":"DOCUMENT_TYPE","value":"10"},{"id":"DOCUMENT_FRAGMENT","name":"DOCUMENT_FRAGMENT","value":"11"},{"id":"NOTATION","name":"NOTATION","value":"12"},{"id":"WHITESPACE","name":"WHITESPACE","value":"13"},{"id":"SIGNIFICANT_WHITESPACE","name":"SIGNIFICANT_WHITESPACE","value":"14"},{"id":"END_ELEMENT","name":"END_ELEMENT","value":"15"},{"id":"END_ENTITY","name":"END_ENTITY","value":"16"},{"id":"XML_DECLARATION","name":"XML_DECLARATION","value":"17"}],"namespace":{"html_id":"Crystal/XML/Reader","kind":"class","full_name":"XML::Reader","name":"Reader"},"instance_methods":[{"html_id":"attribute?-instance-method","name":"attribute?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":5,"url":null},"def":{"name":"attribute?","visibility":"Public","body":"self == ATTRIBUTE"}},{"html_id":"cdata?-instance-method","name":"cdata?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":7,"url":null},"def":{"name":"cdata?","visibility":"Public","body":"self == CDATA"}},{"html_id":"comment?-instance-method","name":"comment?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":11,"url":null},"def":{"name":"comment?","visibility":"Public","body":"self == COMMENT"}},{"html_id":"document?-instance-method","name":"document?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":12,"url":null},"def":{"name":"document?","visibility":"Public","body":"self == DOCUMENT"}},{"html_id":"document_fragment?-instance-method","name":"document_fragment?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":14,"url":null},"def":{"name":"document_fragment?","visibility":"Public","body":"self == DOCUMENT_FRAGMENT"}},{"html_id":"document_type?-instance-method","name":"document_type?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":13,"url":null},"def":{"name":"document_type?","visibility":"Public","body":"self == DOCUMENT_TYPE"}},{"html_id":"element?-instance-method","name":"element?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":4,"url":null},"def":{"name":"element?","visibility":"Public","body":"self == ELEMENT"}},{"html_id":"end_element?-instance-method","name":"end_element?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":18,"url":null},"def":{"name":"end_element?","visibility":"Public","body":"self == END_ELEMENT"}},{"html_id":"end_entity?-instance-method","name":"end_entity?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":19,"url":null},"def":{"name":"end_entity?","visibility":"Public","body":"self == END_ENTITY"}},{"html_id":"entity?-instance-method","name":"entity?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":9,"url":null},"def":{"name":"entity?","visibility":"Public","body":"self == ENTITY"}},{"html_id":"entity_reference?-instance-method","name":"entity_reference?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":8,"url":null},"def":{"name":"entity_reference?","visibility":"Public","body":"self == ENTITY_REFERENCE"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":3,"url":null},"def":{"name":"none?","visibility":"Public","body":"self == NONE"}},{"html_id":"notation?-instance-method","name":"notation?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":15,"url":null},"def":{"name":"notation?","visibility":"Public","body":"self == NOTATION"}},{"html_id":"processing_instruction?-instance-method","name":"processing_instruction?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":10,"url":null},"def":{"name":"processing_instruction?","visibility":"Public","body":"self == PROCESSING_INSTRUCTION"}},{"html_id":"significant_whitespace?-instance-method","name":"significant_whitespace?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":17,"url":null},"def":{"name":"significant_whitespace?","visibility":"Public","body":"self == SIGNIFICANT_WHITESPACE"}},{"html_id":"text?-instance-method","name":"text?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":6,"url":null},"def":{"name":"text?","visibility":"Public","body":"self == TEXT"}},{"html_id":"whitespace?-instance-method","name":"whitespace?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":16,"url":null},"def":{"name":"whitespace?","visibility":"Public","body":"self == WHITESPACE"}},{"html_id":"xml_declaration?-instance-method","name":"xml_declaration?","abstract":false,"location":{"filename":"src/xml/reader/type.cr","line_number":20,"url":null},"def":{"name":"xml_declaration?","visibility":"Public","body":"self == XML_DECLARATION"}}]}]},{"html_id":"Crystal/XML/SaveOptions","path":"XML/SaveOptions.html","kind":"enum","full_name":"XML::SaveOptions","name":"SaveOptions","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/xml/save_options.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"FORMAT","name":"FORMAT","value":"1","doc":"Format save output","summary":"<p>Format save output</p>"},{"id":"NO_DECL","name":"NO_DECL","value":"2","doc":"Drop the xml declaration","summary":"<p>Drop the xml declaration</p>"},{"id":"NO_EMPTY","name":"NO_EMPTY","value":"4","doc":"No empty tags","summary":"<p>No empty tags</p>"},{"id":"NO_XHTML","name":"NO_XHTML","value":"8","doc":"Disable XHTML1 specific rules","summary":"<p>Disable XHTML1 specific rules</p>"},{"id":"XHTML","name":"XHTML","value":"16","doc":"Force XHTML1 specific rules","summary":"<p>Force XHTML1 specific rules</p>"},{"id":"AS_XML","name":"AS_XML","value":"32","doc":"Force XML serialization on HTML doc","summary":"<p>Force XML serialization on HTML doc</p>"},{"id":"AS_HTML","name":"AS_HTML","value":"64","doc":"Force HTML serialization on XML doc","summary":"<p>Force HTML serialization on XML doc</p>"},{"id":"WSNONSIG","name":"WSNONSIG","value":"128","doc":"Format with non-significant whitespace","summary":"<p>Format with non-significant whitespace</p>"}],"namespace":{"html_id":"Crystal/XML","kind":"module","full_name":"XML","name":"XML"},"constructors":[{"html_id":"xml_default:self-class-method","name":"xml_default","abstract":false,"location":{"filename":"src/xml/save_options.cr","line_number":27,"url":null},"def":{"name":"xml_default","return_type":"self","visibility":"Public","body":"FORMAT | AS_XML"}}],"instance_methods":[{"html_id":"as_html?-instance-method","name":"as_html?","abstract":false,"location":{"filename":"src/xml/save_options.cr","line_number":22,"url":null},"def":{"name":"as_html?","visibility":"Public","body":"self.includes?(AS_HTML)"}},{"html_id":"as_xml?-instance-method","name":"as_xml?","abstract":false,"location":{"filename":"src/xml/save_options.cr","line_number":19,"url":null},"def":{"name":"as_xml?","visibility":"Public","body":"self.includes?(AS_XML)"}},{"html_id":"format?-instance-method","name":"format?","abstract":false,"location":{"filename":"src/xml/save_options.cr","line_number":4,"url":null},"def":{"name":"format?","visibility":"Public","body":"self.includes?(FORMAT)"}},{"html_id":"no_decl?-instance-method","name":"no_decl?","abstract":false,"location":{"filename":"src/xml/save_options.cr","line_number":7,"url":null},"def":{"name":"no_decl?","visibility":"Public","body":"self.includes?(NO_DECL)"}},{"html_id":"no_empty?-instance-method","name":"no_empty?","abstract":false,"location":{"filename":"src/xml/save_options.cr","line_number":10,"url":null},"def":{"name":"no_empty?","visibility":"Public","body":"self.includes?(NO_EMPTY)"}},{"html_id":"no_xhtml?-instance-method","name":"no_xhtml?","abstract":false,"location":{"filename":"src/xml/save_options.cr","line_number":13,"url":null},"def":{"name":"no_xhtml?","visibility":"Public","body":"self.includes?(NO_XHTML)"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/xml/save_options.cr","line_number":2,"url":null},"def":{"name":"none?","visibility":"Public","body":"value == 0"}},{"html_id":"wsnonsig?-instance-method","name":"wsnonsig?","abstract":false,"location":{"filename":"src/xml/save_options.cr","line_number":25,"url":null},"def":{"name":"wsnonsig?","visibility":"Public","body":"self.includes?(WSNONSIG)"}},{"html_id":"xhtml?-instance-method","name":"xhtml?","abstract":false,"location":{"filename":"src/xml/save_options.cr","line_number":16,"url":null},"def":{"name":"xhtml?","visibility":"Public","body":"self.includes?(XHTML)"}}]},{"html_id":"Crystal/XML/XPathContext","path":"XML/XPathContext.html","kind":"class","full_name":"XML::XPathContext","name":"XPathContext","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/xml/xpath_context.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/XML","kind":"module","full_name":"XML","name":"XML"},"constructors":[{"html_id":"new(node:Node)-class-method","name":"new","abstract":false,"args":[{"name":"node","external_name":"node","restriction":"Node"}],"args_string":"(node : Node)","args_html":"(node : <a href=\"../XML/Node.html\">Node</a>)","location":{"filename":"src/xml/xpath_context.cr","line_number":2,"url":null},"def":{"name":"new","args":[{"name":"node","external_name":"node","restriction":"Node"}],"visibility":"Public","body":"_ = allocate\n_.initialize(node)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"evaluate(search_path:String)-instance-method","name":"evaluate","abstract":false,"args":[{"name":"search_path","external_name":"search_path","restriction":"String"}],"args_string":"(search_path : String)","args_html":"(search_path : <a href=\"../String.html\">String</a>)","location":{"filename":"src/xml/xpath_context.cr","line_number":7,"url":null},"def":{"name":"evaluate","args":[{"name":"search_path","external_name":"search_path","restriction":"String"}],"visibility":"Public","body":"xpath = LibXML.xmlXPathEvalExpression(search_path, self)\nif xpath\nelse\n  {% if (flag?(:arm)) || (flag?(:aarch64)) %}\n        if errors = XML::Error.errors\n          raise errors.last\n        end\n      {% end %}\n  raise(XML::Error.new(\"Error in '#{search_path}' expression\", 0))\nend\nif xpath.value\nelse\n  raise(XML::Error.new(\"Error in '#{search_path}' expression\", 0))\nend\ncase xpath.value.type\nwhen LibXML::XPathObjectType::STRING\n  String.new(xpath.value.stringval)\nwhen LibXML::XPathObjectType::NUMBER\n  xpath.value.floatval\nwhen LibXML::XPathObjectType::BOOLEAN\n  xpath.value.boolval != 0\nwhen LibXML::XPathObjectType::NODESET\n  if xpath.value.nodesetval\n    NodeSet.new(Node.new(@ctx.value.doc), xpath.value.nodesetval)\n  else\n    NodeSet.new(Node.new(@ctx.value.doc))\n  end\nelse\n  NodeSet.new(Node.new(@ctx.value.doc))\nend\n"}},{"html_id":"register_namespace(prefix:String,uri:String?)-instance-method","name":"register_namespace","abstract":false,"args":[{"name":"prefix","external_name":"prefix","restriction":"String"},{"name":"uri","external_name":"uri","restriction":"String | ::Nil"}],"args_string":"(prefix : String, uri : String?)","args_html":"(prefix : <a href=\"../String.html\">String</a>, uri : <a href=\"../String.html\">String</a>?)","location":{"filename":"src/xml/xpath_context.cr","line_number":44,"url":null},"def":{"name":"register_namespace","args":[{"name":"prefix","external_name":"prefix","restriction":"String"},{"name":"uri","external_name":"uri","restriction":"String | ::Nil"}],"visibility":"Public","body":"prefix = prefix.lchop(\"xmlns:\")\nLibXML.xmlXPathRegisterNs(self, prefix, uri.to_s)\n"}},{"html_id":"register_namespaces(namespaces):Nil-instance-method","name":"register_namespaces","abstract":false,"args":[{"name":"namespaces","external_name":"namespaces","restriction":""}],"args_string":"(namespaces) : Nil","args_html":"(namespaces) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/xpath_context.cr","line_number":38,"url":null},"def":{"name":"register_namespaces","args":[{"name":"namespaces","external_name":"namespaces","restriction":""}],"return_type":"Nil","visibility":"Public","body":"namespaces.each do |prefix, uri|\n  register_namespace(prefix, uri)\nend"}},{"html_id":"register_variable(name,value)-instance-method","name":"register_variable","abstract":false,"args":[{"name":"name","external_name":"name","restriction":""},{"name":"value","external_name":"value","restriction":""}],"args_string":"(name, value)","args_html":"(name, value)","location":{"filename":"src/xml/xpath_context.cr","line_number":55,"url":null},"def":{"name":"register_variable","args":[{"name":"name","external_name":"name","restriction":""},{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"case value\nwhen Bool\n  obj = LibXML.xmlXPathNewBoolean(value ? 1 : 0)\nwhen Number\n  obj = LibXML.xmlXPathNewFloat(value.to_f64)\nelse\n  obj = LibXML.xmlXPathNewCString(value.to_s)\nend\nLibXML.xmlXPathRegisterVariable(self, name, obj)\n"}},{"html_id":"register_variables(variables):Nil-instance-method","name":"register_variables","abstract":false,"args":[{"name":"variables","external_name":"variables","restriction":""}],"args_string":"(variables) : Nil","args_html":"(variables) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/xml/xpath_context.cr","line_number":49,"url":null},"def":{"name":"register_variables","args":[{"name":"variables","external_name":"variables","restriction":""}],"return_type":"Nil","visibility":"Public","body":"variables.each do |name, value|\n  register_variable(name, value)\nend"}},{"html_id":"to_unsafe:Pointer(LibXML::XPathContext)-instance-method","name":"to_unsafe","abstract":false,"location":{"filename":"src/xml/xpath_context.cr","line_number":68,"url":null},"def":{"name":"to_unsafe","visibility":"Public","body":"@ctx"}}]}]},{"html_id":"Crystal/YAML","path":"YAML.html","kind":"module","full_name":"YAML","name":"YAML","abstract":false,"locations":[{"filename":"src/yaml.cr","line_number":77,"url":null},{"filename":"src/yaml/any.cr","line_number":27,"url":null},{"filename":"src/yaml/builder.cr","line_number":225,"url":null},{"filename":"src/yaml/enums.cr","line_number":1,"url":null},{"filename":"src/yaml/serialization.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"doc":"The YAML module provides serialization and deserialization of YAML\nversion 1.1 to/from native Crystal data structures, with the additional\nindependent types specified in http://yaml.org/type/\n\n### Parsing with `#parse` and `#parse_all`\n\n`YAML.parse` will return an `Any`, which is a convenient wrapper around all possible\nYAML core types, making it easy to traverse a complex YAML structure but requires\nsome casts from time to time, mostly via some method invocations.\n\n```\nrequire \"yaml\"\n\ndata = YAML.parse <<-END\n         ---\n         foo:\n           bar:\n             baz:\n               - qux\n               - fox\n         END\ndata[\"foo\"][\"bar\"][\"baz\"][1].as_s # => \"fox\"\n```\n\n`YAML.parse` can read from an `IO` directly (such as a file) which saves\nallocating a string:\n\n```\nrequire \"yaml\"\n\nyaml = File.open(\"path/to/file.yml\") do |file|\n  YAML.parse(file)\nend\n```\n\n### Parsing with `from_yaml`\n\nA type `T` can be deserialized from YAML by invoking `T.from_yaml(string_or_io)`.\nFor this to work, `T` must implement\n`new(ctx : YAML::PullParser, node : YAML::Nodes::Node)` and decode\na value from the given *node*, using *ctx* to store and retrieve\nanchored values (see `YAML::PullParser` for an explanation of this).\n\nCrystal primitive types, `Time`, `Bytes` and `Union` implement\nthis method. `YAML::Serializable` can be used to implement this method\nfor user types.\n\n### Dumping with `YAML.dump` or `#to_yaml`\n\n`YAML.dump` generates the YAML representation for an object.\nAn `IO` can be passed and it will be written there,\notherwise it will be returned as a string. Similarly, `#to_yaml`\n(with or without an `IO`) on any object does the same.\n\nFor this to work, the type given to `YAML.dump` must implement\n`to_yaml(builder : YAML::Nodes::Builder`).\n\nCrystal primitive types, `Time` and `Bytes` implement\nthis method. `YAML::Serializable` can be used to implement this method\nfor user types.\n\n```\nyaml = YAML.dump({hello: \"world\"})                               # => \"---\\nhello: world\\n\"\nFile.open(\"foo.yml\", \"w\") { |f| YAML.dump({hello: \"world\"}, f) } # writes it to the file\n# or:\nyaml = {hello: \"world\"}.to_yaml                               # => \"---\\nhello: world\\n\"\nFile.open(\"foo.yml\", \"w\") { |f| {hello: \"world\"}.to_yaml(f) } # writes it to the file\n```","summary":"<p>The YAML module provides serialization and deserialization of YAML version 1.1 to/from native Crystal data structures, with the additional independent types specified in http://yaml.org/type/</p>","class_methods":[{"html_id":"build(io:IO,&):Nil-class-method","name":"build","doc":"Writes YAML into the given `IO`. A `YAML::Builder` is yielded to the block.","summary":"<p>Writes YAML into the given <code><a href=\"IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO, &) : Nil","args_html":"(io : <a href=\"IO.html\">IO</a>, &) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml/builder.cr","line_number":251,"url":null},"def":{"name":"build","args":[{"name":"io","external_name":"io","restriction":"IO"}],"yields":1,"return_type":"Nil","visibility":"Public","body":"YAML::Builder.build(io) do |yaml|\n  yaml.stream do\n    yaml.document do\n      yield yaml\n    end\n  end\nend"}},{"html_id":"build(&)-class-method","name":"build","doc":"Returns the resulting String of writing YAML to the yielded `YAML::Builder`.\n\n```\nrequire \"yaml\"\n\nstring = YAML.build do |yaml|\n  yaml.mapping do\n    yaml.scalar \"foo\"\n    yaml.sequence do\n      yaml.scalar 1\n      yaml.scalar 2\n    end\n  end\nend\nstring # => \"---\\nfoo:\\n- 1\\n- 2\\n\"\n```","summary":"<p>Returns the resulting String of writing YAML to the yielded <code><a href=\"YAML/Builder.html\">YAML::Builder</a></code>.</p>","abstract":false,"location":{"filename":"src/yaml/builder.cr","line_number":242,"url":null},"def":{"name":"build","yields":1,"visibility":"Public","body":"String.build do |str|\n  build(str) do |yaml|\n    yield yaml\n  end\nend"}},{"html_id":"dump(object,io:IO):Nil-class-method","name":"dump","doc":"Serializes an object to YAML, writing it to *io*.","summary":"<p>Serializes an object to YAML, writing it to <em>io</em>.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":""},{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(object, io : IO) : Nil","args_html":"(object, io : <a href=\"IO.html\">IO</a>) : <a href=\"Nil.html\">Nil</a>","location":{"filename":"src/yaml.cr","line_number":158,"url":null},"def":{"name":"dump","args":[{"name":"object","external_name":"object","restriction":""},{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"object.to_yaml(io)"}},{"html_id":"dump(object):String-class-method","name":"dump","doc":"Serializes an object to YAML, returning it as a `String`.","summary":"<p>Serializes an object to YAML, returning it as a <code><a href=\"String.html\">String</a></code>.</p>","abstract":false,"args":[{"name":"object","external_name":"object","restriction":""}],"args_string":"(object) : String","args_html":"(object) : <a href=\"String.html\">String</a>","location":{"filename":"src/yaml.cr","line_number":153,"url":null},"def":{"name":"dump","args":[{"name":"object","external_name":"object","restriction":""}],"return_type":"String","visibility":"Public","body":"object.to_yaml"}},{"html_id":"libyaml_version:SemanticVersion-class-method","name":"libyaml_version","doc":"Returns the used version of `libyaml`.","summary":"<p>Returns the used version of <code>libyaml</code>.</p>","abstract":false,"location":{"filename":"src/yaml.cr","line_number":163,"url":null},"def":{"name":"libyaml_version","return_type":"SemanticVersion","visibility":"Public","body":"LibYAML.yaml_get_version(out major, out minor, out patch)\nSemanticVersion.new(major, minor, patch)\n"}},{"html_id":"parse(data:String|IO):Any-class-method","name":"parse","doc":"Deserializes a YAML document according to the core schema.\n\n```yaml\n# ./foo.yml\ndata:\n  string: \"foobar\"\n  array:\n    - John\n    - Sarah\n  hash: {key: value}\n  paragraph: |\n    foo\n    bar\n```\n\n```\nrequire \"yaml\"\n\nYAML.parse(File.read(\"./foo.yml\"))\n# => {\n# => \"data\" => {\n# => \"string\" => \"foobar\",\n# => \"array\" => [\"John\", \"Sarah\"],\n# => \"hash\" => {\"key\" => \"value\"},\n# => \"paragraph\" => \"foo\\nbar\\n\"\n# => }\n```","summary":"<p>Deserializes a YAML document according to the core schema.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":"String | IO"}],"args_string":"(data : String | IO) : Any","args_html":"(data : <a href=\"String.html\">String</a> | <a href=\"IO.html\">IO</a>) : <a href=\"YAML/Any.html\">Any</a>","location":{"filename":"src/yaml.cr","line_number":129,"url":null},"def":{"name":"parse","args":[{"name":"data","external_name":"data","restriction":"String | IO"}],"return_type":"Any","visibility":"Public","body":"YAML::Schema::Core.parse(data)"}},{"html_id":"parse_all(data:String):Array(Any)-class-method","name":"parse_all","doc":"Deserializes multiple YAML documents according to the core schema.\n\n```yaml\n# ./foo.yml\nfoo: bar\n---\nhello: world\n```\n\n```\nrequire \"yaml\"\n\nYAML.parse_all(File.read(\"./foo.yml\"))\n# => [{\"foo\" => \"bar\"}, {\"hello\" => \"world\"}]\n```","summary":"<p>Deserializes multiple YAML documents according to the core schema.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":"String"}],"args_string":"(data : String) : Array(Any)","args_html":"(data : <a href=\"String.html\">String</a>) : <a href=\"Array.html\">Array</a>(<a href=\"YAML/Any.html\">Any</a>)","location":{"filename":"src/yaml.cr","line_number":148,"url":null},"def":{"name":"parse_all","args":[{"name":"data","external_name":"data","restriction":"String"}],"return_type":"Array(Any)","visibility":"Public","body":"YAML::Schema::Core.parse_all(data)"}}],"types":[{"html_id":"Crystal/YAML/Any","path":"YAML/Any.html","kind":"struct","full_name":"YAML::Any","name":"Any","abstract":false,"superclass":{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},"ancestors":[{"html_id":"Crystal/Struct","kind":"struct","full_name":"Struct","name":"Struct"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml/any.cr","line_number":27,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":"`YAML::Any` is a convenient wrapper around all possible YAML core types\n(`YAML::Any::Type`) and can be used for traversing dynamic or\nunknown YAML structures.\n\n```\nrequire \"yaml\"\n\ndata = YAML.parse <<-END\n         ---\n         foo:\n           bar:\n             baz:\n               - qux\n               - fox\n         END\ndata[\"foo\"][\"bar\"][\"baz\"][0].as_s # => \"qux\"\ndata[\"foo\"][\"bar\"][\"baz\"].as_a    # => [\"qux\", \"fox\"]\n```\n\nNote that methods used to traverse a YAML structure, `#[]`, `#[]?` and `#each`,\nalways return a `YAML::Any` to allow further traversal. To convert them to `String`,\n`Array`, etc., use the `as_` methods, such as `#as_s`, `#as_a`, which perform\na type check against the raw underlying value. This means that invoking `#as_s`\nwhen the underlying value is not a `String` will raise: the value won't automatically\nbe converted (parsed) to a `String`. There are also nil-able variants (`#as_i?`, `#as_s?`, ...),\nwhich return `nil` when the underlying value type won't match.","summary":"<p><code><a href=\"../YAML/Any.html\">YAML::Any</a></code> is a convenient wrapper around all possible YAML core types (<code><a href=\"../YAML/Any/Type.html\">YAML::Any::Type</a></code>) and can be used for traversing dynamic or unknown YAML structures.</p>","constructors":[{"html_id":"new(ctx:YAML::ParseContext,node:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node)","args_html":"(ctx : <a href=\"../YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"../YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/any.cr","line_number":31,"url":null},"def":{"name":"new","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"visibility":"Public","body":"case node\nwhen YAML::Nodes::Scalar\n  new(YAML::Schema::Core.parse_scalar(node.value))\nwhen YAML::Nodes::Sequence\n  ary = [] of Any\n  node.each do |value|\n    ary << (new(ctx, value))\n  end\n  new(ary)\nwhen YAML::Nodes::Mapping\n  hash = {} of Any => Any\n  node.each do |key, value|\n    hash[new(ctx, key)] = new(ctx, value)\n  end\n  new(hash)\nwhen YAML::Nodes::Alias\n  if value = node.value\n    new(ctx, value)\n  else\n    raise(\"YAML::Nodes::Alias misses anchor value\")\n  end\nelse\n  raise(\"Unknown node: #{node.class}\")\nend"}},{"html_id":"new(raw:Type)-class-method","name":"new","doc":"Creates a `Any` that wraps the given `Type`.","summary":"<p>Creates a <code><a href=\"../YAML/Any.html\">Any</a></code> that wraps the given <code><a href=\"../YAML/Any/Type.html\">Type</a></code>.</p>","abstract":false,"args":[{"name":"raw","external_name":"raw","restriction":"Type"}],"args_string":"(raw : Type)","args_html":"(raw : <a href=\"../YAML/Any/Type.html\">Type</a>)","location":{"filename":"src/yaml/any.cr","line_number":66,"url":null},"def":{"name":"new","args":[{"name":"raw","external_name":"raw","restriction":"Type"}],"visibility":"Public","body":"_ = allocate\n_.initialize(raw)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"==(other:YAML::Any)-instance-method","name":"==","doc":"Returns `true` if both `self` and *other*'s raw object are equal.","summary":"<p>Returns <code>true</code> if both <code>self</code> and <em>other</em>'s raw object are equal.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":"YAML::Any"}],"args_string":"(other : YAML::Any)","args_html":"(other : <a href=\"../YAML/Any.html\">YAML::Any</a>)","location":{"filename":"src/yaml/any.cr","line_number":287,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":"YAML::Any"}],"visibility":"Public","body":"raw == other.raw"}},{"html_id":"==(other)-instance-method","name":"==","doc":"Returns `true` if the raw object is equal to *other*.","summary":"<p>Returns <code>true</code> if the raw object is equal to <em>other</em>.</p>","abstract":false,"args":[{"name":"other","external_name":"other","restriction":""}],"args_string":"(other)","args_html":"(other)","location":{"filename":"src/yaml/any.cr","line_number":292,"url":null},"def":{"name":"==","args":[{"name":"other","external_name":"other","restriction":""}],"visibility":"Public","body":"raw == other"}},{"html_id":"[](index_or_key):YAML::Any-instance-method","name":"[]","doc":"Assumes the underlying value is an `Array` or `Hash`\nand returns the element at the given *index_or_key*.\n\nRaises if the underlying value is not an `Array` nor a `Hash`.","summary":"<p>Assumes the underlying value is an <code><a href=\"../Array.html\">Array</a></code> or <code><a href=\"../Hash.html\">Hash</a></code> and returns the element at the given <em>index_or_key</em>.</p>","abstract":false,"args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""}],"args_string":"(index_or_key) : YAML::Any","args_html":"(index_or_key) : <a href=\"../YAML/Any.html\">YAML::Any</a>","location":{"filename":"src/yaml/any.cr","line_number":87,"url":null},"def":{"name":"[]","args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""}],"return_type":"YAML::Any","visibility":"Public","body":"case object = @raw\nwhen Array\n  if index_or_key.is_a?(Int)\n    object[index_or_key]\n  else\n    raise(\"Expected int key for Array#[], not #{object.class}\")\n  end\nwhen Hash\n  object[index_or_key]\nelse\n  raise(\"Expected Array or Hash, not #{object.class}\")\nend"}},{"html_id":"[]?(index_or_key):YAML::Any?-instance-method","name":"[]?","doc":"Assumes the underlying value is an `Array` or `Hash` and returns the element\nat the given *index_or_key*, or `nil` if out of bounds or the key is missing.\n\nRaises if the underlying value is not an `Array` nor a `Hash`.","summary":"<p>Assumes the underlying value is an <code><a href=\"../Array.html\">Array</a></code> or <code><a href=\"../Hash.html\">Hash</a></code> and returns the element at the given <em>index_or_key</em>, or <code>nil</code> if out of bounds or the key is missing.</p>","abstract":false,"args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""}],"args_string":"(index_or_key) : YAML::Any?","args_html":"(index_or_key) : <a href=\"../YAML/Any.html\">YAML::Any</a>?","location":{"filename":"src/yaml/any.cr","line_number":106,"url":null},"def":{"name":"[]?","args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""}],"return_type":"YAML::Any | ::Nil","visibility":"Public","body":"case object = @raw\nwhen Array\n  if index_or_key.is_a?(Int)\n    object[index_or_key]?\n  else\n    nil\n  end\nwhen Hash\n  object[index_or_key]?\nelse\n  raise(\"Expected Array or Hash, not #{object.class}\")\nend"}},{"html_id":"as_a:Array(Any)-instance-method","name":"as_a","doc":"Checks that the underlying value is `Array`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Array.html\">Array</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":239,"url":null},"def":{"name":"as_a","return_type":"Array(Any)","visibility":"Public","body":"@raw.as(Array)"}},{"html_id":"as_a?:Array(Any)?-instance-method","name":"as_a?","doc":"Checks that the underlying value is `Array`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Array.html\">Array</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":245,"url":null},"def":{"name":"as_a?","return_type":"Array(Any) | ::Nil","visibility":"Public","body":"@raw.as?(Array)"}},{"html_id":"as_bool:Bool-instance-method","name":"as_bool","doc":"Checks that the underlying value is `Bool`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Bool.html\">Bool</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":155,"url":null},"def":{"name":"as_bool","return_type":"Bool","visibility":"Public","body":"@raw.as(Bool)"}},{"html_id":"as_bool?:Bool?-instance-method","name":"as_bool?","doc":"Checks that the underlying value is `Bool`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Bool.html\">Bool</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":161,"url":null},"def":{"name":"as_bool?","return_type":"Bool | ::Nil","visibility":"Public","body":"if @raw.is_a?(Bool)\n  as_bool\nend"}},{"html_id":"as_bytes:Bytes-instance-method","name":"as_bytes","doc":"Checks that the underlying value is `Bytes`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Bytes.html\">Bytes</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":263,"url":null},"def":{"name":"as_bytes","return_type":"Bytes","visibility":"Public","body":"@raw.as(Bytes)"}},{"html_id":"as_bytes?:Bytes?-instance-method","name":"as_bytes?","doc":"Checks that the underlying value is `Bytes`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Bytes.html\">Bytes</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":269,"url":null},"def":{"name":"as_bytes?","return_type":"Bytes | ::Nil","visibility":"Public","body":"@raw.as?(Bytes)"}},{"html_id":"as_f:Float64-instance-method","name":"as_f","doc":"Checks that the underlying value is `Float64`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Float64.html\">Float64</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":203,"url":null},"def":{"name":"as_f","return_type":"Float64","visibility":"Public","body":"@raw.as(Float64)"}},{"html_id":"as_f32:Float32-instance-method","name":"as_f32","doc":"Checks that the underlying value is `Float`, and returns its value as an `Float32`.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Float.html\">Float</a></code>, and returns its value as an <code><a href=\"../Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":215,"url":null},"def":{"name":"as_f32","return_type":"Float32","visibility":"Public","body":"(@raw.as(Float)).to_f32"}},{"html_id":"as_f32?:Float32?-instance-method","name":"as_f32?","doc":"Checks that the underlying value is `Float`, and returns its value as an `Float32`.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Float.html\">Float</a></code>, and returns its value as an <code><a href=\"../Float32.html\">Float32</a></code>.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":221,"url":null},"def":{"name":"as_f32?","return_type":"Float32 | ::Nil","visibility":"Public","body":"if @raw.is_a?(Float)\n  as_f32\nend"}},{"html_id":"as_f?:Float64?-instance-method","name":"as_f?","doc":"Checks that the underlying value is `Float64`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Float64.html\">Float64</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":209,"url":null},"def":{"name":"as_f?","return_type":"Float64 | ::Nil","visibility":"Public","body":"@raw.as?(Float64)"}},{"html_id":"as_h:Hash(Any,Any)-instance-method","name":"as_h","doc":"Checks that the underlying value is `Hash`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Hash.html\">Hash</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":251,"url":null},"def":{"name":"as_h","return_type":"Hash(Any, Any)","visibility":"Public","body":"@raw.as(Hash)"}},{"html_id":"as_h?:Hash(Any,Any)?-instance-method","name":"as_h?","doc":"Checks that the underlying value is `Hash`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Hash.html\">Hash</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":257,"url":null},"def":{"name":"as_h?","return_type":"Hash(Any, Any) | ::Nil","visibility":"Public","body":"@raw.as?(Hash)"}},{"html_id":"as_i:Int32-instance-method","name":"as_i","doc":"Checks that the underlying value is `Int64`, and returns its value as `Int32`.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int64.html\">Int64</a></code>, and returns its value as <code><a href=\"../Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":191,"url":null},"def":{"name":"as_i","return_type":"Int32","visibility":"Public","body":"(@raw.as(Int64)).to_i"}},{"html_id":"as_i64:Int64-instance-method","name":"as_i64","doc":"Checks that the underlying value is `Int64`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int64.html\">Int64</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":179,"url":null},"def":{"name":"as_i64","return_type":"Int64","visibility":"Public","body":"@raw.as(Int64)"}},{"html_id":"as_i64?:Int64?-instance-method","name":"as_i64?","doc":"Checks that the underlying value is `Int64`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int64.html\">Int64</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":185,"url":null},"def":{"name":"as_i64?","return_type":"Int64 | ::Nil","visibility":"Public","body":"@raw.as?(Int64)"}},{"html_id":"as_i?:Int32?-instance-method","name":"as_i?","doc":"Checks that the underlying value is `Int64`, and returns its value as `Int32`.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Int64.html\">Int64</a></code>, and returns its value as <code><a href=\"../Int32.html\">Int32</a></code>.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":197,"url":null},"def":{"name":"as_i?","return_type":"Int32 | ::Nil","visibility":"Public","body":"if @raw.is_a?(Int)\n  as_i\nend"}},{"html_id":"as_nil:Nil-instance-method","name":"as_nil","doc":"Checks that the underlying value is `Nil`, and returns `nil`.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Nil.html\">Nil</a></code>, and returns <code>nil</code>.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":149,"url":null},"def":{"name":"as_nil","return_type":"Nil","visibility":"Public","body":"@raw.as(Nil)"}},{"html_id":"as_s:String-instance-method","name":"as_s","doc":"Checks that the underlying value is `String`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../String.html\">String</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":167,"url":null},"def":{"name":"as_s","return_type":"String","visibility":"Public","body":"@raw.as(String)"}},{"html_id":"as_s?:String?-instance-method","name":"as_s?","doc":"Checks that the underlying value is `String`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../String.html\">String</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":173,"url":null},"def":{"name":"as_s?","return_type":"String | ::Nil","visibility":"Public","body":"@raw.as?(String)"}},{"html_id":"as_time:Time-instance-method","name":"as_time","doc":"Checks that the underlying value is `Time`, and returns its value.\nRaises otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Time.html\">Time</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":227,"url":null},"def":{"name":"as_time","return_type":"Time","visibility":"Public","body":"@raw.as(Time)"}},{"html_id":"as_time?:Time?-instance-method","name":"as_time?","doc":"Checks that the underlying value is `Time`, and returns its value.\nReturns `nil` otherwise.","summary":"<p>Checks that the underlying value is <code><a href=\"../Time.html\">Time</a></code>, and returns its value.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":233,"url":null},"def":{"name":"as_time?","return_type":"Time | ::Nil","visibility":"Public","body":"@raw.as?(Time)"}},{"html_id":"clone-instance-method","name":"clone","doc":"Returns a new YAML::Any instance with the `raw` value `clone`ed.","summary":"<p>Returns a new YAML::Any instance with the <code><a href=\"../YAML/Any.html#raw%3AType-instance-method\">#raw</a></code> value <code><a href=\"../YAML/Any.html#clone-instance-method\">#clone</a></code>ed.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":318,"url":null},"def":{"name":"clone","visibility":"Public","body":"Any.new(raw.clone)"}},{"html_id":"dig(index_or_key,*subkeys):YAML::Any-instance-method","name":"dig","doc":"Traverses the depth of a structure and returns the value, otherwise raises.","summary":"<p>Traverses the depth of a structure and returns the value, otherwise raises.</p>","abstract":false,"args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""},{"name":"subkeys","external_name":"subkeys","restriction":""}],"args_string":"(index_or_key, *subkeys) : YAML::Any","args_html":"(index_or_key, *subkeys) : <a href=\"../YAML/Any.html\">YAML::Any</a>","location":{"filename":"src/yaml/any.cr","line_number":138,"url":null},"def":{"name":"dig","args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""},{"name":"subkeys","external_name":"subkeys","restriction":""}],"splat_index":1,"return_type":"YAML::Any","visibility":"Public","body":"self[index_or_key].dig(*subkeys)"}},{"html_id":"dig?(index_or_key,*subkeys):YAML::Any?-instance-method","name":"dig?","doc":"Traverses the depth of a structure and returns the value.\nReturns `nil` if not found.","summary":"<p>Traverses the depth of a structure and returns the value.</p>","abstract":false,"args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""},{"name":"subkeys","external_name":"subkeys","restriction":""}],"args_string":"(index_or_key, *subkeys) : YAML::Any?","args_html":"(index_or_key, *subkeys) : <a href=\"../YAML/Any.html\">YAML::Any</a>?","location":{"filename":"src/yaml/any.cr","line_number":123,"url":null},"def":{"name":"dig?","args":[{"name":"index_or_key","external_name":"index_or_key","restriction":""},{"name":"subkeys","external_name":"subkeys","restriction":""}],"splat_index":1,"return_type":"YAML::Any | ::Nil","visibility":"Public","body":"self[index_or_key]?.try(&.dig?(*subkeys))"}},{"html_id":"dup-instance-method","name":"dup","doc":"Returns a new YAML::Any instance with the `raw` value `dup`ed.","summary":"<p>Returns a new YAML::Any instance with the <code><a href=\"../YAML/Any.html#raw%3AType-instance-method\">#raw</a></code> value <code><a href=\"../YAML/Any.html#dup-instance-method\">#dup</a></code>ed.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":313,"url":null},"def":{"name":"dup","visibility":"Public","body":"Any.new(raw.dup)"}},{"html_id":"hash(hasher)-instance-method","name":"hash","doc":"See `Object#hash(hasher)`","summary":"<p>See <code><a href=\"../Object.html#hash%28hasher%29-instance-method\">Object#hash(hasher)</a></code></p>","abstract":false,"args":[{"name":"hasher","external_name":"hasher","restriction":""}],"args_string":"(hasher)","args_html":"(hasher)","location":{"filename":"src/yaml/any.cr","line_number":297,"url":null},"def":{"name":"hash","args":[{"name":"hasher","external_name":"hasher","restriction":""}],"visibility":"Public","body":"hasher = raw.hash(hasher)\nhasher\n"}},{"html_id":"inspect(io:IO):Nil-instance-method","name":"inspect","doc":"Appends this struct's name and instance variables names and values\nto the given IO.\n\n```\nstruct Point\n  def initialize(@x : Int32, @y : Int32)\n  end\nend\n\np1 = Point.new 1, 2\np1.to_s    # \"Point(@x=1, @y=2)\"\np1.inspect # \"Point(@x=1, @y=2)\"\n```","summary":"<p>Appends this struct's name and instance variables names and values to the given IO.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/yaml/any.cr","line_number":273,"url":null},"def":{"name":"inspect","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"@raw.inspect(io)"}},{"html_id":"raw:Type-instance-method","name":"raw","doc":"Returns the raw underlying value, a `Type`.","summary":"<p>Returns the raw underlying value, a <code><a href=\"../YAML/Any/Type.html\">Type</a></code>.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":63,"url":null},"def":{"name":"raw","return_type":"Type","visibility":"Public","body":"@raw"}},{"html_id":"size:Int-instance-method","name":"size","doc":"Assumes the underlying value is an `Array` or `Hash` and returns its size.\n\nRaises if the underlying value is not an `Array` or `Hash`.","summary":"<p>Assumes the underlying value is an <code><a href=\"../Array.html\">Array</a></code> or <code><a href=\"../Hash.html\">Hash</a></code> and returns its size.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":72,"url":null},"def":{"name":"size","return_type":"Int","visibility":"Public","body":"case object = @raw\nwhen Array\n  object.size\nwhen Hash\n  object.size\nelse\n  raise(\"Expected Array or Hash for #size, not #{object.class}\")\nend"}},{"html_id":"to_json(builder:JSON::Builder):Nil-instance-method","name":"to_json","abstract":false,"args":[{"name":"builder","external_name":"builder","restriction":"JSON::Builder"}],"args_string":"(builder : JSON::Builder) : Nil","args_html":"(builder : <a href=\"../JSON/Builder.html\">JSON::Builder</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/yaml/any.cr","line_number":304,"url":null},"def":{"name":"to_json","args":[{"name":"builder","external_name":"builder","restriction":"JSON::Builder"}],"return_type":"Nil","visibility":"Public","body":"if (raw = self.raw).is_a?(Slice)\n  raise(\"Can't serialize #{raw.class} to JSON\")\nelse\n  raw.to_json(builder)\nend"}},{"html_id":"to_json_object_key:String-instance-method","name":"to_json_object_key","doc":"Forwards `to_json_object_key` to `raw` if it responds to that method,\nraises `JSON::Error` otherwise.","summary":"<p>Forwards <code><a href=\"../YAML/Any.html#to_json_object_key%3AString-instance-method\">#to_json_object_key</a></code> to <code><a href=\"../YAML/Any.html#raw%3AType-instance-method\">#raw</a></code> if it responds to that method, raises <code><a href=\"../JSON/Error.html\">JSON::Error</a></code> otherwise.</p>","abstract":false,"location":{"filename":"src/yaml/any.cr","line_number":324,"url":null},"def":{"name":"to_json_object_key","return_type":"String","visibility":"Public","body":"raw = @raw\nif raw.responds_to?(:to_json_object_key)\n  raw.to_json_object_key\nelse\n  raise(JSON::Error.new(\"can't convert #{raw.class} to a JSON object key\"))\nend\n"}},{"html_id":"to_s(io:IO):Nil-instance-method","name":"to_s","doc":"Same as `#inspect(io)`.","summary":"<p>Same as <code><a href=\"../YAML/Any.html#inspect%28io%3AIO%29%3ANil-instance-method\">#inspect(io)</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/yaml/any.cr","line_number":277,"url":null},"def":{"name":"to_s","args":[{"name":"io","external_name":"io","restriction":"IO"}],"return_type":"Nil","visibility":"Public","body":"@raw.to_s(io)"}}],"types":[{"html_id":"Crystal/YAML/Any/Type","path":"YAML/Any/Type.html","kind":"alias","full_name":"YAML::Any::Type","name":"Type","abstract":false,"locations":[{"filename":"src/yaml/any.cr","line_number":29,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":true,"aliased":"(Array(YAML::Any) | Bool | Float64 | Hash(YAML::Any, YAML::Any) | Int64 | Set(YAML::Any) | Slice(UInt8) | String | Time | Nil)","aliased_html":"<a href=\"../../Array.html\">Array</a>(<a href=\"../../YAML/Any.html\">YAML::Any</a>) | <a href=\"../../Bool.html\">Bool</a> | <a href=\"../../Float64.html\">Float64</a> | <a href=\"../../Hash.html\">Hash</a>(<a href=\"../../YAML/Any.html\">YAML::Any</a>, <a href=\"../../YAML/Any.html\">YAML::Any</a>) | <a href=\"../../Int64.html\">Int64</a> | <a href=\"../../Set.html\">Set</a>(<a href=\"../../YAML/Any.html\">YAML::Any</a>) | <a href=\"../../Slice.html\">Slice</a>(<a href=\"../../UInt8.html\">UInt8</a>) | <a href=\"../../String.html\">String</a> | <a href=\"../../Time.html\">Time</a> | <a href=\"../../Nil.html\">Nil</a>","const":false,"namespace":{"html_id":"Crystal/YAML/Any","kind":"struct","full_name":"YAML::Any","name":"Any"},"doc":"All valid YAML core schema types.","summary":"<p>All valid YAML core schema types.</p>"}]},{"html_id":"Crystal/YAML/ArrayConverter","path":"YAML/ArrayConverter.html","kind":"module","full_name":"YAML::ArrayConverter(Converter)","name":"ArrayConverter","abstract":false,"locations":[{"filename":"src/yaml/from_yaml.cr","line_number":338,"url":null},{"filename":"src/yaml/to_yaml.cr","line_number":264,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":"Converter to be used with `YAML::Serializable`\nto serialize the `Array(T)` elements with the custom converter.\n\n```\nrequire \"yaml\"\n\nclass Timestamp\n  include YAML::Serializable\n\n  @[YAML::Field(converter: YAML::ArrayConverter(Time::EpochConverter))]\n  property values : Array(Time)\nend\n\ntimestamp = Timestamp.from_yaml(%({\"values\":[1459859781,1567628762]}))\ntimestamp.values  # => [2016-04-05 12:36:21 UTC, 2019-09-04 20:26:02 UTC]\ntimestamp.to_yaml # => ---\\nvalues:\\n- 1459859781\\n- 1567628762\\n\n```","summary":"<p>Converter to be used with <code><a href=\"../YAML/Serializable.html\">YAML::Serializable</a></code> to serialize the <code><a href=\"../Array.html\">Array</a>(T)</code> elements with the custom converter.</p>","class_methods":[{"html_id":"from_yaml(ctx:YAML::ParseContext,node:YAML::Nodes::Node):Array-class-method","name":"from_yaml","abstract":false,"args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(ctx : YAML::ParseContext, node : YAML::Nodes::Node) : Array","args_html":"(ctx : <a href=\"../YAML/ParseContext.html\">YAML::ParseContext</a>, node : <a href=\"../YAML/Nodes/Node.html\">YAML::Nodes::Node</a>) : <a href=\"../Array.html\">Array</a>","location":{"filename":"src/yaml/from_yaml.cr","line_number":339,"url":null},"def":{"name":"from_yaml","args":[{"name":"ctx","external_name":"ctx","restriction":"YAML::ParseContext"},{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"return_type":"Array","visibility":"Public","body":"if node.is_a?(YAML::Nodes::Sequence)\nelse\n  node.raise(\"Expected sequence, not #{node.kind}\")\nend\nary = Array(typeof(Converter.from_yaml(ctx, node))).new\nnode.each do |value|\n  ary << (Converter.from_yaml(ctx, value))\nend\nary\n"}},{"html_id":"to_yaml(values:Array,yaml:YAML::Nodes::Builder)-class-method","name":"to_yaml","abstract":false,"args":[{"name":"values","external_name":"values","restriction":"Array"},{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"args_string":"(values : Array, yaml : YAML::Nodes::Builder)","args_html":"(values : <a href=\"../Array.html\">Array</a>, yaml : <a href=\"../YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>)","location":{"filename":"src/yaml/to_yaml.cr","line_number":265,"url":null},"def":{"name":"to_yaml","args":[{"name":"values","external_name":"values","restriction":"Array"},{"name":"yaml","external_name":"yaml","restriction":"YAML::Nodes::Builder"}],"visibility":"Public","body":"yaml.sequence(reference: self) do\n  values.each do |value|\n    Converter.to_yaml(value, yaml)\n  end\nend"}}]},{"html_id":"Crystal/YAML/Builder","path":"YAML/Builder.html","kind":"class","full_name":"YAML::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml/builder.cr","line_number":26,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":"A YAML builder generates valid YAML.\n\nA `YAML::Error` is raised if attempting to generate\nan invalid YAML (for example, if invoking `end_sequence`\nwithout a matching `start_sequence`)\n\n```\nrequire \"yaml\"\n\nstring = YAML.build do |yaml|\n  yaml.mapping do\n    yaml.scalar \"foo\"\n    yaml.sequence do\n      yaml.scalar 1\n      yaml.scalar 2\n    end\n    yaml.scalar \"bar\"\n    yaml.mapping do\n      yaml.scalar \"baz\"\n      yaml.scalar \"qux\"\n    end\n  end\nend\nstring # => \"---\\nfoo:\\n- 1\\n- 2\\nbar:\\n  baz: qux\\n\"\n```","summary":"<p>A YAML builder generates valid YAML.</p>","class_methods":[{"html_id":"build(io:IO,&:self->):Nil-class-method","name":"build","doc":"Creates a `YAML::Builder` that writes to *io* and yields it to the block.\n\nAfter returning from the block the builder is closed.","summary":"<p>Creates a <code><a href=\"../YAML/Builder.html\">YAML::Builder</a></code> that writes to <em>io</em> and yields it to the block.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO, & : self -> ) : Nil","args_html":"(io : <a href=\"../IO.html\">IO</a>, & : <span class=\"k\">self</span> -> ) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/yaml/builder.cr","line_number":53,"url":null},"def":{"name":"build","args":[{"name":"io","external_name":"io","restriction":"IO"}],"yields":1,"block_arg":{"name":"","external_name":"","restriction":"(self ->)"},"return_type":"Nil","visibility":"Public","body":"builder = new(io)\nbegin\n  yield builder\nensure\n  builder.close\nend\n"}}],"constructors":[{"html_id":"new(io:IO)-class-method","name":"new","doc":"Creates a `YAML::Builder` that will write to the given `IO`.","summary":"<p>Creates a <code><a href=\"../YAML/Builder.html\">YAML::Builder</a></code> that will write to the given <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"args":[{"name":"io","external_name":"io","restriction":"IO"}],"args_string":"(io : IO)","args_html":"(io : <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/yaml/builder.cr","line_number":35,"url":null},"def":{"name":"new","args":[{"name":"io","external_name":"io","restriction":"IO"}],"visibility":"Public","body":"_ = allocate\n_.initialize(io)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"alias(anchor:String):Nil-instance-method","name":"alias","doc":"Emits an alias to the given *anchor*.\n\n```\nrequire \"yaml\"\n\nyaml = YAML.build do |builder|\n  builder.mapping do\n    builder.scalar \"key\"\n    builder.alias \"example\"\n  end\nend\n\nyaml # => \"---\\nkey: *example\\n\"\n```","summary":"<p>Emits an alias to the given <em>anchor</em>.</p>","abstract":false,"args":[{"name":"anchor","external_name":"anchor","restriction":"String"}],"args_string":"(anchor : String) : Nil","args_html":"(anchor : <a href=\"../String.html\">String</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/yaml/builder.cr","line_number":150,"url":null},"def":{"name":"alias","args":[{"name":"anchor","external_name":"anchor","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"LibYAML.yaml_alias_event_initialize(pointerof(@event), anchor)\nyaml_emit(\"alias\")\n"}},{"html_id":"close:Nil-instance-method","name":"close","doc":"Closes the builder, freeing up resources.","summary":"<p>Closes the builder, freeing up resources.</p>","abstract":false,"location":{"filename":"src/yaml/builder.cr","line_number":188,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"finalize\n@closed = true\n"}},{"html_id":"document(&)-instance-method","name":"document","doc":"Starts a document, invokes the block, and then ends it.","summary":"<p>Starts a document, invokes the block, and then ends it.</p>","abstract":false,"location":{"filename":"src/yaml/builder.cr","line_number":86,"url":null},"def":{"name":"document","yields":0,"visibility":"Public","body":"start_document\n(yield).tap do\n  end_document\nend\n"}},{"html_id":"end_document-instance-method","name":"end_document","doc":"Ends a document.","summary":"<p>Ends a document.</p>","abstract":false,"location":{"filename":"src/yaml/builder.cr","line_number":81,"url":null},"def":{"name":"end_document","visibility":"Public","body":"emit(document_end, 1)"}},{"html_id":"end_mapping:Nil-instance-method","name":"end_mapping","doc":"Ends a mapping.","summary":"<p>Ends a mapping.</p>","abstract":false,"location":{"filename":"src/yaml/builder.cr","line_number":125,"url":null},"def":{"name":"end_mapping","return_type":"Nil","visibility":"Public","body":"emit(mapping_end)\ndecrease_nesting\n"}},{"html_id":"end_sequence:Nil-instance-method","name":"end_sequence","doc":"Ends a sequence.","summary":"<p>Ends a sequence.</p>","abstract":false,"location":{"filename":"src/yaml/builder.cr","line_number":106,"url":null},"def":{"name":"end_sequence","return_type":"Nil","visibility":"Public","body":"emit(sequence_end)\ndecrease_nesting\n"}},{"html_id":"end_stream:Nil-instance-method","name":"end_stream","doc":"Ends a YAML stream.","summary":"<p>Ends a YAML stream.</p>","abstract":false,"location":{"filename":"src/yaml/builder.cr","line_number":64,"url":null},"def":{"name":"end_stream","return_type":"Nil","visibility":"Public","body":"emit(stream_end)\nflush\n"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/yaml/builder.cr","line_number":182,"url":null},"def":{"name":"finalize","visibility":"Public","body":"if @closed\n  return\nend\nLibYAML.yaml_emitter_delete(@emitter)\n"}},{"html_id":"flush-instance-method","name":"flush","doc":"Flushes any pending data to the underlying `IO`.","summary":"<p>Flushes any pending data to the underlying <code><a href=\"../IO.html\">IO</a></code>.</p>","abstract":false,"location":{"filename":"src/yaml/builder.cr","line_number":176,"url":null},"def":{"name":"flush","visibility":"Public","body":"LibYAML.yaml_emitter_flush(@emitter)\n@io.flush\n"}},{"html_id":"mapping(anchor:String?=nil,tag:String?=nil,style:YAML::MappingStyle=YAML::MappingStyle::ANY,&)-instance-method","name":"mapping","doc":"Starts a mapping, invokes the block, and then ends it.","summary":"<p>Starts a mapping, invokes the block, and then ends it.</p>","abstract":false,"args":[{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::MappingStyle::ANY","external_name":"style","restriction":"YAML::MappingStyle"}],"args_string":"(anchor : String? = nil, tag : String? = nil, style : YAML::MappingStyle = YAML::MappingStyle::ANY, &)","args_html":"(anchor : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, tag : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, style : <a href=\"../YAML/MappingStyle.html\">YAML::MappingStyle</a> = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">MappingStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>, &)","location":{"filename":"src/yaml/builder.cr","line_number":131,"url":null},"def":{"name":"mapping","args":[{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::MappingStyle::ANY","external_name":"style","restriction":"YAML::MappingStyle"}],"yields":0,"visibility":"Public","body":"start_mapping(anchor, tag, style)\n(yield).tap do\n  end_mapping\nend\n"}},{"html_id":"max_nesting:Int32-instance-method","name":"max_nesting","doc":"By default the maximum nesting of sequences/mappings is 99. Nesting more\nthan this will result in a YAML::Error. Changing the value of this property\nallows more/less nesting.","summary":"<p>By default the maximum nesting of sequences/mappings is 99.</p>","abstract":false,"location":{"filename":"src/yaml/builder.cr","line_number":32,"url":null},"def":{"name":"max_nesting","visibility":"Public","body":"@max_nesting"}},{"html_id":"max_nesting=(max_nesting)-instance-method","name":"max_nesting=","doc":"By default the maximum nesting of sequences/mappings is 99. Nesting more\nthan this will result in a YAML::Error. Changing the value of this property\nallows more/less nesting.","summary":"<p>By default the maximum nesting of sequences/mappings is 99.</p>","abstract":false,"args":[{"name":"max_nesting","external_name":"max_nesting","restriction":""}],"args_string":"(max_nesting)","args_html":"(max_nesting)","location":{"filename":"src/yaml/builder.cr","line_number":32,"url":null},"def":{"name":"max_nesting=","args":[{"name":"max_nesting","external_name":"max_nesting","restriction":""}],"visibility":"Public","body":"@max_nesting = max_nesting"}},{"html_id":"merge(anchor:String):Nil-instance-method","name":"merge","doc":"Emits the scalar `\"<<\"` followed by an alias to the given *anchor*.\n\nSee [YAML Merge](https://yaml.org/type/merge.html).\n\n```\nrequire \"yaml\"\n\nyaml = YAML.build do |builder|\n  builder.mapping do\n    builder.merge \"development\"\n  end\nend\n\nyaml # => \"---\\n<<: *development\\n\"\n```","summary":"<p>Emits the scalar <code>\"<<\"</code> followed by an alias to the given <em>anchor</em>.</p>","abstract":false,"args":[{"name":"anchor","external_name":"anchor","restriction":"String"}],"args_string":"(anchor : String) : Nil","args_html":"(anchor : <a href=\"../String.html\">String</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/yaml/builder.cr","line_number":170,"url":null},"def":{"name":"merge","args":[{"name":"anchor","external_name":"anchor","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"self.scalar(\"<<\")\nself.alias(anchor)\n"}},{"html_id":"scalar(value,anchor:String?=nil,tag:String?=nil,style:YAML::ScalarStyle=YAML::ScalarStyle::ANY)-instance-method","name":"scalar","doc":"Emits a scalar value.","summary":"<p>Emits a scalar value.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::ScalarStyle::ANY","external_name":"style","restriction":"YAML::ScalarStyle"}],"args_string":"(value, anchor : String? = nil, tag : String? = nil, style : YAML::ScalarStyle = YAML::ScalarStyle::ANY)","args_html":"(value, anchor : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, tag : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, style : <a href=\"../YAML/ScalarStyle.html\">YAML::ScalarStyle</a> = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">ScalarStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>)","location":{"filename":"src/yaml/builder.cr","line_number":92,"url":null},"def":{"name":"scalar","args":[{"name":"value","external_name":"value","restriction":""},{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::ScalarStyle::ANY","external_name":"style","restriction":"YAML::ScalarStyle"}],"visibility":"Public","body":"string = value.to_s\nimplicit = tag ? 0 : 1\nemit(scalar, get_anchor(anchor), string_to_unsafe(tag), string, string.bytesize, implicit, implicit, style)\n"}},{"html_id":"sequence(anchor:String?=nil,tag:String?=nil,style:YAML::SequenceStyle=YAML::SequenceStyle::ANY,&)-instance-method","name":"sequence","doc":"Starts a sequence, invokes the block, and the ends it.","summary":"<p>Starts a sequence, invokes the block, and the ends it.</p>","abstract":false,"args":[{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::SequenceStyle::ANY","external_name":"style","restriction":"YAML::SequenceStyle"}],"args_string":"(anchor : String? = nil, tag : String? = nil, style : YAML::SequenceStyle = YAML::SequenceStyle::ANY, &)","args_html":"(anchor : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, tag : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, style : <a href=\"../YAML/SequenceStyle.html\">YAML::SequenceStyle</a> = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">SequenceStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>, &)","location":{"filename":"src/yaml/builder.cr","line_number":112,"url":null},"def":{"name":"sequence","args":[{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::SequenceStyle::ANY","external_name":"style","restriction":"YAML::SequenceStyle"}],"yields":0,"visibility":"Public","body":"start_sequence(anchor, tag, style)\n(yield).tap do\n  end_sequence\nend\n"}},{"html_id":"start_document-instance-method","name":"start_document","doc":"Starts a document.","summary":"<p>Starts a document.</p>","abstract":false,"location":{"filename":"src/yaml/builder.cr","line_number":76,"url":null},"def":{"name":"start_document","visibility":"Public","body":"emit(document_start, nil, nil, nil, 0)"}},{"html_id":"start_mapping(anchor:String?=nil,tag:String?=nil,style:YAML::MappingStyle=YAML::MappingStyle::ANY):Nil-instance-method","name":"start_mapping","doc":"Starts a mapping.","summary":"<p>Starts a mapping.</p>","abstract":false,"args":[{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::MappingStyle::ANY","external_name":"style","restriction":"YAML::MappingStyle"}],"args_string":"(anchor : String? = nil, tag : String? = nil, style : YAML::MappingStyle = YAML::MappingStyle::ANY) : Nil","args_html":"(anchor : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, tag : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, style : <a href=\"../YAML/MappingStyle.html\">YAML::MappingStyle</a> = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">MappingStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/yaml/builder.cr","line_number":118,"url":null},"def":{"name":"start_mapping","args":[{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::MappingStyle::ANY","external_name":"style","restriction":"YAML::MappingStyle"}],"return_type":"Nil","visibility":"Public","body":"implicit = tag ? 0 : 1\nemit(mapping_start, get_anchor(anchor), string_to_unsafe(tag), implicit, style)\nincrease_nesting\n"}},{"html_id":"start_sequence(anchor:String?=nil,tag:String?=nil,style:YAML::SequenceStyle=YAML::SequenceStyle::ANY):Nil-instance-method","name":"start_sequence","doc":"Starts a sequence.","summary":"<p>Starts a sequence.</p>","abstract":false,"args":[{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::SequenceStyle::ANY","external_name":"style","restriction":"YAML::SequenceStyle"}],"args_string":"(anchor : String? = nil, tag : String? = nil, style : YAML::SequenceStyle = YAML::SequenceStyle::ANY) : Nil","args_html":"(anchor : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, tag : <a href=\"../String.html\">String</a>? = <span class=\"n\">nil</span>, style : <a href=\"../YAML/SequenceStyle.html\">YAML::SequenceStyle</a> = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">SequenceStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/yaml/builder.cr","line_number":99,"url":null},"def":{"name":"start_sequence","args":[{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::SequenceStyle::ANY","external_name":"style","restriction":"YAML::SequenceStyle"}],"return_type":"Nil","visibility":"Public","body":"implicit = tag ? 0 : 1\nemit(sequence_start, get_anchor(anchor), string_to_unsafe(tag), implicit, style)\nincrease_nesting\n"}},{"html_id":"start_stream-instance-method","name":"start_stream","doc":"Starts a YAML stream.","summary":"<p>Starts a YAML stream.</p>","abstract":false,"location":{"filename":"src/yaml/builder.cr","line_number":59,"url":null},"def":{"name":"start_stream","visibility":"Public","body":"emit(stream_start, LibYAML::Encoding::UTF8)"}},{"html_id":"stream(&)-instance-method","name":"stream","doc":"Starts a YAML stream, invokes the block, and ends it.","summary":"<p>Starts a YAML stream, invokes the block, and ends it.</p>","abstract":false,"location":{"filename":"src/yaml/builder.cr","line_number":70,"url":null},"def":{"name":"stream","yields":0,"visibility":"Public","body":"start_stream\n(yield).tap do\n  end_stream\nend\n"}}]},{"html_id":"Crystal/YAML/Error","path":"YAML/Error.html","kind":"class","full_name":"YAML::Error","name":"Error","abstract":false,"superclass":{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},"ancestors":[{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml.cr","line_number":78,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/YAML/ParseException","kind":"class","full_name":"YAML::ParseException","name":"ParseException"}],"namespace":{"html_id":"Crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"}},{"html_id":"Crystal/YAML/EventKind","path":"YAML/EventKind.html","kind":"enum","full_name":"YAML::EventKind","name":"EventKind","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml/enums.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"NONE","name":"NONE","value":"0"},{"id":"STREAM_START","name":"STREAM_START","value":"1"},{"id":"STREAM_END","name":"STREAM_END","value":"2"},{"id":"DOCUMENT_START","name":"DOCUMENT_START","value":"3"},{"id":"DOCUMENT_END","name":"DOCUMENT_END","value":"4"},{"id":"ALIAS","name":"ALIAS","value":"5"},{"id":"SCALAR","name":"SCALAR","value":"6"},{"id":"SEQUENCE_START","name":"SEQUENCE_START","value":"7"},{"id":"SEQUENCE_END","name":"SEQUENCE_END","value":"8"},{"id":"MAPPING_START","name":"MAPPING_START","value":"9"},{"id":"MAPPING_END","name":"MAPPING_END","value":"10"}],"namespace":{"html_id":"Crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"instance_methods":[{"html_id":"alias?-instance-method","name":"alias?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":8,"url":null},"def":{"name":"alias?","visibility":"Public","body":"self == ALIAS"}},{"html_id":"document_end?-instance-method","name":"document_end?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":7,"url":null},"def":{"name":"document_end?","visibility":"Public","body":"self == DOCUMENT_END"}},{"html_id":"document_start?-instance-method","name":"document_start?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":6,"url":null},"def":{"name":"document_start?","visibility":"Public","body":"self == DOCUMENT_START"}},{"html_id":"mapping_end?-instance-method","name":"mapping_end?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":13,"url":null},"def":{"name":"mapping_end?","visibility":"Public","body":"self == MAPPING_END"}},{"html_id":"mapping_start?-instance-method","name":"mapping_start?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":12,"url":null},"def":{"name":"mapping_start?","visibility":"Public","body":"self == MAPPING_START"}},{"html_id":"none?-instance-method","name":"none?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":3,"url":null},"def":{"name":"none?","visibility":"Public","body":"self == NONE"}},{"html_id":"scalar?-instance-method","name":"scalar?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":9,"url":null},"def":{"name":"scalar?","visibility":"Public","body":"self == SCALAR"}},{"html_id":"sequence_end?-instance-method","name":"sequence_end?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":11,"url":null},"def":{"name":"sequence_end?","visibility":"Public","body":"self == SEQUENCE_END"}},{"html_id":"sequence_start?-instance-method","name":"sequence_start?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":10,"url":null},"def":{"name":"sequence_start?","visibility":"Public","body":"self == SEQUENCE_START"}},{"html_id":"stream_end?-instance-method","name":"stream_end?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":5,"url":null},"def":{"name":"stream_end?","visibility":"Public","body":"self == STREAM_END"}},{"html_id":"stream_start?-instance-method","name":"stream_start?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":4,"url":null},"def":{"name":"stream_start?","visibility":"Public","body":"self == STREAM_START"}}]},{"html_id":"Crystal/YAML/Field","path":"YAML/Field.html","kind":"annotation","full_name":"YAML::Field","name":"Field","abstract":false,"locations":[{"filename":"src/yaml/serialization.cr","line_number":2,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"}},{"html_id":"Crystal/YAML/MappingStyle","path":"YAML/MappingStyle.html","kind":"enum","full_name":"YAML::MappingStyle","name":"MappingStyle","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml/enums.cr","line_number":31,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"ANY","name":"ANY","value":"0"},{"id":"BLOCK","name":"BLOCK","value":"1"},{"id":"FLOW","name":"FLOW","value":"2"}],"namespace":{"html_id":"Crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"instance_methods":[{"html_id":"any?-instance-method","name":"any?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":32,"url":null},"def":{"name":"any?","visibility":"Public","body":"self == ANY"}},{"html_id":"block?-instance-method","name":"block?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":33,"url":null},"def":{"name":"block?","visibility":"Public","body":"self == BLOCK"}},{"html_id":"flow?-instance-method","name":"flow?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":34,"url":null},"def":{"name":"flow?","visibility":"Public","body":"self == FLOW"}}]},{"html_id":"Crystal/YAML/Nodes","path":"YAML/Nodes.html","kind":"module","full_name":"YAML::Nodes","name":"Nodes","abstract":false,"locations":[{"filename":"src/yaml/nodes.cr","line_number":10,"url":null},{"filename":"src/yaml/nodes/nodes.cr","line_number":1,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":"The YAML::Nodes module provides an implementation of an\nin-memory YAML document tree. This tree can be generated\nwith the `YAML::Nodes.parse` method or created with a\n`YAML::Nodes::Builder`.\n\nThis document tree can then be converted to YAML be\ninvoking `to_yaml` on the document object.","summary":"<p>The YAML::Nodes module provides an implementation of an in-memory YAML document tree.</p>","class_methods":[{"html_id":"parse(string_or_io:String|IO):Document-class-method","name":"parse","doc":"Parses a `String` or `IO` into a `YAML::Document`.","summary":"<p>Parses a <code><a href=\"../String.html\">String</a></code> or <code><a href=\"../IO.html\">IO</a></code> into a <code>YAML::Document</code>.</p>","abstract":false,"args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"}],"args_string":"(string_or_io : String | IO) : Document","args_html":"(string_or_io : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>) : <a href=\"../YAML/Nodes/Document.html\">Document</a>","location":{"filename":"src/yaml/nodes.cr","line_number":12,"url":null},"def":{"name":"parse","args":[{"name":"string_or_io","external_name":"string_or_io","restriction":"String | IO"}],"return_type":"Document","visibility":"Public","body":"Parser.new(string_or_io, &.parse)"}}],"types":[{"html_id":"Crystal/YAML/Nodes/Alias","path":"YAML/Nodes/Alias.html","kind":"class","full_name":"YAML::Nodes::Alias","name":"Alias","abstract":false,"superclass":{"html_id":"Crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},"ancestors":[{"html_id":"Crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml/nodes/nodes.cr","line_number":156,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML/Nodes","kind":"module","full_name":"YAML::Nodes","name":"Nodes"},"doc":"An alias.","summary":"<p>An alias.</p>","constructors":[{"html_id":"new(anchor:String)-class-method","name":"new","doc":"Creates an alias with the given *anchor*.","summary":"<p>Creates an alias with the given <em>anchor</em>.</p>","abstract":false,"args":[{"name":"anchor","external_name":"anchor","restriction":"String"}],"args_string":"(anchor : String)","args_html":"(anchor : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":162,"url":null},"def":{"name":"new","args":[{"name":"anchor","external_name":"anchor","restriction":"String"}],"visibility":"Public","body":"_ = allocate\n_.initialize(anchor)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"kind:String-instance-method","name":"kind","doc":"Returns the kind of this node, which is equivalent to the class name.","summary":"<p>Returns the kind of this node, which is equivalent to the class name.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":169,"url":null},"def":{"name":"kind","return_type":"String","visibility":"Public","body":"\"alias\""}},{"html_id":"to_yaml(builder:YAML::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"builder","external_name":"builder","restriction":"YAML::Builder"}],"args_string":"(builder : YAML::Builder) : Nil","args_html":"(builder : <a href=\"../../YAML/Builder.html\">YAML::Builder</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":165,"url":null},"def":{"name":"to_yaml","args":[{"name":"builder","external_name":"builder","restriction":"YAML::Builder"}],"return_type":"Nil","visibility":"Public","body":"builder.alias(anchor.not_nil!)"}},{"html_id":"value:Node?-instance-method","name":"value","doc":"The node this alias points to.\nThis is set by `YAML::Nodes.parse`, and is `nil` by default.","summary":"<p>The node this alias points to.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":159,"url":null},"def":{"name":"value","return_type":"Node | ::Nil","visibility":"Public","body":"@value"}},{"html_id":"value=(value:Node?)-instance-method","name":"value=","doc":"The node this alias points to.\nThis is set by `YAML::Nodes.parse`, and is `nil` by default.","summary":"<p>The node this alias points to.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"Node | ::Nil"}],"args_string":"(value : Node?)","args_html":"(value : <a href=\"../../YAML/Nodes/Node.html\">Node</a>?)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":159,"url":null},"def":{"name":"value=","args":[{"name":"value","external_name":"value","restriction":"Node | ::Nil"}],"visibility":"Public","body":"@value = value"}}]},{"html_id":"Crystal/YAML/Nodes/Builder","path":"YAML/Nodes/Builder.html","kind":"class","full_name":"YAML::Nodes::Builder","name":"Builder","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml/nodes/builder.cr","line_number":12,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML/Nodes","kind":"module","full_name":"YAML::Nodes","name":"Nodes"},"doc":"Builds a tree of YAML nodes.\n\nThis builder is similar to `YAML::Builder`, but instead of\ndirectly emitting the output to an IO it builds a YAML document\ntree in memory.\n\nAll \"emitting\" methods support specifying a \"reference\" object\nthat will be associated to the emitted object,\nso that when that reference object is emitted again an anchor\nand an alias will be created. This generates both more compact\ndocuments and allows handling recursive data structures.","summary":"<p>Builds a tree of YAML nodes.</p>","constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/yaml/nodes/builder.cr","line_number":18,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"alias(anchor:String):Nil-instance-method","name":"alias","doc":"Emits an alias to the given *anchor*.\n\n```\nrequire \"yaml\"\n\nnodes_builder = YAML::Nodes::Builder.new\n\nnodes_builder.mapping do\n  nodes_builder.scalar \"foo\"\n  nodes_builder.alias \"key\"\nend\n\nyaml = YAML.build do |builder|\n  nodes_builder.document.to_yaml builder\nend\n\nyaml # => \"---\\nfoo: *key\\n\"\n```","summary":"<p>Emits an alias to the given <em>anchor</em>.</p>","abstract":false,"args":[{"name":"anchor","external_name":"anchor","restriction":"String"}],"args_string":"(anchor : String) : Nil","args_html":"(anchor : <a href=\"../../String.html\">String</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/yaml/nodes/builder.cr","line_number":43,"url":null},"def":{"name":"alias","args":[{"name":"anchor","external_name":"anchor","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"push_node(Alias.new(anchor))"}},{"html_id":"document:Document-instance-method","name":"document","doc":"The document this builder builds.","summary":"<p>The document this builder builds.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/builder.cr","line_number":16,"url":null},"def":{"name":"document","return_type":"Document","visibility":"Public","body":"@document"}},{"html_id":"mapping(anchor:String?=nil,tag:String?=nil,style:YAML::MappingStyle=YAML::MappingStyle::ANY,reference=nil,&):Nil-instance-method","name":"mapping","abstract":false,"args":[{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::MappingStyle::ANY","external_name":"style","restriction":"YAML::MappingStyle"},{"name":"reference","default_value":"nil","external_name":"reference","restriction":""}],"args_string":"(anchor : String? = nil, tag : String? = nil, style : YAML::MappingStyle = YAML::MappingStyle::ANY, reference = nil, &) : Nil","args_html":"(anchor : <a href=\"../../String.html\">String</a>? = <span class=\"n\">nil</span>, tag : <a href=\"../../String.html\">String</a>? = <span class=\"n\">nil</span>, style : <a href=\"../../YAML/MappingStyle.html\">YAML::MappingStyle</a> = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">MappingStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>, reference = <span class=\"n\">nil</span>, &) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/yaml/nodes/builder.cr","line_number":103,"url":null},"def":{"name":"mapping","args":[{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::MappingStyle::ANY","external_name":"style","restriction":"YAML::MappingStyle"},{"name":"reference","default_value":"nil","external_name":"reference","restriction":""}],"yields":0,"return_type":"Nil","visibility":"Public","body":"node = Mapping.new\nnode.anchor = anchor\nnode.tag = tag\nnode.style = style\nif register(reference, node)\n  return\nend\npush_to_stack(node) do\n  yield\nend\n"}},{"html_id":"merge(anchor:String):Nil-instance-method","name":"merge","doc":"Emits the scalar `\"<<\"` followed by an alias to the given *anchor*.\n\nSee [YAML Merge](https://yaml.org/type/merge.html).\n\n```\nrequire \"yaml\"\n\nnodes_builder = YAML::Nodes::Builder.new\n\nnodes_builder.mapping do\n  nodes_builder.merge \"key\"\nend\n\nyaml = YAML.build do |builder|\n  nodes_builder.document.to_yaml builder\nend\n\nyaml # => \"---\\n<<: *key\\n\"\n```","summary":"<p>Emits the scalar <code>\"<<\"</code> followed by an alias to the given <em>anchor</em>.</p>","abstract":false,"args":[{"name":"anchor","external_name":"anchor","restriction":"String"}],"args_string":"(anchor : String) : Nil","args_html":"(anchor : <a href=\"../../String.html\">String</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/yaml/nodes/builder.cr","line_number":66,"url":null},"def":{"name":"merge","args":[{"name":"anchor","external_name":"anchor","restriction":"String"}],"return_type":"Nil","visibility":"Public","body":"self.scalar(\"<<\")\nself.alias(anchor)\n"}},{"html_id":"scalar(value,anchor:String?=nil,tag:String?=nil,style:YAML::ScalarStyle=YAML::ScalarStyle::ANY,reference=nil):Nil-instance-method","name":"scalar","abstract":false,"args":[{"name":"value","external_name":"value","restriction":""},{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::ScalarStyle::ANY","external_name":"style","restriction":"YAML::ScalarStyle"},{"name":"reference","default_value":"nil","external_name":"reference","restriction":""}],"args_string":"(value, anchor : String? = nil, tag : String? = nil, style : YAML::ScalarStyle = YAML::ScalarStyle::ANY, reference = nil) : Nil","args_html":"(value, anchor : <a href=\"../../String.html\">String</a>? = <span class=\"n\">nil</span>, tag : <a href=\"../../String.html\">String</a>? = <span class=\"n\">nil</span>, style : <a href=\"../../YAML/ScalarStyle.html\">YAML::ScalarStyle</a> = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">ScalarStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>, reference = <span class=\"n\">nil</span>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/yaml/nodes/builder.cr","line_number":71,"url":null},"def":{"name":"scalar","args":[{"name":"value","external_name":"value","restriction":""},{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::ScalarStyle::ANY","external_name":"style","restriction":"YAML::ScalarStyle"},{"name":"reference","default_value":"nil","external_name":"reference","restriction":""}],"return_type":"Nil","visibility":"Public","body":"node = Scalar.new(value.to_s)\nnode.anchor = anchor\nnode.tag = tag\nnode.style = style\nif register(reference, node)\n  return\nend\npush_node(node)\n"}},{"html_id":"sequence(anchor:String?=nil,tag:String?=nil,style:YAML::SequenceStyle=YAML::SequenceStyle::ANY,reference=nil,&):Nil-instance-method","name":"sequence","abstract":false,"args":[{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::SequenceStyle::ANY","external_name":"style","restriction":"YAML::SequenceStyle"},{"name":"reference","default_value":"nil","external_name":"reference","restriction":""}],"args_string":"(anchor : String? = nil, tag : String? = nil, style : YAML::SequenceStyle = YAML::SequenceStyle::ANY, reference = nil, &) : Nil","args_html":"(anchor : <a href=\"../../String.html\">String</a>? = <span class=\"n\">nil</span>, tag : <a href=\"../../String.html\">String</a>? = <span class=\"n\">nil</span>, style : <a href=\"../../YAML/SequenceStyle.html\">YAML::SequenceStyle</a> = <span class=\"t\">YAML</span><span class=\"t\">::</span><span class=\"t\">SequenceStyle</span><span class=\"t\">::</span><span class=\"t\">ANY</span>, reference = <span class=\"n\">nil</span>, &) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/yaml/nodes/builder.cr","line_number":86,"url":null},"def":{"name":"sequence","args":[{"name":"anchor","default_value":"nil","external_name":"anchor","restriction":"String | ::Nil"},{"name":"tag","default_value":"nil","external_name":"tag","restriction":"String | ::Nil"},{"name":"style","default_value":"YAML::SequenceStyle::ANY","external_name":"style","restriction":"YAML::SequenceStyle"},{"name":"reference","default_value":"nil","external_name":"reference","restriction":""}],"yields":0,"return_type":"Nil","visibility":"Public","body":"node = Sequence.new\nnode.anchor = anchor\nnode.tag = tag\nnode.style = style\nif register(reference, node)\n  return\nend\npush_to_stack(node) do\n  yield\nend\n"}}]},{"html_id":"Crystal/YAML/Nodes/Document","path":"YAML/Nodes/Document.html","kind":"class","full_name":"YAML::Nodes::Document","name":"Document","abstract":false,"superclass":{"html_id":"Crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},"ancestors":[{"html_id":"Crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml/nodes/nodes.cr","line_number":38,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML/Nodes","kind":"module","full_name":"YAML::Nodes","name":"Nodes"},"doc":"A YAML document.","summary":"<p>A YAML document.</p>","instance_methods":[{"html_id":"<<(node)-instance-method","name":"<<","doc":"Appends a node to this document. Raises if more\nthan one node is appended.","summary":"<p>Appends a node to this document.</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":""}],"args_string":"(node)","args_html":"(node)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":46,"url":null},"def":{"name":"<<","args":[{"name":"node","external_name":"node","restriction":""}],"visibility":"Public","body":"if nodes.empty?\n  nodes << node\nelse\n  raise(ArgumentError.new(\"Attempted to append more than one node\"))\nend"}},{"html_id":"kind:String-instance-method","name":"kind","doc":"Returns the kind of this node, which is equivalent to the class name.","summary":"<p>Returns the kind of this node, which is equivalent to the class name.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":58,"url":null},"def":{"name":"kind","return_type":"String","visibility":"Public","body":"\"document\""}},{"html_id":"nodes:Array(YAML::Nodes::Node)-instance-method","name":"nodes","doc":"The nodes inside this document.\n\nA document can hold at most one node.","summary":"<p>The nodes inside this document.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":42,"url":null},"def":{"name":"nodes","visibility":"Public","body":"@nodes"}},{"html_id":"to_yaml(builder:YAML::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"builder","external_name":"builder","restriction":"YAML::Builder"}],"args_string":"(builder : YAML::Builder) : Nil","args_html":"(builder : <a href=\"../../YAML/Builder.html\">YAML::Builder</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":54,"url":null},"def":{"name":"to_yaml","args":[{"name":"builder","external_name":"builder","restriction":"YAML::Builder"}],"return_type":"Nil","visibility":"Public","body":"nodes.each(&.to_yaml(builder))"}}]},{"html_id":"Crystal/YAML/Nodes/Mapping","path":"YAML/Nodes/Mapping.html","kind":"class","full_name":"YAML::Nodes::Mapping","name":"Mapping","abstract":false,"superclass":{"html_id":"Crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},"ancestors":[{"html_id":"Crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml/nodes/nodes.cr","line_number":117,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML/Nodes","kind":"module","full_name":"YAML::Nodes","name":"Nodes"},"doc":"A mapping of nodes.","summary":"<p>A mapping of nodes.</p>","instance_methods":[{"html_id":"<<(node)-instance-method","name":"<<","doc":"Appends a single node into this mapping.","summary":"<p>Appends a single node into this mapping.</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":""}],"args_string":"(node)","args_html":"(node)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":130,"url":null},"def":{"name":"<<","args":[{"name":"node","external_name":"node","restriction":""}],"visibility":"Public","body":"@nodes << node"}},{"html_id":"[]=(key,value)-instance-method","name":"[]=","doc":"Appends two nodes into this mapping.","summary":"<p>Appends two nodes into this mapping.</p>","abstract":false,"args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":""}],"args_string":"(key, value)","args_html":"(key, value)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":125,"url":null},"def":{"name":"[]=","args":[{"name":"key","external_name":"key","restriction":""},{"name":"value","external_name":"value","restriction":""}],"visibility":"Public","body":"(@nodes << key) << value"}},{"html_id":"each(&)-instance-method","name":"each","doc":"Yields each key-value pair in this mapping.","summary":"<p>Yields each key-value pair in this mapping.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":135,"url":null},"def":{"name":"each","yields":1,"visibility":"Public","body":"0.step(by: 2, to: @nodes.size - 1) do |i|\n  yield({@nodes[i], @nodes[i + 1]})\nend"}},{"html_id":"kind:String-instance-method","name":"kind","doc":"Returns the kind of this node, which is equivalent to the class name.","summary":"<p>Returns the kind of this node, which is equivalent to the class name.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":150,"url":null},"def":{"name":"kind","return_type":"String","visibility":"Public","body":"\"mapping\""}},{"html_id":"nodes:Array(YAML::Nodes::Node)-instance-method","name":"nodes","doc":"The nodes inside this mapping, stored linearly\nas key1 - value1 - key2 - value2 - etc.","summary":"<p>The nodes inside this mapping, stored linearly as key1 - value1 - key2 - value2 - etc.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":122,"url":null},"def":{"name":"nodes","visibility":"Public","body":"@nodes"}},{"html_id":"style:MappingStyle-instance-method","name":"style","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":118,"url":null},"def":{"name":"style","return_type":"MappingStyle","visibility":"Public","body":"@style"}},{"html_id":"style=(style:MappingStyle)-instance-method","name":"style=","abstract":false,"args":[{"name":"style","external_name":"style","restriction":"MappingStyle"}],"args_string":"(style : MappingStyle)","args_html":"(style : <a href=\"../../YAML/MappingStyle.html\">MappingStyle</a>)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":118,"url":null},"def":{"name":"style=","args":[{"name":"style","external_name":"style","restriction":"MappingStyle"}],"visibility":"Public","body":"@style = style"}},{"html_id":"to_yaml(builder:YAML::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"builder","external_name":"builder","restriction":"YAML::Builder"}],"args_string":"(builder : YAML::Builder) : Nil","args_html":"(builder : <a href=\"../../YAML/Builder.html\">YAML::Builder</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":141,"url":null},"def":{"name":"to_yaml","args":[{"name":"builder","external_name":"builder","restriction":"YAML::Builder"}],"return_type":"Nil","visibility":"Public","body":"builder.mapping(anchor, tag, style) do\n  each do |key, value|\n    key.to_yaml(builder)\n    value.to_yaml(builder)\n  end\nend"}}]},{"html_id":"Crystal/YAML/Nodes/Node","path":"YAML/Nodes/Node.html","kind":"class","full_name":"YAML::Nodes::Node","name":"Node","abstract":true,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml/nodes/nodes.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"subclasses":[{"html_id":"Crystal/YAML/Nodes/Alias","kind":"class","full_name":"YAML::Nodes::Alias","name":"Alias"},{"html_id":"Crystal/YAML/Nodes/Document","kind":"class","full_name":"YAML::Nodes::Document","name":"Document"},{"html_id":"Crystal/YAML/Nodes/Mapping","kind":"class","full_name":"YAML::Nodes::Mapping","name":"Mapping"},{"html_id":"Crystal/YAML/Nodes/Scalar","kind":"class","full_name":"YAML::Nodes::Scalar","name":"Scalar"},{"html_id":"Crystal/YAML/Nodes/Sequence","kind":"class","full_name":"YAML::Nodes::Sequence","name":"Sequence"}],"namespace":{"html_id":"Crystal/YAML/Nodes","kind":"module","full_name":"YAML::Nodes","name":"Nodes"},"doc":"Abstract class of all YAML tree nodes.","summary":"<p>Abstract class of all YAML tree nodes.</p>","instance_methods":[{"html_id":"anchor:String?-instance-method","name":"anchor","doc":"The optional anchor of a node.","summary":"<p>The optional anchor of a node.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":8,"url":null},"def":{"name":"anchor","return_type":"String | ::Nil","visibility":"Public","body":"@anchor"}},{"html_id":"anchor=(anchor:String?)-instance-method","name":"anchor=","doc":"The optional anchor of a node.","summary":"<p>The optional anchor of a node.</p>","abstract":false,"args":[{"name":"anchor","external_name":"anchor","restriction":"String | ::Nil"}],"args_string":"(anchor : String?)","args_html":"(anchor : <a href=\"../../String.html\">String</a>?)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":8,"url":null},"def":{"name":"anchor=","args":[{"name":"anchor","external_name":"anchor","restriction":"String | ::Nil"}],"visibility":"Public","body":"@anchor = anchor"}},{"html_id":"end_column:Int32-instance-method","name":"end_column","doc":"The column where this node ends.","summary":"<p>The column where this node ends.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":20,"url":null},"def":{"name":"end_column","visibility":"Public","body":"@end_column"}},{"html_id":"end_column=(end_column)-instance-method","name":"end_column=","doc":"The column where this node ends.","summary":"<p>The column where this node ends.</p>","abstract":false,"args":[{"name":"end_column","external_name":"end_column","restriction":""}],"args_string":"(end_column)","args_html":"(end_column)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":20,"url":null},"def":{"name":"end_column=","args":[{"name":"end_column","external_name":"end_column","restriction":""}],"visibility":"Public","body":"@end_column = end_column"}},{"html_id":"end_line:Int32-instance-method","name":"end_line","doc":"The line where this node ends.","summary":"<p>The line where this node ends.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":17,"url":null},"def":{"name":"end_line","visibility":"Public","body":"@end_line"}},{"html_id":"end_line=(end_line)-instance-method","name":"end_line=","doc":"The line where this node ends.","summary":"<p>The line where this node ends.</p>","abstract":false,"args":[{"name":"end_line","external_name":"end_line","restriction":""}],"args_string":"(end_line)","args_html":"(end_line)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":17,"url":null},"def":{"name":"end_line=","args":[{"name":"end_line","external_name":"end_line","restriction":""}],"visibility":"Public","body":"@end_line = end_line"}},{"html_id":"kind:String-instance-method","name":"kind","doc":"Returns the kind of this node, which is equivalent to the class name.","summary":"<p>Returns the kind of this node, which is equivalent to the class name.</p>","abstract":true,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":34,"url":null},"def":{"name":"kind","return_type":"String","visibility":"Public","body":""}},{"html_id":"location:Tuple(Int32,Int32)-instance-method","name":"location","doc":"Returns a tuple of `start_line` and `start_column`.","summary":"<p>Returns a tuple of <code><a href=\"../../YAML/Nodes/Node.html#start_line%3AInt32-instance-method\">#start_line</a></code> and <code><a href=\"../../YAML/Nodes/Node.html#start_column%3AInt32-instance-method\">#start_column</a></code>.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":23,"url":null},"def":{"name":"location","return_type":"::Tuple(Int32, Int32)","visibility":"Public","body":"{start_line, start_column}"}},{"html_id":"raise(message):NoReturn-instance-method","name":"raise","doc":"Raises a `YAML::ParseException` with the given message\nlocated at this node's `location`.","summary":"<p>Raises a <code><a href=\"../../YAML/ParseException.html\">YAML::ParseException</a></code> with the given message located at this node's <code><a href=\"../../YAML/Nodes/Node.html#location%3ATuple%28Int32%2CInt32%29-instance-method\">#location</a></code>.</p>","abstract":false,"args":[{"name":"message","external_name":"message","restriction":""}],"args_string":"(message) : NoReturn","args_html":"(message) : NoReturn","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":29,"url":null},"def":{"name":"raise","args":[{"name":"message","external_name":"message","restriction":""}],"return_type":"NoReturn","visibility":"Public","body":"::raise(YAML::ParseException.new(message, *location))"}},{"html_id":"start_column:Int32-instance-method","name":"start_column","doc":"The column where this node starts.","summary":"<p>The column where this node starts.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":14,"url":null},"def":{"name":"start_column","visibility":"Public","body":"@start_column"}},{"html_id":"start_column=(start_column)-instance-method","name":"start_column=","doc":"The column where this node starts.","summary":"<p>The column where this node starts.</p>","abstract":false,"args":[{"name":"start_column","external_name":"start_column","restriction":""}],"args_string":"(start_column)","args_html":"(start_column)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":14,"url":null},"def":{"name":"start_column=","args":[{"name":"start_column","external_name":"start_column","restriction":""}],"visibility":"Public","body":"@start_column = start_column"}},{"html_id":"start_line:Int32-instance-method","name":"start_line","doc":"The line where this node starts.","summary":"<p>The line where this node starts.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":11,"url":null},"def":{"name":"start_line","visibility":"Public","body":"@start_line"}},{"html_id":"start_line=(start_line)-instance-method","name":"start_line=","doc":"The line where this node starts.","summary":"<p>The line where this node starts.</p>","abstract":false,"args":[{"name":"start_line","external_name":"start_line","restriction":""}],"args_string":"(start_line)","args_html":"(start_line)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":11,"url":null},"def":{"name":"start_line=","args":[{"name":"start_line","external_name":"start_line","restriction":""}],"visibility":"Public","body":"@start_line = start_line"}},{"html_id":"tag:String?-instance-method","name":"tag","doc":"The optional tag of a node.","summary":"<p>The optional tag of a node.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":5,"url":null},"def":{"name":"tag","return_type":"String | ::Nil","visibility":"Public","body":"@tag"}},{"html_id":"tag=(tag:String?)-instance-method","name":"tag=","doc":"The optional tag of a node.","summary":"<p>The optional tag of a node.</p>","abstract":false,"args":[{"name":"tag","external_name":"tag","restriction":"String | ::Nil"}],"args_string":"(tag : String?)","args_html":"(tag : <a href=\"../../String.html\">String</a>?)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":5,"url":null},"def":{"name":"tag=","args":[{"name":"tag","external_name":"tag","restriction":"String | ::Nil"}],"visibility":"Public","body":"@tag = tag"}}]},{"html_id":"Crystal/YAML/Nodes/Scalar","path":"YAML/Nodes/Scalar.html","kind":"class","full_name":"YAML::Nodes::Scalar","name":"Scalar","abstract":false,"superclass":{"html_id":"Crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},"ancestors":[{"html_id":"Crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml/nodes/nodes.cr","line_number":64,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML/Nodes","kind":"module","full_name":"YAML::Nodes","name":"Nodes"},"doc":"A scalar value.","summary":"<p>A scalar value.</p>","constructors":[{"html_id":"new(value:String)-class-method","name":"new","doc":"Creates a scalar with the given *value*.","summary":"<p>Creates a scalar with the given <em>value</em>.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(value : String)","args_html":"(value : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":72,"url":null},"def":{"name":"new","args":[{"name":"value","external_name":"value","restriction":"String"}],"visibility":"Public","body":"_ = allocate\n_.initialize(value)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"kind:String-instance-method","name":"kind","doc":"Returns the kind of this node, which is equivalent to the class name.","summary":"<p>Returns the kind of this node, which is equivalent to the class name.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":79,"url":null},"def":{"name":"kind","return_type":"String","visibility":"Public","body":"\"scalar\""}},{"html_id":"style:ScalarStyle-instance-method","name":"style","doc":"The style of this scalar.","summary":"<p>The style of this scalar.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":66,"url":null},"def":{"name":"style","return_type":"ScalarStyle","visibility":"Public","body":"@style"}},{"html_id":"style=(style:ScalarStyle)-instance-method","name":"style=","doc":"The style of this scalar.","summary":"<p>The style of this scalar.</p>","abstract":false,"args":[{"name":"style","external_name":"style","restriction":"ScalarStyle"}],"args_string":"(style : ScalarStyle)","args_html":"(style : <a href=\"../../YAML/ScalarStyle.html\">ScalarStyle</a>)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":66,"url":null},"def":{"name":"style=","args":[{"name":"style","external_name":"style","restriction":"ScalarStyle"}],"visibility":"Public","body":"@style = style"}},{"html_id":"to_yaml(builder:YAML::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"builder","external_name":"builder","restriction":"YAML::Builder"}],"args_string":"(builder : YAML::Builder) : Nil","args_html":"(builder : <a href=\"../../YAML/Builder.html\">YAML::Builder</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":75,"url":null},"def":{"name":"to_yaml","args":[{"name":"builder","external_name":"builder","restriction":"YAML::Builder"}],"return_type":"Nil","visibility":"Public","body":"builder.scalar(value, anchor, tag, style)"}},{"html_id":"value:String-instance-method","name":"value","doc":"The value of this scalar.","summary":"<p>The value of this scalar.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":69,"url":null},"def":{"name":"value","return_type":"String","visibility":"Public","body":"@value"}},{"html_id":"value=(value:String)-instance-method","name":"value=","doc":"The value of this scalar.","summary":"<p>The value of this scalar.</p>","abstract":false,"args":[{"name":"value","external_name":"value","restriction":"String"}],"args_string":"(value : String)","args_html":"(value : <a href=\"../../String.html\">String</a>)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":69,"url":null},"def":{"name":"value=","args":[{"name":"value","external_name":"value","restriction":"String"}],"visibility":"Public","body":"@value = value"}}]},{"html_id":"Crystal/YAML/Nodes/Sequence","path":"YAML/Nodes/Sequence.html","kind":"class","full_name":"YAML::Nodes::Sequence","name":"Sequence","abstract":false,"superclass":{"html_id":"Crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},"ancestors":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"},{"html_id":"Crystal/YAML/Nodes/Node","kind":"class","full_name":"YAML::Nodes::Node","name":"Node"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml/nodes/nodes.cr","line_number":85,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"included_modules":[{"html_id":"Crystal/Enumerable","kind":"module","full_name":"Enumerable","name":"Enumerable"}],"namespace":{"html_id":"Crystal/YAML/Nodes","kind":"module","full_name":"YAML::Nodes","name":"Nodes"},"doc":"A sequence of nodes.","summary":"<p>A sequence of nodes.</p>","instance_methods":[{"html_id":"<<(node)-instance-method","name":"<<","doc":"Appends a node into this sequence.","summary":"<p>Appends a node into this sequence.</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":""}],"args_string":"(node)","args_html":"(node)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":95,"url":null},"def":{"name":"<<","args":[{"name":"node","external_name":"node","restriction":""}],"visibility":"Public","body":"@nodes << node"}},{"html_id":"each(&)-instance-method","name":"each","doc":"Must yield this collection's elements to the block.","summary":"<p>Must yield this collection's elements to the block.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":99,"url":null},"def":{"name":"each","yields":1,"visibility":"Public","body":"@nodes.each do |node|\n  yield node\nend"}},{"html_id":"kind:String-instance-method","name":"kind","doc":"Returns the kind of this node, which is equivalent to the class name.","summary":"<p>Returns the kind of this node, which is equivalent to the class name.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":111,"url":null},"def":{"name":"kind","return_type":"String","visibility":"Public","body":"\"sequence\""}},{"html_id":"nodes:Array(YAML::Nodes::Node)-instance-method","name":"nodes","doc":"The nodes in this sequence.","summary":"<p>The nodes in this sequence.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":89,"url":null},"def":{"name":"nodes","visibility":"Public","body":"@nodes"}},{"html_id":"style:SequenceStyle-instance-method","name":"style","doc":"The style of this sequence.","summary":"<p>The style of this sequence.</p>","abstract":false,"location":{"filename":"src/yaml/nodes/nodes.cr","line_number":92,"url":null},"def":{"name":"style","return_type":"SequenceStyle","visibility":"Public","body":"@style"}},{"html_id":"style=(style:SequenceStyle)-instance-method","name":"style=","doc":"The style of this sequence.","summary":"<p>The style of this sequence.</p>","abstract":false,"args":[{"name":"style","external_name":"style","restriction":"SequenceStyle"}],"args_string":"(style : SequenceStyle)","args_html":"(style : <a href=\"../../YAML/SequenceStyle.html\">SequenceStyle</a>)","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":92,"url":null},"def":{"name":"style=","args":[{"name":"style","external_name":"style","restriction":"SequenceStyle"}],"visibility":"Public","body":"@style = style"}},{"html_id":"to_yaml(builder:YAML::Builder):Nil-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"builder","external_name":"builder","restriction":"YAML::Builder"}],"args_string":"(builder : YAML::Builder) : Nil","args_html":"(builder : <a href=\"../../YAML/Builder.html\">YAML::Builder</a>) : <a href=\"../../Nil.html\">Nil</a>","location":{"filename":"src/yaml/nodes/nodes.cr","line_number":105,"url":null},"def":{"name":"to_yaml","args":[{"name":"builder","external_name":"builder","restriction":"YAML::Builder"}],"return_type":"Nil","visibility":"Public","body":"builder.sequence(anchor, tag, style) do\n  each(&.to_yaml(builder))\nend"}}]}]},{"html_id":"Crystal/YAML/ParseContext","path":"YAML/ParseContext.html","kind":"class","full_name":"YAML::ParseContext","name":"ParseContext","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml/parse_context.cr","line_number":11,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":"Parsing context that holds anchors and what they refer to.\n\nWhen implementing `new(ctx : YAML::ParseContext, node : YAML::Nodes::Node)`\nto deserialize an object from a node, `Reference` types must invoke\nboth `read_alias` and `record_anchor` in order to support parsing\nrecursive data structures.\n\n- `read_alias` must be invoked before an instance is created\n- `record_anchor` must be invoked after an instance is created and\n  before its members are deserialized.","summary":"<p>Parsing context that holds anchors and what they refer to.</p>","constructors":[{"html_id":"new-class-method","name":"new","abstract":false,"location":{"filename":"src/yaml/parse_context.cr","line_number":12,"url":null},"def":{"name":"new","visibility":"Public","body":"_ = allocate\n_.initialize\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"read_alias(node,type:T.class,&)forallT-instance-method","name":"read_alias","doc":"Tries to read an alias from `node` of type `T`. Invokes\nthe block if successful, and invokers must return this object\ninstead of deserializing their members.","summary":"<p>Tries to read an alias from <code>node</code> of type <code>T</code>.</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":""},{"name":"type","external_name":"type","restriction":"T.class"}],"args_string":"(node, type : T.class, &) forall T","args_html":"(node, type : <span class=\"t\">T</span>.<span class=\"k\">class</span>, &) forall T","location":{"filename":"src/yaml/parse_context.cr","line_number":33,"url":null},"def":{"name":"read_alias","args":[{"name":"node","external_name":"node","restriction":""},{"name":"type","external_name":"type","restriction":"T.class"}],"yields":1,"visibility":"Public","body":"if ptr = read_alias_impl(node, T.crystal_instance_type_id, raise_on_alias: true)\n  yield ptr.unsafe_as(T)\nend"}},{"html_id":"read_alias?(node,type:T.class,&)forallT-instance-method","name":"read_alias?","doc":"Similar to `read_alias` but doesn't raise if an alias exists\nbut an instance of type T isn't associated with the current anchor.","summary":"<p>Similar to <code><a href=\"../YAML/ParseContext.html#read_alias%28node%2Ctype%3AT.class%2C%26%29forallT-instance-method\">#read_alias</a></code> but doesn't raise if an alias exists but an instance of type T isn't associated with the current anchor.</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":""},{"name":"type","external_name":"type","restriction":"T.class"}],"args_string":"(node, type : T.class, &) forall T","args_html":"(node, type : <span class=\"t\">T</span>.<span class=\"k\">class</span>, &) forall T","location":{"filename":"src/yaml/parse_context.cr","line_number":41,"url":null},"def":{"name":"read_alias?","args":[{"name":"node","external_name":"node","restriction":""},{"name":"type","external_name":"type","restriction":"T.class"}],"yields":1,"visibility":"Public","body":"if ptr = read_alias_impl(node, T.crystal_instance_type_id, raise_on_alias: false)\n  yield ptr.unsafe_as(T)\nend"}},{"html_id":"record_anchor(node,object:T):NilforallT-instance-method","name":"record_anchor","doc":"Associates an object with an anchor.","summary":"<p>Associates an object with an anchor.</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":""},{"name":"object","external_name":"object","restriction":"T"}],"args_string":"(node, object : T) : Nil forall T","args_html":"(node, object : T) : <a href=\"../Nil.html\">Nil</a> forall T","location":{"filename":"src/yaml/parse_context.cr","line_number":18,"url":null},"def":{"name":"record_anchor","args":[{"name":"node","external_name":"node","restriction":""},{"name":"object","external_name":"object","restriction":"T"}],"return_type":"Nil","visibility":"Public","body":"if object.is_a?(Reference)\nelse\n  return\nend\nrecord_anchor(node.anchor, object.object_id, object.crystal_type_id)\n"}}]},{"html_id":"Crystal/YAML/ParseException","path":"YAML/ParseException.html","kind":"class","full_name":"YAML::ParseException","name":"ParseException","abstract":false,"superclass":{"html_id":"Crystal/YAML/Error","kind":"class","full_name":"YAML::Error","name":"Error"},"ancestors":[{"html_id":"Crystal/YAML/Error","kind":"class","full_name":"YAML::Error","name":"Error"},{"html_id":"Crystal/Exception","kind":"class","full_name":"Exception","name":"Exception"},{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml.cr","line_number":82,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":"Exception thrown on a YAML parse error.","summary":"<p>Exception thrown on a YAML parse error.</p>","constructors":[{"html_id":"new(message,line_number,column_number,context_info=nil)-class-method","name":"new","abstract":false,"args":[{"name":"message","external_name":"message","restriction":""},{"name":"line_number","external_name":"line_number","restriction":""},{"name":"column_number","external_name":"column_number","restriction":""},{"name":"context_info","default_value":"nil","external_name":"context_info","restriction":""}],"args_string":"(message, line_number, column_number, context_info = nil)","args_html":"(message, line_number, column_number, context_info = <span class=\"n\">nil</span>)","location":{"filename":"src/yaml.cr","line_number":86,"url":null},"def":{"name":"new","args":[{"name":"message","external_name":"message","restriction":""},{"name":"line_number","external_name":"line_number","restriction":""},{"name":"column_number","external_name":"column_number","restriction":""},{"name":"context_info","default_value":"nil","external_name":"context_info","restriction":""}],"visibility":"Public","body":"_ = allocate\n_.initialize(message, line_number, column_number, context_info)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"column_number:Int32-instance-method","name":"column_number","abstract":false,"location":{"filename":"src/yaml.cr","line_number":84,"url":null},"def":{"name":"column_number","return_type":"Int32","visibility":"Public","body":"@column_number"}},{"html_id":"line_number:Int32-instance-method","name":"line_number","abstract":false,"location":{"filename":"src/yaml.cr","line_number":83,"url":null},"def":{"name":"line_number","return_type":"Int32","visibility":"Public","body":"@line_number"}},{"html_id":"location:Tuple(Int32,Int32)-instance-method","name":"location","abstract":false,"location":{"filename":"src/yaml.cr","line_number":97,"url":null},"def":{"name":"location","return_type":"::Tuple(Int32, Int32)","visibility":"Public","body":"{line_number, column_number}"}}]},{"html_id":"Crystal/YAML/PullParser","path":"YAML/PullParser.html","kind":"class","full_name":"YAML::PullParser","name":"PullParser","abstract":false,"superclass":{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},"ancestors":[{"html_id":"Crystal/Reference","kind":"class","full_name":"Reference","name":"Reference"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml/pull_parser.cr","line_number":10,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":"A pull parser allows parsing a YAML document by events.\n\nWhen creating an instance, the parser is positioned in\nthe first event. To get the event kind invoke `kind`.\nIf the event is a scalar you can invoke `value` to get\nits **string** value. Other methods like `tag`, `anchor`\nand `scalar_style` let you inspect other information from events.\n\nInvoking `read_next` reads the next event.","summary":"<p>A pull parser allows parsing a YAML document by events.</p>","constructors":[{"html_id":"new(content:String|IO)-class-method","name":"new","abstract":false,"args":[{"name":"content","external_name":"content","restriction":"String | IO"}],"args_string":"(content : String | IO)","args_html":"(content : <a href=\"../String.html\">String</a> | <a href=\"../IO.html\">IO</a>)","location":{"filename":"src/yaml/pull_parser.cr","line_number":13,"url":null},"def":{"name":"new","args":[{"name":"content","external_name":"content","restriction":"String | IO"}],"visibility":"Public","body":"_ = allocate\n_.initialize(content)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}},{"html_id":"new(content,&)-class-method","name":"new","doc":"Creates a parser, yields it to the block, and closes\nthe parser at the end of it.","summary":"<p>Creates a parser, yields it to the block, and closes the parser at the end of it.</p>","abstract":false,"args":[{"name":"content","external_name":"content","restriction":""}],"args_string":"(content, &)","args_html":"(content, &)","location":{"filename":"src/yaml/pull_parser.cr","line_number":39,"url":null},"def":{"name":"new","args":[{"name":"content","external_name":"content","restriction":""}],"yields":1,"visibility":"Public","body":"parser = new(content)\nbegin\n  yield parser\nensure\n  parser.close\nend\n"}}],"instance_methods":[{"html_id":"anchor:String?-instance-method","name":"anchor","doc":"Returns the anchor associated to the current event, or `nil`\nif there's no anchor.","summary":"<p>Returns the anchor associated to the current event, or <code>nil</code> if there's no anchor.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":76,"url":null},"def":{"name":"anchor","return_type":"String | ::Nil","visibility":"Public","body":"case kind\nwhen .scalar?\n  read_anchor(@event.data.scalar.anchor)\nwhen .sequence_start?\n  read_anchor(@event.data.sequence_start.anchor)\nwhen .mapping_start?\n  read_anchor(@event.data.mapping_start.anchor)\nwhen .alias?\n  read_anchor(@event.data.alias.anchor)\nelse\n  nil\nend"}},{"html_id":"close:Nil-instance-method","name":"close","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":324,"url":null},"def":{"name":"close","return_type":"Nil","visibility":"Public","body":"finalize\n@closed = true\n"}},{"html_id":"end_column:Int32-instance-method","name":"end_column","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":279,"url":null},"def":{"name":"end_column","return_type":"Int32","visibility":"Public","body":"@event.end_mark.column.to_i32 + 1"}},{"html_id":"end_line:Int32-instance-method","name":"end_line","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":275,"url":null},"def":{"name":"end_line","return_type":"Int32","visibility":"Public","body":"@event.end_mark.line.to_i32 + 1"}},{"html_id":"expect_kind(kind:EventKind):Nil-instance-method","name":"expect_kind","doc":"Raises if the current kind is not the expected one.","summary":"<p>Raises if the current kind is not the expected one.</p>","abstract":false,"args":[{"name":"kind","external_name":"kind","restriction":"EventKind"}],"args_string":"(kind : EventKind) : Nil","args_html":"(kind : <a href=\"../YAML/EventKind.html\">EventKind</a>) : <a href=\"../Nil.html\">Nil</a>","location":{"filename":"src/yaml/pull_parser.cr","line_number":330,"url":null},"def":{"name":"expect_kind","args":[{"name":"kind","external_name":"kind","restriction":"EventKind"}],"return_type":"Nil","visibility":"Public","body":"if kind == self.kind\nelse\n  raise(\"Expected #{kind} but was #{self.kind}\")\nend"}},{"html_id":"finalize-instance-method","name":"finalize","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":317,"url":null},"def":{"name":"finalize","visibility":"Public","body":"if @closed\n  return\nend\nLibYAML.yaml_parser_delete(@parser)\nLibYAML.yaml_event_delete(pointerof(@event))\n"}},{"html_id":"kind:EventKind-instance-method","name":"kind","doc":"The current event kind.","summary":"<p>The current event kind.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":45,"url":null},"def":{"name":"kind","return_type":"EventKind","visibility":"Public","body":"@event.type"}},{"html_id":"location:Tuple(Int32,Int32)-instance-method","name":"location","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":263,"url":null},"def":{"name":"location","return_type":"::Tuple(Int32, Int32)","visibility":"Public","body":"{start_line, start_column}"}},{"html_id":"mapping_style:MappingStyle-instance-method","name":"mapping_style","doc":"Returns the mapping style, assuming the pull parser is located\nat a mapping begin event. Raises otherwise.","summary":"<p>Returns the mapping style, assuming the pull parser is located at a mapping begin event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":100,"url":null},"def":{"name":"mapping_style","return_type":"MappingStyle","visibility":"Public","body":"expect_kind(EventKind::MAPPING_START)\n@event.data.mapping_start.style\n"}},{"html_id":"raise(msg:String,line_number=self.start_line,column_number=self.start_column,context_info=nil):NoReturn-instance-method","name":"raise","abstract":false,"args":[{"name":"msg","external_name":"msg","restriction":"String"},{"name":"line_number","default_value":"self.start_line","external_name":"line_number","restriction":""},{"name":"column_number","default_value":"self.start_column","external_name":"column_number","restriction":""},{"name":"context_info","default_value":"nil","external_name":"context_info","restriction":""}],"args_string":"(msg : String, line_number = self.start_line, column_number = self.start_column, context_info = nil) : NoReturn","args_html":"(msg : <a href=\"../String.html\">String</a>, line_number = <span class=\"k\">self</span>.start_line, column_number = <span class=\"k\">self</span>.start_column, context_info = <span class=\"n\">nil</span>) : NoReturn","location":{"filename":"src/yaml/pull_parser.cr","line_number":338,"url":null},"def":{"name":"raise","args":[{"name":"msg","external_name":"msg","restriction":"String"},{"name":"line_number","default_value":"self.start_line","external_name":"line_number","restriction":""},{"name":"column_number","default_value":"self.start_column","external_name":"column_number","restriction":""},{"name":"context_info","default_value":"nil","external_name":"context_info","restriction":""}],"return_type":"NoReturn","visibility":"Public","body":"::raise(ParseException.new(msg, line_number, column_number, context_info))"}},{"html_id":"read(expected_kind:EventKind):EventKind-instance-method","name":"read","doc":"Reads an expected event kind.","summary":"<p>Reads an expected event kind.</p>","abstract":false,"args":[{"name":"expected_kind","external_name":"expected_kind","restriction":"EventKind"}],"args_string":"(expected_kind : EventKind) : EventKind","args_html":"(expected_kind : <a href=\"../YAML/EventKind.html\">EventKind</a>) : <a href=\"../YAML/EventKind.html\">EventKind</a>","location":{"filename":"src/yaml/pull_parser.cr","line_number":220,"url":null},"def":{"name":"read","args":[{"name":"expected_kind","external_name":"expected_kind","restriction":"EventKind"}],"return_type":"EventKind","visibility":"Public","body":"expect_kind(expected_kind)\nread_next\n"}},{"html_id":"read_alias:String?-instance-method","name":"read_alias","doc":"Reads an alias event, returning its anchor.","summary":"<p>Reads an alias event, returning its anchor.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":164,"url":null},"def":{"name":"read_alias","return_type":"String | ::Nil","visibility":"Public","body":"expect_kind(EventKind::ALIAS)\nanchor = self.anchor\nread_next\nanchor\n"}},{"html_id":"read_document(&)-instance-method","name":"read_document","doc":"Reads a \"document start\" event, yields to the block,\nand then reads a \"document end\" event.","summary":"<p>Reads a &quot;document start&quot; event, yields to the block, and then reads a &quot;document end&quot; event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":138,"url":null},"def":{"name":"read_document","yields":0,"visibility":"Public","body":"read_document_start\nvalue = yield\nread_document_end\nvalue\n"}},{"html_id":"read_document_end-instance-method","name":"read_document_end","doc":"Reads a \"document end\" event.","summary":"<p>Reads a &quot;document end&quot; event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":195,"url":null},"def":{"name":"read_document_end","visibility":"Public","body":"read(EventKind::DOCUMENT_END)"}},{"html_id":"read_document_start-instance-method","name":"read_document_start","doc":"Reads a \"document start\" event.","summary":"<p>Reads a &quot;document start&quot; event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":190,"url":null},"def":{"name":"read_document_start","visibility":"Public","body":"read(EventKind::DOCUMENT_START)"}},{"html_id":"read_mapping(&)-instance-method","name":"read_mapping","doc":"Reads a \"mapping start\" event, yields to the block,\nand then reads a \"mapping end\" event.","summary":"<p>Reads a &quot;mapping start&quot; event, yields to the block, and then reads a &quot;mapping end&quot; event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":156,"url":null},"def":{"name":"read_mapping","yields":0,"visibility":"Public","body":"read_mapping_start\nvalue = yield\nread_mapping_end\nvalue\n"}},{"html_id":"read_mapping_end-instance-method","name":"read_mapping_end","doc":"Reads a \"mapping end\" event.","summary":"<p>Reads a &quot;mapping end&quot; event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":215,"url":null},"def":{"name":"read_mapping_end","visibility":"Public","body":"read(EventKind::MAPPING_END)"}},{"html_id":"read_mapping_start-instance-method","name":"read_mapping_start","doc":"Reads a \"mapping start\" event.","summary":"<p>Reads a &quot;mapping start&quot; event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":210,"url":null},"def":{"name":"read_mapping_start","visibility":"Public","body":"read(EventKind::MAPPING_START)"}},{"html_id":"read_next:EventKind-instance-method","name":"read_next","doc":"Reads the next event.","summary":"<p>Reads the next event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":113,"url":null},"def":{"name":"read_next","return_type":"EventKind","visibility":"Public","body":"LibYAML.yaml_event_delete(pointerof(@event))\nLibYAML.yaml_parser_parse(@parser, pointerof(@event))\nif problem = problem?\n  msg = String.new(problem)\n  location = {problem_line_number, problem_column_number}\n  if context = context?\n    context_info = {String.new(context), context_line_number, context_column_number}\n  end\n  raise(msg, *location, context_info)\nend\nkind\n"}},{"html_id":"read_scalar:String-instance-method","name":"read_scalar","doc":"Reads a scalar, returning its value.","summary":"<p>Reads a scalar, returning its value.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":172,"url":null},"def":{"name":"read_scalar","return_type":"String","visibility":"Public","body":"expect_kind(EventKind::SCALAR)\nvalue = self.value\nread_next\nvalue\n"}},{"html_id":"read_sequence(&)-instance-method","name":"read_sequence","doc":"Reads a \"sequence start\" event, yields to the block,\nand then reads a \"sequence end\" event.","summary":"<p>Reads a &quot;sequence start&quot; event, yields to the block, and then reads a &quot;sequence end&quot; event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":147,"url":null},"def":{"name":"read_sequence","yields":0,"visibility":"Public","body":"read_sequence_start\nvalue = yield\nread_sequence_end\nvalue\n"}},{"html_id":"read_sequence_end-instance-method","name":"read_sequence_end","doc":"Reads a \"sequence end\" event.","summary":"<p>Reads a &quot;sequence end&quot; event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":205,"url":null},"def":{"name":"read_sequence_end","visibility":"Public","body":"read(EventKind::SEQUENCE_END)"}},{"html_id":"read_sequence_start-instance-method","name":"read_sequence_start","doc":"Reads a \"sequence start\" event.","summary":"<p>Reads a &quot;sequence start&quot; event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":200,"url":null},"def":{"name":"read_sequence_start","visibility":"Public","body":"read(EventKind::SEQUENCE_START)"}},{"html_id":"read_stream(&)-instance-method","name":"read_stream","doc":"Reads a \"stream start\" event, yields to the block,\nand then reads a \"stream end\" event.","summary":"<p>Reads a &quot;stream start&quot; event, yields to the block, and then reads a &quot;stream end&quot; event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":129,"url":null},"def":{"name":"read_stream","yields":0,"visibility":"Public","body":"read_stream_start\nvalue = yield\nread_stream_end\nvalue\n"}},{"html_id":"read_stream_end-instance-method","name":"read_stream_end","doc":"Reads a \"stream end\" event.","summary":"<p>Reads a &quot;stream end&quot; event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":185,"url":null},"def":{"name":"read_stream_end","visibility":"Public","body":"read(EventKind::STREAM_END)"}},{"html_id":"read_stream_start-instance-method","name":"read_stream_start","doc":"Reads a \"stream start\" event.","summary":"<p>Reads a &quot;stream start&quot; event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":180,"url":null},"def":{"name":"read_stream_start","visibility":"Public","body":"read(EventKind::STREAM_START)"}},{"html_id":"scalar_style:ScalarStyle-instance-method","name":"scalar_style","doc":"Returns the scalar style, assuming the pull parser is located\nat a scalar event. Raises otherwise.","summary":"<p>Returns the scalar style, assuming the pull parser is located at a scalar event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":107,"url":null},"def":{"name":"scalar_style","return_type":"ScalarStyle","visibility":"Public","body":"expect_kind(EventKind::SCALAR)\n@event.data.scalar.style\n"}},{"html_id":"sequence_style:SequenceStyle-instance-method","name":"sequence_style","doc":"Returns the sequence style, assuming the pull parser is located\nat a sequence begin event. Raises otherwise.","summary":"<p>Returns the sequence style, assuming the pull parser is located at a sequence begin event.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":93,"url":null},"def":{"name":"sequence_style","return_type":"SequenceStyle","visibility":"Public","body":"expect_kind(EventKind::SEQUENCE_START)\n@event.data.sequence_start.style\n"}},{"html_id":"skip:YAML::EventKind-instance-method","name":"skip","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":225,"url":null},"def":{"name":"skip","return_type":"YAML::EventKind","visibility":"Public","body":"case kind\nwhen .scalar?\n  read_next\nwhen .alias?\n  read_next\nwhen .sequence_start?\n  read_next\n  while !kind.sequence_end?\n    skip\n  end\n  read_next\nwhen .mapping_start?\n  read_next\n  while !kind.mapping_end?\n    skip\n    skip\n  end\n  read_next\nwhen .document_start?\n  read_next\n  while !kind.document_end?\n    skip\n  end\n  read_next\nwhen .stream_start?\n  read_next\n  while !kind.stream_end?\n    skip\n  end\n  read_next\nelse\n  read_next\nend"}},{"html_id":"start_column:Int32-instance-method","name":"start_column","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":271,"url":null},"def":{"name":"start_column","return_type":"Int32","visibility":"Public","body":"@event.start_mark.column.to_i32 + 1"}},{"html_id":"start_line:Int32-instance-method","name":"start_line","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":267,"url":null},"def":{"name":"start_line","return_type":"Int32","visibility":"Public","body":"@event.start_mark.line.to_i32 + 1"}},{"html_id":"tag:String?-instance-method","name":"tag","doc":"Returns the tag associated to the current event, or `nil`\nif there's no tag.","summary":"<p>Returns the tag associated to the current event, or <code>nil</code> if there's no tag.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":51,"url":null},"def":{"name":"tag","return_type":"String | ::Nil","visibility":"Public","body":"case kind\nwhen .mapping_start?\n  ptr = @event.data.mapping_start.tag\nwhen .sequence_start?\n  ptr = @event.data.sequence_start.tag\nwhen .scalar?\n  ptr = @event.data.scalar.tag\nelse\nend\nptr ? String.new(ptr) : nil\n"}},{"html_id":"value:String-instance-method","name":"value","doc":"Returns the scalar value, assuming the pull parser\nis located at a scalar. Raises otherwise.","summary":"<p>Returns the scalar value, assuming the pull parser is located at a scalar.</p>","abstract":false,"location":{"filename":"src/yaml/pull_parser.cr","line_number":67,"url":null},"def":{"name":"value","return_type":"String","visibility":"Public","body":"expect_kind(EventKind::SCALAR)\nptr = @event.data.scalar.value\nptr ? String.new(ptr, @event.data.scalar.length) : \"\"\n"}}]},{"html_id":"Crystal/YAML/ScalarStyle","path":"YAML/ScalarStyle.html","kind":"enum","full_name":"YAML::ScalarStyle","name":"ScalarStyle","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml/enums.cr","line_number":16,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"ANY","name":"ANY","value":"0"},{"id":"PLAIN","name":"PLAIN","value":"1"},{"id":"SINGLE_QUOTED","name":"SINGLE_QUOTED","value":"2"},{"id":"DOUBLE_QUOTED","name":"DOUBLE_QUOTED","value":"3"},{"id":"LITERAL","name":"LITERAL","value":"4"},{"id":"FOLDED","name":"FOLDED","value":"5"}],"namespace":{"html_id":"Crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"instance_methods":[{"html_id":"any?-instance-method","name":"any?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":17,"url":null},"def":{"name":"any?","visibility":"Public","body":"self == ANY"}},{"html_id":"double_quoted?-instance-method","name":"double_quoted?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":20,"url":null},"def":{"name":"double_quoted?","visibility":"Public","body":"self == DOUBLE_QUOTED"}},{"html_id":"folded?-instance-method","name":"folded?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":22,"url":null},"def":{"name":"folded?","visibility":"Public","body":"self == FOLDED"}},{"html_id":"literal?-instance-method","name":"literal?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":21,"url":null},"def":{"name":"literal?","visibility":"Public","body":"self == LITERAL"}},{"html_id":"plain?-instance-method","name":"plain?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":18,"url":null},"def":{"name":"plain?","visibility":"Public","body":"self == PLAIN"}},{"html_id":"single_quoted?-instance-method","name":"single_quoted?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":19,"url":null},"def":{"name":"single_quoted?","visibility":"Public","body":"self == SINGLE_QUOTED"}}]},{"html_id":"Crystal/YAML/Schema","path":"YAML/Schema.html","kind":"module","full_name":"YAML::Schema","name":"Schema","abstract":false,"locations":[{"filename":"src/yaml/schema/core.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"types":[{"html_id":"Crystal/YAML/Schema/Core","path":"YAML/Schema/Core.html","kind":"module","full_name":"YAML::Schema::Core","name":"Core","abstract":false,"locations":[{"filename":"src/yaml/schema/core.cr","line_number":3,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML/Schema","kind":"module","full_name":"YAML::Schema","name":"Schema"},"doc":"Provides utility methods for the YAML 1.1 core schema\nwith the additional independent types specified in http://yaml.org/type/","summary":"<p>Provides utility methods for the YAML 1.1 core schema with the additional independent types specified in http://yaml.org/type/</p>","class_methods":[{"html_id":"each(node:YAML::Nodes::Mapping,&)-class-method","name":"each","doc":"Invokes the block for each of the given *node*s keys and\nvalues, resolving merge keys (<<) when found (keys and\nvalues of the resolved merge mappings are yielded,\nrecursively).","summary":"<p>Invokes the block for each of the given <em>node</em>s keys and values, resolving merge keys (&lt;&lt;) when found (keys and values of the resolved merge mappings are yielded, recursively).</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":"YAML::Nodes::Mapping"}],"args_string":"(node : YAML::Nodes::Mapping, &)","args_html":"(node : <a href=\"../../YAML/Nodes/Mapping.html\">YAML::Nodes::Mapping</a>, &)","location":{"filename":"src/yaml/schema/core.cr","line_number":143,"url":null},"def":{"name":"each","args":[{"name":"node","external_name":"node","restriction":"YAML::Nodes::Mapping"}],"yields":1,"visibility":"Public","body":"stack = [{node, 0}]\nvisited = Set(YAML::Nodes::Mapping).new\nwhile !stack.empty?\n  mapping, index = stack.pop\n  visited << mapping\n  while index < mapping.nodes.size\n    key = mapping.nodes[index]\n    index = index + 1\n    value = mapping.nodes[index]\n    index = index + 1\n    if ((key.is_a?(YAML::Nodes::Scalar) && (key.value == \"<<\")) && (key.tag != \"tag:yaml.org,2002:str\")) && (solve_merge(stack, mapping, index, value, visited))\n      break\n    else\n      yield({key, value})\n    end\n  end\nend\n"}},{"html_id":"parse(data:String|IO):YAML::Any-class-method","name":"parse","doc":"Deserializes a YAML document.\n\nSame as `YAML.parse`.","summary":"<p>Deserializes a YAML document.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":"String | IO"}],"args_string":"(data : String | IO) : YAML::Any","args_html":"(data : <a href=\"../../String.html\">String</a> | <a href=\"../../IO.html\">IO</a>) : <a href=\"../../YAML/Any.html\">YAML::Any</a>","location":{"filename":"src/yaml/schema/core.cr","line_number":7,"url":null},"def":{"name":"parse","args":[{"name":"data","external_name":"data","restriction":"String | IO"}],"return_type":"YAML::Any","visibility":"Public","body":"Parser.new(data, &.parse)"}},{"html_id":"parse_all(data:String|IO):Array(YAML::Any)-class-method","name":"parse_all","doc":"Deserializes multiple YAML documents.\n\nSame as `YAML.parse_all`.","summary":"<p>Deserializes multiple YAML documents.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":"String | IO"}],"args_string":"(data : String | IO) : Array(YAML::Any)","args_html":"(data : <a href=\"../../String.html\">String</a> | <a href=\"../../IO.html\">IO</a>) : <a href=\"../../Array.html\">Array</a>(<a href=\"../../YAML/Any.html\">YAML::Any</a>)","location":{"filename":"src/yaml/schema/core.cr","line_number":14,"url":null},"def":{"name":"parse_all","args":[{"name":"data","external_name":"data","restriction":"String | IO"}],"return_type":"Array(YAML::Any)","visibility":"Public","body":"Parser.new(data, &.parse_all)"}},{"html_id":"parse_null_or(node:YAML::Nodes::Node,&)-class-method","name":"parse_null_or","doc":"If `node` parses to a null value, returns `nil`, otherwise\ninvokes the given block.","summary":"<p>If <code>node</code> parses to a null value, returns <code>nil</code>, otherwise invokes the given block.</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"args_string":"(node : YAML::Nodes::Node, &)","args_html":"(node : <a href=\"../../YAML/Nodes/Node.html\">YAML::Nodes::Node</a>, &)","location":{"filename":"src/yaml/schema/core.cr","line_number":131,"url":null},"def":{"name":"parse_null_or","args":[{"name":"node","external_name":"node","restriction":"YAML::Nodes::Node"}],"yields":0,"visibility":"Public","body":"if node.is_a?(YAML::Nodes::Scalar) && (parse_null?(node))\n  nil\nelse\n  yield\nend"}},{"html_id":"parse_scalar(pull_parser:YAML::PullParser):Nil|Bool|Int64|Float64|String|Time|Bytes-class-method","name":"parse_scalar","doc":"Assuming the *pull_parser* is positioned in a scalar,\nparses it according to the core schema, taking the\nscalar's style and tag into account, then advances\nthe pull parser.","summary":"<p>Assuming the <em>pull_parser</em> is positioned in a scalar, parses it according to the core schema, taking the scalar's style and tag into account, then advances the pull parser.</p>","abstract":false,"args":[{"name":"pull_parser","external_name":"pull_parser","restriction":"YAML::PullParser"}],"args_string":"(pull_parser : YAML::PullParser) : Nil | Bool | Int64 | Float64 | String | Time | Bytes","args_html":"(pull_parser : <a href=\"../../YAML/PullParser.html\">YAML::PullParser</a>) : <a href=\"../../Nil.html\">Nil</a> | <a href=\"../../Bool.html\">Bool</a> | <a href=\"../../Int64.html\">Int64</a> | <a href=\"../../Float64.html\">Float64</a> | <a href=\"../../String.html\">String</a> | <a href=\"../../Time.html\">Time</a> | <a href=\"../../Bytes.html\">Bytes</a>","location":{"filename":"src/yaml/schema/core.cr","line_number":22,"url":null},"def":{"name":"parse_scalar","args":[{"name":"pull_parser","external_name":"pull_parser","restriction":"YAML::PullParser"}],"return_type":"Nil | Bool | Int64 | Float64 | String | Time | Bytes","visibility":"Public","body":"string = pull_parser.value\nprocess_scalar_tag(pull_parser, pull_parser.tag) do |value|\n  return value\nend\nif pull_parser.scalar_style.plain?\nelse\n  return string\nend\nparse_scalar(string)\n"}},{"html_id":"parse_scalar(string:String):Nil|Bool|Int64|Float64|String|Time|Bytes-class-method","name":"parse_scalar","doc":"Parses a string according to the core schema, assuming\nthe string had a plain style.\n\n```\nrequire \"yaml\"\n\nYAML::Schema::Core.parse_scalar(\"hello\") # => \"hello\"\nYAML::Schema::Core.parse_scalar(\"1.2\")   # => 1.2\nYAML::Schema::Core.parse_scalar(\"false\") # => false\n```","summary":"<p>Parses a string according to the core schema, assuming the string had a plain style.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":"String"}],"args_string":"(string : String) : Nil | Bool | Int64 | Float64 | String | Time | Bytes","args_html":"(string : <a href=\"../../String.html\">String</a>) : <a href=\"../../Nil.html\">Nil</a> | <a href=\"../../Bool.html\">Bool</a> | <a href=\"../../Int64.html\">Int64</a> | <a href=\"../../Float64.html\">Float64</a> | <a href=\"../../String.html\">String</a> | <a href=\"../../Time.html\">Time</a> | <a href=\"../../Bytes.html\">Bytes</a>","location":{"filename":"src/yaml/schema/core.cr","line_number":65,"url":null},"def":{"name":"parse_scalar","args":[{"name":"string","external_name":"string","restriction":"String"}],"return_type":"Nil | Bool | Int64 | Float64 | String | Time | Bytes","visibility":"Public","body":"if parse_null?(string)\n  return nil\nend\nvalue = parse_bool?(string)\nif value.nil?\nelse\n  return value\nend\nvalue = parse_float_infinity_and_nan?(string)\nif value\n  return value\nend\ncase string\nwhen .starts_with?(\"0x\"), .starts_with?(\"+0x\"), .starts_with?(\"-0x\")\n  value = string.to_i64?(base: 16, prefix: true)\n  value || string\nwhen .starts_with?(\"0.\"), .starts_with?('.')\n  value = parse_float?(string)\n  value || string\nwhen .starts_with?('0')\n  if string.size == 1\n    return 0_i64\n  end\n  value = string.to_i64?(base: 8, prefix: true, leading_zero_is_octal: true)\n  value || string\nwhen .starts_with?('-'), .starts_with?('+')\n  value = parse_number?(string)\n  value || string\nelse\n  if string[0].ascii_number?\n    value = parse_number?(string)\n    if value\n      return value\n    end\n    value = parse_time?(string)\n    if value\n      return value\n    end\n  end\n  string\nend\n"}},{"html_id":"parse_scalar(node:YAML::Nodes::Scalar):Nil|Bool|Int64|Float64|String|Time|Bytes-class-method","name":"parse_scalar","doc":"Parses a scalar value from the given *node*.","summary":"<p>Parses a scalar value from the given <em>node</em>.</p>","abstract":false,"args":[{"name":"node","external_name":"node","restriction":"YAML::Nodes::Scalar"}],"args_string":"(node : YAML::Nodes::Scalar) : Nil | Bool | Int64 | Float64 | String | Time | Bytes","args_html":"(node : <a href=\"../../YAML/Nodes/Scalar.html\">YAML::Nodes::Scalar</a>) : <a href=\"../../Nil.html\">Nil</a> | <a href=\"../../Bool.html\">Bool</a> | <a href=\"../../Int64.html\">Int64</a> | <a href=\"../../Float64.html\">Float64</a> | <a href=\"../../String.html\">String</a> | <a href=\"../../Time.html\">Time</a> | <a href=\"../../Bytes.html\">Bytes</a>","location":{"filename":"src/yaml/schema/core.cr","line_number":39,"url":null},"def":{"name":"parse_scalar","args":[{"name":"node","external_name":"node","restriction":"YAML::Nodes::Scalar"}],"return_type":"Nil | Bool | Int64 | Float64 | String | Time | Bytes","visibility":"Public","body":"string = node.value\nprocess_scalar_tag(node) do |value|\n  return value\nend\nif node.style.plain?\nelse\n  return string\nend\nparse_scalar(string)\n"}},{"html_id":"reserved_string?(string):Bool-class-method","name":"reserved_string?","doc":"Returns whether a string is reserved and must non be output\nwith a plain style, according to the core schema.\n\n```\nrequire \"yaml\"\n\nYAML::Schema::Core.reserved_string?(\"hello\") # => false\nYAML::Schema::Core.reserved_string?(\"1.2\")   # => true\nYAML::Schema::Core.reserved_string?(\"false\") # => true\n```","summary":"<p>Returns whether a string is reserved and must non be output with a plain style, according to the core schema.</p>","abstract":false,"args":[{"name":"string","external_name":"string","restriction":""}],"args_string":"(string) : Bool","args_html":"(string) : <a href=\"../../Bool.html\">Bool</a>","location":{"filename":"src/yaml/schema/core.cr","line_number":119,"url":null},"def":{"name":"reserved_string?","args":[{"name":"string","external_name":"string","restriction":""}],"return_type":"Bool","visibility":"Public","body":"!parse_scalar(string).is_a?(String)"}}]},{"html_id":"Crystal/YAML/Schema/FailSafe","path":"YAML/Schema/FailSafe.html","kind":"module","full_name":"YAML::Schema::FailSafe","name":"FailSafe","abstract":false,"locations":[{"filename":"src/yaml/schema/fail_safe.cr","line_number":4,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML/Schema","kind":"module","full_name":"YAML::Schema","name":"Schema"},"doc":"Provides a way to parse a YAML document according to the\nfail-safe schema, as specified in http://www.yaml.org/spec/1.2/spec.html#id2802346,\nwhere all scalar values are considered strings.","summary":"<p>Provides a way to parse a YAML document according to the fail-safe schema, as specified in http://www.yaml.org/spec/1.2/spec.html#id2802346, where all scalar values are considered strings.</p>","class_methods":[{"html_id":"parse(data:String|IO):Any-class-method","name":"parse","doc":"Deserializes a YAML document.","summary":"<p>Deserializes a YAML document.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":"String | IO"}],"args_string":"(data : String | IO) : Any","args_html":"(data : <a href=\"../../String.html\">String</a> | <a href=\"../../IO.html\">IO</a>) : <a href=\"../../YAML/Any.html\">Any</a>","location":{"filename":"src/yaml/schema/fail_safe.cr","line_number":6,"url":null},"def":{"name":"parse","args":[{"name":"data","external_name":"data","restriction":"String | IO"}],"return_type":"Any","visibility":"Public","body":"Parser.new(data, &.parse)"}},{"html_id":"parse_all(data:String|IO):Array(Any)-class-method","name":"parse_all","doc":"Deserializes multiple YAML documents.","summary":"<p>Deserializes multiple YAML documents.</p>","abstract":false,"args":[{"name":"data","external_name":"data","restriction":"String | IO"}],"args_string":"(data : String | IO) : Array(Any)","args_html":"(data : <a href=\"../../String.html\">String</a> | <a href=\"../../IO.html\">IO</a>) : <a href=\"../../Array.html\">Array</a>(<a href=\"../../YAML/Any.html\">Any</a>)","location":{"filename":"src/yaml/schema/fail_safe.cr","line_number":11,"url":null},"def":{"name":"parse_all","args":[{"name":"data","external_name":"data","restriction":"String | IO"}],"return_type":"Array(Any)","visibility":"Public","body":"Parser.new(data, &.parse_all)"}}]}]},{"html_id":"Crystal/YAML/SequenceStyle","path":"YAML/SequenceStyle.html","kind":"enum","full_name":"YAML::SequenceStyle","name":"SequenceStyle","abstract":false,"ancestors":[{"html_id":"Crystal/Enum","kind":"struct","full_name":"Enum","name":"Enum"},{"html_id":"Crystal/Comparable","kind":"module","full_name":"Comparable","name":"Comparable"},{"html_id":"Crystal/Value","kind":"struct","full_name":"Value","name":"Value"},{"html_id":"Crystal/Object","kind":"class","full_name":"Object","name":"Object"}],"locations":[{"filename":"src/yaml/enums.cr","line_number":25,"url":null}],"repository_name":"Crystal","program":false,"enum":true,"alias":false,"const":false,"constants":[{"id":"ANY","name":"ANY","value":"0"},{"id":"BLOCK","name":"BLOCK","value":"1"},{"id":"FLOW","name":"FLOW","value":"2"}],"namespace":{"html_id":"Crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"instance_methods":[{"html_id":"any?-instance-method","name":"any?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":26,"url":null},"def":{"name":"any?","visibility":"Public","body":"self == ANY"}},{"html_id":"block?-instance-method","name":"block?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":27,"url":null},"def":{"name":"block?","visibility":"Public","body":"self == BLOCK"}},{"html_id":"flow?-instance-method","name":"flow?","abstract":false,"location":{"filename":"src/yaml/enums.cr","line_number":28,"url":null},"def":{"name":"flow?","visibility":"Public","body":"self == FLOW"}}]},{"html_id":"Crystal/YAML/Serializable","path":"YAML/Serializable.html","kind":"module","full_name":"YAML::Serializable","name":"Serializable","abstract":false,"locations":[{"filename":"src/yaml/serialization.cr","line_number":128,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML","kind":"module","full_name":"YAML","name":"YAML"},"doc":"The `YAML::Serializable` module automatically generates methods for YAML serialization when included.\n\n### Example\n\n```\nrequire \"yaml\"\n\nclass Location\n  include YAML::Serializable\n\n  @[YAML::Field(key: \"lat\")]\n  property latitude : Float64\n\n  @[YAML::Field(key: \"lng\")]\n  property longitude : Float64\nend\n\nclass House\n  include YAML::Serializable\n  property address : String\n  property location : Location?\nend\n\nhouse = House.from_yaml(%({\"address\": \"Crystal Road 1234\", \"location\": {\"lat\": 12.3, \"lng\": 34.5}}))\nhouse.address  # => \"Crystal Road 1234\"\nhouse.location # => #<Location:0x10cd93d80 @latitude=12.3, @longitude=34.5>\nhouse.to_yaml  # => \"---\\naddress: Crystal Road 1234\\nlocation:\\n  lat: 12.3\\n  lng: 34.5\\n\"\n\nhouses = Array(House).from_yaml(\"---\\n- address: Crystal Road 1234\\n  location:\\n    lat: 12.3\\n    lng: 34.5\\n\")\nhouses.size    # => 1\nhouses.to_yaml # => \"---\\n- address: Crystal Road 1234\\n  location:\\n    lat: 12.3\\n    lng: 34.5\\n\"\n```\n\n### Usage\n\nIncluding `YAML::Serializable` will create `#to_yaml` and `self.from_yaml` methods on the current class,\nand a constructor which takes a `YAML::PullParser`. By default, these methods serialize into a yaml\nobject containing the value of every instance variable, the keys being the instance variable name.\nMost primitives and collections supported as instance variable values (string, integer, array, hash, etc.),\nalong with objects which define to_yaml and a constructor taking a `YAML::PullParser`.\nUnion types are also supported, including unions with nil. If multiple types in a union parse correctly,\nit is undefined which one will be chosen.\n\nTo change how individual instance variables are parsed and serialized, the annotation `YAML::Field`\ncan be placed on the instance variable. Annotating property, getter and setter macros is also allowed.\n```\nrequire \"yaml\"\n\nclass A\n  include YAML::Serializable\n\n  @[YAML::Field(key: \"my_key\", emit_null: true)]\n  getter a : Int32?\nend\n```\n\n`YAML::Field` properties:\n* **ignore**: if `true` skip this field in serialization and deserialization (by default false)\n* **ignore_serialize**: if `true` skip this field in serialization (by default false)\n* **ignore_deserialize**: if `true` skip this field in deserialization (by default false)\n* **key**: the value of the key in the yaml object (by default the name of the instance variable)\n* **converter**: specify an alternate type for parsing and generation. The converter must define `from_yaml(YAML::ParseContext, YAML::Nodes::Node)` and `to_yaml(value, YAML::Nodes::Builder)`. Examples of converters are a `Time::Format` instance and `Time::EpochConverter` for `Time`.\n* **presence**: if `true`, a `@{{key}}_present` instance variable will be generated when the key was present (even if it has a `null` value), `false` by default\n* **emit_null**: if `true`, emits a `null` value for nilable property (by default nulls are not emitted)\n\nDeserialization also respects default values of variables:\n```\nrequire \"yaml\"\n\nstruct A\n  include YAML::Serializable\n  @a : Int32\n  @b : Float64 = 1.0\nend\n\nA.from_yaml(\"---\\na: 1\\n\") # => A(@a=1, @b=1.0)\n```\n\n### Extensions: `YAML::Serializable::Strict` and `YAML::Serializable::Unmapped`.\n\nIf the `YAML::Serializable::Strict` module is included, unknown properties in the YAML\ndocument will raise a parse exception. By default the unknown properties\nare silently ignored.\nIf the `YAML::Serializable::Unmapped` module is included, unknown properties in the YAML\ndocument will be stored in a `Hash(String, YAML::Any)`. On serialization, any keys inside yaml_unmapped\nwill be serialized appended to the current yaml object.\n```\nrequire \"yaml\"\n\nstruct A\n  include YAML::Serializable\n  include YAML::Serializable::Unmapped\n  @a : Int32\nend\n\na = A.from_yaml(\"---\\na: 1\\nb: 2\\n\") # => A(@yaml_unmapped={\"b\" => 2_i64}, @a=1)\na.to_yaml                            # => \"---\\na: 1\\nb: 2\\n\"\n```\n\n\n### Class annotation `YAML::Serializable::Options`\n\nsupported properties:\n* **emit_nulls**: if `true`, emits a `null` value for all nilable properties (by default nulls are not emitted)\n\n```\nrequire \"yaml\"\n\n@[YAML::Serializable::Options(emit_nulls: true)]\nclass A\n  include YAML::Serializable\n  @a : Int32?\nend\n```\n\n### Discriminator field\n\nA very common YAML serialization strategy for handling different objects\nunder a same hierarchy is to use a discriminator field. For example in\n[GeoJSON](https://tools.ietf.org/html/rfc7946) each object has a \"type\"\nfield, and the rest of the fields, and their meaning, depend on its value.\n\nYou can use `YAML::Serializable.use_yaml_discriminator` for this use case.","summary":"<p>The <code><a href=\"../YAML/Serializable.html\">YAML::Serializable</a></code> module automatically generates methods for YAML serialization when included.</p>","constructors":[{"html_id":"new(*,__context_for_yaml_serializablectx:YAML::ParseContext,__node_for_yaml_serializablenode:YAML::Nodes::Node)-class-method","name":"new","abstract":false,"args":[{"name":"","external_name":"","restriction":""},{"name":"ctx","external_name":"__context_for_yaml_serializable","restriction":"YAML::ParseContext"},{"name":"node","external_name":"__node_for_yaml_serializable","restriction":"::YAML::Nodes::Node"}],"args_string":"(*, __context_for_yaml_serializable ctx : YAML::ParseContext, __node_for_yaml_serializable node : YAML::Nodes::Node)","args_html":"(*, __context_for_yaml_serializable ctx : <a href=\"../YAML/ParseContext.html\">YAML::ParseContext</a>, __node_for_yaml_serializable node : <a href=\"../YAML/Nodes/Node.html\">YAML::Nodes::Node</a>)","location":{"filename":"src/yaml/serialization.cr","line_number":164,"url":null},"def":{"name":"new","args":[{"name":"","external_name":"","restriction":""},{"name":"ctx","external_name":"__context_for_yaml_serializable","restriction":"YAML::ParseContext"},{"name":"node","external_name":"__node_for_yaml_serializable","restriction":"::YAML::Nodes::Node"}],"splat_index":0,"visibility":"Public","body":"_ = allocate\n_.initialize(__context_for_yaml_serializable: ctx, __node_for_yaml_serializable: node)\nif _.responds_to?(:finalize)\n  ::GC.add_finalizer(_)\nend\n_\n"}}],"instance_methods":[{"html_id":"to_yaml(yaml:YAML::Nodes::Builder)-instance-method","name":"to_yaml","abstract":false,"args":[{"name":"yaml","external_name":"yaml","restriction":"::YAML::Nodes::Builder"}],"args_string":"(yaml : YAML::Nodes::Builder)","args_html":"(yaml : <a href=\"../YAML/Nodes/Builder.html\">YAML::Nodes::Builder</a>)","location":{"filename":"src/yaml/serialization.cr","line_number":269,"url":null},"def":{"name":"to_yaml","args":[{"name":"yaml","external_name":"yaml","restriction":"::YAML::Nodes::Builder"}],"visibility":"Public","body":"{% if true %}\n        {% options = @type.annotation(::YAML::Serializable::Options) %}\n        {% emit_nulls = options && options[:emit_nulls] %}\n\n        {% properties = {} of Nil => Nil %}\n        {% for ivar in @type.instance_vars %}\n          {% ann = ivar.annotation(::YAML::Field) %}\n          {% if ann && (ann[:ignore] || ann[:ignore_serialize]) %}{% else %}\n            {% properties[ivar.id] = {type: ivar.type, key: ((ann && ann[:key]) || ivar).id.stringify, converter: ann && ann[:converter], emit_null: (ann && (ann[:emit_null] != nil) ? ann[:emit_null] : emit_nulls)} %}\n          {% end %}\n        {% end %}\n\n        yaml.mapping(reference: self) do\n          {% for name, value in properties %}\n            _{{ name }} = @{{ name }}\n\n            {% if value[:emit_null] %}{% else %}\n              unless _{{ name }}.nil?\n            {% end %}\n\n              {{ value[:key] }}.to_yaml(yaml)\n\n              {% if value[:converter] %}\n                if _{{ name }}\n                  {{ value[:converter] }}.to_yaml(_{{ name }}, yaml)\n                else\n                  nil.to_yaml(yaml)\n                end\n              {% else %}\n                _{{ name }}.to_yaml(yaml)\n              {% end %}\n\n            {% if value[:emit_null] %}{% else %}\n              end\n            {% end %}\n          {% end %}\n          on_to_yaml(yaml)\n        end\n      {% end %}"}}],"macros":[{"html_id":"use_yaml_discriminator(field,mapping)-macro","name":"use_yaml_discriminator","doc":"Tells this class to decode YAML by using a field as a discriminator.\n\n- *field* must be the field name to use as a discriminator\n- *mapping* must be a hash or named tuple where each key-value pair\n  maps a discriminator value to a class to deserialize\n\nFor example:\n\n```\nrequire \"yaml\"\n\nabstract class Shape\n  include YAML::Serializable\n\n  use_yaml_discriminator \"type\", {point: Point, circle: Circle}\n\n  property type : String\nend\n\nclass Point < Shape\n  property x : Int32\n  property y : Int32\nend\n\nclass Circle < Shape\n  property x : Int32\n  property y : Int32\n  property radius : Int32\nend\n\nShape.from_yaml(%(\n  type: point\n  x: 1\n  y: 2\n)) # => #<Point:0x10373ae20 @type=\"point\", @x=1, @y=2>\n\nShape.from_yaml(%(\n  type: circle\n  x: 1\n  y: 2\n  radius: 3\n)) # => #<Circle:0x106a4cea0 @type=\"circle\", @x=1, @y=2, @radius=3>\n```","summary":"<p>Tells this class to decode YAML by using a field as a discriminator.</p>","abstract":false,"args":[{"name":"field","external_name":"field","restriction":""},{"name":"mapping","external_name":"mapping","restriction":""}],"args_string":"(field, mapping)","args_html":"(field, mapping)","location":{"filename":"src/yaml/serialization.cr","line_number":383,"url":null},"def":{"name":"use_yaml_discriminator","args":[{"name":"field","external_name":"field","restriction":""},{"name":"mapping","external_name":"mapping","restriction":""}],"visibility":"Public","body":"      \n{% if mapping.is_a?(HashLiteral) || mapping.is_a?(NamedTupleLiteral) %}{% else %}\n        {% mapping.raise(\"mapping argument must be a HashLiteral or a NamedTupleLiteral, not #{mapping.class_name.id}\") %}\n      {% end %}\n\n\n      def self.new(ctx : YAML::ParseContext, node : YAML::Nodes::Node)\n        ctx.read_alias(node, \n\\{\n{@type}}) do |obj|\n          return obj\n        \nend\n\n        unless node.is_a?(YAML::Nodes::Mapping)\n          node.raise \"expected YAML mapping, not #{node.class}\"\n        \nend\n\n        node.each do |key, value|\n          next unless key.is_a?(YAML::Nodes::Scalar) && value.is_a?(YAML::Nodes::Scalar)\n          next unless key.value == \n{{ field.id.stringify }}\n\n\n          discriminator_value = value.value\n          case discriminator_value\n          \n{% for key, value in mapping %}\n            {% if key.is_a?(Path) %}\n              {% key = key.resolve %}\n            {% end %}\n            {% if key.is_a?(NumberLiteral) %}\n              # An enum value is always a typed NumberLiteral and stringifies with type\n              # suffix unless it's Int32.\n              # TODO: Replace this workaround with NumberLiteral#to_number after the next release\n              {% key = (key.id.split(\"_\"))[0] %}\n            {% end %}\n            when {{ key.id.stringify }}\n              return {{ value.id }}.new(ctx, node)\n          {% end %}\n\n          \nelse\n            node.raise \"Unknown '\n{{ field.id }}\n' discriminator value: #{discriminator_value.inspect}\"\n          \nend\n        \nend\n\n        node.raise \"Missing YAML discriminator field '\n{{ field.id }}\n'\"\n      \nend\n    \n"}}],"types":[{"html_id":"Crystal/YAML/Serializable/Options","path":"YAML/Serializable/Options.html","kind":"annotation","full_name":"YAML::Serializable::Options","name":"Options","abstract":false,"locations":[{"filename":"src/yaml/serialization.cr","line_number":129,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML/Serializable","kind":"module","full_name":"YAML::Serializable","name":"Serializable"}},{"html_id":"Crystal/YAML/Serializable/Strict","path":"YAML/Serializable/Strict.html","kind":"module","full_name":"YAML::Serializable::Strict","name":"Strict","abstract":false,"locations":[{"filename":"src/yaml/serialization.cr","line_number":318,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML/Serializable","kind":"module","full_name":"YAML::Serializable","name":"Serializable"}},{"html_id":"Crystal/YAML/Serializable/Unmapped","path":"YAML/Serializable/Unmapped.html","kind":"module","full_name":"YAML::Serializable::Unmapped","name":"Unmapped","abstract":false,"locations":[{"filename":"src/yaml/serialization.cr","line_number":324,"url":null}],"repository_name":"Crystal","program":false,"enum":false,"alias":false,"const":false,"namespace":{"html_id":"Crystal/YAML/Serializable","kind":"module","full_name":"YAML::Serializable","name":"Serializable"},"instance_methods":[{"html_id":"yaml_unmapped-instance-method","name":"yaml_unmapped","abstract":false,"location":{"filename":"src/yaml/serialization.cr","line_number":326,"url":null},"def":{"name":"yaml_unmapped","visibility":"Public","body":"@yaml_unmapped"}},{"html_id":"yaml_unmapped=(yaml_unmapped)-instance-method","name":"yaml_unmapped=","abstract":false,"args":[{"name":"yaml_unmapped","external_name":"yaml_unmapped","restriction":""}],"args_string":"(yaml_unmapped)","args_html":"(yaml_unmapped)","location":{"filename":"src/yaml/serialization.cr","line_number":326,"url":null},"def":{"name":"yaml_unmapped=","args":[{"name":"yaml_unmapped","external_name":"yaml_unmapped","restriction":""}],"visibility":"Public","body":"@yaml_unmapped = yaml_unmapped"}}]}]}]}]}})